# - Try to find APPLfast
# Defines:
#
#  BRIDGE_FOUND
#  BRIDGE_INCLUDE_DIR
#  BRIDGE_INCLUDE_DIRS (not cached)
#  BRIDGE_LIBRARY
#  BRIDGE_LIBRARIES (not cached)
#  BRIDGE_LIBRARY_DIRS (not cached)

find_program(BRIDGE_CONFIG nnlo-config
  HINTS
    $ENV{BRIDGE_ROOT_DIR}/bin
    ${BRIDGE_ROOT_DIR}/bin
  REQUIRED
)

if (BRIDGE_CONFIG)

  execute_process(
    COMMAND ${BRIDGE_CONFIG} --libdir
    OUTPUT_VARIABLE BRIDGE_LIBRARY_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  find_library(BRIDGE_LIBRARY nnlo
    HINTS
      ${BRIDGE_LIBRARY_DIR}
      $ENV{BRIDGE_ROOT_DIR}/lib
      ${BRIDGE_ROOT_DIR}/lib
  )

  execute_process(
    COMMAND ${BRIDGE_CONFIG} --incdir
    OUTPUT_VARIABLE BRIDGE_INCLUDE_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  execute_process(
    COMMAND ${BRIDGE_CONFIG} --version
    OUTPUT_VARIABLE BRIDGE_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  mark_as_advanced(BRIDGE_INCLUDE_DIR BRIDGE_LIBRARY)

  include(FindPackageHandleStandardArgs)
  find_package_handle_standard_args(BRIDGE
    REQUIRED_VARS
      BRIDGE_LIBRARY
      BRIDGE_INCLUDE_DIR
    VERSION_VAR BRIDGE_VERSION
  )

  set(BRIDGE_LIBRARIES ${BRIDGE_LIBRARY})
  set(BRIDGE_LIBRARY_DIRS ${BRIDGE_LIBRARY_DIR})
  set(BRIDGE_INCLUDE_DIRS ${BRIDGE_INCLUDE_DIR})

endif(BRIDGE_CONFIG)
