# - Try to find LHAPDF
# Defines:
#
#  LHAPDF_FOUND
#  LHAPDF_INCLUDE_DIR
#  LHAPDF_INCLUDE_DIRS (not cached)
#  LHAPDF_LIBRARY
#  LHAPDF_LIBRARIES (not cached)
#  LHAPDF_LIBRARY_DIRS (not cached)

find_program(LHAPDF_CONFIG lhapdf-config
  HINTS
    $ENV{LHAPDF_ROOT_DIR}/bin
    ${LHAPDF_ROOT_DIR}/bin
  REQUIRED
)

if (LHAPDF_CONFIG)

  execute_process(
    COMMAND ${LHAPDF_CONFIG} --libdir
    OUTPUT_VARIABLE LHAPDF_LIBRARY_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  find_library(LHAPDF_LIBRARY LHAPDF
    HINTS
      ${LHAPDF_LIBRARY_DIR}
      $ENV{LHAPDF_ROOT_DIR}/lib
      ${LHAPDF_ROOT_DIR}/lib
  )

  execute_process(
    COMMAND ${LHAPDF_CONFIG} --incdir
    OUTPUT_VARIABLE LHAPDF_INCLUDE_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  execute_process(
    COMMAND ${LHAPDF_CONFIG} --version
    OUTPUT_VARIABLE LHAPDF_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )

  mark_as_advanced(LHAPDF_INCLUDE_DIR LHAPDF_LIBRARY)

  include(FindPackageHandleStandardArgs)
  find_package_handle_standard_args(LHAPDF
    REQUIRED_VARS
      LHAPDF_LIBRARY
      LHAPDF_INCLUDE_DIR
    VERSION_VAR LHAPDF_VERSION
  )

  set(LHAPDF_LIBRARIES ${LHAPDF_LIBRARY})
  set(LHAPDF_LIBRARY_DIRS ${LHAPDF_LIBRARY_DIR})
  set(LHAPDF_INCLUDE_DIRS ${LHAPDF_INCLUDE_DIR})


  # exec_program(${LHAPDF_CONFIG}
  #   ARGS --cppflags
  #   OUTPUT_VARIABLE LHAPDF_CXX_FLAGS
  # )
  # set(LHAPDF_CXX_FLAGS ${LHAPDF_CXX_FLAGS} CACHE STRING INTERNAL)

  # exec_program(${LHAPDF_CONFIG}
  #   ARGS --ldflags
  #   OUTPUT_VARIABLE LHAPDF_LIBRARIES
  # )
  # set(LHAPDF_LIBRARIES ${LHAPDF_LIBRARIES} CACHE STRING INTERNAL)

  # exec_program(${LHAPDF_CONFIG}
  #   ARGS --incdir
  #   OUTPUT_VARIABLE LHAPDF_INCLUDE_DIR
  # )
  # set(LHAPDF_INCLUDE_DIR ${LHAPDF_INCLUDE_DIR} CACHE STRING INTERNAL)

  # exec_program(${LHAPDF_CONFIG}
  #   ARGS --libdir
  #   OUTPUT_VARIABLE LHAPDF_LIBRARY
  # )
  # set(LHAPDF_LIBRARY ${LHAPDF_LIBRARY} CACHE STRING INTERNAL)

  # exec_program(${LHAPDF_CONFIG}
  #   ARGS --version
  #   OUTPUT_VARIABLE LHAPDF_VERSION
  # )
  # set(LHAPDF_VERSION ${LHAPDF_VERSION} CACHE STRING INTERNAL)

  # include(FindPackageHandleStandardArgs)
  # find_package_handle_standard_args(LHAPDF
  #   REQUIRED_VARS
  #     LHAPDF_LIBRARIES
  #     LHAPDF_INCLUDE_DIR
  #   VERSION_VAR LHAPDF_VERSION
  # )

endif(LHAPDF_CONFIG)
