
#include <string>
#include "LHAPDF/LHAPDF.h"


// interface routines to fortran
extern "C" {

  LHAPDF::PDF* mkPDF_lhapdf_nnlojet_(char setname[], const int& member) {
    //std::cout << "mkPDF_lhapdf_nnlojet_ > " << std::string(setname) << "[" << member << "]" << std::endl;
    LHAPDF::setVerbosity(0);  // silence
    LHAPDF::PDF* pdf = LHAPDF::mkPDF(std::string(setname), member);
    //pdf->print();
    return pdf;
  }  // end mkPDF_lhapdf_nnlojet_

  void rmPDF_lhapdf_nnlojet_(void* ptr) {
    //std::cout << "rmPDF_lhapdf_nnlojet_" << std::endl;
    LHAPDF::PDF* pdf = (LHAPDF::PDF*) ptr;  // cast
    //pdf->print();
    delete pdf;
  }  // end rmPDF_lhapdf_nnlojet_

  double xMin_lhapdf_nnlojet_(void* ptr) {
    return ( (LHAPDF::PDF*) ptr ) -> xMin();
  }  // end xMin_lhapdf_nnlojet_

  double xMax_lhapdf_nnlojet_(void* ptr) {
    return ( (LHAPDF::PDF*) ptr ) -> xMax();
  }  // end xMax_lhapdf_nnlojet_

  double qMin_lhapdf_nnlojet_(void* ptr) {
    return ( (LHAPDF::PDF*) ptr ) -> qMin();
  }  // end qMin_lhapdf_nnlojet_

  double qMax_lhapdf_nnlojet_(void* ptr) {
    return ( (LHAPDF::PDF*) ptr ) -> qMax();
  }  // end qMax_lhapdf_nnlojet_

  double nf_lhapdf_nnlojet_(void* ptr) {
    return ( (LHAPDF::PDF*) ptr ) -> info().get_entry_as<int>("NumFlavors");
  }  // end nf_lhapdf_nnlojet_

  bool hasFlavor_lhapdf_nnlojet_(void* ptr, const int& flv) {
    return ( (LHAPDF::PDF*) ptr ) -> hasFlavor(flv);
  }  // end hasFlavor_lhapdf_nnlojet_

  double alphasQ_lhapdf_nnlojet_(void* ptr, const double& Q) {
    return ( (LHAPDF::PDF*) ptr ) -> alphasQ(Q);
  }  // end alphasQ_lhapdf_nnlojet_

  double xfxQ_lhapdf_nnlojet_(void* ptr, const int& id, const double& x, const double& Q) {
    // std::cout << "xfxQ_lhapdf_nnlojet_" << std::endl;
    // ( (LHAPDF::PDF*) ptr ) -> print();
    return ( (LHAPDF::PDF*) ptr ) -> xfxQ(id, x, Q);
  }  // end xfxQ_lhapdf_nnlojet_

  void evolvePDFQ_lhapdf_nnlojet_(void* ptr, const double& x, const double& Q, double xfxQ[13]) {
    // std::cout << "evolvePDFQ_lhapdf_nnlojet_" << std::endl;
    // ( (LHAPDF::PDF*) ptr ) -> print();
    LHAPDF::PDF* pdf = (LHAPDF::PDF*) ptr;  // cast
    for (size_t i = 0; i < 13; ++i) {
      xfxQ[i] = pdf->xfxQ(i-6, x, Q);
    }
  }  // end evolvePDFQ_lhapdf_nnlojet_

}  // end extern "C"

