! A small module for the unit phase space checker boolean, 
! This is also useful for the initialisation phase for
! applgrid and fastNLO. This can be extended if necessary

module UnitPhase_mod

  implicit none
  public
  logical :: phase_unit = .false.
  logical :: fixS = .false.
  logical :: nocuts = .false.

contains
  
  double precision function sig_unit(rnorm,x1,x2,wgt)
    use Process_mod, only : nPDFs_proc
    use Channels_mod
    use Scales_mod
    use KinData_mod, only: kin
    double precision rnorm,x1,x2,wgt
    double precision rnormcurr,wgtcurr
    integer ipass,i
    double precision :: bino
    double precision partons(nMax_scl),kinwt(nMax_scl)
    common /histonorm/rnormcurr,wgtcurr
    !$omp threadprivate(/histonorm/)
    double precision sij, dummy_me, sijk
    integer :: n

    call currentContrib_chan(npar=n)

    sig_unit = 0d0
    ipass = 1

    select case (nPDFs_proc)
    case (0)
      call ecuts_epem(0,n,ipass)
    case (1)
      call ecuts_dis(0,n,ipass)
    case default
      call ecuts(0,n,ipass)
    end select

    !> only return zero if nocuts = .false. and the jet algorithm failed
    if ( (.not.nocuts) .and. (ipass.eq.0) ) return 

    current_chan = ilower_multi_chan  ! make sure it's in a valid range
    ip1_chan     = 0
    ip2_chan     = 0

    wgtcurr = wgt
    rnormcurr = rnorm

    partons = 1d0
    kinwt   = 1d0

    dummy_me = 1d0
!      select case(n)
!      case(5)
!         ! HJ
!         sij = kin(n)%s(4,5)
!         dummy_me = 1d0/dsqrt(dabs(sij))
!      case(6)
!         ! HJ & VBF
!         sij = kin(n)%s(3,4)
!         dummy_me = 1d0/dabs(sij)
!      case(7)
!         ! HJJ & VBFJ
!         sij = kin(n)%s(3,4)
!         sijk = kin(n)%s(3,4) + kin(n)%s(3,5) + kin(n)%s(4,5)
!         dummy_me = 1d0/dsqrt(dabs(sij))
!      case(8)
!         ! VBFJJ
!         sij = kin(n)%s(3,4)
!         dummy_me = 1d0/dsqrt(dabs(sij))
!      end select

    sig_unit = bino(1,partons,kinwt)
    ! sig_unit = rnorm*sig_unit
    ! call storewgt(1,kinwt)

    sig_unit = rnorm*dummy_me
    return
  end function sig_unit

end module UnitPhase_mod


! this looks redundant but is essential for the grid-filling routines
logical function getUnitPhase()
use UnitPhase_mod
getUnitPhase = phase_unit
end function getUnitPhase
