*************************************************
* This subroutine determines the input parameters
* for x1 and x2 depending on the region of integration
*
      subroutine determineregions(ix,x1,x2,xreg1,xreg2)
      use Process_mod, only : nPDFs_proc, n_fs_spectators_proc
      implicit real*8(a-h,o-y)
      implicit complex*16(z)

      select case(nPDFs_proc)
      case(2)
         if(ix.eq.1)then
            xreg1 = 1d0
            xreg2 = 1d0
         elseif(ix.eq.2)then
            xreg1 = 1d0
            xreg2 = x2
         elseif(ix.eq.3)then
            xreg1 = x1
            xreg2 = 1d0
         elseif(ix.eq.4)then
            xreg1 = x1
            xreg2 = x2
         else
            write(*,*) "ix region parameter invalid in"//
     $           "determineregions: ", ix
            stop
         endif
      case(1)
         if(n_fs_spectators_proc.eq.1) then
            xreg2=1d0
            if(ix.eq.1)then
               xreg1 = 1d0
            elseif(ix.eq.3)then
               xreg1 = x1
            else
               write(*,*) "ix region parameter invalid in"//
     $              "determineregions for DIS: ", ix
               stop
            endif
         elseif(n_fs_spectators_proc.eq.0) then
         if(ix.eq.1)then
            xreg1 = 1d0
            xreg2 = 1d0
         elseif(ix.eq.2)then
            xreg1 = 1d0
            xreg2 = x2
         elseif(ix.eq.3)then
            xreg1 = x1
            xreg2 = 1d0
         elseif(ix.eq.4)then
            xreg1 = x1
            xreg2 = x2
         else
            write(*,*) "ix region parameter invalid in"//
     $           "determineregions: ", ix
            stop
         endif
      endif
      case(0)
         x1=0d0
         x2=0d0
         xreg1=0d0
         xreg2=0d0
      case default
         stop "nPDFs_proc is not set properly"
      end select

      return
      end
