#include <dlfcn.h>
#include <string.h>
#include <ctype.h>

//#include <iostream>

// default value overridden in cmake
#ifndef SHARED_MODULE_SUFFIX
#define SHARED_MODULE_SUFFIX ".so"
#endif
#ifndef FC_GLOBAL_PREFIX
#define FC_GLOBAL_PREFIX ""
#endif
#ifndef FC_GLOBAL_SUFFIX
#define FC_GLOBAL_SUFFIX "_"
#endif

extern "C" {

  int rtld_lazy_nnlojet_ = RTLD_LAZY;
  int rtld_now_nnlojet_ = RTLD_NOW;
  int rtld_global_nnlojet_ = RTLD_GLOBAL;
  int rtld_local_nnlojet_ = RTLD_LOCAL;

  const char * shared_module_suffix_nnlojet_ = SHARED_MODULE_SUFFIX;

  void mangle_nnlojet_(const char *in_name, char *out_name) {
    //std::cout << "$ " << strlen(in_name) << "\n";
    const int slen = strlen(in_name);
    char case_name[slen+1];
    for (int i=0; i<slen; i++)
#ifdef FC_GLOBAL_QUPPER
        case_name[i] = toupper(in_name[i]);
#else
        case_name[i] = tolower(in_name[i]);
#endif
    case_name[slen] = '\0';
    strcpy(out_name, FC_GLOBAL_PREFIX);
    strcat(out_name, case_name);
    strcat(out_name, FC_GLOBAL_SUFFIX);
    // FC_GLOBAL_PREFIX // FC_GLOBAL_CASE(trim(name)) // FC_GLOBAL_SUFFIX
  }

}  // end extern "C"
