*******************************************************
* A simple subroutine for generating the distributions
* for 1-x1 and 1-x2 and passing them to the /distomx/
* common block
*
      subroutine generatez1z2(x1,x2)
      implicit none
      double precision, intent(in) :: x1,x2
      double precision :: d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      double precision :: omx1, logomx1
      double precision :: omx2, logomx2

      omx1 = 1d0-x1
      omx2 = 1d0-x2
      logomx1 = log(omx1)
      logomx2 = log(omx2)

      d0x1 = 1d0/omx1
      d1x1 = logomx1/omx1
      d2x1 = logomx1**2/omx1
      d3x1 = logomx1**3/omx1
      d0x2 = 1d0/omx2
      d1x2 = logomx2/omx2
      d2x2 = logomx2**2/omx2
      d3x2 = logomx2**3/omx2

      return
      end


