
*************************************************************************************************
*************************************************************************************************

      subroutine phase4allG(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),pap(4),
     .          p3pp(4),p3app(4),papp(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4)
      dimension p2a(4),p3a(4),p4a(4)
      dimension p234(4),p34p(4),p34(4)
      dimension p234p(4)
      dimension p34a(4),p34ap(4),p3t(4),p4t(4),p3ta(4),p4ta(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension parb(4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm12,rg12,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,6)
!$omp threadprivate(/pmom/)
      common/pmomang4/pang4(4,4,4)
!$omp threadprivate(/pmomang4/)
      common/invar4/sij4(4,4),tij4(2,4)
!$omp threadprivate(/invar4/)
      common/invarang4/sijang4(4,4,4),tijang4(2,4,4),iacc(4)
!$omp threadprivate(/invarang4/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase4allG", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=6
      else
         Nphase=24
         wtps=wtps/4d0
      endif


* this is (2;3,4;a)
*
* phase space for 2->4 scattering, a+b -> 1+2+3+4 with G=p1
* with sequential splitting (234) -> 2+(34) -> 2+3+4
*
* (234) system is rotated with respect to pa axis
* (34)  system is rotated with respect to pa axis
*
* default momenta             : pang(i,j,1)
* (34) rotated                : pang(i,j,2)
* (234) rotated               : pang(i,j,3)
* (234) rotated, (34) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      wt = 0d0
      ifail =1


      s234min = dmax1(y0*shat,
     .           (dsqrt(rm2(2))+dsqrt(rm2(3))+dsqrt(rm2(4)))**2)
      s234max = dmin1((dsqrt(shat)-dsqrt(rm2(1)))**2,(1d0-y0)*shat)
      if (s234max.le.s234min) return
      call pick(1,s234,s234min,s234max,r1,wtps)
      wtps = wtps/2d0/pi
      s34min = dmax1(y0*shat,(dsqrt(rm2(3))+dsqrt(rm2(4)))**2)
      s34max = dmin1(s234,(1d0-y0)*shat)
      if (s34max.le.s34min) return
      call pick(2,s34,s34min,s34max,r2,wtps)
      wtps = wtps/2d0/pi

      call p2generic_alt(2,r3,0d0,shat,0d0,0d0,rm2(1),s234,
     .                   p1,p234,pa,pb,wtps)


* TODO: change of variables only works in the massless case.
*       Add a condition s.t. we return to the old calculations
*       for massive partons

      costhmin = -1d0
      costhmax = 1d0
      call pickcos(costh,y0,r4,wtps)

      call pick(1,phi,0d0,twopi,r5,wtps)
      call makeps2com(s234,costh,phi,rm2(2),s34,p2p,p34p,p2ap,p34ap)
      wtps = wtps*dsqrt(dlambda(s234,rm2(2),s34))/s234/32d0/pi**2

***********************************************

c---- rotate the (234) system
      call boostrest(p234,bmat)
      call unboostrest(p234,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p2(i) = 0d0
         p34(i) = 0d0
         p2a(i) = 0d0
         p34a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p2(i) = p2(i) + fmat(i,j)*p2p(j)
            p34(i) = p34(i) + fmat(i,j)*p34p(j)
            p2a(i) = p2a(i) + fmat(i,j)*p2ap(j)
            p34a(i) = p34a(i) + fmat(i,j)*p34ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      call pickcos_alt(costh,r6,wtps)
*      call pickcos(costh,y0,r6,wtps)

      call pick(1,phi,0d0,twopi,r7,wtps)
      call makeps2com(s34,costh,phi,rm2(3),rm2(4),p3p,p4p,p3ap,p4ap)
      wtps = wtps*dsqrt(dlambda(s34,rm2(3),rm2(4)))/s34/32d0/pi**2

***********************************************


      if(p234(4).lt.0d0)then
         ifail = 1
         return
      endif

c---- rotate the (34) system
      call boostrest(p34,bmat)
      call unboostrest(p34,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p4(i) = 0d0
         p3a(i) = 0d0
         p4a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (34ang) system
      call boostrest(p34a,bmat)
      call unboostrest(p34a,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3t(i) = 0d0
         p4t(i) = 0d0
         p3ta(i) = 0d0
         p4ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3t(i) = p3t(i) + fmat(i,j)*p3p(j)
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p3ta(i) = p3ta(i) + fmat(i,j)*p3ap(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         pang4(i,1,1) = p1(i)
         pang4(i,2,1) = p2(i)
         pang4(i,3,1) = p3(i)
         pang4(i,4,1) = p4(i)

         pang4(i,1,2) = p1(i)
         pang4(i,2,2) = p2(i)
         pang4(i,3,2) = p3a(i)
         pang4(i,4,2) = p4a(i)

         pang4(i,1,3) = p1(i)
         pang4(i,2,3) = p2a(i)
         pang4(i,3,3) = p3t(i)
         pang4(i,4,3) = p4t(i)

         pang4(i,1,4) = p1(i)
         pang4(i,2,4) = p2a(i)
         pang4(i,3,4) = p3ta(i)
         pang4(i,4,4) = p4ta(i)
      enddo

      do i=1,4
         call fillinv(4,pang4(1:4,1:4,i),pa,pb,sijang4(1:4,1:4,i)
     .                                        ,tijang4(1:2,1:4,i))
      enddo

      do i=1,4
        call acceptcuts4allG(sijang4(1:4,1:4,i),tijang4(1:2,1:4,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo
      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return

      ifail =0
      wt = wtps


c
c      k10 = 1
c      write(6,101) pang4(1:4,1,k10)
c      write(6,102) pang4(1:4,2,k10)
c      write(6,103) pang4(1:4,3,k10)
c      write(6,104) pang4(1:4,4,k10)
c      write(6,106) pa(1:4)
c      write(6,107) pb(1:4)
c      write(6,109) v1(1:4)
c      write(6,*) q2/dot(q,q)
c

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end


      subroutine acceptcuts4allG(sij4,tij4,ipass,itechpass)
      implicit real*8(a-h,o-z)
      dimension sij4(1:4,1:4),tij4(1:2,1:4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0
      integer ipassIF, ipassFF

      ipass = 0
      itechpass = 0
      ipassIF = 0
      ipassFF = 0

      sa2 = -tij4(1,2)
      sa3 = -tij4(1,3)
      sa4 = -tij4(1,4)
      sb2 = -tij4(2,2)
      sb3 = -tij4(2,3)
      sb4 = -tij4(2,4)
      s23 =  sij4(2,3)
      s24 =  sij4(2,4)
      s34 =  sij4(3,4)

      if (min(sa2,sa3,sa4,sb2,sb3,sb4).lt.y0*shat) return
      if (min(s23,s24,s34).lt.y0*shat) return

      itechpass = 1

* single out on 2||a, 3||a, 4||a
      rinvmina = min(sa2,sa3,sa4)
      rinvminb = min(sb2,sb3,sb4)
      if (rinvmina.lt.rinvminb) ipassIF=1

* single out on 3||4
      rinvmin  = min(s23,s24,s34)
      if (rinvmin.eq.s34) ipassFF=1

      if ((ipassIF.eq.1).and.(ipassFF.eq.1)) ipass=1

      return
      end





      subroutine fillcommon4allpG
*XC based on fillcommon4apG and duplicated for further upgrade
      implicit real*8(a-h,o-z)
      common/pmomang4/pang4(4,4,4)
!$omp threadprivate(/pmomang4/)
      common/invarang4/sijang4(4,4,4),tijang4(2,4,4),iacc(4)
!$omp threadprivate(/invarang4/)
      common/eventmom4allp/pevt4all(4,4,48)
!$omp threadprivate(/eventmom4allp/)
      common/eventinv4allp/sevt4all(4,4,48),tevt4all(2,4,48),ievt4all(48)
!$omp threadprivate(/eventinv4allp/)
      dimension i1(1:4,1:3)

      data i1/1,2,3,4,
     .        1,4,2,3,
     .        1,3,4,2/
c---- pang4 and sijang are input and correspond to an event in (2;3,4;a)
c---- this subroutine fills
c----       pevt4all(ievent,component,pnum)            : 4-momenta of events
c----       sevt4all(i,j,ievent),tevt4all([ab],i,ievent) : invariants of events
c----
c----  1: (2;34;a)
c----  2: (2;34;b)
c----  3: (4;23;a)
c----  4: (4;23;b)
c----  5: (3;42;a)
c----  6: (3;42;b)

c----  7-12: with (34) system rotated
c---- 13-18: with (234) system rotated
c---- 19-24: with (34) and (234) system rotated

c---- full phave space coverage is obtained by summing ievent=1..6
c---- angular average is obtained by averaging:
c----        M2 = 1/4* ( sum_ievent=1..24   M2(ievent))
c----

      do i=1,3
         do j=1,4
            do k=1,4
               pevt4all(k,i1(j,i),2*i-1)   = pang4(k,j,1)
               pevt4all(k,i1(j,i),2*i+5)   = pang4(k,j,2)
               pevt4all(k,i1(j,i),2*i+11)  = pang4(k,j,3)
               pevt4all(k,i1(j,i),2*i+17)  = pang4(k,j,4)
               if (k.ne.3) then
                  pevt4all(k,i1(j,i),2*i)     = pang4(k,j,1)
                  pevt4all(k,i1(j,i),2*i+6)   = pang4(k,j,2)
                  pevt4all(k,i1(j,i),2*i+12)  = pang4(k,j,3)
                  pevt4all(k,i1(j,i),2*i+18)  = pang4(k,j,4)
               else
                  pevt4all(k,i1(j,i),2*i)     = -pang4(k,j,1)
                  pevt4all(k,i1(j,i),2*i+6)   = -pang4(k,j,2)
                  pevt4all(k,i1(j,i),2*i+12)  = -pang4(k,j,3)
                  pevt4all(k,i1(j,i),2*i+18)  = -pang4(k,j,4)
               endif
            enddo
         enddo
      enddo

      do i=1,3
         do j=1,4
            do k=1,4
               sevt4all(i1(j,i),i1(k,i),2*i-1)  = sijang4(j,k,1)
               sevt4all(i1(j,i),i1(k,i),2*i+5)  = sijang4(j,k,2)
               sevt4all(i1(j,i),i1(k,i),2*i+11) = sijang4(j,k,3)
               sevt4all(i1(j,i),i1(k,i),2*i+17) = sijang4(j,k,4)
               sevt4all(i1(j,i),i1(k,i),2*i)    = sijang4(j,k,1)
               sevt4all(i1(j,i),i1(k,i),2*i+6)  = sijang4(j,k,2)
               sevt4all(i1(j,i),i1(k,i),2*i+12) = sijang4(j,k,3)
               sevt4all(i1(j,i),i1(k,i),2*i+18) = sijang4(j,k,4)
            enddo
            tevt4all(1,i1(j,i),2*i-1)  = tijang4(1,j,1)
            tevt4all(2,i1(j,i),2*i-1)  = tijang4(2,j,1)
            tevt4all(1,i1(j,i),2*i+5)  = tijang4(1,j,2)
            tevt4all(2,i1(j,i),2*i+5)  = tijang4(2,j,2)
            tevt4all(1,i1(j,i),2*i+11) = tijang4(1,j,3)
            tevt4all(2,i1(j,i),2*i+11) = tijang4(2,j,3)
            tevt4all(1,i1(j,i),2*i+17) = tijang4(1,j,4)
            tevt4all(2,i1(j,i),2*i+17) = tijang4(2,j,4)
            tevt4all(1,i1(j,i),2*i)    = tijang4(2,j,1)
            tevt4all(2,i1(j,i),2*i)    = tijang4(1,j,1)
            tevt4all(1,i1(j,i),2*i+6)  = tijang4(2,j,2)
            tevt4all(2,i1(j,i),2*i+6)  = tijang4(1,j,2)
            tevt4all(1,i1(j,i),2*i+12) = tijang4(2,j,3)
            tevt4all(2,i1(j,i),2*i+12) = tijang4(1,j,3)
            tevt4all(1,i1(j,i),2*i+18) = tijang4(2,j,4)
            tevt4all(2,i1(j,i),2*i+18) = tijang4(1,j,4)
         enddo
         ievt4all(2*i-1)  = iacc(1)
         ievt4all(2*i)    = iacc(1)
         ievt4all(2*i+5)  = iacc(2)
         ievt4all(2*i+6)  = iacc(2)
         ievt4all(2*i+11) = iacc(3)
         ievt4all(2*i+12) = iacc(3)
         ievt4all(2*i+17) = iacc(4)
         ievt4all(2*i+18) = iacc(4)
      enddo


 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 107  format(4g18.13)
 108  format(3g18.13)


      return
      end



