      subroutine phase3epem(x,wt,ifail)
      use KinData_mod, only : rotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p3p(4),pap(4),pbp(4),qp(4)
      dimension p1a(4),p2a(4),p3a(4)
      dimension p1ap(4),p2ap(4),p3ap(4)
      dimension p12(4),p12p(4)
      dimension pqa(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension trans(4,4),paux(4),ptemp(4)
      parameter(pi=3.141592653589793238d0)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common/pinee/pa(4),pb(4)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang3ee/pang3(4,3,1)
!$omp threadprivate(/pmomang3ee/)
      common/invarang3ee/sijang3(3,3,1)
!$omp threadprivate(/invarang3ee/)
      common /tcuts/ymin,y0
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

*
* phase space for 1->3 decay, q -> 1+2+3
*
* rest frame of q
*
* This is then transformed into the lab pa,pb frame
*
* massless case: integrates to P_3 = 1/256/pi**3*sab
*

cLIPS      print*, "phase3epem", x(1), wt, ifail

      Nphase=1

      r1 = x(1)
      r2 = x(2)
      !> r3 is for cos(theta) to shift photon off axis
      r3 = x(3)
      !> r4 is for phi angle
      r4 = x(4)
      costh = 0d0
      call pick(1,costh,-1d0,1d0,r3,wtps)
      !>normalise
      wtps=wtps/2d0
      sinth=dsqrt(1d0-costh**2)

      call pick(1,phi,0d0,2d0*pi,r4,wtps)
      !>normalise
      wtps=wtps/2d0/pi

      !> energies pa(4),pb(4) are set in setcollider_epem
      paux(4)=1d0
      paux(3)=costh
      paux(2)=sinth*dsin(phi)
      paux(1)=sinth*dcos(phi)

      call rotatetoz(paux,trans)

      ifail =1
      wt = 0d0
      wtps = 1d0
      call p3generic(r1,r2,shat,rm2(1),rm2(2),rm2(3),p1,p2,p3,wtps)

      if (wtps.eq.0d0) return

      p(:,:)=0d0
      do i=1,3
         select case(i)
         case(1)
           ptemp=p1
         case(2)
           ptemp=p2
         case(3)
           ptemp=p3
         end select
         do j=1,4
            do k=1,4
               p(j,i)=p(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo

      do i=1,4
         pang3(i,1,1) = p(i,1)
         pang3(i,2,1) = p(i,2)
         pang3(i,3,1) = p(i,3)
      enddo

      call fillinvee(3,pang3(1:4,1:3,1),sijang3(1:3,1:3,1))
      ifail =0
      wt = wtps

      return
      end

      subroutine fillcommon3pepem
      implicit real*8(a-h,o-z)
      common/pmomang3ee/pang3(4,3,1)
!$omp threadprivate(/pmomang3ee/)
      common/pmomang3gee/pang3g(4,3,1)
!$omp threadprivate(/pmomang3gee/)
      common/invarang3ee/sijang3(3,3,1)
!$omp threadprivate(/invarang3ee/)
      common/eventmom3pee/pevt3(4,3,1)
!$omp threadprivate(/eventmom3pee/)
      common/eventinv3pee/sevt3(3,3,1),ievt3(1)
!$omp threadprivate(/eventinv3pee/)

c---- pang3,pang3g and sija,tija are input
c---- this subroutine fills
c----       pevt3(component,pnum,ievent)             : 4-momenta of events
c----       sevt3(i,j,ievent),tevt3([ab],i,ievent)   : invariants of events
c----
c---- ievent = 1 fixed

      do j=1,3
         do k=1,4
            pevt3(k,j,1)    = pang3(k,j,1)
         enddo
      enddo
      do j=1,3
         do k=1,3
            sevt3(j,k,1)    = sijang3(j,k,1)
         enddo
      enddo
      ievt3(1) = 1
      return
      end




      subroutine phase4epem(x,wt,ifail)
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4)
      dimension p1a(4),p2a(4),p3a(4),p4a(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4)
      dimension p12(4),p12p(4)
      dimension p34(4),p34p(4),p34g(4),papg(4)
      dimension x(*)
      dimension paux(4),trans(4,4),ptemp(4),ptemp1(4,7)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      parameter(pi=3.141592653589793238d0)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common/pinee/pa(4),pb(4)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang4ee/pang4(4,4,2)
!$omp threadprivate(/pmomang4ee/)
      common/invarang4ee/sijang4(4,4,2),iacc(2)
!$omp threadprivate(/invarang4ee/)
      common /tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

c---  corresponds to the phase space(3,4;12)
*
* phase space for 1->4 decay, q -> 1+2+3+4 with (34)->3+4
*
* (34) system is rotated around p1+p2 axis
*
* massless case: integrates to P_4 = 1/24576/pi**5
*

cLIPS      print*, "phase4epem", x(1), wt, ifail

      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)

      ifail =1
      wt = 0d0
      wtps = 1d0

      if(iang.eq.0)then
         Nphase=6
!acceptcuts4epem only accept 1/6 of the full PS. 
!So one needs to permute 6 times to cover the full PS.
      else
         Nphase=12
         wtps=wtps/2d0
      endif

      costh = 0d0
      call pick(1,costh,-1d0,1d0,r6,wtps)
      !>normalise
      wtps=wtps/2d0
      sinth=dsqrt(1d0-costh**2)

      call pick(1,phi,0d0,2d0*pi,r7,wtps)
      !>normalise
      wtps=wtps/2d0/pi

      !> energies pa(4),pb(4) are set in setcollider_epem
      paux(4)=1d0
      paux(3)=costh
      paux(2)=sinth*dsin(phi)
      paux(1)=sinth*dcos(phi)

      call rotatetoz(paux,trans)


      s34min = dmax1(y0*shat,(dsqrt(rm2(3))+dsqrt(rm2(4)))**2)
      s34max = dmin1((dsqrt(shat)-dsqrt(rm2(1))-dsqrt(rm2(2)))**2
     .              ,(1d0-5d0*y0)*shat)
      if (s34min.ge.s34max) return
      call pick(2,s34,s34min,s34max,r1,wtps)
      wtps = wtps/2d0/pi
      call p3generic(r2,r3,shat,rm2(1),rm2(2),s34,p1,p2,p34,wtps)
      if (wtps.eq.0d0) return
      do i=1,4
         p12(i) = p1(i)+p2(i)
      enddo

      costhmin = -1d0
      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi
      call pick(1,costh,costhmin,costhmax,r4,wtps)
      call pick(1,phi,phimin,phimax,r5,wtps)
      wtps = wtps*dsqrt(dlambda(s34,rm2(3),rm2(4)))/s34/32d0/pi**2
      call makeps2com(s34,costh,phi,rm2(3),rm2(4),p3p,p4p,p3ap,p4ap)
      call boostrest(p34,bmat)
      call unboostrest(p34,ubmat)
      do i=1,4
         v(i) = 0d0
         p12p(i) = 0d0
         do j=1,4
            p12p(i) = p12p(i) + bmat(i,j)*p12(j)
         enddo
      enddo

      call unrotatetoz(p12p,urmat)

      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p3(i) = 0d0
         p4(i) = 0d0
         p3a(i) = 0d0
         p4a(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
         enddo
      enddo

      !> rotate electron back to z axis (same as in phase3epem)
      p(:,:)=0d0
      do i=1,4
         select case(i)
         case(1)
            ptemp=p1
         case(2)
            ptemp=p2
         case(3)
            ptemp=p3
         case(4)
            ptemp=p4
         end select
         do j=1,4
            do k=1,4
               p(j,i)=p(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo

! pang4(i,j,1) and pang4(i,j,2) are different in pang4(i,3,x) and pang4(i,4,x)
! With relative pi/2 azimuth angle 
      do i=1,4
         p1a(i) = p(i,1)
         p2a(i) = p(i,2)
         pang4(i,1,1) = p(i,1)
         pang4(i,2,1) = p(i,2)
         pang4(i,3,1) = p(i,3)
         pang4(i,4,1) = p(i,4)
         pang4(i,1,2) = p1a(i)
         pang4(i,2,2) = p2a(i)
      enddo

      !> rotate electron back to z axis
      ptemp1(:,:)=0d0
      do i=1,2
         select case(i)
         case(1)
            ptemp=p3a
         case(2)
            ptemp=p4a
         end select
         do j=1,4
            do k=1,4
               ptemp1(j,i)=ptemp1(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo

      do i=1,4
         pang4(i,3,2) = ptemp1(i,1)
         pang4(i,4,2) = ptemp1(i,2)
      enddo

      do i=1,2
         call fillinvee(4,pang4(1:4,1:4,i),sijang4(1:4,1:4,i))
      enddo
      do i=1,2
         call acceptcuts4epem(sijang4(1:4,1:4,i),iacc(i))
      enddo
      if (iacc(1)+iacc(2).eq.0) return
      ifail =0
      wt = wtps

      return
      end


      subroutine acceptcuts4epem(sij4,ipass)
      implicit real*8(a-h,o-z)
      dimension sij4(1:4,1:4)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0

      s12 = sij4(1,2)
      s13 = sij4(1,3)
      s14 = sij4(1,4)
      s23 = sij4(2,3)
      s24 = sij4(2,4)
      s34 = sij4(3,4)
      rinvmin = min(s12,s13,s14,s23,s24,s34)
      if (rinvmin.lt.y0*shat) return
      ipass = 0
* single out on 3||4, which 1/6 of the full PS region
      if (rinvmin.eq.s34) ipass=1
      return
      end


      subroutine fillcommon4pepem
      implicit real*8(a-h,o-z)
      dimension i1(1:4,1:6)
      common/pmomang4ee/pang4(4,4,2)
!$omp threadprivate(/pmomang4ee/)
      common/invarang4ee/sijang4(4,4,2),iacc(2)
!$omp threadprivate(/invarang4ee/)
      common/eventmom4pee/pevt4(4,4,12)
!$omp threadprivate(/eventmom4pee/)
      common/eventinv4pee/sevt4(4,4,12),ievt4(12)
!$omp threadprivate(/eventinv4pee/)
      data i1/1,2,3,4,
     .        1,3,2,4,
     .        1,4,2,3,
     .        2,3,1,4,
     .        2,4,1,3,
     .        3,4,1,2/

c---- pang4 and sija are input and correspond to an event in (3,4;12)
c---- this subroutine fills
c----       pevt4(component,pnum,ievent)     : 4-momenta of events
c----       sevt4(i,j,ievent)                : invariants of events
c----
c---- ievent
c----  1: (3,4;12)
c----  2: (2,4;13)
c----  3: (2,3;14)
c----  4: (1,4;23)
c----  5: (1,3;24)
c----  6: (1,2;34)
c----
c----  7-12 (i,j;x) with (i,j) system rotated around x-axis
c----
c---- full phave space coverage is obtained by summing all 6 events
c---- angular average is obtained by averaging:
c----        M2 = 1/2* ( sum_ievent=1..12   M2(ievent))
c----
      do i=1,6
         do j=1,4
            do k=1,4
               pevt4(k,i1(j,i),i)    = pang4(k,j,1)
               pevt4(k,i1(j,i),i+6)  = pang4(k,j,2)
            enddo
         enddo
      enddo

      do i=1,6
         do j=1,4
            do k=1,4
               sevt4(i1(j,i),i1(k,i),i)    = sijang4(j,k,1)
               sevt4(i1(j,i),i1(k,i),i+6)  = sijang4(j,k,2)
            enddo
         enddo
         ievt4(i)   = iacc(1)
         ievt4(i+6) = iacc(2)
      enddo

      return
      end



      subroutine phase5aepem(x,wt,ifail)
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
     .          p3pp(4),p3app(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p3a(4),p4a(4),p5a(4)
      dimension p345(4),p45p(4),p45(4)
      dimension p345p(4)
      dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
      dimension p12(4),p12p(4)
      dimension trans(4,4),paux(4),ptemp(4),ptemp1(4,7)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      parameter(pi=3.141592653589793238d0)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common/pinee/pa(4),pb(4)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5ee/pang5(4,5,4)
!$omp threadprivate(/pmomang5ee/)
      common/invarang5ee/sijang5(5,5,4),iacc(4)
!$omp threadprivate(/invarang5ee/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)


* this is (3;4,5;12)
*
* phase space for 1->5 scattering, q -> 1+2+3+4+5
* with sequential splitting (345) -> 3+(45) -> 3+4+5
*
* (345) system is rotated with respect to p12 axis
* (45)  system is rotated with respect to p3 axis
*
* default momenta             : pang(i,j,1)
* (45) rotated                : pang(i,j,2)
* (345) rotated               : pang(i,j,3)
* (345) rotated, (45) rotated : pang(i,j,4)
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*

cLIPS      print*, "phase5aepem", x(1), wt, ifail

      r1  = x(1)
      r2  = x(2)
      r3  = x(3)
      r4  = x(4)
      r5  = x(5)
      r6  = x(6)
      r7  = x(7)
      r8  = x(8)
      r9  = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1
      wtps = 1d0

      if(iang.eq.0)then
         Nphase=30
      else
         Nphase=120
         wtps=wtps/4d0
      endif


      costh = 0d0
      call pick(1,costh,-1d0,1d0,r9,wtps)
      !>normalise
      wtps=wtps/2d0
      sinth=dsqrt(1d0-costh**2)

      call pick(1,phi,0d0,2d0*pi,r10,wtps)
      !>normalise
      wtps=wtps/2d0/pi

      !> energies pa(4),pb(4) are set in setcollider_epem
      paux(4)=1d0
      paux(3)=costh
      paux(2)=sinth*dsin(phi)
      paux(1)=sinth*dcos(phi)

      call rotatetoz(paux,trans)

      s345min = dmax1(y0*shat,
     .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s345max = (1d0-y0)*shat
      if (s345max.le.s345min) return
      call pick(2,s345,s345min,s345max,r1,wtps)
      wtps = wtps/2d0/pi
      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1(s345,(1d0-y0)*shat)
      if (s45max.le.s45min) return
      call pick(2,s45,s45min,s45max,r2,wtps)
      wtps = wtps/2d0/pi

      call p3generic(r3,r4,shat,rm2(1),rm2(2),s345,p1,p2,p345,wtps)
      if (wtps.eq.0d0) return
      do i=1,4
         p12(i) = p1(i)+p2(i)
      enddo

      costhmin = -1d0
      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi
      call pick(1,costh,costhmin,costhmax,r5,wtps)
      call pick(1,phi,phimin,phimax,r6,wtps)
      call makeps2com(s345,costh,phi,rm2(3),s45,p3p,p45p,p3ap,p45ap)
      wtps = wtps*dsqrt(dlambda(s345,rm2(3),s45))/s345/32d0/pi**2

      call pick(1,costh,costhmin,costhmax,r7,wtps)
      call pick(1,phi,phimin,phimax,r8,wtps)
      call makeps2com(s45,costh,phi,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap)
      wtps = wtps*dsqrt(dlambda(s45,rm2(4),rm2(5)))/s45/32d0/pi**2

c---- rotate the (345) system
      call boostrest(p345,bmat)
      call unboostrest(p345,ubmat)
      do i=1,4
         v(i) = 0d0
         p12p(i) = 0d0
         do j=1,4
            p12p(i) = p12p(i) + bmat(i,j)*p12(j)
         enddo
      enddo
      call unrotatetoz(p12p,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p45(i) = 0d0
         p3a(i) = 0d0
         p45a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p45(i) = p45(i) + fmat(i,j)*p45p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (45) system
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         p3pp(i) = 0d0
         do j=1,4
            p3pp(i) = p3pp(i) + bmat(i,j)*p3(j)
         enddo
      enddo
      call unrotatetoz(p3pp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (45ang) system
      call boostrest(p45a,bmat)
      call unboostrest(p45a,ubmat)
      do i=1,4
         v(i) = 0d0
         p3app(i) = 0d0
         do j=1,4
            p3app(i) = p3app(i) + bmat(i,j)*p3a(j)
         enddo
      enddo
      call unrotatetoz(p3app,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4t(i) = 0d0
         p5t(i) = 0d0
         p4ta(i) = 0d0
         p5ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      !> rotate electron back to z axis
      p(:,:)=0d0
      do i=1,5
         select case(i)
         case(1)
            ptemp=p1
         case(2)
            ptemp=p2
         case(3)
            ptemp=p3
         case(4)
            ptemp=p4
         case(5)
            ptemp=p5
         end select
         do j=1,4
            do k=1,4
               p(j,i)=p(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo

      do i=1,4
         pang5(i,1,1) = p(i,1)
         pang5(i,2,1) = p(i,2)
         pang5(i,3,1) = p(i,3)
         pang5(i,4,1) = p(i,4)
         pang5(i,5,1) = p(i,5)

         pang5(i,1,2) = p(i,1)
         pang5(i,2,2) = p(i,2)
         pang5(i,3,2) = p(i,3)

         pang5(i,1,3) = p(i,1)
         pang5(i,2,3) = p(i,2)
         pang5(i,1,4) = p(i,1)
         pang5(i,2,4) = p(i,2)
      enddo


      ptemp1(:,:)=0d0
      do i=1,3
         select case(i)
         case(1)
            ptemp=p3a
         case(2)
            ptemp=p4a
         case(3)
            ptemp=p5a
         end select
         do j=1,4
            do k=1,4
               ptemp1(j,i)=ptemp1(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo
      do i=1,4
         pang5(i,4,2) = ptemp1(i,2)
         pang5(i,5,2) = ptemp1(i,3)

         pang5(i,3,3) = ptemp1(i,1)
         pang5(i,3,4) = ptemp1(i,1)
      enddo

      ptemp1(:,:)=0d0
      do i=1,2
         select case(i)
         case(1)
            ptemp=p4t
         case(2)
            ptemp=p5t
         end select
         do j=1,4
            do k=1,4
               ptemp1(j,i)=ptemp1(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo
      do i=1,4
         pang5(i,4,3) = ptemp1(i,1)
         pang5(i,5,3) = ptemp1(i,2)
      enddo

      ptemp1(:,:)=0d0
      do i=1,2
         select case(i)
         case(1)
            ptemp=p4ta
         case(2)
            ptemp=p5ta
         end select
         do j=1,4
            do k=1,4
               ptemp1(j,i)=ptemp1(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo
      do i=1,4
         pang5(i,4,4) = ptemp1(i,1)
         pang5(i,5,4) = ptemp1(i,2)
      enddo

      do i=1,4
         call fillinvee(5,pang5(1:4,1:5,i),sijang5(1:5,1:5,i))
      enddo

      do i=1,4
        call acceptcuts5aepem(sijang5(1:5,1:5,i),iacc(i))
      enddo
      if ( iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return
      ifail =0
      wt = wtps

      return
      end


      subroutine acceptcuts5aepem(sij5,ipass)
      implicit real*8(a-h,o-z)
      dimension sij5(1:5,1:5)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0

      s12 = sij5(1,2)
      s13 = sij5(1,3)
      s14 = sij5(1,4)
      s15 = sij5(1,5)
      s23 = sij5(2,3)
      s24 = sij5(2,4)
      s25 = sij5(2,5)
      s34 = sij5(3,4)
      s35 = sij5(3,5)
      s45 = sij5(4,5)

      smin1 = shat
      smin2 = shat

      do i=1,5
         do j=i+1,5
            if (sij5(i,j).lt.smin2) then
               smin2 = sij5(i,j)
               if (smin2.lt.smin1) then
                  stmp  = smin1
                  smin1 = smin2
                  smin2 = stmp
               endif
            endif
         enddo
      enddo

      if (smin1.lt.y0*shat) return
      if (smin1.eq.s45.and.smin2.eq.s34) ipass=1
      if (smin1.eq.s45.and.smin2.eq.s35) ipass=1

      return
      end




      subroutine fillcommon5apepem
      implicit real*8(a-h,o-z)
      common/pmomang5ee/pang5(4,5,4)
!$omp threadprivate(/pmomang5ee/)
      common/invarang5ee/sijang5(5,5,4),iacc(4)
!$omp threadprivate(/invarang5ee/)
      common/eventmom5apee/pevt5a(4,5,120)
!$omp threadprivate(/eventmom5apee/)
      common/eventinv5apee/sevt5a(5,5,120),ievt5a(120)
!$omp threadprivate(/eventinv5apee/)
      dimension i1(1:5,1:30)

      data i1/1,2,3,4,5,
     .        1,2,4,5,3,
     .        1,2,5,3,4,
     .        1,3,2,4,5,
     .        1,3,4,5,2,
     .        1,3,5,2,4,
     .        1,4,2,3,5,
     .        1,4,3,5,2,
     .        1,4,5,2,3,
     .        1,5,2,3,4,
     .        1,5,3,4,2,
     .        1,5,4,2,3,
     .        2,3,1,4,5,
     .        2,3,4,5,1,
     .        2,3,5,1,4,
     .        2,4,1,3,5,
     .        2,4,3,5,1,
     .        2,4,5,1,3,
     .        2,5,1,3,4,
     .        2,5,3,4,1,
     .        2,5,4,1,3,
     .        3,4,1,2,5,
     .        3,4,2,5,1,
     .        3,4,5,1,2,
     .        3,5,1,2,4,
     .        3,5,2,4,1,
     .        3,5,4,1,2,
     .        4,5,1,2,3,
     .        4,5,2,3,1,
     .        4,5,3,1,2/

c---- pang5 and sijang are input and correspond to an event in (3;45;12)
c---- this subroutine fills
c----       pevt5a(ievent,component,pnum)            : 4-momenta of events
c----       sevt5a(i,j,ievent),tevt5a([ab],i,ievent) : invariants of events
c----
c----  1: (3;45;12)
c----  2: (4;35;12)
c----  3: (5;34;12)
c----  4: (2;45;13)
c----  5: (4;25;13)
c----  6: (5;24;13)
c----  7: (2;35;14)
c----  8: (3;25;14)
c----  9: (5;23;14)
c---- 10: (2;34;15)
c---- 11: (3;24;15)
c---- 12: (4;23;15)
c---- 13: (1;45;23)
c---- 14: (4;15;23)
c---- 15: (5;14;23)
c---- 16: (1;35;24)
c---- 17: (3;15;24)
c---- 18: (5;13;24)
c---- 19: (1;34;25)
c---- 20: (3;14;25)
c---- 21: (4;13;25)
c---- 22: (1;25;34)
c---- 23: (2;15;34)
c---- 24: (5;12;34)
c---- 25: (1;24;35)
c---- 26: (2;14;35)
c---- 27: (4;12;35)
c---- 28: (1;23;45)
c---- 29: (2;13;45)
c---- 30: (3;12;45)

c---- 31-60:  with (45) system rotated
c---- 61-90:  with (345) system rotated
c---- 91-120: with (45) and (345) system rotated

c---- full phave space coverage is obtained by summing ievent=1..30
c---- angular average is obtained by averaging:
c----        M2 = 1/4* ( sum_ievent=1..120   M2(ievent))
c----

      do i=1,30
         do j=1,5
            do k=1,4
               pevt5a(k,i1(j,i),i)     = pang5(k,j,1)
               pevt5a(k,i1(j,i),i+30)  = pang5(k,j,2)
               pevt5a(k,i1(j,i),i+60)  = pang5(k,j,3)
               pevt5a(k,i1(j,i),i+90)  = pang5(k,j,4)
            enddo
         enddo
      enddo

      do i=1,30
         do j=1,5
            do k=1,5
               sevt5a(i1(j,i),i1(k,i),i)    = sijang5(j,k,1)
               sevt5a(i1(j,i),i1(k,i),i+30) = sijang5(j,k,2)
               sevt5a(i1(j,i),i1(k,i),i+60) = sijang5(j,k,3)
               sevt5a(i1(j,i),i1(k,i),i+90) = sijang5(j,k,4)
            enddo
         enddo
         ievt5a(i)    = iacc(1)
         ievt5a(i+30) = iacc(2)
         ievt5a(i+60) = iacc(3)
         ievt5a(i+90) = iacc(4)
      enddo
      return
      end



      subroutine phase5bepem(x,wt,ifail)
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4)
      dimension p1a(4),p2a(4),p3a(4),p4a(4),p5a(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p12(4),p34(4)
      dimension paux(4),trans(4,4),ptemp(4),ptemp1(4,7)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      parameter(pi=3.141592653589793238d0)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common/pinee/pa(4),pb(4)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5ee/pang5(4,5,4)
!$omp threadprivate(/pmomang5ee/)
      common/invarang5ee/sijang5(5,5,4),iacc(4)
!$omp threadprivate(/invarang5ee/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)


* this is (1,2;5;3,4;5)
*
* phase space for 1->5 decay, q -> 1+2+3+4+5 with q=p1+p2
* with splittings (12) -> 1+2; (34)->3+4
*
* (12) system is rotated with respect to p5 axis
* (34) system is rotated with respect to p5 axis
*
* default momenta            : pang(i,j,1)
* (12) rotated               : pang(i,j,2)
* (34) rotated               : pang(i,j,3)
* (12) rotated, (34) rotated : pang(i,j,4)
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*

cLIPS      print*, "phase5bepem", x(1), wt, ifail

      r1  = x(1)
      r2  = x(2)
      r3  = x(3)
      r4  = x(4)
      r5  = x(5)
      r6  = x(6)
      r7  = x(7)
      r8  = x(8)
      r9  = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1
      wtps = 1d0

      if(iang.eq.0)then
         Nphase=15
      else
         Nphase=60
         wtps=wtps/4d0
      endif


      costh = 0d0
      call pick(1,costh,-1d0,1d0,r9,wtps)
      !>normalise
      wtps=wtps/2d0
      sinth=dsqrt(1d0-costh**2)

      call pick(1,phi,0d0,2d0*pi,r10,wtps)
      !>normalise
      wtps=wtps/2d0/pi

      !> energies pa(4),pb(4) are set in setcollider_epem
      paux(4)=1d0
      paux(3)=costh
      paux(2)=sinth*dsin(phi)
      paux(1)=sinth*dcos(phi)

      call rotatetoz(paux,trans)

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3))-dsqrt(rm2(4))
     .              -dsqrt(rm2(5)))**2,(1d0-5d0*y0)*shat)
      if (s12min.ge.s12max) return
      call pick(2,s12,s12min,s12max,r1,wtps)
      wtps = wtps/2d0/pi

      s34min = dmax1(y0*shat,(dsqrt(rm2(3))+dsqrt(rm2(4)))**2)
      s34max = dmin1((dsqrt(shat)-dsqrt(s12)-dsqrt(rm2(5)))**2
     .        ,(1d0-y0)*shat)
      if (s34max.le.s34min) return
      call pick(2,s34,s34min,s34max,r2,wtps)
      wtps = wtps/2d0/pi
      call p3generic(r3,r4,shat,s12,s34,rm2(5),p12,p34,p5,wtps)
      if (wtps.eq.0d0) return

      costhmin = -1d0
      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi
      call pick(1,costh,costhmin,costhmax,r5,wtps)
      call pick(1,phi,phimin,phimax,r6,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      costhmin = -1d0
      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi
      call pick(1,costh,costhmin,costhmax,r7,wtps)
      call pick(1,phi,phimin,phimax,r8,wtps)
      call makeps2com(s34,costh,phi,rm2(3),rm2(4),p3p,p4p,p3ap,p4ap)
      wtps = wtps*dsqrt(dlambda(s34,rm2(3),rm2(4)))/s34/32d0/pi**2

c---- rotate the (12) system
      call boostrest(p12,bmat)
      call unboostrest(p12,ubmat)
      do i=1,4
         v(i) = 0d0
         p5p(i) = 0d0
         do j=1,4
            p5p(i) = p5p(i) + bmat(i,j)*p5(j)
         enddo
      enddo
      call unrotatetoz(p5p,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
              fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         p1a(i) = 0d0
         p2a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + fmat(i,j)*p1p(j)
            p2(i) = p2(i) + fmat(i,j)*p2p(j)
            p1a(i) = p1a(i) + fmat(i,j)*p1ap(j)
            p2a(i) = p2a(i) + fmat(i,j)*p2ap(j)
            v(i) = v(i) + fmat(i,j)*p5p(j)
         enddo
      enddo

c---- rotate the (34) system
      call boostrest(p34,bmat)
      call unboostrest(p34,ubmat)
      do i=1,4
         v(i) = 0d0
         p5p(i) = 0d0
         do j=1,4
            p5p(i) = p5p(i) + bmat(i,j)*p5(j)
         enddo
      enddo
      call unrotatetoz(p5p,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p4(i) = 0d0
         p3a(i) = 0d0
         p4a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            v(i) = v(i) + fmat(i,j)*p5p(j)
         enddo
      enddo

      !> rotate electron back to z axis
      p(:,:)=0d0
      do i=1,5
         select case(i)
         case(1)
            ptemp=p1
         case(2)
            ptemp=p2
         case(3)
            ptemp=p3
         case(4)
            ptemp=p4
         case(5)
            ptemp=p5
         end select
         do j=1,4
            do k=1,4
               p(j,i)=p(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo
      do i=1,4
         pang5(i,1,1) = p(i,1)
         pang5(i,2,1) = p(i,2)
         pang5(i,3,1) = p(i,3)
         pang5(i,4,1) = p(i,4)
         pang5(i,5,1) = p(i,5)
         pang5(i,3,2) = p(i,3)
         pang5(i,4,2) = p(i,4)
         pang5(i,5,2) = p(i,5)
         pang5(i,1,3) = p(i,1)
         pang5(i,2,3) = p(i,2)
         pang5(i,5,3) = p(i,5)
         pang5(i,5,4) = p(i,5)
      enddo

      ptemp1(:,:)=0d0
      do i=1,5
         select case(i)
         case(1)
            ptemp=p1a
         case(2)
            ptemp=p2a
         case(3)
            ptemp=p3a
         case(4)
            ptemp=p4a
         end select
         do j=1,4
            do k=1,4
               ptemp1(j,i)=ptemp1(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo

      do i=1,4
         pang5(i,1,2) = ptemp1(i,1)
         pang5(i,2,2) = ptemp1(i,2)
         pang5(i,3,3) = ptemp1(i,3)
         pang5(i,4,3) = ptemp1(i,4)
         pang5(i,1,4) = ptemp1(i,1)
         pang5(i,2,4) = ptemp1(i,2)
         pang5(i,3,4) = ptemp1(i,3)
         pang5(i,4,4) = ptemp1(i,4)
      enddo
      do i=1,4
         call fillinvee(5,pang5(1:4,1:5,i),sijang5(1:5,1:5,i))
      enddo
      do i=1,4
        call acceptcuts5bepem(sijang5(1:5,1:5,i),iacc(i))
      enddo
      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return
      ifail =0
      wt = wtps
      return
      end



      subroutine acceptcuts5bepem(sij5,ipass)
      implicit real*8(a-h,o-z)
      dimension sij5(1:5,1:5)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0
      s12 = sij5(1,2)
      s13 = sij5(1,3)
      s14 = sij5(1,4)
      s15 = sij5(1,5)
      s23 = sij5(2,3)
      s24 = sij5(2,4)
      s25 = sij5(2,5)
      s34 = sij5(3,4)
      s35 = sij5(3,5)
      s45 = sij5(4,5)

      smin1 = shat
      smin2 = shat

      do i=1,5
         do j=i+1,5
            if (sij5(i,j).lt.smin2) then
               smin2 = sij5(i,j)
               if (smin2.lt.smin1) then
                  stmp  = smin1
                  smin1 = smin2
                  smin2 = stmp
               endif
            endif
         enddo
      enddo

      if (smin1.lt.y0*shat) return
      if (smin1.eq.s12.and.smin2.eq.s34) ipass=1
      if (smin1.eq.s34.and.smin2.eq.s12) ipass=1

      return
      end


      subroutine fillcommon5bpepem
      implicit real*8(a-h,o-z)
      common/pmomang5ee/pang5(4,5,4)
!$omp threadprivate(/pmomang5ee/)
      common/invarang5ee/sijang5(5,5,4),iacc(4)
!$omp threadprivate(/invarang5ee/)
      common/eventmom5bpee/pevt5b(4,5,60)
!$omp threadprivate(/eventmom5bpee/)
      common/eventinv5bpee/sevt5b(5,5,60),ievt5b(60)
!$omp threadprivate(/eventinv5bpee/)
      dimension i1(1:5,1:15)

      data i1/1,2,3,4,5,
     .        1,3,2,4,5,
     .        1,4,2,3,5,
     .        1,2,3,5,4,
     .        1,3,2,5,4,
     .        1,5,2,3,4,
     .        1,2,4,5,3,
     .        1,4,2,5,3,
     .        1,5,2,4,3,
     .        1,3,4,5,2,
     .        1,4,3,5,2,
     .        1,5,3,4,2,
     .        2,3,4,5,1,
     .        2,4,3,5,1,
     .        2,5,3,4,1/

c---- pang5 and sijang are input and correspond to an event in (12;34;5)
c---- this subroutine fills
c----       pevt5b(ievent,component,pnum)  : 4-momenta of events
c----       sevt5b(i,j,ievent)             : invariants of events
c----
c----  1: (12;34;5)
c----  2: (13;24;5)
c----  3: (14;23;5)
c----  4: (12;35;4)
c----  5: (13;25;4)
c----  6: (15;23;4)
c----  7: (12;45;3)
c----  8: (14;25;3)
c----  9: (15;24;3)
c---- 10: (13;45;2)
c---- 11: (14;35;2)
c---- 12: (15;34;2)
c---- 13: (23;45;1)
c---- 14: (24;35;1)
c---- 15: (25;34;1)

c---- 16-30: with (12) system rotated
c---- 31-45: with (34) system rotated
c---- 46-60: with (12) and (34) system rotated

c---- full phave space coverage is obtained by summing ievent=1..15
c---- angular average is obtained by averaging:
c----        M2 = 1/4* ( sum_ievent=1..60   M2(ievent))
c----

      do i=1,15
         do j=1,5
            do k=1,4
               pevt5b(k,i1(j,i),i)    = pang5(k,j,1)
               pevt5b(k,i1(j,i),i+15) = pang5(k,j,2)
               pevt5b(k,i1(j,i),i+30) = pang5(k,j,3)
               pevt5b(k,i1(j,i),i+45) = pang5(k,j,4)
            enddo
         enddo
      enddo

      do i=1,15
         do j=1,5
            do k=1,5
               sevt5b(i1(j,i),i1(k,i),i)    = sijang5(j,k,1)
               sevt5b(i1(j,i),i1(k,i),i+15) = sijang5(j,k,2)
               sevt5b(i1(j,i),i1(k,i),i+30) = sijang5(j,k,3)
               sevt5b(i1(j,i),i1(k,i),i+45) = sijang5(j,k,4)
            enddo
         enddo
         ievt5b(i)    = iacc(1)
         ievt5b(i+15) = iacc(2)
         ievt5b(i+30) = iacc(3)
         ievt5b(i+45) = iacc(4)
      enddo
      return
      end


      subroutine phase5allepem(x,wt,ifail)
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4)
      dimension p1a(4),p2a(4),p3a(4),p4a(4),p5a(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p12(4),p34(4)
      dimension paux(4),trans(4,4),ptemp(4),ptemp1(4,7)
      dimension x(10)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      parameter(pi=3.141592653589793238d0)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common/pinee/pa(4),pb(4)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5ee/pang5(4,5,4)
!$omp threadprivate(/pmomang5ee/)
      common/invarang5ee/sijang5(5,5,4),iacc(4)
!$omp threadprivate(/invarang5ee/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)


* this is (1,2;3,4;5)
*
* phase space for 1->5 decay, q -> 1+2+3+4+5 with q=p1+p2
* with splittings (12) -> 1+2; (34)->3+4
*
* (34) system is rotated with respect to p5 axis
*
* default momenta            : pang(i,j,1)
* (34) rotated               : pang(i,j,2)
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
      r1  = x(1)
      r2  = x(2)
      r3  = x(3)
      r4  = x(4)
      r5  = x(5)
      r6  = x(6)
      r7  = x(7)
      r8  = x(8)
      r9  = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1
      wtps = 1d0

      if(iang.eq.0)then
         Nphase=10
      else
         Nphase=10*2
         wtps=wtps/2d0
      endif


      costh = 0d0
      call pick(1,costh,-1d0,1d0,r9,wtps)
      !>normalise
      wtps=wtps/2d0
      sinth=dsqrt(1d0-costh**2)

      call pick(1,phi,0d0,2d0*pi,r10,wtps)
      !>normalise
      wtps=wtps/2d0/pi

      !> energies pa(4),pb(4) are set in setcollider_epem
      paux(4)=1d0
      paux(3)=costh
      paux(2)=sinth*dsin(phi)
      paux(1)=sinth*dcos(phi)

      call rotatetoz(paux,trans)

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3))-dsqrt(rm2(4))
     .              -dsqrt(rm2(5)))**2,(1d0-5d0*y0)*shat)
      if (s12min.ge.s12max) return
      call pick(2,s12,s12min,s12max,r1,wtps)
      wtps = wtps/2d0/pi

      s34min = dmax1(y0*shat,(dsqrt(rm2(3))+dsqrt(rm2(4)))**2)
      s34max = dmin1((dsqrt(shat)-dsqrt(s12)-dsqrt(rm2(5)))**2
     .        ,(1d0-y0)*shat)
      if (s34max.le.s34min) return
      call pick(2,s34,s34min,s34max,r2,wtps)
      wtps = wtps/2d0/pi
      call p3generic(r3,r4,shat,s12,s34,rm2(5),p12,p34,p5,wtps)
      if (wtps.eq.0d0) return

      costhmin = -1d0
      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi
      call pick(1,costh,costhmin,costhmax,r5,wtps)
      call pick(1,phi,phimin,phimax,r6,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      costhmin = -1d0
      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi
      call pick(1,costh,costhmin,costhmax,r7,wtps)
      call pick(1,phi,phimin,phimax,r8,wtps)
      call makeps2com(s34,costh,phi,rm2(3),rm2(4),p3p,p4p,p3ap,p4ap)
      wtps = wtps*dsqrt(dlambda(s34,rm2(3),rm2(4)))/s34/32d0/pi**2

      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

c---- rotate the (34) system
      call boostrest(p34,bmat)
      call unboostrest(p34,ubmat)
      do i=1,4
         v(i) = 0d0
         p5p(i) = 0d0
         do j=1,4
            p5p(i) = p5p(i) + bmat(i,j)*p5(j)
         enddo
      enddo
      call unrotatetoz(p5p,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p4(i) = 0d0
         p3a(i) = 0d0
         p4a(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
         enddo
      enddo

      !> rotate electron back to z axis
      p(:,:)=0d0
      do i=1,5
         select case(i)
         case(1)
            ptemp=p1
         case(2)
            ptemp=p2
         case(3)
            ptemp=p3
         case(4)
            ptemp=p4
         case(5)
            ptemp=p5
         end select
         do j=1,4
            do k=1,4
               p(j,i)=p(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo
      do i=1,4
         pang5(i,1,1) = p(i,1)
         pang5(i,2,1) = p(i,2)
         pang5(i,3,1) = p(i,3)
         pang5(i,4,1) = p(i,4)
         pang5(i,5,1) = p(i,5)
         pang5(i,1,2) = p(i,1)
         pang5(i,2,2) = p(i,2)
         pang5(i,5,2) = p(i,5)
      enddo

      ptemp1(:,:)=0d0
      do i=3,4
         select case(i)
         case(3)
            ptemp=p3a
         case(4)
            ptemp=p4a
         end select
         do j=1,4
            do k=1,4
               ptemp1(j,i)=ptemp1(j,i)+trans(j,k)*ptemp(k)
            enddo
         enddo
      enddo

      do i=1,4
         pang5(i,3,2) = ptemp1(i,3)
         pang5(i,4,2) = ptemp1(i,4)
      enddo
      do i=1,2
         call fillinvee(5,pang5(1:4,1:5,i),sijang5(1:5,1:5,i))
      enddo
      do i=1,2
        call acceptcuts5allepem(sijang5(1:5,1:5,i),iacc(i))
      enddo
      if (iacc(1)+iacc(2).eq.0) return
      ifail =0
      wt = wtps
      return
      end


      subroutine acceptcuts5allepem(sij5,ipass)
      implicit real*8(a-h,o-z)
      dimension sij5(1:5,1:5)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0
      s12 = sij5(1,2)
      s13 = sij5(1,3)
      s14 = sij5(1,4)
      s15 = sij5(1,5)
      s23 = sij5(2,3)
      s24 = sij5(2,4)
      s25 = sij5(2,5)
      s34 = sij5(3,4)
      s35 = sij5(3,5)
      s45 = sij5(4,5)

      rinvmin = min(s12,s13,s14,s15,s23,s24,s25,s34,s35,s45)
      if (rinvmin.lt.y0*shat) return
      ipass = 0
* single out on 3||4, which 1/10 of the full PS region
      if (rinvmin.eq.s34) ipass=1
      return
      end

      subroutine fillcommon5allpepem
      implicit real*8(a-h,o-z)
      dimension i1(1:5,1:10)
      common/pmomang5ee/pang5(4,5,4)
!$omp threadprivate(/pmomang5ee/)
      common/invarang5ee/sijang5(5,5,4),iacc(4)
!$omp threadprivate(/invarang5ee/)
      common/eventmom5pee/pevt5(4,5,20)
!$omp threadprivate(/eventmom5pee/)
      common/eventinv5pee/sevt5(5,5,20),ievt5(20)
!$omp threadprivate(/eventinv5pee/)

      data i1/3,4,1,2,5,
     .        2,4,1,3,5,
     .        2,3,1,4,5,
     .        2,3,1,5,4,
     .        1,4,2,3,5,
     .        1,3,2,4,5,
     .        1,3,2,5,4,
     .        1,2,3,4,5,
     .        1,2,3,5,4,
     .        1,2,4,5,3/

c---- pang5 and sijang5 are input and correspond to an event in (3,4;125)
c---- this subroutine fills
c----       pevt5(component,pnum,ievent)     : 4-momenta of events
c----       sevt5(i,j,ievent)                : invariants of events
c----
c---- ievent
c----  1: (1,2;345)
c----  2: (1,3;245)
c----  3: (1,4;235)
c----  4: (1,5;234)
c----  5: (2,3;145)
c----  6: (2,4;135)
c----  7: (2,5;134)
c----  8: (3,4;125)
c----  9: (3,5;124)
c---- 10: (4,5;123)
c----
c---- 11-20 (i,j;x) with (i,j) system rotated around s34-axis
c----
c---- full phave space coverage is obtained by summing all 10 events
c---- angular average is obtained by averaging:
c----        M2 = 1/2* ( sum_ievent=1..20   M2(ievent))
c----
      do i=1,10
         do j=1,5
            do k=1,4
               pevt5(k,i1(j,i),i)     = pang5(k,j,1)
               pevt5(k,i1(j,i),i+10)  = pang5(k,j,2)
            enddo
         enddo
      enddo

      do i=1,10
         do j=1,5
            do k=1,4
               sevt5(i1(j,i),i1(k,i),i)     = sijang5(j,k,1)
               sevt5(i1(j,i),i1(k,i),i+10)  = sijang5(j,k,2)
            enddo
         enddo
         ievt5(i)    = iacc(1)
         ievt5(i+10) = iacc(2)
      enddo

      return
      end


      subroutine p3generic(r1,r2,s,rm1sq,rm2sq,rm3sq,p1,p2,p3,wt)
c--- generates generic 3-parton decay phase space in the rest system
c--- for arbitrary time-like external masses
c--- input: s, external masses (center of mass emergy)
c--- input: random number r1 (sample s23),r2 (sample s12). s13 is fixed by energy conservation.
c--- output: p1(4),p2(4),p3(4)
c--- processed: phase space weight wt
c--- phase space dR3 = d^3p1/(2*E1*(2*pi)^3)*[p1<->p2]*[p1<->p3]*(2*pi)^4*del(..)
c--- More comments:
c--- p1 is on x-axis
c--- p2 is determined by the angle between p1 and p2 using s12
c--- p3 is determined by momentum conservation in center of mass frame
c--- p2 and p3 are both on xy-plane
c--- p1, p2, p3 all have zero z-axis contribution so it is not general.
c--- One needs two extra random number to identify p1-3 in lab frame using rotatetoz 
      implicit real*8(a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      dimension p1(4),p2(4),p3(4),q(4)
      common /tcuts/ymin,y0

      roots=dsqrt(s)
      q(1) = 0d0
      q(2) = 0d0
      q(3) = 0d0
      q(4) = roots
      rm1 = dsqrt(rm1sq)
      rm2 = dsqrt(rm2sq)
      rm3 = dsqrt(rm3sq)

      s23min = max(y0*s,(rm2+rm3)**2)
      s23max = (roots-rm1)**2
      if (s23max.le.s23min) then
         wt = 0d0
         return
      endif
      call pick(1,s23,s23min,s23max,r1,wt)
      disc12 = dsqrt(dlambda(s23,s,rm1sq)*dlambda(s23,rm2sq,rm3sq))
      base12 = rm1sq+rm2sq-0.5d0/s23*(s23-s+rm1sq)*(s23+rm2sq-rm3sq)
      s12min = base12 - 0.5d0/s23*disc12
      s12max = base12 + 0.5d0/s23*disc12
      call pick(1,s12,s12min,s12max,r2,wt)
      if (s12max.le.s12min) then
         wt = 0d0
         return
      endif
      s13 = s + rm1sq + rm2sq + rm3sq - s12 - s23
      wt = wt/128d0/pi**3/s

      e1 = (s+rm1sq-s23)/2d0/roots
      e2 = (s+rm2sq-s13)/2d0/roots
      e3 = (s+rm3sq-s12)/2d0/roots

      p1a = dsqrt(e1**2-rm1sq)
      p2a = dsqrt(e2**2-rm2sq)
      p3a = dsqrt(e3**2-rm3sq)

      ct12 = (s12-rm1sq-rm2sq-2d0*e1*e2)/(-2d0*p1a*p2a)
      if (ct12.lt.-1d0.or.ct12.gt.1d0) then
         wt = 0d0
         return
      endif
      st12 = dsqrt(1d0-ct12**2)

      p1(4) = e1
      p1(1) = p1a
      p1(2) = 0d0
      p1(3) = 0d0

      p2(4) = e2
      p2(1) = p2a*ct12
      p2(2) = p2a*st12
      p2(3) = 0d0

      do i=1,4
         p3(i) = q(i) - p1(i) - p2(i)
      enddo
      return
      end

      subroutine fillinvee(n,p,sij)
      use KinData_mod, only : dot
      implicit real*8(a-h,o-z)
      dimension p(4,1:n),sij(1:n,1:n)

      do i=1,n
         sij(i,i) = 0d0
         do j=i+1,n
            sij(i,j) = 2d0*dot(p(1,i),p(1,j))
            sij(j,i) = sij(i,j)
         enddo
      enddo
      return
      end
