      subroutine phase2h(x, wt, ifail)
      implicit real*8(a-h, o-z)
      double precision x, wt
      integer ifail
      dimension x(*)
      dimension p1(4),p2(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p1ap(4),p2ap(4),qp(4)
      dimension pg1(4), pg2(4), p12(4)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      ! Common Blocks
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0
      common /pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common /pmomang2/pang2(4,2,2)
!$omp threadprivate(/pmomang2/)
      common /invarang2/sijang2(2,2,2),tijang2(2,2,2)
!$omp threadprivate(/invarang2/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common /nwa/rm12,rg12,inwa
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase2h", x(1), wt, ifail

      wtps = 1d0
      Nphase=1

      r1 = x(1)

      ifail = 1
      wt = 0d0

      call p2generic_alt(1,r1,0d0,shat,rma2,rmb2,rm2(1),rm2(2),p1,p2,pa,pb,wtps)
      if(wtps.eq.0d0) return

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         pang2(i,1,1) = p1(i)
         pang2(i,2,1) = p2(i)
      enddo

      call fillinv(2,pang2(1:4,1:2,1),pa,pb,sijang2(1:2,1:2,1)
     .                                     ,tijang2(1:2,1:2,1))

      ifail = 0
      wt = wtps

      return
      end

      subroutine phase3h(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p3p(4),pap(4),pbp(4),qp(4)
      dimension p1a(4),p2a(4),p3a(4)
      dimension p1ap(4),p2ap(4),p3ap(4)
      dimension p12(4),p12p(4)
      dimension pqa(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common /pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common /invar3/sij3(3,3),tij3(2,3)
!$omp threadprivate(/invar3/)
      common /pmomang3/pang3(4,3,2)
!$omp threadprivate(/pmomang3/)
      common /invarang3/sijang3(3,3,2),tijang3(2,3,2),iacc(2)
!$omp threadprivate(/invarang3/)
      common /nwa/rm12,rg12,inwa
      common /tcuts/ymin,y0
      common /mxdim/ mxdim
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase3h", x(1), wt, ifail

      wtps = 1d0
      Nphase = 1

*
* phase space for 2->3 scattering, a+b -> 1+2+3 with q=p1+p2
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_3 = 1/256/pi**3*sab = 1.25982x10^-4*sab
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      ifail =1
      wt = 0d0

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3)))**2,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick_sinv_generic(s12,s12min,s12max,rm12,rg12,r1,wtps,inwa)

      if(shat.lt.s12) return ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
      call p2generic_alt(4,r2,0d0,shat,rma2,rmb2,s12,rm2(3),
     .                   p12,p3,pa,pb,wtps)
      if(wtps.eq.0d0) return
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r3,wtps)
      call pick(1,phi,0d0,twopi,r4,wtps)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      call unboostrest(p12,ubmat)

      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         pang3(i,1,1) = p1(i)
         pang3(i,2,1) = p2(i)
         pang3(i,3,1) = p3(i)
      enddo

      if(p3(4).lt.0d0)then ! negative energy jets
         ifail=1
         return
      endif

      call fillinv(3,pang3(1:4,1:3,1),pa,pb,sijang3(1:3,1:3,1)
     .                                     ,tijang3(1:2,1:3,1))

c      write(6,101) p1(1:4)
c      write(6,102) p2(1:4)
c      write(6,103) p3(1:4)
c      write(6,105) v(1:4)
c      write(6,106) pb(1:4)
c      write(6,109) v1(1:4)
c      write(6,*) q2/dot(q,q)
c      write(6,109) p1(1:4) + p2(1:4) + p3(1:4)

 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 105  format('pa:',4f14.6)
 106  format('pb:',4f14.6)
 109  format('pp:',4f14.6)

      ifail =0
      wt = wtps

      return
      end

      subroutine fillcommon2ph
      implicit real*8(a-h, o-z)
      common /pmomang2/pang2(4,2,2)
!$omp threadprivate(/pmomang2/)
      common/invarang2/sijang2(2,2,2),tijang2(2,2,2)
!$omp threadprivate(/invarang2/)
      common/pmomang2g/pang2g(4,2,2)
      common/eventmom2p/pevt2(4,2,2)
!$omp threadprivate(/eventmom2p/)
      common/eventinv2p/sevt2(2,2,2),tevt2(2,2,2),ievt2(2)
!$omp threadprivate(/eventinv2p/)

      do j=1,2
         do k=1,4
            pevt2(k,j,1) = pang2(k,j,1)
         enddo
      enddo

      do j=1,2
         do k=1,2
            sevt2(j,k,1) = sijang2(j,k,1)
         enddo
         tevt2(1,j,1) = tijang2(1,j,1)
         tevt2(1,j,1) = tijang2(2,j,1)
      enddo
      ievt2(1) = 1

      return
      end


      subroutine fillcommon3ph
      implicit real*8(a-h,o-z)
      common/pmomang3/pang3(4,3,2)
!$omp threadprivate(/pmomang3/)
      common/pmomang3g/pang3g(4,3,2)
!$omp threadprivate(/pmomang3g/)
      common/invarang3/sijang3(3,3,2),tijang3(2,3,2),iacc(2)
!$omp threadprivate(/invarang3/)
      common/eventmom3p/pevt3(4,3,12)
!$omp threadprivate(/eventmom3p/)
      common/eventinv3p/sevt3(3,3,12),tevt3(2,3,12),ievt3(12)
!$omp threadprivate(/eventinv3p/)

c---- pang3,pang3g and sija,tija are input
c---- this subroutine fills
c----       pevt3(component,pnum,ievent)             : 4-momenta of events
c----       sevt3(i,j,ievent),tevt3([ab],i,ievent)   : invariants of events
c----
c---- ievent = 1 fixed

      do j=1,3
         do k=1,4
            pevt3(k,j,1)    = pang3(k,j,1)
         enddo
      enddo

      do j=1,3
         do k=1,3
            sevt3(j,k,1)    = sijang3(j,k,1)
         enddo
         tevt3(1,j,1)   = tijang3(1,j,1)
         tevt3(2,j,1)   = tijang3(2,j,1)
      enddo
      ievt3(1) = 1

c---- a few tests here
c      write(6,101) pevt3(1:4,1,1)
c      write(6,102) pevt3(1:4,2,1)
c      write(6,103) pevt3(1:4,3,1)
c      write(6,104) pevt3(1:4,1,1)+pevt3(1:4,2,1)+pevt3(1:4,3,1)

c      it =1
c      ta1 = -pevt3(4,1,it)+pevt3(3,1,it)
c      ta2 = -pevt3(4,2,it)+pevt3(3,2,it)
c      ta3 = -pevt3(4,3,it)+pevt3(3,3,it)
c      write(6,110) ta1/tevt3(1,1,it),ta2/tevt3(1,2,it),ta3/tevt3(1,3,it)

 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 110  format(3g18.11)
 111  format(2g18.11)

      return
      end



      subroutine phase4h(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),pap(4)
      dimension p1a(4),p2a(4),p3a(4),p4a(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4)
      dimension p12(4)
      dimension p34(4),p34p(4),p34g(4),papg(4),parb(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common /pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common /invar4/sij4(4,4),tij4(2,4)
!$omp threadprivate(/invar4/)
      common /pmomang4/pang4(4,4,4)
!$omp threadprivate(/pmomang4/)
      common /invarang4/sijang4(4,4,4),tijang4(2,4,4),iacc(4)
!$omp threadprivate(/invarang4/)
      common /nwa/rm12,rg12,inwa
      common /techpar/iang
      common /tcuts/ymin,y0
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase4h", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=2
      else
         Nphase=4
         wtps=wtps/2d0
      endif

c---  corresponds to the phase space(3,4;a)

*
* phase space for 2->4 scattering, a+b -> 1+2+3+4 with q=p1+p2
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_4 = 1/24576/pi**5 = 1.32965643x10^-7
*

      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      ifail =1
      wt = 0d0

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3))-dsqrt(rm2(4)))**2
     .              ,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick_sinv_generic(s12,s12min,s12max,rm12,rg12,r1,wtps,inwa)

      if(shat.lt.s12) return ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
      s34min = dmax1(y0*shat,(dsqrt(rm2(3))+dsqrt(rm2(4)))**2)
      s34max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
c      s23min = y0*shat
c      s23max = (1d0-y0)*shat
      if (s34min.ge.s34max) return
c      call pick(1,s34,s34min,s34max,r2,wtps)
c      call pick(2,s34,s34min,s34max,r2,wtps)
      call pick(10,s34,s34min,s34max,r2,wtps)
      wtps = wtps/2d0/pi
c      write(6,*) 'm1, s23',rm2(1),s23,s23min,s23max
      call p2generic_alt(3,r3,0d0,shat,rma2,rmb2,s12,s34,
     .                   p12,p34,pa,pb,wtps)
      if(wtps.eq.0d0) return


**************************************************
*     TM 24/06/2015: switched to sampling
*     rat=sa3/(sa3max-sa3+y0*shat) logarithmically
*     from costh
*

c      call boostrest(p34,bmat)
c      do i=1,4
c         v(i) = 0d0
c         pap(i) = 0d0
c         do j=1,4
c            pap(i) = pap(i) + bmat(i,j)*pa(j)
c         enddo
c      enddo
c
c      call rotatetoz(pap,rmat)
c      do i=1,4
c         parb(i) = 0.d0
c         do j=1,4
c            do k=1,4
c               parb(i) = parb(i) + rmat(i,k)*bmat(k,j)*pa(j)
c            enddo
c         enddo
c      enddo
c
c      bound = 2.d0*(s34+rm2(3))/sqrt(s34)*parb(4)
c      sa3min = y0*shat
c      sa3max = min(bound,(1.d0-y0)*shat)
c      if(sa3max.le.sa3min) return
c
c*     jacobian for costh -> sa3
c      wtps = wtps/(s34)*sqrt(s34)/parb(4)
c
c*     rat=sa3/(sa3max-sa3+y0*shat)
c      ratmin=y0*shat/sa3max
c      ratmax=sa3max/(y0*shat)
c
c      call pick(2,rat,ratmin,ratmax,r4,wtps)
c
c      sa3=rat*(sa3max+y0*shat)/(rat+1d0)
c      wtps=wtps*(sa3max-sa3+y0*shat)**2/(sa3max+y0*shat)
c
c      costh=-(sa3-s34*parb(4)/s34**0.5)/(2d0*parb(4)*(s34/2d0/s34**0.5))

c      call pick(12,costh,-1d0,1d0,r4,wtps)
      call pickcos_alt(costh,r4,wtps)
      call pick(1,phi,0d0,twopi,r5,wtps)
      call makeps2com(s34,costh,phi,rm2(3),rm2(4),p3p,p4p,p3ap,p4ap)
      wtps = wtps*dsqrt(dlambda(s34,rm2(3),rm2(4)))/s34/32d0/pi**2


*****************************************

      call boostrest(p34,bmat)
      call unboostrest(p34,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p3(i) = 0d0
         p4(i) = 0d0
         p3a(i) = 0d0
         p4a(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
         enddo
      enddo

      if((p3(4).lt.0).or.(p3a(4).lt.0).or.(p4(4).lt.0).or.(p4a(4).lt.0))then
         ifail = 1
         return
      endif


      call pick(1,costh,-1d0,1d0,r6,wtps)

      call pick(1,phi,0d0,twopi,r7,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p1a(i) = p1(i)
         p2a(i) = p2(i)
         pang4(i,1,1) = p1(i)
         pang4(i,2,1) = p2(i)
         pang4(i,3,1) = p3(i)
         pang4(i,4,1) = p4(i)
         pang4(i,1,2) = p1a(i)
         pang4(i,2,2) = p2a(i)
         pang4(i,3,2) = p3a(i)
         pang4(i,4,2) = p4a(i)
      enddo

      call fillinv(4,p,pa,pb,sij4,tij4)
      do i=1,2
         call fillinv(4,pang4(1:4,1:4,i),pa,pb,sijang4(1:4,1:4,i)
     .                                        ,tijang4(1:2,1:4,i))
      enddo

      do i=1,2
         call acceptcuts4(sijang4(1:4,1:4,i),tijang4(1:2,1:4,i),iacc(i))
      enddo
      if (iacc(1)+iacc(2).eq.0) return
      ifail =0
      wt = wtps

c      write(6,101) p1(1:4)
c      write(6,102) v(1:4)
c      write(6,103) p3(1:4)
c      write(6,105) pa(1:4)
c      write(6,106) pb(1:4)
 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 105  format('pa:',4f14.6)
 106  format('pb:',4f14.6)

      return
      end


      subroutine acceptcuts4(sij4,tij4,ipass)
      implicit real*8(a-h,o-z)
      dimension sij4(1:4,1:4),tij4(1:2,1:4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0

      sa3 = -tij4(1,3)
      sa4 = -tij4(1,4)
      sb3 = -tij4(2,3)
      sb4 = -tij4(2,4)


      rinvmin = min(sa3,sa4,sb3,sb4)
      if (rinvmin.lt.y0*shat) return

      ipass = 0
* single out on 3||a, 4||a
      if (rinvmin.eq.sa3.or.rinvmin.eq.sa4) ipass=1
      return
      end


      subroutine fillcommon4ph
      implicit real*8(a-h,o-z)
      common/pmomang4/pang4(4,4,4)
!$omp threadprivate(/pmomang4/)
      common/invarang4/sijang4(4,4,4),tijang4(2,4,4),iacc(4)
!$omp threadprivate(/invarang4/)
      common/eventmom4p/pevt4(4,4,6)
!$omp threadprivate(/eventmom4p/)
      common/eventinv4p/sevt4(4,4,6),tevt4(2,4,6),ievt4(6)
!$omp threadprivate(/eventinv4p/)

c---- pang4 and sija,tija are input and correspond to an event in (3,4;a)
c---- this subroutine fills
c----       pevt4(component,pnum,ievent)             : 4-momenta of events
c----       sevt4(i,j,ievent),tevt4([ab],i,ievent)   : invariants of events
c----
c---- ievent
c---- 1: (3,4;a)
c---- 2: (3,4;b)
c----
c---- 3-4 (i,j;x) with (i,j) system rotated around x-axis
c----
c---- full phave space coverage is obtained by summing all 2 events
c---- angular average is obtained by averaging:
c----        M2 = 1/2* ( sum_ievent=1..4   M2(ievent))
c----


      do j=1,4
         do k=1,4
            pevt4(k,j,1) = pang4(k,j,1)
            pevt4(k,j,3) = pang4(k,j,2)
            if (k.ne.3) then
               pevt4(k,j,2) = pang4(k,j,1)
               pevt4(k,j,4) = pang4(k,j,2)
            else
               pevt4(k,j,2) = -pang4(k,j,1)
               pevt4(k,j,4) = -pang4(k,j,2)
            endif
         enddo
      enddo


      do j=1,4
         do k=1,4
            sevt4(j,k,1) = sijang4(j,k,1)
            sevt4(j,k,2) = sijang4(j,k,1)
            sevt4(j,k,3) = sijang4(j,k,2)
            sevt4(j,k,4) = sijang4(j,k,2)
         enddo
         tevt4(1,j,1) = tijang4(1,j,1)
         tevt4(2,j,1) = tijang4(2,j,1)
         tevt4(1,j,3) = tijang4(1,j,2)
         tevt4(2,j,3) = tijang4(2,j,2)
         tevt4(1,j,2) = tijang4(2,j,1)
         tevt4(2,j,2) = tijang4(1,j,1)
         tevt4(1,j,4) = tijang4(2,j,2)
         tevt4(2,j,4) = tijang4(1,j,2)
      enddo
      ievt4(1) = iacc(1)
      ievt4(2) = iacc(1)
      ievt4(3) = iacc(2)
      ievt4(4) = iacc(2)


c---- a few tests here
c      write(6,101) pevt4(1:4,1,1)
c      write(6,102) pevt4(1:4,2,1)
c      write(6,103) pevt4(1:4,3,1)
c      write(6,104) pevt4(1:4,4,1)
c      write(6,101) pevt4(1:4,1,4)
c      write(6,102) pevt4(1:4,2,4)
c      write(6,103) pevt4(1:4,3,4)
c      write(6,104) pevt4(1:4,4,4)

c      it =2
c
c      s12 = 2d0*dot(pevt4(1,1,it),pevt4(1,2,it))
c      s13 = 2d0*dot(pevt4(1,1,it),pevt4(1,3,it))
c      s23 = 2d0*dot(pevt4(1,2,it),pevt4(1,3,it))
c      s14 = 2d0*dot(pevt4(1,1,it),pevt4(1,4,it))
c      s24 = 2d0*dot(pevt4(1,2,it),pevt4(1,4,it))
c      s34 = 2d0*dot(pevt4(1,3,it),pevt4(1,4,it))
c      ta1 = -pevt4(4,1,it)+pevt4(3,1,it)
c      ta2 = -pevt4(4,2,it)+pevt4(3,2,it)
c      ta3 = -pevt4(4,3,it)+pevt4(3,3,it)
c      ta4 = -pevt4(4,4,it)+pevt4(3,4,it)
c      tb1 = -pevt4(4,1,it)-pevt4(3,1,it)
c      tb2 = -pevt4(4,2,it)-pevt4(3,2,it)
c      tb3 = -pevt4(4,3,it)-pevt4(3,3,it)
c      tb4 = -pevt4(4,4,it)-pevt4(3,4,it)

c      it = it+2
c      write(6,110) ta1/tevt4(1,1,it),ta2/tevt4(1,2,it),ta3/tevt4(1,3,it)
c     .            ,ta4/tevt4(1,4,it)
c      write(6,110) tb1/tevt4(2,1,it),tb2/tevt4(2,2,it),tb3/tevt4(2,3,it)
c     .            ,tb4/tevt4(2,4,it)
c      write(6,110) s12/sevt4(1,2,it),s13/sevt4(1,3,it),s23/sevt4(2,3,it)
c     .            ,s14/sevt4(1,4,it)
c      write(6,111) s24/sevt4(2,4,it),s34/sevt4(3,4,it)

 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 110  format(4g18.11)
 111  format(2g18.11)

      return
      end



      subroutine phase5ah(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
     .          p3pp(4),p3app(4),papp(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p3a(4),p4a(4),p5a(4)
      dimension p12(4),p345(4),p45p(4),p45(4)
      dimension p345p(4)
      dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension parb(4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm12,rg12,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invar5/sij5(5,5),tij5(2,5)
!$omp threadprivate(/invar5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase5ah", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=6
      else
         Nphase=24
         wtps=wtps/4d0
      endif


* this is (3;4,5;a)
*
* phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with q=p1+p2
* with sequential splitting (345) -> 3+(45) -> 3+4+5
*
* (345) system is rotated with respect to pa axis
* (45)  system is rotated with respect to p3 axis
*
* default momenta             : pang(i,j,1)
* (45) rotated                : pang(i,j,2)
* (345) rotated               : pang(i,j,3)
* (345) rotated, (45) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      r9 = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3))-dsqrt(rm2(4)))**2
     .              ,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick_sinv_generic(s12,s12min,s12max,rm12,rg12,r1,wtps,inwa)

      if(shat.lt.s12) return    ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r2,wtps)
      call pick(1,phi,0d0,twopi,r3,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      s345min = dmax1(y0*shat,
     .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s345max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s345max.le.s345min) return
      call pick(10,s345,s345min,s345max,r4,wtps)
      wtps = wtps/2d0/pi
      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1(s345,(1d0-y0)*shat)
      if (s45max.le.s45min) return
*      call pick(1,s45,s45min,s45max,r5,wtps)
*     sample log(s45)
      call pick(2,s45,s45min,s45max,r5,wtps)
      wtps = wtps/2d0/pi

      call p2generic_alt(2,r6,0d0,shat,0d0,0d0,s12,s345,
     .                   p12,p345,pa,pb,wtps)
      if(wtps.eq.0d0) return


* TODO: change of variables only works in the massless case.
*       Add a condition s.t. we return to the old calculations
*       for massive partons

      costhmin = -1d0
      costhmax = 1d0
c      call pick(1,costh,costhmin,costhmax,r7,wtps)
c      call pickcos(costh,y0,r7,wtps)


***********************************************
*     TM 03/05/2015: switched to sampling
*     rat=sa3/(sa3max-sa3+y0*shat) logarithmically
*     from costh

c*     boost pa into the s345 rest frame
c      call boostrest(p345,bmat)
c      do i=1,4
c         v(i) = 0.d0
c         pap(i) = 0.d0
c         do j=1,4
c            pap(i) = pap(i) + bmat(i,j)*pa(j)
c         enddo
c      enddo
c
c*     rotate pap into the frame
c      call rotatetoz(pap,rmat)
c
c      do i=1,4
c         parb(i) = 0.d0
c         do j=1,4
c            do k=1,4
c               parb(i) = parb(i) + rmat(i,k)*bmat(k,j)*pa(j)
c            enddo
c         enddo
c      enddo
c
c      bound = 2.d0*(s345+rm2(3)-s45)/sqrt(s345)*parb(4)
c      sa3min = y0*shat
c      sa3max = min(bound,(1.d0-y0)*shat)
c      if(sa3max.le.sa3min) return
c
c*     jacobian for costh -> sa3
c      wtps = wtps/(s345+rm2(3)-s45)*sqrt(s345)/parb(4)
c
c*     rat=sa3/(sa3max-sa3+y0*shat)
c      ratmin=y0*shat/sa3max
c      ratmax=sa3max/(y0*shat)
c
c      call pick(2,rat,ratmin,ratmax,r7,wtps)
c
c      sa3=rat*(sa3max+y0*shat)/(rat+1d0)
c*      wtps=wtps*(sa3max-sa3)**2/sa3max
c
c      wtps=wtps*(sa3max-sa3+y0*shat)**2/(sa3max+y0*shat)
c      costh=-(sa3-(s345-s45)*parb(4)/s345**0.5)/(2d0*parb(4)*((s345-s45)/2d0/s345**0.5))


c      call pickcos_alt(costh,r7,wtps)
      call pickcos(costh,y0,r7,wtps)

      call pick(1,phi,0d0,twopi,r8,wtps)
      call makeps2com(s345,costh,phi,rm2(3),s45,p3p,p45p,p3ap,p45ap)
      wtps = wtps*dsqrt(dlambda(s345,rm2(3),s45))/s345/32d0/pi**2

***********************************************

c---- rotate the (345) system
      call boostrest(p345,bmat)
      call unboostrest(p345,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p45(i) = 0d0
         p3a(i) = 0d0
         p45a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p45(i) = p45(i) + fmat(i,j)*p45p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo


***********************************************
*     TM 03/05/2015: switched to sampling rat=sa5/sa4
*     from costh
c*     boost pa into the s45 rest frame
c      call boostrest(p45,bmat)
c      do i=1,4
c         v(i) = 0.d0
c         pap(i) = 0.d0
c         do j=1,4
c            pap(i) = pap(i) + bmat(i,j)*pa(j)
c         enddo
c      enddo
c
c*     rotate pap into the frame
c      call rotatetoz(pap,rmat)
c      do i=1,4
c         parb(i) = 0.d0
c         do j=1,4
c            do k=1,4
c               parb(i) = parb(i) + rmat(i,k)*bmat(k,j)*pa(j)
c            enddo
c         enddo
c      enddo
c
cc      call pick(1,costh,costhmin,costhmax,r9,wtps)
cc      sa4min = y0*shat
cc      sa4max = 2*s45**0.5*parb(4)-y0*shat
cc      call pick(1,sa4,sa4min,sa4max,r9,wtps)
c
c      E2=2*(s45**0.5/2d0)*parb(4)
c
c      wtps = wtps/E2
c
c      ratmin=2*E2/(2*E2-y0*shat) -1d0
c      ratmax=2*E2/(y0*shat)-1d0
c
c*     pick the ratio rat=sa5/sa4 logarthmically
c      call pick(2,rat,ratmin,ratmax,r9,wtps)
c
c      sa4=2*E2/(rat+1d0)
c      sa5=2*E2-sa4
c
c      wtps=wtps*sa4**2/(2*E2)
c      costh=-(sa4-2*(s45**0.5)*parb(4)/2d0)/(2*(s45**0.5)*parb(4)/2d0)


      call pickcos_alt(costh,r9,wtps)

      call pick(1,phi,0d0,twopi,r10,wtps)
      call makeps2com(s45,costh,phi,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap)
      wtps = wtps*dsqrt(dlambda(s45,rm2(4),rm2(5)))/s45/32d0/pi**2

***********************************************


      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo


      if(p345(4).lt.0d0)then
         ifail = 1
         return
      endif

c---- rotate the (45) system
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (45ang) system
      call boostrest(p45a,bmat)
      call unboostrest(p45a,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4t(i) = 0d0
         p5t(i) = 0d0
         p4ta(i) = 0d0
         p5ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         pang5(i,1,1) = p1(i)
         pang5(i,2,1) = p2(i)
         pang5(i,3,1) = p3(i)
         pang5(i,4,1) = p4(i)
         pang5(i,5,1) = p5(i)

         pang5(i,1,2) = p1(i)
         pang5(i,2,2) = p2(i)
         pang5(i,3,2) = p3(i)
         pang5(i,4,2) = p4a(i)
         pang5(i,5,2) = p5a(i)

         pang5(i,1,3) = p1(i)
         pang5(i,2,3) = p2(i)
         pang5(i,3,3) = p3a(i)
         pang5(i,4,3) = p4t(i)
         pang5(i,5,3) = p5t(i)

         pang5(i,1,4) = p1(i)
         pang5(i,2,4) = p2(i)
         pang5(i,3,4) = p3a(i)
         pang5(i,4,4) = p4ta(i)
         pang5(i,5,4) = p5ta(i)
      enddo

      do i=1,4
         call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
     .                                        ,tijang5(1:2,1:5,i))
      enddo

      do i=1,4
        call acceptcuts5a(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo
      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return

      ifail =0
      wt = wtps


c
c      k10 = 1
c      write(6,101) pang5(1:4,1,k10)
c      write(6,102) pang5(1:4,2,k10)
c      write(6,103) pang5(1:4,3,k10)
c      write(6,104) pang5(1:4,4,k10)
c      write(6,105) pang5(1:4,5,k10)
c      write(6,106) pa(1:4)
c      write(6,107) pb(1:4)
c      write(6,109) v1(1:4)
c      write(6,*) q2/dot(q,q)
c

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end


      subroutine acceptcuts5a(sij5,tij5,ipass,itechpass)
      implicit real*8(a-h,o-z)
      dimension sij5(1:5,1:5),tij5(1:2,1:5)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0
      itechpass = 0

      sa3 = -tij5(1,3)
      sa4 = -tij5(1,4)
      sa5 = -tij5(1,5)
      sb3 = -tij5(2,3)
      sb4 = -tij5(2,4)
      sb5 = -tij5(2,5)
      s34 =  sij5(3,4)
      s35 =  sij5(3,5)
      s45 =  sij5(4,5)

      if (min(sa3,sa4,sa5,sb3,sb4,sb5).lt.y0*shat) return
      if (min(s34,s35,s45).lt.y0*shat) return

      itechpass = 1

      smin1 = shat
      smin2 = shat

      do i=3,5
         do j=i+1,5
            if (sij5(i,j).lt.smin2) then
               smin2 = sij5(i,j)
               if (smin2.lt.smin1) then
                  stmp  = smin1
                  smin1 = smin2
                  smin2 = stmp
               endif
            endif
         enddo
         if (-tij5(1,i).lt.smin2) then
            smin2 = -tij5(1,i)
            if (smin2.lt.smin1) then
               stmp  = smin1
               smin1 = smin2
               smin2 = stmp
            endif
         endif
         if (-tij5(2,i).lt.smin2) then
            smin2 = -tij5(2,i)
            if (smin2.lt.smin1) then
               stmp  = smin1
               smin1 = smin2
               smin2 = stmp
            endif
         endif
      enddo

c---- these are the new selection cuts for phase5a
      if (smin1.eq.s45.and.smin2.eq.sa4) ipass=1
      if (smin2.eq.s45.and.smin1.eq.sa4) ipass=1
      if (smin1.eq.s45.and.smin2.eq.sa5) ipass=1
      if (smin2.eq.s45.and.smin1.eq.sa5) ipass=1
      if (smin1.eq.s45.and.smin2.eq.min(s34,s35)) then
         if ((sa4+sa5).lt.(sb4+sb5)) ipass=1
      endif
      if (smin1.eq.sa4.and.smin2.eq.sa5) ipass=1
      if (smin2.eq.sa4.and.smin1.eq.sa5) ipass=1

      return
      end


      subroutine phase5bh(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
     .          pbp(4),pbap(4)
      dimension parb(4),pbrb(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p3a(4),p4a(4),p5a(4)
      dimension p12(4),p345(4),p45p(4),p45(4)
      dimension p345p(4)
      dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm12,rg12,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invar5/sij5(5,5),tij5(2,5)
!$omp threadprivate(/invar5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase5bh", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase = 6
      else
         Nphase = 24
         wtps=wtps/4d0
      endif


* this is (3;a;4,5;b)
*
* phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with q=p1+p2
* with sequential splitting (345) -> 3+(45) -> 3+4+5
*
* (345) system is rotated with respect to pa axis
* (45)  system is rotated with respect to pb axis
*
* default momenta             : pang(i,j,1)
* (45) rotated                : pang(i,j,2)
* (345) rotated               : pang(i,j,3)
* (345) rotated, (45) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      r9 = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3))-dsqrt(rm2(4)))**2
     .              ,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick_sinv_generic(s12,s12min,s12max,rm12,rg12,r1,wtps,inwa)

      if(shat.lt.s12) return ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r2,wtps)
      call pick(1,phi,0d0,twopi,r3,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      s345min = dmax1(y0*shat,
     .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s345max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s345max.le.s345min) return
      call pick(10,s345,s345min,s345max,r4,wtps)
      wtps = wtps/2d0/pi
      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1(s345,(1d0-y0)*shat)
      if (s45max.le.s45min) return
      call pick(2,s45,s45min,s45max,r5,wtps)
      wtps = wtps/2d0/pi

      call p2generic_alt(2,r6,0d0,shat,0d0,0d0,s12,
     .                   s345,p12,p345,pa,pb,wtps)
      if(wtps.eq.0d0) return

* TODO: change of variables only works in the massless case.
*       Add a condition s.t. we return to the old calculations
*       for massive partons

c      costhmin = -1d0
c      costhmax = 1d0
c      call pick(1,costh,costhmin,costhmax,r7,wtps)

***********************************************
*     TM 03/05/2015: switched to sampling sa3
*     from costh

c      call boostrest(p345,bmat)
c      do i=1,4
c         v(i) = 0.d0
c         pap(i) = 0.d0
c         do j=1,4
c            pap(i) = pap(i) + bmat(i,j)*pa(j)
c         enddo
c      enddo
c
c      call rotatetoz(pap,rmat)
c
c      do i=1,4
c         parb(i) = 0.d0
c         do j=1,4
c            do k=1,4
c               parb(i) = parb(i) + rmat(i,k)*bmat(k,j)*pa(j)
c            enddo
c         enddo
c      enddo
c
c      bound = 2.d0*(s345+rm2(3)-s45)/sqrt(s345)*parb(4)
c      sa3min = y0*shat
c      sa3max = min(bound,(1.d0-y0)*shat)
c
c      wtps = wtps/(s345+rm2(3)-s45)*sqrt(s345)/parb(4)
c      if(sa3max.le.sa3min) return
c
c      call pick(2,sa3,sa3min,sa3max,r7,wtps)
c
c      costh=-(sa3-(s345-s45)*parb(4)/s345**0.5)/(2d0*parb(4)*((s345-s45)/2d0/s345**0.5))


c      call pickcos_alt(costh,r7,wtps)
      call pickcos(costh,y0,r7,wtps)

      call pick(1,phi,0d0,twopi,r8,wtps)
      call makeps2com(s345,costh,phi,rm2(3),s45,p3p,p45p,p3ap,p45ap)
      wtps = wtps*dsqrt(dlambda(s345,rm2(3),s45))/s345/32d0/pi**2

***********************************************

c---- rotate the (345) system
      call boostrest(p345,bmat)
      call unboostrest(p345,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p45(i) = 0d0
         p3a(i) = 0d0
         p45a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p45(i) = p45(i) + fmat(i,j)*p45p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

***********************************************
*     TM 03/05/2015: switched to sampling rat=sb5/sb4
*     from costh
c*     boost pb into the s45 rest frame
c      call boostrest(p45,bmat)
c      do i=1,4
c         v(i) = 0.d0
c         pbp(i) = 0.d0
c         do j=1,4
c            pbp(i) = pbp(i) + bmat(i,j)*pb(j)
c         enddo
c      enddo
c
c*     rotate pbp into the frame
c      call rotatetoz(pbp,rmat)
c      do i=1,4
c         pbrb(i) = 0.d0
c         do j=1,4
c            do k=1,4
c               pbrb(i) = pbrb(i) + rmat(i,k)*bmat(k,j)*pb(j)
c            enddo
c         enddo
c      enddo
c
c      E2=2*(s45**0.5/2d0)*pbrb(4)
c      wtps = wtps/E2
c
c      ratmin=2*E2/(2*E2-y0*shat) -1d0
c      ratmax=2*E2/(y0*shat)-1d0
c
c*     pick the ratio rat=sb5/sb4 logarthmically
c      call pick(2,rat,ratmin,ratmax,r9,wtps)
c
c      sb4=2*E2/(rat+1d0)
c      sb5=2*E2-sb4
c
c      wtps=wtps*sb4**2/(2*E2)
c      costh=-(sb4-2*(s45**0.5)*pbrb(4)/2d0)/(2*(s45**0.5)*pbrb(4)/2d0)


      call pickcos_alt(costh,r9,wtps)

      call pick(1,phi,0d0,twopi,r10,wtps)
      call makeps2com(s45,costh,phi,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap)
      wtps = wtps*dsqrt(dlambda(s45,rm2(4),rm2(5)))/s45/32d0/pi**2

***********************************************

      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

      if(p345(4).lt.0d0)then
         ifail = 1
         return
      endif




c---- rotate the (45) system
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         pbp(i) = 0d0
         do j=1,4
            pbp(i) = pbp(i) + bmat(i,j)*pb(j)
         enddo
      enddo
      call unrotatetoz(pbp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pbp(j)
         enddo
      enddo

c      write(6,107) v(1:4)

c---- rotate the (45ang) system
      call boostrest(p45a,bmat)
      call unboostrest(p45a,ubmat)
      do i=1,4
         v(i) = 0d0
         pbap(i) = 0d0
         do j=1,4
            pbap(i) = pbap(i) + bmat(i,j)*pb(j)
         enddo
      enddo
      call unrotatetoz(pbap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4t(i) = 0d0
         p5t(i) = 0d0
         p4ta(i) = 0d0
         p5ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pbap(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         pang5(i,1,1) = p1(i)
         pang5(i,2,1) = p2(i)
         pang5(i,3,1) = p3(i)
         pang5(i,4,1) = p4(i)
         pang5(i,5,1) = p5(i)
         pang5(i,1,2) = p1(i)
         pang5(i,2,2) = p2(i)
         pang5(i,3,2) = p3(i)
         pang5(i,4,2) = p4a(i)
         pang5(i,5,2) = p5a(i)
         pang5(i,1,3) = p1(i)
         pang5(i,2,3) = p2(i)
         pang5(i,3,3) = p3a(i)
         pang5(i,4,3) = p4t(i)
         pang5(i,5,3) = p5t(i)
         pang5(i,1,4) = p1(i)
         pang5(i,2,4) = p2(i)
         pang5(i,3,4) = p3a(i)
         pang5(i,4,4) = p4ta(i)
         pang5(i,5,4) = p5ta(i)
      enddo

      do i=1,4
         call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
     .                                        ,tijang5(1:2,1:5,i))
      enddo
      do i=1,4
        call acceptcuts5b(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo

      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return


      ifail =0
      wt = wtps

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end



      subroutine acceptcuts5b(sij5,tij5,ipass,itechpass)
      implicit real*8(a-h,o-z)
      dimension sij5(1:5,1:5),tij5(1:2,1:5)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0
      itechpass=0

      sa3 = -tij5(1,3)
      sa4 = -tij5(1,4)
      sa5 = -tij5(1,5)
      sb3 = -tij5(2,3)
      sb4 = -tij5(2,4)
      sb5 = -tij5(2,5)
      s34 =  sij5(3,4)
      s35 =  sij5(3,5)
      s45 =  sij5(4,5)

      if (min(sa3,sa4,sa5,sb3,sb4,sb5).lt.y0*shat) return
      if (min(s34,s35,s45).lt.y0*shat) return

      itechpass=1

      smin1 = shat
      smin2 = shat

      do i=3,5
         do j=i+1,5
            if (sij5(i,j).lt.smin2) then
               smin2 = sij5(i,j)
               if (smin2.lt.smin1) then
                  stmp  = smin1
                  smin1 = smin2
                  smin2 = stmp
               endif
            endif
         enddo
         if (-tij5(1,i).lt.smin2) then
            smin2 = -tij5(1,i)
            if (smin2.lt.smin1) then
               stmp  = smin1
               smin1 = smin2
               smin2 = stmp
            endif
         endif
         if (-tij5(2,i).lt.smin2) then
            smin2 = -tij5(2,i)
            if (smin2.lt.smin1) then
               stmp  = smin1
               smin1 = smin2
               smin2 = stmp
            endif
         endif
      enddo

c---- these are the new selection cuts for phase5b
      if (smin1.eq.sa3.and.smin2.eq.min(sb3,sb4,sb5)) ipass=1
      if (smin1.eq.s45.and.smin2.eq.sa3) ipass=1
      if (smin2.eq.s45.and.smin1.eq.sa3) ipass=1

      return
      end



      subroutine fillcommon5aph
      implicit real*8(a-h,o-z)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/eventmom5ap/pevt5a(4,5,48)
!$omp threadprivate(/eventmom5ap/)
      common/eventinv5ap/sevt5a(5,5,48),tevt5a(2,5,48),ievt5a(48)
!$omp threadprivate(/eventinv5ap/)
      dimension i1(1:5,1:3)

      data i1/1,2,3,4,5,
     .        1,2,5,3,4,
     .        1,2,4,5,3/
c---- pang5 and sijang are input and correspond to an event in (3;4,5;a)
c---- this subroutine fills
c----       pevt5a(ievent,component,pnum)            : 4-momenta of events
c----       sevt5a(i,j,ievent),tevt5a([ab],i,ievent) : invariants of events
c----
c----  1: (3;45;a)
c----  2: (3;45;b)
c----  3: (5;34;a)
c----  4: (5;34;b)
c----  5: (4;53;a)
c----  6: (4;53;b)

c----  7-12: with (45) system rotated
c---- 13-18: with (345) system rotated
c---- 19-24: with (45) and (345) system rotated

c---- full phave space coverage is obtained by summing ievent=1..6
c---- angular average is obtained by averaging:
c----        M2 = 1/4* ( sum_ievent=1..24   M2(ievent))
c----

      do i=1,3
         do j=1,5
            do k=1,4
               pevt5a(k,i1(j,i),2*i-1)   = pang5(k,j,1)
               pevt5a(k,i1(j,i),2*i+5)   = pang5(k,j,2)
               pevt5a(k,i1(j,i),2*i+11)  = pang5(k,j,3)
               pevt5a(k,i1(j,i),2*i+17)  = pang5(k,j,4)
               if (k.ne.3) then
                  pevt5a(k,i1(j,i),2*i)     = pang5(k,j,1)
                  pevt5a(k,i1(j,i),2*i+6)   = pang5(k,j,2)
                  pevt5a(k,i1(j,i),2*i+12)  = pang5(k,j,3)
                  pevt5a(k,i1(j,i),2*i+18)  = pang5(k,j,4)
               else
                  pevt5a(k,i1(j,i),2*i)     = -pang5(k,j,1)
                  pevt5a(k,i1(j,i),2*i+6)   = -pang5(k,j,2)
                  pevt5a(k,i1(j,i),2*i+12)  = -pang5(k,j,3)
                  pevt5a(k,i1(j,i),2*i+18)  = -pang5(k,j,4)
               endif
            enddo
         enddo
      enddo

      do i=1,3
         do j=1,5
            do k=1,5
               sevt5a(i1(j,i),i1(k,i),2*i-1)  = sijang5(j,k,1)
               sevt5a(i1(j,i),i1(k,i),2*i+5)  = sijang5(j,k,2)
               sevt5a(i1(j,i),i1(k,i),2*i+11) = sijang5(j,k,3)
               sevt5a(i1(j,i),i1(k,i),2*i+17) = sijang5(j,k,4)
               sevt5a(i1(j,i),i1(k,i),2*i)    = sijang5(j,k,1)
               sevt5a(i1(j,i),i1(k,i),2*i+6)  = sijang5(j,k,2)
               sevt5a(i1(j,i),i1(k,i),2*i+12) = sijang5(j,k,3)
               sevt5a(i1(j,i),i1(k,i),2*i+18) = sijang5(j,k,4)
            enddo
            tevt5a(1,i1(j,i),2*i-1)  = tijang5(1,j,1)
            tevt5a(2,i1(j,i),2*i-1)  = tijang5(2,j,1)
            tevt5a(1,i1(j,i),2*i+5)  = tijang5(1,j,2)
            tevt5a(2,i1(j,i),2*i+5)  = tijang5(2,j,2)
            tevt5a(1,i1(j,i),2*i+11) = tijang5(1,j,3)
            tevt5a(2,i1(j,i),2*i+11) = tijang5(2,j,3)
            tevt5a(1,i1(j,i),2*i+17) = tijang5(1,j,4)
            tevt5a(2,i1(j,i),2*i+17) = tijang5(2,j,4)
            tevt5a(1,i1(j,i),2*i)    = tijang5(2,j,1)
            tevt5a(2,i1(j,i),2*i)    = tijang5(1,j,1)
            tevt5a(1,i1(j,i),2*i+6)  = tijang5(2,j,2)
            tevt5a(2,i1(j,i),2*i+6)  = tijang5(1,j,2)
            tevt5a(1,i1(j,i),2*i+12) = tijang5(2,j,3)
            tevt5a(2,i1(j,i),2*i+12) = tijang5(1,j,3)
            tevt5a(1,i1(j,i),2*i+18) = tijang5(2,j,4)
            tevt5a(2,i1(j,i),2*i+18) = tijang5(1,j,4)
         enddo
         ievt5a(2*i-1)  = iacc(1)
         ievt5a(2*i)    = iacc(1)
         ievt5a(2*i+5)  = iacc(2)
         ievt5a(2*i+6)  = iacc(2)
         ievt5a(2*i+11) = iacc(3)
         ievt5a(2*i+12) = iacc(3)
         ievt5a(2*i+17) = iacc(4)
         ievt5a(2*i+18) = iacc(4)
      enddo

c---- a few tests here
c      it = 1
c      write(6,101) pevt4b(1:4,1,it)
c      write(6,102) pevt4b(1:4,2,it)
c      write(6,103) pevt4b(1:4,3,it)
c      write(6,104) pevt4b(1:4,4,it)
c      write(6,101) pevt4b(1:4,1,it+1)
c      write(6,102) pevt4b(1:4,2,it+1)
c      write(6,103) pevt4b(1:4,3,it+1)
c      write(6,104) pevt4b(1:4,4,it+1)
c      write(6,101) pevt4b(1:4,1,it+2)
c      write(6,102) pevt4b(1:4,2,it+2)
c      write(6,103) pevt4b(1:4,3,it+2)
c      write(6,104) pevt4b(1:4,4,it+2)
c      write(6,101) pevt4b(1:4,1,it+3)
c      write(6,102) pevt4b(1:4,2,it+3)
c      write(6,103) pevt4b(1:4,3,it+3)
c      write(6,104) pevt4b(1:4,4,it+3)
c      write(6,101) pevt4b(1:4,1,it+4)
c      write(6,102) pevt4b(1:4,2,it+4)
c      write(6,103) pevt4b(1:4,3,it+4)
c      write(6,104) pevt4b(1:4,4,it+4)
c      write(6,101) pevt4b(1:4,1,it+5)
c      write(6,102) pevt4b(1:4,2,it+5)
c      write(6,103) pevt4b(1:4,3,it+5)
c      write(6,104) pevt4b(1:4,4,it+5)
c      write(6,*)
c      do it =1,6
c         write(6,*) it
c      s23 = 2d0*dot(pevt5a(1,2,it),pevt5a(1,3,it))
c      s24 = 2d0*dot(pevt5a(1,2,it),pevt5a(1,4,it))
c      s25 = 2d0*dot(pevt5a(1,2,it),pevt5a(1,5,it))
c      s34 = 2d0*dot(pevt5a(1,3,it),pevt5a(1,4,it))
c      s35 = 2d0*dot(pevt5a(1,3,it),pevt5a(1,5,it))
c      s45 = 2d0*dot(pevt5a(1,4,it),pevt5a(1,5,it))
c      ta2 = -pevt5a(4,2,it)+pevt5a(3,2,it)
c      ta3 = -pevt5a(4,3,it)+pevt5a(3,3,it)
c      ta4 = -pevt5a(4,4,it)+pevt5a(3,4,it)
c      ta5 = -pevt5a(4,5,it)+pevt5a(3,5,it)
c      tb2 = -pevt5a(4,2,it)-pevt5a(3,2,it)
c      tb3 = -pevt5a(4,3,it)-pevt5a(3,3,it)
c      tb4 = -pevt5a(4,4,it)-pevt5a(3,4,it)
c      tb5 = -pevt5a(4,5,it)-pevt5a(3,5,it)

c      it2 = it+12
c      write(6,107) ta2/tevt5a(1,2,it2),ta3/tevt5a(1,3,it2),
c     .             ta4/tevt5a(1,4,it2),ta5/tevt5a(1,5,it2)
c      write(6,107) tb2/tevt5a(2,2,it2),tb3/tevt5a(2,3,it2),
c     .             tb4/tevt5a(2,4,it2),tb5/tevt5a(2,5,it2)
c      write(6,108) s23/sevt5a(2,3,it2),s24/sevt5a(2,4,it2),
c     .             s34/sevt5a(3,4,it2)
c      write(6,108) s25/sevt5a(2,5,it2),s35/sevt5a(3,5,it2),
c     .             s45/sevt5a(4,5,it2)
c      write(6,*)
c      enddo


 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 107  format(4g18.13)
 108  format(3g18.13)


      return
      end

      subroutine fillcommon5bph
      implicit real*8(a-h,o-z)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/eventmom5bp/pevt5b(4,5,24)
!$omp threadprivate(/eventmom5bp/)
      common/eventinv5bp/sevt5b(5,5,24),tevt5b(2,5,24),ievt5b(24)
!$omp threadprivate(/eventinv5bp/)
      dimension i1(1:5,1:3)

      data i1/1,2,3,4,5,
     .        1,2,5,3,4,
     .        1,2,4,5,3/
c---- pang5 and sijang are input and correspond to an event in (3;a;4,5;b)
c---- this subroutine fills
c----       pevt5a(ievent,component,pnum)            : 4-momenta of events
c----       sevt5a(i,j,ievent),tevt5a([ab],i,ievent) : invariants of events
c----
c----  1: (3;a;45;b)
c----  2: (3;b;45;a)
c----  3: (5;a;34;b)
c----  4: (5;b;34;a)
c----  5: (4;a;53;b)
c----  6: (4;b;53;a)

c----  7-12: with (45) system rotated
c---- 13-18: with (345) system rotated
c---- 19-24: with (45) and (345) system rotated

c---- full phave space coverage is obtained by summing ievent=1..6
c---- angular average is obtained by averaging:
c----        M2 = 1/4* ( sum_ievent=1..24   M2(ievent))
c----

      do i=1,3
         do j=1,5
            do k=1,4
               pevt5b(k,i1(j,i),2*i-1)   = pang5(k,j,1)
               pevt5b(k,i1(j,i),2*i+5)   = pang5(k,j,2)
               pevt5b(k,i1(j,i),2*i+11)  = pang5(k,j,3)
               pevt5b(k,i1(j,i),2*i+17)  = pang5(k,j,4)
               if (k.ne.3) then
                  pevt5b(k,i1(j,i),2*i)     = pang5(k,j,1)
                  pevt5b(k,i1(j,i),2*i+6)   = pang5(k,j,2)
                  pevt5b(k,i1(j,i),2*i+12)  = pang5(k,j,3)
                  pevt5b(k,i1(j,i),2*i+18)  = pang5(k,j,4)
               else
                  pevt5b(k,i1(j,i),2*i)     = -pang5(k,j,1)
                  pevt5b(k,i1(j,i),2*i+6)   = -pang5(k,j,2)
                  pevt5b(k,i1(j,i),2*i+12)  = -pang5(k,j,3)
                  pevt5b(k,i1(j,i),2*i+18)  = -pang5(k,j,4)
               endif
            enddo
         enddo
      enddo

      do i=1,3
         do j=1,5
            do k=1,5
               sevt5b(i1(j,i),i1(k,i),2*i-1)  = sijang5(j,k,1)
               sevt5b(i1(j,i),i1(k,i),2*i+5)  = sijang5(j,k,2)
               sevt5b(i1(j,i),i1(k,i),2*i+11) = sijang5(j,k,3)
               sevt5b(i1(j,i),i1(k,i),2*i+17) = sijang5(j,k,4)
               sevt5b(i1(j,i),i1(k,i),2*i)    = sijang5(j,k,1)
               sevt5b(i1(j,i),i1(k,i),2*i+6)  = sijang5(j,k,2)
               sevt5b(i1(j,i),i1(k,i),2*i+12) = sijang5(j,k,3)
               sevt5b(i1(j,i),i1(k,i),2*i+18) = sijang5(j,k,4)
            enddo
            tevt5b(1,i1(j,i),2*i-1)  = tijang5(1,j,1)
            tevt5b(2,i1(j,i),2*i-1)  = tijang5(2,j,1)
            tevt5b(1,i1(j,i),2*i+5)  = tijang5(1,j,2)
            tevt5b(2,i1(j,i),2*i+5)  = tijang5(2,j,2)
            tevt5b(1,i1(j,i),2*i+11) = tijang5(1,j,3)
            tevt5b(2,i1(j,i),2*i+11) = tijang5(2,j,3)
            tevt5b(1,i1(j,i),2*i+17) = tijang5(1,j,4)
            tevt5b(2,i1(j,i),2*i+17) = tijang5(2,j,4)
            tevt5b(1,i1(j,i),2*i)    = tijang5(2,j,1)
            tevt5b(2,i1(j,i),2*i)    = tijang5(1,j,1)
            tevt5b(1,i1(j,i),2*i+6)  = tijang5(2,j,2)
            tevt5b(2,i1(j,i),2*i+6)  = tijang5(1,j,2)
            tevt5b(1,i1(j,i),2*i+12) = tijang5(2,j,3)
            tevt5b(2,i1(j,i),2*i+12) = tijang5(1,j,3)
            tevt5b(1,i1(j,i),2*i+18) = tijang5(2,j,4)
            tevt5b(2,i1(j,i),2*i+18) = tijang5(1,j,4)
         enddo
         ievt5b(i)    = iacc(1)
         ievt5b(i+3)  = iacc(1)
         ievt5b(i+6)  = iacc(2)
         ievt5b(i+9)  = iacc(2)
         ievt5b(i+12) = iacc(3)
         ievt5b(i+15) = iacc(3)
         ievt5b(i+18) = iacc(4)
         ievt5b(i+21) = iacc(4)
      enddo

c---- a few tests here
c      it = 1
c      write(6,101) pevt4b(1:4,1,it)
c      write(6,102) pevt4b(1:4,2,it)
c      write(6,103) pevt4b(1:4,3,it)
c      write(6,104) pevt4b(1:4,4,it)
c      write(6,101) pevt4b(1:4,1,it+1)
c      write(6,102) pevt4b(1:4,2,it+1)
c      write(6,103) pevt4b(1:4,3,it+1)
c      write(6,104) pevt4b(1:4,4,it+1)
c      write(6,101) pevt4b(1:4,1,it+2)
c      write(6,102) pevt4b(1:4,2,it+2)
c      write(6,103) pevt4b(1:4,3,it+2)
c      write(6,104) pevt4b(1:4,4,it+2)
c      write(6,101) pevt4b(1:4,1,it+3)
c      write(6,102) pevt4b(1:4,2,it+3)
c      write(6,103) pevt4b(1:4,3,it+3)
c      write(6,104) pevt4b(1:4,4,it+3)
c      write(6,101) pevt4b(1:4,1,it+4)
c      write(6,102) pevt4b(1:4,2,it+4)
c      write(6,103) pevt4b(1:4,3,it+4)
c      write(6,104) pevt4b(1:4,4,it+4)
c      write(6,101) pevt4b(1:4,1,it+5)
c      write(6,102) pevt4b(1:4,2,it+5)
c      write(6,103) pevt4b(1:4,3,it+5)
c      write(6,104) pevt4b(1:4,4,it+5)
c      write(6,*)
c      do it =13,18
c         write(6,*) it
c      s23 = 2d0*dot(pevt5b(1,2,it),pevt5b(1,3,it))
c      s24 = 2d0*dot(pevt5b(1,2,it),pevt5b(1,4,it))
c      s25 = 2d0*dot(pevt5b(1,2,it),pevt5b(1,5,it))
c      s34 = 2d0*dot(pevt5b(1,3,it),pevt5b(1,4,it))
c      s35 = 2d0*dot(pevt5b(1,3,it),pevt5b(1,5,it))
c      s45 = 2d0*dot(pevt5b(1,4,it),pevt5b(1,5,it))
c      ta2 = -pevt5b(4,2,it)+pevt5b(3,2,it)
c      ta3 = -pevt5b(4,3,it)+pevt5b(3,3,it)
c      ta4 = -pevt5b(4,4,it)+pevt5b(3,4,it)
c      ta5 = -pevt5b(4,5,it)+pevt5b(3,5,it)
c      tb2 = -pevt5b(4,2,it)-pevt5b(3,2,it)
c      tb3 = -pevt5b(4,3,it)-pevt5b(3,3,it)
c      tb4 = -pevt5b(4,4,it)-pevt5b(3,4,it)
c      tb5 = -pevt5b(4,5,it)-pevt5b(3,5,it)
c
c      it2 = it+6
c      write(6,107) ta2/tevt5b(1,2,it2),ta3/tevt5b(1,3,it2),
c     .             ta4/tevt5b(1,4,it2),ta5/tevt5b(1,5,it2)
c      write(6,107) tb2/tevt5b(2,2,it2),tb3/tevt5b(2,3,it2),
c     .             tb4/tevt5b(2,4,it2),tb5/tevt5b(2,5,it2)
c      write(6,108) s23/sevt5b(2,3,it2),s24/sevt5b(2,4,it2),
c     .             s34/sevt5b(3,4,it2)
c      write(6,108) s25/sevt5b(2,5,it2),s35/sevt5b(3,5,it2),
c     .             s45/sevt5b(4,5,it2)
c      write(6,*)
c      enddo


 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 107  format(4g18.13)
 108  format(3g18.13)


      return
      end






      subroutine phase5allh(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
     .          p3pp(4),p3app(4),papp(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p3a(4),p4a(4),p5a(4)
      dimension p12(4),p345(4),p45p(4),p45(4)
      dimension p345p(4)
      dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension parb(4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm12,rg12,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invar5/sij5(5,5),tij5(2,5)
!$omp threadprivate(/invar5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase5allh", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=6
      else
         Nphase=24
         wtps=wtps/4d0
      endif


* this is (3;4,5;a)
*
* phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with q=p1+p2
* with sequential splitting (345) -> 3+(45) -> 3+4+5
*
* (345) system is rotated with respect to pa axis
* (45)  system is rotated with respect to pa axis
*
* default momenta             : pang(i,j,1)
* (45) rotated                : pang(i,j,2)
* (345) rotated               : pang(i,j,3)
* (345) rotated, (45) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      r9 = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1


      s12min=y0*s_proc
      s12max=s_proc
      if (s12min.ge.s12max) return
      call pick_sinv_generic(s12,s12min,s12max,rm12,rg12,r1,wtps,inwa)

      if(shat.lt.s12) return    ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r2,wtps)
      call pick(1,phi,0d0,twopi,r3,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      s345min = dmax1(y0*shat,
     .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s345max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s345max.le.s345min) return
      call pick(1,s345,s345min,s345max,r4,wtps)
      wtps = wtps/2d0/pi
      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1(s345,(1d0-y0)*shat)
      if (s45max.le.s45min) return
*      call pick(1,s45,s45min,s45max,r5,wtps)
*     sample log(s45)
      call pick(2,s45,s45min,s45max,r5,wtps)
      wtps = wtps/2d0/pi

      call p2generic_alt(2,r6,0d0,shat,0d0,0d0,s12,s345,
     .                   p12,p345,pa,pb,wtps)
      if(wtps.eq.0d0) return


* TODO: change of variables only works in the massless case.
*       Add a condition s.t. we return to the old calculations
*       for massive partons

      costhmin = -1d0
      costhmax = 1d0
      call pickcos(costh,y0,r7,wtps)

      call pick(1,phi,0d0,twopi,r8,wtps)
      call makeps2com(s345,costh,phi,rm2(3),s45,p3p,p45p,p3ap,p45ap)
      wtps = wtps*dsqrt(dlambda(s345,rm2(3),s45))/s345/32d0/pi**2

***********************************************

c---- rotate the (345) system
      call boostrest(p345,bmat)
      call unboostrest(p345,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p45(i) = 0d0
         p3a(i) = 0d0
         p45a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p45(i) = p45(i) + fmat(i,j)*p45p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      call pickcos_alt(costh,r9,wtps)
*      call pickcos(costh,y0,r9,wtps)

      call pick(1,phi,0d0,twopi,r10,wtps)
      call makeps2com(s45,costh,phi,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap)
      wtps = wtps*dsqrt(dlambda(s45,rm2(4),rm2(5)))/s45/32d0/pi**2

***********************************************


      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo


      if(p345(4).lt.0d0)then
         ifail = 1
         return
      endif

c---- rotate the (45) system
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (45ang) system
      call boostrest(p45a,bmat)
      call unboostrest(p45a,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4t(i) = 0d0
         p5t(i) = 0d0
         p4ta(i) = 0d0
         p5ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         pang5(i,1,1) = p1(i)
         pang5(i,2,1) = p2(i)
         pang5(i,3,1) = p3(i)
         pang5(i,4,1) = p4(i)
         pang5(i,5,1) = p5(i)

         pang5(i,1,2) = p1(i)
         pang5(i,2,2) = p2(i)
         pang5(i,3,2) = p3(i)
         pang5(i,4,2) = p4a(i)
         pang5(i,5,2) = p5a(i)

         pang5(i,1,3) = p1(i)
         pang5(i,2,3) = p2(i)
         pang5(i,3,3) = p3a(i)
         pang5(i,4,3) = p4t(i)
         pang5(i,5,3) = p5t(i)

         pang5(i,1,4) = p1(i)
         pang5(i,2,4) = p2(i)
         pang5(i,3,4) = p3a(i)
         pang5(i,4,4) = p4ta(i)
         pang5(i,5,4) = p5ta(i)
      enddo

      do i=1,4
         call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
     .                                        ,tijang5(1:2,1:5,i))
      enddo

      do i=1,4
        call acceptcuts5all(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo
      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return

      ifail =0
      wt = wtps


c
c      k10 = 1
c      write(6,101) pang5(1:4,1,k10)
c      write(6,102) pang5(1:4,2,k10)
c      write(6,103) pang5(1:4,3,k10)
c      write(6,104) pang5(1:4,4,k10)
c      write(6,105) pang5(1:4,5,k10)
c      write(6,106) pa(1:4)
c      write(6,107) pb(1:4)
c      write(6,109) v1(1:4)
c      write(6,*) q2/dot(q,q)
c

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end


      subroutine acceptcuts5all(sij5,tij5,ipass,itechpass)
      implicit real*8(a-h,o-z)
      dimension sij5(1:5,1:5),tij5(1:2,1:5)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0
      integer ipassIF, ipassFF

      ipass = 0
      itechpass = 0
      ipassIF = 0
      ipassFF = 0

      sa3 = -tij5(1,3)
      sa4 = -tij5(1,4)
      sa5 = -tij5(1,5)
      sb3 = -tij5(2,3)
      sb4 = -tij5(2,4)
      sb5 = -tij5(2,5)
      s34 =  sij5(3,4)
      s35 =  sij5(3,5)
      s45 =  sij5(4,5)

      if (min(sa3,sa4,sa5,sb3,sb4,sb5).lt.y0*shat) return
      if (min(s34,s35,s45).lt.y0*shat) return

      itechpass = 1

* single out on 3||a, 4||a, 5||a
      rinvmina = min(sa3,sa4,sa5)
      rinvminb = min(sb3,sb4,sb5)
      if (rinvmina.lt.rinvminb) ipassIF=1

* single out on 4||5
      rinvmin  = min(s34,s35,s45)
      if (rinvmin.eq.s45) ipassFF=1

      if ((ipassIF.eq.1).and.(ipassFF.eq.1)) ipass=1

      return
      end





      subroutine fillcommon5allph
*XC based on fillcommon5aph and duplicated for further upgrade
      implicit real*8(a-h,o-z)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/eventmom5allp/pevt5all(4,5,48)
!$omp threadprivate(/eventmom5allp/)
      common/eventinv5allp/sevt5all(5,5,48),tevt5all(2,5,48),ievt5all(48)
!$omp threadprivate(/eventinv5allp/)
      dimension i1(1:5,1:3)

      data i1/1,2,3,4,5,
     .        1,2,5,3,4,
     .        1,2,4,5,3/
c---- pang5 and sijang are input and correspond to an event in (3;4,5;a)
c---- this subroutine fills
c----       pevt5all(ievent,component,pnum)            : 4-momenta of events
c----       sevt5all(i,j,ievent),tevt5all([ab],i,ievent) : invariants of events
c----
c----  1: (3;45;a)
c----  2: (3;45;b)
c----  3: (5;34;a)
c----  4: (5;34;b)
c----  5: (4;53;a)
c----  6: (4;53;b)

c----  7-12: with (45) system rotated
c---- 13-18: with (345) system rotated
c---- 19-24: with (45) and (345) system rotated

c---- full phave space coverage is obtained by summing ievent=1..6
c---- angular average is obtained by averaging:
c----        M2 = 1/4* ( sum_ievent=1..24   M2(ievent))
c----

      do i=1,3
         do j=1,5
            do k=1,4
               pevt5all(k,i1(j,i),2*i-1)   = pang5(k,j,1)
               pevt5all(k,i1(j,i),2*i+5)   = pang5(k,j,2)
               pevt5all(k,i1(j,i),2*i+11)  = pang5(k,j,3)
               pevt5all(k,i1(j,i),2*i+17)  = pang5(k,j,4)
               if (k.ne.3) then
                  pevt5all(k,i1(j,i),2*i)     = pang5(k,j,1)
                  pevt5all(k,i1(j,i),2*i+6)   = pang5(k,j,2)
                  pevt5all(k,i1(j,i),2*i+12)  = pang5(k,j,3)
                  pevt5all(k,i1(j,i),2*i+18)  = pang5(k,j,4)
               else
                  pevt5all(k,i1(j,i),2*i)     = -pang5(k,j,1)
                  pevt5all(k,i1(j,i),2*i+6)   = -pang5(k,j,2)
                  pevt5all(k,i1(j,i),2*i+12)  = -pang5(k,j,3)
                  pevt5all(k,i1(j,i),2*i+18)  = -pang5(k,j,4)
               endif
            enddo
         enddo
      enddo

      do i=1,3
         do j=1,5
            do k=1,5
               sevt5all(i1(j,i),i1(k,i),2*i-1)  = sijang5(j,k,1)
               sevt5all(i1(j,i),i1(k,i),2*i+5)  = sijang5(j,k,2)
               sevt5all(i1(j,i),i1(k,i),2*i+11) = sijang5(j,k,3)
               sevt5all(i1(j,i),i1(k,i),2*i+17) = sijang5(j,k,4)
               sevt5all(i1(j,i),i1(k,i),2*i)    = sijang5(j,k,1)
               sevt5all(i1(j,i),i1(k,i),2*i+6)  = sijang5(j,k,2)
               sevt5all(i1(j,i),i1(k,i),2*i+12) = sijang5(j,k,3)
               sevt5all(i1(j,i),i1(k,i),2*i+18) = sijang5(j,k,4)
            enddo
            tevt5all(1,i1(j,i),2*i-1)  = tijang5(1,j,1)
            tevt5all(2,i1(j,i),2*i-1)  = tijang5(2,j,1)
            tevt5all(1,i1(j,i),2*i+5)  = tijang5(1,j,2)
            tevt5all(2,i1(j,i),2*i+5)  = tijang5(2,j,2)
            tevt5all(1,i1(j,i),2*i+11) = tijang5(1,j,3)
            tevt5all(2,i1(j,i),2*i+11) = tijang5(2,j,3)
            tevt5all(1,i1(j,i),2*i+17) = tijang5(1,j,4)
            tevt5all(2,i1(j,i),2*i+17) = tijang5(2,j,4)
            tevt5all(1,i1(j,i),2*i)    = tijang5(2,j,1)
            tevt5all(2,i1(j,i),2*i)    = tijang5(1,j,1)
            tevt5all(1,i1(j,i),2*i+6)  = tijang5(2,j,2)
            tevt5all(2,i1(j,i),2*i+6)  = tijang5(1,j,2)
            tevt5all(1,i1(j,i),2*i+12) = tijang5(2,j,3)
            tevt5all(2,i1(j,i),2*i+12) = tijang5(1,j,3)
            tevt5all(1,i1(j,i),2*i+18) = tijang5(2,j,4)
            tevt5all(2,i1(j,i),2*i+18) = tijang5(1,j,4)
         enddo
         ievt5all(2*i-1)  = iacc(1)
         ievt5all(2*i)    = iacc(1)
         ievt5all(2*i+5)  = iacc(2)
         ievt5all(2*i+6)  = iacc(2)
         ievt5all(2*i+11) = iacc(3)
         ievt5all(2*i+12) = iacc(3)
         ievt5all(2*i+17) = iacc(4)
         ievt5all(2*i+18) = iacc(4)
      enddo

c---- a few tests here
c      it = 1
c      write(6,101) pevt4b(1:4,1,it)
c      write(6,102) pevt4b(1:4,2,it)
c      write(6,103) pevt4b(1:4,3,it)
c      write(6,104) pevt4b(1:4,4,it)
c      write(6,101) pevt4b(1:4,1,it+1)
c      write(6,102) pevt4b(1:4,2,it+1)
c      write(6,103) pevt4b(1:4,3,it+1)
c      write(6,104) pevt4b(1:4,4,it+1)
c      write(6,101) pevt4b(1:4,1,it+2)
c      write(6,102) pevt4b(1:4,2,it+2)
c      write(6,103) pevt4b(1:4,3,it+2)
c      write(6,104) pevt4b(1:4,4,it+2)
c      write(6,101) pevt4b(1:4,1,it+3)
c      write(6,102) pevt4b(1:4,2,it+3)
c      write(6,103) pevt4b(1:4,3,it+3)
c      write(6,104) pevt4b(1:4,4,it+3)
c      write(6,101) pevt4b(1:4,1,it+4)
c      write(6,102) pevt4b(1:4,2,it+4)
c      write(6,103) pevt4b(1:4,3,it+4)
c      write(6,104) pevt4b(1:4,4,it+4)
c      write(6,101) pevt4b(1:4,1,it+5)
c      write(6,102) pevt4b(1:4,2,it+5)
c      write(6,103) pevt4b(1:4,3,it+5)
c      write(6,104) pevt4b(1:4,4,it+5)
c      write(6,*)
c      do it =1,6
c         write(6,*) it
c      s23 = 2d0*dot(pevt5all(1,2,it),pevt5all(1,3,it))
c      s24 = 2d0*dot(pevt5all(1,2,it),pevt5all(1,4,it))
c      s25 = 2d0*dot(pevt5all(1,2,it),pevt5all(1,5,it))
c      s34 = 2d0*dot(pevt5all(1,3,it),pevt5all(1,4,it))
c      s35 = 2d0*dot(pevt5all(1,3,it),pevt5all(1,5,it))
c      s45 = 2d0*dot(pevt5all(1,4,it),pevt5all(1,5,it))
c      ta2 = -pevt5all(4,2,it)+pevt5all(3,2,it)
c      ta3 = -pevt5all(4,3,it)+pevt5all(3,3,it)
c      ta4 = -pevt5all(4,4,it)+pevt5all(3,4,it)
c      ta5 = -pevt5all(4,5,it)+pevt5all(3,5,it)
c      tb2 = -pevt5all(4,2,it)-pevt5all(3,2,it)
c      tb3 = -pevt5all(4,3,it)-pevt5all(3,3,it)
c      tb4 = -pevt5all(4,4,it)-pevt5all(3,4,it)
c      tb5 = -pevt5all(4,5,it)-pevt5all(3,5,it)

c      it2 = it+12
c      write(6,107) ta2/tevt5all(1,2,it2),ta3/tevt5all(1,3,it2),
c     .             ta4/tevt5all(1,4,it2),ta5/tevt5all(1,5,it2)
c      write(6,107) tb2/tevt5all(2,2,it2),tb3/tevt5all(2,3,it2),
c     .             tb4/tevt5all(2,4,it2),tb5/tevt5all(2,5,it2)
c      write(6,108) s23/sevt5all(2,3,it2),s24/sevt5all(2,4,it2),
c     .             s34/sevt5all(3,4,it2)
c      write(6,108) s25/sevt5all(2,5,it2),s35/sevt5all(3,5,it2),
c     .             s45/sevt5all(4,5,it2)
c      write(6,*)
c      enddo


 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 107  format(4g18.13)
 108  format(3g18.13)


      return
      end

