      subroutine decay3(rmh2,ph,rr,pd,wtps,ipass)
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      use Constants_mod, only : pi, twopi
      implicit real*8(a-h,o-z)
c---- parametrizes the decay of ph to one massive and one massless particles, which then deacy into three massless particles pd(1:3)
c---- requires five random variables rr
c---- settings for H-> Vg: rmv1=M_Z (or M_W), rmv2=0, ios1=1, ios2 no need to define
c---- ios=1: BW parametrization, ios=0: linear parametrization
      dimension ph(4),rr(5),pd(4,3)
      dimension ubmat(4,4),ubmat12(4,4)
      dimension p12(4),p3(4),p12p(4),p3p(4),p12ap(4),p3ap(4)
      dimension p1p(4),p2p(4),p1ap(4),p2ap(4)
      common/vdecay/rmv1,rgv1,rmv2,rgv2,ios1,ios2,isym
      common /tcuts/ymin,y0

      r1 = rr(1)
      r2 = rr(2)
      r3 = rr(3)
      r4 = rr(4)
      r5 = rr(5)

      !> ios1(2) -- heavy particle decay type
      !>  0 : use ds12/s12
      !>  1 : use resonance parametrization (with mass rmv1, width rgv1)
      !>  2 : narrow width inserted: delta function
      !>  3 : on-shell heavy particle no decay
      !>  -1: combine 0 and 1 (mix linear sampling at low s12 and BW sampling for high s12)

      ipass = 0
      s12min = y0*rmh2
      s12max = rmh2-s12min
c      write(6,*) '1:',wtps,r1,s12min,s12max,rmh2
      if (s12min.gt.s12max) return
      if (ios1.eq.0) then
         call pick(1,s12,s12min,s12max,r2,wtps)
      elseif (ios1.eq.1) then
         call pickres(s12,s12min,s12max,rmv1,rgv1,r2,wtps)
      elseif (ios1.eq.2) then
         s12 = rmv1**2
         wtps = wtps*pi*rmv1*rgv1
      elseif (ios1.eq.3) then
         s12 = rmv1**2
         wtps = wtps*pi*(4d0*pi)
      elseif (ios1.eq.-1) then
         call pick_lin_res(s12,s12min,s12max,rmv1,rgv1,r2,wtps)
      else
         write(*,*)"ios1 option not supported in decay3"
         stop
      endif
      if(rmh2.lt.s12) return ! Insufficient scattering energy to produce the heavy gauge boson

c      write(6,*) '2:',wtps
c         s12 = rmv1**2

      costhmin = -1d0
      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi
      call pick(1,costh,costhmin,costhmax,r3,wtps)
c      write(6,*) '4a:',wtps,r3,r4
      call pick(1,phi,phimin,phimax,r1,wtps)
c      write(6,*) '4:',wtps,r3,r4
      wtps = wtps*dsqrt(dlambda(rmh2,s12,rmv2))/rmh2/32d0/pi**2
c      write(6,*) '5:',wtps
      call makeps2com(rmh2,costh,phi,s12,rmv2,p12p,p3p,p12ap,p3ap)
      call unboostrest(ph,ubmat)
      do i=1,4
         p12(i) = 0d0
         p3(i) = 0d0
         do j=1,4
            p12(i) = p12(i) + ubmat(i,j)*p12p(j)
            p3(i)  = p3(i)  + ubmat(i,j)*p3p(j)
         enddo
      enddo

      call pick(1,costh,costhmin,costhmax,r4,wtps)
      call pick(1,phi,phimin,phimax,r5,wtps)
      wtps = wtps*dsqrt(dlambda(s12,0d0,0d0))/s12/32d0/pi**2
      wtps = wtps/2d0/pi
      call makeps2com(s12,costh,phi,0d0,0d0,p1p,p2p,p1ap,p2ap)
      call unboostrest(p12,ubmat12)

      do i=1,4
         pd(i,1) = 0d0
         pd(i,2) = 0d0
         pd(i,3) = 0d0
         do j=1,4
            pd(i,1) = pd(i,1) + ubmat12(i,j)*p1p(j)
            pd(i,2) = pd(i,2) + ubmat12(i,j)*p2p(j)
         enddo
            pd(i,3) = pd(i,3) + p3(i)
      enddo
      ipass =1
      return
      end




      subroutine phase3vp(x, wt, ifail)
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h, o-z)
      double precision x, wt
      integer ifail
      dimension x(*)
      dimension p1(4),p2(4),p3(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p3p(4)
      dimension p1ap(4),p2ap(4),p3ap(4)
      dimension ubmat12(4,4)
      dimension pdecay(4,3)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension p12(4),p12p(4),p12ap(4)
      dimension xveg(8)
      parameter(pi=3.141592653589793238d0)
      ! Common Blocks
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0
      common /pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common /pmomang3/pang3(4,3,2)
!$omp threadprivate(/pmomang3/)
      common /invarang3/sijang3(3,3,2),tijang3(2,3,2),iacc(2)
!$omp threadprivate(/invarang3/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common /nwa/rm12,rg12,inwa
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)
      common/vdecay/rmv1,rgv1,rmv2,rgv2,ios1,ios2,isym

cLIPS      print*, "phase3vp", x(1), wt, ifail

      wtps = 1d0
      Nphase=1

      ifail = 1
      wt = 0d0


      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)

      s12min = y0*shat
      s12max = shat-s12min

c      write(6,*) '1:',wtps,r1,s12min,s12max,rmh2
      if (s12min.gt.s12max) return
      if (ios1.eq.0) then
         call pick(1,s12,s12min,s12max,r1,wtps)
      elseif (ios1.eq.1) then
         call pickres(s12,s12min,s12max,rmv1,rgv1,r1,wtps)
      elseif (ios1.eq.2) then
         s12 = rm12**2
         wtps = wtps*pi*rm12*rg12
      elseif (ios1.eq.3) then
         s12 = rm12**2
         wtps = wtps*pi*(4d0*pi)
      elseif (ios1.eq.-1) then
         call pick_lin_res(s12,s12min,s12max,rmv1,rgv1,r1,wtps)
      else
         write(*,*)"ios1 option not supported in phase3vp"
         stop
      endif
      if(shat.lt.s12) return ! Insufficient scattering energy to produce the heavy gauge boson
c      write(6,*) '2:',wtps
c         s12 = rmv1**2

      call p2generic(r2,0d0,shat,rma2,rmb2,s12,rmv2,p12,p3,pa,pb,wtps)
      if(wtps.eq.0d0) return

      costhmin = -1d0
      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi

      call pick(1,costh,costhmin,costhmax,r3,wtps)
      call pick(1,phi,phimin,phimax,r4,wtps)
      wtps = wtps*dsqrt(dlambda(s12,0d0,0d0))/s12/32d0/pi**2
      wtps = wtps/2d0/pi
      call makeps2com(s12,costh,phi,0d0,0d0,p1p,p2p,p1ap,p2ap)
      call unboostrest(p12,ubmat12)

      do i=1,4
         pdecay(i,1) = 0d0
         pdecay(i,2) = 0d0
         pdecay(i,3) = 0d0
         do j=1,4
            pdecay(i,1) = pdecay(i,1) + ubmat12(i,j)*p1p(j)
            pdecay(i,2) = pdecay(i,2) + ubmat12(i,j)*p2p(j)
         enddo
            pdecay(i,3) = pdecay(i,3) + p3(i)
      enddo

      do i=1,4
         do j=1,3
            p(i,j) = pdecay(i,j)
            pang3(i,j,1) = p(i,j)
         enddo
      enddo

      call fillinv(3,pang3(1:4,1:3,1),pa,pb,sijang3(1:3,1:3,1)
     .                                     ,tijang3(1:2,1:3,1))

      ifail = 0
      wt = wtps

      return
      end

      subroutine fillcommon3pvp
      implicit real*8(a-h, o-z)
      common /pmomang3/pang3(4,3,2)
!$omp threadprivate(/pmomang3/)
      common/invarang3/sijang3(3,3,2),tijang3(2,3,2),iacc(2)
!$omp threadprivate(/invarang3/)
      common/eventmom3p/pevt3(4,3,12)
!$omp threadprivate(/eventmom3p/)
      common/eventinv3p/sevt3(3,3,12),tevt3(2,3,12),ievt3(12)
!$omp threadprivate(/eventinv3p/)

      do j=1,3
         do k=1,4
            pevt3(k,j,1) = pang3(k,j,1)
         enddo
      enddo

c      do j=1,3
c         do k=1,3
c            sevt3(j,k,1)    = sijang3(j,k,1)
c         enddo
c         tevt3(1,j,1)   = tijang3(1,j,1)
c         tevt3(2,j,1)   = tijang3(2,j,1)
c      enddo
c      ievt3(1) = 1

      return
      end


      subroutine phase4vp(x,wt,ifail)
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),v(4),v1(4),q(4)
      dimension pqa(4),p123(4)
      dimension pdecay(1:4,1:3)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      parameter(pi=3.141592653589793238d0)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang4/pang4(4,4,4)
!$omp threadprivate(/pmomang4/)
      common/invar4/sij4(4,4),tij4(2,4)
!$omp threadprivate(/invar4/)
      common/invarang4/sijang4(4,4,4),tijang4(2,4,4),iacc(4)
!$omp threadprivate(/invarang4/)
      common /nwa/rm123,rg123,inwa
      common /tcuts/ymin,y0
      common /mxdim/ mxdim
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase4vp", x(1), wt, ifail

      wtps = 1d0
      Nphase = 1
*
* phase space for 2->4 scattering, a+b -> 1+2+3+4 with ph=p1+p2+p3+p4 and pv12 = p1+p2
*
* incoming momenta along z-axis, pa is +z
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3

      r1 = x(1)
      r2 = x(2)

      ifail =1
      wt = 0d0

      s123min=y0*s_proc
      s123max=s_proc
      if (s123min.ge.s123max) return
      if (inwa.eq.0) then
         call pick(1,s123,s123min,s123max,r1,wtps)
      endif
      if (inwa.eq.1) then
         call pickres(s123,s123min,s123max,rm123,rg123,r1,wtps)
      endif
      if (inwa.eq.2) then
         s123 = rm123**2
         wtps = wtps*pi*rm123*rg123
      endif
      if (inwa.eq.3) then
         s123 = rm123**2
         wtps = wtps*pi*(16d0*pi)
      endif


      if(shat.lt.s123) return ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
c      write(6,*) '1:',wtps
      call p2generic(r2,0d0,shat,rma2,rmb2,s123,rm2(4),p123,p4,pa,pb,wtps)
      if(wtps.eq.0d0) return
c      write(6,*) '2:',wtps

      call decay3(s123,p123,x(3:7),pdecay,wtps,ipass)
      if (ipass.eq.0) return
c      write(6,*) '3:',wtps
      do i=1,4
         do j=1,3
            p(i,j) = pdecay(i,j)
            pang4(i,j,1) = p(i,j)
         enddo
         p(i,4) = p4(i)
         pang4(i,4,1) = p(i,4)
      enddo

      if(p4(4).lt.0d0)then ! negative energy jets
         ifail=1
         return
      endif

      call fillinv(4,pang4(1:4,1:4,1),pa,pb,sijang4(1:4,1:4,1)
     .                                     ,tijang4(1:2,1:4,1))

c      write(6,101) p1(1:4)
c      write(6,102) p2(1:4)
c      write(6,103) p3(1:4)
c      write(6,105) v(1:4)
c      write(6,106) pb(1:4)
c      write(6,109) v1(1:4)
c      write(6,*) q2/dot(q,q)
c      write(6,109) p1(1:4) + p2(1:4) + p3(1:4)

 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 105  format('pa:',4f14.6)
 106  format('pb:',4f14.6)
 109  format('pp:',4f14.6)

      ifail =0
      wt = wtps

      return
      end


      subroutine fillcommon4pvp
      implicit real*8(a-h,o-z)
      common/pmomang4/pang4(4,4,4)
!$omp threadprivate(/pmomang4/)
      common/invarang4/sijang4(4,4,4),tijang4(2,4,4),iacc(4)
!$omp threadprivate(/invarang4/)
      common/eventmom4p/pevt4(4,4,4)
!$omp threadprivate(/eventmom4p/)
      common/eventinv4p/sevt4(4,4,4),tevt4(2,4,4),ievt4(4)
!$omp threadprivate(/eventinv4p/)

c---- pang3,pang3g and sija,tija are input
c---- this subroutine fills
c----       pevt3(component,pnum,ievent)             : 4-momenta of events
c----       sevt3(i,j,ievent),tevt3([ab],i,ievent)   : invariants of events
c----
c---- ievent = 1 fixed

      do j=1,4
         do k=1,4
            pevt4(k,j,1)    = pang4(k,j,1)
         enddo
      enddo

c      do j=1,4
c         do k=1,4
c            sevt4(j,k,1)    = sijang4(j,k,1)
c         enddo
c         tevt4(1,j,1)   = tijang4(1,j,1)
c         tevt4(2,j,1)   = tijang4(2,j,1)
c      enddo
c      ievt4(1) = 1

c---- a few tests here
c      write(6,101) pevt3(1:4,1,1)
c      write(6,102) pevt3(1:4,2,1)
c      write(6,103) pevt3(1:4,3,1)
c      write(6,104) pevt3(1:4,1,1)+pevt3(1:4,2,1)+pevt3(1:4,3,1)

c      it =1
c      ta1 = -pevt3(4,1,it)+pevt3(3,1,it)
c      ta2 = -pevt3(4,2,it)+pevt3(3,2,it)
c      ta3 = -pevt3(4,3,it)+pevt3(3,3,it)
c      write(6,110) ta1/tevt3(1,1,it),ta2/tevt3(1,2,it),ta3/tevt3(1,3,it)

 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 110  format(3g18.11)
 111  format(2g18.11)

      return
      end





      subroutine phase5vp(x,wt,ifail)
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),v1(4),q(4)
      dimension p4p(4),p5p(4),pap(4)
      dimension p4a(4),p5a(4)
      dimension p4ap(4),p5ap(4)
      dimension p45(4),parb(4)
      dimension pqa(4),p123(4)
      dimension pdecay(1:4,1:3)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      parameter(pi=3.141592653589793238d0)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invar5/sij5(5,5),tij5(2,5)
!$omp threadprivate(/invar5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common /nwa/rm123,rg123,inwa
      common /tcuts/ymin,y0
      common /techpar/iang
      common /mxdim/ mxdim
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase5vp", x(1), wt, ifail

      wtps = 1d0
      if(iang.eq.0)then
         Nphase=2
      else
         Nphase=4
         wtps=wtps/2d0
      endif

*
* phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with ph=p1+p2+p3 and pv12 = p1+p2
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)

      ifail =1
      wt = 0d0

      s123min=y0*s_proc
      s123max=s_proc
      if (s123min.ge.s123max) return
      if (inwa.eq.0) then
         call pick(1,s123,s123min,s123max,r1,wtps)
      endif
      if (inwa.eq.1) then
         call pickres(s123,s123min,s123max,rm123,rg123,r1,wtps)
      endif
      if (inwa.eq.2) then
         s123 = rm123**2
         wtps = wtps*pi*rm123*rg123
      endif
      if (inwa.eq.3) then
         s123 = rm123**2
         wtps = wtps*pi*(16d0*pi)
      endif
      if(shat.lt.s123) return ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
c      write(6,*) '1:',wtps

      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1((dsqrt(shat)-dsqrt(s123))**2,(1d0-y0)*shat)
      if (s45min.ge.s45max) return
      call pick(1,s45,s45min,s45max,r2,wtps)
      wtps = wtps/2d0/pi
      call p2generic(r3,0d0,shat,rma2,rmb2,s123,s45,p123,p45,pa,pb,wtps)
      if(wtps.eq.0d0) return

c      write(6,*) '2:',wtps


**************************************************
*     TM 24/06/2015: switched to sampling
*     rat=sa3/(sa3max-sa3+y0*shat) logarithmically
*     from costh
*
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo

      call rotatetoz(pap,rmat)
      do i=1,4
         parb(i) = 0.d0
         do j=1,4
            do k=1,4
               parb(i) = parb(i) + rmat(i,k)*bmat(k,j)*pa(j)
            enddo
         enddo
      enddo

      bound = 2.d0*(s45+rm2(5))/sqrt(s45)*parb(4)
      sa4min = y0*shat
      sa4max = min(bound,(1.d0-y0)*shat)
      if(sa4max.le.sa4min) return

*     jacobian for costh -> sa4
      wtps = wtps/(s45)*sqrt(s45)/parb(4)

*     rat=sa4/(sa4max-sa4+y0*shat)
      ratmin=y0*shat/sa4max
      ratmax=sa4max/(y0*shat)

      call pick(2,rat,ratmin,ratmax,r4,wtps)

      sa4=rat*(sa4max+y0*shat)/(rat+1d0)
      wtps=wtps*(sa4max-sa4+y0*shat)**2/(sa4max+y0*shat)

      costh=-(sa4-s45*parb(4)/s45**0.5)/(2d0*parb(4)*(s45/2d0/s45**0.5))

      phimin = 0d0
      phimax = 2d0*pi

c      call pick(1,costh,costhmin,costhmax,r4,wtps)
      call pick(1,phi,phimin,phimax,r5,wtps)
      wtps = wtps*dsqrt(dlambda(s45,rm2(4),rm2(5)))/s45/32d0/pi**2
      call makeps2com(s45,costh,phi,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap)

      call unrotatetoz(pap,urmat)

      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
         enddo
      enddo

      if((p4(4).lt.0).or.(p4a(4).lt.0).or.(p5(4).lt.0).or.(p5a(4).lt.0))then
         ifail = 1
         return
      endif
**************************************************


      call decay3(s123,p123,x(6:10),pdecay,wtps,ipass)
      if (ipass.eq.0) return
c      write(6,*) '3:',wtps


      do i=1,4
         do j=1,3
            p(i,j) = pdecay(i,j)
            pang5(i,j,1) = p(i,j)
            pang5(i,j,2) = p(i,j)
         enddo
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         pang5(i,4,1) = p4(i)
         pang5(i,5,1) = p5(i)
         pang5(i,4,2) = p4a(i)
         pang5(i,5,2) = p5a(i)
      enddo

      call fillinv(5,p,pa,pb,sij5,tij5)
      do i=1,2
         call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
     .                                        ,tijang5(1:2,1:5,i))
      enddo

      do i=1,2
         call acceptcuts5(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i))
      enddo
      if (iacc(1)+iacc(2).eq.0) return

      ifail =0
      wt = wtps

      return
      end



      subroutine acceptcuts5(sij5,tij5,ipass)
      implicit real*8(a-h,o-z)
      dimension sij5(1:5,1:5),tij5(1:2,1:5)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0

      sa4 = -tij5(1,4)
      sa5 = -tij5(1,5)
      sb4 = -tij5(2,4)
      sb5 = -tij5(2,5)


      rinvmin = min(sa4,sa5,sb4,sb5)
      if (rinvmin.lt.y0*shat) return

      ipass = 0
* single out on 4||a, 5||a
      if (rinvmin.eq.sa4.or.rinvmin.eq.sa5) ipass=1
      return
      end



      subroutine fillcommon5pvp
      implicit real*8(a-h,o-z)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/eventmom5p/pevt5(4,5,4)
!$omp threadprivate(/eventmom5p/)
      common/eventinv5p/sevt5(5,5,4),tevt5(2,5,4),ievt5(4)
!$omp threadprivate(/eventinv5p/)

c---- pang6 and sija,tija are input and correspond to an event in (3,4;a)
c---- this subroutine fills
c----       pevt6(component,pnum,ievent)             : 4-momenta of events
c----       sevt6(i,j,ievent),tevt6([ab],i,ievent)   : invariants of events
c----
c---- ievent
c---- 1: (5,6;a)
c---- 2: (5,6;b)
c----
c---- 5-6 (i,j;x) with (i,j) system rotated around x-axis
c----
c---- full phave space coverage is obtained by summing all 2 events
c---- angular average is obtained by averaging:
c----        M2 = 1/2* ( sum_ievent=1..4   M2(ievent))
c----


      do j=1,5
         do k=1,4
            pevt5(k,j,1) = pang5(k,j,1)
            pevt5(k,j,3) = pang5(k,j,2)
            if (k.ne.3) then
               pevt5(k,j,2) = pang5(k,j,1)
               pevt5(k,j,4) = pang5(k,j,2)
            else
               pevt5(k,j,2) = -pang5(k,j,1)
               pevt5(k,j,4) = -pang5(k,j,2)
            endif
         enddo
      enddo


      do j=1,5
         do k=1,5
            sevt5(j,k,1) = sijang5(j,k,1)
            sevt5(j,k,2) = sijang5(j,k,1)
            sevt5(j,k,3) = sijang5(j,k,2)
            sevt5(j,k,4) = sijang5(j,k,2)
         enddo
         tevt5(1,j,1) = tijang5(1,j,1)
         tevt5(2,j,1) = tijang5(2,j,1)
         tevt5(1,j,3) = tijang5(1,j,2)
         tevt5(2,j,3) = tijang5(2,j,2)
         tevt5(1,j,2) = tijang5(2,j,1)
         tevt5(2,j,2) = tijang5(1,j,1)
         tevt5(1,j,4) = tijang5(2,j,2)
         tevt5(2,j,4) = tijang5(1,j,2)
      enddo
      ievt5(1) = iacc(1)
      ievt5(2) = iacc(1)
      ievt5(3) = iacc(2)
      ievt5(4) = iacc(2)


c---- a few tests here
c      write(6,101) pevt5(1:4,1,1)
c      write(6,102) pevt5(1:4,2,1)
c      write(6,103) pevt5(1:4,3,1)
c      write(6,104) pevt5(1:4,4,1)
c      write(6,105) pevt5(1:4,5,1)
c      write(6,106) pevt5(1:4,6,1)
c      write(6,101) pevt5(1:4,1,4)
c      write(6,102) pevt5(1:4,2,4)
c      write(6,103) pevt5(1:4,3,4)
c      write(6,104) pevt5(1:4,4,4)
c      write(6,105) pevt5(1:4,5,4)
c      write(6,106) pevt5(1:4,6,4)

c      it =2
c
c      s12 = 2d0*dot(pevt5(1,1,it),pevt5(1,2,it))
c      s13 = 2d0*dot(pevt5(1,1,it),pevt5(1,3,it))
c      s23 = 2d0*dot(pevt5(1,2,it),pevt5(1,3,it))
c      s14 = 2d0*dot(pevt5(1,1,it),pevt5(1,4,it))
c      s24 = 2d0*dot(pevt5(1,2,it),pevt5(1,4,it))
c      s34 = 2d0*dot(pevt5(1,3,it),pevt5(1,4,it))
c      ta1 = -pevt5(4,1,it)+pevt5(3,1,it)
c      ta2 = -pevt5(4,2,it)+pevt5(3,2,it)
c      ta3 = -pevt5(4,3,it)+pevt5(3,3,it)
c      ta4 = -pevt5(4,4,it)+pevt5(3,4,it)
c      tb1 = -pevt5(4,1,it)-pevt5(3,1,it)
c      tb2 = -pevt5(4,2,it)-pevt5(3,2,it)
c      tb3 = -pevt5(4,3,it)-pevt5(3,3,it)
c      tb4 = -pevt5(4,4,it)-pevt5(3,4,it)

c      it = it+2
c      write(6,110) ta1/tevt5(1,1,it),ta2/tevt5(1,2,it),ta3/tevt5(1,3,it)
c     .            ,ta4/tevt5(1,4,it)
c      write(6,110) tb1/tevt5(2,1,it),tb2/tevt5(2,2,it),tb3/tevt5(2,3,it)
c     .            ,tb4/tevt5(2,4,it)
c      write(6,110) s12/sevt5(1,2,it),s13/sevt5(1,3,it),s23/sevt5(2,3,it)
c     .            ,s14/sevt5(1,4,it)
c      write(6,111) s24/sevt5(2,4,it),s34/sevt5(3,4,it)

 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 105  format('p5:',4f14.6)
 106  format('p6:',4f14.6)
 110  format(4g18.11)
 111  format(2g18.11)

      return
      end



      subroutine phase6avp(x,wt,ifail)
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),p6(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),p6p(4),pap(4),
     .          p3pp(4),p3app(4),papp(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4),p6ap(4)
      dimension p4a(4),p5a(4),p6a(4)
      dimension p123(4),p456(4),p56p(4),p56(4)
      dimension p456p(4)
      dimension p56a(4),p56ap(4),p5t(4),p6t(4),p5ta(4),p6ta(4)
      dimension pdecay(1:4,1:3)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension parb(4)
      parameter(pi=3.141592653589793238d0)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm123,rg123,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang6/pang6(4,6,4)
!$omp threadprivate(/pmomang6/)
      common/invar6/sij6(6,6),tij6(2,6)
!$omp threadprivate(/invar6/)
      common/invarang6/sijang6(6,6,4),tijang6(2,6,4),iacc(4)
!$omp threadprivate(/invarang6/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase6avp", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=6
      else
         Nphase=24
         wtps=wtps/4d0
      endif


* this is (4;5,6;a)
*
* phase space for 2->6 scattering, a+b -> 1+2+3+4+5+6 with q=p1+p2+p3
* with sequential splitting (456) -> 4+(56) -> 4+5+6
*
* (456) system is rotated with respect to pa axis
* (56)  system is rotated with respect to p3 axis
*
* default momenta             : pang(i,j,1)
* (56) rotated                : pang(i,j,2)
* (456) rotated               : pang(i,j,3)
* (456) rotated, (56) rotated : pang(i,j,4)
*
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      wt = 0d0
      ifail =1


      s123min=y0*s_proc
      s123max=s_proc
c      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
c      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3))-dsqrt(rm2(4)))**2
c     .              ,(1d0-5d0*y0)*shat)
      if (s123min.ge.s123max) return
      if (inwa.eq.0) then
         call pick(1,s123,s123min,s123max,r1,wtps)
      endif
      if (inwa.eq.1) then
         call pickres(s123,s123min,s123max,rm12,rg12,r1,wtps)
      endif
      if (inwa.eq.2) then
         s123 = rm123**2
         wtps = wtps*pi*rm123*rg123
      endif
      if (inwa.eq.3) then
         s123 = rm123**2
         wtps = wtps*pi*(16d0*pi)
      endif
      if(shat.lt.s123) return    ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi


      s456min = dmax1(y0*shat,
     .           (dsqrt(rm2(4))+dsqrt(rm2(5))+dsqrt(rm2(6)))**2)
      s456max = dmin1((dsqrt(shat)-dsqrt(s123))**2,(1d0-y0)*shat)
      if (s456max.le.s456min) return
      call pick(1,s456,s456min,s456max,r2,wtps)
      wtps = wtps/2d0/pi
      s56min = dmax1(y0*shat,(dsqrt(rm2(5))+dsqrt(rm2(6)))**2)
      s56max = dmin1(s456,(1d0-y0)*shat)
      if (s56max.le.s56min) return
*      call pick(1,s56,s56min,s56max,r5,wtps)
*     sample log(s56)
      call pick(2,s56,s56min,s56max,r3,wtps)
      wtps = wtps/2d0/pi

      call p2generic(r4,0d0,shat,0d0,0d0,s123,
     .               s456,p123,p456,pa,pb,wtps)
      if(wtps.eq.0d0) return

      if(p456(4).lt.0d0)then
         ifail = 1
         return
      endif

* TODO: change of variables only works in the massless case.
*       Add a condition s.t. we return to the old calculations
*       for massive partons

***********************************************
*     TM 03/05/2015: switched to sampling
*     rat=sa3/(sa3max-sa3+y0*shat) logarithmically
*     from costh

      costhmin = -1d0
      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi
c      call pick(1,costh,costhmin,costhmax,r7,wtps)
c      call pickcos(costh,y0,r7,wtps)


*     boost pa into the s345 rest frame
      call boostrest(p456,bmat)
      do i=1,4
         v(i) = 0.d0
         pap(i) = 0.d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo

*     rotate pap into the frame
      call rotatetoz(pap,rmat)

      do i=1,4
         parb(i) = 0.d0
         do j=1,4
            do k=1,4
               parb(i) = parb(i) + rmat(i,k)*bmat(k,j)*pa(j)
            enddo
         enddo
      enddo

      bound = 2.d0*(s456+rm2(4)-s56)/sqrt(s456)*parb(4)
      sa4min = y0*shat
      sa4max = min(bound,(1.d0-y0)*shat)
      if(sa4max.le.sa4min) return

*     jacobian for costh -> sa5
      wtps = wtps/(s456+rm2(4)-s56)*sqrt(s456)/parb(4)

*     rat=sa4/(sa4max-sa4+y0*shat)
      ratmin=y0*shat/sa4max
      ratmax=sa4max/(y0*shat)

      call pick(2,rat,ratmin,ratmax,r5,wtps)

      sa4=rat*(sa4max+y0*shat)/(rat+1d0)
*      wtps=wtps*(sa3max-sa3)**2/sa3max

      wtps=wtps*(sa4max-sa4+y0*shat)**2/(sa4max+y0*shat)

      call pick(1,phi,phimin,phimax,r6,wtps)

      costh=-(sa4-(s456-s56)*parb(4)/s456**0.5)/(2d0*parb(4)*((s456-s56)/2d0/s456**0.5))
      call makeps2com(s456,costh,phi,rm2(4),s56,p4p,p56p,p4ap,p56ap)
      wtps = wtps*dsqrt(dlambda(s456,rm2(4),s56))/s456/32d0/pi**2


***********************************************

c---- rotate the (456) system
      call boostrest(p456,bmat)
      call unboostrest(p456,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4(i) = 0d0
         p56(i) = 0d0
         p4a(i) = 0d0
         p56a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p56(i) = p56(i) + fmat(i,j)*p56p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p56a(i) = p56a(i) + fmat(i,j)*p56ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo


***********************************************
*     TM 03/05/2015: switched to sampling rat=sa5/sa4
*     from costh

*     boost pa into the s67 rest frame
      call boostrest(p56,bmat)
      do i=1,4
         v(i) = 0.d0
         pap(i) = 0.d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo

*     rotate pap into the frame
      call rotatetoz(pap,rmat)
      do i=1,4
         parb(i) = 0.d0
         do j=1,4
            do k=1,4
               parb(i) = parb(i) + rmat(i,k)*bmat(k,j)*pa(j)
            enddo
         enddo
      enddo

c      call pick(1,costh,costhmin,costhmax,r9,wtps)
c      sa6min = y0*shat
c      sa6max = 2*s67**0.5*parb(4)-y0*shat
c      call pick(1,sa6,sa6min,sa6max,r9,wtps)

      E2=2*(s56**0.5/2d0)*parb(4)

      wtps = wtps/E2

      ratmin=2*E2/(2*E2-y0*shat) -1d0
      ratmax=2*E2/(y0*shat)-1d0

*     pick the ratio rat=sa5/sa4 logarthmically
      call pick(2,rat,ratmin,ratmax,r7,wtps)

      sa5=2*E2/(rat+1d0)
      sa6=2*E2-sa5

      wtps=wtps*sa5**2/(2*E2)
      costh=-(sa5-2*(s56**0.5)*parb(4)/2d0)/(2*(s56**0.5)*parb(4)/2d0)

      call pick(1,phi,phimin,phimax,r8,wtps)
      call makeps2com(s56,costh,phi,rm2(5),rm2(6),p5p,p6p,p5ap,p6ap)
      wtps = wtps*dsqrt(dlambda(s56,rm2(5),rm2(6)))/s56/32d0/pi**2

***********************************************

c---- rotate the (56) system
      call boostrest(p56,bmat)
      call unboostrest(p56,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p5(i) = 0d0
         p6(i) = 0d0
         p5a(i) = 0d0
         p6a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p6(i) = p6(i) + fmat(i,j)*p6p(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            p6a(i) = p6a(i) + fmat(i,j)*p6ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (56ang) system
      call boostrest(p56a,bmat)
      call unboostrest(p56a,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p5t(i) = 0d0
         p6t(i) = 0d0
         p5ta(i) = 0d0
         p6ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p6t(i) = p6t(i) + fmat(i,j)*p6p(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            p6ta(i) = p6ta(i) + fmat(i,j)*p6ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo


      call decay3(s123,p123,x(9:13),pdecay,wtps,ipass)
      if (ipass.eq.0) return


      do i=1,4
         do j=1,3
            p(i,j) = pdecay(i,j)
            pang6(i,j,1) = p(i,j)
            pang6(i,j,2) = p(i,j)
            pang6(i,j,3) = p(i,j)
            pang6(i,j,4) = p(i,j)
         enddo
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         p(i,6) = p6(i)
         pang6(i,4,1) = p4(i)
         pang6(i,5,1) = p5(i)
         pang6(i,6,1) = p6(i)

         pang6(i,4,2) = p4(i)
         pang6(i,5,2) = p5a(i)
         pang6(i,6,2) = p6a(i)

         pang6(i,4,3) = p4a(i)
         pang6(i,5,3) = p5t(i)
         pang6(i,6,3) = p6t(i)

         pang6(i,4,4) = p4a(i)
         pang6(i,5,4) = p6ta(i)
         pang6(i,6,4) = p6ta(i)
      enddo

      do i=1,4
         call fillinv(6,pang6(1:4,1:6,i),pa,pb,sijang6(1:6,1:6,i)
     .                                        ,tijang6(1:2,1:6,i))
      enddo

      do i=1,4
        call acceptcuts6a(sijang6(1:6,1:6,i),tijang6(1:2,1:6,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo
      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return

      ifail =0
      wt = wtps

c
c      k10 = 1
c      write(6,101) pang5(1:4,1,k10)
c      write(6,102) pang5(1:4,2,k10)
c      write(6,103) pang5(1:4,3,k10)
c      write(6,104) pang5(1:4,4,k10)
c      write(6,105) pang5(1:4,5,k10)
c      write(6,106) pa(1:4)
c      write(6,107) pb(1:4)
c      write(6,109) v1(1:4)
c      write(6,*) q2/dot(q,q)
c

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('p6:',4f14.9)
 107  format('p7:',4f14.9)
 108  format('pa:',4f14.9)
 109  format('pb:',4f14.9)
 110  format('pp:',4f14.9)

      return
      end



      subroutine acceptcuts6a(sij6,tij6,ipass,itechpass)
      implicit real*8(a-h,o-z)
      dimension sij6(1:6,1:6),tij6(1:2,1:6)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0
      itechpass = 0

      sa4 = -tij6(1,4)
      sa5 = -tij6(1,5)
      sa6 = -tij6(1,6)
      sb4 = -tij6(2,4)
      sb5 = -tij6(2,5)
      sb6 = -tij6(2,6)
      s45 =  sij6(4,5)
      s46 =  sij6(4,6)
      s56 =  sij6(5,6)

      if (min(sa4,sa5,sa6,sb4,sb5,sb6).lt.y0*shat) return
      if (min(s45,s46,s56).lt.y0*shat) return

      itechpass = 1

      smin1 = shat
      smin2 = shat

      do i=4,6
         do j=i+1,6
            if (sij6(i,j).lt.smin2) then
               smin2 = sij6(i,j)
               if (smin2.lt.smin1) then
                  stmp  = smin1
                  smin1 = smin2
                  smin2 = stmp
               endif
            endif
         enddo
         if (-tij6(1,i).lt.smin2) then
            smin2 = -tij6(1,i)
            if (smin2.lt.smin1) then
               stmp  = smin1
               smin1 = smin2
               smin2 = stmp
            endif
         endif
         if (-tij6(2,i).lt.smin2) then
            smin2 = -tij6(2,i)
            if (smin2.lt.smin1) then
               stmp  = smin1
               smin1 = smin2
               smin2 = stmp
            endif
         endif
      enddo

c---- these are the new selection cuts for phase6a
      if (smin1.eq.s56.and.smin2.eq.sa5) ipass=1
      if (smin2.eq.s56.and.smin1.eq.sa5) ipass=1
      if (smin1.eq.s56.and.smin2.eq.sa6) ipass=1
      if (smin2.eq.s56.and.smin1.eq.sa6) ipass=1
      if (smin1.eq.s56.and.smin2.eq.min(s45,s46)) then
         if ((sa5+sa6).lt.(sb5+sb6)) ipass=1
      endif
      if (smin1.eq.sa5.and.smin2.eq.sa6) ipass=1
      if (smin2.eq.sa5.and.smin1.eq.sa6) ipass=1

      return
      end




      subroutine fillcommon6apvp
      implicit real*8(a-h,o-z)
      common/pmomang6/pang6(4,6,4)
!$omp threadprivate(/pmomang6/)
      common/invarang6/sijang6(6,6,4),tijang6(2,6,4),iacc(4)
!$omp threadprivate(/invarang6/)
      common/eventmom6ap/pevt6a(4,6,24)
!$omp threadprivate(/eventmom6ap/)
      common/eventinv6ap/sevt6a(6,6,24),tevt6a(2,6,24),ievt6a(24)
!$omp threadprivate(/eventinv6ap/)
      dimension i1(1:6,1:3)

      data i1/1,2,3,4,5,6,
     .        1,2,3,6,4,5,
     .        1,2,3,5,6,4/
c---- pang6 and sijang are input and correspond to an event in (4;5,6;a)
c---- this subroutine fills
c----       pevt6a(ievent,component,pnum)            : 4-momenta of events
c----       sevt6a(i,j,ievent),tevt6a([ab],i,ievent) : invariants of events
c----
c----  1: (4;56;a)
c----  2: (4;56;b)
c----  3: (6;45;a)
c----  4: (6;45;b)
c----  5: (5;64;a)
c----  6: (5;64;b)

c----  7-12: with (56) system rotated
c---- 13-18: with (456) system rotated
c---- 19-24: with (56) and (456) system rotated

c---- full phave space coverage is obtained by summing ievent=1..6
c---- angular average is obtained by averaging:
c----        M2 = 1/4* ( sum_ievent=1..24   M2(ievent))
c----

      do i=1,3
         do j=1,6
            do k=1,4
               pevt6a(k,i1(j,i),2*i-1)   = pang6(k,j,1)
               pevt6a(k,i1(j,i),2*i+5)   = pang6(k,j,2)
               pevt6a(k,i1(j,i),2*i+11)  = pang6(k,j,3)
               pevt6a(k,i1(j,i),2*i+17)  = pang6(k,j,4)
               if (k.ne.3) then
                  pevt6a(k,i1(j,i),2*i)     = pang6(k,j,1)
                  pevt6a(k,i1(j,i),2*i+6)   = pang6(k,j,2)
                  pevt6a(k,i1(j,i),2*i+12)  = pang6(k,j,3)
                  pevt6a(k,i1(j,i),2*i+18)  = pang6(k,j,4)
               else
                  pevt6a(k,i1(j,i),2*i)     = -pang6(k,j,1)
                  pevt6a(k,i1(j,i),2*i+6)   = -pang6(k,j,2)
                  pevt6a(k,i1(j,i),2*i+12)  = -pang6(k,j,3)
                  pevt6a(k,i1(j,i),2*i+18)  = -pang6(k,j,4)
               endif
            enddo
         enddo
      enddo

      do i=1,3
c         do j=1,6
c            do k=1,6
c               sevt6a(i1(j,i),i1(k,i),2*i-1)  = sijang6(j,k,1)
c               sevt6a(i1(j,i),i1(k,i),2*i+5)  = sijang6(j,k,2)
c               sevt6a(i1(j,i),i1(k,i),2*i+11) = sijang6(j,k,3)
c               sevt6a(i1(j,i),i1(k,i),2*i+17) = sijang6(j,k,4)
c               sevt6a(i1(j,i),i1(k,i),2*i)    = sijang6(j,k,1)
c               sevt6a(i1(j,i),i1(k,i),2*i+6)  = sijang6(j,k,2)
c               sevt6a(i1(j,i),i1(k,i),2*i+12) = sijang6(j,k,3)
c               sevt6a(i1(j,i),i1(k,i),2*i+18) = sijang6(j,k,4)
c            enddo
c            tevt6a(1,i1(j,i),2*i-1)  = tijang6(1,j,1)
c            tevt6a(2,i1(j,i),2*i-1)  = tijang6(2,j,1)
c            tevt6a(1,i1(j,i),2*i+5)  = tijang6(1,j,2)
c            tevt6a(2,i1(j,i),2*i+5)  = tijang6(2,j,2)
c            tevt6a(1,i1(j,i),2*i+11) = tijang6(1,j,3)
c            tevt6a(2,i1(j,i),2*i+11) = tijang6(2,j,3)
c            tevt6a(1,i1(j,i),2*i+17) = tijang6(1,j,4)
c            tevt6a(2,i1(j,i),2*i+17) = tijang6(2,j,4)
c            tevt6a(1,i1(j,i),2*i)    = tijang6(2,j,1)
c            tevt6a(2,i1(j,i),2*i)    = tijang6(1,j,1)
c            tevt6a(1,i1(j,i),2*i+6)  = tijang6(2,j,2)
c            tevt6a(2,i1(j,i),2*i+6)  = tijang6(1,j,2)
c            tevt6a(1,i1(j,i),2*i+12) = tijang6(2,j,3)
c            tevt6a(2,i1(j,i),2*i+12) = tijang6(1,j,3)
c            tevt6a(1,i1(j,i),2*i+18) = tijang6(2,j,4)
c            tevt6a(2,i1(j,i),2*i+18) = tijang6Z(1,j,4)
c         enddo
         ievt6a(2*i-1)  = iacc(1)
         ievt6a(2*i)    = iacc(1)
         ievt6a(2*i+5)  = iacc(2)
         ievt6a(2*i+6)  = iacc(2)
         ievt6a(2*i+11) = iacc(3)
         ievt6a(2*i+12) = iacc(3)
         ievt6a(2*i+17) = iacc(4)
         ievt6a(2*i+18) = iacc(4)
      enddo


 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 107  format(4g18.13)
 108  format(3g18.13)


      return
      end




      subroutine phase6bvp(x,wt,ifail)
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),p6(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),p6p(4),pap(4),
     .          pbp(4),pbap(4)
      dimension parb(4),pbrb(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4),p6ap(4)
      dimension p3a(4),p4a(4),p5a(4),p6a(4)
      dimension p123(4),p456(4),p56p(4),p56(4)
      dimension p456p(4)
      dimension p56a(4),p56ap(4),p5t(4),p6t(4),p5ta(4),p6ta(4)
      dimension pdecay(1:4,1:3)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      parameter(pi=3.141592653589793238d0)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm123,rg123,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang6/pang6(4,6,4)
!$omp threadprivate(/pmomang6/)
      common/invar6/sij6(6,6),tij6(2,6)
!$omp threadprivate(/invar6/)
      common/invarang6/sijang6(6,6,4),tijang6(2,6,4),iacc(4)
!$omp threadprivate(/invarang6/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase6bvp", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase = 6
      else
         Nphase = 24
         wtps=wtps/4d0
      endif


* this is (4;a;5,6;b)
*
* phase space for 2->6 scattering, a+b -> 1+2+3+4+5+6 with q=p1+p2+p3
* with sequential splitting (456) -> 4+(56) -> 4+5+6
*
* (456) system is rotated with respect to pa axis
* (56)  system is rotated with respect to pb axis
*
* default momenta             : pang(i,j,1)
* (56) rotated                : pang(i,j,2)
* (456) rotated               : pang(i,j,3)
* (456) rotated, (56) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      wt = 0d0
      ifail =1


      s123min=y0*s_proc
      s123max=s_proc
c      s123min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
c      s123max = dmin1((dsqrt(shat)-dsqrt(rm2(3))-dsqrt(rm2(4)))**2
c     .              ,(1d0-5d0*y0)*shat)
      if (s123min.ge.s123max) return
      if (inwa.eq.0) then
         call pick(1,s123,s124min,s123max,r1,wtps)
      endif
      if (inwa.eq.1) then
         call pickres(s123,s123min,s123max,rm123,rg1234,r1,wtps)
      endif
      if (inwa.eq.2) then
         s123 = rm123**2
         wtps = wtps*pi*rm123*rg123
      endif
      if (inwa.eq.3) then
         s123 = rm123**2
         wtps = wtps*pi*(16d0*pi)
      endif
      if(shat.lt.s123) return ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi


      s456min = dmax1(y0*shat,
     .           (dsqrt(rm2(4))+dsqrt(rm2(5))+dsqrt(rm2(6)))**2)
      s456max = dmin1((dsqrt(shat)-dsqrt(s123))**2,(1d0-y0)*shat)
      if (s456max.le.s456min) return
      call pick(1,s456,s456min,s456max,r2,wtps)
      wtps = wtps/2d0/pi
      s56min = dmax1(y0*shat,(dsqrt(rm2(5))+dsqrt(rm2(6)))**2)
      s56max = dmin1(s456,(1d0-y0)*shat)
      if (s56max.le.s56min) return
      call pick(2,s56,s56min,s56max,r3,wtps)
      wtps = wtps/2d0/pi

      call p2generic(r4,0d0,shat,0d0,0d0,s123,
     .               s456,p123,p456,pa,pb,wtps)
      if(wtps.eq.0d0) return

      if(p456(4).lt.0d0)then
         ifail = 1
         return
      endif

* TODO: change of variables only works in the massless case.
*       Add a condition s.t. we return to the old calculations
*       for massive partons

***********************************************
*     TM 03/05/2015: switched to sampling sa5
*     from costh

c      costhmin = -1d0
c      costhmax = 1d0
      phimin = 0d0
      phimax = 2d0*pi
c      call pick(1,costh,costhmin,costhmax,r7,wtps)

      call boostrest(p456,bmat)
      do i=1,4
         v(i) = 0.d0
         pap(i) = 0.d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo

      call rotatetoz(pap,rmat)

      do i=1,4
         parb(i) = 0.d0
         do j=1,4
            do k=1,4
               parb(i) = parb(i) + rmat(i,k)*bmat(k,j)*pa(j)
            enddo
         enddo
      enddo

      bound = 2.d0*(s456+rm2(4)-s56)/sqrt(s456)*parb(4)
      sa4min = y0*shat
      sa4max = min(bound,(1.d0-y0)*shat)

      wtps = wtps/(s456+rm2(4)-s56)*sqrt(s456)/parb(4)
      if(sa4max.le.sa4min) return

      call pick(2,sa4,sa4min,sa4max,r5,wtps)
      call pick(1,phi,phimin,phimax,r6,wtps)

      costh=-(sa4-(s456-s56)*parb(4)/s456**0.5)/(2d0*parb(4)*((s456-s56)/2d0/s456**0.5))

      call makeps2com(s456,costh,phi,rm2(4),s56,p4p,p56p,p4ap,p56ap)
      wtps = wtps*dsqrt(dlambda(s456,rm2(4),s56))/s456/32d0/pi**2

***********************************************

c---- rotate the (456) system
      call boostrest(p456,bmat)
      call unboostrest(p456,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4(i) = 0d0
         p56(i) = 0d0
         p4a(i) = 0d0
         p56a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p56(i) = p56(i) + fmat(i,j)*p56p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p56a(i) = p56a(i) + fmat(i,j)*p56ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

***********************************************
*     TM 03/05/2015: switched to sampling rat=sb5/sb4
*     from costh

*     boost pb into the s67 rest frame
      call boostrest(p56,bmat)
      do i=1,4
         v(i) = 0.d0
         pbp(i) = 0.d0
         do j=1,4
            pbp(i) = pbp(i) + bmat(i,j)*pb(j)
         enddo
      enddo

*     rotate pbp into the frame
      call rotatetoz(pbp,rmat)
      do i=1,4
         pbrb(i) = 0.d0
         do j=1,4
            do k=1,4
               pbrb(i) = pbrb(i) + rmat(i,k)*bmat(k,j)*pb(j)
            enddo
         enddo
      enddo

      E2=2*(s56**0.5/2d0)*pbrb(4)
      wtps = wtps/E2

      ratmin=2*E2/(2*E2-y0*shat) -1d0
      ratmax=2*E2/(y0*shat)-1d0

*     pick the ratio rat=sb5/sb4 logarthmically
      call pick(2,rat,ratmin,ratmax,r7,wtps)

      sb5=2*E2/(rat+1d0)
      sb6=2*E2-sb5

      wtps=wtps*sb5**2/(2*E2)
      costh=-(sb5-2*(s56**0.5)*pbrb(4)/2d0)/(2*(s56**0.5)*pbrb(4)/2d0)

      call pick(1,phi,phimin,phimax,r8,wtps)
      call makeps2com(s56,costh,phi,rm2(5),rm2(6),p5p,p6p,p5ap,p6ap)
      wtps = wtps*dsqrt(dlambda(s56,rm2(5),rm2(6)))/s56/32d0/pi**2



c---- rotate the (56) system
      call boostrest(p56,bmat)
      call unboostrest(p56,ubmat)
      do i=1,4
         v(i) = 0d0
         pbp(i) = 0d0
         do j=1,4
            pbp(i) = pbp(i) + bmat(i,j)*pb(j)
         enddo
      enddo
      call unrotatetoz(pbp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p5(i) = 0d0
         p6(i) = 0d0
         p5a(i) = 0d0
         p6a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p6(i) = p6(i) + fmat(i,j)*p6p(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            p6a(i) = p6a(i) + fmat(i,j)*p6ap(j)
            v(i) = v(i) + fmat(i,j)*pbp(j)
         enddo
      enddo

c      write(6,107) v(1:4)

c---- rotate the (56ang) system
      call boostrest(p56a,bmat)
      call unboostrest(p56a,ubmat)
      do i=1,4
         v(i) = 0d0
         pbap(i) = 0d0
         do j=1,4
            pbap(i) = pbap(i) + bmat(i,j)*pb(j)
         enddo
      enddo
      call unrotatetoz(pbap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p5t(i) = 0d0
         p6t(i) = 0d0
         p5ta(i) = 0d0
         p6ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p6t(i) = p6t(i) + fmat(i,j)*p6p(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            p6ta(i) = p6ta(i) + fmat(i,j)*p6ap(j)
            v(i) = v(i) + fmat(i,j)*pbap(j)
         enddo
      enddo


      call decay3(s123,p123,x(9:13),pdecay,wtps,ipass)
      if (ipass.eq.0) return


      do i=1,4
         do j=1,3
            p(i,j) = pdecay(i,j)
            pang6(i,j,1) = p(i,j)
            pang6(i,j,2) = p(i,j)
            pang6(i,j,3) = p(i,j)
            pang6(i,j,4) = p(i,j)
         enddo
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         p(i,6) = p6(i)
         pang6(i,4,1) = p4(i)
         pang6(i,5,1) = p5(i)
         pang6(i,6,1) = p6(i)

         pang6(i,4,2) = p4(i)
         pang6(i,5,2) = p5a(i)
         pang6(i,6,2) = p6a(i)

         pang6(i,4,3) = p4a(i)
         pang6(i,5,3) = p5t(i)
         pang6(i,6,3) = p6t(i)

         pang6(i,4,4) = p4a(i)
         pang6(i,5,4) = p5ta(i)
         pang6(i,6,4) = p6ta(i)
      enddo


      do i=1,4
         call fillinv(6,pang6(1:4,1:6,i),pa,pb,sijang6(1:6,1:6,i)
     .                                        ,tijang6(1:2,1:6,i))
      enddo
      do i=1,4
        call acceptcuts6b(sijang6(1:6,1:6,i),tijang6(1:2,1:6,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo

      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return


      ifail =0
      wt = wtps

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end



      subroutine acceptcuts6b(sij6,tij6,ipass,itechpass)
      implicit real*8(a-h,o-z)
      dimension sij6(1:6,1:6),tij6(1:2,1:6)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0

      ipass = 0
      itechpass=0

      sa4 = -tij6(1,4)
      sa5 = -tij6(1,5)
      sa6 = -tij6(1,6)
      sb4 = -tij6(2,4)
      sb5 = -tij6(2,5)
      sb6 = -tij6(2,6)
      s45 =  sij6(4,5)
      s46 =  sij6(4,6)
      s56 =  sij6(5,6)

      if (min(sa4,sa5,sa6,sb4,sb5,sb6).lt.y0*shat) return
      if (min(s45,s46,s56).lt.y0*shat) return

      itechpass=1

      smin1 = shat
      smin2 = shat

      do i=4,6
         do j=i+1,6
            if (sij6(i,j).lt.smin2) then
               smin2 = sij6(i,j)
               if (smin2.lt.smin1) then
                  stmp  = smin1
                  smin1 = smin2
                  smin2 = stmp
               endif
            endif
         enddo
         if (-tij6(1,i).lt.smin2) then
            smin2 = -tij6(1,i)
            if (smin2.lt.smin1) then
               stmp  = smin1
               smin1 = smin2
               smin2 = stmp
            endif
         endif
         if (-tij6(2,i).lt.smin2) then
            smin2 = -tij6(2,i)
            if (smin2.lt.smin1) then
               stmp  = smin1
               smin1 = smin2
               smin2 = stmp
            endif
         endif
      enddo

c---- these are the new selection cuts for phase7b
      if (smin1.eq.sa4.and.smin2.eq.min(sb4,sb5,sb6)) ipass=1
      if (smin1.eq.s56.and.smin2.eq.sa4) ipass=1
      if (smin2.eq.s56.and.smin1.eq.sa4) ipass=1

      return
      end


      subroutine fillcommon6bpvp
      implicit real*8(a-h,o-z)
      common/pmomang6/pang6(4,6,4)
!$omp threadprivate(/pmomang6/)
      common/invarang6/sijang6(6,6,4),tijang6(2,6,4),iacc(4)
!$omp threadprivate(/invarang6/)
      common/eventmom6bp/pevt6b(4,6,24)
!$omp threadprivate(/eventmom6bp/)
      common/eventinv6bp/sevt6b(6,6,24),tevt6b(2,6,24),ievt6b(24)
!$omp threadprivate(/eventinv6bp/)
      dimension i1(1:6,1:3)

      data i1/1,2,3,4,5,6,
     .        1,2,3,6,4,5,
     .        1,2,3,5,6,4/
c---- pang6 and sijang are input and correspond to an event in (4;a;5,6;b)
c---- this subroutine fills
c----       pevt6a(ievent,component,pnum)            : 4-momenta of events
c----       sevt6a(i,j,ievent),tevt5a([ab],i,ievent) : invariants of events
c----
c----  1: (4;a;56;b)
c----  2: (4;b;56;a)
c----  3: (6;a;45;b)
c----  4: (6;b;45;a)
c----  5: (5;a;64;b)
c----  6: (5;b;64;a)

c----  7-12: with (56) system rotated
c---- 13-18: with (456) system rotated
c---- 19-24: with (56) and (456) system rotated

c---- full phave space coverage is obtained by summing ievent=1..6
c---- angular average is obtained by averaging:
c----        M2 = 1/4* ( sum_ievent=1..24   M2(ievent))
c----

      do i=1,3
         do j=1,6
            do k=1,4
               pevt6b(k,i1(j,i),2*i-1)   = pang6(k,j,1)
               pevt6b(k,i1(j,i),2*i+5)   = pang6(k,j,2)
               pevt6b(k,i1(j,i),2*i+11)  = pang6(k,j,3)
               pevt6b(k,i1(j,i),2*i+17)  = pang6(k,j,4)
               if (k.ne.3) then
                  pevt6b(k,i1(j,i),2*i)     = pang6(k,j,1)
                  pevt6b(k,i1(j,i),2*i+6)   = pang6(k,j,2)
                  pevt6b(k,i1(j,i),2*i+12)  = pang6(k,j,3)
                  pevt6b(k,i1(j,i),2*i+18)  = pang6(k,j,4)
               else
                  pevt6b(k,i1(j,i),2*i)     = -pang6(k,j,1)
                  pevt6b(k,i1(j,i),2*i+6)   = -pang6(k,j,2)
                  pevt6b(k,i1(j,i),2*i+12)  = -pang6(k,j,3)
                  pevt6b(k,i1(j,i),2*i+18)  = -pang6(k,j,4)
               endif
            enddo
         enddo
      enddo

      do i=1,3
c         do j=1,6
c            do k=1,6
c               sevt6b(i1(j,i),i1(k,i),2*i-1)  = sijang6(j,k,1)
c               sevt6b(i1(j,i),i1(k,i),2*i+5)  = sijang6(j,k,2)
c               sevt6b(i1(j,i),i1(k,i),2*i+11) = sijang6(j,k,3)
c               sevt6b(i1(j,i),i1(k,i),2*i+17) = sijang6(j,k,4)
c               sevt6b(i1(j,i),i1(k,i),2*i)    = sijang6(j,k,1)
c               sevt6b(i1(j,i),i1(k,i),2*i+6)  = sijang6(j,k,2)
c               sevt6b(i1(j,i),i1(k,i),2*i+12) = sijang6(j,k,3)
c               sevt6b(i1(j,i),i1(k,i),2*i+18) = sijang6(j,k,4)
c            enddo
c            tevt6b(1,i1(j,i),2*i-1)  = tijang6(1,j,1)
c            tevt6b(2,i1(j,i),2*i-1)  = tijang6(2,j,1)
c            tevt6b(1,i1(j,i),2*i+5)  = tijang6(1,j,2)
c            tevt6b(2,i1(j,i),2*i+5)  = tijang6(2,j,2)
c            tevt6b(1,i1(j,i),2*i+11) = tijang6(1,j,3)
c            tevt6b(2,i1(j,i),2*i+11) = tijang6(2,j,3)
c            tevt6b(1,i1(j,i),2*i+17) = tijang6(1,j,4)
c            tevt6b(2,i1(j,i),2*i+17) = tijang6(2,j,4)
c            tevt6b(1,i1(j,i),2*i)    = tijang6(2,j,1)
c            tevt6b(2,i1(j,i),2*i)    = tijang6(1,j,1)
c            tevt6b(1,i1(j,i),2*i+6)  = tijang6(2,j,2)
c            tevt6b(2,i1(j,i),2*i+6)  = tijang6(1,j,2)
c            tevt6b(1,i1(j,i),2*i+12) = tijang6(2,j,3)
c            tevt6b(2,i1(j,i),2*i+12) = tijang6(1,j,3)
c            tevt6b(1,i1(j,i),2*i+18) = tijang6(2,j,4)
c            tevt6b(2,i1(j,i),2*i+18) = tijang6(1,j,4)
c         enddo
         ievt6b(i)    = iacc(1)
         ievt6b(i+3)  = iacc(1)
         ievt6b(i+6)  = iacc(2)
         ievt6b(i+9)  = iacc(2)
         ievt6b(i+12) = iacc(3)
         ievt6b(i+15) = iacc(3)
         ievt6b(i+18) = iacc(4)
         ievt6b(i+21) = iacc(4)
      enddo


 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 107  format(4g18.13)
 108  format(3g18.13)


      return
      end




      subroutine phase6allvp(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),p6(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),p6p(4),pap(4),
     .          p3pp(4),p3app(4),papp(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4),p6ap(4)
      dimension p4a(4),p5a(4),p6a(4)
      dimension p123(4),p456(4),p56p(4),p56(4)
      dimension p456p(4)
      dimension p56a(4),p56ap(4),p5t(4),p6t(4),p5ta(4),p6ta(4)
      dimension pdecay(1:4,1:4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension parb(4)
      double precision p5pp(4),p6pp(4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm123,rg123,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang6/pang6(4,6,4)
!$omp threadprivate(/pmomang6/)
      common/invar6/sij6(6,6),tij6(2,6)
!$omp threadprivate(/invar6/)
      common/invarang6/sijang6(6,6,4),tijang6(2,6,4),iacc(4)
!$omp threadprivate(/invarang6/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase6allvp", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=6
      else
         Nphase=24
         wtps=wtps/4d0
      endif


* this is (4;5,6;a)
*
* phase space for 2->6 scattering, a+b -> 1+2+3+4+5+6 with q=p1+p2+p3
* with sequential splitting (456) -> 4+(56) -> 4+5+6
*
* (456) system is rotated with respect to pa axis
* (56)  system is rotated with respect to pa axis
*
* default momenta             : pang(i,j,1)
* (56) rotated                : pang(i,j,2)
* (456) rotated               : pang(i,j,3)
* (456) rotated, (56) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      wt = 0d0
      ifail =1


      s123min=y0*s_proc
      s123max=s_proc
      if (s123min.ge.s123max) return
      call pick_sinv_generic(s123,s123min,s123max,rm123,rg123,r1,wtps,inwa)

      if(shat.lt.s123) return    ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi


      s456min = dmax1(y0*shat,
     .           (dsqrt(rm2(4))+dsqrt(rm2(5))+dsqrt(rm2(6)))**2)
      s456max = dmin1((dsqrt(shat)-dsqrt(s123))**2,(1d0-y0)*shat)
      if (s456max.le.s456min) return
      call pick(1,s456,s456min,s456max,r2,wtps)
      wtps = wtps/2d0/pi
      s56min = dmax1(y0*shat,(dsqrt(rm2(5))+dsqrt(rm2(6)))**2)
      s56max = dmin1(s456,(1d0-y0)*shat)
      if (s56max.le.s56min) return
*      call pick(1,s45,s45min,s45max,r5,wtps)
*     sample log(s45)
      call pick(2,s56,s56min,s56max,r3,wtps)
      wtps = wtps/2d0/pi

      call p2generic_alt(2,r4,0d0,shat,0d0,0d0,s123,s456,
     .                   p123,p456,pa,pb,wtps)
      if(wtps.eq.0d0) return

      if(p456(4).lt.0d0)then
          ifail = 1
          return
      endif

* TODO: change of variables only works in the massless case.
*       Add a condition s.t. we return to the old calculations
*       for massive partons

      costhmin = -1d0
      costhmax = 1d0
      call pickcos(costh,y0,r5,wtps)

      call pick(1,phi,0d0,twopi,r6,wtps)
      call makeps2com(s456,costh,phi,rm2(4),s56,p4p,p56p,p4ap,p56ap)
      wtps = wtps*dsqrt(dlambda(s456,rm2(4),s56))/s456/32d0/pi**2

***********************************************

c---- rotate the (456) system
      call boostrest(p456,bmat)
      call unboostrest(p456,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4(i) = 0d0
         p56(i) = 0d0
         p4a(i) = 0d0
         p56a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p56(i) = p56(i) + fmat(i,j)*p56p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p56a(i) = p56a(i) + fmat(i,j)*p56ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      call pickcos_alt(costh,r7,wtps)
*      call pickcos(costh,y0,r9,wtps)

      call pick(1,phi,0d0,twopi,r8,wtps)
      call makeps2com(s56,costh,phi,rm2(5),rm2(6),p5p,p6p,p5ap,p6ap)
      wtps = wtps*dsqrt(dlambda(s56,rm2(5),rm2(6)))/s56/32d0/pi**2

***********************************************


c---- rotate the (56) system
      call boostrest(p56,bmat)
      call unboostrest(p56,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p5(i) = 0d0
         p6(i) = 0d0
         p5a(i) = 0d0
         p6a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p6(i) = p6(i) + fmat(i,j)*p6p(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            p6a(i) = p6a(i) + fmat(i,j)*p6ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (56ang) system
      call boostrest(p56a,bmat)
      call unboostrest(p56a,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p5t(i) = 0d0
         p6t(i) = 0d0
         p5ta(i) = 0d0
         p6ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p6t(i) = p6t(i) + fmat(i,j)*p6p(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            p6ta(i) = p6ta(i) + fmat(i,j)*p6ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      call decay3(s123,p123,x(9:13),pdecay,wtps,ipass)
      if (ipass.eq.0) return

      do i=1,4
         do j=1,4
           p(i,j) = pdecay(i,j)
           pang6(i,j,1) = p(i,j)
           pang6(i,j,2) = p(i,j)
           pang6(i,j,3) = p(i,j)
           pang6(i,j,4) = p(i,j)
         enddo
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         p(i,6) = p6(i)
         pang6(i,4,1) = p4(i)
         pang6(i,5,1) = p5(i)
         pang6(i,6,1) = p6(i)

         pang6(i,4,2) = p4(i)
         pang6(i,5,2) = p5a(i)
         pang6(i,6,2) = p6a(i)

         pang6(i,4,3) = p4a(i)
         pang6(i,5,3) = p5t(i)
         pang6(i,6,3) = p6t(i)

         pang6(i,4,4) = p4a(i)
         pang6(i,5,4) = p5ta(i)
         pang6(i,6,4) = p6ta(i)
      enddo

      do i=1,4
         call fillinv(6,pang6(1:4,1:6,i),pa,pb,sijang6(1:6,1:6,i)
     .                                        ,tijang6(1:2,1:6,i))
      enddo

      do i=1,4
        call acceptcuts6all(sijang6(1:6,1:6,i),tijang6(1:2,1:6,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo
      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return

      ifail =0
      wt = wtps


c
c      k10 = 1
c      write(6,101) pang5(1:4,1,k10)
c      write(6,102) pang5(1:4,2,k10)
c      write(6,103) pang5(1:4,3,k10)
c      write(6,104) pang5(1:4,4,k10)
c      write(6,105) pang5(1:4,5,k10)
c      write(6,106) pa(1:4)
c      write(6,107) pb(1:4)
c      write(6,109) v1(1:4)
c      write(6,*) q2/dot(q,q)
c

  101  format('p1:',4f14.9)
  102  format('p2:',4f14.9)
  103  format('p3:',4f14.9)
  104  format('p4:',4f14.9)
  105  format('p5:',4f14.9)
  106  format('p6:',4f14.9)
  107  format('p7:',4f14.9)
  108  format('pa:',4f14.9)
  109  format('pb:',4f14.9)
  110  format('pp:',4f14.9)

      return
      end


      subroutine acceptcuts6all(sij6,tij6,ipass,itechpass)
      implicit real*8(a-h,o-z)
      dimension sij6(1:6,1:6),tij6(1:2,1:6)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /tcuts/ymin,y0
      integer ipassIF, ipassFF

      ipass = 0
      itechpass = 0
      ipassIF = 0
      ipassFF = 0

      sa4 = -tij6(1,4)
      sa5 = -tij6(1,5)
      sa6 = -tij6(1,6)
      sb4 = -tij6(2,4)
      sb5 = -tij6(2,5)
      sb6 = -tij6(2,6)
      s45 =  sij6(4,5)
      s46 =  sij6(4,6)
      s56 =  sij6(5,6)

      if (min(sa4,sa5,sa6,sb4,sb5,sb6).lt.y0*shat) return
      if (min(s45,s46,s56).lt.y0*shat) return

      itechpass = 1

* single out on 4||a, 5||a, 6||a
      rinvmina = min(sa4,sa5,sa6)
      rinvminb = min(sb4,sb5,sb6)
      if (rinvmina.lt.rinvminb) ipassIF=1

* single out on 5||6
      rinvmin  = min(s45,s46,s56)
      if (rinvmin.eq.s56) ipassFF=1

      if ((ipassIF.eq.1).and.(ipassFF.eq.1)) ipass=1

      return
      end





      subroutine fillcommon6allpvp
*XC based on fillcommon5aph and duplicated for further upgrade
      implicit real*8(a-h,o-z)
      common/pmomang6/pang6(4,6,4)
!$omp threadprivate(/pmomang6/)
      common/invarang6/sijang6(6,6,4),tijang6(2,6,4),iacc(4)
!$omp threadprivate(/invarang6/)
      common/eventmom6allp/pevt6all(4,6,48)
!$omp threadprivate(/eventmom6allp/)
      common/eventinv6allp/sevt6all(6,6,48),tevt6all(2,6,48),ievt6all(48)
!$omp threadprivate(/eventinv6allp/)
      dimension i1(1:6,1:3)

      data i1/1,2,3,4,5,6,
     .        1,2,3,6,4,5,
     .        1,2,3,5,6,4/
c---- pang6 and sijang are input and correspond to an event in (4;5,6;a)
c---- this subroutine fills
c----       pevt6all(ievent,component,pnum)            : 4-momenta of events
c----       sevt6all(i,j,ievent),tevt7all([ab],i,ievent) : invariants of events
c----
c----  1: (4;56;a)
c----  2: (4;56;b)
c----  3: (6;45;a)
c----  4: (6;45;b)
c----  5: (5;64;a)
c----  6: (5;64;b)

c----  7-12: with (56) system rotated
c---- 13-18: with (456) system rotated
c---- 19-24: with (56) and (456) system rotated

c---- full phase space coverage is obtained by summing ievent=1..6
c---- angular average is obtained by averaging:
c----        M2 = 1/4* ( sum_ievent=1..24   M2(ievent))
c----

      do i=1,3
         do j=1,6
            do k=1,4
               pevt6all(k,i1(j,i),2*i-1)   = pang6(k,j,1)
               pevt6all(k,i1(j,i),2*i+5)   = pang6(k,j,2)
               pevt6all(k,i1(j,i),2*i+11)  = pang6(k,j,3)
               pevt6all(k,i1(j,i),2*i+17)  = pang6(k,j,4)
               if (k.ne.3) then
                  pevt6all(k,i1(j,i),2*i)     = pang6(k,j,1)
                  pevt6all(k,i1(j,i),2*i+6)   = pang6(k,j,2)
                  pevt6all(k,i1(j,i),2*i+12)  = pang6(k,j,3)
                  pevt6all(k,i1(j,i),2*i+18)  = pang6(k,j,4)
               else
                  pevt6all(k,i1(j,i),2*i)     = -pang6(k,j,1)
                  pevt6all(k,i1(j,i),2*i+6)   = -pang6(k,j,2)
                  pevt6all(k,i1(j,i),2*i+12)  = -pang6(k,j,3)
                  pevt6all(k,i1(j,i),2*i+18)  = -pang6(k,j,4)
               endif
            enddo
         enddo
      enddo

      do i=1,3
         do j=1,6
            do k=1,6
               sevt6all(i1(j,i),i1(k,i),2*i-1)  = sijang6(j,k,1)
               sevt6all(i1(j,i),i1(k,i),2*i+5)  = sijang6(j,k,2)
               sevt6all(i1(j,i),i1(k,i),2*i+11) = sijang6(j,k,3)
               sevt6all(i1(j,i),i1(k,i),2*i+17) = sijang6(j,k,4)
               sevt6all(i1(j,i),i1(k,i),2*i)    = sijang6(j,k,1)
               sevt6all(i1(j,i),i1(k,i),2*i+6)  = sijang6(j,k,2)
               sevt6all(i1(j,i),i1(k,i),2*i+12) = sijang6(j,k,3)
               sevt6all(i1(j,i),i1(k,i),2*i+18) = sijang6(j,k,4)
            enddo
            tevt6all(1,i1(j,i),2*i-1)  = tijang6(1,j,1)
            tevt6all(2,i1(j,i),2*i-1)  = tijang6(2,j,1)
            tevt6all(1,i1(j,i),2*i+5)  = tijang6(1,j,2)
            tevt6all(2,i1(j,i),2*i+5)  = tijang6(2,j,2)
            tevt6all(1,i1(j,i),2*i+11) = tijang6(1,j,3)
            tevt6all(2,i1(j,i),2*i+11) = tijang6(2,j,3)
            tevt6all(1,i1(j,i),2*i+17) = tijang6(1,j,4)
            tevt6all(2,i1(j,i),2*i+17) = tijang6(2,j,4)
            tevt6all(1,i1(j,i),2*i)    = tijang6(2,j,1)
            tevt6all(2,i1(j,i),2*i)    = tijang6(1,j,1)
            tevt6all(1,i1(j,i),2*i+6)  = tijang6(2,j,2)
            tevt6all(2,i1(j,i),2*i+6)  = tijang6(1,j,2)
            tevt6all(1,i1(j,i),2*i+12) = tijang6(2,j,3)
            tevt6all(2,i1(j,i),2*i+12) = tijang6(1,j,3)
            tevt6all(1,i1(j,i),2*i+18) = tijang6(2,j,4)
            tevt6all(2,i1(j,i),2*i+18) = tijang6(1,j,4)
         enddo
         ievt6all(2*i-1)  = iacc(1)
         ievt6all(2*i)    = iacc(1)
         ievt6all(2*i+5)  = iacc(2)
         ievt6all(2*i+6)  = iacc(2)
         ievt6all(2*i+11) = iacc(3)
         ievt6all(2*i+12) = iacc(3)
         ievt6all(2*i+17) = iacc(4)
         ievt6all(2*i+18) = iacc(4)
      enddo


 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 104  format('p4:',4f14.6)
 107  format(4g18.13)
 108  format(3g18.13)


      return
      end
