************************************************
*

      subroutine pointcheck(npar,rnorm,x1,x2,wgt,born,rsub,virt,vsub,dvirt,dvirtsub)
      use Process_mod
      use Channels_mod
      use KinData_mod
      use Observables_mod
      implicit none
      integer :: npar
      double precision :: rnorm,x1,x2,wgt
      double precision :: born,rsub,virt,vsub,dvirt,dvirtsub
      external born,rsub,virt,vsub,dvirt,dvirtsub
      character*100 spointname
      character*10 spar
      !> 
      integer :: i,j, ii,jj, iout
      !> local variables
      double precision :: mat, sub
      integer :: ichan
      character(:), allocatable :: abbr_str
      character(:), allocatable :: chan_str, me_str, sub_str
      integer :: id_ch, nsub_ch, nV_ch, nR_ch, nO_ch, npar_ch
      !> random numbers
      integer :: ndim
      double precision :: xvegas
      common /vdata/xvegas(20)
!$omp threadprivate(/vdata/)
      integer, save :: npar_last = -1

!$omp critical(pntcheck)

      call currentContrib_chan(ndim=ndim)

      write(spar,"(I1)") npar
      spointname = "point_"//trim(name_proc)//"_"//trim(spar)//".txt"

      do j=2,2
         if(j.eq.1) iout = 6 ! output to screen
         if(j.eq.2) then
            iout = 501
            if (npar_last /= npar) then
               npar_last = npar
               open (unit=501,file=trim(spointname),status="unknown",action="write")
               write(iout,*) "# NNLOJET point test for process "//trim(name_proc)//" and npar = "//trim(spar)
            else
               open (unit=501,file=trim(spointname),status="unknown",position="Append",action="write")
            end if
         endif
         do ii=1,ndim
            write(iout,11) ii,xvegas(ii)
         end do
         write(iout,*) "x1 = ", x1
         write(iout,*) "x2 = ", x2
         do ii=1,npar
            do jj=1,4
               write(iout,10) jj,ii,kin(npar)%p(jj,ii)
            enddo
         enddo
         call printAll_obs(npar, skipCache=.true., unit=iout)
         write(iout,*) "          ip       Process               Matrix                 Subtraction"
         do ichan=1,ntot_chan
            if (.not.qactive_chan(ichan)) cycle
            !> channel information
            call get_chan(ichan, chan_str, me_str, sub_str)
            call info_chan(ichan, id_ch, nsub_ch, abbr_str, nV_ch, nR_ch, nO_ch, npar_ch)
            if (npar /= npar_ch) cycle
            !> switch on one single channel
            qselect_chan(:)     = .false.
            qselect_chan(ichan) = .true.


            if(nV_ch.eq.0)then
               mat = born(rnorm,x1,x2,wgt)
               sub = rsub(rnorm,x1,x2,wgt)
               if((mat.ne.0d0).or.(sub.ne.0d0)) write(iout,*)ichan,trim(chan_str)//" ",mat,sub
            elseif(nV_ch.eq.1)then
               mat = virt(rnorm,x1,x2,wgt)
               sub = vsub(rnorm,x1,x2,wgt)
               if((mat.ne.0d0).or.(sub.ne.0d0)) write(iout,*)ichan,trim(chan_str)//" ",mat,sub
            else
               mat = dvirt(rnorm,x1,x2,wgt)
               sub = dvirtsub(rnorm,x1,x2,wgt)
               if((mat.ne.0d0).or.(sub.ne.0d0)) write(iout,*)ichan,trim(chan_str)//" ",mat,sub
            endif
         enddo
         write(iout,*) " "
         write(iout,*) "***********************"
         if(j.eq.2) close(501)
      enddo

 11   format('x(',i2,') = ',f32.30,'d0')
 10   format('p(',i2,',',i2,')=',f18.10)

!$omp end critical(pntcheck)

      end
