      subroutine getlumi2jetfc(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    6,   13,   26,   31,   38,   45,   84,          
     &           89,   98,  109,  120,  127,  134,  191,  196,          
     &          209,  216,  221,  230,  235,  242,  249,  256,          
     &          269,  280,  289,  298,  307,  406,  411,  420,          
     &          431,  448,  459,  460,  465,  474,  481,  488,          
     &          495,  502,  515,  526,  537,  550,  567,  584,          
     &          601,  618,  623,  632,  641,  654,  667,  684,          
     &          703,  714,  725,  730,  739,  748,  757,  770,          
     &          777,  784,  791,  798,  805,  814,  825,  836,          
     &          849,  866,  883,  900,  917,  934)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,    9,   27,   34,   41,   51,   61,   70,          
     &           78,   87,   92,   94,  105,  116,  123,  130,          
     &          145,  155,  165,  173,  181,  189,  192,  202,          
     &          217,  224,  231,  238,  245,  252,  262,  273,          
     &          283,  292,  301,  409,  414,  416,  427,  441,          
     &          452,  463,  468,  470,  477,  484,  491,  498,          
     &          508,  519,  530,  540,  557,  574,  591,  608,          
     &          628,  637,  646,  650,  663,  670,  680,  687,          
     &          706,  717,  728,  735,  744,  753,  762,  766,          
     &          773,  780,  787,  794,  801,  817,  828,  839,          
     &          854,  871,  888,  905,  922,  939)
!       [30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    3,   10,   18,   22,   28,   35,   42,   48,          
     &           58,   68,   76,   95,  106,  117,  124,  131,          
     &          139,  149,  159,  167,  175,  183,  193,  199,          
     &          210,  218,  225,  232,  239,  246,  253,  259,          
     &          270,  281,  290,  299,  308,  314,  320,  332,          
     &          334,  346,  348,  360,  362,  374,  376,  388,          
     &          390,  394,  398,  402,  417,  428,  438,  449,          
     &          471,  478,  485,  492,  499,  505,  516,  527,          
     &          538,  547,  552,  555,  564,  569,  572,  581,          
     &          586,  589,  598,  603,  606,  615,  620,  651,          
     &          664,  681,  699,  710,  721,  767,  774,  781,          
     &          788,  795,  802,  810,  821,  832,  841,  846,          
     &          853,  858,  863,  870,  875,  880,  887,  892,          
     &          897,  904,  909,  914,  921,  926,  931,  938)
!       [30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    4,   11,   29,   36,   43,   53,   63,   72,          
     &           80,   85,   90,   96,  107,  118,  125,  132,          
     &          143,  153,  163,  171,  179,  187,  194,  204,          
     &          219,  226,  233,  240,  247,  254,  264,  275,          
     &          285,  294,  303,  407,  412,  418,  429,  443,          
     &          454,  461,  466,  472,  479,  486,  493,  500,          
     &          510,  521,  532,  542,  559,  576,  593,  610,          
     &          624,  633,  642,  652,  665,  672,  682,  689,          
     &          704,  715,  726,  731,  740,  749,  758,  768,          
     &          775,  782,  789,  796,  803,  815,  826,  837,          
     &          850,  867,  884,  901,  918,  935)
!       [0, 30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (    5,   12,   19,   24,   30,   37,   44,   52,          
     &           62,   71,   79,   97,  108,  119,  126,  133,          
     &          140,  150,  160,  169,  177,  185,  195,  203,          
     &          213,  220,  227,  234,  241,  248,  255,  263,          
     &          274,  284,  293,  302,  311,  317,  324,  333,          
     &          338,  347,  352,  361,  366,  375,  380,  389,          
     &          392,  396,  400,  404,  419,  430,  442,  453,          
     &          473,  480,  487,  494,  501,  509,  520,  531,          
     &          541,  548,  553,  558,  565,  570,  575,  582,          
     &          587,  592,  599,  604,  609,  616,  621,  653,          
     &          666,  683,  700,  711,  722,  769,  776,  783,          
     &          790,  797,  804,  811,  822,  833,  843,  847,          
     &          855,  860,  864,  872,  877,  881,  889,  894,          
     &          898,  906,  911,  915,  923,  928,  932,  940)
!       [-30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    7,   14,   32,   39,   46,   57,   67,   75,          
     &           83,   86,   91,   99,  110,  121,  128,  135,          
     &          144,  154,  164,  172,  180,  188,  197,  208,          
     &          222,  228,  236,  243,  250,  257,  268,  279,          
     &          288,  297,  306,  408,  413,  421,  432,  447,          
     &          458,  462,  467,  475,  482,  489,  496,  503,          
     &          514,  525,  536,  545,  562,  579,  596,  613,          
     &          625,  634,  643,  655,  668,  673,  685,  690,          
     &          705,  716,  727,  732,  741,  750,  759,  771,          
     &          778,  785,  792,  799,  806,  816,  827,  838,          
     &          851,  868,  885,  902,  919,  936)
!       [0, -30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    8,   15,   33,   40,   47,   56,   66,   74,          
     &           82,   88,   93,  100,  111,  122,  129,  136,          
     &          146,  156,  166,  174,  182,  190,  198,  207,          
     &          223,  229,  237,  244,  251,  258,  267,  278,          
     &          287,  296,  305,  410,  415,  422,  433,  446,          
     &          457,  464,  469,  476,  483,  490,  497,  504,          
     &          513,  524,  535,  544,  561,  578,  595,  612,          
     &          631,  640,  649,  656,  669,  671,  686,  688,          
     &          707,  718,  729,  738,  747,  756,  765,  772,          
     &          779,  786,  793,  800,  807,  818,  829,  840,          
     &          857,  874,  891,  908,  925,  942)
!       [-30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   16,   50,   60,  102,  113,  137,  147,  157,          
     &          201,  212,  261,  272,  310,  316,  323,  330,          
     &          337,  344,  351,  358,  365,  372,  379,  386,          
     &          424,  435,  440,  451,  507,  518,  529,  627,          
     &          636,  645,  658,  675,  692,  697,  708,  719,          
     &          734,  743,  752,  761,  808,  819,  830)
!       [31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   17,   49,   59,  101,  112,  138,  148,  158,          
     &          200,  211,  260,  271,  309,  315,  322,  325,          
     &          336,  339,  350,  353,  364,  367,  378,  381,          
     &          423,  434,  439,  450,  506,  517,  528,  626,          
     &          635,  644,  657,  674,  691,  698,  709,  720,          
     &          733,  742,  751,  760,  809,  820,  831)
!       [31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   20,   55,   65,  104,  115,  141,  151,  161,          
     &          206,  215,  266,  277,  313,  319,  329,  331,          
     &          343,  345,  357,  359,  371,  373,  385,  387,          
     &          426,  437,  445,  456,  512,  523,  534,  630,          
     &          639,  648,  661,  678,  695,  701,  712,  723,          
     &          737,  746,  755,  764,  812,  823,  834)
!       [-31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   21,   54,   64,  103,  114,  142,  152,  162,          
     &          205,  214,  265,  276,  312,  318,  326,  328,          
     &          340,  342,  354,  356,  368,  370,  382,  384,          
     &          425,  436,  444,  455,  511,  522,  533,  629,          
     &          638,  647,  660,  677,  694,  702,  713,  724,          
     &          736,  745,  754,  763,  813,  824,  835)
!       [-31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   23,   69,   77,  168,  176,  184,  282,  291,          
     &          300,  321,  335,  349,  363,  377,  391,  395,          
     &          399,  403,  539,  546,  551,  556,  563,  568,          
     &          573,  580,  585,  590,  597,  602,  607,  614,          
     &          619,  659,  676,  693,  842,  845,  852,  859,          
     &          862,  869,  876,  879,  886,  893,  896,  903,          
     &          910,  913,  920,  927,  930,  937)
!       [30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   25,   73,   81,  170,  178,  186,  286,  295,          
     &          304,  327,  341,  355,  369,  383,  393,  397,          
     &          401,  405,  543,  549,  554,  560,  566,  571,          
     &          577,  583,  588,  594,  600,  605,  611,  617,          
     &          622,  662,  679,  696,  844,  848,  856,  861,          
     &          865,  873,  878,  882,  890,  895,  899,  907,          
     &          912,  916,  924,  929,  933,  941)
!       [-30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case default
          print*, "getlumi2jetfc: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumi2jetfc



      function getlumiid2jetfc(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    6,   13,   26,   31,   38,   45,   84,
     &           89,   98,  109,  120,  127,  134,  191,  196,
     &          209,  216,  221,  230,  235,  242,  249,  256,
     &          269,  280,  289,  298,  307,  406,  411,  420,
     &          431,  448,  459,  460,  465,  474,  481,  488,
     &          495,  502,  515,  526,  537,  550,  567,  584,
     &          601,  618,  623,  632,  641,  654,  667,  684,
     &          703,  714,  725,  730,  739,  748,  757,  770,
     &          777,  784,  791,  798,  805,  814,  825,  836,
     &          849,  866,  883,  900,  917,  934)
          id  = 1
          ip1 = 0
          ip2 = 0

        case (    2,    9,   27,   34,   41,   51,   61,   70,
     &           78,   87,   92,   94,  105,  116,  123,  130,
     &          145,  155,  165,  173,  181,  189,  192,  202,
     &          217,  224,  231,  238,  245,  252,  262,  273,
     &          283,  292,  301,  409,  414,  416,  427,  441,
     &          452,  463,  468,  470,  477,  484,  491,  498,
     &          508,  519,  530,  540,  557,  574,  591,  608,
     &          628,  637,  646,  650,  663,  670,  680,  687,
     &          706,  717,  728,  735,  744,  753,  762,  766,
     &          773,  780,  787,  794,  801,  817,  828,  839,
     &          854,  871,  888,  905,  922,  939)
          id  = 2
          ip1 = 30
          ip2 = 0

        case (    3,   10,   18,   22,   28,   35,   42,   48,
     &           58,   68,   76,   95,  106,  117,  124,  131,
     &          139,  149,  159,  167,  175,  183,  193,  199,
     &          210,  218,  225,  232,  239,  246,  253,  259,
     &          270,  281,  290,  299,  308,  314,  320,  332,
     &          334,  346,  348,  360,  362,  374,  376,  388,
     &          390,  394,  398,  402,  417,  428,  438,  449,
     &          471,  478,  485,  492,  499,  505,  516,  527,
     &          538,  547,  552,  555,  564,  569,  572,  581,
     &          586,  589,  598,  603,  606,  615,  620,  651,
     &          664,  681,  699,  710,  721,  767,  774,  781,
     &          788,  795,  802,  810,  821,  832,  841,  846,
     &          853,  858,  863,  870,  875,  880,  887,  892,
     &          897,  904,  909,  914,  921,  926,  931,  938)
          id  = 3
          ip1 = 30
          ip2 = -30

        case (    4,   11,   29,   36,   43,   53,   63,   72,
     &           80,   85,   90,   96,  107,  118,  125,  132,
     &          143,  153,  163,  171,  179,  187,  194,  204,
     &          219,  226,  233,  240,  247,  254,  264,  275,
     &          285,  294,  303,  407,  412,  418,  429,  443,
     &          454,  461,  466,  472,  479,  486,  493,  500,
     &          510,  521,  532,  542,  559,  576,  593,  610,
     &          624,  633,  642,  652,  665,  672,  682,  689,
     &          704,  715,  726,  731,  740,  749,  758,  768,
     &          775,  782,  789,  796,  803,  815,  826,  837,
     &          850,  867,  884,  901,  918,  935)
          id  = 4
          ip1 = 0
          ip2 = 30

        case (    5,   12,   19,   24,   30,   37,   44,   52,
     &           62,   71,   79,   97,  108,  119,  126,  133,
     &          140,  150,  160,  169,  177,  185,  195,  203,
     &          213,  220,  227,  234,  241,  248,  255,  263,
     &          274,  284,  293,  302,  311,  317,  324,  333,
     &          338,  347,  352,  361,  366,  375,  380,  389,
     &          392,  396,  400,  404,  419,  430,  442,  453,
     &          473,  480,  487,  494,  501,  509,  520,  531,
     &          541,  548,  553,  558,  565,  570,  575,  582,
     &          587,  592,  599,  604,  609,  616,  621,  653,
     &          666,  683,  700,  711,  722,  769,  776,  783,
     &          790,  797,  804,  811,  822,  833,  843,  847,
     &          855,  860,  864,  872,  877,  881,  889,  894,
     &          898,  906,  911,  915,  923,  928,  932,  940)
          id  = 5
          ip1 = -30
          ip2 = 30

        case (    7,   14,   32,   39,   46,   57,   67,   75,
     &           83,   86,   91,   99,  110,  121,  128,  135,
     &          144,  154,  164,  172,  180,  188,  197,  208,
     &          222,  228,  236,  243,  250,  257,  268,  279,
     &          288,  297,  306,  408,  413,  421,  432,  447,
     &          458,  462,  467,  475,  482,  489,  496,  503,
     &          514,  525,  536,  545,  562,  579,  596,  613,
     &          625,  634,  643,  655,  668,  673,  685,  690,
     &          705,  716,  727,  732,  741,  750,  759,  771,
     &          778,  785,  792,  799,  806,  816,  827,  838,
     &          851,  868,  885,  902,  919,  936)
          id  = 6
          ip1 = 0
          ip2 = -30

        case (    8,   15,   33,   40,   47,   56,   66,   74,
     &           82,   88,   93,  100,  111,  122,  129,  136,
     &          146,  156,  166,  174,  182,  190,  198,  207,
     &          223,  229,  237,  244,  251,  258,  267,  278,
     &          287,  296,  305,  410,  415,  422,  433,  446,
     &          457,  464,  469,  476,  483,  490,  497,  504,
     &          513,  524,  535,  544,  561,  578,  595,  612,
     &          631,  640,  649,  656,  669,  671,  686,  688,
     &          707,  718,  729,  738,  747,  756,  765,  772,
     &          779,  786,  793,  800,  807,  818,  829,  840,
     &          857,  874,  891,  908,  925,  942)
          id  = 7
          ip1 = -30
          ip2 = 0

        case (   16,   50,   60,  102,  113,  137,  147,  157,
     &          201,  212,  261,  272,  310,  316,  323,  330,
     &          337,  344,  351,  358,  365,  372,  379,  386,
     &          424,  435,  440,  451,  507,  518,  529,  627,
     &          636,  645,  658,  675,  692,  697,  708,  719,
     &          734,  743,  752,  761,  808,  819,  830)
          id  = 8
          ip1 = 31
          ip2 = -31

        case (   17,   49,   59,  101,  112,  138,  148,  158,
     &          200,  211,  260,  271,  309,  315,  322,  325,
     &          336,  339,  350,  353,  364,  367,  378,  381,
     &          423,  434,  439,  450,  506,  517,  528,  626,
     &          635,  644,  657,  674,  691,  698,  709,  720,
     &          733,  742,  751,  760,  809,  820,  831)
          id  = 9
          ip1 = 31
          ip2 = 31

        case (   20,   55,   65,  104,  115,  141,  151,  161,
     &          206,  215,  266,  277,  313,  319,  329,  331,
     &          343,  345,  357,  359,  371,  373,  385,  387,
     &          426,  437,  445,  456,  512,  523,  534,  630,
     &          639,  648,  661,  678,  695,  701,  712,  723,
     &          737,  746,  755,  764,  812,  823,  834)
          id  = 10
          ip1 = -31
          ip2 = -31

        case (   21,   54,   64,  103,  114,  142,  152,  162,
     &          205,  214,  265,  276,  312,  318,  326,  328,
     &          340,  342,  354,  356,  368,  370,  382,  384,
     &          425,  436,  444,  455,  511,  522,  533,  629,
     &          638,  647,  660,  677,  694,  702,  713,  724,
     &          736,  745,  754,  763,  813,  824,  835)
          id  = 11
          ip1 = -31
          ip2 = 31

        case (   23,   69,   77,  168,  176,  184,  282,  291,
     &          300,  321,  335,  349,  363,  377,  391,  395,
     &          399,  403,  539,  546,  551,  556,  563,  568,
     &          573,  580,  585,  590,  597,  602,  607,  614,
     &          619,  659,  676,  693,  842,  845,  852,  859,
     &          862,  869,  876,  879,  886,  893,  896,  903,
     &          910,  913,  920,  927,  930,  937)
          id  = 12
          ip1 = 30
          ip2 = 30

        case (   25,   73,   81,  170,  178,  186,  286,  295,
     &          304,  327,  341,  355,  369,  383,  393,  397,
     &          401,  405,  543,  549,  554,  560,  566,  571,
     &          577,  583,  588,  594,  600,  605,  611,  617,
     &          622,  662,  679,  696,  844,  848,  856,  861,
     &          865,  873,  878,  882,  890,  895,  899,  907,
     &          912,  916,  924,  929,  933,  941)
          id  = 13
          ip1 = -30
          ip2 = -30

        case default
          print*, "getlumiid2jetfc: invalid iproc:", iproc
          stop
        end select

      end function getlumiid2jetfc





#ifdef USE_PINEAPPL


      subroutine init_pine_lumi2jetfc()
        use PineAPPL_mod
        use CKM_mod
!       [0, 0]
        call register_lumi_pine(
     &         [    1,    6,   13,   26,   31,   38,   45,   84,
     &             89,   98,  109,  120,  127,  134,  191,  196,
     &            209,  216,  221,  230,  235,  242,  249,  256,
     &            269,  280,  289,  298,  307,  406,  411,  420,
     &            431,  448,  459,  460,  465,  474,  481,  488,
     &            495,  502,  515,  526,  537,  550,  567,  584,
     &            601,  618,  623,  632,  641,  654,  667,  684,
     &            703,  714,  725,  730,  739,  748,  757,  770,
     &            777,  784,  791,  798,  805,  814,  825,  836,
     &            849,  866,  883,  900,  917,  934],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [30, 0]
        call register_lumi_pine(
     &         [    2,    9,   27,   34,   41,   51,   61,   70,
     &             78,   87,   92,   94,  105,  116,  123,  130,
     &            145,  155,  165,  173,  181,  189,  192,  202,
     &            217,  224,  231,  238,  245,  252,  262,  273,
     &            283,  292,  301,  409,  414,  416,  427,  441,
     &            452,  463,  468,  470,  477,  484,  491,  498,
     &            508,  519,  530,  540,  557,  574,  591,  608,
     &            628,  637,  646,  650,  663,  670,  680,  687,
     &            706,  717,  728,  735,  744,  753,  762,  766,
     &            773,  780,  787,  794,  801,  817,  828,  839,
     &            854,  871,  888,  905,  922,  939],
     &         5,
     &         [    1,   21,    2,   21,    3,   21,    4,   21,
     &              5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [30, -30]
        call register_lumi_pine(
     &         [    3,   10,   18,   22,   28,   35,   42,   48,
     &             58,   68,   76,   95,  106,  117,  124,  131,
     &            139,  149,  159,  167,  175,  183,  193,  199,
     &            210,  218,  225,  232,  239,  246,  253,  259,
     &            270,  281,  290,  299,  308,  314,  320,  332,
     &            334,  346,  348,  360,  362,  374,  376,  388,
     &            390,  394,  398,  402,  417,  428,  438,  449,
     &            471,  478,  485,  492,  499,  505,  516,  527,
     &            538,  547,  552,  555,  564,  569,  572,  581,
     &            586,  589,  598,  603,  606,  615,  620,  651,
     &            664,  681,  699,  710,  721,  767,  774,  781,
     &            788,  795,  802,  810,  821,  832,  841,  846,
     &            853,  858,  863,  870,  875,  880,  887,  892,
     &            897,  904,  909,  914,  921,  926,  931,  938],
     &         5,
     &         [    1,   -1,    2,   -2,    3,   -3,    4,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, 30]
        call register_lumi_pine(
     &         [    4,   11,   29,   36,   43,   53,   63,   72,
     &             80,   85,   90,   96,  107,  118,  125,  132,
     &            143,  153,  163,  171,  179,  187,  194,  204,
     &            219,  226,  233,  240,  247,  254,  264,  275,
     &            285,  294,  303,  407,  412,  418,  429,  443,
     &            454,  461,  466,  472,  479,  486,  493,  500,
     &            510,  521,  532,  542,  559,  576,  593,  610,
     &            624,  633,  642,  652,  665,  672,  682,  689,
     &            704,  715,  726,  731,  740,  749,  758,  768,
     &            775,  782,  789,  796,  803,  815,  826,  837,
     &            850,  867,  884,  901,  918,  935],
     &         5,
     &         [   21,    1,   21,    2,   21,    3,   21,    4,
     &             21,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 30]
        call register_lumi_pine(
     &         [    5,   12,   19,   24,   30,   37,   44,   52,
     &             62,   71,   79,   97,  108,  119,  126,  133,
     &            140,  150,  160,  169,  177,  185,  195,  203,
     &            213,  220,  227,  234,  241,  248,  255,  263,
     &            274,  284,  293,  302,  311,  317,  324,  333,
     &            338,  347,  352,  361,  366,  375,  380,  389,
     &            392,  396,  400,  404,  419,  430,  442,  453,
     &            473,  480,  487,  494,  501,  509,  520,  531,
     &            541,  548,  553,  558,  565,  570,  575,  582,
     &            587,  592,  599,  604,  609,  616,  621,  653,
     &            666,  683,  700,  711,  722,  769,  776,  783,
     &            790,  797,  804,  811,  822,  833,  843,  847,
     &            855,  860,  864,  872,  877,  881,  889,  894,
     &            898,  906,  911,  915,  923,  928,  932,  940],
     &         5,
     &         [   -1,    1,   -2,    2,   -3,    3,   -4,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, -30]
        call register_lumi_pine(
     &         [    7,   14,   32,   39,   46,   57,   67,   75,
     &             83,   86,   91,   99,  110,  121,  128,  135,
     &            144,  154,  164,  172,  180,  188,  197,  208,
     &            222,  228,  236,  243,  250,  257,  268,  279,
     &            288,  297,  306,  408,  413,  421,  432,  447,
     &            458,  462,  467,  475,  482,  489,  496,  503,
     &            514,  525,  536,  545,  562,  579,  596,  613,
     &            625,  634,  643,  655,  668,  673,  685,  690,
     &            705,  716,  727,  732,  741,  750,  759,  771,
     &            778,  785,  792,  799,  806,  816,  827,  838,
     &            851,  868,  885,  902,  919,  936],
     &         5,
     &         [   21,   -1,   21,   -2,   21,   -3,   21,   -4,
     &             21,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 0]
        call register_lumi_pine(
     &         [    8,   15,   33,   40,   47,   56,   66,   74,
     &             82,   88,   93,  100,  111,  122,  129,  136,
     &            146,  156,  166,  174,  182,  190,  198,  207,
     &            223,  229,  237,  244,  251,  258,  267,  278,
     &            287,  296,  305,  410,  415,  422,  433,  446,
     &            457,  464,  469,  476,  483,  490,  497,  504,
     &            513,  524,  535,  544,  561,  578,  595,  612,
     &            631,  640,  649,  656,  669,  671,  686,  688,
     &            707,  718,  729,  738,  747,  756,  765,  772,
     &            779,  786,  793,  800,  807,  818,  829,  840,
     &            857,  874,  891,  908,  925,  942],
     &         5,
     &         [   -1,   21,   -2,   21,   -3,   21,   -4,   21,
     &             -5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [31, -31]
        call register_lumi_pine(
     &         [   16,   50,   60,  102,  113,  137,  147,  157,
     &            201,  212,  261,  272,  310,  316,  323,  330,
     &            337,  344,  351,  358,  365,  372,  379,  386,
     &            424,  435,  440,  451,  507,  518,  529,  627,
     &            636,  645,  658,  675,  692,  697,  708,  719,
     &            734,  743,  752,  761,  808,  819,  830],
     &         25,
     &         [    1,   -1,    1,   -2,    1,   -3,    1,   -4,
     &              1,   -5,    2,   -1,    2,   -2,    2,   -3,
     &              2,   -4,    2,   -5,    3,   -1,    3,   -2,
     &              3,   -3,    3,   -4,    3,   -5,    4,   -1,
     &              4,   -2,    4,   -3,    4,   -4,    4,   -5,
     &              5,   -1,    5,   -2,    5,   -3,    5,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [31, 31]
        call register_lumi_pine(
     &         [   17,   49,   59,  101,  112,  138,  148,  158,
     &            200,  211,  260,  271,  309,  315,  322,  325,
     &            336,  339,  350,  353,  364,  367,  378,  381,
     &            423,  434,  439,  450,  506,  517,  528,  626,
     &            635,  644,  657,  674,  691,  698,  709,  720,
     &            733,  742,  751,  760,  809,  820,  831],
     &         25,
     &         [    1,    1,    1,    2,    1,    3,    1,    4,
     &              1,    5,    2,    1,    2,    2,    2,    3,
     &              2,    4,    2,    5,    3,    1,    3,    2,
     &              3,    3,    3,    4,    3,    5,    4,    1,
     &              4,    2,    4,    3,    4,    4,    4,    5,
     &              5,    1,    5,    2,    5,    3,    5,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, -31]
        call register_lumi_pine(
     &         [   20,   55,   65,  104,  115,  141,  151,  161,
     &            206,  215,  266,  277,  313,  319,  329,  331,
     &            343,  345,  357,  359,  371,  373,  385,  387,
     &            426,  437,  445,  456,  512,  523,  534,  630,
     &            639,  648,  661,  678,  695,  701,  712,  723,
     &            737,  746,  755,  764,  812,  823,  834],
     &         25,
     &         [   -1,   -1,   -1,   -2,   -1,   -3,   -1,   -4,
     &             -1,   -5,   -2,   -1,   -2,   -2,   -2,   -3,
     &             -2,   -4,   -2,   -5,   -3,   -1,   -3,   -2,
     &             -3,   -3,   -3,   -4,   -3,   -5,   -4,   -1,
     &             -4,   -2,   -4,   -3,   -4,   -4,   -4,   -5,
     &             -5,   -1,   -5,   -2,   -5,   -3,   -5,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, 31]
        call register_lumi_pine(
     &         [   21,   54,   64,  103,  114,  142,  152,  162,
     &            205,  214,  265,  276,  312,  318,  326,  328,
     &            340,  342,  354,  356,  368,  370,  382,  384,
     &            425,  436,  444,  455,  511,  522,  533,  629,
     &            638,  647,  660,  677,  694,  702,  713,  724,
     &            736,  745,  754,  763,  813,  824,  835],
     &         25,
     &         [   -1,    1,   -1,    2,   -1,    3,   -1,    4,
     &             -1,    5,   -2,    1,   -2,    2,   -2,    3,
     &             -2,    4,   -2,    5,   -3,    1,   -3,    2,
     &             -3,    3,   -3,    4,   -3,    5,   -4,    1,
     &             -4,    2,   -4,    3,   -4,    4,   -4,    5,
     &             -5,    1,   -5,    2,   -5,    3,   -5,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [30, 30]
        call register_lumi_pine(
     &         [   23,   69,   77,  168,  176,  184,  282,  291,
     &            300,  321,  335,  349,  363,  377,  391,  395,
     &            399,  403,  539,  546,  551,  556,  563,  568,
     &            573,  580,  585,  590,  597,  602,  607,  614,
     &            619,  659,  676,  693,  842,  845,  852,  859,
     &            862,  869,  876,  879,  886,  893,  896,  903,
     &            910,  913,  920,  927,  930,  937],
     &         5,
     &         [    1,    1,    2,    2,    3,    3,    4,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, -30]
        call register_lumi_pine(
     &         [   25,   73,   81,  170,  178,  186,  286,  295,
     &            304,  327,  341,  355,  369,  383,  393,  397,
     &            401,  405,  543,  549,  554,  560,  566,  571,
     &            577,  583,  588,  594,  600,  605,  611,  617,
     &            622,  662,  679,  696,  844,  848,  856,  861,
     &            865,  873,  878,  882,  890,  895,  899,  907,
     &            912,  916,  924,  929,  933,  941],
     &         5,
     &         [   -1,   -1,   -2,   -2,   -3,   -3,   -4,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

      end subroutine init_pine_lumi2jetfc


#endif


