      subroutine getqcdnorm2jetfc(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgt2jetfc(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_jet(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAV2jetfc
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavour2jetfc(current_chan)
         do isub = 1, nflavour2jetfc(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_2jetfc(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=2jetfc "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*((4d0*pi*alphas_scl)*nc)**2*(nc**2-1d0)
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=2d0*1d0/2d0*facB            ! g g -> g g              A4g0
      case(2)
         factor=1d0/nc*facB                 ! q g -> g q              B2g0
      case(3)
         factor=1d0/nc*1d0/2d0*facB         ! q qb -> g g             B2g0
      case(4)
         factor=1d0/nc*facB                 ! g q -> g q              B2g0
      case(5)
         factor=1d0/nc*1d0/2d0*facB         ! qb q -> g g             B2g0
      case(6)
         factor=1d0/nc*nf*facB              ! g g -> qb q             B2g0
      case(7)
         factor=1d0/nc*facB                 ! g qb -> qb g            B2g0
      case(8)
         factor=1d0/nc*facB                 ! qb g -> qb g            B2g0
      case(9)
         factor=-1d0/nc**3*facB             ! q gt -> gt q            Bt2g0
      case(10)
         factor=-1d0/nc**3*1d0/2d0*facB     ! q qb -> gt gt           Bt2g0
      case(11)
         factor=-1d0/nc**3*facB             ! gt q -> gt q            Bt2g0
      case(12)
         factor=-1d0/nc**3*1d0/2d0*facB     ! qb q -> gt gt           Bt2g0
      case(13)
         factor=-1d0/nc**3*nf*facB          ! gt gt -> qb q           Bt2g0
      case(14)
         factor=-1d0/nc**3*facB             ! gt qb -> qb gt          Bt2g0
      case(15)
         factor=-1d0/nc**3*facB             ! qb gt -> qb gt          Bt2g0
      case(16)
         factor=1d0/nc**2*facB              ! q Qb -> Qb q            C0g0
      case(17)
         factor=1d0/nc**2*facB              ! q Q -> Q q              C0g0
      case(18)
         factor=1d0/nc**2*nf*facB           ! q qb -> Q Qb            C0g0
      case(19)
         factor=1d0/nc**2*nf*facB           ! qb q -> Q Qb            C0g0
      case(20)
         factor=1d0/nc**2*facB              ! qb Qb -> qb Qb          C0g0
      case(21)
         factor=1d0/nc**2*facB              ! qb Q -> qb Q            C0g0
      case(22)
         factor=-1d0/nc**3*facB             ! q qb -> qb q            D0g0
      case(23)
         factor=-1d0/nc**3*1d0/2d0*facB     ! q q -> q q              D0g0
      case(24)
         factor=-1d0/nc**3*facB             ! qb q -> qb q            D0g0
      case(25)
         factor=-1d0/nc**3*1d0/2d0*facB     ! qb qb -> qb qb          D0g0

c -- real

      case(26)
         factor=2d0*1d0/6d0*facR            ! g g -> g g g            A5g0
      case(27)
         factor=1d0/nc*1d0/2d0*facR         ! q g -> g g q            B3g0
      case(28)
         factor=1d0/nc*1d0/6d0*facR         ! q qb -> g g g           B3g0
      case(29)
         factor=1d0/nc*1d0/2d0*facR         ! g q -> g g q            B3g0
      case(30)
         factor=1d0/nc*1d0/6d0*facR         ! qb q -> g g g           B3g0
      case(31)
         factor=1d0/nc*nf*facR              ! g g -> qb g q           B3g0
      case(32)
         factor=1d0/nc*1d0/2d0*facR         ! g qb -> qb g g          B3g0
      case(33)
         factor=1d0/nc*1d0/2d0*facR         ! qb g -> qb g g          B3g0
      case(34)
         factor=-1d0/nc**3*1d0/2d0*facR     ! q g -> g g q            Bt3g0
      case(35)
         factor=-1d0/nc**3*1d0/6d0*facR     ! q qb -> g g g           Bt3g0
      case(36)
         factor=-1d0/nc**3*1d0/2d0*facR     ! g q -> g g q            Bt3g0
      case(37)
         factor=-1d0/nc**3*1d0/6d0*facR     ! qb q -> g g g           Bt3g0
      case(38)
         factor=-1d0/nc**3*nf*facR          ! g g -> qb g q           Bt3g0
      case(39)
         factor=-1d0/nc**3*1d0/2d0*facR     ! g qb -> qb g g          Bt3g0
      case(40)
         factor=-1d0/nc**3*1d0/2d0*facR     ! qb g -> qb g g          Bt3g0
      case(41)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facR   ! q gt -> gt gt q         Btt3g0
      case(42)
         factor=(nc**2+1d0)/nc**5*1d0/6d0*facR   ! q qb -> gt gt gt        Btt3g0
      case(43)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facR   ! gt q -> gt gt q         Btt3g0
      case(44)
         factor=(nc**2+1d0)/nc**5*1d0/6d0*facR   ! qb q -> gt gt gt        Btt3g0
      case(45)
         factor=(nc**2+1d0)/nc**5*nf*facR   ! gt gt -> qb gt q        Btt3g0
      case(46)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facR   ! gt qb -> qb gt gt       Btt3g0
      case(47)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facR   ! qb gt -> qb gt gt       Btt3g0
      case(48)
         factor=1d0/nc**2*nf*facR           ! q qb -> Qb Q g          C1g0X
      case(49)
         factor=1d0/nc**2*facR              ! q Q -> q Q g            C1g0X
      case(50)
         factor=1d0/nc**2*facR              ! q Qb -> q Qb g          C1g0X
      case(51)
         factor=1d0/nc**2*nf*facR           ! q g -> q Qb Q           C1g0X
      case(52)
         factor=1d0/nc**2*nf*facR           ! qb q -> Qb Q g          C1g0X
      case(53)
         factor=1d0/nc**2*nf*facR           ! g q -> q Qb Q           C1g0X
      case(54)
         factor=1d0/nc**2*facR              ! qb Q -> qb Q g          C1g0X
      case(55)
         factor=1d0/nc**2*facR              ! qb Qb -> qb Qb g        C1g0X
      case(56)
         factor=1d0/nc**2*nf*facR           ! qb g -> qb Qb Q         C1g0X
      case(57)
         factor=1d0/nc**2*nf*facR           ! g qb -> qb Qb Q         C1g0X
      case(58)
         factor=1d0/nc**4*nf*facR           ! q qb -> Qb Q g          C1g0Y
      case(59)
         factor=1d0/nc**4*facR              ! q Q -> q Q g            C1g0Y
      case(60)
         factor=1d0/nc**4*facR              ! q Qb -> q Qb g          C1g0Y
      case(61)
         factor=1d0/nc**4*nf*facR           ! q g -> q Qb Q           C1g0Y
      case(62)
         factor=1d0/nc**4*nf*facR           ! qb q -> Qb Q g          C1g0Y
      case(63)
         factor=1d0/nc**4*nf*facR           ! g q -> q Qb Q           C1g0Y
      case(64)
         factor=1d0/nc**4*facR              ! qb Q -> qb Q g          C1g0Y
      case(65)
         factor=1d0/nc**4*facR              ! qb Qb -> qb Qb g        C1g0Y
      case(66)
         factor=1d0/nc**4*nf*facR           ! qb g -> qb Qb Q         C1g0Y
      case(67)
         factor=1d0/nc**4*nf*facR           ! g qb -> qb Qb Q         C1g0Y
      case(68)
         factor=1d0/nc**3*facR              ! q qb -> qb q g          D1g0X
      case(69)
         factor=1d0/nc**3*1d0/2d0*facR      ! q q -> q q g            D1g0X
      case(70)
         factor=1d0/nc**3*1d0/2d0*facR      ! q g -> q qb q           D1g0X
      case(71)
         factor=1d0/nc**3*facR              ! qb q -> qb q g          D1g0X
      case(72)
         factor=1d0/nc**3*1d0/2d0*facR      ! g q -> q qb q           D1g0X
      case(73)
         factor=1d0/nc**3*1d0/2d0*facR      ! qb qb -> qb qb g        D1g0X
      case(74)
         factor=1d0/nc**3*1d0/2d0*facR      ! qb g -> qb qb q         D1g0X
      case(75)
         factor=1d0/nc**3*1d0/2d0*facR      ! g qb -> qb qb q         D1g0X
      case(76)
         factor=-(nc**2+1d0)/nc**5*facR     ! q qb -> qb q g          D1g0gam
      case(77)
         factor=-(nc**2+1d0)/nc**5*1d0/2d0*facR   ! q q -> q q g            D1g0gam
      case(78)
         factor=-(nc**2+1d0)/nc**5*1d0/2d0*facR   ! q g -> q qb q           D1g0gam
      case(79)
         factor=-(nc**2+1d0)/nc**5*facR     ! qb q -> qb q g          D1g0gam
      case(80)
         factor=-(nc**2+1d0)/nc**5*1d0/2d0*facR   ! g q -> q qb q           D1g0gam
      case(81)
         factor=-(nc**2+1d0)/nc**5*1d0/2d0*facR   ! qb qb -> qb qb g        D1g0gam
      case(82)
         factor=-(nc**2+1d0)/nc**5*1d0/2d0*facR   ! qb g -> qb qb q         D1g0gam
      case(83)
         factor=-(nc**2+1d0)/nc**5*1d0/2d0*facR   ! g qb -> qb qb q         D1g0gam

c -- virtual

      case(84)
         factor=2d0*1d0/2d0*facV            ! g g -> g g              A4g1
      case(85)
         factor=1d0/nc*facV                 ! g q subtraction         A4g1
      case(86)
         factor=1d0/nc*facV                 ! g qb subtraction        A4g1
      case(87)
         factor=1d0/nc*facV                 ! q g subtraction         A4g1
      case(88)
         factor=1d0/nc*facV                 ! qb g subtraction        A4g1
      case(89)
         factor=1d0/nc*nf*2d0*1d0/2d0*facV   ! g g -> g g              Ah4g1
      case(90)
         factor=1d0/nc**2*nf*facV           ! g q subtraction         Ah4g1
      case(91)
         factor=1d0/nc**2*nf*facV           ! g qb subtraction        Ah4g1
      case(92)
         factor=1d0/nc**2*nf*facV           ! q g subtraction         Ah4g1
      case(93)
         factor=1d0/nc**2*nf*facV           ! qb g subtraction        Ah4g1
      case(94)
         factor=1d0/nc*facV                 ! q g -> g q              B2g1
      case(95)
         factor=1d0/nc*1d0/2d0*facV         ! q qb -> g g             B2g1
      case(96)
         factor=1d0/nc*facV                 ! g q -> g q              B2g1
      case(97)
         factor=1d0/nc*1d0/2d0*facV         ! qb q -> g g             B2g1
      case(98)
         factor=1d0/nc*nf*facV              ! g g -> qb q             B2g1
      case(99)
         factor=1d0/nc*facV                 ! g qb -> qb g            B2g1
      case(100)
         factor=1d0/nc*facV                 ! qb g -> qb g            B2g1
      case(101)
         factor=1d0/nc**2*facV              ! q Q subtraction         B2g1
      case(102)
         factor=1d0/nc**2*facV              ! q Qb subtraction        B2g1
      case(103)
         factor=1d0/nc**2*facV              ! qb Q subtraction        B2g1
      case(104)
         factor=1d0/nc**2*facV              ! qb Qb subtraction       B2g1
      case(105)
         factor=1d0/nc**2*nf*facV           ! q g -> g q              Bh2g1
      case(106)
         factor=1d0/nc**2*nf*1d0/2d0*facV   ! q qb -> g g             Bh2g1
      case(107)
         factor=1d0/nc**2*nf*facV           ! g q -> g q              Bh2g1
      case(108)
         factor=1d0/nc**2*nf*1d0/2d0*facV   ! qb q -> g g             Bh2g1
      case(109)
         factor=1d0/nc**2*nf*nf*facV        ! g g -> qb q             Bh2g1
      case(110)
         factor=1d0/nc**2*nf*facV           ! g qb -> qb g            Bh2g1
      case(111)
         factor=1d0/nc**2*nf*facV           ! qb g -> qb g            Bh2g1
      case(112)
         factor=1d0/nc**3*nf*facV           ! q Q subtraction         Bh2g1
      case(113)
         factor=1d0/nc**3*nf*facV           ! q Qb subtraction        Bh2g1
      case(114)
         factor=1d0/nc**3*nf*facV           ! qb Q subtraction        Bh2g1
      case(115)
         factor=1d0/nc**3*nf*facV           ! qb Qb subtraction       Bh2g1
      case(116)
         factor=1d0/nc**3*facV              ! q gt -> gt q            Bt2g1
      case(117)
         factor=1d0/nc**3*1d0/2d0*facV      ! q qb -> gt gt           Bt2g1
      case(118)
         factor=1d0/nc**3*facV              ! gt q -> gt q            Bt2g1
      case(119)
         factor=1d0/nc**3*1d0/2d0*facV      ! qb q -> gt gt           Bt2g1
      case(120)
         factor=1d0/nc**3*nf*facV           ! gt gt -> qb q           Bt2g1
      case(121)
         factor=1d0/nc**3*facV              ! gt qb -> qb gt          Bt2g1
      case(122)
         factor=1d0/nc**3*facV              ! qb gt -> qb gt          Bt2g1
      case(123)
         factor=1d0/nc**4*nf*facV           ! q gt -> gt q            Bth2g1
      case(124)
         factor=1d0/nc**4*nf*1d0/2d0*facV   ! q qb -> gt gt           Bth2g1
      case(125)
         factor=1d0/nc**4*nf*facV           ! gt q -> gt q            Bth2g1
      case(126)
         factor=1d0/nc**4*nf*1d0/2d0*facV   ! qb q -> gt gt           Bth2g1
      case(127)
         factor=1d0/nc**4*nf*nf*facV        ! gt gt -> qb q           Bth2g1
      case(128)
         factor=1d0/nc**4*nf*facV           ! gt qb -> qb gt          Bth2g1
      case(129)
         factor=1d0/nc**4*nf*facV           ! qb gt -> qb gt          Bth2g1
      case(130)
         factor=1d0/nc**5*facV              ! q gt -> gt q            Btt2g1
      case(131)
         factor=1d0/nc**5*1d0/2d0*facV      ! q qb -> gt gt           Btt2g1
      case(132)
         factor=1d0/nc**5*facV              ! gt q -> gt q            Btt2g1
      case(133)
         factor=1d0/nc**5*1d0/2d0*facV      ! qb q -> gt gt           Btt2g1
      case(134)
         factor=1d0/nc**5*nf*facV           ! gt gt -> qb q           Btt2g1
      case(135)
         factor=1d0/nc**5*facV              ! gt qb -> qb gt          Btt2g1
      case(136)
         factor=1d0/nc**5*facV              ! qb gt -> qb gt          Btt2g1
      case(137)
         factor=1d0/nc**2*facV              ! q Qb -> Qb q            C0g1
      case(138)
         factor=1d0/nc**2*facV              ! q Q -> Q q              C0g1
      case(139)
         factor=1d0/nc**2*nf*facV           ! q qb -> Q Qb            C0g1
      case(140)
         factor=1d0/nc**2*nf*facV           ! qb q -> Q Qb            C0g1
      case(141)
         factor=1d0/nc**2*facV              ! qb Qb -> qb Qb          C0g1
      case(142)
         factor=1d0/nc**2*facV              ! qb Q -> qb Q            C0g1
      case(143)
         factor=1d0/nc**2*nf*facV           ! g q subtraction         C0g1
      case(144)
         factor=1d0/nc**2*nf*facV           ! g qb subtraction        C0g1
      case(145)
         factor=1d0/nc**2*nf*facV           ! q g subtraction         C0g1
      case(146)
         factor=1d0/nc**2*nf*facV           ! qb g subtraction        C0g1
      case(147)
         factor=1d0/nc**3*nf*facV           ! q Qb -> Qb q            Ch0g1
      case(148)
         factor=1d0/nc**3*nf*facV           ! q Q -> Q q              Ch0g1
      case(149)
         factor=1d0/nc**3*nf*nf*facV        ! q qb -> Q Qb            Ch0g1
      case(150)
         factor=1d0/nc**3*nf*nf*facV        ! qb q -> Q Qb            Ch0g1
      case(151)
         factor=1d0/nc**3*nf*facV           ! qb Qb -> qb Qb          Ch0g1
      case(152)
         factor=1d0/nc**3*nf*facV           ! qb Q -> qb Q            Ch0g1
      case(153)
         factor=1d0/nc**3*nf**2*facV        ! g q subtraction         Ch0g1
      case(154)
         factor=1d0/nc**3*nf**2*facV        ! g qb subtraction        Ch0g1
      case(155)
         factor=1d0/nc**3*nf**2*facV        ! q g subtraction         Ch0g1
      case(156)
         factor=1d0/nc**3*nf**2*facV        ! qb g subtraction        Ch0g1
      case(157)
         factor=1d0/nc**4*facV              ! q Qb -> Qb q            Ct0g1
      case(158)
         factor=1d0/nc**4*facV              ! q Q -> Q q              Ct0g1
      case(159)
         factor=1d0/nc**4*nf*facV           ! q qb -> Q Qb            Ct0g1
      case(160)
         factor=1d0/nc**4*nf*facV           ! qb q -> Q Qb            Ct0g1
      case(161)
         factor=1d0/nc**4*facV              ! qb Qb -> qb Qb          Ct0g1
      case(162)
         factor=1d0/nc**4*facV              ! qb Q -> qb Q            Ct0g1
      case(163)
         factor=1d0/nc**4*nf*facV           ! g q subtraction         Ct0g1
      case(164)
         factor=1d0/nc**4*nf*facV           ! g qb subtraction        Ct0g1
      case(165)
         factor=1d0/nc**4*nf*facV           ! q g subtraction         Ct0g1
      case(166)
         factor=1d0/nc**4*nf*facV           ! qb g subtraction        Ct0g1
      case(167)
         factor=-1d0/nc**3*facV             ! q qb -> qb q            D0g1
      case(168)
         factor=-1d0/nc**3*1d0/2d0*facV     ! q q -> q q              D0g1
      case(169)
         factor=-1d0/nc**3*facV             ! qb q -> qb q            D0g1
      case(170)
         factor=-1d0/nc**3*1d0/2d0*facV     ! qb qb -> qb qb          D0g1
      case(171)
         factor=-1d0/nc**3*facV             ! g q subtraction         D0g1
      case(172)
         factor=-1d0/nc**3*facV             ! g qb subtraction        D0g1
      case(173)
         factor=-1d0/nc**3*facV             ! q g subtraction         D0g1
      case(174)
         factor=-1d0/nc**3*facV             ! qb g subtraction        D0g1
      case(175)
         factor=-1d0/nc**4*nf*facV          ! q qb -> qb q            Dh0g1
      case(176)
         factor=-1d0/nc**4*nf*1d0/2d0*facV   ! q q -> q q              Dh0g1
      case(177)
         factor=-1d0/nc**4*nf*facV          ! qb q -> qb q            Dh0g1
      case(178)
         factor=-1d0/nc**4*nf*1d0/2d0*facV   ! qb qb -> qb qb          Dh0g1
      case(179)
         factor=-1d0/nc**4*nf*facV          ! g q subtraction         Dh0g1
      case(180)
         factor=-1d0/nc**4*nf*facV          ! g qb subtraction        Dh0g1
      case(181)
         factor=-1d0/nc**4*nf*facV          ! q g subtraction         Dh0g1
      case(182)
         factor=-1d0/nc**4*nf*facV          ! qb g subtraction        Dh0g1
      case(183)
         factor=-1d0/nc**5*facV             ! q qb -> qb q            Dt0g1
      case(184)
         factor=-1d0/nc**5*1d0/2d0*facV     ! q q -> q q              Dt0g1
      case(185)
         factor=-1d0/nc**5*facV             ! qb q -> qb q            Dt0g1
      case(186)
         factor=-1d0/nc**5*1d0/2d0*facV     ! qb qb -> qb qb          Dt0g1
      case(187)
         factor=-1d0/nc**5*facV             ! g q subtraction         Dt0g1
      case(188)
         factor=-1d0/nc**5*facV             ! g qb subtraction        Dt0g1
      case(189)
         factor=-1d0/nc**5*facV             ! q g subtraction         Dt0g1
      case(190)
         factor=-1d0/nc**5*facV             ! qb g subtraction        Dt0g1

c -- double real

      case(191)
         factor=2d0*1d0/24d0*facRR          ! g g -> g g g g          A6g0
      case(192)
         factor=1d0/nc*1d0/6d0*facRR        ! q g -> g g g q          B4g0
      case(193)
         factor=1d0/nc*1d0/24d0*facRR       ! q qb -> g g g g         B4g0
      case(194)
         factor=1d0/nc*1d0/6d0*facRR        ! g q -> g g g q          B4g0
      case(195)
         factor=1d0/nc*1d0/24d0*facRR       ! qb q -> g g g g         B4g0
      case(196)
         factor=1d0/nc*1d0/2d0*nf*facRR     ! g g -> qb g g q         B4g0
      case(197)
         factor=1d0/nc*1d0/6d0*facRR        ! g qb -> qb g g g        B4g0
      case(198)
         factor=1d0/nc*1d0/6d0*facRR        ! qb g -> qb g g g        B4g0
      case(199)
         factor=1d0/nc**2*1d0/2d0*nf*facRR   ! q qb -> Qb Q g g        sC2g0X
      case(200)
         factor=1d0/nc**2*1d0/2d0*facRR     ! q Q -> q Q g g          sC2g0X
      case(201)
         factor=1d0/nc**2*1d0/2d0*facRR     ! q Qb -> q Qb g g        sC2g0X
      case(202)
         factor=1d0/nc**2*nf*facRR          ! q g -> q Qb Q g         sC2g0X
      case(203)
         factor=1d0/nc**2*1d0/2d0*nf*facRR   ! qb q -> Qb Q g g        sC2g0X
      case(204)
         factor=1d0/nc**2*nf*facRR          ! g q -> q Qb Q g         sC2g0X
      case(205)
         factor=1d0/nc**2*1d0/2d0*facRR     ! qb Q -> qb Q g g        sC2g0X
      case(206)
         factor=1d0/nc**2*1d0/2d0*facRR     ! qb Qb -> qb Qb g g      sC2g0X
      case(207)
         factor=1d0/nc**2*nf*facRR          ! qb g -> qb Qb Q g       sC2g0X
      case(208)
         factor=1d0/nc**2*nf*facRR          ! g qb -> qb Qb Q g       sC2g0X
      case(209)
         factor=1d0/nc**2*1d0/2d0*nf**2*facRR   ! g g -> qb q Qb Q        sC2g0X
      case(210)
         factor=1d0/nc**3*1d0/2d0*nf**2*facRR   ! q qb -> Qb Q Rb R       E0g0X
      case(211)
         factor=1d0/nc**3*nf*facRR          ! q Q -> q Q Rb R         E0g0X
      case(212)
         factor=1d0/nc**3*nf*facRR          ! q Qb -> q Qb Rb R       E0g0X
      case(213)
         factor=1d0/nc**3*1d0/2d0*nf**2*facRR   ! qb q -> Qb Q Rb R       E0g0X
      case(214)
         factor=1d0/nc**3*nf*facRR          ! qb Q -> qb Q Rb R       E0g0X
      case(215)
         factor=1d0/nc**3*nf*facRR          ! qb Qb -> qb Qb Rb R     E0g0X
      case(216)
         factor=2d0/nc**2*2d0*1d0/24d0*facRR   ! g g -> g g g g          At6g0
      case(217)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! q g -> g g g q          Bt4g0
      case(218)
         factor=-1d0/nc**3*1d0/24d0*facRR   ! q qb -> g g g g         Bt4g0
      case(219)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! g q -> g g g q          Bt4g0
      case(220)
         factor=-1d0/nc**3*1d0/24d0*facRR   ! qb q -> g g g g         Bt4g0
      case(221)
         factor=-1d0/nc**3*1d0/2d0*nf*facRR   ! g g -> qb g g q         Bt4g0
      case(222)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! g qb -> qb g g g        Bt4g0
      case(223)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! qb g -> qb g g g        Bt4g0
      case(224)
         factor=1d0/nc**5*1d0/6d0*facRR     ! q gt -> gt g g q        Btt4g0
      case(225)
         factor=1d0/nc**5*1d0/24d0*facRR    ! q qb -> gt gt g g       Btt4g0
      case(226)
         factor=1d0/nc**5*1d0/6d0*facRR     ! gt q -> gt g g q        Btt4g0
      case(227)
         factor=1d0/nc**5*1d0/24d0*facRR    ! qb q -> gt gt g g       Btt4g0
      case(228)
         factor=1d0/nc**5*1d0/6d0*facRR     ! gt qb -> qb gt g g      Btt4g0
      case(229)
         factor=1d0/nc**5*1d0/6d0*facRR     ! qb gt -> qb gt g g      Btt4g0
      case(230)
         factor=1d0/nc**5*1d0/2d0*nf*facRR   ! g g -> qb gt gt q       Btt4g0
      case(231)
         factor=1d0/nc**3*1d0/6d0*facRR     ! q gt -> gt gt gt q      Bttt4g0
      case(232)
         factor=1d0/nc**3*1d0/24d0*facRR    ! q qb -> gt gt gt gt     Bttt4g0
      case(233)
         factor=1d0/nc**3*1d0/6d0*facRR     ! gt q -> gt gt gt q      Bttt4g0
      case(234)
         factor=1d0/nc**3*1d0/24d0*facRR    ! qb q -> gt gt gt gt     Bttt4g0
      case(235)
         factor=1d0/nc**3*1d0/2d0*nf*facRR   ! gt gt -> qb gt gt q     Bttt4g0
      case(236)
         factor=1d0/nc**3*1d0/6d0*facRR     ! gt qb -> qb gt gt gt     Bttt4g0
      case(237)
         factor=1d0/nc**3*1d0/6d0*facRR     ! qb gt -> qb gt gt gt     Bttt4g0
      case(238)
         factor=-3/nc**5*1d0/6d0*facRR      ! q gt -> gt gt gt q      Bttt4g0
      case(239)
         factor=-3/nc**5*1d0/24d0*facRR     ! q qb -> gt gt gt gt     Bttt4g0
      case(240)
         factor=-3/nc**5*1d0/6d0*facRR      ! gt q -> gt gt gt q      Bttt4g0
      case(241)
         factor=-3/nc**5*1d0/24d0*facRR     ! qb q -> gt gt gt gt     Bttt4g0
      case(242)
         factor=-3/nc**5*1d0/2d0*nf*facRR   ! gt gt -> qb gt gt q     Bttt4g0
      case(243)
         factor=-3/nc**5*1d0/6d0*facRR      ! gt qb -> qb gt gt gt     Bttt4g0
      case(244)
         factor=-3/nc**5*1d0/6d0*facRR      ! qb gt -> qb gt gt gt     Bttt4g0
      case(245)
         factor=-1d0/nc**7*1d0/6d0*facRR    ! q gt -> gt gt gt q      Bttt4g0
      case(246)
         factor=-1d0/nc**7*1d0/24d0*facRR   ! q qb -> gt gt gt gt     Bttt4g0
      case(247)
         factor=-1d0/nc**7*1d0/6d0*facRR    ! gt q -> gt gt gt q      Bttt4g0
      case(248)
         factor=-1d0/nc**7*1d0/24d0*facRR   ! qb q -> gt gt gt gt     Bttt4g0
      case(249)
         factor=-1d0/nc**7*1d0/2d0*nf*facRR   ! gt gt -> qb gt gt q     Bttt4g0
      case(250)
         factor=-1d0/nc**7*1d0/6d0*facRR    ! gt qb -> qb gt gt gt     Bttt4g0
      case(251)
         factor=-1d0/nc**7*1d0/6d0*facRR    ! qb gt -> qb gt gt gt     Bttt4g0
      case(252)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! q gt -> gt gt gt q      R4g0
      case(253)
         factor=-1d0/nc**3*1d0/24d0*facRR   ! q qb -> gt gt gt gt     R4g0
      case(254)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! gt q -> gt gt gt q      R4g0
      case(255)
         factor=-1d0/nc**3*1d0/24d0*facRR   ! qb q -> gt gt gt gt     R4g0
      case(256)
         factor=-1d0/nc**3*1d0/2d0*nf*facRR   ! gt gt -> qb gt gt q     R4g0
      case(257)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! gt qb -> qb gt gt gt     R4g0
      case(258)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! qb gt -> qb gt gt gt     R4g0
      case(259)
         factor=1d0/nc**4*1d0/2d0*nf*facRR   ! q qb -> Qb Q gt gt      sCt2g0
      case(260)
         factor=1d0/nc**4*1d0/2d0*facRR     ! q Q -> q Q gt gt        sCt2g0
      case(261)
         factor=1d0/nc**4*1d0/2d0*facRR     ! q Qb -> q Qb gt gt      sCt2g0
      case(262)
         factor=1d0/nc**4*nf*facRR          ! q gt -> q Qb Q gt       sCt2g0
      case(263)
         factor=1d0/nc**4*1d0/2d0*nf*facRR   ! qb q -> Qb Q gt gt      sCt2g0
      case(264)
         factor=1d0/nc**4*nf*facRR          ! gt q -> q Qb Q gt       sCt2g0
      case(265)
         factor=1d0/nc**4*1d0/2d0*facRR     ! qb Q -> qb Q gt gt      sCt2g0
      case(266)
         factor=1d0/nc**4*1d0/2d0*facRR     ! qb Qb -> qb Qb gt gt     sCt2g0
      case(267)
         factor=1d0/nc**4*nf*facRR          ! qb gt -> qb Qb Q gt     sCt2g0
      case(268)
         factor=1d0/nc**4*nf*facRR          ! gt qb -> qb Qb Q gt     sCt2g0
      case(269)
         factor=1d0/nc**4*1d0/2d0*nf**2*facRR   ! gt gt -> qb q Qb Q      sCt2g0
      case(270)
         factor=1d0/nc**6*1d0/2d0*nf*facRR   ! q qb -> Qb Q gt gt      sCtt2g0
      case(271)
         factor=1d0/nc**6*1d0/2d0*facRR     ! q Q -> q Q gt gt        sCtt2g0
      case(272)
         factor=1d0/nc**6*1d0/2d0*facRR     ! q Qb -> q Qb gt gt      sCtt2g0
      case(273)
         factor=1d0/nc**6*nf*facRR          ! q gt -> q Qb Q gt       sCtt2g0
      case(274)
         factor=1d0/nc**6*1d0/2d0*nf*facRR   ! qb q -> Qb Q gt gt      sCtt2g0
      case(275)
         factor=1d0/nc**6*nf*facRR          ! gt q -> q Qb Q gt       sCtt2g0
      case(276)
         factor=1d0/nc**6*1d0/2d0*facRR     ! qb Q -> qb Q gt gt      sCtt2g0
      case(277)
         factor=1d0/nc**6*1d0/2d0*facRR     ! qb Qb -> qb Qb gt gt     sCtt2g0
      case(278)
         factor=1d0/nc**6*nf*facRR          ! qb gt -> qb Qb Q gt     sCtt2g0
      case(279)
         factor=1d0/nc**6*nf*facRR          ! gt qb -> qb Qb Q gt     sCtt2g0
      case(280)
         factor=1d0/nc**6*1d0/2d0*nf**2*facRR   ! gt gt -> qb q Qb Q      sCtt2g0
      case(281)
         factor=1d0/nc**3*1d0/2d0*facRR     ! q qb -> qb q gt gt      D2g0full
      case(282)
         factor=1d0/nc**3*1d0/4d0*facRR     ! q q -> q q gt gt        D2g0full
      case(283)
         factor=1d0/nc**3*1d0/2d0*facRR     ! q gt -> q qb q gt       D2g0full
      case(284)
         factor=1d0/nc**3*1d0/2d0*facRR     ! qb q -> qb q gt gt      D2g0full
      case(285)
         factor=1d0/nc**3*1d0/2d0*facRR     ! gt q -> q qb q gt       D2g0full
      case(286)
         factor=1d0/nc**3*1d0/4d0*facRR     ! qb qb -> qb qb gt gt     D2g0full
      case(287)
         factor=1d0/nc**3*1d0/2d0*facRR     ! qb gt -> qb qb q gt     D2g0full
      case(288)
         factor=1d0/nc**3*1d0/2d0*facRR     ! gt qb -> qb qb q gt     D2g0full
      case(289)
         factor=1d0/nc**3*1d0/4d0*nf*facRR   ! gt gt -> qb q qb q      D2g0full
      case(290)
         factor=1d0/nc**5*1d0/2d0*facRR     ! q qb -> qb q gt gt      Dt2g0full
      case(291)
         factor=1d0/nc**5*1d0/4d0*facRR     ! q q -> q q gt gt        Dt2g0full
      case(292)
         factor=1d0/nc**5*1d0/2d0*facRR     ! q gt -> q qb q gt       Dt2g0full
      case(293)
         factor=1d0/nc**5*1d0/2d0*facRR     ! qb q -> qb q gt gt      Dt2g0full
      case(294)
         factor=1d0/nc**5*1d0/2d0*facRR     ! gt q -> q qb q gt       Dt2g0full
      case(295)
         factor=1d0/nc**5*1d0/4d0*facRR     ! qb qb -> qb qb gt gt     Dt2g0full
      case(296)
         factor=1d0/nc**5*1d0/2d0*facRR     ! qb gt -> qb qb q gt     Dt2g0full
      case(297)
         factor=1d0/nc**5*1d0/2d0*facRR     ! gt qb -> qb qb q gt     Dt2g0full
      case(298)
         factor=1d0/nc**5*1d0/4d0*nf*facRR   ! gt gt -> qb q qb q      Dt2g0full
      case(299)
         factor=1d0/nc**7*1d0/2d0*facRR     ! q qb -> qb q gt gt      Dtt2g0full
      case(300)
         factor=1d0/nc**7*1d0/4d0*facRR     ! q q -> q q gt gt        Dtt2g0full
      case(301)
         factor=1d0/nc**7*1d0/2d0*facRR     ! q gt -> q qb q gt       Dtt2g0full
      case(302)
         factor=1d0/nc**7*1d0/2d0*facRR     ! qb q -> qb q gt gt      Dtt2g0full
      case(303)
         factor=1d0/nc**7*1d0/2d0*facRR     ! gt q -> q qb q gt       Dtt2g0full
      case(304)
         factor=1d0/nc**7*1d0/4d0*facRR     ! qb qb -> qb qb gt gt     Dtt2g0full
      case(305)
         factor=1d0/nc**7*1d0/2d0*facRR     ! qb gt -> qb qb q gt     Dtt2g0full
      case(306)
         factor=1d0/nc**7*1d0/2d0*facRR     ! gt qb -> qb qb q gt     Dtt2g0full
      case(307)
         factor=1d0/nc**7*1d0/4d0*nf*facRR   ! gt gt -> qb q qb q      Dtt2g0full
      case(308)
         factor=1d0/nc**5*1d0/2d0*nf**2*facRR   ! q qb -> Qb Q Rb R       Et0g0X
      case(309)
         factor=1d0/nc**5*nf*facRR          ! q Q -> q Q Rb R         Et0g0X
      case(310)
         factor=1d0/nc**5*nf*facRR          ! q Qb -> q Qb Rb R       Et0g0X
      case(311)
         factor=1d0/nc**5*1d0/2d0*nf**2*facRR   ! qb q -> Qb Q Rb R       Et0g0X
      case(312)
         factor=1d0/nc**5*nf*facRR          ! qb Q -> qb Q Rb R       Et0g0X
      case(313)
         factor=1d0/nc**5*nf*facRR          ! qb Qb -> qb Qb Rb R     Et0g0X
      case(314)
         factor=-3/nc**5*1d0/2d0*nf**2*facRR   ! q qb -> Qb Q Rb R       Ett0g0X
      case(315)
         factor=-3/nc**5*nf*facRR           ! q Q -> q Q Rb R         Ett0g0X
      case(316)
         factor=-3/nc**5*nf*facRR           ! q Qb -> q Qb Rb R       Ett0g0X
      case(317)
         factor=-3/nc**5*1d0/2d0*nf**2*facRR   ! qb q -> Qb Q Rb R       Ett0g0X
      case(318)
         factor=-3/nc**5*nf*facRR           ! qb Q -> qb Q Rb R       Ett0g0X
      case(319)
         factor=-3/nc**5*nf*facRR           ! qb Qb -> qb Qb Rb R     Ett0g0X
      case(320)
         factor=-1d0/nc**4*nf*facRR         ! q qb -> qb q Qb Q       F0g0X
      case(321)
         factor=-1d0/nc**4*1d0/2d0*nf*facRR   ! q q -> q q Qb Q         F0g0X
      case(322)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! q Q -> q qb q Q         F0g0X
      case(323)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! q Qb -> q qb q Qb       F0g0X
      case(324)
         factor=-1d0/nc**4*nf*facRR         ! qb q -> qb q Qb Q       F0g0X
      case(325)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! Q q -> q qb q Q         F0g0X
      case(326)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! Qb q -> q qb q Qb       F0g0X
      case(327)
         factor=-1d0/nc**4*1d0/2d0*nf*facRR   ! qb qb -> qb qb Qb Q     F0g0X
      case(328)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! qb Q -> qb qb q Q       F0g0X
      case(329)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! qb Qb -> qb qb q Qb     F0g0X
      case(330)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! Q qb -> qb qb q Q       F0g0X
      case(331)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! Qb qb -> qb qb q Qb     F0g0X
      case(332)
         factor=-1d0/nc**4*1d0/4d0*nf*facRR   ! Q Qb -> qb q qb q       F0g0X
      case(333)
         factor=-1d0/nc**4*1d0/4d0*nf*facRR   ! Qb Q -> qb q qb q       F0g0X
      case(334)
         factor=-1d0/nc**4*nf*facRR         ! q qb -> qb q Qb Q       Ft0g0X
      case(335)
         factor=-1d0/nc**4*1d0/2d0*nf*facRR   ! q q -> q q Qb Q         Ft0g0X
      case(336)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! q Q -> q qb q Q         Ft0g0X
      case(337)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! q Qb -> q qb q Qb       Ft0g0X
      case(338)
         factor=-1d0/nc**4*nf*facRR         ! qb q -> qb q Qb Q       Ft0g0X
      case(339)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! Q q -> q qb q Q         Ft0g0X
      case(340)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! Qb q -> q qb q Qb       Ft0g0X
      case(341)
         factor=-1d0/nc**4*1d0/2d0*nf*facRR   ! qb qb -> qb qb Qb Q     Ft0g0X
      case(342)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! qb Q -> qb qb q Q       Ft0g0X
      case(343)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! qb Qb -> qb qb q Qb     Ft0g0X
      case(344)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! Q qb -> qb qb q Q       Ft0g0X
      case(345)
         factor=-1d0/nc**4*1d0/2d0*facRR    ! Qb qb -> qb qb q Qb     Ft0g0X
      case(346)
         factor=-1d0/nc**4*1d0/4d0*nf*facRR   ! Q Qb -> qb q qb q       Ft0g0X
      case(347)
         factor=-1d0/nc**4*1d0/4d0*nf*facRR   ! Qb Q -> qb q qb q       Ft0g0X
      case(348)
         factor=1d0/nc**6*nf*facRR          ! q qb -> qb q Qb Q       Ft0g0X
      case(349)
         factor=1d0/nc**6*1d0/2d0*nf*facRR   ! q q -> q q Qb Q         Ft0g0X
      case(350)
         factor=1d0/nc**6*1d0/2d0*facRR     ! q Q -> q qb q Q         Ft0g0X
      case(351)
         factor=1d0/nc**6*1d0/2d0*facRR     ! q Qb -> q qb q Qb       Ft0g0X
      case(352)
         factor=1d0/nc**6*nf*facRR          ! qb q -> qb q Qb Q       Ft0g0X
      case(353)
         factor=1d0/nc**6*1d0/2d0*facRR     ! Q q -> q qb q Q         Ft0g0X
      case(354)
         factor=1d0/nc**6*1d0/2d0*facRR     ! Qb q -> q qb q Qb       Ft0g0X
      case(355)
         factor=1d0/nc**6*1d0/2d0*nf*facRR   ! qb qb -> qb qb Qb Q     Ft0g0X
      case(356)
         factor=1d0/nc**6*1d0/2d0*facRR     ! qb Q -> qb qb q Q       Ft0g0X
      case(357)
         factor=1d0/nc**6*1d0/2d0*facRR     ! qb Qb -> qb qb q Qb     Ft0g0X
      case(358)
         factor=1d0/nc**6*1d0/2d0*facRR     ! Q qb -> qb qb q Q       Ft0g0X
      case(359)
         factor=1d0/nc**6*1d0/2d0*facRR     ! Qb qb -> qb qb q Qb     Ft0g0X
      case(360)
         factor=1d0/nc**6*1d0/4d0*nf*facRR   ! Q Qb -> qb q qb q       Ft0g0X
      case(361)
         factor=1d0/nc**6*1d0/4d0*nf*facRR   ! Qb Q -> qb q qb q       Ft0g0X
      case(362)
         factor=3/nc**4*nf*facRR            ! q qb -> qb q Qb Q       Ftt0g0X
      case(363)
         factor=3/nc**4*1d0/2d0*nf*facRR    ! q q -> q q Qb Q         Ftt0g0X
      case(364)
         factor=3/nc**4*1d0/2d0*facRR       ! q Q -> q qb q Q         Ftt0g0X
      case(365)
         factor=3/nc**4*1d0/2d0*facRR       ! q Qb -> q qb q Qb       Ftt0g0X
      case(366)
         factor=3/nc**4*nf*facRR            ! qb q -> qb q Qb Q       Ftt0g0X
      case(367)
         factor=3/nc**4*1d0/2d0*facRR       ! Q q -> q qb q Q         Ftt0g0X
      case(368)
         factor=3/nc**4*1d0/2d0*facRR       ! Qb q -> q qb q Qb       Ftt0g0X
      case(369)
         factor=3/nc**4*1d0/2d0*nf*facRR    ! qb qb -> qb qb Qb Q     Ftt0g0X
      case(370)
         factor=3/nc**4*1d0/2d0*facRR       ! qb Q -> qb qb q Q       Ftt0g0X
      case(371)
         factor=3/nc**4*1d0/2d0*facRR       ! qb Qb -> qb qb q Qb     Ftt0g0X
      case(372)
         factor=3/nc**4*1d0/2d0*facRR       ! Q qb -> qb qb q Q       Ftt0g0X
      case(373)
         factor=3/nc**4*1d0/2d0*facRR       ! Qb qb -> qb qb q Qb     Ftt0g0X
      case(374)
         factor=3/nc**4*1d0/4d0*nf*facRR    ! Q Qb -> qb q qb q       Ftt0g0X
      case(375)
         factor=3/nc**4*1d0/4d0*nf*facRR    ! Qb Q -> qb q qb q       Ftt0g0X
      case(376)
         factor=-3/nc**6*nf*facRR           ! q qb -> qb q Qb Q       Ftt0g0X
      case(377)
         factor=-3/nc**6*1d0/2d0*nf*facRR   ! q q -> q q Qb Q         Ftt0g0X
      case(378)
         factor=-3/nc**6*1d0/2d0*facRR      ! q Q -> q qb q Q         Ftt0g0X
      case(379)
         factor=-3/nc**6*1d0/2d0*facRR      ! q Qb -> q qb q Qb       Ftt0g0X
      case(380)
         factor=-3/nc**6*nf*facRR           ! qb q -> qb q Qb Q       Ftt0g0X
      case(381)
         factor=-3/nc**6*1d0/2d0*facRR      ! Q q -> q qb q Q         Ftt0g0X
      case(382)
         factor=-3/nc**6*1d0/2d0*facRR      ! Qb q -> q qb q Qb       Ftt0g0X
      case(383)
         factor=-3/nc**6*1d0/2d0*nf*facRR   ! qb qb -> qb qb Qb Q     Ftt0g0X
      case(384)
         factor=-3/nc**6*1d0/2d0*facRR      ! qb Q -> qb qb q Q       Ftt0g0X
      case(385)
         factor=-3/nc**6*1d0/2d0*facRR      ! qb Qb -> qb qb q Qb     Ftt0g0X
      case(386)
         factor=-3/nc**6*1d0/2d0*facRR      ! Q qb -> qb qb q Q       Ftt0g0X
      case(387)
         factor=-3/nc**6*1d0/2d0*facRR      ! Qb qb -> qb qb q Qb     Ftt0g0X
      case(388)
         factor=-3/nc**6*1d0/4d0*nf*facRR   ! Q Qb -> qb q qb q       Ftt0g0X
      case(389)
         factor=-3/nc**6*1d0/4d0*nf*facRR   ! Qb Q -> qb q qb q       Ftt0g0X
      case(390)
         factor=1d0/nc**3*1d0/4d0*facRR     ! q qb -> qb q qb q       G0g0X
      case(391)
         factor=1d0/nc**3*1d0/6d0*facRR     ! q q -> q q qb q         G0g0X
      case(392)
         factor=1d0/nc**3*1d0/4d0*facRR     ! qb q -> qb q qb q       G0g0X
      case(393)
         factor=1d0/nc**3*1d0/6d0*facRR     ! qb qb -> qb qb qb q     G0g0X
      case(394)
         factor=1d0/nc**5*1d0/4d0*facRR     ! q qb -> qb q qb q       Gt0g0X
      case(395)
         factor=1d0/nc**5*1d0/6d0*facRR     ! q q -> q q qb q         Gt0g0X
      case(396)
         factor=1d0/nc**5*1d0/4d0*facRR     ! qb q -> qb q qb q       Gt0g0X
      case(397)
         factor=1d0/nc**5*1d0/6d0*facRR     ! qb qb -> qb qb qb q     Gt0g0X
      case(398)
         factor=-1d0/nc**5*1d0/4d0*facRR    ! q qb -> qb q qb q       Gtt0g0X
      case(399)
         factor=-1d0/nc**5*1d0/6d0*facRR    ! q q -> q q qb q         Gtt0g0X
      case(400)
         factor=-1d0/nc**5*1d0/4d0*facRR    ! qb q -> qb q qb q       Gtt0g0X
      case(401)
         factor=-1d0/nc**5*1d0/6d0*facRR    ! qb qb -> qb qb qb q     Gtt0g0X
      case(402)
         factor=-1d0/nc**7*1d0/4d0*facRR    ! q qb -> qb q qb q       Gtt0g0X
      case(403)
         factor=-1d0/nc**7*1d0/6d0*facRR    ! q q -> q q qb q         Gtt0g0X
      case(404)
         factor=-1d0/nc**7*1d0/4d0*facRR    ! qb q -> qb q qb q       Gtt0g0X
      case(405)
         factor=-1d0/nc**7*1d0/6d0*facRR    ! qb qb -> qb qb qb q     Gtt0g0X

c -- real virtual

      case(406)
         factor=2d0*1d0/6d0*facRV           ! g g -> g g g            A5g1
      case(407)
         factor=1d0/nc*facRV                ! g q subtraction         A5g1
      case(408)
         factor=1d0/nc*facRV                ! g qb subtraction        A5g1
      case(409)
         factor=1d0/nc*facRV                ! q g subtraction         A5g1
      case(410)
         factor=1d0/nc*facRV                ! qb g subtraction        A5g1
      case(411)
         factor=1d0/nc*nf*2d0*1d0/6d0*facRV   ! g g -> g g g            Ah5g1
      case(412)
         factor=1d0/nc**2*nf*facRV          ! g q subtraction         Ah5g1
      case(413)
         factor=1d0/nc**2*nf*facRV          ! g qb subtraction        Ah5g1
      case(414)
         factor=1d0/nc**2*nf*facRV          ! q g subtraction         Ah5g1
      case(415)
         factor=1d0/nc**2*nf*facRV          ! qb g subtraction        Ah5g1
      case(416)
         factor=1d0/nc*1d0/2d0*facRV        ! q g -> g g q            B3g1
      case(417)
         factor=1d0/nc*1d0/6d0*facRV        ! q qb -> g g g           B3g1
      case(418)
         factor=1d0/nc*1d0/2d0*facRV        ! g q -> g g q            B3g1
      case(419)
         factor=1d0/nc*1d0/6d0*facRV        ! qb q -> g g g           B3g1
      case(420)
         factor=1d0/nc*nf*facRV             ! g g -> qb g q           B3g1
      case(421)
         factor=1d0/nc*1d0/2d0*facRV        ! g qb -> qb g g          B3g1
      case(422)
         factor=1d0/nc*1d0/2d0*facRV        ! qb g -> qb g g          B3g1
      case(423)
         factor=1d0/nc**2*facRV             ! q Q subtraction         B3g1
      case(424)
         factor=1d0/nc**2*facRV             ! q Qb subtraction        B3g1
      case(425)
         factor=1d0/nc**2*facRV             ! qb Q subtraction        B3g1
      case(426)
         factor=1d0/nc**2*facRV             ! qb Qb subtraction       B3g1
      case(427)
         factor=1d0/nc**2*nf*1d0/2d0*facRV   ! q g -> g g q            Bh3g1
      case(428)
         factor=1d0/nc**2*nf*1d0/6d0*facRV   ! q qb -> g g g           Bh3g1
      case(429)
         factor=1d0/nc**2*nf*1d0/2d0*facRV   ! g q -> g g q            Bh3g1
      case(430)
         factor=1d0/nc**2*nf*1d0/6d0*facRV   ! qb q -> g g g           Bh3g1
      case(431)
         factor=1d0/nc**2*nf*nf*facRV       ! g g -> qb g q           Bh3g1
      case(432)
         factor=1d0/nc**2*nf*1d0/2d0*facRV   ! g qb -> qb g g          Bh3g1
      case(433)
         factor=1d0/nc**2*nf*1d0/2d0*facRV   ! qb g -> qb g g          Bh3g1
      case(434)
         factor=1d0/nc**3*nf*facRV          ! q Q subtraction         Bh3g1
      case(435)
         factor=1d0/nc**3*nf*facRV          ! q Qb subtraction        Bh3g1
      case(436)
         factor=1d0/nc**3*nf*facRV          ! qb Q subtraction        Bh3g1
      case(437)
         factor=1d0/nc**3*nf*facRV          ! qb Qb subtraction       Bh3g1
      case(438)
         factor=1d0/nc**2*nf*facRV          ! q qb -> Qb Q g          sC1g1X
      case(439)
         factor=1d0/nc**2*facRV             ! q Q -> q Q g            sC1g1X
      case(440)
         factor=1d0/nc**2*facRV             ! q Qb -> q Qb g          sC1g1X
      case(441)
         factor=1d0/nc**2*nf*facRV          ! q g -> q Qb Q           sC1g1X
      case(442)
         factor=1d0/nc**2*nf*facRV          ! qb q -> Qb Q g          sC1g1X
      case(443)
         factor=1d0/nc**2*nf*facRV          ! g q -> q Qb Q           sC1g1X
      case(444)
         factor=1d0/nc**2*facRV             ! qb Q -> qb Q g          sC1g1X
      case(445)
         factor=1d0/nc**2*facRV             ! qb Qb -> qb Qb g        sC1g1X
      case(446)
         factor=1d0/nc**2*nf*facRV          ! qb g -> qb Qb Q         sC1g1X
      case(447)
         factor=1d0/nc**2*nf*facRV          ! g qb -> qb Qb Q         sC1g1X
      case(448)
         factor=1d0/nc**2*nf**2*facRV       ! g g subtraction         sC1g1X
      case(449)
         factor=1d0/nc**3*nf*nf*facRV       ! q qb -> Qb Q g          sCh1g1X
      case(450)
         factor=1d0/nc**3*nf*facRV          ! q Q -> q Q g            sCh1g1X
      case(451)
         factor=1d0/nc**3*nf*facRV          ! q Qb -> q Qb g          sCh1g1X
      case(452)
         factor=1d0/nc**3*nf*nf*facRV       ! q g -> q Qb Q           sCh1g1X
      case(453)
         factor=1d0/nc**3*nf*nf*facRV       ! qb q -> Qb Q g          sCh1g1X
      case(454)
         factor=1d0/nc**3*nf*nf*facRV       ! g q -> q Qb Q           sCh1g1X
      case(455)
         factor=1d0/nc**3*nf*facRV          ! qb Q -> qb Q g          sCh1g1X
      case(456)
         factor=1d0/nc**3*nf*facRV          ! qb Qb -> qb Qb g        sCh1g1X
      case(457)
         factor=1d0/nc**3*nf*nf*facRV       ! qb g -> qb Qb Q         sCh1g1X
      case(458)
         factor=1d0/nc**3*nf*nf*facRV       ! g qb -> qb Qb Q         sCh1g1X
      case(459)
         factor=1d0/nc**3*nf**3*facRV       ! g g subtraction         sCh1g1X
      case(460)
         factor=12d0/nc**2*2d0*1d0/6d0*facRV   ! g g -> g g g            At5g1
      case(461)
         factor=12d0/nc**3*facRV            ! g q subtraction         At5g1
      case(462)
         factor=12d0/nc**3*facRV            ! g qb subtraction        At5g1
      case(463)
         factor=12d0/nc**3*facRV            ! q g subtraction         At5g1
      case(464)
         factor=12d0/nc**3*facRV            ! qb g subtraction        At5g1
      case(465)
         factor=2d0/nc**3*nf*2d0*1d0/6d0*facRV   ! g g -> g g g            Ath5g1
      case(466)
         factor=2d0/nc**4*nf*facRV          ! g q subtraction         Ath5g1
      case(467)
         factor=2d0/nc**4*nf*facRV          ! g qb subtraction        Ath5g1
      case(468)
         factor=2d0/nc**4*nf*facRV          ! q g subtraction         Ath5g1
      case(469)
         factor=2d0/nc**4*nf*facRV          ! qb g subtraction        Ath5g1
      case(470)
         factor=1d0/nc**3*1d0/2d0*facRV     ! q gt -> gt gt q         Bt3g1
      case(471)
         factor=1d0/nc**3*1d0/6d0*facRV     ! q qb -> gt gt gt        Bt3g1
      case(472)
         factor=1d0/nc**3*1d0/2d0*facRV     ! gt q -> gt gt q         Bt3g1
      case(473)
         factor=1d0/nc**3*1d0/6d0*facRV     ! qb q -> gt gt gt        Bt3g1
      case(474)
         factor=1d0/nc**3*nf*facRV          ! gt gt -> qb gt q        Bt3g1
      case(475)
         factor=1d0/nc**3*1d0/2d0*facRV     ! gt qb -> qb gt gt       Bt3g1
      case(476)
         factor=1d0/nc**3*1d0/2d0*facRV     ! qb gt -> qb gt gt       Bt3g1
      case(477)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! q gt -> gt gt q         Bth3g1
      case(478)
         factor=1d0/nc**4*nf*1d0/6d0*facRV   ! q qb -> gt gt gt        Bth3g1
      case(479)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! gt q -> gt gt q         Bth3g1
      case(480)
         factor=1d0/nc**4*nf*1d0/6d0*facRV   ! qb q -> gt gt gt        Bth3g1
      case(481)
         factor=1d0/nc**4*nf*nf*facRV       ! gt gt -> qb gt q        Bth3g1
      case(482)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! gt qb -> qb gt gt       Bth3g1
      case(483)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! qb gt -> qb gt gt       Bth3g1
      case(484)
         factor=1d0/nc**5*1d0/2d0*facRV     ! q gt -> gt gt q         Btt3g1
      case(485)
         factor=1d0/nc**5*1d0/6d0*facRV     ! q qb -> gt gt gt        Btt3g1
      case(486)
         factor=1d0/nc**5*1d0/2d0*facRV     ! gt q -> gt gt q         Btt3g1
      case(487)
         factor=1d0/nc**5*1d0/6d0*facRV     ! qb q -> gt gt gt        Btt3g1
      case(488)
         factor=1d0/nc**5*nf*facRV          ! gt gt -> qb gt q        Btt3g1
      case(489)
         factor=1d0/nc**5*1d0/2d0*facRV     ! gt qb -> qb gt gt       Btt3g1
      case(490)
         factor=1d0/nc**5*1d0/2d0*facRV     ! qb gt -> qb gt gt       Btt3g1
      case(491)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! q gt -> gt gt q         Btth3g1
      case(492)
         factor=1d0/nc**6*nf*1d0/6d0*facRV   ! q qb -> gt gt gt        Btth3g1
      case(493)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! gt q -> gt gt q         Btth3g1
      case(494)
         factor=1d0/nc**6*nf*1d0/6d0*facRV   ! qb q -> gt gt gt        Btth3g1
      case(495)
         factor=1d0/nc**6*nf*nf*facRV       ! gt gt -> qb gt q        Btth3g1
      case(496)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! gt qb -> qb gt gt       Btth3g1
      case(497)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! qb gt -> qb gt gt       Btth3g1
      case(498)
         factor=1d0/nc**7*1d0/2d0*facRV     ! q gt -> gt gt q         Bttt3g1
      case(499)
         factor=1d0/nc**7*1d0/6d0*facRV     ! q qb -> gt gt gt        Bttt3g1
      case(500)
         factor=1d0/nc**7*1d0/2d0*facRV     ! gt q -> gt gt q         Bttt3g1
      case(501)
         factor=1d0/nc**7*1d0/6d0*facRV     ! qb q -> gt gt gt        Bttt3g1
      case(502)
         factor=1d0/nc**7*nf*facRV          ! gt gt -> qb gt q        Bttt3g1
      case(503)
         factor=1d0/nc**7*1d0/2d0*facRV     ! gt qb -> qb gt gt       Bttt3g1
      case(504)
         factor=1d0/nc**7*1d0/2d0*facRV     ! qb gt -> qb gt gt       Bttt3g1
      case(505)
         factor=1d0/nc**4*nf*facRV          ! q qb -> Qb Q g          sCt1g1
      case(506)
         factor=1d0/nc**4*facRV             ! q Q -> q Q g            sCt1g1
      case(507)
         factor=1d0/nc**4*facRV             ! q Qb -> q Qb g          sCt1g1
      case(508)
         factor=1d0/nc**4*nf*facRV          ! q g -> q Qb Q           sCt1g1
      case(509)
         factor=1d0/nc**4*nf*facRV          ! qb q -> Qb Q g          sCt1g1
      case(510)
         factor=1d0/nc**4*nf*facRV          ! g q -> q Qb Q           sCt1g1
      case(511)
         factor=1d0/nc**4*facRV             ! qb Q -> qb Q g          sCt1g1
      case(512)
         factor=1d0/nc**4*facRV             ! qb Qb -> qb Qb g        sCt1g1
      case(513)
         factor=1d0/nc**4*nf*facRV          ! qb g -> qb Qb Q         sCt1g1
      case(514)
         factor=1d0/nc**4*nf*facRV          ! g qb -> qb Qb Q         sCt1g1
      case(515)
         factor=1d0/nc**4*nf**2*facRV       ! g g subtraction         sCt1g1
      case(516)
         factor=1d0/nc**5*nf*nf*facRV       ! q qb -> Qb Q g          Cth1g1
      case(517)
         factor=1d0/nc**5*nf*facRV          ! q Q -> q Q g            Cth1g1
      case(518)
         factor=1d0/nc**5*nf*facRV          ! q Qb -> q Qb g          Cth1g1
      case(519)
         factor=1d0/nc**5*nf*nf*facRV       ! q g -> q Qb Q           Cth1g1
      case(520)
         factor=1d0/nc**5*nf*nf*facRV       ! qb q -> Qb Q g          Cth1g1
      case(521)
         factor=1d0/nc**5*nf*nf*facRV       ! g q -> q Qb Q           Cth1g1
      case(522)
         factor=1d0/nc**5*nf*facRV          ! qb Q -> qb Q g          Cth1g1
      case(523)
         factor=1d0/nc**5*nf*facRV          ! qb Qb -> qb Qb g        Cth1g1
      case(524)
         factor=1d0/nc**5*nf*nf*facRV       ! qb g -> qb Qb Q         Cth1g1
      case(525)
         factor=1d0/nc**5*nf*nf*facRV       ! g qb -> qb Qb Q         Cth1g1
      case(526)
         factor=1d0/nc**5*nf**3*facRV       ! g g subtraction         Cth1g1
      case(527)
         factor=1d0/nc**6*nf*facRV          ! q qb -> Qb Q g          sCtt1g1
      case(528)
         factor=1d0/nc**6*facRV             ! q Q -> q Q g            sCtt1g1
      case(529)
         factor=1d0/nc**6*facRV             ! q Qb -> q Qb g          sCtt1g1
      case(530)
         factor=1d0/nc**6*nf*facRV          ! q g -> q Qb Q           sCtt1g1
      case(531)
         factor=1d0/nc**6*nf*facRV          ! qb q -> Qb Q g          sCtt1g1
      case(532)
         factor=1d0/nc**6*nf*facRV          ! g q -> q Qb Q           sCtt1g1
      case(533)
         factor=1d0/nc**6*facRV             ! qb Q -> qb Q g          sCtt1g1
      case(534)
         factor=1d0/nc**6*facRV             ! qb Qb -> qb Qb g        sCtt1g1
      case(535)
         factor=1d0/nc**6*nf*facRV          ! qb g -> qb Qb Q         sCtt1g1
      case(536)
         factor=1d0/nc**6*nf*facRV          ! g qb -> qb Qb Q         sCtt1g1
      case(537)
         factor=1d0/nc**6*nf**2*facRV       ! g g subtraction         sCtt1g1
      case(538)
         factor=1d0/nc**3*facRV             ! q qb -> qb q g          D1g1full
      case(539)
         factor=1d0/nc**3*1d0/2d0*facRV     ! q q -> q q g            D1g1full
      case(540)
         factor=1d0/nc**3*1d0/2d0*facRV     ! q g -> q qb q           D1g1full
      case(541)
         factor=1d0/nc**3*facRV             ! qb q -> qb q g          D1g1full
      case(542)
         factor=1d0/nc**3*1d0/2d0*facRV     ! g q -> q qb q           D1g1full
      case(543)
         factor=1d0/nc**3*1d0/2d0*facRV     ! qb qb -> qb qb g        D1g1full
      case(544)
         factor=1d0/nc**3*1d0/2d0*facRV     ! qb g -> qb qb q         D1g1full
      case(545)
         factor=1d0/nc**3*1d0/2d0*facRV     ! g qb -> qb qb q         D1g1full
      case(546)
         factor=1d0/nc**4*facRV             ! Q q subtraction         D1g1full
      case(547)
         factor=1d0/nc**4*facRV             ! Q qb subtraction        D1g1full
      case(548)
         factor=1d0/nc**4*facRV             ! Qb q subtraction        D1g1full
      case(549)
         factor=1d0/nc**4*facRV             ! Qb qb subtraction       D1g1full
      case(550)
         factor=1d0/nc**3*nf*facRV          ! g g subtraction         D1g1full
      case(551)
         factor=1d0/nc**4*facRV             ! q Q subtraction         D1g1full
      case(552)
         factor=1d0/nc**4*facRV             ! q Qb subtraction        D1g1full
      case(553)
         factor=1d0/nc**4*facRV             ! qb Q subtraction        D1g1full
      case(554)
         factor=1d0/nc**4*facRV             ! qb Qb subtraction       D1g1full
      case(555)
         factor=1d0/nc**4*nf*facRV          ! q qb -> qb q g          Dh1g1full
      case(556)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! q q -> q q g            Dh1g1full
      case(557)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! q g -> q qb q           Dh1g1full
      case(558)
         factor=1d0/nc**4*nf*facRV          ! qb q -> qb q g          Dh1g1full
      case(559)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! g q -> q qb q           Dh1g1full
      case(560)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! qb qb -> qb qb g        Dh1g1full
      case(561)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! qb g -> qb qb q         Dh1g1full
      case(562)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! g qb -> qb qb q         Dh1g1full
      case(563)
         factor=1d0/nc**5*nf*facRV          ! Q q subtraction         Dh1g1full
      case(564)
         factor=1d0/nc**5*nf*facRV          ! Q qb subtraction        Dh1g1full
      case(565)
         factor=1d0/nc**5*nf*facRV          ! Qb q subtraction        Dh1g1full
      case(566)
         factor=1d0/nc**5*nf*facRV          ! Qb qb subtraction       Dh1g1full
      case(567)
         factor=1d0/nc**4*nf**2*facRV       ! g g subtraction         Dh1g1full
      case(568)
         factor=1d0/nc**5*nf*facRV          ! q Q subtraction         Dh1g1full
      case(569)
         factor=1d0/nc**5*nf*facRV          ! q Qb subtraction        Dh1g1full
      case(570)
         factor=1d0/nc**5*nf*facRV          ! qb Q subtraction        Dh1g1full
      case(571)
         factor=1d0/nc**5*nf*facRV          ! qb Qb subtraction       Dh1g1full
      case(572)
         factor=1d0/nc**5*facRV             ! q qb -> qb q g          Dt1g1full
      case(573)
         factor=1d0/nc**5*1d0/2d0*facRV     ! q q -> q q g            Dt1g1full
      case(574)
         factor=1d0/nc**5*1d0/2d0*facRV     ! q g -> q qb q           Dt1g1full
      case(575)
         factor=1d0/nc**5*facRV             ! qb q -> qb q g          Dt1g1full
      case(576)
         factor=1d0/nc**5*1d0/2d0*facRV     ! g q -> q qb q           Dt1g1full
      case(577)
         factor=1d0/nc**5*1d0/2d0*facRV     ! qb qb -> qb qb g        Dt1g1full
      case(578)
         factor=1d0/nc**5*1d0/2d0*facRV     ! qb g -> qb qb q         Dt1g1full
      case(579)
         factor=1d0/nc**5*1d0/2d0*facRV     ! g qb -> qb qb q         Dt1g1full
      case(580)
         factor=1d0/nc**6*facRV             ! Q q subtraction         Dt1g1full
      case(581)
         factor=1d0/nc**6*facRV             ! Q qb subtraction        Dt1g1full
      case(582)
         factor=1d0/nc**6*facRV             ! Qb q subtraction        Dt1g1full
      case(583)
         factor=1d0/nc**6*facRV             ! Qb qb subtraction       Dt1g1full
      case(584)
         factor=1d0/nc**5*nf*facRV          ! g g subtraction         Dt1g1full
      case(585)
         factor=1d0/nc**6*facRV             ! q Q subtraction         Dt1g1full
      case(586)
         factor=1d0/nc**6*facRV             ! q Qb subtraction        Dt1g1full
      case(587)
         factor=1d0/nc**6*facRV             ! qb Q subtraction        Dt1g1full
      case(588)
         factor=1d0/nc**6*facRV             ! qb Qb subtraction       Dt1g1full
      case(589)
         factor=1d0/nc**6*nf*facRV          ! q qb -> qb q g          Dth1g1full
      case(590)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! q q -> q q g            Dth1g1full
      case(591)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! q g -> q qb q           Dth1g1full
      case(592)
         factor=1d0/nc**6*nf*facRV          ! qb q -> qb q g          Dth1g1full
      case(593)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! g q -> q qb q           Dth1g1full
      case(594)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! qb qb -> qb qb g        Dth1g1full
      case(595)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! qb g -> qb qb q         Dth1g1full
      case(596)
         factor=1d0/nc**6*nf*1d0/2d0*facRV   ! g qb -> qb qb q         Dth1g1full
      case(597)
         factor=1d0/nc**7*nf*facRV          ! Q q subtraction         Dth1g1full
      case(598)
         factor=1d0/nc**7*nf*facRV          ! Q qb subtraction        Dth1g1full
      case(599)
         factor=1d0/nc**7*nf*facRV          ! Qb q subtraction        Dth1g1full
      case(600)
         factor=1d0/nc**7*nf*facRV          ! Qb qb subtraction       Dth1g1full
      case(601)
         factor=1d0/nc**6*nf**2*facRV       ! g g subtraction         Dth1g1full
      case(602)
         factor=1d0/nc**7*nf*facRV          ! q Q subtraction         Dth1g1full
      case(603)
         factor=1d0/nc**7*nf*facRV          ! q Qb subtraction        Dth1g1full
      case(604)
         factor=1d0/nc**7*nf*facRV          ! qb Q subtraction        Dth1g1full
      case(605)
         factor=1d0/nc**7*nf*facRV          ! qb Qb subtraction       Dth1g1full
      case(606)
         factor=1d0/nc**7*facRV             ! q qb -> qb q g          Dtt1g1full
      case(607)
         factor=1d0/nc**7*1d0/2d0*facRV     ! q q -> q q g            Dtt1g1full
      case(608)
         factor=1d0/nc**7*1d0/2d0*facRV     ! q g -> q qb q           Dtt1g1full
      case(609)
         factor=1d0/nc**7*facRV             ! qb q -> qb q g          Dtt1g1full
      case(610)
         factor=1d0/nc**7*1d0/2d0*facRV     ! g q -> q qb q           Dtt1g1full
      case(611)
         factor=1d0/nc**7*1d0/2d0*facRV     ! qb qb -> qb qb g        Dtt1g1full
      case(612)
         factor=1d0/nc**7*1d0/2d0*facRV     ! qb g -> qb qb q         Dtt1g1full
      case(613)
         factor=1d0/nc**7*1d0/2d0*facRV     ! g qb -> qb qb q         Dtt1g1full
      case(614)
         factor=1d0/nc**8d0*facRV           ! Q q subtraction         Dtt1g1full
      case(615)
         factor=1d0/nc**8d0*facRV           ! Q qb subtraction        Dtt1g1full
      case(616)
         factor=1d0/nc**8d0*facRV           ! Qb q subtraction        Dtt1g1full
      case(617)
         factor=1d0/nc**8d0*facRV           ! Qb qb subtraction       Dtt1g1full
      case(618)
         factor=1d0/nc**7*nf*facRV          ! g g subtraction         Dtt1g1full
      case(619)
         factor=1d0/nc**8d0*facRV           ! q Q subtraction         Dtt1g1full
      case(620)
         factor=1d0/nc**8d0*facRV           ! q Qb subtraction        Dtt1g1full
      case(621)
         factor=1d0/nc**8d0*facRV           ! qb Q subtraction        Dtt1g1full
      case(622)
         factor=1d0/nc**8d0*facRV           ! qb Qb subtraction       Dtt1g1full

c -- double virtual

      case(623)
         factor=2d0*1d0/2d0*facVV           ! g g -> g g              A4g2
      case(624)
         factor=1d0/nc*facVV                ! g q subtraction         A4g2
      case(625)
         factor=1d0/nc*facVV                ! g qb subtraction        A4g2
      case(626)
         factor=1d0/nc**2*facVV             ! q Q subtraction         A4g2
      case(627)
         factor=1d0/nc**2*facVV             ! q Qb subtraction        A4g2
      case(628)
         factor=1d0/nc*facVV                ! q g subtraction         A4g2
      case(629)
         factor=1d0/nc**2*facVV             ! qb Q subtraction        A4g2
      case(630)
         factor=1d0/nc**2*facVV             ! qb Qb subtraction       A4g2
      case(631)
         factor=1d0/nc*facVV                ! qb g subtraction        A4g2
      case(632)
         factor=1d0/nc*nf*2d0*1d0/2d0*facVV   ! g g -> g g              Ah4g2
      case(633)
         factor=1d0/nc**2*nf*facVV          ! g q subtraction         Ah4g2
      case(634)
         factor=1d0/nc**2*nf*facVV          ! g qb subtraction        Ah4g2
      case(635)
         factor=1d0/nc**3*nf*facVV          ! q Q subtraction         Ah4g2
      case(636)
         factor=1d0/nc**3*nf*facVV          ! q Qb subtraction        Ah4g2
      case(637)
         factor=1d0/nc**2*nf*facVV          ! q g subtraction         Ah4g2
      case(638)
         factor=1d0/nc**3*nf*facVV          ! qb Q subtraction        Ah4g2
      case(639)
         factor=1d0/nc**3*nf*facVV          ! qb Qb subtraction       Ah4g2
      case(640)
         factor=1d0/nc**2*nf*facVV          ! qb g subtraction        Ah4g2
      case(641)
         factor=1d0/nc**2*nf**2*2d0*1d0/2d0*facVV   ! g g -> g g              Ahh4g2
      case(642)
         factor=1d0/nc**3*nf**2*facVV       ! g q subtraction         Ahh4g2
      case(643)
         factor=1d0/nc**3*nf**2*facVV       ! g qb subtraction        Ahh4g2
      case(644)
         factor=1d0/nc**4*nf**2*facVV       ! q Q subtraction         Ahh4g2
      case(645)
         factor=1d0/nc**4*nf**2*facVV       ! q Qb subtraction        Ahh4g2
      case(646)
         factor=1d0/nc**3*nf**2*facVV       ! q g subtraction         Ahh4g2
      case(647)
         factor=1d0/nc**4*nf**2*facVV       ! qb Q subtraction        Ahh4g2
      case(648)
         factor=1d0/nc**4*nf**2*facVV       ! qb Qb subtraction       Ahh4g2
      case(649)
         factor=1d0/nc**3*nf**2*facVV       ! qb g subtraction        Ahh4g2
      case(650)
         factor=1d0/nc*facVV                ! q g -> g q              B2g2
      case(651)
         factor=1d0/nc*1d0/2d0*facVV        ! q qb -> g g             B2g2
      case(652)
         factor=1d0/nc*facVV                ! g q -> g q              B2g2
      case(653)
         factor=1d0/nc*1d0/2d0*facVV        ! qb q -> g g             B2g2
      case(654)
         factor=1d0/nc*nf*facVV             ! g g -> qb q             B2g2
      case(655)
         factor=1d0/nc*facVV                ! g qb -> qb g            B2g2
      case(656)
         factor=1d0/nc*facVV                ! qb g -> qb g            B2g2
      case(657)
         factor=1d0/nc**2*facVV             ! q Q subtraction         B2g2
      case(658)
         factor=1d0/nc**2*facVV             ! q Qb subtraction        B2g2
      case(659)
         factor=1d0/nc**3*facVV             ! q q subtraction         B2g2
      case(660)
         factor=1d0/nc**2*facVV             ! qb Q subtraction        B2g2
      case(661)
         factor=1d0/nc**2*facVV             ! qb Qb subtraction       B2g2
      case(662)
         factor=1d0/nc**3*facVV             ! qb qb subtraction       B2g2
      case(663)
         factor=1d0/nc**2*nf*facVV          ! q g -> g q              Bh2g2
      case(664)
         factor=1d0/nc**2*nf*1d0/2d0*facVV   ! q qb -> g g             Bh2g2
      case(665)
         factor=1d0/nc**2*nf*facVV          ! g q -> g q              Bh2g2
      case(666)
         factor=1d0/nc**2*nf*1d0/2d0*facVV   ! qb q -> g g             Bh2g2
      case(667)
         factor=1d0/nc**2*nf*nf*facVV       ! g g -> qb q             Bh2g2
      case(668)
         factor=1d0/nc**2*nf*facVV          ! g qb -> qb g            Bh2g2
      case(669)
         factor=1d0/nc**2*nf*facVV          ! qb g -> qb g            Bh2g2
      case(670)
         factor=1d0/nc**2*nf*facVV          ! Q g subtraction         Bh2g2
      case(671)
         factor=1d0/nc**2*nf*facVV          ! Qb g subtraction        Bh2g2
      case(672)
         factor=1d0/nc**2*nf*facVV          ! g Q subtraction         Bh2g2
      case(673)
         factor=1d0/nc**2*nf*facVV          ! g Qb subtraction        Bh2g2
      case(674)
         factor=1d0/nc**3*nf*facVV          ! q Q subtraction         Bh2g2
      case(675)
         factor=1d0/nc**3*nf*facVV          ! q Qb subtraction        Bh2g2
      case(676)
         factor=1d0/nc**4*nf*facVV          ! q q subtraction         Bh2g2
      case(677)
         factor=1d0/nc**3*nf*facVV          ! qb Q subtraction        Bh2g2
      case(678)
         factor=1d0/nc**3*nf*facVV          ! qb Qb subtraction       Bh2g2
      case(679)
         factor=1d0/nc**4*nf*facVV          ! qb qb subtraction       Bh2g2
      case(680)
         factor=1d0/nc**3*nf**2*facVV       ! q g -> g q              Bhh2g2
      case(681)
         factor=1d0/nc**3*nf**2*1d0/2d0*facVV   ! q qb -> g g             Bhh2g2
      case(682)
         factor=1d0/nc**3*nf**2*facVV       ! g q -> g q              Bhh2g2
      case(683)
         factor=1d0/nc**3*nf**2*1d0/2d0*facVV   ! qb q -> g g             Bhh2g2
      case(684)
         factor=1d0/nc**3*nf**2*nf*facVV    ! g g -> qb q             Bhh2g2
      case(685)
         factor=1d0/nc**3*nf**2*facVV       ! g qb -> qb g            Bhh2g2
      case(686)
         factor=1d0/nc**3*nf**2*facVV       ! qb g -> qb g            Bhh2g2
      case(687)
         factor=1d0/nc**3*nf**2*facVV       ! Q g subtraction         Bhh2g2
      case(688)
         factor=1d0/nc**3*nf**2*facVV       ! Qb g subtraction        Bhh2g2
      case(689)
         factor=1d0/nc**3*nf**2*facVV       ! g Q subtraction         Bhh2g2
      case(690)
         factor=1d0/nc**3*nf**2*facVV       ! g Qb subtraction        Bhh2g2
      case(691)
         factor=1d0/nc**4*nf**2*facVV       ! q Q subtraction         Bhh2g2
      case(692)
         factor=1d0/nc**4*nf**2*facVV       ! q Qb subtraction        Bhh2g2
      case(693)
         factor=1d0/nc**5*nf**2*facVV       ! q q subtraction         Bhh2g2
      case(694)
         factor=1d0/nc**4*nf**2*facVV       ! qb Q subtraction        Bhh2g2
      case(695)
         factor=1d0/nc**4*nf**2*facVV       ! qb Qb subtraction       Bhh2g2
      case(696)
         factor=1d0/nc**5*nf**2*facVV       ! qb qb subtraction       Bhh2g2
      case(697)
         factor=1d0/nc**2*facVV             ! q Qb -> Qb q            C0g2
      case(698)
         factor=1d0/nc**2*facVV             ! q Q -> Q q              C0g2
      case(699)
         factor=1d0/nc**2*nf*facVV          ! q qb -> Q Qb            C0g2
      case(700)
         factor=1d0/nc**2*nf*facVV          ! qb q -> Q Qb            C0g2
      case(701)
         factor=1d0/nc**2*facVV             ! qb Qb -> qb Qb          C0g2
      case(702)
         factor=1d0/nc**2*facVV             ! qb Q -> qb Q            C0g2
      case(703)
         factor=1d0/nc**2*nf**2*facVV       ! g g subtraction         C0g2
      case(704)
         factor=1d0/nc**2*nf*facVV          ! g q subtraction         C0g2
      case(705)
         factor=1d0/nc**2*nf*facVV          ! g qb subtraction        C0g2
      case(706)
         factor=1d0/nc**2*nf*facVV          ! q g subtraction         C0g2
      case(707)
         factor=1d0/nc**2*nf*facVV          ! qb g subtraction        C0g2
      case(708)
         factor=1d0/nc**3*nf*facVV          ! q Qb -> Qb q            Ch0g2
      case(709)
         factor=1d0/nc**3*nf*facVV          ! q Q -> Q q              Ch0g2
      case(710)
         factor=1d0/nc**3*nf*nf*facVV       ! q qb -> Q Qb            Ch0g2
      case(711)
         factor=1d0/nc**3*nf*nf*facVV       ! qb q -> Q Qb            Ch0g2
      case(712)
         factor=1d0/nc**3*nf*facVV          ! qb Qb -> qb Qb          Ch0g2
      case(713)
         factor=1d0/nc**3*nf*facVV          ! qb Q -> qb Q            Ch0g2
      case(714)
         factor=1d0/nc**3*nf**3*facVV       ! g g subtraction         Ch0g2
      case(715)
         factor=1d0/nc**3*nf**2*facVV       ! g q subtraction         Ch0g2
      case(716)
         factor=1d0/nc**3*nf**2*facVV       ! g qb subtraction        Ch0g2
      case(717)
         factor=1d0/nc**3*nf**2*facVV       ! q g subtraction         Ch0g2
      case(718)
         factor=1d0/nc**3*nf**2*facVV       ! qb g subtraction        Ch0g2
      case(719)
         factor=1d0/nc**4*nf**2*facVV       ! q Qb -> Qb q            Chh0g2
      case(720)
         factor=1d0/nc**4*nf**2*facVV       ! q Q -> Q q              Chh0g2
      case(721)
         factor=1d0/nc**4*nf**2*nf*facVV    ! q qb -> Q Qb            Chh0g2
      case(722)
         factor=1d0/nc**4*nf**2*nf*facVV    ! qb q -> Q Qb            Chh0g2
      case(723)
         factor=1d0/nc**4*nf**2*facVV       ! qb Qb -> qb Qb          Chh0g2
      case(724)
         factor=1d0/nc**4*nf**2*facVV       ! qb Q -> qb Q            Chh0g2
      case(725)
         factor=1d0/nc**4*nf**4*facVV       ! g g subtraction         Chh0g2
      case(726)
         factor=1d0/nc**4*nf**3*facVV       ! g q subtraction         Chh0g2
      case(727)
         factor=1d0/nc**4*nf**3*facVV       ! g qb subtraction        Chh0g2
      case(728)
         factor=1d0/nc**4*nf**3*facVV       ! q g subtraction         Chh0g2
      case(729)
         factor=1d0/nc**4*nf**3*facVV       ! qb g subtraction        Chh0g2
      case(730)
         factor=1d0/nc**2*2d0*1d0/2d0*facVV   ! g g -> g g              At4g2
      case(731)
         factor=1d0/nc**3*facVV             ! g q subtraction         At4g2
      case(732)
         factor=1d0/nc**3*facVV             ! g qb subtraction        At4g2
      case(733)
         factor=1d0/nc**4*facVV             ! q Q subtraction         At4g2
      case(734)
         factor=1d0/nc**4*facVV             ! q Qb subtraction        At4g2
      case(735)
         factor=1d0/nc**3*facVV             ! q g subtraction         At4g2
      case(736)
         factor=1d0/nc**4*facVV             ! qb Q subtraction        At4g2
      case(737)
         factor=1d0/nc**4*facVV             ! qb Qb subtraction       At4g2
      case(738)
         factor=1d0/nc**3*facVV             ! qb g subtraction        At4g2
      case(739)
         factor=1d0/nc**3*nf*2d0*1d0/2d0*facVV   ! g g -> g g              Ath4g2
      case(740)
         factor=1d0/nc**4*nf*facVV          ! g q subtraction         Ath4g2
      case(741)
         factor=1d0/nc**4*nf*facVV          ! g qb subtraction        Ath4g2
      case(742)
         factor=1d0/nc**5*nf*facVV          ! q Q subtraction         Ath4g2
      case(743)
         factor=1d0/nc**5*nf*facVV          ! q Qb subtraction        Ath4g2
      case(744)
         factor=1d0/nc**4*nf*facVV          ! q g subtraction         Ath4g2
      case(745)
         factor=1d0/nc**5*nf*facVV          ! qb Q subtraction        Ath4g2
      case(746)
         factor=1d0/nc**5*nf*facVV          ! qb Qb subtraction       Ath4g2
      case(747)
         factor=1d0/nc**4*nf*facVV          ! qb g subtraction        Ath4g2
      case(748)
         factor=1d0/nc**4*nf**2*2d0*1d0/2d0*facVV   ! g g -> g g              Athh4g2
      case(749)
         factor=1d0/nc**5*nf**2*facVV       ! g q subtraction         Athh4g2
      case(750)
         factor=1d0/nc**5*nf**2*facVV       ! g qb subtraction        Athh4g2
      case(751)
         factor=1d0/nc**6*nf**2*facVV       ! q Q subtraction         Athh4g2
      case(752)
         factor=1d0/nc**6*nf**2*facVV       ! q Qb subtraction        Athh4g2
      case(753)
         factor=1d0/nc**5*nf**2*facVV       ! q g subtraction         Athh4g2
      case(754)
         factor=1d0/nc**6*nf**2*facVV       ! qb Q subtraction        Athh4g2
      case(755)
         factor=1d0/nc**6*nf**2*facVV       ! qb Qb subtraction       Athh4g2
      case(756)
         factor=1d0/nc**5*nf**2*facVV       ! qb g subtraction        Athh4g2
      case(757)
         factor=1d0/nc**6*nf**2*2d0*1d0/2d0*facVV   ! g g -> g g              Atthh4g2
      case(758)
         factor=1d0/nc**7*nf**2*facVV       ! g q subtraction         Atthh4g2
      case(759)
         factor=1d0/nc**7*nf**2*facVV       ! g qb subtraction        Atthh4g2
      case(760)
         factor=1d0/nc**8d0*nf**2*facVV     ! q Q subtraction         Atthh4g2
      case(761)
         factor=1d0/nc**8d0*nf**2*facVV     ! q Qb subtraction        Atthh4g2
      case(762)
         factor=1d0/nc**7*nf**2*facVV       ! q g subtraction         Atthh4g2
      case(763)
         factor=1d0/nc**8d0*nf**2*facVV     ! qb Q subtraction        Atthh4g2
      case(764)
         factor=1d0/nc**8d0*nf**2*facVV     ! qb Qb subtraction       Atthh4g2
      case(765)
         factor=1d0/nc**7*nf**2*facVV       ! qb g subtraction        Atthh4g2
      case(766)
         factor=1d0/nc**3*facVV             ! q gt -> gt q            Bt2g2
      case(767)
         factor=1d0/nc**3*1d0/2d0*facVV     ! q qb -> gt gt           Bt2g2
      case(768)
         factor=1d0/nc**3*facVV             ! gt q -> gt q            Bt2g2
      case(769)
         factor=1d0/nc**3*1d0/2d0*facVV     ! qb q -> gt gt           Bt2g2
      case(770)
         factor=1d0/nc**3*nf*facVV          ! gt gt -> qb q           Bt2g2
      case(771)
         factor=1d0/nc**3*facVV             ! gt qb -> qb gt          Bt2g2
      case(772)
         factor=1d0/nc**3*facVV             ! qb gt -> qb gt          Bt2g2
      case(773)
         factor=1d0/nc**4*nf*facVV          ! q gt -> gt q            Bth2g2
      case(774)
         factor=1d0/nc**4*nf*1d0/2d0*facVV   ! q qb -> gt gt           Bth2g2
      case(775)
         factor=1d0/nc**4*nf*facVV          ! gt q -> gt q            Bth2g2
      case(776)
         factor=1d0/nc**4*nf*1d0/2d0*facVV   ! qb q -> gt gt           Bth2g2
      case(777)
         factor=1d0/nc**4*nf*nf*facVV       ! gt gt -> qb q           Bth2g2
      case(778)
         factor=1d0/nc**4*nf*facVV          ! gt qb -> qb gt          Bth2g2
      case(779)
         factor=1d0/nc**4*nf*facVV          ! qb gt -> qb gt          Bth2g2
      case(780)
         factor=1d0/nc**5*nf**2*facVV       ! q gt -> gt q            Bthh2g2
      case(781)
         factor=1d0/nc**5*nf**2*1d0/2d0*facVV   ! q qb -> gt gt           Bthh2g2
      case(782)
         factor=1d0/nc**5*nf**2*facVV       ! gt q -> gt q            Bthh2g2
      case(783)
         factor=1d0/nc**5*nf**2*1d0/2d0*facVV   ! qb q -> gt gt           Bthh2g2
      case(784)
         factor=1d0/nc**5*nf**2*nf*facVV    ! gt gt -> qb q           Bthh2g2
      case(785)
         factor=1d0/nc**5*nf**2*facVV       ! gt qb -> qb gt          Bthh2g2
      case(786)
         factor=1d0/nc**5*nf**2*facVV       ! qb gt -> qb gt          Bthh2g2
      case(787)
         factor=1d0/nc**5*facVV             ! q gt -> gt q            Btt2g2
      case(788)
         factor=1d0/nc**5*1d0/2d0*facVV     ! q qb -> gt gt           Btt2g2
      case(789)
         factor=1d0/nc**5*facVV             ! gt q -> gt q            Btt2g2
      case(790)
         factor=1d0/nc**5*1d0/2d0*facVV     ! qb q -> gt gt           Btt2g2
      case(791)
         factor=1d0/nc**5*nf*facVV          ! gt gt -> qb q           Btt2g2
      case(792)
         factor=1d0/nc**5*facVV             ! gt qb -> qb gt          Btt2g2
      case(793)
         factor=1d0/nc**5*facVV             ! qb gt -> qb gt          Btt2g2
      case(794)
         factor=1d0/nc**6*nf*facVV          ! q gt -> gt q            Btth2g2
      case(795)
         factor=1d0/nc**6*nf*1d0/2d0*facVV   ! q qb -> gt gt           Btth2g2
      case(796)
         factor=1d0/nc**6*nf*facVV          ! gt q -> gt q            Btth2g2
      case(797)
         factor=1d0/nc**6*nf*1d0/2d0*facVV   ! qb q -> gt gt           Btth2g2
      case(798)
         factor=1d0/nc**6*nf*nf*facVV       ! gt gt -> qb q           Btth2g2
      case(799)
         factor=1d0/nc**6*nf*facVV          ! gt qb -> qb gt          Btth2g2
      case(800)
         factor=1d0/nc**6*nf*facVV          ! qb gt -> qb gt          Btth2g2
      case(801)
         factor=1d0/nc**7*facVV             ! q gt -> gt q            Bttt2g2
      case(802)
         factor=1d0/nc**7*1d0/2d0*facVV     ! q qb -> gt gt           Bttt2g2
      case(803)
         factor=1d0/nc**7*facVV             ! gt q -> gt q            Bttt2g2
      case(804)
         factor=1d0/nc**7*1d0/2d0*facVV     ! qb q -> gt gt           Bttt2g2
      case(805)
         factor=1d0/nc**7*nf*facVV          ! gt gt -> qb q           Bttt2g2
      case(806)
         factor=1d0/nc**7*facVV             ! gt qb -> qb gt          Bttt2g2
      case(807)
         factor=1d0/nc**7*facVV             ! qb gt -> qb gt          Bttt2g2
      case(808)
         factor=1d0/nc**4*facVV             ! q Qb -> Qb q            Ct0g2
      case(809)
         factor=1d0/nc**4*facVV             ! q Q -> Q q              Ct0g2
      case(810)
         factor=1d0/nc**4*nf*facVV          ! q qb -> Q Qb            Ct0g2
      case(811)
         factor=1d0/nc**4*nf*facVV          ! qb q -> Q Qb            Ct0g2
      case(812)
         factor=1d0/nc**4*facVV             ! qb Qb -> qb Qb          Ct0g2
      case(813)
         factor=1d0/nc**4*facVV             ! qb Q -> qb Q            Ct0g2
      case(814)
         factor=1d0/nc**4*nf**2*facVV       ! g g subtraction         Ct0g2
      case(815)
         factor=1d0/nc**4*nf*facVV          ! g q subtraction         Ct0g2
      case(816)
         factor=1d0/nc**4*nf*facVV          ! g qb subtraction        Ct0g2
      case(817)
         factor=1d0/nc**4*nf*facVV          ! q g subtraction         Ct0g2
      case(818)
         factor=1d0/nc**4*nf*facVV          ! qb g subtraction        Ct0g2
      case(819)
         factor=1d0/nc**5*nf*facVV          ! q Qb -> Qb q            Cth0g2
      case(820)
         factor=1d0/nc**5*nf*facVV          ! q Q -> Q q              Cth0g2
      case(821)
         factor=1d0/nc**5*nf*nf*facVV       ! q qb -> Q Qb            Cth0g2
      case(822)
         factor=1d0/nc**5*nf*nf*facVV       ! qb q -> Q Qb            Cth0g2
      case(823)
         factor=1d0/nc**5*nf*facVV          ! qb Qb -> qb Qb          Cth0g2
      case(824)
         factor=1d0/nc**5*nf*facVV          ! qb Q -> qb Q            Cth0g2
      case(825)
         factor=1d0/nc**5*nf**3*facVV       ! g g subtraction         Cth0g2
      case(826)
         factor=1d0/nc**5*nf**2*facVV       ! g q subtraction         Cth0g2
      case(827)
         factor=1d0/nc**5*nf**2*facVV       ! g qb subtraction        Cth0g2
      case(828)
         factor=1d0/nc**5*nf**2*facVV       ! q g subtraction         Cth0g2
      case(829)
         factor=1d0/nc**5*nf**2*facVV       ! qb g subtraction        Cth0g2
      case(830)
         factor=1d0/nc**6*facVV             ! q Qb -> Qb q            Ctt0g2
      case(831)
         factor=1d0/nc**6*facVV             ! q Q -> Q q              Ctt0g2
      case(832)
         factor=1d0/nc**6*nf*facVV          ! q qb -> Q Qb            Ctt0g2
      case(833)
         factor=1d0/nc**6*nf*facVV          ! qb q -> Q Qb            Ctt0g2
      case(834)
         factor=1d0/nc**6*facVV             ! qb Qb -> qb Qb          Ctt0g2
      case(835)
         factor=1d0/nc**6*facVV             ! qb Q -> qb Q            Ctt0g2
      case(836)
         factor=1d0/nc**6*nf**2*facVV       ! g g subtraction         Ctt0g2
      case(837)
         factor=1d0/nc**6*nf*facVV          ! g q subtraction         Ctt0g2
      case(838)
         factor=1d0/nc**6*nf*facVV          ! g qb subtraction        Ctt0g2
      case(839)
         factor=1d0/nc**6*nf*facVV          ! q g subtraction         Ctt0g2
      case(840)
         factor=1d0/nc**6*nf*facVV          ! qb g subtraction        Ctt0g2
      case(841)
         factor=1d0/nc**3*facVV             ! q qb -> qb q            D0g2
      case(842)
         factor=1d0/nc**3*1d0/2d0*facVV     ! q q -> q q              D0g2
      case(843)
         factor=1d0/nc**3*facVV             ! qb q -> qb q            D0g2
      case(844)
         factor=1d0/nc**3*1d0/2d0*facVV     ! qb qb -> qb qb          D0g2
      case(845)
         factor=1d0/nc**4*facVV             ! Q q subtraction         D0g2
      case(846)
         factor=1d0/nc**4*facVV             ! Q qb subtraction        D0g2
      case(847)
         factor=1d0/nc**4*facVV             ! Qb q subtraction        D0g2
      case(848)
         factor=1d0/nc**4*facVV             ! Qb qb subtraction       D0g2
      case(849)
         factor=1d0/nc**3*nf*facVV          ! g g subtraction         D0g2
      case(850)
         factor=1d0/nc**3*facVV             ! g q subtraction         D0g2
      case(851)
         factor=1d0/nc**3*facVV             ! g qb subtraction        D0g2
      case(852)
         factor=1d0/nc**4*facVV             ! q Q subtraction         D0g2
      case(853)
         factor=1d0/nc**4*facVV             ! q Qb subtraction        D0g2
      case(854)
         factor=1d0/nc**3*facVV             ! q g subtraction         D0g2
      case(855)
         factor=1d0/nc**4*facVV             ! qb Q subtraction        D0g2
      case(856)
         factor=1d0/nc**4*facVV             ! qb Qb subtraction       D0g2
      case(857)
         factor=1d0/nc**3*facVV             ! qb g subtraction        D0g2
      case(858)
         factor=1d0/nc**4*nf*facVV          ! q qb -> qb q            Dh0g2
      case(859)
         factor=1d0/nc**4*nf*1d0/2d0*facVV   ! q q -> q q              Dh0g2
      case(860)
         factor=1d0/nc**4*nf*facVV          ! qb q -> qb q            Dh0g2
      case(861)
         factor=1d0/nc**4*nf*1d0/2d0*facVV   ! qb qb -> qb qb          Dh0g2
      case(862)
         factor=1d0/nc**5*nf*facVV          ! Q q subtraction         Dh0g2
      case(863)
         factor=1d0/nc**5*nf*facVV          ! Q qb subtraction        Dh0g2
      case(864)
         factor=1d0/nc**5*nf*facVV          ! Qb q subtraction        Dh0g2
      case(865)
         factor=1d0/nc**5*nf*facVV          ! Qb qb subtraction       Dh0g2
      case(866)
         factor=1d0/nc**4*nf**2*facVV       ! g g subtraction         Dh0g2
      case(867)
         factor=1d0/nc**4*nf*facVV          ! g q subtraction         Dh0g2
      case(868)
         factor=1d0/nc**4*nf*facVV          ! g qb subtraction        Dh0g2
      case(869)
         factor=1d0/nc**5*nf*facVV          ! q Q subtraction         Dh0g2
      case(870)
         factor=1d0/nc**5*nf*facVV          ! q Qb subtraction        Dh0g2
      case(871)
         factor=1d0/nc**4*nf*facVV          ! q g subtraction         Dh0g2
      case(872)
         factor=1d0/nc**5*nf*facVV          ! qb Q subtraction        Dh0g2
      case(873)
         factor=1d0/nc**5*nf*facVV          ! qb Qb subtraction       Dh0g2
      case(874)
         factor=1d0/nc**4*nf*facVV          ! qb g subtraction        Dh0g2
      case(875)
         factor=1d0/nc**5*nf**2*facVV       ! q qb -> qb q            Dhh0g2
      case(876)
         factor=1d0/nc**5*nf**2*1d0/2d0*facVV   ! q q -> q q              Dhh0g2
      case(877)
         factor=1d0/nc**5*nf**2*facVV       ! qb q -> qb q            Dhh0g2
      case(878)
         factor=1d0/nc**5*nf**2*1d0/2d0*facVV   ! qb qb -> qb qb          Dhh0g2
      case(879)
         factor=1d0/nc**6*nf**2*facVV       ! Q q subtraction         Dhh0g2
      case(880)
         factor=1d0/nc**6*nf**2*facVV       ! Q qb subtraction        Dhh0g2
      case(881)
         factor=1d0/nc**6*nf**2*facVV       ! Qb q subtraction        Dhh0g2
      case(882)
         factor=1d0/nc**6*nf**2*facVV       ! Qb qb subtraction       Dhh0g2
      case(883)
         factor=1d0/nc**5*nf**3*facVV       ! g g subtraction         Dhh0g2
      case(884)
         factor=1d0/nc**5*nf**2*facVV       ! g q subtraction         Dhh0g2
      case(885)
         factor=1d0/nc**5*nf**2*facVV       ! g qb subtraction        Dhh0g2
      case(886)
         factor=1d0/nc**6*nf**2*facVV       ! q Q subtraction         Dhh0g2
      case(887)
         factor=1d0/nc**6*nf**2*facVV       ! q Qb subtraction        Dhh0g2
      case(888)
         factor=1d0/nc**5*nf**2*facVV       ! q g subtraction         Dhh0g2
      case(889)
         factor=1d0/nc**6*nf**2*facVV       ! qb Q subtraction        Dhh0g2
      case(890)
         factor=1d0/nc**6*nf**2*facVV       ! qb Qb subtraction       Dhh0g2
      case(891)
         factor=1d0/nc**5*nf**2*facVV       ! qb g subtraction        Dhh0g2
      case(892)
         factor=1d0/nc**5*facVV             ! q qb -> qb q            Dt0g2
      case(893)
         factor=1d0/nc**5*1d0/2d0*facVV     ! q q -> q q              Dt0g2
      case(894)
         factor=1d0/nc**5*facVV             ! qb q -> qb q            Dt0g2
      case(895)
         factor=1d0/nc**5*1d0/2d0*facVV     ! qb qb -> qb qb          Dt0g2
      case(896)
         factor=1d0/nc**6*facVV             ! Q q subtraction         Dt0g2
      case(897)
         factor=1d0/nc**6*facVV             ! Q qb subtraction        Dt0g2
      case(898)
         factor=1d0/nc**6*facVV             ! Qb q subtraction        Dt0g2
      case(899)
         factor=1d0/nc**6*facVV             ! Qb qb subtraction       Dt0g2
      case(900)
         factor=1d0/nc**5*nf*facVV          ! g g subtraction         Dt0g2
      case(901)
         factor=1d0/nc**5*facVV             ! g q subtraction         Dt0g2
      case(902)
         factor=1d0/nc**5*facVV             ! g qb subtraction        Dt0g2
      case(903)
         factor=1d0/nc**6*facVV             ! q Q subtraction         Dt0g2
      case(904)
         factor=1d0/nc**6*facVV             ! q Qb subtraction        Dt0g2
      case(905)
         factor=1d0/nc**5*facVV             ! q g subtraction         Dt0g2
      case(906)
         factor=1d0/nc**6*facVV             ! qb Q subtraction        Dt0g2
      case(907)
         factor=1d0/nc**6*facVV             ! qb Qb subtraction       Dt0g2
      case(908)
         factor=1d0/nc**5*facVV             ! qb g subtraction        Dt0g2
      case(909)
         factor=1d0/nc**6*nf*facVV          ! q qb -> qb q            Dth0g2
      case(910)
         factor=1d0/nc**6*nf*1d0/2d0*facVV   ! q q -> q q              Dth0g2
      case(911)
         factor=1d0/nc**6*nf*facVV          ! qb q -> qb q            Dth0g2
      case(912)
         factor=1d0/nc**6*nf*1d0/2d0*facVV   ! qb qb -> qb qb          Dth0g2
      case(913)
         factor=1d0/nc**7*nf*facVV          ! Q q subtraction         Dth0g2
      case(914)
         factor=1d0/nc**7*nf*facVV          ! Q qb subtraction        Dth0g2
      case(915)
         factor=1d0/nc**7*nf*facVV          ! Qb q subtraction        Dth0g2
      case(916)
         factor=1d0/nc**7*nf*facVV          ! Qb qb subtraction       Dth0g2
      case(917)
         factor=1d0/nc**6*nf**2*facVV       ! g g subtraction         Dth0g2
      case(918)
         factor=1d0/nc**6*nf*facVV          ! g q subtraction         Dth0g2
      case(919)
         factor=1d0/nc**6*nf*facVV          ! g qb subtraction        Dth0g2
      case(920)
         factor=1d0/nc**7*nf*facVV          ! q Q subtraction         Dth0g2
      case(921)
         factor=1d0/nc**7*nf*facVV          ! q Qb subtraction        Dth0g2
      case(922)
         factor=1d0/nc**6*nf*facVV          ! q g subtraction         Dth0g2
      case(923)
         factor=1d0/nc**7*nf*facVV          ! qb Q subtraction        Dth0g2
      case(924)
         factor=1d0/nc**7*nf*facVV          ! qb Qb subtraction       Dth0g2
      case(925)
         factor=1d0/nc**6*nf*facVV          ! qb g subtraction        Dth0g2
      case(926)
         factor=1d0/nc**7*facVV             ! q qb -> qb q            Dtt0g2
      case(927)
         factor=1d0/nc**7*1d0/2d0*facVV     ! q q -> q q              Dtt0g2
      case(928)
         factor=1d0/nc**7*facVV             ! qb q -> qb q            Dtt0g2
      case(929)
         factor=1d0/nc**7*1d0/2d0*facVV     ! qb qb -> qb qb          Dtt0g2
      case(930)
         factor=1d0/nc**8d0*facVV           ! Q q subtraction         Dtt0g2
      case(931)
         factor=1d0/nc**8d0*facVV           ! Q qb subtraction        Dtt0g2
      case(932)
         factor=1d0/nc**8d0*facVV           ! Qb q subtraction        Dtt0g2
      case(933)
         factor=1d0/nc**8d0*facVV           ! Qb qb subtraction       Dtt0g2
      case(934)
         factor=1d0/nc**7*nf*facVV          ! g g subtraction         Dtt0g2
      case(935)
         factor=1d0/nc**7*facVV             ! g q subtraction         Dtt0g2
      case(936)
         factor=1d0/nc**7*facVV             ! g qb subtraction        Dtt0g2
      case(937)
         factor=1d0/nc**8d0*facVV           ! q Q subtraction         Dtt0g2
      case(938)
         factor=1d0/nc**8d0*facVV           ! q Qb subtraction        Dtt0g2
      case(939)
         factor=1d0/nc**7*facVV             ! q g subtraction         Dtt0g2
      case(940)
         factor=1d0/nc**8d0*facVV           ! qb Q subtraction        Dtt0g2
      case(941)
         factor=1d0/nc**8d0*facVV           ! qb Qb subtraction       Dtt0g2
      case(942)
         factor=1d0/nc**7*facVV             ! qb g subtraction        Dtt0g2
      end select
      factor=relfactor*factor

      return
      end
