      function sigRV2jetfc(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRV2jetfc=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_jet(0,5,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- g g to g g g 
      if (qactive_chan(406).and.qselect_chan(406)) then
        current_chan = 406
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           A5g1(1,2,3,4,5,muR2_scl(i))
     .          +A5g1(1,2,3,5,4,muR2_scl(i))
     .          +A5g1(1,2,4,3,5,muR2_scl(i))
     .          +A5g1(1,2,4,5,3,muR2_scl(i))
     .          +A5g1(1,2,5,3,4,muR2_scl(i))
     .          +A5g1(1,2,5,4,3,muR2_scl(i))
     .          +A5g1(1,3,2,4,5,muR2_scl(i))
     .          +A5g1(1,3,2,5,4,muR2_scl(i))
     .          +A5g1(1,3,4,2,5,muR2_scl(i))
     .          +A5g1(1,3,5,2,4,muR2_scl(i))
     .          +A5g1(1,4,2,3,5,muR2_scl(i))
     .          +A5g1(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to g g g 
      if (qactive_chan(411).and.qselect_chan(411)) then
        current_chan = 411
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Ah5g1(1,2,3,4,5,muR2_scl(i))
     .          +Ah5g1(1,2,3,5,4,muR2_scl(i))
     .          +Ah5g1(1,2,4,3,5,muR2_scl(i))
     .          +Ah5g1(1,2,4,5,3,muR2_scl(i))
     .          +Ah5g1(1,2,5,3,4,muR2_scl(i))
     .          +Ah5g1(1,2,5,4,3,muR2_scl(i))
     .          +Ah5g1(1,3,2,4,5,muR2_scl(i))
     .          +Ah5g1(1,3,2,5,4,muR2_scl(i))
     .          +Ah5g1(1,3,4,2,5,muR2_scl(i))
     .          +Ah5g1(1,3,5,2,4,muR2_scl(i))
     .          +Ah5g1(1,4,2,3,5,muR2_scl(i))
     .          +Ah5g1(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g g q 
      if (qactive_chan(416).and.qselect_chan(416)) then
        current_chan = 416
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B3g1(1,2,3,4,5,muR2_scl(i))
     .          +B3g1(1,2,4,3,5,muR2_scl(i))
     .          +B3g1(1,3,2,4,5,muR2_scl(i))
     .          +B3g1(1,3,4,2,5,muR2_scl(i))
     .          +B3g1(1,4,2,3,5,muR2_scl(i))
     .          +B3g1(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g g 
      if (qactive_chan(417).and.qselect_chan(417)) then
        current_chan = 417
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B3g1(1,3,4,5,2,muR2_scl(i))
     .          +B3g1(1,3,5,4,2,muR2_scl(i))
     .          +B3g1(1,4,3,5,2,muR2_scl(i))
     .          +B3g1(1,4,5,3,2,muR2_scl(i))
     .          +B3g1(1,5,3,4,2,muR2_scl(i))
     .          +B3g1(1,5,4,3,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g g q 
      if (qactive_chan(418).and.qselect_chan(418)) then
        current_chan = 418
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B3g1(2,1,3,4,5,muR2_scl(i))
     .          +B3g1(2,1,4,3,5,muR2_scl(i))
     .          +B3g1(2,3,1,4,5,muR2_scl(i))
     .          +B3g1(2,3,4,1,5,muR2_scl(i))
     .          +B3g1(2,4,1,3,5,muR2_scl(i))
     .          +B3g1(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g g 
      if (qactive_chan(419).and.qselect_chan(419)) then
        current_chan = 419
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B3g1(2,3,4,5,1,muR2_scl(i))
     .          +B3g1(2,3,5,4,1,muR2_scl(i))
     .          +B3g1(2,4,3,5,1,muR2_scl(i))
     .          +B3g1(2,4,5,3,1,muR2_scl(i))
     .          +B3g1(2,5,3,4,1,muR2_scl(i))
     .          +B3g1(2,5,4,3,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb g q 
      if (qactive_chan(420).and.qselect_chan(420)) then
        current_chan = 420
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B3g1(3,1,2,4,5,muR2_scl(i))
     .          +B3g1(3,1,4,2,5,muR2_scl(i))
     .          +B3g1(3,2,1,4,5,muR2_scl(i))
     .          +B3g1(3,2,4,1,5,muR2_scl(i))
     .          +B3g1(3,4,1,2,5,muR2_scl(i))
     .          +B3g1(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g g 
      if (qactive_chan(421).and.qselect_chan(421)) then
        current_chan = 421
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B3g1(3,1,4,5,2,muR2_scl(i))
     .          +B3g1(3,1,5,4,2,muR2_scl(i))
     .          +B3g1(3,4,1,5,2,muR2_scl(i))
     .          +B3g1(3,4,5,1,2,muR2_scl(i))
     .          +B3g1(3,5,1,4,2,muR2_scl(i))
     .          +B3g1(3,5,4,1,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g g 
      if (qactive_chan(422).and.qselect_chan(422)) then
        current_chan = 422
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B3g1(3,2,4,5,1,muR2_scl(i))
     .          +B3g1(3,2,5,4,1,muR2_scl(i))
     .          +B3g1(3,4,2,5,1,muR2_scl(i))
     .          +B3g1(3,4,5,2,1,muR2_scl(i))
     .          +B3g1(3,5,2,4,1,muR2_scl(i))
     .          +B3g1(3,5,4,2,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g g q 
      if (qactive_chan(427).and.qselect_chan(427)) then
        current_chan = 427
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh3g1(1,2,3,4,5,muR2_scl(i))
     .          +Bh3g1(1,2,4,3,5,muR2_scl(i))
     .          +Bh3g1(1,3,2,4,5,muR2_scl(i))
     .          +Bh3g1(1,3,4,2,5,muR2_scl(i))
     .          +Bh3g1(1,4,2,3,5,muR2_scl(i))
     .          +Bh3g1(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g g 
      if (qactive_chan(428).and.qselect_chan(428)) then
        current_chan = 428
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh3g1(1,3,4,5,2,muR2_scl(i))
     .          +Bh3g1(1,3,5,4,2,muR2_scl(i))
     .          +Bh3g1(1,4,3,5,2,muR2_scl(i))
     .          +Bh3g1(1,4,5,3,2,muR2_scl(i))
     .          +Bh3g1(1,5,3,4,2,muR2_scl(i))
     .          +Bh3g1(1,5,4,3,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g g q 
      if (qactive_chan(429).and.qselect_chan(429)) then
        current_chan = 429
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh3g1(2,1,3,4,5,muR2_scl(i))
     .          +Bh3g1(2,1,4,3,5,muR2_scl(i))
     .          +Bh3g1(2,3,1,4,5,muR2_scl(i))
     .          +Bh3g1(2,3,4,1,5,muR2_scl(i))
     .          +Bh3g1(2,4,1,3,5,muR2_scl(i))
     .          +Bh3g1(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g g 
      if (qactive_chan(430).and.qselect_chan(430)) then
        current_chan = 430
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh3g1(2,3,4,5,1,muR2_scl(i))
     .          +Bh3g1(2,3,5,4,1,muR2_scl(i))
     .          +Bh3g1(2,4,3,5,1,muR2_scl(i))
     .          +Bh3g1(2,4,5,3,1,muR2_scl(i))
     .          +Bh3g1(2,5,3,4,1,muR2_scl(i))
     .          +Bh3g1(2,5,4,3,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb g q 
      if (qactive_chan(431).and.qselect_chan(431)) then
        current_chan = 431
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh3g1(3,1,2,4,5,muR2_scl(i))
     .          +Bh3g1(3,1,4,2,5,muR2_scl(i))
     .          +Bh3g1(3,2,1,4,5,muR2_scl(i))
     .          +Bh3g1(3,2,4,1,5,muR2_scl(i))
     .          +Bh3g1(3,4,1,2,5,muR2_scl(i))
     .          +Bh3g1(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g g 
      if (qactive_chan(432).and.qselect_chan(432)) then
        current_chan = 432
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh3g1(3,1,4,5,2,muR2_scl(i))
     .          +Bh3g1(3,1,5,4,2,muR2_scl(i))
     .          +Bh3g1(3,4,1,5,2,muR2_scl(i))
     .          +Bh3g1(3,4,5,1,2,muR2_scl(i))
     .          +Bh3g1(3,5,1,4,2,muR2_scl(i))
     .          +Bh3g1(3,5,4,1,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g g 
      if (qactive_chan(433).and.qselect_chan(433)) then
        current_chan = 433
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh3g1(3,2,4,5,1,muR2_scl(i))
     .          +Bh3g1(3,2,5,4,1,muR2_scl(i))
     .          +Bh3g1(3,4,2,5,1,muR2_scl(i))
     .          +Bh3g1(3,4,5,2,1,muR2_scl(i))
     .          +Bh3g1(3,5,2,4,1,muR2_scl(i))
     .          +Bh3g1(3,5,4,2,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to Qb Q g 
      if (qactive_chan(438).and.qselect_chan(438)) then
        current_chan = 438
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to q Q g 
      if (qactive_chan(439).and.qselect_chan(439)) then
        current_chan = 439
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to q Qb g 
      if (qactive_chan(440).and.qselect_chan(440)) then
        current_chan = 440
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q Qb Q 
      if (qactive_chan(441).and.qselect_chan(441)) then
        current_chan = 441
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to Qb Q g 
      if (qactive_chan(442).and.qselect_chan(442)) then
        current_chan = 442
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q Qb Q 
      if (qactive_chan(443).and.qselect_chan(443)) then
        current_chan = 443
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb Q g 
      if (qactive_chan(444).and.qselect_chan(444)) then
        current_chan = 444
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb Qb g 
      if (qactive_chan(445).and.qselect_chan(445)) then
        current_chan = 445
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb Qb Q 
      if (qactive_chan(446).and.qselect_chan(446)) then
        current_chan = 446
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb Qb Q 
      if (qactive_chan(447).and.qselect_chan(447)) then
        current_chan = 447
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC1g1X(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to Qb Q g 
      if (qactive_chan(449).and.qselect_chan(449)) then
        current_chan = 449
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to q Q g 
      if (qactive_chan(450).and.qselect_chan(450)) then
        current_chan = 450
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to q Qb g 
      if (qactive_chan(451).and.qselect_chan(451)) then
        current_chan = 451
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q Qb Q 
      if (qactive_chan(452).and.qselect_chan(452)) then
        current_chan = 452
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to Qb Q g 
      if (qactive_chan(453).and.qselect_chan(453)) then
        current_chan = 453
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q Qb Q 
      if (qactive_chan(454).and.qselect_chan(454)) then
        current_chan = 454
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb Q g 
      if (qactive_chan(455).and.qselect_chan(455)) then
        current_chan = 455
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb Qb g 
      if (qactive_chan(456).and.qselect_chan(456)) then
        current_chan = 456
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb Qb Q 
      if (qactive_chan(457).and.qselect_chan(457)) then
        current_chan = 457
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb Qb Q 
      if (qactive_chan(458).and.qselect_chan(458)) then
        current_chan = 458
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh1g1X(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to g g g 
      if (qactive_chan(460).and.qselect_chan(460)) then
        current_chan = 460
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           At5g1(1,2,3,4,5,muR2_scl(i))
     .          +At5g1(1,2,3,5,4,muR2_scl(i))
     .          +At5g1(1,2,4,3,5,muR2_scl(i))
     .          +At5g1(1,2,4,5,3,muR2_scl(i))
     .          +At5g1(1,2,5,3,4,muR2_scl(i))
     .          +At5g1(1,2,5,4,3,muR2_scl(i))
     .          +At5g1(1,3,2,4,5,muR2_scl(i))
     .          +At5g1(1,3,2,5,4,muR2_scl(i))
     .          +At5g1(1,3,4,2,5,muR2_scl(i))
     .          +At5g1(1,3,5,2,4,muR2_scl(i))
     .          +At5g1(1,4,2,3,5,muR2_scl(i))
     .          +At5g1(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to g g g 
      if (qactive_chan(465).and.qselect_chan(465)) then
        current_chan = 465
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Ath5g1(1,2,3,4,5,muR2_scl(i))
     .          +Ath5g1(1,2,3,5,4,muR2_scl(i))
     .          +Ath5g1(1,2,4,3,5,muR2_scl(i))
     .          +Ath5g1(1,2,4,5,3,muR2_scl(i))
     .          +Ath5g1(1,2,5,3,4,muR2_scl(i))
     .          +Ath5g1(1,2,5,4,3,muR2_scl(i))
     .          +Ath5g1(1,3,2,4,5,muR2_scl(i))
     .          +Ath5g1(1,3,2,5,4,muR2_scl(i))
     .          +Ath5g1(1,3,4,2,5,muR2_scl(i))
     .          +Ath5g1(1,3,5,2,4,muR2_scl(i))
     .          +Ath5g1(1,4,2,3,5,muR2_scl(i))
     .          +Ath5g1(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt gt q 
      if (qactive_chan(470).and.qselect_chan(470)) then
        current_chan = 470
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt3g1(1,2,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt gt 
      if (qactive_chan(471).and.qselect_chan(471)) then
        current_chan = 471
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt3g1(1,3,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt gt q 
      if (qactive_chan(472).and.qselect_chan(472)) then
        current_chan = 472
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt3g1(2,1,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt gt 
      if (qactive_chan(473).and.qselect_chan(473)) then
        current_chan = 473
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt3g1(2,3,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb gt q 
      if (qactive_chan(474).and.qselect_chan(474)) then
        current_chan = 474
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt3g1(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt gt 
      if (qactive_chan(475).and.qselect_chan(475)) then
        current_chan = 475
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt3g1(3,1,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt gt 
      if (qactive_chan(476).and.qselect_chan(476)) then
        current_chan = 476
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt3g1(3,2,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt gt q 
      if (qactive_chan(477).and.qselect_chan(477)) then
        current_chan = 477
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bth3g1(1,2,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt gt 
      if (qactive_chan(478).and.qselect_chan(478)) then
        current_chan = 478
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bth3g1(1,3,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt gt q 
      if (qactive_chan(479).and.qselect_chan(479)) then
        current_chan = 479
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bth3g1(2,1,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt gt 
      if (qactive_chan(480).and.qselect_chan(480)) then
        current_chan = 480
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bth3g1(2,3,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb gt q 
      if (qactive_chan(481).and.qselect_chan(481)) then
        current_chan = 481
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bth3g1(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt gt 
      if (qactive_chan(482).and.qselect_chan(482)) then
        current_chan = 482
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bth3g1(3,1,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt gt 
      if (qactive_chan(483).and.qselect_chan(483)) then
        current_chan = 483
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bth3g1(3,2,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt gt q 
      if (qactive_chan(484).and.qselect_chan(484)) then
        current_chan = 484
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btt3g1(1,2,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt gt 
      if (qactive_chan(485).and.qselect_chan(485)) then
        current_chan = 485
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btt3g1(1,3,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt gt q 
      if (qactive_chan(486).and.qselect_chan(486)) then
        current_chan = 486
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btt3g1(2,1,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt gt 
      if (qactive_chan(487).and.qselect_chan(487)) then
        current_chan = 487
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btt3g1(2,3,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb gt q 
      if (qactive_chan(488).and.qselect_chan(488)) then
        current_chan = 488
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt3g1(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt gt 
      if (qactive_chan(489).and.qselect_chan(489)) then
        current_chan = 489
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btt3g1(3,1,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt gt 
      if (qactive_chan(490).and.qselect_chan(490)) then
        current_chan = 490
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btt3g1(3,2,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt gt q 
      if (qactive_chan(491).and.qselect_chan(491)) then
        current_chan = 491
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btth3g1(1,2,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt gt 
      if (qactive_chan(492).and.qselect_chan(492)) then
        current_chan = 492
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btth3g1(1,3,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt gt q 
      if (qactive_chan(493).and.qselect_chan(493)) then
        current_chan = 493
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btth3g1(2,1,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt gt 
      if (qactive_chan(494).and.qselect_chan(494)) then
        current_chan = 494
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btth3g1(2,3,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb gt q 
      if (qactive_chan(495).and.qselect_chan(495)) then
        current_chan = 495
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btth3g1(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt gt 
      if (qactive_chan(496).and.qselect_chan(496)) then
        current_chan = 496
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btth3g1(3,1,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt gt 
      if (qactive_chan(497).and.qselect_chan(497)) then
        current_chan = 497
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btth3g1(3,2,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt gt q 
      if (qactive_chan(498).and.qselect_chan(498)) then
        current_chan = 498
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bttt3g1(1,2,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt gt 
      if (qactive_chan(499).and.qselect_chan(499)) then
        current_chan = 499
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bttt3g1(1,3,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt gt q 
      if (qactive_chan(500).and.qselect_chan(500)) then
        current_chan = 500
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bttt3g1(2,1,3,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt gt 
      if (qactive_chan(501).and.qselect_chan(501)) then
        current_chan = 501
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bttt3g1(2,3,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb gt q 
      if (qactive_chan(502).and.qselect_chan(502)) then
        current_chan = 502
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bttt3g1(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt gt 
      if (qactive_chan(503).and.qselect_chan(503)) then
        current_chan = 503
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bttt3g1(3,1,4,5,2,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt gt 
      if (qactive_chan(504).and.qselect_chan(504)) then
        current_chan = 504
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bttt3g1(3,2,4,5,1,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to Qb Q g 
      if (qactive_chan(505).and.qselect_chan(505)) then
        current_chan = 505
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to q Q g 
      if (qactive_chan(506).and.qselect_chan(506)) then
        current_chan = 506
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to q Qb g 
      if (qactive_chan(507).and.qselect_chan(507)) then
        current_chan = 507
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q Qb Q 
      if (qactive_chan(508).and.qselect_chan(508)) then
        current_chan = 508
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to Qb Q g 
      if (qactive_chan(509).and.qselect_chan(509)) then
        current_chan = 509
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q Qb Q 
      if (qactive_chan(510).and.qselect_chan(510)) then
        current_chan = 510
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb Q g 
      if (qactive_chan(511).and.qselect_chan(511)) then
        current_chan = 511
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb Qb g 
      if (qactive_chan(512).and.qselect_chan(512)) then
        current_chan = 512
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb Qb Q 
      if (qactive_chan(513).and.qselect_chan(513)) then
        current_chan = 513
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb Qb Q 
      if (qactive_chan(514).and.qselect_chan(514)) then
        current_chan = 514
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt1g1(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to Qb Q g 
      if (qactive_chan(516).and.qselect_chan(516)) then
        current_chan = 516
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to q Q g 
      if (qactive_chan(517).and.qselect_chan(517)) then
        current_chan = 517
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to q Qb g 
      if (qactive_chan(518).and.qselect_chan(518)) then
        current_chan = 518
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q Qb Q 
      if (qactive_chan(519).and.qselect_chan(519)) then
        current_chan = 519
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to Qb Q g 
      if (qactive_chan(520).and.qselect_chan(520)) then
        current_chan = 520
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q Qb Q 
      if (qactive_chan(521).and.qselect_chan(521)) then
        current_chan = 521
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb Q g 
      if (qactive_chan(522).and.qselect_chan(522)) then
        current_chan = 522
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb Qb g 
      if (qactive_chan(523).and.qselect_chan(523)) then
        current_chan = 523
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb Qb Q 
      if (qactive_chan(524).and.qselect_chan(524)) then
        current_chan = 524
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb Qb Q 
      if (qactive_chan(525).and.qselect_chan(525)) then
        current_chan = 525
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Cth1g1(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to Qb Q g 
      if (qactive_chan(527).and.qselect_chan(527)) then
        current_chan = 527
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to q Q g 
      if (qactive_chan(528).and.qselect_chan(528)) then
        current_chan = 528
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to q Qb g 
      if (qactive_chan(529).and.qselect_chan(529)) then
        current_chan = 529
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q Qb Q 
      if (qactive_chan(530).and.qselect_chan(530)) then
        current_chan = 530
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to Qb Q g 
      if (qactive_chan(531).and.qselect_chan(531)) then
        current_chan = 531
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q Qb Q 
      if (qactive_chan(532).and.qselect_chan(532)) then
        current_chan = 532
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb Q g 
      if (qactive_chan(533).and.qselect_chan(533)) then
        current_chan = 533
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb Qb g 
      if (qactive_chan(534).and.qselect_chan(534)) then
        current_chan = 534
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb Qb Q 
      if (qactive_chan(535).and.qselect_chan(535)) then
        current_chan = 535
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb Qb Q 
      if (qactive_chan(536).and.qselect_chan(536)) then
        current_chan = 536
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCtt1g1(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to qb q g 
      if (qactive_chan(538).and.qselect_chan(538)) then
        current_chan = 538
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D1g1full(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to q q g 
      if (qactive_chan(539).and.qselect_chan(539)) then
        current_chan = 539
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D1g1full(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q qb q 
      if (qactive_chan(540).and.qselect_chan(540)) then
        current_chan = 540
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D1g1full(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to qb q g 
      if (qactive_chan(541).and.qselect_chan(541)) then
        current_chan = 541
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D1g1full(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q qb q 
      if (qactive_chan(542).and.qselect_chan(542)) then
        current_chan = 542
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D1g1full(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb qb g 
      if (qactive_chan(543).and.qselect_chan(543)) then
        current_chan = 543
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D1g1full(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb qb q 
      if (qactive_chan(544).and.qselect_chan(544)) then
        current_chan = 544
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D1g1full(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb qb q 
      if (qactive_chan(545).and.qselect_chan(545)) then
        current_chan = 545
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D1g1full(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to qb q g 
      if (qactive_chan(555).and.qselect_chan(555)) then
        current_chan = 555
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh1g1full(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to q q g 
      if (qactive_chan(556).and.qselect_chan(556)) then
        current_chan = 556
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh1g1full(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q qb q 
      if (qactive_chan(557).and.qselect_chan(557)) then
        current_chan = 557
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh1g1full(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to qb q g 
      if (qactive_chan(558).and.qselect_chan(558)) then
        current_chan = 558
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh1g1full(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q qb q 
      if (qactive_chan(559).and.qselect_chan(559)) then
        current_chan = 559
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh1g1full(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb qb g 
      if (qactive_chan(560).and.qselect_chan(560)) then
        current_chan = 560
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh1g1full(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb qb q 
      if (qactive_chan(561).and.qselect_chan(561)) then
        current_chan = 561
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh1g1full(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb qb q 
      if (qactive_chan(562).and.qselect_chan(562)) then
        current_chan = 562
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh1g1full(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to qb q g 
      if (qactive_chan(572).and.qselect_chan(572)) then
        current_chan = 572
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt1g1full(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to q q g 
      if (qactive_chan(573).and.qselect_chan(573)) then
        current_chan = 573
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt1g1full(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q qb q 
      if (qactive_chan(574).and.qselect_chan(574)) then
        current_chan = 574
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt1g1full(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to qb q g 
      if (qactive_chan(575).and.qselect_chan(575)) then
        current_chan = 575
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt1g1full(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q qb q 
      if (qactive_chan(576).and.qselect_chan(576)) then
        current_chan = 576
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt1g1full(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb qb g 
      if (qactive_chan(577).and.qselect_chan(577)) then
        current_chan = 577
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt1g1full(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb qb q 
      if (qactive_chan(578).and.qselect_chan(578)) then
        current_chan = 578
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt1g1full(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb qb q 
      if (qactive_chan(579).and.qselect_chan(579)) then
        current_chan = 579
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt1g1full(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to qb q g 
      if (qactive_chan(589).and.qselect_chan(589)) then
        current_chan = 589
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dth1g1full(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to q q g 
      if (qactive_chan(590).and.qselect_chan(590)) then
        current_chan = 590
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dth1g1full(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q qb q 
      if (qactive_chan(591).and.qselect_chan(591)) then
        current_chan = 591
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dth1g1full(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to qb q g 
      if (qactive_chan(592).and.qselect_chan(592)) then
        current_chan = 592
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dth1g1full(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q qb q 
      if (qactive_chan(593).and.qselect_chan(593)) then
        current_chan = 593
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dth1g1full(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb qb g 
      if (qactive_chan(594).and.qselect_chan(594)) then
        current_chan = 594
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dth1g1full(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb qb q 
      if (qactive_chan(595).and.qselect_chan(595)) then
        current_chan = 595
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dth1g1full(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb qb q 
      if (qactive_chan(596).and.qselect_chan(596)) then
        current_chan = 596
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dth1g1full(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to qb q g 
      if (qactive_chan(606).and.qselect_chan(606)) then
        current_chan = 606
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dtt1g1full(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to q q g 
      if (qactive_chan(607).and.qselect_chan(607)) then
        current_chan = 607
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dtt1g1full(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q qb q 
      if (qactive_chan(608).and.qselect_chan(608)) then
        current_chan = 608
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dtt1g1full(1,3,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to qb q g 
      if (qactive_chan(609).and.qselect_chan(609)) then
        current_chan = 609
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dtt1g1full(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q qb q 
      if (qactive_chan(610).and.qselect_chan(610)) then
        current_chan = 610
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dtt1g1full(2,3,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb qb g 
      if (qactive_chan(611).and.qselect_chan(611)) then
        current_chan = 611
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dtt1g1full(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb qb q 
      if (qactive_chan(612).and.qselect_chan(612)) then
        current_chan = 612
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,5,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dtt1g1full(3,1,4,5,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb qb q 
      if (qactive_chan(613).and.qselect_chan(613)) then
        current_chan = 613
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,5,1 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dtt1g1full(3,2,4,5,1,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRV2jetfc=rnorm*wtsum

      return
      end
