      function sigU2jetfc(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use Charges_EW_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigU2jetfc=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- g g to g g          
        if (qactive_chan(623).and.qselect_chan(623)) then
          current_chan = 623
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggA4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(624).and.qselect_chan(624)) then
          current_chan = 624
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqA4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(625).and.qselect_chan(625)) then
          current_chan = 625
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbA4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(626).and.qselect_chan(626)) then
          current_chan = 626
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpA4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(627).and.qselect_chan(627)) then
          current_chan = 627
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbA4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(628).and.qselect_chan(628)) then
          current_chan = 628
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgA4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(629).and.qselect_chan(629)) then
          current_chan = 629
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpA4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(630).and.qselect_chan(630)) then
          current_chan = 630
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbA4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(631).and.qselect_chan(631)) then
          current_chan = 631
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgA4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g          
        if (qactive_chan(632).and.qselect_chan(632)) then
          current_chan = 632
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(633).and.qselect_chan(633)) then
          current_chan = 633
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(634).and.qselect_chan(634)) then
          current_chan = 634
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(635).and.qselect_chan(635)) then
          current_chan = 635
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(636).and.qselect_chan(636)) then
          current_chan = 636
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(637).and.qselect_chan(637)) then
          current_chan = 637
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(638).and.qselect_chan(638)) then
          current_chan = 638
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(639).and.qselect_chan(639)) then
          current_chan = 639
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(640).and.qselect_chan(640)) then
          current_chan = 640
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g          
        if (qactive_chan(641).and.qselect_chan(641)) then
          current_chan = 641
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAhh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(642).and.qselect_chan(642)) then
          current_chan = 642
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAhh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(643).and.qselect_chan(643)) then
          current_chan = 643
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAhh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(644).and.qselect_chan(644)) then
          current_chan = 644
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAhh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(645).and.qselect_chan(645)) then
          current_chan = 645
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAhh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(646).and.qselect_chan(646)) then
          current_chan = 646
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAhh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(647).and.qselect_chan(647)) then
          current_chan = 647
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAhh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(648).and.qselect_chan(648)) then
          current_chan = 648
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAhh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(649).and.qselect_chan(649)) then
          current_chan = 649
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAhh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g q          
        if (qactive_chan(650).and.qselect_chan(650)) then
          current_chan = 650
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgB2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g         
        if (qactive_chan(651).and.qselect_chan(651)) then
          current_chan = 651
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbB2g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g q          
        if (qactive_chan(652).and.qselect_chan(652)) then
          current_chan = 652
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqB2g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g         
        if (qactive_chan(653).and.qselect_chan(653)) then
          current_chan = 653
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqB2g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb q         
        if (qactive_chan(654).and.qselect_chan(654)) then
          current_chan = 654
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggB2g2U(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g        
        if (qactive_chan(655).and.qselect_chan(655)) then
          current_chan = 655
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbB2g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g        
        if (qactive_chan(656).and.qselect_chan(656)) then
          current_chan = 656
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgB2g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(657).and.qselect_chan(657)) then
          current_chan = 657
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpB2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(658).and.qselect_chan(658)) then
          current_chan = 658
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbB2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q initiated       
        if (qactive_chan(659).and.qselect_chan(659)) then
          current_chan = 659
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qqB2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(660).and.qselect_chan(660)) then
          current_chan = 660
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpB2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(661).and.qselect_chan(661)) then
          current_chan = 661
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbB2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb initiated     
        if (qactive_chan(662).and.qselect_chan(662)) then
          current_chan = 662
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qbqbB2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g q          
        if (qactive_chan(663).and.qselect_chan(663)) then
          current_chan = 663
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g         
        if (qactive_chan(664).and.qselect_chan(664)) then
          current_chan = 664
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBh2g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g q          
        if (qactive_chan(665).and.qselect_chan(665)) then
          current_chan = 665
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqBh2g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g         
        if (qactive_chan(666).and.qselect_chan(666)) then
          current_chan = 666
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBh2g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb q         
        if (qactive_chan(667).and.qselect_chan(667)) then
          current_chan = 667
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggBh2g2U(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g        
        if (qactive_chan(668).and.qselect_chan(668)) then
          current_chan = 668
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbBh2g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g        
        if (qactive_chan(669).and.qselect_chan(669)) then
          current_chan = 669
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgBh2g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(670).and.qselect_chan(670)) then
          current_chan = 670
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpgBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(671).and.qselect_chan(671)) then
          current_chan = 671
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbgBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(672).and.qselect_chan(672)) then
          current_chan = 672
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(673).and.qselect_chan(673)) then
          current_chan = 673
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpbBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(674).and.qselect_chan(674)) then
          current_chan = 674
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(675).and.qselect_chan(675)) then
          current_chan = 675
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q initiated       
        if (qactive_chan(676).and.qselect_chan(676)) then
          current_chan = 676
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qqBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(677).and.qselect_chan(677)) then
          current_chan = 677
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(678).and.qselect_chan(678)) then
          current_chan = 678
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb initiated     
        if (qactive_chan(679).and.qselect_chan(679)) then
          current_chan = 679
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qbqbBh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g q          
        if (qactive_chan(680).and.qselect_chan(680)) then
          current_chan = 680
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g         
        if (qactive_chan(681).and.qselect_chan(681)) then
          current_chan = 681
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBhh2g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g q          
        if (qactive_chan(682).and.qselect_chan(682)) then
          current_chan = 682
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqBhh2g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g         
        if (qactive_chan(683).and.qselect_chan(683)) then
          current_chan = 683
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBhh2g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb q         
        if (qactive_chan(684).and.qselect_chan(684)) then
          current_chan = 684
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggBhh2g2U(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g        
        if (qactive_chan(685).and.qselect_chan(685)) then
          current_chan = 685
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbBhh2g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g        
        if (qactive_chan(686).and.qselect_chan(686)) then
          current_chan = 686
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgBhh2g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(687).and.qselect_chan(687)) then
          current_chan = 687
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpgBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(688).and.qselect_chan(688)) then
          current_chan = 688
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbgBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(689).and.qselect_chan(689)) then
          current_chan = 689
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(690).and.qselect_chan(690)) then
          current_chan = 690
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpbBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(691).and.qselect_chan(691)) then
          current_chan = 691
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(692).and.qselect_chan(692)) then
          current_chan = 692
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q initiated       
        if (qactive_chan(693).and.qselect_chan(693)) then
          current_chan = 693
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qqBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(694).and.qselect_chan(694)) then
          current_chan = 694
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(695).and.qselect_chan(695)) then
          current_chan = 695
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb initiated     
        if (qactive_chan(696).and.qselect_chan(696)) then
          current_chan = 696
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qbqbBhh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q        
        if (qactive_chan(697).and.qselect_chan(697)) then
          current_chan = 697
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbC0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q          
        if (qactive_chan(698).and.qselect_chan(698)) then
          current_chan = 698
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpC0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb        
        if (qactive_chan(699).and.qselect_chan(699)) then
          current_chan = 699
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqbC0g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb        
        if (qactive_chan(700).and.qselect_chan(700)) then
          current_chan = 700
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqC0g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb      
        if (qactive_chan(701).and.qselect_chan(701)) then
          current_chan = 701
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbC0g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q        
        if (qactive_chan(702).and.qselect_chan(702)) then
          current_chan = 702
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpC0g2U(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(703).and.qselect_chan(703)) then
          current_chan = 703
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = ggC0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(704).and.qselect_chan(704)) then
          current_chan = 704
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqC0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(705).and.qselect_chan(705)) then
          current_chan = 705
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqbC0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(706).and.qselect_chan(706)) then
          current_chan = 706
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qgC0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(707).and.qselect_chan(707)) then
          current_chan = 707
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbgC0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q        
        if (qactive_chan(708).and.qselect_chan(708)) then
          current_chan = 708
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbCh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q          
        if (qactive_chan(709).and.qselect_chan(709)) then
          current_chan = 709
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpCh0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb        
        if (qactive_chan(710).and.qselect_chan(710)) then
          current_chan = 710
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqbCh0g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb        
        if (qactive_chan(711).and.qselect_chan(711)) then
          current_chan = 711
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqCh0g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb      
        if (qactive_chan(712).and.qselect_chan(712)) then
          current_chan = 712
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbCh0g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q        
        if (qactive_chan(713).and.qselect_chan(713)) then
          current_chan = 713
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpCh0g2U(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(714).and.qselect_chan(714)) then
          current_chan = 714
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = ggCh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(715).and.qselect_chan(715)) then
          current_chan = 715
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqCh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(716).and.qselect_chan(716)) then
          current_chan = 716
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqbCh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(717).and.qselect_chan(717)) then
          current_chan = 717
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qgCh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(718).and.qselect_chan(718)) then
          current_chan = 718
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbgCh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q        
        if (qactive_chan(719).and.qselect_chan(719)) then
          current_chan = 719
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbChh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q          
        if (qactive_chan(720).and.qselect_chan(720)) then
          current_chan = 720
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpChh0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb        
        if (qactive_chan(721).and.qselect_chan(721)) then
          current_chan = 721
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqbChh0g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb        
        if (qactive_chan(722).and.qselect_chan(722)) then
          current_chan = 722
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqChh0g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb      
        if (qactive_chan(723).and.qselect_chan(723)) then
          current_chan = 723
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbChh0g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q        
        if (qactive_chan(724).and.qselect_chan(724)) then
          current_chan = 724
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpChh0g2U(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(725).and.qselect_chan(725)) then
          current_chan = 725
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = ggChh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(726).and.qselect_chan(726)) then
          current_chan = 726
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqChh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(727).and.qselect_chan(727)) then
          current_chan = 727
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqbChh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(728).and.qselect_chan(728)) then
          current_chan = 728
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qgChh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(729).and.qselect_chan(729)) then
          current_chan = 729
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbgChh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g          
        if (qactive_chan(730).and.qselect_chan(730)) then
          current_chan = 730
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAt4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(731).and.qselect_chan(731)) then
          current_chan = 731
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAt4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(732).and.qselect_chan(732)) then
          current_chan = 732
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAt4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(733).and.qselect_chan(733)) then
          current_chan = 733
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAt4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(734).and.qselect_chan(734)) then
          current_chan = 734
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAt4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(735).and.qselect_chan(735)) then
          current_chan = 735
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAt4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(736).and.qselect_chan(736)) then
          current_chan = 736
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAt4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(737).and.qselect_chan(737)) then
          current_chan = 737
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAt4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(738).and.qselect_chan(738)) then
          current_chan = 738
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAt4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g          
        if (qactive_chan(739).and.qselect_chan(739)) then
          current_chan = 739
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAth4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(740).and.qselect_chan(740)) then
          current_chan = 740
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAth4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(741).and.qselect_chan(741)) then
          current_chan = 741
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAth4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(742).and.qselect_chan(742)) then
          current_chan = 742
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAth4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(743).and.qselect_chan(743)) then
          current_chan = 743
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAth4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(744).and.qselect_chan(744)) then
          current_chan = 744
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAth4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(745).and.qselect_chan(745)) then
          current_chan = 745
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAth4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(746).and.qselect_chan(746)) then
          current_chan = 746
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAth4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(747).and.qselect_chan(747)) then
          current_chan = 747
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAth4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g          
        if (qactive_chan(748).and.qselect_chan(748)) then
          current_chan = 748
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(749).and.qselect_chan(749)) then
          current_chan = 749
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(750).and.qselect_chan(750)) then
          current_chan = 750
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(751).and.qselect_chan(751)) then
          current_chan = 751
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(752).and.qselect_chan(752)) then
          current_chan = 752
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(753).and.qselect_chan(753)) then
          current_chan = 753
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(754).and.qselect_chan(754)) then
          current_chan = 754
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(755).and.qselect_chan(755)) then
          current_chan = 755
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(756).and.qselect_chan(756)) then
          current_chan = 756
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g          
        if (qactive_chan(757).and.qselect_chan(757)) then
          current_chan = 757
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAtthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(758).and.qselect_chan(758)) then
          current_chan = 758
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAtthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(759).and.qselect_chan(759)) then
          current_chan = 759
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAtthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(760).and.qselect_chan(760)) then
          current_chan = 760
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAtthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(761).and.qselect_chan(761)) then
          current_chan = 761
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAtthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(762).and.qselect_chan(762)) then
          current_chan = 762
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAtthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(763).and.qselect_chan(763)) then
          current_chan = 763
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAtthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(764).and.qselect_chan(764)) then
          current_chan = 764
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAtthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(765).and.qselect_chan(765)) then
          current_chan = 765
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAtthh4g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q        
        if (qactive_chan(766).and.qselect_chan(766)) then
          current_chan = 766
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgtBt2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt       
        if (qactive_chan(767).and.qselect_chan(767)) then
          current_chan = 767
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBt2g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q        
        if (qactive_chan(768).and.qselect_chan(768)) then
          current_chan = 768
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gtqBt2g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt       
        if (qactive_chan(769).and.qselect_chan(769)) then
          current_chan = 769
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBt2g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q       
        if (qactive_chan(770).and.qselect_chan(770)) then
          current_chan = 770
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = gtgtBt2g2U(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt      
        if (qactive_chan(771).and.qselect_chan(771)) then
          current_chan = 771
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gtqbBt2g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt      
        if (qactive_chan(772).and.qselect_chan(772)) then
          current_chan = 772
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgtBt2g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q        
        if (qactive_chan(773).and.qselect_chan(773)) then
          current_chan = 773
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgtBth2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt       
        if (qactive_chan(774).and.qselect_chan(774)) then
          current_chan = 774
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBth2g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q        
        if (qactive_chan(775).and.qselect_chan(775)) then
          current_chan = 775
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gtqBth2g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt       
        if (qactive_chan(776).and.qselect_chan(776)) then
          current_chan = 776
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBth2g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q       
        if (qactive_chan(777).and.qselect_chan(777)) then
          current_chan = 777
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = gtgtBth2g2U(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt      
        if (qactive_chan(778).and.qselect_chan(778)) then
          current_chan = 778
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gtqbBth2g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt      
        if (qactive_chan(779).and.qselect_chan(779)) then
          current_chan = 779
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgtBth2g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q        
        if (qactive_chan(780).and.qselect_chan(780)) then
          current_chan = 780
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgtBthh2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt       
        if (qactive_chan(781).and.qselect_chan(781)) then
          current_chan = 781
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBthh2g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q        
        if (qactive_chan(782).and.qselect_chan(782)) then
          current_chan = 782
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gtqBthh2g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt       
        if (qactive_chan(783).and.qselect_chan(783)) then
          current_chan = 783
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBthh2g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q       
        if (qactive_chan(784).and.qselect_chan(784)) then
          current_chan = 784
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = gtgtBthh2g2U(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt      
        if (qactive_chan(785).and.qselect_chan(785)) then
          current_chan = 785
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gtqbBthh2g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt      
        if (qactive_chan(786).and.qselect_chan(786)) then
          current_chan = 786
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgtBthh2g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q        
        if (qactive_chan(787).and.qselect_chan(787)) then
          current_chan = 787
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgtBtt2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt       
        if (qactive_chan(788).and.qselect_chan(788)) then
          current_chan = 788
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBtt2g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q        
        if (qactive_chan(789).and.qselect_chan(789)) then
          current_chan = 789
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gtqBtt2g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt       
        if (qactive_chan(790).and.qselect_chan(790)) then
          current_chan = 790
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBtt2g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q       
        if (qactive_chan(791).and.qselect_chan(791)) then
          current_chan = 791
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = gtgtBtt2g2U(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt      
        if (qactive_chan(792).and.qselect_chan(792)) then
          current_chan = 792
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gtqbBtt2g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt      
        if (qactive_chan(793).and.qselect_chan(793)) then
          current_chan = 793
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgtBtt2g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q        
        if (qactive_chan(794).and.qselect_chan(794)) then
          current_chan = 794
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgtBtth2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt       
        if (qactive_chan(795).and.qselect_chan(795)) then
          current_chan = 795
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBtth2g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q        
        if (qactive_chan(796).and.qselect_chan(796)) then
          current_chan = 796
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gtqBtth2g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt       
        if (qactive_chan(797).and.qselect_chan(797)) then
          current_chan = 797
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBtth2g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q       
        if (qactive_chan(798).and.qselect_chan(798)) then
          current_chan = 798
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = gtgtBtth2g2U(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt      
        if (qactive_chan(799).and.qselect_chan(799)) then
          current_chan = 799
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gtqbBtth2g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt      
        if (qactive_chan(800).and.qselect_chan(800)) then
          current_chan = 800
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgtBtth2g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q        
        if (qactive_chan(801).and.qselect_chan(801)) then
          current_chan = 801
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgtBttt2g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt       
        if (qactive_chan(802).and.qselect_chan(802)) then
          current_chan = 802
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBttt2g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q        
        if (qactive_chan(803).and.qselect_chan(803)) then
          current_chan = 803
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gtqBttt2g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt       
        if (qactive_chan(804).and.qselect_chan(804)) then
          current_chan = 804
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBttt2g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q       
        if (qactive_chan(805).and.qselect_chan(805)) then
          current_chan = 805
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = gtgtBttt2g2U(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt      
        if (qactive_chan(806).and.qselect_chan(806)) then
          current_chan = 806
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gtqbBttt2g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt      
        if (qactive_chan(807).and.qselect_chan(807)) then
          current_chan = 807
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgtBttt2g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q        
        if (qactive_chan(808).and.qselect_chan(808)) then
          current_chan = 808
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbCt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q          
        if (qactive_chan(809).and.qselect_chan(809)) then
          current_chan = 809
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpCt0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb        
        if (qactive_chan(810).and.qselect_chan(810)) then
          current_chan = 810
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqbCt0g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb        
        if (qactive_chan(811).and.qselect_chan(811)) then
          current_chan = 811
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqCt0g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb      
        if (qactive_chan(812).and.qselect_chan(812)) then
          current_chan = 812
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbCt0g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q        
        if (qactive_chan(813).and.qselect_chan(813)) then
          current_chan = 813
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpCt0g2U(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(814).and.qselect_chan(814)) then
          current_chan = 814
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = ggCt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(815).and.qselect_chan(815)) then
          current_chan = 815
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqCt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(816).and.qselect_chan(816)) then
          current_chan = 816
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqbCt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(817).and.qselect_chan(817)) then
          current_chan = 817
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qgCt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(818).and.qselect_chan(818)) then
          current_chan = 818
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbgCt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q        
        if (qactive_chan(819).and.qselect_chan(819)) then
          current_chan = 819
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbCth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q          
        if (qactive_chan(820).and.qselect_chan(820)) then
          current_chan = 820
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpCth0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb        
        if (qactive_chan(821).and.qselect_chan(821)) then
          current_chan = 821
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqbCth0g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb        
        if (qactive_chan(822).and.qselect_chan(822)) then
          current_chan = 822
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqCth0g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb      
        if (qactive_chan(823).and.qselect_chan(823)) then
          current_chan = 823
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbCth0g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q        
        if (qactive_chan(824).and.qselect_chan(824)) then
          current_chan = 824
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpCth0g2U(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(825).and.qselect_chan(825)) then
          current_chan = 825
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = ggCth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(826).and.qselect_chan(826)) then
          current_chan = 826
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqCth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(827).and.qselect_chan(827)) then
          current_chan = 827
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqbCth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(828).and.qselect_chan(828)) then
          current_chan = 828
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qgCth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(829).and.qselect_chan(829)) then
          current_chan = 829
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbgCth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q        
        if (qactive_chan(830).and.qselect_chan(830)) then
          current_chan = 830
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbCtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q          
        if (qactive_chan(831).and.qselect_chan(831)) then
          current_chan = 831
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpCtt0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb        
        if (qactive_chan(832).and.qselect_chan(832)) then
          current_chan = 832
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqbCtt0g2U(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb        
        if (qactive_chan(833).and.qselect_chan(833)) then
          current_chan = 833
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqCtt0g2U(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb      
        if (qactive_chan(834).and.qselect_chan(834)) then
          current_chan = 834
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbCtt0g2U(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q        
        if (qactive_chan(835).and.qselect_chan(835)) then
          current_chan = 835
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpCtt0g2U(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(836).and.qselect_chan(836)) then
          current_chan = 836
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = ggCtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(837).and.qselect_chan(837)) then
          current_chan = 837
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqCtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(838).and.qselect_chan(838)) then
          current_chan = 838
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqbCtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(839).and.qselect_chan(839)) then
          current_chan = 839
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qgCtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(840).and.qselect_chan(840)) then
          current_chan = 840
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbgCtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q        
        if (qactive_chan(841).and.qselect_chan(841)) then
          current_chan = 841
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqbD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q          
        if (qactive_chan(842).and.qselect_chan(842)) then
          current_chan = 842
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqD0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q        
        if (qactive_chan(843).and.qselect_chan(843)) then
          current_chan = 843
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqD0g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb      
        if (qactive_chan(844).and.qselect_chan(844)) then
          current_chan = 844
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqbD0g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(845).and.qselect_chan(845)) then
          current_chan = 845
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(846).and.qselect_chan(846)) then
          current_chan = 846
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqbD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(847).and.qselect_chan(847)) then
          current_chan = 847
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(848).and.qselect_chan(848)) then
          current_chan = 848
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(849).and.qselect_chan(849)) then
          current_chan = 849
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(850).and.qselect_chan(850)) then
          current_chan = 850
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(851).and.qselect_chan(851)) then
          current_chan = 851
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(852).and.qselect_chan(852)) then
          current_chan = 852
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(853).and.qselect_chan(853)) then
          current_chan = 853
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(854).and.qselect_chan(854)) then
          current_chan = 854
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(855).and.qselect_chan(855)) then
          current_chan = 855
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(856).and.qselect_chan(856)) then
          current_chan = 856
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(857).and.qselect_chan(857)) then
          current_chan = 857
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgD0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q        
        if (qactive_chan(858).and.qselect_chan(858)) then
          current_chan = 858
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqbDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q          
        if (qactive_chan(859).and.qselect_chan(859)) then
          current_chan = 859
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqDh0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q        
        if (qactive_chan(860).and.qselect_chan(860)) then
          current_chan = 860
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqDh0g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb      
        if (qactive_chan(861).and.qselect_chan(861)) then
          current_chan = 861
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDh0g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(862).and.qselect_chan(862)) then
          current_chan = 862
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(863).and.qselect_chan(863)) then
          current_chan = 863
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqbDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(864).and.qselect_chan(864)) then
          current_chan = 864
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(865).and.qselect_chan(865)) then
          current_chan = 865
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(866).and.qselect_chan(866)) then
          current_chan = 866
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(867).and.qselect_chan(867)) then
          current_chan = 867
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(868).and.qselect_chan(868)) then
          current_chan = 868
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(869).and.qselect_chan(869)) then
          current_chan = 869
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(870).and.qselect_chan(870)) then
          current_chan = 870
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(871).and.qselect_chan(871)) then
          current_chan = 871
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(872).and.qselect_chan(872)) then
          current_chan = 872
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(873).and.qselect_chan(873)) then
          current_chan = 873
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(874).and.qselect_chan(874)) then
          current_chan = 874
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgDh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q        
        if (qactive_chan(875).and.qselect_chan(875)) then
          current_chan = 875
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqbDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q          
        if (qactive_chan(876).and.qselect_chan(876)) then
          current_chan = 876
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqDhh0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q        
        if (qactive_chan(877).and.qselect_chan(877)) then
          current_chan = 877
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqDhh0g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb      
        if (qactive_chan(878).and.qselect_chan(878)) then
          current_chan = 878
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDhh0g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(879).and.qselect_chan(879)) then
          current_chan = 879
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(880).and.qselect_chan(880)) then
          current_chan = 880
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqbDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(881).and.qselect_chan(881)) then
          current_chan = 881
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(882).and.qselect_chan(882)) then
          current_chan = 882
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(883).and.qselect_chan(883)) then
          current_chan = 883
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(884).and.qselect_chan(884)) then
          current_chan = 884
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(885).and.qselect_chan(885)) then
          current_chan = 885
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(886).and.qselect_chan(886)) then
          current_chan = 886
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(887).and.qselect_chan(887)) then
          current_chan = 887
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(888).and.qselect_chan(888)) then
          current_chan = 888
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(889).and.qselect_chan(889)) then
          current_chan = 889
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(890).and.qselect_chan(890)) then
          current_chan = 890
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(891).and.qselect_chan(891)) then
          current_chan = 891
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgDhh0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q        
        if (qactive_chan(892).and.qselect_chan(892)) then
          current_chan = 892
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqbDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q          
        if (qactive_chan(893).and.qselect_chan(893)) then
          current_chan = 893
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqDt0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q        
        if (qactive_chan(894).and.qselect_chan(894)) then
          current_chan = 894
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqDt0g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb      
        if (qactive_chan(895).and.qselect_chan(895)) then
          current_chan = 895
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDt0g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(896).and.qselect_chan(896)) then
          current_chan = 896
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(897).and.qselect_chan(897)) then
          current_chan = 897
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqbDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(898).and.qselect_chan(898)) then
          current_chan = 898
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(899).and.qselect_chan(899)) then
          current_chan = 899
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(900).and.qselect_chan(900)) then
          current_chan = 900
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(901).and.qselect_chan(901)) then
          current_chan = 901
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(902).and.qselect_chan(902)) then
          current_chan = 902
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(903).and.qselect_chan(903)) then
          current_chan = 903
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(904).and.qselect_chan(904)) then
          current_chan = 904
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(905).and.qselect_chan(905)) then
          current_chan = 905
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(906).and.qselect_chan(906)) then
          current_chan = 906
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(907).and.qselect_chan(907)) then
          current_chan = 907
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(908).and.qselect_chan(908)) then
          current_chan = 908
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgDt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q        
        if (qactive_chan(909).and.qselect_chan(909)) then
          current_chan = 909
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqbDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q          
        if (qactive_chan(910).and.qselect_chan(910)) then
          current_chan = 910
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqDth0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q        
        if (qactive_chan(911).and.qselect_chan(911)) then
          current_chan = 911
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqDth0g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb      
        if (qactive_chan(912).and.qselect_chan(912)) then
          current_chan = 912
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDth0g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(913).and.qselect_chan(913)) then
          current_chan = 913
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(914).and.qselect_chan(914)) then
          current_chan = 914
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqbDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(915).and.qselect_chan(915)) then
          current_chan = 915
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(916).and.qselect_chan(916)) then
          current_chan = 916
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(917).and.qselect_chan(917)) then
          current_chan = 917
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(918).and.qselect_chan(918)) then
          current_chan = 918
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(919).and.qselect_chan(919)) then
          current_chan = 919
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(920).and.qselect_chan(920)) then
          current_chan = 920
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(921).and.qselect_chan(921)) then
          current_chan = 921
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(922).and.qselect_chan(922)) then
          current_chan = 922
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(923).and.qselect_chan(923)) then
          current_chan = 923
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(924).and.qselect_chan(924)) then
          current_chan = 924
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(925).and.qselect_chan(925)) then
          current_chan = 925
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgDth0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q        
        if (qactive_chan(926).and.qselect_chan(926)) then
          current_chan = 926
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqbDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q          
        if (qactive_chan(927).and.qselect_chan(927)) then
          current_chan = 927
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qqDtt0g2U(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q        
        if (qactive_chan(928).and.qselect_chan(928)) then
          current_chan = 928
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqDtt0g2U(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb      
        if (qactive_chan(929).and.qselect_chan(929)) then
          current_chan = 929
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDtt0g2U(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(930).and.qselect_chan(930)) then
          current_chan = 930
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(931).and.qselect_chan(931)) then
          current_chan = 931
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpqbDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(932).and.qselect_chan(932)) then
          current_chan = 932
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(933).and.qselect_chan(933)) then
          current_chan = 933
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(934).and.qselect_chan(934)) then
          current_chan = 934
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(935).and.qselect_chan(935)) then
          current_chan = 935
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(936).and.qselect_chan(936)) then
          current_chan = 936
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(937).and.qselect_chan(937)) then
          current_chan = 937
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(938).and.qselect_chan(938)) then
          current_chan = 938
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(939).and.qselect_chan(939)) then
          current_chan = 939
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(940).and.qselect_chan(940)) then
          current_chan = 940
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(941).and.qselect_chan(941)) then
          current_chan = 941
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(942).and.qselect_chan(942)) then
          current_chan = 942
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgDtt0g2U(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigU2jetfc=sigU2jetfc+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
