      subroutine getlumiDIS(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    7,   13,   19,   20,   27,   31,   41,          
     &           51,   61,   67,   73,   79,   80,   91,   92,          
     &          103,  109,  115,  125,  135,  145,  155,  165,          
     &          166,  177,  178,  189,  190,  201,  207,  213,          
     &          219,  229,  239,  249,  259,  269)
!       [10, 99]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)                                         
     &       + f1(3,1:nInp_scl)                                         
     &       + f1(5,1:nInp_scl)                                         

        case (    2,    8,   14,   21,   22,   28,   32,   42,          
     &           52,   62,   68,   74,   81,   82,   93,   94,          
     &          104,  110,  116,  126,  136,  146,  156,  167,          
     &          168,  179,  180,  191,  192,  202,  208,  214,          
     &          220,  230,  240,  250,  260,  270)
!       [20, 99]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)                                         
     &       + f1(4,1:nInp_scl)                                         

        case (    3,    4,    9,   10,   15,   16,   33,   34,          
     &           43,   44,   53,   54,   63,   64,   69,   70,          
     &           75,   76,   83,   84,   85,   86,   95,   96,          
     &           97,   98,  105,  106,  111,  112,  117,  118,          
     &          127,  128,  137,  138,  147,  148,  157,  158,          
     &          173,  174,  175,  176,  185,  186,  187,  188,          
     &          197,  198,  199,  200,  205,  206,  211,  212,          
     &          217,  218,  221,  222,  231,  232,  241,  242,          
     &          251,  252,  261,  262,  271,  272)
!       [0, 99]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)                                         

        case (    5,   11,   17,   23,   24,   29,   35,   45,          
     &           55,   65,   71,   77,   87,   88,   99,  100,          
     &          107,  113,  119,  129,  139,  149,  159,  169,          
     &          170,  181,  182,  193,  194,  203,  209,  215,          
     &          223,  233,  243,  253,  263,  273)
!       [-10, 99]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)                                        
     &       + f1(-3,1:nInp_scl)                                        
     &       + f1(-5,1:nInp_scl)                                        

        case (    6,   12,   18,   25,   26,   30,   36,   46,          
     &           56,   66,   72,   78,   89,   90,  101,  102,          
     &          108,  114,  120,  130,  140,  150,  160,  171,          
     &          172,  183,  184,  195,  196,  204,  210,  216,          
     &          224,  234,  244,  254,  264,  274)
!       [-20, 99]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)                                        
     &       + f1(-4,1:nInp_scl)                                        

        case (   37,   38,   47,   48,   57,   58,  121,  122,          
     &          131,  132,  141,  142,  151,  152,  161,  162,          
     &          225,  226,  235,  236,  245,  246,  255,  256,          
     &          265,  266,  275,  276)
!       [30, 99]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)                                         
     &       + f1(2,1:nInp_scl)                                         
     &       + f1(3,1:nInp_scl)                                         
     &       + f1(4,1:nInp_scl)                                         
     &       + f1(5,1:nInp_scl)                                         

        case (   39,   40,   49,   50,   59,   60,  123,  124,          
     &          133,  134,  143,  144,  153,  154,  163,  164,          
     &          227,  228,  237,  238,  247,  248,  257,  258,          
     &          267,  268,  277,  278)
!       [-30, 99]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)                                        
     &       + f1(-2,1:nInp_scl)                                        
     &       + f1(-3,1:nInp_scl)                                        
     &       + f1(-4,1:nInp_scl)                                        
     &       + f1(-5,1:nInp_scl)                                        

        case default
          print*, "getlumiDIS: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiDIS



      function getlumiidDIS(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    7,   13,   19,   20,   27,   31,   41,
     &           51,   61,   67,   73,   79,   80,   91,   92,
     &          103,  109,  115,  125,  135,  145,  155,  165,
     &          166,  177,  178,  189,  190,  201,  207,  213,
     &          219,  229,  239,  249,  259,  269)
          id  = 1
          ip1 = 10
          ip2 = 99

        case (    2,    8,   14,   21,   22,   28,   32,   42,
     &           52,   62,   68,   74,   81,   82,   93,   94,
     &          104,  110,  116,  126,  136,  146,  156,  167,
     &          168,  179,  180,  191,  192,  202,  208,  214,
     &          220,  230,  240,  250,  260,  270)
          id  = 2
          ip1 = 20
          ip2 = 99

        case (    3,    4,    9,   10,   15,   16,   33,   34,
     &           43,   44,   53,   54,   63,   64,   69,   70,
     &           75,   76,   83,   84,   85,   86,   95,   96,
     &           97,   98,  105,  106,  111,  112,  117,  118,
     &          127,  128,  137,  138,  147,  148,  157,  158,
     &          173,  174,  175,  176,  185,  186,  187,  188,
     &          197,  198,  199,  200,  205,  206,  211,  212,
     &          217,  218,  221,  222,  231,  232,  241,  242,
     &          251,  252,  261,  262,  271,  272)
          id  = 3
          ip1 = 0
          ip2 = 99

        case (    5,   11,   17,   23,   24,   29,   35,   45,
     &           55,   65,   71,   77,   87,   88,   99,  100,
     &          107,  113,  119,  129,  139,  149,  159,  169,
     &          170,  181,  182,  193,  194,  203,  209,  215,
     &          223,  233,  243,  253,  263,  273)
          id  = 4
          ip1 = -10
          ip2 = 99

        case (    6,   12,   18,   25,   26,   30,   36,   46,
     &           56,   66,   72,   78,   89,   90,  101,  102,
     &          108,  114,  120,  130,  140,  150,  160,  171,
     &          172,  183,  184,  195,  196,  204,  210,  216,
     &          224,  234,  244,  254,  264,  274)
          id  = 5
          ip1 = -20
          ip2 = 99

        case (   37,   38,   47,   48,   57,   58,  121,  122,
     &          131,  132,  141,  142,  151,  152,  161,  162,
     &          225,  226,  235,  236,  245,  246,  255,  256,
     &          265,  266,  275,  276)
          id  = 6
          ip1 = 30
          ip2 = 99

        case (   39,   40,   49,   50,   59,   60,  123,  124,
     &          133,  134,  143,  144,  153,  154,  163,  164,
     &          227,  228,  237,  238,  247,  248,  257,  258,
     &          267,  268,  277,  278)
          id  = 7
          ip1 = -30
          ip2 = 99

        case default
          print*, "getlumiidDIS: invalid iproc:", iproc
          stop
        end select

      end function getlumiidDIS





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiDIS()
        use PineAPPL_mod
        use CKM_mod
!       [10, 99]
        call register_lumi_pine(
     &         [    1,    7,   13,   19,   20,   27,   31,   41,
     &             51,   61,   67,   73,   79,   80,   91,   92,
     &            103,  109,  115,  125,  135,  145,  155,  165,
     &            166,  177,  178,  189,  190,  201,  207,  213,
     &            219,  229,  239,  249,  259,  269],
     &         3,
     &         [    1,   99,    3,   99,    5,   99],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 99]
        call register_lumi_pine(
     &         [    2,    8,   14,   21,   22,   28,   32,   42,
     &             52,   62,   68,   74,   81,   82,   93,   94,
     &            104,  110,  116,  126,  136,  146,  156,  167,
     &            168,  179,  180,  191,  192,  202,  208,  214,
     &            220,  230,  240,  250,  260,  270],
     &         2,
     &         [    2,   99,    4,   99],
     &         [  1d0,  1d0]
     &       )

!       [0, 99]
        call register_lumi_pine(
     &         [    3,    4,    9,   10,   15,   16,   33,   34,
     &             43,   44,   53,   54,   63,   64,   69,   70,
     &             75,   76,   83,   84,   85,   86,   95,   96,
     &             97,   98,  105,  106,  111,  112,  117,  118,
     &            127,  128,  137,  138,  147,  148,  157,  158,
     &            173,  174,  175,  176,  185,  186,  187,  188,
     &            197,  198,  199,  200,  205,  206,  211,  212,
     &            217,  218,  221,  222,  231,  232,  241,  242,
     &            251,  252,  261,  262,  271,  272],
     &         1,
     &         [   21,   99],
     &         [  1d0]
     &       )

!       [-10, 99]
        call register_lumi_pine(
     &         [    5,   11,   17,   23,   24,   29,   35,   45,
     &             55,   65,   71,   77,   87,   88,   99,  100,
     &            107,  113,  119,  129,  139,  149,  159,  169,
     &            170,  181,  182,  193,  194,  203,  209,  215,
     &            223,  233,  243,  253,  263,  273],
     &         3,
     &         [   -1,   99,   -3,   99,   -5,   99],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 99]
        call register_lumi_pine(
     &         [    6,   12,   18,   25,   26,   30,   36,   46,
     &             56,   66,   72,   78,   89,   90,  101,  102,
     &            108,  114,  120,  130,  140,  150,  160,  171,
     &            172,  183,  184,  195,  196,  204,  210,  216,
     &            224,  234,  244,  254,  264,  274],
     &         2,
     &         [   -2,   99,   -4,   99],
     &         [  1d0,  1d0]
     &       )

!       [30, 99]
        call register_lumi_pine(
     &         [   37,   38,   47,   48,   57,   58,  121,  122,
     &            131,  132,  141,  142,  151,  152,  161,  162,
     &            225,  226,  235,  236,  245,  246,  255,  256,
     &            265,  266,  275,  276],
     &         5,
     &         [    1,   99,    2,   99,    3,   99,    4,   99,
     &              5,   99],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 99]
        call register_lumi_pine(
     &         [   39,   40,   49,   50,   59,   60,  123,  124,
     &            133,  134,  143,  144,  153,  154,  163,  164,
     &            227,  228,  237,  238,  247,  248,  257,  258,
     &            267,  268,  277,  278],
     &         5,
     &         [   -1,   99,   -2,   99,   -3,   99,   -4,   99,
     &             -5,   99],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiDIS


#endif


