      subroutine getqcdnormDIS(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtDIS(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_dis(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVDIS
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourDIS(current_chan)
         do isub = 1, nflavourDIS(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_DIS(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=DIS "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*amz)**2*nc*(nc**2-1d0)/(2d0*nc)*8d0
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d em -> em g d          B1g0Z
      case(2)
         factor=facB                        ! u em -> em g u          B1g0Z
      case(3)
         factor=ndown*facB                  ! g em -> em db d         B1g0Z
      case(4)
         factor=nup*facB                    ! g em -> em ub u         B1g0Z
      case(5)
         factor=facB                        ! db em -> em db g        B1g0Z
      case(6)
         factor=facB                        ! ub em -> em ub g        B1g0Z

c -- real

      case(7)
         factor=1d0/2d0*facR                ! d em -> em g g d        B2g0ZDIS
      case(8)
         factor=1d0/2d0*facR                ! u em -> em g g u        B2g0ZDIS
      case(9)
         factor=ndown*facR                  ! g em -> em db g d       B2g0ZDIS
      case(10)
         factor=nup*facR                    ! g em -> em ub g u       B2g0ZDIS
      case(11)
         factor=1d0/2d0*facR                ! db em -> em db g g      B2g0ZDIS
      case(12)
         factor=1d0/2d0*facR                ! ub em -> em ub g g      B2g0ZDIS
      case(13)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d em -> em gt gt d      Bt2g0ZDIS
      case(14)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u em -> em gt gt u      Bt2g0ZDIS
      case(15)
         factor=-1d0/nc**2*ndown*facR       ! gt em -> em db gt d     Bt2g0ZDIS
      case(16)
         factor=-1d0/nc**2*nup*facR         ! gt em -> em ub gt u     Bt2g0ZDIS
      case(17)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db em -> em db gt gt     Bt2g0ZDIS
      case(18)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub em -> em ub gt gt     Bt2g0ZDIS
      case(19)
         factor=1d0/nc*ndown*facR           ! d em -> em d db d       C0g0ZDIS
      case(20)
         factor=1d0/nc*nup*facR             ! d em -> em u ub d       C0g0ZDIS
      case(21)
         factor=1d0/nc*ndown*facR           ! u em -> em d db u       C0g0ZDIS
      case(22)
         factor=1d0/nc*nup*facR             ! u em -> em u ub u       C0g0ZDIS
      case(23)
         factor=1d0/nc*ndown*facR           ! db em -> em db d db     C0g0ZDIS
      case(24)
         factor=1d0/nc*nup*facR             ! db em -> em db u ub     C0g0ZDIS
      case(25)
         factor=1d0/nc*ndown*facR           ! ub em -> em ub d db     C0g0ZDIS
      case(26)
         factor=1d0/nc*nup*facR             ! ub em -> em ub u ub     C0g0ZDIS
      case(27)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d em -> em d db d       D0g0ZDIS
      case(28)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u em -> em u ub u       D0g0ZDIS
      case(29)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db em -> em db db d     D0g0ZDIS
      case(30)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub em -> em ub ub u     D0g0ZDIS

c -- virtual

      case(31)
         factor=facV                        ! d em -> em g d          B1g1ZDIS
      case(32)
         factor=facV                        ! u em -> em g u          B1g1ZDIS
      case(33)
         factor=ndown*facV                  ! g em -> em db d         B1g1ZDIS
      case(34)
         factor=nup*facV                    ! g em -> em ub u         B1g1ZDIS
      case(35)
         factor=facV                        ! db em -> em db g        B1g1ZDIS
      case(36)
         factor=facV                        ! ub em -> em ub g        B1g1ZDIS
      case(37)
         factor=ndown/nf*facV               ! Q em subtraction        B1g1ZDIS
      case(38)
         factor=1d0/nf*nup*facV             ! Q em subtraction        B1g1ZDIS
      case(39)
         factor=ndown/nf*facV               ! Qb em subtraction       B1g1ZDIS
      case(40)
         factor=1d0/nf*nup*facV             ! Qb em subtraction       B1g1ZDIS
      case(41)
         factor=-1d0/nc**2*facV             ! d em -> em g d          Bt1g1ZDIS
      case(42)
         factor=-1d0/nc**2*facV             ! u em -> em g u          Bt1g1ZDIS
      case(43)
         factor=-1d0/nc**2*ndown*facV       ! g em -> em db d         Bt1g1ZDIS
      case(44)
         factor=-1d0/nc**2*nup*facV         ! g em -> em ub u         Bt1g1ZDIS
      case(45)
         factor=-1d0/nc**2*facV             ! db em -> em db g        Bt1g1ZDIS
      case(46)
         factor=-1d0/nc**2*facV             ! ub em -> em ub g        Bt1g1ZDIS
      case(47)
         factor=-1d0/nc**2*ndown/nf*facV    ! Q em subtraction        Bt1g1ZDIS
      case(48)
         factor=-1d0/nc**2/nf*nup*facV      ! Q em subtraction        Bt1g1ZDIS
      case(49)
         factor=-1d0/nc**2*ndown/nf*facV    ! Qb em subtraction       Bt1g1ZDIS
      case(50)
         factor=-1d0/nc**2/nf*nup*facV      ! Qb em subtraction       Bt1g1ZDIS
      case(51)
         factor=1d0/nc*nf*facV              ! d em -> em g d          Bh1g1ZDIS
      case(52)
         factor=1d0/nc*nf*facV              ! u em -> em g u          Bh1g1ZDIS
      case(53)
         factor=1d0/nc*nf*ndown*facV        ! g em -> em db d         Bh1g1ZDIS
      case(54)
         factor=1d0/nc*nf*nup*facV          ! g em -> em ub u         Bh1g1ZDIS
      case(55)
         factor=1d0/nc*nf*facV              ! db em -> em db g        Bh1g1ZDIS
      case(56)
         factor=1d0/nc*nf*facV              ! ub em -> em ub g        Bh1g1ZDIS
      case(57)
         factor=1d0/nc*ndown*facV           ! Q em subtraction        Bh1g1ZDIS
      case(58)
         factor=1d0/nc*nup*facV             ! Q em subtraction        Bh1g1ZDIS
      case(59)
         factor=1d0/nc*ndown*facV           ! Qb em subtraction       Bh1g1ZDIS
      case(60)
         factor=1d0/nc*nup*facV             ! Qb em subtraction       Bh1g1ZDIS

c -- double real

      case(61)
         factor=1d0/6d0*facRR               ! d em -> em g g g d      sB3g0ZDIS
      case(62)
         factor=1d0/6d0*facRR               ! u em -> em g g g u      sB3g0ZDIS
      case(63)
         factor=1d0/2d0*ndown*facRR         ! g em -> em db g g d     sB3g0ZDIS
      case(64)
         factor=1d0/2d0*nup*facRR           ! g em -> em ub g g u     sB3g0ZDIS
      case(65)
         factor=1d0/6d0*facRR               ! db em -> em db g g g     sB3g0ZDIS
      case(66)
         factor=1d0/6d0*facRR               ! ub em -> em ub g g g     sB3g0ZDIS
      case(67)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! d em -> em g g g d      sBt3g0ZDIS
      case(68)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! u em -> em g g g u      sBt3g0ZDIS
      case(69)
         factor=-1d0/nc**2*1d0/2d0*ndown*facRR   ! g em -> em db g g d     sBt3g0ZDIS
      case(70)
         factor=-1d0/nc**2*1d0/2d0*nup*facRR   ! g em -> em ub g g u     sBt3g0ZDIS
      case(71)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! db em -> em db g g g     sBt3g0ZDIS
      case(72)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! ub em -> em ub g g g     sBt3g0ZDIS
      case(73)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! d em -> em gt gt gt d     sBtt3g0ZDIS
      case(74)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! u em -> em gt gt gt u     sBtt3g0ZDIS
      case(75)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*ndown*facRR   ! gt em -> em db gt gt d     sBtt3g0ZDIS
      case(76)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*nup*facRR   ! gt em -> em ub gt gt u     sBtt3g0ZDIS
      case(77)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! db em -> em db gt gt gt     sBtt3g0ZDIS
      case(78)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! ub em -> em ub gt gt gt     sBtt3g0ZDIS
      case(79)
         factor=1d0/nc*ndown*facRR          ! d em -> em g d db d     sC1g0ZDIS
      case(80)
         factor=1d0/nc*nup*facRR            ! d em -> em g u ub d     sC1g0ZDIS
      case(81)
         factor=1d0/nc*ndown*facRR          ! u em -> em g d db u     sC1g0ZDIS
      case(82)
         factor=1d0/nc*nup*facRR            ! u em -> em g u ub u     sC1g0ZDIS
      case(83)
         factor=1d0/nc*1d0/2d0*ndown**2*facRR   ! g em -> em db d db d     sC1g0ZDIS
      case(84)
         factor=1d0/nc*1d0/2d0*ndown*nup*facRR   ! g em -> em db u ub d     sC1g0ZDIS
      case(85)
         factor=1d0/nc*1d0/2d0*ndown*nup*facRR   ! g em -> em ub d db u     sC1g0ZDIS
      case(86)
         factor=1d0/nc*1d0/2d0*nup**2*facRR   ! g em -> em ub u ub u     sC1g0ZDIS
      case(87)
         factor=1d0/nc*ndown*facRR          ! db em -> em db g d db     sC1g0ZDIS
      case(88)
         factor=1d0/nc*nup*facRR            ! db em -> em db g u ub     sC1g0ZDIS
      case(89)
         factor=1d0/nc*ndown*facRR          ! ub em -> em ub g d db     sC1g0ZDIS
      case(90)
         factor=1d0/nc*nup*facRR            ! ub em -> em ub g u ub     sC1g0ZDIS
      case(91)
         factor=-1d0/nc**3*ndown*facRR      ! d em -> em g d db d     sCt1g0ZDIS
      case(92)
         factor=-1d0/nc**3*nup*facRR        ! d em -> em g u ub d     sCt1g0ZDIS
      case(93)
         factor=-1d0/nc**3*ndown*facRR      ! u em -> em g d db u     sCt1g0ZDIS
      case(94)
         factor=-1d0/nc**3*nup*facRR        ! u em -> em g u ub u     sCt1g0ZDIS
      case(95)
         factor=-1d0/nc**3*1d0/2d0*ndown**2*facRR   ! g em -> em db d db d     sCt1g0ZDIS
      case(96)
         factor=-1d0/nc**3*1d0/2d0*ndown*nup*facRR   ! g em -> em db u ub d     sCt1g0ZDIS
      case(97)
         factor=-1d0/nc**3*1d0/2d0*ndown*nup*facRR   ! g em -> em ub d db u     sCt1g0ZDIS
      case(98)
         factor=-1d0/nc**3*1d0/2d0*nup**2*facRR   ! g em -> em ub u ub u     sCt1g0ZDIS
      case(99)
         factor=-1d0/nc**3*ndown*facRR      ! db em -> em db g d db     sCt1g0ZDIS
      case(100)
         factor=-1d0/nc**3*nup*facRR        ! db em -> em db g u ub     sCt1g0ZDIS
      case(101)
         factor=-1d0/nc**3*ndown*facRR      ! ub em -> em ub g d db     sCt1g0ZDIS
      case(102)
         factor=-1d0/nc**3*nup*facRR        ! ub em -> em ub g u ub     sCt1g0ZDIS
      case(103)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d em -> em g d db d     D1g0ZcDIS
      case(104)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u em -> em g u ub u     D1g0ZcDIS
      case(105)
         factor=-1d0/nc**2*1d0/4d0*ndown*facRR   ! g em -> em db d db d     D1g0ZcDIS
      case(106)
         factor=-1d0/nc**2*1d0/4d0*nup*facRR   ! g em -> em ub u ub u     D1g0ZcDIS
      case(107)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db em -> em db g db d     D1g0ZcDIS
      case(108)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub em -> em ub g ub u     D1g0ZcDIS
      case(109)
         factor=1d0/nc**4*1d0/2d0*facRR     ! d em -> em g d db d     Dt1g0ZDIS
      case(110)
         factor=1d0/nc**4*1d0/2d0*facRR     ! u em -> em g u ub u     Dt1g0ZDIS
      case(111)
         factor=1d0/nc**4*1d0/4d0*ndown*facRR   ! g em -> em db d db d     Dt1g0ZDIS
      case(112)
         factor=1d0/nc**4*1d0/4d0*nup*facRR   ! g em -> em ub u ub u     Dt1g0ZDIS
      case(113)
         factor=1d0/nc**4*1d0/2d0*facRR     ! db em -> em db g db d     Dt1g0ZDIS
      case(114)
         factor=1d0/nc**4*1d0/2d0*facRR     ! ub em -> em ub g ub u     Dt1g0ZDIS

c -- real virtual

      case(115)
         factor=1d0/2d0*facRV               ! d em -> em g g d        sB2g1ZDIS
      case(116)
         factor=1d0/2d0*facRV               ! u em -> em g g u        sB2g1ZDIS
      case(117)
         factor=ndown*facRV                 ! g em -> em db g d       sB2g1ZDIS
      case(118)
         factor=nup*facRV                   ! g em -> em ub g u       sB2g1ZDIS
      case(119)
         factor=1d0/2d0*facRV               ! db em -> em db g g      sB2g1ZDIS
      case(120)
         factor=1d0/2d0*facRV               ! ub em -> em ub g g      sB2g1ZDIS
      case(121)
         factor=ndown/nf*facRV              ! Q em subtraction        sB2g1ZDIS
      case(122)
         factor=1d0/nf*nup*facRV            ! Q em subtraction        sB2g1ZDIS
      case(123)
         factor=ndown/nf*facRV              ! Qb em subtraction       sB2g1ZDIS
      case(124)
         factor=1d0/nf*nup*facRV            ! Qb em subtraction       sB2g1ZDIS
      case(125)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! d em -> em gt gt d      sBt2g1ZDIS
      case(126)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! u em -> em gt gt u      sBt2g1ZDIS
      case(127)
         factor=-1d0/nc**2*ndown*facRV      ! gt em -> em db gt d     sBt2g1ZDIS
      case(128)
         factor=-1d0/nc**2*nup*facRV        ! gt em -> em ub gt u     sBt2g1ZDIS
      case(129)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! db em -> em db gt gt     sBt2g1ZDIS
      case(130)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! ub em -> em ub gt gt     sBt2g1ZDIS
      case(131)
         factor=-1d0/nc**2*ndown/nf*facRV   ! Q em subtraction        sBt2g1ZDIS
      case(132)
         factor=-1d0/nc**2/nf*nup*facRV     ! Q em subtraction        sBt2g1ZDIS
      case(133)
         factor=-1d0/nc**2*ndown/nf*facRV   ! Qb em subtraction       sBt2g1ZDIS
      case(134)
         factor=-1d0/nc**2/nf*nup*facRV     ! Qb em subtraction       sBt2g1ZDIS
      case(135)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d em -> em gt gt d      sBttt2g1ZDIS
      case(136)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u em -> em gt gt u      sBttt2g1ZDIS
      case(137)
         factor=1d0/nc**4*ndown*facRV       ! gt em -> em db gt d     sBttt2g1ZDIS
      case(138)
         factor=1d0/nc**4*nup*facRV         ! gt em -> em ub gt u     sBttt2g1ZDIS
      case(139)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db em -> em db gt gt     sBttt2g1ZDIS
      case(140)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub em -> em ub gt gt     sBttt2g1ZDIS
      case(141)
         factor=1d0/nc**4*ndown/nf*facRV    ! Q em subtraction        sBttt2g1ZDIS
      case(142)
         factor=1d0/nc**4/nf*nup*facRV      ! Q em subtraction        sBttt2g1ZDIS
      case(143)
         factor=1d0/nc**4*ndown/nf*facRV    ! Qb em subtraction       sBttt2g1ZDIS
      case(144)
         factor=1d0/nc**4/nf*nup*facRV      ! Qb em subtraction       sBttt2g1ZDIS
      case(145)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! d em -> em g g d        sBh2g1ZDIS
      case(146)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! u em -> em g g u        sBh2g1ZDIS
      case(147)
         factor=1d0/nc*nf*ndown*facRV       ! g em -> em db g d       sBh2g1ZDIS
      case(148)
         factor=1d0/nc*nf*nup*facRV         ! g em -> em ub g u       sBh2g1ZDIS
      case(149)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! db em -> em db g g      sBh2g1ZDIS
      case(150)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! ub em -> em ub g g      sBh2g1ZDIS
      case(151)
         factor=1d0/nc*ndown*facRV          ! Q em subtraction        sBh2g1ZDIS
      case(152)
         factor=1d0/nc*nup*facRV            ! Q em subtraction        sBh2g1ZDIS
      case(153)
         factor=1d0/nc*ndown*facRV          ! Qb em subtraction       sBh2g1ZDIS
      case(154)
         factor=1d0/nc*nup*facRV            ! Qb em subtraction       sBh2g1ZDIS
      case(155)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! d em -> em gt gt d      sBth2g1ZDIS
      case(156)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! u em -> em gt gt u      sBth2g1ZDIS
      case(157)
         factor=-1d0/nc**3*nf*ndown*facRV   ! gt em -> em db gt d     sBth2g1ZDIS
      case(158)
         factor=-1d0/nc**3*nf*nup*facRV     ! gt em -> em ub gt u     sBth2g1ZDIS
      case(159)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! db em -> em db gt gt     sBth2g1ZDIS
      case(160)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! ub em -> em ub gt gt     sBth2g1ZDIS
      case(161)
         factor=-1d0/nc**3*ndown*facRV      ! Q em subtraction        sBth2g1ZDIS
      case(162)
         factor=-1d0/nc**3*nup*facRV        ! Q em subtraction        sBth2g1ZDIS
      case(163)
         factor=-1d0/nc**3*ndown*facRV      ! Qb em subtraction       sBth2g1ZDIS
      case(164)
         factor=-1d0/nc**3*nup*facRV        ! Qb em subtraction       sBth2g1ZDIS
      case(165)
         factor=1d0/nc*ndown*facRV          ! d em -> em d db d       sC0g1ZDIS
      case(166)
         factor=1d0/nc*nup*facRV            ! d em -> em u ub d       sC0g1ZDIS
      case(167)
         factor=1d0/nc*ndown*facRV          ! u em -> em d db u       sC0g1ZDIS
      case(168)
         factor=1d0/nc*nup*facRV            ! u em -> em u ub u       sC0g1ZDIS
      case(169)
         factor=1d0/nc*ndown*facRV          ! db em -> em db d db     sC0g1ZDIS
      case(170)
         factor=1d0/nc*nup*facRV            ! db em -> em db u ub     sC0g1ZDIS
      case(171)
         factor=1d0/nc*ndown*facRV          ! ub em -> em ub d db     sC0g1ZDIS
      case(172)
         factor=1d0/nc*nup*facRV            ! ub em -> em ub u ub     sC0g1ZDIS
      case(173)
         factor=1d0/nc*ndown**2*facRV       ! g em subtraction        sC0g1ZDIS
      case(174)
         factor=1d0/nc*ndown*nup*facRV      ! g em subtraction        sC0g1ZDIS
      case(175)
         factor=1d0/nc*ndown*nup*facRV      ! g em subtraction        sC0g1ZDIS
      case(176)
         factor=1d0/nc*nup**2*facRV         ! g em subtraction        sC0g1ZDIS
      case(177)
         factor=-1d0/nc**3*ndown*facRV      ! d em -> em d db d       Ct0g1ZDIS
      case(178)
         factor=-1d0/nc**3*nup*facRV        ! d em -> em u ub d       Ct0g1ZDIS
      case(179)
         factor=-1d0/nc**3*ndown*facRV      ! u em -> em d db u       Ct0g1ZDIS
      case(180)
         factor=-1d0/nc**3*nup*facRV        ! u em -> em u ub u       Ct0g1ZDIS
      case(181)
         factor=-1d0/nc**3*ndown*facRV      ! db em -> em db d db     Ct0g1ZDIS
      case(182)
         factor=-1d0/nc**3*nup*facRV        ! db em -> em db u ub     Ct0g1ZDIS
      case(183)
         factor=-1d0/nc**3*ndown*facRV      ! ub em -> em ub d db     Ct0g1ZDIS
      case(184)
         factor=-1d0/nc**3*nup*facRV        ! ub em -> em ub u ub     Ct0g1ZDIS
      case(185)
         factor=-1d0/nc**3*ndown**2*facRV   ! g em subtraction        Ct0g1ZDIS
      case(186)
         factor=-1d0/nc**3*ndown*nup*facRV   ! g em subtraction        Ct0g1ZDIS
      case(187)
         factor=-1d0/nc**3*ndown*nup*facRV   ! g em subtraction        Ct0g1ZDIS
      case(188)
         factor=-1d0/nc**3*nup**2*facRV     ! g em subtraction        Ct0g1ZDIS
      case(189)
         factor=1d0/nc**2*nf*ndown*facRV    ! d em -> em d db d       Ch0g1ZDIS
      case(190)
         factor=1d0/nc**2*nf*nup*facRV      ! d em -> em u ub d       Ch0g1ZDIS
      case(191)
         factor=1d0/nc**2*nf*ndown*facRV    ! u em -> em d db u       Ch0g1ZDIS
      case(192)
         factor=1d0/nc**2*nf*nup*facRV      ! u em -> em u ub u       Ch0g1ZDIS
      case(193)
         factor=1d0/nc**2*nf*ndown*facRV    ! db em -> em db d db     Ch0g1ZDIS
      case(194)
         factor=1d0/nc**2*nf*nup*facRV      ! db em -> em db u ub     Ch0g1ZDIS
      case(195)
         factor=1d0/nc**2*nf*ndown*facRV    ! ub em -> em ub d db     Ch0g1ZDIS
      case(196)
         factor=1d0/nc**2*nf*nup*facRV      ! ub em -> em ub u ub     Ch0g1ZDIS
      case(197)
         factor=1d0/nc**2*ndown**2*nf*facRV   ! g em subtraction        Ch0g1ZDIS
      case(198)
         factor=1d0/nc**2*ndown*nf*nup*facRV   ! g em subtraction        Ch0g1ZDIS
      case(199)
         factor=1d0/nc**2*ndown*nf*nup*facRV   ! g em subtraction        Ch0g1ZDIS
      case(200)
         factor=1d0/nc**2*nf*nup**2*facRV   ! g em subtraction        Ch0g1ZDIS
      case(201)
         factor=1d0/nc**2*1d0/2d0*facRV     ! d em -> em d db d       D0g1ZDIS
      case(202)
         factor=1d0/nc**2*1d0/2d0*facRV     ! u em -> em u ub u       D0g1ZDIS
      case(203)
         factor=1d0/nc**2*1d0/2d0*facRV     ! db em -> em db db d     D0g1ZDIS
      case(204)
         factor=1d0/nc**2*1d0/2d0*facRV     ! ub em -> em ub ub u     D0g1ZDIS
      case(205)
         factor=1d0/nc**2*ndown*facRV       ! g em subtraction        D0g1ZDIS
      case(206)
         factor=1d0/nc**2*nup*facRV         ! g em subtraction        D0g1ZDIS
      case(207)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d em -> em d db d       Dt0g1ZDIS
      case(208)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u em -> em u ub u       Dt0g1ZDIS
      case(209)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db em -> em db db d     Dt0g1ZDIS
      case(210)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub em -> em ub ub u     Dt0g1ZDIS
      case(211)
         factor=1d0/nc**4*ndown*facRV       ! g em subtraction        Dt0g1ZDIS
      case(212)
         factor=1d0/nc**4*nup*facRV         ! g em subtraction        Dt0g1ZDIS
      case(213)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! d em -> em d db d       Dh0g1ZDIS
      case(214)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! u em -> em u ub u       Dh0g1ZDIS
      case(215)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! db em -> em db db d     Dh0g1ZDIS
      case(216)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! ub em -> em ub ub u     Dh0g1ZDIS
      case(217)
         factor=1d0/nc**3*ndown*nf*facRV    ! g em subtraction        Dh0g1ZDIS
      case(218)
         factor=1d0/nc**3*nf*nup*facRV      ! g em subtraction        Dh0g1ZDIS

c -- double virtual

      case(219)
         factor=facVV                       ! d em -> em g d          B1g2ZDIS
      case(220)
         factor=facVV                       ! u em -> em g u          B1g2ZDIS
      case(221)
         factor=ndown*facVV                 ! g em -> em db d         B1g2ZDIS
      case(222)
         factor=nup*facVV                   ! g em -> em ub u         B1g2ZDIS
      case(223)
         factor=facVV                       ! db em -> em db g        B1g2ZDIS
      case(224)
         factor=facVV                       ! ub em -> em ub g        B1g2ZDIS
      case(225)
         factor=ndown/nf*facVV              ! Q em subtraction        B1g2ZDIS
      case(226)
         factor=1d0/nf*nup*facVV            ! Q em subtraction        B1g2ZDIS
      case(227)
         factor=ndown/nf*facVV              ! Qb em subtraction       B1g2ZDIS
      case(228)
         factor=1d0/nf*nup*facVV            ! Qb em subtraction       B1g2ZDIS
      case(229)
         factor=-1d0/nc**2*facVV            ! d em -> em g d          Bt1g2ZDIS
      case(230)
         factor=-1d0/nc**2*facVV            ! u em -> em g u          Bt1g2ZDIS
      case(231)
         factor=-1d0/nc**2*ndown*facVV      ! g em -> em db d         Bt1g2ZDIS
      case(232)
         factor=-1d0/nc**2*nup*facVV        ! g em -> em ub u         Bt1g2ZDIS
      case(233)
         factor=-1d0/nc**2*facVV            ! db em -> em db g        Bt1g2ZDIS
      case(234)
         factor=-1d0/nc**2*facVV            ! ub em -> em ub g        Bt1g2ZDIS
      case(235)
         factor=-1d0/nc**2*ndown/nf*facVV   ! Q em subtraction        Bt1g2ZDIS
      case(236)
         factor=-1d0/nc**2/nf*nup*facVV     ! Q em subtraction        Bt1g2ZDIS
      case(237)
         factor=-1d0/nc**2*ndown/nf*facVV   ! Qb em subtraction       Bt1g2ZDIS
      case(238)
         factor=-1d0/nc**2/nf*nup*facVV     ! Qb em subtraction       Bt1g2ZDIS
      case(239)
         factor=1d0/nc**4*facVV             ! d em -> em g d          Btt1g2ZDIS
      case(240)
         factor=1d0/nc**4*facVV             ! u em -> em g u          Btt1g2ZDIS
      case(241)
         factor=1d0/nc**4*ndown*facVV       ! g em -> em db d         Btt1g2ZDIS
      case(242)
         factor=1d0/nc**4*nup*facVV         ! g em -> em ub u         Btt1g2ZDIS
      case(243)
         factor=1d0/nc**4*facVV             ! db em -> em db g        Btt1g2ZDIS
      case(244)
         factor=1d0/nc**4*facVV             ! ub em -> em ub g        Btt1g2ZDIS
      case(245)
         factor=1d0/nc**4*ndown/nf*facVV    ! Q em subtraction        Btt1g2ZDIS
      case(246)
         factor=1d0/nc**4/nf*nup*facVV      ! Q em subtraction        Btt1g2ZDIS
      case(247)
         factor=1d0/nc**4*ndown/nf*facVV    ! Qb em subtraction       Btt1g2ZDIS
      case(248)
         factor=1d0/nc**4/nf*nup*facVV      ! Qb em subtraction       Btt1g2ZDIS
      case(249)
         factor=1d0/nc*nf*facVV             ! d em -> em g d          Bh1g2ZDIS
      case(250)
         factor=1d0/nc*nf*facVV             ! u em -> em g u          Bh1g2ZDIS
      case(251)
         factor=1d0/nc*nf*ndown*facVV       ! g em -> em db d         Bh1g2ZDIS
      case(252)
         factor=1d0/nc*nf*nup*facVV         ! g em -> em ub u         Bh1g2ZDIS
      case(253)
         factor=1d0/nc*nf*facVV             ! db em -> em db g        Bh1g2ZDIS
      case(254)
         factor=1d0/nc*nf*facVV             ! ub em -> em ub g        Bh1g2ZDIS
      case(255)
         factor=1d0/nc*ndown*facVV          ! Q em subtraction        Bh1g2ZDIS
      case(256)
         factor=1d0/nc*nup*facVV            ! Q em subtraction        Bh1g2ZDIS
      case(257)
         factor=1d0/nc*ndown*facVV          ! Qb em subtraction       Bh1g2ZDIS
      case(258)
         factor=1d0/nc*nup*facVV            ! Qb em subtraction       Bh1g2ZDIS
      case(259)
         factor=1d0/nc**3*nf*facVV          ! d em -> em g d          Bht1g2ZDIS
      case(260)
         factor=1d0/nc**3*nf*facVV          ! u em -> em g u          Bht1g2ZDIS
      case(261)
         factor=1d0/nc**3*nf*ndown*facVV    ! g em -> em db d         Bht1g2ZDIS
      case(262)
         factor=1d0/nc**3*nf*nup*facVV      ! g em -> em ub u         Bht1g2ZDIS
      case(263)
         factor=1d0/nc**3*nf*facVV          ! db em -> em db g        Bht1g2ZDIS
      case(264)
         factor=1d0/nc**3*nf*facVV          ! ub em -> em ub g        Bht1g2ZDIS
      case(265)
         factor=1d0/nc**3*ndown*facVV       ! Q em subtraction        Bht1g2ZDIS
      case(266)
         factor=1d0/nc**3*nup*facVV         ! Q em subtraction        Bht1g2ZDIS
      case(267)
         factor=1d0/nc**3*ndown*facVV       ! Qb em subtraction       Bht1g2ZDIS
      case(268)
         factor=1d0/nc**3*nup*facVV         ! Qb em subtraction       Bht1g2ZDIS
      case(269)
         factor=1d0/nc**2*nf**2*facVV       ! d em -> em g d          Bhh1g2ZDIS
      case(270)
         factor=1d0/nc**2*nf**2*facVV       ! u em -> em g u          Bhh1g2ZDIS
      case(271)
         factor=1d0/nc**2*nf**2*ndown*facVV   ! g em -> em db d         Bhh1g2ZDIS
      case(272)
         factor=1d0/nc**2*nf**2*nup*facVV   ! g em -> em ub u         Bhh1g2ZDIS
      case(273)
         factor=1d0/nc**2*nf**2*facVV       ! db em -> em db g        Bhh1g2ZDIS
      case(274)
         factor=1d0/nc**2*nf**2*facVV       ! ub em -> em ub g        Bhh1g2ZDIS
      case(275)
         factor=1d0/nc**2*ndown*nf*facVV    ! Q em subtraction        Bhh1g2ZDIS
      case(276)
         factor=1d0/nc**2*nf*nup*facVV      ! Q em subtraction        Bhh1g2ZDIS
      case(277)
         factor=1d0/nc**2*ndown*nf*facVV    ! Qb em subtraction       Bhh1g2ZDIS
      case(278)
         factor=1d0/nc**2*nf*nup*facVV      ! Qb em subtraction       Bhh1g2ZDIS
      end select
      factor=relfactor*factor

      return
      end
