      subroutine selectchannelDIS()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*alphas_scl)*(4d0*pi*amz)**2*nc*(nc**2-1d0)/(2d0*nc)*8d0
      n_alphas_proc = 1
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelDIS: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelDIS: already allocated'  
        stop
      end if

      ntot_chan = 278

      allocate(qactive_chan(1:278))
      allocate(contrib_chan(1:278))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! d em to em g d        B1g0Z(1,4,5,3,2)      
c      qactive_chan(2)  = .true.   ! u em to em g u        B1g0Z(1,4,5,3,2)      
c      qactive_chan(3)  = .true.   ! g em to em db d       B1g0Z(4,1,5,3,2)      
c      qactive_chan(4)  = .true.   ! g em to em ub u       B1g0Z(4,1,5,3,2)      
c      qactive_chan(5)  = .true.   ! db em to em db g      B1g0Z(4,5,1,3,2)      
c      qactive_chan(6)  = .true.   ! ub em to em ub g      B1g0Z(4,5,1,3,2)      

      do i=1,6
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(7)  = .true.   ! d em to em g g d      B2g0ZDIS(1,4,5,6,3,2)  qemB2g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(8)  = .true.   ! u em to em g g u      B2g0ZDIS(1,4,5,6,3,2)  qemB2g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(9)  = .true.   ! g em to em db g d     B2g0ZDIS(4,1,5,6,3,2)  gemB2g0ZDISSNLO(4,1,5,6,3,2)
c      qactive_chan(10) = .true.   ! g em to em ub g u     B2g0ZDIS(4,1,5,6,3,2)  gemB2g0ZDISSNLO(4,1,5,6,3,2)
c      qactive_chan(11) = .true.   ! db em to em db g g    B2g0ZDIS(4,5,6,1,3,2)  qbemB2g0ZDISSNLO(4,5,6,1,3,2)
c      qactive_chan(12) = .true.   ! ub em to em ub g g    B2g0ZDIS(4,5,6,1,3,2)  qbemB2g0ZDISSNLO(4,5,6,1,3,2)
c      qactive_chan(13) = .true.   ! d em to em gt gt d    Bt2g0ZDIS(1,4,5,6,3,2)  qemBt2g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(14) = .true.   ! u em to em gt gt u    Bt2g0ZDIS(1,4,5,6,3,2)  qemBt2g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(15) = .true.   ! gt em to em db gt d   Bt2g0ZDIS(4,1,5,6,3,2)  gtemBt2g0ZDISSNLO(4,1,5,6,3,2)
c      qactive_chan(16) = .true.   ! gt em to em ub gt u   Bt2g0ZDIS(4,1,5,6,3,2)  gtemBt2g0ZDISSNLO(4,1,5,6,3,2)
c      qactive_chan(17) = .true.   ! db em to em db gt gt   Bt2g0ZDIS(4,5,6,1,3,2)  qbemBt2g0ZDISSNLO(4,5,6,1,3,2)
c      qactive_chan(18) = .true.   ! ub em to em ub gt gt   Bt2g0ZDIS(4,5,6,1,3,2)  qbemBt2g0ZDISSNLO(4,5,6,1,3,2)
c      qactive_chan(19) = .true.   ! d em to em d db d     C0g0ZDIS(1,4,5,6,3,2)  qemC0g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(20) = .true.   ! d em to em u ub d     C0g0ZDIS(1,4,5,6,3,2)  qemC0g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(21) = .true.   ! u em to em d db u     C0g0ZDIS(1,4,5,6,3,2)  qemC0g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(22) = .true.   ! u em to em u ub u     C0g0ZDIS(1,4,5,6,3,2)  qemC0g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(23) = .true.   ! db em to em db d db   C0g0ZDIS(4,5,6,1,3,2)  qbemC0g0ZDISSNLO(4,5,6,1,3,2)
c      qactive_chan(24) = .true.   ! db em to em db u ub   C0g0ZDIS(4,5,6,1,3,2)  qbemC0g0ZDISSNLO(4,5,6,1,3,2)
c      qactive_chan(25) = .true.   ! ub em to em ub d db   C0g0ZDIS(4,5,6,1,3,2)  qbemC0g0ZDISSNLO(4,5,6,1,3,2)
c      qactive_chan(26) = .true.   ! ub em to em ub u ub   C0g0ZDIS(4,5,6,1,3,2)  qbemC0g0ZDISSNLO(4,5,6,1,3,2)
c      qactive_chan(27) = .true.   ! d em to em d db d     D0g0ZDIS(1,4,5,6,3,2)  qemD0g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(28) = .true.   ! u em to em u ub u     D0g0ZDIS(1,4,5,6,3,2)  qemD0g0ZDISSNLO(1,4,5,6,3,2)
c      qactive_chan(29) = .true.   ! db em to em db db d   D0g0ZDIS(4,1,5,6,3,2)  qbemD0g0ZDISSNLO(4,1,5,6,3,2)
c      qactive_chan(30) = .true.   ! ub em to em ub ub u   D0g0ZDIS(4,1,5,6,3,2)  qbemD0g0ZDISSNLO(4,1,5,6,3,2)

      do i=7,30
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(31) = .true.   ! d em to em g d        B1g1ZDIS(1,4,5,3,2)   qemB1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(32) = .true.   ! u em to em g u        B1g1ZDIS(1,4,5,3,2)   qemB1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(33) = .true.   ! g em to em db d       B1g1ZDIS(4,1,5,3,2)   gemB1g1ZDISTNLO(4,1,5,3,2)
c      qactive_chan(34) = .true.   ! g em to em ub u       B1g1ZDIS(4,1,5,3,2)   gemB1g1ZDISTNLO(4,1,5,3,2)
c      qactive_chan(35) = .true.   ! db em to em db g      B1g1ZDIS(4,5,1,3,2)   qbemB1g1ZDISTNLO(4,5,1,3,2)
c      qactive_chan(36) = .true.   ! ub em to em ub g      B1g1ZDIS(4,5,1,3,2)   qbemB1g1ZDISTNLO(4,5,1,3,2)
c      qactive_chan(37) = .true.   ! Q em subtraction                            qpemB1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(38) = .true.   ! Q em subtraction                            qpemB1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(39) = .true.   ! Qb em subtraction                           qpbemB1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(40) = .true.   ! Qb em subtraction                           qpbemB1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(41) = .true.   ! d em to em g d        Bt1g1ZDIS(1,4,5,3,2)  qemBt1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(42) = .true.   ! u em to em g u        Bt1g1ZDIS(1,4,5,3,2)  qemBt1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(43) = .true.   ! g em to em db d       Bt1g1ZDIS(4,1,5,3,2)  gemBt1g1ZDISTNLO(4,1,5,3,2)
c      qactive_chan(44) = .true.   ! g em to em ub u       Bt1g1ZDIS(4,1,5,3,2)  gemBt1g1ZDISTNLO(4,1,5,3,2)
c      qactive_chan(45) = .true.   ! db em to em db g      Bt1g1ZDIS(4,5,1,3,2)  qbemBt1g1ZDISTNLO(4,5,1,3,2)
c      qactive_chan(46) = .true.   ! ub em to em ub g      Bt1g1ZDIS(4,5,1,3,2)  qbemBt1g1ZDISTNLO(4,5,1,3,2)
c      qactive_chan(47) = .true.   ! Q em subtraction                            qpemBt1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(48) = .true.   ! Q em subtraction                            qpemBt1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(49) = .true.   ! Qb em subtraction                           qpbemBt1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(50) = .true.   ! Qb em subtraction                           qpbemBt1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(51) = .true.   ! d em to em g d        Bh1g1ZDIS(1,4,5,3,2)  qemBh1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(52) = .true.   ! u em to em g u        Bh1g1ZDIS(1,4,5,3,2)  qemBh1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(53) = .true.   ! g em to em db d       Bh1g1ZDIS(4,1,5,3,2)  gemBh1g1ZDISTNLO(4,1,5,3,2)
c      qactive_chan(54) = .true.   ! g em to em ub u       Bh1g1ZDIS(4,1,5,3,2)  gemBh1g1ZDISTNLO(4,1,5,3,2)
c      qactive_chan(55) = .true.   ! db em to em db g      Bh1g1ZDIS(4,5,1,3,2)  qbemBh1g1ZDISTNLO(4,5,1,3,2)
c      qactive_chan(56) = .true.   ! ub em to em ub g      Bh1g1ZDIS(4,5,1,3,2)  qbemBh1g1ZDISTNLO(4,5,1,3,2)
c      qactive_chan(57) = .true.   ! Q em subtraction                            qpemBh1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(58) = .true.   ! Q em subtraction                            qpemBh1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(59) = .true.   ! Qb em subtraction                           qpbemBh1g1ZDISTNLO(1,4,5,3,2)
c      qactive_chan(60) = .true.   ! Qb em subtraction                           qpbemBh1g1ZDISTNLO(1,4,5,3,2)

      do i=31,60
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(61) = .true.   ! d em to em g g g d    sB3g0ZDIS(1,4,5,6,7,3,2)  qemsB3g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(62) = .true.   ! u em to em g g g u    sB3g0ZDIS(1,4,5,6,7,3,2)  qemsB3g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(63) = .true.   ! g em to em db g g d   sB3g0ZDIS(4,1,5,6,7,3,2)  gemsB3g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(64) = .true.   ! g em to em ub g g u   sB3g0ZDIS(4,1,5,6,7,3,2)  gemsB3g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(65) = .true.   ! db em to em db g g g   sB3g0ZDIS(4,5,6,7,1,3,2)  qbemsB3g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(66) = .true.   ! ub em to em ub g g g   sB3g0ZDIS(4,5,6,7,1,3,2)  qbemsB3g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(67) = .true.   ! d em to em g g g d    sBt3g0ZDIS(1,4,5,6,7,3,2)  qemsBt3g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(68) = .true.   ! u em to em g g g u    sBt3g0ZDIS(1,4,5,6,7,3,2)  qemsBt3g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(69) = .true.   ! g em to em db g g d   sBt3g0ZDIS(4,1,5,6,7,3,2)  gemsBt3g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(70) = .true.   ! g em to em ub g g u   sBt3g0ZDIS(4,1,5,6,7,3,2)  gemsBt3g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(71) = .true.   ! db em to em db g g g   sBt3g0ZDIS(4,5,6,7,1,3,2)  qbemsBt3g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(72) = .true.   ! ub em to em ub g g g   sBt3g0ZDIS(4,5,6,7,1,3,2)  qbemsBt3g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(73) = .true.   ! d em to em gt gt gt d   sBtt3g0ZDIS(1,4,5,6,7,3,2)  qemsBtt3g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(74) = .true.   ! u em to em gt gt gt u   sBtt3g0ZDIS(1,4,5,6,7,3,2)  qemsBtt3g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(75) = .true.   ! gt em to em db gt gt d   sBtt3g0ZDIS(4,1,5,6,7,3,2)  gtemsBtt3g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(76) = .true.   ! gt em to em ub gt gt u   sBtt3g0ZDIS(4,1,5,6,7,3,2)  gtemsBtt3g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(77) = .true.   ! db em to em db gt gt gt   sBtt3g0ZDIS(4,5,6,7,1,3,2)  qbemsBtt3g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(78) = .true.   ! ub em to em ub gt gt gt   sBtt3g0ZDIS(4,5,6,7,1,3,2)  qbemsBtt3g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(79) = .true.   ! d em to em g d db d   sC1g0ZDIS(1,4,5,6,7,3,2)  qemsC1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(80) = .true.   ! d em to em g u ub d   sC1g0ZDIS(1,4,5,6,7,3,2)  qemsC1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(81) = .true.   ! u em to em g d db u   sC1g0ZDIS(1,4,5,6,7,3,2)  qemsC1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(82) = .true.   ! u em to em g u ub u   sC1g0ZDIS(1,4,5,6,7,3,2)  qemsC1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(83) = .true.   ! g em to em db d db d   sC1g0ZDIS(4,1,5,6,7,3,2)  gemsC1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(84) = .true.   ! g em to em db u ub d   sC1g0ZDIS(4,1,5,6,7,3,2)  gemsC1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(85) = .true.   ! g em to em ub d db u   sC1g0ZDIS(4,1,5,6,7,3,2)  gemsC1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(86) = .true.   ! g em to em ub u ub u   sC1g0ZDIS(4,1,5,6,7,3,2)  gemsC1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(87) = .true.   ! db em to em db g d db   sC1g0ZDIS(4,5,6,7,1,3,2)  qbemsC1g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(88) = .true.   ! db em to em db g u ub   sC1g0ZDIS(4,5,6,7,1,3,2)  qbemsC1g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(89) = .true.   ! ub em to em ub g d db   sC1g0ZDIS(4,5,6,7,1,3,2)  qbemsC1g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(90) = .true.   ! ub em to em ub g u ub   sC1g0ZDIS(4,5,6,7,1,3,2)  qbemsC1g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(91) = .true.   ! d em to em g d db d   sCt1g0ZDIS(1,4,5,6,7,3,2)  qemsCt1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(92) = .true.   ! d em to em g u ub d   sCt1g0ZDIS(1,4,5,6,7,3,2)  qemsCt1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(93) = .true.   ! u em to em g d db u   sCt1g0ZDIS(1,4,5,6,7,3,2)  qemsCt1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(94) = .true.   ! u em to em g u ub u   sCt1g0ZDIS(1,4,5,6,7,3,2)  qemsCt1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(95) = .true.   ! g em to em db d db d   sCt1g0ZDIS(4,1,5,6,7,3,2)  gemsCt1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(96) = .true.   ! g em to em db u ub d   sCt1g0ZDIS(4,1,5,6,7,3,2)  gemsCt1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(97) = .true.   ! g em to em ub d db u   sCt1g0ZDIS(4,1,5,6,7,3,2)  gemsCt1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(98) = .true.   ! g em to em ub u ub u   sCt1g0ZDIS(4,1,5,6,7,3,2)  gemsCt1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(99) = .true.   ! db em to em db g d db   sCt1g0ZDIS(4,5,6,7,1,3,2)  qbemsCt1g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(100)= .true.   ! db em to em db g u ub   sCt1g0ZDIS(4,5,6,7,1,3,2)  qbemsCt1g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(101)= .true.   ! ub em to em ub g d db   sCt1g0ZDIS(4,5,6,7,1,3,2)  qbemsCt1g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(102)= .true.   ! ub em to em ub g u ub   sCt1g0ZDIS(4,5,6,7,1,3,2)  qbemsCt1g0ZDISS(4,5,6,7,1,3,2)
c      qactive_chan(103)= .true.   ! d em to em g d db d   D1g0ZcDIS(1,4,5,6,7,3,2)  qemD1g0ZcDISS(1,4,5,6,7,3,2)
c      qactive_chan(104)= .true.   ! u em to em g u ub u   D1g0ZcDIS(1,4,5,6,7,3,2)  qemD1g0ZcDISS(1,4,5,6,7,3,2)
c      qactive_chan(105)= .true.   ! g em to em db d db d   D1g0ZcDIS(4,1,5,6,7,3,2)  gemD1g0ZcDISS(4,1,5,6,7,3,2)
c      qactive_chan(106)= .true.   ! g em to em ub u ub u   D1g0ZcDIS(4,1,5,6,7,3,2)  gemD1g0ZcDISS(4,1,5,6,7,3,2)
c      qactive_chan(107)= .true.   ! db em to em db g db d   D1g0ZcDIS(4,5,1,6,7,3,2)  qbemD1g0ZcDISS(4,5,1,6,7,3,2)
c      qactive_chan(108)= .true.   ! ub em to em ub g ub u   D1g0ZcDIS(4,5,1,6,7,3,2)  qbemD1g0ZcDISS(4,5,1,6,7,3,2)
c      qactive_chan(109)= .true.   ! d em to em g d db d   Dt1g0ZDIS(1,4,5,6,7,3,2)  qemDt1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(110)= .true.   ! u em to em g u ub u   Dt1g0ZDIS(1,4,5,6,7,3,2)  qemDt1g0ZDISS(1,4,5,6,7,3,2)
c      qactive_chan(111)= .true.   ! g em to em db d db d   Dt1g0ZDIS(4,1,5,6,7,3,2)  gemDt1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(112)= .true.   ! g em to em ub u ub u   Dt1g0ZDIS(4,1,5,6,7,3,2)  gemDt1g0ZDISS(4,1,5,6,7,3,2)
c      qactive_chan(113)= .true.   ! db em to em db g db d   Dt1g0ZDIS(4,5,1,6,7,3,2)  qbemDt1g0ZDISS(4,5,1,6,7,3,2)
c      qactive_chan(114)= .true.   ! ub em to em ub g ub u   Dt1g0ZDIS(4,5,1,6,7,3,2)  qbemDt1g0ZDISS(4,5,1,6,7,3,2)

      do i=61,114
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(115)= .true.   ! d em to em g g d      sB2g1ZDIS(1,4,5,6,3,2)  qemsB2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(116)= .true.   ! u em to em g g u      sB2g1ZDIS(1,4,5,6,3,2)  qemsB2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(117)= .true.   ! g em to em db g d     sB2g1ZDIS(4,1,5,6,3,2)  gemsB2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(118)= .true.   ! g em to em ub g u     sB2g1ZDIS(4,1,5,6,3,2)  gemsB2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(119)= .true.   ! db em to em db g g    sB2g1ZDIS(4,5,6,1,3,2)  qbemsB2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(120)= .true.   ! ub em to em ub g g    sB2g1ZDIS(4,5,6,1,3,2)  qbemsB2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(121)= .true.   ! Q em subtraction                            qpemsB2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(122)= .true.   ! Q em subtraction                            qpemsB2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(123)= .true.   ! Qb em subtraction                           qpbemsB2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(124)= .true.   ! Qb em subtraction                           qpbemsB2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(125)= .true.   ! d em to em gt gt d    sBt2g1ZDIS(1,4,5,6,3,2)  qemsBt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(126)= .true.   ! u em to em gt gt u    sBt2g1ZDIS(1,4,5,6,3,2)  qemsBt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(127)= .true.   ! gt em to em db gt d   sBt2g1ZDIS(4,1,5,6,3,2)  gtemsBt2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(128)= .true.   ! gt em to em ub gt u   sBt2g1ZDIS(4,1,5,6,3,2)  gtemsBt2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(129)= .true.   ! db em to em db gt gt   sBt2g1ZDIS(4,5,6,1,3,2)  qbemsBt2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(130)= .true.   ! ub em to em ub gt gt   sBt2g1ZDIS(4,5,6,1,3,2)  qbemsBt2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(131)= .true.   ! Q em subtraction                            qpemsBt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(132)= .true.   ! Q em subtraction                            qpemsBt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(133)= .true.   ! Qb em subtraction                           qpbemsBt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(134)= .true.   ! Qb em subtraction                           qpbemsBt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(135)= .true.   ! d em to em gt gt d    sBttt2g1ZDIS(1,4,5,6,3,2)  qemsBttt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(136)= .true.   ! u em to em gt gt u    sBttt2g1ZDIS(1,4,5,6,3,2)  qemsBttt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(137)= .true.   ! gt em to em db gt d   sBttt2g1ZDIS(4,1,5,6,3,2)  gtemsBttt2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(138)= .true.   ! gt em to em ub gt u   sBttt2g1ZDIS(4,1,5,6,3,2)  gtemsBttt2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(139)= .true.   ! db em to em db gt gt   sBttt2g1ZDIS(4,5,6,1,3,2)  qbemsBttt2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(140)= .true.   ! ub em to em ub gt gt   sBttt2g1ZDIS(4,5,6,1,3,2)  qbemsBttt2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(141)= .true.   ! Q em subtraction                            qpemsBttt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(142)= .true.   ! Q em subtraction                            qpemsBttt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(143)= .true.   ! Qb em subtraction                           qpbemsBttt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(144)= .true.   ! Qb em subtraction                           qpbemsBttt2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(145)= .true.   ! d em to em g g d      sBh2g1ZDIS(1,4,5,6,3,2)  qemsBh2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(146)= .true.   ! u em to em g g u      sBh2g1ZDIS(1,4,5,6,3,2)  qemsBh2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(147)= .true.   ! g em to em db g d     sBh2g1ZDIS(4,1,5,6,3,2)  gemsBh2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(148)= .true.   ! g em to em ub g u     sBh2g1ZDIS(4,1,5,6,3,2)  gemsBh2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(149)= .true.   ! db em to em db g g    sBh2g1ZDIS(4,5,6,1,3,2)  qbemsBh2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(150)= .true.   ! ub em to em ub g g    sBh2g1ZDIS(4,5,6,1,3,2)  qbemsBh2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(151)= .true.   ! Q em subtraction                            qpemsBh2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(152)= .true.   ! Q em subtraction                            qpemsBh2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(153)= .true.   ! Qb em subtraction                           qpbemsBh2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(154)= .true.   ! Qb em subtraction                           qpbemsBh2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(155)= .true.   ! d em to em gt gt d    sBth2g1ZDIS(1,4,5,6,3,2)  qemsBth2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(156)= .true.   ! u em to em gt gt u    sBth2g1ZDIS(1,4,5,6,3,2)  qemsBth2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(157)= .true.   ! gt em to em db gt d   sBth2g1ZDIS(4,1,5,6,3,2)  gtemsBth2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(158)= .true.   ! gt em to em ub gt u   sBth2g1ZDIS(4,1,5,6,3,2)  gtemsBth2g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(159)= .true.   ! db em to em db gt gt   sBth2g1ZDIS(4,5,6,1,3,2)  qbemsBth2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(160)= .true.   ! ub em to em ub gt gt   sBth2g1ZDIS(4,5,6,1,3,2)  qbemsBth2g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(161)= .true.   ! Q em subtraction                            qpemsBth2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(162)= .true.   ! Q em subtraction                            qpemsBth2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(163)= .true.   ! Qb em subtraction                           qpbemsBth2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(164)= .true.   ! Qb em subtraction                           qpbemsBth2g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(165)= .true.   ! d em to em d db d     sC0g1ZDIS(1,4,5,6,3,2)  qemsC0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(166)= .true.   ! d em to em u ub d     sC0g1ZDIS(1,4,5,6,3,2)  qemsC0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(167)= .true.   ! u em to em d db u     sC0g1ZDIS(1,4,5,6,3,2)  qemsC0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(168)= .true.   ! u em to em u ub u     sC0g1ZDIS(1,4,5,6,3,2)  qemsC0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(169)= .true.   ! db em to em db d db   sC0g1ZDIS(4,5,6,1,3,2)  qbemsC0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(170)= .true.   ! db em to em db u ub   sC0g1ZDIS(4,5,6,1,3,2)  qbemsC0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(171)= .true.   ! ub em to em ub d db   sC0g1ZDIS(4,5,6,1,3,2)  qbemsC0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(172)= .true.   ! ub em to em ub u ub   sC0g1ZDIS(4,5,6,1,3,2)  qbemsC0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(173)= .true.   ! g em subtraction                            gemsC0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(174)= .true.   ! g em subtraction                            gemsC0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(175)= .true.   ! g em subtraction                            gemsC0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(176)= .true.   ! g em subtraction                            gemsC0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(177)= .true.   ! d em to em d db d     Ct0g1ZDIS(1,4,5,6,3,2)  qemCt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(178)= .true.   ! d em to em u ub d     Ct0g1ZDIS(1,4,5,6,3,2)  qemCt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(179)= .true.   ! u em to em d db u     Ct0g1ZDIS(1,4,5,6,3,2)  qemCt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(180)= .true.   ! u em to em u ub u     Ct0g1ZDIS(1,4,5,6,3,2)  qemCt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(181)= .true.   ! db em to em db d db   Ct0g1ZDIS(4,5,6,1,3,2)  qbemCt0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(182)= .true.   ! db em to em db u ub   Ct0g1ZDIS(4,5,6,1,3,2)  qbemCt0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(183)= .true.   ! ub em to em ub d db   Ct0g1ZDIS(4,5,6,1,3,2)  qbemCt0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(184)= .true.   ! ub em to em ub u ub   Ct0g1ZDIS(4,5,6,1,3,2)  qbemCt0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(185)= .true.   ! g em subtraction                            gemCt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(186)= .true.   ! g em subtraction                            gemCt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(187)= .true.   ! g em subtraction                            gemCt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(188)= .true.   ! g em subtraction                            gemCt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(189)= .true.   ! d em to em d db d     Ch0g1ZDIS(1,4,5,6,3,2)  qemCh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(190)= .true.   ! d em to em u ub d     Ch0g1ZDIS(1,4,5,6,3,2)  qemCh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(191)= .true.   ! u em to em d db u     Ch0g1ZDIS(1,4,5,6,3,2)  qemCh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(192)= .true.   ! u em to em u ub u     Ch0g1ZDIS(1,4,5,6,3,2)  qemCh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(193)= .true.   ! db em to em db d db   Ch0g1ZDIS(4,5,6,1,3,2)  qbemCh0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(194)= .true.   ! db em to em db u ub   Ch0g1ZDIS(4,5,6,1,3,2)  qbemCh0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(195)= .true.   ! ub em to em ub d db   Ch0g1ZDIS(4,5,6,1,3,2)  qbemCh0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(196)= .true.   ! ub em to em ub u ub   Ch0g1ZDIS(4,5,6,1,3,2)  qbemCh0g1ZDIST(4,5,6,1,3,2)
c      qactive_chan(197)= .true.   ! g em subtraction                            gemCh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(198)= .true.   ! g em subtraction                            gemCh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(199)= .true.   ! g em subtraction                            gemCh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(200)= .true.   ! g em subtraction                            gemCh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(201)= .true.   ! d em to em d db d     D0g1ZDIS(1,4,5,6,3,2)  qemD0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(202)= .true.   ! u em to em u ub u     D0g1ZDIS(1,4,5,6,3,2)  qemD0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(203)= .true.   ! db em to em db db d   D0g1ZDIS(4,1,5,6,3,2)  qbemD0g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(204)= .true.   ! ub em to em ub ub u   D0g1ZDIS(4,1,5,6,3,2)  qbemD0g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(205)= .true.   ! g em subtraction                            gemD0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(206)= .true.   ! g em subtraction                            gemD0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(207)= .true.   ! d em to em d db d     Dt0g1ZDIS(1,4,5,6,3,2)  qemDt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(208)= .true.   ! u em to em u ub u     Dt0g1ZDIS(1,4,5,6,3,2)  qemDt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(209)= .true.   ! db em to em db db d   Dt0g1ZDIS(4,1,5,6,3,2)  qbemDt0g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(210)= .true.   ! ub em to em ub ub u   Dt0g1ZDIS(4,1,5,6,3,2)  qbemDt0g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(211)= .true.   ! g em subtraction                            gemDt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(212)= .true.   ! g em subtraction                            gemDt0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(213)= .true.   ! d em to em d db d     Dh0g1ZDIS(1,4,5,6,3,2)  qemDh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(214)= .true.   ! u em to em u ub u     Dh0g1ZDIS(1,4,5,6,3,2)  qemDh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(215)= .true.   ! db em to em db db d   Dh0g1ZDIS(4,1,5,6,3,2)  qbemDh0g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(216)= .true.   ! ub em to em ub ub u   Dh0g1ZDIS(4,1,5,6,3,2)  qbemDh0g1ZDIST(4,1,5,6,3,2)
c      qactive_chan(217)= .true.   ! g em subtraction                            gemDh0g1ZDIST(1,4,5,6,3,2)
c      qactive_chan(218)= .true.   ! g em subtraction                            gemDh0g1ZDIST(1,4,5,6,3,2)

      do i=115,218
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(219)= .true.   ! d em to em g d        B1g2ZDIS(1,4,5,3,2)   qemB1g2ZDISU(1,4,5,3,2)
c      qactive_chan(220)= .true.   ! u em to em g u        B1g2ZDIS(1,4,5,3,2)   qemB1g2ZDISU(1,4,5,3,2)
c      qactive_chan(221)= .true.   ! g em to em db d       B1g2ZDIS(4,1,5,3,2)   gemB1g2ZDISU(4,1,5,3,2)
c      qactive_chan(222)= .true.   ! g em to em ub u       B1g2ZDIS(4,1,5,3,2)   gemB1g2ZDISU(4,1,5,3,2)
c      qactive_chan(223)= .true.   ! db em to em db g      B1g2ZDIS(4,5,1,3,2)   qbemB1g2ZDISU(4,5,1,3,2)
c      qactive_chan(224)= .true.   ! ub em to em ub g      B1g2ZDIS(4,5,1,3,2)   qbemB1g2ZDISU(4,5,1,3,2)
c      qactive_chan(225)= .true.   ! Q em subtraction                            qpemB1g2ZDISU(1,4,5,3,2)
c      qactive_chan(226)= .true.   ! Q em subtraction                            qpemB1g2ZDISU(1,4,5,3,2)
c      qactive_chan(227)= .true.   ! Qb em subtraction                           qpbemB1g2ZDISU(1,4,5,3,2)
c      qactive_chan(228)= .true.   ! Qb em subtraction                           qpbemB1g2ZDISU(1,4,5,3,2)
c      qactive_chan(229)= .true.   ! d em to em g d        Bt1g2ZDIS(1,4,5,3,2)  qemBt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(230)= .true.   ! u em to em g u        Bt1g2ZDIS(1,4,5,3,2)  qemBt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(231)= .true.   ! g em to em db d       Bt1g2ZDIS(4,1,5,3,2)  gemBt1g2ZDISU(4,1,5,3,2)
c      qactive_chan(232)= .true.   ! g em to em ub u       Bt1g2ZDIS(4,1,5,3,2)  gemBt1g2ZDISU(4,1,5,3,2)
c      qactive_chan(233)= .true.   ! db em to em db g      Bt1g2ZDIS(4,5,1,3,2)  qbemBt1g2ZDISU(4,5,1,3,2)
c      qactive_chan(234)= .true.   ! ub em to em ub g      Bt1g2ZDIS(4,5,1,3,2)  qbemBt1g2ZDISU(4,5,1,3,2)
c      qactive_chan(235)= .true.   ! Q em subtraction                            qpemBt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(236)= .true.   ! Q em subtraction                            qpemBt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(237)= .true.   ! Qb em subtraction                           qpbemBt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(238)= .true.   ! Qb em subtraction                           qpbemBt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(239)= .true.   ! d em to em g d        Btt1g2ZDIS(1,4,5,3,2)  qemBtt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(240)= .true.   ! u em to em g u        Btt1g2ZDIS(1,4,5,3,2)  qemBtt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(241)= .true.   ! g em to em db d       Btt1g2ZDIS(4,1,5,3,2)  gemBtt1g2ZDISU(4,1,5,3,2)
c      qactive_chan(242)= .true.   ! g em to em ub u       Btt1g2ZDIS(4,1,5,3,2)  gemBtt1g2ZDISU(4,1,5,3,2)
c      qactive_chan(243)= .true.   ! db em to em db g      Btt1g2ZDIS(4,5,1,3,2)  qbemBtt1g2ZDISU(4,5,1,3,2)
c      qactive_chan(244)= .true.   ! ub em to em ub g      Btt1g2ZDIS(4,5,1,3,2)  qbemBtt1g2ZDISU(4,5,1,3,2)
c      qactive_chan(245)= .true.   ! Q em subtraction                            qpemBtt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(246)= .true.   ! Q em subtraction                            qpemBtt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(247)= .true.   ! Qb em subtraction                           qpbemBtt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(248)= .true.   ! Qb em subtraction                           qpbemBtt1g2ZDISU(1,4,5,3,2)
c      qactive_chan(249)= .true.   ! d em to em g d        Bh1g2ZDIS(1,4,5,3,2)  qemBh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(250)= .true.   ! u em to em g u        Bh1g2ZDIS(1,4,5,3,2)  qemBh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(251)= .true.   ! g em to em db d       Bh1g2ZDIS(4,1,5,3,2)  gemBh1g2ZDISU(4,1,5,3,2)
c      qactive_chan(252)= .true.   ! g em to em ub u       Bh1g2ZDIS(4,1,5,3,2)  gemBh1g2ZDISU(4,1,5,3,2)
c      qactive_chan(253)= .true.   ! db em to em db g      Bh1g2ZDIS(4,5,1,3,2)  qbemBh1g2ZDISU(4,5,1,3,2)
c      qactive_chan(254)= .true.   ! ub em to em ub g      Bh1g2ZDIS(4,5,1,3,2)  qbemBh1g2ZDISU(4,5,1,3,2)
c      qactive_chan(255)= .true.   ! Q em subtraction                            qpemBh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(256)= .true.   ! Q em subtraction                            qpemBh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(257)= .true.   ! Qb em subtraction                           qpbemBh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(258)= .true.   ! Qb em subtraction                           qpbemBh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(259)= .true.   ! d em to em g d        Bht1g2ZDIS(1,4,5,3,2)  qemBht1g2ZDISU(1,4,5,3,2)
c      qactive_chan(260)= .true.   ! u em to em g u        Bht1g2ZDIS(1,4,5,3,2)  qemBht1g2ZDISU(1,4,5,3,2)
c      qactive_chan(261)= .true.   ! g em to em db d       Bht1g2ZDIS(4,1,5,3,2)  gemBht1g2ZDISU(4,1,5,3,2)
c      qactive_chan(262)= .true.   ! g em to em ub u       Bht1g2ZDIS(4,1,5,3,2)  gemBht1g2ZDISU(4,1,5,3,2)
c      qactive_chan(263)= .true.   ! db em to em db g      Bht1g2ZDIS(4,5,1,3,2)  qbemBht1g2ZDISU(4,5,1,3,2)
c      qactive_chan(264)= .true.   ! ub em to em ub g      Bht1g2ZDIS(4,5,1,3,2)  qbemBht1g2ZDISU(4,5,1,3,2)
c      qactive_chan(265)= .true.   ! Q em subtraction                            qpemBht1g2ZDISU(1,4,5,3,2)
c      qactive_chan(266)= .true.   ! Q em subtraction                            qpemBht1g2ZDISU(1,4,5,3,2)
c      qactive_chan(267)= .true.   ! Qb em subtraction                           qpbemBht1g2ZDISU(1,4,5,3,2)
c      qactive_chan(268)= .true.   ! Qb em subtraction                           qpbemBht1g2ZDISU(1,4,5,3,2)
c      qactive_chan(269)= .true.   ! d em to em g d        Bhh1g2ZDIS(1,4,5,3,2)  qemBhh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(270)= .true.   ! u em to em g u        Bhh1g2ZDIS(1,4,5,3,2)  qemBhh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(271)= .true.   ! g em to em db d       Bhh1g2ZDIS(4,1,5,3,2)  gemBhh1g2ZDISU(4,1,5,3,2)
c      qactive_chan(272)= .true.   ! g em to em ub u       Bhh1g2ZDIS(4,1,5,3,2)  gemBhh1g2ZDISU(4,1,5,3,2)
c      qactive_chan(273)= .true.   ! db em to em db g      Bhh1g2ZDIS(4,5,1,3,2)  qbemBhh1g2ZDISU(4,5,1,3,2)
c      qactive_chan(274)= .true.   ! ub em to em ub g      Bhh1g2ZDIS(4,5,1,3,2)  qbemBhh1g2ZDISU(4,5,1,3,2)
c      qactive_chan(275)= .true.   ! Q em subtraction                            qpemBhh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(276)= .true.   ! Q em subtraction                            qpemBhh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(277)= .true.   ! Qb em subtraction                           qpbemBhh1g2ZDISU(1,4,5,3,2)
c      qactive_chan(278)= .true.   ! Qb em subtraction                           qpbemBhh1g2ZDISU(1,4,5,3,2)

      do i=219,278
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelDIS(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'd em to em g d      '
        me_str   = 'B1g0Z(1,4,5,3,2)    '
        sub_str  = ''

      case (2)
        chan_str = 'u em to em g u      '
        me_str   = 'B1g0Z(1,4,5,3,2)    '
        sub_str  = ''

      case (3)
        chan_str = 'g em to em db d     '
        me_str   = 'B1g0Z(4,1,5,3,2)    '
        sub_str  = ''

      case (4)
        chan_str = 'g em to em ub u     '
        me_str   = 'B1g0Z(4,1,5,3,2)    '
        sub_str  = ''

      case (5)
        chan_str = 'db em to em db g    '
        me_str   = 'B1g0Z(4,5,1,3,2)    '
        sub_str  = ''

      case (6)
        chan_str = 'ub em to em ub g    '
        me_str   = 'B1g0Z(4,5,1,3,2)    '
        sub_str  = ''

      case (7)
        chan_str = 'd em to em g g d    '
        me_str   = 'B2g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemB2g0ZDISSNLO(1,4,5,6,3,2)'

      case (8)
        chan_str = 'u em to em g g u    '
        me_str   = 'B2g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemB2g0ZDISSNLO(1,4,5,6,3,2)'

      case (9)
        chan_str = 'g em to em db g d   '
        me_str   = 'B2g0ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gemB2g0ZDISSNLO(4,1,5,6,3,2)'

      case (10)
        chan_str = 'g em to em ub g u   '
        me_str   = 'B2g0ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gemB2g0ZDISSNLO(4,1,5,6,3,2)'

      case (11)
        chan_str = 'db em to em db g g  '
        me_str   = 'B2g0ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemB2g0ZDISSNLO(4,5,6,1,3,2)'

      case (12)
        chan_str = 'ub em to em ub g g  '
        me_str   = 'B2g0ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemB2g0ZDISSNLO(4,5,6,1,3,2)'

      case (13)
        chan_str = 'd em to em gt gt d  '
        me_str   = 'Bt2g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemBt2g0ZDISSNLO(1,4,5,6,3,2)'

      case (14)
        chan_str = 'u em to em gt gt u  '
        me_str   = 'Bt2g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemBt2g0ZDISSNLO(1,4,5,6,3,2)'

      case (15)
        chan_str = 'gt em to em db gt d '
        me_str   = 'Bt2g0ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemBt2g0ZDISSNLO(4,1,5,6,3,2)'

      case (16)
        chan_str = 'gt em to em ub gt u '
        me_str   = 'Bt2g0ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemBt2g0ZDISSNLO(4,1,5,6,3,2)'

      case (17)
        chan_str = 'db em to em db gt gt '
        me_str   = 'Bt2g0ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemBt2g0ZDISSNLO(4,5,6,1,3,2)'

      case (18)
        chan_str = 'ub em to em ub gt gt '
        me_str   = 'Bt2g0ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemBt2g0ZDISSNLO(4,5,6,1,3,2)'

      case (19)
        chan_str = 'd em to em d db d   '
        me_str   = 'C0g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemC0g0ZDISSNLO(1,4,5,6,3,2)'

      case (20)
        chan_str = 'd em to em u ub d   '
        me_str   = 'C0g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemC0g0ZDISSNLO(1,4,5,6,3,2)'

      case (21)
        chan_str = 'u em to em d db u   '
        me_str   = 'C0g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemC0g0ZDISSNLO(1,4,5,6,3,2)'

      case (22)
        chan_str = 'u em to em u ub u   '
        me_str   = 'C0g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemC0g0ZDISSNLO(1,4,5,6,3,2)'

      case (23)
        chan_str = 'db em to em db d db '
        me_str   = 'C0g0ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemC0g0ZDISSNLO(4,5,6,1,3,2)'

      case (24)
        chan_str = 'db em to em db u ub '
        me_str   = 'C0g0ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemC0g0ZDISSNLO(4,5,6,1,3,2)'

      case (25)
        chan_str = 'ub em to em ub d db '
        me_str   = 'C0g0ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemC0g0ZDISSNLO(4,5,6,1,3,2)'

      case (26)
        chan_str = 'ub em to em ub u ub '
        me_str   = 'C0g0ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemC0g0ZDISSNLO(4,5,6,1,3,2)'

      case (27)
        chan_str = 'd em to em d db d   '
        me_str   = 'D0g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemD0g0ZDISSNLO(1,4,5,6,3,2)'

      case (28)
        chan_str = 'u em to em u ub u   '
        me_str   = 'D0g0ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemD0g0ZDISSNLO(1,4,5,6,3,2)'

      case (29)
        chan_str = 'db em to em db db d '
        me_str   = 'D0g0ZDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemD0g0ZDISSNLO(4,1,5,6,3,2)'

      case (30)
        chan_str = 'ub em to em ub ub u '
        me_str   = 'D0g0ZDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemD0g0ZDISSNLO(4,1,5,6,3,2)'

      case (31)
        chan_str = 'd em to em g d      '
        me_str   = 'B1g1ZDIS(1,4,5,3,2) '
        sub_str  = 'qemB1g1ZDISTNLO(1,4,5,3,2)'

      case (32)
        chan_str = 'u em to em g u      '
        me_str   = 'B1g1ZDIS(1,4,5,3,2) '
        sub_str  = 'qemB1g1ZDISTNLO(1,4,5,3,2)'

      case (33)
        chan_str = 'g em to em db d     '
        me_str   = 'B1g1ZDIS(4,1,5,3,2) '
        sub_str  = 'gemB1g1ZDISTNLO(4,1,5,3,2)'

      case (34)
        chan_str = 'g em to em ub u     '
        me_str   = 'B1g1ZDIS(4,1,5,3,2) '
        sub_str  = 'gemB1g1ZDISTNLO(4,1,5,3,2)'

      case (35)
        chan_str = 'db em to em db g    '
        me_str   = 'B1g1ZDIS(4,5,1,3,2) '
        sub_str  = 'qbemB1g1ZDISTNLO(4,5,1,3,2)'

      case (36)
        chan_str = 'ub em to em ub g    '
        me_str   = 'B1g1ZDIS(4,5,1,3,2) '
        sub_str  = 'qbemB1g1ZDISTNLO(4,5,1,3,2)'

      case (37)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB1g1ZDISTNLO(1,4,5,3,2)'

      case (38)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB1g1ZDISTNLO(1,4,5,3,2)'

      case (39)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB1g1ZDISTNLO(1,4,5,3,2)'

      case (40)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB1g1ZDISTNLO(1,4,5,3,2)'

      case (41)
        chan_str = 'd em to em g d      '
        me_str   = 'Bt1g1ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBt1g1ZDISTNLO(1,4,5,3,2)'

      case (42)
        chan_str = 'u em to em g u      '
        me_str   = 'Bt1g1ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBt1g1ZDISTNLO(1,4,5,3,2)'

      case (43)
        chan_str = 'g em to em db d     '
        me_str   = 'Bt1g1ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBt1g1ZDISTNLO(4,1,5,3,2)'

      case (44)
        chan_str = 'g em to em ub u     '
        me_str   = 'Bt1g1ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBt1g1ZDISTNLO(4,1,5,3,2)'

      case (45)
        chan_str = 'db em to em db g    '
        me_str   = 'Bt1g1ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBt1g1ZDISTNLO(4,5,1,3,2)'

      case (46)
        chan_str = 'ub em to em ub g    '
        me_str   = 'Bt1g1ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBt1g1ZDISTNLO(4,5,1,3,2)'

      case (47)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBt1g1ZDISTNLO(1,4,5,3,2)'

      case (48)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBt1g1ZDISTNLO(1,4,5,3,2)'

      case (49)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBt1g1ZDISTNLO(1,4,5,3,2)'

      case (50)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBt1g1ZDISTNLO(1,4,5,3,2)'

      case (51)
        chan_str = 'd em to em g d      '
        me_str   = 'Bh1g1ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBh1g1ZDISTNLO(1,4,5,3,2)'

      case (52)
        chan_str = 'u em to em g u      '
        me_str   = 'Bh1g1ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBh1g1ZDISTNLO(1,4,5,3,2)'

      case (53)
        chan_str = 'g em to em db d     '
        me_str   = 'Bh1g1ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBh1g1ZDISTNLO(4,1,5,3,2)'

      case (54)
        chan_str = 'g em to em ub u     '
        me_str   = 'Bh1g1ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBh1g1ZDISTNLO(4,1,5,3,2)'

      case (55)
        chan_str = 'db em to em db g    '
        me_str   = 'Bh1g1ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBh1g1ZDISTNLO(4,5,1,3,2)'

      case (56)
        chan_str = 'ub em to em ub g    '
        me_str   = 'Bh1g1ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBh1g1ZDISTNLO(4,5,1,3,2)'

      case (57)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBh1g1ZDISTNLO(1,4,5,3,2)'

      case (58)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBh1g1ZDISTNLO(1,4,5,3,2)'

      case (59)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBh1g1ZDISTNLO(1,4,5,3,2)'

      case (60)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBh1g1ZDISTNLO(1,4,5,3,2)'

      case (61)
        chan_str = 'd em to em g g g d  '
        me_str   = 'sB3g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsB3g0ZDISS(1,4,5,6,7,3,2)'

      case (62)
        chan_str = 'u em to em g g g u  '
        me_str   = 'sB3g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsB3g0ZDISS(1,4,5,6,7,3,2)'

      case (63)
        chan_str = 'g em to em db g g d '
        me_str   = 'sB3g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsB3g0ZDISS(4,1,5,6,7,3,2)'

      case (64)
        chan_str = 'g em to em ub g g u '
        me_str   = 'sB3g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsB3g0ZDISS(4,1,5,6,7,3,2)'

      case (65)
        chan_str = 'db em to em db g g g '
        me_str   = 'sB3g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsB3g0ZDISS(4,5,6,7,1,3,2)'

      case (66)
        chan_str = 'ub em to em ub g g g '
        me_str   = 'sB3g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsB3g0ZDISS(4,5,6,7,1,3,2)'

      case (67)
        chan_str = 'd em to em g g g d  '
        me_str   = 'sBt3g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsBt3g0ZDISS(1,4,5,6,7,3,2)'

      case (68)
        chan_str = 'u em to em g g g u  '
        me_str   = 'sBt3g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsBt3g0ZDISS(1,4,5,6,7,3,2)'

      case (69)
        chan_str = 'g em to em db g g d '
        me_str   = 'sBt3g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsBt3g0ZDISS(4,1,5,6,7,3,2)'

      case (70)
        chan_str = 'g em to em ub g g u '
        me_str   = 'sBt3g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsBt3g0ZDISS(4,1,5,6,7,3,2)'

      case (71)
        chan_str = 'db em to em db g g g '
        me_str   = 'sBt3g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsBt3g0ZDISS(4,5,6,7,1,3,2)'

      case (72)
        chan_str = 'ub em to em ub g g g '
        me_str   = 'sBt3g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsBt3g0ZDISS(4,5,6,7,1,3,2)'

      case (73)
        chan_str = 'd em to em gt gt gt d '
        me_str   = 'sBtt3g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsBtt3g0ZDISS(1,4,5,6,7,3,2)'

      case (74)
        chan_str = 'u em to em gt gt gt u '
        me_str   = 'sBtt3g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsBtt3g0ZDISS(1,4,5,6,7,3,2)'

      case (75)
        chan_str = 'gt em to em db gt gt d '
        me_str   = 'sBtt3g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gtemsBtt3g0ZDISS(4,1,5,6,7,3,2)'

      case (76)
        chan_str = 'gt em to em ub gt gt u '
        me_str   = 'sBtt3g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gtemsBtt3g0ZDISS(4,1,5,6,7,3,2)'

      case (77)
        chan_str = 'db em to em db gt gt gt '
        me_str   = 'sBtt3g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsBtt3g0ZDISS(4,5,6,7,1,3,2)'

      case (78)
        chan_str = 'ub em to em ub gt gt gt '
        me_str   = 'sBtt3g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsBtt3g0ZDISS(4,5,6,7,1,3,2)'

      case (79)
        chan_str = 'd em to em g d db d '
        me_str   = 'sC1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsC1g0ZDISS(1,4,5,6,7,3,2)'

      case (80)
        chan_str = 'd em to em g u ub d '
        me_str   = 'sC1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsC1g0ZDISS(1,4,5,6,7,3,2)'

      case (81)
        chan_str = 'u em to em g d db u '
        me_str   = 'sC1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsC1g0ZDISS(1,4,5,6,7,3,2)'

      case (82)
        chan_str = 'u em to em g u ub u '
        me_str   = 'sC1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsC1g0ZDISS(1,4,5,6,7,3,2)'

      case (83)
        chan_str = 'g em to em db d db d '
        me_str   = 'sC1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsC1g0ZDISS(4,1,5,6,7,3,2)'

      case (84)
        chan_str = 'g em to em db u ub d '
        me_str   = 'sC1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsC1g0ZDISS(4,1,5,6,7,3,2)'

      case (85)
        chan_str = 'g em to em ub d db u '
        me_str   = 'sC1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsC1g0ZDISS(4,1,5,6,7,3,2)'

      case (86)
        chan_str = 'g em to em ub u ub u '
        me_str   = 'sC1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsC1g0ZDISS(4,1,5,6,7,3,2)'

      case (87)
        chan_str = 'db em to em db g d db '
        me_str   = 'sC1g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsC1g0ZDISS(4,5,6,7,1,3,2)'

      case (88)
        chan_str = 'db em to em db g u ub '
        me_str   = 'sC1g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsC1g0ZDISS(4,5,6,7,1,3,2)'

      case (89)
        chan_str = 'ub em to em ub g d db '
        me_str   = 'sC1g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsC1g0ZDISS(4,5,6,7,1,3,2)'

      case (90)
        chan_str = 'ub em to em ub g u ub '
        me_str   = 'sC1g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsC1g0ZDISS(4,5,6,7,1,3,2)'

      case (91)
        chan_str = 'd em to em g d db d '
        me_str   = 'sCt1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsCt1g0ZDISS(1,4,5,6,7,3,2)'

      case (92)
        chan_str = 'd em to em g u ub d '
        me_str   = 'sCt1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsCt1g0ZDISS(1,4,5,6,7,3,2)'

      case (93)
        chan_str = 'u em to em g d db u '
        me_str   = 'sCt1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsCt1g0ZDISS(1,4,5,6,7,3,2)'

      case (94)
        chan_str = 'u em to em g u ub u '
        me_str   = 'sCt1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsCt1g0ZDISS(1,4,5,6,7,3,2)'

      case (95)
        chan_str = 'g em to em db d db d '
        me_str   = 'sCt1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsCt1g0ZDISS(4,1,5,6,7,3,2)'

      case (96)
        chan_str = 'g em to em db u ub d '
        me_str   = 'sCt1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsCt1g0ZDISS(4,1,5,6,7,3,2)'

      case (97)
        chan_str = 'g em to em ub d db u '
        me_str   = 'sCt1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsCt1g0ZDISS(4,1,5,6,7,3,2)'

      case (98)
        chan_str = 'g em to em ub u ub u '
        me_str   = 'sCt1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsCt1g0ZDISS(4,1,5,6,7,3,2)'

      case (99)
        chan_str = 'db em to em db g d db '
        me_str   = 'sCt1g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsCt1g0ZDISS(4,5,6,7,1,3,2)'

      case (100)
        chan_str = 'db em to em db g u ub '
        me_str   = 'sCt1g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsCt1g0ZDISS(4,5,6,7,1,3,2)'

      case (101)
        chan_str = 'ub em to em ub g d db '
        me_str   = 'sCt1g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsCt1g0ZDISS(4,5,6,7,1,3,2)'

      case (102)
        chan_str = 'ub em to em ub g u ub '
        me_str   = 'sCt1g0ZDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsCt1g0ZDISS(4,5,6,7,1,3,2)'

      case (103)
        chan_str = 'd em to em g d db d '
        me_str   = 'D1g0ZcDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemD1g0ZcDISS(1,4,5,6,7,3,2)'

      case (104)
        chan_str = 'u em to em g u ub u '
        me_str   = 'D1g0ZcDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemD1g0ZcDISS(1,4,5,6,7,3,2)'

      case (105)
        chan_str = 'g em to em db d db d '
        me_str   = 'D1g0ZcDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemD1g0ZcDISS(4,1,5,6,7,3,2)'

      case (106)
        chan_str = 'g em to em ub u ub u '
        me_str   = 'D1g0ZcDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemD1g0ZcDISS(4,1,5,6,7,3,2)'

      case (107)
        chan_str = 'db em to em db g db d '
        me_str   = 'D1g0ZcDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qbemD1g0ZcDISS(4,5,1,6,7,3,2)'

      case (108)
        chan_str = 'ub em to em ub g ub u '
        me_str   = 'D1g0ZcDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qbemD1g0ZcDISS(4,5,1,6,7,3,2)'

      case (109)
        chan_str = 'd em to em g d db d '
        me_str   = 'Dt1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemDt1g0ZDISS(1,4,5,6,7,3,2)'

      case (110)
        chan_str = 'u em to em g u ub u '
        me_str   = 'Dt1g0ZDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemDt1g0ZDISS(1,4,5,6,7,3,2)'

      case (111)
        chan_str = 'g em to em db d db d '
        me_str   = 'Dt1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemDt1g0ZDISS(4,1,5,6,7,3,2)'

      case (112)
        chan_str = 'g em to em ub u ub u '
        me_str   = 'Dt1g0ZDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemDt1g0ZDISS(4,1,5,6,7,3,2)'

      case (113)
        chan_str = 'db em to em db g db d '
        me_str   = 'Dt1g0ZDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qbemDt1g0ZDISS(4,5,1,6,7,3,2)'

      case (114)
        chan_str = 'ub em to em ub g ub u '
        me_str   = 'Dt1g0ZDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qbemDt1g0ZDISS(4,5,1,6,7,3,2)'

      case (115)
        chan_str = 'd em to em g g d    '
        me_str   = 'sB2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsB2g1ZDIST(1,4,5,6,3,2)'

      case (116)
        chan_str = 'u em to em g g u    '
        me_str   = 'sB2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsB2g1ZDIST(1,4,5,6,3,2)'

      case (117)
        chan_str = 'g em to em db g d   '
        me_str   = 'sB2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gemsB2g1ZDIST(4,1,5,6,3,2)'

      case (118)
        chan_str = 'g em to em ub g u   '
        me_str   = 'sB2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gemsB2g1ZDIST(4,1,5,6,3,2)'

      case (119)
        chan_str = 'db em to em db g g  '
        me_str   = 'sB2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsB2g1ZDIST(4,5,6,1,3,2)'

      case (120)
        chan_str = 'ub em to em ub g g  '
        me_str   = 'sB2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsB2g1ZDIST(4,5,6,1,3,2)'

      case (121)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsB2g1ZDIST(1,4,5,6,3,2)'

      case (122)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsB2g1ZDIST(1,4,5,6,3,2)'

      case (123)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsB2g1ZDIST(1,4,5,6,3,2)'

      case (124)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsB2g1ZDIST(1,4,5,6,3,2)'

      case (125)
        chan_str = 'd em to em gt gt d  '
        me_str   = 'sBt2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBt2g1ZDIST(1,4,5,6,3,2)'

      case (126)
        chan_str = 'u em to em gt gt u  '
        me_str   = 'sBt2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBt2g1ZDIST(1,4,5,6,3,2)'

      case (127)
        chan_str = 'gt em to em db gt d '
        me_str   = 'sBt2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemsBt2g1ZDIST(4,1,5,6,3,2)'

      case (128)
        chan_str = 'gt em to em ub gt u '
        me_str   = 'sBt2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemsBt2g1ZDIST(4,1,5,6,3,2)'

      case (129)
        chan_str = 'db em to em db gt gt '
        me_str   = 'sBt2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBt2g1ZDIST(4,5,6,1,3,2)'

      case (130)
        chan_str = 'ub em to em ub gt gt '
        me_str   = 'sBt2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBt2g1ZDIST(4,5,6,1,3,2)'

      case (131)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBt2g1ZDIST(1,4,5,6,3,2)'

      case (132)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBt2g1ZDIST(1,4,5,6,3,2)'

      case (133)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBt2g1ZDIST(1,4,5,6,3,2)'

      case (134)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBt2g1ZDIST(1,4,5,6,3,2)'

      case (135)
        chan_str = 'd em to em gt gt d  '
        me_str   = 'sBttt2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBttt2g1ZDIST(1,4,5,6,3,2)'

      case (136)
        chan_str = 'u em to em gt gt u  '
        me_str   = 'sBttt2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBttt2g1ZDIST(1,4,5,6,3,2)'

      case (137)
        chan_str = 'gt em to em db gt d '
        me_str   = 'sBttt2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemsBttt2g1ZDIST(4,1,5,6,3,2)'

      case (138)
        chan_str = 'gt em to em ub gt u '
        me_str   = 'sBttt2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemsBttt2g1ZDIST(4,1,5,6,3,2)'

      case (139)
        chan_str = 'db em to em db gt gt '
        me_str   = 'sBttt2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBttt2g1ZDIST(4,5,6,1,3,2)'

      case (140)
        chan_str = 'ub em to em ub gt gt '
        me_str   = 'sBttt2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBttt2g1ZDIST(4,5,6,1,3,2)'

      case (141)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBttt2g1ZDIST(1,4,5,6,3,2)'

      case (142)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBttt2g1ZDIST(1,4,5,6,3,2)'

      case (143)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBttt2g1ZDIST(1,4,5,6,3,2)'

      case (144)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBttt2g1ZDIST(1,4,5,6,3,2)'

      case (145)
        chan_str = 'd em to em g g d    '
        me_str   = 'sBh2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBh2g1ZDIST(1,4,5,6,3,2)'

      case (146)
        chan_str = 'u em to em g g u    '
        me_str   = 'sBh2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBh2g1ZDIST(1,4,5,6,3,2)'

      case (147)
        chan_str = 'g em to em db g d   '
        me_str   = 'sBh2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gemsBh2g1ZDIST(4,1,5,6,3,2)'

      case (148)
        chan_str = 'g em to em ub g u   '
        me_str   = 'sBh2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gemsBh2g1ZDIST(4,1,5,6,3,2)'

      case (149)
        chan_str = 'db em to em db g g  '
        me_str   = 'sBh2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBh2g1ZDIST(4,5,6,1,3,2)'

      case (150)
        chan_str = 'ub em to em ub g g  '
        me_str   = 'sBh2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBh2g1ZDIST(4,5,6,1,3,2)'

      case (151)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBh2g1ZDIST(1,4,5,6,3,2)'

      case (152)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBh2g1ZDIST(1,4,5,6,3,2)'

      case (153)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBh2g1ZDIST(1,4,5,6,3,2)'

      case (154)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBh2g1ZDIST(1,4,5,6,3,2)'

      case (155)
        chan_str = 'd em to em gt gt d  '
        me_str   = 'sBth2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBth2g1ZDIST(1,4,5,6,3,2)'

      case (156)
        chan_str = 'u em to em gt gt u  '
        me_str   = 'sBth2g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBth2g1ZDIST(1,4,5,6,3,2)'

      case (157)
        chan_str = 'gt em to em db gt d '
        me_str   = 'sBth2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemsBth2g1ZDIST(4,1,5,6,3,2)'

      case (158)
        chan_str = 'gt em to em ub gt u '
        me_str   = 'sBth2g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemsBth2g1ZDIST(4,1,5,6,3,2)'

      case (159)
        chan_str = 'db em to em db gt gt '
        me_str   = 'sBth2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBth2g1ZDIST(4,5,6,1,3,2)'

      case (160)
        chan_str = 'ub em to em ub gt gt '
        me_str   = 'sBth2g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBth2g1ZDIST(4,5,6,1,3,2)'

      case (161)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBth2g1ZDIST(1,4,5,6,3,2)'

      case (162)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBth2g1ZDIST(1,4,5,6,3,2)'

      case (163)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBth2g1ZDIST(1,4,5,6,3,2)'

      case (164)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBth2g1ZDIST(1,4,5,6,3,2)'

      case (165)
        chan_str = 'd em to em d db d   '
        me_str   = 'sC0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g1ZDIST(1,4,5,6,3,2)'

      case (166)
        chan_str = 'd em to em u ub d   '
        me_str   = 'sC0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g1ZDIST(1,4,5,6,3,2)'

      case (167)
        chan_str = 'u em to em d db u   '
        me_str   = 'sC0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g1ZDIST(1,4,5,6,3,2)'

      case (168)
        chan_str = 'u em to em u ub u   '
        me_str   = 'sC0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g1ZDIST(1,4,5,6,3,2)'

      case (169)
        chan_str = 'db em to em db d db '
        me_str   = 'sC0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g1ZDIST(4,5,6,1,3,2)'

      case (170)
        chan_str = 'db em to em db u ub '
        me_str   = 'sC0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g1ZDIST(4,5,6,1,3,2)'

      case (171)
        chan_str = 'ub em to em ub d db '
        me_str   = 'sC0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g1ZDIST(4,5,6,1,3,2)'

      case (172)
        chan_str = 'ub em to em ub u ub '
        me_str   = 'sC0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g1ZDIST(4,5,6,1,3,2)'

      case (173)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemsC0g1ZDIST(1,4,5,6,3,2)'

      case (174)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemsC0g1ZDIST(1,4,5,6,3,2)'

      case (175)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemsC0g1ZDIST(1,4,5,6,3,2)'

      case (176)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemsC0g1ZDIST(1,4,5,6,3,2)'

      case (177)
        chan_str = 'd em to em d db d   '
        me_str   = 'Ct0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCt0g1ZDIST(1,4,5,6,3,2)'

      case (178)
        chan_str = 'd em to em u ub d   '
        me_str   = 'Ct0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCt0g1ZDIST(1,4,5,6,3,2)'

      case (179)
        chan_str = 'u em to em d db u   '
        me_str   = 'Ct0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCt0g1ZDIST(1,4,5,6,3,2)'

      case (180)
        chan_str = 'u em to em u ub u   '
        me_str   = 'Ct0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCt0g1ZDIST(1,4,5,6,3,2)'

      case (181)
        chan_str = 'db em to em db d db '
        me_str   = 'Ct0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCt0g1ZDIST(4,5,6,1,3,2)'

      case (182)
        chan_str = 'db em to em db u ub '
        me_str   = 'Ct0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCt0g1ZDIST(4,5,6,1,3,2)'

      case (183)
        chan_str = 'ub em to em ub d db '
        me_str   = 'Ct0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCt0g1ZDIST(4,5,6,1,3,2)'

      case (184)
        chan_str = 'ub em to em ub u ub '
        me_str   = 'Ct0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCt0g1ZDIST(4,5,6,1,3,2)'

      case (185)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCt0g1ZDIST(1,4,5,6,3,2)'

      case (186)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCt0g1ZDIST(1,4,5,6,3,2)'

      case (187)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCt0g1ZDIST(1,4,5,6,3,2)'

      case (188)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCt0g1ZDIST(1,4,5,6,3,2)'

      case (189)
        chan_str = 'd em to em d db d   '
        me_str   = 'Ch0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCh0g1ZDIST(1,4,5,6,3,2)'

      case (190)
        chan_str = 'd em to em u ub d   '
        me_str   = 'Ch0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCh0g1ZDIST(1,4,5,6,3,2)'

      case (191)
        chan_str = 'u em to em d db u   '
        me_str   = 'Ch0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCh0g1ZDIST(1,4,5,6,3,2)'

      case (192)
        chan_str = 'u em to em u ub u   '
        me_str   = 'Ch0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCh0g1ZDIST(1,4,5,6,3,2)'

      case (193)
        chan_str = 'db em to em db d db '
        me_str   = 'Ch0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCh0g1ZDIST(4,5,6,1,3,2)'

      case (194)
        chan_str = 'db em to em db u ub '
        me_str   = 'Ch0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCh0g1ZDIST(4,5,6,1,3,2)'

      case (195)
        chan_str = 'ub em to em ub d db '
        me_str   = 'Ch0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCh0g1ZDIST(4,5,6,1,3,2)'

      case (196)
        chan_str = 'ub em to em ub u ub '
        me_str   = 'Ch0g1ZDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCh0g1ZDIST(4,5,6,1,3,2)'

      case (197)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCh0g1ZDIST(1,4,5,6,3,2)'

      case (198)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCh0g1ZDIST(1,4,5,6,3,2)'

      case (199)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCh0g1ZDIST(1,4,5,6,3,2)'

      case (200)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCh0g1ZDIST(1,4,5,6,3,2)'

      case (201)
        chan_str = 'd em to em d db d   '
        me_str   = 'D0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemD0g1ZDIST(1,4,5,6,3,2)'

      case (202)
        chan_str = 'u em to em u ub u   '
        me_str   = 'D0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemD0g1ZDIST(1,4,5,6,3,2)'

      case (203)
        chan_str = 'db em to em db db d '
        me_str   = 'D0g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemD0g1ZDIST(4,1,5,6,3,2)'

      case (204)
        chan_str = 'ub em to em ub ub u '
        me_str   = 'D0g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemD0g1ZDIST(4,1,5,6,3,2)'

      case (205)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemD0g1ZDIST(1,4,5,6,3,2)'

      case (206)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemD0g1ZDIST(1,4,5,6,3,2)'

      case (207)
        chan_str = 'd em to em d db d   '
        me_str   = 'Dt0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemDt0g1ZDIST(1,4,5,6,3,2)'

      case (208)
        chan_str = 'u em to em u ub u   '
        me_str   = 'Dt0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemDt0g1ZDIST(1,4,5,6,3,2)'

      case (209)
        chan_str = 'db em to em db db d '
        me_str   = 'Dt0g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemDt0g1ZDIST(4,1,5,6,3,2)'

      case (210)
        chan_str = 'ub em to em ub ub u '
        me_str   = 'Dt0g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemDt0g1ZDIST(4,1,5,6,3,2)'

      case (211)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemDt0g1ZDIST(1,4,5,6,3,2)'

      case (212)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemDt0g1ZDIST(1,4,5,6,3,2)'

      case (213)
        chan_str = 'd em to em d db d   '
        me_str   = 'Dh0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemDh0g1ZDIST(1,4,5,6,3,2)'

      case (214)
        chan_str = 'u em to em u ub u   '
        me_str   = 'Dh0g1ZDIS(1,4,5,6,3,2)'
        sub_str  = 'qemDh0g1ZDIST(1,4,5,6,3,2)'

      case (215)
        chan_str = 'db em to em db db d '
        me_str   = 'Dh0g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemDh0g1ZDIST(4,1,5,6,3,2)'

      case (216)
        chan_str = 'ub em to em ub ub u '
        me_str   = 'Dh0g1ZDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemDh0g1ZDIST(4,1,5,6,3,2)'

      case (217)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemDh0g1ZDIST(1,4,5,6,3,2)'

      case (218)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemDh0g1ZDIST(1,4,5,6,3,2)'

      case (219)
        chan_str = 'd em to em g d      '
        me_str   = 'B1g2ZDIS(1,4,5,3,2) '
        sub_str  = 'qemB1g2ZDISU(1,4,5,3,2)'

      case (220)
        chan_str = 'u em to em g u      '
        me_str   = 'B1g2ZDIS(1,4,5,3,2) '
        sub_str  = 'qemB1g2ZDISU(1,4,5,3,2)'

      case (221)
        chan_str = 'g em to em db d     '
        me_str   = 'B1g2ZDIS(4,1,5,3,2) '
        sub_str  = 'gemB1g2ZDISU(4,1,5,3,2)'

      case (222)
        chan_str = 'g em to em ub u     '
        me_str   = 'B1g2ZDIS(4,1,5,3,2) '
        sub_str  = 'gemB1g2ZDISU(4,1,5,3,2)'

      case (223)
        chan_str = 'db em to em db g    '
        me_str   = 'B1g2ZDIS(4,5,1,3,2) '
        sub_str  = 'qbemB1g2ZDISU(4,5,1,3,2)'

      case (224)
        chan_str = 'ub em to em ub g    '
        me_str   = 'B1g2ZDIS(4,5,1,3,2) '
        sub_str  = 'qbemB1g2ZDISU(4,5,1,3,2)'

      case (225)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB1g2ZDISU(1,4,5,3,2)'

      case (226)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB1g2ZDISU(1,4,5,3,2)'

      case (227)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB1g2ZDISU(1,4,5,3,2)'

      case (228)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB1g2ZDISU(1,4,5,3,2)'

      case (229)
        chan_str = 'd em to em g d      '
        me_str   = 'Bt1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBt1g2ZDISU(1,4,5,3,2)'

      case (230)
        chan_str = 'u em to em g u      '
        me_str   = 'Bt1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBt1g2ZDISU(1,4,5,3,2)'

      case (231)
        chan_str = 'g em to em db d     '
        me_str   = 'Bt1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBt1g2ZDISU(4,1,5,3,2)'

      case (232)
        chan_str = 'g em to em ub u     '
        me_str   = 'Bt1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBt1g2ZDISU(4,1,5,3,2)'

      case (233)
        chan_str = 'db em to em db g    '
        me_str   = 'Bt1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBt1g2ZDISU(4,5,1,3,2)'

      case (234)
        chan_str = 'ub em to em ub g    '
        me_str   = 'Bt1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBt1g2ZDISU(4,5,1,3,2)'

      case (235)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBt1g2ZDISU(1,4,5,3,2)'

      case (236)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBt1g2ZDISU(1,4,5,3,2)'

      case (237)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBt1g2ZDISU(1,4,5,3,2)'

      case (238)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBt1g2ZDISU(1,4,5,3,2)'

      case (239)
        chan_str = 'd em to em g d      '
        me_str   = 'Btt1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBtt1g2ZDISU(1,4,5,3,2)'

      case (240)
        chan_str = 'u em to em g u      '
        me_str   = 'Btt1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBtt1g2ZDISU(1,4,5,3,2)'

      case (241)
        chan_str = 'g em to em db d     '
        me_str   = 'Btt1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBtt1g2ZDISU(4,1,5,3,2)'

      case (242)
        chan_str = 'g em to em ub u     '
        me_str   = 'Btt1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBtt1g2ZDISU(4,1,5,3,2)'

      case (243)
        chan_str = 'db em to em db g    '
        me_str   = 'Btt1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBtt1g2ZDISU(4,5,1,3,2)'

      case (244)
        chan_str = 'ub em to em ub g    '
        me_str   = 'Btt1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBtt1g2ZDISU(4,5,1,3,2)'

      case (245)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBtt1g2ZDISU(1,4,5,3,2)'

      case (246)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBtt1g2ZDISU(1,4,5,3,2)'

      case (247)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBtt1g2ZDISU(1,4,5,3,2)'

      case (248)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBtt1g2ZDISU(1,4,5,3,2)'

      case (249)
        chan_str = 'd em to em g d      '
        me_str   = 'Bh1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBh1g2ZDISU(1,4,5,3,2)'

      case (250)
        chan_str = 'u em to em g u      '
        me_str   = 'Bh1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBh1g2ZDISU(1,4,5,3,2)'

      case (251)
        chan_str = 'g em to em db d     '
        me_str   = 'Bh1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBh1g2ZDISU(4,1,5,3,2)'

      case (252)
        chan_str = 'g em to em ub u     '
        me_str   = 'Bh1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBh1g2ZDISU(4,1,5,3,2)'

      case (253)
        chan_str = 'db em to em db g    '
        me_str   = 'Bh1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBh1g2ZDISU(4,5,1,3,2)'

      case (254)
        chan_str = 'ub em to em ub g    '
        me_str   = 'Bh1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBh1g2ZDISU(4,5,1,3,2)'

      case (255)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBh1g2ZDISU(1,4,5,3,2)'

      case (256)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBh1g2ZDISU(1,4,5,3,2)'

      case (257)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBh1g2ZDISU(1,4,5,3,2)'

      case (258)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBh1g2ZDISU(1,4,5,3,2)'

      case (259)
        chan_str = 'd em to em g d      '
        me_str   = 'Bht1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBht1g2ZDISU(1,4,5,3,2)'

      case (260)
        chan_str = 'u em to em g u      '
        me_str   = 'Bht1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBht1g2ZDISU(1,4,5,3,2)'

      case (261)
        chan_str = 'g em to em db d     '
        me_str   = 'Bht1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBht1g2ZDISU(4,1,5,3,2)'

      case (262)
        chan_str = 'g em to em ub u     '
        me_str   = 'Bht1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBht1g2ZDISU(4,1,5,3,2)'

      case (263)
        chan_str = 'db em to em db g    '
        me_str   = 'Bht1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBht1g2ZDISU(4,5,1,3,2)'

      case (264)
        chan_str = 'ub em to em ub g    '
        me_str   = 'Bht1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBht1g2ZDISU(4,5,1,3,2)'

      case (265)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBht1g2ZDISU(1,4,5,3,2)'

      case (266)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBht1g2ZDISU(1,4,5,3,2)'

      case (267)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBht1g2ZDISU(1,4,5,3,2)'

      case (268)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBht1g2ZDISU(1,4,5,3,2)'

      case (269)
        chan_str = 'd em to em g d      '
        me_str   = 'Bhh1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBhh1g2ZDISU(1,4,5,3,2)'

      case (270)
        chan_str = 'u em to em g u      '
        me_str   = 'Bhh1g2ZDIS(1,4,5,3,2)'
        sub_str  = 'qemBhh1g2ZDISU(1,4,5,3,2)'

      case (271)
        chan_str = 'g em to em db d     '
        me_str   = 'Bhh1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBhh1g2ZDISU(4,1,5,3,2)'

      case (272)
        chan_str = 'g em to em ub u     '
        me_str   = 'Bhh1g2ZDIS(4,1,5,3,2)'
        sub_str  = 'gemBhh1g2ZDISU(4,1,5,3,2)'

      case (273)
        chan_str = 'db em to em db g    '
        me_str   = 'Bhh1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBhh1g2ZDISU(4,5,1,3,2)'

      case (274)
        chan_str = 'ub em to em ub g    '
        me_str   = 'Bhh1g2ZDIS(4,5,1,3,2)'
        sub_str  = 'qbemBhh1g2ZDISU(4,5,1,3,2)'

      case (275)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBhh1g2ZDISU(1,4,5,3,2)'

      case (276)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBhh1g2ZDISU(1,4,5,3,2)'

      case (277)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBhh1g2ZDISU(1,4,5,3,2)'

      case (278)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBhh1g2ZDISU(1,4,5,3,2)'

      case default
        print*, 'getchannelDIS: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtDIS(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtDIS = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (7)
        ! [em, g, g, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (8)
        ! [em, g, g, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (11)
        ! [em, db, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (12)
        ! [em, ub, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (13)
        ! [em, gt, gt, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (14)
        ! [em, gt, gt, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (17)
        ! [em, db, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (18)
        ! [em, ub, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (19)
        ! [em, d, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (22)
        ! [em, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (23)
        ! [em, db, d, db]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (26)
        ! [em, ub, u, ub]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (27)
        ! [em, d, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (28)
        ! [em, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (29)
        ! [em, db, db, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (30)
        ! [em, ub, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (61)
        ! [em, g, g, g, d]
        LIPSwgtDIS = weight_lips((/ 4,5,6 /))

      case (62)
        ! [em, g, g, g, u]
        LIPSwgtDIS = weight_lips((/ 4,5,6 /))

      case (63)
        ! [em, db, g, g, d]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (64)
        ! [em, ub, g, g, u]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (65)
        ! [em, db, g, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6,7 /))

      case (66)
        ! [em, ub, g, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6,7 /))

      case (67)
        ! [em, g, g, g, d]
        LIPSwgtDIS = weight_lips((/ 4,5,6 /))

      case (68)
        ! [em, g, g, g, u]
        LIPSwgtDIS = weight_lips((/ 4,5,6 /))

      case (69)
        ! [em, db, g, g, d]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (70)
        ! [em, ub, g, g, u]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (71)
        ! [em, db, g, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6,7 /))

      case (72)
        ! [em, ub, g, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6,7 /))

      case (73)
        ! [em, gt, gt, gt, d]
        LIPSwgtDIS = weight_lips((/ 4,5,6 /))

      case (74)
        ! [em, gt, gt, gt, u]
        LIPSwgtDIS = weight_lips((/ 4,5,6 /))

      case (75)
        ! [em, db, gt, gt, d]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (76)
        ! [em, ub, gt, gt, u]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (77)
        ! [em, db, gt, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6,7 /))

      case (78)
        ! [em, ub, gt, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6,7 /))

      case (79)
        ! [em, g, d, db, d]
        LIPSwgtDIS = weight_lips((/ 5,7 /))

      case (82)
        ! [em, g, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 5,7 /))

      case (83)
        ! [em, db, d, db, d]
        LIPSwgtDIS = weight_lips((/ 5,7 /), (/ 4,6 /))

      case (86)
        ! [em, ub, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 5,7 /), (/ 4,6 /))

      case (87)
        ! [em, db, g, d, db]
        LIPSwgtDIS = weight_lips((/ 4,7 /))

      case (90)
        ! [em, ub, g, u, ub]
        LIPSwgtDIS = weight_lips((/ 4,7 /))

      case (91)
        ! [em, g, d, db, d]
        LIPSwgtDIS = weight_lips((/ 5,7 /))

      case (94)
        ! [em, g, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 5,7 /))

      case (95)
        ! [em, db, d, db, d]
        LIPSwgtDIS = weight_lips((/ 5,7 /), (/ 4,6 /))

      case (98)
        ! [em, ub, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 5,7 /), (/ 4,6 /))

      case (99)
        ! [em, db, g, d, db]
        LIPSwgtDIS = weight_lips((/ 4,7 /))

      case (102)
        ! [em, ub, g, u, ub]
        LIPSwgtDIS = weight_lips((/ 4,7 /))

      case (103)
        ! [em, g, d, db, d]
        LIPSwgtDIS = weight_lips((/ 5,7 /))

      case (104)
        ! [em, g, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 5,7 /))

      case (105)
        ! [em, db, d, db, d]
        LIPSwgtDIS = weight_lips((/ 5,7 /), (/ 4,6 /))

      case (106)
        ! [em, ub, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 5,7 /), (/ 4,6 /))

      case (107)
        ! [em, db, g, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (108)
        ! [em, ub, g, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (109)
        ! [em, g, d, db, d]
        LIPSwgtDIS = weight_lips((/ 5,7 /))

      case (110)
        ! [em, g, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 5,7 /))

      case (111)
        ! [em, db, d, db, d]
        LIPSwgtDIS = weight_lips((/ 5,7 /), (/ 4,6 /))

      case (112)
        ! [em, ub, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 5,7 /), (/ 4,6 /))

      case (113)
        ! [em, db, g, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (114)
        ! [em, ub, g, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (115)
        ! [em, g, g, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (116)
        ! [em, g, g, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (119)
        ! [em, db, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (120)
        ! [em, ub, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (125)
        ! [em, gt, gt, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (126)
        ! [em, gt, gt, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (129)
        ! [em, db, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (130)
        ! [em, ub, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (135)
        ! [em, gt, gt, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (136)
        ! [em, gt, gt, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (139)
        ! [em, db, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (140)
        ! [em, ub, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (145)
        ! [em, g, g, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (146)
        ! [em, g, g, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (149)
        ! [em, db, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (150)
        ! [em, ub, g, g]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (155)
        ! [em, gt, gt, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (156)
        ! [em, gt, gt, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (159)
        ! [em, db, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (160)
        ! [em, ub, gt, gt]
        LIPSwgtDIS = weight_lips((/ 5,6 /))

      case (165)
        ! [em, d, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (168)
        ! [em, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (169)
        ! [em, db, d, db]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (172)
        ! [em, ub, u, ub]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (177)
        ! [em, d, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (180)
        ! [em, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (181)
        ! [em, db, d, db]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (184)
        ! [em, ub, u, ub]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (189)
        ! [em, d, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (192)
        ! [em, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (193)
        ! [em, db, d, db]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (196)
        ! [em, ub, u, ub]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (201)
        ! [em, d, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (202)
        ! [em, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (203)
        ! [em, db, db, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (204)
        ! [em, ub, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (207)
        ! [em, d, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (208)
        ! [em, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (209)
        ! [em, db, db, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (210)
        ! [em, ub, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (213)
        ! [em, d, db, d]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (214)
        ! [em, u, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,6 /))

      case (215)
        ! [em, db, db, d]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case (216)
        ! [em, ub, ub, u]
        LIPSwgtDIS = weight_lips((/ 4,5 /))

      case default
        LIPSwgtDIS = 1

      end select
      end
