      function sigRDIS(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRDIS=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis(0,6,ipass)
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(6, (/ 1, 2, 3, 4, 5, 6 /) )
#endif 

c--- d em to em g g d 
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B2g0ZDIS(1,4,5,6,3,2)
     .          +B2g0ZDIS(1,5,4,6,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g g u 
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B2g0ZDIS(1,4,5,6,3,2)
     .          +B2g0ZDIS(1,5,4,6,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db g d 
      if (qactive_chan(9).and.qselect_chan(9)) then
        current_chan = 9
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B2g0ZDIS(4,1,5,6,3,2)
     .          +B2g0ZDIS(4,5,1,6,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub g u 
      if (qactive_chan(10).and.qselect_chan(10)) then
        current_chan = 10
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B2g0ZDIS(4,1,5,6,3,2)
     .          +B2g0ZDIS(4,5,1,6,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g g 
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B2g0ZDIS(4,5,6,1,3,2)
     .          +B2g0ZDIS(4,6,5,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g g 
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B2g0ZDIS(4,5,6,1,3,2)
     .          +B2g0ZDIS(4,6,5,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em gt gt d 
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt2g0ZDIS(1,4,5,6,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em gt gt u 
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt2g0ZDIS(1,4,5,6,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt em to em db gt d 
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Bt2g0ZDIS(4,1,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt em to em ub gt u 
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Bt2g0ZDIS(4,1,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db gt gt 
      if (qactive_chan(17).and.qselect_chan(17)) then
        current_chan = 17
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt2g0ZDIS(4,5,6,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub gt gt 
      if (qactive_chan(18).and.qselect_chan(18)) then
        current_chan = 18
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt2g0ZDIS(4,5,6,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em d db d 
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = 10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C0g0ZDIS(1,4,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em u ub d 
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = 10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C0g0ZDIS(1,4,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em d db u 
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C0g0ZDIS(1,4,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em u ub u 
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C0g0ZDIS(1,4,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db d db 
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = -10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C0g0ZDIS(4,5,6,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db u ub 
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = -10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C0g0ZDIS(4,5,6,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub d db 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C0g0ZDIS(4,5,6,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub u ub 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C0g0ZDIS(4,5,6,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em d db d 
      if (qactive_chan(27).and.qselect_chan(27)) then
        current_chan = 27
        ip1_chan     = 10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0ZDIS(1,4,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em u ub u 
      if (qactive_chan(28).and.qselect_chan(28)) then
        current_chan = 28
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0ZDIS(1,4,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db db d 
      if (qactive_chan(29).and.qselect_chan(29)) then
        current_chan = 29
        ip1_chan     = -10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0ZDIS(4,1,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub ub u 
      if (qactive_chan(30).and.qselect_chan(30)) then
        current_chan = 30
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0ZDIS(4,1,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRDIS=rnorm*wtsum

      return
      end
