      function sigRRDIS(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRRDIS=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis(0,7,ipass)
      virtsflag=.false.
      jflag=.false.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(7, (/ 1, 2, 3, 4, 5, 6, 7 /) )
#endif 

c--- d em to em g g g d 
      if (qactive_chan(61).and.qselect_chan(61)) then
        current_chan = 61
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0ZDIS(1,4,5,6,7,3,2)
     .          +sB3g0ZDIS(1,4,6,5,7,3,2)
     .          +sB3g0ZDIS(1,5,4,6,7,3,2)
     .          +sB3g0ZDIS(1,5,6,4,7,3,2)
     .          +sB3g0ZDIS(1,6,4,5,7,3,2)
     .          +sB3g0ZDIS(1,6,5,4,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g g g u 
      if (qactive_chan(62).and.qselect_chan(62)) then
        current_chan = 62
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0ZDIS(1,4,5,6,7,3,2)
     .          +sB3g0ZDIS(1,4,6,5,7,3,2)
     .          +sB3g0ZDIS(1,5,4,6,7,3,2)
     .          +sB3g0ZDIS(1,5,6,4,7,3,2)
     .          +sB3g0ZDIS(1,6,4,5,7,3,2)
     .          +sB3g0ZDIS(1,6,5,4,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db g g d 
      if (qactive_chan(63).and.qselect_chan(63)) then
        current_chan = 63
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0ZDIS(4,1,5,6,7,3,2)
     .          +sB3g0ZDIS(4,1,6,5,7,3,2)
     .          +sB3g0ZDIS(4,5,1,6,7,3,2)
     .          +sB3g0ZDIS(4,5,6,1,7,3,2)
     .          +sB3g0ZDIS(4,6,1,5,7,3,2)
     .          +sB3g0ZDIS(4,6,5,1,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub g g u 
      if (qactive_chan(64).and.qselect_chan(64)) then
        current_chan = 64
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0ZDIS(4,1,5,6,7,3,2)
     .          +sB3g0ZDIS(4,1,6,5,7,3,2)
     .          +sB3g0ZDIS(4,5,1,6,7,3,2)
     .          +sB3g0ZDIS(4,5,6,1,7,3,2)
     .          +sB3g0ZDIS(4,6,1,5,7,3,2)
     .          +sB3g0ZDIS(4,6,5,1,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g g g 
      if (qactive_chan(65).and.qselect_chan(65)) then
        current_chan = 65
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0ZDIS(4,5,6,7,1,3,2)
     .          +sB3g0ZDIS(4,5,7,6,1,3,2)
     .          +sB3g0ZDIS(4,6,5,7,1,3,2)
     .          +sB3g0ZDIS(4,6,7,5,1,3,2)
     .          +sB3g0ZDIS(4,7,5,6,1,3,2)
     .          +sB3g0ZDIS(4,7,6,5,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g g g 
      if (qactive_chan(66).and.qselect_chan(66)) then
        current_chan = 66
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0ZDIS(4,5,6,7,1,3,2)
     .          +sB3g0ZDIS(4,5,7,6,1,3,2)
     .          +sB3g0ZDIS(4,6,5,7,1,3,2)
     .          +sB3g0ZDIS(4,6,7,5,1,3,2)
     .          +sB3g0ZDIS(4,7,5,6,1,3,2)
     .          +sB3g0ZDIS(4,7,6,5,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g g g d 
      if (qactive_chan(67).and.qselect_chan(67)) then
        current_chan = 67
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0ZDIS(1,4,5,6,7,3,2)
     .          +sBt3g0ZDIS(1,4,6,5,7,3,2)
     .          +sBt3g0ZDIS(1,5,4,6,7,3,2)
     .          +sBt3g0ZDIS(1,5,6,4,7,3,2)
     .          +sBt3g0ZDIS(1,6,4,5,7,3,2)
     .          +sBt3g0ZDIS(1,6,5,4,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g g g u 
      if (qactive_chan(68).and.qselect_chan(68)) then
        current_chan = 68
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0ZDIS(1,4,5,6,7,3,2)
     .          +sBt3g0ZDIS(1,4,6,5,7,3,2)
     .          +sBt3g0ZDIS(1,5,4,6,7,3,2)
     .          +sBt3g0ZDIS(1,5,6,4,7,3,2)
     .          +sBt3g0ZDIS(1,6,4,5,7,3,2)
     .          +sBt3g0ZDIS(1,6,5,4,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db g g d 
      if (qactive_chan(69).and.qselect_chan(69)) then
        current_chan = 69
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0ZDIS(4,1,5,6,7,3,2)
     .          +sBt3g0ZDIS(4,1,6,5,7,3,2)
     .          +sBt3g0ZDIS(4,5,1,6,7,3,2)
     .          +sBt3g0ZDIS(4,5,6,1,7,3,2)
     .          +sBt3g0ZDIS(4,6,1,5,7,3,2)
     .          +sBt3g0ZDIS(4,6,5,1,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub g g u 
      if (qactive_chan(70).and.qselect_chan(70)) then
        current_chan = 70
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0ZDIS(4,1,5,6,7,3,2)
     .          +sBt3g0ZDIS(4,1,6,5,7,3,2)
     .          +sBt3g0ZDIS(4,5,1,6,7,3,2)
     .          +sBt3g0ZDIS(4,5,6,1,7,3,2)
     .          +sBt3g0ZDIS(4,6,1,5,7,3,2)
     .          +sBt3g0ZDIS(4,6,5,1,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g g g 
      if (qactive_chan(71).and.qselect_chan(71)) then
        current_chan = 71
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0ZDIS(4,5,6,7,1,3,2)
     .          +sBt3g0ZDIS(4,5,7,6,1,3,2)
     .          +sBt3g0ZDIS(4,6,5,7,1,3,2)
     .          +sBt3g0ZDIS(4,6,7,5,1,3,2)
     .          +sBt3g0ZDIS(4,7,5,6,1,3,2)
     .          +sBt3g0ZDIS(4,7,6,5,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g g g 
      if (qactive_chan(72).and.qselect_chan(72)) then
        current_chan = 72
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0ZDIS(4,5,6,7,1,3,2)
     .          +sBt3g0ZDIS(4,5,7,6,1,3,2)
     .          +sBt3g0ZDIS(4,6,5,7,1,3,2)
     .          +sBt3g0ZDIS(4,6,7,5,1,3,2)
     .          +sBt3g0ZDIS(4,7,5,6,1,3,2)
     .          +sBt3g0ZDIS(4,7,6,5,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em gt gt gt d 
      if (qactive_chan(73).and.qselect_chan(73)) then
        current_chan = 73
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0ZDIS(1,4,5,6,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em gt gt gt u 
      if (qactive_chan(74).and.qselect_chan(74)) then
        current_chan = 74
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0ZDIS(1,4,5,6,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt em to em db gt gt d 
      if (qactive_chan(75).and.qselect_chan(75)) then
        current_chan = 75
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0ZDIS(4,1,5,6,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt em to em ub gt gt u 
      if (qactive_chan(76).and.qselect_chan(76)) then
        current_chan = 76
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0ZDIS(4,1,5,6,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db gt gt gt 
      if (qactive_chan(77).and.qselect_chan(77)) then
        current_chan = 77
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0ZDIS(4,5,6,7,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub gt gt gt 
      if (qactive_chan(78).and.qselect_chan(78)) then
        current_chan = 78
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0ZDIS(4,5,6,7,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d db d 
      if (qactive_chan(79).and.qselect_chan(79)) then
        current_chan = 79
        ip1_chan     = 10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g u ub d 
      if (qactive_chan(80).and.qselect_chan(80)) then
        current_chan = 80
        ip1_chan     = 10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g d db u 
      if (qactive_chan(81).and.qselect_chan(81)) then
        current_chan = 81
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u ub u 
      if (qactive_chan(82).and.qselect_chan(82)) then
        current_chan = 82
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d db d 
      if (qactive_chan(83).and.qselect_chan(83)) then
        current_chan = 83
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db u ub d 
      if (qactive_chan(84).and.qselect_chan(84)) then
        current_chan = 84
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub d db u 
      if (qactive_chan(85).and.qselect_chan(85)) then
        current_chan = 85
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u ub u 
      if (qactive_chan(86).and.qselect_chan(86)) then
        current_chan = 86
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g d db 
      if (qactive_chan(87).and.qselect_chan(87)) then
        current_chan = 87
        ip1_chan     = -10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g u ub 
      if (qactive_chan(88).and.qselect_chan(88)) then
        current_chan = 88
        ip1_chan     = -10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g d db 
      if (qactive_chan(89).and.qselect_chan(89)) then
        current_chan = 89
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g u ub 
      if (qactive_chan(90).and.qselect_chan(90)) then
        current_chan = 90
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0ZDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d db d 
      if (qactive_chan(91).and.qselect_chan(91)) then
        current_chan = 91
        ip1_chan     = 10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g u ub d 
      if (qactive_chan(92).and.qselect_chan(92)) then
        current_chan = 92
        ip1_chan     = 10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g d db u 
      if (qactive_chan(93).and.qselect_chan(93)) then
        current_chan = 93
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u ub u 
      if (qactive_chan(94).and.qselect_chan(94)) then
        current_chan = 94
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d db d 
      if (qactive_chan(95).and.qselect_chan(95)) then
        current_chan = 95
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db u ub d 
      if (qactive_chan(96).and.qselect_chan(96)) then
        current_chan = 96
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub d db u 
      if (qactive_chan(97).and.qselect_chan(97)) then
        current_chan = 97
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u ub u 
      if (qactive_chan(98).and.qselect_chan(98)) then
        current_chan = 98
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g d db 
      if (qactive_chan(99).and.qselect_chan(99)) then
        current_chan = 99
        ip1_chan     = -10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g u ub 
      if (qactive_chan(100).and.qselect_chan(100)) then
        current_chan = 100
        ip1_chan     = -10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g d db 
      if (qactive_chan(101).and.qselect_chan(101)) then
        current_chan = 101
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g u ub 
      if (qactive_chan(102).and.qselect_chan(102)) then
        current_chan = 102
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0ZDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d db d 
      if (qactive_chan(103).and.qselect_chan(103)) then
        current_chan = 103
        ip1_chan     = 10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0ZcDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u ub u 
      if (qactive_chan(104).and.qselect_chan(104)) then
        current_chan = 104
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0ZcDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d db d 
      if (qactive_chan(105).and.qselect_chan(105)) then
        current_chan = 105
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0ZcDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u ub u 
      if (qactive_chan(106).and.qselect_chan(106)) then
        current_chan = 106
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0ZcDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g db d 
      if (qactive_chan(107).and.qselect_chan(107)) then
        current_chan = 107
        ip1_chan     = -10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0ZcDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g ub u 
      if (qactive_chan(108).and.qselect_chan(108)) then
        current_chan = 108
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0ZcDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d db d 
      if (qactive_chan(109).and.qselect_chan(109)) then
        current_chan = 109
        ip1_chan     = 10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u ub u 
      if (qactive_chan(110).and.qselect_chan(110)) then
        current_chan = 110
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0ZDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d db d 
      if (qactive_chan(111).and.qselect_chan(111)) then
        current_chan = 111
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u ub u 
      if (qactive_chan(112).and.qselect_chan(112)) then
        current_chan = 112
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0ZDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g db d 
      if (qactive_chan(113).and.qselect_chan(113)) then
        current_chan = 113
        ip1_chan     = -10
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0ZDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g ub u 
      if (qactive_chan(114).and.qselect_chan(114)) then
        current_chan = 114
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0ZDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRRDIS=rnorm*wtsum

      return
      end
