      function sigVDIS(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVDIS=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis(0,5,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- d em to em g d 
      if (qactive_chan(31).and.qselect_chan(31)) then
        current_chan = 31
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(32).and.qselect_chan(32)) then
        current_chan = 32
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(33).and.qselect_chan(33)) then
        current_chan = 33
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(34).and.qselect_chan(34)) then
        current_chan = 34
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d 
      if (qactive_chan(41).and.qselect_chan(41)) then
        current_chan = 41
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(42).and.qselect_chan(42)) then
        current_chan = 42
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(43).and.qselect_chan(43)) then
        current_chan = 43
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(44).and.qselect_chan(44)) then
        current_chan = 44
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(45).and.qselect_chan(45)) then
        current_chan = 45
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(46).and.qselect_chan(46)) then
        current_chan = 46
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d 
      if (qactive_chan(51).and.qselect_chan(51)) then
        current_chan = 51
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(52).and.qselect_chan(52)) then
        current_chan = 52
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(53).and.qselect_chan(53)) then
        current_chan = 53
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(54).and.qselect_chan(54)) then
        current_chan = 54
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(55).and.qselect_chan(55)) then
        current_chan = 55
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(56).and.qselect_chan(56)) then
        current_chan = 56
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigVDIS=rnorm*wtsum

      return
      end
