      function sigVVDIS(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVVDIS=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis(0,5,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

!$omp critical(VV_DIS)
#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- d em to em g d 
      if (qactive_chan(219).and.qselect_chan(219)) then
        current_chan = 219
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(220).and.qselect_chan(220)) then
        current_chan = 220
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(221).and.qselect_chan(221)) then
        current_chan = 221
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(222).and.qselect_chan(222)) then
        current_chan = 222
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(223).and.qselect_chan(223)) then
        current_chan = 223
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(224).and.qselect_chan(224)) then
        current_chan = 224
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d 
      if (qactive_chan(229).and.qselect_chan(229)) then
        current_chan = 229
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(230).and.qselect_chan(230)) then
        current_chan = 230
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(231).and.qselect_chan(231)) then
        current_chan = 231
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(232).and.qselect_chan(232)) then
        current_chan = 232
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(233).and.qselect_chan(233)) then
        current_chan = 233
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(234).and.qselect_chan(234)) then
        current_chan = 234
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d 
      if (qactive_chan(239).and.qselect_chan(239)) then
        current_chan = 239
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(240).and.qselect_chan(240)) then
        current_chan = 240
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(241).and.qselect_chan(241)) then
        current_chan = 241
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(242).and.qselect_chan(242)) then
        current_chan = 242
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(243).and.qselect_chan(243)) then
        current_chan = 243
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(244).and.qselect_chan(244)) then
        current_chan = 244
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d 
      if (qactive_chan(249).and.qselect_chan(249)) then
        current_chan = 249
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(250).and.qselect_chan(250)) then
        current_chan = 250
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(251).and.qselect_chan(251)) then
        current_chan = 251
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(252).and.qselect_chan(252)) then
        current_chan = 252
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(253).and.qselect_chan(253)) then
        current_chan = 253
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(254).and.qselect_chan(254)) then
        current_chan = 254
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d 
      if (qactive_chan(259).and.qselect_chan(259)) then
        current_chan = 259
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(260).and.qselect_chan(260)) then
        current_chan = 260
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(261).and.qselect_chan(261)) then
        current_chan = 261
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(262).and.qselect_chan(262)) then
        current_chan = 262
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(263).and.qselect_chan(263)) then
        current_chan = 263
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(264).and.qselect_chan(264)) then
        current_chan = 264
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to em g d 
      if (qactive_chan(269).and.qselect_chan(269)) then
        current_chan = 269
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(270).and.qselect_chan(270)) then
        current_chan = 270
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2ZDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(271).and.qselect_chan(271)) then
        current_chan = 271
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(272).and.qselect_chan(272)) then
        current_chan = 272
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2ZDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(273).and.qselect_chan(273)) then
        current_chan = 273
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(274).and.qselect_chan(274)) then
        current_chan = 274
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2ZDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
!$omp end critical(VV_DIS)

      sigVVDIS=rnorm*wtsum

      return
      end
