      subroutine getlumiDIS1j(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    5,   11,   21,   27,   33,   34,   41,          
     &           45,   55,   65,   75,   85,   95)
!       [10, 99]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)                                         
     &       + f1(3,1:nInp_scl)                                         
     &       + f1(5,1:nInp_scl)                                         

        case (    2,    6,   12,   22,   28,   35,   36,   42,          
     &           46,   56,   66,   76,   86,   96)
!       [20, 99]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)                                         
     &       + f1(4,1:nInp_scl)                                         

        case (    3,    9,   13,   25,   31,   37,   38,   43,          
     &           49,   59,   69,   77,   87,   97)
!       [-10, 99]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)                                        
     &       + f1(-3,1:nInp_scl)                                        
     &       + f1(-5,1:nInp_scl)                                        

        case (    4,   10,   14,   26,   32,   39,   40,   44,          
     &           50,   60,   70,   78,   88,   98)
!       [-20, 99]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)                                        
     &       + f1(-4,1:nInp_scl)                                        

        case (    7,    8,   19,   20,   23,   24,   29,   30,          
     &           47,   48,   57,   58,   67,   68,   83,   84,          
     &           93,   94,  103,  104)
!       [0, 99]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)                                         

        case (   15,   16,   51,   52,   61,   62,   71,   72,          
     &           79,   80,   89,   90,   99,  100)
!       [30, 99]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)                                         
     &       + f1(2,1:nInp_scl)                                         
     &       + f1(3,1:nInp_scl)                                         
     &       + f1(4,1:nInp_scl)                                         
     &       + f1(5,1:nInp_scl)                                         

        case (   17,   18,   53,   54,   63,   64,   73,   74,          
     &           81,   82,   91,   92,  101,  102)
!       [-30, 99]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)                                        
     &       + f1(-2,1:nInp_scl)                                        
     &       + f1(-3,1:nInp_scl)                                        
     &       + f1(-4,1:nInp_scl)                                        
     &       + f1(-5,1:nInp_scl)                                        

        case default
          print*, "getlumiDIS1j: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiDIS1j



      function getlumiidDIS1j(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    5,   11,   21,   27,   33,   34,   41,
     &           45,   55,   65,   75,   85,   95)
          id  = 1
          ip1 = 10
          ip2 = 99

        case (    2,    6,   12,   22,   28,   35,   36,   42,
     &           46,   56,   66,   76,   86,   96)
          id  = 2
          ip1 = 20
          ip2 = 99

        case (    3,    9,   13,   25,   31,   37,   38,   43,
     &           49,   59,   69,   77,   87,   97)
          id  = 3
          ip1 = -10
          ip2 = 99

        case (    4,   10,   14,   26,   32,   39,   40,   44,
     &           50,   60,   70,   78,   88,   98)
          id  = 4
          ip1 = -20
          ip2 = 99

        case (    7,    8,   19,   20,   23,   24,   29,   30,
     &           47,   48,   57,   58,   67,   68,   83,   84,
     &           93,   94,  103,  104)
          id  = 5
          ip1 = 0
          ip2 = 99

        case (   15,   16,   51,   52,   61,   62,   71,   72,
     &           79,   80,   89,   90,   99,  100)
          id  = 6
          ip1 = 30
          ip2 = 99

        case (   17,   18,   53,   54,   63,   64,   73,   74,
     &           81,   82,   91,   92,  101,  102)
          id  = 7
          ip1 = -30
          ip2 = 99

        case default
          print*, "getlumiidDIS1j: invalid iproc:", iproc
          stop
        end select

      end function getlumiidDIS1j





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiDIS1j()
        use PineAPPL_mod
        use CKM_mod
!       [10, 99]
        call register_lumi_pine(
     &         [    1,    5,   11,   21,   27,   33,   34,   41,
     &             45,   55,   65,   75,   85,   95],
     &         3,
     &         [    1,   99,    3,   99,    5,   99],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 99]
        call register_lumi_pine(
     &         [    2,    6,   12,   22,   28,   35,   36,   42,
     &             46,   56,   66,   76,   86,   96],
     &         2,
     &         [    2,   99,    4,   99],
     &         [  1d0,  1d0]
     &       )

!       [-10, 99]
        call register_lumi_pine(
     &         [    3,    9,   13,   25,   31,   37,   38,   43,
     &             49,   59,   69,   77,   87,   97],
     &         3,
     &         [   -1,   99,   -3,   99,   -5,   99],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 99]
        call register_lumi_pine(
     &         [    4,   10,   14,   26,   32,   39,   40,   44,
     &             50,   60,   70,   78,   88,   98],
     &         2,
     &         [   -2,   99,   -4,   99],
     &         [  1d0,  1d0]
     &       )

!       [0, 99]
        call register_lumi_pine(
     &         [    7,    8,   19,   20,   23,   24,   29,   30,
     &             47,   48,   57,   58,   67,   68,   83,   84,
     &             93,   94,  103,  104],
     &         1,
     &         [   21,   99],
     &         [  1d0]
     &       )

!       [30, 99]
        call register_lumi_pine(
     &         [   15,   16,   51,   52,   61,   62,   71,   72,
     &             79,   80,   89,   90,   99,  100],
     &         5,
     &         [    1,   99,    2,   99,    3,   99,    4,   99,
     &              5,   99],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 99]
        call register_lumi_pine(
     &         [   17,   18,   53,   54,   63,   64,   73,   74,
     &             81,   82,   91,   92,  101,  102],
     &         5,
     &         [   -1,   99,   -2,   99,   -3,   99,   -4,   99,
     &             -5,   99],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiDIS1j


#endif


