      subroutine getqcdnormDIS1j(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtDIS1j(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_dis1j(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVDIS1j
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourDIS1j(current_chan)
         do isub = 1, nflavourDIS1j(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_DIS1j(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=DIS1j "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*amz)**2*nc*4d0
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d em -> em d            B0g0Z
      case(2)
         factor=facB                        ! u em -> em u            B0g0Z
      case(3)
         factor=facB                        ! db em -> em db          B0g0Z
      case(4)
         factor=facB                        ! ub em -> em ub          B0g0Z

c -- real

      case(5)
         factor=(nc**2-1d0)/nc**2*facR      ! d em -> em g d          B1g0ZDIS1j
      case(6)
         factor=(nc**2-1d0)/nc**2*facR      ! u em -> em g u          B1g0ZDIS1j
      case(7)
         factor=(nc**2-1d0)/nc**2*ndown*facR   ! g em -> em db d         B1g0ZDIS1j
      case(8)
         factor=(nc**2-1d0)/nc**2*nup*facR   ! g em -> em ub u         B1g0ZDIS1j
      case(9)
         factor=(nc**2-1d0)/nc**2*facR      ! db em -> em db g        B1g0ZDIS1j
      case(10)
         factor=(nc**2-1d0)/nc**2*facR      ! ub em -> em ub g        B1g0ZDIS1j

c -- virtual

      case(11)
         factor=(nc**2-1d0)/nc**2*facV      ! d em -> em d            B0g1ZDIS1j
      case(12)
         factor=(nc**2-1d0)/nc**2*facV      ! u em -> em u            B0g1ZDIS1j
      case(13)
         factor=(nc**2-1d0)/nc**2*facV      ! db em -> em db          B0g1ZDIS1j
      case(14)
         factor=(nc**2-1d0)/nc**2*facV      ! ub em -> em ub          B0g1ZDIS1j
      case(15)
         factor=(nc**2-1d0)/nc**2*ndown/nf*facV   ! Q em subtraction        B0g1ZDIS1j
      case(16)
         factor=(nc**2-1d0)/nc**2/nf*nup*facV   ! Q em subtraction        B0g1ZDIS1j
      case(17)
         factor=(nc**2-1d0)/nc**2*ndown/nf*facV   ! Qb em subtraction       B0g1ZDIS1j
      case(18)
         factor=(nc**2-1d0)/nc**2/nf*nup*facV   ! Qb em subtraction       B0g1ZDIS1j
      case(19)
         factor=(nc**2-1d0)/nc**2*ndown*facV   ! g em subtraction        B0g1ZDIS1j
      case(20)
         factor=(nc**2-1d0)/nc**2*nup*facV   ! g em subtraction        B0g1ZDIS1j

c -- double real

      case(21)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! d em -> em g g d        csB2g0ZDIS1j
      case(22)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! u em -> em g g u        csB2g0ZDIS1j
      case(23)
         factor=(nc**2-1d0)/nc**2*ndown*facRR   ! g em -> em db g d       csB2g0ZDIS1j
      case(24)
         factor=(nc**2-1d0)/nc**2*nup*facRR   ! g em -> em ub g u       csB2g0ZDIS1j
      case(25)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! db em -> em db g g      csB2g0ZDIS1j
      case(26)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! ub em -> em ub g g      csB2g0ZDIS1j
      case(27)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d em -> em gt gt d      csBt2g0ZDIS1j
      case(28)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u em -> em gt gt u      csBt2g0ZDIS1j
      case(29)
         factor=-(nc**2-1d0)/nc**4*ndown*facRR   ! gt em -> em db gt d     csBt2g0ZDIS1j
      case(30)
         factor=-(nc**2-1d0)/nc**4*nup*facRR   ! gt em -> em ub gt u     csBt2g0ZDIS1j
      case(31)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db em -> em db gt gt     csBt2g0ZDIS1j
      case(32)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub em -> em ub gt gt     csBt2g0ZDIS1j
      case(33)
         factor=(nc**2-1d0)/nc**3*ndown*facRR   ! d em -> em d db d       sC0g0ZDIS1j
      case(34)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! d em -> em u ub d       sC0g0ZDIS1j
      case(35)
         factor=(nc**2-1d0)/nc**3*ndown*facRR   ! u em -> em d db u       sC0g0ZDIS1j
      case(36)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! u em -> em u ub u       sC0g0ZDIS1j
      case(37)
         factor=(nc**2-1d0)/nc**3*ndown*facRR   ! db em -> em db d db     sC0g0ZDIS1j
      case(38)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! db em -> em db u ub     sC0g0ZDIS1j
      case(39)
         factor=(nc**2-1d0)/nc**3*ndown*facRR   ! ub em -> em ub d db     sC0g0ZDIS1j
      case(40)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! ub em -> em ub u ub     sC0g0ZDIS1j
      case(41)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d em -> em d db d       D0g0ZDIS1j
      case(42)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u em -> em u ub u       D0g0ZDIS1j
      case(43)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db em -> em db db d     D0g0ZDIS1j
      case(44)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub em -> em ub ub u     D0g0ZDIS1j

c -- real virtual

      case(45)
         factor=(nc**2-1d0)/nc**2*facRV     ! d em -> em g d          csB1g1ZDIS1j
      case(46)
         factor=(nc**2-1d0)/nc**2*facRV     ! u em -> em g u          csB1g1ZDIS1j
      case(47)
         factor=(nc**2-1d0)/nc**2*ndown*facRV   ! g em -> em db d         csB1g1ZDIS1j
      case(48)
         factor=(nc**2-1d0)/nc**2*nup*facRV   ! g em -> em ub u         csB1g1ZDIS1j
      case(49)
         factor=(nc**2-1d0)/nc**2*facRV     ! db em -> em db g        csB1g1ZDIS1j
      case(50)
         factor=(nc**2-1d0)/nc**2*facRV     ! ub em -> em ub g        csB1g1ZDIS1j
      case(51)
         factor=(nc**2-1d0)/nc**2*ndown/nf*facRV   ! Q em subtraction        csB1g1ZDIS1j
      case(52)
         factor=(nc**2-1d0)/nc**2/nf*nup*facRV   ! Q em subtraction        csB1g1ZDIS1j
      case(53)
         factor=(nc**2-1d0)/nc**2*ndown/nf*facRV   ! Qb em subtraction       csB1g1ZDIS1j
      case(54)
         factor=(nc**2-1d0)/nc**2/nf*nup*facRV   ! Qb em subtraction       csB1g1ZDIS1j
      case(55)
         factor=-(nc**2-1d0)/nc**4*facRV    ! d em -> em g d          csBt1g1ZDIS1j
      case(56)
         factor=-(nc**2-1d0)/nc**4*facRV    ! u em -> em g u          csBt1g1ZDIS1j
      case(57)
         factor=-(nc**2-1d0)/nc**4*ndown*facRV   ! g em -> em db d         csBt1g1ZDIS1j
      case(58)
         factor=-(nc**2-1d0)/nc**4*nup*facRV   ! g em -> em ub u         csBt1g1ZDIS1j
      case(59)
         factor=-(nc**2-1d0)/nc**4*facRV    ! db em -> em db g        csBt1g1ZDIS1j
      case(60)
         factor=-(nc**2-1d0)/nc**4*facRV    ! ub em -> em ub g        csBt1g1ZDIS1j
      case(61)
         factor=-(nc**2-1d0)/nc**4*ndown/nf*facRV   ! Q em subtraction        csBt1g1ZDIS1j
      case(62)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facRV   ! Q em subtraction        csBt1g1ZDIS1j
      case(63)
         factor=-(nc**2-1d0)/nc**4*ndown/nf*facRV   ! Qb em subtraction       csBt1g1ZDIS1j
      case(64)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facRV   ! Qb em subtraction       csBt1g1ZDIS1j
      case(65)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! d em -> em g d          csBh1g1ZDIS1j
      case(66)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! u em -> em g u          csBh1g1ZDIS1j
      case(67)
         factor=(nc**2-1d0)/nc**3*nf*ndown*facRV   ! g em -> em db d         csBh1g1ZDIS1j
      case(68)
         factor=(nc**2-1d0)/nc**3*nf*nup*facRV   ! g em -> em ub u         csBh1g1ZDIS1j
      case(69)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! db em -> em db g        csBh1g1ZDIS1j
      case(70)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! ub em -> em ub g        csBh1g1ZDIS1j
      case(71)
         factor=(nc**2-1d0)/nc**3*ndown*facRV   ! Q em subtraction        csBh1g1ZDIS1j
      case(72)
         factor=(nc**2-1d0)/nc**3*nup*facRV   ! Q em subtraction        csBh1g1ZDIS1j
      case(73)
         factor=(nc**2-1d0)/nc**3*ndown*facRV   ! Qb em subtraction       csBh1g1ZDIS1j
      case(74)
         factor=(nc**2-1d0)/nc**3*nup*facRV   ! Qb em subtraction       csBh1g1ZDIS1j

c -- double virtual

      case(75)
         factor=(nc**2-1d0)/nc**2*facVV     ! d em -> em d            B0g2ZDIS1j
      case(76)
         factor=(nc**2-1d0)/nc**2*facVV     ! u em -> em u            B0g2ZDIS1j
      case(77)
         factor=(nc**2-1d0)/nc**2*facVV     ! db em -> em db          B0g2ZDIS1j
      case(78)
         factor=(nc**2-1d0)/nc**2*facVV     ! ub em -> em ub          B0g2ZDIS1j
      case(79)
         factor=(nc**2-1d0)/nc**2*ndown/nf*facVV   ! Q em subtraction        B0g2ZDIS1j
      case(80)
         factor=(nc**2-1d0)/nc**2/nf*nup*facVV   ! Q em subtraction        B0g2ZDIS1j
      case(81)
         factor=(nc**2-1d0)/nc**2*ndown/nf*facVV   ! Qb em subtraction       B0g2ZDIS1j
      case(82)
         factor=(nc**2-1d0)/nc**2/nf*nup*facVV   ! Qb em subtraction       B0g2ZDIS1j
      case(83)
         factor=(nc**2-1d0)/nc**2*ndown*facVV   ! g em subtraction        B0g2ZDIS1j
      case(84)
         factor=(nc**2-1d0)/nc**2*nup*facVV   ! g em subtraction        B0g2ZDIS1j
      case(85)
         factor=-(nc**2-1d0)/nc**4*facVV    ! d em -> em d            Bt0g2ZDIS1j
      case(86)
         factor=-(nc**2-1d0)/nc**4*facVV    ! u em -> em u            Bt0g2ZDIS1j
      case(87)
         factor=-(nc**2-1d0)/nc**4*facVV    ! db em -> em db          Bt0g2ZDIS1j
      case(88)
         factor=-(nc**2-1d0)/nc**4*facVV    ! ub em -> em ub          Bt0g2ZDIS1j
      case(89)
         factor=-(nc**2-1d0)/nc**4*ndown/nf*facVV   ! Q em subtraction        Bt0g2ZDIS1j
      case(90)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facVV   ! Q em subtraction        Bt0g2ZDIS1j
      case(91)
         factor=-(nc**2-1d0)/nc**4*ndown/nf*facVV   ! Qb em subtraction       Bt0g2ZDIS1j
      case(92)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facVV   ! Qb em subtraction       Bt0g2ZDIS1j
      case(93)
         factor=-(nc**2-1d0)/nc**4*ndown*facVV   ! g em subtraction        Bt0g2ZDIS1j
      case(94)
         factor=-(nc**2-1d0)/nc**4*nup*facVV   ! g em subtraction        Bt0g2ZDIS1j
      case(95)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! d em -> em d            Bh0g2ZDIS1j
      case(96)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! u em -> em u            Bh0g2ZDIS1j
      case(97)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! db em -> em db          Bh0g2ZDIS1j
      case(98)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! ub em -> em ub          Bh0g2ZDIS1j
      case(99)
         factor=(nc**2-1d0)/nc**3*ndown*facVV   ! Q em subtraction        Bh0g2ZDIS1j
      case(100)
         factor=(nc**2-1d0)/nc**3*nup*facVV   ! Q em subtraction        Bh0g2ZDIS1j
      case(101)
         factor=(nc**2-1d0)/nc**3*ndown*facVV   ! Qb em subtraction       Bh0g2ZDIS1j
      case(102)
         factor=(nc**2-1d0)/nc**3*nup*facVV   ! Qb em subtraction       Bh0g2ZDIS1j
      case(103)
         factor=(nc**2-1d0)/nc**3*ndown*nf*facVV   ! g em subtraction        Bh0g2ZDIS1j
      case(104)
         factor=(nc**2-1d0)/nc**3*nf*nup*facVV   ! g em subtraction        Bh0g2ZDIS1j
      end select
      factor=relfactor*factor

      return
      end
