      subroutine selectchannelDIS1j()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*amz)**2*nc*4d0
      n_alphas_proc = 0
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelDIS1j: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelDIS1j: already allocated'  
        stop
      end if

      ntot_chan = 104

      allocate(qactive_chan(1:104))
      allocate(contrib_chan(1:104))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! d em to em d          B0g0Z(1,4,3,2)        
c      qactive_chan(2)  = .true.   ! u em to em u          B0g0Z(1,4,3,2)        
c      qactive_chan(3)  = .true.   ! db em to em db        B0g0Z(4,1,3,2)        
c      qactive_chan(4)  = .true.   ! ub em to em ub        B0g0Z(4,1,3,2)        

      do i=1,4
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(5)  = .true.   ! d em to em g d        B1g0ZDIS1j(1,4,5,3,2)  qemB1g0ZDIS1jSNLO(1,4,5,3,2)
c      qactive_chan(6)  = .true.   ! u em to em g u        B1g0ZDIS1j(1,4,5,3,2)  qemB1g0ZDIS1jSNLO(1,4,5,3,2)
c      qactive_chan(7)  = .true.   ! g em to em db d       B1g0ZDIS1j(4,1,5,3,2)  gemB1g0ZDIS1jSNLO(4,1,5,3,2)
c      qactive_chan(8)  = .true.   ! g em to em ub u       B1g0ZDIS1j(4,1,5,3,2)  gemB1g0ZDIS1jSNLO(4,1,5,3,2)
c      qactive_chan(9)  = .true.   ! db em to em db g      B1g0ZDIS1j(4,5,1,3,2)  qbemB1g0ZDIS1jSNLO(4,5,1,3,2)
c      qactive_chan(10) = .true.   ! ub em to em ub g      B1g0ZDIS1j(4,5,1,3,2)  qbemB1g0ZDIS1jSNLO(4,5,1,3,2)

      do i=5,10
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(11) = .true.   ! d em to em d          B0g1ZDIS1j(1,4,3,2)   qemB0g1ZDIS1jTNLO(1,4,3,2)
c      qactive_chan(12) = .true.   ! u em to em u          B0g1ZDIS1j(1,4,3,2)   qemB0g1ZDIS1jTNLO(1,4,3,2)
c      qactive_chan(13) = .true.   ! db em to em db        B0g1ZDIS1j(4,1,3,2)   qbemB0g1ZDIS1jTNLO(4,1,3,2)
c      qactive_chan(14) = .true.   ! ub em to em ub        B0g1ZDIS1j(4,1,3,2)   qbemB0g1ZDIS1jTNLO(4,1,3,2)
c      qactive_chan(15) = .true.   ! Q em subtraction                            qpemB0g1ZDIS1jTNLO(1,4,3,2)
c      qactive_chan(16) = .true.   ! Q em subtraction                            qpemB0g1ZDIS1jTNLO(1,4,3,2)
c      qactive_chan(17) = .true.   ! Qb em subtraction                           qpbemB0g1ZDIS1jTNLO(1,4,3,2)
c      qactive_chan(18) = .true.   ! Qb em subtraction                           qpbemB0g1ZDIS1jTNLO(1,4,3,2)
c      qactive_chan(19) = .true.   ! g em subtraction                            gemB0g1ZDIS1jTNLO(1,4,3,2)
c      qactive_chan(20) = .true.   ! g em subtraction                            gemB0g1ZDIS1jTNLO(1,4,3,2)

      do i=11,20
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(21) = .true.   ! d em to em g g d      csB2g0ZDIS1j(1,4,5,6,3,2)  qemcsB2g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(22) = .true.   ! u em to em g g u      csB2g0ZDIS1j(1,4,5,6,3,2)  qemcsB2g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(23) = .true.   ! g em to em db g d     csB2g0ZDIS1j(4,1,5,6,3,2)  gemcsB2g0ZDIS1jS(4,1,5,6,3,2)
c      qactive_chan(24) = .true.   ! g em to em ub g u     csB2g0ZDIS1j(4,1,5,6,3,2)  gemcsB2g0ZDIS1jS(4,1,5,6,3,2)
c      qactive_chan(25) = .true.   ! db em to em db g g    csB2g0ZDIS1j(4,5,6,1,3,2)  qbemcsB2g0ZDIS1jS(4,5,6,1,3,2)
c      qactive_chan(26) = .true.   ! ub em to em ub g g    csB2g0ZDIS1j(4,5,6,1,3,2)  qbemcsB2g0ZDIS1jS(4,5,6,1,3,2)
c      qactive_chan(27) = .true.   ! d em to em gt gt d    csBt2g0ZDIS1j(1,4,5,6,3,2)  qemcsBt2g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(28) = .true.   ! u em to em gt gt u    csBt2g0ZDIS1j(1,4,5,6,3,2)  qemcsBt2g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(29) = .true.   ! gt em to em db gt d   csBt2g0ZDIS1j(4,1,5,6,3,2)  gtemcsBt2g0ZDIS1jS(4,1,5,6,3,2)
c      qactive_chan(30) = .true.   ! gt em to em ub gt u   csBt2g0ZDIS1j(4,1,5,6,3,2)  gtemcsBt2g0ZDIS1jS(4,1,5,6,3,2)
c      qactive_chan(31) = .true.   ! db em to em db gt gt   csBt2g0ZDIS1j(4,5,6,1,3,2)  qbemcsBt2g0ZDIS1jS(4,5,6,1,3,2)
c      qactive_chan(32) = .true.   ! ub em to em ub gt gt   csBt2g0ZDIS1j(4,5,6,1,3,2)  qbemcsBt2g0ZDIS1jS(4,5,6,1,3,2)
c      qactive_chan(33) = .true.   ! d em to em d db d     sC0g0ZDIS1j(1,4,5,6,3,2)  qemsC0g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(34) = .true.   ! d em to em u ub d     sC0g0ZDIS1j(1,4,5,6,3,2)  qemsC0g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(35) = .true.   ! u em to em d db u     sC0g0ZDIS1j(1,4,5,6,3,2)  qemsC0g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(36) = .true.   ! u em to em u ub u     sC0g0ZDIS1j(1,4,5,6,3,2)  qemsC0g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(37) = .true.   ! db em to em db d db   sC0g0ZDIS1j(4,5,6,1,3,2)  qbemsC0g0ZDIS1jS(4,5,6,1,3,2)
c      qactive_chan(38) = .true.   ! db em to em db u ub   sC0g0ZDIS1j(4,5,6,1,3,2)  qbemsC0g0ZDIS1jS(4,5,6,1,3,2)
c      qactive_chan(39) = .true.   ! ub em to em ub d db   sC0g0ZDIS1j(4,5,6,1,3,2)  qbemsC0g0ZDIS1jS(4,5,6,1,3,2)
c      qactive_chan(40) = .true.   ! ub em to em ub u ub   sC0g0ZDIS1j(4,5,6,1,3,2)  qbemsC0g0ZDIS1jS(4,5,6,1,3,2)
c      qactive_chan(41) = .true.   ! d em to em d db d     D0g0ZDIS1j(1,4,5,6,3,2)  qemD0g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(42) = .true.   ! u em to em u ub u     D0g0ZDIS1j(1,4,5,6,3,2)  qemD0g0ZDIS1jS(1,4,5,6,3,2)
c      qactive_chan(43) = .true.   ! db em to em db db d   D0g0ZDIS1j(4,1,5,6,3,2)  qbemD0g0ZDIS1jS(4,1,5,6,3,2)
c      qactive_chan(44) = .true.   ! ub em to em ub ub u   D0g0ZDIS1j(4,1,5,6,3,2)  qbemD0g0ZDIS1jS(4,1,5,6,3,2)

      do i=21,44
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(45) = .true.   ! d em to em g d        csB1g1ZDIS1j(1,4,5,3,2)  qemcsB1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(46) = .true.   ! u em to em g u        csB1g1ZDIS1j(1,4,5,3,2)  qemcsB1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(47) = .true.   ! g em to em db d       csB1g1ZDIS1j(4,1,5,3,2)  gemcsB1g1ZDIS1jT(4,1,5,3,2)
c      qactive_chan(48) = .true.   ! g em to em ub u       csB1g1ZDIS1j(4,1,5,3,2)  gemcsB1g1ZDIS1jT(4,1,5,3,2)
c      qactive_chan(49) = .true.   ! db em to em db g      csB1g1ZDIS1j(4,5,1,3,2)  qbemcsB1g1ZDIS1jT(4,5,1,3,2)
c      qactive_chan(50) = .true.   ! ub em to em ub g      csB1g1ZDIS1j(4,5,1,3,2)  qbemcsB1g1ZDIS1jT(4,5,1,3,2)
c      qactive_chan(51) = .true.   ! Q em subtraction                            qpemcsB1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(52) = .true.   ! Q em subtraction                            qpemcsB1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(53) = .true.   ! Qb em subtraction                           qpbemcsB1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(54) = .true.   ! Qb em subtraction                           qpbemcsB1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(55) = .true.   ! d em to em g d        csBt1g1ZDIS1j(1,4,5,3,2)  qemcsBt1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(56) = .true.   ! u em to em g u        csBt1g1ZDIS1j(1,4,5,3,2)  qemcsBt1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(57) = .true.   ! g em to em db d       csBt1g1ZDIS1j(4,1,5,3,2)  gemcsBt1g1ZDIS1jT(4,1,5,3,2)
c      qactive_chan(58) = .true.   ! g em to em ub u       csBt1g1ZDIS1j(4,1,5,3,2)  gemcsBt1g1ZDIS1jT(4,1,5,3,2)
c      qactive_chan(59) = .true.   ! db em to em db g      csBt1g1ZDIS1j(4,5,1,3,2)  qbemcsBt1g1ZDIS1jT(4,5,1,3,2)
c      qactive_chan(60) = .true.   ! ub em to em ub g      csBt1g1ZDIS1j(4,5,1,3,2)  qbemcsBt1g1ZDIS1jT(4,5,1,3,2)
c      qactive_chan(61) = .true.   ! Q em subtraction                            qpemcsBt1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(62) = .true.   ! Q em subtraction                            qpemcsBt1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(63) = .true.   ! Qb em subtraction                           qpbemcsBt1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(64) = .true.   ! Qb em subtraction                           qpbemcsBt1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(65) = .true.   ! d em to em g d        csBh1g1ZDIS1j(1,4,5,3,2)  qemcsBh1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(66) = .true.   ! u em to em g u        csBh1g1ZDIS1j(1,4,5,3,2)  qemcsBh1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(67) = .true.   ! g em to em db d       csBh1g1ZDIS1j(4,1,5,3,2)  gemcsBh1g1ZDIS1jT(4,1,5,3,2)
c      qactive_chan(68) = .true.   ! g em to em ub u       csBh1g1ZDIS1j(4,1,5,3,2)  gemcsBh1g1ZDIS1jT(4,1,5,3,2)
c      qactive_chan(69) = .true.   ! db em to em db g      csBh1g1ZDIS1j(4,5,1,3,2)  qbemcsBh1g1ZDIS1jT(4,5,1,3,2)
c      qactive_chan(70) = .true.   ! ub em to em ub g      csBh1g1ZDIS1j(4,5,1,3,2)  qbemcsBh1g1ZDIS1jT(4,5,1,3,2)
c      qactive_chan(71) = .true.   ! Q em subtraction                            qpemcsBh1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(72) = .true.   ! Q em subtraction                            qpemcsBh1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(73) = .true.   ! Qb em subtraction                           qpbemcsBh1g1ZDIS1jT(1,4,5,3,2)
c      qactive_chan(74) = .true.   ! Qb em subtraction                           qpbemcsBh1g1ZDIS1jT(1,4,5,3,2)

      do i=45,74
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(75) = .true.   ! d em to em d          B0g2ZDIS1j(1,4,3,2)   qemB0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(76) = .true.   ! u em to em u          B0g2ZDIS1j(1,4,3,2)   qemB0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(77) = .true.   ! db em to em db        B0g2ZDIS1j(4,1,3,2)   qbemB0g2ZDIS1jU(4,1,3,2)
c      qactive_chan(78) = .true.   ! ub em to em ub        B0g2ZDIS1j(4,1,3,2)   qbemB0g2ZDIS1jU(4,1,3,2)
c      qactive_chan(79) = .true.   ! Q em subtraction                            qpemB0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(80) = .true.   ! Q em subtraction                            qpemB0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(81) = .true.   ! Qb em subtraction                           qpbemB0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(82) = .true.   ! Qb em subtraction                           qpbemB0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(83) = .true.   ! g em subtraction                            gemB0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(84) = .true.   ! g em subtraction                            gemB0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(85) = .true.   ! d em to em d          Bt0g2ZDIS1j(1,4,3,2)  qemBt0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(86) = .true.   ! u em to em u          Bt0g2ZDIS1j(1,4,3,2)  qemBt0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(87) = .true.   ! db em to em db        Bt0g2ZDIS1j(4,1,3,2)  qbemBt0g2ZDIS1jU(4,1,3,2)
c      qactive_chan(88) = .true.   ! ub em to em ub        Bt0g2ZDIS1j(4,1,3,2)  qbemBt0g2ZDIS1jU(4,1,3,2)
c      qactive_chan(89) = .true.   ! Q em subtraction                            qpemBt0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(90) = .true.   ! Q em subtraction                            qpemBt0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(91) = .true.   ! Qb em subtraction                           qpbemBt0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(92) = .true.   ! Qb em subtraction                           qpbemBt0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(93) = .true.   ! g em subtraction                            gemBt0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(94) = .true.   ! g em subtraction                            gemBt0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(95) = .true.   ! d em to em d          Bh0g2ZDIS1j(1,4,3,2)  qemBh0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(96) = .true.   ! u em to em u          Bh0g2ZDIS1j(1,4,3,2)  qemBh0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(97) = .true.   ! db em to em db        Bh0g2ZDIS1j(4,1,3,2)  qbemBh0g2ZDIS1jU(4,1,3,2)
c      qactive_chan(98) = .true.   ! ub em to em ub        Bh0g2ZDIS1j(4,1,3,2)  qbemBh0g2ZDIS1jU(4,1,3,2)
c      qactive_chan(99) = .true.   ! Q em subtraction                            qpemBh0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(100)= .true.   ! Q em subtraction                            qpemBh0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(101)= .true.   ! Qb em subtraction                           qpbemBh0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(102)= .true.   ! Qb em subtraction                           qpbemBh0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(103)= .true.   ! g em subtraction                            gemBh0g2ZDIS1jU(1,4,3,2)
c      qactive_chan(104)= .true.   ! g em subtraction                            gemBh0g2ZDIS1jU(1,4,3,2)

      do i=75,104
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelDIS1j(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'd em to em d        '
        me_str   = 'B0g0Z(1,4,3,2)      '
        sub_str  = ''

      case (2)
        chan_str = 'u em to em u        '
        me_str   = 'B0g0Z(1,4,3,2)      '
        sub_str  = ''

      case (3)
        chan_str = 'db em to em db      '
        me_str   = 'B0g0Z(4,1,3,2)      '
        sub_str  = ''

      case (4)
        chan_str = 'ub em to em ub      '
        me_str   = 'B0g0Z(4,1,3,2)      '
        sub_str  = ''

      case (5)
        chan_str = 'd em to em g d      '
        me_str   = 'B1g0ZDIS1j(1,4,5,3,2)'
        sub_str  = 'qemB1g0ZDIS1jSNLO(1,4,5,3,2)'

      case (6)
        chan_str = 'u em to em g u      '
        me_str   = 'B1g0ZDIS1j(1,4,5,3,2)'
        sub_str  = 'qemB1g0ZDIS1jSNLO(1,4,5,3,2)'

      case (7)
        chan_str = 'g em to em db d     '
        me_str   = 'B1g0ZDIS1j(4,1,5,3,2)'
        sub_str  = 'gemB1g0ZDIS1jSNLO(4,1,5,3,2)'

      case (8)
        chan_str = 'g em to em ub u     '
        me_str   = 'B1g0ZDIS1j(4,1,5,3,2)'
        sub_str  = 'gemB1g0ZDIS1jSNLO(4,1,5,3,2)'

      case (9)
        chan_str = 'db em to em db g    '
        me_str   = 'B1g0ZDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemB1g0ZDIS1jSNLO(4,5,1,3,2)'

      case (10)
        chan_str = 'ub em to em ub g    '
        me_str   = 'B1g0ZDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemB1g0ZDIS1jSNLO(4,5,1,3,2)'

      case (11)
        chan_str = 'd em to em d        '
        me_str   = 'B0g1ZDIS1j(1,4,3,2) '
        sub_str  = 'qemB0g1ZDIS1jTNLO(1,4,3,2)'

      case (12)
        chan_str = 'u em to em u        '
        me_str   = 'B0g1ZDIS1j(1,4,3,2) '
        sub_str  = 'qemB0g1ZDIS1jTNLO(1,4,3,2)'

      case (13)
        chan_str = 'db em to em db      '
        me_str   = 'B0g1ZDIS1j(4,1,3,2) '
        sub_str  = 'qbemB0g1ZDIS1jTNLO(4,1,3,2)'

      case (14)
        chan_str = 'ub em to em ub      '
        me_str   = 'B0g1ZDIS1j(4,1,3,2) '
        sub_str  = 'qbemB0g1ZDIS1jTNLO(4,1,3,2)'

      case (15)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB0g1ZDIS1jTNLO(1,4,3,2)'

      case (16)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB0g1ZDIS1jTNLO(1,4,3,2)'

      case (17)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB0g1ZDIS1jTNLO(1,4,3,2)'

      case (18)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB0g1ZDIS1jTNLO(1,4,3,2)'

      case (19)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemB0g1ZDIS1jTNLO(1,4,3,2)'

      case (20)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemB0g1ZDIS1jTNLO(1,4,3,2)'

      case (21)
        chan_str = 'd em to em g g d    '
        me_str   = 'csB2g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemcsB2g0ZDIS1jS(1,4,5,6,3,2)'

      case (22)
        chan_str = 'u em to em g g u    '
        me_str   = 'csB2g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemcsB2g0ZDIS1jS(1,4,5,6,3,2)'

      case (23)
        chan_str = 'g em to em db g d   '
        me_str   = 'csB2g0ZDIS1j(4,1,5,6,3,2)'
        sub_str  = 'gemcsB2g0ZDIS1jS(4,1,5,6,3,2)'

      case (24)
        chan_str = 'g em to em ub g u   '
        me_str   = 'csB2g0ZDIS1j(4,1,5,6,3,2)'
        sub_str  = 'gemcsB2g0ZDIS1jS(4,1,5,6,3,2)'

      case (25)
        chan_str = 'db em to em db g g  '
        me_str   = 'csB2g0ZDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemcsB2g0ZDIS1jS(4,5,6,1,3,2)'

      case (26)
        chan_str = 'ub em to em ub g g  '
        me_str   = 'csB2g0ZDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemcsB2g0ZDIS1jS(4,5,6,1,3,2)'

      case (27)
        chan_str = 'd em to em gt gt d  '
        me_str   = 'csBt2g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemcsBt2g0ZDIS1jS(1,4,5,6,3,2)'

      case (28)
        chan_str = 'u em to em gt gt u  '
        me_str   = 'csBt2g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemcsBt2g0ZDIS1jS(1,4,5,6,3,2)'

      case (29)
        chan_str = 'gt em to em db gt d '
        me_str   = 'csBt2g0ZDIS1j(4,1,5,6,3,2)'
        sub_str  = 'gtemcsBt2g0ZDIS1jS(4,1,5,6,3,2)'

      case (30)
        chan_str = 'gt em to em ub gt u '
        me_str   = 'csBt2g0ZDIS1j(4,1,5,6,3,2)'
        sub_str  = 'gtemcsBt2g0ZDIS1jS(4,1,5,6,3,2)'

      case (31)
        chan_str = 'db em to em db gt gt '
        me_str   = 'csBt2g0ZDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemcsBt2g0ZDIS1jS(4,5,6,1,3,2)'

      case (32)
        chan_str = 'ub em to em ub gt gt '
        me_str   = 'csBt2g0ZDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemcsBt2g0ZDIS1jS(4,5,6,1,3,2)'

      case (33)
        chan_str = 'd em to em d db d   '
        me_str   = 'sC0g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g0ZDIS1jS(1,4,5,6,3,2)'

      case (34)
        chan_str = 'd em to em u ub d   '
        me_str   = 'sC0g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g0ZDIS1jS(1,4,5,6,3,2)'

      case (35)
        chan_str = 'u em to em d db u   '
        me_str   = 'sC0g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g0ZDIS1jS(1,4,5,6,3,2)'

      case (36)
        chan_str = 'u em to em u ub u   '
        me_str   = 'sC0g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g0ZDIS1jS(1,4,5,6,3,2)'

      case (37)
        chan_str = 'db em to em db d db '
        me_str   = 'sC0g0ZDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g0ZDIS1jS(4,5,6,1,3,2)'

      case (38)
        chan_str = 'db em to em db u ub '
        me_str   = 'sC0g0ZDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g0ZDIS1jS(4,5,6,1,3,2)'

      case (39)
        chan_str = 'ub em to em ub d db '
        me_str   = 'sC0g0ZDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g0ZDIS1jS(4,5,6,1,3,2)'

      case (40)
        chan_str = 'ub em to em ub u ub '
        me_str   = 'sC0g0ZDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g0ZDIS1jS(4,5,6,1,3,2)'

      case (41)
        chan_str = 'd em to em d db d   '
        me_str   = 'D0g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemD0g0ZDIS1jS(1,4,5,6,3,2)'

      case (42)
        chan_str = 'u em to em u ub u   '
        me_str   = 'D0g0ZDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemD0g0ZDIS1jS(1,4,5,6,3,2)'

      case (43)
        chan_str = 'db em to em db db d '
        me_str   = 'D0g0ZDIS1j(4,1,5,6,3,2)'
        sub_str  = 'qbemD0g0ZDIS1jS(4,1,5,6,3,2)'

      case (44)
        chan_str = 'ub em to em ub ub u '
        me_str   = 'D0g0ZDIS1j(4,1,5,6,3,2)'
        sub_str  = 'qbemD0g0ZDIS1jS(4,1,5,6,3,2)'

      case (45)
        chan_str = 'd em to em g d      '
        me_str   = 'csB1g1ZDIS1j(1,4,5,3,2)'
        sub_str  = 'qemcsB1g1ZDIS1jT(1,4,5,3,2)'

      case (46)
        chan_str = 'u em to em g u      '
        me_str   = 'csB1g1ZDIS1j(1,4,5,3,2)'
        sub_str  = 'qemcsB1g1ZDIS1jT(1,4,5,3,2)'

      case (47)
        chan_str = 'g em to em db d     '
        me_str   = 'csB1g1ZDIS1j(4,1,5,3,2)'
        sub_str  = 'gemcsB1g1ZDIS1jT(4,1,5,3,2)'

      case (48)
        chan_str = 'g em to em ub u     '
        me_str   = 'csB1g1ZDIS1j(4,1,5,3,2)'
        sub_str  = 'gemcsB1g1ZDIS1jT(4,1,5,3,2)'

      case (49)
        chan_str = 'db em to em db g    '
        me_str   = 'csB1g1ZDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemcsB1g1ZDIS1jT(4,5,1,3,2)'

      case (50)
        chan_str = 'ub em to em ub g    '
        me_str   = 'csB1g1ZDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemcsB1g1ZDIS1jT(4,5,1,3,2)'

      case (51)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemcsB1g1ZDIS1jT(1,4,5,3,2)'

      case (52)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemcsB1g1ZDIS1jT(1,4,5,3,2)'

      case (53)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemcsB1g1ZDIS1jT(1,4,5,3,2)'

      case (54)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemcsB1g1ZDIS1jT(1,4,5,3,2)'

      case (55)
        chan_str = 'd em to em g d      '
        me_str   = 'csBt1g1ZDIS1j(1,4,5,3,2)'
        sub_str  = 'qemcsBt1g1ZDIS1jT(1,4,5,3,2)'

      case (56)
        chan_str = 'u em to em g u      '
        me_str   = 'csBt1g1ZDIS1j(1,4,5,3,2)'
        sub_str  = 'qemcsBt1g1ZDIS1jT(1,4,5,3,2)'

      case (57)
        chan_str = 'g em to em db d     '
        me_str   = 'csBt1g1ZDIS1j(4,1,5,3,2)'
        sub_str  = 'gemcsBt1g1ZDIS1jT(4,1,5,3,2)'

      case (58)
        chan_str = 'g em to em ub u     '
        me_str   = 'csBt1g1ZDIS1j(4,1,5,3,2)'
        sub_str  = 'gemcsBt1g1ZDIS1jT(4,1,5,3,2)'

      case (59)
        chan_str = 'db em to em db g    '
        me_str   = 'csBt1g1ZDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemcsBt1g1ZDIS1jT(4,5,1,3,2)'

      case (60)
        chan_str = 'ub em to em ub g    '
        me_str   = 'csBt1g1ZDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemcsBt1g1ZDIS1jT(4,5,1,3,2)'

      case (61)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemcsBt1g1ZDIS1jT(1,4,5,3,2)'

      case (62)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemcsBt1g1ZDIS1jT(1,4,5,3,2)'

      case (63)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemcsBt1g1ZDIS1jT(1,4,5,3,2)'

      case (64)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemcsBt1g1ZDIS1jT(1,4,5,3,2)'

      case (65)
        chan_str = 'd em to em g d      '
        me_str   = 'csBh1g1ZDIS1j(1,4,5,3,2)'
        sub_str  = 'qemcsBh1g1ZDIS1jT(1,4,5,3,2)'

      case (66)
        chan_str = 'u em to em g u      '
        me_str   = 'csBh1g1ZDIS1j(1,4,5,3,2)'
        sub_str  = 'qemcsBh1g1ZDIS1jT(1,4,5,3,2)'

      case (67)
        chan_str = 'g em to em db d     '
        me_str   = 'csBh1g1ZDIS1j(4,1,5,3,2)'
        sub_str  = 'gemcsBh1g1ZDIS1jT(4,1,5,3,2)'

      case (68)
        chan_str = 'g em to em ub u     '
        me_str   = 'csBh1g1ZDIS1j(4,1,5,3,2)'
        sub_str  = 'gemcsBh1g1ZDIS1jT(4,1,5,3,2)'

      case (69)
        chan_str = 'db em to em db g    '
        me_str   = 'csBh1g1ZDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemcsBh1g1ZDIS1jT(4,5,1,3,2)'

      case (70)
        chan_str = 'ub em to em ub g    '
        me_str   = 'csBh1g1ZDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemcsBh1g1ZDIS1jT(4,5,1,3,2)'

      case (71)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemcsBh1g1ZDIS1jT(1,4,5,3,2)'

      case (72)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemcsBh1g1ZDIS1jT(1,4,5,3,2)'

      case (73)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemcsBh1g1ZDIS1jT(1,4,5,3,2)'

      case (74)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemcsBh1g1ZDIS1jT(1,4,5,3,2)'

      case (75)
        chan_str = 'd em to em d        '
        me_str   = 'B0g2ZDIS1j(1,4,3,2) '
        sub_str  = 'qemB0g2ZDIS1jU(1,4,3,2)'

      case (76)
        chan_str = 'u em to em u        '
        me_str   = 'B0g2ZDIS1j(1,4,3,2) '
        sub_str  = 'qemB0g2ZDIS1jU(1,4,3,2)'

      case (77)
        chan_str = 'db em to em db      '
        me_str   = 'B0g2ZDIS1j(4,1,3,2) '
        sub_str  = 'qbemB0g2ZDIS1jU(4,1,3,2)'

      case (78)
        chan_str = 'ub em to em ub      '
        me_str   = 'B0g2ZDIS1j(4,1,3,2) '
        sub_str  = 'qbemB0g2ZDIS1jU(4,1,3,2)'

      case (79)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB0g2ZDIS1jU(1,4,3,2)'

      case (80)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB0g2ZDIS1jU(1,4,3,2)'

      case (81)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB0g2ZDIS1jU(1,4,3,2)'

      case (82)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB0g2ZDIS1jU(1,4,3,2)'

      case (83)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemB0g2ZDIS1jU(1,4,3,2)'

      case (84)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemB0g2ZDIS1jU(1,4,3,2)'

      case (85)
        chan_str = 'd em to em d        '
        me_str   = 'Bt0g2ZDIS1j(1,4,3,2)'
        sub_str  = 'qemBt0g2ZDIS1jU(1,4,3,2)'

      case (86)
        chan_str = 'u em to em u        '
        me_str   = 'Bt0g2ZDIS1j(1,4,3,2)'
        sub_str  = 'qemBt0g2ZDIS1jU(1,4,3,2)'

      case (87)
        chan_str = 'db em to em db      '
        me_str   = 'Bt0g2ZDIS1j(4,1,3,2)'
        sub_str  = 'qbemBt0g2ZDIS1jU(4,1,3,2)'

      case (88)
        chan_str = 'ub em to em ub      '
        me_str   = 'Bt0g2ZDIS1j(4,1,3,2)'
        sub_str  = 'qbemBt0g2ZDIS1jU(4,1,3,2)'

      case (89)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBt0g2ZDIS1jU(1,4,3,2)'

      case (90)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBt0g2ZDIS1jU(1,4,3,2)'

      case (91)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBt0g2ZDIS1jU(1,4,3,2)'

      case (92)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBt0g2ZDIS1jU(1,4,3,2)'

      case (93)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemBt0g2ZDIS1jU(1,4,3,2)'

      case (94)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemBt0g2ZDIS1jU(1,4,3,2)'

      case (95)
        chan_str = 'd em to em d        '
        me_str   = 'Bh0g2ZDIS1j(1,4,3,2)'
        sub_str  = 'qemBh0g2ZDIS1jU(1,4,3,2)'

      case (96)
        chan_str = 'u em to em u        '
        me_str   = 'Bh0g2ZDIS1j(1,4,3,2)'
        sub_str  = 'qemBh0g2ZDIS1jU(1,4,3,2)'

      case (97)
        chan_str = 'db em to em db      '
        me_str   = 'Bh0g2ZDIS1j(4,1,3,2)'
        sub_str  = 'qbemBh0g2ZDIS1jU(4,1,3,2)'

      case (98)
        chan_str = 'ub em to em ub      '
        me_str   = 'Bh0g2ZDIS1j(4,1,3,2)'
        sub_str  = 'qbemBh0g2ZDIS1jU(4,1,3,2)'

      case (99)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBh0g2ZDIS1jU(1,4,3,2)'

      case (100)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBh0g2ZDIS1jU(1,4,3,2)'

      case (101)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBh0g2ZDIS1jU(1,4,3,2)'

      case (102)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBh0g2ZDIS1jU(1,4,3,2)'

      case (103)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemBh0g2ZDIS1jU(1,4,3,2)'

      case (104)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemBh0g2ZDIS1jU(1,4,3,2)'

      case default
        print*, 'getchannelDIS1j: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtDIS1j(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtDIS1j = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (21)
        ! [em, g, g, d]
        LIPSwgtDIS1j = weight_lips((/ 4,5 /))

      case (22)
        ! [em, g, g, u]
        LIPSwgtDIS1j = weight_lips((/ 4,5 /))

      case (25)
        ! [em, db, g, g]
        LIPSwgtDIS1j = weight_lips((/ 5,6 /))

      case (26)
        ! [em, ub, g, g]
        LIPSwgtDIS1j = weight_lips((/ 5,6 /))

      case (27)
        ! [em, gt, gt, d]
        LIPSwgtDIS1j = weight_lips((/ 4,5 /))

      case (28)
        ! [em, gt, gt, u]
        LIPSwgtDIS1j = weight_lips((/ 4,5 /))

      case (31)
        ! [em, db, gt, gt]
        LIPSwgtDIS1j = weight_lips((/ 5,6 /))

      case (32)
        ! [em, ub, gt, gt]
        LIPSwgtDIS1j = weight_lips((/ 5,6 /))

      case (33)
        ! [em, d, db, d]
        LIPSwgtDIS1j = weight_lips((/ 4,6 /))

      case (36)
        ! [em, u, ub, u]
        LIPSwgtDIS1j = weight_lips((/ 4,6 /))

      case (37)
        ! [em, db, d, db]
        LIPSwgtDIS1j = weight_lips((/ 4,6 /))

      case (40)
        ! [em, ub, u, ub]
        LIPSwgtDIS1j = weight_lips((/ 4,6 /))

      case (41)
        ! [em, d, db, d]
        LIPSwgtDIS1j = weight_lips((/ 4,6 /))

      case (42)
        ! [em, u, ub, u]
        LIPSwgtDIS1j = weight_lips((/ 4,6 /))

      case (43)
        ! [em, db, db, d]
        LIPSwgtDIS1j = weight_lips((/ 4,5 /))

      case (44)
        ! [em, ub, ub, u]
        LIPSwgtDIS1j = weight_lips((/ 4,5 /))

      case default
        LIPSwgtDIS1j = 1

      end select
      end
