      function sigRDIS1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRDIS1j=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis1j(0,5,ipass)
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- d em to em g d 
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0ZDIS1j(1,4,5,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em g u 
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0ZDIS1j(1,4,5,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em db d 
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0ZDIS1j(4,1,5,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to em ub u 
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0ZDIS1j(4,1,5,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db g 
      if (qactive_chan(9).and.qselect_chan(9)) then
        current_chan = 9
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0ZDIS1j(4,5,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub g 
      if (qactive_chan(10).and.qselect_chan(10)) then
        current_chan = 10
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0ZDIS1j(4,5,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRDIS1j=rnorm*wtsum

      return
      end
