      function sigVDIS1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVDIS1j=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis1j(0,4,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(4, (/ 1, 2, 3, 4 /) )
#endif 

c--- d em to em d 
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,4,3,2 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B0g1ZDIS1j(1,4,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to em u 
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,4,3,2 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B0g1ZDIS1j(1,4,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to em db 
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 4,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B0g1ZDIS1j(4,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to em ub 
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 4,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B0g1ZDIS1j(4,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigVDIS1j=rnorm*wtsum

      return
      end
