      subroutine getlumiDISWp(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    4,    7,   10,   14,   17,   20,   25,          
     &           30,   35,   38,   41,   44,   49,   54,   58,          
     &           62,   66,   70,   75,   80,   85,   90,   95,          
     &          100,  105,  110,  114,  118,  122,  126,  130,          
     &          134,  141,  148,  155,  162,  169)
!       [40, -99]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)                                         
     &       + f1(3,1:nInp_scl)                                         

        case (    2,    5,    8,   21,   26,   31,   36,   39,          
     &           42,   45,   50,   55,   59,   63,   67,   71,          
     &           76,   81,   86,   91,   99,  104,  109,  113,          
     &          117,  121,  125,  129,  133,  135,  142,  149,          
     &          156,  163,  170)
!       [0, -99]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)                                         

        case (    3,    6,    9,   13,   16,   18,   22,   27,          
     &           32,   37,   40,   43,   48,   53,   57,   60,          
     &           65,   68,   72,   77,   82,   87,   92,   98,          
     &          103,  108,  112,  115,  120,  123,  128,  131,          
     &          136,  143,  150,  157,  164,  171)
!       [-20, -99]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)                                        
     &       + f1(-4,1:nInp_scl)                                        

        case (   11,   24,   29,   34,   46,   51,   74,   79,          
     &           84,   89,   94,   96,  101,  106,  138,  145,          
     &          152,  159,  166,  173)
!       [-30, -99]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)                                        
     &       + f1(-2,1:nInp_scl)                                        
     &       + f1(-3,1:nInp_scl)                                        
     &       + f1(-4,1:nInp_scl)                                        
     &       + f1(-5,1:nInp_scl)                                        

        case (   12,   23,   28,   33,   47,   52,   73,   78,          
     &           83,   88,   93,   97,  102,  107,  137,  144,          
     &          151,  158,  165,  172)
!       [30, -99]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)                                         
     &       + f1(2,1:nInp_scl)                                         
     &       + f1(3,1:nInp_scl)                                         
     &       + f1(4,1:nInp_scl)                                         
     &       + f1(5,1:nInp_scl)                                         

        case (   15,   56,   64,  111,  119,  127,  139,  146,          
     &          153,  160,  167,  174)
!       [-40, -99]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)                                        
     &       + f1(-3,1:nInp_scl)                                        

        case (   19,   61,   69,  116,  124,  132,  140,  147,          
     &          154,  161,  168,  175)
!       [20, -99]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)                                         
     &       + f1(4,1:nInp_scl)                                         

        case default
          print*, "getlumiDISWp: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiDISWp



      function getlumiidDISWp(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    4,    7,   10,   14,   17,   20,   25,
     &           30,   35,   38,   41,   44,   49,   54,   58,
     &           62,   66,   70,   75,   80,   85,   90,   95,
     &          100,  105,  110,  114,  118,  122,  126,  130,
     &          134,  141,  148,  155,  162,  169)
          id  = 1
          ip1 = 40
          ip2 = -99

        case (    2,    5,    8,   21,   26,   31,   36,   39,
     &           42,   45,   50,   55,   59,   63,   67,   71,
     &           76,   81,   86,   91,   99,  104,  109,  113,
     &          117,  121,  125,  129,  133,  135,  142,  149,
     &          156,  163,  170)
          id  = 2
          ip1 = 0
          ip2 = -99

        case (    3,    6,    9,   13,   16,   18,   22,   27,
     &           32,   37,   40,   43,   48,   53,   57,   60,
     &           65,   68,   72,   77,   82,   87,   92,   98,
     &          103,  108,  112,  115,  120,  123,  128,  131,
     &          136,  143,  150,  157,  164,  171)
          id  = 3
          ip1 = -20
          ip2 = -99

        case (   11,   24,   29,   34,   46,   51,   74,   79,
     &           84,   89,   94,   96,  101,  106,  138,  145,
     &          152,  159,  166,  173)
          id  = 4
          ip1 = -30
          ip2 = -99

        case (   12,   23,   28,   33,   47,   52,   73,   78,
     &           83,   88,   93,   97,  102,  107,  137,  144,
     &          151,  158,  165,  172)
          id  = 5
          ip1 = 30
          ip2 = -99

        case (   15,   56,   64,  111,  119,  127,  139,  146,
     &          153,  160,  167,  174)
          id  = 6
          ip1 = -40
          ip2 = -99

        case (   19,   61,   69,  116,  124,  132,  140,  147,
     &          154,  161,  168,  175)
          id  = 7
          ip1 = 20
          ip2 = -99

        case default
          print*, "getlumiidDISWp: invalid iproc:", iproc
          stop
        end select

      end function getlumiidDISWp





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiDISWp()
        use PineAPPL_mod
        use CKM_mod
!       [40, -99]
        call register_lumi_pine(
     &         [    1,    4,    7,   10,   14,   17,   20,   25,
     &             30,   35,   38,   41,   44,   49,   54,   58,
     &             62,   66,   70,   75,   80,   85,   90,   95,
     &            100,  105,  110,  114,  118,  122,  126,  130,
     &            134,  141,  148,  155,  162,  169],
     &         2,
     &         [    1,  -99,    3,  -99],
     &         [  1d0,  1d0]
     &       )

!       [0, -99]
        call register_lumi_pine(
     &         [    2,    5,    8,   21,   26,   31,   36,   39,
     &             42,   45,   50,   55,   59,   63,   67,   71,
     &             76,   81,   86,   91,   99,  104,  109,  113,
     &            117,  121,  125,  129,  133,  135,  142,  149,
     &            156,  163,  170],
     &         1,
     &         [   21,  -99],
     &         [  1d0]
     &       )

!       [-20, -99]
        call register_lumi_pine(
     &         [    3,    6,    9,   13,   16,   18,   22,   27,
     &             32,   37,   40,   43,   48,   53,   57,   60,
     &             65,   68,   72,   77,   82,   87,   92,   98,
     &            103,  108,  112,  115,  120,  123,  128,  131,
     &            136,  143,  150,  157,  164,  171],
     &         2,
     &         [   -2,  -99,   -4,  -99],
     &         [  1d0,  1d0]
     &       )

!       [-30, -99]
        call register_lumi_pine(
     &         [   11,   24,   29,   34,   46,   51,   74,   79,
     &             84,   89,   94,   96,  101,  106,  138,  145,
     &            152,  159,  166,  173],
     &         5,
     &         [   -1,  -99,   -2,  -99,   -3,  -99,   -4,  -99,
     &             -5,  -99],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [30, -99]
        call register_lumi_pine(
     &         [   12,   23,   28,   33,   47,   52,   73,   78,
     &             83,   88,   93,   97,  102,  107,  137,  144,
     &            151,  158,  165,  172],
     &         5,
     &         [    1,  -99,    2,  -99,    3,  -99,    4,  -99,
     &              5,  -99],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-40, -99]
        call register_lumi_pine(
     &         [   15,   56,   64,  111,  119,  127,  139,  146,
     &            153,  160,  167,  174],
     &         2,
     &         [   -1,  -99,   -3,  -99],
     &         [  1d0,  1d0]
     &       )

!       [20, -99]
        call register_lumi_pine(
     &         [   19,   61,   69,  116,  124,  132,  140,  147,
     &            154,  161,  168,  175],
     &         2,
     &         [    2,  -99,    4,  -99],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiDISWp


#endif


