      subroutine getqcdnormDISWm(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtDISWm(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_dis(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVDISWm
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourDISWm(current_chan)
         do isub = 1, nflavourDISWm(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_DISWm(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=DISWm "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param()/stw)**2*(nc**2-1)
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! u em -> enu g d         B1g0WDIS
      case(2)
         factor=nup*facB                    ! g em -> enu ub d        B1g0WDIS
      case(3)
         factor=facB                        ! db em -> enu ub g       B1g0WDIS

c -- real

      case(4)
         factor=1d0/2d0*facR                ! u em -> enu g g d       B2g0WDIS
      case(5)
         factor=nup*facR                    ! g em -> enu ub g d      B2g0WDIS
      case(6)
         factor=1d0/2d0*facR                ! db em -> enu ub g g     B2g0WDIS
      case(7)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u em -> enu gt gt d     Bt2g0WDIS
      case(8)
         factor=-1d0/nc**2*nup*facR         ! gt em -> enu ub gt d     Bt2g0WDIS
      case(9)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db em -> enu ub gt gt     Bt2g0WDIS
      case(10)
         factor=1d0/nc*nf*facR              ! u em -> enu Q Qb d      C0g0WDIS
      case(11)
         factor=1d0/nc*nup*facR             ! Qb em -> enu ub Qb d     C0g0WDIS
      case(12)
         factor=1d0/nc*nup*facR             ! Q em -> enu ub Q d      C0g0WDIS
      case(13)
         factor=1d0/nc*nf*facR              ! db em -> enu ub Q Qb     C0g0WDIS
      case(14)
         factor=-1d0/nc**2*facR             ! u em -> enu u ub d      D0g0WaDIS
      case(15)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub em -> enu ub ub d     D0g0WaDIS
      case(16)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db em -> enu ub u ub     D0g0WaDIS
      case(17)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u em -> enu d db d      D0g0WbDIS
      case(18)
         factor=-1d0/nc**2*facR             ! db em -> enu ub db d     D0g0WbDIS
      case(19)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d em -> enu ub d d      D0g0WbDIS

c -- virtual

      case(20)
         factor=facV                        ! u em -> enu g d         B1g1WDIS
      case(21)
         factor=nup*facV                    ! g em -> enu ub d        B1g1WDIS
      case(22)
         factor=facV                        ! db em -> enu ub g       B1g1WDIS
      case(23)
         factor=1d0/nf*nup*facV             ! Q em subtraction        B1g1WDIS
      case(24)
         factor=1d0/nf*nup*facV             ! Qb em subtraction       B1g1WDIS
      case(25)
         factor=-1d0/nc**2*facV             ! u em -> enu g d         Bt1g1WDIS
      case(26)
         factor=-1d0/nc**2*nup*facV         ! g em -> enu ub d        Bt1g1WDIS
      case(27)
         factor=-1d0/nc**2*facV             ! db em -> enu ub g       Bt1g1WDIS
      case(28)
         factor=-1d0/nc**2/nf*nup*facV      ! Q em subtraction        Bt1g1WDIS
      case(29)
         factor=-1d0/nc**2/nf*nup*facV      ! Qb em subtraction       Bt1g1WDIS
      case(30)
         factor=1d0/nc*nf*facV              ! u em -> enu g d         Bh1g1WDIS
      case(31)
         factor=1d0/nc*nf*nup*facV          ! g em -> enu ub d        Bh1g1WDIS
      case(32)
         factor=1d0/nc*nf*facV              ! db em -> enu ub g       Bh1g1WDIS
      case(33)
         factor=1d0/nc*nup*facV             ! Q em subtraction        Bh1g1WDIS
      case(34)
         factor=1d0/nc*nup*facV             ! Qb em subtraction       Bh1g1WDIS

c -- double real

      case(35)
         factor=1d0/6d0*facRR               ! u em -> enu g g g d     sB3g0WDIS
      case(36)
         factor=1d0/2d0*nup*facRR           ! g em -> enu ub g g d     sB3g0WDIS
      case(37)
         factor=1d0/6d0*facRR               ! db em -> enu ub g g g     sB3g0WDIS
      case(38)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! u em -> enu g g g d     sBt3g0WDIS
      case(39)
         factor=-1d0/nc**2*1d0/2d0*nup*facRR   ! g em -> enu ub g g d     sBt3g0WDIS
      case(40)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! db em -> enu ub g g g     sBt3g0WDIS
      case(41)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! u em -> enu gt gt gt d     sBtt3g0WDIS
      case(42)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*nup*facRR   ! gt em -> enu ub gt gt d     sBtt3g0WDIS
      case(43)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! db em -> enu ub gt gt gt     sBtt3g0WDIS
      case(44)
         factor=1d0/nc*nf*facRR             ! u em -> enu g Q Qb d     sC1g0WDIS
      case(45)
         factor=1d0/nc*nf*nup*facRR         ! g em -> enu ub Q Qb d     sC1g0WDIS
      case(46)
         factor=1d0/nc*nup*facRR            ! Qb em -> enu ub g Qb d     sC1g0WDIS
      case(47)
         factor=1d0/nc*nup*facRR            ! Q em -> enu ub g Q d     sC1g0WDIS
      case(48)
         factor=1d0/nc*nf*facRR             ! db em -> enu ub g Q Qb     sC1g0WDIS
      case(49)
         factor=-1d0/nc**3*nf*facRR         ! u em -> enu g Q Qb d     sCt1g0WDIS
      case(50)
         factor=-1d0/nc**3*nf*nup*facRR     ! g em -> enu ub Q Qb d     sCt1g0WDIS
      case(51)
         factor=-1d0/nc**3*nup*facRR        ! Qb em -> enu ub g Qb d     sCt1g0WDIS
      case(52)
         factor=-1d0/nc**3*nup*facRR        ! Q em -> enu ub g Q d     sCt1g0WDIS
      case(53)
         factor=-1d0/nc**3*nf*facRR         ! db em -> enu ub g Q Qb     sCt1g0WDIS
      case(54)
         factor=-1d0/nc**2*facRR            ! u em -> enu g u ub d     D1g0WpacDIS
      case(55)
         factor=-1d0/nc**2*1d0/2d0*nup*facRR   ! g em -> enu ub u ub d     D1g0WpacDIS
      case(56)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub em -> enu ub g ub d     D1g0WpacDIS
      case(57)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db em -> enu ub g u ub     D1g0WpacDIS
      case(58)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u em -> enu g d db d     D1g0WpbcDIS
      case(59)
         factor=-1d0/nc**2*1d0/2d0*nup*facRR   ! g em -> enu ub d db d     D1g0WpbcDIS
      case(60)
         factor=-1d0/nc**2*facRR            ! db em -> enu ub g db d     D1g0WpbcDIS
      case(61)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d em -> enu ub g d d     D1g0WpbcDIS
      case(62)
         factor=1d0/nc**4*facRR             ! u em -> enu g u ub d     Dt1g0WpaDIS
      case(63)
         factor=1d0/nc**4*1d0/2d0*nup*facRR   ! g em -> enu ub u ub d     Dt1g0WpaDIS
      case(64)
         factor=1d0/nc**4*1d0/2d0*facRR     ! ub em -> enu ub g ub d     Dt1g0WpaDIS
      case(65)
         factor=1d0/nc**4*1d0/2d0*facRR     ! db em -> enu ub g u ub     Dt1g0WpaDIS
      case(66)
         factor=1d0/nc**4*1d0/2d0*facRR     ! u em -> enu g d db d     Dt1g0WpbDIS
      case(67)
         factor=1d0/nc**4*1d0/2d0*nup*facRR   ! g em -> enu ub d db d     Dt1g0WpbDIS
      case(68)
         factor=1d0/nc**4*facRR             ! db em -> enu ub g db d     Dt1g0WpbDIS
      case(69)
         factor=1d0/nc**4*1d0/2d0*facRR     ! d em -> enu ub g d d     Dt1g0WpbDIS

c -- real virtual

      case(70)
         factor=1d0/2d0*facRV               ! u em -> enu g g d       sB2g1WDIS
      case(71)
         factor=nup*facRV                   ! g em -> enu ub g d      sB2g1WDIS
      case(72)
         factor=1d0/2d0*facRV               ! db em -> enu ub g g     sB2g1WDIS
      case(73)
         factor=1d0/nf*nup*facRV            ! Q em subtraction        sB2g1WDIS
      case(74)
         factor=1d0/nf*nup*facRV            ! Qb em subtraction       sB2g1WDIS
      case(75)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! u em -> enu gt gt d     sBt2g1WDIS
      case(76)
         factor=-1d0/nc**2*nup*facRV        ! gt em -> enu ub gt d     sBt2g1WDIS
      case(77)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! db em -> enu ub gt gt     sBt2g1WDIS
      case(78)
         factor=-1d0/nc**2/nf*nup*facRV     ! Q em subtraction        sBt2g1WDIS
      case(79)
         factor=-1d0/nc**2/nf*nup*facRV     ! Qb em subtraction       sBt2g1WDIS
      case(80)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u em -> enu gt gt d     sBttt2g1WDIS
      case(81)
         factor=1d0/nc**4*nup*facRV         ! gt em -> enu ub gt d     sBttt2g1WDIS
      case(82)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db em -> enu ub gt gt     sBttt2g1WDIS
      case(83)
         factor=1d0/nc**4/nf*nup*facRV      ! Q em subtraction        sBttt2g1WDIS
      case(84)
         factor=1d0/nc**4/nf*nup*facRV      ! Qb em subtraction       sBttt2g1WDIS
      case(85)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! u em -> enu g g d       sBh2g1WDIS
      case(86)
         factor=1d0/nc*nf*nup*facRV         ! g em -> enu ub g d      sBh2g1WDIS
      case(87)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! db em -> enu ub g g     sBh2g1WDIS
      case(88)
         factor=1d0/nc*nup*facRV            ! Q em subtraction        sBh2g1WDIS
      case(89)
         factor=1d0/nc*nup*facRV            ! Qb em subtraction       sBh2g1WDIS
      case(90)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! u em -> enu gt gt d     sBth2g1WDIS
      case(91)
         factor=-1d0/nc**3*nf*nup*facRV     ! gt em -> enu ub gt d     sBth2g1WDIS
      case(92)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! db em -> enu ub gt gt     sBth2g1WDIS
      case(93)
         factor=-1d0/nc**3*nup*facRV        ! Q em subtraction        sBth2g1WDIS
      case(94)
         factor=-1d0/nc**3*nup*facRV        ! Qb em subtraction       sBth2g1WDIS
      case(95)
         factor=1d0/nc*nf*facRV             ! u em -> enu Q Qb d      sC0g1WDIS
      case(96)
         factor=1d0/nc*nup*facRV            ! Qb em -> enu ub Qb d     sC0g1WDIS
      case(97)
         factor=1d0/nc*nup*facRV            ! Q em -> enu ub Q d      sC0g1WDIS
      case(98)
         factor=1d0/nc*nf*facRV             ! db em -> enu ub Q Qb     sC0g1WDIS
      case(99)
         factor=1d0/nc*nf*nup*facRV         ! g em subtraction        sC0g1WDIS
      case(100)
         factor=-1d0/nc**3*nf*facRV         ! u em -> enu Q Qb d      Ct0g1WDIS
      case(101)
         factor=-1d0/nc**3*nup*facRV        ! Qb em -> enu ub Qb d     Ct0g1WDIS
      case(102)
         factor=-1d0/nc**3*nup*facRV        ! Q em -> enu ub Q d      Ct0g1WDIS
      case(103)
         factor=-1d0/nc**3*nf*facRV         ! db em -> enu ub Q Qb     Ct0g1WDIS
      case(104)
         factor=-1d0/nc**3*nf*nup*facRV     ! g em subtraction        Ct0g1WDIS
      case(105)
         factor=1d0/nc**2*nf*nf*facRV       ! u em -> enu Q Qb d      Ch0g1WDIS
      case(106)
         factor=1d0/nc**2*nf*nup*facRV      ! Qb em -> enu ub Qb d     Ch0g1WDIS
      case(107)
         factor=1d0/nc**2*nf*nup*facRV      ! Q em -> enu ub Q d      Ch0g1WDIS
      case(108)
         factor=1d0/nc**2*nf*nf*facRV       ! db em -> enu ub Q Qb     Ch0g1WDIS
      case(109)
         factor=1d0/nc**2*nf**2*nup*facRV   ! g em subtraction        Ch0g1WDIS
      case(110)
         factor=1d0/nc**2*facRV             ! u em -> enu u ub d      D0g1WpaDIS
      case(111)
         factor=1d0/nc**2*1d0/2d0*facRV     ! ub em -> enu ub ub d     D0g1WpaDIS
      case(112)
         factor=1d0/nc**2*1d0/2d0*facRV     ! db em -> enu ub u ub     D0g1WpaDIS
      case(113)
         factor=1d0/nc**2*nup*facRV         ! g em subtraction        D0g1WpaDIS
      case(114)
         factor=1d0/nc**2*1d0/2d0*facRV     ! u em -> enu d db d      D0g1WpbDIS
      case(115)
         factor=1d0/nc**2*facRV             ! db em -> enu ub db d     D0g1WpbDIS
      case(116)
         factor=1d0/nc**2*1d0/2d0*facRV     ! d em -> enu ub d d      D0g1WpbDIS
      case(117)
         factor=1d0/nc**2*nup*facRV         ! g em subtraction        D0g1WpbDIS
      case(118)
         factor=1d0/nc**4*facRV             ! u em -> enu u ub d      Dt0g1WpaDIS
      case(119)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub em -> enu ub ub d     Dt0g1WpaDIS
      case(120)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db em -> enu ub u ub     Dt0g1WpaDIS
      case(121)
         factor=1d0/nc**4*nup*facRV         ! g em subtraction        Dt0g1WpaDIS
      case(122)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u em -> enu d db d      Dt0g1WpbDIS
      case(123)
         factor=1d0/nc**4*facRV             ! db em -> enu ub db d     Dt0g1WpbDIS
      case(124)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d em -> enu ub d d      Dt0g1WpbDIS
      case(125)
         factor=1d0/nc**4*nup*facRV         ! g em subtraction        Dt0g1WpbDIS
      case(126)
         factor=1d0/nc**3*nf*facRV          ! u em -> enu u ub d      Dh0g1WpaDIS
      case(127)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! ub em -> enu ub ub d     Dh0g1WpaDIS
      case(128)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! db em -> enu ub u ub     Dh0g1WpaDIS
      case(129)
         factor=1d0/nc**3*nf*nup*facRV      ! g em subtraction        Dh0g1WpaDIS
      case(130)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! u em -> enu d db d      Dh0g1WpbDIS
      case(131)
         factor=1d0/nc**3*nf*facRV          ! db em -> enu ub db d     Dh0g1WpbDIS
      case(132)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! d em -> enu ub d d      Dh0g1WpbDIS
      case(133)
         factor=1d0/nc**3*nf*nup*facRV      ! g em subtraction        Dh0g1WpbDIS

c -- double virtual

      case(134)
         factor=facVV                       ! u em -> enu g d         B1g2WDIS
      case(135)
         factor=nup*facVV                   ! g em -> enu ub d        B1g2WDIS
      case(136)
         factor=facVV                       ! db em -> enu ub g       B1g2WDIS
      case(137)
         factor=1d0/nf*nup*facVV            ! Q em subtraction        B1g2WDIS
      case(138)
         factor=1d0/nf*nup*facVV            ! Qb em subtraction       B1g2WDIS
      case(139)
         factor=facVV                       ! d em subtraction        B1g2WDIS
      case(140)
         factor=facVV                       ! ub em subtraction       B1g2WDIS
      case(141)
         factor=-1d0/nc**2*facVV            ! u em -> enu g d         Bt1g2WDIS
      case(142)
         factor=-1d0/nc**2*nup*facVV        ! g em -> enu ub d        Bt1g2WDIS
      case(143)
         factor=-1d0/nc**2*facVV            ! db em -> enu ub g       Bt1g2WDIS
      case(144)
         factor=-1d0/nc**2/nf*nup*facVV     ! Q em subtraction        Bt1g2WDIS
      case(145)
         factor=-1d0/nc**2/nf*nup*facVV     ! Qb em subtraction       Bt1g2WDIS
      case(146)
         factor=-1d0/nc**2*facVV            ! d em subtraction        Bt1g2WDIS
      case(147)
         factor=-1d0/nc**2*facVV            ! ub em subtraction       Bt1g2WDIS
      case(148)
         factor=1d0/nc**4*facVV             ! u em -> enu g d         Btt1g2WDIS
      case(149)
         factor=1d0/nc**4*nup*facVV         ! g em -> enu ub d        Btt1g2WDIS
      case(150)
         factor=1d0/nc**4*facVV             ! db em -> enu ub g       Btt1g2WDIS
      case(151)
         factor=1d0/nc**4/nf*nup*facVV      ! Q em subtraction        Btt1g2WDIS
      case(152)
         factor=1d0/nc**4/nf*nup*facVV      ! Qb em subtraction       Btt1g2WDIS
      case(153)
         factor=1d0/nc**4*facVV             ! d em subtraction        Btt1g2WDIS
      case(154)
         factor=1d0/nc**4*facVV             ! ub em subtraction       Btt1g2WDIS
      case(155)
         factor=1d0/nc*nf*facVV             ! u em -> enu g d         Bh1g2WDIS
      case(156)
         factor=1d0/nc*nf*nup*facVV         ! g em -> enu ub d        Bh1g2WDIS
      case(157)
         factor=1d0/nc*nf*facVV             ! db em -> enu ub g       Bh1g2WDIS
      case(158)
         factor=1d0/nc*nup*facVV            ! Q em subtraction        Bh1g2WDIS
      case(159)
         factor=1d0/nc*nup*facVV            ! Qb em subtraction       Bh1g2WDIS
      case(160)
         factor=1d0/nc*nf*facVV             ! d em subtraction        Bh1g2WDIS
      case(161)
         factor=1d0/nc*nf*facVV             ! ub em subtraction       Bh1g2WDIS
      case(162)
         factor=1d0/nc**3*nf*facVV          ! u em -> enu g d         Bht1g2WDIS
      case(163)
         factor=1d0/nc**3*nf*nup*facVV      ! g em -> enu ub d        Bht1g2WDIS
      case(164)
         factor=1d0/nc**3*nf*facVV          ! db em -> enu ub g       Bht1g2WDIS
      case(165)
         factor=1d0/nc**3*nup*facVV         ! Q em subtraction        Bht1g2WDIS
      case(166)
         factor=1d0/nc**3*nup*facVV         ! Qb em subtraction       Bht1g2WDIS
      case(167)
         factor=1d0/nc**3*nf*facVV          ! d em subtraction        Bht1g2WDIS
      case(168)
         factor=1d0/nc**3*nf*facVV          ! ub em subtraction       Bht1g2WDIS
      case(169)
         factor=1d0/nc**2*nf**2*facVV       ! u em -> enu g d         Bhh1g2WDIS
      case(170)
         factor=1d0/nc**2*nf**2*nup*facVV   ! g em -> enu ub d        Bhh1g2WDIS
      case(171)
         factor=1d0/nc**2*nf**2*facVV       ! db em -> enu ub g       Bhh1g2WDIS
      case(172)
         factor=1d0/nc**2*nf*nup*facVV      ! Q em subtraction        Bhh1g2WDIS
      case(173)
         factor=1d0/nc**2*nf*nup*facVV      ! Qb em subtraction       Bhh1g2WDIS
      case(174)
         factor=1d0/nc**2*nf**2*facVV       ! d em subtraction        Bhh1g2WDIS
      case(175)
         factor=1d0/nc**2*nf**2*facVV       ! ub em subtraction       Bhh1g2WDIS
      end select
      factor=relfactor*factor

      return
      end
