      subroutine getqcdnormDISWp(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtDISWp(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_dis(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVDISWp
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourDISWp(current_chan)
         do isub = 1, nflavourDISWp(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_DISWp(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=DISWp "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param()/stw)**2*(nc**2-1)
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d ep -> enub g u        B1g0WDIS
      case(2)
         factor=nup*facB                    ! g ep -> enub db u       B1g0WDIS
      case(3)
         factor=facB                        ! ub ep -> enub db g      B1g0WDIS

c -- real

      case(4)
         factor=1d0/2d0*facR                ! d ep -> enub g g u      B2g0WDIS
      case(5)
         factor=nup*facR                    ! g ep -> enub db g u     B2g0WDIS
      case(6)
         factor=1d0/2d0*facR                ! ub ep -> enub db g g     B2g0WDIS
      case(7)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d ep -> enub gt gt u     Bt2g0WDIS
      case(8)
         factor=-1d0/nc**2*nup*facR         ! gt ep -> enub db gt u     Bt2g0WDIS
      case(9)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub ep -> enub db gt gt     Bt2g0WDIS
      case(10)
         factor=1d0/nc*nf*facR              ! d ep -> enub Q Qb u     C0g0WDIS
      case(11)
         factor=1d0/nc*nup*facR             ! Qb ep -> enub db Qb u     C0g0WDIS
      case(12)
         factor=1d0/nc*nup*facR             ! Q ep -> enub db Q u     C0g0WDIS
      case(13)
         factor=1d0/nc*nf*facR              ! ub ep -> enub db Q Qb     C0g0WDIS
      case(14)
         factor=-1d0/nc**2*facR             ! d ep -> enub d db u     D0g0WaDIS
      case(15)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db ep -> enub db db u     D0g0WaDIS
      case(16)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub ep -> enub db d db     D0g0WaDIS
      case(17)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d ep -> enub u ub u     D0g0WbDIS
      case(18)
         factor=-1d0/nc**2*facR             ! ub ep -> enub db ub u     D0g0WbDIS
      case(19)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u ep -> enub db u u     D0g0WbDIS

c -- virtual

      case(20)
         factor=facV                        ! d ep -> enub g u        B1g1WDIS
      case(21)
         factor=nup*facV                    ! g ep -> enub db u       B1g1WDIS
      case(22)
         factor=facV                        ! ub ep -> enub db g      B1g1WDIS
      case(23)
         factor=1d0/nf*nup*facV             ! Q ep subtraction        B1g1WDIS
      case(24)
         factor=1d0/nf*nup*facV             ! Qb ep subtraction       B1g1WDIS
      case(25)
         factor=-1d0/nc**2*facV             ! d ep -> enub g u        Bt1g1WDIS
      case(26)
         factor=-1d0/nc**2*nup*facV         ! g ep -> enub db u       Bt1g1WDIS
      case(27)
         factor=-1d0/nc**2*facV             ! ub ep -> enub db g      Bt1g1WDIS
      case(28)
         factor=-1d0/nc**2/nf*nup*facV      ! Q ep subtraction        Bt1g1WDIS
      case(29)
         factor=-1d0/nc**2/nf*nup*facV      ! Qb ep subtraction       Bt1g1WDIS
      case(30)
         factor=1d0/nc*nf*facV              ! d ep -> enub g u        Bh1g1WDIS
      case(31)
         factor=1d0/nc*nf*nup*facV          ! g ep -> enub db u       Bh1g1WDIS
      case(32)
         factor=1d0/nc*nf*facV              ! ub ep -> enub db g      Bh1g1WDIS
      case(33)
         factor=1d0/nc*nup*facV             ! Q ep subtraction        Bh1g1WDIS
      case(34)
         factor=1d0/nc*nup*facV             ! Qb ep subtraction       Bh1g1WDIS

c -- double real

      case(35)
         factor=1d0/6d0*facRR               ! d ep -> enub g g g u     sB3g0WDIS
      case(36)
         factor=1d0/2d0*nup*facRR           ! g ep -> enub db g g u     sB3g0WDIS
      case(37)
         factor=1d0/6d0*facRR               ! ub ep -> enub db g g g     sB3g0WDIS
      case(38)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! d ep -> enub g g g u     sBt3g0WDIS
      case(39)
         factor=-1d0/nc**2*1d0/2d0*nup*facRR   ! g ep -> enub db g g u     sBt3g0WDIS
      case(40)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! ub ep -> enub db g g g     sBt3g0WDIS
      case(41)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! d ep -> enub gt gt gt u     sBtt3g0WDIS
      case(42)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*nup*facRR   ! gt ep -> enub db gt gt u     sBtt3g0WDIS
      case(43)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! ub ep -> enub db gt gt gt     sBtt3g0WDIS
      case(44)
         factor=1d0/nc*nf*facRR             ! d ep -> enub g Q Qb u     sC1g0WDIS
      case(45)
         factor=1d0/nc*nf*nup*facRR         ! g ep -> enub db Q Qb u     sC1g0WDIS
      case(46)
         factor=1d0/nc*nup*facRR            ! Qb ep -> enub db g Qb u     sC1g0WDIS
      case(47)
         factor=1d0/nc*nup*facRR            ! Q ep -> enub db g Q u     sC1g0WDIS
      case(48)
         factor=1d0/nc*nf*facRR             ! ub ep -> enub db g Q Qb     sC1g0WDIS
      case(49)
         factor=-1d0/nc**3*nf*facRR         ! d ep -> enub g Q Qb u     sCt1g0WDIS
      case(50)
         factor=-1d0/nc**3*nf*nup*facRR     ! g ep -> enub db Q Qb u     sCt1g0WDIS
      case(51)
         factor=-1d0/nc**3*nup*facRR        ! Qb ep -> enub db g Qb u     sCt1g0WDIS
      case(52)
         factor=-1d0/nc**3*nup*facRR        ! Q ep -> enub db g Q u     sCt1g0WDIS
      case(53)
         factor=-1d0/nc**3*nf*facRR         ! ub ep -> enub db g Q Qb     sCt1g0WDIS
      case(54)
         factor=-1d0/nc**2*facRR            ! d ep -> enub g d db u     D1g0WmacDIS
      case(55)
         factor=-1d0/nc**2*1d0/2d0*nup*facRR   ! g ep -> enub db d db u     D1g0WmacDIS
      case(56)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db ep -> enub db g db u     D1g0WmacDIS
      case(57)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub ep -> enub db g d db     D1g0WmacDIS
      case(58)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d ep -> enub g u ub u     D1g0WmbcDIS
      case(59)
         factor=-1d0/nc**2*1d0/2d0*nup*facRR   ! g ep -> enub db u ub u     D1g0WmbcDIS
      case(60)
         factor=-1d0/nc**2*facRR            ! ub ep -> enub db g ub u     D1g0WmbcDIS
      case(61)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u ep -> enub db g u u     D1g0WmbcDIS
      case(62)
         factor=1d0/nc**4*facRR             ! d ep -> enub g d db u     Dt1g0WmaDIS
      case(63)
         factor=1d0/nc**4*1d0/2d0*nup*facRR   ! g ep -> enub db d db u     Dt1g0WmaDIS
      case(64)
         factor=1d0/nc**4*1d0/2d0*facRR     ! db ep -> enub db g db u     Dt1g0WmaDIS
      case(65)
         factor=1d0/nc**4*1d0/2d0*facRR     ! ub ep -> enub db g d db     Dt1g0WmaDIS
      case(66)
         factor=1d0/nc**4*1d0/2d0*facRR     ! d ep -> enub g u ub u     Dt1g0WmbDIS
      case(67)
         factor=1d0/nc**4*1d0/2d0*nup*facRR   ! g ep -> enub db u ub u     Dt1g0WmbDIS
      case(68)
         factor=1d0/nc**4*facRR             ! ub ep -> enub db g ub u     Dt1g0WmbDIS
      case(69)
         factor=1d0/nc**4*1d0/2d0*facRR     ! u ep -> enub db g u u     Dt1g0WmbDIS

c -- real virtual

      case(70)
         factor=1d0/2d0*facRV               ! d ep -> enub g g u      sB2g1WDIS
      case(71)
         factor=nup*facRV                   ! g ep -> enub db g u     sB2g1WDIS
      case(72)
         factor=1d0/2d0*facRV               ! ub ep -> enub db g g     sB2g1WDIS
      case(73)
         factor=1d0/nf*nup*facRV            ! Q ep subtraction        sB2g1WDIS
      case(74)
         factor=1d0/nf*nup*facRV            ! Qb ep subtraction       sB2g1WDIS
      case(75)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! d ep -> enub gt gt u     sBt2g1WDIS
      case(76)
         factor=-1d0/nc**2*nup*facRV        ! gt ep -> enub db gt u     sBt2g1WDIS
      case(77)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! ub ep -> enub db gt gt     sBt2g1WDIS
      case(78)
         factor=-1d0/nc**2/nf*nup*facRV     ! Q ep subtraction        sBt2g1WDIS
      case(79)
         factor=-1d0/nc**2/nf*nup*facRV     ! Qb ep subtraction       sBt2g1WDIS
      case(80)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d ep -> enub gt gt u     sBttt2g1WDIS
      case(81)
         factor=1d0/nc**4*nup*facRV         ! gt ep -> enub db gt u     sBttt2g1WDIS
      case(82)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub ep -> enub db gt gt     sBttt2g1WDIS
      case(83)
         factor=1d0/nc**4/nf*nup*facRV      ! Q ep subtraction        sBttt2g1WDIS
      case(84)
         factor=1d0/nc**4/nf*nup*facRV      ! Qb ep subtraction       sBttt2g1WDIS
      case(85)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! d ep -> enub g g u      sBh2g1WDIS
      case(86)
         factor=1d0/nc*nf*nup*facRV         ! g ep -> enub db g u     sBh2g1WDIS
      case(87)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! ub ep -> enub db g g     sBh2g1WDIS
      case(88)
         factor=1d0/nc*nup*facRV            ! Q ep subtraction        sBh2g1WDIS
      case(89)
         factor=1d0/nc*nup*facRV            ! Qb ep subtraction       sBh2g1WDIS
      case(90)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! d ep -> enub gt gt u     sBth2g1WDIS
      case(91)
         factor=-1d0/nc**3*nf*nup*facRV     ! gt ep -> enub db gt u     sBth2g1WDIS
      case(92)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! ub ep -> enub db gt gt     sBth2g1WDIS
      case(93)
         factor=-1d0/nc**3*nup*facRV        ! Q ep subtraction        sBth2g1WDIS
      case(94)
         factor=-1d0/nc**3*nup*facRV        ! Qb ep subtraction       sBth2g1WDIS
      case(95)
         factor=1d0/nc*nf*facRV             ! d ep -> enub Q Qb u     sC0g1WDIS
      case(96)
         factor=1d0/nc*nup*facRV            ! Qb ep -> enub db Qb u     sC0g1WDIS
      case(97)
         factor=1d0/nc*nup*facRV            ! Q ep -> enub db Q u     sC0g1WDIS
      case(98)
         factor=1d0/nc*nf*facRV             ! ub ep -> enub db Q Qb     sC0g1WDIS
      case(99)
         factor=1d0/nc*nf*nup*facRV         ! g ep subtraction        sC0g1WDIS
      case(100)
         factor=-1d0/nc**3*nf*facRV         ! d ep -> enub Q Qb u     Ct0g1WDIS
      case(101)
         factor=-1d0/nc**3*nup*facRV        ! Qb ep -> enub db Qb u     Ct0g1WDIS
      case(102)
         factor=-1d0/nc**3*nup*facRV        ! Q ep -> enub db Q u     Ct0g1WDIS
      case(103)
         factor=-1d0/nc**3*nf*facRV         ! ub ep -> enub db Q Qb     Ct0g1WDIS
      case(104)
         factor=-1d0/nc**3*nf*nup*facRV     ! g ep subtraction        Ct0g1WDIS
      case(105)
         factor=1d0/nc**2*nf*nf*facRV       ! d ep -> enub Q Qb u     Ch0g1WDIS
      case(106)
         factor=1d0/nc**2*nf*nup*facRV      ! Qb ep -> enub db Qb u     Ch0g1WDIS
      case(107)
         factor=1d0/nc**2*nf*nup*facRV      ! Q ep -> enub db Q u     Ch0g1WDIS
      case(108)
         factor=1d0/nc**2*nf*nf*facRV       ! ub ep -> enub db Q Qb     Ch0g1WDIS
      case(109)
         factor=1d0/nc**2*nf**2*nup*facRV   ! g ep subtraction        Ch0g1WDIS
      case(110)
         factor=1d0/nc**2*facRV             ! d ep -> enub d db u     D0g1WmaDIS
      case(111)
         factor=1d0/nc**2*1d0/2d0*facRV     ! db ep -> enub db db u     D0g1WmaDIS
      case(112)
         factor=1d0/nc**2*1d0/2d0*facRV     ! ub ep -> enub db d db     D0g1WmaDIS
      case(113)
         factor=1d0/nc**2*nup*facRV         ! g ep subtraction        D0g1WmaDIS
      case(114)
         factor=1d0/nc**2*1d0/2d0*facRV     ! d ep -> enub u ub u     D0g1WmbDIS
      case(115)
         factor=1d0/nc**2*facRV             ! ub ep -> enub db ub u     D0g1WmbDIS
      case(116)
         factor=1d0/nc**2*1d0/2d0*facRV     ! u ep -> enub db u u     D0g1WmbDIS
      case(117)
         factor=1d0/nc**2*nup*facRV         ! g ep subtraction        D0g1WmbDIS
      case(118)
         factor=1d0/nc**4*facRV             ! d ep -> enub d db u     Dt0g1WmaDIS
      case(119)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db ep -> enub db db u     Dt0g1WmaDIS
      case(120)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub ep -> enub db d db     Dt0g1WmaDIS
      case(121)
         factor=1d0/nc**4*nup*facRV         ! g ep subtraction        Dt0g1WmaDIS
      case(122)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d ep -> enub u ub u     Dt0g1WmbDIS
      case(123)
         factor=1d0/nc**4*facRV             ! ub ep -> enub db ub u     Dt0g1WmbDIS
      case(124)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u ep -> enub db u u     Dt0g1WmbDIS
      case(125)
         factor=1d0/nc**4*nup*facRV         ! g ep subtraction        Dt0g1WmbDIS
      case(126)
         factor=1d0/nc**3*nf*facRV          ! d ep -> enub d db u     Dh0g1WmaDIS
      case(127)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! db ep -> enub db db u     Dh0g1WmaDIS
      case(128)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! ub ep -> enub db d db     Dh0g1WmaDIS
      case(129)
         factor=1d0/nc**3*nf*nup*facRV      ! g ep subtraction        Dh0g1WmaDIS
      case(130)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! d ep -> enub u ub u     Dh0g1WmbDIS
      case(131)
         factor=1d0/nc**3*nf*facRV          ! ub ep -> enub db ub u     Dh0g1WmbDIS
      case(132)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! u ep -> enub db u u     Dh0g1WmbDIS
      case(133)
         factor=1d0/nc**3*nf*nup*facRV      ! g ep subtraction        Dh0g1WmbDIS

c -- double virtual

      case(134)
         factor=facVV                       ! d ep -> enub g u        B1g2WDIS
      case(135)
         factor=nup*facVV                   ! g ep -> enub db u       B1g2WDIS
      case(136)
         factor=facVV                       ! ub ep -> enub db g      B1g2WDIS
      case(137)
         factor=1d0/nf*nup*facVV            ! Q ep subtraction        B1g2WDIS
      case(138)
         factor=1d0/nf*nup*facVV            ! Qb ep subtraction       B1g2WDIS
      case(139)
         factor=facVV                       ! db ep subtraction       B1g2WDIS
      case(140)
         factor=facVV                       ! u ep subtraction        B1g2WDIS
      case(141)
         factor=-1d0/nc**2*facVV            ! d ep -> enub g u        Bt1g2WDIS
      case(142)
         factor=-1d0/nc**2*nup*facVV        ! g ep -> enub db u       Bt1g2WDIS
      case(143)
         factor=-1d0/nc**2*facVV            ! ub ep -> enub db g      Bt1g2WDIS
      case(144)
         factor=-1d0/nc**2/nf*nup*facVV     ! Q ep subtraction        Bt1g2WDIS
      case(145)
         factor=-1d0/nc**2/nf*nup*facVV     ! Qb ep subtraction       Bt1g2WDIS
      case(146)
         factor=-1d0/nc**2*facVV            ! db ep subtraction       Bt1g2WDIS
      case(147)
         factor=-1d0/nc**2*facVV            ! u ep subtraction        Bt1g2WDIS
      case(148)
         factor=1d0/nc**4*facVV             ! d ep -> enub g u        Btt1g2WDIS
      case(149)
         factor=1d0/nc**4*nup*facVV         ! g ep -> enub db u       Btt1g2WDIS
      case(150)
         factor=1d0/nc**4*facVV             ! ub ep -> enub db g      Btt1g2WDIS
      case(151)
         factor=1d0/nc**4/nf*nup*facVV      ! Q ep subtraction        Btt1g2WDIS
      case(152)
         factor=1d0/nc**4/nf*nup*facVV      ! Qb ep subtraction       Btt1g2WDIS
      case(153)
         factor=1d0/nc**4*facVV             ! db ep subtraction       Btt1g2WDIS
      case(154)
         factor=1d0/nc**4*facVV             ! u ep subtraction        Btt1g2WDIS
      case(155)
         factor=1d0/nc*nf*facVV             ! d ep -> enub g u        Bh1g2WDIS
      case(156)
         factor=1d0/nc*nf*nup*facVV         ! g ep -> enub db u       Bh1g2WDIS
      case(157)
         factor=1d0/nc*nf*facVV             ! ub ep -> enub db g      Bh1g2WDIS
      case(158)
         factor=1d0/nc*nup*facVV            ! Q ep subtraction        Bh1g2WDIS
      case(159)
         factor=1d0/nc*nup*facVV            ! Qb ep subtraction       Bh1g2WDIS
      case(160)
         factor=1d0/nc*nf*facVV             ! db ep subtraction       Bh1g2WDIS
      case(161)
         factor=1d0/nc*nf*facVV             ! u ep subtraction        Bh1g2WDIS
      case(162)
         factor=1d0/nc**3*nf*facVV          ! d ep -> enub g u        Bht1g2WDIS
      case(163)
         factor=1d0/nc**3*nf*nup*facVV      ! g ep -> enub db u       Bht1g2WDIS
      case(164)
         factor=1d0/nc**3*nf*facVV          ! ub ep -> enub db g      Bht1g2WDIS
      case(165)
         factor=1d0/nc**3*nup*facVV         ! Q ep subtraction        Bht1g2WDIS
      case(166)
         factor=1d0/nc**3*nup*facVV         ! Qb ep subtraction       Bht1g2WDIS
      case(167)
         factor=1d0/nc**3*nf*facVV          ! db ep subtraction       Bht1g2WDIS
      case(168)
         factor=1d0/nc**3*nf*facVV          ! u ep subtraction        Bht1g2WDIS
      case(169)
         factor=1d0/nc**2*nf**2*facVV       ! d ep -> enub g u        Bhh1g2WDIS
      case(170)
         factor=1d0/nc**2*nf**2*nup*facVV   ! g ep -> enub db u       Bhh1g2WDIS
      case(171)
         factor=1d0/nc**2*nf**2*facVV       ! ub ep -> enub db g      Bhh1g2WDIS
      case(172)
         factor=1d0/nc**2*nf*nup*facVV      ! Q ep subtraction        Bhh1g2WDIS
      case(173)
         factor=1d0/nc**2*nf*nup*facVV      ! Qb ep subtraction       Bhh1g2WDIS
      case(174)
         factor=1d0/nc**2*nf**2*facVV       ! db ep subtraction       Bhh1g2WDIS
      case(175)
         factor=1d0/nc**2*nf**2*facVV       ! u ep subtraction        Bhh1g2WDIS
      end select
      factor=relfactor*factor

      return
      end
