      subroutine selectchannelDISWm()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*alphas_scl)*(4d0*pi*amzw/stw)**2*(nc**2-1)
      n_alphas_proc = 1
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelDISWm: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelDISWm: already allocated'  
        stop
      end if

      ntot_chan = 175

      allocate(qactive_chan(1:175))
      allocate(contrib_chan(1:175))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! u em to enu g d       B1g0WDIS(1,4,5,3,2)   
c      qactive_chan(2)  = .true.   ! g em to enu ub d      B1g0WDIS(4,1,5,3,2)   
c      qactive_chan(3)  = .true.   ! db em to enu ub g     B1g0WDIS(4,5,1,3,2)   

      do i=1,3
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(4)  = .true.   ! u em to enu g g d     B2g0WDIS(1,4,5,6,3,2)  qemB2g0WDISSNLO(1,4,5,6,3,2)
c      qactive_chan(5)  = .true.   ! g em to enu ub g d    B2g0WDIS(4,1,5,6,3,2)  gemB2g0WDISSNLO(4,1,5,6,3,2)
c      qactive_chan(6)  = .true.   ! db em to enu ub g g   B2g0WDIS(4,5,6,1,3,2)  qbemB2g0WDISSNLO(4,5,6,1,3,2)
c      qactive_chan(7)  = .true.   ! u em to enu gt gt d   Bt2g0WDIS(1,4,5,6,3,2)  qemBt2g0WDISSNLO(1,4,5,6,3,2)
c      qactive_chan(8)  = .true.   ! gt em to enu ub gt d   Bt2g0WDIS(4,1,5,6,3,2)  gtemBt2g0WDISSNLO(4,1,5,6,3,2)
c      qactive_chan(9)  = .true.   ! db em to enu ub gt gt   Bt2g0WDIS(4,5,6,1,3,2)  qbemBt2g0WDISSNLO(4,5,6,1,3,2)
c      qactive_chan(10) = .true.   ! u em to enu Q Qb d    C0g0WDIS(1,4,5,6,3,2)  qemC0g0WDISSNLO(1,4,5,6,3,2)
c      qactive_chan(11) = .true.   ! Qb em to enu ub Qb d   C0g0WDIS(4,1,5,6,3,2)  qpbemC0g0WDISSNLO(4,1,5,6,3,2)
c      qactive_chan(12) = .true.   ! Q em to enu ub Q d    C0g0WDIS(4,5,1,6,3,2)  qpemC0g0WDISSNLO(4,5,1,6,3,2)
c      qactive_chan(13) = .true.   ! db em to enu ub Q Qb   C0g0WDIS(4,5,6,1,3,2)  qbemC0g0WDISSNLO(4,5,6,1,3,2)
c      qactive_chan(14) = .true.   ! u em to enu u ub d    D0g0WaDIS(1,4,5,6,3,2)  qemD0g0WaDISSNLO(1,4,5,6,3,2)
c      qactive_chan(15) = .true.   ! ub em to enu ub ub d   D0g0WaDIS(4,1,5,6,3,2)  qbemD0g0WaDISSNLO(4,1,5,6,3,2)
c      qactive_chan(16) = .true.   ! db em to enu ub u ub   D0g0WaDIS(4,5,6,1,3,2)  qpbemD0g0WaDISSNLO(4,5,6,1,3,2)
c      qactive_chan(17) = .true.   ! u em to enu d db d    D0g0WbDIS(1,4,5,6,3,2)  qemD0g0WbDISSNLO(1,4,5,6,3,2)
c      qactive_chan(18) = .true.   ! db em to enu ub db d   D0g0WbDIS(4,1,5,6,3,2)  qpbemD0g0WbDISSNLO(4,1,5,6,3,2)
c      qactive_chan(19) = .true.   ! d em to enu ub d d    D0g0WbDIS(4,5,1,6,3,2)  qpemD0g0WbDISSNLO(4,5,1,6,3,2)

      do i=4,19
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(20) = .true.   ! u em to enu g d       B1g1WDIS(1,4,5,3,2)   qemB1g1WDISTNLO(1,4,5,3,2)
c      qactive_chan(21) = .true.   ! g em to enu ub d      B1g1WDIS(4,1,5,3,2)   gemB1g1WDISTNLO(4,1,5,3,2)
c      qactive_chan(22) = .true.   ! db em to enu ub g     B1g1WDIS(4,5,1,3,2)   qbemB1g1WDISTNLO(4,5,1,3,2)
c      qactive_chan(23) = .true.   ! Q em subtraction                            qpemB1g1WDISTNLO(1,4,5,3,2)
c      qactive_chan(24) = .true.   ! Qb em subtraction                           qpbemB1g1WDISTNLO(1,4,5,3,2)
c      qactive_chan(25) = .true.   ! u em to enu g d       Bt1g1WDIS(1,4,5,3,2)  qemBt1g1WDISTNLO(1,4,5,3,2)
c      qactive_chan(26) = .true.   ! g em to enu ub d      Bt1g1WDIS(4,1,5,3,2)  gemBt1g1WDISTNLO(4,1,5,3,2)
c      qactive_chan(27) = .true.   ! db em to enu ub g     Bt1g1WDIS(4,5,1,3,2)  qbemBt1g1WDISTNLO(4,5,1,3,2)
c      qactive_chan(28) = .true.   ! Q em subtraction                            qpemBt1g1WDISTNLO(1,4,5,3,2)
c      qactive_chan(29) = .true.   ! Qb em subtraction                           qpbemBt1g1WDISTNLO(1,4,5,3,2)
c      qactive_chan(30) = .true.   ! u em to enu g d       Bh1g1WDIS(1,4,5,3,2)  qemBh1g1WDISTNLO(1,4,5,3,2)
c      qactive_chan(31) = .true.   ! g em to enu ub d      Bh1g1WDIS(4,1,5,3,2)  gemBh1g1WDISTNLO(4,1,5,3,2)
c      qactive_chan(32) = .true.   ! db em to enu ub g     Bh1g1WDIS(4,5,1,3,2)  qbemBh1g1WDISTNLO(4,5,1,3,2)
c      qactive_chan(33) = .true.   ! Q em subtraction                            qpemBh1g1WDISTNLO(1,4,5,3,2)
c      qactive_chan(34) = .true.   ! Qb em subtraction                           qpbemBh1g1WDISTNLO(1,4,5,3,2)

      do i=20,34
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(35) = .true.   ! u em to enu g g g d   sB3g0WDIS(1,4,5,6,7,3,2)  qemsB3g0WDISS(1,4,5,6,7,3,2)
c      qactive_chan(36) = .true.   ! g em to enu ub g g d   sB3g0WDIS(4,1,5,6,7,3,2)  gemsB3g0WDISS(4,1,5,6,7,3,2)
c      qactive_chan(37) = .true.   ! db em to enu ub g g g   sB3g0WDIS(4,5,6,7,1,3,2)  qbemsB3g0WDISS(4,5,6,7,1,3,2)
c      qactive_chan(38) = .true.   ! u em to enu g g g d   sBt3g0WDIS(1,4,5,6,7,3,2)  qemsBt3g0WDISS(1,4,5,6,7,3,2)
c      qactive_chan(39) = .true.   ! g em to enu ub g g d   sBt3g0WDIS(4,1,5,6,7,3,2)  gemsBt3g0WDISS(4,1,5,6,7,3,2)
c      qactive_chan(40) = .true.   ! db em to enu ub g g g   sBt3g0WDIS(4,5,6,7,1,3,2)  qbemsBt3g0WDISS(4,5,6,7,1,3,2)
c      qactive_chan(41) = .true.   ! u em to enu gt gt gt d   sBtt3g0WDIS(1,4,5,6,7,3,2)  qemsBtt3g0WDISS(1,4,5,6,7,3,2)
c      qactive_chan(42) = .true.   ! gt em to enu ub gt gt d   sBtt3g0WDIS(4,1,5,6,7,3,2)  gtemsBtt3g0WDISS(4,1,5,6,7,3,2)
c      qactive_chan(43) = .true.   ! db em to enu ub gt gt gt   sBtt3g0WDIS(4,5,6,7,1,3,2)  qbemsBtt3g0WDISS(4,5,6,7,1,3,2)
c      qactive_chan(44) = .true.   ! u em to enu g Q Qb d   sC1g0WDIS(1,4,5,6,7,3,2)  qemsC1g0WDISS(1,4,5,6,7,3,2)
c      qactive_chan(45) = .true.   ! g em to enu ub Q Qb d   sC1g0WDIS(4,1,5,6,7,3,2)  gemsC1g0WDISS(4,1,5,6,7,3,2)
c      qactive_chan(46) = .true.   ! Qb em to enu ub g Qb d   sC1g0WDIS(4,5,1,6,7,3,2)  qpbemsC1g0WDISS(4,5,1,6,7,3,2)
c      qactive_chan(47) = .true.   ! Q em to enu ub g Q d   sC1g0WDIS(4,5,6,1,7,3,2)  qpemsC1g0WDISS(4,5,6,1,7,3,2)
c      qactive_chan(48) = .true.   ! db em to enu ub g Q Qb   sC1g0WDIS(4,5,6,7,1,3,2)  qbemsC1g0WDISS(4,5,6,7,1,3,2)
c      qactive_chan(49) = .true.   ! u em to enu g Q Qb d   sCt1g0WDIS(1,4,5,6,7,3,2)  qemsCt1g0WDISS(1,4,5,6,7,3,2)
c      qactive_chan(50) = .true.   ! g em to enu ub Q Qb d   sCt1g0WDIS(4,1,5,6,7,3,2)  gemsCt1g0WDISS(4,1,5,6,7,3,2)
c      qactive_chan(51) = .true.   ! Qb em to enu ub g Qb d   sCt1g0WDIS(4,5,1,6,7,3,2)  qpbemsCt1g0WDISS(4,5,1,6,7,3,2)
c      qactive_chan(52) = .true.   ! Q em to enu ub g Q d   sCt1g0WDIS(4,5,6,1,7,3,2)  qpemsCt1g0WDISS(4,5,6,1,7,3,2)
c      qactive_chan(53) = .true.   ! db em to enu ub g Q Qb   sCt1g0WDIS(4,5,6,7,1,3,2)  qbemsCt1g0WDISS(4,5,6,7,1,3,2)
c      qactive_chan(54) = .true.   ! u em to enu g u ub d   D1g0WpacDIS(1,4,5,6,7,3,2)  qemD1g0WpacDISS(1,4,5,6,7,3,2)
c      qactive_chan(55) = .true.   ! g em to enu ub u ub d   D1g0WpacDIS(4,1,5,6,7,3,2)  gemD1g0WpacDISS(4,1,5,6,7,3,2)
c      qactive_chan(56) = .true.   ! ub em to enu ub g ub d   D1g0WpacDIS(4,5,1,6,7,3,2)  qbemD1g0WpacDISS(4,5,1,6,7,3,2)
c      qactive_chan(57) = .true.   ! db em to enu ub g u ub   D1g0WpacDIS(4,5,6,7,1,3,2)  qpbemD1g0WpacDISS(4,5,6,7,1,3,2)
c      qactive_chan(58) = .true.   ! u em to enu g d db d   D1g0WpbcDIS(1,4,5,6,7,3,2)  qemD1g0WpbcDISS(1,4,5,6,7,3,2)
c      qactive_chan(59) = .true.   ! g em to enu ub d db d   D1g0WpbcDIS(4,1,5,6,7,3,2)  gemD1g0WpbcDISS(4,1,5,6,7,3,2)
c      qactive_chan(60) = .true.   ! db em to enu ub g db d   D1g0WpbcDIS(4,5,1,6,7,3,2)  qpbemD1g0WpbcDISS(4,5,1,6,7,3,2)
c      qactive_chan(61) = .true.   ! d em to enu ub g d d   D1g0WpbcDIS(4,5,6,1,7,3,2)  qpemD1g0WpbcDISS(4,5,6,1,7,3,2)
c      qactive_chan(62) = .true.   ! u em to enu g u ub d   Dt1g0WpaDIS(1,4,5,6,7,3,2)  qemDt1g0WpaDISS(1,4,5,6,7,3,2)
c      qactive_chan(63) = .true.   ! g em to enu ub u ub d   Dt1g0WpaDIS(4,1,5,6,7,3,2)  gemDt1g0WpaDISS(4,1,5,6,7,3,2)
c      qactive_chan(64) = .true.   ! ub em to enu ub g ub d   Dt1g0WpaDIS(4,5,1,6,7,3,2)  qbemDt1g0WpaDISS(4,5,1,6,7,3,2)
c      qactive_chan(65) = .true.   ! db em to enu ub g u ub   Dt1g0WpaDIS(4,5,6,7,1,3,2)  qpbemDt1g0WpaDISS(4,5,6,7,1,3,2)
c      qactive_chan(66) = .true.   ! u em to enu g d db d   Dt1g0WpbDIS(1,4,5,6,7,3,2)  qemDt1g0WpbDISS(1,4,5,6,7,3,2)
c      qactive_chan(67) = .true.   ! g em to enu ub d db d   Dt1g0WpbDIS(4,1,5,6,7,3,2)  gemDt1g0WpbDISS(4,1,5,6,7,3,2)
c      qactive_chan(68) = .true.   ! db em to enu ub g db d   Dt1g0WpbDIS(4,5,1,6,7,3,2)  qpbemDt1g0WpbDISS(4,5,1,6,7,3,2)
c      qactive_chan(69) = .true.   ! d em to enu ub g d d   Dt1g0WpbDIS(4,5,6,1,7,3,2)  qpemDt1g0WpbDISS(4,5,6,1,7,3,2)

      do i=35,69
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(70) = .true.   ! u em to enu g g d     sB2g1WDIS(1,4,5,6,3,2)  qemsB2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(71) = .true.   ! g em to enu ub g d    sB2g1WDIS(4,1,5,6,3,2)  gemsB2g1WDIST(4,1,5,6,3,2)
c      qactive_chan(72) = .true.   ! db em to enu ub g g   sB2g1WDIS(4,5,6,1,3,2)  qbemsB2g1WDIST(4,5,6,1,3,2)
c      qactive_chan(73) = .true.   ! Q em subtraction                            qpemsB2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(74) = .true.   ! Qb em subtraction                           qpbemsB2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(75) = .true.   ! u em to enu gt gt d   sBt2g1WDIS(1,4,5,6,3,2)  qemsBt2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(76) = .true.   ! gt em to enu ub gt d   sBt2g1WDIS(4,1,5,6,3,2)  gtemsBt2g1WDIST(4,1,5,6,3,2)
c      qactive_chan(77) = .true.   ! db em to enu ub gt gt   sBt2g1WDIS(4,5,6,1,3,2)  qbemsBt2g1WDIST(4,5,6,1,3,2)
c      qactive_chan(78) = .true.   ! Q em subtraction                            qpemsBt2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(79) = .true.   ! Qb em subtraction                           qpbemsBt2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(80) = .true.   ! u em to enu gt gt d   sBttt2g1WDIS(1,4,5,6,3,2)  qemsBttt2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(81) = .true.   ! gt em to enu ub gt d   sBttt2g1WDIS(4,1,5,6,3,2)  gtemsBttt2g1WDIST(4,1,5,6,3,2)
c      qactive_chan(82) = .true.   ! db em to enu ub gt gt   sBttt2g1WDIS(4,5,6,1,3,2)  qbemsBttt2g1WDIST(4,5,6,1,3,2)
c      qactive_chan(83) = .true.   ! Q em subtraction                            qpemsBttt2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(84) = .true.   ! Qb em subtraction                           qpbemsBttt2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(85) = .true.   ! u em to enu g g d     sBh2g1WDIS(1,4,5,6,3,2)  qemsBh2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(86) = .true.   ! g em to enu ub g d    sBh2g1WDIS(4,1,5,6,3,2)  gemsBh2g1WDIST(4,1,5,6,3,2)
c      qactive_chan(87) = .true.   ! db em to enu ub g g   sBh2g1WDIS(4,5,6,1,3,2)  qbemsBh2g1WDIST(4,5,6,1,3,2)
c      qactive_chan(88) = .true.   ! Q em subtraction                            qpemsBh2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(89) = .true.   ! Qb em subtraction                           qpbemsBh2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(90) = .true.   ! u em to enu gt gt d   sBth2g1WDIS(1,4,5,6,3,2)  qemsBth2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(91) = .true.   ! gt em to enu ub gt d   sBth2g1WDIS(4,1,5,6,3,2)  gtemsBth2g1WDIST(4,1,5,6,3,2)
c      qactive_chan(92) = .true.   ! db em to enu ub gt gt   sBth2g1WDIS(4,5,6,1,3,2)  qbemsBth2g1WDIST(4,5,6,1,3,2)
c      qactive_chan(93) = .true.   ! Q em subtraction                            qpemsBth2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(94) = .true.   ! Qb em subtraction                           qpbemsBth2g1WDIST(1,4,5,6,3,2)
c      qactive_chan(95) = .true.   ! u em to enu Q Qb d    sC0g1WDIS(1,4,5,6,3,2)  qemsC0g1WDIST(1,4,5,6,3,2)
c      qactive_chan(96) = .true.   ! Qb em to enu ub Qb d   sC0g1WDIS(4,1,5,6,3,2)  qpbemsC0g1WDIST(4,1,5,6,3,2)
c      qactive_chan(97) = .true.   ! Q em to enu ub Q d    sC0g1WDIS(4,5,1,6,3,2)  qpemsC0g1WDIST(4,5,1,6,3,2)
c      qactive_chan(98) = .true.   ! db em to enu ub Q Qb   sC0g1WDIS(4,5,6,1,3,2)  qbemsC0g1WDIST(4,5,6,1,3,2)
c      qactive_chan(99) = .true.   ! g em subtraction                            gemsC0g1WDIST(1,4,5,6,3,2)
c      qactive_chan(100)= .true.   ! u em to enu Q Qb d    Ct0g1WDIS(1,4,5,6,3,2)  qemCt0g1WDIST(1,4,5,6,3,2)
c      qactive_chan(101)= .true.   ! Qb em to enu ub Qb d   Ct0g1WDIS(4,1,5,6,3,2)  qpbemCt0g1WDIST(4,1,5,6,3,2)
c      qactive_chan(102)= .true.   ! Q em to enu ub Q d    Ct0g1WDIS(4,5,1,6,3,2)  qpemCt0g1WDIST(4,5,1,6,3,2)
c      qactive_chan(103)= .true.   ! db em to enu ub Q Qb   Ct0g1WDIS(4,5,6,1,3,2)  qbemCt0g1WDIST(4,5,6,1,3,2)
c      qactive_chan(104)= .true.   ! g em subtraction                            gemCt0g1WDIST(1,4,5,6,3,2)
c      qactive_chan(105)= .true.   ! u em to enu Q Qb d    Ch0g1WDIS(1,4,5,6,3,2)  qemCh0g1WDIST(1,4,5,6,3,2)
c      qactive_chan(106)= .true.   ! Qb em to enu ub Qb d   Ch0g1WDIS(4,1,5,6,3,2)  qpbemCh0g1WDIST(4,1,5,6,3,2)
c      qactive_chan(107)= .true.   ! Q em to enu ub Q d    Ch0g1WDIS(4,5,1,6,3,2)  qpemCh0g1WDIST(4,5,1,6,3,2)
c      qactive_chan(108)= .true.   ! db em to enu ub Q Qb   Ch0g1WDIS(4,5,6,1,3,2)  qbemCh0g1WDIST(4,5,6,1,3,2)
c      qactive_chan(109)= .true.   ! g em subtraction                            gemCh0g1WDIST(1,4,5,6,3,2)
c      qactive_chan(110)= .true.   ! u em to enu u ub d    D0g1WpaDIS(1,4,5,6,3,2)  qemD0g1WpaDIST(1,4,5,6,3,2)
c      qactive_chan(111)= .true.   ! ub em to enu ub ub d   D0g1WpaDIS(4,1,5,6,3,2)  qbemD0g1WpaDIST(4,1,5,6,3,2)
c      qactive_chan(112)= .true.   ! db em to enu ub u ub   D0g1WpaDIS(4,5,6,1,3,2)  qpbemD0g1WpaDIST(4,5,6,1,3,2)
c      qactive_chan(113)= .true.   ! g em subtraction                            gemD0g1WpaDIST(1,4,5,6,3,2)
c      qactive_chan(114)= .true.   ! u em to enu d db d    D0g1WpbDIS(1,4,5,6,3,2)  qemD0g1WpbDIST(1,4,5,6,3,2)
c      qactive_chan(115)= .true.   ! db em to enu ub db d   D0g1WpbDIS(4,1,5,6,3,2)  qpbemD0g1WpbDIST(4,1,5,6,3,2)
c      qactive_chan(116)= .true.   ! d em to enu ub d d    D0g1WpbDIS(4,5,1,6,3,2)  qpemD0g1WpbDIST(4,5,1,6,3,2)
c      qactive_chan(117)= .true.   ! g em subtraction                            gemD0g1WpbDIST(1,4,5,6,3,2)
c      qactive_chan(118)= .true.   ! u em to enu u ub d    Dt0g1WpaDIS(1,4,5,6,3,2)  qemDt0g1WpaDIST(1,4,5,6,3,2)
c      qactive_chan(119)= .true.   ! ub em to enu ub ub d   Dt0g1WpaDIS(4,1,5,6,3,2)  qbemDt0g1WpaDIST(4,1,5,6,3,2)
c      qactive_chan(120)= .true.   ! db em to enu ub u ub   Dt0g1WpaDIS(4,5,6,1,3,2)  qpbemDt0g1WpaDIST(4,5,6,1,3,2)
c      qactive_chan(121)= .true.   ! g em subtraction                            gemDt0g1WpaDIST(1,4,5,6,3,2)
c      qactive_chan(122)= .true.   ! u em to enu d db d    Dt0g1WpbDIS(1,4,5,6,3,2)  qemDt0g1WpbDIST(1,4,5,6,3,2)
c      qactive_chan(123)= .true.   ! db em to enu ub db d   Dt0g1WpbDIS(4,1,5,6,3,2)  qpbemDt0g1WpbDIST(4,1,5,6,3,2)
c      qactive_chan(124)= .true.   ! d em to enu ub d d    Dt0g1WpbDIS(4,5,1,6,3,2)  qpemDt0g1WpbDIST(4,5,1,6,3,2)
c      qactive_chan(125)= .true.   ! g em subtraction                            gemDt0g1WpbDIST(1,4,5,6,3,2)
c      qactive_chan(126)= .true.   ! u em to enu u ub d    Dh0g1WpaDIS(1,4,5,6,3,2)  qemDh0g1WpaDIST(1,4,5,6,3,2)
c      qactive_chan(127)= .true.   ! ub em to enu ub ub d   Dh0g1WpaDIS(4,1,5,6,3,2)  qbemDh0g1WpaDIST(4,1,5,6,3,2)
c      qactive_chan(128)= .true.   ! db em to enu ub u ub   Dh0g1WpaDIS(4,5,6,1,3,2)  qpbemDh0g1WpaDIST(4,5,6,1,3,2)
c      qactive_chan(129)= .true.   ! g em subtraction                            gemDh0g1WpaDIST(1,4,5,6,3,2)
c      qactive_chan(130)= .true.   ! u em to enu d db d    Dh0g1WpbDIS(1,4,5,6,3,2)  qemDh0g1WpbDIST(1,4,5,6,3,2)
c      qactive_chan(131)= .true.   ! db em to enu ub db d   Dh0g1WpbDIS(4,1,5,6,3,2)  qpbemDh0g1WpbDIST(4,1,5,6,3,2)
c      qactive_chan(132)= .true.   ! d em to enu ub d d    Dh0g1WpbDIS(4,5,1,6,3,2)  qpemDh0g1WpbDIST(4,5,1,6,3,2)
c      qactive_chan(133)= .true.   ! g em subtraction                            gemDh0g1WpbDIST(1,4,5,6,3,2)

      do i=70,133
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(134)= .true.   ! u em to enu g d       B1g2WDIS(1,4,5,3,2)   qemB1g2WDISU(1,4,5,3,2)
c      qactive_chan(135)= .true.   ! g em to enu ub d      B1g2WDIS(4,1,5,3,2)   gemB1g2WDISU(4,1,5,3,2)
c      qactive_chan(136)= .true.   ! db em to enu ub g     B1g2WDIS(4,5,1,3,2)   qbemB1g2WDISU(4,5,1,3,2)
c      qactive_chan(137)= .true.   ! Q em subtraction                            qpemB1g2WDISU(1,4,5,3,2)
c      qactive_chan(138)= .true.   ! Qb em subtraction                           qpbemB1g2WDISU(1,4,5,3,2)
c      qactive_chan(139)= .true.   ! d em subtraction                            demB1g2WDISU(1,4,5,3,2)
c      qactive_chan(140)= .true.   ! ub em subtraction                           ubemB1g2WDISU(1,4,5,3,2)
c      qactive_chan(141)= .true.   ! u em to enu g d       Bt1g2WDIS(1,4,5,3,2)  qemBt1g2WDISU(1,4,5,3,2)
c      qactive_chan(142)= .true.   ! g em to enu ub d      Bt1g2WDIS(4,1,5,3,2)  gemBt1g2WDISU(4,1,5,3,2)
c      qactive_chan(143)= .true.   ! db em to enu ub g     Bt1g2WDIS(4,5,1,3,2)  qbemBt1g2WDISU(4,5,1,3,2)
c      qactive_chan(144)= .true.   ! Q em subtraction                            qpemBt1g2WDISU(1,4,5,3,2)
c      qactive_chan(145)= .true.   ! Qb em subtraction                           qpbemBt1g2WDISU(1,4,5,3,2)
c      qactive_chan(146)= .true.   ! d em subtraction                            demBt1g2WDISU(1,4,5,3,2)
c      qactive_chan(147)= .true.   ! ub em subtraction                           ubemBt1g2WDISU(1,4,5,3,2)
c      qactive_chan(148)= .true.   ! u em to enu g d       Btt1g2WDIS(1,4,5,3,2)  qemBtt1g2WDISU(1,4,5,3,2)
c      qactive_chan(149)= .true.   ! g em to enu ub d      Btt1g2WDIS(4,1,5,3,2)  gemBtt1g2WDISU(4,1,5,3,2)
c      qactive_chan(150)= .true.   ! db em to enu ub g     Btt1g2WDIS(4,5,1,3,2)  qbemBtt1g2WDISU(4,5,1,3,2)
c      qactive_chan(151)= .true.   ! Q em subtraction                            qpemBtt1g2WDISU(1,4,5,3,2)
c      qactive_chan(152)= .true.   ! Qb em subtraction                           qpbemBtt1g2WDISU(1,4,5,3,2)
c      qactive_chan(153)= .true.   ! d em subtraction                            demBtt1g2WDISU(1,4,5,3,2)
c      qactive_chan(154)= .true.   ! ub em subtraction                           ubemBtt1g2WDISU(1,4,5,3,2)
c      qactive_chan(155)= .true.   ! u em to enu g d       Bh1g2WDIS(1,4,5,3,2)  qemBh1g2WDISU(1,4,5,3,2)
c      qactive_chan(156)= .true.   ! g em to enu ub d      Bh1g2WDIS(4,1,5,3,2)  gemBh1g2WDISU(4,1,5,3,2)
c      qactive_chan(157)= .true.   ! db em to enu ub g     Bh1g2WDIS(4,5,1,3,2)  qbemBh1g2WDISU(4,5,1,3,2)
c      qactive_chan(158)= .true.   ! Q em subtraction                            qpemBh1g2WDISU(1,4,5,3,2)
c      qactive_chan(159)= .true.   ! Qb em subtraction                           qpbemBh1g2WDISU(1,4,5,3,2)
c      qactive_chan(160)= .true.   ! d em subtraction                            demBh1g2WDISU(1,4,5,3,2)
c      qactive_chan(161)= .true.   ! ub em subtraction                           ubemBh1g2WDISU(1,4,5,3,2)
c      qactive_chan(162)= .true.   ! u em to enu g d       Bht1g2WDIS(1,4,5,3,2)  qemBht1g2WDISU(1,4,5,3,2)
c      qactive_chan(163)= .true.   ! g em to enu ub d      Bht1g2WDIS(4,1,5,3,2)  gemBht1g2WDISU(4,1,5,3,2)
c      qactive_chan(164)= .true.   ! db em to enu ub g     Bht1g2WDIS(4,5,1,3,2)  qbemBht1g2WDISU(4,5,1,3,2)
c      qactive_chan(165)= .true.   ! Q em subtraction                            qpemBht1g2WDISU(1,4,5,3,2)
c      qactive_chan(166)= .true.   ! Qb em subtraction                           qpbemBht1g2WDISU(1,4,5,3,2)
c      qactive_chan(167)= .true.   ! d em subtraction                            demBht1g2WDISU(1,4,5,3,2)
c      qactive_chan(168)= .true.   ! ub em subtraction                           ubemBht1g2WDISU(1,4,5,3,2)
c      qactive_chan(169)= .true.   ! u em to enu g d       Bhh1g2WDIS(1,4,5,3,2)  qemBhh1g2WDISU(1,4,5,3,2)
c      qactive_chan(170)= .true.   ! g em to enu ub d      Bhh1g2WDIS(4,1,5,3,2)  gemBhh1g2WDISU(4,1,5,3,2)
c      qactive_chan(171)= .true.   ! db em to enu ub g     Bhh1g2WDIS(4,5,1,3,2)  qbemBhh1g2WDISU(4,5,1,3,2)
c      qactive_chan(172)= .true.   ! Q em subtraction                            qpemBhh1g2WDISU(1,4,5,3,2)
c      qactive_chan(173)= .true.   ! Qb em subtraction                           qpbemBhh1g2WDISU(1,4,5,3,2)
c      qactive_chan(174)= .true.   ! d em subtraction                            demBhh1g2WDISU(1,4,5,3,2)
c      qactive_chan(175)= .true.   ! ub em subtraction                           ubemBhh1g2WDISU(1,4,5,3,2)

      do i=134,175
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelDISWm(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'u em to enu g d     '
        me_str   = 'B1g0WDIS(1,4,5,3,2) '
        sub_str  = ''

      case (2)
        chan_str = 'g em to enu ub d    '
        me_str   = 'B1g0WDIS(4,1,5,3,2) '
        sub_str  = ''

      case (3)
        chan_str = 'db em to enu ub g   '
        me_str   = 'B1g0WDIS(4,5,1,3,2) '
        sub_str  = ''

      case (4)
        chan_str = 'u em to enu g g d   '
        me_str   = 'B2g0WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemB2g0WDISSNLO(1,4,5,6,3,2)'

      case (5)
        chan_str = 'g em to enu ub g d  '
        me_str   = 'B2g0WDIS(4,1,5,6,3,2)'
        sub_str  = 'gemB2g0WDISSNLO(4,1,5,6,3,2)'

      case (6)
        chan_str = 'db em to enu ub g g '
        me_str   = 'B2g0WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemB2g0WDISSNLO(4,5,6,1,3,2)'

      case (7)
        chan_str = 'u em to enu gt gt d '
        me_str   = 'Bt2g0WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemBt2g0WDISSNLO(1,4,5,6,3,2)'

      case (8)
        chan_str = 'gt em to enu ub gt d '
        me_str   = 'Bt2g0WDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemBt2g0WDISSNLO(4,1,5,6,3,2)'

      case (9)
        chan_str = 'db em to enu ub gt gt '
        me_str   = 'Bt2g0WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemBt2g0WDISSNLO(4,5,6,1,3,2)'

      case (10)
        chan_str = 'u em to enu Q Qb d  '
        me_str   = 'C0g0WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemC0g0WDISSNLO(1,4,5,6,3,2)'

      case (11)
        chan_str = 'Qb em to enu ub Qb d '
        me_str   = 'C0g0WDIS(4,1,5,6,3,2)'
        sub_str  = 'qpbemC0g0WDISSNLO(4,1,5,6,3,2)'

      case (12)
        chan_str = 'Q em to enu ub Q d  '
        me_str   = 'C0g0WDIS(4,5,1,6,3,2)'
        sub_str  = 'qpemC0g0WDISSNLO(4,5,1,6,3,2)'

      case (13)
        chan_str = 'db em to enu ub Q Qb '
        me_str   = 'C0g0WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemC0g0WDISSNLO(4,5,6,1,3,2)'

      case (14)
        chan_str = 'u em to enu u ub d  '
        me_str   = 'D0g0WaDIS(1,4,5,6,3,2)'
        sub_str  = 'qemD0g0WaDISSNLO(1,4,5,6,3,2)'

      case (15)
        chan_str = 'ub em to enu ub ub d '
        me_str   = 'D0g0WaDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemD0g0WaDISSNLO(4,1,5,6,3,2)'

      case (16)
        chan_str = 'db em to enu ub u ub '
        me_str   = 'D0g0WaDIS(4,5,6,1,3,2)'
        sub_str  = 'qpbemD0g0WaDISSNLO(4,5,6,1,3,2)'

      case (17)
        chan_str = 'u em to enu d db d  '
        me_str   = 'D0g0WbDIS(1,4,5,6,3,2)'
        sub_str  = 'qemD0g0WbDISSNLO(1,4,5,6,3,2)'

      case (18)
        chan_str = 'db em to enu ub db d '
        me_str   = 'D0g0WbDIS(4,1,5,6,3,2)'
        sub_str  = 'qpbemD0g0WbDISSNLO(4,1,5,6,3,2)'

      case (19)
        chan_str = 'd em to enu ub d d  '
        me_str   = 'D0g0WbDIS(4,5,1,6,3,2)'
        sub_str  = 'qpemD0g0WbDISSNLO(4,5,1,6,3,2)'

      case (20)
        chan_str = 'u em to enu g d     '
        me_str   = 'B1g1WDIS(1,4,5,3,2) '
        sub_str  = 'qemB1g1WDISTNLO(1,4,5,3,2)'

      case (21)
        chan_str = 'g em to enu ub d    '
        me_str   = 'B1g1WDIS(4,1,5,3,2) '
        sub_str  = 'gemB1g1WDISTNLO(4,1,5,3,2)'

      case (22)
        chan_str = 'db em to enu ub g   '
        me_str   = 'B1g1WDIS(4,5,1,3,2) '
        sub_str  = 'qbemB1g1WDISTNLO(4,5,1,3,2)'

      case (23)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB1g1WDISTNLO(1,4,5,3,2)'

      case (24)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB1g1WDISTNLO(1,4,5,3,2)'

      case (25)
        chan_str = 'u em to enu g d     '
        me_str   = 'Bt1g1WDIS(1,4,5,3,2)'
        sub_str  = 'qemBt1g1WDISTNLO(1,4,5,3,2)'

      case (26)
        chan_str = 'g em to enu ub d    '
        me_str   = 'Bt1g1WDIS(4,1,5,3,2)'
        sub_str  = 'gemBt1g1WDISTNLO(4,1,5,3,2)'

      case (27)
        chan_str = 'db em to enu ub g   '
        me_str   = 'Bt1g1WDIS(4,5,1,3,2)'
        sub_str  = 'qbemBt1g1WDISTNLO(4,5,1,3,2)'

      case (28)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBt1g1WDISTNLO(1,4,5,3,2)'

      case (29)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBt1g1WDISTNLO(1,4,5,3,2)'

      case (30)
        chan_str = 'u em to enu g d     '
        me_str   = 'Bh1g1WDIS(1,4,5,3,2)'
        sub_str  = 'qemBh1g1WDISTNLO(1,4,5,3,2)'

      case (31)
        chan_str = 'g em to enu ub d    '
        me_str   = 'Bh1g1WDIS(4,1,5,3,2)'
        sub_str  = 'gemBh1g1WDISTNLO(4,1,5,3,2)'

      case (32)
        chan_str = 'db em to enu ub g   '
        me_str   = 'Bh1g1WDIS(4,5,1,3,2)'
        sub_str  = 'qbemBh1g1WDISTNLO(4,5,1,3,2)'

      case (33)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBh1g1WDISTNLO(1,4,5,3,2)'

      case (34)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBh1g1WDISTNLO(1,4,5,3,2)'

      case (35)
        chan_str = 'u em to enu g g g d '
        me_str   = 'sB3g0WDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsB3g0WDISS(1,4,5,6,7,3,2)'

      case (36)
        chan_str = 'g em to enu ub g g d '
        me_str   = 'sB3g0WDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsB3g0WDISS(4,1,5,6,7,3,2)'

      case (37)
        chan_str = 'db em to enu ub g g g '
        me_str   = 'sB3g0WDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsB3g0WDISS(4,5,6,7,1,3,2)'

      case (38)
        chan_str = 'u em to enu g g g d '
        me_str   = 'sBt3g0WDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsBt3g0WDISS(1,4,5,6,7,3,2)'

      case (39)
        chan_str = 'g em to enu ub g g d '
        me_str   = 'sBt3g0WDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsBt3g0WDISS(4,1,5,6,7,3,2)'

      case (40)
        chan_str = 'db em to enu ub g g g '
        me_str   = 'sBt3g0WDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsBt3g0WDISS(4,5,6,7,1,3,2)'

      case (41)
        chan_str = 'u em to enu gt gt gt d '
        me_str   = 'sBtt3g0WDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsBtt3g0WDISS(1,4,5,6,7,3,2)'

      case (42)
        chan_str = 'gt em to enu ub gt gt d '
        me_str   = 'sBtt3g0WDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gtemsBtt3g0WDISS(4,1,5,6,7,3,2)'

      case (43)
        chan_str = 'db em to enu ub gt gt gt '
        me_str   = 'sBtt3g0WDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsBtt3g0WDISS(4,5,6,7,1,3,2)'

      case (44)
        chan_str = 'u em to enu g Q Qb d '
        me_str   = 'sC1g0WDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsC1g0WDISS(1,4,5,6,7,3,2)'

      case (45)
        chan_str = 'g em to enu ub Q Qb d '
        me_str   = 'sC1g0WDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsC1g0WDISS(4,1,5,6,7,3,2)'

      case (46)
        chan_str = 'Qb em to enu ub g Qb d '
        me_str   = 'sC1g0WDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qpbemsC1g0WDISS(4,5,1,6,7,3,2)'

      case (47)
        chan_str = 'Q em to enu ub g Q d '
        me_str   = 'sC1g0WDIS(4,5,6,1,7,3,2)'
        sub_str  = 'qpemsC1g0WDISS(4,5,6,1,7,3,2)'

      case (48)
        chan_str = 'db em to enu ub g Q Qb '
        me_str   = 'sC1g0WDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsC1g0WDISS(4,5,6,7,1,3,2)'

      case (49)
        chan_str = 'u em to enu g Q Qb d '
        me_str   = 'sCt1g0WDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemsCt1g0WDISS(1,4,5,6,7,3,2)'

      case (50)
        chan_str = 'g em to enu ub Q Qb d '
        me_str   = 'sCt1g0WDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemsCt1g0WDISS(4,1,5,6,7,3,2)'

      case (51)
        chan_str = 'Qb em to enu ub g Qb d '
        me_str   = 'sCt1g0WDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qpbemsCt1g0WDISS(4,5,1,6,7,3,2)'

      case (52)
        chan_str = 'Q em to enu ub g Q d '
        me_str   = 'sCt1g0WDIS(4,5,6,1,7,3,2)'
        sub_str  = 'qpemsCt1g0WDISS(4,5,6,1,7,3,2)'

      case (53)
        chan_str = 'db em to enu ub g Q Qb '
        me_str   = 'sCt1g0WDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qbemsCt1g0WDISS(4,5,6,7,1,3,2)'

      case (54)
        chan_str = 'u em to enu g u ub d '
        me_str   = 'D1g0WpacDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemD1g0WpacDISS(1,4,5,6,7,3,2)'

      case (55)
        chan_str = 'g em to enu ub u ub d '
        me_str   = 'D1g0WpacDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemD1g0WpacDISS(4,1,5,6,7,3,2)'

      case (56)
        chan_str = 'ub em to enu ub g ub d '
        me_str   = 'D1g0WpacDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qbemD1g0WpacDISS(4,5,1,6,7,3,2)'

      case (57)
        chan_str = 'db em to enu ub g u ub '
        me_str   = 'D1g0WpacDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qpbemD1g0WpacDISS(4,5,6,7,1,3,2)'

      case (58)
        chan_str = 'u em to enu g d db d '
        me_str   = 'D1g0WpbcDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemD1g0WpbcDISS(1,4,5,6,7,3,2)'

      case (59)
        chan_str = 'g em to enu ub d db d '
        me_str   = 'D1g0WpbcDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemD1g0WpbcDISS(4,1,5,6,7,3,2)'

      case (60)
        chan_str = 'db em to enu ub g db d '
        me_str   = 'D1g0WpbcDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qpbemD1g0WpbcDISS(4,5,1,6,7,3,2)'

      case (61)
        chan_str = 'd em to enu ub g d d '
        me_str   = 'D1g0WpbcDIS(4,5,6,1,7,3,2)'
        sub_str  = 'qpemD1g0WpbcDISS(4,5,6,1,7,3,2)'

      case (62)
        chan_str = 'u em to enu g u ub d '
        me_str   = 'Dt1g0WpaDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemDt1g0WpaDISS(1,4,5,6,7,3,2)'

      case (63)
        chan_str = 'g em to enu ub u ub d '
        me_str   = 'Dt1g0WpaDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemDt1g0WpaDISS(4,1,5,6,7,3,2)'

      case (64)
        chan_str = 'ub em to enu ub g ub d '
        me_str   = 'Dt1g0WpaDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qbemDt1g0WpaDISS(4,5,1,6,7,3,2)'

      case (65)
        chan_str = 'db em to enu ub g u ub '
        me_str   = 'Dt1g0WpaDIS(4,5,6,7,1,3,2)'
        sub_str  = 'qpbemDt1g0WpaDISS(4,5,6,7,1,3,2)'

      case (66)
        chan_str = 'u em to enu g d db d '
        me_str   = 'Dt1g0WpbDIS(1,4,5,6,7,3,2)'
        sub_str  = 'qemDt1g0WpbDISS(1,4,5,6,7,3,2)'

      case (67)
        chan_str = 'g em to enu ub d db d '
        me_str   = 'Dt1g0WpbDIS(4,1,5,6,7,3,2)'
        sub_str  = 'gemDt1g0WpbDISS(4,1,5,6,7,3,2)'

      case (68)
        chan_str = 'db em to enu ub g db d '
        me_str   = 'Dt1g0WpbDIS(4,5,1,6,7,3,2)'
        sub_str  = 'qpbemDt1g0WpbDISS(4,5,1,6,7,3,2)'

      case (69)
        chan_str = 'd em to enu ub g d d '
        me_str   = 'Dt1g0WpbDIS(4,5,6,1,7,3,2)'
        sub_str  = 'qpemDt1g0WpbDISS(4,5,6,1,7,3,2)'

      case (70)
        chan_str = 'u em to enu g g d   '
        me_str   = 'sB2g1WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsB2g1WDIST(1,4,5,6,3,2)'

      case (71)
        chan_str = 'g em to enu ub g d  '
        me_str   = 'sB2g1WDIS(4,1,5,6,3,2)'
        sub_str  = 'gemsB2g1WDIST(4,1,5,6,3,2)'

      case (72)
        chan_str = 'db em to enu ub g g '
        me_str   = 'sB2g1WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsB2g1WDIST(4,5,6,1,3,2)'

      case (73)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsB2g1WDIST(1,4,5,6,3,2)'

      case (74)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsB2g1WDIST(1,4,5,6,3,2)'

      case (75)
        chan_str = 'u em to enu gt gt d '
        me_str   = 'sBt2g1WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBt2g1WDIST(1,4,5,6,3,2)'

      case (76)
        chan_str = 'gt em to enu ub gt d '
        me_str   = 'sBt2g1WDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemsBt2g1WDIST(4,1,5,6,3,2)'

      case (77)
        chan_str = 'db em to enu ub gt gt '
        me_str   = 'sBt2g1WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBt2g1WDIST(4,5,6,1,3,2)'

      case (78)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBt2g1WDIST(1,4,5,6,3,2)'

      case (79)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBt2g1WDIST(1,4,5,6,3,2)'

      case (80)
        chan_str = 'u em to enu gt gt d '
        me_str   = 'sBttt2g1WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBttt2g1WDIST(1,4,5,6,3,2)'

      case (81)
        chan_str = 'gt em to enu ub gt d '
        me_str   = 'sBttt2g1WDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemsBttt2g1WDIST(4,1,5,6,3,2)'

      case (82)
        chan_str = 'db em to enu ub gt gt '
        me_str   = 'sBttt2g1WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBttt2g1WDIST(4,5,6,1,3,2)'

      case (83)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBttt2g1WDIST(1,4,5,6,3,2)'

      case (84)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBttt2g1WDIST(1,4,5,6,3,2)'

      case (85)
        chan_str = 'u em to enu g g d   '
        me_str   = 'sBh2g1WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBh2g1WDIST(1,4,5,6,3,2)'

      case (86)
        chan_str = 'g em to enu ub g d  '
        me_str   = 'sBh2g1WDIS(4,1,5,6,3,2)'
        sub_str  = 'gemsBh2g1WDIST(4,1,5,6,3,2)'

      case (87)
        chan_str = 'db em to enu ub g g '
        me_str   = 'sBh2g1WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBh2g1WDIST(4,5,6,1,3,2)'

      case (88)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBh2g1WDIST(1,4,5,6,3,2)'

      case (89)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBh2g1WDIST(1,4,5,6,3,2)'

      case (90)
        chan_str = 'u em to enu gt gt d '
        me_str   = 'sBth2g1WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsBth2g1WDIST(1,4,5,6,3,2)'

      case (91)
        chan_str = 'gt em to enu ub gt d '
        me_str   = 'sBth2g1WDIS(4,1,5,6,3,2)'
        sub_str  = 'gtemsBth2g1WDIST(4,1,5,6,3,2)'

      case (92)
        chan_str = 'db em to enu ub gt gt '
        me_str   = 'sBth2g1WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsBth2g1WDIST(4,5,6,1,3,2)'

      case (93)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemsBth2g1WDIST(1,4,5,6,3,2)'

      case (94)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemsBth2g1WDIST(1,4,5,6,3,2)'

      case (95)
        chan_str = 'u em to enu Q Qb d  '
        me_str   = 'sC0g1WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g1WDIST(1,4,5,6,3,2)'

      case (96)
        chan_str = 'Qb em to enu ub Qb d '
        me_str   = 'sC0g1WDIS(4,1,5,6,3,2)'
        sub_str  = 'qpbemsC0g1WDIST(4,1,5,6,3,2)'

      case (97)
        chan_str = 'Q em to enu ub Q d  '
        me_str   = 'sC0g1WDIS(4,5,1,6,3,2)'
        sub_str  = 'qpemsC0g1WDIST(4,5,1,6,3,2)'

      case (98)
        chan_str = 'db em to enu ub Q Qb '
        me_str   = 'sC0g1WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g1WDIST(4,5,6,1,3,2)'

      case (99)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemsC0g1WDIST(1,4,5,6,3,2)'

      case (100)
        chan_str = 'u em to enu Q Qb d  '
        me_str   = 'Ct0g1WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCt0g1WDIST(1,4,5,6,3,2)'

      case (101)
        chan_str = 'Qb em to enu ub Qb d '
        me_str   = 'Ct0g1WDIS(4,1,5,6,3,2)'
        sub_str  = 'qpbemCt0g1WDIST(4,1,5,6,3,2)'

      case (102)
        chan_str = 'Q em to enu ub Q d  '
        me_str   = 'Ct0g1WDIS(4,5,1,6,3,2)'
        sub_str  = 'qpemCt0g1WDIST(4,5,1,6,3,2)'

      case (103)
        chan_str = 'db em to enu ub Q Qb '
        me_str   = 'Ct0g1WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCt0g1WDIST(4,5,6,1,3,2)'

      case (104)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCt0g1WDIST(1,4,5,6,3,2)'

      case (105)
        chan_str = 'u em to enu Q Qb d  '
        me_str   = 'Ch0g1WDIS(1,4,5,6,3,2)'
        sub_str  = 'qemCh0g1WDIST(1,4,5,6,3,2)'

      case (106)
        chan_str = 'Qb em to enu ub Qb d '
        me_str   = 'Ch0g1WDIS(4,1,5,6,3,2)'
        sub_str  = 'qpbemCh0g1WDIST(4,1,5,6,3,2)'

      case (107)
        chan_str = 'Q em to enu ub Q d  '
        me_str   = 'Ch0g1WDIS(4,5,1,6,3,2)'
        sub_str  = 'qpemCh0g1WDIST(4,5,1,6,3,2)'

      case (108)
        chan_str = 'db em to enu ub Q Qb '
        me_str   = 'Ch0g1WDIS(4,5,6,1,3,2)'
        sub_str  = 'qbemCh0g1WDIST(4,5,6,1,3,2)'

      case (109)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemCh0g1WDIST(1,4,5,6,3,2)'

      case (110)
        chan_str = 'u em to enu u ub d  '
        me_str   = 'D0g1WpaDIS(1,4,5,6,3,2)'
        sub_str  = 'qemD0g1WpaDIST(1,4,5,6,3,2)'

      case (111)
        chan_str = 'ub em to enu ub ub d '
        me_str   = 'D0g1WpaDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemD0g1WpaDIST(4,1,5,6,3,2)'

      case (112)
        chan_str = 'db em to enu ub u ub '
        me_str   = 'D0g1WpaDIS(4,5,6,1,3,2)'
        sub_str  = 'qpbemD0g1WpaDIST(4,5,6,1,3,2)'

      case (113)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemD0g1WpaDIST(1,4,5,6,3,2)'

      case (114)
        chan_str = 'u em to enu d db d  '
        me_str   = 'D0g1WpbDIS(1,4,5,6,3,2)'
        sub_str  = 'qemD0g1WpbDIST(1,4,5,6,3,2)'

      case (115)
        chan_str = 'db em to enu ub db d '
        me_str   = 'D0g1WpbDIS(4,1,5,6,3,2)'
        sub_str  = 'qpbemD0g1WpbDIST(4,1,5,6,3,2)'

      case (116)
        chan_str = 'd em to enu ub d d  '
        me_str   = 'D0g1WpbDIS(4,5,1,6,3,2)'
        sub_str  = 'qpemD0g1WpbDIST(4,5,1,6,3,2)'

      case (117)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemD0g1WpbDIST(1,4,5,6,3,2)'

      case (118)
        chan_str = 'u em to enu u ub d  '
        me_str   = 'Dt0g1WpaDIS(1,4,5,6,3,2)'
        sub_str  = 'qemDt0g1WpaDIST(1,4,5,6,3,2)'

      case (119)
        chan_str = 'ub em to enu ub ub d '
        me_str   = 'Dt0g1WpaDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemDt0g1WpaDIST(4,1,5,6,3,2)'

      case (120)
        chan_str = 'db em to enu ub u ub '
        me_str   = 'Dt0g1WpaDIS(4,5,6,1,3,2)'
        sub_str  = 'qpbemDt0g1WpaDIST(4,5,6,1,3,2)'

      case (121)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemDt0g1WpaDIST(1,4,5,6,3,2)'

      case (122)
        chan_str = 'u em to enu d db d  '
        me_str   = 'Dt0g1WpbDIS(1,4,5,6,3,2)'
        sub_str  = 'qemDt0g1WpbDIST(1,4,5,6,3,2)'

      case (123)
        chan_str = 'db em to enu ub db d '
        me_str   = 'Dt0g1WpbDIS(4,1,5,6,3,2)'
        sub_str  = 'qpbemDt0g1WpbDIST(4,1,5,6,3,2)'

      case (124)
        chan_str = 'd em to enu ub d d  '
        me_str   = 'Dt0g1WpbDIS(4,5,1,6,3,2)'
        sub_str  = 'qpemDt0g1WpbDIST(4,5,1,6,3,2)'

      case (125)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemDt0g1WpbDIST(1,4,5,6,3,2)'

      case (126)
        chan_str = 'u em to enu u ub d  '
        me_str   = 'Dh0g1WpaDIS(1,4,5,6,3,2)'
        sub_str  = 'qemDh0g1WpaDIST(1,4,5,6,3,2)'

      case (127)
        chan_str = 'ub em to enu ub ub d '
        me_str   = 'Dh0g1WpaDIS(4,1,5,6,3,2)'
        sub_str  = 'qbemDh0g1WpaDIST(4,1,5,6,3,2)'

      case (128)
        chan_str = 'db em to enu ub u ub '
        me_str   = 'Dh0g1WpaDIS(4,5,6,1,3,2)'
        sub_str  = 'qpbemDh0g1WpaDIST(4,5,6,1,3,2)'

      case (129)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemDh0g1WpaDIST(1,4,5,6,3,2)'

      case (130)
        chan_str = 'u em to enu d db d  '
        me_str   = 'Dh0g1WpbDIS(1,4,5,6,3,2)'
        sub_str  = 'qemDh0g1WpbDIST(1,4,5,6,3,2)'

      case (131)
        chan_str = 'db em to enu ub db d '
        me_str   = 'Dh0g1WpbDIS(4,1,5,6,3,2)'
        sub_str  = 'qpbemDh0g1WpbDIST(4,1,5,6,3,2)'

      case (132)
        chan_str = 'd em to enu ub d d  '
        me_str   = 'Dh0g1WpbDIS(4,5,1,6,3,2)'
        sub_str  = 'qpemDh0g1WpbDIST(4,5,1,6,3,2)'

      case (133)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemDh0g1WpbDIST(1,4,5,6,3,2)'

      case (134)
        chan_str = 'u em to enu g d     '
        me_str   = 'B1g2WDIS(1,4,5,3,2) '
        sub_str  = 'qemB1g2WDISU(1,4,5,3,2)'

      case (135)
        chan_str = 'g em to enu ub d    '
        me_str   = 'B1g2WDIS(4,1,5,3,2) '
        sub_str  = 'gemB1g2WDISU(4,1,5,3,2)'

      case (136)
        chan_str = 'db em to enu ub g   '
        me_str   = 'B1g2WDIS(4,5,1,3,2) '
        sub_str  = 'qbemB1g2WDISU(4,5,1,3,2)'

      case (137)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB1g2WDISU(1,4,5,3,2)'

      case (138)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB1g2WDISU(1,4,5,3,2)'

      case (139)
        chan_str = 'd em subtraction    '
        me_str   = '                    '
        sub_str  = 'demB1g2WDISU(1,4,5,3,2)'

      case (140)
        chan_str = 'ub em subtraction   '
        me_str   = '                    '
        sub_str  = 'ubemB1g2WDISU(1,4,5,3,2)'

      case (141)
        chan_str = 'u em to enu g d     '
        me_str   = 'Bt1g2WDIS(1,4,5,3,2)'
        sub_str  = 'qemBt1g2WDISU(1,4,5,3,2)'

      case (142)
        chan_str = 'g em to enu ub d    '
        me_str   = 'Bt1g2WDIS(4,1,5,3,2)'
        sub_str  = 'gemBt1g2WDISU(4,1,5,3,2)'

      case (143)
        chan_str = 'db em to enu ub g   '
        me_str   = 'Bt1g2WDIS(4,5,1,3,2)'
        sub_str  = 'qbemBt1g2WDISU(4,5,1,3,2)'

      case (144)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBt1g2WDISU(1,4,5,3,2)'

      case (145)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBt1g2WDISU(1,4,5,3,2)'

      case (146)
        chan_str = 'd em subtraction    '
        me_str   = '                    '
        sub_str  = 'demBt1g2WDISU(1,4,5,3,2)'

      case (147)
        chan_str = 'ub em subtraction   '
        me_str   = '                    '
        sub_str  = 'ubemBt1g2WDISU(1,4,5,3,2)'

      case (148)
        chan_str = 'u em to enu g d     '
        me_str   = 'Btt1g2WDIS(1,4,5,3,2)'
        sub_str  = 'qemBtt1g2WDISU(1,4,5,3,2)'

      case (149)
        chan_str = 'g em to enu ub d    '
        me_str   = 'Btt1g2WDIS(4,1,5,3,2)'
        sub_str  = 'gemBtt1g2WDISU(4,1,5,3,2)'

      case (150)
        chan_str = 'db em to enu ub g   '
        me_str   = 'Btt1g2WDIS(4,5,1,3,2)'
        sub_str  = 'qbemBtt1g2WDISU(4,5,1,3,2)'

      case (151)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBtt1g2WDISU(1,4,5,3,2)'

      case (152)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBtt1g2WDISU(1,4,5,3,2)'

      case (153)
        chan_str = 'd em subtraction    '
        me_str   = '                    '
        sub_str  = 'demBtt1g2WDISU(1,4,5,3,2)'

      case (154)
        chan_str = 'ub em subtraction   '
        me_str   = '                    '
        sub_str  = 'ubemBtt1g2WDISU(1,4,5,3,2)'

      case (155)
        chan_str = 'u em to enu g d     '
        me_str   = 'Bh1g2WDIS(1,4,5,3,2)'
        sub_str  = 'qemBh1g2WDISU(1,4,5,3,2)'

      case (156)
        chan_str = 'g em to enu ub d    '
        me_str   = 'Bh1g2WDIS(4,1,5,3,2)'
        sub_str  = 'gemBh1g2WDISU(4,1,5,3,2)'

      case (157)
        chan_str = 'db em to enu ub g   '
        me_str   = 'Bh1g2WDIS(4,5,1,3,2)'
        sub_str  = 'qbemBh1g2WDISU(4,5,1,3,2)'

      case (158)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBh1g2WDISU(1,4,5,3,2)'

      case (159)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBh1g2WDISU(1,4,5,3,2)'

      case (160)
        chan_str = 'd em subtraction    '
        me_str   = '                    '
        sub_str  = 'demBh1g2WDISU(1,4,5,3,2)'

      case (161)
        chan_str = 'ub em subtraction   '
        me_str   = '                    '
        sub_str  = 'ubemBh1g2WDISU(1,4,5,3,2)'

      case (162)
        chan_str = 'u em to enu g d     '
        me_str   = 'Bht1g2WDIS(1,4,5,3,2)'
        sub_str  = 'qemBht1g2WDISU(1,4,5,3,2)'

      case (163)
        chan_str = 'g em to enu ub d    '
        me_str   = 'Bht1g2WDIS(4,1,5,3,2)'
        sub_str  = 'gemBht1g2WDISU(4,1,5,3,2)'

      case (164)
        chan_str = 'db em to enu ub g   '
        me_str   = 'Bht1g2WDIS(4,5,1,3,2)'
        sub_str  = 'qbemBht1g2WDISU(4,5,1,3,2)'

      case (165)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBht1g2WDISU(1,4,5,3,2)'

      case (166)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBht1g2WDISU(1,4,5,3,2)'

      case (167)
        chan_str = 'd em subtraction    '
        me_str   = '                    '
        sub_str  = 'demBht1g2WDISU(1,4,5,3,2)'

      case (168)
        chan_str = 'ub em subtraction   '
        me_str   = '                    '
        sub_str  = 'ubemBht1g2WDISU(1,4,5,3,2)'

      case (169)
        chan_str = 'u em to enu g d     '
        me_str   = 'Bhh1g2WDIS(1,4,5,3,2)'
        sub_str  = 'qemBhh1g2WDISU(1,4,5,3,2)'

      case (170)
        chan_str = 'g em to enu ub d    '
        me_str   = 'Bhh1g2WDIS(4,1,5,3,2)'
        sub_str  = 'gemBhh1g2WDISU(4,1,5,3,2)'

      case (171)
        chan_str = 'db em to enu ub g   '
        me_str   = 'Bhh1g2WDIS(4,5,1,3,2)'
        sub_str  = 'qbemBhh1g2WDISU(4,5,1,3,2)'

      case (172)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBhh1g2WDISU(1,4,5,3,2)'

      case (173)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBhh1g2WDISU(1,4,5,3,2)'

      case (174)
        chan_str = 'd em subtraction    '
        me_str   = '                    '
        sub_str  = 'demBhh1g2WDISU(1,4,5,3,2)'

      case (175)
        chan_str = 'ub em subtraction   '
        me_str   = '                    '
        sub_str  = 'ubemBhh1g2WDISU(1,4,5,3,2)'

      case default
        print*, 'getchannelDISWm: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtDISWm(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtDISWm = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (4)
        ! [enu, g, g, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (6)
        ! [enu, ub, g, g]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (7)
        ! [enu, gt, gt, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (9)
        ! [enu, ub, gt, gt]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (15)
        ! [enu, ub, ub, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (16)
        ! [enu, ub, u, ub]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (17)
        ! [enu, d, db, d]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (19)
        ! [enu, ub, d, d]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (35)
        ! [enu, g, g, g, d]
        LIPSwgtDISWm = weight_lips((/ 4,5,6 /))

      case (36)
        ! [enu, ub, g, g, d]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (37)
        ! [enu, ub, g, g, g]
        LIPSwgtDISWm = weight_lips((/ 5,6,7 /))

      case (38)
        ! [enu, g, g, g, d]
        LIPSwgtDISWm = weight_lips((/ 4,5,6 /))

      case (39)
        ! [enu, ub, g, g, d]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (40)
        ! [enu, ub, g, g, g]
        LIPSwgtDISWm = weight_lips((/ 5,6,7 /))

      case (41)
        ! [enu, gt, gt, gt, d]
        LIPSwgtDISWm = weight_lips((/ 4,5,6 /))

      case (42)
        ! [enu, ub, gt, gt, d]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (43)
        ! [enu, ub, gt, gt, gt]
        LIPSwgtDISWm = weight_lips((/ 5,6,7 /))

      case (55)
        ! [enu, ub, u, ub, d]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (56)
        ! [enu, ub, g, ub, d]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (57)
        ! [enu, ub, g, u, ub]
        LIPSwgtDISWm = weight_lips((/ 4,7 /))

      case (58)
        ! [enu, g, d, db, d]
        LIPSwgtDISWm = weight_lips((/ 5,7 /))

      case (59)
        ! [enu, ub, d, db, d]
        LIPSwgtDISWm = weight_lips((/ 5,7 /))

      case (61)
        ! [enu, ub, g, d, d]
        LIPSwgtDISWm = weight_lips((/ 6,7 /))

      case (63)
        ! [enu, ub, u, ub, d]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (64)
        ! [enu, ub, g, ub, d]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (65)
        ! [enu, ub, g, u, ub]
        LIPSwgtDISWm = weight_lips((/ 4,7 /))

      case (66)
        ! [enu, g, d, db, d]
        LIPSwgtDISWm = weight_lips((/ 5,7 /))

      case (67)
        ! [enu, ub, d, db, d]
        LIPSwgtDISWm = weight_lips((/ 5,7 /))

      case (69)
        ! [enu, ub, g, d, d]
        LIPSwgtDISWm = weight_lips((/ 6,7 /))

      case (70)
        ! [enu, g, g, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (72)
        ! [enu, ub, g, g]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (75)
        ! [enu, gt, gt, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (77)
        ! [enu, ub, gt, gt]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (80)
        ! [enu, gt, gt, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (82)
        ! [enu, ub, gt, gt]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (85)
        ! [enu, g, g, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (87)
        ! [enu, ub, g, g]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (90)
        ! [enu, gt, gt, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (92)
        ! [enu, ub, gt, gt]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (111)
        ! [enu, ub, ub, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (112)
        ! [enu, ub, u, ub]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (114)
        ! [enu, d, db, d]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (116)
        ! [enu, ub, d, d]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (119)
        ! [enu, ub, ub, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (120)
        ! [enu, ub, u, ub]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (122)
        ! [enu, d, db, d]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (124)
        ! [enu, ub, d, d]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case (127)
        ! [enu, ub, ub, d]
        LIPSwgtDISWm = weight_lips((/ 4,5 /))

      case (128)
        ! [enu, ub, u, ub]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (130)
        ! [enu, d, db, d]
        LIPSwgtDISWm = weight_lips((/ 4,6 /))

      case (132)
        ! [enu, ub, d, d]
        LIPSwgtDISWm = weight_lips((/ 5,6 /))

      case default
        LIPSwgtDISWm = 1

      end select
      end
