      subroutine selectchannelDISWp()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*alphas_scl)*(4d0*pi*amzw/stw)**2*(nc**2-1)
      n_alphas_proc = 1
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelDISWp: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelDISWp: already allocated'  
        stop
      end if

      ntot_chan = 175

      allocate(qactive_chan(1:175))
      allocate(contrib_chan(1:175))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! d ep to enub g u      B1g0WDIS(1,4,5,2,3)   
c      qactive_chan(2)  = .true.   ! g ep to enub db u     B1g0WDIS(4,1,5,2,3)   
c      qactive_chan(3)  = .true.   ! ub ep to enub db g    B1g0WDIS(4,5,1,2,3)   

      do i=1,3
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(4)  = .true.   ! d ep to enub g g u    B2g0WDIS(1,4,5,6,2,3)  qepB2g0WDISSNLO(1,4,5,6,2,3)
c      qactive_chan(5)  = .true.   ! g ep to enub db g u   B2g0WDIS(4,1,5,6,2,3)  gepB2g0WDISSNLO(4,1,5,6,2,3)
c      qactive_chan(6)  = .true.   ! ub ep to enub db g g   B2g0WDIS(4,5,6,1,2,3)  qbepB2g0WDISSNLO(4,5,6,1,2,3)
c      qactive_chan(7)  = .true.   ! d ep to enub gt gt u   Bt2g0WDIS(1,4,5,6,2,3)  qepBt2g0WDISSNLO(1,4,5,6,2,3)
c      qactive_chan(8)  = .true.   ! gt ep to enub db gt u   Bt2g0WDIS(4,1,5,6,2,3)  gtepBt2g0WDISSNLO(4,1,5,6,2,3)
c      qactive_chan(9)  = .true.   ! ub ep to enub db gt gt   Bt2g0WDIS(4,5,6,1,2,3)  qbepBt2g0WDISSNLO(4,5,6,1,2,3)
c      qactive_chan(10) = .true.   ! d ep to enub Q Qb u   C0g0WDIS(1,4,5,6,2,3)  qepC0g0WDISSNLO(1,4,5,6,2,3)
c      qactive_chan(11) = .true.   ! Qb ep to enub db Qb u   C0g0WDIS(4,1,5,6,2,3)  qpbepC0g0WDISSNLO(4,1,5,6,2,3)
c      qactive_chan(12) = .true.   ! Q ep to enub db Q u   C0g0WDIS(4,5,1,6,2,3)  qpepC0g0WDISSNLO(4,5,1,6,2,3)
c      qactive_chan(13) = .true.   ! ub ep to enub db Q Qb   C0g0WDIS(4,5,6,1,2,3)  qbepC0g0WDISSNLO(4,5,6,1,2,3)
c      qactive_chan(14) = .true.   ! d ep to enub d db u   D0g0WaDIS(1,4,5,6,2,3)  qpepD0g0WaDISSNLO(1,4,5,6,2,3)
c      qactive_chan(15) = .true.   ! db ep to enub db db u   D0g0WaDIS(4,1,5,6,2,3)  qpbepD0g0WaDISSNLO(4,1,5,6,2,3)
c      qactive_chan(16) = .true.   ! ub ep to enub db d db   D0g0WaDIS(4,5,6,1,2,3)  qbepD0g0WaDISSNLO(4,5,6,1,2,3)
c      qactive_chan(17) = .true.   ! d ep to enub u ub u   D0g0WbDIS(1,4,5,6,2,3)  qpepD0g0WbDISSNLO(1,4,5,6,2,3)
c      qactive_chan(18) = .true.   ! ub ep to enub db ub u   D0g0WbDIS(4,1,5,6,2,3)  qbepD0g0WbDISSNLO(4,1,5,6,2,3)
c      qactive_chan(19) = .true.   ! u ep to enub db u u   D0g0WbDIS(4,5,1,6,2,3)  qepD0g0WbDISSNLO(4,5,1,6,2,3)

      do i=4,19
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(20) = .true.   ! d ep to enub g u      B1g1WDIS(1,4,5,2,3)   qepB1g1WDISTNLO(1,4,5,2,3)
c      qactive_chan(21) = .true.   ! g ep to enub db u     B1g1WDIS(4,1,5,2,3)   gepB1g1WDISTNLO(4,1,5,2,3)
c      qactive_chan(22) = .true.   ! ub ep to enub db g    B1g1WDIS(4,5,1,2,3)   qbepB1g1WDISTNLO(4,5,1,2,3)
c      qactive_chan(23) = .true.   ! Q ep subtraction                            qpepB1g1WDISTNLO(1,4,5,2,3)
c      qactive_chan(24) = .true.   ! Qb ep subtraction                           qpbepB1g1WDISTNLO(1,4,5,2,3)
c      qactive_chan(25) = .true.   ! d ep to enub g u      Bt1g1WDIS(1,4,5,2,3)  qepBt1g1WDISTNLO(1,4,5,2,3)
c      qactive_chan(26) = .true.   ! g ep to enub db u     Bt1g1WDIS(4,1,5,2,3)  gepBt1g1WDISTNLO(4,1,5,2,3)
c      qactive_chan(27) = .true.   ! ub ep to enub db g    Bt1g1WDIS(4,5,1,2,3)  qbepBt1g1WDISTNLO(4,5,1,2,3)
c      qactive_chan(28) = .true.   ! Q ep subtraction                            qpepBt1g1WDISTNLO(1,4,5,2,3)
c      qactive_chan(29) = .true.   ! Qb ep subtraction                           qpbepBt1g1WDISTNLO(1,4,5,2,3)
c      qactive_chan(30) = .true.   ! d ep to enub g u      Bh1g1WDIS(1,4,5,2,3)  qepBh1g1WDISTNLO(1,4,5,2,3)
c      qactive_chan(31) = .true.   ! g ep to enub db u     Bh1g1WDIS(4,1,5,2,3)  gepBh1g1WDISTNLO(4,1,5,2,3)
c      qactive_chan(32) = .true.   ! ub ep to enub db g    Bh1g1WDIS(4,5,1,2,3)  qbepBh1g1WDISTNLO(4,5,1,2,3)
c      qactive_chan(33) = .true.   ! Q ep subtraction                            qpepBh1g1WDISTNLO(1,4,5,2,3)
c      qactive_chan(34) = .true.   ! Qb ep subtraction                           qpbepBh1g1WDISTNLO(1,4,5,2,3)

      do i=20,34
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(35) = .true.   ! d ep to enub g g g u   sB3g0WDIS(1,4,5,6,7,2,3)  qepsB3g0WDISS(1,4,5,6,7,2,3)
c      qactive_chan(36) = .true.   ! g ep to enub db g g u   sB3g0WDIS(4,1,5,6,7,2,3)  gepsB3g0WDISS(4,1,5,6,7,2,3)
c      qactive_chan(37) = .true.   ! ub ep to enub db g g g   sB3g0WDIS(4,5,6,7,1,2,3)  qbepsB3g0WDISS(4,5,6,7,1,2,3)
c      qactive_chan(38) = .true.   ! d ep to enub g g g u   sBt3g0WDIS(1,4,5,6,7,2,3)  qepsBt3g0WDISS(1,4,5,6,7,2,3)
c      qactive_chan(39) = .true.   ! g ep to enub db g g u   sBt3g0WDIS(4,1,5,6,7,2,3)  gepsBt3g0WDISS(4,1,5,6,7,2,3)
c      qactive_chan(40) = .true.   ! ub ep to enub db g g g   sBt3g0WDIS(4,5,6,7,1,2,3)  qbepsBt3g0WDISS(4,5,6,7,1,2,3)
c      qactive_chan(41) = .true.   ! d ep to enub gt gt gt u   sBtt3g0WDIS(1,4,5,6,7,2,3)  qepsBtt3g0WDISS(1,4,5,6,7,2,3)
c      qactive_chan(42) = .true.   ! gt ep to enub db gt gt u   sBtt3g0WDIS(4,1,5,6,7,2,3)  gtepsBtt3g0WDISS(4,1,5,6,7,2,3)
c      qactive_chan(43) = .true.   ! ub ep to enub db gt gt gt   sBtt3g0WDIS(4,5,6,7,1,2,3)  qbepsBtt3g0WDISS(4,5,6,7,1,2,3)
c      qactive_chan(44) = .true.   ! d ep to enub g Q Qb u   sC1g0WDIS(1,4,5,6,7,2,3)  qepsC1g0WDISS(1,4,5,6,7,2,3)
c      qactive_chan(45) = .true.   ! g ep to enub db Q Qb u   sC1g0WDIS(4,1,5,6,7,2,3)  gepsC1g0WDISS(4,1,5,6,7,2,3)
c      qactive_chan(46) = .true.   ! Qb ep to enub db g Qb u   sC1g0WDIS(4,5,1,6,7,2,3)  qpbepsC1g0WDISS(4,5,1,6,7,2,3)
c      qactive_chan(47) = .true.   ! Q ep to enub db g Q u   sC1g0WDIS(4,5,6,1,7,2,3)  qpepsC1g0WDISS(4,5,6,1,7,2,3)
c      qactive_chan(48) = .true.   ! ub ep to enub db g Q Qb   sC1g0WDIS(4,5,6,7,1,2,3)  qbepsC1g0WDISS(4,5,6,7,1,2,3)
c      qactive_chan(49) = .true.   ! d ep to enub g Q Qb u   sCt1g0WDIS(1,4,5,6,7,2,3)  qepsCt1g0WDISS(1,4,5,6,7,2,3)
c      qactive_chan(50) = .true.   ! g ep to enub db Q Qb u   sCt1g0WDIS(4,1,5,6,7,2,3)  gepsCt1g0WDISS(4,1,5,6,7,2,3)
c      qactive_chan(51) = .true.   ! Qb ep to enub db g Qb u   sCt1g0WDIS(4,5,1,6,7,2,3)  qpbepsCt1g0WDISS(4,5,1,6,7,2,3)
c      qactive_chan(52) = .true.   ! Q ep to enub db g Q u   sCt1g0WDIS(4,5,6,1,7,2,3)  qpepsCt1g0WDISS(4,5,6,1,7,2,3)
c      qactive_chan(53) = .true.   ! ub ep to enub db g Q Qb   sCt1g0WDIS(4,5,6,7,1,2,3)  qbepsCt1g0WDISS(4,5,6,7,1,2,3)
c      qactive_chan(54) = .true.   ! d ep to enub g d db u   D1g0WmacDIS(1,4,5,6,7,2,3)  qpepD1g0WmacDISS(1,4,5,6,7,2,3)
c      qactive_chan(55) = .true.   ! g ep to enub db d db u   D1g0WmacDIS(4,1,5,6,7,2,3)  gepD1g0WmacDISS(4,1,5,6,7,2,3)
c      qactive_chan(56) = .true.   ! db ep to enub db g db u   D1g0WmacDIS(4,5,1,6,7,2,3)  qpbepD1g0WmacDISS(4,5,1,6,7,2,3)
c      qactive_chan(57) = .true.   ! ub ep to enub db g d db   D1g0WmacDIS(4,5,6,7,1,2,3)  qbepD1g0WmacDISS(4,5,6,7,1,2,3)
c      qactive_chan(58) = .true.   ! d ep to enub g u ub u   D1g0WmbcDIS(1,4,5,6,7,2,3)  qpepD1g0WmbcDISS(1,4,5,6,7,2,3)
c      qactive_chan(59) = .true.   ! g ep to enub db u ub u   D1g0WmbcDIS(4,1,5,6,7,2,3)  gepD1g0WmbcDISS(4,1,5,6,7,2,3)
c      qactive_chan(60) = .true.   ! ub ep to enub db g ub u   D1g0WmbcDIS(4,5,1,6,7,2,3)  qbepD1g0WmbcDISS(4,5,1,6,7,2,3)
c      qactive_chan(61) = .true.   ! u ep to enub db g u u   D1g0WmbcDIS(4,5,6,1,7,2,3)  qepD1g0WmbcDISS(4,5,6,1,7,2,3)
c      qactive_chan(62) = .true.   ! d ep to enub g d db u   Dt1g0WmaDIS(1,4,5,6,7,2,3)  qpepDt1g0WmaDISS(1,4,5,6,7,2,3)
c      qactive_chan(63) = .true.   ! g ep to enub db d db u   Dt1g0WmaDIS(4,1,5,6,7,2,3)  gepDt1g0WmaDISS(4,1,5,6,7,2,3)
c      qactive_chan(64) = .true.   ! db ep to enub db g db u   Dt1g0WmaDIS(4,5,1,6,7,2,3)  qpbepDt1g0WmaDISS(4,5,1,6,7,2,3)
c      qactive_chan(65) = .true.   ! ub ep to enub db g d db   Dt1g0WmaDIS(4,5,6,7,1,2,3)  qbepDt1g0WmaDISS(4,5,6,7,1,2,3)
c      qactive_chan(66) = .true.   ! d ep to enub g u ub u   Dt1g0WmbDIS(1,4,5,6,7,2,3)  qpepDt1g0WmbDISS(1,4,5,6,7,2,3)
c      qactive_chan(67) = .true.   ! g ep to enub db u ub u   Dt1g0WmbDIS(4,1,5,6,7,2,3)  gepDt1g0WmbDISS(4,1,5,6,7,2,3)
c      qactive_chan(68) = .true.   ! ub ep to enub db g ub u   Dt1g0WmbDIS(4,5,1,6,7,2,3)  qbepDt1g0WmbDISS(4,5,1,6,7,2,3)
c      qactive_chan(69) = .true.   ! u ep to enub db g u u   Dt1g0WmbDIS(4,5,6,1,7,2,3)  qepDt1g0WmbDISS(4,5,6,1,7,2,3)

      do i=35,69
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(70) = .true.   ! d ep to enub g g u    sB2g1WDIS(1,4,5,6,2,3)  qepsB2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(71) = .true.   ! g ep to enub db g u   sB2g1WDIS(4,1,5,6,2,3)  gepsB2g1WDIST(4,1,5,6,2,3)
c      qactive_chan(72) = .true.   ! ub ep to enub db g g   sB2g1WDIS(4,5,6,1,2,3)  qbepsB2g1WDIST(4,5,6,1,2,3)
c      qactive_chan(73) = .true.   ! Q ep subtraction                            qpepsB2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(74) = .true.   ! Qb ep subtraction                           qpbepsB2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(75) = .true.   ! d ep to enub gt gt u   sBt2g1WDIS(1,4,5,6,2,3)  qepsBt2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(76) = .true.   ! gt ep to enub db gt u   sBt2g1WDIS(4,1,5,6,2,3)  gtepsBt2g1WDIST(4,1,5,6,2,3)
c      qactive_chan(77) = .true.   ! ub ep to enub db gt gt   sBt2g1WDIS(4,5,6,1,2,3)  qbepsBt2g1WDIST(4,5,6,1,2,3)
c      qactive_chan(78) = .true.   ! Q ep subtraction                            qpepsBt2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(79) = .true.   ! Qb ep subtraction                           qpbepsBt2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(80) = .true.   ! d ep to enub gt gt u   sBttt2g1WDIS(1,4,5,6,2,3)  qepsBttt2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(81) = .true.   ! gt ep to enub db gt u   sBttt2g1WDIS(4,1,5,6,2,3)  gtepsBttt2g1WDIST(4,1,5,6,2,3)
c      qactive_chan(82) = .true.   ! ub ep to enub db gt gt   sBttt2g1WDIS(4,5,6,1,2,3)  qbepsBttt2g1WDIST(4,5,6,1,2,3)
c      qactive_chan(83) = .true.   ! Q ep subtraction                            qpepsBttt2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(84) = .true.   ! Qb ep subtraction                           qpbepsBttt2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(85) = .true.   ! d ep to enub g g u    sBh2g1WDIS(1,4,5,6,2,3)  qepsBh2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(86) = .true.   ! g ep to enub db g u   sBh2g1WDIS(4,1,5,6,2,3)  gepsBh2g1WDIST(4,1,5,6,2,3)
c      qactive_chan(87) = .true.   ! ub ep to enub db g g   sBh2g1WDIS(4,5,6,1,2,3)  qbepsBh2g1WDIST(4,5,6,1,2,3)
c      qactive_chan(88) = .true.   ! Q ep subtraction                            qpepsBh2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(89) = .true.   ! Qb ep subtraction                           qpbepsBh2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(90) = .true.   ! d ep to enub gt gt u   sBth2g1WDIS(1,4,5,6,2,3)  qepsBth2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(91) = .true.   ! gt ep to enub db gt u   sBth2g1WDIS(4,1,5,6,2,3)  gtepsBth2g1WDIST(4,1,5,6,2,3)
c      qactive_chan(92) = .true.   ! ub ep to enub db gt gt   sBth2g1WDIS(4,5,6,1,2,3)  qbepsBth2g1WDIST(4,5,6,1,2,3)
c      qactive_chan(93) = .true.   ! Q ep subtraction                            qpepsBth2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(94) = .true.   ! Qb ep subtraction                           qpbepsBth2g1WDIST(1,4,5,6,2,3)
c      qactive_chan(95) = .true.   ! d ep to enub Q Qb u   sC0g1WDIS(1,4,5,6,2,3)  qepsC0g1WDIST(1,4,5,6,2,3)
c      qactive_chan(96) = .true.   ! Qb ep to enub db Qb u   sC0g1WDIS(4,1,5,6,2,3)  qpbepsC0g1WDIST(4,1,5,6,2,3)
c      qactive_chan(97) = .true.   ! Q ep to enub db Q u   sC0g1WDIS(4,5,1,6,2,3)  qpepsC0g1WDIST(4,5,1,6,2,3)
c      qactive_chan(98) = .true.   ! ub ep to enub db Q Qb   sC0g1WDIS(4,5,6,1,2,3)  qbepsC0g1WDIST(4,5,6,1,2,3)
c      qactive_chan(99) = .true.   ! g ep subtraction                            gepsC0g1WDIST(1,4,5,6,2,3)
c      qactive_chan(100)= .true.   ! d ep to enub Q Qb u   Ct0g1WDIS(1,4,5,6,2,3)  qepCt0g1WDIST(1,4,5,6,2,3)
c      qactive_chan(101)= .true.   ! Qb ep to enub db Qb u   Ct0g1WDIS(4,1,5,6,2,3)  qpbepCt0g1WDIST(4,1,5,6,2,3)
c      qactive_chan(102)= .true.   ! Q ep to enub db Q u   Ct0g1WDIS(4,5,1,6,2,3)  qpepCt0g1WDIST(4,5,1,6,2,3)
c      qactive_chan(103)= .true.   ! ub ep to enub db Q Qb   Ct0g1WDIS(4,5,6,1,2,3)  qbepCt0g1WDIST(4,5,6,1,2,3)
c      qactive_chan(104)= .true.   ! g ep subtraction                            gepCt0g1WDIST(1,4,5,6,2,3)
c      qactive_chan(105)= .true.   ! d ep to enub Q Qb u   Ch0g1WDIS(1,4,5,6,2,3)  qepCh0g1WDIST(1,4,5,6,2,3)
c      qactive_chan(106)= .true.   ! Qb ep to enub db Qb u   Ch0g1WDIS(4,1,5,6,2,3)  qpbepCh0g1WDIST(4,1,5,6,2,3)
c      qactive_chan(107)= .true.   ! Q ep to enub db Q u   Ch0g1WDIS(4,5,1,6,2,3)  qpepCh0g1WDIST(4,5,1,6,2,3)
c      qactive_chan(108)= .true.   ! ub ep to enub db Q Qb   Ch0g1WDIS(4,5,6,1,2,3)  qbepCh0g1WDIST(4,5,6,1,2,3)
c      qactive_chan(109)= .true.   ! g ep subtraction                            gepCh0g1WDIST(1,4,5,6,2,3)
c      qactive_chan(110)= .true.   ! d ep to enub d db u   D0g1WmaDIS(1,4,5,6,2,3)  qpepD0g1WmaDIST(1,4,5,6,2,3)
c      qactive_chan(111)= .true.   ! db ep to enub db db u   D0g1WmaDIS(4,1,5,6,2,3)  qpbepD0g1WmaDIST(4,1,5,6,2,3)
c      qactive_chan(112)= .true.   ! ub ep to enub db d db   D0g1WmaDIS(4,5,6,1,2,3)  qbepD0g1WmaDIST(4,5,6,1,2,3)
c      qactive_chan(113)= .true.   ! g ep subtraction                            gepD0g1WmaDIST(1,4,5,6,2,3)
c      qactive_chan(114)= .true.   ! d ep to enub u ub u   D0g1WmbDIS(1,4,5,6,2,3)  qpepD0g1WmbDIST(1,4,5,6,2,3)
c      qactive_chan(115)= .true.   ! ub ep to enub db ub u   D0g1WmbDIS(4,1,5,6,2,3)  qbepD0g1WmbDIST(4,1,5,6,2,3)
c      qactive_chan(116)= .true.   ! u ep to enub db u u   D0g1WmbDIS(4,5,1,6,2,3)  qepD0g1WmbDIST(4,5,1,6,2,3)
c      qactive_chan(117)= .true.   ! g ep subtraction                            gepD0g1WmbDIST(1,4,5,6,2,3)
c      qactive_chan(118)= .true.   ! d ep to enub d db u   Dt0g1WmaDIS(1,4,5,6,2,3)  qpepDt0g1WmaDIST(1,4,5,6,2,3)
c      qactive_chan(119)= .true.   ! db ep to enub db db u   Dt0g1WmaDIS(4,1,5,6,2,3)  qpbepDt0g1WmaDIST(4,1,5,6,2,3)
c      qactive_chan(120)= .true.   ! ub ep to enub db d db   Dt0g1WmaDIS(4,5,6,1,2,3)  qbepDt0g1WmaDIST(4,5,6,1,2,3)
c      qactive_chan(121)= .true.   ! g ep subtraction                            gepDt0g1WmaDIST(1,4,5,6,2,3)
c      qactive_chan(122)= .true.   ! d ep to enub u ub u   Dt0g1WmbDIS(1,4,5,6,2,3)  qpepDt0g1WmbDIST(1,4,5,6,2,3)
c      qactive_chan(123)= .true.   ! ub ep to enub db ub u   Dt0g1WmbDIS(4,1,5,6,2,3)  qbepDt0g1WmbDIST(4,1,5,6,2,3)
c      qactive_chan(124)= .true.   ! u ep to enub db u u   Dt0g1WmbDIS(4,5,1,6,2,3)  qepDt0g1WmbDIST(4,5,1,6,2,3)
c      qactive_chan(125)= .true.   ! g ep subtraction                            gepDt0g1WmbDIST(1,4,5,6,2,3)
c      qactive_chan(126)= .true.   ! d ep to enub d db u   Dh0g1WmaDIS(1,4,5,6,2,3)  qpepDh0g1WmaDIST(1,4,5,6,2,3)
c      qactive_chan(127)= .true.   ! db ep to enub db db u   Dh0g1WmaDIS(4,1,5,6,2,3)  qpbepDh0g1WmaDIST(4,1,5,6,2,3)
c      qactive_chan(128)= .true.   ! ub ep to enub db d db   Dh0g1WmaDIS(4,5,6,1,2,3)  qbepDh0g1WmaDIST(4,5,6,1,2,3)
c      qactive_chan(129)= .true.   ! g ep subtraction                            gepDh0g1WmaDIST(1,4,5,6,2,3)
c      qactive_chan(130)= .true.   ! d ep to enub u ub u   Dh0g1WmbDIS(1,4,5,6,2,3)  qpepDh0g1WmbDIST(1,4,5,6,2,3)
c      qactive_chan(131)= .true.   ! ub ep to enub db ub u   Dh0g1WmbDIS(4,1,5,6,2,3)  qbepDh0g1WmbDIST(4,1,5,6,2,3)
c      qactive_chan(132)= .true.   ! u ep to enub db u u   Dh0g1WmbDIS(4,5,1,6,2,3)  qepDh0g1WmbDIST(4,5,1,6,2,3)
c      qactive_chan(133)= .true.   ! g ep subtraction                            gepDh0g1WmbDIST(1,4,5,6,2,3)

      do i=70,133
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(134)= .true.   ! d ep to enub g u      B1g2WDIS(1,4,5,2,3)   qepB1g2WDISU(1,4,5,2,3)
c      qactive_chan(135)= .true.   ! g ep to enub db u     B1g2WDIS(4,1,5,2,3)   gepB1g2WDISU(4,1,5,2,3)
c      qactive_chan(136)= .true.   ! ub ep to enub db g    B1g2WDIS(4,5,1,2,3)   qbepB1g2WDISU(4,5,1,2,3)
c      qactive_chan(137)= .true.   ! Q ep subtraction                            qpepB1g2WDISU(1,4,5,2,3)
c      qactive_chan(138)= .true.   ! Qb ep subtraction                           qpbepB1g2WDISU(1,4,5,2,3)
c      qactive_chan(139)= .true.   ! db ep subtraction                           dbepB1g2WDISU(1,4,5,2,3)
c      qactive_chan(140)= .true.   ! u ep subtraction                            uepB1g2WDISU(1,4,5,2,3)
c      qactive_chan(141)= .true.   ! d ep to enub g u      Bt1g2WDIS(1,4,5,2,3)  qepBt1g2WDISU(1,4,5,2,3)
c      qactive_chan(142)= .true.   ! g ep to enub db u     Bt1g2WDIS(4,1,5,2,3)  gepBt1g2WDISU(4,1,5,2,3)
c      qactive_chan(143)= .true.   ! ub ep to enub db g    Bt1g2WDIS(4,5,1,2,3)  qbepBt1g2WDISU(4,5,1,2,3)
c      qactive_chan(144)= .true.   ! Q ep subtraction                            qpepBt1g2WDISU(1,4,5,2,3)
c      qactive_chan(145)= .true.   ! Qb ep subtraction                           qpbepBt1g2WDISU(1,4,5,2,3)
c      qactive_chan(146)= .true.   ! db ep subtraction                           dbepBt1g2WDISU(1,4,5,2,3)
c      qactive_chan(147)= .true.   ! u ep subtraction                            uepBt1g2WDISU(1,4,5,2,3)
c      qactive_chan(148)= .true.   ! d ep to enub g u      Btt1g2WDIS(1,4,5,2,3)  qepBtt1g2WDISU(1,4,5,2,3)
c      qactive_chan(149)= .true.   ! g ep to enub db u     Btt1g2WDIS(4,1,5,2,3)  gepBtt1g2WDISU(4,1,5,2,3)
c      qactive_chan(150)= .true.   ! ub ep to enub db g    Btt1g2WDIS(4,5,1,2,3)  qbepBtt1g2WDISU(4,5,1,2,3)
c      qactive_chan(151)= .true.   ! Q ep subtraction                            qpepBtt1g2WDISU(1,4,5,2,3)
c      qactive_chan(152)= .true.   ! Qb ep subtraction                           qpbepBtt1g2WDISU(1,4,5,2,3)
c      qactive_chan(153)= .true.   ! db ep subtraction                           dbepBtt1g2WDISU(1,4,5,2,3)
c      qactive_chan(154)= .true.   ! u ep subtraction                            uepBtt1g2WDISU(1,4,5,2,3)
c      qactive_chan(155)= .true.   ! d ep to enub g u      Bh1g2WDIS(1,4,5,2,3)  qepBh1g2WDISU(1,4,5,2,3)
c      qactive_chan(156)= .true.   ! g ep to enub db u     Bh1g2WDIS(4,1,5,2,3)  gepBh1g2WDISU(4,1,5,2,3)
c      qactive_chan(157)= .true.   ! ub ep to enub db g    Bh1g2WDIS(4,5,1,2,3)  qbepBh1g2WDISU(4,5,1,2,3)
c      qactive_chan(158)= .true.   ! Q ep subtraction                            qpepBh1g2WDISU(1,4,5,2,3)
c      qactive_chan(159)= .true.   ! Qb ep subtraction                           qpbepBh1g2WDISU(1,4,5,2,3)
c      qactive_chan(160)= .true.   ! db ep subtraction                           dbepBh1g2WDISU(1,4,5,2,3)
c      qactive_chan(161)= .true.   ! u ep subtraction                            uepBh1g2WDISU(1,4,5,2,3)
c      qactive_chan(162)= .true.   ! d ep to enub g u      Bht1g2WDIS(1,4,5,2,3)  qepBht1g2WDISU(1,4,5,2,3)
c      qactive_chan(163)= .true.   ! g ep to enub db u     Bht1g2WDIS(4,1,5,2,3)  gepBht1g2WDISU(4,1,5,2,3)
c      qactive_chan(164)= .true.   ! ub ep to enub db g    Bht1g2WDIS(4,5,1,2,3)  qbepBht1g2WDISU(4,5,1,2,3)
c      qactive_chan(165)= .true.   ! Q ep subtraction                            qpepBht1g2WDISU(1,4,5,2,3)
c      qactive_chan(166)= .true.   ! Qb ep subtraction                           qpbepBht1g2WDISU(1,4,5,2,3)
c      qactive_chan(167)= .true.   ! db ep subtraction                           dbepBht1g2WDISU(1,4,5,2,3)
c      qactive_chan(168)= .true.   ! u ep subtraction                            uepBht1g2WDISU(1,4,5,2,3)
c      qactive_chan(169)= .true.   ! d ep to enub g u      Bhh1g2WDIS(1,4,5,2,3)  qepBhh1g2WDISU(1,4,5,2,3)
c      qactive_chan(170)= .true.   ! g ep to enub db u     Bhh1g2WDIS(4,1,5,2,3)  gepBhh1g2WDISU(4,1,5,2,3)
c      qactive_chan(171)= .true.   ! ub ep to enub db g    Bhh1g2WDIS(4,5,1,2,3)  qbepBhh1g2WDISU(4,5,1,2,3)
c      qactive_chan(172)= .true.   ! Q ep subtraction                            qpepBhh1g2WDISU(1,4,5,2,3)
c      qactive_chan(173)= .true.   ! Qb ep subtraction                           qpbepBhh1g2WDISU(1,4,5,2,3)
c      qactive_chan(174)= .true.   ! db ep subtraction                           dbepBhh1g2WDISU(1,4,5,2,3)
c      qactive_chan(175)= .true.   ! u ep subtraction                            uepBhh1g2WDISU(1,4,5,2,3)

      do i=134,175
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelDISWp(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'd ep to enub g u    '
        me_str   = 'B1g0WDIS(1,4,5,2,3) '
        sub_str  = ''

      case (2)
        chan_str = 'g ep to enub db u   '
        me_str   = 'B1g0WDIS(4,1,5,2,3) '
        sub_str  = ''

      case (3)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'B1g0WDIS(4,5,1,2,3) '
        sub_str  = ''

      case (4)
        chan_str = 'd ep to enub g g u  '
        me_str   = 'B2g0WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepB2g0WDISSNLO(1,4,5,6,2,3)'

      case (5)
        chan_str = 'g ep to enub db g u '
        me_str   = 'B2g0WDIS(4,1,5,6,2,3)'
        sub_str  = 'gepB2g0WDISSNLO(4,1,5,6,2,3)'

      case (6)
        chan_str = 'ub ep to enub db g g '
        me_str   = 'B2g0WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepB2g0WDISSNLO(4,5,6,1,2,3)'

      case (7)
        chan_str = 'd ep to enub gt gt u '
        me_str   = 'Bt2g0WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepBt2g0WDISSNLO(1,4,5,6,2,3)'

      case (8)
        chan_str = 'gt ep to enub db gt u '
        me_str   = 'Bt2g0WDIS(4,1,5,6,2,3)'
        sub_str  = 'gtepBt2g0WDISSNLO(4,1,5,6,2,3)'

      case (9)
        chan_str = 'ub ep to enub db gt gt '
        me_str   = 'Bt2g0WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepBt2g0WDISSNLO(4,5,6,1,2,3)'

      case (10)
        chan_str = 'd ep to enub Q Qb u '
        me_str   = 'C0g0WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepC0g0WDISSNLO(1,4,5,6,2,3)'

      case (11)
        chan_str = 'Qb ep to enub db Qb u '
        me_str   = 'C0g0WDIS(4,1,5,6,2,3)'
        sub_str  = 'qpbepC0g0WDISSNLO(4,1,5,6,2,3)'

      case (12)
        chan_str = 'Q ep to enub db Q u '
        me_str   = 'C0g0WDIS(4,5,1,6,2,3)'
        sub_str  = 'qpepC0g0WDISSNLO(4,5,1,6,2,3)'

      case (13)
        chan_str = 'ub ep to enub db Q Qb '
        me_str   = 'C0g0WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepC0g0WDISSNLO(4,5,6,1,2,3)'

      case (14)
        chan_str = 'd ep to enub d db u '
        me_str   = 'D0g0WaDIS(1,4,5,6,2,3)'
        sub_str  = 'qpepD0g0WaDISSNLO(1,4,5,6,2,3)'

      case (15)
        chan_str = 'db ep to enub db db u '
        me_str   = 'D0g0WaDIS(4,1,5,6,2,3)'
        sub_str  = 'qpbepD0g0WaDISSNLO(4,1,5,6,2,3)'

      case (16)
        chan_str = 'ub ep to enub db d db '
        me_str   = 'D0g0WaDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepD0g0WaDISSNLO(4,5,6,1,2,3)'

      case (17)
        chan_str = 'd ep to enub u ub u '
        me_str   = 'D0g0WbDIS(1,4,5,6,2,3)'
        sub_str  = 'qpepD0g0WbDISSNLO(1,4,5,6,2,3)'

      case (18)
        chan_str = 'ub ep to enub db ub u '
        me_str   = 'D0g0WbDIS(4,1,5,6,2,3)'
        sub_str  = 'qbepD0g0WbDISSNLO(4,1,5,6,2,3)'

      case (19)
        chan_str = 'u ep to enub db u u '
        me_str   = 'D0g0WbDIS(4,5,1,6,2,3)'
        sub_str  = 'qepD0g0WbDISSNLO(4,5,1,6,2,3)'

      case (20)
        chan_str = 'd ep to enub g u    '
        me_str   = 'B1g1WDIS(1,4,5,2,3) '
        sub_str  = 'qepB1g1WDISTNLO(1,4,5,2,3)'

      case (21)
        chan_str = 'g ep to enub db u   '
        me_str   = 'B1g1WDIS(4,1,5,2,3) '
        sub_str  = 'gepB1g1WDISTNLO(4,1,5,2,3)'

      case (22)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'B1g1WDIS(4,5,1,2,3) '
        sub_str  = 'qbepB1g1WDISTNLO(4,5,1,2,3)'

      case (23)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepB1g1WDISTNLO(1,4,5,2,3)'

      case (24)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepB1g1WDISTNLO(1,4,5,2,3)'

      case (25)
        chan_str = 'd ep to enub g u    '
        me_str   = 'Bt1g1WDIS(1,4,5,2,3)'
        sub_str  = 'qepBt1g1WDISTNLO(1,4,5,2,3)'

      case (26)
        chan_str = 'g ep to enub db u   '
        me_str   = 'Bt1g1WDIS(4,1,5,2,3)'
        sub_str  = 'gepBt1g1WDISTNLO(4,1,5,2,3)'

      case (27)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'Bt1g1WDIS(4,5,1,2,3)'
        sub_str  = 'qbepBt1g1WDISTNLO(4,5,1,2,3)'

      case (28)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepBt1g1WDISTNLO(1,4,5,2,3)'

      case (29)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepBt1g1WDISTNLO(1,4,5,2,3)'

      case (30)
        chan_str = 'd ep to enub g u    '
        me_str   = 'Bh1g1WDIS(1,4,5,2,3)'
        sub_str  = 'qepBh1g1WDISTNLO(1,4,5,2,3)'

      case (31)
        chan_str = 'g ep to enub db u   '
        me_str   = 'Bh1g1WDIS(4,1,5,2,3)'
        sub_str  = 'gepBh1g1WDISTNLO(4,1,5,2,3)'

      case (32)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'Bh1g1WDIS(4,5,1,2,3)'
        sub_str  = 'qbepBh1g1WDISTNLO(4,5,1,2,3)'

      case (33)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepBh1g1WDISTNLO(1,4,5,2,3)'

      case (34)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepBh1g1WDISTNLO(1,4,5,2,3)'

      case (35)
        chan_str = 'd ep to enub g g g u '
        me_str   = 'sB3g0WDIS(1,4,5,6,7,2,3)'
        sub_str  = 'qepsB3g0WDISS(1,4,5,6,7,2,3)'

      case (36)
        chan_str = 'g ep to enub db g g u '
        me_str   = 'sB3g0WDIS(4,1,5,6,7,2,3)'
        sub_str  = 'gepsB3g0WDISS(4,1,5,6,7,2,3)'

      case (37)
        chan_str = 'ub ep to enub db g g g '
        me_str   = 'sB3g0WDIS(4,5,6,7,1,2,3)'
        sub_str  = 'qbepsB3g0WDISS(4,5,6,7,1,2,3)'

      case (38)
        chan_str = 'd ep to enub g g g u '
        me_str   = 'sBt3g0WDIS(1,4,5,6,7,2,3)'
        sub_str  = 'qepsBt3g0WDISS(1,4,5,6,7,2,3)'

      case (39)
        chan_str = 'g ep to enub db g g u '
        me_str   = 'sBt3g0WDIS(4,1,5,6,7,2,3)'
        sub_str  = 'gepsBt3g0WDISS(4,1,5,6,7,2,3)'

      case (40)
        chan_str = 'ub ep to enub db g g g '
        me_str   = 'sBt3g0WDIS(4,5,6,7,1,2,3)'
        sub_str  = 'qbepsBt3g0WDISS(4,5,6,7,1,2,3)'

      case (41)
        chan_str = 'd ep to enub gt gt gt u '
        me_str   = 'sBtt3g0WDIS(1,4,5,6,7,2,3)'
        sub_str  = 'qepsBtt3g0WDISS(1,4,5,6,7,2,3)'

      case (42)
        chan_str = 'gt ep to enub db gt gt u '
        me_str   = 'sBtt3g0WDIS(4,1,5,6,7,2,3)'
        sub_str  = 'gtepsBtt3g0WDISS(4,1,5,6,7,2,3)'

      case (43)
        chan_str = 'ub ep to enub db gt gt gt '
        me_str   = 'sBtt3g0WDIS(4,5,6,7,1,2,3)'
        sub_str  = 'qbepsBtt3g0WDISS(4,5,6,7,1,2,3)'

      case (44)
        chan_str = 'd ep to enub g Q Qb u '
        me_str   = 'sC1g0WDIS(1,4,5,6,7,2,3)'
        sub_str  = 'qepsC1g0WDISS(1,4,5,6,7,2,3)'

      case (45)
        chan_str = 'g ep to enub db Q Qb u '
        me_str   = 'sC1g0WDIS(4,1,5,6,7,2,3)'
        sub_str  = 'gepsC1g0WDISS(4,1,5,6,7,2,3)'

      case (46)
        chan_str = 'Qb ep to enub db g Qb u '
        me_str   = 'sC1g0WDIS(4,5,1,6,7,2,3)'
        sub_str  = 'qpbepsC1g0WDISS(4,5,1,6,7,2,3)'

      case (47)
        chan_str = 'Q ep to enub db g Q u '
        me_str   = 'sC1g0WDIS(4,5,6,1,7,2,3)'
        sub_str  = 'qpepsC1g0WDISS(4,5,6,1,7,2,3)'

      case (48)
        chan_str = 'ub ep to enub db g Q Qb '
        me_str   = 'sC1g0WDIS(4,5,6,7,1,2,3)'
        sub_str  = 'qbepsC1g0WDISS(4,5,6,7,1,2,3)'

      case (49)
        chan_str = 'd ep to enub g Q Qb u '
        me_str   = 'sCt1g0WDIS(1,4,5,6,7,2,3)'
        sub_str  = 'qepsCt1g0WDISS(1,4,5,6,7,2,3)'

      case (50)
        chan_str = 'g ep to enub db Q Qb u '
        me_str   = 'sCt1g0WDIS(4,1,5,6,7,2,3)'
        sub_str  = 'gepsCt1g0WDISS(4,1,5,6,7,2,3)'

      case (51)
        chan_str = 'Qb ep to enub db g Qb u '
        me_str   = 'sCt1g0WDIS(4,5,1,6,7,2,3)'
        sub_str  = 'qpbepsCt1g0WDISS(4,5,1,6,7,2,3)'

      case (52)
        chan_str = 'Q ep to enub db g Q u '
        me_str   = 'sCt1g0WDIS(4,5,6,1,7,2,3)'
        sub_str  = 'qpepsCt1g0WDISS(4,5,6,1,7,2,3)'

      case (53)
        chan_str = 'ub ep to enub db g Q Qb '
        me_str   = 'sCt1g0WDIS(4,5,6,7,1,2,3)'
        sub_str  = 'qbepsCt1g0WDISS(4,5,6,7,1,2,3)'

      case (54)
        chan_str = 'd ep to enub g d db u '
        me_str   = 'D1g0WmacDIS(1,4,5,6,7,2,3)'
        sub_str  = 'qpepD1g0WmacDISS(1,4,5,6,7,2,3)'

      case (55)
        chan_str = 'g ep to enub db d db u '
        me_str   = 'D1g0WmacDIS(4,1,5,6,7,2,3)'
        sub_str  = 'gepD1g0WmacDISS(4,1,5,6,7,2,3)'

      case (56)
        chan_str = 'db ep to enub db g db u '
        me_str   = 'D1g0WmacDIS(4,5,1,6,7,2,3)'
        sub_str  = 'qpbepD1g0WmacDISS(4,5,1,6,7,2,3)'

      case (57)
        chan_str = 'ub ep to enub db g d db '
        me_str   = 'D1g0WmacDIS(4,5,6,7,1,2,3)'
        sub_str  = 'qbepD1g0WmacDISS(4,5,6,7,1,2,3)'

      case (58)
        chan_str = 'd ep to enub g u ub u '
        me_str   = 'D1g0WmbcDIS(1,4,5,6,7,2,3)'
        sub_str  = 'qpepD1g0WmbcDISS(1,4,5,6,7,2,3)'

      case (59)
        chan_str = 'g ep to enub db u ub u '
        me_str   = 'D1g0WmbcDIS(4,1,5,6,7,2,3)'
        sub_str  = 'gepD1g0WmbcDISS(4,1,5,6,7,2,3)'

      case (60)
        chan_str = 'ub ep to enub db g ub u '
        me_str   = 'D1g0WmbcDIS(4,5,1,6,7,2,3)'
        sub_str  = 'qbepD1g0WmbcDISS(4,5,1,6,7,2,3)'

      case (61)
        chan_str = 'u ep to enub db g u u '
        me_str   = 'D1g0WmbcDIS(4,5,6,1,7,2,3)'
        sub_str  = 'qepD1g0WmbcDISS(4,5,6,1,7,2,3)'

      case (62)
        chan_str = 'd ep to enub g d db u '
        me_str   = 'Dt1g0WmaDIS(1,4,5,6,7,2,3)'
        sub_str  = 'qpepDt1g0WmaDISS(1,4,5,6,7,2,3)'

      case (63)
        chan_str = 'g ep to enub db d db u '
        me_str   = 'Dt1g0WmaDIS(4,1,5,6,7,2,3)'
        sub_str  = 'gepDt1g0WmaDISS(4,1,5,6,7,2,3)'

      case (64)
        chan_str = 'db ep to enub db g db u '
        me_str   = 'Dt1g0WmaDIS(4,5,1,6,7,2,3)'
        sub_str  = 'qpbepDt1g0WmaDISS(4,5,1,6,7,2,3)'

      case (65)
        chan_str = 'ub ep to enub db g d db '
        me_str   = 'Dt1g0WmaDIS(4,5,6,7,1,2,3)'
        sub_str  = 'qbepDt1g0WmaDISS(4,5,6,7,1,2,3)'

      case (66)
        chan_str = 'd ep to enub g u ub u '
        me_str   = 'Dt1g0WmbDIS(1,4,5,6,7,2,3)'
        sub_str  = 'qpepDt1g0WmbDISS(1,4,5,6,7,2,3)'

      case (67)
        chan_str = 'g ep to enub db u ub u '
        me_str   = 'Dt1g0WmbDIS(4,1,5,6,7,2,3)'
        sub_str  = 'gepDt1g0WmbDISS(4,1,5,6,7,2,3)'

      case (68)
        chan_str = 'ub ep to enub db g ub u '
        me_str   = 'Dt1g0WmbDIS(4,5,1,6,7,2,3)'
        sub_str  = 'qbepDt1g0WmbDISS(4,5,1,6,7,2,3)'

      case (69)
        chan_str = 'u ep to enub db g u u '
        me_str   = 'Dt1g0WmbDIS(4,5,6,1,7,2,3)'
        sub_str  = 'qepDt1g0WmbDISS(4,5,6,1,7,2,3)'

      case (70)
        chan_str = 'd ep to enub g g u  '
        me_str   = 'sB2g1WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepsB2g1WDIST(1,4,5,6,2,3)'

      case (71)
        chan_str = 'g ep to enub db g u '
        me_str   = 'sB2g1WDIS(4,1,5,6,2,3)'
        sub_str  = 'gepsB2g1WDIST(4,1,5,6,2,3)'

      case (72)
        chan_str = 'ub ep to enub db g g '
        me_str   = 'sB2g1WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepsB2g1WDIST(4,5,6,1,2,3)'

      case (73)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepsB2g1WDIST(1,4,5,6,2,3)'

      case (74)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepsB2g1WDIST(1,4,5,6,2,3)'

      case (75)
        chan_str = 'd ep to enub gt gt u '
        me_str   = 'sBt2g1WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepsBt2g1WDIST(1,4,5,6,2,3)'

      case (76)
        chan_str = 'gt ep to enub db gt u '
        me_str   = 'sBt2g1WDIS(4,1,5,6,2,3)'
        sub_str  = 'gtepsBt2g1WDIST(4,1,5,6,2,3)'

      case (77)
        chan_str = 'ub ep to enub db gt gt '
        me_str   = 'sBt2g1WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepsBt2g1WDIST(4,5,6,1,2,3)'

      case (78)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepsBt2g1WDIST(1,4,5,6,2,3)'

      case (79)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepsBt2g1WDIST(1,4,5,6,2,3)'

      case (80)
        chan_str = 'd ep to enub gt gt u '
        me_str   = 'sBttt2g1WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepsBttt2g1WDIST(1,4,5,6,2,3)'

      case (81)
        chan_str = 'gt ep to enub db gt u '
        me_str   = 'sBttt2g1WDIS(4,1,5,6,2,3)'
        sub_str  = 'gtepsBttt2g1WDIST(4,1,5,6,2,3)'

      case (82)
        chan_str = 'ub ep to enub db gt gt '
        me_str   = 'sBttt2g1WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepsBttt2g1WDIST(4,5,6,1,2,3)'

      case (83)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepsBttt2g1WDIST(1,4,5,6,2,3)'

      case (84)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepsBttt2g1WDIST(1,4,5,6,2,3)'

      case (85)
        chan_str = 'd ep to enub g g u  '
        me_str   = 'sBh2g1WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepsBh2g1WDIST(1,4,5,6,2,3)'

      case (86)
        chan_str = 'g ep to enub db g u '
        me_str   = 'sBh2g1WDIS(4,1,5,6,2,3)'
        sub_str  = 'gepsBh2g1WDIST(4,1,5,6,2,3)'

      case (87)
        chan_str = 'ub ep to enub db g g '
        me_str   = 'sBh2g1WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepsBh2g1WDIST(4,5,6,1,2,3)'

      case (88)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepsBh2g1WDIST(1,4,5,6,2,3)'

      case (89)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepsBh2g1WDIST(1,4,5,6,2,3)'

      case (90)
        chan_str = 'd ep to enub gt gt u '
        me_str   = 'sBth2g1WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepsBth2g1WDIST(1,4,5,6,2,3)'

      case (91)
        chan_str = 'gt ep to enub db gt u '
        me_str   = 'sBth2g1WDIS(4,1,5,6,2,3)'
        sub_str  = 'gtepsBth2g1WDIST(4,1,5,6,2,3)'

      case (92)
        chan_str = 'ub ep to enub db gt gt '
        me_str   = 'sBth2g1WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepsBth2g1WDIST(4,5,6,1,2,3)'

      case (93)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepsBth2g1WDIST(1,4,5,6,2,3)'

      case (94)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepsBth2g1WDIST(1,4,5,6,2,3)'

      case (95)
        chan_str = 'd ep to enub Q Qb u '
        me_str   = 'sC0g1WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepsC0g1WDIST(1,4,5,6,2,3)'

      case (96)
        chan_str = 'Qb ep to enub db Qb u '
        me_str   = 'sC0g1WDIS(4,1,5,6,2,3)'
        sub_str  = 'qpbepsC0g1WDIST(4,1,5,6,2,3)'

      case (97)
        chan_str = 'Q ep to enub db Q u '
        me_str   = 'sC0g1WDIS(4,5,1,6,2,3)'
        sub_str  = 'qpepsC0g1WDIST(4,5,1,6,2,3)'

      case (98)
        chan_str = 'ub ep to enub db Q Qb '
        me_str   = 'sC0g1WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepsC0g1WDIST(4,5,6,1,2,3)'

      case (99)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepsC0g1WDIST(1,4,5,6,2,3)'

      case (100)
        chan_str = 'd ep to enub Q Qb u '
        me_str   = 'Ct0g1WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepCt0g1WDIST(1,4,5,6,2,3)'

      case (101)
        chan_str = 'Qb ep to enub db Qb u '
        me_str   = 'Ct0g1WDIS(4,1,5,6,2,3)'
        sub_str  = 'qpbepCt0g1WDIST(4,1,5,6,2,3)'

      case (102)
        chan_str = 'Q ep to enub db Q u '
        me_str   = 'Ct0g1WDIS(4,5,1,6,2,3)'
        sub_str  = 'qpepCt0g1WDIST(4,5,1,6,2,3)'

      case (103)
        chan_str = 'ub ep to enub db Q Qb '
        me_str   = 'Ct0g1WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepCt0g1WDIST(4,5,6,1,2,3)'

      case (104)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepCt0g1WDIST(1,4,5,6,2,3)'

      case (105)
        chan_str = 'd ep to enub Q Qb u '
        me_str   = 'Ch0g1WDIS(1,4,5,6,2,3)'
        sub_str  = 'qepCh0g1WDIST(1,4,5,6,2,3)'

      case (106)
        chan_str = 'Qb ep to enub db Qb u '
        me_str   = 'Ch0g1WDIS(4,1,5,6,2,3)'
        sub_str  = 'qpbepCh0g1WDIST(4,1,5,6,2,3)'

      case (107)
        chan_str = 'Q ep to enub db Q u '
        me_str   = 'Ch0g1WDIS(4,5,1,6,2,3)'
        sub_str  = 'qpepCh0g1WDIST(4,5,1,6,2,3)'

      case (108)
        chan_str = 'ub ep to enub db Q Qb '
        me_str   = 'Ch0g1WDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepCh0g1WDIST(4,5,6,1,2,3)'

      case (109)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepCh0g1WDIST(1,4,5,6,2,3)'

      case (110)
        chan_str = 'd ep to enub d db u '
        me_str   = 'D0g1WmaDIS(1,4,5,6,2,3)'
        sub_str  = 'qpepD0g1WmaDIST(1,4,5,6,2,3)'

      case (111)
        chan_str = 'db ep to enub db db u '
        me_str   = 'D0g1WmaDIS(4,1,5,6,2,3)'
        sub_str  = 'qpbepD0g1WmaDIST(4,1,5,6,2,3)'

      case (112)
        chan_str = 'ub ep to enub db d db '
        me_str   = 'D0g1WmaDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepD0g1WmaDIST(4,5,6,1,2,3)'

      case (113)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepD0g1WmaDIST(1,4,5,6,2,3)'

      case (114)
        chan_str = 'd ep to enub u ub u '
        me_str   = 'D0g1WmbDIS(1,4,5,6,2,3)'
        sub_str  = 'qpepD0g1WmbDIST(1,4,5,6,2,3)'

      case (115)
        chan_str = 'ub ep to enub db ub u '
        me_str   = 'D0g1WmbDIS(4,1,5,6,2,3)'
        sub_str  = 'qbepD0g1WmbDIST(4,1,5,6,2,3)'

      case (116)
        chan_str = 'u ep to enub db u u '
        me_str   = 'D0g1WmbDIS(4,5,1,6,2,3)'
        sub_str  = 'qepD0g1WmbDIST(4,5,1,6,2,3)'

      case (117)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepD0g1WmbDIST(1,4,5,6,2,3)'

      case (118)
        chan_str = 'd ep to enub d db u '
        me_str   = 'Dt0g1WmaDIS(1,4,5,6,2,3)'
        sub_str  = 'qpepDt0g1WmaDIST(1,4,5,6,2,3)'

      case (119)
        chan_str = 'db ep to enub db db u '
        me_str   = 'Dt0g1WmaDIS(4,1,5,6,2,3)'
        sub_str  = 'qpbepDt0g1WmaDIST(4,1,5,6,2,3)'

      case (120)
        chan_str = 'ub ep to enub db d db '
        me_str   = 'Dt0g1WmaDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepDt0g1WmaDIST(4,5,6,1,2,3)'

      case (121)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepDt0g1WmaDIST(1,4,5,6,2,3)'

      case (122)
        chan_str = 'd ep to enub u ub u '
        me_str   = 'Dt0g1WmbDIS(1,4,5,6,2,3)'
        sub_str  = 'qpepDt0g1WmbDIST(1,4,5,6,2,3)'

      case (123)
        chan_str = 'ub ep to enub db ub u '
        me_str   = 'Dt0g1WmbDIS(4,1,5,6,2,3)'
        sub_str  = 'qbepDt0g1WmbDIST(4,1,5,6,2,3)'

      case (124)
        chan_str = 'u ep to enub db u u '
        me_str   = 'Dt0g1WmbDIS(4,5,1,6,2,3)'
        sub_str  = 'qepDt0g1WmbDIST(4,5,1,6,2,3)'

      case (125)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepDt0g1WmbDIST(1,4,5,6,2,3)'

      case (126)
        chan_str = 'd ep to enub d db u '
        me_str   = 'Dh0g1WmaDIS(1,4,5,6,2,3)'
        sub_str  = 'qpepDh0g1WmaDIST(1,4,5,6,2,3)'

      case (127)
        chan_str = 'db ep to enub db db u '
        me_str   = 'Dh0g1WmaDIS(4,1,5,6,2,3)'
        sub_str  = 'qpbepDh0g1WmaDIST(4,1,5,6,2,3)'

      case (128)
        chan_str = 'ub ep to enub db d db '
        me_str   = 'Dh0g1WmaDIS(4,5,6,1,2,3)'
        sub_str  = 'qbepDh0g1WmaDIST(4,5,6,1,2,3)'

      case (129)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepDh0g1WmaDIST(1,4,5,6,2,3)'

      case (130)
        chan_str = 'd ep to enub u ub u '
        me_str   = 'Dh0g1WmbDIS(1,4,5,6,2,3)'
        sub_str  = 'qpepDh0g1WmbDIST(1,4,5,6,2,3)'

      case (131)
        chan_str = 'ub ep to enub db ub u '
        me_str   = 'Dh0g1WmbDIS(4,1,5,6,2,3)'
        sub_str  = 'qbepDh0g1WmbDIST(4,1,5,6,2,3)'

      case (132)
        chan_str = 'u ep to enub db u u '
        me_str   = 'Dh0g1WmbDIS(4,5,1,6,2,3)'
        sub_str  = 'qepDh0g1WmbDIST(4,5,1,6,2,3)'

      case (133)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepDh0g1WmbDIST(1,4,5,6,2,3)'

      case (134)
        chan_str = 'd ep to enub g u    '
        me_str   = 'B1g2WDIS(1,4,5,2,3) '
        sub_str  = 'qepB1g2WDISU(1,4,5,2,3)'

      case (135)
        chan_str = 'g ep to enub db u   '
        me_str   = 'B1g2WDIS(4,1,5,2,3) '
        sub_str  = 'gepB1g2WDISU(4,1,5,2,3)'

      case (136)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'B1g2WDIS(4,5,1,2,3) '
        sub_str  = 'qbepB1g2WDISU(4,5,1,2,3)'

      case (137)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepB1g2WDISU(1,4,5,2,3)'

      case (138)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepB1g2WDISU(1,4,5,2,3)'

      case (139)
        chan_str = 'db ep subtraction   '
        me_str   = '                    '
        sub_str  = 'dbepB1g2WDISU(1,4,5,2,3)'

      case (140)
        chan_str = 'u ep subtraction    '
        me_str   = '                    '
        sub_str  = 'uepB1g2WDISU(1,4,5,2,3)'

      case (141)
        chan_str = 'd ep to enub g u    '
        me_str   = 'Bt1g2WDIS(1,4,5,2,3)'
        sub_str  = 'qepBt1g2WDISU(1,4,5,2,3)'

      case (142)
        chan_str = 'g ep to enub db u   '
        me_str   = 'Bt1g2WDIS(4,1,5,2,3)'
        sub_str  = 'gepBt1g2WDISU(4,1,5,2,3)'

      case (143)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'Bt1g2WDIS(4,5,1,2,3)'
        sub_str  = 'qbepBt1g2WDISU(4,5,1,2,3)'

      case (144)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepBt1g2WDISU(1,4,5,2,3)'

      case (145)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepBt1g2WDISU(1,4,5,2,3)'

      case (146)
        chan_str = 'db ep subtraction   '
        me_str   = '                    '
        sub_str  = 'dbepBt1g2WDISU(1,4,5,2,3)'

      case (147)
        chan_str = 'u ep subtraction    '
        me_str   = '                    '
        sub_str  = 'uepBt1g2WDISU(1,4,5,2,3)'

      case (148)
        chan_str = 'd ep to enub g u    '
        me_str   = 'Btt1g2WDIS(1,4,5,2,3)'
        sub_str  = 'qepBtt1g2WDISU(1,4,5,2,3)'

      case (149)
        chan_str = 'g ep to enub db u   '
        me_str   = 'Btt1g2WDIS(4,1,5,2,3)'
        sub_str  = 'gepBtt1g2WDISU(4,1,5,2,3)'

      case (150)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'Btt1g2WDIS(4,5,1,2,3)'
        sub_str  = 'qbepBtt1g2WDISU(4,5,1,2,3)'

      case (151)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepBtt1g2WDISU(1,4,5,2,3)'

      case (152)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepBtt1g2WDISU(1,4,5,2,3)'

      case (153)
        chan_str = 'db ep subtraction   '
        me_str   = '                    '
        sub_str  = 'dbepBtt1g2WDISU(1,4,5,2,3)'

      case (154)
        chan_str = 'u ep subtraction    '
        me_str   = '                    '
        sub_str  = 'uepBtt1g2WDISU(1,4,5,2,3)'

      case (155)
        chan_str = 'd ep to enub g u    '
        me_str   = 'Bh1g2WDIS(1,4,5,2,3)'
        sub_str  = 'qepBh1g2WDISU(1,4,5,2,3)'

      case (156)
        chan_str = 'g ep to enub db u   '
        me_str   = 'Bh1g2WDIS(4,1,5,2,3)'
        sub_str  = 'gepBh1g2WDISU(4,1,5,2,3)'

      case (157)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'Bh1g2WDIS(4,5,1,2,3)'
        sub_str  = 'qbepBh1g2WDISU(4,5,1,2,3)'

      case (158)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepBh1g2WDISU(1,4,5,2,3)'

      case (159)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepBh1g2WDISU(1,4,5,2,3)'

      case (160)
        chan_str = 'db ep subtraction   '
        me_str   = '                    '
        sub_str  = 'dbepBh1g2WDISU(1,4,5,2,3)'

      case (161)
        chan_str = 'u ep subtraction    '
        me_str   = '                    '
        sub_str  = 'uepBh1g2WDISU(1,4,5,2,3)'

      case (162)
        chan_str = 'd ep to enub g u    '
        me_str   = 'Bht1g2WDIS(1,4,5,2,3)'
        sub_str  = 'qepBht1g2WDISU(1,4,5,2,3)'

      case (163)
        chan_str = 'g ep to enub db u   '
        me_str   = 'Bht1g2WDIS(4,1,5,2,3)'
        sub_str  = 'gepBht1g2WDISU(4,1,5,2,3)'

      case (164)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'Bht1g2WDIS(4,5,1,2,3)'
        sub_str  = 'qbepBht1g2WDISU(4,5,1,2,3)'

      case (165)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepBht1g2WDISU(1,4,5,2,3)'

      case (166)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepBht1g2WDISU(1,4,5,2,3)'

      case (167)
        chan_str = 'db ep subtraction   '
        me_str   = '                    '
        sub_str  = 'dbepBht1g2WDISU(1,4,5,2,3)'

      case (168)
        chan_str = 'u ep subtraction    '
        me_str   = '                    '
        sub_str  = 'uepBht1g2WDISU(1,4,5,2,3)'

      case (169)
        chan_str = 'd ep to enub g u    '
        me_str   = 'Bhh1g2WDIS(1,4,5,2,3)'
        sub_str  = 'qepBhh1g2WDISU(1,4,5,2,3)'

      case (170)
        chan_str = 'g ep to enub db u   '
        me_str   = 'Bhh1g2WDIS(4,1,5,2,3)'
        sub_str  = 'gepBhh1g2WDISU(4,1,5,2,3)'

      case (171)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'Bhh1g2WDIS(4,5,1,2,3)'
        sub_str  = 'qbepBhh1g2WDISU(4,5,1,2,3)'

      case (172)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepBhh1g2WDISU(1,4,5,2,3)'

      case (173)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepBhh1g2WDISU(1,4,5,2,3)'

      case (174)
        chan_str = 'db ep subtraction   '
        me_str   = '                    '
        sub_str  = 'dbepBhh1g2WDISU(1,4,5,2,3)'

      case (175)
        chan_str = 'u ep subtraction    '
        me_str   = '                    '
        sub_str  = 'uepBhh1g2WDISU(1,4,5,2,3)'

      case default
        print*, 'getchannelDISWp: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtDISWp(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtDISWp = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (4)
        ! [enub, g, g, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (6)
        ! [enub, db, g, g]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (7)
        ! [enub, gt, gt, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (9)
        ! [enub, db, gt, gt]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (15)
        ! [enub, db, db, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (16)
        ! [enub, db, d, db]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (17)
        ! [enub, u, ub, u]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (19)
        ! [enub, db, u, u]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (35)
        ! [enub, g, g, g, u]
        LIPSwgtDISWp = weight_lips((/ 4,5,6 /))

      case (36)
        ! [enub, db, g, g, u]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (37)
        ! [enub, db, g, g, g]
        LIPSwgtDISWp = weight_lips((/ 5,6,7 /))

      case (38)
        ! [enub, g, g, g, u]
        LIPSwgtDISWp = weight_lips((/ 4,5,6 /))

      case (39)
        ! [enub, db, g, g, u]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (40)
        ! [enub, db, g, g, g]
        LIPSwgtDISWp = weight_lips((/ 5,6,7 /))

      case (41)
        ! [enub, gt, gt, gt, u]
        LIPSwgtDISWp = weight_lips((/ 4,5,6 /))

      case (42)
        ! [enub, db, gt, gt, u]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (43)
        ! [enub, db, gt, gt, gt]
        LIPSwgtDISWp = weight_lips((/ 5,6,7 /))

      case (55)
        ! [enub, db, d, db, u]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (56)
        ! [enub, db, g, db, u]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (57)
        ! [enub, db, g, d, db]
        LIPSwgtDISWp = weight_lips((/ 4,7 /))

      case (58)
        ! [enub, g, u, ub, u]
        LIPSwgtDISWp = weight_lips((/ 5,7 /))

      case (59)
        ! [enub, db, u, ub, u]
        LIPSwgtDISWp = weight_lips((/ 5,7 /))

      case (61)
        ! [enub, db, g, u, u]
        LIPSwgtDISWp = weight_lips((/ 6,7 /))

      case (63)
        ! [enub, db, d, db, u]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (64)
        ! [enub, db, g, db, u]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (65)
        ! [enub, db, g, d, db]
        LIPSwgtDISWp = weight_lips((/ 4,7 /))

      case (66)
        ! [enub, g, u, ub, u]
        LIPSwgtDISWp = weight_lips((/ 5,7 /))

      case (67)
        ! [enub, db, u, ub, u]
        LIPSwgtDISWp = weight_lips((/ 5,7 /))

      case (69)
        ! [enub, db, g, u, u]
        LIPSwgtDISWp = weight_lips((/ 6,7 /))

      case (70)
        ! [enub, g, g, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (72)
        ! [enub, db, g, g]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (75)
        ! [enub, gt, gt, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (77)
        ! [enub, db, gt, gt]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (80)
        ! [enub, gt, gt, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (82)
        ! [enub, db, gt, gt]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (85)
        ! [enub, g, g, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (87)
        ! [enub, db, g, g]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (90)
        ! [enub, gt, gt, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (92)
        ! [enub, db, gt, gt]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (111)
        ! [enub, db, db, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (112)
        ! [enub, db, d, db]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (114)
        ! [enub, u, ub, u]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (116)
        ! [enub, db, u, u]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (119)
        ! [enub, db, db, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (120)
        ! [enub, db, d, db]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (122)
        ! [enub, u, ub, u]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (124)
        ! [enub, db, u, u]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case (127)
        ! [enub, db, db, u]
        LIPSwgtDISWp = weight_lips((/ 4,5 /))

      case (128)
        ! [enub, db, d, db]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (130)
        ! [enub, u, ub, u]
        LIPSwgtDISWp = weight_lips((/ 4,6 /))

      case (132)
        ! [enub, db, u, u]
        LIPSwgtDISWp = weight_lips((/ 5,6 /))

      case default
        LIPSwgtDISWp = 1

      end select
      end
