      function sigRRDISWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRRDISWm=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis(0,7,ipass)
      virtsflag=.false.
      jflag=.false.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(7, (/ 1, 2, 3, 4, 5, 6, 7 /) )
#endif 

c--- u em to enu g g g d 
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0WDIS(1,4,5,6,7,3,2)
     .          +sB3g0WDIS(1,4,6,5,7,3,2)
     .          +sB3g0WDIS(1,5,4,6,7,3,2)
     .          +sB3g0WDIS(1,5,6,4,7,3,2)
     .          +sB3g0WDIS(1,6,4,5,7,3,2)
     .          +sB3g0WDIS(1,6,5,4,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub g g d 
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0WDIS(4,1,5,6,7,3,2)
     .          +sB3g0WDIS(4,1,6,5,7,3,2)
     .          +sB3g0WDIS(4,5,1,6,7,3,2)
     .          +sB3g0WDIS(4,5,6,1,7,3,2)
     .          +sB3g0WDIS(4,6,1,5,7,3,2)
     .          +sB3g0WDIS(4,6,5,1,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g g g 
      if (qactive_chan(37).and.qselect_chan(37)) then
        current_chan = 37
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0WDIS(4,5,6,7,1,3,2)
     .          +sB3g0WDIS(4,5,7,6,1,3,2)
     .          +sB3g0WDIS(4,6,5,7,1,3,2)
     .          +sB3g0WDIS(4,6,7,5,1,3,2)
     .          +sB3g0WDIS(4,7,5,6,1,3,2)
     .          +sB3g0WDIS(4,7,6,5,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g g g d 
      if (qactive_chan(38).and.qselect_chan(38)) then
        current_chan = 38
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0WDIS(1,4,5,6,7,3,2)
     .          +sBt3g0WDIS(1,4,6,5,7,3,2)
     .          +sBt3g0WDIS(1,5,4,6,7,3,2)
     .          +sBt3g0WDIS(1,5,6,4,7,3,2)
     .          +sBt3g0WDIS(1,6,4,5,7,3,2)
     .          +sBt3g0WDIS(1,6,5,4,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub g g d 
      if (qactive_chan(39).and.qselect_chan(39)) then
        current_chan = 39
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0WDIS(4,1,5,6,7,3,2)
     .          +sBt3g0WDIS(4,1,6,5,7,3,2)
     .          +sBt3g0WDIS(4,5,1,6,7,3,2)
     .          +sBt3g0WDIS(4,5,6,1,7,3,2)
     .          +sBt3g0WDIS(4,6,1,5,7,3,2)
     .          +sBt3g0WDIS(4,6,5,1,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g g g 
      if (qactive_chan(40).and.qselect_chan(40)) then
        current_chan = 40
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0WDIS(4,5,6,7,1,3,2)
     .          +sBt3g0WDIS(4,5,7,6,1,3,2)
     .          +sBt3g0WDIS(4,6,5,7,1,3,2)
     .          +sBt3g0WDIS(4,6,7,5,1,3,2)
     .          +sBt3g0WDIS(4,7,5,6,1,3,2)
     .          +sBt3g0WDIS(4,7,6,5,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu gt gt gt d 
      if (qactive_chan(41).and.qselect_chan(41)) then
        current_chan = 41
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0WDIS(1,4,5,6,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt em to enu ub gt gt d 
      if (qactive_chan(42).and.qselect_chan(42)) then
        current_chan = 42
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0WDIS(4,1,5,6,7,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub gt gt gt 
      if (qactive_chan(43).and.qselect_chan(43)) then
        current_chan = 43
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0WDIS(4,5,6,7,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g Q Qb d 
      if (qactive_chan(44).and.qselect_chan(44)) then
        current_chan = 44
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0WDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub Q Qb d 
      if (qactive_chan(45).and.qselect_chan(45)) then
        current_chan = 45
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0WDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb em to enu ub g Qb d 
      if (qactive_chan(46).and.qselect_chan(46)) then
        current_chan = 46
        ip1_chan     = -30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0WDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q em to enu ub g Q d 
      if (qactive_chan(47).and.qselect_chan(47)) then
        current_chan = 47
        ip1_chan     = 30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,1,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0WDIS(4,5,6,1,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g Q Qb 
      if (qactive_chan(48).and.qselect_chan(48)) then
        current_chan = 48
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0WDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g Q Qb d 
      if (qactive_chan(49).and.qselect_chan(49)) then
        current_chan = 49
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0WDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub Q Qb d 
      if (qactive_chan(50).and.qselect_chan(50)) then
        current_chan = 50
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0WDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb em to enu ub g Qb d 
      if (qactive_chan(51).and.qselect_chan(51)) then
        current_chan = 51
        ip1_chan     = -30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0WDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q em to enu ub g Q d 
      if (qactive_chan(52).and.qselect_chan(52)) then
        current_chan = 52
        ip1_chan     = 30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,1,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0WDIS(4,5,6,1,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g Q Qb 
      if (qactive_chan(53).and.qselect_chan(53)) then
        current_chan = 53
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0WDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g u ub d 
      if (qactive_chan(54).and.qselect_chan(54)) then
        current_chan = 54
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0WpacDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub u ub d 
      if (qactive_chan(55).and.qselect_chan(55)) then
        current_chan = 55
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0WpacDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to enu ub g ub d 
      if (qactive_chan(56).and.qselect_chan(56)) then
        current_chan = 56
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0WpacDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g u ub 
      if (qactive_chan(57).and.qselect_chan(57)) then
        current_chan = 57
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0WpacDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g d db d 
      if (qactive_chan(58).and.qselect_chan(58)) then
        current_chan = 58
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0WpbcDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub d db d 
      if (qactive_chan(59).and.qselect_chan(59)) then
        current_chan = 59
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0WpbcDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g db d 
      if (qactive_chan(60).and.qselect_chan(60)) then
        current_chan = 60
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0WpbcDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to enu ub g d d 
      if (qactive_chan(61).and.qselect_chan(61)) then
        current_chan = 61
        ip1_chan     = 40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,1,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0WpbcDIS(4,5,6,1,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g u ub d 
      if (qactive_chan(62).and.qselect_chan(62)) then
        current_chan = 62
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0WpaDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub u ub d 
      if (qactive_chan(63).and.qselect_chan(63)) then
        current_chan = 63
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0WpaDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to enu ub g ub d 
      if (qactive_chan(64).and.qselect_chan(64)) then
        current_chan = 64
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0WpaDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g u ub 
      if (qactive_chan(65).and.qselect_chan(65)) then
        current_chan = 65
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,7,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0WpaDIS(4,5,6,7,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g d db d 
      if (qactive_chan(66).and.qselect_chan(66)) then
        current_chan = 66
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,4,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0WpbDIS(1,4,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub d db d 
      if (qactive_chan(67).and.qselect_chan(67)) then
        current_chan = 67
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,1,5,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0WpbDIS(4,1,5,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g db d 
      if (qactive_chan(68).and.qselect_chan(68)) then
        current_chan = 68
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,1,6,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0WpbDIS(4,5,1,6,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to enu ub g d d 
      if (qactive_chan(69).and.qselect_chan(69)) then
        current_chan = 69
        ip1_chan     = 40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 4,5,6,1,7,3,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0WpbDIS(4,5,6,1,7,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRRDISWm=rnorm*wtsum

      return
      end
