      function sigVDISWp(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVDISWp=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis(0,5,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- d ep to enub g u 
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = 40
        ip2_chan     = -99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,2,3 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1WDIS(1,4,5,2,3,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ep to enub db u 
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = 0
        ip2_chan     = -99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,2,3 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1WDIS(4,1,5,2,3,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ep to enub db g 
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = -20
        ip2_chan     = -99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,2,3 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1WDIS(4,5,1,2,3,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ep to enub g u 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = 40
        ip2_chan     = -99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,2,3 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1WDIS(1,4,5,2,3,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ep to enub db u 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = 0
        ip2_chan     = -99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,2,3 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1WDIS(4,1,5,2,3,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ep to enub db g 
      if (qactive_chan(27).and.qselect_chan(27)) then
        current_chan = 27
        ip1_chan     = -20
        ip2_chan     = -99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,2,3 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1WDIS(4,5,1,2,3,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ep to enub g u 
      if (qactive_chan(30).and.qselect_chan(30)) then
        current_chan = 30
        ip1_chan     = 40
        ip2_chan     = -99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,2,3 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1WDIS(1,4,5,2,3,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ep to enub db u 
      if (qactive_chan(31).and.qselect_chan(31)) then
        current_chan = 31
        ip1_chan     = 0
        ip2_chan     = -99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,2,3 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1WDIS(4,1,5,2,3,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ep to enub db g 
      if (qactive_chan(32).and.qselect_chan(32)) then
        current_chan = 32
        ip1_chan     = -20
        ip2_chan     = -99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,2,3 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1WDIS(4,5,1,2,3,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigVDISWp=rnorm*wtsum

      return
      end
