      function sigVVDISWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVVDISWm=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis(0,5,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

!$omp critical(VV_DISWm)
#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- u em to enu g d 
      if (qactive_chan(134).and.qselect_chan(134)) then
        current_chan = 134
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2WDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub d 
      if (qactive_chan(135).and.qselect_chan(135)) then
        current_chan = 135
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2WDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g 
      if (qactive_chan(136).and.qselect_chan(136)) then
        current_chan = 136
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2WDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g d 
      if (qactive_chan(141).and.qselect_chan(141)) then
        current_chan = 141
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2WDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub d 
      if (qactive_chan(142).and.qselect_chan(142)) then
        current_chan = 142
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2WDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g 
      if (qactive_chan(143).and.qselect_chan(143)) then
        current_chan = 143
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2WDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g d 
      if (qactive_chan(148).and.qselect_chan(148)) then
        current_chan = 148
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2WDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub d 
      if (qactive_chan(149).and.qselect_chan(149)) then
        current_chan = 149
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2WDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g 
      if (qactive_chan(150).and.qselect_chan(150)) then
        current_chan = 150
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2WDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g d 
      if (qactive_chan(155).and.qselect_chan(155)) then
        current_chan = 155
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2WDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub d 
      if (qactive_chan(156).and.qselect_chan(156)) then
        current_chan = 156
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2WDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g 
      if (qactive_chan(157).and.qselect_chan(157)) then
        current_chan = 157
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2WDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g d 
      if (qactive_chan(162).and.qselect_chan(162)) then
        current_chan = 162
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2WDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub d 
      if (qactive_chan(163).and.qselect_chan(163)) then
        current_chan = 163
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2WDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g 
      if (qactive_chan(164).and.qselect_chan(164)) then
        current_chan = 164
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2WDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu g d 
      if (qactive_chan(169).and.qselect_chan(169)) then
        current_chan = 169
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,4,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2WDIS(1,4,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub d 
      if (qactive_chan(170).and.qselect_chan(170)) then
        current_chan = 170
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,1,5,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2WDIS(4,1,5,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g 
      if (qactive_chan(171).and.qselect_chan(171)) then
        current_chan = 171
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 4,5,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2WDIS(4,5,1,3,2,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
!$omp end critical(VV_DISWm)

      sigVVDISWm=rnorm*wtsum

      return
      end
