      subroutine getlumiDISWp1j(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    3,    6,   11,   14,   17,   21,   24,          
     &           27,   32,   37,   42,   49,   56)
!       [40, -99]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)                                         
     &       + f1(3,1:nInp_scl)                                         

        case (    2,    5,    7,   13,   16,   20,   23,   25,          
     &           29,   34,   39,   43,   50,   57)
!       [-20, -99]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)                                        
     &       + f1(-4,1:nInp_scl)                                        

        case (    4,   10,   12,   15,   28,   33,   38,   47,          
     &           54,   61)
!       [0, -99]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)                                         

        case (    8,   19,   30,   35,   40,   44,   51,   58)
!       [30, -99]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)                                         
     &       + f1(2,1:nInp_scl)                                         
     &       + f1(3,1:nInp_scl)                                         
     &       + f1(4,1:nInp_scl)                                         
     &       + f1(5,1:nInp_scl)                                         

        case (    9,   18,   31,   36,   41,   45,   52,   59)
!       [-30, -99]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)                                        
     &       + f1(-2,1:nInp_scl)                                        
     &       + f1(-3,1:nInp_scl)                                        
     &       + f1(-4,1:nInp_scl)                                        
     &       + f1(-5,1:nInp_scl)                                        

        case (   22,   46,   53,   60)
!       [-40, -99]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)                                        
     &       + f1(-3,1:nInp_scl)                                        

        case (   26,   48,   55,   62)
!       [20, -99]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)                                         
     &       + f1(4,1:nInp_scl)                                         

        case default
          print*, "getlumiDISWp1j: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiDISWp1j



      function getlumiidDISWp1j(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    3,    6,   11,   14,   17,   21,   24,
     &           27,   32,   37,   42,   49,   56)
          id  = 1
          ip1 = 40
          ip2 = -99

        case (    2,    5,    7,   13,   16,   20,   23,   25,
     &           29,   34,   39,   43,   50,   57)
          id  = 2
          ip1 = -20
          ip2 = -99

        case (    4,   10,   12,   15,   28,   33,   38,   47,
     &           54,   61)
          id  = 3
          ip1 = 0
          ip2 = -99

        case (    8,   19,   30,   35,   40,   44,   51,   58)
          id  = 4
          ip1 = 30
          ip2 = -99

        case (    9,   18,   31,   36,   41,   45,   52,   59)
          id  = 5
          ip1 = -30
          ip2 = -99

        case (   22,   46,   53,   60)
          id  = 6
          ip1 = -40
          ip2 = -99

        case (   26,   48,   55,   62)
          id  = 7
          ip1 = 20
          ip2 = -99

        case default
          print*, "getlumiidDISWp1j: invalid iproc:", iproc
          stop
        end select

      end function getlumiidDISWp1j





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiDISWp1j()
        use PineAPPL_mod
        use CKM_mod
!       [40, -99]
        call register_lumi_pine(
     &         [    1,    3,    6,   11,   14,   17,   21,   24,
     &             27,   32,   37,   42,   49,   56],
     &         2,
     &         [    1,  -99,    3,  -99],
     &         [  1d0,  1d0]
     &       )

!       [-20, -99]
        call register_lumi_pine(
     &         [    2,    5,    7,   13,   16,   20,   23,   25,
     &             29,   34,   39,   43,   50,   57],
     &         2,
     &         [   -2,  -99,   -4,  -99],
     &         [  1d0,  1d0]
     &       )

!       [0, -99]
        call register_lumi_pine(
     &         [    4,   10,   12,   15,   28,   33,   38,   47,
     &             54,   61],
     &         1,
     &         [   21,  -99],
     &         [  1d0]
     &       )

!       [30, -99]
        call register_lumi_pine(
     &         [    8,   19,   30,   35,   40,   44,   51,   58],
     &         5,
     &         [    1,  -99,    2,  -99,    3,  -99,    4,  -99,
     &              5,  -99],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, -99]
        call register_lumi_pine(
     &         [    9,   18,   31,   36,   41,   45,   52,   59],
     &         5,
     &         [   -1,  -99,   -2,  -99,   -3,  -99,   -4,  -99,
     &             -5,  -99],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-40, -99]
        call register_lumi_pine(
     &         [   22,   46,   53,   60],
     &         2,
     &         [   -1,  -99,   -3,  -99],
     &         [  1d0,  1d0]
     &       )

!       [20, -99]
        call register_lumi_pine(
     &         [   26,   48,   55,   62],
     &         2,
     &         [    2,  -99,    4,  -99],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiDISWp1j


#endif


