      subroutine getqcdnormDISWm1j(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtDISWm1j(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_dis1j(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVDISWm1j
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourDISWm1j(current_chan)
         do isub = 1, nflavourDISWm1j(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_DISWm1j(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=DISWm1j "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alpha_param()/stw)**2*nc
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! u em -> enu d           B0g0WDIS1j
      case(2)
         factor=facB                        ! db em -> enu ub         B0g0WDIS1j

c -- real

      case(3)
         factor=(nc**2-1d0)/nc**2*facR      ! u em -> enu g d         B1g0WDIS1j
      case(4)
         factor=(nc**2-1d0)/nc**2*nup*facR   ! g em -> enu ub d        B1g0WDIS1j
      case(5)
         factor=(nc**2-1d0)/nc**2*facR      ! db em -> enu ub g       B1g0WDIS1j

c -- virtual

      case(6)
         factor=(nc**2-1d0)/nc**2*facV      ! u em -> enu d           B0g1WDIS1j
      case(7)
         factor=(nc**2-1d0)/nc**2*facV      ! db em -> enu ub         B0g1WDIS1j
      case(8)
         factor=(nc**2-1d0)/nc**2/nf*nup*facV   ! Q em subtraction        B0g1WDIS1j
      case(9)
         factor=(nc**2-1d0)/nc**2/nf*nup*facV   ! Qb em subtraction       B0g1WDIS1j
      case(10)
         factor=(nc**2-1d0)/nc**2*nup*facV   ! g em subtraction        B0g1WDIS1j

c -- double real

      case(11)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! u em -> enu g g d       csB2g0WDIS1j
      case(12)
         factor=(nc**2-1d0)/nc**2*nup*facRR   ! g em -> enu ub g d      csB2g0WDIS1j
      case(13)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! db em -> enu ub g g     csB2g0WDIS1j
      case(14)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u em -> enu gt gt d     csBt2g0WDIS1j
      case(15)
         factor=-(nc**2-1d0)/nc**4*nup*facRR   ! gt em -> enu ub gt d     csBt2g0WDIS1j
      case(16)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db em -> enu ub gt gt     csBt2g0WDIS1j
      case(17)
         factor=(nc**2-1d0)/nc**3*nf*facRR   ! u em -> enu Q Qb d      sC0g0WDIS1j
      case(18)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! Qb em -> enu ub Qb d     sC0g0WDIS1j
      case(19)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! Q em -> enu ub Q d      sC0g0WDIS1j
      case(20)
         factor=(nc**2-1d0)/nc**3*nf*facRR   ! db em -> enu ub Q Qb     sC0g0WDIS1j
      case(21)
         factor=-(nc**2-1d0)/nc**4*facRR    ! u em -> enu u ub d      D0g0WaDIS1j
      case(22)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub em -> enu ub ub d     D0g0WaDIS1j
      case(23)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db em -> enu ub u ub     D0g0WaDIS1j
      case(24)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u em -> enu d db d      D0g0WbDIS1j
      case(25)
         factor=-(nc**2-1d0)/nc**4*facRR    ! db em -> enu ub db d     D0g0WbDIS1j
      case(26)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d em -> enu ub d d      D0g0WbDIS1j

c -- real virtual

      case(27)
         factor=(nc**2-1d0)/nc**2*facRV     ! u em -> enu g d         csB1g1WDIS1j
      case(28)
         factor=(nc**2-1d0)/nc**2*nup*facRV   ! g em -> enu ub d        csB1g1WDIS1j
      case(29)
         factor=(nc**2-1d0)/nc**2*facRV     ! db em -> enu ub g       csB1g1WDIS1j
      case(30)
         factor=(nc**2-1d0)/nc**2/nf*nup*facRV   ! Q em subtraction        csB1g1WDIS1j
      case(31)
         factor=(nc**2-1d0)/nc**2/nf*nup*facRV   ! Qb em subtraction       csB1g1WDIS1j
      case(32)
         factor=-(nc**2-1d0)/nc**4*facRV    ! u em -> enu g d         csBt1g1WDIS1j
      case(33)
         factor=-(nc**2-1d0)/nc**4*nup*facRV   ! g em -> enu ub d        csBt1g1WDIS1j
      case(34)
         factor=-(nc**2-1d0)/nc**4*facRV    ! db em -> enu ub g       csBt1g1WDIS1j
      case(35)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facRV   ! Q em subtraction        csBt1g1WDIS1j
      case(36)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facRV   ! Qb em subtraction       csBt1g1WDIS1j
      case(37)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! u em -> enu g d         csBh1g1WDIS1j
      case(38)
         factor=(nc**2-1d0)/nc**3*nf*nup*facRV   ! g em -> enu ub d        csBh1g1WDIS1j
      case(39)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! db em -> enu ub g       csBh1g1WDIS1j
      case(40)
         factor=(nc**2-1d0)/nc**3*nup*facRV   ! Q em subtraction        csBh1g1WDIS1j
      case(41)
         factor=(nc**2-1d0)/nc**3*nup*facRV   ! Qb em subtraction       csBh1g1WDIS1j

c -- double virtual

      case(42)
         factor=(nc**2-1d0)/nc**2*facVV     ! u em -> enu d           B0g2WDIS1j
      case(43)
         factor=(nc**2-1d0)/nc**2*facVV     ! db em -> enu ub         B0g2WDIS1j
      case(44)
         factor=(nc**2-1d0)/nc**2/nf*nup*facVV   ! Q em subtraction        B0g2WDIS1j
      case(45)
         factor=(nc**2-1d0)/nc**2/nf*nup*facVV   ! Qb em subtraction       B0g2WDIS1j
      case(46)
         factor=(nc**2-1d0)/nc**2*facVV     ! d em subtraction        B0g2WDIS1j
      case(47)
         factor=(nc**2-1d0)/nc**2*nup*facVV   ! g em subtraction        B0g2WDIS1j
      case(48)
         factor=(nc**2-1d0)/nc**2*facVV     ! ub em subtraction       B0g2WDIS1j
      case(49)
         factor=-(nc**2-1d0)/nc**4*facVV    ! u em -> enu d           Bt0g2WDIS1j
      case(50)
         factor=-(nc**2-1d0)/nc**4*facVV    ! db em -> enu ub         Bt0g2WDIS1j
      case(51)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facVV   ! Q em subtraction        Bt0g2WDIS1j
      case(52)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facVV   ! Qb em subtraction       Bt0g2WDIS1j
      case(53)
         factor=-(nc**2-1d0)/nc**4*facVV    ! d em subtraction        Bt0g2WDIS1j
      case(54)
         factor=-(nc**2-1d0)/nc**4*nup*facVV   ! g em subtraction        Bt0g2WDIS1j
      case(55)
         factor=-(nc**2-1d0)/nc**4*facVV    ! ub em subtraction       Bt0g2WDIS1j
      case(56)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! u em -> enu d           Bh0g2WDIS1j
      case(57)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! db em -> enu ub         Bh0g2WDIS1j
      case(58)
         factor=(nc**2-1d0)/nc**3*nup*facVV   ! Q em subtraction        Bh0g2WDIS1j
      case(59)
         factor=(nc**2-1d0)/nc**3*nup*facVV   ! Qb em subtraction       Bh0g2WDIS1j
      case(60)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! d em subtraction        Bh0g2WDIS1j
      case(61)
         factor=(nc**2-1d0)/nc**3*nf*nup*facVV   ! g em subtraction        Bh0g2WDIS1j
      case(62)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! ub em subtraction       Bh0g2WDIS1j
      end select
      factor=relfactor*factor

      return
      end
