      subroutine getqcdnormDISWp1j(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtDISWp1j(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_dis1j(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVDISWp1j
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourDISWp1j(current_chan)
         do isub = 1, nflavourDISWp1j(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_DISWp1j(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=DISWp1j "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alpha_param()/stw)**2*nc
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d ep -> enub u          B0g0WDIS1j
      case(2)
         factor=facB                        ! ub ep -> enub db        B0g0WDIS1j

c -- real

      case(3)
         factor=(nc**2-1d0)/nc**2*facR      ! d ep -> enub g u        B1g0WDIS1j
      case(4)
         factor=(nc**2-1d0)/nc**2*nup*facR   ! g ep -> enub db u       B1g0WDIS1j
      case(5)
         factor=(nc**2-1d0)/nc**2*facR      ! ub ep -> enub db g      B1g0WDIS1j

c -- virtual

      case(6)
         factor=(nc**2-1d0)/nc**2*facV      ! d ep -> enub u          B0g1WDIS1j
      case(7)
         factor=(nc**2-1d0)/nc**2*facV      ! ub ep -> enub db        B0g1WDIS1j
      case(8)
         factor=(nc**2-1d0)/nc**2/nf*nup*facV   ! Q ep subtraction        B0g1WDIS1j
      case(9)
         factor=(nc**2-1d0)/nc**2/nf*nup*facV   ! Qb ep subtraction       B0g1WDIS1j
      case(10)
         factor=(nc**2-1d0)/nc**2*nup*facV   ! g ep subtraction        B0g1WDIS1j

c -- double real

      case(11)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! d ep -> enub g g u      csB2g0WDIS1j
      case(12)
         factor=(nc**2-1d0)/nc**2*nup*facRR   ! g ep -> enub db g u     csB2g0WDIS1j
      case(13)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! ub ep -> enub db g g     csB2g0WDIS1j
      case(14)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d ep -> enub gt gt u     csBt2g0WDIS1j
      case(15)
         factor=-(nc**2-1d0)/nc**4*nup*facRR   ! gt ep -> enub db gt u     csBt2g0WDIS1j
      case(16)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub ep -> enub db gt gt     csBt2g0WDIS1j
      case(17)
         factor=(nc**2-1d0)/nc**3*nf*facRR   ! d ep -> enub Q Qb u     sC0g0WDIS1j
      case(18)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! Qb ep -> enub db Qb u     sC0g0WDIS1j
      case(19)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! Q ep -> enub db Q u     sC0g0WDIS1j
      case(20)
         factor=(nc**2-1d0)/nc**3*nf*facRR   ! ub ep -> enub db Q Qb     sC0g0WDIS1j
      case(21)
         factor=-(nc**2-1d0)/nc**4*facRR    ! d ep -> enub d db u     D0g0WaDIS1j
      case(22)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db ep -> enub db db u     D0g0WaDIS1j
      case(23)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub ep -> enub db d db     D0g0WaDIS1j
      case(24)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d ep -> enub u ub u     D0g0WbDIS1j
      case(25)
         factor=-(nc**2-1d0)/nc**4*facRR    ! ub ep -> enub db ub u     D0g0WbDIS1j
      case(26)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u ep -> enub db u u     D0g0WbDIS1j

c -- real virtual

      case(27)
         factor=(nc**2-1d0)/nc**2*facRV     ! d ep -> enub g u        csB1g1WDIS1j
      case(28)
         factor=(nc**2-1d0)/nc**2*nup*facRV   ! g ep -> enub db u       csB1g1WDIS1j
      case(29)
         factor=(nc**2-1d0)/nc**2*facRV     ! ub ep -> enub db g      csB1g1WDIS1j
      case(30)
         factor=(nc**2-1d0)/nc**2/nf*nup*facRV   ! Q ep subtraction        csB1g1WDIS1j
      case(31)
         factor=(nc**2-1d0)/nc**2/nf*nup*facRV   ! Qb ep subtraction       csB1g1WDIS1j
      case(32)
         factor=-(nc**2-1d0)/nc**4*facRV    ! d ep -> enub g u        csBt1g1WDIS1j
      case(33)
         factor=-(nc**2-1d0)/nc**4*nup*facRV   ! g ep -> enub db u       csBt1g1WDIS1j
      case(34)
         factor=-(nc**2-1d0)/nc**4*facRV    ! ub ep -> enub db g      csBt1g1WDIS1j
      case(35)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facRV   ! Q ep subtraction        csBt1g1WDIS1j
      case(36)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facRV   ! Qb ep subtraction       csBt1g1WDIS1j
      case(37)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! d ep -> enub g u        csBh1g1WDIS1j
      case(38)
         factor=(nc**2-1d0)/nc**3*nf*nup*facRV   ! g ep -> enub db u       csBh1g1WDIS1j
      case(39)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! ub ep -> enub db g      csBh1g1WDIS1j
      case(40)
         factor=(nc**2-1d0)/nc**3*nup*facRV   ! Q ep subtraction        csBh1g1WDIS1j
      case(41)
         factor=(nc**2-1d0)/nc**3*nup*facRV   ! Qb ep subtraction       csBh1g1WDIS1j

c -- double virtual

      case(42)
         factor=(nc**2-1d0)/nc**2*facVV     ! d ep -> enub u          B0g2WDIS1j
      case(43)
         factor=(nc**2-1d0)/nc**2*facVV     ! ub ep -> enub db        B0g2WDIS1j
      case(44)
         factor=(nc**2-1d0)/nc**2/nf*nup*facVV   ! Q ep subtraction        B0g2WDIS1j
      case(45)
         factor=(nc**2-1d0)/nc**2/nf*nup*facVV   ! Qb ep subtraction       B0g2WDIS1j
      case(46)
         factor=(nc**2-1d0)/nc**2*facVV     ! db ep subtraction       B0g2WDIS1j
      case(47)
         factor=(nc**2-1d0)/nc**2*nup*facVV   ! g ep subtraction        B0g2WDIS1j
      case(48)
         factor=(nc**2-1d0)/nc**2*facVV     ! u ep subtraction        B0g2WDIS1j
      case(49)
         factor=-(nc**2-1d0)/nc**4*facVV    ! d ep -> enub u          Bt0g2WDIS1j
      case(50)
         factor=-(nc**2-1d0)/nc**4*facVV    ! ub ep -> enub db        Bt0g2WDIS1j
      case(51)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facVV   ! Q ep subtraction        Bt0g2WDIS1j
      case(52)
         factor=-(nc**2-1d0)/nc**4/nf*nup*facVV   ! Qb ep subtraction       Bt0g2WDIS1j
      case(53)
         factor=-(nc**2-1d0)/nc**4*facVV    ! db ep subtraction       Bt0g2WDIS1j
      case(54)
         factor=-(nc**2-1d0)/nc**4*nup*facVV   ! g ep subtraction        Bt0g2WDIS1j
      case(55)
         factor=-(nc**2-1d0)/nc**4*facVV    ! u ep subtraction        Bt0g2WDIS1j
      case(56)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! d ep -> enub u          Bh0g2WDIS1j
      case(57)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! ub ep -> enub db        Bh0g2WDIS1j
      case(58)
         factor=(nc**2-1d0)/nc**3*nup*facVV   ! Q ep subtraction        Bh0g2WDIS1j
      case(59)
         factor=(nc**2-1d0)/nc**3*nup*facVV   ! Qb ep subtraction       Bh0g2WDIS1j
      case(60)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! db ep subtraction       Bh0g2WDIS1j
      case(61)
         factor=(nc**2-1d0)/nc**3*nf*nup*facVV   ! g ep subtraction        Bh0g2WDIS1j
      case(62)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! u ep subtraction        Bh0g2WDIS1j
      end select
      factor=relfactor*factor

      return
      end
