      subroutine selectchannelDISWm1j()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*amzw/stw)**2*nc
      n_alphas_proc = 0
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelDISWm1j: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelDISWm1j: already allocated'  
        stop
      end if

      ntot_chan = 62

      allocate(qactive_chan(1:62))
      allocate(contrib_chan(1:62))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! u em to enu d         B0g0WDIS1j(1,4,3,2)   
c      qactive_chan(2)  = .true.   ! db em to enu ub       B0g0WDIS1j(4,1,3,2)   

      do i=1,2
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(3)  = .true.   ! u em to enu g d       B1g0WDIS1j(1,4,5,3,2)  qemB1g0WDIS1jSNLO(1,4,5,3,2)
c      qactive_chan(4)  = .true.   ! g em to enu ub d      B1g0WDIS1j(4,1,5,3,2)  gemB1g0WDIS1jSNLO(4,1,5,3,2)
c      qactive_chan(5)  = .true.   ! db em to enu ub g     B1g0WDIS1j(4,5,1,3,2)  qbemB1g0WDIS1jSNLO(4,5,1,3,2)

      do i=3,5
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(6)  = .true.   ! u em to enu d         B0g1WDIS1j(1,4,3,2)   qemB0g1WDIS1jTNLO(1,4,3,2)
c      qactive_chan(7)  = .true.   ! db em to enu ub       B0g1WDIS1j(4,1,3,2)   qbemB0g1WDIS1jTNLO(4,1,3,2)
c      qactive_chan(8)  = .true.   ! Q em subtraction                            qpemB0g1WDIS1jTNLO(1,4,3,2)
c      qactive_chan(9)  = .true.   ! Qb em subtraction                           qpbemB0g1WDIS1jTNLO(1,4,3,2)
c      qactive_chan(10) = .true.   ! g em subtraction                            gemB0g1WDIS1jTNLO(1,4,3,2)

      do i=6,10
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(11) = .true.   ! u em to enu g g d     csB2g0WDIS1j(1,4,5,6,3,2)  qemcsB2g0WDIS1jS(1,4,5,6,3,2)
c      qactive_chan(12) = .true.   ! g em to enu ub g d    csB2g0WDIS1j(4,1,5,6,3,2)  gemcsB2g0WDIS1jS(4,1,5,6,3,2)
c      qactive_chan(13) = .true.   ! db em to enu ub g g   csB2g0WDIS1j(4,5,6,1,3,2)  qbemcsB2g0WDIS1jS(4,5,6,1,3,2)
c      qactive_chan(14) = .true.   ! u em to enu gt gt d   csBt2g0WDIS1j(1,4,5,6,3,2)  qemcsBt2g0WDIS1jS(1,4,5,6,3,2)
c      qactive_chan(15) = .true.   ! gt em to enu ub gt d   csBt2g0WDIS1j(4,1,5,6,3,2)  gtemcsBt2g0WDIS1jS(4,1,5,6,3,2)
c      qactive_chan(16) = .true.   ! db em to enu ub gt gt   csBt2g0WDIS1j(4,5,6,1,3,2)  qbemcsBt2g0WDIS1jS(4,5,6,1,3,2)
c      qactive_chan(17) = .true.   ! u em to enu Q Qb d    sC0g0WDIS1j(1,4,5,6,3,2)  qemsC0g0WDIS1jS(1,4,5,6,3,2)
c      qactive_chan(18) = .true.   ! Qb em to enu ub Qb d   sC0g0WDIS1j(4,1,5,6,3,2)  qpbemsC0g0WDIS1jS(4,1,5,6,3,2)
c      qactive_chan(19) = .true.   ! Q em to enu ub Q d    sC0g0WDIS1j(4,5,1,6,3,2)  qpemsC0g0WDIS1jS(4,5,1,6,3,2)
c      qactive_chan(20) = .true.   ! db em to enu ub Q Qb   sC0g0WDIS1j(4,5,6,1,3,2)  qbemsC0g0WDIS1jS(4,5,6,1,3,2)
c      qactive_chan(21) = .true.   ! u em to enu u ub d    D0g0WaDIS1j(1,4,5,6,3,2)  qemD0g0WaDIS1jS(1,4,5,6,3,2)
c      qactive_chan(22) = .true.   ! ub em to enu ub ub d   D0g0WaDIS1j(4,1,5,6,3,2)  qbemD0g0WaDIS1jS(4,1,5,6,3,2)
c      qactive_chan(23) = .true.   ! db em to enu ub u ub   D0g0WaDIS1j(4,5,6,1,3,2)  qpbemD0g0WaDIS1jS(4,5,6,1,3,2)
c      qactive_chan(24) = .true.   ! u em to enu d db d    D0g0WbDIS1j(1,4,5,6,3,2)  qemD0g0WbDIS1jS(1,4,5,6,3,2)
c      qactive_chan(25) = .true.   ! db em to enu ub db d   D0g0WbDIS1j(4,1,5,6,3,2)  qpbemD0g0WbDIS1jS(4,1,5,6,3,2)
c      qactive_chan(26) = .true.   ! d em to enu ub d d    D0g0WbDIS1j(4,5,1,6,3,2)  qpemD0g0WbDIS1jS(4,5,1,6,3,2)

      do i=11,26
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(27) = .true.   ! u em to enu g d       csB1g1WDIS1j(1,4,5,3,2)  qemcsB1g1WDIS1jT(1,4,5,3,2)
c      qactive_chan(28) = .true.   ! g em to enu ub d      csB1g1WDIS1j(4,1,5,3,2)  gemcsB1g1WDIS1jT(4,1,5,3,2)
c      qactive_chan(29) = .true.   ! db em to enu ub g     csB1g1WDIS1j(4,5,1,3,2)  qbemcsB1g1WDIS1jT(4,5,1,3,2)
c      qactive_chan(30) = .true.   ! Q em subtraction                            qpemcsB1g1WDIS1jT(1,4,5,3,2)
c      qactive_chan(31) = .true.   ! Qb em subtraction                           qpbemcsB1g1WDIS1jT(1,4,5,3,2)
c      qactive_chan(32) = .true.   ! u em to enu g d       csBt1g1WDIS1j(1,4,5,3,2)  qemcsBt1g1WDIS1jT(1,4,5,3,2)
c      qactive_chan(33) = .true.   ! g em to enu ub d      csBt1g1WDIS1j(4,1,5,3,2)  gemcsBt1g1WDIS1jT(4,1,5,3,2)
c      qactive_chan(34) = .true.   ! db em to enu ub g     csBt1g1WDIS1j(4,5,1,3,2)  qbemcsBt1g1WDIS1jT(4,5,1,3,2)
c      qactive_chan(35) = .true.   ! Q em subtraction                            qpemcsBt1g1WDIS1jT(1,4,5,3,2)
c      qactive_chan(36) = .true.   ! Qb em subtraction                           qpbemcsBt1g1WDIS1jT(1,4,5,3,2)
c      qactive_chan(37) = .true.   ! u em to enu g d       csBh1g1WDIS1j(1,4,5,3,2)  qemcsBh1g1WDIS1jT(1,4,5,3,2)
c      qactive_chan(38) = .true.   ! g em to enu ub d      csBh1g1WDIS1j(4,1,5,3,2)  gemcsBh1g1WDIS1jT(4,1,5,3,2)
c      qactive_chan(39) = .true.   ! db em to enu ub g     csBh1g1WDIS1j(4,5,1,3,2)  qbemcsBh1g1WDIS1jT(4,5,1,3,2)
c      qactive_chan(40) = .true.   ! Q em subtraction                            qpemcsBh1g1WDIS1jT(1,4,5,3,2)
c      qactive_chan(41) = .true.   ! Qb em subtraction                           qpbemcsBh1g1WDIS1jT(1,4,5,3,2)

      do i=27,41
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(42) = .true.   ! u em to enu d         B0g2WDIS1j(1,4,3,2)   qemB0g2WDIS1jU(1,4,3,2)
c      qactive_chan(43) = .true.   ! db em to enu ub       B0g2WDIS1j(4,1,3,2)   qbemB0g2WDIS1jU(4,1,3,2)
c      qactive_chan(44) = .true.   ! Q em subtraction                            qpemB0g2WDIS1jU(1,4,3,2)
c      qactive_chan(45) = .true.   ! Qb em subtraction                           qpbemB0g2WDIS1jU(1,4,3,2)
c      qactive_chan(46) = .true.   ! d em subtraction                            demB0g2WDIS1jU(1,4,3,2)
c      qactive_chan(47) = .true.   ! g em subtraction                            gemB0g2WDIS1jU(1,4,3,2)
c      qactive_chan(48) = .true.   ! ub em subtraction                           ubemB0g2WDIS1jU(1,4,3,2)
c      qactive_chan(49) = .true.   ! u em to enu d         Bt0g2WDIS1j(1,4,3,2)  qemBt0g2WDIS1jU(1,4,3,2)
c      qactive_chan(50) = .true.   ! db em to enu ub       Bt0g2WDIS1j(4,1,3,2)  qbemBt0g2WDIS1jU(4,1,3,2)
c      qactive_chan(51) = .true.   ! Q em subtraction                            qpemBt0g2WDIS1jU(1,4,3,2)
c      qactive_chan(52) = .true.   ! Qb em subtraction                           qpbemBt0g2WDIS1jU(1,4,3,2)
c      qactive_chan(53) = .true.   ! d em subtraction                            demBt0g2WDIS1jU(1,4,3,2)
c      qactive_chan(54) = .true.   ! g em subtraction                            gemBt0g2WDIS1jU(1,4,3,2)
c      qactive_chan(55) = .true.   ! ub em subtraction                           ubemBt0g2WDIS1jU(1,4,3,2)
c      qactive_chan(56) = .true.   ! u em to enu d         Bh0g2WDIS1j(1,4,3,2)  qemBh0g2WDIS1jU(1,4,3,2)
c      qactive_chan(57) = .true.   ! db em to enu ub       Bh0g2WDIS1j(4,1,3,2)  qbemBh0g2WDIS1jU(4,1,3,2)
c      qactive_chan(58) = .true.   ! Q em subtraction                            qpemBh0g2WDIS1jU(1,4,3,2)
c      qactive_chan(59) = .true.   ! Qb em subtraction                           qpbemBh0g2WDIS1jU(1,4,3,2)
c      qactive_chan(60) = .true.   ! d em subtraction                            demBh0g2WDIS1jU(1,4,3,2)
c      qactive_chan(61) = .true.   ! g em subtraction                            gemBh0g2WDIS1jU(1,4,3,2)
c      qactive_chan(62) = .true.   ! ub em subtraction                           ubemBh0g2WDIS1jU(1,4,3,2)

      do i=42,62
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelDISWm1j(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'u em to enu d       '
        me_str   = 'B0g0WDIS1j(1,4,3,2) '
        sub_str  = ''

      case (2)
        chan_str = 'db em to enu ub     '
        me_str   = 'B0g0WDIS1j(4,1,3,2) '
        sub_str  = ''

      case (3)
        chan_str = 'u em to enu g d     '
        me_str   = 'B1g0WDIS1j(1,4,5,3,2)'
        sub_str  = 'qemB1g0WDIS1jSNLO(1,4,5,3,2)'

      case (4)
        chan_str = 'g em to enu ub d    '
        me_str   = 'B1g0WDIS1j(4,1,5,3,2)'
        sub_str  = 'gemB1g0WDIS1jSNLO(4,1,5,3,2)'

      case (5)
        chan_str = 'db em to enu ub g   '
        me_str   = 'B1g0WDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemB1g0WDIS1jSNLO(4,5,1,3,2)'

      case (6)
        chan_str = 'u em to enu d       '
        me_str   = 'B0g1WDIS1j(1,4,3,2) '
        sub_str  = 'qemB0g1WDIS1jTNLO(1,4,3,2)'

      case (7)
        chan_str = 'db em to enu ub     '
        me_str   = 'B0g1WDIS1j(4,1,3,2) '
        sub_str  = 'qbemB0g1WDIS1jTNLO(4,1,3,2)'

      case (8)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB0g1WDIS1jTNLO(1,4,3,2)'

      case (9)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB0g1WDIS1jTNLO(1,4,3,2)'

      case (10)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemB0g1WDIS1jTNLO(1,4,3,2)'

      case (11)
        chan_str = 'u em to enu g g d   '
        me_str   = 'csB2g0WDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemcsB2g0WDIS1jS(1,4,5,6,3,2)'

      case (12)
        chan_str = 'g em to enu ub g d  '
        me_str   = 'csB2g0WDIS1j(4,1,5,6,3,2)'
        sub_str  = 'gemcsB2g0WDIS1jS(4,1,5,6,3,2)'

      case (13)
        chan_str = 'db em to enu ub g g '
        me_str   = 'csB2g0WDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemcsB2g0WDIS1jS(4,5,6,1,3,2)'

      case (14)
        chan_str = 'u em to enu gt gt d '
        me_str   = 'csBt2g0WDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemcsBt2g0WDIS1jS(1,4,5,6,3,2)'

      case (15)
        chan_str = 'gt em to enu ub gt d '
        me_str   = 'csBt2g0WDIS1j(4,1,5,6,3,2)'
        sub_str  = 'gtemcsBt2g0WDIS1jS(4,1,5,6,3,2)'

      case (16)
        chan_str = 'db em to enu ub gt gt '
        me_str   = 'csBt2g0WDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemcsBt2g0WDIS1jS(4,5,6,1,3,2)'

      case (17)
        chan_str = 'u em to enu Q Qb d  '
        me_str   = 'sC0g0WDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemsC0g0WDIS1jS(1,4,5,6,3,2)'

      case (18)
        chan_str = 'Qb em to enu ub Qb d '
        me_str   = 'sC0g0WDIS1j(4,1,5,6,3,2)'
        sub_str  = 'qpbemsC0g0WDIS1jS(4,1,5,6,3,2)'

      case (19)
        chan_str = 'Q em to enu ub Q d  '
        me_str   = 'sC0g0WDIS1j(4,5,1,6,3,2)'
        sub_str  = 'qpemsC0g0WDIS1jS(4,5,1,6,3,2)'

      case (20)
        chan_str = 'db em to enu ub Q Qb '
        me_str   = 'sC0g0WDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qbemsC0g0WDIS1jS(4,5,6,1,3,2)'

      case (21)
        chan_str = 'u em to enu u ub d  '
        me_str   = 'D0g0WaDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemD0g0WaDIS1jS(1,4,5,6,3,2)'

      case (22)
        chan_str = 'ub em to enu ub ub d '
        me_str   = 'D0g0WaDIS1j(4,1,5,6,3,2)'
        sub_str  = 'qbemD0g0WaDIS1jS(4,1,5,6,3,2)'

      case (23)
        chan_str = 'db em to enu ub u ub '
        me_str   = 'D0g0WaDIS1j(4,5,6,1,3,2)'
        sub_str  = 'qpbemD0g0WaDIS1jS(4,5,6,1,3,2)'

      case (24)
        chan_str = 'u em to enu d db d  '
        me_str   = 'D0g0WbDIS1j(1,4,5,6,3,2)'
        sub_str  = 'qemD0g0WbDIS1jS(1,4,5,6,3,2)'

      case (25)
        chan_str = 'db em to enu ub db d '
        me_str   = 'D0g0WbDIS1j(4,1,5,6,3,2)'
        sub_str  = 'qpbemD0g0WbDIS1jS(4,1,5,6,3,2)'

      case (26)
        chan_str = 'd em to enu ub d d  '
        me_str   = 'D0g0WbDIS1j(4,5,1,6,3,2)'
        sub_str  = 'qpemD0g0WbDIS1jS(4,5,1,6,3,2)'

      case (27)
        chan_str = 'u em to enu g d     '
        me_str   = 'csB1g1WDIS1j(1,4,5,3,2)'
        sub_str  = 'qemcsB1g1WDIS1jT(1,4,5,3,2)'

      case (28)
        chan_str = 'g em to enu ub d    '
        me_str   = 'csB1g1WDIS1j(4,1,5,3,2)'
        sub_str  = 'gemcsB1g1WDIS1jT(4,1,5,3,2)'

      case (29)
        chan_str = 'db em to enu ub g   '
        me_str   = 'csB1g1WDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemcsB1g1WDIS1jT(4,5,1,3,2)'

      case (30)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemcsB1g1WDIS1jT(1,4,5,3,2)'

      case (31)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemcsB1g1WDIS1jT(1,4,5,3,2)'

      case (32)
        chan_str = 'u em to enu g d     '
        me_str   = 'csBt1g1WDIS1j(1,4,5,3,2)'
        sub_str  = 'qemcsBt1g1WDIS1jT(1,4,5,3,2)'

      case (33)
        chan_str = 'g em to enu ub d    '
        me_str   = 'csBt1g1WDIS1j(4,1,5,3,2)'
        sub_str  = 'gemcsBt1g1WDIS1jT(4,1,5,3,2)'

      case (34)
        chan_str = 'db em to enu ub g   '
        me_str   = 'csBt1g1WDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemcsBt1g1WDIS1jT(4,5,1,3,2)'

      case (35)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemcsBt1g1WDIS1jT(1,4,5,3,2)'

      case (36)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemcsBt1g1WDIS1jT(1,4,5,3,2)'

      case (37)
        chan_str = 'u em to enu g d     '
        me_str   = 'csBh1g1WDIS1j(1,4,5,3,2)'
        sub_str  = 'qemcsBh1g1WDIS1jT(1,4,5,3,2)'

      case (38)
        chan_str = 'g em to enu ub d    '
        me_str   = 'csBh1g1WDIS1j(4,1,5,3,2)'
        sub_str  = 'gemcsBh1g1WDIS1jT(4,1,5,3,2)'

      case (39)
        chan_str = 'db em to enu ub g   '
        me_str   = 'csBh1g1WDIS1j(4,5,1,3,2)'
        sub_str  = 'qbemcsBh1g1WDIS1jT(4,5,1,3,2)'

      case (40)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemcsBh1g1WDIS1jT(1,4,5,3,2)'

      case (41)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemcsBh1g1WDIS1jT(1,4,5,3,2)'

      case (42)
        chan_str = 'u em to enu d       '
        me_str   = 'B0g2WDIS1j(1,4,3,2) '
        sub_str  = 'qemB0g2WDIS1jU(1,4,3,2)'

      case (43)
        chan_str = 'db em to enu ub     '
        me_str   = 'B0g2WDIS1j(4,1,3,2) '
        sub_str  = 'qbemB0g2WDIS1jU(4,1,3,2)'

      case (44)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemB0g2WDIS1jU(1,4,3,2)'

      case (45)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemB0g2WDIS1jU(1,4,3,2)'

      case (46)
        chan_str = 'd em subtraction    '
        me_str   = '                    '
        sub_str  = 'demB0g2WDIS1jU(1,4,3,2)'

      case (47)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemB0g2WDIS1jU(1,4,3,2)'

      case (48)
        chan_str = 'ub em subtraction   '
        me_str   = '                    '
        sub_str  = 'ubemB0g2WDIS1jU(1,4,3,2)'

      case (49)
        chan_str = 'u em to enu d       '
        me_str   = 'Bt0g2WDIS1j(1,4,3,2)'
        sub_str  = 'qemBt0g2WDIS1jU(1,4,3,2)'

      case (50)
        chan_str = 'db em to enu ub     '
        me_str   = 'Bt0g2WDIS1j(4,1,3,2)'
        sub_str  = 'qbemBt0g2WDIS1jU(4,1,3,2)'

      case (51)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBt0g2WDIS1jU(1,4,3,2)'

      case (52)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBt0g2WDIS1jU(1,4,3,2)'

      case (53)
        chan_str = 'd em subtraction    '
        me_str   = '                    '
        sub_str  = 'demBt0g2WDIS1jU(1,4,3,2)'

      case (54)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemBt0g2WDIS1jU(1,4,3,2)'

      case (55)
        chan_str = 'ub em subtraction   '
        me_str   = '                    '
        sub_str  = 'ubemBt0g2WDIS1jU(1,4,3,2)'

      case (56)
        chan_str = 'u em to enu d       '
        me_str   = 'Bh0g2WDIS1j(1,4,3,2)'
        sub_str  = 'qemBh0g2WDIS1jU(1,4,3,2)'

      case (57)
        chan_str = 'db em to enu ub     '
        me_str   = 'Bh0g2WDIS1j(4,1,3,2)'
        sub_str  = 'qbemBh0g2WDIS1jU(4,1,3,2)'

      case (58)
        chan_str = 'Q em subtraction    '
        me_str   = '                    '
        sub_str  = 'qpemBh0g2WDIS1jU(1,4,3,2)'

      case (59)
        chan_str = 'Qb em subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbemBh0g2WDIS1jU(1,4,3,2)'

      case (60)
        chan_str = 'd em subtraction    '
        me_str   = '                    '
        sub_str  = 'demBh0g2WDIS1jU(1,4,3,2)'

      case (61)
        chan_str = 'g em subtraction    '
        me_str   = '                    '
        sub_str  = 'gemBh0g2WDIS1jU(1,4,3,2)'

      case (62)
        chan_str = 'ub em subtraction   '
        me_str   = '                    '
        sub_str  = 'ubemBh0g2WDIS1jU(1,4,3,2)'

      case default
        print*, 'getchannelDISWm1j: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtDISWm1j(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtDISWm1j = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (11)
        ! [enu, g, g, d]
        LIPSwgtDISWm1j = weight_lips((/ 4,5 /))

      case (13)
        ! [enu, ub, g, g]
        LIPSwgtDISWm1j = weight_lips((/ 5,6 /))

      case (14)
        ! [enu, gt, gt, d]
        LIPSwgtDISWm1j = weight_lips((/ 4,5 /))

      case (16)
        ! [enu, ub, gt, gt]
        LIPSwgtDISWm1j = weight_lips((/ 5,6 /))

      case (22)
        ! [enu, ub, ub, d]
        LIPSwgtDISWm1j = weight_lips((/ 4,5 /))

      case (23)
        ! [enu, ub, u, ub]
        LIPSwgtDISWm1j = weight_lips((/ 4,6 /))

      case (24)
        ! [enu, d, db, d]
        LIPSwgtDISWm1j = weight_lips((/ 4,6 /))

      case (26)
        ! [enu, ub, d, d]
        LIPSwgtDISWm1j = weight_lips((/ 5,6 /))

      case default
        LIPSwgtDISWm1j = 1

      end select
      end
