      subroutine selectchannelDISWp1j()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*amzw/stw)**2*nc
      n_alphas_proc = 0
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelDISWp1j: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelDISWp1j: already allocated'  
        stop
      end if

      ntot_chan = 62

      allocate(qactive_chan(1:62))
      allocate(contrib_chan(1:62))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! d ep to enub u        B0g0WDIS1j(1,4,2,3)   
c      qactive_chan(2)  = .true.   ! ub ep to enub db      B0g0WDIS1j(4,1,2,3)   

      do i=1,2
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(3)  = .true.   ! d ep to enub g u      B1g0WDIS1j(1,4,5,2,3)  qepB1g0WDIS1jSNLO(1,4,5,2,3)
c      qactive_chan(4)  = .true.   ! g ep to enub db u     B1g0WDIS1j(4,1,5,2,3)  gepB1g0WDIS1jSNLO(4,1,5,2,3)
c      qactive_chan(5)  = .true.   ! ub ep to enub db g    B1g0WDIS1j(4,5,1,2,3)  qbepB1g0WDIS1jSNLO(4,5,1,2,3)

      do i=3,5
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(6)  = .true.   ! d ep to enub u        B0g1WDIS1j(1,4,2,3)   qepB0g1WDIS1jTNLO(1,4,2,3)
c      qactive_chan(7)  = .true.   ! ub ep to enub db      B0g1WDIS1j(4,1,2,3)   qbepB0g1WDIS1jTNLO(4,1,2,3)
c      qactive_chan(8)  = .true.   ! Q ep subtraction                            qpepB0g1WDIS1jTNLO(1,4,2,3)
c      qactive_chan(9)  = .true.   ! Qb ep subtraction                           qpbepB0g1WDIS1jTNLO(1,4,2,3)
c      qactive_chan(10) = .true.   ! g ep subtraction                            gepB0g1WDIS1jTNLO(1,4,2,3)

      do i=6,10
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(11) = .true.   ! d ep to enub g g u    csB2g0WDIS1j(1,4,5,6,2,3)  qepcsB2g0WDIS1jS(1,4,5,6,2,3)
c      qactive_chan(12) = .true.   ! g ep to enub db g u   csB2g0WDIS1j(4,1,5,6,2,3)  gepcsB2g0WDIS1jS(4,1,5,6,2,3)
c      qactive_chan(13) = .true.   ! ub ep to enub db g g   csB2g0WDIS1j(4,5,6,1,2,3)  qbepcsB2g0WDIS1jS(4,5,6,1,2,3)
c      qactive_chan(14) = .true.   ! d ep to enub gt gt u   csBt2g0WDIS1j(1,4,5,6,2,3)  qepcsBt2g0WDIS1jS(1,4,5,6,2,3)
c      qactive_chan(15) = .true.   ! gt ep to enub db gt u   csBt2g0WDIS1j(4,1,5,6,2,3)  gtepcsBt2g0WDIS1jS(4,1,5,6,2,3)
c      qactive_chan(16) = .true.   ! ub ep to enub db gt gt   csBt2g0WDIS1j(4,5,6,1,2,3)  qbepcsBt2g0WDIS1jS(4,5,6,1,2,3)
c      qactive_chan(17) = .true.   ! d ep to enub Q Qb u   sC0g0WDIS1j(1,4,5,6,2,3)  qepsC0g0WDIS1jS(1,4,5,6,2,3)
c      qactive_chan(18) = .true.   ! Qb ep to enub db Qb u   sC0g0WDIS1j(4,1,5,6,2,3)  qpbepsC0g0WDIS1jS(4,1,5,6,2,3)
c      qactive_chan(19) = .true.   ! Q ep to enub db Q u   sC0g0WDIS1j(4,5,1,6,2,3)  qpepsC0g0WDIS1jS(4,5,1,6,2,3)
c      qactive_chan(20) = .true.   ! ub ep to enub db Q Qb   sC0g0WDIS1j(4,5,6,1,2,3)  qbepsC0g0WDIS1jS(4,5,6,1,2,3)
c      qactive_chan(21) = .true.   ! d ep to enub d db u   D0g0WaDIS1j(1,4,5,6,2,3)  qpepD0g0WaDIS1jS(1,4,5,6,2,3)
c      qactive_chan(22) = .true.   ! db ep to enub db db u   D0g0WaDIS1j(4,1,5,6,2,3)  qpbepD0g0WaDIS1jS(4,1,5,6,2,3)
c      qactive_chan(23) = .true.   ! ub ep to enub db d db   D0g0WaDIS1j(4,5,6,1,2,3)  qbepD0g0WaDIS1jS(4,5,6,1,2,3)
c      qactive_chan(24) = .true.   ! d ep to enub u ub u   D0g0WbDIS1j(1,4,5,6,2,3)  qpepD0g0WbDIS1jS(1,4,5,6,2,3)
c      qactive_chan(25) = .true.   ! ub ep to enub db ub u   D0g0WbDIS1j(4,1,5,6,2,3)  qbepD0g0WbDIS1jS(4,1,5,6,2,3)
c      qactive_chan(26) = .true.   ! u ep to enub db u u   D0g0WbDIS1j(4,5,1,6,2,3)  qepD0g0WbDIS1jS(4,5,1,6,2,3)

      do i=11,26
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(27) = .true.   ! d ep to enub g u      csB1g1WDIS1j(1,4,5,2,3)  qepcsB1g1WDIS1jT(1,4,5,2,3)
c      qactive_chan(28) = .true.   ! g ep to enub db u     csB1g1WDIS1j(4,1,5,2,3)  gepcsB1g1WDIS1jT(4,1,5,2,3)
c      qactive_chan(29) = .true.   ! ub ep to enub db g    csB1g1WDIS1j(4,5,1,2,3)  qbepcsB1g1WDIS1jT(4,5,1,2,3)
c      qactive_chan(30) = .true.   ! Q ep subtraction                            qpepcsB1g1WDIS1jT(1,4,5,2,3)
c      qactive_chan(31) = .true.   ! Qb ep subtraction                           qpbepcsB1g1WDIS1jT(1,4,5,2,3)
c      qactive_chan(32) = .true.   ! d ep to enub g u      csBt1g1WDIS1j(1,4,5,2,3)  qepcsBt1g1WDIS1jT(1,4,5,2,3)
c      qactive_chan(33) = .true.   ! g ep to enub db u     csBt1g1WDIS1j(4,1,5,2,3)  gepcsBt1g1WDIS1jT(4,1,5,2,3)
c      qactive_chan(34) = .true.   ! ub ep to enub db g    csBt1g1WDIS1j(4,5,1,2,3)  qbepcsBt1g1WDIS1jT(4,5,1,2,3)
c      qactive_chan(35) = .true.   ! Q ep subtraction                            qpepcsBt1g1WDIS1jT(1,4,5,2,3)
c      qactive_chan(36) = .true.   ! Qb ep subtraction                           qpbepcsBt1g1WDIS1jT(1,4,5,2,3)
c      qactive_chan(37) = .true.   ! d ep to enub g u      csBh1g1WDIS1j(1,4,5,2,3)  qepcsBh1g1WDIS1jT(1,4,5,2,3)
c      qactive_chan(38) = .true.   ! g ep to enub db u     csBh1g1WDIS1j(4,1,5,2,3)  gepcsBh1g1WDIS1jT(4,1,5,2,3)
c      qactive_chan(39) = .true.   ! ub ep to enub db g    csBh1g1WDIS1j(4,5,1,2,3)  qbepcsBh1g1WDIS1jT(4,5,1,2,3)
c      qactive_chan(40) = .true.   ! Q ep subtraction                            qpepcsBh1g1WDIS1jT(1,4,5,2,3)
c      qactive_chan(41) = .true.   ! Qb ep subtraction                           qpbepcsBh1g1WDIS1jT(1,4,5,2,3)

      do i=27,41
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(42) = .true.   ! d ep to enub u        B0g2WDIS1j(1,4,2,3)   qepB0g2WDIS1jU(1,4,2,3)
c      qactive_chan(43) = .true.   ! ub ep to enub db      B0g2WDIS1j(4,1,2,3)   qbepB0g2WDIS1jU(4,1,2,3)
c      qactive_chan(44) = .true.   ! Q ep subtraction                            qpepB0g2WDIS1jU(1,4,2,3)
c      qactive_chan(45) = .true.   ! Qb ep subtraction                           qpbepB0g2WDIS1jU(1,4,2,3)
c      qactive_chan(46) = .true.   ! db ep subtraction                           dbepB0g2WDIS1jU(1,4,2,3)
c      qactive_chan(47) = .true.   ! g ep subtraction                            gepB0g2WDIS1jU(1,4,2,3)
c      qactive_chan(48) = .true.   ! u ep subtraction                            uepB0g2WDIS1jU(1,4,2,3)
c      qactive_chan(49) = .true.   ! d ep to enub u        Bt0g2WDIS1j(1,4,2,3)  qepBt0g2WDIS1jU(1,4,2,3)
c      qactive_chan(50) = .true.   ! ub ep to enub db      Bt0g2WDIS1j(4,1,2,3)  qbepBt0g2WDIS1jU(4,1,2,3)
c      qactive_chan(51) = .true.   ! Q ep subtraction                            qpepBt0g2WDIS1jU(1,4,2,3)
c      qactive_chan(52) = .true.   ! Qb ep subtraction                           qpbepBt0g2WDIS1jU(1,4,2,3)
c      qactive_chan(53) = .true.   ! db ep subtraction                           dbepBt0g2WDIS1jU(1,4,2,3)
c      qactive_chan(54) = .true.   ! g ep subtraction                            gepBt0g2WDIS1jU(1,4,2,3)
c      qactive_chan(55) = .true.   ! u ep subtraction                            uepBt0g2WDIS1jU(1,4,2,3)
c      qactive_chan(56) = .true.   ! d ep to enub u        Bh0g2WDIS1j(1,4,2,3)  qepBh0g2WDIS1jU(1,4,2,3)
c      qactive_chan(57) = .true.   ! ub ep to enub db      Bh0g2WDIS1j(4,1,2,3)  qbepBh0g2WDIS1jU(4,1,2,3)
c      qactive_chan(58) = .true.   ! Q ep subtraction                            qpepBh0g2WDIS1jU(1,4,2,3)
c      qactive_chan(59) = .true.   ! Qb ep subtraction                           qpbepBh0g2WDIS1jU(1,4,2,3)
c      qactive_chan(60) = .true.   ! db ep subtraction                           dbepBh0g2WDIS1jU(1,4,2,3)
c      qactive_chan(61) = .true.   ! g ep subtraction                            gepBh0g2WDIS1jU(1,4,2,3)
c      qactive_chan(62) = .true.   ! u ep subtraction                            uepBh0g2WDIS1jU(1,4,2,3)

      do i=42,62
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelDISWp1j(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'd ep to enub u      '
        me_str   = 'B0g0WDIS1j(1,4,2,3) '
        sub_str  = ''

      case (2)
        chan_str = 'ub ep to enub db    '
        me_str   = 'B0g0WDIS1j(4,1,2,3) '
        sub_str  = ''

      case (3)
        chan_str = 'd ep to enub g u    '
        me_str   = 'B1g0WDIS1j(1,4,5,2,3)'
        sub_str  = 'qepB1g0WDIS1jSNLO(1,4,5,2,3)'

      case (4)
        chan_str = 'g ep to enub db u   '
        me_str   = 'B1g0WDIS1j(4,1,5,2,3)'
        sub_str  = 'gepB1g0WDIS1jSNLO(4,1,5,2,3)'

      case (5)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'B1g0WDIS1j(4,5,1,2,3)'
        sub_str  = 'qbepB1g0WDIS1jSNLO(4,5,1,2,3)'

      case (6)
        chan_str = 'd ep to enub u      '
        me_str   = 'B0g1WDIS1j(1,4,2,3) '
        sub_str  = 'qepB0g1WDIS1jTNLO(1,4,2,3)'

      case (7)
        chan_str = 'ub ep to enub db    '
        me_str   = 'B0g1WDIS1j(4,1,2,3) '
        sub_str  = 'qbepB0g1WDIS1jTNLO(4,1,2,3)'

      case (8)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepB0g1WDIS1jTNLO(1,4,2,3)'

      case (9)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepB0g1WDIS1jTNLO(1,4,2,3)'

      case (10)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepB0g1WDIS1jTNLO(1,4,2,3)'

      case (11)
        chan_str = 'd ep to enub g g u  '
        me_str   = 'csB2g0WDIS1j(1,4,5,6,2,3)'
        sub_str  = 'qepcsB2g0WDIS1jS(1,4,5,6,2,3)'

      case (12)
        chan_str = 'g ep to enub db g u '
        me_str   = 'csB2g0WDIS1j(4,1,5,6,2,3)'
        sub_str  = 'gepcsB2g0WDIS1jS(4,1,5,6,2,3)'

      case (13)
        chan_str = 'ub ep to enub db g g '
        me_str   = 'csB2g0WDIS1j(4,5,6,1,2,3)'
        sub_str  = 'qbepcsB2g0WDIS1jS(4,5,6,1,2,3)'

      case (14)
        chan_str = 'd ep to enub gt gt u '
        me_str   = 'csBt2g0WDIS1j(1,4,5,6,2,3)'
        sub_str  = 'qepcsBt2g0WDIS1jS(1,4,5,6,2,3)'

      case (15)
        chan_str = 'gt ep to enub db gt u '
        me_str   = 'csBt2g0WDIS1j(4,1,5,6,2,3)'
        sub_str  = 'gtepcsBt2g0WDIS1jS(4,1,5,6,2,3)'

      case (16)
        chan_str = 'ub ep to enub db gt gt '
        me_str   = 'csBt2g0WDIS1j(4,5,6,1,2,3)'
        sub_str  = 'qbepcsBt2g0WDIS1jS(4,5,6,1,2,3)'

      case (17)
        chan_str = 'd ep to enub Q Qb u '
        me_str   = 'sC0g0WDIS1j(1,4,5,6,2,3)'
        sub_str  = 'qepsC0g0WDIS1jS(1,4,5,6,2,3)'

      case (18)
        chan_str = 'Qb ep to enub db Qb u '
        me_str   = 'sC0g0WDIS1j(4,1,5,6,2,3)'
        sub_str  = 'qpbepsC0g0WDIS1jS(4,1,5,6,2,3)'

      case (19)
        chan_str = 'Q ep to enub db Q u '
        me_str   = 'sC0g0WDIS1j(4,5,1,6,2,3)'
        sub_str  = 'qpepsC0g0WDIS1jS(4,5,1,6,2,3)'

      case (20)
        chan_str = 'ub ep to enub db Q Qb '
        me_str   = 'sC0g0WDIS1j(4,5,6,1,2,3)'
        sub_str  = 'qbepsC0g0WDIS1jS(4,5,6,1,2,3)'

      case (21)
        chan_str = 'd ep to enub d db u '
        me_str   = 'D0g0WaDIS1j(1,4,5,6,2,3)'
        sub_str  = 'qpepD0g0WaDIS1jS(1,4,5,6,2,3)'

      case (22)
        chan_str = 'db ep to enub db db u '
        me_str   = 'D0g0WaDIS1j(4,1,5,6,2,3)'
        sub_str  = 'qpbepD0g0WaDIS1jS(4,1,5,6,2,3)'

      case (23)
        chan_str = 'ub ep to enub db d db '
        me_str   = 'D0g0WaDIS1j(4,5,6,1,2,3)'
        sub_str  = 'qbepD0g0WaDIS1jS(4,5,6,1,2,3)'

      case (24)
        chan_str = 'd ep to enub u ub u '
        me_str   = 'D0g0WbDIS1j(1,4,5,6,2,3)'
        sub_str  = 'qpepD0g0WbDIS1jS(1,4,5,6,2,3)'

      case (25)
        chan_str = 'ub ep to enub db ub u '
        me_str   = 'D0g0WbDIS1j(4,1,5,6,2,3)'
        sub_str  = 'qbepD0g0WbDIS1jS(4,1,5,6,2,3)'

      case (26)
        chan_str = 'u ep to enub db u u '
        me_str   = 'D0g0WbDIS1j(4,5,1,6,2,3)'
        sub_str  = 'qepD0g0WbDIS1jS(4,5,1,6,2,3)'

      case (27)
        chan_str = 'd ep to enub g u    '
        me_str   = 'csB1g1WDIS1j(1,4,5,2,3)'
        sub_str  = 'qepcsB1g1WDIS1jT(1,4,5,2,3)'

      case (28)
        chan_str = 'g ep to enub db u   '
        me_str   = 'csB1g1WDIS1j(4,1,5,2,3)'
        sub_str  = 'gepcsB1g1WDIS1jT(4,1,5,2,3)'

      case (29)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'csB1g1WDIS1j(4,5,1,2,3)'
        sub_str  = 'qbepcsB1g1WDIS1jT(4,5,1,2,3)'

      case (30)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepcsB1g1WDIS1jT(1,4,5,2,3)'

      case (31)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepcsB1g1WDIS1jT(1,4,5,2,3)'

      case (32)
        chan_str = 'd ep to enub g u    '
        me_str   = 'csBt1g1WDIS1j(1,4,5,2,3)'
        sub_str  = 'qepcsBt1g1WDIS1jT(1,4,5,2,3)'

      case (33)
        chan_str = 'g ep to enub db u   '
        me_str   = 'csBt1g1WDIS1j(4,1,5,2,3)'
        sub_str  = 'gepcsBt1g1WDIS1jT(4,1,5,2,3)'

      case (34)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'csBt1g1WDIS1j(4,5,1,2,3)'
        sub_str  = 'qbepcsBt1g1WDIS1jT(4,5,1,2,3)'

      case (35)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepcsBt1g1WDIS1jT(1,4,5,2,3)'

      case (36)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepcsBt1g1WDIS1jT(1,4,5,2,3)'

      case (37)
        chan_str = 'd ep to enub g u    '
        me_str   = 'csBh1g1WDIS1j(1,4,5,2,3)'
        sub_str  = 'qepcsBh1g1WDIS1jT(1,4,5,2,3)'

      case (38)
        chan_str = 'g ep to enub db u   '
        me_str   = 'csBh1g1WDIS1j(4,1,5,2,3)'
        sub_str  = 'gepcsBh1g1WDIS1jT(4,1,5,2,3)'

      case (39)
        chan_str = 'ub ep to enub db g  '
        me_str   = 'csBh1g1WDIS1j(4,5,1,2,3)'
        sub_str  = 'qbepcsBh1g1WDIS1jT(4,5,1,2,3)'

      case (40)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepcsBh1g1WDIS1jT(1,4,5,2,3)'

      case (41)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepcsBh1g1WDIS1jT(1,4,5,2,3)'

      case (42)
        chan_str = 'd ep to enub u      '
        me_str   = 'B0g2WDIS1j(1,4,2,3) '
        sub_str  = 'qepB0g2WDIS1jU(1,4,2,3)'

      case (43)
        chan_str = 'ub ep to enub db    '
        me_str   = 'B0g2WDIS1j(4,1,2,3) '
        sub_str  = 'qbepB0g2WDIS1jU(4,1,2,3)'

      case (44)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepB0g2WDIS1jU(1,4,2,3)'

      case (45)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepB0g2WDIS1jU(1,4,2,3)'

      case (46)
        chan_str = 'db ep subtraction   '
        me_str   = '                    '
        sub_str  = 'dbepB0g2WDIS1jU(1,4,2,3)'

      case (47)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepB0g2WDIS1jU(1,4,2,3)'

      case (48)
        chan_str = 'u ep subtraction    '
        me_str   = '                    '
        sub_str  = 'uepB0g2WDIS1jU(1,4,2,3)'

      case (49)
        chan_str = 'd ep to enub u      '
        me_str   = 'Bt0g2WDIS1j(1,4,2,3)'
        sub_str  = 'qepBt0g2WDIS1jU(1,4,2,3)'

      case (50)
        chan_str = 'ub ep to enub db    '
        me_str   = 'Bt0g2WDIS1j(4,1,2,3)'
        sub_str  = 'qbepBt0g2WDIS1jU(4,1,2,3)'

      case (51)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepBt0g2WDIS1jU(1,4,2,3)'

      case (52)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepBt0g2WDIS1jU(1,4,2,3)'

      case (53)
        chan_str = 'db ep subtraction   '
        me_str   = '                    '
        sub_str  = 'dbepBt0g2WDIS1jU(1,4,2,3)'

      case (54)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepBt0g2WDIS1jU(1,4,2,3)'

      case (55)
        chan_str = 'u ep subtraction    '
        me_str   = '                    '
        sub_str  = 'uepBt0g2WDIS1jU(1,4,2,3)'

      case (56)
        chan_str = 'd ep to enub u      '
        me_str   = 'Bh0g2WDIS1j(1,4,2,3)'
        sub_str  = 'qepBh0g2WDIS1jU(1,4,2,3)'

      case (57)
        chan_str = 'ub ep to enub db    '
        me_str   = 'Bh0g2WDIS1j(4,1,2,3)'
        sub_str  = 'qbepBh0g2WDIS1jU(4,1,2,3)'

      case (58)
        chan_str = 'Q ep subtraction    '
        me_str   = '                    '
        sub_str  = 'qpepBh0g2WDIS1jU(1,4,2,3)'

      case (59)
        chan_str = 'Qb ep subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbepBh0g2WDIS1jU(1,4,2,3)'

      case (60)
        chan_str = 'db ep subtraction   '
        me_str   = '                    '
        sub_str  = 'dbepBh0g2WDIS1jU(1,4,2,3)'

      case (61)
        chan_str = 'g ep subtraction    '
        me_str   = '                    '
        sub_str  = 'gepBh0g2WDIS1jU(1,4,2,3)'

      case (62)
        chan_str = 'u ep subtraction    '
        me_str   = '                    '
        sub_str  = 'uepBh0g2WDIS1jU(1,4,2,3)'

      case default
        print*, 'getchannelDISWp1j: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtDISWp1j(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtDISWp1j = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (11)
        ! [enub, g, g, u]
        LIPSwgtDISWp1j = weight_lips((/ 4,5 /))

      case (13)
        ! [enub, db, g, g]
        LIPSwgtDISWp1j = weight_lips((/ 5,6 /))

      case (14)
        ! [enub, gt, gt, u]
        LIPSwgtDISWp1j = weight_lips((/ 4,5 /))

      case (16)
        ! [enub, db, gt, gt]
        LIPSwgtDISWp1j = weight_lips((/ 5,6 /))

      case (22)
        ! [enub, db, db, u]
        LIPSwgtDISWp1j = weight_lips((/ 4,5 /))

      case (23)
        ! [enub, db, d, db]
        LIPSwgtDISWp1j = weight_lips((/ 4,6 /))

      case (24)
        ! [enub, u, ub, u]
        LIPSwgtDISWp1j = weight_lips((/ 4,6 /))

      case (26)
        ! [enub, db, u, u]
        LIPSwgtDISWp1j = weight_lips((/ 5,6 /))

      case default
        LIPSwgtDISWp1j = 1

      end select
      end
