      function sigRRDISWm1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRRDISWm1j=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_dis1j(0,6,ipass)
      virtsflag=.false.
      jflag=.false.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(6, (/ 1, 2, 3, 4, 5, 6 /) )
#endif 

c--- u em to enu g g d 
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           csB2g0WDIS1j(1,4,5,6,3,2)
     .          +csB2g0WDIS1j(1,5,4,6,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g em to enu ub g d 
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           csB2g0WDIS1j(4,1,5,6,3,2)
     .          +csB2g0WDIS1j(4,5,1,6,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub g g 
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           csB2g0WDIS1j(4,5,6,1,3,2)
     .          +csB2g0WDIS1j(4,6,5,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu gt gt d 
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           csBt2g0WDIS1j(1,4,5,6,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt em to enu ub gt d 
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = csBt2g0WDIS1j(4,1,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub gt gt 
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           csBt2g0WDIS1j(4,5,6,1,3,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu Q Qb d 
      if (qactive_chan(17).and.qselect_chan(17)) then
        current_chan = 17
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC0g0WDIS1j(1,4,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb em to enu ub Qb d 
      if (qactive_chan(18).and.qselect_chan(18)) then
        current_chan = 18
        ip1_chan     = -30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC0g0WDIS1j(4,1,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q em to enu ub Q d 
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = 30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,1,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC0g0WDIS1j(4,5,1,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub Q Qb 
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC0g0WDIS1j(4,5,6,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu u ub d 
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0WaDIS1j(1,4,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub em to enu ub ub d 
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0WaDIS1j(4,1,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub u ub 
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,6,1,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0WaDIS1j(4,5,6,1,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u em to enu d db d 
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,4,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0WbDIS1j(1,4,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db em to enu ub db d 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,1,5,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0WbDIS1j(4,1,5,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d em to enu ub d d 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = 40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 4,5,1,6,3,2 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D0g0WbDIS1j(4,5,1,6,3,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRRDISWm1j=rnorm*wtsum

      return
      end
