      subroutine getlumiGJ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,   13,   27,   73,  103,  133,  163,  177,          
     &          191,  205,  206,  245,  246,  285,  301,  317,          
     &          347,  377,  391,  405,  435,  449,  511,  512,          
     &          551,  552,  591,  592,  611,  627,  643,  660,          
     &          672,  706,  740,  774,  786,  788,  824,  836,          
     &          838,  874,  886,  888,  924)
!       [10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,   14,   28,   74,  104,  134,  164,  178,          
     &          192,  207,  208,  247,  248,  286,  302,  318,          
     &          348,  378,  392,  406,  436,  450,  513,  514,          
     &          553,  554,  593,  594,  612,  628,  644,  661,          
     &          673,  707,  741,  775,  787,  789,  825,  837,          
     &          839,  875,  887,  889,  925)
!       [20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    3,   15,   29,   49,   50,   65,   75,  105,          
     &          135,  165,  179,  193,  217,  218,  257,  258,          
     &          287,  303,  319,  349,  379,  393,  407,  437,          
     &          451,  487,  488,  527,  528,  567,  568,  599,          
     &          615,  631,  674,  708,  742,  776,  826,  876,          
     &          926)
!       [10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    4,   16,   30,   51,   52,   66,   76,  106,          
     &          136,  166,  180,  194,  219,  220,  259,  260,          
     &          288,  304,  320,  350,  380,  394,  408,  438,          
     &          452,  489,  490,  529,  530,  569,  570,  600,          
     &          616,  632,  675,  709,  743,  777,  827,  877,          
     &          927)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (    5,   17,   31,   77,  107,  137,  167,  181,          
     &          195,  221,  222,  261,  262,  291,  307,  321,          
     &          351,  381,  395,  409,  439,  453,  503,  504,          
     &          543,  544,  583,  584,  607,  623,  639,  648,          
     &          676,  710,  744,  778,  794,  796,  828,  844,          
     &          846,  878,  894,  896,  928)
!       [0, 10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (    6,   18,   32,   78,  108,  138,  168,  182,          
     &          196,  223,  224,  263,  264,  292,  308,  322,          
     &          352,  382,  396,  410,  440,  454,  505,  506,          
     &          545,  546,  585,  586,  608,  624,  640,  649,          
     &          677,  711,  745,  779,  795,  797,  829,  845,          
     &          847,  879,  895,  897,  929)
!       [0, 20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (    7,   19,   33,   53,   54,   69,   79,  109,          
     &          139,  169,  183,  197,  225,  226,  265,  266,          
     &          293,  309,  323,  353,  383,  397,  411,  441,          
     &          455,  491,  492,  531,  532,  571,  572,  603,          
     &          619,  635,  678,  712,  746,  780,  830,  880,          
     &          930)
!       [-10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    8,   20,   34,   55,   56,   70,   80,  110,          
     &          140,  170,  184,  198,  227,  228,  267,  268,          
     &          294,  310,  324,  354,  384,  398,  412,  442,          
     &          456,  493,  494,  533,  534,  573,  574,  604,          
     &          620,  636,  679,  713,  747,  781,  831,  881,          
     &          931)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (    9,   23,   37,   81,  111,  141,  173,  187,          
     &          201,  229,  230,  269,  270,  295,  311,  327,          
     &          357,  387,  401,  415,  445,  459,  507,  508,          
     &          547,  548,  587,  588,  609,  625,  641,  650,          
     &          680,  714,  748,  782,  798,  800,  832,  848,          
     &          850,  882,  898,  900,  932)
!       [0, -10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   10,   24,   38,   82,  112,  142,  174,  188,          
     &          202,  231,  232,  271,  272,  296,  312,  328,          
     &          358,  388,  402,  416,  446,  460,  509,  510,          
     &          549,  550,  589,  590,  610,  626,  642,  651,          
     &          681,  715,  749,  783,  799,  801,  833,  849,          
     &          851,  883,  899,  901,  933)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   11,   25,   39,   83,  113,  143,  175,  189,          
     &          203,  233,  234,  273,  274,  297,  313,  329,          
     &          359,  389,  403,  417,  447,  461,  515,  516,          
     &          555,  556,  595,  596,  613,  629,  645,  670,          
     &          682,  716,  750,  784,  790,  792,  834,  840,          
     &          842,  884,  890,  892,  934)
!       [-10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   12,   26,   40,   84,  114,  144,  176,  190,          
     &          204,  235,  236,  275,  276,  298,  314,  330,          
     &          360,  390,  404,  418,  448,  462,  517,  518,          
     &          557,  558,  597,  598,  614,  630,  646,  671,          
     &          683,  717,  751,  785,  791,  793,  835,  841,          
     &          843,  885,  891,  893,  935)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   21,   22,   35,   36,   85,   86,  115,  116,          
     &          145,  146,  171,  172,  185,  186,  199,  200,          
     &          325,  326,  355,  356,  385,  386,  399,  400,          
     &          413,  414,  443,  444,  457,  458,  647,  684,          
     &          685,  718,  719,  752,  753,  802,  803,  852,          
     &          853,  902,  903,  936,  937)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   41,   91,  121,  151,  209,  249,  335,  365,          
     &          423,  467,  479,  519,  559,  656,  690,  724,          
     &          758,  808,  858,  908,  942)
!       [11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   42,   92,  122,  152,  210,  250,  336,  366,          
     &          424,  468,  480,  520,  560,  657,  691,  725,          
     &          759,  809,  859,  909,  943)
!       [11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   43,   93,  123,  153,  211,  251,  337,  367,          
     &          425,  469,  481,  521,  561,  658,  692,  726,          
     &          760,  810,  860,  910,  944)
!       [21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   44,   94,  124,  154,  212,  252,  338,  368,          
     &          426,  470,  482,  522,  562,  659,  693,  727,          
     &          761,  811,  861,  911,  945)
!       [21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   45,   87,  117,  147,  213,  253,  331,  361,          
     &          419,  463,  483,  523,  563,  652,  686,  720,          
     &          754,  804,  854,  904,  938)
!       [11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   46,   88,  118,  148,  214,  254,  332,  362,          
     &          420,  464,  484,  524,  564,  653,  687,  721,          
     &          755,  805,  855,  905,  939)
!       [11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   47,   89,  119,  149,  215,  255,  333,  363,          
     &          421,  465,  485,  525,  565,  654,  688,  722,          
     &          756,  806,  856,  906,  940)
!       [21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   48,   90,  120,  150,  216,  256,  334,  364,          
     &          422,  466,  486,  526,  566,  655,  689,  723,          
     &          757,  807,  857,  907,  941)
!       [21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   57,   99,  129,  159,  237,  277,  343,  373,          
     &          431,  475,  495,  535,  575,  666,  700,  734,          
     &          768,  818,  868,  918,  952)
!       [-11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   58,  100,  130,  160,  238,  278,  344,  374,          
     &          432,  476,  496,  536,  576,  667,  701,  735,          
     &          769,  819,  869,  919,  953)
!       [-11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   59,  101,  131,  161,  239,  279,  345,  375,          
     &          433,  477,  497,  537,  577,  668,  702,  736,          
     &          770,  820,  870,  920,  954)
!       [-21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   60,  102,  132,  162,  240,  280,  346,  376,          
     &          434,  478,  498,  538,  578,  669,  703,  737,          
     &          771,  821,  871,  921,  955)
!       [-21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   61,   95,  125,  155,  241,  281,  339,  369,          
     &          427,  471,  499,  539,  579,  662,  696,  730,          
     &          764,  814,  864,  914,  948)
!       [-11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   62,   96,  126,  156,  242,  282,  340,  370,          
     &          428,  472,  500,  540,  580,  663,  697,  731,          
     &          765,  815,  865,  915,  949)
!       [-11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   63,   97,  127,  157,  243,  283,  341,  371,          
     &          429,  473,  501,  541,  581,  664,  698,  732,          
     &          766,  816,  866,  916,  950)
!       [-21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   64,   98,  128,  158,  244,  284,  342,  372,          
     &          430,  474,  502,  542,  582,  665,  699,  733,          
     &          767,  817,  867,  917,  951)
!       [-21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   67,  289,  305,  601,  617,  633,  694,  728,          
     &          762,  812,  862,  912,  946)
!       [10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   68,  290,  306,  602,  618,  634,  695,  729,          
     &          763,  813,  863,  913,  947)
!       [20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   71,  299,  315,  605,  621,  637,  704,  738,          
     &          772,  822,  872,  922,  956)
!       [-10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   72,  300,  316,  606,  622,  638,  705,  739,          
     &          773,  823,  873,  923,  957)
!       [-20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case default
          print*, "getlumiGJ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiGJ



      function getlumiidGJ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,   13,   27,   73,  103,  133,  163,  177,
     &          191,  205,  206,  245,  246,  285,  301,  317,
     &          347,  377,  391,  405,  435,  449,  511,  512,
     &          551,  552,  591,  592,  611,  627,  643,  660,
     &          672,  706,  740,  774,  786,  788,  824,  836,
     &          838,  874,  886,  888,  924)
          id  = 1
          ip1 = 10
          ip2 = 0

        case (    2,   14,   28,   74,  104,  134,  164,  178,
     &          192,  207,  208,  247,  248,  286,  302,  318,
     &          348,  378,  392,  406,  436,  450,  513,  514,
     &          553,  554,  593,  594,  612,  628,  644,  661,
     &          673,  707,  741,  775,  787,  789,  825,  837,
     &          839,  875,  887,  889,  925)
          id  = 2
          ip1 = 20
          ip2 = 0

        case (    3,   15,   29,   49,   50,   65,   75,  105,
     &          135,  165,  179,  193,  217,  218,  257,  258,
     &          287,  303,  319,  349,  379,  393,  407,  437,
     &          451,  487,  488,  527,  528,  567,  568,  599,
     &          615,  631,  674,  708,  742,  776,  826,  876,
     &          926)
          id  = 3
          ip1 = 10
          ip2 = -10

        case (    4,   16,   30,   51,   52,   66,   76,  106,
     &          136,  166,  180,  194,  219,  220,  259,  260,
     &          288,  304,  320,  350,  380,  394,  408,  438,
     &          452,  489,  490,  529,  530,  569,  570,  600,
     &          616,  632,  675,  709,  743,  777,  827,  877,
     &          927)
          id  = 4
          ip1 = 20
          ip2 = -20

        case (    5,   17,   31,   77,  107,  137,  167,  181,
     &          195,  221,  222,  261,  262,  291,  307,  321,
     &          351,  381,  395,  409,  439,  453,  503,  504,
     &          543,  544,  583,  584,  607,  623,  639,  648,
     &          676,  710,  744,  778,  794,  796,  828,  844,
     &          846,  878,  894,  896,  928)
          id  = 5
          ip1 = 0
          ip2 = 10

        case (    6,   18,   32,   78,  108,  138,  168,  182,
     &          196,  223,  224,  263,  264,  292,  308,  322,
     &          352,  382,  396,  410,  440,  454,  505,  506,
     &          545,  546,  585,  586,  608,  624,  640,  649,
     &          677,  711,  745,  779,  795,  797,  829,  845,
     &          847,  879,  895,  897,  929)
          id  = 6
          ip1 = 0
          ip2 = 20

        case (    7,   19,   33,   53,   54,   69,   79,  109,
     &          139,  169,  183,  197,  225,  226,  265,  266,
     &          293,  309,  323,  353,  383,  397,  411,  441,
     &          455,  491,  492,  531,  532,  571,  572,  603,
     &          619,  635,  678,  712,  746,  780,  830,  880,
     &          930)
          id  = 7
          ip1 = -10
          ip2 = 10

        case (    8,   20,   34,   55,   56,   70,   80,  110,
     &          140,  170,  184,  198,  227,  228,  267,  268,
     &          294,  310,  324,  354,  384,  398,  412,  442,
     &          456,  493,  494,  533,  534,  573,  574,  604,
     &          620,  636,  679,  713,  747,  781,  831,  881,
     &          931)
          id  = 8
          ip1 = -20
          ip2 = 20

        case (    9,   23,   37,   81,  111,  141,  173,  187,
     &          201,  229,  230,  269,  270,  295,  311,  327,
     &          357,  387,  401,  415,  445,  459,  507,  508,
     &          547,  548,  587,  588,  609,  625,  641,  650,
     &          680,  714,  748,  782,  798,  800,  832,  848,
     &          850,  882,  898,  900,  932)
          id  = 9
          ip1 = 0
          ip2 = -10

        case (   10,   24,   38,   82,  112,  142,  174,  188,
     &          202,  231,  232,  271,  272,  296,  312,  328,
     &          358,  388,  402,  416,  446,  460,  509,  510,
     &          549,  550,  589,  590,  610,  626,  642,  651,
     &          681,  715,  749,  783,  799,  801,  833,  849,
     &          851,  883,  899,  901,  933)
          id  = 10
          ip1 = 0
          ip2 = -20

        case (   11,   25,   39,   83,  113,  143,  175,  189,
     &          203,  233,  234,  273,  274,  297,  313,  329,
     &          359,  389,  403,  417,  447,  461,  515,  516,
     &          555,  556,  595,  596,  613,  629,  645,  670,
     &          682,  716,  750,  784,  790,  792,  834,  840,
     &          842,  884,  890,  892,  934)
          id  = 11
          ip1 = -10
          ip2 = 0

        case (   12,   26,   40,   84,  114,  144,  176,  190,
     &          204,  235,  236,  275,  276,  298,  314,  330,
     &          360,  390,  404,  418,  448,  462,  517,  518,
     &          557,  558,  597,  598,  614,  630,  646,  671,
     &          683,  717,  751,  785,  791,  793,  835,  841,
     &          843,  885,  891,  893,  935)
          id  = 12
          ip1 = -20
          ip2 = 0

        case (   21,   22,   35,   36,   85,   86,  115,  116,
     &          145,  146,  171,  172,  185,  186,  199,  200,
     &          325,  326,  355,  356,  385,  386,  399,  400,
     &          413,  414,  443,  444,  457,  458,  647,  684,
     &          685,  718,  719,  752,  753,  802,  803,  852,
     &          853,  902,  903,  936,  937)
          id  = 13
          ip1 = 0
          ip2 = 0

        case (   41,   91,  121,  151,  209,  249,  335,  365,
     &          423,  467,  479,  519,  559,  656,  690,  724,
     &          758,  808,  858,  908,  942)
          id  = 14
          ip1 = 11
          ip2 = -11

        case (   42,   92,  122,  152,  210,  250,  336,  366,
     &          424,  468,  480,  520,  560,  657,  691,  725,
     &          759,  809,  859,  909,  943)
          id  = 15
          ip1 = 11
          ip2 = -21

        case (   43,   93,  123,  153,  211,  251,  337,  367,
     &          425,  469,  481,  521,  561,  658,  692,  726,
     &          760,  810,  860,  910,  944)
          id  = 16
          ip1 = 21
          ip2 = -11

        case (   44,   94,  124,  154,  212,  252,  338,  368,
     &          426,  470,  482,  522,  562,  659,  693,  727,
     &          761,  811,  861,  911,  945)
          id  = 17
          ip1 = 21
          ip2 = -21

        case (   45,   87,  117,  147,  213,  253,  331,  361,
     &          419,  463,  483,  523,  563,  652,  686,  720,
     &          754,  804,  854,  904,  938)
          id  = 18
          ip1 = 11
          ip2 = 11

        case (   46,   88,  118,  148,  214,  254,  332,  362,
     &          420,  464,  484,  524,  564,  653,  687,  721,
     &          755,  805,  855,  905,  939)
          id  = 19
          ip1 = 11
          ip2 = 21

        case (   47,   89,  119,  149,  215,  255,  333,  363,
     &          421,  465,  485,  525,  565,  654,  688,  722,
     &          756,  806,  856,  906,  940)
          id  = 20
          ip1 = 21
          ip2 = 11

        case (   48,   90,  120,  150,  216,  256,  334,  364,
     &          422,  466,  486,  526,  566,  655,  689,  723,
     &          757,  807,  857,  907,  941)
          id  = 21
          ip1 = 21
          ip2 = 21

        case (   57,   99,  129,  159,  237,  277,  343,  373,
     &          431,  475,  495,  535,  575,  666,  700,  734,
     &          768,  818,  868,  918,  952)
          id  = 22
          ip1 = -11
          ip2 = -11

        case (   58,  100,  130,  160,  238,  278,  344,  374,
     &          432,  476,  496,  536,  576,  667,  701,  735,
     &          769,  819,  869,  919,  953)
          id  = 23
          ip1 = -11
          ip2 = -21

        case (   59,  101,  131,  161,  239,  279,  345,  375,
     &          433,  477,  497,  537,  577,  668,  702,  736,
     &          770,  820,  870,  920,  954)
          id  = 24
          ip1 = -21
          ip2 = -11

        case (   60,  102,  132,  162,  240,  280,  346,  376,
     &          434,  478,  498,  538,  578,  669,  703,  737,
     &          771,  821,  871,  921,  955)
          id  = 25
          ip1 = -21
          ip2 = -21

        case (   61,   95,  125,  155,  241,  281,  339,  369,
     &          427,  471,  499,  539,  579,  662,  696,  730,
     &          764,  814,  864,  914,  948)
          id  = 26
          ip1 = -11
          ip2 = 11

        case (   62,   96,  126,  156,  242,  282,  340,  370,
     &          428,  472,  500,  540,  580,  663,  697,  731,
     &          765,  815,  865,  915,  949)
          id  = 27
          ip1 = -11
          ip2 = 21

        case (   63,   97,  127,  157,  243,  283,  341,  371,
     &          429,  473,  501,  541,  581,  664,  698,  732,
     &          766,  816,  866,  916,  950)
          id  = 28
          ip1 = -21
          ip2 = 11

        case (   64,   98,  128,  158,  244,  284,  342,  372,
     &          430,  474,  502,  542,  582,  665,  699,  733,
     &          767,  817,  867,  917,  951)
          id  = 29
          ip1 = -21
          ip2 = 21

        case (   67,  289,  305,  601,  617,  633,  694,  728,
     &          762,  812,  862,  912,  946)
          id  = 30
          ip1 = 10
          ip2 = 10

        case (   68,  290,  306,  602,  618,  634,  695,  729,
     &          763,  813,  863,  913,  947)
          id  = 31
          ip1 = 20
          ip2 = 20

        case (   71,  299,  315,  605,  621,  637,  704,  738,
     &          772,  822,  872,  922,  956)
          id  = 32
          ip1 = -10
          ip2 = -10

        case (   72,  300,  316,  606,  622,  638,  705,  739,
     &          773,  823,  873,  923,  957)
          id  = 33
          ip1 = -20
          ip2 = -20

        case default
          print*, "getlumiidGJ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidGJ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiGJ()
        use PineAPPL_mod
        use CKM_mod
!       [10, 0]
        call register_lumi_pine(
     &         [    1,   13,   27,   73,  103,  133,  163,  177,
     &            191,  205,  206,  245,  246,  285,  301,  317,
     &            347,  377,  391,  405,  435,  449,  511,  512,
     &            551,  552,  591,  592,  611,  627,  643,  660,
     &            672,  706,  740,  774,  786,  788,  824,  836,
     &            838,  874,  886,  888,  924],
     &         3,
     &         [    1,   21,    3,   21,    5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 0]
        call register_lumi_pine(
     &         [    2,   14,   28,   74,  104,  134,  164,  178,
     &            192,  207,  208,  247,  248,  286,  302,  318,
     &            348,  378,  392,  406,  436,  450,  513,  514,
     &            553,  554,  593,  594,  612,  628,  644,  661,
     &            673,  707,  741,  775,  787,  789,  825,  837,
     &            839,  875,  887,  889,  925],
     &         2,
     &         [    2,   21,    4,   21],
     &         [  1d0,  1d0]
     &       )

!       [10, -10]
        call register_lumi_pine(
     &         [    3,   15,   29,   49,   50,   65,   75,  105,
     &            135,  165,  179,  193,  217,  218,  257,  258,
     &            287,  303,  319,  349,  379,  393,  407,  437,
     &            451,  487,  488,  527,  528,  567,  568,  599,
     &            615,  631,  674,  708,  742,  776,  826,  876,
     &            926],
     &         3,
     &         [    1,   -1,    3,   -3,    5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [    4,   16,   30,   51,   52,   66,   76,  106,
     &            136,  166,  180,  194,  219,  220,  259,  260,
     &            288,  304,  320,  350,  380,  394,  408,  438,
     &            452,  489,  490,  529,  530,  569,  570,  600,
     &            616,  632,  675,  709,  743,  777,  827,  877,
     &            927],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [0, 10]
        call register_lumi_pine(
     &         [    5,   17,   31,   77,  107,  137,  167,  181,
     &            195,  221,  222,  261,  262,  291,  307,  321,
     &            351,  381,  395,  409,  439,  453,  503,  504,
     &            543,  544,  583,  584,  607,  623,  639,  648,
     &            676,  710,  744,  778,  794,  796,  828,  844,
     &            846,  878,  894,  896,  928],
     &         3,
     &         [   21,    1,   21,    3,   21,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, 20]
        call register_lumi_pine(
     &         [    6,   18,   32,   78,  108,  138,  168,  182,
     &            196,  223,  224,  263,  264,  292,  308,  322,
     &            352,  382,  396,  410,  440,  454,  505,  506,
     &            545,  546,  585,  586,  608,  624,  640,  649,
     &            677,  711,  745,  779,  795,  797,  829,  845,
     &            847,  879,  895,  897,  929],
     &         2,
     &         [   21,    2,   21,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 10]
        call register_lumi_pine(
     &         [    7,   19,   33,   53,   54,   69,   79,  109,
     &            139,  169,  183,  197,  225,  226,  265,  266,
     &            293,  309,  323,  353,  383,  397,  411,  441,
     &            455,  491,  492,  531,  532,  571,  572,  603,
     &            619,  635,  678,  712,  746,  780,  830,  880,
     &            930],
     &         3,
     &         [   -1,    1,   -3,    3,   -5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [    8,   20,   34,   55,   56,   70,   80,  110,
     &            140,  170,  184,  198,  227,  228,  267,  268,
     &            294,  310,  324,  354,  384,  398,  412,  442,
     &            456,  493,  494,  533,  534,  573,  574,  604,
     &            620,  636,  679,  713,  747,  781,  831,  881,
     &            931],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [0, -10]
        call register_lumi_pine(
     &         [    9,   23,   37,   81,  111,  141,  173,  187,
     &            201,  229,  230,  269,  270,  295,  311,  327,
     &            357,  387,  401,  415,  445,  459,  507,  508,
     &            547,  548,  587,  588,  609,  625,  641,  650,
     &            680,  714,  748,  782,  798,  800,  832,  848,
     &            850,  882,  898,  900,  932],
     &         3,
     &         [   21,   -1,   21,   -3,   21,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [   10,   24,   38,   82,  112,  142,  174,  188,
     &            202,  231,  232,  271,  272,  296,  312,  328,
     &            358,  388,  402,  416,  446,  460,  509,  510,
     &            549,  550,  589,  590,  610,  626,  642,  651,
     &            681,  715,  749,  783,  799,  801,  833,  849,
     &            851,  883,  899,  901,  933],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 0]
        call register_lumi_pine(
     &         [   11,   25,   39,   83,  113,  143,  175,  189,
     &            203,  233,  234,  273,  274,  297,  313,  329,
     &            359,  389,  403,  417,  447,  461,  515,  516,
     &            555,  556,  595,  596,  613,  629,  645,  670,
     &            682,  716,  750,  784,  790,  792,  834,  840,
     &            842,  884,  890,  892,  934],
     &         3,
     &         [   -1,   21,   -3,   21,   -5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [   12,   26,   40,   84,  114,  144,  176,  190,
     &            204,  235,  236,  275,  276,  298,  314,  330,
     &            360,  390,  404,  418,  448,  462,  517,  518,
     &            557,  558,  597,  598,  614,  630,  646,  671,
     &            683,  717,  751,  785,  791,  793,  835,  841,
     &            843,  885,  891,  893,  935],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 0]
        call register_lumi_pine(
     &         [   21,   22,   35,   36,   85,   86,  115,  116,
     &            145,  146,  171,  172,  185,  186,  199,  200,
     &            325,  326,  355,  356,  385,  386,  399,  400,
     &            413,  414,  443,  444,  457,  458,  647,  684,
     &            685,  718,  719,  752,  753,  802,  803,  852,
     &            853,  902,  903,  936,  937],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [11, -11]
        call register_lumi_pine(
     &         [   41,   91,  121,  151,  209,  249,  335,  365,
     &            423,  467,  479,  519,  559,  656,  690,  724,
     &            758,  808,  858,  908,  942],
     &         9,
     &         [    1,   -1,    1,   -3,    1,   -5,    3,   -1,
     &              3,   -3,    3,   -5,    5,   -1,    5,   -3,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, -21]
        call register_lumi_pine(
     &         [   42,   92,  122,  152,  210,  250,  336,  366,
     &            424,  468,  480,  520,  560,  657,  691,  725,
     &            759,  809,  859,  909,  943],
     &         6,
     &         [    1,   -2,    1,   -4,    3,   -2,    3,   -4,
     &              5,   -2,    5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -11]
        call register_lumi_pine(
     &         [   43,   93,  123,  153,  211,  251,  337,  367,
     &            425,  469,  481,  521,  561,  658,  692,  726,
     &            760,  810,  860,  910,  944],
     &         6,
     &         [    2,   -1,    2,   -3,    2,   -5,    4,   -1,
     &              4,   -3,    4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -21]
        call register_lumi_pine(
     &         [   44,   94,  124,  154,  212,  252,  338,  368,
     &            426,  470,  482,  522,  562,  659,  693,  727,
     &            761,  811,  861,  911,  945],
     &         4,
     &         [    2,   -2,    2,   -4,    4,   -2,    4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [11, 11]
        call register_lumi_pine(
     &         [   45,   87,  117,  147,  213,  253,  331,  361,
     &            419,  463,  483,  523,  563,  652,  686,  720,
     &            754,  804,  854,  904,  938],
     &         9,
     &         [    1,    1,    1,    3,    1,    5,    3,    1,
     &              3,    3,    3,    5,    5,    1,    5,    3,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, 21]
        call register_lumi_pine(
     &         [   46,   88,  118,  148,  214,  254,  332,  362,
     &            420,  464,  484,  524,  564,  653,  687,  721,
     &            755,  805,  855,  905,  939],
     &         6,
     &         [    1,    2,    1,    4,    3,    2,    3,    4,
     &              5,    2,    5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 11]
        call register_lumi_pine(
     &         [   47,   89,  119,  149,  215,  255,  333,  363,
     &            421,  465,  485,  525,  565,  654,  688,  722,
     &            756,  806,  856,  906,  940],
     &         6,
     &         [    2,    1,    2,    3,    2,    5,    4,    1,
     &              4,    3,    4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 21]
        call register_lumi_pine(
     &         [   48,   90,  120,  150,  216,  256,  334,  364,
     &            422,  466,  486,  526,  566,  655,  689,  723,
     &            757,  807,  857,  907,  941],
     &         4,
     &         [    2,    2,    2,    4,    4,    2,    4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, -11]
        call register_lumi_pine(
     &         [   57,   99,  129,  159,  237,  277,  343,  373,
     &            431,  475,  495,  535,  575,  666,  700,  734,
     &            768,  818,  868,  918,  952],
     &         9,
     &         [   -1,   -1,   -1,   -3,   -1,   -5,   -3,   -1,
     &             -3,   -3,   -3,   -5,   -5,   -1,   -5,   -3,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, -21]
        call register_lumi_pine(
     &         [   58,  100,  130,  160,  238,  278,  344,  374,
     &            432,  476,  496,  536,  576,  667,  701,  735,
     &            769,  819,  869,  919,  953],
     &         6,
     &         [   -1,   -2,   -1,   -4,   -3,   -2,   -3,   -4,
     &             -5,   -2,   -5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -11]
        call register_lumi_pine(
     &         [   59,  101,  131,  161,  239,  279,  345,  375,
     &            433,  477,  497,  537,  577,  668,  702,  736,
     &            770,  820,  870,  920,  954],
     &         6,
     &         [   -2,   -1,   -2,   -3,   -2,   -5,   -4,   -1,
     &             -4,   -3,   -4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -21]
        call register_lumi_pine(
     &         [   60,  102,  132,  162,  240,  280,  346,  376,
     &            434,  478,  498,  538,  578,  669,  703,  737,
     &            771,  821,  871,  921,  955],
     &         4,
     &         [   -2,   -2,   -2,   -4,   -4,   -2,   -4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, 11]
        call register_lumi_pine(
     &         [   61,   95,  125,  155,  241,  281,  339,  369,
     &            427,  471,  499,  539,  579,  662,  696,  730,
     &            764,  814,  864,  914,  948],
     &         9,
     &         [   -1,    1,   -1,    3,   -1,    5,   -3,    1,
     &             -3,    3,   -3,    5,   -5,    1,   -5,    3,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, 21]
        call register_lumi_pine(
     &         [   62,   96,  126,  156,  242,  282,  340,  370,
     &            428,  472,  500,  540,  580,  663,  697,  731,
     &            765,  815,  865,  915,  949],
     &         6,
     &         [   -1,    2,   -1,    4,   -3,    2,   -3,    4,
     &             -5,    2,   -5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 11]
        call register_lumi_pine(
     &         [   63,   97,  127,  157,  243,  283,  341,  371,
     &            429,  473,  501,  541,  581,  664,  698,  732,
     &            766,  816,  866,  916,  950],
     &         6,
     &         [   -2,    1,   -2,    3,   -2,    5,   -4,    1,
     &             -4,    3,   -4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 21]
        call register_lumi_pine(
     &         [   64,   98,  128,  158,  244,  284,  342,  372,
     &            430,  474,  502,  542,  582,  665,  699,  733,
     &            767,  817,  867,  917,  951],
     &         4,
     &         [   -2,    2,   -2,    4,   -4,    2,   -4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [10, 10]
        call register_lumi_pine(
     &         [   67,  289,  305,  601,  617,  633,  694,  728,
     &            762,  812,  862,  912,  946],
     &         3,
     &         [    1,    1,    3,    3,    5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 20]
        call register_lumi_pine(
     &         [   68,  290,  306,  602,  618,  634,  695,  729,
     &            763,  813,  863,  913,  947],
     &         2,
     &         [    2,    2,    4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, -10]
        call register_lumi_pine(
     &         [   71,  299,  315,  605,  621,  637,  704,  738,
     &            772,  822,  872,  922,  956],
     &         3,
     &         [   -1,   -1,   -3,   -3,   -5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, -20]
        call register_lumi_pine(
     &         [   72,  300,  316,  606,  622,  638,  705,  739,
     &            773,  823,  873,  923,  957],
     &         2,
     &         [   -2,   -2,   -4,   -4],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiGJ


#endif


