*********************************************************************
*
*
* Quark pair NNLO double real subtraction term for
*
* q(i1) g (i2) g (i3) g(i4) qb(i5) e-(i6) e+(i7)
*
* summed and squared over helicities, single colour ordering without
* overall factors
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BGFlav/

      function gqsB3g0GS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqsB3g0GS = qgsB3g0GS(i1,i2,i3,i4,i5,i6)

      return
      end
      function gqbsB3g0GS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqbsB3g0GS = qbgsB3g0GS(i1,i2,i3,i4,i5,i6)

      return
      end

      function qgsB3g0GS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qgsB3g0GS =+qgB3g0GYS(i1,i3,i2,i4,i5,i6)
     .          +qgB3g0GXS(i1,i2,i3,i4,i5,i6)
     .          +qgB3g0GXS(i1,i2,i4,i3,i5,i6)

      return
      end

      function qbgsB3g0GS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbgsB3g0GS =+qbgB3g0GYS(i1,i3,i2,i4,i5,i6)
     .            +qbgB3g0GXS(i1,i3,i4,i2,i5,i6)
     .            +qbgB3g0GXS(i1,i4,i3,i2,i5,i6)

      return
      end

      function ggsB3g0GS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      ggsB3g0GS = ggB3g0GFS(i1,i2,i3,i4,i5,i6)
     .           +ggB3g0GFS(i1,i3,i2,i4,i5,i6)

      return
      end

      function qbqsB3g0GS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbqsB3g0GS = qqbsB3g0GS(i1,i2,i3,i4,i5,i6)

      return
      end

      function qqbsB3g0GS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qqbsB3g0GS = qqbB3g0GS(i1,i2,i3,i4,i5,i6)
     .            +qqbB3g0GS(i1,i2,i4,i3,i5,i6)
     .            +qqbB3g0GS(i1,i3,i2,i4,i5,i6)

      return
      end

*     FRAGMENTATION SUBTRACTION TERMS

      function qgsB3g0GS_frag(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qgsB3g0GS_frag = qgB3g0GS_frag(i1,i2,i3,i4,i5,i6)

      return
      end

      function qqbsB3g0GS_frag(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qqbsB3g0GS_frag = qqbsB3g0GS(i1,i2,i3,i4,i5,i6)

      return
      end

      function gqsB3g0GS_frag(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqsB3g0GS_frag = qgsB3g0GS_frag(i1,i2,i3,i4,i5,i6)

      return
      end

      function qbqsB3g0GS_frag(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbqsB3g0GS_frag = qqbsB3g0GS(i1,i2,i3,i4,i5,i6)

      return
      end

      function ggsB3g0GS_frag(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      ggsB3g0GS_frag = ggB3g0GFS_frag(i1,i2,i3,i4,i5,i6)

      return
      end

      function gqbsB3g0GS_frag(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqbsB3g0GS_frag = qbgsB3g0GS_frag(i1,i2,i3,i4,i5,i6)

      return
      end

      function qbgsB3g0GS_frag(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbgsB3g0GS_frag = qgsB3g0GS_frag(i5,i2,i3,i4,i1,i6)

      return
      end
