      function sigVGJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVGJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,4,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(4, (/ 1, 2, 3, 4 /) )
#endif 

c--- d g to d G 
      if (qactive_chan(73).and.qselect_chan(73)) then
        current_chan = 73
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(74).and.qselect_chan(74)) then
        current_chan = 74
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(75).and.qselect_chan(75)) then
        current_chan = 75
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(76).and.qselect_chan(76)) then
        current_chan = 76
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(77).and.qselect_chan(77)) then
        current_chan = 77
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(78).and.qselect_chan(78)) then
        current_chan = 78
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(79).and.qselect_chan(79)) then
        current_chan = 79
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(80).and.qselect_chan(80)) then
        current_chan = 80
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(81).and.qselect_chan(81)) then
        current_chan = 81
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(82).and.qselect_chan(82)) then
        current_chan = 82
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(83).and.qselect_chan(83)) then
        current_chan = 83
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(84).and.qselect_chan(84)) then
        current_chan = 84
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d G 
      if (qactive_chan(103).and.qselect_chan(103)) then
        current_chan = 103
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(104).and.qselect_chan(104)) then
        current_chan = 104
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(105).and.qselect_chan(105)) then
        current_chan = 105
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(106).and.qselect_chan(106)) then
        current_chan = 106
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(107).and.qselect_chan(107)) then
        current_chan = 107
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(108).and.qselect_chan(108)) then
        current_chan = 108
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(109).and.qselect_chan(109)) then
        current_chan = 109
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(110).and.qselect_chan(110)) then
        current_chan = 110
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(111).and.qselect_chan(111)) then
        current_chan = 111
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(112).and.qselect_chan(112)) then
        current_chan = 112
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(113).and.qselect_chan(113)) then
        current_chan = 113
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(114).and.qselect_chan(114)) then
        current_chan = 114
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d G 
      if (qactive_chan(133).and.qselect_chan(133)) then
        current_chan = 133
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(134).and.qselect_chan(134)) then
        current_chan = 134
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(135).and.qselect_chan(135)) then
        current_chan = 135
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(136).and.qselect_chan(136)) then
        current_chan = 136
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(137).and.qselect_chan(137)) then
        current_chan = 137
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(138).and.qselect_chan(138)) then
        current_chan = 138
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(139).and.qselect_chan(139)) then
        current_chan = 139
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(140).and.qselect_chan(140)) then
        current_chan = 140
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(141).and.qselect_chan(141)) then
        current_chan = 141
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(142).and.qselect_chan(142)) then
        current_chan = 142
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(143).and.qselect_chan(143)) then
        current_chan = 143
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(144).and.qselect_chan(144)) then
        current_chan = 144
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigVGJ=rnorm*wtsum

      return
      end
