      function sigVVGJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVVGJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,4,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

!$omp critical(VV_GJ)
#ifdef USE_OL  
      call fill_pOL(4, (/ 1, 2, 3, 4 /) )
#endif 

c--- g g to g G 
      if (qactive_chan(647).and.qselect_chan(647)) then
        current_chan = 647
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           A3g2G(1,2,3,4,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d G 
      if (qactive_chan(672).and.qselect_chan(672)) then
        current_chan = 672
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(673).and.qselect_chan(673)) then
        current_chan = 673
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(674).and.qselect_chan(674)) then
        current_chan = 674
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(675).and.qselect_chan(675)) then
        current_chan = 675
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(676).and.qselect_chan(676)) then
        current_chan = 676
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(677).and.qselect_chan(677)) then
        current_chan = 677
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(678).and.qselect_chan(678)) then
        current_chan = 678
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(679).and.qselect_chan(679)) then
        current_chan = 679
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(680).and.qselect_chan(680)) then
        current_chan = 680
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(681).and.qselect_chan(681)) then
        current_chan = 681
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(682).and.qselect_chan(682)) then
        current_chan = 682
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(683).and.qselect_chan(683)) then
        current_chan = 683
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d G 
      if (qactive_chan(706).and.qselect_chan(706)) then
        current_chan = 706
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(707).and.qselect_chan(707)) then
        current_chan = 707
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(708).and.qselect_chan(708)) then
        current_chan = 708
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(709).and.qselect_chan(709)) then
        current_chan = 709
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(710).and.qselect_chan(710)) then
        current_chan = 710
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(711).and.qselect_chan(711)) then
        current_chan = 711
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(712).and.qselect_chan(712)) then
        current_chan = 712
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(713).and.qselect_chan(713)) then
        current_chan = 713
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(714).and.qselect_chan(714)) then
        current_chan = 714
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(715).and.qselect_chan(715)) then
        current_chan = 715
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(716).and.qselect_chan(716)) then
        current_chan = 716
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(717).and.qselect_chan(717)) then
        current_chan = 717
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d G 
      if (qactive_chan(740).and.qselect_chan(740)) then
        current_chan = 740
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(741).and.qselect_chan(741)) then
        current_chan = 741
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(742).and.qselect_chan(742)) then
        current_chan = 742
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(743).and.qselect_chan(743)) then
        current_chan = 743
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(744).and.qselect_chan(744)) then
        current_chan = 744
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(745).and.qselect_chan(745)) then
        current_chan = 745
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(746).and.qselect_chan(746)) then
        current_chan = 746
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(747).and.qselect_chan(747)) then
        current_chan = 747
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(748).and.qselect_chan(748)) then
        current_chan = 748
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(749).and.qselect_chan(749)) then
        current_chan = 749
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(750).and.qselect_chan(750)) then
        current_chan = 750
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(751).and.qselect_chan(751)) then
        current_chan = 751
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d G 
      if (qactive_chan(774).and.qselect_chan(774)) then
        current_chan = 774
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(775).and.qselect_chan(775)) then
        current_chan = 775
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(776).and.qselect_chan(776)) then
        current_chan = 776
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(777).and.qselect_chan(777)) then
        current_chan = 777
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(778).and.qselect_chan(778)) then
        current_chan = 778
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(779).and.qselect_chan(779)) then
        current_chan = 779
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(780).and.qselect_chan(780)) then
        current_chan = 780
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(781).and.qselect_chan(781)) then
        current_chan = 781
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(782).and.qselect_chan(782)) then
        current_chan = 782
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(783).and.qselect_chan(783)) then
        current_chan = 783
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(784).and.qselect_chan(784)) then
        current_chan = 784
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(785).and.qselect_chan(785)) then
        current_chan = 785
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d G 
      if (qactive_chan(824).and.qselect_chan(824)) then
        current_chan = 824
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(825).and.qselect_chan(825)) then
        current_chan = 825
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(826).and.qselect_chan(826)) then
        current_chan = 826
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(827).and.qselect_chan(827)) then
        current_chan = 827
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(828).and.qselect_chan(828)) then
        current_chan = 828
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(829).and.qselect_chan(829)) then
        current_chan = 829
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(830).and.qselect_chan(830)) then
        current_chan = 830
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(831).and.qselect_chan(831)) then
        current_chan = 831
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(832).and.qselect_chan(832)) then
        current_chan = 832
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(833).and.qselect_chan(833)) then
        current_chan = 833
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(834).and.qselect_chan(834)) then
        current_chan = 834
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(835).and.qselect_chan(835)) then
        current_chan = 835
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d G 
      if (qactive_chan(874).and.qselect_chan(874)) then
        current_chan = 874
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(875).and.qselect_chan(875)) then
        current_chan = 875
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(876).and.qselect_chan(876)) then
        current_chan = 876
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(877).and.qselect_chan(877)) then
        current_chan = 877
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(878).and.qselect_chan(878)) then
        current_chan = 878
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(879).and.qselect_chan(879)) then
        current_chan = 879
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(880).and.qselect_chan(880)) then
        current_chan = 880
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(881).and.qselect_chan(881)) then
        current_chan = 881
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(882).and.qselect_chan(882)) then
        current_chan = 882
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(883).and.qselect_chan(883)) then
        current_chan = 883
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(884).and.qselect_chan(884)) then
        current_chan = 884
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(885).and.qselect_chan(885)) then
        current_chan = 885
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2G(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d G 
      if (qactive_chan(924).and.qselect_chan(924)) then
        current_chan = 924
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to u G 
      if (qactive_chan(925).and.qselect_chan(925)) then
        current_chan = 925
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g G 
      if (qactive_chan(926).and.qselect_chan(926)) then
        current_chan = 926
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g G 
      if (qactive_chan(927).and.qselect_chan(927)) then
        current_chan = 927
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,3,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(1,3,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d G 
      if (qactive_chan(928).and.qselect_chan(928)) then
        current_chan = 928
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to u G 
      if (qactive_chan(929).and.qselect_chan(929)) then
        current_chan = 929
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g G 
      if (qactive_chan(930).and.qselect_chan(930)) then
        current_chan = 930
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g G 
      if (qactive_chan(931).and.qselect_chan(931)) then
        current_chan = 931
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,3,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(2,3,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db G 
      if (qactive_chan(932).and.qselect_chan(932)) then
        current_chan = 932
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub G 
      if (qactive_chan(933).and.qselect_chan(933)) then
        current_chan = 933
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,1,2,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(3,1,2,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db G 
      if (qactive_chan(934).and.qselect_chan(934)) then
        current_chan = 934
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub G 
      if (qactive_chan(935).and.qselect_chan(935)) then
        current_chan = 935
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 3,2,1,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2G34(3,2,1,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
!$omp end critical(VV_GJ)

      sigVVGJ=rnorm*wtsum

      return
      end
