      subroutine getlumiGG(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    7,   17,   31,   45,   65,   66,   81,          
     &           91,  121,  151,  181,  209,  243,  277,  311)
!       [10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    2,    8,   18,   32,   46,   67,   68,   82,          
     &           92,  122,  152,  182,  210,  244,  278,  312)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (    3,   11,   19,   35,   49,   69,   70,   85,          
     &           95,  125,  155,  185,  211,  245,  279,  313)
!       [-10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    4,   12,   20,   36,   50,   71,   72,   86,          
     &           96,  126,  156,  186,  212,  246,  280,  314)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (    5,   25,   29,   43,   89,  119,  149,  179,          
     &          227,  261,  295,  329,  358)
!       [10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    6,   26,   30,   44,   90,  120,  150,  180,          
     &          228,  262,  296,  330,  359)
!       [20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    9,   21,   33,   47,   93,  123,  153,  183,          
     &          215,  249,  283,  317,  346)
!       [0, 10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   10,   22,   34,   48,   94,  124,  154,  184,          
     &          216,  250,  284,  318,  347)
!       [0, 20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   13,   23,   39,   53,   97,  127,  157,  187,          
     &          217,  251,  285,  319,  348)
!       [0, -10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   14,   24,   40,   54,   98,  128,  158,  188,          
     &          218,  252,  286,  320,  349)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   15,   27,   41,   55,   99,  129,  159,  189,          
     &          239,  273,  307,  341,  368)
!       [-10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   16,   28,   42,   56,  100,  130,  160,  190,          
     &          240,  274,  308,  342,  369)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   37,   38,   51,   52,  101,  102,  131,  132,          
     &          161,  162,  191,  192,  213,  214,  247,  248,          
     &          281,  282,  315,  316,  345)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   57,  107,  137,  167,  197,  223,  257,  291,          
     &          325,  354)
!       [11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   58,  108,  138,  168,  198,  224,  258,  292,          
     &          326,  355)
!       [11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   59,  109,  139,  169,  199,  225,  259,  293,          
     &          327,  356)
!       [21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   60,  110,  140,  170,  200,  226,  260,  294,          
     &          328,  357)
!       [21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   61,  103,  133,  163,  193,  219,  253,  287,          
     &          321,  350)
!       [11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   62,  104,  134,  164,  194,  220,  254,  288,          
     &          322,  351)
!       [11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   63,  105,  135,  165,  195,  221,  255,  289,          
     &          323,  352)
!       [21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   64,  106,  136,  166,  196,  222,  256,  290,          
     &          324,  353)
!       [21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   73,  115,  145,  175,  205,  235,  269,  303,          
     &          337,  364)
!       [-11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   74,  116,  146,  176,  206,  236,  270,  304,          
     &          338,  365)
!       [-11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   75,  117,  147,  177,  207,  237,  271,  305,          
     &          339,  366)
!       [-21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   76,  118,  148,  178,  208,  238,  272,  306,          
     &          340,  367)
!       [-21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   77,  111,  141,  171,  201,  231,  265,  299,          
     &          333,  360)
!       [-11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   78,  112,  142,  172,  202,  232,  266,  300,          
     &          334,  361)
!       [-11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   79,  113,  143,  173,  203,  233,  267,  301,          
     &          335,  362)
!       [-21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   80,  114,  144,  174,  204,  234,  268,  302,          
     &          336,  363)
!       [-21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   83,  229,  263,  297,  331)
!       [10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   84,  230,  264,  298,  332)
!       [20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   87,  241,  275,  309,  343)
!       [-10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   88,  242,  276,  310,  344)
!       [-20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case default
          print*, "getlumiGG: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiGG



      function getlumiidGG(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    7,   17,   31,   45,   65,   66,   81,
     &           91,  121,  151,  181,  209,  243,  277,  311)
          id  = 1
          ip1 = 10
          ip2 = -10

        case (    2,    8,   18,   32,   46,   67,   68,   82,
     &           92,  122,  152,  182,  210,  244,  278,  312)
          id  = 2
          ip1 = 20
          ip2 = -20

        case (    3,   11,   19,   35,   49,   69,   70,   85,
     &           95,  125,  155,  185,  211,  245,  279,  313)
          id  = 3
          ip1 = -10
          ip2 = 10

        case (    4,   12,   20,   36,   50,   71,   72,   86,
     &           96,  126,  156,  186,  212,  246,  280,  314)
          id  = 4
          ip1 = -20
          ip2 = 20

        case (    5,   25,   29,   43,   89,  119,  149,  179,
     &          227,  261,  295,  329,  358)
          id  = 5
          ip1 = 10
          ip2 = 0

        case (    6,   26,   30,   44,   90,  120,  150,  180,
     &          228,  262,  296,  330,  359)
          id  = 6
          ip1 = 20
          ip2 = 0

        case (    9,   21,   33,   47,   93,  123,  153,  183,
     &          215,  249,  283,  317,  346)
          id  = 7
          ip1 = 0
          ip2 = 10

        case (   10,   22,   34,   48,   94,  124,  154,  184,
     &          216,  250,  284,  318,  347)
          id  = 8
          ip1 = 0
          ip2 = 20

        case (   13,   23,   39,   53,   97,  127,  157,  187,
     &          217,  251,  285,  319,  348)
          id  = 9
          ip1 = 0
          ip2 = -10

        case (   14,   24,   40,   54,   98,  128,  158,  188,
     &          218,  252,  286,  320,  349)
          id  = 10
          ip1 = 0
          ip2 = -20

        case (   15,   27,   41,   55,   99,  129,  159,  189,
     &          239,  273,  307,  341,  368)
          id  = 11
          ip1 = -10
          ip2 = 0

        case (   16,   28,   42,   56,  100,  130,  160,  190,
     &          240,  274,  308,  342,  369)
          id  = 12
          ip1 = -20
          ip2 = 0

        case (   37,   38,   51,   52,  101,  102,  131,  132,
     &          161,  162,  191,  192,  213,  214,  247,  248,
     &          281,  282,  315,  316,  345)
          id  = 13
          ip1 = 0
          ip2 = 0

        case (   57,  107,  137,  167,  197,  223,  257,  291,
     &          325,  354)
          id  = 14
          ip1 = 11
          ip2 = -11

        case (   58,  108,  138,  168,  198,  224,  258,  292,
     &          326,  355)
          id  = 15
          ip1 = 11
          ip2 = -21

        case (   59,  109,  139,  169,  199,  225,  259,  293,
     &          327,  356)
          id  = 16
          ip1 = 21
          ip2 = -11

        case (   60,  110,  140,  170,  200,  226,  260,  294,
     &          328,  357)
          id  = 17
          ip1 = 21
          ip2 = -21

        case (   61,  103,  133,  163,  193,  219,  253,  287,
     &          321,  350)
          id  = 18
          ip1 = 11
          ip2 = 11

        case (   62,  104,  134,  164,  194,  220,  254,  288,
     &          322,  351)
          id  = 19
          ip1 = 11
          ip2 = 21

        case (   63,  105,  135,  165,  195,  221,  255,  289,
     &          323,  352)
          id  = 20
          ip1 = 21
          ip2 = 11

        case (   64,  106,  136,  166,  196,  222,  256,  290,
     &          324,  353)
          id  = 21
          ip1 = 21
          ip2 = 21

        case (   73,  115,  145,  175,  205,  235,  269,  303,
     &          337,  364)
          id  = 22
          ip1 = -11
          ip2 = -11

        case (   74,  116,  146,  176,  206,  236,  270,  304,
     &          338,  365)
          id  = 23
          ip1 = -11
          ip2 = -21

        case (   75,  117,  147,  177,  207,  237,  271,  305,
     &          339,  366)
          id  = 24
          ip1 = -21
          ip2 = -11

        case (   76,  118,  148,  178,  208,  238,  272,  306,
     &          340,  367)
          id  = 25
          ip1 = -21
          ip2 = -21

        case (   77,  111,  141,  171,  201,  231,  265,  299,
     &          333,  360)
          id  = 26
          ip1 = -11
          ip2 = 11

        case (   78,  112,  142,  172,  202,  232,  266,  300,
     &          334,  361)
          id  = 27
          ip1 = -11
          ip2 = 21

        case (   79,  113,  143,  173,  203,  233,  267,  301,
     &          335,  362)
          id  = 28
          ip1 = -21
          ip2 = 11

        case (   80,  114,  144,  174,  204,  234,  268,  302,
     &          336,  363)
          id  = 29
          ip1 = -21
          ip2 = 21

        case (   83,  229,  263,  297,  331)
          id  = 30
          ip1 = 10
          ip2 = 10

        case (   84,  230,  264,  298,  332)
          id  = 31
          ip1 = 20
          ip2 = 20

        case (   87,  241,  275,  309,  343)
          id  = 32
          ip1 = -10
          ip2 = -10

        case (   88,  242,  276,  310,  344)
          id  = 33
          ip1 = -20
          ip2 = -20

        case default
          print*, "getlumiidGG: invalid iproc:", iproc
          stop
        end select

      end function getlumiidGG





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiGG()
        use PineAPPL_mod
        use CKM_mod
!       [10, -10]
        call register_lumi_pine(
     &         [    1,    7,   17,   31,   45,   65,   66,   81,
     &             91,  121,  151,  181,  209,  243,  277,  311],
     &         3,
     &         [    1,   -1,    3,   -3,    5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [    2,    8,   18,   32,   46,   67,   68,   82,
     &             92,  122,  152,  182,  210,  244,  278,  312],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 10]
        call register_lumi_pine(
     &         [    3,   11,   19,   35,   49,   69,   70,   85,
     &             95,  125,  155,  185,  211,  245,  279,  313],
     &         3,
     &         [   -1,    1,   -3,    3,   -5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [    4,   12,   20,   36,   50,   71,   72,   86,
     &             96,  126,  156,  186,  212,  246,  280,  314],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [10, 0]
        call register_lumi_pine(
     &         [    5,   25,   29,   43,   89,  119,  149,  179,
     &            227,  261,  295,  329,  358],
     &         3,
     &         [    1,   21,    3,   21,    5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 0]
        call register_lumi_pine(
     &         [    6,   26,   30,   44,   90,  120,  150,  180,
     &            228,  262,  296,  330,  359],
     &         2,
     &         [    2,   21,    4,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 10]
        call register_lumi_pine(
     &         [    9,   21,   33,   47,   93,  123,  153,  183,
     &            215,  249,  283,  317,  346],
     &         3,
     &         [   21,    1,   21,    3,   21,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, 20]
        call register_lumi_pine(
     &         [   10,   22,   34,   48,   94,  124,  154,  184,
     &            216,  250,  284,  318,  347],
     &         2,
     &         [   21,    2,   21,    4],
     &         [  1d0,  1d0]
     &       )

!       [0, -10]
        call register_lumi_pine(
     &         [   13,   23,   39,   53,   97,  127,  157,  187,
     &            217,  251,  285,  319,  348],
     &         3,
     &         [   21,   -1,   21,   -3,   21,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [   14,   24,   40,   54,   98,  128,  158,  188,
     &            218,  252,  286,  320,  349],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 0]
        call register_lumi_pine(
     &         [   15,   27,   41,   55,   99,  129,  159,  189,
     &            239,  273,  307,  341,  368],
     &         3,
     &         [   -1,   21,   -3,   21,   -5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [   16,   28,   42,   56,  100,  130,  160,  190,
     &            240,  274,  308,  342,  369],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 0]
        call register_lumi_pine(
     &         [   37,   38,   51,   52,  101,  102,  131,  132,
     &            161,  162,  191,  192,  213,  214,  247,  248,
     &            281,  282,  315,  316,  345],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [11, -11]
        call register_lumi_pine(
     &         [   57,  107,  137,  167,  197,  223,  257,  291,
     &            325,  354],
     &         9,
     &         [    1,   -1,    1,   -3,    1,   -5,    3,   -1,
     &              3,   -3,    3,   -5,    5,   -1,    5,   -3,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, -21]
        call register_lumi_pine(
     &         [   58,  108,  138,  168,  198,  224,  258,  292,
     &            326,  355],
     &         6,
     &         [    1,   -2,    1,   -4,    3,   -2,    3,   -4,
     &              5,   -2,    5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -11]
        call register_lumi_pine(
     &         [   59,  109,  139,  169,  199,  225,  259,  293,
     &            327,  356],
     &         6,
     &         [    2,   -1,    2,   -3,    2,   -5,    4,   -1,
     &              4,   -3,    4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -21]
        call register_lumi_pine(
     &         [   60,  110,  140,  170,  200,  226,  260,  294,
     &            328,  357],
     &         4,
     &         [    2,   -2,    2,   -4,    4,   -2,    4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [11, 11]
        call register_lumi_pine(
     &         [   61,  103,  133,  163,  193,  219,  253,  287,
     &            321,  350],
     &         9,
     &         [    1,    1,    1,    3,    1,    5,    3,    1,
     &              3,    3,    3,    5,    5,    1,    5,    3,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, 21]
        call register_lumi_pine(
     &         [   62,  104,  134,  164,  194,  220,  254,  288,
     &            322,  351],
     &         6,
     &         [    1,    2,    1,    4,    3,    2,    3,    4,
     &              5,    2,    5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 11]
        call register_lumi_pine(
     &         [   63,  105,  135,  165,  195,  221,  255,  289,
     &            323,  352],
     &         6,
     &         [    2,    1,    2,    3,    2,    5,    4,    1,
     &              4,    3,    4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 21]
        call register_lumi_pine(
     &         [   64,  106,  136,  166,  196,  222,  256,  290,
     &            324,  353],
     &         4,
     &         [    2,    2,    2,    4,    4,    2,    4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, -11]
        call register_lumi_pine(
     &         [   73,  115,  145,  175,  205,  235,  269,  303,
     &            337,  364],
     &         9,
     &         [   -1,   -1,   -1,   -3,   -1,   -5,   -3,   -1,
     &             -3,   -3,   -3,   -5,   -5,   -1,   -5,   -3,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, -21]
        call register_lumi_pine(
     &         [   74,  116,  146,  176,  206,  236,  270,  304,
     &            338,  365],
     &         6,
     &         [   -1,   -2,   -1,   -4,   -3,   -2,   -3,   -4,
     &             -5,   -2,   -5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -11]
        call register_lumi_pine(
     &         [   75,  117,  147,  177,  207,  237,  271,  305,
     &            339,  366],
     &         6,
     &         [   -2,   -1,   -2,   -3,   -2,   -5,   -4,   -1,
     &             -4,   -3,   -4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -21]
        call register_lumi_pine(
     &         [   76,  118,  148,  178,  208,  238,  272,  306,
     &            340,  367],
     &         4,
     &         [   -2,   -2,   -2,   -4,   -4,   -2,   -4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, 11]
        call register_lumi_pine(
     &         [   77,  111,  141,  171,  201,  231,  265,  299,
     &            333,  360],
     &         9,
     &         [   -1,    1,   -1,    3,   -1,    5,   -3,    1,
     &             -3,    3,   -3,    5,   -5,    1,   -5,    3,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, 21]
        call register_lumi_pine(
     &         [   78,  112,  142,  172,  202,  232,  266,  300,
     &            334,  361],
     &         6,
     &         [   -1,    2,   -1,    4,   -3,    2,   -3,    4,
     &             -5,    2,   -5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 11]
        call register_lumi_pine(
     &         [   79,  113,  143,  173,  203,  233,  267,  301,
     &            335,  362],
     &         6,
     &         [   -2,    1,   -2,    3,   -2,    5,   -4,    1,
     &             -4,    3,   -4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 21]
        call register_lumi_pine(
     &         [   80,  114,  144,  174,  204,  234,  268,  302,
     &            336,  363],
     &         4,
     &         [   -2,    2,   -2,    4,   -4,    2,   -4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [10, 10]
        call register_lumi_pine(
     &         [   83,  229,  263,  297,  331],
     &         3,
     &         [    1,    1,    3,    3,    5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 20]
        call register_lumi_pine(
     &         [   84,  230,  264,  298,  332],
     &         2,
     &         [    2,    2,    4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, -10]
        call register_lumi_pine(
     &         [   87,  241,  275,  309,  343],
     &         3,
     &         [   -1,   -1,   -3,   -3,   -5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, -20]
        call register_lumi_pine(
     &         [   88,  242,  276,  310,  344],
     &         2,
     &         [   -2,   -2,   -4,   -4],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiGG


#endif


