      subroutine getqcdnormGG(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtGG(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVGG
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourGG(current_chan)
         do isub = 1, nflavourGG(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_GG(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=GG "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      ! # photons >=  2
      if ( qalpha0_hard_photons .and. (n_fs_photons_proc > 0) ) then
         ave = ave * (alpha0_param()/alpha_param())**n_fs_photons_proc
      end if
      
      facB=ave*(4d0*pi*alpha_param())**2*nc*8d0
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=1d0/2d0*facB                ! d db -> G G             B0g0GG
      case(2)
         factor=1d0/2d0*facB                ! u ub -> G G             B0g0GG
      case(3)
         factor=1d0/2d0*facB                ! db d -> G G             B0g0GG
      case(4)
         factor=1d0/2d0*facB                ! ub u -> G G             B0g0GG

c -- real

      case(5)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! d g -> d G G            B1g0GG
      case(6)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! u g -> u G G            B1g0GG
      case(7)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! d db -> g G G           B1g0GG
      case(8)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! u ub -> g G G           B1g0GG
      case(9)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! g d -> d G G            B1g0GG
      case(10)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! g u -> u G G            B1g0GG
      case(11)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! db d -> g G G           B1g0GG
      case(12)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! ub u -> g G G           B1g0GG
      case(13)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! g db -> db G G          B1g0GG
      case(14)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! g ub -> ub G G          B1g0GG
      case(15)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! db g -> db G G          B1g0GG
      case(16)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facR   ! ub g -> ub G G          B1g0GG

c -- virtual

      case(17)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facV   ! d db -> G G             B0g1GG
      case(18)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facV   ! u ub -> G G             B0g1GG
      case(19)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facV   ! db d -> G G             B0g1GG
      case(20)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facV   ! ub u -> G G             B0g1GG
      case(21)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facV   ! g d subtraction         B0g1GG
      case(22)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facV   ! g u subtraction         B0g1GG
      case(23)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facV   ! g db subtraction        B0g1GG
      case(24)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facV   ! g ub subtraction        B0g1GG
      case(25)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facV   ! d g subtraction         B0g1GG
      case(26)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facV   ! u g subtraction         B0g1GG
      case(27)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facV   ! db g subtraction        B0g1GG
      case(28)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facV   ! ub g subtraction        B0g1GG

c -- double real

      case(29)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! d g -> g d G G          B2g0GG
      case(30)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! u g -> g u G G          B2g0GG
      case(31)
         factor=(nc**2-1d0)/nc**2*1d0/4d0*facRR   ! d db -> g g G G         B2g0GG
      case(32)
         factor=(nc**2-1d0)/nc**2*1d0/4d0*facRR   ! u ub -> g g G G         B2g0GG
      case(33)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! g d -> g d G G          B2g0GG
      case(34)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! g u -> g u G G          B2g0GG
      case(35)
         factor=(nc**2-1d0)/nc**2*1d0/4d0*facRR   ! db d -> g g G G         B2g0GG
      case(36)
         factor=(nc**2-1d0)/nc**2*1d0/4d0*facRR   ! ub u -> g g G G         B2g0GG
      case(37)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*ndown*facRR   ! g g -> db d G G         B2g0GG
      case(38)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*nup*facRR   ! g g -> ub u G G         B2g0GG
      case(39)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! g db -> db g G G        B2g0GG
      case(40)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! g ub -> ub g G G        B2g0GG
      case(41)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! db g -> db g G G        B2g0GG
      case(42)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! ub g -> ub g G G        B2g0GG
      case(43)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d gt -> gt d G G        Bt2g0GG
      case(44)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u gt -> gt u G G        Bt2g0GG
      case(45)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*facRR   ! d db -> gt gt G G       Bt2g0GG
      case(46)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*facRR   ! u ub -> gt gt G G       Bt2g0GG
      case(47)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! gt d -> gt d G G        Bt2g0GG
      case(48)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! gt u -> gt u G G        Bt2g0GG
      case(49)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*facRR   ! db d -> gt gt G G       Bt2g0GG
      case(50)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*facRR   ! ub u -> gt gt G G       Bt2g0GG
      case(51)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*ndown*facRR   ! gt gt -> db d G G       Bt2g0GG
      case(52)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*nup*facRR   ! gt gt -> ub u G G       Bt2g0GG
      case(53)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! gt db -> db gt G G      Bt2g0GG
      case(54)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! gt ub -> ub gt G G      Bt2g0GG
      case(55)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db gt -> db gt G G      Bt2g0GG
      case(56)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub gt -> ub gt G G      Bt2g0GG
      case(57)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! d db -> db d G G        C0g0GG
      case(58)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! d ub -> ub d G G        C0g0GG
      case(59)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! u db -> db u G G        C0g0GG
      case(60)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! u ub -> ub u G G        C0g0GG
      case(61)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! d d -> d d G G          C0g0GG
      case(62)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! d u -> u d G G          C0g0GG
      case(63)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! u d -> d u G G          C0g0GG
      case(64)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! u u -> u u G G          C0g0GG
      case(65)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*ndown*facRR   ! d db -> d db G G        C0g0GG
      case(66)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*nup*facRR   ! d db -> u ub G G        C0g0GG
      case(67)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*ndown*facRR   ! u ub -> d db G G        C0g0GG
      case(68)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*nup*facRR   ! u ub -> u ub G G        C0g0GG
      case(69)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*ndown*facRR   ! db d -> d db G G        C0g0GG
      case(70)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*nup*facRR   ! db d -> u ub G G        C0g0GG
      case(71)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*ndown*facRR   ! ub u -> d db G G        C0g0GG
      case(72)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*nup*facRR   ! ub u -> u ub G G        C0g0GG
      case(73)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! db db -> db db G G      C0g0GG
      case(74)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! db ub -> db ub G G      C0g0GG
      case(75)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! ub db -> ub db G G      C0g0GG
      case(76)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! ub ub -> ub ub G G      C0g0GG
      case(77)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! db d -> db d G G        C0g0GG
      case(78)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! db u -> db u G G        C0g0GG
      case(79)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! ub d -> ub d G G        C0g0GG
      case(80)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRR   ! ub u -> ub u G G        C0g0GG
      case(81)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d db -> db d G G        D0g0GG
      case(82)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u ub -> ub u G G        D0g0GG
      case(83)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*facRR   ! d d -> d d G G          D0g0GG
      case(84)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*facRR   ! u u -> u u G G          D0g0GG
      case(85)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db d -> db d G G        D0g0GG
      case(86)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub u -> ub u G G        D0g0GG
      case(87)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*facRR   ! db db -> db db G G      D0g0GG
      case(88)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*facRR   ! ub ub -> ub ub G G      D0g0GG

c -- real virtual

      case(89)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! d g -> d G G            B1g1GG
      case(90)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! u g -> u G G            B1g1GG
      case(91)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! d db -> g G G           B1g1GG
      case(92)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! u ub -> g G G           B1g1GG
      case(93)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! g d -> d G G            B1g1GG
      case(94)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! g u -> u G G            B1g1GG
      case(95)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! db d -> g G G           B1g1GG
      case(96)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! ub u -> g G G           B1g1GG
      case(97)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! g db -> db G G          B1g1GG
      case(98)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! g ub -> ub G G          B1g1GG
      case(99)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! db g -> db G G          B1g1GG
      case(100)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRV   ! ub g -> ub G G          B1g1GG
      case(101)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*ndown*facRV   ! g g subtraction         B1g1GG
      case(102)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*nup*facRV   ! g g subtraction         B1g1GG
      case(103)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! d d subtraction         B1g1GG
      case(104)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! d u subtraction         B1g1GG
      case(105)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! u d subtraction         B1g1GG
      case(106)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! u u subtraction         B1g1GG
      case(107)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! d db subtraction        B1g1GG
      case(108)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! d ub subtraction        B1g1GG
      case(109)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! u db subtraction        B1g1GG
      case(110)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! u ub subtraction        B1g1GG
      case(111)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! db d subtraction        B1g1GG
      case(112)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! db u subtraction        B1g1GG
      case(113)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! ub d subtraction        B1g1GG
      case(114)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! ub u subtraction        B1g1GG
      case(115)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! db db subtraction       B1g1GG
      case(116)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! db ub subtraction       B1g1GG
      case(117)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! ub db subtraction       B1g1GG
      case(118)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facRV   ! ub ub subtraction       B1g1GG
      case(119)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! d g -> d G G            Bt1g1GG
      case(120)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! u g -> u G G            Bt1g1GG
      case(121)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! d db -> g G G           Bt1g1GG
      case(122)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! u ub -> g G G           Bt1g1GG
      case(123)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! g d -> d G G            Bt1g1GG
      case(124)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! g u -> u G G            Bt1g1GG
      case(125)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! db d -> g G G           Bt1g1GG
      case(126)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! ub u -> g G G           Bt1g1GG
      case(127)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! g db -> db G G          Bt1g1GG
      case(128)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! g ub -> ub G G          Bt1g1GG
      case(129)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! db g -> db G G          Bt1g1GG
      case(130)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRV   ! ub g -> ub G G          Bt1g1GG
      case(131)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*ndown*facRV   ! g g subtraction         Bt1g1GG
      case(132)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*nup*facRV   ! g g subtraction         Bt1g1GG
      case(133)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! d d subtraction         Bt1g1GG
      case(134)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! d u subtraction         Bt1g1GG
      case(135)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! u d subtraction         Bt1g1GG
      case(136)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! u u subtraction         Bt1g1GG
      case(137)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! d db subtraction        Bt1g1GG
      case(138)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! d ub subtraction        Bt1g1GG
      case(139)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! u db subtraction        Bt1g1GG
      case(140)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! u ub subtraction        Bt1g1GG
      case(141)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! db d subtraction        Bt1g1GG
      case(142)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! db u subtraction        Bt1g1GG
      case(143)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! ub d subtraction        Bt1g1GG
      case(144)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! ub u subtraction        Bt1g1GG
      case(145)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! db db subtraction       Bt1g1GG
      case(146)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! db ub subtraction       Bt1g1GG
      case(147)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! ub db subtraction       Bt1g1GG
      case(148)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facRV   ! ub ub subtraction       Bt1g1GG
      case(149)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! d g -> d G G            Bh1g1GG
      case(150)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! u g -> u G G            Bh1g1GG
      case(151)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! d db -> g G G           Bh1g1GG
      case(152)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! u ub -> g G G           Bh1g1GG
      case(153)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! g d -> d G G            Bh1g1GG
      case(154)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! g u -> u G G            Bh1g1GG
      case(155)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! db d -> g G G           Bh1g1GG
      case(156)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! ub u -> g G G           Bh1g1GG
      case(157)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! g db -> db G G          Bh1g1GG
      case(158)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! g ub -> ub G G          Bh1g1GG
      case(159)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! db g -> db G G          Bh1g1GG
      case(160)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facRV   ! ub g -> ub G G          Bh1g1GG
      case(161)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*ndown*nf*facRV   ! g g subtraction         Bh1g1GG
      case(162)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*nup*facRV   ! g g subtraction         Bh1g1GG
      case(163)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! d d subtraction         Bh1g1GG
      case(164)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! d u subtraction         Bh1g1GG
      case(165)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! u d subtraction         Bh1g1GG
      case(166)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! u u subtraction         Bh1g1GG
      case(167)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! d db subtraction        Bh1g1GG
      case(168)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! d ub subtraction        Bh1g1GG
      case(169)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! u db subtraction        Bh1g1GG
      case(170)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! u ub subtraction        Bh1g1GG
      case(171)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! db d subtraction        Bh1g1GG
      case(172)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! db u subtraction        Bh1g1GG
      case(173)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! ub d subtraction        Bh1g1GG
      case(174)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! ub u subtraction        Bh1g1GG
      case(175)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! db db subtraction       Bh1g1GG
      case(176)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! db ub subtraction       Bh1g1GG
      case(177)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! ub db subtraction       Bh1g1GG
      case(178)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facRV   ! ub ub subtraction       Bh1g1GG
      case(179)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! d g -> d G G            Bv1g1GG
      case(180)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! u g -> u G G            Bv1g1GG
      case(181)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! d db -> g G G           Bv1g1GG
      case(182)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! u ub -> g G G           Bv1g1GG
      case(183)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! g d -> d G G            Bv1g1GG
      case(184)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! g u -> u G G            Bv1g1GG
      case(185)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! db d -> g G G           Bv1g1GG
      case(186)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! ub u -> g G G           Bv1g1GG
      case(187)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! g db -> db G G          Bv1g1GG
      case(188)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! g ub -> ub G G          Bv1g1GG
      case(189)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! db g -> db G G          Bv1g1GG
      case(190)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facRV   ! ub g -> ub G G          Bv1g1GG
      case(191)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*ndown*facRV   ! g g subtraction         Bv1g1GG
      case(192)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nup*facRV   ! g g subtraction         Bv1g1GG
      case(193)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! d d subtraction         Bv1g1GG
      case(194)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! d u subtraction         Bv1g1GG
      case(195)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! u d subtraction         Bv1g1GG
      case(196)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! u u subtraction         Bv1g1GG
      case(197)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! d db subtraction        Bv1g1GG
      case(198)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! d ub subtraction        Bv1g1GG
      case(199)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! u db subtraction        Bv1g1GG
      case(200)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! u ub subtraction        Bv1g1GG
      case(201)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! db d subtraction        Bv1g1GG
      case(202)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! db u subtraction        Bv1g1GG
      case(203)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! ub d subtraction        Bv1g1GG
      case(204)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! ub u subtraction        Bv1g1GG
      case(205)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! db db subtraction       Bv1g1GG
      case(206)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! db ub subtraction       Bv1g1GG
      case(207)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! ub db subtraction       Bv1g1GG
      case(208)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facRV   ! ub ub subtraction       Bv1g1GG

c -- double virtual

      case(209)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facVV   ! d db -> G G             B0g2GG
      case(210)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facVV   ! u ub -> G G             B0g2GG
      case(211)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facVV   ! db d -> G G             B0g2GG
      case(212)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facVV   ! ub u -> G G             B0g2GG
      case(213)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*ndown*facVV   ! g g subtraction         B0g2GG
      case(214)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*nup*facVV   ! g g subtraction         B0g2GG
      case(215)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facVV   ! g d subtraction         B0g2GG
      case(216)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facVV   ! g u subtraction         B0g2GG
      case(217)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facVV   ! g db subtraction        B0g2GG
      case(218)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facVV   ! g ub subtraction        B0g2GG
      case(219)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! d d subtraction         B0g2GG
      case(220)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! d u subtraction         B0g2GG
      case(221)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! u d subtraction         B0g2GG
      case(222)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! u u subtraction         B0g2GG
      case(223)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! d db subtraction        B0g2GG
      case(224)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! d ub subtraction        B0g2GG
      case(225)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! u db subtraction        B0g2GG
      case(226)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! u ub subtraction        B0g2GG
      case(227)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facVV   ! d g subtraction         B0g2GG
      case(228)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facVV   ! u g subtraction         B0g2GG
      case(229)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! d d subtraction         B0g2GG
      case(230)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! u u subtraction         B0g2GG
      case(231)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! db d subtraction        B0g2GG
      case(232)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! db u subtraction        B0g2GG
      case(233)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! ub d subtraction        B0g2GG
      case(234)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! ub u subtraction        B0g2GG
      case(235)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! db db subtraction       B0g2GG
      case(236)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! db ub subtraction       B0g2GG
      case(237)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! ub db subtraction       B0g2GG
      case(238)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! ub ub subtraction       B0g2GG
      case(239)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facVV   ! db g subtraction        B0g2GG
      case(240)
         factor=1d0/2d0*(nc**2-1d0)/nc**2*facVV   ! ub g subtraction        B0g2GG
      case(241)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! db db subtraction       B0g2GG
      case(242)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! ub ub subtraction       B0g2GG
      case(243)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facVV   ! d db -> G G             Bt0g2GG
      case(244)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facVV   ! u ub -> G G             Bt0g2GG
      case(245)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facVV   ! db d -> G G             Bt0g2GG
      case(246)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facVV   ! ub u -> G G             Bt0g2GG
      case(247)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*ndown*facVV   ! g g subtraction         Bt0g2GG
      case(248)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*nup*facVV   ! g g subtraction         Bt0g2GG
      case(249)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! g d subtraction         Bt0g2GG
      case(250)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! g u subtraction         Bt0g2GG
      case(251)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! g db subtraction        Bt0g2GG
      case(252)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! g ub subtraction        Bt0g2GG
      case(253)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! d d subtraction         Bt0g2GG
      case(254)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! d u subtraction         Bt0g2GG
      case(255)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! u d subtraction         Bt0g2GG
      case(256)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! u u subtraction         Bt0g2GG
      case(257)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! d db subtraction        Bt0g2GG
      case(258)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! d ub subtraction        Bt0g2GG
      case(259)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! u db subtraction        Bt0g2GG
      case(260)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! u ub subtraction        Bt0g2GG
      case(261)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! d g subtraction         Bt0g2GG
      case(262)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! u g subtraction         Bt0g2GG
      case(263)
         factor=-1d0/2d0*(nc**2-1d0)/nc**6*facVV   ! d d subtraction         Bt0g2GG
      case(264)
         factor=-1d0/2d0*(nc**2-1d0)/nc**6*facVV   ! u u subtraction         Bt0g2GG
      case(265)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! db d subtraction        Bt0g2GG
      case(266)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! db u subtraction        Bt0g2GG
      case(267)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! ub d subtraction        Bt0g2GG
      case(268)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! ub u subtraction        Bt0g2GG
      case(269)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! db db subtraction       Bt0g2GG
      case(270)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! db ub subtraction       Bt0g2GG
      case(271)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! ub db subtraction       Bt0g2GG
      case(272)
         factor=-1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! ub ub subtraction       Bt0g2GG
      case(273)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! db g subtraction        Bt0g2GG
      case(274)
         factor=-1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! ub g subtraction        Bt0g2GG
      case(275)
         factor=-1d0/2d0*(nc**2-1d0)/nc**6*facVV   ! db db subtraction       Bt0g2GG
      case(276)
         factor=-1d0/2d0*(nc**2-1d0)/nc**6*facVV   ! ub ub subtraction       Bt0g2GG
      case(277)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facVV   ! d db -> G G             Bh0g2GG
      case(278)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facVV   ! u ub -> G G             Bh0g2GG
      case(279)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facVV   ! db d -> G G             Bh0g2GG
      case(280)
         factor=(nc**2-1d0)/nc**3*nf*1d0/2d0*facVV   ! ub u -> G G             Bh0g2GG
      case(281)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*ndown*nf*facVV   ! g g subtraction         Bh0g2GG
      case(282)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*nup*facVV   ! g g subtraction         Bh0g2GG
      case(283)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*facVV   ! g d subtraction         Bh0g2GG
      case(284)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*facVV   ! g u subtraction         Bh0g2GG
      case(285)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*facVV   ! g db subtraction        Bh0g2GG
      case(286)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*facVV   ! g ub subtraction        Bh0g2GG
      case(287)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! d d subtraction         Bh0g2GG
      case(288)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! d u subtraction         Bh0g2GG
      case(289)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! u d subtraction         Bh0g2GG
      case(290)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! u u subtraction         Bh0g2GG
      case(291)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! d db subtraction        Bh0g2GG
      case(292)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! d ub subtraction        Bh0g2GG
      case(293)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! u db subtraction        Bh0g2GG
      case(294)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! u ub subtraction        Bh0g2GG
      case(295)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*facVV   ! d g subtraction         Bh0g2GG
      case(296)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*facVV   ! u g subtraction         Bh0g2GG
      case(297)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*nf*facVV   ! d d subtraction         Bh0g2GG
      case(298)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*nf*facVV   ! u u subtraction         Bh0g2GG
      case(299)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! db d subtraction        Bh0g2GG
      case(300)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! db u subtraction        Bh0g2GG
      case(301)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! ub d subtraction        Bh0g2GG
      case(302)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! ub u subtraction        Bh0g2GG
      case(303)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! db db subtraction       Bh0g2GG
      case(304)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! db ub subtraction       Bh0g2GG
      case(305)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! ub db subtraction       Bh0g2GG
      case(306)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*nf*facVV   ! ub ub subtraction       Bh0g2GG
      case(307)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*facVV   ! db g subtraction        Bh0g2GG
      case(308)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nf*facVV   ! ub g subtraction        Bh0g2GG
      case(309)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*nf*facVV   ! db db subtraction       Bh0g2GG
      case(310)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*nf*facVV   ! ub ub subtraction       Bh0g2GG
      case(311)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facVV   ! d db -> G G             Bh0g2GG34
      case(312)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facVV   ! u ub -> G G             Bh0g2GG34
      case(313)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facVV   ! db d -> G G             Bh0g2GG34
      case(314)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facVV   ! ub u -> G G             Bh0g2GG34
      case(315)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*ndown*facVV   ! g g subtraction         Bh0g2GG34
      case(316)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*nup*facVV   ! g g subtraction         Bh0g2GG34
      case(317)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! g d subtraction         Bh0g2GG34
      case(318)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! g u subtraction         Bh0g2GG34
      case(319)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! g db subtraction        Bh0g2GG34
      case(320)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! g ub subtraction        Bh0g2GG34
      case(321)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! d d subtraction         Bh0g2GG34
      case(322)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! d u subtraction         Bh0g2GG34
      case(323)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! u d subtraction         Bh0g2GG34
      case(324)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! u u subtraction         Bh0g2GG34
      case(325)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! d db subtraction        Bh0g2GG34
      case(326)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! d ub subtraction        Bh0g2GG34
      case(327)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! u db subtraction        Bh0g2GG34
      case(328)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! u ub subtraction        Bh0g2GG34
      case(329)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! d g subtraction         Bh0g2GG34
      case(330)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! u g subtraction         Bh0g2GG34
      case(331)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! d d subtraction         Bh0g2GG34
      case(332)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! u u subtraction         Bh0g2GG34
      case(333)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! db d subtraction        Bh0g2GG34
      case(334)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! db u subtraction        Bh0g2GG34
      case(335)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! ub d subtraction        Bh0g2GG34
      case(336)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! ub u subtraction        Bh0g2GG34
      case(337)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! db db subtraction       Bh0g2GG34
      case(338)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! db ub subtraction       Bh0g2GG34
      case(339)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! ub db subtraction       Bh0g2GG34
      case(340)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! ub ub subtraction       Bh0g2GG34
      case(341)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! db g subtraction        Bh0g2GG34
      case(342)
         factor=1d0/2d0*(nc**2-1d0)/nc**3*facVV   ! ub g subtraction        Bh0g2GG34
      case(343)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! db db subtraction       Bh0g2GG34
      case(344)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! ub ub subtraction       Bh0g2GG34
      case(345)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*facVV   ! g g -> G G              B2g1GG
      case(346)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! g d subtraction         B2g1GG
      case(347)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! g u subtraction         B2g1GG
      case(348)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! g db subtraction        B2g1GG
      case(349)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! g ub subtraction        B2g1GG
      case(350)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! d d subtraction         B2g1GG
      case(351)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! d u subtraction         B2g1GG
      case(352)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! u d subtraction         B2g1GG
      case(353)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! u u subtraction         B2g1GG
      case(354)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! d db subtraction        B2g1GG
      case(355)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! d ub subtraction        B2g1GG
      case(356)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! u db subtraction        B2g1GG
      case(357)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! u ub subtraction        B2g1GG
      case(358)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! d g subtraction         B2g1GG
      case(359)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! u g subtraction         B2g1GG
      case(360)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! db d subtraction        B2g1GG
      case(361)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! db u subtraction        B2g1GG
      case(362)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! ub d subtraction        B2g1GG
      case(363)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! ub u subtraction        B2g1GG
      case(364)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! db db subtraction       B2g1GG
      case(365)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! db ub subtraction       B2g1GG
      case(366)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! ub db subtraction       B2g1GG
      case(367)
         factor=1d0/2d0*(nc**2-1d0)/nc**5*facVV   ! ub ub subtraction       B2g1GG
      case(368)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! db g subtraction        B2g1GG
      case(369)
         factor=1d0/2d0*(nc**2-1d0)/nc**4*facVV   ! ub g subtraction        B2g1GG
      end select
      factor=relfactor*factor

      return
      end
