      subroutine getlumiGJJ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,   15,   61,   75,   89,  103,  104,  143,          
     &          144,  183,  199,  215,  245,  275,  289,  303,          
     &          333,  347,  409,  410,  449,  450,  489,  490,          
     &          509,  525,  541)
!       [10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,   16,   62,   76,   90,  105,  106,  145,          
     &          146,  184,  200,  216,  246,  276,  290,  304,          
     &          334,  348,  411,  412,  451,  452,  491,  492,          
     &          510,  526,  542)
!       [20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    3,   17,   37,   38,   53,   63,   77,   91,          
     &          115,  116,  155,  156,  185,  201,  217,  247,          
     &          277,  291,  305,  335,  349,  385,  386,  425,          
     &          426,  465,  466,  497,  513,  529)
!       [10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    4,   18,   39,   40,   54,   64,   78,   92,          
     &          117,  118,  157,  158,  186,  202,  218,  248,          
     &          278,  292,  306,  336,  350,  387,  388,  427,          
     &          428,  467,  468,  498,  514,  530)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (    5,   19,   65,   79,   93,  119,  120,  159,          
     &          160,  189,  205,  219,  249,  279,  293,  307,          
     &          337,  351,  401,  402,  441,  442,  481,  482,          
     &          505,  521,  537)
!       [0, 10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (    6,   20,   66,   80,   94,  121,  122,  161,          
     &          162,  190,  206,  220,  250,  280,  294,  308,          
     &          338,  352,  403,  404,  443,  444,  483,  484,          
     &          506,  522,  538)
!       [0, 20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (    7,   21,   41,   42,   57,   67,   81,   95,          
     &          123,  124,  163,  164,  191,  207,  221,  251,          
     &          281,  295,  309,  339,  353,  389,  390,  429,          
     &          430,  469,  470,  501,  517,  533)
!       [-10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    8,   22,   43,   44,   58,   68,   82,   96,          
     &          125,  126,  165,  166,  192,  208,  222,  252,          
     &          282,  296,  310,  340,  354,  391,  392,  431,          
     &          432,  471,  472,  502,  518,  534)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (    9,   10,   23,   24,   69,   70,   83,   84,          
     &           97,   98,  223,  224,  253,  254,  283,  284,          
     &          297,  298,  311,  312,  341,  342,  355,  356)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   11,   25,   71,   85,   99,  127,  128,  167,          
     &          168,  193,  209,  225,  255,  285,  299,  313,          
     &          343,  357,  405,  406,  445,  446,  485,  486,          
     &          507,  523,  539)
!       [0, -10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   12,   26,   72,   86,  100,  129,  130,  169,          
     &          170,  194,  210,  226,  256,  286,  300,  314,          
     &          344,  358,  407,  408,  447,  448,  487,  488,          
     &          508,  524,  540)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   13,   27,   73,   87,  101,  131,  132,  171,          
     &          172,  195,  211,  227,  257,  287,  301,  315,          
     &          345,  359,  413,  414,  453,  454,  493,  494,          
     &          511,  527,  543)
!       [-10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   14,   28,   74,   88,  102,  133,  134,  173,          
     &          174,  196,  212,  228,  258,  288,  302,  316,          
     &          346,  360,  415,  416,  455,  456,  495,  496,          
     &          512,  528,  544)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   29,  107,  147,  233,  263,  321,  365,  377,          
     &          417,  457)
!       [11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   30,  108,  148,  234,  264,  322,  366,  378,          
     &          418,  458)
!       [11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   31,  109,  149,  235,  265,  323,  367,  379,          
     &          419,  459)
!       [21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   32,  110,  150,  236,  266,  324,  368,  380,          
     &          420,  460)
!       [21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   33,  111,  151,  229,  259,  317,  361,  381,          
     &          421,  461)
!       [11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   34,  112,  152,  230,  260,  318,  362,  382,          
     &          422,  462)
!       [11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   35,  113,  153,  231,  261,  319,  363,  383,          
     &          423,  463)
!       [21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   36,  114,  154,  232,  262,  320,  364,  384,          
     &          424,  464)
!       [21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   45,  135,  175,  241,  271,  329,  373,  393,          
     &          433,  473)
!       [-11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   46,  136,  176,  242,  272,  330,  374,  394,          
     &          434,  474)
!       [-11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   47,  137,  177,  243,  273,  331,  375,  395,          
     &          435,  475)
!       [-21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   48,  138,  178,  244,  274,  332,  376,  396,          
     &          436,  476)
!       [-21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   49,  139,  179,  237,  267,  325,  369,  397,          
     &          437,  477)
!       [-11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   50,  140,  180,  238,  268,  326,  370,  398,          
     &          438,  478)
!       [-11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   51,  141,  181,  239,  269,  327,  371,  399,          
     &          439,  479)
!       [-21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   52,  142,  182,  240,  270,  328,  372,  400,          
     &          440,  480)
!       [-21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   55,  187,  203,  499,  515,  531)
!       [10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   56,  188,  204,  500,  516,  532)
!       [20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   59,  197,  213,  503,  519,  535)
!       [-10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   60,  198,  214,  504,  520,  536)
!       [-20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case default
          print*, "getlumiGJJ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiGJJ



      function getlumiidGJJ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,   15,   61,   75,   89,  103,  104,  143,
     &          144,  183,  199,  215,  245,  275,  289,  303,
     &          333,  347,  409,  410,  449,  450,  489,  490,
     &          509,  525,  541)
          id  = 1
          ip1 = 10
          ip2 = 0

        case (    2,   16,   62,   76,   90,  105,  106,  145,
     &          146,  184,  200,  216,  246,  276,  290,  304,
     &          334,  348,  411,  412,  451,  452,  491,  492,
     &          510,  526,  542)
          id  = 2
          ip1 = 20
          ip2 = 0

        case (    3,   17,   37,   38,   53,   63,   77,   91,
     &          115,  116,  155,  156,  185,  201,  217,  247,
     &          277,  291,  305,  335,  349,  385,  386,  425,
     &          426,  465,  466,  497,  513,  529)
          id  = 3
          ip1 = 10
          ip2 = -10

        case (    4,   18,   39,   40,   54,   64,   78,   92,
     &          117,  118,  157,  158,  186,  202,  218,  248,
     &          278,  292,  306,  336,  350,  387,  388,  427,
     &          428,  467,  468,  498,  514,  530)
          id  = 4
          ip1 = 20
          ip2 = -20

        case (    5,   19,   65,   79,   93,  119,  120,  159,
     &          160,  189,  205,  219,  249,  279,  293,  307,
     &          337,  351,  401,  402,  441,  442,  481,  482,
     &          505,  521,  537)
          id  = 5
          ip1 = 0
          ip2 = 10

        case (    6,   20,   66,   80,   94,  121,  122,  161,
     &          162,  190,  206,  220,  250,  280,  294,  308,
     &          338,  352,  403,  404,  443,  444,  483,  484,
     &          506,  522,  538)
          id  = 6
          ip1 = 0
          ip2 = 20

        case (    7,   21,   41,   42,   57,   67,   81,   95,
     &          123,  124,  163,  164,  191,  207,  221,  251,
     &          281,  295,  309,  339,  353,  389,  390,  429,
     &          430,  469,  470,  501,  517,  533)
          id  = 7
          ip1 = -10
          ip2 = 10

        case (    8,   22,   43,   44,   58,   68,   82,   96,
     &          125,  126,  165,  166,  192,  208,  222,  252,
     &          282,  296,  310,  340,  354,  391,  392,  431,
     &          432,  471,  472,  502,  518,  534)
          id  = 8
          ip1 = -20
          ip2 = 20

        case (    9,   10,   23,   24,   69,   70,   83,   84,
     &           97,   98,  223,  224,  253,  254,  283,  284,
     &          297,  298,  311,  312,  341,  342,  355,  356)
          id  = 9
          ip1 = 0
          ip2 = 0

        case (   11,   25,   71,   85,   99,  127,  128,  167,
     &          168,  193,  209,  225,  255,  285,  299,  313,
     &          343,  357,  405,  406,  445,  446,  485,  486,
     &          507,  523,  539)
          id  = 10
          ip1 = 0
          ip2 = -10

        case (   12,   26,   72,   86,  100,  129,  130,  169,
     &          170,  194,  210,  226,  256,  286,  300,  314,
     &          344,  358,  407,  408,  447,  448,  487,  488,
     &          508,  524,  540)
          id  = 11
          ip1 = 0
          ip2 = -20

        case (   13,   27,   73,   87,  101,  131,  132,  171,
     &          172,  195,  211,  227,  257,  287,  301,  315,
     &          345,  359,  413,  414,  453,  454,  493,  494,
     &          511,  527,  543)
          id  = 12
          ip1 = -10
          ip2 = 0

        case (   14,   28,   74,   88,  102,  133,  134,  173,
     &          174,  196,  212,  228,  258,  288,  302,  316,
     &          346,  360,  415,  416,  455,  456,  495,  496,
     &          512,  528,  544)
          id  = 13
          ip1 = -20
          ip2 = 0

        case (   29,  107,  147,  233,  263,  321,  365,  377,
     &          417,  457)
          id  = 14
          ip1 = 11
          ip2 = -11

        case (   30,  108,  148,  234,  264,  322,  366,  378,
     &          418,  458)
          id  = 15
          ip1 = 11
          ip2 = -21

        case (   31,  109,  149,  235,  265,  323,  367,  379,
     &          419,  459)
          id  = 16
          ip1 = 21
          ip2 = -11

        case (   32,  110,  150,  236,  266,  324,  368,  380,
     &          420,  460)
          id  = 17
          ip1 = 21
          ip2 = -21

        case (   33,  111,  151,  229,  259,  317,  361,  381,
     &          421,  461)
          id  = 18
          ip1 = 11
          ip2 = 11

        case (   34,  112,  152,  230,  260,  318,  362,  382,
     &          422,  462)
          id  = 19
          ip1 = 11
          ip2 = 21

        case (   35,  113,  153,  231,  261,  319,  363,  383,
     &          423,  463)
          id  = 20
          ip1 = 21
          ip2 = 11

        case (   36,  114,  154,  232,  262,  320,  364,  384,
     &          424,  464)
          id  = 21
          ip1 = 21
          ip2 = 21

        case (   45,  135,  175,  241,  271,  329,  373,  393,
     &          433,  473)
          id  = 22
          ip1 = -11
          ip2 = -11

        case (   46,  136,  176,  242,  272,  330,  374,  394,
     &          434,  474)
          id  = 23
          ip1 = -11
          ip2 = -21

        case (   47,  137,  177,  243,  273,  331,  375,  395,
     &          435,  475)
          id  = 24
          ip1 = -21
          ip2 = -11

        case (   48,  138,  178,  244,  274,  332,  376,  396,
     &          436,  476)
          id  = 25
          ip1 = -21
          ip2 = -21

        case (   49,  139,  179,  237,  267,  325,  369,  397,
     &          437,  477)
          id  = 26
          ip1 = -11
          ip2 = 11

        case (   50,  140,  180,  238,  268,  326,  370,  398,
     &          438,  478)
          id  = 27
          ip1 = -11
          ip2 = 21

        case (   51,  141,  181,  239,  269,  327,  371,  399,
     &          439,  479)
          id  = 28
          ip1 = -21
          ip2 = 11

        case (   52,  142,  182,  240,  270,  328,  372,  400,
     &          440,  480)
          id  = 29
          ip1 = -21
          ip2 = 21

        case (   55,  187,  203,  499,  515,  531)
          id  = 30
          ip1 = 10
          ip2 = 10

        case (   56,  188,  204,  500,  516,  532)
          id  = 31
          ip1 = 20
          ip2 = 20

        case (   59,  197,  213,  503,  519,  535)
          id  = 32
          ip1 = -10
          ip2 = -10

        case (   60,  198,  214,  504,  520,  536)
          id  = 33
          ip1 = -20
          ip2 = -20

        case default
          print*, "getlumiidGJJ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidGJJ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiGJJ()
        use PineAPPL_mod
        use CKM_mod
!       [10, 0]
        call register_lumi_pine(
     &         [    1,   15,   61,   75,   89,  103,  104,  143,
     &            144,  183,  199,  215,  245,  275,  289,  303,
     &            333,  347,  409,  410,  449,  450,  489,  490,
     &            509,  525,  541],
     &         3,
     &         [    1,   21,    3,   21,    5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 0]
        call register_lumi_pine(
     &         [    2,   16,   62,   76,   90,  105,  106,  145,
     &            146,  184,  200,  216,  246,  276,  290,  304,
     &            334,  348,  411,  412,  451,  452,  491,  492,
     &            510,  526,  542],
     &         2,
     &         [    2,   21,    4,   21],
     &         [  1d0,  1d0]
     &       )

!       [10, -10]
        call register_lumi_pine(
     &         [    3,   17,   37,   38,   53,   63,   77,   91,
     &            115,  116,  155,  156,  185,  201,  217,  247,
     &            277,  291,  305,  335,  349,  385,  386,  425,
     &            426,  465,  466,  497,  513,  529],
     &         3,
     &         [    1,   -1,    3,   -3,    5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [    4,   18,   39,   40,   54,   64,   78,   92,
     &            117,  118,  157,  158,  186,  202,  218,  248,
     &            278,  292,  306,  336,  350,  387,  388,  427,
     &            428,  467,  468,  498,  514,  530],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [0, 10]
        call register_lumi_pine(
     &         [    5,   19,   65,   79,   93,  119,  120,  159,
     &            160,  189,  205,  219,  249,  279,  293,  307,
     &            337,  351,  401,  402,  441,  442,  481,  482,
     &            505,  521,  537],
     &         3,
     &         [   21,    1,   21,    3,   21,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, 20]
        call register_lumi_pine(
     &         [    6,   20,   66,   80,   94,  121,  122,  161,
     &            162,  190,  206,  220,  250,  280,  294,  308,
     &            338,  352,  403,  404,  443,  444,  483,  484,
     &            506,  522,  538],
     &         2,
     &         [   21,    2,   21,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 10]
        call register_lumi_pine(
     &         [    7,   21,   41,   42,   57,   67,   81,   95,
     &            123,  124,  163,  164,  191,  207,  221,  251,
     &            281,  295,  309,  339,  353,  389,  390,  429,
     &            430,  469,  470,  501,  517,  533],
     &         3,
     &         [   -1,    1,   -3,    3,   -5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [    8,   22,   43,   44,   58,   68,   82,   96,
     &            125,  126,  165,  166,  192,  208,  222,  252,
     &            282,  296,  310,  340,  354,  391,  392,  431,
     &            432,  471,  472,  502,  518,  534],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [0, 0]
        call register_lumi_pine(
     &         [    9,   10,   23,   24,   69,   70,   83,   84,
     &             97,   98,  223,  224,  253,  254,  283,  284,
     &            297,  298,  311,  312,  341,  342,  355,  356],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [0, -10]
        call register_lumi_pine(
     &         [   11,   25,   71,   85,   99,  127,  128,  167,
     &            168,  193,  209,  225,  255,  285,  299,  313,
     &            343,  357,  405,  406,  445,  446,  485,  486,
     &            507,  523,  539],
     &         3,
     &         [   21,   -1,   21,   -3,   21,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [   12,   26,   72,   86,  100,  129,  130,  169,
     &            170,  194,  210,  226,  256,  286,  300,  314,
     &            344,  358,  407,  408,  447,  448,  487,  488,
     &            508,  524,  540],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 0]
        call register_lumi_pine(
     &         [   13,   27,   73,   87,  101,  131,  132,  171,
     &            172,  195,  211,  227,  257,  287,  301,  315,
     &            345,  359,  413,  414,  453,  454,  493,  494,
     &            511,  527,  543],
     &         3,
     &         [   -1,   21,   -3,   21,   -5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [   14,   28,   74,   88,  102,  133,  134,  173,
     &            174,  196,  212,  228,  258,  288,  302,  316,
     &            346,  360,  415,  416,  455,  456,  495,  496,
     &            512,  528,  544],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [11, -11]
        call register_lumi_pine(
     &         [   29,  107,  147,  233,  263,  321,  365,  377,
     &            417,  457],
     &         9,
     &         [    1,   -1,    1,   -3,    1,   -5,    3,   -1,
     &              3,   -3,    3,   -5,    5,   -1,    5,   -3,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, -21]
        call register_lumi_pine(
     &         [   30,  108,  148,  234,  264,  322,  366,  378,
     &            418,  458],
     &         6,
     &         [    1,   -2,    1,   -4,    3,   -2,    3,   -4,
     &              5,   -2,    5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -11]
        call register_lumi_pine(
     &         [   31,  109,  149,  235,  265,  323,  367,  379,
     &            419,  459],
     &         6,
     &         [    2,   -1,    2,   -3,    2,   -5,    4,   -1,
     &              4,   -3,    4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -21]
        call register_lumi_pine(
     &         [   32,  110,  150,  236,  266,  324,  368,  380,
     &            420,  460],
     &         4,
     &         [    2,   -2,    2,   -4,    4,   -2,    4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [11, 11]
        call register_lumi_pine(
     &         [   33,  111,  151,  229,  259,  317,  361,  381,
     &            421,  461],
     &         9,
     &         [    1,    1,    1,    3,    1,    5,    3,    1,
     &              3,    3,    3,    5,    5,    1,    5,    3,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, 21]
        call register_lumi_pine(
     &         [   34,  112,  152,  230,  260,  318,  362,  382,
     &            422,  462],
     &         6,
     &         [    1,    2,    1,    4,    3,    2,    3,    4,
     &              5,    2,    5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 11]
        call register_lumi_pine(
     &         [   35,  113,  153,  231,  261,  319,  363,  383,
     &            423,  463],
     &         6,
     &         [    2,    1,    2,    3,    2,    5,    4,    1,
     &              4,    3,    4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 21]
        call register_lumi_pine(
     &         [   36,  114,  154,  232,  262,  320,  364,  384,
     &            424,  464],
     &         4,
     &         [    2,    2,    2,    4,    4,    2,    4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, -11]
        call register_lumi_pine(
     &         [   45,  135,  175,  241,  271,  329,  373,  393,
     &            433,  473],
     &         9,
     &         [   -1,   -1,   -1,   -3,   -1,   -5,   -3,   -1,
     &             -3,   -3,   -3,   -5,   -5,   -1,   -5,   -3,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, -21]
        call register_lumi_pine(
     &         [   46,  136,  176,  242,  272,  330,  374,  394,
     &            434,  474],
     &         6,
     &         [   -1,   -2,   -1,   -4,   -3,   -2,   -3,   -4,
     &             -5,   -2,   -5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -11]
        call register_lumi_pine(
     &         [   47,  137,  177,  243,  273,  331,  375,  395,
     &            435,  475],
     &         6,
     &         [   -2,   -1,   -2,   -3,   -2,   -5,   -4,   -1,
     &             -4,   -3,   -4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -21]
        call register_lumi_pine(
     &         [   48,  138,  178,  244,  274,  332,  376,  396,
     &            436,  476],
     &         4,
     &         [   -2,   -2,   -2,   -4,   -4,   -2,   -4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, 11]
        call register_lumi_pine(
     &         [   49,  139,  179,  237,  267,  325,  369,  397,
     &            437,  477],
     &         9,
     &         [   -1,    1,   -1,    3,   -1,    5,   -3,    1,
     &             -3,    3,   -3,    5,   -5,    1,   -5,    3,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, 21]
        call register_lumi_pine(
     &         [   50,  140,  180,  238,  268,  326,  370,  398,
     &            438,  478],
     &         6,
     &         [   -1,    2,   -1,    4,   -3,    2,   -3,    4,
     &             -5,    2,   -5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 11]
        call register_lumi_pine(
     &         [   51,  141,  181,  239,  269,  327,  371,  399,
     &            439,  479],
     &         6,
     &         [   -2,    1,   -2,    3,   -2,    5,   -4,    1,
     &             -4,    3,   -4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 21]
        call register_lumi_pine(
     &         [   52,  142,  182,  240,  270,  328,  372,  400,
     &            440,  480],
     &         4,
     &         [   -2,    2,   -2,    4,   -4,    2,   -4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [10, 10]
        call register_lumi_pine(
     &         [   55,  187,  203,  499,  515,  531],
     &         3,
     &         [    1,    1,    3,    3,    5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 20]
        call register_lumi_pine(
     &         [   56,  188,  204,  500,  516,  532],
     &         2,
     &         [    2,    2,    4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, -10]
        call register_lumi_pine(
     &         [   59,  197,  213,  503,  519,  535],
     &         3,
     &         [   -1,   -1,   -3,   -3,   -5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, -20]
        call register_lumi_pine(
     &         [   60,  198,  214,  504,  520,  536],
     &         2,
     &         [   -2,   -2,   -4,   -4],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiGJJ


#endif


