      function sigVGJJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVGJJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,5,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- d g to g d G 
      if (qactive_chan(215).and.qselect_chan(215)) then
        current_chan = 215
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(1,2,3,4,5,muR2_scl(i))
     .          +sB2g1G(1,3,2,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to g u G 
      if (qactive_chan(216).and.qselect_chan(216)) then
        current_chan = 216
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(1,2,3,4,5,muR2_scl(i))
     .          +sB2g1G(1,3,2,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g g G 
      if (qactive_chan(217).and.qselect_chan(217)) then
        current_chan = 217
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(1,3,4,2,5,muR2_scl(i))
     .          +sB2g1G(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g g G 
      if (qactive_chan(218).and.qselect_chan(218)) then
        current_chan = 218
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(1,3,4,2,5,muR2_scl(i))
     .          +sB2g1G(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g d G 
      if (qactive_chan(219).and.qselect_chan(219)) then
        current_chan = 219
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(2,1,3,4,5,muR2_scl(i))
     .          +sB2g1G(2,3,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to g u G 
      if (qactive_chan(220).and.qselect_chan(220)) then
        current_chan = 220
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(2,1,3,4,5,muR2_scl(i))
     .          +sB2g1G(2,3,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g g G 
      if (qactive_chan(221).and.qselect_chan(221)) then
        current_chan = 221
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(2,3,4,1,5,muR2_scl(i))
     .          +sB2g1G(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g g G 
      if (qactive_chan(222).and.qselect_chan(222)) then
        current_chan = 222
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(2,3,4,1,5,muR2_scl(i))
     .          +sB2g1G(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db d G 
      if (qactive_chan(223).and.qselect_chan(223)) then
        current_chan = 223
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(3,1,2,4,5,muR2_scl(i))
     .          +sB2g1G(3,2,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to ub u G 
      if (qactive_chan(224).and.qselect_chan(224)) then
        current_chan = 224
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(3,1,2,4,5,muR2_scl(i))
     .          +sB2g1G(3,2,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db g G 
      if (qactive_chan(225).and.qselect_chan(225)) then
        current_chan = 225
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(3,1,4,2,5,muR2_scl(i))
     .          +sB2g1G(3,4,1,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub g G 
      if (qactive_chan(226).and.qselect_chan(226)) then
        current_chan = 226
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(3,1,4,2,5,muR2_scl(i))
     .          +sB2g1G(3,4,1,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db g G 
      if (qactive_chan(227).and.qselect_chan(227)) then
        current_chan = 227
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(3,2,4,1,5,muR2_scl(i))
     .          +sB2g1G(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub g G 
      if (qactive_chan(228).and.qselect_chan(228)) then
        current_chan = 228
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1G(3,2,4,1,5,muR2_scl(i))
     .          +sB2g1G(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to g d G 
      if (qactive_chan(245).and.qselect_chan(245)) then
        current_chan = 245
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(1,2,3,4,5,muR2_scl(i))
     .          +sBt2g1G(1,3,2,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to g u G 
      if (qactive_chan(246).and.qselect_chan(246)) then
        current_chan = 246
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(1,2,3,4,5,muR2_scl(i))
     .          +sBt2g1G(1,3,2,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g g G 
      if (qactive_chan(247).and.qselect_chan(247)) then
        current_chan = 247
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(1,3,4,2,5,muR2_scl(i))
     .          +sBt2g1G(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g g G 
      if (qactive_chan(248).and.qselect_chan(248)) then
        current_chan = 248
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(1,3,4,2,5,muR2_scl(i))
     .          +sBt2g1G(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g d G 
      if (qactive_chan(249).and.qselect_chan(249)) then
        current_chan = 249
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(2,1,3,4,5,muR2_scl(i))
     .          +sBt2g1G(2,3,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to g u G 
      if (qactive_chan(250).and.qselect_chan(250)) then
        current_chan = 250
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(2,1,3,4,5,muR2_scl(i))
     .          +sBt2g1G(2,3,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g g G 
      if (qactive_chan(251).and.qselect_chan(251)) then
        current_chan = 251
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(2,3,4,1,5,muR2_scl(i))
     .          +sBt2g1G(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g g G 
      if (qactive_chan(252).and.qselect_chan(252)) then
        current_chan = 252
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(2,3,4,1,5,muR2_scl(i))
     .          +sBt2g1G(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db d G 
      if (qactive_chan(253).and.qselect_chan(253)) then
        current_chan = 253
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(3,1,2,4,5,muR2_scl(i))
     .          +sBt2g1G(3,2,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to ub u G 
      if (qactive_chan(254).and.qselect_chan(254)) then
        current_chan = 254
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(3,1,2,4,5,muR2_scl(i))
     .          +sBt2g1G(3,2,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db g G 
      if (qactive_chan(255).and.qselect_chan(255)) then
        current_chan = 255
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(3,1,4,2,5,muR2_scl(i))
     .          +sBt2g1G(3,4,1,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub g G 
      if (qactive_chan(256).and.qselect_chan(256)) then
        current_chan = 256
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(3,1,4,2,5,muR2_scl(i))
     .          +sBt2g1G(3,4,1,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db g G 
      if (qactive_chan(257).and.qselect_chan(257)) then
        current_chan = 257
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(3,2,4,1,5,muR2_scl(i))
     .          +sBt2g1G(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub g G 
      if (qactive_chan(258).and.qselect_chan(258)) then
        current_chan = 258
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1G(3,2,4,1,5,muR2_scl(i))
     .          +sBt2g1G(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt d G 
      if (qactive_chan(275).and.qselect_chan(275)) then
        current_chan = 275
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u gt to gt u G 
      if (qactive_chan(276).and.qselect_chan(276)) then
        current_chan = 276
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to gt gt G 
      if (qactive_chan(277).and.qselect_chan(277)) then
        current_chan = 277
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Gc(1,3,4,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to gt gt G 
      if (qactive_chan(278).and.qselect_chan(278)) then
        current_chan = 278
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Gc(1,3,4,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt d G 
      if (qactive_chan(279).and.qselect_chan(279)) then
        current_chan = 279
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt u to gt u G 
      if (qactive_chan(280).and.qselect_chan(280)) then
        current_chan = 280
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to gt gt G 
      if (qactive_chan(281).and.qselect_chan(281)) then
        current_chan = 281
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Gc(2,3,4,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to gt gt G 
      if (qactive_chan(282).and.qselect_chan(282)) then
        current_chan = 282
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Gc(2,3,4,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db d G 
      if (qactive_chan(283).and.qselect_chan(283)) then
        current_chan = 283
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to ub u G 
      if (qactive_chan(284).and.qselect_chan(284)) then
        current_chan = 284
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt db to db gt G 
      if (qactive_chan(285).and.qselect_chan(285)) then
        current_chan = 285
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to ub gt G 
      if (qactive_chan(286).and.qselect_chan(286)) then
        current_chan = 286
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db gt to db gt G 
      if (qactive_chan(287).and.qselect_chan(287)) then
        current_chan = 287
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to ub gt G 
      if (qactive_chan(288).and.qselect_chan(288)) then
        current_chan = 288
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Gc(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt d G 
      if (qactive_chan(289).and.qselect_chan(289)) then
        current_chan = 289
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u gt to gt u G 
      if (qactive_chan(290).and.qselect_chan(290)) then
        current_chan = 290
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to gt gt G 
      if (qactive_chan(291).and.qselect_chan(291)) then
        current_chan = 291
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1G(1,3,4,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to gt gt G 
      if (qactive_chan(292).and.qselect_chan(292)) then
        current_chan = 292
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1G(1,3,4,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt d G 
      if (qactive_chan(293).and.qselect_chan(293)) then
        current_chan = 293
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt u to gt u G 
      if (qactive_chan(294).and.qselect_chan(294)) then
        current_chan = 294
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to gt gt G 
      if (qactive_chan(295).and.qselect_chan(295)) then
        current_chan = 295
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1G(2,3,4,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to gt gt G 
      if (qactive_chan(296).and.qselect_chan(296)) then
        current_chan = 296
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1G(2,3,4,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db d G 
      if (qactive_chan(297).and.qselect_chan(297)) then
        current_chan = 297
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to ub u G 
      if (qactive_chan(298).and.qselect_chan(298)) then
        current_chan = 298
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt db to db gt G 
      if (qactive_chan(299).and.qselect_chan(299)) then
        current_chan = 299
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to ub gt G 
      if (qactive_chan(300).and.qselect_chan(300)) then
        current_chan = 300
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db gt to db gt G 
      if (qactive_chan(301).and.qselect_chan(301)) then
        current_chan = 301
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to ub gt G 
      if (qactive_chan(302).and.qselect_chan(302)) then
        current_chan = 302
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to g d G 
      if (qactive_chan(303).and.qselect_chan(303)) then
        current_chan = 303
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(1,2,3,4,5,muR2_scl(i))
     .          +sBh2g1G(1,3,2,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to g u G 
      if (qactive_chan(304).and.qselect_chan(304)) then
        current_chan = 304
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(1,2,3,4,5,muR2_scl(i))
     .          +sBh2g1G(1,3,2,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g g G 
      if (qactive_chan(305).and.qselect_chan(305)) then
        current_chan = 305
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(1,3,4,2,5,muR2_scl(i))
     .          +sBh2g1G(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g g G 
      if (qactive_chan(306).and.qselect_chan(306)) then
        current_chan = 306
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(1,3,4,2,5,muR2_scl(i))
     .          +sBh2g1G(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g d G 
      if (qactive_chan(307).and.qselect_chan(307)) then
        current_chan = 307
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(2,1,3,4,5,muR2_scl(i))
     .          +sBh2g1G(2,3,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to g u G 
      if (qactive_chan(308).and.qselect_chan(308)) then
        current_chan = 308
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(2,1,3,4,5,muR2_scl(i))
     .          +sBh2g1G(2,3,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g g G 
      if (qactive_chan(309).and.qselect_chan(309)) then
        current_chan = 309
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(2,3,4,1,5,muR2_scl(i))
     .          +sBh2g1G(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g g G 
      if (qactive_chan(310).and.qselect_chan(310)) then
        current_chan = 310
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(2,3,4,1,5,muR2_scl(i))
     .          +sBh2g1G(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db d G 
      if (qactive_chan(311).and.qselect_chan(311)) then
        current_chan = 311
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(3,1,2,4,5,muR2_scl(i))
     .          +sBh2g1G(3,2,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to ub u G 
      if (qactive_chan(312).and.qselect_chan(312)) then
        current_chan = 312
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(3,1,2,4,5,muR2_scl(i))
     .          +sBh2g1G(3,2,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db g G 
      if (qactive_chan(313).and.qselect_chan(313)) then
        current_chan = 313
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(3,1,4,2,5,muR2_scl(i))
     .          +sBh2g1G(3,4,1,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub g G 
      if (qactive_chan(314).and.qselect_chan(314)) then
        current_chan = 314
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(3,1,4,2,5,muR2_scl(i))
     .          +sBh2g1G(3,4,1,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db g G 
      if (qactive_chan(315).and.qselect_chan(315)) then
        current_chan = 315
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(3,2,4,1,5,muR2_scl(i))
     .          +sBh2g1G(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub g G 
      if (qactive_chan(316).and.qselect_chan(316)) then
        current_chan = 316
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1G(3,2,4,1,5,muR2_scl(i))
     .          +sBh2g1G(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt d G 
      if (qactive_chan(333).and.qselect_chan(333)) then
        current_chan = 333
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u gt to gt u G 
      if (qactive_chan(334).and.qselect_chan(334)) then
        current_chan = 334
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to gt gt G 
      if (qactive_chan(335).and.qselect_chan(335)) then
        current_chan = 335
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1G(1,3,4,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to gt gt G 
      if (qactive_chan(336).and.qselect_chan(336)) then
        current_chan = 336
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1G(1,3,4,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt d G 
      if (qactive_chan(337).and.qselect_chan(337)) then
        current_chan = 337
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt u to gt u G 
      if (qactive_chan(338).and.qselect_chan(338)) then
        current_chan = 338
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to gt gt G 
      if (qactive_chan(339).and.qselect_chan(339)) then
        current_chan = 339
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1G(2,3,4,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to gt gt G 
      if (qactive_chan(340).and.qselect_chan(340)) then
        current_chan = 340
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1G(2,3,4,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db d G 
      if (qactive_chan(341).and.qselect_chan(341)) then
        current_chan = 341
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to ub u G 
      if (qactive_chan(342).and.qselect_chan(342)) then
        current_chan = 342
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt db to db gt G 
      if (qactive_chan(343).and.qselect_chan(343)) then
        current_chan = 343
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to ub gt G 
      if (qactive_chan(344).and.qselect_chan(344)) then
        current_chan = 344
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db gt to db gt G 
      if (qactive_chan(345).and.qselect_chan(345)) then
        current_chan = 345
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to ub gt G 
      if (qactive_chan(346).and.qselect_chan(346)) then
        current_chan = 346
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to g d G 
      if (qactive_chan(347).and.qselect_chan(347)) then
        current_chan = 347
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(1,2,3,4,5,muR2_scl(i))
     .          +Bv2g1G(1,3,2,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to g u G 
      if (qactive_chan(348).and.qselect_chan(348)) then
        current_chan = 348
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(1,2,3,4,5,muR2_scl(i))
     .          +Bv2g1G(1,3,2,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g g G 
      if (qactive_chan(349).and.qselect_chan(349)) then
        current_chan = 349
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(1,3,4,2,5,muR2_scl(i))
     .          +Bv2g1G(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g g G 
      if (qactive_chan(350).and.qselect_chan(350)) then
        current_chan = 350
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(1,3,4,2,5,muR2_scl(i))
     .          +Bv2g1G(1,4,3,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g d G 
      if (qactive_chan(351).and.qselect_chan(351)) then
        current_chan = 351
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(2,1,3,4,5,muR2_scl(i))
     .          +Bv2g1G(2,3,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to g u G 
      if (qactive_chan(352).and.qselect_chan(352)) then
        current_chan = 352
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(2,1,3,4,5,muR2_scl(i))
     .          +Bv2g1G(2,3,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g g G 
      if (qactive_chan(353).and.qselect_chan(353)) then
        current_chan = 353
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(2,3,4,1,5,muR2_scl(i))
     .          +Bv2g1G(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g g G 
      if (qactive_chan(354).and.qselect_chan(354)) then
        current_chan = 354
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(2,3,4,1,5,muR2_scl(i))
     .          +Bv2g1G(2,4,3,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db d G 
      if (qactive_chan(355).and.qselect_chan(355)) then
        current_chan = 355
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(3,1,2,4,5,muR2_scl(i))
     .          +Bv2g1G(3,2,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to ub u G 
      if (qactive_chan(356).and.qselect_chan(356)) then
        current_chan = 356
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(3,1,2,4,5,muR2_scl(i))
     .          +Bv2g1G(3,2,1,4,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db g G 
      if (qactive_chan(357).and.qselect_chan(357)) then
        current_chan = 357
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(3,1,4,2,5,muR2_scl(i))
     .          +Bv2g1G(3,4,1,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub g G 
      if (qactive_chan(358).and.qselect_chan(358)) then
        current_chan = 358
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(3,1,4,2,5,muR2_scl(i))
     .          +Bv2g1G(3,4,1,2,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db g G 
      if (qactive_chan(359).and.qselect_chan(359)) then
        current_chan = 359
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(3,2,4,1,5,muR2_scl(i))
     .          +Bv2g1G(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub g G 
      if (qactive_chan(360).and.qselect_chan(360)) then
        current_chan = 360
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bv2g1G(3,2,4,1,5,muR2_scl(i))
     .          +Bv2g1G(3,4,2,1,5,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d G 
      if (qactive_chan(377).and.qselect_chan(377)) then
        current_chan = 377
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to ub d G 
      if (qactive_chan(378).and.qselect_chan(378)) then
        current_chan = 378
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u db to db u G 
      if (qactive_chan(379).and.qselect_chan(379)) then
        current_chan = 379
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u G 
      if (qactive_chan(380).and.qselect_chan(380)) then
        current_chan = 380
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d G 
      if (qactive_chan(381).and.qselect_chan(381)) then
        current_chan = 381
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to u d G 
      if (qactive_chan(382).and.qselect_chan(382)) then
        current_chan = 382
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to d u G 
      if (qactive_chan(383).and.qselect_chan(383)) then
        current_chan = 383
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u G 
      if (qactive_chan(384).and.qselect_chan(384)) then
        current_chan = 384
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to d db G 
      if (qactive_chan(385).and.qselect_chan(385)) then
        current_chan = 385
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to u ub G 
      if (qactive_chan(386).and.qselect_chan(386)) then
        current_chan = 386
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to d db G 
      if (qactive_chan(387).and.qselect_chan(387)) then
        current_chan = 387
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to u ub G 
      if (qactive_chan(388).and.qselect_chan(388)) then
        current_chan = 388
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to d db G 
      if (qactive_chan(389).and.qselect_chan(389)) then
        current_chan = 389
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to u ub G 
      if (qactive_chan(390).and.qselect_chan(390)) then
        current_chan = 390
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to d db G 
      if (qactive_chan(391).and.qselect_chan(391)) then
        current_chan = 391
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to u ub G 
      if (qactive_chan(392).and.qselect_chan(392)) then
        current_chan = 392
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db G 
      if (qactive_chan(393).and.qselect_chan(393)) then
        current_chan = 393
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db ub G 
      if (qactive_chan(394).and.qselect_chan(394)) then
        current_chan = 394
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to ub db G 
      if (qactive_chan(395).and.qselect_chan(395)) then
        current_chan = 395
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub G 
      if (qactive_chan(396).and.qselect_chan(396)) then
        current_chan = 396
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d G 
      if (qactive_chan(397).and.qselect_chan(397)) then
        current_chan = 397
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db u to db u G 
      if (qactive_chan(398).and.qselect_chan(398)) then
        current_chan = 398
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to ub d G 
      if (qactive_chan(399).and.qselect_chan(399)) then
        current_chan = 399
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u G 
      if (qactive_chan(400).and.qselect_chan(400)) then
        current_chan = 400
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d G 
      if (qactive_chan(417).and.qselect_chan(417)) then
        current_chan = 417
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to ub d G 
      if (qactive_chan(418).and.qselect_chan(418)) then
        current_chan = 418
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u db to db u G 
      if (qactive_chan(419).and.qselect_chan(419)) then
        current_chan = 419
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u G 
      if (qactive_chan(420).and.qselect_chan(420)) then
        current_chan = 420
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d G 
      if (qactive_chan(421).and.qselect_chan(421)) then
        current_chan = 421
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to u d G 
      if (qactive_chan(422).and.qselect_chan(422)) then
        current_chan = 422
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to d u G 
      if (qactive_chan(423).and.qselect_chan(423)) then
        current_chan = 423
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u G 
      if (qactive_chan(424).and.qselect_chan(424)) then
        current_chan = 424
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to d db G 
      if (qactive_chan(425).and.qselect_chan(425)) then
        current_chan = 425
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to u ub G 
      if (qactive_chan(426).and.qselect_chan(426)) then
        current_chan = 426
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to d db G 
      if (qactive_chan(427).and.qselect_chan(427)) then
        current_chan = 427
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to u ub G 
      if (qactive_chan(428).and.qselect_chan(428)) then
        current_chan = 428
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to d db G 
      if (qactive_chan(429).and.qselect_chan(429)) then
        current_chan = 429
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to u ub G 
      if (qactive_chan(430).and.qselect_chan(430)) then
        current_chan = 430
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to d db G 
      if (qactive_chan(431).and.qselect_chan(431)) then
        current_chan = 431
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to u ub G 
      if (qactive_chan(432).and.qselect_chan(432)) then
        current_chan = 432
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db G 
      if (qactive_chan(433).and.qselect_chan(433)) then
        current_chan = 433
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db ub G 
      if (qactive_chan(434).and.qselect_chan(434)) then
        current_chan = 434
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to ub db G 
      if (qactive_chan(435).and.qselect_chan(435)) then
        current_chan = 435
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub G 
      if (qactive_chan(436).and.qselect_chan(436)) then
        current_chan = 436
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d G 
      if (qactive_chan(437).and.qselect_chan(437)) then
        current_chan = 437
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db u to db u G 
      if (qactive_chan(438).and.qselect_chan(438)) then
        current_chan = 438
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to ub d G 
      if (qactive_chan(439).and.qselect_chan(439)) then
        current_chan = 439
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u G 
      if (qactive_chan(440).and.qselect_chan(440)) then
        current_chan = 440
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCt0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d G 
      if (qactive_chan(457).and.qselect_chan(457)) then
        current_chan = 457
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to ub d G 
      if (qactive_chan(458).and.qselect_chan(458)) then
        current_chan = 458
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u db to db u G 
      if (qactive_chan(459).and.qselect_chan(459)) then
        current_chan = 459
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u G 
      if (qactive_chan(460).and.qselect_chan(460)) then
        current_chan = 460
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d G 
      if (qactive_chan(461).and.qselect_chan(461)) then
        current_chan = 461
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to u d G 
      if (qactive_chan(462).and.qselect_chan(462)) then
        current_chan = 462
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to d u G 
      if (qactive_chan(463).and.qselect_chan(463)) then
        current_chan = 463
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u G 
      if (qactive_chan(464).and.qselect_chan(464)) then
        current_chan = 464
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to d db G 
      if (qactive_chan(465).and.qselect_chan(465)) then
        current_chan = 465
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to u ub G 
      if (qactive_chan(466).and.qselect_chan(466)) then
        current_chan = 466
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to d db G 
      if (qactive_chan(467).and.qselect_chan(467)) then
        current_chan = 467
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to u ub G 
      if (qactive_chan(468).and.qselect_chan(468)) then
        current_chan = 468
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(1,3,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to d db G 
      if (qactive_chan(469).and.qselect_chan(469)) then
        current_chan = 469
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to u ub G 
      if (qactive_chan(470).and.qselect_chan(470)) then
        current_chan = 470
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to d db G 
      if (qactive_chan(471).and.qselect_chan(471)) then
        current_chan = 471
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to u ub G 
      if (qactive_chan(472).and.qselect_chan(472)) then
        current_chan = 472
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(2,3,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db G 
      if (qactive_chan(473).and.qselect_chan(473)) then
        current_chan = 473
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db ub G 
      if (qactive_chan(474).and.qselect_chan(474)) then
        current_chan = 474
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to ub db G 
      if (qactive_chan(475).and.qselect_chan(475)) then
        current_chan = 475
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub G 
      if (qactive_chan(476).and.qselect_chan(476)) then
        current_chan = 476
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,4,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(3,2,4,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d G 
      if (qactive_chan(477).and.qselect_chan(477)) then
        current_chan = 477
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db u to db u G 
      if (qactive_chan(478).and.qselect_chan(478)) then
        current_chan = 478
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to ub d G 
      if (qactive_chan(479).and.qselect_chan(479)) then
        current_chan = 479
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u G 
      if (qactive_chan(480).and.qselect_chan(480)) then
        current_chan = 480
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,4,2,1,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sCh0g1G(3,4,2,1,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d G 
      if (qactive_chan(497).and.qselect_chan(497)) then
        current_chan = 497
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u G 
      if (qactive_chan(498).and.qselect_chan(498)) then
        current_chan = 498
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d G 
      if (qactive_chan(499).and.qselect_chan(499)) then
        current_chan = 499
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u G 
      if (qactive_chan(500).and.qselect_chan(500)) then
        current_chan = 500
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d G 
      if (qactive_chan(501).and.qselect_chan(501)) then
        current_chan = 501
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u G 
      if (qactive_chan(502).and.qselect_chan(502)) then
        current_chan = 502
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db G 
      if (qactive_chan(503).and.qselect_chan(503)) then
        current_chan = 503
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub G 
      if (qactive_chan(504).and.qselect_chan(504)) then
        current_chan = 504
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d G 
      if (qactive_chan(513).and.qselect_chan(513)) then
        current_chan = 513
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u G 
      if (qactive_chan(514).and.qselect_chan(514)) then
        current_chan = 514
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d G 
      if (qactive_chan(515).and.qselect_chan(515)) then
        current_chan = 515
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u G 
      if (qactive_chan(516).and.qselect_chan(516)) then
        current_chan = 516
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d G 
      if (qactive_chan(517).and.qselect_chan(517)) then
        current_chan = 517
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u G 
      if (qactive_chan(518).and.qselect_chan(518)) then
        current_chan = 518
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db G 
      if (qactive_chan(519).and.qselect_chan(519)) then
        current_chan = 519
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub G 
      if (qactive_chan(520).and.qselect_chan(520)) then
        current_chan = 520
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d G 
      if (qactive_chan(529).and.qselect_chan(529)) then
        current_chan = 529
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u G 
      if (qactive_chan(530).and.qselect_chan(530)) then
        current_chan = 530
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1G(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d G 
      if (qactive_chan(531).and.qselect_chan(531)) then
        current_chan = 531
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u G 
      if (qactive_chan(532).and.qselect_chan(532)) then
        current_chan = 532
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1G(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d G 
      if (qactive_chan(533).and.qselect_chan(533)) then
        current_chan = 533
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u G 
      if (qactive_chan(534).and.qselect_chan(534)) then
        current_chan = 534
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1G(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db G 
      if (qactive_chan(535).and.qselect_chan(535)) then
        current_chan = 535
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub G 
      if (qactive_chan(536).and.qselect_chan(536)) then
        current_chan = 536
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,4,2,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1G(3,1,4,2,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigVGJJ=rnorm*wtsum

      return
      end
