      subroutine getlumiH2(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    2,    9,   14,   19,   20,   25,   32,          
     &           45,   50,   61,   72,   83,   88,   95,  104,          
     &          113,  122,  131,  140,  145,  150,  151)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    3,   12,   17,   21,   28,   48,   53,   55,          
     &           66,   77,   89,  100,  109,  118,  127,  136,          
     &          143,  148)
!       [30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    4,   22,   29,   37,   41,   56,   67,   78,          
     &           90)
!       [30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    5,   10,   15,   23,   30,   46,   51,   57,          
     &           68,   79,   91,   96,  105,  114,  123,  132,          
     &          141,  146)
!       [0, 30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (    6,   24,   31,   38,   43,   58,   69,   80,          
     &           92)
!       [-30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    7,   11,   16,   26,   33,   47,   52,   59,          
     &           70,   81,   93,   97,  106,  115,  124,  133,          
     &          142,  147)
!       [0, -30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    8,   13,   18,   27,   34,   49,   54,   60,          
     &           71,   82,   94,  103,  112,  121,  130,  139,          
     &          144,  149)
!       [-30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   35,   63,   74,   85,   99,  108,  117,  126,          
     &          135)
!       [31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   36,   62,   73,   84,   98,  107,  116,  125,          
     &          134)
!       [31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   39,   65,   76,   87,  102,  111,  120,  129,          
     &          138)
!       [-31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   40,   64,   75,   86,  101,  110,  119,  128,          
     &          137)
!       [-31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   42)
!       [30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   44)
!       [-30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case default
          print*, "getlumiH2: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiH2



      function getlumiidH2(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    2,    9,   14,   19,   20,   25,   32,
     &           45,   50,   61,   72,   83,   88,   95,  104,
     &          113,  122,  131,  140,  145,  150,  151)
          id  = 1
          ip1 = 0
          ip2 = 0

        case (    3,   12,   17,   21,   28,   48,   53,   55,
     &           66,   77,   89,  100,  109,  118,  127,  136,
     &          143,  148)
          id  = 2
          ip1 = 30
          ip2 = 0

        case (    4,   22,   29,   37,   41,   56,   67,   78,
     &           90)
          id  = 3
          ip1 = 30
          ip2 = -30

        case (    5,   10,   15,   23,   30,   46,   51,   57,
     &           68,   79,   91,   96,  105,  114,  123,  132,
     &          141,  146)
          id  = 4
          ip1 = 0
          ip2 = 30

        case (    6,   24,   31,   38,   43,   58,   69,   80,
     &           92)
          id  = 5
          ip1 = -30
          ip2 = 30

        case (    7,   11,   16,   26,   33,   47,   52,   59,
     &           70,   81,   93,   97,  106,  115,  124,  133,
     &          142,  147)
          id  = 6
          ip1 = 0
          ip2 = -30

        case (    8,   13,   18,   27,   34,   49,   54,   60,
     &           71,   82,   94,  103,  112,  121,  130,  139,
     &          144,  149)
          id  = 7
          ip1 = -30
          ip2 = 0

        case (   35,   63,   74,   85,   99,  108,  117,  126,
     &          135)
          id  = 8
          ip1 = 31
          ip2 = -31

        case (   36,   62,   73,   84,   98,  107,  116,  125,
     &          134)
          id  = 9
          ip1 = 31
          ip2 = 31

        case (   39,   65,   76,   87,  102,  111,  120,  129,
     &          138)
          id  = 10
          ip1 = -31
          ip2 = -31

        case (   40,   64,   75,   86,  101,  110,  119,  128,
     &          137)
          id  = 11
          ip1 = -31
          ip2 = 31

        case (   42)
          id  = 12
          ip1 = 30
          ip2 = 30

        case (   44)
          id  = 13
          ip1 = -30
          ip2 = -30

        case default
          print*, "getlumiidH2: invalid iproc:", iproc
          stop
        end select

      end function getlumiidH2





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiH2()
        use PineAPPL_mod
        use CKM_mod
!       [0, 0]
        call register_lumi_pine(
     &         [    1,    2,    9,   14,   19,   20,   25,   32,
     &             45,   50,   61,   72,   83,   88,   95,  104,
     &            113,  122,  131,  140,  145,  150,  151],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [30, 0]
        call register_lumi_pine(
     &         [    3,   12,   17,   21,   28,   48,   53,   55,
     &             66,   77,   89,  100,  109,  118,  127,  136,
     &            143,  148],
     &         5,
     &         [    1,   21,    2,   21,    3,   21,    4,   21,
     &              5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [30, -30]
        call register_lumi_pine(
     &         [    4,   22,   29,   37,   41,   56,   67,   78,
     &             90],
     &         5,
     &         [    1,   -1,    2,   -2,    3,   -3,    4,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, 30]
        call register_lumi_pine(
     &         [    5,   10,   15,   23,   30,   46,   51,   57,
     &             68,   79,   91,   96,  105,  114,  123,  132,
     &            141,  146],
     &         5,
     &         [   21,    1,   21,    2,   21,    3,   21,    4,
     &             21,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 30]
        call register_lumi_pine(
     &         [    6,   24,   31,   38,   43,   58,   69,   80,
     &             92],
     &         5,
     &         [   -1,    1,   -2,    2,   -3,    3,   -4,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, -30]
        call register_lumi_pine(
     &         [    7,   11,   16,   26,   33,   47,   52,   59,
     &             70,   81,   93,   97,  106,  115,  124,  133,
     &            142,  147],
     &         5,
     &         [   21,   -1,   21,   -2,   21,   -3,   21,   -4,
     &             21,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 0]
        call register_lumi_pine(
     &         [    8,   13,   18,   27,   34,   49,   54,   60,
     &             71,   82,   94,  103,  112,  121,  130,  139,
     &            144,  149],
     &         5,
     &         [   -1,   21,   -2,   21,   -3,   21,   -4,   21,
     &             -5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [31, -31]
        call register_lumi_pine(
     &         [   35,   63,   74,   85,   99,  108,  117,  126,
     &            135],
     &         25,
     &         [    1,   -1,    1,   -2,    1,   -3,    1,   -4,
     &              1,   -5,    2,   -1,    2,   -2,    2,   -3,
     &              2,   -4,    2,   -5,    3,   -1,    3,   -2,
     &              3,   -3,    3,   -4,    3,   -5,    4,   -1,
     &              4,   -2,    4,   -3,    4,   -4,    4,   -5,
     &              5,   -1,    5,   -2,    5,   -3,    5,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [31, 31]
        call register_lumi_pine(
     &         [   36,   62,   73,   84,   98,  107,  116,  125,
     &            134],
     &         25,
     &         [    1,    1,    1,    2,    1,    3,    1,    4,
     &              1,    5,    2,    1,    2,    2,    2,    3,
     &              2,    4,    2,    5,    3,    1,    3,    2,
     &              3,    3,    3,    4,    3,    5,    4,    1,
     &              4,    2,    4,    3,    4,    4,    4,    5,
     &              5,    1,    5,    2,    5,    3,    5,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, -31]
        call register_lumi_pine(
     &         [   39,   65,   76,   87,  102,  111,  120,  129,
     &            138],
     &         25,
     &         [   -1,   -1,   -1,   -2,   -1,   -3,   -1,   -4,
     &             -1,   -5,   -2,   -1,   -2,   -2,   -2,   -3,
     &             -2,   -4,   -2,   -5,   -3,   -1,   -3,   -2,
     &             -3,   -3,   -3,   -4,   -3,   -5,   -4,   -1,
     &             -4,   -2,   -4,   -3,   -4,   -4,   -4,   -5,
     &             -5,   -1,   -5,   -2,   -5,   -3,   -5,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, 31]
        call register_lumi_pine(
     &         [   40,   64,   75,   86,  101,  110,  119,  128,
     &            137],
     &         25,
     &         [   -1,    1,   -1,    2,   -1,    3,   -1,    4,
     &             -1,    5,   -2,    1,   -2,    2,   -2,    3,
     &             -2,    4,   -2,    5,   -3,    1,   -3,    2,
     &             -3,    3,   -3,    4,   -3,    5,   -4,    1,
     &             -4,    2,   -4,    3,   -4,    4,   -4,    5,
     &             -5,    1,   -5,    2,   -5,    3,   -5,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [30, 30]
        call register_lumi_pine(
     &         [   42],
     &         5,
     &         [    1,    1,    2,    2,    3,    3,    4,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, -30]
        call register_lumi_pine(
     &         [   44],
     &         5,
     &         [   -1,   -1,   -2,   -2,   -3,   -3,   -4,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiH2


#endif


