      subroutine getqcdnormH2(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtH2(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVH2
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourH2(current_chan)
         do isub = 1, nflavourH2(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_H2(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=H2 "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      v=246.21846d0
      C0=(alphas_scl/6d0/pi/v)**2
      C1=11d0/3d0
* C1 = 7/2 + 3/2/nc**2
      dlstop = 0d0
      do iscl=1,nAct_scl
        idmap = idmap_scl(iscl, withR=.true.)
        if (idmap == iscl) then
          if (mt_scheme_param() == id_mass_scheme_MSbar) then
            dlstop(iscl) = 2d0*log(muR_scl(iscl)/mt_param(muR_scl(iscl)))
          else
            dlstop(iscl) = 2d0*log(muR_scl(iscl)/mt_param())
          end if
        else
          dlstop(iscl) = dlstop(idmap)
        end if
      end do
      C2=1933d0/162d0 + 19d0/18d0*dlstop
* C2 = 91/12/nc**2 + 9/4/nc**4 + 1/6/nc**3 - 3/8/nc + 805/72 + 11/4*dlstop/nc**2 + 3/4*dlstop
      C2h=(1d0/3d0)*(-67d0/36d0 + 8d0/9d0*dlstop)
* C2h = 5/8/nc**3 - 139/72/nc - dlstop/nc**3 + dlstop/nc
      facB=ave*C0*(nc**2-1)
      if((amzW.eq.0).or.(stw.eq.0))then
         call initeweak
      endif
      gwsq=4d0*pi*amzW/stw
      select case ( name_proc )
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTO2TAUM','HTO2TAUJM')
        Cew=gwsq
      case default
        Cew=1d0
      end select
      facB=facB*Cew
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! g g -> ph1 ph2          A2g0H2

c -- real

      case(2)
         factor=2d0*facR                    ! g g -> g ph1 ph2        A3g0H2
      case(3)
         factor=1d0/nc*facR                 ! q g -> q ph1 ph2        B1g0H2
      case(4)
         factor=1d0/nc*facR                 ! q qb -> g ph1 ph2       B1g0H2
      case(5)
         factor=1d0/nc*facR                 ! g q -> q ph1 ph2        B1g0H2
      case(6)
         factor=1d0/nc*facR                 ! qb q -> g ph1 ph2       B1g0H2
      case(7)
         factor=1d0/nc*facR                 ! g qb -> qb ph1 ph2      B1g0H2
      case(8)
         factor=1d0/nc*facR                 ! qb g -> qb ph1 ph2      B1g0H2

c -- virtual

      case(9)
         factor=facV                        ! g g -> ph1 ph2          A2g1H2
      case(10)
         factor=1d0/nc*facV                 ! g q subtraction         A2g1H2
      case(11)
         factor=1d0/nc*facV                 ! g qb subtraction        A2g1H2
      case(12)
         factor=1d0/nc*facV                 ! q g subtraction         A2g1H2
      case(13)
         factor=1d0/nc*facV                 ! qb g subtraction        A2g1H2
      case(14)
         factor=1d0/nc*nf*facV              ! g g -> ph1 ph2          Ah2g1H2
      case(15)
         factor=1d0/nc**2*nf*facV           ! g q subtraction         Ah2g1H2
      case(16)
         factor=1d0/nc**2*nf*facV           ! g qb subtraction        Ah2g1H2
      case(17)
         factor=1d0/nc**2*nf*facV           ! q g subtraction         Ah2g1H2
      case(18)
         factor=1d0/nc**2*nf*facV           ! qb g subtraction        Ah2g1H2
      case(19)
         factor=C1*facV                     ! g g -> ph1 ph2          A2g0H2

c -- double real

      case(20)
         factor=2d0*1d0/2d0*facRR           ! g g -> g g ph1 ph2      A4g0H2
      case(21)
         factor=1d0/nc*facRR                ! q g -> g q ph1 ph2      B2g0H2
      case(22)
         factor=1d0/nc*1d0/2d0*facRR        ! q qb -> g g ph1 ph2     B2g0H2
      case(23)
         factor=1d0/nc*facRR                ! g q -> g q ph1 ph2      B2g0H2
      case(24)
         factor=1d0/nc*1d0/2d0*facRR        ! qb q -> g g ph1 ph2     B2g0H2
      case(25)
         factor=1d0/nc*nf*facRR             ! g g -> qb q ph1 ph2     B2g0H2
      case(26)
         factor=1d0/nc*facRR                ! g qb -> qb g ph1 ph2     B2g0H2
      case(27)
         factor=1d0/nc*facRR                ! qb g -> qb g ph1 ph2     B2g0H2
      case(28)
         factor=-1d0/nc**3*facRR            ! q gt -> gt q ph1 ph2     Bt2g0H2
      case(29)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! q qb -> gt gt ph1 ph2     Bt2g0H2
      case(30)
         factor=-1d0/nc**3*facRR            ! gt q -> gt q ph1 ph2     Bt2g0H2
      case(31)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! qb q -> gt gt ph1 ph2     Bt2g0H2
      case(32)
         factor=-1d0/nc**3*nf*facRR         ! gt gt -> qb q ph1 ph2     Bt2g0H2
      case(33)
         factor=-1d0/nc**3*facRR            ! gt qb -> qb gt ph1 ph2     Bt2g0H2
      case(34)
         factor=-1d0/nc**3*facRR            ! qb gt -> qb gt ph1 ph2     Bt2g0H2
      case(35)
         factor=1d0/nc**2*facRR             ! q Qb -> Qb q ph1 ph2     C0g0H2
      case(36)
         factor=1d0/nc**2*facRR             ! q Q -> Q q ph1 ph2      C0g0H2
      case(37)
         factor=1d0/nc**2*nf*facRR          ! q qb -> Q Qb ph1 ph2     C0g0H2
      case(38)
         factor=1d0/nc**2*nf*facRR          ! qb q -> Q Qb ph1 ph2     C0g0H2
      case(39)
         factor=1d0/nc**2*facRR             ! qb Qb -> qb Qb ph1 ph2     C0g0H2
      case(40)
         factor=1d0/nc**2*facRR             ! qb Q -> qb Q ph1 ph2     C0g0H2
      case(41)
         factor=-1d0/nc**3*facRR            ! q qb -> qb q ph1 ph2     D0g0H2
      case(42)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! q q -> q q ph1 ph2      D0g0H2
      case(43)
         factor=-1d0/nc**3*facRR            ! qb q -> qb q ph1 ph2     D0g0H2
      case(44)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! qb qb -> qb qb ph1 ph2     D0g0H2

c -- real virtual

      case(45)
         factor=2d0*facRV                   ! g g -> g ph1 ph2        A3g1H2
      case(46)
         factor=1d0/nc*facRV                ! g q subtraction         A3g1H2
      case(47)
         factor=1d0/nc*facRV                ! g qb subtraction        A3g1H2
      case(48)
         factor=1d0/nc*facRV                ! q g subtraction         A3g1H2
      case(49)
         factor=1d0/nc*facRV                ! qb g subtraction        A3g1H2
      case(50)
         factor=1d0/nc*nf*2d0*facRV         ! g g -> g ph1 ph2        Ah3g1H2
      case(51)
         factor=1d0/nc**2*nf*facRV          ! g q subtraction         Ah3g1H2
      case(52)
         factor=1d0/nc**2*nf*facRV          ! g qb subtraction        Ah3g1H2
      case(53)
         factor=1d0/nc**2*nf*facRV          ! q g subtraction         Ah3g1H2
      case(54)
         factor=1d0/nc**2*nf*facRV          ! qb g subtraction        Ah3g1H2
      case(55)
         factor=1d0/nc*facRV                ! q g -> q ph1 ph2        B1g1H2
      case(56)
         factor=1d0/nc*facRV                ! q qb -> g ph1 ph2       B1g1H2
      case(57)
         factor=1d0/nc*facRV                ! g q -> q ph1 ph2        B1g1H2
      case(58)
         factor=1d0/nc*facRV                ! qb q -> g ph1 ph2       B1g1H2
      case(59)
         factor=1d0/nc*facRV                ! g qb -> qb ph1 ph2      B1g1H2
      case(60)
         factor=1d0/nc*facRV                ! qb g -> qb ph1 ph2      B1g1H2
      case(61)
         factor=1d0/nc*nf*facRV             ! g g subtraction         B1g1H2
      case(62)
         factor=1d0/nc**2*facRV             ! q Q subtraction         B1g1H2
      case(63)
         factor=1d0/nc**2*facRV             ! q Qb subtraction        B1g1H2
      case(64)
         factor=1d0/nc**2*facRV             ! qb Q subtraction        B1g1H2
      case(65)
         factor=1d0/nc**2*facRV             ! qb Qb subtraction       B1g1H2
      case(66)
         factor=1d0/nc**2*nf*facRV          ! q g -> q ph1 ph2        Bh1g1H2
      case(67)
         factor=1d0/nc**2*nf*facRV          ! q qb -> g ph1 ph2       Bh1g1H2
      case(68)
         factor=1d0/nc**2*nf*facRV          ! g q -> q ph1 ph2        Bh1g1H2
      case(69)
         factor=1d0/nc**2*nf*facRV          ! qb q -> g ph1 ph2       Bh1g1H2
      case(70)
         factor=1d0/nc**2*nf*facRV          ! g qb -> qb ph1 ph2      Bh1g1H2
      case(71)
         factor=1d0/nc**2*nf*facRV          ! qb g -> qb ph1 ph2      Bh1g1H2
      case(72)
         factor=1d0/nc**2*nf**2*facRV       ! g g subtraction         Bh1g1H2
      case(73)
         factor=1d0/nc**3*nf*facRV          ! q Q subtraction         Bh1g1H2
      case(74)
         factor=1d0/nc**3*nf*facRV          ! q Qb subtraction        Bh1g1H2
      case(75)
         factor=1d0/nc**3*nf*facRV          ! qb Q subtraction        Bh1g1H2
      case(76)
         factor=1d0/nc**3*nf*facRV          ! qb Qb subtraction       Bh1g1H2
      case(77)
         factor=-1d0/nc**3*facRV            ! q g -> q ph1 ph2        Bt1g1H2
      case(78)
         factor=-1d0/nc**3*facRV            ! q qb -> g ph1 ph2       Bt1g1H2
      case(79)
         factor=-1d0/nc**3*facRV            ! g q -> q ph1 ph2        Bt1g1H2
      case(80)
         factor=-1d0/nc**3*facRV            ! qb q -> g ph1 ph2       Bt1g1H2
      case(81)
         factor=-1d0/nc**3*facRV            ! g qb -> qb ph1 ph2      Bt1g1H2
      case(82)
         factor=-1d0/nc**3*facRV            ! qb g -> qb ph1 ph2      Bt1g1H2
      case(83)
         factor=-1d0/nc**3*nf*facRV         ! g g subtraction         Bt1g1H2
      case(84)
         factor=-1d0/nc**4*facRV            ! q Q subtraction         Bt1g1H2
      case(85)
         factor=-1d0/nc**4*facRV            ! q Qb subtraction        Bt1g1H2
      case(86)
         factor=-1d0/nc**4*facRV            ! qb Q subtraction        Bt1g1H2
      case(87)
         factor=-1d0/nc**4*facRV            ! qb Qb subtraction       Bt1g1H2
      case(88)
         factor=C1*2d0*facRV                ! g g -> g ph1 ph2        A3g0H2
      case(89)
         factor=C1/nc*facRV                 ! q g -> q ph1 ph2        B1g0H2
      case(90)
         factor=C1/nc*facRV                 ! q qb -> g ph1 ph2       B1g0H2
      case(91)
         factor=C1/nc*facRV                 ! g q -> q ph1 ph2        B1g0H2
      case(92)
         factor=C1/nc*facRV                 ! qb q -> g ph1 ph2       B1g0H2
      case(93)
         factor=C1/nc*facRV                 ! g qb -> qb ph1 ph2      B1g0H2
      case(94)
         factor=C1/nc*facRV                 ! qb g -> qb ph1 ph2      B1g0H2

c -- double virtual

      case(95)
         factor=facVV                       ! g g -> ph1 ph2          A2g2H2
      case(96)
         factor=1d0/nc*facVV                ! g q subtraction         A2g2H2
      case(97)
         factor=1d0/nc*facVV                ! g qb subtraction        A2g2H2
      case(98)
         factor=1d0/nc**2*facVV             ! q Q subtraction         A2g2H2
      case(99)
         factor=1d0/nc**2*facVV             ! q Qb subtraction        A2g2H2
      case(100)
         factor=1d0/nc*facVV                ! q g subtraction         A2g2H2
      case(101)
         factor=1d0/nc**2*facVV             ! qb Q subtraction        A2g2H2
      case(102)
         factor=1d0/nc**2*facVV             ! qb Qb subtraction       A2g2H2
      case(103)
         factor=1d0/nc*facVV                ! qb g subtraction        A2g2H2
      case(104)
         factor=-1d0/nc**2*facVV            ! g g -> ph1 ph2          At2g2H2
      case(105)
         factor=-1d0/nc**3*facVV            ! g q subtraction         At2g2H2
      case(106)
         factor=-1d0/nc**3*facVV            ! g qb subtraction        At2g2H2
      case(107)
         factor=-1d0/nc**4*facVV            ! q Q subtraction         At2g2H2
      case(108)
         factor=-1d0/nc**4*facVV            ! q Qb subtraction        At2g2H2
      case(109)
         factor=-1d0/nc**3*facVV            ! q g subtraction         At2g2H2
      case(110)
         factor=-1d0/nc**4*facVV            ! qb Q subtraction        At2g2H2
      case(111)
         factor=-1d0/nc**4*facVV            ! qb Qb subtraction       At2g2H2
      case(112)
         factor=-1d0/nc**3*facVV            ! qb g subtraction        At2g2H2
      case(113)
         factor=1d0/nc**3*nf*facVV          ! g g -> ph1 ph2          Aht2g2H2
      case(114)
         factor=1d0/nc**4*nf*facVV          ! g q subtraction         Aht2g2H2
      case(115)
         factor=1d0/nc**4*nf*facVV          ! g qb subtraction        Aht2g2H2
      case(116)
         factor=1d0/nc**5*nf*facVV          ! q Q subtraction         Aht2g2H2
      case(117)
         factor=1d0/nc**5*nf*facVV          ! q Qb subtraction        Aht2g2H2
      case(118)
         factor=1d0/nc**4*nf*facVV          ! q g subtraction         Aht2g2H2
      case(119)
         factor=1d0/nc**5*nf*facVV          ! qb Q subtraction        Aht2g2H2
      case(120)
         factor=1d0/nc**5*nf*facVV          ! qb Qb subtraction       Aht2g2H2
      case(121)
         factor=1d0/nc**4*nf*facVV          ! qb g subtraction        Aht2g2H2
      case(122)
         factor=1d0/nc*nf*facVV             ! g g -> ph1 ph2          Ah2g2H2
      case(123)
         factor=1d0/nc**2*nf*facVV          ! g q subtraction         Ah2g2H2
      case(124)
         factor=1d0/nc**2*nf*facVV          ! g qb subtraction        Ah2g2H2
      case(125)
         factor=1d0/nc**3*nf*facVV          ! q Q subtraction         Ah2g2H2
      case(126)
         factor=1d0/nc**3*nf*facVV          ! q Qb subtraction        Ah2g2H2
      case(127)
         factor=1d0/nc**2*nf*facVV          ! q g subtraction         Ah2g2H2
      case(128)
         factor=1d0/nc**3*nf*facVV          ! qb Q subtraction        Ah2g2H2
      case(129)
         factor=1d0/nc**3*nf*facVV          ! qb Qb subtraction       Ah2g2H2
      case(130)
         factor=1d0/nc**2*nf*facVV          ! qb g subtraction        Ah2g2H2
      case(131)
         factor=1d0/nc**2*nf**2*facVV       ! g g -> ph1 ph2          Ahh2g2H2
      case(132)
         factor=1d0/nc**3*nf**2*facVV       ! g q subtraction         Ahh2g2H2
      case(133)
         factor=1d0/nc**3*nf**2*facVV       ! g qb subtraction        Ahh2g2H2
      case(134)
         factor=1d0/nc**4*nf**2*facVV       ! q Q subtraction         Ahh2g2H2
      case(135)
         factor=1d0/nc**4*nf**2*facVV       ! q Qb subtraction        Ahh2g2H2
      case(136)
         factor=1d0/nc**3*nf**2*facVV       ! q g subtraction         Ahh2g2H2
      case(137)
         factor=1d0/nc**4*nf**2*facVV       ! qb Q subtraction        Ahh2g2H2
      case(138)
         factor=1d0/nc**4*nf**2*facVV       ! qb Qb subtraction       Ahh2g2H2
      case(139)
         factor=1d0/nc**3*nf**2*facVV       ! qb g subtraction        Ahh2g2H2
      case(140)
         factor=C1*facVV                    ! g g -> ph1 ph2          A2g1H2
      case(141)
         factor=C1/nc*facVV                 ! g q subtraction         A2g1H2
      case(142)
         factor=C1/nc*facVV                 ! g qb subtraction        A2g1H2
      case(143)
         factor=C1/nc*facVV                 ! q g subtraction         A2g1H2
      case(144)
         factor=C1/nc*facVV                 ! qb g subtraction        A2g1H2
      case(145)
         factor=C1/nc*nf*facVV              ! g g -> ph1 ph2          Ah2g1H2
      case(146)
         factor=C1/nc**2*nf*facVV           ! g q subtraction         Ah2g1H2
      case(147)
         factor=C1/nc**2*nf*facVV           ! g qb subtraction        Ah2g1H2
      case(148)
         factor=C1/nc**2*nf*facVV           ! q g subtraction         Ah2g1H2
      case(149)
         factor=C1/nc**2*nf*facVV           ! qb g subtraction        Ah2g1H2
      case(150)
         factor=C2*facVV                    ! g g -> ph1 ph2          A2g0H2
      case(151)
         factor=C2h*nf*facVV                ! g g -> ph1 ph2          A2g0H2
      end select
      factor=relfactor*factor

      return
      end
