      subroutine getlumiH2J(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    8,   13,   20,   33,   38,   49,   60,          
     &           71,   76,   83,   88,   95,  102,  141,  146,          
     &          155,  166,  177,  188,  195,  202,  259,  264,          
     &          271,  284,  293,  302,  311,  320,  329,  344,          
     &          357,  374,  391,  408,  421,  428,  435,  442,          
     &          447,  458,  469,  480)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,    9,   16,   36,   41,   43,   54,   65,          
     &           77,   84,   91,   98,  105,  115,  125,  133,          
     &          144,  149,  151,  162,  173,  184,  191,  198,          
     &          213,  223,  233,  241,  249,  257,  260,  267,          
     &          289,  298,  307,  316,  325,  334,  338,  351,          
     &          364,  370,  381,  387,  398,  404,  415,  429,          
     &          436,  445,  450,  452,  463,  474)
!       [30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    3,   10,   17,   25,   29,   44,   55,   66,          
     &           78,   85,   92,   99,  108,  118,  126,  134,          
     &          152,  163,  174,  185,  192,  199,  207,  217,          
     &          227,  235,  243,  251,  261,  268,  276,  280,          
     &          339,  352,  365,  382,  399,  416,  430,  437,          
     &          453,  464,  475)
!       [30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    4,   11,   18,   34,   39,   45,   56,   67,          
     &           79,   86,   93,  100,  109,  119,  128,  136,          
     &          142,  147,  153,  164,  175,  186,  193,  200,          
     &          211,  221,  231,  239,  247,  255,  262,  269,          
     &          285,  294,  303,  312,  321,  330,  340,  353,          
     &          366,  372,  383,  389,  400,  406,  417,  431,          
     &          438,  443,  448,  454,  465,  476)
!       [0, 30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (    5,   12,   19,   26,   31,   46,   57,   68,          
     &           80,   87,   94,  101,  110,  120,  129,  137,          
     &          154,  165,  176,  187,  194,  201,  208,  218,          
     &          228,  237,  245,  253,  263,  270,  277,  282,          
     &          341,  354,  367,  384,  401,  418,  432,  439,          
     &          455,  466,  477)
!       [-30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    6,   14,   21,   35,   40,   47,   58,   69,          
     &           81,   89,   96,  103,  111,  121,  130,  138,          
     &          143,  148,  156,  167,  178,  189,  196,  203,          
     &          212,  222,  232,  240,  248,  256,  265,  272,          
     &          286,  295,  304,  313,  322,  331,  342,  355,          
     &          368,  373,  385,  390,  402,  407,  419,  433,          
     &          440,  444,  449,  456,  467,  478)
!       [0, -30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    7,   15,   22,   37,   42,   48,   59,   70,          
     &           82,   90,   97,  104,  112,  122,  131,  139,          
     &          145,  150,  157,  168,  179,  190,  197,  204,          
     &          214,  224,  234,  242,  250,  258,  266,  273,          
     &          292,  301,  310,  319,  328,  337,  343,  356,          
     &          369,  371,  386,  388,  403,  405,  420,  434,          
     &          441,  446,  451,  457,  468,  479)
!       [-30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   23,   51,   62,   73,  106,  116,  159,  170,          
     &          181,  205,  215,  225,  274,  288,  297,  306,          
     &          315,  324,  333,  346,  359,  376,  393,  410,          
     &          423,  460,  471,  482)
!       [31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   24,   50,   61,   72,  107,  117,  127,  158,          
     &          169,  180,  206,  216,  226,  275,  287,  296,          
     &          305,  314,  323,  332,  345,  358,  375,  392,          
     &          409,  422,  459,  470,  481)
!       [31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   27,   53,   64,   75,  113,  123,  132,  161,          
     &          172,  183,  209,  219,  229,  278,  291,  300,          
     &          309,  318,  327,  336,  349,  362,  379,  396,          
     &          413,  426,  462,  473,  484)
!       [-31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   28,   52,   63,   74,  114,  124,  160,  171,          
     &          182,  210,  220,  230,  279,  290,  299,  308,          
     &          317,  326,  335,  348,  361,  378,  395,  412,          
     &          425,  461,  472,  483)
!       [-31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   30,  135,  236,  244,  252,  281,  347,  360,          
     &          377,  394,  411,  424)
!       [30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   32,  140,  238,  246,  254,  283,  350,  363,          
     &          380,  397,  414,  427)
!       [-30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case default
          print*, "getlumiH2J: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiH2J



      function getlumiidH2J(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    8,   13,   20,   33,   38,   49,   60,
     &           71,   76,   83,   88,   95,  102,  141,  146,
     &          155,  166,  177,  188,  195,  202,  259,  264,
     &          271,  284,  293,  302,  311,  320,  329,  344,
     &          357,  374,  391,  408,  421,  428,  435,  442,
     &          447,  458,  469,  480)
          id  = 1
          ip1 = 0
          ip2 = 0

        case (    2,    9,   16,   36,   41,   43,   54,   65,
     &           77,   84,   91,   98,  105,  115,  125,  133,
     &          144,  149,  151,  162,  173,  184,  191,  198,
     &          213,  223,  233,  241,  249,  257,  260,  267,
     &          289,  298,  307,  316,  325,  334,  338,  351,
     &          364,  370,  381,  387,  398,  404,  415,  429,
     &          436,  445,  450,  452,  463,  474)
          id  = 2
          ip1 = 30
          ip2 = 0

        case (    3,   10,   17,   25,   29,   44,   55,   66,
     &           78,   85,   92,   99,  108,  118,  126,  134,
     &          152,  163,  174,  185,  192,  199,  207,  217,
     &          227,  235,  243,  251,  261,  268,  276,  280,
     &          339,  352,  365,  382,  399,  416,  430,  437,
     &          453,  464,  475)
          id  = 3
          ip1 = 30
          ip2 = -30

        case (    4,   11,   18,   34,   39,   45,   56,   67,
     &           79,   86,   93,  100,  109,  119,  128,  136,
     &          142,  147,  153,  164,  175,  186,  193,  200,
     &          211,  221,  231,  239,  247,  255,  262,  269,
     &          285,  294,  303,  312,  321,  330,  340,  353,
     &          366,  372,  383,  389,  400,  406,  417,  431,
     &          438,  443,  448,  454,  465,  476)
          id  = 4
          ip1 = 0
          ip2 = 30

        case (    5,   12,   19,   26,   31,   46,   57,   68,
     &           80,   87,   94,  101,  110,  120,  129,  137,
     &          154,  165,  176,  187,  194,  201,  208,  218,
     &          228,  237,  245,  253,  263,  270,  277,  282,
     &          341,  354,  367,  384,  401,  418,  432,  439,
     &          455,  466,  477)
          id  = 5
          ip1 = -30
          ip2 = 30

        case (    6,   14,   21,   35,   40,   47,   58,   69,
     &           81,   89,   96,  103,  111,  121,  130,  138,
     &          143,  148,  156,  167,  178,  189,  196,  203,
     &          212,  222,  232,  240,  248,  256,  265,  272,
     &          286,  295,  304,  313,  322,  331,  342,  355,
     &          368,  373,  385,  390,  402,  407,  419,  433,
     &          440,  444,  449,  456,  467,  478)
          id  = 6
          ip1 = 0
          ip2 = -30

        case (    7,   15,   22,   37,   42,   48,   59,   70,
     &           82,   90,   97,  104,  112,  122,  131,  139,
     &          145,  150,  157,  168,  179,  190,  197,  204,
     &          214,  224,  234,  242,  250,  258,  266,  273,
     &          292,  301,  310,  319,  328,  337,  343,  356,
     &          369,  371,  386,  388,  403,  405,  420,  434,
     &          441,  446,  451,  457,  468,  479)
          id  = 7
          ip1 = -30
          ip2 = 0

        case (   23,   51,   62,   73,  106,  116,  159,  170,
     &          181,  205,  215,  225,  274,  288,  297,  306,
     &          315,  324,  333,  346,  359,  376,  393,  410,
     &          423,  460,  471,  482)
          id  = 8
          ip1 = 31
          ip2 = -31

        case (   24,   50,   61,   72,  107,  117,  127,  158,
     &          169,  180,  206,  216,  226,  275,  287,  296,
     &          305,  314,  323,  332,  345,  358,  375,  392,
     &          409,  422,  459,  470,  481)
          id  = 9
          ip1 = 31
          ip2 = 31

        case (   27,   53,   64,   75,  113,  123,  132,  161,
     &          172,  183,  209,  219,  229,  278,  291,  300,
     &          309,  318,  327,  336,  349,  362,  379,  396,
     &          413,  426,  462,  473,  484)
          id  = 10
          ip1 = -31
          ip2 = -31

        case (   28,   52,   63,   74,  114,  124,  160,  171,
     &          182,  210,  220,  230,  279,  290,  299,  308,
     &          317,  326,  335,  348,  361,  378,  395,  412,
     &          425,  461,  472,  483)
          id  = 11
          ip1 = -31
          ip2 = 31

        case (   30,  135,  236,  244,  252,  281,  347,  360,
     &          377,  394,  411,  424)
          id  = 12
          ip1 = 30
          ip2 = 30

        case (   32,  140,  238,  246,  254,  283,  350,  363,
     &          380,  397,  414,  427)
          id  = 13
          ip1 = -30
          ip2 = -30

        case default
          print*, "getlumiidH2J: invalid iproc:", iproc
          stop
        end select

      end function getlumiidH2J





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiH2J()
        use PineAPPL_mod
        use CKM_mod
!       [0, 0]
        call register_lumi_pine(
     &         [    1,    8,   13,   20,   33,   38,   49,   60,
     &             71,   76,   83,   88,   95,  102,  141,  146,
     &            155,  166,  177,  188,  195,  202,  259,  264,
     &            271,  284,  293,  302,  311,  320,  329,  344,
     &            357,  374,  391,  408,  421,  428,  435,  442,
     &            447,  458,  469,  480],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [30, 0]
        call register_lumi_pine(
     &         [    2,    9,   16,   36,   41,   43,   54,   65,
     &             77,   84,   91,   98,  105,  115,  125,  133,
     &            144,  149,  151,  162,  173,  184,  191,  198,
     &            213,  223,  233,  241,  249,  257,  260,  267,
     &            289,  298,  307,  316,  325,  334,  338,  351,
     &            364,  370,  381,  387,  398,  404,  415,  429,
     &            436,  445,  450,  452,  463,  474],
     &         5,
     &         [    1,   21,    2,   21,    3,   21,    4,   21,
     &              5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [30, -30]
        call register_lumi_pine(
     &         [    3,   10,   17,   25,   29,   44,   55,   66,
     &             78,   85,   92,   99,  108,  118,  126,  134,
     &            152,  163,  174,  185,  192,  199,  207,  217,
     &            227,  235,  243,  251,  261,  268,  276,  280,
     &            339,  352,  365,  382,  399,  416,  430,  437,
     &            453,  464,  475],
     &         5,
     &         [    1,   -1,    2,   -2,    3,   -3,    4,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, 30]
        call register_lumi_pine(
     &         [    4,   11,   18,   34,   39,   45,   56,   67,
     &             79,   86,   93,  100,  109,  119,  128,  136,
     &            142,  147,  153,  164,  175,  186,  193,  200,
     &            211,  221,  231,  239,  247,  255,  262,  269,
     &            285,  294,  303,  312,  321,  330,  340,  353,
     &            366,  372,  383,  389,  400,  406,  417,  431,
     &            438,  443,  448,  454,  465,  476],
     &         5,
     &         [   21,    1,   21,    2,   21,    3,   21,    4,
     &             21,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 30]
        call register_lumi_pine(
     &         [    5,   12,   19,   26,   31,   46,   57,   68,
     &             80,   87,   94,  101,  110,  120,  129,  137,
     &            154,  165,  176,  187,  194,  201,  208,  218,
     &            228,  237,  245,  253,  263,  270,  277,  282,
     &            341,  354,  367,  384,  401,  418,  432,  439,
     &            455,  466,  477],
     &         5,
     &         [   -1,    1,   -2,    2,   -3,    3,   -4,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, -30]
        call register_lumi_pine(
     &         [    6,   14,   21,   35,   40,   47,   58,   69,
     &             81,   89,   96,  103,  111,  121,  130,  138,
     &            143,  148,  156,  167,  178,  189,  196,  203,
     &            212,  222,  232,  240,  248,  256,  265,  272,
     &            286,  295,  304,  313,  322,  331,  342,  355,
     &            368,  373,  385,  390,  402,  407,  419,  433,
     &            440,  444,  449,  456,  467,  478],
     &         5,
     &         [   21,   -1,   21,   -2,   21,   -3,   21,   -4,
     &             21,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 0]
        call register_lumi_pine(
     &         [    7,   15,   22,   37,   42,   48,   59,   70,
     &             82,   90,   97,  104,  112,  122,  131,  139,
     &            145,  150,  157,  168,  179,  190,  197,  204,
     &            214,  224,  234,  242,  250,  258,  266,  273,
     &            292,  301,  310,  319,  328,  337,  343,  356,
     &            369,  371,  386,  388,  403,  405,  420,  434,
     &            441,  446,  451,  457,  468,  479],
     &         5,
     &         [   -1,   21,   -2,   21,   -3,   21,   -4,   21,
     &             -5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [31, -31]
        call register_lumi_pine(
     &         [   23,   51,   62,   73,  106,  116,  159,  170,
     &            181,  205,  215,  225,  274,  288,  297,  306,
     &            315,  324,  333,  346,  359,  376,  393,  410,
     &            423,  460,  471,  482],
     &         25,
     &         [    1,   -1,    1,   -2,    1,   -3,    1,   -4,
     &              1,   -5,    2,   -1,    2,   -2,    2,   -3,
     &              2,   -4,    2,   -5,    3,   -1,    3,   -2,
     &              3,   -3,    3,   -4,    3,   -5,    4,   -1,
     &              4,   -2,    4,   -3,    4,   -4,    4,   -5,
     &              5,   -1,    5,   -2,    5,   -3,    5,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [31, 31]
        call register_lumi_pine(
     &         [   24,   50,   61,   72,  107,  117,  127,  158,
     &            169,  180,  206,  216,  226,  275,  287,  296,
     &            305,  314,  323,  332,  345,  358,  375,  392,
     &            409,  422,  459,  470,  481],
     &         25,
     &         [    1,    1,    1,    2,    1,    3,    1,    4,
     &              1,    5,    2,    1,    2,    2,    2,    3,
     &              2,    4,    2,    5,    3,    1,    3,    2,
     &              3,    3,    3,    4,    3,    5,    4,    1,
     &              4,    2,    4,    3,    4,    4,    4,    5,
     &              5,    1,    5,    2,    5,    3,    5,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, -31]
        call register_lumi_pine(
     &         [   27,   53,   64,   75,  113,  123,  132,  161,
     &            172,  183,  209,  219,  229,  278,  291,  300,
     &            309,  318,  327,  336,  349,  362,  379,  396,
     &            413,  426,  462,  473,  484],
     &         25,
     &         [   -1,   -1,   -1,   -2,   -1,   -3,   -1,   -4,
     &             -1,   -5,   -2,   -1,   -2,   -2,   -2,   -3,
     &             -2,   -4,   -2,   -5,   -3,   -1,   -3,   -2,
     &             -3,   -3,   -3,   -4,   -3,   -5,   -4,   -1,
     &             -4,   -2,   -4,   -3,   -4,   -4,   -4,   -5,
     &             -5,   -1,   -5,   -2,   -5,   -3,   -5,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, 31]
        call register_lumi_pine(
     &         [   28,   52,   63,   74,  114,  124,  160,  171,
     &            182,  210,  220,  230,  279,  290,  299,  308,
     &            317,  326,  335,  348,  361,  378,  395,  412,
     &            425,  461,  472,  483],
     &         25,
     &         [   -1,    1,   -1,    2,   -1,    3,   -1,    4,
     &             -1,    5,   -2,    1,   -2,    2,   -2,    3,
     &             -2,    4,   -2,    5,   -3,    1,   -3,    2,
     &             -3,    3,   -3,    4,   -3,    5,   -4,    1,
     &             -4,    2,   -4,    3,   -4,    4,   -4,    5,
     &             -5,    1,   -5,    2,   -5,    3,   -5,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [30, 30]
        call register_lumi_pine(
     &         [   30,  135,  236,  244,  252,  281,  347,  360,
     &            377,  394,  411,  424],
     &         5,
     &         [    1,    1,    2,    2,    3,    3,    4,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, -30]
        call register_lumi_pine(
     &         [   32,  140,  238,  246,  254,  283,  350,  363,
     &            380,  397,  414,  427],
     &         5,
     &         [   -1,   -1,   -2,   -2,   -3,   -3,   -4,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiH2J


#endif


