      function sigTNLOH2J(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLOH2J=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- g g to g ph1 ph2    
        if (qactive_chan(33).and.qselect_chan(33)) then
          current_chan = 33
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggA3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(34).and.qselect_chan(34)) then
          current_chan = 34
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqA3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(35).and.qselect_chan(35)) then
          current_chan = 35
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbA3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(36).and.qselect_chan(36)) then
          current_chan = 36
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgA3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(37).and.qselect_chan(37)) then
          current_chan = 37
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgA3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g ph1 ph2    
        if (qactive_chan(38).and.qselect_chan(38)) then
          current_chan = 38
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggAh3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(39).and.qselect_chan(39)) then
          current_chan = 39
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqAh3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(40).and.qselect_chan(40)) then
          current_chan = 40
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbAh3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(41).and.qselect_chan(41)) then
          current_chan = 41
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgAh3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(42).and.qselect_chan(42)) then
          current_chan = 42
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgAh3g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q ph1 ph2    
        if (qactive_chan(43).and.qselect_chan(43)) then
          current_chan = 43
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgB1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g ph1 ph2   
        if (qactive_chan(44).and.qselect_chan(44)) then
          current_chan = 44
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbB1g1H2TNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q ph1 ph2    
        if (qactive_chan(45).and.qselect_chan(45)) then
          current_chan = 45
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqB1g1H2TNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g ph1 ph2   
        if (qactive_chan(46).and.qselect_chan(46)) then
          current_chan = 46
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqB1g1H2TNLO(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb ph1 ph2  
        if (qactive_chan(47).and.qselect_chan(47)) then
          current_chan = 47
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbB1g1H2TNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb ph1 ph2  
        if (qactive_chan(48).and.qselect_chan(48)) then
          current_chan = 48
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgB1g1H2TNLO(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(49).and.qselect_chan(49)) then
          current_chan = 49
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggB1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(50).and.qselect_chan(50)) then
          current_chan = 50
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpB1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(51).and.qselect_chan(51)) then
          current_chan = 51
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbB1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(52).and.qselect_chan(52)) then
          current_chan = 52
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpB1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(53).and.qselect_chan(53)) then
          current_chan = 53
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbB1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q ph1 ph2    
        if (qactive_chan(54).and.qselect_chan(54)) then
          current_chan = 54
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgBh1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g ph1 ph2   
        if (qactive_chan(55).and.qselect_chan(55)) then
          current_chan = 55
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBh1g1H2TNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q ph1 ph2    
        if (qactive_chan(56).and.qselect_chan(56)) then
          current_chan = 56
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqBh1g1H2TNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g ph1 ph2   
        if (qactive_chan(57).and.qselect_chan(57)) then
          current_chan = 57
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBh1g1H2TNLO(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb ph1 ph2  
        if (qactive_chan(58).and.qselect_chan(58)) then
          current_chan = 58
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbBh1g1H2TNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb ph1 ph2  
        if (qactive_chan(59).and.qselect_chan(59)) then
          current_chan = 59
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgBh1g1H2TNLO(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(60).and.qselect_chan(60)) then
          current_chan = 60
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggBh1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(61).and.qselect_chan(61)) then
          current_chan = 61
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpBh1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(62).and.qselect_chan(62)) then
          current_chan = 62
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBh1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(63).and.qselect_chan(63)) then
          current_chan = 63
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBh1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(64).and.qselect_chan(64)) then
          current_chan = 64
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBh1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q ph1 ph2    
        if (qactive_chan(65).and.qselect_chan(65)) then
          current_chan = 65
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgBt1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g ph1 ph2   
        if (qactive_chan(66).and.qselect_chan(66)) then
          current_chan = 66
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBt1g1H2TNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q ph1 ph2    
        if (qactive_chan(67).and.qselect_chan(67)) then
          current_chan = 67
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqBt1g1H2TNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g ph1 ph2   
        if (qactive_chan(68).and.qselect_chan(68)) then
          current_chan = 68
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBt1g1H2TNLO(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb ph1 ph2  
        if (qactive_chan(69).and.qselect_chan(69)) then
          current_chan = 69
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbBt1g1H2TNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb ph1 ph2  
        if (qactive_chan(70).and.qselect_chan(70)) then
          current_chan = 70
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgBt1g1H2TNLO(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(71).and.qselect_chan(71)) then
          current_chan = 71
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggBt1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(72).and.qselect_chan(72)) then
          current_chan = 72
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpBt1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(73).and.qselect_chan(73)) then
          current_chan = 73
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBt1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(74).and.qselect_chan(74)) then
          current_chan = 74
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBt1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(75).and.qselect_chan(75)) then
          current_chan = 75
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBt1g1H2TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g ph1 ph2 wilson
        if (qactive_chan(76).and.qselect_chan(76)) then
          current_chan = 76
          ip1_chan     = 0
          ip2_chan     = 0
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- q g to q ph1 ph2 wilson
        if (qactive_chan(77).and.qselect_chan(77)) then
          current_chan = 77
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- q qb to g ph1 ph2 wilson
        if (qactive_chan(78).and.qselect_chan(78)) then
          current_chan = 78
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- g q to q ph1 ph2 wilson
        if (qactive_chan(79).and.qselect_chan(79)) then
          current_chan = 79
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- qb q to g ph1 ph2 wilson
        if (qactive_chan(80).and.qselect_chan(80)) then
          current_chan = 80
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- g qb to qb ph1 ph2 wilson
        if (qactive_chan(81).and.qselect_chan(81)) then
          current_chan = 81
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- qb g to qb ph1 ph2 wilson
        if (qactive_chan(82).and.qselect_chan(82)) then
          current_chan = 82
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
        sigTNLOH2J=sigTNLOH2J+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
