      subroutine getqcdnormH2JJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtH2JJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVH2JJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourH2JJ(current_chan)
         do isub = 1, nflavourH2JJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_H2JJ(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=H2JJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      v=246.21846d0
      C0=(alphas_scl/6d0/pi/v)**2
      C1=11d0/3d0
* C1 = 7/2 + 3/2/nc**2
      dlstop = 0d0
      do iscl=1,nAct_scl
        idmap = idmap_scl(iscl, withR=.true.)
        if (idmap == iscl) then
          if (mt_scheme_param() == id_mass_scheme_MSbar) then
            dlstop(iscl) = 2d0*log(muR_scl(iscl)/mt_param(muR_scl(iscl)))
          else
            dlstop(iscl) = 2d0*log(muR_scl(iscl)/mt_param())
          end if
        else
          dlstop(iscl) = dlstop(idmap)
        end if
      end do
      C2=1933d0/162d0 + 19d0/18d0*dlstop
* C2 = 91/12/nc**2 + 9/4/nc**4 + 1/6/nc**3 - 3/8/nc + 805/72 + 11/4*dlstop/nc**2 + 3/4*dlstop
      C2h=(1d0/3d0)*(-67d0/36d0 + 8d0/9d0*dlstop)
* C2h = 5/8/nc**3 - 139/72/nc - dlstop/nc**3 + dlstop/nc
      facB=ave*C0*(nc**2d0-1d0)*nc**2*(4d0*pi*alphas_scl)**2
      if((amzW.eq.0).or.(stw.eq.0))then
         call initeweak
      endif
      gwsq=4d0*pi*amzW/stw
      select case ( name_proc )
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTO2TAUM','HTO2TAUJM')
        Cew=gwsq
      case default
        Cew=1d0
      end select
      facB=facB*Cew
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=2d0*1d0/2d0*facB            ! g g -> g g ph1 ph2      A4g0H2
      case(2)
         factor=1d0/nc*facB                 ! q g -> g q ph1 ph2      B2g0H2
      case(3)
         factor=1d0/nc*1d0/2d0*facB         ! q qb -> g g ph1 ph2     B2g0H2
      case(4)
         factor=1d0/nc*facB                 ! g q -> g q ph1 ph2      B2g0H2
      case(5)
         factor=1d0/nc*1d0/2d0*facB         ! qb q -> g g ph1 ph2     B2g0H2
      case(6)
         factor=1d0/nc*nf*facB              ! g g -> qb q ph1 ph2     B2g0H2
      case(7)
         factor=1d0/nc*facB                 ! g qb -> qb g ph1 ph2     B2g0H2
      case(8)
         factor=1d0/nc*facB                 ! qb g -> qb g ph1 ph2     B2g0H2
      case(9)
         factor=-1d0/nc**3*facB             ! q gt -> gt q ph1 ph2     Bt2g0H2
      case(10)
         factor=-1d0/nc**3*1d0/2d0*facB     ! q qb -> gt gt ph1 ph2     Bt2g0H2
      case(11)
         factor=-1d0/nc**3*facB             ! gt q -> gt q ph1 ph2     Bt2g0H2
      case(12)
         factor=-1d0/nc**3*1d0/2d0*facB     ! qb q -> gt gt ph1 ph2     Bt2g0H2
      case(13)
         factor=-1d0/nc**3*nf*facB          ! gt gt -> qb q ph1 ph2     Bt2g0H2
      case(14)
         factor=-1d0/nc**3*facB             ! gt qb -> qb gt ph1 ph2     Bt2g0H2
      case(15)
         factor=-1d0/nc**3*facB             ! qb gt -> qb gt ph1 ph2     Bt2g0H2
      case(16)
         factor=1d0/nc**2*facB              ! q Qb -> Qb q ph1 ph2     C0g0H2
      case(17)
         factor=1d0/nc**2*facB              ! q Q -> Q q ph1 ph2      C0g0H2
      case(18)
         factor=1d0/nc**2*nf*facB           ! q qb -> Q Qb ph1 ph2     C0g0H2
      case(19)
         factor=1d0/nc**2*nf*facB           ! qb q -> Q Qb ph1 ph2     C0g0H2
      case(20)
         factor=1d0/nc**2*facB              ! qb Qb -> qb Qb ph1 ph2     C0g0H2
      case(21)
         factor=1d0/nc**2*facB              ! qb Q -> qb Q ph1 ph2     C0g0H2
      case(22)
         factor=-1d0/nc**3*facB             ! q qb -> qb q ph1 ph2     D0g0H2
      case(23)
         factor=-1d0/nc**3*1d0/2d0*facB     ! q q -> q q ph1 ph2      D0g0H2
      case(24)
         factor=-1d0/nc**3*facB             ! qb q -> qb q ph1 ph2     D0g0H2
      case(25)
         factor=-1d0/nc**3*1d0/2d0*facB     ! qb qb -> qb qb ph1 ph2     D0g0H2

c -- real

      case(26)
         factor=2d0*1d0/6d0*facR            ! g g -> g g g ph1 ph2     A5g0H2
      case(27)
         factor=1d0/nc*1d0/2d0*facR         ! q g -> g g q ph1 ph2     B3g0H2
      case(28)
         factor=1d0/nc*1d0/6d0*facR         ! q qb -> g g g ph1 ph2     B3g0H2
      case(29)
         factor=1d0/nc*1d0/2d0*facR         ! g q -> g g q ph1 ph2     B3g0H2
      case(30)
         factor=1d0/nc*1d0/6d0*facR         ! qb q -> g g g ph1 ph2     B3g0H2
      case(31)
         factor=1d0/nc*nf*facR              ! g g -> qb g q ph1 ph2     B3g0H2
      case(32)
         factor=1d0/nc*1d0/2d0*facR         ! g qb -> qb g g ph1 ph2     B3g0H2
      case(33)
         factor=1d0/nc*1d0/2d0*facR         ! qb g -> qb g g ph1 ph2     B3g0H2
      case(34)
         factor=-1d0/nc**3*1d0/2d0*facR     ! q g -> g g q ph1 ph2     Bt3g0H2
      case(35)
         factor=-1d0/nc**3*1d0/6d0*facR     ! q qb -> g g g ph1 ph2     Bt3g0H2
      case(36)
         factor=-1d0/nc**3*1d0/2d0*facR     ! g q -> g g q ph1 ph2     Bt3g0H2
      case(37)
         factor=-1d0/nc**3*1d0/6d0*facR     ! qb q -> g g g ph1 ph2     Bt3g0H2
      case(38)
         factor=-1d0/nc**3*nf*facR          ! g g -> qb g q ph1 ph2     Bt3g0H2
      case(39)
         factor=-1d0/nc**3*1d0/2d0*facR     ! g qb -> qb g g ph1 ph2     Bt3g0H2
      case(40)
         factor=-1d0/nc**3*1d0/2d0*facR     ! qb g -> qb g g ph1 ph2     Bt3g0H2
      case(41)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facR   ! q gt -> gt gt q ph1 ph2     Btt3g0H2
      case(42)
         factor=(nc**2+1d0)/nc**5*1d0/6d0*facR   ! q qb -> gt gt gt ph1 ph2     Btt3g0H2
      case(43)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facR   ! gt q -> gt gt q ph1 ph2     Btt3g0H2
      case(44)
         factor=(nc**2+1d0)/nc**5*1d0/6d0*facR   ! qb q -> gt gt gt ph1 ph2     Btt3g0H2
      case(45)
         factor=(nc**2+1d0)/nc**5*nf*facR   ! gt gt -> qb gt q ph1 ph2     Btt3g0H2
      case(46)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facR   ! gt qb -> qb gt gt ph1 ph2     Btt3g0H2
      case(47)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facR   ! qb gt -> qb gt gt ph1 ph2     Btt3g0H2
      case(48)
         factor=1d0/nc**2*nf*facR           ! q g -> Q Qb q ph1 ph2     C1g0H2F
      case(49)
         factor=1d0/nc**2*facR              ! q Qb -> g Qb q ph1 ph2     C1g0H2F
      case(50)
         factor=1d0/nc**2*facR              ! q Q -> g Q q ph1 ph2     C1g0H2F
      case(51)
         factor=1d0/nc**2*nf*facR           ! q qb -> g Q Qb ph1 ph2     C1g0H2F
      case(52)
         factor=1d0/nc**2*nf*facR           ! g q -> Q Qb q ph1 ph2     C1g0H2F
      case(53)
         factor=1d0/nc**2*nf*facR           ! qb q -> g Q Qb ph1 ph2     C1g0H2F
      case(54)
         factor=1d0/nc**2*nf*facR           ! g qb -> qb Q Qb ph1 ph2     C1g0H2F
      case(55)
         factor=1d0/nc**2*nf*facR           ! qb g -> qb Q Qb ph1 ph2     C1g0H2F
      case(56)
         factor=1d0/nc**2*facR              ! qb Qb -> qb g Qb ph1 ph2     C1g0H2F
      case(57)
         factor=1d0/nc**2*facR              ! qb Q -> qb g Q ph1 ph2     C1g0H2F
      case(58)
         factor=1d0/nc**4*nf*facR           ! q g -> Q Qb q ph1 ph2     Ct1g0H2F
      case(59)
         factor=1d0/nc**4*facR              ! q Qb -> g Qb q ph1 ph2     Ct1g0H2F
      case(60)
         factor=1d0/nc**4*facR              ! q Q -> g Q q ph1 ph2     Ct1g0H2F
      case(61)
         factor=1d0/nc**4*nf*facR           ! q qb -> g Q Qb ph1 ph2     Ct1g0H2F
      case(62)
         factor=1d0/nc**4*nf*facR           ! g q -> Q Qb q ph1 ph2     Ct1g0H2F
      case(63)
         factor=1d0/nc**4*nf*facR           ! qb q -> g Q Qb ph1 ph2     Ct1g0H2F
      case(64)
         factor=1d0/nc**4*nf*facR           ! g qb -> qb Q Qb ph1 ph2     Ct1g0H2F
      case(65)
         factor=1d0/nc**4*nf*facR           ! qb g -> qb Q Qb ph1 ph2     Ct1g0H2F
      case(66)
         factor=1d0/nc**4*facR              ! qb Qb -> qb g Qb ph1 ph2     Ct1g0H2F
      case(67)
         factor=1d0/nc**4*facR              ! qb Q -> qb g Q ph1 ph2     Ct1g0H2F
      case(68)
         factor=-1d0/nc**3*1d0/2d0*facR     ! q g -> q qb q ph1 ph2     D1g0H2F
      case(69)
         factor=-1d0/nc**3*facR             ! q qb -> g qb q ph1 ph2     D1g0H2F
      case(70)
         factor=-1d0/nc**3*1d0/2d0*facR     ! q q -> g q q ph1 ph2     D1g0H2F
      case(71)
         factor=-1d0/nc**3*1d0/2d0*facR     ! g q -> q qb q ph1 ph2     D1g0H2F
      case(72)
         factor=-1d0/nc**3*facR             ! qb q -> g qb q ph1 ph2     D1g0H2F
      case(73)
         factor=-1d0/nc**3*1d0/2d0*facR     ! g qb -> qb qb q ph1 ph2     D1g0H2F
      case(74)
         factor=-1d0/nc**3*1d0/2d0*facR     ! qb g -> qb qb q ph1 ph2     D1g0H2F
      case(75)
         factor=-1d0/nc**3*1d0/2d0*facR     ! qb qb -> qb g qb ph1 ph2     D1g0H2F
      case(76)
         factor=1d0/nc**5*1d0/2d0*facR      ! q g -> q qb q ph1 ph2     Dt1g0H2
      case(77)
         factor=1d0/nc**5*facR              ! q qb -> g qb q ph1 ph2     Dt1g0H2
      case(78)
         factor=1d0/nc**5*1d0/2d0*facR      ! q q -> g q q ph1 ph2     Dt1g0H2
      case(79)
         factor=1d0/nc**5*1d0/2d0*facR      ! g q -> q qb q ph1 ph2     Dt1g0H2
      case(80)
         factor=1d0/nc**5*facR              ! qb q -> g qb q ph1 ph2     Dt1g0H2
      case(81)
         factor=1d0/nc**5*1d0/2d0*facR      ! g qb -> qb qb q ph1 ph2     Dt1g0H2
      case(82)
         factor=1d0/nc**5*1d0/2d0*facR      ! qb g -> qb qb q ph1 ph2     Dt1g0H2
      case(83)
         factor=1d0/nc**5*1d0/2d0*facR      ! qb qb -> qb g qb ph1 ph2     Dt1g0H2

c -- virtual

      case(84)
         factor=2d0*1d0/2d0*facV            ! g g -> g g ph1 ph2      A4g1H2
      case(85)
         factor=1d0/nc*facV                 ! g q subtraction         A4g1H2
      case(86)
         factor=1d0/nc*facV                 ! g qb subtraction        A4g1H2
      case(87)
         factor=1d0/nc*facV                 ! q g subtraction         A4g1H2
      case(88)
         factor=1d0/nc*facV                 ! qb g subtraction        A4g1H2
      case(89)
         factor=1d0/nc*nf*2d0*1d0/2d0*facV   ! g g -> g g ph1 ph2      Ah4g1H2
      case(90)
         factor=1d0/nc**2*nf*facV           ! g q subtraction         Ah4g1H2
      case(91)
         factor=1d0/nc**2*nf*facV           ! g qb subtraction        Ah4g1H2
      case(92)
         factor=1d0/nc**2*nf*facV           ! q g subtraction         Ah4g1H2
      case(93)
         factor=1d0/nc**2*nf*facV           ! qb g subtraction        Ah4g1H2
      case(94)
         factor=1d0/nc*facV                 ! q g -> g q ph1 ph2      B2g1H2
      case(95)
         factor=1d0/nc*1d0/2d0*facV         ! q qb -> g g ph1 ph2     B2g1H2
      case(96)
         factor=1d0/nc*facV                 ! g q -> g q ph1 ph2      B2g1H2
      case(97)
         factor=1d0/nc*1d0/2d0*facV         ! qb q -> g g ph1 ph2     B2g1H2
      case(98)
         factor=1d0/nc*nf*facV              ! g g -> qb q ph1 ph2     B2g1H2
      case(99)
         factor=1d0/nc*facV                 ! g qb -> qb g ph1 ph2     B2g1H2
      case(100)
         factor=1d0/nc*facV                 ! qb g -> qb g ph1 ph2     B2g1H2
      case(101)
         factor=1d0/nc**2*facV              ! q Q subtraction         B2g1H2
      case(102)
         factor=1d0/nc**2*facV              ! q Qb subtraction        B2g1H2
      case(103)
         factor=1d0/nc**2*facV              ! qb Q subtraction        B2g1H2
      case(104)
         factor=1d0/nc**2*facV              ! qb Qb subtraction       B2g1H2
      case(105)
         factor=1d0/nc**2*nf*facV           ! q g -> g q ph1 ph2      Bh2g1H2
      case(106)
         factor=1d0/nc**2*nf*1d0/2d0*facV   ! q qb -> g g ph1 ph2     Bh2g1H2
      case(107)
         factor=1d0/nc**2*nf*facV           ! g q -> g q ph1 ph2      Bh2g1H2
      case(108)
         factor=1d0/nc**2*nf*1d0/2d0*facV   ! qb q -> g g ph1 ph2     Bh2g1H2
      case(109)
         factor=1d0/nc**2*nf*nf*facV        ! g g -> qb q ph1 ph2     Bh2g1H2
      case(110)
         factor=1d0/nc**2*nf*facV           ! g qb -> qb g ph1 ph2     Bh2g1H2
      case(111)
         factor=1d0/nc**2*nf*facV           ! qb g -> qb g ph1 ph2     Bh2g1H2
      case(112)
         factor=1d0/nc**3*nf*facV           ! q Q subtraction         Bh2g1H2
      case(113)
         factor=1d0/nc**3*nf*facV           ! q Qb subtraction        Bh2g1H2
      case(114)
         factor=1d0/nc**3*nf*facV           ! qb Q subtraction        Bh2g1H2
      case(115)
         factor=1d0/nc**3*nf*facV           ! qb Qb subtraction       Bh2g1H2
      case(116)
         factor=-1d0/nc**3*facV             ! q g -> g q ph1 ph2      Bt2g1H2
      case(117)
         factor=-1d0/nc**3*1d0/2d0*facV     ! q qb -> g g ph1 ph2     Bt2g1H2
      case(118)
         factor=-1d0/nc**3*facV             ! g q -> g q ph1 ph2      Bt2g1H2
      case(119)
         factor=-1d0/nc**3*1d0/2d0*facV     ! qb q -> g g ph1 ph2     Bt2g1H2
      case(120)
         factor=-1d0/nc**3*nf*facV          ! g g -> qb q ph1 ph2     Bt2g1H2
      case(121)
         factor=-1d0/nc**3*facV             ! g qb -> qb g ph1 ph2     Bt2g1H2
      case(122)
         factor=-1d0/nc**3*facV             ! qb g -> qb g ph1 ph2     Bt2g1H2
      case(123)
         factor=-1d0/nc**4*facV             ! q Q subtraction         Bt2g1H2
      case(124)
         factor=-1d0/nc**4*facV             ! q Qb subtraction        Bt2g1H2
      case(125)
         factor=-1d0/nc**4*facV             ! qb Q subtraction        Bt2g1H2
      case(126)
         factor=-1d0/nc**4*facV             ! qb Qb subtraction       Bt2g1H2
      case(127)
         factor=-1d0/nc**3*facV             ! q gt -> gt q ph1 ph2     Btt2g1H2F
      case(128)
         factor=-1d0/nc**3*1d0/2d0*facV     ! q qb -> gt gt ph1 ph2     Btt2g1H2F
      case(129)
         factor=-1d0/nc**3*facV             ! gt q -> gt q ph1 ph2     Btt2g1H2F
      case(130)
         factor=-1d0/nc**3*1d0/2d0*facV     ! qb q -> gt gt ph1 ph2     Btt2g1H2F
      case(131)
         factor=-1d0/nc**3*nf*facV          ! gt gt -> qb q ph1 ph2     Btt2g1H2F
      case(132)
         factor=-1d0/nc**3*facV             ! gt qb -> qb gt ph1 ph2     Btt2g1H2F
      case(133)
         factor=-1d0/nc**3*facV             ! qb gt -> qb gt ph1 ph2     Btt2g1H2F
      case(134)
         factor=1d0/nc**5*facV              ! q gt -> gt q ph1 ph2     Bttt2g1H2
      case(135)
         factor=1d0/nc**5*1d0/2d0*facV      ! q qb -> gt gt ph1 ph2     Bttt2g1H2
      case(136)
         factor=1d0/nc**5*facV              ! gt q -> gt q ph1 ph2     Bttt2g1H2
      case(137)
         factor=1d0/nc**5*1d0/2d0*facV      ! qb q -> gt gt ph1 ph2     Bttt2g1H2
      case(138)
         factor=1d0/nc**5*nf*facV           ! gt gt -> qb q ph1 ph2     Bttt2g1H2
      case(139)
         factor=1d0/nc**5*facV              ! gt qb -> qb gt ph1 ph2     Bttt2g1H2
      case(140)
         factor=1d0/nc**5*facV              ! qb gt -> qb gt ph1 ph2     Bttt2g1H2
      case(141)
         factor=-1d0/nc**4*nf*facV          ! q gt -> gt q ph1 ph2     Btth2g1H2
      case(142)
         factor=-1d0/nc**4*nf*1d0/2d0*facV   ! q qb -> gt gt ph1 ph2     Btth2g1H2
      case(143)
         factor=-1d0/nc**4*nf*facV          ! gt q -> gt q ph1 ph2     Btth2g1H2
      case(144)
         factor=-1d0/nc**4*nf*1d0/2d0*facV   ! qb q -> gt gt ph1 ph2     Btth2g1H2
      case(145)
         factor=-1d0/nc**4*nf*nf*facV       ! gt gt -> qb q ph1 ph2     Btth2g1H2
      case(146)
         factor=-1d0/nc**4*nf*facV          ! gt qb -> qb gt ph1 ph2     Btth2g1H2
      case(147)
         factor=-1d0/nc**4*nf*facV          ! qb gt -> qb gt ph1 ph2     Btth2g1H2
      case(148)
         factor=1d0/nc**2*facV              ! q Qb -> Qb q ph1 ph2     C0g1H2F
      case(149)
         factor=1d0/nc**2*facV              ! q Q -> Q q ph1 ph2      C0g1H2F
      case(150)
         factor=1d0/nc**2*nf*facV           ! q qb -> Q Qb ph1 ph2     C0g1H2F
      case(151)
         factor=1d0/nc**2*nf*facV           ! qb q -> Q Qb ph1 ph2     C0g1H2F
      case(152)
         factor=1d0/nc**2*facV              ! qb Qb -> qb Qb ph1 ph2     C0g1H2F
      case(153)
         factor=1d0/nc**2*facV              ! qb Q -> qb Q ph1 ph2     C0g1H2F
      case(154)
         factor=1d0/nc**2*nf*facV           ! g q subtraction         C0g1H2F
      case(155)
         factor=1d0/nc**2*nf*facV           ! g qb subtraction        C0g1H2F
      case(156)
         factor=1d0/nc**2*nf*facV           ! q g subtraction         C0g1H2F
      case(157)
         factor=1d0/nc**2*nf*facV           ! qb g subtraction        C0g1H2F
      case(158)
         factor=-1d0/nc**4*facV             ! q Qb -> Qb q ph1 ph2     Ct0g1H2F
      case(159)
         factor=-1d0/nc**4*facV             ! q Q -> Q q ph1 ph2      Ct0g1H2F
      case(160)
         factor=-1d0/nc**4*nf*facV          ! q qb -> Q Qb ph1 ph2     Ct0g1H2F
      case(161)
         factor=-1d0/nc**4*nf*facV          ! qb q -> Q Qb ph1 ph2     Ct0g1H2F
      case(162)
         factor=-1d0/nc**4*facV             ! qb Qb -> qb Qb ph1 ph2     Ct0g1H2F
      case(163)
         factor=-1d0/nc**4*facV             ! qb Q -> qb Q ph1 ph2     Ct0g1H2F
      case(164)
         factor=-1d0/nc**4*nf*facV          ! g q subtraction         Ct0g1H2F
      case(165)
         factor=-1d0/nc**4*nf*facV          ! g qb subtraction        Ct0g1H2F
      case(166)
         factor=-1d0/nc**4*nf*facV          ! q g subtraction         Ct0g1H2F
      case(167)
         factor=-1d0/nc**4*nf*facV          ! qb g subtraction        Ct0g1H2F
      case(168)
         factor=1d0/nc**3*nf*facV           ! q Qb -> Qb q ph1 ph2     Ch0g1H2
      case(169)
         factor=1d0/nc**3*nf*facV           ! q Q -> Q q ph1 ph2      Ch0g1H2
      case(170)
         factor=1d0/nc**3*nf*nf*facV        ! q qb -> Q Qb ph1 ph2     Ch0g1H2
      case(171)
         factor=1d0/nc**3*nf*nf*facV        ! qb q -> Q Qb ph1 ph2     Ch0g1H2
      case(172)
         factor=1d0/nc**3*nf*facV           ! qb Qb -> qb Qb ph1 ph2     Ch0g1H2
      case(173)
         factor=1d0/nc**3*nf*facV           ! qb Q -> qb Q ph1 ph2     Ch0g1H2
      case(174)
         factor=1d0/nc**3*nf**2*facV        ! g q subtraction         Ch0g1H2
      case(175)
         factor=1d0/nc**3*nf**2*facV        ! g qb subtraction        Ch0g1H2
      case(176)
         factor=1d0/nc**3*nf**2*facV        ! q g subtraction         Ch0g1H2
      case(177)
         factor=1d0/nc**3*nf**2*facV        ! qb g subtraction        Ch0g1H2
      case(178)
         factor=-1d0/nc**3*facV             ! q qb -> qb q ph1 ph2     D0g1H2
      case(179)
         factor=-1d0/nc**3*1d0/2d0*facV     ! q q -> q q ph1 ph2      D0g1H2
      case(180)
         factor=-1d0/nc**3*facV             ! qb q -> qb q ph1 ph2     D0g1H2
      case(181)
         factor=-1d0/nc**3*1d0/2d0*facV     ! qb qb -> qb qb ph1 ph2     D0g1H2
      case(182)
         factor=-1d0/nc**3*facV             ! g q subtraction         D0g1H2
      case(183)
         factor=-1d0/nc**3*facV             ! g qb subtraction        D0g1H2
      case(184)
         factor=-1d0/nc**3*facV             ! q g subtraction         D0g1H2
      case(185)
         factor=-1d0/nc**3*facV             ! qb g subtraction        D0g1H2
      case(186)
         factor=-1d0/nc**5*facV             ! q qb -> qb q ph1 ph2     Dt0g1H2
      case(187)
         factor=-1d0/nc**5*1d0/2d0*facV     ! q q -> q q ph1 ph2      Dt0g1H2
      case(188)
         factor=-1d0/nc**5*facV             ! qb q -> qb q ph1 ph2     Dt0g1H2
      case(189)
         factor=-1d0/nc**5*1d0/2d0*facV     ! qb qb -> qb qb ph1 ph2     Dt0g1H2
      case(190)
         factor=-1d0/nc**5*facV             ! g q subtraction         Dt0g1H2
      case(191)
         factor=-1d0/nc**5*facV             ! g qb subtraction        Dt0g1H2
      case(192)
         factor=-1d0/nc**5*facV             ! q g subtraction         Dt0g1H2
      case(193)
         factor=-1d0/nc**5*facV             ! qb g subtraction        Dt0g1H2
      case(194)
         factor=1d0/nc**4*nf*facV           ! q qb -> qb q ph1 ph2     Dh0g1H2
      case(195)
         factor=1d0/nc**4*nf*1d0/2d0*facV   ! q q -> q q ph1 ph2      Dh0g1H2
      case(196)
         factor=1d0/nc**4*nf*facV           ! qb q -> qb q ph1 ph2     Dh0g1H2
      case(197)
         factor=1d0/nc**4*nf*1d0/2d0*facV   ! qb qb -> qb qb ph1 ph2     Dh0g1H2
      case(198)
         factor=1d0/nc**4*nf*facV           ! g q subtraction         Dh0g1H2
      case(199)
         factor=1d0/nc**4*nf*facV           ! g qb subtraction        Dh0g1H2
      case(200)
         factor=1d0/nc**4*nf*facV           ! q g subtraction         Dh0g1H2
      case(201)
         factor=1d0/nc**4*nf*facV           ! qb g subtraction        Dh0g1H2
      case(202)
         factor=C1*2d0*1d0/2d0*facV         ! g g -> g g ph1 ph2      A4g0H2
      case(203)
         factor=C1/nc*facV                  ! q g -> g q ph1 ph2      B2g0H2
      case(204)
         factor=C1/nc*1d0/2d0*facV          ! q qb -> g g ph1 ph2     B2g0H2
      case(205)
         factor=C1/nc*facV                  ! g q -> g q ph1 ph2      B2g0H2
      case(206)
         factor=C1/nc*1d0/2d0*facV          ! qb q -> g g ph1 ph2     B2g0H2
      case(207)
         factor=C1/nc*nf*facV               ! g g -> qb q ph1 ph2     B2g0H2
      case(208)
         factor=C1/nc*facV                  ! g qb -> qb g ph1 ph2     B2g0H2
      case(209)
         factor=C1/nc*facV                  ! qb g -> qb g ph1 ph2     B2g0H2
      case(210)
         factor=-C1/nc**3*facV              ! q gt -> gt q ph1 ph2     Bt2g0H2
      case(211)
         factor=-C1/nc**3*1d0/2d0*facV      ! q qb -> gt gt ph1 ph2     Bt2g0H2
      case(212)
         factor=-C1/nc**3*facV              ! gt q -> gt q ph1 ph2     Bt2g0H2
      case(213)
         factor=-C1/nc**3*1d0/2d0*facV      ! qb q -> gt gt ph1 ph2     Bt2g0H2
      case(214)
         factor=-C1/nc**3*nf*facV           ! gt gt -> qb q ph1 ph2     Bt2g0H2
      case(215)
         factor=-C1/nc**3*facV              ! gt qb -> qb gt ph1 ph2     Bt2g0H2
      case(216)
         factor=-C1/nc**3*facV              ! qb gt -> qb gt ph1 ph2     Bt2g0H2
      case(217)
         factor=C1/nc**2*facV               ! q Qb -> Qb q ph1 ph2     C0g0H2
      case(218)
         factor=C1/nc**2*facV               ! q Q -> Q q ph1 ph2      C0g0H2
      case(219)
         factor=C1/nc**2*nf*facV            ! q qb -> Q Qb ph1 ph2     C0g0H2
      case(220)
         factor=C1/nc**2*nf*facV            ! qb q -> Q Qb ph1 ph2     C0g0H2
      case(221)
         factor=C1/nc**2*facV               ! qb Qb -> qb Qb ph1 ph2     C0g0H2
      case(222)
         factor=C1/nc**2*facV               ! qb Q -> qb Q ph1 ph2     C0g0H2
      case(223)
         factor=-C1/nc**3*facV              ! q qb -> qb q ph1 ph2     D0g0H2
      case(224)
         factor=-C1/nc**3*1d0/2d0*facV      ! q q -> q q ph1 ph2      D0g0H2
      case(225)
         factor=-C1/nc**3*facV              ! qb q -> qb q ph1 ph2     D0g0H2
      case(226)
         factor=-C1/nc**3*1d0/2d0*facV      ! qb qb -> qb qb ph1 ph2     D0g0H2

c -- double real


c -- real virtual


c -- double virtual

      end select
      factor=relfactor*factor

      return
      end
