      subroutine selectchannelH2JJ()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*C0*(nc**2d0-1d0)*nc**2*(4d0*pi*alphas_scl)**2
      n_alphas_proc = 4
      n_alpha_proc  = 0
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelH2JJ: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelH2JJ: already allocated'  
        stop
      end if

      ntot_chan = 226

      allocate(qactive_chan(1:226))
      allocate(contrib_chan(1:226))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! g g to g g ph1 ph2    A4g0H2(1,2,3,4,5,6)   
c      qactive_chan(2)  = .true.   ! q g to g q ph1 ph2    B2g0H2(1,2,3,4,5,6)   
c      qactive_chan(3)  = .true.   ! q qb to g g ph1 ph2   B2g0H2(1,3,4,2,5,6)   
c      qactive_chan(4)  = .true.   ! g q to g q ph1 ph2    B2g0H2(2,1,3,4,5,6)   
c      qactive_chan(5)  = .true.   ! qb q to g g ph1 ph2   B2g0H2(2,3,4,1,5,6)   
c      qactive_chan(6)  = .true.   ! g g to qb q ph1 ph2   B2g0H2(3,1,2,4,5,6)   
c      qactive_chan(7)  = .true.   ! g qb to qb g ph1 ph2   B2g0H2(3,1,4,2,5,6)   
c      qactive_chan(8)  = .true.   ! qb g to qb g ph1 ph2   B2g0H2(3,2,4,1,5,6)   
c      qactive_chan(9)  = .true.   ! q gt to gt q ph1 ph2   Bt2g0H2(1,2,3,4,5,6)  
c      qactive_chan(10) = .true.   ! q qb to gt gt ph1 ph2   Bt2g0H2(1,3,4,2,5,6)  
c      qactive_chan(11) = .true.   ! gt q to gt q ph1 ph2   Bt2g0H2(2,1,3,4,5,6)  
c      qactive_chan(12) = .true.   ! qb q to gt gt ph1 ph2   Bt2g0H2(2,3,4,1,5,6)  
c      qactive_chan(13) = .true.   ! gt gt to qb q ph1 ph2   Bt2g0H2(3,1,2,4,5,6)  
c      qactive_chan(14) = .true.   ! gt qb to qb gt ph1 ph2   Bt2g0H2(3,1,4,2,5,6)  
c      qactive_chan(15) = .true.   ! qb gt to qb gt ph1 ph2   Bt2g0H2(3,2,4,1,5,6)  
c      qactive_chan(16) = .true.   ! q Qb to Qb q ph1 ph2   C0g0H2(1,2,3,4,5,6)   
c      qactive_chan(17) = .true.   ! q Q to Q q ph1 ph2    C0g0H2(1,3,2,4,5,6)   
c      qactive_chan(18) = .true.   ! q qb to Q Qb ph1 ph2   C0g0H2(1,3,4,2,5,6)   
c      qactive_chan(19) = .true.   ! qb q to Q Qb ph1 ph2   C0g0H2(2,3,4,1,5,6)   
c      qactive_chan(20) = .true.   ! qb Qb to qb Qb ph1 ph2   C0g0H2(3,2,4,1,5,6)   
c      qactive_chan(21) = .true.   ! qb Q to qb Q ph1 ph2   C0g0H2(3,4,2,1,5,6)   
c      qactive_chan(22) = .true.   ! q qb to qb q ph1 ph2   D0g0H2(1,2,3,4,5,6)   
c      qactive_chan(23) = .true.   ! q q to q q ph1 ph2    D0g0H2(1,3,2,4,5,6)   
c      qactive_chan(24) = .true.   ! qb q to qb q ph1 ph2   D0g0H2(2,1,3,4,5,6)   
c      qactive_chan(25) = .true.   ! qb qb to qb qb ph1 ph2   D0g0H2(3,1,4,2,5,6)   

      do i=1,25
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(26) = .true.   ! g g to g g g ph1 ph2   A5g0H2(1,2,3,4,5,6,7)  ggA5g0H2SNLO(1,2,3,4,5,6,7)
c      qactive_chan(27) = .true.   ! q g to g g q ph1 ph2   B3g0H2(1,2,3,4,5,6,7)  qgB3g0H2SNLO(1,2,3,4,5,6,7)
c      qactive_chan(28) = .true.   ! q qb to g g g ph1 ph2   B3g0H2(1,3,4,5,2,6,7)  qqbB3g0H2SNLO(1,3,4,5,2,6,7)
c      qactive_chan(29) = .true.   ! g q to g g q ph1 ph2   B3g0H2(2,1,3,4,5,6,7)  gqB3g0H2SNLO(2,1,3,4,5,6,7)
c      qactive_chan(30) = .true.   ! qb q to g g g ph1 ph2   B3g0H2(2,3,4,5,1,6,7)  qbqB3g0H2SNLO(2,3,4,5,1,6,7)
c      qactive_chan(31) = .true.   ! g g to qb g q ph1 ph2   B3g0H2(3,1,2,4,5,6,7)  ggB3g0H2SNLO(3,1,2,4,5,6,7)
c      qactive_chan(32) = .true.   ! g qb to qb g g ph1 ph2   B3g0H2(3,1,4,5,2,6,7)  gqbB3g0H2SNLO(3,1,4,5,2,6,7)
c      qactive_chan(33) = .true.   ! qb g to qb g g ph1 ph2   B3g0H2(3,2,4,5,1,6,7)  qbgB3g0H2SNLO(3,2,4,5,1,6,7)
c      qactive_chan(34) = .true.   ! q g to g g q ph1 ph2   Bt3g0H2(1,2,3,4,5,6,7)  qgBt3g0H2SNLO(1,2,3,4,5,6,7)
c      qactive_chan(35) = .true.   ! q qb to g g g ph1 ph2   Bt3g0H2(1,3,4,5,2,6,7)  qqbBt3g0H2SNLO(1,3,4,5,2,6,7)
c      qactive_chan(36) = .true.   ! g q to g g q ph1 ph2   Bt3g0H2(2,1,3,4,5,6,7)  gqBt3g0H2SNLO(2,1,3,4,5,6,7)
c      qactive_chan(37) = .true.   ! qb q to g g g ph1 ph2   Bt3g0H2(2,3,4,5,1,6,7)  qbqBt3g0H2SNLO(2,3,4,5,1,6,7)
c      qactive_chan(38) = .true.   ! g g to qb g q ph1 ph2   Bt3g0H2(3,1,2,4,5,6,7)  ggBt3g0H2SNLO(3,1,2,4,5,6,7)
c      qactive_chan(39) = .true.   ! g qb to qb g g ph1 ph2   Bt3g0H2(3,1,4,5,2,6,7)  gqbBt3g0H2SNLO(3,1,4,5,2,6,7)
c      qactive_chan(40) = .true.   ! qb g to qb g g ph1 ph2   Bt3g0H2(3,2,4,5,1,6,7)  qbgBt3g0H2SNLO(3,2,4,5,1,6,7)
c      qactive_chan(41) = .true.   ! q gt to gt gt q ph1 ph2   Btt3g0H2(1,2,3,4,5,6,7)  qgtBtt3g0H2SNLO(1,2,3,4,5,6,7)
c      qactive_chan(42) = .true.   ! q qb to gt gt gt ph1 ph2   Btt3g0H2(1,3,4,5,2,6,7)  qqbBtt3g0H2SNLO(1,3,4,5,2,6,7)
c      qactive_chan(43) = .true.   ! gt q to gt gt q ph1 ph2   Btt3g0H2(2,1,3,4,5,6,7)  gtqBtt3g0H2SNLO(2,1,3,4,5,6,7)
c      qactive_chan(44) = .true.   ! qb q to gt gt gt ph1 ph2   Btt3g0H2(2,3,4,5,1,6,7)  qbqBtt3g0H2SNLO(2,3,4,5,1,6,7)
c      qactive_chan(45) = .true.   ! gt gt to qb gt q ph1 ph2   Btt3g0H2(3,1,2,4,5,6,7)  gtgtBtt3g0H2SNLO(3,1,2,4,5,6,7)
c      qactive_chan(46) = .true.   ! gt qb to qb gt gt ph1 ph2   Btt3g0H2(3,1,4,5,2,6,7)  gtqbBtt3g0H2SNLO(3,1,4,5,2,6,7)
c      qactive_chan(47) = .true.   ! qb gt to qb gt gt ph1 ph2   Btt3g0H2(3,2,4,5,1,6,7)  qbgtBtt3g0H2SNLO(3,2,4,5,1,6,7)
c      qactive_chan(48) = .true.   ! q g to Q Qb q ph1 ph2   C1g0H2F(1,2,3,4,5,6,7)  qgC1g0H2FSNLO(1,2,3,4,5,6,7)
c      qactive_chan(49) = .true.   ! q Qb to g Qb q ph1 ph2   C1g0H2F(1,3,2,4,5,6,7)  qqpbC1g0H2FSNLO(1,3,2,4,5,6,7)
c      qactive_chan(50) = .true.   ! q Q to g Q q ph1 ph2   C1g0H2F(1,3,4,2,5,6,7)  qqpC1g0H2FSNLO(1,3,4,2,5,6,7)
c      qactive_chan(51) = .true.   ! q qb to g Q Qb ph1 ph2   C1g0H2F(1,3,4,5,2,6,7)  qqbC1g0H2FSNLO(1,3,4,5,2,6,7)
c      qactive_chan(52) = .true.   ! g q to Q Qb q ph1 ph2   C1g0H2F(2,1,3,4,5,6,7)  gqC1g0H2FSNLO(2,1,3,4,5,6,7)
c      qactive_chan(53) = .true.   ! qb q to g Q Qb ph1 ph2   C1g0H2F(2,3,4,5,1,6,7)  qbqC1g0H2FSNLO(2,3,4,5,1,6,7)
c      qactive_chan(54) = .true.   ! g qb to qb Q Qb ph1 ph2   C1g0H2F(3,1,4,5,2,6,7)  gqbC1g0H2FSNLO(3,1,4,5,2,6,7)
c      qactive_chan(55) = .true.   ! qb g to qb Q Qb ph1 ph2   C1g0H2F(3,2,4,5,1,6,7)  qbgC1g0H2FSNLO(3,2,4,5,1,6,7)
c      qactive_chan(56) = .true.   ! qb Qb to qb g Qb ph1 ph2   C1g0H2F(3,4,2,5,1,6,7)  qbqpbC1g0H2FSNLO(3,4,2,5,1,6,7)
c      qactive_chan(57) = .true.   ! qb Q to qb g Q ph1 ph2   C1g0H2F(3,4,5,2,1,6,7)  qbqpC1g0H2FSNLO(3,4,5,2,1,6,7)
c      qactive_chan(58) = .true.   ! q g to Q Qb q ph1 ph2   Ct1g0H2F(1,2,3,4,5,6,7)  qgCt1g0H2FSNLO(1,2,3,4,5,6,7)
c      qactive_chan(59) = .true.   ! q Qb to g Qb q ph1 ph2   Ct1g0H2F(1,3,2,4,5,6,7)  qqpbCt1g0H2FSNLO(1,3,2,4,5,6,7)
c      qactive_chan(60) = .true.   ! q Q to g Q q ph1 ph2   Ct1g0H2F(1,3,4,2,5,6,7)  qqpCt1g0H2FSNLO(1,3,4,2,5,6,7)
c      qactive_chan(61) = .true.   ! q qb to g Q Qb ph1 ph2   Ct1g0H2F(1,3,4,5,2,6,7)  qqbCt1g0H2FSNLO(1,3,4,5,2,6,7)
c      qactive_chan(62) = .true.   ! g q to Q Qb q ph1 ph2   Ct1g0H2F(2,1,3,4,5,6,7)  gqCt1g0H2FSNLO(2,1,3,4,5,6,7)
c      qactive_chan(63) = .true.   ! qb q to g Q Qb ph1 ph2   Ct1g0H2F(2,3,4,5,1,6,7)  qbqCt1g0H2FSNLO(2,3,4,5,1,6,7)
c      qactive_chan(64) = .true.   ! g qb to qb Q Qb ph1 ph2   Ct1g0H2F(3,1,4,5,2,6,7)  gqbCt1g0H2FSNLO(3,1,4,5,2,6,7)
c      qactive_chan(65) = .true.   ! qb g to qb Q Qb ph1 ph2   Ct1g0H2F(3,2,4,5,1,6,7)  qbgCt1g0H2FSNLO(3,2,4,5,1,6,7)
c      qactive_chan(66) = .true.   ! qb Qb to qb g Qb ph1 ph2   Ct1g0H2F(3,4,2,5,1,6,7)  qbqpbCt1g0H2FSNLO(3,4,2,5,1,6,7)
c      qactive_chan(67) = .true.   ! qb Q to qb g Q ph1 ph2   Ct1g0H2F(3,4,5,2,1,6,7)  qbqpCt1g0H2FSNLO(3,4,5,2,1,6,7)
c      qactive_chan(68) = .true.   ! q g to q qb q ph1 ph2   D1g0H2F(1,2,3,4,5,6,7)  qgD1g0H2FSNLO(1,2,3,4,5,6,7)
c      qactive_chan(69) = .true.   ! q qb to g qb q ph1 ph2   D1g0H2F(1,3,2,4,5,6,7)  qqbD1g0H2FSNLO(1,3,2,4,5,6,7)
c      qactive_chan(70) = .true.   ! q q to g q q ph1 ph2   D1g0H2F(1,3,4,2,5,6,7)  qqD1g0H2FSNLO(1,3,4,2,5,6,7)
c      qactive_chan(71) = .true.   ! g q to q qb q ph1 ph2   D1g0H2F(2,1,3,4,5,6,7)  gqD1g0H2FSNLO(2,1,3,4,5,6,7)
c      qactive_chan(72) = .true.   ! qb q to g qb q ph1 ph2   D1g0H2F(2,3,1,4,5,6,7)  qbqD1g0H2FSNLO(2,3,1,4,5,6,7)
c      qactive_chan(73) = .true.   ! g qb to qb qb q ph1 ph2   D1g0H2F(3,1,2,4,5,6,7)  gqbD1g0H2FSNLO(3,1,2,4,5,6,7)
c      qactive_chan(74) = .true.   ! qb g to qb qb q ph1 ph2   D1g0H2F(3,2,1,4,5,6,7)  qbgD1g0H2FSNLO(3,2,1,4,5,6,7)
c      qactive_chan(75) = .true.   ! qb qb to qb g qb ph1 ph2   D1g0H2F(3,4,1,5,2,6,7)  qbqbD1g0H2FSNLO(3,4,1,5,2,6,7)
c      qactive_chan(76) = .true.   ! q g to q qb q ph1 ph2   Dt1g0H2(1,2,3,4,5,6,7)  qgDt1g0H2SNLO(1,2,3,4,5,6,7)
c      qactive_chan(77) = .true.   ! q qb to g qb q ph1 ph2   Dt1g0H2(1,3,2,4,5,6,7)  qqbDt1g0H2SNLO(1,3,2,4,5,6,7)
c      qactive_chan(78) = .true.   ! q q to g q q ph1 ph2   Dt1g0H2(1,3,4,2,5,6,7)  qqDt1g0H2SNLO(1,3,4,2,5,6,7)
c      qactive_chan(79) = .true.   ! g q to q qb q ph1 ph2   Dt1g0H2(2,1,3,4,5,6,7)  gqDt1g0H2SNLO(2,1,3,4,5,6,7)
c      qactive_chan(80) = .true.   ! qb q to g qb q ph1 ph2   Dt1g0H2(2,3,1,4,5,6,7)  qbqDt1g0H2SNLO(2,3,1,4,5,6,7)
c      qactive_chan(81) = .true.   ! g qb to qb qb q ph1 ph2   Dt1g0H2(3,1,2,4,5,6,7)  gqbDt1g0H2SNLO(3,1,2,4,5,6,7)
c      qactive_chan(82) = .true.   ! qb g to qb qb q ph1 ph2   Dt1g0H2(3,2,1,4,5,6,7)  qbgDt1g0H2SNLO(3,2,1,4,5,6,7)
c      qactive_chan(83) = .true.   ! qb qb to qb g qb ph1 ph2   Dt1g0H2(3,4,1,5,2,6,7)  qbqbDt1g0H2SNLO(3,4,1,5,2,6,7)

      do i=26,83
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(84) = .true.   ! g g to g g ph1 ph2    A4g1H2(1,2,3,4,5,6)   ggA4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(85) = .true.   ! g q subtraction                             gqA4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(86) = .true.   ! g qb subtraction                            gqbA4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(87) = .true.   ! q g subtraction                             qgA4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(88) = .true.   ! qb g subtraction                            qbgA4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(89) = .true.   ! g g to g g ph1 ph2    Ah4g1H2(1,2,3,4,5,6)  ggAh4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(90) = .true.   ! g q subtraction                             gqAh4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(91) = .true.   ! g qb subtraction                            gqbAh4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(92) = .true.   ! q g subtraction                             qgAh4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(93) = .true.   ! qb g subtraction                            qbgAh4g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(94) = .true.   ! q g to g q ph1 ph2    B2g1H2(1,2,3,4,5,6)   qgB2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(95) = .true.   ! q qb to g g ph1 ph2   B2g1H2(1,3,4,2,5,6)   qqbB2g1H2TNLO(1,3,4,2,5,6)
c      qactive_chan(96) = .true.   ! g q to g q ph1 ph2    B2g1H2(2,1,3,4,5,6)   gqB2g1H2TNLO(2,1,3,4,5,6)
c      qactive_chan(97) = .true.   ! qb q to g g ph1 ph2   B2g1H2(2,3,4,1,5,6)   qbqB2g1H2TNLO(2,3,4,1,5,6)
c      qactive_chan(98) = .true.   ! g g to qb q ph1 ph2   B2g1H2(3,1,2,4,5,6)   ggB2g1H2TNLO(3,1,2,4,5,6)
c      qactive_chan(99) = .true.   ! g qb to qb g ph1 ph2   B2g1H2(3,1,4,2,5,6)   gqbB2g1H2TNLO(3,1,4,2,5,6)
c      qactive_chan(100)= .true.   ! qb g to qb g ph1 ph2   B2g1H2(3,2,4,1,5,6)   qbgB2g1H2TNLO(3,2,4,1,5,6)
c      qactive_chan(101)= .true.   ! q Q subtraction                             qqpB2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(102)= .true.   ! q Qb subtraction                            qqpbB2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(103)= .true.   ! qb Q subtraction                            qbqpB2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(104)= .true.   ! qb Qb subtraction                           qbqpbB2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(105)= .true.   ! q g to g q ph1 ph2    Bh2g1H2(1,2,3,4,5,6)  qgBh2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(106)= .true.   ! q qb to g g ph1 ph2   Bh2g1H2(1,3,4,2,5,6)  qqbBh2g1H2TNLO(1,3,4,2,5,6)
c      qactive_chan(107)= .true.   ! g q to g q ph1 ph2    Bh2g1H2(2,1,3,4,5,6)  gqBh2g1H2TNLO(2,1,3,4,5,6)
c      qactive_chan(108)= .true.   ! qb q to g g ph1 ph2   Bh2g1H2(2,3,4,1,5,6)  qbqBh2g1H2TNLO(2,3,4,1,5,6)
c      qactive_chan(109)= .true.   ! g g to qb q ph1 ph2   Bh2g1H2(3,1,2,4,5,6)  ggBh2g1H2TNLO(3,1,2,4,5,6)
c      qactive_chan(110)= .true.   ! g qb to qb g ph1 ph2   Bh2g1H2(3,1,4,2,5,6)  gqbBh2g1H2TNLO(3,1,4,2,5,6)
c      qactive_chan(111)= .true.   ! qb g to qb g ph1 ph2   Bh2g1H2(3,2,4,1,5,6)  qbgBh2g1H2TNLO(3,2,4,1,5,6)
c      qactive_chan(112)= .true.   ! q Q subtraction                             qqpBh2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(113)= .true.   ! q Qb subtraction                            qqpbBh2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(114)= .true.   ! qb Q subtraction                            qbqpBh2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(115)= .true.   ! qb Qb subtraction                           qbqpbBh2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(116)= .true.   ! q g to g q ph1 ph2    Bt2g1H2(1,2,3,4,5,6)  qgBt2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(117)= .true.   ! q qb to g g ph1 ph2   Bt2g1H2(1,3,4,2,5,6)  qqbBt2g1H2TNLO(1,3,4,2,5,6)
c      qactive_chan(118)= .true.   ! g q to g q ph1 ph2    Bt2g1H2(2,1,3,4,5,6)  gqBt2g1H2TNLO(2,1,3,4,5,6)
c      qactive_chan(119)= .true.   ! qb q to g g ph1 ph2   Bt2g1H2(2,3,4,1,5,6)  qbqBt2g1H2TNLO(2,3,4,1,5,6)
c      qactive_chan(120)= .true.   ! g g to qb q ph1 ph2   Bt2g1H2(3,1,2,4,5,6)  ggBt2g1H2TNLO(3,1,2,4,5,6)
c      qactive_chan(121)= .true.   ! g qb to qb g ph1 ph2   Bt2g1H2(3,1,4,2,5,6)  gqbBt2g1H2TNLO(3,1,4,2,5,6)
c      qactive_chan(122)= .true.   ! qb g to qb g ph1 ph2   Bt2g1H2(3,2,4,1,5,6)  qbgBt2g1H2TNLO(3,2,4,1,5,6)
c      qactive_chan(123)= .true.   ! q Q subtraction                             qqpBt2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(124)= .true.   ! q Qb subtraction                            qqpbBt2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(125)= .true.   ! qb Q subtraction                            qbqpBt2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(126)= .true.   ! qb Qb subtraction                           qbqpbBt2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(127)= .true.   ! q gt to gt q ph1 ph2   Btt2g1H2F(1,2,3,4,5,6)  qgtBtt2g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(128)= .true.   ! q qb to gt gt ph1 ph2   Btt2g1H2F(1,3,4,2,5,6)  qqbBtt2g1H2FTNLO(1,3,4,2,5,6)
c      qactive_chan(129)= .true.   ! gt q to gt q ph1 ph2   Btt2g1H2F(2,1,3,4,5,6)  gtqBtt2g1H2FTNLO(2,1,3,4,5,6)
c      qactive_chan(130)= .true.   ! qb q to gt gt ph1 ph2   Btt2g1H2F(2,3,4,1,5,6)  qbqBtt2g1H2FTNLO(2,3,4,1,5,6)
c      qactive_chan(131)= .true.   ! gt gt to qb q ph1 ph2   Btt2g1H2F(3,1,2,4,5,6)  gtgtBtt2g1H2FTNLO(3,1,2,4,5,6)
c      qactive_chan(132)= .true.   ! gt qb to qb gt ph1 ph2   Btt2g1H2F(3,1,4,2,5,6)  gtqbBtt2g1H2FTNLO(3,1,4,2,5,6)
c      qactive_chan(133)= .true.   ! qb gt to qb gt ph1 ph2   Btt2g1H2F(3,2,4,1,5,6)  qbgtBtt2g1H2FTNLO(3,2,4,1,5,6)
c      qactive_chan(134)= .true.   ! q gt to gt q ph1 ph2   Bttt2g1H2(1,2,3,4,5,6)  qgtBttt2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(135)= .true.   ! q qb to gt gt ph1 ph2   Bttt2g1H2(1,3,4,2,5,6)  qqbBttt2g1H2TNLO(1,3,4,2,5,6)
c      qactive_chan(136)= .true.   ! gt q to gt q ph1 ph2   Bttt2g1H2(2,1,3,4,5,6)  gtqBttt2g1H2TNLO(2,1,3,4,5,6)
c      qactive_chan(137)= .true.   ! qb q to gt gt ph1 ph2   Bttt2g1H2(2,3,4,1,5,6)  qbqBttt2g1H2TNLO(2,3,4,1,5,6)
c      qactive_chan(138)= .true.   ! gt gt to qb q ph1 ph2   Bttt2g1H2(3,1,2,4,5,6)  gtgtBttt2g1H2TNLO(3,1,2,4,5,6)
c      qactive_chan(139)= .true.   ! gt qb to qb gt ph1 ph2   Bttt2g1H2(3,1,4,2,5,6)  gtqbBttt2g1H2TNLO(3,1,4,2,5,6)
c      qactive_chan(140)= .true.   ! qb gt to qb gt ph1 ph2   Bttt2g1H2(3,2,4,1,5,6)  qbgtBttt2g1H2TNLO(3,2,4,1,5,6)
c      qactive_chan(141)= .true.   ! q gt to gt q ph1 ph2   Btth2g1H2(1,2,3,4,5,6)  qgtBtth2g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(142)= .true.   ! q qb to gt gt ph1 ph2   Btth2g1H2(1,3,4,2,5,6)  qqbBtth2g1H2TNLO(1,3,4,2,5,6)
c      qactive_chan(143)= .true.   ! gt q to gt q ph1 ph2   Btth2g1H2(2,1,3,4,5,6)  gtqBtth2g1H2TNLO(2,1,3,4,5,6)
c      qactive_chan(144)= .true.   ! qb q to gt gt ph1 ph2   Btth2g1H2(2,3,4,1,5,6)  qbqBtth2g1H2TNLO(2,3,4,1,5,6)
c      qactive_chan(145)= .true.   ! gt gt to qb q ph1 ph2   Btth2g1H2(3,1,2,4,5,6)  gtgtBtth2g1H2TNLO(3,1,2,4,5,6)
c      qactive_chan(146)= .true.   ! gt qb to qb gt ph1 ph2   Btth2g1H2(3,1,4,2,5,6)  gtqbBtth2g1H2TNLO(3,1,4,2,5,6)
c      qactive_chan(147)= .true.   ! qb gt to qb gt ph1 ph2   Btth2g1H2(3,2,4,1,5,6)  qbgtBtth2g1H2TNLO(3,2,4,1,5,6)
c      qactive_chan(148)= .true.   ! q Qb to Qb q ph1 ph2   C0g1H2F(1,2,3,4,5,6)  qqpbC0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(149)= .true.   ! q Q to Q q ph1 ph2    C0g1H2F(1,3,2,4,5,6)  qqpC0g1H2FTNLO(1,3,2,4,5,6)
c      qactive_chan(150)= .true.   ! q qb to Q Qb ph1 ph2   C0g1H2F(1,3,4,2,5,6)  qqbC0g1H2FTNLO(1,3,4,2,5,6)
c      qactive_chan(151)= .true.   ! qb q to Q Qb ph1 ph2   C0g1H2F(2,3,4,1,5,6)  qbqC0g1H2FTNLO(2,3,4,1,5,6)
c      qactive_chan(152)= .true.   ! qb Qb to qb Qb ph1 ph2   C0g1H2F(3,2,4,1,5,6)  qbqpbC0g1H2FTNLO(3,2,4,1,5,6)
c      qactive_chan(153)= .true.   ! qb Q to qb Q ph1 ph2   C0g1H2F(3,4,2,1,5,6)  qbqpC0g1H2FTNLO(3,4,2,1,5,6)
c      qactive_chan(154)= .true.   ! g q subtraction                             gqC0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(155)= .true.   ! g qb subtraction                            gqbC0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(156)= .true.   ! q g subtraction                             qgC0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(157)= .true.   ! qb g subtraction                            qbgC0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(158)= .true.   ! q Qb to Qb q ph1 ph2   Ct0g1H2F(1,2,3,4,5,6)  qqpbCt0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(159)= .true.   ! q Q to Q q ph1 ph2    Ct0g1H2F(1,3,2,4,5,6)  qqpCt0g1H2FTNLO(1,3,2,4,5,6)
c      qactive_chan(160)= .true.   ! q qb to Q Qb ph1 ph2   Ct0g1H2F(1,3,4,2,5,6)  qqbCt0g1H2FTNLO(1,3,4,2,5,6)
c      qactive_chan(161)= .true.   ! qb q to Q Qb ph1 ph2   Ct0g1H2F(2,3,4,1,5,6)  qbqCt0g1H2FTNLO(2,3,4,1,5,6)
c      qactive_chan(162)= .true.   ! qb Qb to qb Qb ph1 ph2   Ct0g1H2F(3,2,4,1,5,6)  qbqpbCt0g1H2FTNLO(3,2,4,1,5,6)
c      qactive_chan(163)= .true.   ! qb Q to qb Q ph1 ph2   Ct0g1H2F(3,4,2,1,5,6)  qbqpCt0g1H2FTNLO(3,4,2,1,5,6)
c      qactive_chan(164)= .true.   ! g q subtraction                             gqCt0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(165)= .true.   ! g qb subtraction                            gqbCt0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(166)= .true.   ! q g subtraction                             qgCt0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(167)= .true.   ! qb g subtraction                            qbgCt0g1H2FTNLO(1,2,3,4,5,6)
c      qactive_chan(168)= .true.   ! q Qb to Qb q ph1 ph2   Ch0g1H2(1,2,3,4,5,6)  qqpbCh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(169)= .true.   ! q Q to Q q ph1 ph2    Ch0g1H2(1,3,2,4,5,6)  qqpCh0g1H2TNLO(1,3,2,4,5,6)
c      qactive_chan(170)= .true.   ! q qb to Q Qb ph1 ph2   Ch0g1H2(1,3,4,2,5,6)  qqbCh0g1H2TNLO(1,3,4,2,5,6)
c      qactive_chan(171)= .true.   ! qb q to Q Qb ph1 ph2   Ch0g1H2(2,3,4,1,5,6)  qbqCh0g1H2TNLO(2,3,4,1,5,6)
c      qactive_chan(172)= .true.   ! qb Qb to qb Qb ph1 ph2   Ch0g1H2(3,2,4,1,5,6)  qbqpbCh0g1H2TNLO(3,2,4,1,5,6)
c      qactive_chan(173)= .true.   ! qb Q to qb Q ph1 ph2   Ch0g1H2(3,4,2,1,5,6)  qbqpCh0g1H2TNLO(3,4,2,1,5,6)
c      qactive_chan(174)= .true.   ! g q subtraction                             gqCh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(175)= .true.   ! g qb subtraction                            gqbCh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(176)= .true.   ! q g subtraction                             qgCh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(177)= .true.   ! qb g subtraction                            qbgCh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(178)= .true.   ! q qb to qb q ph1 ph2   D0g1H2(1,2,3,4,5,6)   qqbD0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(179)= .true.   ! q q to q q ph1 ph2    D0g1H2(1,3,2,4,5,6)   qqD0g1H2TNLO(1,3,2,4,5,6)
c      qactive_chan(180)= .true.   ! qb q to qb q ph1 ph2   D0g1H2(2,1,3,4,5,6)   qbqD0g1H2TNLO(2,1,3,4,5,6)
c      qactive_chan(181)= .true.   ! qb qb to qb qb ph1 ph2   D0g1H2(3,1,4,2,5,6)   qbqbD0g1H2TNLO(3,1,4,2,5,6)
c      qactive_chan(182)= .true.   ! g q subtraction                             gqD0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(183)= .true.   ! g qb subtraction                            gqbD0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(184)= .true.   ! q g subtraction                             qgD0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(185)= .true.   ! qb g subtraction                            qbgD0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(186)= .true.   ! q qb to qb q ph1 ph2   Dt0g1H2(1,2,3,4,5,6)  qqbDt0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(187)= .true.   ! q q to q q ph1 ph2    Dt0g1H2(1,3,2,4,5,6)  qqDt0g1H2TNLO(1,3,2,4,5,6)
c      qactive_chan(188)= .true.   ! qb q to qb q ph1 ph2   Dt0g1H2(2,1,3,4,5,6)  qbqDt0g1H2TNLO(2,1,3,4,5,6)
c      qactive_chan(189)= .true.   ! qb qb to qb qb ph1 ph2   Dt0g1H2(3,1,4,2,5,6)  qbqbDt0g1H2TNLO(3,1,4,2,5,6)
c      qactive_chan(190)= .true.   ! g q subtraction                             gqDt0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(191)= .true.   ! g qb subtraction                            gqbDt0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(192)= .true.   ! q g subtraction                             qgDt0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(193)= .true.   ! qb g subtraction                            qbgDt0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(194)= .true.   ! q qb to qb q ph1 ph2   Dh0g1H2(1,2,3,4,5,6)  qqbDh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(195)= .true.   ! q q to q q ph1 ph2    Dh0g1H2(1,3,2,4,5,6)  qqDh0g1H2TNLO(1,3,2,4,5,6)
c      qactive_chan(196)= .true.   ! qb q to qb q ph1 ph2   Dh0g1H2(2,1,3,4,5,6)  qbqDh0g1H2TNLO(2,1,3,4,5,6)
c      qactive_chan(197)= .true.   ! qb qb to qb qb ph1 ph2   Dh0g1H2(3,1,4,2,5,6)  qbqbDh0g1H2TNLO(3,1,4,2,5,6)
c      qactive_chan(198)= .true.   ! g q subtraction                             gqDh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(199)= .true.   ! g qb subtraction                            gqbDh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(200)= .true.   ! q g subtraction                             qgDh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(201)= .true.   ! qb g subtraction                            qbgDh0g1H2TNLO(1,2,3,4,5,6)
c      qactive_chan(202)= .true.   ! g g to g g ph1 ph2    A4g0H2(1,2,3,4,5,6)   wilsonggA4g0H2TNLO(1,2,3,4,5,6)
c      qactive_chan(203)= .true.   ! q g to g q ph1 ph2    B2g0H2(1,2,3,4,5,6)   wilsonqgB2g0H2TNLO(1,2,3,4,5,6)
c      qactive_chan(204)= .true.   ! q qb to g g ph1 ph2   B2g0H2(1,3,4,2,5,6)   wilsonqqbB2g0H2TNLO(1,3,4,2,5,6)
c      qactive_chan(205)= .true.   ! g q to g q ph1 ph2    B2g0H2(2,1,3,4,5,6)   wilsongqB2g0H2TNLO(2,1,3,4,5,6)
c      qactive_chan(206)= .true.   ! qb q to g g ph1 ph2   B2g0H2(2,3,4,1,5,6)   wilsonqbqB2g0H2TNLO(2,3,4,1,5,6)
c      qactive_chan(207)= .true.   ! g g to qb q ph1 ph2   B2g0H2(3,1,2,4,5,6)   wilsonggB2g0H2TNLO(3,1,2,4,5,6)
c      qactive_chan(208)= .true.   ! g qb to qb g ph1 ph2   B2g0H2(3,1,4,2,5,6)   wilsongqbB2g0H2TNLO(3,1,4,2,5,6)
c      qactive_chan(209)= .true.   ! qb g to qb g ph1 ph2   B2g0H2(3,2,4,1,5,6)   wilsonqbgB2g0H2TNLO(3,2,4,1,5,6)
c      qactive_chan(210)= .true.   ! q gt to gt q ph1 ph2   Bt2g0H2(1,2,3,4,5,6)  wilsonqgtBt2g0H2TNLO(1,2,3,4,5,6)
c      qactive_chan(211)= .true.   ! q qb to gt gt ph1 ph2   Bt2g0H2(1,3,4,2,5,6)  wilsonqqbBt2g0H2TNLO(1,3,4,2,5,6)
c      qactive_chan(212)= .true.   ! gt q to gt q ph1 ph2   Bt2g0H2(2,1,3,4,5,6)  wilsongtqBt2g0H2TNLO(2,1,3,4,5,6)
c      qactive_chan(213)= .true.   ! qb q to gt gt ph1 ph2   Bt2g0H2(2,3,4,1,5,6)  wilsonqbqBt2g0H2TNLO(2,3,4,1,5,6)
c      qactive_chan(214)= .true.   ! gt gt to qb q ph1 ph2   Bt2g0H2(3,1,2,4,5,6)  wilsongtgtBt2g0H2TNLO(3,1,2,4,5,6)
c      qactive_chan(215)= .true.   ! gt qb to qb gt ph1 ph2   Bt2g0H2(3,1,4,2,5,6)  wilsongtqbBt2g0H2TNLO(3,1,4,2,5,6)
c      qactive_chan(216)= .true.   ! qb gt to qb gt ph1 ph2   Bt2g0H2(3,2,4,1,5,6)  wilsonqbgtBt2g0H2TNLO(3,2,4,1,5,6)
c      qactive_chan(217)= .true.   ! q Qb to Qb q ph1 ph2   C0g0H2(1,2,3,4,5,6)   wilsonqqpbC0g0H2TNLO(1,2,3,4,5,6)
c      qactive_chan(218)= .true.   ! q Q to Q q ph1 ph2    C0g0H2(1,3,2,4,5,6)   wilsonqqpC0g0H2TNLO(1,3,2,4,5,6)
c      qactive_chan(219)= .true.   ! q qb to Q Qb ph1 ph2   C0g0H2(1,3,4,2,5,6)   wilsonqqbC0g0H2TNLO(1,3,4,2,5,6)
c      qactive_chan(220)= .true.   ! qb q to Q Qb ph1 ph2   C0g0H2(2,3,4,1,5,6)   wilsonqbqC0g0H2TNLO(2,3,4,1,5,6)
c      qactive_chan(221)= .true.   ! qb Qb to qb Qb ph1 ph2   C0g0H2(3,2,4,1,5,6)   wilsonqbqpbC0g0H2TNLO(3,2,4,1,5,6)
c      qactive_chan(222)= .true.   ! qb Q to qb Q ph1 ph2   C0g0H2(3,4,2,1,5,6)   wilsonqbqpC0g0H2TNLO(3,4,2,1,5,6)
c      qactive_chan(223)= .true.   ! q qb to qb q ph1 ph2   D0g0H2(1,2,3,4,5,6)   wilsonqqbD0g0H2TNLO(1,2,3,4,5,6)
c      qactive_chan(224)= .true.   ! q q to q q ph1 ph2    D0g0H2(1,3,2,4,5,6)   wilsonqqD0g0H2TNLO(1,3,2,4,5,6)
c      qactive_chan(225)= .true.   ! qb q to qb q ph1 ph2   D0g0H2(2,1,3,4,5,6)   wilsonqbqD0g0H2TNLO(2,1,3,4,5,6)
c      qactive_chan(226)= .true.   ! qb qb to qb qb ph1 ph2   D0g0H2(3,1,4,2,5,6)   wilsonqbqbD0g0H2TNLO(3,1,4,2,5,6)

      do i=84,226
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c -- real virtual                                 ME                   T  

c -- double virtual                               ME                   U  

      return
      end


c---- get channel strings
      subroutine getchannelH2JJ(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'g g to g g ph1 ph2  '
        me_str   = 'A4g0H2(1,2,3,4,5,6) '
        sub_str  = ''

      case (2)
        chan_str = 'q g to g q ph1 ph2  '
        me_str   = 'B2g0H2(1,2,3,4,5,6) '
        sub_str  = ''

      case (3)
        chan_str = 'q qb to g g ph1 ph2 '
        me_str   = 'B2g0H2(1,3,4,2,5,6) '
        sub_str  = ''

      case (4)
        chan_str = 'g q to g q ph1 ph2  '
        me_str   = 'B2g0H2(2,1,3,4,5,6) '
        sub_str  = ''

      case (5)
        chan_str = 'qb q to g g ph1 ph2 '
        me_str   = 'B2g0H2(2,3,4,1,5,6) '
        sub_str  = ''

      case (6)
        chan_str = 'g g to qb q ph1 ph2 '
        me_str   = 'B2g0H2(3,1,2,4,5,6) '
        sub_str  = ''

      case (7)
        chan_str = 'g qb to qb g ph1 ph2 '
        me_str   = 'B2g0H2(3,1,4,2,5,6) '
        sub_str  = ''

      case (8)
        chan_str = 'qb g to qb g ph1 ph2 '
        me_str   = 'B2g0H2(3,2,4,1,5,6) '
        sub_str  = ''

      case (9)
        chan_str = 'q gt to gt q ph1 ph2 '
        me_str   = 'Bt2g0H2(1,2,3,4,5,6)'
        sub_str  = ''

      case (10)
        chan_str = 'q qb to gt gt ph1 ph2 '
        me_str   = 'Bt2g0H2(1,3,4,2,5,6)'
        sub_str  = ''

      case (11)
        chan_str = 'gt q to gt q ph1 ph2 '
        me_str   = 'Bt2g0H2(2,1,3,4,5,6)'
        sub_str  = ''

      case (12)
        chan_str = 'qb q to gt gt ph1 ph2 '
        me_str   = 'Bt2g0H2(2,3,4,1,5,6)'
        sub_str  = ''

      case (13)
        chan_str = 'gt gt to qb q ph1 ph2 '
        me_str   = 'Bt2g0H2(3,1,2,4,5,6)'
        sub_str  = ''

      case (14)
        chan_str = 'gt qb to qb gt ph1 ph2 '
        me_str   = 'Bt2g0H2(3,1,4,2,5,6)'
        sub_str  = ''

      case (15)
        chan_str = 'qb gt to qb gt ph1 ph2 '
        me_str   = 'Bt2g0H2(3,2,4,1,5,6)'
        sub_str  = ''

      case (16)
        chan_str = 'q Qb to Qb q ph1 ph2 '
        me_str   = 'C0g0H2(1,2,3,4,5,6) '
        sub_str  = ''

      case (17)
        chan_str = 'q Q to Q q ph1 ph2  '
        me_str   = 'C0g0H2(1,3,2,4,5,6) '
        sub_str  = ''

      case (18)
        chan_str = 'q qb to Q Qb ph1 ph2 '
        me_str   = 'C0g0H2(1,3,4,2,5,6) '
        sub_str  = ''

      case (19)
        chan_str = 'qb q to Q Qb ph1 ph2 '
        me_str   = 'C0g0H2(2,3,4,1,5,6) '
        sub_str  = ''

      case (20)
        chan_str = 'qb Qb to qb Qb ph1 ph2 '
        me_str   = 'C0g0H2(3,2,4,1,5,6) '
        sub_str  = ''

      case (21)
        chan_str = 'qb Q to qb Q ph1 ph2 '
        me_str   = 'C0g0H2(3,4,2,1,5,6) '
        sub_str  = ''

      case (22)
        chan_str = 'q qb to qb q ph1 ph2 '
        me_str   = 'D0g0H2(1,2,3,4,5,6) '
        sub_str  = ''

      case (23)
        chan_str = 'q q to q q ph1 ph2  '
        me_str   = 'D0g0H2(1,3,2,4,5,6) '
        sub_str  = ''

      case (24)
        chan_str = 'qb q to qb q ph1 ph2 '
        me_str   = 'D0g0H2(2,1,3,4,5,6) '
        sub_str  = ''

      case (25)
        chan_str = 'qb qb to qb qb ph1 ph2 '
        me_str   = 'D0g0H2(3,1,4,2,5,6) '
        sub_str  = ''

      case (26)
        chan_str = 'g g to g g g ph1 ph2 '
        me_str   = 'A5g0H2(1,2,3,4,5,6,7)'
        sub_str  = 'ggA5g0H2SNLO(1,2,3,4,5,6,7)'

      case (27)
        chan_str = 'q g to g g q ph1 ph2 '
        me_str   = 'B3g0H2(1,2,3,4,5,6,7)'
        sub_str  = 'qgB3g0H2SNLO(1,2,3,4,5,6,7)'

      case (28)
        chan_str = 'q qb to g g g ph1 ph2 '
        me_str   = 'B3g0H2(1,3,4,5,2,6,7)'
        sub_str  = 'qqbB3g0H2SNLO(1,3,4,5,2,6,7)'

      case (29)
        chan_str = 'g q to g g q ph1 ph2 '
        me_str   = 'B3g0H2(2,1,3,4,5,6,7)'
        sub_str  = 'gqB3g0H2SNLO(2,1,3,4,5,6,7)'

      case (30)
        chan_str = 'qb q to g g g ph1 ph2 '
        me_str   = 'B3g0H2(2,3,4,5,1,6,7)'
        sub_str  = 'qbqB3g0H2SNLO(2,3,4,5,1,6,7)'

      case (31)
        chan_str = 'g g to qb g q ph1 ph2 '
        me_str   = 'B3g0H2(3,1,2,4,5,6,7)'
        sub_str  = 'ggB3g0H2SNLO(3,1,2,4,5,6,7)'

      case (32)
        chan_str = 'g qb to qb g g ph1 ph2 '
        me_str   = 'B3g0H2(3,1,4,5,2,6,7)'
        sub_str  = 'gqbB3g0H2SNLO(3,1,4,5,2,6,7)'

      case (33)
        chan_str = 'qb g to qb g g ph1 ph2 '
        me_str   = 'B3g0H2(3,2,4,5,1,6,7)'
        sub_str  = 'qbgB3g0H2SNLO(3,2,4,5,1,6,7)'

      case (34)
        chan_str = 'q g to g g q ph1 ph2 '
        me_str   = 'Bt3g0H2(1,2,3,4,5,6,7)'
        sub_str  = 'qgBt3g0H2SNLO(1,2,3,4,5,6,7)'

      case (35)
        chan_str = 'q qb to g g g ph1 ph2 '
        me_str   = 'Bt3g0H2(1,3,4,5,2,6,7)'
        sub_str  = 'qqbBt3g0H2SNLO(1,3,4,5,2,6,7)'

      case (36)
        chan_str = 'g q to g g q ph1 ph2 '
        me_str   = 'Bt3g0H2(2,1,3,4,5,6,7)'
        sub_str  = 'gqBt3g0H2SNLO(2,1,3,4,5,6,7)'

      case (37)
        chan_str = 'qb q to g g g ph1 ph2 '
        me_str   = 'Bt3g0H2(2,3,4,5,1,6,7)'
        sub_str  = 'qbqBt3g0H2SNLO(2,3,4,5,1,6,7)'

      case (38)
        chan_str = 'g g to qb g q ph1 ph2 '
        me_str   = 'Bt3g0H2(3,1,2,4,5,6,7)'
        sub_str  = 'ggBt3g0H2SNLO(3,1,2,4,5,6,7)'

      case (39)
        chan_str = 'g qb to qb g g ph1 ph2 '
        me_str   = 'Bt3g0H2(3,1,4,5,2,6,7)'
        sub_str  = 'gqbBt3g0H2SNLO(3,1,4,5,2,6,7)'

      case (40)
        chan_str = 'qb g to qb g g ph1 ph2 '
        me_str   = 'Bt3g0H2(3,2,4,5,1,6,7)'
        sub_str  = 'qbgBt3g0H2SNLO(3,2,4,5,1,6,7)'

      case (41)
        chan_str = 'q gt to gt gt q ph1 ph2 '
        me_str   = 'Btt3g0H2(1,2,3,4,5,6,7)'
        sub_str  = 'qgtBtt3g0H2SNLO(1,2,3,4,5,6,7)'

      case (42)
        chan_str = 'q qb to gt gt gt ph1 ph2 '
        me_str   = 'Btt3g0H2(1,3,4,5,2,6,7)'
        sub_str  = 'qqbBtt3g0H2SNLO(1,3,4,5,2,6,7)'

      case (43)
        chan_str = 'gt q to gt gt q ph1 ph2 '
        me_str   = 'Btt3g0H2(2,1,3,4,5,6,7)'
        sub_str  = 'gtqBtt3g0H2SNLO(2,1,3,4,5,6,7)'

      case (44)
        chan_str = 'qb q to gt gt gt ph1 ph2 '
        me_str   = 'Btt3g0H2(2,3,4,5,1,6,7)'
        sub_str  = 'qbqBtt3g0H2SNLO(2,3,4,5,1,6,7)'

      case (45)
        chan_str = 'gt gt to qb gt q ph1 ph2 '
        me_str   = 'Btt3g0H2(3,1,2,4,5,6,7)'
        sub_str  = 'gtgtBtt3g0H2SNLO(3,1,2,4,5,6,7)'

      case (46)
        chan_str = 'gt qb to qb gt gt ph1 ph2 '
        me_str   = 'Btt3g0H2(3,1,4,5,2,6,7)'
        sub_str  = 'gtqbBtt3g0H2SNLO(3,1,4,5,2,6,7)'

      case (47)
        chan_str = 'qb gt to qb gt gt ph1 ph2 '
        me_str   = 'Btt3g0H2(3,2,4,5,1,6,7)'
        sub_str  = 'qbgtBtt3g0H2SNLO(3,2,4,5,1,6,7)'

      case (48)
        chan_str = 'q g to Q Qb q ph1 ph2 '
        me_str   = 'C1g0H2F(1,2,3,4,5,6,7)'
        sub_str  = 'qgC1g0H2FSNLO(1,2,3,4,5,6,7)'

      case (49)
        chan_str = 'q Qb to g Qb q ph1 ph2 '
        me_str   = 'C1g0H2F(1,3,2,4,5,6,7)'
        sub_str  = 'qqpbC1g0H2FSNLO(1,3,2,4,5,6,7)'

      case (50)
        chan_str = 'q Q to g Q q ph1 ph2 '
        me_str   = 'C1g0H2F(1,3,4,2,5,6,7)'
        sub_str  = 'qqpC1g0H2FSNLO(1,3,4,2,5,6,7)'

      case (51)
        chan_str = 'q qb to g Q Qb ph1 ph2 '
        me_str   = 'C1g0H2F(1,3,4,5,2,6,7)'
        sub_str  = 'qqbC1g0H2FSNLO(1,3,4,5,2,6,7)'

      case (52)
        chan_str = 'g q to Q Qb q ph1 ph2 '
        me_str   = 'C1g0H2F(2,1,3,4,5,6,7)'
        sub_str  = 'gqC1g0H2FSNLO(2,1,3,4,5,6,7)'

      case (53)
        chan_str = 'qb q to g Q Qb ph1 ph2 '
        me_str   = 'C1g0H2F(2,3,4,5,1,6,7)'
        sub_str  = 'qbqC1g0H2FSNLO(2,3,4,5,1,6,7)'

      case (54)
        chan_str = 'g qb to qb Q Qb ph1 ph2 '
        me_str   = 'C1g0H2F(3,1,4,5,2,6,7)'
        sub_str  = 'gqbC1g0H2FSNLO(3,1,4,5,2,6,7)'

      case (55)
        chan_str = 'qb g to qb Q Qb ph1 ph2 '
        me_str   = 'C1g0H2F(3,2,4,5,1,6,7)'
        sub_str  = 'qbgC1g0H2FSNLO(3,2,4,5,1,6,7)'

      case (56)
        chan_str = 'qb Qb to qb g Qb ph1 ph2 '
        me_str   = 'C1g0H2F(3,4,2,5,1,6,7)'
        sub_str  = 'qbqpbC1g0H2FSNLO(3,4,2,5,1,6,7)'

      case (57)
        chan_str = 'qb Q to qb g Q ph1 ph2 '
        me_str   = 'C1g0H2F(3,4,5,2,1,6,7)'
        sub_str  = 'qbqpC1g0H2FSNLO(3,4,5,2,1,6,7)'

      case (58)
        chan_str = 'q g to Q Qb q ph1 ph2 '
        me_str   = 'Ct1g0H2F(1,2,3,4,5,6,7)'
        sub_str  = 'qgCt1g0H2FSNLO(1,2,3,4,5,6,7)'

      case (59)
        chan_str = 'q Qb to g Qb q ph1 ph2 '
        me_str   = 'Ct1g0H2F(1,3,2,4,5,6,7)'
        sub_str  = 'qqpbCt1g0H2FSNLO(1,3,2,4,5,6,7)'

      case (60)
        chan_str = 'q Q to g Q q ph1 ph2 '
        me_str   = 'Ct1g0H2F(1,3,4,2,5,6,7)'
        sub_str  = 'qqpCt1g0H2FSNLO(1,3,4,2,5,6,7)'

      case (61)
        chan_str = 'q qb to g Q Qb ph1 ph2 '
        me_str   = 'Ct1g0H2F(1,3,4,5,2,6,7)'
        sub_str  = 'qqbCt1g0H2FSNLO(1,3,4,5,2,6,7)'

      case (62)
        chan_str = 'g q to Q Qb q ph1 ph2 '
        me_str   = 'Ct1g0H2F(2,1,3,4,5,6,7)'
        sub_str  = 'gqCt1g0H2FSNLO(2,1,3,4,5,6,7)'

      case (63)
        chan_str = 'qb q to g Q Qb ph1 ph2 '
        me_str   = 'Ct1g0H2F(2,3,4,5,1,6,7)'
        sub_str  = 'qbqCt1g0H2FSNLO(2,3,4,5,1,6,7)'

      case (64)
        chan_str = 'g qb to qb Q Qb ph1 ph2 '
        me_str   = 'Ct1g0H2F(3,1,4,5,2,6,7)'
        sub_str  = 'gqbCt1g0H2FSNLO(3,1,4,5,2,6,7)'

      case (65)
        chan_str = 'qb g to qb Q Qb ph1 ph2 '
        me_str   = 'Ct1g0H2F(3,2,4,5,1,6,7)'
        sub_str  = 'qbgCt1g0H2FSNLO(3,2,4,5,1,6,7)'

      case (66)
        chan_str = 'qb Qb to qb g Qb ph1 ph2 '
        me_str   = 'Ct1g0H2F(3,4,2,5,1,6,7)'
        sub_str  = 'qbqpbCt1g0H2FSNLO(3,4,2,5,1,6,7)'

      case (67)
        chan_str = 'qb Q to qb g Q ph1 ph2 '
        me_str   = 'Ct1g0H2F(3,4,5,2,1,6,7)'
        sub_str  = 'qbqpCt1g0H2FSNLO(3,4,5,2,1,6,7)'

      case (68)
        chan_str = 'q g to q qb q ph1 ph2 '
        me_str   = 'D1g0H2F(1,2,3,4,5,6,7)'
        sub_str  = 'qgD1g0H2FSNLO(1,2,3,4,5,6,7)'

      case (69)
        chan_str = 'q qb to g qb q ph1 ph2 '
        me_str   = 'D1g0H2F(1,3,2,4,5,6,7)'
        sub_str  = 'qqbD1g0H2FSNLO(1,3,2,4,5,6,7)'

      case (70)
        chan_str = 'q q to g q q ph1 ph2 '
        me_str   = 'D1g0H2F(1,3,4,2,5,6,7)'
        sub_str  = 'qqD1g0H2FSNLO(1,3,4,2,5,6,7)'

      case (71)
        chan_str = 'g q to q qb q ph1 ph2 '
        me_str   = 'D1g0H2F(2,1,3,4,5,6,7)'
        sub_str  = 'gqD1g0H2FSNLO(2,1,3,4,5,6,7)'

      case (72)
        chan_str = 'qb q to g qb q ph1 ph2 '
        me_str   = 'D1g0H2F(2,3,1,4,5,6,7)'
        sub_str  = 'qbqD1g0H2FSNLO(2,3,1,4,5,6,7)'

      case (73)
        chan_str = 'g qb to qb qb q ph1 ph2 '
        me_str   = 'D1g0H2F(3,1,2,4,5,6,7)'
        sub_str  = 'gqbD1g0H2FSNLO(3,1,2,4,5,6,7)'

      case (74)
        chan_str = 'qb g to qb qb q ph1 ph2 '
        me_str   = 'D1g0H2F(3,2,1,4,5,6,7)'
        sub_str  = 'qbgD1g0H2FSNLO(3,2,1,4,5,6,7)'

      case (75)
        chan_str = 'qb qb to qb g qb ph1 ph2 '
        me_str   = 'D1g0H2F(3,4,1,5,2,6,7)'
        sub_str  = 'qbqbD1g0H2FSNLO(3,4,1,5,2,6,7)'

      case (76)
        chan_str = 'q g to q qb q ph1 ph2 '
        me_str   = 'Dt1g0H2(1,2,3,4,5,6,7)'
        sub_str  = 'qgDt1g0H2SNLO(1,2,3,4,5,6,7)'

      case (77)
        chan_str = 'q qb to g qb q ph1 ph2 '
        me_str   = 'Dt1g0H2(1,3,2,4,5,6,7)'
        sub_str  = 'qqbDt1g0H2SNLO(1,3,2,4,5,6,7)'

      case (78)
        chan_str = 'q q to g q q ph1 ph2 '
        me_str   = 'Dt1g0H2(1,3,4,2,5,6,7)'
        sub_str  = 'qqDt1g0H2SNLO(1,3,4,2,5,6,7)'

      case (79)
        chan_str = 'g q to q qb q ph1 ph2 '
        me_str   = 'Dt1g0H2(2,1,3,4,5,6,7)'
        sub_str  = 'gqDt1g0H2SNLO(2,1,3,4,5,6,7)'

      case (80)
        chan_str = 'qb q to g qb q ph1 ph2 '
        me_str   = 'Dt1g0H2(2,3,1,4,5,6,7)'
        sub_str  = 'qbqDt1g0H2SNLO(2,3,1,4,5,6,7)'

      case (81)
        chan_str = 'g qb to qb qb q ph1 ph2 '
        me_str   = 'Dt1g0H2(3,1,2,4,5,6,7)'
        sub_str  = 'gqbDt1g0H2SNLO(3,1,2,4,5,6,7)'

      case (82)
        chan_str = 'qb g to qb qb q ph1 ph2 '
        me_str   = 'Dt1g0H2(3,2,1,4,5,6,7)'
        sub_str  = 'qbgDt1g0H2SNLO(3,2,1,4,5,6,7)'

      case (83)
        chan_str = 'qb qb to qb g qb ph1 ph2 '
        me_str   = 'Dt1g0H2(3,4,1,5,2,6,7)'
        sub_str  = 'qbqbDt1g0H2SNLO(3,4,1,5,2,6,7)'

      case (84)
        chan_str = 'g g to g g ph1 ph2  '
        me_str   = 'A4g1H2(1,2,3,4,5,6) '
        sub_str  = 'ggA4g1H2TNLO(1,2,3,4,5,6)'

      case (85)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqA4g1H2TNLO(1,2,3,4,5,6)'

      case (86)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbA4g1H2TNLO(1,2,3,4,5,6)'

      case (87)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgA4g1H2TNLO(1,2,3,4,5,6)'

      case (88)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgA4g1H2TNLO(1,2,3,4,5,6)'

      case (89)
        chan_str = 'g g to g g ph1 ph2  '
        me_str   = 'Ah4g1H2(1,2,3,4,5,6)'
        sub_str  = 'ggAh4g1H2TNLO(1,2,3,4,5,6)'

      case (90)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqAh4g1H2TNLO(1,2,3,4,5,6)'

      case (91)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbAh4g1H2TNLO(1,2,3,4,5,6)'

      case (92)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgAh4g1H2TNLO(1,2,3,4,5,6)'

      case (93)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgAh4g1H2TNLO(1,2,3,4,5,6)'

      case (94)
        chan_str = 'q g to g q ph1 ph2  '
        me_str   = 'B2g1H2(1,2,3,4,5,6) '
        sub_str  = 'qgB2g1H2TNLO(1,2,3,4,5,6)'

      case (95)
        chan_str = 'q qb to g g ph1 ph2 '
        me_str   = 'B2g1H2(1,3,4,2,5,6) '
        sub_str  = 'qqbB2g1H2TNLO(1,3,4,2,5,6)'

      case (96)
        chan_str = 'g q to g q ph1 ph2  '
        me_str   = 'B2g1H2(2,1,3,4,5,6) '
        sub_str  = 'gqB2g1H2TNLO(2,1,3,4,5,6)'

      case (97)
        chan_str = 'qb q to g g ph1 ph2 '
        me_str   = 'B2g1H2(2,3,4,1,5,6) '
        sub_str  = 'qbqB2g1H2TNLO(2,3,4,1,5,6)'

      case (98)
        chan_str = 'g g to qb q ph1 ph2 '
        me_str   = 'B2g1H2(3,1,2,4,5,6) '
        sub_str  = 'ggB2g1H2TNLO(3,1,2,4,5,6)'

      case (99)
        chan_str = 'g qb to qb g ph1 ph2 '
        me_str   = 'B2g1H2(3,1,4,2,5,6) '
        sub_str  = 'gqbB2g1H2TNLO(3,1,4,2,5,6)'

      case (100)
        chan_str = 'qb g to qb g ph1 ph2 '
        me_str   = 'B2g1H2(3,2,4,1,5,6) '
        sub_str  = 'qbgB2g1H2TNLO(3,2,4,1,5,6)'

      case (101)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB2g1H2TNLO(1,2,3,4,5,6)'

      case (102)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB2g1H2TNLO(1,2,3,4,5,6)'

      case (103)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB2g1H2TNLO(1,2,3,4,5,6)'

      case (104)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB2g1H2TNLO(1,2,3,4,5,6)'

      case (105)
        chan_str = 'q g to g q ph1 ph2  '
        me_str   = 'Bh2g1H2(1,2,3,4,5,6)'
        sub_str  = 'qgBh2g1H2TNLO(1,2,3,4,5,6)'

      case (106)
        chan_str = 'q qb to g g ph1 ph2 '
        me_str   = 'Bh2g1H2(1,3,4,2,5,6)'
        sub_str  = 'qqbBh2g1H2TNLO(1,3,4,2,5,6)'

      case (107)
        chan_str = 'g q to g q ph1 ph2  '
        me_str   = 'Bh2g1H2(2,1,3,4,5,6)'
        sub_str  = 'gqBh2g1H2TNLO(2,1,3,4,5,6)'

      case (108)
        chan_str = 'qb q to g g ph1 ph2 '
        me_str   = 'Bh2g1H2(2,3,4,1,5,6)'
        sub_str  = 'qbqBh2g1H2TNLO(2,3,4,1,5,6)'

      case (109)
        chan_str = 'g g to qb q ph1 ph2 '
        me_str   = 'Bh2g1H2(3,1,2,4,5,6)'
        sub_str  = 'ggBh2g1H2TNLO(3,1,2,4,5,6)'

      case (110)
        chan_str = 'g qb to qb g ph1 ph2 '
        me_str   = 'Bh2g1H2(3,1,4,2,5,6)'
        sub_str  = 'gqbBh2g1H2TNLO(3,1,4,2,5,6)'

      case (111)
        chan_str = 'qb g to qb g ph1 ph2 '
        me_str   = 'Bh2g1H2(3,2,4,1,5,6)'
        sub_str  = 'qbgBh2g1H2TNLO(3,2,4,1,5,6)'

      case (112)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh2g1H2TNLO(1,2,3,4,5,6)'

      case (113)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh2g1H2TNLO(1,2,3,4,5,6)'

      case (114)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh2g1H2TNLO(1,2,3,4,5,6)'

      case (115)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh2g1H2TNLO(1,2,3,4,5,6)'

      case (116)
        chan_str = 'q g to g q ph1 ph2  '
        me_str   = 'Bt2g1H2(1,2,3,4,5,6)'
        sub_str  = 'qgBt2g1H2TNLO(1,2,3,4,5,6)'

      case (117)
        chan_str = 'q qb to g g ph1 ph2 '
        me_str   = 'Bt2g1H2(1,3,4,2,5,6)'
        sub_str  = 'qqbBt2g1H2TNLO(1,3,4,2,5,6)'

      case (118)
        chan_str = 'g q to g q ph1 ph2  '
        me_str   = 'Bt2g1H2(2,1,3,4,5,6)'
        sub_str  = 'gqBt2g1H2TNLO(2,1,3,4,5,6)'

      case (119)
        chan_str = 'qb q to g g ph1 ph2 '
        me_str   = 'Bt2g1H2(2,3,4,1,5,6)'
        sub_str  = 'qbqBt2g1H2TNLO(2,3,4,1,5,6)'

      case (120)
        chan_str = 'g g to qb q ph1 ph2 '
        me_str   = 'Bt2g1H2(3,1,2,4,5,6)'
        sub_str  = 'ggBt2g1H2TNLO(3,1,2,4,5,6)'

      case (121)
        chan_str = 'g qb to qb g ph1 ph2 '
        me_str   = 'Bt2g1H2(3,1,4,2,5,6)'
        sub_str  = 'gqbBt2g1H2TNLO(3,1,4,2,5,6)'

      case (122)
        chan_str = 'qb g to qb g ph1 ph2 '
        me_str   = 'Bt2g1H2(3,2,4,1,5,6)'
        sub_str  = 'qbgBt2g1H2TNLO(3,2,4,1,5,6)'

      case (123)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt2g1H2TNLO(1,2,3,4,5,6)'

      case (124)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt2g1H2TNLO(1,2,3,4,5,6)'

      case (125)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt2g1H2TNLO(1,2,3,4,5,6)'

      case (126)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt2g1H2TNLO(1,2,3,4,5,6)'

      case (127)
        chan_str = 'q gt to gt q ph1 ph2 '
        me_str   = 'Btt2g1H2F(1,2,3,4,5,6)'
        sub_str  = 'qgtBtt2g1H2FTNLO(1,2,3,4,5,6)'

      case (128)
        chan_str = 'q qb to gt gt ph1 ph2 '
        me_str   = 'Btt2g1H2F(1,3,4,2,5,6)'
        sub_str  = 'qqbBtt2g1H2FTNLO(1,3,4,2,5,6)'

      case (129)
        chan_str = 'gt q to gt q ph1 ph2 '
        me_str   = 'Btt2g1H2F(2,1,3,4,5,6)'
        sub_str  = 'gtqBtt2g1H2FTNLO(2,1,3,4,5,6)'

      case (130)
        chan_str = 'qb q to gt gt ph1 ph2 '
        me_str   = 'Btt2g1H2F(2,3,4,1,5,6)'
        sub_str  = 'qbqBtt2g1H2FTNLO(2,3,4,1,5,6)'

      case (131)
        chan_str = 'gt gt to qb q ph1 ph2 '
        me_str   = 'Btt2g1H2F(3,1,2,4,5,6)'
        sub_str  = 'gtgtBtt2g1H2FTNLO(3,1,2,4,5,6)'

      case (132)
        chan_str = 'gt qb to qb gt ph1 ph2 '
        me_str   = 'Btt2g1H2F(3,1,4,2,5,6)'
        sub_str  = 'gtqbBtt2g1H2FTNLO(3,1,4,2,5,6)'

      case (133)
        chan_str = 'qb gt to qb gt ph1 ph2 '
        me_str   = 'Btt2g1H2F(3,2,4,1,5,6)'
        sub_str  = 'qbgtBtt2g1H2FTNLO(3,2,4,1,5,6)'

      case (134)
        chan_str = 'q gt to gt q ph1 ph2 '
        me_str   = 'Bttt2g1H2(1,2,3,4,5,6)'
        sub_str  = 'qgtBttt2g1H2TNLO(1,2,3,4,5,6)'

      case (135)
        chan_str = 'q qb to gt gt ph1 ph2 '
        me_str   = 'Bttt2g1H2(1,3,4,2,5,6)'
        sub_str  = 'qqbBttt2g1H2TNLO(1,3,4,2,5,6)'

      case (136)
        chan_str = 'gt q to gt q ph1 ph2 '
        me_str   = 'Bttt2g1H2(2,1,3,4,5,6)'
        sub_str  = 'gtqBttt2g1H2TNLO(2,1,3,4,5,6)'

      case (137)
        chan_str = 'qb q to gt gt ph1 ph2 '
        me_str   = 'Bttt2g1H2(2,3,4,1,5,6)'
        sub_str  = 'qbqBttt2g1H2TNLO(2,3,4,1,5,6)'

      case (138)
        chan_str = 'gt gt to qb q ph1 ph2 '
        me_str   = 'Bttt2g1H2(3,1,2,4,5,6)'
        sub_str  = 'gtgtBttt2g1H2TNLO(3,1,2,4,5,6)'

      case (139)
        chan_str = 'gt qb to qb gt ph1 ph2 '
        me_str   = 'Bttt2g1H2(3,1,4,2,5,6)'
        sub_str  = 'gtqbBttt2g1H2TNLO(3,1,4,2,5,6)'

      case (140)
        chan_str = 'qb gt to qb gt ph1 ph2 '
        me_str   = 'Bttt2g1H2(3,2,4,1,5,6)'
        sub_str  = 'qbgtBttt2g1H2TNLO(3,2,4,1,5,6)'

      case (141)
        chan_str = 'q gt to gt q ph1 ph2 '
        me_str   = 'Btth2g1H2(1,2,3,4,5,6)'
        sub_str  = 'qgtBtth2g1H2TNLO(1,2,3,4,5,6)'

      case (142)
        chan_str = 'q qb to gt gt ph1 ph2 '
        me_str   = 'Btth2g1H2(1,3,4,2,5,6)'
        sub_str  = 'qqbBtth2g1H2TNLO(1,3,4,2,5,6)'

      case (143)
        chan_str = 'gt q to gt q ph1 ph2 '
        me_str   = 'Btth2g1H2(2,1,3,4,5,6)'
        sub_str  = 'gtqBtth2g1H2TNLO(2,1,3,4,5,6)'

      case (144)
        chan_str = 'qb q to gt gt ph1 ph2 '
        me_str   = 'Btth2g1H2(2,3,4,1,5,6)'
        sub_str  = 'qbqBtth2g1H2TNLO(2,3,4,1,5,6)'

      case (145)
        chan_str = 'gt gt to qb q ph1 ph2 '
        me_str   = 'Btth2g1H2(3,1,2,4,5,6)'
        sub_str  = 'gtgtBtth2g1H2TNLO(3,1,2,4,5,6)'

      case (146)
        chan_str = 'gt qb to qb gt ph1 ph2 '
        me_str   = 'Btth2g1H2(3,1,4,2,5,6)'
        sub_str  = 'gtqbBtth2g1H2TNLO(3,1,4,2,5,6)'

      case (147)
        chan_str = 'qb gt to qb gt ph1 ph2 '
        me_str   = 'Btth2g1H2(3,2,4,1,5,6)'
        sub_str  = 'qbgtBtth2g1H2TNLO(3,2,4,1,5,6)'

      case (148)
        chan_str = 'q Qb to Qb q ph1 ph2 '
        me_str   = 'C0g1H2F(1,2,3,4,5,6)'
        sub_str  = 'qqpbC0g1H2FTNLO(1,2,3,4,5,6)'

      case (149)
        chan_str = 'q Q to Q q ph1 ph2  '
        me_str   = 'C0g1H2F(1,3,2,4,5,6)'
        sub_str  = 'qqpC0g1H2FTNLO(1,3,2,4,5,6)'

      case (150)
        chan_str = 'q qb to Q Qb ph1 ph2 '
        me_str   = 'C0g1H2F(1,3,4,2,5,6)'
        sub_str  = 'qqbC0g1H2FTNLO(1,3,4,2,5,6)'

      case (151)
        chan_str = 'qb q to Q Qb ph1 ph2 '
        me_str   = 'C0g1H2F(2,3,4,1,5,6)'
        sub_str  = 'qbqC0g1H2FTNLO(2,3,4,1,5,6)'

      case (152)
        chan_str = 'qb Qb to qb Qb ph1 ph2 '
        me_str   = 'C0g1H2F(3,2,4,1,5,6)'
        sub_str  = 'qbqpbC0g1H2FTNLO(3,2,4,1,5,6)'

      case (153)
        chan_str = 'qb Q to qb Q ph1 ph2 '
        me_str   = 'C0g1H2F(3,4,2,1,5,6)'
        sub_str  = 'qbqpC0g1H2FTNLO(3,4,2,1,5,6)'

      case (154)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqC0g1H2FTNLO(1,2,3,4,5,6)'

      case (155)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbC0g1H2FTNLO(1,2,3,4,5,6)'

      case (156)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgC0g1H2FTNLO(1,2,3,4,5,6)'

      case (157)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgC0g1H2FTNLO(1,2,3,4,5,6)'

      case (158)
        chan_str = 'q Qb to Qb q ph1 ph2 '
        me_str   = 'Ct0g1H2F(1,2,3,4,5,6)'
        sub_str  = 'qqpbCt0g1H2FTNLO(1,2,3,4,5,6)'

      case (159)
        chan_str = 'q Q to Q q ph1 ph2  '
        me_str   = 'Ct0g1H2F(1,3,2,4,5,6)'
        sub_str  = 'qqpCt0g1H2FTNLO(1,3,2,4,5,6)'

      case (160)
        chan_str = 'q qb to Q Qb ph1 ph2 '
        me_str   = 'Ct0g1H2F(1,3,4,2,5,6)'
        sub_str  = 'qqbCt0g1H2FTNLO(1,3,4,2,5,6)'

      case (161)
        chan_str = 'qb q to Q Qb ph1 ph2 '
        me_str   = 'Ct0g1H2F(2,3,4,1,5,6)'
        sub_str  = 'qbqCt0g1H2FTNLO(2,3,4,1,5,6)'

      case (162)
        chan_str = 'qb Qb to qb Qb ph1 ph2 '
        me_str   = 'Ct0g1H2F(3,2,4,1,5,6)'
        sub_str  = 'qbqpbCt0g1H2FTNLO(3,2,4,1,5,6)'

      case (163)
        chan_str = 'qb Q to qb Q ph1 ph2 '
        me_str   = 'Ct0g1H2F(3,4,2,1,5,6)'
        sub_str  = 'qbqpCt0g1H2FTNLO(3,4,2,1,5,6)'

      case (164)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqCt0g1H2FTNLO(1,2,3,4,5,6)'

      case (165)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbCt0g1H2FTNLO(1,2,3,4,5,6)'

      case (166)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgCt0g1H2FTNLO(1,2,3,4,5,6)'

      case (167)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgCt0g1H2FTNLO(1,2,3,4,5,6)'

      case (168)
        chan_str = 'q Qb to Qb q ph1 ph2 '
        me_str   = 'Ch0g1H2(1,2,3,4,5,6)'
        sub_str  = 'qqpbCh0g1H2TNLO(1,2,3,4,5,6)'

      case (169)
        chan_str = 'q Q to Q q ph1 ph2  '
        me_str   = 'Ch0g1H2(1,3,2,4,5,6)'
        sub_str  = 'qqpCh0g1H2TNLO(1,3,2,4,5,6)'

      case (170)
        chan_str = 'q qb to Q Qb ph1 ph2 '
        me_str   = 'Ch0g1H2(1,3,4,2,5,6)'
        sub_str  = 'qqbCh0g1H2TNLO(1,3,4,2,5,6)'

      case (171)
        chan_str = 'qb q to Q Qb ph1 ph2 '
        me_str   = 'Ch0g1H2(2,3,4,1,5,6)'
        sub_str  = 'qbqCh0g1H2TNLO(2,3,4,1,5,6)'

      case (172)
        chan_str = 'qb Qb to qb Qb ph1 ph2 '
        me_str   = 'Ch0g1H2(3,2,4,1,5,6)'
        sub_str  = 'qbqpbCh0g1H2TNLO(3,2,4,1,5,6)'

      case (173)
        chan_str = 'qb Q to qb Q ph1 ph2 '
        me_str   = 'Ch0g1H2(3,4,2,1,5,6)'
        sub_str  = 'qbqpCh0g1H2TNLO(3,4,2,1,5,6)'

      case (174)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqCh0g1H2TNLO(1,2,3,4,5,6)'

      case (175)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbCh0g1H2TNLO(1,2,3,4,5,6)'

      case (176)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgCh0g1H2TNLO(1,2,3,4,5,6)'

      case (177)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgCh0g1H2TNLO(1,2,3,4,5,6)'

      case (178)
        chan_str = 'q qb to qb q ph1 ph2 '
        me_str   = 'D0g1H2(1,2,3,4,5,6) '
        sub_str  = 'qqbD0g1H2TNLO(1,2,3,4,5,6)'

      case (179)
        chan_str = 'q q to q q ph1 ph2  '
        me_str   = 'D0g1H2(1,3,2,4,5,6) '
        sub_str  = 'qqD0g1H2TNLO(1,3,2,4,5,6)'

      case (180)
        chan_str = 'qb q to qb q ph1 ph2 '
        me_str   = 'D0g1H2(2,1,3,4,5,6) '
        sub_str  = 'qbqD0g1H2TNLO(2,1,3,4,5,6)'

      case (181)
        chan_str = 'qb qb to qb qb ph1 ph2 '
        me_str   = 'D0g1H2(3,1,4,2,5,6) '
        sub_str  = 'qbqbD0g1H2TNLO(3,1,4,2,5,6)'

      case (182)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqD0g1H2TNLO(1,2,3,4,5,6)'

      case (183)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbD0g1H2TNLO(1,2,3,4,5,6)'

      case (184)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgD0g1H2TNLO(1,2,3,4,5,6)'

      case (185)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgD0g1H2TNLO(1,2,3,4,5,6)'

      case (186)
        chan_str = 'q qb to qb q ph1 ph2 '
        me_str   = 'Dt0g1H2(1,2,3,4,5,6)'
        sub_str  = 'qqbDt0g1H2TNLO(1,2,3,4,5,6)'

      case (187)
        chan_str = 'q q to q q ph1 ph2  '
        me_str   = 'Dt0g1H2(1,3,2,4,5,6)'
        sub_str  = 'qqDt0g1H2TNLO(1,3,2,4,5,6)'

      case (188)
        chan_str = 'qb q to qb q ph1 ph2 '
        me_str   = 'Dt0g1H2(2,1,3,4,5,6)'
        sub_str  = 'qbqDt0g1H2TNLO(2,1,3,4,5,6)'

      case (189)
        chan_str = 'qb qb to qb qb ph1 ph2 '
        me_str   = 'Dt0g1H2(3,1,4,2,5,6)'
        sub_str  = 'qbqbDt0g1H2TNLO(3,1,4,2,5,6)'

      case (190)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqDt0g1H2TNLO(1,2,3,4,5,6)'

      case (191)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbDt0g1H2TNLO(1,2,3,4,5,6)'

      case (192)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgDt0g1H2TNLO(1,2,3,4,5,6)'

      case (193)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgDt0g1H2TNLO(1,2,3,4,5,6)'

      case (194)
        chan_str = 'q qb to qb q ph1 ph2 '
        me_str   = 'Dh0g1H2(1,2,3,4,5,6)'
        sub_str  = 'qqbDh0g1H2TNLO(1,2,3,4,5,6)'

      case (195)
        chan_str = 'q q to q q ph1 ph2  '
        me_str   = 'Dh0g1H2(1,3,2,4,5,6)'
        sub_str  = 'qqDh0g1H2TNLO(1,3,2,4,5,6)'

      case (196)
        chan_str = 'qb q to qb q ph1 ph2 '
        me_str   = 'Dh0g1H2(2,1,3,4,5,6)'
        sub_str  = 'qbqDh0g1H2TNLO(2,1,3,4,5,6)'

      case (197)
        chan_str = 'qb qb to qb qb ph1 ph2 '
        me_str   = 'Dh0g1H2(3,1,4,2,5,6)'
        sub_str  = 'qbqbDh0g1H2TNLO(3,1,4,2,5,6)'

      case (198)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqDh0g1H2TNLO(1,2,3,4,5,6)'

      case (199)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbDh0g1H2TNLO(1,2,3,4,5,6)'

      case (200)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgDh0g1H2TNLO(1,2,3,4,5,6)'

      case (201)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgDh0g1H2TNLO(1,2,3,4,5,6)'

      case (202)
        chan_str = 'g g to g g ph1 ph2  '
        me_str   = 'A4g0H2(1,2,3,4,5,6) '
        sub_str  = 'wilsonggA4g0H2TNLO(1,2,3,4,5,6)'

      case (203)
        chan_str = 'q g to g q ph1 ph2  '
        me_str   = 'B2g0H2(1,2,3,4,5,6) '
        sub_str  = 'wilsonqgB2g0H2TNLO(1,2,3,4,5,6)'

      case (204)
        chan_str = 'q qb to g g ph1 ph2 '
        me_str   = 'B2g0H2(1,3,4,2,5,6) '
        sub_str  = 'wilsonqqbB2g0H2TNLO(1,3,4,2,5,6)'

      case (205)
        chan_str = 'g q to g q ph1 ph2  '
        me_str   = 'B2g0H2(2,1,3,4,5,6) '
        sub_str  = 'wilsongqB2g0H2TNLO(2,1,3,4,5,6)'

      case (206)
        chan_str = 'qb q to g g ph1 ph2 '
        me_str   = 'B2g0H2(2,3,4,1,5,6) '
        sub_str  = 'wilsonqbqB2g0H2TNLO(2,3,4,1,5,6)'

      case (207)
        chan_str = 'g g to qb q ph1 ph2 '
        me_str   = 'B2g0H2(3,1,2,4,5,6) '
        sub_str  = 'wilsonggB2g0H2TNLO(3,1,2,4,5,6)'

      case (208)
        chan_str = 'g qb to qb g ph1 ph2 '
        me_str   = 'B2g0H2(3,1,4,2,5,6) '
        sub_str  = 'wilsongqbB2g0H2TNLO(3,1,4,2,5,6)'

      case (209)
        chan_str = 'qb g to qb g ph1 ph2 '
        me_str   = 'B2g0H2(3,2,4,1,5,6) '
        sub_str  = 'wilsonqbgB2g0H2TNLO(3,2,4,1,5,6)'

      case (210)
        chan_str = 'q gt to gt q ph1 ph2 '
        me_str   = 'Bt2g0H2(1,2,3,4,5,6)'
        sub_str  = 'wilsonqgtBt2g0H2TNLO(1,2,3,4,5,6)'

      case (211)
        chan_str = 'q qb to gt gt ph1 ph2 '
        me_str   = 'Bt2g0H2(1,3,4,2,5,6)'
        sub_str  = 'wilsonqqbBt2g0H2TNLO(1,3,4,2,5,6)'

      case (212)
        chan_str = 'gt q to gt q ph1 ph2 '
        me_str   = 'Bt2g0H2(2,1,3,4,5,6)'
        sub_str  = 'wilsongtqBt2g0H2TNLO(2,1,3,4,5,6)'

      case (213)
        chan_str = 'qb q to gt gt ph1 ph2 '
        me_str   = 'Bt2g0H2(2,3,4,1,5,6)'
        sub_str  = 'wilsonqbqBt2g0H2TNLO(2,3,4,1,5,6)'

      case (214)
        chan_str = 'gt gt to qb q ph1 ph2 '
        me_str   = 'Bt2g0H2(3,1,2,4,5,6)'
        sub_str  = 'wilsongtgtBt2g0H2TNLO(3,1,2,4,5,6)'

      case (215)
        chan_str = 'gt qb to qb gt ph1 ph2 '
        me_str   = 'Bt2g0H2(3,1,4,2,5,6)'
        sub_str  = 'wilsongtqbBt2g0H2TNLO(3,1,4,2,5,6)'

      case (216)
        chan_str = 'qb gt to qb gt ph1 ph2 '
        me_str   = 'Bt2g0H2(3,2,4,1,5,6)'
        sub_str  = 'wilsonqbgtBt2g0H2TNLO(3,2,4,1,5,6)'

      case (217)
        chan_str = 'q Qb to Qb q ph1 ph2 '
        me_str   = 'C0g0H2(1,2,3,4,5,6) '
        sub_str  = 'wilsonqqpbC0g0H2TNLO(1,2,3,4,5,6)'

      case (218)
        chan_str = 'q Q to Q q ph1 ph2  '
        me_str   = 'C0g0H2(1,3,2,4,5,6) '
        sub_str  = 'wilsonqqpC0g0H2TNLO(1,3,2,4,5,6)'

      case (219)
        chan_str = 'q qb to Q Qb ph1 ph2 '
        me_str   = 'C0g0H2(1,3,4,2,5,6) '
        sub_str  = 'wilsonqqbC0g0H2TNLO(1,3,4,2,5,6)'

      case (220)
        chan_str = 'qb q to Q Qb ph1 ph2 '
        me_str   = 'C0g0H2(2,3,4,1,5,6) '
        sub_str  = 'wilsonqbqC0g0H2TNLO(2,3,4,1,5,6)'

      case (221)
        chan_str = 'qb Qb to qb Qb ph1 ph2 '
        me_str   = 'C0g0H2(3,2,4,1,5,6) '
        sub_str  = 'wilsonqbqpbC0g0H2TNLO(3,2,4,1,5,6)'

      case (222)
        chan_str = 'qb Q to qb Q ph1 ph2 '
        me_str   = 'C0g0H2(3,4,2,1,5,6) '
        sub_str  = 'wilsonqbqpC0g0H2TNLO(3,4,2,1,5,6)'

      case (223)
        chan_str = 'q qb to qb q ph1 ph2 '
        me_str   = 'D0g0H2(1,2,3,4,5,6) '
        sub_str  = 'wilsonqqbD0g0H2TNLO(1,2,3,4,5,6)'

      case (224)
        chan_str = 'q q to q q ph1 ph2  '
        me_str   = 'D0g0H2(1,3,2,4,5,6) '
        sub_str  = 'wilsonqqD0g0H2TNLO(1,3,2,4,5,6)'

      case (225)
        chan_str = 'qb q to qb q ph1 ph2 '
        me_str   = 'D0g0H2(2,1,3,4,5,6) '
        sub_str  = 'wilsonqbqD0g0H2TNLO(2,1,3,4,5,6)'

      case (226)
        chan_str = 'qb qb to qb qb ph1 ph2 '
        me_str   = 'D0g0H2(3,1,4,2,5,6) '
        sub_str  = 'wilsonqbqbD0g0H2TNLO(3,1,4,2,5,6)'

      case default
        print*, 'getchannelH2JJ: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtH2JJ(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtH2JJ = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (1)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (3)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (5)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (10)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (12)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (23)
        ! [q, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (25)
        ! [qb, qb, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (26)
        ! [g, g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4,5 /))

      case (27)
        ! [g, g, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (28)
        ! [g, g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4,5 /))

      case (29)
        ! [g, g, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (30)
        ! [g, g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4,5 /))

      case (32)
        ! [qb, g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 4,5 /))

      case (33)
        ! [qb, g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 4,5 /))

      case (34)
        ! [g, g, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (35)
        ! [g, g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4,5 /))

      case (36)
        ! [g, g, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (37)
        ! [g, g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4,5 /))

      case (39)
        ! [qb, g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 4,5 /))

      case (40)
        ! [qb, g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 4,5 /))

      case (41)
        ! [gt, gt, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (42)
        ! [gt, gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4,5 /))

      case (43)
        ! [gt, gt, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (44)
        ! [gt, gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4,5 /))

      case (46)
        ! [qb, gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 4,5 /))

      case (47)
        ! [qb, gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 4,5 /))

      case (68)
        ! [q, qb, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,5 /))

      case (70)
        ! [g, q, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 4,5 /))

      case (71)
        ! [q, qb, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,5 /))

      case (73)
        ! [qb, qb, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (74)
        ! [qb, qb, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (75)
        ! [qb, g, qb, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,5 /))

      case (76)
        ! [q, qb, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,5 /))

      case (78)
        ! [g, q, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 4,5 /))

      case (79)
        ! [q, qb, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,5 /))

      case (81)
        ! [qb, qb, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (82)
        ! [qb, qb, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (83)
        ! [qb, g, qb, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,5 /))

      case (84)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (89)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (95)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (97)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (106)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (108)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (117)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (119)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (128)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (130)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (135)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (137)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (142)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (144)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (179)
        ! [q, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (181)
        ! [qb, qb, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (187)
        ! [q, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (189)
        ! [qb, qb, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (195)
        ! [q, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (197)
        ! [qb, qb, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (202)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (204)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (206)
        ! [g, g, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (211)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (213)
        ! [gt, gt, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (224)
        ! [q, q, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case (226)
        ! [qb, qb, ph1, ph2]
        LIPSwgtH2JJ = weight_lips((/ 3,4 /))

      case default
        LIPSwgtH2JJ = 1

      end select
      end
