      subroutine selectchannelH3()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*C0*(nc**2-1)
      n_alphas_proc = 2
      n_alpha_proc  = 0
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelH3: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelH3: already allocated'  
        stop
      end if

      ntot_chan = 151

      allocate(qactive_chan(1:151))
      allocate(contrib_chan(1:151))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

#ifdef USE_OL
      call registerOLH3()
#endif

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! g g to l1 l2 l3       A2g0H3(1,2,3,4,5)     

      do i=1,1
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(2)  = .true.   ! g g to g l1 l2 l3     A3g0H3(1,2,3,4,5,6)   ggA3g0H3SNLO(1,2,3,4,5,6)
c      qactive_chan(3)  = .true.   ! q g to q l1 l2 l3     B1g0H3(1,2,3,4,5,6)   qgB1g0H3SNLO(1,2,3,4,5,6)
c      qactive_chan(4)  = .true.   ! q qb to g l1 l2 l3    B1g0H3(1,3,2,4,5,6)   qqbB1g0H3SNLO(1,3,2,4,5,6)
c      qactive_chan(5)  = .true.   ! g q to q l1 l2 l3     B1g0H3(2,1,3,4,5,6)   gqB1g0H3SNLO(2,1,3,4,5,6)
c      qactive_chan(6)  = .true.   ! qb q to g l1 l2 l3    B1g0H3(2,3,1,4,5,6)   qbqB1g0H3SNLO(2,3,1,4,5,6)
c      qactive_chan(7)  = .true.   ! g qb to qb l1 l2 l3   B1g0H3(3,1,2,4,5,6)   gqbB1g0H3SNLO(3,1,2,4,5,6)
c      qactive_chan(8)  = .true.   ! qb g to qb l1 l2 l3   B1g0H3(3,2,1,4,5,6)   qbgB1g0H3SNLO(3,2,1,4,5,6)

      do i=2,8
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(9)  = .true.   ! g g to l1 l2 l3       A2g1H3(1,2,3,4,5)     ggA2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(10) = .true.   ! g q subtraction                             gqA2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(11) = .true.   ! g qb subtraction                            gqbA2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(12) = .true.   ! q g subtraction                             qgA2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(13) = .true.   ! qb g subtraction                            qbgA2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(14) = .true.   ! g g to l1 l2 l3       Ah2g1H3(1,2,3,4,5)    ggAh2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(15) = .true.   ! g q subtraction                             gqAh2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(16) = .true.   ! g qb subtraction                            gqbAh2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(17) = .true.   ! q g subtraction                             qgAh2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(18) = .true.   ! qb g subtraction                            qbgAh2g1H3TNLO(1,2,3,4,5)
c      qactive_chan(19) = .true.   ! g g to l1 l2 l3       A2g0H3(1,2,3,4,5)     wilsonggA2g0H3TNLO(1,2,3,4,5)

      do i=9,19
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(20) = .true.   ! g g to g g l1 l2 l3   A4g0H3(1,2,3,4,5,6,7)  ggA4g0H3S(1,2,3,4,5,6,7)
c      qactive_chan(21) = .true.   ! q g to g q l1 l2 l3   B2g0H3(1,2,3,4,5,6,7)  qgB2g0H3S(1,2,3,4,5,6,7)
c      qactive_chan(22) = .true.   ! q qb to g g l1 l2 l3   B2g0H3(1,3,4,2,5,6,7)  qqbB2g0H3S(1,3,4,2,5,6,7)
c      qactive_chan(23) = .true.   ! g q to g q l1 l2 l3   B2g0H3(2,1,3,4,5,6,7)  gqB2g0H3S(2,1,3,4,5,6,7)
c      qactive_chan(24) = .true.   ! qb q to g g l1 l2 l3   B2g0H3(2,3,4,1,5,6,7)  qbqB2g0H3S(2,3,4,1,5,6,7)
c      qactive_chan(25) = .true.   ! g g to qb q l1 l2 l3   B2g0H3(3,1,2,4,5,6,7)  ggB2g0H3S(3,1,2,4,5,6,7)
c      qactive_chan(26) = .true.   ! g qb to qb g l1 l2 l3   B2g0H3(3,1,4,2,5,6,7)  gqbB2g0H3S(3,1,4,2,5,6,7)
c      qactive_chan(27) = .true.   ! qb g to qb g l1 l2 l3   B2g0H3(3,2,4,1,5,6,7)  qbgB2g0H3S(3,2,4,1,5,6,7)
c      qactive_chan(28) = .true.   ! q gt to gt q l1 l2 l3   Bt2g0H3(1,2,3,4,5,6,7)  qgtBt2g0H3S(1,2,3,4,5,6,7)
c      qactive_chan(29) = .true.   ! q qb to gt gt l1 l2 l3   Bt2g0H3(1,3,4,2,5,6,7)  qqbBt2g0H3S(1,3,4,2,5,6,7)
c      qactive_chan(30) = .true.   ! gt q to gt q l1 l2 l3   Bt2g0H3(2,1,3,4,5,6,7)  gtqBt2g0H3S(2,1,3,4,5,6,7)
c      qactive_chan(31) = .true.   ! qb q to gt gt l1 l2 l3   Bt2g0H3(2,3,4,1,5,6,7)  qbqBt2g0H3S(2,3,4,1,5,6,7)
c      qactive_chan(32) = .true.   ! gt gt to qb q l1 l2 l3   Bt2g0H3(3,1,2,4,5,6,7)  gtgtBt2g0H3S(3,1,2,4,5,6,7)
c      qactive_chan(33) = .true.   ! gt qb to qb gt l1 l2 l3   Bt2g0H3(3,1,4,2,5,6,7)  gtqbBt2g0H3S(3,1,4,2,5,6,7)
c      qactive_chan(34) = .true.   ! qb gt to qb gt l1 l2 l3   Bt2g0H3(3,2,4,1,5,6,7)  qbgtBt2g0H3S(3,2,4,1,5,6,7)
c      qactive_chan(35) = .true.   ! q Qb to Qb q l1 l2 l3   C0g0H3(1,2,3,4,5,6,7)  qqpbC0g0H3S(1,2,3,4,5,6,7)
c      qactive_chan(36) = .true.   ! q Q to Q q l1 l2 l3   C0g0H3(1,3,2,4,5,6,7)  qqpC0g0H3S(1,3,2,4,5,6,7)
c      qactive_chan(37) = .true.   ! q qb to Q Qb l1 l2 l3   C0g0H3(1,3,4,2,5,6,7)  qqbC0g0H3S(1,3,4,2,5,6,7)
c      qactive_chan(38) = .true.   ! qb q to Q Qb l1 l2 l3   C0g0H3(2,3,4,1,5,6,7)  qbqC0g0H3S(2,3,4,1,5,6,7)
c      qactive_chan(39) = .true.   ! qb Qb to qb Qb l1 l2 l3   C0g0H3(3,2,4,1,5,6,7)  qbqpbC0g0H3S(3,2,4,1,5,6,7)
c      qactive_chan(40) = .true.   ! qb Q to qb Q l1 l2 l3   C0g0H3(3,4,2,1,5,6,7)  qbqpC0g0H3S(3,4,2,1,5,6,7)
c      qactive_chan(41) = .true.   ! q qb to qb q l1 l2 l3   D0g0H3(1,2,3,4,5,6,7)  qqbD0g0H3S(1,2,3,4,5,6,7)
c      qactive_chan(42) = .true.   ! q q to q q l1 l2 l3   D0g0H3(1,3,2,4,5,6,7)  qqD0g0H3S(1,3,2,4,5,6,7)
c      qactive_chan(43) = .true.   ! qb q to qb q l1 l2 l3   D0g0H3(2,1,3,4,5,6,7)  qbqD0g0H3S(2,1,3,4,5,6,7)
c      qactive_chan(44) = .true.   ! qb qb to qb qb l1 l2 l3   D0g0H3(3,1,4,2,5,6,7)  qbqbD0g0H3S(3,1,4,2,5,6,7)

      do i=20,44
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(45) = .true.   ! g g to g l1 l2 l3     A3g1H3(1,2,3,4,5,6)   ggA3g1H3T(1,2,3,4,5,6)
c      qactive_chan(46) = .true.   ! g q subtraction                             gqA3g1H3T(1,2,3,4,5,6)
c      qactive_chan(47) = .true.   ! g qb subtraction                            gqbA3g1H3T(1,2,3,4,5,6)
c      qactive_chan(48) = .true.   ! q g subtraction                             qgA3g1H3T(1,2,3,4,5,6)
c      qactive_chan(49) = .true.   ! qb g subtraction                            qbgA3g1H3T(1,2,3,4,5,6)
c      qactive_chan(50) = .true.   ! g g to g l1 l2 l3     Ah3g1H3(1,2,3,4,5,6)  ggAh3g1H3T(1,2,3,4,5,6)
c      qactive_chan(51) = .true.   ! g q subtraction                             gqAh3g1H3T(1,2,3,4,5,6)
c      qactive_chan(52) = .true.   ! g qb subtraction                            gqbAh3g1H3T(1,2,3,4,5,6)
c      qactive_chan(53) = .true.   ! q g subtraction                             qgAh3g1H3T(1,2,3,4,5,6)
c      qactive_chan(54) = .true.   ! qb g subtraction                            qbgAh3g1H3T(1,2,3,4,5,6)
c      qactive_chan(55) = .true.   ! q g to q l1 l2 l3     B1g1H3(1,2,3,4,5,6)   qgB1g1H3T(1,2,3,4,5,6)
c      qactive_chan(56) = .true.   ! q qb to g l1 l2 l3    B1g1H3(1,3,2,4,5,6)   qqbB1g1H3T(1,3,2,4,5,6)
c      qactive_chan(57) = .true.   ! g q to q l1 l2 l3     B1g1H3(2,1,3,4,5,6)   gqB1g1H3T(2,1,3,4,5,6)
c      qactive_chan(58) = .true.   ! qb q to g l1 l2 l3    B1g1H3(2,3,1,4,5,6)   qbqB1g1H3T(2,3,1,4,5,6)
c      qactive_chan(59) = .true.   ! g qb to qb l1 l2 l3   B1g1H3(3,1,2,4,5,6)   gqbB1g1H3T(3,1,2,4,5,6)
c      qactive_chan(60) = .true.   ! qb g to qb l1 l2 l3   B1g1H3(3,2,1,4,5,6)   qbgB1g1H3T(3,2,1,4,5,6)
c      qactive_chan(61) = .true.   ! g g subtraction                             ggB1g1H3T(1,2,3,4,5,6)
c      qactive_chan(62) = .true.   ! q Q subtraction                             qqpB1g1H3T(1,2,3,4,5,6)
c      qactive_chan(63) = .true.   ! q Qb subtraction                            qqpbB1g1H3T(1,2,3,4,5,6)
c      qactive_chan(64) = .true.   ! qb Q subtraction                            qbqpB1g1H3T(1,2,3,4,5,6)
c      qactive_chan(65) = .true.   ! qb Qb subtraction                           qbqpbB1g1H3T(1,2,3,4,5,6)
c      qactive_chan(66) = .true.   ! q g to q l1 l2 l3     Bh1g1H3(1,2,3,4,5,6)  qgBh1g1H3T(1,2,3,4,5,6)
c      qactive_chan(67) = .true.   ! q qb to g l1 l2 l3    Bh1g1H3(1,3,2,4,5,6)  qqbBh1g1H3T(1,3,2,4,5,6)
c      qactive_chan(68) = .true.   ! g q to q l1 l2 l3     Bh1g1H3(2,1,3,4,5,6)  gqBh1g1H3T(2,1,3,4,5,6)
c      qactive_chan(69) = .true.   ! qb q to g l1 l2 l3    Bh1g1H3(2,3,1,4,5,6)  qbqBh1g1H3T(2,3,1,4,5,6)
c      qactive_chan(70) = .true.   ! g qb to qb l1 l2 l3   Bh1g1H3(3,1,2,4,5,6)  gqbBh1g1H3T(3,1,2,4,5,6)
c      qactive_chan(71) = .true.   ! qb g to qb l1 l2 l3   Bh1g1H3(3,2,1,4,5,6)  qbgBh1g1H3T(3,2,1,4,5,6)
c      qactive_chan(72) = .true.   ! g g subtraction                             ggBh1g1H3T(1,2,3,4,5,6)
c      qactive_chan(73) = .true.   ! q Q subtraction                             qqpBh1g1H3T(1,2,3,4,5,6)
c      qactive_chan(74) = .true.   ! q Qb subtraction                            qqpbBh1g1H3T(1,2,3,4,5,6)
c      qactive_chan(75) = .true.   ! qb Q subtraction                            qbqpBh1g1H3T(1,2,3,4,5,6)
c      qactive_chan(76) = .true.   ! qb Qb subtraction                           qbqpbBh1g1H3T(1,2,3,4,5,6)
c      qactive_chan(77) = .true.   ! q g to q l1 l2 l3     Bt1g1H3(1,2,3,4,5,6)  qgBt1g1H3T(1,2,3,4,5,6)
c      qactive_chan(78) = .true.   ! q qb to g l1 l2 l3    Bt1g1H3(1,3,2,4,5,6)  qqbBt1g1H3T(1,3,2,4,5,6)
c      qactive_chan(79) = .true.   ! g q to q l1 l2 l3     Bt1g1H3(2,1,3,4,5,6)  gqBt1g1H3T(2,1,3,4,5,6)
c      qactive_chan(80) = .true.   ! qb q to g l1 l2 l3    Bt1g1H3(2,3,1,4,5,6)  qbqBt1g1H3T(2,3,1,4,5,6)
c      qactive_chan(81) = .true.   ! g qb to qb l1 l2 l3   Bt1g1H3(3,1,2,4,5,6)  gqbBt1g1H3T(3,1,2,4,5,6)
c      qactive_chan(82) = .true.   ! qb g to qb l1 l2 l3   Bt1g1H3(3,2,1,4,5,6)  qbgBt1g1H3T(3,2,1,4,5,6)
c      qactive_chan(83) = .true.   ! g g subtraction                             ggBt1g1H3T(1,2,3,4,5,6)
c      qactive_chan(84) = .true.   ! q Q subtraction                             qqpBt1g1H3T(1,2,3,4,5,6)
c      qactive_chan(85) = .true.   ! q Qb subtraction                            qqpbBt1g1H3T(1,2,3,4,5,6)
c      qactive_chan(86) = .true.   ! qb Q subtraction                            qbqpBt1g1H3T(1,2,3,4,5,6)
c      qactive_chan(87) = .true.   ! qb Qb subtraction                           qbqpbBt1g1H3T(1,2,3,4,5,6)
c      qactive_chan(88) = .true.   ! g g to g l1 l2 l3     A3g0H3(1,2,3,4,5,6)   wilsonggA3g0H3T(1,2,3,4,5,6)
c      qactive_chan(89) = .true.   ! q g to q l1 l2 l3     B1g0H3(1,2,3,4,5,6)   wilsonqgB1g0H3T(1,2,3,4,5,6)
c      qactive_chan(90) = .true.   ! q qb to g l1 l2 l3    B1g0H3(1,3,2,4,5,6)   wilsonqqbB1g0H3T(1,3,2,4,5,6)
c      qactive_chan(91) = .true.   ! g q to q l1 l2 l3     B1g0H3(2,1,3,4,5,6)   wilsongqB1g0H3T(2,1,3,4,5,6)
c      qactive_chan(92) = .true.   ! qb q to g l1 l2 l3    B1g0H3(2,3,1,4,5,6)   wilsonqbqB1g0H3T(2,3,1,4,5,6)
c      qactive_chan(93) = .true.   ! g qb to qb l1 l2 l3   B1g0H3(3,1,2,4,5,6)   wilsongqbB1g0H3T(3,1,2,4,5,6)
c      qactive_chan(94) = .true.   ! qb g to qb l1 l2 l3   B1g0H3(3,2,1,4,5,6)   wilsonqbgB1g0H3T(3,2,1,4,5,6)

      do i=45,94
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(95) = .true.   ! g g to l1 l2 l3       A2g2H3(1,2,3,4,5)     ggA2g2H3U(1,2,3,4,5)
c      qactive_chan(96) = .true.   ! g q subtraction                             gqA2g2H3U(1,2,3,4,5)
c      qactive_chan(97) = .true.   ! g qb subtraction                            gqbA2g2H3U(1,2,3,4,5)
c      qactive_chan(98) = .true.   ! q Q subtraction                             qqpA2g2H3U(1,2,3,4,5)
c      qactive_chan(99) = .true.   ! q Qb subtraction                            qqpbA2g2H3U(1,2,3,4,5)
c      qactive_chan(100)= .true.   ! q g subtraction                             qgA2g2H3U(1,2,3,4,5)
c      qactive_chan(101)= .true.   ! qb Q subtraction                            qbqpA2g2H3U(1,2,3,4,5)
c      qactive_chan(102)= .true.   ! qb Qb subtraction                           qbqpbA2g2H3U(1,2,3,4,5)
c      qactive_chan(103)= .true.   ! qb g subtraction                            qbgA2g2H3U(1,2,3,4,5)
c      qactive_chan(104)= .true.   ! g g to l1 l2 l3       At2g2H3(1,2,3,4,5)    ggAt2g2H3U(1,2,3,4,5)
c      qactive_chan(105)= .true.   ! g q subtraction                             gqAt2g2H3U(1,2,3,4,5)
c      qactive_chan(106)= .true.   ! g qb subtraction                            gqbAt2g2H3U(1,2,3,4,5)
c      qactive_chan(107)= .true.   ! q Q subtraction                             qqpAt2g2H3U(1,2,3,4,5)
c      qactive_chan(108)= .true.   ! q Qb subtraction                            qqpbAt2g2H3U(1,2,3,4,5)
c      qactive_chan(109)= .true.   ! q g subtraction                             qgAt2g2H3U(1,2,3,4,5)
c      qactive_chan(110)= .true.   ! qb Q subtraction                            qbqpAt2g2H3U(1,2,3,4,5)
c      qactive_chan(111)= .true.   ! qb Qb subtraction                           qbqpbAt2g2H3U(1,2,3,4,5)
c      qactive_chan(112)= .true.   ! qb g subtraction                            qbgAt2g2H3U(1,2,3,4,5)
c      qactive_chan(113)= .true.   ! g g to l1 l2 l3       Aht2g2H3(1,2,3,4,5)   ggAht2g2H3U(1,2,3,4,5)
c      qactive_chan(114)= .true.   ! g q subtraction                             gqAht2g2H3U(1,2,3,4,5)
c      qactive_chan(115)= .true.   ! g qb subtraction                            gqbAht2g2H3U(1,2,3,4,5)
c      qactive_chan(116)= .true.   ! q Q subtraction                             qqpAht2g2H3U(1,2,3,4,5)
c      qactive_chan(117)= .true.   ! q Qb subtraction                            qqpbAht2g2H3U(1,2,3,4,5)
c      qactive_chan(118)= .true.   ! q g subtraction                             qgAht2g2H3U(1,2,3,4,5)
c      qactive_chan(119)= .true.   ! qb Q subtraction                            qbqpAht2g2H3U(1,2,3,4,5)
c      qactive_chan(120)= .true.   ! qb Qb subtraction                           qbqpbAht2g2H3U(1,2,3,4,5)
c      qactive_chan(121)= .true.   ! qb g subtraction                            qbgAht2g2H3U(1,2,3,4,5)
c      qactive_chan(122)= .true.   ! g g to l1 l2 l3       Ah2g2H3(1,2,3,4,5)    ggAh2g2H3U(1,2,3,4,5)
c      qactive_chan(123)= .true.   ! g q subtraction                             gqAh2g2H3U(1,2,3,4,5)
c      qactive_chan(124)= .true.   ! g qb subtraction                            gqbAh2g2H3U(1,2,3,4,5)
c      qactive_chan(125)= .true.   ! q Q subtraction                             qqpAh2g2H3U(1,2,3,4,5)
c      qactive_chan(126)= .true.   ! q Qb subtraction                            qqpbAh2g2H3U(1,2,3,4,5)
c      qactive_chan(127)= .true.   ! q g subtraction                             qgAh2g2H3U(1,2,3,4,5)
c      qactive_chan(128)= .true.   ! qb Q subtraction                            qbqpAh2g2H3U(1,2,3,4,5)
c      qactive_chan(129)= .true.   ! qb Qb subtraction                           qbqpbAh2g2H3U(1,2,3,4,5)
c      qactive_chan(130)= .true.   ! qb g subtraction                            qbgAh2g2H3U(1,2,3,4,5)
c      qactive_chan(131)= .true.   ! g g to l1 l2 l3       Ahh2g2H3(1,2,3,4,5)   ggAhh2g2H3U(1,2,3,4,5)
c      qactive_chan(132)= .true.   ! g q subtraction                             gqAhh2g2H3U(1,2,3,4,5)
c      qactive_chan(133)= .true.   ! g qb subtraction                            gqbAhh2g2H3U(1,2,3,4,5)
c      qactive_chan(134)= .true.   ! q Q subtraction                             qqpAhh2g2H3U(1,2,3,4,5)
c      qactive_chan(135)= .true.   ! q Qb subtraction                            qqpbAhh2g2H3U(1,2,3,4,5)
c      qactive_chan(136)= .true.   ! q g subtraction                             qgAhh2g2H3U(1,2,3,4,5)
c      qactive_chan(137)= .true.   ! qb Q subtraction                            qbqpAhh2g2H3U(1,2,3,4,5)
c      qactive_chan(138)= .true.   ! qb Qb subtraction                           qbqpbAhh2g2H3U(1,2,3,4,5)
c      qactive_chan(139)= .true.   ! qb g subtraction                            qbgAhh2g2H3U(1,2,3,4,5)
c      qactive_chan(140)= .true.   ! g g to l1 l2 l3       A2g1H3(1,2,3,4,5)     wilsonggA2g1H3U(1,2,3,4,5)
c      qactive_chan(141)= .true.   ! g q subtraction                             wilsongqA2g1H3U(1,2,3,4,5)
c      qactive_chan(142)= .true.   ! g qb subtraction                            wilsongqbA2g1H3U(1,2,3,4,5)
c      qactive_chan(143)= .true.   ! q g subtraction                             wilsonqgA2g1H3U(1,2,3,4,5)
c      qactive_chan(144)= .true.   ! qb g subtraction                            wilsonqbgA2g1H3U(1,2,3,4,5)
c      qactive_chan(145)= .true.   ! g g to l1 l2 l3       Ah2g1H3(1,2,3,4,5)    wilsonggAh2g1H3U(1,2,3,4,5)
c      qactive_chan(146)= .true.   ! g q subtraction                             wilsongqAh2g1H3U(1,2,3,4,5)
c      qactive_chan(147)= .true.   ! g qb subtraction                            wilsongqbAh2g1H3U(1,2,3,4,5)
c      qactive_chan(148)= .true.   ! q g subtraction                             wilsonqgAh2g1H3U(1,2,3,4,5)
c      qactive_chan(149)= .true.   ! qb g subtraction                            wilsonqbgAh2g1H3U(1,2,3,4,5)
c      qactive_chan(150)= .true.   ! g g to l1 l2 l3       A2g0H3(1,2,3,4,5)     wilsonggA2g0H3U(1,2,3,4,5)
c      qactive_chan(151)= .true.   ! g g to l1 l2 l3       A2g0H3(1,2,3,4,5)     wilsonggA2g0H3U(1,2,3,4,5)

      do i=95,151
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelH3(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'A2g0H3(1,2,3,4,5)   '
        sub_str  = ''

      case (2)
        chan_str = 'g g to g l1 l2 l3   '
        me_str   = 'A3g0H3(1,2,3,4,5,6) '
        sub_str  = 'ggA3g0H3SNLO(1,2,3,4,5,6)'

      case (3)
        chan_str = 'q g to q l1 l2 l3   '
        me_str   = 'B1g0H3(1,2,3,4,5,6) '
        sub_str  = 'qgB1g0H3SNLO(1,2,3,4,5,6)'

      case (4)
        chan_str = 'q qb to g l1 l2 l3  '
        me_str   = 'B1g0H3(1,3,2,4,5,6) '
        sub_str  = 'qqbB1g0H3SNLO(1,3,2,4,5,6)'

      case (5)
        chan_str = 'g q to q l1 l2 l3   '
        me_str   = 'B1g0H3(2,1,3,4,5,6) '
        sub_str  = 'gqB1g0H3SNLO(2,1,3,4,5,6)'

      case (6)
        chan_str = 'qb q to g l1 l2 l3  '
        me_str   = 'B1g0H3(2,3,1,4,5,6) '
        sub_str  = 'qbqB1g0H3SNLO(2,3,1,4,5,6)'

      case (7)
        chan_str = 'g qb to qb l1 l2 l3 '
        me_str   = 'B1g0H3(3,1,2,4,5,6) '
        sub_str  = 'gqbB1g0H3SNLO(3,1,2,4,5,6)'

      case (8)
        chan_str = 'qb g to qb l1 l2 l3 '
        me_str   = 'B1g0H3(3,2,1,4,5,6) '
        sub_str  = 'qbgB1g0H3SNLO(3,2,1,4,5,6)'

      case (9)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'A2g1H3(1,2,3,4,5)   '
        sub_str  = 'ggA2g1H3TNLO(1,2,3,4,5)'

      case (10)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqA2g1H3TNLO(1,2,3,4,5)'

      case (11)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbA2g1H3TNLO(1,2,3,4,5)'

      case (12)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgA2g1H3TNLO(1,2,3,4,5)'

      case (13)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgA2g1H3TNLO(1,2,3,4,5)'

      case (14)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'Ah2g1H3(1,2,3,4,5)  '
        sub_str  = 'ggAh2g1H3TNLO(1,2,3,4,5)'

      case (15)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqAh2g1H3TNLO(1,2,3,4,5)'

      case (16)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbAh2g1H3TNLO(1,2,3,4,5)'

      case (17)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgAh2g1H3TNLO(1,2,3,4,5)'

      case (18)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgAh2g1H3TNLO(1,2,3,4,5)'

      case (19)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'A2g0H3(1,2,3,4,5)   '
        sub_str  = 'wilsonggA2g0H3TNLO(1,2,3,4,5)'

      case (20)
        chan_str = 'g g to g g l1 l2 l3 '
        me_str   = 'A4g0H3(1,2,3,4,5,6,7)'
        sub_str  = 'ggA4g0H3S(1,2,3,4,5,6,7)'

      case (21)
        chan_str = 'q g to g q l1 l2 l3 '
        me_str   = 'B2g0H3(1,2,3,4,5,6,7)'
        sub_str  = 'qgB2g0H3S(1,2,3,4,5,6,7)'

      case (22)
        chan_str = 'q qb to g g l1 l2 l3 '
        me_str   = 'B2g0H3(1,3,4,2,5,6,7)'
        sub_str  = 'qqbB2g0H3S(1,3,4,2,5,6,7)'

      case (23)
        chan_str = 'g q to g q l1 l2 l3 '
        me_str   = 'B2g0H3(2,1,3,4,5,6,7)'
        sub_str  = 'gqB2g0H3S(2,1,3,4,5,6,7)'

      case (24)
        chan_str = 'qb q to g g l1 l2 l3 '
        me_str   = 'B2g0H3(2,3,4,1,5,6,7)'
        sub_str  = 'qbqB2g0H3S(2,3,4,1,5,6,7)'

      case (25)
        chan_str = 'g g to qb q l1 l2 l3 '
        me_str   = 'B2g0H3(3,1,2,4,5,6,7)'
        sub_str  = 'ggB2g0H3S(3,1,2,4,5,6,7)'

      case (26)
        chan_str = 'g qb to qb g l1 l2 l3 '
        me_str   = 'B2g0H3(3,1,4,2,5,6,7)'
        sub_str  = 'gqbB2g0H3S(3,1,4,2,5,6,7)'

      case (27)
        chan_str = 'qb g to qb g l1 l2 l3 '
        me_str   = 'B2g0H3(3,2,4,1,5,6,7)'
        sub_str  = 'qbgB2g0H3S(3,2,4,1,5,6,7)'

      case (28)
        chan_str = 'q gt to gt q l1 l2 l3 '
        me_str   = 'Bt2g0H3(1,2,3,4,5,6,7)'
        sub_str  = 'qgtBt2g0H3S(1,2,3,4,5,6,7)'

      case (29)
        chan_str = 'q qb to gt gt l1 l2 l3 '
        me_str   = 'Bt2g0H3(1,3,4,2,5,6,7)'
        sub_str  = 'qqbBt2g0H3S(1,3,4,2,5,6,7)'

      case (30)
        chan_str = 'gt q to gt q l1 l2 l3 '
        me_str   = 'Bt2g0H3(2,1,3,4,5,6,7)'
        sub_str  = 'gtqBt2g0H3S(2,1,3,4,5,6,7)'

      case (31)
        chan_str = 'qb q to gt gt l1 l2 l3 '
        me_str   = 'Bt2g0H3(2,3,4,1,5,6,7)'
        sub_str  = 'qbqBt2g0H3S(2,3,4,1,5,6,7)'

      case (32)
        chan_str = 'gt gt to qb q l1 l2 l3 '
        me_str   = 'Bt2g0H3(3,1,2,4,5,6,7)'
        sub_str  = 'gtgtBt2g0H3S(3,1,2,4,5,6,7)'

      case (33)
        chan_str = 'gt qb to qb gt l1 l2 l3 '
        me_str   = 'Bt2g0H3(3,1,4,2,5,6,7)'
        sub_str  = 'gtqbBt2g0H3S(3,1,4,2,5,6,7)'

      case (34)
        chan_str = 'qb gt to qb gt l1 l2 l3 '
        me_str   = 'Bt2g0H3(3,2,4,1,5,6,7)'
        sub_str  = 'qbgtBt2g0H3S(3,2,4,1,5,6,7)'

      case (35)
        chan_str = 'q Qb to Qb q l1 l2 l3 '
        me_str   = 'C0g0H3(1,2,3,4,5,6,7)'
        sub_str  = 'qqpbC0g0H3S(1,2,3,4,5,6,7)'

      case (36)
        chan_str = 'q Q to Q q l1 l2 l3 '
        me_str   = 'C0g0H3(1,3,2,4,5,6,7)'
        sub_str  = 'qqpC0g0H3S(1,3,2,4,5,6,7)'

      case (37)
        chan_str = 'q qb to Q Qb l1 l2 l3 '
        me_str   = 'C0g0H3(1,3,4,2,5,6,7)'
        sub_str  = 'qqbC0g0H3S(1,3,4,2,5,6,7)'

      case (38)
        chan_str = 'qb q to Q Qb l1 l2 l3 '
        me_str   = 'C0g0H3(2,3,4,1,5,6,7)'
        sub_str  = 'qbqC0g0H3S(2,3,4,1,5,6,7)'

      case (39)
        chan_str = 'qb Qb to qb Qb l1 l2 l3 '
        me_str   = 'C0g0H3(3,2,4,1,5,6,7)'
        sub_str  = 'qbqpbC0g0H3S(3,2,4,1,5,6,7)'

      case (40)
        chan_str = 'qb Q to qb Q l1 l2 l3 '
        me_str   = 'C0g0H3(3,4,2,1,5,6,7)'
        sub_str  = 'qbqpC0g0H3S(3,4,2,1,5,6,7)'

      case (41)
        chan_str = 'q qb to qb q l1 l2 l3 '
        me_str   = 'D0g0H3(1,2,3,4,5,6,7)'
        sub_str  = 'qqbD0g0H3S(1,2,3,4,5,6,7)'

      case (42)
        chan_str = 'q q to q q l1 l2 l3 '
        me_str   = 'D0g0H3(1,3,2,4,5,6,7)'
        sub_str  = 'qqD0g0H3S(1,3,2,4,5,6,7)'

      case (43)
        chan_str = 'qb q to qb q l1 l2 l3 '
        me_str   = 'D0g0H3(2,1,3,4,5,6,7)'
        sub_str  = 'qbqD0g0H3S(2,1,3,4,5,6,7)'

      case (44)
        chan_str = 'qb qb to qb qb l1 l2 l3 '
        me_str   = 'D0g0H3(3,1,4,2,5,6,7)'
        sub_str  = 'qbqbD0g0H3S(3,1,4,2,5,6,7)'

      case (45)
        chan_str = 'g g to g l1 l2 l3   '
        me_str   = 'A3g1H3(1,2,3,4,5,6) '
        sub_str  = 'ggA3g1H3T(1,2,3,4,5,6)'

      case (46)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqA3g1H3T(1,2,3,4,5,6)'

      case (47)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbA3g1H3T(1,2,3,4,5,6)'

      case (48)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgA3g1H3T(1,2,3,4,5,6)'

      case (49)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgA3g1H3T(1,2,3,4,5,6)'

      case (50)
        chan_str = 'g g to g l1 l2 l3   '
        me_str   = 'Ah3g1H3(1,2,3,4,5,6)'
        sub_str  = 'ggAh3g1H3T(1,2,3,4,5,6)'

      case (51)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqAh3g1H3T(1,2,3,4,5,6)'

      case (52)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbAh3g1H3T(1,2,3,4,5,6)'

      case (53)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgAh3g1H3T(1,2,3,4,5,6)'

      case (54)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgAh3g1H3T(1,2,3,4,5,6)'

      case (55)
        chan_str = 'q g to q l1 l2 l3   '
        me_str   = 'B1g1H3(1,2,3,4,5,6) '
        sub_str  = 'qgB1g1H3T(1,2,3,4,5,6)'

      case (56)
        chan_str = 'q qb to g l1 l2 l3  '
        me_str   = 'B1g1H3(1,3,2,4,5,6) '
        sub_str  = 'qqbB1g1H3T(1,3,2,4,5,6)'

      case (57)
        chan_str = 'g q to q l1 l2 l3   '
        me_str   = 'B1g1H3(2,1,3,4,5,6) '
        sub_str  = 'gqB1g1H3T(2,1,3,4,5,6)'

      case (58)
        chan_str = 'qb q to g l1 l2 l3  '
        me_str   = 'B1g1H3(2,3,1,4,5,6) '
        sub_str  = 'qbqB1g1H3T(2,3,1,4,5,6)'

      case (59)
        chan_str = 'g qb to qb l1 l2 l3 '
        me_str   = 'B1g1H3(3,1,2,4,5,6) '
        sub_str  = 'gqbB1g1H3T(3,1,2,4,5,6)'

      case (60)
        chan_str = 'qb g to qb l1 l2 l3 '
        me_str   = 'B1g1H3(3,2,1,4,5,6) '
        sub_str  = 'qbgB1g1H3T(3,2,1,4,5,6)'

      case (61)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggB1g1H3T(1,2,3,4,5,6)'

      case (62)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB1g1H3T(1,2,3,4,5,6)'

      case (63)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB1g1H3T(1,2,3,4,5,6)'

      case (64)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB1g1H3T(1,2,3,4,5,6)'

      case (65)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB1g1H3T(1,2,3,4,5,6)'

      case (66)
        chan_str = 'q g to q l1 l2 l3   '
        me_str   = 'Bh1g1H3(1,2,3,4,5,6)'
        sub_str  = 'qgBh1g1H3T(1,2,3,4,5,6)'

      case (67)
        chan_str = 'q qb to g l1 l2 l3  '
        me_str   = 'Bh1g1H3(1,3,2,4,5,6)'
        sub_str  = 'qqbBh1g1H3T(1,3,2,4,5,6)'

      case (68)
        chan_str = 'g q to q l1 l2 l3   '
        me_str   = 'Bh1g1H3(2,1,3,4,5,6)'
        sub_str  = 'gqBh1g1H3T(2,1,3,4,5,6)'

      case (69)
        chan_str = 'qb q to g l1 l2 l3  '
        me_str   = 'Bh1g1H3(2,3,1,4,5,6)'
        sub_str  = 'qbqBh1g1H3T(2,3,1,4,5,6)'

      case (70)
        chan_str = 'g qb to qb l1 l2 l3 '
        me_str   = 'Bh1g1H3(3,1,2,4,5,6)'
        sub_str  = 'gqbBh1g1H3T(3,1,2,4,5,6)'

      case (71)
        chan_str = 'qb g to qb l1 l2 l3 '
        me_str   = 'Bh1g1H3(3,2,1,4,5,6)'
        sub_str  = 'qbgBh1g1H3T(3,2,1,4,5,6)'

      case (72)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBh1g1H3T(1,2,3,4,5,6)'

      case (73)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh1g1H3T(1,2,3,4,5,6)'

      case (74)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh1g1H3T(1,2,3,4,5,6)'

      case (75)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh1g1H3T(1,2,3,4,5,6)'

      case (76)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh1g1H3T(1,2,3,4,5,6)'

      case (77)
        chan_str = 'q g to q l1 l2 l3   '
        me_str   = 'Bt1g1H3(1,2,3,4,5,6)'
        sub_str  = 'qgBt1g1H3T(1,2,3,4,5,6)'

      case (78)
        chan_str = 'q qb to g l1 l2 l3  '
        me_str   = 'Bt1g1H3(1,3,2,4,5,6)'
        sub_str  = 'qqbBt1g1H3T(1,3,2,4,5,6)'

      case (79)
        chan_str = 'g q to q l1 l2 l3   '
        me_str   = 'Bt1g1H3(2,1,3,4,5,6)'
        sub_str  = 'gqBt1g1H3T(2,1,3,4,5,6)'

      case (80)
        chan_str = 'qb q to g l1 l2 l3  '
        me_str   = 'Bt1g1H3(2,3,1,4,5,6)'
        sub_str  = 'qbqBt1g1H3T(2,3,1,4,5,6)'

      case (81)
        chan_str = 'g qb to qb l1 l2 l3 '
        me_str   = 'Bt1g1H3(3,1,2,4,5,6)'
        sub_str  = 'gqbBt1g1H3T(3,1,2,4,5,6)'

      case (82)
        chan_str = 'qb g to qb l1 l2 l3 '
        me_str   = 'Bt1g1H3(3,2,1,4,5,6)'
        sub_str  = 'qbgBt1g1H3T(3,2,1,4,5,6)'

      case (83)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBt1g1H3T(1,2,3,4,5,6)'

      case (84)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt1g1H3T(1,2,3,4,5,6)'

      case (85)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt1g1H3T(1,2,3,4,5,6)'

      case (86)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt1g1H3T(1,2,3,4,5,6)'

      case (87)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt1g1H3T(1,2,3,4,5,6)'

      case (88)
        chan_str = 'g g to g l1 l2 l3   '
        me_str   = 'A3g0H3(1,2,3,4,5,6) '
        sub_str  = 'wilsonggA3g0H3T(1,2,3,4,5,6)'

      case (89)
        chan_str = 'q g to q l1 l2 l3   '
        me_str   = 'B1g0H3(1,2,3,4,5,6) '
        sub_str  = 'wilsonqgB1g0H3T(1,2,3,4,5,6)'

      case (90)
        chan_str = 'q qb to g l1 l2 l3  '
        me_str   = 'B1g0H3(1,3,2,4,5,6) '
        sub_str  = 'wilsonqqbB1g0H3T(1,3,2,4,5,6)'

      case (91)
        chan_str = 'g q to q l1 l2 l3   '
        me_str   = 'B1g0H3(2,1,3,4,5,6) '
        sub_str  = 'wilsongqB1g0H3T(2,1,3,4,5,6)'

      case (92)
        chan_str = 'qb q to g l1 l2 l3  '
        me_str   = 'B1g0H3(2,3,1,4,5,6) '
        sub_str  = 'wilsonqbqB1g0H3T(2,3,1,4,5,6)'

      case (93)
        chan_str = 'g qb to qb l1 l2 l3 '
        me_str   = 'B1g0H3(3,1,2,4,5,6) '
        sub_str  = 'wilsongqbB1g0H3T(3,1,2,4,5,6)'

      case (94)
        chan_str = 'qb g to qb l1 l2 l3 '
        me_str   = 'B1g0H3(3,2,1,4,5,6) '
        sub_str  = 'wilsonqbgB1g0H3T(3,2,1,4,5,6)'

      case (95)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'A2g2H3(1,2,3,4,5)   '
        sub_str  = 'ggA2g2H3U(1,2,3,4,5)'

      case (96)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqA2g2H3U(1,2,3,4,5)'

      case (97)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbA2g2H3U(1,2,3,4,5)'

      case (98)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpA2g2H3U(1,2,3,4,5)'

      case (99)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbA2g2H3U(1,2,3,4,5)'

      case (100)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgA2g2H3U(1,2,3,4,5)'

      case (101)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpA2g2H3U(1,2,3,4,5)'

      case (102)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbA2g2H3U(1,2,3,4,5)'

      case (103)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgA2g2H3U(1,2,3,4,5)'

      case (104)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'At2g2H3(1,2,3,4,5)  '
        sub_str  = 'ggAt2g2H3U(1,2,3,4,5)'

      case (105)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqAt2g2H3U(1,2,3,4,5)'

      case (106)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbAt2g2H3U(1,2,3,4,5)'

      case (107)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpAt2g2H3U(1,2,3,4,5)'

      case (108)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbAt2g2H3U(1,2,3,4,5)'

      case (109)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgAt2g2H3U(1,2,3,4,5)'

      case (110)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpAt2g2H3U(1,2,3,4,5)'

      case (111)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbAt2g2H3U(1,2,3,4,5)'

      case (112)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgAt2g2H3U(1,2,3,4,5)'

      case (113)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'Aht2g2H3(1,2,3,4,5) '
        sub_str  = 'ggAht2g2H3U(1,2,3,4,5)'

      case (114)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqAht2g2H3U(1,2,3,4,5)'

      case (115)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbAht2g2H3U(1,2,3,4,5)'

      case (116)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpAht2g2H3U(1,2,3,4,5)'

      case (117)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbAht2g2H3U(1,2,3,4,5)'

      case (118)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgAht2g2H3U(1,2,3,4,5)'

      case (119)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpAht2g2H3U(1,2,3,4,5)'

      case (120)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbAht2g2H3U(1,2,3,4,5)'

      case (121)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgAht2g2H3U(1,2,3,4,5)'

      case (122)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'Ah2g2H3(1,2,3,4,5)  '
        sub_str  = 'ggAh2g2H3U(1,2,3,4,5)'

      case (123)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqAh2g2H3U(1,2,3,4,5)'

      case (124)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbAh2g2H3U(1,2,3,4,5)'

      case (125)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpAh2g2H3U(1,2,3,4,5)'

      case (126)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbAh2g2H3U(1,2,3,4,5)'

      case (127)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgAh2g2H3U(1,2,3,4,5)'

      case (128)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpAh2g2H3U(1,2,3,4,5)'

      case (129)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbAh2g2H3U(1,2,3,4,5)'

      case (130)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgAh2g2H3U(1,2,3,4,5)'

      case (131)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'Ahh2g2H3(1,2,3,4,5) '
        sub_str  = 'ggAhh2g2H3U(1,2,3,4,5)'

      case (132)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqAhh2g2H3U(1,2,3,4,5)'

      case (133)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbAhh2g2H3U(1,2,3,4,5)'

      case (134)
        chan_str = 'q Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpAhh2g2H3U(1,2,3,4,5)'

      case (135)
        chan_str = 'q Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbAhh2g2H3U(1,2,3,4,5)'

      case (136)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgAhh2g2H3U(1,2,3,4,5)'

      case (137)
        chan_str = 'qb Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpAhh2g2H3U(1,2,3,4,5)'

      case (138)
        chan_str = 'qb Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbAhh2g2H3U(1,2,3,4,5)'

      case (139)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgAhh2g2H3U(1,2,3,4,5)'

      case (140)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'A2g1H3(1,2,3,4,5)   '
        sub_str  = 'wilsonggA2g1H3U(1,2,3,4,5)'

      case (141)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'wilsongqA2g1H3U(1,2,3,4,5)'

      case (142)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'wilsongqbA2g1H3U(1,2,3,4,5)'

      case (143)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'wilsonqgA2g1H3U(1,2,3,4,5)'

      case (144)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'wilsonqbgA2g1H3U(1,2,3,4,5)'

      case (145)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'Ah2g1H3(1,2,3,4,5)  '
        sub_str  = 'wilsonggAh2g1H3U(1,2,3,4,5)'

      case (146)
        chan_str = 'g q subtraction     '
        me_str   = '                    '
        sub_str  = 'wilsongqAh2g1H3U(1,2,3,4,5)'

      case (147)
        chan_str = 'g qb subtraction    '
        me_str   = '                    '
        sub_str  = 'wilsongqbAh2g1H3U(1,2,3,4,5)'

      case (148)
        chan_str = 'q g subtraction     '
        me_str   = '                    '
        sub_str  = 'wilsonqgAh2g1H3U(1,2,3,4,5)'

      case (149)
        chan_str = 'qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'wilsonqbgAh2g1H3U(1,2,3,4,5)'

      case (150)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'A2g0H3(1,2,3,4,5)   '
        sub_str  = 'wilsonggA2g0H3U(1,2,3,4,5)'

      case (151)
        chan_str = 'g g to l1 l2 l3     '
        me_str   = 'A2g0H3(1,2,3,4,5)   '
        sub_str  = 'wilsonggA2g0H3U(1,2,3,4,5)'

      case default
        print*, 'getchannelH3: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtH3(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtH3 = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (20)
        ! [g, g, l1, l2, l3]
        LIPSwgtH3 = weight_lips((/ 3,4 /))

      case (22)
        ! [g, g, l1, l2, l3]
        LIPSwgtH3 = weight_lips((/ 3,4 /))

      case (24)
        ! [g, g, l1, l2, l3]
        LIPSwgtH3 = weight_lips((/ 3,4 /))

      case (29)
        ! [gt, gt, l1, l2, l3]
        LIPSwgtH3 = weight_lips((/ 3,4 /))

      case (31)
        ! [gt, gt, l1, l2, l3]
        LIPSwgtH3 = weight_lips((/ 3,4 /))

      case (42)
        ! [q, q, l1, l2, l3]
        LIPSwgtH3 = weight_lips((/ 3,4 /))

      case (44)
        ! [qb, qb, l1, l2, l3]
        LIPSwgtH3 = weight_lips((/ 3,4 /))

      case default
        LIPSwgtH3 = 1

      end select
      end
