      function sigUH3(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUH3=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- g g to l1 l2 l3     
        if (qactive_chan(95).and.qselect_chan(95)) then
          current_chan = 95
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggA2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(96).and.qselect_chan(96)) then
          current_chan = 96
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqA2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(97).and.qselect_chan(97)) then
          current_chan = 97
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbA2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(98).and.qselect_chan(98)) then
          current_chan = 98
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpA2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(99).and.qselect_chan(99)) then
          current_chan = 99
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbA2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(100).and.qselect_chan(100)) then
          current_chan = 100
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgA2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(101).and.qselect_chan(101)) then
          current_chan = 101
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpA2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(102).and.qselect_chan(102)) then
          current_chan = 102
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbA2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(103).and.qselect_chan(103)) then
          current_chan = 103
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgA2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3     
        if (qactive_chan(104).and.qselect_chan(104)) then
          current_chan = 104
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAt2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(105).and.qselect_chan(105)) then
          current_chan = 105
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAt2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(106).and.qselect_chan(106)) then
          current_chan = 106
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAt2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(107).and.qselect_chan(107)) then
          current_chan = 107
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAt2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(108).and.qselect_chan(108)) then
          current_chan = 108
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAt2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(109).and.qselect_chan(109)) then
          current_chan = 109
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAt2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(110).and.qselect_chan(110)) then
          current_chan = 110
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAt2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(111).and.qselect_chan(111)) then
          current_chan = 111
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAt2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(112).and.qselect_chan(112)) then
          current_chan = 112
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAt2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3     
        if (qactive_chan(113).and.qselect_chan(113)) then
          current_chan = 113
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAht2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(114).and.qselect_chan(114)) then
          current_chan = 114
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAht2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(115).and.qselect_chan(115)) then
          current_chan = 115
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAht2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(116).and.qselect_chan(116)) then
          current_chan = 116
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAht2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(117).and.qselect_chan(117)) then
          current_chan = 117
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAht2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(118).and.qselect_chan(118)) then
          current_chan = 118
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAht2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(119).and.qselect_chan(119)) then
          current_chan = 119
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAht2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(120).and.qselect_chan(120)) then
          current_chan = 120
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAht2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(121).and.qselect_chan(121)) then
          current_chan = 121
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAht2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3     
        if (qactive_chan(122).and.qselect_chan(122)) then
          current_chan = 122
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(123).and.qselect_chan(123)) then
          current_chan = 123
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(124).and.qselect_chan(124)) then
          current_chan = 124
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(125).and.qselect_chan(125)) then
          current_chan = 125
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(126).and.qselect_chan(126)) then
          current_chan = 126
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(127).and.qselect_chan(127)) then
          current_chan = 127
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(128).and.qselect_chan(128)) then
          current_chan = 128
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(129).and.qselect_chan(129)) then
          current_chan = 129
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(130).and.qselect_chan(130)) then
          current_chan = 130
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3     
        if (qactive_chan(131).and.qselect_chan(131)) then
          current_chan = 131
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAhh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(132).and.qselect_chan(132)) then
          current_chan = 132
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAhh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(133).and.qselect_chan(133)) then
          current_chan = 133
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAhh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(134).and.qselect_chan(134)) then
          current_chan = 134
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAhh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(135).and.qselect_chan(135)) then
          current_chan = 135
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAhh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(136).and.qselect_chan(136)) then
          current_chan = 136
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAhh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(137).and.qselect_chan(137)) then
          current_chan = 137
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAhh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(138).and.qselect_chan(138)) then
          current_chan = 138
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAhh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(139).and.qselect_chan(139)) then
          current_chan = 139
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAhh2g2H3U(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3 wilson
        if (qactive_chan(140).and.qselect_chan(140)) then
          current_chan = 140
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggA2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiatedwilson 
        if (qactive_chan(141).and.qselect_chan(141)) then
          current_chan = 141
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqA2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiatedwilson
        if (qactive_chan(142).and.qselect_chan(142)) then
          current_chan = 142
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbA2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiatedwilson 
        if (qactive_chan(143).and.qselect_chan(143)) then
          current_chan = 143
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgA2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiatedwilson
        if (qactive_chan(144).and.qselect_chan(144)) then
          current_chan = 144
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgA2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3 wilson
        if (qactive_chan(145).and.qselect_chan(145)) then
          current_chan = 145
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAh2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiatedwilson 
        if (qactive_chan(146).and.qselect_chan(146)) then
          current_chan = 146
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAh2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiatedwilson
        if (qactive_chan(147).and.qselect_chan(147)) then
          current_chan = 147
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAh2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiatedwilson 
        if (qactive_chan(148).and.qselect_chan(148)) then
          current_chan = 148
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAh2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiatedwilson
        if (qactive_chan(149).and.qselect_chan(149)) then
          current_chan = 149
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAh2g1H3TNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3 wilson
        if (qactive_chan(150).and.qselect_chan(150)) then
          current_chan = 150
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3 wilson
        if (qactive_chan(151).and.qselect_chan(151)) then
          current_chan = 151
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = 0d0
          wtsum = wtsum + wt
        endif
        sigUH3=sigUH3+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
