      subroutine registerOLH3J()
#ifdef USE_OL  
      use openloops 
      use Parameters_mod, only : initOL_param 
      use Channels_mod
      use Process_mod
#endif 
#ifdef USE_OMP  
      use omp_lib 
#endif 
      implicit none 

#ifdef USE_OMP  
      !> OL is not thread-safe!
      if (omp_get_num_threads() > 1) then
        call omp_set_num_threads(1)
      end if
#endif 

#ifdef USE_OL  

      if ( allocated(OLiproc_chan) ) then
        print*, 'registerOLH3J: already allocated'  
        stop
      end if


c -- register OL decay channel
      allocate(OLiproc_chan(1:ntot_chan+1))
      OLiproc_chan(:)=0
      call initOL_param()

      if (name_proc(1:7).eq.'HTO2L1P') then
          OLiproc_chan(ntot_chan+1) = register_process('25 -> -13 13 2002', 12)

c -- The order of 25 -> -13(npar-2) 13(npar-1) 2002(npar) is the same as NNLOJET PS generator
      else
          write(*,*) 'Invalid process in registerOLH3J: ', name_proc
         stop
      end if

c -- tree level


c -- real


c -- virtual


c -- double real


c -- real virtual


c -- double virtual

      OLntot_chan = 0
      print*, 'registered', OLntot_chan, 'OL amplitudes for process H3J...'  

#endif 

      return
      end
