      function sigRRH3J(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRRH3J=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,8,ipass)
      virtsflag=.false.
      jflag=.false.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(8, (/ 1, 2, 3, 4, 5, 6, 7, 8 /) )
#endif 

c--- g g to g g g l1 l2 l3 
      if (qactive_chan(83).and.qselect_chan(83)) then
        current_chan = 83
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           A5g0H3(1,2,3,4,5,6,7,8)
     .          +A5g0H3(1,2,3,5,4,6,7,8)
     .          +A5g0H3(1,2,4,3,5,6,7,8)
     .          +A5g0H3(1,2,4,5,3,6,7,8)
     .          +A5g0H3(1,2,5,3,4,6,7,8)
     .          +A5g0H3(1,2,5,4,3,6,7,8)
     .          +A5g0H3(1,3,2,4,5,6,7,8)
     .          +A5g0H3(1,3,2,5,4,6,7,8)
     .          +A5g0H3(1,3,4,2,5,6,7,8)
     .          +A5g0H3(1,3,5,2,4,6,7,8)
     .          +A5g0H3(1,4,2,3,5,6,7,8)
     .          +A5g0H3(1,4,3,2,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g g q l1 l2 l3 
      if (qactive_chan(84).and.qselect_chan(84)) then
        current_chan = 84
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(1,2,3,4,5,6,7,8)
     .          +B3g0H3(1,2,4,3,5,6,7,8)
     .          +B3g0H3(1,3,2,4,5,6,7,8)
     .          +B3g0H3(1,3,4,2,5,6,7,8)
     .          +B3g0H3(1,4,2,3,5,6,7,8)
     .          +B3g0H3(1,4,3,2,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g g l1 l2 l3 
      if (qactive_chan(85).and.qselect_chan(85)) then
        current_chan = 85
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(1,3,4,5,2,6,7,8)
     .          +B3g0H3(1,3,5,4,2,6,7,8)
     .          +B3g0H3(1,4,3,5,2,6,7,8)
     .          +B3g0H3(1,4,5,3,2,6,7,8)
     .          +B3g0H3(1,5,3,4,2,6,7,8)
     .          +B3g0H3(1,5,4,3,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g g q l1 l2 l3 
      if (qactive_chan(86).and.qselect_chan(86)) then
        current_chan = 86
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(2,1,3,4,5,6,7,8)
     .          +B3g0H3(2,1,4,3,5,6,7,8)
     .          +B3g0H3(2,3,1,4,5,6,7,8)
     .          +B3g0H3(2,3,4,1,5,6,7,8)
     .          +B3g0H3(2,4,1,3,5,6,7,8)
     .          +B3g0H3(2,4,3,1,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g g l1 l2 l3 
      if (qactive_chan(87).and.qselect_chan(87)) then
        current_chan = 87
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(2,3,4,5,1,6,7,8)
     .          +B3g0H3(2,3,5,4,1,6,7,8)
     .          +B3g0H3(2,4,3,5,1,6,7,8)
     .          +B3g0H3(2,4,5,3,1,6,7,8)
     .          +B3g0H3(2,5,3,4,1,6,7,8)
     .          +B3g0H3(2,5,4,3,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb g q l1 l2 l3 
      if (qactive_chan(88).and.qselect_chan(88)) then
        current_chan = 88
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(3,1,2,4,5,6,7,8)
     .          +B3g0H3(3,1,4,2,5,6,7,8)
     .          +B3g0H3(3,2,1,4,5,6,7,8)
     .          +B3g0H3(3,2,4,1,5,6,7,8)
     .          +B3g0H3(3,4,1,2,5,6,7,8)
     .          +B3g0H3(3,4,2,1,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g g l1 l2 l3 
      if (qactive_chan(89).and.qselect_chan(89)) then
        current_chan = 89
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(3,1,4,5,2,6,7,8)
     .          +B3g0H3(3,1,5,4,2,6,7,8)
     .          +B3g0H3(3,4,1,5,2,6,7,8)
     .          +B3g0H3(3,4,5,1,2,6,7,8)
     .          +B3g0H3(3,5,1,4,2,6,7,8)
     .          +B3g0H3(3,5,4,1,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g g l1 l2 l3 
      if (qactive_chan(90).and.qselect_chan(90)) then
        current_chan = 90
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(3,2,4,5,1,6,7,8)
     .          +B3g0H3(3,2,5,4,1,6,7,8)
     .          +B3g0H3(3,4,2,5,1,6,7,8)
     .          +B3g0H3(3,4,5,2,1,6,7,8)
     .          +B3g0H3(3,5,2,4,1,6,7,8)
     .          +B3g0H3(3,5,4,2,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g g q l1 l2 l3 
      if (qactive_chan(91).and.qselect_chan(91)) then
        current_chan = 91
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(1,2,3,4,5,6,7,8)
     .          +Bt3g0H3(1,2,4,3,5,6,7,8)
     .          +Bt3g0H3(1,3,2,4,5,6,7,8)
     .          +Bt3g0H3(1,3,4,2,5,6,7,8)
     .          +Bt3g0H3(1,4,2,3,5,6,7,8)
     .          +Bt3g0H3(1,4,3,2,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g g l1 l2 l3 
      if (qactive_chan(92).and.qselect_chan(92)) then
        current_chan = 92
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(1,3,4,5,2,6,7,8)
     .          +Bt3g0H3(1,3,5,4,2,6,7,8)
     .          +Bt3g0H3(1,4,3,5,2,6,7,8)
     .          +Bt3g0H3(1,4,5,3,2,6,7,8)
     .          +Bt3g0H3(1,5,3,4,2,6,7,8)
     .          +Bt3g0H3(1,5,4,3,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g g q l1 l2 l3 
      if (qactive_chan(93).and.qselect_chan(93)) then
        current_chan = 93
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(2,1,3,4,5,6,7,8)
     .          +Bt3g0H3(2,1,4,3,5,6,7,8)
     .          +Bt3g0H3(2,3,1,4,5,6,7,8)
     .          +Bt3g0H3(2,3,4,1,5,6,7,8)
     .          +Bt3g0H3(2,4,1,3,5,6,7,8)
     .          +Bt3g0H3(2,4,3,1,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g g l1 l2 l3 
      if (qactive_chan(94).and.qselect_chan(94)) then
        current_chan = 94
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(2,3,4,5,1,6,7,8)
     .          +Bt3g0H3(2,3,5,4,1,6,7,8)
     .          +Bt3g0H3(2,4,3,5,1,6,7,8)
     .          +Bt3g0H3(2,4,5,3,1,6,7,8)
     .          +Bt3g0H3(2,5,3,4,1,6,7,8)
     .          +Bt3g0H3(2,5,4,3,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb g q l1 l2 l3 
      if (qactive_chan(95).and.qselect_chan(95)) then
        current_chan = 95
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(3,1,2,4,5,6,7,8)
     .          +Bt3g0H3(3,1,4,2,5,6,7,8)
     .          +Bt3g0H3(3,2,1,4,5,6,7,8)
     .          +Bt3g0H3(3,2,4,1,5,6,7,8)
     .          +Bt3g0H3(3,4,1,2,5,6,7,8)
     .          +Bt3g0H3(3,4,2,1,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g g l1 l2 l3 
      if (qactive_chan(96).and.qselect_chan(96)) then
        current_chan = 96
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(3,1,4,5,2,6,7,8)
     .          +Bt3g0H3(3,1,5,4,2,6,7,8)
     .          +Bt3g0H3(3,4,1,5,2,6,7,8)
     .          +Bt3g0H3(3,4,5,1,2,6,7,8)
     .          +Bt3g0H3(3,5,1,4,2,6,7,8)
     .          +Bt3g0H3(3,5,4,1,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g g l1 l2 l3 
      if (qactive_chan(97).and.qselect_chan(97)) then
        current_chan = 97
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(3,2,4,5,1,6,7,8)
     .          +Bt3g0H3(3,2,5,4,1,6,7,8)
     .          +Bt3g0H3(3,4,2,5,1,6,7,8)
     .          +Bt3g0H3(3,4,5,2,1,6,7,8)
     .          +Bt3g0H3(3,5,2,4,1,6,7,8)
     .          +Bt3g0H3(3,5,4,2,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt gt q l1 l2 l3 
      if (qactive_chan(98).and.qselect_chan(98)) then
        current_chan = 98
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(1,2,3,4,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt gt l1 l2 l3 
      if (qactive_chan(99).and.qselect_chan(99)) then
        current_chan = 99
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(1,3,4,5,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt gt q l1 l2 l3 
      if (qactive_chan(100).and.qselect_chan(100)) then
        current_chan = 100
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(2,1,3,4,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt gt l1 l2 l3 
      if (qactive_chan(101).and.qselect_chan(101)) then
        current_chan = 101
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(2,3,4,5,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb gt q l1 l2 l3 
      if (qactive_chan(102).and.qselect_chan(102)) then
        current_chan = 102
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Btt3g0H3(3,1,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt gt l1 l2 l3 
      if (qactive_chan(103).and.qselect_chan(103)) then
        current_chan = 103
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(3,1,4,5,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt gt l1 l2 l3 
      if (qactive_chan(104).and.qselect_chan(104)) then
        current_chan = 104
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(3,2,4,5,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to Q Qb q l1 l2 l3 
      if (qactive_chan(105).and.qselect_chan(105)) then
        current_chan = 105
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(1,2,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to g Qb q l1 l2 l3 
      if (qactive_chan(106).and.qselect_chan(106)) then
        current_chan = 106
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(1,3,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to g Q q l1 l2 l3 
      if (qactive_chan(107).and.qselect_chan(107)) then
        current_chan = 107
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,2,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(1,3,4,2,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g Q Qb l1 l2 l3 
      if (qactive_chan(108).and.qselect_chan(108)) then
        current_chan = 108
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(1,3,4,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to Q Qb q l1 l2 l3 
      if (qactive_chan(109).and.qselect_chan(109)) then
        current_chan = 109
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(2,1,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g Q Qb l1 l2 l3 
      if (qactive_chan(110).and.qselect_chan(110)) then
        current_chan = 110
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(2,3,4,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb Q Qb l1 l2 l3 
      if (qactive_chan(111).and.qselect_chan(111)) then
        current_chan = 111
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(3,1,4,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb Q Qb l1 l2 l3 
      if (qactive_chan(112).and.qselect_chan(112)) then
        current_chan = 112
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(3,2,4,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb g Qb l1 l2 l3 
      if (qactive_chan(113).and.qselect_chan(113)) then
        current_chan = 113
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,2,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(3,4,2,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb g Q l1 l2 l3 
      if (qactive_chan(114).and.qselect_chan(114)) then
        current_chan = 114
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,5,2,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(3,4,5,2,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to Q Qb q l1 l2 l3 
      if (qactive_chan(115).and.qselect_chan(115)) then
        current_chan = 115
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(1,2,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to g Qb q l1 l2 l3 
      if (qactive_chan(116).and.qselect_chan(116)) then
        current_chan = 116
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(1,3,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to g Q q l1 l2 l3 
      if (qactive_chan(117).and.qselect_chan(117)) then
        current_chan = 117
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,2,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(1,3,4,2,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g Q Qb l1 l2 l3 
      if (qactive_chan(118).and.qselect_chan(118)) then
        current_chan = 118
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(1,3,4,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to Q Qb q l1 l2 l3 
      if (qactive_chan(119).and.qselect_chan(119)) then
        current_chan = 119
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(2,1,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g Q Qb l1 l2 l3 
      if (qactive_chan(120).and.qselect_chan(120)) then
        current_chan = 120
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(2,3,4,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb Q Qb l1 l2 l3 
      if (qactive_chan(121).and.qselect_chan(121)) then
        current_chan = 121
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(3,1,4,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb Q Qb l1 l2 l3 
      if (qactive_chan(122).and.qselect_chan(122)) then
        current_chan = 122
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(3,2,4,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb g Qb l1 l2 l3 
      if (qactive_chan(123).and.qselect_chan(123)) then
        current_chan = 123
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,2,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(3,4,2,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb g Q l1 l2 l3 
      if (qactive_chan(124).and.qselect_chan(124)) then
        current_chan = 124
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,5,2,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(3,4,5,2,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q qb q l1 l2 l3 
      if (qactive_chan(125).and.qselect_chan(125)) then
        current_chan = 125
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(1,2,3,4,5,6,7,8)
     .          +D1g0H3F(1,2,5,4,3,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g qb q l1 l2 l3 
      if (qactive_chan(126).and.qselect_chan(126)) then
        current_chan = 126
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0H3F(1,3,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to g q q l1 l2 l3 
      if (qactive_chan(127).and.qselect_chan(127)) then
        current_chan = 127
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,2,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(1,3,4,2,5,6,7,8)
     .          +D1g0H3F(1,3,5,2,4,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q qb q l1 l2 l3 
      if (qactive_chan(128).and.qselect_chan(128)) then
        current_chan = 128
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(2,1,3,4,5,6,7,8)
     .          +D1g0H3F(2,1,5,4,3,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g qb q l1 l2 l3 
      if (qactive_chan(129).and.qselect_chan(129)) then
        current_chan = 129
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,1,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0H3F(2,3,1,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb qb q l1 l2 l3 
      if (qactive_chan(130).and.qselect_chan(130)) then
        current_chan = 130
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(3,1,2,4,5,6,7,8)
     .          +D1g0H3F(4,1,2,3,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb qb q l1 l2 l3 
      if (qactive_chan(131).and.qselect_chan(131)) then
        current_chan = 131
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,1,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(3,2,1,4,5,6,7,8)
     .          +D1g0H3F(4,2,1,3,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb g qb l1 l2 l3 
      if (qactive_chan(132).and.qselect_chan(132)) then
        current_chan = 132
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,1,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(3,4,1,5,2,6,7,8)
     .          +D1g0H3F(5,4,1,3,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q qb q l1 l2 l3 
      if (qactive_chan(133).and.qselect_chan(133)) then
        current_chan = 133
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(1,2,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g qb q l1 l2 l3 
      if (qactive_chan(134).and.qselect_chan(134)) then
        current_chan = 134
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(1,3,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to g q q l1 l2 l3 
      if (qactive_chan(135).and.qselect_chan(135)) then
        current_chan = 135
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,2,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(1,3,4,2,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q qb q l1 l2 l3 
      if (qactive_chan(136).and.qselect_chan(136)) then
        current_chan = 136
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(2,1,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g qb q l1 l2 l3 
      if (qactive_chan(137).and.qselect_chan(137)) then
        current_chan = 137
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,1,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(2,3,1,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb qb q l1 l2 l3 
      if (qactive_chan(138).and.qselect_chan(138)) then
        current_chan = 138
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(3,1,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb qb q l1 l2 l3 
      if (qactive_chan(139).and.qselect_chan(139)) then
        current_chan = 139
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,1,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(3,2,1,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb g qb l1 l2 l3 
      if (qactive_chan(140).and.qselect_chan(140)) then
        current_chan = 140
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,1,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(3,4,1,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRRH3J=rnorm*wtsum

      return
      end
