      subroutine getlumiH3JJ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    6,   13,   26,   31,   38,   45,   84,          
     &           89,   98,  109,  120,  131,  138,  145,  202,          
     &          207,  214)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,    9,   27,   34,   41,   48,   58,   68,          
     &           76,   87,   92,   94,  105,  116,  127,  134,          
     &          141,  156,  166,  176,  184,  192,  200,  203,          
     &          210)
!       [30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    3,   10,   18,   22,   28,   35,   42,   51,          
     &           61,   69,   77,   95,  106,  117,  128,  135,          
     &          142,  150,  160,  170,  178,  186,  194,  204,          
     &          211,  219,  223)
!       [30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    4,   11,   29,   36,   43,   52,   62,   71,          
     &           79,   85,   90,   96,  107,  118,  129,  136,          
     &          143,  154,  164,  174,  182,  190,  198,  205,          
     &          212)
!       [0, 30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (    5,   12,   19,   24,   30,   37,   44,   53,          
     &           63,   72,   80,   97,  108,  119,  130,  137,          
     &          144,  151,  161,  171,  180,  188,  196,  206,          
     &          213,  220,  225)
!       [-30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    7,   14,   32,   39,   46,   54,   64,   73,          
     &           81,   86,   91,   99,  110,  121,  132,  139,          
     &          146,  155,  165,  175,  183,  191,  199,  208,          
     &          215)
!       [0, -30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    8,   15,   33,   40,   47,   55,   65,   74,          
     &           82,   88,   93,  100,  111,  122,  133,  140,          
     &          147,  157,  167,  177,  185,  193,  201,  209,          
     &          216)
!       [-30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   16,   49,   59,  102,  113,  124,  148,  158,          
     &          168,  217)
!       [31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   17,   50,   60,   70,  101,  112,  123,  149,          
     &          159,  169,  218)
!       [31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   20,   56,   66,   75,  104,  115,  126,  152,          
     &          162,  172,  221)
!       [-31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   21,   57,   67,  103,  114,  125,  153,  163,          
     &          173,  222)
!       [-31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   23,   78,  179,  187,  195,  224)
!       [30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   25,   83,  181,  189,  197,  226)
!       [-30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case default
          print*, "getlumiH3JJ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiH3JJ



      function getlumiidH3JJ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    6,   13,   26,   31,   38,   45,   84,
     &           89,   98,  109,  120,  131,  138,  145,  202,
     &          207,  214)
          id  = 1
          ip1 = 0
          ip2 = 0

        case (    2,    9,   27,   34,   41,   48,   58,   68,
     &           76,   87,   92,   94,  105,  116,  127,  134,
     &          141,  156,  166,  176,  184,  192,  200,  203,
     &          210)
          id  = 2
          ip1 = 30
          ip2 = 0

        case (    3,   10,   18,   22,   28,   35,   42,   51,
     &           61,   69,   77,   95,  106,  117,  128,  135,
     &          142,  150,  160,  170,  178,  186,  194,  204,
     &          211,  219,  223)
          id  = 3
          ip1 = 30
          ip2 = -30

        case (    4,   11,   29,   36,   43,   52,   62,   71,
     &           79,   85,   90,   96,  107,  118,  129,  136,
     &          143,  154,  164,  174,  182,  190,  198,  205,
     &          212)
          id  = 4
          ip1 = 0
          ip2 = 30

        case (    5,   12,   19,   24,   30,   37,   44,   53,
     &           63,   72,   80,   97,  108,  119,  130,  137,
     &          144,  151,  161,  171,  180,  188,  196,  206,
     &          213,  220,  225)
          id  = 5
          ip1 = -30
          ip2 = 30

        case (    7,   14,   32,   39,   46,   54,   64,   73,
     &           81,   86,   91,   99,  110,  121,  132,  139,
     &          146,  155,  165,  175,  183,  191,  199,  208,
     &          215)
          id  = 6
          ip1 = 0
          ip2 = -30

        case (    8,   15,   33,   40,   47,   55,   65,   74,
     &           82,   88,   93,  100,  111,  122,  133,  140,
     &          147,  157,  167,  177,  185,  193,  201,  209,
     &          216)
          id  = 7
          ip1 = -30
          ip2 = 0

        case (   16,   49,   59,  102,  113,  124,  148,  158,
     &          168,  217)
          id  = 8
          ip1 = 31
          ip2 = -31

        case (   17,   50,   60,   70,  101,  112,  123,  149,
     &          159,  169,  218)
          id  = 9
          ip1 = 31
          ip2 = 31

        case (   20,   56,   66,   75,  104,  115,  126,  152,
     &          162,  172,  221)
          id  = 10
          ip1 = -31
          ip2 = -31

        case (   21,   57,   67,  103,  114,  125,  153,  163,
     &          173,  222)
          id  = 11
          ip1 = -31
          ip2 = 31

        case (   23,   78,  179,  187,  195,  224)
          id  = 12
          ip1 = 30
          ip2 = 30

        case (   25,   83,  181,  189,  197,  226)
          id  = 13
          ip1 = -30
          ip2 = -30

        case default
          print*, "getlumiidH3JJ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidH3JJ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiH3JJ()
        use PineAPPL_mod
        use CKM_mod
!       [0, 0]
        call register_lumi_pine(
     &         [    1,    6,   13,   26,   31,   38,   45,   84,
     &             89,   98,  109,  120,  131,  138,  145,  202,
     &            207,  214],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [30, 0]
        call register_lumi_pine(
     &         [    2,    9,   27,   34,   41,   48,   58,   68,
     &             76,   87,   92,   94,  105,  116,  127,  134,
     &            141,  156,  166,  176,  184,  192,  200,  203,
     &            210],
     &         5,
     &         [    1,   21,    2,   21,    3,   21,    4,   21,
     &              5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [30, -30]
        call register_lumi_pine(
     &         [    3,   10,   18,   22,   28,   35,   42,   51,
     &             61,   69,   77,   95,  106,  117,  128,  135,
     &            142,  150,  160,  170,  178,  186,  194,  204,
     &            211,  219,  223],
     &         5,
     &         [    1,   -1,    2,   -2,    3,   -3,    4,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, 30]
        call register_lumi_pine(
     &         [    4,   11,   29,   36,   43,   52,   62,   71,
     &             79,   85,   90,   96,  107,  118,  129,  136,
     &            143,  154,  164,  174,  182,  190,  198,  205,
     &            212],
     &         5,
     &         [   21,    1,   21,    2,   21,    3,   21,    4,
     &             21,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 30]
        call register_lumi_pine(
     &         [    5,   12,   19,   24,   30,   37,   44,   53,
     &             63,   72,   80,   97,  108,  119,  130,  137,
     &            144,  151,  161,  171,  180,  188,  196,  206,
     &            213,  220,  225],
     &         5,
     &         [   -1,    1,   -2,    2,   -3,    3,   -4,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, -30]
        call register_lumi_pine(
     &         [    7,   14,   32,   39,   46,   54,   64,   73,
     &             81,   86,   91,   99,  110,  121,  132,  139,
     &            146,  155,  165,  175,  183,  191,  199,  208,
     &            215],
     &         5,
     &         [   21,   -1,   21,   -2,   21,   -3,   21,   -4,
     &             21,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 0]
        call register_lumi_pine(
     &         [    8,   15,   33,   40,   47,   55,   65,   74,
     &             82,   88,   93,  100,  111,  122,  133,  140,
     &            147,  157,  167,  177,  185,  193,  201,  209,
     &            216],
     &         5,
     &         [   -1,   21,   -2,   21,   -3,   21,   -4,   21,
     &             -5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [31, -31]
        call register_lumi_pine(
     &         [   16,   49,   59,  102,  113,  124,  148,  158,
     &            168,  217],
     &         25,
     &         [    1,   -1,    1,   -2,    1,   -3,    1,   -4,
     &              1,   -5,    2,   -1,    2,   -2,    2,   -3,
     &              2,   -4,    2,   -5,    3,   -1,    3,   -2,
     &              3,   -3,    3,   -4,    3,   -5,    4,   -1,
     &              4,   -2,    4,   -3,    4,   -4,    4,   -5,
     &              5,   -1,    5,   -2,    5,   -3,    5,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [31, 31]
        call register_lumi_pine(
     &         [   17,   50,   60,   70,  101,  112,  123,  149,
     &            159,  169,  218],
     &         25,
     &         [    1,    1,    1,    2,    1,    3,    1,    4,
     &              1,    5,    2,    1,    2,    2,    2,    3,
     &              2,    4,    2,    5,    3,    1,    3,    2,
     &              3,    3,    3,    4,    3,    5,    4,    1,
     &              4,    2,    4,    3,    4,    4,    4,    5,
     &              5,    1,    5,    2,    5,    3,    5,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, -31]
        call register_lumi_pine(
     &         [   20,   56,   66,   75,  104,  115,  126,  152,
     &            162,  172,  221],
     &         25,
     &         [   -1,   -1,   -1,   -2,   -1,   -3,   -1,   -4,
     &             -1,   -5,   -2,   -1,   -2,   -2,   -2,   -3,
     &             -2,   -4,   -2,   -5,   -3,   -1,   -3,   -2,
     &             -3,   -3,   -3,   -4,   -3,   -5,   -4,   -1,
     &             -4,   -2,   -4,   -3,   -4,   -4,   -4,   -5,
     &             -5,   -1,   -5,   -2,   -5,   -3,   -5,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, 31]
        call register_lumi_pine(
     &         [   21,   57,   67,  103,  114,  125,  153,  163,
     &            173,  222],
     &         25,
     &         [   -1,    1,   -1,    2,   -1,    3,   -1,    4,
     &             -1,    5,   -2,    1,   -2,    2,   -2,    3,
     &             -2,    4,   -2,    5,   -3,    1,   -3,    2,
     &             -3,    3,   -3,    4,   -3,    5,   -4,    1,
     &             -4,    2,   -4,    3,   -4,    4,   -4,    5,
     &             -5,    1,   -5,    2,   -5,    3,   -5,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [30, 30]
        call register_lumi_pine(
     &         [   23,   78,  179,  187,  195,  224],
     &         5,
     &         [    1,    1,    2,    2,    3,    3,    4,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, -30]
        call register_lumi_pine(
     &         [   25,   83,  181,  189,  197,  226],
     &         5,
     &         [   -1,   -1,   -2,   -2,   -3,   -3,   -4,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiH3JJ


#endif


