      function sigBH3JJJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigBH3JJJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,8,ipass)
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(8, (/ 1, 2, 3, 4, 5, 6, 7, 8 /) )
#endif 

c--- g g to g g g l1 l2 l3 
      if (qactive_chan(1).and.qselect_chan(1)) then
        current_chan = 1
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           A5g0H3(1,2,3,4,5,6,7,8)
     .          +A5g0H3(1,2,3,5,4,6,7,8)
     .          +A5g0H3(1,2,4,3,5,6,7,8)
     .          +A5g0H3(1,2,4,5,3,6,7,8)
     .          +A5g0H3(1,2,5,3,4,6,7,8)
     .          +A5g0H3(1,2,5,4,3,6,7,8)
     .          +A5g0H3(1,3,2,4,5,6,7,8)
     .          +A5g0H3(1,3,2,5,4,6,7,8)
     .          +A5g0H3(1,3,4,2,5,6,7,8)
     .          +A5g0H3(1,3,5,2,4,6,7,8)
     .          +A5g0H3(1,4,2,3,5,6,7,8)
     .          +A5g0H3(1,4,3,2,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g g q l1 l2 l3 
      if (qactive_chan(2).and.qselect_chan(2)) then
        current_chan = 2
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(1,2,3,4,5,6,7,8)
     .          +B3g0H3(1,2,4,3,5,6,7,8)
     .          +B3g0H3(1,3,2,4,5,6,7,8)
     .          +B3g0H3(1,3,4,2,5,6,7,8)
     .          +B3g0H3(1,4,2,3,5,6,7,8)
     .          +B3g0H3(1,4,3,2,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g g l1 l2 l3 
      if (qactive_chan(3).and.qselect_chan(3)) then
        current_chan = 3
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(1,3,4,5,2,6,7,8)
     .          +B3g0H3(1,3,5,4,2,6,7,8)
     .          +B3g0H3(1,4,3,5,2,6,7,8)
     .          +B3g0H3(1,4,5,3,2,6,7,8)
     .          +B3g0H3(1,5,3,4,2,6,7,8)
     .          +B3g0H3(1,5,4,3,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g g q l1 l2 l3 
      if (qactive_chan(4).and.qselect_chan(4)) then
        current_chan = 4
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(2,1,3,4,5,6,7,8)
     .          +B3g0H3(2,1,4,3,5,6,7,8)
     .          +B3g0H3(2,3,1,4,5,6,7,8)
     .          +B3g0H3(2,3,4,1,5,6,7,8)
     .          +B3g0H3(2,4,1,3,5,6,7,8)
     .          +B3g0H3(2,4,3,1,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g g l1 l2 l3 
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(2,3,4,5,1,6,7,8)
     .          +B3g0H3(2,3,5,4,1,6,7,8)
     .          +B3g0H3(2,4,3,5,1,6,7,8)
     .          +B3g0H3(2,4,5,3,1,6,7,8)
     .          +B3g0H3(2,5,3,4,1,6,7,8)
     .          +B3g0H3(2,5,4,3,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb g q l1 l2 l3 
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(3,1,2,4,5,6,7,8)
     .          +B3g0H3(3,1,4,2,5,6,7,8)
     .          +B3g0H3(3,2,1,4,5,6,7,8)
     .          +B3g0H3(3,2,4,1,5,6,7,8)
     .          +B3g0H3(3,4,1,2,5,6,7,8)
     .          +B3g0H3(3,4,2,1,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g g l1 l2 l3 
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(3,1,4,5,2,6,7,8)
     .          +B3g0H3(3,1,5,4,2,6,7,8)
     .          +B3g0H3(3,4,1,5,2,6,7,8)
     .          +B3g0H3(3,4,5,1,2,6,7,8)
     .          +B3g0H3(3,5,1,4,2,6,7,8)
     .          +B3g0H3(3,5,4,1,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g g l1 l2 l3 
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0H3(3,2,4,5,1,6,7,8)
     .          +B3g0H3(3,2,5,4,1,6,7,8)
     .          +B3g0H3(3,4,2,5,1,6,7,8)
     .          +B3g0H3(3,4,5,2,1,6,7,8)
     .          +B3g0H3(3,5,2,4,1,6,7,8)
     .          +B3g0H3(3,5,4,2,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g g q l1 l2 l3 
      if (qactive_chan(9).and.qselect_chan(9)) then
        current_chan = 9
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(1,2,3,4,5,6,7,8)
     .          +Bt3g0H3(1,2,4,3,5,6,7,8)
     .          +Bt3g0H3(1,3,2,4,5,6,7,8)
     .          +Bt3g0H3(1,3,4,2,5,6,7,8)
     .          +Bt3g0H3(1,4,2,3,5,6,7,8)
     .          +Bt3g0H3(1,4,3,2,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g g l1 l2 l3 
      if (qactive_chan(10).and.qselect_chan(10)) then
        current_chan = 10
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(1,3,4,5,2,6,7,8)
     .          +Bt3g0H3(1,3,5,4,2,6,7,8)
     .          +Bt3g0H3(1,4,3,5,2,6,7,8)
     .          +Bt3g0H3(1,4,5,3,2,6,7,8)
     .          +Bt3g0H3(1,5,3,4,2,6,7,8)
     .          +Bt3g0H3(1,5,4,3,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g g q l1 l2 l3 
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(2,1,3,4,5,6,7,8)
     .          +Bt3g0H3(2,1,4,3,5,6,7,8)
     .          +Bt3g0H3(2,3,1,4,5,6,7,8)
     .          +Bt3g0H3(2,3,4,1,5,6,7,8)
     .          +Bt3g0H3(2,4,1,3,5,6,7,8)
     .          +Bt3g0H3(2,4,3,1,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g g l1 l2 l3 
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(2,3,4,5,1,6,7,8)
     .          +Bt3g0H3(2,3,5,4,1,6,7,8)
     .          +Bt3g0H3(2,4,3,5,1,6,7,8)
     .          +Bt3g0H3(2,4,5,3,1,6,7,8)
     .          +Bt3g0H3(2,5,3,4,1,6,7,8)
     .          +Bt3g0H3(2,5,4,3,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb g q l1 l2 l3 
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(3,1,2,4,5,6,7,8)
     .          +Bt3g0H3(3,1,4,2,5,6,7,8)
     .          +Bt3g0H3(3,2,1,4,5,6,7,8)
     .          +Bt3g0H3(3,2,4,1,5,6,7,8)
     .          +Bt3g0H3(3,4,1,2,5,6,7,8)
     .          +Bt3g0H3(3,4,2,1,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g g l1 l2 l3 
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(3,1,4,5,2,6,7,8)
     .          +Bt3g0H3(3,1,5,4,2,6,7,8)
     .          +Bt3g0H3(3,4,1,5,2,6,7,8)
     .          +Bt3g0H3(3,4,5,1,2,6,7,8)
     .          +Bt3g0H3(3,5,1,4,2,6,7,8)
     .          +Bt3g0H3(3,5,4,1,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g g l1 l2 l3 
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0H3(3,2,4,5,1,6,7,8)
     .          +Bt3g0H3(3,2,5,4,1,6,7,8)
     .          +Bt3g0H3(3,4,2,5,1,6,7,8)
     .          +Bt3g0H3(3,4,5,2,1,6,7,8)
     .          +Bt3g0H3(3,5,2,4,1,6,7,8)
     .          +Bt3g0H3(3,5,4,2,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt gt q l1 l2 l3 
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(1,2,3,4,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt gt l1 l2 l3 
      if (qactive_chan(17).and.qselect_chan(17)) then
        current_chan = 17
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(1,3,4,5,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt gt q l1 l2 l3 
      if (qactive_chan(18).and.qselect_chan(18)) then
        current_chan = 18
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(2,1,3,4,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt gt l1 l2 l3 
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(2,3,4,5,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb gt q l1 l2 l3 
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Btt3g0H3(3,1,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt gt l1 l2 l3 
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(3,1,4,5,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt gt l1 l2 l3 
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0H3(3,2,4,5,1,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to Q Qb q l1 l2 l3 
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(1,2,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to g Qb q l1 l2 l3 
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(1,3,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to g Q q l1 l2 l3 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,2,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(1,3,4,2,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g Q Qb l1 l2 l3 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(1,3,4,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to Q Qb q l1 l2 l3 
      if (qactive_chan(27).and.qselect_chan(27)) then
        current_chan = 27
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(2,1,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g Q Qb l1 l2 l3 
      if (qactive_chan(28).and.qselect_chan(28)) then
        current_chan = 28
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(2,3,4,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb Q Qb l1 l2 l3 
      if (qactive_chan(29).and.qselect_chan(29)) then
        current_chan = 29
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(3,1,4,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb Q Qb l1 l2 l3 
      if (qactive_chan(30).and.qselect_chan(30)) then
        current_chan = 30
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(3,2,4,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb g Qb l1 l2 l3 
      if (qactive_chan(31).and.qselect_chan(31)) then
        current_chan = 31
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,2,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(3,4,2,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb g Q l1 l2 l3 
      if (qactive_chan(32).and.qselect_chan(32)) then
        current_chan = 32
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,5,2,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0H3F(3,4,5,2,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to Q Qb q l1 l2 l3 
      if (qactive_chan(33).and.qselect_chan(33)) then
        current_chan = 33
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(1,2,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to g Qb q l1 l2 l3 
      if (qactive_chan(34).and.qselect_chan(34)) then
        current_chan = 34
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(1,3,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to g Q q l1 l2 l3 
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,2,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(1,3,4,2,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g Q Qb l1 l2 l3 
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(1,3,4,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to Q Qb q l1 l2 l3 
      if (qactive_chan(37).and.qselect_chan(37)) then
        current_chan = 37
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(2,1,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g Q Qb l1 l2 l3 
      if (qactive_chan(38).and.qselect_chan(38)) then
        current_chan = 38
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(2,3,4,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb Q Qb l1 l2 l3 
      if (qactive_chan(39).and.qselect_chan(39)) then
        current_chan = 39
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,4,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(3,1,4,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb Q Qb l1 l2 l3 
      if (qactive_chan(40).and.qselect_chan(40)) then
        current_chan = 40
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,4,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(3,2,4,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb g Qb l1 l2 l3 
      if (qactive_chan(41).and.qselect_chan(41)) then
        current_chan = 41
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,2,5,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(3,4,2,5,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb g Q l1 l2 l3 
      if (qactive_chan(42).and.qselect_chan(42)) then
        current_chan = 42
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,5,2,1,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Ct1g0H3F(3,4,5,2,1,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q qb q l1 l2 l3 
      if (qactive_chan(43).and.qselect_chan(43)) then
        current_chan = 43
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(1,2,3,4,5,6,7,8)
     .          +D1g0H3F(1,2,5,4,3,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g qb q l1 l2 l3 
      if (qactive_chan(44).and.qselect_chan(44)) then
        current_chan = 44
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0H3F(1,3,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to g q q l1 l2 l3 
      if (qactive_chan(45).and.qselect_chan(45)) then
        current_chan = 45
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,2,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(1,3,4,2,5,6,7,8)
     .          +D1g0H3F(1,3,5,2,4,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q qb q l1 l2 l3 
      if (qactive_chan(46).and.qselect_chan(46)) then
        current_chan = 46
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(2,1,3,4,5,6,7,8)
     .          +D1g0H3F(2,1,5,4,3,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g qb q l1 l2 l3 
      if (qactive_chan(47).and.qselect_chan(47)) then
        current_chan = 47
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,1,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0H3F(2,3,1,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb qb q l1 l2 l3 
      if (qactive_chan(48).and.qselect_chan(48)) then
        current_chan = 48
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(3,1,2,4,5,6,7,8)
     .          +D1g0H3F(4,1,2,3,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb qb q l1 l2 l3 
      if (qactive_chan(49).and.qselect_chan(49)) then
        current_chan = 49
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,1,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(3,2,1,4,5,6,7,8)
     .          +D1g0H3F(4,2,1,3,5,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb g qb l1 l2 l3 
      if (qactive_chan(50).and.qselect_chan(50)) then
        current_chan = 50
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,1,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           D1g0H3F(3,4,1,5,2,6,7,8)
     .          +D1g0H3F(5,4,1,3,2,6,7,8) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q qb q l1 l2 l3 
      if (qactive_chan(51).and.qselect_chan(51)) then
        current_chan = 51
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,2,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(1,2,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g qb q l1 l2 l3 
      if (qactive_chan(52).and.qselect_chan(52)) then
        current_chan = 52
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(1,3,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to g q q l1 l2 l3 
      if (qactive_chan(53).and.qselect_chan(53)) then
        current_chan = 53
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 1,3,4,2,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(1,3,4,2,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q qb q l1 l2 l3 
      if (qactive_chan(54).and.qselect_chan(54)) then
        current_chan = 54
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,1,3,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(2,1,3,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g qb q l1 l2 l3 
      if (qactive_chan(55).and.qselect_chan(55)) then
        current_chan = 55
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 2,3,1,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(2,3,1,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb qb q l1 l2 l3 
      if (qactive_chan(56).and.qselect_chan(56)) then
        current_chan = 56
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,1,2,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(3,1,2,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb qb q l1 l2 l3 
      if (qactive_chan(57).and.qselect_chan(57)) then
        current_chan = 57
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,2,1,4,5,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(3,2,1,4,5,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb g qb l1 l2 l3 
      if (qactive_chan(58).and.qselect_chan(58)) then
        current_chan = 58
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(8, (/ 3,4,1,5,2,6,7,8 /))
        call getqcdnorm(ix,partons,factor, 8, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0H3(3,4,1,5,2,6,7,8)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigBH3JJJ=rnorm*wtsum

      return
      end
