      function sigTNLOH4(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLOH4=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(6,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(6,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- g g to l1 l2 l3 l4  
        if (qactive_chan(9).and.qselect_chan(9)) then
          current_chan = 9
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggA2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(10).and.qselect_chan(10)) then
          current_chan = 10
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqA2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(11).and.qselect_chan(11)) then
          current_chan = 11
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbA2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(12).and.qselect_chan(12)) then
          current_chan = 12
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgA2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(13).and.qselect_chan(13)) then
          current_chan = 13
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgA2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3 l4  
        if (qactive_chan(14).and.qselect_chan(14)) then
          current_chan = 14
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggAh2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(15).and.qselect_chan(15)) then
          current_chan = 15
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqAh2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(16).and.qselect_chan(16)) then
          current_chan = 16
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbAh2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(17).and.qselect_chan(17)) then
          current_chan = 17
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgAh2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(18).and.qselect_chan(18)) then
          current_chan = 18
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgAh2g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to l1 l2 l3 l4 wilson
        if (qactive_chan(19).and.qselect_chan(19)) then
          current_chan = 19
          ip1_chan     = 0
          ip2_chan     = 0
          wt = 0d0
          wtsum = wtsum + wt
        endif
        sigTNLOH4=sigTNLOH4+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
