      subroutine getlumiH4JJJ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    6,   13,   20)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,    9,   16,   23,   33,   43,   51)
!       [30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    3,   10,   17,   26,   36,   44,   52)
!       [30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    4,   11,   18,   27,   37,   46,   54)
!       [0, 30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (    5,   12,   19,   28,   38,   47,   55)
!       [-30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    7,   14,   21,   29,   39,   48,   56)
!       [0, -30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    8,   15,   22,   30,   40,   49,   57)
!       [-30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   24,   34)
!       [31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   25,   35,   45)
!       [31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   31,   41,   50)
!       [-31, -31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   32,   42)
!       [-31, 31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   53)
!       [30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   58)
!       [-30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case default
          print*, "getlumiH4JJJ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiH4JJJ



      function getlumiidH4JJJ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    6,   13,   20)
          id  = 1
          ip1 = 0
          ip2 = 0

        case (    2,    9,   16,   23,   33,   43,   51)
          id  = 2
          ip1 = 30
          ip2 = 0

        case (    3,   10,   17,   26,   36,   44,   52)
          id  = 3
          ip1 = 30
          ip2 = -30

        case (    4,   11,   18,   27,   37,   46,   54)
          id  = 4
          ip1 = 0
          ip2 = 30

        case (    5,   12,   19,   28,   38,   47,   55)
          id  = 5
          ip1 = -30
          ip2 = 30

        case (    7,   14,   21,   29,   39,   48,   56)
          id  = 6
          ip1 = 0
          ip2 = -30

        case (    8,   15,   22,   30,   40,   49,   57)
          id  = 7
          ip1 = -30
          ip2 = 0

        case (   24,   34)
          id  = 8
          ip1 = 31
          ip2 = -31

        case (   25,   35,   45)
          id  = 9
          ip1 = 31
          ip2 = 31

        case (   31,   41,   50)
          id  = 10
          ip1 = -31
          ip2 = -31

        case (   32,   42)
          id  = 11
          ip1 = -31
          ip2 = 31

        case (   53)
          id  = 12
          ip1 = 30
          ip2 = 30

        case (   58)
          id  = 13
          ip1 = -30
          ip2 = -30

        case default
          print*, "getlumiidH4JJJ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidH4JJJ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiH4JJJ()
        use PineAPPL_mod
        use CKM_mod
!       [0, 0]
        call register_lumi_pine(
     &         [    1,    6,   13,   20],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [30, 0]
        call register_lumi_pine(
     &         [    2,    9,   16,   23,   33,   43,   51],
     &         5,
     &         [    1,   21,    2,   21,    3,   21,    4,   21,
     &              5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [30, -30]
        call register_lumi_pine(
     &         [    3,   10,   17,   26,   36,   44,   52],
     &         5,
     &         [    1,   -1,    2,   -2,    3,   -3,    4,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, 30]
        call register_lumi_pine(
     &         [    4,   11,   18,   27,   37,   46,   54],
     &         5,
     &         [   21,    1,   21,    2,   21,    3,   21,    4,
     &             21,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 30]
        call register_lumi_pine(
     &         [    5,   12,   19,   28,   38,   47,   55],
     &         5,
     &         [   -1,    1,   -2,    2,   -3,    3,   -4,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, -30]
        call register_lumi_pine(
     &         [    7,   14,   21,   29,   39,   48,   56],
     &         5,
     &         [   21,   -1,   21,   -2,   21,   -3,   21,   -4,
     &             21,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 0]
        call register_lumi_pine(
     &         [    8,   15,   22,   30,   40,   49,   57],
     &         5,
     &         [   -1,   21,   -2,   21,   -3,   21,   -4,   21,
     &             -5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [31, -31]
        call register_lumi_pine(
     &         [   24,   34],
     &         25,
     &         [    1,   -1,    1,   -2,    1,   -3,    1,   -4,
     &              1,   -5,    2,   -1,    2,   -2,    2,   -3,
     &              2,   -4,    2,   -5,    3,   -1,    3,   -2,
     &              3,   -3,    3,   -4,    3,   -5,    4,   -1,
     &              4,   -2,    4,   -3,    4,   -4,    4,   -5,
     &              5,   -1,    5,   -2,    5,   -3,    5,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [31, 31]
        call register_lumi_pine(
     &         [   25,   35,   45],
     &         25,
     &         [    1,    1,    1,    2,    1,    3,    1,    4,
     &              1,    5,    2,    1,    2,    2,    2,    3,
     &              2,    4,    2,    5,    3,    1,    3,    2,
     &              3,    3,    3,    4,    3,    5,    4,    1,
     &              4,    2,    4,    3,    4,    4,    4,    5,
     &              5,    1,    5,    2,    5,    3,    5,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, -31]
        call register_lumi_pine(
     &         [   31,   41,   50],
     &         25,
     &         [   -1,   -1,   -1,   -2,   -1,   -3,   -1,   -4,
     &             -1,   -5,   -2,   -1,   -2,   -2,   -2,   -3,
     &             -2,   -4,   -2,   -5,   -3,   -1,   -3,   -2,
     &             -3,   -3,   -3,   -4,   -3,   -5,   -4,   -1,
     &             -4,   -2,   -4,   -3,   -4,   -4,   -4,   -5,
     &             -5,   -1,   -5,   -2,   -5,   -3,   -5,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-31, 31]
        call register_lumi_pine(
     &         [   32,   42],
     &         25,
     &         [   -1,    1,   -1,    2,   -1,    3,   -1,    4,
     &             -1,    5,   -2,    1,   -2,    2,   -2,    3,
     &             -2,    4,   -2,    5,   -3,    1,   -3,    2,
     &             -3,    3,   -3,    4,   -3,    5,   -4,    1,
     &             -4,    2,   -4,    3,   -4,    4,   -4,    5,
     &             -5,    1,   -5,    2,   -5,    3,   -5,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [30, 30]
        call register_lumi_pine(
     &         [   53],
     &         5,
     &         [    1,    1,    2,    2,    3,    3,    4,    4,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, -30]
        call register_lumi_pine(
     &         [   58],
     &         5,
     &         [   -1,   -1,   -2,   -2,   -3,   -3,   -4,   -4,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiH4JJJ


#endif


