      subroutine getqcdnormH4JJJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtH4JJJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVH4JJJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourH4JJJ(current_chan)
         do isub = 1, nflavourH4JJJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_H4JJJ(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=H4JJJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      v=246.21846d0
      C0=(alphas_scl/6d0/pi/v)**2
      C1=11d0/3d0
* C1 = 7/2 + 3/2/nc**2
      dlstop = 0d0
      do iscl=1,nAct_scl
        idmap = idmap_scl(iscl, withR=.true.)
        if (idmap == iscl) then
          if (mt_scheme_param() == id_mass_scheme_MSbar) then
            dlstop(iscl) = 2d0*log(muR_scl(iscl)/mt_param(muR_scl(iscl)))
          else
            dlstop(iscl) = 2d0*log(muR_scl(iscl)/mt_param())
          end if
        else
          dlstop(iscl) = dlstop(idmap)
        end if
      end do
      C2=1933d0/162d0 + 19d0/18d0*dlstop
* C2 = 91/12/nc**2 + 9/4/nc**4 + 1/6/nc**3 - 3/8/nc + 805/72 + 11/4*dlstop/nc**2 + 3/4*dlstop
      C2h=(1d0/3d0)*(-67d0/36d0 + 8d0/9d0*dlstop)
* C2h = 5/8/nc**3 - 139/72/nc - dlstop/nc**3 + dlstop/nc
      facB=ave*C0*(nc**2d0-1d0)*nc**3*(4d0*pi*alphas_scl)**3
      if((amzW.eq.0).or.(stw.eq.0))then
         call initeweak
      endif
      gwsq=4d0*pi*amzW/stw
      select case ( name_proc )
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM',
     .     'HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM',
     .     'HTO2E2MUJM')
        Cew=gwsq**3*emz**2*4d0*stw**2/(1d0-stw)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM',
     .     'HTO2L2NJM')
        Cew=gwsq**3*emw**2
      case default
        Cew=1d0
      end select
      facB=facB*Cew
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=2d0*1d0/6d0*facB            ! g g -> g g g l1 l2 l3 l4     A5g0H4
      case(2)
         factor=1d0/nc*1d0/2d0*facB         ! q g -> g g q l1 l2 l3 l4     B3g0H4
      case(3)
         factor=1d0/nc*1d0/6d0*facB         ! q qb -> g g g l1 l2 l3 l4     B3g0H4
      case(4)
         factor=1d0/nc*1d0/2d0*facB         ! g q -> g g q l1 l2 l3 l4     B3g0H4
      case(5)
         factor=1d0/nc*1d0/6d0*facB         ! qb q -> g g g l1 l2 l3 l4     B3g0H4
      case(6)
         factor=1d0/nc*nf*facB              ! g g -> qb g q l1 l2 l3 l4     B3g0H4
      case(7)
         factor=1d0/nc*1d0/2d0*facB         ! g qb -> qb g g l1 l2 l3 l4     B3g0H4
      case(8)
         factor=1d0/nc*1d0/2d0*facB         ! qb g -> qb g g l1 l2 l3 l4     B3g0H4
      case(9)
         factor=-1d0/nc**3*1d0/2d0*facB     ! q g -> g g q l1 l2 l3 l4     Bt3g0H4
      case(10)
         factor=-1d0/nc**3*1d0/6d0*facB     ! q qb -> g g g l1 l2 l3 l4     Bt3g0H4
      case(11)
         factor=-1d0/nc**3*1d0/2d0*facB     ! g q -> g g q l1 l2 l3 l4     Bt3g0H4
      case(12)
         factor=-1d0/nc**3*1d0/6d0*facB     ! qb q -> g g g l1 l2 l3 l4     Bt3g0H4
      case(13)
         factor=-1d0/nc**3*nf*facB          ! g g -> qb g q l1 l2 l3 l4     Bt3g0H4
      case(14)
         factor=-1d0/nc**3*1d0/2d0*facB     ! g qb -> qb g g l1 l2 l3 l4     Bt3g0H4
      case(15)
         factor=-1d0/nc**3*1d0/2d0*facB     ! qb g -> qb g g l1 l2 l3 l4     Bt3g0H4
      case(16)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facB   ! q gt -> gt gt q l1 l2 l3 l4     Btt3g0H4
      case(17)
         factor=(nc**2+1d0)/nc**5*1d0/6d0*facB   ! q qb -> gt gt gt l1 l2 l3 l4     Btt3g0H4
      case(18)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facB   ! gt q -> gt gt q l1 l2 l3 l4     Btt3g0H4
      case(19)
         factor=(nc**2+1d0)/nc**5*1d0/6d0*facB   ! qb q -> gt gt gt l1 l2 l3 l4     Btt3g0H4
      case(20)
         factor=(nc**2+1d0)/nc**5*nf*facB   ! gt gt -> qb gt q l1 l2 l3 l4     Btt3g0H4
      case(21)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facB   ! gt qb -> qb gt gt l1 l2 l3 l4     Btt3g0H4
      case(22)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facB   ! qb gt -> qb gt gt l1 l2 l3 l4     Btt3g0H4
      case(23)
         factor=1d0/nc**2*nf*facB           ! q g -> Q Qb q l1 l2 l3 l4     C1g0H4F
      case(24)
         factor=1d0/nc**2*facB              ! q Qb -> g Qb q l1 l2 l3 l4     C1g0H4F
      case(25)
         factor=1d0/nc**2*facB              ! q Q -> g Q q l1 l2 l3 l4     C1g0H4F
      case(26)
         factor=1d0/nc**2*nf*facB           ! q qb -> g Q Qb l1 l2 l3 l4     C1g0H4F
      case(27)
         factor=1d0/nc**2*nf*facB           ! g q -> Q Qb q l1 l2 l3 l4     C1g0H4F
      case(28)
         factor=1d0/nc**2*nf*facB           ! qb q -> g Q Qb l1 l2 l3 l4     C1g0H4F
      case(29)
         factor=1d0/nc**2*nf*facB           ! g qb -> qb Q Qb l1 l2 l3 l4     C1g0H4F
      case(30)
         factor=1d0/nc**2*nf*facB           ! qb g -> qb Q Qb l1 l2 l3 l4     C1g0H4F
      case(31)
         factor=1d0/nc**2*facB              ! qb Qb -> qb g Qb l1 l2 l3 l4     C1g0H4F
      case(32)
         factor=1d0/nc**2*facB              ! qb Q -> qb g Q l1 l2 l3 l4     C1g0H4F
      case(33)
         factor=1d0/nc**4*nf*facB           ! q g -> Q Qb q l1 l2 l3 l4     Ct1g0H4F
      case(34)
         factor=1d0/nc**4*facB              ! q Qb -> g Qb q l1 l2 l3 l4     Ct1g0H4F
      case(35)
         factor=1d0/nc**4*facB              ! q Q -> g Q q l1 l2 l3 l4     Ct1g0H4F
      case(36)
         factor=1d0/nc**4*nf*facB           ! q qb -> g Q Qb l1 l2 l3 l4     Ct1g0H4F
      case(37)
         factor=1d0/nc**4*nf*facB           ! g q -> Q Qb q l1 l2 l3 l4     Ct1g0H4F
      case(38)
         factor=1d0/nc**4*nf*facB           ! qb q -> g Q Qb l1 l2 l3 l4     Ct1g0H4F
      case(39)
         factor=1d0/nc**4*nf*facB           ! g qb -> qb Q Qb l1 l2 l3 l4     Ct1g0H4F
      case(40)
         factor=1d0/nc**4*nf*facB           ! qb g -> qb Q Qb l1 l2 l3 l4     Ct1g0H4F
      case(41)
         factor=1d0/nc**4*facB              ! qb Qb -> qb g Qb l1 l2 l3 l4     Ct1g0H4F
      case(42)
         factor=1d0/nc**4*facB              ! qb Q -> qb g Q l1 l2 l3 l4     Ct1g0H4F
      case(43)
         factor=-1d0/nc**3*1d0/2d0*facB     ! q g -> q qb q l1 l2 l3 l4     D1g0H4F
      case(44)
         factor=-1d0/nc**3*facB             ! q qb -> g qb q l1 l2 l3 l4     D1g0H4F
      case(45)
         factor=-1d0/nc**3*1d0/2d0*facB     ! q q -> g q q l1 l2 l3 l4     D1g0H4F
      case(46)
         factor=-1d0/nc**3*1d0/2d0*facB     ! g q -> q qb q l1 l2 l3 l4     D1g0H4F
      case(47)
         factor=-1d0/nc**3*facB             ! qb q -> g qb q l1 l2 l3 l4     D1g0H4F
      case(48)
         factor=-1d0/nc**3*1d0/2d0*facB     ! g qb -> qb qb q l1 l2 l3 l4     D1g0H4F
      case(49)
         factor=-1d0/nc**3*1d0/2d0*facB     ! qb g -> qb qb q l1 l2 l3 l4     D1g0H4F
      case(50)
         factor=-1d0/nc**3*1d0/2d0*facB     ! qb qb -> qb g qb l1 l2 l3 l4     D1g0H4F
      case(51)
         factor=1d0/nc**5*1d0/2d0*facB      ! q g -> q qb q l1 l2 l3 l4     Dt1g0H4
      case(52)
         factor=1d0/nc**5*facB              ! q qb -> g qb q l1 l2 l3 l4     Dt1g0H4
      case(53)
         factor=1d0/nc**5*1d0/2d0*facB      ! q q -> g q q l1 l2 l3 l4     Dt1g0H4
      case(54)
         factor=1d0/nc**5*1d0/2d0*facB      ! g q -> q qb q l1 l2 l3 l4     Dt1g0H4
      case(55)
         factor=1d0/nc**5*facB              ! qb q -> g qb q l1 l2 l3 l4     Dt1g0H4
      case(56)
         factor=1d0/nc**5*1d0/2d0*facB      ! g qb -> qb qb q l1 l2 l3 l4     Dt1g0H4
      case(57)
         factor=1d0/nc**5*1d0/2d0*facB      ! qb g -> qb qb q l1 l2 l3 l4     Dt1g0H4
      case(58)
         factor=1d0/nc**5*1d0/2d0*facB      ! qb qb -> qb g qb l1 l2 l3 l4     Dt1g0H4

c -- real


c -- virtual


c -- double real


c -- real virtual


c -- double virtual

      end select
      factor=relfactor*factor

      return
      end
