      subroutine getqcdnormHJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtHJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVHJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourHJ(current_chan)
         do isub = 1, nflavourHJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_HJ(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=HJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      v=246.21846d0
      C0=(alphas_scl/6d0/pi/v)**2
      C1=11d0/3d0
* C1 = 7/2 + 3/2/nc**2
      dlstop = 0d0
      do iscl=1,nAct_scl
        idmap = idmap_scl(iscl, withR=.true.)
        if (idmap == iscl) then
          if (mt_scheme_param() == id_mass_scheme_MSbar) then
            dlstop(iscl) = 2d0*log(muR_scl(iscl)/mt_param(muR_scl(iscl)))
          else
            dlstop(iscl) = 2d0*log(muR_scl(iscl)/mt_param())
          end if
        else
          dlstop(iscl) = dlstop(idmap)
        end if
      end do
      C2=1933d0/162d0 + 19d0/18d0*dlstop
* C2 = 91/12/nc**2 + 9/4/nc**4 + 1/6/nc**3 - 3/8/nc + 805/72 + 11/4*dlstop/nc**2 + 3/4*dlstop
      C2h=(1d0/3d0)*(-67d0/36d0 + 8d0/9d0*dlstop)
* C2h = 5/8/nc**3 - 139/72/nc - dlstop/nc**3 + dlstop/nc
      facB=ave*C0*(nc**2d0-1d0)*nc*(4d0*pi*alphas_scl)
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=2d0*facB                    ! g g -> g ph1 ph2        A3g0H
      case(2)
         factor=1d0/nc*facB                 ! q g -> q ph1 ph2        B1g0H
      case(3)
         factor=1d0/nc*facB                 ! q qb -> g ph1 ph2       B1g0H
      case(4)
         factor=1d0/nc*facB                 ! g q -> q ph1 ph2        B1g0H
      case(5)
         factor=1d0/nc*facB                 ! qb q -> g ph1 ph2       B1g0H
      case(6)
         factor=1d0/nc*facB                 ! g qb -> qb ph1 ph2      B1g0H
      case(7)
         factor=1d0/nc*facB                 ! qb g -> qb ph1 ph2      B1g0H

c -- real

      case(8)
         factor=2d0*1d0/2d0*facR            ! g g -> g g ph1 ph2      A4g0H
      case(9)
         factor=1d0/nc*facR                 ! q g -> g q ph1 ph2      B2g0H
      case(10)
         factor=1d0/nc*1d0/2d0*facR         ! q qb -> g g ph1 ph2     B2g0H
      case(11)
         factor=1d0/nc*facR                 ! g q -> g q ph1 ph2      B2g0H
      case(12)
         factor=1d0/nc*1d0/2d0*facR         ! qb q -> g g ph1 ph2     B2g0H
      case(13)
         factor=1d0/nc*nf*facR              ! g g -> qb q ph1 ph2     B2g0H
      case(14)
         factor=1d0/nc*facR                 ! g qb -> qb g ph1 ph2     B2g0H
      case(15)
         factor=1d0/nc*facR                 ! qb g -> qb g ph1 ph2     B2g0H
      case(16)
         factor=-1d0/nc**3*facR             ! q gt -> gt q ph1 ph2     Bt2g0H
      case(17)
         factor=-1d0/nc**3*1d0/2d0*facR     ! q qb -> gt gt ph1 ph2     Bt2g0H
      case(18)
         factor=-1d0/nc**3*facR             ! gt q -> gt q ph1 ph2     Bt2g0H
      case(19)
         factor=-1d0/nc**3*1d0/2d0*facR     ! qb q -> gt gt ph1 ph2     Bt2g0H
      case(20)
         factor=-1d0/nc**3*nf*facR          ! gt gt -> qb q ph1 ph2     Bt2g0H
      case(21)
         factor=-1d0/nc**3*facR             ! gt qb -> qb gt ph1 ph2     Bt2g0H
      case(22)
         factor=-1d0/nc**3*facR             ! qb gt -> qb gt ph1 ph2     Bt2g0H
      case(23)
         factor=1d0/nc**2*facR              ! q Qb -> Qb q ph1 ph2     C0g0H
      case(24)
         factor=1d0/nc**2*facR              ! q Q -> Q q ph1 ph2      C0g0H
      case(25)
         factor=1d0/nc**2*nf*facR           ! q qb -> Q Qb ph1 ph2     C0g0H
      case(26)
         factor=1d0/nc**2*nf*facR           ! qb q -> Q Qb ph1 ph2     C0g0H
      case(27)
         factor=1d0/nc**2*facR              ! qb Qb -> qb Qb ph1 ph2     C0g0H
      case(28)
         factor=1d0/nc**2*facR              ! qb Q -> qb Q ph1 ph2     C0g0H
      case(29)
         factor=-1d0/nc**3*facR             ! q qb -> qb q ph1 ph2     D0g0H
      case(30)
         factor=-1d0/nc**3*1d0/2d0*facR     ! q q -> q q ph1 ph2      D0g0H
      case(31)
         factor=-1d0/nc**3*facR             ! qb q -> qb q ph1 ph2     D0g0H
      case(32)
         factor=-1d0/nc**3*1d0/2d0*facR     ! qb qb -> qb qb ph1 ph2     D0g0H

c -- virtual

      case(33)
         factor=2d0*facV                    ! g g -> g ph1 ph2        A3g1H
      case(34)
         factor=1d0/nc*facV                 ! g q subtraction         A3g1H
      case(35)
         factor=1d0/nc*facV                 ! g qb subtraction        A3g1H
      case(36)
         factor=1d0/nc*facV                 ! q g subtraction         A3g1H
      case(37)
         factor=1d0/nc*facV                 ! qb g subtraction        A3g1H
      case(38)
         factor=1d0/nc*nf*2d0*facV          ! g g -> g ph1 ph2        Ah3g1H
      case(39)
         factor=1d0/nc**2*nf*facV           ! g q subtraction         Ah3g1H
      case(40)
         factor=1d0/nc**2*nf*facV           ! g qb subtraction        Ah3g1H
      case(41)
         factor=1d0/nc**2*nf*facV           ! q g subtraction         Ah3g1H
      case(42)
         factor=1d0/nc**2*nf*facV           ! qb g subtraction        Ah3g1H
      case(43)
         factor=1d0/nc*facV                 ! q g -> q ph1 ph2        B1g1H
      case(44)
         factor=1d0/nc*facV                 ! q qb -> g ph1 ph2       B1g1H
      case(45)
         factor=1d0/nc*facV                 ! g q -> q ph1 ph2        B1g1H
      case(46)
         factor=1d0/nc*facV                 ! qb q -> g ph1 ph2       B1g1H
      case(47)
         factor=1d0/nc*facV                 ! g qb -> qb ph1 ph2      B1g1H
      case(48)
         factor=1d0/nc*facV                 ! qb g -> qb ph1 ph2      B1g1H
      case(49)
         factor=1d0/nc*nf*facV              ! g g subtraction         B1g1H
      case(50)
         factor=1d0/nc**2*facV              ! q Q subtraction         B1g1H
      case(51)
         factor=1d0/nc**2*facV              ! q Qb subtraction        B1g1H
      case(52)
         factor=1d0/nc**2*facV              ! qb Q subtraction        B1g1H
      case(53)
         factor=1d0/nc**2*facV              ! qb Qb subtraction       B1g1H
      case(54)
         factor=1d0/nc**2*nf*facV           ! q g -> q ph1 ph2        Bh1g1H
      case(55)
         factor=1d0/nc**2*nf*facV           ! q qb -> g ph1 ph2       Bh1g1H
      case(56)
         factor=1d0/nc**2*nf*facV           ! g q -> q ph1 ph2        Bh1g1H
      case(57)
         factor=1d0/nc**2*nf*facV           ! qb q -> g ph1 ph2       Bh1g1H
      case(58)
         factor=1d0/nc**2*nf*facV           ! g qb -> qb ph1 ph2      Bh1g1H
      case(59)
         factor=1d0/nc**2*nf*facV           ! qb g -> qb ph1 ph2      Bh1g1H
      case(60)
         factor=1d0/nc**2*nf**2*facV        ! g g subtraction         Bh1g1H
      case(61)
         factor=1d0/nc**3*nf*facV           ! q Q subtraction         Bh1g1H
      case(62)
         factor=1d0/nc**3*nf*facV           ! q Qb subtraction        Bh1g1H
      case(63)
         factor=1d0/nc**3*nf*facV           ! qb Q subtraction        Bh1g1H
      case(64)
         factor=1d0/nc**3*nf*facV           ! qb Qb subtraction       Bh1g1H
      case(65)
         factor=-1d0/nc**3*facV             ! q g -> q ph1 ph2        Bt1g1H
      case(66)
         factor=-1d0/nc**3*facV             ! q qb -> g ph1 ph2       Bt1g1H
      case(67)
         factor=-1d0/nc**3*facV             ! g q -> q ph1 ph2        Bt1g1H
      case(68)
         factor=-1d0/nc**3*facV             ! qb q -> g ph1 ph2       Bt1g1H
      case(69)
         factor=-1d0/nc**3*facV             ! g qb -> qb ph1 ph2      Bt1g1H
      case(70)
         factor=-1d0/nc**3*facV             ! qb g -> qb ph1 ph2      Bt1g1H
      case(71)
         factor=-1d0/nc**3*nf*facV          ! g g subtraction         Bt1g1H
      case(72)
         factor=-1d0/nc**4*facV             ! q Q subtraction         Bt1g1H
      case(73)
         factor=-1d0/nc**4*facV             ! q Qb subtraction        Bt1g1H
      case(74)
         factor=-1d0/nc**4*facV             ! qb Q subtraction        Bt1g1H
      case(75)
         factor=-1d0/nc**4*facV             ! qb Qb subtraction       Bt1g1H
      case(76)
         factor=C1*2d0*facV                 ! g g -> g ph1 ph2        A3g0H
      case(77)
         factor=C1/nc*facV                  ! q g -> q ph1 ph2        B1g0H
      case(78)
         factor=C1/nc*facV                  ! q qb -> g ph1 ph2       B1g0H
      case(79)
         factor=C1/nc*facV                  ! g q -> q ph1 ph2        B1g0H
      case(80)
         factor=C1/nc*facV                  ! qb q -> g ph1 ph2       B1g0H
      case(81)
         factor=C1/nc*facV                  ! g qb -> qb ph1 ph2      B1g0H
      case(82)
         factor=C1/nc*facV                  ! qb g -> qb ph1 ph2      B1g0H

c -- double real

      case(83)
         factor=2d0*1d0/6d0*facRR           ! g g -> g g g ph1 ph2     A5g0H
      case(84)
         factor=1d0/nc*1d0/2d0*facRR        ! q g -> g g q ph1 ph2     B3g0H
      case(85)
         factor=1d0/nc*1d0/6d0*facRR        ! q qb -> g g g ph1 ph2     B3g0H
      case(86)
         factor=1d0/nc*1d0/2d0*facRR        ! g q -> g g q ph1 ph2     B3g0H
      case(87)
         factor=1d0/nc*1d0/6d0*facRR        ! qb q -> g g g ph1 ph2     B3g0H
      case(88)
         factor=1d0/nc*nf*facRR             ! g g -> qb g q ph1 ph2     B3g0H
      case(89)
         factor=1d0/nc*1d0/2d0*facRR        ! g qb -> qb g g ph1 ph2     B3g0H
      case(90)
         factor=1d0/nc*1d0/2d0*facRR        ! qb g -> qb g g ph1 ph2     B3g0H
      case(91)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! q g -> g g q ph1 ph2     Bt3g0H
      case(92)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! q qb -> g g g ph1 ph2     Bt3g0H
      case(93)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! g q -> g g q ph1 ph2     Bt3g0H
      case(94)
         factor=-1d0/nc**3*1d0/6d0*facRR    ! qb q -> g g g ph1 ph2     Bt3g0H
      case(95)
         factor=-1d0/nc**3*nf*facRR         ! g g -> qb g q ph1 ph2     Bt3g0H
      case(96)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! g qb -> qb g g ph1 ph2     Bt3g0H
      case(97)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! qb g -> qb g g ph1 ph2     Bt3g0H
      case(98)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facRR   ! q gt -> gt gt q ph1 ph2     Btt3g0H
      case(99)
         factor=(nc**2+1d0)/nc**5*1d0/6d0*facRR   ! q qb -> gt gt gt ph1 ph2     Btt3g0H
      case(100)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facRR   ! gt q -> gt gt q ph1 ph2     Btt3g0H
      case(101)
         factor=(nc**2+1d0)/nc**5*1d0/6d0*facRR   ! qb q -> gt gt gt ph1 ph2     Btt3g0H
      case(102)
         factor=(nc**2+1d0)/nc**5*nf*facRR   ! gt gt -> qb gt q ph1 ph2     Btt3g0H
      case(103)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facRR   ! gt qb -> qb gt gt ph1 ph2     Btt3g0H
      case(104)
         factor=(nc**2+1d0)/nc**5*1d0/2d0*facRR   ! qb gt -> qb gt gt ph1 ph2     Btt3g0H
      case(105)
         factor=1d0/nc**2*nf*facRR          ! q g -> Q Qb q ph1 ph2     C1g0HF
      case(106)
         factor=1d0/nc**2*facRR             ! q Qb -> g Qb q ph1 ph2     C1g0HF
      case(107)
         factor=1d0/nc**2*facRR             ! q Q -> g Q q ph1 ph2     C1g0HF
      case(108)
         factor=1d0/nc**2*nf*facRR          ! q qb -> g Q Qb ph1 ph2     C1g0HF
      case(109)
         factor=1d0/nc**2*nf*facRR          ! g q -> Q Qb q ph1 ph2     C1g0HF
      case(110)
         factor=1d0/nc**2*nf*facRR          ! qb q -> g Q Qb ph1 ph2     C1g0HF
      case(111)
         factor=1d0/nc**2*nf*facRR          ! g qb -> qb Q Qb ph1 ph2     C1g0HF
      case(112)
         factor=1d0/nc**2*nf*facRR          ! qb g -> qb Q Qb ph1 ph2     C1g0HF
      case(113)
         factor=1d0/nc**2*facRR             ! qb Qb -> qb g Qb ph1 ph2     C1g0HF
      case(114)
         factor=1d0/nc**2*facRR             ! qb Q -> qb g Q ph1 ph2     C1g0HF
      case(115)
         factor=1d0/nc**4*nf*facRR          ! q g -> Q Qb q ph1 ph2     Ct1g0HF
      case(116)
         factor=1d0/nc**4*facRR             ! q Qb -> g Qb q ph1 ph2     Ct1g0HF
      case(117)
         factor=1d0/nc**4*facRR             ! q Q -> g Q q ph1 ph2     Ct1g0HF
      case(118)
         factor=1d0/nc**4*nf*facRR          ! q qb -> g Q Qb ph1 ph2     Ct1g0HF
      case(119)
         factor=1d0/nc**4*nf*facRR          ! g q -> Q Qb q ph1 ph2     Ct1g0HF
      case(120)
         factor=1d0/nc**4*nf*facRR          ! qb q -> g Q Qb ph1 ph2     Ct1g0HF
      case(121)
         factor=1d0/nc**4*nf*facRR          ! g qb -> qb Q Qb ph1 ph2     Ct1g0HF
      case(122)
         factor=1d0/nc**4*nf*facRR          ! qb g -> qb Q Qb ph1 ph2     Ct1g0HF
      case(123)
         factor=1d0/nc**4*facRR             ! qb Qb -> qb g Qb ph1 ph2     Ct1g0HF
      case(124)
         factor=1d0/nc**4*facRR             ! qb Q -> qb g Q ph1 ph2     Ct1g0HF
      case(125)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! q g -> q qb q ph1 ph2     D1g0HF
      case(126)
         factor=-1d0/nc**3*facRR            ! q qb -> g qb q ph1 ph2     D1g0HF
      case(127)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! q q -> g q q ph1 ph2     D1g0HF
      case(128)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! g q -> q qb q ph1 ph2     D1g0HF
      case(129)
         factor=-1d0/nc**3*facRR            ! qb q -> g qb q ph1 ph2     D1g0HF
      case(130)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! g qb -> qb qb q ph1 ph2     D1g0HF
      case(131)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! qb g -> qb qb q ph1 ph2     D1g0HF
      case(132)
         factor=-1d0/nc**3*1d0/2d0*facRR    ! qb qb -> qb g qb ph1 ph2     D1g0HF
      case(133)
         factor=1d0/nc**5*1d0/2d0*facRR     ! q g -> q qb q ph1 ph2     Dt1g0H
      case(134)
         factor=1d0/nc**5*facRR             ! q qb -> g qb q ph1 ph2     Dt1g0H
      case(135)
         factor=1d0/nc**5*1d0/2d0*facRR     ! q q -> g q q ph1 ph2     Dt1g0H
      case(136)
         factor=1d0/nc**5*1d0/2d0*facRR     ! g q -> q qb q ph1 ph2     Dt1g0H
      case(137)
         factor=1d0/nc**5*facRR             ! qb q -> g qb q ph1 ph2     Dt1g0H
      case(138)
         factor=1d0/nc**5*1d0/2d0*facRR     ! g qb -> qb qb q ph1 ph2     Dt1g0H
      case(139)
         factor=1d0/nc**5*1d0/2d0*facRR     ! qb g -> qb qb q ph1 ph2     Dt1g0H
      case(140)
         factor=1d0/nc**5*1d0/2d0*facRR     ! qb qb -> qb g qb ph1 ph2     Dt1g0H

c -- real virtual

      case(141)
         factor=2d0*1d0/2d0*facRV           ! g g -> g g ph1 ph2      A4g1H
      case(142)
         factor=1d0/nc*facRV                ! g q subtraction         A4g1H
      case(143)
         factor=1d0/nc*facRV                ! g qb subtraction        A4g1H
      case(144)
         factor=1d0/nc*facRV                ! q g subtraction         A4g1H
      case(145)
         factor=1d0/nc*facRV                ! qb g subtraction        A4g1H
      case(146)
         factor=1d0/nc*nf*2d0*1d0/2d0*facRV   ! g g -> g g ph1 ph2      Ah4g1H
      case(147)
         factor=1d0/nc**2*nf*facRV          ! g q subtraction         Ah4g1H
      case(148)
         factor=1d0/nc**2*nf*facRV          ! g qb subtraction        Ah4g1H
      case(149)
         factor=1d0/nc**2*nf*facRV          ! q g subtraction         Ah4g1H
      case(150)
         factor=1d0/nc**2*nf*facRV          ! qb g subtraction        Ah4g1H
      case(151)
         factor=1d0/nc*facRV                ! q g -> g q ph1 ph2      B2g1H
      case(152)
         factor=1d0/nc*1d0/2d0*facRV        ! q qb -> g g ph1 ph2     B2g1H
      case(153)
         factor=1d0/nc*facRV                ! g q -> g q ph1 ph2      B2g1H
      case(154)
         factor=1d0/nc*1d0/2d0*facRV        ! qb q -> g g ph1 ph2     B2g1H
      case(155)
         factor=1d0/nc*nf*facRV             ! g g -> qb q ph1 ph2     B2g1H
      case(156)
         factor=1d0/nc*facRV                ! g qb -> qb g ph1 ph2     B2g1H
      case(157)
         factor=1d0/nc*facRV                ! qb g -> qb g ph1 ph2     B2g1H
      case(158)
         factor=1d0/nc**2*facRV             ! q Q subtraction         B2g1H
      case(159)
         factor=1d0/nc**2*facRV             ! q Qb subtraction        B2g1H
      case(160)
         factor=1d0/nc**2*facRV             ! qb Q subtraction        B2g1H
      case(161)
         factor=1d0/nc**2*facRV             ! qb Qb subtraction       B2g1H
      case(162)
         factor=1d0/nc**2*nf*facRV          ! q g -> g q ph1 ph2      Bh2g1H
      case(163)
         factor=1d0/nc**2*nf*1d0/2d0*facRV   ! q qb -> g g ph1 ph2     Bh2g1H
      case(164)
         factor=1d0/nc**2*nf*facRV          ! g q -> g q ph1 ph2      Bh2g1H
      case(165)
         factor=1d0/nc**2*nf*1d0/2d0*facRV   ! qb q -> g g ph1 ph2     Bh2g1H
      case(166)
         factor=1d0/nc**2*nf*nf*facRV       ! g g -> qb q ph1 ph2     Bh2g1H
      case(167)
         factor=1d0/nc**2*nf*facRV          ! g qb -> qb g ph1 ph2     Bh2g1H
      case(168)
         factor=1d0/nc**2*nf*facRV          ! qb g -> qb g ph1 ph2     Bh2g1H
      case(169)
         factor=1d0/nc**3*nf*facRV          ! q Q subtraction         Bh2g1H
      case(170)
         factor=1d0/nc**3*nf*facRV          ! q Qb subtraction        Bh2g1H
      case(171)
         factor=1d0/nc**3*nf*facRV          ! qb Q subtraction        Bh2g1H
      case(172)
         factor=1d0/nc**3*nf*facRV          ! qb Qb subtraction       Bh2g1H
      case(173)
         factor=-1d0/nc**3*facRV            ! q g -> g q ph1 ph2      Bt2g1H
      case(174)
         factor=-1d0/nc**3*1d0/2d0*facRV    ! q qb -> g g ph1 ph2     Bt2g1H
      case(175)
         factor=-1d0/nc**3*facRV            ! g q -> g q ph1 ph2      Bt2g1H
      case(176)
         factor=-1d0/nc**3*1d0/2d0*facRV    ! qb q -> g g ph1 ph2     Bt2g1H
      case(177)
         factor=-1d0/nc**3*nf*facRV         ! g g -> qb q ph1 ph2     Bt2g1H
      case(178)
         factor=-1d0/nc**3*facRV            ! g qb -> qb g ph1 ph2     Bt2g1H
      case(179)
         factor=-1d0/nc**3*facRV            ! qb g -> qb g ph1 ph2     Bt2g1H
      case(180)
         factor=-1d0/nc**4*facRV            ! q Q subtraction         Bt2g1H
      case(181)
         factor=-1d0/nc**4*facRV            ! q Qb subtraction        Bt2g1H
      case(182)
         factor=-1d0/nc**4*facRV            ! qb Q subtraction        Bt2g1H
      case(183)
         factor=-1d0/nc**4*facRV            ! qb Qb subtraction       Bt2g1H
      case(184)
         factor=-1d0/nc**3*facRV            ! q gt -> gt q ph1 ph2     Btt2g1HF
      case(185)
         factor=-1d0/nc**3*1d0/2d0*facRV    ! q qb -> gt gt ph1 ph2     Btt2g1HF
      case(186)
         factor=-1d0/nc**3*facRV            ! gt q -> gt q ph1 ph2     Btt2g1HF
      case(187)
         factor=-1d0/nc**3*1d0/2d0*facRV    ! qb q -> gt gt ph1 ph2     Btt2g1HF
      case(188)
         factor=-1d0/nc**3*nf*facRV         ! gt gt -> qb q ph1 ph2     Btt2g1HF
      case(189)
         factor=-1d0/nc**3*facRV            ! gt qb -> qb gt ph1 ph2     Btt2g1HF
      case(190)
         factor=-1d0/nc**3*facRV            ! qb gt -> qb gt ph1 ph2     Btt2g1HF
      case(191)
         factor=1d0/nc**5*facRV             ! q gt -> gt q ph1 ph2     Bttt2g1H
      case(192)
         factor=1d0/nc**5*1d0/2d0*facRV     ! q qb -> gt gt ph1 ph2     Bttt2g1H
      case(193)
         factor=1d0/nc**5*facRV             ! gt q -> gt q ph1 ph2     Bttt2g1H
      case(194)
         factor=1d0/nc**5*1d0/2d0*facRV     ! qb q -> gt gt ph1 ph2     Bttt2g1H
      case(195)
         factor=1d0/nc**5*nf*facRV          ! gt gt -> qb q ph1 ph2     Bttt2g1H
      case(196)
         factor=1d0/nc**5*facRV             ! gt qb -> qb gt ph1 ph2     Bttt2g1H
      case(197)
         factor=1d0/nc**5*facRV             ! qb gt -> qb gt ph1 ph2     Bttt2g1H
      case(198)
         factor=-1d0/nc**4*nf*facRV         ! q gt -> gt q ph1 ph2     Btth2g1H
      case(199)
         factor=-1d0/nc**4*nf*1d0/2d0*facRV   ! q qb -> gt gt ph1 ph2     Btth2g1H
      case(200)
         factor=-1d0/nc**4*nf*facRV         ! gt q -> gt q ph1 ph2     Btth2g1H
      case(201)
         factor=-1d0/nc**4*nf*1d0/2d0*facRV   ! qb q -> gt gt ph1 ph2     Btth2g1H
      case(202)
         factor=-1d0/nc**4*nf*nf*facRV      ! gt gt -> qb q ph1 ph2     Btth2g1H
      case(203)
         factor=-1d0/nc**4*nf*facRV         ! gt qb -> qb gt ph1 ph2     Btth2g1H
      case(204)
         factor=-1d0/nc**4*nf*facRV         ! qb gt -> qb gt ph1 ph2     Btth2g1H
      case(205)
         factor=1d0/nc**2*facRV             ! q Qb -> Qb q ph1 ph2     C0g1HF
      case(206)
         factor=1d0/nc**2*facRV             ! q Q -> Q q ph1 ph2      C0g1HF
      case(207)
         factor=1d0/nc**2*nf*facRV          ! q qb -> Q Qb ph1 ph2     C0g1HF
      case(208)
         factor=1d0/nc**2*nf*facRV          ! qb q -> Q Qb ph1 ph2     C0g1HF
      case(209)
         factor=1d0/nc**2*facRV             ! qb Qb -> qb Qb ph1 ph2     C0g1HF
      case(210)
         factor=1d0/nc**2*facRV             ! qb Q -> qb Q ph1 ph2     C0g1HF
      case(211)
         factor=1d0/nc**2*nf*facRV          ! g q subtraction         C0g1HF
      case(212)
         factor=1d0/nc**2*nf*facRV          ! g qb subtraction        C0g1HF
      case(213)
         factor=1d0/nc**2*nf*facRV          ! q g subtraction         C0g1HF
      case(214)
         factor=1d0/nc**2*nf*facRV          ! qb g subtraction        C0g1HF
      case(215)
         factor=-1d0/nc**4*facRV            ! q Qb -> Qb q ph1 ph2     Ct0g1HF
      case(216)
         factor=-1d0/nc**4*facRV            ! q Q -> Q q ph1 ph2      Ct0g1HF
      case(217)
         factor=-1d0/nc**4*nf*facRV         ! q qb -> Q Qb ph1 ph2     Ct0g1HF
      case(218)
         factor=-1d0/nc**4*nf*facRV         ! qb q -> Q Qb ph1 ph2     Ct0g1HF
      case(219)
         factor=-1d0/nc**4*facRV            ! qb Qb -> qb Qb ph1 ph2     Ct0g1HF
      case(220)
         factor=-1d0/nc**4*facRV            ! qb Q -> qb Q ph1 ph2     Ct0g1HF
      case(221)
         factor=-1d0/nc**4*nf*facRV         ! g q subtraction         Ct0g1HF
      case(222)
         factor=-1d0/nc**4*nf*facRV         ! g qb subtraction        Ct0g1HF
      case(223)
         factor=-1d0/nc**4*nf*facRV         ! q g subtraction         Ct0g1HF
      case(224)
         factor=-1d0/nc**4*nf*facRV         ! qb g subtraction        Ct0g1HF
      case(225)
         factor=1d0/nc**3*nf*facRV          ! q Qb -> Qb q ph1 ph2     Ch0g1H
      case(226)
         factor=1d0/nc**3*nf*facRV          ! q Q -> Q q ph1 ph2      Ch0g1H
      case(227)
         factor=1d0/nc**3*nf*nf*facRV       ! q qb -> Q Qb ph1 ph2     Ch0g1H
      case(228)
         factor=1d0/nc**3*nf*nf*facRV       ! qb q -> Q Qb ph1 ph2     Ch0g1H
      case(229)
         factor=1d0/nc**3*nf*facRV          ! qb Qb -> qb Qb ph1 ph2     Ch0g1H
      case(230)
         factor=1d0/nc**3*nf*facRV          ! qb Q -> qb Q ph1 ph2     Ch0g1H
      case(231)
         factor=1d0/nc**3*nf**2*facRV       ! g q subtraction         Ch0g1H
      case(232)
         factor=1d0/nc**3*nf**2*facRV       ! g qb subtraction        Ch0g1H
      case(233)
         factor=1d0/nc**3*nf**2*facRV       ! q g subtraction         Ch0g1H
      case(234)
         factor=1d0/nc**3*nf**2*facRV       ! qb g subtraction        Ch0g1H
      case(235)
         factor=-1d0/nc**3*facRV            ! q qb -> qb q ph1 ph2     D0g1H
      case(236)
         factor=-1d0/nc**3*1d0/2d0*facRV    ! q q -> q q ph1 ph2      D0g1H
      case(237)
         factor=-1d0/nc**3*facRV            ! qb q -> qb q ph1 ph2     D0g1H
      case(238)
         factor=-1d0/nc**3*1d0/2d0*facRV    ! qb qb -> qb qb ph1 ph2     D0g1H
      case(239)
         factor=-1d0/nc**3*facRV            ! g q subtraction         D0g1H
      case(240)
         factor=-1d0/nc**3*facRV            ! g qb subtraction        D0g1H
      case(241)
         factor=-1d0/nc**3*facRV            ! q g subtraction         D0g1H
      case(242)
         factor=-1d0/nc**3*facRV            ! qb g subtraction        D0g1H
      case(243)
         factor=-1d0/nc**5*facRV            ! q qb -> qb q ph1 ph2     Dt0g1H
      case(244)
         factor=-1d0/nc**5*1d0/2d0*facRV    ! q q -> q q ph1 ph2      Dt0g1H
      case(245)
         factor=-1d0/nc**5*facRV            ! qb q -> qb q ph1 ph2     Dt0g1H
      case(246)
         factor=-1d0/nc**5*1d0/2d0*facRV    ! qb qb -> qb qb ph1 ph2     Dt0g1H
      case(247)
         factor=-1d0/nc**5*facRV            ! g q subtraction         Dt0g1H
      case(248)
         factor=-1d0/nc**5*facRV            ! g qb subtraction        Dt0g1H
      case(249)
         factor=-1d0/nc**5*facRV            ! q g subtraction         Dt0g1H
      case(250)
         factor=-1d0/nc**5*facRV            ! qb g subtraction        Dt0g1H
      case(251)
         factor=1d0/nc**4*nf*facRV          ! q qb -> qb q ph1 ph2     Dh0g1H
      case(252)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! q q -> q q ph1 ph2      Dh0g1H
      case(253)
         factor=1d0/nc**4*nf*facRV          ! qb q -> qb q ph1 ph2     Dh0g1H
      case(254)
         factor=1d0/nc**4*nf*1d0/2d0*facRV   ! qb qb -> qb qb ph1 ph2     Dh0g1H
      case(255)
         factor=1d0/nc**4*nf*facRV          ! g q subtraction         Dh0g1H
      case(256)
         factor=1d0/nc**4*nf*facRV          ! g qb subtraction        Dh0g1H
      case(257)
         factor=1d0/nc**4*nf*facRV          ! q g subtraction         Dh0g1H
      case(258)
         factor=1d0/nc**4*nf*facRV          ! qb g subtraction        Dh0g1H
      case(259)
         factor=C1*2d0*1d0/2d0*facRV        ! g g -> g g ph1 ph2      A4g0H
      case(260)
         factor=C1/nc*facRV                 ! q g -> g q ph1 ph2      B2g0H
      case(261)
         factor=C1/nc*1d0/2d0*facRV         ! q qb -> g g ph1 ph2     B2g0H
      case(262)
         factor=C1/nc*facRV                 ! g q -> g q ph1 ph2      B2g0H
      case(263)
         factor=C1/nc*1d0/2d0*facRV         ! qb q -> g g ph1 ph2     B2g0H
      case(264)
         factor=C1/nc*nf*facRV              ! g g -> qb q ph1 ph2     B2g0H
      case(265)
         factor=C1/nc*facRV                 ! g qb -> qb g ph1 ph2     B2g0H
      case(266)
         factor=C1/nc*facRV                 ! qb g -> qb g ph1 ph2     B2g0H
      case(267)
         factor=-C1/nc**3*facRV             ! q gt -> gt q ph1 ph2     Bt2g0H
      case(268)
         factor=-C1/nc**3*1d0/2d0*facRV     ! q qb -> gt gt ph1 ph2     Bt2g0H
      case(269)
         factor=-C1/nc**3*facRV             ! gt q -> gt q ph1 ph2     Bt2g0H
      case(270)
         factor=-C1/nc**3*1d0/2d0*facRV     ! qb q -> gt gt ph1 ph2     Bt2g0H
      case(271)
         factor=-C1/nc**3*nf*facRV          ! gt gt -> qb q ph1 ph2     Bt2g0H
      case(272)
         factor=-C1/nc**3*facRV             ! gt qb -> qb gt ph1 ph2     Bt2g0H
      case(273)
         factor=-C1/nc**3*facRV             ! qb gt -> qb gt ph1 ph2     Bt2g0H
      case(274)
         factor=C1/nc**2*facRV              ! q Qb -> Qb q ph1 ph2     C0g0H
      case(275)
         factor=C1/nc**2*facRV              ! q Q -> Q q ph1 ph2      C0g0H
      case(276)
         factor=C1/nc**2*nf*facRV           ! q qb -> Q Qb ph1 ph2     C0g0H
      case(277)
         factor=C1/nc**2*nf*facRV           ! qb q -> Q Qb ph1 ph2     C0g0H
      case(278)
         factor=C1/nc**2*facRV              ! qb Qb -> qb Qb ph1 ph2     C0g0H
      case(279)
         factor=C1/nc**2*facRV              ! qb Q -> qb Q ph1 ph2     C0g0H
      case(280)
         factor=-C1/nc**3*facRV             ! q qb -> qb q ph1 ph2     D0g0H
      case(281)
         factor=-C1/nc**3*1d0/2d0*facRV     ! q q -> q q ph1 ph2      D0g0H
      case(282)
         factor=-C1/nc**3*facRV             ! qb q -> qb q ph1 ph2     D0g0H
      case(283)
         factor=-C1/nc**3*1d0/2d0*facRV     ! qb qb -> qb qb ph1 ph2     D0g0H

c -- double virtual

      case(284)
         factor=2d0*facVV                   ! g g -> g ph1 ph2        A3g2H
      case(285)
         factor=1d0/nc*facVV                ! g q subtraction         A3g2H
      case(286)
         factor=1d0/nc*facVV                ! g qb subtraction        A3g2H
      case(287)
         factor=1d0/nc**2*facVV             ! q Q subtraction         A3g2H
      case(288)
         factor=1d0/nc**2*facVV             ! q Qb subtraction        A3g2H
      case(289)
         factor=1d0/nc*facVV                ! q g subtraction         A3g2H
      case(290)
         factor=1d0/nc**2*facVV             ! qb Q subtraction        A3g2H
      case(291)
         factor=1d0/nc**2*facVV             ! qb Qb subtraction       A3g2H
      case(292)
         factor=1d0/nc*facVV                ! qb g subtraction        A3g2H
      case(293)
         factor=1d0/nc**2*2d0*facVV         ! g g -> g ph1 ph2        At3g2H
      case(294)
         factor=1d0/nc**3*facVV             ! g q subtraction         At3g2H
      case(295)
         factor=1d0/nc**3*facVV             ! g qb subtraction        At3g2H
      case(296)
         factor=1d0/nc**4*facVV             ! q Q subtraction         At3g2H
      case(297)
         factor=1d0/nc**4*facVV             ! q Qb subtraction        At3g2H
      case(298)
         factor=1d0/nc**3*facVV             ! q g subtraction         At3g2H
      case(299)
         factor=1d0/nc**4*facVV             ! qb Q subtraction        At3g2H
      case(300)
         factor=1d0/nc**4*facVV             ! qb Qb subtraction       At3g2H
      case(301)
         factor=1d0/nc**3*facVV             ! qb g subtraction        At3g2H
      case(302)
         factor=1d0/nc*nf*2d0*facVV         ! g g -> g ph1 ph2        Ah3g2H
      case(303)
         factor=1d0/nc**2*nf*facVV          ! g q subtraction         Ah3g2H
      case(304)
         factor=1d0/nc**2*nf*facVV          ! g qb subtraction        Ah3g2H
      case(305)
         factor=1d0/nc**3*nf*facVV          ! q Q subtraction         Ah3g2H
      case(306)
         factor=1d0/nc**3*nf*facVV          ! q Qb subtraction        Ah3g2H
      case(307)
         factor=1d0/nc**2*nf*facVV          ! q g subtraction         Ah3g2H
      case(308)
         factor=1d0/nc**3*nf*facVV          ! qb Q subtraction        Ah3g2H
      case(309)
         factor=1d0/nc**3*nf*facVV          ! qb Qb subtraction       Ah3g2H
      case(310)
         factor=1d0/nc**2*nf*facVV          ! qb g subtraction        Ah3g2H
      case(311)
         factor=1d0/nc**2*nf**2*2d0*facVV   ! g g -> g ph1 ph2        Ahh3g2H
      case(312)
         factor=1d0/nc**3*nf**2*facVV       ! g q subtraction         Ahh3g2H
      case(313)
         factor=1d0/nc**3*nf**2*facVV       ! g qb subtraction        Ahh3g2H
      case(314)
         factor=1d0/nc**4*nf**2*facVV       ! q Q subtraction         Ahh3g2H
      case(315)
         factor=1d0/nc**4*nf**2*facVV       ! q Qb subtraction        Ahh3g2H
      case(316)
         factor=1d0/nc**3*nf**2*facVV       ! q g subtraction         Ahh3g2H
      case(317)
         factor=1d0/nc**4*nf**2*facVV       ! qb Q subtraction        Ahh3g2H
      case(318)
         factor=1d0/nc**4*nf**2*facVV       ! qb Qb subtraction       Ahh3g2H
      case(319)
         factor=1d0/nc**3*nf**2*facVV       ! qb g subtraction        Ahh3g2H
      case(320)
         factor=1d0/nc**3*nf*2d0*facVV      ! g g -> g ph1 ph2        Aht3g2H
      case(321)
         factor=1d0/nc**4*nf*facVV          ! g q subtraction         Aht3g2H
      case(322)
         factor=1d0/nc**4*nf*facVV          ! g qb subtraction        Aht3g2H
      case(323)
         factor=1d0/nc**5*nf*facVV          ! q Q subtraction         Aht3g2H
      case(324)
         factor=1d0/nc**5*nf*facVV          ! q Qb subtraction        Aht3g2H
      case(325)
         factor=1d0/nc**4*nf*facVV          ! q g subtraction         Aht3g2H
      case(326)
         factor=1d0/nc**5*nf*facVV          ! qb Q subtraction        Aht3g2H
      case(327)
         factor=1d0/nc**5*nf*facVV          ! qb Qb subtraction       Aht3g2H
      case(328)
         factor=1d0/nc**4*nf*facVV          ! qb g subtraction        Aht3g2H
      case(329)
         factor=1d0/nc**4*2d0*facVV         ! g g -> g ph1 ph2        Att3g2H
      case(330)
         factor=1d0/nc**5*facVV             ! g q subtraction         Att3g2H
      case(331)
         factor=1d0/nc**5*facVV             ! g qb subtraction        Att3g2H
      case(332)
         factor=1d0/nc**6*facVV             ! q Q subtraction         Att3g2H
      case(333)
         factor=1d0/nc**6*facVV             ! q Qb subtraction        Att3g2H
      case(334)
         factor=1d0/nc**5*facVV             ! q g subtraction         Att3g2H
      case(335)
         factor=1d0/nc**6*facVV             ! qb Q subtraction        Att3g2H
      case(336)
         factor=1d0/nc**6*facVV             ! qb Qb subtraction       Att3g2H
      case(337)
         factor=1d0/nc**5*facVV             ! qb g subtraction        Att3g2H
      case(338)
         factor=1d0/nc*facVV                ! q g -> q ph1 ph2        B1g2H
      case(339)
         factor=1d0/nc*facVV                ! q qb -> g ph1 ph2       B1g2H
      case(340)
         factor=1d0/nc*facVV                ! g q -> q ph1 ph2        B1g2H
      case(341)
         factor=1d0/nc*facVV                ! qb q -> g ph1 ph2       B1g2H
      case(342)
         factor=1d0/nc*facVV                ! g qb -> qb ph1 ph2      B1g2H
      case(343)
         factor=1d0/nc*facVV                ! qb g -> qb ph1 ph2      B1g2H
      case(344)
         factor=1d0/nc*nf*facVV             ! g g subtraction         B1g2H
      case(345)
         factor=1d0/nc**2*facVV             ! q Q subtraction         B1g2H
      case(346)
         factor=1d0/nc**2*facVV             ! q Qb subtraction        B1g2H
      case(347)
         factor=1d0/nc**3*facVV             ! q q subtraction         B1g2H
      case(348)
         factor=1d0/nc**2*facVV             ! qb Q subtraction        B1g2H
      case(349)
         factor=1d0/nc**2*facVV             ! qb Qb subtraction       B1g2H
      case(350)
         factor=1d0/nc**3*facVV             ! qb qb subtraction       B1g2H
      case(351)
         factor=1d0/nc**3*facVV             ! q g -> q ph1 ph2        Bt1g2H
      case(352)
         factor=1d0/nc**3*facVV             ! q qb -> g ph1 ph2       Bt1g2H
      case(353)
         factor=1d0/nc**3*facVV             ! g q -> q ph1 ph2        Bt1g2H
      case(354)
         factor=1d0/nc**3*facVV             ! qb q -> g ph1 ph2       Bt1g2H
      case(355)
         factor=1d0/nc**3*facVV             ! g qb -> qb ph1 ph2      Bt1g2H
      case(356)
         factor=1d0/nc**3*facVV             ! qb g -> qb ph1 ph2      Bt1g2H
      case(357)
         factor=1d0/nc**3*nf*facVV          ! g g subtraction         Bt1g2H
      case(358)
         factor=1d0/nc**4*facVV             ! q Q subtraction         Bt1g2H
      case(359)
         factor=1d0/nc**4*facVV             ! q Qb subtraction        Bt1g2H
      case(360)
         factor=1d0/nc**5*facVV             ! q q subtraction         Bt1g2H
      case(361)
         factor=1d0/nc**4*facVV             ! qb Q subtraction        Bt1g2H
      case(362)
         factor=1d0/nc**4*facVV             ! qb Qb subtraction       Bt1g2H
      case(363)
         factor=1d0/nc**5*facVV             ! qb qb subtraction       Bt1g2H
      case(364)
         factor=1d0/nc**2*nf*facVV          ! q g -> q ph1 ph2        Bh1g2H
      case(365)
         factor=1d0/nc**2*nf*facVV          ! q qb -> g ph1 ph2       Bh1g2H
      case(366)
         factor=1d0/nc**2*nf*facVV          ! g q -> q ph1 ph2        Bh1g2H
      case(367)
         factor=1d0/nc**2*nf*facVV          ! qb q -> g ph1 ph2       Bh1g2H
      case(368)
         factor=1d0/nc**2*nf*facVV          ! g qb -> qb ph1 ph2      Bh1g2H
      case(369)
         factor=1d0/nc**2*nf*facVV          ! qb g -> qb ph1 ph2      Bh1g2H
      case(370)
         factor=1d0/nc**2*nf*facVV          ! Q g subtraction         Bh1g2H
      case(371)
         factor=1d0/nc**2*nf*facVV          ! Qb g subtraction        Bh1g2H
      case(372)
         factor=1d0/nc**2*nf*facVV          ! g Q subtraction         Bh1g2H
      case(373)
         factor=1d0/nc**2*nf*facVV          ! g Qb subtraction        Bh1g2H
      case(374)
         factor=1d0/nc**2*nf**2*facVV       ! g g subtraction         Bh1g2H
      case(375)
         factor=1d0/nc**3*nf*facVV          ! q Q subtraction         Bh1g2H
      case(376)
         factor=1d0/nc**3*nf*facVV          ! q Qb subtraction        Bh1g2H
      case(377)
         factor=1d0/nc**4*nf*facVV          ! q q subtraction         Bh1g2H
      case(378)
         factor=1d0/nc**3*nf*facVV          ! qb Q subtraction        Bh1g2H
      case(379)
         factor=1d0/nc**3*nf*facVV          ! qb Qb subtraction       Bh1g2H
      case(380)
         factor=1d0/nc**4*nf*facVV          ! qb qb subtraction       Bh1g2H
      case(381)
         factor=1d0/nc**3*nf**2*facVV       ! q g -> q ph1 ph2        Bhh1g2H
      case(382)
         factor=1d0/nc**3*nf**2*facVV       ! q qb -> g ph1 ph2       Bhh1g2H
      case(383)
         factor=1d0/nc**3*nf**2*facVV       ! g q -> q ph1 ph2        Bhh1g2H
      case(384)
         factor=1d0/nc**3*nf**2*facVV       ! qb q -> g ph1 ph2       Bhh1g2H
      case(385)
         factor=1d0/nc**3*nf**2*facVV       ! g qb -> qb ph1 ph2      Bhh1g2H
      case(386)
         factor=1d0/nc**3*nf**2*facVV       ! qb g -> qb ph1 ph2      Bhh1g2H
      case(387)
         factor=1d0/nc**3*nf**2*facVV       ! Q g subtraction         Bhh1g2H
      case(388)
         factor=1d0/nc**3*nf**2*facVV       ! Qb g subtraction        Bhh1g2H
      case(389)
         factor=1d0/nc**3*nf**2*facVV       ! g Q subtraction         Bhh1g2H
      case(390)
         factor=1d0/nc**3*nf**2*facVV       ! g Qb subtraction        Bhh1g2H
      case(391)
         factor=1d0/nc**3*nf**3*facVV       ! g g subtraction         Bhh1g2H
      case(392)
         factor=1d0/nc**4*nf**2*facVV       ! q Q subtraction         Bhh1g2H
      case(393)
         factor=1d0/nc**4*nf**2*facVV       ! q Qb subtraction        Bhh1g2H
      case(394)
         factor=1d0/nc**5*nf**2*facVV       ! q q subtraction         Bhh1g2H
      case(395)
         factor=1d0/nc**4*nf**2*facVV       ! qb Q subtraction        Bhh1g2H
      case(396)
         factor=1d0/nc**4*nf**2*facVV       ! qb Qb subtraction       Bhh1g2H
      case(397)
         factor=1d0/nc**5*nf**2*facVV       ! qb qb subtraction       Bhh1g2H
      case(398)
         factor=1d0/nc**4*nf*facVV          ! q g -> q ph1 ph2        Bht1g2H
      case(399)
         factor=1d0/nc**4*nf*facVV          ! q qb -> g ph1 ph2       Bht1g2H
      case(400)
         factor=1d0/nc**4*nf*facVV          ! g q -> q ph1 ph2        Bht1g2H
      case(401)
         factor=1d0/nc**4*nf*facVV          ! qb q -> g ph1 ph2       Bht1g2H
      case(402)
         factor=1d0/nc**4*nf*facVV          ! g qb -> qb ph1 ph2      Bht1g2H
      case(403)
         factor=1d0/nc**4*nf*facVV          ! qb g -> qb ph1 ph2      Bht1g2H
      case(404)
         factor=1d0/nc**4*nf*facVV          ! Q g subtraction         Bht1g2H
      case(405)
         factor=1d0/nc**4*nf*facVV          ! Qb g subtraction        Bht1g2H
      case(406)
         factor=1d0/nc**4*nf*facVV          ! g Q subtraction         Bht1g2H
      case(407)
         factor=1d0/nc**4*nf*facVV          ! g Qb subtraction        Bht1g2H
      case(408)
         factor=1d0/nc**4*nf**2*facVV       ! g g subtraction         Bht1g2H
      case(409)
         factor=1d0/nc**5*nf*facVV          ! q Q subtraction         Bht1g2H
      case(410)
         factor=1d0/nc**5*nf*facVV          ! q Qb subtraction        Bht1g2H
      case(411)
         factor=1d0/nc**6*nf*facVV          ! q q subtraction         Bht1g2H
      case(412)
         factor=1d0/nc**5*nf*facVV          ! qb Q subtraction        Bht1g2H
      case(413)
         factor=1d0/nc**5*nf*facVV          ! qb Qb subtraction       Bht1g2H
      case(414)
         factor=1d0/nc**6*nf*facVV          ! qb qb subtraction       Bht1g2H
      case(415)
         factor=1d0/nc**5*facVV             ! q g -> q ph1 ph2        Btt1g2H
      case(416)
         factor=1d0/nc**5*facVV             ! q qb -> g ph1 ph2       Btt1g2H
      case(417)
         factor=1d0/nc**5*facVV             ! g q -> q ph1 ph2        Btt1g2H
      case(418)
         factor=1d0/nc**5*facVV             ! qb q -> g ph1 ph2       Btt1g2H
      case(419)
         factor=1d0/nc**5*facVV             ! g qb -> qb ph1 ph2      Btt1g2H
      case(420)
         factor=1d0/nc**5*facVV             ! qb g -> qb ph1 ph2      Btt1g2H
      case(421)
         factor=1d0/nc**5*nf*facVV          ! g g subtraction         Btt1g2H
      case(422)
         factor=1d0/nc**6*facVV             ! q Q subtraction         Btt1g2H
      case(423)
         factor=1d0/nc**6*facVV             ! q Qb subtraction        Btt1g2H
      case(424)
         factor=1d0/nc**7*facVV             ! q q subtraction         Btt1g2H
      case(425)
         factor=1d0/nc**6*facVV             ! qb Q subtraction        Btt1g2H
      case(426)
         factor=1d0/nc**6*facVV             ! qb Qb subtraction       Btt1g2H
      case(427)
         factor=1d0/nc**7*facVV             ! qb qb subtraction       Btt1g2H
      case(428)
         factor=C2*2d0*facVV                ! g g -> g ph1 ph2        A3g0H
      case(429)
         factor=C2/nc*facVV                 ! q g -> q ph1 ph2        B1g0H
      case(430)
         factor=C2/nc*facVV                 ! q qb -> g ph1 ph2       B1g0H
      case(431)
         factor=C2/nc*facVV                 ! g q -> q ph1 ph2        B1g0H
      case(432)
         factor=C2/nc*facVV                 ! qb q -> g ph1 ph2       B1g0H
      case(433)
         factor=C2/nc*facVV                 ! g qb -> qb ph1 ph2      B1g0H
      case(434)
         factor=C2/nc*facVV                 ! qb g -> qb ph1 ph2      B1g0H
      case(435)
         factor=C2h*nf*2d0*facVV            ! g g -> g ph1 ph2        A3g0H
      case(436)
         factor=C2h/nc*nf*facVV             ! q g -> q ph1 ph2        B1g0H
      case(437)
         factor=C2h/nc*nf*facVV             ! q qb -> g ph1 ph2       B1g0H
      case(438)
         factor=C2h/nc*nf*facVV             ! g q -> q ph1 ph2        B1g0H
      case(439)
         factor=C2h/nc*nf*facVV             ! qb q -> g ph1 ph2       B1g0H
      case(440)
         factor=C2h/nc*nf*facVV             ! g qb -> qb ph1 ph2      B1g0H
      case(441)
         factor=C2h/nc*nf*facVV             ! qb g -> qb ph1 ph2      B1g0H
      case(442)
         factor=C1*2d0*facVV                ! g g -> g ph1 ph2        A3g1H
      case(443)
         factor=C1/nc*facVV                 ! g q subtraction         A3g1H
      case(444)
         factor=C1/nc*facVV                 ! g qb subtraction        A3g1H
      case(445)
         factor=C1/nc*facVV                 ! q g subtraction         A3g1H
      case(446)
         factor=C1/nc*facVV                 ! qb g subtraction        A3g1H
      case(447)
         factor=C1/nc*nf*2d0*facVV          ! g g -> g ph1 ph2        Ah3g1H
      case(448)
         factor=C1/nc**2*nf*facVV           ! g q subtraction         Ah3g1H
      case(449)
         factor=C1/nc**2*nf*facVV           ! g qb subtraction        Ah3g1H
      case(450)
         factor=C1/nc**2*nf*facVV           ! q g subtraction         Ah3g1H
      case(451)
         factor=C1/nc**2*nf*facVV           ! qb g subtraction        Ah3g1H
      case(452)
         factor=C1/nc*facVV                 ! q g -> q ph1 ph2        B1g1H
      case(453)
         factor=C1/nc*facVV                 ! q qb -> g ph1 ph2       B1g1H
      case(454)
         factor=C1/nc*facVV                 ! g q -> q ph1 ph2        B1g1H
      case(455)
         factor=C1/nc*facVV                 ! qb q -> g ph1 ph2       B1g1H
      case(456)
         factor=C1/nc*facVV                 ! g qb -> qb ph1 ph2      B1g1H
      case(457)
         factor=C1/nc*facVV                 ! qb g -> qb ph1 ph2      B1g1H
      case(458)
         factor=C1/nc*nf*facVV              ! g g subtraction         B1g1H
      case(459)
         factor=C1/nc**2*facVV              ! q Q subtraction         B1g1H
      case(460)
         factor=C1/nc**2*facVV              ! q Qb subtraction        B1g1H
      case(461)
         factor=C1/nc**2*facVV              ! qb Q subtraction        B1g1H
      case(462)
         factor=C1/nc**2*facVV              ! qb Qb subtraction       B1g1H
      case(463)
         factor=C1/nc**2*nf*facVV           ! q g -> q ph1 ph2        Bh1g1H
      case(464)
         factor=C1/nc**2*nf*facVV           ! q qb -> g ph1 ph2       Bh1g1H
      case(465)
         factor=C1/nc**2*nf*facVV           ! g q -> q ph1 ph2        Bh1g1H
      case(466)
         factor=C1/nc**2*nf*facVV           ! qb q -> g ph1 ph2       Bh1g1H
      case(467)
         factor=C1/nc**2*nf*facVV           ! g qb -> qb ph1 ph2      Bh1g1H
      case(468)
         factor=C1/nc**2*nf*facVV           ! qb g -> qb ph1 ph2      Bh1g1H
      case(469)
         factor=C1/nc**2*nf**2*facVV        ! g g subtraction         Bh1g1H
      case(470)
         factor=C1/nc**3*nf*facVV           ! q Q subtraction         Bh1g1H
      case(471)
         factor=C1/nc**3*nf*facVV           ! q Qb subtraction        Bh1g1H
      case(472)
         factor=C1/nc**3*nf*facVV           ! qb Q subtraction        Bh1g1H
      case(473)
         factor=C1/nc**3*nf*facVV           ! qb Qb subtraction       Bh1g1H
      case(474)
         factor=-C1/nc**3*facVV             ! q g -> q ph1 ph2        Bt1g1H
      case(475)
         factor=-C1/nc**3*facVV             ! q qb -> g ph1 ph2       Bt1g1H
      case(476)
         factor=-C1/nc**3*facVV             ! g q -> q ph1 ph2        Bt1g1H
      case(477)
         factor=-C1/nc**3*facVV             ! qb q -> g ph1 ph2       Bt1g1H
      case(478)
         factor=-C1/nc**3*facVV             ! g qb -> qb ph1 ph2      Bt1g1H
      case(479)
         factor=-C1/nc**3*facVV             ! qb g -> qb ph1 ph2      Bt1g1H
      case(480)
         factor=-C1/nc**3*nf*facVV          ! g g subtraction         Bt1g1H
      case(481)
         factor=-C1/nc**4*facVV             ! q Q subtraction         Bt1g1H
      case(482)
         factor=-C1/nc**4*facVV             ! q Qb subtraction        Bt1g1H
      case(483)
         factor=-C1/nc**4*facVV             ! qb Q subtraction        Bt1g1H
      case(484)
         factor=-C1/nc**4*facVV             ! qb Qb subtraction       Bt1g1H
      end select
      factor=relfactor*factor

      return
      end
