      function sigBHJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigBHJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,5,ipass)
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- g g to g ph1 ph2 
      if (qactive_chan(1).and.qselect_chan(1)) then
        current_chan = 1
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           A3g0H(1,2,3,4,5) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to q ph1 ph2 
      if (qactive_chan(2).and.qselect_chan(2)) then
        current_chan = 2
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0H(1,2,3,4,5)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g ph1 ph2 
      if (qactive_chan(3).and.qselect_chan(3)) then
        current_chan = 3
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0H(1,3,2,4,5)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to q ph1 ph2 
      if (qactive_chan(4).and.qselect_chan(4)) then
        current_chan = 4
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0H(2,1,3,4,5)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g ph1 ph2 
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0H(2,3,1,4,5)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb ph1 ph2 
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0H(3,1,2,4,5)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb ph1 ph2 
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B1g0H(3,2,1,4,5)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigBHJ=rnorm*wtsum

      return
      end
