      function sigRVHJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRVHJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,6,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(6, (/ 1, 2, 3, 4, 5, 6 /) )
#endif 

c--- g g to g g ph1 ph2 
      if (qactive_chan(141).and.qselect_chan(141)) then
        current_chan = 141
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           A4g1H(1,2,3,4,5,6,muR2_scl(i))
     .          +A4g1H(1,2,4,3,5,6,muR2_scl(i))
     .          +A4g1H(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to g g ph1 ph2 
      if (qactive_chan(146).and.qselect_chan(146)) then
        current_chan = 146
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Ah4g1H(1,2,3,4,5,6,muR2_scl(i))
     .          +Ah4g1H(1,2,4,3,5,6,muR2_scl(i))
     .          +Ah4g1H(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g q ph1 ph2 
      if (qactive_chan(151).and.qselect_chan(151)) then
        current_chan = 151
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g1H(1,2,3,4,5,6,muR2_scl(i))
     .          +B2g1H(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g ph1 ph2 
      if (qactive_chan(152).and.qselect_chan(152)) then
        current_chan = 152
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g1H(1,3,4,2,5,6,muR2_scl(i))
     .          +B2g1H(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g q ph1 ph2 
      if (qactive_chan(153).and.qselect_chan(153)) then
        current_chan = 153
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g1H(2,1,3,4,5,6,muR2_scl(i))
     .          +B2g1H(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g ph1 ph2 
      if (qactive_chan(154).and.qselect_chan(154)) then
        current_chan = 154
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g1H(2,3,4,1,5,6,muR2_scl(i))
     .          +B2g1H(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb q ph1 ph2 
      if (qactive_chan(155).and.qselect_chan(155)) then
        current_chan = 155
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g1H(3,1,2,4,5,6,muR2_scl(i))
     .          +B2g1H(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g ph1 ph2 
      if (qactive_chan(156).and.qselect_chan(156)) then
        current_chan = 156
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g1H(3,1,4,2,5,6,muR2_scl(i))
     .          +B2g1H(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g ph1 ph2 
      if (qactive_chan(157).and.qselect_chan(157)) then
        current_chan = 157
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g1H(3,2,4,1,5,6,muR2_scl(i))
     .          +B2g1H(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g q ph1 ph2 
      if (qactive_chan(162).and.qselect_chan(162)) then
        current_chan = 162
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh2g1H(1,2,3,4,5,6,muR2_scl(i))
     .          +Bh2g1H(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g ph1 ph2 
      if (qactive_chan(163).and.qselect_chan(163)) then
        current_chan = 163
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh2g1H(1,3,4,2,5,6,muR2_scl(i))
     .          +Bh2g1H(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g q ph1 ph2 
      if (qactive_chan(164).and.qselect_chan(164)) then
        current_chan = 164
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh2g1H(2,1,3,4,5,6,muR2_scl(i))
     .          +Bh2g1H(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g ph1 ph2 
      if (qactive_chan(165).and.qselect_chan(165)) then
        current_chan = 165
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh2g1H(2,3,4,1,5,6,muR2_scl(i))
     .          +Bh2g1H(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb q ph1 ph2 
      if (qactive_chan(166).and.qselect_chan(166)) then
        current_chan = 166
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh2g1H(3,1,2,4,5,6,muR2_scl(i))
     .          +Bh2g1H(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g ph1 ph2 
      if (qactive_chan(167).and.qselect_chan(167)) then
        current_chan = 167
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh2g1H(3,1,4,2,5,6,muR2_scl(i))
     .          +Bh2g1H(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g ph1 ph2 
      if (qactive_chan(168).and.qselect_chan(168)) then
        current_chan = 168
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bh2g1H(3,2,4,1,5,6,muR2_scl(i))
     .          +Bh2g1H(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g q ph1 ph2 
      if (qactive_chan(173).and.qselect_chan(173)) then
        current_chan = 173
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt2g1H(1,2,3,4,5,6,muR2_scl(i))
     .          +Bt2g1H(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g ph1 ph2 
      if (qactive_chan(174).and.qselect_chan(174)) then
        current_chan = 174
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt2g1H(1,3,4,2,5,6,muR2_scl(i))
     .          +Bt2g1H(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g q ph1 ph2 
      if (qactive_chan(175).and.qselect_chan(175)) then
        current_chan = 175
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt2g1H(2,1,3,4,5,6,muR2_scl(i))
     .          +Bt2g1H(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g ph1 ph2 
      if (qactive_chan(176).and.qselect_chan(176)) then
        current_chan = 176
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt2g1H(2,3,4,1,5,6,muR2_scl(i))
     .          +Bt2g1H(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb q ph1 ph2 
      if (qactive_chan(177).and.qselect_chan(177)) then
        current_chan = 177
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt2g1H(3,1,2,4,5,6,muR2_scl(i))
     .          +Bt2g1H(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g ph1 ph2 
      if (qactive_chan(178).and.qselect_chan(178)) then
        current_chan = 178
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt2g1H(3,1,4,2,5,6,muR2_scl(i))
     .          +Bt2g1H(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g ph1 ph2 
      if (qactive_chan(179).and.qselect_chan(179)) then
        current_chan = 179
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt2g1H(3,2,4,1,5,6,muR2_scl(i))
     .          +Bt2g1H(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt q ph1 ph2 
      if (qactive_chan(184).and.qselect_chan(184)) then
        current_chan = 184
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt2g1HF(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt ph1 ph2 
      if (qactive_chan(185).and.qselect_chan(185)) then
        current_chan = 185
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btt2g1HF(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt q ph1 ph2 
      if (qactive_chan(186).and.qselect_chan(186)) then
        current_chan = 186
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt2g1HF(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt ph1 ph2 
      if (qactive_chan(187).and.qselect_chan(187)) then
        current_chan = 187
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btt2g1HF(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb q ph1 ph2 
      if (qactive_chan(188).and.qselect_chan(188)) then
        current_chan = 188
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt2g1HF(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt ph1 ph2 
      if (qactive_chan(189).and.qselect_chan(189)) then
        current_chan = 189
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt2g1HF(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt ph1 ph2 
      if (qactive_chan(190).and.qselect_chan(190)) then
        current_chan = 190
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt2g1HF(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt q ph1 ph2 
      if (qactive_chan(191).and.qselect_chan(191)) then
        current_chan = 191
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bttt2g1H(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt ph1 ph2 
      if (qactive_chan(192).and.qselect_chan(192)) then
        current_chan = 192
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bttt2g1H(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt q ph1 ph2 
      if (qactive_chan(193).and.qselect_chan(193)) then
        current_chan = 193
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bttt2g1H(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt ph1 ph2 
      if (qactive_chan(194).and.qselect_chan(194)) then
        current_chan = 194
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bttt2g1H(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb q ph1 ph2 
      if (qactive_chan(195).and.qselect_chan(195)) then
        current_chan = 195
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bttt2g1H(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt ph1 ph2 
      if (qactive_chan(196).and.qselect_chan(196)) then
        current_chan = 196
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bttt2g1H(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt ph1 ph2 
      if (qactive_chan(197).and.qselect_chan(197)) then
        current_chan = 197
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bttt2g1H(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt q ph1 ph2 
      if (qactive_chan(198).and.qselect_chan(198)) then
        current_chan = 198
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btth2g1H(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt ph1 ph2 
      if (qactive_chan(199).and.qselect_chan(199)) then
        current_chan = 199
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btth2g1H(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt q ph1 ph2 
      if (qactive_chan(200).and.qselect_chan(200)) then
        current_chan = 200
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btth2g1H(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt ph1 ph2 
      if (qactive_chan(201).and.qselect_chan(201)) then
        current_chan = 201
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Btth2g1H(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb q ph1 ph2 
      if (qactive_chan(202).and.qselect_chan(202)) then
        current_chan = 202
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btth2g1H(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt ph1 ph2 
      if (qactive_chan(203).and.qselect_chan(203)) then
        current_chan = 203
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btth2g1H(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt ph1 ph2 
      if (qactive_chan(204).and.qselect_chan(204)) then
        current_chan = 204
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btth2g1H(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to Qb q ph1 ph2 
      if (qactive_chan(205).and.qselect_chan(205)) then
        current_chan = 205
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g1HF(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to Q q ph1 ph2 
      if (qactive_chan(206).and.qselect_chan(206)) then
        current_chan = 206
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g1HF(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to Q Qb ph1 ph2 
      if (qactive_chan(207).and.qselect_chan(207)) then
        current_chan = 207
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g1HF(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to Q Qb ph1 ph2 
      if (qactive_chan(208).and.qselect_chan(208)) then
        current_chan = 208
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g1HF(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb Qb ph1 ph2 
      if (qactive_chan(209).and.qselect_chan(209)) then
        current_chan = 209
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g1HF(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb Q ph1 ph2 
      if (qactive_chan(210).and.qselect_chan(210)) then
        current_chan = 210
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g1HF(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to Qb q ph1 ph2 
      if (qactive_chan(215).and.qselect_chan(215)) then
        current_chan = 215
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1HF(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to Q q ph1 ph2 
      if (qactive_chan(216).and.qselect_chan(216)) then
        current_chan = 216
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1HF(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to Q Qb ph1 ph2 
      if (qactive_chan(217).and.qselect_chan(217)) then
        current_chan = 217
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1HF(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to Q Qb ph1 ph2 
      if (qactive_chan(218).and.qselect_chan(218)) then
        current_chan = 218
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1HF(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb Qb ph1 ph2 
      if (qactive_chan(219).and.qselect_chan(219)) then
        current_chan = 219
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1HF(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb Q ph1 ph2 
      if (qactive_chan(220).and.qselect_chan(220)) then
        current_chan = 220
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1HF(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to Qb q ph1 ph2 
      if (qactive_chan(225).and.qselect_chan(225)) then
        current_chan = 225
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1H(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to Q q ph1 ph2 
      if (qactive_chan(226).and.qselect_chan(226)) then
        current_chan = 226
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1H(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to Q Qb ph1 ph2 
      if (qactive_chan(227).and.qselect_chan(227)) then
        current_chan = 227
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1H(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to Q Qb ph1 ph2 
      if (qactive_chan(228).and.qselect_chan(228)) then
        current_chan = 228
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1H(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb Qb ph1 ph2 
      if (qactive_chan(229).and.qselect_chan(229)) then
        current_chan = 229
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1H(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb Q ph1 ph2 
      if (qactive_chan(230).and.qselect_chan(230)) then
        current_chan = 230
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1H(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to qb q ph1 ph2 
      if (qactive_chan(235).and.qselect_chan(235)) then
        current_chan = 235
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1H(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to q q ph1 ph2 
      if (qactive_chan(236).and.qselect_chan(236)) then
        current_chan = 236
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1H(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to qb q ph1 ph2 
      if (qactive_chan(237).and.qselect_chan(237)) then
        current_chan = 237
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1H(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb qb ph1 ph2 
      if (qactive_chan(238).and.qselect_chan(238)) then
        current_chan = 238
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1H(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to qb q ph1 ph2 
      if (qactive_chan(243).and.qselect_chan(243)) then
        current_chan = 243
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1H(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to q q ph1 ph2 
      if (qactive_chan(244).and.qselect_chan(244)) then
        current_chan = 244
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1H(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to qb q ph1 ph2 
      if (qactive_chan(245).and.qselect_chan(245)) then
        current_chan = 245
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1H(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb qb ph1 ph2 
      if (qactive_chan(246).and.qselect_chan(246)) then
        current_chan = 246
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1H(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to qb q ph1 ph2 
      if (qactive_chan(251).and.qselect_chan(251)) then
        current_chan = 251
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1H(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to q q ph1 ph2 
      if (qactive_chan(252).and.qselect_chan(252)) then
        current_chan = 252
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1H(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to qb q ph1 ph2 
      if (qactive_chan(253).and.qselect_chan(253)) then
        current_chan = 253
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1H(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb qb ph1 ph2 
      if (qactive_chan(254).and.qselect_chan(254)) then
        current_chan = 254
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1H(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to g g ph1 ph2 wilson
      if (qactive_chan(259).and.qselect_chan(259)) then
        current_chan = 259
        ip1_chan     = 0
        ip2_chan     = 0
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           A4g0H(1,2,3,4,5,6)
     .          +A4g0H(1,2,4,3,5,6)
     .          +A4g0H(1,3,2,4,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q g to g q ph1 ph2 wilson
      if (qactive_chan(260).and.qselect_chan(260)) then
        current_chan = 260
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g0H(1,2,3,4,5,6)
     .          +B2g0H(1,3,2,4,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to g g ph1 ph2 wilson
      if (qactive_chan(261).and.qselect_chan(261)) then
        current_chan = 261
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g0H(1,3,4,2,5,6)
     .          +B2g0H(1,4,3,2,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g q to g q ph1 ph2 wilson
      if (qactive_chan(262).and.qselect_chan(262)) then
        current_chan = 262
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g0H(2,1,3,4,5,6)
     .          +B2g0H(2,3,1,4,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to g g ph1 ph2 wilson
      if (qactive_chan(263).and.qselect_chan(263)) then
        current_chan = 263
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g0H(2,3,4,1,5,6)
     .          +B2g0H(2,4,3,1,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to qb q ph1 ph2 wilson
      if (qactive_chan(264).and.qselect_chan(264)) then
        current_chan = 264
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g0H(3,1,2,4,5,6)
     .          +B2g0H(3,2,1,4,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g qb to qb g ph1 ph2 wilson
      if (qactive_chan(265).and.qselect_chan(265)) then
        current_chan = 265
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g0H(3,1,4,2,5,6)
     .          +B2g0H(3,4,1,2,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb g to qb g ph1 ph2 wilson
      if (qactive_chan(266).and.qselect_chan(266)) then
        current_chan = 266
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           B2g0H(3,2,4,1,5,6)
     .          +B2g0H(3,4,2,1,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q gt to gt q ph1 ph2 wilson
      if (qactive_chan(267).and.qselect_chan(267)) then
        current_chan = 267
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt2g0H(1,2,3,4,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to gt gt ph1 ph2 wilson
      if (qactive_chan(268).and.qselect_chan(268)) then
        current_chan = 268
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt2g0H(1,3,4,2,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt q to gt q ph1 ph2 wilson
      if (qactive_chan(269).and.qselect_chan(269)) then
        current_chan = 269
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt2g0H(2,1,3,4,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to gt gt ph1 ph2 wilson
      if (qactive_chan(270).and.qselect_chan(270)) then
        current_chan = 270
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           Bt2g0H(2,3,4,1,5,6) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to qb q ph1 ph2 wilson
      if (qactive_chan(271).and.qselect_chan(271)) then
        current_chan = 271
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt2g0H(3,1,2,4,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt qb to qb gt ph1 ph2 wilson
      if (qactive_chan(272).and.qselect_chan(272)) then
        current_chan = 272
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt2g0H(3,1,4,2,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb gt to qb gt ph1 ph2 wilson
      if (qactive_chan(273).and.qselect_chan(273)) then
        current_chan = 273
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt2g0H(3,2,4,1,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Qb to Qb q ph1 ph2 wilson
      if (qactive_chan(274).and.qselect_chan(274)) then
        current_chan = 274
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g0H(1,2,3,4,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q Q to Q q ph1 ph2 wilson
      if (qactive_chan(275).and.qselect_chan(275)) then
        current_chan = 275
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g0H(1,3,2,4,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to Q Qb ph1 ph2 wilson
      if (qactive_chan(276).and.qselect_chan(276)) then
        current_chan = 276
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g0H(1,3,4,2,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to Q Qb ph1 ph2 wilson
      if (qactive_chan(277).and.qselect_chan(277)) then
        current_chan = 277
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g0H(2,3,4,1,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Qb to qb Qb ph1 ph2 wilson
      if (qactive_chan(278).and.qselect_chan(278)) then
        current_chan = 278
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g0H(3,2,4,1,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb Q to qb Q ph1 ph2 wilson
      if (qactive_chan(279).and.qselect_chan(279)) then
        current_chan = 279
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = C0g0H(3,4,2,1,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q qb to qb q ph1 ph2 wilson
      if (qactive_chan(280).and.qselect_chan(280)) then
        current_chan = 280
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g0H(1,2,3,4,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- q q to q q ph1 ph2 wilson
      if (qactive_chan(281).and.qselect_chan(281)) then
        current_chan = 281
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g0H(1,3,2,4,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb q to qb q ph1 ph2 wilson
      if (qactive_chan(282).and.qselect_chan(282)) then
        current_chan = 282
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g0H(2,1,3,4,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- qb qb to qb qb ph1 ph2 wilson
      if (qactive_chan(283).and.qselect_chan(283)) then
        current_chan = 283
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g0H(3,1,4,2,5,6)
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRVHJ=rnorm*wtsum

      return
      end
