      subroutine getlumiWm(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    4,    9,   16,   23,   31,   43,   48,          
     &           56,   71,   86,  100,  119,  138)
!       [40, -20]
          if ( .not. ckmflag ) then
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
          else
          partons(1:nInp_scl) =                                         
     &         CKM(1,2)*f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)              
     &       + CKM(1,4)*f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)              
     &       + CKM(3,2)*f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)              
     &       + CKM(3,4)*f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)
          end if

        case (    2,    6,   10,   18,   25,   34,   45,   50,          
     &           58,   73,   88,  101,  120,  139)
!       [-20, 40]
          if ( .not. ckmflag ) then
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
          else
          partons(1:nInp_scl) =                                         
     &         CKM(2,1)*f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)              
     &       + CKM(2,3)*f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)              
     &       + CKM(4,1)*f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)              
     &       + CKM(4,3)*f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)
          end if

        case (    3,   13,   15,   22,   55,   70,   85,  113,          
     &          132,  151)
!       [40, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    5,   11,   17,   24,   57,   72,   87,  109,          
     &          128,  147)
!       [0, 40]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (    7,   12,   20,   27,   59,   74,   89,  110,          
     &          129,  148)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (    8,   14,   21,   28,   60,   75,   90,  116,          
     &          135,  154)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   19,   26,   65,   80,   95,  108,  127,  146)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   29,   67,   82,   97,  112,  131,  150)
!       [41, -31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   30,   66,   81,   96,  111,  130,  149)
!       [41, 31]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   32,   63,   78,   93,  104,  123,  142)
!       [-31, 41]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       

        case (   33,   61,   76,   91,  102,  121,  140)
!       [31, 41]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (   35)
!       [-30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   36,   64,   79,   94,  105,  124,  143)
!       [-31, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   37)
!       [30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   38,   69,   84,   99,  115,  134,  153)
!       [-21, -31]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   39,   62,   77,   92,  103,  122,  141)
!       [31, -21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   40,   68,   83,   98,  114,  133,  152)
!       [-21, 31]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   41)
!       [40, -40]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case (   42)
!       [40, 40]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (   44)
!       [-40, 40]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       

        case (   46,  107,  126,  145)
!       [-40, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   47,  118,  137,  156)
!       [-20, -40]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   49,  106,  125,  144)
!       [40, 20]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   51,  117,  136,  155)
!       [20, 40]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (   52)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   53)
!       [-20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   54)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case default
          print*, "getlumiWm: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiWm



      function getlumiidWm(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    4,    9,   16,   23,   31,   43,   48,
     &           56,   71,   86,  100,  119,  138)
          id  = 1
          ip1 = 40
          ip2 = -20

        case (    2,    6,   10,   18,   25,   34,   45,   50,
     &           58,   73,   88,  101,  120,  139)
          id  = 2
          ip1 = -20
          ip2 = 40

        case (    3,   13,   15,   22,   55,   70,   85,  113,
     &          132,  151)
          id  = 3
          ip1 = 40
          ip2 = 0

        case (    5,   11,   17,   24,   57,   72,   87,  109,
     &          128,  147)
          id  = 4
          ip1 = 0
          ip2 = 40

        case (    7,   12,   20,   27,   59,   74,   89,  110,
     &          129,  148)
          id  = 5
          ip1 = 0
          ip2 = -20

        case (    8,   14,   21,   28,   60,   75,   90,  116,
     &          135,  154)
          id  = 6
          ip1 = -20
          ip2 = 0

        case (   19,   26,   65,   80,   95,  108,  127,  146)
          id  = 7
          ip1 = 0
          ip2 = 0

        case (   29,   67,   82,   97,  112,  131,  150)
          id  = 8
          ip1 = 41
          ip2 = -31

        case (   30,   66,   81,   96,  111,  130,  149)
          id  = 9
          ip1 = 41
          ip2 = 31

        case (   32,   63,   78,   93,  104,  123,  142)
          id  = 10
          ip1 = -31
          ip2 = 41

        case (   33,   61,   76,   91,  102,  121,  140)
          id  = 11
          ip1 = 31
          ip2 = 41

        case (   35)
          id  = 12
          ip1 = -30
          ip2 = 30

        case (   36,   64,   79,   94,  105,  124,  143)
          id  = 13
          ip1 = -31
          ip2 = -21

        case (   37)
          id  = 14
          ip1 = 30
          ip2 = -30

        case (   38,   69,   84,   99,  115,  134,  153)
          id  = 15
          ip1 = -21
          ip2 = -31

        case (   39,   62,   77,   92,  103,  122,  141)
          id  = 16
          ip1 = 31
          ip2 = -21

        case (   40,   68,   83,   98,  114,  133,  152)
          id  = 17
          ip1 = -21
          ip2 = 31

        case (   41)
          id  = 18
          ip1 = 40
          ip2 = -40

        case (   42)
          id  = 19
          ip1 = 40
          ip2 = 40

        case (   44)
          id  = 20
          ip1 = -40
          ip2 = 40

        case (   46,  107,  126,  145)
          id  = 21
          ip1 = -40
          ip2 = -20

        case (   47,  118,  137,  156)
          id  = 22
          ip1 = -20
          ip2 = -40

        case (   49,  106,  125,  144)
          id  = 23
          ip1 = 40
          ip2 = 20

        case (   51,  117,  136,  155)
          id  = 24
          ip1 = 20
          ip2 = 40

        case (   52)
          id  = 25
          ip1 = -20
          ip2 = 20

        case (   53)
          id  = 26
          ip1 = -20
          ip2 = -20

        case (   54)
          id  = 27
          ip1 = 20
          ip2 = -20

        case default
          print*, "getlumiidWm: invalid iproc:", iproc
          stop
        end select

      end function getlumiidWm





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiWm()
        use PineAPPL_mod
        use CKM_mod
!       [40, -20]
        if ( .not. ckmflag ) then
        call register_lumi_pine(
     &         [    1,    4,    9,   16,   23,   31,   43,   48,
     &             56,   71,   86,  100,  119,  138],
     &         2,
     &         [    1,   -2,    3,   -4],
     &         [  1d0,  1d0]
     &       )
        else
        call register_lumi_pine(
     &         [    1,    4,    9,   16,   23,   31,   43,   48,
     &             56,   71,   86,  100,  119,  138],
     &         4,
     &         [    1,   -2,    1,   -4,    3,   -2,    3,   -4],
     &         [ CKM(1,2), CKM(1,4), CKM(3,2), CKM(3,4)]
     &       )
        end if

!       [-20, 40]
        if ( .not. ckmflag ) then
        call register_lumi_pine(
     &         [    2,    6,   10,   18,   25,   34,   45,   50,
     &             58,   73,   88,  101,  120,  139],
     &         2,
     &         [   -2,    1,   -4,    3],
     &         [  1d0,  1d0]
     &       )
        else
        call register_lumi_pine(
     &         [    2,    6,   10,   18,   25,   34,   45,   50,
     &             58,   73,   88,  101,  120,  139],
     &         4,
     &         [   -2,    1,   -2,    3,   -4,    1,   -4,    3],
     &         [ CKM(2,1), CKM(2,3), CKM(4,1), CKM(4,3)]
     &       )
        end if

!       [40, 0]
        call register_lumi_pine(
     &         [    3,   13,   15,   22,   55,   70,   85,  113,
     &            132,  151],
     &         2,
     &         [    1,   21,    3,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 40]
        call register_lumi_pine(
     &         [    5,   11,   17,   24,   57,   72,   87,  109,
     &            128,  147],
     &         2,
     &         [   21,    1,   21,    3],
     &         [  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [    7,   12,   20,   27,   59,   74,   89,  110,
     &            129,  148],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [    8,   14,   21,   28,   60,   75,   90,  116,
     &            135,  154],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 0]
        call register_lumi_pine(
     &         [   19,   26,   65,   80,   95,  108,  127,  146],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [41, -31]
        call register_lumi_pine(
     &         [   29,   67,   82,   97,  112,  131,  150],
     &         10,
     &         [    1,   -1,    1,   -2,    1,   -3,    1,   -4,
     &              1,   -5,    3,   -1,    3,   -2,    3,   -3,
     &              3,   -4,    3,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [41, 31]
        call register_lumi_pine(
     &         [   30,   66,   81,   96,  111,  130,  149],
     &         10,
     &         [    1,    1,    1,    2,    1,    3,    1,    4,
     &              1,    5,    3,    1,    3,    2,    3,    3,
     &              3,    4,    3,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-31, 41]
        call register_lumi_pine(
     &         [   32,   63,   78,   93,  104,  123,  142],
     &         10,
     &         [   -1,    1,   -1,    3,   -2,    1,   -2,    3,
     &             -3,    1,   -3,    3,   -4,    1,   -4,    3,
     &             -5,    1,   -5,    3],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [31, 41]
        call register_lumi_pine(
     &         [   33,   61,   76,   91,  102,  121,  140],
     &         10,
     &         [    1,    1,    1,    3,    2,    1,    2,    3,
     &              3,    1,    3,    3,    4,    1,    4,    3,
     &              5,    1,    5,    3],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-30, 30]
        call register_lumi_pine(
     &         [   35],
     &         5,
     &         [   -1,    1,   -2,    2,   -3,    3,   -4,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-31, -21]
        call register_lumi_pine(
     &         [   36,   64,   79,   94,  105,  124,  143],
     &         10,
     &         [   -1,   -2,   -1,   -4,   -2,   -2,   -2,   -4,
     &             -3,   -2,   -3,   -4,   -4,   -2,   -4,   -4,
     &             -5,   -2,   -5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [30, -30]
        call register_lumi_pine(
     &         [   37],
     &         5,
     &         [    1,   -1,    2,   -2,    3,   -3,    4,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -31]
        call register_lumi_pine(
     &         [   38,   69,   84,   99,  115,  134,  153],
     &         10,
     &         [   -2,   -1,   -2,   -2,   -2,   -3,   -2,   -4,
     &             -2,   -5,   -4,   -1,   -4,   -2,   -4,   -3,
     &             -4,   -4,   -4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [31, -21]
        call register_lumi_pine(
     &         [   39,   62,   77,   92,  103,  122,  141],
     &         10,
     &         [    1,   -2,    1,   -4,    2,   -2,    2,   -4,
     &              3,   -2,    3,   -4,    4,   -2,    4,   -4,
     &              5,   -2,    5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-21, 31]
        call register_lumi_pine(
     &         [   40,   68,   83,   98,  114,  133,  152],
     &         10,
     &         [   -2,    1,   -2,    2,   -2,    3,   -2,    4,
     &             -2,    5,   -4,    1,   -4,    2,   -4,    3,
     &             -4,    4,   -4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [40, -40]
        call register_lumi_pine(
     &         [   41],
     &         2,
     &         [    1,   -1,    3,   -3],
     &         [  1d0,  1d0]
     &       )

!       [40, 40]
        call register_lumi_pine(
     &         [   42],
     &         2,
     &         [    1,    1,    3,    3],
     &         [  1d0,  1d0]
     &       )

!       [-40, 40]
        call register_lumi_pine(
     &         [   44],
     &         2,
     &         [   -1,    1,   -3,    3],
     &         [  1d0,  1d0]
     &       )

!       [-40, -20]
        call register_lumi_pine(
     &         [   46,  107,  126,  145],
     &         2,
     &         [   -1,   -2,   -3,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-20, -40]
        call register_lumi_pine(
     &         [   47,  118,  137,  156],
     &         2,
     &         [   -2,   -1,   -4,   -3],
     &         [  1d0,  1d0]
     &       )

!       [40, 20]
        call register_lumi_pine(
     &         [   49,  106,  125,  144],
     &         2,
     &         [    1,    2,    3,    4],
     &         [  1d0,  1d0]
     &       )

!       [20, 40]
        call register_lumi_pine(
     &         [   51,  117,  136,  155],
     &         2,
     &         [    2,    1,    4,    3],
     &         [  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [   52],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-20, -20]
        call register_lumi_pine(
     &         [   53],
     &         2,
     &         [   -2,   -2,   -4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [   54],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiWm


#endif


