      subroutine getqcdnormWm(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      real(8) :: fac_ckm
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtWm(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVWm
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourWm(current_chan)
         do isub = 1, nflavourWm(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_Wm(current_chan, isub, ipass_sub, flav_block, fac_ckm)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           partons_sub = fac_ckm*partons_sub
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=Wm "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alpha_param()/stw)**2*nc
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d ub -> lm nub          B0g0W
      case(2)
         factor=facB                        ! ub d -> lm nub          B0g0W

c -- real

      case(3)
         factor=(nc**2-1d0)/nc**2*facR      ! d g -> u lm nub         B1g0W
      case(4)
         factor=(nc**2-1d0)/nc**2*facR      ! d ub -> g lm nub        B1g0W
      case(5)
         factor=(nc**2-1d0)/nc**2*facR      ! g d -> u lm nub         B1g0W
      case(6)
         factor=(nc**2-1d0)/nc**2*facR      ! ub d -> g lm nub        B1g0W
      case(7)
         factor=(nc**2-1d0)/nc**2*facR      ! g ub -> db lm nub       B1g0W
      case(8)
         factor=(nc**2-1d0)/nc**2*facR      ! ub g -> db lm nub       B1g0W

c -- virtual

      case(9)
         factor=(nc**2-1d0)/nc**2*facV      ! d ub -> lm nub          B0g1W
      case(10)
         factor=(nc**2-1d0)/nc**2*facV      ! ub d -> lm nub          B0g1W
      case(11)
         factor=(nc**2-1d0)/nc**2*facV      ! g d subtraction         B0g1W
      case(12)
         factor=(nc**2-1d0)/nc**2*facV      ! g ub subtraction        B0g1W
      case(13)
         factor=(nc**2-1d0)/nc**2*facV      ! d g subtraction         B0g1W
      case(14)
         factor=(nc**2-1d0)/nc**2*facV      ! ub g subtraction        B0g1W

c -- double real

      case(15)
         factor=(nc**2-1d0)/nc**2*facRR     ! d g -> g u lm nub       B2g0W
      case(16)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! d ub -> g g lm nub      B2g0W
      case(17)
         factor=(nc**2-1d0)/nc**2*facRR     ! g d -> g u lm nub       B2g0W
      case(18)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! ub d -> g g lm nub      B2g0W
      case(19)
         factor=(nc**2-1d0)/nc**2*nup*facRR   ! g g -> db u lm nub      B2g0W
      case(20)
         factor=(nc**2-1d0)/nc**2*facRR     ! g ub -> db g lm nub     B2g0W
      case(21)
         factor=(nc**2-1d0)/nc**2*facRR     ! ub g -> db g lm nub     B2g0W
      case(22)
         factor=-(nc**2-1d0)/nc**4*facRR    ! d gt -> gt u lm nub     Bt2g0W
      case(23)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d ub -> gt gt lm nub     Bt2g0W
      case(24)
         factor=-(nc**2-1d0)/nc**4*facRR    ! gt d -> gt u lm nub     Bt2g0W
      case(25)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub d -> gt gt lm nub     Bt2g0W
      case(26)
         factor=-(nc**2-1d0)/nc**4*nup*facRR   ! gt gt -> db u lm nub     Bt2g0W
      case(27)
         factor=-(nc**2-1d0)/nc**4*facRR    ! gt ub -> db gt lm nub     Bt2g0W
      case(28)
         factor=-(nc**2-1d0)/nc**4*facRR    ! ub gt -> db gt lm nub     Bt2g0W
      case(29)
         factor=(nc**2-1d0)/nc**3*facRR     ! d Qb -> Qb u lm nub     C0g0W
      case(30)
         factor=(nc**2-1d0)/nc**3*facRR     ! d Q -> Q u lm nub       C0g0W
      case(31)
         factor=(nc**2-1d0)/nc**3*nf*facRR   ! d ub -> Q Qb lm nub     C0g0W
      case(32)
         factor=(nc**2-1d0)/nc**3*facRR     ! Qb d -> Qb u lm nub     C0g0W
      case(33)
         factor=(nc**2-1d0)/nc**3*facRR     ! Q d -> Q u lm nub       C0g0W
      case(34)
         factor=(nc**2-1d0)/nc**3*nf*facRR   ! ub d -> Q Qb lm nub     C0g0W
      case(35)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! Qb Q -> db u lm nub     C0g0W
      case(36)
         factor=(nc**2-1d0)/nc**3*facRR     ! Qb ub -> db Qb lm nub     C0g0W
      case(37)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! Q Qb -> db u lm nub     C0g0W
      case(38)
         factor=(nc**2-1d0)/nc**3*facRR     ! ub Qb -> db Qb lm nub     C0g0W
      case(39)
         factor=(nc**2-1d0)/nc**3*facRR     ! Q ub -> db Q lm nub     C0g0W
      case(40)
         factor=(nc**2-1d0)/nc**3*facRR     ! ub Q -> db Q lm nub     C0g0W
      case(41)
         factor=-(nc**2-1d0)/nc**4*facRR    ! d db -> db u lm nub     D0g0Wa
      case(42)
         factor=-(nc**2-1d0)/nc**4*facRR    ! d d -> d u lm nub       D0g0Wa
      case(43)
         factor=-(nc**2-1d0)/nc**4*facRR    ! d ub -> d db lm nub     D0g0Wa
      case(44)
         factor=-(nc**2-1d0)/nc**4*facRR    ! db d -> db u lm nub     D0g0Wa
      case(45)
         factor=-(nc**2-1d0)/nc**4*facRR    ! ub d -> d db lm nub     D0g0Wa
      case(46)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db ub -> db db lm nub     D0g0Wa
      case(47)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub db -> db db lm nub     D0g0Wa
      case(48)
         factor=-(nc**2-1d0)/nc**4*facRR    ! d ub -> ub u lm nub     D0g0Wb
      case(49)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d u -> u u lm nub       D0g0Wb
      case(50)
         factor=-(nc**2-1d0)/nc**4*facRR    ! ub d -> ub u lm nub     D0g0Wb
      case(51)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u d -> u u lm nub       D0g0Wb
      case(52)
         factor=-(nc**2-1d0)/nc**4*facRR    ! ub u -> db u lm nub     D0g0Wb
      case(53)
         factor=-(nc**2-1d0)/nc**4*facRR    ! ub ub -> db ub lm nub     D0g0Wb
      case(54)
         factor=-(nc**2-1d0)/nc**4*facRR    ! u ub -> db u lm nub     D0g0Wb

c -- real virtual

      case(55)
         factor=(nc**2-1d0)/nc**2*facRV     ! d g -> u lm nub         B1g1W
      case(56)
         factor=(nc**2-1d0)/nc**2*facRV     ! d ub -> g lm nub        B1g1W
      case(57)
         factor=(nc**2-1d0)/nc**2*facRV     ! g d -> u lm nub         B1g1W
      case(58)
         factor=(nc**2-1d0)/nc**2*facRV     ! ub d -> g lm nub        B1g1W
      case(59)
         factor=(nc**2-1d0)/nc**2*facRV     ! g ub -> db lm nub       B1g1W
      case(60)
         factor=(nc**2-1d0)/nc**2*facRV     ! ub g -> db lm nub       B1g1W
      case(61)
         factor=(nc**2-1d0)/nc**3*facRV     ! Q d subtraction         B1g1W
      case(62)
         factor=(nc**2-1d0)/nc**3*facRV     ! Q ub subtraction        B1g1W
      case(63)
         factor=(nc**2-1d0)/nc**3*facRV     ! Qb d subtraction        B1g1W
      case(64)
         factor=(nc**2-1d0)/nc**3*facRV     ! Qb ub subtraction       B1g1W
      case(65)
         factor=(nc**2-1d0)/nc**2*nup*facRV   ! g g subtraction         B1g1W
      case(66)
         factor=(nc**2-1d0)/nc**3*facRV     ! d Q subtraction         B1g1W
      case(67)
         factor=(nc**2-1d0)/nc**3*facRV     ! d Qb subtraction        B1g1W
      case(68)
         factor=(nc**2-1d0)/nc**3*facRV     ! ub Q subtraction        B1g1W
      case(69)
         factor=(nc**2-1d0)/nc**3*facRV     ! ub Qb subtraction       B1g1W
      case(70)
         factor=-(nc**2-1d0)/nc**4*facRV    ! d g -> u lm nub         Bt1g1W
      case(71)
         factor=-(nc**2-1d0)/nc**4*facRV    ! d ub -> g lm nub        Bt1g1W
      case(72)
         factor=-(nc**2-1d0)/nc**4*facRV    ! g d -> u lm nub         Bt1g1W
      case(73)
         factor=-(nc**2-1d0)/nc**4*facRV    ! ub d -> g lm nub        Bt1g1W
      case(74)
         factor=-(nc**2-1d0)/nc**4*facRV    ! g ub -> db lm nub       Bt1g1W
      case(75)
         factor=-(nc**2-1d0)/nc**4*facRV    ! ub g -> db lm nub       Bt1g1W
      case(76)
         factor=-(nc**2-1d0)/nc**5*facRV    ! Q d subtraction         Bt1g1W
      case(77)
         factor=-(nc**2-1d0)/nc**5*facRV    ! Q ub subtraction        Bt1g1W
      case(78)
         factor=-(nc**2-1d0)/nc**5*facRV    ! Qb d subtraction        Bt1g1W
      case(79)
         factor=-(nc**2-1d0)/nc**5*facRV    ! Qb ub subtraction       Bt1g1W
      case(80)
         factor=-(nc**2-1d0)/nc**4*nup*facRV   ! g g subtraction         Bt1g1W
      case(81)
         factor=-(nc**2-1d0)/nc**5*facRV    ! d Q subtraction         Bt1g1W
      case(82)
         factor=-(nc**2-1d0)/nc**5*facRV    ! d Qb subtraction        Bt1g1W
      case(83)
         factor=-(nc**2-1d0)/nc**5*facRV    ! ub Q subtraction        Bt1g1W
      case(84)
         factor=-(nc**2-1d0)/nc**5*facRV    ! ub Qb subtraction       Bt1g1W
      case(85)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! d g -> u lm nub         Bh1g1W
      case(86)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! d ub -> g lm nub        Bh1g1W
      case(87)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! g d -> u lm nub         Bh1g1W
      case(88)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! ub d -> g lm nub        Bh1g1W
      case(89)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! g ub -> db lm nub       Bh1g1W
      case(90)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! ub g -> db lm nub       Bh1g1W
      case(91)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! Q d subtraction         Bh1g1W
      case(92)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! Q ub subtraction        Bh1g1W
      case(93)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! Qb d subtraction        Bh1g1W
      case(94)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! Qb ub subtraction       Bh1g1W
      case(95)
         factor=(nc**2-1d0)/nc**3*nf*nup*facRV   ! g g subtraction         Bh1g1W
      case(96)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! d Q subtraction         Bh1g1W
      case(97)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! d Qb subtraction        Bh1g1W
      case(98)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! ub Q subtraction        Bh1g1W
      case(99)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! ub Qb subtraction       Bh1g1W

c -- double virtual

      case(100)
         factor=(nc**2-1d0)/nc**2*facVV     ! d ub -> lm nub          B0g2Wm
      case(101)
         factor=(nc**2-1d0)/nc**2*facVV     ! ub d -> lm nub          B0g2Wm
      case(102)
         factor=(nc**2-1d0)/nc**3*facVV     ! Q d subtraction         B0g2Wm
      case(103)
         factor=(nc**2-1d0)/nc**3*facVV     ! Q ub subtraction        B0g2Wm
      case(104)
         factor=(nc**2-1d0)/nc**3*facVV     ! Qb d subtraction        B0g2Wm
      case(105)
         factor=(nc**2-1d0)/nc**3*facVV     ! Qb ub subtraction       B0g2Wm
      case(106)
         factor=(nc**2-1d0)/nc**4*facVV     ! d u subtraction         B0g2Wm
      case(107)
         factor=(nc**2-1d0)/nc**4*facVV     ! db ub subtraction       B0g2Wm
      case(108)
         factor=(nc**2-1d0)/nc**2*nup*facVV   ! g g subtraction         B0g2Wm
      case(109)
         factor=(nc**2-1d0)/nc**2*facVV     ! g d subtraction         B0g2Wm
      case(110)
         factor=(nc**2-1d0)/nc**2*facVV     ! g ub subtraction        B0g2Wm
      case(111)
         factor=(nc**2-1d0)/nc**3*facVV     ! d Q subtraction         B0g2Wm
      case(112)
         factor=(nc**2-1d0)/nc**3*facVV     ! d Qb subtraction        B0g2Wm
      case(113)
         factor=(nc**2-1d0)/nc**2*facVV     ! d g subtraction         B0g2Wm
      case(114)
         factor=(nc**2-1d0)/nc**3*facVV     ! ub Q subtraction        B0g2Wm
      case(115)
         factor=(nc**2-1d0)/nc**3*facVV     ! ub Qb subtraction       B0g2Wm
      case(116)
         factor=(nc**2-1d0)/nc**2*facVV     ! ub g subtraction        B0g2Wm
      case(117)
         factor=(nc**2-1d0)/nc**4*facVV     ! u d subtraction         B0g2Wm
      case(118)
         factor=(nc**2-1d0)/nc**4*facVV     ! ub db subtraction       B0g2Wm
      case(119)
         factor=-(nc**2-1d0)/nc**4*facVV    ! d ub -> lm nub          Bt0g2W
      case(120)
         factor=-(nc**2-1d0)/nc**4*facVV    ! ub d -> lm nub          Bt0g2W
      case(121)
         factor=-(nc**2-1d0)/nc**5*facVV    ! Q d subtraction         Bt0g2W
      case(122)
         factor=-(nc**2-1d0)/nc**5*facVV    ! Q ub subtraction        Bt0g2W
      case(123)
         factor=-(nc**2-1d0)/nc**5*facVV    ! Qb d subtraction        Bt0g2W
      case(124)
         factor=-(nc**2-1d0)/nc**5*facVV    ! Qb ub subtraction       Bt0g2W
      case(125)
         factor=-(nc**2-1d0)/nc**6*facVV    ! d u subtraction         Bt0g2W
      case(126)
         factor=-(nc**2-1d0)/nc**6*facVV    ! db ub subtraction       Bt0g2W
      case(127)
         factor=-(nc**2-1d0)/nc**4*nup*facVV   ! g g subtraction         Bt0g2W
      case(128)
         factor=-(nc**2-1d0)/nc**4*facVV    ! g d subtraction         Bt0g2W
      case(129)
         factor=-(nc**2-1d0)/nc**4*facVV    ! g ub subtraction        Bt0g2W
      case(130)
         factor=-(nc**2-1d0)/nc**5*facVV    ! d Q subtraction         Bt0g2W
      case(131)
         factor=-(nc**2-1d0)/nc**5*facVV    ! d Qb subtraction        Bt0g2W
      case(132)
         factor=-(nc**2-1d0)/nc**4*facVV    ! d g subtraction         Bt0g2W
      case(133)
         factor=-(nc**2-1d0)/nc**5*facVV    ! ub Q subtraction        Bt0g2W
      case(134)
         factor=-(nc**2-1d0)/nc**5*facVV    ! ub Qb subtraction       Bt0g2W
      case(135)
         factor=-(nc**2-1d0)/nc**4*facVV    ! ub g subtraction        Bt0g2W
      case(136)
         factor=-(nc**2-1d0)/nc**6*facVV    ! u d subtraction         Bt0g2W
      case(137)
         factor=-(nc**2-1d0)/nc**6*facVV    ! ub db subtraction       Bt0g2W
      case(138)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! d ub -> lm nub          Bh0g2W
      case(139)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! ub d -> lm nub          Bh0g2W
      case(140)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! Q d subtraction         Bh0g2W
      case(141)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! Q ub subtraction        Bh0g2W
      case(142)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! Qb d subtraction        Bh0g2W
      case(143)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! Qb ub subtraction       Bh0g2W
      case(144)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! d u subtraction         Bh0g2W
      case(145)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! db ub subtraction       Bh0g2W
      case(146)
         factor=(nc**2-1d0)/nc**3*nf*nup*facVV   ! g g subtraction         Bh0g2W
      case(147)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! g d subtraction         Bh0g2W
      case(148)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! g ub subtraction        Bh0g2W
      case(149)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! d Q subtraction         Bh0g2W
      case(150)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! d Qb subtraction        Bh0g2W
      case(151)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! d g subtraction         Bh0g2W
      case(152)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! ub Q subtraction        Bh0g2W
      case(153)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! ub Qb subtraction       Bh0g2W
      case(154)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! ub g subtraction        Bh0g2W
      case(155)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! u d subtraction         Bh0g2W
      case(156)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! ub db subtraction       Bh0g2W
      end select
      factor=relfactor*factor

      return
      end
