      subroutine getqcdnormWp(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      real(8) :: fac_ckm
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtWp(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVWp
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourWp(current_chan)
         do isub = 1, nflavourWp(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_Wp(current_chan, isub, ipass_sub, flav_block, fac_ckm)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           partons_sub = fac_ckm*partons_sub
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=Wp "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alpha_param()/stw)**2*nc
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! u db -> nu lp           B0g0W
      case(2)
         factor=facB                        ! db u -> nu lp           B0g0W

c -- real

      case(3)
         factor=(nc**2-1d0)/nc**2*facR      ! u g -> d nu lp          B1g0W
      case(4)
         factor=(nc**2-1d0)/nc**2*facR      ! u db -> g nu lp         B1g0W
      case(5)
         factor=(nc**2-1d0)/nc**2*facR      ! g u -> d nu lp          B1g0W
      case(6)
         factor=(nc**2-1d0)/nc**2*facR      ! db u -> g nu lp         B1g0W
      case(7)
         factor=(nc**2-1d0)/nc**2*facR      ! g db -> ub nu lp        B1g0W
      case(8)
         factor=(nc**2-1d0)/nc**2*facR      ! db g -> ub nu lp        B1g0W

c -- virtual

      case(9)
         factor=(nc**2-1d0)/nc**2*facV      ! u db -> nu lp           B0g1W
      case(10)
         factor=(nc**2-1d0)/nc**2*facV      ! db u -> nu lp           B0g1W
      case(11)
         factor=(nc**2-1d0)/nc**2*facV      ! g u subtraction         B0g1W
      case(12)
         factor=(nc**2-1d0)/nc**2*facV      ! g db subtraction        B0g1W
      case(13)
         factor=(nc**2-1d0)/nc**2*facV      ! u g subtraction         B0g1W
      case(14)
         factor=(nc**2-1d0)/nc**2*facV      ! db g subtraction        B0g1W

c -- double real

      case(15)
         factor=(nc**2-1d0)/nc**2*facRR     ! u g -> g d nu lp        B2g0W
      case(16)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! u db -> g g nu lp       B2g0W
      case(17)
         factor=(nc**2-1d0)/nc**2*facRR     ! g u -> g d nu lp        B2g0W
      case(18)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! db u -> g g nu lp       B2g0W
      case(19)
         factor=(nc**2-1d0)/nc**2*nup*facRR   ! g g -> ub d nu lp       B2g0W
      case(20)
         factor=(nc**2-1d0)/nc**2*facRR     ! g db -> ub g nu lp      B2g0W
      case(21)
         factor=(nc**2-1d0)/nc**2*facRR     ! db g -> ub g nu lp      B2g0W
      case(22)
         factor=-(nc**2-1d0)/nc**4*facRR    ! u gt -> gt d nu lp      Bt2g0W
      case(23)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u db -> gt gt nu lp     Bt2g0W
      case(24)
         factor=-(nc**2-1d0)/nc**4*facRR    ! gt u -> gt d nu lp      Bt2g0W
      case(25)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db u -> gt gt nu lp     Bt2g0W
      case(26)
         factor=-(nc**2-1d0)/nc**4*nup*facRR   ! gt gt -> ub d nu lp     Bt2g0W
      case(27)
         factor=-(nc**2-1d0)/nc**4*facRR    ! gt db -> ub gt nu lp     Bt2g0W
      case(28)
         factor=-(nc**2-1d0)/nc**4*facRR    ! db gt -> ub gt nu lp     Bt2g0W
      case(29)
         factor=(nc**2-1d0)/nc**3*facRR     ! u Qb -> Qb d nu lp      C0g0W
      case(30)
         factor=(nc**2-1d0)/nc**3*facRR     ! u Q -> Q d nu lp        C0g0W
      case(31)
         factor=(nc**2-1d0)/nc**3*nf*facRR   ! u db -> Q Qb nu lp      C0g0W
      case(32)
         factor=(nc**2-1d0)/nc**3*facRR     ! Qb u -> Qb d nu lp      C0g0W
      case(33)
         factor=(nc**2-1d0)/nc**3*facRR     ! Q u -> Q d nu lp        C0g0W
      case(34)
         factor=(nc**2-1d0)/nc**3*nf*facRR   ! db u -> Q Qb nu lp      C0g0W
      case(35)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! Qb Q -> ub d nu lp      C0g0W
      case(36)
         factor=(nc**2-1d0)/nc**3*facRR     ! Qb db -> ub Qb nu lp     C0g0W
      case(37)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! Q Qb -> ub d nu lp      C0g0W
      case(38)
         factor=(nc**2-1d0)/nc**3*facRR     ! db Qb -> ub Qb nu lp     C0g0W
      case(39)
         factor=(nc**2-1d0)/nc**3*facRR     ! Q db -> ub Q nu lp      C0g0W
      case(40)
         factor=(nc**2-1d0)/nc**3*facRR     ! db Q -> ub Q nu lp      C0g0W
      case(41)
         factor=-(nc**2-1d0)/nc**4*facRR    ! u ub -> ub d nu lp      D0g0Wa
      case(42)
         factor=-(nc**2-1d0)/nc**4*facRR    ! u u -> u d nu lp        D0g0Wa
      case(43)
         factor=-(nc**2-1d0)/nc**4*facRR    ! u db -> u ub nu lp      D0g0Wa
      case(44)
         factor=-(nc**2-1d0)/nc**4*facRR    ! ub u -> ub d nu lp      D0g0Wa
      case(45)
         factor=-(nc**2-1d0)/nc**4*facRR    ! db u -> u ub nu lp      D0g0Wa
      case(46)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub db -> ub ub nu lp     D0g0Wa
      case(47)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db ub -> ub ub nu lp     D0g0Wa
      case(48)
         factor=-(nc**2-1d0)/nc**4*facRR    ! u db -> db d nu lp      D0g0Wb
      case(49)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u d -> d d nu lp        D0g0Wb
      case(50)
         factor=-(nc**2-1d0)/nc**4*facRR    ! db u -> db d nu lp      D0g0Wb
      case(51)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d u -> d d nu lp        D0g0Wb
      case(52)
         factor=-(nc**2-1d0)/nc**4*facRR    ! db d -> ub d nu lp      D0g0Wb
      case(53)
         factor=-(nc**2-1d0)/nc**4*facRR    ! db db -> ub db nu lp     D0g0Wb
      case(54)
         factor=-(nc**2-1d0)/nc**4*facRR    ! d db -> ub d nu lp      D0g0Wb

c -- real virtual

      case(55)
         factor=(nc**2-1d0)/nc**2*facRV     ! u g -> d nu lp          B1g1W
      case(56)
         factor=(nc**2-1d0)/nc**2*facRV     ! u db -> g nu lp         B1g1W
      case(57)
         factor=(nc**2-1d0)/nc**2*facRV     ! g u -> d nu lp          B1g1W
      case(58)
         factor=(nc**2-1d0)/nc**2*facRV     ! db u -> g nu lp         B1g1W
      case(59)
         factor=(nc**2-1d0)/nc**2*facRV     ! g db -> ub nu lp        B1g1W
      case(60)
         factor=(nc**2-1d0)/nc**2*facRV     ! db g -> ub nu lp        B1g1W
      case(61)
         factor=(nc**2-1d0)/nc**3*facRV     ! Q u subtraction         B1g1W
      case(62)
         factor=(nc**2-1d0)/nc**3*facRV     ! Q db subtraction        B1g1W
      case(63)
         factor=(nc**2-1d0)/nc**3*facRV     ! Qb u subtraction        B1g1W
      case(64)
         factor=(nc**2-1d0)/nc**3*facRV     ! Qb db subtraction       B1g1W
      case(65)
         factor=(nc**2-1d0)/nc**2*nup*facRV   ! g g subtraction         B1g1W
      case(66)
         factor=(nc**2-1d0)/nc**3*facRV     ! u Q subtraction         B1g1W
      case(67)
         factor=(nc**2-1d0)/nc**3*facRV     ! u Qb subtraction        B1g1W
      case(68)
         factor=(nc**2-1d0)/nc**3*facRV     ! db Q subtraction        B1g1W
      case(69)
         factor=(nc**2-1d0)/nc**3*facRV     ! db Qb subtraction       B1g1W
      case(70)
         factor=-(nc**2-1d0)/nc**4*facRV    ! u g -> d nu lp          Bt1g1W
      case(71)
         factor=-(nc**2-1d0)/nc**4*facRV    ! u db -> g nu lp         Bt1g1W
      case(72)
         factor=-(nc**2-1d0)/nc**4*facRV    ! g u -> d nu lp          Bt1g1W
      case(73)
         factor=-(nc**2-1d0)/nc**4*facRV    ! db u -> g nu lp         Bt1g1W
      case(74)
         factor=-(nc**2-1d0)/nc**4*facRV    ! g db -> ub nu lp        Bt1g1W
      case(75)
         factor=-(nc**2-1d0)/nc**4*facRV    ! db g -> ub nu lp        Bt1g1W
      case(76)
         factor=-(nc**2-1d0)/nc**5*facRV    ! Q u subtraction         Bt1g1W
      case(77)
         factor=-(nc**2-1d0)/nc**5*facRV    ! Q db subtraction        Bt1g1W
      case(78)
         factor=-(nc**2-1d0)/nc**5*facRV    ! Qb u subtraction        Bt1g1W
      case(79)
         factor=-(nc**2-1d0)/nc**5*facRV    ! Qb db subtraction       Bt1g1W
      case(80)
         factor=-(nc**2-1d0)/nc**4*nup*facRV   ! g g subtraction         Bt1g1W
      case(81)
         factor=-(nc**2-1d0)/nc**5*facRV    ! u Q subtraction         Bt1g1W
      case(82)
         factor=-(nc**2-1d0)/nc**5*facRV    ! u Qb subtraction        Bt1g1W
      case(83)
         factor=-(nc**2-1d0)/nc**5*facRV    ! db Q subtraction        Bt1g1W
      case(84)
         factor=-(nc**2-1d0)/nc**5*facRV    ! db Qb subtraction       Bt1g1W
      case(85)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! u g -> d nu lp          Bh1g1W
      case(86)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! u db -> g nu lp         Bh1g1W
      case(87)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! g u -> d nu lp          Bh1g1W
      case(88)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! db u -> g nu lp         Bh1g1W
      case(89)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! g db -> ub nu lp        Bh1g1W
      case(90)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! db g -> ub nu lp        Bh1g1W
      case(91)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! Q u subtraction         Bh1g1W
      case(92)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! Q db subtraction        Bh1g1W
      case(93)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! Qb u subtraction        Bh1g1W
      case(94)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! Qb db subtraction       Bh1g1W
      case(95)
         factor=(nc**2-1d0)/nc**3*nf*nup*facRV   ! g g subtraction         Bh1g1W
      case(96)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! u Q subtraction         Bh1g1W
      case(97)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! u Qb subtraction        Bh1g1W
      case(98)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! db Q subtraction        Bh1g1W
      case(99)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! db Qb subtraction       Bh1g1W

c -- double virtual

      case(100)
         factor=(nc**2-1d0)/nc**2*facVV     ! u db -> nu lp           B0g2Wp
      case(101)
         factor=(nc**2-1d0)/nc**2*facVV     ! db u -> nu lp           B0g2Wp
      case(102)
         factor=(nc**2-1d0)/nc**3*facVV     ! Q u subtraction         B0g2Wp
      case(103)
         factor=(nc**2-1d0)/nc**3*facVV     ! Q db subtraction        B0g2Wp
      case(104)
         factor=(nc**2-1d0)/nc**3*facVV     ! Qb u subtraction        B0g2Wp
      case(105)
         factor=(nc**2-1d0)/nc**3*facVV     ! Qb db subtraction       B0g2Wp
      case(106)
         factor=(nc**2-1d0)/nc**4*facVV     ! d u subtraction         B0g2Wp
      case(107)
         factor=(nc**2-1d0)/nc**4*facVV     ! db ub subtraction       B0g2Wp
      case(108)
         factor=(nc**2-1d0)/nc**2*nup*facVV   ! g g subtraction         B0g2Wp
      case(109)
         factor=(nc**2-1d0)/nc**2*facVV     ! g u subtraction         B0g2Wp
      case(110)
         factor=(nc**2-1d0)/nc**2*facVV     ! g db subtraction        B0g2Wp
      case(111)
         factor=(nc**2-1d0)/nc**3*facVV     ! u Q subtraction         B0g2Wp
      case(112)
         factor=(nc**2-1d0)/nc**3*facVV     ! u Qb subtraction        B0g2Wp
      case(113)
         factor=(nc**2-1d0)/nc**2*facVV     ! u g subtraction         B0g2Wp
      case(114)
         factor=(nc**2-1d0)/nc**3*facVV     ! db Q subtraction        B0g2Wp
      case(115)
         factor=(nc**2-1d0)/nc**3*facVV     ! db Qb subtraction       B0g2Wp
      case(116)
         factor=(nc**2-1d0)/nc**2*facVV     ! db g subtraction        B0g2Wp
      case(117)
         factor=(nc**2-1d0)/nc**4*facVV     ! u d subtraction         B0g2Wp
      case(118)
         factor=(nc**2-1d0)/nc**4*facVV     ! ub db subtraction       B0g2Wp
      case(119)
         factor=-(nc**2-1d0)/nc**4*facVV    ! u db -> nu lp           Bt0g2W
      case(120)
         factor=-(nc**2-1d0)/nc**4*facVV    ! db u -> nu lp           Bt0g2W
      case(121)
         factor=-(nc**2-1d0)/nc**5*facVV    ! Q u subtraction         Bt0g2W
      case(122)
         factor=-(nc**2-1d0)/nc**5*facVV    ! Q db subtraction        Bt0g2W
      case(123)
         factor=-(nc**2-1d0)/nc**5*facVV    ! Qb u subtraction        Bt0g2W
      case(124)
         factor=-(nc**2-1d0)/nc**5*facVV    ! Qb db subtraction       Bt0g2W
      case(125)
         factor=-(nc**2-1d0)/nc**6*facVV    ! d u subtraction         Bt0g2W
      case(126)
         factor=-(nc**2-1d0)/nc**6*facVV    ! db ub subtraction       Bt0g2W
      case(127)
         factor=-(nc**2-1d0)/nc**4*nup*facVV   ! g g subtraction         Bt0g2W
      case(128)
         factor=-(nc**2-1d0)/nc**4*facVV    ! g u subtraction         Bt0g2W
      case(129)
         factor=-(nc**2-1d0)/nc**4*facVV    ! g db subtraction        Bt0g2W
      case(130)
         factor=-(nc**2-1d0)/nc**5*facVV    ! u Q subtraction         Bt0g2W
      case(131)
         factor=-(nc**2-1d0)/nc**5*facVV    ! u Qb subtraction        Bt0g2W
      case(132)
         factor=-(nc**2-1d0)/nc**4*facVV    ! u g subtraction         Bt0g2W
      case(133)
         factor=-(nc**2-1d0)/nc**5*facVV    ! db Q subtraction        Bt0g2W
      case(134)
         factor=-(nc**2-1d0)/nc**5*facVV    ! db Qb subtraction       Bt0g2W
      case(135)
         factor=-(nc**2-1d0)/nc**4*facVV    ! db g subtraction        Bt0g2W
      case(136)
         factor=-(nc**2-1d0)/nc**6*facVV    ! u d subtraction         Bt0g2W
      case(137)
         factor=-(nc**2-1d0)/nc**6*facVV    ! ub db subtraction       Bt0g2W
      case(138)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! u db -> nu lp           Bh0g2W
      case(139)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! db u -> nu lp           Bh0g2W
      case(140)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! Q u subtraction         Bh0g2W
      case(141)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! Q db subtraction        Bh0g2W
      case(142)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! Qb u subtraction        Bh0g2W
      case(143)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! Qb db subtraction       Bh0g2W
      case(144)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! d u subtraction         Bh0g2W
      case(145)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! db ub subtraction       Bh0g2W
      case(146)
         factor=(nc**2-1d0)/nc**3*nf*nup*facVV   ! g g subtraction         Bh0g2W
      case(147)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! g u subtraction         Bh0g2W
      case(148)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! g db subtraction        Bh0g2W
      case(149)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! u Q subtraction         Bh0g2W
      case(150)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! u Qb subtraction        Bh0g2W
      case(151)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! u g subtraction         Bh0g2W
      case(152)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! db Q subtraction        Bh0g2W
      case(153)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! db Qb subtraction       Bh0g2W
      case(154)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! db g subtraction        Bh0g2W
      case(155)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! u d subtraction         Bh0g2W
      case(156)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! ub db subtraction       Bh0g2W
      end select
      factor=relfactor*factor

      return
      end
