      subroutine selectchannelWm()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*amzW/stw)**2*nc
      n_alphas_proc = 0
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelWm: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelWm: already allocated'  
        stop
      end if

      ntot_chan = 156

      allocate(qactive_chan(1:156))
      allocate(contrib_chan(1:156))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! d ub to lm nub        B0g0W(1,2,3,4)        
c      qactive_chan(2)  = .true.   ! ub d to lm nub        B0g0W(2,1,3,4)        

      do i=1,2
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(3)  = .true.   ! d g to u lm nub       B1g0W(1,2,3,4,5)      qgB1g0WSNLO(1,2,3,4,5)
c      qactive_chan(4)  = .true.   ! d ub to g lm nub      B1g0W(1,3,2,4,5)      qqbB1g0WSNLO(1,3,2,4,5)
c      qactive_chan(5)  = .true.   ! g d to u lm nub       B1g0W(2,1,3,4,5)      gqB1g0WSNLO(2,1,3,4,5)
c      qactive_chan(6)  = .true.   ! ub d to g lm nub      B1g0W(2,3,1,4,5)      qbqB1g0WSNLO(2,3,1,4,5)
c      qactive_chan(7)  = .true.   ! g ub to db lm nub     B1g0W(3,1,2,4,5)      gqbB1g0WSNLO(3,1,2,4,5)
c      qactive_chan(8)  = .true.   ! ub g to db lm nub     B1g0W(3,2,1,4,5)      qbgB1g0WSNLO(3,2,1,4,5)

      do i=3,8
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(9)  = .true.   ! d ub to lm nub        B0g1W(1,2,3,4)        qqbB0g1WTNLO(1,2,3,4)
c      qactive_chan(10) = .true.   ! ub d to lm nub        B0g1W(2,1,3,4)        qbqB0g1WTNLO(2,1,3,4)
c      qactive_chan(11) = .true.   ! g d subtraction                             gqB0g1WTNLO(1,2,3,4)
c      qactive_chan(12) = .true.   ! g ub subtraction                            gqbB0g1WTNLO(1,2,3,4)
c      qactive_chan(13) = .true.   ! d g subtraction                             qgB0g1WTNLO(1,2,3,4)
c      qactive_chan(14) = .true.   ! ub g subtraction                            qbgB0g1WTNLO(1,2,3,4)

      do i=9,14
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(15) = .true.   ! d g to g u lm nub     B2g0W(1,2,3,4,5,6)    qgB2g0WS(1,2,3,4,5,6)
c      qactive_chan(16) = .true.   ! d ub to g g lm nub    B2g0W(1,3,4,2,5,6)    qqbB2g0WS(1,3,4,2,5,6)
c      qactive_chan(17) = .true.   ! g d to g u lm nub     B2g0W(2,1,3,4,5,6)    gqB2g0WS(2,1,3,4,5,6)
c      qactive_chan(18) = .true.   ! ub d to g g lm nub    B2g0W(2,3,4,1,5,6)    qbqB2g0WS(2,3,4,1,5,6)
c      qactive_chan(19) = .true.   ! g g to db u lm nub    B2g0W(3,1,2,4,5,6)    ggB2g0WS(3,1,2,4,5,6)
c      qactive_chan(20) = .true.   ! g ub to db g lm nub   B2g0W(3,1,4,2,5,6)    gqbB2g0WS(3,1,4,2,5,6)
c      qactive_chan(21) = .true.   ! ub g to db g lm nub   B2g0W(3,2,4,1,5,6)    qbgB2g0WS(3,2,4,1,5,6)
c      qactive_chan(22) = .true.   ! d gt to gt u lm nub   Bt2g0W(1,2,3,4,5,6)   qgtBt2g0WS(1,2,3,4,5,6)
c      qactive_chan(23) = .true.   ! d ub to gt gt lm nub   Bt2g0W(1,3,4,2,5,6)   qqbBt2g0WS(1,3,4,2,5,6)
c      qactive_chan(24) = .true.   ! gt d to gt u lm nub   Bt2g0W(2,1,3,4,5,6)   gtqBt2g0WS(2,1,3,4,5,6)
c      qactive_chan(25) = .true.   ! ub d to gt gt lm nub   Bt2g0W(2,3,4,1,5,6)   qbqBt2g0WS(2,3,4,1,5,6)
c      qactive_chan(26) = .true.   ! gt gt to db u lm nub   Bt2g0W(3,1,2,4,5,6)   gtgtBt2g0WS(3,1,2,4,5,6)
c      qactive_chan(27) = .true.   ! gt ub to db gt lm nub   Bt2g0W(3,1,4,2,5,6)   gtqbBt2g0WS(3,1,4,2,5,6)
c      qactive_chan(28) = .true.   ! ub gt to db gt lm nub   Bt2g0W(3,2,4,1,5,6)   qbgtBt2g0WS(3,2,4,1,5,6)
c      qactive_chan(29) = .true.   ! d Qb to Qb u lm nub   C0g0W(1,2,3,4,5,6)    qqpbC0g0WS(1,2,3,4,5,6)
c      qactive_chan(30) = .true.   ! d Q to Q u lm nub     C0g0W(1,3,2,4,5,6)    qqpC0g0WS(1,3,2,4,5,6)
c      qactive_chan(31) = .true.   ! d ub to Q Qb lm nub   C0g0W(1,3,4,2,5,6)    qqbC0g0WS(1,3,4,2,5,6)
c      qactive_chan(32) = .true.   ! Qb d to Qb u lm nub   C0g0W(2,1,3,4,5,6)    qpbqC0g0WS(2,1,3,4,5,6)
c      qactive_chan(33) = .true.   ! Q d to Q u lm nub     C0g0W(2,3,1,4,5,6)    qpqC0g0WS(2,3,1,4,5,6)
c      qactive_chan(34) = .true.   ! ub d to Q Qb lm nub   C0g0W(2,3,4,1,5,6)    qbqC0g0WS(2,3,4,1,5,6)
c      qactive_chan(35) = .true.   ! Qb Q to db u lm nub   C0g0W(3,1,2,4,5,6)    qpbqpC0g0WS(3,1,2,4,5,6)
c      qactive_chan(36) = .true.   ! Qb ub to db Qb lm nub   C0g0W(3,1,4,2,5,6)    qpbqbC0g0WS(3,1,4,2,5,6)
c      qactive_chan(37) = .true.   ! Q Qb to db u lm nub   C0g0W(3,2,1,4,5,6)    qpqpbC0g0WS(3,2,1,4,5,6)
c      qactive_chan(38) = .true.   ! ub Qb to db Qb lm nub   C0g0W(3,2,4,1,5,6)    qbqpbC0g0WS(3,2,4,1,5,6)
c      qactive_chan(39) = .true.   ! Q ub to db Q lm nub   C0g0W(3,4,1,2,5,6)    qpqbC0g0WS(3,4,1,2,5,6)
c      qactive_chan(40) = .true.   ! ub Q to db Q lm nub   C0g0W(3,4,2,1,5,6)    qbqpC0g0WS(3,4,2,1,5,6)
c      qactive_chan(41) = .true.   ! d db to db u lm nub   D0g0Wa(1,2,3,4,5,6)   qpqpbD0g0WaS(1,2,3,4,5,6)
c      qactive_chan(42) = .true.   ! d d to d u lm nub     D0g0Wa(1,3,2,4,5,6)   qpqpD0g0WaS(1,3,2,4,5,6)
c      qactive_chan(43) = .true.   ! d ub to d db lm nub   D0g0Wa(1,3,4,2,5,6)   qpqbD0g0WaS(1,3,4,2,5,6)
c      qactive_chan(44) = .true.   ! db d to db u lm nub   D0g0Wa(2,1,3,4,5,6)   qpbqpD0g0WaS(2,1,3,4,5,6)
c      qactive_chan(45) = .true.   ! ub d to d db lm nub   D0g0Wa(2,3,4,1,5,6)   qbqpD0g0WaS(2,3,4,1,5,6)
c      qactive_chan(46) = .true.   ! db ub to db db lm nub   D0g0Wa(3,1,4,2,5,6)   qpbqbD0g0WaS(3,1,4,2,5,6)
c      qactive_chan(47) = .true.   ! ub db to db db lm nub   D0g0Wa(3,2,4,1,5,6)   qbqpbD0g0WaS(3,2,4,1,5,6)
c      qactive_chan(48) = .true.   ! d ub to ub u lm nub   D0g0Wb(1,2,3,4,5,6)   qpqbD0g0WbS(1,2,3,4,5,6)
c      qactive_chan(49) = .true.   ! d u to u u lm nub     D0g0Wb(1,3,2,4,5,6)   qpqD0g0WbS(1,3,2,4,5,6)
c      qactive_chan(50) = .true.   ! ub d to ub u lm nub   D0g0Wb(2,1,3,4,5,6)   qbqpD0g0WbS(2,1,3,4,5,6)
c      qactive_chan(51) = .true.   ! u d to u u lm nub     D0g0Wb(2,3,1,4,5,6)   qqpD0g0WbS(2,3,1,4,5,6)
c      qactive_chan(52) = .true.   ! ub u to db u lm nub   D0g0Wb(3,1,2,4,5,6)   qbqD0g0WbS(3,1,2,4,5,6)
c      qactive_chan(53) = .true.   ! ub ub to db ub lm nub   D0g0Wb(3,1,4,2,5,6)   qbqbD0g0WbS(3,1,4,2,5,6)
c      qactive_chan(54) = .true.   ! u ub to db u lm nub   D0g0Wb(3,2,1,4,5,6)   qqbD0g0WbS(3,2,1,4,5,6)

      do i=15,54
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(55) = .true.   ! d g to u lm nub       B1g1W(1,2,3,4,5)      qgB1g1WT(1,2,3,4,5)
c      qactive_chan(56) = .true.   ! d ub to g lm nub      B1g1W(1,3,2,4,5)      qqbB1g1WT(1,3,2,4,5)
c      qactive_chan(57) = .true.   ! g d to u lm nub       B1g1W(2,1,3,4,5)      gqB1g1WT(2,1,3,4,5)
c      qactive_chan(58) = .true.   ! ub d to g lm nub      B1g1W(2,3,1,4,5)      qbqB1g1WT(2,3,1,4,5)
c      qactive_chan(59) = .true.   ! g ub to db lm nub     B1g1W(3,1,2,4,5)      gqbB1g1WT(3,1,2,4,5)
c      qactive_chan(60) = .true.   ! ub g to db lm nub     B1g1W(3,2,1,4,5)      qbgB1g1WT(3,2,1,4,5)
c      qactive_chan(61) = .true.   ! Q d subtraction                             qpqB1g1WT(1,2,3,4,5)
c      qactive_chan(62) = .true.   ! Q ub subtraction                            qpqbB1g1WT(1,2,3,4,5)
c      qactive_chan(63) = .true.   ! Qb d subtraction                            qpbqB1g1WT(1,2,3,4,5)
c      qactive_chan(64) = .true.   ! Qb ub subtraction                           qpbqbB1g1WT(1,2,3,4,5)
c      qactive_chan(65) = .true.   ! g g subtraction                             ggB1g1WT(1,2,3,4,5)
c      qactive_chan(66) = .true.   ! d Q subtraction                             qqpB1g1WT(1,2,3,4,5)
c      qactive_chan(67) = .true.   ! d Qb subtraction                            qqpbB1g1WT(1,2,3,4,5)
c      qactive_chan(68) = .true.   ! ub Q subtraction                            qbqpB1g1WT(1,2,3,4,5)
c      qactive_chan(69) = .true.   ! ub Qb subtraction                           qbqpbB1g1WT(1,2,3,4,5)
c      qactive_chan(70) = .true.   ! d g to u lm nub       Bt1g1W(1,2,3,4,5)     qgBt1g1WT(1,2,3,4,5)
c      qactive_chan(71) = .true.   ! d ub to g lm nub      Bt1g1W(1,3,2,4,5)     qqbBt1g1WT(1,3,2,4,5)
c      qactive_chan(72) = .true.   ! g d to u lm nub       Bt1g1W(2,1,3,4,5)     gqBt1g1WT(2,1,3,4,5)
c      qactive_chan(73) = .true.   ! ub d to g lm nub      Bt1g1W(2,3,1,4,5)     qbqBt1g1WT(2,3,1,4,5)
c      qactive_chan(74) = .true.   ! g ub to db lm nub     Bt1g1W(3,1,2,4,5)     gqbBt1g1WT(3,1,2,4,5)
c      qactive_chan(75) = .true.   ! ub g to db lm nub     Bt1g1W(3,2,1,4,5)     qbgBt1g1WT(3,2,1,4,5)
c      qactive_chan(76) = .true.   ! Q d subtraction                             qpqBt1g1WT(1,2,3,4,5)
c      qactive_chan(77) = .true.   ! Q ub subtraction                            qpqbBt1g1WT(1,2,3,4,5)
c      qactive_chan(78) = .true.   ! Qb d subtraction                            qpbqBt1g1WT(1,2,3,4,5)
c      qactive_chan(79) = .true.   ! Qb ub subtraction                           qpbqbBt1g1WT(1,2,3,4,5)
c      qactive_chan(80) = .true.   ! g g subtraction                             ggBt1g1WT(1,2,3,4,5)
c      qactive_chan(81) = .true.   ! d Q subtraction                             qqpBt1g1WT(1,2,3,4,5)
c      qactive_chan(82) = .true.   ! d Qb subtraction                            qqpbBt1g1WT(1,2,3,4,5)
c      qactive_chan(83) = .true.   ! ub Q subtraction                            qbqpBt1g1WT(1,2,3,4,5)
c      qactive_chan(84) = .true.   ! ub Qb subtraction                           qbqpbBt1g1WT(1,2,3,4,5)
c      qactive_chan(85) = .true.   ! d g to u lm nub       Bh1g1W(1,2,3,4,5)     qgBh1g1WT(1,2,3,4,5)
c      qactive_chan(86) = .true.   ! d ub to g lm nub      Bh1g1W(1,3,2,4,5)     qqbBh1g1WT(1,3,2,4,5)
c      qactive_chan(87) = .true.   ! g d to u lm nub       Bh1g1W(2,1,3,4,5)     gqBh1g1WT(2,1,3,4,5)
c      qactive_chan(88) = .true.   ! ub d to g lm nub      Bh1g1W(2,3,1,4,5)     qbqBh1g1WT(2,3,1,4,5)
c      qactive_chan(89) = .true.   ! g ub to db lm nub     Bh1g1W(3,1,2,4,5)     gqbBh1g1WT(3,1,2,4,5)
c      qactive_chan(90) = .true.   ! ub g to db lm nub     Bh1g1W(3,2,1,4,5)     qbgBh1g1WT(3,2,1,4,5)
c      qactive_chan(91) = .true.   ! Q d subtraction                             qpqBh1g1WT(1,2,3,4,5)
c      qactive_chan(92) = .true.   ! Q ub subtraction                            qpqbBh1g1WT(1,2,3,4,5)
c      qactive_chan(93) = .true.   ! Qb d subtraction                            qpbqBh1g1WT(1,2,3,4,5)
c      qactive_chan(94) = .true.   ! Qb ub subtraction                           qpbqbBh1g1WT(1,2,3,4,5)
c      qactive_chan(95) = .true.   ! g g subtraction                             ggBh1g1WT(1,2,3,4,5)
c      qactive_chan(96) = .true.   ! d Q subtraction                             qqpBh1g1WT(1,2,3,4,5)
c      qactive_chan(97) = .true.   ! d Qb subtraction                            qqpbBh1g1WT(1,2,3,4,5)
c      qactive_chan(98) = .true.   ! ub Q subtraction                            qbqpBh1g1WT(1,2,3,4,5)
c      qactive_chan(99) = .true.   ! ub Qb subtraction                           qbqpbBh1g1WT(1,2,3,4,5)

      do i=55,99
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(100)= .true.   ! d ub to lm nub        B0g2Wm(1,2,3,4)       qqbB0g2WmU(1,2,3,4)
c      qactive_chan(101)= .true.   ! ub d to lm nub        B0g2Wm(2,1,3,4)       qbqB0g2WmU(2,1,3,4)
c      qactive_chan(102)= .true.   ! Q d subtraction                             qpqB0g2WmU(1,2,3,4)
c      qactive_chan(103)= .true.   ! Q ub subtraction                            qpqbB0g2WmU(1,2,3,4)
c      qactive_chan(104)= .true.   ! Qb d subtraction                            qpbqB0g2WmU(1,2,3,4)
c      qactive_chan(105)= .true.   ! Qb ub subtraction                           qpbqbB0g2WmU(1,2,3,4)
c      qactive_chan(106)= .true.   ! d u subtraction                             duB0g2WmU(1,2,3,4)
c      qactive_chan(107)= .true.   ! db ub subtraction                           dbubB0g2WmU(1,2,3,4)
c      qactive_chan(108)= .true.   ! g g subtraction                             ggB0g2WmU(1,2,3,4)
c      qactive_chan(109)= .true.   ! g d subtraction                             gqB0g2WmU(1,2,3,4)
c      qactive_chan(110)= .true.   ! g ub subtraction                            gqbB0g2WmU(1,2,3,4)
c      qactive_chan(111)= .true.   ! d Q subtraction                             qqpB0g2WmU(1,2,3,4)
c      qactive_chan(112)= .true.   ! d Qb subtraction                            qqpbB0g2WmU(1,2,3,4)
c      qactive_chan(113)= .true.   ! d g subtraction                             qgB0g2WmU(1,2,3,4)
c      qactive_chan(114)= .true.   ! ub Q subtraction                            qbqpB0g2WmU(1,2,3,4)
c      qactive_chan(115)= .true.   ! ub Qb subtraction                           qbqpbB0g2WmU(1,2,3,4)
c      qactive_chan(116)= .true.   ! ub g subtraction                            qbgB0g2WmU(1,2,3,4)
c      qactive_chan(117)= .true.   ! u d subtraction                             udB0g2WmU(1,2,3,4)
c      qactive_chan(118)= .true.   ! ub db subtraction                           ubdbB0g2WmU(1,2,3,4)
c      qactive_chan(119)= .true.   ! d ub to lm nub        Bt0g2W(1,2,3,4)       qqbBt0g2WU(1,2,3,4)
c      qactive_chan(120)= .true.   ! ub d to lm nub        Bt0g2W(2,1,3,4)       qbqBt0g2WU(2,1,3,4)
c      qactive_chan(121)= .true.   ! Q d subtraction                             qpqBt0g2WU(1,2,3,4)
c      qactive_chan(122)= .true.   ! Q ub subtraction                            qpqbBt0g2WU(1,2,3,4)
c      qactive_chan(123)= .true.   ! Qb d subtraction                            qpbqBt0g2WU(1,2,3,4)
c      qactive_chan(124)= .true.   ! Qb ub subtraction                           qpbqbBt0g2WU(1,2,3,4)
c      qactive_chan(125)= .true.   ! d u subtraction                             duBt0g2WU(1,2,3,4)
c      qactive_chan(126)= .true.   ! db ub subtraction                           dbubBt0g2WU(1,2,3,4)
c      qactive_chan(127)= .true.   ! g g subtraction                             ggBt0g2WU(1,2,3,4)
c      qactive_chan(128)= .true.   ! g d subtraction                             gqBt0g2WU(1,2,3,4)
c      qactive_chan(129)= .true.   ! g ub subtraction                            gqbBt0g2WU(1,2,3,4)
c      qactive_chan(130)= .true.   ! d Q subtraction                             qqpBt0g2WU(1,2,3,4)
c      qactive_chan(131)= .true.   ! d Qb subtraction                            qqpbBt0g2WU(1,2,3,4)
c      qactive_chan(132)= .true.   ! d g subtraction                             qgBt0g2WU(1,2,3,4)
c      qactive_chan(133)= .true.   ! ub Q subtraction                            qbqpBt0g2WU(1,2,3,4)
c      qactive_chan(134)= .true.   ! ub Qb subtraction                           qbqpbBt0g2WU(1,2,3,4)
c      qactive_chan(135)= .true.   ! ub g subtraction                            qbgBt0g2WU(1,2,3,4)
c      qactive_chan(136)= .true.   ! u d subtraction                             udBt0g2WU(1,2,3,4)
c      qactive_chan(137)= .true.   ! ub db subtraction                           ubdbBt0g2WU(1,2,3,4)
c      qactive_chan(138)= .true.   ! d ub to lm nub        Bh0g2W(1,2,3,4)       qqbBh0g2WU(1,2,3,4)
c      qactive_chan(139)= .true.   ! ub d to lm nub        Bh0g2W(2,1,3,4)       qbqBh0g2WU(2,1,3,4)
c      qactive_chan(140)= .true.   ! Q d subtraction                             qpqBh0g2WU(1,2,3,4)
c      qactive_chan(141)= .true.   ! Q ub subtraction                            qpqbBh0g2WU(1,2,3,4)
c      qactive_chan(142)= .true.   ! Qb d subtraction                            qpbqBh0g2WU(1,2,3,4)
c      qactive_chan(143)= .true.   ! Qb ub subtraction                           qpbqbBh0g2WU(1,2,3,4)
c      qactive_chan(144)= .true.   ! d u subtraction                             duBh0g2WU(1,2,3,4)
c      qactive_chan(145)= .true.   ! db ub subtraction                           dbubBh0g2WU(1,2,3,4)
c      qactive_chan(146)= .true.   ! g g subtraction                             ggBh0g2WU(1,2,3,4)
c      qactive_chan(147)= .true.   ! g d subtraction                             gqBh0g2WU(1,2,3,4)
c      qactive_chan(148)= .true.   ! g ub subtraction                            gqbBh0g2WU(1,2,3,4)
c      qactive_chan(149)= .true.   ! d Q subtraction                             qqpBh0g2WU(1,2,3,4)
c      qactive_chan(150)= .true.   ! d Qb subtraction                            qqpbBh0g2WU(1,2,3,4)
c      qactive_chan(151)= .true.   ! d g subtraction                             qgBh0g2WU(1,2,3,4)
c      qactive_chan(152)= .true.   ! ub Q subtraction                            qbqpBh0g2WU(1,2,3,4)
c      qactive_chan(153)= .true.   ! ub Qb subtraction                           qbqpbBh0g2WU(1,2,3,4)
c      qactive_chan(154)= .true.   ! ub g subtraction                            qbgBh0g2WU(1,2,3,4)
c      qactive_chan(155)= .true.   ! u d subtraction                             udBh0g2WU(1,2,3,4)
c      qactive_chan(156)= .true.   ! ub db subtraction                           ubdbBh0g2WU(1,2,3,4)

      do i=100,156
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelWm(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'd ub to lm nub      '
        me_str   = 'B0g0W(1,2,3,4)      '
        sub_str  = ''

      case (2)
        chan_str = 'ub d to lm nub      '
        me_str   = 'B0g0W(2,1,3,4)      '
        sub_str  = ''

      case (3)
        chan_str = 'd g to u lm nub     '
        me_str   = 'B1g0W(1,2,3,4,5)    '
        sub_str  = 'qgB1g0WSNLO(1,2,3,4,5)'

      case (4)
        chan_str = 'd ub to g lm nub    '
        me_str   = 'B1g0W(1,3,2,4,5)    '
        sub_str  = 'qqbB1g0WSNLO(1,3,2,4,5)'

      case (5)
        chan_str = 'g d to u lm nub     '
        me_str   = 'B1g0W(2,1,3,4,5)    '
        sub_str  = 'gqB1g0WSNLO(2,1,3,4,5)'

      case (6)
        chan_str = 'ub d to g lm nub    '
        me_str   = 'B1g0W(2,3,1,4,5)    '
        sub_str  = 'qbqB1g0WSNLO(2,3,1,4,5)'

      case (7)
        chan_str = 'g ub to db lm nub   '
        me_str   = 'B1g0W(3,1,2,4,5)    '
        sub_str  = 'gqbB1g0WSNLO(3,1,2,4,5)'

      case (8)
        chan_str = 'ub g to db lm nub   '
        me_str   = 'B1g0W(3,2,1,4,5)    '
        sub_str  = 'qbgB1g0WSNLO(3,2,1,4,5)'

      case (9)
        chan_str = 'd ub to lm nub      '
        me_str   = 'B0g1W(1,2,3,4)      '
        sub_str  = 'qqbB0g1WTNLO(1,2,3,4)'

      case (10)
        chan_str = 'ub d to lm nub      '
        me_str   = 'B0g1W(2,1,3,4)      '
        sub_str  = 'qbqB0g1WTNLO(2,1,3,4)'

      case (11)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gqB0g1WTNLO(1,2,3,4)'

      case (12)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbB0g1WTNLO(1,2,3,4)'

      case (13)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgB0g1WTNLO(1,2,3,4)'

      case (14)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgB0g1WTNLO(1,2,3,4)'

      case (15)
        chan_str = 'd g to g u lm nub   '
        me_str   = 'B2g0W(1,2,3,4,5,6)  '
        sub_str  = 'qgB2g0WS(1,2,3,4,5,6)'

      case (16)
        chan_str = 'd ub to g g lm nub  '
        me_str   = 'B2g0W(1,3,4,2,5,6)  '
        sub_str  = 'qqbB2g0WS(1,3,4,2,5,6)'

      case (17)
        chan_str = 'g d to g u lm nub   '
        me_str   = 'B2g0W(2,1,3,4,5,6)  '
        sub_str  = 'gqB2g0WS(2,1,3,4,5,6)'

      case (18)
        chan_str = 'ub d to g g lm nub  '
        me_str   = 'B2g0W(2,3,4,1,5,6)  '
        sub_str  = 'qbqB2g0WS(2,3,4,1,5,6)'

      case (19)
        chan_str = 'g g to db u lm nub  '
        me_str   = 'B2g0W(3,1,2,4,5,6)  '
        sub_str  = 'ggB2g0WS(3,1,2,4,5,6)'

      case (20)
        chan_str = 'g ub to db g lm nub '
        me_str   = 'B2g0W(3,1,4,2,5,6)  '
        sub_str  = 'gqbB2g0WS(3,1,4,2,5,6)'

      case (21)
        chan_str = 'ub g to db g lm nub '
        me_str   = 'B2g0W(3,2,4,1,5,6)  '
        sub_str  = 'qbgB2g0WS(3,2,4,1,5,6)'

      case (22)
        chan_str = 'd gt to gt u lm nub '
        me_str   = 'Bt2g0W(1,2,3,4,5,6) '
        sub_str  = 'qgtBt2g0WS(1,2,3,4,5,6)'

      case (23)
        chan_str = 'd ub to gt gt lm nub '
        me_str   = 'Bt2g0W(1,3,4,2,5,6) '
        sub_str  = 'qqbBt2g0WS(1,3,4,2,5,6)'

      case (24)
        chan_str = 'gt d to gt u lm nub '
        me_str   = 'Bt2g0W(2,1,3,4,5,6) '
        sub_str  = 'gtqBt2g0WS(2,1,3,4,5,6)'

      case (25)
        chan_str = 'ub d to gt gt lm nub '
        me_str   = 'Bt2g0W(2,3,4,1,5,6) '
        sub_str  = 'qbqBt2g0WS(2,3,4,1,5,6)'

      case (26)
        chan_str = 'gt gt to db u lm nub '
        me_str   = 'Bt2g0W(3,1,2,4,5,6) '
        sub_str  = 'gtgtBt2g0WS(3,1,2,4,5,6)'

      case (27)
        chan_str = 'gt ub to db gt lm nub '
        me_str   = 'Bt2g0W(3,1,4,2,5,6) '
        sub_str  = 'gtqbBt2g0WS(3,1,4,2,5,6)'

      case (28)
        chan_str = 'ub gt to db gt lm nub '
        me_str   = 'Bt2g0W(3,2,4,1,5,6) '
        sub_str  = 'qbgtBt2g0WS(3,2,4,1,5,6)'

      case (29)
        chan_str = 'd Qb to Qb u lm nub '
        me_str   = 'C0g0W(1,2,3,4,5,6)  '
        sub_str  = 'qqpbC0g0WS(1,2,3,4,5,6)'

      case (30)
        chan_str = 'd Q to Q u lm nub   '
        me_str   = 'C0g0W(1,3,2,4,5,6)  '
        sub_str  = 'qqpC0g0WS(1,3,2,4,5,6)'

      case (31)
        chan_str = 'd ub to Q Qb lm nub '
        me_str   = 'C0g0W(1,3,4,2,5,6)  '
        sub_str  = 'qqbC0g0WS(1,3,4,2,5,6)'

      case (32)
        chan_str = 'Qb d to Qb u lm nub '
        me_str   = 'C0g0W(2,1,3,4,5,6)  '
        sub_str  = 'qpbqC0g0WS(2,1,3,4,5,6)'

      case (33)
        chan_str = 'Q d to Q u lm nub   '
        me_str   = 'C0g0W(2,3,1,4,5,6)  '
        sub_str  = 'qpqC0g0WS(2,3,1,4,5,6)'

      case (34)
        chan_str = 'ub d to Q Qb lm nub '
        me_str   = 'C0g0W(2,3,4,1,5,6)  '
        sub_str  = 'qbqC0g0WS(2,3,4,1,5,6)'

      case (35)
        chan_str = 'Qb Q to db u lm nub '
        me_str   = 'C0g0W(3,1,2,4,5,6)  '
        sub_str  = 'qpbqpC0g0WS(3,1,2,4,5,6)'

      case (36)
        chan_str = 'Qb ub to db Qb lm nub '
        me_str   = 'C0g0W(3,1,4,2,5,6)  '
        sub_str  = 'qpbqbC0g0WS(3,1,4,2,5,6)'

      case (37)
        chan_str = 'Q Qb to db u lm nub '
        me_str   = 'C0g0W(3,2,1,4,5,6)  '
        sub_str  = 'qpqpbC0g0WS(3,2,1,4,5,6)'

      case (38)
        chan_str = 'ub Qb to db Qb lm nub '
        me_str   = 'C0g0W(3,2,4,1,5,6)  '
        sub_str  = 'qbqpbC0g0WS(3,2,4,1,5,6)'

      case (39)
        chan_str = 'Q ub to db Q lm nub '
        me_str   = 'C0g0W(3,4,1,2,5,6)  '
        sub_str  = 'qpqbC0g0WS(3,4,1,2,5,6)'

      case (40)
        chan_str = 'ub Q to db Q lm nub '
        me_str   = 'C0g0W(3,4,2,1,5,6)  '
        sub_str  = 'qbqpC0g0WS(3,4,2,1,5,6)'

      case (41)
        chan_str = 'd db to db u lm nub '
        me_str   = 'D0g0Wa(1,2,3,4,5,6) '
        sub_str  = 'qpqpbD0g0WaS(1,2,3,4,5,6)'

      case (42)
        chan_str = 'd d to d u lm nub   '
        me_str   = 'D0g0Wa(1,3,2,4,5,6) '
        sub_str  = 'qpqpD0g0WaS(1,3,2,4,5,6)'

      case (43)
        chan_str = 'd ub to d db lm nub '
        me_str   = 'D0g0Wa(1,3,4,2,5,6) '
        sub_str  = 'qpqbD0g0WaS(1,3,4,2,5,6)'

      case (44)
        chan_str = 'db d to db u lm nub '
        me_str   = 'D0g0Wa(2,1,3,4,5,6) '
        sub_str  = 'qpbqpD0g0WaS(2,1,3,4,5,6)'

      case (45)
        chan_str = 'ub d to d db lm nub '
        me_str   = 'D0g0Wa(2,3,4,1,5,6) '
        sub_str  = 'qbqpD0g0WaS(2,3,4,1,5,6)'

      case (46)
        chan_str = 'db ub to db db lm nub '
        me_str   = 'D0g0Wa(3,1,4,2,5,6) '
        sub_str  = 'qpbqbD0g0WaS(3,1,4,2,5,6)'

      case (47)
        chan_str = 'ub db to db db lm nub '
        me_str   = 'D0g0Wa(3,2,4,1,5,6) '
        sub_str  = 'qbqpbD0g0WaS(3,2,4,1,5,6)'

      case (48)
        chan_str = 'd ub to ub u lm nub '
        me_str   = 'D0g0Wb(1,2,3,4,5,6) '
        sub_str  = 'qpqbD0g0WbS(1,2,3,4,5,6)'

      case (49)
        chan_str = 'd u to u u lm nub   '
        me_str   = 'D0g0Wb(1,3,2,4,5,6) '
        sub_str  = 'qpqD0g0WbS(1,3,2,4,5,6)'

      case (50)
        chan_str = 'ub d to ub u lm nub '
        me_str   = 'D0g0Wb(2,1,3,4,5,6) '
        sub_str  = 'qbqpD0g0WbS(2,1,3,4,5,6)'

      case (51)
        chan_str = 'u d to u u lm nub   '
        me_str   = 'D0g0Wb(2,3,1,4,5,6) '
        sub_str  = 'qqpD0g0WbS(2,3,1,4,5,6)'

      case (52)
        chan_str = 'ub u to db u lm nub '
        me_str   = 'D0g0Wb(3,1,2,4,5,6) '
        sub_str  = 'qbqD0g0WbS(3,1,2,4,5,6)'

      case (53)
        chan_str = 'ub ub to db ub lm nub '
        me_str   = 'D0g0Wb(3,1,4,2,5,6) '
        sub_str  = 'qbqbD0g0WbS(3,1,4,2,5,6)'

      case (54)
        chan_str = 'u ub to db u lm nub '
        me_str   = 'D0g0Wb(3,2,1,4,5,6) '
        sub_str  = 'qqbD0g0WbS(3,2,1,4,5,6)'

      case (55)
        chan_str = 'd g to u lm nub     '
        me_str   = 'B1g1W(1,2,3,4,5)    '
        sub_str  = 'qgB1g1WT(1,2,3,4,5)'

      case (56)
        chan_str = 'd ub to g lm nub    '
        me_str   = 'B1g1W(1,3,2,4,5)    '
        sub_str  = 'qqbB1g1WT(1,3,2,4,5)'

      case (57)
        chan_str = 'g d to u lm nub     '
        me_str   = 'B1g1W(2,1,3,4,5)    '
        sub_str  = 'gqB1g1WT(2,1,3,4,5)'

      case (58)
        chan_str = 'ub d to g lm nub    '
        me_str   = 'B1g1W(2,3,1,4,5)    '
        sub_str  = 'qbqB1g1WT(2,3,1,4,5)'

      case (59)
        chan_str = 'g ub to db lm nub   '
        me_str   = 'B1g1W(3,1,2,4,5)    '
        sub_str  = 'gqbB1g1WT(3,1,2,4,5)'

      case (60)
        chan_str = 'ub g to db lm nub   '
        me_str   = 'B1g1W(3,2,1,4,5)    '
        sub_str  = 'qbgB1g1WT(3,2,1,4,5)'

      case (61)
        chan_str = 'Q d subtraction     '
        me_str   = '                    '
        sub_str  = 'qpqB1g1WT(1,2,3,4,5)'

      case (62)
        chan_str = 'Q ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qpqbB1g1WT(1,2,3,4,5)'

      case (63)
        chan_str = 'Qb d subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbqB1g1WT(1,2,3,4,5)'

      case (64)
        chan_str = 'Qb ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbqbB1g1WT(1,2,3,4,5)'

      case (65)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggB1g1WT(1,2,3,4,5)'

      case (66)
        chan_str = 'd Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB1g1WT(1,2,3,4,5)'

      case (67)
        chan_str = 'd Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB1g1WT(1,2,3,4,5)'

      case (68)
        chan_str = 'ub Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB1g1WT(1,2,3,4,5)'

      case (69)
        chan_str = 'ub Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB1g1WT(1,2,3,4,5)'

      case (70)
        chan_str = 'd g to u lm nub     '
        me_str   = 'Bt1g1W(1,2,3,4,5)   '
        sub_str  = 'qgBt1g1WT(1,2,3,4,5)'

      case (71)
        chan_str = 'd ub to g lm nub    '
        me_str   = 'Bt1g1W(1,3,2,4,5)   '
        sub_str  = 'qqbBt1g1WT(1,3,2,4,5)'

      case (72)
        chan_str = 'g d to u lm nub     '
        me_str   = 'Bt1g1W(2,1,3,4,5)   '
        sub_str  = 'gqBt1g1WT(2,1,3,4,5)'

      case (73)
        chan_str = 'ub d to g lm nub    '
        me_str   = 'Bt1g1W(2,3,1,4,5)   '
        sub_str  = 'qbqBt1g1WT(2,3,1,4,5)'

      case (74)
        chan_str = 'g ub to db lm nub   '
        me_str   = 'Bt1g1W(3,1,2,4,5)   '
        sub_str  = 'gqbBt1g1WT(3,1,2,4,5)'

      case (75)
        chan_str = 'ub g to db lm nub   '
        me_str   = 'Bt1g1W(3,2,1,4,5)   '
        sub_str  = 'qbgBt1g1WT(3,2,1,4,5)'

      case (76)
        chan_str = 'Q d subtraction     '
        me_str   = '                    '
        sub_str  = 'qpqBt1g1WT(1,2,3,4,5)'

      case (77)
        chan_str = 'Q ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qpqbBt1g1WT(1,2,3,4,5)'

      case (78)
        chan_str = 'Qb d subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbqBt1g1WT(1,2,3,4,5)'

      case (79)
        chan_str = 'Qb ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbqbBt1g1WT(1,2,3,4,5)'

      case (80)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBt1g1WT(1,2,3,4,5)'

      case (81)
        chan_str = 'd Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt1g1WT(1,2,3,4,5)'

      case (82)
        chan_str = 'd Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt1g1WT(1,2,3,4,5)'

      case (83)
        chan_str = 'ub Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt1g1WT(1,2,3,4,5)'

      case (84)
        chan_str = 'ub Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt1g1WT(1,2,3,4,5)'

      case (85)
        chan_str = 'd g to u lm nub     '
        me_str   = 'Bh1g1W(1,2,3,4,5)   '
        sub_str  = 'qgBh1g1WT(1,2,3,4,5)'

      case (86)
        chan_str = 'd ub to g lm nub    '
        me_str   = 'Bh1g1W(1,3,2,4,5)   '
        sub_str  = 'qqbBh1g1WT(1,3,2,4,5)'

      case (87)
        chan_str = 'g d to u lm nub     '
        me_str   = 'Bh1g1W(2,1,3,4,5)   '
        sub_str  = 'gqBh1g1WT(2,1,3,4,5)'

      case (88)
        chan_str = 'ub d to g lm nub    '
        me_str   = 'Bh1g1W(2,3,1,4,5)   '
        sub_str  = 'qbqBh1g1WT(2,3,1,4,5)'

      case (89)
        chan_str = 'g ub to db lm nub   '
        me_str   = 'Bh1g1W(3,1,2,4,5)   '
        sub_str  = 'gqbBh1g1WT(3,1,2,4,5)'

      case (90)
        chan_str = 'ub g to db lm nub   '
        me_str   = 'Bh1g1W(3,2,1,4,5)   '
        sub_str  = 'qbgBh1g1WT(3,2,1,4,5)'

      case (91)
        chan_str = 'Q d subtraction     '
        me_str   = '                    '
        sub_str  = 'qpqBh1g1WT(1,2,3,4,5)'

      case (92)
        chan_str = 'Q ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qpqbBh1g1WT(1,2,3,4,5)'

      case (93)
        chan_str = 'Qb d subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbqBh1g1WT(1,2,3,4,5)'

      case (94)
        chan_str = 'Qb ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbqbBh1g1WT(1,2,3,4,5)'

      case (95)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBh1g1WT(1,2,3,4,5)'

      case (96)
        chan_str = 'd Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh1g1WT(1,2,3,4,5)'

      case (97)
        chan_str = 'd Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh1g1WT(1,2,3,4,5)'

      case (98)
        chan_str = 'ub Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh1g1WT(1,2,3,4,5)'

      case (99)
        chan_str = 'ub Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh1g1WT(1,2,3,4,5)'

      case (100)
        chan_str = 'd ub to lm nub      '
        me_str   = 'B0g2Wm(1,2,3,4)     '
        sub_str  = 'qqbB0g2WmU(1,2,3,4)'

      case (101)
        chan_str = 'ub d to lm nub      '
        me_str   = 'B0g2Wm(2,1,3,4)     '
        sub_str  = 'qbqB0g2WmU(2,1,3,4)'

      case (102)
        chan_str = 'Q d subtraction     '
        me_str   = '                    '
        sub_str  = 'qpqB0g2WmU(1,2,3,4)'

      case (103)
        chan_str = 'Q ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qpqbB0g2WmU(1,2,3,4)'

      case (104)
        chan_str = 'Qb d subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbqB0g2WmU(1,2,3,4)'

      case (105)
        chan_str = 'Qb ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbqbB0g2WmU(1,2,3,4)'

      case (106)
        chan_str = 'd u subtraction     '
        me_str   = '                    '
        sub_str  = 'duB0g2WmU(1,2,3,4)'

      case (107)
        chan_str = 'db ub subtraction   '
        me_str   = '                    '
        sub_str  = 'dbubB0g2WmU(1,2,3,4)'

      case (108)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggB0g2WmU(1,2,3,4)'

      case (109)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gqB0g2WmU(1,2,3,4)'

      case (110)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbB0g2WmU(1,2,3,4)'

      case (111)
        chan_str = 'd Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB0g2WmU(1,2,3,4)'

      case (112)
        chan_str = 'd Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB0g2WmU(1,2,3,4)'

      case (113)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgB0g2WmU(1,2,3,4)'

      case (114)
        chan_str = 'ub Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB0g2WmU(1,2,3,4)'

      case (115)
        chan_str = 'ub Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB0g2WmU(1,2,3,4)'

      case (116)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgB0g2WmU(1,2,3,4)'

      case (117)
        chan_str = 'u d subtraction     '
        me_str   = '                    '
        sub_str  = 'udB0g2WmU(1,2,3,4)'

      case (118)
        chan_str = 'ub db subtraction   '
        me_str   = '                    '
        sub_str  = 'ubdbB0g2WmU(1,2,3,4)'

      case (119)
        chan_str = 'd ub to lm nub      '
        me_str   = 'Bt0g2W(1,2,3,4)     '
        sub_str  = 'qqbBt0g2WU(1,2,3,4)'

      case (120)
        chan_str = 'ub d to lm nub      '
        me_str   = 'Bt0g2W(2,1,3,4)     '
        sub_str  = 'qbqBt0g2WU(2,1,3,4)'

      case (121)
        chan_str = 'Q d subtraction     '
        me_str   = '                    '
        sub_str  = 'qpqBt0g2WU(1,2,3,4)'

      case (122)
        chan_str = 'Q ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qpqbBt0g2WU(1,2,3,4)'

      case (123)
        chan_str = 'Qb d subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbqBt0g2WU(1,2,3,4)'

      case (124)
        chan_str = 'Qb ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbqbBt0g2WU(1,2,3,4)'

      case (125)
        chan_str = 'd u subtraction     '
        me_str   = '                    '
        sub_str  = 'duBt0g2WU(1,2,3,4)'

      case (126)
        chan_str = 'db ub subtraction   '
        me_str   = '                    '
        sub_str  = 'dbubBt0g2WU(1,2,3,4)'

      case (127)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBt0g2WU(1,2,3,4)'

      case (128)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gqBt0g2WU(1,2,3,4)'

      case (129)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbBt0g2WU(1,2,3,4)'

      case (130)
        chan_str = 'd Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt0g2WU(1,2,3,4)'

      case (131)
        chan_str = 'd Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt0g2WU(1,2,3,4)'

      case (132)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgBt0g2WU(1,2,3,4)'

      case (133)
        chan_str = 'ub Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt0g2WU(1,2,3,4)'

      case (134)
        chan_str = 'ub Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt0g2WU(1,2,3,4)'

      case (135)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgBt0g2WU(1,2,3,4)'

      case (136)
        chan_str = 'u d subtraction     '
        me_str   = '                    '
        sub_str  = 'udBt0g2WU(1,2,3,4)'

      case (137)
        chan_str = 'ub db subtraction   '
        me_str   = '                    '
        sub_str  = 'ubdbBt0g2WU(1,2,3,4)'

      case (138)
        chan_str = 'd ub to lm nub      '
        me_str   = 'Bh0g2W(1,2,3,4)     '
        sub_str  = 'qqbBh0g2WU(1,2,3,4)'

      case (139)
        chan_str = 'ub d to lm nub      '
        me_str   = 'Bh0g2W(2,1,3,4)     '
        sub_str  = 'qbqBh0g2WU(2,1,3,4)'

      case (140)
        chan_str = 'Q d subtraction     '
        me_str   = '                    '
        sub_str  = 'qpqBh0g2WU(1,2,3,4)'

      case (141)
        chan_str = 'Q ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qpqbBh0g2WU(1,2,3,4)'

      case (142)
        chan_str = 'Qb d subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbqBh0g2WU(1,2,3,4)'

      case (143)
        chan_str = 'Qb ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbqbBh0g2WU(1,2,3,4)'

      case (144)
        chan_str = 'd u subtraction     '
        me_str   = '                    '
        sub_str  = 'duBh0g2WU(1,2,3,4)'

      case (145)
        chan_str = 'db ub subtraction   '
        me_str   = '                    '
        sub_str  = 'dbubBh0g2WU(1,2,3,4)'

      case (146)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBh0g2WU(1,2,3,4)'

      case (147)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gqBh0g2WU(1,2,3,4)'

      case (148)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbBh0g2WU(1,2,3,4)'

      case (149)
        chan_str = 'd Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh0g2WU(1,2,3,4)'

      case (150)
        chan_str = 'd Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh0g2WU(1,2,3,4)'

      case (151)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgBh0g2WU(1,2,3,4)'

      case (152)
        chan_str = 'ub Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh0g2WU(1,2,3,4)'

      case (153)
        chan_str = 'ub Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh0g2WU(1,2,3,4)'

      case (154)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgBh0g2WU(1,2,3,4)'

      case (155)
        chan_str = 'u d subtraction     '
        me_str   = '                    '
        sub_str  = 'udBh0g2WU(1,2,3,4)'

      case (156)
        chan_str = 'ub db subtraction   '
        me_str   = '                    '
        sub_str  = 'ubdbBh0g2WU(1,2,3,4)'

      case default
        print*, 'getchannelWm: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtWm(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtWm = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (16)
        ! [g, g, lm, nub]
        LIPSwgtWm = weight_lips((/ 3,4 /))

      case (18)
        ! [g, g, lm, nub]
        LIPSwgtWm = weight_lips((/ 3,4 /))

      case (23)
        ! [gt, gt, lm, nub]
        LIPSwgtWm = weight_lips((/ 3,4 /))

      case (25)
        ! [gt, gt, lm, nub]
        LIPSwgtWm = weight_lips((/ 3,4 /))

      case (46)
        ! [db, db, lm, nub]
        LIPSwgtWm = weight_lips((/ 3,4 /))

      case (47)
        ! [db, db, lm, nub]
        LIPSwgtWm = weight_lips((/ 3,4 /))

      case (49)
        ! [u, u, lm, nub]
        LIPSwgtWm = weight_lips((/ 3,4 /))

      case (51)
        ! [u, u, lm, nub]
        LIPSwgtWm = weight_lips((/ 3,4 /))

      case default
        LIPSwgtWm = 1

      end select
      end
