      function sigRVWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use CKM_mod, only : ckmflag  
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRVWm=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,5,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- d g to u lm nub 
      if (qactive_chan(55).and.qselect_chan(55)) then
        current_chan = 55
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1W(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g lm nub 
      if (qactive_chan(56).and.qselect_chan(56)) then
        current_chan = 56
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1W(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u lm nub 
      if (qactive_chan(57).and.qselect_chan(57)) then
        current_chan = 57
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1W(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g lm nub 
      if (qactive_chan(58).and.qselect_chan(58)) then
        current_chan = 58
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1W(2,3,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db lm nub 
      if (qactive_chan(59).and.qselect_chan(59)) then
        current_chan = 59
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1W(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db lm nub 
      if (qactive_chan(60).and.qselect_chan(60)) then
        current_chan = 60
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g1W(3,2,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to u lm nub 
      if (qactive_chan(70).and.qselect_chan(70)) then
        current_chan = 70
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1W(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g lm nub 
      if (qactive_chan(71).and.qselect_chan(71)) then
        current_chan = 71
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1W(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u lm nub 
      if (qactive_chan(72).and.qselect_chan(72)) then
        current_chan = 72
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1W(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g lm nub 
      if (qactive_chan(73).and.qselect_chan(73)) then
        current_chan = 73
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1W(2,3,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db lm nub 
      if (qactive_chan(74).and.qselect_chan(74)) then
        current_chan = 74
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1W(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db lm nub 
      if (qactive_chan(75).and.qselect_chan(75)) then
        current_chan = 75
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g1W(3,2,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to u lm nub 
      if (qactive_chan(85).and.qselect_chan(85)) then
        current_chan = 85
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1W(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g lm nub 
      if (qactive_chan(86).and.qselect_chan(86)) then
        current_chan = 86
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1W(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u lm nub 
      if (qactive_chan(87).and.qselect_chan(87)) then
        current_chan = 87
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1W(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g lm nub 
      if (qactive_chan(88).and.qselect_chan(88)) then
        current_chan = 88
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1W(2,3,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db lm nub 
      if (qactive_chan(89).and.qselect_chan(89)) then
        current_chan = 89
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1W(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db lm nub 
      if (qactive_chan(90).and.qselect_chan(90)) then
        current_chan = 90
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g1W(3,2,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRVWm=rnorm*wtsum

      return
      end
