      function sigTWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTWm=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d g to u lm nub     
        if (qactive_chan(55).and.qselect_chan(55)) then
          current_chan = 55
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g lm nub    
        if (qactive_chan(56).and.qselect_chan(56)) then
          current_chan = 56
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbB1g1WT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to u lm nub     
        if (qactive_chan(57).and.qselect_chan(57)) then
          current_chan = 57
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gqB1g1WT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g lm nub    
        if (qactive_chan(58).and.qselect_chan(58)) then
          current_chan = 58
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqB1g1WT(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db lm nub   
        if (qactive_chan(59).and.qselect_chan(59)) then
          current_chan = 59
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gqbB1g1WT(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db lm nub   
        if (qactive_chan(60).and.qselect_chan(60)) then
          current_chan = 60
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgB1g1WT(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(61).and.qselect_chan(61)) then
          current_chan = 61
          ip1_chan     = 31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(62).and.qselect_chan(62)) then
          current_chan = 62
          ip1_chan     = 31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(63).and.qselect_chan(63)) then
          current_chan = 63
          ip1_chan     = -31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(64).and.qselect_chan(64)) then
          current_chan = 64
          ip1_chan     = -31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(65).and.qselect_chan(65)) then
          current_chan = 65
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ggB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(66).and.qselect_chan(66)) then
          current_chan = 66
          ip1_chan     = 41
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(67).and.qselect_chan(67)) then
          current_chan = 67
          ip1_chan     = 41
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(68).and.qselect_chan(68)) then
          current_chan = 68
          ip1_chan     = -21
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(69).and.qselect_chan(69)) then
          current_chan = 69
          ip1_chan     = -21
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbB1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to u lm nub     
        if (qactive_chan(70).and.qselect_chan(70)) then
          current_chan = 70
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g lm nub    
        if (qactive_chan(71).and.qselect_chan(71)) then
          current_chan = 71
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbBt1g1WT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to u lm nub     
        if (qactive_chan(72).and.qselect_chan(72)) then
          current_chan = 72
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gqBt1g1WT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g lm nub    
        if (qactive_chan(73).and.qselect_chan(73)) then
          current_chan = 73
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqBt1g1WT(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db lm nub   
        if (qactive_chan(74).and.qselect_chan(74)) then
          current_chan = 74
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gqbBt1g1WT(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db lm nub   
        if (qactive_chan(75).and.qselect_chan(75)) then
          current_chan = 75
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgBt1g1WT(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(76).and.qselect_chan(76)) then
          current_chan = 76
          ip1_chan     = 31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(77).and.qselect_chan(77)) then
          current_chan = 77
          ip1_chan     = 31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(78).and.qselect_chan(78)) then
          current_chan = 78
          ip1_chan     = -31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(79).and.qselect_chan(79)) then
          current_chan = 79
          ip1_chan     = -31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(80).and.qselect_chan(80)) then
          current_chan = 80
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ggBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(81).and.qselect_chan(81)) then
          current_chan = 81
          ip1_chan     = 41
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(82).and.qselect_chan(82)) then
          current_chan = 82
          ip1_chan     = 41
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(83).and.qselect_chan(83)) then
          current_chan = 83
          ip1_chan     = -21
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(84).and.qselect_chan(84)) then
          current_chan = 84
          ip1_chan     = -21
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbBt1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to u lm nub     
        if (qactive_chan(85).and.qselect_chan(85)) then
          current_chan = 85
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g lm nub    
        if (qactive_chan(86).and.qselect_chan(86)) then
          current_chan = 86
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbBh1g1WT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to u lm nub     
        if (qactive_chan(87).and.qselect_chan(87)) then
          current_chan = 87
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gqBh1g1WT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g lm nub    
        if (qactive_chan(88).and.qselect_chan(88)) then
          current_chan = 88
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqBh1g1WT(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db lm nub   
        if (qactive_chan(89).and.qselect_chan(89)) then
          current_chan = 89
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gqbBh1g1WT(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db lm nub   
        if (qactive_chan(90).and.qselect_chan(90)) then
          current_chan = 90
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgBh1g1WT(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(91).and.qselect_chan(91)) then
          current_chan = 91
          ip1_chan     = 31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(92).and.qselect_chan(92)) then
          current_chan = 92
          ip1_chan     = 31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(93).and.qselect_chan(93)) then
          current_chan = 93
          ip1_chan     = -31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(94).and.qselect_chan(94)) then
          current_chan = 94
          ip1_chan     = -31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(95).and.qselect_chan(95)) then
          current_chan = 95
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ggBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(96).and.qselect_chan(96)) then
          current_chan = 96
          ip1_chan     = 41
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(97).and.qselect_chan(97)) then
          current_chan = 97
          ip1_chan     = 41
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(98).and.qselect_chan(98)) then
          current_chan = 98
          ip1_chan     = -21
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(99).and.qselect_chan(99)) then
          current_chan = 99
          ip1_chan     = -21
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbBh1g1WT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTWm=sigTWm+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
