      function sigUWp(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUWp=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- u db to nu lp       
        if (qactive_chan(100).and.qselect_chan(100)) then
          current_chan = 100
          ip1_chan     = 20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 1
          ckmflag = .true.
          wt = qqbB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to nu lp       
        if (qactive_chan(101).and.qselect_chan(101)) then
          current_chan = 101
          ip1_chan     = -40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 1
          ckmflag = .true.
          wt = qbqB0g2WpU(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q u initiated       
        if (qactive_chan(102).and.qselect_chan(102)) then
          current_chan = 102
          ip1_chan     = 31
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q db initiated      
        if (qactive_chan(103).and.qselect_chan(103)) then
          current_chan = 103
          ip1_chan     = 31
          ip2_chan     = -41
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb u initiated      
        if (qactive_chan(104).and.qselect_chan(104)) then
          current_chan = 104
          ip1_chan     = -31
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb db initiated     
        if (qactive_chan(105).and.qselect_chan(105)) then
          current_chan = 105
          ip1_chan     = -31
          ip2_chan     = -41
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(106).and.qselect_chan(106)) then
          current_chan = 106
          ip1_chan     = 40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = duB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(107).and.qselect_chan(107)) then
          current_chan = 107
          ip1_chan     = -40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = dbubB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(108).and.qselect_chan(108)) then
          current_chan = 108
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = ggB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(109).and.qselect_chan(109)) then
          current_chan = 109
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = gqB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(110).and.qselect_chan(110)) then
          current_chan = 110
          ip1_chan     = 0
          ip2_chan     = -40
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = gqbB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Q initiated       
        if (qactive_chan(111).and.qselect_chan(111)) then
          current_chan = 111
          ip1_chan     = 21
          ip2_chan     = 31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Qb initiated      
        if (qactive_chan(112).and.qselect_chan(112)) then
          current_chan = 112
          ip1_chan     = 21
          ip2_chan     = -31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(113).and.qselect_chan(113)) then
          current_chan = 113
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = qgB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Q initiated      
        if (qactive_chan(114).and.qselect_chan(114)) then
          current_chan = 114
          ip1_chan     = -41
          ip2_chan     = 31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Qb initiated     
        if (qactive_chan(115).and.qselect_chan(115)) then
          current_chan = 115
          ip1_chan     = -41
          ip2_chan     = -31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(116).and.qselect_chan(116)) then
          current_chan = 116
          ip1_chan     = -40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = qbgB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(117).and.qselect_chan(117)) then
          current_chan = 117
          ip1_chan     = 20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = udB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(118).and.qselect_chan(118)) then
          current_chan = 118
          ip1_chan     = -20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = ubdbB0g2WpU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to nu lp       
        if (qactive_chan(119).and.qselect_chan(119)) then
          current_chan = 119
          ip1_chan     = 20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 1
          ckmflag = .true.
          wt = qqbBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to nu lp       
        if (qactive_chan(120).and.qselect_chan(120)) then
          current_chan = 120
          ip1_chan     = -40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 1
          ckmflag = .true.
          wt = qbqBt0g2WU(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q u initiated       
        if (qactive_chan(121).and.qselect_chan(121)) then
          current_chan = 121
          ip1_chan     = 31
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q db initiated      
        if (qactive_chan(122).and.qselect_chan(122)) then
          current_chan = 122
          ip1_chan     = 31
          ip2_chan     = -41
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb u initiated      
        if (qactive_chan(123).and.qselect_chan(123)) then
          current_chan = 123
          ip1_chan     = -31
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb db initiated     
        if (qactive_chan(124).and.qselect_chan(124)) then
          current_chan = 124
          ip1_chan     = -31
          ip2_chan     = -41
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(125).and.qselect_chan(125)) then
          current_chan = 125
          ip1_chan     = 40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = duBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(126).and.qselect_chan(126)) then
          current_chan = 126
          ip1_chan     = -40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = dbubBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(127).and.qselect_chan(127)) then
          current_chan = 127
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = ggBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(128).and.qselect_chan(128)) then
          current_chan = 128
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = gqBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(129).and.qselect_chan(129)) then
          current_chan = 129
          ip1_chan     = 0
          ip2_chan     = -40
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = gqbBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Q initiated       
        if (qactive_chan(130).and.qselect_chan(130)) then
          current_chan = 130
          ip1_chan     = 21
          ip2_chan     = 31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Qb initiated      
        if (qactive_chan(131).and.qselect_chan(131)) then
          current_chan = 131
          ip1_chan     = 21
          ip2_chan     = -31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(132).and.qselect_chan(132)) then
          current_chan = 132
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = qgBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Q initiated      
        if (qactive_chan(133).and.qselect_chan(133)) then
          current_chan = 133
          ip1_chan     = -41
          ip2_chan     = 31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Qb initiated     
        if (qactive_chan(134).and.qselect_chan(134)) then
          current_chan = 134
          ip1_chan     = -41
          ip2_chan     = -31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(135).and.qselect_chan(135)) then
          current_chan = 135
          ip1_chan     = -40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = qbgBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(136).and.qselect_chan(136)) then
          current_chan = 136
          ip1_chan     = 20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = udBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(137).and.qselect_chan(137)) then
          current_chan = 137
          ip1_chan     = -20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = ubdbBt0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to nu lp       
        if (qactive_chan(138).and.qselect_chan(138)) then
          current_chan = 138
          ip1_chan     = 20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 1
          ckmflag = .true.
          wt = qqbBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to nu lp       
        if (qactive_chan(139).and.qselect_chan(139)) then
          current_chan = 139
          ip1_chan     = -40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 1
          ckmflag = .true.
          wt = qbqBh0g2WU(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q u initiated       
        if (qactive_chan(140).and.qselect_chan(140)) then
          current_chan = 140
          ip1_chan     = 31
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q db initiated      
        if (qactive_chan(141).and.qselect_chan(141)) then
          current_chan = 141
          ip1_chan     = 31
          ip2_chan     = -41
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb u initiated      
        if (qactive_chan(142).and.qselect_chan(142)) then
          current_chan = 142
          ip1_chan     = -31
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb db initiated     
        if (qactive_chan(143).and.qselect_chan(143)) then
          current_chan = 143
          ip1_chan     = -31
          ip2_chan     = -41
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(144).and.qselect_chan(144)) then
          current_chan = 144
          ip1_chan     = 40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = duBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(145).and.qselect_chan(145)) then
          current_chan = 145
          ip1_chan     = -40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = dbubBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(146).and.qselect_chan(146)) then
          current_chan = 146
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = ggBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(147).and.qselect_chan(147)) then
          current_chan = 147
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = gqBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(148).and.qselect_chan(148)) then
          current_chan = 148
          ip1_chan     = 0
          ip2_chan     = -40
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = gqbBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Q initiated       
        if (qactive_chan(149).and.qselect_chan(149)) then
          current_chan = 149
          ip1_chan     = 21
          ip2_chan     = 31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Qb initiated      
        if (qactive_chan(150).and.qselect_chan(150)) then
          current_chan = 150
          ip1_chan     = 21
          ip2_chan     = -31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(151).and.qselect_chan(151)) then
          current_chan = 151
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = qgBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Q initiated      
        if (qactive_chan(152).and.qselect_chan(152)) then
          current_chan = 152
          ip1_chan     = -41
          ip2_chan     = 31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Qb initiated     
        if (qactive_chan(153).and.qselect_chan(153)) then
          current_chan = 153
          ip1_chan     = -41
          ip2_chan     = -31
          call Q3_check
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(154).and.qselect_chan(154)) then
          current_chan = 154
          ip1_chan     = -40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = qbgBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(155).and.qselect_chan(155)) then
          current_chan = 155
          ip1_chan     = 20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = udBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(156).and.qselect_chan(156)) then
          current_chan = 156
          ip1_chan     = -20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 1
          ckmflag = .false.
          wt = ubdbBh0g2WU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUWp=sigUWp+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
