      function sigVVWp(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use CKM_mod, only : ckmflag  
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVVWp=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,4,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

!$omp critical(VV_Wp)
#ifdef USE_OL  
      call fill_pOL(4, (/ 1, 2, 3, 4 /) )
#endif 

c--- u db to nu lp 
      if (qactive_chan(100).and.qselect_chan(100)) then
        current_chan = 100
        ip1_chan     = 20
        ip2_chan     = -40
        nfB1 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B0g2Wp(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db u to nu lp 
      if (qactive_chan(101).and.qselect_chan(101)) then
        current_chan = 101
        ip1_chan     = -40
        ip2_chan     = 20
        nfB1 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B0g2Wp(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u db to nu lp 
      if (qactive_chan(119).and.qselect_chan(119)) then
        current_chan = 119
        ip1_chan     = 20
        ip2_chan     = -40
        nfB1 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt0g2W(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db u to nu lp 
      if (qactive_chan(120).and.qselect_chan(120)) then
        current_chan = 120
        ip1_chan     = -40
        ip2_chan     = 20
        nfB1 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt0g2W(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u db to nu lp 
      if (qactive_chan(138).and.qselect_chan(138)) then
        current_chan = 138
        ip1_chan     = 20
        ip2_chan     = -40
        nfB1 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh0g2W(1,2,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db u to nu lp 
      if (qactive_chan(139).and.qselect_chan(139)) then
        current_chan = 139
        ip1_chan     = -40
        ip2_chan     = 20
        nfB1 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh0g2W(2,1,3,4,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
!$omp end critical(VV_Wp)

      sigVVWp=rnorm*wtsum

      return
      end
