      subroutine getlumiWpJ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    7,   14,   47,   62,   77,   92,   99,          
     &          106,  113,  133,  153,  166,  179,  192,  205,          
     &          220,  235,  242,  249,  264,  289,  309,  329,          
     &          342,  368,  394,  409,  432,  455,  478,  501,          
     &          524)
!       [20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,    8,   15,   23,   35,   40,   48,   63,          
     &           78,   93,  100,  107,  116,  136,  156,  167,          
     &          182,  193,  206,  221,  236,  243,  250,  265,          
     &          273,  293,  313,  333,  344,  359,  370,  385,          
     &          396,  410,  433,  456,  479,  502,  525)
!       [20, -40]
          if ( .not. ckmflag ) then
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
          else
          partons(1:nInp_scl) =                                         
     &         CKM(2,1)*f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)              
     &       + CKM(2,3)*f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)              
     &       + CKM(4,1)*f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)              
     &       + CKM(4,3)*f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)
          end if

        case (    3,    9,   16,   49,   64,   79,   94,  101,          
     &          108,  117,  137,  157,  169,  183,  195,  207,          
     &          222,  237,  244,  251,  266,  287,  307,  327,          
     &          340,  366,  392,  411,  434,  457,  480,  503,          
     &          526)
!       [0, 20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (    4,   10,   17,   26,   37,   42,   50,   65,          
     &           80,   95,  102,  109,  120,  140,  159,  170,          
     &          185,  196,  208,  223,  238,  245,  252,  267,          
     &          276,  296,  316,  335,  346,  361,  372,  387,          
     &          398,  412,  435,  458,  481,  504,  527)
!       [-40, 20]
          if ( .not. ckmflag ) then
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
          else
          partons(1:nInp_scl) =                                         
     &         CKM(1,2)*f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)              
     &       + CKM(1,4)*f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)              
     &       + CKM(3,2)*f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)              
     &       + CKM(3,4)*f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)
          end if

        case (    5,   12,   19,   51,   66,   81,   97,  104,          
     &          111,  123,  143,  161,  172,  187,  198,  210,          
     &          225,  240,  247,  254,  269,  288,  308,  328,          
     &          354,  380,  406,  413,  436,  459,  482,  505,          
     &          528)
!       [0, -40]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case (    6,   13,   20,   52,   67,   82,   98,  105,          
     &          112,  126,  146,  163,  174,  189,  200,  211,          
     &          226,  241,  248,  255,  270,  290,  310,  330,          
     &          352,  378,  404,  414,  437,  460,  483,  506,          
     &          529)
!       [-40, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   11,   18,   57,   72,   87,   96,  103,  110,          
     &          209,  224,  239,  246,  253,  268,  423,  446,          
     &          469,  494,  517,  540)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   21,   59,   74,   89,  114,  134,  217,  232,          
     &          261,  271,  291,  311,  426,  449,  472,  496,          
     &          519,  542)
!       [21, -31]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   22,   58,   73,   88,  115,  135,  216,  231,          
     &          260,  272,  292,  312,  425,  448,  471,  495,          
     &          518,  541)
!       [21, 31]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   24,   55,   70,   85,  118,  138,  214,  229,          
     &          258,  274,  294,  314,  417,  440,  463,  488,          
     &          511,  534)
!       [-31, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   25,   53,   68,   83,  119,  139,  212,  227,          
     &          256,  275,  295,  315,  415,  438,  461,  485,          
     &          508,  531)
!       [31, 21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   27,  127,  147,  277,  297,  317)
!       [-30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   28,   56,   71,   86,  128,  148,  215,  230,          
     &          259,  278,  298,  318,  418,  441,  464,  489,          
     &          512,  535)
!       [-31, -41]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   29,  129,  149,  279,  299,  319)
!       [30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   30,   61,   76,   91,  130,  150,  219,  234,          
     &          263,  280,  300,  320,  428,  451,  474,  498,          
     &          521,  544)
!       [-41, -31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   31,   54,   69,   84,  131,  151,  213,  228,          
     &          257,  281,  301,  321,  416,  439,  462,  486,          
     &          509,  532)
!       [31, -41]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case (   32,   60,   75,   90,  132,  152,  218,  233,          
     &          262,  282,  302,  322,  427,  450,  473,  497,          
     &          520,  543)
!       [-41, 31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   33,  154,  180,  331,  357,  383)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   34,  155,  181,  332,  358,  384)
!       [20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   36,  158,  184,  334,  360,  386)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   38,  164,  190,  336,  362,  388,  430,  453,          
     &          476,  500,  523,  546)
!       [-20, -40]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   39,  165,  191,  337,  363,  389,  421,  444,          
     &          467,  491,  514,  537)
!       [-40, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   41,  168,  194,  345,  371,  397,  429,  452,          
     &          475,  499,  522,  545)
!       [20, 40]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (   43,  171,  197,  347,  373,  399,  420,  443,          
     &          466,  490,  513,  536)
!       [40, 20]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   44,  176,  202,  348,  374,  400)
!       [-40, 40]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       

        case (   45,  177,  203,  349,  375,  401)
!       [-40, -40]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   46,  178,  204,  350,  376,  402)
!       [40, -40]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case (  121,  141,  286,  306,  326,  493,  516,  539)
!       [0, -30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (  122,  142,  285,  305,  325,  492,  515,  538)
!       [0, 30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (  124,  144,  284,  304,  324,  487,  510,  533)
!       [-30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (  125,  145,  283,  303,  323,  484,  507,  530)
!       [30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (  160,  186,  341,  355,  367,  381,  393,  407,          
     &          424,  447,  470)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (  162,  188,  343,  356,  369,  382,  395,  408,          
     &          431,  454,  477)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (  173,  199,  339,  353,  365,  379,  391,  405,          
     &          422,  445,  468)
!       [0, 40]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (  175,  201,  338,  351,  364,  377,  390,  403,          
     &          419,  442,  465)
!       [40, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case default
          print*, "getlumiWpJ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiWpJ



      function getlumiidWpJ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    7,   14,   47,   62,   77,   92,   99,
     &          106,  113,  133,  153,  166,  179,  192,  205,
     &          220,  235,  242,  249,  264,  289,  309,  329,
     &          342,  368,  394,  409,  432,  455,  478,  501,
     &          524)
          id  = 1
          ip1 = 20
          ip2 = 0

        case (    2,    8,   15,   23,   35,   40,   48,   63,
     &           78,   93,  100,  107,  116,  136,  156,  167,
     &          182,  193,  206,  221,  236,  243,  250,  265,
     &          273,  293,  313,  333,  344,  359,  370,  385,
     &          396,  410,  433,  456,  479,  502,  525)
          id  = 2
          ip1 = 20
          ip2 = -40

        case (    3,    9,   16,   49,   64,   79,   94,  101,
     &          108,  117,  137,  157,  169,  183,  195,  207,
     &          222,  237,  244,  251,  266,  287,  307,  327,
     &          340,  366,  392,  411,  434,  457,  480,  503,
     &          526)
          id  = 3
          ip1 = 0
          ip2 = 20

        case (    4,   10,   17,   26,   37,   42,   50,   65,
     &           80,   95,  102,  109,  120,  140,  159,  170,
     &          185,  196,  208,  223,  238,  245,  252,  267,
     &          276,  296,  316,  335,  346,  361,  372,  387,
     &          398,  412,  435,  458,  481,  504,  527)
          id  = 4
          ip1 = -40
          ip2 = 20

        case (    5,   12,   19,   51,   66,   81,   97,  104,
     &          111,  123,  143,  161,  172,  187,  198,  210,
     &          225,  240,  247,  254,  269,  288,  308,  328,
     &          354,  380,  406,  413,  436,  459,  482,  505,
     &          528)
          id  = 5
          ip1 = 0
          ip2 = -40

        case (    6,   13,   20,   52,   67,   82,   98,  105,
     &          112,  126,  146,  163,  174,  189,  200,  211,
     &          226,  241,  248,  255,  270,  290,  310,  330,
     &          352,  378,  404,  414,  437,  460,  483,  506,
     &          529)
          id  = 6
          ip1 = -40
          ip2 = 0

        case (   11,   18,   57,   72,   87,   96,  103,  110,
     &          209,  224,  239,  246,  253,  268,  423,  446,
     &          469,  494,  517,  540)
          id  = 7
          ip1 = 0
          ip2 = 0

        case (   21,   59,   74,   89,  114,  134,  217,  232,
     &          261,  271,  291,  311,  426,  449,  472,  496,
     &          519,  542)
          id  = 8
          ip1 = 21
          ip2 = -31

        case (   22,   58,   73,   88,  115,  135,  216,  231,
     &          260,  272,  292,  312,  425,  448,  471,  495,
     &          518,  541)
          id  = 9
          ip1 = 21
          ip2 = 31

        case (   24,   55,   70,   85,  118,  138,  214,  229,
     &          258,  274,  294,  314,  417,  440,  463,  488,
     &          511,  534)
          id  = 10
          ip1 = -31
          ip2 = 21

        case (   25,   53,   68,   83,  119,  139,  212,  227,
     &          256,  275,  295,  315,  415,  438,  461,  485,
     &          508,  531)
          id  = 11
          ip1 = 31
          ip2 = 21

        case (   27,  127,  147,  277,  297,  317)
          id  = 12
          ip1 = -30
          ip2 = 30

        case (   28,   56,   71,   86,  128,  148,  215,  230,
     &          259,  278,  298,  318,  418,  441,  464,  489,
     &          512,  535)
          id  = 13
          ip1 = -31
          ip2 = -41

        case (   29,  129,  149,  279,  299,  319)
          id  = 14
          ip1 = 30
          ip2 = -30

        case (   30,   61,   76,   91,  130,  150,  219,  234,
     &          263,  280,  300,  320,  428,  451,  474,  498,
     &          521,  544)
          id  = 15
          ip1 = -41
          ip2 = -31

        case (   31,   54,   69,   84,  131,  151,  213,  228,
     &          257,  281,  301,  321,  416,  439,  462,  486,
     &          509,  532)
          id  = 16
          ip1 = 31
          ip2 = -41

        case (   32,   60,   75,   90,  132,  152,  218,  233,
     &          262,  282,  302,  322,  427,  450,  473,  497,
     &          520,  543)
          id  = 17
          ip1 = -41
          ip2 = 31

        case (   33,  154,  180,  331,  357,  383)
          id  = 18
          ip1 = 20
          ip2 = -20

        case (   34,  155,  181,  332,  358,  384)
          id  = 19
          ip1 = 20
          ip2 = 20

        case (   36,  158,  184,  334,  360,  386)
          id  = 20
          ip1 = -20
          ip2 = 20

        case (   38,  164,  190,  336,  362,  388,  430,  453,
     &          476,  500,  523,  546)
          id  = 21
          ip1 = -20
          ip2 = -40

        case (   39,  165,  191,  337,  363,  389,  421,  444,
     &          467,  491,  514,  537)
          id  = 22
          ip1 = -40
          ip2 = -20

        case (   41,  168,  194,  345,  371,  397,  429,  452,
     &          475,  499,  522,  545)
          id  = 23
          ip1 = 20
          ip2 = 40

        case (   43,  171,  197,  347,  373,  399,  420,  443,
     &          466,  490,  513,  536)
          id  = 24
          ip1 = 40
          ip2 = 20

        case (   44,  176,  202,  348,  374,  400)
          id  = 25
          ip1 = -40
          ip2 = 40

        case (   45,  177,  203,  349,  375,  401)
          id  = 26
          ip1 = -40
          ip2 = -40

        case (   46,  178,  204,  350,  376,  402)
          id  = 27
          ip1 = 40
          ip2 = -40

        case (  121,  141,  286,  306,  326,  493,  516,  539)
          id  = 28
          ip1 = 0
          ip2 = -30

        case (  122,  142,  285,  305,  325,  492,  515,  538)
          id  = 29
          ip1 = 0
          ip2 = 30

        case (  124,  144,  284,  304,  324,  487,  510,  533)
          id  = 30
          ip1 = -30
          ip2 = 0

        case (  125,  145,  283,  303,  323,  484,  507,  530)
          id  = 31
          ip1 = 30
          ip2 = 0

        case (  160,  186,  341,  355,  367,  381,  393,  407,
     &          424,  447,  470)
          id  = 32
          ip1 = 0
          ip2 = -20

        case (  162,  188,  343,  356,  369,  382,  395,  408,
     &          431,  454,  477)
          id  = 33
          ip1 = -20
          ip2 = 0

        case (  173,  199,  339,  353,  365,  379,  391,  405,
     &          422,  445,  468)
          id  = 34
          ip1 = 0
          ip2 = 40

        case (  175,  201,  338,  351,  364,  377,  390,  403,
     &          419,  442,  465)
          id  = 35
          ip1 = 40
          ip2 = 0

        case default
          print*, "getlumiidWpJ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidWpJ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiWpJ()
        use PineAPPL_mod
        use CKM_mod
!       [20, 0]
        call register_lumi_pine(
     &         [    1,    7,   14,   47,   62,   77,   92,   99,
     &            106,  113,  133,  153,  166,  179,  192,  205,
     &            220,  235,  242,  249,  264,  289,  309,  329,
     &            342,  368,  394,  409,  432,  455,  478,  501,
     &            524],
     &         2,
     &         [    2,   21,    4,   21],
     &         [  1d0,  1d0]
     &       )

!       [20, -40]
        if ( .not. ckmflag ) then
        call register_lumi_pine(
     &         [    2,    8,   15,   23,   35,   40,   48,   63,
     &             78,   93,  100,  107,  116,  136,  156,  167,
     &            182,  193,  206,  221,  236,  243,  250,  265,
     &            273,  293,  313,  333,  344,  359,  370,  385,
     &            396,  410,  433,  456,  479,  502,  525],
     &         2,
     &         [    2,   -1,    4,   -3],
     &         [  1d0,  1d0]
     &       )
        else
        call register_lumi_pine(
     &         [    2,    8,   15,   23,   35,   40,   48,   63,
     &             78,   93,  100,  107,  116,  136,  156,  167,
     &            182,  193,  206,  221,  236,  243,  250,  265,
     &            273,  293,  313,  333,  344,  359,  370,  385,
     &            396,  410,  433,  456,  479,  502,  525],
     &         4,
     &         [    2,   -1,    2,   -3,    4,   -1,    4,   -3],
     &         [ CKM(2,1), CKM(2,3), CKM(4,1), CKM(4,3)]
     &       )
        end if

!       [0, 20]
        call register_lumi_pine(
     &         [    3,    9,   16,   49,   64,   79,   94,  101,
     &            108,  117,  137,  157,  169,  183,  195,  207,
     &            222,  237,  244,  251,  266,  287,  307,  327,
     &            340,  366,  392,  411,  434,  457,  480,  503,
     &            526],
     &         2,
     &         [   21,    2,   21,    4],
     &         [  1d0,  1d0]
     &       )

!       [-40, 20]
        if ( .not. ckmflag ) then
        call register_lumi_pine(
     &         [    4,   10,   17,   26,   37,   42,   50,   65,
     &             80,   95,  102,  109,  120,  140,  159,  170,
     &            185,  196,  208,  223,  238,  245,  252,  267,
     &            276,  296,  316,  335,  346,  361,  372,  387,
     &            398,  412,  435,  458,  481,  504,  527],
     &         2,
     &         [   -1,    2,   -3,    4],
     &         [  1d0,  1d0]
     &       )
        else
        call register_lumi_pine(
     &         [    4,   10,   17,   26,   37,   42,   50,   65,
     &             80,   95,  102,  109,  120,  140,  159,  170,
     &            185,  196,  208,  223,  238,  245,  252,  267,
     &            276,  296,  316,  335,  346,  361,  372,  387,
     &            398,  412,  435,  458,  481,  504,  527],
     &         4,
     &         [   -1,    2,   -1,    4,   -3,    2,   -3,    4],
     &         [ CKM(1,2), CKM(1,4), CKM(3,2), CKM(3,4)]
     &       )
        end if

!       [0, -40]
        call register_lumi_pine(
     &         [    5,   12,   19,   51,   66,   81,   97,  104,
     &            111,  123,  143,  161,  172,  187,  198,  210,
     &            225,  240,  247,  254,  269,  288,  308,  328,
     &            354,  380,  406,  413,  436,  459,  482,  505,
     &            528],
     &         2,
     &         [   21,   -1,   21,   -3],
     &         [  1d0,  1d0]
     &       )

!       [-40, 0]
        call register_lumi_pine(
     &         [    6,   13,   20,   52,   67,   82,   98,  105,
     &            112,  126,  146,  163,  174,  189,  200,  211,
     &            226,  241,  248,  255,  270,  290,  310,  330,
     &            352,  378,  404,  414,  437,  460,  483,  506,
     &            529],
     &         2,
     &         [   -1,   21,   -3,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 0]
        call register_lumi_pine(
     &         [   11,   18,   57,   72,   87,   96,  103,  110,
     &            209,  224,  239,  246,  253,  268,  423,  446,
     &            469,  494,  517,  540],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [21, -31]
        call register_lumi_pine(
     &         [   21,   59,   74,   89,  114,  134,  217,  232,
     &            261,  271,  291,  311,  426,  449,  472,  496,
     &            519,  542],
     &         10,
     &         [    2,   -1,    2,   -2,    2,   -3,    2,   -4,
     &              2,   -5,    4,   -1,    4,   -2,    4,   -3,
     &              4,   -4,    4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [21, 31]
        call register_lumi_pine(
     &         [   22,   58,   73,   88,  115,  135,  216,  231,
     &            260,  272,  292,  312,  425,  448,  471,  495,
     &            518,  541],
     &         10,
     &         [    2,    1,    2,    2,    2,    3,    2,    4,
     &              2,    5,    4,    1,    4,    2,    4,    3,
     &              4,    4,    4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-31, 21]
        call register_lumi_pine(
     &         [   24,   55,   70,   85,  118,  138,  214,  229,
     &            258,  274,  294,  314,  417,  440,  463,  488,
     &            511,  534],
     &         10,
     &         [   -1,    2,   -1,    4,   -2,    2,   -2,    4,
     &             -3,    2,   -3,    4,   -4,    2,   -4,    4,
     &             -5,    2,   -5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [31, 21]
        call register_lumi_pine(
     &         [   25,   53,   68,   83,  119,  139,  212,  227,
     &            256,  275,  295,  315,  415,  438,  461,  485,
     &            508,  531],
     &         10,
     &         [    1,    2,    1,    4,    2,    2,    2,    4,
     &              3,    2,    3,    4,    4,    2,    4,    4,
     &              5,    2,    5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-30, 30]
        call register_lumi_pine(
     &         [   27,  127,  147,  277,  297,  317],
     &         5,
     &         [   -1,    1,   -2,    2,   -3,    3,   -4,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-31, -41]
        call register_lumi_pine(
     &         [   28,   56,   71,   86,  128,  148,  215,  230,
     &            259,  278,  298,  318,  418,  441,  464,  489,
     &            512,  535],
     &         10,
     &         [   -1,   -1,   -1,   -3,   -2,   -1,   -2,   -3,
     &             -3,   -1,   -3,   -3,   -4,   -1,   -4,   -3,
     &             -5,   -1,   -5,   -3],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [30, -30]
        call register_lumi_pine(
     &         [   29,  129,  149,  279,  299,  319],
     &         5,
     &         [    1,   -1,    2,   -2,    3,   -3,    4,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-41, -31]
        call register_lumi_pine(
     &         [   30,   61,   76,   91,  130,  150,  219,  234,
     &            263,  280,  300,  320,  428,  451,  474,  498,
     &            521,  544],
     &         10,
     &         [   -1,   -1,   -1,   -2,   -1,   -3,   -1,   -4,
     &             -1,   -5,   -3,   -1,   -3,   -2,   -3,   -3,
     &             -3,   -4,   -3,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [31, -41]
        call register_lumi_pine(
     &         [   31,   54,   69,   84,  131,  151,  213,  228,
     &            257,  281,  301,  321,  416,  439,  462,  486,
     &            509,  532],
     &         10,
     &         [    1,   -1,    1,   -3,    2,   -1,    2,   -3,
     &              3,   -1,    3,   -3,    4,   -1,    4,   -3,
     &              5,   -1,    5,   -3],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-41, 31]
        call register_lumi_pine(
     &         [   32,   60,   75,   90,  132,  152,  218,  233,
     &            262,  282,  302,  322,  427,  450,  473,  497,
     &            520,  543],
     &         10,
     &         [   -1,    1,   -1,    2,   -1,    3,   -1,    4,
     &             -1,    5,   -3,    1,   -3,    2,   -3,    3,
     &             -3,    4,   -3,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [   33,  154,  180,  331,  357,  383],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [20, 20]
        call register_lumi_pine(
     &         [   34,  155,  181,  332,  358,  384],
     &         2,
     &         [    2,    2,    4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [   36,  158,  184,  334,  360,  386],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-20, -40]
        call register_lumi_pine(
     &         [   38,  164,  190,  336,  362,  388,  430,  453,
     &            476,  500,  523,  546],
     &         2,
     &         [   -2,   -1,   -4,   -3],
     &         [  1d0,  1d0]
     &       )

!       [-40, -20]
        call register_lumi_pine(
     &         [   39,  165,  191,  337,  363,  389,  421,  444,
     &            467,  491,  514,  537],
     &         2,
     &         [   -1,   -2,   -3,   -4],
     &         [  1d0,  1d0]
     &       )

!       [20, 40]
        call register_lumi_pine(
     &         [   41,  168,  194,  345,  371,  397,  429,  452,
     &            475,  499,  522,  545],
     &         2,
     &         [    2,    1,    4,    3],
     &         [  1d0,  1d0]
     &       )

!       [40, 20]
        call register_lumi_pine(
     &         [   43,  171,  197,  347,  373,  399,  420,  443,
     &            466,  490,  513,  536],
     &         2,
     &         [    1,    2,    3,    4],
     &         [  1d0,  1d0]
     &       )

!       [-40, 40]
        call register_lumi_pine(
     &         [   44,  176,  202,  348,  374,  400],
     &         2,
     &         [   -1,    1,   -3,    3],
     &         [  1d0,  1d0]
     &       )

!       [-40, -40]
        call register_lumi_pine(
     &         [   45,  177,  203,  349,  375,  401],
     &         2,
     &         [   -1,   -1,   -3,   -3],
     &         [  1d0,  1d0]
     &       )

!       [40, -40]
        call register_lumi_pine(
     &         [   46,  178,  204,  350,  376,  402],
     &         2,
     &         [    1,   -1,    3,   -3],
     &         [  1d0,  1d0]
     &       )

!       [0, -30]
        call register_lumi_pine(
     &         [  121,  141,  286,  306,  326,  493,  516,  539],
     &         5,
     &         [   21,   -1,   21,   -2,   21,   -3,   21,   -4,
     &             21,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, 30]
        call register_lumi_pine(
     &         [  122,  142,  285,  305,  325,  492,  515,  538],
     &         5,
     &         [   21,    1,   21,    2,   21,    3,   21,    4,
     &             21,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 0]
        call register_lumi_pine(
     &         [  124,  144,  284,  304,  324,  487,  510,  533],
     &         5,
     &         [   -1,   21,   -2,   21,   -3,   21,   -4,   21,
     &             -5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [30, 0]
        call register_lumi_pine(
     &         [  125,  145,  283,  303,  323,  484,  507,  530],
     &         5,
     &         [    1,   21,    2,   21,    3,   21,    4,   21,
     &              5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [  160,  186,  341,  355,  367,  381,  393,  407,
     &            424,  447,  470],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [  162,  188,  343,  356,  369,  382,  395,  408,
     &            431,  454,  477],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 40]
        call register_lumi_pine(
     &         [  173,  199,  339,  353,  365,  379,  391,  405,
     &            422,  445,  468],
     &         2,
     &         [   21,    1,   21,    3],
     &         [  1d0,  1d0]
     &       )

!       [40, 0]
        call register_lumi_pine(
     &         [  175,  201,  338,  351,  364,  377,  390,  403,
     &            419,  442,  465],
     &         2,
     &         [    1,   21,    3,   21],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiWpJ


#endif


