      subroutine getqcdnormWmJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      real(8) :: fac_ckm
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtWmJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVWmJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourWmJ(current_chan)
         do isub = 1, nflavourWmJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_WmJ(current_chan, isub, ipass_sub, flav_block, fac_ckm)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           partons_sub = fac_ckm*partons_sub
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=WmJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param()/stw)**2*(nc**2-1)
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d g -> u lm nub         B1g0W
      case(2)
         factor=facB                        ! d ub -> g lm nub        B1g0W
      case(3)
         factor=facB                        ! g d -> u lm nub         B1g0W
      case(4)
         factor=facB                        ! ub d -> g lm nub        B1g0W
      case(5)
         factor=facB                        ! g ub -> db lm nub       B1g0W
      case(6)
         factor=facB                        ! ub g -> db lm nub       B1g0W

c -- real

      case(7)
         factor=facR                        ! d g -> g u lm nub       B2g0W
      case(8)
         factor=1d0/2d0*facR                ! d ub -> g g lm nub      B2g0W
      case(9)
         factor=facR                        ! g d -> g u lm nub       B2g0W
      case(10)
         factor=1d0/2d0*facR                ! ub d -> g g lm nub      B2g0W
      case(11)
         factor=nup*facR                    ! g g -> db u lm nub      B2g0W
      case(12)
         factor=facR                        ! g ub -> db g lm nub     B2g0W
      case(13)
         factor=facR                        ! ub g -> db g lm nub     B2g0W
      case(14)
         factor=-1d0/nc**2*facR             ! d gt -> gt u lm nub     Bt2g0W
      case(15)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d ub -> gt gt lm nub     Bt2g0W
      case(16)
         factor=-1d0/nc**2*facR             ! gt d -> gt u lm nub     Bt2g0W
      case(17)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub d -> gt gt lm nub     Bt2g0W
      case(18)
         factor=-1d0/nc**2*nup*facR         ! gt gt -> db u lm nub     Bt2g0W
      case(19)
         factor=-1d0/nc**2*facR             ! gt ub -> db gt lm nub     Bt2g0W
      case(20)
         factor=-1d0/nc**2*facR             ! ub gt -> db gt lm nub     Bt2g0W
      case(21)
         factor=1d0/nc*facR                 ! d Qb -> Qb u lm nub     C0g0W
      case(22)
         factor=1d0/nc*facR                 ! d Q -> Q u lm nub       C0g0W
      case(23)
         factor=1d0/nc*nf*facR              ! d ub -> Q Qb lm nub     C0g0W
      case(24)
         factor=1d0/nc*facR                 ! Qb d -> Qb u lm nub     C0g0W
      case(25)
         factor=1d0/nc*facR                 ! Q d -> Q u lm nub       C0g0W
      case(26)
         factor=1d0/nc*nf*facR              ! ub d -> Q Qb lm nub     C0g0W
      case(27)
         factor=1d0/nc*nup*facR             ! Qb Q -> db u lm nub     C0g0W
      case(28)
         factor=1d0/nc*facR                 ! Qb ub -> db Qb lm nub     C0g0W
      case(29)
         factor=1d0/nc*nup*facR             ! Q Qb -> db u lm nub     C0g0W
      case(30)
         factor=1d0/nc*facR                 ! ub Qb -> db Qb lm nub     C0g0W
      case(31)
         factor=1d0/nc*facR                 ! Q ub -> db Q lm nub     C0g0W
      case(32)
         factor=1d0/nc*facR                 ! ub Q -> db Q lm nub     C0g0W
      case(33)
         factor=-1d0/nc**2*facR             ! d db -> db u lm nub     D0g0Wa
      case(34)
         factor=-1d0/nc**2*facR             ! d d -> d u lm nub       D0g0Wa
      case(35)
         factor=-1d0/nc**2*facR             ! d ub -> d db lm nub     D0g0Wa
      case(36)
         factor=-1d0/nc**2*facR             ! db d -> db u lm nub     D0g0Wa
      case(37)
         factor=-1d0/nc**2*facR             ! ub d -> d db lm nub     D0g0Wa
      case(38)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db ub -> db db lm nub     D0g0Wa
      case(39)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub db -> db db lm nub     D0g0Wa
      case(40)
         factor=-1d0/nc**2*facR             ! d ub -> ub u lm nub     D0g0Wb
      case(41)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d u -> u u lm nub       D0g0Wb
      case(42)
         factor=-1d0/nc**2*facR             ! ub d -> ub u lm nub     D0g0Wb
      case(43)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u d -> u u lm nub       D0g0Wb
      case(44)
         factor=-1d0/nc**2*facR             ! ub u -> db u lm nub     D0g0Wb
      case(45)
         factor=-1d0/nc**2*facR             ! ub ub -> db ub lm nub     D0g0Wb
      case(46)
         factor=-1d0/nc**2*facR             ! u ub -> db u lm nub     D0g0Wb

c -- virtual

      case(47)
         factor=facV                        ! d g -> u lm nub         B1g1W
      case(48)
         factor=facV                        ! d ub -> g lm nub        B1g1W
      case(49)
         factor=facV                        ! g d -> u lm nub         B1g1W
      case(50)
         factor=facV                        ! ub d -> g lm nub        B1g1W
      case(51)
         factor=facV                        ! g ub -> db lm nub       B1g1W
      case(52)
         factor=facV                        ! ub g -> db lm nub       B1g1W
      case(53)
         factor=1d0/nc*facV                 ! Q d subtraction         B1g1W
      case(54)
         factor=1d0/nc*facV                 ! Q ub subtraction        B1g1W
      case(55)
         factor=1d0/nc*facV                 ! Qb d subtraction        B1g1W
      case(56)
         factor=1d0/nc*facV                 ! Qb ub subtraction       B1g1W
      case(57)
         factor=nup*facV                    ! g g subtraction         B1g1W
      case(58)
         factor=1d0/nc*facV                 ! d Q subtraction         B1g1W
      case(59)
         factor=1d0/nc*facV                 ! d Qb subtraction        B1g1W
      case(60)
         factor=1d0/nc*facV                 ! ub Q subtraction        B1g1W
      case(61)
         factor=1d0/nc*facV                 ! ub Qb subtraction       B1g1W
      case(62)
         factor=-1d0/nc**2*facV             ! d g -> u lm nub         Bt1g1W
      case(63)
         factor=-1d0/nc**2*facV             ! d ub -> g lm nub        Bt1g1W
      case(64)
         factor=-1d0/nc**2*facV             ! g d -> u lm nub         Bt1g1W
      case(65)
         factor=-1d0/nc**2*facV             ! ub d -> g lm nub        Bt1g1W
      case(66)
         factor=-1d0/nc**2*facV             ! g ub -> db lm nub       Bt1g1W
      case(67)
         factor=-1d0/nc**2*facV             ! ub g -> db lm nub       Bt1g1W
      case(68)
         factor=-1d0/nc**3*facV             ! Q d subtraction         Bt1g1W
      case(69)
         factor=-1d0/nc**3*facV             ! Q ub subtraction        Bt1g1W
      case(70)
         factor=-1d0/nc**3*facV             ! Qb d subtraction        Bt1g1W
      case(71)
         factor=-1d0/nc**3*facV             ! Qb ub subtraction       Bt1g1W
      case(72)
         factor=-1d0/nc**2*nup*facV         ! g g subtraction         Bt1g1W
      case(73)
         factor=-1d0/nc**3*facV             ! d Q subtraction         Bt1g1W
      case(74)
         factor=-1d0/nc**3*facV             ! d Qb subtraction        Bt1g1W
      case(75)
         factor=-1d0/nc**3*facV             ! ub Q subtraction        Bt1g1W
      case(76)
         factor=-1d0/nc**3*facV             ! ub Qb subtraction       Bt1g1W
      case(77)
         factor=1d0/nc*nf*facV              ! d g -> u lm nub         Bh1g1W
      case(78)
         factor=1d0/nc*nf*facV              ! d ub -> g lm nub        Bh1g1W
      case(79)
         factor=1d0/nc*nf*facV              ! g d -> u lm nub         Bh1g1W
      case(80)
         factor=1d0/nc*nf*facV              ! ub d -> g lm nub        Bh1g1W
      case(81)
         factor=1d0/nc*nf*facV              ! g ub -> db lm nub       Bh1g1W
      case(82)
         factor=1d0/nc*nf*facV              ! ub g -> db lm nub       Bh1g1W
      case(83)
         factor=1d0/nc**2*nf*facV           ! Q d subtraction         Bh1g1W
      case(84)
         factor=1d0/nc**2*nf*facV           ! Q ub subtraction        Bh1g1W
      case(85)
         factor=1d0/nc**2*nf*facV           ! Qb d subtraction        Bh1g1W
      case(86)
         factor=1d0/nc**2*nf*facV           ! Qb ub subtraction       Bh1g1W
      case(87)
         factor=1d0/nc*nf*nup*facV          ! g g subtraction         Bh1g1W
      case(88)
         factor=1d0/nc**2*nf*facV           ! d Q subtraction         Bh1g1W
      case(89)
         factor=1d0/nc**2*nf*facV           ! d Qb subtraction        Bh1g1W
      case(90)
         factor=1d0/nc**2*nf*facV           ! ub Q subtraction        Bh1g1W
      case(91)
         factor=1d0/nc**2*nf*facV           ! ub Qb subtraction       Bh1g1W

c -- double real

      case(92)
         factor=1d0/2d0*facRR               ! d g -> g g u lm nub     sB3g0W
      case(93)
         factor=1d0/6d0*facRR               ! d ub -> g g g lm nub     sB3g0W
      case(94)
         factor=1d0/2d0*facRR               ! g d -> g g u lm nub     sB3g0W
      case(95)
         factor=1d0/6d0*facRR               ! ub d -> g g g lm nub     sB3g0W
      case(96)
         factor=nup*facRR                   ! g g -> db g u lm nub     sB3g0W
      case(97)
         factor=1d0/2d0*facRR               ! g ub -> db g g lm nub     sB3g0W
      case(98)
         factor=1d0/2d0*facRR               ! ub g -> db g g lm nub     sB3g0W
      case(99)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d g -> g g u lm nub     sBt3g0W
      case(100)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! d ub -> g g g lm nub     sBt3g0W
      case(101)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g d -> g g u lm nub     sBt3g0W
      case(102)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! ub d -> g g g lm nub     sBt3g0W
      case(103)
         factor=-1d0/nc**2*nup*facRR        ! g g -> db g u lm nub     sBt3g0W
      case(104)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g ub -> db g g lm nub     sBt3g0W
      case(105)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub g -> db g g lm nub     sBt3g0W
      case(106)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! d gt -> gt gt u lm nub     sBtt3g0W
      case(107)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! d ub -> gt gt gt lm nub     sBtt3g0W
      case(108)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! gt d -> gt gt u lm nub     sBtt3g0W
      case(109)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! ub d -> gt gt gt lm nub     sBtt3g0W
      case(110)
         factor=(nc**2+1d0)/nc**4*nup*facRR   ! gt gt -> db gt u lm nub     sBtt3g0W
      case(111)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! gt ub -> db gt gt lm nub     sBtt3g0W
      case(112)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! ub gt -> db gt gt lm nub     sBtt3g0W
      case(113)
         factor=1d0/nc*nf*facRR             ! d g -> Q Qb u lm nub     sC1g0W
      case(114)
         factor=1d0/nc*facRR                ! d Qb -> g Qb u lm nub     sC1g0W
      case(115)
         factor=1d0/nc*facRR                ! d Q -> g Q u lm nub     sC1g0W
      case(116)
         factor=1d0/nc*nf*facRR             ! d ub -> g Q Qb lm nub     sC1g0W
      case(117)
         factor=1d0/nc*nf*facRR             ! g d -> Q Qb u lm nub     sC1g0W
      case(118)
         factor=1d0/nc*facRR                ! Qb d -> g Qb u lm nub     sC1g0W
      case(119)
         factor=1d0/nc*facRR                ! Q d -> g Q u lm nub     sC1g0W
      case(120)
         factor=1d0/nc*nf*facRR             ! ub d -> g Q Qb lm nub     sC1g0W
      case(121)
         factor=1d0/nc*nup*facRR            ! g Qb -> db Qb u lm nub     sC1g0W
      case(122)
         factor=1d0/nc*nup*facRR            ! g Q -> db Q u lm nub     sC1g0W
      case(123)
         factor=1d0/nc*nf*facRR             ! g ub -> db Q Qb lm nub     sC1g0W
      case(124)
         factor=1d0/nc*nup*facRR            ! Qb g -> db Qb u lm nub     sC1g0W
      case(125)
         factor=1d0/nc*nup*facRR            ! Q g -> db Q u lm nub     sC1g0W
      case(126)
         factor=1d0/nc*nf*facRR             ! ub g -> db Q Qb lm nub     sC1g0W
      case(127)
         factor=1d0/nc*nup*facRR            ! Qb Q -> db g u lm nub     sC1g0W
      case(128)
         factor=1d0/nc*facRR                ! Qb ub -> db g Qb lm nub     sC1g0W
      case(129)
         factor=1d0/nc*nup*facRR            ! Q Qb -> db g u lm nub     sC1g0W
      case(130)
         factor=1d0/nc*facRR                ! ub Qb -> db g Qb lm nub     sC1g0W
      case(131)
         factor=1d0/nc*facRR                ! Q ub -> db g Q lm nub     sC1g0W
      case(132)
         factor=1d0/nc*facRR                ! ub Q -> db g Q lm nub     sC1g0W
      case(133)
         factor=1d0/nc**3*nf*facRR          ! d g -> Q Qb u lm nub     sCt1g0W
      case(134)
         factor=1d0/nc**3*facRR             ! d Qb -> g Qb u lm nub     sCt1g0W
      case(135)
         factor=1d0/nc**3*facRR             ! d Q -> g Q u lm nub     sCt1g0W
      case(136)
         factor=1d0/nc**3*nf*facRR          ! d ub -> g Q Qb lm nub     sCt1g0W
      case(137)
         factor=1d0/nc**3*nf*facRR          ! g d -> Q Qb u lm nub     sCt1g0W
      case(138)
         factor=1d0/nc**3*facRR             ! Qb d -> g Qb u lm nub     sCt1g0W
      case(139)
         factor=1d0/nc**3*facRR             ! Q d -> g Q u lm nub     sCt1g0W
      case(140)
         factor=1d0/nc**3*nf*facRR          ! ub d -> g Q Qb lm nub     sCt1g0W
      case(141)
         factor=1d0/nc**3*nup*facRR         ! g Qb -> db Qb u lm nub     sCt1g0W
      case(142)
         factor=1d0/nc**3*nup*facRR         ! g Q -> db Q u lm nub     sCt1g0W
      case(143)
         factor=1d0/nc**3*nf*facRR          ! g ub -> db Q Qb lm nub     sCt1g0W
      case(144)
         factor=1d0/nc**3*nup*facRR         ! Qb g -> db Qb u lm nub     sCt1g0W
      case(145)
         factor=1d0/nc**3*nup*facRR         ! Q g -> db Q u lm nub     sCt1g0W
      case(146)
         factor=1d0/nc**3*nf*facRR          ! ub g -> db Q Qb lm nub     sCt1g0W
      case(147)
         factor=1d0/nc**3*nup*facRR         ! Qb Q -> db g u lm nub     sCt1g0W
      case(148)
         factor=1d0/nc**3*facRR             ! Qb ub -> db g Qb lm nub     sCt1g0W
      case(149)
         factor=1d0/nc**3*nup*facRR         ! Q Qb -> db g u lm nub     sCt1g0W
      case(150)
         factor=1d0/nc**3*facRR             ! ub Qb -> db g Qb lm nub     sCt1g0W
      case(151)
         factor=1d0/nc**3*facRR             ! Q ub -> db g Q lm nub     sCt1g0W
      case(152)
         factor=1d0/nc**3*facRR             ! ub Q -> db g Q lm nub     sCt1g0W
      case(153)
         factor=-1d0/nc**2*facRR            ! d g -> d db u lm nub     D1g0Wmac
      case(154)
         factor=-1d0/nc**2*facRR            ! d db -> g db u lm nub     D1g0Wmac
      case(155)
         factor=-1d0/nc**2*facRR            ! d d -> g d u lm nub     D1g0Wmac
      case(156)
         factor=-1d0/nc**2*facRR            ! d ub -> g d db lm nub     D1g0Wmac
      case(157)
         factor=-1d0/nc**2*facRR            ! g d -> d db u lm nub     D1g0Wmac
      case(158)
         factor=-1d0/nc**2*facRR            ! db d -> g db u lm nub     D1g0Wmac
      case(159)
         factor=-1d0/nc**2*facRR            ! ub d -> g d db lm nub     D1g0Wmac
      case(160)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g db -> db db u lm nub     D1g0Wmac
      case(161)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g ub -> db d db lm nub     D1g0Wmac
      case(162)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db g -> db db u lm nub     D1g0Wmac
      case(163)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub g -> db d db lm nub     D1g0Wmac
      case(164)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db ub -> db g db lm nub     D1g0Wmac
      case(165)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub db -> db g db lm nub     D1g0Wmac
      case(166)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d g -> u ub u lm nub     D1g0Wmbc
      case(167)
         factor=-1d0/nc**2*facRR            ! d ub -> g ub u lm nub     D1g0Wmbc
      case(168)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d u -> g u u lm nub     D1g0Wmbc
      case(169)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g d -> u ub u lm nub     D1g0Wmbc
      case(170)
         factor=-1d0/nc**2*facRR            ! ub d -> g ub u lm nub     D1g0Wmbc
      case(171)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u d -> g u u lm nub     D1g0Wmbc
      case(172)
         factor=-1d0/nc**2*facRR            ! g ub -> db ub u lm nub     D1g0Wmbc
      case(173)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g u -> db u u lm nub     D1g0Wmbc
      case(174)
         factor=-1d0/nc**2*facRR            ! ub g -> db ub u lm nub     D1g0Wmbc
      case(175)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u g -> db u u lm nub     D1g0Wmbc
      case(176)
         factor=-1d0/nc**2*facRR            ! ub u -> db g u lm nub     D1g0Wmbc
      case(177)
         factor=-1d0/nc**2*facRR            ! ub ub -> db g ub lm nub     D1g0Wmbc
      case(178)
         factor=-1d0/nc**2*facRR            ! u ub -> db g u lm nub     D1g0Wmbc
      case(179)
         factor=1d0/nc**4*facRR             ! d g -> d db u lm nub     Dt1g0Wma
      case(180)
         factor=1d0/nc**4*facRR             ! d db -> g db u lm nub     Dt1g0Wma
      case(181)
         factor=1d0/nc**4*facRR             ! d d -> g d u lm nub     Dt1g0Wma
      case(182)
         factor=1d0/nc**4*facRR             ! d ub -> g d db lm nub     Dt1g0Wma
      case(183)
         factor=1d0/nc**4*facRR             ! g d -> d db u lm nub     Dt1g0Wma
      case(184)
         factor=1d0/nc**4*facRR             ! db d -> g db u lm nub     Dt1g0Wma
      case(185)
         factor=1d0/nc**4*facRR             ! ub d -> g d db lm nub     Dt1g0Wma
      case(186)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g db -> db db u lm nub     Dt1g0Wma
      case(187)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g ub -> db d db lm nub     Dt1g0Wma
      case(188)
         factor=1d0/nc**4*1d0/2d0*facRR     ! db g -> db db u lm nub     Dt1g0Wma
      case(189)
         factor=1d0/nc**4*1d0/2d0*facRR     ! ub g -> db d db lm nub     Dt1g0Wma
      case(190)
         factor=1d0/nc**4*1d0/2d0*facRR     ! db ub -> db g db lm nub     Dt1g0Wma
      case(191)
         factor=1d0/nc**4*1d0/2d0*facRR     ! ub db -> db g db lm nub     Dt1g0Wma
      case(192)
         factor=1d0/nc**4*1d0/2d0*facRR     ! d g -> u ub u lm nub     Dt1g0Wmb
      case(193)
         factor=1d0/nc**4*facRR             ! d ub -> g ub u lm nub     Dt1g0Wmb
      case(194)
         factor=1d0/nc**4*1d0/2d0*facRR     ! d u -> g u u lm nub     Dt1g0Wmb
      case(195)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g d -> u ub u lm nub     Dt1g0Wmb
      case(196)
         factor=1d0/nc**4*facRR             ! ub d -> g ub u lm nub     Dt1g0Wmb
      case(197)
         factor=1d0/nc**4*1d0/2d0*facRR     ! u d -> g u u lm nub     Dt1g0Wmb
      case(198)
         factor=1d0/nc**4*facRR             ! g ub -> db ub u lm nub     Dt1g0Wmb
      case(199)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g u -> db u u lm nub     Dt1g0Wmb
      case(200)
         factor=1d0/nc**4*facRR             ! ub g -> db ub u lm nub     Dt1g0Wmb
      case(201)
         factor=1d0/nc**4*1d0/2d0*facRR     ! u g -> db u u lm nub     Dt1g0Wmb
      case(202)
         factor=1d0/nc**4*facRR             ! ub u -> db g u lm nub     Dt1g0Wmb
      case(203)
         factor=1d0/nc**4*facRR             ! ub ub -> db g ub lm nub     Dt1g0Wmb
      case(204)
         factor=1d0/nc**4*facRR             ! u ub -> db g u lm nub     Dt1g0Wmb

c -- real virtual

      case(205)
         factor=facRV                       ! d g -> g u lm nub       sB2g1W
      case(206)
         factor=1d0/2d0*facRV               ! d ub -> g g lm nub      sB2g1W
      case(207)
         factor=facRV                       ! g d -> g u lm nub       sB2g1W
      case(208)
         factor=1d0/2d0*facRV               ! ub d -> g g lm nub      sB2g1W
      case(209)
         factor=nup*facRV                   ! g g -> db u lm nub      sB2g1W
      case(210)
         factor=facRV                       ! g ub -> db g lm nub     sB2g1W
      case(211)
         factor=facRV                       ! ub g -> db g lm nub     sB2g1W
      case(212)
         factor=1d0/nc*facRV                ! Q d subtraction         sB2g1W
      case(213)
         factor=1d0/nc*facRV                ! Q ub subtraction        sB2g1W
      case(214)
         factor=1d0/nc*facRV                ! Qb d subtraction        sB2g1W
      case(215)
         factor=1d0/nc*facRV                ! Qb ub subtraction       sB2g1W
      case(216)
         factor=1d0/nc*facRV                ! d Q subtraction         sB2g1W
      case(217)
         factor=1d0/nc*facRV                ! d Qb subtraction        sB2g1W
      case(218)
         factor=1d0/nc*facRV                ! ub Q subtraction        sB2g1W
      case(219)
         factor=1d0/nc*facRV                ! ub Qb subtraction       sB2g1W
      case(220)
         factor=-1d0/nc**2*facRV            ! d g -> g u lm nub       sBt2g1W
      case(221)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! d ub -> g g lm nub      sBt2g1W
      case(222)
         factor=-1d0/nc**2*facRV            ! g d -> g u lm nub       sBt2g1W
      case(223)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! ub d -> g g lm nub      sBt2g1W
      case(224)
         factor=-1d0/nc**2*nup*facRV        ! g g -> db u lm nub      sBt2g1W
      case(225)
         factor=-1d0/nc**2*facRV            ! g ub -> db g lm nub     sBt2g1W
      case(226)
         factor=-1d0/nc**2*facRV            ! ub g -> db g lm nub     sBt2g1W
      case(227)
         factor=-1d0/nc**3*facRV            ! Q d subtraction         sBt2g1W
      case(228)
         factor=-1d0/nc**3*facRV            ! Q ub subtraction        sBt2g1W
      case(229)
         factor=-1d0/nc**3*facRV            ! Qb d subtraction        sBt2g1W
      case(230)
         factor=-1d0/nc**3*facRV            ! Qb ub subtraction       sBt2g1W
      case(231)
         factor=-1d0/nc**3*facRV            ! d Q subtraction         sBt2g1W
      case(232)
         factor=-1d0/nc**3*facRV            ! d Qb subtraction        sBt2g1W
      case(233)
         factor=-1d0/nc**3*facRV            ! ub Q subtraction        sBt2g1W
      case(234)
         factor=-1d0/nc**3*facRV            ! ub Qb subtraction       sBt2g1W
      case(235)
         factor=-1d0/nc**2*facRV            ! d gt -> gt u lm nub     sBtt2g1Wc
      case(236)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! d ub -> gt gt lm nub     sBtt2g1Wc
      case(237)
         factor=-1d0/nc**2*facRV            ! gt d -> gt u lm nub     sBtt2g1Wc
      case(238)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! ub d -> gt gt lm nub     sBtt2g1Wc
      case(239)
         factor=-1d0/nc**2*nup*facRV        ! gt gt -> db u lm nub     sBtt2g1Wc
      case(240)
         factor=-1d0/nc**2*facRV            ! gt ub -> db gt lm nub     sBtt2g1Wc
      case(241)
         factor=-1d0/nc**2*facRV            ! ub gt -> db gt lm nub     sBtt2g1Wc
      case(242)
         factor=1d0/nc**4*facRV             ! d gt -> gt u lm nub     sBttt2g1W
      case(243)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d ub -> gt gt lm nub     sBttt2g1W
      case(244)
         factor=1d0/nc**4*facRV             ! gt d -> gt u lm nub     sBttt2g1W
      case(245)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub d -> gt gt lm nub     sBttt2g1W
      case(246)
         factor=1d0/nc**4*nup*facRV         ! gt gt -> db u lm nub     sBttt2g1W
      case(247)
         factor=1d0/nc**4*facRV             ! gt ub -> db gt lm nub     sBttt2g1W
      case(248)
         factor=1d0/nc**4*facRV             ! ub gt -> db gt lm nub     sBttt2g1W
      case(249)
         factor=1d0/nc*nf*facRV             ! d g -> g u lm nub       sBh2g1W
      case(250)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! d ub -> g g lm nub      sBh2g1W
      case(251)
         factor=1d0/nc*nf*facRV             ! g d -> g u lm nub       sBh2g1W
      case(252)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! ub d -> g g lm nub      sBh2g1W
      case(253)
         factor=1d0/nc*nf*nup*facRV         ! g g -> db u lm nub      sBh2g1W
      case(254)
         factor=1d0/nc*nf*facRV             ! g ub -> db g lm nub     sBh2g1W
      case(255)
         factor=1d0/nc*nf*facRV             ! ub g -> db g lm nub     sBh2g1W
      case(256)
         factor=1d0/nc**2*nf*facRV          ! Q d subtraction         sBh2g1W
      case(257)
         factor=1d0/nc**2*nf*facRV          ! Q ub subtraction        sBh2g1W
      case(258)
         factor=1d0/nc**2*nf*facRV          ! Qb d subtraction        sBh2g1W
      case(259)
         factor=1d0/nc**2*nf*facRV          ! Qb ub subtraction       sBh2g1W
      case(260)
         factor=1d0/nc**2*nf*facRV          ! d Q subtraction         sBh2g1W
      case(261)
         factor=1d0/nc**2*nf*facRV          ! d Qb subtraction        sBh2g1W
      case(262)
         factor=1d0/nc**2*nf*facRV          ! ub Q subtraction        sBh2g1W
      case(263)
         factor=1d0/nc**2*nf*facRV          ! ub Qb subtraction       sBh2g1W
      case(264)
         factor=-1d0/nc**3*nf*facRV         ! d gt -> gt u lm nub     sBth2g1W
      case(265)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! d ub -> gt gt lm nub     sBth2g1W
      case(266)
         factor=-1d0/nc**3*nf*facRV         ! gt d -> gt u lm nub     sBth2g1W
      case(267)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! ub d -> gt gt lm nub     sBth2g1W
      case(268)
         factor=-1d0/nc**3*nf*nup*facRV     ! gt gt -> db u lm nub     sBth2g1W
      case(269)
         factor=-1d0/nc**3*nf*facRV         ! gt ub -> db gt lm nub     sBth2g1W
      case(270)
         factor=-1d0/nc**3*nf*facRV         ! ub gt -> db gt lm nub     sBth2g1W
      case(271)
         factor=1d0/nc*facRV                ! d Qb -> Qb u lm nub     sC0g1W
      case(272)
         factor=1d0/nc*facRV                ! d Q -> Q u lm nub       sC0g1W
      case(273)
         factor=1d0/nc*nf*facRV             ! d ub -> Q Qb lm nub     sC0g1W
      case(274)
         factor=1d0/nc*facRV                ! Qb d -> Qb u lm nub     sC0g1W
      case(275)
         factor=1d0/nc*facRV                ! Q d -> Q u lm nub       sC0g1W
      case(276)
         factor=1d0/nc*nf*facRV             ! ub d -> Q Qb lm nub     sC0g1W
      case(277)
         factor=1d0/nc*nup*facRV            ! Qb Q -> db u lm nub     sC0g1W
      case(278)
         factor=1d0/nc*facRV                ! Qb ub -> db Qb lm nub     sC0g1W
      case(279)
         factor=1d0/nc*nup*facRV            ! Q Qb -> db u lm nub     sC0g1W
      case(280)
         factor=1d0/nc*facRV                ! ub Qb -> db Qb lm nub     sC0g1W
      case(281)
         factor=1d0/nc*facRV                ! Q ub -> db Q lm nub     sC0g1W
      case(282)
         factor=1d0/nc*facRV                ! ub Q -> db Q lm nub     sC0g1W
      case(283)
         factor=1d0/nc*nup*facRV            ! Q g subtraction         sC0g1W
      case(284)
         factor=1d0/nc*nup*facRV            ! Qb g subtraction        sC0g1W
      case(285)
         factor=1d0/nc*nup*facRV            ! g Q subtraction         sC0g1W
      case(286)
         factor=1d0/nc*nup*facRV            ! g Qb subtraction        sC0g1W
      case(287)
         factor=1d0/nc*nf*facRV             ! g d subtraction         sC0g1W
      case(288)
         factor=1d0/nc*nf*facRV             ! g ub subtraction        sC0g1W
      case(289)
         factor=1d0/nc*nf*facRV             ! d g subtraction         sC0g1W
      case(290)
         factor=1d0/nc*nf*facRV             ! ub g subtraction        sC0g1W
      case(291)
         factor=1d0/nc**3*facRV             ! d Qb -> Qb u lm nub     Ct0g1W
      case(292)
         factor=1d0/nc**3*facRV             ! d Q -> Q u lm nub       Ct0g1W
      case(293)
         factor=1d0/nc**3*nf*facRV          ! d ub -> Q Qb lm nub     Ct0g1W
      case(294)
         factor=1d0/nc**3*facRV             ! Qb d -> Qb u lm nub     Ct0g1W
      case(295)
         factor=1d0/nc**3*facRV             ! Q d -> Q u lm nub       Ct0g1W
      case(296)
         factor=1d0/nc**3*nf*facRV          ! ub d -> Q Qb lm nub     Ct0g1W
      case(297)
         factor=1d0/nc**3*nup*facRV         ! Qb Q -> db u lm nub     Ct0g1W
      case(298)
         factor=1d0/nc**3*facRV             ! Qb ub -> db Qb lm nub     Ct0g1W
      case(299)
         factor=1d0/nc**3*nup*facRV         ! Q Qb -> db u lm nub     Ct0g1W
      case(300)
         factor=1d0/nc**3*facRV             ! ub Qb -> db Qb lm nub     Ct0g1W
      case(301)
         factor=1d0/nc**3*facRV             ! Q ub -> db Q lm nub     Ct0g1W
      case(302)
         factor=1d0/nc**3*facRV             ! ub Q -> db Q lm nub     Ct0g1W
      case(303)
         factor=1d0/nc**3*nup*facRV         ! Q g subtraction         Ct0g1W
      case(304)
         factor=1d0/nc**3*nup*facRV         ! Qb g subtraction        Ct0g1W
      case(305)
         factor=1d0/nc**3*nup*facRV         ! g Q subtraction         Ct0g1W
      case(306)
         factor=1d0/nc**3*nup*facRV         ! g Qb subtraction        Ct0g1W
      case(307)
         factor=1d0/nc**3*nf*facRV          ! g d subtraction         Ct0g1W
      case(308)
         factor=1d0/nc**3*nf*facRV          ! g ub subtraction        Ct0g1W
      case(309)
         factor=1d0/nc**3*nf*facRV          ! d g subtraction         Ct0g1W
      case(310)
         factor=1d0/nc**3*nf*facRV          ! ub g subtraction        Ct0g1W
      case(311)
         factor=1d0/nc**2*nf*facRV          ! d Qb -> Qb u lm nub     Ch0g1W
      case(312)
         factor=1d0/nc**2*nf*facRV          ! d Q -> Q u lm nub       Ch0g1W
      case(313)
         factor=1d0/nc**2*nf*nf*facRV       ! d ub -> Q Qb lm nub     Ch0g1W
      case(314)
         factor=1d0/nc**2*nf*facRV          ! Qb d -> Qb u lm nub     Ch0g1W
      case(315)
         factor=1d0/nc**2*nf*facRV          ! Q d -> Q u lm nub       Ch0g1W
      case(316)
         factor=1d0/nc**2*nf*nf*facRV       ! ub d -> Q Qb lm nub     Ch0g1W
      case(317)
         factor=1d0/nc**2*nf*nup*facRV      ! Qb Q -> db u lm nub     Ch0g1W
      case(318)
         factor=1d0/nc**2*nf*facRV          ! Qb ub -> db Qb lm nub     Ch0g1W
      case(319)
         factor=1d0/nc**2*nf*nup*facRV      ! Q Qb -> db u lm nub     Ch0g1W
      case(320)
         factor=1d0/nc**2*nf*facRV          ! ub Qb -> db Qb lm nub     Ch0g1W
      case(321)
         factor=1d0/nc**2*nf*facRV          ! Q ub -> db Q lm nub     Ch0g1W
      case(322)
         factor=1d0/nc**2*nf*facRV          ! ub Q -> db Q lm nub     Ch0g1W
      case(323)
         factor=1d0/nc**2*nf*nup*facRV      ! Q g subtraction         Ch0g1W
      case(324)
         factor=1d0/nc**2*nf*nup*facRV      ! Qb g subtraction        Ch0g1W
      case(325)
         factor=1d0/nc**2*nf*nup*facRV      ! g Q subtraction         Ch0g1W
      case(326)
         factor=1d0/nc**2*nf*nup*facRV      ! g Qb subtraction        Ch0g1W
      case(327)
         factor=1d0/nc**2*nf**2*facRV       ! g d subtraction         Ch0g1W
      case(328)
         factor=1d0/nc**2*nf**2*facRV       ! g ub subtraction        Ch0g1W
      case(329)
         factor=1d0/nc**2*nf**2*facRV       ! d g subtraction         Ch0g1W
      case(330)
         factor=1d0/nc**2*nf**2*facRV       ! ub g subtraction        Ch0g1W
      case(331)
         factor=1d0/nc**2*facRV             ! d db -> db u lm nub     D0g1Wma
      case(332)
         factor=1d0/nc**2*facRV             ! d d -> d u lm nub       D0g1Wma
      case(333)
         factor=1d0/nc**2*facRV             ! d ub -> d db lm nub     D0g1Wma
      case(334)
         factor=1d0/nc**2*facRV             ! db d -> db u lm nub     D0g1Wma
      case(335)
         factor=1d0/nc**2*facRV             ! ub d -> d db lm nub     D0g1Wma
      case(336)
         factor=1d0/nc**2*1d0/2d0*facRV     ! db ub -> db db lm nub     D0g1Wma
      case(337)
         factor=1d0/nc**2*1d0/2d0*facRV     ! ub db -> db db lm nub     D0g1Wma
      case(338)
         factor=1d0/nc**2*facRV             ! d g subtraction         D0g1Wma
      case(339)
         factor=1d0/nc**2*facRV             ! db g subtraction        D0g1Wma
      case(340)
         factor=1d0/nc**2*facRV             ! g d subtraction         D0g1Wma
      case(341)
         factor=1d0/nc**2*facRV             ! g db subtraction        D0g1Wma
      case(342)
         factor=1d0/nc**2*facRV             ! g u subtraction         D0g1Wma
      case(343)
         factor=1d0/nc**2*facRV             ! u g subtraction         D0g1Wma
      case(344)
         factor=1d0/nc**2*facRV             ! d ub -> ub u lm nub     D0g1Wmb
      case(345)
         factor=1d0/nc**2*1d0/2d0*facRV     ! d u -> u u lm nub       D0g1Wmb
      case(346)
         factor=1d0/nc**2*facRV             ! ub d -> ub u lm nub     D0g1Wmb
      case(347)
         factor=1d0/nc**2*1d0/2d0*facRV     ! u d -> u u lm nub       D0g1Wmb
      case(348)
         factor=1d0/nc**2*facRV             ! ub u -> db u lm nub     D0g1Wmb
      case(349)
         factor=1d0/nc**2*facRV             ! ub ub -> db ub lm nub     D0g1Wmb
      case(350)
         factor=1d0/nc**2*facRV             ! u ub -> db u lm nub     D0g1Wmb
      case(351)
         factor=1d0/nc**2*facRV             ! db g subtraction        D0g1Wmb
      case(352)
         factor=1d0/nc**2*facRV             ! g db subtraction        D0g1Wmb
      case(353)
         factor=1d0/nc**2*facRV             ! g u subtraction         D0g1Wmb
      case(354)
         factor=1d0/nc**2*facRV             ! g ub subtraction        D0g1Wmb
      case(355)
         factor=1d0/nc**2*facRV             ! u g subtraction         D0g1Wmb
      case(356)
         factor=1d0/nc**2*facRV             ! ub g subtraction        D0g1Wmb
      case(357)
         factor=1d0/nc**4*facRV             ! d db -> db u lm nub     Dt0g1Wma
      case(358)
         factor=1d0/nc**4*facRV             ! d d -> d u lm nub       Dt0g1Wma
      case(359)
         factor=1d0/nc**4*facRV             ! d ub -> d db lm nub     Dt0g1Wma
      case(360)
         factor=1d0/nc**4*facRV             ! db d -> db u lm nub     Dt0g1Wma
      case(361)
         factor=1d0/nc**4*facRV             ! ub d -> d db lm nub     Dt0g1Wma
      case(362)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db ub -> db db lm nub     Dt0g1Wma
      case(363)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub db -> db db lm nub     Dt0g1Wma
      case(364)
         factor=1d0/nc**4*facRV             ! d g subtraction         Dt0g1Wma
      case(365)
         factor=1d0/nc**4*facRV             ! db g subtraction        Dt0g1Wma
      case(366)
         factor=1d0/nc**4*facRV             ! g d subtraction         Dt0g1Wma
      case(367)
         factor=1d0/nc**4*facRV             ! g db subtraction        Dt0g1Wma
      case(368)
         factor=1d0/nc**4*facRV             ! g u subtraction         Dt0g1Wma
      case(369)
         factor=1d0/nc**4*facRV             ! u g subtraction         Dt0g1Wma
      case(370)
         factor=1d0/nc**4*facRV             ! d ub -> ub u lm nub     Dt0g1Wmb
      case(371)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d u -> u u lm nub       Dt0g1Wmb
      case(372)
         factor=1d0/nc**4*facRV             ! ub d -> ub u lm nub     Dt0g1Wmb
      case(373)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u d -> u u lm nub       Dt0g1Wmb
      case(374)
         factor=1d0/nc**4*facRV             ! ub u -> db u lm nub     Dt0g1Wmb
      case(375)
         factor=1d0/nc**4*facRV             ! ub ub -> db ub lm nub     Dt0g1Wmb
      case(376)
         factor=1d0/nc**4*facRV             ! u ub -> db u lm nub     Dt0g1Wmb
      case(377)
         factor=1d0/nc**4*facRV             ! db g subtraction        Dt0g1Wmb
      case(378)
         factor=1d0/nc**4*facRV             ! g db subtraction        Dt0g1Wmb
      case(379)
         factor=1d0/nc**4*facRV             ! g u subtraction         Dt0g1Wmb
      case(380)
         factor=1d0/nc**4*facRV             ! g ub subtraction        Dt0g1Wmb
      case(381)
         factor=1d0/nc**4*facRV             ! u g subtraction         Dt0g1Wmb
      case(382)
         factor=1d0/nc**4*facRV             ! ub g subtraction        Dt0g1Wmb
      case(383)
         factor=1d0/nc**3*nf*facRV          ! d db -> db u lm nub     Dh0g1Wma
      case(384)
         factor=1d0/nc**3*nf*facRV          ! d d -> d u lm nub       Dh0g1Wma
      case(385)
         factor=1d0/nc**3*nf*facRV          ! d ub -> d db lm nub     Dh0g1Wma
      case(386)
         factor=1d0/nc**3*nf*facRV          ! db d -> db u lm nub     Dh0g1Wma
      case(387)
         factor=1d0/nc**3*nf*facRV          ! ub d -> d db lm nub     Dh0g1Wma
      case(388)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! db ub -> db db lm nub     Dh0g1Wma
      case(389)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! ub db -> db db lm nub     Dh0g1Wma
      case(390)
         factor=1d0/nc**3*nf*facRV          ! d g subtraction         Dh0g1Wma
      case(391)
         factor=1d0/nc**3*nf*facRV          ! db g subtraction        Dh0g1Wma
      case(392)
         factor=1d0/nc**3*nf*facRV          ! g d subtraction         Dh0g1Wma
      case(393)
         factor=1d0/nc**3*nf*facRV          ! g db subtraction        Dh0g1Wma
      case(394)
         factor=1d0/nc**3*nf*facRV          ! g u subtraction         Dh0g1Wma
      case(395)
         factor=1d0/nc**3*nf*facRV          ! u g subtraction         Dh0g1Wma
      case(396)
         factor=1d0/nc**3*nf*facRV          ! d ub -> ub u lm nub     Dh0g1Wmb
      case(397)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! d u -> u u lm nub       Dh0g1Wmb
      case(398)
         factor=1d0/nc**3*nf*facRV          ! ub d -> ub u lm nub     Dh0g1Wmb
      case(399)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! u d -> u u lm nub       Dh0g1Wmb
      case(400)
         factor=1d0/nc**3*nf*facRV          ! ub u -> db u lm nub     Dh0g1Wmb
      case(401)
         factor=1d0/nc**3*nf*facRV          ! ub ub -> db ub lm nub     Dh0g1Wmb
      case(402)
         factor=1d0/nc**3*nf*facRV          ! u ub -> db u lm nub     Dh0g1Wmb
      case(403)
         factor=1d0/nc**3*nf*facRV          ! db g subtraction        Dh0g1Wmb
      case(404)
         factor=1d0/nc**3*nf*facRV          ! g db subtraction        Dh0g1Wmb
      case(405)
         factor=1d0/nc**3*nf*facRV          ! g u subtraction         Dh0g1Wmb
      case(406)
         factor=1d0/nc**3*nf*facRV          ! g ub subtraction        Dh0g1Wmb
      case(407)
         factor=1d0/nc**3*nf*facRV          ! u g subtraction         Dh0g1Wmb
      case(408)
         factor=1d0/nc**3*nf*facRV          ! ub g subtraction        Dh0g1Wmb

c -- double virtual

      case(409)
         factor=facVV                       ! d g -> u lm nub         B1g2Wm
      case(410)
         factor=facVV                       ! d ub -> g lm nub        B1g2Wm
      case(411)
         factor=facVV                       ! g d -> u lm nub         B1g2Wm
      case(412)
         factor=facVV                       ! ub d -> g lm nub        B1g2Wm
      case(413)
         factor=facVV                       ! g ub -> db lm nub       B1g2Wm
      case(414)
         factor=facVV                       ! ub g -> db lm nub       B1g2Wm
      case(415)
         factor=1d0/nc*facVV                ! Q d subtraction         B1g2Wm
      case(416)
         factor=1d0/nc*facVV                ! Q ub subtraction        B1g2Wm
      case(417)
         factor=1d0/nc*facVV                ! Qb d subtraction        B1g2Wm
      case(418)
         factor=1d0/nc*facVV                ! Qb ub subtraction       B1g2Wm
      case(419)
         factor=1d0/nc**2*facVV             ! d u subtraction         B1g2Wm
      case(420)
         factor=facVV                       ! db g subtraction        B1g2Wm
      case(421)
         factor=1d0/nc**2*facVV             ! db ub subtraction       B1g2Wm
      case(422)
         factor=facVV                       ! g db subtraction        B1g2Wm
      case(423)
         factor=nup*facVV                   ! g g subtraction         B1g2Wm
      case(424)
         factor=facVV                       ! g u subtraction         B1g2Wm
      case(425)
         factor=1d0/nc*facVV                ! d Q subtraction         B1g2Wm
      case(426)
         factor=1d0/nc*facVV                ! d Qb subtraction        B1g2Wm
      case(427)
         factor=1d0/nc*facVV                ! ub Q subtraction        B1g2Wm
      case(428)
         factor=1d0/nc*facVV                ! ub Qb subtraction       B1g2Wm
      case(429)
         factor=1d0/nc**2*facVV             ! u d subtraction         B1g2Wm
      case(430)
         factor=facVV                       ! u g subtraction         B1g2Wm
      case(431)
         factor=1d0/nc**2*facVV             ! ub db subtraction       B1g2Wm
      case(432)
         factor=-1d0/nc**2*facVV            ! d g -> u lm nub         Bt1g2Wm
      case(433)
         factor=-1d0/nc**2*facVV            ! d ub -> g lm nub        Bt1g2Wm
      case(434)
         factor=-1d0/nc**2*facVV            ! g d -> u lm nub         Bt1g2Wm
      case(435)
         factor=-1d0/nc**2*facVV            ! ub d -> g lm nub        Bt1g2Wm
      case(436)
         factor=-1d0/nc**2*facVV            ! g ub -> db lm nub       Bt1g2Wm
      case(437)
         factor=-1d0/nc**2*facVV            ! ub g -> db lm nub       Bt1g2Wm
      case(438)
         factor=-1d0/nc**3*facVV            ! Q d subtraction         Bt1g2Wm
      case(439)
         factor=-1d0/nc**3*facVV            ! Q ub subtraction        Bt1g2Wm
      case(440)
         factor=-1d0/nc**3*facVV            ! Qb d subtraction        Bt1g2Wm
      case(441)
         factor=-1d0/nc**3*facVV            ! Qb ub subtraction       Bt1g2Wm
      case(442)
         factor=-1d0/nc**4*facVV            ! d u subtraction         Bt1g2Wm
      case(443)
         factor=-1d0/nc**2*facVV            ! db g subtraction        Bt1g2Wm
      case(444)
         factor=-1d0/nc**4*facVV            ! db ub subtraction       Bt1g2Wm
      case(445)
         factor=-1d0/nc**2*facVV            ! g db subtraction        Bt1g2Wm
      case(446)
         factor=-1d0/nc**2*nup*facVV        ! g g subtraction         Bt1g2Wm
      case(447)
         factor=-1d0/nc**2*facVV            ! g u subtraction         Bt1g2Wm
      case(448)
         factor=-1d0/nc**3*facVV            ! d Q subtraction         Bt1g2Wm
      case(449)
         factor=-1d0/nc**3*facVV            ! d Qb subtraction        Bt1g2Wm
      case(450)
         factor=-1d0/nc**3*facVV            ! ub Q subtraction        Bt1g2Wm
      case(451)
         factor=-1d0/nc**3*facVV            ! ub Qb subtraction       Bt1g2Wm
      case(452)
         factor=-1d0/nc**4*facVV            ! u d subtraction         Bt1g2Wm
      case(453)
         factor=-1d0/nc**2*facVV            ! u g subtraction         Bt1g2Wm
      case(454)
         factor=-1d0/nc**4*facVV            ! ub db subtraction       Bt1g2Wm
      case(455)
         factor=1d0/nc**4*facVV             ! d g -> u lm nub         Btt1g2W
      case(456)
         factor=1d0/nc**4*facVV             ! d ub -> g lm nub        Btt1g2W
      case(457)
         factor=1d0/nc**4*facVV             ! g d -> u lm nub         Btt1g2W
      case(458)
         factor=1d0/nc**4*facVV             ! ub d -> g lm nub        Btt1g2W
      case(459)
         factor=1d0/nc**4*facVV             ! g ub -> db lm nub       Btt1g2W
      case(460)
         factor=1d0/nc**4*facVV             ! ub g -> db lm nub       Btt1g2W
      case(461)
         factor=1d0/nc**5*facVV             ! Q d subtraction         Btt1g2W
      case(462)
         factor=1d0/nc**5*facVV             ! Q ub subtraction        Btt1g2W
      case(463)
         factor=1d0/nc**5*facVV             ! Qb d subtraction        Btt1g2W
      case(464)
         factor=1d0/nc**5*facVV             ! Qb ub subtraction       Btt1g2W
      case(465)
         factor=1d0/nc**6*facVV             ! d u subtraction         Btt1g2W
      case(466)
         factor=1d0/nc**4*facVV             ! db g subtraction        Btt1g2W
      case(467)
         factor=1d0/nc**6*facVV             ! db ub subtraction       Btt1g2W
      case(468)
         factor=1d0/nc**4*facVV             ! g db subtraction        Btt1g2W
      case(469)
         factor=1d0/nc**4*nup*facVV         ! g g subtraction         Btt1g2W
      case(470)
         factor=1d0/nc**4*facVV             ! g u subtraction         Btt1g2W
      case(471)
         factor=1d0/nc**5*facVV             ! d Q subtraction         Btt1g2W
      case(472)
         factor=1d0/nc**5*facVV             ! d Qb subtraction        Btt1g2W
      case(473)
         factor=1d0/nc**5*facVV             ! ub Q subtraction        Btt1g2W
      case(474)
         factor=1d0/nc**5*facVV             ! ub Qb subtraction       Btt1g2W
      case(475)
         factor=1d0/nc**6*facVV             ! u d subtraction         Btt1g2W
      case(476)
         factor=1d0/nc**4*facVV             ! u g subtraction         Btt1g2W
      case(477)
         factor=1d0/nc**6*facVV             ! ub db subtraction       Btt1g2W
      case(478)
         factor=1d0/nc*nf*facVV             ! d g -> u lm nub         Bh1g2W
      case(479)
         factor=1d0/nc*nf*facVV             ! d ub -> g lm nub        Bh1g2W
      case(480)
         factor=1d0/nc*nf*facVV             ! g d -> u lm nub         Bh1g2W
      case(481)
         factor=1d0/nc*nf*facVV             ! ub d -> g lm nub        Bh1g2W
      case(482)
         factor=1d0/nc*nf*facVV             ! g ub -> db lm nub       Bh1g2W
      case(483)
         factor=1d0/nc*nf*facVV             ! ub g -> db lm nub       Bh1g2W
      case(484)
         factor=1d0/nc*nup*facVV            ! Q g subtraction         Bh1g2W
      case(485)
         factor=1d0/nc**2*nf*facVV          ! Q d subtraction         Bh1g2W
      case(486)
         factor=1d0/nc**2*nf*facVV          ! Q ub subtraction        Bh1g2W
      case(487)
         factor=1d0/nc*nup*facVV            ! Qb g subtraction        Bh1g2W
      case(488)
         factor=1d0/nc**2*nf*facVV          ! Qb d subtraction        Bh1g2W
      case(489)
         factor=1d0/nc**2*nf*facVV          ! Qb ub subtraction       Bh1g2W
      case(490)
         factor=1d0/nc**3*nf*facVV          ! d u subtraction         Bh1g2W
      case(491)
         factor=1d0/nc**3*nf*facVV          ! db ub subtraction       Bh1g2W
      case(492)
         factor=1d0/nc*nup*facVV            ! g Q subtraction         Bh1g2W
      case(493)
         factor=1d0/nc*nup*facVV            ! g Qb subtraction        Bh1g2W
      case(494)
         factor=1d0/nc*nf*nup*facVV         ! g g subtraction         Bh1g2W
      case(495)
         factor=1d0/nc**2*nf*facVV          ! d Q subtraction         Bh1g2W
      case(496)
         factor=1d0/nc**2*nf*facVV          ! d Qb subtraction        Bh1g2W
      case(497)
         factor=1d0/nc**2*nf*facVV          ! ub Q subtraction        Bh1g2W
      case(498)
         factor=1d0/nc**2*nf*facVV          ! ub Qb subtraction       Bh1g2W
      case(499)
         factor=1d0/nc**3*nf*facVV          ! u d subtraction         Bh1g2W
      case(500)
         factor=1d0/nc**3*nf*facVV          ! ub db subtraction       Bh1g2W
      case(501)
         factor=1d0/nc**3*nf*facVV          ! d g -> u lm nub         Bht1g2W
      case(502)
         factor=1d0/nc**3*nf*facVV          ! d ub -> g lm nub        Bht1g2W
      case(503)
         factor=1d0/nc**3*nf*facVV          ! g d -> u lm nub         Bht1g2W
      case(504)
         factor=1d0/nc**3*nf*facVV          ! ub d -> g lm nub        Bht1g2W
      case(505)
         factor=1d0/nc**3*nf*facVV          ! g ub -> db lm nub       Bht1g2W
      case(506)
         factor=1d0/nc**3*nf*facVV          ! ub g -> db lm nub       Bht1g2W
      case(507)
         factor=1d0/nc**3*nup*facVV         ! Q g subtraction         Bht1g2W
      case(508)
         factor=1d0/nc**4*nf*facVV          ! Q d subtraction         Bht1g2W
      case(509)
         factor=1d0/nc**4*nf*facVV          ! Q ub subtraction        Bht1g2W
      case(510)
         factor=1d0/nc**3*nup*facVV         ! Qb g subtraction        Bht1g2W
      case(511)
         factor=1d0/nc**4*nf*facVV          ! Qb d subtraction        Bht1g2W
      case(512)
         factor=1d0/nc**4*nf*facVV          ! Qb ub subtraction       Bht1g2W
      case(513)
         factor=1d0/nc**5*nf*facVV          ! d u subtraction         Bht1g2W
      case(514)
         factor=1d0/nc**5*nf*facVV          ! db ub subtraction       Bht1g2W
      case(515)
         factor=1d0/nc**3*nup*facVV         ! g Q subtraction         Bht1g2W
      case(516)
         factor=1d0/nc**3*nup*facVV         ! g Qb subtraction        Bht1g2W
      case(517)
         factor=1d0/nc**3*nf*nup*facVV      ! g g subtraction         Bht1g2W
      case(518)
         factor=1d0/nc**4*nf*facVV          ! d Q subtraction         Bht1g2W
      case(519)
         factor=1d0/nc**4*nf*facVV          ! d Qb subtraction        Bht1g2W
      case(520)
         factor=1d0/nc**4*nf*facVV          ! ub Q subtraction        Bht1g2W
      case(521)
         factor=1d0/nc**4*nf*facVV          ! ub Qb subtraction       Bht1g2W
      case(522)
         factor=1d0/nc**5*nf*facVV          ! u d subtraction         Bht1g2W
      case(523)
         factor=1d0/nc**5*nf*facVV          ! ub db subtraction       Bht1g2W
      case(524)
         factor=1d0/nc**2*nf**2*facVV       ! d g -> u lm nub         Bhh1g2W
      case(525)
         factor=1d0/nc**2*nf**2*facVV       ! d ub -> g lm nub        Bhh1g2W
      case(526)
         factor=1d0/nc**2*nf**2*facVV       ! g d -> u lm nub         Bhh1g2W
      case(527)
         factor=1d0/nc**2*nf**2*facVV       ! ub d -> g lm nub        Bhh1g2W
      case(528)
         factor=1d0/nc**2*nf**2*facVV       ! g ub -> db lm nub       Bhh1g2W
      case(529)
         factor=1d0/nc**2*nf**2*facVV       ! ub g -> db lm nub       Bhh1g2W
      case(530)
         factor=1d0/nc**2*nf*nup*facVV      ! Q g subtraction         Bhh1g2W
      case(531)
         factor=1d0/nc**3*nf**2*facVV       ! Q d subtraction         Bhh1g2W
      case(532)
         factor=1d0/nc**3*nf**2*facVV       ! Q ub subtraction        Bhh1g2W
      case(533)
         factor=1d0/nc**2*nf*nup*facVV      ! Qb g subtraction        Bhh1g2W
      case(534)
         factor=1d0/nc**3*nf**2*facVV       ! Qb d subtraction        Bhh1g2W
      case(535)
         factor=1d0/nc**3*nf**2*facVV       ! Qb ub subtraction       Bhh1g2W
      case(536)
         factor=1d0/nc**4*nf**2*facVV       ! d u subtraction         Bhh1g2W
      case(537)
         factor=1d0/nc**4*nf**2*facVV       ! db ub subtraction       Bhh1g2W
      case(538)
         factor=1d0/nc**2*nf*nup*facVV      ! g Q subtraction         Bhh1g2W
      case(539)
         factor=1d0/nc**2*nf*nup*facVV      ! g Qb subtraction        Bhh1g2W
      case(540)
         factor=1d0/nc**2*nf**2*nup*facVV   ! g g subtraction         Bhh1g2W
      case(541)
         factor=1d0/nc**3*nf**2*facVV       ! d Q subtraction         Bhh1g2W
      case(542)
         factor=1d0/nc**3*nf**2*facVV       ! d Qb subtraction        Bhh1g2W
      case(543)
         factor=1d0/nc**3*nf**2*facVV       ! ub Q subtraction        Bhh1g2W
      case(544)
         factor=1d0/nc**3*nf**2*facVV       ! ub Qb subtraction       Bhh1g2W
      case(545)
         factor=1d0/nc**4*nf**2*facVV       ! u d subtraction         Bhh1g2W
      case(546)
         factor=1d0/nc**4*nf**2*facVV       ! ub db subtraction       Bhh1g2W
      end select
      factor=relfactor*factor

      return
      end
