      subroutine getqcdnormWpJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      real(8) :: fac_ckm
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtWpJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVWpJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourWpJ(current_chan)
         do isub = 1, nflavourWpJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_WpJ(current_chan, isub, ipass_sub, flav_block, fac_ckm)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           partons_sub = fac_ckm*partons_sub
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=WpJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param()/stw)**2*(nc**2-1)
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! u g -> d nu lp          B1g0W
      case(2)
         factor=facB                        ! u db -> g nu lp         B1g0W
      case(3)
         factor=facB                        ! g u -> d nu lp          B1g0W
      case(4)
         factor=facB                        ! db u -> g nu lp         B1g0W
      case(5)
         factor=facB                        ! g db -> ub nu lp        B1g0W
      case(6)
         factor=facB                        ! db g -> ub nu lp        B1g0W

c -- real

      case(7)
         factor=facR                        ! u g -> g d nu lp        B2g0W
      case(8)
         factor=1d0/2d0*facR                ! u db -> g g nu lp       B2g0W
      case(9)
         factor=facR                        ! g u -> g d nu lp        B2g0W
      case(10)
         factor=1d0/2d0*facR                ! db u -> g g nu lp       B2g0W
      case(11)
         factor=nup*facR                    ! g g -> ub d nu lp       B2g0W
      case(12)
         factor=facR                        ! g db -> ub g nu lp      B2g0W
      case(13)
         factor=facR                        ! db g -> ub g nu lp      B2g0W
      case(14)
         factor=-1d0/nc**2*facR             ! u gt -> gt d nu lp      Bt2g0W
      case(15)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u db -> gt gt nu lp     Bt2g0W
      case(16)
         factor=-1d0/nc**2*facR             ! gt u -> gt d nu lp      Bt2g0W
      case(17)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db u -> gt gt nu lp     Bt2g0W
      case(18)
         factor=-1d0/nc**2*nup*facR         ! gt gt -> ub d nu lp     Bt2g0W
      case(19)
         factor=-1d0/nc**2*facR             ! gt db -> ub gt nu lp     Bt2g0W
      case(20)
         factor=-1d0/nc**2*facR             ! db gt -> ub gt nu lp     Bt2g0W
      case(21)
         factor=1d0/nc*facR                 ! u Qb -> Qb d nu lp      C0g0W
      case(22)
         factor=1d0/nc*facR                 ! u Q -> Q d nu lp        C0g0W
      case(23)
         factor=1d0/nc*nf*facR              ! u db -> Q Qb nu lp      C0g0W
      case(24)
         factor=1d0/nc*facR                 ! Qb u -> Qb d nu lp      C0g0W
      case(25)
         factor=1d0/nc*facR                 ! Q u -> Q d nu lp        C0g0W
      case(26)
         factor=1d0/nc*nf*facR              ! db u -> Q Qb nu lp      C0g0W
      case(27)
         factor=1d0/nc*nup*facR             ! Qb Q -> ub d nu lp      C0g0W
      case(28)
         factor=1d0/nc*facR                 ! Qb db -> ub Qb nu lp     C0g0W
      case(29)
         factor=1d0/nc*nup*facR             ! Q Qb -> ub d nu lp      C0g0W
      case(30)
         factor=1d0/nc*facR                 ! db Qb -> ub Qb nu lp     C0g0W
      case(31)
         factor=1d0/nc*facR                 ! Q db -> ub Q nu lp      C0g0W
      case(32)
         factor=1d0/nc*facR                 ! db Q -> ub Q nu lp      C0g0W
      case(33)
         factor=-1d0/nc**2*facR             ! u ub -> ub d nu lp      D0g0Wa
      case(34)
         factor=-1d0/nc**2*facR             ! u u -> u d nu lp        D0g0Wa
      case(35)
         factor=-1d0/nc**2*facR             ! u db -> u ub nu lp      D0g0Wa
      case(36)
         factor=-1d0/nc**2*facR             ! ub u -> ub d nu lp      D0g0Wa
      case(37)
         factor=-1d0/nc**2*facR             ! db u -> u ub nu lp      D0g0Wa
      case(38)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub db -> ub ub nu lp     D0g0Wa
      case(39)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db ub -> ub ub nu lp     D0g0Wa
      case(40)
         factor=-1d0/nc**2*facR             ! u db -> db d nu lp      D0g0Wb
      case(41)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u d -> d d nu lp        D0g0Wb
      case(42)
         factor=-1d0/nc**2*facR             ! db u -> db d nu lp      D0g0Wb
      case(43)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d u -> d d nu lp        D0g0Wb
      case(44)
         factor=-1d0/nc**2*facR             ! db d -> ub d nu lp      D0g0Wb
      case(45)
         factor=-1d0/nc**2*facR             ! db db -> ub db nu lp     D0g0Wb
      case(46)
         factor=-1d0/nc**2*facR             ! d db -> ub d nu lp      D0g0Wb

c -- virtual

      case(47)
         factor=facV                        ! u g -> d nu lp          B1g1W
      case(48)
         factor=facV                        ! u db -> g nu lp         B1g1W
      case(49)
         factor=facV                        ! g u -> d nu lp          B1g1W
      case(50)
         factor=facV                        ! db u -> g nu lp         B1g1W
      case(51)
         factor=facV                        ! g db -> ub nu lp        B1g1W
      case(52)
         factor=facV                        ! db g -> ub nu lp        B1g1W
      case(53)
         factor=1d0/nc*facV                 ! Q u subtraction         B1g1W
      case(54)
         factor=1d0/nc*facV                 ! Q db subtraction        B1g1W
      case(55)
         factor=1d0/nc*facV                 ! Qb u subtraction        B1g1W
      case(56)
         factor=1d0/nc*facV                 ! Qb db subtraction       B1g1W
      case(57)
         factor=nup*facV                    ! g g subtraction         B1g1W
      case(58)
         factor=1d0/nc*facV                 ! u Q subtraction         B1g1W
      case(59)
         factor=1d0/nc*facV                 ! u Qb subtraction        B1g1W
      case(60)
         factor=1d0/nc*facV                 ! db Q subtraction        B1g1W
      case(61)
         factor=1d0/nc*facV                 ! db Qb subtraction       B1g1W
      case(62)
         factor=-1d0/nc**2*facV             ! u g -> d nu lp          Bt1g1W
      case(63)
         factor=-1d0/nc**2*facV             ! u db -> g nu lp         Bt1g1W
      case(64)
         factor=-1d0/nc**2*facV             ! g u -> d nu lp          Bt1g1W
      case(65)
         factor=-1d0/nc**2*facV             ! db u -> g nu lp         Bt1g1W
      case(66)
         factor=-1d0/nc**2*facV             ! g db -> ub nu lp        Bt1g1W
      case(67)
         factor=-1d0/nc**2*facV             ! db g -> ub nu lp        Bt1g1W
      case(68)
         factor=-1d0/nc**3*facV             ! Q u subtraction         Bt1g1W
      case(69)
         factor=-1d0/nc**3*facV             ! Q db subtraction        Bt1g1W
      case(70)
         factor=-1d0/nc**3*facV             ! Qb u subtraction        Bt1g1W
      case(71)
         factor=-1d0/nc**3*facV             ! Qb db subtraction       Bt1g1W
      case(72)
         factor=-1d0/nc**2*nup*facV         ! g g subtraction         Bt1g1W
      case(73)
         factor=-1d0/nc**3*facV             ! u Q subtraction         Bt1g1W
      case(74)
         factor=-1d0/nc**3*facV             ! u Qb subtraction        Bt1g1W
      case(75)
         factor=-1d0/nc**3*facV             ! db Q subtraction        Bt1g1W
      case(76)
         factor=-1d0/nc**3*facV             ! db Qb subtraction       Bt1g1W
      case(77)
         factor=1d0/nc*nf*facV              ! u g -> d nu lp          Bh1g1W
      case(78)
         factor=1d0/nc*nf*facV              ! u db -> g nu lp         Bh1g1W
      case(79)
         factor=1d0/nc*nf*facV              ! g u -> d nu lp          Bh1g1W
      case(80)
         factor=1d0/nc*nf*facV              ! db u -> g nu lp         Bh1g1W
      case(81)
         factor=1d0/nc*nf*facV              ! g db -> ub nu lp        Bh1g1W
      case(82)
         factor=1d0/nc*nf*facV              ! db g -> ub nu lp        Bh1g1W
      case(83)
         factor=1d0/nc**2*nf*facV           ! Q u subtraction         Bh1g1W
      case(84)
         factor=1d0/nc**2*nf*facV           ! Q db subtraction        Bh1g1W
      case(85)
         factor=1d0/nc**2*nf*facV           ! Qb u subtraction        Bh1g1W
      case(86)
         factor=1d0/nc**2*nf*facV           ! Qb db subtraction       Bh1g1W
      case(87)
         factor=1d0/nc*nf*nup*facV          ! g g subtraction         Bh1g1W
      case(88)
         factor=1d0/nc**2*nf*facV           ! u Q subtraction         Bh1g1W
      case(89)
         factor=1d0/nc**2*nf*facV           ! u Qb subtraction        Bh1g1W
      case(90)
         factor=1d0/nc**2*nf*facV           ! db Q subtraction        Bh1g1W
      case(91)
         factor=1d0/nc**2*nf*facV           ! db Qb subtraction       Bh1g1W

c -- double real

      case(92)
         factor=1d0/2d0*facRR               ! u g -> g g d nu lp      sB3g0W
      case(93)
         factor=1d0/6d0*facRR               ! u db -> g g g nu lp     sB3g0W
      case(94)
         factor=1d0/2d0*facRR               ! g u -> g g d nu lp      sB3g0W
      case(95)
         factor=1d0/6d0*facRR               ! db u -> g g g nu lp     sB3g0W
      case(96)
         factor=nup*facRR                   ! g g -> ub g d nu lp     sB3g0W
      case(97)
         factor=1d0/2d0*facRR               ! g db -> ub g g nu lp     sB3g0W
      case(98)
         factor=1d0/2d0*facRR               ! db g -> ub g g nu lp     sB3g0W
      case(99)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u g -> g g d nu lp      sBt3g0W
      case(100)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! u db -> g g g nu lp     sBt3g0W
      case(101)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g u -> g g d nu lp      sBt3g0W
      case(102)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! db u -> g g g nu lp     sBt3g0W
      case(103)
         factor=-1d0/nc**2*nup*facRR        ! g g -> ub g d nu lp     sBt3g0W
      case(104)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g db -> ub g g nu lp     sBt3g0W
      case(105)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db g -> ub g g nu lp     sBt3g0W
      case(106)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! u gt -> gt gt d nu lp     sBtt3g0W
      case(107)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! u db -> gt gt gt nu lp     sBtt3g0W
      case(108)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! gt u -> gt gt d nu lp     sBtt3g0W
      case(109)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! db u -> gt gt gt nu lp     sBtt3g0W
      case(110)
         factor=(nc**2+1d0)/nc**4*nup*facRR   ! gt gt -> ub gt d nu lp     sBtt3g0W
      case(111)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! gt db -> ub gt gt nu lp     sBtt3g0W
      case(112)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! db gt -> ub gt gt nu lp     sBtt3g0W
      case(113)
         factor=1d0/nc*nf*facRR             ! u g -> Q Qb d nu lp     sC1g0W
      case(114)
         factor=1d0/nc*facRR                ! u Qb -> g Qb d nu lp     sC1g0W
      case(115)
         factor=1d0/nc*facRR                ! u Q -> g Q d nu lp      sC1g0W
      case(116)
         factor=1d0/nc*nf*facRR             ! u db -> g Q Qb nu lp     sC1g0W
      case(117)
         factor=1d0/nc*nf*facRR             ! g u -> Q Qb d nu lp     sC1g0W
      case(118)
         factor=1d0/nc*facRR                ! Qb u -> g Qb d nu lp     sC1g0W
      case(119)
         factor=1d0/nc*facRR                ! Q u -> g Q d nu lp      sC1g0W
      case(120)
         factor=1d0/nc*nf*facRR             ! db u -> g Q Qb nu lp     sC1g0W
      case(121)
         factor=1d0/nc*nup*facRR            ! g Qb -> ub Qb d nu lp     sC1g0W
      case(122)
         factor=1d0/nc*nup*facRR            ! g Q -> ub Q d nu lp     sC1g0W
      case(123)
         factor=1d0/nc*nf*facRR             ! g db -> ub Q Qb nu lp     sC1g0W
      case(124)
         factor=1d0/nc*nup*facRR            ! Qb g -> ub Qb d nu lp     sC1g0W
      case(125)
         factor=1d0/nc*nup*facRR            ! Q g -> ub Q d nu lp     sC1g0W
      case(126)
         factor=1d0/nc*nf*facRR             ! db g -> ub Q Qb nu lp     sC1g0W
      case(127)
         factor=1d0/nc*nup*facRR            ! Qb Q -> ub g d nu lp     sC1g0W
      case(128)
         factor=1d0/nc*facRR                ! Qb db -> ub g Qb nu lp     sC1g0W
      case(129)
         factor=1d0/nc*nup*facRR            ! Q Qb -> ub g d nu lp     sC1g0W
      case(130)
         factor=1d0/nc*facRR                ! db Qb -> ub g Qb nu lp     sC1g0W
      case(131)
         factor=1d0/nc*facRR                ! Q db -> ub g Q nu lp     sC1g0W
      case(132)
         factor=1d0/nc*facRR                ! db Q -> ub g Q nu lp     sC1g0W
      case(133)
         factor=1d0/nc**3*nf*facRR          ! u g -> Q Qb d nu lp     sCt1g0W
      case(134)
         factor=1d0/nc**3*facRR             ! u Qb -> g Qb d nu lp     sCt1g0W
      case(135)
         factor=1d0/nc**3*facRR             ! u Q -> g Q d nu lp      sCt1g0W
      case(136)
         factor=1d0/nc**3*nf*facRR          ! u db -> g Q Qb nu lp     sCt1g0W
      case(137)
         factor=1d0/nc**3*nf*facRR          ! g u -> Q Qb d nu lp     sCt1g0W
      case(138)
         factor=1d0/nc**3*facRR             ! Qb u -> g Qb d nu lp     sCt1g0W
      case(139)
         factor=1d0/nc**3*facRR             ! Q u -> g Q d nu lp      sCt1g0W
      case(140)
         factor=1d0/nc**3*nf*facRR          ! db u -> g Q Qb nu lp     sCt1g0W
      case(141)
         factor=1d0/nc**3*nup*facRR         ! g Qb -> ub Qb d nu lp     sCt1g0W
      case(142)
         factor=1d0/nc**3*nup*facRR         ! g Q -> ub Q d nu lp     sCt1g0W
      case(143)
         factor=1d0/nc**3*nf*facRR          ! g db -> ub Q Qb nu lp     sCt1g0W
      case(144)
         factor=1d0/nc**3*nup*facRR         ! Qb g -> ub Qb d nu lp     sCt1g0W
      case(145)
         factor=1d0/nc**3*nup*facRR         ! Q g -> ub Q d nu lp     sCt1g0W
      case(146)
         factor=1d0/nc**3*nf*facRR          ! db g -> ub Q Qb nu lp     sCt1g0W
      case(147)
         factor=1d0/nc**3*nup*facRR         ! Qb Q -> ub g d nu lp     sCt1g0W
      case(148)
         factor=1d0/nc**3*facRR             ! Qb db -> ub g Qb nu lp     sCt1g0W
      case(149)
         factor=1d0/nc**3*nup*facRR         ! Q Qb -> ub g d nu lp     sCt1g0W
      case(150)
         factor=1d0/nc**3*facRR             ! db Qb -> ub g Qb nu lp     sCt1g0W
      case(151)
         factor=1d0/nc**3*facRR             ! Q db -> ub g Q nu lp     sCt1g0W
      case(152)
         factor=1d0/nc**3*facRR             ! db Q -> ub g Q nu lp     sCt1g0W
      case(153)
         factor=-1d0/nc**2*facRR            ! u g -> u ub d nu lp     D1g0Wpac
      case(154)
         factor=-1d0/nc**2*facRR            ! u ub -> g ub d nu lp     D1g0Wpac
      case(155)
         factor=-1d0/nc**2*facRR            ! u u -> g u d nu lp      D1g0Wpac
      case(156)
         factor=-1d0/nc**2*facRR            ! u db -> g u ub nu lp     D1g0Wpac
      case(157)
         factor=-1d0/nc**2*facRR            ! g u -> u ub d nu lp     D1g0Wpac
      case(158)
         factor=-1d0/nc**2*facRR            ! ub u -> g ub d nu lp     D1g0Wpac
      case(159)
         factor=-1d0/nc**2*facRR            ! db u -> g u ub nu lp     D1g0Wpac
      case(160)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g ub -> ub ub d nu lp     D1g0Wpac
      case(161)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g db -> ub u ub nu lp     D1g0Wpac
      case(162)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub g -> ub ub d nu lp     D1g0Wpac
      case(163)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db g -> ub u ub nu lp     D1g0Wpac
      case(164)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub db -> ub g ub nu lp     D1g0Wpac
      case(165)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db ub -> ub g ub nu lp     D1g0Wpac
      case(166)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u g -> d db d nu lp     D1g0Wpbc
      case(167)
         factor=-1d0/nc**2*facRR            ! u db -> g db d nu lp     D1g0Wpbc
      case(168)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u d -> g d d nu lp      D1g0Wpbc
      case(169)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g u -> d db d nu lp     D1g0Wpbc
      case(170)
         factor=-1d0/nc**2*facRR            ! db u -> g db d nu lp     D1g0Wpbc
      case(171)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d u -> g d d nu lp      D1g0Wpbc
      case(172)
         factor=-1d0/nc**2*facRR            ! g db -> ub db d nu lp     D1g0Wpbc
      case(173)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g d -> ub d d nu lp     D1g0Wpbc
      case(174)
         factor=-1d0/nc**2*facRR            ! db g -> ub db d nu lp     D1g0Wpbc
      case(175)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d g -> ub d d nu lp     D1g0Wpbc
      case(176)
         factor=-1d0/nc**2*facRR            ! db d -> ub g d nu lp     D1g0Wpbc
      case(177)
         factor=-1d0/nc**2*facRR            ! db db -> ub g db nu lp     D1g0Wpbc
      case(178)
         factor=-1d0/nc**2*facRR            ! d db -> ub g d nu lp     D1g0Wpbc
      case(179)
         factor=1d0/nc**4*facRR             ! u g -> u ub d nu lp     Dt1g0Wpa
      case(180)
         factor=1d0/nc**4*facRR             ! u ub -> g ub d nu lp     Dt1g0Wpa
      case(181)
         factor=1d0/nc**4*facRR             ! u u -> g u d nu lp      Dt1g0Wpa
      case(182)
         factor=1d0/nc**4*facRR             ! u db -> g u ub nu lp     Dt1g0Wpa
      case(183)
         factor=1d0/nc**4*facRR             ! g u -> u ub d nu lp     Dt1g0Wpa
      case(184)
         factor=1d0/nc**4*facRR             ! ub u -> g ub d nu lp     Dt1g0Wpa
      case(185)
         factor=1d0/nc**4*facRR             ! db u -> g u ub nu lp     Dt1g0Wpa
      case(186)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g ub -> ub ub d nu lp     Dt1g0Wpa
      case(187)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g db -> ub u ub nu lp     Dt1g0Wpa
      case(188)
         factor=1d0/nc**4*1d0/2d0*facRR     ! ub g -> ub ub d nu lp     Dt1g0Wpa
      case(189)
         factor=1d0/nc**4*1d0/2d0*facRR     ! db g -> ub u ub nu lp     Dt1g0Wpa
      case(190)
         factor=1d0/nc**4*1d0/2d0*facRR     ! ub db -> ub g ub nu lp     Dt1g0Wpa
      case(191)
         factor=1d0/nc**4*1d0/2d0*facRR     ! db ub -> ub g ub nu lp     Dt1g0Wpa
      case(192)
         factor=1d0/nc**4*1d0/2d0*facRR     ! u g -> d db d nu lp     Dt1g0Wpb
      case(193)
         factor=1d0/nc**4*facRR             ! u db -> g db d nu lp     Dt1g0Wpb
      case(194)
         factor=1d0/nc**4*1d0/2d0*facRR     ! u d -> g d d nu lp      Dt1g0Wpb
      case(195)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g u -> d db d nu lp     Dt1g0Wpb
      case(196)
         factor=1d0/nc**4*facRR             ! db u -> g db d nu lp     Dt1g0Wpb
      case(197)
         factor=1d0/nc**4*1d0/2d0*facRR     ! d u -> g d d nu lp      Dt1g0Wpb
      case(198)
         factor=1d0/nc**4*facRR             ! g db -> ub db d nu lp     Dt1g0Wpb
      case(199)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g d -> ub d d nu lp     Dt1g0Wpb
      case(200)
         factor=1d0/nc**4*facRR             ! db g -> ub db d nu lp     Dt1g0Wpb
      case(201)
         factor=1d0/nc**4*1d0/2d0*facRR     ! d g -> ub d d nu lp     Dt1g0Wpb
      case(202)
         factor=1d0/nc**4*facRR             ! db d -> ub g d nu lp     Dt1g0Wpb
      case(203)
         factor=1d0/nc**4*facRR             ! db db -> ub g db nu lp     Dt1g0Wpb
      case(204)
         factor=1d0/nc**4*facRR             ! d db -> ub g d nu lp     Dt1g0Wpb

c -- real virtual

      case(205)
         factor=facRV                       ! u g -> g d nu lp        sB2g1W
      case(206)
         factor=1d0/2d0*facRV               ! u db -> g g nu lp       sB2g1W
      case(207)
         factor=facRV                       ! g u -> g d nu lp        sB2g1W
      case(208)
         factor=1d0/2d0*facRV               ! db u -> g g nu lp       sB2g1W
      case(209)
         factor=nup*facRV                   ! g g -> ub d nu lp       sB2g1W
      case(210)
         factor=facRV                       ! g db -> ub g nu lp      sB2g1W
      case(211)
         factor=facRV                       ! db g -> ub g nu lp      sB2g1W
      case(212)
         factor=1d0/nc*facRV                ! Q u subtraction         sB2g1W
      case(213)
         factor=1d0/nc*facRV                ! Q db subtraction        sB2g1W
      case(214)
         factor=1d0/nc*facRV                ! Qb u subtraction        sB2g1W
      case(215)
         factor=1d0/nc*facRV                ! Qb db subtraction       sB2g1W
      case(216)
         factor=1d0/nc*facRV                ! u Q subtraction         sB2g1W
      case(217)
         factor=1d0/nc*facRV                ! u Qb subtraction        sB2g1W
      case(218)
         factor=1d0/nc*facRV                ! db Q subtraction        sB2g1W
      case(219)
         factor=1d0/nc*facRV                ! db Qb subtraction       sB2g1W
      case(220)
         factor=-1d0/nc**2*facRV            ! u g -> g d nu lp        sBt2g1W
      case(221)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! u db -> g g nu lp       sBt2g1W
      case(222)
         factor=-1d0/nc**2*facRV            ! g u -> g d nu lp        sBt2g1W
      case(223)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! db u -> g g nu lp       sBt2g1W
      case(224)
         factor=-1d0/nc**2*nup*facRV        ! g g -> ub d nu lp       sBt2g1W
      case(225)
         factor=-1d0/nc**2*facRV            ! g db -> ub g nu lp      sBt2g1W
      case(226)
         factor=-1d0/nc**2*facRV            ! db g -> ub g nu lp      sBt2g1W
      case(227)
         factor=-1d0/nc**3*facRV            ! Q u subtraction         sBt2g1W
      case(228)
         factor=-1d0/nc**3*facRV            ! Q db subtraction        sBt2g1W
      case(229)
         factor=-1d0/nc**3*facRV            ! Qb u subtraction        sBt2g1W
      case(230)
         factor=-1d0/nc**3*facRV            ! Qb db subtraction       sBt2g1W
      case(231)
         factor=-1d0/nc**3*facRV            ! u Q subtraction         sBt2g1W
      case(232)
         factor=-1d0/nc**3*facRV            ! u Qb subtraction        sBt2g1W
      case(233)
         factor=-1d0/nc**3*facRV            ! db Q subtraction        sBt2g1W
      case(234)
         factor=-1d0/nc**3*facRV            ! db Qb subtraction       sBt2g1W
      case(235)
         factor=-1d0/nc**2*facRV            ! u gt -> gt d nu lp      sBtt2g1Wc
      case(236)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! u db -> gt gt nu lp     sBtt2g1Wc
      case(237)
         factor=-1d0/nc**2*facRV            ! gt u -> gt d nu lp      sBtt2g1Wc
      case(238)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! db u -> gt gt nu lp     sBtt2g1Wc
      case(239)
         factor=-1d0/nc**2*nup*facRV        ! gt gt -> ub d nu lp     sBtt2g1Wc
      case(240)
         factor=-1d0/nc**2*facRV            ! gt db -> ub gt nu lp     sBtt2g1Wc
      case(241)
         factor=-1d0/nc**2*facRV            ! db gt -> ub gt nu lp     sBtt2g1Wc
      case(242)
         factor=1d0/nc**4*facRV             ! u gt -> gt d nu lp      sBttt2g1W
      case(243)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u db -> gt gt nu lp     sBttt2g1W
      case(244)
         factor=1d0/nc**4*facRV             ! gt u -> gt d nu lp      sBttt2g1W
      case(245)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db u -> gt gt nu lp     sBttt2g1W
      case(246)
         factor=1d0/nc**4*nup*facRV         ! gt gt -> ub d nu lp     sBttt2g1W
      case(247)
         factor=1d0/nc**4*facRV             ! gt db -> ub gt nu lp     sBttt2g1W
      case(248)
         factor=1d0/nc**4*facRV             ! db gt -> ub gt nu lp     sBttt2g1W
      case(249)
         factor=1d0/nc*nf*facRV             ! u g -> g d nu lp        sBh2g1W
      case(250)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! u db -> g g nu lp       sBh2g1W
      case(251)
         factor=1d0/nc*nf*facRV             ! g u -> g d nu lp        sBh2g1W
      case(252)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! db u -> g g nu lp       sBh2g1W
      case(253)
         factor=1d0/nc*nf*nup*facRV         ! g g -> ub d nu lp       sBh2g1W
      case(254)
         factor=1d0/nc*nf*facRV             ! g db -> ub g nu lp      sBh2g1W
      case(255)
         factor=1d0/nc*nf*facRV             ! db g -> ub g nu lp      sBh2g1W
      case(256)
         factor=1d0/nc**2*nf*facRV          ! Q u subtraction         sBh2g1W
      case(257)
         factor=1d0/nc**2*nf*facRV          ! Q db subtraction        sBh2g1W
      case(258)
         factor=1d0/nc**2*nf*facRV          ! Qb u subtraction        sBh2g1W
      case(259)
         factor=1d0/nc**2*nf*facRV          ! Qb db subtraction       sBh2g1W
      case(260)
         factor=1d0/nc**2*nf*facRV          ! u Q subtraction         sBh2g1W
      case(261)
         factor=1d0/nc**2*nf*facRV          ! u Qb subtraction        sBh2g1W
      case(262)
         factor=1d0/nc**2*nf*facRV          ! db Q subtraction        sBh2g1W
      case(263)
         factor=1d0/nc**2*nf*facRV          ! db Qb subtraction       sBh2g1W
      case(264)
         factor=-1d0/nc**3*nf*facRV         ! u gt -> gt d nu lp      sBth2g1W
      case(265)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! u db -> gt gt nu lp     sBth2g1W
      case(266)
         factor=-1d0/nc**3*nf*facRV         ! gt u -> gt d nu lp      sBth2g1W
      case(267)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! db u -> gt gt nu lp     sBth2g1W
      case(268)
         factor=-1d0/nc**3*nf*nup*facRV     ! gt gt -> ub d nu lp     sBth2g1W
      case(269)
         factor=-1d0/nc**3*nf*facRV         ! gt db -> ub gt nu lp     sBth2g1W
      case(270)
         factor=-1d0/nc**3*nf*facRV         ! db gt -> ub gt nu lp     sBth2g1W
      case(271)
         factor=1d0/nc*facRV                ! u Qb -> Qb d nu lp      sC0g1W
      case(272)
         factor=1d0/nc*facRV                ! u Q -> Q d nu lp        sC0g1W
      case(273)
         factor=1d0/nc*nf*facRV             ! u db -> Q Qb nu lp      sC0g1W
      case(274)
         factor=1d0/nc*facRV                ! Qb u -> Qb d nu lp      sC0g1W
      case(275)
         factor=1d0/nc*facRV                ! Q u -> Q d nu lp        sC0g1W
      case(276)
         factor=1d0/nc*nf*facRV             ! db u -> Q Qb nu lp      sC0g1W
      case(277)
         factor=1d0/nc*nup*facRV            ! Qb Q -> ub d nu lp      sC0g1W
      case(278)
         factor=1d0/nc*facRV                ! Qb db -> ub Qb nu lp     sC0g1W
      case(279)
         factor=1d0/nc*nup*facRV            ! Q Qb -> ub d nu lp      sC0g1W
      case(280)
         factor=1d0/nc*facRV                ! db Qb -> ub Qb nu lp     sC0g1W
      case(281)
         factor=1d0/nc*facRV                ! Q db -> ub Q nu lp      sC0g1W
      case(282)
         factor=1d0/nc*facRV                ! db Q -> ub Q nu lp      sC0g1W
      case(283)
         factor=1d0/nc*nup*facRV            ! Q g subtraction         sC0g1W
      case(284)
         factor=1d0/nc*nup*facRV            ! Qb g subtraction        sC0g1W
      case(285)
         factor=1d0/nc*nup*facRV            ! g Q subtraction         sC0g1W
      case(286)
         factor=1d0/nc*nup*facRV            ! g Qb subtraction        sC0g1W
      case(287)
         factor=1d0/nc*nf*facRV             ! g u subtraction         sC0g1W
      case(288)
         factor=1d0/nc*nf*facRV             ! g db subtraction        sC0g1W
      case(289)
         factor=1d0/nc*nf*facRV             ! u g subtraction         sC0g1W
      case(290)
         factor=1d0/nc*nf*facRV             ! db g subtraction        sC0g1W
      case(291)
         factor=1d0/nc**3*facRV             ! u Qb -> Qb d nu lp      Ct0g1W
      case(292)
         factor=1d0/nc**3*facRV             ! u Q -> Q d nu lp        Ct0g1W
      case(293)
         factor=1d0/nc**3*nf*facRV          ! u db -> Q Qb nu lp      Ct0g1W
      case(294)
         factor=1d0/nc**3*facRV             ! Qb u -> Qb d nu lp      Ct0g1W
      case(295)
         factor=1d0/nc**3*facRV             ! Q u -> Q d nu lp        Ct0g1W
      case(296)
         factor=1d0/nc**3*nf*facRV          ! db u -> Q Qb nu lp      Ct0g1W
      case(297)
         factor=1d0/nc**3*nup*facRV         ! Qb Q -> ub d nu lp      Ct0g1W
      case(298)
         factor=1d0/nc**3*facRV             ! Qb db -> ub Qb nu lp     Ct0g1W
      case(299)
         factor=1d0/nc**3*nup*facRV         ! Q Qb -> ub d nu lp      Ct0g1W
      case(300)
         factor=1d0/nc**3*facRV             ! db Qb -> ub Qb nu lp     Ct0g1W
      case(301)
         factor=1d0/nc**3*facRV             ! Q db -> ub Q nu lp      Ct0g1W
      case(302)
         factor=1d0/nc**3*facRV             ! db Q -> ub Q nu lp      Ct0g1W
      case(303)
         factor=1d0/nc**3*nup*facRV         ! Q g subtraction         Ct0g1W
      case(304)
         factor=1d0/nc**3*nup*facRV         ! Qb g subtraction        Ct0g1W
      case(305)
         factor=1d0/nc**3*nup*facRV         ! g Q subtraction         Ct0g1W
      case(306)
         factor=1d0/nc**3*nup*facRV         ! g Qb subtraction        Ct0g1W
      case(307)
         factor=1d0/nc**3*nf*facRV          ! g u subtraction         Ct0g1W
      case(308)
         factor=1d0/nc**3*nf*facRV          ! g db subtraction        Ct0g1W
      case(309)
         factor=1d0/nc**3*nf*facRV          ! u g subtraction         Ct0g1W
      case(310)
         factor=1d0/nc**3*nf*facRV          ! db g subtraction        Ct0g1W
      case(311)
         factor=1d0/nc**2*nf*facRV          ! u Qb -> Qb d nu lp      Ch0g1W
      case(312)
         factor=1d0/nc**2*nf*facRV          ! u Q -> Q d nu lp        Ch0g1W
      case(313)
         factor=1d0/nc**2*nf*nf*facRV       ! u db -> Q Qb nu lp      Ch0g1W
      case(314)
         factor=1d0/nc**2*nf*facRV          ! Qb u -> Qb d nu lp      Ch0g1W
      case(315)
         factor=1d0/nc**2*nf*facRV          ! Q u -> Q d nu lp        Ch0g1W
      case(316)
         factor=1d0/nc**2*nf*nf*facRV       ! db u -> Q Qb nu lp      Ch0g1W
      case(317)
         factor=1d0/nc**2*nf*nup*facRV      ! Qb Q -> ub d nu lp      Ch0g1W
      case(318)
         factor=1d0/nc**2*nf*facRV          ! Qb db -> ub Qb nu lp     Ch0g1W
      case(319)
         factor=1d0/nc**2*nf*nup*facRV      ! Q Qb -> ub d nu lp      Ch0g1W
      case(320)
         factor=1d0/nc**2*nf*facRV          ! db Qb -> ub Qb nu lp     Ch0g1W
      case(321)
         factor=1d0/nc**2*nf*facRV          ! Q db -> ub Q nu lp      Ch0g1W
      case(322)
         factor=1d0/nc**2*nf*facRV          ! db Q -> ub Q nu lp      Ch0g1W
      case(323)
         factor=1d0/nc**2*nf*nup*facRV      ! Q g subtraction         Ch0g1W
      case(324)
         factor=1d0/nc**2*nf*nup*facRV      ! Qb g subtraction        Ch0g1W
      case(325)
         factor=1d0/nc**2*nf*nup*facRV      ! g Q subtraction         Ch0g1W
      case(326)
         factor=1d0/nc**2*nf*nup*facRV      ! g Qb subtraction        Ch0g1W
      case(327)
         factor=1d0/nc**2*nf**2*facRV       ! g u subtraction         Ch0g1W
      case(328)
         factor=1d0/nc**2*nf**2*facRV       ! g db subtraction        Ch0g1W
      case(329)
         factor=1d0/nc**2*nf**2*facRV       ! u g subtraction         Ch0g1W
      case(330)
         factor=1d0/nc**2*nf**2*facRV       ! db g subtraction        Ch0g1W
      case(331)
         factor=1d0/nc**2*facRV             ! u ub -> ub d nu lp      D0g1Wpa
      case(332)
         factor=1d0/nc**2*facRV             ! u u -> u d nu lp        D0g1Wpa
      case(333)
         factor=1d0/nc**2*facRV             ! u db -> u ub nu lp      D0g1Wpa
      case(334)
         factor=1d0/nc**2*facRV             ! ub u -> ub d nu lp      D0g1Wpa
      case(335)
         factor=1d0/nc**2*facRV             ! db u -> u ub nu lp      D0g1Wpa
      case(336)
         factor=1d0/nc**2*1d0/2d0*facRV     ! ub db -> ub ub nu lp     D0g1Wpa
      case(337)
         factor=1d0/nc**2*1d0/2d0*facRV     ! db ub -> ub ub nu lp     D0g1Wpa
      case(338)
         factor=1d0/nc**2*facRV             ! d g subtraction         D0g1Wpa
      case(339)
         factor=1d0/nc**2*facRV             ! g d subtraction         D0g1Wpa
      case(340)
         factor=1d0/nc**2*facRV             ! g u subtraction         D0g1Wpa
      case(341)
         factor=1d0/nc**2*facRV             ! g ub subtraction        D0g1Wpa
      case(342)
         factor=1d0/nc**2*facRV             ! u g subtraction         D0g1Wpa
      case(343)
         factor=1d0/nc**2*facRV             ! ub g subtraction        D0g1Wpa
      case(344)
         factor=1d0/nc**2*facRV             ! u db -> db d nu lp      D0g1Wpb
      case(345)
         factor=1d0/nc**2*1d0/2d0*facRV     ! u d -> d d nu lp        D0g1Wpb
      case(346)
         factor=1d0/nc**2*facRV             ! db u -> db d nu lp      D0g1Wpb
      case(347)
         factor=1d0/nc**2*1d0/2d0*facRV     ! d u -> d d nu lp        D0g1Wpb
      case(348)
         factor=1d0/nc**2*facRV             ! db d -> ub d nu lp      D0g1Wpb
      case(349)
         factor=1d0/nc**2*facRV             ! db db -> ub db nu lp     D0g1Wpb
      case(350)
         factor=1d0/nc**2*facRV             ! d db -> ub d nu lp      D0g1Wpb
      case(351)
         factor=1d0/nc**2*facRV             ! d g subtraction         D0g1Wpb
      case(352)
         factor=1d0/nc**2*facRV             ! db g subtraction        D0g1Wpb
      case(353)
         factor=1d0/nc**2*facRV             ! g d subtraction         D0g1Wpb
      case(354)
         factor=1d0/nc**2*facRV             ! g db subtraction        D0g1Wpb
      case(355)
         factor=1d0/nc**2*facRV             ! g ub subtraction        D0g1Wpb
      case(356)
         factor=1d0/nc**2*facRV             ! ub g subtraction        D0g1Wpb
      case(357)
         factor=1d0/nc**4*facRV             ! u ub -> ub d nu lp      Dt0g1Wpa
      case(358)
         factor=1d0/nc**4*facRV             ! u u -> u d nu lp        Dt0g1Wpa
      case(359)
         factor=1d0/nc**4*facRV             ! u db -> u ub nu lp      Dt0g1Wpa
      case(360)
         factor=1d0/nc**4*facRV             ! ub u -> ub d nu lp      Dt0g1Wpa
      case(361)
         factor=1d0/nc**4*facRV             ! db u -> u ub nu lp      Dt0g1Wpa
      case(362)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub db -> ub ub nu lp     Dt0g1Wpa
      case(363)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db ub -> ub ub nu lp     Dt0g1Wpa
      case(364)
         factor=1d0/nc**4*facRV             ! d g subtraction         Dt0g1Wpa
      case(365)
         factor=1d0/nc**4*facRV             ! g d subtraction         Dt0g1Wpa
      case(366)
         factor=1d0/nc**4*facRV             ! g u subtraction         Dt0g1Wpa
      case(367)
         factor=1d0/nc**4*facRV             ! g ub subtraction        Dt0g1Wpa
      case(368)
         factor=1d0/nc**4*facRV             ! u g subtraction         Dt0g1Wpa
      case(369)
         factor=1d0/nc**4*facRV             ! ub g subtraction        Dt0g1Wpa
      case(370)
         factor=1d0/nc**4*facRV             ! u db -> db d nu lp      Dt0g1Wpb
      case(371)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u d -> d d nu lp        Dt0g1Wpb
      case(372)
         factor=1d0/nc**4*facRV             ! db u -> db d nu lp      Dt0g1Wpb
      case(373)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d u -> d d nu lp        Dt0g1Wpb
      case(374)
         factor=1d0/nc**4*facRV             ! db d -> ub d nu lp      Dt0g1Wpb
      case(375)
         factor=1d0/nc**4*facRV             ! db db -> ub db nu lp     Dt0g1Wpb
      case(376)
         factor=1d0/nc**4*facRV             ! d db -> ub d nu lp      Dt0g1Wpb
      case(377)
         factor=1d0/nc**4*facRV             ! d g subtraction         Dt0g1Wpb
      case(378)
         factor=1d0/nc**4*facRV             ! db g subtraction        Dt0g1Wpb
      case(379)
         factor=1d0/nc**4*facRV             ! g d subtraction         Dt0g1Wpb
      case(380)
         factor=1d0/nc**4*facRV             ! g db subtraction        Dt0g1Wpb
      case(381)
         factor=1d0/nc**4*facRV             ! g ub subtraction        Dt0g1Wpb
      case(382)
         factor=1d0/nc**4*facRV             ! ub g subtraction        Dt0g1Wpb
      case(383)
         factor=1d0/nc**3*nf*facRV          ! u ub -> ub d nu lp      Dh0g1Wpa
      case(384)
         factor=1d0/nc**3*nf*facRV          ! u u -> u d nu lp        Dh0g1Wpa
      case(385)
         factor=1d0/nc**3*nf*facRV          ! u db -> u ub nu lp      Dh0g1Wpa
      case(386)
         factor=1d0/nc**3*nf*facRV          ! ub u -> ub d nu lp      Dh0g1Wpa
      case(387)
         factor=1d0/nc**3*nf*facRV          ! db u -> u ub nu lp      Dh0g1Wpa
      case(388)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! ub db -> ub ub nu lp     Dh0g1Wpa
      case(389)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! db ub -> ub ub nu lp     Dh0g1Wpa
      case(390)
         factor=1d0/nc**3*nf*facRV          ! d g subtraction         Dh0g1Wpa
      case(391)
         factor=1d0/nc**3*nf*facRV          ! g d subtraction         Dh0g1Wpa
      case(392)
         factor=1d0/nc**3*nf*facRV          ! g u subtraction         Dh0g1Wpa
      case(393)
         factor=1d0/nc**3*nf*facRV          ! g ub subtraction        Dh0g1Wpa
      case(394)
         factor=1d0/nc**3*nf*facRV          ! u g subtraction         Dh0g1Wpa
      case(395)
         factor=1d0/nc**3*nf*facRV          ! ub g subtraction        Dh0g1Wpa
      case(396)
         factor=1d0/nc**3*nf*facRV          ! u db -> db d nu lp      Dh0g1Wpb
      case(397)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! u d -> d d nu lp        Dh0g1Wpb
      case(398)
         factor=1d0/nc**3*nf*facRV          ! db u -> db d nu lp      Dh0g1Wpb
      case(399)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! d u -> d d nu lp        Dh0g1Wpb
      case(400)
         factor=1d0/nc**3*nf*facRV          ! db d -> ub d nu lp      Dh0g1Wpb
      case(401)
         factor=1d0/nc**3*nf*facRV          ! db db -> ub db nu lp     Dh0g1Wpb
      case(402)
         factor=1d0/nc**3*nf*facRV          ! d db -> ub d nu lp      Dh0g1Wpb
      case(403)
         factor=1d0/nc**3*nf*facRV          ! d g subtraction         Dh0g1Wpb
      case(404)
         factor=1d0/nc**3*nf*facRV          ! db g subtraction        Dh0g1Wpb
      case(405)
         factor=1d0/nc**3*nf*facRV          ! g d subtraction         Dh0g1Wpb
      case(406)
         factor=1d0/nc**3*nf*facRV          ! g db subtraction        Dh0g1Wpb
      case(407)
         factor=1d0/nc**3*nf*facRV          ! g ub subtraction        Dh0g1Wpb
      case(408)
         factor=1d0/nc**3*nf*facRV          ! ub g subtraction        Dh0g1Wpb

c -- double virtual

      case(409)
         factor=facVV                       ! u g -> d nu lp          B1g2Wp
      case(410)
         factor=facVV                       ! u db -> g nu lp         B1g2Wp
      case(411)
         factor=facVV                       ! g u -> d nu lp          B1g2Wp
      case(412)
         factor=facVV                       ! db u -> g nu lp         B1g2Wp
      case(413)
         factor=facVV                       ! g db -> ub nu lp        B1g2Wp
      case(414)
         factor=facVV                       ! db g -> ub nu lp        B1g2Wp
      case(415)
         factor=1d0/nc*facVV                ! Q u subtraction         B1g2Wp
      case(416)
         factor=1d0/nc*facVV                ! Q db subtraction        B1g2Wp
      case(417)
         factor=1d0/nc*facVV                ! Qb u subtraction        B1g2Wp
      case(418)
         factor=1d0/nc*facVV                ! Qb db subtraction       B1g2Wp
      case(419)
         factor=facVV                       ! d g subtraction         B1g2Wp
      case(420)
         factor=1d0/nc**2*facVV             ! d u subtraction         B1g2Wp
      case(421)
         factor=1d0/nc**2*facVV             ! db ub subtraction       B1g2Wp
      case(422)
         factor=facVV                       ! g d subtraction         B1g2Wp
      case(423)
         factor=nup*facVV                   ! g g subtraction         B1g2Wp
      case(424)
         factor=facVV                       ! g ub subtraction        B1g2Wp
      case(425)
         factor=1d0/nc*facVV                ! u Q subtraction         B1g2Wp
      case(426)
         factor=1d0/nc*facVV                ! u Qb subtraction        B1g2Wp
      case(427)
         factor=1d0/nc*facVV                ! db Q subtraction        B1g2Wp
      case(428)
         factor=1d0/nc*facVV                ! db Qb subtraction       B1g2Wp
      case(429)
         factor=1d0/nc**2*facVV             ! u d subtraction         B1g2Wp
      case(430)
         factor=1d0/nc**2*facVV             ! ub db subtraction       B1g2Wp
      case(431)
         factor=facVV                       ! ub g subtraction        B1g2Wp
      case(432)
         factor=-1d0/nc**2*facVV            ! u g -> d nu lp          Bt1g2Wp
      case(433)
         factor=-1d0/nc**2*facVV            ! u db -> g nu lp         Bt1g2Wp
      case(434)
         factor=-1d0/nc**2*facVV            ! g u -> d nu lp          Bt1g2Wp
      case(435)
         factor=-1d0/nc**2*facVV            ! db u -> g nu lp         Bt1g2Wp
      case(436)
         factor=-1d0/nc**2*facVV            ! g db -> ub nu lp        Bt1g2Wp
      case(437)
         factor=-1d0/nc**2*facVV            ! db g -> ub nu lp        Bt1g2Wp
      case(438)
         factor=-1d0/nc**3*facVV            ! Q u subtraction         Bt1g2Wp
      case(439)
         factor=-1d0/nc**3*facVV            ! Q db subtraction        Bt1g2Wp
      case(440)
         factor=-1d0/nc**3*facVV            ! Qb u subtraction        Bt1g2Wp
      case(441)
         factor=-1d0/nc**3*facVV            ! Qb db subtraction       Bt1g2Wp
      case(442)
         factor=-1d0/nc**2*facVV            ! d g subtraction         Bt1g2Wp
      case(443)
         factor=-1d0/nc**4*facVV            ! d u subtraction         Bt1g2Wp
      case(444)
         factor=-1d0/nc**4*facVV            ! db ub subtraction       Bt1g2Wp
      case(445)
         factor=-1d0/nc**2*facVV            ! g d subtraction         Bt1g2Wp
      case(446)
         factor=-1d0/nc**2*nup*facVV        ! g g subtraction         Bt1g2Wp
      case(447)
         factor=-1d0/nc**2*facVV            ! g ub subtraction        Bt1g2Wp
      case(448)
         factor=-1d0/nc**3*facVV            ! u Q subtraction         Bt1g2Wp
      case(449)
         factor=-1d0/nc**3*facVV            ! u Qb subtraction        Bt1g2Wp
      case(450)
         factor=-1d0/nc**3*facVV            ! db Q subtraction        Bt1g2Wp
      case(451)
         factor=-1d0/nc**3*facVV            ! db Qb subtraction       Bt1g2Wp
      case(452)
         factor=-1d0/nc**4*facVV            ! u d subtraction         Bt1g2Wp
      case(453)
         factor=-1d0/nc**4*facVV            ! ub db subtraction       Bt1g2Wp
      case(454)
         factor=-1d0/nc**2*facVV            ! ub g subtraction        Bt1g2Wp
      case(455)
         factor=1d0/nc**4*facVV             ! u g -> d nu lp          Btt1g2W
      case(456)
         factor=1d0/nc**4*facVV             ! u db -> g nu lp         Btt1g2W
      case(457)
         factor=1d0/nc**4*facVV             ! g u -> d nu lp          Btt1g2W
      case(458)
         factor=1d0/nc**4*facVV             ! db u -> g nu lp         Btt1g2W
      case(459)
         factor=1d0/nc**4*facVV             ! g db -> ub nu lp        Btt1g2W
      case(460)
         factor=1d0/nc**4*facVV             ! db g -> ub nu lp        Btt1g2W
      case(461)
         factor=1d0/nc**5*facVV             ! Q u subtraction         Btt1g2W
      case(462)
         factor=1d0/nc**5*facVV             ! Q db subtraction        Btt1g2W
      case(463)
         factor=1d0/nc**5*facVV             ! Qb u subtraction        Btt1g2W
      case(464)
         factor=1d0/nc**5*facVV             ! Qb db subtraction       Btt1g2W
      case(465)
         factor=1d0/nc**4*facVV             ! d g subtraction         Btt1g2W
      case(466)
         factor=1d0/nc**6*facVV             ! d u subtraction         Btt1g2W
      case(467)
         factor=1d0/nc**6*facVV             ! db ub subtraction       Btt1g2W
      case(468)
         factor=1d0/nc**4*facVV             ! g d subtraction         Btt1g2W
      case(469)
         factor=1d0/nc**4*nup*facVV         ! g g subtraction         Btt1g2W
      case(470)
         factor=1d0/nc**4*facVV             ! g ub subtraction        Btt1g2W
      case(471)
         factor=1d0/nc**5*facVV             ! u Q subtraction         Btt1g2W
      case(472)
         factor=1d0/nc**5*facVV             ! u Qb subtraction        Btt1g2W
      case(473)
         factor=1d0/nc**5*facVV             ! db Q subtraction        Btt1g2W
      case(474)
         factor=1d0/nc**5*facVV             ! db Qb subtraction       Btt1g2W
      case(475)
         factor=1d0/nc**6*facVV             ! u d subtraction         Btt1g2W
      case(476)
         factor=1d0/nc**6*facVV             ! ub db subtraction       Btt1g2W
      case(477)
         factor=1d0/nc**4*facVV             ! ub g subtraction        Btt1g2W
      case(478)
         factor=1d0/nc*nf*facVV             ! u g -> d nu lp          Bh1g2W
      case(479)
         factor=1d0/nc*nf*facVV             ! u db -> g nu lp         Bh1g2W
      case(480)
         factor=1d0/nc*nf*facVV             ! g u -> d nu lp          Bh1g2W
      case(481)
         factor=1d0/nc*nf*facVV             ! db u -> g nu lp         Bh1g2W
      case(482)
         factor=1d0/nc*nf*facVV             ! g db -> ub nu lp        Bh1g2W
      case(483)
         factor=1d0/nc*nf*facVV             ! db g -> ub nu lp        Bh1g2W
      case(484)
         factor=1d0/nc*nup*facVV            ! Q g subtraction         Bh1g2W
      case(485)
         factor=1d0/nc**2*nf*facVV          ! Q u subtraction         Bh1g2W
      case(486)
         factor=1d0/nc**2*nf*facVV          ! Q db subtraction        Bh1g2W
      case(487)
         factor=1d0/nc*nup*facVV            ! Qb g subtraction        Bh1g2W
      case(488)
         factor=1d0/nc**2*nf*facVV          ! Qb u subtraction        Bh1g2W
      case(489)
         factor=1d0/nc**2*nf*facVV          ! Qb db subtraction       Bh1g2W
      case(490)
         factor=1d0/nc**3*nf*facVV          ! d u subtraction         Bh1g2W
      case(491)
         factor=1d0/nc**3*nf*facVV          ! db ub subtraction       Bh1g2W
      case(492)
         factor=1d0/nc*nup*facVV            ! g Q subtraction         Bh1g2W
      case(493)
         factor=1d0/nc*nup*facVV            ! g Qb subtraction        Bh1g2W
      case(494)
         factor=1d0/nc*nf*nup*facVV         ! g g subtraction         Bh1g2W
      case(495)
         factor=1d0/nc**2*nf*facVV          ! u Q subtraction         Bh1g2W
      case(496)
         factor=1d0/nc**2*nf*facVV          ! u Qb subtraction        Bh1g2W
      case(497)
         factor=1d0/nc**2*nf*facVV          ! db Q subtraction        Bh1g2W
      case(498)
         factor=1d0/nc**2*nf*facVV          ! db Qb subtraction       Bh1g2W
      case(499)
         factor=1d0/nc**3*nf*facVV          ! u d subtraction         Bh1g2W
      case(500)
         factor=1d0/nc**3*nf*facVV          ! ub db subtraction       Bh1g2W
      case(501)
         factor=1d0/nc**3*nf*facVV          ! u g -> d nu lp          Bht1g2W
      case(502)
         factor=1d0/nc**3*nf*facVV          ! u db -> g nu lp         Bht1g2W
      case(503)
         factor=1d0/nc**3*nf*facVV          ! g u -> d nu lp          Bht1g2W
      case(504)
         factor=1d0/nc**3*nf*facVV          ! db u -> g nu lp         Bht1g2W
      case(505)
         factor=1d0/nc**3*nf*facVV          ! g db -> ub nu lp        Bht1g2W
      case(506)
         factor=1d0/nc**3*nf*facVV          ! db g -> ub nu lp        Bht1g2W
      case(507)
         factor=1d0/nc**3*nup*facVV         ! Q g subtraction         Bht1g2W
      case(508)
         factor=1d0/nc**4*nf*facVV          ! Q u subtraction         Bht1g2W
      case(509)
         factor=1d0/nc**4*nf*facVV          ! Q db subtraction        Bht1g2W
      case(510)
         factor=1d0/nc**3*nup*facVV         ! Qb g subtraction        Bht1g2W
      case(511)
         factor=1d0/nc**4*nf*facVV          ! Qb u subtraction        Bht1g2W
      case(512)
         factor=1d0/nc**4*nf*facVV          ! Qb db subtraction       Bht1g2W
      case(513)
         factor=1d0/nc**5*nf*facVV          ! d u subtraction         Bht1g2W
      case(514)
         factor=1d0/nc**5*nf*facVV          ! db ub subtraction       Bht1g2W
      case(515)
         factor=1d0/nc**3*nup*facVV         ! g Q subtraction         Bht1g2W
      case(516)
         factor=1d0/nc**3*nup*facVV         ! g Qb subtraction        Bht1g2W
      case(517)
         factor=1d0/nc**3*nf*nup*facVV      ! g g subtraction         Bht1g2W
      case(518)
         factor=1d0/nc**4*nf*facVV          ! u Q subtraction         Bht1g2W
      case(519)
         factor=1d0/nc**4*nf*facVV          ! u Qb subtraction        Bht1g2W
      case(520)
         factor=1d0/nc**4*nf*facVV          ! db Q subtraction        Bht1g2W
      case(521)
         factor=1d0/nc**4*nf*facVV          ! db Qb subtraction       Bht1g2W
      case(522)
         factor=1d0/nc**5*nf*facVV          ! u d subtraction         Bht1g2W
      case(523)
         factor=1d0/nc**5*nf*facVV          ! ub db subtraction       Bht1g2W
      case(524)
         factor=1d0/nc**2*nf**2*facVV       ! u g -> d nu lp          Bhh1g2W
      case(525)
         factor=1d0/nc**2*nf**2*facVV       ! u db -> g nu lp         Bhh1g2W
      case(526)
         factor=1d0/nc**2*nf**2*facVV       ! g u -> d nu lp          Bhh1g2W
      case(527)
         factor=1d0/nc**2*nf**2*facVV       ! db u -> g nu lp         Bhh1g2W
      case(528)
         factor=1d0/nc**2*nf**2*facVV       ! g db -> ub nu lp        Bhh1g2W
      case(529)
         factor=1d0/nc**2*nf**2*facVV       ! db g -> ub nu lp        Bhh1g2W
      case(530)
         factor=1d0/nc**2*nf*nup*facVV      ! Q g subtraction         Bhh1g2W
      case(531)
         factor=1d0/nc**3*nf**2*facVV       ! Q u subtraction         Bhh1g2W
      case(532)
         factor=1d0/nc**3*nf**2*facVV       ! Q db subtraction        Bhh1g2W
      case(533)
         factor=1d0/nc**2*nf*nup*facVV      ! Qb g subtraction        Bhh1g2W
      case(534)
         factor=1d0/nc**3*nf**2*facVV       ! Qb u subtraction        Bhh1g2W
      case(535)
         factor=1d0/nc**3*nf**2*facVV       ! Qb db subtraction       Bhh1g2W
      case(536)
         factor=1d0/nc**4*nf**2*facVV       ! d u subtraction         Bhh1g2W
      case(537)
         factor=1d0/nc**4*nf**2*facVV       ! db ub subtraction       Bhh1g2W
      case(538)
         factor=1d0/nc**2*nf*nup*facVV      ! g Q subtraction         Bhh1g2W
      case(539)
         factor=1d0/nc**2*nf*nup*facVV      ! g Qb subtraction        Bhh1g2W
      case(540)
         factor=1d0/nc**2*nf**2*nup*facVV   ! g g subtraction         Bhh1g2W
      case(541)
         factor=1d0/nc**3*nf**2*facVV       ! u Q subtraction         Bhh1g2W
      case(542)
         factor=1d0/nc**3*nf**2*facVV       ! u Qb subtraction        Bhh1g2W
      case(543)
         factor=1d0/nc**3*nf**2*facVV       ! db Q subtraction        Bhh1g2W
      case(544)
         factor=1d0/nc**3*nf**2*facVV       ! db Qb subtraction       Bhh1g2W
      case(545)
         factor=1d0/nc**4*nf**2*facVV       ! u d subtraction         Bhh1g2W
      case(546)
         factor=1d0/nc**4*nf**2*facVV       ! ub db subtraction       Bhh1g2W
      end select
      factor=relfactor*factor

      return
      end
