!********************************************************************
!
!
! Quark pair NNLO double real subtraction term for
!
! q(i1) g (i2) g (i3) g(i4) qb(i5) e-(i6) e+(i7)
!
! summed and squared over helicities, single colour ordering without
! overall factors
!
! The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BWFlav/

      function gqsB3g0WS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqsB3g0WS = qgsB3g0WS(i1,i2,i3,i4,i5,i6,i7)

      return
      end
      function gqbsB3g0WS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqbsB3g0WS = qbgsB3g0WS(i1,i2,i3,i4,i5,i6,i7)

      return
      end

      function qgsB3g0WS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qgsB3g0WS =+qgB3g0WYS(i1,i3,i2,i4,i5,i6,i7)
     .          +qgB3g0WXS(i1,i2,i3,i4,i5,i6,i7)
     .          +qgB3g0WXS(i1,i2,i4,i3,i5,i6,i7)

      return
      end

      function qbgsB3g0WS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbgsB3g0WS =+qbgB3g0WYS(i1,i3,i2,i4,i5,i6,i7)
     .            +qbgB3g0WXS(i1,i3,i4,i2,i5,i6,i7)
     .            +qbgB3g0WXS(i1,i4,i3,i2,i5,i6,i7)

      return
      end

      function ggsB3g0WS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

! Xuan's subtraction term
!      ggsB3g0WS = ggB3g0WFS_v1(i1,i2,i4,i3,i5,i6,i7)

C --- Aude's subtraction term
      ggsB3g0WS = ggB3g0WFS(i1,i2,i3,i4,i5,i6,i7)
     .           +ggB3g0WFS(i1,i3,i2,i4,i5,i6,i7)

      return
      end

      function qqbsB3g0WS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qqbsB3g0WS = B3g0WS(i1,i2,i3,i4,i5,i6,i7)
     .            +B3g0WS(i1,i2,i4,i3,i5,i6,i7)
     .            +B3g0WS(i1,i3,i2,i4,i5,i6,i7)

      return
      end

      function qbqsB3g0WS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbqsB3g0WS = qqbsB3g0WS(i1,i2,i3,i4,i5,i6,i7)

      return
      end

