      function sigRVWmJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use CKM_mod, only : ckmflag  
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRVWmJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,6,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(6, (/ 1, 2, 3, 4, 5, 6 /) )
#endif 

c--- d g to g u lm nub 
      if (qactive_chan(205).and.qselect_chan(205)) then
        current_chan = 205
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1W(1,2,3,4,5,6,muR2_scl(i))
     .          +sB2g1W(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g g lm nub 
      if (qactive_chan(206).and.qselect_chan(206)) then
        current_chan = 206
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1W(1,3,4,2,5,6,muR2_scl(i))
     .          +sB2g1W(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g u lm nub 
      if (qactive_chan(207).and.qselect_chan(207)) then
        current_chan = 207
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1W(2,1,3,4,5,6,muR2_scl(i))
     .          +sB2g1W(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g g lm nub 
      if (qactive_chan(208).and.qselect_chan(208)) then
        current_chan = 208
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1W(2,3,4,1,5,6,muR2_scl(i))
     .          +sB2g1W(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db u lm nub 
      if (qactive_chan(209).and.qselect_chan(209)) then
        current_chan = 209
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1W(3,1,2,4,5,6,muR2_scl(i))
     .          +sB2g1W(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db g lm nub 
      if (qactive_chan(210).and.qselect_chan(210)) then
        current_chan = 210
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1W(3,1,4,2,5,6,muR2_scl(i))
     .          +sB2g1W(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db g lm nub 
      if (qactive_chan(211).and.qselect_chan(211)) then
        current_chan = 211
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1W(3,2,4,1,5,6,muR2_scl(i))
     .          +sB2g1W(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to g u lm nub 
      if (qactive_chan(220).and.qselect_chan(220)) then
        current_chan = 220
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1W(1,2,3,4,5,6,muR2_scl(i))
     .          +sBt2g1W(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g g lm nub 
      if (qactive_chan(221).and.qselect_chan(221)) then
        current_chan = 221
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1W(1,3,4,2,5,6,muR2_scl(i))
     .          +sBt2g1W(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g u lm nub 
      if (qactive_chan(222).and.qselect_chan(222)) then
        current_chan = 222
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1W(2,1,3,4,5,6,muR2_scl(i))
     .          +sBt2g1W(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g g lm nub 
      if (qactive_chan(223).and.qselect_chan(223)) then
        current_chan = 223
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1W(2,3,4,1,5,6,muR2_scl(i))
     .          +sBt2g1W(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db u lm nub 
      if (qactive_chan(224).and.qselect_chan(224)) then
        current_chan = 224
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1W(3,1,2,4,5,6,muR2_scl(i))
     .          +sBt2g1W(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db g lm nub 
      if (qactive_chan(225).and.qselect_chan(225)) then
        current_chan = 225
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1W(3,1,4,2,5,6,muR2_scl(i))
     .          +sBt2g1W(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db g lm nub 
      if (qactive_chan(226).and.qselect_chan(226)) then
        current_chan = 226
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1W(3,2,4,1,5,6,muR2_scl(i))
     .          +sBt2g1W(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt u lm nub 
      if (qactive_chan(235).and.qselect_chan(235)) then
        current_chan = 235
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Wc(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to gt gt lm nub 
      if (qactive_chan(236).and.qselect_chan(236)) then
        current_chan = 236
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Wc(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt u lm nub 
      if (qactive_chan(237).and.qselect_chan(237)) then
        current_chan = 237
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Wc(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to gt gt lm nub 
      if (qactive_chan(238).and.qselect_chan(238)) then
        current_chan = 238
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Wc(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db u lm nub 
      if (qactive_chan(239).and.qselect_chan(239)) then
        current_chan = 239
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Wc(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to db gt lm nub 
      if (qactive_chan(240).and.qselect_chan(240)) then
        current_chan = 240
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Wc(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to db gt lm nub 
      if (qactive_chan(241).and.qselect_chan(241)) then
        current_chan = 241
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Wc(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt u lm nub 
      if (qactive_chan(242).and.qselect_chan(242)) then
        current_chan = 242
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1W(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to gt gt lm nub 
      if (qactive_chan(243).and.qselect_chan(243)) then
        current_chan = 243
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1W(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt u lm nub 
      if (qactive_chan(244).and.qselect_chan(244)) then
        current_chan = 244
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1W(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to gt gt lm nub 
      if (qactive_chan(245).and.qselect_chan(245)) then
        current_chan = 245
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1W(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db u lm nub 
      if (qactive_chan(246).and.qselect_chan(246)) then
        current_chan = 246
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1W(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to db gt lm nub 
      if (qactive_chan(247).and.qselect_chan(247)) then
        current_chan = 247
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1W(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to db gt lm nub 
      if (qactive_chan(248).and.qselect_chan(248)) then
        current_chan = 248
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1W(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to g u lm nub 
      if (qactive_chan(249).and.qselect_chan(249)) then
        current_chan = 249
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1W(1,2,3,4,5,6,muR2_scl(i))
     .          +sBh2g1W(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g g lm nub 
      if (qactive_chan(250).and.qselect_chan(250)) then
        current_chan = 250
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1W(1,3,4,2,5,6,muR2_scl(i))
     .          +sBh2g1W(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g u lm nub 
      if (qactive_chan(251).and.qselect_chan(251)) then
        current_chan = 251
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1W(2,1,3,4,5,6,muR2_scl(i))
     .          +sBh2g1W(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g g lm nub 
      if (qactive_chan(252).and.qselect_chan(252)) then
        current_chan = 252
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1W(2,3,4,1,5,6,muR2_scl(i))
     .          +sBh2g1W(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db u lm nub 
      if (qactive_chan(253).and.qselect_chan(253)) then
        current_chan = 253
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1W(3,1,2,4,5,6,muR2_scl(i))
     .          +sBh2g1W(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db g lm nub 
      if (qactive_chan(254).and.qselect_chan(254)) then
        current_chan = 254
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1W(3,1,4,2,5,6,muR2_scl(i))
     .          +sBh2g1W(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db g lm nub 
      if (qactive_chan(255).and.qselect_chan(255)) then
        current_chan = 255
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1W(3,2,4,1,5,6,muR2_scl(i))
     .          +sBh2g1W(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt u lm nub 
      if (qactive_chan(264).and.qselect_chan(264)) then
        current_chan = 264
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1W(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to gt gt lm nub 
      if (qactive_chan(265).and.qselect_chan(265)) then
        current_chan = 265
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1W(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt u lm nub 
      if (qactive_chan(266).and.qselect_chan(266)) then
        current_chan = 266
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1W(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to gt gt lm nub 
      if (qactive_chan(267).and.qselect_chan(267)) then
        current_chan = 267
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1W(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db u lm nub 
      if (qactive_chan(268).and.qselect_chan(268)) then
        current_chan = 268
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1W(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to db gt lm nub 
      if (qactive_chan(269).and.qselect_chan(269)) then
        current_chan = 269
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1W(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to db gt lm nub 
      if (qactive_chan(270).and.qselect_chan(270)) then
        current_chan = 270
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1W(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Qb to Qb u lm nub 
      if (qactive_chan(271).and.qselect_chan(271)) then
        current_chan = 271
        ip1_chan     = 41
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Q to Q u lm nub 
      if (qactive_chan(272).and.qselect_chan(272)) then
        current_chan = 272
        ip1_chan     = 41
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to Q Qb lm nub 
      if (qactive_chan(273).and.qselect_chan(273)) then
        current_chan = 273
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb d to Qb u lm nub 
      if (qactive_chan(274).and.qselect_chan(274)) then
        current_chan = 274
        ip1_chan     = -31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q d to Q u lm nub 
      if (qactive_chan(275).and.qselect_chan(275)) then
        current_chan = 275
        ip1_chan     = 31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(2,3,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to Q Qb lm nub 
      if (qactive_chan(276).and.qselect_chan(276)) then
        current_chan = 276
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb Q to db u lm nub 
      if (qactive_chan(277).and.qselect_chan(277)) then
        current_chan = 277
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb ub to db Qb lm nub 
      if (qactive_chan(278).and.qselect_chan(278)) then
        current_chan = 278
        ip1_chan     = -31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q Qb to db u lm nub 
      if (qactive_chan(279).and.qselect_chan(279)) then
        current_chan = 279
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(3,2,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Qb to db Qb lm nub 
      if (qactive_chan(280).and.qselect_chan(280)) then
        current_chan = 280
        ip1_chan     = -21
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q ub to db Q lm nub 
      if (qactive_chan(281).and.qselect_chan(281)) then
        current_chan = 281
        ip1_chan     = 31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,1,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(3,4,1,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Q to db Q lm nub 
      if (qactive_chan(282).and.qselect_chan(282)) then
        current_chan = 282
        ip1_chan     = -21
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1W(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Qb to Qb u lm nub 
      if (qactive_chan(291).and.qselect_chan(291)) then
        current_chan = 291
        ip1_chan     = 41
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Q to Q u lm nub 
      if (qactive_chan(292).and.qselect_chan(292)) then
        current_chan = 292
        ip1_chan     = 41
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to Q Qb lm nub 
      if (qactive_chan(293).and.qselect_chan(293)) then
        current_chan = 293
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb d to Qb u lm nub 
      if (qactive_chan(294).and.qselect_chan(294)) then
        current_chan = 294
        ip1_chan     = -31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q d to Q u lm nub 
      if (qactive_chan(295).and.qselect_chan(295)) then
        current_chan = 295
        ip1_chan     = 31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(2,3,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to Q Qb lm nub 
      if (qactive_chan(296).and.qselect_chan(296)) then
        current_chan = 296
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb Q to db u lm nub 
      if (qactive_chan(297).and.qselect_chan(297)) then
        current_chan = 297
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb ub to db Qb lm nub 
      if (qactive_chan(298).and.qselect_chan(298)) then
        current_chan = 298
        ip1_chan     = -31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q Qb to db u lm nub 
      if (qactive_chan(299).and.qselect_chan(299)) then
        current_chan = 299
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(3,2,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Qb to db Qb lm nub 
      if (qactive_chan(300).and.qselect_chan(300)) then
        current_chan = 300
        ip1_chan     = -21
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q ub to db Q lm nub 
      if (qactive_chan(301).and.qselect_chan(301)) then
        current_chan = 301
        ip1_chan     = 31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,1,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(3,4,1,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Q to db Q lm nub 
      if (qactive_chan(302).and.qselect_chan(302)) then
        current_chan = 302
        ip1_chan     = -21
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1W(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Qb to Qb u lm nub 
      if (qactive_chan(311).and.qselect_chan(311)) then
        current_chan = 311
        ip1_chan     = 41
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Q to Q u lm nub 
      if (qactive_chan(312).and.qselect_chan(312)) then
        current_chan = 312
        ip1_chan     = 41
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to Q Qb lm nub 
      if (qactive_chan(313).and.qselect_chan(313)) then
        current_chan = 313
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb d to Qb u lm nub 
      if (qactive_chan(314).and.qselect_chan(314)) then
        current_chan = 314
        ip1_chan     = -31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q d to Q u lm nub 
      if (qactive_chan(315).and.qselect_chan(315)) then
        current_chan = 315
        ip1_chan     = 31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(2,3,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to Q Qb lm nub 
      if (qactive_chan(316).and.qselect_chan(316)) then
        current_chan = 316
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb Q to db u lm nub 
      if (qactive_chan(317).and.qselect_chan(317)) then
        current_chan = 317
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb ub to db Qb lm nub 
      if (qactive_chan(318).and.qselect_chan(318)) then
        current_chan = 318
        ip1_chan     = -31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q Qb to db u lm nub 
      if (qactive_chan(319).and.qselect_chan(319)) then
        current_chan = 319
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(3,2,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Qb to db Qb lm nub 
      if (qactive_chan(320).and.qselect_chan(320)) then
        current_chan = 320
        ip1_chan     = -21
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q ub to db Q lm nub 
      if (qactive_chan(321).and.qselect_chan(321)) then
        current_chan = 321
        ip1_chan     = 31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,1,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(3,4,1,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Q to db Q lm nub 
      if (qactive_chan(322).and.qselect_chan(322)) then
        current_chan = 322
        ip1_chan     = -21
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1W(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db u lm nub 
      if (qactive_chan(331).and.qselect_chan(331)) then
        current_chan = 331
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wma(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d u lm nub 
      if (qactive_chan(332).and.qselect_chan(332)) then
        current_chan = 332
        ip1_chan     = 40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wma(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to d db lm nub 
      if (qactive_chan(333).and.qselect_chan(333)) then
        current_chan = 333
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wma(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db u lm nub 
      if (qactive_chan(334).and.qselect_chan(334)) then
        current_chan = 334
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wma(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to d db lm nub 
      if (qactive_chan(335).and.qselect_chan(335)) then
        current_chan = 335
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wma(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db db lm nub 
      if (qactive_chan(336).and.qselect_chan(336)) then
        current_chan = 336
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wma(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to db db lm nub 
      if (qactive_chan(337).and.qselect_chan(337)) then
        current_chan = 337
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wma(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to ub u lm nub 
      if (qactive_chan(344).and.qselect_chan(344)) then
        current_chan = 344
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wmb(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to u u lm nub 
      if (qactive_chan(345).and.qselect_chan(345)) then
        current_chan = 345
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wmb(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to ub u lm nub 
      if (qactive_chan(346).and.qselect_chan(346)) then
        current_chan = 346
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wmb(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to u u lm nub 
      if (qactive_chan(347).and.qselect_chan(347)) then
        current_chan = 347
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wmb(2,3,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to db u lm nub 
      if (qactive_chan(348).and.qselect_chan(348)) then
        current_chan = 348
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wmb(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to db ub lm nub 
      if (qactive_chan(349).and.qselect_chan(349)) then
        current_chan = 349
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wmb(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to db u lm nub 
      if (qactive_chan(350).and.qselect_chan(350)) then
        current_chan = 350
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Wmb(3,2,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db u lm nub 
      if (qactive_chan(357).and.qselect_chan(357)) then
        current_chan = 357
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wma(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d u lm nub 
      if (qactive_chan(358).and.qselect_chan(358)) then
        current_chan = 358
        ip1_chan     = 40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wma(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to d db lm nub 
      if (qactive_chan(359).and.qselect_chan(359)) then
        current_chan = 359
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wma(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db u lm nub 
      if (qactive_chan(360).and.qselect_chan(360)) then
        current_chan = 360
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wma(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to d db lm nub 
      if (qactive_chan(361).and.qselect_chan(361)) then
        current_chan = 361
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wma(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db db lm nub 
      if (qactive_chan(362).and.qselect_chan(362)) then
        current_chan = 362
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wma(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to db db lm nub 
      if (qactive_chan(363).and.qselect_chan(363)) then
        current_chan = 363
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wma(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to ub u lm nub 
      if (qactive_chan(370).and.qselect_chan(370)) then
        current_chan = 370
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wmb(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to u u lm nub 
      if (qactive_chan(371).and.qselect_chan(371)) then
        current_chan = 371
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wmb(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to ub u lm nub 
      if (qactive_chan(372).and.qselect_chan(372)) then
        current_chan = 372
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wmb(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to u u lm nub 
      if (qactive_chan(373).and.qselect_chan(373)) then
        current_chan = 373
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wmb(2,3,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to db u lm nub 
      if (qactive_chan(374).and.qselect_chan(374)) then
        current_chan = 374
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wmb(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to db ub lm nub 
      if (qactive_chan(375).and.qselect_chan(375)) then
        current_chan = 375
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wmb(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to db u lm nub 
      if (qactive_chan(376).and.qselect_chan(376)) then
        current_chan = 376
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Wmb(3,2,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db u lm nub 
      if (qactive_chan(383).and.qselect_chan(383)) then
        current_chan = 383
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wma(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d u lm nub 
      if (qactive_chan(384).and.qselect_chan(384)) then
        current_chan = 384
        ip1_chan     = 40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wma(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to d db lm nub 
      if (qactive_chan(385).and.qselect_chan(385)) then
        current_chan = 385
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wma(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db u lm nub 
      if (qactive_chan(386).and.qselect_chan(386)) then
        current_chan = 386
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wma(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to d db lm nub 
      if (qactive_chan(387).and.qselect_chan(387)) then
        current_chan = 387
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wma(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db db lm nub 
      if (qactive_chan(388).and.qselect_chan(388)) then
        current_chan = 388
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wma(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to db db lm nub 
      if (qactive_chan(389).and.qselect_chan(389)) then
        current_chan = 389
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wma(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to ub u lm nub 
      if (qactive_chan(396).and.qselect_chan(396)) then
        current_chan = 396
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wmb(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to u u lm nub 
      if (qactive_chan(397).and.qselect_chan(397)) then
        current_chan = 397
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wmb(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to ub u lm nub 
      if (qactive_chan(398).and.qselect_chan(398)) then
        current_chan = 398
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wmb(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to u u lm nub 
      if (qactive_chan(399).and.qselect_chan(399)) then
        current_chan = 399
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wmb(2,3,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to db u lm nub 
      if (qactive_chan(400).and.qselect_chan(400)) then
        current_chan = 400
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wmb(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to db ub lm nub 
      if (qactive_chan(401).and.qselect_chan(401)) then
        current_chan = 401
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wmb(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to db u lm nub 
      if (qactive_chan(402).and.qselect_chan(402)) then
        current_chan = 402
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,1,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Wmb(3,2,1,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRVWmJ=rnorm*wtsum

      return
      end
