      function sigTWpJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTWpJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(6,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(6,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- u g to g d nu lp    
        if (qactive_chan(205).and.qselect_chan(205)) then
          current_chan = 205
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qgsB2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to g g nu lp   
        if (qactive_chan(206).and.qselect_chan(206)) then
          current_chan = 206
          ip1_chan     = 20
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .true.
          wt = qqbsB2g1WT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g d nu lp    
        if (qactive_chan(207).and.qselect_chan(207)) then
          current_chan = 207
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .false.
          wt = gqsB2g1WT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to g g nu lp   
        if (qactive_chan(208).and.qselect_chan(208)) then
          current_chan = 208
          ip1_chan     = -40
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .true.
          wt = qbqsB2g1WT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub d nu lp   
        if (qactive_chan(209).and.qselect_chan(209)) then
          current_chan = 209
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ggsB2g1WT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to ub g nu lp  
        if (qactive_chan(210).and.qselect_chan(210)) then
          current_chan = 210
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .false.
          wt = gqbsB2g1WT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to ub g nu lp  
        if (qactive_chan(211).and.qselect_chan(211)) then
          current_chan = 211
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qbgsB2g1WT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q u initiated       
        if (qactive_chan(212).and.qselect_chan(212)) then
          current_chan = 212
          ip1_chan     = 31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqsB2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q db initiated      
        if (qactive_chan(213).and.qselect_chan(213)) then
          current_chan = 213
          ip1_chan     = 31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbsB2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb u initiated      
        if (qactive_chan(214).and.qselect_chan(214)) then
          current_chan = 214
          ip1_chan     = -31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqsB2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb db initiated     
        if (qactive_chan(215).and.qselect_chan(215)) then
          current_chan = 215
          ip1_chan     = -31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbsB2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Q initiated       
        if (qactive_chan(216).and.qselect_chan(216)) then
          current_chan = 216
          ip1_chan     = 21
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpsB2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Qb initiated      
        if (qactive_chan(217).and.qselect_chan(217)) then
          current_chan = 217
          ip1_chan     = 21
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbsB2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Q initiated      
        if (qactive_chan(218).and.qselect_chan(218)) then
          current_chan = 218
          ip1_chan     = -41
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpsB2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Qb initiated     
        if (qactive_chan(219).and.qselect_chan(219)) then
          current_chan = 219
          ip1_chan     = -41
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbsB2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to g d nu lp    
        if (qactive_chan(220).and.qselect_chan(220)) then
          current_chan = 220
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qgsBt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to g g nu lp   
        if (qactive_chan(221).and.qselect_chan(221)) then
          current_chan = 221
          ip1_chan     = 20
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .true.
          wt = qqbsBt2g1WT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g d nu lp    
        if (qactive_chan(222).and.qselect_chan(222)) then
          current_chan = 222
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .false.
          wt = gqsBt2g1WT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to g g nu lp   
        if (qactive_chan(223).and.qselect_chan(223)) then
          current_chan = 223
          ip1_chan     = -40
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .true.
          wt = qbqsBt2g1WT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub d nu lp   
        if (qactive_chan(224).and.qselect_chan(224)) then
          current_chan = 224
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ggsBt2g1WT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to ub g nu lp  
        if (qactive_chan(225).and.qselect_chan(225)) then
          current_chan = 225
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .false.
          wt = gqbsBt2g1WT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to ub g nu lp  
        if (qactive_chan(226).and.qselect_chan(226)) then
          current_chan = 226
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qbgsBt2g1WT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q u initiated       
        if (qactive_chan(227).and.qselect_chan(227)) then
          current_chan = 227
          ip1_chan     = 31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqsBt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q db initiated      
        if (qactive_chan(228).and.qselect_chan(228)) then
          current_chan = 228
          ip1_chan     = 31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbsBt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb u initiated      
        if (qactive_chan(229).and.qselect_chan(229)) then
          current_chan = 229
          ip1_chan     = -31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqsBt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb db initiated     
        if (qactive_chan(230).and.qselect_chan(230)) then
          current_chan = 230
          ip1_chan     = -31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbsBt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Q initiated       
        if (qactive_chan(231).and.qselect_chan(231)) then
          current_chan = 231
          ip1_chan     = 21
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpsBt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Qb initiated      
        if (qactive_chan(232).and.qselect_chan(232)) then
          current_chan = 232
          ip1_chan     = 21
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbsBt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Q initiated      
        if (qactive_chan(233).and.qselect_chan(233)) then
          current_chan = 233
          ip1_chan     = -41
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpsBt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Qb initiated     
        if (qactive_chan(234).and.qselect_chan(234)) then
          current_chan = 234
          ip1_chan     = -41
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbsBt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u gt to gt d nu lp  
        if (qactive_chan(235).and.qselect_chan(235)) then
          current_chan = 235
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qgtsBtt2g1WcT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to gt gt nu lp 
        if (qactive_chan(236).and.qselect_chan(236)) then
          current_chan = 236
          ip1_chan     = 20
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .true.
          wt = qqbsBtt2g1WcT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt u to gt d nu lp  
        if (qactive_chan(237).and.qselect_chan(237)) then
          current_chan = 237
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .false.
          wt = gtqsBtt2g1WcT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to gt gt nu lp 
        if (qactive_chan(238).and.qselect_chan(238)) then
          current_chan = 238
          ip1_chan     = -40
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .true.
          wt = qbqsBtt2g1WcT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to ub d nu lp 
        if (qactive_chan(239).and.qselect_chan(239)) then
          current_chan = 239
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = gtgtsBtt2g1WcT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt db to ub gt nu lp 
        if (qactive_chan(240).and.qselect_chan(240)) then
          current_chan = 240
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .false.
          wt = gtqbsBtt2g1WcT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db gt to ub gt nu lp 
        if (qactive_chan(241).and.qselect_chan(241)) then
          current_chan = 241
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qbgtsBtt2g1WcT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u gt to gt d nu lp  
        if (qactive_chan(242).and.qselect_chan(242)) then
          current_chan = 242
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qgtsBttt2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to gt gt nu lp 
        if (qactive_chan(243).and.qselect_chan(243)) then
          current_chan = 243
          ip1_chan     = 20
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .true.
          wt = qqbsBttt2g1WT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt u to gt d nu lp  
        if (qactive_chan(244).and.qselect_chan(244)) then
          current_chan = 244
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .false.
          wt = gtqsBttt2g1WT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to gt gt nu lp 
        if (qactive_chan(245).and.qselect_chan(245)) then
          current_chan = 245
          ip1_chan     = -40
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .true.
          wt = qbqsBttt2g1WT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to ub d nu lp 
        if (qactive_chan(246).and.qselect_chan(246)) then
          current_chan = 246
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = gtgtsBttt2g1WT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt db to ub gt nu lp 
        if (qactive_chan(247).and.qselect_chan(247)) then
          current_chan = 247
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .false.
          wt = gtqbsBttt2g1WT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db gt to ub gt nu lp 
        if (qactive_chan(248).and.qselect_chan(248)) then
          current_chan = 248
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qbgtsBttt2g1WT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to g d nu lp    
        if (qactive_chan(249).and.qselect_chan(249)) then
          current_chan = 249
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qgsBh2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to g g nu lp   
        if (qactive_chan(250).and.qselect_chan(250)) then
          current_chan = 250
          ip1_chan     = 20
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .true.
          wt = qqbsBh2g1WT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g d nu lp    
        if (qactive_chan(251).and.qselect_chan(251)) then
          current_chan = 251
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .false.
          wt = gqsBh2g1WT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to g g nu lp   
        if (qactive_chan(252).and.qselect_chan(252)) then
          current_chan = 252
          ip1_chan     = -40
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .true.
          wt = qbqsBh2g1WT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub d nu lp   
        if (qactive_chan(253).and.qselect_chan(253)) then
          current_chan = 253
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ggsBh2g1WT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to ub g nu lp  
        if (qactive_chan(254).and.qselect_chan(254)) then
          current_chan = 254
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .false.
          wt = gqbsBh2g1WT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to ub g nu lp  
        if (qactive_chan(255).and.qselect_chan(255)) then
          current_chan = 255
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qbgsBh2g1WT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q u initiated       
        if (qactive_chan(256).and.qselect_chan(256)) then
          current_chan = 256
          ip1_chan     = 31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqsBh2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q db initiated      
        if (qactive_chan(257).and.qselect_chan(257)) then
          current_chan = 257
          ip1_chan     = 31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbsBh2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb u initiated      
        if (qactive_chan(258).and.qselect_chan(258)) then
          current_chan = 258
          ip1_chan     = -31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqsBh2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb db initiated     
        if (qactive_chan(259).and.qselect_chan(259)) then
          current_chan = 259
          ip1_chan     = -31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbsBh2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Q initiated       
        if (qactive_chan(260).and.qselect_chan(260)) then
          current_chan = 260
          ip1_chan     = 21
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpsBh2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Qb initiated      
        if (qactive_chan(261).and.qselect_chan(261)) then
          current_chan = 261
          ip1_chan     = 21
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbsBh2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Q initiated      
        if (qactive_chan(262).and.qselect_chan(262)) then
          current_chan = 262
          ip1_chan     = -41
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpsBh2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Qb initiated     
        if (qactive_chan(263).and.qselect_chan(263)) then
          current_chan = 263
          ip1_chan     = -41
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbsBh2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u gt to gt d nu lp  
        if (qactive_chan(264).and.qselect_chan(264)) then
          current_chan = 264
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qgtsBth2g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to gt gt nu lp 
        if (qactive_chan(265).and.qselect_chan(265)) then
          current_chan = 265
          ip1_chan     = 20
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .true.
          wt = qqbsBth2g1WT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt u to gt d nu lp  
        if (qactive_chan(266).and.qselect_chan(266)) then
          current_chan = 266
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .false.
          wt = gtqsBth2g1WT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to gt gt nu lp 
        if (qactive_chan(267).and.qselect_chan(267)) then
          current_chan = 267
          ip1_chan     = -40
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .true.
          wt = qbqsBth2g1WT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to ub d nu lp 
        if (qactive_chan(268).and.qselect_chan(268)) then
          current_chan = 268
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = gtgtsBth2g1WT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt db to ub gt nu lp 
        if (qactive_chan(269).and.qselect_chan(269)) then
          current_chan = 269
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .false.
          wt = gtqbsBth2g1WT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db gt to ub gt nu lp 
        if (qactive_chan(270).and.qselect_chan(270)) then
          current_chan = 270
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = qbgtsBth2g1WT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Qb to Qb d nu lp  
        if (qactive_chan(271).and.qselect_chan(271)) then
          current_chan = 271
          ip1_chan     = 21
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbsC0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Q to Q d nu lp    
        if (qactive_chan(272).and.qselect_chan(272)) then
          current_chan = 272
          ip1_chan     = 21
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpsC0g1WT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to Q Qb nu lp  
        if (qactive_chan(273).and.qselect_chan(273)) then
          current_chan = 273
          ip1_chan     = 20
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 4
          ckmflag = .true.
          wt = qqbsC0g1WT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb u to Qb d nu lp  
        if (qactive_chan(274).and.qselect_chan(274)) then
          current_chan = 274
          ip1_chan     = -31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqsC0g1WT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q u to Q d nu lp    
        if (qactive_chan(275).and.qselect_chan(275)) then
          current_chan = 275
          ip1_chan     = 31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqsC0g1WT(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to Q Qb nu lp  
        if (qactive_chan(276).and.qselect_chan(276)) then
          current_chan = 276
          ip1_chan     = -40
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 4
          ckmflag = .true.
          wt = qbqsC0g1WT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb Q to ub d nu lp  
        if (qactive_chan(277).and.qselect_chan(277)) then
          current_chan = 277
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqpsC0g1WT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb db to ub Qb nu lp 
        if (qactive_chan(278).and.qselect_chan(278)) then
          current_chan = 278
          ip1_chan     = -31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbsC0g1WT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q Qb to ub d nu lp  
        if (qactive_chan(279).and.qselect_chan(279)) then
          current_chan = 279
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqpbsC0g1WT(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Qb to ub Qb nu lp 
        if (qactive_chan(280).and.qselect_chan(280)) then
          current_chan = 280
          ip1_chan     = -41
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbsC0g1WT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q db to ub Q nu lp  
        if (qactive_chan(281).and.qselect_chan(281)) then
          current_chan = 281
          ip1_chan     = 31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbsC0g1WT(ix,xri1,xri2,3,4,1,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Q to ub Q nu lp  
        if (qactive_chan(282).and.qselect_chan(282)) then
          current_chan = 282
          ip1_chan     = -41
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpsC0g1WT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(283).and.qselect_chan(283)) then
          current_chan = 283
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpgsC0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(284).and.qselect_chan(284)) then
          current_chan = 284
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbgsC0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(285).and.qselect_chan(285)) then
          current_chan = 285
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqpsC0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(286).and.qselect_chan(286)) then
          current_chan = 286
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqpbsC0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(287).and.qselect_chan(287)) then
          current_chan = 287
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqsC0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(288).and.qselect_chan(288)) then
          current_chan = 288
          ip1_chan     = 0
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqbsC0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(289).and.qselect_chan(289)) then
          current_chan = 289
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qgsC0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(290).and.qselect_chan(290)) then
          current_chan = 290
          ip1_chan     = -40
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbgsC0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Qb to Qb d nu lp  
        if (qactive_chan(291).and.qselect_chan(291)) then
          current_chan = 291
          ip1_chan     = 21
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbCt0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Q to Q d nu lp    
        if (qactive_chan(292).and.qselect_chan(292)) then
          current_chan = 292
          ip1_chan     = 21
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpCt0g1WT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to Q Qb nu lp  
        if (qactive_chan(293).and.qselect_chan(293)) then
          current_chan = 293
          ip1_chan     = 20
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 4
          ckmflag = .true.
          wt = qqbCt0g1WT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb u to Qb d nu lp  
        if (qactive_chan(294).and.qselect_chan(294)) then
          current_chan = 294
          ip1_chan     = -31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqCt0g1WT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q u to Q d nu lp    
        if (qactive_chan(295).and.qselect_chan(295)) then
          current_chan = 295
          ip1_chan     = 31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqCt0g1WT(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to Q Qb nu lp  
        if (qactive_chan(296).and.qselect_chan(296)) then
          current_chan = 296
          ip1_chan     = -40
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 4
          ckmflag = .true.
          wt = qbqCt0g1WT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb Q to ub d nu lp  
        if (qactive_chan(297).and.qselect_chan(297)) then
          current_chan = 297
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqpCt0g1WT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb db to ub Qb nu lp 
        if (qactive_chan(298).and.qselect_chan(298)) then
          current_chan = 298
          ip1_chan     = -31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbCt0g1WT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q Qb to ub d nu lp  
        if (qactive_chan(299).and.qselect_chan(299)) then
          current_chan = 299
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqpbCt0g1WT(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Qb to ub Qb nu lp 
        if (qactive_chan(300).and.qselect_chan(300)) then
          current_chan = 300
          ip1_chan     = -41
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbCt0g1WT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q db to ub Q nu lp  
        if (qactive_chan(301).and.qselect_chan(301)) then
          current_chan = 301
          ip1_chan     = 31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbCt0g1WT(ix,xri1,xri2,3,4,1,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Q to ub Q nu lp  
        if (qactive_chan(302).and.qselect_chan(302)) then
          current_chan = 302
          ip1_chan     = -41
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpCt0g1WT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(303).and.qselect_chan(303)) then
          current_chan = 303
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpgCt0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(304).and.qselect_chan(304)) then
          current_chan = 304
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbgCt0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(305).and.qselect_chan(305)) then
          current_chan = 305
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqpCt0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(306).and.qselect_chan(306)) then
          current_chan = 306
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqpbCt0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(307).and.qselect_chan(307)) then
          current_chan = 307
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqCt0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(308).and.qselect_chan(308)) then
          current_chan = 308
          ip1_chan     = 0
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqbCt0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(309).and.qselect_chan(309)) then
          current_chan = 309
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qgCt0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(310).and.qselect_chan(310)) then
          current_chan = 310
          ip1_chan     = -40
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbgCt0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Qb to Qb d nu lp  
        if (qactive_chan(311).and.qselect_chan(311)) then
          current_chan = 311
          ip1_chan     = 21
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbCh0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u Q to Q d nu lp    
        if (qactive_chan(312).and.qselect_chan(312)) then
          current_chan = 312
          ip1_chan     = 21
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qqpCh0g1WT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to Q Qb nu lp  
        if (qactive_chan(313).and.qselect_chan(313)) then
          current_chan = 313
          ip1_chan     = 20
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 4
          ckmflag = .true.
          wt = qqbCh0g1WT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb u to Qb d nu lp  
        if (qactive_chan(314).and.qselect_chan(314)) then
          current_chan = 314
          ip1_chan     = -31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqCh0g1WT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q u to Q d nu lp    
        if (qactive_chan(315).and.qselect_chan(315)) then
          current_chan = 315
          ip1_chan     = 31
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqCh0g1WT(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to Q Qb nu lp  
        if (qactive_chan(316).and.qselect_chan(316)) then
          current_chan = 316
          ip1_chan     = -40
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 4
          ckmflag = .true.
          wt = qbqCh0g1WT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb Q to ub d nu lp  
        if (qactive_chan(317).and.qselect_chan(317)) then
          current_chan = 317
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqpCh0g1WT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb db to ub Qb nu lp 
        if (qactive_chan(318).and.qselect_chan(318)) then
          current_chan = 318
          ip1_chan     = -31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbCh0g1WT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q Qb to ub d nu lp  
        if (qactive_chan(319).and.qselect_chan(319)) then
          current_chan = 319
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqpbCh0g1WT(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Qb to ub Qb nu lp 
        if (qactive_chan(320).and.qselect_chan(320)) then
          current_chan = 320
          ip1_chan     = -41
          ip2_chan     = -31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbCh0g1WT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q db to ub Q nu lp  
        if (qactive_chan(321).and.qselect_chan(321)) then
          current_chan = 321
          ip1_chan     = 31
          ip2_chan     = -41
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbCh0g1WT(ix,xri1,xri2,3,4,1,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db Q to ub Q nu lp  
        if (qactive_chan(322).and.qselect_chan(322)) then
          current_chan = 322
          ip1_chan     = -41
          ip2_chan     = 31
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpCh0g1WT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(323).and.qselect_chan(323)) then
          current_chan = 323
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpgCh0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(324).and.qselect_chan(324)) then
          current_chan = 324
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qpbgCh0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(325).and.qselect_chan(325)) then
          current_chan = 325
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqpCh0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(326).and.qselect_chan(326)) then
          current_chan = 326
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqpbCh0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(327).and.qselect_chan(327)) then
          current_chan = 327
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqCh0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(328).and.qselect_chan(328)) then
          current_chan = 328
          ip1_chan     = 0
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = gqbCh0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(329).and.qselect_chan(329)) then
          current_chan = 329
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qgCh0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(330).and.qselect_chan(330)) then
          current_chan = 330
          ip1_chan     = -40
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 4
          ckmflag = .false.
          wt = qbgCh0g1WT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub d nu lp  
        if (qactive_chan(331).and.qselect_chan(331)) then
          current_chan = 331
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqbD0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u d nu lp    
        if (qactive_chan(332).and.qselect_chan(332)) then
          current_chan = 332
          ip1_chan     = 20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqD0g1WpaT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to u ub nu lp  
        if (qactive_chan(333).and.qselect_chan(333)) then
          current_chan = 333
          ip1_chan     = 20
          ip2_chan     = -40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qqpbD0g1WpaT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub d nu lp  
        if (qactive_chan(334).and.qselect_chan(334)) then
          current_chan = 334
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqD0g1WpaT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to u ub nu lp  
        if (qactive_chan(335).and.qselect_chan(335)) then
          current_chan = 335
          ip1_chan     = -40
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qpbqD0g1WpaT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to ub ub nu lp 
        if (qactive_chan(336).and.qselect_chan(336)) then
          current_chan = 336
          ip1_chan     = -20
          ip2_chan     = -40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqpbD0g1WpaT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to ub ub nu lp 
        if (qactive_chan(337).and.qselect_chan(337)) then
          current_chan = 337
          ip1_chan     = -40
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qpbqbD0g1WpaT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(338).and.qselect_chan(338)) then
          current_chan = 338
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = dgD0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(339).and.qselect_chan(339)) then
          current_chan = 339
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 1
          ckmflag = .false.
          wt = gdD0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(340).and.qselect_chan(340)) then
          current_chan = 340
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .false.
          wt = guD0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(341).and.qselect_chan(341)) then
          current_chan = 341
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 1
          ckmflag = .false.
          wt = gubD0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(342).and.qselect_chan(342)) then
          current_chan = 342
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ugD0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(343).and.qselect_chan(343)) then
          current_chan = 343
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ubgD0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to db d nu lp  
        if (qactive_chan(344).and.qselect_chan(344)) then
          current_chan = 344
          ip1_chan     = 20
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qqpbD0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to d d nu lp    
        if (qactive_chan(345).and.qselect_chan(345)) then
          current_chan = 345
          ip1_chan     = 20
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qqpD0g1WpbT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to db d nu lp  
        if (qactive_chan(346).and.qselect_chan(346)) then
          current_chan = 346
          ip1_chan     = -40
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qpbqD0g1WpbT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to d d nu lp    
        if (qactive_chan(347).and.qselect_chan(347)) then
          current_chan = 347
          ip1_chan     = 40
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqD0g1WpbT(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to ub d nu lp  
        if (qactive_chan(348).and.qselect_chan(348)) then
          current_chan = 348
          ip1_chan     = -40
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqpD0g1WpbT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to ub db nu lp 
        if (qactive_chan(349).and.qselect_chan(349)) then
          current_chan = 349
          ip1_chan     = -40
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqpbD0g1WpbT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to ub d nu lp  
        if (qactive_chan(350).and.qselect_chan(350)) then
          current_chan = 350
          ip1_chan     = 40
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqpbD0g1WpbT(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(351).and.qselect_chan(351)) then
          current_chan = 351
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = dgD0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(352).and.qselect_chan(352)) then
          current_chan = 352
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = dbgD0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(353).and.qselect_chan(353)) then
          current_chan = 353
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 1
          ckmflag = .false.
          wt = gdD0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(354).and.qselect_chan(354)) then
          current_chan = 354
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .false.
          wt = gdbD0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(355).and.qselect_chan(355)) then
          current_chan = 355
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 1
          ckmflag = .false.
          wt = gubD0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(356).and.qselect_chan(356)) then
          current_chan = 356
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ubgD0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub d nu lp  
        if (qactive_chan(357).and.qselect_chan(357)) then
          current_chan = 357
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqbDt0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u d nu lp    
        if (qactive_chan(358).and.qselect_chan(358)) then
          current_chan = 358
          ip1_chan     = 20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqDt0g1WpaT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to u ub nu lp  
        if (qactive_chan(359).and.qselect_chan(359)) then
          current_chan = 359
          ip1_chan     = 20
          ip2_chan     = -40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qqpbDt0g1WpaT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub d nu lp  
        if (qactive_chan(360).and.qselect_chan(360)) then
          current_chan = 360
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqDt0g1WpaT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to u ub nu lp  
        if (qactive_chan(361).and.qselect_chan(361)) then
          current_chan = 361
          ip1_chan     = -40
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qpbqDt0g1WpaT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to ub ub nu lp 
        if (qactive_chan(362).and.qselect_chan(362)) then
          current_chan = 362
          ip1_chan     = -20
          ip2_chan     = -40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqpbDt0g1WpaT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to ub ub nu lp 
        if (qactive_chan(363).and.qselect_chan(363)) then
          current_chan = 363
          ip1_chan     = -40
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qpbqbDt0g1WpaT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(364).and.qselect_chan(364)) then
          current_chan = 364
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = dgDt0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(365).and.qselect_chan(365)) then
          current_chan = 365
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 1
          ckmflag = .false.
          wt = gdDt0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(366).and.qselect_chan(366)) then
          current_chan = 366
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .false.
          wt = guDt0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(367).and.qselect_chan(367)) then
          current_chan = 367
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 1
          ckmflag = .false.
          wt = gubDt0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(368).and.qselect_chan(368)) then
          current_chan = 368
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ugDt0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(369).and.qselect_chan(369)) then
          current_chan = 369
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ubgDt0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to db d nu lp  
        if (qactive_chan(370).and.qselect_chan(370)) then
          current_chan = 370
          ip1_chan     = 20
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qqpbDt0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to d d nu lp    
        if (qactive_chan(371).and.qselect_chan(371)) then
          current_chan = 371
          ip1_chan     = 20
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qqpDt0g1WpbT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to db d nu lp  
        if (qactive_chan(372).and.qselect_chan(372)) then
          current_chan = 372
          ip1_chan     = -40
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qpbqDt0g1WpbT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to d d nu lp    
        if (qactive_chan(373).and.qselect_chan(373)) then
          current_chan = 373
          ip1_chan     = 40
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqDt0g1WpbT(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to ub d nu lp  
        if (qactive_chan(374).and.qselect_chan(374)) then
          current_chan = 374
          ip1_chan     = -40
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqpDt0g1WpbT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to ub db nu lp 
        if (qactive_chan(375).and.qselect_chan(375)) then
          current_chan = 375
          ip1_chan     = -40
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqpbDt0g1WpbT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to ub d nu lp  
        if (qactive_chan(376).and.qselect_chan(376)) then
          current_chan = 376
          ip1_chan     = 40
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqpbDt0g1WpbT(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(377).and.qselect_chan(377)) then
          current_chan = 377
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = dgDt0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(378).and.qselect_chan(378)) then
          current_chan = 378
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = dbgDt0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(379).and.qselect_chan(379)) then
          current_chan = 379
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 1
          ckmflag = .false.
          wt = gdDt0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(380).and.qselect_chan(380)) then
          current_chan = 380
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .false.
          wt = gdbDt0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(381).and.qselect_chan(381)) then
          current_chan = 381
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 1
          ckmflag = .false.
          wt = gubDt0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(382).and.qselect_chan(382)) then
          current_chan = 382
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ubgDt0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub d nu lp  
        if (qactive_chan(383).and.qselect_chan(383)) then
          current_chan = 383
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqbDh0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u d nu lp    
        if (qactive_chan(384).and.qselect_chan(384)) then
          current_chan = 384
          ip1_chan     = 20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqDh0g1WpaT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to u ub nu lp  
        if (qactive_chan(385).and.qselect_chan(385)) then
          current_chan = 385
          ip1_chan     = 20
          ip2_chan     = -40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qqpbDh0g1WpaT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub d nu lp  
        if (qactive_chan(386).and.qselect_chan(386)) then
          current_chan = 386
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqDh0g1WpaT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to u ub nu lp  
        if (qactive_chan(387).and.qselect_chan(387)) then
          current_chan = 387
          ip1_chan     = -40
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qpbqDh0g1WpaT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to ub ub nu lp 
        if (qactive_chan(388).and.qselect_chan(388)) then
          current_chan = 388
          ip1_chan     = -20
          ip2_chan     = -40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqpbDh0g1WpaT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to ub ub nu lp 
        if (qactive_chan(389).and.qselect_chan(389)) then
          current_chan = 389
          ip1_chan     = -40
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qpbqbDh0g1WpaT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(390).and.qselect_chan(390)) then
          current_chan = 390
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = dgDh0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(391).and.qselect_chan(391)) then
          current_chan = 391
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 1
          ckmflag = .false.
          wt = gdDh0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(392).and.qselect_chan(392)) then
          current_chan = 392
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 1
          ckmflag = .false.
          wt = guDh0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(393).and.qselect_chan(393)) then
          current_chan = 393
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 1
          ckmflag = .false.
          wt = gubDh0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(394).and.qselect_chan(394)) then
          current_chan = 394
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ugDh0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(395).and.qselect_chan(395)) then
          current_chan = 395
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ubgDh0g1WpaT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to db d nu lp  
        if (qactive_chan(396).and.qselect_chan(396)) then
          current_chan = 396
          ip1_chan     = 20
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qqpbDh0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to d d nu lp    
        if (qactive_chan(397).and.qselect_chan(397)) then
          current_chan = 397
          ip1_chan     = 20
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qqpDh0g1WpbT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to db d nu lp  
        if (qactive_chan(398).and.qselect_chan(398)) then
          current_chan = 398
          ip1_chan     = -40
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qpbqDh0g1WpbT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to d d nu lp    
        if (qactive_chan(399).and.qselect_chan(399)) then
          current_chan = 399
          ip1_chan     = 40
          ip2_chan     = 20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqDh0g1WpbT(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to ub d nu lp  
        if (qactive_chan(400).and.qselect_chan(400)) then
          current_chan = 400
          ip1_chan     = -40
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqpDh0g1WpbT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to ub db nu lp 
        if (qactive_chan(401).and.qselect_chan(401)) then
          current_chan = 401
          ip1_chan     = -40
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqpbDh0g1WpbT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to ub d nu lp  
        if (qactive_chan(402).and.qselect_chan(402)) then
          current_chan = 402
          ip1_chan     = 40
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqpbDh0g1WpbT(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(403).and.qselect_chan(403)) then
          current_chan = 403
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = dgDh0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(404).and.qselect_chan(404)) then
          current_chan = 404
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = dbgDh0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(405).and.qselect_chan(405)) then
          current_chan = 405
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 1
          ckmflag = .false.
          wt = gdDh0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(406).and.qselect_chan(406)) then
          current_chan = 406
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 1
          ckmflag = .false.
          wt = gdbDh0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(407).and.qselect_chan(407)) then
          current_chan = 407
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 1
          ckmflag = .false.
          wt = gubDh0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(408).and.qselect_chan(408)) then
          current_chan = 408
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 1
          ckmflag = .false.
          wt = ubgDh0g1WpbT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTWpJ=sigTWpJ+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
