      function sigVVWmJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use CKM_mod, only : ckmflag  
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigVVWmJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,5,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

!$omp critical(VV_WmJ)
#ifdef USE_OL  
      call fill_pOL(5, (/ 1, 2, 3, 4, 5 /) )
#endif 

c--- d g to u lm nub 
      if (qactive_chan(409).and.qselect_chan(409)) then
        current_chan = 409
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2Wm(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g lm nub 
      if (qactive_chan(410).and.qselect_chan(410)) then
        current_chan = 410
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2Wm(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u lm nub 
      if (qactive_chan(411).and.qselect_chan(411)) then
        current_chan = 411
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2Wm(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g lm nub 
      if (qactive_chan(412).and.qselect_chan(412)) then
        current_chan = 412
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2Wm(2,3,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db lm nub 
      if (qactive_chan(413).and.qselect_chan(413)) then
        current_chan = 413
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2Wm(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db lm nub 
      if (qactive_chan(414).and.qselect_chan(414)) then
        current_chan = 414
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = B1g2Wm(3,2,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to u lm nub 
      if (qactive_chan(432).and.qselect_chan(432)) then
        current_chan = 432
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2Wm(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g lm nub 
      if (qactive_chan(433).and.qselect_chan(433)) then
        current_chan = 433
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2Wm(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u lm nub 
      if (qactive_chan(434).and.qselect_chan(434)) then
        current_chan = 434
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2Wm(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g lm nub 
      if (qactive_chan(435).and.qselect_chan(435)) then
        current_chan = 435
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2Wm(2,3,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db lm nub 
      if (qactive_chan(436).and.qselect_chan(436)) then
        current_chan = 436
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2Wm(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db lm nub 
      if (qactive_chan(437).and.qselect_chan(437)) then
        current_chan = 437
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bt1g2Wm(3,2,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to u lm nub 
      if (qactive_chan(455).and.qselect_chan(455)) then
        current_chan = 455
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2W(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g lm nub 
      if (qactive_chan(456).and.qselect_chan(456)) then
        current_chan = 456
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2W(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u lm nub 
      if (qactive_chan(457).and.qselect_chan(457)) then
        current_chan = 457
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2W(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g lm nub 
      if (qactive_chan(458).and.qselect_chan(458)) then
        current_chan = 458
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2W(2,3,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db lm nub 
      if (qactive_chan(459).and.qselect_chan(459)) then
        current_chan = 459
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2W(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db lm nub 
      if (qactive_chan(460).and.qselect_chan(460)) then
        current_chan = 460
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Btt1g2W(3,2,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to u lm nub 
      if (qactive_chan(478).and.qselect_chan(478)) then
        current_chan = 478
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2W(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g lm nub 
      if (qactive_chan(479).and.qselect_chan(479)) then
        current_chan = 479
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2W(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u lm nub 
      if (qactive_chan(480).and.qselect_chan(480)) then
        current_chan = 480
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2W(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g lm nub 
      if (qactive_chan(481).and.qselect_chan(481)) then
        current_chan = 481
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2W(2,3,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db lm nub 
      if (qactive_chan(482).and.qselect_chan(482)) then
        current_chan = 482
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2W(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db lm nub 
      if (qactive_chan(483).and.qselect_chan(483)) then
        current_chan = 483
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bh1g2W(3,2,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to u lm nub 
      if (qactive_chan(501).and.qselect_chan(501)) then
        current_chan = 501
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2W(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g lm nub 
      if (qactive_chan(502).and.qselect_chan(502)) then
        current_chan = 502
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2W(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u lm nub 
      if (qactive_chan(503).and.qselect_chan(503)) then
        current_chan = 503
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2W(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g lm nub 
      if (qactive_chan(504).and.qselect_chan(504)) then
        current_chan = 504
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2W(2,3,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db lm nub 
      if (qactive_chan(505).and.qselect_chan(505)) then
        current_chan = 505
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2W(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db lm nub 
      if (qactive_chan(506).and.qselect_chan(506)) then
        current_chan = 506
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bht1g2W(3,2,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to u lm nub 
      if (qactive_chan(524).and.qselect_chan(524)) then
        current_chan = 524
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,2,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2W(1,2,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g lm nub 
      if (qactive_chan(525).and.qselect_chan(525)) then
        current_chan = 525
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 1,3,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2W(1,3,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u lm nub 
      if (qactive_chan(526).and.qselect_chan(526)) then
        current_chan = 526
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,1,3,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2W(2,1,3,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g lm nub 
      if (qactive_chan(527).and.qselect_chan(527)) then
        current_chan = 527
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(5, (/ 2,3,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2W(2,3,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db lm nub 
      if (qactive_chan(528).and.qselect_chan(528)) then
        current_chan = 528
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,1,2,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2W(3,1,2,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db lm nub 
      if (qactive_chan(529).and.qselect_chan(529)) then
        current_chan = 529
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(5, (/ 3,2,1,4,5 /))
        call getqcdnorm(ix,partons,factor, 5, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Bhh1g2W(3,2,1,4,5,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
!$omp end critical(VV_WmJ)

      sigVVWmJ=rnorm*wtsum

      return
      end
