      subroutine getlumiWpJJ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    8,   41,   48,   55,   62,   82,  102,          
     &          115,  128,  141,  154,  169,  184,  191,  198,          
     &          213,  238,  258,  278,  291,  317,  343)
!       [20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,    9,   17,   29,   34,   42,   49,   56,          
     &           65,   85,  105,  116,  131,  142,  155,  170,          
     &          185,  192,  199,  214,  222,  242,  262,  282,          
     &          293,  308,  319,  334,  345)
!       [20, -40]
          if ( .not. ckmflag ) then
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
          else
          partons(1:nInp_scl) =                                         
     &         CKM(2,1)*f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)              
     &       + CKM(2,3)*f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)              
     &       + CKM(4,1)*f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)              
     &       + CKM(4,3)*f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)
          end if

        case (    3,   10,   43,   50,   57,   66,   86,  106,          
     &          118,  132,  144,  156,  171,  186,  193,  200,          
     &          215,  236,  256,  276,  289,  315,  341)
!       [0, 20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (    4,   11,   20,   31,   36,   44,   51,   58,          
     &           69,   89,  108,  119,  134,  145,  157,  172,          
     &          187,  194,  201,  216,  225,  245,  265,  284,          
     &          295,  310,  321,  336,  347)
!       [-40, 20]
          if ( .not. ckmflag ) then
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
          else
          partons(1:nInp_scl) =                                         
     &         CKM(1,2)*f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)              
     &       + CKM(1,4)*f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)              
     &       + CKM(3,2)*f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)              
     &       + CKM(3,4)*f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)
          end if

        case (    5,   12,   45,   52,   59,  158,  173,  188,          
     &          195,  202,  217)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    6,   13,   46,   53,   60,   72,   92,  110,          
     &          121,  136,  147,  159,  174,  189,  196,  203,          
     &          218,  237,  257,  277,  303,  329,  355)
!       [0, -40]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case (    7,   14,   47,   54,   61,   75,   95,  112,          
     &          123,  138,  149,  160,  175,  190,  197,  204,          
     &          219,  239,  259,  279,  301,  327,  353)
!       [-40, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   15,   63,   83,  166,  181,  210,  220,  240,          
     &          260)
!       [21, -31]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   16,   64,   84,  165,  180,  209,  221,  241,          
     &          261)
!       [21, 31]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   18,   67,   87,  163,  178,  207,  223,  243,          
     &          263)
!       [-31, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   19,   68,   88,  161,  176,  205,  224,  244,          
     &          264)
!       [31, 21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   21,   76,   96,  226,  246,  266)
!       [-30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   22,   77,   97,  164,  179,  208,  227,  247,          
     &          267)
!       [-31, -41]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   23,   78,   98,  228,  248,  268)
!       [30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   24,   79,   99,  168,  183,  212,  229,  249,          
     &          269)
!       [-41, -31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   25,   80,  100,  162,  177,  206,  230,  250,          
     &          270)
!       [31, -41]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case (   26,   81,  101,  167,  182,  211,  231,  251,          
     &          271)
!       [-41, 31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   27,  103,  129,  280,  306,  332)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   28,  104,  130,  281,  307,  333)
!       [20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   30,  107,  133,  283,  309,  335)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   32,  113,  139,  285,  311,  337)
!       [-20, -40]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   33,  114,  140,  286,  312,  338)
!       [-40, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   35,  117,  143,  294,  320,  346)
!       [20, 40]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (   37,  120,  146,  296,  322,  348)
!       [40, 20]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   38,  125,  151,  297,  323,  349)
!       [-40, 40]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       

        case (   39,  126,  152,  298,  324,  350)
!       [-40, -40]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   40,  127,  153,  299,  325,  351)
!       [40, -40]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case (   70,   90,  235,  255,  275)
!       [0, -30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   71,   91,  234,  254,  274)
!       [0, 30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   73,   93,  233,  253,  273)
!       [-30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   74,   94,  232,  252,  272)
!       [30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (  109,  135,  290,  304,  316,  330,  342,  356)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (  111,  137,  292,  305,  318,  331,  344,  357)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (  122,  148,  288,  302,  314,  328,  340,  354)
!       [0, 40]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (  124,  150,  287,  300,  313,  326,  339,  352)
!       [40, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case default
          print*, "getlumiWpJJ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiWpJJ



      function getlumiidWpJJ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    8,   41,   48,   55,   62,   82,  102,
     &          115,  128,  141,  154,  169,  184,  191,  198,
     &          213,  238,  258,  278,  291,  317,  343)
          id  = 1
          ip1 = 20
          ip2 = 0

        case (    2,    9,   17,   29,   34,   42,   49,   56,
     &           65,   85,  105,  116,  131,  142,  155,  170,
     &          185,  192,  199,  214,  222,  242,  262,  282,
     &          293,  308,  319,  334,  345)
          id  = 2
          ip1 = 20
          ip2 = -40

        case (    3,   10,   43,   50,   57,   66,   86,  106,
     &          118,  132,  144,  156,  171,  186,  193,  200,
     &          215,  236,  256,  276,  289,  315,  341)
          id  = 3
          ip1 = 0
          ip2 = 20

        case (    4,   11,   20,   31,   36,   44,   51,   58,
     &           69,   89,  108,  119,  134,  145,  157,  172,
     &          187,  194,  201,  216,  225,  245,  265,  284,
     &          295,  310,  321,  336,  347)
          id  = 4
          ip1 = -40
          ip2 = 20

        case (    5,   12,   45,   52,   59,  158,  173,  188,
     &          195,  202,  217)
          id  = 5
          ip1 = 0
          ip2 = 0

        case (    6,   13,   46,   53,   60,   72,   92,  110,
     &          121,  136,  147,  159,  174,  189,  196,  203,
     &          218,  237,  257,  277,  303,  329,  355)
          id  = 6
          ip1 = 0
          ip2 = -40

        case (    7,   14,   47,   54,   61,   75,   95,  112,
     &          123,  138,  149,  160,  175,  190,  197,  204,
     &          219,  239,  259,  279,  301,  327,  353)
          id  = 7
          ip1 = -40
          ip2 = 0

        case (   15,   63,   83,  166,  181,  210,  220,  240,
     &          260)
          id  = 8
          ip1 = 21
          ip2 = -31

        case (   16,   64,   84,  165,  180,  209,  221,  241,
     &          261)
          id  = 9
          ip1 = 21
          ip2 = 31

        case (   18,   67,   87,  163,  178,  207,  223,  243,
     &          263)
          id  = 10
          ip1 = -31
          ip2 = 21

        case (   19,   68,   88,  161,  176,  205,  224,  244,
     &          264)
          id  = 11
          ip1 = 31
          ip2 = 21

        case (   21,   76,   96,  226,  246,  266)
          id  = 12
          ip1 = -30
          ip2 = 30

        case (   22,   77,   97,  164,  179,  208,  227,  247,
     &          267)
          id  = 13
          ip1 = -31
          ip2 = -41

        case (   23,   78,   98,  228,  248,  268)
          id  = 14
          ip1 = 30
          ip2 = -30

        case (   24,   79,   99,  168,  183,  212,  229,  249,
     &          269)
          id  = 15
          ip1 = -41
          ip2 = -31

        case (   25,   80,  100,  162,  177,  206,  230,  250,
     &          270)
          id  = 16
          ip1 = 31
          ip2 = -41

        case (   26,   81,  101,  167,  182,  211,  231,  251,
     &          271)
          id  = 17
          ip1 = -41
          ip2 = 31

        case (   27,  103,  129,  280,  306,  332)
          id  = 18
          ip1 = 20
          ip2 = -20

        case (   28,  104,  130,  281,  307,  333)
          id  = 19
          ip1 = 20
          ip2 = 20

        case (   30,  107,  133,  283,  309,  335)
          id  = 20
          ip1 = -20
          ip2 = 20

        case (   32,  113,  139,  285,  311,  337)
          id  = 21
          ip1 = -20
          ip2 = -40

        case (   33,  114,  140,  286,  312,  338)
          id  = 22
          ip1 = -40
          ip2 = -20

        case (   35,  117,  143,  294,  320,  346)
          id  = 23
          ip1 = 20
          ip2 = 40

        case (   37,  120,  146,  296,  322,  348)
          id  = 24
          ip1 = 40
          ip2 = 20

        case (   38,  125,  151,  297,  323,  349)
          id  = 25
          ip1 = -40
          ip2 = 40

        case (   39,  126,  152,  298,  324,  350)
          id  = 26
          ip1 = -40
          ip2 = -40

        case (   40,  127,  153,  299,  325,  351)
          id  = 27
          ip1 = 40
          ip2 = -40

        case (   70,   90,  235,  255,  275)
          id  = 28
          ip1 = 0
          ip2 = -30

        case (   71,   91,  234,  254,  274)
          id  = 29
          ip1 = 0
          ip2 = 30

        case (   73,   93,  233,  253,  273)
          id  = 30
          ip1 = -30
          ip2 = 0

        case (   74,   94,  232,  252,  272)
          id  = 31
          ip1 = 30
          ip2 = 0

        case (  109,  135,  290,  304,  316,  330,  342,  356)
          id  = 32
          ip1 = 0
          ip2 = -20

        case (  111,  137,  292,  305,  318,  331,  344,  357)
          id  = 33
          ip1 = -20
          ip2 = 0

        case (  122,  148,  288,  302,  314,  328,  340,  354)
          id  = 34
          ip1 = 0
          ip2 = 40

        case (  124,  150,  287,  300,  313,  326,  339,  352)
          id  = 35
          ip1 = 40
          ip2 = 0

        case default
          print*, "getlumiidWpJJ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidWpJJ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiWpJJ()
        use PineAPPL_mod
        use CKM_mod
!       [20, 0]
        call register_lumi_pine(
     &         [    1,    8,   41,   48,   55,   62,   82,  102,
     &            115,  128,  141,  154,  169,  184,  191,  198,
     &            213,  238,  258,  278,  291,  317,  343],
     &         2,
     &         [    2,   21,    4,   21],
     &         [  1d0,  1d0]
     &       )

!       [20, -40]
        if ( .not. ckmflag ) then
        call register_lumi_pine(
     &         [    2,    9,   17,   29,   34,   42,   49,   56,
     &             65,   85,  105,  116,  131,  142,  155,  170,
     &            185,  192,  199,  214,  222,  242,  262,  282,
     &            293,  308,  319,  334,  345],
     &         2,
     &         [    2,   -1,    4,   -3],
     &         [  1d0,  1d0]
     &       )
        else
        call register_lumi_pine(
     &         [    2,    9,   17,   29,   34,   42,   49,   56,
     &             65,   85,  105,  116,  131,  142,  155,  170,
     &            185,  192,  199,  214,  222,  242,  262,  282,
     &            293,  308,  319,  334,  345],
     &         4,
     &         [    2,   -1,    2,   -3,    4,   -1,    4,   -3],
     &         [ CKM(2,1), CKM(2,3), CKM(4,1), CKM(4,3)]
     &       )
        end if

!       [0, 20]
        call register_lumi_pine(
     &         [    3,   10,   43,   50,   57,   66,   86,  106,
     &            118,  132,  144,  156,  171,  186,  193,  200,
     &            215,  236,  256,  276,  289,  315,  341],
     &         2,
     &         [   21,    2,   21,    4],
     &         [  1d0,  1d0]
     &       )

!       [-40, 20]
        if ( .not. ckmflag ) then
        call register_lumi_pine(
     &         [    4,   11,   20,   31,   36,   44,   51,   58,
     &             69,   89,  108,  119,  134,  145,  157,  172,
     &            187,  194,  201,  216,  225,  245,  265,  284,
     &            295,  310,  321,  336,  347],
     &         2,
     &         [   -1,    2,   -3,    4],
     &         [  1d0,  1d0]
     &       )
        else
        call register_lumi_pine(
     &         [    4,   11,   20,   31,   36,   44,   51,   58,
     &             69,   89,  108,  119,  134,  145,  157,  172,
     &            187,  194,  201,  216,  225,  245,  265,  284,
     &            295,  310,  321,  336,  347],
     &         4,
     &         [   -1,    2,   -1,    4,   -3,    2,   -3,    4],
     &         [ CKM(1,2), CKM(1,4), CKM(3,2), CKM(3,4)]
     &       )
        end if

!       [0, 0]
        call register_lumi_pine(
     &         [    5,   12,   45,   52,   59,  158,  173,  188,
     &            195,  202,  217],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [0, -40]
        call register_lumi_pine(
     &         [    6,   13,   46,   53,   60,   72,   92,  110,
     &            121,  136,  147,  159,  174,  189,  196,  203,
     &            218,  237,  257,  277,  303,  329,  355],
     &         2,
     &         [   21,   -1,   21,   -3],
     &         [  1d0,  1d0]
     &       )

!       [-40, 0]
        call register_lumi_pine(
     &         [    7,   14,   47,   54,   61,   75,   95,  112,
     &            123,  138,  149,  160,  175,  190,  197,  204,
     &            219,  239,  259,  279,  301,  327,  353],
     &         2,
     &         [   -1,   21,   -3,   21],
     &         [  1d0,  1d0]
     &       )

!       [21, -31]
        call register_lumi_pine(
     &         [   15,   63,   83,  166,  181,  210,  220,  240,
     &            260],
     &         10,
     &         [    2,   -1,    2,   -2,    2,   -3,    2,   -4,
     &              2,   -5,    4,   -1,    4,   -2,    4,   -3,
     &              4,   -4,    4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [21, 31]
        call register_lumi_pine(
     &         [   16,   64,   84,  165,  180,  209,  221,  241,
     &            261],
     &         10,
     &         [    2,    1,    2,    2,    2,    3,    2,    4,
     &              2,    5,    4,    1,    4,    2,    4,    3,
     &              4,    4,    4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-31, 21]
        call register_lumi_pine(
     &         [   18,   67,   87,  163,  178,  207,  223,  243,
     &            263],
     &         10,
     &         [   -1,    2,   -1,    4,   -2,    2,   -2,    4,
     &             -3,    2,   -3,    4,   -4,    2,   -4,    4,
     &             -5,    2,   -5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [31, 21]
        call register_lumi_pine(
     &         [   19,   68,   88,  161,  176,  205,  224,  244,
     &            264],
     &         10,
     &         [    1,    2,    1,    4,    2,    2,    2,    4,
     &              3,    2,    3,    4,    4,    2,    4,    4,
     &              5,    2,    5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-30, 30]
        call register_lumi_pine(
     &         [   21,   76,   96,  226,  246,  266],
     &         5,
     &         [   -1,    1,   -2,    2,   -3,    3,   -4,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-31, -41]
        call register_lumi_pine(
     &         [   22,   77,   97,  164,  179,  208,  227,  247,
     &            267],
     &         10,
     &         [   -1,   -1,   -1,   -3,   -2,   -1,   -2,   -3,
     &             -3,   -1,   -3,   -3,   -4,   -1,   -4,   -3,
     &             -5,   -1,   -5,   -3],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [30, -30]
        call register_lumi_pine(
     &         [   23,   78,   98,  228,  248,  268],
     &         5,
     &         [    1,   -1,    2,   -2,    3,   -3,    4,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-41, -31]
        call register_lumi_pine(
     &         [   24,   79,   99,  168,  183,  212,  229,  249,
     &            269],
     &         10,
     &         [   -1,   -1,   -1,   -2,   -1,   -3,   -1,   -4,
     &             -1,   -5,   -3,   -1,   -3,   -2,   -3,   -3,
     &             -3,   -4,   -3,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [31, -41]
        call register_lumi_pine(
     &         [   25,   80,  100,  162,  177,  206,  230,  250,
     &            270],
     &         10,
     &         [    1,   -1,    1,   -3,    2,   -1,    2,   -3,
     &              3,   -1,    3,   -3,    4,   -1,    4,   -3,
     &              5,   -1,    5,   -3],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-41, 31]
        call register_lumi_pine(
     &         [   26,   81,  101,  167,  182,  211,  231,  251,
     &            271],
     &         10,
     &         [   -1,    1,   -1,    2,   -1,    3,   -1,    4,
     &             -1,    5,   -3,    1,   -3,    2,   -3,    3,
     &             -3,    4,   -3,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [   27,  103,  129,  280,  306,  332],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [20, 20]
        call register_lumi_pine(
     &         [   28,  104,  130,  281,  307,  333],
     &         2,
     &         [    2,    2,    4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [   30,  107,  133,  283,  309,  335],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-20, -40]
        call register_lumi_pine(
     &         [   32,  113,  139,  285,  311,  337],
     &         2,
     &         [   -2,   -1,   -4,   -3],
     &         [  1d0,  1d0]
     &       )

!       [-40, -20]
        call register_lumi_pine(
     &         [   33,  114,  140,  286,  312,  338],
     &         2,
     &         [   -1,   -2,   -3,   -4],
     &         [  1d0,  1d0]
     &       )

!       [20, 40]
        call register_lumi_pine(
     &         [   35,  117,  143,  294,  320,  346],
     &         2,
     &         [    2,    1,    4,    3],
     &         [  1d0,  1d0]
     &       )

!       [40, 20]
        call register_lumi_pine(
     &         [   37,  120,  146,  296,  322,  348],
     &         2,
     &         [    1,    2,    3,    4],
     &         [  1d0,  1d0]
     &       )

!       [-40, 40]
        call register_lumi_pine(
     &         [   38,  125,  151,  297,  323,  349],
     &         2,
     &         [   -1,    1,   -3,    3],
     &         [  1d0,  1d0]
     &       )

!       [-40, -40]
        call register_lumi_pine(
     &         [   39,  126,  152,  298,  324,  350],
     &         2,
     &         [   -1,   -1,   -3,   -3],
     &         [  1d0,  1d0]
     &       )

!       [40, -40]
        call register_lumi_pine(
     &         [   40,  127,  153,  299,  325,  351],
     &         2,
     &         [    1,   -1,    3,   -3],
     &         [  1d0,  1d0]
     &       )

!       [0, -30]
        call register_lumi_pine(
     &         [   70,   90,  235,  255,  275],
     &         5,
     &         [   21,   -1,   21,   -2,   21,   -3,   21,   -4,
     &             21,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, 30]
        call register_lumi_pine(
     &         [   71,   91,  234,  254,  274],
     &         5,
     &         [   21,    1,   21,    2,   21,    3,   21,    4,
     &             21,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 0]
        call register_lumi_pine(
     &         [   73,   93,  233,  253,  273],
     &         5,
     &         [   -1,   21,   -2,   21,   -3,   21,   -4,   21,
     &             -5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [30, 0]
        call register_lumi_pine(
     &         [   74,   94,  232,  252,  272],
     &         5,
     &         [    1,   21,    2,   21,    3,   21,    4,   21,
     &              5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [  109,  135,  290,  304,  316,  330,  342,  356],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [  111,  137,  292,  305,  318,  331,  344,  357],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 40]
        call register_lumi_pine(
     &         [  122,  148,  288,  302,  314,  328,  340,  354],
     &         2,
     &         [   21,    1,   21,    3],
     &         [  1d0,  1d0]
     &       )

!       [40, 0]
        call register_lumi_pine(
     &         [  124,  150,  287,  300,  313,  326,  339,  352],
     &         2,
     &         [    1,   21,    3,   21],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiWpJJ


#endif


