      subroutine getqcdnormWmJJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      real(8) :: fac_ckm
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtWmJJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVWmJJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourWmJJ(current_chan)
         do isub = 1, nflavourWmJJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_WmJJ(current_chan, isub, ipass_sub, flav_block, fac_ckm)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           partons_sub = fac_ckm*partons_sub
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=WmJJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param()/stw)**2*(nc**2-1)*nc*(4d0*pi*alphas_scl)
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d g -> g u lm nub       B2g0W
      case(2)
         factor=1d0/2d0*facB                ! d ub -> g g lm nub      B2g0W
      case(3)
         factor=facB                        ! g d -> g u lm nub       B2g0W
      case(4)
         factor=1d0/2d0*facB                ! ub d -> g g lm nub      B2g0W
      case(5)
         factor=nup*facB                    ! g g -> db u lm nub      B2g0W
      case(6)
         factor=facB                        ! g ub -> db g lm nub     B2g0W
      case(7)
         factor=facB                        ! ub g -> db g lm nub     B2g0W
      case(8)
         factor=-1d0/nc**2*facB             ! d gt -> gt u lm nub     Bt2g0W
      case(9)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d ub -> gt gt lm nub     Bt2g0W
      case(10)
         factor=-1d0/nc**2*facB             ! gt d -> gt u lm nub     Bt2g0W
      case(11)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub d -> gt gt lm nub     Bt2g0W
      case(12)
         factor=-1d0/nc**2*nup*facB         ! gt gt -> db u lm nub     Bt2g0W
      case(13)
         factor=-1d0/nc**2*facB             ! gt ub -> db gt lm nub     Bt2g0W
      case(14)
         factor=-1d0/nc**2*facB             ! ub gt -> db gt lm nub     Bt2g0W
      case(15)
         factor=1d0/nc*facB                 ! d Qb -> Qb u lm nub     C0g0W
      case(16)
         factor=1d0/nc*facB                 ! d Q -> Q u lm nub       C0g0W
      case(17)
         factor=1d0/nc*nf*facB              ! d ub -> Q Qb lm nub     C0g0W
      case(18)
         factor=1d0/nc*facB                 ! Qb d -> Qb u lm nub     C0g0W
      case(19)
         factor=1d0/nc*facB                 ! Q d -> Q u lm nub       C0g0W
      case(20)
         factor=1d0/nc*nf*facB              ! ub d -> Q Qb lm nub     C0g0W
      case(21)
         factor=1d0/nc*nup*facB             ! Qb Q -> db u lm nub     C0g0W
      case(22)
         factor=1d0/nc*facB                 ! Qb ub -> db Qb lm nub     C0g0W
      case(23)
         factor=1d0/nc*nup*facB             ! Q Qb -> db u lm nub     C0g0W
      case(24)
         factor=1d0/nc*facB                 ! ub Qb -> db Qb lm nub     C0g0W
      case(25)
         factor=1d0/nc*facB                 ! Q ub -> db Q lm nub     C0g0W
      case(26)
         factor=1d0/nc*facB                 ! ub Q -> db Q lm nub     C0g0W
      case(27)
         factor=-1d0/nc**2*facB             ! d db -> db u lm nub     D0g0Wa
      case(28)
         factor=-1d0/nc**2*facB             ! d d -> d u lm nub       D0g0Wa
      case(29)
         factor=-1d0/nc**2*facB             ! d ub -> d db lm nub     D0g0Wa
      case(30)
         factor=-1d0/nc**2*facB             ! db d -> db u lm nub     D0g0Wa
      case(31)
         factor=-1d0/nc**2*facB             ! ub d -> d db lm nub     D0g0Wa
      case(32)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db ub -> db db lm nub     D0g0Wa
      case(33)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub db -> db db lm nub     D0g0Wa
      case(34)
         factor=-1d0/nc**2*facB             ! d ub -> ub u lm nub     D0g0Wb
      case(35)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d u -> u u lm nub       D0g0Wb
      case(36)
         factor=-1d0/nc**2*facB             ! ub d -> ub u lm nub     D0g0Wb
      case(37)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u d -> u u lm nub       D0g0Wb
      case(38)
         factor=-1d0/nc**2*facB             ! ub u -> db u lm nub     D0g0Wb
      case(39)
         factor=-1d0/nc**2*facB             ! ub ub -> db ub lm nub     D0g0Wb
      case(40)
         factor=-1d0/nc**2*facB             ! u ub -> db u lm nub     D0g0Wb

c -- real

      case(41)
         factor=1d0/2d0*facR                ! d g -> g g u lm nub     sB3g0W
      case(42)
         factor=1d0/6d0*facR                ! d ub -> g g g lm nub     sB3g0W
      case(43)
         factor=1d0/2d0*facR                ! g d -> g g u lm nub     sB3g0W
      case(44)
         factor=1d0/6d0*facR                ! ub d -> g g g lm nub     sB3g0W
      case(45)
         factor=nup*facR                    ! g g -> db g u lm nub     sB3g0W
      case(46)
         factor=1d0/2d0*facR                ! g ub -> db g g lm nub     sB3g0W
      case(47)
         factor=1d0/2d0*facR                ! ub g -> db g g lm nub     sB3g0W
      case(48)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d g -> g g u lm nub     sBt3g0W
      case(49)
         factor=-1d0/nc**2*1d0/6d0*facR     ! d ub -> g g g lm nub     sBt3g0W
      case(50)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g d -> g g u lm nub     sBt3g0W
      case(51)
         factor=-1d0/nc**2*1d0/6d0*facR     ! ub d -> g g g lm nub     sBt3g0W
      case(52)
         factor=-1d0/nc**2*nup*facR         ! g g -> db g u lm nub     sBt3g0W
      case(53)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g ub -> db g g lm nub     sBt3g0W
      case(54)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub g -> db g g lm nub     sBt3g0W
      case(55)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! d gt -> gt gt u lm nub     sBtt3g0W
      case(56)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facR   ! d ub -> gt gt gt lm nub     sBtt3g0W
      case(57)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! gt d -> gt gt u lm nub     sBtt3g0W
      case(58)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facR   ! ub d -> gt gt gt lm nub     sBtt3g0W
      case(59)
         factor=(nc**2+1d0)/nc**4*nup*facR   ! gt gt -> db gt u lm nub     sBtt3g0W
      case(60)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! gt ub -> db gt gt lm nub     sBtt3g0W
      case(61)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! ub gt -> db gt gt lm nub     sBtt3g0W
      case(62)
         factor=1d0/nc*nf*facR              ! d g -> Q Qb u lm nub     sC1g0W
      case(63)
         factor=1d0/nc*facR                 ! d Qb -> g Qb u lm nub     sC1g0W
      case(64)
         factor=1d0/nc*facR                 ! d Q -> g Q u lm nub     sC1g0W
      case(65)
         factor=1d0/nc*nf*facR              ! d ub -> g Q Qb lm nub     sC1g0W
      case(66)
         factor=1d0/nc*nf*facR              ! g d -> Q Qb u lm nub     sC1g0W
      case(67)
         factor=1d0/nc*facR                 ! Qb d -> g Qb u lm nub     sC1g0W
      case(68)
         factor=1d0/nc*facR                 ! Q d -> g Q u lm nub     sC1g0W
      case(69)
         factor=1d0/nc*nf*facR              ! ub d -> g Q Qb lm nub     sC1g0W
      case(70)
         factor=1d0/nc*nup*facR             ! g Qb -> db Qb u lm nub     sC1g0W
      case(71)
         factor=1d0/nc*nup*facR             ! g Q -> db Q u lm nub     sC1g0W
      case(72)
         factor=1d0/nc*nf*facR              ! g ub -> db Q Qb lm nub     sC1g0W
      case(73)
         factor=1d0/nc*nup*facR             ! Qb g -> db Qb u lm nub     sC1g0W
      case(74)
         factor=1d0/nc*nup*facR             ! Q g -> db Q u lm nub     sC1g0W
      case(75)
         factor=1d0/nc*nf*facR              ! ub g -> db Q Qb lm nub     sC1g0W
      case(76)
         factor=1d0/nc*nup*facR             ! Qb Q -> db g u lm nub     sC1g0W
      case(77)
         factor=1d0/nc*facR                 ! Qb ub -> db g Qb lm nub     sC1g0W
      case(78)
         factor=1d0/nc*nup*facR             ! Q Qb -> db g u lm nub     sC1g0W
      case(79)
         factor=1d0/nc*facR                 ! ub Qb -> db g Qb lm nub     sC1g0W
      case(80)
         factor=1d0/nc*facR                 ! Q ub -> db g Q lm nub     sC1g0W
      case(81)
         factor=1d0/nc*facR                 ! ub Q -> db g Q lm nub     sC1g0W
      case(82)
         factor=1d0/nc**3*nf*facR           ! d g -> Q Qb u lm nub     sCt1g0W
      case(83)
         factor=1d0/nc**3*facR              ! d Qb -> g Qb u lm nub     sCt1g0W
      case(84)
         factor=1d0/nc**3*facR              ! d Q -> g Q u lm nub     sCt1g0W
      case(85)
         factor=1d0/nc**3*nf*facR           ! d ub -> g Q Qb lm nub     sCt1g0W
      case(86)
         factor=1d0/nc**3*nf*facR           ! g d -> Q Qb u lm nub     sCt1g0W
      case(87)
         factor=1d0/nc**3*facR              ! Qb d -> g Qb u lm nub     sCt1g0W
      case(88)
         factor=1d0/nc**3*facR              ! Q d -> g Q u lm nub     sCt1g0W
      case(89)
         factor=1d0/nc**3*nf*facR           ! ub d -> g Q Qb lm nub     sCt1g0W
      case(90)
         factor=1d0/nc**3*nup*facR          ! g Qb -> db Qb u lm nub     sCt1g0W
      case(91)
         factor=1d0/nc**3*nup*facR          ! g Q -> db Q u lm nub     sCt1g0W
      case(92)
         factor=1d0/nc**3*nf*facR           ! g ub -> db Q Qb lm nub     sCt1g0W
      case(93)
         factor=1d0/nc**3*nup*facR          ! Qb g -> db Qb u lm nub     sCt1g0W
      case(94)
         factor=1d0/nc**3*nup*facR          ! Q g -> db Q u lm nub     sCt1g0W
      case(95)
         factor=1d0/nc**3*nf*facR           ! ub g -> db Q Qb lm nub     sCt1g0W
      case(96)
         factor=1d0/nc**3*nup*facR          ! Qb Q -> db g u lm nub     sCt1g0W
      case(97)
         factor=1d0/nc**3*facR              ! Qb ub -> db g Qb lm nub     sCt1g0W
      case(98)
         factor=1d0/nc**3*nup*facR          ! Q Qb -> db g u lm nub     sCt1g0W
      case(99)
         factor=1d0/nc**3*facR              ! ub Qb -> db g Qb lm nub     sCt1g0W
      case(100)
         factor=1d0/nc**3*facR              ! Q ub -> db g Q lm nub     sCt1g0W
      case(101)
         factor=1d0/nc**3*facR              ! ub Q -> db g Q lm nub     sCt1g0W
      case(102)
         factor=-1d0/nc**2*facR             ! d g -> d db u lm nub     D1g0Wmac
      case(103)
         factor=-1d0/nc**2*facR             ! d db -> g db u lm nub     D1g0Wmac
      case(104)
         factor=-1d0/nc**2*facR             ! d d -> g d u lm nub     D1g0Wmac
      case(105)
         factor=-1d0/nc**2*facR             ! d ub -> g d db lm nub     D1g0Wmac
      case(106)
         factor=-1d0/nc**2*facR             ! g d -> d db u lm nub     D1g0Wmac
      case(107)
         factor=-1d0/nc**2*facR             ! db d -> g db u lm nub     D1g0Wmac
      case(108)
         factor=-1d0/nc**2*facR             ! ub d -> g d db lm nub     D1g0Wmac
      case(109)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g db -> db db u lm nub     D1g0Wmac
      case(110)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g ub -> db d db lm nub     D1g0Wmac
      case(111)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db g -> db db u lm nub     D1g0Wmac
      case(112)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub g -> db d db lm nub     D1g0Wmac
      case(113)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db ub -> db g db lm nub     D1g0Wmac
      case(114)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub db -> db g db lm nub     D1g0Wmac
      case(115)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d g -> u ub u lm nub     D1g0Wmbc
      case(116)
         factor=-1d0/nc**2*facR             ! d ub -> g ub u lm nub     D1g0Wmbc
      case(117)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d u -> g u u lm nub     D1g0Wmbc
      case(118)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g d -> u ub u lm nub     D1g0Wmbc
      case(119)
         factor=-1d0/nc**2*facR             ! ub d -> g ub u lm nub     D1g0Wmbc
      case(120)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u d -> g u u lm nub     D1g0Wmbc
      case(121)
         factor=-1d0/nc**2*facR             ! g ub -> db ub u lm nub     D1g0Wmbc
      case(122)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g u -> db u u lm nub     D1g0Wmbc
      case(123)
         factor=-1d0/nc**2*facR             ! ub g -> db ub u lm nub     D1g0Wmbc
      case(124)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u g -> db u u lm nub     D1g0Wmbc
      case(125)
         factor=-1d0/nc**2*facR             ! ub u -> db g u lm nub     D1g0Wmbc
      case(126)
         factor=-1d0/nc**2*facR             ! ub ub -> db g ub lm nub     D1g0Wmbc
      case(127)
         factor=-1d0/nc**2*facR             ! u ub -> db g u lm nub     D1g0Wmbc
      case(128)
         factor=1d0/nc**4*facR              ! d g -> d db u lm nub     Dt1g0Wma
      case(129)
         factor=1d0/nc**4*facR              ! d db -> g db u lm nub     Dt1g0Wma
      case(130)
         factor=1d0/nc**4*facR              ! d d -> g d u lm nub     Dt1g0Wma
      case(131)
         factor=1d0/nc**4*facR              ! d ub -> g d db lm nub     Dt1g0Wma
      case(132)
         factor=1d0/nc**4*facR              ! g d -> d db u lm nub     Dt1g0Wma
      case(133)
         factor=1d0/nc**4*facR              ! db d -> g db u lm nub     Dt1g0Wma
      case(134)
         factor=1d0/nc**4*facR              ! ub d -> g d db lm nub     Dt1g0Wma
      case(135)
         factor=1d0/nc**4*1d0/2d0*facR      ! g db -> db db u lm nub     Dt1g0Wma
      case(136)
         factor=1d0/nc**4*1d0/2d0*facR      ! g ub -> db d db lm nub     Dt1g0Wma
      case(137)
         factor=1d0/nc**4*1d0/2d0*facR      ! db g -> db db u lm nub     Dt1g0Wma
      case(138)
         factor=1d0/nc**4*1d0/2d0*facR      ! ub g -> db d db lm nub     Dt1g0Wma
      case(139)
         factor=1d0/nc**4*1d0/2d0*facR      ! db ub -> db g db lm nub     Dt1g0Wma
      case(140)
         factor=1d0/nc**4*1d0/2d0*facR      ! ub db -> db g db lm nub     Dt1g0Wma
      case(141)
         factor=1d0/nc**4*1d0/2d0*facR      ! d g -> u ub u lm nub     Dt1g0Wmb
      case(142)
         factor=1d0/nc**4*facR              ! d ub -> g ub u lm nub     Dt1g0Wmb
      case(143)
         factor=1d0/nc**4*1d0/2d0*facR      ! d u -> g u u lm nub     Dt1g0Wmb
      case(144)
         factor=1d0/nc**4*1d0/2d0*facR      ! g d -> u ub u lm nub     Dt1g0Wmb
      case(145)
         factor=1d0/nc**4*facR              ! ub d -> g ub u lm nub     Dt1g0Wmb
      case(146)
         factor=1d0/nc**4*1d0/2d0*facR      ! u d -> g u u lm nub     Dt1g0Wmb
      case(147)
         factor=1d0/nc**4*facR              ! g ub -> db ub u lm nub     Dt1g0Wmb
      case(148)
         factor=1d0/nc**4*1d0/2d0*facR      ! g u -> db u u lm nub     Dt1g0Wmb
      case(149)
         factor=1d0/nc**4*facR              ! ub g -> db ub u lm nub     Dt1g0Wmb
      case(150)
         factor=1d0/nc**4*1d0/2d0*facR      ! u g -> db u u lm nub     Dt1g0Wmb
      case(151)
         factor=1d0/nc**4*facR              ! ub u -> db g u lm nub     Dt1g0Wmb
      case(152)
         factor=1d0/nc**4*facR              ! ub ub -> db g ub lm nub     Dt1g0Wmb
      case(153)
         factor=1d0/nc**4*facR              ! u ub -> db g u lm nub     Dt1g0Wmb

c -- virtual

      case(154)
         factor=facV                        ! d g -> g u lm nub       sB2g1W
      case(155)
         factor=1d0/2d0*facV                ! d ub -> g g lm nub      sB2g1W
      case(156)
         factor=facV                        ! g d -> g u lm nub       sB2g1W
      case(157)
         factor=1d0/2d0*facV                ! ub d -> g g lm nub      sB2g1W
      case(158)
         factor=nup*facV                    ! g g -> db u lm nub      sB2g1W
      case(159)
         factor=facV                        ! g ub -> db g lm nub     sB2g1W
      case(160)
         factor=facV                        ! ub g -> db g lm nub     sB2g1W
      case(161)
         factor=1d0/nc*facV                 ! Q d subtraction         sB2g1W
      case(162)
         factor=1d0/nc*facV                 ! Q ub subtraction        sB2g1W
      case(163)
         factor=1d0/nc*facV                 ! Qb d subtraction        sB2g1W
      case(164)
         factor=1d0/nc*facV                 ! Qb ub subtraction       sB2g1W
      case(165)
         factor=1d0/nc*facV                 ! d Q subtraction         sB2g1W
      case(166)
         factor=1d0/nc*facV                 ! d Qb subtraction        sB2g1W
      case(167)
         factor=1d0/nc*facV                 ! ub Q subtraction        sB2g1W
      case(168)
         factor=1d0/nc*facV                 ! ub Qb subtraction       sB2g1W
      case(169)
         factor=-1d0/nc**2*facV             ! d g -> g u lm nub       sBt2g1W
      case(170)
         factor=-1d0/nc**2*1d0/2d0*facV     ! d ub -> g g lm nub      sBt2g1W
      case(171)
         factor=-1d0/nc**2*facV             ! g d -> g u lm nub       sBt2g1W
      case(172)
         factor=-1d0/nc**2*1d0/2d0*facV     ! ub d -> g g lm nub      sBt2g1W
      case(173)
         factor=-1d0/nc**2*nup*facV         ! g g -> db u lm nub      sBt2g1W
      case(174)
         factor=-1d0/nc**2*facV             ! g ub -> db g lm nub     sBt2g1W
      case(175)
         factor=-1d0/nc**2*facV             ! ub g -> db g lm nub     sBt2g1W
      case(176)
         factor=-1d0/nc**3*facV             ! Q d subtraction         sBt2g1W
      case(177)
         factor=-1d0/nc**3*facV             ! Q ub subtraction        sBt2g1W
      case(178)
         factor=-1d0/nc**3*facV             ! Qb d subtraction        sBt2g1W
      case(179)
         factor=-1d0/nc**3*facV             ! Qb ub subtraction       sBt2g1W
      case(180)
         factor=-1d0/nc**3*facV             ! d Q subtraction         sBt2g1W
      case(181)
         factor=-1d0/nc**3*facV             ! d Qb subtraction        sBt2g1W
      case(182)
         factor=-1d0/nc**3*facV             ! ub Q subtraction        sBt2g1W
      case(183)
         factor=-1d0/nc**3*facV             ! ub Qb subtraction       sBt2g1W
      case(184)
         factor=-1d0/nc**2*facV             ! d gt -> gt u lm nub     sBtt2g1Wc
      case(185)
         factor=-1d0/nc**2*1d0/2d0*facV     ! d ub -> gt gt lm nub     sBtt2g1Wc
      case(186)
         factor=-1d0/nc**2*facV             ! gt d -> gt u lm nub     sBtt2g1Wc
      case(187)
         factor=-1d0/nc**2*1d0/2d0*facV     ! ub d -> gt gt lm nub     sBtt2g1Wc
      case(188)
         factor=-1d0/nc**2*nup*facV         ! gt gt -> db u lm nub     sBtt2g1Wc
      case(189)
         factor=-1d0/nc**2*facV             ! gt ub -> db gt lm nub     sBtt2g1Wc
      case(190)
         factor=-1d0/nc**2*facV             ! ub gt -> db gt lm nub     sBtt2g1Wc
      case(191)
         factor=1d0/nc**4*facV              ! d gt -> gt u lm nub     sBttt2g1W
      case(192)
         factor=1d0/nc**4*1d0/2d0*facV      ! d ub -> gt gt lm nub     sBttt2g1W
      case(193)
         factor=1d0/nc**4*facV              ! gt d -> gt u lm nub     sBttt2g1W
      case(194)
         factor=1d0/nc**4*1d0/2d0*facV      ! ub d -> gt gt lm nub     sBttt2g1W
      case(195)
         factor=1d0/nc**4*nup*facV          ! gt gt -> db u lm nub     sBttt2g1W
      case(196)
         factor=1d0/nc**4*facV              ! gt ub -> db gt lm nub     sBttt2g1W
      case(197)
         factor=1d0/nc**4*facV              ! ub gt -> db gt lm nub     sBttt2g1W
      case(198)
         factor=1d0/nc*nf*facV              ! d g -> g u lm nub       sBh2g1W
      case(199)
         factor=1d0/nc*nf*1d0/2d0*facV      ! d ub -> g g lm nub      sBh2g1W
      case(200)
         factor=1d0/nc*nf*facV              ! g d -> g u lm nub       sBh2g1W
      case(201)
         factor=1d0/nc*nf*1d0/2d0*facV      ! ub d -> g g lm nub      sBh2g1W
      case(202)
         factor=1d0/nc*nf*nup*facV          ! g g -> db u lm nub      sBh2g1W
      case(203)
         factor=1d0/nc*nf*facV              ! g ub -> db g lm nub     sBh2g1W
      case(204)
         factor=1d0/nc*nf*facV              ! ub g -> db g lm nub     sBh2g1W
      case(205)
         factor=1d0/nc**2*nf*facV           ! Q d subtraction         sBh2g1W
      case(206)
         factor=1d0/nc**2*nf*facV           ! Q ub subtraction        sBh2g1W
      case(207)
         factor=1d0/nc**2*nf*facV           ! Qb d subtraction        sBh2g1W
      case(208)
         factor=1d0/nc**2*nf*facV           ! Qb ub subtraction       sBh2g1W
      case(209)
         factor=1d0/nc**2*nf*facV           ! d Q subtraction         sBh2g1W
      case(210)
         factor=1d0/nc**2*nf*facV           ! d Qb subtraction        sBh2g1W
      case(211)
         factor=1d0/nc**2*nf*facV           ! ub Q subtraction        sBh2g1W
      case(212)
         factor=1d0/nc**2*nf*facV           ! ub Qb subtraction       sBh2g1W
      case(213)
         factor=-1d0/nc**3*nf*facV          ! d gt -> gt u lm nub     sBth2g1W
      case(214)
         factor=-1d0/nc**3*nf*1d0/2d0*facV   ! d ub -> gt gt lm nub     sBth2g1W
      case(215)
         factor=-1d0/nc**3*nf*facV          ! gt d -> gt u lm nub     sBth2g1W
      case(216)
         factor=-1d0/nc**3*nf*1d0/2d0*facV   ! ub d -> gt gt lm nub     sBth2g1W
      case(217)
         factor=-1d0/nc**3*nf*nup*facV      ! gt gt -> db u lm nub     sBth2g1W
      case(218)
         factor=-1d0/nc**3*nf*facV          ! gt ub -> db gt lm nub     sBth2g1W
      case(219)
         factor=-1d0/nc**3*nf*facV          ! ub gt -> db gt lm nub     sBth2g1W
      case(220)
         factor=1d0/nc*facV                 ! d Qb -> Qb u lm nub     sC0g1W
      case(221)
         factor=1d0/nc*facV                 ! d Q -> Q u lm nub       sC0g1W
      case(222)
         factor=1d0/nc*nf*facV              ! d ub -> Q Qb lm nub     sC0g1W
      case(223)
         factor=1d0/nc*facV                 ! Qb d -> Qb u lm nub     sC0g1W
      case(224)
         factor=1d0/nc*facV                 ! Q d -> Q u lm nub       sC0g1W
      case(225)
         factor=1d0/nc*nf*facV              ! ub d -> Q Qb lm nub     sC0g1W
      case(226)
         factor=1d0/nc*nup*facV             ! Qb Q -> db u lm nub     sC0g1W
      case(227)
         factor=1d0/nc*facV                 ! Qb ub -> db Qb lm nub     sC0g1W
      case(228)
         factor=1d0/nc*nup*facV             ! Q Qb -> db u lm nub     sC0g1W
      case(229)
         factor=1d0/nc*facV                 ! ub Qb -> db Qb lm nub     sC0g1W
      case(230)
         factor=1d0/nc*facV                 ! Q ub -> db Q lm nub     sC0g1W
      case(231)
         factor=1d0/nc*facV                 ! ub Q -> db Q lm nub     sC0g1W
      case(232)
         factor=1d0/nc*nup*facV             ! Q g subtraction         sC0g1W
      case(233)
         factor=1d0/nc*nup*facV             ! Qb g subtraction        sC0g1W
      case(234)
         factor=1d0/nc*nup*facV             ! g Q subtraction         sC0g1W
      case(235)
         factor=1d0/nc*nup*facV             ! g Qb subtraction        sC0g1W
      case(236)
         factor=1d0/nc*nf*facV              ! g d subtraction         sC0g1W
      case(237)
         factor=1d0/nc*nf*facV              ! g ub subtraction        sC0g1W
      case(238)
         factor=1d0/nc*nf*facV              ! d g subtraction         sC0g1W
      case(239)
         factor=1d0/nc*nf*facV              ! ub g subtraction        sC0g1W
      case(240)
         factor=1d0/nc**3*facV              ! d Qb -> Qb u lm nub     Ct0g1W
      case(241)
         factor=1d0/nc**3*facV              ! d Q -> Q u lm nub       Ct0g1W
      case(242)
         factor=1d0/nc**3*nf*facV           ! d ub -> Q Qb lm nub     Ct0g1W
      case(243)
         factor=1d0/nc**3*facV              ! Qb d -> Qb u lm nub     Ct0g1W
      case(244)
         factor=1d0/nc**3*facV              ! Q d -> Q u lm nub       Ct0g1W
      case(245)
         factor=1d0/nc**3*nf*facV           ! ub d -> Q Qb lm nub     Ct0g1W
      case(246)
         factor=1d0/nc**3*nup*facV          ! Qb Q -> db u lm nub     Ct0g1W
      case(247)
         factor=1d0/nc**3*facV              ! Qb ub -> db Qb lm nub     Ct0g1W
      case(248)
         factor=1d0/nc**3*nup*facV          ! Q Qb -> db u lm nub     Ct0g1W
      case(249)
         factor=1d0/nc**3*facV              ! ub Qb -> db Qb lm nub     Ct0g1W
      case(250)
         factor=1d0/nc**3*facV              ! Q ub -> db Q lm nub     Ct0g1W
      case(251)
         factor=1d0/nc**3*facV              ! ub Q -> db Q lm nub     Ct0g1W
      case(252)
         factor=1d0/nc**3*nup*facV          ! Q g subtraction         Ct0g1W
      case(253)
         factor=1d0/nc**3*nup*facV          ! Qb g subtraction        Ct0g1W
      case(254)
         factor=1d0/nc**3*nup*facV          ! g Q subtraction         Ct0g1W
      case(255)
         factor=1d0/nc**3*nup*facV          ! g Qb subtraction        Ct0g1W
      case(256)
         factor=1d0/nc**3*nf*facV           ! g d subtraction         Ct0g1W
      case(257)
         factor=1d0/nc**3*nf*facV           ! g ub subtraction        Ct0g1W
      case(258)
         factor=1d0/nc**3*nf*facV           ! d g subtraction         Ct0g1W
      case(259)
         factor=1d0/nc**3*nf*facV           ! ub g subtraction        Ct0g1W
      case(260)
         factor=1d0/nc**2*nf*facV           ! d Qb -> Qb u lm nub     Ch0g1W
      case(261)
         factor=1d0/nc**2*nf*facV           ! d Q -> Q u lm nub       Ch0g1W
      case(262)
         factor=1d0/nc**2*nf*nf*facV        ! d ub -> Q Qb lm nub     Ch0g1W
      case(263)
         factor=1d0/nc**2*nf*facV           ! Qb d -> Qb u lm nub     Ch0g1W
      case(264)
         factor=1d0/nc**2*nf*facV           ! Q d -> Q u lm nub       Ch0g1W
      case(265)
         factor=1d0/nc**2*nf*nf*facV        ! ub d -> Q Qb lm nub     Ch0g1W
      case(266)
         factor=1d0/nc**2*nf*nup*facV       ! Qb Q -> db u lm nub     Ch0g1W
      case(267)
         factor=1d0/nc**2*nf*facV           ! Qb ub -> db Qb lm nub     Ch0g1W
      case(268)
         factor=1d0/nc**2*nf*nup*facV       ! Q Qb -> db u lm nub     Ch0g1W
      case(269)
         factor=1d0/nc**2*nf*facV           ! ub Qb -> db Qb lm nub     Ch0g1W
      case(270)
         factor=1d0/nc**2*nf*facV           ! Q ub -> db Q lm nub     Ch0g1W
      case(271)
         factor=1d0/nc**2*nf*facV           ! ub Q -> db Q lm nub     Ch0g1W
      case(272)
         factor=1d0/nc**2*nf*nup*facV       ! Q g subtraction         Ch0g1W
      case(273)
         factor=1d0/nc**2*nf*nup*facV       ! Qb g subtraction        Ch0g1W
      case(274)
         factor=1d0/nc**2*nf*nup*facV       ! g Q subtraction         Ch0g1W
      case(275)
         factor=1d0/nc**2*nf*nup*facV       ! g Qb subtraction        Ch0g1W
      case(276)
         factor=1d0/nc**2*nf**2*facV        ! g d subtraction         Ch0g1W
      case(277)
         factor=1d0/nc**2*nf**2*facV        ! g ub subtraction        Ch0g1W
      case(278)
         factor=1d0/nc**2*nf**2*facV        ! d g subtraction         Ch0g1W
      case(279)
         factor=1d0/nc**2*nf**2*facV        ! ub g subtraction        Ch0g1W
      case(280)
         factor=1d0/nc**2*facV              ! d db -> db u lm nub     D0g1Wma
      case(281)
         factor=1d0/nc**2*facV              ! d d -> d u lm nub       D0g1Wma
      case(282)
         factor=1d0/nc**2*facV              ! d ub -> d db lm nub     D0g1Wma
      case(283)
         factor=1d0/nc**2*facV              ! db d -> db u lm nub     D0g1Wma
      case(284)
         factor=1d0/nc**2*facV              ! ub d -> d db lm nub     D0g1Wma
      case(285)
         factor=1d0/nc**2*1d0/2d0*facV      ! db ub -> db db lm nub     D0g1Wma
      case(286)
         factor=1d0/nc**2*1d0/2d0*facV      ! ub db -> db db lm nub     D0g1Wma
      case(287)
         factor=1d0/nc**2*facV              ! d g subtraction         D0g1Wma
      case(288)
         factor=1d0/nc**2*facV              ! db g subtraction        D0g1Wma
      case(289)
         factor=1d0/nc**2*facV              ! g d subtraction         D0g1Wma
      case(290)
         factor=1d0/nc**2*facV              ! g db subtraction        D0g1Wma
      case(291)
         factor=1d0/nc**2*facV              ! g u subtraction         D0g1Wma
      case(292)
         factor=1d0/nc**2*facV              ! u g subtraction         D0g1Wma
      case(293)
         factor=1d0/nc**2*facV              ! d ub -> ub u lm nub     D0g1Wmb
      case(294)
         factor=1d0/nc**2*1d0/2d0*facV      ! d u -> u u lm nub       D0g1Wmb
      case(295)
         factor=1d0/nc**2*facV              ! ub d -> ub u lm nub     D0g1Wmb
      case(296)
         factor=1d0/nc**2*1d0/2d0*facV      ! u d -> u u lm nub       D0g1Wmb
      case(297)
         factor=1d0/nc**2*facV              ! ub u -> db u lm nub     D0g1Wmb
      case(298)
         factor=1d0/nc**2*facV              ! ub ub -> db ub lm nub     D0g1Wmb
      case(299)
         factor=1d0/nc**2*facV              ! u ub -> db u lm nub     D0g1Wmb
      case(300)
         factor=1d0/nc**2*facV              ! db g subtraction        D0g1Wmb
      case(301)
         factor=1d0/nc**2*facV              ! g db subtraction        D0g1Wmb
      case(302)
         factor=1d0/nc**2*facV              ! g u subtraction         D0g1Wmb
      case(303)
         factor=1d0/nc**2*facV              ! g ub subtraction        D0g1Wmb
      case(304)
         factor=1d0/nc**2*facV              ! u g subtraction         D0g1Wmb
      case(305)
         factor=1d0/nc**2*facV              ! ub g subtraction        D0g1Wmb
      case(306)
         factor=1d0/nc**4*facV              ! d db -> db u lm nub     Dt0g1Wma
      case(307)
         factor=1d0/nc**4*facV              ! d d -> d u lm nub       Dt0g1Wma
      case(308)
         factor=1d0/nc**4*facV              ! d ub -> d db lm nub     Dt0g1Wma
      case(309)
         factor=1d0/nc**4*facV              ! db d -> db u lm nub     Dt0g1Wma
      case(310)
         factor=1d0/nc**4*facV              ! ub d -> d db lm nub     Dt0g1Wma
      case(311)
         factor=1d0/nc**4*1d0/2d0*facV      ! db ub -> db db lm nub     Dt0g1Wma
      case(312)
         factor=1d0/nc**4*1d0/2d0*facV      ! ub db -> db db lm nub     Dt0g1Wma
      case(313)
         factor=1d0/nc**4*facV              ! d g subtraction         Dt0g1Wma
      case(314)
         factor=1d0/nc**4*facV              ! db g subtraction        Dt0g1Wma
      case(315)
         factor=1d0/nc**4*facV              ! g d subtraction         Dt0g1Wma
      case(316)
         factor=1d0/nc**4*facV              ! g db subtraction        Dt0g1Wma
      case(317)
         factor=1d0/nc**4*facV              ! g u subtraction         Dt0g1Wma
      case(318)
         factor=1d0/nc**4*facV              ! u g subtraction         Dt0g1Wma
      case(319)
         factor=1d0/nc**4*facV              ! d ub -> ub u lm nub     Dt0g1Wmb
      case(320)
         factor=1d0/nc**4*1d0/2d0*facV      ! d u -> u u lm nub       Dt0g1Wmb
      case(321)
         factor=1d0/nc**4*facV              ! ub d -> ub u lm nub     Dt0g1Wmb
      case(322)
         factor=1d0/nc**4*1d0/2d0*facV      ! u d -> u u lm nub       Dt0g1Wmb
      case(323)
         factor=1d0/nc**4*facV              ! ub u -> db u lm nub     Dt0g1Wmb
      case(324)
         factor=1d0/nc**4*facV              ! ub ub -> db ub lm nub     Dt0g1Wmb
      case(325)
         factor=1d0/nc**4*facV              ! u ub -> db u lm nub     Dt0g1Wmb
      case(326)
         factor=1d0/nc**4*facV              ! db g subtraction        Dt0g1Wmb
      case(327)
         factor=1d0/nc**4*facV              ! g db subtraction        Dt0g1Wmb
      case(328)
         factor=1d0/nc**4*facV              ! g u subtraction         Dt0g1Wmb
      case(329)
         factor=1d0/nc**4*facV              ! g ub subtraction        Dt0g1Wmb
      case(330)
         factor=1d0/nc**4*facV              ! u g subtraction         Dt0g1Wmb
      case(331)
         factor=1d0/nc**4*facV              ! ub g subtraction        Dt0g1Wmb
      case(332)
         factor=1d0/nc**3*nf*facV           ! d db -> db u lm nub     Dh0g1Wma
      case(333)
         factor=1d0/nc**3*nf*facV           ! d d -> d u lm nub       Dh0g1Wma
      case(334)
         factor=1d0/nc**3*nf*facV           ! d ub -> d db lm nub     Dh0g1Wma
      case(335)
         factor=1d0/nc**3*nf*facV           ! db d -> db u lm nub     Dh0g1Wma
      case(336)
         factor=1d0/nc**3*nf*facV           ! ub d -> d db lm nub     Dh0g1Wma
      case(337)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! db ub -> db db lm nub     Dh0g1Wma
      case(338)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! ub db -> db db lm nub     Dh0g1Wma
      case(339)
         factor=1d0/nc**3*nf*facV           ! d g subtraction         Dh0g1Wma
      case(340)
         factor=1d0/nc**3*nf*facV           ! db g subtraction        Dh0g1Wma
      case(341)
         factor=1d0/nc**3*nf*facV           ! g d subtraction         Dh0g1Wma
      case(342)
         factor=1d0/nc**3*nf*facV           ! g db subtraction        Dh0g1Wma
      case(343)
         factor=1d0/nc**3*nf*facV           ! g u subtraction         Dh0g1Wma
      case(344)
         factor=1d0/nc**3*nf*facV           ! u g subtraction         Dh0g1Wma
      case(345)
         factor=1d0/nc**3*nf*facV           ! d ub -> ub u lm nub     Dh0g1Wmb
      case(346)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! d u -> u u lm nub       Dh0g1Wmb
      case(347)
         factor=1d0/nc**3*nf*facV           ! ub d -> ub u lm nub     Dh0g1Wmb
      case(348)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! u d -> u u lm nub       Dh0g1Wmb
      case(349)
         factor=1d0/nc**3*nf*facV           ! ub u -> db u lm nub     Dh0g1Wmb
      case(350)
         factor=1d0/nc**3*nf*facV           ! ub ub -> db ub lm nub     Dh0g1Wmb
      case(351)
         factor=1d0/nc**3*nf*facV           ! u ub -> db u lm nub     Dh0g1Wmb
      case(352)
         factor=1d0/nc**3*nf*facV           ! db g subtraction        Dh0g1Wmb
      case(353)
         factor=1d0/nc**3*nf*facV           ! g db subtraction        Dh0g1Wmb
      case(354)
         factor=1d0/nc**3*nf*facV           ! g u subtraction         Dh0g1Wmb
      case(355)
         factor=1d0/nc**3*nf*facV           ! g ub subtraction        Dh0g1Wmb
      case(356)
         factor=1d0/nc**3*nf*facV           ! u g subtraction         Dh0g1Wmb
      case(357)
         factor=1d0/nc**3*nf*facV           ! ub g subtraction        Dh0g1Wmb

c -- double real


c -- real virtual


c -- double virtual

      end select
      factor=relfactor*factor

      return
      end
