      subroutine getqcdnormWpJJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      real(8) :: fac_ckm
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtWpJJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVWpJJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourWpJJ(current_chan)
         do isub = 1, nflavourWpJJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_WpJJ(current_chan, isub, ipass_sub, flav_block, fac_ckm)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           partons_sub = fac_ckm*partons_sub
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=WpJJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param()/stw)**2*(nc**2-1)*nc*(4d0*pi*alphas_scl)
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! u g -> g d nu lp        B2g0W
      case(2)
         factor=1d0/2d0*facB                ! u db -> g g nu lp       B2g0W
      case(3)
         factor=facB                        ! g u -> g d nu lp        B2g0W
      case(4)
         factor=1d0/2d0*facB                ! db u -> g g nu lp       B2g0W
      case(5)
         factor=nup*facB                    ! g g -> ub d nu lp       B2g0W
      case(6)
         factor=facB                        ! g db -> ub g nu lp      B2g0W
      case(7)
         factor=facB                        ! db g -> ub g nu lp      B2g0W
      case(8)
         factor=-1d0/nc**2*facB             ! u gt -> gt d nu lp      Bt2g0W
      case(9)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u db -> gt gt nu lp     Bt2g0W
      case(10)
         factor=-1d0/nc**2*facB             ! gt u -> gt d nu lp      Bt2g0W
      case(11)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db u -> gt gt nu lp     Bt2g0W
      case(12)
         factor=-1d0/nc**2*nup*facB         ! gt gt -> ub d nu lp     Bt2g0W
      case(13)
         factor=-1d0/nc**2*facB             ! gt db -> ub gt nu lp     Bt2g0W
      case(14)
         factor=-1d0/nc**2*facB             ! db gt -> ub gt nu lp     Bt2g0W
      case(15)
         factor=1d0/nc*facB                 ! u Qb -> Qb d nu lp      C0g0W
      case(16)
         factor=1d0/nc*facB                 ! u Q -> Q d nu lp        C0g0W
      case(17)
         factor=1d0/nc*nf*facB              ! u db -> Q Qb nu lp      C0g0W
      case(18)
         factor=1d0/nc*facB                 ! Qb u -> Qb d nu lp      C0g0W
      case(19)
         factor=1d0/nc*facB                 ! Q u -> Q d nu lp        C0g0W
      case(20)
         factor=1d0/nc*nf*facB              ! db u -> Q Qb nu lp      C0g0W
      case(21)
         factor=1d0/nc*nup*facB             ! Qb Q -> ub d nu lp      C0g0W
      case(22)
         factor=1d0/nc*facB                 ! Qb db -> ub Qb nu lp     C0g0W
      case(23)
         factor=1d0/nc*nup*facB             ! Q Qb -> ub d nu lp      C0g0W
      case(24)
         factor=1d0/nc*facB                 ! db Qb -> ub Qb nu lp     C0g0W
      case(25)
         factor=1d0/nc*facB                 ! Q db -> ub Q nu lp      C0g0W
      case(26)
         factor=1d0/nc*facB                 ! db Q -> ub Q nu lp      C0g0W
      case(27)
         factor=-1d0/nc**2*facB             ! u ub -> ub d nu lp      D0g0Wa
      case(28)
         factor=-1d0/nc**2*facB             ! u u -> u d nu lp        D0g0Wa
      case(29)
         factor=-1d0/nc**2*facB             ! u db -> u ub nu lp      D0g0Wa
      case(30)
         factor=-1d0/nc**2*facB             ! ub u -> ub d nu lp      D0g0Wa
      case(31)
         factor=-1d0/nc**2*facB             ! db u -> u ub nu lp      D0g0Wa
      case(32)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub db -> ub ub nu lp     D0g0Wa
      case(33)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db ub -> ub ub nu lp     D0g0Wa
      case(34)
         factor=-1d0/nc**2*facB             ! u db -> db d nu lp      D0g0Wb
      case(35)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u d -> d d nu lp        D0g0Wb
      case(36)
         factor=-1d0/nc**2*facB             ! db u -> db d nu lp      D0g0Wb
      case(37)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d u -> d d nu lp        D0g0Wb
      case(38)
         factor=-1d0/nc**2*facB             ! db d -> ub d nu lp      D0g0Wb
      case(39)
         factor=-1d0/nc**2*facB             ! db db -> ub db nu lp     D0g0Wb
      case(40)
         factor=-1d0/nc**2*facB             ! d db -> ub d nu lp      D0g0Wb

c -- real

      case(41)
         factor=1d0/2d0*facR                ! u g -> g g d nu lp      sB3g0W
      case(42)
         factor=1d0/6d0*facR                ! u db -> g g g nu lp     sB3g0W
      case(43)
         factor=1d0/2d0*facR                ! g u -> g g d nu lp      sB3g0W
      case(44)
         factor=1d0/6d0*facR                ! db u -> g g g nu lp     sB3g0W
      case(45)
         factor=nup*facR                    ! g g -> ub g d nu lp     sB3g0W
      case(46)
         factor=1d0/2d0*facR                ! g db -> ub g g nu lp     sB3g0W
      case(47)
         factor=1d0/2d0*facR                ! db g -> ub g g nu lp     sB3g0W
      case(48)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u g -> g g d nu lp      sBt3g0W
      case(49)
         factor=-1d0/nc**2*1d0/6d0*facR     ! u db -> g g g nu lp     sBt3g0W
      case(50)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g u -> g g d nu lp      sBt3g0W
      case(51)
         factor=-1d0/nc**2*1d0/6d0*facR     ! db u -> g g g nu lp     sBt3g0W
      case(52)
         factor=-1d0/nc**2*nup*facR         ! g g -> ub g d nu lp     sBt3g0W
      case(53)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g db -> ub g g nu lp     sBt3g0W
      case(54)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db g -> ub g g nu lp     sBt3g0W
      case(55)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! u gt -> gt gt d nu lp     sBtt3g0W
      case(56)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facR   ! u db -> gt gt gt nu lp     sBtt3g0W
      case(57)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! gt u -> gt gt d nu lp     sBtt3g0W
      case(58)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facR   ! db u -> gt gt gt nu lp     sBtt3g0W
      case(59)
         factor=(nc**2+1d0)/nc**4*nup*facR   ! gt gt -> ub gt d nu lp     sBtt3g0W
      case(60)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! gt db -> ub gt gt nu lp     sBtt3g0W
      case(61)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! db gt -> ub gt gt nu lp     sBtt3g0W
      case(62)
         factor=1d0/nc*nf*facR              ! u g -> Q Qb d nu lp     sC1g0W
      case(63)
         factor=1d0/nc*facR                 ! u Qb -> g Qb d nu lp     sC1g0W
      case(64)
         factor=1d0/nc*facR                 ! u Q -> g Q d nu lp      sC1g0W
      case(65)
         factor=1d0/nc*nf*facR              ! u db -> g Q Qb nu lp     sC1g0W
      case(66)
         factor=1d0/nc*nf*facR              ! g u -> Q Qb d nu lp     sC1g0W
      case(67)
         factor=1d0/nc*facR                 ! Qb u -> g Qb d nu lp     sC1g0W
      case(68)
         factor=1d0/nc*facR                 ! Q u -> g Q d nu lp      sC1g0W
      case(69)
         factor=1d0/nc*nf*facR              ! db u -> g Q Qb nu lp     sC1g0W
      case(70)
         factor=1d0/nc*nup*facR             ! g Qb -> ub Qb d nu lp     sC1g0W
      case(71)
         factor=1d0/nc*nup*facR             ! g Q -> ub Q d nu lp     sC1g0W
      case(72)
         factor=1d0/nc*nf*facR              ! g db -> ub Q Qb nu lp     sC1g0W
      case(73)
         factor=1d0/nc*nup*facR             ! Qb g -> ub Qb d nu lp     sC1g0W
      case(74)
         factor=1d0/nc*nup*facR             ! Q g -> ub Q d nu lp     sC1g0W
      case(75)
         factor=1d0/nc*nf*facR              ! db g -> ub Q Qb nu lp     sC1g0W
      case(76)
         factor=1d0/nc*nup*facR             ! Qb Q -> ub g d nu lp     sC1g0W
      case(77)
         factor=1d0/nc*facR                 ! Qb db -> ub g Qb nu lp     sC1g0W
      case(78)
         factor=1d0/nc*nup*facR             ! Q Qb -> ub g d nu lp     sC1g0W
      case(79)
         factor=1d0/nc*facR                 ! db Qb -> ub g Qb nu lp     sC1g0W
      case(80)
         factor=1d0/nc*facR                 ! Q db -> ub g Q nu lp     sC1g0W
      case(81)
         factor=1d0/nc*facR                 ! db Q -> ub g Q nu lp     sC1g0W
      case(82)
         factor=1d0/nc**3*nf*facR           ! u g -> Q Qb d nu lp     sCt1g0W
      case(83)
         factor=1d0/nc**3*facR              ! u Qb -> g Qb d nu lp     sCt1g0W
      case(84)
         factor=1d0/nc**3*facR              ! u Q -> g Q d nu lp      sCt1g0W
      case(85)
         factor=1d0/nc**3*nf*facR           ! u db -> g Q Qb nu lp     sCt1g0W
      case(86)
         factor=1d0/nc**3*nf*facR           ! g u -> Q Qb d nu lp     sCt1g0W
      case(87)
         factor=1d0/nc**3*facR              ! Qb u -> g Qb d nu lp     sCt1g0W
      case(88)
         factor=1d0/nc**3*facR              ! Q u -> g Q d nu lp      sCt1g0W
      case(89)
         factor=1d0/nc**3*nf*facR           ! db u -> g Q Qb nu lp     sCt1g0W
      case(90)
         factor=1d0/nc**3*nup*facR          ! g Qb -> ub Qb d nu lp     sCt1g0W
      case(91)
         factor=1d0/nc**3*nup*facR          ! g Q -> ub Q d nu lp     sCt1g0W
      case(92)
         factor=1d0/nc**3*nf*facR           ! g db -> ub Q Qb nu lp     sCt1g0W
      case(93)
         factor=1d0/nc**3*nup*facR          ! Qb g -> ub Qb d nu lp     sCt1g0W
      case(94)
         factor=1d0/nc**3*nup*facR          ! Q g -> ub Q d nu lp     sCt1g0W
      case(95)
         factor=1d0/nc**3*nf*facR           ! db g -> ub Q Qb nu lp     sCt1g0W
      case(96)
         factor=1d0/nc**3*nup*facR          ! Qb Q -> ub g d nu lp     sCt1g0W
      case(97)
         factor=1d0/nc**3*facR              ! Qb db -> ub g Qb nu lp     sCt1g0W
      case(98)
         factor=1d0/nc**3*nup*facR          ! Q Qb -> ub g d nu lp     sCt1g0W
      case(99)
         factor=1d0/nc**3*facR              ! db Qb -> ub g Qb nu lp     sCt1g0W
      case(100)
         factor=1d0/nc**3*facR              ! Q db -> ub g Q nu lp     sCt1g0W
      case(101)
         factor=1d0/nc**3*facR              ! db Q -> ub g Q nu lp     sCt1g0W
      case(102)
         factor=-1d0/nc**2*facR             ! u g -> u ub d nu lp     D1g0Wpac
      case(103)
         factor=-1d0/nc**2*facR             ! u ub -> g ub d nu lp     D1g0Wpac
      case(104)
         factor=-1d0/nc**2*facR             ! u u -> g u d nu lp      D1g0Wpac
      case(105)
         factor=-1d0/nc**2*facR             ! u db -> g u ub nu lp     D1g0Wpac
      case(106)
         factor=-1d0/nc**2*facR             ! g u -> u ub d nu lp     D1g0Wpac
      case(107)
         factor=-1d0/nc**2*facR             ! ub u -> g ub d nu lp     D1g0Wpac
      case(108)
         factor=-1d0/nc**2*facR             ! db u -> g u ub nu lp     D1g0Wpac
      case(109)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g ub -> ub ub d nu lp     D1g0Wpac
      case(110)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g db -> ub u ub nu lp     D1g0Wpac
      case(111)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub g -> ub ub d nu lp     D1g0Wpac
      case(112)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db g -> ub u ub nu lp     D1g0Wpac
      case(113)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub db -> ub g ub nu lp     D1g0Wpac
      case(114)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db ub -> ub g ub nu lp     D1g0Wpac
      case(115)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u g -> d db d nu lp     D1g0Wpbc
      case(116)
         factor=-1d0/nc**2*facR             ! u db -> g db d nu lp     D1g0Wpbc
      case(117)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u d -> g d d nu lp      D1g0Wpbc
      case(118)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g u -> d db d nu lp     D1g0Wpbc
      case(119)
         factor=-1d0/nc**2*facR             ! db u -> g db d nu lp     D1g0Wpbc
      case(120)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d u -> g d d nu lp      D1g0Wpbc
      case(121)
         factor=-1d0/nc**2*facR             ! g db -> ub db d nu lp     D1g0Wpbc
      case(122)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g d -> ub d d nu lp     D1g0Wpbc
      case(123)
         factor=-1d0/nc**2*facR             ! db g -> ub db d nu lp     D1g0Wpbc
      case(124)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d g -> ub d d nu lp     D1g0Wpbc
      case(125)
         factor=-1d0/nc**2*facR             ! db d -> ub g d nu lp     D1g0Wpbc
      case(126)
         factor=-1d0/nc**2*facR             ! db db -> ub g db nu lp     D1g0Wpbc
      case(127)
         factor=-1d0/nc**2*facR             ! d db -> ub g d nu lp     D1g0Wpbc
      case(128)
         factor=1d0/nc**4*facR              ! u g -> u ub d nu lp     Dt1g0Wpa
      case(129)
         factor=1d0/nc**4*facR              ! u ub -> g ub d nu lp     Dt1g0Wpa
      case(130)
         factor=1d0/nc**4*facR              ! u u -> g u d nu lp      Dt1g0Wpa
      case(131)
         factor=1d0/nc**4*facR              ! u db -> g u ub nu lp     Dt1g0Wpa
      case(132)
         factor=1d0/nc**4*facR              ! g u -> u ub d nu lp     Dt1g0Wpa
      case(133)
         factor=1d0/nc**4*facR              ! ub u -> g ub d nu lp     Dt1g0Wpa
      case(134)
         factor=1d0/nc**4*facR              ! db u -> g u ub nu lp     Dt1g0Wpa
      case(135)
         factor=1d0/nc**4*1d0/2d0*facR      ! g ub -> ub ub d nu lp     Dt1g0Wpa
      case(136)
         factor=1d0/nc**4*1d0/2d0*facR      ! g db -> ub u ub nu lp     Dt1g0Wpa
      case(137)
         factor=1d0/nc**4*1d0/2d0*facR      ! ub g -> ub ub d nu lp     Dt1g0Wpa
      case(138)
         factor=1d0/nc**4*1d0/2d0*facR      ! db g -> ub u ub nu lp     Dt1g0Wpa
      case(139)
         factor=1d0/nc**4*1d0/2d0*facR      ! ub db -> ub g ub nu lp     Dt1g0Wpa
      case(140)
         factor=1d0/nc**4*1d0/2d0*facR      ! db ub -> ub g ub nu lp     Dt1g0Wpa
      case(141)
         factor=1d0/nc**4*1d0/2d0*facR      ! u g -> d db d nu lp     Dt1g0Wpb
      case(142)
         factor=1d0/nc**4*facR              ! u db -> g db d nu lp     Dt1g0Wpb
      case(143)
         factor=1d0/nc**4*1d0/2d0*facR      ! u d -> g d d nu lp      Dt1g0Wpb
      case(144)
         factor=1d0/nc**4*1d0/2d0*facR      ! g u -> d db d nu lp     Dt1g0Wpb
      case(145)
         factor=1d0/nc**4*facR              ! db u -> g db d nu lp     Dt1g0Wpb
      case(146)
         factor=1d0/nc**4*1d0/2d0*facR      ! d u -> g d d nu lp      Dt1g0Wpb
      case(147)
         factor=1d0/nc**4*facR              ! g db -> ub db d nu lp     Dt1g0Wpb
      case(148)
         factor=1d0/nc**4*1d0/2d0*facR      ! g d -> ub d d nu lp     Dt1g0Wpb
      case(149)
         factor=1d0/nc**4*facR              ! db g -> ub db d nu lp     Dt1g0Wpb
      case(150)
         factor=1d0/nc**4*1d0/2d0*facR      ! d g -> ub d d nu lp     Dt1g0Wpb
      case(151)
         factor=1d0/nc**4*facR              ! db d -> ub g d nu lp     Dt1g0Wpb
      case(152)
         factor=1d0/nc**4*facR              ! db db -> ub g db nu lp     Dt1g0Wpb
      case(153)
         factor=1d0/nc**4*facR              ! d db -> ub g d nu lp     Dt1g0Wpb

c -- virtual

      case(154)
         factor=facV                        ! u g -> g d nu lp        sB2g1W
      case(155)
         factor=1d0/2d0*facV                ! u db -> g g nu lp       sB2g1W
      case(156)
         factor=facV                        ! g u -> g d nu lp        sB2g1W
      case(157)
         factor=1d0/2d0*facV                ! db u -> g g nu lp       sB2g1W
      case(158)
         factor=nup*facV                    ! g g -> ub d nu lp       sB2g1W
      case(159)
         factor=facV                        ! g db -> ub g nu lp      sB2g1W
      case(160)
         factor=facV                        ! db g -> ub g nu lp      sB2g1W
      case(161)
         factor=1d0/nc*facV                 ! Q u subtraction         sB2g1W
      case(162)
         factor=1d0/nc*facV                 ! Q db subtraction        sB2g1W
      case(163)
         factor=1d0/nc*facV                 ! Qb u subtraction        sB2g1W
      case(164)
         factor=1d0/nc*facV                 ! Qb db subtraction       sB2g1W
      case(165)
         factor=1d0/nc*facV                 ! u Q subtraction         sB2g1W
      case(166)
         factor=1d0/nc*facV                 ! u Qb subtraction        sB2g1W
      case(167)
         factor=1d0/nc*facV                 ! db Q subtraction        sB2g1W
      case(168)
         factor=1d0/nc*facV                 ! db Qb subtraction       sB2g1W
      case(169)
         factor=-1d0/nc**2*facV             ! u g -> g d nu lp        sBt2g1W
      case(170)
         factor=-1d0/nc**2*1d0/2d0*facV     ! u db -> g g nu lp       sBt2g1W
      case(171)
         factor=-1d0/nc**2*facV             ! g u -> g d nu lp        sBt2g1W
      case(172)
         factor=-1d0/nc**2*1d0/2d0*facV     ! db u -> g g nu lp       sBt2g1W
      case(173)
         factor=-1d0/nc**2*nup*facV         ! g g -> ub d nu lp       sBt2g1W
      case(174)
         factor=-1d0/nc**2*facV             ! g db -> ub g nu lp      sBt2g1W
      case(175)
         factor=-1d0/nc**2*facV             ! db g -> ub g nu lp      sBt2g1W
      case(176)
         factor=-1d0/nc**3*facV             ! Q u subtraction         sBt2g1W
      case(177)
         factor=-1d0/nc**3*facV             ! Q db subtraction        sBt2g1W
      case(178)
         factor=-1d0/nc**3*facV             ! Qb u subtraction        sBt2g1W
      case(179)
         factor=-1d0/nc**3*facV             ! Qb db subtraction       sBt2g1W
      case(180)
         factor=-1d0/nc**3*facV             ! u Q subtraction         sBt2g1W
      case(181)
         factor=-1d0/nc**3*facV             ! u Qb subtraction        sBt2g1W
      case(182)
         factor=-1d0/nc**3*facV             ! db Q subtraction        sBt2g1W
      case(183)
         factor=-1d0/nc**3*facV             ! db Qb subtraction       sBt2g1W
      case(184)
         factor=-1d0/nc**2*facV             ! u gt -> gt d nu lp      sBtt2g1Wc
      case(185)
         factor=-1d0/nc**2*1d0/2d0*facV     ! u db -> gt gt nu lp     sBtt2g1Wc
      case(186)
         factor=-1d0/nc**2*facV             ! gt u -> gt d nu lp      sBtt2g1Wc
      case(187)
         factor=-1d0/nc**2*1d0/2d0*facV     ! db u -> gt gt nu lp     sBtt2g1Wc
      case(188)
         factor=-1d0/nc**2*nup*facV         ! gt gt -> ub d nu lp     sBtt2g1Wc
      case(189)
         factor=-1d0/nc**2*facV             ! gt db -> ub gt nu lp     sBtt2g1Wc
      case(190)
         factor=-1d0/nc**2*facV             ! db gt -> ub gt nu lp     sBtt2g1Wc
      case(191)
         factor=1d0/nc**4*facV              ! u gt -> gt d nu lp      sBttt2g1W
      case(192)
         factor=1d0/nc**4*1d0/2d0*facV      ! u db -> gt gt nu lp     sBttt2g1W
      case(193)
         factor=1d0/nc**4*facV              ! gt u -> gt d nu lp      sBttt2g1W
      case(194)
         factor=1d0/nc**4*1d0/2d0*facV      ! db u -> gt gt nu lp     sBttt2g1W
      case(195)
         factor=1d0/nc**4*nup*facV          ! gt gt -> ub d nu lp     sBttt2g1W
      case(196)
         factor=1d0/nc**4*facV              ! gt db -> ub gt nu lp     sBttt2g1W
      case(197)
         factor=1d0/nc**4*facV              ! db gt -> ub gt nu lp     sBttt2g1W
      case(198)
         factor=1d0/nc*nf*facV              ! u g -> g d nu lp        sBh2g1W
      case(199)
         factor=1d0/nc*nf*1d0/2d0*facV      ! u db -> g g nu lp       sBh2g1W
      case(200)
         factor=1d0/nc*nf*facV              ! g u -> g d nu lp        sBh2g1W
      case(201)
         factor=1d0/nc*nf*1d0/2d0*facV      ! db u -> g g nu lp       sBh2g1W
      case(202)
         factor=1d0/nc*nf*nup*facV          ! g g -> ub d nu lp       sBh2g1W
      case(203)
         factor=1d0/nc*nf*facV              ! g db -> ub g nu lp      sBh2g1W
      case(204)
         factor=1d0/nc*nf*facV              ! db g -> ub g nu lp      sBh2g1W
      case(205)
         factor=1d0/nc**2*nf*facV           ! Q u subtraction         sBh2g1W
      case(206)
         factor=1d0/nc**2*nf*facV           ! Q db subtraction        sBh2g1W
      case(207)
         factor=1d0/nc**2*nf*facV           ! Qb u subtraction        sBh2g1W
      case(208)
         factor=1d0/nc**2*nf*facV           ! Qb db subtraction       sBh2g1W
      case(209)
         factor=1d0/nc**2*nf*facV           ! u Q subtraction         sBh2g1W
      case(210)
         factor=1d0/nc**2*nf*facV           ! u Qb subtraction        sBh2g1W
      case(211)
         factor=1d0/nc**2*nf*facV           ! db Q subtraction        sBh2g1W
      case(212)
         factor=1d0/nc**2*nf*facV           ! db Qb subtraction       sBh2g1W
      case(213)
         factor=-1d0/nc**3*nf*facV          ! u gt -> gt d nu lp      sBth2g1W
      case(214)
         factor=-1d0/nc**3*nf*1d0/2d0*facV   ! u db -> gt gt nu lp     sBth2g1W
      case(215)
         factor=-1d0/nc**3*nf*facV          ! gt u -> gt d nu lp      sBth2g1W
      case(216)
         factor=-1d0/nc**3*nf*1d0/2d0*facV   ! db u -> gt gt nu lp     sBth2g1W
      case(217)
         factor=-1d0/nc**3*nf*nup*facV      ! gt gt -> ub d nu lp     sBth2g1W
      case(218)
         factor=-1d0/nc**3*nf*facV          ! gt db -> ub gt nu lp     sBth2g1W
      case(219)
         factor=-1d0/nc**3*nf*facV          ! db gt -> ub gt nu lp     sBth2g1W
      case(220)
         factor=1d0/nc*facV                 ! u Qb -> Qb d nu lp      sC0g1W
      case(221)
         factor=1d0/nc*facV                 ! u Q -> Q d nu lp        sC0g1W
      case(222)
         factor=1d0/nc*nf*facV              ! u db -> Q Qb nu lp      sC0g1W
      case(223)
         factor=1d0/nc*facV                 ! Qb u -> Qb d nu lp      sC0g1W
      case(224)
         factor=1d0/nc*facV                 ! Q u -> Q d nu lp        sC0g1W
      case(225)
         factor=1d0/nc*nf*facV              ! db u -> Q Qb nu lp      sC0g1W
      case(226)
         factor=1d0/nc*nup*facV             ! Qb Q -> ub d nu lp      sC0g1W
      case(227)
         factor=1d0/nc*facV                 ! Qb db -> ub Qb nu lp     sC0g1W
      case(228)
         factor=1d0/nc*nup*facV             ! Q Qb -> ub d nu lp      sC0g1W
      case(229)
         factor=1d0/nc*facV                 ! db Qb -> ub Qb nu lp     sC0g1W
      case(230)
         factor=1d0/nc*facV                 ! Q db -> ub Q nu lp      sC0g1W
      case(231)
         factor=1d0/nc*facV                 ! db Q -> ub Q nu lp      sC0g1W
      case(232)
         factor=1d0/nc*nup*facV             ! Q g subtraction         sC0g1W
      case(233)
         factor=1d0/nc*nup*facV             ! Qb g subtraction        sC0g1W
      case(234)
         factor=1d0/nc*nup*facV             ! g Q subtraction         sC0g1W
      case(235)
         factor=1d0/nc*nup*facV             ! g Qb subtraction        sC0g1W
      case(236)
         factor=1d0/nc*nf*facV              ! g u subtraction         sC0g1W
      case(237)
         factor=1d0/nc*nf*facV              ! g db subtraction        sC0g1W
      case(238)
         factor=1d0/nc*nf*facV              ! u g subtraction         sC0g1W
      case(239)
         factor=1d0/nc*nf*facV              ! db g subtraction        sC0g1W
      case(240)
         factor=1d0/nc**3*facV              ! u Qb -> Qb d nu lp      Ct0g1W
      case(241)
         factor=1d0/nc**3*facV              ! u Q -> Q d nu lp        Ct0g1W
      case(242)
         factor=1d0/nc**3*nf*facV           ! u db -> Q Qb nu lp      Ct0g1W
      case(243)
         factor=1d0/nc**3*facV              ! Qb u -> Qb d nu lp      Ct0g1W
      case(244)
         factor=1d0/nc**3*facV              ! Q u -> Q d nu lp        Ct0g1W
      case(245)
         factor=1d0/nc**3*nf*facV           ! db u -> Q Qb nu lp      Ct0g1W
      case(246)
         factor=1d0/nc**3*nup*facV          ! Qb Q -> ub d nu lp      Ct0g1W
      case(247)
         factor=1d0/nc**3*facV              ! Qb db -> ub Qb nu lp     Ct0g1W
      case(248)
         factor=1d0/nc**3*nup*facV          ! Q Qb -> ub d nu lp      Ct0g1W
      case(249)
         factor=1d0/nc**3*facV              ! db Qb -> ub Qb nu lp     Ct0g1W
      case(250)
         factor=1d0/nc**3*facV              ! Q db -> ub Q nu lp      Ct0g1W
      case(251)
         factor=1d0/nc**3*facV              ! db Q -> ub Q nu lp      Ct0g1W
      case(252)
         factor=1d0/nc**3*nup*facV          ! Q g subtraction         Ct0g1W
      case(253)
         factor=1d0/nc**3*nup*facV          ! Qb g subtraction        Ct0g1W
      case(254)
         factor=1d0/nc**3*nup*facV          ! g Q subtraction         Ct0g1W
      case(255)
         factor=1d0/nc**3*nup*facV          ! g Qb subtraction        Ct0g1W
      case(256)
         factor=1d0/nc**3*nf*facV           ! g u subtraction         Ct0g1W
      case(257)
         factor=1d0/nc**3*nf*facV           ! g db subtraction        Ct0g1W
      case(258)
         factor=1d0/nc**3*nf*facV           ! u g subtraction         Ct0g1W
      case(259)
         factor=1d0/nc**3*nf*facV           ! db g subtraction        Ct0g1W
      case(260)
         factor=1d0/nc**2*nf*facV           ! u Qb -> Qb d nu lp      Ch0g1W
      case(261)
         factor=1d0/nc**2*nf*facV           ! u Q -> Q d nu lp        Ch0g1W
      case(262)
         factor=1d0/nc**2*nf*nf*facV        ! u db -> Q Qb nu lp      Ch0g1W
      case(263)
         factor=1d0/nc**2*nf*facV           ! Qb u -> Qb d nu lp      Ch0g1W
      case(264)
         factor=1d0/nc**2*nf*facV           ! Q u -> Q d nu lp        Ch0g1W
      case(265)
         factor=1d0/nc**2*nf*nf*facV        ! db u -> Q Qb nu lp      Ch0g1W
      case(266)
         factor=1d0/nc**2*nf*nup*facV       ! Qb Q -> ub d nu lp      Ch0g1W
      case(267)
         factor=1d0/nc**2*nf*facV           ! Qb db -> ub Qb nu lp     Ch0g1W
      case(268)
         factor=1d0/nc**2*nf*nup*facV       ! Q Qb -> ub d nu lp      Ch0g1W
      case(269)
         factor=1d0/nc**2*nf*facV           ! db Qb -> ub Qb nu lp     Ch0g1W
      case(270)
         factor=1d0/nc**2*nf*facV           ! Q db -> ub Q nu lp      Ch0g1W
      case(271)
         factor=1d0/nc**2*nf*facV           ! db Q -> ub Q nu lp      Ch0g1W
      case(272)
         factor=1d0/nc**2*nf*nup*facV       ! Q g subtraction         Ch0g1W
      case(273)
         factor=1d0/nc**2*nf*nup*facV       ! Qb g subtraction        Ch0g1W
      case(274)
         factor=1d0/nc**2*nf*nup*facV       ! g Q subtraction         Ch0g1W
      case(275)
         factor=1d0/nc**2*nf*nup*facV       ! g Qb subtraction        Ch0g1W
      case(276)
         factor=1d0/nc**2*nf**2*facV        ! g u subtraction         Ch0g1W
      case(277)
         factor=1d0/nc**2*nf**2*facV        ! g db subtraction        Ch0g1W
      case(278)
         factor=1d0/nc**2*nf**2*facV        ! u g subtraction         Ch0g1W
      case(279)
         factor=1d0/nc**2*nf**2*facV        ! db g subtraction        Ch0g1W
      case(280)
         factor=1d0/nc**2*facV              ! u ub -> ub d nu lp      D0g1Wpa
      case(281)
         factor=1d0/nc**2*facV              ! u u -> u d nu lp        D0g1Wpa
      case(282)
         factor=1d0/nc**2*facV              ! u db -> u ub nu lp      D0g1Wpa
      case(283)
         factor=1d0/nc**2*facV              ! ub u -> ub d nu lp      D0g1Wpa
      case(284)
         factor=1d0/nc**2*facV              ! db u -> u ub nu lp      D0g1Wpa
      case(285)
         factor=1d0/nc**2*1d0/2d0*facV      ! ub db -> ub ub nu lp     D0g1Wpa
      case(286)
         factor=1d0/nc**2*1d0/2d0*facV      ! db ub -> ub ub nu lp     D0g1Wpa
      case(287)
         factor=1d0/nc**2*facV              ! d g subtraction         D0g1Wpa
      case(288)
         factor=1d0/nc**2*facV              ! g d subtraction         D0g1Wpa
      case(289)
         factor=1d0/nc**2*facV              ! g u subtraction         D0g1Wpa
      case(290)
         factor=1d0/nc**2*facV              ! g ub subtraction        D0g1Wpa
      case(291)
         factor=1d0/nc**2*facV              ! u g subtraction         D0g1Wpa
      case(292)
         factor=1d0/nc**2*facV              ! ub g subtraction        D0g1Wpa
      case(293)
         factor=1d0/nc**2*facV              ! u db -> db d nu lp      D0g1Wpb
      case(294)
         factor=1d0/nc**2*1d0/2d0*facV      ! u d -> d d nu lp        D0g1Wpb
      case(295)
         factor=1d0/nc**2*facV              ! db u -> db d nu lp      D0g1Wpb
      case(296)
         factor=1d0/nc**2*1d0/2d0*facV      ! d u -> d d nu lp        D0g1Wpb
      case(297)
         factor=1d0/nc**2*facV              ! db d -> ub d nu lp      D0g1Wpb
      case(298)
         factor=1d0/nc**2*facV              ! db db -> ub db nu lp     D0g1Wpb
      case(299)
         factor=1d0/nc**2*facV              ! d db -> ub d nu lp      D0g1Wpb
      case(300)
         factor=1d0/nc**2*facV              ! d g subtraction         D0g1Wpb
      case(301)
         factor=1d0/nc**2*facV              ! db g subtraction        D0g1Wpb
      case(302)
         factor=1d0/nc**2*facV              ! g d subtraction         D0g1Wpb
      case(303)
         factor=1d0/nc**2*facV              ! g db subtraction        D0g1Wpb
      case(304)
         factor=1d0/nc**2*facV              ! g ub subtraction        D0g1Wpb
      case(305)
         factor=1d0/nc**2*facV              ! ub g subtraction        D0g1Wpb
      case(306)
         factor=1d0/nc**4*facV              ! u ub -> ub d nu lp      Dt0g1Wpa
      case(307)
         factor=1d0/nc**4*facV              ! u u -> u d nu lp        Dt0g1Wpa
      case(308)
         factor=1d0/nc**4*facV              ! u db -> u ub nu lp      Dt0g1Wpa
      case(309)
         factor=1d0/nc**4*facV              ! ub u -> ub d nu lp      Dt0g1Wpa
      case(310)
         factor=1d0/nc**4*facV              ! db u -> u ub nu lp      Dt0g1Wpa
      case(311)
         factor=1d0/nc**4*1d0/2d0*facV      ! ub db -> ub ub nu lp     Dt0g1Wpa
      case(312)
         factor=1d0/nc**4*1d0/2d0*facV      ! db ub -> ub ub nu lp     Dt0g1Wpa
      case(313)
         factor=1d0/nc**4*facV              ! d g subtraction         Dt0g1Wpa
      case(314)
         factor=1d0/nc**4*facV              ! g d subtraction         Dt0g1Wpa
      case(315)
         factor=1d0/nc**4*facV              ! g u subtraction         Dt0g1Wpa
      case(316)
         factor=1d0/nc**4*facV              ! g ub subtraction        Dt0g1Wpa
      case(317)
         factor=1d0/nc**4*facV              ! u g subtraction         Dt0g1Wpa
      case(318)
         factor=1d0/nc**4*facV              ! ub g subtraction        Dt0g1Wpa
      case(319)
         factor=1d0/nc**4*facV              ! u db -> db d nu lp      Dt0g1Wpb
      case(320)
         factor=1d0/nc**4*1d0/2d0*facV      ! u d -> d d nu lp        Dt0g1Wpb
      case(321)
         factor=1d0/nc**4*facV              ! db u -> db d nu lp      Dt0g1Wpb
      case(322)
         factor=1d0/nc**4*1d0/2d0*facV      ! d u -> d d nu lp        Dt0g1Wpb
      case(323)
         factor=1d0/nc**4*facV              ! db d -> ub d nu lp      Dt0g1Wpb
      case(324)
         factor=1d0/nc**4*facV              ! db db -> ub db nu lp     Dt0g1Wpb
      case(325)
         factor=1d0/nc**4*facV              ! d db -> ub d nu lp      Dt0g1Wpb
      case(326)
         factor=1d0/nc**4*facV              ! d g subtraction         Dt0g1Wpb
      case(327)
         factor=1d0/nc**4*facV              ! db g subtraction        Dt0g1Wpb
      case(328)
         factor=1d0/nc**4*facV              ! g d subtraction         Dt0g1Wpb
      case(329)
         factor=1d0/nc**4*facV              ! g db subtraction        Dt0g1Wpb
      case(330)
         factor=1d0/nc**4*facV              ! g ub subtraction        Dt0g1Wpb
      case(331)
         factor=1d0/nc**4*facV              ! ub g subtraction        Dt0g1Wpb
      case(332)
         factor=1d0/nc**3*nf*facV           ! u ub -> ub d nu lp      Dh0g1Wpa
      case(333)
         factor=1d0/nc**3*nf*facV           ! u u -> u d nu lp        Dh0g1Wpa
      case(334)
         factor=1d0/nc**3*nf*facV           ! u db -> u ub nu lp      Dh0g1Wpa
      case(335)
         factor=1d0/nc**3*nf*facV           ! ub u -> ub d nu lp      Dh0g1Wpa
      case(336)
         factor=1d0/nc**3*nf*facV           ! db u -> u ub nu lp      Dh0g1Wpa
      case(337)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! ub db -> ub ub nu lp     Dh0g1Wpa
      case(338)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! db ub -> ub ub nu lp     Dh0g1Wpa
      case(339)
         factor=1d0/nc**3*nf*facV           ! d g subtraction         Dh0g1Wpa
      case(340)
         factor=1d0/nc**3*nf*facV           ! g d subtraction         Dh0g1Wpa
      case(341)
         factor=1d0/nc**3*nf*facV           ! g u subtraction         Dh0g1Wpa
      case(342)
         factor=1d0/nc**3*nf*facV           ! g ub subtraction        Dh0g1Wpa
      case(343)
         factor=1d0/nc**3*nf*facV           ! u g subtraction         Dh0g1Wpa
      case(344)
         factor=1d0/nc**3*nf*facV           ! ub g subtraction        Dh0g1Wpa
      case(345)
         factor=1d0/nc**3*nf*facV           ! u db -> db d nu lp      Dh0g1Wpb
      case(346)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! u d -> d d nu lp        Dh0g1Wpb
      case(347)
         factor=1d0/nc**3*nf*facV           ! db u -> db d nu lp      Dh0g1Wpb
      case(348)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! d u -> d d nu lp        Dh0g1Wpb
      case(349)
         factor=1d0/nc**3*nf*facV           ! db d -> ub d nu lp      Dh0g1Wpb
      case(350)
         factor=1d0/nc**3*nf*facV           ! db db -> ub db nu lp     Dh0g1Wpb
      case(351)
         factor=1d0/nc**3*nf*facV           ! d db -> ub d nu lp      Dh0g1Wpb
      case(352)
         factor=1d0/nc**3*nf*facV           ! d g subtraction         Dh0g1Wpb
      case(353)
         factor=1d0/nc**3*nf*facV           ! db g subtraction        Dh0g1Wpb
      case(354)
         factor=1d0/nc**3*nf*facV           ! g d subtraction         Dh0g1Wpb
      case(355)
         factor=1d0/nc**3*nf*facV           ! g db subtraction        Dh0g1Wpb
      case(356)
         factor=1d0/nc**3*nf*facV           ! g ub subtraction        Dh0g1Wpb
      case(357)
         factor=1d0/nc**3*nf*facV           ! ub g subtraction        Dh0g1Wpb

c -- double real


c -- real virtual


c -- double virtual

      end select
      factor=relfactor*factor

      return
      end
