      subroutine getlumiWpJJJ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    8,   15,   22,   42,   62,   75,   88,          
     &          101)
!       [20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,    9,   16,   25,   45,   65,   76,   91,          
     &          102)
!       [20, -40]
          if ( .not. ckmflag ) then
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
          else
          partons(1:nInp_scl) =                                         
     &         CKM(2,1)*f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)              
     &       + CKM(2,3)*f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)              
     &       + CKM(4,1)*f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)              
     &       + CKM(4,3)*f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)
          end if

        case (    3,   10,   17,   26,   46,   66,   78,   92,          
     &          104)
!       [0, 20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (    4,   11,   18,   29,   49,   68,   79,   94,          
     &          105)
!       [-40, 20]
          if ( .not. ckmflag ) then
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
          else
          partons(1:nInp_scl) =                                         
     &         CKM(1,2)*f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)              
     &       + CKM(1,4)*f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)              
     &       + CKM(3,2)*f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)              
     &       + CKM(3,4)*f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)
          end if

        case (    5,   12,   19)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    6,   13,   20,   32,   52,   70,   81,   96,          
     &          107)
!       [0, -40]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case (    7,   14,   21,   35,   55,   72,   83,   98,          
     &          109)
!       [-40, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   23,   43)
!       [21, -31]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   24,   44)
!       [21, 31]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   27,   47)
!       [-31, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   28,   48)
!       [31, 21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   30,   50)
!       [0, -30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   31,   51)
!       [0, 30]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   33,   53)
!       [-30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   34,   54)
!       [30, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   36,   56)
!       [-30, 30]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   37,   57)
!       [-31, -41]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   38,   58)
!       [30, -30]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   39,   59)
!       [-41, -31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   40,   60)
!       [31, -41]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case (   41,   61)
!       [-41, 31]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   63,   89)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   64,   90)
!       [20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   67,   93)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   69,   95)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   71,   97)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   73,   99)
!       [-20, -40]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   74,  100)
!       [-40, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   77,  103)
!       [20, 40]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (   80,  106)
!       [40, 20]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   82,  108)
!       [0, 40]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        

        case (   84,  110)
!       [40, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   85,  111)
!       [-40, 40]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       

        case (   86,  112)
!       [-40, -40]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      

        case (   87,  113)
!       [40, -40]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       

        case default
          print*, "getlumiWpJJJ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiWpJJJ



      function getlumiidWpJJJ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    8,   15,   22,   42,   62,   75,   88,
     &          101)
          id  = 1
          ip1 = 20
          ip2 = 0

        case (    2,    9,   16,   25,   45,   65,   76,   91,
     &          102)
          id  = 2
          ip1 = 20
          ip2 = -40

        case (    3,   10,   17,   26,   46,   66,   78,   92,
     &          104)
          id  = 3
          ip1 = 0
          ip2 = 20

        case (    4,   11,   18,   29,   49,   68,   79,   94,
     &          105)
          id  = 4
          ip1 = -40
          ip2 = 20

        case (    5,   12,   19)
          id  = 5
          ip1 = 0
          ip2 = 0

        case (    6,   13,   20,   32,   52,   70,   81,   96,
     &          107)
          id  = 6
          ip1 = 0
          ip2 = -40

        case (    7,   14,   21,   35,   55,   72,   83,   98,
     &          109)
          id  = 7
          ip1 = -40
          ip2 = 0

        case (   23,   43)
          id  = 8
          ip1 = 21
          ip2 = -31

        case (   24,   44)
          id  = 9
          ip1 = 21
          ip2 = 31

        case (   27,   47)
          id  = 10
          ip1 = -31
          ip2 = 21

        case (   28,   48)
          id  = 11
          ip1 = 31
          ip2 = 21

        case (   30,   50)
          id  = 12
          ip1 = 0
          ip2 = -30

        case (   31,   51)
          id  = 13
          ip1 = 0
          ip2 = 30

        case (   33,   53)
          id  = 14
          ip1 = -30
          ip2 = 0

        case (   34,   54)
          id  = 15
          ip1 = 30
          ip2 = 0

        case (   36,   56)
          id  = 16
          ip1 = -30
          ip2 = 30

        case (   37,   57)
          id  = 17
          ip1 = -31
          ip2 = -41

        case (   38,   58)
          id  = 18
          ip1 = 30
          ip2 = -30

        case (   39,   59)
          id  = 19
          ip1 = -41
          ip2 = -31

        case (   40,   60)
          id  = 20
          ip1 = 31
          ip2 = -41

        case (   41,   61)
          id  = 21
          ip1 = -41
          ip2 = 31

        case (   63,   89)
          id  = 22
          ip1 = 20
          ip2 = -20

        case (   64,   90)
          id  = 23
          ip1 = 20
          ip2 = 20

        case (   67,   93)
          id  = 24
          ip1 = -20
          ip2 = 20

        case (   69,   95)
          id  = 25
          ip1 = 0
          ip2 = -20

        case (   71,   97)
          id  = 26
          ip1 = -20
          ip2 = 0

        case (   73,   99)
          id  = 27
          ip1 = -20
          ip2 = -40

        case (   74,  100)
          id  = 28
          ip1 = -40
          ip2 = -20

        case (   77,  103)
          id  = 29
          ip1 = 20
          ip2 = 40

        case (   80,  106)
          id  = 30
          ip1 = 40
          ip2 = 20

        case (   82,  108)
          id  = 31
          ip1 = 0
          ip2 = 40

        case (   84,  110)
          id  = 32
          ip1 = 40
          ip2 = 0

        case (   85,  111)
          id  = 33
          ip1 = -40
          ip2 = 40

        case (   86,  112)
          id  = 34
          ip1 = -40
          ip2 = -40

        case (   87,  113)
          id  = 35
          ip1 = 40
          ip2 = -40

        case default
          print*, "getlumiidWpJJJ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidWpJJJ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiWpJJJ()
        use PineAPPL_mod
        use CKM_mod
!       [20, 0]
        call register_lumi_pine(
     &         [    1,    8,   15,   22,   42,   62,   75,   88,
     &            101],
     &         2,
     &         [    2,   21,    4,   21],
     &         [  1d0,  1d0]
     &       )

!       [20, -40]
        if ( .not. ckmflag ) then
        call register_lumi_pine(
     &         [    2,    9,   16,   25,   45,   65,   76,   91,
     &            102],
     &         2,
     &         [    2,   -1,    4,   -3],
     &         [  1d0,  1d0]
     &       )
        else
        call register_lumi_pine(
     &         [    2,    9,   16,   25,   45,   65,   76,   91,
     &            102],
     &         4,
     &         [    2,   -1,    2,   -3,    4,   -1,    4,   -3],
     &         [ CKM(2,1), CKM(2,3), CKM(4,1), CKM(4,3)]
     &       )
        end if

!       [0, 20]
        call register_lumi_pine(
     &         [    3,   10,   17,   26,   46,   66,   78,   92,
     &            104],
     &         2,
     &         [   21,    2,   21,    4],
     &         [  1d0,  1d0]
     &       )

!       [-40, 20]
        if ( .not. ckmflag ) then
        call register_lumi_pine(
     &         [    4,   11,   18,   29,   49,   68,   79,   94,
     &            105],
     &         2,
     &         [   -1,    2,   -3,    4],
     &         [  1d0,  1d0]
     &       )
        else
        call register_lumi_pine(
     &         [    4,   11,   18,   29,   49,   68,   79,   94,
     &            105],
     &         4,
     &         [   -1,    2,   -1,    4,   -3,    2,   -3,    4],
     &         [ CKM(1,2), CKM(1,4), CKM(3,2), CKM(3,4)]
     &       )
        end if

!       [0, 0]
        call register_lumi_pine(
     &         [    5,   12,   19],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [0, -40]
        call register_lumi_pine(
     &         [    6,   13,   20,   32,   52,   70,   81,   96,
     &            107],
     &         2,
     &         [   21,   -1,   21,   -3],
     &         [  1d0,  1d0]
     &       )

!       [-40, 0]
        call register_lumi_pine(
     &         [    7,   14,   21,   35,   55,   72,   83,   98,
     &            109],
     &         2,
     &         [   -1,   21,   -3,   21],
     &         [  1d0,  1d0]
     &       )

!       [21, -31]
        call register_lumi_pine(
     &         [   23,   43],
     &         10,
     &         [    2,   -1,    2,   -2,    2,   -3,    2,   -4,
     &              2,   -5,    4,   -1,    4,   -2,    4,   -3,
     &              4,   -4,    4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [21, 31]
        call register_lumi_pine(
     &         [   24,   44],
     &         10,
     &         [    2,    1,    2,    2,    2,    3,    2,    4,
     &              2,    5,    4,    1,    4,    2,    4,    3,
     &              4,    4,    4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-31, 21]
        call register_lumi_pine(
     &         [   27,   47],
     &         10,
     &         [   -1,    2,   -1,    4,   -2,    2,   -2,    4,
     &             -3,    2,   -3,    4,   -4,    2,   -4,    4,
     &             -5,    2,   -5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [31, 21]
        call register_lumi_pine(
     &         [   28,   48],
     &         10,
     &         [    1,    2,    1,    4,    2,    2,    2,    4,
     &              3,    2,    3,    4,    4,    2,    4,    4,
     &              5,    2,    5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [0, -30]
        call register_lumi_pine(
     &         [   30,   50],
     &         5,
     &         [   21,   -1,   21,   -2,   21,   -3,   21,   -4,
     &             21,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [0, 30]
        call register_lumi_pine(
     &         [   31,   51],
     &         5,
     &         [   21,    1,   21,    2,   21,    3,   21,    4,
     &             21,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 0]
        call register_lumi_pine(
     &         [   33,   53],
     &         5,
     &         [   -1,   21,   -2,   21,   -3,   21,   -4,   21,
     &             -5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [30, 0]
        call register_lumi_pine(
     &         [   34,   54],
     &         5,
     &         [    1,   21,    2,   21,    3,   21,    4,   21,
     &              5,   21],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-30, 30]
        call register_lumi_pine(
     &         [   36,   56],
     &         5,
     &         [   -1,    1,   -2,    2,   -3,    3,   -4,    4,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-31, -41]
        call register_lumi_pine(
     &         [   37,   57],
     &         10,
     &         [   -1,   -1,   -1,   -3,   -2,   -1,   -2,   -3,
     &             -3,   -1,   -3,   -3,   -4,   -1,   -4,   -3,
     &             -5,   -1,   -5,   -3],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [30, -30]
        call register_lumi_pine(
     &         [   38,   58],
     &         5,
     &         [    1,   -1,    2,   -2,    3,   -3,    4,   -4,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-41, -31]
        call register_lumi_pine(
     &         [   39,   59],
     &         10,
     &         [   -1,   -1,   -1,   -2,   -1,   -3,   -1,   -4,
     &             -1,   -5,   -3,   -1,   -3,   -2,   -3,   -3,
     &             -3,   -4,   -3,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [31, -41]
        call register_lumi_pine(
     &         [   40,   60],
     &         10,
     &         [    1,   -1,    1,   -3,    2,   -1,    2,   -3,
     &              3,   -1,    3,   -3,    4,   -1,    4,   -3,
     &              5,   -1,    5,   -3],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [-41, 31]
        call register_lumi_pine(
     &         [   41,   61],
     &         10,
     &         [   -1,    1,   -1,    2,   -1,    3,   -1,    4,
     &             -1,    5,   -3,    1,   -3,    2,   -3,    3,
     &             -3,    4,   -3,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [   63,   89],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [20, 20]
        call register_lumi_pine(
     &         [   64,   90],
     &         2,
     &         [    2,    2,    4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [   67,   93],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [   69,   95],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [   71,   97],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [-20, -40]
        call register_lumi_pine(
     &         [   73,   99],
     &         2,
     &         [   -2,   -1,   -4,   -3],
     &         [  1d0,  1d0]
     &       )

!       [-40, -20]
        call register_lumi_pine(
     &         [   74,  100],
     &         2,
     &         [   -1,   -2,   -3,   -4],
     &         [  1d0,  1d0]
     &       )

!       [20, 40]
        call register_lumi_pine(
     &         [   77,  103],
     &         2,
     &         [    2,    1,    4,    3],
     &         [  1d0,  1d0]
     &       )

!       [40, 20]
        call register_lumi_pine(
     &         [   80,  106],
     &         2,
     &         [    1,    2,    3,    4],
     &         [  1d0,  1d0]
     &       )

!       [0, 40]
        call register_lumi_pine(
     &         [   82,  108],
     &         2,
     &         [   21,    1,   21,    3],
     &         [  1d0,  1d0]
     &       )

!       [40, 0]
        call register_lumi_pine(
     &         [   84,  110],
     &         2,
     &         [    1,   21,    3,   21],
     &         [  1d0,  1d0]
     &       )

!       [-40, 40]
        call register_lumi_pine(
     &         [   85,  111],
     &         2,
     &         [   -1,    1,   -3,    3],
     &         [  1d0,  1d0]
     &       )

!       [-40, -40]
        call register_lumi_pine(
     &         [   86,  112],
     &         2,
     &         [   -1,   -1,   -3,   -3],
     &         [  1d0,  1d0]
     &       )

!       [40, -40]
        call register_lumi_pine(
     &         [   87,  113],
     &         2,
     &         [    1,   -1,    3,   -3],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiWpJJJ


#endif


