      subroutine getqcdnormWmJJJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      real(8) :: fac_ckm
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtWmJJJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVWmJJJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourWmJJJ(current_chan)
         do isub = 1, nflavourWmJJJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_WmJJJ(current_chan, isub, ipass_sub, flav_block, fac_ckm)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           partons_sub = fac_ckm*partons_sub
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=WmJJJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param()/stw)**2*(nc**2-1)*(nc*(4d0*pi*alphas_scl))**2
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=1d0/2d0*facB                ! d g -> g g u lm nub     sB3g0W
      case(2)
         factor=1d0/6d0*facB                ! d ub -> g g g lm nub     sB3g0W
      case(3)
         factor=1d0/2d0*facB                ! g d -> g g u lm nub     sB3g0W
      case(4)
         factor=1d0/6d0*facB                ! ub d -> g g g lm nub     sB3g0W
      case(5)
         factor=nup*facB                    ! g g -> db g u lm nub     sB3g0W
      case(6)
         factor=1d0/2d0*facB                ! g ub -> db g g lm nub     sB3g0W
      case(7)
         factor=1d0/2d0*facB                ! ub g -> db g g lm nub     sB3g0W
      case(8)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d g -> g g u lm nub     sBt3g0W
      case(9)
         factor=-1d0/nc**2*1d0/6d0*facB     ! d ub -> g g g lm nub     sBt3g0W
      case(10)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g d -> g g u lm nub     sBt3g0W
      case(11)
         factor=-1d0/nc**2*1d0/6d0*facB     ! ub d -> g g g lm nub     sBt3g0W
      case(12)
         factor=-1d0/nc**2*nup*facB         ! g g -> db g u lm nub     sBt3g0W
      case(13)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g ub -> db g g lm nub     sBt3g0W
      case(14)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub g -> db g g lm nub     sBt3g0W
      case(15)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! d gt -> gt gt u lm nub     sBtt3g0W
      case(16)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facB   ! d ub -> gt gt gt lm nub     sBtt3g0W
      case(17)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! gt d -> gt gt u lm nub     sBtt3g0W
      case(18)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facB   ! ub d -> gt gt gt lm nub     sBtt3g0W
      case(19)
         factor=(nc**2+1d0)/nc**4*nup*facB   ! gt gt -> db gt u lm nub     sBtt3g0W
      case(20)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! gt ub -> db gt gt lm nub     sBtt3g0W
      case(21)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! ub gt -> db gt gt lm nub     sBtt3g0W
      case(22)
         factor=1d0/nc*nf*facB              ! d g -> Q Qb u lm nub     sC1g0W
      case(23)
         factor=1d0/nc*facB                 ! d Qb -> g Qb u lm nub     sC1g0W
      case(24)
         factor=1d0/nc*facB                 ! d Q -> g Q u lm nub     sC1g0W
      case(25)
         factor=1d0/nc*nf*facB              ! d ub -> g Q Qb lm nub     sC1g0W
      case(26)
         factor=1d0/nc*nf*facB              ! g d -> Q Qb u lm nub     sC1g0W
      case(27)
         factor=1d0/nc*facB                 ! Qb d -> g Qb u lm nub     sC1g0W
      case(28)
         factor=1d0/nc*facB                 ! Q d -> g Q u lm nub     sC1g0W
      case(29)
         factor=1d0/nc*nf*facB              ! ub d -> g Q Qb lm nub     sC1g0W
      case(30)
         factor=1d0/nc*nup*facB             ! g Qb -> db Qb u lm nub     sC1g0W
      case(31)
         factor=1d0/nc*nup*facB             ! g Q -> db Q u lm nub     sC1g0W
      case(32)
         factor=1d0/nc*nf*facB              ! g ub -> db Q Qb lm nub     sC1g0W
      case(33)
         factor=1d0/nc*nup*facB             ! Qb g -> db Qb u lm nub     sC1g0W
      case(34)
         factor=1d0/nc*nup*facB             ! Q g -> db Q u lm nub     sC1g0W
      case(35)
         factor=1d0/nc*nf*facB              ! ub g -> db Q Qb lm nub     sC1g0W
      case(36)
         factor=1d0/nc*nup*facB             ! Qb Q -> db g u lm nub     sC1g0W
      case(37)
         factor=1d0/nc*facB                 ! Qb ub -> db g Qb lm nub     sC1g0W
      case(38)
         factor=1d0/nc*nup*facB             ! Q Qb -> db g u lm nub     sC1g0W
      case(39)
         factor=1d0/nc*facB                 ! ub Qb -> db g Qb lm nub     sC1g0W
      case(40)
         factor=1d0/nc*facB                 ! Q ub -> db g Q lm nub     sC1g0W
      case(41)
         factor=1d0/nc*facB                 ! ub Q -> db g Q lm nub     sC1g0W
      case(42)
         factor=1d0/nc**3*nf*facB           ! d g -> Q Qb u lm nub     sCt1g0W
      case(43)
         factor=1d0/nc**3*facB              ! d Qb -> g Qb u lm nub     sCt1g0W
      case(44)
         factor=1d0/nc**3*facB              ! d Q -> g Q u lm nub     sCt1g0W
      case(45)
         factor=1d0/nc**3*nf*facB           ! d ub -> g Q Qb lm nub     sCt1g0W
      case(46)
         factor=1d0/nc**3*nf*facB           ! g d -> Q Qb u lm nub     sCt1g0W
      case(47)
         factor=1d0/nc**3*facB              ! Qb d -> g Qb u lm nub     sCt1g0W
      case(48)
         factor=1d0/nc**3*facB              ! Q d -> g Q u lm nub     sCt1g0W
      case(49)
         factor=1d0/nc**3*nf*facB           ! ub d -> g Q Qb lm nub     sCt1g0W
      case(50)
         factor=1d0/nc**3*nup*facB          ! g Qb -> db Qb u lm nub     sCt1g0W
      case(51)
         factor=1d0/nc**3*nup*facB          ! g Q -> db Q u lm nub     sCt1g0W
      case(52)
         factor=1d0/nc**3*nf*facB           ! g ub -> db Q Qb lm nub     sCt1g0W
      case(53)
         factor=1d0/nc**3*nup*facB          ! Qb g -> db Qb u lm nub     sCt1g0W
      case(54)
         factor=1d0/nc**3*nup*facB          ! Q g -> db Q u lm nub     sCt1g0W
      case(55)
         factor=1d0/nc**3*nf*facB           ! ub g -> db Q Qb lm nub     sCt1g0W
      case(56)
         factor=1d0/nc**3*nup*facB          ! Qb Q -> db g u lm nub     sCt1g0W
      case(57)
         factor=1d0/nc**3*facB              ! Qb ub -> db g Qb lm nub     sCt1g0W
      case(58)
         factor=1d0/nc**3*nup*facB          ! Q Qb -> db g u lm nub     sCt1g0W
      case(59)
         factor=1d0/nc**3*facB              ! ub Qb -> db g Qb lm nub     sCt1g0W
      case(60)
         factor=1d0/nc**3*facB              ! Q ub -> db g Q lm nub     sCt1g0W
      case(61)
         factor=1d0/nc**3*facB              ! ub Q -> db g Q lm nub     sCt1g0W
      case(62)
         factor=-1d0/nc**2*facB             ! d g -> d db u lm nub     D1g0Wac
      case(63)
         factor=-1d0/nc**2*facB             ! d db -> g db u lm nub     D1g0Wac
      case(64)
         factor=-1d0/nc**2*facB             ! d d -> g d u lm nub     D1g0Wac
      case(65)
         factor=-1d0/nc**2*facB             ! d ub -> g d db lm nub     D1g0Wac
      case(66)
         factor=-1d0/nc**2*facB             ! g d -> d db u lm nub     D1g0Wac
      case(67)
         factor=-1d0/nc**2*facB             ! db d -> g db u lm nub     D1g0Wac
      case(68)
         factor=-1d0/nc**2*facB             ! ub d -> g d db lm nub     D1g0Wac
      case(69)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g db -> db db u lm nub     D1g0Wac
      case(70)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g ub -> db d db lm nub     D1g0Wac
      case(71)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db g -> db db u lm nub     D1g0Wac
      case(72)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub g -> db d db lm nub     D1g0Wac
      case(73)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db ub -> db g db lm nub     D1g0Wac
      case(74)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub db -> db g db lm nub     D1g0Wac
      case(75)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d g -> u ub u lm nub     D1g0Wbc
      case(76)
         factor=-1d0/nc**2*facB             ! d ub -> g ub u lm nub     D1g0Wbc
      case(77)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d u -> g u u lm nub     D1g0Wbc
      case(78)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g d -> u ub u lm nub     D1g0Wbc
      case(79)
         factor=-1d0/nc**2*facB             ! ub d -> g ub u lm nub     D1g0Wbc
      case(80)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u d -> g u u lm nub     D1g0Wbc
      case(81)
         factor=-1d0/nc**2*facB             ! g ub -> db ub u lm nub     D1g0Wbc
      case(82)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g u -> db u u lm nub     D1g0Wbc
      case(83)
         factor=-1d0/nc**2*facB             ! ub g -> db ub u lm nub     D1g0Wbc
      case(84)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u g -> db u u lm nub     D1g0Wbc
      case(85)
         factor=-1d0/nc**2*facB             ! ub u -> db g u lm nub     D1g0Wbc
      case(86)
         factor=-1d0/nc**2*facB             ! ub ub -> db g ub lm nub     D1g0Wbc
      case(87)
         factor=-1d0/nc**2*facB             ! u ub -> db g u lm nub     D1g0Wbc
      case(88)
         factor=1d0/nc**4*facB              ! d g -> d db u lm nub     Dt1g0Wa
      case(89)
         factor=1d0/nc**4*facB              ! d db -> g db u lm nub     Dt1g0Wa
      case(90)
         factor=1d0/nc**4*facB              ! d d -> g d u lm nub     Dt1g0Wa
      case(91)
         factor=1d0/nc**4*facB              ! d ub -> g d db lm nub     Dt1g0Wa
      case(92)
         factor=1d0/nc**4*facB              ! g d -> d db u lm nub     Dt1g0Wa
      case(93)
         factor=1d0/nc**4*facB              ! db d -> g db u lm nub     Dt1g0Wa
      case(94)
         factor=1d0/nc**4*facB              ! ub d -> g d db lm nub     Dt1g0Wa
      case(95)
         factor=1d0/nc**4*1d0/2d0*facB      ! g db -> db db u lm nub     Dt1g0Wa
      case(96)
         factor=1d0/nc**4*1d0/2d0*facB      ! g ub -> db d db lm nub     Dt1g0Wa
      case(97)
         factor=1d0/nc**4*1d0/2d0*facB      ! db g -> db db u lm nub     Dt1g0Wa
      case(98)
         factor=1d0/nc**4*1d0/2d0*facB      ! ub g -> db d db lm nub     Dt1g0Wa
      case(99)
         factor=1d0/nc**4*1d0/2d0*facB      ! db ub -> db g db lm nub     Dt1g0Wa
      case(100)
         factor=1d0/nc**4*1d0/2d0*facB      ! ub db -> db g db lm nub     Dt1g0Wa
      case(101)
         factor=1d0/nc**4*1d0/2d0*facB      ! d g -> u ub u lm nub     Dt1g0Wb
      case(102)
         factor=1d0/nc**4*facB              ! d ub -> g ub u lm nub     Dt1g0Wb
      case(103)
         factor=1d0/nc**4*1d0/2d0*facB      ! d u -> g u u lm nub     Dt1g0Wb
      case(104)
         factor=1d0/nc**4*1d0/2d0*facB      ! g d -> u ub u lm nub     Dt1g0Wb
      case(105)
         factor=1d0/nc**4*facB              ! ub d -> g ub u lm nub     Dt1g0Wb
      case(106)
         factor=1d0/nc**4*1d0/2d0*facB      ! u d -> g u u lm nub     Dt1g0Wb
      case(107)
         factor=1d0/nc**4*facB              ! g ub -> db ub u lm nub     Dt1g0Wb
      case(108)
         factor=1d0/nc**4*1d0/2d0*facB      ! g u -> db u u lm nub     Dt1g0Wb
      case(109)
         factor=1d0/nc**4*facB              ! ub g -> db ub u lm nub     Dt1g0Wb
      case(110)
         factor=1d0/nc**4*1d0/2d0*facB      ! u g -> db u u lm nub     Dt1g0Wb
      case(111)
         factor=1d0/nc**4*facB              ! ub u -> db g u lm nub     Dt1g0Wb
      case(112)
         factor=1d0/nc**4*facB              ! ub ub -> db g ub lm nub     Dt1g0Wb
      case(113)
         factor=1d0/nc**4*facB              ! u ub -> db g u lm nub     Dt1g0Wb

c -- real


c -- virtual


c -- double real


c -- real virtual


c -- double virtual

      end select
      factor=relfactor*factor

      return
      end
