      function sigBWmJJJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use CKM_mod, only : ckmflag  
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigBWmJJJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,7,ipass)
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(7, (/ 1, 2, 3, 4, 5, 6, 7 /) )
#endif 

c--- d g to g g u lm nub 
      if (qactive_chan(1).and.qselect_chan(1)) then
        current_chan = 1
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,2,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0W(1,2,3,4,5,6,7)
     .          +sB3g0W(1,2,4,3,5,6,7)
     .          +sB3g0W(1,3,2,4,5,6,7)
     .          +sB3g0W(1,3,4,2,5,6,7)
     .          +sB3g0W(1,4,2,3,5,6,7)
     .          +sB3g0W(1,4,3,2,5,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g g g lm nub 
      if (qactive_chan(2).and.qselect_chan(2)) then
        current_chan = 2
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0W(1,3,4,5,2,6,7)
     .          +sB3g0W(1,3,5,4,2,6,7)
     .          +sB3g0W(1,4,3,5,2,6,7)
     .          +sB3g0W(1,4,5,3,2,6,7)
     .          +sB3g0W(1,5,3,4,2,6,7)
     .          +sB3g0W(1,5,4,3,2,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g g u lm nub 
      if (qactive_chan(3).and.qselect_chan(3)) then
        current_chan = 3
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,1,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0W(2,1,3,4,5,6,7)
     .          +sB3g0W(2,1,4,3,5,6,7)
     .          +sB3g0W(2,3,1,4,5,6,7)
     .          +sB3g0W(2,3,4,1,5,6,7)
     .          +sB3g0W(2,4,1,3,5,6,7)
     .          +sB3g0W(2,4,3,1,5,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g g g lm nub 
      if (qactive_chan(4).and.qselect_chan(4)) then
        current_chan = 4
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0W(2,3,4,5,1,6,7)
     .          +sB3g0W(2,3,5,4,1,6,7)
     .          +sB3g0W(2,4,3,5,1,6,7)
     .          +sB3g0W(2,4,5,3,1,6,7)
     .          +sB3g0W(2,5,3,4,1,6,7)
     .          +sB3g0W(2,5,4,3,1,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db g u lm nub 
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0W(3,1,2,4,5,6,7)
     .          +sB3g0W(3,1,4,2,5,6,7)
     .          +sB3g0W(3,2,1,4,5,6,7)
     .          +sB3g0W(3,2,4,1,5,6,7)
     .          +sB3g0W(3,4,1,2,5,6,7)
     .          +sB3g0W(3,4,2,1,5,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db g g lm nub 
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0W(3,1,4,5,2,6,7)
     .          +sB3g0W(3,1,5,4,2,6,7)
     .          +sB3g0W(3,4,1,5,2,6,7)
     .          +sB3g0W(3,4,5,1,2,6,7)
     .          +sB3g0W(3,5,1,4,2,6,7)
     .          +sB3g0W(3,5,4,1,2,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db g g lm nub 
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sB3g0W(3,2,4,5,1,6,7)
     .          +sB3g0W(3,2,5,4,1,6,7)
     .          +sB3g0W(3,4,2,5,1,6,7)
     .          +sB3g0W(3,4,5,2,1,6,7)
     .          +sB3g0W(3,5,2,4,1,6,7)
     .          +sB3g0W(3,5,4,2,1,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to g g u lm nub 
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,2,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0W(1,2,3,4,5,6,7)
     .          +sBt3g0W(1,2,4,3,5,6,7)
     .          +sBt3g0W(1,3,2,4,5,6,7)
     .          +sBt3g0W(1,3,4,2,5,6,7)
     .          +sBt3g0W(1,4,2,3,5,6,7)
     .          +sBt3g0W(1,4,3,2,5,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g g g lm nub 
      if (qactive_chan(9).and.qselect_chan(9)) then
        current_chan = 9
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0W(1,3,4,5,2,6,7)
     .          +sBt3g0W(1,3,5,4,2,6,7)
     .          +sBt3g0W(1,4,3,5,2,6,7)
     .          +sBt3g0W(1,4,5,3,2,6,7)
     .          +sBt3g0W(1,5,3,4,2,6,7)
     .          +sBt3g0W(1,5,4,3,2,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g g u lm nub 
      if (qactive_chan(10).and.qselect_chan(10)) then
        current_chan = 10
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,1,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0W(2,1,3,4,5,6,7)
     .          +sBt3g0W(2,1,4,3,5,6,7)
     .          +sBt3g0W(2,3,1,4,5,6,7)
     .          +sBt3g0W(2,3,4,1,5,6,7)
     .          +sBt3g0W(2,4,1,3,5,6,7)
     .          +sBt3g0W(2,4,3,1,5,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g g g lm nub 
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0W(2,3,4,5,1,6,7)
     .          +sBt3g0W(2,3,5,4,1,6,7)
     .          +sBt3g0W(2,4,3,5,1,6,7)
     .          +sBt3g0W(2,4,5,3,1,6,7)
     .          +sBt3g0W(2,5,3,4,1,6,7)
     .          +sBt3g0W(2,5,4,3,1,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db g u lm nub 
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0W(3,1,2,4,5,6,7)
     .          +sBt3g0W(3,1,4,2,5,6,7)
     .          +sBt3g0W(3,2,1,4,5,6,7)
     .          +sBt3g0W(3,2,4,1,5,6,7)
     .          +sBt3g0W(3,4,1,2,5,6,7)
     .          +sBt3g0W(3,4,2,1,5,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db g g lm nub 
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0W(3,1,4,5,2,6,7)
     .          +sBt3g0W(3,1,5,4,2,6,7)
     .          +sBt3g0W(3,4,1,5,2,6,7)
     .          +sBt3g0W(3,4,5,1,2,6,7)
     .          +sBt3g0W(3,5,1,4,2,6,7)
     .          +sBt3g0W(3,5,4,1,2,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db g g lm nub 
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBt3g0W(3,2,4,5,1,6,7)
     .          +sBt3g0W(3,2,5,4,1,6,7)
     .          +sBt3g0W(3,4,2,5,1,6,7)
     .          +sBt3g0W(3,4,5,2,1,6,7)
     .          +sBt3g0W(3,5,2,4,1,6,7)
     .          +sBt3g0W(3,5,4,2,1,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt gt u lm nub 
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,2,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0W(1,2,3,4,5,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to gt gt gt lm nub 
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0W(1,3,4,5,2,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt gt u lm nub 
      if (qactive_chan(17).and.qselect_chan(17)) then
        current_chan = 17
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,1,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0W(2,1,3,4,5,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to gt gt gt lm nub 
      if (qactive_chan(18).and.qselect_chan(18)) then
        current_chan = 18
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0W(2,3,4,5,1,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db gt u lm nub 
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sBtt3g0W(3,1,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to db gt gt lm nub 
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0W(3,1,4,5,2,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to db gt gt lm nub 
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           sBtt3g0W(3,2,4,5,1,6,7) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to Q Qb u lm nub 
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,2,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(1,2,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Qb to g Qb u lm nub 
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = 41
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(1,3,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Q to g Q u lm nub 
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = 41
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(1,3,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g Q Qb lm nub 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(1,3,4,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to Q Qb u lm nub 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,1,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(2,1,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb d to g Qb u lm nub 
      if (qactive_chan(27).and.qselect_chan(27)) then
        current_chan = 27
        ip1_chan     = -31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(2,3,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q d to g Q u lm nub 
      if (qactive_chan(28).and.qselect_chan(28)) then
        current_chan = 28
        ip1_chan     = 31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(2,3,4,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g Q Qb lm nub 
      if (qactive_chan(29).and.qselect_chan(29)) then
        current_chan = 29
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(2,3,4,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g Qb to db Qb u lm nub 
      if (qactive_chan(30).and.qselect_chan(30)) then
        current_chan = 30
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,1,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g Q to db Q u lm nub 
      if (qactive_chan(31).and.qselect_chan(31)) then
        current_chan = 31
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,1,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db Q Qb lm nub 
      if (qactive_chan(32).and.qselect_chan(32)) then
        current_chan = 32
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,1,4,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb g to db Qb u lm nub 
      if (qactive_chan(33).and.qselect_chan(33)) then
        current_chan = 33
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,2,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q g to db Q u lm nub 
      if (qactive_chan(34).and.qselect_chan(34)) then
        current_chan = 34
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,2,4,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db Q Qb lm nub 
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,2,4,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb Q to db g u lm nub 
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,4,1,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb ub to db g Qb lm nub 
      if (qactive_chan(37).and.qselect_chan(37)) then
        current_chan = 37
        ip1_chan     = -31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,4,1,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q Qb to db g u lm nub 
      if (qactive_chan(38).and.qselect_chan(38)) then
        current_chan = 38
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,2,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,4,2,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Qb to db g Qb lm nub 
      if (qactive_chan(39).and.qselect_chan(39)) then
        current_chan = 39
        ip1_chan     = -21
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,2,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,4,2,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q ub to db g Q lm nub 
      if (qactive_chan(40).and.qselect_chan(40)) then
        current_chan = 40
        ip1_chan     = 31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,1,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,4,5,1,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Q to db g Q lm nub 
      if (qactive_chan(41).and.qselect_chan(41)) then
        current_chan = 41
        ip1_chan     = -21
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,2,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sC1g0W(3,4,5,2,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to Q Qb u lm nub 
      if (qactive_chan(42).and.qselect_chan(42)) then
        current_chan = 42
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,2,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(1,2,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Qb to g Qb u lm nub 
      if (qactive_chan(43).and.qselect_chan(43)) then
        current_chan = 43
        ip1_chan     = 41
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(1,3,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d Q to g Q u lm nub 
      if (qactive_chan(44).and.qselect_chan(44)) then
        current_chan = 44
        ip1_chan     = 41
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(1,3,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g Q Qb lm nub 
      if (qactive_chan(45).and.qselect_chan(45)) then
        current_chan = 45
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(1,3,4,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to Q Qb u lm nub 
      if (qactive_chan(46).and.qselect_chan(46)) then
        current_chan = 46
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,1,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(2,1,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb d to g Qb u lm nub 
      if (qactive_chan(47).and.qselect_chan(47)) then
        current_chan = 47
        ip1_chan     = -31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(2,3,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q d to g Q u lm nub 
      if (qactive_chan(48).and.qselect_chan(48)) then
        current_chan = 48
        ip1_chan     = 31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(2,3,4,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g Q Qb lm nub 
      if (qactive_chan(49).and.qselect_chan(49)) then
        current_chan = 49
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(2,3,4,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g Qb to db Qb u lm nub 
      if (qactive_chan(50).and.qselect_chan(50)) then
        current_chan = 50
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,1,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g Q to db Q u lm nub 
      if (qactive_chan(51).and.qselect_chan(51)) then
        current_chan = 51
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,1,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db Q Qb lm nub 
      if (qactive_chan(52).and.qselect_chan(52)) then
        current_chan = 52
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,1,4,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb g to db Qb u lm nub 
      if (qactive_chan(53).and.qselect_chan(53)) then
        current_chan = 53
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,2,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q g to db Q u lm nub 
      if (qactive_chan(54).and.qselect_chan(54)) then
        current_chan = 54
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,2,4,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db Q Qb lm nub 
      if (qactive_chan(55).and.qselect_chan(55)) then
        current_chan = 55
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,2,4,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb Q to db g u lm nub 
      if (qactive_chan(56).and.qselect_chan(56)) then
        current_chan = 56
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,4,1,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Qb ub to db g Qb lm nub 
      if (qactive_chan(57).and.qselect_chan(57)) then
        current_chan = 57
        ip1_chan     = -31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,4,1,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q Qb to db g u lm nub 
      if (qactive_chan(58).and.qselect_chan(58)) then
        current_chan = 58
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,2,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,4,2,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Qb to db g Qb lm nub 
      if (qactive_chan(59).and.qselect_chan(59)) then
        current_chan = 59
        ip1_chan     = -21
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,2,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,4,2,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- Q ub to db g Q lm nub 
      if (qactive_chan(60).and.qselect_chan(60)) then
        current_chan = 60
        ip1_chan     = 31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,1,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,4,5,1,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub Q to db g Q lm nub 
      if (qactive_chan(61).and.qselect_chan(61)) then
        current_chan = 61
        ip1_chan     = -21
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,2,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0W(3,4,5,2,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d db u lm nub 
      if (qactive_chan(62).and.qselect_chan(62)) then
        current_chan = 62
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,2,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(1,2,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g db u lm nub 
      if (qactive_chan(63).and.qselect_chan(63)) then
        current_chan = 63
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(1,3,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to g d u lm nub 
      if (qactive_chan(64).and.qselect_chan(64)) then
        current_chan = 64
        ip1_chan     = 40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(1,3,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g d db lm nub 
      if (qactive_chan(65).and.qselect_chan(65)) then
        current_chan = 65
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(1,3,4,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d db u lm nub 
      if (qactive_chan(66).and.qselect_chan(66)) then
        current_chan = 66
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,1,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(2,1,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g db u lm nub 
      if (qactive_chan(67).and.qselect_chan(67)) then
        current_chan = 67
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(2,3,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g d db lm nub 
      if (qactive_chan(68).and.qselect_chan(68)) then
        current_chan = 68
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(2,3,4,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db db u lm nub 
      if (qactive_chan(69).and.qselect_chan(69)) then
        current_chan = 69
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(3,1,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db d db lm nub 
      if (qactive_chan(70).and.qselect_chan(70)) then
        current_chan = 70
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(3,1,4,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db db u lm nub 
      if (qactive_chan(71).and.qselect_chan(71)) then
        current_chan = 71
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(3,2,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db d db lm nub 
      if (qactive_chan(72).and.qselect_chan(72)) then
        current_chan = 72
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(3,2,4,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db g db lm nub 
      if (qactive_chan(73).and.qselect_chan(73)) then
        current_chan = 73
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(3,4,1,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to db g db lm nub 
      if (qactive_chan(74).and.qselect_chan(74)) then
        current_chan = 74
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,2,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wac(3,4,2,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to u ub u lm nub 
      if (qactive_chan(75).and.qselect_chan(75)) then
        current_chan = 75
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,2,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(1,2,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g ub u lm nub 
      if (qactive_chan(76).and.qselect_chan(76)) then
        current_chan = 76
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(1,3,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to g u u lm nub 
      if (qactive_chan(77).and.qselect_chan(77)) then
        current_chan = 77
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(1,3,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u ub u lm nub 
      if (qactive_chan(78).and.qselect_chan(78)) then
        current_chan = 78
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,1,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(2,1,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g ub u lm nub 
      if (qactive_chan(79).and.qselect_chan(79)) then
        current_chan = 79
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(2,3,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to g u u lm nub 
      if (qactive_chan(80).and.qselect_chan(80)) then
        current_chan = 80
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(2,3,4,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db ub u lm nub 
      if (qactive_chan(81).and.qselect_chan(81)) then
        current_chan = 81
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(3,1,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to db u u lm nub 
      if (qactive_chan(82).and.qselect_chan(82)) then
        current_chan = 82
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(3,1,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db ub u lm nub 
      if (qactive_chan(83).and.qselect_chan(83)) then
        current_chan = 83
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(3,2,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to db u u lm nub 
      if (qactive_chan(84).and.qselect_chan(84)) then
        current_chan = 84
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(3,2,4,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to db g u lm nub 
      if (qactive_chan(85).and.qselect_chan(85)) then
        current_chan = 85
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(3,4,1,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to db g ub lm nub 
      if (qactive_chan(86).and.qselect_chan(86)) then
        current_chan = 86
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(3,4,1,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to db g u lm nub 
      if (qactive_chan(87).and.qselect_chan(87)) then
        current_chan = 87
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,2,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Wbc(3,4,2,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to d db u lm nub 
      if (qactive_chan(88).and.qselect_chan(88)) then
        current_chan = 88
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,2,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(1,2,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g db u lm nub 
      if (qactive_chan(89).and.qselect_chan(89)) then
        current_chan = 89
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(1,3,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to g d u lm nub 
      if (qactive_chan(90).and.qselect_chan(90)) then
        current_chan = 90
        ip1_chan     = 40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(1,3,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g d db lm nub 
      if (qactive_chan(91).and.qselect_chan(91)) then
        current_chan = 91
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(1,3,4,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to d db u lm nub 
      if (qactive_chan(92).and.qselect_chan(92)) then
        current_chan = 92
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,1,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(2,1,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g db u lm nub 
      if (qactive_chan(93).and.qselect_chan(93)) then
        current_chan = 93
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(2,3,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g d db lm nub 
      if (qactive_chan(94).and.qselect_chan(94)) then
        current_chan = 94
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(2,3,4,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db db u lm nub 
      if (qactive_chan(95).and.qselect_chan(95)) then
        current_chan = 95
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(3,1,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db d db lm nub 
      if (qactive_chan(96).and.qselect_chan(96)) then
        current_chan = 96
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(3,1,4,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db db u lm nub 
      if (qactive_chan(97).and.qselect_chan(97)) then
        current_chan = 97
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(3,2,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db d db lm nub 
      if (qactive_chan(98).and.qselect_chan(98)) then
        current_chan = 98
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(3,2,4,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db g db lm nub 
      if (qactive_chan(99).and.qselect_chan(99)) then
        current_chan = 99
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(3,4,1,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to db g db lm nub 
      if (qactive_chan(100).and.qselect_chan(100)) then
        current_chan = 100
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,2,5,1,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wa(3,4,2,5,1,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to u ub u lm nub 
      if (qactive_chan(101).and.qselect_chan(101)) then
        current_chan = 101
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,2,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(1,2,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to g ub u lm nub 
      if (qactive_chan(102).and.qselect_chan(102)) then
        current_chan = 102
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(1,3,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to g u u lm nub 
      if (qactive_chan(103).and.qselect_chan(103)) then
        current_chan = 103
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 1,3,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(1,3,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to u ub u lm nub 
      if (qactive_chan(104).and.qselect_chan(104)) then
        current_chan = 104
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,1,3,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(2,1,3,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to g ub u lm nub 
      if (qactive_chan(105).and.qselect_chan(105)) then
        current_chan = 105
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .true.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(2,3,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to g u u lm nub 
      if (qactive_chan(106).and.qselect_chan(106)) then
        current_chan = 106
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 2,3,4,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(2,3,4,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to db ub u lm nub 
      if (qactive_chan(107).and.qselect_chan(107)) then
        current_chan = 107
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,2,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(3,1,2,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to db u u lm nub 
      if (qactive_chan(108).and.qselect_chan(108)) then
        current_chan = 108
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,1,4,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(3,1,4,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to db ub u lm nub 
      if (qactive_chan(109).and.qselect_chan(109)) then
        current_chan = 109
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,1,4,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(3,2,1,4,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to db u u lm nub 
      if (qactive_chan(110).and.qselect_chan(110)) then
        current_chan = 110
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,2,4,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(3,2,4,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to db g u lm nub 
      if (qactive_chan(111).and.qselect_chan(111)) then
        current_chan = 111
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,2,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(3,4,1,2,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to db g ub lm nub 
      if (qactive_chan(112).and.qselect_chan(112)) then
        current_chan = 112
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,1,5,2,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(3,4,1,5,2,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to db g u lm nub 
      if (qactive_chan(113).and.qselect_chan(113)) then
        current_chan = 113
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ckmflag = .false.
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,2,1,5,6,7 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Wb(3,4,2,1,5,6,7)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigBWmJJJ=rnorm*wtsum

      return
      end
