      subroutine getlumiZ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    7,   17,   31,   45,   65,   66,   81,          
     &           91,  121,  151,  179,  213,  247)
!       [10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    2,    8,   18,   32,   46,   67,   68,   82,          
     &           92,  122,  152,  180,  214,  248)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (    3,   11,   19,   35,   49,   69,   70,   85,          
     &           95,  125,  155,  181,  215,  249)
!       [-10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    4,   12,   20,   36,   50,   71,   72,   86,          
     &           96,  126,  156,  182,  216,  250)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (    5,   25,   29,   43,   89,  119,  149,  197,          
     &          231,  265)
!       [10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    6,   26,   30,   44,   90,  120,  150,  198,          
     &          232,  266)
!       [20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    9,   21,   33,   47,   93,  123,  153,  185,          
     &          219,  253)
!       [0, 10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   10,   22,   34,   48,   94,  124,  154,  186,          
     &          220,  254)
!       [0, 20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   13,   23,   39,   53,   97,  127,  157,  187,          
     &          221,  255)
!       [0, -10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   14,   24,   40,   54,   98,  128,  158,  188,          
     &          222,  256)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   15,   27,   41,   55,   99,  129,  159,  209,          
     &          243,  277)
!       [-10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   16,   28,   42,   56,  100,  130,  160,  210,          
     &          244,  278)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   37,   38,   51,   52,  101,  102,  131,  132,          
     &          161,  162,  183,  184,  217,  218,  251,  252)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   57,  107,  137,  167,  193,  227,  261)
!       [11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   58,  108,  138,  168,  194,  228,  262)
!       [11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   59,  109,  139,  169,  195,  229,  263)
!       [21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   60,  110,  140,  170,  196,  230,  264)
!       [21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   61,  103,  133,  163,  189,  223,  257)
!       [11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   62,  104,  134,  164,  190,  224,  258)
!       [11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   63,  105,  135,  165,  191,  225,  259)
!       [21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   64,  106,  136,  166,  192,  226,  260)
!       [21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   73,  115,  145,  175,  205,  239,  273)
!       [-11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   74,  116,  146,  176,  206,  240,  274)
!       [-11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   75,  117,  147,  177,  207,  241,  275)
!       [-21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   76,  118,  148,  178,  208,  242,  276)
!       [-21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   77,  111,  141,  171,  201,  235,  269)
!       [-11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   78,  112,  142,  172,  202,  236,  270)
!       [-11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   79,  113,  143,  173,  203,  237,  271)
!       [-21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   80,  114,  144,  174,  204,  238,  272)
!       [-21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   83,  199,  233,  267)
!       [10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   84,  200,  234,  268)
!       [20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   87,  211,  245,  279)
!       [-10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   88,  212,  246,  280)
!       [-20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case default
          print*, "getlumiZ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiZ



      function getlumiidZ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    7,   17,   31,   45,   65,   66,   81,
     &           91,  121,  151,  179,  213,  247)
          id  = 1
          ip1 = 10
          ip2 = -10

        case (    2,    8,   18,   32,   46,   67,   68,   82,
     &           92,  122,  152,  180,  214,  248)
          id  = 2
          ip1 = 20
          ip2 = -20

        case (    3,   11,   19,   35,   49,   69,   70,   85,
     &           95,  125,  155,  181,  215,  249)
          id  = 3
          ip1 = -10
          ip2 = 10

        case (    4,   12,   20,   36,   50,   71,   72,   86,
     &           96,  126,  156,  182,  216,  250)
          id  = 4
          ip1 = -20
          ip2 = 20

        case (    5,   25,   29,   43,   89,  119,  149,  197,
     &          231,  265)
          id  = 5
          ip1 = 10
          ip2 = 0

        case (    6,   26,   30,   44,   90,  120,  150,  198,
     &          232,  266)
          id  = 6
          ip1 = 20
          ip2 = 0

        case (    9,   21,   33,   47,   93,  123,  153,  185,
     &          219,  253)
          id  = 7
          ip1 = 0
          ip2 = 10

        case (   10,   22,   34,   48,   94,  124,  154,  186,
     &          220,  254)
          id  = 8
          ip1 = 0
          ip2 = 20

        case (   13,   23,   39,   53,   97,  127,  157,  187,
     &          221,  255)
          id  = 9
          ip1 = 0
          ip2 = -10

        case (   14,   24,   40,   54,   98,  128,  158,  188,
     &          222,  256)
          id  = 10
          ip1 = 0
          ip2 = -20

        case (   15,   27,   41,   55,   99,  129,  159,  209,
     &          243,  277)
          id  = 11
          ip1 = -10
          ip2 = 0

        case (   16,   28,   42,   56,  100,  130,  160,  210,
     &          244,  278)
          id  = 12
          ip1 = -20
          ip2 = 0

        case (   37,   38,   51,   52,  101,  102,  131,  132,
     &          161,  162,  183,  184,  217,  218,  251,  252)
          id  = 13
          ip1 = 0
          ip2 = 0

        case (   57,  107,  137,  167,  193,  227,  261)
          id  = 14
          ip1 = 11
          ip2 = -11

        case (   58,  108,  138,  168,  194,  228,  262)
          id  = 15
          ip1 = 11
          ip2 = -21

        case (   59,  109,  139,  169,  195,  229,  263)
          id  = 16
          ip1 = 21
          ip2 = -11

        case (   60,  110,  140,  170,  196,  230,  264)
          id  = 17
          ip1 = 21
          ip2 = -21

        case (   61,  103,  133,  163,  189,  223,  257)
          id  = 18
          ip1 = 11
          ip2 = 11

        case (   62,  104,  134,  164,  190,  224,  258)
          id  = 19
          ip1 = 11
          ip2 = 21

        case (   63,  105,  135,  165,  191,  225,  259)
          id  = 20
          ip1 = 21
          ip2 = 11

        case (   64,  106,  136,  166,  192,  226,  260)
          id  = 21
          ip1 = 21
          ip2 = 21

        case (   73,  115,  145,  175,  205,  239,  273)
          id  = 22
          ip1 = -11
          ip2 = -11

        case (   74,  116,  146,  176,  206,  240,  274)
          id  = 23
          ip1 = -11
          ip2 = -21

        case (   75,  117,  147,  177,  207,  241,  275)
          id  = 24
          ip1 = -21
          ip2 = -11

        case (   76,  118,  148,  178,  208,  242,  276)
          id  = 25
          ip1 = -21
          ip2 = -21

        case (   77,  111,  141,  171,  201,  235,  269)
          id  = 26
          ip1 = -11
          ip2 = 11

        case (   78,  112,  142,  172,  202,  236,  270)
          id  = 27
          ip1 = -11
          ip2 = 21

        case (   79,  113,  143,  173,  203,  237,  271)
          id  = 28
          ip1 = -21
          ip2 = 11

        case (   80,  114,  144,  174,  204,  238,  272)
          id  = 29
          ip1 = -21
          ip2 = 21

        case (   83,  199,  233,  267)
          id  = 30
          ip1 = 10
          ip2 = 10

        case (   84,  200,  234,  268)
          id  = 31
          ip1 = 20
          ip2 = 20

        case (   87,  211,  245,  279)
          id  = 32
          ip1 = -10
          ip2 = -10

        case (   88,  212,  246,  280)
          id  = 33
          ip1 = -20
          ip2 = -20

        case default
          print*, "getlumiidZ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidZ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiZ()
        use PineAPPL_mod
        use CKM_mod
!       [10, -10]
        call register_lumi_pine(
     &         [    1,    7,   17,   31,   45,   65,   66,   81,
     &             91,  121,  151,  179,  213,  247],
     &         3,
     &         [    1,   -1,    3,   -3,    5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [    2,    8,   18,   32,   46,   67,   68,   82,
     &             92,  122,  152,  180,  214,  248],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 10]
        call register_lumi_pine(
     &         [    3,   11,   19,   35,   49,   69,   70,   85,
     &             95,  125,  155,  181,  215,  249],
     &         3,
     &         [   -1,    1,   -3,    3,   -5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [    4,   12,   20,   36,   50,   71,   72,   86,
     &             96,  126,  156,  182,  216,  250],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [10, 0]
        call register_lumi_pine(
     &         [    5,   25,   29,   43,   89,  119,  149,  197,
     &            231,  265],
     &         3,
     &         [    1,   21,    3,   21,    5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 0]
        call register_lumi_pine(
     &         [    6,   26,   30,   44,   90,  120,  150,  198,
     &            232,  266],
     &         2,
     &         [    2,   21,    4,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 10]
        call register_lumi_pine(
     &         [    9,   21,   33,   47,   93,  123,  153,  185,
     &            219,  253],
     &         3,
     &         [   21,    1,   21,    3,   21,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, 20]
        call register_lumi_pine(
     &         [   10,   22,   34,   48,   94,  124,  154,  186,
     &            220,  254],
     &         2,
     &         [   21,    2,   21,    4],
     &         [  1d0,  1d0]
     &       )

!       [0, -10]
        call register_lumi_pine(
     &         [   13,   23,   39,   53,   97,  127,  157,  187,
     &            221,  255],
     &         3,
     &         [   21,   -1,   21,   -3,   21,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [   14,   24,   40,   54,   98,  128,  158,  188,
     &            222,  256],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 0]
        call register_lumi_pine(
     &         [   15,   27,   41,   55,   99,  129,  159,  209,
     &            243,  277],
     &         3,
     &         [   -1,   21,   -3,   21,   -5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [   16,   28,   42,   56,  100,  130,  160,  210,
     &            244,  278],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 0]
        call register_lumi_pine(
     &         [   37,   38,   51,   52,  101,  102,  131,  132,
     &            161,  162,  183,  184,  217,  218,  251,  252],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [11, -11]
        call register_lumi_pine(
     &         [   57,  107,  137,  167,  193,  227,  261],
     &         9,
     &         [    1,   -1,    1,   -3,    1,   -5,    3,   -1,
     &              3,   -3,    3,   -5,    5,   -1,    5,   -3,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, -21]
        call register_lumi_pine(
     &         [   58,  108,  138,  168,  194,  228,  262],
     &         6,
     &         [    1,   -2,    1,   -4,    3,   -2,    3,   -4,
     &              5,   -2,    5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -11]
        call register_lumi_pine(
     &         [   59,  109,  139,  169,  195,  229,  263],
     &         6,
     &         [    2,   -1,    2,   -3,    2,   -5,    4,   -1,
     &              4,   -3,    4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -21]
        call register_lumi_pine(
     &         [   60,  110,  140,  170,  196,  230,  264],
     &         4,
     &         [    2,   -2,    2,   -4,    4,   -2,    4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [11, 11]
        call register_lumi_pine(
     &         [   61,  103,  133,  163,  189,  223,  257],
     &         9,
     &         [    1,    1,    1,    3,    1,    5,    3,    1,
     &              3,    3,    3,    5,    5,    1,    5,    3,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, 21]
        call register_lumi_pine(
     &         [   62,  104,  134,  164,  190,  224,  258],
     &         6,
     &         [    1,    2,    1,    4,    3,    2,    3,    4,
     &              5,    2,    5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 11]
        call register_lumi_pine(
     &         [   63,  105,  135,  165,  191,  225,  259],
     &         6,
     &         [    2,    1,    2,    3,    2,    5,    4,    1,
     &              4,    3,    4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 21]
        call register_lumi_pine(
     &         [   64,  106,  136,  166,  192,  226,  260],
     &         4,
     &         [    2,    2,    2,    4,    4,    2,    4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, -11]
        call register_lumi_pine(
     &         [   73,  115,  145,  175,  205,  239,  273],
     &         9,
     &         [   -1,   -1,   -1,   -3,   -1,   -5,   -3,   -1,
     &             -3,   -3,   -3,   -5,   -5,   -1,   -5,   -3,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, -21]
        call register_lumi_pine(
     &         [   74,  116,  146,  176,  206,  240,  274],
     &         6,
     &         [   -1,   -2,   -1,   -4,   -3,   -2,   -3,   -4,
     &             -5,   -2,   -5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -11]
        call register_lumi_pine(
     &         [   75,  117,  147,  177,  207,  241,  275],
     &         6,
     &         [   -2,   -1,   -2,   -3,   -2,   -5,   -4,   -1,
     &             -4,   -3,   -4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -21]
        call register_lumi_pine(
     &         [   76,  118,  148,  178,  208,  242,  276],
     &         4,
     &         [   -2,   -2,   -2,   -4,   -4,   -2,   -4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, 11]
        call register_lumi_pine(
     &         [   77,  111,  141,  171,  201,  235,  269],
     &         9,
     &         [   -1,    1,   -1,    3,   -1,    5,   -3,    1,
     &             -3,    3,   -3,    5,   -5,    1,   -5,    3,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, 21]
        call register_lumi_pine(
     &         [   78,  112,  142,  172,  202,  236,  270],
     &         6,
     &         [   -1,    2,   -1,    4,   -3,    2,   -3,    4,
     &             -5,    2,   -5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 11]
        call register_lumi_pine(
     &         [   79,  113,  143,  173,  203,  237,  271],
     &         6,
     &         [   -2,    1,   -2,    3,   -2,    5,   -4,    1,
     &             -4,    3,   -4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 21]
        call register_lumi_pine(
     &         [   80,  114,  144,  174,  204,  238,  272],
     &         4,
     &         [   -2,    2,   -2,    4,   -4,    2,   -4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [10, 10]
        call register_lumi_pine(
     &         [   83,  199,  233,  267],
     &         3,
     &         [    1,    1,    3,    3,    5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 20]
        call register_lumi_pine(
     &         [   84,  200,  234,  268],
     &         2,
     &         [    2,    2,    4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, -10]
        call register_lumi_pine(
     &         [   87,  211,  245,  279],
     &         3,
     &         [   -1,   -1,   -3,   -3,   -5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, -20]
        call register_lumi_pine(
     &         [   88,  212,  246,  280],
     &         2,
     &         [   -2,   -2,   -4,   -4],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiZ


#endif


