      subroutine getqcdnormZ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtZ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVZ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourZ(current_chan)
         do isub = 1, nflavourZ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_Z(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=Z "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alpha_param())**2*nc*4d0
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d db -> lp lm           B0g0Z
      case(2)
         factor=facB                        ! u ub -> lp lm           B0g0Z
      case(3)
         factor=facB                        ! db d -> lp lm           B0g0Z
      case(4)
         factor=facB                        ! ub u -> lp lm           B0g0Z

c -- real

      case(5)
         factor=(nc**2-1d0)/nc**2*facR      ! d g -> d lp lm          B1g0Z
      case(6)
         factor=(nc**2-1d0)/nc**2*facR      ! u g -> u lp lm          B1g0Z
      case(7)
         factor=(nc**2-1d0)/nc**2*facR      ! d db -> g lp lm         B1g0Z
      case(8)
         factor=(nc**2-1d0)/nc**2*facR      ! u ub -> g lp lm         B1g0Z
      case(9)
         factor=(nc**2-1d0)/nc**2*facR      ! g d -> d lp lm          B1g0Z
      case(10)
         factor=(nc**2-1d0)/nc**2*facR      ! g u -> u lp lm          B1g0Z
      case(11)
         factor=(nc**2-1d0)/nc**2*facR      ! db d -> g lp lm         B1g0Z
      case(12)
         factor=(nc**2-1d0)/nc**2*facR      ! ub u -> g lp lm         B1g0Z
      case(13)
         factor=(nc**2-1d0)/nc**2*facR      ! g db -> db lp lm        B1g0Z
      case(14)
         factor=(nc**2-1d0)/nc**2*facR      ! g ub -> ub lp lm        B1g0Z
      case(15)
         factor=(nc**2-1d0)/nc**2*facR      ! db g -> db lp lm        B1g0Z
      case(16)
         factor=(nc**2-1d0)/nc**2*facR      ! ub g -> ub lp lm        B1g0Z

c -- virtual

      case(17)
         factor=(nc**2-1d0)/nc**2*facV      ! d db -> lp lm           B0g1Z
      case(18)
         factor=(nc**2-1d0)/nc**2*facV      ! u ub -> lp lm           B0g1Z
      case(19)
         factor=(nc**2-1d0)/nc**2*facV      ! db d -> lp lm           B0g1Z
      case(20)
         factor=(nc**2-1d0)/nc**2*facV      ! ub u -> lp lm           B0g1Z
      case(21)
         factor=(nc**2-1d0)/nc**2*facV      ! g d subtraction         B0g1Z
      case(22)
         factor=(nc**2-1d0)/nc**2*facV      ! g u subtraction         B0g1Z
      case(23)
         factor=(nc**2-1d0)/nc**2*facV      ! g db subtraction        B0g1Z
      case(24)
         factor=(nc**2-1d0)/nc**2*facV      ! g ub subtraction        B0g1Z
      case(25)
         factor=(nc**2-1d0)/nc**2*facV      ! d g subtraction         B0g1Z
      case(26)
         factor=(nc**2-1d0)/nc**2*facV      ! u g subtraction         B0g1Z
      case(27)
         factor=(nc**2-1d0)/nc**2*facV      ! db g subtraction        B0g1Z
      case(28)
         factor=(nc**2-1d0)/nc**2*facV      ! ub g subtraction        B0g1Z

c -- double real

      case(29)
         factor=(nc**2-1d0)/nc**2*facRR     ! d g -> g d lp lm        B2g0Z
      case(30)
         factor=(nc**2-1d0)/nc**2*facRR     ! u g -> g u lp lm        B2g0Z
      case(31)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! d db -> g g lp lm       B2g0Z
      case(32)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! u ub -> g g lp lm       B2g0Z
      case(33)
         factor=(nc**2-1d0)/nc**2*facRR     ! g d -> g d lp lm        B2g0Z
      case(34)
         factor=(nc**2-1d0)/nc**2*facRR     ! g u -> g u lp lm        B2g0Z
      case(35)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! db d -> g g lp lm       B2g0Z
      case(36)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*facRR   ! ub u -> g g lp lm       B2g0Z
      case(37)
         factor=(nc**2-1d0)/nc**2*ndown*facRR   ! g g -> db d lp lm       B2g0Z
      case(38)
         factor=(nc**2-1d0)/nc**2*nup*facRR   ! g g -> ub u lp lm       B2g0Z
      case(39)
         factor=(nc**2-1d0)/nc**2*facRR     ! g db -> db g lp lm      B2g0Z
      case(40)
         factor=(nc**2-1d0)/nc**2*facRR     ! g ub -> ub g lp lm      B2g0Z
      case(41)
         factor=(nc**2-1d0)/nc**2*facRR     ! db g -> db g lp lm      B2g0Z
      case(42)
         factor=(nc**2-1d0)/nc**2*facRR     ! ub g -> ub g lp lm      B2g0Z
      case(43)
         factor=-(nc**2-1d0)/nc**4*facRR    ! d gt -> gt d lp lm      Bt2g0Z
      case(44)
         factor=-(nc**2-1d0)/nc**4*facRR    ! u gt -> gt u lp lm      Bt2g0Z
      case(45)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d db -> gt gt lp lm     Bt2g0Z
      case(46)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u ub -> gt gt lp lm     Bt2g0Z
      case(47)
         factor=-(nc**2-1d0)/nc**4*facRR    ! gt d -> gt d lp lm      Bt2g0Z
      case(48)
         factor=-(nc**2-1d0)/nc**4*facRR    ! gt u -> gt u lp lm      Bt2g0Z
      case(49)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db d -> gt gt lp lm     Bt2g0Z
      case(50)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub u -> gt gt lp lm     Bt2g0Z
      case(51)
         factor=-(nc**2-1d0)/nc**4*ndown*facRR   ! gt gt -> db d lp lm     Bt2g0Z
      case(52)
         factor=-(nc**2-1d0)/nc**4*nup*facRR   ! gt gt -> ub u lp lm     Bt2g0Z
      case(53)
         factor=-(nc**2-1d0)/nc**4*facRR    ! gt db -> db gt lp lm     Bt2g0Z
      case(54)
         factor=-(nc**2-1d0)/nc**4*facRR    ! gt ub -> ub gt lp lm     Bt2g0Z
      case(55)
         factor=-(nc**2-1d0)/nc**4*facRR    ! db gt -> db gt lp lm     Bt2g0Z
      case(56)
         factor=-(nc**2-1d0)/nc**4*facRR    ! ub gt -> ub gt lp lm     Bt2g0Z
      case(57)
         factor=(nc**2-1d0)/nc**3*facRR     ! d db -> db d lp lm      C0g0Z
      case(58)
         factor=(nc**2-1d0)/nc**3*facRR     ! d ub -> ub d lp lm      C0g0Z
      case(59)
         factor=(nc**2-1d0)/nc**3*facRR     ! u db -> db u lp lm      C0g0Z
      case(60)
         factor=(nc**2-1d0)/nc**3*facRR     ! u ub -> ub u lp lm      C0g0Z
      case(61)
         factor=(nc**2-1d0)/nc**3*facRR     ! d d -> d d lp lm        C0g0Z
      case(62)
         factor=(nc**2-1d0)/nc**3*facRR     ! d u -> u d lp lm        C0g0Z
      case(63)
         factor=(nc**2-1d0)/nc**3*facRR     ! u d -> d u lp lm        C0g0Z
      case(64)
         factor=(nc**2-1d0)/nc**3*facRR     ! u u -> u u lp lm        C0g0Z
      case(65)
         factor=(nc**2-1d0)/nc**3*ndown*facRR   ! d db -> d db lp lm      C0g0Z
      case(66)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! d db -> u ub lp lm      C0g0Z
      case(67)
         factor=(nc**2-1d0)/nc**3*ndown*facRR   ! u ub -> d db lp lm      C0g0Z
      case(68)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! u ub -> u ub lp lm      C0g0Z
      case(69)
         factor=(nc**2-1d0)/nc**3*ndown*facRR   ! db d -> d db lp lm      C0g0Z
      case(70)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! db d -> u ub lp lm      C0g0Z
      case(71)
         factor=(nc**2-1d0)/nc**3*ndown*facRR   ! ub u -> d db lp lm      C0g0Z
      case(72)
         factor=(nc**2-1d0)/nc**3*nup*facRR   ! ub u -> u ub lp lm      C0g0Z
      case(73)
         factor=(nc**2-1d0)/nc**3*facRR     ! db db -> db db lp lm     C0g0Z
      case(74)
         factor=(nc**2-1d0)/nc**3*facRR     ! db ub -> db ub lp lm     C0g0Z
      case(75)
         factor=(nc**2-1d0)/nc**3*facRR     ! ub db -> ub db lp lm     C0g0Z
      case(76)
         factor=(nc**2-1d0)/nc**3*facRR     ! ub ub -> ub ub lp lm     C0g0Z
      case(77)
         factor=(nc**2-1d0)/nc**3*facRR     ! db d -> db d lp lm      C0g0Z
      case(78)
         factor=(nc**2-1d0)/nc**3*facRR     ! db u -> db u lp lm      C0g0Z
      case(79)
         factor=(nc**2-1d0)/nc**3*facRR     ! ub d -> ub d lp lm      C0g0Z
      case(80)
         factor=(nc**2-1d0)/nc**3*facRR     ! ub u -> ub u lp lm      C0g0Z
      case(81)
         factor=-(nc**2-1d0)/nc**4*facRR    ! d db -> db d lp lm      D0g0Z
      case(82)
         factor=-(nc**2-1d0)/nc**4*facRR    ! u ub -> ub u lp lm      D0g0Z
      case(83)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! d d -> d d lp lm        D0g0Z
      case(84)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! u u -> u u lp lm        D0g0Z
      case(85)
         factor=-(nc**2-1d0)/nc**4*facRR    ! db d -> db d lp lm      D0g0Z
      case(86)
         factor=-(nc**2-1d0)/nc**4*facRR    ! ub u -> ub u lp lm      D0g0Z
      case(87)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! db db -> db db lp lm     D0g0Z
      case(88)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*facRR   ! ub ub -> ub ub lp lm     D0g0Z

c -- real virtual

      case(89)
         factor=(nc**2-1d0)/nc**2*facRV     ! d g -> d lp lm          B1g1Z
      case(90)
         factor=(nc**2-1d0)/nc**2*facRV     ! u g -> u lp lm          B1g1Z
      case(91)
         factor=(nc**2-1d0)/nc**2*facRV     ! d db -> g lp lm         B1g1Z
      case(92)
         factor=(nc**2-1d0)/nc**2*facRV     ! u ub -> g lp lm         B1g1Z
      case(93)
         factor=(nc**2-1d0)/nc**2*facRV     ! g d -> d lp lm          B1g1Z
      case(94)
         factor=(nc**2-1d0)/nc**2*facRV     ! g u -> u lp lm          B1g1Z
      case(95)
         factor=(nc**2-1d0)/nc**2*facRV     ! db d -> g lp lm         B1g1Z
      case(96)
         factor=(nc**2-1d0)/nc**2*facRV     ! ub u -> g lp lm         B1g1Z
      case(97)
         factor=(nc**2-1d0)/nc**2*facRV     ! g db -> db lp lm        B1g1Z
      case(98)
         factor=(nc**2-1d0)/nc**2*facRV     ! g ub -> ub lp lm        B1g1Z
      case(99)
         factor=(nc**2-1d0)/nc**2*facRV     ! db g -> db lp lm        B1g1Z
      case(100)
         factor=(nc**2-1d0)/nc**2*facRV     ! ub g -> ub lp lm        B1g1Z
      case(101)
         factor=(nc**2-1d0)/nc**2*ndown*facRV   ! g g subtraction         B1g1Z
      case(102)
         factor=(nc**2-1d0)/nc**2*nup*facRV   ! g g subtraction         B1g1Z
      case(103)
         factor=(nc**2-1d0)/nc**3*facRV     ! d d subtraction         B1g1Z
      case(104)
         factor=(nc**2-1d0)/nc**3*facRV     ! d u subtraction         B1g1Z
      case(105)
         factor=(nc**2-1d0)/nc**3*facRV     ! u d subtraction         B1g1Z
      case(106)
         factor=(nc**2-1d0)/nc**3*facRV     ! u u subtraction         B1g1Z
      case(107)
         factor=(nc**2-1d0)/nc**3*facRV     ! d db subtraction        B1g1Z
      case(108)
         factor=(nc**2-1d0)/nc**3*facRV     ! d ub subtraction        B1g1Z
      case(109)
         factor=(nc**2-1d0)/nc**3*facRV     ! u db subtraction        B1g1Z
      case(110)
         factor=(nc**2-1d0)/nc**3*facRV     ! u ub subtraction        B1g1Z
      case(111)
         factor=(nc**2-1d0)/nc**3*facRV     ! db d subtraction        B1g1Z
      case(112)
         factor=(nc**2-1d0)/nc**3*facRV     ! db u subtraction        B1g1Z
      case(113)
         factor=(nc**2-1d0)/nc**3*facRV     ! ub d subtraction        B1g1Z
      case(114)
         factor=(nc**2-1d0)/nc**3*facRV     ! ub u subtraction        B1g1Z
      case(115)
         factor=(nc**2-1d0)/nc**3*facRV     ! db db subtraction       B1g1Z
      case(116)
         factor=(nc**2-1d0)/nc**3*facRV     ! db ub subtraction       B1g1Z
      case(117)
         factor=(nc**2-1d0)/nc**3*facRV     ! ub db subtraction       B1g1Z
      case(118)
         factor=(nc**2-1d0)/nc**3*facRV     ! ub ub subtraction       B1g1Z
      case(119)
         factor=-(nc**2-1d0)/nc**4*facRV    ! d g -> d lp lm          Bt1g1Z
      case(120)
         factor=-(nc**2-1d0)/nc**4*facRV    ! u g -> u lp lm          Bt1g1Z
      case(121)
         factor=-(nc**2-1d0)/nc**4*facRV    ! d db -> g lp lm         Bt1g1Z
      case(122)
         factor=-(nc**2-1d0)/nc**4*facRV    ! u ub -> g lp lm         Bt1g1Z
      case(123)
         factor=-(nc**2-1d0)/nc**4*facRV    ! g d -> d lp lm          Bt1g1Z
      case(124)
         factor=-(nc**2-1d0)/nc**4*facRV    ! g u -> u lp lm          Bt1g1Z
      case(125)
         factor=-(nc**2-1d0)/nc**4*facRV    ! db d -> g lp lm         Bt1g1Z
      case(126)
         factor=-(nc**2-1d0)/nc**4*facRV    ! ub u -> g lp lm         Bt1g1Z
      case(127)
         factor=-(nc**2-1d0)/nc**4*facRV    ! g db -> db lp lm        Bt1g1Z
      case(128)
         factor=-(nc**2-1d0)/nc**4*facRV    ! g ub -> ub lp lm        Bt1g1Z
      case(129)
         factor=-(nc**2-1d0)/nc**4*facRV    ! db g -> db lp lm        Bt1g1Z
      case(130)
         factor=-(nc**2-1d0)/nc**4*facRV    ! ub g -> ub lp lm        Bt1g1Z
      case(131)
         factor=-(nc**2-1d0)/nc**4*ndown*facRV   ! g g subtraction         Bt1g1Z
      case(132)
         factor=-(nc**2-1d0)/nc**4*nup*facRV   ! g g subtraction         Bt1g1Z
      case(133)
         factor=-(nc**2-1d0)/nc**5*facRV    ! d d subtraction         Bt1g1Z
      case(134)
         factor=-(nc**2-1d0)/nc**5*facRV    ! d u subtraction         Bt1g1Z
      case(135)
         factor=-(nc**2-1d0)/nc**5*facRV    ! u d subtraction         Bt1g1Z
      case(136)
         factor=-(nc**2-1d0)/nc**5*facRV    ! u u subtraction         Bt1g1Z
      case(137)
         factor=-(nc**2-1d0)/nc**5*facRV    ! d db subtraction        Bt1g1Z
      case(138)
         factor=-(nc**2-1d0)/nc**5*facRV    ! d ub subtraction        Bt1g1Z
      case(139)
         factor=-(nc**2-1d0)/nc**5*facRV    ! u db subtraction        Bt1g1Z
      case(140)
         factor=-(nc**2-1d0)/nc**5*facRV    ! u ub subtraction        Bt1g1Z
      case(141)
         factor=-(nc**2-1d0)/nc**5*facRV    ! db d subtraction        Bt1g1Z
      case(142)
         factor=-(nc**2-1d0)/nc**5*facRV    ! db u subtraction        Bt1g1Z
      case(143)
         factor=-(nc**2-1d0)/nc**5*facRV    ! ub d subtraction        Bt1g1Z
      case(144)
         factor=-(nc**2-1d0)/nc**5*facRV    ! ub u subtraction        Bt1g1Z
      case(145)
         factor=-(nc**2-1d0)/nc**5*facRV    ! db db subtraction       Bt1g1Z
      case(146)
         factor=-(nc**2-1d0)/nc**5*facRV    ! db ub subtraction       Bt1g1Z
      case(147)
         factor=-(nc**2-1d0)/nc**5*facRV    ! ub db subtraction       Bt1g1Z
      case(148)
         factor=-(nc**2-1d0)/nc**5*facRV    ! ub ub subtraction       Bt1g1Z
      case(149)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! d g -> d lp lm          Bh1g1Z
      case(150)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! u g -> u lp lm          Bh1g1Z
      case(151)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! d db -> g lp lm         Bh1g1Z
      case(152)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! u ub -> g lp lm         Bh1g1Z
      case(153)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! g d -> d lp lm          Bh1g1Z
      case(154)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! g u -> u lp lm          Bh1g1Z
      case(155)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! db d -> g lp lm         Bh1g1Z
      case(156)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! ub u -> g lp lm         Bh1g1Z
      case(157)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! g db -> db lp lm        Bh1g1Z
      case(158)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! g ub -> ub lp lm        Bh1g1Z
      case(159)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! db g -> db lp lm        Bh1g1Z
      case(160)
         factor=(nc**2-1d0)/nc**3*nf*facRV   ! ub g -> ub lp lm        Bh1g1Z
      case(161)
         factor=(nc**2-1d0)/nc**3*ndown*nf*facRV   ! g g subtraction         Bh1g1Z
      case(162)
         factor=(nc**2-1d0)/nc**3*nf*nup*facRV   ! g g subtraction         Bh1g1Z
      case(163)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! d d subtraction         Bh1g1Z
      case(164)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! d u subtraction         Bh1g1Z
      case(165)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! u d subtraction         Bh1g1Z
      case(166)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! u u subtraction         Bh1g1Z
      case(167)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! d db subtraction        Bh1g1Z
      case(168)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! d ub subtraction        Bh1g1Z
      case(169)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! u db subtraction        Bh1g1Z
      case(170)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! u ub subtraction        Bh1g1Z
      case(171)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! db d subtraction        Bh1g1Z
      case(172)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! db u subtraction        Bh1g1Z
      case(173)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! ub d subtraction        Bh1g1Z
      case(174)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! ub u subtraction        Bh1g1Z
      case(175)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! db db subtraction       Bh1g1Z
      case(176)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! db ub subtraction       Bh1g1Z
      case(177)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! ub db subtraction       Bh1g1Z
      case(178)
         factor=(nc**2-1d0)/nc**4*nf*facRV   ! ub ub subtraction       Bh1g1Z

c -- double virtual

      case(179)
         factor=(nc**2-1d0)/nc**2*facVV     ! d db -> lp lm           B0g2Z
      case(180)
         factor=(nc**2-1d0)/nc**2*facVV     ! u ub -> lp lm           B0g2Z
      case(181)
         factor=(nc**2-1d0)/nc**2*facVV     ! db d -> lp lm           B0g2Z
      case(182)
         factor=(nc**2-1d0)/nc**2*facVV     ! ub u -> lp lm           B0g2Z
      case(183)
         factor=(nc**2-1d0)/nc**2*ndown*facVV   ! g g subtraction         B0g2Z
      case(184)
         factor=(nc**2-1d0)/nc**2*nup*facVV   ! g g subtraction         B0g2Z
      case(185)
         factor=(nc**2-1d0)/nc**2*facVV     ! g d subtraction         B0g2Z
      case(186)
         factor=(nc**2-1d0)/nc**2*facVV     ! g u subtraction         B0g2Z
      case(187)
         factor=(nc**2-1d0)/nc**2*facVV     ! g db subtraction        B0g2Z
      case(188)
         factor=(nc**2-1d0)/nc**2*facVV     ! g ub subtraction        B0g2Z
      case(189)
         factor=(nc**2-1d0)/nc**3*facVV     ! d d subtraction         B0g2Z
      case(190)
         factor=(nc**2-1d0)/nc**3*facVV     ! d u subtraction         B0g2Z
      case(191)
         factor=(nc**2-1d0)/nc**3*facVV     ! u d subtraction         B0g2Z
      case(192)
         factor=(nc**2-1d0)/nc**3*facVV     ! u u subtraction         B0g2Z
      case(193)
         factor=(nc**2-1d0)/nc**3*facVV     ! d db subtraction        B0g2Z
      case(194)
         factor=(nc**2-1d0)/nc**3*facVV     ! d ub subtraction        B0g2Z
      case(195)
         factor=(nc**2-1d0)/nc**3*facVV     ! u db subtraction        B0g2Z
      case(196)
         factor=(nc**2-1d0)/nc**3*facVV     ! u ub subtraction        B0g2Z
      case(197)
         factor=(nc**2-1d0)/nc**2*facVV     ! d g subtraction         B0g2Z
      case(198)
         factor=(nc**2-1d0)/nc**2*facVV     ! u g subtraction         B0g2Z
      case(199)
         factor=(nc**2-1d0)/nc**4*facVV     ! d d subtraction         B0g2Z
      case(200)
         factor=(nc**2-1d0)/nc**4*facVV     ! u u subtraction         B0g2Z
      case(201)
         factor=(nc**2-1d0)/nc**3*facVV     ! db d subtraction        B0g2Z
      case(202)
         factor=(nc**2-1d0)/nc**3*facVV     ! db u subtraction        B0g2Z
      case(203)
         factor=(nc**2-1d0)/nc**3*facVV     ! ub d subtraction        B0g2Z
      case(204)
         factor=(nc**2-1d0)/nc**3*facVV     ! ub u subtraction        B0g2Z
      case(205)
         factor=(nc**2-1d0)/nc**3*facVV     ! db db subtraction       B0g2Z
      case(206)
         factor=(nc**2-1d0)/nc**3*facVV     ! db ub subtraction       B0g2Z
      case(207)
         factor=(nc**2-1d0)/nc**3*facVV     ! ub db subtraction       B0g2Z
      case(208)
         factor=(nc**2-1d0)/nc**3*facVV     ! ub ub subtraction       B0g2Z
      case(209)
         factor=(nc**2-1d0)/nc**2*facVV     ! db g subtraction        B0g2Z
      case(210)
         factor=(nc**2-1d0)/nc**2*facVV     ! ub g subtraction        B0g2Z
      case(211)
         factor=(nc**2-1d0)/nc**4*facVV     ! db db subtraction       B0g2Z
      case(212)
         factor=(nc**2-1d0)/nc**4*facVV     ! ub ub subtraction       B0g2Z
      case(213)
         factor=-(nc**2-1d0)/nc**4*facVV    ! d db -> lp lm           Bt0g2Z
      case(214)
         factor=-(nc**2-1d0)/nc**4*facVV    ! u ub -> lp lm           Bt0g2Z
      case(215)
         factor=-(nc**2-1d0)/nc**4*facVV    ! db d -> lp lm           Bt0g2Z
      case(216)
         factor=-(nc**2-1d0)/nc**4*facVV    ! ub u -> lp lm           Bt0g2Z
      case(217)
         factor=-(nc**2-1d0)/nc**4*ndown*facVV   ! g g subtraction         Bt0g2Z
      case(218)
         factor=-(nc**2-1d0)/nc**4*nup*facVV   ! g g subtraction         Bt0g2Z
      case(219)
         factor=-(nc**2-1d0)/nc**4*facVV    ! g d subtraction         Bt0g2Z
      case(220)
         factor=-(nc**2-1d0)/nc**4*facVV    ! g u subtraction         Bt0g2Z
      case(221)
         factor=-(nc**2-1d0)/nc**4*facVV    ! g db subtraction        Bt0g2Z
      case(222)
         factor=-(nc**2-1d0)/nc**4*facVV    ! g ub subtraction        Bt0g2Z
      case(223)
         factor=-(nc**2-1d0)/nc**5*facVV    ! d d subtraction         Bt0g2Z
      case(224)
         factor=-(nc**2-1d0)/nc**5*facVV    ! d u subtraction         Bt0g2Z
      case(225)
         factor=-(nc**2-1d0)/nc**5*facVV    ! u d subtraction         Bt0g2Z
      case(226)
         factor=-(nc**2-1d0)/nc**5*facVV    ! u u subtraction         Bt0g2Z
      case(227)
         factor=-(nc**2-1d0)/nc**5*facVV    ! d db subtraction        Bt0g2Z
      case(228)
         factor=-(nc**2-1d0)/nc**5*facVV    ! d ub subtraction        Bt0g2Z
      case(229)
         factor=-(nc**2-1d0)/nc**5*facVV    ! u db subtraction        Bt0g2Z
      case(230)
         factor=-(nc**2-1d0)/nc**5*facVV    ! u ub subtraction        Bt0g2Z
      case(231)
         factor=-(nc**2-1d0)/nc**4*facVV    ! d g subtraction         Bt0g2Z
      case(232)
         factor=-(nc**2-1d0)/nc**4*facVV    ! u g subtraction         Bt0g2Z
      case(233)
         factor=-(nc**2-1d0)/nc**6*facVV    ! d d subtraction         Bt0g2Z
      case(234)
         factor=-(nc**2-1d0)/nc**6*facVV    ! u u subtraction         Bt0g2Z
      case(235)
         factor=-(nc**2-1d0)/nc**5*facVV    ! db d subtraction        Bt0g2Z
      case(236)
         factor=-(nc**2-1d0)/nc**5*facVV    ! db u subtraction        Bt0g2Z
      case(237)
         factor=-(nc**2-1d0)/nc**5*facVV    ! ub d subtraction        Bt0g2Z
      case(238)
         factor=-(nc**2-1d0)/nc**5*facVV    ! ub u subtraction        Bt0g2Z
      case(239)
         factor=-(nc**2-1d0)/nc**5*facVV    ! db db subtraction       Bt0g2Z
      case(240)
         factor=-(nc**2-1d0)/nc**5*facVV    ! db ub subtraction       Bt0g2Z
      case(241)
         factor=-(nc**2-1d0)/nc**5*facVV    ! ub db subtraction       Bt0g2Z
      case(242)
         factor=-(nc**2-1d0)/nc**5*facVV    ! ub ub subtraction       Bt0g2Z
      case(243)
         factor=-(nc**2-1d0)/nc**4*facVV    ! db g subtraction        Bt0g2Z
      case(244)
         factor=-(nc**2-1d0)/nc**4*facVV    ! ub g subtraction        Bt0g2Z
      case(245)
         factor=-(nc**2-1d0)/nc**6*facVV    ! db db subtraction       Bt0g2Z
      case(246)
         factor=-(nc**2-1d0)/nc**6*facVV    ! ub ub subtraction       Bt0g2Z
      case(247)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! d db -> lp lm           Bh0g2Z
      case(248)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! u ub -> lp lm           Bh0g2Z
      case(249)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! db d -> lp lm           Bh0g2Z
      case(250)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! ub u -> lp lm           Bh0g2Z
      case(251)
         factor=(nc**2-1d0)/nc**3*ndown*nf*facVV   ! g g subtraction         Bh0g2Z
      case(252)
         factor=(nc**2-1d0)/nc**3*nf*nup*facVV   ! g g subtraction         Bh0g2Z
      case(253)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! g d subtraction         Bh0g2Z
      case(254)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! g u subtraction         Bh0g2Z
      case(255)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! g db subtraction        Bh0g2Z
      case(256)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! g ub subtraction        Bh0g2Z
      case(257)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! d d subtraction         Bh0g2Z
      case(258)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! d u subtraction         Bh0g2Z
      case(259)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! u d subtraction         Bh0g2Z
      case(260)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! u u subtraction         Bh0g2Z
      case(261)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! d db subtraction        Bh0g2Z
      case(262)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! d ub subtraction        Bh0g2Z
      case(263)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! u db subtraction        Bh0g2Z
      case(264)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! u ub subtraction        Bh0g2Z
      case(265)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! d g subtraction         Bh0g2Z
      case(266)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! u g subtraction         Bh0g2Z
      case(267)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! d d subtraction         Bh0g2Z
      case(268)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! u u subtraction         Bh0g2Z
      case(269)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! db d subtraction        Bh0g2Z
      case(270)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! db u subtraction        Bh0g2Z
      case(271)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! ub d subtraction        Bh0g2Z
      case(272)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! ub u subtraction        Bh0g2Z
      case(273)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! db db subtraction       Bh0g2Z
      case(274)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! db ub subtraction       Bh0g2Z
      case(275)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! ub db subtraction       Bh0g2Z
      case(276)
         factor=(nc**2-1d0)/nc**4*nf*facVV   ! ub ub subtraction       Bh0g2Z
      case(277)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! db g subtraction        Bh0g2Z
      case(278)
         factor=(nc**2-1d0)/nc**3*nf*facVV   ! ub g subtraction        Bh0g2Z
      case(279)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! db db subtraction       Bh0g2Z
      case(280)
         factor=(nc**2-1d0)/nc**5*nf*facVV   ! ub ub subtraction       Bh0g2Z
      end select
      factor=relfactor*factor

      return
      end
