      subroutine selectchannelZ()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*amz)**2*nc*4d0
      n_alphas_proc = 0
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelZ: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelZ: already allocated'  
        stop
      end if

      ntot_chan = 280

      allocate(qactive_chan(1:280))
      allocate(contrib_chan(1:280))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! d db to lp lm         B0g0Z(1,2,3,4)        
c      qactive_chan(2)  = .true.   ! u ub to lp lm         B0g0Z(1,2,3,4)        
c      qactive_chan(3)  = .true.   ! db d to lp lm         B0g0Z(2,1,3,4)        
c      qactive_chan(4)  = .true.   ! ub u to lp lm         B0g0Z(2,1,3,4)        

      do i=1,4
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(5)  = .true.   ! d g to d lp lm        B1g0Z(1,2,3,4,5)      qgB1g0ZSNLO(1,2,3,4,5)
c      qactive_chan(6)  = .true.   ! u g to u lp lm        B1g0Z(1,2,3,4,5)      qgB1g0ZSNLO(1,2,3,4,5)
c      qactive_chan(7)  = .true.   ! d db to g lp lm       B1g0Z(1,3,2,4,5)      qqbB1g0ZSNLO(1,3,2,4,5)
c      qactive_chan(8)  = .true.   ! u ub to g lp lm       B1g0Z(1,3,2,4,5)      qqbB1g0ZSNLO(1,3,2,4,5)
c      qactive_chan(9)  = .true.   ! g d to d lp lm        B1g0Z(2,1,3,4,5)      gqB1g0ZSNLO(2,1,3,4,5)
c      qactive_chan(10) = .true.   ! g u to u lp lm        B1g0Z(2,1,3,4,5)      gqB1g0ZSNLO(2,1,3,4,5)
c      qactive_chan(11) = .true.   ! db d to g lp lm       B1g0Z(2,3,1,4,5)      qbqB1g0ZSNLO(2,3,1,4,5)
c      qactive_chan(12) = .true.   ! ub u to g lp lm       B1g0Z(2,3,1,4,5)      qbqB1g0ZSNLO(2,3,1,4,5)
c      qactive_chan(13) = .true.   ! g db to db lp lm      B1g0Z(3,1,2,4,5)      gqbB1g0ZSNLO(3,1,2,4,5)
c      qactive_chan(14) = .true.   ! g ub to ub lp lm      B1g0Z(3,1,2,4,5)      gqbB1g0ZSNLO(3,1,2,4,5)
c      qactive_chan(15) = .true.   ! db g to db lp lm      B1g0Z(3,2,1,4,5)      qbgB1g0ZSNLO(3,2,1,4,5)
c      qactive_chan(16) = .true.   ! ub g to ub lp lm      B1g0Z(3,2,1,4,5)      qbgB1g0ZSNLO(3,2,1,4,5)

      do i=5,16
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(17) = .true.   ! d db to lp lm         B0g1Z(1,2,3,4)        qqbB0g1ZTNLO(1,2,3,4)
c      qactive_chan(18) = .true.   ! u ub to lp lm         B0g1Z(1,2,3,4)        qqbB0g1ZTNLO(1,2,3,4)
c      qactive_chan(19) = .true.   ! db d to lp lm         B0g1Z(2,1,3,4)        qbqB0g1ZTNLO(2,1,3,4)
c      qactive_chan(20) = .true.   ! ub u to lp lm         B0g1Z(2,1,3,4)        qbqB0g1ZTNLO(2,1,3,4)
c      qactive_chan(21) = .true.   ! g d subtraction                             gqB0g1ZTNLO(1,2,3,4)
c      qactive_chan(22) = .true.   ! g u subtraction                             gqB0g1ZTNLO(1,2,3,4)
c      qactive_chan(23) = .true.   ! g db subtraction                            gqbB0g1ZTNLO(1,2,3,4)
c      qactive_chan(24) = .true.   ! g ub subtraction                            gqbB0g1ZTNLO(1,2,3,4)
c      qactive_chan(25) = .true.   ! d g subtraction                             qgB0g1ZTNLO(1,2,3,4)
c      qactive_chan(26) = .true.   ! u g subtraction                             qgB0g1ZTNLO(1,2,3,4)
c      qactive_chan(27) = .true.   ! db g subtraction                            qbgB0g1ZTNLO(1,2,3,4)
c      qactive_chan(28) = .true.   ! ub g subtraction                            qbgB0g1ZTNLO(1,2,3,4)

      do i=17,28
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(29) = .true.   ! d g to g d lp lm      B2g0Z(1,2,3,4,5,6)    qgB2g0ZS(1,2,3,4,5,6)
c      qactive_chan(30) = .true.   ! u g to g u lp lm      B2g0Z(1,2,3,4,5,6)    qgB2g0ZS(1,2,3,4,5,6)
c      qactive_chan(31) = .true.   ! d db to g g lp lm     B2g0Z(1,3,4,2,5,6)    qqbB2g0ZS(1,3,4,2,5,6)
c      qactive_chan(32) = .true.   ! u ub to g g lp lm     B2g0Z(1,3,4,2,5,6)    qqbB2g0ZS(1,3,4,2,5,6)
c      qactive_chan(33) = .true.   ! g d to g d lp lm      B2g0Z(2,1,3,4,5,6)    gqB2g0ZS(2,1,3,4,5,6)
c      qactive_chan(34) = .true.   ! g u to g u lp lm      B2g0Z(2,1,3,4,5,6)    gqB2g0ZS(2,1,3,4,5,6)
c      qactive_chan(35) = .true.   ! db d to g g lp lm     B2g0Z(2,3,4,1,5,6)    qbqB2g0ZS(2,3,4,1,5,6)
c      qactive_chan(36) = .true.   ! ub u to g g lp lm     B2g0Z(2,3,4,1,5,6)    qbqB2g0ZS(2,3,4,1,5,6)
c      qactive_chan(37) = .true.   ! g g to db d lp lm     B2g0Z(3,1,2,4,5,6)    ggB2g0ZS(3,1,2,4,5,6)
c      qactive_chan(38) = .true.   ! g g to ub u lp lm     B2g0Z(3,1,2,4,5,6)    ggB2g0ZS(3,1,2,4,5,6)
c      qactive_chan(39) = .true.   ! g db to db g lp lm    B2g0Z(3,1,4,2,5,6)    gqbB2g0ZS(3,1,4,2,5,6)
c      qactive_chan(40) = .true.   ! g ub to ub g lp lm    B2g0Z(3,1,4,2,5,6)    gqbB2g0ZS(3,1,4,2,5,6)
c      qactive_chan(41) = .true.   ! db g to db g lp lm    B2g0Z(3,2,4,1,5,6)    qbgB2g0ZS(3,2,4,1,5,6)
c      qactive_chan(42) = .true.   ! ub g to ub g lp lm    B2g0Z(3,2,4,1,5,6)    qbgB2g0ZS(3,2,4,1,5,6)
c      qactive_chan(43) = .true.   ! d gt to gt d lp lm    Bt2g0Z(1,2,3,4,5,6)   qgtBt2g0ZS(1,2,3,4,5,6)
c      qactive_chan(44) = .true.   ! u gt to gt u lp lm    Bt2g0Z(1,2,3,4,5,6)   qgtBt2g0ZS(1,2,3,4,5,6)
c      qactive_chan(45) = .true.   ! d db to gt gt lp lm   Bt2g0Z(1,3,4,2,5,6)   qqbBt2g0ZS(1,3,4,2,5,6)
c      qactive_chan(46) = .true.   ! u ub to gt gt lp lm   Bt2g0Z(1,3,4,2,5,6)   qqbBt2g0ZS(1,3,4,2,5,6)
c      qactive_chan(47) = .true.   ! gt d to gt d lp lm    Bt2g0Z(2,1,3,4,5,6)   gtqBt2g0ZS(2,1,3,4,5,6)
c      qactive_chan(48) = .true.   ! gt u to gt u lp lm    Bt2g0Z(2,1,3,4,5,6)   gtqBt2g0ZS(2,1,3,4,5,6)
c      qactive_chan(49) = .true.   ! db d to gt gt lp lm   Bt2g0Z(2,3,4,1,5,6)   qbqBt2g0ZS(2,3,4,1,5,6)
c      qactive_chan(50) = .true.   ! ub u to gt gt lp lm   Bt2g0Z(2,3,4,1,5,6)   qbqBt2g0ZS(2,3,4,1,5,6)
c      qactive_chan(51) = .true.   ! gt gt to db d lp lm   Bt2g0Z(3,1,2,4,5,6)   gtgtBt2g0ZS(3,1,2,4,5,6)
c      qactive_chan(52) = .true.   ! gt gt to ub u lp lm   Bt2g0Z(3,1,2,4,5,6)   gtgtBt2g0ZS(3,1,2,4,5,6)
c      qactive_chan(53) = .true.   ! gt db to db gt lp lm   Bt2g0Z(3,1,4,2,5,6)   gtqbBt2g0ZS(3,1,4,2,5,6)
c      qactive_chan(54) = .true.   ! gt ub to ub gt lp lm   Bt2g0Z(3,1,4,2,5,6)   gtqbBt2g0ZS(3,1,4,2,5,6)
c      qactive_chan(55) = .true.   ! db gt to db gt lp lm   Bt2g0Z(3,2,4,1,5,6)   qbgtBt2g0ZS(3,2,4,1,5,6)
c      qactive_chan(56) = .true.   ! ub gt to ub gt lp lm   Bt2g0Z(3,2,4,1,5,6)   qbgtBt2g0ZS(3,2,4,1,5,6)
c      qactive_chan(57) = .true.   ! d db to db d lp lm    C0g0Z(1,2,3,4,5,6)    qqpbC0g0ZS(1,2,3,4,5,6)
c      qactive_chan(58) = .true.   ! d ub to ub d lp lm    C0g0Z(1,2,3,4,5,6)    qqpbC0g0ZS(1,2,3,4,5,6)
c      qactive_chan(59) = .true.   ! u db to db u lp lm    C0g0Z(1,2,3,4,5,6)    qqpbC0g0ZS(1,2,3,4,5,6)
c      qactive_chan(60) = .true.   ! u ub to ub u lp lm    C0g0Z(1,2,3,4,5,6)    qqpbC0g0ZS(1,2,3,4,5,6)
c      qactive_chan(61) = .true.   ! d d to d d lp lm      C0g0Z(1,3,2,4,5,6)    qqpC0g0ZS(1,3,2,4,5,6)
c      qactive_chan(62) = .true.   ! d u to u d lp lm      C0g0Z(1,3,2,4,5,6)    qqpC0g0ZS(1,3,2,4,5,6)
c      qactive_chan(63) = .true.   ! u d to d u lp lm      C0g0Z(1,3,2,4,5,6)    qqpC0g0ZS(1,3,2,4,5,6)
c      qactive_chan(64) = .true.   ! u u to u u lp lm      C0g0Z(1,3,2,4,5,6)    qqpC0g0ZS(1,3,2,4,5,6)
c      qactive_chan(65) = .true.   ! d db to d db lp lm    C0g0Z(1,3,4,2,5,6)    qqbC0g0ZS(1,3,4,2,5,6)
c      qactive_chan(66) = .true.   ! d db to u ub lp lm    C0g0Z(1,3,4,2,5,6)    qqbC0g0ZS(1,3,4,2,5,6)
c      qactive_chan(67) = .true.   ! u ub to d db lp lm    C0g0Z(1,3,4,2,5,6)    qqbC0g0ZS(1,3,4,2,5,6)
c      qactive_chan(68) = .true.   ! u ub to u ub lp lm    C0g0Z(1,3,4,2,5,6)    qqbC0g0ZS(1,3,4,2,5,6)
c      qactive_chan(69) = .true.   ! db d to d db lp lm    C0g0Z(2,3,4,1,5,6)    qbqC0g0ZS(2,3,4,1,5,6)
c      qactive_chan(70) = .true.   ! db d to u ub lp lm    C0g0Z(2,3,4,1,5,6)    qbqC0g0ZS(2,3,4,1,5,6)
c      qactive_chan(71) = .true.   ! ub u to d db lp lm    C0g0Z(2,3,4,1,5,6)    qbqC0g0ZS(2,3,4,1,5,6)
c      qactive_chan(72) = .true.   ! ub u to u ub lp lm    C0g0Z(2,3,4,1,5,6)    qbqC0g0ZS(2,3,4,1,5,6)
c      qactive_chan(73) = .true.   ! db db to db db lp lm   C0g0Z(3,2,4,1,5,6)    qbqpbC0g0ZS(3,2,4,1,5,6)
c      qactive_chan(74) = .true.   ! db ub to db ub lp lm   C0g0Z(3,2,4,1,5,6)    qbqpbC0g0ZS(3,2,4,1,5,6)
c      qactive_chan(75) = .true.   ! ub db to ub db lp lm   C0g0Z(3,2,4,1,5,6)    qbqpbC0g0ZS(3,2,4,1,5,6)
c      qactive_chan(76) = .true.   ! ub ub to ub ub lp lm   C0g0Z(3,2,4,1,5,6)    qbqpbC0g0ZS(3,2,4,1,5,6)
c      qactive_chan(77) = .true.   ! db d to db d lp lm    C0g0Z(3,4,2,1,5,6)    qbqpC0g0ZS(3,4,2,1,5,6)
c      qactive_chan(78) = .true.   ! db u to db u lp lm    C0g0Z(3,4,2,1,5,6)    qbqpC0g0ZS(3,4,2,1,5,6)
c      qactive_chan(79) = .true.   ! ub d to ub d lp lm    C0g0Z(3,4,2,1,5,6)    qbqpC0g0ZS(3,4,2,1,5,6)
c      qactive_chan(80) = .true.   ! ub u to ub u lp lm    C0g0Z(3,4,2,1,5,6)    qbqpC0g0ZS(3,4,2,1,5,6)
c      qactive_chan(81) = .true.   ! d db to db d lp lm    D0g0Z(1,2,3,4,5,6)    qqbD0g0ZS(1,2,3,4,5,6)
c      qactive_chan(82) = .true.   ! u ub to ub u lp lm    D0g0Z(1,2,3,4,5,6)    qqbD0g0ZS(1,2,3,4,5,6)
c      qactive_chan(83) = .true.   ! d d to d d lp lm      D0g0Z(1,3,2,4,5,6)    qqD0g0ZS(1,3,2,4,5,6)
c      qactive_chan(84) = .true.   ! u u to u u lp lm      D0g0Z(1,3,2,4,5,6)    qqD0g0ZS(1,3,2,4,5,6)
c      qactive_chan(85) = .true.   ! db d to db d lp lm    D0g0Z(2,1,3,4,5,6)    qbqD0g0ZS(2,1,3,4,5,6)
c      qactive_chan(86) = .true.   ! ub u to ub u lp lm    D0g0Z(2,1,3,4,5,6)    qbqD0g0ZS(2,1,3,4,5,6)
c      qactive_chan(87) = .true.   ! db db to db db lp lm   D0g0Z(3,1,4,2,5,6)    qbqbD0g0ZS(3,1,4,2,5,6)
c      qactive_chan(88) = .true.   ! ub ub to ub ub lp lm   D0g0Z(3,1,4,2,5,6)    qbqbD0g0ZS(3,1,4,2,5,6)

      do i=29,88
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(89) = .true.   ! d g to d lp lm        B1g1Z(1,2,3,4,5)      qgB1g1ZT(1,2,3,4,5)
c      qactive_chan(90) = .true.   ! u g to u lp lm        B1g1Z(1,2,3,4,5)      qgB1g1ZT(1,2,3,4,5)
c      qactive_chan(91) = .true.   ! d db to g lp lm       B1g1Z(1,3,2,4,5)      qqbB1g1ZT(1,3,2,4,5)
c      qactive_chan(92) = .true.   ! u ub to g lp lm       B1g1Z(1,3,2,4,5)      qqbB1g1ZT(1,3,2,4,5)
c      qactive_chan(93) = .true.   ! g d to d lp lm        B1g1Z(2,1,3,4,5)      gqB1g1ZT(2,1,3,4,5)
c      qactive_chan(94) = .true.   ! g u to u lp lm        B1g1Z(2,1,3,4,5)      gqB1g1ZT(2,1,3,4,5)
c      qactive_chan(95) = .true.   ! db d to g lp lm       B1g1Z(2,3,1,4,5)      qbqB1g1ZT(2,3,1,4,5)
c      qactive_chan(96) = .true.   ! ub u to g lp lm       B1g1Z(2,3,1,4,5)      qbqB1g1ZT(2,3,1,4,5)
c      qactive_chan(97) = .true.   ! g db to db lp lm      B1g1Z(3,1,2,4,5)      gqbB1g1ZT(3,1,2,4,5)
c      qactive_chan(98) = .true.   ! g ub to ub lp lm      B1g1Z(3,1,2,4,5)      gqbB1g1ZT(3,1,2,4,5)
c      qactive_chan(99) = .true.   ! db g to db lp lm      B1g1Z(3,2,1,4,5)      qbgB1g1ZT(3,2,1,4,5)
c      qactive_chan(100)= .true.   ! ub g to ub lp lm      B1g1Z(3,2,1,4,5)      qbgB1g1ZT(3,2,1,4,5)
c      qactive_chan(101)= .true.   ! g g subtraction                             ggB1g1ZT(1,2,3,4,5)
c      qactive_chan(102)= .true.   ! g g subtraction                             ggB1g1ZT(1,2,3,4,5)
c      qactive_chan(103)= .true.   ! d d subtraction                             qqpB1g1ZT(1,2,3,4,5)
c      qactive_chan(104)= .true.   ! d u subtraction                             qqpB1g1ZT(1,2,3,4,5)
c      qactive_chan(105)= .true.   ! u d subtraction                             qqpB1g1ZT(1,2,3,4,5)
c      qactive_chan(106)= .true.   ! u u subtraction                             qqpB1g1ZT(1,2,3,4,5)
c      qactive_chan(107)= .true.   ! d db subtraction                            qqpbB1g1ZT(1,2,3,4,5)
c      qactive_chan(108)= .true.   ! d ub subtraction                            qqpbB1g1ZT(1,2,3,4,5)
c      qactive_chan(109)= .true.   ! u db subtraction                            qqpbB1g1ZT(1,2,3,4,5)
c      qactive_chan(110)= .true.   ! u ub subtraction                            qqpbB1g1ZT(1,2,3,4,5)
c      qactive_chan(111)= .true.   ! db d subtraction                            qbqpB1g1ZT(1,2,3,4,5)
c      qactive_chan(112)= .true.   ! db u subtraction                            qbqpB1g1ZT(1,2,3,4,5)
c      qactive_chan(113)= .true.   ! ub d subtraction                            qbqpB1g1ZT(1,2,3,4,5)
c      qactive_chan(114)= .true.   ! ub u subtraction                            qbqpB1g1ZT(1,2,3,4,5)
c      qactive_chan(115)= .true.   ! db db subtraction                           qbqpbB1g1ZT(1,2,3,4,5)
c      qactive_chan(116)= .true.   ! db ub subtraction                           qbqpbB1g1ZT(1,2,3,4,5)
c      qactive_chan(117)= .true.   ! ub db subtraction                           qbqpbB1g1ZT(1,2,3,4,5)
c      qactive_chan(118)= .true.   ! ub ub subtraction                           qbqpbB1g1ZT(1,2,3,4,5)
c      qactive_chan(119)= .true.   ! d g to d lp lm        Bt1g1Z(1,2,3,4,5)     qgBt1g1ZT(1,2,3,4,5)
c      qactive_chan(120)= .true.   ! u g to u lp lm        Bt1g1Z(1,2,3,4,5)     qgBt1g1ZT(1,2,3,4,5)
c      qactive_chan(121)= .true.   ! d db to g lp lm       Bt1g1Z(1,3,2,4,5)     qqbBt1g1ZT(1,3,2,4,5)
c      qactive_chan(122)= .true.   ! u ub to g lp lm       Bt1g1Z(1,3,2,4,5)     qqbBt1g1ZT(1,3,2,4,5)
c      qactive_chan(123)= .true.   ! g d to d lp lm        Bt1g1Z(2,1,3,4,5)     gqBt1g1ZT(2,1,3,4,5)
c      qactive_chan(124)= .true.   ! g u to u lp lm        Bt1g1Z(2,1,3,4,5)     gqBt1g1ZT(2,1,3,4,5)
c      qactive_chan(125)= .true.   ! db d to g lp lm       Bt1g1Z(2,3,1,4,5)     qbqBt1g1ZT(2,3,1,4,5)
c      qactive_chan(126)= .true.   ! ub u to g lp lm       Bt1g1Z(2,3,1,4,5)     qbqBt1g1ZT(2,3,1,4,5)
c      qactive_chan(127)= .true.   ! g db to db lp lm      Bt1g1Z(3,1,2,4,5)     gqbBt1g1ZT(3,1,2,4,5)
c      qactive_chan(128)= .true.   ! g ub to ub lp lm      Bt1g1Z(3,1,2,4,5)     gqbBt1g1ZT(3,1,2,4,5)
c      qactive_chan(129)= .true.   ! db g to db lp lm      Bt1g1Z(3,2,1,4,5)     qbgBt1g1ZT(3,2,1,4,5)
c      qactive_chan(130)= .true.   ! ub g to ub lp lm      Bt1g1Z(3,2,1,4,5)     qbgBt1g1ZT(3,2,1,4,5)
c      qactive_chan(131)= .true.   ! g g subtraction                             ggBt1g1ZT(1,2,3,4,5)
c      qactive_chan(132)= .true.   ! g g subtraction                             ggBt1g1ZT(1,2,3,4,5)
c      qactive_chan(133)= .true.   ! d d subtraction                             qqpBt1g1ZT(1,2,3,4,5)
c      qactive_chan(134)= .true.   ! d u subtraction                             qqpBt1g1ZT(1,2,3,4,5)
c      qactive_chan(135)= .true.   ! u d subtraction                             qqpBt1g1ZT(1,2,3,4,5)
c      qactive_chan(136)= .true.   ! u u subtraction                             qqpBt1g1ZT(1,2,3,4,5)
c      qactive_chan(137)= .true.   ! d db subtraction                            qqpbBt1g1ZT(1,2,3,4,5)
c      qactive_chan(138)= .true.   ! d ub subtraction                            qqpbBt1g1ZT(1,2,3,4,5)
c      qactive_chan(139)= .true.   ! u db subtraction                            qqpbBt1g1ZT(1,2,3,4,5)
c      qactive_chan(140)= .true.   ! u ub subtraction                            qqpbBt1g1ZT(1,2,3,4,5)
c      qactive_chan(141)= .true.   ! db d subtraction                            qbqpBt1g1ZT(1,2,3,4,5)
c      qactive_chan(142)= .true.   ! db u subtraction                            qbqpBt1g1ZT(1,2,3,4,5)
c      qactive_chan(143)= .true.   ! ub d subtraction                            qbqpBt1g1ZT(1,2,3,4,5)
c      qactive_chan(144)= .true.   ! ub u subtraction                            qbqpBt1g1ZT(1,2,3,4,5)
c      qactive_chan(145)= .true.   ! db db subtraction                           qbqpbBt1g1ZT(1,2,3,4,5)
c      qactive_chan(146)= .true.   ! db ub subtraction                           qbqpbBt1g1ZT(1,2,3,4,5)
c      qactive_chan(147)= .true.   ! ub db subtraction                           qbqpbBt1g1ZT(1,2,3,4,5)
c      qactive_chan(148)= .true.   ! ub ub subtraction                           qbqpbBt1g1ZT(1,2,3,4,5)
c      qactive_chan(149)= .true.   ! d g to d lp lm        Bh1g1Z(1,2,3,4,5)     qgBh1g1ZT(1,2,3,4,5)
c      qactive_chan(150)= .true.   ! u g to u lp lm        Bh1g1Z(1,2,3,4,5)     qgBh1g1ZT(1,2,3,4,5)
c      qactive_chan(151)= .true.   ! d db to g lp lm       Bh1g1Z(1,3,2,4,5)     qqbBh1g1ZT(1,3,2,4,5)
c      qactive_chan(152)= .true.   ! u ub to g lp lm       Bh1g1Z(1,3,2,4,5)     qqbBh1g1ZT(1,3,2,4,5)
c      qactive_chan(153)= .true.   ! g d to d lp lm        Bh1g1Z(2,1,3,4,5)     gqBh1g1ZT(2,1,3,4,5)
c      qactive_chan(154)= .true.   ! g u to u lp lm        Bh1g1Z(2,1,3,4,5)     gqBh1g1ZT(2,1,3,4,5)
c      qactive_chan(155)= .true.   ! db d to g lp lm       Bh1g1Z(2,3,1,4,5)     qbqBh1g1ZT(2,3,1,4,5)
c      qactive_chan(156)= .true.   ! ub u to g lp lm       Bh1g1Z(2,3,1,4,5)     qbqBh1g1ZT(2,3,1,4,5)
c      qactive_chan(157)= .true.   ! g db to db lp lm      Bh1g1Z(3,1,2,4,5)     gqbBh1g1ZT(3,1,2,4,5)
c      qactive_chan(158)= .true.   ! g ub to ub lp lm      Bh1g1Z(3,1,2,4,5)     gqbBh1g1ZT(3,1,2,4,5)
c      qactive_chan(159)= .true.   ! db g to db lp lm      Bh1g1Z(3,2,1,4,5)     qbgBh1g1ZT(3,2,1,4,5)
c      qactive_chan(160)= .true.   ! ub g to ub lp lm      Bh1g1Z(3,2,1,4,5)     qbgBh1g1ZT(3,2,1,4,5)
c      qactive_chan(161)= .true.   ! g g subtraction                             ggBh1g1ZT(1,2,3,4,5)
c      qactive_chan(162)= .true.   ! g g subtraction                             ggBh1g1ZT(1,2,3,4,5)
c      qactive_chan(163)= .true.   ! d d subtraction                             qqpBh1g1ZT(1,2,3,4,5)
c      qactive_chan(164)= .true.   ! d u subtraction                             qqpBh1g1ZT(1,2,3,4,5)
c      qactive_chan(165)= .true.   ! u d subtraction                             qqpBh1g1ZT(1,2,3,4,5)
c      qactive_chan(166)= .true.   ! u u subtraction                             qqpBh1g1ZT(1,2,3,4,5)
c      qactive_chan(167)= .true.   ! d db subtraction                            qqpbBh1g1ZT(1,2,3,4,5)
c      qactive_chan(168)= .true.   ! d ub subtraction                            qqpbBh1g1ZT(1,2,3,4,5)
c      qactive_chan(169)= .true.   ! u db subtraction                            qqpbBh1g1ZT(1,2,3,4,5)
c      qactive_chan(170)= .true.   ! u ub subtraction                            qqpbBh1g1ZT(1,2,3,4,5)
c      qactive_chan(171)= .true.   ! db d subtraction                            qbqpBh1g1ZT(1,2,3,4,5)
c      qactive_chan(172)= .true.   ! db u subtraction                            qbqpBh1g1ZT(1,2,3,4,5)
c      qactive_chan(173)= .true.   ! ub d subtraction                            qbqpBh1g1ZT(1,2,3,4,5)
c      qactive_chan(174)= .true.   ! ub u subtraction                            qbqpBh1g1ZT(1,2,3,4,5)
c      qactive_chan(175)= .true.   ! db db subtraction                           qbqpbBh1g1ZT(1,2,3,4,5)
c      qactive_chan(176)= .true.   ! db ub subtraction                           qbqpbBh1g1ZT(1,2,3,4,5)
c      qactive_chan(177)= .true.   ! ub db subtraction                           qbqpbBh1g1ZT(1,2,3,4,5)
c      qactive_chan(178)= .true.   ! ub ub subtraction                           qbqpbBh1g1ZT(1,2,3,4,5)

      do i=89,178
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(179)= .true.   ! d db to lp lm         B0g2Z(1,2,3,4)        qqbB0g2ZU(1,2,3,4)
c      qactive_chan(180)= .true.   ! u ub to lp lm         B0g2Z(1,2,3,4)        qqbB0g2ZU(1,2,3,4)
c      qactive_chan(181)= .true.   ! db d to lp lm         B0g2Z(2,1,3,4)        qbqB0g2ZU(2,1,3,4)
c      qactive_chan(182)= .true.   ! ub u to lp lm         B0g2Z(2,1,3,4)        qbqB0g2ZU(2,1,3,4)
c      qactive_chan(183)= .true.   ! g g subtraction                             ggB0g2ZU(1,2,3,4)
c      qactive_chan(184)= .true.   ! g g subtraction                             ggB0g2ZU(1,2,3,4)
c      qactive_chan(185)= .true.   ! g d subtraction                             gqB0g2ZU(1,2,3,4)
c      qactive_chan(186)= .true.   ! g u subtraction                             gqB0g2ZU(1,2,3,4)
c      qactive_chan(187)= .true.   ! g db subtraction                            gqbB0g2ZU(1,2,3,4)
c      qactive_chan(188)= .true.   ! g ub subtraction                            gqbB0g2ZU(1,2,3,4)
c      qactive_chan(189)= .true.   ! d d subtraction                             qqpB0g2ZU(1,2,3,4)
c      qactive_chan(190)= .true.   ! d u subtraction                             qqpB0g2ZU(1,2,3,4)
c      qactive_chan(191)= .true.   ! u d subtraction                             qqpB0g2ZU(1,2,3,4)
c      qactive_chan(192)= .true.   ! u u subtraction                             qqpB0g2ZU(1,2,3,4)
c      qactive_chan(193)= .true.   ! d db subtraction                            qqpbB0g2ZU(1,2,3,4)
c      qactive_chan(194)= .true.   ! d ub subtraction                            qqpbB0g2ZU(1,2,3,4)
c      qactive_chan(195)= .true.   ! u db subtraction                            qqpbB0g2ZU(1,2,3,4)
c      qactive_chan(196)= .true.   ! u ub subtraction                            qqpbB0g2ZU(1,2,3,4)
c      qactive_chan(197)= .true.   ! d g subtraction                             qgB0g2ZU(1,2,3,4)
c      qactive_chan(198)= .true.   ! u g subtraction                             qgB0g2ZU(1,2,3,4)
c      qactive_chan(199)= .true.   ! d d subtraction                             qqB0g2ZU(1,2,3,4)
c      qactive_chan(200)= .true.   ! u u subtraction                             qqB0g2ZU(1,2,3,4)
c      qactive_chan(201)= .true.   ! db d subtraction                            qbqpB0g2ZU(1,2,3,4)
c      qactive_chan(202)= .true.   ! db u subtraction                            qbqpB0g2ZU(1,2,3,4)
c      qactive_chan(203)= .true.   ! ub d subtraction                            qbqpB0g2ZU(1,2,3,4)
c      qactive_chan(204)= .true.   ! ub u subtraction                            qbqpB0g2ZU(1,2,3,4)
c      qactive_chan(205)= .true.   ! db db subtraction                           qbqpbB0g2ZU(1,2,3,4)
c      qactive_chan(206)= .true.   ! db ub subtraction                           qbqpbB0g2ZU(1,2,3,4)
c      qactive_chan(207)= .true.   ! ub db subtraction                           qbqpbB0g2ZU(1,2,3,4)
c      qactive_chan(208)= .true.   ! ub ub subtraction                           qbqpbB0g2ZU(1,2,3,4)
c      qactive_chan(209)= .true.   ! db g subtraction                            qbgB0g2ZU(1,2,3,4)
c      qactive_chan(210)= .true.   ! ub g subtraction                            qbgB0g2ZU(1,2,3,4)
c      qactive_chan(211)= .true.   ! db db subtraction                           qbqbB0g2ZU(1,2,3,4)
c      qactive_chan(212)= .true.   ! ub ub subtraction                           qbqbB0g2ZU(1,2,3,4)
c      qactive_chan(213)= .true.   ! d db to lp lm         Bt0g2Z(1,2,3,4)       qqbBt0g2ZU(1,2,3,4)
c      qactive_chan(214)= .true.   ! u ub to lp lm         Bt0g2Z(1,2,3,4)       qqbBt0g2ZU(1,2,3,4)
c      qactive_chan(215)= .true.   ! db d to lp lm         Bt0g2Z(2,1,3,4)       qbqBt0g2ZU(2,1,3,4)
c      qactive_chan(216)= .true.   ! ub u to lp lm         Bt0g2Z(2,1,3,4)       qbqBt0g2ZU(2,1,3,4)
c      qactive_chan(217)= .true.   ! g g subtraction                             ggBt0g2ZU(1,2,3,4)
c      qactive_chan(218)= .true.   ! g g subtraction                             ggBt0g2ZU(1,2,3,4)
c      qactive_chan(219)= .true.   ! g d subtraction                             gqBt0g2ZU(1,2,3,4)
c      qactive_chan(220)= .true.   ! g u subtraction                             gqBt0g2ZU(1,2,3,4)
c      qactive_chan(221)= .true.   ! g db subtraction                            gqbBt0g2ZU(1,2,3,4)
c      qactive_chan(222)= .true.   ! g ub subtraction                            gqbBt0g2ZU(1,2,3,4)
c      qactive_chan(223)= .true.   ! d d subtraction                             qqpBt0g2ZU(1,2,3,4)
c      qactive_chan(224)= .true.   ! d u subtraction                             qqpBt0g2ZU(1,2,3,4)
c      qactive_chan(225)= .true.   ! u d subtraction                             qqpBt0g2ZU(1,2,3,4)
c      qactive_chan(226)= .true.   ! u u subtraction                             qqpBt0g2ZU(1,2,3,4)
c      qactive_chan(227)= .true.   ! d db subtraction                            qqpbBt0g2ZU(1,2,3,4)
c      qactive_chan(228)= .true.   ! d ub subtraction                            qqpbBt0g2ZU(1,2,3,4)
c      qactive_chan(229)= .true.   ! u db subtraction                            qqpbBt0g2ZU(1,2,3,4)
c      qactive_chan(230)= .true.   ! u ub subtraction                            qqpbBt0g2ZU(1,2,3,4)
c      qactive_chan(231)= .true.   ! d g subtraction                             qgBt0g2ZU(1,2,3,4)
c      qactive_chan(232)= .true.   ! u g subtraction                             qgBt0g2ZU(1,2,3,4)
c      qactive_chan(233)= .true.   ! d d subtraction                             qqBt0g2ZU(1,2,3,4)
c      qactive_chan(234)= .true.   ! u u subtraction                             qqBt0g2ZU(1,2,3,4)
c      qactive_chan(235)= .true.   ! db d subtraction                            qbqpBt0g2ZU(1,2,3,4)
c      qactive_chan(236)= .true.   ! db u subtraction                            qbqpBt0g2ZU(1,2,3,4)
c      qactive_chan(237)= .true.   ! ub d subtraction                            qbqpBt0g2ZU(1,2,3,4)
c      qactive_chan(238)= .true.   ! ub u subtraction                            qbqpBt0g2ZU(1,2,3,4)
c      qactive_chan(239)= .true.   ! db db subtraction                           qbqpbBt0g2ZU(1,2,3,4)
c      qactive_chan(240)= .true.   ! db ub subtraction                           qbqpbBt0g2ZU(1,2,3,4)
c      qactive_chan(241)= .true.   ! ub db subtraction                           qbqpbBt0g2ZU(1,2,3,4)
c      qactive_chan(242)= .true.   ! ub ub subtraction                           qbqpbBt0g2ZU(1,2,3,4)
c      qactive_chan(243)= .true.   ! db g subtraction                            qbgBt0g2ZU(1,2,3,4)
c      qactive_chan(244)= .true.   ! ub g subtraction                            qbgBt0g2ZU(1,2,3,4)
c      qactive_chan(245)= .true.   ! db db subtraction                           qbqbBt0g2ZU(1,2,3,4)
c      qactive_chan(246)= .true.   ! ub ub subtraction                           qbqbBt0g2ZU(1,2,3,4)
c      qactive_chan(247)= .true.   ! d db to lp lm         Bh0g2Z(1,2,3,4)       qqbBh0g2ZU(1,2,3,4)
c      qactive_chan(248)= .true.   ! u ub to lp lm         Bh0g2Z(1,2,3,4)       qqbBh0g2ZU(1,2,3,4)
c      qactive_chan(249)= .true.   ! db d to lp lm         Bh0g2Z(2,1,3,4)       qbqBh0g2ZU(2,1,3,4)
c      qactive_chan(250)= .true.   ! ub u to lp lm         Bh0g2Z(2,1,3,4)       qbqBh0g2ZU(2,1,3,4)
c      qactive_chan(251)= .true.   ! g g subtraction                             ggBh0g2ZU(1,2,3,4)
c      qactive_chan(252)= .true.   ! g g subtraction                             ggBh0g2ZU(1,2,3,4)
c      qactive_chan(253)= .true.   ! g d subtraction                             gqBh0g2ZU(1,2,3,4)
c      qactive_chan(254)= .true.   ! g u subtraction                             gqBh0g2ZU(1,2,3,4)
c      qactive_chan(255)= .true.   ! g db subtraction                            gqbBh0g2ZU(1,2,3,4)
c      qactive_chan(256)= .true.   ! g ub subtraction                            gqbBh0g2ZU(1,2,3,4)
c      qactive_chan(257)= .true.   ! d d subtraction                             qqpBh0g2ZU(1,2,3,4)
c      qactive_chan(258)= .true.   ! d u subtraction                             qqpBh0g2ZU(1,2,3,4)
c      qactive_chan(259)= .true.   ! u d subtraction                             qqpBh0g2ZU(1,2,3,4)
c      qactive_chan(260)= .true.   ! u u subtraction                             qqpBh0g2ZU(1,2,3,4)
c      qactive_chan(261)= .true.   ! d db subtraction                            qqpbBh0g2ZU(1,2,3,4)
c      qactive_chan(262)= .true.   ! d ub subtraction                            qqpbBh0g2ZU(1,2,3,4)
c      qactive_chan(263)= .true.   ! u db subtraction                            qqpbBh0g2ZU(1,2,3,4)
c      qactive_chan(264)= .true.   ! u ub subtraction                            qqpbBh0g2ZU(1,2,3,4)
c      qactive_chan(265)= .true.   ! d g subtraction                             qgBh0g2ZU(1,2,3,4)
c      qactive_chan(266)= .true.   ! u g subtraction                             qgBh0g2ZU(1,2,3,4)
c      qactive_chan(267)= .true.   ! d d subtraction                             qqBh0g2ZU(1,2,3,4)
c      qactive_chan(268)= .true.   ! u u subtraction                             qqBh0g2ZU(1,2,3,4)
c      qactive_chan(269)= .true.   ! db d subtraction                            qbqpBh0g2ZU(1,2,3,4)
c      qactive_chan(270)= .true.   ! db u subtraction                            qbqpBh0g2ZU(1,2,3,4)
c      qactive_chan(271)= .true.   ! ub d subtraction                            qbqpBh0g2ZU(1,2,3,4)
c      qactive_chan(272)= .true.   ! ub u subtraction                            qbqpBh0g2ZU(1,2,3,4)
c      qactive_chan(273)= .true.   ! db db subtraction                           qbqpbBh0g2ZU(1,2,3,4)
c      qactive_chan(274)= .true.   ! db ub subtraction                           qbqpbBh0g2ZU(1,2,3,4)
c      qactive_chan(275)= .true.   ! ub db subtraction                           qbqpbBh0g2ZU(1,2,3,4)
c      qactive_chan(276)= .true.   ! ub ub subtraction                           qbqpbBh0g2ZU(1,2,3,4)
c      qactive_chan(277)= .true.   ! db g subtraction                            qbgBh0g2ZU(1,2,3,4)
c      qactive_chan(278)= .true.   ! ub g subtraction                            qbgBh0g2ZU(1,2,3,4)
c      qactive_chan(279)= .true.   ! db db subtraction                           qbqbBh0g2ZU(1,2,3,4)
c      qactive_chan(280)= .true.   ! ub ub subtraction                           qbqbBh0g2ZU(1,2,3,4)

      do i=179,280
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelZ(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'd db to lp lm       '
        me_str   = 'B0g0Z(1,2,3,4)      '
        sub_str  = ''

      case (2)
        chan_str = 'u ub to lp lm       '
        me_str   = 'B0g0Z(1,2,3,4)      '
        sub_str  = ''

      case (3)
        chan_str = 'db d to lp lm       '
        me_str   = 'B0g0Z(2,1,3,4)      '
        sub_str  = ''

      case (4)
        chan_str = 'ub u to lp lm       '
        me_str   = 'B0g0Z(2,1,3,4)      '
        sub_str  = ''

      case (5)
        chan_str = 'd g to d lp lm      '
        me_str   = 'B1g0Z(1,2,3,4,5)    '
        sub_str  = 'qgB1g0ZSNLO(1,2,3,4,5)'

      case (6)
        chan_str = 'u g to u lp lm      '
        me_str   = 'B1g0Z(1,2,3,4,5)    '
        sub_str  = 'qgB1g0ZSNLO(1,2,3,4,5)'

      case (7)
        chan_str = 'd db to g lp lm     '
        me_str   = 'B1g0Z(1,3,2,4,5)    '
        sub_str  = 'qqbB1g0ZSNLO(1,3,2,4,5)'

      case (8)
        chan_str = 'u ub to g lp lm     '
        me_str   = 'B1g0Z(1,3,2,4,5)    '
        sub_str  = 'qqbB1g0ZSNLO(1,3,2,4,5)'

      case (9)
        chan_str = 'g d to d lp lm      '
        me_str   = 'B1g0Z(2,1,3,4,5)    '
        sub_str  = 'gqB1g0ZSNLO(2,1,3,4,5)'

      case (10)
        chan_str = 'g u to u lp lm      '
        me_str   = 'B1g0Z(2,1,3,4,5)    '
        sub_str  = 'gqB1g0ZSNLO(2,1,3,4,5)'

      case (11)
        chan_str = 'db d to g lp lm     '
        me_str   = 'B1g0Z(2,3,1,4,5)    '
        sub_str  = 'qbqB1g0ZSNLO(2,3,1,4,5)'

      case (12)
        chan_str = 'ub u to g lp lm     '
        me_str   = 'B1g0Z(2,3,1,4,5)    '
        sub_str  = 'qbqB1g0ZSNLO(2,3,1,4,5)'

      case (13)
        chan_str = 'g db to db lp lm    '
        me_str   = 'B1g0Z(3,1,2,4,5)    '
        sub_str  = 'gqbB1g0ZSNLO(3,1,2,4,5)'

      case (14)
        chan_str = 'g ub to ub lp lm    '
        me_str   = 'B1g0Z(3,1,2,4,5)    '
        sub_str  = 'gqbB1g0ZSNLO(3,1,2,4,5)'

      case (15)
        chan_str = 'db g to db lp lm    '
        me_str   = 'B1g0Z(3,2,1,4,5)    '
        sub_str  = 'qbgB1g0ZSNLO(3,2,1,4,5)'

      case (16)
        chan_str = 'ub g to ub lp lm    '
        me_str   = 'B1g0Z(3,2,1,4,5)    '
        sub_str  = 'qbgB1g0ZSNLO(3,2,1,4,5)'

      case (17)
        chan_str = 'd db to lp lm       '
        me_str   = 'B0g1Z(1,2,3,4)      '
        sub_str  = 'qqbB0g1ZTNLO(1,2,3,4)'

      case (18)
        chan_str = 'u ub to lp lm       '
        me_str   = 'B0g1Z(1,2,3,4)      '
        sub_str  = 'qqbB0g1ZTNLO(1,2,3,4)'

      case (19)
        chan_str = 'db d to lp lm       '
        me_str   = 'B0g1Z(2,1,3,4)      '
        sub_str  = 'qbqB0g1ZTNLO(2,1,3,4)'

      case (20)
        chan_str = 'ub u to lp lm       '
        me_str   = 'B0g1Z(2,1,3,4)      '
        sub_str  = 'qbqB0g1ZTNLO(2,1,3,4)'

      case (21)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gqB0g1ZTNLO(1,2,3,4)'

      case (22)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'gqB0g1ZTNLO(1,2,3,4)'

      case (23)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbB0g1ZTNLO(1,2,3,4)'

      case (24)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbB0g1ZTNLO(1,2,3,4)'

      case (25)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgB0g1ZTNLO(1,2,3,4)'

      case (26)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgB0g1ZTNLO(1,2,3,4)'

      case (27)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgB0g1ZTNLO(1,2,3,4)'

      case (28)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgB0g1ZTNLO(1,2,3,4)'

      case (29)
        chan_str = 'd g to g d lp lm    '
        me_str   = 'B2g0Z(1,2,3,4,5,6)  '
        sub_str  = 'qgB2g0ZS(1,2,3,4,5,6)'

      case (30)
        chan_str = 'u g to g u lp lm    '
        me_str   = 'B2g0Z(1,2,3,4,5,6)  '
        sub_str  = 'qgB2g0ZS(1,2,3,4,5,6)'

      case (31)
        chan_str = 'd db to g g lp lm   '
        me_str   = 'B2g0Z(1,3,4,2,5,6)  '
        sub_str  = 'qqbB2g0ZS(1,3,4,2,5,6)'

      case (32)
        chan_str = 'u ub to g g lp lm   '
        me_str   = 'B2g0Z(1,3,4,2,5,6)  '
        sub_str  = 'qqbB2g0ZS(1,3,4,2,5,6)'

      case (33)
        chan_str = 'g d to g d lp lm    '
        me_str   = 'B2g0Z(2,1,3,4,5,6)  '
        sub_str  = 'gqB2g0ZS(2,1,3,4,5,6)'

      case (34)
        chan_str = 'g u to g u lp lm    '
        me_str   = 'B2g0Z(2,1,3,4,5,6)  '
        sub_str  = 'gqB2g0ZS(2,1,3,4,5,6)'

      case (35)
        chan_str = 'db d to g g lp lm   '
        me_str   = 'B2g0Z(2,3,4,1,5,6)  '
        sub_str  = 'qbqB2g0ZS(2,3,4,1,5,6)'

      case (36)
        chan_str = 'ub u to g g lp lm   '
        me_str   = 'B2g0Z(2,3,4,1,5,6)  '
        sub_str  = 'qbqB2g0ZS(2,3,4,1,5,6)'

      case (37)
        chan_str = 'g g to db d lp lm   '
        me_str   = 'B2g0Z(3,1,2,4,5,6)  '
        sub_str  = 'ggB2g0ZS(3,1,2,4,5,6)'

      case (38)
        chan_str = 'g g to ub u lp lm   '
        me_str   = 'B2g0Z(3,1,2,4,5,6)  '
        sub_str  = 'ggB2g0ZS(3,1,2,4,5,6)'

      case (39)
        chan_str = 'g db to db g lp lm  '
        me_str   = 'B2g0Z(3,1,4,2,5,6)  '
        sub_str  = 'gqbB2g0ZS(3,1,4,2,5,6)'

      case (40)
        chan_str = 'g ub to ub g lp lm  '
        me_str   = 'B2g0Z(3,1,4,2,5,6)  '
        sub_str  = 'gqbB2g0ZS(3,1,4,2,5,6)'

      case (41)
        chan_str = 'db g to db g lp lm  '
        me_str   = 'B2g0Z(3,2,4,1,5,6)  '
        sub_str  = 'qbgB2g0ZS(3,2,4,1,5,6)'

      case (42)
        chan_str = 'ub g to ub g lp lm  '
        me_str   = 'B2g0Z(3,2,4,1,5,6)  '
        sub_str  = 'qbgB2g0ZS(3,2,4,1,5,6)'

      case (43)
        chan_str = 'd gt to gt d lp lm  '
        me_str   = 'Bt2g0Z(1,2,3,4,5,6) '
        sub_str  = 'qgtBt2g0ZS(1,2,3,4,5,6)'

      case (44)
        chan_str = 'u gt to gt u lp lm  '
        me_str   = 'Bt2g0Z(1,2,3,4,5,6) '
        sub_str  = 'qgtBt2g0ZS(1,2,3,4,5,6)'

      case (45)
        chan_str = 'd db to gt gt lp lm '
        me_str   = 'Bt2g0Z(1,3,4,2,5,6) '
        sub_str  = 'qqbBt2g0ZS(1,3,4,2,5,6)'

      case (46)
        chan_str = 'u ub to gt gt lp lm '
        me_str   = 'Bt2g0Z(1,3,4,2,5,6) '
        sub_str  = 'qqbBt2g0ZS(1,3,4,2,5,6)'

      case (47)
        chan_str = 'gt d to gt d lp lm  '
        me_str   = 'Bt2g0Z(2,1,3,4,5,6) '
        sub_str  = 'gtqBt2g0ZS(2,1,3,4,5,6)'

      case (48)
        chan_str = 'gt u to gt u lp lm  '
        me_str   = 'Bt2g0Z(2,1,3,4,5,6) '
        sub_str  = 'gtqBt2g0ZS(2,1,3,4,5,6)'

      case (49)
        chan_str = 'db d to gt gt lp lm '
        me_str   = 'Bt2g0Z(2,3,4,1,5,6) '
        sub_str  = 'qbqBt2g0ZS(2,3,4,1,5,6)'

      case (50)
        chan_str = 'ub u to gt gt lp lm '
        me_str   = 'Bt2g0Z(2,3,4,1,5,6) '
        sub_str  = 'qbqBt2g0ZS(2,3,4,1,5,6)'

      case (51)
        chan_str = 'gt gt to db d lp lm '
        me_str   = 'Bt2g0Z(3,1,2,4,5,6) '
        sub_str  = 'gtgtBt2g0ZS(3,1,2,4,5,6)'

      case (52)
        chan_str = 'gt gt to ub u lp lm '
        me_str   = 'Bt2g0Z(3,1,2,4,5,6) '
        sub_str  = 'gtgtBt2g0ZS(3,1,2,4,5,6)'

      case (53)
        chan_str = 'gt db to db gt lp lm '
        me_str   = 'Bt2g0Z(3,1,4,2,5,6) '
        sub_str  = 'gtqbBt2g0ZS(3,1,4,2,5,6)'

      case (54)
        chan_str = 'gt ub to ub gt lp lm '
        me_str   = 'Bt2g0Z(3,1,4,2,5,6) '
        sub_str  = 'gtqbBt2g0ZS(3,1,4,2,5,6)'

      case (55)
        chan_str = 'db gt to db gt lp lm '
        me_str   = 'Bt2g0Z(3,2,4,1,5,6) '
        sub_str  = 'qbgtBt2g0ZS(3,2,4,1,5,6)'

      case (56)
        chan_str = 'ub gt to ub gt lp lm '
        me_str   = 'Bt2g0Z(3,2,4,1,5,6) '
        sub_str  = 'qbgtBt2g0ZS(3,2,4,1,5,6)'

      case (57)
        chan_str = 'd db to db d lp lm  '
        me_str   = 'C0g0Z(1,2,3,4,5,6)  '
        sub_str  = 'qqpbC0g0ZS(1,2,3,4,5,6)'

      case (58)
        chan_str = 'd ub to ub d lp lm  '
        me_str   = 'C0g0Z(1,2,3,4,5,6)  '
        sub_str  = 'qqpbC0g0ZS(1,2,3,4,5,6)'

      case (59)
        chan_str = 'u db to db u lp lm  '
        me_str   = 'C0g0Z(1,2,3,4,5,6)  '
        sub_str  = 'qqpbC0g0ZS(1,2,3,4,5,6)'

      case (60)
        chan_str = 'u ub to ub u lp lm  '
        me_str   = 'C0g0Z(1,2,3,4,5,6)  '
        sub_str  = 'qqpbC0g0ZS(1,2,3,4,5,6)'

      case (61)
        chan_str = 'd d to d d lp lm    '
        me_str   = 'C0g0Z(1,3,2,4,5,6)  '
        sub_str  = 'qqpC0g0ZS(1,3,2,4,5,6)'

      case (62)
        chan_str = 'd u to u d lp lm    '
        me_str   = 'C0g0Z(1,3,2,4,5,6)  '
        sub_str  = 'qqpC0g0ZS(1,3,2,4,5,6)'

      case (63)
        chan_str = 'u d to d u lp lm    '
        me_str   = 'C0g0Z(1,3,2,4,5,6)  '
        sub_str  = 'qqpC0g0ZS(1,3,2,4,5,6)'

      case (64)
        chan_str = 'u u to u u lp lm    '
        me_str   = 'C0g0Z(1,3,2,4,5,6)  '
        sub_str  = 'qqpC0g0ZS(1,3,2,4,5,6)'

      case (65)
        chan_str = 'd db to d db lp lm  '
        me_str   = 'C0g0Z(1,3,4,2,5,6)  '
        sub_str  = 'qqbC0g0ZS(1,3,4,2,5,6)'

      case (66)
        chan_str = 'd db to u ub lp lm  '
        me_str   = 'C0g0Z(1,3,4,2,5,6)  '
        sub_str  = 'qqbC0g0ZS(1,3,4,2,5,6)'

      case (67)
        chan_str = 'u ub to d db lp lm  '
        me_str   = 'C0g0Z(1,3,4,2,5,6)  '
        sub_str  = 'qqbC0g0ZS(1,3,4,2,5,6)'

      case (68)
        chan_str = 'u ub to u ub lp lm  '
        me_str   = 'C0g0Z(1,3,4,2,5,6)  '
        sub_str  = 'qqbC0g0ZS(1,3,4,2,5,6)'

      case (69)
        chan_str = 'db d to d db lp lm  '
        me_str   = 'C0g0Z(2,3,4,1,5,6)  '
        sub_str  = 'qbqC0g0ZS(2,3,4,1,5,6)'

      case (70)
        chan_str = 'db d to u ub lp lm  '
        me_str   = 'C0g0Z(2,3,4,1,5,6)  '
        sub_str  = 'qbqC0g0ZS(2,3,4,1,5,6)'

      case (71)
        chan_str = 'ub u to d db lp lm  '
        me_str   = 'C0g0Z(2,3,4,1,5,6)  '
        sub_str  = 'qbqC0g0ZS(2,3,4,1,5,6)'

      case (72)
        chan_str = 'ub u to u ub lp lm  '
        me_str   = 'C0g0Z(2,3,4,1,5,6)  '
        sub_str  = 'qbqC0g0ZS(2,3,4,1,5,6)'

      case (73)
        chan_str = 'db db to db db lp lm '
        me_str   = 'C0g0Z(3,2,4,1,5,6)  '
        sub_str  = 'qbqpbC0g0ZS(3,2,4,1,5,6)'

      case (74)
        chan_str = 'db ub to db ub lp lm '
        me_str   = 'C0g0Z(3,2,4,1,5,6)  '
        sub_str  = 'qbqpbC0g0ZS(3,2,4,1,5,6)'

      case (75)
        chan_str = 'ub db to ub db lp lm '
        me_str   = 'C0g0Z(3,2,4,1,5,6)  '
        sub_str  = 'qbqpbC0g0ZS(3,2,4,1,5,6)'

      case (76)
        chan_str = 'ub ub to ub ub lp lm '
        me_str   = 'C0g0Z(3,2,4,1,5,6)  '
        sub_str  = 'qbqpbC0g0ZS(3,2,4,1,5,6)'

      case (77)
        chan_str = 'db d to db d lp lm  '
        me_str   = 'C0g0Z(3,4,2,1,5,6)  '
        sub_str  = 'qbqpC0g0ZS(3,4,2,1,5,6)'

      case (78)
        chan_str = 'db u to db u lp lm  '
        me_str   = 'C0g0Z(3,4,2,1,5,6)  '
        sub_str  = 'qbqpC0g0ZS(3,4,2,1,5,6)'

      case (79)
        chan_str = 'ub d to ub d lp lm  '
        me_str   = 'C0g0Z(3,4,2,1,5,6)  '
        sub_str  = 'qbqpC0g0ZS(3,4,2,1,5,6)'

      case (80)
        chan_str = 'ub u to ub u lp lm  '
        me_str   = 'C0g0Z(3,4,2,1,5,6)  '
        sub_str  = 'qbqpC0g0ZS(3,4,2,1,5,6)'

      case (81)
        chan_str = 'd db to db d lp lm  '
        me_str   = 'D0g0Z(1,2,3,4,5,6)  '
        sub_str  = 'qqbD0g0ZS(1,2,3,4,5,6)'

      case (82)
        chan_str = 'u ub to ub u lp lm  '
        me_str   = 'D0g0Z(1,2,3,4,5,6)  '
        sub_str  = 'qqbD0g0ZS(1,2,3,4,5,6)'

      case (83)
        chan_str = 'd d to d d lp lm    '
        me_str   = 'D0g0Z(1,3,2,4,5,6)  '
        sub_str  = 'qqD0g0ZS(1,3,2,4,5,6)'

      case (84)
        chan_str = 'u u to u u lp lm    '
        me_str   = 'D0g0Z(1,3,2,4,5,6)  '
        sub_str  = 'qqD0g0ZS(1,3,2,4,5,6)'

      case (85)
        chan_str = 'db d to db d lp lm  '
        me_str   = 'D0g0Z(2,1,3,4,5,6)  '
        sub_str  = 'qbqD0g0ZS(2,1,3,4,5,6)'

      case (86)
        chan_str = 'ub u to ub u lp lm  '
        me_str   = 'D0g0Z(2,1,3,4,5,6)  '
        sub_str  = 'qbqD0g0ZS(2,1,3,4,5,6)'

      case (87)
        chan_str = 'db db to db db lp lm '
        me_str   = 'D0g0Z(3,1,4,2,5,6)  '
        sub_str  = 'qbqbD0g0ZS(3,1,4,2,5,6)'

      case (88)
        chan_str = 'ub ub to ub ub lp lm '
        me_str   = 'D0g0Z(3,1,4,2,5,6)  '
        sub_str  = 'qbqbD0g0ZS(3,1,4,2,5,6)'

      case (89)
        chan_str = 'd g to d lp lm      '
        me_str   = 'B1g1Z(1,2,3,4,5)    '
        sub_str  = 'qgB1g1ZT(1,2,3,4,5)'

      case (90)
        chan_str = 'u g to u lp lm      '
        me_str   = 'B1g1Z(1,2,3,4,5)    '
        sub_str  = 'qgB1g1ZT(1,2,3,4,5)'

      case (91)
        chan_str = 'd db to g lp lm     '
        me_str   = 'B1g1Z(1,3,2,4,5)    '
        sub_str  = 'qqbB1g1ZT(1,3,2,4,5)'

      case (92)
        chan_str = 'u ub to g lp lm     '
        me_str   = 'B1g1Z(1,3,2,4,5)    '
        sub_str  = 'qqbB1g1ZT(1,3,2,4,5)'

      case (93)
        chan_str = 'g d to d lp lm      '
        me_str   = 'B1g1Z(2,1,3,4,5)    '
        sub_str  = 'gqB1g1ZT(2,1,3,4,5)'

      case (94)
        chan_str = 'g u to u lp lm      '
        me_str   = 'B1g1Z(2,1,3,4,5)    '
        sub_str  = 'gqB1g1ZT(2,1,3,4,5)'

      case (95)
        chan_str = 'db d to g lp lm     '
        me_str   = 'B1g1Z(2,3,1,4,5)    '
        sub_str  = 'qbqB1g1ZT(2,3,1,4,5)'

      case (96)
        chan_str = 'ub u to g lp lm     '
        me_str   = 'B1g1Z(2,3,1,4,5)    '
        sub_str  = 'qbqB1g1ZT(2,3,1,4,5)'

      case (97)
        chan_str = 'g db to db lp lm    '
        me_str   = 'B1g1Z(3,1,2,4,5)    '
        sub_str  = 'gqbB1g1ZT(3,1,2,4,5)'

      case (98)
        chan_str = 'g ub to ub lp lm    '
        me_str   = 'B1g1Z(3,1,2,4,5)    '
        sub_str  = 'gqbB1g1ZT(3,1,2,4,5)'

      case (99)
        chan_str = 'db g to db lp lm    '
        me_str   = 'B1g1Z(3,2,1,4,5)    '
        sub_str  = 'qbgB1g1ZT(3,2,1,4,5)'

      case (100)
        chan_str = 'ub g to ub lp lm    '
        me_str   = 'B1g1Z(3,2,1,4,5)    '
        sub_str  = 'qbgB1g1ZT(3,2,1,4,5)'

      case (101)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggB1g1ZT(1,2,3,4,5)'

      case (102)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggB1g1ZT(1,2,3,4,5)'

      case (103)
        chan_str = 'd d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB1g1ZT(1,2,3,4,5)'

      case (104)
        chan_str = 'd u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB1g1ZT(1,2,3,4,5)'

      case (105)
        chan_str = 'u d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB1g1ZT(1,2,3,4,5)'

      case (106)
        chan_str = 'u u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB1g1ZT(1,2,3,4,5)'

      case (107)
        chan_str = 'd db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB1g1ZT(1,2,3,4,5)'

      case (108)
        chan_str = 'd ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB1g1ZT(1,2,3,4,5)'

      case (109)
        chan_str = 'u db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB1g1ZT(1,2,3,4,5)'

      case (110)
        chan_str = 'u ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB1g1ZT(1,2,3,4,5)'

      case (111)
        chan_str = 'db d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB1g1ZT(1,2,3,4,5)'

      case (112)
        chan_str = 'db u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB1g1ZT(1,2,3,4,5)'

      case (113)
        chan_str = 'ub d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB1g1ZT(1,2,3,4,5)'

      case (114)
        chan_str = 'ub u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB1g1ZT(1,2,3,4,5)'

      case (115)
        chan_str = 'db db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB1g1ZT(1,2,3,4,5)'

      case (116)
        chan_str = 'db ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB1g1ZT(1,2,3,4,5)'

      case (117)
        chan_str = 'ub db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB1g1ZT(1,2,3,4,5)'

      case (118)
        chan_str = 'ub ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB1g1ZT(1,2,3,4,5)'

      case (119)
        chan_str = 'd g to d lp lm      '
        me_str   = 'Bt1g1Z(1,2,3,4,5)   '
        sub_str  = 'qgBt1g1ZT(1,2,3,4,5)'

      case (120)
        chan_str = 'u g to u lp lm      '
        me_str   = 'Bt1g1Z(1,2,3,4,5)   '
        sub_str  = 'qgBt1g1ZT(1,2,3,4,5)'

      case (121)
        chan_str = 'd db to g lp lm     '
        me_str   = 'Bt1g1Z(1,3,2,4,5)   '
        sub_str  = 'qqbBt1g1ZT(1,3,2,4,5)'

      case (122)
        chan_str = 'u ub to g lp lm     '
        me_str   = 'Bt1g1Z(1,3,2,4,5)   '
        sub_str  = 'qqbBt1g1ZT(1,3,2,4,5)'

      case (123)
        chan_str = 'g d to d lp lm      '
        me_str   = 'Bt1g1Z(2,1,3,4,5)   '
        sub_str  = 'gqBt1g1ZT(2,1,3,4,5)'

      case (124)
        chan_str = 'g u to u lp lm      '
        me_str   = 'Bt1g1Z(2,1,3,4,5)   '
        sub_str  = 'gqBt1g1ZT(2,1,3,4,5)'

      case (125)
        chan_str = 'db d to g lp lm     '
        me_str   = 'Bt1g1Z(2,3,1,4,5)   '
        sub_str  = 'qbqBt1g1ZT(2,3,1,4,5)'

      case (126)
        chan_str = 'ub u to g lp lm     '
        me_str   = 'Bt1g1Z(2,3,1,4,5)   '
        sub_str  = 'qbqBt1g1ZT(2,3,1,4,5)'

      case (127)
        chan_str = 'g db to db lp lm    '
        me_str   = 'Bt1g1Z(3,1,2,4,5)   '
        sub_str  = 'gqbBt1g1ZT(3,1,2,4,5)'

      case (128)
        chan_str = 'g ub to ub lp lm    '
        me_str   = 'Bt1g1Z(3,1,2,4,5)   '
        sub_str  = 'gqbBt1g1ZT(3,1,2,4,5)'

      case (129)
        chan_str = 'db g to db lp lm    '
        me_str   = 'Bt1g1Z(3,2,1,4,5)   '
        sub_str  = 'qbgBt1g1ZT(3,2,1,4,5)'

      case (130)
        chan_str = 'ub g to ub lp lm    '
        me_str   = 'Bt1g1Z(3,2,1,4,5)   '
        sub_str  = 'qbgBt1g1ZT(3,2,1,4,5)'

      case (131)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBt1g1ZT(1,2,3,4,5)'

      case (132)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBt1g1ZT(1,2,3,4,5)'

      case (133)
        chan_str = 'd d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt1g1ZT(1,2,3,4,5)'

      case (134)
        chan_str = 'd u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt1g1ZT(1,2,3,4,5)'

      case (135)
        chan_str = 'u d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt1g1ZT(1,2,3,4,5)'

      case (136)
        chan_str = 'u u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt1g1ZT(1,2,3,4,5)'

      case (137)
        chan_str = 'd db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt1g1ZT(1,2,3,4,5)'

      case (138)
        chan_str = 'd ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt1g1ZT(1,2,3,4,5)'

      case (139)
        chan_str = 'u db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt1g1ZT(1,2,3,4,5)'

      case (140)
        chan_str = 'u ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt1g1ZT(1,2,3,4,5)'

      case (141)
        chan_str = 'db d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt1g1ZT(1,2,3,4,5)'

      case (142)
        chan_str = 'db u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt1g1ZT(1,2,3,4,5)'

      case (143)
        chan_str = 'ub d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt1g1ZT(1,2,3,4,5)'

      case (144)
        chan_str = 'ub u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt1g1ZT(1,2,3,4,5)'

      case (145)
        chan_str = 'db db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt1g1ZT(1,2,3,4,5)'

      case (146)
        chan_str = 'db ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt1g1ZT(1,2,3,4,5)'

      case (147)
        chan_str = 'ub db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt1g1ZT(1,2,3,4,5)'

      case (148)
        chan_str = 'ub ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt1g1ZT(1,2,3,4,5)'

      case (149)
        chan_str = 'd g to d lp lm      '
        me_str   = 'Bh1g1Z(1,2,3,4,5)   '
        sub_str  = 'qgBh1g1ZT(1,2,3,4,5)'

      case (150)
        chan_str = 'u g to u lp lm      '
        me_str   = 'Bh1g1Z(1,2,3,4,5)   '
        sub_str  = 'qgBh1g1ZT(1,2,3,4,5)'

      case (151)
        chan_str = 'd db to g lp lm     '
        me_str   = 'Bh1g1Z(1,3,2,4,5)   '
        sub_str  = 'qqbBh1g1ZT(1,3,2,4,5)'

      case (152)
        chan_str = 'u ub to g lp lm     '
        me_str   = 'Bh1g1Z(1,3,2,4,5)   '
        sub_str  = 'qqbBh1g1ZT(1,3,2,4,5)'

      case (153)
        chan_str = 'g d to d lp lm      '
        me_str   = 'Bh1g1Z(2,1,3,4,5)   '
        sub_str  = 'gqBh1g1ZT(2,1,3,4,5)'

      case (154)
        chan_str = 'g u to u lp lm      '
        me_str   = 'Bh1g1Z(2,1,3,4,5)   '
        sub_str  = 'gqBh1g1ZT(2,1,3,4,5)'

      case (155)
        chan_str = 'db d to g lp lm     '
        me_str   = 'Bh1g1Z(2,3,1,4,5)   '
        sub_str  = 'qbqBh1g1ZT(2,3,1,4,5)'

      case (156)
        chan_str = 'ub u to g lp lm     '
        me_str   = 'Bh1g1Z(2,3,1,4,5)   '
        sub_str  = 'qbqBh1g1ZT(2,3,1,4,5)'

      case (157)
        chan_str = 'g db to db lp lm    '
        me_str   = 'Bh1g1Z(3,1,2,4,5)   '
        sub_str  = 'gqbBh1g1ZT(3,1,2,4,5)'

      case (158)
        chan_str = 'g ub to ub lp lm    '
        me_str   = 'Bh1g1Z(3,1,2,4,5)   '
        sub_str  = 'gqbBh1g1ZT(3,1,2,4,5)'

      case (159)
        chan_str = 'db g to db lp lm    '
        me_str   = 'Bh1g1Z(3,2,1,4,5)   '
        sub_str  = 'qbgBh1g1ZT(3,2,1,4,5)'

      case (160)
        chan_str = 'ub g to ub lp lm    '
        me_str   = 'Bh1g1Z(3,2,1,4,5)   '
        sub_str  = 'qbgBh1g1ZT(3,2,1,4,5)'

      case (161)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBh1g1ZT(1,2,3,4,5)'

      case (162)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBh1g1ZT(1,2,3,4,5)'

      case (163)
        chan_str = 'd d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh1g1ZT(1,2,3,4,5)'

      case (164)
        chan_str = 'd u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh1g1ZT(1,2,3,4,5)'

      case (165)
        chan_str = 'u d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh1g1ZT(1,2,3,4,5)'

      case (166)
        chan_str = 'u u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh1g1ZT(1,2,3,4,5)'

      case (167)
        chan_str = 'd db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh1g1ZT(1,2,3,4,5)'

      case (168)
        chan_str = 'd ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh1g1ZT(1,2,3,4,5)'

      case (169)
        chan_str = 'u db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh1g1ZT(1,2,3,4,5)'

      case (170)
        chan_str = 'u ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh1g1ZT(1,2,3,4,5)'

      case (171)
        chan_str = 'db d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh1g1ZT(1,2,3,4,5)'

      case (172)
        chan_str = 'db u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh1g1ZT(1,2,3,4,5)'

      case (173)
        chan_str = 'ub d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh1g1ZT(1,2,3,4,5)'

      case (174)
        chan_str = 'ub u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh1g1ZT(1,2,3,4,5)'

      case (175)
        chan_str = 'db db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh1g1ZT(1,2,3,4,5)'

      case (176)
        chan_str = 'db ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh1g1ZT(1,2,3,4,5)'

      case (177)
        chan_str = 'ub db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh1g1ZT(1,2,3,4,5)'

      case (178)
        chan_str = 'ub ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh1g1ZT(1,2,3,4,5)'

      case (179)
        chan_str = 'd db to lp lm       '
        me_str   = 'B0g2Z(1,2,3,4)      '
        sub_str  = 'qqbB0g2ZU(1,2,3,4)'

      case (180)
        chan_str = 'u ub to lp lm       '
        me_str   = 'B0g2Z(1,2,3,4)      '
        sub_str  = 'qqbB0g2ZU(1,2,3,4)'

      case (181)
        chan_str = 'db d to lp lm       '
        me_str   = 'B0g2Z(2,1,3,4)      '
        sub_str  = 'qbqB0g2ZU(2,1,3,4)'

      case (182)
        chan_str = 'ub u to lp lm       '
        me_str   = 'B0g2Z(2,1,3,4)      '
        sub_str  = 'qbqB0g2ZU(2,1,3,4)'

      case (183)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggB0g2ZU(1,2,3,4)'

      case (184)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggB0g2ZU(1,2,3,4)'

      case (185)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gqB0g2ZU(1,2,3,4)'

      case (186)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'gqB0g2ZU(1,2,3,4)'

      case (187)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbB0g2ZU(1,2,3,4)'

      case (188)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbB0g2ZU(1,2,3,4)'

      case (189)
        chan_str = 'd d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB0g2ZU(1,2,3,4)'

      case (190)
        chan_str = 'd u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB0g2ZU(1,2,3,4)'

      case (191)
        chan_str = 'u d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB0g2ZU(1,2,3,4)'

      case (192)
        chan_str = 'u u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpB0g2ZU(1,2,3,4)'

      case (193)
        chan_str = 'd db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB0g2ZU(1,2,3,4)'

      case (194)
        chan_str = 'd ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB0g2ZU(1,2,3,4)'

      case (195)
        chan_str = 'u db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB0g2ZU(1,2,3,4)'

      case (196)
        chan_str = 'u ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbB0g2ZU(1,2,3,4)'

      case (197)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgB0g2ZU(1,2,3,4)'

      case (198)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgB0g2ZU(1,2,3,4)'

      case (199)
        chan_str = 'd d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqB0g2ZU(1,2,3,4)'

      case (200)
        chan_str = 'u u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqB0g2ZU(1,2,3,4)'

      case (201)
        chan_str = 'db d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB0g2ZU(1,2,3,4)'

      case (202)
        chan_str = 'db u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB0g2ZU(1,2,3,4)'

      case (203)
        chan_str = 'ub d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB0g2ZU(1,2,3,4)'

      case (204)
        chan_str = 'ub u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpB0g2ZU(1,2,3,4)'

      case (205)
        chan_str = 'db db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB0g2ZU(1,2,3,4)'

      case (206)
        chan_str = 'db ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB0g2ZU(1,2,3,4)'

      case (207)
        chan_str = 'ub db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB0g2ZU(1,2,3,4)'

      case (208)
        chan_str = 'ub ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbB0g2ZU(1,2,3,4)'

      case (209)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgB0g2ZU(1,2,3,4)'

      case (210)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgB0g2ZU(1,2,3,4)'

      case (211)
        chan_str = 'db db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqbB0g2ZU(1,2,3,4)'

      case (212)
        chan_str = 'ub ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqbB0g2ZU(1,2,3,4)'

      case (213)
        chan_str = 'd db to lp lm       '
        me_str   = 'Bt0g2Z(1,2,3,4)     '
        sub_str  = 'qqbBt0g2ZU(1,2,3,4)'

      case (214)
        chan_str = 'u ub to lp lm       '
        me_str   = 'Bt0g2Z(1,2,3,4)     '
        sub_str  = 'qqbBt0g2ZU(1,2,3,4)'

      case (215)
        chan_str = 'db d to lp lm       '
        me_str   = 'Bt0g2Z(2,1,3,4)     '
        sub_str  = 'qbqBt0g2ZU(2,1,3,4)'

      case (216)
        chan_str = 'ub u to lp lm       '
        me_str   = 'Bt0g2Z(2,1,3,4)     '
        sub_str  = 'qbqBt0g2ZU(2,1,3,4)'

      case (217)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBt0g2ZU(1,2,3,4)'

      case (218)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBt0g2ZU(1,2,3,4)'

      case (219)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gqBt0g2ZU(1,2,3,4)'

      case (220)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'gqBt0g2ZU(1,2,3,4)'

      case (221)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbBt0g2ZU(1,2,3,4)'

      case (222)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbBt0g2ZU(1,2,3,4)'

      case (223)
        chan_str = 'd d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt0g2ZU(1,2,3,4)'

      case (224)
        chan_str = 'd u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt0g2ZU(1,2,3,4)'

      case (225)
        chan_str = 'u d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt0g2ZU(1,2,3,4)'

      case (226)
        chan_str = 'u u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBt0g2ZU(1,2,3,4)'

      case (227)
        chan_str = 'd db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt0g2ZU(1,2,3,4)'

      case (228)
        chan_str = 'd ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt0g2ZU(1,2,3,4)'

      case (229)
        chan_str = 'u db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt0g2ZU(1,2,3,4)'

      case (230)
        chan_str = 'u ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBt0g2ZU(1,2,3,4)'

      case (231)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgBt0g2ZU(1,2,3,4)'

      case (232)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgBt0g2ZU(1,2,3,4)'

      case (233)
        chan_str = 'd d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqBt0g2ZU(1,2,3,4)'

      case (234)
        chan_str = 'u u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqBt0g2ZU(1,2,3,4)'

      case (235)
        chan_str = 'db d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt0g2ZU(1,2,3,4)'

      case (236)
        chan_str = 'db u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt0g2ZU(1,2,3,4)'

      case (237)
        chan_str = 'ub d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt0g2ZU(1,2,3,4)'

      case (238)
        chan_str = 'ub u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBt0g2ZU(1,2,3,4)'

      case (239)
        chan_str = 'db db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt0g2ZU(1,2,3,4)'

      case (240)
        chan_str = 'db ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt0g2ZU(1,2,3,4)'

      case (241)
        chan_str = 'ub db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt0g2ZU(1,2,3,4)'

      case (242)
        chan_str = 'ub ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBt0g2ZU(1,2,3,4)'

      case (243)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgBt0g2ZU(1,2,3,4)'

      case (244)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgBt0g2ZU(1,2,3,4)'

      case (245)
        chan_str = 'db db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqbBt0g2ZU(1,2,3,4)'

      case (246)
        chan_str = 'ub ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqbBt0g2ZU(1,2,3,4)'

      case (247)
        chan_str = 'd db to lp lm       '
        me_str   = 'Bh0g2Z(1,2,3,4)     '
        sub_str  = 'qqbBh0g2ZU(1,2,3,4)'

      case (248)
        chan_str = 'u ub to lp lm       '
        me_str   = 'Bh0g2Z(1,2,3,4)     '
        sub_str  = 'qqbBh0g2ZU(1,2,3,4)'

      case (249)
        chan_str = 'db d to lp lm       '
        me_str   = 'Bh0g2Z(2,1,3,4)     '
        sub_str  = 'qbqBh0g2ZU(2,1,3,4)'

      case (250)
        chan_str = 'ub u to lp lm       '
        me_str   = 'Bh0g2Z(2,1,3,4)     '
        sub_str  = 'qbqBh0g2ZU(2,1,3,4)'

      case (251)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBh0g2ZU(1,2,3,4)'

      case (252)
        chan_str = 'g g subtraction     '
        me_str   = '                    '
        sub_str  = 'ggBh0g2ZU(1,2,3,4)'

      case (253)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gqBh0g2ZU(1,2,3,4)'

      case (254)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'gqBh0g2ZU(1,2,3,4)'

      case (255)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbBh0g2ZU(1,2,3,4)'

      case (256)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbBh0g2ZU(1,2,3,4)'

      case (257)
        chan_str = 'd d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh0g2ZU(1,2,3,4)'

      case (258)
        chan_str = 'd u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh0g2ZU(1,2,3,4)'

      case (259)
        chan_str = 'u d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh0g2ZU(1,2,3,4)'

      case (260)
        chan_str = 'u u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpBh0g2ZU(1,2,3,4)'

      case (261)
        chan_str = 'd db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh0g2ZU(1,2,3,4)'

      case (262)
        chan_str = 'd ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh0g2ZU(1,2,3,4)'

      case (263)
        chan_str = 'u db subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh0g2ZU(1,2,3,4)'

      case (264)
        chan_str = 'u ub subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbBh0g2ZU(1,2,3,4)'

      case (265)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgBh0g2ZU(1,2,3,4)'

      case (266)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgBh0g2ZU(1,2,3,4)'

      case (267)
        chan_str = 'd d subtraction     '
        me_str   = '                    '
        sub_str  = 'qqBh0g2ZU(1,2,3,4)'

      case (268)
        chan_str = 'u u subtraction     '
        me_str   = '                    '
        sub_str  = 'qqBh0g2ZU(1,2,3,4)'

      case (269)
        chan_str = 'db d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh0g2ZU(1,2,3,4)'

      case (270)
        chan_str = 'db u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh0g2ZU(1,2,3,4)'

      case (271)
        chan_str = 'ub d subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh0g2ZU(1,2,3,4)'

      case (272)
        chan_str = 'ub u subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpBh0g2ZU(1,2,3,4)'

      case (273)
        chan_str = 'db db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh0g2ZU(1,2,3,4)'

      case (274)
        chan_str = 'db ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh0g2ZU(1,2,3,4)'

      case (275)
        chan_str = 'ub db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh0g2ZU(1,2,3,4)'

      case (276)
        chan_str = 'ub ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbBh0g2ZU(1,2,3,4)'

      case (277)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgBh0g2ZU(1,2,3,4)'

      case (278)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgBh0g2ZU(1,2,3,4)'

      case (279)
        chan_str = 'db db subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqbBh0g2ZU(1,2,3,4)'

      case (280)
        chan_str = 'ub ub subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqbBh0g2ZU(1,2,3,4)'

      case default
        print*, 'getchannelZ: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtZ(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtZ = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (31)
        ! [g, g, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (32)
        ! [g, g, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (35)
        ! [g, g, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (36)
        ! [g, g, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (45)
        ! [gt, gt, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (46)
        ! [gt, gt, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (49)
        ! [gt, gt, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (50)
        ! [gt, gt, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (61)
        ! [d, d, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (64)
        ! [u, u, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (73)
        ! [db, db, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (76)
        ! [ub, ub, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (83)
        ! [d, d, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (84)
        ! [u, u, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (87)
        ! [db, db, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case (88)
        ! [ub, ub, lp, lm]
        LIPSwgtZ = weight_lips((/ 3,4 /))

      case default
        LIPSwgtZ = 1

      end select
      end
