      function sigBZ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigBZ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,4,ipass)
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(4, (/ 1, 2, 3, 4 /) )
#endif 

c--- d db to lp lm 
      if (qactive_chan(1).and.qselect_chan(1)) then
        current_chan = 1
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B0g0Z(1,2,3,4)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to lp lm 
      if (qactive_chan(2).and.qselect_chan(2)) then
        current_chan = 2
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 1,2,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B0g0Z(1,2,3,4)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to lp lm 
      if (qactive_chan(3).and.qselect_chan(3)) then
        current_chan = 3
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B0g0Z(2,1,3,4)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to lp lm 
      if (qactive_chan(4).and.qselect_chan(4)) then
        current_chan = 4
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(4, (/ 2,1,3,4 /))
        call getqcdnorm(ix,partons,factor, 4, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = B0g0Z(2,1,3,4)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigBZ=rnorm*wtsum

      return
      end
