      subroutine getlumiZJ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,   13,   27,   73,  103,  133,  163,  177,          
     &          191,  205,  206,  245,  246,  285,  301,  317,          
     &          347,  377,  391,  405,  435,  481,  482,  521,          
     &          522,  561,  562,  581,  597,  613,  617,  651,          
     &          685,  719,  731,  733,  769,  781,  783,  819,          
     &          831,  833)
!       [10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,   14,   28,   74,  104,  134,  164,  178,          
     &          192,  207,  208,  247,  248,  286,  302,  318,          
     &          348,  378,  392,  406,  436,  483,  484,  523,          
     &          524,  563,  564,  582,  598,  614,  618,  652,          
     &          686,  720,  732,  734,  770,  782,  784,  820,          
     &          832,  834)
!       [20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    3,   15,   29,   49,   50,   65,   75,  105,          
     &          135,  165,  179,  193,  217,  218,  257,  258,          
     &          287,  303,  319,  349,  379,  393,  407,  437,          
     &          457,  458,  497,  498,  537,  538,  569,  585,          
     &          601,  619,  653,  687,  721,  771,  821)
!       [10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    4,   16,   30,   51,   52,   66,   76,  106,          
     &          136,  166,  180,  194,  219,  220,  259,  260,          
     &          288,  304,  320,  350,  380,  394,  408,  438,          
     &          459,  460,  499,  500,  539,  540,  570,  586,          
     &          602,  620,  654,  688,  722,  772,  822)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (    5,   17,   31,   77,  107,  137,  167,  181,          
     &          195,  221,  222,  261,  262,  291,  307,  321,          
     &          351,  381,  395,  409,  439,  473,  474,  513,          
     &          514,  553,  554,  577,  593,  609,  621,  655,          
     &          689,  723,  739,  741,  773,  789,  791,  823,          
     &          839,  841)
!       [0, 10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (    6,   18,   32,   78,  108,  138,  168,  182,          
     &          196,  223,  224,  263,  264,  292,  308,  322,          
     &          352,  382,  396,  410,  440,  475,  476,  515,          
     &          516,  555,  556,  578,  594,  610,  622,  656,          
     &          690,  724,  740,  742,  774,  790,  792,  824,          
     &          840,  842)
!       [0, 20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (    7,   19,   33,   53,   54,   69,   79,  109,          
     &          139,  169,  183,  197,  225,  226,  265,  266,          
     &          293,  309,  323,  353,  383,  397,  411,  441,          
     &          461,  462,  501,  502,  541,  542,  573,  589,          
     &          605,  623,  657,  691,  725,  775,  825)
!       [-10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    8,   20,   34,   55,   56,   70,   80,  110,          
     &          140,  170,  184,  198,  227,  228,  267,  268,          
     &          294,  310,  324,  354,  384,  398,  412,  442,          
     &          463,  464,  503,  504,  543,  544,  574,  590,          
     &          606,  624,  658,  692,  726,  776,  826)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (    9,   23,   37,   81,  111,  141,  173,  187,          
     &          201,  229,  230,  269,  270,  295,  311,  327,          
     &          357,  387,  401,  415,  445,  477,  478,  517,          
     &          518,  557,  558,  579,  595,  611,  625,  659,          
     &          693,  727,  743,  745,  777,  793,  795,  827,          
     &          843,  845)
!       [0, -10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   10,   24,   38,   82,  112,  142,  174,  188,          
     &          202,  231,  232,  271,  272,  296,  312,  328,          
     &          358,  388,  402,  416,  446,  479,  480,  519,          
     &          520,  559,  560,  580,  596,  612,  626,  660,          
     &          694,  728,  744,  746,  778,  794,  796,  828,          
     &          844,  846)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   11,   25,   39,   83,  113,  143,  175,  189,          
     &          203,  233,  234,  273,  274,  297,  313,  329,          
     &          359,  389,  403,  417,  447,  485,  486,  525,          
     &          526,  565,  566,  583,  599,  615,  627,  661,          
     &          695,  729,  735,  737,  779,  785,  787,  829,          
     &          835,  837)
!       [-10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   12,   26,   40,   84,  114,  144,  176,  190,          
     &          204,  235,  236,  275,  276,  298,  314,  330,          
     &          360,  390,  404,  418,  448,  487,  488,  527,          
     &          528,  567,  568,  584,  600,  616,  628,  662,          
     &          696,  730,  736,  738,  780,  786,  788,  830,          
     &          836,  838)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   21,   22,   35,   36,   85,   86,  115,  116,          
     &          145,  146,  171,  172,  185,  186,  199,  200,          
     &          325,  326,  355,  356,  385,  386,  399,  400,          
     &          413,  414,  443,  444,  629,  630,  663,  664,          
     &          697,  698,  747,  748,  797,  798,  847,  848)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   41,   91,  121,  151,  209,  249,  335,  365,          
     &          423,  449,  489,  529,  635,  669,  703,  753,          
     &          803,  853)
!       [11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   42,   92,  122,  152,  210,  250,  336,  366,          
     &          424,  450,  490,  530,  636,  670,  704,  754,          
     &          804,  854)
!       [11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   43,   93,  123,  153,  211,  251,  337,  367,          
     &          425,  451,  491,  531,  637,  671,  705,  755,          
     &          805,  855)
!       [21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   44,   94,  124,  154,  212,  252,  338,  368,          
     &          426,  452,  492,  532,  638,  672,  706,  756,          
     &          806,  856)
!       [21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   45,   87,  117,  147,  213,  253,  331,  361,          
     &          419,  453,  493,  533,  631,  665,  699,  749,          
     &          799,  849)
!       [11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   46,   88,  118,  148,  214,  254,  332,  362,          
     &          420,  454,  494,  534,  632,  666,  700,  750,          
     &          800,  850)
!       [11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   47,   89,  119,  149,  215,  255,  333,  363,          
     &          421,  455,  495,  535,  633,  667,  701,  751,          
     &          801,  851)
!       [21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   48,   90,  120,  150,  216,  256,  334,  364,          
     &          422,  456,  496,  536,  634,  668,  702,  752,          
     &          802,  852)
!       [21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   57,   99,  129,  159,  237,  277,  343,  373,          
     &          431,  465,  505,  545,  645,  679,  713,  763,          
     &          813,  863)
!       [-11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   58,  100,  130,  160,  238,  278,  344,  374,          
     &          432,  466,  506,  546,  646,  680,  714,  764,          
     &          814,  864)
!       [-11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   59,  101,  131,  161,  239,  279,  345,  375,          
     &          433,  467,  507,  547,  647,  681,  715,  765,          
     &          815,  865)
!       [-21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   60,  102,  132,  162,  240,  280,  346,  376,          
     &          434,  468,  508,  548,  648,  682,  716,  766,          
     &          816,  866)
!       [-21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   61,   95,  125,  155,  241,  281,  339,  369,          
     &          427,  469,  509,  549,  641,  675,  709,  759,          
     &          809,  859)
!       [-11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   62,   96,  126,  156,  242,  282,  340,  370,          
     &          428,  470,  510,  550,  642,  676,  710,  760,          
     &          810,  860)
!       [-11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   63,   97,  127,  157,  243,  283,  341,  371,          
     &          429,  471,  511,  551,  643,  677,  711,  761,          
     &          811,  861)
!       [-21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   64,   98,  128,  158,  244,  284,  342,  372,          
     &          430,  472,  512,  552,  644,  678,  712,  762,          
     &          812,  862)
!       [-21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   67,  289,  305,  571,  587,  603,  639,  673,          
     &          707,  757,  807,  857)
!       [10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   68,  290,  306,  572,  588,  604,  640,  674,          
     &          708,  758,  808,  858)
!       [20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   71,  299,  315,  575,  591,  607,  649,  683,          
     &          717,  767,  817,  867)
!       [-10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   72,  300,  316,  576,  592,  608,  650,  684,          
     &          718,  768,  818,  868)
!       [-20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case default
          print*, "getlumiZJ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiZJ



      function getlumiidZJ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,   13,   27,   73,  103,  133,  163,  177,
     &          191,  205,  206,  245,  246,  285,  301,  317,
     &          347,  377,  391,  405,  435,  481,  482,  521,
     &          522,  561,  562,  581,  597,  613,  617,  651,
     &          685,  719,  731,  733,  769,  781,  783,  819,
     &          831,  833)
          id  = 1
          ip1 = 10
          ip2 = 0

        case (    2,   14,   28,   74,  104,  134,  164,  178,
     &          192,  207,  208,  247,  248,  286,  302,  318,
     &          348,  378,  392,  406,  436,  483,  484,  523,
     &          524,  563,  564,  582,  598,  614,  618,  652,
     &          686,  720,  732,  734,  770,  782,  784,  820,
     &          832,  834)
          id  = 2
          ip1 = 20
          ip2 = 0

        case (    3,   15,   29,   49,   50,   65,   75,  105,
     &          135,  165,  179,  193,  217,  218,  257,  258,
     &          287,  303,  319,  349,  379,  393,  407,  437,
     &          457,  458,  497,  498,  537,  538,  569,  585,
     &          601,  619,  653,  687,  721,  771,  821)
          id  = 3
          ip1 = 10
          ip2 = -10

        case (    4,   16,   30,   51,   52,   66,   76,  106,
     &          136,  166,  180,  194,  219,  220,  259,  260,
     &          288,  304,  320,  350,  380,  394,  408,  438,
     &          459,  460,  499,  500,  539,  540,  570,  586,
     &          602,  620,  654,  688,  722,  772,  822)
          id  = 4
          ip1 = 20
          ip2 = -20

        case (    5,   17,   31,   77,  107,  137,  167,  181,
     &          195,  221,  222,  261,  262,  291,  307,  321,
     &          351,  381,  395,  409,  439,  473,  474,  513,
     &          514,  553,  554,  577,  593,  609,  621,  655,
     &          689,  723,  739,  741,  773,  789,  791,  823,
     &          839,  841)
          id  = 5
          ip1 = 0
          ip2 = 10

        case (    6,   18,   32,   78,  108,  138,  168,  182,
     &          196,  223,  224,  263,  264,  292,  308,  322,
     &          352,  382,  396,  410,  440,  475,  476,  515,
     &          516,  555,  556,  578,  594,  610,  622,  656,
     &          690,  724,  740,  742,  774,  790,  792,  824,
     &          840,  842)
          id  = 6
          ip1 = 0
          ip2 = 20

        case (    7,   19,   33,   53,   54,   69,   79,  109,
     &          139,  169,  183,  197,  225,  226,  265,  266,
     &          293,  309,  323,  353,  383,  397,  411,  441,
     &          461,  462,  501,  502,  541,  542,  573,  589,
     &          605,  623,  657,  691,  725,  775,  825)
          id  = 7
          ip1 = -10
          ip2 = 10

        case (    8,   20,   34,   55,   56,   70,   80,  110,
     &          140,  170,  184,  198,  227,  228,  267,  268,
     &          294,  310,  324,  354,  384,  398,  412,  442,
     &          463,  464,  503,  504,  543,  544,  574,  590,
     &          606,  624,  658,  692,  726,  776,  826)
          id  = 8
          ip1 = -20
          ip2 = 20

        case (    9,   23,   37,   81,  111,  141,  173,  187,
     &          201,  229,  230,  269,  270,  295,  311,  327,
     &          357,  387,  401,  415,  445,  477,  478,  517,
     &          518,  557,  558,  579,  595,  611,  625,  659,
     &          693,  727,  743,  745,  777,  793,  795,  827,
     &          843,  845)
          id  = 9
          ip1 = 0
          ip2 = -10

        case (   10,   24,   38,   82,  112,  142,  174,  188,
     &          202,  231,  232,  271,  272,  296,  312,  328,
     &          358,  388,  402,  416,  446,  479,  480,  519,
     &          520,  559,  560,  580,  596,  612,  626,  660,
     &          694,  728,  744,  746,  778,  794,  796,  828,
     &          844,  846)
          id  = 10
          ip1 = 0
          ip2 = -20

        case (   11,   25,   39,   83,  113,  143,  175,  189,
     &          203,  233,  234,  273,  274,  297,  313,  329,
     &          359,  389,  403,  417,  447,  485,  486,  525,
     &          526,  565,  566,  583,  599,  615,  627,  661,
     &          695,  729,  735,  737,  779,  785,  787,  829,
     &          835,  837)
          id  = 11
          ip1 = -10
          ip2 = 0

        case (   12,   26,   40,   84,  114,  144,  176,  190,
     &          204,  235,  236,  275,  276,  298,  314,  330,
     &          360,  390,  404,  418,  448,  487,  488,  527,
     &          528,  567,  568,  584,  600,  616,  628,  662,
     &          696,  730,  736,  738,  780,  786,  788,  830,
     &          836,  838)
          id  = 12
          ip1 = -20
          ip2 = 0

        case (   21,   22,   35,   36,   85,   86,  115,  116,
     &          145,  146,  171,  172,  185,  186,  199,  200,
     &          325,  326,  355,  356,  385,  386,  399,  400,
     &          413,  414,  443,  444,  629,  630,  663,  664,
     &          697,  698,  747,  748,  797,  798,  847,  848)
          id  = 13
          ip1 = 0
          ip2 = 0

        case (   41,   91,  121,  151,  209,  249,  335,  365,
     &          423,  449,  489,  529,  635,  669,  703,  753,
     &          803,  853)
          id  = 14
          ip1 = 11
          ip2 = -11

        case (   42,   92,  122,  152,  210,  250,  336,  366,
     &          424,  450,  490,  530,  636,  670,  704,  754,
     &          804,  854)
          id  = 15
          ip1 = 11
          ip2 = -21

        case (   43,   93,  123,  153,  211,  251,  337,  367,
     &          425,  451,  491,  531,  637,  671,  705,  755,
     &          805,  855)
          id  = 16
          ip1 = 21
          ip2 = -11

        case (   44,   94,  124,  154,  212,  252,  338,  368,
     &          426,  452,  492,  532,  638,  672,  706,  756,
     &          806,  856)
          id  = 17
          ip1 = 21
          ip2 = -21

        case (   45,   87,  117,  147,  213,  253,  331,  361,
     &          419,  453,  493,  533,  631,  665,  699,  749,
     &          799,  849)
          id  = 18
          ip1 = 11
          ip2 = 11

        case (   46,   88,  118,  148,  214,  254,  332,  362,
     &          420,  454,  494,  534,  632,  666,  700,  750,
     &          800,  850)
          id  = 19
          ip1 = 11
          ip2 = 21

        case (   47,   89,  119,  149,  215,  255,  333,  363,
     &          421,  455,  495,  535,  633,  667,  701,  751,
     &          801,  851)
          id  = 20
          ip1 = 21
          ip2 = 11

        case (   48,   90,  120,  150,  216,  256,  334,  364,
     &          422,  456,  496,  536,  634,  668,  702,  752,
     &          802,  852)
          id  = 21
          ip1 = 21
          ip2 = 21

        case (   57,   99,  129,  159,  237,  277,  343,  373,
     &          431,  465,  505,  545,  645,  679,  713,  763,
     &          813,  863)
          id  = 22
          ip1 = -11
          ip2 = -11

        case (   58,  100,  130,  160,  238,  278,  344,  374,
     &          432,  466,  506,  546,  646,  680,  714,  764,
     &          814,  864)
          id  = 23
          ip1 = -11
          ip2 = -21

        case (   59,  101,  131,  161,  239,  279,  345,  375,
     &          433,  467,  507,  547,  647,  681,  715,  765,
     &          815,  865)
          id  = 24
          ip1 = -21
          ip2 = -11

        case (   60,  102,  132,  162,  240,  280,  346,  376,
     &          434,  468,  508,  548,  648,  682,  716,  766,
     &          816,  866)
          id  = 25
          ip1 = -21
          ip2 = -21

        case (   61,   95,  125,  155,  241,  281,  339,  369,
     &          427,  469,  509,  549,  641,  675,  709,  759,
     &          809,  859)
          id  = 26
          ip1 = -11
          ip2 = 11

        case (   62,   96,  126,  156,  242,  282,  340,  370,
     &          428,  470,  510,  550,  642,  676,  710,  760,
     &          810,  860)
          id  = 27
          ip1 = -11
          ip2 = 21

        case (   63,   97,  127,  157,  243,  283,  341,  371,
     &          429,  471,  511,  551,  643,  677,  711,  761,
     &          811,  861)
          id  = 28
          ip1 = -21
          ip2 = 11

        case (   64,   98,  128,  158,  244,  284,  342,  372,
     &          430,  472,  512,  552,  644,  678,  712,  762,
     &          812,  862)
          id  = 29
          ip1 = -21
          ip2 = 21

        case (   67,  289,  305,  571,  587,  603,  639,  673,
     &          707,  757,  807,  857)
          id  = 30
          ip1 = 10
          ip2 = 10

        case (   68,  290,  306,  572,  588,  604,  640,  674,
     &          708,  758,  808,  858)
          id  = 31
          ip1 = 20
          ip2 = 20

        case (   71,  299,  315,  575,  591,  607,  649,  683,
     &          717,  767,  817,  867)
          id  = 32
          ip1 = -10
          ip2 = -10

        case (   72,  300,  316,  576,  592,  608,  650,  684,
     &          718,  768,  818,  868)
          id  = 33
          ip1 = -20
          ip2 = -20

        case default
          print*, "getlumiidZJ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidZJ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiZJ()
        use PineAPPL_mod
        use CKM_mod
!       [10, 0]
        call register_lumi_pine(
     &         [    1,   13,   27,   73,  103,  133,  163,  177,
     &            191,  205,  206,  245,  246,  285,  301,  317,
     &            347,  377,  391,  405,  435,  481,  482,  521,
     &            522,  561,  562,  581,  597,  613,  617,  651,
     &            685,  719,  731,  733,  769,  781,  783,  819,
     &            831,  833],
     &         3,
     &         [    1,   21,    3,   21,    5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 0]
        call register_lumi_pine(
     &         [    2,   14,   28,   74,  104,  134,  164,  178,
     &            192,  207,  208,  247,  248,  286,  302,  318,
     &            348,  378,  392,  406,  436,  483,  484,  523,
     &            524,  563,  564,  582,  598,  614,  618,  652,
     &            686,  720,  732,  734,  770,  782,  784,  820,
     &            832,  834],
     &         2,
     &         [    2,   21,    4,   21],
     &         [  1d0,  1d0]
     &       )

!       [10, -10]
        call register_lumi_pine(
     &         [    3,   15,   29,   49,   50,   65,   75,  105,
     &            135,  165,  179,  193,  217,  218,  257,  258,
     &            287,  303,  319,  349,  379,  393,  407,  437,
     &            457,  458,  497,  498,  537,  538,  569,  585,
     &            601,  619,  653,  687,  721,  771,  821],
     &         3,
     &         [    1,   -1,    3,   -3,    5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [    4,   16,   30,   51,   52,   66,   76,  106,
     &            136,  166,  180,  194,  219,  220,  259,  260,
     &            288,  304,  320,  350,  380,  394,  408,  438,
     &            459,  460,  499,  500,  539,  540,  570,  586,
     &            602,  620,  654,  688,  722,  772,  822],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [0, 10]
        call register_lumi_pine(
     &         [    5,   17,   31,   77,  107,  137,  167,  181,
     &            195,  221,  222,  261,  262,  291,  307,  321,
     &            351,  381,  395,  409,  439,  473,  474,  513,
     &            514,  553,  554,  577,  593,  609,  621,  655,
     &            689,  723,  739,  741,  773,  789,  791,  823,
     &            839,  841],
     &         3,
     &         [   21,    1,   21,    3,   21,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, 20]
        call register_lumi_pine(
     &         [    6,   18,   32,   78,  108,  138,  168,  182,
     &            196,  223,  224,  263,  264,  292,  308,  322,
     &            352,  382,  396,  410,  440,  475,  476,  515,
     &            516,  555,  556,  578,  594,  610,  622,  656,
     &            690,  724,  740,  742,  774,  790,  792,  824,
     &            840,  842],
     &         2,
     &         [   21,    2,   21,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 10]
        call register_lumi_pine(
     &         [    7,   19,   33,   53,   54,   69,   79,  109,
     &            139,  169,  183,  197,  225,  226,  265,  266,
     &            293,  309,  323,  353,  383,  397,  411,  441,
     &            461,  462,  501,  502,  541,  542,  573,  589,
     &            605,  623,  657,  691,  725,  775,  825],
     &         3,
     &         [   -1,    1,   -3,    3,   -5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [    8,   20,   34,   55,   56,   70,   80,  110,
     &            140,  170,  184,  198,  227,  228,  267,  268,
     &            294,  310,  324,  354,  384,  398,  412,  442,
     &            463,  464,  503,  504,  543,  544,  574,  590,
     &            606,  624,  658,  692,  726,  776,  826],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [0, -10]
        call register_lumi_pine(
     &         [    9,   23,   37,   81,  111,  141,  173,  187,
     &            201,  229,  230,  269,  270,  295,  311,  327,
     &            357,  387,  401,  415,  445,  477,  478,  517,
     &            518,  557,  558,  579,  595,  611,  625,  659,
     &            693,  727,  743,  745,  777,  793,  795,  827,
     &            843,  845],
     &         3,
     &         [   21,   -1,   21,   -3,   21,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [   10,   24,   38,   82,  112,  142,  174,  188,
     &            202,  231,  232,  271,  272,  296,  312,  328,
     &            358,  388,  402,  416,  446,  479,  480,  519,
     &            520,  559,  560,  580,  596,  612,  626,  660,
     &            694,  728,  744,  746,  778,  794,  796,  828,
     &            844,  846],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 0]
        call register_lumi_pine(
     &         [   11,   25,   39,   83,  113,  143,  175,  189,
     &            203,  233,  234,  273,  274,  297,  313,  329,
     &            359,  389,  403,  417,  447,  485,  486,  525,
     &            526,  565,  566,  583,  599,  615,  627,  661,
     &            695,  729,  735,  737,  779,  785,  787,  829,
     &            835,  837],
     &         3,
     &         [   -1,   21,   -3,   21,   -5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [   12,   26,   40,   84,  114,  144,  176,  190,
     &            204,  235,  236,  275,  276,  298,  314,  330,
     &            360,  390,  404,  418,  448,  487,  488,  527,
     &            528,  567,  568,  584,  600,  616,  628,  662,
     &            696,  730,  736,  738,  780,  786,  788,  830,
     &            836,  838],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [0, 0]
        call register_lumi_pine(
     &         [   21,   22,   35,   36,   85,   86,  115,  116,
     &            145,  146,  171,  172,  185,  186,  199,  200,
     &            325,  326,  355,  356,  385,  386,  399,  400,
     &            413,  414,  443,  444,  629,  630,  663,  664,
     &            697,  698,  747,  748,  797,  798,  847,  848],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [11, -11]
        call register_lumi_pine(
     &         [   41,   91,  121,  151,  209,  249,  335,  365,
     &            423,  449,  489,  529,  635,  669,  703,  753,
     &            803,  853],
     &         9,
     &         [    1,   -1,    1,   -3,    1,   -5,    3,   -1,
     &              3,   -3,    3,   -5,    5,   -1,    5,   -3,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, -21]
        call register_lumi_pine(
     &         [   42,   92,  122,  152,  210,  250,  336,  366,
     &            424,  450,  490,  530,  636,  670,  704,  754,
     &            804,  854],
     &         6,
     &         [    1,   -2,    1,   -4,    3,   -2,    3,   -4,
     &              5,   -2,    5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -11]
        call register_lumi_pine(
     &         [   43,   93,  123,  153,  211,  251,  337,  367,
     &            425,  451,  491,  531,  637,  671,  705,  755,
     &            805,  855],
     &         6,
     &         [    2,   -1,    2,   -3,    2,   -5,    4,   -1,
     &              4,   -3,    4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -21]
        call register_lumi_pine(
     &         [   44,   94,  124,  154,  212,  252,  338,  368,
     &            426,  452,  492,  532,  638,  672,  706,  756,
     &            806,  856],
     &         4,
     &         [    2,   -2,    2,   -4,    4,   -2,    4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [11, 11]
        call register_lumi_pine(
     &         [   45,   87,  117,  147,  213,  253,  331,  361,
     &            419,  453,  493,  533,  631,  665,  699,  749,
     &            799,  849],
     &         9,
     &         [    1,    1,    1,    3,    1,    5,    3,    1,
     &              3,    3,    3,    5,    5,    1,    5,    3,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, 21]
        call register_lumi_pine(
     &         [   46,   88,  118,  148,  214,  254,  332,  362,
     &            420,  454,  494,  534,  632,  666,  700,  750,
     &            800,  850],
     &         6,
     &         [    1,    2,    1,    4,    3,    2,    3,    4,
     &              5,    2,    5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 11]
        call register_lumi_pine(
     &         [   47,   89,  119,  149,  215,  255,  333,  363,
     &            421,  455,  495,  535,  633,  667,  701,  751,
     &            801,  851],
     &         6,
     &         [    2,    1,    2,    3,    2,    5,    4,    1,
     &              4,    3,    4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 21]
        call register_lumi_pine(
     &         [   48,   90,  120,  150,  216,  256,  334,  364,
     &            422,  456,  496,  536,  634,  668,  702,  752,
     &            802,  852],
     &         4,
     &         [    2,    2,    2,    4,    4,    2,    4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, -11]
        call register_lumi_pine(
     &         [   57,   99,  129,  159,  237,  277,  343,  373,
     &            431,  465,  505,  545,  645,  679,  713,  763,
     &            813,  863],
     &         9,
     &         [   -1,   -1,   -1,   -3,   -1,   -5,   -3,   -1,
     &             -3,   -3,   -3,   -5,   -5,   -1,   -5,   -3,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, -21]
        call register_lumi_pine(
     &         [   58,  100,  130,  160,  238,  278,  344,  374,
     &            432,  466,  506,  546,  646,  680,  714,  764,
     &            814,  864],
     &         6,
     &         [   -1,   -2,   -1,   -4,   -3,   -2,   -3,   -4,
     &             -5,   -2,   -5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -11]
        call register_lumi_pine(
     &         [   59,  101,  131,  161,  239,  279,  345,  375,
     &            433,  467,  507,  547,  647,  681,  715,  765,
     &            815,  865],
     &         6,
     &         [   -2,   -1,   -2,   -3,   -2,   -5,   -4,   -1,
     &             -4,   -3,   -4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -21]
        call register_lumi_pine(
     &         [   60,  102,  132,  162,  240,  280,  346,  376,
     &            434,  468,  508,  548,  648,  682,  716,  766,
     &            816,  866],
     &         4,
     &         [   -2,   -2,   -2,   -4,   -4,   -2,   -4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, 11]
        call register_lumi_pine(
     &         [   61,   95,  125,  155,  241,  281,  339,  369,
     &            427,  469,  509,  549,  641,  675,  709,  759,
     &            809,  859],
     &         9,
     &         [   -1,    1,   -1,    3,   -1,    5,   -3,    1,
     &             -3,    3,   -3,    5,   -5,    1,   -5,    3,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, 21]
        call register_lumi_pine(
     &         [   62,   96,  126,  156,  242,  282,  340,  370,
     &            428,  470,  510,  550,  642,  676,  710,  760,
     &            810,  860],
     &         6,
     &         [   -1,    2,   -1,    4,   -3,    2,   -3,    4,
     &             -5,    2,   -5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 11]
        call register_lumi_pine(
     &         [   63,   97,  127,  157,  243,  283,  341,  371,
     &            429,  471,  511,  551,  643,  677,  711,  761,
     &            811,  861],
     &         6,
     &         [   -2,    1,   -2,    3,   -2,    5,   -4,    1,
     &             -4,    3,   -4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 21]
        call register_lumi_pine(
     &         [   64,   98,  128,  158,  244,  284,  342,  372,
     &            430,  472,  512,  552,  644,  678,  712,  762,
     &            812,  862],
     &         4,
     &         [   -2,    2,   -2,    4,   -4,    2,   -4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [10, 10]
        call register_lumi_pine(
     &         [   67,  289,  305,  571,  587,  603,  639,  673,
     &            707,  757,  807,  857],
     &         3,
     &         [    1,    1,    3,    3,    5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 20]
        call register_lumi_pine(
     &         [   68,  290,  306,  572,  588,  604,  640,  674,
     &            708,  758,  808,  858],
     &         2,
     &         [    2,    2,    4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, -10]
        call register_lumi_pine(
     &         [   71,  299,  315,  575,  591,  607,  649,  683,
     &            717,  767,  817,  867],
     &         3,
     &         [   -1,   -1,   -3,   -3,   -5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, -20]
        call register_lumi_pine(
     &         [   72,  300,  316,  576,  592,  608,  650,  684,
     &            718,  768,  818,  868],
     &         2,
     &         [   -2,   -2,   -4,   -4],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiZJ


#endif


