      subroutine getqcdnormZJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtZJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVZJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourZJ(current_chan)
         do isub = 1, nflavourZJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_ZJ(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=ZJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param())**2*nc*(nc**2-1d0)/(2d0*nc)*8d0
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d g -> d lm lp          B1g0Z
      case(2)
         factor=facB                        ! u g -> u lm lp          B1g0Z
      case(3)
         factor=facB                        ! d db -> g lm lp         B1g0Z
      case(4)
         factor=facB                        ! u ub -> g lm lp         B1g0Z
      case(5)
         factor=facB                        ! g d -> d lm lp          B1g0Z
      case(6)
         factor=facB                        ! g u -> u lm lp          B1g0Z
      case(7)
         factor=facB                        ! db d -> g lm lp         B1g0Z
      case(8)
         factor=facB                        ! ub u -> g lm lp         B1g0Z
      case(9)
         factor=facB                        ! g db -> db lm lp        B1g0Z
      case(10)
         factor=facB                        ! g ub -> ub lm lp        B1g0Z
      case(11)
         factor=facB                        ! db g -> db lm lp        B1g0Z
      case(12)
         factor=facB                        ! ub g -> ub lm lp        B1g0Z

c -- real

      case(13)
         factor=facR                        ! d g -> g d lm lp        B2g0Z
      case(14)
         factor=facR                        ! u g -> g u lm lp        B2g0Z
      case(15)
         factor=1d0/2d0*facR                ! d db -> g g lm lp       B2g0Z
      case(16)
         factor=1d0/2d0*facR                ! u ub -> g g lm lp       B2g0Z
      case(17)
         factor=facR                        ! g d -> g d lm lp        B2g0Z
      case(18)
         factor=facR                        ! g u -> g u lm lp        B2g0Z
      case(19)
         factor=1d0/2d0*facR                ! db d -> g g lm lp       B2g0Z
      case(20)
         factor=1d0/2d0*facR                ! ub u -> g g lm lp       B2g0Z
      case(21)
         factor=ndown*facR                  ! g g -> db d lm lp       B2g0Z
      case(22)
         factor=nup*facR                    ! g g -> ub u lm lp       B2g0Z
      case(23)
         factor=facR                        ! g db -> db g lm lp      B2g0Z
      case(24)
         factor=facR                        ! g ub -> ub g lm lp      B2g0Z
      case(25)
         factor=facR                        ! db g -> db g lm lp      B2g0Z
      case(26)
         factor=facR                        ! ub g -> ub g lm lp      B2g0Z
      case(27)
         factor=-1d0/nc**2*facR             ! d gt -> gt d lm lp      Bt2g0Z
      case(28)
         factor=-1d0/nc**2*facR             ! u gt -> gt u lm lp      Bt2g0Z
      case(29)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d db -> gt gt lm lp     Bt2g0Z
      case(30)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u ub -> gt gt lm lp     Bt2g0Z
      case(31)
         factor=-1d0/nc**2*facR             ! gt d -> gt d lm lp      Bt2g0Z
      case(32)
         factor=-1d0/nc**2*facR             ! gt u -> gt u lm lp      Bt2g0Z
      case(33)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db d -> gt gt lm lp     Bt2g0Z
      case(34)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub u -> gt gt lm lp     Bt2g0Z
      case(35)
         factor=-1d0/nc**2*ndown*facR       ! gt gt -> db d lm lp     Bt2g0Z
      case(36)
         factor=-1d0/nc**2*nup*facR         ! gt gt -> ub u lm lp     Bt2g0Z
      case(37)
         factor=-1d0/nc**2*facR             ! gt db -> db gt lm lp     Bt2g0Z
      case(38)
         factor=-1d0/nc**2*facR             ! gt ub -> ub gt lm lp     Bt2g0Z
      case(39)
         factor=-1d0/nc**2*facR             ! db gt -> db gt lm lp     Bt2g0Z
      case(40)
         factor=-1d0/nc**2*facR             ! ub gt -> ub gt lm lp     Bt2g0Z
      case(41)
         factor=1d0/nc*facR                 ! d db -> db d lm lp      C0g0Z
      case(42)
         factor=1d0/nc*facR                 ! d ub -> ub d lm lp      C0g0Z
      case(43)
         factor=1d0/nc*facR                 ! u db -> db u lm lp      C0g0Z
      case(44)
         factor=1d0/nc*facR                 ! u ub -> ub u lm lp      C0g0Z
      case(45)
         factor=1d0/nc*facR                 ! d d -> d d lm lp        C0g0Z
      case(46)
         factor=1d0/nc*facR                 ! d u -> u d lm lp        C0g0Z
      case(47)
         factor=1d0/nc*facR                 ! u d -> d u lm lp        C0g0Z
      case(48)
         factor=1d0/nc*facR                 ! u u -> u u lm lp        C0g0Z
      case(49)
         factor=1d0/nc*ndown*facR           ! d db -> d db lm lp      C0g0Z
      case(50)
         factor=1d0/nc*nup*facR             ! d db -> u ub lm lp      C0g0Z
      case(51)
         factor=1d0/nc*ndown*facR           ! u ub -> d db lm lp      C0g0Z
      case(52)
         factor=1d0/nc*nup*facR             ! u ub -> u ub lm lp      C0g0Z
      case(53)
         factor=1d0/nc*ndown*facR           ! db d -> d db lm lp      C0g0Z
      case(54)
         factor=1d0/nc*nup*facR             ! db d -> u ub lm lp      C0g0Z
      case(55)
         factor=1d0/nc*ndown*facR           ! ub u -> d db lm lp      C0g0Z
      case(56)
         factor=1d0/nc*nup*facR             ! ub u -> u ub lm lp      C0g0Z
      case(57)
         factor=1d0/nc*facR                 ! db db -> db db lm lp     C0g0Z
      case(58)
         factor=1d0/nc*facR                 ! db ub -> db ub lm lp     C0g0Z
      case(59)
         factor=1d0/nc*facR                 ! ub db -> ub db lm lp     C0g0Z
      case(60)
         factor=1d0/nc*facR                 ! ub ub -> ub ub lm lp     C0g0Z
      case(61)
         factor=1d0/nc*facR                 ! db d -> db d lm lp      C0g0Z
      case(62)
         factor=1d0/nc*facR                 ! db u -> db u lm lp      C0g0Z
      case(63)
         factor=1d0/nc*facR                 ! ub d -> ub d lm lp      C0g0Z
      case(64)
         factor=1d0/nc*facR                 ! ub u -> ub u lm lp      C0g0Z
      case(65)
         factor=-1d0/nc**2*facR             ! d db -> db d lm lp      D0g0Z
      case(66)
         factor=-1d0/nc**2*facR             ! u ub -> ub u lm lp      D0g0Z
      case(67)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d d -> d d lm lp        D0g0Z
      case(68)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u u -> u u lm lp        D0g0Z
      case(69)
         factor=-1d0/nc**2*facR             ! db d -> db d lm lp      D0g0Z
      case(70)
         factor=-1d0/nc**2*facR             ! ub u -> ub u lm lp      D0g0Z
      case(71)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db db -> db db lm lp     D0g0Z
      case(72)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub ub -> ub ub lm lp     D0g0Z

c -- virtual

      case(73)
         factor=facV                        ! d g -> d lm lp          B1g1Z
      case(74)
         factor=facV                        ! u g -> u lm lp          B1g1Z
      case(75)
         factor=facV                        ! d db -> g lm lp         B1g1Z
      case(76)
         factor=facV                        ! u ub -> g lm lp         B1g1Z
      case(77)
         factor=facV                        ! g d -> d lm lp          B1g1Z
      case(78)
         factor=facV                        ! g u -> u lm lp          B1g1Z
      case(79)
         factor=facV                        ! db d -> g lm lp         B1g1Z
      case(80)
         factor=facV                        ! ub u -> g lm lp         B1g1Z
      case(81)
         factor=facV                        ! g db -> db lm lp        B1g1Z
      case(82)
         factor=facV                        ! g ub -> ub lm lp        B1g1Z
      case(83)
         factor=facV                        ! db g -> db lm lp        B1g1Z
      case(84)
         factor=facV                        ! ub g -> ub lm lp        B1g1Z
      case(85)
         factor=ndown*facV                  ! g g subtraction         B1g1Z
      case(86)
         factor=nup*facV                    ! g g subtraction         B1g1Z
      case(87)
         factor=1d0/nc*facV                 ! d d subtraction         B1g1Z
      case(88)
         factor=1d0/nc*facV                 ! d u subtraction         B1g1Z
      case(89)
         factor=1d0/nc*facV                 ! u d subtraction         B1g1Z
      case(90)
         factor=1d0/nc*facV                 ! u u subtraction         B1g1Z
      case(91)
         factor=1d0/nc*facV                 ! d db subtraction        B1g1Z
      case(92)
         factor=1d0/nc*facV                 ! d ub subtraction        B1g1Z
      case(93)
         factor=1d0/nc*facV                 ! u db subtraction        B1g1Z
      case(94)
         factor=1d0/nc*facV                 ! u ub subtraction        B1g1Z
      case(95)
         factor=1d0/nc*facV                 ! db d subtraction        B1g1Z
      case(96)
         factor=1d0/nc*facV                 ! db u subtraction        B1g1Z
      case(97)
         factor=1d0/nc*facV                 ! ub d subtraction        B1g1Z
      case(98)
         factor=1d0/nc*facV                 ! ub u subtraction        B1g1Z
      case(99)
         factor=1d0/nc*facV                 ! db db subtraction       B1g1Z
      case(100)
         factor=1d0/nc*facV                 ! db ub subtraction       B1g1Z
      case(101)
         factor=1d0/nc*facV                 ! ub db subtraction       B1g1Z
      case(102)
         factor=1d0/nc*facV                 ! ub ub subtraction       B1g1Z
      case(103)
         factor=-1d0/nc**2*facV             ! d g -> d lm lp          Bt1g1Z
      case(104)
         factor=-1d0/nc**2*facV             ! u g -> u lm lp          Bt1g1Z
      case(105)
         factor=-1d0/nc**2*facV             ! d db -> g lm lp         Bt1g1Z
      case(106)
         factor=-1d0/nc**2*facV             ! u ub -> g lm lp         Bt1g1Z
      case(107)
         factor=-1d0/nc**2*facV             ! g d -> d lm lp          Bt1g1Z
      case(108)
         factor=-1d0/nc**2*facV             ! g u -> u lm lp          Bt1g1Z
      case(109)
         factor=-1d0/nc**2*facV             ! db d -> g lm lp         Bt1g1Z
      case(110)
         factor=-1d0/nc**2*facV             ! ub u -> g lm lp         Bt1g1Z
      case(111)
         factor=-1d0/nc**2*facV             ! g db -> db lm lp        Bt1g1Z
      case(112)
         factor=-1d0/nc**2*facV             ! g ub -> ub lm lp        Bt1g1Z
      case(113)
         factor=-1d0/nc**2*facV             ! db g -> db lm lp        Bt1g1Z
      case(114)
         factor=-1d0/nc**2*facV             ! ub g -> ub lm lp        Bt1g1Z
      case(115)
         factor=-1d0/nc**2*ndown*facV       ! g g subtraction         Bt1g1Z
      case(116)
         factor=-1d0/nc**2*nup*facV         ! g g subtraction         Bt1g1Z
      case(117)
         factor=-1d0/nc**3*facV             ! d d subtraction         Bt1g1Z
      case(118)
         factor=-1d0/nc**3*facV             ! d u subtraction         Bt1g1Z
      case(119)
         factor=-1d0/nc**3*facV             ! u d subtraction         Bt1g1Z
      case(120)
         factor=-1d0/nc**3*facV             ! u u subtraction         Bt1g1Z
      case(121)
         factor=-1d0/nc**3*facV             ! d db subtraction        Bt1g1Z
      case(122)
         factor=-1d0/nc**3*facV             ! d ub subtraction        Bt1g1Z
      case(123)
         factor=-1d0/nc**3*facV             ! u db subtraction        Bt1g1Z
      case(124)
         factor=-1d0/nc**3*facV             ! u ub subtraction        Bt1g1Z
      case(125)
         factor=-1d0/nc**3*facV             ! db d subtraction        Bt1g1Z
      case(126)
         factor=-1d0/nc**3*facV             ! db u subtraction        Bt1g1Z
      case(127)
         factor=-1d0/nc**3*facV             ! ub d subtraction        Bt1g1Z
      case(128)
         factor=-1d0/nc**3*facV             ! ub u subtraction        Bt1g1Z
      case(129)
         factor=-1d0/nc**3*facV             ! db db subtraction       Bt1g1Z
      case(130)
         factor=-1d0/nc**3*facV             ! db ub subtraction       Bt1g1Z
      case(131)
         factor=-1d0/nc**3*facV             ! ub db subtraction       Bt1g1Z
      case(132)
         factor=-1d0/nc**3*facV             ! ub ub subtraction       Bt1g1Z
      case(133)
         factor=1d0/nc*nf*facV              ! d g -> d lm lp          Bh1g1Z
      case(134)
         factor=1d0/nc*nf*facV              ! u g -> u lm lp          Bh1g1Z
      case(135)
         factor=1d0/nc*nf*facV              ! d db -> g lm lp         Bh1g1Z
      case(136)
         factor=1d0/nc*nf*facV              ! u ub -> g lm lp         Bh1g1Z
      case(137)
         factor=1d0/nc*nf*facV              ! g d -> d lm lp          Bh1g1Z
      case(138)
         factor=1d0/nc*nf*facV              ! g u -> u lm lp          Bh1g1Z
      case(139)
         factor=1d0/nc*nf*facV              ! db d -> g lm lp         Bh1g1Z
      case(140)
         factor=1d0/nc*nf*facV              ! ub u -> g lm lp         Bh1g1Z
      case(141)
         factor=1d0/nc*nf*facV              ! g db -> db lm lp        Bh1g1Z
      case(142)
         factor=1d0/nc*nf*facV              ! g ub -> ub lm lp        Bh1g1Z
      case(143)
         factor=1d0/nc*nf*facV              ! db g -> db lm lp        Bh1g1Z
      case(144)
         factor=1d0/nc*nf*facV              ! ub g -> ub lm lp        Bh1g1Z
      case(145)
         factor=1d0/nc*ndown*nf*facV        ! g g subtraction         Bh1g1Z
      case(146)
         factor=1d0/nc*nf*nup*facV          ! g g subtraction         Bh1g1Z
      case(147)
         factor=1d0/nc**2*nf*facV           ! d d subtraction         Bh1g1Z
      case(148)
         factor=1d0/nc**2*nf*facV           ! d u subtraction         Bh1g1Z
      case(149)
         factor=1d0/nc**2*nf*facV           ! u d subtraction         Bh1g1Z
      case(150)
         factor=1d0/nc**2*nf*facV           ! u u subtraction         Bh1g1Z
      case(151)
         factor=1d0/nc**2*nf*facV           ! d db subtraction        Bh1g1Z
      case(152)
         factor=1d0/nc**2*nf*facV           ! d ub subtraction        Bh1g1Z
      case(153)
         factor=1d0/nc**2*nf*facV           ! u db subtraction        Bh1g1Z
      case(154)
         factor=1d0/nc**2*nf*facV           ! u ub subtraction        Bh1g1Z
      case(155)
         factor=1d0/nc**2*nf*facV           ! db d subtraction        Bh1g1Z
      case(156)
         factor=1d0/nc**2*nf*facV           ! db u subtraction        Bh1g1Z
      case(157)
         factor=1d0/nc**2*nf*facV           ! ub d subtraction        Bh1g1Z
      case(158)
         factor=1d0/nc**2*nf*facV           ! ub u subtraction        Bh1g1Z
      case(159)
         factor=1d0/nc**2*nf*facV           ! db db subtraction       Bh1g1Z
      case(160)
         factor=1d0/nc**2*nf*facV           ! db ub subtraction       Bh1g1Z
      case(161)
         factor=1d0/nc**2*nf*facV           ! ub db subtraction       Bh1g1Z
      case(162)
         factor=1d0/nc**2*nf*facV           ! ub ub subtraction       Bh1g1Z

c -- double real

      case(163)
         factor=1d0/2d0*facRR               ! d g -> g g d lm lp      sB3g0Z
      case(164)
         factor=1d0/2d0*facRR               ! u g -> g g u lm lp      sB3g0Z
      case(165)
         factor=1d0/6d0*facRR               ! d db -> g g g lm lp     sB3g0Z
      case(166)
         factor=1d0/6d0*facRR               ! u ub -> g g g lm lp     sB3g0Z
      case(167)
         factor=1d0/2d0*facRR               ! g d -> g g d lm lp      sB3g0Z
      case(168)
         factor=1d0/2d0*facRR               ! g u -> g g u lm lp      sB3g0Z
      case(169)
         factor=1d0/6d0*facRR               ! db d -> g g g lm lp     sB3g0Z
      case(170)
         factor=1d0/6d0*facRR               ! ub u -> g g g lm lp     sB3g0Z
      case(171)
         factor=ndown*facRR                 ! g g -> db g d lm lp     sB3g0Z
      case(172)
         factor=nup*facRR                   ! g g -> ub g u lm lp     sB3g0Z
      case(173)
         factor=1d0/2d0*facRR               ! g db -> db g g lm lp     sB3g0Z
      case(174)
         factor=1d0/2d0*facRR               ! g ub -> ub g g lm lp     sB3g0Z
      case(175)
         factor=1d0/2d0*facRR               ! db g -> db g g lm lp     sB3g0Z
      case(176)
         factor=1d0/2d0*facRR               ! ub g -> ub g g lm lp     sB3g0Z
      case(177)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d g -> g g d lm lp      sBt3g0Z
      case(178)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u g -> g g u lm lp      sBt3g0Z
      case(179)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! d db -> g g g lm lp     sBt3g0Z
      case(180)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! u ub -> g g g lm lp     sBt3g0Z
      case(181)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g d -> g g d lm lp      sBt3g0Z
      case(182)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g u -> g g u lm lp      sBt3g0Z
      case(183)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! db d -> g g g lm lp     sBt3g0Z
      case(184)
         factor=-1d0/nc**2*1d0/6d0*facRR    ! ub u -> g g g lm lp     sBt3g0Z
      case(185)
         factor=-1d0/nc**2*ndown*facRR      ! g g -> db g d lm lp     sBt3g0Z
      case(186)
         factor=-1d0/nc**2*nup*facRR        ! g g -> ub g u lm lp     sBt3g0Z
      case(187)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g db -> db g g lm lp     sBt3g0Z
      case(188)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g ub -> ub g g lm lp     sBt3g0Z
      case(189)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db g -> db g g lm lp     sBt3g0Z
      case(190)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub g -> ub g g lm lp     sBt3g0Z
      case(191)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! d gt -> gt gt d lm lp     sBtt3g0Z
      case(192)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! u gt -> gt gt u lm lp     sBtt3g0Z
      case(193)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! d db -> gt gt gt lm lp     sBtt3g0Z
      case(194)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! u ub -> gt gt gt lm lp     sBtt3g0Z
      case(195)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! gt d -> gt gt d lm lp     sBtt3g0Z
      case(196)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! gt u -> gt gt u lm lp     sBtt3g0Z
      case(197)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! db d -> gt gt gt lm lp     sBtt3g0Z
      case(198)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facRR   ! ub u -> gt gt gt lm lp     sBtt3g0Z
      case(199)
         factor=(nc**2+1d0)/nc**4*ndown*facRR   ! gt gt -> db gt d lm lp     sBtt3g0Z
      case(200)
         factor=(nc**2+1d0)/nc**4*nup*facRR   ! gt gt -> ub gt u lm lp     sBtt3g0Z
      case(201)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! gt db -> db gt gt lm lp     sBtt3g0Z
      case(202)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! gt ub -> ub gt gt lm lp     sBtt3g0Z
      case(203)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! db gt -> db gt gt lm lp     sBtt3g0Z
      case(204)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facRR   ! ub gt -> ub gt gt lm lp     sBtt3g0Z
      case(205)
         factor=1d0/nc*ndown*facRR          ! d g -> d db d lm lp     sC1g0Z
      case(206)
         factor=1d0/nc*nup*facRR            ! d g -> u ub d lm lp     sC1g0Z
      case(207)
         factor=1d0/nc*ndown*facRR          ! u g -> d db u lm lp     sC1g0Z
      case(208)
         factor=1d0/nc*nup*facRR            ! u g -> u ub u lm lp     sC1g0Z
      case(209)
         factor=1d0/nc*facRR                ! d db -> g db d lm lp     sC1g0Z
      case(210)
         factor=1d0/nc*facRR                ! d ub -> g ub d lm lp     sC1g0Z
      case(211)
         factor=1d0/nc*facRR                ! u db -> g db u lm lp     sC1g0Z
      case(212)
         factor=1d0/nc*facRR                ! u ub -> g ub u lm lp     sC1g0Z
      case(213)
         factor=1d0/nc*facRR                ! d d -> g d d lm lp      sC1g0Z
      case(214)
         factor=1d0/nc*facRR                ! d u -> g u d lm lp      sC1g0Z
      case(215)
         factor=1d0/nc*facRR                ! u d -> g d u lm lp      sC1g0Z
      case(216)
         factor=1d0/nc*facRR                ! u u -> g u u lm lp      sC1g0Z
      case(217)
         factor=1d0/nc*ndown*facRR          ! d db -> g d db lm lp     sC1g0Z
      case(218)
         factor=1d0/nc*nup*facRR            ! d db -> g u ub lm lp     sC1g0Z
      case(219)
         factor=1d0/nc*ndown*facRR          ! u ub -> g d db lm lp     sC1g0Z
      case(220)
         factor=1d0/nc*nup*facRR            ! u ub -> g u ub lm lp     sC1g0Z
      case(221)
         factor=1d0/nc*ndown*facRR          ! g d -> d db d lm lp     sC1g0Z
      case(222)
         factor=1d0/nc*nup*facRR            ! g d -> u ub d lm lp     sC1g0Z
      case(223)
         factor=1d0/nc*ndown*facRR          ! g u -> d db u lm lp     sC1g0Z
      case(224)
         factor=1d0/nc*nup*facRR            ! g u -> u ub u lm lp     sC1g0Z
      case(225)
         factor=1d0/nc*ndown*facRR          ! db d -> g d db lm lp     sC1g0Z
      case(226)
         factor=1d0/nc*nup*facRR            ! db d -> g u ub lm lp     sC1g0Z
      case(227)
         factor=1d0/nc*ndown*facRR          ! ub u -> g d db lm lp     sC1g0Z
      case(228)
         factor=1d0/nc*nup*facRR            ! ub u -> g u ub lm lp     sC1g0Z
      case(229)
         factor=1d0/nc*ndown*facRR          ! g db -> db d db lm lp     sC1g0Z
      case(230)
         factor=1d0/nc*nup*facRR            ! g db -> db u ub lm lp     sC1g0Z
      case(231)
         factor=1d0/nc*ndown*facRR          ! g ub -> ub d db lm lp     sC1g0Z
      case(232)
         factor=1d0/nc*nup*facRR            ! g ub -> ub u ub lm lp     sC1g0Z
      case(233)
         factor=1d0/nc*ndown*facRR          ! db g -> db d db lm lp     sC1g0Z
      case(234)
         factor=1d0/nc*nup*facRR            ! db g -> db u ub lm lp     sC1g0Z
      case(235)
         factor=1d0/nc*ndown*facRR          ! ub g -> ub d db lm lp     sC1g0Z
      case(236)
         factor=1d0/nc*nup*facRR            ! ub g -> ub u ub lm lp     sC1g0Z
      case(237)
         factor=1d0/nc*facRR                ! db db -> db g db lm lp     sC1g0Z
      case(238)
         factor=1d0/nc*facRR                ! db ub -> db g ub lm lp     sC1g0Z
      case(239)
         factor=1d0/nc*facRR                ! ub db -> ub g db lm lp     sC1g0Z
      case(240)
         factor=1d0/nc*facRR                ! ub ub -> ub g ub lm lp     sC1g0Z
      case(241)
         factor=1d0/nc*facRR                ! db d -> db g d lm lp     sC1g0Z
      case(242)
         factor=1d0/nc*facRR                ! db u -> db g u lm lp     sC1g0Z
      case(243)
         factor=1d0/nc*facRR                ! ub d -> ub g d lm lp     sC1g0Z
      case(244)
         factor=1d0/nc*facRR                ! ub u -> ub g u lm lp     sC1g0Z
      case(245)
         factor=1d0/nc**3*ndown*facRR       ! d g -> d db d lm lp     sCt1g0Z
      case(246)
         factor=1d0/nc**3*nup*facRR         ! d g -> u ub d lm lp     sCt1g0Z
      case(247)
         factor=1d0/nc**3*ndown*facRR       ! u g -> d db u lm lp     sCt1g0Z
      case(248)
         factor=1d0/nc**3*nup*facRR         ! u g -> u ub u lm lp     sCt1g0Z
      case(249)
         factor=1d0/nc**3*facRR             ! d db -> g db d lm lp     sCt1g0Z
      case(250)
         factor=1d0/nc**3*facRR             ! d ub -> g ub d lm lp     sCt1g0Z
      case(251)
         factor=1d0/nc**3*facRR             ! u db -> g db u lm lp     sCt1g0Z
      case(252)
         factor=1d0/nc**3*facRR             ! u ub -> g ub u lm lp     sCt1g0Z
      case(253)
         factor=1d0/nc**3*facRR             ! d d -> g d d lm lp      sCt1g0Z
      case(254)
         factor=1d0/nc**3*facRR             ! d u -> g u d lm lp      sCt1g0Z
      case(255)
         factor=1d0/nc**3*facRR             ! u d -> g d u lm lp      sCt1g0Z
      case(256)
         factor=1d0/nc**3*facRR             ! u u -> g u u lm lp      sCt1g0Z
      case(257)
         factor=1d0/nc**3*ndown*facRR       ! d db -> g d db lm lp     sCt1g0Z
      case(258)
         factor=1d0/nc**3*nup*facRR         ! d db -> g u ub lm lp     sCt1g0Z
      case(259)
         factor=1d0/nc**3*ndown*facRR       ! u ub -> g d db lm lp     sCt1g0Z
      case(260)
         factor=1d0/nc**3*nup*facRR         ! u ub -> g u ub lm lp     sCt1g0Z
      case(261)
         factor=1d0/nc**3*ndown*facRR       ! g d -> d db d lm lp     sCt1g0Z
      case(262)
         factor=1d0/nc**3*nup*facRR         ! g d -> u ub d lm lp     sCt1g0Z
      case(263)
         factor=1d0/nc**3*ndown*facRR       ! g u -> d db u lm lp     sCt1g0Z
      case(264)
         factor=1d0/nc**3*nup*facRR         ! g u -> u ub u lm lp     sCt1g0Z
      case(265)
         factor=1d0/nc**3*ndown*facRR       ! db d -> g d db lm lp     sCt1g0Z
      case(266)
         factor=1d0/nc**3*nup*facRR         ! db d -> g u ub lm lp     sCt1g0Z
      case(267)
         factor=1d0/nc**3*ndown*facRR       ! ub u -> g d db lm lp     sCt1g0Z
      case(268)
         factor=1d0/nc**3*nup*facRR         ! ub u -> g u ub lm lp     sCt1g0Z
      case(269)
         factor=1d0/nc**3*ndown*facRR       ! g db -> db d db lm lp     sCt1g0Z
      case(270)
         factor=1d0/nc**3*nup*facRR         ! g db -> db u ub lm lp     sCt1g0Z
      case(271)
         factor=1d0/nc**3*ndown*facRR       ! g ub -> ub d db lm lp     sCt1g0Z
      case(272)
         factor=1d0/nc**3*nup*facRR         ! g ub -> ub u ub lm lp     sCt1g0Z
      case(273)
         factor=1d0/nc**3*ndown*facRR       ! db g -> db d db lm lp     sCt1g0Z
      case(274)
         factor=1d0/nc**3*nup*facRR         ! db g -> db u ub lm lp     sCt1g0Z
      case(275)
         factor=1d0/nc**3*ndown*facRR       ! ub g -> ub d db lm lp     sCt1g0Z
      case(276)
         factor=1d0/nc**3*nup*facRR         ! ub g -> ub u ub lm lp     sCt1g0Z
      case(277)
         factor=1d0/nc**3*facRR             ! db db -> db g db lm lp     sCt1g0Z
      case(278)
         factor=1d0/nc**3*facRR             ! db ub -> db g ub lm lp     sCt1g0Z
      case(279)
         factor=1d0/nc**3*facRR             ! ub db -> ub g db lm lp     sCt1g0Z
      case(280)
         factor=1d0/nc**3*facRR             ! ub ub -> ub g ub lm lp     sCt1g0Z
      case(281)
         factor=1d0/nc**3*facRR             ! db d -> db g d lm lp     sCt1g0Z
      case(282)
         factor=1d0/nc**3*facRR             ! db u -> db g u lm lp     sCt1g0Z
      case(283)
         factor=1d0/nc**3*facRR             ! ub d -> ub g d lm lp     sCt1g0Z
      case(284)
         factor=1d0/nc**3*facRR             ! ub u -> ub g u lm lp     sCt1g0Z
      case(285)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d g -> d db d lm lp     D1g0Zc
      case(286)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u g -> u ub u lm lp     D1g0Zc
      case(287)
         factor=-1d0/nc**2*facRR            ! d db -> g db d lm lp     D1g0Zc
      case(288)
         factor=-1d0/nc**2*facRR            ! u ub -> g ub u lm lp     D1g0Zc
      case(289)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! d d -> g d d lm lp      D1g0Zc
      case(290)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! u u -> g u u lm lp      D1g0Zc
      case(291)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g d -> d db d lm lp     D1g0Zc
      case(292)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g u -> u ub u lm lp     D1g0Zc
      case(293)
         factor=-1d0/nc**2*facRR            ! db d -> g db d lm lp     D1g0Zc
      case(294)
         factor=-1d0/nc**2*facRR            ! ub u -> g ub u lm lp     D1g0Zc
      case(295)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g db -> db db d lm lp     D1g0Zc
      case(296)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! g ub -> ub ub u lm lp     D1g0Zc
      case(297)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db g -> db db d lm lp     D1g0Zc
      case(298)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub g -> ub ub u lm lp     D1g0Zc
      case(299)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! db db -> db g db lm lp     D1g0Zc
      case(300)
         factor=-1d0/nc**2*1d0/2d0*facRR    ! ub ub -> ub g ub lm lp     D1g0Zc
      case(301)
         factor=1d0/nc**4*1d0/2d0*facRR     ! d g -> d db d lm lp     Dt1g0Z
      case(302)
         factor=1d0/nc**4*1d0/2d0*facRR     ! u g -> u ub u lm lp     Dt1g0Z
      case(303)
         factor=1d0/nc**4*facRR             ! d db -> g db d lm lp     Dt1g0Z
      case(304)
         factor=1d0/nc**4*facRR             ! u ub -> g ub u lm lp     Dt1g0Z
      case(305)
         factor=1d0/nc**4*1d0/2d0*facRR     ! d d -> g d d lm lp      Dt1g0Z
      case(306)
         factor=1d0/nc**4*1d0/2d0*facRR     ! u u -> g u u lm lp      Dt1g0Z
      case(307)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g d -> d db d lm lp     Dt1g0Z
      case(308)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g u -> u ub u lm lp     Dt1g0Z
      case(309)
         factor=1d0/nc**4*facRR             ! db d -> g db d lm lp     Dt1g0Z
      case(310)
         factor=1d0/nc**4*facRR             ! ub u -> g ub u lm lp     Dt1g0Z
      case(311)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g db -> db db d lm lp     Dt1g0Z
      case(312)
         factor=1d0/nc**4*1d0/2d0*facRR     ! g ub -> ub ub u lm lp     Dt1g0Z
      case(313)
         factor=1d0/nc**4*1d0/2d0*facRR     ! db g -> db db d lm lp     Dt1g0Z
      case(314)
         factor=1d0/nc**4*1d0/2d0*facRR     ! ub g -> ub ub u lm lp     Dt1g0Z
      case(315)
         factor=1d0/nc**4*1d0/2d0*facRR     ! db db -> db g db lm lp     Dt1g0Z
      case(316)
         factor=1d0/nc**4*1d0/2d0*facRR     ! ub ub -> ub g ub lm lp     Dt1g0Z

c -- real virtual

      case(317)
         factor=facRV                       ! d g -> g d lm lp        sB2g1Z
      case(318)
         factor=facRV                       ! u g -> g u lm lp        sB2g1Z
      case(319)
         factor=1d0/2d0*facRV               ! d db -> g g lm lp       sB2g1Z
      case(320)
         factor=1d0/2d0*facRV               ! u ub -> g g lm lp       sB2g1Z
      case(321)
         factor=facRV                       ! g d -> g d lm lp        sB2g1Z
      case(322)
         factor=facRV                       ! g u -> g u lm lp        sB2g1Z
      case(323)
         factor=1d0/2d0*facRV               ! db d -> g g lm lp       sB2g1Z
      case(324)
         factor=1d0/2d0*facRV               ! ub u -> g g lm lp       sB2g1Z
      case(325)
         factor=ndown*facRV                 ! g g -> db d lm lp       sB2g1Z
      case(326)
         factor=nup*facRV                   ! g g -> ub u lm lp       sB2g1Z
      case(327)
         factor=facRV                       ! g db -> db g lm lp      sB2g1Z
      case(328)
         factor=facRV                       ! g ub -> ub g lm lp      sB2g1Z
      case(329)
         factor=facRV                       ! db g -> db g lm lp      sB2g1Z
      case(330)
         factor=facRV                       ! ub g -> ub g lm lp      sB2g1Z
      case(331)
         factor=1d0/nc*facRV                ! d d subtraction         sB2g1Z
      case(332)
         factor=1d0/nc*facRV                ! d u subtraction         sB2g1Z
      case(333)
         factor=1d0/nc*facRV                ! u d subtraction         sB2g1Z
      case(334)
         factor=1d0/nc*facRV                ! u u subtraction         sB2g1Z
      case(335)
         factor=1d0/nc*facRV                ! d db subtraction        sB2g1Z
      case(336)
         factor=1d0/nc*facRV                ! d ub subtraction        sB2g1Z
      case(337)
         factor=1d0/nc*facRV                ! u db subtraction        sB2g1Z
      case(338)
         factor=1d0/nc*facRV                ! u ub subtraction        sB2g1Z
      case(339)
         factor=1d0/nc*facRV                ! db d subtraction        sB2g1Z
      case(340)
         factor=1d0/nc*facRV                ! db u subtraction        sB2g1Z
      case(341)
         factor=1d0/nc*facRV                ! ub d subtraction        sB2g1Z
      case(342)
         factor=1d0/nc*facRV                ! ub u subtraction        sB2g1Z
      case(343)
         factor=1d0/nc*facRV                ! db db subtraction       sB2g1Z
      case(344)
         factor=1d0/nc*facRV                ! db ub subtraction       sB2g1Z
      case(345)
         factor=1d0/nc*facRV                ! ub db subtraction       sB2g1Z
      case(346)
         factor=1d0/nc*facRV                ! ub ub subtraction       sB2g1Z
      case(347)
         factor=-1d0/nc**2*facRV            ! d g -> g d lm lp        sBt2g1Z
      case(348)
         factor=-1d0/nc**2*facRV            ! u g -> g u lm lp        sBt2g1Z
      case(349)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! d db -> g g lm lp       sBt2g1Z
      case(350)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! u ub -> g g lm lp       sBt2g1Z
      case(351)
         factor=-1d0/nc**2*facRV            ! g d -> g d lm lp        sBt2g1Z
      case(352)
         factor=-1d0/nc**2*facRV            ! g u -> g u lm lp        sBt2g1Z
      case(353)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! db d -> g g lm lp       sBt2g1Z
      case(354)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! ub u -> g g lm lp       sBt2g1Z
      case(355)
         factor=-1d0/nc**2*ndown*facRV      ! g g -> db d lm lp       sBt2g1Z
      case(356)
         factor=-1d0/nc**2*nup*facRV        ! g g -> ub u lm lp       sBt2g1Z
      case(357)
         factor=-1d0/nc**2*facRV            ! g db -> db g lm lp      sBt2g1Z
      case(358)
         factor=-1d0/nc**2*facRV            ! g ub -> ub g lm lp      sBt2g1Z
      case(359)
         factor=-1d0/nc**2*facRV            ! db g -> db g lm lp      sBt2g1Z
      case(360)
         factor=-1d0/nc**2*facRV            ! ub g -> ub g lm lp      sBt2g1Z
      case(361)
         factor=-1d0/nc**3*facRV            ! d d subtraction         sBt2g1Z
      case(362)
         factor=-1d0/nc**3*facRV            ! d u subtraction         sBt2g1Z
      case(363)
         factor=-1d0/nc**3*facRV            ! u d subtraction         sBt2g1Z
      case(364)
         factor=-1d0/nc**3*facRV            ! u u subtraction         sBt2g1Z
      case(365)
         factor=-1d0/nc**3*facRV            ! d db subtraction        sBt2g1Z
      case(366)
         factor=-1d0/nc**3*facRV            ! d ub subtraction        sBt2g1Z
      case(367)
         factor=-1d0/nc**3*facRV            ! u db subtraction        sBt2g1Z
      case(368)
         factor=-1d0/nc**3*facRV            ! u ub subtraction        sBt2g1Z
      case(369)
         factor=-1d0/nc**3*facRV            ! db d subtraction        sBt2g1Z
      case(370)
         factor=-1d0/nc**3*facRV            ! db u subtraction        sBt2g1Z
      case(371)
         factor=-1d0/nc**3*facRV            ! ub d subtraction        sBt2g1Z
      case(372)
         factor=-1d0/nc**3*facRV            ! ub u subtraction        sBt2g1Z
      case(373)
         factor=-1d0/nc**3*facRV            ! db db subtraction       sBt2g1Z
      case(374)
         factor=-1d0/nc**3*facRV            ! db ub subtraction       sBt2g1Z
      case(375)
         factor=-1d0/nc**3*facRV            ! ub db subtraction       sBt2g1Z
      case(376)
         factor=-1d0/nc**3*facRV            ! ub ub subtraction       sBt2g1Z
      case(377)
         factor=-1d0/nc**2*facRV            ! d gt -> gt d lm lp      sBtt2g1Zc
      case(378)
         factor=-1d0/nc**2*facRV            ! u gt -> gt u lm lp      sBtt2g1Zc
      case(379)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! d db -> gt gt lm lp     sBtt2g1Zc
      case(380)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! u ub -> gt gt lm lp     sBtt2g1Zc
      case(381)
         factor=-1d0/nc**2*facRV            ! gt d -> gt d lm lp      sBtt2g1Zc
      case(382)
         factor=-1d0/nc**2*facRV            ! gt u -> gt u lm lp      sBtt2g1Zc
      case(383)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! db d -> gt gt lm lp     sBtt2g1Zc
      case(384)
         factor=-1d0/nc**2*1d0/2d0*facRV    ! ub u -> gt gt lm lp     sBtt2g1Zc
      case(385)
         factor=-1d0/nc**2*ndown*facRV      ! gt gt -> db d lm lp     sBtt2g1Zc
      case(386)
         factor=-1d0/nc**2*nup*facRV        ! gt gt -> ub u lm lp     sBtt2g1Zc
      case(387)
         factor=-1d0/nc**2*facRV            ! gt db -> db gt lm lp     sBtt2g1Zc
      case(388)
         factor=-1d0/nc**2*facRV            ! gt ub -> ub gt lm lp     sBtt2g1Zc
      case(389)
         factor=-1d0/nc**2*facRV            ! db gt -> db gt lm lp     sBtt2g1Zc
      case(390)
         factor=-1d0/nc**2*facRV            ! ub gt -> ub gt lm lp     sBtt2g1Zc
      case(391)
         factor=1d0/nc**4*facRV             ! d gt -> gt d lm lp      sBttt2g1Z
      case(392)
         factor=1d0/nc**4*facRV             ! u gt -> gt u lm lp      sBttt2g1Z
      case(393)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d db -> gt gt lm lp     sBttt2g1Z
      case(394)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u ub -> gt gt lm lp     sBttt2g1Z
      case(395)
         factor=1d0/nc**4*facRV             ! gt d -> gt d lm lp      sBttt2g1Z
      case(396)
         factor=1d0/nc**4*facRV             ! gt u -> gt u lm lp      sBttt2g1Z
      case(397)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db d -> gt gt lm lp     sBttt2g1Z
      case(398)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub u -> gt gt lm lp     sBttt2g1Z
      case(399)
         factor=1d0/nc**4*ndown*facRV       ! gt gt -> db d lm lp     sBttt2g1Z
      case(400)
         factor=1d0/nc**4*nup*facRV         ! gt gt -> ub u lm lp     sBttt2g1Z
      case(401)
         factor=1d0/nc**4*facRV             ! gt db -> db gt lm lp     sBttt2g1Z
      case(402)
         factor=1d0/nc**4*facRV             ! gt ub -> ub gt lm lp     sBttt2g1Z
      case(403)
         factor=1d0/nc**4*facRV             ! db gt -> db gt lm lp     sBttt2g1Z
      case(404)
         factor=1d0/nc**4*facRV             ! ub gt -> ub gt lm lp     sBttt2g1Z
      case(405)
         factor=1d0/nc*nf*facRV             ! d g -> g d lm lp        sBh2g1Z
      case(406)
         factor=1d0/nc*nf*facRV             ! u g -> g u lm lp        sBh2g1Z
      case(407)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! d db -> g g lm lp       sBh2g1Z
      case(408)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! u ub -> g g lm lp       sBh2g1Z
      case(409)
         factor=1d0/nc*nf*facRV             ! g d -> g d lm lp        sBh2g1Z
      case(410)
         factor=1d0/nc*nf*facRV             ! g u -> g u lm lp        sBh2g1Z
      case(411)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! db d -> g g lm lp       sBh2g1Z
      case(412)
         factor=1d0/nc*nf*1d0/2d0*facRV     ! ub u -> g g lm lp       sBh2g1Z
      case(413)
         factor=1d0/nc*nf*ndown*facRV       ! g g -> db d lm lp       sBh2g1Z
      case(414)
         factor=1d0/nc*nf*nup*facRV         ! g g -> ub u lm lp       sBh2g1Z
      case(415)
         factor=1d0/nc*nf*facRV             ! g db -> db g lm lp      sBh2g1Z
      case(416)
         factor=1d0/nc*nf*facRV             ! g ub -> ub g lm lp      sBh2g1Z
      case(417)
         factor=1d0/nc*nf*facRV             ! db g -> db g lm lp      sBh2g1Z
      case(418)
         factor=1d0/nc*nf*facRV             ! ub g -> ub g lm lp      sBh2g1Z
      case(419)
         factor=1d0/nc**2*nf*facRV          ! d d subtraction         sBh2g1Z
      case(420)
         factor=1d0/nc**2*nf*facRV          ! d u subtraction         sBh2g1Z
      case(421)
         factor=1d0/nc**2*nf*facRV          ! u d subtraction         sBh2g1Z
      case(422)
         factor=1d0/nc**2*nf*facRV          ! u u subtraction         sBh2g1Z
      case(423)
         factor=1d0/nc**2*nf*facRV          ! d db subtraction        sBh2g1Z
      case(424)
         factor=1d0/nc**2*nf*facRV          ! d ub subtraction        sBh2g1Z
      case(425)
         factor=1d0/nc**2*nf*facRV          ! u db subtraction        sBh2g1Z
      case(426)
         factor=1d0/nc**2*nf*facRV          ! u ub subtraction        sBh2g1Z
      case(427)
         factor=1d0/nc**2*nf*facRV          ! db d subtraction        sBh2g1Z
      case(428)
         factor=1d0/nc**2*nf*facRV          ! db u subtraction        sBh2g1Z
      case(429)
         factor=1d0/nc**2*nf*facRV          ! ub d subtraction        sBh2g1Z
      case(430)
         factor=1d0/nc**2*nf*facRV          ! ub u subtraction        sBh2g1Z
      case(431)
         factor=1d0/nc**2*nf*facRV          ! db db subtraction       sBh2g1Z
      case(432)
         factor=1d0/nc**2*nf*facRV          ! db ub subtraction       sBh2g1Z
      case(433)
         factor=1d0/nc**2*nf*facRV          ! ub db subtraction       sBh2g1Z
      case(434)
         factor=1d0/nc**2*nf*facRV          ! ub ub subtraction       sBh2g1Z
      case(435)
         factor=-1d0/nc**3*nf*facRV         ! d gt -> gt d lm lp      sBth2g1Z
      case(436)
         factor=-1d0/nc**3*nf*facRV         ! u gt -> gt u lm lp      sBth2g1Z
      case(437)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! d db -> gt gt lm lp     sBth2g1Z
      case(438)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! u ub -> gt gt lm lp     sBth2g1Z
      case(439)
         factor=-1d0/nc**3*nf*facRV         ! gt d -> gt d lm lp      sBth2g1Z
      case(440)
         factor=-1d0/nc**3*nf*facRV         ! gt u -> gt u lm lp      sBth2g1Z
      case(441)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! db d -> gt gt lm lp     sBth2g1Z
      case(442)
         factor=-1d0/nc**3*nf*1d0/2d0*facRV   ! ub u -> gt gt lm lp     sBth2g1Z
      case(443)
         factor=-1d0/nc**3*nf*ndown*facRV   ! gt gt -> db d lm lp     sBth2g1Z
      case(444)
         factor=-1d0/nc**3*nf*nup*facRV     ! gt gt -> ub u lm lp     sBth2g1Z
      case(445)
         factor=-1d0/nc**3*nf*facRV         ! gt db -> db gt lm lp     sBth2g1Z
      case(446)
         factor=-1d0/nc**3*nf*facRV         ! gt ub -> ub gt lm lp     sBth2g1Z
      case(447)
         factor=-1d0/nc**3*nf*facRV         ! db gt -> db gt lm lp     sBth2g1Z
      case(448)
         factor=-1d0/nc**3*nf*facRV         ! ub gt -> ub gt lm lp     sBth2g1Z
      case(449)
         factor=1d0/nc*facRV                ! d db -> db d lm lp      sC0g1Z
      case(450)
         factor=1d0/nc*facRV                ! d ub -> ub d lm lp      sC0g1Z
      case(451)
         factor=1d0/nc*facRV                ! u db -> db u lm lp      sC0g1Z
      case(452)
         factor=1d0/nc*facRV                ! u ub -> ub u lm lp      sC0g1Z
      case(453)
         factor=1d0/nc*facRV                ! d d -> d d lm lp        sC0g1Z
      case(454)
         factor=1d0/nc*facRV                ! d u -> u d lm lp        sC0g1Z
      case(455)
         factor=1d0/nc*facRV                ! u d -> d u lm lp        sC0g1Z
      case(456)
         factor=1d0/nc*facRV                ! u u -> u u lm lp        sC0g1Z
      case(457)
         factor=1d0/nc*ndown*facRV          ! d db -> d db lm lp      sC0g1Z
      case(458)
         factor=1d0/nc*nup*facRV            ! d db -> u ub lm lp      sC0g1Z
      case(459)
         factor=1d0/nc*ndown*facRV          ! u ub -> d db lm lp      sC0g1Z
      case(460)
         factor=1d0/nc*nup*facRV            ! u ub -> u ub lm lp      sC0g1Z
      case(461)
         factor=1d0/nc*ndown*facRV          ! db d -> d db lm lp      sC0g1Z
      case(462)
         factor=1d0/nc*nup*facRV            ! db d -> u ub lm lp      sC0g1Z
      case(463)
         factor=1d0/nc*ndown*facRV          ! ub u -> d db lm lp      sC0g1Z
      case(464)
         factor=1d0/nc*nup*facRV            ! ub u -> u ub lm lp      sC0g1Z
      case(465)
         factor=1d0/nc*facRV                ! db db -> db db lm lp     sC0g1Z
      case(466)
         factor=1d0/nc*facRV                ! db ub -> db ub lm lp     sC0g1Z
      case(467)
         factor=1d0/nc*facRV                ! ub db -> ub db lm lp     sC0g1Z
      case(468)
         factor=1d0/nc*facRV                ! ub ub -> ub ub lm lp     sC0g1Z
      case(469)
         factor=1d0/nc*facRV                ! db d -> db d lm lp      sC0g1Z
      case(470)
         factor=1d0/nc*facRV                ! db u -> db u lm lp      sC0g1Z
      case(471)
         factor=1d0/nc*facRV                ! ub d -> ub d lm lp      sC0g1Z
      case(472)
         factor=1d0/nc*facRV                ! ub u -> ub u lm lp      sC0g1Z
      case(473)
         factor=1d0/nc*ndown*facRV          ! g d subtraction         sC0g1Z
      case(474)
         factor=1d0/nc*nup*facRV            ! g d subtraction         sC0g1Z
      case(475)
         factor=1d0/nc*ndown*facRV          ! g u subtraction         sC0g1Z
      case(476)
         factor=1d0/nc*nup*facRV            ! g u subtraction         sC0g1Z
      case(477)
         factor=1d0/nc*ndown*facRV          ! g db subtraction        sC0g1Z
      case(478)
         factor=1d0/nc*nup*facRV            ! g db subtraction        sC0g1Z
      case(479)
         factor=1d0/nc*ndown*facRV          ! g ub subtraction        sC0g1Z
      case(480)
         factor=1d0/nc*nup*facRV            ! g ub subtraction        sC0g1Z
      case(481)
         factor=1d0/nc*ndown*facRV          ! d g subtraction         sC0g1Z
      case(482)
         factor=1d0/nc*nup*facRV            ! d g subtraction         sC0g1Z
      case(483)
         factor=1d0/nc*ndown*facRV          ! u g subtraction         sC0g1Z
      case(484)
         factor=1d0/nc*nup*facRV            ! u g subtraction         sC0g1Z
      case(485)
         factor=1d0/nc*ndown*facRV          ! db g subtraction        sC0g1Z
      case(486)
         factor=1d0/nc*nup*facRV            ! db g subtraction        sC0g1Z
      case(487)
         factor=1d0/nc*ndown*facRV          ! ub g subtraction        sC0g1Z
      case(488)
         factor=1d0/nc*nup*facRV            ! ub g subtraction        sC0g1Z
      case(489)
         factor=1d0/nc**3*facRV             ! d db -> db d lm lp      Ct0g1Z
      case(490)
         factor=1d0/nc**3*facRV             ! d ub -> ub d lm lp      Ct0g1Z
      case(491)
         factor=1d0/nc**3*facRV             ! u db -> db u lm lp      Ct0g1Z
      case(492)
         factor=1d0/nc**3*facRV             ! u ub -> ub u lm lp      Ct0g1Z
      case(493)
         factor=1d0/nc**3*facRV             ! d d -> d d lm lp        Ct0g1Z
      case(494)
         factor=1d0/nc**3*facRV             ! d u -> u d lm lp        Ct0g1Z
      case(495)
         factor=1d0/nc**3*facRV             ! u d -> d u lm lp        Ct0g1Z
      case(496)
         factor=1d0/nc**3*facRV             ! u u -> u u lm lp        Ct0g1Z
      case(497)
         factor=1d0/nc**3*ndown*facRV       ! d db -> d db lm lp      Ct0g1Z
      case(498)
         factor=1d0/nc**3*nup*facRV         ! d db -> u ub lm lp      Ct0g1Z
      case(499)
         factor=1d0/nc**3*ndown*facRV       ! u ub -> d db lm lp      Ct0g1Z
      case(500)
         factor=1d0/nc**3*nup*facRV         ! u ub -> u ub lm lp      Ct0g1Z
      case(501)
         factor=1d0/nc**3*ndown*facRV       ! db d -> d db lm lp      Ct0g1Z
      case(502)
         factor=1d0/nc**3*nup*facRV         ! db d -> u ub lm lp      Ct0g1Z
      case(503)
         factor=1d0/nc**3*ndown*facRV       ! ub u -> d db lm lp      Ct0g1Z
      case(504)
         factor=1d0/nc**3*nup*facRV         ! ub u -> u ub lm lp      Ct0g1Z
      case(505)
         factor=1d0/nc**3*facRV             ! db db -> db db lm lp     Ct0g1Z
      case(506)
         factor=1d0/nc**3*facRV             ! db ub -> db ub lm lp     Ct0g1Z
      case(507)
         factor=1d0/nc**3*facRV             ! ub db -> ub db lm lp     Ct0g1Z
      case(508)
         factor=1d0/nc**3*facRV             ! ub ub -> ub ub lm lp     Ct0g1Z
      case(509)
         factor=1d0/nc**3*facRV             ! db d -> db d lm lp      Ct0g1Z
      case(510)
         factor=1d0/nc**3*facRV             ! db u -> db u lm lp      Ct0g1Z
      case(511)
         factor=1d0/nc**3*facRV             ! ub d -> ub d lm lp      Ct0g1Z
      case(512)
         factor=1d0/nc**3*facRV             ! ub u -> ub u lm lp      Ct0g1Z
      case(513)
         factor=1d0/nc**3*ndown*facRV       ! g d subtraction         Ct0g1Z
      case(514)
         factor=1d0/nc**3*nup*facRV         ! g d subtraction         Ct0g1Z
      case(515)
         factor=1d0/nc**3*ndown*facRV       ! g u subtraction         Ct0g1Z
      case(516)
         factor=1d0/nc**3*nup*facRV         ! g u subtraction         Ct0g1Z
      case(517)
         factor=1d0/nc**3*ndown*facRV       ! g db subtraction        Ct0g1Z
      case(518)
         factor=1d0/nc**3*nup*facRV         ! g db subtraction        Ct0g1Z
      case(519)
         factor=1d0/nc**3*ndown*facRV       ! g ub subtraction        Ct0g1Z
      case(520)
         factor=1d0/nc**3*nup*facRV         ! g ub subtraction        Ct0g1Z
      case(521)
         factor=1d0/nc**3*ndown*facRV       ! d g subtraction         Ct0g1Z
      case(522)
         factor=1d0/nc**3*nup*facRV         ! d g subtraction         Ct0g1Z
      case(523)
         factor=1d0/nc**3*ndown*facRV       ! u g subtraction         Ct0g1Z
      case(524)
         factor=1d0/nc**3*nup*facRV         ! u g subtraction         Ct0g1Z
      case(525)
         factor=1d0/nc**3*ndown*facRV       ! db g subtraction        Ct0g1Z
      case(526)
         factor=1d0/nc**3*nup*facRV         ! db g subtraction        Ct0g1Z
      case(527)
         factor=1d0/nc**3*ndown*facRV       ! ub g subtraction        Ct0g1Z
      case(528)
         factor=1d0/nc**3*nup*facRV         ! ub g subtraction        Ct0g1Z
      case(529)
         factor=1d0/nc**2*nf*facRV          ! d db -> db d lm lp      Ch0g1Z
      case(530)
         factor=1d0/nc**2*nf*facRV          ! d ub -> ub d lm lp      Ch0g1Z
      case(531)
         factor=1d0/nc**2*nf*facRV          ! u db -> db u lm lp      Ch0g1Z
      case(532)
         factor=1d0/nc**2*nf*facRV          ! u ub -> ub u lm lp      Ch0g1Z
      case(533)
         factor=1d0/nc**2*nf*facRV          ! d d -> d d lm lp        Ch0g1Z
      case(534)
         factor=1d0/nc**2*nf*facRV          ! d u -> u d lm lp        Ch0g1Z
      case(535)
         factor=1d0/nc**2*nf*facRV          ! u d -> d u lm lp        Ch0g1Z
      case(536)
         factor=1d0/nc**2*nf*facRV          ! u u -> u u lm lp        Ch0g1Z
      case(537)
         factor=1d0/nc**2*nf*ndown*facRV    ! d db -> d db lm lp      Ch0g1Z
      case(538)
         factor=1d0/nc**2*nf*nup*facRV      ! d db -> u ub lm lp      Ch0g1Z
      case(539)
         factor=1d0/nc**2*nf*ndown*facRV    ! u ub -> d db lm lp      Ch0g1Z
      case(540)
         factor=1d0/nc**2*nf*nup*facRV      ! u ub -> u ub lm lp      Ch0g1Z
      case(541)
         factor=1d0/nc**2*nf*ndown*facRV    ! db d -> d db lm lp      Ch0g1Z
      case(542)
         factor=1d0/nc**2*nf*nup*facRV      ! db d -> u ub lm lp      Ch0g1Z
      case(543)
         factor=1d0/nc**2*nf*ndown*facRV    ! ub u -> d db lm lp      Ch0g1Z
      case(544)
         factor=1d0/nc**2*nf*nup*facRV      ! ub u -> u ub lm lp      Ch0g1Z
      case(545)
         factor=1d0/nc**2*nf*facRV          ! db db -> db db lm lp     Ch0g1Z
      case(546)
         factor=1d0/nc**2*nf*facRV          ! db ub -> db ub lm lp     Ch0g1Z
      case(547)
         factor=1d0/nc**2*nf*facRV          ! ub db -> ub db lm lp     Ch0g1Z
      case(548)
         factor=1d0/nc**2*nf*facRV          ! ub ub -> ub ub lm lp     Ch0g1Z
      case(549)
         factor=1d0/nc**2*nf*facRV          ! db d -> db d lm lp      Ch0g1Z
      case(550)
         factor=1d0/nc**2*nf*facRV          ! db u -> db u lm lp      Ch0g1Z
      case(551)
         factor=1d0/nc**2*nf*facRV          ! ub d -> ub d lm lp      Ch0g1Z
      case(552)
         factor=1d0/nc**2*nf*facRV          ! ub u -> ub u lm lp      Ch0g1Z
      case(553)
         factor=1d0/nc**2*ndown*nf*facRV    ! g d subtraction         Ch0g1Z
      case(554)
         factor=1d0/nc**2*nf*nup*facRV      ! g d subtraction         Ch0g1Z
      case(555)
         factor=1d0/nc**2*ndown*nf*facRV    ! g u subtraction         Ch0g1Z
      case(556)
         factor=1d0/nc**2*nf*nup*facRV      ! g u subtraction         Ch0g1Z
      case(557)
         factor=1d0/nc**2*ndown*nf*facRV    ! g db subtraction        Ch0g1Z
      case(558)
         factor=1d0/nc**2*nf*nup*facRV      ! g db subtraction        Ch0g1Z
      case(559)
         factor=1d0/nc**2*ndown*nf*facRV    ! g ub subtraction        Ch0g1Z
      case(560)
         factor=1d0/nc**2*nf*nup*facRV      ! g ub subtraction        Ch0g1Z
      case(561)
         factor=1d0/nc**2*ndown*nf*facRV    ! d g subtraction         Ch0g1Z
      case(562)
         factor=1d0/nc**2*nf*nup*facRV      ! d g subtraction         Ch0g1Z
      case(563)
         factor=1d0/nc**2*ndown*nf*facRV    ! u g subtraction         Ch0g1Z
      case(564)
         factor=1d0/nc**2*nf*nup*facRV      ! u g subtraction         Ch0g1Z
      case(565)
         factor=1d0/nc**2*ndown*nf*facRV    ! db g subtraction        Ch0g1Z
      case(566)
         factor=1d0/nc**2*nf*nup*facRV      ! db g subtraction        Ch0g1Z
      case(567)
         factor=1d0/nc**2*ndown*nf*facRV    ! ub g subtraction        Ch0g1Z
      case(568)
         factor=1d0/nc**2*nf*nup*facRV      ! ub g subtraction        Ch0g1Z
      case(569)
         factor=1d0/nc**2*facRV             ! d db -> db d lm lp      D0g1Z
      case(570)
         factor=1d0/nc**2*facRV             ! u ub -> ub u lm lp      D0g1Z
      case(571)
         factor=1d0/nc**2*1d0/2d0*facRV     ! d d -> d d lm lp        D0g1Z
      case(572)
         factor=1d0/nc**2*1d0/2d0*facRV     ! u u -> u u lm lp        D0g1Z
      case(573)
         factor=1d0/nc**2*facRV             ! db d -> db d lm lp      D0g1Z
      case(574)
         factor=1d0/nc**2*facRV             ! ub u -> ub u lm lp      D0g1Z
      case(575)
         factor=1d0/nc**2*1d0/2d0*facRV     ! db db -> db db lm lp     D0g1Z
      case(576)
         factor=1d0/nc**2*1d0/2d0*facRV     ! ub ub -> ub ub lm lp     D0g1Z
      case(577)
         factor=1d0/nc**2*facRV             ! g d subtraction         D0g1Z
      case(578)
         factor=1d0/nc**2*facRV             ! g u subtraction         D0g1Z
      case(579)
         factor=1d0/nc**2*facRV             ! g db subtraction        D0g1Z
      case(580)
         factor=1d0/nc**2*facRV             ! g ub subtraction        D0g1Z
      case(581)
         factor=1d0/nc**2*facRV             ! d g subtraction         D0g1Z
      case(582)
         factor=1d0/nc**2*facRV             ! u g subtraction         D0g1Z
      case(583)
         factor=1d0/nc**2*facRV             ! db g subtraction        D0g1Z
      case(584)
         factor=1d0/nc**2*facRV             ! ub g subtraction        D0g1Z
      case(585)
         factor=1d0/nc**4*facRV             ! d db -> db d lm lp      Dt0g1Z
      case(586)
         factor=1d0/nc**4*facRV             ! u ub -> ub u lm lp      Dt0g1Z
      case(587)
         factor=1d0/nc**4*1d0/2d0*facRV     ! d d -> d d lm lp        Dt0g1Z
      case(588)
         factor=1d0/nc**4*1d0/2d0*facRV     ! u u -> u u lm lp        Dt0g1Z
      case(589)
         factor=1d0/nc**4*facRV             ! db d -> db d lm lp      Dt0g1Z
      case(590)
         factor=1d0/nc**4*facRV             ! ub u -> ub u lm lp      Dt0g1Z
      case(591)
         factor=1d0/nc**4*1d0/2d0*facRV     ! db db -> db db lm lp     Dt0g1Z
      case(592)
         factor=1d0/nc**4*1d0/2d0*facRV     ! ub ub -> ub ub lm lp     Dt0g1Z
      case(593)
         factor=1d0/nc**4*facRV             ! g d subtraction         Dt0g1Z
      case(594)
         factor=1d0/nc**4*facRV             ! g u subtraction         Dt0g1Z
      case(595)
         factor=1d0/nc**4*facRV             ! g db subtraction        Dt0g1Z
      case(596)
         factor=1d0/nc**4*facRV             ! g ub subtraction        Dt0g1Z
      case(597)
         factor=1d0/nc**4*facRV             ! d g subtraction         Dt0g1Z
      case(598)
         factor=1d0/nc**4*facRV             ! u g subtraction         Dt0g1Z
      case(599)
         factor=1d0/nc**4*facRV             ! db g subtraction        Dt0g1Z
      case(600)
         factor=1d0/nc**4*facRV             ! ub g subtraction        Dt0g1Z
      case(601)
         factor=1d0/nc**3*nf*facRV          ! d db -> db d lm lp      Dh0g1Z
      case(602)
         factor=1d0/nc**3*nf*facRV          ! u ub -> ub u lm lp      Dh0g1Z
      case(603)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! d d -> d d lm lp        Dh0g1Z
      case(604)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! u u -> u u lm lp        Dh0g1Z
      case(605)
         factor=1d0/nc**3*nf*facRV          ! db d -> db d lm lp      Dh0g1Z
      case(606)
         factor=1d0/nc**3*nf*facRV          ! ub u -> ub u lm lp      Dh0g1Z
      case(607)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! db db -> db db lm lp     Dh0g1Z
      case(608)
         factor=1d0/nc**3*nf*1d0/2d0*facRV   ! ub ub -> ub ub lm lp     Dh0g1Z
      case(609)
         factor=1d0/nc**3*nf*facRV          ! g d subtraction         Dh0g1Z
      case(610)
         factor=1d0/nc**3*nf*facRV          ! g u subtraction         Dh0g1Z
      case(611)
         factor=1d0/nc**3*nf*facRV          ! g db subtraction        Dh0g1Z
      case(612)
         factor=1d0/nc**3*nf*facRV          ! g ub subtraction        Dh0g1Z
      case(613)
         factor=1d0/nc**3*nf*facRV          ! d g subtraction         Dh0g1Z
      case(614)
         factor=1d0/nc**3*nf*facRV          ! u g subtraction         Dh0g1Z
      case(615)
         factor=1d0/nc**3*nf*facRV          ! db g subtraction        Dh0g1Z
      case(616)
         factor=1d0/nc**3*nf*facRV          ! ub g subtraction        Dh0g1Z

c -- double virtual

      case(617)
         factor=facVV                       ! d g -> d lm lp          B1g2Z
      case(618)
         factor=facVV                       ! u g -> u lm lp          B1g2Z
      case(619)
         factor=facVV                       ! d db -> g lm lp         B1g2Z
      case(620)
         factor=facVV                       ! u ub -> g lm lp         B1g2Z
      case(621)
         factor=facVV                       ! g d -> d lm lp          B1g2Z
      case(622)
         factor=facVV                       ! g u -> u lm lp          B1g2Z
      case(623)
         factor=facVV                       ! db d -> g lm lp         B1g2Z
      case(624)
         factor=facVV                       ! ub u -> g lm lp         B1g2Z
      case(625)
         factor=facVV                       ! g db -> db lm lp        B1g2Z
      case(626)
         factor=facVV                       ! g ub -> ub lm lp        B1g2Z
      case(627)
         factor=facVV                       ! db g -> db lm lp        B1g2Z
      case(628)
         factor=facVV                       ! ub g -> ub lm lp        B1g2Z
      case(629)
         factor=ndown*facVV                 ! g g subtraction         B1g2Z
      case(630)
         factor=nup*facVV                   ! g g subtraction         B1g2Z
      case(631)
         factor=1d0/nc*facVV                ! d d subtraction         B1g2Z
      case(632)
         factor=1d0/nc*facVV                ! d u subtraction         B1g2Z
      case(633)
         factor=1d0/nc*facVV                ! u d subtraction         B1g2Z
      case(634)
         factor=1d0/nc*facVV                ! u u subtraction         B1g2Z
      case(635)
         factor=1d0/nc*facVV                ! d db subtraction        B1g2Z
      case(636)
         factor=1d0/nc*facVV                ! d ub subtraction        B1g2Z
      case(637)
         factor=1d0/nc*facVV                ! u db subtraction        B1g2Z
      case(638)
         factor=1d0/nc*facVV                ! u ub subtraction        B1g2Z
      case(639)
         factor=1d0/nc**2*facVV             ! d d subtraction         B1g2Z
      case(640)
         factor=1d0/nc**2*facVV             ! u u subtraction         B1g2Z
      case(641)
         factor=1d0/nc*facVV                ! db d subtraction        B1g2Z
      case(642)
         factor=1d0/nc*facVV                ! db u subtraction        B1g2Z
      case(643)
         factor=1d0/nc*facVV                ! ub d subtraction        B1g2Z
      case(644)
         factor=1d0/nc*facVV                ! ub u subtraction        B1g2Z
      case(645)
         factor=1d0/nc*facVV                ! db db subtraction       B1g2Z
      case(646)
         factor=1d0/nc*facVV                ! db ub subtraction       B1g2Z
      case(647)
         factor=1d0/nc*facVV                ! ub db subtraction       B1g2Z
      case(648)
         factor=1d0/nc*facVV                ! ub ub subtraction       B1g2Z
      case(649)
         factor=1d0/nc**2*facVV             ! db db subtraction       B1g2Z
      case(650)
         factor=1d0/nc**2*facVV             ! ub ub subtraction       B1g2Z
      case(651)
         factor=-1d0/nc**2*facVV            ! d g -> d lm lp          Bt1g2Z
      case(652)
         factor=-1d0/nc**2*facVV            ! u g -> u lm lp          Bt1g2Z
      case(653)
         factor=-1d0/nc**2*facVV            ! d db -> g lm lp         Bt1g2Z
      case(654)
         factor=-1d0/nc**2*facVV            ! u ub -> g lm lp         Bt1g2Z
      case(655)
         factor=-1d0/nc**2*facVV            ! g d -> d lm lp          Bt1g2Z
      case(656)
         factor=-1d0/nc**2*facVV            ! g u -> u lm lp          Bt1g2Z
      case(657)
         factor=-1d0/nc**2*facVV            ! db d -> g lm lp         Bt1g2Z
      case(658)
         factor=-1d0/nc**2*facVV            ! ub u -> g lm lp         Bt1g2Z
      case(659)
         factor=-1d0/nc**2*facVV            ! g db -> db lm lp        Bt1g2Z
      case(660)
         factor=-1d0/nc**2*facVV            ! g ub -> ub lm lp        Bt1g2Z
      case(661)
         factor=-1d0/nc**2*facVV            ! db g -> db lm lp        Bt1g2Z
      case(662)
         factor=-1d0/nc**2*facVV            ! ub g -> ub lm lp        Bt1g2Z
      case(663)
         factor=-1d0/nc**2*ndown*facVV      ! g g subtraction         Bt1g2Z
      case(664)
         factor=-1d0/nc**2*nup*facVV        ! g g subtraction         Bt1g2Z
      case(665)
         factor=-1d0/nc**3*facVV            ! d d subtraction         Bt1g2Z
      case(666)
         factor=-1d0/nc**3*facVV            ! d u subtraction         Bt1g2Z
      case(667)
         factor=-1d0/nc**3*facVV            ! u d subtraction         Bt1g2Z
      case(668)
         factor=-1d0/nc**3*facVV            ! u u subtraction         Bt1g2Z
      case(669)
         factor=-1d0/nc**3*facVV            ! d db subtraction        Bt1g2Z
      case(670)
         factor=-1d0/nc**3*facVV            ! d ub subtraction        Bt1g2Z
      case(671)
         factor=-1d0/nc**3*facVV            ! u db subtraction        Bt1g2Z
      case(672)
         factor=-1d0/nc**3*facVV            ! u ub subtraction        Bt1g2Z
      case(673)
         factor=-1d0/nc**4*facVV            ! d d subtraction         Bt1g2Z
      case(674)
         factor=-1d0/nc**4*facVV            ! u u subtraction         Bt1g2Z
      case(675)
         factor=-1d0/nc**3*facVV            ! db d subtraction        Bt1g2Z
      case(676)
         factor=-1d0/nc**3*facVV            ! db u subtraction        Bt1g2Z
      case(677)
         factor=-1d0/nc**3*facVV            ! ub d subtraction        Bt1g2Z
      case(678)
         factor=-1d0/nc**3*facVV            ! ub u subtraction        Bt1g2Z
      case(679)
         factor=-1d0/nc**3*facVV            ! db db subtraction       Bt1g2Z
      case(680)
         factor=-1d0/nc**3*facVV            ! db ub subtraction       Bt1g2Z
      case(681)
         factor=-1d0/nc**3*facVV            ! ub db subtraction       Bt1g2Z
      case(682)
         factor=-1d0/nc**3*facVV            ! ub ub subtraction       Bt1g2Z
      case(683)
         factor=-1d0/nc**4*facVV            ! db db subtraction       Bt1g2Z
      case(684)
         factor=-1d0/nc**4*facVV            ! ub ub subtraction       Bt1g2Z
      case(685)
         factor=1d0/nc**4*facVV             ! d g -> d lm lp          Btt1g2Z
      case(686)
         factor=1d0/nc**4*facVV             ! u g -> u lm lp          Btt1g2Z
      case(687)
         factor=1d0/nc**4*facVV             ! d db -> g lm lp         Btt1g2Z
      case(688)
         factor=1d0/nc**4*facVV             ! u ub -> g lm lp         Btt1g2Z
      case(689)
         factor=1d0/nc**4*facVV             ! g d -> d lm lp          Btt1g2Z
      case(690)
         factor=1d0/nc**4*facVV             ! g u -> u lm lp          Btt1g2Z
      case(691)
         factor=1d0/nc**4*facVV             ! db d -> g lm lp         Btt1g2Z
      case(692)
         factor=1d0/nc**4*facVV             ! ub u -> g lm lp         Btt1g2Z
      case(693)
         factor=1d0/nc**4*facVV             ! g db -> db lm lp        Btt1g2Z
      case(694)
         factor=1d0/nc**4*facVV             ! g ub -> ub lm lp        Btt1g2Z
      case(695)
         factor=1d0/nc**4*facVV             ! db g -> db lm lp        Btt1g2Z
      case(696)
         factor=1d0/nc**4*facVV             ! ub g -> ub lm lp        Btt1g2Z
      case(697)
         factor=1d0/nc**4*ndown*facVV       ! g g subtraction         Btt1g2Z
      case(698)
         factor=1d0/nc**4*nup*facVV         ! g g subtraction         Btt1g2Z
      case(699)
         factor=1d0/nc**5*facVV             ! d d subtraction         Btt1g2Z
      case(700)
         factor=1d0/nc**5*facVV             ! d u subtraction         Btt1g2Z
      case(701)
         factor=1d0/nc**5*facVV             ! u d subtraction         Btt1g2Z
      case(702)
         factor=1d0/nc**5*facVV             ! u u subtraction         Btt1g2Z
      case(703)
         factor=1d0/nc**5*facVV             ! d db subtraction        Btt1g2Z
      case(704)
         factor=1d0/nc**5*facVV             ! d ub subtraction        Btt1g2Z
      case(705)
         factor=1d0/nc**5*facVV             ! u db subtraction        Btt1g2Z
      case(706)
         factor=1d0/nc**5*facVV             ! u ub subtraction        Btt1g2Z
      case(707)
         factor=1d0/nc**6*facVV             ! d d subtraction         Btt1g2Z
      case(708)
         factor=1d0/nc**6*facVV             ! u u subtraction         Btt1g2Z
      case(709)
         factor=1d0/nc**5*facVV             ! db d subtraction        Btt1g2Z
      case(710)
         factor=1d0/nc**5*facVV             ! db u subtraction        Btt1g2Z
      case(711)
         factor=1d0/nc**5*facVV             ! ub d subtraction        Btt1g2Z
      case(712)
         factor=1d0/nc**5*facVV             ! ub u subtraction        Btt1g2Z
      case(713)
         factor=1d0/nc**5*facVV             ! db db subtraction       Btt1g2Z
      case(714)
         factor=1d0/nc**5*facVV             ! db ub subtraction       Btt1g2Z
      case(715)
         factor=1d0/nc**5*facVV             ! ub db subtraction       Btt1g2Z
      case(716)
         factor=1d0/nc**5*facVV             ! ub ub subtraction       Btt1g2Z
      case(717)
         factor=1d0/nc**6*facVV             ! db db subtraction       Btt1g2Z
      case(718)
         factor=1d0/nc**6*facVV             ! ub ub subtraction       Btt1g2Z
      case(719)
         factor=1d0/nc*nf*facVV             ! d g -> d lm lp          Bh1g2Z
      case(720)
         factor=1d0/nc*nf*facVV             ! u g -> u lm lp          Bh1g2Z
      case(721)
         factor=1d0/nc*nf*facVV             ! d db -> g lm lp         Bh1g2Z
      case(722)
         factor=1d0/nc*nf*facVV             ! u ub -> g lm lp         Bh1g2Z
      case(723)
         factor=1d0/nc*nf*facVV             ! g d -> d lm lp          Bh1g2Z
      case(724)
         factor=1d0/nc*nf*facVV             ! g u -> u lm lp          Bh1g2Z
      case(725)
         factor=1d0/nc*nf*facVV             ! db d -> g lm lp         Bh1g2Z
      case(726)
         factor=1d0/nc*nf*facVV             ! ub u -> g lm lp         Bh1g2Z
      case(727)
         factor=1d0/nc*nf*facVV             ! g db -> db lm lp        Bh1g2Z
      case(728)
         factor=1d0/nc*nf*facVV             ! g ub -> ub lm lp        Bh1g2Z
      case(729)
         factor=1d0/nc*nf*facVV             ! db g -> db lm lp        Bh1g2Z
      case(730)
         factor=1d0/nc*nf*facVV             ! ub g -> ub lm lp        Bh1g2Z
      case(731)
         factor=1d0/nc*ndown*facVV          ! d g subtraction         Bh1g2Z
      case(732)
         factor=1d0/nc*ndown*facVV          ! u g subtraction         Bh1g2Z
      case(733)
         factor=1d0/nc*nup*facVV            ! d g subtraction         Bh1g2Z
      case(734)
         factor=1d0/nc*nup*facVV            ! u g subtraction         Bh1g2Z
      case(735)
         factor=1d0/nc*ndown*facVV          ! db g subtraction        Bh1g2Z
      case(736)
         factor=1d0/nc*ndown*facVV          ! ub g subtraction        Bh1g2Z
      case(737)
         factor=1d0/nc*nup*facVV            ! db g subtraction        Bh1g2Z
      case(738)
         factor=1d0/nc*nup*facVV            ! ub g subtraction        Bh1g2Z
      case(739)
         factor=1d0/nc*ndown*facVV          ! g d subtraction         Bh1g2Z
      case(740)
         factor=1d0/nc*ndown*facVV          ! g u subtraction         Bh1g2Z
      case(741)
         factor=1d0/nc*nup*facVV            ! g d subtraction         Bh1g2Z
      case(742)
         factor=1d0/nc*nup*facVV            ! g u subtraction         Bh1g2Z
      case(743)
         factor=1d0/nc*ndown*facVV          ! g db subtraction        Bh1g2Z
      case(744)
         factor=1d0/nc*ndown*facVV          ! g ub subtraction        Bh1g2Z
      case(745)
         factor=1d0/nc*nup*facVV            ! g db subtraction        Bh1g2Z
      case(746)
         factor=1d0/nc*nup*facVV            ! g ub subtraction        Bh1g2Z
      case(747)
         factor=1d0/nc*ndown*nf*facVV       ! g g subtraction         Bh1g2Z
      case(748)
         factor=1d0/nc*nf*nup*facVV         ! g g subtraction         Bh1g2Z
      case(749)
         factor=1d0/nc**2*nf*facVV          ! d d subtraction         Bh1g2Z
      case(750)
         factor=1d0/nc**2*nf*facVV          ! d u subtraction         Bh1g2Z
      case(751)
         factor=1d0/nc**2*nf*facVV          ! u d subtraction         Bh1g2Z
      case(752)
         factor=1d0/nc**2*nf*facVV          ! u u subtraction         Bh1g2Z
      case(753)
         factor=1d0/nc**2*nf*facVV          ! d db subtraction        Bh1g2Z
      case(754)
         factor=1d0/nc**2*nf*facVV          ! d ub subtraction        Bh1g2Z
      case(755)
         factor=1d0/nc**2*nf*facVV          ! u db subtraction        Bh1g2Z
      case(756)
         factor=1d0/nc**2*nf*facVV          ! u ub subtraction        Bh1g2Z
      case(757)
         factor=1d0/nc**3*nf*facVV          ! d d subtraction         Bh1g2Z
      case(758)
         factor=1d0/nc**3*nf*facVV          ! u u subtraction         Bh1g2Z
      case(759)
         factor=1d0/nc**2*nf*facVV          ! db d subtraction        Bh1g2Z
      case(760)
         factor=1d0/nc**2*nf*facVV          ! db u subtraction        Bh1g2Z
      case(761)
         factor=1d0/nc**2*nf*facVV          ! ub d subtraction        Bh1g2Z
      case(762)
         factor=1d0/nc**2*nf*facVV          ! ub u subtraction        Bh1g2Z
      case(763)
         factor=1d0/nc**2*nf*facVV          ! db db subtraction       Bh1g2Z
      case(764)
         factor=1d0/nc**2*nf*facVV          ! db ub subtraction       Bh1g2Z
      case(765)
         factor=1d0/nc**2*nf*facVV          ! ub db subtraction       Bh1g2Z
      case(766)
         factor=1d0/nc**2*nf*facVV          ! ub ub subtraction       Bh1g2Z
      case(767)
         factor=1d0/nc**3*nf*facVV          ! db db subtraction       Bh1g2Z
      case(768)
         factor=1d0/nc**3*nf*facVV          ! ub ub subtraction       Bh1g2Z
      case(769)
         factor=1d0/nc**3*nf*facVV          ! d g -> d lm lp          Bht1g2Z
      case(770)
         factor=1d0/nc**3*nf*facVV          ! u g -> u lm lp          Bht1g2Z
      case(771)
         factor=1d0/nc**3*nf*facVV          ! d db -> g lm lp         Bht1g2Z
      case(772)
         factor=1d0/nc**3*nf*facVV          ! u ub -> g lm lp         Bht1g2Z
      case(773)
         factor=1d0/nc**3*nf*facVV          ! g d -> d lm lp          Bht1g2Z
      case(774)
         factor=1d0/nc**3*nf*facVV          ! g u -> u lm lp          Bht1g2Z
      case(775)
         factor=1d0/nc**3*nf*facVV          ! db d -> g lm lp         Bht1g2Z
      case(776)
         factor=1d0/nc**3*nf*facVV          ! ub u -> g lm lp         Bht1g2Z
      case(777)
         factor=1d0/nc**3*nf*facVV          ! g db -> db lm lp        Bht1g2Z
      case(778)
         factor=1d0/nc**3*nf*facVV          ! g ub -> ub lm lp        Bht1g2Z
      case(779)
         factor=1d0/nc**3*nf*facVV          ! db g -> db lm lp        Bht1g2Z
      case(780)
         factor=1d0/nc**3*nf*facVV          ! ub g -> ub lm lp        Bht1g2Z
      case(781)
         factor=1d0/nc**3*ndown*facVV       ! d g subtraction         Bht1g2Z
      case(782)
         factor=1d0/nc**3*ndown*facVV       ! u g subtraction         Bht1g2Z
      case(783)
         factor=1d0/nc**3*nup*facVV         ! d g subtraction         Bht1g2Z
      case(784)
         factor=1d0/nc**3*nup*facVV         ! u g subtraction         Bht1g2Z
      case(785)
         factor=1d0/nc**3*ndown*facVV       ! db g subtraction        Bht1g2Z
      case(786)
         factor=1d0/nc**3*ndown*facVV       ! ub g subtraction        Bht1g2Z
      case(787)
         factor=1d0/nc**3*nup*facVV         ! db g subtraction        Bht1g2Z
      case(788)
         factor=1d0/nc**3*nup*facVV         ! ub g subtraction        Bht1g2Z
      case(789)
         factor=1d0/nc**3*ndown*facVV       ! g d subtraction         Bht1g2Z
      case(790)
         factor=1d0/nc**3*ndown*facVV       ! g u subtraction         Bht1g2Z
      case(791)
         factor=1d0/nc**3*nup*facVV         ! g d subtraction         Bht1g2Z
      case(792)
         factor=1d0/nc**3*nup*facVV         ! g u subtraction         Bht1g2Z
      case(793)
         factor=1d0/nc**3*ndown*facVV       ! g db subtraction        Bht1g2Z
      case(794)
         factor=1d0/nc**3*ndown*facVV       ! g ub subtraction        Bht1g2Z
      case(795)
         factor=1d0/nc**3*nup*facVV         ! g db subtraction        Bht1g2Z
      case(796)
         factor=1d0/nc**3*nup*facVV         ! g ub subtraction        Bht1g2Z
      case(797)
         factor=1d0/nc**3*ndown*nf*facVV    ! g g subtraction         Bht1g2Z
      case(798)
         factor=1d0/nc**3*nf*nup*facVV      ! g g subtraction         Bht1g2Z
      case(799)
         factor=1d0/nc**4*nf*facVV          ! d d subtraction         Bht1g2Z
      case(800)
         factor=1d0/nc**4*nf*facVV          ! d u subtraction         Bht1g2Z
      case(801)
         factor=1d0/nc**4*nf*facVV          ! u d subtraction         Bht1g2Z
      case(802)
         factor=1d0/nc**4*nf*facVV          ! u u subtraction         Bht1g2Z
      case(803)
         factor=1d0/nc**4*nf*facVV          ! d db subtraction        Bht1g2Z
      case(804)
         factor=1d0/nc**4*nf*facVV          ! d ub subtraction        Bht1g2Z
      case(805)
         factor=1d0/nc**4*nf*facVV          ! u db subtraction        Bht1g2Z
      case(806)
         factor=1d0/nc**4*nf*facVV          ! u ub subtraction        Bht1g2Z
      case(807)
         factor=1d0/nc**5*nf*facVV          ! d d subtraction         Bht1g2Z
      case(808)
         factor=1d0/nc**5*nf*facVV          ! u u subtraction         Bht1g2Z
      case(809)
         factor=1d0/nc**4*nf*facVV          ! db d subtraction        Bht1g2Z
      case(810)
         factor=1d0/nc**4*nf*facVV          ! db u subtraction        Bht1g2Z
      case(811)
         factor=1d0/nc**4*nf*facVV          ! ub d subtraction        Bht1g2Z
      case(812)
         factor=1d0/nc**4*nf*facVV          ! ub u subtraction        Bht1g2Z
      case(813)
         factor=1d0/nc**4*nf*facVV          ! db db subtraction       Bht1g2Z
      case(814)
         factor=1d0/nc**4*nf*facVV          ! db ub subtraction       Bht1g2Z
      case(815)
         factor=1d0/nc**4*nf*facVV          ! ub db subtraction       Bht1g2Z
      case(816)
         factor=1d0/nc**4*nf*facVV          ! ub ub subtraction       Bht1g2Z
      case(817)
         factor=1d0/nc**5*nf*facVV          ! db db subtraction       Bht1g2Z
      case(818)
         factor=1d0/nc**5*nf*facVV          ! ub ub subtraction       Bht1g2Z
      case(819)
         factor=1d0/nc**2*nf**2*facVV       ! d g -> d lm lp          Bhh1g2Z
      case(820)
         factor=1d0/nc**2*nf**2*facVV       ! u g -> u lm lp          Bhh1g2Z
      case(821)
         factor=1d0/nc**2*nf**2*facVV       ! d db -> g lm lp         Bhh1g2Z
      case(822)
         factor=1d0/nc**2*nf**2*facVV       ! u ub -> g lm lp         Bhh1g2Z
      case(823)
         factor=1d0/nc**2*nf**2*facVV       ! g d -> d lm lp          Bhh1g2Z
      case(824)
         factor=1d0/nc**2*nf**2*facVV       ! g u -> u lm lp          Bhh1g2Z
      case(825)
         factor=1d0/nc**2*nf**2*facVV       ! db d -> g lm lp         Bhh1g2Z
      case(826)
         factor=1d0/nc**2*nf**2*facVV       ! ub u -> g lm lp         Bhh1g2Z
      case(827)
         factor=1d0/nc**2*nf**2*facVV       ! g db -> db lm lp        Bhh1g2Z
      case(828)
         factor=1d0/nc**2*nf**2*facVV       ! g ub -> ub lm lp        Bhh1g2Z
      case(829)
         factor=1d0/nc**2*nf**2*facVV       ! db g -> db lm lp        Bhh1g2Z
      case(830)
         factor=1d0/nc**2*nf**2*facVV       ! ub g -> ub lm lp        Bhh1g2Z
      case(831)
         factor=1d0/nc**2*ndown*nf*facVV    ! d g subtraction         Bhh1g2Z
      case(832)
         factor=1d0/nc**2*ndown*nf*facVV    ! u g subtraction         Bhh1g2Z
      case(833)
         factor=1d0/nc**2*nf*nup*facVV      ! d g subtraction         Bhh1g2Z
      case(834)
         factor=1d0/nc**2*nf*nup*facVV      ! u g subtraction         Bhh1g2Z
      case(835)
         factor=1d0/nc**2*ndown*nf*facVV    ! db g subtraction        Bhh1g2Z
      case(836)
         factor=1d0/nc**2*ndown*nf*facVV    ! ub g subtraction        Bhh1g2Z
      case(837)
         factor=1d0/nc**2*nf*nup*facVV      ! db g subtraction        Bhh1g2Z
      case(838)
         factor=1d0/nc**2*nf*nup*facVV      ! ub g subtraction        Bhh1g2Z
      case(839)
         factor=1d0/nc**2*ndown*nf*facVV    ! g d subtraction         Bhh1g2Z
      case(840)
         factor=1d0/nc**2*ndown*nf*facVV    ! g u subtraction         Bhh1g2Z
      case(841)
         factor=1d0/nc**2*nf*nup*facVV      ! g d subtraction         Bhh1g2Z
      case(842)
         factor=1d0/nc**2*nf*nup*facVV      ! g u subtraction         Bhh1g2Z
      case(843)
         factor=1d0/nc**2*ndown*nf*facVV    ! g db subtraction        Bhh1g2Z
      case(844)
         factor=1d0/nc**2*ndown*nf*facVV    ! g ub subtraction        Bhh1g2Z
      case(845)
         factor=1d0/nc**2*nf*nup*facVV      ! g db subtraction        Bhh1g2Z
      case(846)
         factor=1d0/nc**2*nf*nup*facVV      ! g ub subtraction        Bhh1g2Z
      case(847)
         factor=1d0/nc**2*ndown*nf**2*facVV   ! g g subtraction         Bhh1g2Z
      case(848)
         factor=1d0/nc**2*nf**2*nup*facVV   ! g g subtraction         Bhh1g2Z
      case(849)
         factor=1d0/nc**3*nf**2*facVV       ! d d subtraction         Bhh1g2Z
      case(850)
         factor=1d0/nc**3*nf**2*facVV       ! d u subtraction         Bhh1g2Z
      case(851)
         factor=1d0/nc**3*nf**2*facVV       ! u d subtraction         Bhh1g2Z
      case(852)
         factor=1d0/nc**3*nf**2*facVV       ! u u subtraction         Bhh1g2Z
      case(853)
         factor=1d0/nc**3*nf**2*facVV       ! d db subtraction        Bhh1g2Z
      case(854)
         factor=1d0/nc**3*nf**2*facVV       ! d ub subtraction        Bhh1g2Z
      case(855)
         factor=1d0/nc**3*nf**2*facVV       ! u db subtraction        Bhh1g2Z
      case(856)
         factor=1d0/nc**3*nf**2*facVV       ! u ub subtraction        Bhh1g2Z
      case(857)
         factor=1d0/nc**4*nf**2*facVV       ! d d subtraction         Bhh1g2Z
      case(858)
         factor=1d0/nc**4*nf**2*facVV       ! u u subtraction         Bhh1g2Z
      case(859)
         factor=1d0/nc**3*nf**2*facVV       ! db d subtraction        Bhh1g2Z
      case(860)
         factor=1d0/nc**3*nf**2*facVV       ! db u subtraction        Bhh1g2Z
      case(861)
         factor=1d0/nc**3*nf**2*facVV       ! ub d subtraction        Bhh1g2Z
      case(862)
         factor=1d0/nc**3*nf**2*facVV       ! ub u subtraction        Bhh1g2Z
      case(863)
         factor=1d0/nc**3*nf**2*facVV       ! db db subtraction       Bhh1g2Z
      case(864)
         factor=1d0/nc**3*nf**2*facVV       ! db ub subtraction       Bhh1g2Z
      case(865)
         factor=1d0/nc**3*nf**2*facVV       ! ub db subtraction       Bhh1g2Z
      case(866)
         factor=1d0/nc**3*nf**2*facVV       ! ub ub subtraction       Bhh1g2Z
      case(867)
         factor=1d0/nc**4*nf**2*facVV       ! db db subtraction       Bhh1g2Z
      case(868)
         factor=1d0/nc**4*nf**2*facVV       ! ub ub subtraction       Bhh1g2Z
      end select
      factor=relfactor*factor

      return
      end
