C --- Quark pair NNLO double real subtraction term for
C ---
C --- q(i1) g (i2) g (i3) g(i4) qb(i5) e-(i6) e+(i7)
C ---
C --- summed and squared over helicities, single colour ordering without
C --- overall factors
C ---
C --- The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function gqsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqsB3g0ZS = qgsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)

      return
      end
      function gqbsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqbsB3g0ZS = qbgsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)

      return
      end

      function qgsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qgsB3g0ZS = +qgB3g0ZYS(i1,i3,i2,i4,i5,i6,i7)
     .            +qgB3g0ZXS(i1,i2,i3,i4,i5,i6,i7)
     .            +qgB3g0ZXS(i1,i2,i4,i3,i5,i6,i7)

      return
      end

      function qbgsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbgsB3g0ZS = +qbgB3g0ZYS(i1,i3,i2,i4,i5,i6,i7)
     .             +qbgB3g0ZXS(i1,i3,i4,i2,i5,i6,i7)
     .             +qbgB3g0ZXS(i1,i4,i3,i2,i5,i6,i7)

      return
      end

      function ggsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

C --- Xuan's subtraction term
C --- ggsB3g0ZS = ggB3g0ZFS_v1(i1,i2,i4,i3,i5,i6,i7)

C --- Aude's subtraction term
      ggsB3g0ZS = ggB3g0ZFS(i1,i2,i3,i4,i5,i6,i7)
     .           +ggB3g0ZFS(i1,i3,i2,i4,i5,i6,i7)

      return
      end

      function qbqsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbqsB3g0ZS = qqbsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)

      return
      end

      function qqbsB3g0ZS(i1,i2,i3,i4,i5,i6,i7)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qqbsB3g0ZS = qqbB3g0ZS(i1,i2,i3,i4,i5,i6,i7)
     .            +qqbB3g0ZS(i1,i2,i4,i3,i5,i6,i7)
     .            +qqbB3g0ZS(i1,i3,i2,i4,i5,i6,i7)

      return
      end


