      function sigRVZJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRVZJ=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_vj(0,6,ipass)
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return
      ix=1
      ix_chan=1

#ifdef USE_OL  
      call fill_pOL(6, (/ 1, 2, 3, 4, 5, 6 /) )
#endif 

c--- d g to g d lm lp 
      if (qactive_chan(317).and.qselect_chan(317)) then
        current_chan = 317
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(1,2,3,4,5,6,muR2_scl(i))
     .          +sB2g1Z(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to g u lm lp 
      if (qactive_chan(318).and.qselect_chan(318)) then
        current_chan = 318
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(1,2,3,4,5,6,muR2_scl(i))
     .          +sB2g1Z(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g g lm lp 
      if (qactive_chan(319).and.qselect_chan(319)) then
        current_chan = 319
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(1,3,4,2,5,6,muR2_scl(i))
     .          +sB2g1Z(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g g lm lp 
      if (qactive_chan(320).and.qselect_chan(320)) then
        current_chan = 320
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(1,3,4,2,5,6,muR2_scl(i))
     .          +sB2g1Z(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g d lm lp 
      if (qactive_chan(321).and.qselect_chan(321)) then
        current_chan = 321
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(2,1,3,4,5,6,muR2_scl(i))
     .          +sB2g1Z(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to g u lm lp 
      if (qactive_chan(322).and.qselect_chan(322)) then
        current_chan = 322
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(2,1,3,4,5,6,muR2_scl(i))
     .          +sB2g1Z(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g g lm lp 
      if (qactive_chan(323).and.qselect_chan(323)) then
        current_chan = 323
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(2,3,4,1,5,6,muR2_scl(i))
     .          +sB2g1Z(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g g lm lp 
      if (qactive_chan(324).and.qselect_chan(324)) then
        current_chan = 324
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(2,3,4,1,5,6,muR2_scl(i))
     .          +sB2g1Z(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db d lm lp 
      if (qactive_chan(325).and.qselect_chan(325)) then
        current_chan = 325
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(3,1,2,4,5,6,muR2_scl(i))
     .          +sB2g1Z(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to ub u lm lp 
      if (qactive_chan(326).and.qselect_chan(326)) then
        current_chan = 326
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(3,1,2,4,5,6,muR2_scl(i))
     .          +sB2g1Z(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db g lm lp 
      if (qactive_chan(327).and.qselect_chan(327)) then
        current_chan = 327
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(3,1,4,2,5,6,muR2_scl(i))
     .          +sB2g1Z(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub g lm lp 
      if (qactive_chan(328).and.qselect_chan(328)) then
        current_chan = 328
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(3,1,4,2,5,6,muR2_scl(i))
     .          +sB2g1Z(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db g lm lp 
      if (qactive_chan(329).and.qselect_chan(329)) then
        current_chan = 329
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(3,2,4,1,5,6,muR2_scl(i))
     .          +sB2g1Z(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub g lm lp 
      if (qactive_chan(330).and.qselect_chan(330)) then
        current_chan = 330
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sB2g1Z(3,2,4,1,5,6,muR2_scl(i))
     .          +sB2g1Z(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to g d lm lp 
      if (qactive_chan(347).and.qselect_chan(347)) then
        current_chan = 347
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(1,2,3,4,5,6,muR2_scl(i))
     .          +sBt2g1Z(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to g u lm lp 
      if (qactive_chan(348).and.qselect_chan(348)) then
        current_chan = 348
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(1,2,3,4,5,6,muR2_scl(i))
     .          +sBt2g1Z(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g g lm lp 
      if (qactive_chan(349).and.qselect_chan(349)) then
        current_chan = 349
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(1,3,4,2,5,6,muR2_scl(i))
     .          +sBt2g1Z(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g g lm lp 
      if (qactive_chan(350).and.qselect_chan(350)) then
        current_chan = 350
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(1,3,4,2,5,6,muR2_scl(i))
     .          +sBt2g1Z(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g d lm lp 
      if (qactive_chan(351).and.qselect_chan(351)) then
        current_chan = 351
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(2,1,3,4,5,6,muR2_scl(i))
     .          +sBt2g1Z(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to g u lm lp 
      if (qactive_chan(352).and.qselect_chan(352)) then
        current_chan = 352
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(2,1,3,4,5,6,muR2_scl(i))
     .          +sBt2g1Z(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g g lm lp 
      if (qactive_chan(353).and.qselect_chan(353)) then
        current_chan = 353
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(2,3,4,1,5,6,muR2_scl(i))
     .          +sBt2g1Z(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g g lm lp 
      if (qactive_chan(354).and.qselect_chan(354)) then
        current_chan = 354
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(2,3,4,1,5,6,muR2_scl(i))
     .          +sBt2g1Z(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db d lm lp 
      if (qactive_chan(355).and.qselect_chan(355)) then
        current_chan = 355
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(3,1,2,4,5,6,muR2_scl(i))
     .          +sBt2g1Z(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to ub u lm lp 
      if (qactive_chan(356).and.qselect_chan(356)) then
        current_chan = 356
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(3,1,2,4,5,6,muR2_scl(i))
     .          +sBt2g1Z(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db g lm lp 
      if (qactive_chan(357).and.qselect_chan(357)) then
        current_chan = 357
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(3,1,4,2,5,6,muR2_scl(i))
     .          +sBt2g1Z(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub g lm lp 
      if (qactive_chan(358).and.qselect_chan(358)) then
        current_chan = 358
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(3,1,4,2,5,6,muR2_scl(i))
     .          +sBt2g1Z(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db g lm lp 
      if (qactive_chan(359).and.qselect_chan(359)) then
        current_chan = 359
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(3,2,4,1,5,6,muR2_scl(i))
     .          +sBt2g1Z(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub g lm lp 
      if (qactive_chan(360).and.qselect_chan(360)) then
        current_chan = 360
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBt2g1Z(3,2,4,1,5,6,muR2_scl(i))
     .          +sBt2g1Z(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt d lm lp 
      if (qactive_chan(377).and.qselect_chan(377)) then
        current_chan = 377
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u gt to gt u lm lp 
      if (qactive_chan(378).and.qselect_chan(378)) then
        current_chan = 378
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to gt gt lm lp 
      if (qactive_chan(379).and.qselect_chan(379)) then
        current_chan = 379
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Zc(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to gt gt lm lp 
      if (qactive_chan(380).and.qselect_chan(380)) then
        current_chan = 380
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Zc(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt d lm lp 
      if (qactive_chan(381).and.qselect_chan(381)) then
        current_chan = 381
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt u to gt u lm lp 
      if (qactive_chan(382).and.qselect_chan(382)) then
        current_chan = 382
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to gt gt lm lp 
      if (qactive_chan(383).and.qselect_chan(383)) then
        current_chan = 383
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Zc(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to gt gt lm lp 
      if (qactive_chan(384).and.qselect_chan(384)) then
        current_chan = 384
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBtt2g1Zc(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db d lm lp 
      if (qactive_chan(385).and.qselect_chan(385)) then
        current_chan = 385
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to ub u lm lp 
      if (qactive_chan(386).and.qselect_chan(386)) then
        current_chan = 386
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt db to db gt lm lp 
      if (qactive_chan(387).and.qselect_chan(387)) then
        current_chan = 387
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to ub gt lm lp 
      if (qactive_chan(388).and.qselect_chan(388)) then
        current_chan = 388
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db gt to db gt lm lp 
      if (qactive_chan(389).and.qselect_chan(389)) then
        current_chan = 389
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to ub gt lm lp 
      if (qactive_chan(390).and.qselect_chan(390)) then
        current_chan = 390
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBtt2g1Zc(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt d lm lp 
      if (qactive_chan(391).and.qselect_chan(391)) then
        current_chan = 391
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u gt to gt u lm lp 
      if (qactive_chan(392).and.qselect_chan(392)) then
        current_chan = 392
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to gt gt lm lp 
      if (qactive_chan(393).and.qselect_chan(393)) then
        current_chan = 393
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1Z(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to gt gt lm lp 
      if (qactive_chan(394).and.qselect_chan(394)) then
        current_chan = 394
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1Z(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt d lm lp 
      if (qactive_chan(395).and.qselect_chan(395)) then
        current_chan = 395
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt u to gt u lm lp 
      if (qactive_chan(396).and.qselect_chan(396)) then
        current_chan = 396
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to gt gt lm lp 
      if (qactive_chan(397).and.qselect_chan(397)) then
        current_chan = 397
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1Z(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to gt gt lm lp 
      if (qactive_chan(398).and.qselect_chan(398)) then
        current_chan = 398
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBttt2g1Z(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db d lm lp 
      if (qactive_chan(399).and.qselect_chan(399)) then
        current_chan = 399
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to ub u lm lp 
      if (qactive_chan(400).and.qselect_chan(400)) then
        current_chan = 400
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt db to db gt lm lp 
      if (qactive_chan(401).and.qselect_chan(401)) then
        current_chan = 401
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to ub gt lm lp 
      if (qactive_chan(402).and.qselect_chan(402)) then
        current_chan = 402
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db gt to db gt lm lp 
      if (qactive_chan(403).and.qselect_chan(403)) then
        current_chan = 403
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to ub gt lm lp 
      if (qactive_chan(404).and.qselect_chan(404)) then
        current_chan = 404
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBttt2g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d g to g d lm lp 
      if (qactive_chan(405).and.qselect_chan(405)) then
        current_chan = 405
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(1,2,3,4,5,6,muR2_scl(i))
     .          +sBh2g1Z(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u g to g u lm lp 
      if (qactive_chan(406).and.qselect_chan(406)) then
        current_chan = 406
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(1,2,3,4,5,6,muR2_scl(i))
     .          +sBh2g1Z(1,3,2,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to g g lm lp 
      if (qactive_chan(407).and.qselect_chan(407)) then
        current_chan = 407
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(1,3,4,2,5,6,muR2_scl(i))
     .          +sBh2g1Z(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to g g lm lp 
      if (qactive_chan(408).and.qselect_chan(408)) then
        current_chan = 408
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(1,3,4,2,5,6,muR2_scl(i))
     .          +sBh2g1Z(1,4,3,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g d to g d lm lp 
      if (qactive_chan(409).and.qselect_chan(409)) then
        current_chan = 409
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(2,1,3,4,5,6,muR2_scl(i))
     .          +sBh2g1Z(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g u to g u lm lp 
      if (qactive_chan(410).and.qselect_chan(410)) then
        current_chan = 410
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(2,1,3,4,5,6,muR2_scl(i))
     .          +sBh2g1Z(2,3,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to g g lm lp 
      if (qactive_chan(411).and.qselect_chan(411)) then
        current_chan = 411
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(2,3,4,1,5,6,muR2_scl(i))
     .          +sBh2g1Z(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to g g lm lp 
      if (qactive_chan(412).and.qselect_chan(412)) then
        current_chan = 412
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(2,3,4,1,5,6,muR2_scl(i))
     .          +sBh2g1Z(2,4,3,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to db d lm lp 
      if (qactive_chan(413).and.qselect_chan(413)) then
        current_chan = 413
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(3,1,2,4,5,6,muR2_scl(i))
     .          +sBh2g1Z(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g g to ub u lm lp 
      if (qactive_chan(414).and.qselect_chan(414)) then
        current_chan = 414
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(3,1,2,4,5,6,muR2_scl(i))
     .          +sBh2g1Z(3,2,1,4,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g db to db g lm lp 
      if (qactive_chan(415).and.qselect_chan(415)) then
        current_chan = 415
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(3,1,4,2,5,6,muR2_scl(i))
     .          +sBh2g1Z(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- g ub to ub g lm lp 
      if (qactive_chan(416).and.qselect_chan(416)) then
        current_chan = 416
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(3,1,4,2,5,6,muR2_scl(i))
     .          +sBh2g1Z(3,4,1,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db g to db g lm lp 
      if (qactive_chan(417).and.qselect_chan(417)) then
        current_chan = 417
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(3,2,4,1,5,6,muR2_scl(i))
     .          +sBh2g1Z(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub g to ub g lm lp 
      if (qactive_chan(418).and.qselect_chan(418)) then
        current_chan = 418
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBh2g1Z(3,2,4,1,5,6,muR2_scl(i))
     .          +sBh2g1Z(3,4,2,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d gt to gt d lm lp 
      if (qactive_chan(435).and.qselect_chan(435)) then
        current_chan = 435
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u gt to gt u lm lp 
      if (qactive_chan(436).and.qselect_chan(436)) then
        current_chan = 436
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to gt gt lm lp 
      if (qactive_chan(437).and.qselect_chan(437)) then
        current_chan = 437
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1Z(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to gt gt lm lp 
      if (qactive_chan(438).and.qselect_chan(438)) then
        current_chan = 438
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1Z(1,3,4,2,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt d to gt d lm lp 
      if (qactive_chan(439).and.qselect_chan(439)) then
        current_chan = 439
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt u to gt u lm lp 
      if (qactive_chan(440).and.qselect_chan(440)) then
        current_chan = 440
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to gt gt lm lp 
      if (qactive_chan(441).and.qselect_chan(441)) then
        current_chan = 441
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1Z(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to gt gt lm lp 
      if (qactive_chan(442).and.qselect_chan(442)) then
        current_chan = 442
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = (
     .           sBth2g1Z(2,3,4,1,5,6,muR2_scl(i)) )
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to db d lm lp 
      if (qactive_chan(443).and.qselect_chan(443)) then
        current_chan = 443
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt gt to ub u lm lp 
      if (qactive_chan(444).and.qselect_chan(444)) then
        current_chan = 444
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(3,1,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt db to db gt lm lp 
      if (qactive_chan(445).and.qselect_chan(445)) then
        current_chan = 445
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- gt ub to ub gt lm lp 
      if (qactive_chan(446).and.qselect_chan(446)) then
        current_chan = 446
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db gt to db gt lm lp 
      if (qactive_chan(447).and.qselect_chan(447)) then
        current_chan = 447
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub gt to ub gt lm lp 
      if (qactive_chan(448).and.qselect_chan(448)) then
        current_chan = 448
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sBth2g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d lm lp 
      if (qactive_chan(449).and.qselect_chan(449)) then
        current_chan = 449
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to ub d lm lp 
      if (qactive_chan(450).and.qselect_chan(450)) then
        current_chan = 450
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u db to db u lm lp 
      if (qactive_chan(451).and.qselect_chan(451)) then
        current_chan = 451
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u lm lp 
      if (qactive_chan(452).and.qselect_chan(452)) then
        current_chan = 452
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d lm lp 
      if (qactive_chan(453).and.qselect_chan(453)) then
        current_chan = 453
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to u d lm lp 
      if (qactive_chan(454).and.qselect_chan(454)) then
        current_chan = 454
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to d u lm lp 
      if (qactive_chan(455).and.qselect_chan(455)) then
        current_chan = 455
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u lm lp 
      if (qactive_chan(456).and.qselect_chan(456)) then
        current_chan = 456
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to d db lm lp 
      if (qactive_chan(457).and.qselect_chan(457)) then
        current_chan = 457
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to u ub lm lp 
      if (qactive_chan(458).and.qselect_chan(458)) then
        current_chan = 458
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to d db lm lp 
      if (qactive_chan(459).and.qselect_chan(459)) then
        current_chan = 459
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to u ub lm lp 
      if (qactive_chan(460).and.qselect_chan(460)) then
        current_chan = 460
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to d db lm lp 
      if (qactive_chan(461).and.qselect_chan(461)) then
        current_chan = 461
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to u ub lm lp 
      if (qactive_chan(462).and.qselect_chan(462)) then
        current_chan = 462
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to d db lm lp 
      if (qactive_chan(463).and.qselect_chan(463)) then
        current_chan = 463
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to u ub lm lp 
      if (qactive_chan(464).and.qselect_chan(464)) then
        current_chan = 464
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db lm lp 
      if (qactive_chan(465).and.qselect_chan(465)) then
        current_chan = 465
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db ub lm lp 
      if (qactive_chan(466).and.qselect_chan(466)) then
        current_chan = 466
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to ub db lm lp 
      if (qactive_chan(467).and.qselect_chan(467)) then
        current_chan = 467
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub lm lp 
      if (qactive_chan(468).and.qselect_chan(468)) then
        current_chan = 468
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d lm lp 
      if (qactive_chan(469).and.qselect_chan(469)) then
        current_chan = 469
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db u to db u lm lp 
      if (qactive_chan(470).and.qselect_chan(470)) then
        current_chan = 470
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to ub d lm lp 
      if (qactive_chan(471).and.qselect_chan(471)) then
        current_chan = 471
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u lm lp 
      if (qactive_chan(472).and.qselect_chan(472)) then
        current_chan = 472
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = sC0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d lm lp 
      if (qactive_chan(489).and.qselect_chan(489)) then
        current_chan = 489
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to ub d lm lp 
      if (qactive_chan(490).and.qselect_chan(490)) then
        current_chan = 490
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u db to db u lm lp 
      if (qactive_chan(491).and.qselect_chan(491)) then
        current_chan = 491
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u lm lp 
      if (qactive_chan(492).and.qselect_chan(492)) then
        current_chan = 492
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d lm lp 
      if (qactive_chan(493).and.qselect_chan(493)) then
        current_chan = 493
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to u d lm lp 
      if (qactive_chan(494).and.qselect_chan(494)) then
        current_chan = 494
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to d u lm lp 
      if (qactive_chan(495).and.qselect_chan(495)) then
        current_chan = 495
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u lm lp 
      if (qactive_chan(496).and.qselect_chan(496)) then
        current_chan = 496
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to d db lm lp 
      if (qactive_chan(497).and.qselect_chan(497)) then
        current_chan = 497
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to u ub lm lp 
      if (qactive_chan(498).and.qselect_chan(498)) then
        current_chan = 498
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to d db lm lp 
      if (qactive_chan(499).and.qselect_chan(499)) then
        current_chan = 499
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to u ub lm lp 
      if (qactive_chan(500).and.qselect_chan(500)) then
        current_chan = 500
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to d db lm lp 
      if (qactive_chan(501).and.qselect_chan(501)) then
        current_chan = 501
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to u ub lm lp 
      if (qactive_chan(502).and.qselect_chan(502)) then
        current_chan = 502
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to d db lm lp 
      if (qactive_chan(503).and.qselect_chan(503)) then
        current_chan = 503
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to u ub lm lp 
      if (qactive_chan(504).and.qselect_chan(504)) then
        current_chan = 504
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db lm lp 
      if (qactive_chan(505).and.qselect_chan(505)) then
        current_chan = 505
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db ub lm lp 
      if (qactive_chan(506).and.qselect_chan(506)) then
        current_chan = 506
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to ub db lm lp 
      if (qactive_chan(507).and.qselect_chan(507)) then
        current_chan = 507
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub lm lp 
      if (qactive_chan(508).and.qselect_chan(508)) then
        current_chan = 508
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d lm lp 
      if (qactive_chan(509).and.qselect_chan(509)) then
        current_chan = 509
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db u to db u lm lp 
      if (qactive_chan(510).and.qselect_chan(510)) then
        current_chan = 510
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to ub d lm lp 
      if (qactive_chan(511).and.qselect_chan(511)) then
        current_chan = 511
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u lm lp 
      if (qactive_chan(512).and.qselect_chan(512)) then
        current_chan = 512
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ct0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d lm lp 
      if (qactive_chan(529).and.qselect_chan(529)) then
        current_chan = 529
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d ub to ub d lm lp 
      if (qactive_chan(530).and.qselect_chan(530)) then
        current_chan = 530
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u db to db u lm lp 
      if (qactive_chan(531).and.qselect_chan(531)) then
        current_chan = 531
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u lm lp 
      if (qactive_chan(532).and.qselect_chan(532)) then
        current_chan = 532
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d lm lp 
      if (qactive_chan(533).and.qselect_chan(533)) then
        current_chan = 533
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d u to u d lm lp 
      if (qactive_chan(534).and.qselect_chan(534)) then
        current_chan = 534
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u d to d u lm lp 
      if (qactive_chan(535).and.qselect_chan(535)) then
        current_chan = 535
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u lm lp 
      if (qactive_chan(536).and.qselect_chan(536)) then
        current_chan = 536
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to d db lm lp 
      if (qactive_chan(537).and.qselect_chan(537)) then
        current_chan = 537
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to u ub lm lp 
      if (qactive_chan(538).and.qselect_chan(538)) then
        current_chan = 538
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to d db lm lp 
      if (qactive_chan(539).and.qselect_chan(539)) then
        current_chan = 539
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to u ub lm lp 
      if (qactive_chan(540).and.qselect_chan(540)) then
        current_chan = 540
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(1,3,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to d db lm lp 
      if (qactive_chan(541).and.qselect_chan(541)) then
        current_chan = 541
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to u ub lm lp 
      if (qactive_chan(542).and.qselect_chan(542)) then
        current_chan = 542
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to d db lm lp 
      if (qactive_chan(543).and.qselect_chan(543)) then
        current_chan = 543
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to u ub lm lp 
      if (qactive_chan(544).and.qselect_chan(544)) then
        current_chan = 544
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,3,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(2,3,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db lm lp 
      if (qactive_chan(545).and.qselect_chan(545)) then
        current_chan = 545
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db ub to db ub lm lp 
      if (qactive_chan(546).and.qselect_chan(546)) then
        current_chan = 546
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub db to ub db lm lp 
      if (qactive_chan(547).and.qselect_chan(547)) then
        current_chan = 547
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub lm lp 
      if (qactive_chan(548).and.qselect_chan(548)) then
        current_chan = 548
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,2,4,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(3,2,4,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d lm lp 
      if (qactive_chan(549).and.qselect_chan(549)) then
        current_chan = 549
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db u to db u lm lp 
      if (qactive_chan(550).and.qselect_chan(550)) then
        current_chan = 550
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub d to ub d lm lp 
      if (qactive_chan(551).and.qselect_chan(551)) then
        current_chan = 551
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u lm lp 
      if (qactive_chan(552).and.qselect_chan(552)) then
        current_chan = 552
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,4,2,1,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Ch0g1Z(3,4,2,1,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d lm lp 
      if (qactive_chan(569).and.qselect_chan(569)) then
        current_chan = 569
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u lm lp 
      if (qactive_chan(570).and.qselect_chan(570)) then
        current_chan = 570
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d lm lp 
      if (qactive_chan(571).and.qselect_chan(571)) then
        current_chan = 571
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u lm lp 
      if (qactive_chan(572).and.qselect_chan(572)) then
        current_chan = 572
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d lm lp 
      if (qactive_chan(573).and.qselect_chan(573)) then
        current_chan = 573
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u lm lp 
      if (qactive_chan(574).and.qselect_chan(574)) then
        current_chan = 574
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db lm lp 
      if (qactive_chan(575).and.qselect_chan(575)) then
        current_chan = 575
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub lm lp 
      if (qactive_chan(576).and.qselect_chan(576)) then
        current_chan = 576
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = D0g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d lm lp 
      if (qactive_chan(585).and.qselect_chan(585)) then
        current_chan = 585
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u lm lp 
      if (qactive_chan(586).and.qselect_chan(586)) then
        current_chan = 586
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d lm lp 
      if (qactive_chan(587).and.qselect_chan(587)) then
        current_chan = 587
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u lm lp 
      if (qactive_chan(588).and.qselect_chan(588)) then
        current_chan = 588
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d lm lp 
      if (qactive_chan(589).and.qselect_chan(589)) then
        current_chan = 589
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u lm lp 
      if (qactive_chan(590).and.qselect_chan(590)) then
        current_chan = 590
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db lm lp 
      if (qactive_chan(591).and.qselect_chan(591)) then
        current_chan = 591
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub lm lp 
      if (qactive_chan(592).and.qselect_chan(592)) then
        current_chan = 592
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dt0g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d db to db d lm lp 
      if (qactive_chan(601).and.qselect_chan(601)) then
        current_chan = 601
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u ub to ub u lm lp 
      if (qactive_chan(602).and.qselect_chan(602)) then
        current_chan = 602
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,2,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Z(1,2,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- d d to d d lm lp 
      if (qactive_chan(603).and.qselect_chan(603)) then
        current_chan = 603
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- u u to u u lm lp 
      if (qactive_chan(604).and.qselect_chan(604)) then
        current_chan = 604
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 1,3,2,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Z(1,3,2,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db d to db d lm lp 
      if (qactive_chan(605).and.qselect_chan(605)) then
        current_chan = 605
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub u to ub u lm lp 
      if (qactive_chan(606).and.qselect_chan(606)) then
        current_chan = 606
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 2,1,3,4,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Z(2,1,3,4,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- db db to db db lm lp 
      if (qactive_chan(607).and.qselect_chan(607)) then
        current_chan = 607
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ub ub to ub ub lm lp 
      if (qactive_chan(608).and.qselect_chan(608)) then
        current_chan = 608
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(6, (/ 3,1,4,2,5,6 /))
        call getqcdnorm(ix,partons,factor, 6, ipass_chan, 0)
        if (ipass_chan == 1) then
          do i=1,nAct_scl
            idmap = idmap_scl(i, withR=.true.)
            if (idmap == i) then
               kinwt(i) = Dh0g1Z(3,1,4,2,5,6,muR2_scl(i))
            else
               kinwt(i) = kinwt(idmap)
            endif
          enddo
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRVZJ=rnorm*wtsum

      return
      end
