      subroutine getlumiZJJ(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,   15,   61,   75,   89,  103,  104,  143,          
     &          144,  183,  199,  215,  245,  275,  289,  303,          
     &          333,  379,  380,  419,  420,  459,  460,  479,          
     &          495,  511)
!       [10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    2,   16,   62,   76,   90,  105,  106,  145,          
     &          146,  184,  200,  216,  246,  276,  290,  304,          
     &          334,  381,  382,  421,  422,  461,  462,  480,          
     &          496,  512)
!       [20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(0,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (    3,   17,   37,   38,   53,   63,   77,   91,          
     &          115,  116,  155,  156,  185,  201,  217,  247,          
     &          277,  291,  305,  335,  355,  356,  395,  396,          
     &          435,  436,  467,  483,  499)
!       [10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (    4,   18,   39,   40,   54,   64,   78,   92,          
     &          117,  118,  157,  158,  186,  202,  218,  248,          
     &          278,  292,  306,  336,  357,  358,  397,  398,          
     &          437,  438,  468,  484,  500)
!       [20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (    5,   19,   65,   79,   93,  119,  120,  159,          
     &          160,  189,  205,  219,  249,  279,  293,  307,          
     &          337,  371,  372,  411,  412,  451,  452,  475,          
     &          491,  507)
!       [0, 10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (    6,   20,   66,   80,   94,  121,  122,  161,          
     &          162,  190,  206,  220,  250,  280,  294,  308,          
     &          338,  373,  374,  413,  414,  453,  454,  476,          
     &          492,  508)
!       [0, 20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(0,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (    7,   21,   41,   42,   57,   67,   81,   95,          
     &          123,  124,  163,  164,  191,  207,  221,  251,          
     &          281,  295,  309,  339,  359,  360,  399,  400,          
     &          439,  440,  471,  487,  503)
!       [-10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (    8,   22,   43,   44,   58,   68,   82,   96,          
     &          125,  126,  165,  166,  192,  208,  222,  252,          
     &          282,  296,  310,  340,  361,  362,  401,  402,          
     &          441,  442,  472,  488,  504)
!       [-20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (    9,   10,   23,   24,   69,   70,   83,   84,          
     &           97,   98,  223,  224,  253,  254,  283,  284,          
     &          297,  298,  311,  312,  341,  342)
!       [0, 0]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(0,1:nInp_scl)                        

        case (   11,   25,   71,   85,   99,  127,  128,  167,          
     &          168,  193,  209,  225,  255,  285,  299,  313,          
     &          343,  375,  376,  415,  416,  455,  456,  477,          
     &          493,  509)
!       [0, -10]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   12,   26,   72,   86,  100,  129,  130,  169,          
     &          170,  194,  210,  226,  256,  286,  300,  314,          
     &          344,  377,  378,  417,  418,  457,  458,  478,          
     &          494,  510)
!       [0, -20]
          partons(1:nInp_scl) =                                         
     &         f1(0,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(0,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   13,   27,   73,   87,  101,  131,  132,  171,          
     &          172,  195,  211,  227,  257,  287,  301,  315,          
     &          345,  383,  384,  423,  424,  463,  464,  481,          
     &          497,  513)
!       [-10, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   14,   28,   74,   88,  102,  133,  134,  173,          
     &          174,  196,  212,  228,  258,  288,  302,  316,          
     &          346,  385,  386,  425,  426,  465,  466,  482,          
     &          498,  514)
!       [-20, 0]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(0,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(0,1:nInp_scl)                       

        case (   29,  107,  147,  233,  263,  321,  347,  387,          
     &          427)
!       [11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   30,  108,  148,  234,  264,  322,  348,  388,          
     &          428)
!       [11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(1,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(3,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(5,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   31,  109,  149,  235,  265,  323,  349,  389,          
     &          429)
!       [21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-5,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-1,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-3,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-5,1:nInp_scl)                       

        case (   32,  110,  150,  236,  266,  324,  350,  390,          
     &          430)
!       [21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(2,1:nInp_scl)*f2(-4,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-2,1:nInp_scl)                       
     &       + f1(4,1:nInp_scl)*f2(-4,1:nInp_scl)                       

        case (   33,  111,  151,  229,  259,  317,  351,  391,          
     &          431)
!       [11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   34,  112,  152,  230,  260,  318,  352,  392,          
     &          432)
!       [11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(1,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   35,  113,  153,  231,  261,  319,  353,  393,          
     &          433)
!       [21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(5,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   36,  114,  154,  232,  262,  320,  354,  394,          
     &          434)
!       [21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(2,1:nInp_scl)*f2(4,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   45,  135,  175,  241,  271,  329,  363,  403,          
     &          443)
!       [-11, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   46,  136,  176,  242,  272,  330,  364,  404,          
     &          444)
!       [-11, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-1,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   47,  137,  177,  243,  273,  331,  365,  405,          
     &          445)
!       [-21, -11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-5,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   48,  138,  178,  244,  274,  332,  366,  406,          
     &          446)
!       [-21, -21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-2,1:nInp_scl)*f2(-4,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case (   49,  139,  179,  237,  267,  325,  367,  407,          
     &          447)
!       [-11, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   50,  140,  180,  238,  268,  326,  368,  408,          
     &          448)
!       [-11, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-1,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-3,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-5,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   51,  141,  181,  239,  269,  327,  369,  409,          
     &          449)
!       [-21, 11]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(5,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(1,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(3,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(5,1:nInp_scl)                       

        case (   52,  142,  182,  240,  270,  328,  370,  410,          
     &          450)
!       [-21, 21]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-2,1:nInp_scl)*f2(4,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(2,1:nInp_scl)                       
     &       + f1(-4,1:nInp_scl)*f2(4,1:nInp_scl)                       

        case (   55,  187,  203,  469,  485,  501)
!       [10, 10]
          partons(1:nInp_scl) =                                         
     &         f1(1,1:nInp_scl)*f2(1,1:nInp_scl)                        
     &       + f1(3,1:nInp_scl)*f2(3,1:nInp_scl)                        
     &       + f1(5,1:nInp_scl)*f2(5,1:nInp_scl)                        

        case (   56,  188,  204,  470,  486,  502)
!       [20, 20]
          partons(1:nInp_scl) =                                         
     &         f1(2,1:nInp_scl)*f2(2,1:nInp_scl)                        
     &       + f1(4,1:nInp_scl)*f2(4,1:nInp_scl)                        

        case (   59,  197,  213,  473,  489,  505)
!       [-10, -10]
          partons(1:nInp_scl) =                                         
     &         f1(-1,1:nInp_scl)*f2(-1,1:nInp_scl)                      
     &       + f1(-3,1:nInp_scl)*f2(-3,1:nInp_scl)                      
     &       + f1(-5,1:nInp_scl)*f2(-5,1:nInp_scl)                      

        case (   60,  198,  214,  474,  490,  506)
!       [-20, -20]
          partons(1:nInp_scl) =                                         
     &         f1(-2,1:nInp_scl)*f2(-2,1:nInp_scl)                      
     &       + f1(-4,1:nInp_scl)*f2(-4,1:nInp_scl)                      

        case default
          print*, "getlumiZJJ: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiZJJ



      function getlumiidZJJ(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,   15,   61,   75,   89,  103,  104,  143,
     &          144,  183,  199,  215,  245,  275,  289,  303,
     &          333,  379,  380,  419,  420,  459,  460,  479,
     &          495,  511)
          id  = 1
          ip1 = 10
          ip2 = 0

        case (    2,   16,   62,   76,   90,  105,  106,  145,
     &          146,  184,  200,  216,  246,  276,  290,  304,
     &          334,  381,  382,  421,  422,  461,  462,  480,
     &          496,  512)
          id  = 2
          ip1 = 20
          ip2 = 0

        case (    3,   17,   37,   38,   53,   63,   77,   91,
     &          115,  116,  155,  156,  185,  201,  217,  247,
     &          277,  291,  305,  335,  355,  356,  395,  396,
     &          435,  436,  467,  483,  499)
          id  = 3
          ip1 = 10
          ip2 = -10

        case (    4,   18,   39,   40,   54,   64,   78,   92,
     &          117,  118,  157,  158,  186,  202,  218,  248,
     &          278,  292,  306,  336,  357,  358,  397,  398,
     &          437,  438,  468,  484,  500)
          id  = 4
          ip1 = 20
          ip2 = -20

        case (    5,   19,   65,   79,   93,  119,  120,  159,
     &          160,  189,  205,  219,  249,  279,  293,  307,
     &          337,  371,  372,  411,  412,  451,  452,  475,
     &          491,  507)
          id  = 5
          ip1 = 0
          ip2 = 10

        case (    6,   20,   66,   80,   94,  121,  122,  161,
     &          162,  190,  206,  220,  250,  280,  294,  308,
     &          338,  373,  374,  413,  414,  453,  454,  476,
     &          492,  508)
          id  = 6
          ip1 = 0
          ip2 = 20

        case (    7,   21,   41,   42,   57,   67,   81,   95,
     &          123,  124,  163,  164,  191,  207,  221,  251,
     &          281,  295,  309,  339,  359,  360,  399,  400,
     &          439,  440,  471,  487,  503)
          id  = 7
          ip1 = -10
          ip2 = 10

        case (    8,   22,   43,   44,   58,   68,   82,   96,
     &          125,  126,  165,  166,  192,  208,  222,  252,
     &          282,  296,  310,  340,  361,  362,  401,  402,
     &          441,  442,  472,  488,  504)
          id  = 8
          ip1 = -20
          ip2 = 20

        case (    9,   10,   23,   24,   69,   70,   83,   84,
     &           97,   98,  223,  224,  253,  254,  283,  284,
     &          297,  298,  311,  312,  341,  342)
          id  = 9
          ip1 = 0
          ip2 = 0

        case (   11,   25,   71,   85,   99,  127,  128,  167,
     &          168,  193,  209,  225,  255,  285,  299,  313,
     &          343,  375,  376,  415,  416,  455,  456,  477,
     &          493,  509)
          id  = 10
          ip1 = 0
          ip2 = -10

        case (   12,   26,   72,   86,  100,  129,  130,  169,
     &          170,  194,  210,  226,  256,  286,  300,  314,
     &          344,  377,  378,  417,  418,  457,  458,  478,
     &          494,  510)
          id  = 11
          ip1 = 0
          ip2 = -20

        case (   13,   27,   73,   87,  101,  131,  132,  171,
     &          172,  195,  211,  227,  257,  287,  301,  315,
     &          345,  383,  384,  423,  424,  463,  464,  481,
     &          497,  513)
          id  = 12
          ip1 = -10
          ip2 = 0

        case (   14,   28,   74,   88,  102,  133,  134,  173,
     &          174,  196,  212,  228,  258,  288,  302,  316,
     &          346,  385,  386,  425,  426,  465,  466,  482,
     &          498,  514)
          id  = 13
          ip1 = -20
          ip2 = 0

        case (   29,  107,  147,  233,  263,  321,  347,  387,
     &          427)
          id  = 14
          ip1 = 11
          ip2 = -11

        case (   30,  108,  148,  234,  264,  322,  348,  388,
     &          428)
          id  = 15
          ip1 = 11
          ip2 = -21

        case (   31,  109,  149,  235,  265,  323,  349,  389,
     &          429)
          id  = 16
          ip1 = 21
          ip2 = -11

        case (   32,  110,  150,  236,  266,  324,  350,  390,
     &          430)
          id  = 17
          ip1 = 21
          ip2 = -21

        case (   33,  111,  151,  229,  259,  317,  351,  391,
     &          431)
          id  = 18
          ip1 = 11
          ip2 = 11

        case (   34,  112,  152,  230,  260,  318,  352,  392,
     &          432)
          id  = 19
          ip1 = 11
          ip2 = 21

        case (   35,  113,  153,  231,  261,  319,  353,  393,
     &          433)
          id  = 20
          ip1 = 21
          ip2 = 11

        case (   36,  114,  154,  232,  262,  320,  354,  394,
     &          434)
          id  = 21
          ip1 = 21
          ip2 = 21

        case (   45,  135,  175,  241,  271,  329,  363,  403,
     &          443)
          id  = 22
          ip1 = -11
          ip2 = -11

        case (   46,  136,  176,  242,  272,  330,  364,  404,
     &          444)
          id  = 23
          ip1 = -11
          ip2 = -21

        case (   47,  137,  177,  243,  273,  331,  365,  405,
     &          445)
          id  = 24
          ip1 = -21
          ip2 = -11

        case (   48,  138,  178,  244,  274,  332,  366,  406,
     &          446)
          id  = 25
          ip1 = -21
          ip2 = -21

        case (   49,  139,  179,  237,  267,  325,  367,  407,
     &          447)
          id  = 26
          ip1 = -11
          ip2 = 11

        case (   50,  140,  180,  238,  268,  326,  368,  408,
     &          448)
          id  = 27
          ip1 = -11
          ip2 = 21

        case (   51,  141,  181,  239,  269,  327,  369,  409,
     &          449)
          id  = 28
          ip1 = -21
          ip2 = 11

        case (   52,  142,  182,  240,  270,  328,  370,  410,
     &          450)
          id  = 29
          ip1 = -21
          ip2 = 21

        case (   55,  187,  203,  469,  485,  501)
          id  = 30
          ip1 = 10
          ip2 = 10

        case (   56,  188,  204,  470,  486,  502)
          id  = 31
          ip1 = 20
          ip2 = 20

        case (   59,  197,  213,  473,  489,  505)
          id  = 32
          ip1 = -10
          ip2 = -10

        case (   60,  198,  214,  474,  490,  506)
          id  = 33
          ip1 = -20
          ip2 = -20

        case default
          print*, "getlumiidZJJ: invalid iproc:", iproc
          stop
        end select

      end function getlumiidZJJ





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiZJJ()
        use PineAPPL_mod
        use CKM_mod
!       [10, 0]
        call register_lumi_pine(
     &         [    1,   15,   61,   75,   89,  103,  104,  143,
     &            144,  183,  199,  215,  245,  275,  289,  303,
     &            333,  379,  380,  419,  420,  459,  460,  479,
     &            495,  511],
     &         3,
     &         [    1,   21,    3,   21,    5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 0]
        call register_lumi_pine(
     &         [    2,   16,   62,   76,   90,  105,  106,  145,
     &            146,  184,  200,  216,  246,  276,  290,  304,
     &            334,  381,  382,  421,  422,  461,  462,  480,
     &            496,  512],
     &         2,
     &         [    2,   21,    4,   21],
     &         [  1d0,  1d0]
     &       )

!       [10, -10]
        call register_lumi_pine(
     &         [    3,   17,   37,   38,   53,   63,   77,   91,
     &            115,  116,  155,  156,  185,  201,  217,  247,
     &            277,  291,  305,  335,  355,  356,  395,  396,
     &            435,  436,  467,  483,  499],
     &         3,
     &         [    1,   -1,    3,   -3,    5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, -20]
        call register_lumi_pine(
     &         [    4,   18,   39,   40,   54,   64,   78,   92,
     &            117,  118,  157,  158,  186,  202,  218,  248,
     &            278,  292,  306,  336,  357,  358,  397,  398,
     &            437,  438,  468,  484,  500],
     &         2,
     &         [    2,   -2,    4,   -4],
     &         [  1d0,  1d0]
     &       )

!       [0, 10]
        call register_lumi_pine(
     &         [    5,   19,   65,   79,   93,  119,  120,  159,
     &            160,  189,  205,  219,  249,  279,  293,  307,
     &            337,  371,  372,  411,  412,  451,  452,  475,
     &            491,  507],
     &         3,
     &         [   21,    1,   21,    3,   21,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, 20]
        call register_lumi_pine(
     &         [    6,   20,   66,   80,   94,  121,  122,  161,
     &            162,  190,  206,  220,  250,  280,  294,  308,
     &            338,  373,  374,  413,  414,  453,  454,  476,
     &            492,  508],
     &         2,
     &         [   21,    2,   21,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 10]
        call register_lumi_pine(
     &         [    7,   21,   41,   42,   57,   67,   81,   95,
     &            123,  124,  163,  164,  191,  207,  221,  251,
     &            281,  295,  309,  339,  359,  360,  399,  400,
     &            439,  440,  471,  487,  503],
     &         3,
     &         [   -1,    1,   -3,    3,   -5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 20]
        call register_lumi_pine(
     &         [    8,   22,   43,   44,   58,   68,   82,   96,
     &            125,  126,  165,  166,  192,  208,  222,  252,
     &            282,  296,  310,  340,  361,  362,  401,  402,
     &            441,  442,  472,  488,  504],
     &         2,
     &         [   -2,    2,   -4,    4],
     &         [  1d0,  1d0]
     &       )

!       [0, 0]
        call register_lumi_pine(
     &         [    9,   10,   23,   24,   69,   70,   83,   84,
     &             97,   98,  223,  224,  253,  254,  283,  284,
     &            297,  298,  311,  312,  341,  342],
     &         1,
     &         [   21,   21],
     &         [  1d0]
     &       )

!       [0, -10]
        call register_lumi_pine(
     &         [   11,   25,   71,   85,   99,  127,  128,  167,
     &            168,  193,  209,  225,  255,  285,  299,  313,
     &            343,  375,  376,  415,  416,  455,  456,  477,
     &            493,  509],
     &         3,
     &         [   21,   -1,   21,   -3,   21,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [0, -20]
        call register_lumi_pine(
     &         [   12,   26,   72,   86,  100,  129,  130,  169,
     &            170,  194,  210,  226,  256,  286,  300,  314,
     &            344,  377,  378,  417,  418,  457,  458,  478,
     &            494,  510],
     &         2,
     &         [   21,   -2,   21,   -4],
     &         [  1d0,  1d0]
     &       )

!       [-10, 0]
        call register_lumi_pine(
     &         [   13,   27,   73,   87,  101,  131,  132,  171,
     &            172,  195,  211,  227,  257,  287,  301,  315,
     &            345,  383,  384,  423,  424,  463,  464,  481,
     &            497,  513],
     &         3,
     &         [   -1,   21,   -3,   21,   -5,   21],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, 0]
        call register_lumi_pine(
     &         [   14,   28,   74,   88,  102,  133,  134,  173,
     &            174,  196,  212,  228,  258,  288,  302,  316,
     &            346,  385,  386,  425,  426,  465,  466,  482,
     &            498,  514],
     &         2,
     &         [   -2,   21,   -4,   21],
     &         [  1d0,  1d0]
     &       )

!       [11, -11]
        call register_lumi_pine(
     &         [   29,  107,  147,  233,  263,  321,  347,  387,
     &            427],
     &         9,
     &         [    1,   -1,    1,   -3,    1,   -5,    3,   -1,
     &              3,   -3,    3,   -5,    5,   -1,    5,   -3,
     &              5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, -21]
        call register_lumi_pine(
     &         [   30,  108,  148,  234,  264,  322,  348,  388,
     &            428],
     &         6,
     &         [    1,   -2,    1,   -4,    3,   -2,    3,   -4,
     &              5,   -2,    5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -11]
        call register_lumi_pine(
     &         [   31,  109,  149,  235,  265,  323,  349,  389,
     &            429],
     &         6,
     &         [    2,   -1,    2,   -3,    2,   -5,    4,   -1,
     &              4,   -3,    4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, -21]
        call register_lumi_pine(
     &         [   32,  110,  150,  236,  266,  324,  350,  390,
     &            430],
     &         4,
     &         [    2,   -2,    2,   -4,    4,   -2,    4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [11, 11]
        call register_lumi_pine(
     &         [   33,  111,  151,  229,  259,  317,  351,  391,
     &            431],
     &         9,
     &         [    1,    1,    1,    3,    1,    5,    3,    1,
     &              3,    3,    3,    5,    5,    1,    5,    3,
     &              5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [11, 21]
        call register_lumi_pine(
     &         [   34,  112,  152,  230,  260,  318,  352,  392,
     &            432],
     &         6,
     &         [    1,    2,    1,    4,    3,    2,    3,    4,
     &              5,    2,    5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 11]
        call register_lumi_pine(
     &         [   35,  113,  153,  231,  261,  319,  353,  393,
     &            433],
     &         6,
     &         [    2,    1,    2,    3,    2,    5,    4,    1,
     &              4,    3,    4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [21, 21]
        call register_lumi_pine(
     &         [   36,  114,  154,  232,  262,  320,  354,  394,
     &            434],
     &         4,
     &         [    2,    2,    2,    4,    4,    2,    4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, -11]
        call register_lumi_pine(
     &         [   45,  135,  175,  241,  271,  329,  363,  403,
     &            443],
     &         9,
     &         [   -1,   -1,   -1,   -3,   -1,   -5,   -3,   -1,
     &             -3,   -3,   -3,   -5,   -5,   -1,   -5,   -3,
     &             -5,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, -21]
        call register_lumi_pine(
     &         [   46,  136,  176,  242,  272,  330,  364,  404,
     &            444],
     &         6,
     &         [   -1,   -2,   -1,   -4,   -3,   -2,   -3,   -4,
     &             -5,   -2,   -5,   -4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -11]
        call register_lumi_pine(
     &         [   47,  137,  177,  243,  273,  331,  365,  405,
     &            445],
     &         6,
     &         [   -2,   -1,   -2,   -3,   -2,   -5,   -4,   -1,
     &             -4,   -3,   -4,   -5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, -21]
        call register_lumi_pine(
     &         [   48,  138,  178,  244,  274,  332,  366,  406,
     &            446],
     &         4,
     &         [   -2,   -2,   -2,   -4,   -4,   -2,   -4,   -4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-11, 11]
        call register_lumi_pine(
     &         [   49,  139,  179,  237,  267,  325,  367,  407,
     &            447],
     &         9,
     &         [   -1,    1,   -1,    3,   -1,    5,   -3,    1,
     &             -3,    3,   -3,    5,   -5,    1,   -5,    3,
     &             -5,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,  1d0,
     &            1d0]
     &       )

!       [-11, 21]
        call register_lumi_pine(
     &         [   50,  140,  180,  238,  268,  326,  368,  408,
     &            448],
     &         6,
     &         [   -1,    2,   -1,    4,   -3,    2,   -3,    4,
     &             -5,    2,   -5,    4],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 11]
        call register_lumi_pine(
     &         [   51,  141,  181,  239,  269,  327,  369,  409,
     &            449],
     &         6,
     &         [   -2,    1,   -2,    3,   -2,    5,   -4,    1,
     &             -4,    3,   -4,    5],
     &         [  1d0,  1d0,  1d0,  1d0,  1d0,  1d0]
     &       )

!       [-21, 21]
        call register_lumi_pine(
     &         [   52,  142,  182,  240,  270,  328,  370,  410,
     &            450],
     &         4,
     &         [   -2,    2,   -2,    4,   -4,    2,   -4,    4],
     &         [  1d0,  1d0,  1d0,  1d0]
     &       )

!       [10, 10]
        call register_lumi_pine(
     &         [   55,  187,  203,  469,  485,  501],
     &         3,
     &         [    1,    1,    3,    3,    5,    5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [20, 20]
        call register_lumi_pine(
     &         [   56,  188,  204,  470,  486,  502],
     &         2,
     &         [    2,    2,    4,    4],
     &         [  1d0,  1d0]
     &       )

!       [-10, -10]
        call register_lumi_pine(
     &         [   59,  197,  213,  473,  489,  505],
     &         3,
     &         [   -1,   -1,   -3,   -3,   -5,   -5],
     &         [  1d0,  1d0,  1d0]
     &       )

!       [-20, -20]
        call register_lumi_pine(
     &         [   60,  198,  214,  474,  490,  506],
     &         2,
     &         [   -2,   -2,   -4,   -4],
     &         [  1d0,  1d0]
     &       )

      end subroutine init_pine_lumiZJJ


#endif


