      subroutine getqcdnormZJJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtZJJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVZJJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourZJJ(current_chan)
         do isub = 1, nflavourZJJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_ZJJ(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=ZJJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param())**2*nc*(nc**2-1)/(2d0*nc)*8d0*nc*(4d0*pi*alphas_scl)
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=facB                        ! d g -> g d lp lm        B2g0Z
      case(2)
         factor=facB                        ! u g -> g u lp lm        B2g0Z
      case(3)
         factor=1d0/2d0*facB                ! d db -> g g lp lm       B2g0Z
      case(4)
         factor=1d0/2d0*facB                ! u ub -> g g lp lm       B2g0Z
      case(5)
         factor=facB                        ! g d -> g d lp lm        B2g0Z
      case(6)
         factor=facB                        ! g u -> g u lp lm        B2g0Z
      case(7)
         factor=1d0/2d0*facB                ! db d -> g g lp lm       B2g0Z
      case(8)
         factor=1d0/2d0*facB                ! ub u -> g g lp lm       B2g0Z
      case(9)
         factor=ndown*facB                  ! g g -> db d lp lm       B2g0Z
      case(10)
         factor=nup*facB                    ! g g -> ub u lp lm       B2g0Z
      case(11)
         factor=facB                        ! g db -> db g lp lm      B2g0Z
      case(12)
         factor=facB                        ! g ub -> ub g lp lm      B2g0Z
      case(13)
         factor=facB                        ! db g -> db g lp lm      B2g0Z
      case(14)
         factor=facB                        ! ub g -> ub g lp lm      B2g0Z
      case(15)
         factor=-1d0/nc**2*facB             ! d gt -> gt d lp lm      Bt2g0Z
      case(16)
         factor=-1d0/nc**2*facB             ! u gt -> gt u lp lm      Bt2g0Z
      case(17)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d db -> gt gt lp lm     Bt2g0Z
      case(18)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u ub -> gt gt lp lm     Bt2g0Z
      case(19)
         factor=-1d0/nc**2*facB             ! gt d -> gt d lp lm      Bt2g0Z
      case(20)
         factor=-1d0/nc**2*facB             ! gt u -> gt u lp lm      Bt2g0Z
      case(21)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db d -> gt gt lp lm     Bt2g0Z
      case(22)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub u -> gt gt lp lm     Bt2g0Z
      case(23)
         factor=-1d0/nc**2*ndown*facB       ! gt gt -> db d lp lm     Bt2g0Z
      case(24)
         factor=-1d0/nc**2*nup*facB         ! gt gt -> ub u lp lm     Bt2g0Z
      case(25)
         factor=-1d0/nc**2*facB             ! gt db -> db gt lp lm     Bt2g0Z
      case(26)
         factor=-1d0/nc**2*facB             ! gt ub -> ub gt lp lm     Bt2g0Z
      case(27)
         factor=-1d0/nc**2*facB             ! db gt -> db gt lp lm     Bt2g0Z
      case(28)
         factor=-1d0/nc**2*facB             ! ub gt -> ub gt lp lm     Bt2g0Z
      case(29)
         factor=1d0/nc*facB                 ! d db -> db d lp lm      C0g0Z
      case(30)
         factor=1d0/nc*facB                 ! d ub -> ub d lp lm      C0g0Z
      case(31)
         factor=1d0/nc*facB                 ! u db -> db u lp lm      C0g0Z
      case(32)
         factor=1d0/nc*facB                 ! u ub -> ub u lp lm      C0g0Z
      case(33)
         factor=1d0/nc*facB                 ! d d -> d d lp lm        C0g0Z
      case(34)
         factor=1d0/nc*facB                 ! d u -> u d lp lm        C0g0Z
      case(35)
         factor=1d0/nc*facB                 ! u d -> d u lp lm        C0g0Z
      case(36)
         factor=1d0/nc*facB                 ! u u -> u u lp lm        C0g0Z
      case(37)
         factor=1d0/nc*ndown*facB           ! d db -> d db lp lm      C0g0Z
      case(38)
         factor=1d0/nc*nup*facB             ! d db -> u ub lp lm      C0g0Z
      case(39)
         factor=1d0/nc*ndown*facB           ! u ub -> d db lp lm      C0g0Z
      case(40)
         factor=1d0/nc*nup*facB             ! u ub -> u ub lp lm      C0g0Z
      case(41)
         factor=1d0/nc*ndown*facB           ! db d -> d db lp lm      C0g0Z
      case(42)
         factor=1d0/nc*nup*facB             ! db d -> u ub lp lm      C0g0Z
      case(43)
         factor=1d0/nc*ndown*facB           ! ub u -> d db lp lm      C0g0Z
      case(44)
         factor=1d0/nc*nup*facB             ! ub u -> u ub lp lm      C0g0Z
      case(45)
         factor=1d0/nc*facB                 ! db db -> db db lp lm     C0g0Z
      case(46)
         factor=1d0/nc*facB                 ! db ub -> db ub lp lm     C0g0Z
      case(47)
         factor=1d0/nc*facB                 ! ub db -> ub db lp lm     C0g0Z
      case(48)
         factor=1d0/nc*facB                 ! ub ub -> ub ub lp lm     C0g0Z
      case(49)
         factor=1d0/nc*facB                 ! db d -> db d lp lm      C0g0Z
      case(50)
         factor=1d0/nc*facB                 ! db u -> db u lp lm      C0g0Z
      case(51)
         factor=1d0/nc*facB                 ! ub d -> ub d lp lm      C0g0Z
      case(52)
         factor=1d0/nc*facB                 ! ub u -> ub u lp lm      C0g0Z
      case(53)
         factor=-1d0/nc**2*facB             ! d db -> db d lp lm      D0g0Z
      case(54)
         factor=-1d0/nc**2*facB             ! u ub -> ub u lp lm      D0g0Z
      case(55)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d d -> d d lp lm        D0g0Z
      case(56)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u u -> u u lp lm        D0g0Z
      case(57)
         factor=-1d0/nc**2*facB             ! db d -> db d lp lm      D0g0Z
      case(58)
         factor=-1d0/nc**2*facB             ! ub u -> ub u lp lm      D0g0Z
      case(59)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db db -> db db lp lm     D0g0Z
      case(60)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub ub -> ub ub lp lm     D0g0Z

c -- real

      case(61)
         factor=1d0/2d0*facR                ! d g -> g g d lp lm      sB3g0Z
      case(62)
         factor=1d0/2d0*facR                ! u g -> g g u lp lm      sB3g0Z
      case(63)
         factor=1d0/6d0*facR                ! d db -> g g g lp lm     sB3g0Z
      case(64)
         factor=1d0/6d0*facR                ! u ub -> g g g lp lm     sB3g0Z
      case(65)
         factor=1d0/2d0*facR                ! g d -> g g d lp lm      sB3g0Z
      case(66)
         factor=1d0/2d0*facR                ! g u -> g g u lp lm      sB3g0Z
      case(67)
         factor=1d0/6d0*facR                ! db d -> g g g lp lm     sB3g0Z
      case(68)
         factor=1d0/6d0*facR                ! ub u -> g g g lp lm     sB3g0Z
      case(69)
         factor=ndown*facR                  ! g g -> db g d lp lm     sB3g0Z
      case(70)
         factor=nup*facR                    ! g g -> ub g u lp lm     sB3g0Z
      case(71)
         factor=1d0/2d0*facR                ! g db -> db g g lp lm     sB3g0Z
      case(72)
         factor=1d0/2d0*facR                ! g ub -> ub g g lp lm     sB3g0Z
      case(73)
         factor=1d0/2d0*facR                ! db g -> db g g lp lm     sB3g0Z
      case(74)
         factor=1d0/2d0*facR                ! ub g -> ub g g lp lm     sB3g0Z
      case(75)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d g -> g g d lp lm      sBt3g0Z
      case(76)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u g -> g g u lp lm      sBt3g0Z
      case(77)
         factor=-1d0/nc**2*1d0/6d0*facR     ! d db -> g g g lp lm     sBt3g0Z
      case(78)
         factor=-1d0/nc**2*1d0/6d0*facR     ! u ub -> g g g lp lm     sBt3g0Z
      case(79)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g d -> g g d lp lm      sBt3g0Z
      case(80)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g u -> g g u lp lm      sBt3g0Z
      case(81)
         factor=-1d0/nc**2*1d0/6d0*facR     ! db d -> g g g lp lm     sBt3g0Z
      case(82)
         factor=-1d0/nc**2*1d0/6d0*facR     ! ub u -> g g g lp lm     sBt3g0Z
      case(83)
         factor=-1d0/nc**2*ndown*facR       ! g g -> db g d lp lm     sBt3g0Z
      case(84)
         factor=-1d0/nc**2*nup*facR         ! g g -> ub g u lp lm     sBt3g0Z
      case(85)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g db -> db g g lp lm     sBt3g0Z
      case(86)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g ub -> ub g g lp lm     sBt3g0Z
      case(87)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db g -> db g g lp lm     sBt3g0Z
      case(88)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub g -> ub g g lp lm     sBt3g0Z
      case(89)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! d gt -> gt gt d lp lm     sBtt3g0Z
      case(90)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! u gt -> gt gt u lp lm     sBtt3g0Z
      case(91)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facR   ! d db -> gt gt gt lp lm     sBtt3g0Z
      case(92)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facR   ! u ub -> gt gt gt lp lm     sBtt3g0Z
      case(93)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! gt d -> gt gt d lp lm     sBtt3g0Z
      case(94)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! gt u -> gt gt u lp lm     sBtt3g0Z
      case(95)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facR   ! db d -> gt gt gt lp lm     sBtt3g0Z
      case(96)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facR   ! ub u -> gt gt gt lp lm     sBtt3g0Z
      case(97)
         factor=(nc**2+1d0)/nc**4*ndown*facR   ! gt gt -> db gt d lp lm     sBtt3g0Z
      case(98)
         factor=(nc**2+1d0)/nc**4*nup*facR   ! gt gt -> ub gt u lp lm     sBtt3g0Z
      case(99)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! gt db -> db gt gt lp lm     sBtt3g0Z
      case(100)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! gt ub -> ub gt gt lp lm     sBtt3g0Z
      case(101)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! db gt -> db gt gt lp lm     sBtt3g0Z
      case(102)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facR   ! ub gt -> ub gt gt lp lm     sBtt3g0Z
      case(103)
         factor=1d0/nc*ndown*facR           ! d g -> d db d lp lm     sC1g0Z
      case(104)
         factor=1d0/nc*nup*facR             ! d g -> u ub d lp lm     sC1g0Z
      case(105)
         factor=1d0/nc*ndown*facR           ! u g -> d db u lp lm     sC1g0Z
      case(106)
         factor=1d0/nc*nup*facR             ! u g -> u ub u lp lm     sC1g0Z
      case(107)
         factor=1d0/nc*facR                 ! d db -> g db d lp lm     sC1g0Z
      case(108)
         factor=1d0/nc*facR                 ! d ub -> g ub d lp lm     sC1g0Z
      case(109)
         factor=1d0/nc*facR                 ! u db -> g db u lp lm     sC1g0Z
      case(110)
         factor=1d0/nc*facR                 ! u ub -> g ub u lp lm     sC1g0Z
      case(111)
         factor=1d0/nc*facR                 ! d d -> g d d lp lm      sC1g0Z
      case(112)
         factor=1d0/nc*facR                 ! d u -> g u d lp lm      sC1g0Z
      case(113)
         factor=1d0/nc*facR                 ! u d -> g d u lp lm      sC1g0Z
      case(114)
         factor=1d0/nc*facR                 ! u u -> g u u lp lm      sC1g0Z
      case(115)
         factor=1d0/nc*ndown*facR           ! d db -> g d db lp lm     sC1g0Z
      case(116)
         factor=1d0/nc*nup*facR             ! d db -> g u ub lp lm     sC1g0Z
      case(117)
         factor=1d0/nc*ndown*facR           ! u ub -> g d db lp lm     sC1g0Z
      case(118)
         factor=1d0/nc*nup*facR             ! u ub -> g u ub lp lm     sC1g0Z
      case(119)
         factor=1d0/nc*ndown*facR           ! g d -> d db d lp lm     sC1g0Z
      case(120)
         factor=1d0/nc*nup*facR             ! g d -> u ub d lp lm     sC1g0Z
      case(121)
         factor=1d0/nc*ndown*facR           ! g u -> d db u lp lm     sC1g0Z
      case(122)
         factor=1d0/nc*nup*facR             ! g u -> u ub u lp lm     sC1g0Z
      case(123)
         factor=1d0/nc*ndown*facR           ! db d -> g d db lp lm     sC1g0Z
      case(124)
         factor=1d0/nc*nup*facR             ! db d -> g u ub lp lm     sC1g0Z
      case(125)
         factor=1d0/nc*ndown*facR           ! ub u -> g d db lp lm     sC1g0Z
      case(126)
         factor=1d0/nc*nup*facR             ! ub u -> g u ub lp lm     sC1g0Z
      case(127)
         factor=1d0/nc*ndown*facR           ! g db -> db d db lp lm     sC1g0Z
      case(128)
         factor=1d0/nc*nup*facR             ! g db -> db u ub lp lm     sC1g0Z
      case(129)
         factor=1d0/nc*ndown*facR           ! g ub -> ub d db lp lm     sC1g0Z
      case(130)
         factor=1d0/nc*nup*facR             ! g ub -> ub u ub lp lm     sC1g0Z
      case(131)
         factor=1d0/nc*ndown*facR           ! db g -> db d db lp lm     sC1g0Z
      case(132)
         factor=1d0/nc*nup*facR             ! db g -> db u ub lp lm     sC1g0Z
      case(133)
         factor=1d0/nc*ndown*facR           ! ub g -> ub d db lp lm     sC1g0Z
      case(134)
         factor=1d0/nc*nup*facR             ! ub g -> ub u ub lp lm     sC1g0Z
      case(135)
         factor=1d0/nc*facR                 ! db db -> db g db lp lm     sC1g0Z
      case(136)
         factor=1d0/nc*facR                 ! db ub -> db g ub lp lm     sC1g0Z
      case(137)
         factor=1d0/nc*facR                 ! ub db -> ub g db lp lm     sC1g0Z
      case(138)
         factor=1d0/nc*facR                 ! ub ub -> ub g ub lp lm     sC1g0Z
      case(139)
         factor=1d0/nc*facR                 ! db d -> db g d lp lm     sC1g0Z
      case(140)
         factor=1d0/nc*facR                 ! db u -> db g u lp lm     sC1g0Z
      case(141)
         factor=1d0/nc*facR                 ! ub d -> ub g d lp lm     sC1g0Z
      case(142)
         factor=1d0/nc*facR                 ! ub u -> ub g u lp lm     sC1g0Z
      case(143)
         factor=1d0/nc**3*ndown*facR        ! d g -> d db d lp lm     sCt1g0Z
      case(144)
         factor=1d0/nc**3*nup*facR          ! d g -> u ub d lp lm     sCt1g0Z
      case(145)
         factor=1d0/nc**3*ndown*facR        ! u g -> d db u lp lm     sCt1g0Z
      case(146)
         factor=1d0/nc**3*nup*facR          ! u g -> u ub u lp lm     sCt1g0Z
      case(147)
         factor=1d0/nc**3*facR              ! d db -> g db d lp lm     sCt1g0Z
      case(148)
         factor=1d0/nc**3*facR              ! d ub -> g ub d lp lm     sCt1g0Z
      case(149)
         factor=1d0/nc**3*facR              ! u db -> g db u lp lm     sCt1g0Z
      case(150)
         factor=1d0/nc**3*facR              ! u ub -> g ub u lp lm     sCt1g0Z
      case(151)
         factor=1d0/nc**3*facR              ! d d -> g d d lp lm      sCt1g0Z
      case(152)
         factor=1d0/nc**3*facR              ! d u -> g u d lp lm      sCt1g0Z
      case(153)
         factor=1d0/nc**3*facR              ! u d -> g d u lp lm      sCt1g0Z
      case(154)
         factor=1d0/nc**3*facR              ! u u -> g u u lp lm      sCt1g0Z
      case(155)
         factor=1d0/nc**3*ndown*facR        ! d db -> g d db lp lm     sCt1g0Z
      case(156)
         factor=1d0/nc**3*nup*facR          ! d db -> g u ub lp lm     sCt1g0Z
      case(157)
         factor=1d0/nc**3*ndown*facR        ! u ub -> g d db lp lm     sCt1g0Z
      case(158)
         factor=1d0/nc**3*nup*facR          ! u ub -> g u ub lp lm     sCt1g0Z
      case(159)
         factor=1d0/nc**3*ndown*facR        ! g d -> d db d lp lm     sCt1g0Z
      case(160)
         factor=1d0/nc**3*nup*facR          ! g d -> u ub d lp lm     sCt1g0Z
      case(161)
         factor=1d0/nc**3*ndown*facR        ! g u -> d db u lp lm     sCt1g0Z
      case(162)
         factor=1d0/nc**3*nup*facR          ! g u -> u ub u lp lm     sCt1g0Z
      case(163)
         factor=1d0/nc**3*ndown*facR        ! db d -> g d db lp lm     sCt1g0Z
      case(164)
         factor=1d0/nc**3*nup*facR          ! db d -> g u ub lp lm     sCt1g0Z
      case(165)
         factor=1d0/nc**3*ndown*facR        ! ub u -> g d db lp lm     sCt1g0Z
      case(166)
         factor=1d0/nc**3*nup*facR          ! ub u -> g u ub lp lm     sCt1g0Z
      case(167)
         factor=1d0/nc**3*ndown*facR        ! g db -> db d db lp lm     sCt1g0Z
      case(168)
         factor=1d0/nc**3*nup*facR          ! g db -> db u ub lp lm     sCt1g0Z
      case(169)
         factor=1d0/nc**3*ndown*facR        ! g ub -> ub d db lp lm     sCt1g0Z
      case(170)
         factor=1d0/nc**3*nup*facR          ! g ub -> ub u ub lp lm     sCt1g0Z
      case(171)
         factor=1d0/nc**3*ndown*facR        ! db g -> db d db lp lm     sCt1g0Z
      case(172)
         factor=1d0/nc**3*nup*facR          ! db g -> db u ub lp lm     sCt1g0Z
      case(173)
         factor=1d0/nc**3*ndown*facR        ! ub g -> ub d db lp lm     sCt1g0Z
      case(174)
         factor=1d0/nc**3*nup*facR          ! ub g -> ub u ub lp lm     sCt1g0Z
      case(175)
         factor=1d0/nc**3*facR              ! db db -> db g db lp lm     sCt1g0Z
      case(176)
         factor=1d0/nc**3*facR              ! db ub -> db g ub lp lm     sCt1g0Z
      case(177)
         factor=1d0/nc**3*facR              ! ub db -> ub g db lp lm     sCt1g0Z
      case(178)
         factor=1d0/nc**3*facR              ! ub ub -> ub g ub lp lm     sCt1g0Z
      case(179)
         factor=1d0/nc**3*facR              ! db d -> db g d lp lm     sCt1g0Z
      case(180)
         factor=1d0/nc**3*facR              ! db u -> db g u lp lm     sCt1g0Z
      case(181)
         factor=1d0/nc**3*facR              ! ub d -> ub g d lp lm     sCt1g0Z
      case(182)
         factor=1d0/nc**3*facR              ! ub u -> ub g u lp lm     sCt1g0Z
      case(183)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d g -> d db d lp lm     D1g0Zc
      case(184)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u g -> u ub u lp lm     D1g0Zc
      case(185)
         factor=-1d0/nc**2*facR             ! d db -> g db d lp lm     D1g0Zc
      case(186)
         factor=-1d0/nc**2*facR             ! u ub -> g ub u lp lm     D1g0Zc
      case(187)
         factor=-1d0/nc**2*1d0/2d0*facR     ! d d -> g d d lp lm      D1g0Zc
      case(188)
         factor=-1d0/nc**2*1d0/2d0*facR     ! u u -> g u u lp lm      D1g0Zc
      case(189)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g d -> d db d lp lm     D1g0Zc
      case(190)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g u -> u ub u lp lm     D1g0Zc
      case(191)
         factor=-1d0/nc**2*facR             ! db d -> g db d lp lm     D1g0Zc
      case(192)
         factor=-1d0/nc**2*facR             ! ub u -> g ub u lp lm     D1g0Zc
      case(193)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g db -> db db d lp lm     D1g0Zc
      case(194)
         factor=-1d0/nc**2*1d0/2d0*facR     ! g ub -> ub ub u lp lm     D1g0Zc
      case(195)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db g -> db db d lp lm     D1g0Zc
      case(196)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub g -> ub ub u lp lm     D1g0Zc
      case(197)
         factor=-1d0/nc**2*1d0/2d0*facR     ! db db -> db g db lp lm     D1g0Zc
      case(198)
         factor=-1d0/nc**2*1d0/2d0*facR     ! ub ub -> ub g ub lp lm     D1g0Zc
      case(199)
         factor=1d0/nc**4*1d0/2d0*facR      ! d g -> d db d lp lm     Dt1g0Z
      case(200)
         factor=1d0/nc**4*1d0/2d0*facR      ! u g -> u ub u lp lm     Dt1g0Z
      case(201)
         factor=1d0/nc**4*facR              ! d db -> g db d lp lm     Dt1g0Z
      case(202)
         factor=1d0/nc**4*facR              ! u ub -> g ub u lp lm     Dt1g0Z
      case(203)
         factor=1d0/nc**4*1d0/2d0*facR      ! d d -> g d d lp lm      Dt1g0Z
      case(204)
         factor=1d0/nc**4*1d0/2d0*facR      ! u u -> g u u lp lm      Dt1g0Z
      case(205)
         factor=1d0/nc**4*1d0/2d0*facR      ! g d -> d db d lp lm     Dt1g0Z
      case(206)
         factor=1d0/nc**4*1d0/2d0*facR      ! g u -> u ub u lp lm     Dt1g0Z
      case(207)
         factor=1d0/nc**4*facR              ! db d -> g db d lp lm     Dt1g0Z
      case(208)
         factor=1d0/nc**4*facR              ! ub u -> g ub u lp lm     Dt1g0Z
      case(209)
         factor=1d0/nc**4*1d0/2d0*facR      ! g db -> db db d lp lm     Dt1g0Z
      case(210)
         factor=1d0/nc**4*1d0/2d0*facR      ! g ub -> ub ub u lp lm     Dt1g0Z
      case(211)
         factor=1d0/nc**4*1d0/2d0*facR      ! db g -> db db d lp lm     Dt1g0Z
      case(212)
         factor=1d0/nc**4*1d0/2d0*facR      ! ub g -> ub ub u lp lm     Dt1g0Z
      case(213)
         factor=1d0/nc**4*1d0/2d0*facR      ! db db -> db g db lp lm     Dt1g0Z
      case(214)
         factor=1d0/nc**4*1d0/2d0*facR      ! ub ub -> ub g ub lp lm     Dt1g0Z

c -- virtual

      case(215)
         factor=facV                        ! d g -> g d lp lm        sB2g1Z
      case(216)
         factor=facV                        ! u g -> g u lp lm        sB2g1Z
      case(217)
         factor=1d0/2d0*facV                ! d db -> g g lp lm       sB2g1Z
      case(218)
         factor=1d0/2d0*facV                ! u ub -> g g lp lm       sB2g1Z
      case(219)
         factor=facV                        ! g d -> g d lp lm        sB2g1Z
      case(220)
         factor=facV                        ! g u -> g u lp lm        sB2g1Z
      case(221)
         factor=1d0/2d0*facV                ! db d -> g g lp lm       sB2g1Z
      case(222)
         factor=1d0/2d0*facV                ! ub u -> g g lp lm       sB2g1Z
      case(223)
         factor=ndown*facV                  ! g g -> db d lp lm       sB2g1Z
      case(224)
         factor=nup*facV                    ! g g -> ub u lp lm       sB2g1Z
      case(225)
         factor=facV                        ! g db -> db g lp lm      sB2g1Z
      case(226)
         factor=facV                        ! g ub -> ub g lp lm      sB2g1Z
      case(227)
         factor=facV                        ! db g -> db g lp lm      sB2g1Z
      case(228)
         factor=facV                        ! ub g -> ub g lp lm      sB2g1Z
      case(229)
         factor=1d0/nc*facV                 ! d d subtraction         sB2g1Z
      case(230)
         factor=1d0/nc*facV                 ! d u subtraction         sB2g1Z
      case(231)
         factor=1d0/nc*facV                 ! u d subtraction         sB2g1Z
      case(232)
         factor=1d0/nc*facV                 ! u u subtraction         sB2g1Z
      case(233)
         factor=1d0/nc*facV                 ! d db subtraction        sB2g1Z
      case(234)
         factor=1d0/nc*facV                 ! d ub subtraction        sB2g1Z
      case(235)
         factor=1d0/nc*facV                 ! u db subtraction        sB2g1Z
      case(236)
         factor=1d0/nc*facV                 ! u ub subtraction        sB2g1Z
      case(237)
         factor=1d0/nc*facV                 ! db d subtraction        sB2g1Z
      case(238)
         factor=1d0/nc*facV                 ! db u subtraction        sB2g1Z
      case(239)
         factor=1d0/nc*facV                 ! ub d subtraction        sB2g1Z
      case(240)
         factor=1d0/nc*facV                 ! ub u subtraction        sB2g1Z
      case(241)
         factor=1d0/nc*facV                 ! db db subtraction       sB2g1Z
      case(242)
         factor=1d0/nc*facV                 ! db ub subtraction       sB2g1Z
      case(243)
         factor=1d0/nc*facV                 ! ub db subtraction       sB2g1Z
      case(244)
         factor=1d0/nc*facV                 ! ub ub subtraction       sB2g1Z
      case(245)
         factor=-1d0/nc**2*facV             ! d g -> g d lp lm        sBt2g1Z
      case(246)
         factor=-1d0/nc**2*facV             ! u g -> g u lp lm        sBt2g1Z
      case(247)
         factor=-1d0/nc**2*1d0/2d0*facV     ! d db -> g g lp lm       sBt2g1Z
      case(248)
         factor=-1d0/nc**2*1d0/2d0*facV     ! u ub -> g g lp lm       sBt2g1Z
      case(249)
         factor=-1d0/nc**2*facV             ! g d -> g d lp lm        sBt2g1Z
      case(250)
         factor=-1d0/nc**2*facV             ! g u -> g u lp lm        sBt2g1Z
      case(251)
         factor=-1d0/nc**2*1d0/2d0*facV     ! db d -> g g lp lm       sBt2g1Z
      case(252)
         factor=-1d0/nc**2*1d0/2d0*facV     ! ub u -> g g lp lm       sBt2g1Z
      case(253)
         factor=-1d0/nc**2*ndown*facV       ! g g -> db d lp lm       sBt2g1Z
      case(254)
         factor=-1d0/nc**2*nup*facV         ! g g -> ub u lp lm       sBt2g1Z
      case(255)
         factor=-1d0/nc**2*facV             ! g db -> db g lp lm      sBt2g1Z
      case(256)
         factor=-1d0/nc**2*facV             ! g ub -> ub g lp lm      sBt2g1Z
      case(257)
         factor=-1d0/nc**2*facV             ! db g -> db g lp lm      sBt2g1Z
      case(258)
         factor=-1d0/nc**2*facV             ! ub g -> ub g lp lm      sBt2g1Z
      case(259)
         factor=-1d0/nc**3*facV             ! d d subtraction         sBt2g1Z
      case(260)
         factor=-1d0/nc**3*facV             ! d u subtraction         sBt2g1Z
      case(261)
         factor=-1d0/nc**3*facV             ! u d subtraction         sBt2g1Z
      case(262)
         factor=-1d0/nc**3*facV             ! u u subtraction         sBt2g1Z
      case(263)
         factor=-1d0/nc**3*facV             ! d db subtraction        sBt2g1Z
      case(264)
         factor=-1d0/nc**3*facV             ! d ub subtraction        sBt2g1Z
      case(265)
         factor=-1d0/nc**3*facV             ! u db subtraction        sBt2g1Z
      case(266)
         factor=-1d0/nc**3*facV             ! u ub subtraction        sBt2g1Z
      case(267)
         factor=-1d0/nc**3*facV             ! db d subtraction        sBt2g1Z
      case(268)
         factor=-1d0/nc**3*facV             ! db u subtraction        sBt2g1Z
      case(269)
         factor=-1d0/nc**3*facV             ! ub d subtraction        sBt2g1Z
      case(270)
         factor=-1d0/nc**3*facV             ! ub u subtraction        sBt2g1Z
      case(271)
         factor=-1d0/nc**3*facV             ! db db subtraction       sBt2g1Z
      case(272)
         factor=-1d0/nc**3*facV             ! db ub subtraction       sBt2g1Z
      case(273)
         factor=-1d0/nc**3*facV             ! ub db subtraction       sBt2g1Z
      case(274)
         factor=-1d0/nc**3*facV             ! ub ub subtraction       sBt2g1Z
      case(275)
         factor=-1d0/nc**2*facV             ! d gt -> gt d lp lm      sBtt2g1Zc
      case(276)
         factor=-1d0/nc**2*facV             ! u gt -> gt u lp lm      sBtt2g1Zc
      case(277)
         factor=-1d0/nc**2*1d0/2d0*facV     ! d db -> gt gt lp lm     sBtt2g1Zc
      case(278)
         factor=-1d0/nc**2*1d0/2d0*facV     ! u ub -> gt gt lp lm     sBtt2g1Zc
      case(279)
         factor=-1d0/nc**2*facV             ! gt d -> gt d lp lm      sBtt2g1Zc
      case(280)
         factor=-1d0/nc**2*facV             ! gt u -> gt u lp lm      sBtt2g1Zc
      case(281)
         factor=-1d0/nc**2*1d0/2d0*facV     ! db d -> gt gt lp lm     sBtt2g1Zc
      case(282)
         factor=-1d0/nc**2*1d0/2d0*facV     ! ub u -> gt gt lp lm     sBtt2g1Zc
      case(283)
         factor=-1d0/nc**2*ndown*facV       ! gt gt -> db d lp lm     sBtt2g1Zc
      case(284)
         factor=-1d0/nc**2*nup*facV         ! gt gt -> ub u lp lm     sBtt2g1Zc
      case(285)
         factor=-1d0/nc**2*facV             ! gt db -> db gt lp lm     sBtt2g1Zc
      case(286)
         factor=-1d0/nc**2*facV             ! gt ub -> ub gt lp lm     sBtt2g1Zc
      case(287)
         factor=-1d0/nc**2*facV             ! db gt -> db gt lp lm     sBtt2g1Zc
      case(288)
         factor=-1d0/nc**2*facV             ! ub gt -> ub gt lp lm     sBtt2g1Zc
      case(289)
         factor=1d0/nc**4*facV              ! d gt -> gt d lp lm      sBttt2g1Z
      case(290)
         factor=1d0/nc**4*facV              ! u gt -> gt u lp lm      sBttt2g1Z
      case(291)
         factor=1d0/nc**4*1d0/2d0*facV      ! d db -> gt gt lp lm     sBttt2g1Z
      case(292)
         factor=1d0/nc**4*1d0/2d0*facV      ! u ub -> gt gt lp lm     sBttt2g1Z
      case(293)
         factor=1d0/nc**4*facV              ! gt d -> gt d lp lm      sBttt2g1Z
      case(294)
         factor=1d0/nc**4*facV              ! gt u -> gt u lp lm      sBttt2g1Z
      case(295)
         factor=1d0/nc**4*1d0/2d0*facV      ! db d -> gt gt lp lm     sBttt2g1Z
      case(296)
         factor=1d0/nc**4*1d0/2d0*facV      ! ub u -> gt gt lp lm     sBttt2g1Z
      case(297)
         factor=1d0/nc**4*ndown*facV        ! gt gt -> db d lp lm     sBttt2g1Z
      case(298)
         factor=1d0/nc**4*nup*facV          ! gt gt -> ub u lp lm     sBttt2g1Z
      case(299)
         factor=1d0/nc**4*facV              ! gt db -> db gt lp lm     sBttt2g1Z
      case(300)
         factor=1d0/nc**4*facV              ! gt ub -> ub gt lp lm     sBttt2g1Z
      case(301)
         factor=1d0/nc**4*facV              ! db gt -> db gt lp lm     sBttt2g1Z
      case(302)
         factor=1d0/nc**4*facV              ! ub gt -> ub gt lp lm     sBttt2g1Z
      case(303)
         factor=1d0/nc*nf*facV              ! d g -> g d lp lm        sBh2g1Z
      case(304)
         factor=1d0/nc*nf*facV              ! u g -> g u lp lm        sBh2g1Z
      case(305)
         factor=1d0/nc*nf*1d0/2d0*facV      ! d db -> g g lp lm       sBh2g1Z
      case(306)
         factor=1d0/nc*nf*1d0/2d0*facV      ! u ub -> g g lp lm       sBh2g1Z
      case(307)
         factor=1d0/nc*nf*facV              ! g d -> g d lp lm        sBh2g1Z
      case(308)
         factor=1d0/nc*nf*facV              ! g u -> g u lp lm        sBh2g1Z
      case(309)
         factor=1d0/nc*nf*1d0/2d0*facV      ! db d -> g g lp lm       sBh2g1Z
      case(310)
         factor=1d0/nc*nf*1d0/2d0*facV      ! ub u -> g g lp lm       sBh2g1Z
      case(311)
         factor=1d0/nc*nf*ndown*facV        ! g g -> db d lp lm       sBh2g1Z
      case(312)
         factor=1d0/nc*nf*nup*facV          ! g g -> ub u lp lm       sBh2g1Z
      case(313)
         factor=1d0/nc*nf*facV              ! g db -> db g lp lm      sBh2g1Z
      case(314)
         factor=1d0/nc*nf*facV              ! g ub -> ub g lp lm      sBh2g1Z
      case(315)
         factor=1d0/nc*nf*facV              ! db g -> db g lp lm      sBh2g1Z
      case(316)
         factor=1d0/nc*nf*facV              ! ub g -> ub g lp lm      sBh2g1Z
      case(317)
         factor=1d0/nc**2*nf*facV           ! d d subtraction         sBh2g1Z
      case(318)
         factor=1d0/nc**2*nf*facV           ! d u subtraction         sBh2g1Z
      case(319)
         factor=1d0/nc**2*nf*facV           ! u d subtraction         sBh2g1Z
      case(320)
         factor=1d0/nc**2*nf*facV           ! u u subtraction         sBh2g1Z
      case(321)
         factor=1d0/nc**2*nf*facV           ! d db subtraction        sBh2g1Z
      case(322)
         factor=1d0/nc**2*nf*facV           ! d ub subtraction        sBh2g1Z
      case(323)
         factor=1d0/nc**2*nf*facV           ! u db subtraction        sBh2g1Z
      case(324)
         factor=1d0/nc**2*nf*facV           ! u ub subtraction        sBh2g1Z
      case(325)
         factor=1d0/nc**2*nf*facV           ! db d subtraction        sBh2g1Z
      case(326)
         factor=1d0/nc**2*nf*facV           ! db u subtraction        sBh2g1Z
      case(327)
         factor=1d0/nc**2*nf*facV           ! ub d subtraction        sBh2g1Z
      case(328)
         factor=1d0/nc**2*nf*facV           ! ub u subtraction        sBh2g1Z
      case(329)
         factor=1d0/nc**2*nf*facV           ! db db subtraction       sBh2g1Z
      case(330)
         factor=1d0/nc**2*nf*facV           ! db ub subtraction       sBh2g1Z
      case(331)
         factor=1d0/nc**2*nf*facV           ! ub db subtraction       sBh2g1Z
      case(332)
         factor=1d0/nc**2*nf*facV           ! ub ub subtraction       sBh2g1Z
      case(333)
         factor=-1d0/nc**3*nf*facV          ! d gt -> gt d lp lm      sBth2g1Z
      case(334)
         factor=-1d0/nc**3*nf*facV          ! u gt -> gt u lp lm      sBth2g1Z
      case(335)
         factor=-1d0/nc**3*nf*1d0/2d0*facV   ! d db -> gt gt lp lm     sBth2g1Z
      case(336)
         factor=-1d0/nc**3*nf*1d0/2d0*facV   ! u ub -> gt gt lp lm     sBth2g1Z
      case(337)
         factor=-1d0/nc**3*nf*facV          ! gt d -> gt d lp lm      sBth2g1Z
      case(338)
         factor=-1d0/nc**3*nf*facV          ! gt u -> gt u lp lm      sBth2g1Z
      case(339)
         factor=-1d0/nc**3*nf*1d0/2d0*facV   ! db d -> gt gt lp lm     sBth2g1Z
      case(340)
         factor=-1d0/nc**3*nf*1d0/2d0*facV   ! ub u -> gt gt lp lm     sBth2g1Z
      case(341)
         factor=-1d0/nc**3*nf*ndown*facV    ! gt gt -> db d lp lm     sBth2g1Z
      case(342)
         factor=-1d0/nc**3*nf*nup*facV      ! gt gt -> ub u lp lm     sBth2g1Z
      case(343)
         factor=-1d0/nc**3*nf*facV          ! gt db -> db gt lp lm     sBth2g1Z
      case(344)
         factor=-1d0/nc**3*nf*facV          ! gt ub -> ub gt lp lm     sBth2g1Z
      case(345)
         factor=-1d0/nc**3*nf*facV          ! db gt -> db gt lp lm     sBth2g1Z
      case(346)
         factor=-1d0/nc**3*nf*facV          ! ub gt -> ub gt lp lm     sBth2g1Z
      case(347)
         factor=1d0/nc*facV                 ! d db -> db d lp lm      sC0g1Z
      case(348)
         factor=1d0/nc*facV                 ! d ub -> ub d lp lm      sC0g1Z
      case(349)
         factor=1d0/nc*facV                 ! u db -> db u lp lm      sC0g1Z
      case(350)
         factor=1d0/nc*facV                 ! u ub -> ub u lp lm      sC0g1Z
      case(351)
         factor=1d0/nc*facV                 ! d d -> d d lp lm        sC0g1Z
      case(352)
         factor=1d0/nc*facV                 ! d u -> u d lp lm        sC0g1Z
      case(353)
         factor=1d0/nc*facV                 ! u d -> d u lp lm        sC0g1Z
      case(354)
         factor=1d0/nc*facV                 ! u u -> u u lp lm        sC0g1Z
      case(355)
         factor=1d0/nc*ndown*facV           ! d db -> d db lp lm      sC0g1Z
      case(356)
         factor=1d0/nc*nup*facV             ! d db -> u ub lp lm      sC0g1Z
      case(357)
         factor=1d0/nc*ndown*facV           ! u ub -> d db lp lm      sC0g1Z
      case(358)
         factor=1d0/nc*nup*facV             ! u ub -> u ub lp lm      sC0g1Z
      case(359)
         factor=1d0/nc*ndown*facV           ! db d -> d db lp lm      sC0g1Z
      case(360)
         factor=1d0/nc*nup*facV             ! db d -> u ub lp lm      sC0g1Z
      case(361)
         factor=1d0/nc*ndown*facV           ! ub u -> d db lp lm      sC0g1Z
      case(362)
         factor=1d0/nc*nup*facV             ! ub u -> u ub lp lm      sC0g1Z
      case(363)
         factor=1d0/nc*facV                 ! db db -> db db lp lm     sC0g1Z
      case(364)
         factor=1d0/nc*facV                 ! db ub -> db ub lp lm     sC0g1Z
      case(365)
         factor=1d0/nc*facV                 ! ub db -> ub db lp lm     sC0g1Z
      case(366)
         factor=1d0/nc*facV                 ! ub ub -> ub ub lp lm     sC0g1Z
      case(367)
         factor=1d0/nc*facV                 ! db d -> db d lp lm      sC0g1Z
      case(368)
         factor=1d0/nc*facV                 ! db u -> db u lp lm      sC0g1Z
      case(369)
         factor=1d0/nc*facV                 ! ub d -> ub d lp lm      sC0g1Z
      case(370)
         factor=1d0/nc*facV                 ! ub u -> ub u lp lm      sC0g1Z
      case(371)
         factor=1d0/nc*ndown*facV           ! g d subtraction         sC0g1Z
      case(372)
         factor=1d0/nc*nup*facV             ! g d subtraction         sC0g1Z
      case(373)
         factor=1d0/nc*ndown*facV           ! g u subtraction         sC0g1Z
      case(374)
         factor=1d0/nc*nup*facV             ! g u subtraction         sC0g1Z
      case(375)
         factor=1d0/nc*ndown*facV           ! g db subtraction        sC0g1Z
      case(376)
         factor=1d0/nc*nup*facV             ! g db subtraction        sC0g1Z
      case(377)
         factor=1d0/nc*ndown*facV           ! g ub subtraction        sC0g1Z
      case(378)
         factor=1d0/nc*nup*facV             ! g ub subtraction        sC0g1Z
      case(379)
         factor=1d0/nc*ndown*facV           ! d g subtraction         sC0g1Z
      case(380)
         factor=1d0/nc*nup*facV             ! d g subtraction         sC0g1Z
      case(381)
         factor=1d0/nc*ndown*facV           ! u g subtraction         sC0g1Z
      case(382)
         factor=1d0/nc*nup*facV             ! u g subtraction         sC0g1Z
      case(383)
         factor=1d0/nc*ndown*facV           ! db g subtraction        sC0g1Z
      case(384)
         factor=1d0/nc*nup*facV             ! db g subtraction        sC0g1Z
      case(385)
         factor=1d0/nc*ndown*facV           ! ub g subtraction        sC0g1Z
      case(386)
         factor=1d0/nc*nup*facV             ! ub g subtraction        sC0g1Z
      case(387)
         factor=1d0/nc**3*facV              ! d db -> db d lp lm      Ct0g1Z
      case(388)
         factor=1d0/nc**3*facV              ! d ub -> ub d lp lm      Ct0g1Z
      case(389)
         factor=1d0/nc**3*facV              ! u db -> db u lp lm      Ct0g1Z
      case(390)
         factor=1d0/nc**3*facV              ! u ub -> ub u lp lm      Ct0g1Z
      case(391)
         factor=1d0/nc**3*facV              ! d d -> d d lp lm        Ct0g1Z
      case(392)
         factor=1d0/nc**3*facV              ! d u -> u d lp lm        Ct0g1Z
      case(393)
         factor=1d0/nc**3*facV              ! u d -> d u lp lm        Ct0g1Z
      case(394)
         factor=1d0/nc**3*facV              ! u u -> u u lp lm        Ct0g1Z
      case(395)
         factor=1d0/nc**3*ndown*facV        ! d db -> d db lp lm      Ct0g1Z
      case(396)
         factor=1d0/nc**3*nup*facV          ! d db -> u ub lp lm      Ct0g1Z
      case(397)
         factor=1d0/nc**3*ndown*facV        ! u ub -> d db lp lm      Ct0g1Z
      case(398)
         factor=1d0/nc**3*nup*facV          ! u ub -> u ub lp lm      Ct0g1Z
      case(399)
         factor=1d0/nc**3*ndown*facV        ! db d -> d db lp lm      Ct0g1Z
      case(400)
         factor=1d0/nc**3*nup*facV          ! db d -> u ub lp lm      Ct0g1Z
      case(401)
         factor=1d0/nc**3*ndown*facV        ! ub u -> d db lp lm      Ct0g1Z
      case(402)
         factor=1d0/nc**3*nup*facV          ! ub u -> u ub lp lm      Ct0g1Z
      case(403)
         factor=1d0/nc**3*facV              ! db db -> db db lp lm     Ct0g1Z
      case(404)
         factor=1d0/nc**3*facV              ! db ub -> db ub lp lm     Ct0g1Z
      case(405)
         factor=1d0/nc**3*facV              ! ub db -> ub db lp lm     Ct0g1Z
      case(406)
         factor=1d0/nc**3*facV              ! ub ub -> ub ub lp lm     Ct0g1Z
      case(407)
         factor=1d0/nc**3*facV              ! db d -> db d lp lm      Ct0g1Z
      case(408)
         factor=1d0/nc**3*facV              ! db u -> db u lp lm      Ct0g1Z
      case(409)
         factor=1d0/nc**3*facV              ! ub d -> ub d lp lm      Ct0g1Z
      case(410)
         factor=1d0/nc**3*facV              ! ub u -> ub u lp lm      Ct0g1Z
      case(411)
         factor=1d0/nc**3*ndown*facV        ! g d subtraction         Ct0g1Z
      case(412)
         factor=1d0/nc**3*nup*facV          ! g d subtraction         Ct0g1Z
      case(413)
         factor=1d0/nc**3*ndown*facV        ! g u subtraction         Ct0g1Z
      case(414)
         factor=1d0/nc**3*nup*facV          ! g u subtraction         Ct0g1Z
      case(415)
         factor=1d0/nc**3*ndown*facV        ! g db subtraction        Ct0g1Z
      case(416)
         factor=1d0/nc**3*nup*facV          ! g db subtraction        Ct0g1Z
      case(417)
         factor=1d0/nc**3*ndown*facV        ! g ub subtraction        Ct0g1Z
      case(418)
         factor=1d0/nc**3*nup*facV          ! g ub subtraction        Ct0g1Z
      case(419)
         factor=1d0/nc**3*ndown*facV        ! d g subtraction         Ct0g1Z
      case(420)
         factor=1d0/nc**3*nup*facV          ! d g subtraction         Ct0g1Z
      case(421)
         factor=1d0/nc**3*ndown*facV        ! u g subtraction         Ct0g1Z
      case(422)
         factor=1d0/nc**3*nup*facV          ! u g subtraction         Ct0g1Z
      case(423)
         factor=1d0/nc**3*ndown*facV        ! db g subtraction        Ct0g1Z
      case(424)
         factor=1d0/nc**3*nup*facV          ! db g subtraction        Ct0g1Z
      case(425)
         factor=1d0/nc**3*ndown*facV        ! ub g subtraction        Ct0g1Z
      case(426)
         factor=1d0/nc**3*nup*facV          ! ub g subtraction        Ct0g1Z
      case(427)
         factor=1d0/nc**2*nf*facV           ! d db -> db d lp lm      Ch0g1Z
      case(428)
         factor=1d0/nc**2*nf*facV           ! d ub -> ub d lp lm      Ch0g1Z
      case(429)
         factor=1d0/nc**2*nf*facV           ! u db -> db u lp lm      Ch0g1Z
      case(430)
         factor=1d0/nc**2*nf*facV           ! u ub -> ub u lp lm      Ch0g1Z
      case(431)
         factor=1d0/nc**2*nf*facV           ! d d -> d d lp lm        Ch0g1Z
      case(432)
         factor=1d0/nc**2*nf*facV           ! d u -> u d lp lm        Ch0g1Z
      case(433)
         factor=1d0/nc**2*nf*facV           ! u d -> d u lp lm        Ch0g1Z
      case(434)
         factor=1d0/nc**2*nf*facV           ! u u -> u u lp lm        Ch0g1Z
      case(435)
         factor=1d0/nc**2*nf*ndown*facV     ! d db -> d db lp lm      Ch0g1Z
      case(436)
         factor=1d0/nc**2*nf*nup*facV       ! d db -> u ub lp lm      Ch0g1Z
      case(437)
         factor=1d0/nc**2*nf*ndown*facV     ! u ub -> d db lp lm      Ch0g1Z
      case(438)
         factor=1d0/nc**2*nf*nup*facV       ! u ub -> u ub lp lm      Ch0g1Z
      case(439)
         factor=1d0/nc**2*nf*ndown*facV     ! db d -> d db lp lm      Ch0g1Z
      case(440)
         factor=1d0/nc**2*nf*nup*facV       ! db d -> u ub lp lm      Ch0g1Z
      case(441)
         factor=1d0/nc**2*nf*ndown*facV     ! ub u -> d db lp lm      Ch0g1Z
      case(442)
         factor=1d0/nc**2*nf*nup*facV       ! ub u -> u ub lp lm      Ch0g1Z
      case(443)
         factor=1d0/nc**2*nf*facV           ! db db -> db db lp lm     Ch0g1Z
      case(444)
         factor=1d0/nc**2*nf*facV           ! db ub -> db ub lp lm     Ch0g1Z
      case(445)
         factor=1d0/nc**2*nf*facV           ! ub db -> ub db lp lm     Ch0g1Z
      case(446)
         factor=1d0/nc**2*nf*facV           ! ub ub -> ub ub lp lm     Ch0g1Z
      case(447)
         factor=1d0/nc**2*nf*facV           ! db d -> db d lp lm      Ch0g1Z
      case(448)
         factor=1d0/nc**2*nf*facV           ! db u -> db u lp lm      Ch0g1Z
      case(449)
         factor=1d0/nc**2*nf*facV           ! ub d -> ub d lp lm      Ch0g1Z
      case(450)
         factor=1d0/nc**2*nf*facV           ! ub u -> ub u lp lm      Ch0g1Z
      case(451)
         factor=1d0/nc**2*ndown*nf*facV     ! g d subtraction         Ch0g1Z
      case(452)
         factor=1d0/nc**2*nf*nup*facV       ! g d subtraction         Ch0g1Z
      case(453)
         factor=1d0/nc**2*ndown*nf*facV     ! g u subtraction         Ch0g1Z
      case(454)
         factor=1d0/nc**2*nf*nup*facV       ! g u subtraction         Ch0g1Z
      case(455)
         factor=1d0/nc**2*ndown*nf*facV     ! g db subtraction        Ch0g1Z
      case(456)
         factor=1d0/nc**2*nf*nup*facV       ! g db subtraction        Ch0g1Z
      case(457)
         factor=1d0/nc**2*ndown*nf*facV     ! g ub subtraction        Ch0g1Z
      case(458)
         factor=1d0/nc**2*nf*nup*facV       ! g ub subtraction        Ch0g1Z
      case(459)
         factor=1d0/nc**2*ndown*nf*facV     ! d g subtraction         Ch0g1Z
      case(460)
         factor=1d0/nc**2*nf*nup*facV       ! d g subtraction         Ch0g1Z
      case(461)
         factor=1d0/nc**2*ndown*nf*facV     ! u g subtraction         Ch0g1Z
      case(462)
         factor=1d0/nc**2*nf*nup*facV       ! u g subtraction         Ch0g1Z
      case(463)
         factor=1d0/nc**2*ndown*nf*facV     ! db g subtraction        Ch0g1Z
      case(464)
         factor=1d0/nc**2*nf*nup*facV       ! db g subtraction        Ch0g1Z
      case(465)
         factor=1d0/nc**2*ndown*nf*facV     ! ub g subtraction        Ch0g1Z
      case(466)
         factor=1d0/nc**2*nf*nup*facV       ! ub g subtraction        Ch0g1Z
      case(467)
         factor=1d0/nc**2*facV              ! d db -> db d lp lm      D0g1Z
      case(468)
         factor=1d0/nc**2*facV              ! u ub -> ub u lp lm      D0g1Z
      case(469)
         factor=1d0/nc**2*1d0/2d0*facV      ! d d -> d d lp lm        D0g1Z
      case(470)
         factor=1d0/nc**2*1d0/2d0*facV      ! u u -> u u lp lm        D0g1Z
      case(471)
         factor=1d0/nc**2*facV              ! db d -> db d lp lm      D0g1Z
      case(472)
         factor=1d0/nc**2*facV              ! ub u -> ub u lp lm      D0g1Z
      case(473)
         factor=1d0/nc**2*1d0/2d0*facV      ! db db -> db db lp lm     D0g1Z
      case(474)
         factor=1d0/nc**2*1d0/2d0*facV      ! ub ub -> ub ub lp lm     D0g1Z
      case(475)
         factor=1d0/nc**2*facV              ! g d subtraction         D0g1Z
      case(476)
         factor=1d0/nc**2*facV              ! g u subtraction         D0g1Z
      case(477)
         factor=1d0/nc**2*facV              ! g db subtraction        D0g1Z
      case(478)
         factor=1d0/nc**2*facV              ! g ub subtraction        D0g1Z
      case(479)
         factor=1d0/nc**2*facV              ! d g subtraction         D0g1Z
      case(480)
         factor=1d0/nc**2*facV              ! u g subtraction         D0g1Z
      case(481)
         factor=1d0/nc**2*facV              ! db g subtraction        D0g1Z
      case(482)
         factor=1d0/nc**2*facV              ! ub g subtraction        D0g1Z
      case(483)
         factor=1d0/nc**4*facV              ! d db -> db d lp lm      Dt0g1Z
      case(484)
         factor=1d0/nc**4*facV              ! u ub -> ub u lp lm      Dt0g1Z
      case(485)
         factor=1d0/nc**4*1d0/2d0*facV      ! d d -> d d lp lm        Dt0g1Z
      case(486)
         factor=1d0/nc**4*1d0/2d0*facV      ! u u -> u u lp lm        Dt0g1Z
      case(487)
         factor=1d0/nc**4*facV              ! db d -> db d lp lm      Dt0g1Z
      case(488)
         factor=1d0/nc**4*facV              ! ub u -> ub u lp lm      Dt0g1Z
      case(489)
         factor=1d0/nc**4*1d0/2d0*facV      ! db db -> db db lp lm     Dt0g1Z
      case(490)
         factor=1d0/nc**4*1d0/2d0*facV      ! ub ub -> ub ub lp lm     Dt0g1Z
      case(491)
         factor=1d0/nc**4*facV              ! g d subtraction         Dt0g1Z
      case(492)
         factor=1d0/nc**4*facV              ! g u subtraction         Dt0g1Z
      case(493)
         factor=1d0/nc**4*facV              ! g db subtraction        Dt0g1Z
      case(494)
         factor=1d0/nc**4*facV              ! g ub subtraction        Dt0g1Z
      case(495)
         factor=1d0/nc**4*facV              ! d g subtraction         Dt0g1Z
      case(496)
         factor=1d0/nc**4*facV              ! u g subtraction         Dt0g1Z
      case(497)
         factor=1d0/nc**4*facV              ! db g subtraction        Dt0g1Z
      case(498)
         factor=1d0/nc**4*facV              ! ub g subtraction        Dt0g1Z
      case(499)
         factor=1d0/nc**3*nf*facV           ! d db -> db d lp lm      Dh0g1Z
      case(500)
         factor=1d0/nc**3*nf*facV           ! u ub -> ub u lp lm      Dh0g1Z
      case(501)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! d d -> d d lp lm        Dh0g1Z
      case(502)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! u u -> u u lp lm        Dh0g1Z
      case(503)
         factor=1d0/nc**3*nf*facV           ! db d -> db d lp lm      Dh0g1Z
      case(504)
         factor=1d0/nc**3*nf*facV           ! ub u -> ub u lp lm      Dh0g1Z
      case(505)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! db db -> db db lp lm     Dh0g1Z
      case(506)
         factor=1d0/nc**3*nf*1d0/2d0*facV   ! ub ub -> ub ub lp lm     Dh0g1Z
      case(507)
         factor=1d0/nc**3*nf*facV           ! g d subtraction         Dh0g1Z
      case(508)
         factor=1d0/nc**3*nf*facV           ! g u subtraction         Dh0g1Z
      case(509)
         factor=1d0/nc**3*nf*facV           ! g db subtraction        Dh0g1Z
      case(510)
         factor=1d0/nc**3*nf*facV           ! g ub subtraction        Dh0g1Z
      case(511)
         factor=1d0/nc**3*nf*facV           ! d g subtraction         Dh0g1Z
      case(512)
         factor=1d0/nc**3*nf*facV           ! u g subtraction         Dh0g1Z
      case(513)
         factor=1d0/nc**3*nf*facV           ! db g subtraction        Dh0g1Z
      case(514)
         factor=1d0/nc**3*nf*facV           ! ub g subtraction        Dh0g1Z

c -- double real


c -- real virtual


c -- double virtual

      end select
      factor=relfactor*factor

      return
      end
