      subroutine getqcdnormZJJJ(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtZJJJ(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_vj(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVZJJJ
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourZJJJ(current_chan)
         do isub = 1, nflavourZJJJ(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_ZJJJ(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=ZJJJ "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param())**2*nc*(nc**2-1)/(2d0*nc)*8d0*(nc*(4d0*pi*alphas_scl))**2
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=1d0/2d0*facB                ! d g -> g g d lp lm      sB3g0Z
      case(2)
         factor=1d0/2d0*facB                ! u g -> g g u lp lm      sB3g0Z
      case(3)
         factor=1d0/6d0*facB                ! d db -> g g g lp lm     sB3g0Z
      case(4)
         factor=1d0/6d0*facB                ! u ub -> g g g lp lm     sB3g0Z
      case(5)
         factor=1d0/2d0*facB                ! g d -> g g d lp lm      sB3g0Z
      case(6)
         factor=1d0/2d0*facB                ! g u -> g g u lp lm      sB3g0Z
      case(7)
         factor=1d0/6d0*facB                ! db d -> g g g lp lm     sB3g0Z
      case(8)
         factor=1d0/6d0*facB                ! ub u -> g g g lp lm     sB3g0Z
      case(9)
         factor=ndown*facB                  ! g g -> db g d lp lm     sB3g0Z
      case(10)
         factor=nup*facB                    ! g g -> ub g u lp lm     sB3g0Z
      case(11)
         factor=1d0/2d0*facB                ! g db -> db g g lp lm     sB3g0Z
      case(12)
         factor=1d0/2d0*facB                ! g ub -> ub g g lp lm     sB3g0Z
      case(13)
         factor=1d0/2d0*facB                ! db g -> db g g lp lm     sB3g0Z
      case(14)
         factor=1d0/2d0*facB                ! ub g -> ub g g lp lm     sB3g0Z
      case(15)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d g -> g g d lp lm      sBt3g0Z
      case(16)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u g -> g g u lp lm      sBt3g0Z
      case(17)
         factor=-1d0/nc**2*1d0/6d0*facB     ! d db -> g g g lp lm     sBt3g0Z
      case(18)
         factor=-1d0/nc**2*1d0/6d0*facB     ! u ub -> g g g lp lm     sBt3g0Z
      case(19)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g d -> g g d lp lm      sBt3g0Z
      case(20)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g u -> g g u lp lm      sBt3g0Z
      case(21)
         factor=-1d0/nc**2*1d0/6d0*facB     ! db d -> g g g lp lm     sBt3g0Z
      case(22)
         factor=-1d0/nc**2*1d0/6d0*facB     ! ub u -> g g g lp lm     sBt3g0Z
      case(23)
         factor=-1d0/nc**2*ndown*facB       ! g g -> db g d lp lm     sBt3g0Z
      case(24)
         factor=-1d0/nc**2*nup*facB         ! g g -> ub g u lp lm     sBt3g0Z
      case(25)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g db -> db g g lp lm     sBt3g0Z
      case(26)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g ub -> ub g g lp lm     sBt3g0Z
      case(27)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db g -> db g g lp lm     sBt3g0Z
      case(28)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub g -> ub g g lp lm     sBt3g0Z
      case(29)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! d gt -> gt gt d lp lm     sBtt3g0Z
      case(30)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! u gt -> gt gt u lp lm     sBtt3g0Z
      case(31)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facB   ! d db -> gt gt gt lp lm     sBtt3g0Z
      case(32)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facB   ! u ub -> gt gt gt lp lm     sBtt3g0Z
      case(33)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! gt d -> gt gt d lp lm     sBtt3g0Z
      case(34)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! gt u -> gt gt u lp lm     sBtt3g0Z
      case(35)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facB   ! db d -> gt gt gt lp lm     sBtt3g0Z
      case(36)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*facB   ! ub u -> gt gt gt lp lm     sBtt3g0Z
      case(37)
         factor=(nc**2+1d0)/nc**4*ndown*facB   ! gt gt -> db gt d lp lm     sBtt3g0Z
      case(38)
         factor=(nc**2+1d0)/nc**4*nup*facB   ! gt gt -> ub gt u lp lm     sBtt3g0Z
      case(39)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! gt db -> db gt gt lp lm     sBtt3g0Z
      case(40)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! gt ub -> ub gt gt lp lm     sBtt3g0Z
      case(41)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! db gt -> db gt gt lp lm     sBtt3g0Z
      case(42)
         factor=(nc**2+1d0)/nc**4*1d0/2d0*facB   ! ub gt -> ub gt gt lp lm     sBtt3g0Z
      case(43)
         factor=1d0/nc*ndown*facB           ! d g -> d db d lp lm     sC1g0Z
      case(44)
         factor=1d0/nc*nup*facB             ! d g -> u ub d lp lm     sC1g0Z
      case(45)
         factor=1d0/nc*ndown*facB           ! u g -> d db u lp lm     sC1g0Z
      case(46)
         factor=1d0/nc*nup*facB             ! u g -> u ub u lp lm     sC1g0Z
      case(47)
         factor=1d0/nc*facB                 ! d db -> g db d lp lm     sC1g0Z
      case(48)
         factor=1d0/nc*facB                 ! d ub -> g ub d lp lm     sC1g0Z
      case(49)
         factor=1d0/nc*facB                 ! u db -> g db u lp lm     sC1g0Z
      case(50)
         factor=1d0/nc*facB                 ! u ub -> g ub u lp lm     sC1g0Z
      case(51)
         factor=1d0/nc*facB                 ! d d -> g d d lp lm      sC1g0Z
      case(52)
         factor=1d0/nc*facB                 ! d u -> g u d lp lm      sC1g0Z
      case(53)
         factor=1d0/nc*facB                 ! u d -> g d u lp lm      sC1g0Z
      case(54)
         factor=1d0/nc*facB                 ! u u -> g u u lp lm      sC1g0Z
      case(55)
         factor=1d0/nc*ndown*facB           ! d db -> g d db lp lm     sC1g0Z
      case(56)
         factor=1d0/nc*nup*facB             ! d db -> g u ub lp lm     sC1g0Z
      case(57)
         factor=1d0/nc*ndown*facB           ! u ub -> g d db lp lm     sC1g0Z
      case(58)
         factor=1d0/nc*nup*facB             ! u ub -> g u ub lp lm     sC1g0Z
      case(59)
         factor=1d0/nc*ndown*facB           ! g d -> d db d lp lm     sC1g0Z
      case(60)
         factor=1d0/nc*nup*facB             ! g d -> u ub d lp lm     sC1g0Z
      case(61)
         factor=1d0/nc*ndown*facB           ! g u -> d db u lp lm     sC1g0Z
      case(62)
         factor=1d0/nc*nup*facB             ! g u -> u ub u lp lm     sC1g0Z
      case(63)
         factor=1d0/nc*ndown*facB           ! db d -> g d db lp lm     sC1g0Z
      case(64)
         factor=1d0/nc*nup*facB             ! db d -> g u ub lp lm     sC1g0Z
      case(65)
         factor=1d0/nc*ndown*facB           ! ub u -> g d db lp lm     sC1g0Z
      case(66)
         factor=1d0/nc*nup*facB             ! ub u -> g u ub lp lm     sC1g0Z
      case(67)
         factor=1d0/nc*ndown*facB           ! g db -> db d db lp lm     sC1g0Z
      case(68)
         factor=1d0/nc*nup*facB             ! g db -> db u ub lp lm     sC1g0Z
      case(69)
         factor=1d0/nc*ndown*facB           ! g ub -> ub d db lp lm     sC1g0Z
      case(70)
         factor=1d0/nc*nup*facB             ! g ub -> ub u ub lp lm     sC1g0Z
      case(71)
         factor=1d0/nc*ndown*facB           ! db g -> db d db lp lm     sC1g0Z
      case(72)
         factor=1d0/nc*nup*facB             ! db g -> db u ub lp lm     sC1g0Z
      case(73)
         factor=1d0/nc*ndown*facB           ! ub g -> ub d db lp lm     sC1g0Z
      case(74)
         factor=1d0/nc*nup*facB             ! ub g -> ub u ub lp lm     sC1g0Z
      case(75)
         factor=1d0/nc*facB                 ! db db -> db g db lp lm     sC1g0Z
      case(76)
         factor=1d0/nc*facB                 ! db ub -> db g ub lp lm     sC1g0Z
      case(77)
         factor=1d0/nc*facB                 ! ub db -> ub g db lp lm     sC1g0Z
      case(78)
         factor=1d0/nc*facB                 ! ub ub -> ub g ub lp lm     sC1g0Z
      case(79)
         factor=1d0/nc*facB                 ! db d -> db g d lp lm     sC1g0Z
      case(80)
         factor=1d0/nc*facB                 ! db u -> db g u lp lm     sC1g0Z
      case(81)
         factor=1d0/nc*facB                 ! ub d -> ub g d lp lm     sC1g0Z
      case(82)
         factor=1d0/nc*facB                 ! ub u -> ub g u lp lm     sC1g0Z
      case(83)
         factor=1d0/nc**3*ndown*facB        ! d g -> d db d lp lm     sCt1g0Z
      case(84)
         factor=1d0/nc**3*nup*facB          ! d g -> u ub d lp lm     sCt1g0Z
      case(85)
         factor=1d0/nc**3*ndown*facB        ! u g -> d db u lp lm     sCt1g0Z
      case(86)
         factor=1d0/nc**3*nup*facB          ! u g -> u ub u lp lm     sCt1g0Z
      case(87)
         factor=1d0/nc**3*facB              ! d db -> g db d lp lm     sCt1g0Z
      case(88)
         factor=1d0/nc**3*facB              ! d ub -> g ub d lp lm     sCt1g0Z
      case(89)
         factor=1d0/nc**3*facB              ! u db -> g db u lp lm     sCt1g0Z
      case(90)
         factor=1d0/nc**3*facB              ! u ub -> g ub u lp lm     sCt1g0Z
      case(91)
         factor=1d0/nc**3*facB              ! d d -> g d d lp lm      sCt1g0Z
      case(92)
         factor=1d0/nc**3*facB              ! d u -> g u d lp lm      sCt1g0Z
      case(93)
         factor=1d0/nc**3*facB              ! u d -> g d u lp lm      sCt1g0Z
      case(94)
         factor=1d0/nc**3*facB              ! u u -> g u u lp lm      sCt1g0Z
      case(95)
         factor=1d0/nc**3*ndown*facB        ! d db -> g d db lp lm     sCt1g0Z
      case(96)
         factor=1d0/nc**3*nup*facB          ! d db -> g u ub lp lm     sCt1g0Z
      case(97)
         factor=1d0/nc**3*ndown*facB        ! u ub -> g d db lp lm     sCt1g0Z
      case(98)
         factor=1d0/nc**3*nup*facB          ! u ub -> g u ub lp lm     sCt1g0Z
      case(99)
         factor=1d0/nc**3*ndown*facB        ! g d -> d db d lp lm     sCt1g0Z
      case(100)
         factor=1d0/nc**3*nup*facB          ! g d -> u ub d lp lm     sCt1g0Z
      case(101)
         factor=1d0/nc**3*ndown*facB        ! g u -> d db u lp lm     sCt1g0Z
      case(102)
         factor=1d0/nc**3*nup*facB          ! g u -> u ub u lp lm     sCt1g0Z
      case(103)
         factor=1d0/nc**3*ndown*facB        ! db d -> g d db lp lm     sCt1g0Z
      case(104)
         factor=1d0/nc**3*nup*facB          ! db d -> g u ub lp lm     sCt1g0Z
      case(105)
         factor=1d0/nc**3*ndown*facB        ! ub u -> g d db lp lm     sCt1g0Z
      case(106)
         factor=1d0/nc**3*nup*facB          ! ub u -> g u ub lp lm     sCt1g0Z
      case(107)
         factor=1d0/nc**3*ndown*facB        ! g db -> db d db lp lm     sCt1g0Z
      case(108)
         factor=1d0/nc**3*nup*facB          ! g db -> db u ub lp lm     sCt1g0Z
      case(109)
         factor=1d0/nc**3*ndown*facB        ! g ub -> ub d db lp lm     sCt1g0Z
      case(110)
         factor=1d0/nc**3*nup*facB          ! g ub -> ub u ub lp lm     sCt1g0Z
      case(111)
         factor=1d0/nc**3*ndown*facB        ! db g -> db d db lp lm     sCt1g0Z
      case(112)
         factor=1d0/nc**3*nup*facB          ! db g -> db u ub lp lm     sCt1g0Z
      case(113)
         factor=1d0/nc**3*ndown*facB        ! ub g -> ub d db lp lm     sCt1g0Z
      case(114)
         factor=1d0/nc**3*nup*facB          ! ub g -> ub u ub lp lm     sCt1g0Z
      case(115)
         factor=1d0/nc**3*facB              ! db db -> db g db lp lm     sCt1g0Z
      case(116)
         factor=1d0/nc**3*facB              ! db ub -> db g ub lp lm     sCt1g0Z
      case(117)
         factor=1d0/nc**3*facB              ! ub db -> ub g db lp lm     sCt1g0Z
      case(118)
         factor=1d0/nc**3*facB              ! ub ub -> ub g ub lp lm     sCt1g0Z
      case(119)
         factor=1d0/nc**3*facB              ! db d -> db g d lp lm     sCt1g0Z
      case(120)
         factor=1d0/nc**3*facB              ! db u -> db g u lp lm     sCt1g0Z
      case(121)
         factor=1d0/nc**3*facB              ! ub d -> ub g d lp lm     sCt1g0Z
      case(122)
         factor=1d0/nc**3*facB              ! ub u -> ub g u lp lm     sCt1g0Z
      case(123)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d g -> d db d lp lm     D1g0Zc
      case(124)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u g -> u ub u lp lm     D1g0Zc
      case(125)
         factor=-1d0/nc**2*facB             ! d db -> g db d lp lm     D1g0Zc
      case(126)
         factor=-1d0/nc**2*facB             ! u ub -> g ub u lp lm     D1g0Zc
      case(127)
         factor=-1d0/nc**2*1d0/2d0*facB     ! d d -> g d d lp lm      D1g0Zc
      case(128)
         factor=-1d0/nc**2*1d0/2d0*facB     ! u u -> g u u lp lm      D1g0Zc
      case(129)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g d -> d db d lp lm     D1g0Zc
      case(130)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g u -> u ub u lp lm     D1g0Zc
      case(131)
         factor=-1d0/nc**2*facB             ! db d -> g db d lp lm     D1g0Zc
      case(132)
         factor=-1d0/nc**2*facB             ! ub u -> g ub u lp lm     D1g0Zc
      case(133)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g db -> db db d lp lm     D1g0Zc
      case(134)
         factor=-1d0/nc**2*1d0/2d0*facB     ! g ub -> ub ub u lp lm     D1g0Zc
      case(135)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db g -> db db d lp lm     D1g0Zc
      case(136)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub g -> ub ub u lp lm     D1g0Zc
      case(137)
         factor=-1d0/nc**2*1d0/2d0*facB     ! db db -> db g db lp lm     D1g0Zc
      case(138)
         factor=-1d0/nc**2*1d0/2d0*facB     ! ub ub -> ub g ub lp lm     D1g0Zc
      case(139)
         factor=1d0/nc**4*1d0/2d0*facB      ! d g -> d db d lp lm     Dt1g0Z
      case(140)
         factor=1d0/nc**4*1d0/2d0*facB      ! u g -> u ub u lp lm     Dt1g0Z
      case(141)
         factor=1d0/nc**4*facB              ! d db -> g db d lp lm     Dt1g0Z
      case(142)
         factor=1d0/nc**4*facB              ! u ub -> g ub u lp lm     Dt1g0Z
      case(143)
         factor=1d0/nc**4*1d0/2d0*facB      ! d d -> g d d lp lm      Dt1g0Z
      case(144)
         factor=1d0/nc**4*1d0/2d0*facB      ! u u -> g u u lp lm      Dt1g0Z
      case(145)
         factor=1d0/nc**4*1d0/2d0*facB      ! g d -> d db d lp lm     Dt1g0Z
      case(146)
         factor=1d0/nc**4*1d0/2d0*facB      ! g u -> u ub u lp lm     Dt1g0Z
      case(147)
         factor=1d0/nc**4*facB              ! db d -> g db d lp lm     Dt1g0Z
      case(148)
         factor=1d0/nc**4*facB              ! ub u -> g ub u lp lm     Dt1g0Z
      case(149)
         factor=1d0/nc**4*1d0/2d0*facB      ! g db -> db db d lp lm     Dt1g0Z
      case(150)
         factor=1d0/nc**4*1d0/2d0*facB      ! g ub -> ub ub u lp lm     Dt1g0Z
      case(151)
         factor=1d0/nc**4*1d0/2d0*facB      ! db g -> db db d lp lm     Dt1g0Z
      case(152)
         factor=1d0/nc**4*1d0/2d0*facB      ! ub g -> ub ub u lp lm     Dt1g0Z
      case(153)
         factor=1d0/nc**4*1d0/2d0*facB      ! db db -> db g db lp lm     Dt1g0Z
      case(154)
         factor=1d0/nc**4*1d0/2d0*facB      ! ub ub -> ub g ub lp lm     Dt1g0Z

c -- real


c -- virtual


c -- double real


c -- real virtual


c -- double virtual

      end select
      factor=relfactor*factor

      return
      end
