      subroutine getlumiepem(ix, iproc, partons)
        use Scales_mod
        use CKM_mod
        integer, intent(in) :: iproc, ix
        double precision, dimension(nMax_scl), intent(out) :: partons
        double precision, dimension(:,:), pointer :: f1, f2
        integer :: imethod
        common /method/ imethod

        if (imethod == 2) then
           select case (ix)
           case (1)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (2)
              f1(-6:7,1:nMax_scl) => f1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           case (3)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2_scl
           case (4)
              f1(-6:7,1:nMax_scl) => f1x1_scl
              f2(-6:7,1:nMax_scl) => f2x2_scl
           end select
        else
          f1(-6:7,1:nMax_scl) => f1_scl
          f2(-6:7,1:nMax_scl) => f2_scl
        end if

        partons = 0d0

        select case (iproc)

        case (    1,    2,    3,    4,    5,    6,    7,    8,          
     &            9,   10,   11,   12,   13,   14,   15,   16,          
     &           17,   18,   19,   20,   21,   22,   23,   24,          
     &           25,   26,   27,   28,   29,   30,   31,   32,          
     &           33,   34,   35,   36,   37,   38,   39,   40,          
     &           41,   42,   43,   44,   45,   46,   47,   48,          
     &           49,   50,   51,   52,   53,   54,   55,   56,          
     &           57,   58,   59,   60,   61,   62,   63,   64,          
     &           65,   66,   67,   68,   69,   70,   71,   72,          
     &           73,   74,   75,   76)
!       [-99, 99]
          partons(1:nInp_scl) = 1d0

        case default
          print*, "getlumiepem: invalid iproc:", iproc
          stop
        end select

      end subroutine getlumiepem



      function getlumiidepem(iproc, ip1, ip2) result(id)
        integer :: id
        integer, intent(in) :: iproc
        integer, intent(out) :: ip1, ip2

        id = 0

        select case (iproc)

        case (    1,    2,    3,    4,    5,    6,    7,    8,
     &            9,   10,   11,   12,   13,   14,   15,   16,
     &           17,   18,   19,   20,   21,   22,   23,   24,
     &           25,   26,   27,   28,   29,   30,   31,   32,
     &           33,   34,   35,   36,   37,   38,   39,   40,
     &           41,   42,   43,   44,   45,   46,   47,   48,
     &           49,   50,   51,   52,   53,   54,   55,   56,
     &           57,   58,   59,   60,   61,   62,   63,   64,
     &           65,   66,   67,   68,   69,   70,   71,   72,
     &           73,   74,   75,   76)
          id  = 1
          ip1 = -99
          ip2 = 99

        case default
          print*, "getlumiidepem: invalid iproc:", iproc
          stop
        end select

      end function getlumiidepem





#ifdef USE_PINEAPPL


      subroutine init_pine_lumiepem()
        use PineAPPL_mod
        use CKM_mod
!       [-99, 99]
        call register_lumi_pine(
     &         [    1,    2,    3,    4,    5,    6,    7,    8,
     &              9,   10,   11,   12,   13,   14,   15,   16,
     &             17,   18,   19,   20,   21,   22,   23,   24,
     &             25,   26,   27,   28,   29,   30,   31,   32,
     &             33,   34,   35,   36,   37,   38,   39,   40,
     &             41,   42,   43,   44,   45,   46,   47,   48,
     &             49,   50,   51,   52,   53,   54,   55,   56,
     &             57,   58,   59,   60,   61,   62,   63,   64,
     &             65,   66,   67,   68,   69,   70,   71,   72,
     &             73,   74,   75,   76],
     &         1,
     &         [  -99,   99],
     &         [  1d0]
     &       )

      end subroutine init_pine_lumiepem


#endif


