      subroutine getqcdnormepem(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtepem(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_epem(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVepem
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourepem(current_chan)
         do isub = 1, nflavourepem(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_epem(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=epem "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alphas_scl)*(4d0*pi*alpha_param())**2*nc*(nc**2-1)/(2d0*nc)*8d0
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=ndown*facB                  ! ep em -> db g d         B1g0Z
      case(2)
         factor=nup*facB                    ! ep em -> ub g u         B1g0Z

c -- real

      case(3)
         factor=1d0/2d0*ndown*facR          ! ep em -> db g g d       B2g0Zepem
      case(4)
         factor=1d0/2d0*nup*facR            ! ep em -> ub g g u       B2g0Zepem
      case(5)
         factor=-1d0/nc**2*1d0/2d0*ndown*facR   ! ep em -> db gt gt d     Bt2g0Zepem
      case(6)
         factor=-1d0/nc**2*1d0/2d0*nup*facR   ! ep em -> ub gt gt u     Bt2g0Zepem
      case(7)
         factor=1d0/nc*1d0/2d0*ndown**2*facR   ! ep em -> db d db d      C0g0Zepem
      case(8)
         factor=1d0/nc*1d0/2d0*ndown*nup*facR   ! ep em -> db u ub d      C0g0Zepem
      case(9)
         factor=1d0/nc*1d0/2d0*ndown*nup*facR   ! ep em -> ub d db u      C0g0Zepem
      case(10)
         factor=1d0/nc*1d0/2d0*nup**2*facR   ! ep em -> ub u ub u      C0g0Zepem
      case(11)
         factor=-1d0/nc**2*1d0/4d0*ndown*facR   ! ep em -> db d db d      D0g0Zepem
      case(12)
         factor=-1d0/nc**2*1d0/4d0*nup*facR   ! ep em -> ub u ub u      D0g0Zepem

c -- virtual

      case(13)
         factor=ndown*facV                  ! ep em -> db g d         B1g1Zepem
      case(14)
         factor=nup*facV                    ! ep em -> ub g u         B1g1Zepem
      case(15)
         factor=-1d0/nc**2*ndown*facV       ! ep em -> db g d         Bt1g1Zepem
      case(16)
         factor=-1d0/nc**2*nup*facV         ! ep em -> ub g u         Bt1g1Zepem
      case(17)
         factor=1d0/nc*nf*ndown*facV        ! ep em -> db g d         Bh1g1Zepem
      case(18)
         factor=1d0/nc*nf*nup*facV          ! ep em -> ub g u         Bh1g1Zepem

c -- double real

      case(19)
         factor=1d0/6d0*ndown*facRR         ! ep em -> db g g g d     B3g0Zepem
      case(20)
         factor=1d0/6d0*nup*facRR           ! ep em -> ub g g g u     B3g0Zepem
      case(21)
         factor=-1d0/nc**2*1d0/6d0*ndown*facRR   ! ep em -> db g g g d     Bt3g0Zepem
      case(22)
         factor=-1d0/nc**2*1d0/6d0*nup*facRR   ! ep em -> ub g g g u     Bt3g0Zepem
      case(23)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*ndown*facRR   ! ep em -> db gt gt gt d     Btt3g0Zepem
      case(24)
         factor=(nc**2+1d0)/nc**4*1d0/6d0*nup*facRR   ! ep em -> ub gt gt gt u     Btt3g0Zepem
      case(25)
         factor=1d0/nc*1d0/2d0*ndown**2*facRR   ! ep em -> db g d db d     C1g0Zepem
      case(26)
         factor=1d0/nc*1d0/2d0*ndown*nup*facRR   ! ep em -> db g u ub d     C1g0Zepem
      case(27)
         factor=1d0/nc*1d0/2d0*ndown*nup*facRR   ! ep em -> ub g d db u     C1g0Zepem
      case(28)
         factor=1d0/nc*1d0/2d0*nup**2*facRR   ! ep em -> ub g u ub u     C1g0Zepem
      case(29)
         factor=-1d0/nc**3*1d0/2d0*ndown**2*facRR   ! ep em -> db g d db d     sCt1g0Zepem
      case(30)
         factor=-1d0/nc**3*1d0/2d0*ndown*nup*facRR   ! ep em -> db g u ub d     sCt1g0Zepem
      case(31)
         factor=-1d0/nc**3*1d0/2d0*ndown*nup*facRR   ! ep em -> ub g d db u     sCt1g0Zepem
      case(32)
         factor=-1d0/nc**3*1d0/2d0*nup**2*facRR   ! ep em -> ub g u ub u     sCt1g0Zepem
      case(33)
         factor=-1d0/nc**2*1d0/4d0*ndown*facRR   ! ep em -> db g d db d     D1g0Zcepem
      case(34)
         factor=-1d0/nc**2*1d0/4d0*nup*facRR   ! ep em -> ub g u ub u     D1g0Zcepem
      case(35)
         factor=1d0/nc**4*1d0/4d0*ndown*facRR   ! ep em -> db g d db d     Dt1g0Zepem
      case(36)
         factor=1d0/nc**4*1d0/4d0*nup*facRR   ! ep em -> ub g u ub u     Dt1g0Zepem

c -- real virtual

      case(37)
         factor=1d0/2d0*ndown*facRV         ! ep em -> db g g d       B2g1Zepem
      case(38)
         factor=1d0/2d0*nup*facRV           ! ep em -> ub g g u       B2g1Zepem
      case(39)
         factor=-1d0/nc**2*1d0/2d0*ndown*facRV   ! ep em -> db gt gt d     Bt2g1Zepem
      case(40)
         factor=-1d0/nc**2*1d0/2d0*nup*facRV   ! ep em -> ub gt gt u     Bt2g1Zepem
      case(41)
         factor=1d0/nc**4*1d0/2d0*ndown*facRV   ! ep em -> db gt gt d     Bttt2g1Zepem
      case(42)
         factor=1d0/nc**4*1d0/2d0*nup*facRV   ! ep em -> ub gt gt u     Bttt2g1Zepem
      case(43)
         factor=1d0/nc*nf*1d0/2d0*ndown*facRV   ! ep em -> db g g d       Bh2g1Zepem
      case(44)
         factor=1d0/nc*nf*1d0/2d0*nup*facRV   ! ep em -> ub g g u       Bh2g1Zepem
      case(45)
         factor=-1d0/nc**3*nf*1d0/2d0*ndown*facRV   ! ep em -> db gt gt d     Bth2g1Zepem
      case(46)
         factor=-1d0/nc**3*nf*1d0/2d0*nup*facRV   ! ep em -> ub gt gt u     Bth2g1Zepem
      case(47)
         factor=1d0/nc*1d0/2d0*ndown**2*facRV   ! ep em -> db d db d      sC0g1Zepem
      case(48)
         factor=1d0/nc*1d0/2d0*ndown*nup*facRV   ! ep em -> db u ub d      sC0g1Zepem
      case(49)
         factor=1d0/nc*1d0/2d0*ndown*nup*facRV   ! ep em -> ub d db u      sC0g1Zepem
      case(50)
         factor=1d0/nc*1d0/2d0*nup**2*facRV   ! ep em -> ub u ub u      sC0g1Zepem
      case(51)
         factor=1d0/nc**3*1d0/2d0*ndown**2*facRV   ! ep em -> db d db d      Ct0g1Zepem
      case(52)
         factor=1d0/nc**3*1d0/2d0*ndown*nup*facRV   ! ep em -> db u ub d      Ct0g1Zepem
      case(53)
         factor=1d0/nc**3*1d0/2d0*ndown*nup*facRV   ! ep em -> ub d db u      Ct0g1Zepem
      case(54)
         factor=1d0/nc**3*1d0/2d0*nup**2*facRV   ! ep em -> ub u ub u      Ct0g1Zepem
      case(55)
         factor=1d0/nc**2*nf*1d0/2d0*ndown**2*facRV   ! ep em -> db d db d      Ch0g1Zepem
      case(56)
         factor=1d0/nc**2*nf*1d0/2d0*ndown*nup*facRV   ! ep em -> db u ub d      Ch0g1Zepem
      case(57)
         factor=1d0/nc**2*nf*1d0/2d0*ndown*nup*facRV   ! ep em -> ub d db u      Ch0g1Zepem
      case(58)
         factor=1d0/nc**2*nf*1d0/2d0*nup**2*facRV   ! ep em -> ub u ub u      Ch0g1Zepem
      case(59)
         factor=1d0/nc**2*1d0/4d0*ndown*facRV   ! ep em -> db d db d      D0g1Zepem
      case(60)
         factor=1d0/nc**2*1d0/4d0*nup*facRV   ! ep em -> ub u ub u      D0g1Zepem
      case(61)
         factor=1d0/nc**4*1d0/4d0*ndown*facRV   ! ep em -> db d db d      Dt0g1Zepem
      case(62)
         factor=1d0/nc**4*1d0/4d0*nup*facRV   ! ep em -> ub u ub u      Dt0g1Zepem
      case(63)
         factor=1d0/nc**3*nf*1d0/2d0*ndown*facRV   ! ep em -> db d db d      Dh0g1Zepem
      case(64)
         factor=1d0/nc**3*nf*1d0/2d0*nup*facRV   ! ep em -> ub u ub u      Dh0g1Zepem

c -- double virtual

      case(65)
         factor=ndown*facVV                 ! ep em -> db g d         B1g2Zepem
      case(66)
         factor=nup*facVV                   ! ep em -> ub g u         B1g2Zepem
      case(67)
         factor=-1d0/nc**2*ndown*facVV      ! ep em -> db g d         Bt1g2Zepem
      case(68)
         factor=-1d0/nc**2*nup*facVV        ! ep em -> ub g u         Bt1g2Zepem
      case(69)
         factor=1d0/nc**4*ndown*facVV       ! ep em -> db g d         Btt1g2Zepem
      case(70)
         factor=1d0/nc**4*nup*facVV         ! ep em -> ub g u         Btt1g2Zepem
      case(71)
         factor=1d0/nc*nf*ndown*facVV       ! ep em -> db g d         Bh1g2Zepem
      case(72)
         factor=1d0/nc*nf*nup*facVV         ! ep em -> ub g u         Bh1g2Zepem
      case(73)
         factor=1d0/nc**3*nf*ndown*facVV    ! ep em -> db g d         Bht1g2Zepem
      case(74)
         factor=1d0/nc**3*nf*nup*facVV      ! ep em -> ub g u         Bht1g2Zepem
      case(75)
         factor=1d0/nc**2*nf**2*ndown*facVV   ! ep em -> db g d         Bhh1g2Zepem
      case(76)
         factor=1d0/nc**2*nf**2*nup*facVV   ! ep em -> ub g u         Bhh1g2Zepem
      end select
      factor=relfactor*factor

      return
      end
