      subroutine selectchannelepem()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*alphas_scl)*(4d0*pi*amz)**2*nc*(nc**2-1)/(2d0*nc)*8d0
      n_alphas_proc = 1
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelepem: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelepem: already allocated'  
        stop
      end if

      ntot_chan = 76

      allocate(qactive_chan(1:76))
      allocate(contrib_chan(1:76))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! ep em to db g d       B1g0Z(3,4,5,1,2)      
c      qactive_chan(2)  = .true.   ! ep em to ub g u       B1g0Z(3,4,5,1,2)      

      do i=1,2
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(3)  = .true.   ! ep em to db g g d     B2g0Zepem(3,4,5,6,1,2)  epemB2g0ZepemSNLO(3,4,5,6,1,2)
c      qactive_chan(4)  = .true.   ! ep em to ub g g u     B2g0Zepem(3,4,5,6,1,2)  epemB2g0ZepemSNLO(3,4,5,6,1,2)
c      qactive_chan(5)  = .true.   ! ep em to db gt gt d   Bt2g0Zepem(3,4,5,6,1,2)  epemBt2g0ZepemSNLO(3,4,5,6,1,2)
c      qactive_chan(6)  = .true.   ! ep em to ub gt gt u   Bt2g0Zepem(3,4,5,6,1,2)  epemBt2g0ZepemSNLO(3,4,5,6,1,2)
c      qactive_chan(7)  = .true.   ! ep em to db d db d    C0g0Zepem(3,4,5,6,1,2)  epemC0g0ZepemSNLO(3,4,5,6,1,2)
c      qactive_chan(8)  = .true.   ! ep em to db u ub d    C0g0Zepem(3,4,5,6,1,2)  epemC0g0ZepemSNLO(3,4,5,6,1,2)
c      qactive_chan(9)  = .true.   ! ep em to ub d db u    C0g0Zepem(3,4,5,6,1,2)  epemC0g0ZepemSNLO(3,4,5,6,1,2)
c      qactive_chan(10) = .true.   ! ep em to ub u ub u    C0g0Zepem(3,4,5,6,1,2)  epemC0g0ZepemSNLO(3,4,5,6,1,2)
c      qactive_chan(11) = .true.   ! ep em to db d db d    D0g0Zepem(3,4,5,6,1,2)  epemD0g0ZepemSNLO(3,4,5,6,1,2)
c      qactive_chan(12) = .true.   ! ep em to ub u ub u    D0g0Zepem(3,4,5,6,1,2)  epemD0g0ZepemSNLO(3,4,5,6,1,2)

      do i=3,12
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(13) = .true.   ! ep em to db g d       B1g1Zepem(3,4,5,1,2)  epemB1g1ZepemTNLO(3,4,5,1,2)
c      qactive_chan(14) = .true.   ! ep em to ub g u       B1g1Zepem(3,4,5,1,2)  epemB1g1ZepemTNLO(3,4,5,1,2)
c      qactive_chan(15) = .true.   ! ep em to db g d       Bt1g1Zepem(3,4,5,1,2)  epemBt1g1ZepemTNLO(3,4,5,1,2)
c      qactive_chan(16) = .true.   ! ep em to ub g u       Bt1g1Zepem(3,4,5,1,2)  epemBt1g1ZepemTNLO(3,4,5,1,2)
c      qactive_chan(17) = .true.   ! ep em to db g d       Bh1g1Zepem(3,4,5,1,2)  epemBh1g1ZepemTNLO(3,4,5,1,2)
c      qactive_chan(18) = .true.   ! ep em to ub g u       Bh1g1Zepem(3,4,5,1,2)  epemBh1g1ZepemTNLO(3,4,5,1,2)

      do i=13,18
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(19) = .true.   ! ep em to db g g g d   B3g0Zepem(3,4,5,6,7,1,2)  epemB3g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(20) = .true.   ! ep em to ub g g g u   B3g0Zepem(3,4,5,6,7,1,2)  epemB3g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(21) = .true.   ! ep em to db g g g d   Bt3g0Zepem(3,4,5,6,7,1,2)  epemBt3g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(22) = .true.   ! ep em to ub g g g u   Bt3g0Zepem(3,4,5,6,7,1,2)  epemBt3g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(23) = .true.   ! ep em to db gt gt gt d   Btt3g0Zepem(3,4,5,6,7,1,2)  epemBtt3g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(24) = .true.   ! ep em to ub gt gt gt u   Btt3g0Zepem(3,4,5,6,7,1,2)  epemBtt3g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(25) = .true.   ! ep em to db g d db d   C1g0Zepem(3,4,5,6,7,1,2)  epemC1g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(26) = .true.   ! ep em to db g u ub d   C1g0Zepem(3,4,5,6,7,1,2)  epemC1g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(27) = .true.   ! ep em to ub g d db u   C1g0Zepem(3,4,5,6,7,1,2)  epemC1g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(28) = .true.   ! ep em to ub g u ub u   C1g0Zepem(3,4,5,6,7,1,2)  epemC1g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(29) = .true.   ! ep em to db g d db d   sCt1g0Zepem(3,4,5,6,7,1,2)  epemsCt1g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(30) = .true.   ! ep em to db g u ub d   sCt1g0Zepem(3,4,5,6,7,1,2)  epemsCt1g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(31) = .true.   ! ep em to ub g d db u   sCt1g0Zepem(3,4,5,6,7,1,2)  epemsCt1g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(32) = .true.   ! ep em to ub g u ub u   sCt1g0Zepem(3,4,5,6,7,1,2)  epemsCt1g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(33) = .true.   ! ep em to db g d db d   D1g0Zcepem(3,4,5,6,7,1,2)  epemD1g0ZcepemS(3,4,5,6,7,1,2)
c      qactive_chan(34) = .true.   ! ep em to ub g u ub u   D1g0Zcepem(3,4,5,6,7,1,2)  epemD1g0ZcepemS(3,4,5,6,7,1,2)
c      qactive_chan(35) = .true.   ! ep em to db g d db d   Dt1g0Zepem(3,4,5,6,7,1,2)  epemDt1g0ZepemS(3,4,5,6,7,1,2)
c      qactive_chan(36) = .true.   ! ep em to ub g u ub u   Dt1g0Zepem(3,4,5,6,7,1,2)  epemDt1g0ZepemS(3,4,5,6,7,1,2)

      do i=19,36
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(37) = .true.   ! ep em to db g g d     B2g1Zepem(3,4,5,6,1,2)  epemB2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(38) = .true.   ! ep em to ub g g u     B2g1Zepem(3,4,5,6,1,2)  epemB2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(39) = .true.   ! ep em to db gt gt d   Bt2g1Zepem(3,4,5,6,1,2)  epemBt2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(40) = .true.   ! ep em to ub gt gt u   Bt2g1Zepem(3,4,5,6,1,2)  epemBt2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(41) = .true.   ! ep em to db gt gt d   Bttt2g1Zepem(3,4,5,6,1,2)  epemBttt2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(42) = .true.   ! ep em to ub gt gt u   Bttt2g1Zepem(3,4,5,6,1,2)  epemBttt2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(43) = .true.   ! ep em to db g g d     Bh2g1Zepem(3,4,5,6,1,2)  epemBh2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(44) = .true.   ! ep em to ub g g u     Bh2g1Zepem(3,4,5,6,1,2)  epemBh2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(45) = .true.   ! ep em to db gt gt d   Bth2g1Zepem(3,4,5,6,1,2)  epemBth2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(46) = .true.   ! ep em to ub gt gt u   Bth2g1Zepem(3,4,5,6,1,2)  epemBth2g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(47) = .true.   ! ep em to db d db d    sC0g1Zepem(3,4,5,6,1,2)  epemsC0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(48) = .true.   ! ep em to db u ub d    sC0g1Zepem(3,4,5,6,1,2)  epemsC0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(49) = .true.   ! ep em to ub d db u    sC0g1Zepem(3,4,5,6,1,2)  epemsC0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(50) = .true.   ! ep em to ub u ub u    sC0g1Zepem(3,4,5,6,1,2)  epemsC0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(51) = .true.   ! ep em to db d db d    Ct0g1Zepem(3,4,5,6,1,2)  epemCt0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(52) = .true.   ! ep em to db u ub d    Ct0g1Zepem(3,4,5,6,1,2)  epemCt0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(53) = .true.   ! ep em to ub d db u    Ct0g1Zepem(3,4,5,6,1,2)  epemCt0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(54) = .true.   ! ep em to ub u ub u    Ct0g1Zepem(3,4,5,6,1,2)  epemCt0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(55) = .true.   ! ep em to db d db d    Ch0g1Zepem(3,4,5,6,1,2)  epemCh0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(56) = .true.   ! ep em to db u ub d    Ch0g1Zepem(3,4,5,6,1,2)  epemCh0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(57) = .true.   ! ep em to ub d db u    Ch0g1Zepem(3,4,5,6,1,2)  epemCh0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(58) = .true.   ! ep em to ub u ub u    Ch0g1Zepem(3,4,5,6,1,2)  epemCh0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(59) = .true.   ! ep em to db d db d    D0g1Zepem(3,4,5,6,1,2)  epemD0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(60) = .true.   ! ep em to ub u ub u    D0g1Zepem(3,4,5,6,1,2)  epemD0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(61) = .true.   ! ep em to db d db d    Dt0g1Zepem(3,4,5,6,1,2)  epemDt0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(62) = .true.   ! ep em to ub u ub u    Dt0g1Zepem(3,4,5,6,1,2)  epemDt0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(63) = .true.   ! ep em to db d db d    Dh0g1Zepem(3,4,5,6,1,2)  epemDh0g1ZepemT(3,4,5,6,1,2)
c      qactive_chan(64) = .true.   ! ep em to ub u ub u    Dh0g1Zepem(3,4,5,6,1,2)  epemDh0g1ZepemT(3,4,5,6,1,2)

      do i=37,64
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(65) = .true.   ! ep em to db g d       B1g2Zepem(3,4,5,1,2)  epemB1g2ZepemU(3,4,5,1,2)
c      qactive_chan(66) = .true.   ! ep em to ub g u       B1g2Zepem(3,4,5,1,2)  epemB1g2ZepemU(3,4,5,1,2)
c      qactive_chan(67) = .true.   ! ep em to db g d       Bt1g2Zepem(3,4,5,1,2)  epemBt1g2ZepemU(3,4,5,1,2)
c      qactive_chan(68) = .true.   ! ep em to ub g u       Bt1g2Zepem(3,4,5,1,2)  epemBt1g2ZepemU(3,4,5,1,2)
c      qactive_chan(69) = .true.   ! ep em to db g d       Btt1g2Zepem(3,4,5,1,2)  epemBtt1g2ZepemU(3,4,5,1,2)
c      qactive_chan(70) = .true.   ! ep em to ub g u       Btt1g2Zepem(3,4,5,1,2)  epemBtt1g2ZepemU(3,4,5,1,2)
c      qactive_chan(71) = .true.   ! ep em to db g d       Bh1g2Zepem(3,4,5,1,2)  epemBh1g2ZepemU(3,4,5,1,2)
c      qactive_chan(72) = .true.   ! ep em to ub g u       Bh1g2Zepem(3,4,5,1,2)  epemBh1g2ZepemU(3,4,5,1,2)
c      qactive_chan(73) = .true.   ! ep em to db g d       Bht1g2Zepem(3,4,5,1,2)  epemBht1g2ZepemU(3,4,5,1,2)
c      qactive_chan(74) = .true.   ! ep em to ub g u       Bht1g2Zepem(3,4,5,1,2)  epemBht1g2ZepemU(3,4,5,1,2)
c      qactive_chan(75) = .true.   ! ep em to db g d       Bhh1g2Zepem(3,4,5,1,2)  epemBhh1g2ZepemU(3,4,5,1,2)
c      qactive_chan(76) = .true.   ! ep em to ub g u       Bhh1g2Zepem(3,4,5,1,2)  epemBhh1g2ZepemU(3,4,5,1,2)

      do i=65,76
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelepem(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'ep em to db g d     '
        me_str   = 'B1g0Z(3,4,5,1,2)    '
        sub_str  = ''

      case (2)
        chan_str = 'ep em to ub g u     '
        me_str   = 'B1g0Z(3,4,5,1,2)    '
        sub_str  = ''

      case (3)
        chan_str = 'ep em to db g g d   '
        me_str   = 'B2g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemB2g0ZepemSNLO(3,4,5,6,1,2)'

      case (4)
        chan_str = 'ep em to ub g g u   '
        me_str   = 'B2g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemB2g0ZepemSNLO(3,4,5,6,1,2)'

      case (5)
        chan_str = 'ep em to db gt gt d '
        me_str   = 'Bt2g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBt2g0ZepemSNLO(3,4,5,6,1,2)'

      case (6)
        chan_str = 'ep em to ub gt gt u '
        me_str   = 'Bt2g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBt2g0ZepemSNLO(3,4,5,6,1,2)'

      case (7)
        chan_str = 'ep em to db d db d  '
        me_str   = 'C0g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemC0g0ZepemSNLO(3,4,5,6,1,2)'

      case (8)
        chan_str = 'ep em to db u ub d  '
        me_str   = 'C0g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemC0g0ZepemSNLO(3,4,5,6,1,2)'

      case (9)
        chan_str = 'ep em to ub d db u  '
        me_str   = 'C0g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemC0g0ZepemSNLO(3,4,5,6,1,2)'

      case (10)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'C0g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemC0g0ZepemSNLO(3,4,5,6,1,2)'

      case (11)
        chan_str = 'ep em to db d db d  '
        me_str   = 'D0g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemD0g0ZepemSNLO(3,4,5,6,1,2)'

      case (12)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'D0g0Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemD0g0ZepemSNLO(3,4,5,6,1,2)'

      case (13)
        chan_str = 'ep em to db g d     '
        me_str   = 'B1g1Zepem(3,4,5,1,2)'
        sub_str  = 'epemB1g1ZepemTNLO(3,4,5,1,2)'

      case (14)
        chan_str = 'ep em to ub g u     '
        me_str   = 'B1g1Zepem(3,4,5,1,2)'
        sub_str  = 'epemB1g1ZepemTNLO(3,4,5,1,2)'

      case (15)
        chan_str = 'ep em to db g d     '
        me_str   = 'Bt1g1Zepem(3,4,5,1,2)'
        sub_str  = 'epemBt1g1ZepemTNLO(3,4,5,1,2)'

      case (16)
        chan_str = 'ep em to ub g u     '
        me_str   = 'Bt1g1Zepem(3,4,5,1,2)'
        sub_str  = 'epemBt1g1ZepemTNLO(3,4,5,1,2)'

      case (17)
        chan_str = 'ep em to db g d     '
        me_str   = 'Bh1g1Zepem(3,4,5,1,2)'
        sub_str  = 'epemBh1g1ZepemTNLO(3,4,5,1,2)'

      case (18)
        chan_str = 'ep em to ub g u     '
        me_str   = 'Bh1g1Zepem(3,4,5,1,2)'
        sub_str  = 'epemBh1g1ZepemTNLO(3,4,5,1,2)'

      case (19)
        chan_str = 'ep em to db g g g d '
        me_str   = 'B3g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemB3g0ZepemS(3,4,5,6,7,1,2)'

      case (20)
        chan_str = 'ep em to ub g g g u '
        me_str   = 'B3g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemB3g0ZepemS(3,4,5,6,7,1,2)'

      case (21)
        chan_str = 'ep em to db g g g d '
        me_str   = 'Bt3g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemBt3g0ZepemS(3,4,5,6,7,1,2)'

      case (22)
        chan_str = 'ep em to ub g g g u '
        me_str   = 'Bt3g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemBt3g0ZepemS(3,4,5,6,7,1,2)'

      case (23)
        chan_str = 'ep em to db gt gt gt d '
        me_str   = 'Btt3g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemBtt3g0ZepemS(3,4,5,6,7,1,2)'

      case (24)
        chan_str = 'ep em to ub gt gt gt u '
        me_str   = 'Btt3g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemBtt3g0ZepemS(3,4,5,6,7,1,2)'

      case (25)
        chan_str = 'ep em to db g d db d '
        me_str   = 'C1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemC1g0ZepemS(3,4,5,6,7,1,2)'

      case (26)
        chan_str = 'ep em to db g u ub d '
        me_str   = 'C1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemC1g0ZepemS(3,4,5,6,7,1,2)'

      case (27)
        chan_str = 'ep em to ub g d db u '
        me_str   = 'C1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemC1g0ZepemS(3,4,5,6,7,1,2)'

      case (28)
        chan_str = 'ep em to ub g u ub u '
        me_str   = 'C1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemC1g0ZepemS(3,4,5,6,7,1,2)'

      case (29)
        chan_str = 'ep em to db g d db d '
        me_str   = 'sCt1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemsCt1g0ZepemS(3,4,5,6,7,1,2)'

      case (30)
        chan_str = 'ep em to db g u ub d '
        me_str   = 'sCt1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemsCt1g0ZepemS(3,4,5,6,7,1,2)'

      case (31)
        chan_str = 'ep em to ub g d db u '
        me_str   = 'sCt1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemsCt1g0ZepemS(3,4,5,6,7,1,2)'

      case (32)
        chan_str = 'ep em to ub g u ub u '
        me_str   = 'sCt1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemsCt1g0ZepemS(3,4,5,6,7,1,2)'

      case (33)
        chan_str = 'ep em to db g d db d '
        me_str   = 'D1g0Zcepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemD1g0ZcepemS(3,4,5,6,7,1,2)'

      case (34)
        chan_str = 'ep em to ub g u ub u '
        me_str   = 'D1g0Zcepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemD1g0ZcepemS(3,4,5,6,7,1,2)'

      case (35)
        chan_str = 'ep em to db g d db d '
        me_str   = 'Dt1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemDt1g0ZepemS(3,4,5,6,7,1,2)'

      case (36)
        chan_str = 'ep em to ub g u ub u '
        me_str   = 'Dt1g0Zepem(3,4,5,6,7,1,2)'
        sub_str  = 'epemDt1g0ZepemS(3,4,5,6,7,1,2)'

      case (37)
        chan_str = 'ep em to db g g d   '
        me_str   = 'B2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemB2g1ZepemT(3,4,5,6,1,2)'

      case (38)
        chan_str = 'ep em to ub g g u   '
        me_str   = 'B2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemB2g1ZepemT(3,4,5,6,1,2)'

      case (39)
        chan_str = 'ep em to db gt gt d '
        me_str   = 'Bt2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBt2g1ZepemT(3,4,5,6,1,2)'

      case (40)
        chan_str = 'ep em to ub gt gt u '
        me_str   = 'Bt2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBt2g1ZepemT(3,4,5,6,1,2)'

      case (41)
        chan_str = 'ep em to db gt gt d '
        me_str   = 'Bttt2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBttt2g1ZepemT(3,4,5,6,1,2)'

      case (42)
        chan_str = 'ep em to ub gt gt u '
        me_str   = 'Bttt2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBttt2g1ZepemT(3,4,5,6,1,2)'

      case (43)
        chan_str = 'ep em to db g g d   '
        me_str   = 'Bh2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBh2g1ZepemT(3,4,5,6,1,2)'

      case (44)
        chan_str = 'ep em to ub g g u   '
        me_str   = 'Bh2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBh2g1ZepemT(3,4,5,6,1,2)'

      case (45)
        chan_str = 'ep em to db gt gt d '
        me_str   = 'Bth2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBth2g1ZepemT(3,4,5,6,1,2)'

      case (46)
        chan_str = 'ep em to ub gt gt u '
        me_str   = 'Bth2g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemBth2g1ZepemT(3,4,5,6,1,2)'

      case (47)
        chan_str = 'ep em to db d db d  '
        me_str   = 'sC0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemsC0g1ZepemT(3,4,5,6,1,2)'

      case (48)
        chan_str = 'ep em to db u ub d  '
        me_str   = 'sC0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemsC0g1ZepemT(3,4,5,6,1,2)'

      case (49)
        chan_str = 'ep em to ub d db u  '
        me_str   = 'sC0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemsC0g1ZepemT(3,4,5,6,1,2)'

      case (50)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'sC0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemsC0g1ZepemT(3,4,5,6,1,2)'

      case (51)
        chan_str = 'ep em to db d db d  '
        me_str   = 'Ct0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemCt0g1ZepemT(3,4,5,6,1,2)'

      case (52)
        chan_str = 'ep em to db u ub d  '
        me_str   = 'Ct0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemCt0g1ZepemT(3,4,5,6,1,2)'

      case (53)
        chan_str = 'ep em to ub d db u  '
        me_str   = 'Ct0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemCt0g1ZepemT(3,4,5,6,1,2)'

      case (54)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'Ct0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemCt0g1ZepemT(3,4,5,6,1,2)'

      case (55)
        chan_str = 'ep em to db d db d  '
        me_str   = 'Ch0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemCh0g1ZepemT(3,4,5,6,1,2)'

      case (56)
        chan_str = 'ep em to db u ub d  '
        me_str   = 'Ch0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemCh0g1ZepemT(3,4,5,6,1,2)'

      case (57)
        chan_str = 'ep em to ub d db u  '
        me_str   = 'Ch0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemCh0g1ZepemT(3,4,5,6,1,2)'

      case (58)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'Ch0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemCh0g1ZepemT(3,4,5,6,1,2)'

      case (59)
        chan_str = 'ep em to db d db d  '
        me_str   = 'D0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemD0g1ZepemT(3,4,5,6,1,2)'

      case (60)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'D0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemD0g1ZepemT(3,4,5,6,1,2)'

      case (61)
        chan_str = 'ep em to db d db d  '
        me_str   = 'Dt0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemDt0g1ZepemT(3,4,5,6,1,2)'

      case (62)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'Dt0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemDt0g1ZepemT(3,4,5,6,1,2)'

      case (63)
        chan_str = 'ep em to db d db d  '
        me_str   = 'Dh0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemDh0g1ZepemT(3,4,5,6,1,2)'

      case (64)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'Dh0g1Zepem(3,4,5,6,1,2)'
        sub_str  = 'epemDh0g1ZepemT(3,4,5,6,1,2)'

      case (65)
        chan_str = 'ep em to db g d     '
        me_str   = 'B1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemB1g2ZepemU(3,4,5,1,2)'

      case (66)
        chan_str = 'ep em to ub g u     '
        me_str   = 'B1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemB1g2ZepemU(3,4,5,1,2)'

      case (67)
        chan_str = 'ep em to db g d     '
        me_str   = 'Bt1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBt1g2ZepemU(3,4,5,1,2)'

      case (68)
        chan_str = 'ep em to ub g u     '
        me_str   = 'Bt1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBt1g2ZepemU(3,4,5,1,2)'

      case (69)
        chan_str = 'ep em to db g d     '
        me_str   = 'Btt1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBtt1g2ZepemU(3,4,5,1,2)'

      case (70)
        chan_str = 'ep em to ub g u     '
        me_str   = 'Btt1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBtt1g2ZepemU(3,4,5,1,2)'

      case (71)
        chan_str = 'ep em to db g d     '
        me_str   = 'Bh1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBh1g2ZepemU(3,4,5,1,2)'

      case (72)
        chan_str = 'ep em to ub g u     '
        me_str   = 'Bh1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBh1g2ZepemU(3,4,5,1,2)'

      case (73)
        chan_str = 'ep em to db g d     '
        me_str   = 'Bht1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBht1g2ZepemU(3,4,5,1,2)'

      case (74)
        chan_str = 'ep em to ub g u     '
        me_str   = 'Bht1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBht1g2ZepemU(3,4,5,1,2)'

      case (75)
        chan_str = 'ep em to db g d     '
        me_str   = 'Bhh1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBhh1g2ZepemU(3,4,5,1,2)'

      case (76)
        chan_str = 'ep em to ub g u     '
        me_str   = 'Bhh1g2Zepem(3,4,5,1,2)'
        sub_str  = 'epemBhh1g2ZepemU(3,4,5,1,2)'

      case default
        print*, 'getchannelepem: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtepem(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtepem = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (3)
        ! [db, g, g, d]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (4)
        ! [ub, g, g, u]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (5)
        ! [db, gt, gt, d]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (6)
        ! [ub, gt, gt, u]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (7)
        ! [db, d, db, d]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (10)
        ! [ub, u, ub, u]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (11)
        ! [db, d, db, d]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (12)
        ! [ub, u, ub, u]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (19)
        ! [db, g, g, g, d]
        LIPSwgtepem = weight_lips((/ 4,5,6 /))

      case (20)
        ! [ub, g, g, g, u]
        LIPSwgtepem = weight_lips((/ 4,5,6 /))

      case (21)
        ! [db, g, g, g, d]
        LIPSwgtepem = weight_lips((/ 4,5,6 /))

      case (22)
        ! [ub, g, g, g, u]
        LIPSwgtepem = weight_lips((/ 4,5,6 /))

      case (23)
        ! [db, gt, gt, gt, d]
        LIPSwgtepem = weight_lips((/ 4,5,6 /))

      case (24)
        ! [ub, gt, gt, gt, u]
        LIPSwgtepem = weight_lips((/ 4,5,6 /))

      case (25)
        ! [db, g, d, db, d]
        LIPSwgtepem = weight_lips((/ 5,7 /), (/ 3,6 /))

      case (28)
        ! [ub, g, u, ub, u]
        LIPSwgtepem = weight_lips((/ 5,7 /), (/ 3,6 /))

      case (29)
        ! [db, g, d, db, d]
        LIPSwgtepem = weight_lips((/ 5,7 /), (/ 3,6 /))

      case (32)
        ! [ub, g, u, ub, u]
        LIPSwgtepem = weight_lips((/ 5,7 /), (/ 3,6 /))

      case (33)
        ! [db, g, d, db, d]
        LIPSwgtepem = weight_lips((/ 5,7 /), (/ 3,6 /))

      case (34)
        ! [ub, g, u, ub, u]
        LIPSwgtepem = weight_lips((/ 5,7 /), (/ 3,6 /))

      case (35)
        ! [db, g, d, db, d]
        LIPSwgtepem = weight_lips((/ 5,7 /), (/ 3,6 /))

      case (36)
        ! [ub, g, u, ub, u]
        LIPSwgtepem = weight_lips((/ 5,7 /), (/ 3,6 /))

      case (37)
        ! [db, g, g, d]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (38)
        ! [ub, g, g, u]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (39)
        ! [db, gt, gt, d]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (40)
        ! [ub, gt, gt, u]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (41)
        ! [db, gt, gt, d]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (42)
        ! [ub, gt, gt, u]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (43)
        ! [db, g, g, d]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (44)
        ! [ub, g, g, u]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (45)
        ! [db, gt, gt, d]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (46)
        ! [ub, gt, gt, u]
        LIPSwgtepem = weight_lips((/ 4,5 /))

      case (47)
        ! [db, d, db, d]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (50)
        ! [ub, u, ub, u]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (51)
        ! [db, d, db, d]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (54)
        ! [ub, u, ub, u]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (55)
        ! [db, d, db, d]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (58)
        ! [ub, u, ub, u]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (59)
        ! [db, d, db, d]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (60)
        ! [ub, u, ub, u]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (61)
        ! [db, d, db, d]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (62)
        ! [ub, u, ub, u]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (63)
        ! [db, d, db, d]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (64)
        ! [ub, u, ub, u]
        LIPSwgtepem = weight_lips((/ 4,6 /), (/ 3,5 /))

      case default
        LIPSwgtepem = 1

      end select
      end
