      function sigRRepem(rnorm,x1,x2,wgt)
      use Channels_mod
      use Mapping_mod
      use Scales_mod
#ifdef USE_OL  
      use KinData_mod 
      use openloops 
      use Constants_mod 
#endif 
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      use Observables_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      double precision kinwt(nMax_scl)
      double precision wt, wtsum
      double precision treeME,loopindME,loopME(0:2)
      double precision treeME_t,loopME_t(0:2)
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /order/ieorder
      double precision acc

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      ix=1
      ix_chan=1

      sigRRepem=0d0
      wtsum=0d0
      kinwt=0d0
      wt=0d0
      acc=0d0
      treeME=0d0
      loopindME=0d0
      loopME=0d0
      ipass=1
      call unset_map()
      call ecuts_epem(0,7,ipass)
      virtsflag=.false.
      jflag=.false.
      if(ipass.eq.0)return

#ifdef USE_OL  
      call fill_pOL(7, (/ 1, 2, 3, 4, 5, 6, 7 /) )
#endif 

c--- ep em to db g g g d 
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0Zepem(3,4,5,6,7,1,2)
     .          +B3g0Zepem(3,4,6,5,7,1,2)
     .          +B3g0Zepem(3,5,4,6,7,1,2)
     .          +B3g0Zepem(3,5,6,4,7,1,2)
     .          +B3g0Zepem(3,6,4,5,7,1,2)
     .          +B3g0Zepem(3,6,5,4,7,1,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to ub g g g u 
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           B3g0Zepem(3,4,5,6,7,1,2)
     .          +B3g0Zepem(3,4,6,5,7,1,2)
     .          +B3g0Zepem(3,5,4,6,7,1,2)
     .          +B3g0Zepem(3,5,6,4,7,1,2)
     .          +B3g0Zepem(3,6,4,5,7,1,2)
     .          +B3g0Zepem(3,6,5,4,7,1,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to db g g g d 
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0Zepem(3,4,5,6,7,1,2)
     .          +Bt3g0Zepem(3,4,6,5,7,1,2)
     .          +Bt3g0Zepem(3,5,4,6,7,1,2)
     .          +Bt3g0Zepem(3,5,6,4,7,1,2)
     .          +Bt3g0Zepem(3,6,4,5,7,1,2)
     .          +Bt3g0Zepem(3,6,5,4,7,1,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to ub g g g u 
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Bt3g0Zepem(3,4,5,6,7,1,2)
     .          +Bt3g0Zepem(3,4,6,5,7,1,2)
     .          +Bt3g0Zepem(3,5,4,6,7,1,2)
     .          +Bt3g0Zepem(3,5,6,4,7,1,2)
     .          +Bt3g0Zepem(3,6,4,5,7,1,2)
     .          +Bt3g0Zepem(3,6,5,4,7,1,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to db gt gt gt d 
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0Zepem(3,4,5,6,7,1,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to ub gt gt gt u 
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = (
     .           Btt3g0Zepem(3,4,5,6,7,1,2) )
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to db g d db d 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to db g u ub d 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to ub g d db u 
      if (qactive_chan(27).and.qselect_chan(27)) then
        current_chan = 27
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to ub g u ub u 
      if (qactive_chan(28).and.qselect_chan(28)) then
        current_chan = 28
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = C1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to db g d db d 
      if (qactive_chan(29).and.qselect_chan(29)) then
        current_chan = 29
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to db g u ub d 
      if (qactive_chan(30).and.qselect_chan(30)) then
        current_chan = 30
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to ub g d db u 
      if (qactive_chan(31).and.qselect_chan(31)) then
        current_chan = 31
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to ub g u ub u 
      if (qactive_chan(32).and.qselect_chan(32)) then
        current_chan = 32
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = sCt1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to db g d db d 
      if (qactive_chan(33).and.qselect_chan(33)) then
        current_chan = 33
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Zcepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to ub g u ub u 
      if (qactive_chan(34).and.qselect_chan(34)) then
        current_chan = 34
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = D1g0Zcepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to db g d db d 
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif
c--- ep em to ub g u ub u 
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        ipass_chan = 1
        call set_flav_perm(7, (/ 3,4,5,6,7,1,2 /))
        call getqcdnorm(ix,partons,factor, 7, ipass_chan, 0)
        if (ipass_chan == 1) then
          kinwt = Dt1g0Zepem(3,4,5,6,7,1,2)
          kinwt = kinwt * factor
          wt = bino(ix,partons,kinwt)
          wtsum = wtsum + wt
        endif
        call unset_flav_perm()
      endif

      sigRRepem=rnorm*wtsum

      return
      end
