      subroutine getqcdnormepemjj(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Charges_EW_mod
      use Process_mod
      use ProcLib_mod, only : getlumi_plib
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use Flavour_mod
      use Histograms_mod, only: isActive_hist
      use LIPS_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      double precision relfactor
      double precision partons_sub(nMax_scl)
      double precision facB(nMax_scl)
      double precision facV(nMax_scl),facR(nMax_scl)
      double precision facVV(nMax_scl),facRV(nMax_scl),facRR(nMax_scl)
      double precision C0(nMax_scl), C1(nMax_scl), C2(nMax_scl)
      double precision C2h(nMax_scl), dlstop(nMax_scl)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /eweakW/amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Hmass/ emh,ehwidth
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtepemjj(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_epem(1,npar,ipass)
      if (ipass==0) return
      
      
      if (.not.isActive_flav()) then
        call getlumi_plib(ix, current_chan, partons)
        relfactor = 1d0
      else
#ifdef FLAVepemjj
         ipass = 0
         partons = 0d0
         relfactor  = 1d0/relfacflavourepemjj(current_chan)
         do isub = 1, nflavourepemjj(current_chan)
           ipass_sub = 1
      
           !> this dresses the flavours, does permutations, makes coffee
           call dress_flav_epemjj(current_chan, isub, ipass_sub, flav_block)
           if (ipass_sub == 0) cycle
           call ecuts_flav(0, npar, ipass_sub)
           if (ipass_sub == 0) cycle
           ipass = 1
      
           ip1_chan = getPDF_flav(npar, 1)
           ip2_chan = getPDF_flav(npar, 2)
      
           call get_lumi_scl(ix, ip1_chan, ip2_chan, partons_sub)
           if ( isActive_hist() ) call push_flav(ip1_chan, ip2_chan, partons_sub)
           partons = partons + partons_sub
         end do
         if (ipass==0) return
#else
         print*,"flavour-tagging routines not compiled for this process"
         print*,"run: make flav=epemjj "
         stop
#endif
      end if
      
      
      ave = ilips * get_avg(ip1_chan,ip2_chan)
      
      facB=ave*(4d0*pi*alpha_param())**2*nc*4d0
      facR=facB*nc*4d0*pi*alphas_scl
      facV=facB*nc*alphas_scl/twopi
      facRR=facR*nc*4d0*pi*alphas_scl
      facRV=facR*nc*alphas_scl/twopi
      facVV=facV*nc*alphas_scl/twopi
      
      select case (current_chan)

c -- tree level

      case(1)
         factor=ndown*facB                  ! ep em -> db d           B0g0Z
      case(2)
         factor=nup*facB                    ! ep em -> ub u           B0g0Z

c -- real

      case(3)
         factor=(nc**2-1d0)/nc**2*ndown*facR   ! ep em -> db g d         B1g0Z
      case(4)
         factor=(nc**2-1d0)/nc**2*nup*facR   ! ep em -> ub g u         B1g0Z

c -- virtual

      case(5)
         factor=(nc**2-1d0)/nc**2*ndown*facV   ! ep em -> db d           B0g1Z
      case(6)
         factor=(nc**2-1d0)/nc**2*nup*facV   ! ep em -> ub u           B0g1Z

c -- double real

      case(7)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*ndown*facRR   ! ep em -> db g g d       B2g0Z
      case(8)
         factor=(nc**2-1d0)/nc**2*1d0/2d0*nup*facRR   ! ep em -> ub g g u       B2g0Z
      case(9)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*ndown*facRR   ! ep em -> db gt gt d     Bt2g0Z
      case(10)
         factor=-(nc**2-1d0)/nc**4*1d0/2d0*nup*facRR   ! ep em -> ub gt gt u     Bt2g0Z
      case(11)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*ndown**2*facRR   ! ep em -> db d db d      C0g0Z
      case(12)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*ndown*nup*facRR   ! ep em -> db u ub d      C0g0Z
      case(13)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*ndown*nup*facRR   ! ep em -> ub d db u      C0g0Z
      case(14)
         factor=(nc**2-1d0)/nc**3*1d0/2d0*nup**2*facRR   ! ep em -> ub u ub u      C0g0Z
      case(15)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*ndown*facRR   ! ep em -> db d db d      D0g0Z
      case(16)
         factor=-(nc**2-1d0)/nc**4*1d0/4d0*nup*facRR   ! ep em -> ub u ub u      D0g0Z

c -- real virtual

      case(17)
         factor=(nc**2-1d0)/nc**2*ndown*facRV   ! ep em -> db g d         B1g1Z
      case(18)
         factor=(nc**2-1d0)/nc**2*nup*facRV   ! ep em -> ub g u         B1g1Z
      case(19)
         factor=-(nc**2-1d0)/nc**4*ndown*facRV   ! ep em -> db g d         Bt1g1Z
      case(20)
         factor=-(nc**2-1d0)/nc**4*nup*facRV   ! ep em -> ub g u         Bt1g1Z
      case(21)
         factor=(nc**2-1d0)/nc**3*nf*ndown*facRV   ! ep em -> db g d         Bh1g1Z
      case(22)
         factor=(nc**2-1d0)/nc**3*nf*nup*facRV   ! ep em -> ub g u         Bh1g1Z

c -- double virtual

      case(23)
         factor=(nc**2-1d0)/nc**2*ndown*facVV   ! ep em -> db d           B0g2Z
      case(24)
         factor=(nc**2-1d0)/nc**2*nup*facVV   ! ep em -> ub u           B0g2Z
      case(25)
         factor=-(nc**2-1d0)/nc**4*ndown*facVV   ! ep em -> db d           Bt0g2Z
      case(26)
         factor=-(nc**2-1d0)/nc**4*nup*facVV   ! ep em -> ub u           Bt0g2Z
      case(27)
         factor=(nc**2-1d0)/nc**3*nf*ndown*facVV   ! ep em -> db d           Bh0g2Z
      case(28)
         factor=(nc**2-1d0)/nc**3*nf*nup*facVV   ! ep em -> ub u           Bh0g2Z
      end select
      factor=relfactor*factor

      return
      end
