      subroutine selectchannelepemjj()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*amz)**2*nc*4d0
      n_alphas_proc = 0
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelepemjj: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelepemjj: already allocated'  
        stop
      end if

      ntot_chan = 28

      allocate(qactive_chan(1:28))
      allocate(contrib_chan(1:28))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! ep em to db d         B0g0Z(3,4,2,1)        
c      qactive_chan(2)  = .true.   ! ep em to ub u         B0g0Z(3,4,2,1)        

      do i=1,2
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(3)  = .true.   ! ep em to db g d       B1g0Z(3,4,5,2,1)      epemB1g0ZSNLO(3,4,5,2,1)
c      qactive_chan(4)  = .true.   ! ep em to ub g u       B1g0Z(3,4,5,2,1)      epemB1g0ZSNLO(3,4,5,2,1)

      do i=3,4
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(5)  = .true.   ! ep em to db d         B0g1Z(3,4,2,1)        epemB0g1ZTNLO(3,4,2,1)
c      qactive_chan(6)  = .true.   ! ep em to ub u         B0g1Z(3,4,2,1)        epemB0g1ZTNLO(3,4,2,1)

      do i=5,6
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c      qactive_chan(7)  = .true.   ! ep em to db g g d     B2g0Z(3,4,5,6,2,1)    epemB2g0ZS(3,4,5,6,2,1)
c      qactive_chan(8)  = .true.   ! ep em to ub g g u     B2g0Z(3,4,5,6,2,1)    epemB2g0ZS(3,4,5,6,2,1)
c      qactive_chan(9)  = .true.   ! ep em to db gt gt d   Bt2g0Z(3,4,5,6,2,1)   epemBt2g0ZS(3,4,5,6,2,1)
c      qactive_chan(10) = .true.   ! ep em to ub gt gt u   Bt2g0Z(3,4,5,6,2,1)   epemBt2g0ZS(3,4,5,6,2,1)
c      qactive_chan(11) = .true.   ! ep em to db d db d    C0g0Z(3,4,5,6,2,1)    epemC0g0ZS(3,4,5,6,2,1)
c      qactive_chan(12) = .true.   ! ep em to db u ub d    C0g0Z(3,4,5,6,2,1)    epemC0g0ZS(3,4,5,6,2,1)
c      qactive_chan(13) = .true.   ! ep em to ub d db u    C0g0Z(3,4,5,6,2,1)    epemC0g0ZS(3,4,5,6,2,1)
c      qactive_chan(14) = .true.   ! ep em to ub u ub u    C0g0Z(3,4,5,6,2,1)    epemC0g0ZS(3,4,5,6,2,1)
c      qactive_chan(15) = .true.   ! ep em to db d db d    D0g0Z(3,4,5,6,2,1)    epemD0g0ZS(3,4,5,6,2,1)
c      qactive_chan(16) = .true.   ! ep em to ub u ub u    D0g0Z(3,4,5,6,2,1)    epemD0g0ZS(3,4,5,6,2,1)

      do i=7,16
        contrib_chan(i)=4
      enddo

c -- real virtual                                 ME                   T  

c      qactive_chan(17) = .true.   ! ep em to db g d       B1g1Z(3,4,5,2,1)      epemB1g1ZT(3,4,5,2,1)
c      qactive_chan(18) = .true.   ! ep em to ub g u       B1g1Z(3,4,5,2,1)      epemB1g1ZT(3,4,5,2,1)
c      qactive_chan(19) = .true.   ! ep em to db g d       Bt1g1Z(3,4,5,2,1)     epemBt1g1ZT(3,4,5,2,1)
c      qactive_chan(20) = .true.   ! ep em to ub g u       Bt1g1Z(3,4,5,2,1)     epemBt1g1ZT(3,4,5,2,1)
c      qactive_chan(21) = .true.   ! ep em to db g d       Bh1g1Z(3,4,5,2,1)     epemBh1g1ZT(3,4,5,2,1)
c      qactive_chan(22) = .true.   ! ep em to ub g u       Bh1g1Z(3,4,5,2,1)     epemBh1g1ZT(3,4,5,2,1)

      do i=17,22
        contrib_chan(i)=5
      enddo

c -- double virtual                               ME                   U  

c      qactive_chan(23) = .true.   ! ep em to db d         B0g2Z(3,4,2,1)        epemB0g2ZU(3,4,2,1)
c      qactive_chan(24) = .true.   ! ep em to ub u         B0g2Z(3,4,2,1)        epemB0g2ZU(3,4,2,1)
c      qactive_chan(25) = .true.   ! ep em to db d         Bt0g2Z(3,4,2,1)       epemBt0g2ZU(3,4,2,1)
c      qactive_chan(26) = .true.   ! ep em to ub u         Bt0g2Z(3,4,2,1)       epemBt0g2ZU(3,4,2,1)
c      qactive_chan(27) = .true.   ! ep em to db d         Bh0g2Z(3,4,2,1)       epemBh0g2ZU(3,4,2,1)
c      qactive_chan(28) = .true.   ! ep em to ub u         Bh0g2Z(3,4,2,1)       epemBh0g2ZU(3,4,2,1)

      do i=23,28
        contrib_chan(i)=6
      enddo

      return
      end


c---- get channel strings
      subroutine getchannelepemjj(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'ep em to db d       '
        me_str   = 'B0g0Z(3,4,2,1)      '
        sub_str  = ''

      case (2)
        chan_str = 'ep em to ub u       '
        me_str   = 'B0g0Z(3,4,2,1)      '
        sub_str  = ''

      case (3)
        chan_str = 'ep em to db g d     '
        me_str   = 'B1g0Z(3,4,5,2,1)    '
        sub_str  = 'epemB1g0ZSNLO(3,4,5,2,1)'

      case (4)
        chan_str = 'ep em to ub g u     '
        me_str   = 'B1g0Z(3,4,5,2,1)    '
        sub_str  = 'epemB1g0ZSNLO(3,4,5,2,1)'

      case (5)
        chan_str = 'ep em to db d       '
        me_str   = 'B0g1Z(3,4,2,1)      '
        sub_str  = 'epemB0g1ZTNLO(3,4,2,1)'

      case (6)
        chan_str = 'ep em to ub u       '
        me_str   = 'B0g1Z(3,4,2,1)      '
        sub_str  = 'epemB0g1ZTNLO(3,4,2,1)'

      case (7)
        chan_str = 'ep em to db g g d   '
        me_str   = 'B2g0Z(3,4,5,6,2,1)  '
        sub_str  = 'epemB2g0ZS(3,4,5,6,2,1)'

      case (8)
        chan_str = 'ep em to ub g g u   '
        me_str   = 'B2g0Z(3,4,5,6,2,1)  '
        sub_str  = 'epemB2g0ZS(3,4,5,6,2,1)'

      case (9)
        chan_str = 'ep em to db gt gt d '
        me_str   = 'Bt2g0Z(3,4,5,6,2,1) '
        sub_str  = 'epemBt2g0ZS(3,4,5,6,2,1)'

      case (10)
        chan_str = 'ep em to ub gt gt u '
        me_str   = 'Bt2g0Z(3,4,5,6,2,1) '
        sub_str  = 'epemBt2g0ZS(3,4,5,6,2,1)'

      case (11)
        chan_str = 'ep em to db d db d  '
        me_str   = 'C0g0Z(3,4,5,6,2,1)  '
        sub_str  = 'epemC0g0ZS(3,4,5,6,2,1)'

      case (12)
        chan_str = 'ep em to db u ub d  '
        me_str   = 'C0g0Z(3,4,5,6,2,1)  '
        sub_str  = 'epemC0g0ZS(3,4,5,6,2,1)'

      case (13)
        chan_str = 'ep em to ub d db u  '
        me_str   = 'C0g0Z(3,4,5,6,2,1)  '
        sub_str  = 'epemC0g0ZS(3,4,5,6,2,1)'

      case (14)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'C0g0Z(3,4,5,6,2,1)  '
        sub_str  = 'epemC0g0ZS(3,4,5,6,2,1)'

      case (15)
        chan_str = 'ep em to db d db d  '
        me_str   = 'D0g0Z(3,4,5,6,2,1)  '
        sub_str  = 'epemD0g0ZS(3,4,5,6,2,1)'

      case (16)
        chan_str = 'ep em to ub u ub u  '
        me_str   = 'D0g0Z(3,4,5,6,2,1)  '
        sub_str  = 'epemD0g0ZS(3,4,5,6,2,1)'

      case (17)
        chan_str = 'ep em to db g d     '
        me_str   = 'B1g1Z(3,4,5,2,1)    '
        sub_str  = 'epemB1g1ZT(3,4,5,2,1)'

      case (18)
        chan_str = 'ep em to ub g u     '
        me_str   = 'B1g1Z(3,4,5,2,1)    '
        sub_str  = 'epemB1g1ZT(3,4,5,2,1)'

      case (19)
        chan_str = 'ep em to db g d     '
        me_str   = 'Bt1g1Z(3,4,5,2,1)   '
        sub_str  = 'epemBt1g1ZT(3,4,5,2,1)'

      case (20)
        chan_str = 'ep em to ub g u     '
        me_str   = 'Bt1g1Z(3,4,5,2,1)   '
        sub_str  = 'epemBt1g1ZT(3,4,5,2,1)'

      case (21)
        chan_str = 'ep em to db g d     '
        me_str   = 'Bh1g1Z(3,4,5,2,1)   '
        sub_str  = 'epemBh1g1ZT(3,4,5,2,1)'

      case (22)
        chan_str = 'ep em to ub g u     '
        me_str   = 'Bh1g1Z(3,4,5,2,1)   '
        sub_str  = 'epemBh1g1ZT(3,4,5,2,1)'

      case (23)
        chan_str = 'ep em to db d       '
        me_str   = 'B0g2Z(3,4,2,1)      '
        sub_str  = 'epemB0g2ZU(3,4,2,1)'

      case (24)
        chan_str = 'ep em to ub u       '
        me_str   = 'B0g2Z(3,4,2,1)      '
        sub_str  = 'epemB0g2ZU(3,4,2,1)'

      case (25)
        chan_str = 'ep em to db d       '
        me_str   = 'Bt0g2Z(3,4,2,1)     '
        sub_str  = 'epemBt0g2ZU(3,4,2,1)'

      case (26)
        chan_str = 'ep em to ub u       '
        me_str   = 'Bt0g2Z(3,4,2,1)     '
        sub_str  = 'epemBt0g2ZU(3,4,2,1)'

      case (27)
        chan_str = 'ep em to db d       '
        me_str   = 'Bh0g2Z(3,4,2,1)     '
        sub_str  = 'epemBh0g2ZU(3,4,2,1)'

      case (28)
        chan_str = 'ep em to ub u       '
        me_str   = 'Bh0g2Z(3,4,2,1)     '
        sub_str  = 'epemBh0g2ZU(3,4,2,1)'

      case default
        print*, 'getchannelepemjj: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtepemjj(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtepemjj = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (7)
        ! [db, g, g, d]
        LIPSwgtepemjj = weight_lips((/ 4,5 /))

      case (8)
        ! [ub, g, g, u]
        LIPSwgtepemjj = weight_lips((/ 4,5 /))

      case (9)
        ! [db, gt, gt, d]
        LIPSwgtepemjj = weight_lips((/ 4,5 /))

      case (10)
        ! [ub, gt, gt, u]
        LIPSwgtepemjj = weight_lips((/ 4,5 /))

      case (11)
        ! [db, d, db, d]
        LIPSwgtepemjj = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (14)
        ! [ub, u, ub, u]
        LIPSwgtepemjj = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (15)
        ! [db, d, db, d]
        LIPSwgtepemjj = weight_lips((/ 4,6 /), (/ 3,5 /))

      case (16)
        ! [ub, u, ub, u]
        LIPSwgtepemjj = weight_lips((/ 4,6 /), (/ 3,5 /))

      case default
        LIPSwgtepemjj = 1

      end select
      end
