****************************************************
* ggd30II(i1,i2,i3,ipset)
*   d30 sub antenna two initial gluons
*   D(gg,q) = D(g1,g2;q) + D(g2,g1;q)
*   D(g1,g2;q) is singular when g2//q NOT when g1//q
*   D(g2,g1;q) is singular when g1//q NOT when g2//q
*
*   D(q,g1,g2) = D(g2,g1,q) using reflection symmetry
*
*	intial states i2 and i3
      function ggd30II(i1,i2,i3,ipset) ! singular when i1//i2
      use KinData_mod
      implicit double precision (a-h,o-z)
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      ggd30II=s23**2/s12+4d0*s13**2/s12+4d0*s12**2/s23
     .   +3d0*s23*s13/s12+2d0*s13**3/s23/s12+3d0*s13*s12/s23
     .   +3d0*s23+9d0*s12

      ggd30II=ggd30II/s123**2
*      write(*,*)" qgd30II ",qgd30II
      return
      end

************************************************************************
