************************************************************************
      function SSintFI(ix,x1,x2,i1,i2,i12set,i3,i4,i34set,renscale)
*XC i1=a, i2=c, i3=2 ((boosted) from double real level), i4=K, i2 and i4 are assumed to be in final states
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /boost/pinit(4),ip
!$omp threadprivate(/boost/)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(ip.eq.1)then
         SSintFI=SSintIF(ix,x1,x2,i1,i2,i12set,i3,i4,i34set,renscale)
         return
      endif

      s12=2d0*dot(kin(i12set)%p(:,i1),kin(i12set)%p(:,i2))
      s34=abs(2d0*dot(pinit,kin(i34set)%p(:,i4)))
      s14=2d0*dot(kin(i12set)%p(:,i1),kin(i34set)%p(:,i4))
      s24=2d0*dot(kin(i12set)%p(:,i2),kin(i34set)%p(:,i4))
      s13=2d0*dot(kin(i12set)%p(:,i1),pinit)
      s23=2d0*dot(kin(i12set)%p(:,i2),pinit)

      ! if(i12set.eq.4.and.i34set.eq.4)then
      !   s12=2d0*dot(p4(1,i1),p4(1,i2))
      !   s34=abs(2d0*dot(pinit(1),p4(1,i4)))
      !   s14=2d0*dot(p4(1,i1),p4(1,i4))
      !   s24=2d0*dot(p4(1,i2),p4(1,i4))
      !   s13=2d0*dot(p4(1,i1),pinit(1))
      !   s23=2d0*dot(p4(1,i2),pinit(1))
      ! elseif(i12set.eq.4.and.i34set.eq.5)then
      !   s12=2d0*dot(p4(1,i1),p4(1,i2))
      !   s34=abs(2d0*dot(pinit(1),p5(1,i4)))
      !   s14=2d0*dot(p4(1,i1),p5(1,i4))
      !   s24=2d0*dot(p4(1,i2),p5(1,i4))
      !   s13=2d0*dot(p4(1,i1),pinit(1))
      !   s23=2d0*dot(p4(1,i2),pinit(1))
      ! elseif(i12set.eq.5.and.i34set.eq.5)then
      !   s12=2d0*dot(p5(1,i1),p5(1,i2))
      !   s34=abs(2d0*dot(pinit(1),p5(1,i4)))
      !   s14=2d0*dot(p5(1,i1),p5(1,i4))
      !   s24=2d0*dot(p5(1,i2),p5(1,i4))
      !   s13=2d0*dot(p5(1,i1),pinit(1))
      !   s23=2d0*dot(p5(1,i2),pinit(1))
      ! elseif(i12set.eq.5.and.i34set.eq.6)then
      !    s12=2d0*dot(p5(1,i1),p5(1,i2))
      !    s34=abs(2d0*dot(pinit(1),p6(1,i4)))
      !    s14=2d0*dot(p5(1,i1),p6(1,i4))
      !    s24=2d0*dot(p5(1,i2),p6(1,i4))
      !    s13=2d0*dot(p5(1,i1),pinit(1))
      !    s23=2d0*dot(p5(1,i2),pinit(1))
      ! elseif(i12set.eq.6.and.i34set.eq.6)then
      !    s12=2d0*dot(p6(1,i1),p6(1,i2))
      !    s34=abs(2d0*dot(pinit(1),p6(1,i4)))
      !    s14=2d0*dot(p6(1,i1),p6(1,i4))
      !    s24=2d0*dot(p6(1,i2),p6(1,i4))
      !    s13=2d0*dot(p6(1,i1),pinit(1))
      !    s23=2d0*dot(p6(1,i2),pinit(1))
      ! elseif(i12set.eq.6.and.i34set.eq.7)then
      !    s12=2d0*dot(p6(1,i1),p6(1,i2))
      !    s34=abs(2d0*dot(pinit(1),p7(1,i4)))
      !    s14=2d0*dot(p6(1,i1),p7(1,i4))
      !    s24=2d0*dot(p6(1,i2),p7(1,i4))
      !    s13=2d0*dot(p6(1,i1),pinit(1))
      !    s23=2d0*dot(p6(1,i2),pinit(1))
      ! elseif(i12set.eq.7.and.i34set.eq.7)then
      !    s12=2d0*dot(p7(1,i1),p7(1,i2))
      !    s34=abs(2d0*dot(pinit(1),p7(1,i4)))
      !    s14=2d0*dot(p7(1,i1),p7(1,i4))
      !    s24=2d0*dot(p7(1,i2),p7(1,i4))
      !    s13=2d0*dot(p7(1,i1),pinit(1))
      !    s23=2d0*dot(p7(1,i2),pinit(1))
      ! endif

      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      d1=s14+(1d0-x2)*s13/x2
      d2=s24+(1d0-x2)*s23/x2

      dls=log(renscale/abs(s34))
      e2=0d0
      e1=0d0
      e0=0d0

cupdateTG: the value of y can never be negative (sign convention)
cupdateTG: y is basically a ratio of particle energies, weighted by integrals over positive definite functions

      if( (i1.eq.i4.or.i2.eq.i4) .and. i12set.eq.i34set )then
       if (i1.eq.i4) then
         yy=s12/d2
       else ! i2.eq.i4
         yy=s12/d1
       end if
        yy1=1d0
      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 2
      e1 = -2d0 * (rH1(0, yy1)) + 0.2D1 * d0x2
      e0 = rH1(0, yy1) ** 2 - pi ** 2 / 0.6D1 - 0.2D1 * d1x2 - 0.2D1 *
     # rH1(0, yy1) * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.2D1 / omz1 / omz2
      e1 = -0.2D1 / omz1 / omz2 * rH1(0, yy1) + 0.2D1 * d0x2 / omz1 +
     #0.2D1 * rH1(1, z2) / omz1 / omz2
      e0 = -0.2D1 / omz1 * rH1(0, yy1) * d0x2 - 0.2D1 * d1x2 / omz1 +
     #0.1D1 / omz1 / omz2 * rH1(0, yy1) ** 2 + 0.2D1 / omz1 / omz2 * rH2
     #(1, 1, z2) - pi ** 2 / omz1 / omz2 / 0.6D1 - 0.2D1 * rH1(1, z2) /
     #omz1 / omz2 * rH1(0, yy1)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.2D1 * d0x2 + 0.2D1
      e0 = 0.2D1 * rH1(0, yy1) * d0x2 - 0.2D1 * rH1(0, x2) * x2 / omx2
     # - 0.2D1 / omx2 * rH1(0, yy1) + 2d0 * (rH1(1, x2)) + 0.2D1 * d1x
     #2 + 0.2D1 * rH1(0, yy) * x2 / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.2D1 * d0x2 / omz1 + 0.2D1 / omz1
      e0 = 0.2D1 / omz1 * rH1(0, yy1) * d0x2 - 0.2D1 * x2 / omx2 / omz
     #1 * rH1(0, x2) - 0.2D1 / omx2 / omz1 * rH1(0, yy1) + 0.2D1 * rH1(1
     #, x2) / omz1 + 0.2D1 * d1x2 / omz1 + 0.2D1 * x2 / omx2 / omz1 * rH
     #1(0, yy)
      endif
      else
        yy=s12*s34/d1/d2
        yy1=s12*s34/s14/s24
      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = -rH1(0, yy1) + 0.2D1 * d0x2
      e0 = rH1(0, yy1) ** 2 / 0.2D1 - pi ** 2 / 0.12D2 - 0.4D1 * d1x2
     #- 0.2D1 * rH1(0, yy1) * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = -0.1D1 / omz1 / omz2 * rH1(0, yy1) + 0.2D1 * d0x2 / omz1 +
     #0.2D1 * rH1(1, z2) / omz1 / omz2
      e0 = -0.2D1 / omz1 * rH1(0, yy1) * d0x2 - 0.4D1 * d1x2 / omz1 +
     #0.1D1 / omz1 / omz2 * rH1(0, yy1) ** 2 / 0.2D1 + 0.4D1 / omz1 / om
     #z2 * rH2(1, 1, z2) - pi ** 2 / omz1 / omz2 / 0.12D2 - 0.2D1 * rH1(
     #1, z2) / omz1 / omz2 * rH1(0, yy1)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.2D1 * d0x2 + 0.2D1
      e0 = 0.2D1 * rH1(0, yy1) * d0x2 - 0.4D1 * rH1(0, x2) * x2 / omx2
     # - 0.2D1 / omx2 * rH1(0, yy1) + 4d0 * (rH1(1, x2)) + 0.4D1 * d1x
     #2 + 0.2D1 * rH1(0, yy) * x2 / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.2D1 * d0x2 / omz1 + 0.2D1 / omz1
      e0 = 0.2D1 / omz1 * rH1(0, yy1) * d0x2 - 0.4D1 * x2 / omx2 / omz
     #1 * rH1(0, x2) - 0.2D1 / omx2 / omz1 * rH1(0, yy1) + 0.4D1 * rH1(1
     #, x2) / omz1 + 0.4D1 * d1x2 / omz1 + 0.2D1 * x2 / omx2 / omz1 * rH
     #1(0, yy)
      endif
      endif

      if(ieorder.eq.-2)then
        SSintFI=e2
      elseif(ieorder.eq.-1)then
        SSintFI=e1+dls*e2
      elseif(ieorder.eq.0)then
        SSintFI=e0+dls*e1+1d0/2d0*dls**2*e2
      endif


      return
      end


