************************************************************************
*
      function rJ21QQFF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.2D1 + dls
      e0 = 0.3D1 / 0.2D1 * dls + dls ** 2 / 0.2D1 + 0.19D2 / 0.4D1 - 0
     #.7D1 / 0.12D2 * pi ** 2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.3D1 / 0.2D1 / omz1 / omz2
      e0 = 0.1D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.3D1 / 0.2D1 / om
     #z1 / omz2 * dls + 0.19D2 / 0.4D1 / omz1 / omz2 - 0.7D1 / 0.12D2 * 
     #pi ** 2 / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21QQFF=e2
      elseif(ieorder.eq.-1)then
        rJ21QQFF=e1
      elseif(ieorder.eq.0)then
        rJ21QQFF=e0
      endif

*      write(*,*)" rJ21QQFF ",rJ21QQFF

      return
      end
************************************************************************
*
      function rJ21hQQFF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2


      if(ieorder.eq.-2)then
        rJ21hQQFF=e2
      elseif(ieorder.eq.-1)then
        rJ21hQQFF=e1
      elseif(ieorder.eq.0)then
        rJ21hQQFF=e0
      endif

*      write(*,*)" rJ21hQQFF ",rJ21hQQFF

      return
      end
************************************************************************
*
      function rJ21QGFF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.5D1 / 0.3D1 + dls
      e0 = 0.5D1 / 0.3D1 * dls + dls ** 2 / 0.2D1 + 0.17D2 / 0.3D1 - 0
     #.7D1 / 0.12D2 * pi ** 2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.5D1 / 0.3D1 / omz1 / omz2
      e0 = 0.1D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.5D1 / 0.3D1 / om
     #z1 / omz2 * dls + 0.17D2 / 0.3D1 / omz1 / omz2 - 0.7D1 / 0.12D2 * 
     #pi ** 2 / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21QGFF=e2
      elseif(ieorder.eq.-1)then
        rJ21QGFF=e1
      elseif(ieorder.eq.0)then
        rJ21QGFF=e0
      endif

*      write(*,*)" rJ21QGFF ",rJ21QGFF

      return
      end
************************************************************************
*
      function rJ21GQFF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.5D1 / 0.3D1 + dls
      e0 = 0.5D1 / 0.3D1 * dls + dls ** 2 / 0.2D1 + 0.17D2 / 0.3D1 - 0
     #.7D1 / 0.12D2 * pi ** 2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.5D1 / 0.3D1 / omz1 / omz2
      e0 = 0.1D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.5D1 / 0.3D1 / om
     #z1 / omz2 * dls + 0.17D2 / 0.3D1 / omz1 / omz2 - 0.7D1 / 0.12D2 * 
     #pi ** 2 / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21GQFF=e2
      elseif(ieorder.eq.-1)then
        rJ21GQFF=e1
      elseif(ieorder.eq.0)then
        rJ21GQFF=e0
      endif

*      write(*,*)" rJ21GQFF ",rJ21GQFF

      return
      end
************************************************************************
*
      function rJ21hQGFF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.6D1
      e0 = -dls / 0.6D1 - 0.1D1 / 0.2D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 * dls / 0.6D1 - 0.1D1 / omz1 / omz2 / 
     #0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21hQGFF=e2
      elseif(ieorder.eq.-1)then
        rJ21hQGFF=e1
      elseif(ieorder.eq.0)then
        rJ21hQGFF=e0
      endif

*      write(*,*)" rJ21hQGFF ",rJ21hQGFF

      return
      end
************************************************************************
*
      function rJ21hGQFF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.6D1
      e0 = -dls / 0.6D1 - 0.1D1 / 0.2D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 * dls / 0.6D1 - 0.1D1 / omz1 / omz2 / 
     #0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGQFF=e2
      elseif(ieorder.eq.-1)then
        rJ21hGQFF=e1
      elseif(ieorder.eq.0)then
        rJ21hGQFF=e0
      endif

*      write(*,*)" rJ21hGQFF ",rJ21hGQFF

      return
      end
************************************************************************
*
      function rJ21GGFF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.11D2 / 0.6D1 + dls
      e0 = 0.11D2 / 0.6D1 * dls + dls ** 2 / 0.2D1 + 0.73D2 / 0.12D2 -
     # 0.7D1 / 0.12D2 * pi ** 2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.11D2 / 0.6D1 / omz1 / omz2
      e0 = 0.1D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.11D2 / 0.6D1 / o
     #mz1 / omz2 * dls + 0.73D2 / 0.12D2 / omz1 / omz2 - 0.7D1 / 0.12D2 
     #* pi ** 2 / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21GGFF=e2
      elseif(ieorder.eq.-1)then
        rJ21GGFF=e1
      elseif(ieorder.eq.0)then
        rJ21GGFF=e0
      endif

*      write(*,*)" rJ21GGFF ",rJ21GGFF

      return
      end
************************************************************************
*
      function rJ21hGGFF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -dls / 0.3D1 - 0.7D1 / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -0.1D1 / omz1 / omz2 * dls / 0.3D1 - 0.7D1 / 0.6D1 / omz1 /
     # omz2
      endif

      if(ieorder.eq.-2)then
        rJ21hGGFF=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGFF=e1
      elseif(ieorder.eq.0)then
        rJ21hGGFF=e0
      endif

*      write(*,*)" rJ21hGGFF ",rJ21hGGFF

      return
      end
