************************************************************************
*
      function rJ21QQFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QQFI=rJ21QQIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.2D1 + dls
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.3D1 / 0.4D1 * dlm + 0.3
     #D1 / 0.4D1 * dls + dls ** 2 / 0.2D1 + 0.3D1 / 0.4D1 * d0x2 + d0x2 
     #* dls - d0x2 * dlm - d1x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.3D1 / 0.2D1 / omz1 / omz2
      e0 = -0.1D1 / omz1 * d0x2 * dlm + 0.1D1 / omz1 * d0x2 * dls + 0.
     #3D1 / 0.4D1 / omz1 * d0x2 - 0.1D1 / omz1 * d1x2 + 0.3D1 / 0.4D1 / 
     #omz1 / omz2 * dlm - 0.1D1 / omz1 / omz2 * rH1(1, z2) * dlm + 0.1D1
     # / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.3D1 / 0.4D1 / omz1 / omz2 * 
     #dls + 0.1D1 / omz1 / omz2 * rH1(1, z2) * dls + 0.7D1 / 0.4D1 / omz
     #1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.3D1 / 0.4D1 / omz1 / 
     #omz2 * rH1(1, z2) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.3D1 / 0.4D1 * d0x2 - d0x2 * dls + d0x2 * dlm + d1x2 + dl
     #m * (-0.1D1 / 0.2D1 - x2 / 0.2D1) + dls * (0.1D1 / 0.2D1 + x2 / 0.
     #2D1) + 0.3D1 / 0.2D1 - x2 / 0.2D1 + (0.1D1 / 0.2D1 + x2 / 0.2D1) *
     # rH1(0, x2) + rH1(1, x2) * (0.1D1 / 0.2D1 + x2 / 0.2D1) - rH1(0, x
     #2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 * d0x2 * dlm - 0.1D1 / omz1 * d0x2 * dls - 0.3
     #D1 / 0.4D1 / omz1 * d0x2 + 0.1D1 / omz1 * d1x2 + (-0.1D1 / 0.2D1 -
     # x2 / 0.2D1) / omz1 * dlm + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * 
     #dls + (0.3D1 / 0.2D1 - x2 / 0.2D1) / omz1 + (0.1D1 / 0.2D1 + x2 / 
     #0.2D1) / omz1 * rH1(0, x2) + (0.1D1 / 0.2D1 + x2 / 0.2D1) * rH1(1,
     # x2) / omz1 - 0.1D1 / omz1 * rH1(0, x2) / omx2
      endif

      if(ieorder.eq.-2)then
        rJ21QQFI=e2
      elseif(ieorder.eq.-1)then
        rJ21QQFI=e1
      elseif(ieorder.eq.0)then
        rJ21QQFI=e0
      endif

*      write(*,*)" rJ21QQFI ",rJ21QQFI

      return
      end
************************************************************************
*
      function rJ21hQQFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21hQQFI=rJ21hQQIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2


      if(ieorder.eq.-2)then
        rJ21hQQFI=e2
      elseif(ieorder.eq.-1)then
        rJ21hQQFI=e1
      elseif(ieorder.eq.0)then
        rJ21hQQFI=e0
      endif

*      write(*,*)" rJ21hQQFI ",rJ21hQQFI

      return
      end
************************************************************************
*
      function rJ21GQFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GQFI=rJ21QGIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.5D1 / 0.3D1 + dls
      e0 = 0.3D1 / 0.4D1 * dlm + 0.11D2 / 0.12D2 * dls + dls ** 2 / 0.
     #2D1 + 0.67D2 / 0.36D2 - pi ** 2 / 0.4D1 + 0.11D2 / 0.12D2 * d0x2 -
     # d0x2 * dlm + d0x2 * dls - d1x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.5D1 / 0.3D1 / omz1 / omz2
      e0 = -0.1D1 / omz1 * d0x2 * dlm + 0.1D1 / omz1 * d0x2 * dls + 0.
     #11D2 / 0.12D2 / omz1 * d0x2 - 0.1D1 / omz1 * d1x2 + 0.3D1 / 0.4D1 
     #/ omz1 / omz2 * dlm - 0.1D1 / omz1 / omz2 * rH1(1, z2) * dlm + 0.1
     #D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.11D2 / 0.12D2 / omz1 / omz
     #2 * dls + 0.1D1 / omz1 / omz2 * rH1(1, z2) * dls + 0.67D2 / 0.36D2
     # / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.11D2 / 0.12D2 /
     # omz1 / omz2 * rH1(1, z2) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.11D2 / 0.12D2 * d0x2 + d0x2 * dlm - d0x2 * dls + d1x2 + 
     #dlm * (-0.1D1 / 0.2D1 - x2 / 0.2D1) + dls * (0.1D1 / 0.2D1 + x2 / 
     #0.2D1) - (0.3D1 * x2 ** 2 - 0.3D1 * x2 + 0.1D1) / x2 / 0.6D1 + (0.
     #1D1 / 0.2D1 + x2 / 0.2D1) * rH1(0, x2) + rH1(1, x2) * (0.1D1 / 0.2
     #D1 + x2 / 0.2D1) - rH1(0, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 * d0x2 * dlm - 0.1D1 / omz1 * d0x2 * dls - 0.1
     #1D2 / 0.12D2 / omz1 * d0x2 + 0.1D1 / omz1 * d1x2 + (-0.1D1 / 0.2D1
     # - x2 / 0.2D1) / omz1 * dlm + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 
     #* dls - (0.3D1 * x2 ** 2 - 0.3D1 * x2 + 0.1D1) / x2 / omz1 / 0.6D1
     # + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * rH1(0, x2) + (0.1D1 / 0.2
     #D1 + x2 / 0.2D1) * rH1(1, x2) / omz1 - 0.1D1 / omz1 * rH1(0, x2) /
     # omx2
      endif

      if(ieorder.eq.-2)then
        rJ21GQFI=e2
      elseif(ieorder.eq.-1)then
        rJ21GQFI=e1
      elseif(ieorder.eq.0)then
        rJ21GQFI=e0
      endif

*      write(*,*)" rJ21GQFI ",rJ21GQFI

      return
      end
************************************************************************
*
      function rJ21hGQFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21hGQFI=rJ21hQGIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.6D1
      e0 = -0.5D1 / 0.18D2 - dls / 0.6D1 - d0x2 / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.6D1
      e0 = -0.1D1 / omz1 * d0x2 / 0.6D1 - 0.1D1 / omz1 / omz2 * dls / 
     #0.6D1 - 0.1D1 / omz1 / omz2 * rH1(1, z2) / 0.6D1 - 0.5D1 / 0.18D2 
     #/ omz1 / omz2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / x2 / 0.12D2 + d0x2 / 0.6D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / x2 / omz1 / 0.12D2 + 0.1D1 / omz1 * d0x2 / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGQFI=e2
      elseif(ieorder.eq.-1)then
        rJ21hGQFI=e1
      elseif(ieorder.eq.0)then
        rJ21hGQFI=e0
      endif

*      write(*,*)" rJ21hGQFI ",rJ21hGQFI

      return
      end
************************************************************************
*
      function rJ21QGFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QGFI=rJ21GQIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.5D1 / 0.3D1 + dls
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.11D2 / 0.12D2 * dlm + 0
     #.3D1 / 0.4D1 * dls + dls ** 2 / 0.2D1 + 0.3D1 / 0.4D1 * d0x2 + d0x
     #2 * dls - d0x2 * dlm - d1x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.5D1 / 0.3D1 / omz1 / omz2
      e0 = -0.1D1 / omz1 * d0x2 * dlm + 0.1D1 / omz1 * d0x2 * dls + 0.
     #3D1 / 0.4D1 / omz1 * d0x2 - 0.1D1 / omz1 * d1x2 + 0.11D2 / 0.12D2 
     #/ omz1 / omz2 * dlm - 0.1D1 / omz1 / omz2 * rH1(1, z2) * dlm + 0.1
     #D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.3D1 / 0.4D1 / omz1 / omz2 
     #* dls + 0.1D1 / omz1 / omz2 * rH1(1, z2) * dls + 0.7D1 / 0.4D1 / o
     #mz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.3D1 / 0.4D1 / omz1 
     #/ omz2 * rH1(1, z2) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.3D1 / 0.4D1 * d0x2 - d0x2 * dls + d0x2 * dlm + d1x2 - (x
     #2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * dlm + (x2 ** 3 - x2 
     #** 2 + 0.2D1 * x2 - 0.1D1) / x2 * dls + (x2 ** 3 - x2 ** 2 + 0.2D1
     # * x2 - 0.1D1) / x2 * rH1(0, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2
     # - 0.1D1) / x2 * rH1(1, x2) - 0.3D1 / 0.2D1 - rH1(0, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 * d0x2 * dlm - 0.1D1 / omz1 * d0x2 * dls - 0.3
     #D1 / 0.4D1 / omz1 * d0x2 + 0.1D1 / omz1 * d1x2 - (x2 ** 3 - x2 ** 
     #2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * dlm + (x2 ** 3 - x2 ** 2 + 0
     #.2D1 * x2 - 0.1D1) / x2 / omz1 * dls + (x2 ** 3 - x2 ** 2 + 0.2D1 
     #* x2 - 0.1D1) / x2 / omz1 * rH1(0, x2) + (x2 ** 3 - x2 ** 2 + 0.2D
     #1 * x2 - 0.1D1) / x2 / omz1 * rH1(1, x2) - 0.3D1 / 0.2D1 / omz1 - 
     #0.1D1 / omz1 * rH1(0, x2) / omx2
      endif

      if(ieorder.eq.-2)then
        rJ21QGFI=e2
      elseif(ieorder.eq.-1)then
        rJ21QGFI=e1
      elseif(ieorder.eq.0)then
        rJ21QGFI=e0
      endif

*      write(*,*)" rJ21QGFI ",rJ21QGFI

      return
      end
************************************************************************
*
      function rJ21hQGFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21hQGFI=rJ21hGQIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.6D1
      e0 = -dlm / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 * dlm / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hQGFI=e2
      elseif(ieorder.eq.-1)then
        rJ21hQGFI=e1
      elseif(ieorder.eq.0)then
        rJ21hQGFI=e0
      endif

*      write(*,*)" rJ21hQGFI ",rJ21hQGFI

      return
      end
************************************************************************
*
      function rJ21GGFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GGFI=rJ21GGIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.11D2 / 0.6D1 + dls
      e0 = 0.11D2 / 0.12D2 * dlm + 0.11D2 / 0.12D2 * dls + dls ** 2 / 
     #0.2D1 + 0.67D2 / 0.36D2 - pi ** 2 / 0.4D1 + 0.11D2 / 0.12D2 * d0x2
     # - d0x2 * dlm + d0x2 * dls - d1x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.11D2 / 0.6D1 / omz1 / omz2
      e0 = -0.1D1 / omz1 * d0x2 * dlm + 0.1D1 / omz1 * d0x2 * dls + 0.
     #11D2 / 0.12D2 / omz1 * d0x2 - 0.1D1 / omz1 * d1x2 + 0.11D2 / 0.12D
     #2 / omz1 / omz2 * dlm - 0.1D1 / omz1 / omz2 * rH1(1, z2) * dlm + 0
     #.1D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.11D2 / 0.12D2 / omz1 / o
     #mz2 * dls + 0.1D1 / omz1 / omz2 * rH1(1, z2) * dls + 0.67D2 / 0.36
     #D2 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.11D2 / 0.12D2
     # / omz1 / omz2 * rH1(1, z2) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.11D2 / 0.12D2 * d0x2 + d0x2 * dlm - d0x2 * dls + d1x2 - 
     #(x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * dlm + (x2 ** 3 - x
     #2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * dls + (x2 ** 3 - x2 ** 2 + 0.2
     #D1 * x2 - 0.1D1) / x2 * rH1(0, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * 
     #x2 - 0.1D1) / x2 * rH1(1, x2) - 0.11D2 / 0.12D2 / x2 - rH1(0, x2) 
     #/ omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 * d0x2 * dlm - 0.1D1 / omz1 * d0x2 * dls - 0.1
     #1D2 / 0.12D2 / omz1 * d0x2 + 0.1D1 / omz1 * d1x2 - (x2 ** 3 - x2 *
     #* 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * dlm + (x2 ** 3 - x2 ** 2 +
     # 0.2D1 * x2 - 0.1D1) / x2 / omz1 * dls + (x2 ** 3 - x2 ** 2 + 0.2D
     #1 * x2 - 0.1D1) / x2 / omz1 * rH1(0, x2) + (x2 ** 3 - x2 ** 2 + 0.
     #2D1 * x2 - 0.1D1) / x2 / omz1 * rH1(1, x2) - 0.11D2 / 0.12D2 / x2 
     #/ omz1 - 0.1D1 / omz1 * rH1(0, x2) / omx2
      endif

      if(ieorder.eq.-2)then
        rJ21GGFI=e2
      elseif(ieorder.eq.-1)then
        rJ21GGFI=e1
      elseif(ieorder.eq.0)then
        rJ21GGFI=e0
      endif

*      write(*,*)" rJ21GGFI ",rJ21GGFI

      return
      end
************************************************************************
*
      function rJ21hGGFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21hGGFI=rJ21hGGIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -0.5D1 / 0.18D2 - dlm / 0.6D1 - dls / 0.6D1 - d0x2 / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -0.1D1 / omz1 * d0x2 / 0.6D1 - 0.1D1 / omz1 / omz2 * dlm / 
     #0.6D1 - 0.1D1 / omz1 / omz2 * dls / 0.6D1 - 0.1D1 / omz1 / omz2 * 
     #rH1(1, z2) / 0.6D1 - 0.5D1 / 0.18D2 / omz1 / omz2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / x2 / 0.6D1 + d0x2 / 0.6D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / x2 / omz1 / 0.6D1 + 0.1D1 / omz1 * d0x2 / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGFI=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGFI=e1
      elseif(ieorder.eq.0)then
        rJ21hGGFI=e0
      endif

*      write(*,*)" rJ21hGGFI ",rJ21hGGFI

      return
      end
************************************************************************
*
      function rJ21QQgtoqFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QQgtoqFI=rJ21QQgtoqIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = dlm * (0.1D1 / 0.2D1 - x2 + x2 ** 2) + dls * (-0.1D1 / 0.2D
     #1 + x2 - x2 ** 2) + rH1(0, x2) * (-0.1D1 / 0.2D1 + x2 - x2 ** 2) +
     # rH1(1, x2) * (-0.1D1 / 0.2D1 + x2 - x2 ** 2) - x2 ** 2 + x2 - 0.1
     #D1 / 0.2D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) / omz1 * dlm + dls * (-0.1D1
     # / 0.2D1 + x2 - x2 ** 2) / omz1 + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) 
     #/ omz1 + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) / omz1 * rH1(0, x2) + (-0
     #.1D1 / 0.2D1 + x2 - x2 ** 2) * rH1(1, x2) / omz1
      endif

      if(ieorder.eq.-2)then
        rJ21QQgtoqFI=e2
      elseif(ieorder.eq.-1)then
        rJ21QQgtoqFI=e1
      elseif(ieorder.eq.0)then
        rJ21QQgtoqFI=e0
      endif

*      write(*,*)" rJ21QQgtoqFI ",rJ21QQgtoqFI

      return
      end
************************************************************************
*
      function rJ21GQgtoqFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GQgtoqFI=rJ21QGgtoqIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = dlm * (0.1D1 / 0.2D1 - x2 + x2 ** 2) + dls * (-0.1D1 / 0.2D
     #1 + x2 - x2 ** 2) - (0.4D1 * x2 ** 3 - 0.4D1 * x2 ** 2 + 0.6D1 * x
     #2 - 0.3D1) / x2 / 0.4D1 + rH1(0, x2) * (-0.1D1 / 0.2D1 + x2 - x2 *
     #* 2) + rH1(1, x2) * (-0.1D1 / 0.2D1 + x2 - x2 ** 2)
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) / omz1 * dlm + dls * (-0.1D1
     # / 0.2D1 + x2 - x2 ** 2) / omz1 - (0.4D1 * x2 ** 3 - 0.4D1 * x2 **
     # 2 + 0.6D1 * x2 - 0.3D1) / x2 / omz1 / 0.4D1 + (-0.1D1 / 0.2D1 + x
     #2 - x2 ** 2) / omz1 * rH1(0, x2) + (-0.1D1 / 0.2D1 + x2 - x2 ** 2)
     # * rH1(1, x2) / omz1
      endif

      if(ieorder.eq.-2)then
        rJ21GQgtoqFI=e2
      elseif(ieorder.eq.-1)then
        rJ21GQgtoqFI=e1
      elseif(ieorder.eq.0)then
        rJ21GQgtoqFI=e0
      endif

*      write(*,*)" rJ21GQgtoqFI ",rJ21GQgtoqFI

      return
      end
************************************************************************
*
      function rJ21QGqtogFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QGqtogFI=rJ21GQqtogIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * dlm / 0.2D1 - (x2 ** 
     #2 - 0.2D1 * x2 + 0.2D1) / x2 * dls / 0.2D1 + (x2 + 0.2D1) * (x2 - 
     #0.1D1) / x2 / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(0,
     # x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(1, x2) / 
     #0.2D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * dlm / 0.2D1 - 
     #(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * dls / 0.2D1 + (x2 + 0
     #.2D1) * (x2 - 0.1D1) / x2 / omz1 / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 +
     # 0.2D1) / x2 / omz1 * rH1(0, x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 +
     # 0.2D1) / x2 / omz1 * rH1(1, x2) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21QGqtogFI=e2
      elseif(ieorder.eq.-1)then
        rJ21QGqtogFI=e1
      elseif(ieorder.eq.0)then
        rJ21QGqtogFI=e0
      endif

*      write(*,*)" rJ21QGqtogFI ",rJ21QGqtogFI

      return
      end
************************************************************************
*
      function rJ21GGqtogFI(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GGqtogFI=rJ21GGqtogIF(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * dlm / 0.2D1 - (x2 ** 
     #2 - 0.2D1 * x2 + 0.2D1) / x2 * dls / 0.2D1 - (x2 ** 2 - 0.2D1 * x2
     # + 0.2D1) / x2 * rH1(0, x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D
     #1) / x2 * rH1(1, x2) / 0.2D1 + (0.2D1 * x2 ** 2 - 0.3D1) / x2 / 0.
     #4D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * dlm / 0.2D1 - 
     #(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * dls / 0.2D1 - (x2 ** 
     #2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * rH1(0, x2) / 0.2D1 - (x2 ** 
     #2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * rH1(1, x2) / 0.2D1 + (0.2D1 
     #* x2 ** 2 - 0.3D1) / x2 / omz1 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        rJ21GGqtogFI=e2
      elseif(ieorder.eq.-1)then
        rJ21GGqtogFI=e1
      elseif(ieorder.eq.0)then
        rJ21GGqtogFI=e0
      endif

*      write(*,*)" rJ21GGqtogFI ",rJ21GGqtogFI

      return
      end
