************************************************************************
*
      function rJ21QQIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QQIF=rJ21QQFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.2D1 + dls
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.3D1 / 0.4D1 * dlm + 0.3
     #D1 / 0.4D1 * dls + dls ** 2 / 0.2D1 + 0.3D1 / 0.4D1 * d0x1 + d0x1 
     #* dls - d0x1 * dlm - d1x1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.3D1 / 0.2D1 / omz1 / omz2
      e0 = -0.1D1 / omz2 * d0x1 * dlm + 0.1D1 / omz2 * d0x1 * dls + 0.
     #3D1 / 0.4D1 * d0x1 / omz2 - d1x1 / omz2 - 0.1D1 / omz1 / omz2 * rH
     #1(1, z1) * dlm + 0.3D1 / 0.4D1 / omz1 / omz2 * dlm + 0.1D1 / omz1 
     #/ omz2 * dls ** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(1, z1) * dls
     # + 0.3D1 / 0.4D1 / omz1 / omz2 * dls + 0.7D1 / 0.4D1 / omz1 / omz2
     # - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.3D1 / 0.4D1 / omz1 / omz2 * r
     #H1(1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z1)
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.3D1 / 0.4D1 * d0x1 - d0x1 * dls + d0x1 * dlm + d1x1 + dl
     #m * (-0.1D1 / 0.2D1 - x1 / 0.2D1) + dls * (0.1D1 / 0.2D1 + x1 / 0.
     #2D1) + 0.3D1 / 0.2D1 - x1 / 0.2D1 + (0.1D1 / 0.2D1 + x1 / 0.2D1) *
     # rH1(0, x1) + (0.1D1 / 0.2D1 + x1 / 0.2D1) * rH1(1, x1) - rH1(0, x
     #1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz2 * d0x1 * dlm - 0.1D1 / omz2 * d0x1 * dls - 0.3
     #D1 / 0.4D1 * d0x1 / omz2 + d1x1 / omz2 + (-0.1D1 / 0.2D1 - x1 / 0.
     #2D1) / omz2 * dlm + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * dls + (0
     #.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * rH1(0, x1) + (0.1D1 / 0.2D1 + 
     #x1 / 0.2D1) * rH1(1, x1) / omz2 + (0.3D1 / 0.2D1 - x1 / 0.2D1) / o
     #mz2 - 0.1D1 / omz2 * rH1(0, x1) / omx1
      endif

      if(ieorder.eq.-2)then
        rJ21QQIF=e2
      elseif(ieorder.eq.-1)then
        rJ21QQIF=e1
      elseif(ieorder.eq.0)then
        rJ21QQIF=e0
      endif

*      write(*,*)" rJ21QQIF ",rJ21QQIF

      return
      end
************************************************************************
*
      function rJ21hQQIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21hQQIF=rJ21hQQFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2


      if(ieorder.eq.-2)then
        rJ21hQQIF=e2
      elseif(ieorder.eq.-1)then
        rJ21hQQIF=e1
      elseif(ieorder.eq.0)then
        rJ21hQQIF=e0
      endif

*      write(*,*)" rJ21hQQIF ",rJ21hQQIF

      return
      end
************************************************************************
*
      function rJ21QGIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QGIF=rJ21GQFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.5D1 / 0.3D1 + dls
      e0 = 0.3D1 / 0.4D1 * dlm + 0.67D2 / 0.36D2 - pi ** 2 / 0.4D1 + 0
     #.11D2 / 0.12D2 * dls + dls ** 2 / 0.2D1 + 0.11D2 / 0.12D2 * d0x1 -
     # d0x1 * dlm + d0x1 * dls - d1x1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.5D1 / 0.3D1 / omz1 / omz2
      e0 = -0.1D1 / omz2 * d0x1 * dlm + 0.1D1 / omz2 * d0x1 * dls + 0.
     #11D2 / 0.12D2 * d0x1 / omz2 - d1x1 / omz2 - 0.1D1 / omz1 / omz2 * 
     #rH1(1, z1) * dlm + 0.3D1 / 0.4D1 / omz1 / omz2 * dlm + 0.1D1 / omz
     #1 / omz2 * dls ** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(1, z1) * d
     #ls + 0.11D2 / 0.12D2 / omz1 / omz2 * dls + 0.67D2 / 0.36D2 / omz1 
     #/ omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.11D2 / 0.12D2 / omz1 / 
     #omz2 * rH1(1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z1)
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.11D2 / 0.12D2 * d0x1 + d0x1 * dlm - d0x1 * dls + d1x1 + 
     #dlm * (-0.1D1 / 0.2D1 - x1 / 0.2D1) + dls * (0.1D1 / 0.2D1 + x1 / 
     #0.2D1) - (0.3D1 * x1 ** 2 - 0.3D1 * x1 + 0.1D1) / x1 / 0.6D1 + (0.
     #1D1 / 0.2D1 + x1 / 0.2D1) * rH1(0, x1) + (0.1D1 / 0.2D1 + x1 / 0.2
     #D1) * rH1(1, x1) - rH1(0, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz2 * d0x1 * dlm - 0.1D1 / omz2 * d0x1 * dls - 0.1
     #1D2 / 0.12D2 * d0x1 / omz2 + d1x1 / omz2 + (-0.1D1 / 0.2D1 - x1 / 
     #0.2D1) / omz2 * dlm + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * dls + 
     #(0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * rH1(0, x1) + (0.1D1 / 0.2D1 
     #+ x1 / 0.2D1) * rH1(1, x1) / omz2 - (0.3D1 * x1 ** 2 - 0.3D1 * x1 
     #+ 0.1D1) / x1 / omz2 / 0.6D1 - 0.1D1 / omz2 * rH1(0, x1) / omx1
      endif

      if(ieorder.eq.-2)then
        rJ21QGIF=e2
      elseif(ieorder.eq.-1)then
        rJ21QGIF=e1
      elseif(ieorder.eq.0)then
        rJ21QGIF=e0
      endif

*      write(*,*)" rJ21QGIF ",rJ21QGIF

      return
      end
************************************************************************
*
      function rJ21hQGIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21hQGIF=rJ21hGQFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.6D1
      e0 = -0.5D1 / 0.18D2 - dls / 0.6D1 - d0x1 / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.6D1
      e0 = -d0x1 / omz2 / 0.6D1 - 0.1D1 / omz1 / omz2 * dls / 0.6D1 - 
     #0.1D1 / omz1 / omz2 * rH1(1, z1) / 0.6D1 - 0.5D1 / 0.18D2 / omz1 /
     # omz2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / x1 / 0.12D2 + d0x1 / 0.6D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / x1 / omz2 / 0.12D2 + d0x1 / omz2 / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hQGIF=e2
      elseif(ieorder.eq.-1)then
        rJ21hQGIF=e1
      elseif(ieorder.eq.0)then
        rJ21hQGIF=e0
      endif

*      write(*,*)" rJ21hQGIF ",rJ21hQGIF

      return
      end
************************************************************************
*
      function rJ21GQIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GQIF=rJ21QGFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.5D1 / 0.3D1 + dls
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.11D2 / 0.12D2 * dlm + 0
     #.3D1 / 0.4D1 * dls + dls ** 2 / 0.2D1 + 0.3D1 / 0.4D1 * d0x1 + d0x
     #1 * dls - d0x1 * dlm - d1x1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.5D1 / 0.3D1 / omz1 / omz2
      e0 = -0.1D1 / omz2 * d0x1 * dlm + 0.1D1 / omz2 * d0x1 * dls + 0.
     #3D1 / 0.4D1 * d0x1 / omz2 - d1x1 / omz2 - 0.1D1 / omz1 / omz2 * rH
     #1(1, z1) * dlm + 0.11D2 / 0.12D2 / omz1 / omz2 * dlm + 0.1D1 / omz
     #1 / omz2 * dls ** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(1, z1) * d
     #ls + 0.3D1 / 0.4D1 / omz1 / omz2 * dls + 0.7D1 / 0.4D1 / omz1 / om
     #z2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.3D1 / 0.4D1 / omz1 / omz2 *
     # rH1(1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z1)
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.3D1 / 0.4D1 * d0x1 - d0x1 * dls + d0x1 * dlm + d1x1 - (x
     #1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * dlm + (x1 ** 3 - x1 
     #** 2 + 0.2D1 * x1 - 0.1D1) / x1 * dls + (x1 ** 3 - x1 ** 2 + 0.2D1
     # * x1 - 0.1D1) / x1 * rH1(0, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1
     # - 0.1D1) / x1 * rH1(1, x1) - 0.3D1 / 0.2D1 - rH1(0, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz2 * d0x1 * dlm - 0.1D1 / omz2 * d0x1 * dls - 0.3
     #D1 / 0.4D1 * d0x1 / omz2 + d1x1 / omz2 - (x1 ** 3 - x1 ** 2 + 0.2D
     #1 * x1 - 0.1D1) / x1 / omz2 * dlm + (x1 ** 3 - x1 ** 2 + 0.2D1 * x
     #1 - 0.1D1) / x1 / omz2 * dls + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0
     #.1D1) / x1 / omz2 * rH1(0, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 -
     # 0.1D1) / x1 / omz2 * rH1(1, x1) - 0.3D1 / 0.2D1 / omz2 - 0.1D1 / 
     #omz2 * rH1(0, x1) / omx1
      endif

      if(ieorder.eq.-2)then
        rJ21GQIF=e2
      elseif(ieorder.eq.-1)then
        rJ21GQIF=e1
      elseif(ieorder.eq.0)then
        rJ21GQIF=e0
      endif

*      write(*,*)" rJ21GQIF ",rJ21GQIF

      return
      end
************************************************************************
*
      function rJ21hGQIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21hGQIF=rJ21hQGFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.6D1
      e0 = -dlm / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 * dlm / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGQIF=e2
      elseif(ieorder.eq.-1)then
        rJ21hGQIF=e1
      elseif(ieorder.eq.0)then
        rJ21hGQIF=e0
      endif

*      write(*,*)" rJ21hGQIF ",rJ21hGQIF

      return
      end
************************************************************************
*
      function rJ21GGIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GGIF=rJ21GGFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.11D2 / 0.6D1 + dls
      e0 = 0.11D2 / 0.12D2 * dlm + 0.67D2 / 0.36D2 - pi ** 2 / 0.4D1 +
     # 0.11D2 / 0.12D2 * dls + dls ** 2 / 0.2D1 + 0.11D2 / 0.12D2 * d0x1
     # - d0x1 * dlm + d0x1 * dls - d1x1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.11D2 / 0.6D1 / omz1 / omz2
      e0 = -0.1D1 / omz2 * d0x1 * dlm + 0.1D1 / omz2 * d0x1 * dls + 0.
     #11D2 / 0.12D2 * d0x1 / omz2 - d1x1 / omz2 - 0.1D1 / omz1 / omz2 * 
     #rH1(1, z1) * dlm + 0.11D2 / 0.12D2 / omz1 / omz2 * dlm + 0.1D1 / o
     #mz1 / omz2 * dls ** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(1, z1) *
     # dls + 0.11D2 / 0.12D2 / omz1 / omz2 * dls + 0.67D2 / 0.36D2 / omz
     #1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.11D2 / 0.12D2 / omz1 
     #/ omz2 * rH1(1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z1)
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.11D2 / 0.12D2 * d0x1 + d0x1 * dlm - d0x1 * dls + d1x1 - 
     #(x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * dlm + (x1 ** 3 - x
     #1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * dls + (x1 ** 3 - x1 ** 2 + 0.2
     #D1 * x1 - 0.1D1) / x1 * rH1(0, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 * 
     #x1 - 0.1D1) / x1 * rH1(1, x1) - 0.11D2 / 0.12D2 / x1 - rH1(0, x1) 
     #/ omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz2 * d0x1 * dlm - 0.1D1 / omz2 * d0x1 * dls - 0.1
     #1D2 / 0.12D2 * d0x1 / omz2 + d1x1 / omz2 - (x1 ** 3 - x1 ** 2 + 0.
     #2D1 * x1 - 0.1D1) / x1 / omz2 * dlm + (x1 ** 3 - x1 ** 2 + 0.2D1 *
     # x1 - 0.1D1) / x1 / omz2 * dls + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 -
     # 0.1D1) / x1 / omz2 * rH1(0, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1
     # - 0.1D1) / x1 / omz2 * rH1(1, x1) - 0.11D2 / 0.12D2 / x1 / omz2 -
     # 0.1D1 / omz2 * rH1(0, x1) / omx1
      endif

      if(ieorder.eq.-2)then
        rJ21GGIF=e2
      elseif(ieorder.eq.-1)then
        rJ21GGIF=e1
      elseif(ieorder.eq.0)then
        rJ21GGIF=e0
      endif

*      write(*,*)" rJ21GGIF ",rJ21GGIF

      return
      end
************************************************************************
*
      function rJ21hGGIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21hGGIF=rJ21hGGFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -0.5D1 / 0.18D2 - dlm / 0.6D1 - dls / 0.6D1 - d0x1 / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -d0x1 / omz2 / 0.6D1 - 0.1D1 / omz1 / omz2 * dlm / 0.6D1 - 
     #0.1D1 / omz1 / omz2 * dls / 0.6D1 - 0.1D1 / omz1 / omz2 * rH1(1, z
     #1) / 0.6D1 - 0.5D1 / 0.18D2 / omz1 / omz2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / x1 / 0.6D1 + d0x1 / 0.6D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / x1 / omz2 / 0.6D1 + d0x1 / omz2 / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGIF=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGIF=e1
      elseif(ieorder.eq.0)then
        rJ21hGGIF=e0
      endif

*      write(*,*)" rJ21hGGIF ",rJ21hGGIF

      return
      end
************************************************************************
*
      function rJ21QQgtoqIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QQgtoqIF=rJ21QQgtoqFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = dlm * (0.1D1 / 0.2D1 - x1 + x1 ** 2) + dls * (-0.1D1 / 0.2D
     #1 + x1 - x1 ** 2) + rH1(0, x1) * (-0.1D1 / 0.2D1 + x1 - x1 ** 2) +
     # rH1(1, x1) * (-0.1D1 / 0.2D1 + x1 - x1 ** 2) - x1 ** 2 + x1 - 0.1
     #D1 / 0.2D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) / omz2 * dlm + dls * (-0.1D1
     # / 0.2D1 + x1 - x1 ** 2) / omz2 + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) 
     #/ omz2 * rH1(0, x1) + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) * rH1(1, x1)
     # / omz2 + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21QQgtoqIF=e2
      elseif(ieorder.eq.-1)then
        rJ21QQgtoqIF=e1
      elseif(ieorder.eq.0)then
        rJ21QQgtoqIF=e0
      endif

*      write(*,*)" rJ21QQgtoqIF ",rJ21QQgtoqIF

      return
      end
************************************************************************
*
      function rJ21QGgtoqIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QGgtoqIF=rJ21GQgtoqFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = dlm * (0.1D1 / 0.2D1 - x1 + x1 ** 2) + dls * (-0.1D1 / 0.2D
     #1 + x1 - x1 ** 2) - (0.4D1 * x1 ** 3 - 0.4D1 * x1 ** 2 + 0.6D1 * x
     #1 - 0.3D1) / x1 / 0.4D1 + rH1(0, x1) * (-0.1D1 / 0.2D1 + x1 - x1 *
     #* 2) + rH1(1, x1) * (-0.1D1 / 0.2D1 + x1 - x1 ** 2)
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) / omz2 * dlm + dls * (-0.1D1
     # / 0.2D1 + x1 - x1 ** 2) / omz2 + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) 
     #/ omz2 * rH1(0, x1) + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) * rH1(1, x1)
     # / omz2 - (0.4D1 * x1 ** 3 - 0.4D1 * x1 ** 2 + 0.6D1 * x1 - 0.3D1)
     # / x1 / omz2 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        rJ21QGgtoqIF=e2
      elseif(ieorder.eq.-1)then
        rJ21QGgtoqIF=e1
      elseif(ieorder.eq.0)then
        rJ21QGgtoqIF=e0
      endif

*      write(*,*)" rJ21QGgtoqIF ",rJ21QGgtoqIF

      return
      end
************************************************************************
*
      function rJ21GQqtogIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GQqtogIF=rJ21QGqtogFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * dlm / 0.2D1 - (x1 ** 
     #2 - 0.2D1 * x1 + 0.2D1) / x1 * dls / 0.2D1 + (x1 + 0.2D1) * (-0.1D
     #1 + x1) / x1 / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * rH1(0
     #, x1) / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * rH1(1, x1) /
     # 0.2D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * dlm / 0.2D1 - 
     #(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * dls / 0.2D1 - (x1 ** 
     #2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * rH1(0, x1) / 0.2D1 - (x1 ** 
     #2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * rH1(1, x1) / 0.2D1 + (x1 + 0
     #.2D1) * (-0.1D1 + x1) / x1 / omz2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GQqtogIF=e2
      elseif(ieorder.eq.-1)then
        rJ21GQqtogIF=e1
      elseif(ieorder.eq.0)then
        rJ21GQqtogIF=e0
      endif

*      write(*,*)" rJ21GQqtogIF ",rJ21GQqtogIF

      return
      end
************************************************************************
*
      function rJ21GGqtogIF(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GGqtogIF=rJ21GGqtogFI(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * dlm / 0.2D1 - (x1 ** 
     #2 - 0.2D1 * x1 + 0.2D1) / x1 * dls / 0.2D1 - (x1 ** 2 - 0.2D1 * x1
     # + 0.2D1) / x1 * rH1(0, x1) / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D
     #1) / x1 * rH1(1, x1) / 0.2D1 + (0.2D1 * x1 ** 2 - 0.3D1) / x1 / 0.
     #4D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * dlm / 0.2D1 - 
     #(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * dls / 0.2D1 - (x1 ** 
     #2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * rH1(0, x1) / 0.2D1 - (x1 ** 
     #2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * rH1(1, x1) / 0.2D1 + (0.2D1 
     #* x1 ** 2 - 0.3D1) / x1 / omz2 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        rJ21GGqtogIF=e2
      elseif(ieorder.eq.-1)then
        rJ21GGqtogIF=e1
      elseif(ieorder.eq.0)then
        rJ21GGqtogIF=e0
      endif

*      write(*,*)" rJ21GGqtogIF ",rJ21GGqtogIF

      return
      end
