************************************************************************
*
      function P0qqFI(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.3D1 / 0.4D1 - d0x2
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 - 0.1D1 / omz2 * rH1(1, z2) + 0.3D1 / 0.4D1 / omz2
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / 0.2D1 - x2 / 0.2D1 + d0x2
      endif

      if(ieorder.eq.-2)then
        P0qqFI=e2
      elseif(ieorder.eq.-1)then
        P0qqFI=e1
      elseif(ieorder.eq.0)then
        P0qqFI=e0
      endif

*      write(*,*)" P0qqFI ",P0qqFI

      return
      end
************************************************************************
*
      function P0qgFI(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / 0.2D1 - x2 + x2 ** 2
      endif

      if(ieorder.eq.-2)then
        P0qgFI=e2
      elseif(ieorder.eq.-1)then
        P0qgFI=e1
      elseif(ieorder.eq.0)then
        P0qgFI=e0
      endif

*      write(*,*)" P0qgFI ",P0qgFI

      return
      end
************************************************************************
*
      function P0gqFI(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        P0gqFI=e2
      elseif(ieorder.eq.-1)then
        P0gqFI=e1
      elseif(ieorder.eq.0)then
        P0gqFI=e0
      endif

*      write(*,*)" P0gqFI ",P0gqFI

      return
      end
************************************************************************
*
      function P0ggFI(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.11D2 / 0.6D1 - 0.2D1 * d0x2
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -0.2D1 * d0x2 - 0.2D1 / omz2 * rH1(1, z2) + 0.11D2 / 0.6D1
     #/ omz2
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = 0.2D1 * d0x2 - 0.2D1 * (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.
     #1D1) / x2
      endif

      if(ieorder.eq.-2)then
        P0ggFI=e2
      elseif(ieorder.eq.-1)then
        P0ggFI=e1
      elseif(ieorder.eq.0)then
        P0ggFI=e0
      endif

*      write(*,*)" P0ggFI ",P0ggFI

      return
      end
************************************************************************
*
      function P0ggFFI(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / 0.3D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / omz2 / 0.3D1
      endif

      if(ieorder.eq.-2)then
        P0ggFFI=e2
      elseif(ieorder.eq.-1)then
        P0ggFFI=e1
      elseif(ieorder.eq.0)then
        P0ggFFI=e0
      endif

*      write(*,*)" P0ggFFI ",P0ggFFI

      return
      end
