************************************************************************
*
      function P0qqIF(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.3D1 / 0.4D1 - d0x1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 - 0.1D1 / omz1 * rH1(1, z1) + 0.3D1 / 0.4D1 / omz1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / 0.2D1 - x1 / 0.2D1 + d0x1
      endif

      if(ieorder.eq.-2)then
        P0qqIF=e2
      elseif(ieorder.eq.-1)then
        P0qqIF=e1
      elseif(ieorder.eq.0)then
        P0qqIF=e0
      endif

*      write(*,*)" P0qqIF ",P0qqIF

      return
      end
************************************************************************
*
      function P0qgIF(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / 0.2D1 - x1 + x1 ** 2
      endif

      if(ieorder.eq.-2)then
        P0qgIF=e2
      elseif(ieorder.eq.-1)then
        P0qgIF=e1
      elseif(ieorder.eq.0)then
        P0qgIF=e0
      endif

*      write(*,*)" P0qgIF ",P0qgIF

      return
      end
************************************************************************
*
      function P0gqIF(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        P0gqIF=e2
      elseif(ieorder.eq.-1)then
        P0gqIF=e1
      elseif(ieorder.eq.0)then
        P0gqIF=e0
      endif

*      write(*,*)" P0gqIF ",P0gqIF

      return
      end
************************************************************************
*
      function P0ggIF(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.11D2 / 0.6D1 - 0.2D1 * d0x1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -0.2D1 * d0x1 - 0.2D1 / omz1 * rH1(1, z1) + 0.11D2 / 0.6D1
     #/ omz1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = 0.2D1 * d0x1 - 0.2D1 * (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.
     #1D1) / x1
      endif

      if(ieorder.eq.-2)then
        P0ggIF=e2
      elseif(ieorder.eq.-1)then
        P0ggIF=e1
      elseif(ieorder.eq.0)then
        P0ggIF=e0
      endif

*      write(*,*)" P0ggIF ",P0ggIF

      return
      end
************************************************************************
*
      function P0ggFIF(ix,x1,x2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / 0.3D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / omz1 / 0.3D1
      endif

      if(ieorder.eq.-2)then
        P0ggFIF=e2
      elseif(ieorder.eq.-1)then
        P0ggFIF=e1
      elseif(ieorder.eq.0)then
        P0ggFIF=e0
      endif

*      write(*,*)" P0ggFIF ",P0ggFIF

      return
      end
