************************************************************************
*
      function A30FFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.2D1
      e0 = 0.19D2 / 0.4D1 - 0.7D1 / 0.12D2 * pi ** 2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.3D1 / 0.2D1 / omz1 / omz2
      e0 = 0.19D2 / 0.4D1 / omz1 / omz2 - 0.7D1 / 0.12D2 * pi ** 2 / o
     #mz1 / omz2
      endif

      if(ieorder.eq.-2)then
        A30FFint=e2
      elseif(ieorder.eq.-1)then
        A30FFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        A30FFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" A30FFint ",A30FFint

      return
      end
************************************************************************
*
      function D30FFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 2
      e1 = 0.10D2 / 0.3D1
      e0 = 0.34D2 / 0.3D1 - 0.7D1 / 0.6D1 * pi ** 2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.2D1 / omz1 / omz2
      e1 = 0.10D2 / 0.3D1 / omz1 / omz2
      e0 = 0.34D2 / 0.3D1 / omz1 / omz2 - 0.7D1 / 0.6D1 * pi ** 2 / om
     #z1 / omz2
      endif

      if(ieorder.eq.-2)then
        D30FFint=e2
      elseif(ieorder.eq.-1)then
        D30FFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        D30FFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" D30FFint ",D30FFint

      return
      end
************************************************************************
*
      function E30FFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -0.1D1 / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        E30FFint=e2
      elseif(ieorder.eq.-1)then
        E30FFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        E30FFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" E30FFint ",E30FFint

      return
      end
************************************************************************
*
      function F30FFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 3
      e1 = 0.11D2 / 0.2D1
      e0 = 0.73D2 / 0.4D1 - 0.7D1 / 0.4D1 * pi ** 2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.3D1 / omz1 / omz2
      e1 = 0.11D2 / 0.2D1 / omz1 / omz2
      e0 = 0.73D2 / 0.4D1 / omz1 / omz2 - 0.7D1 / 0.4D1 * pi ** 2 / om
     #z1 / omz2
      endif

      if(ieorder.eq.-2)then
        F30FFint=e2
      elseif(ieorder.eq.-1)then
        F30FFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        F30FFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" F30FFint ",F30FFint

      return
      end
************************************************************************
*
      function G30FFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -0.7D1 / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -0.7D1 / 0.6D1 / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        G30FFint=e2
      elseif(ieorder.eq.-1)then
        G30FFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        G30FFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" G30FFint ",G30FFint

      return
      end
