************************************************************************
*
      function gA30FIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        gA30FIint=gA30IFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.2D1 * x2 ** 2 - 0.2D1 * x2 + 0.1D1
      e0 = (0.2D1 * x2 ** 2 - 0.2D1 * x2 + 0.1D1) * rH1(0, x2) + (0.2D
     #1 * x2 ** 2 - 0.2D1 * x2 + 0.1D1) * rH1(1, x2)
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.2D1 * x2 ** 2 - 0.2D1 * x2 + 0.1D1) / omz1
      e0 = (0.2D1 * x2 ** 2 - 0.2D1 * x2 + 0.1D1) / omz1 * rH1(0, x2) 
     #+ (0.2D1 * x2 ** 2 - 0.2D1 * x2 + 0.1D1) / omz1 * rH1(1, x2)
      endif

      if(ieorder.eq.-2)then
        gA30FIint=e2
      elseif(ieorder.eq.-1)then
        gA30FIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gA30FIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gA30FIint ",gA30FIint

      return
      end
************************************************************************
*
      function gD30FIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        gD30FIint=gD30IFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.4D1 + d0x2
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.3D1 / 0.4D1 * d0x2 - d1
     #x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x2 / omz1 + 0.1D1 / omz1 / omz2 * rH1(1, z2) + 0.3D1 / 0.
     #4D1 / omz1 / omz2
      e0 = 0.3D1 / 0.4D1 * d0x2 / omz1 - 0.1D1 / omz1 * d1x2 + 0.7D1 /
     # 0.4D1 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.3D1 / 0.4
     #D1 / omz1 / omz2 * rH1(1, z2) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2
     #)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = -d0x2 + (0.2D1 * x2 - 0.1D1) * (0.2D1 * x2 ** 2 - x2 + 0.2D
     #1) / x2 / 0.2D1
      e0 = -0.3D1 / 0.4D1 * d0x2 + d1x2 - (0.2D1 * x2 + 0.3D1) / x2 / 
     #0.4D1 + (0.2D1 * x2 - 0.1D1) * (0.2D1 * x2 ** 2 - x2 + 0.2D1) / x2
     # * rH1(0, x2) / 0.2D1 + (0.2D1 * x2 - 0.1D1) * (0.2D1 * x2 ** 2 - 
     #x2 + 0.2D1) / x2 * rH1(1, x2) / 0.2D1 - rH1(0, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = -d0x2 / omz1 + (0.2D1 * x2 - 0.1D1) * (0.2D1 * x2 ** 2 - x2
     # + 0.2D1) / x2 / omz1 / 0.2D1
      e0 = -0.3D1 / 0.4D1 * d0x2 / omz1 + 0.1D1 / omz1 * d1x2 + (0.2D1
     # * x2 - 0.1D1) * (0.2D1 * x2 ** 2 - x2 + 0.2D1) / x2 * rH1(0, x2) 
     #/ omz1 / 0.2D1 + (0.2D1 * x2 - 0.1D1) * (0.2D1 * x2 ** 2 - x2 + 0.
     #2D1) / x2 / omz1 * rH1(1, x2) / 0.2D1 - (0.2D1 * x2 + 0.3D1) / x2 
     #/ omz1 / 0.4D1 - rH1(0, x2) / omz1 / omx2
      endif

      if(ieorder.eq.-2)then
        gD30FIint=e2
      elseif(ieorder.eq.-1)then
        gD30FIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gD30FIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gD30FIint ",gD30FIint

      return
      end
************************************************************************
*
      function qpE30FIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        qpE30FIint=qpE30IFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(0, x2) / 0.2D1 + 
     #(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(1, x2) / 0.2D1 - (0.3D1 
     #* x2 - 0.4D1) / x2 / 0.2D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * rH1(0, x2) / 0
     #.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * rH1(1, x2) / 0
     #.2D1 - (0.3D1 * x2 - 0.4D1) / x2 / omz1 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        qpE30FIint=e2
      elseif(ieorder.eq.-1)then
        qpE30FIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qpE30FIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qpE30FIint ",qpE30FIint

      return
      end
************************************************************************
*
      function gF30FIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        gF30FIint=gF30IFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 2
      e1 = 0.11D2 / 0.6D1 + 0.2D1 * d0x2
      e0 = 0.67D2 / 0.18D2 - pi ** 2 / 0.2D1 + 0.11D2 / 0.6D1 * d0x2 -
     # 0.2D1 * d1x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.2D1 / omz1 / omz2
      e1 = 0.2D1 * d0x2 / omz1 + 0.2D1 / omz1 / omz2 * rH1(1, z2) + 0.
     #11D2 / 0.6D1 / omz1 / omz2
      e0 = 0.11D2 / 0.6D1 * d0x2 / omz1 - 0.2D1 / omz1 * d1x2 + 0.67D2
     # / 0.18D2 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.2D1 + 0.2D1 / 
     #omz1 / omz2 * rH2(1, 1, z2) + 0.11D2 / 0.6D1 / omz1 / omz2 * rH1(1
     #, z2)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.2D1 * d0x2 + 0.2D1 * (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0
     #.1D1) / x2
      e0 = -0.11D2 / 0.6D1 * d0x2 + 0.2D1 * d1x2 + 0.2D1 * (x2 ** 3 - 
     #x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rH1(0, x2) + 0.2D1 * (x2 ** 3
     # - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rH1(1, x2) - 0.11D2 / 0.6D
     #1 / x2 - 0.2D1 * rH1(0, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.2D1 * d0x2 / omz1 + 0.2D1 * (x2 ** 3 - x2 ** 2 + 0.2D1 *
     # x2 - 0.1D1) / x2 / omz1
      e0 = -0.11D2 / 0.6D1 * d0x2 / omz1 + 0.2D1 / omz1 * d1x2 + 0.2D1
     # * (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rH1(0, x
     #2) + 0.2D1 * (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 
     #* rH1(1, x2) - 0.11D2 / 0.6D1 / x2 / omz1 - 0.2D1 * rH1(0, x2) / o
     #mz1 / omx2
      endif

      if(ieorder.eq.-2)then
        gF30FIint=e2
      elseif(ieorder.eq.-1)then
        gF30FIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gF30FIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gF30FIint ",gF30FIint

      return
      end
************************************************************************
*
      function qpG30FIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        qpG30FIint=qpG30IFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(0, x2) / 0.2D1 + 
     #(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(1, x2) / 0.2D1 - (0.4D1 
     #* x2 - 0.7D1) / x2 / 0.4D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * rH1(0, x2) / 0
     #.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * rH1(1, x2) / 0
     #.2D1 - (0.4D1 * x2 - 0.7D1) / x2 / omz1 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        qpG30FIint=e2
      elseif(ieorder.eq.-1)then
        qpG30FIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qpG30FIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qpG30FIint ",qpG30FIint

      return
      end
************************************************************************
*
      function qA30FIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        qA30FIint=qA30IFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.4D1 + d0x2
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.3D1 / 0.4D1 * d0x2 - d1
     #x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x2 / omz1 + 0.1D1 / omz1 / omz2 * rH1(1, z2) + 0.3D1 / 0.
     #4D1 / omz1 / omz2
      e0 = 0.3D1 / 0.4D1 * d0x2 / omz1 - 0.1D1 / omz1 * d1x2 + 0.7D1 /
     # 0.4D1 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.3D1 / 0.4
     #D1 / omz1 / omz2 * rH1(1, z2) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2
     #)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 + x2 / 0.2D1 - d0x2
      e0 = -0.3D1 / 0.4D1 * d0x2 + d1x2 + 0.3D1 / 0.2D1 - x2 / 0.2D1 +
     # (0.1D1 / 0.2D1 + x2 / 0.2D1) * rH1(0, x2) + (0.1D1 / 0.2D1 + x2 /
     # 0.2D1) * rH1(1, x2) - rH1(0, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 - d0x2 / omz1
      e0 = -0.3D1 / 0.4D1 * d0x2 / omz1 + 0.1D1 / omz1 * d1x2 + (0.3D1
     # / 0.2D1 - x2 / 0.2D1) / omz1 + (0.1D1 / 0.2D1 + x2 / 0.2D1) * rH1
     #(0, x2) / omz1 + (0.1D1 / 0.2D1 + x2 / 0.2D1) * rH1(1, x2) / omz1 
     #- rH1(0, x2) / omz1 / omx2
      endif

      if(ieorder.eq.-2)then
        qA30FIint=e2
      elseif(ieorder.eq.-1)then
        qA30FIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qA30FIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qA30FIint ",qA30FIint

      return
      end
************************************************************************
*
      function qD30FIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        qD30FIint=qD30IFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 2
      e1 = 0.11D2 / 0.6D1 + 0.2D1 * d0x2
      e0 = 0.67D2 / 0.18D2 - pi ** 2 / 0.2D1 + 0.11D2 / 0.6D1 * d0x2 -
     # 0.2D1 * d1x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.2D1 / omz1 / omz2
      e1 = 0.2D1 * d0x2 / omz1 + 0.2D1 / omz1 / omz2 * rH1(1, z2) + 0.
     #11D2 / 0.6D1 / omz1 / omz2
      e0 = 0.11D2 / 0.6D1 * d0x2 / omz1 - 0.2D1 / omz1 * d1x2 + 0.67D2
     # / 0.18D2 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.2D1 + 0.11D2 /
     # 0.6D1 / omz1 / omz2 * rH1(1, z2) + 0.2D1 / omz1 / omz2 * rH2(1, 1
     #, z2)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 + x2 - 0.2D1 * d0x2
      e0 = -0.11D2 / 0.6D1 * d0x2 + 0.2D1 * d1x2 - (0.3D1 * x2 ** 2 - 
     #0.3D1 * x2 + 0.1D1) / x2 / 0.3D1 + (0.1D1 + x2) * rH1(0, x2) + (0.
     #1D1 + x2) * rH1(1, x2) - 0.2D1 * rH1(0, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 + x2) / omz1 - 0.2D1 * d0x2 / omz1
      e0 = -0.11D2 / 0.6D1 * d0x2 / omz1 + 0.2D1 / omz1 * d1x2 - (0.3D
     #1 * x2 ** 2 - 0.3D1 * x2 + 0.1D1) / x2 / omz1 / 0.3D1 + (0.1D1 + x
     #2) / omz1 * rH1(0, x2) + (0.1D1 + x2) / omz1 * rH1(1, x2) - 0.2D1 
     #* rH1(0, x2) / omz1 / omx2
      endif

      if(ieorder.eq.-2)then
        qD30FIint=e2
      elseif(ieorder.eq.-1)then
        qD30FIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qD30FIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qD30FIint ",qD30FIint

      return
      end
************************************************************************
*
      function qE30FIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        qE30FIint=qE30IFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -0.5D1 / 0.9D1 - d0x2 / 0.3D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -d0x2 / omz1 / 0.3D1 - 0.1D1 / omz1 / omz2 * rH1(1, z2) / 0
     #.3D1 - 0.5D1 / 0.9D1 / omz1 / omz2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / x2 / 0.6D1 + d0x2 / 0.3D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / x2 / omz1 / 0.6D1 + d0x2 / omz1 / 0.3D1
      endif

      if(ieorder.eq.-2)then
        qE30FIint=e2
      elseif(ieorder.eq.-1)then
        qE30FIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qE30FIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qE30FIint ",qE30FIint

      return
      end
************************************************************************
*
      function gG30FIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        gG30FIint=gG30IFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -0.5D1 / 0.9D1 - d0x2 / 0.3D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -d0x2 / omz1 / 0.3D1 - 0.1D1 / omz1 / omz2 * rH1(1, z2) / 0
     #.3D1 - 0.5D1 / 0.9D1 / omz1 / omz2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / x2 / 0.3D1 + d0x2 / 0.3D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / x2 / omz1 / 0.3D1 + d0x2 / omz1 / 0.3D1
      endif

      if(ieorder.eq.-2)then
        gG30FIint=e2
      elseif(ieorder.eq.-1)then
        gG30FIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gG30FIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gG30FIint ",gG30FIint

      return
      end
************************************************************************
*
      function gD30qgFIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        gD30qgFIint=gD30qgIFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 - x2 + x2 ** 2
      e0 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) * rH1(0, x2) + (0.1D1 / 0.2D
     #1 - x2 + x2 ** 2) * rH1(1, x2) + (0.4D1 * x2 - 0.3D1) / x2 / 0.4D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) / omz1
      e0 = (0.4D1 * x2 - 0.3D1) / x2 / omz1 / 0.4D1 + (0.1D1 / 0.2D1 -
     # x2 + x2 ** 2) * rH1(0, x2) / omz1 + (0.1D1 / 0.2D1 - x2 + x2 ** 2
     #) * rH1(1, x2) / omz1
      endif

      if(ieorder.eq.-2)then
        gD30qgFIint=e2
      elseif(ieorder.eq.-1)then
        gD30qgFIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gD30qgFIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gD30qgFIint ",gD30qgFIint

      return
      end
************************************************************************
*
      function gD30gqFIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.1).or.(i2.eq.1))then
        gD30gqFIint=gD30gqIFint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.4D1 + d0x2
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.3D1 / 0.4D1 * d0x2 - d1
     #x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x2 / omz1 + 0.1D1 / omz1 / omz2 * rH1(1, z2) + 0.3D1 / 0.
     #4D1 / omz1 / omz2
      e0 = 0.3D1 / 0.4D1 * d0x2 / omz1 - 0.1D1 / omz1 * d1x2 + 0.7D1 /
     # 0.4D1 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.3D1 / 0.4
     #D1 / omz1 / omz2 * rH1(1, z2) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2
     #)
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = -d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2
      e0 = -0.3D1 / 0.4D1 * d0x2 + d1x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 *
     # x2 - 0.1D1) / x2 * rH1(0, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 -
     # 0.1D1) / x2 * rH1(1, x2) - 0.3D1 / 0.2D1 - rH1(0, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = -d0x2 / omz1 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x
     #2 / omz1
      e0 = -0.3D1 / 0.4D1 * d0x2 / omz1 + 0.1D1 / omz1 * d1x2 + (x2 **
     # 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rH1(0, x2) + (x2 
     #** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rH1(1, x2) - 0.
     #3D1 / 0.2D1 / omz1 - rH1(0, x2) / omz1 / omx2
      endif

      if(ieorder.eq.-2)then
        gD30gqFIint=e2
      elseif(ieorder.eq.-1)then
        gD30gqFIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gD30gqFIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gD30gqFIint ",gD30gqFIint

      return
      end
