************************************************************************
*
      function gA30IFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        gA30IFint=gA30FIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.2D1 * x1 ** 2 - 0.2D1 * x1 + 0.1D1
      e0 = (0.2D1 * x1 ** 2 - 0.2D1 * x1 + 0.1D1) * rH1(0, x1) + (0.2D
     #1 * x1 ** 2 - 0.2D1 * x1 + 0.1D1) * rH1(1, x1)
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.2D1 * x1 ** 2 - 0.2D1 * x1 + 0.1D1) / omz2
      e0 = (0.2D1 * x1 ** 2 - 0.2D1 * x1 + 0.1D1) / omz2 * rH1(0, x1) 
     #+ (0.2D1 * x1 ** 2 - 0.2D1 * x1 + 0.1D1) / omz2 * rH1(1, x1)
      endif

      if(ieorder.eq.-2)then
        gA30IFint=e2
      elseif(ieorder.eq.-1)then
        gA30IFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gA30IFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gA30IFint ",gA30IFint

      return
      end
************************************************************************
*
      function gD30IFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        gD30IFint=gD30FIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.4D1 + d0x1
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.3D1 / 0.4D1 * d0x1 - d1
     #x1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x1 / omz2 + 0.1D1 / omz1 / omz2 * rH1(1, z1) + 0.3D1 / 0.
     #4D1 / omz1 / omz2
      e0 = 0.3D1 / 0.4D1 * d0x1 / omz2 - 0.1D1 / omz2 * d1x1 + 0.7D1 /
     # 0.4D1 / omz1 / omz2 + 0.3D1 / 0.4D1 / omz1 / omz2 * rH1(1, z1) - 
     #pi ** 2 / omz1 / omz2 / 0.4D1 + 0.1D1 / omz1 / omz2 * rH2(1, 1, z1
     #)
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = -d0x1 + (0.2D1 * x1 - 0.1D1) * (0.2D1 * x1 ** 2 - x1 + 0.2D
     #1) / x1 / 0.2D1
      e0 = -0.3D1 / 0.4D1 * d0x1 + d1x1 - (0.2D1 * x1 + 0.3D1) / x1 / 
     #0.4D1 + (0.2D1 * x1 - 0.1D1) * (0.2D1 * x1 ** 2 - x1 + 0.2D1) / x1
     # * rH1(0, x1) / 0.2D1 + (0.2D1 * x1 - 0.1D1) * (0.2D1 * x1 ** 2 - 
     #x1 + 0.2D1) / x1 * rH1(1, x1) / 0.2D1 - rH1(0, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = -d0x1 / omz2 + (0.2D1 * x1 - 0.1D1) * (0.2D1 * x1 ** 2 - x1
     # + 0.2D1) / x1 / omz2 / 0.2D1
      e0 = -0.3D1 / 0.4D1 * d0x1 / omz2 + 0.1D1 / omz2 * d1x1 + (0.2D1
     # * x1 - 0.1D1) * (0.2D1 * x1 ** 2 - x1 + 0.2D1) / x1 / omz2 * rH1(
     #0, x1) / 0.2D1 + (0.2D1 * x1 - 0.1D1) * (0.2D1 * x1 ** 2 - x1 + 0.
     #2D1) / x1 / omz2 * rH1(1, x1) / 0.2D1 - (0.2D1 * x1 + 0.3D1) / x1 
     #/ omz2 / 0.4D1 - 0.1D1 / omz2 * rH1(0, x1) / omx1
      endif

      if(ieorder.eq.-2)then
        gD30IFint=e2
      elseif(ieorder.eq.-1)then
        gD30IFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gD30IFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gD30IFint ",gD30IFint

      return
      end
************************************************************************
*
      function qpE30IFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        qpE30IFint=qpE30FIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / 0.2D1
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * rH1(0, x1) / 0.2D1 + 
     #(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * rH1(1, x1) / 0.2D1 - (0.3D1 
     #* x1 - 0.4D1) / x1 / 0.2D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / 0.2D1
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * rH1(0, x1) / 0
     #.2D1 + (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * rH1(1, x1) / 0
     #.2D1 - (0.3D1 * x1 - 0.4D1) / x1 / omz2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        qpE30IFint=e2
      elseif(ieorder.eq.-1)then
        qpE30IFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qpE30IFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qpE30IFint ",qpE30IFint

      return
      end
************************************************************************
*
      function gF30IFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        gF30IFint=gF30FIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 2
      e1 = 0.11D2 / 0.6D1 + 0.2D1 * d0x1
      e0 = 0.67D2 / 0.18D2 - pi ** 2 / 0.2D1 + 0.11D2 / 0.6D1 * d0x1 -
     # 0.2D1 * d1x1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.2D1 / omz1 / omz2
      e1 = 0.2D1 * d0x1 / omz2 + 0.2D1 / omz1 / omz2 * rH1(1, z1) + 0.
     #11D2 / 0.6D1 / omz1 / omz2
      e0 = 0.11D2 / 0.6D1 * d0x1 / omz2 - 0.2D1 / omz2 * d1x1 + 0.67D2
     # / 0.18D2 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.2D1 + 0.11D2 /
     # 0.6D1 / omz1 / omz2 * rH1(1, z1) + 0.2D1 / omz1 / omz2 * rH2(1, 1
     #, z1)
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.2D1 * d0x1 + 0.2D1 * (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0
     #.1D1) / x1
      e0 = -0.11D2 / 0.6D1 * d0x1 + 0.2D1 * d1x1 + 0.2D1 * (x1 ** 3 - 
     #x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * rH1(0, x1) + 0.2D1 * (x1 ** 3
     # - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * rH1(1, x1) - 0.11D2 / 0.6D
     #1 / x1 - 0.2D1 * rH1(0, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.2D1 * d0x1 / omz2 + 0.2D1 * (x1 ** 3 - x1 ** 2 + 0.2D1 *
     # x1 - 0.1D1) / x1 / omz2
      e0 = -0.11D2 / 0.6D1 * d0x1 / omz2 + 0.2D1 / omz2 * d1x1 + 0.2D1
     # * (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * rH1(0, x
     #1) + 0.2D1 * (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 
     #* rH1(1, x1) - 0.11D2 / 0.6D1 / x1 / omz2 - 0.2D1 * rH1(0, x1) / o
     #mz2 / omx1
      endif

      if(ieorder.eq.-2)then
        gF30IFint=e2
      elseif(ieorder.eq.-1)then
        gF30IFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gF30IFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gF30IFint ",gF30IFint

      return
      end
************************************************************************
*
      function qpG30IFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        qpG30IFint=qpG30FIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / 0.2D1
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * rH1(0, x1) / 0.2D1 + 
     #(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * rH1(1, x1) / 0.2D1 - (0.4D1 
     #* x1 - 0.7D1) / x1 / 0.4D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / 0.2D1
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * rH1(0, x1) / 0
     #.2D1 + (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * rH1(1, x1) / 0
     #.2D1 - (0.4D1 * x1 - 0.7D1) / x1 / omz2 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        qpG30IFint=e2
      elseif(ieorder.eq.-1)then
        qpG30IFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qpG30IFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qpG30IFint ",qpG30IFint

      return
      end
************************************************************************
*
      function qA30IFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        qA30IFint=qA30FIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.4D1 + d0x1
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.3D1 / 0.4D1 * d0x1 - d1
     #x1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x1 / omz2 + 0.1D1 / omz1 / omz2 * rH1(1, z1) + 0.3D1 / 0.
     #4D1 / omz1 / omz2
      e0 = 0.3D1 / 0.4D1 * d0x1 / omz2 - 0.1D1 / omz2 * d1x1 + 0.7D1 /
     # 0.4D1 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.3D1 / 0.4
     #D1 / omz1 / omz2 * rH1(1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z1
     #)
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 + x1 / 0.2D1 - d0x1
      e0 = -0.3D1 / 0.4D1 * d0x1 + d1x1 + 0.3D1 / 0.2D1 - x1 / 0.2D1 +
     # (0.1D1 / 0.2D1 + x1 / 0.2D1) * rH1(0, x1) + (0.1D1 / 0.2D1 + x1 /
     # 0.2D1) * rH1(1, x1) - rH1(0, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 - d0x1 / omz2
      e0 = -0.3D1 / 0.4D1 * d0x1 / omz2 + 0.1D1 / omz2 * d1x1 + (0.1D1
     # / 0.2D1 + x1 / 0.2D1) / omz2 * rH1(0, x1) + (0.1D1 / 0.2D1 + x1 /
     # 0.2D1) * rH1(1, x1) / omz2 + (0.3D1 / 0.2D1 - x1 / 0.2D1) / omz2 
     #- 0.1D1 / omz2 * rH1(0, x1) / omx1
      endif

      if(ieorder.eq.-2)then
        qA30IFint=e2
      elseif(ieorder.eq.-1)then
        qA30IFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qA30IFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qA30IFint ",qA30IFint

      return
      end
************************************************************************
*
      function qD30IFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        qD30IFint=qD30FIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 2
      e1 = 0.11D2 / 0.6D1 + 0.2D1 * d0x1
      e0 = 0.67D2 / 0.18D2 - pi ** 2 / 0.2D1 + 0.11D2 / 0.6D1 * d0x1 -
     # 0.2D1 * d1x1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.2D1 / omz1 / omz2
      e1 = 0.2D1 * d0x1 / omz2 + 0.2D1 / omz1 / omz2 * rH1(1, z1) + 0.
     #11D2 / 0.6D1 / omz1 / omz2
      e0 = 0.11D2 / 0.6D1 * d0x1 / omz2 - 0.2D1 / omz2 * d1x1 + 0.67D2
     # / 0.18D2 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.2D1 + 0.11D2 /
     # 0.6D1 / omz1 / omz2 * rH1(1, z1) + 0.2D1 / omz1 / omz2 * rH2(1, 1
     #, z1)
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 + x1 - 0.2D1 * d0x1
      e0 = -0.11D2 / 0.6D1 * d0x1 + 0.2D1 * d1x1 - (0.3D1 * x1 ** 2 - 
     #0.3D1 * x1 + 0.1D1) / x1 / 0.3D1 + (0.1D1 + x1) * rH1(0, x1) + (0.
     #1D1 + x1) * rH1(1, x1) - 0.2D1 * rH1(0, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 + x1) / omz2 - 0.2D1 * d0x1 / omz2
      e0 = -0.11D2 / 0.6D1 * d0x1 / omz2 + 0.2D1 / omz2 * d1x1 + (0.1D
     #1 + x1) / omz2 * rH1(0, x1) + (0.1D1 + x1) / omz2 * rH1(1, x1) - (
     #0.3D1 * x1 ** 2 - 0.3D1 * x1 + 0.1D1) / x1 / omz2 / 0.3D1 - 0.2D1 
     #/ omz2 * rH1(0, x1) / omx1
      endif

      if(ieorder.eq.-2)then
        qD30IFint=e2
      elseif(ieorder.eq.-1)then
        qD30IFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qD30IFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qD30IFint ",qD30IFint

      return
      end
************************************************************************
*
      function qE30IFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        qE30IFint=qE30FIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -0.5D1 / 0.9D1 - d0x1 / 0.3D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -d0x1 / omz2 / 0.3D1 - 0.1D1 / omz1 / omz2 * rH1(1, z1) / 0
     #.3D1 - 0.5D1 / 0.9D1 / omz1 / omz2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / x1 / 0.6D1 + d0x1 / 0.3D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / x1 / omz2 / 0.6D1 + d0x1 / omz2 / 0.3D1
      endif

      if(ieorder.eq.-2)then
        qE30IFint=e2
      elseif(ieorder.eq.-1)then
        qE30IFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qE30IFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qE30IFint ",qE30IFint

      return
      end
************************************************************************
*
      function gG30IFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        gG30IFint=gG30FIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -0.5D1 / 0.9D1 - d0x1 / 0.3D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -d0x1 / omz2 / 0.3D1 - 0.1D1 / omz1 / omz2 * rH1(1, z1) / 0
     #.3D1 - 0.5D1 / 0.9D1 / omz1 / omz2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / x1 / 0.3D1 + d0x1 / 0.3D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / x1 / omz2 / 0.3D1 + d0x1 / omz2 / 0.3D1
      endif

      if(ieorder.eq.-2)then
        gG30IFint=e2
      elseif(ieorder.eq.-1)then
        gG30IFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gG30IFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gG30IFint ",gG30IFint

      return
      end
************************************************************************
*
      function gD30qgIFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        gD30qgIFint=gD30qgFIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 - x1 + x1 ** 2
      e0 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) * rH1(0, x1) + (0.1D1 / 0.2D
     #1 - x1 + x1 ** 2) * rH1(1, x1) + (0.4D1 * x1 - 0.3D1) / x1 / 0.4D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) / omz2
      e0 = (0.4D1 * x1 - 0.3D1) / x1 / omz2 / 0.4D1 + (0.1D1 / 0.2D1 -
     # x1 + x1 ** 2) * rH1(0, x1) / omz2 + (0.1D1 / 0.2D1 - x1 + x1 ** 2
     #) * rH1(1, x1) / omz2
      endif

      if(ieorder.eq.-2)then
        gD30qgIFint=e2
      elseif(ieorder.eq.-1)then
        gD30qgIFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gD30qgIFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gD30qgIFint ",gD30qgIFint

      return
      end
************************************************************************
*
      function gD30gqIFint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).or.(i2.eq.2))then
        gD30gqIFint=gD30gqFIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.4D1 + d0x1
      e0 = 0.7D1 / 0.4D1 - pi ** 2 / 0.4D1 + 0.3D1 / 0.4D1 * d0x1 - d1
     #x1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x1 / omz2 + 0.1D1 / omz1 / omz2 * rH1(1, z1) + 0.3D1 / 0.
     #4D1 / omz1 / omz2
      e0 = 0.3D1 / 0.4D1 * d0x1 / omz2 - 0.1D1 / omz2 * d1x1 + 0.7D1 /
     # 0.4D1 / omz1 / omz2 - pi ** 2 / omz1 / omz2 / 0.4D1 + 0.1D1 / omz
     #1 / omz2 * rH2(1, 1, z1) + 0.3D1 / 0.4D1 / omz1 / omz2 * rH1(1, z1
     #)
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = -d0x1 + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1
      e0 = -0.3D1 / 0.4D1 * d0x1 + d1x1 + (x1 ** 3 - x1 ** 2 + 0.2D1 *
     # x1 - 0.1D1) / x1 * rH1(0, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 -
     # 0.1D1) / x1 * rH1(1, x1) - 0.3D1 / 0.2D1 - rH1(0, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = -d0x1 / omz2 + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x
     #1 / omz2
      e0 = -0.3D1 / 0.4D1 * d0x1 / omz2 + 0.1D1 / omz2 * d1x1 + (x1 **
     # 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * rH1(0, x1) + (x1 
     #** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * rH1(1, x1) - 0.
     #3D1 / 0.2D1 / omz2 - 0.1D1 / omz2 * rH1(0, x1) / omx1
      endif

      if(ieorder.eq.-2)then
        gD30gqIFint=e2
      elseif(ieorder.eq.-1)then
        gD30gqIFint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gD30gqIFint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gD30gqIFint ",gD30gqIFint

      return
      end
