************************************************************************
*
      function G1QQ1(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.1)then
        e2= 0d0
        e1=+1d0*d0x1
     .     -3d0/4d0
        e0= 0d0
      endif
      if(ix.eq.2)then
        e2= 0d0
        e1=-1d0*d0x1
     .     +1d0/2d0*(1d0+x1)
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1QQ1=e2
      elseif(ieorder.eq.-1)then
        G1QQ1=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1QQ1=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1QQ1 ",G1QQ1

      return
      end
************************************************************************
*
      function G1QQ2(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.1)then
        e2= 0d0
        e1=+1d0*d0x2
     .     -3d0/4d0
        e0= 0d0
      endif
      if(ix.eq.3)then
        e2= 0d0
        e1=-1d0*d0x2
     .     +1d0/2d0*(1d0+x2)
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1QQ2=e2
      elseif(ieorder.eq.-1)then
        G1QQ2=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1QQ2=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1QQ2 ",G1QQ2

      return
      end
************************************************************************
*
      function G1GQ1(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.2)then
        e2= 0d0
        e1=-1d0*(-2d0*x1+2d0+x1**2)/(x1)
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1GQ1=e2
      elseif(ieorder.eq.-1)then
        G1GQ1=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1GQ1=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1GQ1 ",G1GQ1

      return
      end
************************************************************************
*
      function G1GQ2(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.3)then
        e2= 0d0
        e1=-1d0*(-2d0*x2+2d0+x2**2)/(x2)
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1GQ2=e2
      elseif(ieorder.eq.-1)then
        G1GQ2=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1GQ2=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1GQ2 ",G1GQ2

      return
      end
************************************************************************
*
      function G1QG1(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.2)then
        e2= 0d0
        e1=-1d0/2d0*(1d0-2d0*x1+2d0*x1**2)
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1QG1=e2
      elseif(ieorder.eq.-1)then
        G1QG1=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1QG1=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1QG1 ",G1QG1

      return
      end
************************************************************************
*
      function G1QG2(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.3)then
        e2= 0d0
        e1=-1d0/2d0*(1d0-2d0*x2+2d0*x2**2)
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1QG2=e2
      elseif(ieorder.eq.-1)then
        G1QG2=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1QG2=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1QG2 ",G1QG2

      return
      end
************************************************************************
*
      function G1GG1(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.1)then
        e2= 0d0
        e1=+2d0*d0x1
     .     -11d0/6d0
        e0= 0d0
      endif
      if(ix.eq.2)then
        e2= 0d0
        e1=-2d0*d0x1
     .     +2d0*(2d0*x1-1d0-x1**2+x1**3)/(x1)
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1GG1=e2
      elseif(ieorder.eq.-1)then
        G1GG1=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1GG1=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1GG1 ",G1GG1

      return
      end
************************************************************************
*
      function G1GG2(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.1)then
        e2= 0d0
        e1=+2d0*d0x2
     .     -11d0/6d0
        e0= 0d0
      endif
      if(ix.eq.3)then
        e2= 0d0
        e1=-2d0*d0x2
     .     +2d0*(2d0*x2-1d0-x2**2+x2**3)/(x2)
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1GG2=e2
      elseif(ieorder.eq.-1)then
        G1GG2=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1GG2=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1GG2 ",G1GG2

      return
      end
************************************************************************
*
      function G1GGF1(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.1)then
        e2= 0d0
        e1=+1d0/3d0
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1GGF1=e2
      elseif(ieorder.eq.-1)then
        G1GGF1=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1GGF1=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1GGF1 ",G1GGF1

      return
      end
************************************************************************
*
      function G1GGF2(ix,x1,x2,renscale2,facscale2)
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      dls=log(renscale2/facscale2)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ix.eq.1)then
        e2= 0d0
        e1=+1d0/3d0
        e0= 0d0
      endif

      if(ieorder.eq.-2)then
        G1GGF2=e2
      elseif(ieorder.eq.-1)then
        G1GGF2=e1+dls*e2
      elseif(ieorder.eq.0)then
        G1GGF2=e0+dls*e1+1d0/2d0*dls**2*e2
      endif

*      write(*,*)" G1GGF2 ",G1GGF2

      return
      end
