****************************************************
* C40 full antenna function
* Eq.(5.42) of hep-ph/0505111
* flavour assignment: q(i1) q(i3) qb(i4) qb(i2)
* limit: triple-collinear i3||i4||i2
      function FullC40(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34

      s1234=s12+s13+s14+s23+s24+s34

      c40 =  + s123**(-1)*s134**(-1)*s1234**(-1)*S23**(-1)*S34**(-1)
     &  * (
     &     + s14**3
     &     )
      c40 = c40 + s123**(-1)*s134**(-1)*s1234**(-1)*S23**(-1) * (
     &     + s34**2
     &     + 3.D0*s14*s34
     &     + 3.D0*s14**2
     &     )
      c40 = c40 + s123**(-1)*s234**(-1)*s1234**(-1)*S23**(-1) * (
     &     + s13*s14
     &     )
      c40 = c40 + s123**(-1)*s234**(-1)*s1234**(-1)*S34**(-1) * (
     &     + 1.D0/2.D0*s14**2
     &     + 1.D0/2.D0*s13**2
     &     )
      c40 = c40 + s123**(-1)*s234**(-1)*s1234**(-1) * (
     &     + 1.D0/2.D0*s34
     &     + s14
     &     - s13
     &     )
      c40 = c40 + s123**(-1)*s1234**(-1)*S23**(-1)*S34**(-1) * (
     &     - s14**2
     &     + 1.D0/2.D0*s13*s14
     &     - 1.D0/2.D0*s13**2
     &     )
      c40 = c40 + s123**(-1)*s1234**(-1)*S23**(-1) * (
     &     - s34
     &     - 2.D0*s14
     &     + 3.D0/2.D0*s13
     &     )
      c40 = c40 + s134**(-1)*s234**(-1)*s1234**(-1)*S23**(-1) * (
     &     + 1.D0/2.D0*s34**2
     &     + s14*s34
     &     + 1.D0/2.D0*s14**2
     &     + 1.D0/2.D0*s12**2
     &     )
      c40 = c40 + s134**(-1)*s234**(-1)*s1234**(-1)*S34**(-1) * (
     &     - s12*s14
     &     )
      c40 = c40 + s134**(-1)*s234**(-1)*s1234**(-1) * (
     &     + 1.D0/2.D0*s34
     &     - 1.D0/2.D0*s24
     &     + s14
     &     )
      c40 = c40 + s134**(-1)*s1234**(-1)*S23**(-1)*S34**(-1) * (
     &     + 1.D0/2.D0*s14**2
     &     + 1.D0/2.D0*s12*s14
     &     )
      c40 = c40 + s134**(-1)*s1234**(-1)*S23**(-1) * (
     &     + 1.D0/2.D0*s34
     &     + s14
     &     + 1.D0/2.D0*s12
     &     )
      c40 = c40 + s134**(-1)*s1234**(-1)*S34**(-1) * (
     &     - 1.D0/2.D0*s14
     &     )
      c40 = c40 + s234**(-2)*s1234**(-1)*S23**(-1) * (
     &     - s14*s34
     &     - s13*s34
     &     - s12*s34
     &     )
      c40 = c40 + s234**(-2)*s1234**(-1)*S34**(-1) * (
     &     + s14*s24
     &     + s13*s24
     &     + s12*s24
     &     )
      c40 = c40 + s234**(-2)*s1234**(-1) * (
     &     - s14
     &     - s13
     &     - s12
     &     )
      c40 = c40 + s234**(-1)*s1234**(-1)*S23**(-1) * (
     &     - s34
     &     + 2.D0*s13
     &     + s12
     &     )
      c40 = c40 + s234**(-1)*s1234**(-1)*S34**(-1) * (
     &     + 1.D0/2.D0*s24
     &     + 1.D0/2.D0*s13
     &     + 1.D0/2.D0*s12
     &     )
      c40 = c40 + s234**(-1)*s1234**(-1) * (
     &     - 1.D0/2.D0
     &     )
      c40 = c40 + s1234**(-1)*S23**(-1)*S34**(-1) * (
     &     - 1.D0/2.D0*s14
     &     - 1.D0/2.D0*s13
     &     - 1.D0/2.D0*s12
     &     )
      c40 = c40 + s1234**(-1)*S23**(-1) * (
     &     - 1.D0/2.D0
     &     )

      FullC40 = c40

C      DcompC40 = subc40(i1,i2,i3,i4,ipset) + subc40(i1,i4,i3,i2,ipset)
C      print*, "comparison"
C      print*, "FullC40  ", FullC40
C      print*, "DcompC40 ", DcompC40
C      read(*,*)
      return
      end



C      function subc40(i1,i2,i3,i4,ipset)
C      use KinData_mod
C      implicit real*8 (a-h,o-y)
C
C      s12=kin(ipset)%s(i1,i2)
C      s13=kin(ipset)%s(i1,i3)
C      s14=kin(ipset)%s(i1,i4)
C      s23=kin(ipset)%s(i2,i3)
C      s24=kin(ipset)%s(i2,i4)
C      s34=kin(ipset)%s(i3,i4)
C
C      s123=s12+s13+s23
C      s124=s12+s14+s24
C      s134=s13+s14+s34
C      s234=s23+s24+s34
C
C      s1234=s12+s13+s14+s23+s24+s34
C
C      subc40 = 1d0/s1234 *(
C     &     -s12*s13*s14/2d0/s23/s34/s123/s134
C     &     +1d0/2d0/s23/s34/s134/s234 * (-s12*s13*s24+s13*s14*s24)
C     &     -s13*s24**2/2d0/s23/s34/s234**2
C     &     -s12*s13/s23/s123/s134
C     &     +1d0/2d0/s23/s123/s234 * (-s12*s14-s12*s34-s12**2+s13*s24)
C     &     +1d0/2d0/s23/s134/s234 * (s12*s14+s12*s34+s12**2+s13*s24)
C     &     -s13/2d0/s123/s134
C     &     +1d0/s23/s234**2 * (s12*s24+s14*s24)
C     &     +1d0/2d0/s123/s234 * (-s12+s14)
C     &   )
C
C      return
C      end
