****************************************************
* F40(i1,i2,i3,i4)
* The full F40 antenna.

      function FullF40(i1,i2,i3,i4,ipset)
      use KinData_mod
      implicit double precision (a-h,o-z)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34

      s1234=s12+s13+s14+s23+s24+s34


      f40 =  + s123**(-2)*s1234**(-2)*S12**(-2) * (
     &     + 2.D0*s23**2*s34**2
     &     + 4.D0*s23**2*s24*s34
     &     + 2.D0*s23**2*s24**2
     &     + 4.D0*s14*s23**2*s34
     &     + 4.D0*s14*s23**2*s24
     &     + 2.D0*s14**2*s23**2
     &     )
      f40 = f40 + s123**(-2)*s1234**(-2)*S12**(-1) * (
     &     + 4.D0*s23*s34**2
     &     + 8.D0*s23*s24*s34
     &     + 4.D0*s23*s24**2
     &     + 8.D0*s14*s23*s34
     &     + 8.D0*s14*s23*s24
     &     + 4.D0*s14**2*s23
     &     )
      f40 = f40 + s123**(-2)*s1234**(-2)*S23**(-2) * (
     &     + 2.D0*s13**2*s34**2
     &     + 4.D0*s13**2*s24*s34
     &     + 2.D0*s13**2*s24**2
     &     + 4.D0*s13**2*s14*s34
     &     + 4.D0*s13**2*s14*s24
     &     + 2.D0*s13**2*s14**2
     &     )
      f40 = f40 + s123**(-2)*s1234**(-2) * (
     &     + 4.D0*s34**2
     &     + 8.D0*s24*s34
     &     + 4.D0*s24**2
     &     + 8.D0*s14*s34
     &     + 8.D0*s14*s24
     &     + 4.D0*s14**2
     &     )
      f40 = f40 + s123**(-1)*s124**(-1)*s1234**(-2)*S12**(-2) * (
     &     - 4.D0*s23*s24*s34**2
     &     )
      f40 = f40 + s123**(-1)*s124**(-1)*s1234**(-2)*S12**(-1) * (
     &     - 8.D0*s34**3
     &     - 4.D0*s24*s34**2
     &     - 8.D0*s24**2*s34
     &     - 8.D0*s23*s24*s34
     &     - 8.D0*s23**2*s34
     &     )
      f40 = f40 + s123**(-1)*s124**(-1)*s1234**(-2)*S14**(-1)*S23**(-1)
     &  * (
     &     + 2.D0*s34**4
     &     + 8.D0*s24*s34**3
     &     + 12.D0*s24**2*s34**2
     &     + 8.D0*s24**3*s34
     &     + 2.D0*s24**4
     &     )
      f40 = f40 + s123**(-1)*s124**(-1)*s1234**(-2)*S14**(-1) * (
     &     - 4.D0*s34**3
     &     - 12.D0*s24*s34**2
     &     - 12.D0*s24**2*s34
     &     - 4.D0*s24**3
     &     + 6.D0*s23*s34**2
     &     + 12.D0*s23*s24*s34
     &     + 6.D0*s23*s24**2
     &     - 4.D0*s23**2*s34
     &     - 4.D0*s23**2*s24
     &     + 2.D0*s23**3
     &     )
      f40 = f40 + s123**(-1)*s124**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 4.D0*s34**3
     &     + 12.D0*s24*s34**2
     &     + 12.D0*s24**2*s34
     &     + 4.D0*s24**3
     &     + 6.D0*s14*s34**2
     &     + 12.D0*s14*s24*s34
     &     + 6.D0*s14*s24**2
     &     + 4.D0*s14**2*s34
     &     + 4.D0*s14**2*s24
     &     + 2.D0*s14**3
     &     )
      f40 = f40 + s123**(-1)*s124**(-1)*s1234**(-2) * (
     &     - 24.D0*s24*s34
     &     - 12.D0*s24**2
     &     + 12.D0*s23*s24
     &     - 4.D0*s23**2
     &     - 12.D0*s14*s24
     &     + 6.D0*s14*s23
     &     - 4.D0*s14**2
     &     )
      f40 = f40 + s123**(-1)*s134**(-1)*s1234**(-2)*S12**(-1)*S14**(-1)
     &  * (
     &     + 2.D0*s34**4
     &     + 4.D0*s24*s34**3
     &     + 6.D0*s24**2*s34**2
     &     + 4.D0*s24**3*s34
     &     + 2.D0*s24**4
     &     )
      f40 = f40 + s123**(-1)*s134**(-1)*s1234**(-2)*S12**(-1)*S34**(-1)
     &  * (
     &     + 2.D0*s24**4
     &     + 8.D0*s14*s24**3
     &     + 12.D0*s14**2*s24**2
     &     + 8.D0*s14**3*s24
     &     + 2.D0*s14**4
     &     )
      f40 = f40 + s123**(-1)*s134**(-1)*s1234**(-2)*S12**(-1) * (
     &     + 6.D0*s34**3
     &     + 16.D0*s24*s34**2
     &     + 18.D0*s24**2*s34
     &     + 12.D0*s24**3
     &     + 10.D0*s14*s34**2
     &     + 24.D0*s14*s24*s34
     &     + 24.D0*s14*s24**2
     &     + 10.D0*s14**2*s34
     &     + 20.D0*s14**2*s24
     &     + 6.D0*s14**3
     &     )
      f40 = f40 + s123**(-1)*s134**(-1)*s1234**(-2)*S14**(-1)*S23**(-1)
     &  * (
     &     + 2.D0*s34**4
     &     + 8.D0*s24*s34**3
     &     + 12.D0*s24**2*s34**2
     &     + 8.D0*s24**3*s34
     &     + 2.D0*s24**4
     &     )
      f40 = f40 + s123**(-1)*s134**(-1)*s1234**(-2)*S14**(-1) * (
     &     - 4.D0*s34**3
     &     - 8.D0*s24*s34**2
     &     - 6.D0*s24**2*s34
     &     + 2.D0*s23*s34**2
     &     + 4.D0*s23*s24*s34
     &     - 2.D0*s23**2*s34
     &     )
      f40 = f40 + s123**(-1)*s134**(-1)*s1234**(-2)*S23**(-1)*S34**(-1)
     &  * (
     &     + 2.D0*s24**4
     &     + 4.D0*s14*s24**3
     &     + 6.D0*s14**2*s24**2
     &     + 4.D0*s14**3*s24
     &     + 2.D0*s14**4
     &     )
      f40 = f40 + s123**(-1)*s134**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 6.D0*s34**3
     &     + 20.D0*s24*s34**2
     &     + 24.D0*s24**2*s34
     &     + 12.D0*s24**3
     &     + 10.D0*s14*s34**2
     &     + 24.D0*s14*s24*s34
     &     + 18.D0*s14*s24**2
     &     + 10.D0*s14**2*s34
     &     + 16.D0*s14**2*s24
     &     + 6.D0*s14**3
     &     )
      f40 = f40 + s123**(-1)*s134**(-1)*s1234**(-2)*S34**(-1) * (
     &     - 6.D0*s14*s24**2
     &     - 4.D0*s14*s23*s24
     &     - 2.D0*s14*s23**2
     &     - 4.D0*s14**2*s24
     &     + 2.D0*s14**2*s23
     &     - 4.D0*s14**3
     &     )
      f40 = f40 + s123**(-1)*s134**(-1)*s1234**(-2) * (
     &     - 16.D0*s34**2
     &     - 28.D0*s24*s34
     &     - 8.D0*s24**2
     &     + 6.D0*s23*s34
     &     - 4.D0*s23**2
     &     - 24.D0*s14*s34
     &     - 24.D0*s14*s24
     &     + 6.D0*s14*s23
     &     - 16.D0*s14**2
     &     )
      f40 = f40 + s123**(-1)*s234**(-1)*s1234**(-2)*S12**(-1)*S34**(-1)
     &  * (
     &     + 2.D0*s24**4
     &     + 8.D0*s14*s24**3
     &     + 12.D0*s14**2*s24**2
     &     + 8.D0*s14**3*s24
     &     + 2.D0*s14**4
     &     )
      f40 = f40 + s123**(-1)*s234**(-1)*s1234**(-2)*S12**(-1) * (
     &     + 2.D0*s34**3
     &     + 4.D0*s24*s34**2
     &     + 6.D0*s24**2*s34
     &     + 4.D0*s24**3
     &     + 4.D0*s14*s34**2
     &     + 12.D0*s14*s24*s34
     &     + 12.D0*s14*s24**2
     &     + 6.D0*s14**2*s34
     &     + 12.D0*s14**2*s24
     &     + 4.D0*s14**3
     &     )
      f40 = f40 + s123**(-1)*s234**(-1)*s1234**(-2)*S23**(-2) * (
     &     - 4.D0*s13*s14**2*s34
     &     )
      f40 = f40 + s123**(-1)*s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     - 8.D0*s14*s34**2
     &     - 8.D0*s14**3
     &     - 8.D0*s13*s14*s34
     &     - 4.D0*s13*s14**2
     &     - 8.D0*s13**2*s14
     &     )
      f40 = f40 + s123**(-1)*s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     - 4.D0*s14*s24**2
     &     - 6.D0*s14**2*s24
     &     - 4.D0*s14**3
     &     - 4.D0*s13*s24**2
     &     - 4.D0*s13*s14*s24
     &     - 6.D0*s13*s14**2
     &     + 2.D0*s13**2*s24
     &     - 4.D0*s13**2*s14
     &     - 2.D0*s13**3
     &     )
      f40 = f40 + s123**(-1)*s234**(-1)*s1234**(-2) * (
     &     - 4.D0*s14*s34
     &     + 4.D0*s14*s24
     &     + 6.D0*s14**2
     &     - 4.D0*s13*s34
     &     - 8.D0*s13*s24
     &     - 16.D0*s13*s14
     &     + 2.D0*s13**2
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S12**(-2) * (
     &     - 8.D0*s23*s24*s34
     &     - 4.D0*s23*s24**2
     &     + 4.D0*s23**2*s34
     &     + 4.D0*s23**2*s24
     &     - 4.D0*s14*s23*s24
     &     + 4.D0*s14*s23**2
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S12**(-1)*S14**(-1) * (
     &     - 4.D0*s23*s34**2
     &     + 2.D0*s23**2*s34
     &     - 2.D0*s23**3
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     - 4.D0*s24**3
     &     - 2.D0*s23*s24**2
     &     - 2.D0*s23**2*s24
     &     - 10.D0*s14*s24**2
     &     - 2.D0*s14*s23**2
     &     - 10.D0*s14**2*s24
     &     + 2.D0*s14**2*s23
     &     - 4.D0*s14**3
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S12**(-1) * (
     &     - 20.D0*s34**2
     &     - 26.D0*s24*s34
     &     - 22.D0*s24**2
     &     + 12.D0*s23*s34
     &     - 6.D0*s23**2
     &     - 24.D0*s14*s34
     &     - 28.D0*s14*s24
     &     + 14.D0*s14*s23
     &     - 16.D0*s14**2
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     - 4.D0*s34**3
     &     - 10.D0*s24*s34**2
     &     - 10.D0*s24**2*s34
     &     - 4.D0*s24**3
     &     - 2.D0*s13*s34**2
     &     + 2.D0*s13*s24**2
     &     - 2.D0*s13**2*s34
     &     - 2.D0*s13**2*s24
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S14**(-1) * (
     &     + 6.D0*s34**2
     &     + 16.D0*s24*s34
     &     + 6.D0*s24**2
     &     - 4.D0*s23*s34
     &     - 4.D0*s23*s24
     &     - 2.D0*s13*s34
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S23**(-2) * (
     &     - 4.D0*s13*s34**2
     &     - 4.D0*s13*s24*s34
     &     - 8.D0*s13*s14*s34
     &     + 4.D0*s13**2*s34
     &     + 4.D0*s13**2*s24
     &     + 4.D0*s13**2*s14
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S23**(-1)*S34**(-1) * (
     &     + 4.D0*s13*s14**2
     &     + 2.D0*s13**2*s14
     &     + 2.D0*s13**3
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S23**(-1) * (
     &     - 16.D0*s34**2
     &     - 24.D0*s24*s34
     &     - 18.D0*s24**2
     &     - 16.D0*s14*s34
     &     - 26.D0*s14*s24
     &     - 20.D0*s14**2
     &     - 6.D0*s13*s34
     &     + 8.D0*s13*s24
     &     + 4.D0*s13*s14
     &     - 6.D0*s13**2
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2)*S34**(-1) * (
     &     + 4.D0*s14*s24
     &     - 4.D0*s14*s23
     &     + 6.D0*s14**2
     &     + 4.D0*s13*s24
     &     - 2.D0*s13*s14
     &     )
      f40 = f40 + s123**(-1)*s1234**(-2) * (
     &     + 26.D0*s34
     &     + 28.D0*s24
     &     - 12.D0*s23
     &     + 28.D0*s14
     &     )
      f40 = f40 + s124**(-2)*s1234**(-2)*S12**(-2) * (
     &     + 2.D0*s24**2*s34**2
     &     + 4.D0*s23*s24**2*s34
     &     + 2.D0*s23**2*s24**2
     &     + 4.D0*s13*s24**2*s34
     &     + 4.D0*s13*s23*s24**2
     &     + 2.D0*s13**2*s24**2
     &     )
      f40 = f40 + s124**(-2)*s1234**(-2)*S14**(-2) * (
     &     + 2.D0*s24**2*s34**2
     &     + 4.D0*s23*s24**2*s34
     &     + 2.D0*s23**2*s24**2
     &     + 4.D0*s13*s24**2*s34
     &     + 4.D0*s13*s23*s24**2
     &     + 2.D0*s13**2*s24**2
     &     )
      f40 = f40 + s124**(-2)*s1234**(-2) * (
     &     + 2.D0*s34**2
     &     + 4.D0*s23*s34
     &     + 2.D0*s23**2
     &     + 4.D0*s13*s34
     &     + 4.D0*s13*s23
     &     + 2.D0*s13**2
     &     )
      f40 = f40 + s124**(-1)*s134**(-1)*s1234**(-2)*S12**(-1)*S34**(-1)
     &  * (
     &     + 2.D0*s24**4
     &     + 8.D0*s23*s24**3
     &     + 12.D0*s23**2*s24**2
     &     + 8.D0*s23**3*s24
     &     + 2.D0*s23**4
     &     )
      f40 = f40 + s124**(-1)*s134**(-1)*s1234**(-2)*S12**(-1) * (
     &     + 2.D0*s34**3
     &     - 4.D0*s24*s34**2
     &     + 6.D0*s24**2*s34
     &     - 4.D0*s24**3
     &     - 4.D0*s23*s34**2
     &     + 12.D0*s23*s24*s34
     &     - 12.D0*s23*s24**2
     &     + 6.D0*s23**2*s34
     &     - 12.D0*s23**2*s24
     &     - 4.D0*s23**3
     &     )
      f40 = f40 + s124**(-1)*s134**(-1)*s1234**(-2)*S14**(-2) * (
     &     - 4.D0*s23**2*s24*s34
     &     )
      f40 = f40 + s124**(-1)*s134**(-1)*s1234**(-2)*S14**(-1) * (
     &     - 8.D0*s23*s34**2
     &     - 8.D0*s23*s24*s34
     &     - 8.D0*s23*s24**2
     &     - 4.D0*s23**2*s24
     &     - 8.D0*s23**3
     &     )
      f40 = f40 + s124**(-1)*s134**(-1)*s1234**(-2)*S34**(-1) * (
     &     + 4.D0*s23*s24**2
     &     + 6.D0*s23**2*s24
     &     + 4.D0*s23**3
     &     - 4.D0*s14*s24**2
     &     - 4.D0*s14*s23*s24
     &     - 6.D0*s14*s23**2
     &     - 2.D0*s14**2*s24
     &     + 4.D0*s14**2*s23
     &     - 2.D0*s14**3
     &     )
      f40 = f40 + s124**(-1)*s134**(-1)*s1234**(-2) * (
     &     - 4.D0*s34**2
     &     + 6.D0*s24*s34
     &     - 4.D0*s24**2
     &     - 24.D0*s23*s24
     &     - 6.D0*s14*s34
     &     + 4.D0*s14*s24
     &     - 4.D0*s14**2
     &     )
      f40 = f40 + s124**(-1)*s234**(-1)*s1234**(-2)*S12**(-1)*S23**(-1)
     &  * (
     &     + 2.D0*s34**4
     &     + 4.D0*s13*s34**3
     &     + 6.D0*s13**2*s34**2
     &     + 4.D0*s13**3*s34
     &     + 2.D0*s13**4
     &     )
      f40 = f40 + s124**(-1)*s234**(-1)*s1234**(-2)*S12**(-1)*S34**(-1)
     &  * (
     &     + 2.D0*s24**4
     &     - 8.D0*s13*s24**3
     &     + 12.D0*s13**2*s24**2
     &     - 8.D0*s13**3*s24
     &     + 2.D0*s13**4
     &     )
      f40 = f40 + s124**(-1)*s234**(-1)*s1234**(-2)*S12**(-1) * (
     &     + 2.D0*s34**3
     &     + 4.D0*s24**2*s34
     &     + 2.D0*s24**3
     &     + 4.D0*s13*s34**2
     &     - 8.D0*s13*s24*s34
     &     - 4.D0*s13*s24**2
     &     + 6.D0*s13**2*s34
     &     + 4.D0*s13**3
     &     )
      f40 = f40 + s124**(-1)*s234**(-1)*s1234**(-2)*S14**(-1)*S23**(-1)
     &  * (
     &     + 2.D0*s34**4
     &     + 8.D0*s13*s34**3
     &     + 12.D0*s13**2*s34**2
     &     + 8.D0*s13**3*s34
     &     + 2.D0*s13**4
     &     )
      f40 = f40 + s124**(-1)*s234**(-1)*s1234**(-2)*S14**(-1)*S34**(-1)
     &  * (
     &     + 2.D0*s24**4
     &     - 4.D0*s13*s24**3
     &     + 6.D0*s13**2*s24**2
     &     - 4.D0*s13**3*s24
     &     + 2.D0*s13**4
     &     )
      f40 = f40 + s124**(-1)*s234**(-1)*s1234**(-2)*S14**(-1) * (
     &     + 2.D0*s34**3
     &     + 4.D0*s24**2*s34
     &     + 2.D0*s24**3
     &     + 8.D0*s13*s34**2
     &     - 4.D0*s13*s24*s34
     &     + 4.D0*s13*s24**2
     &     + 12.D0*s13**2*s34
     &     - 6.D0*s13**2*s24
     &     + 8.D0*s13**3
     &     )
      f40 = f40 + s124**(-1)*s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     - 4.D0*s34**3
     &     + 2.D0*s14*s34**2
     &     - 2.D0*s14**2*s34
     &     - 8.D0*s13*s34**2
     &     + 4.D0*s13*s14*s34
     &     - 6.D0*s13**2*s34
     &     )
      f40 = f40 + s124**(-1)*s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     + 4.D0*s24**3
     &     + 2.D0*s14*s24**2
     &     + 2.D0*s14**2*s24
     &     - 4.D0*s13*s24**2
     &     + 4.D0*s13*s14*s24
     &     + 6.D0*s13**2*s24
     &     )
      f40 = f40 + s124**(-1)*s234**(-1)*s1234**(-2) * (
     &     - 4.D0*s34**2
     &     + 4.D0*s24*s34
     &     - 4.D0*s24**2
     &     + 2.D0*s14*s34
     &     - 2.D0*s14*s24
     &     - 2.D0*s14**2
     &     - 8.D0*s13*s34
     &     + 16.D0*s13*s24
     &     + 4.D0*s13*s14
     &     - 2.D0*s13**2
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S12**(-2) * (
     &     + 4.D0*s24**2*s34
     &     - 8.D0*s23*s24*s34
     &     + 4.D0*s23*s24**2
     &     - 4.D0*s23**2*s24
     &     + 4.D0*s13*s24**2
     &     - 4.D0*s13*s23*s24
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S12**(-1)*S23**(-1) * (
     &     + 4.D0*s24*s34**2
     &     + 2.D0*s24**2*s34
     &     + 2.D0*s24**3
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 8.D0*s23*s24**2
     &     + 8.D0*s23**2*s24
     &     + 6.D0*s23**3
     &     + 8.D0*s13*s24**2
     &     + 10.D0*s13*s23**2
     &     - 8.D0*s13**2*s24
     &     + 10.D0*s13**2*s23
     &     + 6.D0*s13**3
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S12**(-1) * (
     &     - 16.D0*s34**2
     &     + 4.D0*s24*s34
     &     - 8.D0*s24**2
     &     - 2.D0*s23*s34
     &     - 12.D0*s23*s24
     &     - 12.D0*s23**2
     &     - 10.D0*s13*s34
     &     + 4.D0*s13*s24
     &     - 8.D0*s13*s23
     &     - 4.D0*s13**2
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S14**(-2) * (
     &     - 4.D0*s24*s34**2
     &     + 4.D0*s24**2*s34
     &     - 8.D0*s23*s24*s34
     &     + 4.D0*s23*s24**2
     &     - 4.D0*s13*s24*s34
     &     + 4.D0*s13*s24**2
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     + 4.D0*s34**3
     &     + 10.D0*s24*s34**2
     &     + 6.D0*s24**2*s34
     &     + 2.D0*s24**3
     &     + 2.D0*s13*s34**2
     &     + 8.D0*s13*s24*s34
     &     - 2.D0*s13**2*s34
     &     + 4.D0*s13**2*s24
     &     - 2.D0*s13**3
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S14**(-1)*S34**(-1) * (
     &     + 4.D0*s23*s24**2
     &     + 2.D0*s23**2*s24
     &     + 2.D0*s23**3
     &     + 4.D0*s13*s24**2
     &     - 4.D0*s13*s23*s24
     &     + 4.D0*s13*s23**2
     &     - 6.D0*s13**2*s24
     &     + 6.D0*s13**2*s23
     &     + 4.D0*s13**3
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S14**(-1) * (
     &     - 12.D0*s34**2
     &     - 14.D0*s24*s34
     &     - 8.D0*s24**2
     &     - 2.D0*s23*s34
     &     + 6.D0*s23*s24
     &     - 16.D0*s23**2
     &     - 8.D0*s13*s34
     &     - 10.D0*s13*s23
     &     - 4.D0*s13**2
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 10.D0*s34**2
     &     + 4.D0*s24*s34
     &     + 4.D0*s24**2
     &     + 2.D0*s14*s34
     &     + 2.D0*s14*s24
     &     + 2.D0*s14**2
     &     + 12.D0*s13*s34
     &     + 4.D0*s13**2
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2)*S34**(-1) * (
     &     + 4.D0*s23*s24
     &     + 6.D0*s23**2
     &     - 4.D0*s14*s23
     &     + 4.D0*s13*s24
     &     + 4.D0*s13*s23
     &     - 4.D0*s13*s14
     &     - 2.D0*s13**2
     &     )
      f40 = f40 + s124**(-1)*s1234**(-2) * (
     &     + 10.D0*s34
     &     - 12.D0*s24
     &     + 10.D0*s23
     &     + 4.D0*s13
     &     )
      f40 = f40 + s134**(-2)*s1234**(-2)*S14**(-2) * (
     &     + 2.D0*s24**2*s34**2
     &     + 4.D0*s23*s24*s34**2
     &     + 2.D0*s23**2*s34**2
     &     + 4.D0*s12*s24*s34**2
     &     + 4.D0*s12*s23*s34**2
     &     + 2.D0*s12**2*s34**2
     &     )
      f40 = f40 + s134**(-2)*s1234**(-2)*S14**(-1) * (
     &     + 4.D0*s24**2*s34
     &     + 8.D0*s23*s24*s34
     &     + 4.D0*s23**2*s34
     &     + 8.D0*s12*s24*s34
     &     + 8.D0*s12*s23*s34
     &     + 4.D0*s12**2*s34
     &     )
      f40 = f40 + s134**(-2)*s1234**(-2)*S34**(-2) * (
     &     + 2.D0*s14**2*s24**2
     &     + 4.D0*s14**2*s23*s24
     &     + 2.D0*s14**2*s23**2
     &     + 4.D0*s12*s14**2*s24
     &     + 4.D0*s12*s14**2*s23
     &     + 2.D0*s12**2*s14**2
     &     )
      f40 = f40 + s134**(-2)*s1234**(-2)*S34**(-1) * (
     &     + 4.D0*s14*s24**2
     &     + 8.D0*s14*s23*s24
     &     + 4.D0*s14*s23**2
     &     + 8.D0*s12*s14*s24
     &     + 8.D0*s12*s14*s23
     &     + 4.D0*s12**2*s14
     &     )
      f40 = f40 + s134**(-2)*s1234**(-2) * (
     &     + 6.D0*s24**2
     &     + 12.D0*s23*s24
     &     + 6.D0*s23**2
     &     + 12.D0*s12*s24
     &     + 12.D0*s12*s23
     &     + 6.D0*s12**2
     &     )
      f40 = f40 + s134**(-1)*s234**(-1)*s1234**(-2)*S14**(-1)*S23**(-1)
     &  * (
     &     + 2.D0*s34**4
     &     - 8.D0*s12*s34**3
     &     + 12.D0*s12**2*s34**2
     &     - 8.D0*s12**3*s34
     &     + 2.D0*s12**4
     &     )
      f40 = f40 + s134**(-1)*s234**(-1)*s1234**(-2)*S14**(-1) * (
     &     - 4.D0*s24*s34**2
     &     - 2.D0*s24**2*s34
     &     - 2.D0*s24**3
     &     - 4.D0*s12*s34**2
     &     + 4.D0*s12*s24*s34
     &     - 4.D0*s12*s24**2
     &     + 6.D0*s12**2*s34
     &     - 6.D0*s12**2*s24
     &     - 4.D0*s12**3
     &     )
      f40 = f40 + s134**(-1)*s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 4.D0*s34**3
     &     + 6.D0*s14*s34**2
     &     + 4.D0*s14**2*s34
     &     + 2.D0*s14**3
     &     - 12.D0*s12*s34**2
     &     - 12.D0*s12*s14*s34
     &     - 4.D0*s12*s14**2
     &     + 12.D0*s12**2*s34
     &     + 6.D0*s12**2*s14
     &     - 4.D0*s12**3
     &     )
      f40 = f40 + s134**(-1)*s234**(-1)*s1234**(-2)*S34**(-2) * (
     &     - 4.D0*s12**2*s14*s24
     &     )
      f40 = f40 + s134**(-1)*s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     - 8.D0*s12*s24**2
     &     - 8.D0*s12*s14*s24
     &     - 8.D0*s12*s14**2
     &     - 4.D0*s12**2*s24
     &     - 8.D0*s12**3
     &     )
      f40 = f40 + s134**(-1)*s234**(-1)*s1234**(-2) * (
     &     - 12.D0*s12*s34
     &     - 12.D0*s12*s24
     &     - 12.D0*s12*s14
     &     + 12.D0*s12**2
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S12**(-1)*S14**(-1) * (
     &     + 4.D0*s24*s34**2
     &     + 6.D0*s24**2*s34
     &     + 4.D0*s24**3
     &     + 4.D0*s23*s34**2
     &     + 4.D0*s23*s24*s34
     &     + 6.D0*s23*s24**2
     &     - 2.D0*s23**2*s34
     &     + 4.D0*s23**2*s24
     &     + 2.D0*s23**3
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 4.D0*s24**3
     &     + 2.D0*s23*s24**2
     &     - 2.D0*s23**2*s24
     &     - 2.D0*s23**3
     &     + 10.D0*s14*s24**2
     &     + 8.D0*s14*s23*s24
     &     + 4.D0*s14*s23**2
     &     + 6.D0*s14**2*s24
     &     + 2.D0*s14**3
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S12**(-1) * (
     &     + 4.D0*s34**2
     &     + 6.D0*s24*s34
     &     + 16.D0*s24**2
     &     + 20.D0*s23*s24
     &     + 8.D0*s23**2
     &     + 6.D0*s14*s34
     &     + 8.D0*s14*s24
     &     + 4.D0*s14**2
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S14**(-2) * (
     &     + 4.D0*s24*s34**2
     &     - 4.D0*s24**2*s34
     &     + 4.D0*s23*s34**2
     &     - 8.D0*s23*s24*s34
     &     + 4.D0*s12*s34**2
     &     - 4.D0*s12*s24*s34
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     + 8.D0*s24*s34**2
     &     + 8.D0*s24**2*s34
     &     + 6.D0*s24**3
     &     + 8.D0*s12*s34**2
     &     + 10.D0*s12*s24**2
     &     - 8.D0*s12**2*s34
     &     + 10.D0*s12**2*s24
     &     + 6.D0*s12**3
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S14**(-1) * (
     &     - 4.D0*s34**2
     &     + 4.D0*s24*s34
     &     - 6.D0*s24**2
     &     + 14.D0*s23*s34
     &     - 12.D0*s23*s24
     &     - 14.D0*s23**2
     &     + 12.D0*s12*s34
     &     - 8.D0*s12*s24
     &     - 14.D0*s12*s23
     &     - 6.D0*s12**2
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S23**(-1)*S34**(-1) * (
     &     + 4.D0*s24**3
     &     + 6.D0*s14*s24**2
     &     + 4.D0*s14**2*s24
     &     + 6.D0*s12*s24**2
     &     + 4.D0*s12*s14*s24
     &     + 4.D0*s12*s14**2
     &     + 4.D0*s12**2*s24
     &     - 2.D0*s12**2*s14
     &     + 2.D0*s12**3
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 12.D0*s24*s34
     &     + 12.D0*s24**2
     &     + 12.D0*s14*s24
     &     + 12.D0*s12*s34
     &     + 8.D0*s12*s24
     &     + 12.D0*s12*s14
     &     - 4.D0*s12**2
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S34**(-2) * (
     &     - 4.D0*s14*s24**2
     &     - 4.D0*s14*s23*s24
     &     + 4.D0*s14**2*s24
     &     + 4.D0*s14**2*s23
     &     - 8.D0*s12*s14*s24
     &     + 4.D0*s12*s14**2
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2)*S34**(-1) * (
     &     - 6.D0*s24**2
     &     - 8.D0*s23*s24
     &     - 6.D0*s23**2
     &     + 8.D0*s14*s24
     &     + 14.D0*s14*s23
     &     - 4.D0*s14**2
     &     - 12.D0*s12*s24
     &     - 14.D0*s12*s23
     &     + 12.D0*s12*s14
     &     - 14.D0*s12**2
     &     )
      f40 = f40 + s134**(-1)*s1234**(-2) * (
     &     - 12.D0*s34
     &     + 8.D0*s24
     &     + 32.D0*s23
     &     - 12.D0*s14
     &     + 28.D0*s12
     &     )
      f40 = f40 + s234**(-2)*s1234**(-2)*S23**(-2) * (
     &     + 2.D0*s14**2*s34**2
     &     + 4.D0*s13*s14*s34**2
     &     + 2.D0*s13**2*s34**2
     &     + 4.D0*s12*s14*s34**2
     &     + 4.D0*s12*s13*s34**2
     &     + 2.D0*s12**2*s34**2
     &     )
      f40 = f40 + s234**(-2)*s1234**(-2)*S23**(-1) * (
     &     + 4.D0*s14**2*s34
     &     + 8.D0*s13*s14*s34
     &     + 4.D0*s13**2*s34
     &     + 8.D0*s12*s14*s34
     &     + 8.D0*s12*s13*s34
     &     + 4.D0*s12**2*s34
     &     )
      f40 = f40 + s234**(-2)*s1234**(-2)*S34**(-2) * (
     &     + 2.D0*s14**2*s24**2
     &     + 4.D0*s13*s14*s24**2
     &     + 2.D0*s13**2*s24**2
     &     + 4.D0*s12*s14*s24**2
     &     + 4.D0*s12*s13*s24**2
     &     + 2.D0*s12**2*s24**2
     &     )
      f40 = f40 + s234**(-2)*s1234**(-2) * (
     &     + 4.D0*s14**2
     &     + 8.D0*s13*s14
     &     + 4.D0*s13**2
     &     + 8.D0*s12*s14
     &     + 8.D0*s12*s13
     &     + 4.D0*s12**2
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S12**(-1)*S23**(-1) * (
     &     + 4.D0*s14*s34**2
     &     - 2.D0*s14**2*s34
     &     + 2.D0*s14**3
     &     + 4.D0*s13*s34**2
     &     + 4.D0*s13*s14*s34
     &     + 4.D0*s13*s14**2
     &     + 6.D0*s13**2*s34
     &     + 6.D0*s13**2*s14
     &     + 4.D0*s13**3
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 8.D0*s14*s24**2
     &     + 8.D0*s14**2*s24
     &     + 6.D0*s14**3
     &     + 8.D0*s13*s24**2
     &     + 10.D0*s13*s14**2
     &     - 8.D0*s13**2*s24
     &     + 10.D0*s13**2*s14
     &     + 6.D0*s13**3
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S12**(-1) * (
     &     + 8.D0*s14*s34
     &     + 4.D0*s14*s24
     &     + 4.D0*s14**2
     &     + 8.D0*s13*s34
     &     + 4.D0*s13*s24
     &     + 8.D0*s13*s14
     &     + 4.D0*s13**2
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     + 8.D0*s13*s34**2
     &     + 8.D0*s13**2*s34
     &     + 6.D0*s13**3
     &     + 8.D0*s12*s34**2
     &     + 10.D0*s12*s13**2
     &     - 8.D0*s12**2*s34
     &     + 10.D0*s12**2*s13
     &     + 6.D0*s12**3
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S14**(-1)*S34**(-1) * (
     &     + 4.D0*s13*s24**2
     &     - 6.D0*s13**2*s24
     &     + 4.D0*s13**3
     &     + 4.D0*s12*s24**2
     &     - 4.D0*s12*s13*s24
     &     + 6.D0*s12*s13**2
     &     + 2.D0*s12**2*s24
     &     + 4.D0*s12**2*s13
     &     + 2.D0*s12**3
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S14**(-1) * (
     &     + 4.D0*s13*s34
     &     - 4.D0*s13*s24
     &     + 6.D0*s13**2
     &     + 4.D0*s12*s34
     &     - 4.D0*s12*s24
     &     + 4.D0*s12*s13
     &     - 2.D0*s12**2
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S23**(-2) * (
     &     + 4.D0*s14*s34**2
     &     + 4.D0*s13*s34**2
     &     - 8.D0*s13*s14*s34
     &     - 4.D0*s13**2*s34
     &     + 4.D0*s12*s34**2
     &     - 4.D0*s12*s13*s34
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     - 8.D0*s34**2
     &     + 12.D0*s14*s34
     &     - 16.D0*s14**2
     &     + 4.D0*s13*s34
     &     - 10.D0*s13*s14
     &     - 8.D0*s13**2
     &     + 20.D0*s12*s34
     &     - 10.D0*s12*s14
     &     - 12.D0*s12*s13
     &     - 12.D0*s12**2
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S34**(-2) * (
     &     + 4.D0*s14*s24**2
     &     - 4.D0*s14**2*s24
     &     + 4.D0*s13*s24**2
     &     - 4.D0*s13*s14*s24
     &     + 4.D0*s12*s24**2
     &     - 8.D0*s12*s14*s24
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     - 4.D0*s24**2
     &     - 6.D0*s14*s24
     &     - 6.D0*s14**2
     &     - 4.D0*s13*s14
     &     - 2.D0*s13**2
     &     + 4.D0*s12*s24
     &     - 6.D0*s12*s14
     &     - 12.D0*s12*s13
     &     - 14.D0*s12**2
     &     )
      f40 = f40 + s234**(-1)*s1234**(-2) * (
     &     - 4.D0*s34
     &     + 4.D0*s24
     &     + 22.D0*s14
     &     + 4.D0*s13
     &     + 24.D0*s12
     &     )
      f40 = f40 + s1234**(-2)*S12**(-2) * (
     &     + 2.D0*s24**2
     &     - 8.D0*s23*s24
     &     + 2.D0*s23**2
     &     )
      f40 = f40 + s1234**(-2)*S12**(-1)*S14**(-1)*S23**(-1)*S34**(-1)
     &  * (
     &     + 2.D0*s24**4
     &     + 4.D0*s13*s24**3
     &     + 6.D0*s13**2*s24**2
     &     + 4.D0*s13**3*s24
     &     + 2.D0*s13**4
     &     )
      f40 = f40 + s1234**(-2)*S12**(-1)*S14**(-1)*S23**(-1) * (
     &     + 2.D0*s34**3
     &     + 4.D0*s24*s34**2
     &     + 6.D0*s24**2*s34
     &     + 4.D0*s24**3
     &     + 4.D0*s13*s34**2
     &     + 12.D0*s13*s24*s34
     &     + 12.D0*s13*s24**2
     &     + 6.D0*s13**2*s34
     &     + 12.D0*s13**2*s24
     &     + 4.D0*s13**3
     &     )
      f40 = f40 + s1234**(-2)*S12**(-1)*S14**(-1)*S34**(-1) * (
     &     + 4.D0*s24**3
     &     + 6.D0*s23*s24**2
     &     + 4.D0*s23**2*s24
     &     + 2.D0*s23**3
     &     + 12.D0*s13*s24**2
     &     + 12.D0*s13*s23*s24
     &     + 4.D0*s13*s23**2
     &     + 12.D0*s13**2*s24
     &     + 6.D0*s13**2*s23
     &     + 4.D0*s13**3
     &     )
      f40 = f40 + s1234**(-2)*S12**(-1)*S14**(-1) * (
     &     + 12.D0*s34**2
     &     + 20.D0*s24*s34
     &     + 18.D0*s24**2
     &     + 6.D0*s23*s34
     &     + 20.D0*s23*s24
     &     + 12.D0*s23**2
     &     + 16.D0*s13*s34
     &     + 28.D0*s13*s24
     &     + 16.D0*s13*s23
     &     + 16.D0*s13**2
     &     )
      f40 = f40 + s1234**(-2)*S12**(-1)*S23**(-1)*S34**(-1) * (
     &     + 4.D0*s24**3
     &     + 6.D0*s14*s24**2
     &     + 4.D0*s14**2*s24
     &     + 2.D0*s14**3
     &     + 12.D0*s13*s24**2
     &     + 12.D0*s13*s14*s24
     &     + 4.D0*s13*s14**2
     &     + 12.D0*s13**2*s24
     &     + 6.D0*s13**2*s14
     &     + 4.D0*s13**3
     &     )
      f40 = f40 + s1234**(-2)*S12**(-1)*S23**(-1) * (
     &     + 8.D0*s34**2
     &     + 14.D0*s24*s34
     &     + 14.D0*s24**2
     &     + 8.D0*s14*s34
     &     + 18.D0*s14*s24
     &     + 10.D0*s14**2
     &     + 20.D0*s13*s34
     &     + 28.D0*s13*s24
     &     + 20.D0*s13*s14
     &     + 18.D0*s13**2
     &     )
      f40 = f40 + s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 12.D0*s24**2
     &     + 8.D0*s23*s24
     &     + 2.D0*s23**2
     &     + 8.D0*s14*s24
     &     + 4.D0*s14*s23
     &     + 2.D0*s14**2
     &     + 16.D0*s13*s24
     &     + 14.D0*s13*s23
     &     + 14.D0*s13*s14
     &     + 18.D0*s13**2
     &     )
      f40 = f40 + s1234**(-2)*S12**(-1) * (
     &     - 8.D0*s34
     &     + 22.D0*s24
     &     + 14.D0*s23
     &     - 4.D0*s14
     &     + 14.D0*s13
     &     )
      f40 = f40 + s1234**(-2)*S14**(-2) * (
     &     + 2.D0*s34**2
     &     - 8.D0*s24*s34
     &     + 2.D0*s24**2
     &     )
      f40 = f40 + s1234**(-2)*S14**(-1)*S23**(-1)*S34**(-1) * (
     &     + 4.D0*s24**3
     &     + 12.D0*s13*s24**2
     &     + 12.D0*s13**2*s24
     &     + 4.D0*s13**3
     &     + 6.D0*s12*s24**2
     &     + 12.D0*s12*s13*s24
     &     + 6.D0*s12*s13**2
     &     + 4.D0*s12**2*s24
     &     + 4.D0*s12**2*s13
     &     + 2.D0*s12**3
     &     )
      f40 = f40 + s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     + 4.D0*s34**2
     &     + 8.D0*s24*s34
     &     + 10.D0*s24**2
     &     + 8.D0*s13*s34
     &     + 26.D0*s13*s24
     &     + 10.D0*s13**2
     &     - 6.D0*s12*s34
     &     + 14.D0*s12*s24
     &     + 14.D0*s12*s13
     &     + 10.D0*s12**2
     &     )
      f40 = f40 + s1234**(-2)*S14**(-1)*S34**(-1) * (
     &     + 14.D0*s24**2
     &     + 14.D0*s23*s24
     &     + 8.D0*s23**2
     &     + 24.D0*s13*s24
     &     + 24.D0*s13*s23
     &     + 24.D0*s13**2
     &     + 14.D0*s12*s24
     &     + 12.D0*s12*s23
     &     + 24.D0*s12*s13
     &     + 8.D0*s12**2
     &     )
      f40 = f40 + s1234**(-2)*S14**(-1) * (
     &     + 14.D0*s34
     &     + 20.D0*s24
     &     - 8.D0*s23
     &     + 18.D0*s13
     &     )
      f40 = f40 + s1234**(-2)*S23**(-2) * (
     &     + 2.D0*s34**2
     &     - 8.D0*s13*s34
     &     + 2.D0*s13**2
     &     )
      f40 = f40 + s1234**(-2)*S23**(-1)*S34**(-1) * (
     &     + 18.D0*s24**2
     &     + 20.D0*s14*s24
     &     + 8.D0*s14**2
     &     + 28.D0*s13*s24
     &     + 14.D0*s13*s14
     &     + 14.D0*s13**2
     &     + 20.D0*s12*s24
     &     + 8.D0*s12*s14
     &     + 18.D0*s12*s13
     &     + 10.D0*s12**2
     &     )
      f40 = f40 + s1234**(-2)*S23**(-1) * (
     &     + 14.D0*s34
     &     + 10.D0*s24
     &     - 8.D0*s14
     &     + 20.D0*s13
     &     - 8.D0*s12
     &     )
      f40 = f40 + s1234**(-2)*S34**(-2) * (
     &     + 2.D0*s24**2
     &     - 8.D0*s14*s24
     &     + 2.D0*s14**2
     &     )
      f40 = f40 + s1234**(-2)*S34**(-1) * (
     &     + 18.D0*s24
     &     + 14.D0*s14
     &     + 18.D0*s13
     &     - 8.D0*s12
     &     )
      f40 = f40 + s1234**(-2) * (
     &     + 42.D0
     &     )

      f40 = f40 + 2d0*s1234**(-2)*s12**(-2)*s34**(-2) * (
     &    (s14*s23-s13*s24)**2)
      f40 = f40 + 2d0*s1234**(-2)*s14**(-2)*s23**(-2) * (
     &    (s13*s24-s12*s34)**2)


      FullF40=f40
*      write(*,*)"FullF40",FullF40


      return
      end

************************************************************************
