      function D40a2(i1,i3,i4,i5,ipset)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(j1=1,j2=2,j3=3,j4=4,j5=5)

      ipass=1

      D40a2 = 1d0/2d0*D40l(i1,i3,i4,i5,ipset)
     .     +FullA40(i1,i3,i4,i5,ipset)-1d0/2d0*FullEt40(i1,i3,i4,i5,ipset)

      call pmap6to5ff(1,2,i1,i3,i4,i5,j1,j2,j3,j4,j5,ipass)
      D40a2 = D40a2
     .     + FullA30FF(i1,i3,i4,ipset)*
     .       (S30(j3,j4,j5,ipset-1)-FullE30FF(j3,j4,j5,ipset-1)-Q30(j3,j5,j4,ipset-1))

      call pmap6to5ff(1,2,i3,i4,i5,i1,j1,j2,j3,j4,j5,ipass)
      D40a2 = D40a2
     .     + 1d0/2d0*FullA30FF(i3,i4,i5,ipset)*(S30(j5,j4,j3,ipset-1)-R30(j5,j4,j3,ipset-1))
     .     - FullE30FF(i5,i4,i3,ipset)*Q30(j5,j3,j4,ipset-1)

      return
      end
***********************************************************************
      function D40c2(i1,i3,i5,i4,ipset)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(j1=1,j2=2,j3=3,j4=4,j5=5)

      ipass=1

      D40c2 = At40a(i1,i3,i5,i4,ipset)-FullE40(i1,i5,i4,i3,ipset)
     .     + FullB40(i1,i5,i4,i3,ipset)+FullC40(i1,i4,i5,i3,ipset)

      call pmap6to5ff(1,2,i1,i3,i4,i5,j1,j2,j3,j4,j5,ipass)
      D40c2 = D40c2 + FullA30FF(i1,i3,i4,ipset)*FullE30FF(j3,j4,j5,ipset-1)
     .     + a30FF(i1,i3,i4,ipset)*Q30(j3,j5,j4,ipset-1)

      call pmap6to5ff(1,2,i3,i4,i5,i1,j1,j2,j3,j4,j5,ipass)
      D40c2 = D40c2 + FullE30FF(i3,i4,i5,ipset)*Q30(j5,j4,j3,ipset-1)

      call pmap6to5ff(1,2,i4,i5,i1,i3,j1,j2,j3,j4,j5,ipass)
      D40c2 = D40c2 + a30FF(i4,i5,i1,ipset)*Q30(j4,j5,j3,ipset-1)

      return
      end
***********************************************************************
* D40l finite antenna
      function D40l(i1,i3,i4,i5,ipset)
      use KinData_mod
      implicit real*8(a-h,o-z)
      parameter(j1=1,j2=2,j3=3,j4=4,j5=5)

      ipass=1

      D40l = FullD40(i1,i3,i4,i5,ipset)-FullA40(i1,i3,i4,i5,ipset)-FullA40(i1,i5,i4,i3,ipset)
     .     +1d0/2d0*(FullEt40(i1,i3,i4,i5,ipset)+FullEt40(i1,i5,i4,i3,ipset))
     .     -FullAt40(i1,i3,i5,i4,ipset)
     .     +FullE40(i1,i5,i4,i3,ipset)-FullB40(i1,i5,i4,i3,ipset)-FullC40(i1,i4,i5,i3,ipset)
     .     +FullE40(i1,i3,i4,i5,ipset)-FullB40(i1,i3,i4,i5,ipset)-FullC40(i1,i4,i3,i5,ipset)

      call pmap6to5FF(1,2,i1,i3,i4,i5,j1,j2,j3,j4,j5,ipass)
      D40l = D40l - FullA30FF(i1,i3,i4,ipset)*S30(j3,j4,j5,ipset-1)

      call pmap6to5FF(1,2,i1,i5,i4,i3,j1,j2,j3,j4,j5,ipass)
      D40l = D40l - FullA30FF(i1,i5,i4,ipset)*S30(j3,j4,j5,ipset-1)

      call pmap6to5FF(1,2,i3,i4,i5,i1,j1,j2,j3,j4,j5,ipass)
      D40l = D40l - FullA30FF(i3,i4,i5,ipset)*S30(j5,j4,j3,ipset-1)

      return
      end

**********************************************************
      function Q30(i1,i2,i3,ipset)
      use KinData_mod
      implicit real*8(a-h,o-z)

      Q30 = d30FF(i1,i2,i3,ipset)-FullA30FF(i1,i2,i3,ipset)

      return
      end
**********************************************************
      function R30(i1,i2,i3,ipset)
      use KinData_mod
      implicit real*8(a-h,o-z)

      R30 = Q30(i1,i2,i3,ipset)-Q30(i1,i3,i2,ipset)

      return
      end
**********************************************************
      function S30(i1,i2,i3,ipset)
      use KinData_mod
      implicit real*8(a-h,o-z)

      S30 = Q30(i1,i2,i3,ipset)+Q30(i1,i3,i2,ipset)+FullE30FF(i1,i2,i3,ipset)

      return
      end
**********************************************************
* a30FF(i1,i2,i3,ipset) sub-antenna i.e. for i2 soft

      function a30FF(i1,i2,i3,ipset)
      use KinData_mod
      implicit double precision (a-h,o-z)
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      a30FF=s23/s12+2d0*s13*s123/s12/(s12+s23)
      a30FF=a30FF/s123
*      write(*,*)" a30FF ",a30FF
      return
      end
