      subroutine VVdebug(x1,x2)

      implicit double precision (a-h,o-z)
      dimension GII(8,2),GIIdiff(8)
      dimension PLI1(11),PLI1diff(11)
      dimension PLI2(30),PLI2diff(30)
      dimension PLI3(30),PLI3diff(30)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)
      parameter(dli2one=1.6449340668482264365d0)
      parameter(dli2mone=-.82246703342411321826d0)
      parameter(dli2half=0.58224052646501250592d0)
      parameter(dli3one=1.2020569031595942854d0)
      parameter(dli3mone=-.90154267736969571405d0)
      parameter(dli3half=0.53721319360804020089d0)

      write(*,*)" in VVdebug = ", x1,x2

      opx1 = 1.d0+x1
      omx1 = 1.d0-x1
      opx2 = 1.d0+x2
      omx2 = 1.d0-x2
      x1px2 = x1+x2
      x1mx2 = x1-x2
      omx1x2 = 1d0-x1*x2
      opx1x2 = 1d0+x1*x2

      PLI1(1)=log(x1)
      PLI1(2)=log(x2)
      PLI1(3)=log(omx1)
      PLI1(4)=log(omx2)
      PLI1(5)=log(opx1)-rln2
      PLI1(6)=log(opx2)-rln2
      PLI1(7)=log(x1px2)-(log(opx1)+log(opx2)-rln2)
      PLI1(8)=log(opx1x2)-rln2
      PLI1(9)=log(omx1x2)

      PLI2(1)=dli2(x1)-(dli2one)
      PLI2(2)=dli2(x2)-(dli2one)
      PLI2(3)=dli2(-x1)-(dli2mone)
      PLI2(4)=dli2(-x2)-(dli2mone)
      PLI2(5)=dli2(omx1/2d0)
      PLI2(6)=dli2(omx2/2d0)
      PLI2(7)=dli2(x1/opx1)-(dli2half)
      PLI2(8)=dli2(x2/opx2)-(dli2half)
      PLI2(9)=dli2(-omx1/x1px2)
      PLI2(10)=dli2(-omx2/x1px2)
      PLI2(11)=dli2(opx1*omx1/opx1x2)
      PLI2(12)=dli2(opx2*omx2/opx1x2)
      PLI2(13)=dli2(x1*opx2/opx1)
      PLI2(14)=dli2(x2*opx1/opx2)
      PLI2(15)=dli2(-x1/x2)
      PLI2(16)=dli2(-x2/x1)
      PLI2(17)=dli2(omx1x2)
      PLI2(18)=dli2(x1mx2/opx1)
      PLI2(19)=dli2(-x1mx2/opx2)
      PLI2(20)=dli2(x1mx2/x1px2)
      PLI2(21)=dli2(-x1mx2/x1px2)

      PLI3(1)=dli3(x1)-(dli3one)
      PLI3(2)=dli3(x2)-(dli3one)
      PLI3(3)=dli3(-x1)-(dli3mone)
      PLI3(4)=dli3(-x2)-(dli3mone)
      PLI3(5)=dli3(omx1)
      PLI3(6)=dli3(omx2)
      PLI3(7)=dli3(1d0/opx1)-(dli3half)
      PLI3(8)=dli3(1d0/opx2)-(dli3half)
      PLI3(9)=dli3(omx1/2d0)
      PLI3(10)=dli3(omx2/2d0)
      PLI3(11)=dli3(opx1/2d0)-(dli3one)
      PLI3(12)=dli3(opx2/2d0)-(dli3one)
      PLI3(13)=dli3(2d0*x1/opx1)-(dli3one)
      PLI3(14)=dli3(2d0*x2/opx2)-(dli3one)
*      PLI3(15)=dli3(-omx1/2d0/x1)
*      PLI3(16)=dli3(-omx2/2d0/x2)
      PLI3(15)=dli3(omx1/opx1)
      PLI3(16)=dli3(omx2/opx2)

      GII(1,1) = g23b(x1)
      GII(1,2) = g23b(x2)
      GII(2,1) = g23c(x1)
      GII(2,2) = g23c(x2)
      GII(3,1) = g13(x1,x2)
      GII(3,2) = g13(x2,x1)
      GII(4,1) = g14(x1,x2)
      GII(4,2) = g14(x2,x1)
      GII(5,1) = g22(x1,x2)
      GII(5,2) = g22(x2,x1)
      GII(6,1) = g23(x1,x2)
      GII(6,2) = g23(x2,x1)
      GII(7,1) = g24(x1,x2)
      GII(7,2) = g24(x2,x1)
      GII(8,1) = g25(x1,x2)
      GII(8,2) = g25(x2,x1)

      do i=1,11
      write(*,*)" PLI1(",i,") = ",PLI1(i)
      enddo
      do i=1,21
      write(*,*)" PLI2(",i,") = ",PLI2(i)
      enddo
      do i=1,16
      write(*,*)" PLI3(",i,") = ",PLI3(i)
      enddo
      do i=1,8
      write(*,*)" GII(",i,") = ",GII(i,1),GII(i,2)
      enddo

      return
      end



