***************************************************
*     An amplitude storage element for 4q1g
*     contributions to ZJ processes. For now
*     this is process dependent but in principle we
*     could extend this to support other processes
*     we're attaching this to the pstoreflag
*
      module astore
      implicit none

      type ampstore
      logical :: exists = .false.
      complex*16 :: zA1(2,2,2,2)
      complex*16 :: zA2(2,2,2,2)
      complex*16 :: zB3(2,2,2,2)
      complex*16 :: zB4(2,2,2,2)
      end type ampstore

      type (ampstore) zampstore(7,7,7,7,7)
!$omp threadprivate(zampstore)
      save zampstore

      logical :: qampflag = .false.
!$omp threadprivate(qampflag)
      save qampflag

      contains

      subroutine aflush
      implicit none
      logical pstoreflag
      integer ipsid
      common /pstore/pstoreflag,ipsid

      if ((pstoreflag).and.(qampflag)) zampstore%exists = .false.

      end subroutine aflush

      subroutine addamp(i1,i2,i3,i4,i5,zampA1,zampA2,zampB3,zampB4)
      implicit none
      integer i1,i2,i3,i4,i5
      logical pstoreflag
      integer ipsid
      common /pstore/pstoreflag,ipsid
      complex*16 :: zampA1(2,2,2,2)
      complex*16 :: zampA2(2,2,2,2)
      complex*16 :: zampB3(2,2,2,2)
      complex*16 :: zampB4(2,2,2,2)

      if(pstoreflag)then
         qampflag = .true.

         zampstore(i1,i2,i3,i4,i5)%exists=.true.
         zampstore(i1,i2,i3,i4,i5)%zA1=zampA1
         zampstore(i1,i2,i3,i4,i5)%zA2=zampA2
         zampstore(i1,i2,i3,i4,i5)%zB3=zampB3
         zampstore(i1,i2,i3,i4,i5)%zB4=zampB4
      endif

      end subroutine addamp

      subroutine checkamp(i1,i2,i3,i4,i5,exists,
     &  zampA1,zampA2,zampB3,zampB4)
      implicit none
      integer i1,i2,i3,i4,i5
      logical exists
      logical pstoreflag
      integer ipsid
      common /pstore/pstoreflag,ipsid
      complex*16 :: zampA1(2,2,2,2)
      complex*16 :: zampA2(2,2,2,2)
      complex*16 :: zampB3(2,2,2,2)
      complex*16 :: zampB4(2,2,2,2)

      if(.not.pstoreflag)then
         exists=.false.
         return
      endif

      exists = zampstore(i1,i2,i3,i4,i5)%exists

      if(exists)then
         zampA1=zampstore(i1,i2,i3,i4,i5)%zA1
         zampA2=zampstore(i1,i2,i3,i4,i5)%zA2
         zampB3=zampstore(i1,i2,i3,i4,i5)%zB3
         zampB4=zampstore(i1,i2,i3,i4,i5)%zB4
      endif

      end subroutine checkamp


      end module astore
