**********************************************
* Calculates the relavent electroweak constants for the q qbar -> g + Z/gamma* processes
* nflav is an integer corresponding to the quark flavour, s is the invariant of the two electrons (necessary for off-shell calculations)
*
* NOTE: THIS SUBROUTINE ONLY WORKS WITH ONE QQBAR PAIR. For two q qbar pairs, see the subroutine eweakZ2qq
*

      subroutine eweakW1qq(nflav1,nflav2,s)
      use Parameters_mod, only : width_V_scheme_param
      implicit none
      integer, intent(in) :: nflav1, nflav2
      double precision :: prop, emw, ewwidth, amz, stw, ewfac
      double precision, intent(in) :: s
      common /Wmass/ emw,ewwidth
      common /eweakW/ amz,stw,ewfac
!$omp threadprivate(/eweakW/)
      
      if(amz.eq.0d0)then ! check if parameters have not been initialised
         print*, "you forgot to call initeweak, doing it now..."
         call initeweak
      endif

      if (width_V_scheme_param().eq.-4) then      ! Energy dependent W width
         !> Eqns 1.6, 1.7 in http://www.sciencedirect.com/science/article/pii/0370269388916279
         prop = s**2/((s-emw**2)**2+(s*ewwidth/emw)**2)
      else
         prop = s**2/((s-emw**2)**2+(emw*ewwidth)**2)
      endif

      ewfac = prop
      return
      end




