************************************************************************
*
      function rJ21QQFFqgam_frag_ho(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ieord)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use PhotonFragmentation_mod, only : iz_frag
      implicit double precision (a-h,o-z)
      integer, intent(in) :: ieord
      integer ielocal
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFFqgam_frag_ho: only imethod=2!' 
      endif

      ielocal=ieord

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      em2=0d0
      em1=0d0
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      izz=iz_frag
      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 / omzo * zo / 0.2D1 - dla / omz1 / omz2 /
     # omzo + dla / omz1 / omz2 / omzo / zo - dls / omz1 / omz2 / omzo *
     # zo / 0.2D1 + dls / omz1 / omz2 / omzo - dls / omz1 / omz2 / omzo 
     #/ zo - 0.1D1 / omz1 / omz2 / omzo * zo / 0.4D1 + rH1(0, zo) / omz1
     # / omz2 / omzo * zo / 0.2D1 - rH1(1, zo) / omz1 / omz2 / omzo * zo
     # / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo - rH1(0, zo) / omz1 / omz2 /
     # omzo + rH1(1, zo) / omz1 / omz2 / omzo - 0.3D1 / 0.4D1 / omz1 / o
     #mz2 / omzo / zo + rH1(0, zo) / omz1 / omz2 / omzo / zo - rH1(1, zo
     #) / omz1 / omz2 / omzo / zo
      if(ielocal.eq.1)then
      em1 = 0.3D1 / 0.4D1 * rH1(0, zo) / omz1 / omz2 / omzo / zo + dls 
     #/ omz1 / omz2 / omzo - 0.11D2 / 0.8D1 / omz1 / omz2 / omzo * zo + 
     #rH1(0, zo) * dls / omz1 / omz2 / omzo * zo / 0.2D1 - rH1(1, zo) * 
     #dls / omz1 / omz2 / omzo * zo / 0.2D1 + rH1(1, zo) * dls / omz1 / 
     #omz2 / omzo - rH1(1, zo) * dls / omz1 / omz2 / omzo / zo + rH1(1, 
     #zo) * rH1(0, zo) / omz1 / omz2 / omzo * zo / 0.2D1 - rH1(1, zo) **
     # 2 / omz1 / omz2 / omzo / zo / 0.2D1 + 0.5D1 / 0.24D2 / omz1 / omz
     #2 / omzo * pi ** 2 * zo + 0.5D1 / 0.12D2 / omz1 / omz2 / omzo * pi
     # ** 2 / zo - 0.1D1 / omz1 / omz2 / omzo * zo * rH1(0, zo) ** 2 / 0
     #.4D1 - rH1(1, zo) ** 2 / omz1 / omz2 / omzo * zo / 0.4D1 - rH1(1, 
     #zo) * rH1(0, zo) / omz1 / omz2 / omzo - 0.1D1 / omz1 / omz2 / omzo
     # / zo * rH1(0, zo) ** 2 / 0.2D1 - rH1(0, zo) * dls / omz1 / omz2 /
     # omzo + dla ** 2 / omz1 / omz2 / omzo * zo / 0.4D1 + dla ** 2 / om
     #z1 / omz2 / omzo / zo / 0.2D1 - dls ** 2 / omz1 / omz2 / omzo * zo
     # / 0.4D1 - dls ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 - 0.5D1 / 0.
     #12D2 / omz1 / omz2 / omzo * pi ** 2 + 0.1D1 / omz1 / omz2 / omzo *
     # rH1(0, zo) ** 2 / 0.2D1 + rH1(1, zo) ** 2 / omz1 / omz2 / omzo / 
     #0.2D1 + dls ** 2 / omz1 / omz2 / omzo / 0.2D1 - dla ** 2 / omz1 / 
     #omz2 / omzo / 0.2D1 - 0.19D2 / 0.8D1 / omz1 / omz2 / omzo / zo - r
     #H1(0, zo) / omz1 / omz2 / omzo - dls / omz1 / omz2 / omzo * zo / 0
     #.4D1 - 0.3D1 / 0.4D1 * dls / omz1 / omz2 / omzo / zo + rH1(0, zo) 
     #/ omz1 / omz2 / omzo * zo / 0.4D1 - rH1(1, zo) / omz1 / omz2 / omz
     #o * zo / 0.4D1 + rH1(1, zo) / omz1 / omz2 / omzo - 0.3D1 / 0.4D1 *
     # rH1(1, zo) / omz1 / omz2 / omzo / zo + 0.5D1 / 0.2D1 / omz1 / omz
     #2 / omzo + rH1(0, zo) * dls / omz1 / omz2 / omzo / zo + rH1(1, zo)
     # * rH1(0, zo) / omz1 / omz2 / omzo / zo
      elseif(ielocal.eq.2)then
      em2 = 0.19D2 / 0.8D1 * rH1(0, zo) / omz1 / omz2 / omzo / zo + 0.5
     #D1 / 0.2D1 * dls / omz1 / omz2 / omzo - 0.65D2 / 0.16D2 / omz1 / o
     #mz2 / omzo * zo + rH1(1, zo) * rH1(0, zo) * dls / omz1 / omz2 / om
     #zo / zo - 0.5D1 / 0.12D2 * rH1(1, zo) / omz1 / omz2 / omzo * pi **
     # 2 + 0.19D2 / 0.6D1 / omz1 / omz2 / omzo * zeta3 * zo + 0.19D2 / 0
     #.3D1 / omz1 / omz2 / omzo * zeta3 / zo + 0.1D1 / omz1 / omz2 / omz
     #o * zo * rH1(0, zo) ** 3 / 0.12D2 - rH1(1, zo) ** 3 / omz1 / omz2 
     #/ omzo * zo / 0.12D2 + rH1(1, zo) / omz1 / omz2 / omzo * rH1(0, zo
     #) ** 2 / 0.2D1 - rH1(1, zo) ** 2 * rH1(0, zo) / omz1 / omz2 / omzo
     # / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 3 / 0.6
     #D1 - rH1(1, zo) ** 3 / omz1 / omz2 / omzo / zo / 0.6D1 + 0.5D1 / 0
     #.12D2 * rH1(0, zo) / omz1 / omz2 / omzo * pi ** 2 - 0.5D1 / 0.12D2
     # * dls / omz1 / omz2 / omzo * pi ** 2 + dls / omz1 / omz2 / omzo *
     # rH1(0, zo) ** 2 / 0.2D1 + rH1(1, zo) ** 2 * dls / omz1 / omz2 / o
     #mzo / 0.2D1 - rH1(0, zo) * dls ** 2 / omz1 / omz2 / omzo / 0.2D1 +
     # rH1(1, zo) * dls ** 2 / omz1 / omz2 / omzo / 0.2D1 + dla ** 3 / o
     #mz1 / omz2 / omzo * zo / 0.12D2 + dla ** 3 / omz1 / omz2 / omzo / 
     #zo / 0.6D1 - dls ** 3 / omz1 / omz2 / omzo * zo / 0.12D2 - dls ** 
     #3 / omz1 / omz2 / omzo / zo / 0.6D1 - rH1(1, zo) / omz1 / omz2 / o
     #mzo / zo * rH1(0, zo) ** 2 / 0.2D1 + rH1(1, zo) ** 2 * rH1(0, zo) 
     #/ omz1 / omz2 / omzo / zo / 0.2D1 - rH1(1, zo) ** 2 * dls / omz1 /
     # omz2 / omzo / zo / 0.2D1 - 0.5D1 / 0.24D2 * rH1(0, zo) / omz1 / o
     #mz2 / omzo * pi ** 2 * zo + 0.5D1 / 0.24D2 * rH1(1, zo) / omz1 / o
     #mz2 / omzo * pi ** 2 * zo - 0.5D1 / 0.12D2 * rH1(0, zo) / omz1 / o
     #mz2 / omzo * pi ** 2 / zo + 0.5D1 / 0.12D2 * rH1(1, zo) / omz1 / o
     #mz2 / omzo * pi ** 2 / zo - rH1(1, zo) / omz1 / omz2 / omzo * zo *
     # rH1(0, zo) ** 2 / 0.4D1 + rH1(1, zo) ** 2 * rH1(0, zo) / omz1 / o
     #mz2 / omzo * zo / 0.4D1 + rH1(0, zo) * dls ** 2 / omz1 / omz2 / om
     #zo / zo / 0.2D1 - rH1(1, zo) * dls ** 2 / omz1 / omz2 / omzo / zo 
     #/ 0.2D1 + 0.5D1 / 0.24D2 * dls / omz1 / omz2 / omzo * pi ** 2 * zo
     # + 0.5D1 / 0.12D2 * dls / omz1 / omz2 / omzo * pi ** 2 / zo - dls 
     #/ omz1 / omz2 / omzo * zo * rH1(0, zo) ** 2 / 0.4D1 - rH1(1, zo) *
     #* 2 * dls / omz1 / omz2 / omzo * zo / 0.4D1 - rH1(1, zo) * rH1(0, 
     #zo) * dls / omz1 / omz2 / omzo - dls / omz1 / omz2 / omzo / zo * r
     #H1(0, zo) ** 2 / 0.2D1 + rH1(0, zo) * dls ** 2 / omz1 / omz2 / omz
     #o * zo / 0.4D1 - rH1(1, zo) * dls ** 2 / omz1 / omz2 / omzo * zo /
     # 0.4D1 + rH1(0, zo) * dls / omz1 / omz2 / omzo * zo / 0.4D1 - rH1(
     #1, zo) * dls / omz1 / omz2 / omzo * zo / 0.4D1 + rH1(1, zo) * dls 
     #/ omz1 / omz2 / omzo - 0.3D1 / 0.4D1 * rH1(1, zo) * dls / omz1 / o
     #mz2 / omzo / zo + rH1(1, zo) * rH1(0, zo) / omz1 / omz2 / omzo * z
     #o / 0.4D1 - 0.3D1 / 0.8D1 * rH1(1, zo) ** 2 / omz1 / omz2 / omzo /
     # zo + 0.5D1 / 0.48D2 / omz1 / omz2 / omzo * pi ** 2 * zo + 0.5D1 /
     # 0.16D2 / omz1 / omz2 / omzo * pi ** 2 / zo - 0.1D1 / omz1 / omz2 
     #/ omzo * zo * rH1(0, zo) ** 2 / 0.8D1 - rH1(1, zo) ** 2 / omz1 / o
     #mz2 / omzo * zo / 0.8D1 - rH1(1, zo) * rH1(0, zo) / omz1 / omz2 / 
     #omzo - 0.3D1 / 0.8D1 / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 2 -
     # rH1(0, zo) * dls / omz1 / omz2 / omzo - dls ** 2 / omz1 / omz2 / 
     #omzo * zo / 0.8D1 - 0.3D1 / 0.8D1 * dls ** 2 / omz1 / omz2 / omzo 
     #/ zo - 0.19D2 / 0.3D1 / omz1 / omz2 / omzo * zeta3 - 0.1D1 / omz1 
     #/ omz2 / omzo * rH1(0, zo) ** 3 / 0.6D1 + rH1(1, zo) ** 3 / omz1 /
     # omz2 / omzo / 0.6D1 + dls ** 3 / omz1 / omz2 / omzo / 0.6D1 - dla
     # ** 3 / omz1 / omz2 / omzo / 0.6D1 - 0.5D1 / 0.12D2 / omz1 / omz2 
     #/ omzo * pi ** 2 + 0.1D1 / omz1 / omz2 / omzo * rH1(0, zo) ** 2 / 
     #0.2D1 + rH1(1, zo) ** 2 / omz1 / omz2 / omzo / 0.2D1 + dls ** 2 / 
     #omz1 / omz2 / omzo / 0.2D1 - 0.113D3 / 0.16D2 / omz1 / omz2 / omzo
     # / zo - 0.5D1 / 0.2D1 * rH1(0, zo) / omz1 / omz2 / omzo - 0.11D2 /
     # 0.8D1 * dls / omz1 / omz2 / omzo * zo - 0.19D2 / 0.8D1 * dls / om
     #z1 / omz2 / omzo / zo + 0.11D2 / 0.8D1 * rH1(0, zo) / omz1 / omz2 
     #/ omzo * zo - 0.11D2 / 0.8D1 * rH1(1, zo) / omz1 / omz2 / omzo * z
     #o + 0.5D1 / 0.2D1 * rH1(1, zo) / omz1 / omz2 / omzo - 0.19D2 / 0.8
     #D1 * rH1(1, zo) / omz1 / omz2 / omzo / zo + 0.31D2 / 0.4D1 / omz1 
     #/ omz2 / omzo + rH1(1, zo) * rH1(0, zo) * dls / omz1 / omz2 / omzo
     # * zo / 0.2D1 + 0.3D1 / 0.4D1 * rH1(0, zo) * dls / omz1 / omz2 / o
     #mzo / zo + 0.3D1 / 0.4D1 * rH1(1, zo) * rH1(0, zo) / omz1 / omz2 /
     # omzo / zo
      endif
      endif

      if(ielocal.eq.-2)then
        rJ21QQFFqgam_frag_ho=e2
      elseif(ielocal.eq.-1)then
        rJ21QQFFqgam_frag_ho=e1
      elseif(ielocal.eq.0)then
        rJ21QQFFqgam_frag_ho=e0
      elseif(ielocal.eq.1)then
        rJ21QQFFqgam_frag_ho=em1
      elseif(ielocal.eq.2)then
        rJ21QQFFqgam_frag_ho=em2
      endif

*      write(*,*)" rJ21QQFFqgam_frag_ho ",rJ21QQFFqgam_frag_ho

      return
      end
************************************************************************
*
      function rJ21QQFFqgam_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFFqgam_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QQFFqgam_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 / omzo * zo / 0.2D1 - dla / omz1 / omz2 /
     # omzo + dla / omz1 / omz2 / omzo / zo - dls / omz1 / omz2 / omzo *
     # zo / 0.2D1 + dls / omz1 / omz2 / omzo - dls / omz1 / omz2 / omzo 
     #/ zo - 0.1D1 / omz1 / omz2 / omzo * zo / 0.4D1 + rH1(0, zo) / omz1
     # / omz2 / omzo * zo / 0.2D1 - rH1(1, zo) / omz1 / omz2 / omzo * zo
     # / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo - rH1(0, zo) / omz1 / omz2 /
     # omzo + rH1(1, zo) / omz1 / omz2 / omzo - 0.3D1 / 0.4D1 / omz1 / o
     #mz2 / omzo / zo + rH1(0, zo) / omz1 / omz2 / omzo / zo - rH1(1, zo
     #) / omz1 / omz2 / omzo / zo
      endif

      if(ieorder.eq.-2)then
        rJ21QQFFqgam_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QQFFqgam_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QQFFqgam_frag_gen=e0
      endif

*      write(*,*)" rJ21QQFFqgam_frag_gen ",rJ21QQFFqgam_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QQFFqgam_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFFqgam_frag = rJ21QQFFqgam_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QQFFqgam_frag

C---- wrapper 2
      function rJ21QQFFqgam_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFFqgam_frag2 = rJ21QQFFqgam_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QQFFqgam_frag2

************************************************************************
*
      function rJ21QQFFqbq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFFqbq_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QQFFqbq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.3D1 / 0.2D1 / omz1 / omz2 / om
     #zo
      e0 = -0.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d0
     #z * dls + 0.3D1 / 0.4D1 / omz1 / omz2 * d0z - 0.1D1 / omz1 / omz2 
     #* d1z - rH1(1, zo) / omz1 / omz2 / omzo * dla + 0.3D1 / 0.4D1 * dl
     #a / omz1 / omz2 / omzo + dls ** 2 / omz1 / omz2 / omzo / 0.2D1 + r
     #H1(1, zo) * dls / omz1 / omz2 / omzo + 0.3D1 / 0.4D1 * dls / omz1 
     #/ omz2 / omzo + 0.19D2 / 0.8D1 / omz1 / omz2 / omzo - 0.5D1 / 0.12
     #D2 / omz1 / omz2 / omzo * pi ** 2 + 0.1D1 / omz1 / omz2 / omzo * r
     #H2(1, 1, zo) + 0.3D1 / 0.4D1 * rH1(1, zo) / omz1 / omz2 / omzo
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z * dla - 0.1D1 / omz1 / omz2 * d0z
     # * dls - 0.3D1 / 0.4D1 / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2 *
     # d1z - dla / omz1 / omz2 / 0.2D1 - z * dla / omz1 / omz2 / 0.2D1 +
     # dls / omz1 / omz2 / 0.2D1 + z * dls / omz1 / omz2 / 0.2D1 + 0.1D1
     # / omz1 / omz2 * z / 0.4D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1 +
     # rH1(1, z) / omz1 / omz2 * z / 0.2D1 + 0.3D1 / 0.4D1 / omz1 / omz2
     # - 0.1D1 / omz1 / omz2 * rH1(0, z) / 0.2D1 + rH1(1, z) / omz1 / om
     #z2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(0, z) / omz
      endif

      if(ieorder.eq.-2)then
        rJ21QQFFqbq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QQFFqbq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QQFFqbq_frag_gen=e0
      endif

*      write(*,*)" rJ21QQFFqbq_frag_gen ",rJ21QQFFqbq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QQFFqbq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFFqbq_frag = rJ21QQFFqbq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QQFFqbq_frag

C---- wrapper 2
      function rJ21QQFFqbq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFFqbq_frag2 = rJ21QQFFqbq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QQFFqbq_frag2

************************************************************************
*
      function rJ21GQFFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQFFgq_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GQFFgq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 / omz1 / omz2 / om
     #zo
      e0 = -0.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d0
     #z * dls + 0.11D2 / 0.12D2 / omz1 / omz2 * d0z - 0.1D1 / omz1 / omz
     #2 * d1z - rH1(1, zo) / omz1 / omz2 / omzo * dla + 0.3D1 / 0.4D1 * 
     #dla / omz1 / omz2 / omzo + dls ** 2 / omz1 / omz2 / omzo / 0.2D1 +
     # rH1(1, zo) * dls / omz1 / omz2 / omzo + 0.11D2 / 0.12D2 * dls / o
     #mz1 / omz2 / omzo + 0.67D2 / 0.24D2 / omz1 / omz2 / omzo - 0.5D1 /
     # 0.12D2 / omz1 / omz2 / omzo * pi ** 2 + 0.11D2 / 0.12D2 * rH1(1, 
     #zo) / omz1 / omz2 / omzo + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, 
     #zo)
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z * dla - 0.1D1 / omz1 / omz2 * d0z
     # * dls - 0.11D2 / 0.12D2 / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2
     # * d1z - dla / omz1 / omz2 / 0.2D1 - z * dla / omz1 / omz2 / 0.2D1
     # + dls / omz1 / omz2 / 0.2D1 + z * dls / omz1 / omz2 / 0.2D1 + 0.1
     #D1 / omz1 / omz2 * z / 0.3D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1
     # + rH1(1, z) / omz1 / omz2 * z / 0.2D1 + 0.29D2 / 0.24D2 / omz1 / 
     #omz2 - 0.1D1 / omz1 / omz2 * rH1(0, z) / 0.2D1 + rH1(1, z) / omz1 
     #/ omz2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(0, z) / omz
      endif

      if(ieorder.eq.-2)then
        rJ21GQFFgq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GQFFgq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GQFFgq_frag_gen=e0
      endif

*      write(*,*)" rJ21GQFFgq_frag_gen ",rJ21GQFFgq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GQFFgq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQFFgq_frag = rJ21GQFFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GQFFgq_frag

C---- wrapper 2
      function rJ21GQFFgq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQFFgq_frag2 = rJ21GQFFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GQFFgq_frag2

************************************************************************
*
      function rJ21hQGFFqqp_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hQGFFqqp_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21hQGFFqqp_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 / 0.4D1 - z * dla / omz1 / omz2 / 0.2D1 +
     # z ** 2 * dla / omz1 / omz2 / 0.2D1 - dls / omz1 / omz2 / 0.4D1 + 
     #z * dls / omz1 / omz2 / 0.2D1 - z ** 2 * dls / omz1 / omz2 / 0.2D1
     # - 0.17D2 / 0.12D2 / omz1 / omz2 * z ** 2 + rH1(0, z) / omz1 / omz
     #2 * z ** 2 / 0.2D1 - rH1(1, z) / omz1 / omz2 * z ** 2 / 0.2D1 + 0.
     #17D2 / 0.12D2 / omz1 / omz2 * z - rH1(0, z) / omz1 / omz2 * z / 0.
     #2D1 + rH1(1, z) / omz1 / omz2 * z / 0.2D1 - 0.3D1 / 0.8D1 / omz1 /
     # omz2 + 0.1D1 / omz1 / omz2 * rH1(0, z) / 0.4D1 - rH1(1, z) / omz1
     # / omz2 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        rJ21hQGFFqqp_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21hQGFFqqp_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21hQGFFqqp_frag_gen=e0
      endif

*      write(*,*)" rJ21hQGFFqqp_frag_gen ",rJ21hQGFFqqp_frag_gen

      return
      end

C---- wrapper 1
      function rJ21hQGFFqqp_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hQGFFqqp_frag = rJ21hQGFFqqp_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21hQGFFqqp_frag

C---- wrapper 2
      function rJ21hQGFFqqp_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hQGFFqqp_frag2 = rJ21hQGFFqqp_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21hQGFFqqp_frag2

************************************************************************
*
      function rJ21hGQFFqpq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGQFFqpq_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21hGQFFqpq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / omzo / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 * d0z / 0.6D1 - dls / omz1 / omz2 / om
     #zo / 0.6D1 - rH1(1, zo) / omz1 / omz2 / omzo / 0.6D1 - 0.11D2 / 0.
     #24D2 / omz1 / omz2 / omzo
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / omz1 / omz2 / 0.24D2 + 0.1D1 / omz1 / omz2 * d0z /
     # 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGQFFqpq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21hGQFFqpq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21hGQFFqpq_frag_gen=e0
      endif

*      write(*,*)" rJ21hGQFFqpq_frag_gen ",rJ21hGQFFqpq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21hGQFFqpq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGQFFqpq_frag = rJ21hGQFFqpq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21hGQFFqpq_frag

C---- wrapper 2
      function rJ21hGQFFqpq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGQFFqpq_frag2 = rJ21hGQFFqpq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21hGQFFqpq_frag2

************************************************************************
*
      function rJ21hGGFFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGGFFgq_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21hGGFFgq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 / 0.2D1 - z * dla / omz1 / omz2 + z ** 2 
     #* dla / omz1 / omz2 - dls / omz1 / omz2 / 0.2D1 + z * dls / omz1 /
     # omz2 - z ** 2 * dls / omz1 / omz2 - 0.17D2 / 0.6D1 / omz1 / omz2 
     #* z ** 2 + rH1(0, z) / omz1 / omz2 * z ** 2 - rH1(1, z) / omz1 / o
     #mz2 * z ** 2 + 0.17D2 / 0.6D1 / omz1 / omz2 * z - rH1(0, z) / omz1
     # / omz2 * z + rH1(1, z) / omz1 / omz2 * z - 0.11D2 / 0.12D2 / omz1
     # / omz2 + rH1(0, z) / omz1 / omz2 / 0.2D1 - rH1(1, z) / omz1 / omz
     #2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGFFgq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGFFgq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21hGGFFgq_frag_gen=e0
      endif

*      write(*,*)" rJ21hGGFFgq_frag_gen ",rJ21hGGFFgq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21hGGFFgq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGFFgq_frag = rJ21hGGFFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21hGGFFgq_frag

C---- wrapper 2
      function rJ21hGGFFgq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGFFgq_frag2 = rJ21hGGFFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21hGGFFgq_frag2

************************************************************************
*
      function rJ21QQFFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFFqg_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QQFFqg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = z * dla / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 + dla / o
     #mz1 / omz2 / z - z * dls / omz1 / omz2 / 0.2D1 + dls / omz1 / omz2
     # - dls / omz1 / omz2 / z - 0.1D1 / omz1 / omz2 * z / 0.4D1 + rH1(0
     #, z) / omz1 / omz2 * z / 0.2D1 - rH1(1, z) / omz1 / omz2 * z / 0.2
     #D1 + 0.1D1 / omz1 / omz2 - rH1(0, z) / omz1 / omz2 + rH1(1, z) / o
     #mz1 / omz2 - 0.3D1 / 0.4D1 / omz1 / omz2 / z + rH1(0, z) / omz1 / 
     #omz2 / z - rH1(1, z) / omz1 / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QQFFqg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QQFFqg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QQFFqg_frag_gen=e0
      endif

*      write(*,*)" rJ21QQFFqg_frag_gen ",rJ21QQFFqg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QQFFqg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFFqg_frag = rJ21QQFFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QQFFqg_frag

C---- wrapper 2
      function rJ21QQFFqg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFFqg_frag2 = rJ21QQFFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QQFFqg_frag2

************************************************************************
*
      function rJ21QGFFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGFFqg_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QGFFqg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = 0.1D1 / omz1 / omz2 / omzo * dls + 0.5D1 / 0.3D1 / omz1 / o
     #mz2 / omzo
      e0 = -0.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d0
     #z * dls + 0.3D1 / 0.4D1 / omz1 / omz2 * d0z - 0.1D1 / omz1 / omz2 
     #* d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.11D2 / 0
     #.12D2 / omz1 / omz2 / omzo * dla + 0.1D1 / omz1 / omz2 / omzo * dl
     #s ** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dls + 0
     #.3D1 / 0.4D1 / omz1 / omz2 / omzo * dls + 0.19D2 / 0.8D1 / omz1 / 
     #omz2 / omzo - 0.5D1 / 0.12D2 * pi ** 2 / omz1 / omz2 / omzo + 0.3D
     #1 / 0.4D1 / omz1 / omz2 / omzo * rH1(1, zo) + 0.1D1 / omz1 / omz2 
     #/ omzo * rH2(1, 1, zo)
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 / z - dls / omz1 / omz2 / z - rH1(1, z) /
     # omz1 / omz2 / z + 0.1D1 / omz1 / omz2 * d0z * dla - 0.2D1 * dla /
     # omz1 / omz2 + 0.2D1 * dls / omz1 / omz2 + 0.11D2 / 0.6D1 / omz1 /
     # omz2 * z ** 2 - 0.11D2 / 0.6D1 / omz1 / omz2 * z - 0.2D1 * rH1(0,
     # z) / omz1 / omz2 + 0.2D1 * rH1(1, z) / omz1 / omz2 - 0.3D1 / 0.4D
     #1 / omz1 / omz2 * d0z + rH1(0, z) / omz1 / omz2 / z + z * dla / om
     #z1 / omz2 + z ** 2 * dls / omz1 / omz2 + rH1(1, z) / omz1 / omz2 *
     # z ** 2 + rH1(0, z) / omz1 / omz2 * z + 0.1D1 / omz1 / omz2 * d1z 
     #- 0.1D1 / omz1 / omz2 * d0z * dls - 0.3D1 / 0.4D1 / omz1 / omz2 / 
     #z + rH1(0, z) / omz1 / omz2 / omz - z ** 2 * dla / omz1 / omz2 - z
     # * dls / omz1 / omz2 - rH1(0, z) / omz1 / omz2 * z ** 2 - rH1(1, z
     #) / omz1 / omz2 * z + 0.19D2 / 0.6D1 / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21QGFFqg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QGFFqg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QGFFqg_frag_gen=e0
      endif

*      write(*,*)" rJ21QGFFqg_frag_gen ",rJ21QGFFqg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QGFFqg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGFFqg_frag = rJ21QGFFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QGFFqg_frag

C---- wrapper 2
      function rJ21QGFFqg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGFFqg_frag2 = rJ21QGFFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QGFFqg_frag2

************************************************************************
*
      function rJ21QGFFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGFFgg_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QGFFgg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = z * dla / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 + dla / o
     #mz1 / omz2 / z - z * dls / omz1 / omz2 / 0.2D1 + dls / omz1 / omz2
     # - dls / omz1 / omz2 / z - 0.1D1 / omz1 / omz2 * z / 0.3D1 + rH1(0
     #, z) / omz1 / omz2 * z / 0.2D1 - rH1(1, z) / omz1 / omz2 * z / 0.2
     #D1 + 0.37D2 / 0.24D2 / omz1 / omz2 - rH1(0, z) / omz1 / omz2 + rH1
     #(1, z) / omz1 / omz2 - 0.11D2 / 0.12D2 / omz1 / omz2 / z + rH1(0, 
     #z) / omz1 / omz2 / z - rH1(1, z) / omz1 / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QGFFgg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QGFFgg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QGFFgg_frag_gen=e0
      endif

*      write(*,*)" rJ21QGFFgg_frag_gen ",rJ21QGFFgg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QGFFgg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGFFgg_frag = rJ21QGFFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QGFFgg_frag

C---- wrapper 2
      function rJ21QGFFgg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGFFgg_frag2 = rJ21QGFFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QGFFgg_frag2

************************************************************************
*
      function rJ21GGFFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGFFgg_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GGFFgg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = 0.1D1 / omz1 / omz2 / omzo * dls + 0.11D2 / 0.6D1 / omz1 / 
     #omz2 / omzo
      e0 = -0.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d0
     #z * dls + 0.11D2 / 0.12D2 / omz1 / omz2 * d0z - 0.1D1 / omz1 / omz
     #2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.11D2 /
     # 0.12D2 / omz1 / omz2 / omzo * dla + 0.1D1 / omz1 / omz2 / omzo * 
     #dls ** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dls +
     # 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * dls + 0.67D2 / 0.24D2 / om
     #z1 / omz2 / omzo - 0.5D1 / 0.12D2 * pi ** 2 / omz1 / omz2 / omzo +
     # 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * rH1(1, zo) + 0.1D1 / omz1 
     #/ omz2 / omzo * rH2(1, 1, zo)
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 / z - dls / omz1 / omz2 / z - rH1(1, z) /
     # omz1 / omz2 / z + 0.1D1 / omz1 / omz2 * d0z * dla - dla / omz1 / 
     #omz2 * z ** 2 + dls / omz1 / omz2 * z ** 2 - rH1(0, z) / omz1 / om
     #z2 * z ** 2 - 0.2D1 * dla / omz1 / omz2 + 0.2D1 * dls / omz1 / omz
     #2 - 0.11D2 / 0.6D1 / omz1 / omz2 * z - 0.2D1 * rH1(0, z) / omz1 / 
     #omz2 + 0.2D1 * rH1(1, z) / omz1 / omz2 - 0.11D2 / 0.12D2 / omz1 / 
     #omz2 * d0z + 0.11D2 / 0.6D1 / omz1 / omz2 * z ** 2 + rH1(0, z) / o
     #mz1 / omz2 / z + z * dla / omz1 / omz2 + rH1(0, z) / omz1 / omz2 *
     # z + rH1(1, z) / omz1 / omz2 * z ** 2 + rH1(0, z) / omz1 / omz2 / 
     #omz + 0.1D1 / omz1 / omz2 * d1z - 0.1D1 / omz1 / omz2 * d0z * dls 
     #- 0.11D2 / 0.12D2 / omz1 / omz2 / z - z * dls / omz1 / omz2 - rH1(
     #1, z) / omz1 / omz2 * z + 0.19D2 / 0.6D1 / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21GGFFgg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GGFFgg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GGFFgg_frag_gen=e0
      endif

*      write(*,*)" rJ21GGFFgg_frag_gen ",rJ21GGFFgg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GGFFgg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGFFgg_frag = rJ21GGFFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GGFFgg_frag

C---- wrapper 2
      function rJ21GGFFgg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGFFgg_frag2 = rJ21GGFFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GGFFgg_frag2

************************************************************************
*
      function rJ21hGGFFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGGFFqg_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21hGGFFqg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / omzo / 0.3D1
      e0 = -0.1D1 / omz1 / omz2 * d0z / 0.3D1 - 0.1D1 / omz1 / omz2 / 
     #omzo * dls / 0.3D1 - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) / 0.3
     #D1 - 0.11D2 / 0.12D2 / omz1 / omz2 / omzo
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z / 0.3D1 - 0.1D1 / omz1 / omz2 / 0
     #.6D1 - 0.1D1 / omz1 / omz2 * z / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGFFqg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGFFqg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21hGGFFqg_frag_gen=e0
      endif

*      write(*,*)" rJ21hGGFFqg_frag_gen ",rJ21hGGFFqg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21hGGFFqg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGFFqg_frag = rJ21hGGFFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21hGGFFqg_frag

C---- wrapper 2
      function rJ21hGGFFqg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGFFqg_frag2 = rJ21hGGFFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21hGGFFqg_frag2

************************************************************************
*
      function rJ21hGGFFg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGGFFg_frag_gen: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21hGGFFg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / omzo / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 / omzo * dla / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGFFg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGFFg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21hGGFFg_frag_gen=e0
      endif

*      write(*,*)" rJ21hGGFFg_frag_gen ",rJ21hGGFFg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21hGGFFg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGFFg_frag = rJ21hGGFFg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21hGGFFg_frag

C---- wrapper 2
      function rJ21hGGFFg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGFFg_frag2 = rJ21hGGFFg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21hGGFFg_frag2

