************************************************************************
*
      function rJ21QQFIqgam_frag_ho(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ieord)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use PhotonFragmentation_mod, only : iz_frag
      implicit double precision (a-h,o-z)
      integer, intent(in) :: ieord
      integer ielocal
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFIqgam_frag_ho: only imethod=2!' 
      endif

      ielocal=ieord

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QQFIqgam_frag_ho=rJ21QQIFqgam_frag_ho(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ieord)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      em2=0d0
      em1=0d0
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      izz=iz_frag
      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 / omzo * zo / 0.2D1 + d0x2 / omz1 / omzo - d0x
     #2 / omz1 / omzo / zo + dla / omz1 / omz2 / omzo * zo / 0.2D1 - dla
     # / omz1 / omz2 / omzo + dla / omz1 / omz2 / omzo / zo - dls / omz1
     # / omz2 / omzo * zo / 0.2D1 + dls / omz1 / omz2 / omzo - dls / omz
     #1 / omz2 / omzo / zo + zo / omz1 / omz2 / omzo / 0.2D1 + rH1(0, zo
     #) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(1, z2) * zo / omz1 / omz
     #2 / omzo / 0.2D1 - rH1(1, zo) * zo / omz1 / omz2 / omzo / 0.2D1 - 
     #rH1(0, zo) / omz1 / omz2 / omzo + rH1(1, z2) / omz1 / omz2 / omzo 
     #+ rH1(1, zo) / omz1 / omz2 / omzo + rH1(0, zo) / omz1 / omz2 / omz
     #o / zo - rH1(1, z2) / omz1 / omz2 / omzo / zo - rH1(1, zo) / omz1 
     #/ omz2 / omzo / zo
      if(ielocal.eq.1)then
      em1 = -0.1D1 / omz1 / omz2 / omzo * pi ** 2 / 0.12D2 + 0.1D1 / om
     #z1 / omz2 / omzo * rH1(0, zo) ** 2 / 0.2D1 + rH1(1, zo) ** 2 / omz
     #1 / omz2 / omzo / 0.2D1 - dla ** 2 / omz1 / omz2 / omzo / 0.2D1 + 
     #dls ** 2 / omz1 / omz2 / omzo / 0.2D1 - rH1(0, zo) * d0x2 / omz1 /
     # omzo + d1x2 / omz1 / omzo * zo / 0.2D1 + d1x2 / omz1 / omzo / zo 
     #+ d0x2 * dls / omz1 / omzo + d0x2 / omz1 / omzo * zo / 0.2D1 + rH1
     #(1, z2) * rH1(0, zo) / omz1 / omz2 / omzo / zo + rH1(1, zo) * rH1(
     #0, zo) / omz1 / omz2 / omzo / zo + rH1(0, zo) * dls / omz1 / omz2 
     #/ omzo / zo - d1x2 / omz1 / omzo - 0.1D1 / omz1 / omz2 / omzo / zo
     # * rH1(0, zo) ** 2 / 0.2D1 - rH2(1, 1, z2) / omz1 / omz2 / omzo / 
     #zo - rH1(1, zo) ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 + 0.1D1 / o
     #mz1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + 0.1D1 / omz1 / omz2 / 
     #omzo * pi ** 2 / zo / 0.12D2 - zo / omz1 / omz2 / omzo * rH1(0, zo
     #) ** 2 / 0.4D1 - rH2(1, 1, z2) * zo / omz1 / omz2 / omzo / 0.2D1 -
     # rH1(1, zo) ** 2 * zo / omz1 / omz2 / omzo / 0.4D1 - rH1(1, z2) * 
     #rH1(0, zo) / omz1 / omz2 / omzo - rH1(1, zo) * rH1(0, zo) / omz1 /
     # omz2 / omzo + rH2(1, 1, z2) / omz1 / omz2 / omzo - rH1(0, zo) * d
     #ls / omz1 / omz2 / omzo + dla ** 2 / omz1 / omz2 / omzo * zo / 0.4
     #D1 + dla ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 - dls ** 2 / omz1 
     #/ omz2 / omzo * zo / 0.4D1 - dls ** 2 / omz1 / omz2 / omzo / zo / 
     #0.2D1 + rH1(0, zo) * d0x2 / omz1 / omzo * zo / 0.2D1 - rH1(1, zo) 
     #* d0x2 / omz1 / omzo * zo / 0.2D1 + rH1(1, zo) * d0x2 / omz1 / omz
     #o - rH1(1, zo) * d0x2 / omz1 / omzo / zo - d0x2 * dls / omz1 / omz
     #o * zo / 0.2D1 - d0x2 * dls / omz1 / omzo / zo - rH1(0, zo) * zo /
     # omz1 / omz2 / omzo / 0.2D1 + rH1(1, z2) * zo / omz1 / omz2 / omzo
     # / 0.2D1 + rH1(1, zo) * zo / omz1 / omz2 / omzo / 0.2D1 + dls / om
     #z1 / omz2 / omzo * zo / 0.2D1 + rH1(1, z2) * rH1(0, zo) * zo / omz
     #1 / omz2 / omzo / 0.2D1 + rH1(1, zo) * rH1(0, zo) * zo / omz1 / om
     #z2 / omzo / 0.2D1 - rH1(1, zo) * rH1(1, z2) * zo / omz1 / omz2 / o
     #mzo / 0.2D1 + rH1(1, zo) * rH1(1, z2) / omz1 / omz2 / omzo - rH1(1
     #, zo) * rH1(1, z2) / omz1 / omz2 / omzo / zo + rH1(0, zo) * dls / 
     #omz1 / omz2 / omzo * zo / 0.2D1 - rH1(1, z2) * dls / omz1 / omz2 /
     # omzo * zo / 0.2D1 - rH1(1, zo) * dls / omz1 / omz2 / omzo * zo / 
     #0.2D1 + rH1(1, z2) * dls / omz1 / omz2 / omzo + rH1(1, zo) * dls /
     # omz1 / omz2 / omzo - rH1(1, z2) * dls / omz1 / omz2 / omzo / zo -
     # rH1(1, zo) * dls / omz1 / omz2 / omzo / zo + rH1(0, zo) * d0x2 / 
     #omz1 / omzo / zo
      elseif(ielocal.eq.2)then
      em2 = d0x2 * dls ** 2 / omz1 / omzo / 0.2D1 - d1x2 / omz1 / omzo 
     #* zo / 0.2D1 + rH2(1, 1, z2) * rH1(0, zo) / omz1 / omz2 / omzo / z
     #o + rH1(1, zo) * rH1(1, z2) * rH1(0, zo) * zo / omz1 / omz2 / omzo
     # / 0.2D1 + rH1(1, z2) * rH1(0, zo) * dls / omz1 / omz2 / omzo * zo
     # / 0.2D1 + rH1(1, zo) * rH1(0, zo) * dls / omz1 / omz2 / omzo * zo
     # / 0.2D1 - rH1(1, zo) * rH1(1, z2) * dls / omz1 / omz2 / omzo * zo
     # / 0.2D1 + rH1(1, zo) * rH1(1, z2) * dls / omz1 / omz2 / omzo - rH
     #1(1, zo) * rH1(1, z2) * dls / omz1 / omz2 / omzo / zo + rH1(1, zo)
     # * rH1(0, zo) * d0x2 / omz1 / omzo / zo + rH1(0, zo) * d0x2 * dls 
     #/ omz1 / omzo / zo + rH1(1, zo) * rH1(1, z2) * rH1(0, zo) / omz1 /
     # omz2 / omzo / zo + rH1(1, z2) * rH1(0, zo) * dls / omz1 / omz2 / 
     #omzo / zo + rH1(1, zo) * rH1(0, zo) * dls / omz1 / omz2 / omzo / z
     #o - d0x2 / omz1 / omzo * pi ** 2 / 0.12D2 + rH1(1, zo) ** 2 * d0x2
     # / omz1 / omzo / 0.2D1 + rH1(0, zo) ** 2 * d0x2 / omz1 / omzo / 0.
     #2D1 - d1x2 * dls / omz1 / omzo - rH1(1, zo) * d1x2 / omz1 / omzo -
     # d2x2 / omz1 / omzo * zo / 0.4D1 - d2x2 / omz1 / omzo / zo / 0.2D1
     # - dla ** 3 / omz1 / omz2 / omzo / 0.6D1 + dls ** 3 / omz1 / omz2 
     #/ omzo / 0.6D1 - rH1(1, zo) ** 3 * zo / omz1 / omz2 / omzo / 0.12D
     #2 - rH3(1, 1, 1, z2) * zo / omz1 / omz2 / omzo / 0.2D1 + rH1(1, z2
     #) / omz1 / omz2 / omzo * rH1(0, zo) ** 2 / 0.2D1 + rH1(1, zo) / om
     #z1 / omz2 / omzo * rH1(0, zo) ** 2 / 0.2D1 - rH2(1, 1, z2) * rH1(0
     #, zo) / omz1 / omz2 / omzo - rH1(1, zo) ** 2 * rH1(0, zo) / omz1 /
     # omz2 / omzo / 0.2D1 + rH1(1, zo) ** 2 * rH1(1, z2) / omz1 / omz2 
     #/ omzo / 0.2D1 + rH3(1, 1, 1, z2) / omz1 / omz2 / omzo + 0.1D1 / o
     #mz1 / omz2 / omzo / zo * rH1(0, zo) ** 3 / 0.6D1 - rH1(1, zo) ** 3
     # / omz1 / omz2 / omzo / zo / 0.6D1 - rH3(1, 1, 1, z2) / omz1 / omz
     #2 / omzo / zo + rH1(1, zo) ** 3 / omz1 / omz2 / omzo / 0.6D1 - 0.1
     #D1 / omz1 / omz2 / omzo * rH1(0, zo) ** 3 / 0.6D1 - 0.1D1 / omz1 /
     # omz2 / omzo * zeta3 / 0.3D1 + d2x2 / omz1 / omzo / 0.2D1 - rH1(1,
     # zo) / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 2 / 0.2D1 + rH1(1, 
     #zo) ** 2 * rH1(0, zo) / omz1 / omz2 / omzo / zo / 0.2D1 - rH1(1, z
     #o) ** 2 * rH1(1, z2) / omz1 / omz2 / omzo / zo / 0.2D1 - rH2(1, 1,
     # z2) * rH1(1, zo) / omz1 / omz2 / omzo / zo - rH1(0, zo) / omz1 / 
     #omz2 / omzo * pi ** 2 / zo / 0.12D2 + rH1(1, z2) / omz1 / omz2 / o
     #mzo * pi ** 2 / zo / 0.12D2 + rH1(1, zo) / omz1 / omz2 / omzo * pi
     # ** 2 / zo / 0.12D2 - rH1(1, z2) * zo / omz1 / omz2 / omzo * rH1(0
     #, zo) ** 2 / 0.4D1 - rH1(1, zo) * zo / omz1 / omz2 / omzo * rH1(0,
     # zo) ** 2 / 0.4D1 + rH2(1, 1, z2) * rH1(0, zo) * zo / omz1 / omz2 
     #/ omzo / 0.2D1 + rH1(1, zo) ** 2 * rH1(0, zo) * zo / omz1 / omz2 /
     # omzo / 0.4D1 - rH1(1, zo) ** 2 * rH1(1, z2) * zo / omz1 / omz2 / 
     #omzo / 0.4D1 - rH2(1, 1, z2) * rH1(1, zo) * zo / omz1 / omz2 / omz
     #o / 0.2D1 - rH1(1, zo) * rH1(1, z2) * rH1(0, zo) / omz1 / omz2 / o
     #mzo + rH2(1, 1, z2) * rH1(1, zo) / omz1 / omz2 / omzo - rH1(1, z2)
     # / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 2 / 0.2D1 - dls / omz1 
     #/ omz2 / omzo / zo * rH1(0, zo) ** 2 / 0.2D1 - rH2(1, 1, z2) * dls
     # / omz1 / omz2 / omzo / zo - rH1(1, zo) ** 2 * dls / omz1 / omz2 /
     # omzo / zo / 0.2D1 - rH1(0, zo) / omz1 / omz2 / omzo * pi ** 2 * z
     #o / 0.24D2 + rH1(1, z2) / omz1 / omz2 / omzo * pi ** 2 * zo / 0.24
     #D2 + rH1(1, zo) / omz1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + dls
     # / omz1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + dls / omz1 / omz2 
     #/ omzo * pi ** 2 / zo / 0.12D2 - dls / omz1 / omz2 / omzo * zo * r
     #H1(0, zo) ** 2 / 0.4D1 - rH2(1, 1, z2) * dls / omz1 / omz2 / omzo 
     #* zo / 0.2D1 - rH1(1, zo) ** 2 * dls / omz1 / omz2 / omzo * zo / 0
     #.4D1 - rH1(1, z2) * rH1(0, zo) * dls / omz1 / omz2 / omzo - rH1(1,
     # zo) * rH1(0, zo) * dls / omz1 / omz2 / omzo + rH2(1, 1, z2) * dls
     # / omz1 / omz2 / omzo + rH1(0, zo) * dls ** 2 / omz1 / omz2 / omzo
     # * zo / 0.4D1 - rH1(1, z2) * dls ** 2 / omz1 / omz2 / omzo * zo / 
     #0.4D1 - rH1(1, zo) * dls ** 2 / omz1 / omz2 / omzo * zo / 0.4D1 + 
     #rH1(0, zo) * dls ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 - rH1(1, z
     #2) * dls ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 - rH1(1, zo) * dls
     # ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 + rH1(1, zo) * d1x2 / omz1
     # / omzo / zo + rH1(0, zo) * d0x2 * dls / omz1 / omzo * zo / 0.2D1 
     #- rH1(1, zo) * d0x2 * dls / omz1 / omzo * zo / 0.2D1 + rH1(1, zo) 
     #* d0x2 * dls / omz1 / omzo - rH1(1, zo) * d0x2 * dls / omz1 / omzo
     # / zo + rH1(1, zo) * rH1(0, zo) * d0x2 / omz1 / omzo * zo / 0.2D1 
     #+ rH1(0, zo) / omz1 / omz2 / omzo * pi ** 2 / 0.12D2 - rH1(1, z2) 
     #/ omz1 / omz2 / omzo * pi ** 2 / 0.12D2 - rH1(1, zo) / omz1 / omz2
     # / omzo * pi ** 2 / 0.12D2 + 0.1D1 / omz1 / omz2 / omzo * zeta3 * 
     #zo / 0.6D1 + 0.1D1 / omz1 / omz2 / omzo * zeta3 / zo / 0.3D1 + zo 
     #/ omz1 / omz2 / omzo * rH1(0, zo) ** 3 / 0.12D2 + dls / omz1 / omz
     #2 / omzo * rH1(0, zo) ** 2 / 0.2D1 + rH1(1, zo) ** 2 * dls / omz1 
     #/ omz2 / omzo / 0.2D1 - rH1(0, zo) * dls ** 2 / omz1 / omz2 / omzo
     # / 0.2D1 + rH1(1, z2) * dls ** 2 / omz1 / omz2 / omzo / 0.2D1 + rH
     #1(1, zo) * dls ** 2 / omz1 / omz2 / omzo / 0.2D1 - dls / omz1 / om
     #z2 / omzo * pi ** 2 / 0.12D2 - dls ** 3 / omz1 / omz2 / omzo * zo 
     #/ 0.12D2 - dls ** 3 / omz1 / omz2 / omzo / zo / 0.6D1 + dla ** 3 /
     # omz1 / omz2 / omzo * zo / 0.12D2 + dla ** 3 / omz1 / omz2 / omzo 
     #/ zo / 0.6D1 - rH1(0, zo) * d1x2 / omz1 / omzo * zo / 0.2D1 + rH1(
     #1, zo) * d1x2 / omz1 / omzo * zo / 0.2D1 + rH1(0, zo) * d1x2 / omz
     #1 / omzo - rH1(0, zo) * d1x2 / omz1 / omzo / zo + d1x2 * dls / omz
     #1 / omzo * zo / 0.2D1 + d1x2 * dls / omz1 / omzo / zo + d0x2 / omz
     #1 / omzo * pi ** 2 * zo / 0.24D2 + d0x2 / omz1 / omzo * pi ** 2 / 
     #zo / 0.12D2 - d0x2 / omz1 / omzo * zo * rH1(0, zo) ** 2 / 0.4D1 - 
     #rH1(1, zo) ** 2 * d0x2 / omz1 / omzo * zo / 0.4D1 - rH1(1, zo) * r
     #H1(0, zo) * d0x2 / omz1 / omzo - rH1(1, zo) ** 2 * d0x2 / omz1 / o
     #mzo / zo / 0.2D1 - rH1(0, zo) ** 2 * d0x2 / omz1 / omzo / zo / 0.2
     #D1 - rH1(0, zo) * d0x2 * dls / omz1 / omzo - d0x2 * dls ** 2 / omz
     #1 / omzo * zo / 0.4D1 - d0x2 * dls ** 2 / omz1 / omzo / zo / 0.2D1
     # - 0.1D1 / omz1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + zo / omz1 
     #/ omz2 / omzo * rH1(0, zo) ** 2 / 0.4D1 + rH2(1, 1, z2) * zo / omz
     #1 / omz2 / omzo / 0.2D1 + rH1(1, zo) ** 2 * zo / omz1 / omz2 / omz
     #o / 0.4D1 + dls ** 2 / omz1 / omz2 / omzo * zo / 0.4D1 - rH1(0, zo
     #) * d0x2 / omz1 / omzo * zo / 0.2D1 + rH1(1, zo) * d0x2 / omz1 / o
     #mzo * zo / 0.2D1 + d0x2 * dls / omz1 / omzo * zo / 0.2D1 - rH1(1, 
     #z2) * rH1(0, zo) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(1, zo) * 
     #rH1(0, zo) * zo / omz1 / omz2 / omzo / 0.2D1 + rH1(1, zo) * rH1(1,
     # z2) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(0, zo) * dls / omz1 /
     # omz2 / omzo * zo / 0.2D1 + rH1(1, z2) * dls / omz1 / omz2 / omzo 
     #* zo / 0.2D1 + rH1(1, zo) * dls / omz1 / omz2 / omzo * zo / 0.2D1
      endif
      endif
      if(ix.eq.2.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 / omzo * zo / 0.2D1 - d0x2 / omz1 / omzo + d0x2
     # / omz1 / omzo / zo + 0.1D1 / omz1 / omzo + (-0.1D1 / 0.2D1 - x2 /
     # 0.2D1) / omz1 / omzo / zo
      if(ielocal.eq.1)then
      em1 = dls / omz1 / omzo - rH1(0, zo) / omz1 / omzo + rH1(0, zo) *
     # d0x2 / omz1 / omzo - d1x2 / omz1 / omzo * zo / 0.2D1 - d1x2 / omz
     #1 / omzo / zo - d0x2 * dls / omz1 / omzo - d0x2 / omz1 / omzo * zo
     # / 0.2D1 + (x2 / 0.2D1 - 0.1D1 / 0.2D1) / omz1 / omzo / zo + (0.1D
     #1 / 0.2D1 + x2 / 0.2D1) * rH1(0, zo) / omz1 / omzo / zo + (-0.1D1 
     #/ 0.2D1 - x2 / 0.2D1) * rH1(0, x2) / omz1 / omzo / zo + (-0.1D1 / 
     #0.2D1 - x2 / 0.2D1) * rH1(1, x2) / omz1 / omzo / zo + (-0.1D1 / 0.
     #2D1 - x2 / 0.2D1) * rH1(1, zo) / omz1 / omzo / zo + rH1(0, x2) / o
     #mx2 / omz1 / omzo * zo / 0.2D1 + rH1(0, x2) / omz1 / omzo + rH1(1,
     # x2) / omz1 / omzo + rH1(1, zo) / omz1 / omzo - rH1(0, x2) / omx2 
     #/ omz1 / omzo + 0.1D1 / omz1 / omzo + (-0.1D1 / 0.2D1 - x2 / 0.2D1
     #) * dls / omz1 / omzo / zo + rH1(0, x2) / omx2 / omz1 / omzo / zo 
     #+ d1x2 / omz1 / omzo - rH1(0, zo) * d0x2 / omz1 / omzo * zo / 0.2D
     #1 + rH1(1, zo) * d0x2 / omz1 / omzo * zo / 0.2D1 - rH1(1, zo) * d0
     #x2 / omz1 / omzo + rH1(1, zo) * d0x2 / omz1 / omzo / zo + d0x2 * d
     #ls / omz1 / omzo * zo / 0.2D1 + d0x2 * dls / omz1 / omzo / zo - rH
     #1(0, zo) * d0x2 / omz1 / omzo / zo
      elseif(ielocal.eq.2)then
      em2 = 0.1D1 / omx2 / omz1 / omzo / zo * rH1(0, x2) ** 2 / 0.2D1 +
     # rH1(1, x2) * rH1(0, x2) / omz1 / omzo + rH1(1, zo) * rH1(0, x2) /
     # omz1 / omzo + rH1(1, zo) * rH1(1, x2) / omz1 / omzo + (x2 / 0.2D1
     # - 0.1D1 / 0.2D1) * rH1(1, zo) / omz1 / omzo / zo + (-0.1D1 / 0.4D
     #1 - x2 / 0.4D1) * rH1(1, zo) ** 2 / omz1 / omzo / zo + 0.1D1 / omx
     #2 / omz1 / omzo * zo * rH1(0, x2) ** 2 / 0.4D1 - rH1(1, x2) * rH1(
     #0, x2) / omx2 / omz1 / omzo - rH1(1, zo) * rH1(0, x2) / omx2 / omz
     #1 / omzo - d0x2 * dls ** 2 / omz1 / omzo / 0.2D1 + rH1(0, x2) * dl
     #s / omz1 / omzo + rH1(1, x2) * dls / omz1 / omzo + rH1(1, zo) * dl
     #s / omz1 / omzo - rH1(0, x2) * dls / omx2 / omz1 / omzo + dls / om
     #z1 / omzo - rH1(0, zo) / omz1 / omzo + rH1(0, x2) * dls / omx2 / o
     #mz1 / omzo / zo + rH1(1, x2) * rH1(0, x2) / omx2 / omz1 / omzo / z
     #o + rH1(1, zo) * rH1(0, x2) / omx2 / omz1 / omzo / zo + d1x2 / omz
     #1 / omzo * zo / 0.2D1 - rH1(0, x2) / omx2 / omz1 / omzo * zo / 0.2
     #D1 + rH1(0, x2) / omz1 / omzo + rH1(1, x2) / omz1 / omzo + rH1(1, 
     #zo) / omz1 / omzo - rH1(0, zo) * dls / omz1 / omzo - rH1(0, zo) * 
     #rH1(0, x2) / omz1 / omzo - rH1(1, x2) * rH1(0, zo) / omz1 / omzo -
     # rH1(1, zo) * rH1(0, zo) / omz1 / omzo - 0.1D1 / omx2 / omz1 / omz
     #o * rH1(0, x2) ** 2 / 0.2D1 + dls ** 2 / omz1 / omzo / 0.2D1 + rH1
     #(1, zo) ** 2 / omz1 / omzo / 0.2D1 - 0.1D1 / omz1 / omzo * pi ** 2
     # / 0.12D2 + 0.1D1 / omz1 / omzo * rH1(0, x2) ** 2 / 0.2D1 + 0.1D1 
     #/ omz1 / omzo * rH1(0, zo) ** 2 / 0.2D1 + 0.1D1 / omz1 / omzo * rH
     #1(1, x2) ** 2 / 0.2D1 - rH1(1, zo) * rH1(0, zo) * d0x2 / omz1 / om
     #zo / zo - rH1(0, zo) * d0x2 * dls / omz1 / omzo / zo + (-0.1D1 / 0
     #.4D1 - x2 / 0.4D1) * dls ** 2 / omz1 / omzo / zo + (x2 / 0.2D1 - 0
     #.1D1 / 0.2D1) * dls / omz1 / omzo / zo + (0.1D1 / 0.2D1 + x2 / 0.2
     #D1) * rH1(0, zo) * dls / omz1 / omzo / zo + (-0.1D1 / 0.2D1 - x2 /
     # 0.2D1) * rH1(0, x2) * dls / omz1 / omzo / zo + (-0.1D1 / 0.2D1 - 
     #x2 / 0.2D1) * rH1(1, x2) * dls / omz1 / omzo / zo + (-0.1D1 / 0.2D
     #1 - x2 / 0.2D1) * rH1(1, zo) * dls / omz1 / omzo / zo + rH1(0, x2)
     # * dls / omx2 / omz1 / omzo * zo / 0.2D1 + (0.1D1 / 0.24D2 + x2 / 
     #0.24D2) / omz1 / omzo * pi ** 2 / zo + (-0.1D1 / 0.4D1 - x2 / 0.4D
     #1) / omz1 / omzo / zo * rH1(0, x2) ** 2 + (x2 / 0.2D1 - 0.1D1 / 0.
     #2D1) / omz1 / omzo / zo * rH1(0, x2) + (0.1D1 / 0.2D1 + x2 / 0.2D1
     #) * rH1(0, zo) / omz1 / omzo / zo * rH1(0, x2) + (-0.1D1 / 0.2D1 -
     # x2 / 0.2D1) * rH1(1, x2) / omz1 / omzo / zo * rH1(0, x2) + (-0.1D
     #1 / 0.2D1 - x2 / 0.2D1) * rH1(1, zo) / omz1 / omzo / zo * rH1(0, x
     #2) + (-0.1D1 / 0.4D1 - x2 / 0.4D1) / omz1 / omzo / zo * rH1(0, zo)
     # ** 2 + (-x2 / 0.2D1 + 0.1D1 / 0.2D1) / omz1 / omzo / zo * rH1(0, 
     #zo) + (0.1D1 / 0.2D1 + x2 / 0.2D1) * rH1(1, x2) / omz1 / omzo / zo
     # * rH1(0, zo) + (0.1D1 / 0.2D1 + x2 / 0.2D1) * rH1(1, zo) / omz1 /
     # omzo / zo * rH1(0, zo) + (-0.1D1 / 0.4D1 - x2 / 0.4D1) / omz1 / o
     #mzo / zo * rH1(1, x2) ** 2 + (x2 / 0.2D1 - 0.1D1 / 0.2D1) / omz1 /
     # omzo / zo * rH1(1, x2) + (-0.1D1 / 0.2D1 - x2 / 0.2D1) * rH1(1, z
     #o) / omz1 / omzo / zo * rH1(1, x2) - rH1(0, zo) * rH1(0, x2) / omx
     #2 / omz1 / omzo * zo / 0.2D1 + rH1(1, x2) * rH1(0, x2) / omx2 / om
     #z1 / omzo * zo / 0.2D1 + rH1(1, zo) * rH1(0, x2) / omx2 / omz1 / o
     #mzo * zo / 0.2D1 + rH1(0, zo) * rH1(0, x2) / omx2 / omz1 / omzo - 
     #rH1(0, zo) * rH1(0, x2) / omx2 / omz1 / omzo / zo + d0x2 / omz1 / 
     #omzo * pi ** 2 / 0.12D2 - rH1(1, zo) ** 2 * d0x2 / omz1 / omzo / 0
     #.2D1 - rH1(0, zo) ** 2 * d0x2 / omz1 / omzo / 0.2D1 + d1x2 * dls /
     # omz1 / omzo + rH1(1, zo) * d1x2 / omz1 / omzo + d2x2 / omz1 / omz
     #o * zo / 0.4D1 + d2x2 / omz1 / omzo / zo / 0.2D1 - d2x2 / omz1 / o
     #mzo / 0.2D1 - rH1(1, zo) * d1x2 / omz1 / omzo / zo - rH1(0, zo) * 
     #d0x2 * dls / omz1 / omzo * zo / 0.2D1 + rH1(1, zo) * d0x2 * dls / 
     #omz1 / omzo * zo / 0.2D1 - rH1(1, zo) * d0x2 * dls / omz1 / omzo +
     # rH1(1, zo) * d0x2 * dls / omz1 / omzo / zo - rH1(1, zo) * rH1(0, 
     #zo) * d0x2 / omz1 / omzo * zo / 0.2D1 + rH1(0, zo) * d1x2 / omz1 /
     # omzo * zo / 0.2D1 - rH1(1, zo) * d1x2 / omz1 / omzo * zo / 0.2D1 
     #- rH1(0, zo) * d1x2 / omz1 / omzo + rH1(0, zo) * d1x2 / omz1 / omz
     #o / zo - d1x2 * dls / omz1 / omzo * zo / 0.2D1 - d1x2 * dls / omz1
     # / omzo / zo - d0x2 / omz1 / omzo * pi ** 2 * zo / 0.24D2 - d0x2 /
     # omz1 / omzo * pi ** 2 / zo / 0.12D2 + d0x2 / omz1 / omzo * zo * r
     #H1(0, zo) ** 2 / 0.4D1 + rH1(1, zo) ** 2 * d0x2 / omz1 / omzo * zo
     # / 0.4D1 + rH1(1, zo) * rH1(0, zo) * d0x2 / omz1 / omzo + rH1(1, z
     #o) ** 2 * d0x2 / omz1 / omzo / zo / 0.2D1 + rH1(0, zo) ** 2 * d0x2
     # / omz1 / omzo / zo / 0.2D1 + rH1(0, zo) * d0x2 * dls / omz1 / omz
     #o + d0x2 * dls ** 2 / omz1 / omzo * zo / 0.4D1 + d0x2 * dls ** 2 /
     # omz1 / omzo / zo / 0.2D1 + rH1(0, zo) * d0x2 / omz1 / omzo * zo /
     # 0.2D1 - rH1(1, zo) * d0x2 / omz1 / omzo * zo / 0.2D1 - d0x2 * dls
     # / omz1 / omzo * zo / 0.2D1
      endif
      endif

      if(ielocal.eq.-2)then
        rJ21QQFIqgam_frag_ho=e2
      elseif(ielocal.eq.-1)then
        rJ21QQFIqgam_frag_ho=e1
      elseif(ielocal.eq.0)then
        rJ21QQFIqgam_frag_ho=e0
      elseif(ielocal.eq.1)then
        rJ21QQFIqgam_frag_ho=em1
      elseif(ielocal.eq.2)then
        rJ21QQFIqgam_frag_ho=em2
      endif

*      write(*,*)" rJ21QQFIqgam_frag_ho ",rJ21QQFIqgam_frag_ho

      return
      end
************************************************************************
*
      function rJ21QQFIqgam_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFIqgam_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QQFIqgam_frag_gen=rJ21QQIFqgam_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QQFIqgam_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 / omzo * zo / 0.2D1 + d0x2 / omz1 / omzo - d0x
     #2 / omz1 / omzo / zo + dla / omz1 / omz2 / omzo * zo / 0.2D1 - dla
     # / omz1 / omz2 / omzo + dla / omz1 / omz2 / omzo / zo - dls / omz1
     # / omz2 / omzo * zo / 0.2D1 + dls / omz1 / omz2 / omzo - dls / omz
     #1 / omz2 / omzo / zo + zo / omz1 / omz2 / omzo / 0.2D1 + rH1(0, zo
     #) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(1, z2) * zo / omz1 / omz
     #2 / omzo / 0.2D1 - rH1(1, zo) * zo / omz1 / omz2 / omzo / 0.2D1 - 
     #rH1(0, zo) / omz1 / omz2 / omzo + rH1(1, z2) / omz1 / omz2 / omzo 
     #+ rH1(1, zo) / omz1 / omz2 / omzo + rH1(0, zo) / omz1 / omz2 / omz
     #o / zo - rH1(1, z2) / omz1 / omz2 / omzo / zo - rH1(1, zo) / omz1 
     #/ omz2 / omzo / zo
      endif
      if(ix.eq.2.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 / omzo * zo / 0.2D1 - d0x2 / omz1 / omzo + d0x2
     # / omz1 / omzo / zo + 0.1D1 / omz1 / omzo + (-0.1D1 / 0.2D1 - x2 /
     # 0.2D1) / omz1 / omzo / zo
      endif

      if(ieorder.eq.-2)then
        rJ21QQFIqgam_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QQFIqgam_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QQFIqgam_frag_gen=e0
      endif

*      write(*,*)" rJ21QQFIqgam_frag_gen ",rJ21QQFIqgam_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QQFIqgam_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFIqgam_frag = rJ21QQFIqgam_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QQFIqgam_frag

C---- wrapper 2
      function rJ21QQFIqgam_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFIqgam_frag2 = rJ21QQFIqgam_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QQFIqgam_frag2

************************************************************************
*
      function rJ21QQFIqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFIqg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QQFIqg_frag_gen=rJ21QQIFqg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QQFIqg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 * z / 0.2D1 + d0x2 / omz1 - d0x2 / omz1 / z + 
     #dla / omz1 / omz2 * z / 0.2D1 - dla / omz1 / omz2 + dla / omz1 / o
     #mz2 / z - dls / omz1 / omz2 * z / 0.2D1 + dls / omz1 / omz2 - dls 
     #/ omz1 / omz2 / z + z / omz1 / omz2 / 0.2D1 + rH1(0, z) * z / omz1
     # / omz2 / 0.2D1 - rH1(1, z) * z / omz1 / omz2 / 0.2D1 - rH1(1, z2)
     # * z / omz1 / omz2 / 0.2D1 - rH1(0, z) / omz1 / omz2 + rH1(1, z) /
     # omz1 / omz2 + rH1(1, z2) / omz1 / omz2 + rH1(0, z) / omz1 / omz2 
     #/ z - rH1(1, z) / omz1 / omz2 / z - rH1(1, z2) / omz1 / omz2 / z
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 * z / 0.2D1 - d0x2 / omz1 + d0x2 / omz1 / z + 0
     #.1D1 / omz1 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) / omz1 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QQFIqg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QQFIqg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QQFIqg_frag_gen=e0
      endif

*      write(*,*)" rJ21QQFIqg_frag_gen ",rJ21QQFIqg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QQFIqg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFIqg_frag = rJ21QQFIqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QQFIqg_frag

C---- wrapper 2
      function rJ21QQFIqg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFIqg_frag2 = rJ21QQFIqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QQFIqg_frag2

************************************************************************
*
      function rJ21QQFIqq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFIqq_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QQFIqq_frag_gen=rJ21QQIFqq_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QQFIqq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.3D1 / 0.2D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x2 / omz1 - 0.1D1 / omz1 / omzo * d0x2 * dlm + 0.1D
     #1 / omz1 / omzo * rH1(1, zo) * d0x2 + dls / omz1 / omzo * d0x2 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + rH1(1, z2) / omz1 / omz2 * d0z + 
     #dls / omz1 / omz2 * d0z - 0.1D1 / omz1 / omzo * d1x2 - 0.1D1 / omz
     #1 / omz2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0
     #.3D1 / 0.4D1 / omz1 / omz2 / omzo * dla - 0.1D1 / omz1 / omz2 / om
     #zo * rH1(1, z2) * dlm + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo * dlm +
     # 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 / omz1 / om
     #z2 / omzo * rH1(1, z2) * dls + dls / omz1 / omz2 / omzo * rH1(1, z
     #o) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z2) + 0.1D1 
     #/ omz1 / omz2 / omzo * rH2(1, 1, z2) + 0.1D1 / omz1 / omz2 / omzo 
     #* rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.2.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + 0.1D1 / omz1 / omzo * d0x2 * dlm - 0.1
     #D1 / omz1 / omzo * rH1(1, zo) * d0x2 - dls / omz1 / omzo * d0x2 + 
     #(0.1D1 / 0.2D1 + x2 / 0.2D1) * d0z / omz1 + 0.1D1 / omz1 / omzo * 
     #d1x2 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) / omz1 / omzo * dlm + (0.1D1 
     #/ 0.2D1 + x2 / 0.2D1) / omz1 / omzo * dls + (0.1D1 / 0.2D1 + x2 / 
     #0.2D1) / omz1 / omzo * rH1(1, zo) + (0.1D1 / 0.2D1 + x2 / 0.2D1) /
     # omz1 / omzo * rH1(0, x2) + (0.1D1 / 0.2D1 + x2 / 0.2D1) * rH1(1, 
     #x2) / omzo / omz1 + (-x2 / 0.2D1 + 0.1D1 / 0.2D1) / omz1 / omzo - 
     #0.1D1 / omz1 / omzo * rH1(0, x2) / omx2
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + d0x2 / omz1 / 0.2D1 + d0x2 / omz1 * z 
     #/ 0.2D1 + 0.1D1 / omz1 / omz2 * d0z * dla - rH1(1, z2) / omz1 / om
     #z2 * d0z - dls / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2 * d1z - d
     #la / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 * z / 0.2D1 + dls / o
     #mz1 / omz2 / 0.2D1 + dls / omz1 / omz2 * z / 0.2D1 - z / omz1 / om
     #z2 / 0.2D1 - rH1(0, z) * z / omz1 / omz2 / 0.2D1 + rH1(1, z) * z /
     # omz1 / omz2 / 0.2D1 + rH1(1, z2) * z / omz1 / omz2 / 0.2D1 + 0.1D
     #1 / omz1 / omz2 / 0.2D1 - rH1(0, z) / omz1 / omz2 / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 / 0.2D1 + rH1(1, z2) / omz1 / omz2 / 0.2D1 + rH1
     #(0, z) / omz1 / omz2 / omz
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x2 / omz1 - d0x2 / omz1 / 0.2D1 - d0x2 / omz1 * z /
     # 0.2D1 + 0.1D1 / omz1 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) * d0z / omz1
      endif

      if(ieorder.eq.-2)then
        rJ21QQFIqq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QQFIqq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QQFIqq_frag_gen=e0
      endif

*      write(*,*)" rJ21QQFIqq_frag_gen ",rJ21QQFIqq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QQFIqq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFIqq_frag = rJ21QQFIqq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QQFIqq_frag

C---- wrapper 2
      function rJ21QQFIqq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQFIqq_frag2 = rJ21QQFIqq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QQFIqq_frag2

************************************************************************
*
      function rJ21GQFIqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQFIqg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GQFIqg_frag_gen=rJ21QGIFqg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GQFIqg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x2 / omz1 - 0.1D1 / omz1 / omzo * d0x2 * dlm + 0.1D
     #1 / omz1 / omzo * rH1(1, zo) * d0x2 + dls / omz1 / omzo * d0x2 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + rH1(1, z2) / omz1 / omz2 * d0z + 
     #dls / omz1 / omz2 * d0z - 0.1D1 / omz1 / omzo * d1x2 - 0.1D1 / omz
     #1 / omz2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0
     #.11D2 / 0.12D2 / omz1 / omz2 / omzo * dla - 0.1D1 / omz1 / omz2 / 
     #omzo * rH1(1, z2) * dlm + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo * dlm
     # + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 / omz1 / 
     #omz2 / omzo * rH1(1, z2) * dls + dls / omz1 / omz2 / omzo * rH1(1,
     # zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z2) + 0.1D
     #1 / omz1 / omz2 / omzo * rH2(1, 1, z2) + 0.1D1 / omz1 / omz2 / omz
     #o * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.2.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + 0.1D1 / omz1 / omzo * d0x2 * dlm - 0.1
     #D1 / omz1 / omzo * rH1(1, zo) * d0x2 - dls / omz1 / omzo * d0x2 + 
     #(0.1D1 / 0.2D1 + x2 / 0.2D1) * d0z / omz1 + 0.1D1 / omz1 / omzo * 
     #d1x2 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) / omz1 / omzo * dlm + (0.1D1 
     #/ 0.2D1 + x2 / 0.2D1) / omz1 / omzo * dls + (0.1D1 / 0.2D1 + x2 / 
     #0.2D1) / omz1 / omzo * rH1(1, zo) + (0.1D1 / 0.2D1 + x2 / 0.2D1) /
     # omz1 / omzo * rH1(0, x2) + (0.1D1 / 0.2D1 + x2 / 0.2D1) * rH1(1, 
     #x2) / omzo / omz1 + (-x2 / 0.2D1 + 0.1D1 / 0.2D1) / omz1 / omzo - 
     #0.1D1 / omz1 / omzo * rH1(0, x2) / omx2
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 * z + dla / omz1 / omz2 / z - dls / omz1 
     #/ omz2 * z - dls / omz1 / omz2 / z + rH1(0, z) * z / omz1 / omz2 -
     # rH1(1, z) * z / omz1 / omz2 - rH1(1, z2) * z / omz1 / omz2 + 0.2D
     #1 * rH1(1, z) / omz1 / omz2 + 0.2D1 * rH1(1, z2) / omz1 / omz2 - r
     #H1(1, z) / omz1 / omz2 / z - rH1(1, z2) / omz1 / omz2 / z + 0.1D1 
     #/ omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d1z + rH1(0, z) 
     #/ omz1 / omz2 / z - 0.2D1 * rH1(0, z) / omz1 / omz2 - d0x2 / omz1 
     #* z - d0x2 / omz1 / z - 0.2D1 * dla / omz1 / omz2 + 0.2D1 * dls / 
     #omz1 / omz2 + 0.2D1 * d0x2 / omz1 - d0z * d0x2 / omz1 - rH1(1, z2)
     # / omz1 / omz2 * d0z - dls / omz1 / omz2 * d0z - dla / omz1 / omz2
     # * z ** 2 + dls / omz1 / omz2 * z ** 2 - rH1(0, z) / omz1 / omz2 *
     # z ** 2 + d0x2 / omz1 * z ** 2 + rH1(1, z) / omz1 / omz2 * z ** 2 
     #+ rH1(1, z2) / omz1 / omz2 * z ** 2 + rH1(0, z) / omz1 / omz2 / om
     #z
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x2 / omz1 - d0x2 / omz1 * z ** 2 + d0x2 / omz1 * z 
     #- 0.2D1 * d0x2 / omz1 + d0x2 / omz1 / z + (-0.1D1 / 0.2D1 - x2 / 0
     #.2D1) * d0z / omz1 - 0.1D1 / x2 / omz1 * z ** 2 + 0.1D1 / x2 * z /
     # omz1 - 0.1D1 / x2 / omz1 / 0.2D1 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) 
     #/ omz1 / z
      endif

      if(ieorder.eq.-2)then
        rJ21GQFIqg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GQFIqg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GQFIqg_frag_gen=e0
      endif

*      write(*,*)" rJ21GQFIqg_frag_gen ",rJ21GQFIqg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GQFIqg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQFIqg_frag = rJ21GQFIqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GQFIqg_frag

C---- wrapper 2
      function rJ21GQFIqg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQFIqg_frag2 = rJ21GQFIqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GQFIqg_frag2

************************************************************************
*
      function rJ21QGFIgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGFIgq_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QGFIgq_frag_gen=rJ21GQIFgq_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QGFIgq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x2 / omz1 - 0.1D1 / omz1 / omzo * d0x2 * dlm + 0.1D
     #1 / omz1 / omzo * rH1(1, zo) * d0x2 + dls / omz1 / omzo * d0x2 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + rH1(1, z2) / omz1 / omz2 * d0z + 
     #dls / omz1 / omz2 * d0z - 0.1D1 / omz1 / omzo * d1x2 - 0.1D1 / omz
     #1 / omz2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0
     #.3D1 / 0.4D1 / omz1 / omz2 / omzo * dla - 0.1D1 / omz1 / omz2 / om
     #zo * rH1(1, z2) * dlm + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * dlm
     # + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 / omz1 / 
     #omz2 / omzo * rH1(1, z2) * dls + dls / omz1 / omz2 / omzo * rH1(1,
     # zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z2) + 0.1D
     #1 / omz1 / omz2 / omzo * rH2(1, 1, z2) + 0.1D1 / omz1 / omz2 / omz
     #o * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.2.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + 0.1D1 / omz1 / omzo * d0x2 * dlm - 0.1
     #D1 / omz1 / omzo * rH1(1, zo) * d0x2 - dls / omz1 / omzo * d0x2 + 
     #(x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * d0z / omz1 + 0.1D1
     # / omz1 / omzo * d1x2 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) /
     # x2 / omz1 / omzo * dlm + dls * (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 
     #0.1D1) / x2 / omz1 / omzo + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D
     #1) / x2 / omz1 / omzo * rH1(1, zo) + (x2 ** 3 - x2 ** 2 + 0.2D1 * 
     #x2 - 0.1D1) / x2 / omz1 / omzo * rH1(0, x2) + (x2 ** 3 - x2 ** 2 +
     # 0.2D1 * x2 - 0.1D1) / x2 / omz1 / omzo * rH1(1, x2) - 0.1D1 / omz
     #1 / omzo * rH1(0, x2) / omx2
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + d0x2 / omz1 / 0.2D1 + d0x2 / omz1 * z 
     #/ 0.2D1 + 0.1D1 / omz1 / omz2 * d0z * dla - rH1(1, z2) / omz1 / om
     #z2 * d0z - dls / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2 * d1z - d
     #la / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 * z / 0.2D1 + dls / o
     #mz1 / omz2 / 0.2D1 + dls / omz1 / omz2 * z / 0.2D1 - z / omz1 / om
     #z2 / 0.2D1 - rH1(0, z) * z / omz1 / omz2 / 0.2D1 + rH1(1, z) * z /
     # omz1 / omz2 / 0.2D1 + rH1(1, z2) * z / omz1 / omz2 / 0.2D1 + 0.1D
     #1 / omz1 / omz2 / 0.2D1 - rH1(0, z) / omz1 / omz2 / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 / 0.2D1 + rH1(1, z2) / omz1 / omz2 / 0.2D1 + rH1
     #(0, z) / omz1 / omz2 / omz
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x2 / omz1 - d0x2 / omz1 / 0.2D1 - d0x2 / omz1 * z /
     # 0.2D1 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * d0z / omz
     #1 - 0.3D1 / 0.2D1 / omz1
      endif

      if(ieorder.eq.-2)then
        rJ21QGFIgq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QGFIgq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QGFIgq_frag_gen=e0
      endif

*      write(*,*)" rJ21QGFIgq_frag_gen ",rJ21QGFIgq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QGFIgq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGFIgq_frag = rJ21QGFIgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QGFIgq_frag

C---- wrapper 2
      function rJ21QGFIgq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGFIgq_frag2 = rJ21QGFIgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QGFIgq_frag2

************************************************************************
*
      function rJ21QGFIgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGFIgg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QGFIgg_frag_gen=rJ21GQIFgg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QGFIgg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 * z / 0.2D1 + d0x2 / omz1 - d0x2 / omz1 / z + 
     #dla / omz1 / omz2 * z / 0.2D1 - dla / omz1 / omz2 + dla / omz1 / o
     #mz2 / z - dls / omz1 / omz2 * z / 0.2D1 + dls / omz1 / omz2 - dls 
     #/ omz1 / omz2 / z + z / omz1 / omz2 / 0.2D1 + rH1(0, z) * z / omz1
     # / omz2 / 0.2D1 - rH1(1, z) * z / omz1 / omz2 / 0.2D1 - rH1(1, z2)
     # * z / omz1 / omz2 / 0.2D1 - rH1(0, z) / omz1 / omz2 + rH1(1, z) /
     # omz1 / omz2 + rH1(1, z2) / omz1 / omz2 + rH1(0, z) / omz1 / omz2 
     #/ z - rH1(1, z) / omz1 / omz2 / z - rH1(1, z2) / omz1 / omz2 / z
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 * z / 0.2D1 - d0x2 / omz1 + d0x2 / omz1 / z - 0
     #.3D1 / 0.2D1 / omz1 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x
     #2 / omz1 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QGFIgg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QGFIgg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QGFIgg_frag_gen=e0
      endif

*      write(*,*)" rJ21QGFIgg_frag_gen ",rJ21QGFIgg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QGFIgg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGFIgg_frag = rJ21QGFIgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QGFIgg_frag

C---- wrapper 2
      function rJ21QGFIgg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGFIgg_frag2 = rJ21QGFIgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QGFIgg_frag2

************************************************************************
*
      function rJ21GGFIgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGFIgg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GGFIgg_frag_gen=rJ21GGIFgg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GGFIgg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.11D2 / 0.6D1 / omz1 / omz2 / o
     #mzo
      e0 = d0z * d0x2 / omz1 - 0.1D1 / omz1 / omzo * d0x2 * dlm + 0.1D
     #1 / omz1 / omzo * rH1(1, zo) * d0x2 + dls / omz1 / omzo * d0x2 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + rH1(1, z2) / omz1 / omz2 * d0z + 
     #dls / omz1 / omz2 * d0z - 0.1D1 / omz1 / omzo * d1x2 - 0.1D1 / omz
     #1 / omz2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0
     #.11D2 / 0.12D2 / omz1 / omz2 / omzo * dla - 0.1D1 / omz1 / omz2 / 
     #omzo * rH1(1, z2) * dlm + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * d
     #lm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 / omz1 
     #/ omz2 / omzo * rH1(1, z2) * dls + dls / omz1 / omz2 / omzo * rH1(
     #1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z2) + 0.
     #1D1 / omz1 / omz2 / omzo * rH2(1, 1, z2) + 0.1D1 / omz1 / omz2 / o
     #mzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.2.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + 0.1D1 / omz1 / omzo * d0x2 * dlm - 0.1
     #D1 / omz1 / omzo * rH1(1, zo) * d0x2 - dls / omz1 / omzo * d0x2 + 
     #(x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * d0z / omz1 + 0.1D1
     # / omz1 / omzo * d1x2 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) /
     # x2 / omz1 / omzo * dlm + dls * (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 
     #0.1D1) / x2 / omz1 / omzo + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D
     #1) / x2 / omz1 / omzo * rH1(1, zo) + (x2 ** 3 - x2 ** 2 + 0.2D1 * 
     #x2 - 0.1D1) / x2 / omz1 / omzo * rH1(0, x2) + (x2 ** 3 - x2 ** 2 +
     # 0.2D1 * x2 - 0.1D1) / x2 / omz1 / omzo * rH1(1, x2) - 0.1D1 / omz
     #1 / omzo * rH1(0, x2) / omx2
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 * z + dla / omz1 / omz2 / z - dls / omz1 
     #/ omz2 * z - dls / omz1 / omz2 / z + rH1(0, z) * z / omz1 / omz2 -
     # rH1(1, z) * z / omz1 / omz2 - rH1(1, z2) * z / omz1 / omz2 + 0.2D
     #1 * rH1(1, z) / omz1 / omz2 + 0.2D1 * rH1(1, z2) / omz1 / omz2 - r
     #H1(1, z) / omz1 / omz2 / z - rH1(1, z2) / omz1 / omz2 / z + 0.1D1 
     #/ omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d1z + rH1(0, z) 
     #/ omz1 / omz2 / z - 0.2D1 * rH1(0, z) / omz1 / omz2 - d0x2 / omz1 
     #* z - d0x2 / omz1 / z - 0.2D1 * dla / omz1 / omz2 + 0.2D1 * dls / 
     #omz1 / omz2 + 0.2D1 * d0x2 / omz1 - d0z * d0x2 / omz1 - rH1(1, z2)
     # / omz1 / omz2 * d0z - dls / omz1 / omz2 * d0z - dla / omz1 / omz2
     # * z ** 2 + dls / omz1 / omz2 * z ** 2 - rH1(0, z) / omz1 / omz2 *
     # z ** 2 + d0x2 / omz1 * z ** 2 + rH1(1, z) / omz1 / omz2 * z ** 2 
     #+ rH1(1, z2) / omz1 / omz2 * z ** 2 + rH1(0, z) / omz1 / omz2 / om
     #z
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x2 / omz1 - d0x2 / omz1 * z ** 2 + d0x2 / omz1 * z 
     #- 0.2D1 * d0x2 / omz1 + d0x2 / omz1 / z - (x2 ** 3 - x2 ** 2 + 0.2
     #D1 * x2 - 0.1D1) / x2 * d0z / omz1 - 0.1D1 / x2 / omz1 * z ** 2 + 
     #0.1D1 / x2 * z / omz1 - 0.2D1 / x2 / omz1 - (x2 ** 3 - x2 ** 2 + 0
     #.2D1 * x2 - 0.1D1) / x2 / omz1 / z
      endif

      if(ieorder.eq.-2)then
        rJ21GGFIgg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GGFIgg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GGFIgg_frag_gen=e0
      endif

*      write(*,*)" rJ21GGFIgg_frag_gen ",rJ21GGFIgg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GGFIgg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGFIgg_frag = rJ21GGFIgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GGFIgg_frag

C---- wrapper 2
      function rJ21GGFIgg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGFIgg_frag2 = rJ21GGFIgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GGFIgg_frag2

************************************************************************
*
      function rJ21hGGFIgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGGFIgq_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21hGGFIgq_frag_gen=rJ21hGGIFgq_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21hGGFIgq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 / 0.4D1 + d0x2 / omz1 * z / 0.2D1 - d0x2 / omz
     #1 * z ** 2 / 0.2D1 + dla / omz1 / omz2 / 0.4D1 - z * dla / omz1 / 
     #omz2 / 0.2D1 + z ** 2 * dla / omz1 / omz2 / 0.2D1 - dls / omz1 / o
     #mz2 / 0.4D1 + z * dls / omz1 / omz2 / 0.2D1 - z ** 2 * dls / omz1 
     #/ omz2 / 0.2D1 - 0.1D1 / omz1 / omz2 * z ** 2 / 0.2D1 + rH1(0, z) 
     #/ omz1 / omz2 * z ** 2 / 0.2D1 - rH1(1, z) / omz1 / omz2 * z ** 2 
     #/ 0.2D1 - rH1(1, z2) / omz1 / omz2 * z ** 2 / 0.2D1 + 0.1D1 / omz1
     # / omz2 * z / 0.2D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z2) / omz1 / omz2 * z / 0.2
     #D1 + rH1(0, z) / omz1 / omz2 / 0.4D1 - rH1(1, z) / omz1 / omz2 / 0
     #.4D1 - rH1(1, z2) / omz1 / omz2 / 0.4D1
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 / 0.4D1 - d0x2 / omz1 * z / 0.2D1 + d0x2 / omz1
     # * z ** 2 / 0.2D1 + 0.1D1 / x2 / omz1 * z ** 2 / 0.2D1 - 0.1D1 / x
     #2 * z / omz1 / 0.2D1 + 0.1D1 / x2 / omz1 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGFIgq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGFIgq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21hGGFIgq_frag_gen=e0
      endif

*      write(*,*)" rJ21hGGFIgq_frag_gen ",rJ21hGGFIgq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21hGGFIgq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGFIgq_frag = rJ21hGGFIgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21hGGFIgq_frag

C---- wrapper 2
      function rJ21hGGFIgq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGFIgq_frag2 = rJ21hGGFIgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21hGGFIgq_frag2

************************************************************************
*
      function rJ21hGQFIqqp_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGQFIqqp_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21hGQFIqqp_frag_gen=rJ21hQGIFqqp_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21hGQFIqqp_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 / 0.4D1 + d0x2 / omz1 * z / 0.2D1 - d0x2 / omz
     #1 * z ** 2 / 0.2D1 + dla / omz1 / omz2 / 0.4D1 - z * dla / omz1 / 
     #omz2 / 0.2D1 + z ** 2 * dla / omz1 / omz2 / 0.2D1 - dls / omz1 / o
     #mz2 / 0.4D1 + z * dls / omz1 / omz2 / 0.2D1 - z ** 2 * dls / omz1 
     #/ omz2 / 0.2D1 - 0.1D1 / omz1 / omz2 * z ** 2 / 0.2D1 + rH1(0, z) 
     #/ omz1 / omz2 * z ** 2 / 0.2D1 - rH1(1, z) / omz1 / omz2 * z ** 2 
     #/ 0.2D1 - rH1(1, z2) / omz1 / omz2 * z ** 2 / 0.2D1 + 0.1D1 / omz1
     # / omz2 * z / 0.2D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z2) / omz1 / omz2 * z / 0.2
     #D1 + rH1(0, z) / omz1 / omz2 / 0.4D1 - rH1(1, z) / omz1 / omz2 / 0
     #.4D1 - rH1(1, z2) / omz1 / omz2 / 0.4D1
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 / 0.4D1 - d0x2 / omz1 * z / 0.2D1 + d0x2 / omz1
     # * z ** 2 / 0.2D1 + 0.1D1 / x2 / omz1 * z ** 2 / 0.2D1 - 0.1D1 / x
     #2 * z / omz1 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGQFIqqp_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21hGQFIqqp_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21hGQFIqqp_frag_gen=e0
      endif

*      write(*,*)" rJ21hGQFIqqp_frag_gen ",rJ21hGQFIqqp_frag_gen

      return
      end

C---- wrapper 1
      function rJ21hGQFIqqp_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGQFIqqp_frag = rJ21hGQFIqqp_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21hGQFIqqp_frag

C---- wrapper 2
      function rJ21hGQFIqqp_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGQFIqqp_frag2 = rJ21hGQFIqqp_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21hGQFIqqp_frag2

************************************************************************
*
      function rJ21QGqtogFIqpq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGqtogFIqpq_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QGqtogFIqpq_frag_gen=rJ21GQqtogIFqpq_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QGqtogFIqpq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.2.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0z / omz1 / 0.2D1 +
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omzo / omz1 * dlm / 0.2D1 -
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omzo / omz1 * dls / 0.2D1 -
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * rH1(0, x2) / 
     #0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * rH1(1,
     # x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo *
     # rH1(1, zo) / 0.2D1 + x2 / omz1 / omzo / 0.2D1
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0z / omz1 / 0.2D1 + 
     #(x2 - 0.2D1) / x2 / omz1 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21QGqtogFIqpq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QGqtogFIqpq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QGqtogFIqpq_frag_gen=e0
      endif

*      write(*,*)" rJ21QGqtogFIqpq_frag_gen ",rJ21QGqtogFIqpq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QGqtogFIqpq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGqtogFIqpq_frag = rJ21QGqtogFIqpq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QGqtogFIqpq_frag

C---- wrapper 2
      function rJ21QGqtogFIqpq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGqtogFIqpq_frag2 = rJ21QGqtogFIqpq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QGqtogFIqpq_frag2

************************************************************************
*
      function rJ21GGqtogFIqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGqtogFIqg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GGqtogFIqg_frag_gen=rJ21GGqtogIFqg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GGqtogFIqg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.2.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0z / omz1 / 0.2D1 +
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omzo / omz1 * dlm / 0.2D1 -
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omzo / omz1 * dls / 0.2D1 -
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * rH1(0, x2) / 
     #0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * rH1(1,
     # x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo *
     # rH1(1, zo) / 0.2D1 + x2 / omz1 / omzo / 0.2D1
      endif
      if(ix.eq.2.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0z / omz1 / 0.2D1 - 
     #0.1D1 / x2 * z / omz1 / 0.2D1 - 0.1D1 / x2 / omz1 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GGqtogFIqg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GGqtogFIqg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GGqtogFIqg_frag_gen=e0
      endif

*      write(*,*)" rJ21GGqtogFIqg_frag_gen ",rJ21GGqtogFIqg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GGqtogFIqg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGqtogFIqg_frag = rJ21GGqtogFIqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GGqtogFIqg_frag

C---- wrapper 2
      function rJ21GGqtogFIqg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGqtogFIqg_frag2 = rJ21GGqtogFIqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GGqtogFIqg_frag2

