************************************************************************
*
      function rJ21QQIFqgam_frag_ho(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ieord)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use PhotonFragmentation_mod, only : iz_frag
      implicit double precision (a-h,o-z)
      integer, intent(in) :: ieord
      integer ielocal
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQIFqgam_frag_ho: only imethod=2!' 
      endif

      ielocal=ieord

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QQIFqgam_frag_ho=rJ21QQFIqgam_frag_ho(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ieord)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      em2=0d0
      em1=0d0
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      izz=iz_frag
      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 / omz2 / omzo * zo / 0.2D1 + d0x1 / omz2 / omzo - d0x
     #1 / omz2 / omzo / zo + 0.1D1 / omz1 / omz2 / omzo * dla * zo / 0.2
     #D1 - 0.1D1 / omz1 / omz2 / omzo * dla + 0.1D1 / omz1 / omz2 / omzo
     # * dla / zo - dls / omz1 / omz2 / omzo * zo / 0.2D1 + dls / omz1 /
     # omz2 / omzo - dls / omz1 / omz2 / omzo / zo + zo / omz1 / omz2 / 
     #omzo / 0.2D1 + rH1(0, zo) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(
     #1, z1) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(1, zo) * zo / omz1 
     #/ omz2 / omzo / 0.2D1 - rH1(0, zo) / omz1 / omz2 / omzo + rH1(1, z
     #1) / omz1 / omz2 / omzo + rH1(1, zo) / omz1 / omz2 / omzo + rH1(0,
     # zo) / omz1 / omz2 / omzo / zo - rH1(1, z1) / omz1 / omz2 / omzo /
     # zo - rH1(1, zo) / omz1 / omz2 / omzo / zo
      if(ielocal.eq.1)then
      em1 = -d1x1 / omz2 / omzo + dls / omz1 / omz2 / omzo * zo / 0.2D1
     # - rH1(0, zo) * zo / omz1 / omz2 / omzo / 0.2D1 + rH1(1, z1) * zo 
     #/ omz1 / omz2 / omzo / 0.2D1 + rH1(0, zo) * dls / omz1 / omz2 / om
     #zo / zo + rH1(1, z1) * rH1(0, zo) / omz1 / omz2 / omzo / zo + rH1(
     #1, zo) * rH1(0, zo) / omz1 / omz2 / omzo / zo - d0x1 * dls / omz2 
     #/ omzo * zo / 0.2D1 - d0x1 * dls / omz2 / omzo / zo + rH1(0, zo) *
     # d0x1 / omz2 / omzo * zo / 0.2D1 - rH1(1, zo) * d0x1 / omz2 / omzo
     # * zo / 0.2D1 + rH1(1, zo) * d0x1 / omz2 / omzo - rH1(1, zo) * d0x
     #1 / omz2 / omzo / zo + dla ** 2 / omz1 / omz2 / omzo * zo / 0.4D1 
     #+ dla ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 + rH1(1, zo) * zo / o
     #mz1 / omz2 / omzo / 0.2D1 - dls ** 2 / omz1 / omz2 / omzo * zo / 0
     #.4D1 - dls ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 - rH1(0, zo) * d
     #ls / omz1 / omz2 / omzo + 0.1D1 / omz1 / omz2 / omzo * pi ** 2 * z
     #o / 0.24D2 + 0.1D1 / omz1 / omz2 / omzo * pi ** 2 / zo / 0.12D2 - 
     #zo / omz1 / omz2 / omzo * rH1(0, zo) ** 2 / 0.4D1 - rH2(1, 1, z1) 
     #* zo / omz1 / omz2 / omzo / 0.2D1 - rH1(1, zo) ** 2 * zo / omz1 / 
     #omz2 / omzo / 0.4D1 - rH1(1, z1) * rH1(0, zo) / omz1 / omz2 / omzo
     # - rH1(1, zo) * rH1(0, zo) / omz1 / omz2 / omzo + rH2(1, 1, z1) / 
     #omz1 / omz2 / omzo - 0.1D1 / omz1 / omz2 / omzo / zo * rH1(0, zo) 
     #** 2 / 0.2D1 - rH2(1, 1, z1) / omz1 / omz2 / omzo / zo - rH1(1, zo
     #) ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 - 0.1D1 / omz1 / omz2 / o
     #mzo * pi ** 2 / 0.12D2 + 0.1D1 / omz1 / omz2 / omzo * rH1(0, zo) *
     #* 2 / 0.2D1 + rH1(1, zo) ** 2 / omz1 / omz2 / omzo / 0.2D1 + dls *
     #* 2 / omz1 / omz2 / omzo / 0.2D1 - rH1(0, zo) * d0x1 / omz2 / omzo
     # + d1x1 / omz2 / omzo * zo / 0.2D1 + d1x1 / omz2 / omzo / zo - dla
     # ** 2 / omz1 / omz2 / omzo / 0.2D1 + d0x1 * dls / omz2 / omzo + d0
     #x1 / omz2 / omzo * zo / 0.2D1 + rH1(1, z1) * rH1(0, zo) * zo / omz
     #1 / omz2 / omzo / 0.2D1 + rH1(1, zo) * rH1(0, zo) * zo / omz1 / om
     #z2 / omzo / 0.2D1 - rH1(1, zo) * rH1(1, z1) * zo / omz1 / omz2 / o
     #mzo / 0.2D1 + rH1(1, zo) * rH1(1, z1) / omz1 / omz2 / omzo - rH1(1
     #, zo) * rH1(1, z1) / omz1 / omz2 / omzo / zo + rH1(0, zo) * dls / 
     #omz1 / omz2 / omzo * zo / 0.2D1 - rH1(1, z1) * dls / omz1 / omz2 /
     # omzo * zo / 0.2D1 - rH1(1, zo) * dls / omz1 / omz2 / omzo * zo / 
     #0.2D1 + rH1(1, z1) * dls / omz1 / omz2 / omzo + rH1(1, zo) * dls /
     # omz1 / omz2 / omzo - rH1(1, z1) * dls / omz1 / omz2 / omzo / zo -
     # rH1(1, zo) * dls / omz1 / omz2 / omzo / zo + rH1(0, zo) * d0x1 / 
     #omz2 / omzo / zo
      elseif(ielocal.eq.2)then
      em2 = -d0x1 * dls ** 2 / omz2 / omzo / zo / 0.2D1 + d0x1 * dls / 
     #omz2 / omzo * zo / 0.2D1 - rH1(0, zo) * d0x1 / omz2 / omzo * zo / 
     #0.2D1 + rH1(1, zo) * d0x1 / omz2 / omzo * zo / 0.2D1 + rH1(1, z1) 
     #* rH1(0, zo) * dls / omz1 / omz2 / omzo / zo + rH1(1, zo) * rH1(0,
     # zo) * dls / omz1 / omz2 / omzo / zo + rH1(1, zo) * rH1(1, z1) * r
     #H1(0, zo) / omz1 / omz2 / omzo / zo + d2x1 / omz2 / omzo / 0.2D1 -
     # d0x1 * dls ** 2 / omz2 / omzo * zo / 0.4D1 + dls ** 2 / omz1 / om
     #z2 / omzo * zo / 0.4D1 - 0.1D1 / omz1 / omz2 / omzo * pi ** 2 * zo
     # / 0.24D2 + zo / omz1 / omz2 / omzo * rH1(0, zo) ** 2 / 0.4D1 + rH
     #2(1, 1, z1) * zo / omz1 / omz2 / omzo / 0.2D1 + rH1(1, zo) ** 2 * 
     #zo / omz1 / omz2 / omzo / 0.4D1 + rH2(1, 1, z1) * rH1(0, zo) / omz
     #1 / omz2 / omzo / zo + rH1(1, z1) * rH1(0, zo) * dls / omz1 / omz2
     # / omzo * zo / 0.2D1 + rH1(1, zo) * rH1(0, zo) * dls / omz1 / omz2
     # / omzo * zo / 0.2D1 - rH1(1, zo) * rH1(1, z1) * dls / omz1 / omz2
     # / omzo * zo / 0.2D1 + rH1(1, zo) * rH1(1, z1) * dls / omz1 / omz2
     # / omzo - rH1(1, zo) * rH1(1, z1) * dls / omz1 / omz2 / omzo / zo 
     #+ rH1(1, zo) * rH1(1, z1) * rH1(0, zo) * zo / omz1 / omz2 / omzo /
     # 0.2D1 + rH1(0, zo) * d0x1 * dls / omz2 / omzo / zo + rH1(1, zo) *
     # rH1(0, zo) * d0x1 / omz2 / omzo / zo - 0.1D1 / omz1 / omz2 / omzo
     # * rH1(0, zo) ** 3 / 0.6D1 + rH1(1, zo) ** 3 / omz1 / omz2 / omzo 
     #/ 0.6D1 - 0.1D1 / omz1 / omz2 / omzo * zeta3 / 0.3D1 + 0.1D1 / omz
     #1 / omz2 / omzo * zeta3 * zo / 0.6D1 + 0.1D1 / omz1 / omz2 / omzo 
     #* zeta3 / zo / 0.3D1 + zo / omz1 / omz2 / omzo * rH1(0, zo) ** 3 /
     # 0.12D2 - rH3(1, 1, 1, z1) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1
     #(1, zo) ** 3 * zo / omz1 / omz2 / omzo / 0.12D2 + rH1(1, z1) / omz
     #1 / omz2 / omzo * rH1(0, zo) ** 2 / 0.2D1 + rH1(1, zo) / omz1 / om
     #z2 / omzo * rH1(0, zo) ** 2 / 0.2D1 - rH2(1, 1, z1) * rH1(0, zo) /
     # omz1 / omz2 / omzo - rH1(1, zo) ** 2 * rH1(0, zo) / omz1 / omz2 /
     # omzo / 0.2D1 + rH3(1, 1, 1, z1) / omz1 / omz2 / omzo + rH1(1, zo)
     # ** 2 * rH1(1, z1) / omz1 / omz2 / omzo / 0.2D1 + 0.1D1 / omz1 / o
     #mz2 / omzo / zo * rH1(0, zo) ** 3 / 0.6D1 - rH3(1, 1, 1, z1) / omz
     #1 / omz2 / omzo / zo - rH1(1, zo) ** 3 / omz1 / omz2 / omzo / zo /
     # 0.6D1 + rH1(0, zo) / omz1 / omz2 / omzo * pi ** 2 / 0.12D2 - rH1(
     #1, z1) / omz1 / omz2 / omzo * pi ** 2 / 0.12D2 - rH1(1, zo) / omz1
     # / omz2 / omzo * pi ** 2 / 0.12D2 + rH1(1, zo) ** 2 * dls / omz1 /
     # omz2 / omzo / 0.2D1 - dls / omz1 / omz2 / omzo * pi ** 2 / 0.12D2
     # + dls / omz1 / omz2 / omzo * rH1(0, zo) ** 2 / 0.2D1 - rH1(0, zo)
     # * dls ** 2 / omz1 / omz2 / omzo / 0.2D1 + rH1(1, z1) * dls ** 2 /
     # omz1 / omz2 / omzo / 0.2D1 + rH1(1, zo) * dls ** 2 / omz1 / omz2 
     #/ omzo / 0.2D1 + dla ** 3 / omz1 / omz2 / omzo / zo / 0.6D1 - dls 
     #** 3 / omz1 / omz2 / omzo * zo / 0.12D2 - dls ** 3 / omz1 / omz2 /
     # omzo / zo / 0.6D1 + dla ** 3 / omz1 / omz2 / omzo * zo / 0.12D2 +
     # d1x1 * dls / omz2 / omzo * zo / 0.2D1 + d1x1 * dls / omz2 / omzo 
     #/ zo - rH1(0, zo) * d1x1 / omz2 / omzo * zo / 0.2D1 + rH1(1, zo) *
     # d1x1 / omz2 / omzo * zo / 0.2D1 + rH1(0, zo) * d1x1 / omz2 / omzo
     # - rH1(0, zo) * d1x1 / omz2 / omzo / zo + d0x1 / omz2 / omzo * pi 
     #** 2 * zo / 0.24D2 + d0x1 / omz2 / omzo * pi ** 2 / zo / 0.12D2 - 
     #d0x1 / omz2 / omzo * zo * rH1(0, zo) ** 2 / 0.4D1 - rH1(1, zo) ** 
     #2 * d0x1 / omz2 / omzo * zo / 0.4D1 - rH1(1, zo) * rH1(0, zo) * d0
     #x1 / omz2 / omzo - rH1(0, zo) ** 2 * d0x1 / omz2 / omzo / zo / 0.2
     #D1 - rH1(1, zo) ** 2 * d0x1 / omz2 / omzo / zo / 0.2D1 - rH1(0, zo
     #) * d0x1 * dls / omz2 / omzo - rH1(1, zo) * rH1(1, z1) * rH1(0, zo
     #) / omz1 / omz2 / omzo + rH2(1, 1, z1) * rH1(1, zo) / omz1 / omz2 
     #/ omzo - rH1(1, z1) / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 2 / 
     #0.2D1 - rH1(1, zo) / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 2 / 0
     #.2D1 + rH1(1, zo) ** 2 * rH1(0, zo) / omz1 / omz2 / omzo / zo / 0.
     #2D1 - rH1(1, zo) ** 2 * rH1(1, z1) / omz1 / omz2 / omzo / zo / 0.2
     #D1 - rH2(1, 1, z1) * rH1(1, zo) / omz1 / omz2 / omzo / zo - rH1(0,
     # zo) / omz1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + rH1(1, z1) / o
     #mz1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + rH1(1, zo) / omz1 / om
     #z2 / omzo * pi ** 2 * zo / 0.24D2 - rH1(0, zo) / omz1 / omz2 / omz
     #o * pi ** 2 / zo / 0.12D2 + rH1(1, z1) / omz1 / omz2 / omzo * pi *
     #* 2 / zo / 0.12D2 + rH1(1, zo) / omz1 / omz2 / omzo * pi ** 2 / zo
     # / 0.12D2 - rH1(1, z1) * zo / omz1 / omz2 / omzo * rH1(0, zo) ** 2
     # / 0.4D1 - rH1(1, zo) * zo / omz1 / omz2 / omzo * rH1(0, zo) ** 2 
     #/ 0.4D1 + rH2(1, 1, z1) * rH1(0, zo) * zo / omz1 / omz2 / omzo / 0
     #.2D1 + rH1(1, zo) ** 2 * rH1(0, zo) * zo / omz1 / omz2 / omzo / 0.
     #4D1 - rH1(1, zo) ** 2 * rH1(1, z1) * zo / omz1 / omz2 / omzo / 0.4
     #D1 - rH2(1, 1, z1) * rH1(1, zo) * zo / omz1 / omz2 / omzo / 0.2D1 
     #- rH2(1, 1, z1) * dls / omz1 / omz2 / omzo * zo / 0.2D1 - rH1(1, z
     #o) ** 2 * dls / omz1 / omz2 / omzo * zo / 0.4D1 - rH1(1, z1) * rH1
     #(0, zo) * dls / omz1 / omz2 / omzo - rH1(1, zo) * rH1(0, zo) * dls
     # / omz1 / omz2 / omzo + rH2(1, 1, z1) * dls / omz1 / omz2 / omzo -
     # dls / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 2 / 0.2D1 - rH2(1, 
     #1, z1) * dls / omz1 / omz2 / omzo / zo - rH1(1, zo) ** 2 * dls / o
     #mz1 / omz2 / omzo / zo / 0.2D1 + dls / omz1 / omz2 / omzo * pi ** 
     #2 * zo / 0.24D2 + dls / omz1 / omz2 / omzo * pi ** 2 / zo / 0.12D2
     # - dls / omz1 / omz2 / omzo * zo * rH1(0, zo) ** 2 / 0.4D1 + rH1(0
     #, zo) * dls ** 2 / omz1 / omz2 / omzo * zo / 0.4D1 - rH1(1, z1) * 
     #dls ** 2 / omz1 / omz2 / omzo * zo / 0.4D1 - rH1(1, zo) * dls ** 2
     # / omz1 / omz2 / omzo * zo / 0.4D1 + rH1(0, zo) * dls ** 2 / omz1 
     #/ omz2 / omzo / zo / 0.2D1 - rH1(1, z1) * dls ** 2 / omz1 / omz2 /
     # omzo / zo / 0.2D1 - rH1(1, zo) * dls ** 2 / omz1 / omz2 / omzo / 
     #zo / 0.2D1 + rH1(1, zo) * d1x1 / omz2 / omzo / zo + rH1(1, zo) * r
     #H1(0, zo) * d0x1 / omz2 / omzo * zo / 0.2D1 + rH1(0, zo) * d0x1 * 
     #dls / omz2 / omzo * zo / 0.2D1 - rH1(1, zo) * d0x1 * dls / omz2 / 
     #omzo * zo / 0.2D1 + rH1(1, zo) * d0x1 * dls / omz2 / omzo - rH1(1,
     # zo) * d0x1 * dls / omz2 / omzo / zo + dls ** 3 / omz1 / omz2 / om
     #zo / 0.6D1 - d2x1 / omz2 / omzo * zo / 0.4D1 - d2x1 / omz2 / omzo 
     #/ zo / 0.2D1 - dla ** 3 / omz1 / omz2 / omzo / 0.6D1 - rH1(1, zo) 
     #* d1x1 / omz2 / omzo + rH1(0, zo) ** 2 * d0x1 / omz2 / omzo / 0.2D
     #1 + rH1(1, zo) ** 2 * d0x1 / omz2 / omzo / 0.2D1 - d1x1 * dls / om
     #z2 / omzo - d0x1 / omz2 / omzo * pi ** 2 / 0.12D2 + d0x1 * dls ** 
     #2 / omz2 / omzo / 0.2D1 - d1x1 / omz2 / omzo * zo / 0.2D1 - rH1(1,
     # z1) * rH1(0, zo) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(1, zo) *
     # rH1(0, zo) * zo / omz1 / omz2 / omzo / 0.2D1 + rH1(1, zo) * rH1(1
     #, z1) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(0, zo) * dls / omz1 
     #/ omz2 / omzo * zo / 0.2D1 + rH1(1, z1) * dls / omz1 / omz2 / omzo
     # * zo / 0.2D1 + rH1(1, zo) * dls / omz1 / omz2 / omzo * zo / 0.2D1
      endif
      endif
      if(ix.eq.3.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = d0x1 / omz2 / omzo * zo / 0.2D1 - d0x1 / omz2 / omzo + d0x1
     # / omz2 / omzo / zo + 0.1D1 / omz2 / omzo + (-0.1D1 / 0.2D1 - x1 /
     # 0.2D1) / omz2 / omzo / zo
      if(ielocal.eq.1)then
      em1 = d1x1 / omz2 / omzo + d0x1 * dls / omz2 / omzo * zo / 0.2D1 
     #+ d0x1 * dls / omz2 / omzo / zo - rH1(0, zo) * d0x1 / omz2 / omzo 
     #* zo / 0.2D1 + rH1(1, zo) * d0x1 / omz2 / omzo * zo / 0.2D1 - rH1(
     #1, zo) * d0x1 / omz2 / omzo + rH1(1, zo) * d0x1 / omz2 / omzo / zo
     # - rH1(0, zo) / omz2 / omzo + dls / omz2 / omzo + (x1 / 0.2D1 - 0.
     #1D1 / 0.2D1) / omz2 / omzo / zo + (0.1D1 / 0.2D1 + x1 / 0.2D1) * r
     #H1(0, zo) / omz2 / omzo / zo + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rH1
     #(1, zo) / omz2 / omzo / zo + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rH1(0
     #, x1) / omz2 / omzo / zo + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rH1(1, 
     #x1) / omz2 / omzo / zo + rH1(0, x1) / omx1 / omz2 / omzo * zo / 0.
     #2D1 + 0.1D1 / omz2 / omzo + rH1(0, x1) / omx1 / omz2 / omzo / zo +
     # (-0.1D1 / 0.2D1 - x1 / 0.2D1) * dls / omz2 / omzo / zo + rH1(1, z
     #o) / omz2 / omzo + rH1(0, x1) / omz2 / omzo + rH1(1, x1) / omz2 / 
     #omzo - rH1(0, x1) / omx1 / omz2 / omzo + rH1(0, zo) * d0x1 / omz2 
     #/ omzo - d1x1 / omz2 / omzo * zo / 0.2D1 - d1x1 / omz2 / omzo / zo
     # - d0x1 * dls / omz2 / omzo - d0x1 / omz2 / omzo * zo / 0.2D1 - rH
     #1(0, zo) * d0x1 / omz2 / omzo / zo
      elseif(ielocal.eq.2)then
      em2 = d0x1 * dls ** 2 / omz2 / omzo / zo / 0.2D1 - d0x1 * dls / o
     #mz2 / omzo * zo / 0.2D1 + rH1(0, zo) * d0x1 / omz2 / omzo * zo / 0
     #.2D1 - rH1(1, zo) * d0x1 / omz2 / omzo * zo / 0.2D1 - d2x1 / omz2 
     #/ omzo / 0.2D1 + d0x1 * dls ** 2 / omz2 / omzo * zo / 0.4D1 - rH1(
     #0, zo) * d0x1 * dls / omz2 / omzo / zo - rH1(1, zo) * rH1(0, zo) *
     # d0x1 / omz2 / omzo / zo + 0.1D1 / omx1 / omz2 / omzo * zo * rH1(0
     #, x1) ** 2 / 0.4D1 - rH1(1, zo) * rH1(0, x1) / omx1 / omz2 / omzo 
     #- rH1(1, x1) * rH1(0, x1) / omx1 / omz2 / omzo + 0.1D1 / omx1 / om
     #z2 / omzo / zo * rH1(0, x1) ** 2 / 0.2D1 + rH1(1, zo) * rH1(0, x1)
     # / omz2 / omzo + rH1(1, x1) * rH1(0, x1) / omz2 / omzo + rH1(1, zo
     #) * rH1(1, x1) / omz2 / omzo + (-0.1D1 / 0.4D1 - x1 / 0.4D1) * rH1
     #(1, zo) ** 2 / omz2 / omzo / zo + (x1 / 0.2D1 - 0.1D1 / 0.2D1) * r
     #H1(1, zo) / omz2 / omzo / zo + rH1(1, zo) * dls / omz2 / omzo + rH
     #1(0, x1) * dls / omz2 / omzo + rH1(1, x1) * dls / omz2 / omzo - rH
     #1(0, x1) * dls / omx1 / omz2 / omzo + rH1(0, x1) * dls / omx1 / om
     #z2 / omzo / zo + rH1(1, zo) * rH1(0, x1) / omx1 / omz2 / omzo / zo
     # + rH1(1, x1) * rH1(0, x1) / omx1 / omz2 / omzo / zo + 0.1D1 / omz
     #2 / omzo * rH1(0, zo) ** 2 / 0.2D1 + 0.1D1 / omz2 / omzo * rH1(1, 
     #x1) ** 2 / 0.2D1 + rH1(1, zo) ** 2 / omz2 / omzo / 0.2D1 - 0.1D1 /
     # omz2 / omzo * pi ** 2 / 0.12D2 + 0.1D1 / omz2 / omzo * rH1(0, x1)
     # ** 2 / 0.2D1 + dls ** 2 / omz2 / omzo / 0.2D1 - 0.1D1 / omx1 / om
     #z2 / omzo * rH1(0, x1) ** 2 / 0.2D1 - rH1(0, zo) * rH1(0, x1) / om
     #z2 / omzo - rH1(1, zo) * rH1(0, zo) / omz2 / omzo - rH1(1, x1) * r
     #H1(0, zo) / omz2 / omzo - rH1(0, zo) * dls / omz2 / omzo - rH1(0, 
     #zo) / omz2 / omzo + dls / omz2 / omzo - rH1(0, x1) / omx1 / omz2 /
     # omzo * zo / 0.2D1 + (-0.1D1 / 0.4D1 - x1 / 0.4D1) / omz2 / omzo /
     # zo * rH1(0, x1) ** 2 + (x1 / 0.2D1 - 0.1D1 / 0.2D1) / omz2 / omzo
     # / zo * rH1(0, x1) + (0.1D1 / 0.2D1 + x1 / 0.2D1) * rH1(0, zo) / o
     #mz2 / omzo / zo * rH1(0, x1) + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rH1
     #(1, zo) / omz2 / omzo / zo * rH1(0, x1) + (-0.1D1 / 0.2D1 - x1 / 0
     #.2D1) * rH1(1, x1) / omz2 / omzo / zo * rH1(0, x1) + (-0.1D1 / 0.4
     #D1 - x1 / 0.4D1) / omz2 / omzo / zo * rH1(0, zo) ** 2 + (-x1 / 0.2
     #D1 + 0.1D1 / 0.2D1) / omz2 / omzo / zo * rH1(0, zo) + (0.1D1 / 0.2
     #D1 + x1 / 0.2D1) * rH1(1, zo) / omz2 / omzo / zo * rH1(0, zo) + (0
     #.1D1 / 0.2D1 + x1 / 0.2D1) * rH1(1, x1) / omz2 / omzo / zo * rH1(0
     #, zo) + (-0.1D1 / 0.4D1 - x1 / 0.4D1) / omz2 / omzo / zo * rH1(1, 
     #x1) ** 2 + (x1 / 0.2D1 - 0.1D1 / 0.2D1) / omz2 / omzo / zo * rH1(1
     #, x1) + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rH1(1, zo) / omz2 / omzo /
     # zo * rH1(1, x1) - rH1(0, zo) * rH1(0, x1) / omx1 / omz2 / omzo * 
     #zo / 0.2D1 + rH1(1, zo) * rH1(0, x1) / omx1 / omz2 / omzo * zo / 0
     #.2D1 + rH1(1, x1) * rH1(0, x1) / omx1 / omz2 / omzo * zo / 0.2D1 +
     # rH1(0, zo) * rH1(0, x1) / omx1 / omz2 / omzo - rH1(0, zo) * rH1(0
     #, x1) / omx1 / omz2 / omzo / zo + (-0.1D1 / 0.4D1 - x1 / 0.4D1) * 
     #dls ** 2 / omz2 / omzo / zo + (x1 / 0.2D1 - 0.1D1 / 0.2D1) * dls /
     # omz2 / omzo / zo + (0.1D1 / 0.2D1 + x1 / 0.2D1) * rH1(0, zo) * dl
     #s / omz2 / omzo / zo + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rH1(1, zo) 
     #* dls / omz2 / omzo / zo + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rH1(0, 
     #x1) * dls / omz2 / omzo / zo + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rH1
     #(1, x1) * dls / omz2 / omzo / zo + rH1(0, x1) * dls / omx1 / omz2 
     #/ omzo * zo / 0.2D1 + (0.1D1 / 0.24D2 + x1 / 0.24D2) / omz2 / omzo
     # * pi ** 2 / zo + rH1(1, zo) / omz2 / omzo + rH1(0, x1) / omz2 / o
     #mzo + rH1(1, x1) / omz2 / omzo - d1x1 * dls / omz2 / omzo * zo / 0
     #.2D1 - d1x1 * dls / omz2 / omzo / zo + rH1(0, zo) * d1x1 / omz2 / 
     #omzo * zo / 0.2D1 - rH1(1, zo) * d1x1 / omz2 / omzo * zo / 0.2D1 -
     # rH1(0, zo) * d1x1 / omz2 / omzo + rH1(0, zo) * d1x1 / omz2 / omzo
     # / zo - d0x1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 - d0x1 / omz2 /
     # omzo * pi ** 2 / zo / 0.12D2 + d0x1 / omz2 / omzo * zo * rH1(0, z
     #o) ** 2 / 0.4D1 + rH1(1, zo) ** 2 * d0x1 / omz2 / omzo * zo / 0.4D
     #1 + rH1(1, zo) * rH1(0, zo) * d0x1 / omz2 / omzo + rH1(0, zo) ** 2
     # * d0x1 / omz2 / omzo / zo / 0.2D1 + rH1(1, zo) ** 2 * d0x1 / omz2
     # / omzo / zo / 0.2D1 + rH1(0, zo) * d0x1 * dls / omz2 / omzo - rH1
     #(1, zo) * d1x1 / omz2 / omzo / zo - rH1(1, zo) * rH1(0, zo) * d0x1
     # / omz2 / omzo * zo / 0.2D1 - rH1(0, zo) * d0x1 * dls / omz2 / omz
     #o * zo / 0.2D1 + rH1(1, zo) * d0x1 * dls / omz2 / omzo * zo / 0.2D
     #1 - rH1(1, zo) * d0x1 * dls / omz2 / omzo + rH1(1, zo) * d0x1 * dl
     #s / omz2 / omzo / zo + d2x1 / omz2 / omzo * zo / 0.4D1 + d2x1 / om
     #z2 / omzo / zo / 0.2D1 + rH1(1, zo) * d1x1 / omz2 / omzo - rH1(0, 
     #zo) ** 2 * d0x1 / omz2 / omzo / 0.2D1 - rH1(1, zo) ** 2 * d0x1 / o
     #mz2 / omzo / 0.2D1 + d1x1 * dls / omz2 / omzo + d0x1 / omz2 / omzo
     # * pi ** 2 / 0.12D2 - d0x1 * dls ** 2 / omz2 / omzo / 0.2D1 + d1x1
     # / omz2 / omzo * zo / 0.2D1
      endif
      endif

      if(ielocal.eq.-2)then
        rJ21QQIFqgam_frag_ho=e2
      elseif(ielocal.eq.-1)then
        rJ21QQIFqgam_frag_ho=e1
      elseif(ielocal.eq.0)then
        rJ21QQIFqgam_frag_ho=e0
      elseif(ielocal.eq.1)then
        rJ21QQIFqgam_frag_ho=em1
      elseif(ielocal.eq.2)then
        rJ21QQIFqgam_frag_ho=em2
      endif

*      write(*,*)" rJ21QQIFqgam_frag_ho ",rJ21QQIFqgam_frag_ho

      return
      end
************************************************************************
*
      function rJ21QQIFqgam_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQIFqgam_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QQIFqgam_frag_gen=rJ21QQFIqgam_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QQIFqgam_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 / omz2 / omzo * zo / 0.2D1 + d0x1 / omz2 / omzo - d0x
     #1 / omz2 / omzo / zo + 0.1D1 / omz1 / omz2 / omzo * dla * zo / 0.2
     #D1 - 0.1D1 / omz1 / omz2 / omzo * dla + 0.1D1 / omz1 / omz2 / omzo
     # * dla / zo - dls / omz1 / omz2 / omzo * zo / 0.2D1 + dls / omz1 /
     # omz2 / omzo - dls / omz1 / omz2 / omzo / zo + zo / omz1 / omz2 / 
     #omzo / 0.2D1 + rH1(0, zo) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(
     #1, z1) * zo / omz1 / omz2 / omzo / 0.2D1 - rH1(1, zo) * zo / omz1 
     #/ omz2 / omzo / 0.2D1 - rH1(0, zo) / omz1 / omz2 / omzo + rH1(1, z
     #1) / omz1 / omz2 / omzo + rH1(1, zo) / omz1 / omz2 / omzo + rH1(0,
     # zo) / omz1 / omz2 / omzo / zo - rH1(1, z1) / omz1 / omz2 / omzo /
     # zo - rH1(1, zo) / omz1 / omz2 / omzo / zo
      endif
      if(ix.eq.3.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = d0x1 / omz2 / omzo * zo / 0.2D1 - d0x1 / omz2 / omzo + d0x1
     # / omz2 / omzo / zo + 0.1D1 / omz2 / omzo + (-0.1D1 / 0.2D1 - x1 /
     # 0.2D1) / omz2 / omzo / zo
      endif

      if(ieorder.eq.-2)then
        rJ21QQIFqgam_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QQIFqgam_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QQIFqgam_frag_gen=e0
      endif

*      write(*,*)" rJ21QQIFqgam_frag_gen ",rJ21QQIFqgam_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QQIFqgam_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQIFqgam_frag = rJ21QQIFqgam_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QQIFqgam_frag

C---- wrapper 2
      function rJ21QQIFqgam_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQIFqgam_frag2 = rJ21QQIFqgam_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QQIFqgam_frag2

************************************************************************
*
      function rJ21QQIFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQIFqg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QQIFqg_frag_gen=rJ21QQFIqg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QQIFqg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 / omz2 * z / 0.2D1 + d0x1 / omz2 - d0x1 / omz2 / z + 
     #dla / omz1 / omz2 * z / 0.2D1 - dla / omz1 / omz2 + dla / omz1 / o
     #mz2 / z - dls / omz1 / omz2 * z / 0.2D1 + dls / omz1 / omz2 - dls 
     #/ omz1 / omz2 / z + 0.1D1 / omz1 / omz2 * z / 0.2D1 + rH1(0, z) / 
     #omz1 / omz2 * z / 0.2D1 - rH1(1, z) / omz1 / omz2 * z / 0.2D1 - rH
     #1(1, z1) / omz1 / omz2 * z / 0.2D1 - rH1(0, z) / omz1 / omz2 + rH1
     #(1, z) / omz1 / omz2 + rH1(1, z1) / omz1 / omz2 + rH1(0, z) / omz1
     # / omz2 / z - rH1(1, z) / omz1 / omz2 / z - rH1(1, z1) / omz1 / om
     #z2 / z
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x1 / omz2 * z / 0.2D1 - d0x1 / omz2 + d0x1 / omz2 / z + 0
     #.1D1 / omz2 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QQIFqg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QQIFqg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QQIFqg_frag_gen=e0
      endif

*      write(*,*)" rJ21QQIFqg_frag_gen ",rJ21QQIFqg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QQIFqg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQIFqg_frag = rJ21QQIFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QQIFqg_frag

C---- wrapper 2
      function rJ21QQIFqg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQIFqg_frag2 = rJ21QQIFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QQIFqg_frag2

************************************************************************
*
      function rJ21QQIFqq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQIFqq_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QQIFqq_frag_gen=rJ21QQFIqq_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QQIFqq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.3D1 / 0.2D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x1 / omz2 - 0.1D1 / omz2 / omzo * d0x1 * dlm + dls 
     #/ omz2 / omzo * d0x1 + 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * rH1(1, z1) 
     #* d0z + dls / omz1 / omz2 * d0z - 0.1D1 / omz2 / omzo * d1x1 - 0.1
     #D1 / omz1 / omz2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) *
     # dla + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo * dla - 0.1D1 / omz1 / o
     #mz2 / omzo * rH1(1, z1) * dlm + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo
     # * dlm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 / o
     #mz1 / omz2 / omzo * rH1(1, z1) * dls + dls / omz1 / omz2 / omzo * 
     #rH1(1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z1) 
     #+ 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, z1) + 0.1D1 / omz1 / omz2
     # / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.3.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + 0.1D1 / omz2 / omzo * d0x1 * dlm - dls
     # / omz2 / omzo * d0x1 - 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 + 
     #(0.1D1 / 0.2D1 + x1 / 0.2D1) * d0z / omz2 + 0.1D1 / omz2 / omzo * 
     #d1x1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz2 / omzo * dlm + (0.1D1 
     #/ 0.2D1 + x1 / 0.2D1) / omz2 / omzo * dls + (0.1D1 / 0.2D1 + x1 / 
     #0.2D1) / omz2 / omzo * rH1(1, zo) + (0.1D1 / 0.2D1 + x1 / 0.2D1) *
     # rH1(1, x1) / omzo / omz2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 / 
     #omzo * rH1(0, x1) + (-x1 / 0.2D1 + 0.1D1 / 0.2D1) / omz2 / omzo - 
     #0.1D1 / omz2 / omzo * rH1(0, x1) / omx1
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + d0x1 / omz2 / 0.2D1 + z * d0x1 / omz2 
     #/ 0.2D1 + 0.1D1 / omz1 / omz2 * d0z * dla - 0.1D1 / omz1 / omz2 * 
     #rH1(1, z1) * d0z - dls / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2 *
     # d1z - dla / omz1 / omz2 / 0.2D1 - z * dla / omz1 / omz2 / 0.2D1 +
     # dls / omz1 / omz2 / 0.2D1 + z * dls / omz1 / omz2 / 0.2D1 - 0.1D1
     # / omz1 / omz2 * z / 0.2D1 + rH1(1, z1) / omz1 / omz2 * z / 0.2D1 
     #- rH1(0, z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z) / omz1 / omz2 * 
     #z / 0.2D1 + 0.1D1 / omz1 / omz2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH
     #1(1, z1) / 0.2D1 - 0.1D1 / omz1 / omz2 * rH1(0, z) / 0.2D1 + rH1(1
     #, z) / omz1 / omz2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(0, z) / omz
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x1 / omz2 - d0x1 / omz2 / 0.2D1 - z * d0x1 / omz2 /
     # 0.2D1 + 0.1D1 / omz2 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * d0z / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21QQIFqq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QQIFqq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QQIFqq_frag_gen=e0
      endif

*      write(*,*)" rJ21QQIFqq_frag_gen ",rJ21QQIFqq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QQIFqq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQIFqq_frag = rJ21QQIFqq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QQIFqq_frag

C---- wrapper 2
      function rJ21QQIFqq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QQIFqq_frag2 = rJ21QQIFqq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QQIFqq_frag2

************************************************************************
*
      function rJ21QGIFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGIFqg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QGIFqg_frag_gen=rJ21GQFIqg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21QGIFqg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x1 / omz2 - 0.1D1 / omz2 / omzo * d0x1 * dlm + dls 
     #/ omz2 / omzo * d0x1 + 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * rH1(1, z1) 
     #* d0z + dls / omz1 / omz2 * d0z - 0.1D1 / omz2 / omzo * d1x1 - 0.1
     #D1 / omz1 / omz2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) *
     # dla + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * dla - 0.1D1 / omz1 /
     # omz2 / omzo * rH1(1, z1) * dlm + 0.3D1 / 0.4D1 / omz1 / omz2 / om
     #zo * dlm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 /
     # omz1 / omz2 / omzo * rH1(1, z1) * dls + dls / omz1 / omz2 / omzo 
     #* rH1(1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z1
     #) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, z1) + 0.1D1 / omz1 / om
     #z2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.3.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + 0.1D1 / omz2 / omzo * d0x1 * dlm - dls
     # / omz2 / omzo * d0x1 - 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 + 
     #(0.1D1 / 0.2D1 + x1 / 0.2D1) * d0z / omz2 + 0.1D1 / omz2 / omzo * 
     #d1x1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz2 / omzo * dlm + (0.1D1 
     #/ 0.2D1 + x1 / 0.2D1) / omz2 / omzo * dls + (0.1D1 / 0.2D1 + x1 / 
     #0.2D1) / omz2 / omzo * rH1(1, zo) + (0.1D1 / 0.2D1 + x1 / 0.2D1) *
     # rH1(1, x1) / omzo / omz2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 / 
     #omzo * rH1(0, x1) + (-x1 / 0.2D1 + 0.1D1 / 0.2D1) / omz2 / omzo - 
     #0.1D1 / omz2 / omzo * rH1(0, x1) / omx1
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z * dla + 0.2D1 / omz1 / omz2 * rH1
     #(1, z1) + 0.1D1 / omz1 / omz2 * d1z - d0z * d0x1 / omz2 + 0.2D1 * 
     #dls / omz1 / omz2 - 0.1D1 / omz1 / omz2 * rH1(1, z1) * d0z - dls /
     # omz1 / omz2 * d0z + 0.2D1 * d0x1 / omz2 - z * d0x1 / omz2 + rH1(1
     #, z1) / omz1 / omz2 * z ** 2 + rH1(1, z) / omz1 / omz2 * z ** 2 + 
     #rH1(0, z) / omz1 / omz2 / z + d0x1 / omz2 * z ** 2 - d0x1 / omz2 /
     # z - 0.2D1 * dla / omz1 / omz2 - 0.2D1 / omz1 / omz2 * rH1(0, z) +
     # 0.2D1 * rH1(1, z) / omz1 / omz2 - rH1(1, z1) / omz1 / omz2 * z + 
     #rH1(0, z) / omz1 / omz2 * z - rH1(1, z) / omz1 / omz2 * z - z * dl
     #s / omz1 / omz2 + z * dla / omz1 / omz2 - rH1(0, z) / omz1 / omz2 
     #* z ** 2 - rH1(1, z1) / omz1 / omz2 / z - rH1(1, z) / omz1 / omz2 
     #/ z + 0.1D1 / omz1 / omz2 * rH1(0, z) / omz + dla / omz1 / omz2 / 
     #z + dls / omz1 / omz2 * z ** 2 - dls / omz1 / omz2 / z - dla / omz
     #1 / omz2 * z ** 2
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x1 / omz2 - d0x1 / omz2 * z ** 2 + z * d0x1 / omz2 
     #- 0.2D1 * d0x1 / omz2 + d0x1 / omz2 / z + (-0.1D1 / 0.2D1 - x1 / 0
     #.2D1) * d0z / omz2 - 0.1D1 / x1 / omz2 * z ** 2 + 0.1D1 / x1 / omz
     #2 * z - 0.1D1 / x1 / omz2 / 0.2D1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) 
     #/ omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QGIFqg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21QGIFqg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21QGIFqg_frag_gen=e0
      endif

*      write(*,*)" rJ21QGIFqg_frag_gen ",rJ21QGIFqg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21QGIFqg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGIFqg_frag = rJ21QGIFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21QGIFqg_frag

C---- wrapper 2
      function rJ21QGIFqg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21QGIFqg_frag2 = rJ21QGIFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21QGIFqg_frag2

************************************************************************
*
      function rJ21GQIFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQIFgq_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GQIFgq_frag_gen=rJ21QGFIgq_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GQIFgq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x1 / omz2 - 0.1D1 / omz2 / omzo * d0x1 * dlm + dls 
     #/ omz2 / omzo * d0x1 + 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * rH1(1, z1) 
     #* d0z + dls / omz1 / omz2 * d0z - 0.1D1 / omz2 / omzo * d1x1 - 0.1
     #D1 / omz1 / omz2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) *
     # dla + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo * dla - 0.1D1 / omz1 / o
     #mz2 / omzo * rH1(1, z1) * dlm + 0.11D2 / 0.12D2 / omz1 / omz2 / om
     #zo * dlm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 /
     # omz1 / omz2 / omzo * rH1(1, z1) * dls + dls / omz1 / omz2 / omzo 
     #* rH1(1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z1
     #) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, z1) + 0.1D1 / omz1 / om
     #z2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.3.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + 0.1D1 / omz2 / omzo * d0x1 * dlm - dls
     # / omz2 / omzo * d0x1 - 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 + 
     #(x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * d0z / omz2 + 0.1D1
     # / omz2 / omzo * d1x1 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) /
     # x1 / omz2 / omzo * dlm + dls * (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 
     #0.1D1) / x1 / omz2 / omzo + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D
     #1) / x1 / omz2 / omzo * rH1(1, zo) + (x1 ** 3 - x1 ** 2 + 0.2D1 * 
     #x1 - 0.1D1) / x1 / omz2 / omzo * rH1(1, x1) + (x1 ** 3 - x1 ** 2 +
     # 0.2D1 * x1 - 0.1D1) / x1 / omz2 / omzo * rH1(0, x1) - 0.1D1 / omz
     #2 / omzo * rH1(0, x1) / omx1
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + d0x1 / omz2 / 0.2D1 + z * d0x1 / omz2 
     #/ 0.2D1 + 0.1D1 / omz1 / omz2 * d0z * dla - 0.1D1 / omz1 / omz2 * 
     #rH1(1, z1) * d0z - dls / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2 *
     # d1z - dla / omz1 / omz2 / 0.2D1 - z * dla / omz1 / omz2 / 0.2D1 +
     # dls / omz1 / omz2 / 0.2D1 + z * dls / omz1 / omz2 / 0.2D1 - 0.1D1
     # / omz1 / omz2 * z / 0.2D1 + rH1(1, z1) / omz1 / omz2 * z / 0.2D1 
     #- rH1(0, z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z) / omz1 / omz2 * 
     #z / 0.2D1 + 0.1D1 / omz1 / omz2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH
     #1(1, z1) / 0.2D1 - 0.1D1 / omz1 / omz2 * rH1(0, z) / 0.2D1 + rH1(1
     #, z) / omz1 / omz2 / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(0, z) / omz
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x1 / omz2 - z * d0x1 / omz2 / 0.2D1 - d0x1 / omz2 /
     # 0.2D1 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * d0
     #z - 0.3D1 / 0.2D1 / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21GQIFgq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GQIFgq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GQIFgq_frag_gen=e0
      endif

*      write(*,*)" rJ21GQIFgq_frag_gen ",rJ21GQIFgq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GQIFgq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQIFgq_frag = rJ21GQIFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GQIFgq_frag

C---- wrapper 2
      function rJ21GQIFgq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQIFgq_frag2 = rJ21GQIFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GQIFgq_frag2

************************************************************************
*
      function rJ21GQIFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQIFgg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GQIFgg_frag_gen=rJ21QGFIgg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GQIFgg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -z * d0x1 / omz2 / 0.2D1 + d0x1 / omz2 - d0x1 / omz2 / z + 
     #z * dla / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 + dla / omz1 / o
     #mz2 / z - z * dls / omz1 / omz2 / 0.2D1 + dls / omz1 / omz2 - dls 
     #/ omz1 / omz2 / z + 0.1D1 / omz1 / omz2 * z / 0.2D1 + rH1(0, z) / 
     #omz1 / omz2 * z / 0.2D1 - rH1(1, z) / omz1 / omz2 * z / 0.2D1 - rH
     #1(1, z1) / omz1 / omz2 * z / 0.2D1 - 0.1D1 / omz1 / omz2 * rH1(0, 
     #z) + rH1(1, z) / omz1 / omz2 + 0.1D1 / omz1 / omz2 * rH1(1, z1) + 
     #rH1(0, z) / omz1 / omz2 / z - rH1(1, z) / omz1 / omz2 / z - rH1(1,
     # z1) / omz1 / omz2 / z
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = z * d0x1 / omz2 / 0.2D1 - d0x1 / omz2 + d0x1 / omz2 / z - 0
     #.3D1 / 0.2D1 / omz2 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x
     #1 / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21GQIFgg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GQIFgg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GQIFgg_frag_gen=e0
      endif

*      write(*,*)" rJ21GQIFgg_frag_gen ",rJ21GQIFgg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GQIFgg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQIFgg_frag = rJ21GQIFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GQIFgg_frag

C---- wrapper 2
      function rJ21GQIFgg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQIFgg_frag2 = rJ21GQIFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GQIFgg_frag2

************************************************************************
*
      function rJ21GGIFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGIFgg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GGIFgg_frag_gen=rJ21GGFIgg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GGIFgg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.11D2 / 0.6D1 / omz1 / omz2 / o
     #mzo
      e0 = d0z * d0x1 / omz2 - 0.1D1 / omz2 / omzo * d0x1 * dlm + 0.1D
     #1 / omz2 / omzo * rH1(1, zo) * d0x1 + dls / omz2 / omzo * d0x1 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + dls / omz1 / omz2 * d0z + 0.1D1 /
     # omz1 / omz2 * rH1(1, z1) * d0z - 0.1D1 / omz2 / omzo * d1x1 - 0.1
     #D1 / omz1 / omz2 * d1z + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * dl
     #a - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.11D2 / 0.12D
     #2 / omz1 / omz2 / omzo * dlm - 0.1D1 / omz1 / omz2 / omzo * rH1(1,
     # z1) * dlm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1
     # / omz1 / omz2 / omzo * rH1(1, z1) * dls + dls / omz1 / omz2 / omz
     #o * rH1(1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, 
     #z1) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, z1) + 0.1D1 / omz1 / 
     #omz2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D
     #2
      endif
      if(ix.eq.3.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + 0.1D1 / omz2 / omzo * d0x1 * dlm - 0.1
     #D1 / omz2 / omzo * rH1(1, zo) * d0x1 - dls / omz2 / omzo * d0x1 + 
     #(x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * d0z + 0.1D1
     # / omz2 / omzo * d1x1 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) /
     # x1 / omz2 / omzo * dlm + dls * (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 
     #0.1D1) / x1 / omz2 / omzo + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D
     #1) / x1 / omz2 / omzo * rH1(0, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 * 
     #x1 - 0.1D1) / x1 / omz2 / omzo * rH1(1, x1) + (x1 ** 3 - x1 ** 2 +
     # 0.2D1 * x1 - 0.1D1) / x1 / omz2 / omzo * rH1(1, zo) - 0.1D1 / omz
     #2 / omzo * rH1(0, x1) / omx1
      endif
      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z * dla + dla / omz1 / omz2 / z - d
     #ls / omz1 / omz2 / z - rH1(1, z) / omz1 / omz2 / z - rH1(1, z1) / 
     #omz1 / omz2 / z + 0.2D1 / omz1 / omz2 * rH1(1, z1) + 0.1D1 / omz1 
     #/ omz2 * d1z - d0x1 / omz2 / z - d0z * d0x1 / omz2 + 0.2D1 * dls /
     # omz1 / omz2 - 0.1D1 / omz1 / omz2 * rH1(1, z1) * d0z - dls / omz1
     # / omz2 * d0z + 0.2D1 * d0x1 / omz2 - z * d0x1 / omz2 - 0.2D1 * dl
     #a / omz1 / omz2 - 0.2D1 / omz1 / omz2 * rH1(0, z) + 0.2D1 * rH1(1,
     # z) / omz1 / omz2 + rH1(0, z) / omz1 / omz2 / z - rH1(1, z1) / omz
     #1 / omz2 * z + rH1(0, z) / omz1 / omz2 * z - rH1(1, z) / omz1 / om
     #z2 * z - z * dls / omz1 / omz2 + z * dla / omz1 / omz2 + dls / omz
     #1 / omz2 * z ** 2 - rH1(0, z) / omz1 / omz2 * z ** 2 - dla / omz1 
     #/ omz2 * z ** 2 + 0.1D1 / omz1 / omz2 * rH1(0, z) / omz + rH1(1, z
     #) / omz1 / omz2 * z ** 2 + rH1(1, z1) / omz1 / omz2 * z ** 2 + d0x
     #1 / omz2 * z ** 2
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x1 / omz2 - d0x1 / omz2 * z ** 2 + z * d0x1 / omz2 
     #- 0.2D1 * d0x1 / omz2 + d0x1 / omz2 / z - (x1 ** 3 - x1 ** 2 + 0.2
     #D1 * x1 - 0.1D1) / x1 / omz2 * d0z - 0.1D1 / x1 / omz2 * z ** 2 + 
     #0.1D1 / x1 / omz2 * z - 0.2D1 / x1 / omz2 - (x1 ** 3 - x1 ** 2 + 0
     #.2D1 * x1 - 0.1D1) / x1 / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21GGIFgg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GGIFgg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GGIFgg_frag_gen=e0
      endif

*      write(*,*)" rJ21GGIFgg_frag_gen ",rJ21GGIFgg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GGIFgg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGIFgg_frag = rJ21GGIFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GGIFgg_frag

C---- wrapper 2
      function rJ21GGIFgg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGIFgg_frag2 = rJ21GGIFgg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GGIFgg_frag2

************************************************************************
*
      function rJ21hGGIFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGGIFgq_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21hGGIFgq_frag_gen=rJ21hGGFIgq_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21hGGIFgq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 / omz2 / 0.4D1 + z * d0x1 / omz2 / 0.2D1 - z ** 2 * d
     #0x1 / omz2 / 0.2D1 + dla / omz1 / omz2 / 0.4D1 - z * dla / omz1 / 
     #omz2 / 0.2D1 + z ** 2 * dla / omz1 / omz2 / 0.2D1 - dls / omz1 / o
     #mz2 / 0.4D1 + z * dls / omz1 / omz2 / 0.2D1 - z ** 2 * dls / omz1 
     #/ omz2 / 0.2D1 - 0.1D1 / omz1 / omz2 * z ** 2 / 0.2D1 + rH1(0, z) 
     #/ omz1 / omz2 * z ** 2 / 0.2D1 - rH1(1, z) / omz1 / omz2 * z ** 2 
     #/ 0.2D1 - rH1(1, z1) / omz1 / omz2 * z ** 2 / 0.2D1 + 0.1D1 / omz1
     # / omz2 * z / 0.2D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z1) / omz1 / omz2 * z / 0.2
     #D1 + rH1(0, z) / omz1 / omz2 / 0.4D1 - rH1(1, z) / omz1 / omz2 / 0
     #.4D1 - rH1(1, z1) / omz1 / omz2 / 0.4D1
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x1 / omz2 / 0.4D1 - z * d0x1 / omz2 / 0.2D1 + z ** 2 * d0
     #x1 / omz2 / 0.2D1 + 0.1D1 / x1 / omz2 * z ** 2 / 0.2D1 - 0.1D1 / x
     #1 / omz2 * z / 0.2D1 + 0.1D1 / x1 / omz2 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGIFgq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGIFgq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21hGGIFgq_frag_gen=e0
      endif

*      write(*,*)" rJ21hGGIFgq_frag_gen ",rJ21hGGIFgq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21hGGIFgq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGIFgq_frag = rJ21hGGIFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21hGGIFgq_frag

C---- wrapper 2
      function rJ21hGGIFgq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hGGIFgq_frag2 = rJ21hGGIFgq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21hGGIFgq_frag2

************************************************************************
*
      function rJ21hQGIFqqp_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hQGIFqqp_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21hQGIFqqp_frag_gen=rJ21hGQFIqqp_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21hQGIFqqp_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 / omz2 / 0.4D1 + z * d0x1 / omz2 / 0.2D1 - z ** 2 * d
     #0x1 / omz2 / 0.2D1 + dla / omz1 / omz2 / 0.4D1 - z * dla / omz1 / 
     #omz2 / 0.2D1 + z ** 2 * dla / omz1 / omz2 / 0.2D1 - dls / omz1 / o
     #mz2 / 0.4D1 + z * dls / omz1 / omz2 / 0.2D1 - z ** 2 * dls / omz1 
     #/ omz2 / 0.2D1 - 0.1D1 / omz1 / omz2 * z ** 2 / 0.2D1 + rH1(0, z) 
     #/ omz1 / omz2 * z ** 2 / 0.2D1 - rH1(1, z) / omz1 / omz2 * z ** 2 
     #/ 0.2D1 - rH1(1, z1) / omz1 / omz2 * z ** 2 / 0.2D1 + 0.1D1 / omz1
     # / omz2 * z / 0.2D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z1) / omz1 / omz2 * z / 0.2
     #D1 + rH1(0, z) / omz1 / omz2 / 0.4D1 - rH1(1, z) / omz1 / omz2 / 0
     #.4D1 - rH1(1, z1) / omz1 / omz2 / 0.4D1
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x1 / omz2 / 0.4D1 - z * d0x1 / omz2 / 0.2D1 + z ** 2 * d0
     #x1 / omz2 / 0.2D1 + 0.1D1 / x1 / omz2 * z ** 2 / 0.2D1 - 0.1D1 / x
     #1 / omz2 * z / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21hQGIFqqp_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21hQGIFqqp_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21hQGIFqqp_frag_gen=e0
      endif

*      write(*,*)" rJ21hQGIFqqp_frag_gen ",rJ21hQGIFqqp_frag_gen

      return
      end

C---- wrapper 1
      function rJ21hQGIFqqp_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hQGIFqqp_frag = rJ21hQGIFqqp_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21hQGIFqqp_frag

C---- wrapper 2
      function rJ21hQGIFqqp_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21hQGIFqqp_frag2 = rJ21hQGIFqqp_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21hQGIFqqp_frag2

************************************************************************
*
      function rJ21GQqtogIFqpq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQqtogIFqpq_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GQqtogIFqpq_frag_gen=rJ21QGqtogFIqpq_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GQqtogIFqpq_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.3.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0z / omz2 / 0.2D1 +
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omzo / omz2 * dlm / 0.2D1 -
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omzo / omz2 * dls / 0.2D1 -
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo * rH1(0, x1) / 
     #0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo * rH1(1,
     # x1) / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo *
     # rH1(1, zo) / 0.2D1 + x1 / omz2 / omzo / 0.2D1
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0z / omz2 / 0.2D1 + 
     #(x1 - 0.2D1) / x1 / omz2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GQqtogIFqpq_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GQqtogIFqpq_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GQqtogIFqpq_frag_gen=e0
      endif

*      write(*,*)" rJ21GQqtogIFqpq_frag_gen ",rJ21GQqtogIFqpq_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GQqtogIFqpq_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQqtogIFqpq_frag = rJ21GQqtogIFqpq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GQqtogIFqpq_frag

C---- wrapper 2
      function rJ21GQqtogIFqpq_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GQqtogIFqpq_frag2 = rJ21GQqtogIFqpq_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GQqtogIFqpq_frag2

************************************************************************
*
      function rJ21GGqtogIFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,ifrag)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin, z2frag_kin, zreg2frag_kin
      use PhotonFragmentation_mod, only : iz_frag, iz2_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGqtogIFqg_frag_gen: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GGqtogIFqg_frag_gen=rJ21GGqtogFIqg_frag_gen(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2,ifrag)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if (ifrag == 1) then
        izz=iz_frag
        z=zregfrag_kin
        zo=zfrag_kin
      else if (ifrag == 2) then
        izz=iz2_frag
        z=zreg2frag_kin
        zo=z2frag_kin
      else
        stop "J21GGqtogIFqg_frag_gen: invalid ifrag"
      end if

      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.3.and.izz.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0z / omz2 / 0.2D1 +
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omzo / omz2 * dlm / 0.2D1 -
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omzo / omz2 * dls / 0.2D1 -
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo * rH1(0, x1) / 
     #0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo * rH1(1,
     # x1) / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo *
     # rH1(1, zo) / 0.2D1 + x1 / omz2 / omzo / 0.2D1
      endif
      if(ix.eq.3.and.izz.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0z / omz2 / 0.2D1 - 
     #0.1D1 / x1 / omz2 * z / 0.2D1 - 0.1D1 / x1 / omz2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GGqtogIFqg_frag_gen=e2
      elseif(ieorder.eq.-1)then
        rJ21GGqtogIFqg_frag_gen=e1
      elseif(ieorder.eq.0)then
        rJ21GGqtogIFqg_frag_gen=e0
      endif

*      write(*,*)" rJ21GGqtogIFqg_frag_gen ",rJ21GGqtogIFqg_frag_gen

      return
      end

C---- wrapper 1
      function rJ21GGqtogIFqg_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGqtogIFqg_frag = rJ21GGqtogIFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,1)
      end function rJ21GGqtogIFqg_frag

C---- wrapper 2
      function rJ21GGqtogIFqg_frag2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      implicit double precision (a-h,o-z)
      rJ21GGqtogIFqg_frag2 = rJ21GGqtogIFqg_frag_gen(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2,2)
      end function rJ21GGqtogIFqg_frag2

