************************************************************************
*
      function rJ22QQFIqgam_fragh(ix,x1,x2,zo,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use PhotonFragmentation_mod, only : iz_frag
      implicit double precision (a-h,o-z)
      logical :: region1 = .false.
      logical :: region2 = .false.
      logical :: region3 = .false.
      logical :: region4 = .false.
      common /order/ieorder
      common /method/imethod
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J22QQFIqgam_fragh: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        stop 'wrong index asigned in J22QQFIqgam_fragh'
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      dlogomx1=-rH1(1,x1)
      d0x1=1d0/omx1
      d1x1=dlogomx1*d0x1
      d2x1=dlogomx1*d1x1
      d3x1=dlogomx1*d2x1
      dlogomx2=-rH1(1,x2)
      d0x2=1d0/omx2
      d1x2=dlogomx2*d0x2
      d2x2=dlogomx2*d1x2
      d3x2=dlogomx2*d2x2

      if((zo==x2) .or. (zo==omx2))then
        rJ22QQFIqgam_fragh=0d0
        return
      else if((0d0 < zo) .and. (zo < min(x2,omx2)))then
        region1=.true.
      else if((omx2 < zo) .and. (zo < x2))then
        region2=.true.
      else if((x2 < zo) .and. (zo < omx2))then
        region3=.true.
      else if((max(x2,omx2) < zo) .and. (zo < 1d0))then
        region4=.true.
      endif

      if(ix.eq.1.and.iz_frag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.35D2 / 0.8D1 / omz1 / omz2 / omzo - rH1(1, zo) * d0x2 * d
     #la / omz1 / omzo * zo / 0.2D1 - rH1(0, zo) * d0x2 * dla / omz1 / o
     #mzo * zo / 0.4D1 + rH1(1, zo) * d0x2 * dla / omz1 / omzo - rH1(1, 
     #zo) * d0x2 * dla / omz1 / omzo / zo + rH1(1, zo) * d0x2 * dls / om
     #z1 / omzo * zo / 0.2D1 + rH1(0, zo) * d0x2 * dls / omz1 / omzo * z
     #o / 0.4D1 - rH1(1, zo) * rH1(0, zo) * d0x2 / omz1 / omzo * zo / 0.
     #2D1 + rH1(1, zo) * d0x2 / omz1 / omzo * rH1(0, zo) - rH1(1, zo) * 
     #rH1(0, zo) * d0x2 / omz1 / omzo / zo + rH1(1, zo) * dla ** 2 / omz
     #1 / omz2 / omzo * zo / 0.4D1 + rH1(1, zo) * dla ** 2 / omz1 / omz2
     # / omzo / zo / 0.2D1 - dla / omz1 / omz2 / omzo * pi ** 2 / zo / 0
     #.6D1 - dla / omz1 / omz2 / omzo * zo * rH1(1, z2) / 0.8D1 - rH1(1,
     # zo) ** 2 * dla / omz1 / omz2 / omzo * zo / 0.4D1 + rH1(1, z2) * d
     #la / omz1 / omz2 / omzo * rH1(0, zo) / 0.2D1 - rH1(1, zo) * dla / 
     #omz1 / omz2 / omzo * rH1(0, zo) - 0.2D1 * rH2(0, 1, zo) * dla / om
     #z1 / omz2 / omzo / zo - rH1(1, zo) ** 2 * dla / omz1 / omz2 / omzo
     # / zo / 0.2D1 + rH1(1, zo) * dls ** 2 / omz1 / omz2 / omzo * zo / 
     #0.4D1 + rH1(1, zo) * dls ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 + 
     #dls / omz1 / omz2 / omzo * pi ** 2 / zo / 0.6D1 + dls / omz1 / omz
     #2 / omzo * zo * rH1(1, z2) / 0.8D1 + rH1(1, zo) ** 2 * dls / omz1 
     #/ omz2 / omzo * zo / 0.4D1 - rH1(1, z2) * dls / omz1 / omz2 / omzo
     # * rH1(0, zo) / 0.2D1 - rH1(1, zo) * dls / omz1 / omz2 / omzo * rH
     #1(1, z2) + 0.2D1 * rH2(0, 1, zo) * dls / omz1 / omz2 / omzo / zo +
     # rH1(1, zo) ** 2 * dls / omz1 / omz2 / omzo / zo / 0.2D1 + rH1(1, 
     #z2) / omz1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + rH1(1, zo) / om
     #z1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + rH1(1, z2) / omz1 / omz
     #2 / omzo * pi ** 2 / zo / 0.6D1 + rH1(1, zo) / omz1 / omz2 / omzo 
     #* pi ** 2 / zo / 0.12D2 + rH1(1, zo) / omz1 / omz2 / omzo * zo * r
     #H1(0, zo) ** 2 / 0.4D1 + rH2(1, 1, z2) / omz1 / omz2 / omzo * zo *
     # rH1(0, zo) / 0.4D1 + rH1(1, zo) / omz1 / omz2 / omzo * zo * rH1(1
     #, z2) / 0.8D1 + 0.5D1 / 0.4D1 * rH2(0, 1, zo) / omz1 / omz2 / omzo
     # * zo * rH1(1, z2) + rH1(1, zo) ** 2 / omz1 / omz2 / omzo * zo * r
     #H1(1, z2) / 0.4D1 + rH2(1, 1, z2) / omz1 / omz2 / omzo * zo * rH1(
     #1, zo) / 0.2D1 + rH1(1, zo) / omz1 / omz2 / omzo / zo * rH1(0, zo)
     # ** 2 / 0.2D1 - rH2(0, 1, zo) / omz1 / omz2 / omzo / zo * rH1(0, z
     #o) - rH1(1, zo) ** 2 / omz1 / omz2 / omzo / zo * rH1(0, zo) / 0.2D
     #1 + 0.2D1 * rH2(0, 1, zo) / omz1 / omz2 / omzo / zo * rH1(1, z2) +
     # rH1(1, zo) ** 2 / omz1 / omz2 / omzo / zo * rH1(1, z2) / 0.2D1 + 
     #0.3D1 / 0.2D1 * rH2(0, 1, zo) * rH1(1, zo) / omz1 / omz2 / omzo / 
     #zo + 0.9D1 / 0.8D1 / omz1 / omz2 / omzo * rH1(1, z2) - 0.1D1 / omz
     #1 / omz2 / omzo * rH1(1, zo) ** 3 / 0.12D2 - rH2(1, 1, z2) / omz1 
     #/ omz2 / omzo / 0.2D1 + 0.5D1 / 0.2D1 * rH2(0, 1, zo) / omz1 / omz
     #2 / omzo + 0.1D1 / omz1 / omz2 / omzo * pi ** 2 * zo / 0.16D2 + 0.
     #1D1 / omz1 / omz2 / omzo * pi ** 2 / zo / 0.8D1 + 0.7D1 / 0.4D1 / 
     #omz1 / omz2 / omzo * zeta3 * zo + rH1(0, zo) * dla * dls / omz1 / 
     #omz2 / omzo / 0.2D1 - 0.5D1 / 0.4D1 * rH2(0, 1, zo) * dla / omz1 /
     # omz2 / omzo * zo + rH1(1, zo) * rH1(0, zo) * dla / omz1 / omz2 / 
     #omzo / zo + rH1(1, zo) * rH1(1, z2) * dls / omz1 / omz2 / omzo / z
     #o - 0.1D1 / omz1 / omz2 / omzo * zo * rH1(0, zo) ** 3 / 0.16D2 + 0
     #.5D1 / 0.32D2 / omz1 / omz2 / omzo * zo * rH1(0, zo) ** 2 + 0.9D1 
     #/ 0.8D1 * d0x2 / omz1 / omzo + d1x2 / omz1 / omzo / 0.2D1 - d0x2 *
     # dla / omz1 / omzo * zo / 0.8D1 + rH1(0, zo) * d0x2 * dla / omz1 /
     # omzo / 0.2D1 + d0x2 * dls / omz1 / omzo * zo / 0.8D1 - rH1(1, zo)
     # * d0x2 * dls / omz1 / omzo - rH1(0, zo) * d0x2 * dls / omz1 / omz
     #o / 0.2D1 + d0x2 / omz1 / omzo * pi ** 2 * zo / 0.24D2 + d0x2 / om
     #z1 / omzo * pi ** 2 / zo / 0.6D1 + rH1(1, zo) * d0x2 / omz1 / omzo
     # * zo / 0.8D1 + 0.5D1 / 0.4D1 * rH2(0, 1, zo) * d0x2 / omz1 / omzo
     # * zo + rH1(1, zo) ** 2 * d0x2 / omz1 / omzo * zo / 0.4D1 + 0.2D1 
     #* rH2(0, 1, zo) * d0x2 / omz1 / omzo / zo + rH1(1, zo) ** 2 * d0x2
     # / omz1 / omzo / zo / 0.2D1 - rH1(1, zo) * d1x2 / omz1 / omzo * zo
     # / 0.2D1 - rH1(0, zo) * d1x2 / omz1 / omzo * zo / 0.4D1 + rH1(1, z
     #o) * d1x2 / omz1 / omzo - rH1(1, zo) * d1x2 / omz1 / omzo / zo - r
     #H1(1, zo) * dla ** 2 / omz1 / omz2 / omzo / 0.2D1 + dla / omz1 / o
     #mz2 / omzo * rH1(1, z2) / 0.2D1 + rH1(1, zo) ** 2 * dla / omz1 / o
     #mz2 / omzo / 0.2D1 + rH1(1, zo) * d0x2 * dls / omz1 / omzo / zo - 
     #rH1(1, zo) * dla * dls / omz1 / omz2 / omzo * zo / 0.2D1 + rH1(1, 
     #zo) * dla * dls / omz1 / omz2 / omzo - rH1(1, zo) * dla * dls / om
     #z1 / omz2 / omzo / zo - rH1(1, z2) * dla / omz1 / omz2 / omzo * zo
     # * rH1(0, zo) / 0.4D1 + rH1(1, zo) * dla / omz1 / omz2 / omzo * zo
     # * rH1(0, zo) / 0.2D1 - rH1(1, zo) * dla / omz1 / omz2 / omzo * zo
     # * rH1(1, z2) / 0.2D1 + rH1(1, zo) * dla / omz1 / omz2 / omzo * rH
     #1(1, z2) - rH1(1, zo) * rH1(1, z2) * dla / omz1 / omz2 / omzo / zo
     # + rH1(1, z2) * dls / omz1 / omz2 / omzo * zo * rH1(0, zo) / 0.4D1
     # - rH1(1, zo) * dls / omz1 / omz2 / omzo * zo * rH1(0, zo) / 0.2D1
     # + rH1(1, zo) * dls / omz1 / omz2 / omzo * zo * rH1(1, z2) / 0.2D1
     # + rH1(1, zo) * dls / omz1 / omz2 / omzo * rH1(0, zo) - rH1(1, zo)
     # * rH1(0, zo) * dls / omz1 / omz2 / omzo / zo - rH1(1, zo) * rH1(1
     #, z2) / omz1 / omz2 / omzo * zo * rH1(0, zo) / 0.2D1 + rH1(1, zo) 
     #/ omz1 / omz2 / omzo * rH1(0, zo) * rH1(1, z2) - rH1(1, zo) * rH1(
     #1, z2) / omz1 / omz2 / omzo / zo * rH1(0, zo) + rH2(1, 1, z2) * rH
     #1(1, zo) / omz1 / omz2 / omzo / zo - rH1(1, zo) * dls ** 2 / omz1 
     #/ omz2 / omzo / 0.2D1 - dls / omz1 / omz2 / omzo * rH1(1, z2) / 0.
     #2D1 - rH1(1, zo) ** 2 * dls / omz1 / omz2 / omzo / 0.2D1 - rH1(1, 
     #z2) / omz1 / omz2 / omzo * pi ** 2 / 0.12D2 - rH1(1, zo) / omz1 / 
     #omz2 / omzo * pi ** 2 / 0.12D2 + 0.3D1 / omz1 / omz2 / omzo * zeta
     #3 / zo - 0.9D1 / 0.8D1 / omz1 / omz2 / omzo * zo * rH1(1, z2) + 0.
     #1D1 / omz1 / omz2 / omzo * zo * rH1(1, zo) ** 3 / 0.24D2 + rH2(1, 
     #1, z2) / omz1 / omz2 / omzo * zo / 0.8D1 - rH1(1, zo) / omz1 / omz
     #2 / omzo * rH1(0, zo) ** 2 / 0.2D1 + 0.5D1 / 0.4D1 / omz1 / omz2 /
     # omzo * rH1(0, zo) * rH1(1, z2) - rH2(1, 1, z2) / omz1 / omz2 / om
     #zo * rH1(0, zo) / 0.2D1 - rH1(1, zo) / omz1 / omz2 / omzo * rH1(1,
     # z2) / 0.2D1 - 0.5D1 / 0.2D1 * rH2(0, 1, zo) / omz1 / omz2 / omzo 
     #* rH1(1, z2) - rH1(1, zo) ** 2 / omz1 / omz2 / omzo * rH1(1, z2) /
     # 0.2D1 - rH2(1, 1, z2) / omz1 / omz2 / omzo * rH1(1, zo) - 0.5D1 /
     # 0.8D1 / omz1 / omz2 / omzo / zo * rH1(1, z2) + 0.1D1 / omz1 / omz
     #2 / omzo / zo * rH1(1, zo) ** 3 / 0.12D2 - 0.3D1 / 0.4D1 * rH2(0, 
     #1, zo) / omz1 / omz2 / omzo / zo + rH3(1, 1, 0, zo) / omz1 / omz2 
     #/ omzo / zo / 0.2D1 + dls ** 2 / omz1 / omz2 / omzo * zo / 0.16D2 
     #- rH1(0, zo) * dls ** 2 / omz1 / omz2 / omzo / 0.4D1 + 0.5D1 / 0.4
     #D1 * dls / omz1 / omz2 / omzo * rH1(0, zo) - rH1(1, zo) * dls / om
     #z1 / omz2 / omzo / 0.2D1 - 0.5D1 / 0.2D1 * rH2(0, 1, zo) * dls / o
     #mz1 / omz2 / omzo - 0.5D1 / 0.8D1 * dls / omz1 / omz2 / omzo / zo 
     #- 0.2D1 * rH2(0, 1, zo) / omz1 / omz2 / omzo * rH1(1, zo) + 0.13D2
     # / 0.16D2 / omz1 / omz2 / omzo * zo * rH1(0, zo) + 0.3D1 / 0.16D2 
     #/ omz1 / omz2 / omzo * zo * rH1(1, zo) ** 2 - 0.9D1 / 0.8D1 / omz1
     # / omz2 / omzo * zo * rH1(1, zo) - 0.3D1 / 0.2D1 * rH2(0, 1, zo) /
     # omz1 / omz2 / omzo * zo - rH3(0, 0, 1, zo) / omz1 / omz2 / omzo *
     # zo / 0.2D1 + rH3(1, 1, 0, zo) / omz1 / omz2 / omzo * zo / 0.2D1 -
     # 0.5D1 / 0.4D1 * rH1(1, zo) / omz1 / omz2 / omzo * rH1(0, zo) + rH
     #2(0, 1, zo) / omz1 / omz2 / omzo * rH1(0, zo) / 0.2D1 + 0.3D1 / 0.
     #4D1 * rH1(1, zo) ** 2 / omz1 / omz2 / omzo * rH1(0, zo) - 0.1D1 / 
     #omz1 / omz2 / omzo * rH1(1, zo) ** 2 / 0.4D1 + 0.1D1 / omz1 / omz2
     # / omzo * rH1(1, zo) + rH3(0, 0, 1, zo) / omz1 / omz2 / omzo - rH3
     #(1, 1, 0, zo) / omz1 / omz2 / omzo + dla * dls / omz1 / omz2 / omz
     #o / 0.2D1 + dla / omz1 / omz2 / omzo * pi ** 2 / 0.12D2 + 0.9D1 / 
     #0.8D1 * dla / omz1 / omz2 / omzo * zo - 0.5D1 / 0.4D1 * dla / omz1
     # / omz2 / omzo * rH1(0, zo) + rH1(1, zo) * dla / omz1 / omz2 / omz
     #o / 0.2D1 + 0.5D1 / 0.8D1 * dla / omz1 / omz2 / omzo / zo + rH1(0,
     # zo) * dla ** 2 / omz1 / omz2 / omzo * zo / 0.8D1 - dla * dls / om
     #z1 / omz2 / omzo * zo / 0.8D1 - dla / omz1 / omz2 / omzo * pi ** 2
     # * zo / 0.24D2 - rH1(1, zo) * dla / omz1 / omz2 / omzo * zo / 0.8D
     #1 + 0.5D1 / 0.2D1 * rH2(0, 1, zo) * dla / omz1 / omz2 / omzo + rH1
     #(0, zo) * dls ** 2 / omz1 / omz2 / omzo * zo / 0.8D1 + dls / omz1 
     #/ omz2 / omzo * pi ** 2 * zo / 0.24D2 + rH1(1, zo) * dls / omz1 / 
     #omz2 / omzo * zo / 0.8D1 + 0.5D1 / 0.4D1 * rH2(0, 1, zo) * dls / o
     #mz1 / omz2 / omzo * zo + rH1(1, zo) / omz1 / omz2 / omzo * zo * rH
     #1(0, zo) - rH2(0, 1, zo) / omz1 / omz2 / omzo * zo * rH1(0, zo) / 
     #0.4D1 - 0.3D1 / 0.8D1 * rH1(1, zo) ** 2 / omz1 / omz2 / omzo * zo 
     #* rH1(0, zo) + rH2(0, 1, zo) / omz1 / omz2 / omzo * zo * rH1(1, zo
     #) + 0.3D1 / 0.4D1 * rH1(1, zo) / omz1 / omz2 / omzo / zo * rH1(0, 
     #zo) + 0.9D1 / 0.8D1 * dls / omz1 / omz2 / omzo - 0.3D1 / omz1 / om
     #z2 / omzo / zo + 0.1D1 / omz1 / omz2 / omzo * rH1(0, zo) ** 3 / 0.
     #8D1 - 0.1D1 / omz1 / omz2 / omzo * rH1(0, zo) ** 2 / 0.2D1 - 0.21D
     #2 / 0.16D2 / omz1 / omz2 / omzo * rH1(0, zo) - 0.7D1 / 0.2D1 / omz
     #1 / omz2 / omzo * zeta3 - 0.27D2 / 0.16D2 / omz1 / omz2 / omzo * z
     #o - rH1(0, zo) * dla * dls / omz1 / omz2 / omzo * zo / 0.4D1 - 0.1
     #D1 / omz1 / omz2 / omzo * pi ** 2 / 0.3D1 - dls ** 2 / omz1 / omz2
     # / omzo / 0.4D1 - 0.9D1 / 0.8D1 * dls / omz1 / omz2 / omzo * zo + 
     #dla ** 2 / omz1 / omz2 / omzo * zo / 0.16D2 - d1x2 / omz1 / omzo *
     # zo / 0.8D1 + rH1(0, zo) * d1x2 / omz1 / omzo / 0.2D1 - 0.9D1 / 0.
     #8D1 * d0x2 / omz1 / omzo * zo - 0.5D1 / 0.8D1 * d0x2 / omz1 / omzo
     # / zo + 0.5D1 / 0.4D1 * d0x2 / omz1 / omzo * rH1(0, zo) - rH1(1, z
     #o) * d0x2 / omz1 / omzo / 0.2D1 - 0.5D1 / 0.2D1 * rH2(0, 1, zo) * 
     #d0x2 / omz1 / omzo - rH1(1, zo) ** 2 * d0x2 / omz1 / omzo / 0.2D1 
     #- d0x2 / omz1 / omzo * pi ** 2 / 0.12D2 - d0x2 * dls / omz1 / omzo
     # / 0.2D1 + d0x2 * dla / omz1 / omzo / 0.2D1 - dls / omz1 / omz2 / 
     #omzo * pi ** 2 / 0.12D2 - 0.9D1 / 0.8D1 * dla / omz1 / omz2 / omzo
     # - 0.5D1 / 0.8D1 * rH1(1, zo) / omz1 / omz2 / omzo / zo - dla ** 2
     # / omz1 / omz2 / omzo / 0.4D1 - rH1(0, zo) * dla ** 2 / omz1 / omz
     #2 / omzo / 0.4D1
      endif
      if(ix.eq.2.and.iz_frag.eq.1)then
      e2 = 0
      e1 = 0
      if(region1) then
      e0 = (-0.1D1 - x2) * rH1(0, x2) / omzo / omz1 * rln2 / zo + (-0.
     #1D1 - x2) * rH1(0, zo) / omzo / omz1 * rln2 / zo + (0.2D1 + 0.2D1 
     #* x2) * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1
     # * zo + 0.1D1)) / omzo / omz1 * rln2 / zo - (0.3D1 * x2 ** 3 * zo 
     #** 2 + 0.6D1 * x2 ** 2 * zo ** 3 + 0.3D1 * x2 * zo ** 4 + 0.2D1 * 
     #x2 ** 3 * zo - x2 ** 2 * zo ** 2 - 0.2D1 * x2 * zo ** 3 + zo ** 4 
     #- 0.2D1 * x2 ** 3 - 0.8D1 * x2 ** 2 * zo + 0.11D2 * x2 * zo ** 2 +
     # 0.6D1 * zo ** 3 - 0.2D1 * x2 ** 2 - 0.22D2 * x2 * zo - 0.21D2 * z
     #o ** 2 + 0.10D2 * x2 + 0.20D2 * zo - 0.6D1) / zo / (-0.1D1 + x2 + 
     #zo) ** 2 / omzo / omz1 * rH1(0, x2) / 0.8D1 + (0.1D1 + x2) / zo * 
     #rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 
     #0.1D1)) / omzo / omz1 * rH1(0, x2) + (x2 - 0.2D1 * zo + 0.1D1) / z
     #o * rH1(0, x2 - zo) / omzo / omz1 * rH1(0, x2) / 0.2D1 + (x2 - 0.2
     #D1 * zo + 0.1D1) / zo * rH1(0, 0.1D1 - x2 - zo) / omzo / omz1 * rH
     #1(0, x2) / 0.2D1 + (0.1D1 + x2) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.
     #4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omzo / omz1 * rH1
     #(0, zo) - (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, x2 - zo) / omzo 
     #/ omz1 * rH1(0, zo) / 0.2D1 + (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1
     #(1, zo) / omzo / omz1 * rH1(1, x2) / 0.2D1 - (0.4D1 * x2 * zo - zo
     # ** 2 + 0.4D1 * zo + 0.1D1) / zo * rH1(0, x2) / omzo / omz1 / Sqrt
     #(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (0.4D1 * x2 * z
     #o - zo ** 2 + 0.4D1 * zo + 0.1D1) / zo * rH1(0, zo) / omzo / omz1 
     #/ Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (zo - 0.1
     #D1) ** 2 / zo / omx2 / omz1 / omzo * pi ** 2 / 0.6D1 - 0.1D1 / Sqr
     #t(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx2 / omz1 / 
     #omzo * rln2 * zo ** 2 - 0.2D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x
     #2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rln
     #2 * zo + 0.3D1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1
     #D1) / omx2 / omz1 / omzo * rln2 / zo + 0.2D1 * rH1(0, x2) / omx2 /
     # omz1 / omzo * rln2 / zo + 0.2D1 * rH1(0, zo) / omx2 / omz1 / omzo
     # * rln2 / zo - 0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + 
     #zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rln2 / zo + 
     #(0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo / omx2 / omz1 / omzo *
     # rH1(0, x2) ** 2 / 0.2D1 - (0.3D1 * zo ** 2 - 0.10D2 * zo + 0.6D1)
     # / zo / omx2 / omz1 / omzo * rH1(0, x2) / 0.8D1 + (0.1D1 - zo / 0.
     #2D1) * rH1(0, zo) / omx2 / omz1 / omzo * rH1(0, x2) + (zo - 0.1D1)
     # ** 2 / zo * rH2(0, 1, zo) / omx2 / omz1 / omzo + (zo - 0.1D1) ** 
     #2 / zo * rH2(0, 1, 0.1D1 / x2 / omx2 * zo * (0.1D1 - zo)) / omx2 /
     # omz1 / omzo + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, omx2 / (0.1D1 - 
     #zo)) / omx2 / omz1 / omzo + 0.2D1 * (zo ** 2 - 0.2D1 * zo + 0.2D1)
     # / zo * rH2(0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.
     #2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo + (zo - 0.1D1) ** 2 / zo *
     # rH2(0, 1, 0.1D1 / x2 * (x2 - zo)) / omx2 / omz1 / omzo + (zo + 0.
     #1D1) * (zo - 0.3D1) / zo / omx2 / omz1 / omzo * rH1(0, zo) / 0.2D1
     # - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(
     #0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / o
     #mzo * rH1(0, zo) + (zo - 0.1D1) ** 2 / zo * rH1(0, x2 - zo) / omx2
     # / omz1 / omzo * rH1(0, zo) - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D
     #1) / zo * rH1(1, zo) / omx2 / omz1 / omzo * rH1(0, 0.1D1 - x2 - zo
     #) / 0.2D1 - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(1, z
     #o) / omx2 / omz1 / omzo * rH1(1, x2) / 0.2D1 + (zo - 0.3D1) / zo *
     # rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo +
     # 0.1D1)) / omx2 / omz1 / omzo * Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0
     #.2D1 * zo + 0.1D1) - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, 
     #zo) / omx2 / omz1 / omzo * rH1(0, x2) / 0.2D1 - (zo - 0.1D1) ** 2 
     #/ zo * rH1(1, x2) / omx2 / omz1 / omzo * rH1(0, x2) - (zo ** 2 - 0
     #.2D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo
     # + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rH1(0, x2
     #) - (zo - 0.1D1) ** 2 / zo * rH1(0, x2 - zo) / omx2 / omz1 / omzo 
     #* rH1(0, x2) - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(0
     #, 0.1D1 - x2 - zo) / omx2 / omz1 / omzo * rH1(0, x2) / 0.2D1 + 0.1
     #D1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx2 /
     # omz1 / omzo * rln2 * zo + rH1(0, x2) / omx2 / omz1 / omzo * rln2 
     #* zo + rH1(0, zo) / omx2 / omz1 / omzo * rln2 * zo - (x2 - 0.2D1 *
     # zo + 0.1D1) / zo * rH1(1, zo) * dla / omz1 / omzo / 0.2D1 + (0.3D
     #1 / 0.8D1 * zo - x2 / 0.4D1 - x2 * zo / 0.8D1) * dls / omz1 / omzo
     # + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d1x2 / omz1 
     #/ omzo / 0.2D1 - (zo - 0.3D1) * (zo + 0.1D1) ** 2 / zo * rH1(0, x2
     #) / omx2 / omz1 / omzo / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * 
     #zo + 0.1D1) / 0.2D1 - (zo - 0.3D1) * (zo + 0.1D1) ** 2 / zo * rH1(
     #0, zo) / omx2 / omz1 / omzo / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2
     #D1 * zo + 0.1D1) / 0.2D1 - (0.5D1 * zo ** 2 - 0.10D2 * zo + 0.8D1)
     # / zo * rH2(0, 1, zo) * d0x2 / omz1 / omzo / 0.4D1 - (zo ** 2 - 0.
     #2D1 * zo + 0.2D1) / zo * rH1(1, zo) ** 2 * d0x2 / omz1 / omzo / 0.
     #4D1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * d0x2 * dls / omz1 / omzo + (0
     #.1D1 / 0.2D1 - zo / 0.4D1) * rH1(0, zo) * d0x2 * dls / omz1 / omzo
     # + (-0.1D1 / 0.2D1 + zo / 0.8D1) * d0x2 * dla / omz1 / omzo + (-0.
     #1D1 / 0.2D1 + zo / 0.4D1) * rH1(0, zo) * d0x2 * dla / omz1 / omzo 
     #+ (0.9D1 * zo ** 2 - 0.9D1 * zo + 0.5D1) / zo * d0x2 / omz1 / omzo
     # / 0.8D1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * rH1(1, zo) * d0x2 / omz1
     # / omzo - 0.5D1 / 0.4D1 * d0x2 / omz1 / omzo * rH1(0, zo) + (0.2D1
     # * x2 - 0.3D1 * zo + 0.2D1) / zo / omzo / omz1 * pi ** 2 / 0.12D2 
     #+ (-0.1D1 - x2) / zo / omzo / omz1 * rln2 ** 2 + 0.2D1 / Sqrt(0.4D
     #1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omzo / omz1 * rln2 *
     # zo + (-0.8D1 * x2 - 0.8D1) / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2
     #D1 * zo + 0.1D1) / omzo / omz1 * rln2 - 0.2D1 / Sqrt(0.4D1 * x2 * 
     #zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omzo / omz1 * rln2 / zo + 0.2
     #D1 / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2
     #D1 * zo + 0.1D1)) / omzo / omz1 * Sqrt(0.4D1 * x2 * zo + zo ** 2 -
     # 0.2D1 * zo + 0.1D1) - (x2 * zo ** 2 - 0.2D1 * x2 * zo + zo ** 2 +
     # 0.9D1 * x2 - 0.12D2 * zo + 0.9D1) / zo / omzo / omz1 * rH1(0, x2)
     # ** 2 / 0.8D1 + (-x2 * zo / 0.4D1 + x2 / 0.2D1 - zo / 0.4D1 - 0.1D
     #1 / 0.2D1) * rH1(1, x2) / omzo / omz1 * rH1(0, x2) + (0.1D1 / 0.2D
     #1 + x2 * zo / 0.8D1 - x2 / 0.4D1 + zo / 0.8D1) / omzo / omz1 * rH1
     #(0, zo) ** 2 + (x2 * zo ** 2 + 0.2D1 * x2 * zo - 0.3D1 * zo ** 2 +
     # 0.10D2 * zo + 0.8D1) / zo / omzo / omz1 * rH1(0, zo) / 0.8D1 + (0
     #.1D1 / 0.2D1 + zo / 0.4D1 - x2 / 0.2D1 + x2 * zo / 0.4D1) * rH1(1,
     # zo) / omzo / omz1 * rH1(0, zo) + (0.1D1 / 0.2D1 - 0.3D1 / 0.8D1 *
     # x2 * zo + x2 / 0.4D1 - 0.3D1 / 0.8D1 * zo) / omzo / omz1 * rH1(1,
     # x2) + (-0.1D1 / 0.2D1 + zo / 0.8D1) * d1x2 / omz1 / omzo + (x2 - 
     #0.2D1 * zo + 0.1D1) / zo / omz1 / omzo * rH1(1, zo) * rH1(0, 0.1D1
     # - x2 - zo) / 0.2D1 + (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omzo
     # * rH2(0, 1, 0.1D1 / omx2 * zo) / 0.2D1 - (x2 * zo ** 2 - 0.2D1 * 
     #x2 * zo + zo ** 2 + 0.2D1 * x2 + 0.2D1) / zo / omz1 / omzo * rH2(0
     #, 1, zo) / 0.4D1 - 0.2D1 * (0.1D1 + x2) / zo / omz1 / omzo * rH2(0
     #, 0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.
     #1D1)) - (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omzo * rH2(0, 1, 0
     #.1D1 / x2 * (x2 - zo)) / 0.2D1 - (x2 - 0.2D1 * zo + 0.1D1) / zo / 
     #omz1 / omzo * rH2(0, 1, 0.1D1 / x2 / omx2 * zo * (0.1D1 - zo)) / 0
     #.2D1 - (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omzo * rH2(0, 1, om
     #x2 / (0.1D1 - zo)) / 0.2D1 + (0.1D1 - zo / 0.2D1) * rH2(0, 1, 0.1D
     #1 / omx2 * zo) / omx2 / omz1 / omzo + (-0.1D1 / 0.2D1 + zo / 0.4D1
     #) * rH1(1, zo) ** 2 / omx2 / omz1 / omzo + (-0.1D1 / 0.2D1 + zo / 
     #0.4D1) * rH1(0, zo) * d1x2 / omz1 / omzo + (x2 * zo / 0.8D1 + x2 /
     # 0.4D1 - 0.3D1 / 0.8D1 * zo) * dla / omz1 / omzo + 0.1D1 / omx2 / 
     #omz1 / omzo * rln2 ** 2 * zo + 0.2D1 / omx2 / omz1 / omzo * rln2 *
     #* 2 / zo + 0.5D1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0
     #.1D1) / omx2 / omz1 / omzo * rln2 - 0.2D1 * rH1(0, x2) / omx2 / om
     #z1 / omzo * rln2 - 0.2D1 * rH1(0, zo) / omx2 / omz1 / omzo * rln2 
     #+ 0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2
     #D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rln2 + (zo ** 2 - 0.2D1 *
     # zo + 0.2D1) / zo * rH1(1, zo) * d0x2 * dla / omz1 / omzo / 0.2D1 
     #- (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d0x2 * dls / 
     #omz1 / omzo / 0.2D1 - (zo ** 3 + (x2 - 0.3D1) * zo ** 2 + (-0.2D1 
     #* x2 + 0.6D1) * zo + 0.4D1 * x2 - 0.4D1) / (-0.1D1 + x2 + zo) / zo
     # * d0x2 / omz1 / omzo * pi ** 2 / 0.24D2 + (zo ** 2 - 0.2D1 * zo +
     # 0.2D1) / zo * rH1(1, zo) * d0x2 / omz1 / omzo * rH1(0, zo) / 0.2D
     #1 + (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) * dls / omz1 / omz
     #o / 0.2D1 - (0.3D1 * x2 ** 2 * zo ** 2 + 0.3D1 * x2 * zo ** 3 - 0.
     #2D1 * x2 ** 2 * zo - 0.14D2 * x2 * zo ** 2 - 0.9D1 * zo ** 3 + 0.1
     #0D2 * x2 ** 2 + 0.10D2 * x2 * zo - zo ** 2 - 0.14D2 * x2 + 0.6D1 *
     # zo + 0.4D1) / (-0.1D1 + x2 + zo) / zo / omzo / omz1 / 0.8D1 - (x2
     # ** 3 * zo + 0.2D1 * x2 ** 2 * zo ** 2 + x2 * zo ** 3 + 0.2D1 * x2
     # ** 3 - x2 ** 2 * zo - 0.6D1 * x2 * zo ** 2 - 0.3D1 * zo ** 3 - 0.
     #4D1 * x2 ** 2 + 0.19D2 * x2 * zo + 0.14D2 * zo ** 2 - 0.14D2 * x2 
     #- 0.19D2 * zo + 0.8D1) / (-0.1D1 + x2 + zo) ** 2 * rH1(1, zo) / om
     #zo / omz1 / 0.8D1 - rH1(0, zo) / omzo / omz1 * rH1(0, x2) - rH1(1,
     # x2) / omzo / omz1 * rH1(0, zo) / 0.2D1 + (0.1D1 / 0.2D1 + zo / 0.
     #4D1 - x2 / 0.2D1 + x2 * zo / 0.4D1) * rH2(0, 1, x2) / omzo / omz1 
     #- 0.2D1 / omx2 / omz1 / omzo * rln2 ** 2 - (zo ** 2 - 0.2D1 * zo +
     # 0.2D1) / omx2 / zo / omz1 / omzo * rH2(0, 1, x2 / omx2 * zo / (0.
     #1D1 - zo)) / 0.2D1 + rH1(0, zo) * dla / omz1 / omzo / 0.2D1 - rH1(
     #0, zo) * dls / omz1 / omzo / 0.2D1
      elseif(region2) then
      e0 = (zo / 0.2D1 - 0.1D1) * rH2(0, 1, omx2 / zo) / omx2 / omz1 /
     # omzo + (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) ** 2 / omzo / 
     #omz1 / 0.4D1 - (x2 * zo ** 2 - 0.2D1 * x2 * zo + zo ** 2 + 0.7D1 *
     # x2 - 0.8D1 * zo + 0.7D1) / zo / omzo / omz1 * rH1(0, x2) ** 2 / 0
     #.8D1 + (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omzo * rH1(1, zo) *
     # rH1(0, -0.1D1 + x2 + zo) / 0.2D1 + (x2 - 0.2D1 * zo + 0.1D1) / zo
     # * rH1(0, -0.1D1 + x2 + zo) / omzo / omz1 * rH1(0, x2) / 0.2D1 + (
     #x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) / omzo / omz1 * rH1(0, 
     #x2) / 0.2D1 - (0.1D1 + x2) / zo * rH1(0, zo) / omzo / omz1 * rH1(0
     #, x2) / 0.2D1 + (x2 * zo ** 2 - 0.2D1 * x2 * zo + zo ** 2 - 0.2D1 
     #* x2 + 0.6D1 * zo - 0.2D1) / zo * rH1(1, zo) / omzo / omz1 * rH1(0
     #, zo) / 0.4D1 + (0.5D1 * zo ** 2 - 0.10D2 * zo + 0.8D1) / zo / omx
     #2 / omz1 / omzo * rH1(0, x2) ** 2 / 0.4D1 - (zo - 0.1D1) ** 2 / zo
     # * rH2(0, 1, x2 * omx2 / zo / (0.1D1 - zo)) / omx2 / omz1 / omzo +
     # (-0.1D1 - x2) * rH1(0, x2) / omzo / omz1 * rln2 / zo + (-0.1D1 - 
     #x2) * rH1(0, zo) / omzo / omz1 * rln2 / zo + (0.2D1 + 0.2D1 * x2) 
     #* rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo 
     #+ 0.1D1)) / omzo / omz1 * rln2 / zo - (0.3D1 * x2 ** 3 * zo ** 2 +
     # 0.6D1 * x2 ** 2 * zo ** 3 + 0.3D1 * x2 * zo ** 4 + 0.2D1 * x2 ** 
     #3 * zo - x2 ** 2 * zo ** 2 - 0.2D1 * x2 * zo ** 3 + zo ** 4 - 0.2D
     #1 * x2 ** 3 - 0.8D1 * x2 ** 2 * zo + 0.11D2 * x2 * zo ** 2 + 0.6D1
     # * zo ** 3 - 0.2D1 * x2 ** 2 - 0.22D2 * x2 * zo - 0.21D2 * zo ** 2
     # + 0.10D2 * x2 + 0.20D2 * zo - 0.6D1) / zo / (-0.1D1 + x2 + zo) **
     # 2 / omzo / omz1 * rH1(0, x2) / 0.8D1 + (0.1D1 + x2) / zo * rH1(0,
     # 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)
     #) / omzo / omz1 * rH1(0, x2) + (x2 - 0.2D1 * zo + 0.1D1) / zo * rH
     #1(0, x2 - zo) / omzo / omz1 * rH1(0, x2) / 0.2D1 + (0.1D1 + x2) / 
     #zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * 
     #zo + 0.1D1)) / omzo / omz1 * rH1(0, zo) - (x2 - 0.2D1 * zo + 0.1D1
     #) / zo * rH1(0, x2 - zo) / omzo / omz1 * rH1(0, zo) / 0.2D1 - (0.4
     #D1 * x2 * zo - zo ** 2 + 0.4D1 * zo + 0.1D1) / zo * rH1(0, x2) / o
     #mzo / omz1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) 
     #- (0.4D1 * x2 * zo - zo ** 2 + 0.4D1 * zo + 0.1D1) / zo * rH1(0, z
     #o) / omzo / omz1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0
     #.1D1) - (zo - 0.1D1) ** 2 / zo / omx2 / omz1 / omzo * pi ** 2 / 0.
     #6D1 - 0.1D1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)
     # / omx2 / omz1 / omzo * rln2 * zo ** 2 - 0.2D1 * rH1(0, 0.1D1 - zo
     # + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / 
     #omz1 / omzo * rln2 * zo + 0.3D1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 -
     # 0.2D1 * zo + 0.1D1) / omx2 / omz1 / omzo * rln2 / zo + 0.2D1 * rH
     #1(0, x2) / omx2 / omz1 / omzo * rln2 / zo + 0.2D1 * rH1(0, zo) / o
     #mx2 / omz1 / omzo * rln2 / zo - 0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0
     #.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / om
     #zo * rln2 / zo - (0.3D1 * zo ** 2 - 0.10D2 * zo + 0.6D1) / zo / om
     #x2 / omz1 / omzo * rH1(0, x2) / 0.8D1 + (zo - 0.1D1) ** 2 / zo * r
     #H2(0, 1, zo) / omx2 / omz1 / omzo + (zo - 0.1D1) ** 2 / zo * rH2(0
     #, 1, omx2 / (0.1D1 - zo)) / omx2 / omz1 / omzo + 0.2D1 * (zo ** 2 
     #- 0.2D1 * zo + 0.2D1) / zo * rH2(0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x
     #2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo + (zo
     # - 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / x2 * (x2 - zo)) / omx2 / o
     #mz1 / omzo - (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omzo * rH2(0,
     # 1, omx2 / zo) / 0.2D1 + (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / o
     #mzo * rH2(0, 1, x2 * omx2 / zo / (0.1D1 - zo)) / 0.2D1 + (zo ** 2 
     #- 0.2D1 * zo + 0.2D1) / omx2 / zo / omz1 / omzo * rH2(0, 1, 0.1D1 
     #/ x2 * omx2 / zo * (0.1D1 - zo)) / 0.2D1 + (zo + 0.1D1) * (zo - 0.
     #3D1) / zo / omx2 / omz1 / omzo * rH1(0, zo) / 0.2D1 - (zo ** 2 - 0
     #.2D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo
     # + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rH1(0, zo
     #) + (zo - 0.1D1) ** 2 / zo * rH1(0, x2 - zo) / omx2 / omz1 / omzo 
     #* rH1(0, zo) + (zo - 0.3D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 
     #* x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * 
     #Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (zo ** 2 - 
     #0.2D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * z
     #o + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rH1(0, x
     #2) - (zo - 0.1D1) ** 2 / zo * rH1(0, x2 - zo) / omx2 / omz1 / omzo
     # * rH1(0, x2) + 0.1D1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * z
     #o + 0.1D1) / omx2 / omz1 / omzo * rln2 * zo + rH1(0, x2) / omx2 / 
     #omz1 / omzo * rln2 * zo + rH1(0, zo) / omx2 / omz1 / omzo * rln2 *
     # zo - (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) * dla / omz1 / o
     #mzo / 0.2D1 + (0.3D1 / 0.8D1 * zo - x2 / 0.4D1 - x2 * zo / 0.8D1) 
     #* dls / omz1 / omzo + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1,
     # zo) * d1x2 / omz1 / omzo / 0.2D1 - (zo - 0.3D1) * (zo + 0.1D1) **
     # 2 / zo * rH1(0, x2) / omx2 / omz1 / omzo / Sqrt(0.4D1 * x2 * zo +
     # zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (zo - 0.3D1) * (zo + 0.1D
     #1) ** 2 / zo * rH1(0, zo) / omx2 / omz1 / omzo / Sqrt(0.4D1 * x2 *
     # zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (0.5D1 * zo ** 2 - 0
     #.10D2 * zo + 0.8D1) / zo * rH2(0, 1, zo) * d0x2 / omz1 / omzo / 0.
     #4D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) ** 2 * d0x2
     # / omz1 / omzo / 0.4D1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * d0x2 * dls
     # / omz1 / omzo + (0.1D1 / 0.2D1 - zo / 0.4D1) * rH1(0, zo) * d0x2 
     #* dls / omz1 / omzo + (-0.1D1 / 0.2D1 + zo / 0.8D1) * d0x2 * dla /
     # omz1 / omzo + (-0.1D1 / 0.2D1 + zo / 0.4D1) * rH1(0, zo) * d0x2 *
     # dla / omz1 / omzo - (zo ** 2 - 0.2D1 * zo + 0.2D1) * (0.1D1 + x2)
     # / zo * rH1(1, x2) / omzo / omz1 * rH1(0, x2) / 0.4D1 + (0.9D1 * z
     #o ** 2 - 0.9D1 * zo + 0.5D1) / zo * d0x2 / omz1 / omzo / 0.8D1 + (
     #0.1D1 / 0.2D1 - zo / 0.8D1) * rH1(1, zo) * d0x2 / omz1 / omzo + (0
     #.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(1, zo) / omx2 / om
     #z1 / omzo * rH1(0, zo) / 0.2D1 - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0
     #.4D1) / zo * rH1(1, zo) / omx2 / omz1 / omzo * rH1(0, -0.1D1 + x2 
     #+ zo) / 0.2D1 - 0.5D1 / 0.4D1 * d0x2 / omz1 / omzo * rH1(0, zo) + 
     #(0.2D1 * x2 - 0.3D1 * zo + 0.2D1) / zo / omzo / omz1 * pi ** 2 / 0
     #.12D2 + (-0.1D1 - x2) / zo / omzo / omz1 * rln2 ** 2 + 0.2D1 / Sqr
     #t(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omzo / omz1 * 
     #rln2 * zo + (-0.8D1 * x2 - 0.8D1) / Sqrt(0.4D1 * x2 * zo + zo ** 2
     # - 0.2D1 * zo + 0.1D1) / omzo / omz1 * rln2 - 0.2D1 / Sqrt(0.4D1 *
     # x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omzo / omz1 * rln2 / zo
     # + 0.2D1 / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2
     # - 0.2D1 * zo + 0.1D1)) / omzo / omz1 * Sqrt(0.4D1 * x2 * zo + zo 
     #** 2 - 0.2D1 * zo + 0.1D1) + (0.1D1 / 0.2D1 + x2 * zo / 0.8D1 - x2
     # / 0.4D1 + zo / 0.8D1) / omzo / omz1 * rH1(0, zo) ** 2 + (x2 * zo 
     #** 2 + 0.2D1 * x2 * zo - 0.3D1 * zo ** 2 + 0.10D2 * zo + 0.8D1) / 
     #zo / omzo / omz1 * rH1(0, zo) / 0.8D1 + (0.1D1 / 0.2D1 - 0.3D1 / 0
     #.8D1 * x2 * zo + x2 / 0.4D1 - 0.3D1 / 0.8D1 * zo) / omzo / omz1 * 
     #rH1(1, x2) + (-0.1D1 / 0.2D1 + zo / 0.8D1) * d1x2 / omz1 / omzo - 
     #(x2 * zo ** 2 - 0.2D1 * x2 * zo + zo ** 2 + 0.2D1 * x2 + 0.2D1) / 
     #zo / omz1 / omzo * rH2(0, 1, zo) / 0.4D1 - 0.2D1 * (0.1D1 + x2) / 
     #zo / omz1 / omzo * rH2(0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + z
     #o ** 2 - 0.2D1 * zo + 0.1D1)) - (x2 - 0.2D1 * zo + 0.1D1) / zo / o
     #mz1 / omzo * rH2(0, 1, 0.1D1 / x2 * (x2 - zo)) / 0.2D1 - (x2 - 0.2
     #D1 * zo + 0.1D1) / zo / omz1 / omzo * rH2(0, 1, omx2 / (0.1D1 - zo
     #)) / 0.2D1 + (-0.1D1 / 0.2D1 + zo / 0.4D1) * rH1(0, zo) * d1x2 / o
     #mz1 / omzo + (x2 * zo / 0.8D1 + x2 / 0.4D1 - 0.3D1 / 0.8D1 * zo) *
     # dla / omz1 / omzo + 0.1D1 / omx2 / omz1 / omzo * rln2 ** 2 * zo +
     # 0.2D1 / omx2 / omz1 / omzo * rln2 ** 2 / zo + 0.5D1 / Sqrt(0.4D1 
     #* x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx2 / omz1 / omzo * r
     #ln2 - 0.2D1 * rH1(0, x2) / omx2 / omz1 / omzo * rln2 - 0.2D1 * rH1
     #(0, zo) / omx2 / omz1 / omzo * rln2 + 0.4D1 * rH1(0, 0.1D1 - zo + 
     #Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz
     #1 / omzo * rln2 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo)
     # * d0x2 * dla / omz1 / omzo / 0.2D1 - (zo ** 2 - 0.2D1 * zo + 0.2D
     #1) / zo * rH1(1, zo) * d0x2 * dls / omz1 / omzo / 0.2D1 - (zo ** 3
     # + (x2 - 0.3D1) * zo ** 2 + (-0.2D1 * x2 + 0.6D1) * zo + 0.4D1 * x
     #2 - 0.4D1) / (-0.1D1 + x2 + zo) / zo * d0x2 / omz1 / omzo * pi ** 
     #2 / 0.24D2 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d0
     #x2 / omz1 / omzo * rH1(0, zo) / 0.2D1 + (x2 - 0.2D1 * zo + 0.1D1) 
     #/ zo * rH1(1, zo) * dls / omz1 / omzo / 0.2D1 - (0.3D1 * x2 ** 2 *
     # zo ** 2 + 0.3D1 * x2 * zo ** 3 - 0.2D1 * x2 ** 2 * zo - 0.14D2 * 
     #x2 * zo ** 2 - 0.9D1 * zo ** 3 + 0.10D2 * x2 ** 2 + 0.10D2 * x2 * 
     #zo - zo ** 2 - 0.14D2 * x2 + 0.6D1 * zo + 0.4D1) / (-0.1D1 + x2 + 
     #zo) / zo / omzo / omz1 / 0.8D1 - (x2 ** 3 * zo + 0.2D1 * x2 ** 2 *
     # zo ** 2 + x2 * zo ** 3 + 0.2D1 * x2 ** 3 - x2 ** 2 * zo - 0.6D1 *
     # x2 * zo ** 2 - 0.3D1 * zo ** 3 - 0.4D1 * x2 ** 2 + 0.19D2 * x2 * 
     #zo + 0.14D2 * zo ** 2 - 0.14D2 * x2 - 0.19D2 * zo + 0.8D1) / (-0.1
     #D1 + x2 + zo) ** 2 * rH1(1, zo) / omzo / omz1 / 0.8D1 - rH1(1, x2)
     # / omzo / omz1 * rH1(0, zo) / 0.2D1 + (0.1D1 / 0.2D1 + zo / 0.4D1 
     #- x2 / 0.2D1 + x2 * zo / 0.4D1) * rH2(0, 1, x2) / omzo / omz1 - 0.
     #2D1 / omx2 / omz1 / omzo * rln2 ** 2 + rH1(0, zo) * dla / omz1 / o
     #mzo / 0.2D1 - rH1(0, zo) * dls / omz1 / omzo / 0.2D1 - (0.3D1 * zo
     # ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(0, -0.1D1 + x2 + zo) / omx2
     # / omz1 / omzo * rH1(0, x2) / 0.2D1 - (zo - 0.1D1) ** 2 / zo * rH1
     #(1, zo) / omx2 / omz1 / omzo * rH1(0, x2) + (zo ** 2 - 0.2D1 * zo 
     #+ 0.2D1) / zo * rH1(1, x2) / omx2 / omz1 / omzo * rH1(0, x2) / 0.2
     #D1 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(0, zo) / omx2 / omz
     #1 / omzo * rH1(0, x2)
      elseif(region3) then
      e0 = -(zo - 0.1D1) ** 2 / zo / omx2 / omz1 / omzo * rH1(0, zo) *
     #* 2 / 0.2D1 - (zo - 0.1D1) ** 2 / zo / omx2 / omz1 / omzo * rH1(1,
     # x2) ** 2 + (zo / 0.2D1 - 0.1D1) * rH1(1, zo) / omx2 / omz1 / omzo
     # * rH1(1, x2) - (zo - 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / omx2 * 
     #(0.1D1 - zo)) / omx2 / omz1 / omzo - (0.3D1 * zo ** 2 - 0.6D1 * zo
     # + 0.4D1) / zo * rH1(1, zo) ** 2 / omx2 / omz1 / omzo / 0.4D1 + (x
     #2 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) ** 2 / omzo / omz1 / 0.2
     #D1 - (x2 * zo ** 2 - 0.2D1 * x2 * zo + zo ** 2 + 0.7D1 * x2 - 0.8D
     #1 * zo + 0.7D1) / zo / omzo / omz1 * rH1(0, x2) ** 2 / 0.8D1 + (x2
     # - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) / omzo / omz1 * rH1(0, x2
     #) / 0.2D1 - (0.1D1 + x2) / zo * rH1(0, zo) / omzo / omz1 * rH1(0, 
     #x2) / 0.2D1 + (x2 * zo ** 2 - 0.2D1 * x2 * zo + zo ** 2 - 0.2D1 * 
     #x2 + 0.6D1 * zo - 0.2D1) / zo * rH1(1, zo) / omzo / omz1 * rH1(0, 
     #zo) / 0.4D1 - (zo - 0.1D1) ** 2 / zo * rH2(0, 1, x2 * omx2 / zo / 
     #(0.1D1 - zo)) / omx2 / omz1 / omzo - (0.2D1 * x2 - 0.5D1 * zo + 0.
     #2D1) / zo / omzo / omz1 * pi ** 2 / 0.12D2 + (x2 * zo ** 2 - 0.2D1
     # * x2 * zo + zo ** 2 + 0.2D1 * x2 + 0.2D1) / zo / omzo / omz1 * rH
     #1(0, zo) ** 2 / 0.8D1 + (-0.1D1 - x2) * rH1(0, x2) / omzo / omz1 *
     # rln2 / zo + (-0.1D1 - x2) * rH1(0, zo) / omzo / omz1 * rln2 / zo 
     #+ (0.2D1 + 0.2D1 * x2) * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo 
     #+ zo ** 2 - 0.2D1 * zo + 0.1D1)) / omzo / omz1 * rln2 / zo - (0.3D
     #1 * x2 ** 3 * zo ** 2 + 0.6D1 * x2 ** 2 * zo ** 3 + 0.3D1 * x2 * z
     #o ** 4 + 0.2D1 * x2 ** 3 * zo - x2 ** 2 * zo ** 2 - 0.2D1 * x2 * z
     #o ** 3 + zo ** 4 - 0.2D1 * x2 ** 3 - 0.8D1 * x2 ** 2 * zo + 0.11D2
     # * x2 * zo ** 2 + 0.6D1 * zo ** 3 - 0.2D1 * x2 ** 2 - 0.22D2 * x2 
     #* zo - 0.21D2 * zo ** 2 + 0.10D2 * x2 + 0.20D2 * zo - 0.6D1) / zo 
     #/ (-0.1D1 + x2 + zo) ** 2 / omzo / omz1 * rH1(0, x2) / 0.8D1 + (0.
     #1D1 + x2) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 
     #2 - 0.2D1 * zo + 0.1D1)) / omzo / omz1 * rH1(0, x2) + (x2 - 0.2D1 
     #* zo + 0.1D1) / zo * rH1(0, 0.1D1 - x2 - zo) / omzo / omz1 * rH1(0
     #, x2) / 0.2D1 + (0.1D1 + x2) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1
     # * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omzo / omz1 * rH1(0,
     # zo) - (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) / omzo / omz1 *
     # rH1(1, x2) / 0.2D1 - (0.4D1 * x2 * zo - zo ** 2 + 0.4D1 * zo + 0.
     #1D1) / zo * rH1(0, x2) / omzo / omz1 / Sqrt(0.4D1 * x2 * zo + zo *
     #* 2 - 0.2D1 * zo + 0.1D1) - (0.4D1 * x2 * zo - zo ** 2 + 0.4D1 * z
     #o + 0.1D1) / zo * rH1(0, zo) / omzo / omz1 / Sqrt(0.4D1 * x2 * zo 
     #+ zo ** 2 - 0.2D1 * zo + 0.1D1) + (zo - 0.1D1) ** 2 / zo / omx2 / 
     #omz1 / omzo * pi ** 2 / 0.2D1 - 0.1D1 / Sqrt(0.4D1 * x2 * zo + zo 
     #** 2 - 0.2D1 * zo + 0.1D1) / omx2 / omz1 / omzo * rln2 * zo ** 2 -
     # 0.2D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D
     #1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rln2 * zo + 0.3D1 / Sqrt(0
     #.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx2 / omz1 / omz
     #o * rln2 / zo + 0.2D1 * rH1(0, x2) / omx2 / omz1 / omzo * rln2 / z
     #o + 0.2D1 * rH1(0, zo) / omx2 / omz1 / omzo * rln2 / zo - 0.4D1 * 
     #rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 
     #0.1D1)) / omx2 / omz1 / omzo * rln2 / zo - (0.3D1 * zo ** 2 - 0.10
     #D2 * zo + 0.6D1) / zo / omx2 / omz1 / omzo * rH1(0, x2) / 0.8D1 + 
     #(zo - 0.1D1) ** 2 / zo * rH2(0, 1, zo) / omx2 / omz1 / omzo + 0.2D
     #1 * (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH2(0, 0, 0.1D1 - zo + S
     #qrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1
     # / omzo + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / x2 * (x2 - zo
     #)) / omx2 / omz1 / omzo + (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / 
     #omzo * rH2(0, 1, x2 * omx2 / zo / (0.1D1 - zo)) / 0.2D1 + (zo + 0.
     #1D1) * (zo - 0.3D1) / zo / omx2 / omz1 / omzo * rH1(0, zo) / 0.2D1
     # - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(
     #0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / o
     #mzo * rH1(0, zo) - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * r
     #H1(1, zo) / omx2 / omz1 / omzo * rH1(0, 0.1D1 - x2 - zo) / 0.2D1 +
     # (zo - 0.3D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo
     # ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * Sqrt(0.4D1 * x
     #2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (zo ** 2 - 0.2D1 * zo + 0
     #.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 
     #0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rH1(0, x2) - (0.3D1 * 
     #zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(0, 0.1D1 - x2 - zo) / omx
     #2 / omz1 / omzo * rH1(0, x2) / 0.2D1 + 0.1D1 / Sqrt(0.4D1 * x2 * z
     #o + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx2 / omz1 / omzo * rln2 * zo
     # + rH1(0, x2) / omx2 / omz1 / omzo * rln2 * zo + rH1(0, zo) / omx2
     # / omz1 / omzo * rln2 * zo + (0.2D1 * zo ** 2 - 0.4D1 * zo + 0.3D1
     #) / zo / omx2 / omz1 / omzo * rH1(0, x2) ** 2 / 0.2D1 - (x2 - 0.2D
     #1 * zo + 0.1D1) / zo * rH1(1, zo) * dla / omz1 / omzo / 0.2D1 + (0
     #.3D1 / 0.8D1 * zo - x2 / 0.4D1 - x2 * zo / 0.8D1) * dls / omz1 / o
     #mzo + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d1x2 / om
     #z1 / omzo / 0.2D1 + (zo - 0.1D1) ** 2 / zo * rH1(1, zo) / omx2 / o
     #mz1 / omzo * rH1(0, zo) - (zo - 0.1D1) ** 2 / zo * rH1(1, x2) / om
     #x2 / omz1 / omzo * rH1(0, zo) - (zo - 0.3D1) * (zo + 0.1D1) ** 2 /
     # zo * rH1(0, x2) / omx2 / omz1 / omzo / Sqrt(0.4D1 * x2 * zo + zo 
     #** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (zo - 0.3D1) * (zo + 0.1D1) *
     #* 2 / zo * rH1(0, zo) / omx2 / omz1 / omzo / Sqrt(0.4D1 * x2 * zo 
     #+ zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (zo - 0.1D1) ** 2 / zo *
     # rH1(0, -x2 + zo) / omx2 / omz1 / omzo * rH1(0, x2) - (0.3D1 * zo 
     #** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(1, zo) / omx2 / omz1 / omzo 
     #* rH1(0, x2) / 0.2D1 + (zo - 0.1D1) ** 2 / zo * rH1(0, -x2 + zo) /
     # omx2 / omz1 / omzo * rH1(0, zo) - (0.5D1 * zo ** 2 - 0.10D2 * zo 
     #+ 0.8D1) / zo * rH2(0, 1, zo) * d0x2 / omz1 / omzo / 0.4D1 - (zo *
     #* 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) ** 2 * d0x2 / omz1 / o
     #mzo / 0.4D1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * d0x2 * dls / omz1 / o
     #mzo + (0.1D1 / 0.2D1 - zo / 0.4D1) * rH1(0, zo) * d0x2 * dls / omz
     #1 / omzo + (-0.1D1 / 0.2D1 + zo / 0.8D1) * d0x2 * dla / omz1 / omz
     #o + (-0.1D1 / 0.2D1 + zo / 0.4D1) * rH1(0, zo) * d0x2 * dla / omz1
     # / omzo - (zo ** 2 - 0.2D1 * zo + 0.2D1) * (0.1D1 + x2) / zo * rH1
     #(1, x2) / omzo / omz1 * rH1(0, x2) / 0.4D1 + (0.9D1 * zo ** 2 - 0.
     #9D1 * zo + 0.5D1) / zo * d0x2 / omz1 / omzo / 0.8D1 + (0.1D1 / 0.2
     #D1 - zo / 0.8D1) * rH1(1, zo) * d0x2 / omz1 / omzo - (x2 - 0.2D1 *
     # zo + 0.1D1) / zo * rH1(0, -x2 + zo) / omzo / omz1 * rH1(0, zo) / 
     #0.2D1 + (x2 - 0.3D1 * zo + 0.1D1) / zo * rH1(1, x2) / omzo / omz1 
     #* rH1(0, zo) / 0.2D1 - 0.5D1 / 0.4D1 * d0x2 / omz1 / omzo * rH1(0,
     # zo) + (-0.1D1 - x2) / zo / omzo / omz1 * rln2 ** 2 + 0.2D1 / Sqrt
     #(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omzo / omz1 * r
     #ln2 * zo + (-0.8D1 * x2 - 0.8D1) / Sqrt(0.4D1 * x2 * zo + zo ** 2 
     #- 0.2D1 * zo + 0.1D1) / omzo / omz1 * rln2 - 0.2D1 / Sqrt(0.4D1 * 
     #x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omzo / omz1 * rln2 / zo 
     #+ 0.2D1 / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 
     #- 0.2D1 * zo + 0.1D1)) / omzo / omz1 * Sqrt(0.4D1 * x2 * zo + zo *
     #* 2 - 0.2D1 * zo + 0.1D1) + (x2 * zo ** 2 + 0.2D1 * x2 * zo - 0.3D
     #1 * zo ** 2 + 0.10D2 * zo + 0.8D1) / zo / omzo / omz1 * rH1(0, zo)
     # / 0.8D1 + (0.1D1 / 0.2D1 - 0.3D1 / 0.8D1 * x2 * zo + x2 / 0.4D1 -
     # 0.3D1 / 0.8D1 * zo) / omzo / omz1 * rH1(1, x2) + (-0.1D1 / 0.2D1 
     #+ zo / 0.8D1) * d1x2 / omz1 / omzo + (x2 - 0.2D1 * zo + 0.1D1) / z
     #o / omz1 / omzo * rH1(1, zo) * rH1(0, 0.1D1 - x2 - zo) / 0.2D1 + (
     #x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, -x2 + zo) / omzo / omz1 * r
     #H1(0, x2) / 0.2D1 + (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omzo *
     # rH2(0, 1, 0.1D1 / omx2 * zo) / 0.2D1 + (x2 - 0.2D1 * zo + 0.1D1) 
     #/ zo / omz1 / omzo * rH1(1, x2) ** 2 / 0.2D1 - (x2 * zo ** 2 - 0.2
     #D1 * x2 * zo + zo ** 2 + 0.2D1 * x2 + 0.2D1) / zo / omz1 / omzo * 
     #rH2(0, 1, zo) / 0.4D1 - 0.2D1 * (0.1D1 + x2) / zo / omz1 / omzo * 
     #rH2(0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo
     # + 0.1D1)) - (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omzo * rH2(0,
     # 1, 0.1D1 / x2 * (x2 - zo)) / 0.2D1 + (0.1D1 - zo / 0.2D1) * rH2(0
     #, 1, 0.1D1 / omx2 * zo) / omx2 / omz1 / omzo + (-0.1D1 / 0.2D1 + z
     #o / 0.4D1) * rH1(0, zo) * d1x2 / omz1 / omzo + (x2 * zo / 0.8D1 + 
     #x2 / 0.4D1 - 0.3D1 / 0.8D1 * zo) * dla / omz1 / omzo + (x2 - 0.2D1
     # * zo + 0.1D1) / zo / omz1 / omzo * rH2(0, 1, 0.1D1 / omx2 * (0.1D
     #1 - zo)) / 0.2D1 + 0.1D1 / omx2 / omz1 / omzo * rln2 ** 2 * zo + 0
     #.2D1 / omx2 / omz1 / omzo * rln2 ** 2 / zo + 0.5D1 / Sqrt(0.4D1 * 
     #x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx2 / omz1 / omzo * rln
     #2 - 0.2D1 * rH1(0, x2) / omx2 / omz1 / omzo * rln2 - 0.2D1 * rH1(0
     #, zo) / omx2 / omz1 / omzo * rln2 + 0.4D1 * rH1(0, 0.1D1 - zo + Sq
     #rt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 
     #/ omzo * rln2 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) *
     # d0x2 * dla / omz1 / omzo / 0.2D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1)
     # / zo * rH1(1, zo) * d0x2 * dls / omz1 / omzo / 0.2D1 - (zo ** 3 +
     # (x2 - 0.3D1) * zo ** 2 + (-0.2D1 * x2 + 0.6D1) * zo + 0.4D1 * x2 
     #- 0.4D1) / (-0.1D1 + x2 + zo) / zo * d0x2 / omz1 / omzo * pi ** 2 
     #/ 0.24D2 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d0x2
     # / omz1 / omzo * rH1(0, zo) / 0.2D1 + (x2 - 0.2D1 * zo + 0.1D1) / 
     #zo * rH1(1, zo) * dls / omz1 / omzo / 0.2D1 - (0.3D1 * x2 ** 2 * z
     #o ** 2 + 0.3D1 * x2 * zo ** 3 - 0.2D1 * x2 ** 2 * zo - 0.14D2 * x2
     # * zo ** 2 - 0.9D1 * zo ** 3 + 0.10D2 * x2 ** 2 + 0.10D2 * x2 * zo
     # - zo ** 2 - 0.14D2 * x2 + 0.6D1 * zo + 0.4D1) / (-0.1D1 + x2 + zo
     #) / zo / omzo / omz1 / 0.8D1 - (x2 ** 3 * zo + 0.2D1 * x2 ** 2 * z
     #o ** 2 + x2 * zo ** 3 + 0.2D1 * x2 ** 3 - x2 ** 2 * zo - 0.6D1 * x
     #2 * zo ** 2 - 0.3D1 * zo ** 3 - 0.4D1 * x2 ** 2 + 0.19D2 * x2 * zo
     # + 0.14D2 * zo ** 2 - 0.14D2 * x2 - 0.19D2 * zo + 0.8D1) / (-0.1D1
     # + x2 + zo) ** 2 * rH1(1, zo) / omzo / omz1 / 0.8D1 + (0.1D1 / 0.2
     #D1 + zo / 0.4D1 - x2 / 0.2D1 + x2 * zo / 0.4D1) * rH2(0, 1, x2) / 
     #omzo / omz1 - 0.2D1 / omx2 / omz1 / omzo * rln2 ** 2 - (zo ** 2 - 
     #0.2D1 * zo + 0.2D1) / omx2 / zo / omz1 / omzo * rH2(0, 1, x2 / omx
     #2 * zo / (0.1D1 - zo)) / 0.2D1 + rH1(0, zo) * dla / omz1 / omzo / 
     #0.2D1 - rH1(0, zo) * dls / omz1 / omzo / 0.2D1 + (zo ** 2 - 0.2D1 
     #* zo + 0.2D1) / zo * rH1(0, zo) / omx2 / omz1 / omzo * rH1(0, x2) 
     #/ 0.2D1
      elseif(region4) then
      e0 = (0.7D1 * zo ** 2 - 0.14D2 * zo + 0.10D2) / zo / omx2 / omz1
     # / omzo * rH1(0, x2) ** 2 / 0.4D1 + (0.1D1 - zo / 0.2D1) * rH1(1, 
     #x2) / omx2 / omz1 / omzo * rH1(0, x2) + 0.1D1 / zo * rH1(0, zo) / 
     #omx2 / omz1 / omzo * rH1(0, x2) - (x2 - zo + 0.1D1) / zo * rH1(1, 
     #x2) / omzo / omz1 * rH1(0, zo) / 0.2D1 + (zo - 0.1D1) ** 2 / zo / 
     #omx2 / omz1 / omzo * rH1(0, zo) ** 2 / 0.2D1 - (zo - 0.1D1) ** 2 /
     # zo * rH2(0, 1, 0.1D1 / omx2 * (0.1D1 - zo)) / omx2 / omz1 / omzo 
     #+ (zo / 0.2D1 - 0.1D1) * rH2(0, 1, omx2 / zo) / omx2 / omz1 / omzo
     # + (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) ** 2 / omzo / omz1 
     #/ 0.4D1 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) / omx2 
     #/ omz1 / omzo * rH1(0, zo) / 0.2D1 + (x2 - 0.2D1 * zo + 0.1D1) / z
     #o / omz1 / omzo * rH1(1, zo) * rH1(0, -0.1D1 + x2 + zo) / 0.2D1 + 
     #(x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, -0.1D1 + x2 + zo) / omzo /
     # omz1 * rH1(0, x2) / 0.2D1 + (x2 * zo ** 2 - 0.2D1 * x2 * zo + zo 
     #** 2 - 0.2D1 * x2 + 0.8D1 * zo - 0.2D1) / zo / omzo / omz1 * rH1(0
     #, zo) ** 2 / 0.8D1 + (-0.1D1 - x2) * rH1(0, x2) / omzo / omz1 * rl
     #n2 / zo + (-0.1D1 - x2) * rH1(0, zo) / omzo / omz1 * rln2 / zo + (
     #0.2D1 + 0.2D1 * x2) * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + z
     #o ** 2 - 0.2D1 * zo + 0.1D1)) / omzo / omz1 * rln2 / zo - (0.3D1 *
     # x2 ** 3 * zo ** 2 + 0.6D1 * x2 ** 2 * zo ** 3 + 0.3D1 * x2 * zo *
     #* 4 + 0.2D1 * x2 ** 3 * zo - x2 ** 2 * zo ** 2 - 0.2D1 * x2 * zo *
     #* 3 + zo ** 4 - 0.2D1 * x2 ** 3 - 0.8D1 * x2 ** 2 * zo + 0.11D2 * 
     #x2 * zo ** 2 + 0.6D1 * zo ** 3 - 0.2D1 * x2 ** 2 - 0.22D2 * x2 * z
     #o - 0.21D2 * zo ** 2 + 0.10D2 * x2 + 0.20D2 * zo - 0.6D1) / zo / (
     #-0.1D1 + x2 + zo) ** 2 / omzo / omz1 * rH1(0, x2) / 0.8D1 + (0.1D1
     # + x2) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 -
     # 0.2D1 * zo + 0.1D1)) / omzo / omz1 * rH1(0, x2) + (0.1D1 + x2) / 
     #zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * 
     #zo + 0.1D1)) / omzo / omz1 * rH1(0, zo) - (0.4D1 * x2 * zo - zo **
     # 2 + 0.4D1 * zo + 0.1D1) / zo * rH1(0, x2) / omzo / omz1 / Sqrt(0.
     #4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (0.4D1 * x2 * zo -
     # zo ** 2 + 0.4D1 * zo + 0.1D1) / zo * rH1(0, zo) / omzo / omz1 / S
     #qrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (zo - 0.1D1)
     # ** 2 / zo / omx2 / omz1 / omzo * pi ** 2 / 0.6D1 - 0.1D1 / Sqrt(0
     #.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx2 / omz1 / omz
     #o * rln2 * zo ** 2 - 0.2D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 *
     # zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rln2 *
     # zo + 0.3D1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)
     # / omx2 / omz1 / omzo * rln2 / zo + 0.2D1 * rH1(0, x2) / omx2 / om
     #z1 / omzo * rln2 / zo + 0.2D1 * rH1(0, zo) / omx2 / omz1 / omzo * 
     #rln2 / zo - 0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo 
     #** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rln2 / zo - (0.
     #3D1 * zo ** 2 - 0.10D2 * zo + 0.6D1) / zo / omx2 / omz1 / omzo * r
     #H1(0, x2) / 0.8D1 + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, zo) / omx2 
     #/ omz1 / omzo + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / x2 / om
     #x2 * zo * (0.1D1 - zo)) / omx2 / omz1 / omzo + 0.2D1 * (zo ** 2 - 
     #0.2D1 * zo + 0.2D1) / zo * rH2(0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x2 
     #* zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo + (zo -
     # 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / x2 * (x2 - zo)) / omx2 / omz
     #1 / omzo - (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omzo * rH2(0, 1
     #, omx2 / zo) / 0.2D1 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / omx2 / zo 
     #/ omz1 / omzo * rH2(0, 1, 0.1D1 / x2 * omx2 / zo * (0.1D1 - zo)) /
     # 0.2D1 + (zo + 0.1D1) * (zo - 0.3D1) / zo / omx2 / omz1 / omzo * r
     #H1(0, zo) / 0.2D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(0, 0
     #.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) 
     #/ omx2 / omz1 / omzo * rH1(0, zo) + (zo - 0.3D1) / zo * rH1(0, 0.1
     #D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / 
     #omx2 / omz1 / omzo * Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo +
     # 0.1D1) - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo 
     #+ Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx2 / o
     #mz1 / omzo * rH1(0, x2) + 0.1D1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 -
     # 0.2D1 * zo + 0.1D1) / omx2 / omz1 / omzo * rln2 * zo + rH1(0, x2)
     # / omx2 / omz1 / omzo * rln2 * zo + rH1(0, zo) / omx2 / omz1 / omz
     #o * rln2 * zo - (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) * dla 
     #/ omz1 / omzo / 0.2D1 + (0.3D1 / 0.8D1 * zo - x2 / 0.4D1 - x2 * zo
     # / 0.8D1) * dls / omz1 / omzo + (zo ** 2 - 0.2D1 * zo + 0.2D1) / z
     #o * rH1(1, zo) * d1x2 / omz1 / omzo / 0.2D1 + (zo - 0.1D1) ** 2 / 
     #zo * rH1(1, x2) / omx2 / omz1 / omzo * rH1(0, zo) - (zo - 0.3D1) *
     # (zo + 0.1D1) ** 2 / zo * rH1(0, x2) / omx2 / omz1 / omzo / Sqrt(0
     #.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (zo - 0.3
     #D1) * (zo + 0.1D1) ** 2 / zo * rH1(0, zo) / omx2 / omz1 / omzo / S
     #qrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (zo 
     #- 0.1D1) ** 2 / zo * rH1(0, -x2 + zo) / omx2 / omz1 / omzo * rH1(0
     #, x2) + (zo - 0.1D1) ** 2 / zo * rH1(0, -x2 + zo) / omx2 / omz1 / 
     #omzo * rH1(0, zo) - (0.5D1 * zo ** 2 - 0.10D2 * zo + 0.8D1) / zo *
     # rH2(0, 1, zo) * d0x2 / omz1 / omzo / 0.4D1 - (zo ** 2 - 0.2D1 * z
     #o + 0.2D1) / zo * rH1(1, zo) ** 2 * d0x2 / omz1 / omzo / 0.4D1 + (
     #0.1D1 / 0.2D1 - zo / 0.8D1) * d0x2 * dls / omz1 / omzo + (0.1D1 / 
     #0.2D1 - zo / 0.4D1) * rH1(0, zo) * d0x2 * dls / omz1 / omzo + (-0.
     #1D1 / 0.2D1 + zo / 0.8D1) * d0x2 * dla / omz1 / omzo + (-0.1D1 / 0
     #.2D1 + zo / 0.4D1) * rH1(0, zo) * d0x2 * dla / omz1 / omzo + (0.9D
     #1 * zo ** 2 - 0.9D1 * zo + 0.5D1) / zo * d0x2 / omz1 / omzo / 0.8D
     #1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * rH1(1, zo) * d0x2 / omz1 / omzo
     # - (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, -x2 + zo) / omzo / omz1
     # * rH1(0, zo) / 0.2D1 - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / z
     #o * rH1(1, zo) / omx2 / omz1 / omzo * rH1(0, -0.1D1 + x2 + zo) / 0
     #.2D1 - 0.5D1 / 0.4D1 * d0x2 / omz1 / omzo * rH1(0, zo) + (0.2D1 * 
     #x2 - 0.3D1 * zo + 0.2D1) / zo / omzo / omz1 * pi ** 2 / 0.12D2 + (
     #-0.1D1 - x2) / zo / omzo / omz1 * rln2 ** 2 + 0.2D1 / Sqrt(0.4D1 *
     # x2 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omzo / omz1 * rln2 * zo
     # + (-0.8D1 * x2 - 0.8D1) / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 
     #* zo + 0.1D1) / omzo / omz1 * rln2 - 0.2D1 / Sqrt(0.4D1 * x2 * zo 
     #+ zo ** 2 - 0.2D1 * zo + 0.1D1) / omzo / omz1 * rln2 / zo + 0.2D1 
     #/ zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 
     #* zo + 0.1D1)) / omzo / omz1 * Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.
     #2D1 * zo + 0.1D1) - (x2 * zo ** 2 - 0.2D1 * x2 * zo + zo ** 2 + 0.
     #9D1 * x2 - 0.12D2 * zo + 0.9D1) / zo / omzo / omz1 * rH1(0, x2) **
     # 2 / 0.8D1 + (-x2 * zo / 0.4D1 + x2 / 0.2D1 - zo / 0.4D1 - 0.1D1 /
     # 0.2D1) * rH1(1, x2) / omzo / omz1 * rH1(0, x2) + (x2 * zo ** 2 + 
     #0.2D1 * x2 * zo - 0.3D1 * zo ** 2 + 0.10D2 * zo + 0.8D1) / zo / om
     #zo / omz1 * rH1(0, zo) / 0.8D1 + (0.1D1 / 0.2D1 + zo / 0.4D1 - x2 
     #/ 0.2D1 + x2 * zo / 0.4D1) * rH1(1, zo) / omzo / omz1 * rH1(0, zo)
     # + (0.1D1 / 0.2D1 - 0.3D1 / 0.8D1 * x2 * zo + x2 / 0.4D1 - 0.3D1 /
     # 0.8D1 * zo) / omzo / omz1 * rH1(1, x2) + (-0.1D1 / 0.2D1 + zo / 0
     #.8D1) * d1x2 / omz1 / omzo + (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(
     #0, -x2 + zo) / omzo / omz1 * rH1(0, x2) / 0.2D1 - (x2 * zo ** 2 - 
     #0.2D1 * x2 * zo + zo ** 2 + 0.2D1 * x2 + 0.2D1) / zo / omz1 / omzo
     # * rH2(0, 1, zo) / 0.4D1 - 0.2D1 * (0.1D1 + x2) / zo / omz1 / omzo
     # * rH2(0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 *
     # zo + 0.1D1)) - (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omzo * rH2
     #(0, 1, 0.1D1 / x2 * (x2 - zo)) / 0.2D1 - (x2 - 0.2D1 * zo + 0.1D1)
     # / zo / omz1 / omzo * rH2(0, 1, 0.1D1 / x2 / omx2 * zo * (0.1D1 - 
     #zo)) / 0.2D1 + (-0.1D1 / 0.2D1 + zo / 0.4D1) * rH1(0, zo) * d1x2 /
     # omz1 / omzo + (x2 * zo / 0.8D1 + x2 / 0.4D1 - 0.3D1 / 0.8D1 * zo)
     # * dla / omz1 / omzo + (x2 - 0.2D1 * zo + 0.1D1) / zo / omz1 / omz
     #o * rH2(0, 1, 0.1D1 / omx2 * (0.1D1 - zo)) / 0.2D1 + 0.1D1 / omx2 
     #/ omz1 / omzo * rln2 ** 2 * zo + 0.2D1 / omx2 / omz1 / omzo * rln2
     # ** 2 / zo + 0.5D1 / Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0.2D1 * zo +
     # 0.1D1) / omx2 / omz1 / omzo * rln2 - 0.2D1 * rH1(0, x2) / omx2 / 
     #omz1 / omzo * rln2 - 0.2D1 * rH1(0, zo) / omx2 / omz1 / omzo * rln
     #2 + 0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x2 * zo + zo ** 2 - 0
     #.2D1 * zo + 0.1D1)) / omx2 / omz1 / omzo * rln2 + (zo ** 2 - 0.2D1
     # * zo + 0.2D1) / zo * rH1(1, zo) * d0x2 * dla / omz1 / omzo / 0.2D
     #1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d0x2 * dls 
     #/ omz1 / omzo / 0.2D1 - (zo ** 3 + (x2 - 0.3D1) * zo ** 2 + (-0.2D
     #1 * x2 + 0.6D1) * zo + 0.4D1 * x2 - 0.4D1) / (-0.1D1 + x2 + zo) / 
     #zo * d0x2 / omz1 / omzo * pi ** 2 / 0.24D2 + (zo ** 2 - 0.2D1 * zo
     # + 0.2D1) / zo * rH1(1, zo) * d0x2 / omz1 / omzo * rH1(0, zo) / 0.
     #2D1 + (x2 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) * dls / omz1 / o
     #mzo / 0.2D1 - (0.3D1 * x2 ** 2 * zo ** 2 + 0.3D1 * x2 * zo ** 3 - 
     #0.2D1 * x2 ** 2 * zo - 0.14D2 * x2 * zo ** 2 - 0.9D1 * zo ** 3 + 0
     #.10D2 * x2 ** 2 + 0.10D2 * x2 * zo - zo ** 2 - 0.14D2 * x2 + 0.6D1
     # * zo + 0.4D1) / (-0.1D1 + x2 + zo) / zo / omzo / omz1 / 0.8D1 - (
     #x2 ** 3 * zo + 0.2D1 * x2 ** 2 * zo ** 2 + x2 * zo ** 3 + 0.2D1 * 
     #x2 ** 3 - x2 ** 2 * zo - 0.6D1 * x2 * zo ** 2 - 0.3D1 * zo ** 3 - 
     #0.4D1 * x2 ** 2 + 0.19D2 * x2 * zo + 0.14D2 * zo ** 2 - 0.14D2 * x
     #2 - 0.19D2 * zo + 0.8D1) / (-0.1D1 + x2 + zo) ** 2 * rH1(1, zo) / 
     #omzo / omz1 / 0.8D1 - rH1(0, zo) / omzo / omz1 * rH1(0, x2) + (0.1
     #D1 / 0.2D1 + zo / 0.4D1 - x2 / 0.2D1 + x2 * zo / 0.4D1) * rH2(0, 1
     #, x2) / omzo / omz1 - 0.2D1 / omx2 / omz1 / omzo * rln2 ** 2 + rH1
     #(0, zo) * dla / omz1 / omzo / 0.2D1 - rH1(0, zo) * dls / omz1 / om
     #zo / 0.2D1 - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(0, 
     #-0.1D1 + x2 + zo) / omx2 / omz1 / omzo * rH1(0, x2) / 0.2D1
      endif
      endif

      if(ieorder.eq.-2)then
        rJ22QQFIqgam_fragh=e2
      elseif(ieorder.eq.-1)then
        rJ22QQFIqgam_fragh=e1
      elseif(ieorder.eq.0)then
        rJ22QQFIqgam_fragh=e0
      endif

*      write(*,*)" rJ22QQFIqgam_fragh ",rJ22QQFIqgam_fragh

      return
      end
************************************************************************
*
      function rJ22hGQFIqgam_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use PhotonFragmentation_mod, only : iz_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J22hGQFIqgam_frag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ22hGQFIqgam_frag=rJ22hQGIFqgam_frag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_frag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = rH1(0, zo) * d0x2 * dla / omz1 / omzo - rH1(0, zo) * d0x2 *
     # dls / omz1 / omzo * zo + rH1(0, zo) * d1x2 / omz1 / omzo * zo - r
     #H1(0, zo) * dla ** 2 / omz1 / omz2 / omzo * zo / 0.2D1 - 0.2D1 / 0
     #.3D1 * dla * dls / omz1 / omz2 / omzo * zo ** 2 - dla * dls / omz1
     # / omz2 / omzo * zo / 0.2D1 + 0.2D1 / 0.3D1 * dla * dls / omz1 / o
     #mz2 / omzo / zo - dla / omz1 / omz2 / omzo * pi ** 2 * zo / 0.6D1 
     #- 0.2D1 / 0.3D1 * rH1(1, z2) * dla / omz1 / omz2 / omzo * zo ** 2 
     #- 0.2D1 / 0.3D1 * rH1(1, zo) * dla / omz1 / omz2 / omzo * zo ** 2 
     #+ 0.2D1 / 0.3D1 * rH1(0, zo) * dla / omz1 / omz2 / omzo * zo ** 2 
     #+ dla / omz1 / omz2 / omzo * zo * rH1(0, zo) - rH1(1, z2) * dla / 
     #omz1 / omz2 / omzo * zo / 0.2D1 - rH1(1, zo) * dla / omz1 / omz2 /
     # omzo * zo / 0.2D1 + rH2(0, 1, zo) * dla / omz1 / omz2 / omzo + 0.
     #2D1 / 0.3D1 * rH1(1, z2) * dla / omz1 / omz2 / omzo / zo + 0.2D1 /
     # 0.3D1 * rH1(1, zo) * dla / omz1 / omz2 / omzo / zo + 0.2D1 / 0.3D
     #1 * rH1(0, zo) * dla / omz1 / omz2 / omzo / zo - rH1(0, zo) * dls 
     #** 2 / omz1 / omz2 / omzo * zo / 0.2D1 + dls / omz1 / omz2 / omzo 
     #* pi ** 2 * zo / 0.6D1 + 0.2D1 / 0.3D1 * rH1(1, z2) * dls / omz1 /
     # omz2 / omzo * zo ** 2 + 0.2D1 / 0.3D1 * rH1(1, zo) * dls / omz1 /
     # omz2 / omzo * zo ** 2 - 0.2D1 / 0.3D1 * rH1(0, zo) * dls / omz1 /
     # omz2 / omzo * zo ** 2 - dls / omz1 / omz2 / omzo * zo * rH1(0, zo
     #) + rH1(1, z2) * dls / omz1 / omz2 / omzo * zo / 0.2D1 + rH1(1, zo
     #) * dls / omz1 / omz2 / omzo * zo / 0.2D1 - rH2(0, 1, zo) * dls / 
     #omz1 / omz2 / omzo * zo - rH1(1, z2) * dls / omz1 / omz2 / omzo * 
     #rH1(0, zo) - 0.2D1 / 0.3D1 * rH1(1, z2) * dls / omz1 / omz2 / omzo
     # / zo - 0.2D1 / 0.3D1 * rH1(1, zo) * dls / omz1 / omz2 / omzo / zo
     # - 0.2D1 / 0.3D1 * rH1(0, zo) * dls / omz1 / omz2 / omzo / zo + rH
     #1(1, z2) / omz1 / omz2 / omzo * pi ** 2 * zo / 0.6D1 - 0.2D1 / 0.3
     #D1 * rH1(1, z2) / omz1 / omz2 / omzo * zo ** 2 * rH1(0, zo) + 0.2D
     #1 / 0.3D1 * rH1(1, zo) / omz1 / omz2 / omzo * zo ** 2 * rH1(0, zo)
     # + 0.2D1 / 0.3D1 * rH1(1, zo) / omz1 / omz2 / omzo * zo ** 2 * rH1
     #(1, z2) - rH1(1, z2) / omz1 / omz2 / omzo * zo * rH1(0, zo) - rH2(
     #1, 1, z2) / omz1 / omz2 / omzo * zo * rH1(0, zo) + rH1(1, zo) / om
     #z1 / omz2 / omzo * zo * rH1(0, zo) / 0.2D1 - rH2(0, 1, zo) / omz1 
     #/ omz2 / omzo * zo * rH1(0, zo) + rH1(1, zo) ** 2 / omz1 / omz2 / 
     #omzo * zo * rH1(0, zo) / 0.2D1 + rH1(1, zo) / omz1 / omz2 / omzo *
     # zo * rH1(1, z2) / 0.2D1 - rH2(0, 1, zo) / omz1 / omz2 / omzo * zo
     # * rH1(1, z2) - rH2(0, 1, zo) / omz1 / omz2 / omzo * zo * rH1(1, z
     #o) - 0.2D1 / 0.3D1 * rH1(1, z2) / omz1 / omz2 / omzo / zo * rH1(0,
     # zo) - 0.2D1 / 0.3D1 * rH1(1, zo) / omz1 / omz2 / omzo / zo * rH1(
     #0, zo) - 0.2D1 / 0.3D1 * rH1(1, zo) / omz1 / omz2 / omzo / zo * rH
     #1(1, z2) + 0.2D1 / 0.3D1 * d0x2 * dls / omz1 / omzo * zo ** 2 + d0
     #x2 * dls / omz1 / omzo * zo / 0.2D1 - rH1(0, zo) * d0x2 * dls / om
     #z1 / omzo - 0.2D1 / 0.3D1 * d0x2 * dls / omz1 / omzo / zo + d0x2 /
     # omz1 / omzo * pi ** 2 * zo / 0.6D1 + 0.2D1 / 0.3D1 * rH1(1, zo) *
     # d0x2 / omz1 / omzo * zo ** 2 - 0.2D1 / 0.3D1 * rH1(0, zo) * d0x2 
     #/ omz1 / omzo * zo ** 2 + rH1(1, zo) * d0x2 / omz1 / omzo * zo / 0
     #.2D1 - rH1(0, zo) * d0x2 / omz1 / omzo * zo - rH2(0, 1, zo) * d0x2
     # / omz1 / omzo * zo - 0.2D1 / 0.3D1 * rH1(1, zo) * d0x2 / omz1 / o
     #mzo / zo - 0.2D1 / 0.3D1 * rH1(0, zo) * d0x2 / omz1 / omzo / zo + 
     #rH1(0, zo) * d1x2 / omz1 / omzo + dla ** 2 / omz1 / omz2 / omzo * 
     #zo ** 2 / 0.3D1 + dla ** 2 / omz1 / omz2 / omzo * zo / 0.4D1 - rH1
     #(0, zo) * dla ** 2 / omz1 / omz2 / omzo / 0.2D1 - dla ** 2 / omz1 
     #/ omz2 / omzo / zo / 0.3D1 + dla * dls / omz1 / omz2 / omzo / 0.2D
     #1 - dla / omz1 / omz2 / omzo * pi ** 2 / 0.6D1 - 0.17D2 / 0.6D1 * 
     #dla / omz1 / omz2 / omzo * zo ** 2 + 0.8D1 / 0.3D1 * dla / omz1 / 
     #omz2 / omzo * zo + dla / omz1 / omz2 / omzo * rH1(0, zo) / 0.2D1 +
     # rH1(1, z2) * dla / omz1 / omz2 / omzo / 0.2D1 + rH1(1, zo) * dla 
     #/ omz1 / omz2 / omzo / 0.2D1 + 0.11D2 / 0.6D1 * dla / omz1 / omz2 
     #/ omzo / zo + dls ** 2 / omz1 / omz2 / omzo * zo ** 2 / 0.3D1 + dl
     #s ** 2 / omz1 / omz2 / omzo * zo / 0.4D1 - rH1(0, zo) * dls ** 2 /
     # omz1 / omz2 / omzo / 0.2D1 - dls ** 2 / omz1 / omz2 / omzo / zo /
     # 0.3D1 + dls / omz1 / omz2 / omzo * pi ** 2 / 0.6D1 + 0.17D2 / 0.6
     #D1 * dls / omz1 / omz2 / omzo * zo ** 2 - 0.8D1 / 0.3D1 * dls / om
     #z1 / omz2 / omzo * zo - dls / omz1 / omz2 / omzo * rH1(0, zo) / 0.
     #2D1 - rH1(1, z2) * dls / omz1 / omz2 / omzo / 0.2D1 - rH1(1, zo) *
     # dls / omz1 / omz2 / omzo / 0.2D1 - rH2(0, 1, zo) * dls / omz1 / o
     #mz2 / omzo - 0.11D2 / 0.6D1 * dls / omz1 / omz2 / omzo / zo + 0.1D
     #1 / omz1 / omz2 / omzo * pi ** 2 * zo ** 2 / 0.9D1 + 0.1D1 / omz1 
     #/ omz2 / omzo * pi ** 2 * zo / 0.6D1 + rH1(1, z2) / omz1 / omz2 / 
     #omzo * pi ** 2 / 0.6D1 + 0.1D1 / omz1 / omz2 / omzo * pi ** 2 / zo
     # / 0.9D1 - 0.1D1 / omz1 / omz2 / omzo * zeta3 * zo + 0.1D1 / omz1 
     #/ omz2 / omzo * zo ** 2 * rH1(0, zo) ** 2 / 0.3D1 + 0.31D2 / 0.18D
     #2 / omz1 / omz2 / omzo * zo ** 2 * rH1(0, zo) + 0.17D2 / 0.6D1 / o
     #mz1 / omz2 / omzo * zo ** 2 * rH1(1, z2) + 0.2D1 / 0.3D1 * rH2(1, 
     #1, z2) / omz1 / omz2 / omzo * zo ** 2 + 0.17D2 / 0.6D1 * rH1(1, zo
     #) / omz1 / omz2 / omzo * zo ** 2 - 0.4D1 / 0.3D1 * rH2(0, 1, zo) /
     # omz1 / omz2 / omzo * zo ** 2 + rH1(1, zo) ** 2 / omz1 / omz2 / om
     #zo * zo ** 2 / 0.3D1 + 0.1D1 / omz1 / omz2 / omzo * zo * rH1(0, zo
     #) ** 3 / 0.4D1 + 0.5D1 / 0.8D1 / omz1 / omz2 / omzo * zo * rH1(0, 
     #zo) ** 2 + 0.22D2 / 0.3D1 / omz1 / omz2 / omzo * zo * rH1(0, zo) -
     # 0.8D1 / 0.3D1 / omz1 / omz2 / omzo * zo * rH1(1, z2) + rH1(0, zo)
     # * d0x2 * dla / omz1 / omzo * zo + 0.1D1 / omz1 / omz2 / omzo * zo
     # * rH1(1, zo) ** 2 / 0.4D1 - 0.8D1 / 0.3D1 / omz1 / omz2 / omzo * 
     #zo * rH1(1, zo) + rH2(1, 1, z2) / omz1 / omz2 / omzo * zo / 0.2D1 
     #+ 0.2D1 * rH3(0, 0, 1, zo) / omz1 / omz2 / omzo * zo - rH3(1, 1, 0
     #, zo) / omz1 / omz2 / omzo * zo - 0.3D1 / 0.2D1 * rH2(0, 1, zo) / 
     #omz1 / omz2 / omzo * zo - rH1(1, z2) / omz1 / omz2 / omzo * rH1(0,
     # zo) / 0.2D1 - rH2(1, 1, z2) / omz1 / omz2 / omzo * rH1(0, zo) - r
     #H1(1, zo) / omz1 / omz2 / omzo * rH1(0, zo) / 0.2D1 - rH2(0, 1, zo
     #) / omz1 / omz2 / omzo * rH1(0, zo) + rH1(1, zo) ** 2 / omz1 / omz
     #2 / omzo * rH1(0, zo) / 0.2D1 - rH1(1, zo) / omz1 / omz2 / omzo * 
     #rH1(1, z2) / 0.2D1 - rH2(0, 1, zo) / omz1 / omz2 / omzo * rH1(1, z
     #2) - rH2(0, 1, zo) / omz1 / omz2 / omzo * rH1(1, zo) + 0.2D1 / 0.3
     #D1 / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 2 + 0.13D2 / 0.9D1 / 
     #omz1 / omz2 / omzo / zo * rH1(0, zo) - 0.11D2 / 0.6D1 / omz1 / omz
     #2 / omzo / zo * rH1(1, z2) - 0.2D1 / 0.3D1 * rH2(1, 1, z2) / omz1 
     #/ omz2 / omzo / zo - 0.11D2 / 0.6D1 * rH1(1, zo) / omz1 / omz2 / o
     #mzo / zo - rH1(1, zo) ** 2 / omz1 / omz2 / omzo / zo / 0.3D1 + rH1
     #(0, zo) * dla * dls / omz1 / omz2 / omzo + rH2(0, 1, zo) * dla / o
     #mz1 / omz2 / omzo * zo + rH1(1, z2) * dla / omz1 / omz2 / omzo * r
     #H1(0, zo) - rH1(1, z2) * dls / omz1 / omz2 / omzo * zo * rH1(0, zo
     #) - 0.2D1 / 0.3D1 * d1x2 / omz1 / omzo * zo ** 2 - d1x2 / omz1 / o
     #mzo * zo / 0.2D1 + 0.2D1 / 0.3D1 * d1x2 / omz1 / omzo / zo + 0.17D
     #2 / 0.6D1 * d0x2 / omz1 / omzo * zo ** 2 - 0.8D1 / 0.3D1 * d0x2 / 
     #omz1 / omzo * zo - 0.11D2 / 0.6D1 * d0x2 / omz1 / omzo / zo - rH1(
     #1, zo) * d0x2 / omz1 / omzo / 0.2D1 - rH2(0, 1, zo) * d0x2 / omz1 
     #/ omzo + rH1(0, zo) * dla * dls / omz1 / omz2 / omzo * zo + rH1(1,
     # z2) * dla / omz1 / omz2 / omzo * zo * rH1(0, zo) + 0.35D2 / 0.6D1
     # / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 * d0x2 / omz1 / omzo - 0.2D1
     # / 0.3D1 * d0x2 * dla / omz1 / omzo * zo ** 2 - d0x2 * dla / omz1 
     #/ omzo * zo / 0.2D1 + 0.2D1 / 0.3D1 * d0x2 * dla / omz1 / omzo / z
     #o + d1x2 / omz1 / omzo / 0.2D1 - d0x2 / omz1 / omzo * rH1(0, zo) /
     # 0.2D1 + d0x2 / omz1 / omzo * pi ** 2 / 0.6D1 - d0x2 * dls / omz1 
     #/ omzo / 0.2D1 + d0x2 * dla / omz1 / omzo / 0.2D1 - rH3(1, 1, 0, z
     #o) / omz1 / omz2 / omzo + 0.8D1 / 0.3D1 / omz1 / omz2 / omzo * rH1
     #(0, zo) + 0.5D1 / 0.3D1 / omz1 / omz2 / omzo * rH1(1, z2) - 0.1D1 
     #/ omz1 / omz2 / omzo * rH1(1, zo) ** 2 / 0.4D1 + 0.5D1 / 0.3D1 / o
     #mz1 / omz2 / omzo * rH1(1, zo) - rH2(1, 1, z2) / omz1 / omz2 / omz
     #o / 0.2D1 + 0.2D1 * rH3(0, 0, 1, zo) / omz1 / omz2 / omzo + 0.4D1 
     #/ 0.9D1 / omz1 / omz2 / omzo / zo + 0.1D1 / omz1 / omz2 / omzo * r
     #H1(0, zo) ** 3 / 0.4D1 + 0.5D1 / 0.8D1 / omz1 / omz2 / omzo * rH1(
     #0, zo) ** 2 - 0.1D1 / omz1 / omz2 / omzo * zeta3 - 0.19D2 / 0.9D1 
     #/ omz1 / omz2 / omzo * zo ** 2 - 0.25D2 / 0.6D1 / omz1 / omz2 / om
     #zo * zo + 0.1D1 / omz1 / omz2 / omzo * pi ** 2 / 0.12D2 + 0.5D1 / 
     #0.3D1 * dls / omz1 / omz2 / omzo - dls ** 2 / omz1 / omz2 / omzo /
     # 0.4D1 - 0.5D1 / 0.3D1 * dla / omz1 / omz2 / omzo - dla ** 2 / omz
     #1 / omz2 / omzo / 0.4D1
      endif
      if(ix.eq.2.and.iz_frag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = (0.19D2 * x2 ** 2 - 0.44D2 * x2 - 0.4D1) / x2 / omzo / omz1
     # * zo ** 2 / 0.18D2 + (x2 / 0.3D1 - 0.2D1 / 0.3D1) * rH1(1, zo) / 
     #omzo / omz1 * zo ** 2 + (x2 / 0.3D1 - 0.2D1 / 0.3D1) * rH1(1, x2) 
     #/ omzo / omz1 * zo ** 2 + (-x2 / 0.3D1 + 0.2D1 / 0.3D1) * rH1(0, z
     #o) / omzo / omz1 * zo ** 2 - (0.19D2 * x2 ** 2 - 0.74D2 * x2 - 0.3
     #D1) / x2 * zo / omzo / omz1 / 0.12D2 + 0.1D1 / x2 * rH1(0, zo) ** 
     #2 * zo / omzo / omz1 / 0.2D1 + (-x2 / 0.2D1 + 0.3D1 / 0.2D1) * rH1
     #(1, zo) * zo / omzo / omz1 + (-x2 / 0.2D1 + 0.3D1 / 0.2D1) * rH1(1
     #, x2) * zo / omzo / omz1 + (x2 / 0.2D1 - 0.3D1 / 0.2D1) * rH1(0, z
     #o) * zo / omzo / omz1 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) / omzo / omz
     #1 * rH1(0, zo) - (0.29D2 * x2 ** 2 + 0.2D1 * x2 + 0.19D2) / x2 / o
     #mzo / omz1 / zo / 0.36D2 + (-0.1D1 / 0.3D1 - x2 / 0.3D1) * rH1(1, 
     #zo) / omzo / omz1 / zo + (-0.1D1 / 0.3D1 - x2 / 0.3D1) * rH1(1, x2
     #) / omzo / omz1 / zo - 0.1D1 / x2 * rH1(0, zo) / omzo / omz1 / zo 
     #/ 0.3D1 + (-x2 / 0.3D1 + 0.2D1 / 0.3D1) * dla / omz1 / omzo * zo *
     #* 2 + (x2 / 0.2D1 - 0.3D1 / 0.2D1) * dla / omz1 / omzo * zo + (0.1
     #D1 / 0.3D1 + x2 / 0.3D1) * dla / omz1 / omzo / zo + (x2 / 0.3D1 - 
     #0.2D1 / 0.3D1) * dls / omz1 / omzo * zo ** 2 + (-x2 / 0.2D1 + 0.3D
     #1 / 0.2D1) * dls / omz1 / omzo * zo + (-0.1D1 / 0.3D1 - x2 / 0.3D1
     #) * dls / omz1 / omzo / zo + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 *
     # rH1(0, x2) / omzo / omz1 * zo ** 2 / 0.3D1 + (-x2 / 0.2D1 + 0.3D1
     # / 0.2D1) * zo / omzo / omz1 * rH1(0, x2) - 0.1D1 / x2 * rH1(0, zo
     #) * zo / omzo / omz1 * rH1(0, x2) + (0.1D1 + x2) * (x2 - 0.2D1) / 
     #x2 / omzo / omz1 * rH1(0, x2) / 0.2D1 - (x2 ** 2 + x2 - 0.1D1) / x
     #2 * rH1(0, x2) / omzo / omz1 / zo / 0.3D1 - rH1(0, zo) * d0x2 * dl
     #a / omz1 / omzo + rH1(0, zo) * d0x2 * dls / omz1 / omzo * zo - rH1
     #(0, zo) * d1x2 / omz1 / omzo * zo - 0.2D1 / 0.3D1 * d0x2 * dls / o
     #mz1 / omzo * zo ** 2 - d0x2 * dls / omz1 / omzo * zo / 0.2D1 + rH1
     #(0, zo) * d0x2 * dls / omz1 / omzo + 0.2D1 / 0.3D1 * d0x2 * dls / 
     #omz1 / omzo / zo - d0x2 / omz1 / omzo * pi ** 2 * zo / 0.6D1 - 0.2
     #D1 / 0.3D1 * rH1(1, zo) * d0x2 / omz1 / omzo * zo ** 2 + 0.2D1 / 0
     #.3D1 * rH1(0, zo) * d0x2 / omz1 / omzo * zo ** 2 - rH1(1, zo) * d0
     #x2 / omz1 / omzo * zo / 0.2D1 + rH1(0, zo) * d0x2 / omz1 / omzo * 
     #zo + rH2(0, 1, zo) * d0x2 / omz1 / omzo * zo + 0.2D1 / 0.3D1 * rH1
     #(1, zo) * d0x2 / omz1 / omzo / zo + 0.2D1 / 0.3D1 * rH1(0, zo) * d
     #0x2 / omz1 / omzo / zo - rH1(0, zo) * d1x2 / omz1 / omzo - rH1(0, 
     #zo) * d0x2 * dla / omz1 / omzo * zo + (0.8D1 * x2 ** 2 - 0.22D2 * 
     #x2 + 0.3D1) / x2 / omzo / omz1 / 0.6D1 + (x2 / 0.2D1 - 0.1D1 / 0.2
     #D1) * rH1(1, zo) / omzo / omz1 + (x2 / 0.2D1 - 0.1D1 / 0.2D1) * rH
     #1(1, x2) / omzo / omz1 + 0.2D1 / 0.3D1 * d1x2 / omz1 / omzo * zo *
     #* 2 + d1x2 / omz1 / omzo * zo / 0.2D1 - 0.2D1 / 0.3D1 * d1x2 / omz
     #1 / omzo / zo - 0.17D2 / 0.6D1 * d0x2 / omz1 / omzo * zo ** 2 + 0.
     #8D1 / 0.3D1 * d0x2 / omz1 / omzo * zo + 0.11D2 / 0.6D1 * d0x2 / om
     #z1 / omzo / zo + rH1(1, zo) * d0x2 / omz1 / omzo / 0.2D1 + rH2(0, 
     #1, zo) * d0x2 / omz1 / omzo - 0.5D1 / 0.3D1 * d0x2 / omz1 / omzo +
     # 0.2D1 / 0.3D1 * d0x2 * dla / omz1 / omzo * zo ** 2 + d0x2 * dla /
     # omz1 / omzo * zo / 0.2D1 - 0.2D1 / 0.3D1 * d0x2 * dla / omz1 / om
     #zo / zo - d1x2 / omz1 / omzo / 0.2D1 + d0x2 / omz1 / omzo * rH1(0,
     # zo) / 0.2D1 - d0x2 / omz1 / omzo * pi ** 2 / 0.6D1 + d0x2 * dls /
     # omz1 / omzo / 0.2D1 - d0x2 * dla / omz1 / omzo / 0.2D1 + (x2 / 0.
     #2D1 - 0.1D1 / 0.2D1) * dls / omz1 / omzo + (-x2 / 0.2D1 + 0.1D1 / 
     #0.2D1) * dla / omz1 / omzo - 0.1D1 / omzo / omz1 * rH2(0, 1, zo) +
     # 0.1D1 / omzo / omz1 * rH1(0, zo) ** 2 / 0.2D1 + 0.1D1 / omzo / om
     #z1 * pi ** 2 / 0.6D1 - rH1(0, zo) / omzo / omz1 * rH1(0, x2) - rH1
     #(1, x2) / omzo / omz1 * rH1(0, zo) + rH1(0, zo) * dla / omz1 / omz
     #o - rH1(0, zo) * dls / omz1 / omzo
      endif

      if(ieorder.eq.-2)then
        rJ22hGQFIqgam_frag=e2
      elseif(ieorder.eq.-1)then
        rJ22hGQFIqgam_frag=e1
      elseif(ieorder.eq.0)then
        rJ22hGQFIqgam_frag=e0
      endif

*      write(*,*)" rJ22hGQFIqgam_frag ",rJ22hGQFIqgam_frag

      return
      end
