************************************************************************
*
      function rJ22QQIFqgam_fragh(ix,x1,x2,zo,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use PhotonFragmentation_mod, only : iz_frag
      implicit double precision (a-h,o-z)
      logical :: region1 = .false.
      logical :: region2 = .false.
      logical :: region3 = .false.
      logical :: region4 = .false.
      common /order/ieorder
      common /method/imethod
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J22QQIFqgam_fragh: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        stop 'wrong index asigned in J22QQIFqgam_fragh'
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      dlogomx1=-rH1(1,x1)
      d0x1=1d0/omx1
      d1x1=dlogomx1*d0x1
      d2x1=dlogomx1*d1x1
      d3x1=dlogomx1*d2x1
      dlogomx2=-rH1(1,x2)
      d0x2=1d0/omx2
      d1x2=dlogomx2*d0x2
      d2x2=dlogomx2*d1x2
      d3x2=dlogomx2*d2x2

      if((zo==x1) .or. (zo==omx1))then
        rJ22QQIFqgam_fragh=0d0
        return
      else if((0d0 < zo) .and. (zo < min(x1,omx1)))then
        region1=.true.
      else if((omx1 < zo) .and. (zo < x1))then
        region2=.true.
      else if((x1 < zo) .and. (zo < omx1))then
        region3=.true.
      else if((max(x1,omx1) < zo) .and. (zo < 1d0))then
        region4=.true.
      endif

      if(ix.eq.1.and.iz_frag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = rH1(1, zo) * rH1(1, z1) * dls / omz1 / omz2 / omzo / zo + r
     #H1(1, zo) * rH1(0, zo) / omz1 / omz2 / omzo * dla / zo - d0x1 * dl
     #a / omz2 / omzo * zo / 0.8D1 + rH1(0, zo) * d0x1 * dla / omz2 / om
     #zo / 0.2D1 + d0x1 * dls / omz2 / omzo * zo / 0.8D1 - rH1(0, zo) * 
     #d0x1 * dls / omz2 / omzo / 0.2D1 - rH1(1, zo) * d0x1 * dls / omz2 
     #/ omzo + d0x1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + d0x1 / omz2 
     #/ omzo * pi ** 2 / zo / 0.6D1 - rH1(0, zo) * d0x1 * dla / omz2 / o
     #mzo * zo / 0.4D1 - rH1(1, zo) * d0x1 * dla / omz2 / omzo * zo / 0.
     #2D1 + rH1(1, zo) * d0x1 * dla / omz2 / omzo - rH1(1, zo) * d0x1 * 
     #dla / omz2 / omzo / zo + rH1(0, zo) * d0x1 * dls / omz2 / omzo * z
     #o / 0.4D1 + rH1(1, zo) * d0x1 * dls / omz2 / omzo * zo / 0.2D1 - r
     #H1(1, zo) * rH1(0, zo) * d0x1 / omz2 / omzo * zo / 0.2D1 + rH1(1, 
     #zo) * d0x1 / omz2 / omzo * rH1(0, zo) - rH1(1, zo) * rH1(0, zo) * 
     #d0x1 / omz2 / omzo / zo + rH1(0, zo) * dla ** 2 / omz1 / omz2 / om
     #zo * zo / 0.8D1 + rH1(1, zo) * dla ** 2 / omz1 / omz2 / omzo * zo 
     #/ 0.4D1 + rH1(1, zo) * dla ** 2 / omz1 / omz2 / omzo / zo / 0.2D1 
     #+ d0x1 * dla / omz2 / omzo / 0.2D1 - d0x1 * dls / omz2 / omzo / 0.
     #2D1 - d0x1 / omz2 / omzo * pi ** 2 / 0.12D2 - 0.9D1 / 0.8D1 * d0x1
     # / omz2 / omzo * zo - 0.5D1 / 0.8D1 * d0x1 / omz2 / omzo / zo + 0.
     #5D1 / 0.4D1 * d0x1 / omz2 / omzo * rH1(0, zo) - 0.5D1 / 0.2D1 * rH
     #2(0, 1, zo) * d0x1 / omz2 / omzo - rH1(1, zo) ** 2 * d0x1 / omz2 /
     # omzo / 0.2D1 - rH1(1, zo) * d0x1 / omz2 / omzo / 0.2D1 - d1x1 / o
     #mz2 / omzo * zo / 0.8D1 + rH1(0, zo) * d1x1 / omz2 / omzo / 0.2D1 
     #- dla ** 2 / omz1 / omz2 / omzo / 0.4D1 + 0.9D1 / 0.8D1 * d0x1 / o
     #mz2 / omzo + d1x1 / omz2 / omzo / 0.2D1 + 0.5D1 / 0.4D1 * rH2(0, 1
     #, zo) * d0x1 / omz2 / omzo * zo + rH1(1, zo) ** 2 * d0x1 / omz2 / 
     #omzo * zo / 0.4D1 + rH1(1, zo) * d0x1 / omz2 / omzo * zo / 0.8D1 +
     # 0.2D1 * rH2(0, 1, zo) * d0x1 / omz2 / omzo / zo + rH1(1, zo) ** 2
     # * d0x1 / omz2 / omzo / zo / 0.2D1 - rH1(0, zo) * d1x1 / omz2 / om
     #zo * zo / 0.4D1 - rH1(1, zo) * d1x1 / omz2 / omzo * zo / 0.2D1 + r
     #H1(1, zo) * d1x1 / omz2 / omzo - rH1(1, zo) * d1x1 / omz2 / omzo /
     # zo + dla ** 2 / omz1 / omz2 / omzo * zo / 0.16D2 - rH1(0, zo) * d
     #la ** 2 / omz1 / omz2 / omzo / 0.4D1 - rH1(1, zo) * dla ** 2 / omz
     #1 / omz2 / omzo / 0.2D1 + dls * dla / omz1 / omz2 / omzo / 0.2D1 +
     # 0.1D1 / omz1 / omz2 / omzo * dla * pi ** 2 / 0.12D2 + 0.9D1 / 0.8
     #D1 / omz1 / omz2 / omzo * dla * zo - 0.5D1 / 0.4D1 / omz1 / omz2 /
     # omzo * dla * rH1(0, zo) + 0.1D1 / omz1 / omz2 / omzo * dla * rH1(
     #1, z1) / 0.2D1 + 0.5D1 / 0.2D1 * rH2(0, 1, zo) / omz1 / omz2 / omz
     #o * dla + rH1(1, zo) ** 2 / omz1 / omz2 / omzo * dla / 0.2D1 + 0.5
     #D1 / 0.8D1 / omz1 / omz2 / omzo * dla / zo + 0.1D1 / omz1 / omz2 /
     # omzo * dls ** 2 * zo / 0.16D2 - rH1(0, zo) / omz1 / omz2 / omzo *
     # dls ** 2 / 0.4D1 - rH1(1, zo) / omz1 / omz2 / omzo * dls ** 2 / 0
     #.2D1 - dls / omz1 / omz2 / omzo * pi ** 2 / 0.12D2 - 0.9D1 / 0.8D1
     # * dls / omz1 / omz2 / omzo * zo + 0.5D1 / 0.4D1 * dls / omz1 / om
     #z2 / omzo * rH1(0, zo) - dls / omz1 / omz2 / omzo * rH1(1, z1) / 0
     #.2D1 - 0.5D1 / 0.2D1 * rH2(0, 1, zo) * dls / omz1 / omz2 / omzo - 
     #rH1(1, zo) ** 2 * dls / omz1 / omz2 / omzo / 0.2D1 - 0.5D1 / 0.8D1
     # * dls / omz1 / omz2 / omzo / zo + pi ** 2 / omz1 / omz2 / omzo * 
     #zo / 0.16D2 - rH1(1, z1) * pi ** 2 / omz1 / omz2 / omzo / 0.12D2 -
     # rH1(1, zo) * pi ** 2 / omz1 / omz2 / omzo / 0.12D2 + pi ** 2 / om
     #z1 / omz2 / omzo / zo / 0.8D1 + 0.7D1 / 0.4D1 / omz1 / omz2 / omzo
     # * zeta3 * zo + 0.3D1 / omz1 / omz2 / omzo * zeta3 / zo - 0.1D1 / 
     #omz1 / omz2 / omzo * zo * rH1(0, zo) ** 3 / 0.16D2 + 0.5D1 / 0.32D
     #2 / omz1 / omz2 / omzo * zo * rH1(0, zo) ** 2 + 0.13D2 / 0.16D2 / 
     #omz1 / omz2 / omzo * zo * rH1(0, zo) - 0.9D1 / 0.8D1 / omz1 / omz2
     # / omzo * zo * rH1(1, z1) + 0.1D1 / omz1 / omz2 / omzo * zo * rH1(
     #1, zo) ** 3 / 0.24D2 + 0.3D1 / 0.16D2 / omz1 / omz2 / omzo * zo * 
     #rH1(1, zo) ** 2 - 0.9D1 / 0.8D1 / omz1 / omz2 / omzo * zo * rH1(1,
     # zo) - 0.3D1 / 0.2D1 * rH2(0, 1, zo) / omz1 / omz2 / omzo * zo + r
     #H2(1, 1, z1) / omz1 / omz2 / omzo * zo / 0.8D1 - rH3(0, 0, 1, zo) 
     #/ omz1 / omz2 / omzo * zo / 0.2D1 + rH3(1, 1, 0, zo) / omz1 / omz2
     # / omzo * zo / 0.2D1 - rH1(1, zo) / omz1 / omz2 / omzo * rH1(0, zo
     #) ** 2 / 0.2D1 + 0.5D1 / 0.4D1 / omz1 / omz2 / omzo * rH1(0, zo) *
     # rH1(1, z1) + rH2(0, 1, zo) / omz1 / omz2 / omzo * rH1(0, zo) / 0.
     #2D1 - rH2(1, 1, z1) / omz1 / omz2 / omzo * rH1(0, zo) / 0.2D1 + 0.
     #3D1 / 0.4D1 * rH1(1, zo) ** 2 / omz1 / omz2 / omzo * rH1(0, zo) - 
     #0.5D1 / 0.4D1 * rH1(1, zo) / omz1 / omz2 / omzo * rH1(0, zo) - 0.5
     #D1 / 0.2D1 * rH2(0, 1, zo) / omz1 / omz2 / omzo * rH1(1, z1) - rH1
     #(1, zo) ** 2 / omz1 / omz2 / omzo * rH1(1, z1) / 0.2D1 - rH1(1, zo
     #) / omz1 / omz2 / omzo * rH1(1, z1) / 0.2D1 - 0.2D1 * rH2(0, 1, zo
     #) / omz1 / omz2 / omzo * rH1(1, zo) - rH2(1, 1, z1) / omz1 / omz2 
     #/ omzo * rH1(1, zo) + rH3(0, 0, 1, zo) / omz1 / omz2 / omzo - 0.5D
     #1 / 0.8D1 / omz1 / omz2 / omzo / zo * rH1(1, z1) + 0.1D1 / omz1 / 
     #omz2 / omzo / zo * rH1(1, zo) ** 3 / 0.12D2 - 0.5D1 / 0.8D1 / omz1
     # / omz2 / omzo / zo * rH1(1, zo) - 0.3D1 / 0.4D1 * rH2(0, 1, zo) /
     # omz1 / omz2 / omzo / zo + rH3(1, 1, 0, zo) / omz1 / omz2 / omzo /
     # zo / 0.2D1 - dls * dla / omz1 / omz2 / omzo * zo / 0.8D1 + rH1(0,
     # zo) * dls * dla / omz1 / omz2 / omzo / 0.2D1 - 0.1D1 / omz1 / omz
     #2 / omzo * dla * pi ** 2 * zo / 0.24D2 - 0.1D1 / omz1 / omz2 / omz
     #o * dla * pi ** 2 / zo / 0.6D1 - 0.1D1 / omz1 / omz2 / omzo * dla 
     #* zo * rH1(1, z1) / 0.8D1 - 0.5D1 / 0.4D1 * rH2(0, 1, zo) / omz1 /
     # omz2 / omzo * dla * zo - rH1(1, zo) ** 2 / omz1 / omz2 / omzo * d
     #la * zo / 0.4D1 - rH1(1, zo) / omz1 / omz2 / omzo * dla * zo / 0.8
     #D1 + rH1(1, z1) / omz1 / omz2 / omzo * dla * rH1(0, zo) / 0.2D1 - 
     #rH1(1, zo) / omz1 / omz2 / omzo * dla * rH1(0, zo) - 0.2D1 * rH2(0
     #, 1, zo) / omz1 / omz2 / omzo * dla / zo - rH1(1, zo) ** 2 / omz1 
     #/ omz2 / omzo * dla / zo / 0.2D1 + rH1(0, zo) / omz1 / omz2 / omzo
     # * dls ** 2 * zo / 0.8D1 + rH1(1, zo) / omz1 / omz2 / omzo * dls *
     #* 2 * zo / 0.4D1 + rH1(1, zo) / omz1 / omz2 / omzo * dls ** 2 / zo
     # / 0.2D1 + dls / omz1 / omz2 / omzo * pi ** 2 * zo / 0.24D2 + dls 
     #/ omz1 / omz2 / omzo * pi ** 2 / zo / 0.6D1 + dls / omz1 / omz2 / 
     #omzo * zo * rH1(1, z1) / 0.8D1 + 0.5D1 / 0.4D1 * rH2(0, 1, zo) * d
     #ls / omz1 / omz2 / omzo * zo + rH1(1, zo) ** 2 * dls / omz1 / omz2
     # / omzo * zo / 0.4D1 + rH1(1, zo) * dls / omz1 / omz2 / omzo * zo 
     #/ 0.8D1 - rH1(1, z1) * dls / omz1 / omz2 / omzo * rH1(0, zo) / 0.2
     #D1 - rH1(1, zo) * dls / omz1 / omz2 / omzo * rH1(1, z1) + 0.2D1 * 
     #rH2(0, 1, zo) * dls / omz1 / omz2 / omzo / zo + rH1(1, zo) ** 2 * 
     #dls / omz1 / omz2 / omzo / zo / 0.2D1 + rH1(1, z1) * pi ** 2 / omz
     #1 / omz2 / omzo * zo / 0.24D2 + rH1(1, zo) * pi ** 2 / omz1 / omz2
     # / omzo * zo / 0.24D2 + rH1(1, z1) * pi ** 2 / omz1 / omz2 / omzo 
     #/ zo / 0.6D1 + rH1(1, zo) * pi ** 2 / omz1 / omz2 / omzo / zo / 0.
     #12D2 + rH1(1, zo) / omz1 / omz2 / omzo * zo * rH1(0, zo) ** 2 / 0.
     #4D1 - rH2(0, 1, zo) / omz1 / omz2 / omzo * zo * rH1(0, zo) / 0.4D1
     # + rH2(1, 1, z1) / omz1 / omz2 / omzo * zo * rH1(0, zo) / 0.4D1 - 
     #0.3D1 / 0.8D1 * rH1(1, zo) ** 2 / omz1 / omz2 / omzo * zo * rH1(0,
     # zo) + 0.5D1 / 0.4D1 * rH2(0, 1, zo) / omz1 / omz2 / omzo * zo * r
     #H1(1, z1) + rH1(1, zo) ** 2 / omz1 / omz2 / omzo * zo * rH1(1, z1)
     # / 0.4D1 + rH1(1, zo) / omz1 / omz2 / omzo * zo * rH1(1, z1) / 0.8
     #D1 + rH2(1, 1, z1) / omz1 / omz2 / omzo * zo * rH1(1, zo) / 0.2D1 
     #+ rH1(1, zo) / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 2 / 0.2D1 -
     # rH2(0, 1, zo) / omz1 / omz2 / omzo / zo * rH1(0, zo) - rH1(1, zo)
     # ** 2 / omz1 / omz2 / omzo / zo * rH1(0, zo) / 0.2D1 + 0.3D1 / 0.4
     #D1 * rH1(1, zo) / omz1 / omz2 / omzo / zo * rH1(0, zo) + 0.2D1 * r
     #H2(0, 1, zo) / omz1 / omz2 / omzo / zo * rH1(1, z1) + rH1(1, zo) *
     #* 2 / omz1 / omz2 / omzo / zo * rH1(1, z1) / 0.2D1 + 0.3D1 / 0.2D1
     # * rH2(0, 1, zo) / omz1 / omz2 / omzo / zo * rH1(1, zo) - 0.7D1 / 
     #0.2D1 / omz1 / omz2 / omzo * zeta3 - 0.27D2 / 0.16D2 / omz1 / omz2
     # / omzo * zo - 0.3D1 / omz1 / omz2 / omzo / zo + 0.1D1 / omz1 / om
     #z2 / omzo * rH1(0, zo) ** 3 / 0.8D1 - 0.1D1 / omz1 / omz2 / omzo *
     # rH1(0, zo) ** 2 / 0.2D1 - 0.21D2 / 0.16D2 / omz1 / omz2 / omzo * 
     #rH1(0, zo) + 0.9D1 / 0.8D1 / omz1 / omz2 / omzo * rH1(1, z1) - 0.1
     #D1 / omz1 / omz2 / omzo * rH1(1, zo) ** 3 / 0.12D2 - 0.1D1 / omz1 
     #/ omz2 / omzo * rH1(1, zo) ** 2 / 0.4D1 + 0.5D1 / 0.2D1 * rH2(0, 1
     #, zo) / omz1 / omz2 / omzo - rH2(1, 1, z1) / omz1 / omz2 / omzo / 
     #0.2D1 - rH3(1, 1, 0, zo) / omz1 / omz2 / omzo - dls / omz1 / omz2 
     #/ omzo * rH1(1, zo) / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo * rH1(1, 
     #zo) * dla / 0.2D1 - pi ** 2 / omz1 / omz2 / omzo / 0.3D1 - 0.1D1 /
     # omz1 / omz2 / omzo * dls ** 2 / 0.4D1 - 0.9D1 / 0.8D1 / omz1 / om
     #z2 / omzo * dla + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) - rH1(1,
     # zo) * rH1(1, z1) / omz1 / omz2 / omzo / zo * rH1(0, zo) + rH2(1, 
     #1, z1) / omz1 / omz2 / omzo / zo * rH1(1, zo) - rH1(1, zo) * rH1(1
     #, z1) / omz1 / omz2 / omzo * zo * rH1(0, zo) / 0.2D1 + rH1(1, zo) 
     #/ omz1 / omz2 / omzo * zo * rH1(0, zo) + rH2(0, 1, zo) / omz1 / om
     #z2 / omzo * zo * rH1(1, zo) + rH1(1, zo) / omz1 / omz2 / omzo * rH
     #1(0, zo) * rH1(1, z1) - rH1(1, zo) * dls / omz1 / omz2 / omzo * zo
     # * rH1(0, zo) / 0.2D1 + rH1(1, zo) * dls / omz1 / omz2 / omzo * zo
     # * rH1(1, z1) / 0.2D1 + rH1(1, zo) * dls / omz1 / omz2 / omzo * rH
     #1(0, zo) - rH1(1, zo) * rH1(0, zo) * dls / omz1 / omz2 / omzo / zo
     # + rH1(1, z1) * dls / omz1 / omz2 / omzo * zo * rH1(0, zo) / 0.4D1
     # + rH1(1, zo) / omz1 / omz2 / omzo * dla * rH1(1, z1) - rH1(1, zo)
     # * rH1(1, z1) / omz1 / omz2 / omzo * dla / zo + 0.9D1 / 0.8D1 * dl
     #s / omz1 / omz2 / omzo - rH1(0, zo) * dls * dla / omz1 / omz2 / om
     #zo * zo / 0.4D1 - rH1(1, zo) * dls * dla / omz1 / omz2 / omzo * zo
     # / 0.2D1 + rH1(1, zo) * dls * dla / omz1 / omz2 / omzo - rH1(1, zo
     #) * dls * dla / omz1 / omz2 / omzo / zo - rH1(1, z1) / omz1 / omz2
     # / omzo * dla * zo * rH1(0, zo) / 0.4D1 + rH1(1, zo) / omz1 / omz2
     # / omzo * dla * zo * rH1(0, zo) / 0.2D1 - rH1(1, zo) / omz1 / omz2
     # / omzo * dla * zo * rH1(1, z1) / 0.2D1 + rH1(1, zo) * d0x1 * dls 
     #/ omz2 / omzo / zo + 0.35D2 / 0.8D1 / omz1 / omz2 / omzo
      endif
      if(ix.eq.3.and.iz_frag.eq.1)then
      e2 = 0
      e1 = 0
      if(region1) then
      e0 = -0.5D1 / 0.4D1 * d0x1 / omz2 / omzo * rH1(0, zo) + (0.9D1 *
     # zo ** 2 - 0.9D1 * zo + 0.5D1) / zo * d0x1 / omz2 / omzo / 0.8D1 +
     # (0.1D1 / 0.2D1 - zo / 0.8D1) * rH1(1, zo) * d0x1 / omz2 / omzo + 
     #(-0.1D1 / 0.2D1 + zo / 0.8D1) * d1x1 / omz2 / omzo + (-0.1D1 / 0.2
     #D1 + zo / 0.4D1) * rH1(0, zo) * d1x1 / omz2 / omzo + (x1 * zo / 0.
     #8D1 + x1 / 0.4D1 - 0.3D1 / 0.8D1 * zo) * dla / omz2 / omzo + (-0.1
     #D1 / 0.2D1 + zo / 0.8D1) * d0x1 * dla / omz2 / omzo + (-0.1D1 / 0.
     #2D1 + zo / 0.4D1) * rH1(0, zo) * d0x1 * dla / omz2 / omzo + rH1(0,
     # zo) * dla / omz2 / omzo / 0.2D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) 
     #/ omx1 / zo / omz2 / omzo * rH2(0, 1, x1 / omx1 * zo / (0.1D1 - zo
     #)) / 0.2D1 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d0
     #x1 * dla / omz2 / omzo / 0.2D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) / 
     #zo * rH1(1, zo) * d0x1 * dls / omz2 / omzo / 0.2D1 - (zo ** 3 + (x
     #1 - 0.3D1) * zo ** 2 + (-0.2D1 * x1 + 0.6D1) * zo + 0.4D1 * x1 - 0
     #.4D1) / zo / (-0.1D1 + x1 + zo) * d0x1 / omz2 / omzo * pi ** 2 / 0
     #.24D2 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d0x1 / 
     #omz2 / omzo * rH1(0, zo) / 0.2D1 + rH1(0, zo) / omx1 / omz2 / omzo
     # * rln2 * zo + 0.1D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo
     # + 0.1D1) / omx1 / omz2 / omzo * rln2 * zo + rH1(0, x1) / omx1 / o
     #mz2 / omzo * rln2 * zo + (zo - 0.3D1) / zo * rH1(0, 0.1D1 - zo + S
     #qrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2
     # / omzo * Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (
     #0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(0, 0.1D1 - x1 - z
     #o) / omx1 / omz2 / omzo * rH1(0, x1) / 0.2D1 - (zo ** 2 - 0.2D1 * 
     #zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo *
     #* 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rH1(0, x1) - (zo
     # - 0.1D1) ** 2 / zo * rH1(0, x1 - zo) / omx1 / omz2 / omzo * rH1(0
     #, x1) - (zo - 0.1D1) ** 2 / zo * rH1(1, x1) / omx1 / omz2 / omzo *
     # rH1(0, x1) - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) / o
     #mx1 / omz2 / omzo * rH1(0, x1) / 0.2D1 + (zo + 0.1D1) * (zo - 0.3D
     #1) / zo / omx1 / omz2 / omzo * rH1(0, zo) / 0.2D1 - (zo ** 2 - 0.2
     #D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo +
     # zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rH1(0, zo) 
     #+ (zo - 0.1D1) ** 2 / zo * rH1(0, x1 - zo) / omx1 / omz2 / omzo * 
     #rH1(0, zo) - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(1, 
     #zo) / omx1 / omz2 / omzo * rH1(0, 0.1D1 - x1 - zo) / 0.2D1 - (0.3D
     #1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(1, zo) / omx1 / omz2 
     #/ omzo * rH1(1, x1) / 0.2D1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * d0x1 
     #* dls / omz2 / omzo + (0.1D1 / 0.2D1 - zo / 0.4D1) * rH1(0, zo) * 
     #d0x1 * dls / omz2 / omzo - (0.5D1 * zo ** 2 - 0.10D2 * zo + 0.8D1)
     # / zo * rH2(0, 1, zo) * d0x1 / omz2 / omzo / 0.4D1 - (zo ** 2 - 0.
     #2D1 * zo + 0.2D1) / zo * rH1(1, zo) ** 2 * d0x1 / omz2 / omzo / 0.
     #4D1 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d1x1 / om
     #z2 / omzo / 0.2D1 - (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) * 
     #dla / omz2 / omzo / 0.2D1 + (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(1
     #, zo) * dls / omz2 / omzo / 0.2D1 + (0.3D1 / 0.8D1 * zo - x1 / 0.4
     #D1 - x1 * zo / 0.8D1) * dls / omz2 / omzo + (x1 - 0.2D1 * zo + 0.1
     #D1) / zo / omz2 / omzo * rH2(0, 1, 0.1D1 / omx1 * zo) / 0.2D1 - 0.
     #2D1 * (0.1D1 + x1) / zo / omz2 / omzo * rH2(0, 0, 0.1D1 - zo + Sqr
     #t(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) - (x1 - 0.2D1 *
     # zo + 0.1D1) / zo / omz2 / omzo * rH2(0, 1, 0.1D1 / x1 * (x1 - zo)
     #) / 0.2D1 - (x1 - 0.2D1 * zo + 0.1D1) / zo / omz2 / omzo * rH2(0, 
     #1, omx1 / (0.1D1 - zo)) / 0.2D1 - (x1 - 0.2D1 * zo + 0.1D1) / zo /
     # omz2 / omzo * rH2(0, 1, 0.1D1 / x1 / omx1 * zo * (0.1D1 - zo)) / 
     #0.2D1 - (x1 * zo ** 2 - 0.2D1 * x1 * zo + zo ** 2 + 0.2D1 * x1 + 0
     #.2D1) / zo / omz2 / omzo * rH2(0, 1, zo) / 0.4D1 + (0.2D1 * x1 - 0
     #.3D1 * zo + 0.2D1) / zo / omz2 / omzo * pi ** 2 / 0.12D2 + (-0.1D1
     # - x1) / zo / omz2 / omzo * rln2 ** 2 + 0.2D1 / Sqrt(0.4D1 * x1 * 
     #zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omz2 / omzo * rln2 * zo + (-0
     #.8D1 * x1 - 0.8D1) / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo +
     # 0.1D1) / omz2 / omzo * rln2 - 0.2D1 / Sqrt(0.4D1 * x1 * zo + zo *
     #* 2 - 0.2D1 * zo + 0.1D1) / omz2 / omzo * rln2 / zo + 0.2D1 / zo *
     # rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo +
     # 0.1D1)) / omz2 / omzo * Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * 
     #zo + 0.1D1) - (x1 * zo ** 2 - 0.2D1 * x1 * zo + zo ** 2 + 0.9D1 * 
     #x1 - 0.12D2 * zo + 0.9D1) / zo / omz2 / omzo * rH1(0, x1) ** 2 / 0
     #.8D1 + (-0.1D1 / 0.2D1 - x1 * zo / 0.4D1 + x1 / 0.2D1 - zo / 0.4D1
     #) * rH1(1, x1) / omz2 / omzo * rH1(0, x1) + (0.1D1 / 0.2D1 + x1 * 
     #zo / 0.8D1 - x1 / 0.4D1 + zo / 0.8D1) / omz2 / omzo * rH1(0, zo) *
     #* 2 + (x1 * zo ** 2 + 0.2D1 * x1 * zo - 0.3D1 * zo ** 2 + 0.10D2 *
     # zo + 0.8D1) / zo / omz2 / omzo * rH1(0, zo) / 0.8D1 + (0.1D1 / 0.
     #2D1 + zo / 0.4D1 - x1 / 0.2D1 + x1 * zo / 0.4D1) * rH1(1, zo) / om
     #z2 / omzo * rH1(0, zo) + (0.1D1 / 0.2D1 - 0.3D1 / 0.8D1 * x1 * zo 
     #+ x1 / 0.4D1 - 0.3D1 / 0.8D1 * zo) / omz2 / omzo * rH1(1, x1) - (0
     #.3D1 * x1 ** 2 * zo ** 2 + 0.3D1 * x1 * zo ** 3 - 0.2D1 * x1 ** 2 
     #* zo - 0.14D2 * x1 * zo ** 2 - 0.9D1 * zo ** 3 + 0.10D2 * x1 ** 2 
     #+ 0.10D2 * x1 * zo - zo ** 2 - 0.14D2 * x1 + 0.6D1 * zo + 0.4D1) /
     # zo / (-0.1D1 + x1 + zo) / omz2 / omzo / 0.8D1 - (x1 ** 3 * zo + 0
     #.2D1 * x1 ** 2 * zo ** 2 + x1 * zo ** 3 + 0.2D1 * x1 ** 3 - x1 ** 
     #2 * zo - 0.6D1 * x1 * zo ** 2 - 0.3D1 * zo ** 3 - 0.4D1 * x1 ** 2 
     #+ 0.19D2 * x1 * zo + 0.14D2 * zo ** 2 - 0.14D2 * x1 - 0.19D2 * zo 
     #+ 0.8D1) / (-0.1D1 + x1 + zo) ** 2 * rH1(1, zo) / omz2 / omzo / 0.
     #8D1 + 0.1D1 / omx1 / omz2 / omzo * rln2 ** 2 * zo + 0.2D1 / omx1 /
     # omz2 / omzo * rln2 ** 2 / zo - 0.2D1 * rH1(0, zo) / omx1 / omz2 /
     # omzo * rln2 + 0.5D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo
     # + 0.1D1) / omx1 / omz2 / omzo * rln2 + 0.4D1 * rH1(0, 0.1D1 - zo 
     #+ Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / o
     #mz2 / omzo * rln2 - 0.2D1 * rH1(0, x1) / omx1 / omz2 / omzo * rln2
     # - rH1(0, zo) * dls / omz2 / omzo / 0.2D1 - rH1(0, zo) / omz2 / om
     #zo * rH1(0, x1) - rH1(1, x1) / omz2 / omzo * rH1(0, zo) / 0.2D1 + 
     #(0.1D1 / 0.2D1 + zo / 0.4D1 - x1 / 0.2D1 + x1 * zo / 0.4D1) * rH2(
     #0, 1, x1) / omz2 / omzo + (x1 - 0.2D1 * zo + 0.1D1) / zo / omz2 / 
     #omzo * rH1(1, zo) * rH1(0, 0.1D1 - x1 - zo) / 0.2D1 + (-0.1D1 - x1
     #) * rH1(0, zo) / omz2 / omzo * rln2 / zo + (0.2D1 + 0.2D1 * x1) * 
     #rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 
     #0.1D1)) / omz2 / omzo * rln2 / zo + (-0.1D1 - x1) * rH1(0, x1) / o
     #mz2 / omzo * rln2 / zo - (0.3D1 * x1 ** 3 * zo ** 2 + 0.6D1 * x1 *
     #* 2 * zo ** 3 + 0.3D1 * x1 * zo ** 4 + 0.2D1 * x1 ** 3 * zo - x1 *
     #* 2 * zo ** 2 - 0.2D1 * x1 * zo ** 3 + zo ** 4 - 0.2D1 * x1 ** 3 -
     # 0.8D1 * x1 ** 2 * zo + 0.11D2 * x1 * zo ** 2 + 0.6D1 * zo ** 3 - 
     #0.2D1 * x1 ** 2 - 0.22D2 * x1 * zo - 0.21D2 * zo ** 2 + 0.10D2 * x
     #1 + 0.20D2 * zo - 0.6D1) / zo / (-0.1D1 + x1 + zo) ** 2 / omz2 / o
     #mzo * rH1(0, x1) / 0.8D1 + (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(0,
     # 0.1D1 - x1 - zo) / omz2 / omzo * rH1(0, x1) / 0.2D1 + (0.1D1 + x1
     #) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D
     #1 * zo + 0.1D1)) / omz2 / omzo * rH1(0, x1) + (x1 - 0.2D1 * zo + 0
     #.1D1) / zo * rH1(0, x1 - zo) / omz2 / omzo * rH1(0, x1) / 0.2D1 + 
     #(0.1D1 + x1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo 
     #** 2 - 0.2D1 * zo + 0.1D1)) / omz2 / omzo * rH1(0, zo) - (x1 - 0.2
     #D1 * zo + 0.1D1) / zo * rH1(0, x1 - zo) / omz2 / omzo * rH1(0, zo)
     # / 0.2D1 + (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) / omz2 / om
     #zo * rH1(1, x1) / 0.2D1 - (0.4D1 * x1 * zo - zo ** 2 + 0.4D1 * zo 
     #+ 0.1D1) / zo * rH1(0, zo) / omz2 / omzo / Sqrt(0.4D1 * x1 * zo + 
     #zo ** 2 - 0.2D1 * zo + 0.1D1) - (0.4D1 * x1 * zo - zo ** 2 + 0.4D1
     # * zo + 0.1D1) / zo * rH1(0, x1) / omz2 / omzo / Sqrt(0.4D1 * x1 *
     # zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (zo - 0.1D1) ** 2 / zo / omx
     #1 / omz2 / omzo * pi ** 2 / 0.6D1 - 0.1D1 / Sqrt(0.4D1 * x1 * zo +
     # zo ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2 * zo **
     # 2 - 0.2D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 
     #0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rln2 * zo + 0.2D1 * rH
     #1(0, zo) / omx1 / omz2 / omzo * rln2 / zo + 0.3D1 / Sqrt(0.4D1 * x
     #1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2
     # / zo - 0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2
     # - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rln2 / zo + 0.2D1 *
     # rH1(0, x1) / omx1 / omz2 / omzo * rln2 / zo + (0.3D1 * zo ** 2 - 
     #0.6D1 * zo + 0.4D1) / zo / omx1 / omz2 / omzo * rH1(0, x1) ** 2 / 
     #0.2D1 - (0.3D1 * zo ** 2 - 0.10D2 * zo + 0.6D1) / zo / omx1 / omz2
     # / omzo * rH1(0, x1) / 0.8D1 + (0.1D1 - zo / 0.2D1) * rH1(0, zo) /
     # omx1 / omz2 / omzo * rH1(0, x1) + (zo - 0.1D1) ** 2 / zo * rH2(0,
     # 1, zo) / omx1 / omz2 / omzo + 0.2D1 * (zo ** 2 - 0.2D1 * zo + 0.2
     #D1) / zo * rH2(0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 -
     # 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo + (zo - 0.1D1) ** 2 / z
     #o * rH2(0, 1, 0.1D1 / x1 * (x1 - zo)) / omx1 / omz2 / omzo + (zo -
     # 0.1D1) ** 2 / zo * rH2(0, 1, omx1 / (0.1D1 - zo)) / omx1 / omz2 /
     # omzo + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / x1 / omx1 * zo 
     #* (0.1D1 - zo)) / omx1 / omz2 / omzo - (zo - 0.3D1) * (zo + 0.1D1)
     # ** 2 / zo * rH1(0, zo) / omx1 / omz2 / omzo / Sqrt(0.4D1 * x1 * z
     #o + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (zo - 0.3D1) * (zo + 0
     #.1D1) ** 2 / zo * rH1(0, x1) / omx1 / omz2 / omzo / Sqrt(0.4D1 * x
     #1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - 0.2D1 / omx1 / om
     #z2 / omzo * rln2 ** 2 + (-0.1D1 / 0.2D1 + zo / 0.4D1) * rH1(1, zo)
     # ** 2 / omx1 / omz2 / omzo + (0.1D1 - zo / 0.2D1) * rH2(0, 1, 0.1D
     #1 / omx1 * zo) / omx1 / omz2 / omzo
      elseif(region2) then
      e0 = -0.5D1 / 0.4D1 * d0x1 / omz2 / omzo * rH1(0, zo) + (0.9D1 *
     # zo ** 2 - 0.9D1 * zo + 0.5D1) / zo * d0x1 / omz2 / omzo / 0.8D1 +
     # (0.1D1 / 0.2D1 - zo / 0.8D1) * rH1(1, zo) * d0x1 / omz2 / omzo + 
     #(-0.1D1 / 0.2D1 + zo / 0.8D1) * d1x1 / omz2 / omzo + (-0.1D1 / 0.2
     #D1 + zo / 0.4D1) * rH1(0, zo) * d1x1 / omz2 / omzo + (x1 * zo / 0.
     #8D1 + x1 / 0.4D1 - 0.3D1 / 0.8D1 * zo) * dla / omz2 / omzo + (-0.1
     #D1 / 0.2D1 + zo / 0.8D1) * d0x1 * dla / omz2 / omzo + (-0.1D1 / 0.
     #2D1 + zo / 0.4D1) * rH1(0, zo) * d0x1 * dla / omz2 / omzo + rH1(0,
     # zo) * dla / omz2 / omzo / 0.2D1 + (zo ** 2 - 0.2D1 * zo + 0.2D1) 
     #/ zo * rH1(1, zo) * d0x1 * dla / omz2 / omzo / 0.2D1 - (zo ** 2 - 
     #0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d0x1 * dls / omz2 / omzo /
     # 0.2D1 - (zo ** 3 + (x1 - 0.3D1) * zo ** 2 + (-0.2D1 * x1 + 0.6D1)
     # * zo + 0.4D1 * x1 - 0.4D1) / zo / (-0.1D1 + x1 + zo) * d0x1 / omz
     #2 / omzo * pi ** 2 / 0.24D2 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo 
     #* rH1(1, zo) * d0x1 / omz2 / omzo * rH1(0, zo) / 0.2D1 + rH1(0, zo
     #) / omx1 / omz2 / omzo * rln2 * zo + 0.1D1 / Sqrt(0.4D1 * x1 * zo 
     #+ zo ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2 * zo +
     # rH1(0, x1) / omx1 / omz2 / omzo * rln2 * zo + (zo - 0.3D1) / zo *
     # rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo +
     # 0.1D1)) / omx1 / omz2 / omzo * Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0
     #.2D1 * zo + 0.1D1) - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(0, 
     #0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1))
     # / omx1 / omz2 / omzo * rH1(0, x1) - (zo - 0.1D1) ** 2 / zo * rH1(
     #0, x1 - zo) / omx1 / omz2 / omzo * rH1(0, x1) + (zo + 0.1D1) * (zo
     # - 0.3D1) / zo / omx1 / omz2 / omzo * rH1(0, zo) / 0.2D1 - (zo ** 
     #2 - 0.2D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1
     # * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rH1(
     #0, zo) + (zo - 0.1D1) ** 2 / zo * rH1(0, x1 - zo) / omx1 / omz2 / 
     #omzo * rH1(0, zo) + (zo ** 2 - 0.2D1 * zo + 0.2D1) / omx1 / zo / o
     #mz2 / omzo * rH2(0, 1, 0.1D1 / x1 * omx1 / zo * (0.1D1 - zo)) / 0.
     #2D1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * d0x1 * dls / omz2 / omzo + (0
     #.1D1 / 0.2D1 - zo / 0.4D1) * rH1(0, zo) * d0x1 * dls / omz2 / omzo
     # - (0.5D1 * zo ** 2 - 0.10D2 * zo + 0.8D1) / zo * rH2(0, 1, zo) * 
     #d0x1 / omz2 / omzo / 0.4D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo *
     # rH1(1, zo) ** 2 * d0x1 / omz2 / omzo / 0.4D1 + (zo ** 2 - 0.2D1 *
     # zo + 0.2D1) / zo * rH1(1, zo) * d1x1 / omz2 / omzo / 0.2D1 - (x1 
     #- 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) * dla / omz2 / omzo / 0.2D
     #1 + (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) * dls / omz2 / omz
     #o / 0.2D1 + (0.3D1 / 0.8D1 * zo - x1 / 0.4D1 - x1 * zo / 0.8D1) * 
     #dls / omz2 / omzo - 0.2D1 * (0.1D1 + x1) / zo / omz2 / omzo * rH2(
     #0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0
     #.1D1)) - (x1 - 0.2D1 * zo + 0.1D1) / zo / omz2 / omzo * rH2(0, 1, 
     #0.1D1 / x1 * (x1 - zo)) / 0.2D1 - (x1 - 0.2D1 * zo + 0.1D1) / zo /
     # omz2 / omzo * rH2(0, 1, omx1 / (0.1D1 - zo)) / 0.2D1 - (x1 * zo *
     #* 2 - 0.2D1 * x1 * zo + zo ** 2 + 0.2D1 * x1 + 0.2D1) / zo / omz2 
     #/ omzo * rH2(0, 1, zo) / 0.4D1 + (0.2D1 * x1 - 0.3D1 * zo + 0.2D1)
     # / zo / omz2 / omzo * pi ** 2 / 0.12D2 + (-0.1D1 - x1) / zo / omz2
     # / omzo * rln2 ** 2 + 0.2D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2
     #D1 * zo + 0.1D1) / omz2 / omzo * rln2 * zo + (-0.8D1 * x1 - 0.8D1)
     # / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omz2 / o
     #mzo * rln2 - 0.2D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo +
     # 0.1D1) / omz2 / omzo * rln2 / zo + 0.2D1 / zo * rH1(0, 0.1D1 - zo
     # + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omz2 / 
     #omzo * Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) + (0.1
     #D1 / 0.2D1 + x1 * zo / 0.8D1 - x1 / 0.4D1 + zo / 0.8D1) / omz2 / o
     #mzo * rH1(0, zo) ** 2 + (x1 * zo ** 2 + 0.2D1 * x1 * zo - 0.3D1 * 
     #zo ** 2 + 0.10D2 * zo + 0.8D1) / zo / omz2 / omzo * rH1(0, zo) / 0
     #.8D1 + (0.1D1 / 0.2D1 - 0.3D1 / 0.8D1 * x1 * zo + x1 / 0.4D1 - 0.3
     #D1 / 0.8D1 * zo) / omz2 / omzo * rH1(1, x1) - (0.3D1 * x1 ** 2 * z
     #o ** 2 + 0.3D1 * x1 * zo ** 3 - 0.2D1 * x1 ** 2 * zo - 0.14D2 * x1
     # * zo ** 2 - 0.9D1 * zo ** 3 + 0.10D2 * x1 ** 2 + 0.10D2 * x1 * zo
     # - zo ** 2 - 0.14D2 * x1 + 0.6D1 * zo + 0.4D1) / zo / (-0.1D1 + x1
     # + zo) / omz2 / omzo / 0.8D1 - (x1 ** 3 * zo + 0.2D1 * x1 ** 2 * z
     #o ** 2 + x1 * zo ** 3 + 0.2D1 * x1 ** 3 - x1 ** 2 * zo - 0.6D1 * x
     #1 * zo ** 2 - 0.3D1 * zo ** 3 - 0.4D1 * x1 ** 2 + 0.19D2 * x1 * zo
     # + 0.14D2 * zo ** 2 - 0.14D2 * x1 - 0.19D2 * zo + 0.8D1) / (-0.1D1
     # + x1 + zo) ** 2 * rH1(1, zo) / omz2 / omzo / 0.8D1 + 0.1D1 / omx1
     # / omz2 / omzo * rln2 ** 2 * zo + 0.2D1 / omx1 / omz2 / omzo * rln
     #2 ** 2 / zo - 0.2D1 * rH1(0, zo) / omx1 / omz2 / omzo * rln2 + 0.5
     #D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx1 /
     # omz2 / omzo * rln2 + 0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 
     #* zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rln2 
     #- 0.2D1 * rH1(0, x1) / omx1 / omz2 / omzo * rln2 - rH1(0, zo) * dl
     #s / omz2 / omzo / 0.2D1 - rH1(1, x1) / omz2 / omzo * rH1(0, zo) / 
     #0.2D1 + (0.1D1 / 0.2D1 + zo / 0.4D1 - x1 / 0.2D1 + x1 * zo / 0.4D1
     #) * rH2(0, 1, x1) / omz2 / omzo + (-0.1D1 - x1) * rH1(0, zo) / omz
     #2 / omzo * rln2 / zo + (0.2D1 + 0.2D1 * x1) * rH1(0, 0.1D1 - zo + 
     #Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omz2 / omz
     #o * rln2 / zo + (-0.1D1 - x1) * rH1(0, x1) / omz2 / omzo * rln2 / 
     #zo - (0.3D1 * x1 ** 3 * zo ** 2 + 0.6D1 * x1 ** 2 * zo ** 3 + 0.3D
     #1 * x1 * zo ** 4 + 0.2D1 * x1 ** 3 * zo - x1 ** 2 * zo ** 2 - 0.2D
     #1 * x1 * zo ** 3 + zo ** 4 - 0.2D1 * x1 ** 3 - 0.8D1 * x1 ** 2 * z
     #o + 0.11D2 * x1 * zo ** 2 + 0.6D1 * zo ** 3 - 0.2D1 * x1 ** 2 - 0.
     #22D2 * x1 * zo - 0.21D2 * zo ** 2 + 0.10D2 * x1 + 0.20D2 * zo - 0.
     #6D1) / zo / (-0.1D1 + x1 + zo) ** 2 / omz2 / omzo * rH1(0, x1) / 0
     #.8D1 + (0.1D1 + x1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * z
     #o + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omz2 / omzo * rH1(0, x1) + (x
     #1 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, x1 - zo) / omz2 / omzo * rH1
     #(0, x1) / 0.2D1 + (0.1D1 + x1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4
     #D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omz2 / omzo * rH1(
     #0, zo) - (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, x1 - zo) / omz2 /
     # omzo * rH1(0, zo) / 0.2D1 - (0.4D1 * x1 * zo - zo ** 2 + 0.4D1 * 
     #zo + 0.1D1) / zo * rH1(0, zo) / omz2 / omzo / Sqrt(0.4D1 * x1 * zo
     # + zo ** 2 - 0.2D1 * zo + 0.1D1) - (0.4D1 * x1 * zo - zo ** 2 + 0.
     #4D1 * zo + 0.1D1) / zo * rH1(0, x1) / omz2 / omzo / Sqrt(0.4D1 * x
     #1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (zo - 0.1D1) ** 2 / zo / 
     #omx1 / omz2 / omzo * pi ** 2 / 0.6D1 - 0.1D1 / Sqrt(0.4D1 * x1 * z
     #o + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2 * zo
     # ** 2 - 0.2D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2
     # - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rln2 * zo + 0.2D1 *
     # rH1(0, zo) / omx1 / omz2 / omzo * rln2 / zo + 0.3D1 / Sqrt(0.4D1 
     #* x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * r
     #ln2 / zo - 0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo *
     #* 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rln2 / zo + 0.2D
     #1 * rH1(0, x1) / omx1 / omz2 / omzo * rln2 / zo - (0.3D1 * zo ** 2
     # - 0.10D2 * zo + 0.6D1) / zo / omx1 / omz2 / omzo * rH1(0, x1) / 0
     #.8D1 + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, zo) / omx1 / omz2 / omzo
     # + 0.2D1 * (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH2(0, 0, 0.1D1 -
     # zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1
     # / omz2 / omzo + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / x1 * (
     #x1 - zo)) / omx1 / omz2 / omzo + (zo - 0.1D1) ** 2 / zo * rH2(0, 1
     #, omx1 / (0.1D1 - zo)) / omx1 / omz2 / omzo - (zo - 0.3D1) * (zo +
     # 0.1D1) ** 2 / zo * rH1(0, zo) / omx1 / omz2 / omzo / Sqrt(0.4D1 *
     # x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (zo - 0.3D1) * 
     #(zo + 0.1D1) ** 2 / zo * rH1(0, x1) / omx1 / omz2 / omzo / Sqrt(0.
     #4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - 0.2D1 / om
     #x1 / omz2 / omzo * rln2 ** 2 - (x1 - 0.2D1 * zo + 0.1D1) / zo / om
     #z2 / omzo * rH2(0, 1, omx1 / zo) / 0.2D1 + (x1 - 0.2D1 * zo + 0.1D
     #1) / zo / omz2 / omzo * rH2(0, 1, x1 * omx1 / zo / (0.1D1 - zo)) /
     # 0.2D1 + (0.5D1 * zo ** 2 - 0.10D2 * zo + 0.8D1) / zo / omx1 / omz
     #2 / omzo * rH1(0, x1) ** 2 / 0.4D1 - (zo - 0.1D1) ** 2 / zo * rH2(
     #0, 1, x1 * omx1 / zo / (0.1D1 - zo)) / omx1 / omz2 / omzo + (x1 - 
     #0.2D1 * zo + 0.1D1) / zo / omz2 / omzo * rH1(1, zo) * rH1(0, -0.1D
     #1 + x1 + zo) / 0.2D1 + (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo)
     # ** 2 / omzo / omz2 / 0.4D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) * (0.
     #1D1 + x1) / zo * rH1(1, x1) / omzo / omz2 * rH1(0, x1) / 0.4D1 - (
     #zo - 0.1D1) ** 2 / zo * rH1(1, zo) / omx1 / omz2 / omzo * rH1(0, x
     #1) - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(0, -0.1D1 +
     # x1 + zo) / omx1 / omz2 / omzo * rH1(0, x1) / 0.2D1 + (zo ** 2 - 0
     #.2D1 * zo + 0.2D1) / zo * rH1(0, zo) / omx1 / omz2 / omzo * rH1(0,
     # x1) + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, x1) / omx1 / o
     #mz2 / omzo * rH1(0, x1) / 0.2D1 + (0.3D1 * zo ** 2 - 0.6D1 * zo + 
     #0.4D1) / zo * rH1(1, zo) / omx1 / omz2 / omzo * rH1(0, zo) / 0.2D1
     # - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(1, zo) / omx1
     # / omz2 / omzo * rH1(0, -0.1D1 + x1 + zo) / 0.2D1 + (x1 - 0.2D1 * 
     #zo + 0.1D1) / zo * rH1(1, zo) / omzo / omz2 * rH1(0, x1) / 0.2D1 +
     # (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, -0.1D1 + x1 + zo) / omzo 
     #/ omz2 * rH1(0, x1) / 0.2D1 - (0.1D1 + x1) / zo * rH1(0, zo) / omz
     #o / omz2 * rH1(0, x1) / 0.2D1 + (zo / 0.2D1 - 0.1D1) * rH2(0, 1, o
     #mx1 / zo) / omx1 / omz2 / omzo - (x1 * zo ** 2 - 0.2D1 * x1 * zo +
     # zo ** 2 + 0.7D1 * x1 - 0.8D1 * zo + 0.7D1) / zo / omzo / omz2 * r
     #H1(0, x1) ** 2 / 0.8D1 + (x1 * zo ** 2 - 0.2D1 * x1 * zo + zo ** 2
     # - 0.2D1 * x1 + 0.6D1 * zo - 0.2D1) / zo * rH1(1, zo) / omzo / omz
     #2 * rH1(0, zo) / 0.4D1
      elseif(region3) then
      e0 = -0.5D1 / 0.4D1 * d0x1 / omz2 / omzo * rH1(0, zo) + (x1 - 0.
     #2D1 * zo + 0.1D1) / zo * rH1(0, -x1 + zo) / omzo / omz2 * rH1(0, x
     #1) / 0.2D1 - (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, -x1 + zo) / o
     #mzo / omz2 * rH1(0, zo) / 0.2D1 + (x1 - 0.3D1 * zo + 0.1D1) / zo *
     # rH1(1, x1) / omzo / omz2 * rH1(0, zo) / 0.2D1 + (0.2D1 * zo ** 2 
     #- 0.4D1 * zo + 0.3D1) / zo / omx1 / omz2 / omzo * rH1(0, x1) ** 2 
     #/ 0.2D1 - (zo - 0.1D1) ** 2 / zo / omx1 / omz2 / omzo * rH1(0, zo)
     # ** 2 / 0.2D1 - (zo - 0.1D1) ** 2 / zo / omx1 / omz2 / omzo * rH1(
     #1, x1) ** 2 + (zo / 0.2D1 - 0.1D1) * rH1(1, zo) / omx1 / omz2 / om
     #zo * rH1(1, x1) - (zo - 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / omx1 
     #* (0.1D1 - zo)) / omx1 / omz2 / omzo - (0.3D1 * zo ** 2 - 0.6D1 * 
     #zo + 0.4D1) / zo * rH1(1, zo) ** 2 / omx1 / omz2 / omzo / 0.4D1 + 
     #(0.9D1 * zo ** 2 - 0.9D1 * zo + 0.5D1) / zo * d0x1 / omz2 / omzo /
     # 0.8D1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * rH1(1, zo) * d0x1 / omz2 /
     # omzo + (-0.1D1 / 0.2D1 + zo / 0.8D1) * d1x1 / omz2 / omzo + (-0.1
     #D1 / 0.2D1 + zo / 0.4D1) * rH1(0, zo) * d1x1 / omz2 / omzo + (x1 *
     # zo / 0.8D1 + x1 / 0.4D1 - 0.3D1 / 0.8D1 * zo) * dla / omz2 / omzo
     # + (-0.1D1 / 0.2D1 + zo / 0.8D1) * d0x1 * dla / omz2 / omzo + (-0.
     #1D1 / 0.2D1 + zo / 0.4D1) * rH1(0, zo) * d0x1 * dla / omz2 / omzo 
     #+ rH1(0, zo) * dla / omz2 / omzo / 0.2D1 - (zo ** 2 - 0.2D1 * zo +
     # 0.2D1) / omx1 / zo / omz2 / omzo * rH2(0, 1, x1 / omx1 * zo / (0.
     #1D1 - zo)) / 0.2D1 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, 
     #zo) * d0x1 * dla / omz2 / omzo / 0.2D1 - (zo ** 2 - 0.2D1 * zo + 0
     #.2D1) / zo * rH1(1, zo) * d0x1 * dls / omz2 / omzo / 0.2D1 - (zo *
     #* 3 + (x1 - 0.3D1) * zo ** 2 + (-0.2D1 * x1 + 0.6D1) * zo + 0.4D1 
     #* x1 - 0.4D1) / zo / (-0.1D1 + x1 + zo) * d0x1 / omz2 / omzo * pi 
     #** 2 / 0.24D2 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) *
     # d0x1 / omz2 / omzo * rH1(0, zo) / 0.2D1 + rH1(0, zo) / omx1 / omz
     #2 / omzo * rln2 * zo + 0.1D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.
     #2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2 * zo + rH1(0, x1) / 
     #omx1 / omz2 / omzo * rln2 * zo + (zo - 0.3D1) / zo * rH1(0, 0.1D1 
     #- zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx
     #1 / omz2 / omzo * Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.
     #1D1) - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo * rH1(0, 0.1D1 
     #- x1 - zo) / omx1 / omz2 / omzo * rH1(0, x1) / 0.2D1 - (zo ** 2 - 
     #0.2D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * z
     #o + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rH1(0, x
     #1) + (zo + 0.1D1) * (zo - 0.3D1) / zo / omx1 / omz2 / omzo * rH1(0
     #, zo) / 0.2D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(0, 0.1D1
     # - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / om
     #x1 / omz2 / omzo * rH1(0, zo) - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.
     #4D1) / zo * rH1(1, zo) / omx1 / omz2 / omzo * rH1(0, 0.1D1 - x1 - 
     #zo) / 0.2D1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * d0x1 * dls / omz2 / o
     #mzo + (0.1D1 / 0.2D1 - zo / 0.4D1) * rH1(0, zo) * d0x1 * dls / omz
     #2 / omzo - (0.5D1 * zo ** 2 - 0.10D2 * zo + 0.8D1) / zo * rH2(0, 1
     #, zo) * d0x1 / omz2 / omzo / 0.4D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1
     #) / zo * rH1(1, zo) ** 2 * d0x1 / omz2 / omzo / 0.4D1 + (zo ** 2 -
     # 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d1x1 / omz2 / omzo / 0.2D
     #1 - (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) * dla / omz2 / omz
     #o / 0.2D1 + (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) * dls / om
     #z2 / omzo / 0.2D1 + (0.3D1 / 0.8D1 * zo - x1 / 0.4D1 - x1 * zo / 0
     #.8D1) * dls / omz2 / omzo + (x1 - 0.2D1 * zo + 0.1D1) / zo / omz2 
     #/ omzo * rH2(0, 1, 0.1D1 / omx1 * zo) / 0.2D1 - 0.2D1 * (0.1D1 + x
     #1) / zo / omz2 / omzo * rH2(0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * z
     #o + zo ** 2 - 0.2D1 * zo + 0.1D1)) - (x1 - 0.2D1 * zo + 0.1D1) / z
     #o / omz2 / omzo * rH2(0, 1, 0.1D1 / x1 * (x1 - zo)) / 0.2D1 - (x1 
     #* zo ** 2 - 0.2D1 * x1 * zo + zo ** 2 + 0.2D1 * x1 + 0.2D1) / zo /
     # omz2 / omzo * rH2(0, 1, zo) / 0.4D1 + (-0.1D1 - x1) / zo / omz2 /
     # omzo * rln2 ** 2 + 0.2D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1
     # * zo + 0.1D1) / omz2 / omzo * rln2 * zo + (-0.8D1 * x1 - 0.8D1) /
     # Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omz2 / omz
     #o * rln2 - 0.2D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0
     #.1D1) / omz2 / omzo * rln2 / zo + 0.2D1 / zo * rH1(0, 0.1D1 - zo +
     # Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omz2 / om
     #zo * Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) + (x1 * 
     #zo ** 2 + 0.2D1 * x1 * zo - 0.3D1 * zo ** 2 + 0.10D2 * zo + 0.8D1)
     # / zo / omz2 / omzo * rH1(0, zo) / 0.8D1 + (0.1D1 / 0.2D1 - 0.3D1 
     #/ 0.8D1 * x1 * zo + x1 / 0.4D1 - 0.3D1 / 0.8D1 * zo) / omz2 / omzo
     # * rH1(1, x1) - (0.3D1 * x1 ** 2 * zo ** 2 + 0.3D1 * x1 * zo ** 3 
     #- 0.2D1 * x1 ** 2 * zo - 0.14D2 * x1 * zo ** 2 - 0.9D1 * zo ** 3 +
     # 0.10D2 * x1 ** 2 + 0.10D2 * x1 * zo - zo ** 2 - 0.14D2 * x1 + 0.6
     #D1 * zo + 0.4D1) / zo / (-0.1D1 + x1 + zo) / omz2 / omzo / 0.8D1 -
     # (x1 ** 3 * zo + 0.2D1 * x1 ** 2 * zo ** 2 + x1 * zo ** 3 + 0.2D1 
     #* x1 ** 3 - x1 ** 2 * zo - 0.6D1 * x1 * zo ** 2 - 0.3D1 * zo ** 3 
     #- 0.4D1 * x1 ** 2 + 0.19D2 * x1 * zo + 0.14D2 * zo ** 2 - 0.14D2 *
     # x1 - 0.19D2 * zo + 0.8D1) / (-0.1D1 + x1 + zo) ** 2 * rH1(1, zo) 
     #/ omz2 / omzo / 0.8D1 + 0.1D1 / omx1 / omz2 / omzo * rln2 ** 2 * z
     #o + 0.2D1 / omx1 / omz2 / omzo * rln2 ** 2 / zo - 0.2D1 * rH1(0, z
     #o) / omx1 / omz2 / omzo * rln2 + 0.5D1 / Sqrt(0.4D1 * x1 * zo + zo
     # ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2 + 0.4D1 * 
     #rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 
     #0.1D1)) / omx1 / omz2 / omzo * rln2 - 0.2D1 * rH1(0, x1) / omx1 / 
     #omz2 / omzo * rln2 - rH1(0, zo) * dls / omz2 / omzo / 0.2D1 + (0.1
     #D1 / 0.2D1 + zo / 0.4D1 - x1 / 0.2D1 + x1 * zo / 0.4D1) * rH2(0, 1
     #, x1) / omz2 / omzo + (x1 - 0.2D1 * zo + 0.1D1) / zo / omz2 / omzo
     # * rH1(1, zo) * rH1(0, 0.1D1 - x1 - zo) / 0.2D1 + (-0.1D1 - x1) * 
     #rH1(0, zo) / omz2 / omzo * rln2 / zo + (0.2D1 + 0.2D1 * x1) * rH1(
     #0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D
     #1)) / omz2 / omzo * rln2 / zo + (-0.1D1 - x1) * rH1(0, x1) / omz2 
     #/ omzo * rln2 / zo - (0.3D1 * x1 ** 3 * zo ** 2 + 0.6D1 * x1 ** 2 
     #* zo ** 3 + 0.3D1 * x1 * zo ** 4 + 0.2D1 * x1 ** 3 * zo - x1 ** 2 
     #* zo ** 2 - 0.2D1 * x1 * zo ** 3 + zo ** 4 - 0.2D1 * x1 ** 3 - 0.8
     #D1 * x1 ** 2 * zo + 0.11D2 * x1 * zo ** 2 + 0.6D1 * zo ** 3 - 0.2D
     #1 * x1 ** 2 - 0.22D2 * x1 * zo - 0.21D2 * zo ** 2 + 0.10D2 * x1 + 
     #0.20D2 * zo - 0.6D1) / zo / (-0.1D1 + x1 + zo) ** 2 / omz2 / omzo 
     #* rH1(0, x1) / 0.8D1 + (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, 0.1
     #D1 - x1 - zo) / omz2 / omzo * rH1(0, x1) / 0.2D1 + (0.1D1 + x1) / 
     #zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * 
     #zo + 0.1D1)) / omz2 / omzo * rH1(0, x1) + (0.1D1 + x1) / zo * rH1(
     #0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D
     #1)) / omz2 / omzo * rH1(0, zo) - (x1 - 0.2D1 * zo + 0.1D1) / zo * 
     #rH1(1, zo) / omz2 / omzo * rH1(1, x1) / 0.2D1 - (0.4D1 * x1 * zo -
     # zo ** 2 + 0.4D1 * zo + 0.1D1) / zo * rH1(0, zo) / omz2 / omzo / S
     #qrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (0.4D1 * x1 
     #* zo - zo ** 2 + 0.4D1 * zo + 0.1D1) / zo * rH1(0, x1) / omz2 / om
     #zo / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) + (zo - 
     #0.1D1) ** 2 / zo / omx1 / omz2 / omzo * pi ** 2 / 0.2D1 - 0.1D1 / 
     #Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2
     # / omzo * rln2 * zo ** 2 - 0.2D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 
     #* x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * 
     #rln2 * zo + 0.2D1 * rH1(0, zo) / omx1 / omz2 / omzo * rln2 / zo + 
     #0.3D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx
     #1 / omz2 / omzo * rln2 / zo - 0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4
     #D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo
     # * rln2 / zo + 0.2D1 * rH1(0, x1) / omx1 / omz2 / omzo * rln2 / zo
     # - (0.3D1 * zo ** 2 - 0.10D2 * zo + 0.6D1) / zo / omx1 / omz2 / om
     #zo * rH1(0, x1) / 0.8D1 + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, zo) /
     # omx1 / omz2 / omzo + 0.2D1 * (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo 
     #* rH2(0, 0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * 
     #zo + 0.1D1)) / omx1 / omz2 / omzo + (zo - 0.1D1) ** 2 / zo * rH2(0
     #, 1, 0.1D1 / x1 * (x1 - zo)) / omx1 / omz2 / omzo - (zo - 0.3D1) *
     # (zo + 0.1D1) ** 2 / zo * rH1(0, zo) / omx1 / omz2 / omzo / Sqrt(0
     #.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (zo - 0.3
     #D1) * (zo + 0.1D1) ** 2 / zo * rH1(0, x1) / omx1 / omz2 / omzo / S
     #qrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - 0.2D
     #1 / omx1 / omz2 / omzo * rln2 ** 2 + (0.1D1 - zo / 0.2D1) * rH2(0,
     # 1, 0.1D1 / omx1 * zo) / omx1 / omz2 / omzo + (x1 - 0.2D1 * zo + 0
     #.1D1) / zo / omz2 / omzo * rH1(1, x1) ** 2 / 0.2D1 + (x1 - 0.2D1 *
     # zo + 0.1D1) / zo / omz2 / omzo * rH2(0, 1, x1 * omx1 / zo / (0.1D
     #1 - zo)) / 0.2D1 - (zo - 0.1D1) ** 2 / zo * rH2(0, 1, x1 * omx1 / 
     #zo / (0.1D1 - zo)) / omx1 / omz2 / omzo + (x1 - 0.2D1 * zo + 0.1D1
     #) / zo / omz2 / omzo * rH2(0, 1, 0.1D1 / omx1 * (0.1D1 - zo)) / 0.
     #2D1 + (zo - 0.1D1) ** 2 / zo * rH1(1, zo) / omx1 / omz2 / omzo * r
     #H1(0, zo) - (zo - 0.1D1) ** 2 / zo * rH1(1, x1) / omx1 / omz2 / om
     #zo * rH1(0, zo) - (zo - 0.1D1) ** 2 / zo * rH1(0, -x1 + zo) / omx1
     # / omz2 / omzo * rH1(0, x1) - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D
     #1) / zo * rH1(1, zo) / omx1 / omz2 / omzo * rH1(0, x1) / 0.2D1 + (
     #zo - 0.1D1) ** 2 / zo * rH1(0, -x1 + zo) / omx1 / omz2 / omzo * rH
     #1(0, zo) + (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) ** 2 / omzo
     # / omz2 / 0.2D1 - (0.2D1 * x1 - 0.5D1 * zo + 0.2D1) / zo / omzo / 
     #omz2 * pi ** 2 / 0.12D2 + (x1 * zo ** 2 - 0.2D1 * x1 * zo + zo ** 
     #2 + 0.2D1 * x1 + 0.2D1) / zo / omzo / omz2 * rH1(0, zo) ** 2 / 0.8
     #D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) * (0.1D1 + x1) / zo * rH1(1, x
     #1) / omzo / omz2 * rH1(0, x1) / 0.4D1 + (zo ** 2 - 0.2D1 * zo + 0.
     #2D1) / zo * rH1(0, zo) / omx1 / omz2 / omzo * rH1(0, x1) / 0.2D1 +
     # (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(1, zo) / omzo / omz2 * rH1(0
     #, x1) / 0.2D1 - (0.1D1 + x1) / zo * rH1(0, zo) / omzo / omz2 * rH1
     #(0, x1) / 0.2D1 - (x1 * zo ** 2 - 0.2D1 * x1 * zo + zo ** 2 + 0.7D
     #1 * x1 - 0.8D1 * zo + 0.7D1) / zo / omzo / omz2 * rH1(0, x1) ** 2 
     #/ 0.8D1 + (x1 * zo ** 2 - 0.2D1 * x1 * zo + zo ** 2 - 0.2D1 * x1 +
     # 0.6D1 * zo - 0.2D1) / zo * rH1(1, zo) / omzo / omz2 * rH1(0, zo) 
     #/ 0.4D1
      elseif(region4) then
      e0 = -0.5D1 / 0.4D1 * d0x1 / omz2 / omzo * rH1(0, zo) + (x1 - 0.
     #2D1 * zo + 0.1D1) / zo * rH1(0, -x1 + zo) / omzo / omz2 * rH1(0, x
     #1) / 0.2D1 - (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, -x1 + zo) / o
     #mzo / omz2 * rH1(0, zo) / 0.2D1 + (zo - 0.1D1) ** 2 / zo / omx1 / 
     #omz2 / omzo * rH1(0, zo) ** 2 / 0.2D1 - (zo - 0.1D1) ** 2 / zo * r
     #H2(0, 1, 0.1D1 / omx1 * (0.1D1 - zo)) / omx1 / omz2 / omzo + (0.9D
     #1 * zo ** 2 - 0.9D1 * zo + 0.5D1) / zo * d0x1 / omz2 / omzo / 0.8D
     #1 + (0.1D1 / 0.2D1 - zo / 0.8D1) * rH1(1, zo) * d0x1 / omz2 / omzo
     # + (-0.1D1 / 0.2D1 + zo / 0.8D1) * d1x1 / omz2 / omzo + (-0.1D1 / 
     #0.2D1 + zo / 0.4D1) * rH1(0, zo) * d1x1 / omz2 / omzo + (x1 * zo /
     # 0.8D1 + x1 / 0.4D1 - 0.3D1 / 0.8D1 * zo) * dla / omz2 / omzo + (-
     #0.1D1 / 0.2D1 + zo / 0.8D1) * d0x1 * dla / omz2 / omzo + (-0.1D1 /
     # 0.2D1 + zo / 0.4D1) * rH1(0, zo) * d0x1 * dla / omz2 / omzo + rH1
     #(0, zo) * dla / omz2 / omzo / 0.2D1 + (zo ** 2 - 0.2D1 * zo + 0.2D
     #1) / zo * rH1(1, zo) * d0x1 * dla / omz2 / omzo / 0.2D1 - (zo ** 2
     # - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) * d0x1 * dls / omz2 / omz
     #o / 0.2D1 - (zo ** 3 + (x1 - 0.3D1) * zo ** 2 + (-0.2D1 * x1 + 0.6
     #D1) * zo + 0.4D1 * x1 - 0.4D1) / zo / (-0.1D1 + x1 + zo) * d0x1 / 
     #omz2 / omzo * pi ** 2 / 0.24D2 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / 
     #zo * rH1(1, zo) * d0x1 / omz2 / omzo * rH1(0, zo) / 0.2D1 + rH1(0,
     # zo) / omx1 / omz2 / omzo * rln2 * zo + 0.1D1 / Sqrt(0.4D1 * x1 * 
     #zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2 * z
     #o + rH1(0, x1) / omx1 / omz2 / omzo * rln2 * zo + (zo - 0.3D1) / z
     #o * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * z
     #o + 0.1D1)) / omx1 / omz2 / omzo * Sqrt(0.4D1 * x1 * zo + zo ** 2 
     #- 0.2D1 * zo + 0.1D1) - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(
     #0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D
     #1)) / omx1 / omz2 / omzo * rH1(0, x1) + (zo + 0.1D1) * (zo - 0.3D1
     #) / zo / omx1 / omz2 / omzo * rH1(0, zo) / 0.2D1 - (zo ** 2 - 0.2D
     #1 * zo + 0.2D1) / zo * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + 
     #zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / omzo * rH1(0, zo) +
     # (zo ** 2 - 0.2D1 * zo + 0.2D1) / omx1 / zo / omz2 / omzo * rH2(0,
     # 1, 0.1D1 / x1 * omx1 / zo * (0.1D1 - zo)) / 0.2D1 + (0.1D1 / 0.2D
     #1 - zo / 0.8D1) * d0x1 * dls / omz2 / omzo + (0.1D1 / 0.2D1 - zo /
     # 0.4D1) * rH1(0, zo) * d0x1 * dls / omz2 / omzo - (0.5D1 * zo ** 2
     # - 0.10D2 * zo + 0.8D1) / zo * rH2(0, 1, zo) * d0x1 / omz2 / omzo 
     #/ 0.4D1 - (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH1(1, zo) ** 2 * 
     #d0x1 / omz2 / omzo / 0.4D1 + (zo ** 2 - 0.2D1 * zo + 0.2D1) / zo *
     # rH1(1, zo) * d1x1 / omz2 / omzo / 0.2D1 - (x1 - 0.2D1 * zo + 0.1D
     #1) / zo * rH1(1, zo) * dla / omz2 / omzo / 0.2D1 + (x1 - 0.2D1 * z
     #o + 0.1D1) / zo * rH1(1, zo) * dls / omz2 / omzo / 0.2D1 + (0.3D1 
     #/ 0.8D1 * zo - x1 / 0.4D1 - x1 * zo / 0.8D1) * dls / omz2 / omzo -
     # 0.2D1 * (0.1D1 + x1) / zo / omz2 / omzo * rH2(0, 0, 0.1D1 - zo + 
     #Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) - (x1 - 0.2D
     #1 * zo + 0.1D1) / zo / omz2 / omzo * rH2(0, 1, 0.1D1 / x1 * (x1 - 
     #zo)) / 0.2D1 - (x1 - 0.2D1 * zo + 0.1D1) / zo / omz2 / omzo * rH2(
     #0, 1, 0.1D1 / x1 / omx1 * zo * (0.1D1 - zo)) / 0.2D1 - (x1 * zo **
     # 2 - 0.2D1 * x1 * zo + zo ** 2 + 0.2D1 * x1 + 0.2D1) / zo / omz2 /
     # omzo * rH2(0, 1, zo) / 0.4D1 + (0.2D1 * x1 - 0.3D1 * zo + 0.2D1) 
     #/ zo / omz2 / omzo * pi ** 2 / 0.12D2 + (-0.1D1 - x1) / zo / omz2 
     #/ omzo * rln2 ** 2 + 0.2D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D
     #1 * zo + 0.1D1) / omz2 / omzo * rln2 * zo + (-0.8D1 * x1 - 0.8D1) 
     #/ Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / omz2 / om
     #zo * rln2 - 0.2D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 
     #0.1D1) / omz2 / omzo * rln2 / zo + 0.2D1 / zo * rH1(0, 0.1D1 - zo 
     #+ Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omz2 / o
     #mzo * Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) - (x1 *
     # zo ** 2 - 0.2D1 * x1 * zo + zo ** 2 + 0.9D1 * x1 - 0.12D2 * zo + 
     #0.9D1) / zo / omz2 / omzo * rH1(0, x1) ** 2 / 0.8D1 + (-0.1D1 / 0.
     #2D1 - x1 * zo / 0.4D1 + x1 / 0.2D1 - zo / 0.4D1) * rH1(1, x1) / om
     #z2 / omzo * rH1(0, x1) + (x1 * zo ** 2 + 0.2D1 * x1 * zo - 0.3D1 *
     # zo ** 2 + 0.10D2 * zo + 0.8D1) / zo / omz2 / omzo * rH1(0, zo) / 
     #0.8D1 + (0.1D1 / 0.2D1 + zo / 0.4D1 - x1 / 0.2D1 + x1 * zo / 0.4D1
     #) * rH1(1, zo) / omz2 / omzo * rH1(0, zo) + (0.1D1 / 0.2D1 - 0.3D1
     # / 0.8D1 * x1 * zo + x1 / 0.4D1 - 0.3D1 / 0.8D1 * zo) / omz2 / omz
     #o * rH1(1, x1) - (0.3D1 * x1 ** 2 * zo ** 2 + 0.3D1 * x1 * zo ** 3
     # - 0.2D1 * x1 ** 2 * zo - 0.14D2 * x1 * zo ** 2 - 0.9D1 * zo ** 3 
     #+ 0.10D2 * x1 ** 2 + 0.10D2 * x1 * zo - zo ** 2 - 0.14D2 * x1 + 0.
     #6D1 * zo + 0.4D1) / zo / (-0.1D1 + x1 + zo) / omz2 / omzo / 0.8D1 
     #- (x1 ** 3 * zo + 0.2D1 * x1 ** 2 * zo ** 2 + x1 * zo ** 3 + 0.2D1
     # * x1 ** 3 - x1 ** 2 * zo - 0.6D1 * x1 * zo ** 2 - 0.3D1 * zo ** 3
     # - 0.4D1 * x1 ** 2 + 0.19D2 * x1 * zo + 0.14D2 * zo ** 2 - 0.14D2 
     #* x1 - 0.19D2 * zo + 0.8D1) / (-0.1D1 + x1 + zo) ** 2 * rH1(1, zo)
     # / omz2 / omzo / 0.8D1 + 0.1D1 / omx1 / omz2 / omzo * rln2 ** 2 * 
     #zo + 0.2D1 / omx1 / omz2 / omzo * rln2 ** 2 / zo - 0.2D1 * rH1(0, 
     #zo) / omx1 / omz2 / omzo * rln2 + 0.5D1 / Sqrt(0.4D1 * x1 * zo + z
     #o ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2 + 0.4D1 *
     # rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo +
     # 0.1D1)) / omx1 / omz2 / omzo * rln2 - 0.2D1 * rH1(0, x1) / omx1 /
     # omz2 / omzo * rln2 - rH1(0, zo) * dls / omz2 / omzo / 0.2D1 - rH1
     #(0, zo) / omz2 / omzo * rH1(0, x1) + (0.1D1 / 0.2D1 + zo / 0.4D1 -
     # x1 / 0.2D1 + x1 * zo / 0.4D1) * rH2(0, 1, x1) / omz2 / omzo + (-0
     #.1D1 - x1) * rH1(0, zo) / omz2 / omzo * rln2 / zo + (0.2D1 + 0.2D1
     # * x1) * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D
     #1 * zo + 0.1D1)) / omz2 / omzo * rln2 / zo + (-0.1D1 - x1) * rH1(0
     #, x1) / omz2 / omzo * rln2 / zo - (0.3D1 * x1 ** 3 * zo ** 2 + 0.6
     #D1 * x1 ** 2 * zo ** 3 + 0.3D1 * x1 * zo ** 4 + 0.2D1 * x1 ** 3 * 
     #zo - x1 ** 2 * zo ** 2 - 0.2D1 * x1 * zo ** 3 + zo ** 4 - 0.2D1 * 
     #x1 ** 3 - 0.8D1 * x1 ** 2 * zo + 0.11D2 * x1 * zo ** 2 + 0.6D1 * z
     #o ** 3 - 0.2D1 * x1 ** 2 - 0.22D2 * x1 * zo - 0.21D2 * zo ** 2 + 0
     #.10D2 * x1 + 0.20D2 * zo - 0.6D1) / zo / (-0.1D1 + x1 + zo) ** 2 /
     # omz2 / omzo * rH1(0, x1) / 0.8D1 + (0.1D1 + x1) / zo * rH1(0, 0.1
     #D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / 
     #omz2 / omzo * rH1(0, x1) + (0.1D1 + x1) / zo * rH1(0, 0.1D1 - zo +
     # Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omz2 / om
     #zo * rH1(0, zo) - (0.4D1 * x1 * zo - zo ** 2 + 0.4D1 * zo + 0.1D1)
     # / zo * rH1(0, zo) / omz2 / omzo / Sqrt(0.4D1 * x1 * zo + zo ** 2 
     #- 0.2D1 * zo + 0.1D1) - (0.4D1 * x1 * zo - zo ** 2 + 0.4D1 * zo + 
     #0.1D1) / zo * rH1(0, x1) / omz2 / omzo / Sqrt(0.4D1 * x1 * zo + zo
     # ** 2 - 0.2D1 * zo + 0.1D1) - (zo - 0.1D1) ** 2 / zo / omx1 / omz2
     # / omzo * pi ** 2 / 0.6D1 - 0.1D1 / Sqrt(0.4D1 * x1 * zo + zo ** 2
     # - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2 * zo ** 2 - 0.2
     #D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * 
     #zo + 0.1D1)) / omx1 / omz2 / omzo * rln2 * zo + 0.2D1 * rH1(0, zo)
     # / omx1 / omz2 / omzo * rln2 / zo + 0.3D1 / Sqrt(0.4D1 * x1 * zo +
     # zo ** 2 - 0.2D1 * zo + 0.1D1) / omx1 / omz2 / omzo * rln2 / zo - 
     #0.4D1 * rH1(0, 0.1D1 - zo + Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1
     # * zo + 0.1D1)) / omx1 / omz2 / omzo * rln2 / zo + 0.2D1 * rH1(0, 
     #x1) / omx1 / omz2 / omzo * rln2 / zo - (0.3D1 * zo ** 2 - 0.10D2 *
     # zo + 0.6D1) / zo / omx1 / omz2 / omzo * rH1(0, x1) / 0.8D1 + (zo 
     #- 0.1D1) ** 2 / zo * rH2(0, 1, zo) / omx1 / omz2 / omzo + 0.2D1 * 
     #(zo ** 2 - 0.2D1 * zo + 0.2D1) / zo * rH2(0, 0, 0.1D1 - zo + Sqrt(
     #0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1)) / omx1 / omz2 / o
     #mzo + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / x1 * (x1 - zo)) /
     # omx1 / omz2 / omzo + (zo - 0.1D1) ** 2 / zo * rH2(0, 1, 0.1D1 / x
     #1 / omx1 * zo * (0.1D1 - zo)) / omx1 / omz2 / omzo - (zo - 0.3D1) 
     #* (zo + 0.1D1) ** 2 / zo * rH1(0, zo) / omx1 / omz2 / omzo / Sqrt(
     #0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - (zo - 0.
     #3D1) * (zo + 0.1D1) ** 2 / zo * rH1(0, x1) / omx1 / omz2 / omzo / 
     #Sqrt(0.4D1 * x1 * zo + zo ** 2 - 0.2D1 * zo + 0.1D1) / 0.2D1 - 0.2
     #D1 / omx1 / omz2 / omzo * rln2 ** 2 - (x1 - 0.2D1 * zo + 0.1D1) / 
     #zo / omz2 / omzo * rH2(0, 1, omx1 / zo) / 0.2D1 + (x1 - 0.2D1 * zo
     # + 0.1D1) / zo / omz2 / omzo * rH2(0, 1, 0.1D1 / omx1 * (0.1D1 - z
     #o)) / 0.2D1 + (x1 - 0.2D1 * zo + 0.1D1) / zo / omz2 / omzo * rH1(1
     #, zo) * rH1(0, -0.1D1 + x1 + zo) / 0.2D1 + (x1 * zo ** 2 - 0.2D1 *
     # x1 * zo + zo ** 2 - 0.2D1 * x1 + 0.8D1 * zo - 0.2D1) / zo / omzo 
     #/ omz2 * rH1(0, zo) ** 2 / 0.8D1 + (zo ** 2 - 0.2D1 * zo + 0.2D1) 
     #/ zo * rH1(1, zo) / omx1 / omz2 / omzo * rH1(0, zo) / 0.2D1 + (zo 
     #- 0.1D1) ** 2 / zo * rH1(1, x1) / omx1 / omz2 / omzo * rH1(0, zo) 
     #- (zo - 0.1D1) ** 2 / zo * rH1(0, -x1 + zo) / omx1 / omz2 / omzo *
     # rH1(0, x1) + (zo - 0.1D1) ** 2 / zo * rH1(0, -x1 + zo) / omx1 / o
     #mz2 / omzo * rH1(0, zo) - (x1 - zo + 0.1D1) / zo * rH1(1, x1) / om
     #zo / omz2 * rH1(0, zo) / 0.2D1 + (x1 - 0.2D1 * zo + 0.1D1) / zo * 
     #rH1(1, zo) ** 2 / omzo / omz2 / 0.4D1 - (0.3D1 * zo ** 2 - 0.6D1 *
     # zo + 0.4D1) / zo * rH1(0, -0.1D1 + x1 + zo) / omx1 / omz2 / omzo 
     #* rH1(0, x1) / 0.2D1 - (0.3D1 * zo ** 2 - 0.6D1 * zo + 0.4D1) / zo
     # * rH1(1, zo) / omx1 / omz2 / omzo * rH1(0, -0.1D1 + x1 + zo) / 0.
     #2D1 + (x1 - 0.2D1 * zo + 0.1D1) / zo * rH1(0, -0.1D1 + x1 + zo) / 
     #omzo / omz2 * rH1(0, x1) / 0.2D1 + (0.7D1 * zo ** 2 - 0.14D2 * zo 
     #+ 0.10D2) / zo / omx1 / omz2 / omzo * rH1(0, x1) ** 2 / 0.4D1 + 0.
     #1D1 / zo * rH1(0, zo) / omx1 / omz2 / omzo * rH1(0, x1) + (0.1D1 -
     # zo / 0.2D1) * rH1(1, x1) / omx1 / omz2 / omzo * rH1(0, x1) + (zo 
     #/ 0.2D1 - 0.1D1) * rH2(0, 1, omx1 / zo) / omx1 / omz2 / omzo
      endif
      endif

      if(ieorder.eq.-2)then
        rJ22QQIFqgam_fragh=e2
      elseif(ieorder.eq.-1)then
        rJ22QQIFqgam_fragh=e1
      elseif(ieorder.eq.0)then
        rJ22QQIFqgam_fragh=e0
      endif

*      write(*,*)" rJ22QQIFqgam_fragh ",rJ22QQIFqgam_fragh

      return
      end
************************************************************************
*
      function rJ22hQGIFqgam_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use PhotonFragmentation_mod, only : iz_frag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J22hQGIFqgam_frag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ22hQGIFqgam_frag=rJ22hGQFIqgam_frag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_frag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = 0.35D2 / 0.6D1 / omz1 / omz2 / omzo - d0x1 / omz2 / omzo * 
     #rH1(0, zo) / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo * pi ** 2 * zo ** 
     #2 / 0.9D1 + 0.1D1 / omz1 / omz2 / omzo * pi ** 2 * zo / 0.6D1 + rH
     #1(1, z1) / omz1 / omz2 / omzo * pi ** 2 / 0.6D1 + 0.1D1 / omz1 / o
     #mz2 / omzo * pi ** 2 / zo / 0.9D1 - 0.1D1 / omz1 / omz2 / omzo * z
     #eta3 * zo + rH1(0, zo) * dla * dls / omz1 / omz2 / omzo + rH2(0, 1
     #, zo) * dla / omz1 / omz2 / omzo * zo + rH1(1, z1) * dla / omz1 / 
     #omz2 / omzo * rH1(0, zo) - rH1(1, z1) * dls / omz1 / omz2 / omzo *
     # zo * rH1(0, zo) + 0.1D1 / omz1 / omz2 / omzo * zo ** 2 * rH1(0, z
     #o) ** 2 / 0.3D1 + 0.31D2 / 0.18D2 / omz1 / omz2 / omzo * zo ** 2 *
     # rH1(0, zo) + 0.17D2 / 0.6D1 / omz1 / omz2 / omzo * zo ** 2 * rH1(
     #1, z1) + 0.17D2 / 0.6D1 * rH1(1, zo) / omz1 / omz2 / omzo * zo ** 
     #2 - 0.4D1 / 0.3D1 * rH2(0, 1, zo) / omz1 / omz2 / omzo * zo ** 2 +
     # rH1(1, zo) ** 2 / omz1 / omz2 / omzo * zo ** 2 / 0.3D1 + 0.2D1 / 
     #0.3D1 * rH2(1, 1, z1) / omz1 / omz2 / omzo * zo ** 2 + 0.1D1 / omz
     #1 / omz2 / omzo * zo * rH1(0, zo) ** 3 / 0.4D1 + 0.5D1 / 0.8D1 / o
     #mz1 / omz2 / omzo * zo * rH1(0, zo) ** 2 + dls ** 2 / omz1 / omz2 
     #/ omzo * zo ** 2 / 0.3D1 + dls ** 2 / omz1 / omz2 / omzo * zo / 0.
     #4D1 - rH1(0, zo) * dls ** 2 / omz1 / omz2 / omzo / 0.2D1 - dls ** 
     #2 / omz1 / omz2 / omzo / zo / 0.3D1 + d0x1 * dla / omz2 / omzo / 0
     #.2D1 - d0x1 * dls / omz2 / omzo / 0.2D1 + d0x1 / omz2 / omzo * pi 
     #** 2 / 0.6D1 - dls / omz1 / omz2 / omzo * rH1(0, zo) / 0.2D1 - rH1
     #(1, zo) * dls / omz1 / omz2 / omzo / 0.2D1 - rH2(0, 1, zo) * dls /
     # omz1 / omz2 / omzo - rH1(1, z1) * dls / omz1 / omz2 / omzo / 0.2D
     #1 - 0.11D2 / 0.6D1 * dls / omz1 / omz2 / omzo / zo + 0.2D1 / 0.3D1
     # / omz1 / omz2 / omzo / zo * rH1(0, zo) ** 2 - rH2(0, 1, zo) / omz
     #1 / omz2 / omzo * rH1(1, zo) + 0.22D2 / 0.3D1 / omz1 / omz2 / omzo
     # * zo * rH1(0, zo) - 0.8D1 / 0.3D1 / omz1 / omz2 / omzo * zo * rH1
     #(1, z1) + 0.1D1 / omz1 / omz2 / omzo * zo * rH1(1, zo) ** 2 / 0.4D
     #1 - 0.8D1 / 0.3D1 / omz1 / omz2 / omzo * zo * rH1(1, zo) - 0.3D1 /
     # 0.2D1 * rH2(0, 1, zo) / omz1 / omz2 / omzo * zo + rH2(1, 1, z1) /
     # omz1 / omz2 / omzo * zo / 0.2D1 + 0.2D1 * rH3(0, 0, 1, zo) / omz1
     # / omz2 / omzo * zo - rH3(1, 1, 0, zo) / omz1 / omz2 / omzo * zo -
     # rH1(1, zo) / omz1 / omz2 / omzo * rH1(0, zo) / 0.2D1 - rH2(0, 1, 
     #zo) / omz1 / omz2 / omzo * rH1(0, zo) + rH1(1, zo) ** 2 / omz1 / o
     #mz2 / omzo * rH1(0, zo) / 0.2D1 - rH1(1, z1) / omz1 / omz2 / omzo 
     #* rH1(0, zo) / 0.2D1 - rH2(1, 1, z1) / omz1 / omz2 / omzo * rH1(0,
     # zo) - rH1(1, zo) / omz1 / omz2 / omzo * rH1(1, z1) / 0.2D1 - rH2(
     #0, 1, zo) / omz1 / omz2 / omzo * rH1(1, z1) - 0.1D1 / omz1 / omz2 
     #/ omzo * rH1(1, zo) ** 2 / 0.4D1 + 0.5D1 / 0.3D1 / omz1 / omz2 / o
     #mzo * rH1(1, zo) - rH2(1, 1, z1) / omz1 / omz2 / omzo / 0.2D1 + 0.
     #2D1 * rH3(0, 0, 1, zo) / omz1 / omz2 / omzo - rH3(1, 1, 0, zo) / o
     #mz1 / omz2 / omzo + dla * dls / omz1 / omz2 / omzo / 0.2D1 - dla /
     # omz1 / omz2 / omzo * pi ** 2 / 0.6D1 - 0.17D2 / 0.6D1 * dla / omz
     #1 / omz2 / omzo * zo ** 2 + 0.8D1 / 0.3D1 * dla / omz1 / omz2 / om
     #zo * zo + dla / omz1 / omz2 / omzo * rH1(0, zo) / 0.2D1 + rH1(1, z
     #o) * dla / omz1 / omz2 / omzo / 0.2D1 + rH1(1, z1) * dla / omz1 / 
     #omz2 / omzo / 0.2D1 + 0.11D2 / 0.6D1 * dla / omz1 / omz2 / omzo / 
     #zo - d0x1 * dla / omz2 / omzo * zo / 0.2D1 + 0.2D1 / 0.3D1 * d0x1 
     #* dla / omz2 / omzo / zo + 0.2D1 / 0.3D1 * d0x1 * dls / omz2 / omz
     #o * zo ** 2 + d0x1 * dls / omz2 / omzo * zo / 0.2D1 - rH1(0, zo) *
     # d0x1 * dls / omz2 / omzo - 0.2D1 / 0.3D1 * d0x1 * dls / omz2 / om
     #zo / zo + d0x1 / omz2 / omzo * pi ** 2 * zo / 0.6D1 + 0.2D1 / 0.3D
     #1 * rH1(1, zo) * d0x1 / omz2 / omzo * zo ** 2 - 0.2D1 / 0.3D1 * rH
     #1(0, zo) * d0x1 / omz2 / omzo * zo ** 2 + rH1(1, zo) * d0x1 / omz2
     # / omzo * zo / 0.2D1 - rH2(0, 1, zo) * d0x1 / omz2 / omzo * zo - r
     #H1(0, zo) * d0x1 / omz2 / omzo * zo - 0.2D1 / 0.3D1 * rH1(1, zo) *
     # d0x1 / omz2 / omzo / zo - 0.2D1 / 0.3D1 * rH1(0, zo) * d0x1 / omz
     #2 / omzo / zo + rH1(0, zo) * d0x1 * dla / omz2 / omzo - rH1(0, zo)
     # * d0x1 * dls / omz2 / omzo * zo + rH1(0, zo) * d1x1 / omz2 / omzo
     # * zo - rH1(0, zo) * dla ** 2 / omz1 / omz2 / omzo * zo / 0.2D1 - 
     #0.2D1 / 0.3D1 * dla * dls / omz1 / omz2 / omzo * zo ** 2 - dla * d
     #ls / omz1 / omz2 / omzo * zo / 0.2D1 + 0.2D1 / 0.3D1 * dla * dls /
     # omz1 / omz2 / omzo / zo - dla / omz1 / omz2 / omzo * pi ** 2 * zo
     # / 0.6D1 - 0.2D1 / 0.3D1 * rH1(1, zo) * dla / omz1 / omz2 / omzo *
     # zo ** 2 + 0.2D1 / 0.3D1 * rH1(0, zo) * dla / omz1 / omz2 / omzo *
     # zo ** 2 - 0.2D1 / 0.3D1 * rH1(1, z1) * dla / omz1 / omz2 / omzo *
     # zo ** 2 + dla / omz1 / omz2 / omzo * zo * rH1(0, zo) - rH1(1, zo)
     # * dla / omz1 / omz2 / omzo * zo / 0.2D1 - rH1(1, z1) * dla / omz1
     # / omz2 / omzo * zo / 0.2D1 + rH2(0, 1, zo) * dla / omz1 / omz2 / 
     #omzo + 0.2D1 / 0.3D1 * rH1(1, zo) * dla / omz1 / omz2 / omzo / zo 
     #+ 0.2D1 / 0.3D1 * rH1(0, zo) * dla / omz1 / omz2 / omzo / zo + 0.2
     #D1 / 0.3D1 * rH1(1, z1) * dla / omz1 / omz2 / omzo / zo - rH1(0, z
     #o) * dls ** 2 / omz1 / omz2 / omzo * zo / 0.2D1 + dls / omz1 / omz
     #2 / omzo * pi ** 2 * zo / 0.6D1 + 0.2D1 / 0.3D1 * rH1(1, zo) * dls
     # / omz1 / omz2 / omzo * zo ** 2 - 0.2D1 / 0.3D1 * rH1(0, zo) * dls
     # / omz1 / omz2 / omzo * zo ** 2 + 0.2D1 / 0.3D1 * rH1(1, z1) * dls
     # / omz1 / omz2 / omzo * zo ** 2 - dls / omz1 / omz2 / omzo * zo * 
     #rH1(0, zo) + rH1(1, zo) * dls / omz1 / omz2 / omzo * zo / 0.2D1 - 
     #rH2(0, 1, zo) * dls / omz1 / omz2 / omzo * zo + rH1(1, z1) * dls /
     # omz1 / omz2 / omzo * zo / 0.2D1 - rH1(1, z1) * dls / omz1 / omz2 
     #/ omzo * rH1(0, zo) - 0.2D1 / 0.3D1 * rH1(1, zo) * dls / omz1 / om
     #z2 / omzo / zo - 0.2D1 / 0.3D1 * rH1(0, zo) * dls / omz1 / omz2 / 
     #omzo / zo - 0.2D1 / 0.3D1 * rH1(1, z1) * dls / omz1 / omz2 / omzo 
     #/ zo + rH1(1, z1) / omz1 / omz2 / omzo * pi ** 2 * zo / 0.6D1 + 0.
     #2D1 / 0.3D1 * rH1(1, zo) / omz1 / omz2 / omzo * zo ** 2 * rH1(0, z
     #o) - 0.2D1 / 0.3D1 * rH1(1, z1) / omz1 / omz2 / omzo * zo ** 2 * r
     #H1(0, zo) + 0.2D1 / 0.3D1 * rH1(1, zo) / omz1 / omz2 / omzo * zo *
     #* 2 * rH1(1, z1) + rH1(1, zo) / omz1 / omz2 / omzo * zo * rH1(0, z
     #o) / 0.2D1 - rH2(0, 1, zo) / omz1 / omz2 / omzo * zo * rH1(0, zo) 
     #+ rH1(1, zo) ** 2 / omz1 / omz2 / omzo * zo * rH1(0, zo) / 0.2D1 -
     # rH1(1, z1) / omz1 / omz2 / omzo * zo * rH1(0, zo) - rH2(1, 1, z1)
     # / omz1 / omz2 / omzo * zo * rH1(0, zo) + rH1(1, zo) / omz1 / omz2
     # / omzo * zo * rH1(1, z1) / 0.2D1 - rH2(0, 1, zo) / omz1 / omz2 / 
     #omzo * zo * rH1(1, z1) - rH2(0, 1, zo) / omz1 / omz2 / omzo * zo *
     # rH1(1, zo) - 0.2D1 / 0.3D1 * rH1(1, zo) / omz1 / omz2 / omzo / zo
     # * rH1(0, zo) - 0.2D1 / 0.3D1 * rH1(1, z1) / omz1 / omz2 / omzo / 
     #zo * rH1(0, zo) - 0.2D1 / 0.3D1 * rH1(1, zo) / omz1 / omz2 / omzo 
     #/ zo * rH1(1, z1) + rH1(0, zo) * d0x1 * dla / omz2 / omzo * zo + 0
     #.5D1 / 0.3D1 * dls / omz1 / omz2 / omzo - 0.2D1 / 0.3D1 * d0x1 * d
     #la / omz2 / omzo * zo ** 2 + 0.4D1 / 0.9D1 / omz1 / omz2 / omzo / 
     #zo + 0.1D1 / omz1 / omz2 / omzo * rH1(0, zo) ** 3 / 0.4D1 + 0.5D1 
     #/ 0.8D1 / omz1 / omz2 / omzo * rH1(0, zo) ** 2 + 0.8D1 / 0.3D1 / o
     #mz1 / omz2 / omzo * rH1(0, zo) + 0.5D1 / 0.3D1 / omz1 / omz2 / omz
     #o * rH1(1, z1) - 0.1D1 / omz1 / omz2 / omzo * zeta3 - 0.19D2 / 0.9
     #D1 / omz1 / omz2 / omzo * zo ** 2 - 0.25D2 / 0.6D1 / omz1 / omz2 /
     # omzo * zo + rH1(1, z1) * dla / omz1 / omz2 / omzo * zo * rH1(0, z
     #o) + rH1(0, zo) * dla * dls / omz1 / omz2 / omzo * zo + 0.17D2 / 0
     #.6D1 * d0x1 / omz2 / omzo * zo ** 2 - 0.8D1 / 0.3D1 * d0x1 / omz2 
     #/ omzo * zo - 0.11D2 / 0.6D1 * d0x1 / omz2 / omzo / zo + 0.1D1 / o
     #mz1 / omz2 / omzo * pi ** 2 / 0.12D2 + rH1(0, zo) * d1x1 / omz2 / 
     #omzo + 0.13D2 / 0.9D1 / omz1 / omz2 / omzo / zo * rH1(0, zo) - 0.1
     #1D2 / 0.6D1 / omz1 / omz2 / omzo / zo * rH1(1, z1) - dls ** 2 / om
     #z1 / omz2 / omzo / 0.4D1 + 0.17D2 / 0.6D1 * dls / omz1 / omz2 / om
     #zo * zo ** 2 - 0.8D1 / 0.3D1 * dls / omz1 / omz2 / omzo * zo + dla
     # ** 2 / omz1 / omz2 / omzo * zo ** 2 / 0.3D1 + dla ** 2 / omz1 / o
     #mz2 / omzo * zo / 0.4D1 + dls / omz1 / omz2 / omzo * pi ** 2 / 0.6
     #D1 - 0.5D1 / 0.3D1 * dla / omz1 / omz2 / omzo + d1x1 / omz2 / omzo
     # / 0.2D1 - 0.11D2 / 0.6D1 * rH1(1, zo) / omz1 / omz2 / omzo / zo -
     # rH1(1, zo) ** 2 / omz1 / omz2 / omzo / zo / 0.3D1 - 0.2D1 / 0.3D1
     # * rH2(1, 1, z1) / omz1 / omz2 / omzo / zo + 0.5D1 / 0.3D1 * d0x1 
     #/ omz2 / omzo - rH1(1, zo) * d0x1 / omz2 / omzo / 0.2D1 - rH2(0, 1
     #, zo) * d0x1 / omz2 / omzo - 0.2D1 / 0.3D1 * d1x1 / omz2 / omzo * 
     #zo ** 2 - d1x1 / omz2 / omzo * zo / 0.2D1 + 0.2D1 / 0.3D1 * d1x1 /
     # omz2 / omzo / zo - dla ** 2 / omz1 / omz2 / omzo / 0.4D1 - rH1(0,
     # zo) * dla ** 2 / omz1 / omz2 / omzo / 0.2D1 - dla ** 2 / omz1 / o
     #mz2 / omzo / zo / 0.3D1
      endif
      if(ix.eq.3.and.iz_frag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -0.1D1 / omzo / omz2 * rH2(0, 1, zo) + d0x1 / omz2 / omzo *
     # rH1(0, zo) / 0.2D1 + (0.8D1 * x1 ** 2 - 0.22D2 * x1 + 0.3D1) / x1
     # / omzo / omz2 / 0.6D1 + (x1 / 0.2D1 - 0.1D1 / 0.2D1) * rH1(1, zo)
     # / omzo / omz2 + (x1 / 0.2D1 - 0.1D1 / 0.2D1) * rH1(1, x1) / omzo 
     #/ omz2 + (-x1 / 0.3D1 + 0.2D1 / 0.3D1) * dla / omz2 / omzo * zo **
     # 2 + (x1 / 0.2D1 - 0.3D1 / 0.2D1) * dla / omz2 / omzo * zo + (0.1D
     #1 / 0.3D1 + x1 / 0.3D1) * dla / omz2 / omzo / zo + (x1 / 0.3D1 - 0
     #.2D1 / 0.3D1) * dls / omz2 / omzo * zo ** 2 + (-x1 / 0.2D1 + 0.3D1
     # / 0.2D1) * dls / omz2 / omzo * zo + (-0.1D1 / 0.3D1 - x1 / 0.3D1)
     # * dls / omz2 / omzo / zo + (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * 
     #rH1(0, x1) / omzo / omz2 * zo ** 2 / 0.3D1 + (-x1 / 0.2D1 + 0.3D1 
     #/ 0.2D1) * zo / omzo / omz2 * rH1(0, x1) - 0.1D1 / x1 * rH1(0, zo)
     # * zo / omzo / omz2 * rH1(0, x1) + (0.1D1 + x1) * (x1 - 0.2D1) / x
     #1 / omzo / omz2 * rH1(0, x1) / 0.2D1 - (x1 ** 2 + x1 - 0.1D1) / x1
     # * rH1(0, x1) / omzo / omz2 / zo / 0.3D1 + (-x1 / 0.2D1 + 0.1D1 / 
     #0.2D1) * dla / omz2 / omzo + (x1 / 0.2D1 - 0.1D1 / 0.2D1) * dls / 
     #omz2 / omzo + (0.19D2 * x1 ** 2 - 0.44D2 * x1 - 0.4D1) / x1 / omzo
     # / omz2 * zo ** 2 / 0.18D2 + (x1 / 0.3D1 - 0.2D1 / 0.3D1) * rH1(1,
     # zo) / omzo / omz2 * zo ** 2 + (-x1 / 0.3D1 + 0.2D1 / 0.3D1) * rH1
     #(0, zo) / omzo / omz2 * zo ** 2 + (x1 / 0.3D1 - 0.2D1 / 0.3D1) * r
     #H1(1, x1) / omzo / omz2 * zo ** 2 - (0.19D2 * x1 ** 2 - 0.74D2 * x
     #1 - 0.3D1) / x1 * zo / omzo / omz2 / 0.12D2 + (-x1 / 0.2D1 + 0.3D1
     # / 0.2D1) * rH1(1, zo) * zo / omzo / omz2 + (x1 / 0.2D1 - 0.3D1 / 
     #0.2D1) * rH1(0, zo) * zo / omzo / omz2 + (-x1 / 0.2D1 + 0.3D1 / 0.
     #2D1) * rH1(1, x1) * zo / omzo / omz2 + 0.1D1 / x1 * rH1(0, zo) ** 
     #2 * zo / omzo / omz2 / 0.2D1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz
     #o / omz2 * rH1(0, zo) - (0.29D2 * x1 ** 2 + 0.2D1 * x1 + 0.19D2) /
     # x1 / omzo / omz2 / zo / 0.36D2 + (-0.1D1 / 0.3D1 - x1 / 0.3D1) * 
     #rH1(1, zo) / omzo / omz2 / zo - 0.1D1 / x1 * rH1(0, zo) / omzo / o
     #mz2 / zo / 0.3D1 + (-0.1D1 / 0.3D1 - x1 / 0.3D1) * rH1(1, x1) / om
     #zo / omz2 / zo + rH1(0, zo) * dla / omz2 / omzo - rH1(0, zo) * dls
     # / omz2 / omzo - rH1(0, zo) / omz2 / omzo * rH1(0, x1) - rH1(1, x1
     #) / omz2 / omzo * rH1(0, zo) - d0x1 * dla / omz2 / omzo / 0.2D1 + 
     #d0x1 * dls / omz2 / omzo / 0.2D1 - d0x1 / omz2 / omzo * pi ** 2 / 
     #0.6D1 + d0x1 * dla / omz2 / omzo * zo / 0.2D1 - 0.2D1 / 0.3D1 * d0
     #x1 * dla / omz2 / omzo / zo - 0.2D1 / 0.3D1 * d0x1 * dls / omz2 / 
     #omzo * zo ** 2 - d0x1 * dls / omz2 / omzo * zo / 0.2D1 + rH1(0, zo
     #) * d0x1 * dls / omz2 / omzo + 0.2D1 / 0.3D1 * d0x1 * dls / omz2 /
     # omzo / zo - d0x1 / omz2 / omzo * pi ** 2 * zo / 0.6D1 - 0.2D1 / 0
     #.3D1 * rH1(1, zo) * d0x1 / omz2 / omzo * zo ** 2 + 0.2D1 / 0.3D1 *
     # rH1(0, zo) * d0x1 / omz2 / omzo * zo ** 2 - rH1(1, zo) * d0x1 / o
     #mz2 / omzo * zo / 0.2D1 + rH2(0, 1, zo) * d0x1 / omz2 / omzo * zo 
     #+ rH1(0, zo) * d0x1 / omz2 / omzo * zo + 0.2D1 / 0.3D1 * rH1(1, zo
     #) * d0x1 / omz2 / omzo / zo + 0.2D1 / 0.3D1 * rH1(0, zo) * d0x1 / 
     #omz2 / omzo / zo - rH1(0, zo) * d0x1 * dla / omz2 / omzo + rH1(0, 
     #zo) * d0x1 * dls / omz2 / omzo * zo - rH1(0, zo) * d1x1 / omz2 / o
     #mzo * zo - rH1(0, zo) * d0x1 * dla / omz2 / omzo * zo + 0.1D1 / om
     #zo / omz2 * pi ** 2 / 0.6D1 + 0.2D1 / 0.3D1 * d0x1 * dla / omz2 / 
     #omzo * zo ** 2 - 0.17D2 / 0.6D1 * d0x1 / omz2 / omzo * zo ** 2 + 0
     #.8D1 / 0.3D1 * d0x1 / omz2 / omzo * zo + 0.11D2 / 0.6D1 * d0x1 / o
     #mz2 / omzo / zo - rH1(0, zo) * d1x1 / omz2 / omzo + 0.1D1 / omzo /
     # omz2 * rH1(0, zo) ** 2 / 0.2D1 - d1x1 / omz2 / omzo / 0.2D1 - 0.5
     #D1 / 0.3D1 * d0x1 / omz2 / omzo + rH1(1, zo) * d0x1 / omz2 / omzo 
     #/ 0.2D1 + rH2(0, 1, zo) * d0x1 / omz2 / omzo + 0.2D1 / 0.3D1 * d1x
     #1 / omz2 / omzo * zo ** 2 + d1x1 / omz2 / omzo * zo / 0.2D1 - 0.2D
     #1 / 0.3D1 * d1x1 / omz2 / omzo / zo
      endif

      if(ieorder.eq.-2)then
        rJ22hQGIFqgam_frag=e2
      elseif(ieorder.eq.-1)then
        rJ22hQGIFqgam_frag=e1
      elseif(ieorder.eq.0)then
        rJ22hQGIFqgam_frag=e0
      endif

*      write(*,*)" rJ22hQGIFqgam_frag ",rJ22hQGIFqgam_frag

      return
      end
