************************************************************************
*
      function rJ21QQFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = 0.1D1 / omz1 / omz2 / omzo * dls + 0.3D1 / 0.2D1 / omz1 / o
     #mz2 / omzo
      e0 = -0.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d0
     #z * dls + 0.3D1 / 0.4D1 / omz1 / omz2 * d0z - 0.1D1 / omz1 / omz2 
     #* d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.3D1 / 0.
     #4D1 / omz1 / omz2 / omzo * dla + 0.1D1 / omz1 / omz2 / omzo * dls 
     #** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dls + 0.3
     #D1 / 0.4D1 / omz1 / omz2 / omzo * dls + 0.7D1 / 0.4D1 / omz1 / omz
     #2 / omzo + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo * rH1(1, zo) + 0.1D1
     # / omz1 / omz2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / om
     #zo / 0.4D1
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 + 0.1D1 / omz / omz1 / omz2 - z / omz 
     #/ omz1 / omz2
      e0 = 0.1D1 / omz1 / omz2 * d0z * dla - 0.1D1 / omz1 / omz2 * d0z
     # * dls - 0.3D1 / 0.4D1 / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2 *
     # d1z - dla / omz1 / omz2 / 0.2D1 - z * dla / omz1 / omz2 / 0.2D1 -
     # dls / omz1 / omz2 / 0.2D1 + z * dls / omz1 / omz2 / 0.2D1 + dls /
     # omz / omz1 / omz2 - z * dls / omz / omz1 / omz2 - z / omz1 / omz2
     # / 0.2D1 - z / omz1 / omz2 * rH1(0, z) + rH1(1, z) * z / omz1 / om
     #z2 / 0.2D1 + 0.1D1 / omz1 / omz2 / 0.2D1 + rH1(0, z) / omz1 / omz2
     # - rH1(1, z) / omz1 / omz2 / 0.2D1 + 0.1D1 / omz / omz1 / omz2 * z
     # ** 2 / 0.4D1 - z / omz / omz1 / omz2 + 0.2D1 * rH1(0, z) * z / om
     #z / omz1 / omz2 - rH1(1, z) * z / omz / omz1 / omz2 + 0.3D1 / 0.4D
     #1 / omz / omz1 / omz2 + rH1(1, z) / omz / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21QQFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21QQFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21QQFF_hfrag=e0
      endif

*      write(*,*)" rJ21QQFF_hfrag ",rJ21QQFF_hfrag

      return
      end
************************************************************************
*
      function rJ21hQQFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hQQFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z


      if(ieorder.eq.-2)then
        rJ21hQQFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21hQQFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21hQQFF_hfrag=e0
      endif

*      write(*,*)" rJ21hQQFF_hfrag ",rJ21hQQFF_hfrag

      return
      end
************************************************************************
*
      function rJ21QGFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = 0.1D1 / omz1 / omz2 / omzo * dls + 0.5D1 / 0.3D1 / omz1 / o
     #mz2 / omzo
      e0 = -0.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d0
     #z * dls + 0.11D2 / 0.12D2 / omz1 / omz2 * d0z - 0.1D1 / omz1 / omz
     #2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.3D1 / 
     #0.4D1 / omz1 / omz2 / omzo * dla + 0.1D1 / omz1 / omz2 / omzo * dl
     #s ** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dls + 0
     #.11D2 / 0.12D2 / omz1 / omz2 / omzo * dls + 0.67D2 / 0.36D2 / omz1
     # / omz2 / omzo + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * rH1(1, zo)
     # + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / o
     #mz2 / omzo / 0.4D1
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z * dla - 0.1D1 / omz1 / omz2 * d0z
     # * dls - 0.11D2 / 0.12D2 / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2
     # * d1z - dla / omz1 / omz2 / 0.2D1 - z * dla / omz1 / omz2 / 0.2D1
     # + dls / omz1 / omz2 / 0.2D1 + z * dls / omz1 / omz2 / 0.2D1 + 0.1
     #D1 / omz1 / omz2 * z ** 2 / 0.6D1 + 0.5D1 / 0.12D2 * z / omz1 / om
     #z2 - z / omz1 / omz2 * rH1(0, z) + rH1(1, z) * z / omz1 / omz2 / 0
     #.2D1 + 0.17D2 / 0.12D2 / omz1 / omz2 - rH1(0, z) / omz1 / omz2 + r
     #H1(1, z) / omz1 / omz2 / 0.2D1 + 0.2D1 * rH1(0, z) / omz1 / omz2 /
     # omz
      endif

      if(ieorder.eq.-2)then
        rJ21QGFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21QGFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21QGFF_hfrag=e0
      endif

*      write(*,*)" rJ21QGFF_hfrag ",rJ21QGFF_hfrag

      return
      end
************************************************************************
*
      function rJ21hQGFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hQGFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / omzo / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 * d0z / 0.6D1 - 0.1D1 / omz1 / omz2 / 
     #omzo * dls / 0.6D1 - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) / 0.6
     #D1 - 0.5D1 / 0.18D2 / omz1 / omz2 / omzo
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z / 0.6D1 - 0.1D1 / omz1 / omz2 / 0
     #.6D1 - z / omz1 / omz2 / 0.6D1 + 0.1D1 / omz1 / omz2 * z ** 2 / 0.
     #12D2
      endif

      if(ieorder.eq.-2)then
        rJ21hQGFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21hQGFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21hQGFF_hfrag=e0
      endif

*      write(*,*)" rJ21hQGFF_hfrag ",rJ21hQGFF_hfrag

      return
      end
************************************************************************
*
      function rJ21GQFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = 0.1D1 / omz1 / omz2 / omzo * dls + 0.5D1 / 0.3D1 / omz1 / o
     #mz2 / omzo
      e0 = -0.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d0
     #z * dls + 0.3D1 / 0.4D1 / omz1 / omz2 * d0z - 0.1D1 / omz1 / omz2 
     #* d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.11D2 / 0
     #.12D2 / omz1 / omz2 / omzo * dla + 0.1D1 / omz1 / omz2 / omzo * dl
     #s ** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dls + 0
     #.3D1 / 0.4D1 / omz1 / omz2 / omzo * dls + 0.7D1 / 0.4D1 / omz1 / o
     #mz2 / omzo + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, zo) + 0.3D1 / 
     #0.4D1 / omz1 / omz2 / omzo * rH1(1, zo) - pi ** 2 / omz1 / omz2 / 
     #omzo / 0.4D1
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z * dla - 0.1D1 / omz1 / omz2 * d0z
     # * dls - 0.3D1 / 0.4D1 / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2 *
     # d1z - dla / omz1 / omz2 * z ** 2 + z * dla / omz1 / omz2 - 0.2D1 
     #* dla / omz1 / omz2 + dla / omz1 / omz2 / z + dls / omz1 / omz2 * 
     #z ** 2 - z * dls / omz1 / omz2 + 0.2D1 * dls / omz1 / omz2 - dls /
     # omz1 / omz2 / z - 0.2D1 * rH1(0, z) / omz1 / omz2 * z ** 2 + rH1(
     #1, z) / omz1 / omz2 * z ** 2 + 0.9D1 / 0.4D1 * z / omz1 / omz2 + 0
     #.2D1 * z / omz1 / omz2 * rH1(0, z) - rH1(1, z) * z / omz1 / omz2 +
     # 0.3D1 / 0.4D1 / omz1 / omz2 - 0.4D1 * rH1(0, z) / omz1 / omz2 + 0
     #.2D1 * rH1(1, z) / omz1 / omz2 + 0.2D1 * rH1(0, z) / omz1 / omz2 /
     # z - rH1(1, z) / omz1 / omz2 / z + 0.2D1 * rH1(0, z) / omz1 / omz2
     # / omz
      endif

      if(ieorder.eq.-2)then
        rJ21GQFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21GQFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21GQFF_hfrag=e0
      endif

*      write(*,*)" rJ21GQFF_hfrag ",rJ21GQFF_hfrag

      return
      end
************************************************************************
*
      function rJ21hGQFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGQFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / omzo / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 / omzo * dla / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGQFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21hGQFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21hGQFF_hfrag=e0
      endif

*      write(*,*)" rJ21hGQFF_hfrag ",rJ21hGQFF_hfrag

      return
      end
************************************************************************
*
      function rJ21GGFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = 0.1D1 / omz1 / omz2 / omzo * dls + 0.11D2 / 0.6D1 / omz1 / 
     #omz2 / omzo
      e0 = -0.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * d0
     #z * dls + 0.11D2 / 0.12D2 / omz1 / omz2 * d0z - 0.1D1 / omz1 / omz
     #2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.11D2 /
     # 0.12D2 / omz1 / omz2 / omzo * dla + 0.1D1 / omz1 / omz2 / omzo * 
     #dls ** 2 / 0.2D1 + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dls +
     # 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * dls + 0.67D2 / 0.36D2 / om
     #z1 / omz2 / omzo + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * rH1(1, z
     #o) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 /
     # omz2 / omzo / 0.4D1
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z * dla - 0.1D1 / omz1 / omz2 * d0z
     # * dls - 0.11D2 / 0.12D2 / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2
     # * d1z - dla / omz1 / omz2 * z ** 2 + dla / omz1 / omz2 * z - 0.2D
     #1 * dla / omz1 / omz2 + dla / omz1 / omz2 / z + dls / omz1 / omz2 
     #* z ** 2 - dls / omz1 / omz2 * z + 0.2D1 * dls / omz1 / omz2 - dls
     # / omz1 / omz2 / z + 0.11D2 / 0.12D2 / omz1 / omz2 * z ** 2 - 0.2D
     #1 * rH1(0, z) / omz1 / omz2 * z ** 2 + rH1(1, z) / omz1 / omz2 * z
     # ** 2 + 0.11D2 / 0.12D2 / omz1 / omz2 * z + 0.2D1 * rH1(0, z) / om
     #z1 / omz2 * z - rH1(1, z) / omz1 / omz2 * z + 0.11D2 / 0.12D2 / om
     #z1 / omz2 - 0.4D1 / omz1 / omz2 * rH1(0, z) + 0.2D1 * rH1(1, z) / 
     #omz1 / omz2 + 0.2D1 * rH1(0, z) / omz1 / omz2 / z - rH1(1, z) / om
     #z1 / omz2 / z + 0.2D1 / omz1 / omz2 * rH1(0, z) / omz
      endif

      if(ieorder.eq.-2)then
        rJ21GGFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21GGFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21GGFF_hfrag=e0
      endif

*      write(*,*)" rJ21GGFF_hfrag ",rJ21GGFF_hfrag

      return
      end
************************************************************************
*
      function rJ21hGGFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGGFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / omzo / 0.3D1
      e0 = -0.1D1 / omz1 / omz2 * d0z / 0.6D1 - 0.1D1 / omz1 / omz2 / 
     #omzo * dla / 0.6D1 - 0.1D1 / omz1 / omz2 / omzo * dls / 0.6D1 - 0.
     #1D1 / omz1 / omz2 / omzo * rH1(1, zo) / 0.6D1 - 0.5D1 / 0.18D2 / o
     #mz1 / omz2 / omzo
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * d0z / 0.6D1 - 0.1D1 / omz1 / omz2 / 0
     #.6D1 - 0.1D1 / omz1 / omz2 * z / 0.6D1 - 0.1D1 / omz1 / omz2 * z *
     #* 2 / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21hGGFF_hfrag=e0
      endif

*      write(*,*)" rJ21hGGFF_hfrag ",rJ21hGGFF_hfrag

      return
      end
************************************************************************
*
      function rJ21QQgtoqFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQgtoqFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 * z / 0.2D1 - dla / omz1 / omz2 + dla / o
     #mz1 / omz2 / z - dls / omz1 / omz2 * z / 0.2D1 + dls / omz1 / omz2
     # - dls / omz1 / omz2 / z + rH1(0, z) / omz1 / omz2 * z - rH1(1, z)
     # / omz1 / omz2 * z / 0.2D1 - 0.2D1 / omz1 / omz2 * rH1(0, z) + rH1
     #(1, z) / omz1 / omz2 + 0.2D1 * rH1(0, z) / omz1 / omz2 / z - rH1(1
     #, z) / omz1 / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QQgtoqFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21QQgtoqFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21QQgtoqFF_hfrag=e0
      endif

*      write(*,*)" rJ21QQgtoqFF_hfrag ",rJ21QQgtoqFF_hfrag

      return
      end
************************************************************************
*
      function rJ21QGgtoqFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGgtoqFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 * z / 0.2D1 - dla / omz1 / omz2 + dla / o
     #mz1 / omz2 / z - dls / omz1 / omz2 * z / 0.2D1 + dls / omz1 / omz2
     # - dls / omz1 / omz2 / z + 0.3D1 / 0.4D1 / omz1 / omz2 * z ** 2 - 
     #0.1D1 / omz1 / omz2 * z + rH1(0, z) / omz1 / omz2 * z - rH1(1, z) 
     #/ omz1 / omz2 * z / 0.2D1 - 0.2D1 * rH1(0, z) / omz1 / omz2 + rH1(
     #1, z) / omz1 / omz2 + 0.2D1 * rH1(0, z) / omz1 / omz2 / z - rH1(1,
     # z) / omz1 / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QGgtoqFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21QGgtoqFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21QGgtoqFF_hfrag=e0
      endif

*      write(*,*)" rJ21QGgtoqFF_hfrag ",rJ21QGgtoqFF_hfrag

      return
      end
************************************************************************
*
      function rJ21GQqtogFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQqtogFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 * z + z ** 2 
     #* dla / omz1 / omz2 - dls / omz1 / omz2 / 0.2D1 + dls / omz1 / omz
     #2 * z - z ** 2 * dls / omz1 / omz2 - 0.2D1 / omz1 / omz2 * z ** 2 
     #+ 0.2D1 * rH1(0, z) / omz1 / omz2 * z ** 2 - rH1(1, z) / omz1 / om
     #z2 * z ** 2 + 0.3D1 / 0.2D1 / omz1 / omz2 * z - 0.2D1 * rH1(0, z) 
     #/ omz1 / omz2 * z + rH1(1, z) / omz1 / omz2 * z + rH1(0, z) / omz1
     # / omz2 - rH1(1, z) / omz1 / omz2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GQqtogFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21GQqtogFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21GQqtogFF_hfrag=e0
      endif

*      write(*,*)" rJ21GQqtogFF_hfrag ",rJ21GQqtogFF_hfrag

      return
      end
************************************************************************
*
      function rJ21GGqtogFF_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGqtogFF_hfrag: only imethod=2!' 
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = dla / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 * z + z ** 2 
     #* dla / omz1 / omz2 - dls / omz1 / omz2 / 0.2D1 + dls / omz1 / omz
     #2 * z - z ** 2 * dls / omz1 / omz2 - 0.7D1 / 0.4D1 / omz1 / omz2 *
     # z ** 2 + 0.2D1 * rH1(0, z) / omz1 / omz2 * z ** 2 - rH1(1, z) / o
     #mz1 / omz2 * z ** 2 + 0.1D1 / omz1 / omz2 * z - 0.2D1 * rH1(0, z) 
     #/ omz1 / omz2 * z + rH1(1, z) / omz1 / omz2 * z + rH1(0, z) / omz1
     # / omz2 - rH1(1, z) / omz1 / omz2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GGqtogFF_hfrag=e2
      elseif(ieorder.eq.-1)then
        rJ21GGqtogFF_hfrag=e1
      elseif(ieorder.eq.0)then
        rJ21GGqtogFF_hfrag=e0
      endif

*      write(*,*)" rJ21GGqtogFF_hfrag ",rJ21GGqtogFF_hfrag

      return
      end
