************************************************************************
*
      function rJ21QQFIqg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFIqg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QQFIqg_hfrag=rJ21QQIFqg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 * z / 0.2D1 + d0x2 / omz1 - d0x2 / omz1 / z + 
     #dla / omz1 / omz2 * z / 0.2D1 - dla / omz1 / omz2 + dla / omz1 / o
     #mz2 / z - dls / omz1 / omz2 * z / 0.2D1 + dls / omz1 / omz2 - dls 
     #/ omz1 / omz2 / z + z / omz1 / omz2 / 0.2D1 + rH1(0, z) * z / omz1
     # / omz2 / 0.2D1 - rH1(1, z) * z / omz1 / omz2 / 0.2D1 - rH1(1, z2)
     # * z / omz1 / omz2 / 0.2D1 - rH1(0, z) / omz1 / omz2 + rH1(1, z) /
     # omz1 / omz2 + rH1(1, z2) / omz1 / omz2 + rH1(0, z) / omz1 / omz2 
     #/ z - rH1(1, z) / omz1 / omz2 / z - rH1(1, z2) / omz1 / omz2 / z
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 * z / 0.2D1 - d0x2 / omz1 + d0x2 / omz1 / z + 0
     #.1D1 / omz1 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) / omz1 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QQFIqg_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21QQFIqg_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21QQFIqg_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21QQFIqg_hfrag ",rJ21QQFIqg_hfrag

      return
      end
************************************************************************
*
      function rJ21QQFIqq_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQFIqq_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QQFIqq_hfrag=rJ21QQIFqq_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.3D1 / 0.2D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x2 / omz1 - 0.1D1 / omz1 / omzo * d0x2 * dlm + 0.1D
     #1 / omz1 / omzo * rH1(1, zo) * d0x2 + dls / omz1 / omzo * d0x2 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + dls / omz1 / omz2 * d0z + rH1(1, 
     #z2) / omz1 / omz2 * d0z - 0.1D1 / omz1 / omzo * d1x2 - 0.1D1 / omz
     #1 / omz2 * d1z - rH1(1, zo) / omz1 / omz2 / omzo * dla + 0.3D1 / 0
     #.4D1 * dla / omz1 / omz2 / omzo - rH1(1, z2) / omz1 / omz2 / omzo 
     #* dlm + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo * dlm + 0.1D1 / omz1 / 
     #omz2 / omzo * dls ** 2 / 0.2D1 + rH1(1, z2) / omz1 / omz2 / omzo *
     # dls + dls / omz1 / omz2 / omzo * rH1(1, zo) + rH1(1, zo) / omz1 /
     # omz2 / omzo * rH1(1, z2) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1,
     # z2) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1
     # / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.2.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + 0.1D1 / omz1 / omzo * d0x2 * dlm - 0.1
     #D1 / omz1 / omzo * rH1(1, zo) * d0x2 - dls / omz1 / omzo * d0x2 + 
     #(0.1D1 / 0.2D1 + x2 / 0.2D1) * d0z / omz1 + 0.1D1 / omz1 / omzo * 
     #d1x2 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) / omz1 / omzo * dlm + (0.1D1 
     #/ 0.2D1 + x2 / 0.2D1) / omz1 / omzo * dls + (0.1D1 / 0.2D1 + x2 / 
     #0.2D1) / omz1 / omzo * rH1(0, x2) + (0.1D1 / 0.2D1 + x2 / 0.2D1) *
     # rH1(1, x2) / omzo / omz1 + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 / 
     #omzo * rH1(1, zo) + (-x2 / 0.2D1 + 0.1D1 / 0.2D1) / omz1 / omzo - 
     #0.1D1 / omz1 / omzo * rH1(0, x2) / omx2
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + d0x2 / omz1 / 0.2D1 + d0x2 / omz1 * z 
     #/ 0.2D1 + 0.1D1 / omz1 / omz2 * d0z * dla - dls / omz1 / omz2 * d0
     #z - rH1(1, z2) / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2 * d1z - d
     #la / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 * z / 0.2D1 + dls / o
     #mz1 / omz2 / 0.2D1 + dls / omz1 / omz2 * z / 0.2D1 - z / omz1 / om
     #z2 / 0.2D1 - rH1(0, z) * z / omz1 / omz2 / 0.2D1 + rH1(1, z) * z /
     # omz1 / omz2 / 0.2D1 + rH1(1, z2) * z / omz1 / omz2 / 0.2D1 + 0.1D
     #1 / omz1 / omz2 / 0.2D1 - rH1(0, z) / omz1 / omz2 / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 / 0.2D1 + rH1(1, z2) / omz1 / omz2 / 0.2D1 + rH1
     #(0, z) / omz1 / omz2 / omz
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x2 / omz1 - d0x2 / omz1 / 0.2D1 - d0x2 / omz1 * z /
     # 0.2D1 + 0.1D1 / omz1 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) * d0z / omz1
      endif

      if(ieorder.eq.-2)then
        rJ21QQFIqq_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21QQFIqq_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21QQFIqq_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21QQFIqq_hfrag ",rJ21QQFIqq_hfrag

      return
      end
************************************************************************
*
      function rJ21GQFIqg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQFIqg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GQFIqg_hfrag=rJ21QGIFqg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x2 / omz1 - 0.1D1 / omz1 / omzo * d0x2 * dlm + 0.1D
     #1 / omz1 / omzo * rH1(1, zo) * d0x2 + dls / omz1 / omzo * d0x2 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + dls / omz1 / omz2 * d0z + rH1(1, 
     #z2) / omz1 / omz2 * d0z - 0.1D1 / omz1 / omzo * d1x2 - 0.1D1 / omz
     #1 / omz2 * d1z - rH1(1, zo) / omz1 / omz2 / omzo * dla + 0.11D2 / 
     #0.12D2 * dla / omz1 / omz2 / omzo - rH1(1, z2) / omz1 / omz2 / omz
     #o * dlm + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo * dlm + 0.1D1 / omz1 
     #/ omz2 / omzo * dls ** 2 / 0.2D1 + rH1(1, z2) / omz1 / omz2 / omzo
     # * dls + dls / omz1 / omz2 / omzo * rH1(1, zo) + rH1(1, zo) / omz1
     # / omz2 / omzo * rH1(1, z2) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 
     #1, z2) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, zo) - pi ** 2 / om
     #z1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.2.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + 0.1D1 / omz1 / omzo * d0x2 * dlm - 0.1
     #D1 / omz1 / omzo * rH1(1, zo) * d0x2 - dls / omz1 / omzo * d0x2 + 
     #(0.1D1 / 0.2D1 + x2 / 0.2D1) * d0z / omz1 + 0.1D1 / omz1 / omzo * 
     #d1x2 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) / omz1 / omzo * dlm + (0.1D1 
     #/ 0.2D1 + x2 / 0.2D1) / omz1 / omzo * dls + (0.1D1 / 0.2D1 + x2 / 
     #0.2D1) / omz1 / omzo * rH1(0, x2) + (0.1D1 / 0.2D1 + x2 / 0.2D1) *
     # rH1(1, x2) / omzo / omz1 + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 / 
     #omzo * rH1(1, zo) + (-x2 / 0.2D1 + 0.1D1 / 0.2D1) / omz1 / omzo - 
     #0.1D1 / omz1 / omzo * rH1(0, x2) / omx2
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = rH1(1, z) / omz1 / omz2 * z ** 2 + rH1(1, z2) / omz1 / omz2
     # * z ** 2 + d0x2 / omz1 * z ** 2 + rH1(0, z) / omz1 / omz2 / omz -
     # rH1(0, z) / omz1 / omz2 * z ** 2 + dls / omz1 / omz2 * z ** 2 - d
     #la / omz1 / omz2 * z ** 2 - dls / omz1 / omz2 * d0z - rH1(1, z2) /
     # omz1 / omz2 * d0z - d0z * d0x2 / omz1 + 0.1D1 / omz1 / omz2 * d0z
     # * dla - 0.2D1 * rH1(0, z) / omz1 / omz2 - d0x2 / omz1 * z - d0x2 
     #/ omz1 / z - 0.2D1 * dla / omz1 / omz2 + 0.2D1 * dls / omz1 / omz2
     # + 0.1D1 / omz1 / omz2 * d1z + rH1(0, z) / omz1 / omz2 / z + 0.2D1
     # * d0x2 / omz1 + dla / omz1 / omz2 * z + dla / omz1 / omz2 / z - d
     #ls / omz1 / omz2 * z - dls / omz1 / omz2 / z + rH1(0, z) * z / omz
     #1 / omz2 - rH1(1, z) * z / omz1 / omz2 - rH1(1, z2) * z / omz1 / o
     #mz2 + 0.2D1 * rH1(1, z) / omz1 / omz2 + 0.2D1 * rH1(1, z2) / omz1 
     #/ omz2 - rH1(1, z) / omz1 / omz2 / z - rH1(1, z2) / omz1 / omz2 / 
     #z
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x2 / omz1 - d0x2 / omz1 * z ** 2 + d0x2 / omz1 * z 
     #- 0.2D1 * d0x2 / omz1 + d0x2 / omz1 / z + (-0.1D1 / 0.2D1 - x2 / 0
     #.2D1) * d0z / omz1 - 0.1D1 / x2 / omz1 * z ** 2 + 0.1D1 / x2 * z /
     # omz1 - 0.1D1 / x2 / omz1 / 0.2D1 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) 
     #/ omz1 / z
      endif

      if(ieorder.eq.-2)then
        rJ21GQFIqg_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21GQFIqg_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21GQFIqg_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21GQFIqg_hfrag ",rJ21GQFIqg_hfrag

      return
      end
************************************************************************
*
      function rJ21QGFIgq_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGFIgq_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QGFIgq_hfrag=rJ21GQIFgq_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x2 / omz1 - 0.1D1 / omz1 / omzo * d0x2 * dlm + 0.1D
     #1 / omz1 / omzo * rH1(1, zo) * d0x2 + dls / omz1 / omzo * d0x2 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + dls / omz1 / omz2 * d0z + rH1(1, 
     #z2) / omz1 / omz2 * d0z - 0.1D1 / omz1 / omzo * d1x2 - 0.1D1 / omz
     #1 / omz2 * d1z - rH1(1, zo) / omz1 / omz2 / omzo * dla + 0.3D1 / 0
     #.4D1 * dla / omz1 / omz2 / omzo - rH1(1, z2) / omz1 / omz2 / omzo 
     #* dlm + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * dlm + 0.1D1 / omz1 
     #/ omz2 / omzo * dls ** 2 / 0.2D1 + rH1(1, z2) / omz1 / omz2 / omzo
     # * dls + dls / omz1 / omz2 / omzo * rH1(1, zo) + rH1(1, zo) / omz1
     # / omz2 / omzo * rH1(1, z2) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 
     #1, z2) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, zo) - pi ** 2 / om
     #z1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.2.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + 0.1D1 / omz1 / omzo * d0x2 * dlm - 0.1
     #D1 / omz1 / omzo * rH1(1, zo) * d0x2 - dls / omz1 / omzo * d0x2 + 
     #(x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * d0z / omz1 + 0.1D1
     # / omz1 / omzo * d1x2 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) /
     # x2 / omz1 / omzo * dlm + dls * (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 
     #0.1D1) / x2 / omz1 / omzo + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D
     #1) / x2 / omz1 / omzo * rH1(0, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * 
     #x2 - 0.1D1) / x2 / omz1 / omzo * rH1(1, x2) + (x2 ** 3 - x2 ** 2 +
     # 0.2D1 * x2 - 0.1D1) / x2 / omz1 / omzo * rH1(1, zo) - 0.1D1 / omz
     #1 / omzo * rH1(0, x2) / omx2
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + d0x2 / omz1 / 0.2D1 + d0x2 / omz1 * z 
     #/ 0.2D1 + 0.1D1 / omz1 / omz2 * d0z * dla - dls / omz1 / omz2 * d0
     #z - rH1(1, z2) / omz1 / omz2 * d0z + 0.1D1 / omz1 / omz2 * d1z - d
     #la / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 * z / 0.2D1 + dls / o
     #mz1 / omz2 / 0.2D1 + dls / omz1 / omz2 * z / 0.2D1 - z / omz1 / om
     #z2 / 0.2D1 - rH1(0, z) * z / omz1 / omz2 / 0.2D1 + rH1(1, z) * z /
     # omz1 / omz2 / 0.2D1 + rH1(1, z2) * z / omz1 / omz2 / 0.2D1 + 0.1D
     #1 / omz1 / omz2 / 0.2D1 - rH1(0, z) / omz1 / omz2 / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 / 0.2D1 + rH1(1, z2) / omz1 / omz2 / 0.2D1 + rH1
     #(0, z) / omz1 / omz2 / omz
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x2 / omz1 - d0x2 / omz1 / 0.2D1 - d0x2 / omz1 * z /
     # 0.2D1 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * d0z / omz
     #1 - 0.3D1 / 0.2D1 / omz1
      endif

      if(ieorder.eq.-2)then
        rJ21QGFIgq_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21QGFIgq_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21QGFIgq_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21QGFIgq_hfrag ",rJ21QGFIgq_hfrag

      return
      end
************************************************************************
*
      function rJ21QGFIgg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGFIgg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QGFIgg_hfrag=rJ21GQIFgg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 * z / 0.2D1 + d0x2 / omz1 - d0x2 / omz1 / z + 
     #dla / omz1 / omz2 * z / 0.2D1 - dla / omz1 / omz2 + dla / omz1 / o
     #mz2 / z - dls / omz1 / omz2 * z / 0.2D1 + dls / omz1 / omz2 - dls 
     #/ omz1 / omz2 / z + z / omz1 / omz2 / 0.2D1 + rH1(0, z) * z / omz1
     # / omz2 / 0.2D1 - rH1(1, z) * z / omz1 / omz2 / 0.2D1 - rH1(1, z2)
     # * z / omz1 / omz2 / 0.2D1 - rH1(0, z) / omz1 / omz2 + rH1(1, z) /
     # omz1 / omz2 + rH1(1, z2) / omz1 / omz2 + rH1(0, z) / omz1 / omz2 
     #/ z - rH1(1, z) / omz1 / omz2 / z - rH1(1, z2) / omz1 / omz2 / z
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 * z / 0.2D1 - d0x2 / omz1 + d0x2 / omz1 / z - 0
     #.3D1 / 0.2D1 / omz1 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x
     #2 / omz1 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QGFIgg_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21QGFIgg_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21QGFIgg_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21QGFIgg_hfrag ",rJ21QGFIgg_hfrag

      return
      end
************************************************************************
*
      function rJ21GGFIgg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGFIgg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GGFIgg_hfrag=rJ21GGIFgg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.11D2 / 0.6D1 / omz1 / omz2 / o
     #mzo
      e0 = d0z * d0x2 / omz1 - 0.1D1 / omz1 / omzo * d0x2 * dlm + 0.1D
     #1 / omz1 / omzo * rH1(1, zo) * d0x2 + dls / omz1 / omzo * d0x2 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + rH1(1, z2) / omz1 / omz2 * d0z + 
     #dls / omz1 / omz2 * d0z - 0.1D1 / omz1 / omzo * d1x2 - 0.1D1 / omz
     #1 / omz2 * d1z - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0
     #.11D2 / 0.12D2 / omz1 / omz2 / omzo * dla - 0.1D1 / omz1 / omz2 / 
     #omzo * rH1(1, z2) * dlm + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * d
     #lm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 / omz1 
     #/ omz2 / omzo * rH1(1, z2) * dls + dls / omz1 / omz2 / omzo * rH1(
     #1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z2) + 0.
     #1D1 / omz1 / omz2 / omzo * rH2(1, 1, z2) + 0.1D1 / omz1 / omz2 / o
     #mzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.2.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x2 / omz1 + 0.1D1 / omz1 / omzo * d0x2 * dlm - 0.1
     #D1 / omz1 / omzo * rH1(1, zo) * d0x2 - dls / omz1 / omzo * d0x2 + 
     #(x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * d0z / omz1 + 0.1D1
     # / omz1 / omzo * d1x2 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) /
     # x2 / omz1 / omzo * dlm + dls * (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 
     #0.1D1) / x2 / omz1 / omzo + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D
     #1) / x2 / omz1 / omzo * rH1(0, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * 
     #x2 - 0.1D1) / x2 / omz1 / omzo * rH1(1, x2) + (x2 ** 3 - x2 ** 2 +
     # 0.2D1 * x2 - 0.1D1) / x2 / omz1 / omzo * rH1(1, zo) - 0.1D1 / omz
     #1 / omzo * rH1(0, x2) / omx2
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = rH1(0, z) / omz1 / omz2 / omz + rH1(1, z) / omz1 / omz2 * z
     # ** 2 + rH1(1, z2) / omz1 / omz2 * z ** 2 - rH1(1, z2) / omz1 / om
     #z2 * d0z - dls / omz1 / omz2 * d0z - d0z * d0x2 / omz1 + 0.1D1 / o
     #mz1 / omz2 * d1z + 0.1D1 / omz1 / omz2 * d0z * dla + d0x2 / omz1 *
     # z ** 2 - dla / omz1 / omz2 * z ** 2 + dls / omz1 / omz2 * z ** 2 
     #- rH1(0, z) / omz1 / omz2 * z ** 2 - d0x2 / omz1 * z + 0.2D1 * dls
     # / omz1 / omz2 + rH1(0, z) / omz1 / omz2 / z - 0.2D1 * rH1(0, z) /
     # omz1 / omz2 - 0.2D1 * dla / omz1 / omz2 - d0x2 / omz1 / z + 0.2D1
     # * d0x2 / omz1 + dla / omz1 / omz2 * z + dla / omz1 / omz2 / z - d
     #ls / omz1 / omz2 * z - dls / omz1 / omz2 / z + rH1(0, z) * z / omz
     #1 / omz2 - rH1(1, z) * z / omz1 / omz2 - rH1(1, z2) * z / omz1 / o
     #mz2 + 0.2D1 * rH1(1, z) / omz1 / omz2 + 0.2D1 * rH1(1, z2) / omz1 
     #/ omz2 - rH1(1, z) / omz1 / omz2 / z - rH1(1, z2) / omz1 / omz2 / 
     #z
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x2 / omz1 - d0x2 / omz1 * z ** 2 + d0x2 / omz1 * z 
     #- 0.2D1 * d0x2 / omz1 + d0x2 / omz1 / z - (x2 ** 3 - x2 ** 2 + 0.2
     #D1 * x2 - 0.1D1) / x2 * d0z / omz1 - 0.1D1 / x2 / omz1 * z ** 2 + 
     #0.1D1 / x2 * z / omz1 - 0.2D1 / x2 / omz1 - (x2 ** 3 - x2 ** 2 + 0
     #.2D1 * x2 - 0.1D1) / x2 / omz1 / z
      endif

      if(ieorder.eq.-2)then
        rJ21GGFIgg_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21GGFIgg_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21GGFIgg_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21GGFIgg_hfrag ",rJ21GGFIgg_hfrag

      return
      end
************************************************************************
*
      function rJ21hGGFIgq_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGGFIgq_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21hGGFIgq_hfrag=rJ21hGGIFgq_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 / 0.4D1 + d0x2 / omz1 * z / 0.2D1 - d0x2 / omz
     #1 * z ** 2 / 0.2D1 + dla / omz1 / omz2 / 0.4D1 - dla / omz1 / omz2
     # * z / 0.2D1 + dla / omz1 / omz2 * z ** 2 / 0.2D1 - dls / omz1 / o
     #mz2 / 0.4D1 + dls / omz1 / omz2 * z / 0.2D1 - dls / omz1 / omz2 * 
     #z ** 2 / 0.2D1 - 0.1D1 / omz1 / omz2 * z ** 2 / 0.2D1 + rH1(0, z) 
     #/ omz1 / omz2 * z ** 2 / 0.2D1 - rH1(1, z) / omz1 / omz2 * z ** 2 
     #/ 0.2D1 - rH1(1, z2) / omz1 / omz2 * z ** 2 / 0.2D1 + z / omz1 / o
     #mz2 / 0.2D1 - rH1(0, z) * z / omz1 / omz2 / 0.2D1 + rH1(1, z) * z 
     #/ omz1 / omz2 / 0.2D1 + rH1(1, z2) * z / omz1 / omz2 / 0.2D1 + rH1
     #(0, z) / omz1 / omz2 / 0.4D1 - rH1(1, z) / omz1 / omz2 / 0.4D1 - r
     #H1(1, z2) / omz1 / omz2 / 0.4D1
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 / 0.4D1 - d0x2 / omz1 * z / 0.2D1 + d0x2 / omz1
     # * z ** 2 / 0.2D1 + 0.1D1 / x2 / omz1 * z ** 2 / 0.2D1 - 0.1D1 / x
     #2 * z / omz1 / 0.2D1 + 0.1D1 / x2 / omz1 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGFIgq_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21hGGFIgq_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21hGGFIgq_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21hGGFIgq_hfrag ",rJ21hGGFIgq_hfrag

      return
      end
************************************************************************
*
      function rJ21hGQFIqqp_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGQFIqqp_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21hGQFIqqp_hfrag=rJ21hQGIFqqp_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x2 / omz1 / 0.4D1 + d0x2 / omz1 * z / 0.2D1 - d0x2 / omz
     #1 * z ** 2 / 0.2D1 + dla / omz1 / omz2 / 0.4D1 - dla / omz1 / omz2
     # * z / 0.2D1 + dla / omz1 / omz2 * z ** 2 / 0.2D1 - dls / omz1 / o
     #mz2 / 0.4D1 + dls / omz1 / omz2 * z / 0.2D1 - dls / omz1 / omz2 * 
     #z ** 2 / 0.2D1 - 0.1D1 / omz1 / omz2 * z ** 2 / 0.2D1 + rH1(0, z) 
     #/ omz1 / omz2 * z ** 2 / 0.2D1 - rH1(1, z) / omz1 / omz2 * z ** 2 
     #/ 0.2D1 - rH1(1, z2) / omz1 / omz2 * z ** 2 / 0.2D1 + z / omz1 / o
     #mz2 / 0.2D1 - rH1(0, z) * z / omz1 / omz2 / 0.2D1 + rH1(1, z) * z 
     #/ omz1 / omz2 / 0.2D1 + rH1(1, z2) * z / omz1 / omz2 / 0.2D1 + rH1
     #(0, z) / omz1 / omz2 / 0.4D1 - rH1(1, z) / omz1 / omz2 / 0.4D1 - r
     #H1(1, z2) / omz1 / omz2 / 0.4D1
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x2 / omz1 / 0.4D1 - d0x2 / omz1 * z / 0.2D1 + d0x2 / omz1
     # * z ** 2 / 0.2D1 + 0.1D1 / x2 / omz1 * z ** 2 / 0.2D1 - 0.1D1 / x
     #2 * z / omz1 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGQFIqqp_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21hGQFIqqp_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21hGQFIqqp_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21hGQFIqqp_hfrag ",rJ21hGQFIqqp_hfrag

      return
      end
************************************************************************
*
      function rJ21QGqtogFIqpq_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGqtogFIqpq_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21QGqtogFIqpq_hfrag=rJ21GQqtogIFqpq_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.2.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0z / omz1 / 0.2D1 +
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * dlm / 0.2D1 -
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * dls / 0.2D1 -
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * rH1(0, x2) / 
     #0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * rH1(1,
     # x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo *
     # rH1(1, zo) / 0.2D1 + x2 / omz1 / omzo / 0.2D1
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0z / omz1 / 0.2D1 + 
     #(x2 - 0.2D1) / x2 / omz1 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21QGqtogFIqpq_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21QGqtogFIqpq_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21QGqtogFIqpq_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21QGqtogFIqpq_hfrag ",rJ21QGqtogFIqpq_hfrag

      return
      end
************************************************************************
*
      function rJ21GGqtogFIqg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGqtogFIqg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ21GGqtogFIqg_hfrag=rJ21GGqtogIFqg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.2.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0z / omz1 / 0.2D1 +
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * dlm / 0.2D1 -
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * dls / 0.2D1 -
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * rH1(0, x2) / 
     #0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo * rH1(1,
     # x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / omzo *
     # rH1(1, zo) / 0.2D1 + x2 / omz1 / omzo / 0.2D1
      endif
      if(ix.eq.2.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0z / omz1 / 0.2D1 - 
     #0.1D1 / x2 * z / omz1 / 0.2D1 - 0.1D1 / x2 / omz1 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GGqtogFIqg_hfrag=e2 !* omzo !Adrian checks
      elseif(ieorder.eq.-1)then
        rJ21GGqtogFIqg_hfrag=e1 !* omzo !Adrian checks
      elseif(ieorder.eq.0)then
        rJ21GGqtogFIqg_hfrag=e0 !* omzo !Adrian checks
      endif

*      write(*,*)" rJ21GGqtogFIqg_hfrag ",rJ21GGqtogFIqg_hfrag

      return
      end
