************************************************************************
*
      function rJ21QQIFqg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQIFqg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QQIFqg_hfrag=rJ21QQFIqg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 / omz2 * z / 0.2D1 + d0x1 / omz2 - d0x1 / omz2 / z + 
     #dla / omz1 / omz2 * z / 0.2D1 - dla / omz1 / omz2 + dla / omz1 / o
     #mz2 / z - dls / omz1 / omz2 * z / 0.2D1 + dls / omz1 / omz2 - dls 
     #/ omz1 / omz2 / z + z / omz1 / omz2 / 0.2D1 + rH1(0, z) * z / omz1
     # / omz2 / 0.2D1 - rH1(1, z) * z / omz1 / omz2 / 0.2D1 - rH1(1, z1)
     # * z / omz1 / omz2 / 0.2D1 - rH1(0, z) / omz1 / omz2 + rH1(1, z) /
     # omz1 / omz2 + rH1(1, z1) / omz1 / omz2 + rH1(0, z) / omz1 / omz2 
     #/ z - rH1(1, z) / omz1 / omz2 / z - rH1(1, z1) / omz1 / omz2 / z
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x1 / omz2 * z / 0.2D1 - d0x1 / omz2 + d0x1 / omz2 / z + 0
     #.1D1 / omz2 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QQIFqg_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21QQIFqg_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21QQIFqg_hfrag=e0  
      endif

*      write(*,*)" rJ21QQIFqg_hfrag ",rJ21QQIFqg_hfrag

      return
      end
************************************************************************
*
      function rJ21QQIFqq_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QQIFqq_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QQIFqq_hfrag=rJ21QQFIqq_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.3D1 / 0.2D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x1 / omz2 - 0.1D1 / omz2 / omzo * d0x1 * dlm + dls 
     #/ omz2 / omzo * d0x1 + 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + dls / omz1 / omz2 * d0z + 0.1D1 /
     # omz1 / omz2 * rH1(1, z1) * d0z - 0.1D1 / omz2 / omzo * d1x1 - 0.1
     #D1 / omz1 / omz2 * d1z + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo * dla 
     #- 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.3D1 / 0.4D1 / 
     #omz1 / omz2 / omzo * dlm - 0.1D1 / omz1 / omz2 / omzo * rH1(1, z1)
     # * dlm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 / o
     #mz1 / omz2 / omzo * rH1(1, z1) * dls + dls / omz1 / omz2 / omzo * 
     #rH1(1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z1) 
     #+ 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, z1) + 0.1D1 / omz1 / omz2
     # / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.3.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + 0.1D1 / omz2 / omzo * d0x1 * dlm - dls
     # / omz2 / omzo * d0x1 - 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 + 
     #(0.1D1 / 0.2D1 + x1 / 0.2D1) * d0z / omz2 + 0.1D1 / omz2 / omzo * 
     #d1x1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz2 / omzo * dlm + (0.1D1 
     #/ 0.2D1 + x1 / 0.2D1) / omz2 / omzo * dls + (0.1D1 / 0.2D1 + x1 / 
     #0.2D1) / omz2 / omzo * rH1(0, x1) + (0.1D1 / 0.2D1 + x1 / 0.2D1) *
     # rH1(1, x1) / omzo / omz2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 / 
     #omzo * rH1(1, zo) + (-x1 / 0.2D1 + 0.1D1 / 0.2D1) / omz2 / omzo - 
     #0.1D1 / omz2 / omzo * rH1(0, x1) / omx1
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + d0x1 / omz2 / 0.2D1 + z * d0x1 / omz2 
     #/ 0.2D1 + 0.1D1 / omz1 / omz2 * d0z * dla - dls / omz1 / omz2 * d0
     #z - 0.1D1 / omz1 / omz2 * rH1(1, z1) * d0z + 0.1D1 / omz1 / omz2 *
     # d1z - dla / omz1 / omz2 / 0.2D1 - z * dla / omz1 / omz2 / 0.2D1 +
     # dls / omz1 / omz2 / 0.2D1 + z * dls / omz1 / omz2 / 0.2D1 - 0.1D1
     # / omz1 / omz2 * z / 0.2D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1 +
     # rH1(1, z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z1) / omz1 / omz2 * 
     #z / 0.2D1 + 0.1D1 / omz1 / omz2 / 0.2D1 - 0.1D1 / omz1 / omz2 * rH
     #1(0, z) / 0.2D1 + rH1(1, z) / omz1 / omz2 / 0.2D1 + 0.1D1 / omz1 /
     # omz2 * rH1(1, z1) / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(0, z) / omz
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x1 / omz2 - d0x1 / omz2 / 0.2D1 - z * d0x1 / omz2 /
     # 0.2D1 + 0.1D1 / omz2 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * d0z / omz2
      endif

      if(ieorder.eq.-2)then
        rJ21QQIFqq_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21QQIFqq_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21QQIFqq_hfrag=e0  
      endif

*      write(*,*)" rJ21QQIFqq_hfrag ",rJ21QQIFqq_hfrag

      return
      end
************************************************************************
*
      function rJ21QGIFqg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21QGIFqg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21QGIFqg_hfrag=rJ21GQFIqg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x1 / omz2 - 0.1D1 / omz2 / omzo * d0x1 * dlm + dls 
     #/ omz2 / omzo * d0x1 + 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + dls / omz1 / omz2 * d0z + 0.1D1 /
     # omz1 / omz2 * rH1(1, z1) * d0z - 0.1D1 / omz2 / omzo * d1x1 - 0.1
     #D1 / omz1 / omz2 * d1z + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * dl
     #a - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.3D1 / 0.4D1 
     #/ omz1 / omz2 / omzo * dlm - 0.1D1 / omz1 / omz2 / omzo * rH1(1, z
     #1) * dlm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 /
     # omz1 / omz2 / omzo * rH1(1, z1) * dls + dls / omz1 / omz2 / omzo 
     #* rH1(1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z1
     #) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, z1) + 0.1D1 / omz1 / om
     #z2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.3.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + 0.1D1 / omz2 / omzo * d0x1 * dlm - dls
     # / omz2 / omzo * d0x1 - 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 + 
     #(0.1D1 / 0.2D1 + x1 / 0.2D1) * d0z / omz2 + 0.1D1 / omz2 / omzo * 
     #d1x1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz2 / omzo * dlm + (0.1D1 
     #/ 0.2D1 + x1 / 0.2D1) / omz2 / omzo * dls + (0.1D1 / 0.2D1 + x1 / 
     #0.2D1) / omz2 / omzo * rH1(0, x1) + (0.1D1 / 0.2D1 + x1 / 0.2D1) *
     # rH1(1, x1) / omzo / omz2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 / 
     #omzo * rH1(1, zo) + (-x1 / 0.2D1 + 0.1D1 / 0.2D1) / omz2 / omzo - 
     #0.1D1 / omz2 / omzo * rH1(0, x1) / omx1
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -rH1(0, z) / omz1 / omz2 * z ** 2 - rH1(1, z) / omz1 / omz2
     # / z - rH1(1, z1) / omz1 / omz2 / z + dla / omz1 / omz2 / z + dls 
     #/ omz1 / omz2 * z ** 2 - dls / omz1 / omz2 / z - dla / omz1 / omz2
     # * z ** 2 + 0.1D1 / omz1 / omz2 * rH1(0, z) / omz - d0z * d0x1 / o
     #mz2 - 0.2D1 * dla / omz1 / omz2 - 0.2D1 / omz1 / omz2 * rH1(0, z) 
     #+ 0.2D1 * rH1(1, z) / omz1 / omz2 - dls / omz1 / omz2 * d0z - 0.1D
     #1 / omz1 / omz2 * rH1(1, z1) * d0z - d0x1 / omz2 / z + d0x1 / omz2
     # * z ** 2 + rH1(0, z) / omz1 / omz2 * z - rH1(1, z) / omz1 / omz2 
     #* z - rH1(1, z1) / omz1 / omz2 * z + z * dla / omz1 / omz2 - z * d
     #ls / omz1 / omz2 + rH1(1, z) / omz1 / omz2 * z ** 2 + rH1(1, z1) /
     # omz1 / omz2 * z ** 2 + rH1(0, z) / omz1 / omz2 / z + 0.2D1 * dls 
     #/ omz1 / omz2 + 0.2D1 * d0x1 / omz2 + 0.1D1 / omz1 / omz2 * d0z * 
     #dla - z * d0x1 / omz2 + 0.1D1 / omz1 / omz2 * d1z + 0.2D1 / omz1 /
     # omz2 * rH1(1, z1)
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x1 / omz2 - d0x1 / omz2 * z ** 2 + z * d0x1 / omz2 
     #- 0.2D1 * d0x1 / omz2 + d0x1 / omz2 / z + (-0.1D1 / 0.2D1 - x1 / 0
     #.2D1) * d0z / omz2 - 0.1D1 / x1 / omz2 * z ** 2 + 0.1D1 / x1 / omz
     #2 * z - 0.1D1 / x1 / omz2 / 0.2D1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) 
     #/ omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21QGIFqg_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21QGIFqg_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21QGIFqg_hfrag=e0  
      endif

*      write(*,*)" rJ21QGIFqg_hfrag ",rJ21QGIFqg_hfrag

      return
      end
************************************************************************
*
      function rJ21GQIFgq_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQIFgq_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GQIFgq_hfrag=rJ21QGFIgq_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo 
      e1 = dls / omz1 / omz2 / omzo + 0.5D1 / 0.3D1 / omz1 / omz2 / om
     #zo
      e0 = d0z * d0x1 / omz2 - 0.1D1 / omz2 / omzo * d0x1 * dlm + dls
     #/ omz2 / omzo * d0x1 + 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + dls / omz1 / omz2 * d0z + 0.1D1 /
     # omz1 / omz2 * rH1(1, z1) * d0z - 0.1D1 / omz2 / omzo * d1x1 - 0.1
     #D1 / omz1 / omz2 * d1z + 0.3D1 / 0.4D1 / omz1 / omz2 / omzo * dla
     #- 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.11D2 / 0.12D2
     #/ omz1 / omz2 / omzo * dlm - 0.1D1 / omz1 / omz2 / omzo * rH1(1, z
     #1) * dlm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1 /
     # omz1 / omz2 / omzo * rH1(1, z1) * dls + dls / omz1 / omz2 / omzo
     #* rH1(1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, z1
     #) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, z1) + 0.1D1 / omz1 / om
     #z2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D2
      endif
      if(ix.eq.3.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + 0.1D1 / omz2 / omzo * d0x1 * dlm - dls
     # / omz2 / omzo * d0x1 - 0.1D1 / omz2 / omzo * rH1(1, zo) * d0x1 +
     #(x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * d0z / omz2 + 0.1D1
     # / omz2 / omzo * d1x1 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) /
     # x1 / omz2 / omzo * dlm + dls * (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 -
     #0.1D1) / x1 / omz2 / omzo + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D
     #1) / x1 / omz2 / omzo * rH1(0, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 *
     #x1 - 0.1D1) / x1 / omz2 / omzo * rH1(1, x1) + (x1 ** 3 - x1 ** 2 +
     # 0.2D1 * x1 - 0.1D1) / x1 / omz2 / omzo * rH1(1, zo) - 0.1D1 / omz
     #2 / omzo * rH1(0, x1) / omx1
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + d0x1 / omz2 / 0.2D1 + z * d0x1 / omz2
     #/ 0.2D1 + 0.1D1 / omz1 / omz2 * d0z * dla - dls / omz1 / omz2 * d0
     #z - 0.1D1 / omz1 / omz2 * rH1(1, z1) * d0z + 0.1D1 / omz1 / omz2 *
     # d1z - dla / omz1 / omz2 / 0.2D1 - z * dla / omz1 / omz2 / 0.2D1 +
     # dls / omz1 / omz2 / 0.2D1 + z * dls / omz1 / omz2 / 0.2D1 - 0.1D1
     # / omz1 / omz2 * z / 0.2D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1 +
     # rH1(1, z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z1) / omz1 / omz2 *
     #z / 0.2D1 + 0.1D1 / omz1 / omz2 / 0.2D1 - 0.1D1 / omz1 / omz2 * rH
     #1(0, z) / 0.2D1 + rH1(1, z) / omz1 / omz2 / 0.2D1 + 0.1D1 / omz1 /
     # omz2 * rH1(1, z1) / 0.2D1 + 0.1D1 / omz1 / omz2 * rH1(0, z) / omz
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x1 / omz2 - z * d0x1 / omz2 / 0.2D1 - d0x1 / omz2 /
     # 0.2D1 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * d0
     #z - 0.3D1 / 0.2D1 / omz2
      endif
      
      if(ieorder.eq.-2)then
        rJ21GQIFgq_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21GQIFgq_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21GQIFgq_hfrag=e0  
      endif

*      write(*,*)" rJ21GQIFgq_hfrag ",rJ21GQIFgq_hfrag

      return
      end
************************************************************************
*      
      function rJ21GQIFgg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQIFgg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GQIFgg_hfrag=rJ21QGFIgg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -z * d0x1 / omz2 / 0.2D1 + d0x1 / omz2 - d0x1 / omz2 / z + 
     #z * dla / omz1 / omz2 / 0.2D1 - dla / omz1 / omz2 + dla / omz1 / o
     #mz2 / z - z * dls / omz1 / omz2 / 0.2D1 + dls / omz1 / omz2 - dls 
     #/ omz1 / omz2 / z + 0.1D1 / omz1 / omz2 * z / 0.2D1 + rH1(0, z) / 
     #omz1 / omz2 * z / 0.2D1 - rH1(1, z) / omz1 / omz2 * z / 0.2D1 - rH
     #1(1, z1) / omz1 / omz2 * z / 0.2D1 - 0.1D1 / omz1 / omz2 * rH1(0, 
     #z) + rH1(1, z) / omz1 / omz2 + 0.1D1 / omz1 / omz2 * rH1(1, z1) + 
     #rH1(0, z) / omz1 / omz2 / z - rH1(1, z) / omz1 / omz2 / z - rH1(1,
     # z1) / omz1 / omz2 / z
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = z * d0x1 / omz2 / 0.2D1 - d0x1 / omz2 + d0x1 / omz2 / z - 0
     #.3D1 / 0.2D1 / omz2 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x
     #1 / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21GQIFgg_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21GQIFgg_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21GQIFgg_hfrag=e0  
      endif

*      write(*,*)" rJ21GQIFgg_hfrag ",rJ21GQIFgg_hfrag

      return
      end
************************************************************************
*
      !!!!!1
      !checked
      !!!!!
      function rJ21GGIFgg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGIFgg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GGIFgg_hfrag=rJ21GGFIgg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.1)then
      e2 = 0.1D1 / omz1 / omz2 / omzo
      e1 = dls / omz1 / omz2 / omzo + 0.11D2 / 0.6D1 / omz1 / omz2 / o
     #mzo
      e0 = d0z * d0x1 / omz2 - 0.1D1 / omz2 / omzo * d0x1 * dlm + 0.1D
     #1 / omz2 / omzo * rH1(1, zo) * d0x1 + dls / omz2 / omzo * d0x1 - 0
     #.1D1 / omz1 / omz2 * d0z * dla + 0.1D1 / omz1 / omz2 * rH1(1, z1) 
     #* d0z + dls / omz1 / omz2 * d0z - 0.1D1 / omz2 / omzo * d1x1 - 0.1
     #D1 / omz1 / omz2 * d1z + 0.11D2 / 0.12D2 / omz1 / omz2 / omzo * dl
     #a - 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * dla + 0.11D2 / 0.12D
     #2 / omz1 / omz2 / omzo * dlm - 0.1D1 / omz1 / omz2 / omzo * rH1(1,
     # z1) * dlm + 0.1D1 / omz1 / omz2 / omzo * dls ** 2 / 0.2D1 + 0.1D1
     # / omz1 / omz2 / omzo * rH1(1, z1) * dls + dls / omz1 / omz2 / omz
     #o * rH1(1, zo) + 0.1D1 / omz1 / omz2 / omzo * rH1(1, zo) * rH1(1, 
     #z1) + 0.1D1 / omz1 / omz2 / omzo * rH2(1, 1, z1) + 0.1D1 / omz1 / 
     #omz2 / omzo * rH2(1, 1, zo) - pi ** 2 / omz1 / omz2 / omzo / 0.12D
     #2
      endif
      if(ix.eq.3.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0z * d0x1 / omz2 + 0.1D1 / omz2 / omzo * d0x1 * dlm - 0.1
     #D1 / omz2 / omzo * rH1(1, zo) * d0x1 - dls / omz2 / omzo * d0x1 + 
     #(x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * d0z + 0.1D1
     # / omz2 / omzo * d1x1 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) /
     # x1 / omz2 / omzo * dlm + dls * (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 
     #0.1D1) / x1 / omz2 / omzo + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D
     #1) / x1 / omz2 / omzo * rH1(1, zo) + (x1 ** 3 - x1 ** 2 + 0.2D1 * 
     #x1 - 0.1D1) / x1 / omz2 / omzo * rH1(0, x1) + (x1 ** 3 - x1 ** 2 +
     # 0.2D1 * x1 - 0.1D1) / x1 / omz2 / omzo * rH1(1, x1) - 0.1D1 / omz
     #2 / omzo * rH1(0, x1) / omx1
      endif
      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = 0.1D1 / omz1 / omz2 * rH1(0, z) / omz - d0z * d0x1 / omz2 +
     # rH1(1, z) / omz1 / omz2 * z ** 2 + rH1(1, z1) / omz1 / omz2 * z *
     #* 2 - 0.2D1 * dla / omz1 / omz2 - 0.2D1 / omz1 / omz2 * rH1(0, z) 
     #+ 0.2D1 * rH1(1, z) / omz1 / omz2 - dls / omz1 / omz2 * d0z - 0.1D
     #1 / omz1 / omz2 * rH1(1, z1) * d0z + rH1(0, z) / omz1 / omz2 * z -
     # rH1(1, z) / omz1 / omz2 * z - rH1(1, z1) / omz1 / omz2 * z + z * 
     #dla / omz1 / omz2 - z * dls / omz1 / omz2 - rH1(1, z) / omz1 / omz
     #2 / z - rH1(1, z1) / omz1 / omz2 / z - dls / omz1 / omz2 / z + dla
     # / omz1 / omz2 / z - dla / omz1 / omz2 * z ** 2 + dls / omz1 / omz
     #2 * z ** 2 - rH1(0, z) / omz1 / omz2 * z ** 2 + 0.2D1 * dls / omz1
     # / omz2 + 0.2D1 * d0x1 / omz2 + 0.1D1 / omz1 / omz2 * d0z * dla - 
     #d0x1 / omz2 / z - z * d0x1 / omz2 + 0.1D1 / omz1 / omz2 * d1z + 0.
     #2D1 / omz1 / omz2 * rH1(1, z1) + d0x1 / omz2 * z ** 2 + rH1(0, z) 
     #/ omz1 / omz2 / z
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0z * d0x1 / omz2 - d0x1 / omz2 * z ** 2 + z * d0x1 / omz2 
     #- 0.2D1 * d0x1 / omz2 + d0x1 / omz2 / z - (x1 ** 3 - x1 ** 2 + 0.2
     #D1 * x1 - 0.1D1) / x1 / omz2 * d0z - 0.1D1 / x1 / omz2 * z ** 2 + 
     #0.1D1 / x1 / omz2 * z - 0.2D1 / x1 / omz2 - (x1 ** 3 - x1 ** 2 + 0
     #.2D1 * x1 - 0.1D1) / x1 / omz2 / z
      endif

      if(ieorder.eq.-2)then
        rJ21GGIFgg_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21GGIFgg_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21GGIFgg_hfrag=e0  
      endif

*      write(*,*)" rJ21GGIFgg_hfrag ",rJ21GGIFgg_hfrag

      return
      end
************************************************************************
*
      function rJ21hGGIFgq_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hGGIFgq_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21hGGIFgq_hfrag=rJ21hGGFIgq_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 / omz2 / 0.4D1 + z * d0x1 / omz2 / 0.2D1 - z ** 2 * d
     #0x1 / omz2 / 0.2D1 + dla / omz1 / omz2 / 0.4D1 - z * dla / omz1 / 
     #omz2 / 0.2D1 + z ** 2 * dla / omz1 / omz2 / 0.2D1 - dls / omz1 / o
     #mz2 / 0.4D1 + z * dls / omz1 / omz2 / 0.2D1 - z ** 2 * dls / omz1 
     #/ omz2 / 0.2D1 - 0.1D1 / omz1 / omz2 * z ** 2 / 0.2D1 + rH1(0, z) 
     #/ omz1 / omz2 * z ** 2 / 0.2D1 - rH1(1, z) / omz1 / omz2 * z ** 2 
     #/ 0.2D1 - rH1(1, z1) / omz1 / omz2 * z ** 2 / 0.2D1 + 0.1D1 / omz1
     # / omz2 * z / 0.2D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z1) / omz1 / omz2 * z / 0.2
     #D1 + rH1(0, z) / omz1 / omz2 / 0.4D1 - rH1(1, z) / omz1 / omz2 / 0
     #.4D1 - rH1(1, z1) / omz1 / omz2 / 0.4D1
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x1 / omz2 / 0.4D1 - z * d0x1 / omz2 / 0.2D1 + z ** 2 * d0
     #x1 / omz2 / 0.2D1 + 0.1D1 / x1 / omz2 * z ** 2 / 0.2D1 - 0.1D1 / x
     #1 / omz2 * z / 0.2D1 + 0.1D1 / x1 / omz2 / 0.4D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGIFgq_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21hGGIFgq_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21hGGIFgq_hfrag=e0  
      endif

*      write(*,*)" rJ21hGGIFgq_hfrag ",rJ21hGGIFgq_hfrag

      return
      end
************************************************************************
*
      function rJ21hQGIFqqp_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21hQGIFqqp_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21hQGIFqqp_hfrag=rJ21hGQFIqqp_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.1.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 / omz2 / 0.4D1 + z * d0x1 / omz2 / 0.2D1 - z ** 2 * d
     #0x1 / omz2 / 0.2D1 + dla / omz1 / omz2 / 0.4D1 - z * dla / omz1 / 
     #omz2 / 0.2D1 + z ** 2 * dla / omz1 / omz2 / 0.2D1 - dls / omz1 / o
     #mz2 / 0.4D1 + z * dls / omz1 / omz2 / 0.2D1 - z ** 2 * dls / omz1 
     #/ omz2 / 0.2D1 - 0.1D1 / omz1 / omz2 * z ** 2 / 0.2D1 + rH1(0, z) 
     #/ omz1 / omz2 * z ** 2 / 0.2D1 - rH1(1, z) / omz1 / omz2 * z ** 2 
     #/ 0.2D1 - rH1(1, z1) / omz1 / omz2 * z ** 2 / 0.2D1 + 0.1D1 / omz1
     # / omz2 * z / 0.2D1 - rH1(0, z) / omz1 / omz2 * z / 0.2D1 + rH1(1,
     # z) / omz1 / omz2 * z / 0.2D1 + rH1(1, z1) / omz1 / omz2 * z / 0.2
     #D1 + rH1(0, z) / omz1 / omz2 / 0.4D1 - rH1(1, z) / omz1 / omz2 / 0
     #.4D1 - rH1(1, z1) / omz1 / omz2 / 0.4D1
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = d0x1 / omz2 / 0.4D1 - z * d0x1 / omz2 / 0.2D1 + z ** 2 * d0
     #x1 / omz2 / 0.2D1 + 0.1D1 / x1 / omz2 * z ** 2 / 0.2D1 - 0.1D1 / x
     #1 / omz2 * z / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21hQGIFqqp_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21hQGIFqqp_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21hQGIFqqp_hfrag=e0  
      endif

*      write(*,*)" rJ21hQGIFqqp_hfrag ",rJ21hQGIFqqp_hfrag

      return
      end
************************************************************************
*
      function rJ21GQqtogIFqpq_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GQqtogIFqpq_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GQqtogIFqpq_hfrag=rJ21QGqtogFIqpq_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.3.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0z / omz2 / 0.2D1 +
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omzo / omz2 * dlm / 0.2D1 -
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omzo / omz2 * dls / 0.2D1 -
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo * rH1(0, x1) / 
     #0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo * rH1(1,
     # x1) / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo *
     # rH1(1, zo) / 0.2D1 + x1 / omz2 / omzo / 0.2D1
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0z / omz2 / 0.2D1 + 
     #(x1 - 0.2D1) / x1 / omz2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GQqtogIFqpq_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21GQqtogIFqpq_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21GQqtogIFqpq_hfrag=e0  
      endif

*      write(*,*)" rJ21GQqtogIFqpq_hfrag ",rJ21GQqtogIFqpq_hfrag

      return
      end
************************************************************************
*
      function rJ21GGqtogIFqg_hfrag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : kin, zfrag_kin, zregfrag_kin
      use HadronFragmentation_mod, only : iz_hfrag
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if(imethod /= 2)then
        stop 'J21GGqtogIFqg_hfrag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ21GGqtogIFqg_hfrag=rJ21GGqtogFIqg_hfrag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      dla=log(renscale2/fragscale2) 
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      z=zregfrag_kin
      zo=zfrag_kin
      omz=1d0-z
      omzo=1d0-zo
      dlogomz=-rH1(1,z)
      d0z=1d0/omz
      d1z=dlogomz*d0z
      d2z=dlogomz*d1z
      d3z=dlogomz*d2z

      if(ix.eq.3.and.iz_hfrag.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0z / omz2 / 0.2D1 +
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omzo / omz2 * dlm / 0.2D1 -
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omzo / omz2 * dls / 0.2D1 -
     # (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo * rH1(0, x1) / 
     #0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo * rH1(1,
     # x1) / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 / omzo *
     # rH1(1, zo) / 0.2D1 + x1 / omz2 / omzo / 0.2D1
      endif
      if(ix.eq.3.and.iz_hfrag.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0z / omz2 / 0.2D1 - 
     #0.1D1 / x1 / omz2 * z / 0.2D1 - 0.1D1 / x1 / omz2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GGqtogIFqg_hfrag=e2  
      elseif(ieorder.eq.-1)then
        rJ21GGqtogIFqg_hfrag=e1  
      elseif(ieorder.eq.0)then
        rJ21GGqtogIFqg_hfrag=e0  
      endif

*      write(*,*)" rJ21GGqtogIFqg_hfrag ",rJ21GGqtogIFqg_hfrag

      return
      end
