!>***************************************************
!> Exact DIS coefficient funtion c2g_new in x space
!> including scale dependence
!>
      function c2g_new(iorder,x,ireg,rmu2,fmu2,q2, flavchange)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      implicit none
      integer iorder,ireg, flavchange
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
      common /Hrs/ Hr1,Hr2,Hr3,Hr4,Hr5
!$omp threadprivate(/Hrs/)
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR
      real*8 c2g_new,x


      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             c2g_new =  0 
         elseif (iorder.eq.1) then 
             c2g_new =  0 
         elseif (iorder.eq.2) then 
             c2g_new =  0 
         elseif (iorder.eq.3) then 
             c2g_new =  0 
             c2g_new = c2g_new + c2g_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.1) then      
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             c2g_new =  0 
         elseif (iorder.eq.1) then 
             c2g_new =  + LM * ( 2 - 4*x + 4*x**2 )
      c2g_new = c2g_new - 2 + 2*dlx1 - 2*dlx + 16*x - 4*x*dlx1 + 4*x*
     &    dlx - 16*x**2 + 4*x**2*dlx1 - 4*x**2*dlx 
         elseif (iorder.eq.2) then 
             c2g_new =  + LM * (  - 86 + 104.D0/3.D0*x**(-1) + 16*
     &    x**(-1)*dlx1 - 92.D0/3.D0*dlx1 + 68.D0/3.D0*dlx1**2 + 16.D0/3.
     &    D0*dlx - 136.D0/3.D0*dlx*dlx1 - 56.D0/3.D0*dlx**2 - 8.D0/3.D0
     &    *Pi**2 - 688.D0/3.D0*x + 304*x*dlx1 - 136.D0/3.D0*x*dlx1**2
     &     - 320*x*dlx + 272.D0/3.D0*x*dlx*dlx1 - 248.D0/3.D0*x*dlx**2
     &     + 64.D0/3.D0*x*Pi**2 + 282*x**2 - 964.D0/3.D0*x**2*dlx1 + 
     &    136.D0/3.D0*x**2*dlx1**2 + 1060.D0/3.D0*x**2*dlx - 272.D0/3.D0
     &    *x**2*dlx*dlx1 + 64.D0/3.D0*x**2*dlx**2 - 136.D0/9.D0*x**2*
     &    Pi**2 - 24*Hr1(-1)*dlx - 48*Hr1(-1)*x*dlx - 48*Hr1(-1)*x**2*
     &    dlx + 24*Hr2(0,-1) + 48*Hr2(0,-1)*x + 48*Hr2(0,-1)*x**2 - 88.D
     &    0/3.D0*Hr2(0,1) - 256.D0/3.D0*Hr2(0,1)*x )
      c2g_new = c2g_new + LM**2 * ( 14.D0/3.D0 + 8*x**(-1) + 52.D0/3.D0
     &    *dlx1 + 28.D0/3.D0*dlx + 160.D0/3.D0*x - 104.D0/3.D0*x*dlx1
     &     + 160.D0/3.D0*x*dlx - 62*x**2 + 104.D0/3.D0*x**2*dlx1 - 32.D0
     &    /3.D0*x**2*dlx )
      c2g_new = c2g_new + LR * ( 22 - 22*dlx1 + 22*dlx - 176*x + 44*x*
     &    dlx1 - 44*x*dlx + 176*x**2 - 44*x**2*dlx1 + 44*x**2*dlx )
      c2g_new = c2g_new + LR*LM * (  - 22 + 44*x - 44*x**2 )
      c2g_new = c2g_new + rnf*LR * (  - 4.D0/3.D0 + 4.D0/3.D0*dlx1 - 4.D
     &    0/3.D0*dlx + 32.D0/3.D0*x - 8.D0/3.D0*x*dlx1 + 8.D0/3.D0*x*
     &    dlx - 32.D0/3.D0*x**2 + 8.D0/3.D0*x**2*dlx1 - 8.D0/3.D0*x**2*
     &    dlx )
      c2g_new = c2g_new + rnf*LR*LM * ( 4.D0/3.D0 - 8.D0/3.D0*x + 8.D0/
     &    3.D0*x**2 )
      c2g_new = c2g_new + 997.D0/45.D0 + 584.D0/15.D0*x**(-1) + 104.D0/
     &    3.D0*x**(-1)*dlx1 + 8*x**(-1)*dlx1**2 - 32.D0/45.D0*x**(-1)*
     &    dlx - 16*x**(-1)*dlx*dlx1 - 8.D0/3.D0*x**(-1)*Pi**2 - 130.D0/
     &    3.D0*dlx1 - 70.D0/3.D0*dlx1**2 + 58.D0/9.D0*dlx1**3 + 6886.D0/
     &    45.D0*dlx + 140.D0/3.D0*dlx*dlx1 - 86.D0/3.D0*dlx*dlx1**2 - 5
     &    *dlx**2 + 62.D0/3.D0*dlx**2*dlx1 + 70.D0/9.D0*dlx**3 + 68.D0/
     &    9.D0*Pi**2 - 52.D0/9.D0*Pi**2*dlx1 - 4.D0/9.D0*Pi**2*dlx + 
     &    164.D0/3.D0*Zeta3 + 6316.D0/15.D0*x - 1522.D0/3.D0*x*dlx1 + 
     &    484.D0/3.D0*x*dlx1**2 - 116.D0/9.D0*x*dlx1**3 + 9212.D0/15.D0
     &    *x*dlx - 1040.D0/3.D0*x*dlx*dlx1 + 172.D0/3.D0*x*dlx*dlx1**2
     &     + 2464.D0/9.D0*x*dlx**2 - 124.D0/3.D0*x*dlx**2*dlx1 + 292.D0/
     &    9.D0*x*dlx**3 - 2152.D0/27.D0*x*Pi**2 + 104.D0/9.D0*x*Pi**2*
     &    dlx1 - 352.D0/9.D0*x*Pi**2*dlx - 144*x*Zeta3 - 22897.D0/45.D0
     &    *x**2 + 1666.D0/3.D0*x**2*dlx1 - 170*x**2*dlx1**2 + 116.D0/9.D
     &    0*x**2*dlx1**3 - 11314.D0/15.D0*x**2*dlx + 364*x**2*dlx*dlx1
     &     - 172.D0/3.D0*x**2*dlx*dlx1**2
      c2g_new = c2g_new - 242*x**2*dlx**2 + 40*x**2*dlx**2*dlx1 - 80.D0/
     &    9.D0*x**2*dlx**3 + 90*x**2*Pi**2 - 100.D0/9.D0*x**2*Pi**2*
     &    dlx1 + 56.D0/3.D0*x**2*Pi**2*dlx + 168*x**2*Zeta3 - 64.D0/5.D0
     &    *x**3*dlx**2 + 64.D0/15.D0*x**3*Pi**2 + 32.D0/45.D0*Hr1(-1)*
     &    x**(-2)*dlx - 16*Hr1(-1)*x**(-1)*dlx - 8*Hr1(-1)*dlx + 68.D0/
     &    3.D0*Hr1(-1)*dlx**2 - 50.D0/9.D0*Hr1(-1)*Pi**2 + 256.D0/9.D0*
     &    Hr1(-1)*x*dlx + 136.D0/3.D0*Hr1(-1)*x*dlx**2 - 100.D0/9.D0*
     &    Hr1(-1)*x*Pi**2 + 80*Hr1(-1)*x**2*dlx + 140.D0/3.D0*Hr1(-1)*
     &    x**2*dlx**2 - 104.D0/9.D0*Hr1(-1)*x**2*Pi**2 + 128.D0/5.D0*
     &    Hr1(-1)*x**3*dlx - 56.D0/3.D0*Hr2(-1,-1)*dlx - 112.D0/3.D0*
     &    Hr2(-1,-1)*x*dlx - 128.D0/3.D0*Hr2(-1,-1)*x**2*dlx + 8*Hr2(0,
     &    -1) - 32.D0/45.D0*Hr2(0,-1)*x**(-2) + 16*Hr2(0,-1)*x**(-1) - 
     &    8.D0/3.D0*Hr2(0,-1)*dlx - 256.D0/9.D0*Hr2(0,-1)*x - 272.D0/3.D
     &    0*Hr2(0,-1)*x*dlx - 80*Hr2(0,-1)*x**2 - 8.D0/3.D0*Hr2(0,-1)*
     &    x**2*dlx - 128.D0/5.D0*Hr2(0,-1)*x**3 + 4.D0/3.D0*Hr2(0,1) - 
     &    16*Hr2(0,1)*x**(-1)
      c2g_new = c2g_new - 40.D0/3.D0*Hr2(0,1)*dlx1 + 76.D0/3.D0*Hr2(0,1
     &    )*dlx + 160*Hr2(0,1)*x + 80.D0/3.D0*Hr2(0,1)*x*dlx1 + 280.D0/
     &    3.D0*Hr2(0,1)*x*dlx - 176*Hr2(0,1)*x**2 - 80.D0/3.D0*Hr2(0,1)
     &    *x**2*dlx1 - 32.D0/3.D0*Hr2(0,1)*x**2*dlx + 56.D0/3.D0*Hr3(-1
     &    ,0,-1) + 112.D0/3.D0*Hr3(-1,0,-1)*x + 128.D0/3.D0*Hr3(-1,0,-1
     &    )*x**2 + 24*Hr3(-1,0,1) + 48*Hr3(-1,0,1)*x + 48*Hr3(-1,0,1)*
     &    x**2 + 56.D0/3.D0*Hr3(0,-1,-1) + 112.D0/3.D0*Hr3(0,-1,-1)*x
     &     + 128.D0/3.D0*Hr3(0,-1,-1)*x**2 - 40*Hr3(0,0,-1) + 272.D0/3.D
     &    0*Hr3(0,0,-1)*x - 88*Hr3(0,0,-1)*x**2 - 20.D0/3.D0*Hr3(0,0,1)
     &     - 104.D0/3.D0*Hr3(0,0,1)*x - 32.D0/3.D0*Hr3(0,0,1)*x**2 + 28.
     &    D0/3.D0*Hr3(0,1,1) + 376.D0/3.D0*Hr3(0,1,1)*x - 40*Hr3(0,1,1)
     &    *x**2 
         elseif (iorder.eq.3) then 
             c2g_new =  - 32.D0/45.D0*x**(-2)*Pi**2*dlx1*LM - 829144.D0/
     & 135.D0*x**(-1)*LM - 1228*x**(-1)*LM**2 - 544.D0/3.D0*x**(-1)*
     & LM**3 - 12848.D0/15.D0*x**(-1)*LR - 2288.D0/3.D0*x**(-1)*LR*LM
     &  - 176*x**(-1)*LR*LM**2 - 348248.D0/135.D0*x**(-1)*dlx1*LM - 
     & 2768.D0/9.D0*x**(-1)*dlx1*LM**2 + 704.D0/9.D0*x**(-1)*dlx1*LM**3
     &  - 2288.D0/3.D0*x**(-1)*dlx1*LR - 352*x**(-1)*dlx1*LR*LM - 2044.D
     & 0/9.D0*x**(-1)*dlx1**2*LM + 560.D0/3.D0*x**(-1)*dlx1**2*LM**2 - 
     & 176*x**(-1)*dlx1**2*LR + 416.D0/3.D0*x**(-1)*dlx1**3*LM - 101216.
     & D0/135.D0*x**(-1)*dlx*LM - 208*x**(-1)*dlx*LM**2 - 32*x**(-1)*
     & dlx*LM**3 + 704.D0/45.D0*x**(-1)*dlx*LR + 3152.D0/9.D0*x**(-1)*
     & dlx*dlx1*LM - 1120.D0/3.D0*x**(-1)*dlx*dlx1*LM**2 + 352*x**(-1)*
     & dlx*dlx1*LR - 464*x**(-1)*dlx*dlx1**2*LM + 64.D0/15.D0*x**(-1)*
     & dlx**2*LM + 1424.D0/3.D0*x**(-1)*dlx**2*dlx1*LM + 8032.D0/45.D0*
     & x**(-1)*Pi**2*LM + 176.D0/3.D0*x**(-1)*Pi**2*LR - 1408.D0/9.D0*
     & x**(-1)*Pi**2*dlx1*LM + 32*x**(-1)*Pi**2*dlx*LM + 42656.D0/1215.D
     & 0*x**(-1)*rnf*LM
      c2g_new = c2g_new + 304.D0/81.D0*x**(-1)*rnf*LM**2 + 272.D0/81.D0
     & *x**(-1)*rnf*LM**3 + 2336.D0/45.D0*x**(-1)*rnf*LR + 416.D0/9.D0*
     & x**(-1)*rnf*LR*LM + 32.D0/3.D0*x**(-1)*rnf*LR*LM**2 + 608.D0/81.D
     & 0*x**(-1)*rnf*dlx1*LM + 272.D0/27.D0*x**(-1)*rnf*dlx1*LM**2 + 
     & 416.D0/9.D0*x**(-1)*rnf*dlx1*LR + 64.D0/3.D0*x**(-1)*rnf*dlx1*LR
     & *LM + 272.D0/27.D0*x**(-1)*rnf*dlx1**2*LM + 32.D0/3.D0*x**(-1)*
     & rnf*dlx1**2*LR - 64.D0/135.D0*x**(-1)*rnf*dlx*LM - 128.D0/135.D0
     & *x**(-1)*rnf*dlx*LR - 544.D0/27.D0*x**(-1)*rnf*dlx*dlx1*LM - 64.D
     & 0/3.D0*x**(-1)*rnf*dlx*dlx1*LR - 272.D0/81.D0*x**(-1)*rnf*Pi**2*
     & LM - 32.D0/9.D0*x**(-1)*rnf*Pi**2*LR + 2944.D0/3.D0*x**(-1)*
     & Zeta3*LM + 1505303.D0/135.D0*LM + 351*LM**2 + 6458.D0/27.D0*
     & LM**3 - 12754.D0/45.D0*LR + 1688*LR*LM - 308.D0/3.D0*LR*LM**2 - 
     & 242*LR**2 + 242*LR**2*LM - 19502.D0/15.D0*dlx1*LM + 1210.D0/3.D0
     & *dlx1*LM**2 - 932.D0/27.D0*dlx1*LM**3 + 2248.D0/3.D0*dlx1*LR + 
     & 2024.D0/3.D0*dlx1*LR*LM - 1144.D0/3.D0*dlx1*LR*LM**2 + 242*dlx1*
     & LR**2
      c2g_new = c2g_new + 692*dlx1**2*LM - 2870.D0/9.D0*dlx1**2*LM**2
     &  + 2128.D0/27.D0*dlx1**2*LM**3 + 1540.D0/3.D0*dlx1**2*LR - 1496.D
     & 0/3.D0*dlx1**2*LR*LM - 9172.D0/27.D0*dlx1**3*LM + 1192.D0/9.D0*
     & dlx1**3*LM**2 - 1276.D0/9.D0*dlx1**3*LR + 1900.D0/27.D0*dlx1**4*
     & LM - 599114.D0/135.D0*dlx*LM - 6026.D0/3.D0*dlx*LM**2 - 220.D0/9.
     & D0*dlx*LM**3 - 142312.D0/45.D0*dlx*LR - 352.D0/3.D0*dlx*LR*LM - 
     & 616.D0/3.D0*dlx*LR*LM**2 - 242*dlx*LR**2 - 1072*dlx*dlx1*LM + 
     & 3724.D0/9.D0*dlx*dlx1*LM**2 - 2128.D0/27.D0*dlx*dlx1*LM**3 - 
     & 3080.D0/3.D0*dlx*dlx1*LR + 2992.D0/3.D0*dlx*dlx1*LR*LM + 9764.D0/
     & 9.D0*dlx*dlx1**2*LM - 3448.D0/9.D0*dlx*dlx1**2*LM**2 + 1892.D0/3.
     & D0*dlx*dlx1**2*LR - 9304.D0/27.D0*dlx*dlx1**3*LM + 55843.D0/15.D0
     & *dlx**2*LM + 190.D0/3.D0*dlx**2*LM**2 + 536.D0/27.D0*dlx**2*
     & LM**3 + 110*dlx**2*LR + 1232.D0/3.D0*dlx**2*LR*LM - 530*dlx**2*
     & dlx1*LM + 1948.D0/9.D0*dlx**2*dlx1*LM**2 - 1364.D0/3.D0*dlx**2*
     & dlx1*LR + 4160.D0/9.D0*dlx**2*dlx1**2*LM - 2210.D0/27.D0*dlx**3*
     & LM
      c2g_new = c2g_new - 536.D0/9.D0*dlx**3*LM**2 - 1540.D0/9.D0*
     & dlx**3*LR - 5396.D0/27.D0*dlx**3*dlx1*LM + 1474.D0/27.D0*dlx**4*
     & LM - 79784.D0/135.D0*Pi**2*LM - 28.D0/3.D0*Pi**2*LM**2 + 1312.D0/
     & 81.D0*Pi**2*LM**3 - 1496.D0/9.D0*Pi**2*LR + 176.D0/3.D0*Pi**2*LR
     & *LM + 6146.D0/27.D0*Pi**2*dlx1*LM - 2672.D0/27.D0*Pi**2*dlx1*
     & LM**2 + 1144.D0/9.D0*Pi**2*dlx1*LR - 1256.D0/9.D0*Pi**2*dlx1**2*
     & LM - 842.D0/27.D0*Pi**2*dlx*LM - 232.D0/3.D0*Pi**2*dlx*LM**2 + 
     & 88.D0/9.D0*Pi**2*dlx*LR + 7648.D0/27.D0*Pi**2*dlx*dlx1*LM + 1441.
     & D0/27.D0*Pi**2*dlx**2*LM + 17909.D0/810.D0*Pi**4*LM - 564098.D0/
     & 405.D0*rnf*LM + 2038.D0/9.D0*rnf*LM**2 - 412.D0/27.D0*rnf*LM**3
     &  + 568.D0/135.D0*rnf*LR - 268.D0/3.D0*rnf*LR*LM + 56.D0/9.D0*rnf
     & *LR*LM**2 + 88.D0/3.D0*rnf*LR**2 - 88.D0/3.D0*rnf*LR**2*LM + 
     & 4996.D0/9.D0*rnf*dlx1*LM - 2260.D0/27.D0*rnf*dlx1*LM**2 + 136.D0/
     & 27.D0*rnf*dlx1*LM**3 - 292.D0/9.D0*rnf*dlx1*LR - 368.D0/9.D0*rnf
     & *dlx1*LR*LM + 208.D0/9.D0*rnf*dlx1*LR*LM**2 - 88.D0/3.D0*rnf*
     & dlx1*LR**2
      c2g_new = c2g_new - 2564.D0/27.D0*rnf*dlx1**2*LM + 28.D0/3.D0*rnf
     & *dlx1**2*LM**2 - 280.D0/9.D0*rnf*dlx1**2*LR + 272.D0/9.D0*rnf*
     & dlx1**2*LR*LM + 56.D0/9.D0*rnf*dlx1**3*LM + 232.D0/27.D0*rnf*
     & dlx1**3*LR - 38716.D0/45.D0*rnf*dlx*LM + 4100.D0/27.D0*rnf*dlx*
     & LM**2 - 104.D0/27.D0*rnf*dlx*LM**3 + 24124.D0/135.D0*rnf*dlx*LR
     &  + 64.D0/9.D0*rnf*dlx*LR*LM + 112.D0/9.D0*rnf*dlx*LR*LM**2 + 88.D
     & 0/3.D0*rnf*dlx*LR**2 + 5416.D0/27.D0*rnf*dlx*dlx1*LM - 200.D0/9.D
     & 0*rnf*dlx*dlx1*LM**2 + 560.D0/9.D0*rnf*dlx*dlx1*LR - 544.D0/9.D0
     & *rnf*dlx*dlx1*LR*LM - 80.D0/3.D0*rnf*dlx*dlx1**2*LM - 344.D0/9.D0
     & *rnf*dlx*dlx1**2*LR - 7810.D0/27.D0*rnf*dlx**2*LM + 212.D0/9.D0*
     & rnf*dlx**2*LM**2 - 16.D0/9.D0*rnf*dlx**2*LM**3 - 20.D0/3.D0*rnf*
     & dlx**2*LR - 224.D0/9.D0*rnf*dlx**2*LR*LM + 272.D0/9.D0*rnf*
     & dlx**2*dlx1*LM + 248.D0/9.D0*rnf*dlx**2*dlx1*LR - 268.D0/9.D0*
     & rnf*dlx**3*LM + 16.D0/3.D0*rnf*dlx**3*LM**2 + 280.D0/27.D0*rnf*
     & dlx**3*LR - 44.D0/9.D0*rnf*dlx**4*LM + 1660.D0/27.D0*rnf*Pi**2*
     & LM
      c2g_new = c2g_new - 104.D0/27.D0*rnf*Pi**2*LM**2 + 272.D0/27.D0*
     & rnf*Pi**2*LR - 32.D0/9.D0*rnf*Pi**2*LR*LM - 44.D0/9.D0*rnf*Pi**2
     & *dlx1*LM - 208.D0/27.D0*rnf*Pi**2*dlx1*LR + 176.D0/9.D0*rnf*
     & Pi**2*dlx*LM - 16.D0/9.D0*rnf*Pi**2*dlx*LM**2 - 16.D0/27.D0*rnf*
     & Pi**2*dlx*LR + 16.D0/3.D0*rnf*Pi**2*dlx**2*LM + 8.D0/135.D0*rnf*
     & Pi**4*LM - 8.D0/9.D0*rnf**2*LR**2 + 8.D0/9.D0*rnf**2*LR**2*LM + 
     & 8.D0/9.D0*rnf**2*dlx1*LR**2 - 8.D0/9.D0*rnf**2*dlx*LR**2 - 6772.D
     & 0/9.D0*Zeta3*LM - 3440.D0/9.D0*Zeta3*LM**2 - 3608.D0/3.D0*Zeta3*
     & LR + 4424.D0/3.D0*Zeta3*dlx1*LM + 19472.D0/9.D0*Zeta3*dlx*LM + 
     & 1624.D0/9.D0*Zeta3*rnf*LM - 32.D0/3.D0*Zeta3*rnf*LM**2 + 656.D0/
     & 9.D0*Zeta3*rnf*LR + 128.D0/3.D0*Zeta3*rnf*dlx*LM - 7653988.D0/
     & 135.D0*x*LM + 68342.D0/9.D0*x*LM**2 - 36824.D0/27.D0*x*LM**3 - 
     & 163432.D0/15.D0*x*LR + 16360.D0/3.D0*x*LR*LM - 3520.D0/3.D0*x*LR
     & *LM**2 + 1936*x*LR**2 - 484*x*LR**2*LM + 557332.D0/15.D0*x*dlx1*
     & LM - 86312.D0/9.D0*x*dlx1*LM**2 + 18248.D0/27.D0*x*dlx1*LM**3 + 
     & 34708.D0/3.D0*x*dlx1*LR
      c2g_new = c2g_new - 6688*x*dlx1*LR*LM + 2288.D0/3.D0*x*dlx1*LR*
     & LM**2 - 484*x*dlx1*LR**2 - 138220.D0/9.D0*x*dlx1**2*LM + 24436.D0
     & /9.D0*x*dlx1**2*LM**2 - 4256.D0/27.D0*x*dlx1**2*LM**3 - 10648.D0/
     & 3.D0*x*dlx1**2*LR + 2992.D0/3.D0*x*dlx1**2*LR*LM + 63400.D0/27.D0
     & *x*dlx1**3*LM - 2384.D0/9.D0*x*dlx1**3*LM**2 + 2552.D0/9.D0*x*
     & dlx1**3*LR - 3800.D0/27.D0*x*dlx1**4*LM - 1990814.D0/45.D0*x*dlx
     & *LM + 67912.D0/9.D0*x*dlx*LM**2 - 6176.D0/9.D0*x*dlx*LM**3 - 
     & 208784.D0/15.D0*x*dlx*LR + 7040*x*dlx*LR*LM - 3520.D0/3.D0*x*dlx
     & *LR*LM**2 + 484*x*dlx*LR**2 + 254744.D0/9.D0*x*dlx*dlx1*LM - 
     & 13048.D0/3.D0*x*dlx*dlx1*LM**2 + 4256.D0/27.D0*x*dlx*dlx1*LM**3
     &  + 22880.D0/3.D0*x*dlx*dlx1*LR - 5984.D0/3.D0*x*dlx*dlx1*LR*LM
     &  - 68944.D0/9.D0*x*dlx*dlx1**2*LM + 6896.D0/9.D0*x*dlx*dlx1**2*
     & LM**2 - 3784.D0/3.D0*x*dlx*dlx1**2*LR + 18608.D0/27.D0*x*dlx*
     & dlx1**3*LM - 2168848.D0/135.D0*x*dlx**2*LM + 8536.D0/3.D0*x*
     & dlx**2*LM**2 - 5824.D0/27.D0*x*dlx**2*LM**3 - 54208.D0/9.D0*x*
     & dlx**2*LR
      c2g_new = c2g_new + 5456.D0/3.D0*x*dlx**2*LR*LM + 17566.D0/3.D0*x
     & *dlx**2*dlx1*LM - 3896.D0/9.D0*x*dlx**2*dlx1*LM**2 + 2728.D0/3.D0
     & *x*dlx**2*dlx1*LR - 8320.D0/9.D0*x*dlx**2*dlx1**2*LM - 30976.D0/
     & 9.D0*x*dlx**3*LM + 12032.D0/27.D0*x*dlx**3*LM**2 - 6424.D0/9.D0*
     & x*dlx**3*LR + 10792.D0/27.D0*x*dlx**3*dlx1*LM - 9550.D0/27.D0*x*
     & dlx**4*LM + 2284816.D0/405.D0*x*Pi**2*LM - 25600.D0/27.D0*x*
     & Pi**2*LM**2 + 6880.D0/81.D0*x*Pi**2*LM**3 + 47344.D0/27.D0*x*
     & Pi**2*LR - 1408.D0/3.D0*x*Pi**2*LR*LM - 55784.D0/27.D0*x*Pi**2*
     & dlx1*LM + 5344.D0/27.D0*x*Pi**2*dlx1*LM**2 - 2288.D0/9.D0*x*
     & Pi**2*dlx1*LR + 2512.D0/9.D0*x*Pi**2*dlx1**2*LM + 103702.D0/27.D0
     & *x*Pi**2*dlx*LM - 12272.D0/27.D0*x*Pi**2*dlx*LM**2 + 7744.D0/9.D0
     & *x*Pi**2*dlx*LR - 15296.D0/27.D0*x*Pi**2*dlx*dlx1*LM + 7858.D0/9.
     & D0*x*Pi**2*dlx**2*LM - 671.D0/27.D0*x*Pi**4*LM + 1404488.D0/405.D
     & 0*x*rnf*LM - 5180.D0/9.D0*x*rnf*LM**2 + 1072.D0/27.D0*x*rnf*
     & LM**3 + 34384.D0/45.D0*x*rnf*LR - 3208.D0/9.D0*x*rnf*LR*LM + 640.
     & D0/9.D0*x*rnf*LR*LM**2
      c2g_new = c2g_new - 704.D0/3.D0*x*rnf*LR**2 + 176.D0/3.D0*x*rnf*
     & LR**2*LM - 44212.D0/27.D0*x*rnf*dlx1*LM + 6320.D0/27.D0*x*rnf*
     & dlx1*LM**2 - 272.D0/27.D0*x*rnf*dlx1*LM**3 - 6544.D0/9.D0*x*rnf*
     & dlx1*LR + 1216.D0/3.D0*x*rnf*dlx1*LR*LM - 416.D0/9.D0*x*rnf*dlx1
     & *LR*LM**2 + 176.D0/3.D0*x*rnf*dlx1*LR**2 + 6928.D0/27.D0*x*rnf*
     & dlx1**2*LM - 56.D0/3.D0*x*rnf*dlx1**2*LM**2 + 1936.D0/9.D0*x*rnf
     & *dlx1**2*LR - 544.D0/9.D0*x*rnf*dlx1**2*LR*LM - 112.D0/9.D0*x*
     & rnf*dlx1**3*LM - 464.D0/27.D0*x*rnf*dlx1**3*LR + 255832.D0/135.D0
     & *x*rnf*dlx*LM - 6784.D0/27.D0*x*rnf*dlx*LM**2 + 352.D0/27.D0*x*
     & rnf*dlx*LM**3 + 39128.D0/45.D0*x*rnf*dlx*LR - 1280.D0/3.D0*x*rnf
     & *dlx*LR*LM + 640.D0/9.D0*x*rnf*dlx*LR*LM**2 - 176.D0/3.D0*x*rnf*
     & dlx*LR**2 - 14816.D0/27.D0*x*rnf*dlx*dlx1*LM + 400.D0/9.D0*x*rnf
     & *dlx*dlx1*LM**2 - 4160.D0/9.D0*x*rnf*dlx*dlx1*LR + 1088.D0/9.D0*
     & x*rnf*dlx*dlx1*LR*LM + 160.D0/3.D0*x*rnf*dlx*dlx1**2*LM + 688.D0/
     & 9.D0*x*rnf*dlx*dlx1**2*LR + 15748.D0/27.D0*x*rnf*dlx**2*LM - 736.
     & D0/9.D0*x*rnf*dlx**2*LM**2
      c2g_new = c2g_new + 32.D0/9.D0*x*rnf*dlx**2*LM**3 + 9856.D0/27.D0
     & *x*rnf*dlx**2*LR - 992.D0/9.D0*x*rnf*dlx**2*LR*LM - 544.D0/9.D0*
     & x*rnf*dlx**2*dlx1*LM - 496.D0/9.D0*x*rnf*dlx**2*dlx1*LR + 392.D0/
     & 3.D0*x*rnf*dlx**3*LM - 32.D0/3.D0*x*rnf*dlx**3*LM**2 + 1168.D0/
     & 27.D0*x*rnf*dlx**3*LR + 88.D0/9.D0*x*rnf*dlx**4*LM - 8756.D0/81.D
     & 0*x*rnf*Pi**2*LM + 208.D0/27.D0*x*rnf*Pi**2*LM**2 - 8608.D0/81.D0
     & *x*rnf*Pi**2*LR + 256.D0/9.D0*x*rnf*Pi**2*LR*LM + 88.D0/9.D0*x*
     & rnf*Pi**2*dlx1*LM + 416.D0/27.D0*x*rnf*Pi**2*dlx1*LR - 688.D0/9.D
     & 0*x*rnf*Pi**2*dlx*LM + 32.D0/9.D0*x*rnf*Pi**2*dlx*LM**2 - 1408.D0
     & /27.D0*x*rnf*Pi**2*dlx*LR - 32.D0/3.D0*x*rnf*Pi**2*dlx**2*LM - 
     & 16.D0/135.D0*x*rnf*Pi**4*LM + 64.D0/9.D0*x*rnf**2*LR**2 - 16.D0/
     & 9.D0*x*rnf**2*LR**2*LM - 16.D0/9.D0*x*rnf**2*dlx1*LR**2 + 16.D0/
     & 9.D0*x*rnf**2*dlx*LR**2 + 96760.D0/9.D0*x*Zeta3*LM + 1424.D0/9.D0
     & *x*Zeta3*LM**2 + 3168*x*Zeta3*LR - 8848.D0/3.D0*x*Zeta3*dlx1*LM
     &  + 62912.D0/9.D0*x*Zeta3*dlx*LM - 1424.D0/3.D0*x*Zeta3*rnf*LM + 
     & 64.D0/3.D0*x*Zeta3*rnf*LM**2
      c2g_new = c2g_new - 192*x*Zeta3*rnf*LR - 256.D0/3.D0*x*Zeta3*rnf*
     & dlx*LM + 258857.D0/5.D0*x**2*LM - 59231.D0/9.D0*x**2*LM**2 + 
     & 1282*x**2*LM**3 + 577174.D0/45.D0*x**2*LR - 6612*x**2*LR*LM + 
     & 1364*x**2*LR*LM**2 - 1936*x**2*LR**2 + 484*x**2*LR**2*LM - 
     & 4745182.D0/135.D0*x**2*dlx1*LM + 90874.D0/9.D0*x**2*dlx1*LM**2
     &  - 6952.D0/9.D0*x**2*dlx1*LM**3 - 37876.D0/3.D0*x**2*dlx1*LR + 
     & 21208.D0/3.D0*x**2*dlx1*LR*LM - 2288.D0/3.D0*x**2*dlx1*LR*LM**2
     &  + 484*x**2*dlx1*LR**2 + 145948.D0/9.D0*x**2*dlx1**2*LM - 26576.D
     & 0/9.D0*x**2*dlx1**2*LM**2 + 4256.D0/27.D0*x**2*dlx1**2*LM**3 + 
     & 3740*x**2*dlx1**2*LR - 2992.D0/3.D0*x**2*dlx1**2*LR*LM - 2528*
     & x**2*dlx1**3*LM + 2384.D0/9.D0*x**2*dlx1**3*LM**2 - 2552.D0/9.D0
     & *x**2*dlx1**3*LR + 3800.D0/27.D0*x**2*dlx1**4*LM + 3584506.D0/
     & 135.D0*x**2*dlx*LM - 103150.D0/9.D0*x**2*dlx*LM**2 + 2344.D0/9.D0
     & *x**2*dlx*LM**3 + 255028.D0/15.D0*x**2*dlx*LR - 23320.D0/3.D0*
     & x**2*dlx*LR*LM + 704.D0/3.D0*x**2*dlx*LR*LM**2 - 484*x**2*dlx*
     & LR**2
      c2g_new = c2g_new - 29864*x**2*dlx*dlx1*LM + 43424.D0/9.D0*x**2*
     & dlx*dlx1*LM**2 - 4256.D0/27.D0*x**2*dlx*dlx1*LM**3 - 8008*x**2*
     & dlx*dlx1*LR + 5984.D0/3.D0*x**2*dlx*dlx1*LR*LM + 74108.D0/9.D0*
     & x**2*dlx*dlx1**2*LM - 6896.D0/9.D0*x**2*dlx*dlx1**2*LM**2 + 3784.
     & D0/3.D0*x**2*dlx*dlx1**2*LR - 18608.D0/27.D0*x**2*dlx*dlx1**3*LM
     &  + 319384.D0/15.D0*x**2*dlx**2*LM - 10708.D0/9.D0*x**2*dlx**2*
     & LM**2 + 256.D0/27.D0*x**2*dlx**2*LM**3 + 5324*x**2*dlx**2*LR - 
     & 1408.D0/3.D0*x**2*dlx**2*LR*LM - 6628*x**2*dlx**2*dlx1*LM + 3896.
     & D0/9.D0*x**2*dlx**2*dlx1*LM**2 - 880*x**2*dlx**2*dlx1*LR + 8248.D
     & 0/9.D0*x**2*dlx**2*dlx1**2*LM + 39812.D0/27.D0*x**2*dlx**3*LM - 
     & 256.D0/9.D0*x**2*dlx**3*LM**2 + 1760.D0/9.D0*x**2*dlx**3*LR - 
     & 10648.D0/27.D0*x**2*dlx**3*dlx1*LM + 704.D0/27.D0*x**2*dlx**4*LM
     &  - 312904.D0/45.D0*x**2*Pi**2*LM + 22424.D0/27.D0*x**2*Pi**2*
     & LM**2 - 1088.D0/81.D0*x**2*Pi**2*LM**3 - 1980*x**2*Pi**2*LR + 
     & 2992.D0/9.D0*x**2*Pi**2*LR*LM + 20156.D0/9.D0*x**2*Pi**2*dlx1*LM
     &  - 5344.D0/27.D0*x**2*Pi**2*dlx1*LM**2
      c2g_new = c2g_new + 2200.D0/9.D0*x**2*Pi**2*dlx1*LR - 2464.D0/9.D0
     & *x**2*Pi**2*dlx1**2*LM - 75224.D0/27.D0*x**2*Pi**2*dlx*LM + 2432.
     & D0/27.D0*x**2*Pi**2*dlx*LM**2 - 1232.D0/3.D0*x**2*Pi**2*dlx*LR
     &  + 15008.D0/27.D0*x**2*Pi**2*dlx*dlx1*LM - 5240.D0/27.D0*x**2*
     & Pi**2*dlx**2*LM + 21376.D0/405.D0*x**2*Pi**4*LM - 2596676.D0/
     & 1215.D0*x**2*rnf*LM + 27488.D0/81.D0*x**2*rnf*LM**2 - 2108.D0/81.
     & D0*x**2*rnf*LM**3 - 118948.D0/135.D0*x**2*rnf*LR + 1280.D0/3.D0*
     & x**2*rnf*LR*LM - 248.D0/3.D0*x**2*rnf*LR*LM**2 + 704.D0/3.D0*
     & x**2*rnf*LR**2 - 176.D0/3.D0*x**2*rnf*LR**2*LM + 94264.D0/81.D0*
     & x**2*rnf*dlx1*LM - 5212.D0/27.D0*x**2*rnf*dlx1*LM**2 + 272.D0/27.
     & D0*x**2*rnf*dlx1*LM**3 + 7120.D0/9.D0*x**2*rnf*dlx1*LR - 3856.D0/
     & 9.D0*x**2*rnf*dlx1*LR*LM + 416.D0/9.D0*x**2*rnf*dlx1*LR*LM**2 - 
     & 176.D0/3.D0*x**2*rnf*dlx1*LR**2 - 1940.D0/9.D0*x**2*rnf*dlx1**2*
     & LM + 56.D0/3.D0*x**2*rnf*dlx1**2*LM**2 - 680.D0/3.D0*x**2*rnf*
     & dlx1**2*LR + 544.D0/9.D0*x**2*rnf*dlx1**2*LR*LM + 112.D0/9.D0*
     & x**2*rnf*dlx1**3*LM
      c2g_new = c2g_new + 464.D0/27.D0*x**2*rnf*dlx1**3*LR - 122944.D0/
     & 135.D0*x**2*rnf*dlx*LM + 3716.D0/27.D0*x**2*rnf*dlx*LM**2 - 
     & 47536.D0/45.D0*x**2*rnf*dlx*LR + 4240.D0/9.D0*x**2*rnf*dlx*LR*LM
     &  - 128.D0/9.D0*x**2*rnf*dlx*LR*LM**2 + 176.D0/3.D0*x**2*rnf*dlx*
     & LR**2 + 1400.D0/3.D0*x**2*rnf*dlx*dlx1*LM - 400.D0/9.D0*x**2*rnf
     & *dlx*dlx1*LM**2 + 1456.D0/3.D0*x**2*rnf*dlx*dlx1*LR - 1088.D0/9.D
     & 0*x**2*rnf*dlx*dlx1*LR*LM - 160.D0/3.D0*x**2*rnf*dlx*dlx1**2*LM
     &  - 688.D0/9.D0*x**2*rnf*dlx*dlx1**2*LR - 4060.D0/27.D0*x**2*rnf*
     & dlx**2*LM - 64.D0/9.D0*x**2*rnf*dlx**2*LM**2 - 968.D0/3.D0*x**2*
     & rnf*dlx**2*LR + 256.D0/9.D0*x**2*rnf*dlx**2*LR*LM + 536.D0/9.D0*
     & x**2*rnf*dlx**2*dlx1*LM + 160.D0/3.D0*x**2*rnf*dlx**2*dlx1*LR + 
     & 128.D0/9.D0*x**2*rnf*dlx**3*LM - 320.D0/27.D0*x**2*rnf*dlx**3*LR
     &  + 6340.D0/81.D0*x**2*rnf*Pi**2*LM - 104.D0/27.D0*x**2*rnf*Pi**2
     & *LM**2 + 120*x**2*rnf*Pi**2*LR - 544.D0/27.D0*x**2*rnf*Pi**2*LR*
     & LM - 256.D0/27.D0*x**2*rnf*Pi**2*dlx1*LM - 400.D0/27.D0*x**2*rnf
     & *Pi**2*dlx1*LR
      c2g_new = c2g_new + 80.D0/27.D0*x**2*rnf*Pi**2*dlx*LM + 224.D0/9.D
     & 0*x**2*rnf*Pi**2*dlx*LR - 64.D0/9.D0*x**2*rnf**2*LR**2 + 16.D0/9.
     & D0*x**2*rnf**2*LR**2*LM + 16.D0/9.D0*x**2*rnf**2*dlx1*LR**2 - 16.
     & D0/9.D0*x**2*rnf**2*dlx*LR**2 - 163184.D0/9.D0*x**2*Zeta3*LM + 
     & 3200.D0/9.D0*x**2*Zeta3*LM**2 - 3696*x**2*Zeta3*LR + 8512.D0/3.D0
     & *x**2*Zeta3*dlx1*LM - 13568.D0/9.D0*x**2*Zeta3*dlx*LM + 944.D0/9.
     & D0*x**2*Zeta3*rnf*LM + 224*x**2*Zeta3*rnf*LR + 4352.D0/15.D0*
     & x**3*dlx**2*LM + 1408.D0/5.D0*x**3*dlx**2*LR + 256.D0/5.D0*x**3*
     & dlx**3*LM - 4352.D0/45.D0*x**3*Pi**2*LM - 1408.D0/15.D0*x**3*
     & Pi**2*LR + 128.D0/5.D0*x**3*Pi**2*dlx1*LM - 512.D0/5.D0*x**3*
     & Pi**2*dlx*LM - 128.D0/15.D0*x**3*rnf*dlx**2*LM - 256.D0/15.D0*
     & x**3*rnf*dlx**2*LR + 128.D0/45.D0*x**3*rnf*Pi**2*LM + 256.D0/45.D
     & 0*x**3*rnf*Pi**2*LR - 768*x**3*Zeta3*LM - 2176.D0/135.D0*Hr1(-1)
     & *x**(-2)*dlx*LM - 704.D0/45.D0*Hr1(-1)*x**(-2)*dlx*LR - 64.D0/15.
     & D0*Hr1(-1)*x**(-2)*dlx**2*LM + 32.D0/15.D0*Hr1(-1)*x**(-2)*Pi**2
     & *LM
      c2g_new = c2g_new + 64.D0/135.D0*Hr1(-1)*x**(-2)*rnf*dlx*LM + 128.
     & D0/135.D0*Hr1(-1)*x**(-2)*rnf*dlx*LR + 28672.D0/15.D0*Hr1(-1)*
     & x**(-1)*dlx*LM + 192*Hr1(-1)*x**(-1)*dlx*LM**2 + 352*Hr1(-1)*
     & x**(-1)*dlx*LR - 1136.D0/3.D0*Hr1(-1)*x**(-1)*dlx**2*LM + 560.D0/
     & 9.D0*Hr1(-1)*x**(-1)*Pi**2*LM - 544.D0/27.D0*Hr1(-1)*x**(-1)*rnf
     & *dlx*LM - 64.D0/3.D0*Hr1(-1)*x**(-1)*rnf*dlx*LR + 126112.D0/45.D0
     & *Hr1(-1)*dlx*LM - 28.D0/9.D0*Hr1(-1)*dlx*LM**2 + 176*Hr1(-1)*dlx
     & *LR + 528*Hr1(-1)*dlx*LR*LM - 1724.D0/3.D0*Hr1(-1)*dlx**2*LM + 
     & 1244.D0/9.D0*Hr1(-1)*dlx**2*LM**2 - 1496.D0/3.D0*Hr1(-1)*dlx**2*
     & LR - 6308.D0/27.D0*Hr1(-1)*dlx**3*LM + 2410.D0/9.D0*Hr1(-1)*
     & Pi**2*LM - 1712.D0/27.D0*Hr1(-1)*Pi**2*LM**2 + 1100.D0/9.D0*Hr1(
     & -1)*Pi**2*LR + 8968.D0/27.D0*Hr1(-1)*Pi**2*dlx*LM + 256.D0/3.D0*
     & Hr1(-1)*rnf*dlx*LM - 8*Hr1(-1)*rnf*dlx*LM**2 - 32.D0/3.D0*Hr1(-1
     & )*rnf*dlx*LR - 32*Hr1(-1)*rnf*dlx*LR*LM + 208.D0/9.D0*Hr1(-1)*
     & rnf*dlx**2*LM + 272.D0/9.D0*Hr1(-1)*rnf*dlx**2*LR - 100.D0/27.D0
     & *Hr1(-1)*rnf*Pi**2*LM
      c2g_new = c2g_new - 200.D0/27.D0*Hr1(-1)*rnf*Pi**2*LR + 16408.D0/
     & 9.D0*Hr1(-1)*Zeta3*LM + 56456.D0/135.D0*Hr1(-1)*x*dlx*LM + 13160.
     & D0/9.D0*Hr1(-1)*x*dlx*LM**2 - 5632.D0/9.D0*Hr1(-1)*x*dlx*LR + 
     & 1056*Hr1(-1)*x*dlx*LR*LM - 43292.D0/9.D0*Hr1(-1)*x*dlx**2*LM + 
     & 2488.D0/9.D0*Hr1(-1)*x*dlx**2*LM**2 - 2992.D0/3.D0*Hr1(-1)*x*
     & dlx**2*LR - 12616.D0/27.D0*Hr1(-1)*x*dlx**3*LM + 35264.D0/27.D0*
     & Hr1(-1)*x*Pi**2*LM - 3424.D0/27.D0*Hr1(-1)*x*Pi**2*LM**2 + 2200.D
     & 0/9.D0*Hr1(-1)*x*Pi**2*LR + 17936.D0/27.D0*Hr1(-1)*x*Pi**2*dlx*
     & LM + 1520.D0/27.D0*Hr1(-1)*x*rnf*dlx*LM - 16*Hr1(-1)*x*rnf*dlx*
     & LM**2 + 1024.D0/27.D0*Hr1(-1)*x*rnf*dlx*LR - 64*Hr1(-1)*x*rnf*
     & dlx*LR*LM + 416.D0/9.D0*Hr1(-1)*x*rnf*dlx**2*LM + 544.D0/9.D0*
     & Hr1(-1)*x*rnf*dlx**2*LR - 200.D0/27.D0*Hr1(-1)*x*rnf*Pi**2*LM - 
     & 400.D0/27.D0*Hr1(-1)*x*rnf*Pi**2*LR + 32816.D0/9.D0*Hr1(-1)*x*
     & Zeta3*LM - 86944.D0/45.D0*Hr1(-1)*x**2*dlx*LM + 5224.D0/3.D0*
     & Hr1(-1)*x**2*dlx*LM**2 - 1760*Hr1(-1)*x**2*dlx*LR + 1056*Hr1(-1)
     & *x**2*dlx*LR*LM
      c2g_new = c2g_new - 48956.D0/9.D0*Hr1(-1)*x**2*dlx**2*LM + 2488.D0
     & /9.D0*Hr1(-1)*x**2*dlx**2*LM**2 - 3080.D0/3.D0*Hr1(-1)*x**2*
     & dlx**2*LR - 12760.D0/27.D0*Hr1(-1)*x**2*dlx**3*LM + 37616.D0/27.D
     & 0*Hr1(-1)*x**2*Pi**2*LM - 3424.D0/27.D0*Hr1(-1)*x**2*Pi**2*LM**2
     &  + 2288.D0/9.D0*Hr1(-1)*x**2*Pi**2*LR + 18224.D0/27.D0*Hr1(-1)*
     & x**2*Pi**2*dlx*LM + 464.D0/27.D0*Hr1(-1)*x**2*rnf*dlx*LM - 16*
     & Hr1(-1)*x**2*rnf*dlx*LM**2 + 320.D0/3.D0*Hr1(-1)*x**2*rnf*dlx*LR
     &  - 64*Hr1(-1)*x**2*rnf*dlx*LR*LM + 424.D0/9.D0*Hr1(-1)*x**2*rnf*
     & dlx**2*LM + 560.D0/9.D0*Hr1(-1)*x**2*rnf*dlx**2*LR - 208.D0/27.D0
     & *Hr1(-1)*x**2*rnf*Pi**2*LM - 416.D0/27.D0*Hr1(-1)*x**2*rnf*Pi**2
     & *LR + 33824.D0/9.D0*Hr1(-1)*x**2*Zeta3*LM - 8704.D0/15.D0*Hr1(-1
     & )*x**3*dlx*LM - 2816.D0/5.D0*Hr1(-1)*x**3*dlx*LR - 768.D0/5.D0*
     & Hr1(-1)*x**3*dlx**2*LM + 384.D0/5.D0*Hr1(-1)*x**3*Pi**2*LM + 256.
     & D0/15.D0*Hr1(-1)*x**3*rnf*dlx*LM + 512.D0/15.D0*Hr1(-1)*x**3*rnf
     & *dlx*LR + 128.D0/15.D0*Hr2(-1,-1)*x**(-2)*dlx*LM - 64.D0/3.D0*
     & Hr2(-1,-1)*x**(-1)*dlx*LM
      c2g_new = c2g_new + 8872.D0/9.D0*Hr2(-1,-1)*dlx*LM - 3104.D0/9.D0
     & *Hr2(-1,-1)*dlx*LM**2 + 1232.D0/3.D0*Hr2(-1,-1)*dlx*LR + 9352.D0/
     & 9.D0*Hr2(-1,-1)*dlx**2*LM - 8584.D0/27.D0*Hr2(-1,-1)*Pi**2*LM - 
     & 112.D0/9.D0*Hr2(-1,-1)*rnf*dlx*LM - 224.D0/9.D0*Hr2(-1,-1)*rnf*
     & dlx*LR + 13600.D0/3.D0*Hr2(-1,-1)*x*dlx*LM - 6208.D0/9.D0*Hr2(-1
     & ,-1)*x*dlx*LM**2 + 2464.D0/3.D0*Hr2(-1,-1)*x*dlx*LR + 18704.D0/9.
     & D0*Hr2(-1,-1)*x*dlx**2*LM - 17168.D0/27.D0*Hr2(-1,-1)*x*Pi**2*LM
     &  - 224.D0/9.D0*Hr2(-1,-1)*x*rnf*dlx*LM - 448.D0/9.D0*Hr2(-1,-1)*
     & x*rnf*dlx*LR + 44000.D0/9.D0*Hr2(-1,-1)*x**2*dlx*LM - 6208.D0/9.D
     & 0*Hr2(-1,-1)*x**2*dlx*LM**2 + 2816.D0/3.D0*Hr2(-1,-1)*x**2*dlx*
     & LR + 19136.D0/9.D0*Hr2(-1,-1)*x**2*dlx**2*LM - 17744.D0/27.D0*
     & Hr2(-1,-1)*x**2*Pi**2*LM - 256.D0/9.D0*Hr2(-1,-1)*x**2*rnf*dlx*
     & LM - 512.D0/9.D0*Hr2(-1,-1)*x**2*rnf*dlx*LR + 1536.D0/5.D0*Hr2(
     & -1,-1)*x**3*dlx*LM + 2176.D0/135.D0*Hr2(0,-1)*x**(-2)*LM + 704.D0
     & /45.D0*Hr2(0,-1)*x**(-2)*LR + 128.D0/15.D0*Hr2(0,-1)*x**(-2)*dlx
     & *LM
      c2g_new = c2g_new - 64.D0/135.D0*Hr2(0,-1)*x**(-2)*rnf*LM - 128.D0
     & /135.D0*Hr2(0,-1)*x**(-2)*rnf*LR - 28672.D0/15.D0*Hr2(0,-1)*
     & x**(-1)*LM - 192*Hr2(0,-1)*x**(-1)*LM**2 - 352*Hr2(0,-1)*x**(-1)
     & *LR + 2848.D0/3.D0*Hr2(0,-1)*x**(-1)*dlx*LM + 544.D0/27.D0*Hr2(0
     & ,-1)*x**(-1)*rnf*LM + 64.D0/3.D0*Hr2(0,-1)*x**(-1)*rnf*LR - 
     & 126112.D0/45.D0*Hr2(0,-1)*LM + 28.D0/9.D0*Hr2(0,-1)*LM**2 - 176*
     & Hr2(0,-1)*LR - 528*Hr2(0,-1)*LR*LM + 3920.D0/9.D0*Hr2(0,-1)*dlx*
     & LM - 536*Hr2(0,-1)*dlx*LM**2 + 176.D0/3.D0*Hr2(0,-1)*dlx*LR + 
     & 2480.D0/9.D0*Hr2(0,-1)*dlx*dlx1*LM + 2072.D0/3.D0*Hr2(0,-1)*
     & dlx**2*LM - 3716.D0/27.D0*Hr2(0,-1)*Pi**2*LM - 256.D0/3.D0*Hr2(0
     & ,-1)*rnf*LM + 8*Hr2(0,-1)*rnf*LM**2 + 32.D0/3.D0*Hr2(0,-1)*rnf*
     & LR + 32*Hr2(0,-1)*rnf*LR*LM + 224.D0/9.D0*Hr2(0,-1)*rnf*dlx*LM
     &  - 32.D0/9.D0*Hr2(0,-1)*rnf*dlx*LR - 56456.D0/135.D0*Hr2(0,-1)*x
     & *LM - 13160.D0/9.D0*Hr2(0,-1)*x*LM**2 + 5632.D0/9.D0*Hr2(0,-1)*x
     & *LR - 1056*Hr2(0,-1)*x*LR*LM + 5936*Hr2(0,-1)*x*dlx*LM + 656*
     & Hr2(0,-1)*x*dlx*LM**2
      c2g_new = c2g_new + 5984.D0/3.D0*Hr2(0,-1)*x*dlx*LR - 4960.D0/9.D0
     & *Hr2(0,-1)*x*dlx*dlx1*LM - 14896.D0/9.D0*Hr2(0,-1)*x*dlx**2*LM
     &  + 296.D0/9.D0*Hr2(0,-1)*x*Pi**2*LM - 1520.D0/27.D0*Hr2(0,-1)*x*
     & rnf*LM + 16*Hr2(0,-1)*x*rnf*LM**2 - 1024.D0/27.D0*Hr2(0,-1)*x*
     & rnf*LR + 64*Hr2(0,-1)*x*rnf*LR*LM - 1600.D0/9.D0*Hr2(0,-1)*x*rnf
     & *dlx*LM - 1088.D0/9.D0*Hr2(0,-1)*x*rnf*dlx*LR + 86944.D0/45.D0*
     & Hr2(0,-1)*x**2*LM - 5224.D0/3.D0*Hr2(0,-1)*x**2*LM**2 + 1760*
     & Hr2(0,-1)*x**2*LR - 1056*Hr2(0,-1)*x**2*LR*LM + 19352.D0/9.D0*
     & Hr2(0,-1)*x**2*dlx*LM - 3952.D0/9.D0*Hr2(0,-1)*x**2*dlx*LM**2 + 
     & 176.D0/3.D0*Hr2(0,-1)*x**2*dlx*LR + 4960.D0/9.D0*Hr2(0,-1)*x**2*
     & dlx*dlx1*LM - 40.D0/9.D0*Hr2(0,-1)*x**2*dlx**2*LM - 112.D0/9.D0*
     & Hr2(0,-1)*x**2*Pi**2*LM - 464.D0/27.D0*Hr2(0,-1)*x**2*rnf*LM + 
     & 16*Hr2(0,-1)*x**2*rnf*LM**2 - 320.D0/3.D0*Hr2(0,-1)*x**2*rnf*LR
     &  + 64*Hr2(0,-1)*x**2*rnf*LR*LM - 16.D0/3.D0*Hr2(0,-1)*x**2*rnf*
     & dlx*LM - 32.D0/9.D0*Hr2(0,-1)*x**2*rnf*dlx*LR + 8704.D0/15.D0*
     & Hr2(0,-1)*x**3*LM
      c2g_new = c2g_new + 2816.D0/5.D0*Hr2(0,-1)*x**3*LR - 256.D0/15.D0
     & *Hr2(0,-1)*x**3*rnf*LM - 512.D0/15.D0*Hr2(0,-1)*x**3*rnf*LR + 
     & 53584.D0/45.D0*Hr2(0,1)*x**(-1)*LM - 544.D0/3.D0*Hr2(0,1)*
     & x**(-1)*LM**2 + 352*Hr2(0,1)*x**(-1)*LR + 1696.D0/3.D0*Hr2(0,1)*
     & x**(-1)*dlx*LM - 544.D0/27.D0*Hr2(0,1)*x**(-1)*rnf*LM - 64.D0/3.D
     & 0*Hr2(0,1)*x**(-1)*rnf*LR + 111328.D0/45.D0*Hr2(0,1)*LM + 4228.D0
     & /9.D0*Hr2(0,1)*LM**2 - 176*Hr2(0,1)*LM**3 - 88.D0/3.D0*Hr2(0,1)*
     & LR + 1936.D0/3.D0*Hr2(0,1)*LR*LM + 2800.D0/9.D0*Hr2(0,1)*dlx1*LM
     &  + 880.D0/3.D0*Hr2(0,1)*dlx1*LR - 320.D0/9.D0*Hr2(0,1)*dlx1**2*
     & LM - 5140.D0/9.D0*Hr2(0,1)*dlx*LM + 6008.D0/9.D0*Hr2(0,1)*dlx*
     & LM**2 - 1672.D0/3.D0*Hr2(0,1)*dlx*LR - 352.D0/9.D0*Hr2(0,1)*dlx*
     & dlx1*LM - 8222.D0/9.D0*Hr2(0,1)*dlx**2*LM + 324*Hr2(0,1)*Pi**2*
     & LM - 4544.D0/27.D0*Hr2(0,1)*rnf*LM + 8.D0/9.D0*Hr2(0,1)*rnf*
     & LM**2 + 16.D0/9.D0*Hr2(0,1)*rnf*LR - 352.D0/9.D0*Hr2(0,1)*rnf*LR
     & *LM - 160.D0/9.D0*Hr2(0,1)*rnf*dlx1*LM - 160.D0/9.D0*Hr2(0,1)*
     & rnf*dlx1*LR
      c2g_new = c2g_new + 128.D0/9.D0*Hr2(0,1)*rnf*dlx*LM + 304.D0/9.D0
     & *Hr2(0,1)*rnf*dlx*LR - 230672.D0/45.D0*Hr2(0,1)*x*LM + 25216.D0/
     & 9.D0*Hr2(0,1)*x*LM**2 - 352*Hr2(0,1)*x*LM**3 - 3520*Hr2(0,1)*x*
     & LR + 5632.D0/3.D0*Hr2(0,1)*x*LR*LM - 5920.D0/9.D0*Hr2(0,1)*x*
     & dlx1*LM - 1760.D0/3.D0*Hr2(0,1)*x*dlx1*LR + 640.D0/9.D0*Hr2(0,1)
     & *x*dlx1**2*LM - 87308.D0/9.D0*Hr2(0,1)*x*dlx*LM + 18224.D0/9.D0*
     & Hr2(0,1)*x*dlx*LM**2 - 6160.D0/3.D0*Hr2(0,1)*x*dlx*LR + 704.D0/9.
     & D0*Hr2(0,1)*x*dlx*dlx1*LM - 24268.D0/9.D0*Hr2(0,1)*x*dlx**2*LM
     &  + 20408.D0/27.D0*Hr2(0,1)*x*Pi**2*LM + 4216.D0/27.D0*Hr2(0,1)*x
     & *rnf*LM - 160.D0/9.D0*Hr2(0,1)*x*rnf*LM**2 + 640.D0/3.D0*Hr2(0,1
     & )*x*rnf*LR - 1024.D0/9.D0*Hr2(0,1)*x*rnf*LR*LM + 320.D0/9.D0*
     & Hr2(0,1)*x*rnf*dlx1*LM + 320.D0/9.D0*Hr2(0,1)*x*rnf*dlx1*LR + 32.
     & D0/9.D0*Hr2(0,1)*x*rnf*dlx*LM + 1120.D0/9.D0*Hr2(0,1)*x*rnf*dlx*
     & LR + 177848.D0/15.D0*Hr2(0,1)*x**2*LM - 1424.D0/9.D0*Hr2(0,1)*
     & x**2*LM**2 - 2080.D0/27.D0*Hr2(0,1)*x**2*LM**3 + 3872*Hr2(0,1)*
     & x**2*LR
      c2g_new = c2g_new + 1760.D0/3.D0*Hr2(0,1)*x**2*dlx1*LM + 1760.D0/
     & 3.D0*Hr2(0,1)*x**2*dlx1*LR - 640.D0/9.D0*Hr2(0,1)*x**2*dlx1**2*
     & LM + 24712.D0/9.D0*Hr2(0,1)*x**2*dlx*LM + 112.D0/3.D0*Hr2(0,1)*
     & x**2*dlx*LM**2 + 704.D0/3.D0*Hr2(0,1)*x**2*dlx*LR - 992.D0/9.D0*
     & Hr2(0,1)*x**2*dlx*dlx1*LM - 1352.D0/9.D0*Hr2(0,1)*x**2*dlx**2*LM
     &  + 4256.D0/27.D0*Hr2(0,1)*x**2*Pi**2*LM - 80.D0/27.D0*Hr2(0,1)*
     & x**2*rnf*LM - 64.D0/3.D0*Hr2(0,1)*x**2*rnf*LM**2 - 704.D0/3.D0*
     & Hr2(0,1)*x**2*rnf*LR - 320.D0/9.D0*Hr2(0,1)*x**2*rnf*dlx1*LM - 
     & 320.D0/9.D0*Hr2(0,1)*x**2*rnf*dlx1*LR + 656.D0/9.D0*Hr2(0,1)*
     & x**2*rnf*dlx*LM - 128.D0/9.D0*Hr2(0,1)*x**2*rnf*dlx*LR - 5792.D0/
     & 9.D0*Hr3(-1,-1,-1)*dlx*LM - 11584.D0/9.D0*Hr3(-1,-1,-1)*x*dlx*LM
     &  - 12736.D0/9.D0*Hr3(-1,-1,-1)*x**2*dlx*LM - 128.D0/15.D0*Hr3(-1
     & ,0,-1)*x**(-2)*LM + 64.D0/3.D0*Hr3(-1,0,-1)*x**(-1)*LM - 8872.D0/
     & 9.D0*Hr3(-1,0,-1)*LM + 3104.D0/9.D0*Hr3(-1,0,-1)*LM**2 - 1232.D0/
     & 3.D0*Hr3(-1,0,-1)*LR - 4064.D0/3.D0*Hr3(-1,0,-1)*dlx*LM + 112.D0/
     & 9.D0*Hr3(-1,0,-1)*rnf*LM
      c2g_new = c2g_new + 224.D0/9.D0*Hr3(-1,0,-1)*rnf*LR - 13600.D0/3.D
     & 0*Hr3(-1,0,-1)*x*LM + 6208.D0/9.D0*Hr3(-1,0,-1)*x*LM**2 - 2464.D0
     & /3.D0*Hr3(-1,0,-1)*x*LR - 8128.D0/3.D0*Hr3(-1,0,-1)*x*dlx*LM + 
     & 224.D0/9.D0*Hr3(-1,0,-1)*x*rnf*LM + 448.D0/9.D0*Hr3(-1,0,-1)*x*
     & rnf*LR - 44000.D0/9.D0*Hr3(-1,0,-1)*x**2*LM + 6208.D0/9.D0*Hr3(
     & -1,0,-1)*x**2*LM**2 - 2816.D0/3.D0*Hr3(-1,0,-1)*x**2*LR - 8224.D0
     & /3.D0*Hr3(-1,0,-1)*x**2*dlx*LM + 256.D0/9.D0*Hr3(-1,0,-1)*x**2*
     & rnf*LM + 512.D0/9.D0*Hr3(-1,0,-1)*x**2*rnf*LR - 1536.D0/5.D0*
     & Hr3(-1,0,-1)*x**3*LM - 128.D0/15.D0*Hr3(-1,0,1)*x**(-2)*LM - 384
     & *Hr3(-1,0,1)*x**(-1)*LM - 10024.D0/9.D0*Hr3(-1,0,1)*LM + 208*
     & Hr3(-1,0,1)*LM**2 - 528*Hr3(-1,0,1)*LR - 544*Hr3(-1,0,1)*dlx*LM
     &  + 16*Hr3(-1,0,1)*rnf*LM + 32*Hr3(-1,0,1)*rnf*LR - 50128.D0/9.D0
     & *Hr3(-1,0,1)*x*LM + 416*Hr3(-1,0,1)*x*LM**2 - 1056*Hr3(-1,0,1)*x
     & *LR - 1088*Hr3(-1,0,1)*x*dlx*LM + 32*Hr3(-1,0,1)*x*rnf*LM + 64*
     & Hr3(-1,0,1)*x*rnf*LR - 17744.D0/3.D0*Hr3(-1,0,1)*x**2*LM + 416*
     & Hr3(-1,0,1)*x**2*LM**2
      c2g_new = c2g_new - 1056*Hr3(-1,0,1)*x**2*LR - 1088*Hr3(-1,0,1)*
     & x**2*dlx*LM + 32*Hr3(-1,0,1)*x**2*rnf*LM + 64*Hr3(-1,0,1)*x**2*
     & rnf*LR - 1536.D0/5.D0*Hr3(-1,0,1)*x**3*LM - 128.D0/15.D0*Hr3(0,
     & -1,-1)*x**(-2)*LM + 64.D0/3.D0*Hr3(0,-1,-1)*x**(-1)*LM - 8872.D0/
     & 9.D0*Hr3(0,-1,-1)*LM + 3104.D0/9.D0*Hr3(0,-1,-1)*LM**2 - 1232.D0/
     & 3.D0*Hr3(0,-1,-1)*LR - 9664.D0/9.D0*Hr3(0,-1,-1)*dlx*LM + 112.D0/
     & 9.D0*Hr3(0,-1,-1)*rnf*LM + 224.D0/9.D0*Hr3(0,-1,-1)*rnf*LR - 
     & 13600.D0/3.D0*Hr3(0,-1,-1)*x*LM + 6208.D0/9.D0*Hr3(0,-1,-1)*x*
     & LM**2 - 2464.D0/3.D0*Hr3(0,-1,-1)*x*LR - 20608.D0/9.D0*Hr3(0,-1,
     & -1)*x*dlx*LM + 224.D0/9.D0*Hr3(0,-1,-1)*x*rnf*LM + 448.D0/9.D0*
     & Hr3(0,-1,-1)*x*rnf*LR - 44000.D0/9.D0*Hr3(0,-1,-1)*x**2*LM + 
     & 6208.D0/9.D0*Hr3(0,-1,-1)*x**2*LM**2 - 2816.D0/3.D0*Hr3(0,-1,-1)
     & *x**2*LR - 4864.D0/3.D0*Hr3(0,-1,-1)*x**2*dlx*LM + 256.D0/9.D0*
     & Hr3(0,-1,-1)*x**2*rnf*LM + 512.D0/9.D0*Hr3(0,-1,-1)*x**2*rnf*LR
     &  - 1536.D0/5.D0*Hr3(0,-1,-1)*x**3*LM + 2480.D0/9.D0*Hr3(0,-1,1)*
     & dlx*LM
      c2g_new = c2g_new - 4960.D0/9.D0*Hr3(0,-1,1)*x*dlx*LM + 4960.D0/9.
     & D0*Hr3(0,-1,1)*x**2*dlx*LM - 128.D0/15.D0*Hr3(0,0,-1)*x**(-2)*LM
     &  - 3424.D0/3.D0*Hr3(0,0,-1)*x**(-1)*LM + 2504.D0/9.D0*Hr3(0,0,-1
     & )*LM + 7160.D0/9.D0*Hr3(0,0,-1)*LM**2 + 880*Hr3(0,0,-1)*LR - 
     & 4960.D0/9.D0*Hr3(0,0,-1)*dlx1*LM + 1168.D0/9.D0*Hr3(0,0,-1)*dlx*
     & LM - 96*Hr3(0,0,-1)*rnf*LM - 160.D0/3.D0*Hr3(0,0,-1)*rnf*LR - 
     & 20264.D0/9.D0*Hr3(0,0,-1)*x*LM - 16784.D0/9.D0*Hr3(0,0,-1)*x*
     & LM**2 - 5984.D0/3.D0*Hr3(0,0,-1)*x*LR + 9920.D0/9.D0*Hr3(0,0,-1)
     & *x*dlx1*LM + 7872*Hr3(0,0,-1)*x*dlx*LM + 2368.D0/9.D0*Hr3(0,0,-1
     & )*x*rnf*LM + 1088.D0/9.D0*Hr3(0,0,-1)*x*rnf*LR + 19736.D0/3.D0*
     & Hr3(0,0,-1)*x**2*LM + 976.D0/3.D0*Hr3(0,0,-1)*x**2*LM**2 + 1936*
     & Hr3(0,0,-1)*x**2*LR - 9920.D0/9.D0*Hr3(0,0,-1)*x**2*dlx1*LM + 
     & 22096.D0/9.D0*Hr3(0,0,-1)*x**2*dlx*LM - 752.D0/9.D0*Hr3(0,0,-1)*
     & x**2*rnf*LM - 352.D0/3.D0*Hr3(0,0,-1)*x**2*rnf*LR + 1536.D0/5.D0
     & *Hr3(0,0,-1)*x**3*LM - 544.D0/3.D0*Hr3(0,0,1)*x**(-1)*LM + 808.D0
     & /3.D0*Hr3(0,0,1)*LM
      c2g_new = c2g_new - 3944.D0/9.D0*Hr3(0,0,1)*LM**2 + 440.D0/3.D0*
     & Hr3(0,0,1)*LR + 32.D0/9.D0*Hr3(0,0,1)*dlx1*LM + 4624.D0/3.D0*
     & Hr3(0,0,1)*dlx*LM - 256.D0/3.D0*Hr3(0,0,1)*rnf*LM + 32.D0/3.D0*
     & Hr3(0,0,1)*rnf*LM**2 - 80.D0/9.D0*Hr3(0,0,1)*rnf*LR - 64.D0/3.D0
     & *Hr3(0,0,1)*rnf*dlx*LM + 39448.D0/9.D0*Hr3(0,0,1)*x*LM - 8816.D0/
     & 9.D0*Hr3(0,0,1)*x*LM**2 + 2288.D0/3.D0*Hr3(0,0,1)*x*LR - 64.D0/9.
     & D0*Hr3(0,0,1)*x*dlx1*LM + 20480.D0/9.D0*Hr3(0,0,1)*x*dlx*LM + 
     & 736.D0/3.D0*Hr3(0,0,1)*x*rnf*LM - 64.D0/3.D0*Hr3(0,0,1)*x*rnf*
     & LM**2 - 416.D0/9.D0*Hr3(0,0,1)*x*rnf*LR + 128.D0/3.D0*Hr3(0,0,1)
     & *x*rnf*dlx*LM - 18280.D0/9.D0*Hr3(0,0,1)*x**2*LM + 752.D0/3.D0*
     & Hr3(0,0,1)*x**2*LM**2 + 704.D0/3.D0*Hr3(0,0,1)*x**2*LR + 640.D0/
     & 9.D0*Hr3(0,0,1)*x**2*dlx1*LM + 1808.D0/3.D0*Hr3(0,0,1)*x**2*dlx*
     & LM - 400.D0/9.D0*Hr3(0,0,1)*x**2*rnf*LM - 128.D0/9.D0*Hr3(0,0,1)
     & *x**2*rnf*LR + 1536.D0/5.D0*Hr3(0,0,1)*x**3*LM + 2480.D0/9.D0*
     & Hr3(0,1,-1)*dlx*LM - 4960.D0/9.D0*Hr3(0,1,-1)*x*dlx*LM + 4960.D0/
     & 9.D0*Hr3(0,1,-1)*x**2*dlx*LM
      c2g_new = c2g_new + 448*Hr3(0,1,1)*x**(-1)*LM - 7096.D0/9.D0*Hr3(
     & 0,1,1)*LM + 6880.D0/9.D0*Hr3(0,1,1)*LM**2 - 616.D0/3.D0*Hr3(0,1,
     & 1)*LR - 14704.D0/9.D0*Hr3(0,1,1)*dlx*LM - 256.D0/9.D0*Hr3(0,1,1)
     & *rnf*LM + 112.D0/9.D0*Hr3(0,1,1)*rnf*LR - 91744.D0/9.D0*Hr3(0,1,
     & 1)*x*LM + 16480.D0/9.D0*Hr3(0,1,1)*x*LM**2 - 8272.D0/3.D0*Hr3(0,
     & 1,1)*x*LR - 45760.D0/9.D0*Hr3(0,1,1)*x*dlx*LM + 800.D0/9.D0*Hr3(
     & 0,1,1)*x*rnf*LM + 1504.D0/9.D0*Hr3(0,1,1)*x*rnf*LR + 23456.D0/9.D
     & 0*Hr3(0,1,1)*x**2*LM + 2080.D0/9.D0*Hr3(0,1,1)*x**2*LM**2 + 880*
     & Hr3(0,1,1)*x**2*LR - 352.D0/9.D0*Hr3(0,1,1)*x**2*dlx*LM - 32.D0/
     & 3.D0*Hr3(0,1,1)*x**2*rnf*LM - 160.D0/3.D0*Hr3(0,1,1)*x**2*rnf*LR
     &  + 5792.D0/9.D0*Hr4(-1,-1,0,-1)*LM + 11584.D0/9.D0*Hr4(-1,-1,0,
     & -1)*x*LM + 12736.D0/9.D0*Hr4(-1,-1,0,-1)*x**2*LM + 14272.D0/9.D0
     & *Hr4(-1,-1,0,1)*LM + 28544.D0/9.D0*Hr4(-1,-1,0,1)*x*LM + 29120.D0
     & /9.D0*Hr4(-1,-1,0,1)*x**2*LM + 5792.D0/9.D0*Hr4(-1,0,-1,-1)*LM
     &  + 11584.D0/9.D0*Hr4(-1,0,-1,-1)*x*LM + 12736.D0/9.D0*Hr4(-1,0,
     & -1,-1)*x**2*LM
      c2g_new = c2g_new + 5680.D0/9.D0*Hr4(-1,0,0,-1)*LM + 11360.D0/9.D0
     & *Hr4(-1,0,0,-1)*x*LM + 11072.D0/9.D0*Hr4(-1,0,0,-1)*x**2*LM - 
     & 6128.D0/9.D0*Hr4(-1,0,0,1)*LM - 12256.D0/9.D0*Hr4(-1,0,0,1)*x*LM
     &  - 12544.D0/9.D0*Hr4(-1,0,0,1)*x**2*LM - 544*Hr4(-1,0,1,1)*LM - 
     & 1088*Hr4(-1,0,1,1)*x*LM - 1088*Hr4(-1,0,1,1)*x**2*LM + 5792.D0/9.
     & D0*Hr4(0,-1,-1,-1)*LM + 11584.D0/9.D0*Hr4(0,-1,-1,-1)*x*LM + 
     & 12736.D0/9.D0*Hr4(0,-1,-1,-1)*x**2*LM + 3152.D0/9.D0*Hr4(0,-1,0,
     & -1)*LM + 2528.D0/3.D0*Hr4(0,-1,0,-1)*x*LM + 992.D0/9.D0*Hr4(0,-1
     & ,0,-1)*x**2*LM - 1088.D0/9.D0*Hr4(0,-1,0,1)*LM - 19456.D0/9.D0*
     & Hr4(0,-1,0,1)*x*LM - 14144.D0/9.D0*Hr4(0,-1,0,1)*x**2*LM + 208.D0
     & /3.D0*Hr4(0,0,-1,-1)*LM + 3808.D0/9.D0*Hr4(0,0,-1,-1)*x*LM - 
     & 9088.D0/9.D0*Hr4(0,0,-1,-1)*x**2*LM - 4960.D0/9.D0*Hr4(0,0,-1,1)
     & *LM + 9920.D0/9.D0*Hr4(0,0,-1,1)*x*LM - 9920.D0/9.D0*Hr4(0,0,-1,
     & 1)*x**2*LM - 28184.D0/9.D0*Hr4(0,0,0,-1)*LM - 97936.D0/9.D0*Hr4(
     & 0,0,0,-1)*x*LM - 40528.D0/9.D0*Hr4(0,0,0,-1)*x**2*LM - 8840.D0/9.
     & D0*Hr4(0,0,0,1)*LM
      c2g_new = c2g_new - 2512.D0/9.D0*Hr4(0,0,0,1)*x*LM - 944*Hr4(0,0,
     & 0,1)*x**2*LM - 4960.D0/9.D0*Hr4(0,0,1,-1)*LM + 9920.D0/9.D0*Hr4(
     & 0,0,1,-1)*x*LM - 9920.D0/9.D0*Hr4(0,0,1,-1)*x**2*LM + 2096.D0/3.D
     & 0*Hr4(0,0,1,1)*LM - 64.D0/3.D0*Hr4(0,0,1,1)*rnf*LM + 5120.D0/3.D0
     & *Hr4(0,0,1,1)*x*LM + 128.D0/3.D0*Hr4(0,0,1,1)*x*rnf*LM - 4640.D0/
     & 9.D0*Hr4(0,0,1,1)*x**2*LM - 2480.D0/9.D0*Hr4(0,1,0,-1)*LM + 4960.
     & D0/9.D0*Hr4(0,1,0,-1)*x*LM - 4960.D0/9.D0*Hr4(0,1,0,-1)*x**2*LM
     &  - 640.D0/9.D0*Hr4(0,1,0,1)*LM + 1280.D0/9.D0*Hr4(0,1,0,1)*x*LM
     &  - 544.D0/3.D0*Hr4(0,1,0,1)*x**2*LM - 12688.D0/9.D0*Hr4(0,1,1,1)
     & *LM - 42016.D0/9.D0*Hr4(0,1,1,1)*x*LM + 160.D0/3.D0*Hr4(0,1,1,1)
     & *x**2*LM 
             c2g_new = c2g_new + c2g_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             c2g_new =  0 
         elseif (iorder.eq.1) then 
             c2g_new =  0 
         elseif (iorder.eq.2) then 
             c2g_new =  0 
         elseif (iorder.eq.3) then 
             c2g_new =  0 
             c2g_new = c2g_new + c2g_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      endif      
      return     
      end function c2g_new  
