!>***************************************************
!> Exact DIS coefficient funtion c2q_new in x space
!> including scale dependence
!>
      function c2q_new(iorder,x,ireg,rmu2,fmu2,q2, flavchange)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      implicit none
      integer iorder,ireg, flavchange
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
      common /Hrs/ Hr1,Hr2,Hr3,Hr4,Hr5
!$omp threadprivate(/Hrs/)
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR
      real*8 c2q_new,x


      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             c2q_new =  + 1 
         elseif (iorder.eq.1) then 
             c2q_new =  + LM * ( 4 + 16.D0/3.D0*dd0 )
             c2q_new = c2q_new - 12 + 16.D0/3.D0*dd1 - 4*dd0 - 8.D0/9.D0*Pi**2 ! Delta part of (4.2) arxiv:0504242.
             ! CF multiplied out along with zeta(2)
         elseif (iorder.eq.2) then 
             c2q_new =  + LM * ( 98 + 128.D0/3.D0*dd2 - 80*dd1 + 748.D0/
     &    9.D0*dd0 + 16*Pi**2 - 400.D0/27.D0*Pi**2*dd0 + 208.D0/9.D0*
     &    Zeta3 )
      c2q_new = c2q_new + LM**2 * (  - 14 + 256.D0/9.D0*dd1 - 8*dd0 - 
     &    64.D0/27.D0*Pi**2 )
      c2q_new = c2q_new + LR * ( 132 - 176.D0/3.D0*dd1 + 44*dd0 + 88.D0/
     &    9.D0*Pi**2 )
      c2q_new = c2q_new + LR*LM * (  - 44 - 176.D0/3.D0*dd0 )
      c2q_new = c2q_new + rnf * ( 457.D0/27.D0 + 16.D0/9.D0*dd2 - 232.D0
     &    /27.D0*dd1 + 988.D0/81.D0*dd0 + 76.D0/27.D0*Pi**2 - 16.D0/27.D
     &    0*Pi**2*dd0 + 16.D0/9.D0*Zeta3 )
      c2q_new = c2q_new + rnf*LM * (  - 76.D0/9.D0 + 32.D0/9.D0*dd1 - 
     &    232.D0/27.D0*dd0 - 32.D0/27.D0*Pi**2 )
      c2q_new = c2q_new + rnf*LM**2 * ( 4.D0/3.D0 + 16.D0/9.D0*dd0 )
      c2q_new = c2q_new + rnf*LR * (  - 8 + 32.D0/9.D0*dd1 - 8.D0/3.D0*
     &    dd0 - 16.D0/27.D0*Pi**2 )
      c2q_new = c2q_new + rnf*LR*LM * ( 8.D0/3.D0 + 32.D0/9.D0*dd0 )
      c2q_new = c2q_new - 4141.D0/18.D0 + 128.D0/9.D0*dd3 - 184.D0/3.D0
     &    *dd2 + 1036.D0/9.D0*dd1 - 5086.D0/27.D0*dd0 - 106.D0/3.D0*
     &    Pi**2 - 400.D0/27.D0*Pi**2*dd1 + 184.D0/9.D0*Pi**2*dd0 + 253.D
     &    0/135.D0*Pi**4 + 48*Zeta3 + 1312.D0/9.D0*Zeta3*dd0 
         elseif (iorder.eq.3) then 
             c2q_new = 131770.D0/27.D0*LM - 1058*LM**2 + 84*LM**3 + 
     & 56567.D0/9.D0*LR - 2564*LR*LM + 308*LR*LM**2 - 1452*LR**2 + 484*
     & LR**2*LM + 2560.D0/27.D0*dd4*LM - 18688.D0/27.D0*dd3*LM + 4096.D0
     & /27.D0*dd3*LM**2 - 2816.D0/9.D0*dd3*LR + 26800.D0/9.D0*dd2*LM - 
     & 704*dd2*LM**2 + 2048.D0/27.D0*dd2*LM**3 + 4048.D0/3.D0*dd2*LR - 
     & 2816.D0/3.D0*dd2*LR*LM - 445784.D0/81.D0*dd1*LM + 48560.D0/27.D0
     & *dd1*LM**2 - 1792.D0/9.D0*dd1*LM**3 - 27688.D0/9.D0*dd1*LR + 
     & 1760*dd1*LR*LM - 5632.D0/9.D0*dd1*LR*LM**2 + 1936.D0/3.D0*dd1*
     & LR**2 + 82252.D0/27.D0*dd0*LM - 4348.D0/9.D0*dd0*LM**2 + 208.D0/
     & 9.D0*dd0*LM**3 + 122908.D0/27.D0*dd0*LR - 21352.D0/9.D0*dd0*LR*
     & LM + 176*dd0*LR*LM**2 - 484*dd0*LR**2 + 1936.D0/3.D0*dd0*LR**2*
     & LM + 268532.D0/243.D0*Pi**2*LM - 17936.D0/81.D0*Pi**2*LM**2 + 
     & 448.D0/27.D0*Pi**2*LM**3 + 868*Pi**2*LR - 352*Pi**2*LR*LM + 1408.
     & D0/27.D0*Pi**2*LR*LM**2 - 968.D0/9.D0*Pi**2*LR**2 - 1792.D0/9.D0
     & *Pi**2*dd2*LM + 18080.D0/27.D0*Pi**2*dd1*LM - 11776.D0/81.D0*
     & Pi**2*dd1*LM**2
      c2q_new = c2q_new + 8800.D0/27.D0*Pi**2*dd1*LR - 28880.D0/27.D0*
     & Pi**2*dd0*LM + 5872.D0/27.D0*Pi**2*dd0*LM**2 - 1024.D0/81.D0*
     & Pi**2*dd0*LM**3 - 4048.D0/9.D0*Pi**2*dd0*LR + 8800.D0/27.D0*
     & Pi**2*dd0*LR*LM - 2716.D0/45.D0*Pi**4*LM + 7808.D0/1215.D0*Pi**4
     & *LM**2 - 5566.D0/135.D0*Pi**4*LR + 47776.D0/1215.D0*Pi**4*dd0*LM
     &  - 19412.D0/27.D0*rnf*LM + 1492.D0/9.D0*rnf*LM**2 - 128.D0/9.D0*
     & rnf*LM**3 - 7480.D0/9.D0*rnf*LR + 3304.D0/9.D0*rnf*LR*LM - 48*
     & rnf*LR*LM**2 + 176*rnf*LR**2 - 176.D0/3.D0*rnf*LR**2*LM + 2560.D0
     & /81.D0*rnf*dd3*LM + 512.D0/27.D0*rnf*dd3*LR - 6208.D0/27.D0*rnf*
     & dd2*LM + 128.D0/3.D0*rnf*dd2*LM**2 - 1088.D0/9.D0*rnf*dd2*LR + 
     & 512.D0/9.D0*rnf*dd2*LR*LM + 133856.D0/243.D0*rnf*dd1*LM - 13184.D
     & 0/81.D0*rnf*dd1*LM**2 + 512.D0/27.D0*rnf*dd1*LM**3 + 11072.D0/27.
     & D0*rnf*dd1*LR - 1664.D0/9.D0*rnf*dd1*LR*LM + 1024.D0/27.D0*rnf*
     & dd1*LR*LM**2 - 704.D0/9.D0*rnf*dd1*LR**2 - 14776.D0/27.D0*rnf*
     & dd0*LM + 3536.D0/27.D0*rnf*dd0*LM**2 - 320.D0/27.D0*rnf*dd0*
     & LM**3
      c2q_new = c2q_new - 46184.D0/81.D0*rnf*dd0*LR + 9920.D0/27.D0*rnf
     & *dd0*LR*LM - 448.D0/9.D0*rnf*dd0*LR*LM**2 + 176.D0/3.D0*rnf*dd0*
     & LR**2 - 704.D0/9.D0*rnf*dd0*LR**2*LM - 107408.D0/729.D0*rnf*
     & Pi**2*LM + 6464.D0/243.D0*rnf*Pi**2*LM**2 - 128.D0/81.D0*rnf*
     & Pi**2*LM**3 - 3248.D0/27.D0*rnf*Pi**2*LR + 1280.D0/27.D0*rnf*
     & Pi**2*LR*LM - 256.D0/81.D0*rnf*Pi**2*LR*LM**2 + 352.D0/27.D0*rnf
     & *Pi**2*LR**2 - 2624.D0/81.D0*rnf*Pi**2*dd1*LM - 1600.D0/81.D0*
     & rnf*Pi**2*dd1*LR + 256.D0/3.D0*rnf*Pi**2*dd0*LM - 1312.D0/81.D0*
     & rnf*Pi**2*dd0*LM**2 + 1088.D0/27.D0*rnf*Pi**2*dd0*LR - 1600.D0/
     & 81.D0*rnf*Pi**2*dd0*LR*LM + 5096.D0/1215.D0*rnf*Pi**4*LM + 1012.D
     & 0/405.D0*rnf*Pi**4*LR + 1624.D0/81.D0*rnf**2*LM - 152.D0/27.D0*
     & rnf**2*LM**2 + 16.D0/27.D0*rnf**2*LM**3 + 1828.D0/81.D0*rnf**2*
     & LR - 304.D0/27.D0*rnf**2*LR*LM + 16.D0/9.D0*rnf**2*LR*LM**2 - 16.
     & D0/3.D0*rnf**2*LR**2 + 16.D0/9.D0*rnf**2*LR**2*LM + 64.D0/27.D0*
     & rnf**2*dd2*LM + 64.D0/27.D0*rnf**2*dd2*LR - 928.D0/81.D0*rnf**2*
     & dd1*LM
      c2q_new = c2q_new + 64.D0/27.D0*rnf**2*dd1*LM**2 - 928.D0/81.D0*
     & rnf**2*dd1*LR + 128.D0/27.D0*rnf**2*dd1*LR*LM + 64.D0/27.D0*
     & rnf**2*dd1*LR**2 + 3760.D0/243.D0*rnf**2*dd0*LM - 464.D0/81.D0*
     & rnf**2*dd0*LM**2 + 64.D0/81.D0*rnf**2*dd0*LM**3 + 3952.D0/243.D0
     & *rnf**2*dd0*LR - 928.D0/81.D0*rnf**2*dd0*LR*LM + 64.D0/27.D0*
     & rnf**2*dd0*LR*LM**2 - 16.D0/9.D0*rnf**2*dd0*LR**2 + 64.D0/27.D0*
     & rnf**2*dd0*LR**2*LM + 1072.D0/243.D0*rnf**2*Pi**2*LM - 64.D0/81.D
     & 0*rnf**2*Pi**2*LM**2 + 304.D0/81.D0*rnf**2*Pi**2*LR - 128.D0/81.D
     & 0*rnf**2*Pi**2*LR*LM - 32.D0/81.D0*rnf**2*Pi**2*LR**2 - 64.D0/81.
     & D0*rnf**2*Pi**2*dd0*LM - 64.D0/81.D0*rnf**2*Pi**2*dd0*LR + 9056.D
     & 0/9.D0*Zeta5*LM + 1120.D0/27.D0*Zeta3*LM - 432*Zeta3*LM**2 + 
     & 4096.D0/81.D0*Zeta3*LM**3 - 1056*Zeta3*LR - 4576.D0/9.D0*Zeta3*
     & LR*LM + 53504.D0/27.D0*Zeta3*dd1*LM - 23840.D0/9.D0*Zeta3*dd0*LM
     &  + 7424.D0/27.D0*Zeta3*dd0*LM**2 - 28864.D0/9.D0*Zeta3*dd0*LR - 
     & 18688.D0/81.D0*Zeta3*Pi**2*LM - 3008.D0/81.D0*Zeta3*rnf*LM + 224.
     & D0/9.D0*Zeta3*rnf*LM**2
      c2q_new = c2q_new + 224.D0/9.D0*Zeta3*rnf*LR + 832.D0/27.D0*Zeta3
     & *rnf*LR*LM + 3520.D0/27.D0*Zeta3*rnf*dd0*LM + 5248.D0/27.D0*
     & Zeta3*rnf*dd0*LR + 64.D0/27.D0*Zeta3*rnf**2*LR 
             c2q_new = c2q_new + c2q_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.1) then ! regular component
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             c2q_new =  0 
         elseif (iorder.eq.1) then 
             c2q_new =  + LM * (  - 8.D0/3.D0 + 16.D0/3.D0*dd0 - 8.D0/3.
     &    D0*x )
      c2q_new = c2q_new + 8 - 8.D0/3.D0*dlx1 + 8.D0/3.D0*dlx + 16.D0/3.D
     &    0*dd1 - 4*dd0 - 16.D0/3.D0*dd0*dlx + 16.D0/3.D0*x - 8.D0/3.D0
     &    *x*dlx1 + 8.D0/3.D0*x*dlx 
         elseif (iorder.eq.2) then 
             c2q_new =  + LM * (  - 16.D0/3.D0 + 520.D0/9.D0*dlx1 - 64.D
     &    0/3.D0*dlx1**2 - 176.D0/3.D0*dlx + 128.D0/3.D0*dlx*dlx1 - 64.D
     &    0/3.D0*dlx**2 + 128.D0/3.D0*dd2 - 80*dd1 - 256.D0/3.D0*dd1*
     &    dlx + 748.D0/9.D0*dd0 + 96*dd0*dlx + 272.D0/9.D0*dd0*dlx**2
     &     + 224.D0/27.D0*Pi**2 - 400.D0/27.D0*Pi**2*dd0 - 1288.D0/9.D0
     &    *x + 72*x*dlx1 - 64.D0/3.D0*x*dlx1**2 - 784.D0/9.D0*x*dlx + 
     &    128.D0/3.D0*x*dlx*dlx1 - 208.D0/9.D0*x*dlx**2 + 80.D0/9.D0*x*
     &    Pi**2 - 32.D0/9.D0*Hr1(-1)*dlx + 32.D0/9.D0*Hr1(-1)*x*dlx + 
     &    32.D0/9.D0*Hr2(0,-1) - 32.D0/9.D0*Hr2(0,-1)*x - 64.D0/9.D0*
     &    Hr2(0,1) - 64.D0/9.D0*Hr2(0,1)*x - 16.D0/9.D0/(1 + x)*dlx**2
     &     + 16.D0/27.D0/(1 + x)*Pi**2 + 64.D0/9.D0/(1 + x)*Hr1(-1)*dlx
     &     - 64.D0/9.D0/(1 + x)*Hr2(0,-1) )
      c2q_new = c2q_new + LM**2 * (  - 28.D0/9.D0 - 128.D0/9.D0*dlx1 + 
     &    32.D0/3.D0*dlx + 256.D0/9.D0*dd1 - 8*dd0 - 128.D0/9.D0*dd0*
     &    dlx + 100.D0/9.D0*x - 128.D0/9.D0*x*dlx1 + 32.D0/3.D0*x*dlx )
      c2q_new = c2q_new + LR * (  - 88 + 88.D0/3.D0*dlx1 - 88.D0/3.D0*
     &    dlx - 176.D0/3.D0*dd1 + 44*dd0 + 176.D0/3.D0*dd0*dlx - 176.D0/
     &    3.D0*x + 88.D0/3.D0*x*dlx1 - 88.D0/3.D0*x*dlx )
      c2q_new = c2q_new + LR*LM * ( 88.D0/3.D0 - 176.D0/3.D0*dd0 + 88.D0
     &    /3.D0*x )
      c2q_new = c2q_new + rnf * (  - 632.D0/81.D0 + 128.D0/27.D0*dlx1
     &     - 8.D0/9.D0*dlx1**2 - 104.D0/9.D0*dlx + 16.D0/9.D0*dlx*dlx1
     &     - 20.D0/9.D0*dlx**2 + 16.D0/9.D0*dd2 - 232.D0/27.D0*dd1 - 32.
     &    D0/9.D0*dd1*dlx + 988.D0/81.D0*dd0 + 152.D0/9.D0*dd0*dlx + 40.
     &    D0/9.D0*dd0*dlx**2 + 16.D0/27.D0*Pi**2 - 32.D0/27.D0*Pi**2*
     &    dd0 - 1952.D0/81.D0*x + 272.D0/27.D0*x*dlx1 - 8.D0/9.D0*x*
     &    dlx1**2 - 152.D0/9.D0*x*dlx + 16.D0/9.D0*x*dlx*dlx1 - 20.D0/9.
     &    D0*x*dlx**2 + 16.D0/27.D0*x*Pi**2 - 16.D0/9.D0*Hr2(0,1) + 32.D
     &    0/9.D0*Hr2(0,1)*dd0 - 16.D0/9.D0*Hr2(0,1)*x )
      c2q_new = c2q_new + rnf*LM * ( 128.D0/27.D0 - 16.D0/9.D0*dlx1 + 
     &    32.D0/9.D0*dlx + 32.D0/9.D0*dd1 - 232.D0/27.D0*dd0 - 64.D0/9.D
     &    0*dd0*dlx + 272.D0/27.D0*x - 16.D0/9.D0*x*dlx1 + 32.D0/9.D0*x
     &    *dlx )
      c2q_new = c2q_new + rnf*LM**2 * (  - 8.D0/9.D0 + 16.D0/9.D0*dd0
     &     - 8.D0/9.D0*x )
      c2q_new = c2q_new + rnf*LR * ( 16.D0/3.D0 - 16.D0/9.D0*dlx1 + 16.D
     &    0/9.D0*dlx + 32.D0/9.D0*dd1 - 8.D0/3.D0*dd0 - 32.D0/9.D0*dd0*
     &    dlx + 32.D0/9.D0*x - 16.D0/9.D0*x*dlx1 + 16.D0/9.D0*x*dlx )
      c2q_new = c2q_new + rnf*LR*LM * (  - 16.D0/9.D0 + 32.D0/9.D0*dd0
     &     - 16.D0/9.D0*x )
      c2q_new = c2q_new + 8884.D0/135.D0 - 32.D0/45.D0*x**(-1) + 32.D0/
     &    45.D0*x**(-1)*dlx - 160.D0/3.D0*dlx1 + 356.D0/9.D0*dlx1**2 - 
     &    64.D0/9.D0*dlx1**3 + 1628.D0/15.D0*dlx - 776.D0/9.D0*dlx*dlx1
     &     + 184.D0/9.D0*dlx*dlx1**2 + 58*dlx**2 - 232.D0/9.D0*dlx**2*
     &    dlx1 + 80.D0/9.D0*dlx**3 + 128.D0/9.D0*dd3 - 184.D0/3.D0*dd2
     &     - 368.D0/9.D0*dd2*dlx + 1036.D0/9.D0*dd1 + 368.D0/3.D0*dd1*
     &    dlx + 160.D0/3.D0*dd1*dlx**2 - 5086.D0/27.D0*dd0 - 1892.D0/9.D
     &    0*dd0*dlx - 236.D0/3.D0*dd0*dlx**2 - 344.D0/27.D0*dd0*dlx**3
     &     - 520.D0/27.D0*Pi**2 + 272.D0/27.D0*Pi**2*dlx1 - 320.D0/27.D0
     &    *Pi**2*dlx - 560.D0/27.D0*Pi**2*dd1 + 80.D0/3.D0*Pi**2*dd0 + 
     &    176.D0/9.D0*Pi**2*dd0*dlx - 592.D0/9.D0*Zeta3 + 1168.D0/9.D0*
     &    Zeta3*dd0 + 48376.D0/135.D0*x - 176*x*dlx1 + 140.D0/3.D0*x*
     &    dlx1**2 - 64.D0/9.D0*x*dlx1**3 + 12284.D0/45.D0*x*dlx - 776.D0
     &    /9.D0*x*dlx*dlx1 + 184.D0/9.D0*x*dlx*dlx1**2 + 658.D0/9.D0*x*
     &    dlx**2 - 280.D0/9.D0*x*dlx**2*dlx1 + 88.D0/9.D0*x*dlx**3 - 
     &    688.D0/27.D0*x*Pi**2
      c2q_new = c2q_new + 320.D0/27.D0*x*Pi**2*dlx1 - 112.D0/9.D0*x*
     &    Pi**2*dlx - 96*x*Zeta3 - 32.D0/5.D0*x**2 - 32.D0/5.D0*x**2*
     &    dlx - 16.D0/5.D0*x**3*dlx**2 + 16.D0/15.D0*x**3*Pi**2 - 32.D0/
     &    45.D0*Hr1(-1)*x**(-2)*dlx - 16*Hr1(-1)*dlx + 32.D0/9.D0*Hr1(
     &    -1)*dlx**2 - 8.D0/9.D0*Hr1(-1)*Pi**2 - 80.D0/9.D0*Hr1(-1)*x*
     &    dlx - 80.D0/9.D0*Hr1(-1)*x*dlx**2 + 8.D0/3.D0*Hr1(-1)*x*Pi**2
     &     + 32.D0/5.D0*Hr1(-1)*x**3*dlx - 32.D0/9.D0*Hr2(-1,-1)*dlx + 
     &    224.D0/9.D0*Hr2(-1,-1)*x*dlx + 16*Hr2(0,-1) + 32.D0/45.D0*
     &    Hr2(0,-1)*x**(-2) - 32.D0/3.D0*Hr2(0,-1)*dd0*dlx + 80.D0/9.D0
     &    *Hr2(0,-1)*x + 160.D0/9.D0*Hr2(0,-1)*x*dlx - 32.D0/5.D0*Hr2(0
     &    ,-1)*x**3 + 88.D0/3.D0*Hr2(0,1) - 160.D0/9.D0*Hr2(0,1)*dlx1
     &     - 16.D0/9.D0*Hr2(0,1)*dlx + 320.D0/9.D0*Hr2(0,1)*dd1 - 112.D0
     &    /3.D0*Hr2(0,1)*dd0 + 64.D0/3.D0*Hr2(0,1)*dd0*dlx + 520.D0/9.D0
     &    *Hr2(0,1)*x - 160.D0/9.D0*Hr2(0,1)*x*dlx1 - 112.D0/9.D0*Hr2(0
     &    ,1)*x*dlx + 32.D0/9.D0*Hr3(-1,0,-1) - 224.D0/9.D0*Hr3(-1,0,-1
     &    )*x
      c2q_new = c2q_new + 32.D0/9.D0*Hr3(-1,0,1) - 32.D0/9.D0*Hr3(-1,0,
     &    1)*x + 32.D0/9.D0*Hr3(0,-1,-1) - 224.D0/9.D0*Hr3(0,-1,-1)*x
     &     - 64.D0/9.D0*Hr3(0,0,-1) + 64.D0/3.D0*Hr3(0,0,-1)*dd0 - 160.D
     &    0/9.D0*Hr3(0,0,-1)*x + 208.D0/9.D0*Hr3(0,0,1) - 160.D0/3.D0*
     &    Hr3(0,0,1)*dd0 + 112.D0/3.D0*Hr3(0,0,1)*x - 176.D0/9.D0*Hr3(0
     &    ,1,1) + 160.D0/3.D0*Hr3(0,1,1)*dd0 - 176.D0/9.D0*Hr3(0,1,1)*x
     &     + 32.D0/9.D0/(1 + x)*dlx + 8.D0/9.D0/(1 + x)*dlx**3 - 16.D0/
     &    27.D0/(1 + x)*Pi**2*dlx - 112.D0/9.D0/(1 + x)*Zeta3 - 80.D0/9.
     &    D0/(1 + x)*Hr1(-1)*dlx**2 + 64.D0/27.D0/(1 + x)*Hr1(-1)*Pi**2
     &     + 128.D0/9.D0/(1 + x)*Hr2(-1,-1)*dlx + 64.D0/9.D0/(1 + x)*
     &    Hr2(0,-1)*dlx - 128.D0/9.D0/(1 + x)*Hr3(-1,0,-1) - 64.D0/9.D0
     &    /(1 + x)*Hr3(-1,0,1) - 128.D0/9.D0/(1 + x)*Hr3(0,-1,-1) + 32.D
     &    0/9.D0/(1 + x)*Hr3(0,0,-1) + 32.D0/9.D0/(1 + x)*Hr3(0,0,1) 
         elseif (iorder.eq.3) then 
             c2q_new = 128.D0/405.D0*x**(-2)*Pi**2*dlx1*LM + 5824.D0/
     & 405.D0*x**(-1)*LM + 704.D0/45.D0*x**(-1)*LR - 512.D0/135.D0*
     & x**(-1)*dlx1*LM - 5824.D0/405.D0*x**(-1)*dlx*LM - 704.D0/45.D0*
     & x**(-1)*dlx*LR - 256.D0/135.D0*x**(-1)*dlx**2*LM + 512.D0/405.D0
     & *x**(-1)*Pi**2*LM - 128.D0/135.D0*x**(-1)*rnf*LM - 128.D0/135.D0
     & *x**(-1)*rnf*LR + 128.D0/135.D0*x**(-1)*rnf*dlx*LM + 128.D0/135.D
     & 0*x**(-1)*rnf*dlx*LR + 433936.D0/135.D0*LM - 5512.D0/9.D0*LM**2
     &  + 1544.D0/27.D0*LM**3 - 305608.D0/135.D0*LR + 1168.D0/3.D0*LR*
     & LM + 616.D0/9.D0*LR*LM**2 + 968*LR**2 - 968.D0/3.D0*LR**2*LM + 
     & 429104.D0/405.D0*dlx1*LM - 16712.D0/27.D0*dlx1*LM**2 + 1664.D0/
     & 27.D0*dlx1*LM**3 + 4336.D0/3.D0*dlx1*LR - 11440.D0/9.D0*dlx1*LR*
     & LM + 2816.D0/9.D0*dlx1*LR*LM**2 - 968.D0/3.D0*dlx1*LR**2 - 11032.
     & D0/9.D0*dlx1**2*LM + 9248.D0/27.D0*dlx1**2*LM**2 - 1024.D0/27.D0
     & *dlx1**2*LM**3 - 7832.D0/9.D0*dlx1**2*LR + 1408.D0/3.D0*dlx1**2*
     & LR*LM + 3200.D0/9.D0*dlx1**3*LM - 2048.D0/27.D0*dlx1**3*LM**2 + 
     & 1408.D0/9.D0*dlx1**3*LR
      c2q_new = c2q_new - 1280.D0/27.D0*dlx1**4*LM - 907792.D0/405.D0*
     & dlx*LM + 656*dlx*LM**2 - 1760.D0/27.D0*dlx*LM**3 - 39896.D0/15.D0
     & *dlx*LR + 3872.D0/3.D0*dlx*LR*LM - 704.D0/3.D0*dlx*LR*LM**2 + 
     & 968.D0/3.D0*dlx*LR**2 + 70736.D0/27.D0*dlx*dlx1*LM - 14464.D0/27.
     & D0*dlx*dlx1*LM**2 + 1024.D0/27.D0*dlx*dlx1*LM**3 + 17072.D0/9.D0
     & *dlx*dlx1*LR - 2816.D0/3.D0*dlx*dlx1*LR*LM - 27472.D0/27.D0*dlx*
     & dlx1**2*LM + 5632.D0/27.D0*dlx*dlx1**2*LM**2 - 4048.D0/9.D0*dlx*
     & dlx1**2*LR + 1664.D0/9.D0*dlx*dlx1**3*LM - 80864.D0/45.D0*dlx**2
     & *LM + 7952.D0/27.D0*dlx**2*LM**2 - 896.D0/81.D0*dlx**2*LM**3 - 
     & 1276*dlx**2*LR + 1408.D0/3.D0*dlx**2*LR*LM + 1000*dlx**2*dlx1*LM
     &  - 3712.D0/27.D0*dlx**2*dlx1*LM**2 + 5104.D0/9.D0*dlx**2*dlx1*LR
     &  - 6272.D0/27.D0*dlx**2*dlx1**2*LM - 10544.D0/27.D0*dlx**3*LM + 
     & 896.D0/27.D0*dlx**3*LM**2 - 1760.D0/9.D0*dlx**3*LR + 11488.D0/81.
     & D0*dlx**3*dlx1*LM - 2464.D0/81.D0*dlx**4*LM + 2560.D0/27.D0*dd4*
     & LM - 18688.D0/27.D0*dd3*LM + 4096.D0/27.D0*dd3*LM**2 - 2816.D0/9.
     & D0*dd3*LR
      c2q_new = c2q_new - 3328.D0/9.D0*dd3*dlx*LM + 26800.D0/9.D0*dd2*
     & LM - 704*dd2*LM**2 + 2048.D0/27.D0*dd2*LM**3 + 4048.D0/3.D0*dd2*
     & LR - 2816.D0/3.D0*dd2*LR*LM + 5792.D0/3.D0*dd2*dlx*LM - 11264.D0/
     & 27.D0*dd2*dlx*LM**2 + 8096.D0/9.D0*dd2*dlx*LR + 1408.D0/3.D0*dd2
     & *dlx**2*LM - 445784.D0/81.D0*dd1*LM + 48560.D0/27.D0*dd1*LM**2
     &  - 1792.D0/9.D0*dd1*LM**3 - 27688.D0/9.D0*dd1*LR + 1760*dd1*LR*
     & LM - 5632.D0/9.D0*dd1*LR*LM**2 + 1936.D0/3.D0*dd1*LR**2 - 169888.
     & D0/27.D0*dd1*dlx*LM + 1280*dd1*dlx*LM**2 - 2048.D0/27.D0*dd1*dlx
     & *LM**3 - 8096.D0/3.D0*dd1*dlx*LR + 5632.D0/3.D0*dd1*dlx*LR*LM - 
     & 6160.D0/3.D0*dd1*dlx**2*LM + 7424.D0/27.D0*dd1*dlx**2*LM**2 - 
     & 3520.D0/3.D0*dd1*dlx**2*LR - 7744.D0/27.D0*dd1*dlx**3*LM + 82252.
     & D0/27.D0*dd0*LM - 4348.D0/9.D0*dd0*LM**2 + 208.D0/9.D0*dd0*LM**3
     &  + 122908.D0/27.D0*dd0*LR - 21352.D0/9.D0*dd0*LR*LM + 176*dd0*LR
     & *LM**2 - 484*dd0*LR**2 + 1936.D0/3.D0*dd0*LR**2*LM + 533752.D0/
     & 81.D0*dd0*dlx*LM - 35872.D0/27.D0*dd0*dlx*LM**2 + 896.D0/9.D0*
     & dd0*dlx*LM**3
      c2q_new = c2q_new + 46520.D0/9.D0*dd0*dlx*LR - 2112*dd0*dlx*LR*LM
     &  + 2816.D0/9.D0*dd0*dlx*LR*LM**2 - 1936.D0/3.D0*dd0*dlx*LR**2 + 
     & 80960.D0/27.D0*dd0*dlx**2*LM - 3760.D0/9.D0*dd0*dlx**2*LM**2 + 
     & 1024.D0/81.D0*dd0*dlx**2*LM**3 + 5192.D0/3.D0*dd0*dlx**2*LR - 
     & 5984.D0/9.D0*dd0*dlx**2*LR*LM + 14432.D0/27.D0*dd0*dlx**3*LM - 
     & 3328.D0/81.D0*dd0*dlx**3*LM**2 + 7568.D0/27.D0*dd0*dlx**3*LR + 
     & 112.D0/3.D0*dd0*dlx**4*LM + 218192.D0/405.D0*Pi**2*LM - 9904.D0/
     & 81.D0*Pi**2*LM**2 + 256.D0/27.D0*Pi**2*LM**3 + 11440.D0/27.D0*
     & Pi**2*LR - 4928.D0/27.D0*Pi**2*LR*LM - 31616.D0/81.D0*Pi**2*dlx1
     & *LM + 5888.D0/81.D0*Pi**2*dlx1*LM**2 - 5984.D0/27.D0*Pi**2*dlx1*
     & LR + 1024.D0/9.D0*Pi**2*dlx1**2*LM + 40568.D0/81.D0*Pi**2*dlx*LM
     &  - 5504.D0/81.D0*Pi**2*dlx*LM**2 + 7040.D0/27.D0*Pi**2*dlx*LR - 
     & 6880.D0/27.D0*Pi**2*dlx*dlx1*LM + 3404.D0/27.D0*Pi**2*dlx**2*LM
     &  - 18688.D0/81.D0*Pi**2*dd2*LM + 21856.D0/27.D0*Pi**2*dd1*LM - 
     & 11776.D0/81.D0*Pi**2*dd1*LM**2 + 12320.D0/27.D0*Pi**2*dd1*LR + 
     & 41792.D0/81.D0*Pi**2*dd1*dlx*LM
      c2q_new = c2q_new - 31904.D0/27.D0*Pi**2*dd0*LM + 5872.D0/27.D0*
     & Pi**2*dd0*LM**2 - 1024.D0/81.D0*Pi**2*dd0*LM**3 - 1760.D0/3.D0*
     & Pi**2*dd0*LR + 8800.D0/27.D0*Pi**2*dd0*LR*LM - 21520.D0/27.D0*
     & Pi**2*dd0*dlx*LM + 2560.D0/27.D0*Pi**2*dd0*dlx*LM**2 - 3872.D0/9.
     & D0*Pi**2*dd0*dlx*LR - 13888.D0/81.D0*Pi**2*dd0*dlx**2*LM - 28958.
     & D0/1215.D0*Pi**4*LM + 15616.D0/405.D0*Pi**4*dd0*LM - 88912.D0/
     & 1215.D0*rnf*LM - 1144.D0/81.D0*rnf*LM**2 + 32.D0/27.D0*rnf*LM**3
     &  + 146096.D0/405.D0*rnf*LR - 3920.D0/27.D0*rnf*LR*LM + 416.D0/27.
     & D0*rnf*LR*LM**2 - 352.D0/3.D0*rnf*LR**2 + 352.D0/9.D0*rnf*LR**2*
     & LM - 49936.D0/243.D0*rnf*dlx1*LM + 6496.D0/81.D0*rnf*dlx1*LM**2
     &  - 256.D0/27.D0*rnf*dlx1*LM**3 - 5648.D0/27.D0*rnf*dlx1*LR + 
     & 3136.D0/27.D0*rnf*dlx1*LR*LM - 512.D0/27.D0*rnf*dlx1*LR*LM**2 + 
     & 352.D0/9.D0*rnf*dlx1*LR**2 + 3104.D0/27.D0*rnf*dlx1**2*LM - 64.D0
     & /3.D0*rnf*dlx1**2*LM**2 + 1952.D0/27.D0*rnf*dlx1**2*LR - 256.D0/
     & 9.D0*rnf*dlx1**2*LR*LM - 1280.D0/81.D0*rnf*dlx1**3*LM - 256.D0/
     & 27.D0*rnf*dlx1**3*LR
      c2q_new = c2q_new + 161888.D0/405.D0*rnf*dlx*LM - 256.D0/3.D0*rnf
     & *dlx*LM**2 + 64.D0/9.D0*rnf*dlx*LM**3 + 19472.D0/45.D0*rnf*dlx*
     & LR - 1408.D0/9.D0*rnf*dlx*LR*LM + 128.D0/9.D0*rnf*dlx*LR*LM**2
     &  - 352.D0/9.D0*rnf*dlx*LR**2 - 21184.D0/81.D0*rnf*dlx*dlx1*LM + 
     & 1280.D0/27.D0*rnf*dlx*dlx1*LM**2 - 4160.D0/27.D0*rnf*dlx*dlx1*LR
     &  + 512.D0/9.D0*rnf*dlx*dlx1*LR*LM + 416.D0/9.D0*rnf*dlx*dlx1**2*
     & LM + 736.D0/27.D0*rnf*dlx*dlx1**2*LR + 5168.D0/27.D0*rnf*dlx**2*
     & LM - 224.D0/9.D0*rnf*dlx**2*LM**2 + 1136.D0/9.D0*rnf*dlx**2*LR
     &  - 256.D0/9.D0*rnf*dlx**2*LR*LM - 176.D0/3.D0*rnf*dlx**2*dlx1*LM
     &  - 928.D0/27.D0*rnf*dlx**2*dlx1*LR + 736.D0/27.D0*rnf*dlx**3*LM
     &  + 320.D0/27.D0*rnf*dlx**3*LR + 2560.D0/81.D0*rnf*dd3*LM + 512.D0
     & /27.D0*rnf*dd3*LR - 6208.D0/27.D0*rnf*dd2*LM + 128.D0/3.D0*rnf*
     & dd2*LM**2 - 1088.D0/9.D0*rnf*dd2*LR + 512.D0/9.D0*rnf*dd2*LR*LM
     &  - 832.D0/9.D0*rnf*dd2*dlx*LM - 1472.D0/27.D0*rnf*dd2*dlx*LR + 
     & 133856.D0/243.D0*rnf*dd1*LM - 13184.D0/81.D0*rnf*dd1*LM**2 + 512.
     & D0/27.D0*rnf*dd1*LM**3
      c2q_new = c2q_new + 11072.D0/27.D0*rnf*dd1*LR - 1664.D0/9.D0*rnf*
     & dd1*LR*LM + 1024.D0/27.D0*rnf*dd1*LR*LM**2 - 704.D0/9.D0*rnf*dd1
     & *LR**2 + 40832.D0/81.D0*rnf*dd1*dlx*LM - 2560.D0/27.D0*rnf*dd1*
     & dlx*LM**2 + 2176.D0/9.D0*rnf*dd1*dlx*LR - 1024.D0/9.D0*rnf*dd1*
     & dlx*LR*LM + 3232.D0/27.D0*rnf*dd1*dlx**2*LM + 640.D0/9.D0*rnf*
     & dd1*dlx**2*LR - 14776.D0/27.D0*rnf*dd0*LM + 3536.D0/27.D0*rnf*
     & dd0*LM**2 - 320.D0/27.D0*rnf*dd0*LM**3 - 46184.D0/81.D0*rnf*dd0*
     & LR + 9920.D0/27.D0*rnf*dd0*LR*LM - 448.D0/9.D0*rnf*dd0*LR*LM**2
     &  + 176.D0/3.D0*rnf*dd0*LR**2 - 704.D0/9.D0*rnf*dd0*LR**2*LM - 
     & 214240.D0/243.D0*rnf*dd0*dlx*LM + 12928.D0/81.D0*rnf*dd0*dlx*
     & LM**2 - 256.D0/27.D0*rnf*dd0*dlx*LM**3 - 19424.D0/27.D0*rnf*dd0*
     & dlx*LR + 2560.D0/9.D0*rnf*dd0*dlx*LR*LM - 512.D0/27.D0*rnf*dd0*
     & dlx*LR*LM**2 + 704.D0/9.D0*rnf*dd0*dlx*LR**2 - 25376.D0/81.D0*
     & rnf*dd0*dlx**2*LM + 928.D0/27.D0*rnf*dd0*dlx**2*LM**2 - 608.D0/3.
     & D0*rnf*dd0*dlx**2*LR + 1088.D0/27.D0*rnf*dd0*dlx**2*LR*LM - 3104.
     & D0/81.D0*rnf*dd0*dlx**3*LM
      c2q_new = c2q_new - 1376.D0/81.D0*rnf*dd0*dlx**3*LR - 1520.D0/27.D
     & 0*rnf*Pi**2*LM + 736.D0/81.D0*rnf*Pi**2*LM**2 - 3136.D0/81.D0*
     & rnf*Pi**2*LR + 896.D0/81.D0*rnf*Pi**2*LR*LM + 64.D0/3.D0*rnf*
     & Pi**2*dlx1*LM + 1088.D0/81.D0*rnf*Pi**2*dlx1*LR - 2608.D0/81.D0*
     & rnf*Pi**2*dlx*LM - 1280.D0/81.D0*rnf*Pi**2*dlx*LR - 3520.D0/81.D0
     & *rnf*Pi**2*dd1*LM - 2240.D0/81.D0*rnf*Pi**2*dd1*LR + 2816.D0/27.D
     & 0*rnf*Pi**2*dd0*LM - 1312.D0/81.D0*rnf*Pi**2*dd0*LM**2 + 1664.D0/
     & 27.D0*rnf*Pi**2*dd0*LR - 1600.D0/81.D0*rnf*Pi**2*dd0*LR*LM + 
     & 4352.D0/81.D0*rnf*Pi**2*dd0*dlx*LM + 704.D0/27.D0*rnf*Pi**2*dd0*
     & dlx*LR - 1184.D0/243.D0*rnf**2*LM + 256.D0/81.D0*rnf**2*LM**2 - 
     & 32.D0/81.D0*rnf**2*LM**3 - 2528.D0/243.D0*rnf**2*LR + 512.D0/81.D
     & 0*rnf**2*LR*LM - 32.D0/27.D0*rnf**2*LR*LM**2 + 32.D0/9.D0*rnf**2
     & *LR**2 - 32.D0/27.D0*rnf**2*LR**2*LM + 512.D0/81.D0*rnf**2*dlx1*
     & LM - 32.D0/27.D0*rnf**2*dlx1*LM**2 + 512.D0/81.D0*rnf**2*dlx1*LR
     &  - 64.D0/27.D0*rnf**2*dlx1*LR*LM - 32.D0/27.D0*rnf**2*dlx1*LR**2
     &  - 32.D0/27.D0*rnf**2*dlx1**2*LM
      c2q_new = c2q_new - 32.D0/27.D0*rnf**2*dlx1**2*LR - 1216.D0/81.D0
     & *rnf**2*dlx*LM + 64.D0/27.D0*rnf**2*dlx*LM**2 - 416.D0/27.D0*
     & rnf**2*dlx*LR + 128.D0/27.D0*rnf**2*dlx*LR*LM + 32.D0/27.D0*
     & rnf**2*dlx*LR**2 + 64.D0/27.D0*rnf**2*dlx*dlx1*LM + 64.D0/27.D0*
     & rnf**2*dlx*dlx1*LR - 32.D0/9.D0*rnf**2*dlx**2*LM - 80.D0/27.D0*
     & rnf**2*dlx**2*LR + 64.D0/27.D0*rnf**2*dd2*LM + 64.D0/27.D0*
     & rnf**2*dd2*LR - 928.D0/81.D0*rnf**2*dd1*LM + 64.D0/27.D0*rnf**2*
     & dd1*LM**2 - 928.D0/81.D0*rnf**2*dd1*LR + 128.D0/27.D0*rnf**2*dd1
     & *LR*LM + 64.D0/27.D0*rnf**2*dd1*LR**2 - 128.D0/27.D0*rnf**2*dd1*
     & dlx*LM - 128.D0/27.D0*rnf**2*dd1*dlx*LR + 3760.D0/243.D0*rnf**2*
     & dd0*LM - 464.D0/81.D0*rnf**2*dd0*LM**2 + 64.D0/81.D0*rnf**2*dd0*
     & LM**3 + 3952.D0/243.D0*rnf**2*dd0*LR - 928.D0/81.D0*rnf**2*dd0*
     & LR*LM + 64.D0/27.D0*rnf**2*dd0*LR*LM**2 - 16.D0/9.D0*rnf**2*dd0*
     & LR**2 + 64.D0/27.D0*rnf**2*dd0*LR**2*LM + 2144.D0/81.D0*rnf**2*
     & dd0*dlx*LM - 128.D0/27.D0*rnf**2*dd0*dlx*LM**2 + 608.D0/27.D0*
     & rnf**2*dd0*dlx*LR
      c2q_new = c2q_new - 256.D0/27.D0*rnf**2*dd0*dlx*LR*LM - 64.D0/27.D
     & 0*rnf**2*dd0*dlx*LR**2 + 64.D0/9.D0*rnf**2*dd0*dlx**2*LM + 160.D0
     & /27.D0*rnf**2*dd0*dlx**2*LR + 64.D0/81.D0*rnf**2*Pi**2*LM + 64.D0
     & /81.D0*rnf**2*Pi**2*LR - 128.D0/81.D0*rnf**2*Pi**2*dd0*LM - 128.D
     & 0/81.D0*rnf**2*Pi**2*dd0*LR + 29152.D0/27.D0*Zeta3*LM - 2176.D0/
     & 27.D0*Zeta3*LM**2 + 13024.D0/9.D0*Zeta3*LR - 18496.D0/27.D0*
     & Zeta3*dlx1*LM + 14848.D0/27.D0*Zeta3*dlx*LM + 12928.D0/9.D0*
     & Zeta3*dd1*LM - 19616.D0/9.D0*Zeta3*dd0*LM + 4352.D0/27.D0*Zeta3*
     & dd0*LM**2 - 25696.D0/9.D0*Zeta3*dd0*LR - 20992.D0/27.D0*Zeta3*
     & dd0*dlx*LM - 1792.D0/27.D0*Zeta3*rnf*LM - 2368.D0/27.D0*Zeta3*
     & rnf*LR + 2816.D0/27.D0*Zeta3*rnf*dd0*LM + 4672.D0/27.D0*Zeta3*
     & rnf*dd0*LR - 4593448.D0/405.D0*x*LM + 15152.D0/9.D0*x*LM**2 - 
     & 2168.D0/27.D0*x*LM**3 - 1137712.D0/135.D0*x*LR + 30784.D0/9.D0*x
     & *LR*LM - 2200.D0/9.D0*x*LR*LM**2 + 1936.D0/3.D0*x*LR**2 - 968.D0/
     & 3.D0*x*LR**2*LM + 3592016.D0/405.D0*x*dlx1*LM - 16216.D0/9.D0*x*
     & dlx1*LM**2
      c2q_new = c2q_new + 3712.D0/27.D0*x*dlx1*LM**3 + 4144*x*dlx1*LR
     &  - 1584*x*dlx1*LR*LM + 2816.D0/9.D0*x*dlx1*LR*LM**2 - 968.D0/3.D0
     & *x*dlx1*LR**2 - 75848.D0/27.D0*x*dlx1**2*LM + 4448.D0/9.D0*x*
     & dlx1**2*LM**2 - 1024.D0/27.D0*x*dlx1**2*LM**3 - 3080.D0/3.D0*x*
     & dlx1**2*LR + 1408.D0/3.D0*x*dlx1**2*LR*LM + 1408.D0/3.D0*x*
     & dlx1**3*LM - 2048.D0/27.D0*x*dlx1**3*LM**2 + 1408.D0/9.D0*x*
     & dlx1**3*LR - 1280.D0/27.D0*x*dlx1**4*LM - 1419136.D0/135.D0*x*
     & dlx*LM + 43120.D0/27.D0*x*dlx*LM**2 - 928.D0/9.D0*x*dlx*LM**3 - 
     & 282488.D0/45.D0*x*dlx*LR + 17248.D0/9.D0*x*dlx*LR*LM - 704.D0/3.D
     & 0*x*dlx*LR*LM**2 + 968.D0/3.D0*x*dlx*LR**2 + 149200.D0/27.D0*x*
     & dlx*dlx1*LM - 23680.D0/27.D0*x*dlx*dlx1*LM**2 + 1024.D0/27.D0*x*
     & dlx*dlx1*LM**3 + 17072.D0/9.D0*x*dlx*dlx1*LR - 2816.D0/3.D0*x*
     & dlx*dlx1*LR*LM - 35408.D0/27.D0*x*dlx*dlx1**2*LM + 5632.D0/27.D0
     & *x*dlx*dlx1**2*LM**2 - 4048.D0/9.D0*x*dlx*dlx1**2*LR + 1664.D0/9.
     & D0*x*dlx*dlx1**3*LM - 1401296.D0/405.D0*x*dlx**2*LM + 11872.D0/
     & 27.D0*x*dlx**2*LM**2
      c2q_new = c2q_new - 896.D0/81.D0*x*dlx**2*LM**3 - 14476.D0/9.D0*x
     & *dlx**2*LR + 4576.D0/9.D0*x*dlx**2*LR*LM + 37784.D0/27.D0*x*
     & dlx**2*dlx1*LM - 3712.D0/27.D0*x*dlx**2*dlx1*LM**2 + 6160.D0/9.D0
     & *x*dlx**2*dlx1*LR - 6656.D0/27.D0*x*dlx**2*dlx1**2*LM - 46112.D0/
     & 81.D0*x*dlx**3*LM + 1024.D0/27.D0*x*dlx**3*LM**2 - 1936.D0/9.D0*
     & x*dlx**3*LR + 12256.D0/81.D0*x*dlx**3*dlx1*LM - 2812.D0/81.D0*x*
     & dlx**4*LM + 1547072.D0/1215.D0*x*Pi**2*LM - 15104.D0/81.D0*x*
     & Pi**2*LM**2 + 256.D0/27.D0*x*Pi**2*LM**3 + 15136.D0/27.D0*x*
     & Pi**2*LR - 1760.D0/9.D0*x*Pi**2*LR*LM - 46624.D0/81.D0*x*Pi**2*
     & dlx1*LM + 5888.D0/81.D0*x*Pi**2*dlx1*LM**2 - 7040.D0/27.D0*x*
     & Pi**2*dlx1*LR + 3328.D0/27.D0*x*Pi**2*dlx1**2*LM + 60200.D0/81.D0
     & *x*Pi**2*dlx*LM - 2048.D0/27.D0*x*Pi**2*dlx*LM**2 + 2464.D0/9.D0
     & *x*Pi**2*dlx*LR - 2464.D0/9.D0*x*Pi**2*dlx*dlx1*LM + 3668.D0/27.D
     & 0*x*Pi**2*dlx**2*LM - 6442.D0/243.D0*x*Pi**4*LM + 1705312.D0/
     & 1215.D0*x*rnf*LM - 17528.D0/81.D0*x*rnf*LM**2 + 32.D0/3.D0*x*rnf
     & *LM**3
      c2q_new = c2q_new + 435584.D0/405.D0*x*rnf*LR - 4016.D0/9.D0*x*
     & rnf*LR*LM + 928.D0/27.D0*x*rnf*LR*LM**2 - 704.D0/9.D0*x*rnf*
     & LR**2 + 352.D0/9.D0*x*rnf*LR**2*LM - 187120.D0/243.D0*x*rnf*dlx1
     & *LM + 10720.D0/81.D0*x*rnf*dlx1*LM**2 - 256.D0/27.D0*x*rnf*dlx1*
     & LM**3 - 13232.D0/27.D0*x*rnf*dlx1*LR + 1216.D0/9.D0*x*rnf*dlx1*
     & LR*LM - 512.D0/27.D0*x*rnf*dlx1*LR*LM**2 + 352.D0/9.D0*x*rnf*
     & dlx1*LR**2 + 544.D0/3.D0*x*rnf*dlx1**2*LM - 64.D0/3.D0*x*rnf*
     & dlx1**2*LM**2 + 736.D0/9.D0*x*rnf*dlx1**2*LR - 256.D0/9.D0*x*rnf
     & *dlx1**2*LR*LM - 1280.D0/81.D0*x*rnf*dlx1**3*LM - 256.D0/27.D0*x
     & *rnf*dlx1**3*LR + 149216.D0/135.D0*x*rnf*dlx*LM - 3712.D0/27.D0*
     & x*rnf*dlx*LM**2 + 64.D0/9.D0*x*rnf*dlx*LM**3 + 103856.D0/135.D0*
     & x*rnf*dlx*LR - 5248.D0/27.D0*x*rnf*dlx*LR*LM + 128.D0/9.D0*x*rnf
     & *dlx*LR*LM**2 - 352.D0/9.D0*x*rnf*dlx*LR**2 - 30400.D0/81.D0*x*
     & rnf*dlx*dlx1*LM + 1280.D0/27.D0*x*rnf*dlx*dlx1*LM**2 - 4160.D0/
     & 27.D0*x*rnf*dlx*dlx1*LR + 512.D0/9.D0*x*rnf*dlx*dlx1*LR*LM + 416.
     & D0/9.D0*x*rnf*dlx*dlx1**2*LM
      c2q_new = c2q_new + 736.D0/27.D0*x*rnf*dlx*dlx1**2*LR + 21920.D0/
     & 81.D0*x*rnf*dlx**2*LM - 704.D0/27.D0*x*rnf*dlx**2*LM**2 + 3952.D0
     & /27.D0*x*rnf*dlx**2*LR - 832.D0/27.D0*x*rnf*dlx**2*LR*LM - 592.D0
     & /9.D0*x*rnf*dlx**2*dlx1*LM - 1120.D0/27.D0*x*rnf*dlx**2*dlx1*LR
     &  + 2368.D0/81.D0*x*rnf*dlx**3*LM + 352.D0/27.D0*x*rnf*dlx**3*LR
     &  - 21584.D0/243.D0*x*rnf*Pi**2*LM + 256.D0/27.D0*x*rnf*Pi**2*
     & LM**2 - 3808.D0/81.D0*x*rnf*Pi**2*LR + 320.D0/27.D0*x*rnf*Pi**2*
     & LR*LM + 640.D0/27.D0*x*rnf*Pi**2*dlx1*LM + 1280.D0/81.D0*x*rnf*
     & Pi**2*dlx1*LR - 880.D0/27.D0*x*rnf*Pi**2*dlx*LM - 448.D0/27.D0*x
     & *rnf*Pi**2*dlx*LR - 8960.D0/243.D0*x*rnf**2*LM + 544.D0/81.D0*x*
     & rnf**2*LM**2 - 32.D0/81.D0*x*rnf**2*LM**3 - 7808.D0/243.D0*x*
     & rnf**2*LR + 1088.D0/81.D0*x*rnf**2*LR*LM - 32.D0/27.D0*x*rnf**2*
     & LR*LM**2 + 64.D0/27.D0*x*rnf**2*LR**2 - 32.D0/27.D0*x*rnf**2*
     & LR**2*LM + 1088.D0/81.D0*x*rnf**2*dlx1*LM - 32.D0/27.D0*x*rnf**2
     & *dlx1*LM**2 + 1088.D0/81.D0*x*rnf**2*dlx1*LR - 64.D0/27.D0*x*
     & rnf**2*dlx1*LR*LM
      c2q_new = c2q_new - 32.D0/27.D0*x*rnf**2*dlx1*LR**2 - 32.D0/27.D0
     & *x*rnf**2*dlx1**2*LM - 32.D0/27.D0*x*rnf**2*dlx1**2*LR - 2176.D0/
     & 81.D0*x*rnf**2*dlx*LM + 64.D0/27.D0*x*rnf**2*dlx*LM**2 - 608.D0/
     & 27.D0*x*rnf**2*dlx*LR + 128.D0/27.D0*x*rnf**2*dlx*LR*LM + 32.D0/
     & 27.D0*x*rnf**2*dlx*LR**2 + 64.D0/27.D0*x*rnf**2*dlx*dlx1*LM + 64.
     & D0/27.D0*x*rnf**2*dlx*dlx1*LR - 32.D0/9.D0*x*rnf**2*dlx**2*LM - 
     & 80.D0/27.D0*x*rnf**2*dlx**2*LR + 64.D0/81.D0*x*rnf**2*Pi**2*LM
     &  + 64.D0/81.D0*x*rnf**2*Pi**2*LR + 24128.D0/9.D0*x*Zeta3*LM - 
     & 4736.D0/27.D0*x*Zeta3*LM**2 + 2112*x*Zeta3*LR - 23872.D0/27.D0*x
     & *Zeta3*dlx1*LM + 20800.D0/27.D0*x*Zeta3*dlx*LM - 896.D0/9.D0*x*
     & Zeta3*rnf*LM - 128*x*Zeta3*rnf*LR + 5824.D0/45.D0*x**2*LM + 704.D
     & 0/5.D0*x**2*LR - 512.D0/15.D0*x**2*dlx1*LM + 1472.D0/9.D0*x**2*
     & dlx*LM + 704.D0/5.D0*x**2*dlx*LR + 256.D0/15.D0*x**2*dlx**2*LM
     &  - 256.D0/45.D0*x**2*Pi**2*LM - 128.D0/15.D0*x**2*rnf*LM - 128.D0
     & /15.D0*x**2*rnf*LR - 128.D0/15.D0*x**2*rnf*dlx*LM - 128.D0/15.D0
     & *x**2*rnf*dlx*LR
      c2q_new = c2q_new + 736.D0/9.D0*x**3*dlx**2*LM + 352.D0/5.D0*x**3
     & *dlx**2*LR + 256.D0/45.D0*x**3*dlx**3*LM - 736.D0/27.D0*x**3*
     & Pi**2*LM - 352.D0/15.D0*x**3*Pi**2*LR + 128.D0/45.D0*x**3*Pi**2*
     & dlx1*LM - 512.D0/45.D0*x**3*Pi**2*dlx*LM - 64.D0/15.D0*x**3*rnf*
     & dlx**2*LM - 64.D0/15.D0*x**3*rnf*dlx**2*LR + 64.D0/45.D0*x**3*
     & rnf*Pi**2*LM + 64.D0/45.D0*x**3*rnf*Pi**2*LR - 256.D0/3.D0*x**3*
     & Zeta3*LM + 1472.D0/81.D0*Hr1(-1)*x**(-2)*dlx*LM + 704.D0/45.D0*
     & Hr1(-1)*x**(-2)*dlx*LR + 256.D0/135.D0*Hr1(-1)*x**(-2)*dlx**2*LM
     &  - 128.D0/135.D0*Hr1(-1)*x**(-2)*Pi**2*LM - 128.D0/135.D0*Hr1(-1
     & )*x**(-2)*rnf*dlx*LM - 128.D0/135.D0*Hr1(-1)*x**(-2)*rnf*dlx*LR
     &  + 512.D0/135.D0*Hr1(-1)*x**(-1)*dlx*LM + 54944.D0/135.D0*Hr1(-1
     & )*dlx*LM + 160.D0/27.D0*Hr1(-1)*dlx*LM**2 + 352*Hr1(-1)*dlx*LR
     &  + 704.D0/9.D0*Hr1(-1)*dlx*LR*LM + 16.D0/27.D0*Hr1(-1)*dlx**2*LM
     &  + 128.D0/9.D0*Hr1(-1)*dlx**2*LM**2 - 704.D0/9.D0*Hr1(-1)*dlx**2
     & *LR - 544.D0/27.D0*Hr1(-1)*dlx**3*LM - 1328.D0/81.D0*Hr1(-1)*
     & Pi**2*LM
      c2q_new = c2q_new - 512.D0/81.D0*Hr1(-1)*Pi**2*LM**2 + 176.D0/9.D0
     & *Hr1(-1)*Pi**2*LR + 352.D0/27.D0*Hr1(-1)*Pi**2*dlx*LM - 1472.D0/
     & 81.D0*Hr1(-1)*rnf*dlx*LM - 64.D0/27.D0*Hr1(-1)*rnf*dlx*LM**2 - 
     & 64.D0/3.D0*Hr1(-1)*rnf*dlx*LR - 128.D0/27.D0*Hr1(-1)*rnf*dlx*LR*
     & LM + 160.D0/27.D0*Hr1(-1)*rnf*dlx**2*LM + 128.D0/27.D0*Hr1(-1)*
     & rnf*dlx**2*LR - 32.D0/81.D0*Hr1(-1)*rnf*Pi**2*LM - 32.D0/27.D0*
     & Hr1(-1)*rnf*Pi**2*LR + 2176.D0/27.D0*Hr1(-1)*Zeta3*LM + 221152.D0
     & /405.D0*Hr1(-1)*x*dlx*LM - 1184.D0/27.D0*Hr1(-1)*x*dlx*LM**2 + 
     & 1760.D0/9.D0*Hr1(-1)*x*dlx*LR - 704.D0/9.D0*Hr1(-1)*x*dlx*LR*LM
     &  + 2416.D0/9.D0*Hr1(-1)*x*dlx**2*LM - 128.D0/9.D0*Hr1(-1)*x*
     & dlx**2*LM**2 + 1760.D0/9.D0*Hr1(-1)*x*dlx**2*LR + 800.D0/27.D0*
     & Hr1(-1)*x*dlx**3*LM - 208.D0/3.D0*Hr1(-1)*x*Pi**2*LM + 512.D0/81.
     & D0*Hr1(-1)*x*Pi**2*LM**2 - 176.D0/3.D0*Hr1(-1)*x*Pi**2*LR - 32*
     & Hr1(-1)*x*Pi**2*dlx*LM - 1984.D0/81.D0*Hr1(-1)*x*rnf*dlx*LM + 64.
     & D0/27.D0*Hr1(-1)*x*rnf*dlx*LM**2 - 320.D0/27.D0*Hr1(-1)*x*rnf*
     & dlx*LR
      c2q_new = c2q_new + 128.D0/27.D0*Hr1(-1)*x*rnf*dlx*LR*LM - 352.D0/
     & 27.D0*Hr1(-1)*x*rnf*dlx**2*LM - 320.D0/27.D0*Hr1(-1)*x*rnf*
     & dlx**2*LR + 224.D0/81.D0*Hr1(-1)*x*rnf*Pi**2*LM + 32.D0/9.D0*
     & Hr1(-1)*x*rnf*Pi**2*LR - 7552.D0/27.D0*Hr1(-1)*x*Zeta3*LM - 512.D
     & 0/15.D0*Hr1(-1)*x**2*dlx*LM - 1472.D0/9.D0*Hr1(-1)*x**3*dlx*LM
     &  - 704.D0/5.D0*Hr1(-1)*x**3*dlx*LR - 256.D0/15.D0*Hr1(-1)*x**3*
     & dlx**2*LM + 128.D0/15.D0*Hr1(-1)*x**3*Pi**2*LM + 128.D0/15.D0*
     & Hr1(-1)*x**3*rnf*dlx*LM + 128.D0/15.D0*Hr1(-1)*x**3*rnf*dlx*LR
     &  - 512.D0/135.D0*Hr2(-1,-1)*x**(-2)*dlx*LM - 320.D0/9.D0*Hr2(-1,
     & -1)*dlx*LM - 1024.D0/27.D0*Hr2(-1,-1)*dlx*LM**2 + 704.D0/9.D0*
     & Hr2(-1,-1)*dlx*LR + 256.D0/3.D0*Hr2(-1,-1)*dlx**2*LM - 640.D0/81.
     & D0*Hr2(-1,-1)*Pi**2*LM - 128.D0/27.D0*Hr2(-1,-1)*rnf*dlx*LM - 
     & 128.D0/27.D0*Hr2(-1,-1)*rnf*dlx*LR - 5696.D0/9.D0*Hr2(-1,-1)*x*
     & dlx*LM + 1024.D0/27.D0*Hr2(-1,-1)*x*dlx*LM**2 - 4928.D0/9.D0*
     & Hr2(-1,-1)*x*dlx*LR - 512.D0/3.D0*Hr2(-1,-1)*x*dlx**2*LM + 3712.D
     & 0/81.D0*Hr2(-1,-1)*x*Pi**2*LM
      c2q_new = c2q_new + 896.D0/27.D0*Hr2(-1,-1)*x*rnf*dlx*LM + 896.D0/
     & 27.D0*Hr2(-1,-1)*x*rnf*dlx*LR + 512.D0/15.D0*Hr2(-1,-1)*x**3*dlx
     & *LM - 1472.D0/81.D0*Hr2(0,-1)*x**(-2)*LM - 704.D0/45.D0*Hr2(0,-1
     & )*x**(-2)*LR - 512.D0/135.D0*Hr2(0,-1)*x**(-2)*dlx*LM + 128.D0/
     & 135.D0*Hr2(0,-1)*x**(-2)*rnf*LM + 128.D0/135.D0*Hr2(0,-1)*
     & x**(-2)*rnf*LR - 512.D0/135.D0*Hr2(0,-1)*x**(-1)*LM - 54944.D0/
     & 135.D0*Hr2(0,-1)*LM - 160.D0/27.D0*Hr2(0,-1)*LM**2 - 352*Hr2(0,
     & -1)*LR - 704.D0/9.D0*Hr2(0,-1)*LR*LM - 2240.D0/27.D0*Hr2(0,-1)*
     & dlx*LM + 3200.D0/27.D0*Hr2(0,-1)*dlx*dlx1*LM - 112.D0/3.D0*Hr2(0
     & ,-1)*dlx**2*LM - 6400.D0/27.D0*Hr2(0,-1)*dd1*dlx*LM + 128*Hr2(0,
     & -1)*dd0*dlx*LM + 704.D0/3.D0*Hr2(0,-1)*dd0*dlx*LR + 320.D0/9.D0*
     & Hr2(0,-1)*dd0*dlx**2*LM + 368.D0/27.D0*Hr2(0,-1)*Pi**2*LM - 640.D
     & 0/27.D0*Hr2(0,-1)*Pi**2*dd0*LM + 1472.D0/81.D0*Hr2(0,-1)*rnf*LM
     &  + 64.D0/27.D0*Hr2(0,-1)*rnf*LM**2 + 64.D0/3.D0*Hr2(0,-1)*rnf*LR
     &  + 128.D0/27.D0*Hr2(0,-1)*rnf*LR*LM - 128.D0/9.D0*Hr2(0,-1)*rnf*
     & dd0*dlx*LM
      c2q_new = c2q_new - 128.D0/9.D0*Hr2(0,-1)*rnf*dd0*dlx*LR - 221152.
     & D0/405.D0*Hr2(0,-1)*x*LM + 1184.D0/27.D0*Hr2(0,-1)*x*LM**2 - 
     & 1760.D0/9.D0*Hr2(0,-1)*x*LR + 704.D0/9.D0*Hr2(0,-1)*x*LR*LM - 
     & 9664.D0/27.D0*Hr2(0,-1)*x*dlx*LM - 3520.D0/9.D0*Hr2(0,-1)*x*dlx*
     & LR + 3200.D0/27.D0*Hr2(0,-1)*x*dlx*dlx1*LM - 80.D0/27.D0*Hr2(0,
     & -1)*x*dlx**2*LM + 176.D0/9.D0*Hr2(0,-1)*x*Pi**2*LM + 1984.D0/81.D
     & 0*Hr2(0,-1)*x*rnf*LM - 64.D0/27.D0*Hr2(0,-1)*x*rnf*LM**2 + 320.D0
     & /27.D0*Hr2(0,-1)*x*rnf*LR - 128.D0/27.D0*Hr2(0,-1)*x*rnf*LR*LM
     &  + 640.D0/27.D0*Hr2(0,-1)*x*rnf*dlx*LM + 640.D0/27.D0*Hr2(0,-1)*
     & x*rnf*dlx*LR + 512.D0/15.D0*Hr2(0,-1)*x**2*LM + 1472.D0/9.D0*
     & Hr2(0,-1)*x**3*LM + 704.D0/5.D0*Hr2(0,-1)*x**3*LR - 128.D0/15.D0
     & *Hr2(0,-1)*x**3*rnf*LM - 128.D0/15.D0*Hr2(0,-1)*x**3*rnf*LR - 
     & 512.D0/135.D0*Hr2(0,1)*x**(-1)*LM - 27568.D0/45.D0*Hr2(0,1)*LM
     &  + 5344.D0/27.D0*Hr2(0,1)*LM**2 - 512.D0/27.D0*Hr2(0,1)*LM**3 - 
     & 1936.D0/3.D0*Hr2(0,1)*LR + 1408.D0/9.D0*Hr2(0,1)*LR*LM + 8768.D0/
     & 27.D0*Hr2(0,1)*dlx1*LM
      c2q_new = c2q_new + 3520.D0/9.D0*Hr2(0,1)*dlx1*LR - 2560.D0/27.D0
     & *Hr2(0,1)*dlx1**2*LM - 12112.D0/27.D0*Hr2(0,1)*dlx*LM + 3328.D0/
     & 27.D0*Hr2(0,1)*dlx*LM**2 + 352.D0/9.D0*Hr2(0,1)*dlx*LR + 2560.D0/
     & 9.D0*Hr2(0,1)*dlx*dlx1*LM - 2984.D0/27.D0*Hr2(0,1)*dlx**2*LM + 
     & 5120.D0/27.D0*Hr2(0,1)*dd2*LM - 7552.D0/9.D0*Hr2(0,1)*dd1*LM - 
     & 7040.D0/9.D0*Hr2(0,1)*dd1*LR - 14848.D0/27.D0*Hr2(0,1)*dd1*dlx*
     & LM + 672*Hr2(0,1)*dd0*LM + 2464.D0/3.D0*Hr2(0,1)*dd0*LR - 352.D0/
     & 9.D0*Hr2(0,1)*dd0*dlx*LM - 512.D0/9.D0*Hr2(0,1)*dd0*dlx*LM**2 - 
     & 1408.D0/3.D0*Hr2(0,1)*dd0*dlx*LR + 64.D0/9.D0*Hr2(0,1)*dd0*
     & dlx**2*LM + 848.D0/81.D0*Hr2(0,1)*Pi**2*LM + 5824.D0/81.D0*Hr2(0
     & ,1)*Pi**2*dd0*LM + 6176.D0/81.D0*Hr2(0,1)*rnf*LM - 64.D0/9.D0*
     & Hr2(0,1)*rnf*LM**2 + 704.D0/9.D0*Hr2(0,1)*rnf*LR - 256.D0/27.D0*
     & Hr2(0,1)*rnf*LR*LM - 896.D0/27.D0*Hr2(0,1)*rnf*dlx1*LM - 640.D0/
     & 27.D0*Hr2(0,1)*rnf*dlx1*LR + 544.D0/27.D0*Hr2(0,1)*rnf*dlx*LM - 
     & 64.D0/27.D0*Hr2(0,1)*rnf*dlx*LR + 1792.D0/27.D0*Hr2(0,1)*rnf*dd1
     & *LM
      c2q_new = c2q_new + 1280.D0/27.D0*Hr2(0,1)*rnf*dd1*LR - 1024.D0/9.
     & D0*Hr2(0,1)*rnf*dd0*LM - 128*Hr2(0,1)*rnf*dd0*LR - 64.D0/9.D0*
     & Hr2(0,1)*rnf*dd0*dlx*LM + 256.D0/9.D0*Hr2(0,1)*rnf*dd0*dlx*LR - 
     & 64.D0/27.D0*Hr2(0,1)*rnf**2*LM - 64.D0/27.D0*Hr2(0,1)*rnf**2*LR
     &  + 128.D0/27.D0*Hr2(0,1)*rnf**2*dd0*LM + 128.D0/27.D0*Hr2(0,1)*
     & rnf**2*dd0*LR - 211664.D0/135.D0*Hr2(0,1)*x*LM + 5344.D0/27.D0*
     & Hr2(0,1)*x*LM**2 - 512.D0/27.D0*Hr2(0,1)*x*LM**3 - 11440.D0/9.D0
     & *Hr2(0,1)*x*LR + 1408.D0/9.D0*Hr2(0,1)*x*LR*LM + 13888.D0/27.D0*
     & Hr2(0,1)*x*dlx1*LM + 3520.D0/9.D0*Hr2(0,1)*x*dlx1*LR - 2560.D0/
     & 27.D0*Hr2(0,1)*x*dlx1**2*LM - 1552.D0/3.D0*Hr2(0,1)*x*dlx*LM + 
     & 3328.D0/27.D0*Hr2(0,1)*x*dlx*LM**2 + 2464.D0/9.D0*Hr2(0,1)*x*dlx
     & *LR + 2048.D0/9.D0*Hr2(0,1)*x*dlx*dlx1*LM - 2600.D0/27.D0*Hr2(0,
     & 1)*x*dlx**2*LM - 176.D0/81.D0*Hr2(0,1)*x*Pi**2*LM + 10784.D0/81.D
     & 0*Hr2(0,1)*x*rnf*LM - 64.D0/9.D0*Hr2(0,1)*x*rnf*LM**2 + 3136.D0/
     & 27.D0*Hr2(0,1)*x*rnf*LR - 256.D0/27.D0*Hr2(0,1)*x*rnf*LR*LM - 
     & 896.D0/27.D0*Hr2(0,1)*x*rnf*dlx1*LM
      c2q_new = c2q_new - 640.D0/27.D0*Hr2(0,1)*x*rnf*dlx1*LR + 160.D0/
     & 27.D0*Hr2(0,1)*x*rnf*dlx*LM - 448.D0/27.D0*Hr2(0,1)*x*rnf*dlx*LR
     &  - 64.D0/27.D0*Hr2(0,1)*x*rnf**2*LM - 64.D0/27.D0*Hr2(0,1)*x*
     & rnf**2*LR + 512.D0/15.D0*Hr2(0,1)*x**2*LM - 3584.D0/27.D0*Hr3(-1
     & ,-1,-1)*dlx*LM + 9728.D0/27.D0*Hr3(-1,-1,-1)*x*dlx*LM + 512.D0/
     & 135.D0*Hr3(-1,0,-1)*x**(-2)*LM + 320.D0/9.D0*Hr3(-1,0,-1)*LM + 
     & 1024.D0/27.D0*Hr3(-1,0,-1)*LM**2 - 704.D0/9.D0*Hr3(-1,0,-1)*LR
     &  - 1280.D0/27.D0*Hr3(-1,0,-1)*dlx*LM + 128.D0/27.D0*Hr3(-1,0,-1)
     & *rnf*LM + 128.D0/27.D0*Hr3(-1,0,-1)*rnf*LR + 5696.D0/9.D0*Hr3(-1
     & ,0,-1)*x*LM - 1024.D0/27.D0*Hr3(-1,0,-1)*x*LM**2 + 4928.D0/9.D0*
     & Hr3(-1,0,-1)*x*LR + 2816.D0/27.D0*Hr3(-1,0,-1)*x*dlx*LM - 896.D0/
     & 27.D0*Hr3(-1,0,-1)*x*rnf*LM - 896.D0/27.D0*Hr3(-1,0,-1)*x*rnf*LR
     &  - 512.D0/15.D0*Hr3(-1,0,-1)*x**3*LM + 512.D0/135.D0*Hr3(-1,0,1)
     & *x**(-2)*LM + 2176.D0/27.D0*Hr3(-1,0,1)*LM + 512.D0/27.D0*Hr3(-1
     & ,0,1)*LM**2 - 704.D0/9.D0*Hr3(-1,0,1)*LR - 512.D0/9.D0*Hr3(-1,0,
     & 1)*dlx*LM
      c2q_new = c2q_new + 128.D0/27.D0*Hr3(-1,0,1)*rnf*LR + 896.D0/9.D0
     & *Hr3(-1,0,1)*x*LM - 512.D0/27.D0*Hr3(-1,0,1)*x*LM**2 + 704.D0/9.D
     & 0*Hr3(-1,0,1)*x*LR + 512.D0/9.D0*Hr3(-1,0,1)*x*dlx*LM - 128.D0/
     & 27.D0*Hr3(-1,0,1)*x*rnf*LR - 512.D0/15.D0*Hr3(-1,0,1)*x**3*LM + 
     & 512.D0/135.D0*Hr3(0,-1,-1)*x**(-2)*LM + 320.D0/9.D0*Hr3(0,-1,-1)
     & *LM + 1024.D0/27.D0*Hr3(0,-1,-1)*LM**2 - 704.D0/9.D0*Hr3(0,-1,-1
     & )*LR - 448.D0/9.D0*Hr3(0,-1,-1)*dlx*LM + 128.D0/27.D0*Hr3(0,-1,
     & -1)*rnf*LM + 128.D0/27.D0*Hr3(0,-1,-1)*rnf*LR + 5696.D0/9.D0*
     & Hr3(0,-1,-1)*x*LM - 1024.D0/27.D0*Hr3(0,-1,-1)*x*LM**2 + 4928.D0/
     & 9.D0*Hr3(0,-1,-1)*x*LR + 3904.D0/27.D0*Hr3(0,-1,-1)*x*dlx*LM - 
     & 896.D0/27.D0*Hr3(0,-1,-1)*x*rnf*LM - 896.D0/27.D0*Hr3(0,-1,-1)*x
     & *rnf*LR - 512.D0/15.D0*Hr3(0,-1,-1)*x**3*LM + 3200.D0/27.D0*Hr3(
     & 0,-1,1)*dlx*LM - 6400.D0/27.D0*Hr3(0,-1,1)*dd0*dlx*LM + 3200.D0/
     & 27.D0*Hr3(0,-1,1)*x*dlx*LM + 512.D0/135.D0*Hr3(0,0,-1)*x**(-2)*
     & LM + 4448.D0/27.D0*Hr3(0,0,-1)*LM - 256.D0/9.D0*Hr3(0,0,-1)*
     & LM**2
      c2q_new = c2q_new + 1408.D0/9.D0*Hr3(0,0,-1)*LR - 6400.D0/27.D0*
     & Hr3(0,0,-1)*dlx1*LM + 992.D0/9.D0*Hr3(0,0,-1)*dlx*LM + 12800.D0/
     & 27.D0*Hr3(0,0,-1)*dd1*LM - 256*Hr3(0,0,-1)*dd0*LM - 1408.D0/3.D0
     & *Hr3(0,0,-1)*dd0*LR - 640.D0/27.D0*Hr3(0,0,-1)*dd0*dlx*LM - 320.D
     & 0/27.D0*Hr3(0,0,-1)*rnf*LM - 256.D0/27.D0*Hr3(0,0,-1)*rnf*LR + 
     & 256.D0/9.D0*Hr3(0,0,-1)*rnf*dd0*LM + 256.D0/9.D0*Hr3(0,0,-1)*rnf
     & *dd0*LR + 4832.D0/27.D0*Hr3(0,0,-1)*x*LM + 256.D0/9.D0*Hr3(0,0,
     & -1)*x*LM**2 + 3520.D0/9.D0*Hr3(0,0,-1)*x*LR - 6400.D0/27.D0*Hr3(
     & 0,0,-1)*x*dlx1*LM - 4384.D0/27.D0*Hr3(0,0,-1)*x*dlx*LM - 64.D0/3.
     & D0*Hr3(0,0,-1)*x*rnf*LM - 640.D0/27.D0*Hr3(0,0,-1)*x*rnf*LR + 
     & 512.D0/15.D0*Hr3(0,0,-1)*x**3*LM - 2912.D0/27.D0*Hr3(0,0,1)*LM
     &  - 1024.D0/9.D0*Hr3(0,0,1)*LM**2 - 4576.D0/9.D0*Hr3(0,0,1)*LR + 
     & 256.D0/9.D0*Hr3(0,0,1)*dlx1*LM - 2464.D0/27.D0*Hr3(0,0,1)*dlx*LM
     &  - 2560.D0/27.D0*Hr3(0,0,1)*dd1*LM + 2048.D0/3.D0*Hr3(0,0,1)*dd0
     & *LM + 1024.D0/9.D0*Hr3(0,0,1)*dd0*LM**2 + 3520.D0/3.D0*Hr3(0,0,1
     & )*dd0*LR
      c2q_new = c2q_new + 7552.D0/27.D0*Hr3(0,0,1)*dd0*dlx*LM + 320.D0/
     & 9.D0*Hr3(0,0,1)*rnf*LM + 832.D0/27.D0*Hr3(0,0,1)*rnf*LR - 1792.D0
     & /27.D0*Hr3(0,0,1)*rnf*dd0*LM - 640.D0/9.D0*Hr3(0,0,1)*rnf*dd0*LR
     &  - 12064.D0/27.D0*Hr3(0,0,1)*x*LM - 2560.D0/27.D0*Hr3(0,0,1)*x*
     & LM**2 - 2464.D0/3.D0*Hr3(0,0,1)*x*LR + 1280.D0/9.D0*Hr3(0,0,1)*x
     & *dlx1*LM - 4000.D0/27.D0*Hr3(0,0,1)*x*dlx*LM + 448.D0/9.D0*Hr3(0
     & ,0,1)*x*rnf*LM + 448.D0/9.D0*Hr3(0,0,1)*x*rnf*LR + 512.D0/15.D0*
     & Hr3(0,0,1)*x**3*LM + 3200.D0/27.D0*Hr3(0,1,-1)*dlx*LM - 6400.D0/
     & 27.D0*Hr3(0,1,-1)*dd0*dlx*LM + 3200.D0/27.D0*Hr3(0,1,-1)*x*dlx*
     & LM - 3104.D0/27.D0*Hr3(0,1,1)*LM + 2560.D0/27.D0*Hr3(0,1,1)*
     & LM**2 + 3872.D0/9.D0*Hr3(0,1,1)*LR - 1280.D0/9.D0*Hr3(0,1,1)*
     & dlx1*LM + 2944.D0/27.D0*Hr3(0,1,1)*dlx*LM + 2560.D0/9.D0*Hr3(0,1
     & ,1)*dd1*LM - 960*Hr3(0,1,1)*dd0*LM - 3520.D0/3.D0*Hr3(0,1,1)*dd0
     & *LR - 17408.D0/27.D0*Hr3(0,1,1)*dd0*dlx*LM - 64.D0/3.D0*Hr3(0,1,
     & 1)*rnf*LM - 704.D0/27.D0*Hr3(0,1,1)*rnf*LR + 640.D0/9.D0*Hr3(0,1
     & ,1)*rnf*dd0*LM
      c2q_new = c2q_new + 640.D0/9.D0*Hr3(0,1,1)*rnf*dd0*LR - 96*Hr3(0,
     & 1,1)*x*LM + 2560.D0/27.D0*Hr3(0,1,1)*x*LM**2 + 3872.D0/9.D0*Hr3(
     & 0,1,1)*x*LR - 1280.D0/9.D0*Hr3(0,1,1)*x*dlx1*LM + 1408.D0/27.D0*
     & Hr3(0,1,1)*x*dlx*LM - 64.D0/3.D0*Hr3(0,1,1)*x*rnf*LM - 704.D0/27.
     & D0*Hr3(0,1,1)*x*rnf*LR + 3584.D0/27.D0*Hr4(-1,-1,0,-1)*LM - 9728.
     & D0/27.D0*Hr4(-1,-1,0,-1)*x*LM - 512.D0/27.D0*Hr4(-1,-1,0,1)*LM
     &  - 2560.D0/27.D0*Hr4(-1,-1,0,1)*x*LM + 3584.D0/27.D0*Hr4(-1,0,-1
     & ,-1)*LM - 9728.D0/27.D0*Hr4(-1,0,-1,-1)*x*LM - 2048.D0/27.D0*
     & Hr4(-1,0,0,-1)*LM + 3584.D0/27.D0*Hr4(-1,0,0,-1)*x*LM + 1024.D0/
     & 27.D0*Hr4(-1,0,0,1)*LM + 512.D0/27.D0*Hr4(-1,0,0,1)*x*LM - 512.D0
     & /9.D0*Hr4(-1,0,1,1)*LM + 512.D0/9.D0*Hr4(-1,0,1,1)*x*LM + 3584.D0
     & /27.D0*Hr4(0,-1,-1,-1)*LM - 9728.D0/27.D0*Hr4(0,-1,-1,-1)*x*LM
     &  - 1984.D0/27.D0*Hr4(0,-1,0,-1)*LM + 832.D0/9.D0*Hr4(0,-1,0,-1)*
     & x*LM - 128.D0/3.D0*Hr4(0,-1,0,1)*LM + 1280.D0/9.D0*Hr4(0,-1,0,1)
     & *dd0*LM - 2176.D0/27.D0*Hr4(0,-1,0,1)*x*LM - 640.D0/9.D0*Hr4(0,0
     & ,-1,-1)*LM
      c2q_new = c2q_new + 1408.D0/27.D0*Hr4(0,0,-1,-1)*x*LM - 6400.D0/
     & 27.D0*Hr4(0,0,-1,1)*LM + 12800.D0/27.D0*Hr4(0,0,-1,1)*dd0*LM - 
     & 6400.D0/27.D0*Hr4(0,0,-1,1)*x*LM + 128.D0/9.D0*Hr4(0,0,0,-1)*LM
     &  - 1280.D0/9.D0*Hr4(0,0,0,-1)*dd0*LM + 2944.D0/9.D0*Hr4(0,0,0,-1
     & )*x*LM + 7424.D0/27.D0*Hr4(0,0,0,1)*LM - 4864.D0/9.D0*Hr4(0,0,0,
     & 1)*dd0*LM + 8192.D0/27.D0*Hr4(0,0,0,1)*x*LM - 6400.D0/27.D0*Hr4(
     & 0,0,1,-1)*LM + 12800.D0/27.D0*Hr4(0,0,1,-1)*dd0*LM - 6400.D0/27.D
     & 0*Hr4(0,0,1,-1)*x*LM + 6400.D0/27.D0*Hr4(0,0,1,1)*LM - 11264.D0/
     & 27.D0*Hr4(0,0,1,1)*dd0*LM + 9472.D0/27.D0*Hr4(0,0,1,1)*x*LM - 
     & 3200.D0/27.D0*Hr4(0,1,0,-1)*LM + 6400.D0/27.D0*Hr4(0,1,0,-1)*dd0
     & *LM - 3200.D0/27.D0*Hr4(0,1,0,-1)*x*LM + 512.D0/3.D0*Hr4(0,1,0,1
     & )*LM - 4096.D0/9.D0*Hr4(0,1,0,1)*dd0*LM + 2048.D0/9.D0*Hr4(0,1,0
     & ,1)*x*LM - 2048.D0/9.D0*Hr4(0,1,1,1)*LM - 2048.D0/9.D0*Hr4(0,1,1
     & ,1)*x*LM - 736.D0/9.D0/(1 + x)*dlx*LM - 704.D0/9.D0/(1 + x)*dlx*
     & LR - 608.D0/9.D0/(1 + x)*dlx**2*LM + 112.D0/9.D0/(1 + x)*dlx**2*
     & LM**2
      c2q_new = c2q_new + 352.D0/9.D0/(1 + x)*dlx**2*LR*LM - 800.D0/27.D
     & 0/(1 + x)*dlx**3*LM + 256.D0/81.D0/(1 + x)*dlx**3*LM**2 - 176.D0/
     & 9.D0/(1 + x)*dlx**3*LR - 208.D0/81.D0/(1 + x)*dlx**4*LM + 1952.D0
     & /81.D0/(1 + x)*Pi**2*LM - 112.D0/27.D0/(1 + x)*Pi**2*LM**2 - 352.
     & D0/27.D0/(1 + x)*Pi**2*LR*LM + 448.D0/27.D0/(1 + x)*Pi**2*dlx*LM
     &  - 512.D0/81.D0/(1 + x)*Pi**2*dlx*LM**2 + 352.D0/27.D0/(1 + x)*
     & Pi**2*dlx*LR + 608.D0/81.D0/(1 + x)*Pi**2*dlx**2*LM - 928.D0/405.
     & D0/(1 + x)*Pi**4*LM + 128.D0/27.D0/(1 + x)*rnf*dlx*LM + 128.D0/
     & 27.D0/(1 + x)*rnf*dlx*LR + 320.D0/81.D0/(1 + x)*rnf*dlx**2*LM - 
     & 32.D0/27.D0/(1 + x)*rnf*dlx**2*LM**2 - 64.D0/27.D0/(1 + x)*rnf*
     & dlx**2*LR*LM + 160.D0/81.D0/(1 + x)*rnf*dlx**3*LM + 32.D0/27.D0
     & /(1 + x)*rnf*dlx**3*LR - 320.D0/243.D0/(1 + x)*rnf*Pi**2*LM + 32.
     & D0/81.D0/(1 + x)*rnf*Pi**2*LM**2 + 64.D0/81.D0/(1 + x)*rnf*Pi**2
     & *LR*LM - 32.D0/81.D0/(1 + x)*rnf*Pi**2*dlx*LM - 64.D0/81.D0/(1
     &  + x)*rnf*Pi**2*dlx*LR + 1792.D0/9.D0/(1 + x)*Zeta3*LM - 1792.D0/
     & 27.D0/(1 + x)*Zeta3*LM**2
      c2q_new = c2q_new + 2464.D0/9.D0/(1 + x)*Zeta3*LR + 2560.D0/27.D0
     & /(1 + x)*Zeta3*dlx*LM - 256.D0/27.D0/(1 + x)*Zeta3*rnf*LM - 448.D
     & 0/27.D0/(1 + x)*Zeta3*rnf*LR + 6784.D0/27.D0/(1 + x)*Hr1(-1)*dlx
     & *LM - 448.D0/9.D0/(1 + x)*Hr1(-1)*dlx*LM**2 - 1408.D0/9.D0/(1 + 
     & x)*Hr1(-1)*dlx*LR*LM + 1856.D0/9.D0/(1 + x)*Hr1(-1)*dlx**2*LM - 
     & 256.D0/9.D0/(1 + x)*Hr1(-1)*dlx**2*LM**2 + 1760.D0/9.D0/(1 + x)*
     & Hr1(-1)*dlx**2*LR + 3520.D0/81.D0/(1 + x)*Hr1(-1)*dlx**3*LM - 
     & 320.D0/9.D0/(1 + x)*Hr1(-1)*Pi**2*LM + 1024.D0/81.D0/(1 + x)*
     & Hr1(-1)*Pi**2*LM**2 - 1408.D0/27.D0/(1 + x)*Hr1(-1)*Pi**2*LR - 
     & 2624.D0/81.D0/(1 + x)*Hr1(-1)*Pi**2*dlx*LM - 1280.D0/81.D0/(1 + 
     & x)*Hr1(-1)*rnf*dlx*LM + 128.D0/27.D0/(1 + x)*Hr1(-1)*rnf*dlx*
     & LM**2 + 256.D0/27.D0/(1 + x)*Hr1(-1)*rnf*dlx*LR*LM - 128.D0/9.D0
     & /(1 + x)*Hr1(-1)*rnf*dlx**2*LM - 320.D0/27.D0/(1 + x)*Hr1(-1)*
     & rnf*dlx**2*LR + 128.D0/81.D0/(1 + x)*Hr1(-1)*rnf*Pi**2*LM + 256.D
     & 0/81.D0/(1 + x)*Hr1(-1)*rnf*Pi**2*LR - 2048.D0/9.D0/(1 + x)*Hr1(
     & -1)*Zeta3*LM
      c2q_new = c2q_new - 2816.D0/9.D0/(1 + x)*Hr2(-1,-1)*dlx*LM + 2048.
     & D0/27.D0/(1 + x)*Hr2(-1,-1)*dlx*LM**2 - 2816.D0/9.D0/(1 + x)*
     & Hr2(-1,-1)*dlx*LR - 1792.D0/9.D0/(1 + x)*Hr2(-1,-1)*dlx**2*LM + 
     & 256.D0/9.D0/(1 + x)*Hr2(-1,-1)*Pi**2*LM + 512.D0/27.D0/(1 + x)*
     & Hr2(-1,-1)*rnf*dlx*LM + 512.D0/27.D0/(1 + x)*Hr2(-1,-1)*rnf*dlx*
     & LR - 6784.D0/27.D0/(1 + x)*Hr2(0,-1)*LM + 448.D0/9.D0/(1 + x)*
     & Hr2(0,-1)*LM**2 + 1408.D0/9.D0/(1 + x)*Hr2(0,-1)*LR*LM - 1280.D0/
     & 9.D0/(1 + x)*Hr2(0,-1)*dlx*LM + 512.D0/27.D0/(1 + x)*Hr2(0,-1)*
     & dlx*LM**2 - 1408.D0/9.D0/(1 + x)*Hr2(0,-1)*dlx*LR + 320.D0/27.D0
     & /(1 + x)*Hr2(0,-1)*dlx**2*LM - 64.D0/81.D0/(1 + x)*Hr2(0,-1)*
     & Pi**2*LM + 1280.D0/81.D0/(1 + x)*Hr2(0,-1)*rnf*LM - 128.D0/27.D0
     & /(1 + x)*Hr2(0,-1)*rnf*LM**2 - 256.D0/27.D0/(1 + x)*Hr2(0,-1)*
     & rnf*LR*LM + 256.D0/27.D0/(1 + x)*Hr2(0,-1)*rnf*dlx*LM + 256.D0/
     & 27.D0/(1 + x)*Hr2(0,-1)*rnf*dlx*LR - 512.D0/27.D0/(1 + x)*Hr2(0,
     & 1)*LM + 1024.D0/3.D0/(1 + x)*Hr3(-1,-1,-1)*dlx*LM + 2816.D0/9.D0
     & /(1 + x)*Hr3(-1,0,-1)*LM
      c2q_new = c2q_new - 2048.D0/27.D0/(1 + x)*Hr3(-1,0,-1)*LM**2 + 
     & 2816.D0/9.D0/(1 + x)*Hr3(-1,0,-1)*LR + 1024.D0/9.D0/(1 + x)*Hr3(
     & -1,0,-1)*dlx*LM - 512.D0/27.D0/(1 + x)*Hr3(-1,0,-1)*rnf*LM - 512.
     & D0/27.D0/(1 + x)*Hr3(-1,0,-1)*rnf*LR + 512.D0/9.D0/(1 + x)*Hr3(
     & -1,0,1)*LM - 1024.D0/27.D0/(1 + x)*Hr3(-1,0,1)*LM**2 + 1408.D0/9.
     & D0/(1 + x)*Hr3(-1,0,1)*LR + 1024.D0/9.D0/(1 + x)*Hr3(-1,0,1)*dlx
     & *LM - 256.D0/27.D0/(1 + x)*Hr3(-1,0,1)*rnf*LR + 2816.D0/9.D0/(1
     &  + x)*Hr3(0,-1,-1)*LM - 2048.D0/27.D0/(1 + x)*Hr3(0,-1,-1)*LM**2
     &  + 2816.D0/9.D0/(1 + x)*Hr3(0,-1,-1)*LR + 1024.D0/9.D0/(1 + x)*
     & Hr3(0,-1,-1)*dlx*LM - 512.D0/27.D0/(1 + x)*Hr3(0,-1,-1)*rnf*LM
     &  - 512.D0/27.D0/(1 + x)*Hr3(0,-1,-1)*rnf*LR - 128/(1 + x)*Hr3(0,
     & 0,-1)*LM + 512.D0/27.D0/(1 + x)*Hr3(0,0,-1)*LM**2 - 704.D0/9.D0
     & /(1 + x)*Hr3(0,0,-1)*LR - 1792.D0/9.D0/(1 + x)*Hr3(0,0,-1)*dlx*
     & LM + 256.D0/27.D0/(1 + x)*Hr3(0,0,-1)*rnf*LM + 128.D0/27.D0/(1
     &  + x)*Hr3(0,0,-1)*rnf*LR - 256.D0/9.D0/(1 + x)*Hr3(0,0,1)*LM + 
     & 512.D0/27.D0/(1 + x)*Hr3(0,0,1)*LM**2
      c2q_new = c2q_new - 704.D0/9.D0/(1 + x)*Hr3(0,0,1)*LR - 512.D0/9.D
     & 0/(1 + x)*Hr3(0,0,1)*dlx*LM + 128.D0/27.D0/(1 + x)*Hr3(0,0,1)*
     & rnf*LR - 1024.D0/3.D0/(1 + x)*Hr4(-1,-1,0,-1)*LM - 1024.D0/3.D0
     & /(1 + x)*Hr4(-1,0,-1,-1)*LM + 512.D0/3.D0/(1 + x)*Hr4(-1,0,0,-1)
     & *LM - 512.D0/9.D0/(1 + x)*Hr4(-1,0,0,1)*LM + 1024.D0/9.D0/(1 + x
     & )*Hr4(-1,0,1,1)*LM - 1024.D0/3.D0/(1 + x)*Hr4(0,-1,-1,-1)*LM + 
     & 512.D0/3.D0/(1 + x)*Hr4(0,-1,0,-1)*LM - 512.D0/9.D0/(1 + x)*Hr4(
     & 0,-1,0,1)*LM + 512.D0/3.D0/(1 + x)*Hr4(0,0,-1,-1)*LM + 7168.D0/
     & 27.D0/(1 + x)*Hr4(0,0,0,-1)*LM + 2048.D0/27.D0/(1 + x)*Hr4(0,0,0
     & ,1)*LM - 512.D0/9.D0/(1 + x)*Hr4(0,0,1,1)*LM 
             c2q_new = c2q_new + c2q_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             c2q_new =  0 
         elseif (iorder.eq.1) then 
             c2q_new =  + LM * ( 16.D0/3.D0*dd0 ) ! + distribution component @ x=1 
      c2q_new = c2q_new + 16.D0/3.D0*dd1 - 4*dd0 
         elseif (iorder.eq.2) then 
             c2q_new =  + LM * ( 128.D0/3.D0*dd2 - 80*dd1 + 748.D0/9.D0
     &    *dd0 - 400.D0/27.D0*Pi**2*dd0 )
      c2q_new = c2q_new + LM**2 * ( 256.D0/9.D0*dd1 - 8*dd0 )
      c2q_new = c2q_new + LR * (  - 176.D0/3.D0*dd1 + 44*dd0 )
      c2q_new = c2q_new + LR*LM * (  - 176.D0/3.D0*dd0 )
      c2q_new = c2q_new + rnf * ( 16.D0/9.D0*dd2 - 232.D0/27.D0*dd1 + 
     &    988.D0/81.D0*dd0 - 16.D0/27.D0*Pi**2*dd0 )
      c2q_new = c2q_new + rnf*LM * ( 32.D0/9.D0*dd1 - 232.D0/27.D0*dd0
     &     )
      c2q_new = c2q_new + rnf*LM**2 * ( 16.D0/9.D0*dd0 )
      c2q_new = c2q_new + rnf*LR * ( 32.D0/9.D0*dd1 - 8.D0/3.D0*dd0 )
      c2q_new = c2q_new + rnf*LR*LM * ( 32.D0/9.D0*dd0 )
      c2q_new = c2q_new + 128.D0/9.D0*dd3 - 184.D0/3.D0*dd2 + 1036.D0/9.
     &    D0*dd1 - 5086.D0/27.D0*dd0 - 400.D0/27.D0*Pi**2*dd1 + 184.D0/
     &    9.D0*Pi**2*dd0 + 1312.D0/9.D0*Zeta3*dd0 
         elseif (iorder.eq.3) then 
             c2q_new = 2560.D0/27.D0*dd4*LM - 18688.D0/27.D0*dd3*LM + 
     & 4096.D0/27.D0*dd3*LM**2 - 2816.D0/9.D0*dd3*LR + 26800.D0/9.D0*
     & dd2*LM - 704*dd2*LM**2 + 2048.D0/27.D0*dd2*LM**3 + 4048.D0/3.D0*
     & dd2*LR - 2816.D0/3.D0*dd2*LR*LM - 445784.D0/81.D0*dd1*LM + 48560.
     & D0/27.D0*dd1*LM**2 - 1792.D0/9.D0*dd1*LM**3 - 27688.D0/9.D0*dd1*
     & LR + 1760*dd1*LR*LM - 5632.D0/9.D0*dd1*LR*LM**2 + 1936.D0/3.D0*
     & dd1*LR**2 + 82252.D0/27.D0*dd0*LM - 4348.D0/9.D0*dd0*LM**2 + 208.
     & D0/9.D0*dd0*LM**3 + 122908.D0/27.D0*dd0*LR - 21352.D0/9.D0*dd0*
     & LR*LM + 176*dd0*LR*LM**2 - 484*dd0*LR**2 + 1936.D0/3.D0*dd0*
     & LR**2*LM - 1792.D0/9.D0*Pi**2*dd2*LM + 18080.D0/27.D0*Pi**2*dd1*
     & LM - 11776.D0/81.D0*Pi**2*dd1*LM**2 + 8800.D0/27.D0*Pi**2*dd1*LR
     &  - 28880.D0/27.D0*Pi**2*dd0*LM + 5872.D0/27.D0*Pi**2*dd0*LM**2
     &  - 1024.D0/81.D0*Pi**2*dd0*LM**3 - 4048.D0/9.D0*Pi**2*dd0*LR + 
     & 8800.D0/27.D0*Pi**2*dd0*LR*LM + 47776.D0/1215.D0*Pi**4*dd0*LM + 
     & 2560.D0/81.D0*rnf*dd3*LM + 512.D0/27.D0*rnf*dd3*LR - 6208.D0/27.D
     & 0*rnf*dd2*LM
      c2q_new = c2q_new + 128.D0/3.D0*rnf*dd2*LM**2 - 1088.D0/9.D0*rnf*
     & dd2*LR + 512.D0/9.D0*rnf*dd2*LR*LM + 133856.D0/243.D0*rnf*dd1*LM
     &  - 13184.D0/81.D0*rnf*dd1*LM**2 + 512.D0/27.D0*rnf*dd1*LM**3 + 
     & 11072.D0/27.D0*rnf*dd1*LR - 1664.D0/9.D0*rnf*dd1*LR*LM + 1024.D0/
     & 27.D0*rnf*dd1*LR*LM**2 - 704.D0/9.D0*rnf*dd1*LR**2 - 14776.D0/27.
     & D0*rnf*dd0*LM + 3536.D0/27.D0*rnf*dd0*LM**2 - 320.D0/27.D0*rnf*
     & dd0*LM**3 - 46184.D0/81.D0*rnf*dd0*LR + 9920.D0/27.D0*rnf*dd0*LR
     & *LM - 448.D0/9.D0*rnf*dd0*LR*LM**2 + 176.D0/3.D0*rnf*dd0*LR**2
     &  - 704.D0/9.D0*rnf*dd0*LR**2*LM - 2624.D0/81.D0*rnf*Pi**2*dd1*LM
     &  - 1600.D0/81.D0*rnf*Pi**2*dd1*LR + 256.D0/3.D0*rnf*Pi**2*dd0*LM
     &  - 1312.D0/81.D0*rnf*Pi**2*dd0*LM**2 + 1088.D0/27.D0*rnf*Pi**2*
     & dd0*LR - 1600.D0/81.D0*rnf*Pi**2*dd0*LR*LM + 64.D0/27.D0*rnf**2*
     & dd2*LM + 64.D0/27.D0*rnf**2*dd2*LR - 928.D0/81.D0*rnf**2*dd1*LM
     &  + 64.D0/27.D0*rnf**2*dd1*LM**2 - 928.D0/81.D0*rnf**2*dd1*LR + 
     & 128.D0/27.D0*rnf**2*dd1*LR*LM + 64.D0/27.D0*rnf**2*dd1*LR**2 + 
     & 3760.D0/243.D0*rnf**2*dd0*LM
      c2q_new = c2q_new - 464.D0/81.D0*rnf**2*dd0*LM**2 + 64.D0/81.D0*
     & rnf**2*dd0*LM**3 + 3952.D0/243.D0*rnf**2*dd0*LR - 928.D0/81.D0*
     & rnf**2*dd0*LR*LM + 64.D0/27.D0*rnf**2*dd0*LR*LM**2 - 16.D0/9.D0*
     & rnf**2*dd0*LR**2 + 64.D0/27.D0*rnf**2*dd0*LR**2*LM - 64.D0/81.D0
     & *rnf**2*Pi**2*dd0*LM - 64.D0/81.D0*rnf**2*Pi**2*dd0*LR + 53504.D0
     & /27.D0*Zeta3*dd1*LM - 23840.D0/9.D0*Zeta3*dd0*LM + 7424.D0/27.D0
     & *Zeta3*dd0*LM**2 - 28864.D0/9.D0*Zeta3*dd0*LR + 3520.D0/27.D0*
     & Zeta3*rnf*dd0*LM + 5248.D0/27.D0*Zeta3*rnf*dd0*LR 
             c2q_new = c2q_new + c2q_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      endif      
      return     
      end function c2q_new  
