!>***************************************************
!> Exact DIS coefficient funtion c2q_diff in x space
!> not including scale dependence (yet!)
!> Function taken from results of hep-ph/0708.3731
      function c2q_diff(iorder,x,ireg,rmu2,fmu2,q2,flavchange)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      use xcdf3p
      implicit none
      integer iorder,ireg,flavchange
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
      common /Hrs/ Hr1,Hr2,Hr3,Hr4,Hr5
!$omp threadprivate(/Hrs/)
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      integer, parameter :: nf  = 5
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR,DX,DP,CAM2CF,CA,CF
      real*8 c2q_diff,x

      CF = 4./3.D0
      CA = 3.D0
      CAM2CF = CA - 2.* CF

      DX = 1.D0/X
      DP = 1.D0/(1.D0+X)

      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             c2q_diff = 0.D0
         elseif (iorder.eq.1) then 
             c2q_diff = 0.D0 
         elseif (iorder.eq.2) then 
             c2q_diff = 0.D0
         elseif (iorder.eq.3) then 
             c2q_diff = 0.D0
         endif 
      elseif (ireg.eq.1) then ! regular component
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             c2q_diff = 0 
         elseif (iorder.eq.1) then 
             c2q_diff = 0 
          elseif (iorder.eq.2) then
             c2q_diff =
     &  + cf*cam2cf * ( 162.D0/5.D0 - 82.D0/5.D0*x - 72.D0/5.D0*x**2
     &     - 8.D0/5.D0*dx + 20.D0*Zeta3 - 68.D0*Zeta3*x - 56.D0*Zeta3*dp - 4.D0*
     &    Zeta2 - 28.D0*Zeta2*x - 48.D0*Zeta2*x**2 + 72.D0/5.D0*Zeta2*x**3 - 24.D0*
     &    Hr1(-1)*Zeta2 + 72.D0*Hr1(-1)*Zeta2*x + 64.D0*Hr1(-1)*Zeta2*dp - 14.D0/
     &    5.D0*Hr1(0) + 146.D0/5.D0*Hr1(0)*x - 72.D0/5.D0*Hr1(0)*x**2
     &     + 8.D0/5.D0*Hr1(0)*dx + 16.D0*Hr1(0)*dp + 8.D0*Hr1(0)*Zeta2 - 8.
     &    D0*Hr1(0)*Zeta2*x - 16.D0*Hr1(0)*Zeta2*dp + 16.D0*Hr1(1) - 16.D0*
     &    Hr1(1)*x - 32.D0*Hr2(-1,0) - 32.D0*Hr2(-1,0)*x - 48.D0*Hr2(-1
     &    ,0)*x**2 + 72.D0/5.D0*Hr2(-1,0)*x**3 - 8.D0/5.D0*Hr2(-1,0)*
     &    dx**2 + 8.D0*Hr2(0,0) + 32.D0*Hr2(0,0)*x + 48.D0*Hr2(0,0)*
     &    x**2 - 72.D0/5.D0*Hr2(0,0)*x**3 + 8.D0*Hr2(0,1) + 8.D0*Hr2(0,
     &    1)*x - 16.D0*Hr3(-1,-1,0) + 112.D0*Hr3(-1,-1,0)*x + 64.D0*
     &    Hr3(-1,-1,0)*dp + 32.D0*Hr3(-1,0,0) - 80.D0*Hr3(-1,0,0)*x -
     &    80.D0*Hr3(-1,0,0)*dp + 16.D0*Hr3(-1,0,1) - 16.D0*Hr3(-1,0,1)*
     &    x - 32.D0*Hr3(-1,0,1)*dp + 16.D0*Hr3(0,-1,0) - 64.D0*Hr3(0,-1
     &    ,0)*x )
       c2q_diff = c2q_diff + cf*cam2cf * (  - 48.D0*Hr3(0,-1,0)*dp - 12.D0
     &    *Hr3(0,0,0) + 12.D0*Hr3(0,0,0)*x + 24.D0*Hr3(0,0,0)*dp - 8.D0
     &    *Hr3(0,0,1) + 8.D0*Hr3(0,0,1)*x + 16.D0*Hr3(0,0,1)*dp )
      elseif (iorder.eq.3) then
         c2q_diff  = C2Q3DF(x, nf, 0)
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             c2q_diff = 0 
         elseif (iorder.eq.1) then 
             c2q_diff = 0 
         elseif (iorder.eq.2) then 
             c2q_diff = 0 
         elseif (iorder.eq.3) then 
             c2q_diff = 0 
         endif 
      endif      
      return     
      end function c2q_diff  
