!>***************************************************
!> Exact DIS coefficient funtion c2q_minus in x space
!> including scale dependence (new version)
!>
      function c2q_minus(iorder,x,ireg,rmu2,fmu2,q2,flavchange)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      use xcdf3p
      implicit none
      integer iorder,ireg,flavchange
      common/Hrs/Hr1,Hr2,Hr3,Hr4,Hr5
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
!$omp threadprivate(/Hrs/)
      logical qexact
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      integer, parameter :: nf  = 5
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR
      real*8 c2q_minus,x


      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             c2q_minus =  + 1 
         elseif (iorder.eq.1) then 
             c2q_minus =  + LM * ( 4 + 16.D0/3.D0*dd0 )
      c2q_minus = c2q_minus - 12 + 16.D0/3.D0*dd1 - 4*dd0 - 8.D0/9.D0*
     &    Pi**2 
         elseif (iorder.eq.2) then 
             c2q_minus =  + LM * ( 98 + 128.D0/3.D0*dd2 - 80*dd1 + 748.D
     &    0/9.D0*dd0 + 16*Pi**2 - 400.D0/27.D0*Pi**2*dd0 + 208.D0/9.D0*
     &    Zeta3 )
      c2q_minus = c2q_minus + LM**2 * (  - 14 + 256.D0/9.D0*dd1 - 8*dd0
     &     - 64.D0/27.D0*Pi**2 )
      c2q_minus = c2q_minus + LR * ( 132 - 176.D0/3.D0*dd1 + 44*dd0 + 
     &    88.D0/9.D0*Pi**2 )
      c2q_minus = c2q_minus + LR*LM * (  - 44 - 176.D0/3.D0*dd0 )
      c2q_minus = c2q_minus + rnf * ( 457.D0/27.D0 + 16.D0/9.D0*dd2 - 
     &    232.D0/27.D0*dd1 + 988.D0/81.D0*dd0 + 76.D0/27.D0*Pi**2 - 16.D
     &    0/27.D0*Pi**2*dd0 + 16.D0/9.D0*Zeta3 )
      c2q_minus = c2q_minus + rnf*LM * (  - 76.D0/9.D0 + 32.D0/9.D0*dd1
     &     - 232.D0/27.D0*dd0 - 32.D0/27.D0*Pi**2 )
      c2q_minus = c2q_minus + rnf*LM**2 * ( 4.D0/3.D0 + 16.D0/9.D0*dd0
     &     )
      c2q_minus = c2q_minus + rnf*LR * (  - 8 + 32.D0/9.D0*dd1 - 8.D0/3.
     &    D0*dd0 - 16.D0/27.D0*Pi**2 )
      c2q_minus = c2q_minus + rnf*LR*LM * ( 8.D0/3.D0 + 32.D0/9.D0*dd0
     &     )
      c2q_minus = c2q_minus - 4141.D0/18.D0 + 128.D0/9.D0*dd3 - 184.D0/
     &    3.D0*dd2 + 1036.D0/9.D0*dd1 - 5086.D0/27.D0*dd0 - 106.D0/3.D0
     &    *Pi**2 - 400.D0/27.D0*Pi**2*dd1 + 184.D0/9.D0*Pi**2*dd0 + 253.
     &    D0/135.D0*Pi**4 + 48*Zeta3 + 1312.D0/9.D0*Zeta3*dd0 
         elseif (iorder.eq.3) then 
             c2q_minus = 131770.D0/27.D0*LM - 1058*LM**2 + 84*LM**3 + 
     & 56567.D0/9.D0*LR - 2564*LR*LM + 308*LR*LM**2 - 1452*LR**2 + 484*
     & LR**2*LM + 2560.D0/27.D0*dd4*LM - 18688.D0/27.D0*dd3*LM + 4096.D0
     & /27.D0*dd3*LM**2 - 2816.D0/9.D0*dd3*LR + 26800.D0/9.D0*dd2*LM - 
     & 704*dd2*LM**2 + 2048.D0/27.D0*dd2*LM**3 + 4048.D0/3.D0*dd2*LR - 
     & 2816.D0/3.D0*dd2*LR*LM - 445784.D0/81.D0*dd1*LM + 48560.D0/27.D0
     & *dd1*LM**2 - 1792.D0/9.D0*dd1*LM**3 - 27688.D0/9.D0*dd1*LR + 
     & 1760*dd1*LR*LM - 5632.D0/9.D0*dd1*LR*LM**2 + 1936.D0/3.D0*dd1*
     & LR**2 + 82252.D0/27.D0*dd0*LM - 4348.D0/9.D0*dd0*LM**2 + 208.D0/
     & 9.D0*dd0*LM**3 + 122908.D0/27.D0*dd0*LR - 21352.D0/9.D0*dd0*LR*
     & LM + 176*dd0*LR*LM**2 - 484*dd0*LR**2 + 1936.D0/3.D0*dd0*LR**2*
     & LM + 268532.D0/243.D0*Pi**2*LM - 17936.D0/81.D0*Pi**2*LM**2 + 
     & 448.D0/27.D0*Pi**2*LM**3 + 868*Pi**2*LR - 352*Pi**2*LR*LM + 1408.
     & D0/27.D0*Pi**2*LR*LM**2 - 968.D0/9.D0*Pi**2*LR**2 - 1792.D0/9.D0
     & *Pi**2*dd2*LM + 18080.D0/27.D0*Pi**2*dd1*LM - 11776.D0/81.D0*
     & Pi**2*dd1*LM**2
      c2q_minus = c2q_minus + 8800.D0/27.D0*Pi**2*dd1*LR - 28880.D0/27.D
     & 0*Pi**2*dd0*LM + 5872.D0/27.D0*Pi**2*dd0*LM**2 - 1024.D0/81.D0*
     & Pi**2*dd0*LM**3 - 4048.D0/9.D0*Pi**2*dd0*LR + 8800.D0/27.D0*
     & Pi**2*dd0*LR*LM - 2716.D0/45.D0*Pi**4*LM + 7808.D0/1215.D0*Pi**4
     & *LM**2 - 5566.D0/135.D0*Pi**4*LR + 47776.D0/1215.D0*Pi**4*dd0*LM
     &  - 19412.D0/27.D0*rnf*LM + 1492.D0/9.D0*rnf*LM**2 - 128.D0/9.D0*
     & rnf*LM**3 - 7480.D0/9.D0*rnf*LR + 3304.D0/9.D0*rnf*LR*LM - 48*
     & rnf*LR*LM**2 + 176*rnf*LR**2 - 176.D0/3.D0*rnf*LR**2*LM + 2560.D0
     & /81.D0*rnf*dd3*LM + 512.D0/27.D0*rnf*dd3*LR - 6208.D0/27.D0*rnf*
     & dd2*LM + 128.D0/3.D0*rnf*dd2*LM**2 - 1088.D0/9.D0*rnf*dd2*LR + 
     & 512.D0/9.D0*rnf*dd2*LR*LM + 133856.D0/243.D0*rnf*dd1*LM - 13184.D
     & 0/81.D0*rnf*dd1*LM**2 + 512.D0/27.D0*rnf*dd1*LM**3 + 11072.D0/27.
     & D0*rnf*dd1*LR - 1664.D0/9.D0*rnf*dd1*LR*LM + 1024.D0/27.D0*rnf*
     & dd1*LR*LM**2 - 704.D0/9.D0*rnf*dd1*LR**2 - 14776.D0/27.D0*rnf*
     & dd0*LM + 3536.D0/27.D0*rnf*dd0*LM**2 - 320.D0/27.D0*rnf*dd0*
     & LM**3
      c2q_minus = c2q_minus - 46184.D0/81.D0*rnf*dd0*LR + 9920.D0/27.D0
     & *rnf*dd0*LR*LM - 448.D0/9.D0*rnf*dd0*LR*LM**2 + 176.D0/3.D0*rnf*
     & dd0*LR**2 - 704.D0/9.D0*rnf*dd0*LR**2*LM - 107408.D0/729.D0*rnf*
     & Pi**2*LM + 6464.D0/243.D0*rnf*Pi**2*LM**2 - 128.D0/81.D0*rnf*
     & Pi**2*LM**3 - 3248.D0/27.D0*rnf*Pi**2*LR + 1280.D0/27.D0*rnf*
     & Pi**2*LR*LM - 256.D0/81.D0*rnf*Pi**2*LR*LM**2 + 352.D0/27.D0*rnf
     & *Pi**2*LR**2 - 2624.D0/81.D0*rnf*Pi**2*dd1*LM - 1600.D0/81.D0*
     & rnf*Pi**2*dd1*LR + 256.D0/3.D0*rnf*Pi**2*dd0*LM - 1312.D0/81.D0*
     & rnf*Pi**2*dd0*LM**2 + 1088.D0/27.D0*rnf*Pi**2*dd0*LR - 1600.D0/
     & 81.D0*rnf*Pi**2*dd0*LR*LM + 5096.D0/1215.D0*rnf*Pi**4*LM + 1012.D
     & 0/405.D0*rnf*Pi**4*LR + 1624.D0/81.D0*rnf**2*LM - 152.D0/27.D0*
     & rnf**2*LM**2 + 16.D0/27.D0*rnf**2*LM**3 + 1828.D0/81.D0*rnf**2*
     & LR - 304.D0/27.D0*rnf**2*LR*LM + 16.D0/9.D0*rnf**2*LR*LM**2 - 16.
     & D0/3.D0*rnf**2*LR**2 + 16.D0/9.D0*rnf**2*LR**2*LM + 64.D0/27.D0*
     & rnf**2*dd2*LM + 64.D0/27.D0*rnf**2*dd2*LR - 928.D0/81.D0*rnf**2*
     & dd1*LM
      c2q_minus = c2q_minus + 64.D0/27.D0*rnf**2*dd1*LM**2 - 928.D0/81.D
     & 0*rnf**2*dd1*LR + 128.D0/27.D0*rnf**2*dd1*LR*LM + 64.D0/27.D0*
     & rnf**2*dd1*LR**2 + 3760.D0/243.D0*rnf**2*dd0*LM - 464.D0/81.D0*
     & rnf**2*dd0*LM**2 + 64.D0/81.D0*rnf**2*dd0*LM**3 + 3952.D0/243.D0
     & *rnf**2*dd0*LR - 928.D0/81.D0*rnf**2*dd0*LR*LM + 64.D0/27.D0*
     & rnf**2*dd0*LR*LM**2 - 16.D0/9.D0*rnf**2*dd0*LR**2 + 64.D0/27.D0*
     & rnf**2*dd0*LR**2*LM + 1072.D0/243.D0*rnf**2*Pi**2*LM - 64.D0/81.D
     & 0*rnf**2*Pi**2*LM**2 + 304.D0/81.D0*rnf**2*Pi**2*LR - 128.D0/81.D
     & 0*rnf**2*Pi**2*LR*LM - 32.D0/81.D0*rnf**2*Pi**2*LR**2 - 64.D0/81.
     & D0*rnf**2*Pi**2*dd0*LM - 64.D0/81.D0*rnf**2*Pi**2*dd0*LR + 9056.D
     & 0/9.D0*Zeta5*LM + 1120.D0/27.D0*Zeta3*LM - 432*Zeta3*LM**2 + 
     & 4096.D0/81.D0*Zeta3*LM**3 - 1056*Zeta3*LR - 4576.D0/9.D0*Zeta3*
     & LR*LM + 53504.D0/27.D0*Zeta3*dd1*LM - 23840.D0/9.D0*Zeta3*dd0*LM
     &  + 7424.D0/27.D0*Zeta3*dd0*LM**2 - 28864.D0/9.D0*Zeta3*dd0*LR - 
     & 18688.D0/81.D0*Zeta3*Pi**2*LM - 3008.D0/81.D0*Zeta3*rnf*LM + 224.
     & D0/9.D0*Zeta3*rnf*LM**2
      c2q_minus = c2q_minus + 224.D0/9.D0*Zeta3*rnf*LR + 832.D0/27.D0*
     & Zeta3*rnf*LR*LM + 3520.D0/27.D0*Zeta3*rnf*dd0*LM + 5248.D0/27.D0
     & *Zeta3*rnf*dd0*LR + 64.D0/27.D0*Zeta3*rnf**2*LR 
             c2q_minus = c2q_minus + c2q_av(iorder,x,ireg,.false.,
     & flavchange) 
         endif 
      elseif (ireg.eq.1) then      
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             c2q_minus =  0 
         elseif (iorder.eq.1) then 
             c2q_minus =  + LM * (  - 8.D0/3.D0 + 16.D0/3.D0*dd0 - 8.D0/
     &    3.D0*x )
      c2q_minus = c2q_minus + 8 - 8.D0/3.D0*dlx1 + 8.D0/3.D0*dlx + 16.D0
     &    /3.D0*dd1 - 4*dd0 - 16.D0/3.D0*dd0*dlx + 16.D0/3.D0*x - 8.D0/
     &    3.D0*x*dlx1 + 8.D0/3.D0*x*dlx 
         elseif (iorder.eq.2) then 
             c2q_minus =  + LM * ( 16.D0/9.D0 + 520.D0/9.D0*dlx1 - 64.D0
     &    /3.D0*dlx1**2 - 496.D0/9.D0*dlx + 128.D0/3.D0*dlx*dlx1 - 176.D
     &    0/9.D0*dlx**2 + 128.D0/3.D0*dd2 - 80*dd1 - 256.D0/3.D0*dd1*
     &    dlx + 748.D0/9.D0*dd0 + 96*dd0*dlx + 272.D0/9.D0*dd0*dlx**2
     &     + 224.D0/27.D0*Pi**2 - 400.D0/27.D0*Pi**2*dd0 - 1352.D0/9.D0
     &    *x + 72*x*dlx1 - 64.D0/3.D0*x*dlx1**2 - 752.D0/9.D0*x*dlx + 
     &    128.D0/3.D0*x*dlx*dlx1 - 64.D0/3.D0*x*dlx**2 + 80.D0/9.D0*x*
     &    Pi**2 - 32.D0/9.D0*Hr1(-1)*dlx + 32.D0/9.D0*Hr1(-1)*x*dlx + 
     &    32.D0/9.D0*Hr2(0,-1) - 32.D0/9.D0*Hr2(0,-1)*x - 64.D0/9.D0*
     &    Hr2(0,1) - 64.D0/9.D0*Hr2(0,1)*x - 16.D0/9.D0/(1 + x)*dlx**2
     &     + 16.D0/27.D0/(1 + x)*Pi**2 + 64.D0/9.D0/(1 + x)*Hr1(-1)*dlx
     &     - 64.D0/9.D0/(1 + x)*Hr2(0,-1) )
      c2q_minus = c2q_minus + LM**2 * (  - 28.D0/9.D0 - 128.D0/9.D0*
     &    dlx1 + 32.D0/3.D0*dlx + 256.D0/9.D0*dd1 - 8*dd0 - 128.D0/9.D0
     &    *dd0*dlx + 100.D0/9.D0*x - 128.D0/9.D0*x*dlx1 + 32.D0/3.D0*x*
     &    dlx )
      c2q_minus = c2q_minus + LR * (  - 88 + 88.D0/3.D0*dlx1 - 88.D0/3.D
     &    0*dlx - 176.D0/3.D0*dd1 + 44*dd0 + 176.D0/3.D0*dd0*dlx - 176.D
     &    0/3.D0*x + 88.D0/3.D0*x*dlx1 - 88.D0/3.D0*x*dlx )
      c2q_minus = c2q_minus + LR*LM * ( 88.D0/3.D0 - 176.D0/3.D0*dd0 + 
     &    88.D0/3.D0*x )
      c2q_minus = c2q_minus + rnf * (  - 632.D0/81.D0 + 128.D0/27.D0*
     &    dlx1 - 8.D0/9.D0*dlx1**2 - 104.D0/9.D0*dlx + 16.D0/9.D0*dlx*
     &    dlx1 - 20.D0/9.D0*dlx**2 + 16.D0/9.D0*dd2 - 232.D0/27.D0*dd1
     &     - 32.D0/9.D0*dd1*dlx + 988.D0/81.D0*dd0 + 152.D0/9.D0*dd0*
     &    dlx + 40.D0/9.D0*dd0*dlx**2 + 16.D0/27.D0*Pi**2 - 32.D0/27.D0
     &    *Pi**2*dd0 - 1952.D0/81.D0*x + 272.D0/27.D0*x*dlx1 - 8.D0/9.D0
     &    *x*dlx1**2 - 152.D0/9.D0*x*dlx + 16.D0/9.D0*x*dlx*dlx1 - 20.D0
     &    /9.D0*x*dlx**2 + 16.D0/27.D0*x*Pi**2 - 16.D0/9.D0*Hr2(0,1) + 
     &    32.D0/9.D0*Hr2(0,1)*dd0 - 16.D0/9.D0*Hr2(0,1)*x )
      c2q_minus = c2q_minus + rnf*LM * ( 128.D0/27.D0 - 16.D0/9.D0*dlx1
     &     + 32.D0/9.D0*dlx + 32.D0/9.D0*dd1 - 232.D0/27.D0*dd0 - 64.D0/
     &    9.D0*dd0*dlx + 272.D0/27.D0*x - 16.D0/9.D0*x*dlx1 + 32.D0/9.D0
     &    *x*dlx )
      c2q_minus = c2q_minus + rnf*LM**2 * (  - 8.D0/9.D0 + 16.D0/9.D0*
     &    dd0 - 8.D0/9.D0*x )
      c2q_minus = c2q_minus + rnf*LR * ( 16.D0/3.D0 - 16.D0/9.D0*dlx1
     &     + 16.D0/9.D0*dlx + 32.D0/9.D0*dd1 - 8.D0/3.D0*dd0 - 32.D0/9.D
     &    0*dd0*dlx + 32.D0/9.D0*x - 16.D0/9.D0*x*dlx1 + 16.D0/9.D0*x*
     &    dlx )
      c2q_minus = c2q_minus + rnf*LR*LM * (  - 16.D0/9.D0 + 32.D0/9.D0*
     &    dd0 - 16.D0/9.D0*x )
      c2q_minus = c2q_minus + 1388.D0/27.D0 - 416.D0/9.D0*dlx1 + 356.D0/
     &    9.D0*dlx1**2 - 64.D0/9.D0*dlx1**3 + 988.D0/9.D0*dlx - 776.D0/
     &    9.D0*dlx*dlx1 + 184.D0/9.D0*dlx*dlx1**2 + 506.D0/9.D0*dlx**2
     &     - 232.D0/9.D0*dlx**2*dlx1 + 88.D0/9.D0*dlx**3 + 128.D0/9.D0*
     &    dd3 - 184.D0/3.D0*dd2 - 368.D0/9.D0*dd2*dlx + 1036.D0/9.D0*
     &    dd1 + 368.D0/3.D0*dd1*dlx + 160.D0/3.D0*dd1*dlx**2 - 5086.D0/
     &    27.D0*dd0 - 1892.D0/9.D0*dd0*dlx - 236.D0/3.D0*dd0*dlx**2 - 
     &    344.D0/27.D0*dd0*dlx**3 - 512.D0/27.D0*Pi**2 + 272.D0/27.D0*
     &    Pi**2*dlx1 - 112.D0/9.D0*Pi**2*dlx - 560.D0/27.D0*Pi**2*dd1
     &     + 80.D0/3.D0*Pi**2*dd0 + 176.D0/9.D0*Pi**2*dd0*dlx - 224.D0/
     &    3.D0*Zeta3 + 1168.D0/9.D0*Zeta3*dd0 + 9872.D0/27.D0*x - 1648.D
     &    0/9.D0*x*dlx1 + 140.D0/3.D0*x*dlx1**2 - 64.D0/9.D0*x*dlx1**3
     &     + 260*x*dlx - 776.D0/9.D0*x*dlx*dlx1 + 184.D0/9.D0*x*dlx*
     &    dlx1**2 + 66*x*dlx**2 - 280.D0/9.D0*x*dlx**2*dlx1 + 80.D0/9.D0
     &    *x*dlx**3 - 632.D0/27.D0*x*Pi**2 + 320.D0/27.D0*x*Pi**2*dlx1
     &     - 320.D0/27.D0*x*Pi**2*dlx
      c2q_minus = c2q_minus - 592.D0/9.D0*x*Zeta3 - 32.D0/3.D0*x**2*
     &    dlx**2 + 32.D0/9.D0*x**2*Pi**2 - 16.D0/9.D0*Hr1(-1)*dlx - 32.D
     &    0/9.D0*Hr1(-1)*dlx**2 + 8.D0/9.D0*Hr1(-1)*Pi**2 + 16.D0/3.D0*
     &    Hr1(-1)*x*dlx + 80.D0/9.D0*Hr1(-1)*x*dlx**2 - 8.D0/3.D0*Hr1(
     &    -1)*x*Pi**2 + 64.D0/3.D0*Hr1(-1)*x**2*dlx + 32.D0/9.D0*Hr2(-1
     &    ,-1)*dlx - 224.D0/9.D0*Hr2(-1,-1)*x*dlx + 16.D0/9.D0*Hr2(0,-1
     &    ) + 64.D0/9.D0*Hr2(0,-1)*dlx - 32.D0/3.D0*Hr2(0,-1)*dd0*dlx
     &     - 16.D0/3.D0*Hr2(0,-1)*x + 32.D0/3.D0*Hr2(0,-1)*x*dlx - 64.D0
     &    /3.D0*Hr2(0,-1)*x**2 + 232.D0/9.D0*Hr2(0,1) - 160.D0/9.D0*
     &    Hr2(0,1)*dlx1 - 16.D0/9.D0*Hr2(0,1)*dlx + 320.D0/9.D0*Hr2(0,1
     &    )*dd1 - 112.D0/3.D0*Hr2(0,1)*dd0 + 64.D0/3.D0*Hr2(0,1)*dd0*
     &    dlx + 488.D0/9.D0*Hr2(0,1)*x - 160.D0/9.D0*Hr2(0,1)*x*dlx1 - 
     &    112.D0/9.D0*Hr2(0,1)*x*dlx - 32.D0/9.D0*Hr3(-1,0,-1) + 224.D0/
     &    9.D0*Hr3(-1,0,-1)*x - 32.D0/9.D0*Hr3(-1,0,1) + 32.D0/9.D0*
     &    Hr3(-1,0,1)*x - 32.D0/9.D0*Hr3(0,-1,-1) + 224.D0/9.D0*Hr3(0,
     &    -1,-1)*x
      c2q_minus = c2q_minus - 64.D0/9.D0*Hr3(0,0,-1) + 64.D0/3.D0*Hr3(0
     &    ,0,-1)*dd0 - 352.D0/9.D0*Hr3(0,0,-1)*x + 80.D0/3.D0*Hr3(0,0,1
     &    ) - 160.D0/3.D0*Hr3(0,0,1)*dd0 + 304.D0/9.D0*Hr3(0,0,1)*x - 
     &    176.D0/9.D0*Hr3(0,1,1) + 160.D0/3.D0*Hr3(0,1,1)*dd0 - 176.D0/
     &    9.D0*Hr3(0,1,1)*x - 32.D0/9.D0/(1 + x)*dlx - 8.D0/9.D0/(1 + x
     &    )*dlx**3 + 16.D0/27.D0/(1 + x)*Pi**2*dlx + 112.D0/9.D0/(1 + x
     &    )*Zeta3 + 80.D0/9.D0/(1 + x)*Hr1(-1)*dlx**2 - 64.D0/27.D0/(1
     &     + x)*Hr1(-1)*Pi**2 - 128.D0/9.D0/(1 + x)*Hr2(-1,-1)*dlx - 64.
     &    D0/9.D0/(1 + x)*Hr2(0,-1)*dlx + 128.D0/9.D0/(1 + x)*Hr3(-1,0,
     &    -1) + 64.D0/9.D0/(1 + x)*Hr3(-1,0,1) + 128.D0/9.D0/(1 + x)*
     &    Hr3(0,-1,-1) - 32.D0/9.D0/(1 + x)*Hr3(0,0,-1) - 32.D0/9.D0/(1
     &     + x)*Hr3(0,0,1) 
         elseif (iorder.eq.3) then 
             c2q_minus = 291008.D0/81.D0*LM - 6344.D0/9.D0*LM**2 + 1544.
     & D0/27.D0*LM**3 - 52568.D0/27.D0*LR + 2096.D0/9.D0*LR*LM + 616.D0/
     & 9.D0*LR*LM**2 + 968*LR**2 - 968.D0/3.D0*LR**2*LM + 63088.D0/81.D0
     & *dlx1*LM - 600*dlx1*LM**2 + 1664.D0/27.D0*dlx1*LM**3 + 11600.D0/
     & 9.D0*dlx1*LR - 11440.D0/9.D0*dlx1*LR*LM + 2816.D0/9.D0*dlx1*LR*
     & LM**2 - 968.D0/3.D0*dlx1*LR**2 - 32072.D0/27.D0*dlx1**2*LM + 
     & 9248.D0/27.D0*dlx1**2*LM**2 - 1024.D0/27.D0*dlx1**2*LM**3 - 7832.
     & D0/9.D0*dlx1**2*LR + 1408.D0/3.D0*dlx1**2*LR*LM + 3200.D0/9.D0*
     & dlx1**3*LM - 2048.D0/27.D0*dlx1**3*LM**2 + 1408.D0/9.D0*dlx1**3*
     & LR - 1280.D0/27.D0*dlx1**4*LM - 59008.D0/27.D0*dlx*LM + 16336.D0/
     & 27.D0*dlx*LM**2 - 1760.D0/27.D0*dlx*LM**3 - 24184.D0/9.D0*dlx*LR
     &  + 10912.D0/9.D0*dlx*LR*LM - 704.D0/3.D0*dlx*LR*LM**2 + 968.D0/3.
     & D0*dlx*LR**2 + 69712.D0/27.D0*dlx*dlx1*LM - 14464.D0/27.D0*dlx*
     & dlx1*LM**2 + 1024.D0/27.D0*dlx*dlx1*LM**3 + 17072.D0/9.D0*dlx*
     & dlx1*LR - 2816.D0/3.D0*dlx*dlx1*LR*LM - 27472.D0/27.D0*dlx*
     & dlx1**2*LM
      c2q_minus = c2q_minus + 5632.D0/27.D0*dlx*dlx1**2*LM**2 - 4048.D0/
     & 9.D0*dlx*dlx1**2*LR + 1664.D0/9.D0*dlx*dlx1**3*LM - 47648.D0/27.D
     & 0*dlx**2*LM + 2464.D0/9.D0*dlx**2*LM**2 - 896.D0/81.D0*dlx**2*
     & LM**3 - 11132.D0/9.D0*dlx**2*LR + 3872.D0/9.D0*dlx**2*LR*LM + 
     & 1000*dlx**2*dlx1*LM - 3712.D0/27.D0*dlx**2*dlx1*LM**2 + 5104.D0/
     & 9.D0*dlx**2*dlx1*LR - 6272.D0/27.D0*dlx**2*dlx1**2*LM - 32608.D0/
     & 81.D0*dlx**3*LM + 2624.D0/81.D0*dlx**3*LM**2 - 1936.D0/9.D0*
     & dlx**3*LR + 11488.D0/81.D0*dlx**3*dlx1*LM - 2608.D0/81.D0*dlx**4
     & *LM + 2560.D0/27.D0*dd4*LM - 18688.D0/27.D0*dd3*LM + 4096.D0/27.D
     & 0*dd3*LM**2 - 2816.D0/9.D0*dd3*LR - 3328.D0/9.D0*dd3*dlx*LM + 
     & 26800.D0/9.D0*dd2*LM - 704*dd2*LM**2 + 2048.D0/27.D0*dd2*LM**3
     &  + 4048.D0/3.D0*dd2*LR - 2816.D0/3.D0*dd2*LR*LM + 5792.D0/3.D0*
     & dd2*dlx*LM - 11264.D0/27.D0*dd2*dlx*LM**2 + 8096.D0/9.D0*dd2*dlx
     & *LR + 1408.D0/3.D0*dd2*dlx**2*LM - 445784.D0/81.D0*dd1*LM + 
     & 48560.D0/27.D0*dd1*LM**2 - 1792.D0/9.D0*dd1*LM**3 - 27688.D0/9.D0
     & *dd1*LR
      c2q_minus = c2q_minus + 1760*dd1*LR*LM - 5632.D0/9.D0*dd1*LR*
     & LM**2 + 1936.D0/3.D0*dd1*LR**2 - 169888.D0/27.D0*dd1*dlx*LM + 
     & 1280*dd1*dlx*LM**2 - 2048.D0/27.D0*dd1*dlx*LM**3 - 8096.D0/3.D0*
     & dd1*dlx*LR + 5632.D0/3.D0*dd1*dlx*LR*LM - 6160.D0/3.D0*dd1*
     & dlx**2*LM + 7424.D0/27.D0*dd1*dlx**2*LM**2 - 3520.D0/3.D0*dd1*
     & dlx**2*LR - 7744.D0/27.D0*dd1*dlx**3*LM + 82252.D0/27.D0*dd0*LM
     &  - 4348.D0/9.D0*dd0*LM**2 + 208.D0/9.D0*dd0*LM**3 + 122908.D0/27.
     & D0*dd0*LR - 21352.D0/9.D0*dd0*LR*LM + 176*dd0*LR*LM**2 - 484*dd0
     & *LR**2 + 1936.D0/3.D0*dd0*LR**2*LM + 533752.D0/81.D0*dd0*dlx*LM
     &  - 35872.D0/27.D0*dd0*dlx*LM**2 + 896.D0/9.D0*dd0*dlx*LM**3 + 
     & 46520.D0/9.D0*dd0*dlx*LR - 2112*dd0*dlx*LR*LM + 2816.D0/9.D0*dd0
     & *dlx*LR*LM**2 - 1936.D0/3.D0*dd0*dlx*LR**2 + 80960.D0/27.D0*dd0*
     & dlx**2*LM - 3760.D0/9.D0*dd0*dlx**2*LM**2 + 1024.D0/81.D0*dd0*
     & dlx**2*LM**3 + 5192.D0/3.D0*dd0*dlx**2*LR - 5984.D0/9.D0*dd0*
     & dlx**2*LR*LM + 14432.D0/27.D0*dd0*dlx**3*LM - 3328.D0/81.D0*dd0*
     & dlx**3*LM**2
      c2q_minus = c2q_minus + 7568.D0/27.D0*dd0*dlx**3*LR + 112.D0/3.D0
     & *dd0*dlx**4*LM + 14432.D0/27.D0*Pi**2*LM - 9776.D0/81.D0*Pi**2*
     & LM**2 + 256.D0/27.D0*Pi**2*LM**3 + 11264.D0/27.D0*Pi**2*LR - 
     & 4928.D0/27.D0*Pi**2*LR*LM - 3584.D0/9.D0*Pi**2*dlx1*LM + 5888.D0/
     & 81.D0*Pi**2*dlx1*LM**2 - 5984.D0/27.D0*Pi**2*dlx1*LR + 1024.D0/9.
     & D0*Pi**2*dlx1**2*LM + 40984.D0/81.D0*Pi**2*dlx*LM - 1792.D0/27.D0
     & *Pi**2*dlx*LM**2 + 2464.D0/9.D0*Pi**2*dlx*LR - 6880.D0/27.D0*
     & Pi**2*dlx*dlx1*LM + 3532.D0/27.D0*Pi**2*dlx**2*LM - 18688.D0/81.D
     & 0*Pi**2*dd2*LM + 21856.D0/27.D0*Pi**2*dd1*LM - 11776.D0/81.D0*
     & Pi**2*dd1*LM**2 + 12320.D0/27.D0*Pi**2*dd1*LR + 41792.D0/81.D0*
     & Pi**2*dd1*dlx*LM - 31904.D0/27.D0*Pi**2*dd0*LM + 5872.D0/27.D0*
     & Pi**2*dd0*LM**2 - 1024.D0/81.D0*Pi**2*dd0*LM**3 - 1760.D0/3.D0*
     & Pi**2*dd0*LR + 8800.D0/27.D0*Pi**2*dd0*LR*LM - 21520.D0/27.D0*
     & Pi**2*dd0*dlx*LM + 2560.D0/27.D0*Pi**2*dd0*dlx*LM**2 - 3872.D0/9.
     & D0*Pi**2*dd0*dlx*LR - 13888.D0/81.D0*Pi**2*dd0*dlx**2*LM - 9706.D
     & 0/405.D0*Pi**4*LM
      c2q_minus = c2q_minus + 15616.D0/405.D0*Pi**4*dd0*LM - 22448.D0/
     & 243.D0*rnf*LM - 760.D0/81.D0*rnf*LM**2 + 32.D0/27.D0*rnf*LM**3
     &  + 27664.D0/81.D0*rnf*LR - 3664.D0/27.D0*rnf*LR*LM + 416.D0/27.D0
     & *rnf*LR*LM**2 - 352.D0/3.D0*rnf*LR**2 + 352.D0/9.D0*rnf*LR**2*LM
     &  - 47632.D0/243.D0*rnf*dlx1*LM + 6496.D0/81.D0*rnf*dlx1*LM**2 - 
     & 256.D0/27.D0*rnf*dlx1*LM**3 - 5392.D0/27.D0*rnf*dlx1*LR + 3136.D0
     & /27.D0*rnf*dlx1*LR*LM - 512.D0/27.D0*rnf*dlx1*LR*LM**2 + 352.D0/
     & 9.D0*rnf*dlx1*LR**2 + 3104.D0/27.D0*rnf*dlx1**2*LM - 64.D0/3.D0*
     & rnf*dlx1**2*LM**2 + 1952.D0/27.D0*rnf*dlx1**2*LR - 256.D0/9.D0*
     & rnf*dlx1**2*LR*LM - 1280.D0/81.D0*rnf*dlx1**3*LM - 256.D0/27.D0*
     & rnf*dlx1**3*LR + 32512.D0/81.D0*rnf*dlx*LM - 2240.D0/27.D0*rnf*
     & dlx*LM**2 + 64.D0/9.D0*rnf*dlx*LM**3 + 11728.D0/27.D0*rnf*dlx*LR
     &  - 4096.D0/27.D0*rnf*dlx*LR*LM + 128.D0/9.D0*rnf*dlx*LR*LM**2 - 
     & 352.D0/9.D0*rnf*dlx*LR**2 - 21184.D0/81.D0*rnf*dlx*dlx1*LM + 
     & 1280.D0/27.D0*rnf*dlx*dlx1*LM**2 - 4160.D0/27.D0*rnf*dlx*dlx1*LR
     &  + 512.D0/9.D0*rnf*dlx*dlx1*LR*LM
      c2q_minus = c2q_minus + 416.D0/9.D0*rnf*dlx*dlx1**2*LM + 736.D0/
     & 27.D0*rnf*dlx*dlx1**2*LR + 5104.D0/27.D0*rnf*dlx**2*LM - 640.D0/
     & 27.D0*rnf*dlx**2*LM**2 + 3344.D0/27.D0*rnf*dlx**2*LR - 704.D0/27.
     & D0*rnf*dlx**2*LR*LM - 176.D0/3.D0*rnf*dlx**2*dlx1*LM - 928.D0/27.
     & D0*rnf*dlx**2*dlx1*LR + 256.D0/9.D0*rnf*dlx**3*LM + 352.D0/27.D0
     & *rnf*dlx**3*LR + 2560.D0/81.D0*rnf*dd3*LM + 512.D0/27.D0*rnf*dd3
     & *LR - 6208.D0/27.D0*rnf*dd2*LM + 128.D0/3.D0*rnf*dd2*LM**2 - 
     & 1088.D0/9.D0*rnf*dd2*LR + 512.D0/9.D0*rnf*dd2*LR*LM - 832.D0/9.D0
     & *rnf*dd2*dlx*LM - 1472.D0/27.D0*rnf*dd2*dlx*LR + 133856.D0/243.D0
     & *rnf*dd1*LM - 13184.D0/81.D0*rnf*dd1*LM**2 + 512.D0/27.D0*rnf*
     & dd1*LM**3 + 11072.D0/27.D0*rnf*dd1*LR - 1664.D0/9.D0*rnf*dd1*LR*
     & LM + 1024.D0/27.D0*rnf*dd1*LR*LM**2 - 704.D0/9.D0*rnf*dd1*LR**2
     &  + 40832.D0/81.D0*rnf*dd1*dlx*LM - 2560.D0/27.D0*rnf*dd1*dlx*
     & LM**2 + 2176.D0/9.D0*rnf*dd1*dlx*LR - 1024.D0/9.D0*rnf*dd1*dlx*
     & LR*LM + 3232.D0/27.D0*rnf*dd1*dlx**2*LM + 640.D0/9.D0*rnf*dd1*
     & dlx**2*LR
      c2q_minus = c2q_minus - 14776.D0/27.D0*rnf*dd0*LM + 3536.D0/27.D0
     & *rnf*dd0*LM**2 - 320.D0/27.D0*rnf*dd0*LM**3 - 46184.D0/81.D0*rnf
     & *dd0*LR + 9920.D0/27.D0*rnf*dd0*LR*LM - 448.D0/9.D0*rnf*dd0*LR*
     & LM**2 + 176.D0/3.D0*rnf*dd0*LR**2 - 704.D0/9.D0*rnf*dd0*LR**2*LM
     &  - 214240.D0/243.D0*rnf*dd0*dlx*LM + 12928.D0/81.D0*rnf*dd0*dlx*
     & LM**2 - 256.D0/27.D0*rnf*dd0*dlx*LM**3 - 19424.D0/27.D0*rnf*dd0*
     & dlx*LR + 2560.D0/9.D0*rnf*dd0*dlx*LR*LM - 512.D0/27.D0*rnf*dd0*
     & dlx*LR*LM**2 + 704.D0/9.D0*rnf*dd0*dlx*LR**2 - 25376.D0/81.D0*
     & rnf*dd0*dlx**2*LM + 928.D0/27.D0*rnf*dd0*dlx**2*LM**2 - 608.D0/3.
     & D0*rnf*dd0*dlx**2*LR + 1088.D0/27.D0*rnf*dd0*dlx**2*LR*LM - 3104.
     & D0/81.D0*rnf*dd0*dlx**3*LM - 1376.D0/81.D0*rnf*dd0*dlx**3*LR - 
     & 4528.D0/81.D0*rnf*Pi**2*LM + 736.D0/81.D0*rnf*Pi**2*LM**2 - 3104.
     & D0/81.D0*rnf*Pi**2*LR + 896.D0/81.D0*rnf*Pi**2*LR*LM + 64.D0/3.D0
     & *rnf*Pi**2*dlx1*LM + 1088.D0/81.D0*rnf*Pi**2*dlx1*LR - 2672.D0/
     & 81.D0*rnf*Pi**2*dlx*LM - 448.D0/27.D0*rnf*Pi**2*dlx*LR - 3520.D0/
     & 81.D0*rnf*Pi**2*dd1*LM
      c2q_minus = c2q_minus - 2240.D0/81.D0*rnf*Pi**2*dd1*LR + 2816.D0/
     & 27.D0*rnf*Pi**2*dd0*LM - 1312.D0/81.D0*rnf*Pi**2*dd0*LM**2 + 
     & 1664.D0/27.D0*rnf*Pi**2*dd0*LR - 1600.D0/81.D0*rnf*Pi**2*dd0*LR*
     & LM + 4352.D0/81.D0*rnf*Pi**2*dd0*dlx*LM + 704.D0/27.D0*rnf*Pi**2
     & *dd0*dlx*LR - 1184.D0/243.D0*rnf**2*LM + 256.D0/81.D0*rnf**2*
     & LM**2 - 32.D0/81.D0*rnf**2*LM**3 - 2528.D0/243.D0*rnf**2*LR + 
     & 512.D0/81.D0*rnf**2*LR*LM - 32.D0/27.D0*rnf**2*LR*LM**2 + 32.D0/
     & 9.D0*rnf**2*LR**2 - 32.D0/27.D0*rnf**2*LR**2*LM + 512.D0/81.D0*
     & rnf**2*dlx1*LM - 32.D0/27.D0*rnf**2*dlx1*LM**2 + 512.D0/81.D0*
     & rnf**2*dlx1*LR - 64.D0/27.D0*rnf**2*dlx1*LR*LM - 32.D0/27.D0*
     & rnf**2*dlx1*LR**2 - 32.D0/27.D0*rnf**2*dlx1**2*LM - 32.D0/27.D0*
     & rnf**2*dlx1**2*LR - 1216.D0/81.D0*rnf**2*dlx*LM + 64.D0/27.D0*
     & rnf**2*dlx*LM**2 - 416.D0/27.D0*rnf**2*dlx*LR + 128.D0/27.D0*
     & rnf**2*dlx*LR*LM + 32.D0/27.D0*rnf**2*dlx*LR**2 + 64.D0/27.D0*
     & rnf**2*dlx*dlx1*LM + 64.D0/27.D0*rnf**2*dlx*dlx1*LR - 32.D0/9.D0
     & *rnf**2*dlx**2*LM
      c2q_minus = c2q_minus - 80.D0/27.D0*rnf**2*dlx**2*LR + 64.D0/27.D0
     & *rnf**2*dd2*LM + 64.D0/27.D0*rnf**2*dd2*LR - 928.D0/81.D0*rnf**2
     & *dd1*LM + 64.D0/27.D0*rnf**2*dd1*LM**2 - 928.D0/81.D0*rnf**2*dd1
     & *LR + 128.D0/27.D0*rnf**2*dd1*LR*LM + 64.D0/27.D0*rnf**2*dd1*
     & LR**2 - 128.D0/27.D0*rnf**2*dd1*dlx*LM - 128.D0/27.D0*rnf**2*dd1
     & *dlx*LR + 3760.D0/243.D0*rnf**2*dd0*LM - 464.D0/81.D0*rnf**2*dd0
     & *LM**2 + 64.D0/81.D0*rnf**2*dd0*LM**3 + 3952.D0/243.D0*rnf**2*
     & dd0*LR - 928.D0/81.D0*rnf**2*dd0*LR*LM + 64.D0/27.D0*rnf**2*dd0*
     & LR*LM**2 - 16.D0/9.D0*rnf**2*dd0*LR**2 + 64.D0/27.D0*rnf**2*dd0*
     & LR**2*LM + 2144.D0/81.D0*rnf**2*dd0*dlx*LM - 128.D0/27.D0*rnf**2
     & *dd0*dlx*LM**2 + 608.D0/27.D0*rnf**2*dd0*dlx*LR - 256.D0/27.D0*
     & rnf**2*dd0*dlx*LR*LM - 64.D0/27.D0*rnf**2*dd0*dlx*LR**2 + 64.D0/
     & 9.D0*rnf**2*dd0*dlx**2*LM + 160.D0/27.D0*rnf**2*dd0*dlx**2*LR + 
     & 64.D0/81.D0*rnf**2*Pi**2*LM + 64.D0/81.D0*rnf**2*Pi**2*LR - 128.D
     & 0/81.D0*rnf**2*Pi**2*dd0*LM - 128.D0/81.D0*rnf**2*Pi**2*dd0*LR
     &  + 31168.D0/27.D0*Zeta3*LM
      c2q_minus = c2q_minus - 640.D0/9.D0*Zeta3*LM**2 + 4928.D0/3.D0*
     & Zeta3*LR - 18496.D0/27.D0*Zeta3*dlx1*LM + 6016.D0/9.D0*Zeta3*dlx
     & *LM + 12928.D0/9.D0*Zeta3*dd1*LM - 19616.D0/9.D0*Zeta3*dd0*LM + 
     & 4352.D0/27.D0*Zeta3*dd0*LM**2 - 25696.D0/9.D0*Zeta3*dd0*LR - 
     & 20992.D0/27.D0*Zeta3*dd0*dlx*LM - 704.D0/9.D0*Zeta3*rnf*LM - 896.
     & D0/9.D0*Zeta3*rnf*LR + 2816.D0/27.D0*Zeta3*rnf*dd0*LM + 4672.D0/
     & 27.D0*Zeta3*rnf*dd0*LR - 937688.D0/81.D0*x*LM + 1776*x*LM**2 - 
     & 2168.D0/27.D0*x*LM**3 - 231872.D0/27.D0*x*LR + 32192.D0/9.D0*x*
     & LR*LM - 2200.D0/9.D0*x*LR*LM**2 + 1936.D0/3.D0*x*LR**2 - 968.D0/
     & 3.D0*x*LR**2*LM + 738064.D0/81.D0*x*dlx1*LM - 49160.D0/27.D0*x*
     & dlx1*LM**2 + 3712.D0/27.D0*x*dlx1*LM**3 + 38704.D0/9.D0*x*dlx1*
     & LR - 1584*x*dlx1*LR*LM + 2816.D0/9.D0*x*dlx1*LR*LM**2 - 968.D0/3.
     & D0*x*dlx1*LR**2 - 25624.D0/9.D0*x*dlx1**2*LM + 4448.D0/9.D0*x*
     & dlx1**2*LM**2 - 1024.D0/27.D0*x*dlx1**2*LM**3 - 3080.D0/3.D0*x*
     & dlx1**2*LR + 1408.D0/3.D0*x*dlx1**2*LR*LM + 1408.D0/3.D0*x*
     & dlx1**3*LM
      c2q_minus = c2q_minus - 2048.D0/27.D0*x*dlx1**3*LM**2 + 1408.D0/9.
     & D0*x*dlx1**3*LR - 1280.D0/27.D0*x*dlx1**4*LM - 93232.D0/9.D0*x*
     & dlx*LM + 42512.D0/27.D0*x*dlx*LM**2 - 928.D0/9.D0*x*dlx*LM**3 - 
     & 5992*x*dlx*LR + 16544.D0/9.D0*x*dlx*LR*LM - 704.D0/3.D0*x*dlx*LR
     & *LM**2 + 968.D0/3.D0*x*dlx*LR**2 + 150224.D0/27.D0*x*dlx*dlx1*LM
     &  - 23680.D0/27.D0*x*dlx*dlx1*LM**2 + 1024.D0/27.D0*x*dlx*dlx1*
     & LM**3 + 17072.D0/9.D0*x*dlx*dlx1*LR - 2816.D0/3.D0*x*dlx*dlx1*LR
     & *LM - 35408.D0/27.D0*x*dlx*dlx1**2*LM + 5632.D0/27.D0*x*dlx*
     & dlx1**2*LM**2 - 4048.D0/9.D0*x*dlx*dlx1**2*LR + 1664.D0/9.D0*x*
     & dlx*dlx1**3*LM - 86608.D0/27.D0*x*dlx**2*LM + 11312.D0/27.D0*x*
     & dlx**2*LM**2 - 896.D0/81.D0*x*dlx**2*LM**3 - 1452*x*dlx**2*LR + 
     & 1408.D0/3.D0*x*dlx**2*LR*LM + 37784.D0/27.D0*x*dlx**2*dlx1*LM - 
     & 3712.D0/27.D0*x*dlx**2*dlx1*LM**2 + 6160.D0/9.D0*x*dlx**2*dlx1*
     & LR - 6656.D0/27.D0*x*dlx**2*dlx1**2*LM - 4816.D0/9.D0*x*dlx**3*
     & LM + 3008.D0/81.D0*x*dlx**3*LM**2 - 1760.D0/9.D0*x*dlx**3*LR + 
     & 12256.D0/81.D0*x*dlx**3*dlx1*LM
      c2q_minus = c2q_minus - 2668.D0/81.D0*x*dlx**4*LM + 10736.D0/9.D0
     & *x*Pi**2*LM - 1664.D0/9.D0*x*Pi**2*LM**2 + 256.D0/27.D0*x*Pi**2*
     & LM**3 + 13904.D0/27.D0*x*Pi**2*LR - 1760.D0/9.D0*x*Pi**2*LR*LM
     &  - 46496.D0/81.D0*x*Pi**2*dlx1*LM + 5888.D0/81.D0*x*Pi**2*dlx1*
     & LM**2 - 7040.D0/27.D0*x*Pi**2*dlx1*LR + 3328.D0/27.D0*x*Pi**2*
     & dlx1**2*LM + 6344.D0/9.D0*x*Pi**2*dlx*LM - 6016.D0/81.D0*x*Pi**2
     & *dlx*LM**2 + 7040.D0/27.D0*x*Pi**2*dlx*LR - 2464.D0/9.D0*x*Pi**2
     & *dlx*dlx1*LM + 1180.D0/9.D0*x*Pi**2*dlx**2*LM - 6506.D0/243.D0*x
     & *Pi**4*LM + 343424.D0/243.D0*x*rnf*LM - 17912.D0/81.D0*x*rnf*
     & LM**2 + 32.D0/3.D0*x*rnf*LM**3 + 87904.D0/81.D0*x*rnf*LR - 12304.
     & D0/27.D0*x*rnf*LR*LM + 928.D0/27.D0*x*rnf*LR*LM**2 - 704.D0/9.D0
     & *x*rnf*LR**2 + 352.D0/9.D0*x*rnf*LR**2*LM - 189424.D0/243.D0*x*
     & rnf*dlx1*LM + 10720.D0/81.D0*x*rnf*dlx1*LM**2 - 256.D0/27.D0*x*
     & rnf*dlx1*LM**3 - 4496.D0/9.D0*x*rnf*dlx1*LR + 1216.D0/9.D0*x*rnf
     & *dlx1*LR*LM - 512.D0/27.D0*x*rnf*dlx1*LR*LM**2 + 352.D0/9.D0*x*
     & rnf*dlx1*LR**2
      c2q_minus = c2q_minus + 544.D0/3.D0*x*rnf*dlx1**2*LM - 64.D0/3.D0
     & *x*rnf*dlx1**2*LM**2 + 736.D0/9.D0*x*rnf*dlx1**2*LR - 256.D0/9.D0
     & *x*rnf*dlx1**2*LR*LM - 1280.D0/81.D0*x*rnf*dlx1**3*LM - 256.D0/
     & 27.D0*x*rnf*dlx1**3*LR + 1088*x*rnf*dlx*LM - 1216.D0/9.D0*x*rnf*
     & dlx*LM**2 + 64.D0/9.D0*x*rnf*dlx*LM**3 + 752*x*rnf*dlx*LR - 5120.
     & D0/27.D0*x*rnf*dlx*LR*LM + 128.D0/9.D0*x*rnf*dlx*LR*LM**2 - 352.D
     & 0/9.D0*x*rnf*dlx*LR**2 - 30400.D0/81.D0*x*rnf*dlx*dlx1*LM + 1280.
     & D0/27.D0*x*rnf*dlx*dlx1*LM**2 - 4160.D0/27.D0*x*rnf*dlx*dlx1*LR
     &  + 512.D0/9.D0*x*rnf*dlx*dlx1*LR*LM + 416.D0/9.D0*x*rnf*dlx*
     & dlx1**2*LM + 736.D0/27.D0*x*rnf*dlx*dlx1**2*LR + 21152.D0/81.D0*
     & x*rnf*dlx**2*LM - 224.D0/9.D0*x*rnf*dlx**2*LM**2 + 1232.D0/9.D0*
     & x*rnf*dlx**2*LR - 256.D0/9.D0*x*rnf*dlx**2*LR*LM - 592.D0/9.D0*x
     & *rnf*dlx**2*dlx1*LM - 1120.D0/27.D0*x*rnf*dlx**2*dlx1*LR + 2272.D
     & 0/81.D0*x*rnf*dlx**3*LM + 320.D0/27.D0*x*rnf*dlx**3*LR - 20912.D0
     & /243.D0*x*rnf*Pi**2*LM + 256.D0/27.D0*x*rnf*Pi**2*LM**2 - 3584.D0
     & /81.D0*x*rnf*Pi**2*LR
      c2q_minus = c2q_minus + 320.D0/27.D0*x*rnf*Pi**2*LR*LM + 640.D0/
     & 27.D0*x*rnf*Pi**2*dlx1*LM + 1280.D0/81.D0*x*rnf*Pi**2*dlx1*LR - 
     & 2576.D0/81.D0*x*rnf*Pi**2*dlx*LM - 1280.D0/81.D0*x*rnf*Pi**2*dlx
     & *LR - 8960.D0/243.D0*x*rnf**2*LM + 544.D0/81.D0*x*rnf**2*LM**2
     &  - 32.D0/81.D0*x*rnf**2*LM**3 - 7808.D0/243.D0*x*rnf**2*LR + 
     & 1088.D0/81.D0*x*rnf**2*LR*LM - 32.D0/27.D0*x*rnf**2*LR*LM**2 + 
     & 64.D0/27.D0*x*rnf**2*LR**2 - 32.D0/27.D0*x*rnf**2*LR**2*LM + 
     & 1088.D0/81.D0*x*rnf**2*dlx1*LM - 32.D0/27.D0*x*rnf**2*dlx1*LM**2
     &  + 1088.D0/81.D0*x*rnf**2*dlx1*LR - 64.D0/27.D0*x*rnf**2*dlx1*LR
     & *LM - 32.D0/27.D0*x*rnf**2*dlx1*LR**2 - 32.D0/27.D0*x*rnf**2*
     & dlx1**2*LM - 32.D0/27.D0*x*rnf**2*dlx1**2*LR - 2176.D0/81.D0*x*
     & rnf**2*dlx*LM + 64.D0/27.D0*x*rnf**2*dlx*LM**2 - 608.D0/27.D0*x*
     & rnf**2*dlx*LR + 128.D0/27.D0*x*rnf**2*dlx*LR*LM + 32.D0/27.D0*x*
     & rnf**2*dlx*LR**2 + 64.D0/27.D0*x*rnf**2*dlx*dlx1*LM + 64.D0/27.D0
     & *x*rnf**2*dlx*dlx1*LR - 32.D0/9.D0*x*rnf**2*dlx**2*LM - 80.D0/27.
     & D0*x*rnf**2*dlx**2*LR
      c2q_minus = c2q_minus + 64.D0/81.D0*x*rnf**2*Pi**2*LM + 64.D0/81.D
     & 0*x*rnf**2*Pi**2*LR + 49504.D0/27.D0*x*Zeta3*LM - 4480.D0/27.D0*
     & x*Zeta3*LM**2 + 13024.D0/9.D0*x*Zeta3*LR - 23872.D0/27.D0*x*
     & Zeta3*dlx1*LM + 16064.D0/27.D0*x*Zeta3*dlx*LM - 1600.D0/27.D0*x*
     & Zeta3*rnf*LM - 2368.D0/27.D0*x*Zeta3*rnf*LR + 704.D0/3.D0*x**2*
     & dlx**2*LM + 704.D0/3.D0*x**2*dlx**2*LR + 512.D0/27.D0*x**2*
     & dlx**3*LM - 704.D0/9.D0*x**2*Pi**2*LM - 704.D0/9.D0*x**2*Pi**2*
     & LR + 256.D0/27.D0*x**2*Pi**2*dlx1*LM - 1024.D0/27.D0*x**2*Pi**2*
     & dlx*LM - 128.D0/9.D0*x**2*rnf*dlx**2*LM - 128.D0/9.D0*x**2*rnf*
     & dlx**2*LR + 128.D0/27.D0*x**2*rnf*Pi**2*LM + 128.D0/27.D0*x**2*
     & rnf*Pi**2*LR - 2560.D0/9.D0*x**2*Zeta3*LM + 928.D0/27.D0*Hr1(-1)
     & *dlx*LM + 160.D0/27.D0*Hr1(-1)*dlx*LM**2 + 352.D0/9.D0*Hr1(-1)*
     & dlx*LR + 704.D0/9.D0*Hr1(-1)*dlx*LR*LM + 400.D0/27.D0*Hr1(-1)*
     & dlx**2*LM + 128.D0/9.D0*Hr1(-1)*dlx**2*LM**2 + 704.D0/9.D0*Hr1(
     & -1)*dlx**2*LR - 224.D0/81.D0*Hr1(-1)*dlx**3*LM - 592.D0/81.D0*
     & Hr1(-1)*Pi**2*LM
      c2q_minus = c2q_minus - 512.D0/81.D0*Hr1(-1)*Pi**2*LM**2 - 176.D0/
     & 9.D0*Hr1(-1)*Pi**2*LR - 992.D0/81.D0*Hr1(-1)*Pi**2*dlx*LM + 64.D0
     & /81.D0*Hr1(-1)*rnf*dlx*LM - 64.D0/27.D0*Hr1(-1)*rnf*dlx*LM**2 - 
     & 64.D0/27.D0*Hr1(-1)*rnf*dlx*LR - 128.D0/27.D0*Hr1(-1)*rnf*dlx*LR
     & *LM - 32.D0/9.D0*Hr1(-1)*rnf*dlx**2*LM - 128.D0/27.D0*Hr1(-1)*
     & rnf*dlx**2*LR + 160.D0/81.D0*Hr1(-1)*rnf*Pi**2*LM + 32.D0/27.D0*
     & Hr1(-1)*rnf*Pi**2*LR - 128*Hr1(-1)*Zeta3*LM + 928.D0/27.D0*Hr1(
     & -1)*x*dlx*LM - 1184.D0/27.D0*Hr1(-1)*x*dlx*LM**2 - 352.D0/3.D0*
     & Hr1(-1)*x*dlx*LR - 704.D0/9.D0*Hr1(-1)*x*dlx*LR*LM - 496.D0/3.D0
     & *Hr1(-1)*x*dlx**2*LM - 128.D0/9.D0*Hr1(-1)*x*dlx**2*LM**2 - 1760.
     & D0/9.D0*Hr1(-1)*x*dlx**2*LR - 544.D0/81.D0*Hr1(-1)*x*dlx**3*LM
     &  + 5488.D0/81.D0*Hr1(-1)*x*Pi**2*LM + 512.D0/81.D0*Hr1(-1)*x*
     & Pi**2*LM**2 + 176.D0/3.D0*Hr1(-1)*x*Pi**2*LR + 2528.D0/81.D0*
     & Hr1(-1)*x*Pi**2*dlx*LM - 448.D0/81.D0*Hr1(-1)*x*rnf*dlx*LM + 64.D
     & 0/27.D0*Hr1(-1)*x*rnf*dlx*LM**2 + 64.D0/9.D0*Hr1(-1)*x*rnf*dlx*
     & LR
      c2q_minus = c2q_minus + 128.D0/27.D0*Hr1(-1)*x*rnf*dlx*LR*LM + 32.
     & D0/3.D0*Hr1(-1)*x*rnf*dlx**2*LM + 320.D0/27.D0*Hr1(-1)*x*rnf*
     & dlx**2*LR - 352.D0/81.D0*Hr1(-1)*x*rnf*Pi**2*LM - 32.D0/9.D0*
     & Hr1(-1)*x*rnf*Pi**2*LR + 2944.D0/9.D0*Hr1(-1)*x*Zeta3*LM - 1408.D
     & 0/3.D0*Hr1(-1)*x**2*dlx*LM - 1408.D0/3.D0*Hr1(-1)*x**2*dlx*LR - 
     & 512.D0/9.D0*Hr1(-1)*x**2*dlx**2*LM + 256.D0/9.D0*Hr1(-1)*x**2*
     & Pi**2*LM + 256.D0/9.D0*Hr1(-1)*x**2*rnf*dlx*LM + 256.D0/9.D0*
     & Hr1(-1)*x**2*rnf*dlx*LR + 2752.D0/27.D0*Hr2(-1,-1)*dlx*LM - 1024.
     & D0/27.D0*Hr2(-1,-1)*dlx*LM**2 - 704.D0/9.D0*Hr2(-1,-1)*dlx*LR - 
     & 512.D0/27.D0*Hr2(-1,-1)*dlx**2*LM + 640.D0/27.D0*Hr2(-1,-1)*
     & Pi**2*LM + 128.D0/27.D0*Hr2(-1,-1)*rnf*dlx*LM + 128.D0/27.D0*
     & Hr2(-1,-1)*rnf*dlx*LR + 14272.D0/27.D0*Hr2(-1,-1)*x*dlx*LM + 
     & 1024.D0/27.D0*Hr2(-1,-1)*x*dlx*LM**2 + 4928.D0/9.D0*Hr2(-1,-1)*x
     & *dlx*LR + 2816.D0/27.D0*Hr2(-1,-1)*x*dlx**2*LM - 1664.D0/27.D0*
     & Hr2(-1,-1)*x*Pi**2*LM - 896.D0/27.D0*Hr2(-1,-1)*x*rnf*dlx*LM - 
     & 896.D0/27.D0*Hr2(-1,-1)*x*rnf*dlx*LR
      c2q_minus = c2q_minus + 1024.D0/9.D0*Hr2(-1,-1)*x**2*dlx*LM - 928.
     & D0/27.D0*Hr2(0,-1)*LM - 160.D0/27.D0*Hr2(0,-1)*LM**2 - 352.D0/9.D
     & 0*Hr2(0,-1)*LR - 704.D0/9.D0*Hr2(0,-1)*LR*LM - 1600.D0/27.D0*
     & Hr2(0,-1)*dlx*LM - 1408.D0/9.D0*Hr2(0,-1)*dlx*LR + 3200.D0/27.D0
     & *Hr2(0,-1)*dlx*dlx1*LM - 112.D0/27.D0*Hr2(0,-1)*dlx**2*LM - 6400.
     & D0/27.D0*Hr2(0,-1)*dd1*dlx*LM + 128*Hr2(0,-1)*dd0*dlx*LM + 704.D0
     & /3.D0*Hr2(0,-1)*dd0*dlx*LR + 320.D0/9.D0*Hr2(0,-1)*dd0*dlx**2*LM
     &  + 976.D0/81.D0*Hr2(0,-1)*Pi**2*LM - 640.D0/27.D0*Hr2(0,-1)*
     & Pi**2*dd0*LM - 64.D0/81.D0*Hr2(0,-1)*rnf*LM + 64.D0/27.D0*Hr2(0,
     & -1)*rnf*LM**2 + 64.D0/27.D0*Hr2(0,-1)*rnf*LR + 128.D0/27.D0*Hr2(
     & 0,-1)*rnf*LR*LM + 256.D0/27.D0*Hr2(0,-1)*rnf*dlx*LM + 256.D0/27.D
     & 0*Hr2(0,-1)*rnf*dlx*LR - 128.D0/9.D0*Hr2(0,-1)*rnf*dd0*dlx*LM - 
     & 128.D0/9.D0*Hr2(0,-1)*rnf*dd0*dlx*LR - 928.D0/27.D0*Hr2(0,-1)*x*
     & LM + 1184.D0/27.D0*Hr2(0,-1)*x*LM**2 + 352.D0/3.D0*Hr2(0,-1)*x*
     & LR + 704.D0/9.D0*Hr2(0,-1)*x*LR*LM - 4672.D0/27.D0*Hr2(0,-1)*x*
     & dlx*LM
      c2q_minus = c2q_minus - 704.D0/3.D0*Hr2(0,-1)*x*dlx*LR + 3200.D0/
     & 27.D0*Hr2(0,-1)*x*dlx*dlx1*LM - 1744.D0/27.D0*Hr2(0,-1)*x*dlx**2
     & *LM + 1712.D0/81.D0*Hr2(0,-1)*x*Pi**2*LM + 448.D0/81.D0*Hr2(0,-1
     & )*x*rnf*LM - 64.D0/27.D0*Hr2(0,-1)*x*rnf*LM**2 - 64.D0/9.D0*Hr2(
     & 0,-1)*x*rnf*LR - 128.D0/27.D0*Hr2(0,-1)*x*rnf*LR*LM + 128.D0/9.D0
     & *Hr2(0,-1)*x*rnf*dlx*LM + 128.D0/9.D0*Hr2(0,-1)*x*rnf*dlx*LR + 
     & 1408.D0/3.D0*Hr2(0,-1)*x**2*LM + 1408.D0/3.D0*Hr2(0,-1)*x**2*LR
     &  - 256.D0/9.D0*Hr2(0,-1)*x**2*rnf*LM - 256.D0/9.D0*Hr2(0,-1)*
     & x**2*rnf*LR - 14992.D0/27.D0*Hr2(0,1)*LM + 1696.D0/9.D0*Hr2(0,1)
     & *LM**2 - 512.D0/27.D0*Hr2(0,1)*LM**3 - 5104.D0/9.D0*Hr2(0,1)*LR
     &  + 1408.D0/9.D0*Hr2(0,1)*LR*LM + 8768.D0/27.D0*Hr2(0,1)*dlx1*LM
     &  + 3520.D0/9.D0*Hr2(0,1)*dlx1*LR - 2560.D0/27.D0*Hr2(0,1)*
     & dlx1**2*LM - 11600.D0/27.D0*Hr2(0,1)*dlx*LM + 3328.D0/27.D0*Hr2(
     & 0,1)*dlx*LM**2 + 352.D0/9.D0*Hr2(0,1)*dlx*LR + 2560.D0/9.D0*Hr2(
     & 0,1)*dlx*dlx1*LM - 2984.D0/27.D0*Hr2(0,1)*dlx**2*LM + 5120.D0/27.
     & D0*Hr2(0,1)*dd2*LM
      c2q_minus = c2q_minus - 7552.D0/9.D0*Hr2(0,1)*dd1*LM - 7040.D0/9.D
     & 0*Hr2(0,1)*dd1*LR - 14848.D0/27.D0*Hr2(0,1)*dd1*dlx*LM + 672*
     & Hr2(0,1)*dd0*LM + 2464.D0/3.D0*Hr2(0,1)*dd0*LR - 352.D0/9.D0*
     & Hr2(0,1)*dd0*dlx*LM - 512.D0/9.D0*Hr2(0,1)*dd0*dlx*LM**2 - 1408.D
     & 0/3.D0*Hr2(0,1)*dd0*dlx*LR + 64.D0/9.D0*Hr2(0,1)*dd0*dlx**2*LM
     &  + 592.D0/81.D0*Hr2(0,1)*Pi**2*LM + 5824.D0/81.D0*Hr2(0,1)*Pi**2
     & *dd0*LM + 5792.D0/81.D0*Hr2(0,1)*rnf*LM - 64.D0/9.D0*Hr2(0,1)*
     & rnf*LM**2 + 1984.D0/27.D0*Hr2(0,1)*rnf*LR - 256.D0/27.D0*Hr2(0,1
     & )*rnf*LR*LM - 896.D0/27.D0*Hr2(0,1)*rnf*dlx1*LM - 640.D0/27.D0*
     & Hr2(0,1)*rnf*dlx1*LR + 544.D0/27.D0*Hr2(0,1)*rnf*dlx*LM - 64.D0/
     & 27.D0*Hr2(0,1)*rnf*dlx*LR + 1792.D0/27.D0*Hr2(0,1)*rnf*dd1*LM + 
     & 1280.D0/27.D0*Hr2(0,1)*rnf*dd1*LR - 1024.D0/9.D0*Hr2(0,1)*rnf*
     & dd0*LM - 128*Hr2(0,1)*rnf*dd0*LR - 64.D0/9.D0*Hr2(0,1)*rnf*dd0*
     & dlx*LM + 256.D0/9.D0*Hr2(0,1)*rnf*dd0*dlx*LR - 64.D0/27.D0*Hr2(0
     & ,1)*rnf**2*LM - 64.D0/27.D0*Hr2(0,1)*rnf**2*LR + 128.D0/27.D0*
     & Hr2(0,1)*rnf**2*dd0*LM
      c2q_minus = c2q_minus + 128.D0/27.D0*Hr2(0,1)*rnf**2*dd0*LR - 
     & 37712.D0/27.D0*Hr2(0,1)*x*LM + 1696.D0/9.D0*Hr2(0,1)*x*LM**2 - 
     & 512.D0/27.D0*Hr2(0,1)*x*LM**3 - 10736.D0/9.D0*Hr2(0,1)*x*LR + 
     & 1408.D0/9.D0*Hr2(0,1)*x*LR*LM + 13888.D0/27.D0*Hr2(0,1)*x*dlx1*
     & LM + 3520.D0/9.D0*Hr2(0,1)*x*dlx1*LR - 2560.D0/27.D0*Hr2(0,1)*x*
     & dlx1**2*LM - 13456.D0/27.D0*Hr2(0,1)*x*dlx*LM + 3328.D0/27.D0*
     & Hr2(0,1)*x*dlx*LM**2 + 2464.D0/9.D0*Hr2(0,1)*x*dlx*LR + 2048.D0/
     & 9.D0*Hr2(0,1)*x*dlx*dlx1*LM - 2600.D0/27.D0*Hr2(0,1)*x*dlx**2*LM
     &  + 848.D0/81.D0*Hr2(0,1)*x*Pi**2*LM + 10400.D0/81.D0*Hr2(0,1)*x*
     & rnf*LM - 64.D0/9.D0*Hr2(0,1)*x*rnf*LM**2 + 3008.D0/27.D0*Hr2(0,1
     & )*x*rnf*LR - 256.D0/27.D0*Hr2(0,1)*x*rnf*LR*LM - 896.D0/27.D0*
     & Hr2(0,1)*x*rnf*dlx1*LM - 640.D0/27.D0*Hr2(0,1)*x*rnf*dlx1*LR + 
     & 160.D0/27.D0*Hr2(0,1)*x*rnf*dlx*LM - 448.D0/27.D0*Hr2(0,1)*x*rnf
     & *dlx*LR - 64.D0/27.D0*Hr2(0,1)*x*rnf**2*LM - 64.D0/27.D0*Hr2(0,1
     & )*x*rnf**2*LR + 512.D0/27.D0*Hr3(-1,-1,-1)*dlx*LM - 6656.D0/27.D0
     & *Hr3(-1,-1,-1)*x*dlx*LM
      c2q_minus = c2q_minus - 2752.D0/27.D0*Hr3(-1,0,-1)*LM + 1024.D0/
     & 27.D0*Hr3(-1,0,-1)*LM**2 + 704.D0/9.D0*Hr3(-1,0,-1)*LR + 1792.D0/
     & 27.D0*Hr3(-1,0,-1)*dlx*LM - 128.D0/27.D0*Hr3(-1,0,-1)*rnf*LM - 
     & 128.D0/27.D0*Hr3(-1,0,-1)*rnf*LR - 14272.D0/27.D0*Hr3(-1,0,-1)*x
     & *LM - 1024.D0/27.D0*Hr3(-1,0,-1)*x*LM**2 - 4928.D0/9.D0*Hr3(-1,0
     & ,-1)*x*LR - 3328.D0/27.D0*Hr3(-1,0,-1)*x*dlx*LM + 896.D0/27.D0*
     & Hr3(-1,0,-1)*x*rnf*LM + 896.D0/27.D0*Hr3(-1,0,-1)*x*rnf*LR - 
     & 1024.D0/9.D0*Hr3(-1,0,-1)*x**2*LM + 2560.D0/27.D0*Hr3(-1,0,1)*LM
     &  + 512.D0/27.D0*Hr3(-1,0,1)*LM**2 + 704.D0/9.D0*Hr3(-1,0,1)*LR
     &  - 512.D0/27.D0*Hr3(-1,0,1)*dlx*LM - 256.D0/27.D0*Hr3(-1,0,1)*
     & rnf*LM - 128.D0/27.D0*Hr3(-1,0,1)*rnf*LR - 1280.D0/9.D0*Hr3(-1,0
     & ,1)*x*LM - 512.D0/27.D0*Hr3(-1,0,1)*x*LM**2 - 704.D0/9.D0*Hr3(-1
     & ,0,1)*x*LR + 512.D0/27.D0*Hr3(-1,0,1)*x*dlx*LM + 256.D0/27.D0*
     & Hr3(-1,0,1)*x*rnf*LM + 128.D0/27.D0*Hr3(-1,0,1)*x*rnf*LR - 1024.D
     & 0/9.D0*Hr3(-1,0,1)*x**2*LM - 2752.D0/27.D0*Hr3(0,-1,-1)*LM + 
     & 1024.D0/27.D0*Hr3(0,-1,-1)*LM**2
      c2q_minus = c2q_minus + 704.D0/9.D0*Hr3(0,-1,-1)*LR + 704.D0/27.D0
     & *Hr3(0,-1,-1)*dlx*LM - 128.D0/27.D0*Hr3(0,-1,-1)*rnf*LM - 128.D0/
     & 27.D0*Hr3(0,-1,-1)*rnf*LR - 14272.D0/27.D0*Hr3(0,-1,-1)*x*LM - 
     & 1024.D0/27.D0*Hr3(0,-1,-1)*x*LM**2 - 4928.D0/9.D0*Hr3(0,-1,-1)*x
     & *LR - 1216.D0/27.D0*Hr3(0,-1,-1)*x*dlx*LM + 896.D0/27.D0*Hr3(0,
     & -1,-1)*x*rnf*LM + 896.D0/27.D0*Hr3(0,-1,-1)*x*rnf*LR - 1024.D0/9.
     & D0*Hr3(0,-1,-1)*x**2*LM + 3200.D0/27.D0*Hr3(0,-1,1)*dlx*LM - 
     & 6400.D0/27.D0*Hr3(0,-1,1)*dd0*dlx*LM + 3200.D0/27.D0*Hr3(0,-1,1)
     & *x*dlx*LM + 800.D0/9.D0*Hr3(0,0,-1)*LM - 256.D0/9.D0*Hr3(0,0,-1)
     & *LM**2 + 1408.D0/9.D0*Hr3(0,0,-1)*LR - 6400.D0/27.D0*Hr3(0,0,-1)
     & *dlx1*LM - 1376.D0/27.D0*Hr3(0,0,-1)*dlx*LM + 12800.D0/27.D0*
     & Hr3(0,0,-1)*dd1*LM - 256*Hr3(0,0,-1)*dd0*LM - 1408.D0/3.D0*Hr3(0
     & ,0,-1)*dd0*LR - 640.D0/27.D0*Hr3(0,0,-1)*dd0*dlx*LM - 320.D0/27.D
     & 0*Hr3(0,0,-1)*rnf*LM - 256.D0/27.D0*Hr3(0,0,-1)*rnf*LR + 256.D0/
     & 9.D0*Hr3(0,0,-1)*rnf*dd0*LM + 256.D0/9.D0*Hr3(0,0,-1)*rnf*dd0*LR
     &  + 18272.D0/27.D0*Hr3(0,0,-1)*x*LM
      c2q_minus = c2q_minus + 256.D0/9.D0*Hr3(0,0,-1)*x*LM**2 + 7744.D0/
     & 9.D0*Hr3(0,0,-1)*x*LR - 6400.D0/27.D0*Hr3(0,0,-1)*x*dlx1*LM + 
     & 4576.D0/27.D0*Hr3(0,0,-1)*x*dlx*LM - 448.D0/9.D0*Hr3(0,0,-1)*x*
     & rnf*LM - 1408.D0/27.D0*Hr3(0,0,-1)*x*rnf*LR + 1024.D0/9.D0*Hr3(0
     & ,0,-1)*x**2*LM - 4640.D0/27.D0*Hr3(0,0,1)*LM - 3328.D0/27.D0*
     & Hr3(0,0,1)*LM**2 - 1760.D0/3.D0*Hr3(0,0,1)*LR + 256.D0/9.D0*Hr3(
     & 0,0,1)*dlx1*LM - 992.D0/9.D0*Hr3(0,0,1)*dlx*LM - 2560.D0/27.D0*
     & Hr3(0,0,1)*dd1*LM + 2048.D0/3.D0*Hr3(0,0,1)*dd0*LM + 1024.D0/9.D0
     & *Hr3(0,0,1)*dd0*LM**2 + 3520.D0/3.D0*Hr3(0,0,1)*dd0*LR + 7552.D0/
     & 27.D0*Hr3(0,0,1)*dd0*dlx*LM + 1088.D0/27.D0*Hr3(0,0,1)*rnf*LM + 
     & 320.D0/9.D0*Hr3(0,0,1)*rnf*LR - 1792.D0/27.D0*Hr3(0,0,1)*rnf*dd0
     & *LM - 640.D0/9.D0*Hr3(0,0,1)*rnf*dd0*LR - 8288.D0/27.D0*Hr3(0,0,
     & 1)*x*LM - 2816.D0/27.D0*Hr3(0,0,1)*x*LM**2 - 6688.D0/9.D0*Hr3(0,
     & 0,1)*x*LR + 1280.D0/9.D0*Hr3(0,0,1)*x*dlx1*LM - 3488.D0/27.D0*
     & Hr3(0,0,1)*x*dlx*LM + 1216.D0/27.D0*Hr3(0,0,1)*x*rnf*LM + 1216.D0
     & /27.D0*Hr3(0,0,1)*x*rnf*LR
      c2q_minus = c2q_minus + 1024.D0/9.D0*Hr3(0,0,1)*x**2*LM + 3200.D0/
     & 27.D0*Hr3(0,1,-1)*dlx*LM - 6400.D0/27.D0*Hr3(0,1,-1)*dd0*dlx*LM
     &  + 3200.D0/27.D0*Hr3(0,1,-1)*x*dlx*LM - 2080.D0/27.D0*Hr3(0,1,1)
     & *LM + 2560.D0/27.D0*Hr3(0,1,1)*LM**2 + 3872.D0/9.D0*Hr3(0,1,1)*
     & LR - 1280.D0/9.D0*Hr3(0,1,1)*dlx1*LM + 2944.D0/27.D0*Hr3(0,1,1)*
     & dlx*LM + 2560.D0/9.D0*Hr3(0,1,1)*dd1*LM - 960*Hr3(0,1,1)*dd0*LM
     &  - 3520.D0/3.D0*Hr3(0,1,1)*dd0*LR - 17408.D0/27.D0*Hr3(0,1,1)*
     & dd0*dlx*LM - 64.D0/3.D0*Hr3(0,1,1)*rnf*LM - 704.D0/27.D0*Hr3(0,1
     & ,1)*rnf*LR + 640.D0/9.D0*Hr3(0,1,1)*rnf*dd0*LM + 640.D0/9.D0*
     & Hr3(0,1,1)*rnf*dd0*LR - 1568.D0/27.D0*Hr3(0,1,1)*x*LM + 2560.D0/
     & 27.D0*Hr3(0,1,1)*x*LM**2 + 3872.D0/9.D0*Hr3(0,1,1)*x*LR - 1280.D0
     & /9.D0*Hr3(0,1,1)*x*dlx1*LM + 1408.D0/27.D0*Hr3(0,1,1)*x*dlx*LM
     &  - 64.D0/3.D0*Hr3(0,1,1)*x*rnf*LM - 704.D0/27.D0*Hr3(0,1,1)*x*
     & rnf*LR - 512.D0/27.D0*Hr4(-1,-1,0,-1)*LM + 6656.D0/27.D0*Hr4(-1,
     & -1,0,-1)*x*LM - 3584.D0/27.D0*Hr4(-1,-1,0,1)*LM + 6656.D0/27.D0*
     & Hr4(-1,-1,0,1)*x*LM
      c2q_minus = c2q_minus - 512.D0/27.D0*Hr4(-1,0,-1,-1)*LM + 6656.D0/
     & 27.D0*Hr4(-1,0,-1,-1)*x*LM - 2560.D0/27.D0*Hr4(-1,0,0,-1)*LM + 
     & 1024.D0/27.D0*Hr4(-1,0,0,-1)*x*LM + 2560.D0/27.D0*Hr4(-1,0,0,1)*
     & LM - 4096.D0/27.D0*Hr4(-1,0,0,1)*x*LM + 512.D0/27.D0*Hr4(-1,0,1,
     & 1)*LM - 512.D0/27.D0*Hr4(-1,0,1,1)*x*LM - 512.D0/27.D0*Hr4(0,-1,
     & -1,-1)*LM + 6656.D0/27.D0*Hr4(0,-1,-1,-1)*x*LM - 1472.D0/27.D0*
     & Hr4(0,-1,0,-1)*LM - 1088.D0/27.D0*Hr4(0,-1,0,-1)*x*LM + 128.D0/9.
     & D0*Hr4(0,-1,0,1)*LM + 1280.D0/9.D0*Hr4(0,-1,0,1)*dd0*LM - 6784.D0
     & /27.D0*Hr4(0,-1,0,1)*x*LM - 128.D0/9.D0*Hr4(0,0,-1,-1)*LM - 3200.
     & D0/27.D0*Hr4(0,0,-1,-1)*x*LM - 6400.D0/27.D0*Hr4(0,0,-1,1)*LM + 
     & 12800.D0/27.D0*Hr4(0,0,-1,1)*dd0*LM - 6400.D0/27.D0*Hr4(0,0,-1,1
     & )*x*LM + 5248.D0/27.D0*Hr4(0,0,0,-1)*LM - 1280.D0/9.D0*Hr4(0,0,0
     & ,-1)*dd0*LM - 2176.D0/27.D0*Hr4(0,0,0,-1)*x*LM + 7424.D0/27.D0*
     & Hr4(0,0,0,1)*LM - 4864.D0/9.D0*Hr4(0,0,0,1)*dd0*LM + 8192.D0/27.D
     & 0*Hr4(0,0,0,1)*x*LM - 6400.D0/27.D0*Hr4(0,0,1,-1)*LM + 12800.D0/
     & 27.D0*Hr4(0,0,1,-1)*dd0*LM
      c2q_minus = c2q_minus - 6400.D0/27.D0*Hr4(0,0,1,-1)*x*LM + 1792.D0
     & /9.D0*Hr4(0,0,1,1)*LM - 11264.D0/27.D0*Hr4(0,0,1,1)*dd0*LM + 
     & 10496.D0/27.D0*Hr4(0,0,1,1)*x*LM - 3200.D0/27.D0*Hr4(0,1,0,-1)*
     & LM + 6400.D0/27.D0*Hr4(0,1,0,-1)*dd0*LM - 3200.D0/27.D0*Hr4(0,1,
     & 0,-1)*x*LM + 512.D0/3.D0*Hr4(0,1,0,1)*LM - 4096.D0/9.D0*Hr4(0,1,
     & 0,1)*dd0*LM + 2048.D0/9.D0*Hr4(0,1,0,1)*x*LM - 2048.D0/9.D0*Hr4(
     & 0,1,1,1)*LM - 2048.D0/9.D0*Hr4(0,1,1,1)*x*LM + 416.D0/9.D0/(1 + 
     & x)*dlx*LM + 704.D0/9.D0/(1 + x)*dlx*LR - 1312.D0/27.D0/(1 + x)*
     & dlx**2*LM + 112.D0/9.D0/(1 + x)*dlx**2*LM**2 + 352.D0/9.D0/(1 + 
     & x)*dlx**2*LR*LM + 64.D0/27.D0/(1 + x)*dlx**3*LM + 256.D0/81.D0/(
     & 1 + x)*dlx**3*LM**2 + 176.D0/9.D0/(1 + x)*dlx**3*LR - 16.D0/81.D0
     & /(1 + x)*dlx**4*LM + 1184.D0/81.D0/(1 + x)*Pi**2*LM - 112.D0/27.D
     & 0/(1 + x)*Pi**2*LM**2 - 352.D0/27.D0/(1 + x)*Pi**2*LR*LM - 128.D0
     & /27.D0/(1 + x)*Pi**2*dlx*LM - 512.D0/81.D0/(1 + x)*Pi**2*dlx*
     & LM**2 - 352.D0/27.D0/(1 + x)*Pi**2*dlx*LR - 32.D0/81.D0/(1 + x)*
     & Pi**2*dlx**2*LM
      c2q_minus = c2q_minus - 2848.D0/1215.D0/(1 + x)*Pi**4*LM - 128.D0/
     & 27.D0/(1 + x)*rnf*dlx*LM - 128.D0/27.D0/(1 + x)*rnf*dlx*LR + 320.
     & D0/81.D0/(1 + x)*rnf*dlx**2*LM - 32.D0/27.D0/(1 + x)*rnf*dlx**2*
     & LM**2 - 64.D0/27.D0/(1 + x)*rnf*dlx**2*LR*LM - 32.D0/81.D0/(1 + 
     & x)*rnf*dlx**3*LM - 32.D0/27.D0/(1 + x)*rnf*dlx**3*LR - 320.D0/
     & 243.D0/(1 + x)*rnf*Pi**2*LM + 32.D0/81.D0/(1 + x)*rnf*Pi**2*
     & LM**2 + 64.D0/81.D0/(1 + x)*rnf*Pi**2*LR*LM + 32.D0/27.D0/(1 + x
     & )*rnf*Pi**2*dlx*LM + 64.D0/81.D0/(1 + x)*rnf*Pi**2*dlx*LR - 2240.
     & D0/9.D0/(1 + x)*Zeta3*LM - 1792.D0/27.D0/(1 + x)*Zeta3*LM**2 - 
     & 2464.D0/9.D0/(1 + x)*Zeta3*LR - 2560.D0/27.D0/(1 + x)*Zeta3*dlx*
     & LM + 640.D0/27.D0/(1 + x)*Zeta3*rnf*LM + 448.D0/27.D0/(1 + x)*
     & Zeta3*rnf*LR + 640.D0/3.D0/(1 + x)*Hr1(-1)*dlx*LM - 448.D0/9.D0
     & /(1 + x)*Hr1(-1)*dlx*LM**2 - 1408.D0/9.D0/(1 + x)*Hr1(-1)*dlx*LR
     & *LM - 1024.D0/9.D0/(1 + x)*Hr1(-1)*dlx**2*LM - 256.D0/9.D0/(1 + 
     & x)*Hr1(-1)*dlx**2*LM**2 - 1760.D0/9.D0/(1 + x)*Hr1(-1)*dlx**2*LR
     &  + 64.D0/27.D0/(1 + x)*Hr1(-1)*dlx**3*LM
      c2q_minus = c2q_minus + 448.D0/9.D0/(1 + x)*Hr1(-1)*Pi**2*LM + 
     & 1024.D0/81.D0/(1 + x)*Hr1(-1)*Pi**2*LM**2 + 1408.D0/27.D0/(1 + x
     & )*Hr1(-1)*Pi**2*LR + 832.D0/27.D0/(1 + x)*Hr1(-1)*Pi**2*dlx*LM
     &  - 1280.D0/81.D0/(1 + x)*Hr1(-1)*rnf*dlx*LM + 128.D0/27.D0/(1 + 
     & x)*Hr1(-1)*rnf*dlx*LM**2 + 256.D0/27.D0/(1 + x)*Hr1(-1)*rnf*dlx*
     & LR*LM + 256.D0/27.D0/(1 + x)*Hr1(-1)*rnf*dlx**2*LM + 320.D0/27.D0
     & /(1 + x)*Hr1(-1)*rnf*dlx**2*LR - 128.D0/27.D0/(1 + x)*Hr1(-1)*
     & rnf*Pi**2*LM - 256.D0/81.D0/(1 + x)*Hr1(-1)*rnf*Pi**2*LR + 8704.D
     & 0/27.D0/(1 + x)*Hr1(-1)*Zeta3*LM + 1792.D0/9.D0/(1 + x)*Hr2(-1,
     & -1)*dlx*LM + 2048.D0/27.D0/(1 + x)*Hr2(-1,-1)*dlx*LM**2 + 2816.D0
     & /9.D0/(1 + x)*Hr2(-1,-1)*dlx*LR + 1792.D0/27.D0/(1 + x)*Hr2(-1,
     & -1)*dlx**2*LM - 4864.D0/81.D0/(1 + x)*Hr2(-1,-1)*Pi**2*LM - 512.D
     & 0/27.D0/(1 + x)*Hr2(-1,-1)*rnf*dlx*LM - 512.D0/27.D0/(1 + x)*
     & Hr2(-1,-1)*rnf*dlx*LR - 640.D0/3.D0/(1 + x)*Hr2(0,-1)*LM + 448.D0
     & /9.D0/(1 + x)*Hr2(0,-1)*LM**2 + 1408.D0/9.D0/(1 + x)*Hr2(0,-1)*
     & LR*LM
      c2q_minus = c2q_minus + 1024.D0/9.D0/(1 + x)*Hr2(0,-1)*dlx*LM + 
     & 512.D0/27.D0/(1 + x)*Hr2(0,-1)*dlx*LM**2 + 1408.D0/9.D0/(1 + x)*
     & Hr2(0,-1)*dlx*LR - 448.D0/27.D0/(1 + x)*Hr2(0,-1)*dlx**2*LM - 
     & 832.D0/81.D0/(1 + x)*Hr2(0,-1)*Pi**2*LM + 1280.D0/81.D0/(1 + x)*
     & Hr2(0,-1)*rnf*LM - 128.D0/27.D0/(1 + x)*Hr2(0,-1)*rnf*LM**2 - 
     & 256.D0/27.D0/(1 + x)*Hr2(0,-1)*rnf*LR*LM - 256.D0/27.D0/(1 + x)*
     & Hr2(0,-1)*rnf*dlx*LM - 256.D0/27.D0/(1 + x)*Hr2(0,-1)*rnf*dlx*LR
     &  + 512.D0/27.D0/(1 + x)*Hr2(0,1)*LM + 256.D0/27.D0/(1 + x)*Hr2(0
     & ,1)*Pi**2*LM - 1024.D0/9.D0/(1 + x)*Hr3(-1,-1,-1)*dlx*LM - 1792.D
     & 0/9.D0/(1 + x)*Hr3(-1,0,-1)*LM - 2048.D0/27.D0/(1 + x)*Hr3(-1,0,
     & -1)*LM**2 - 2816.D0/9.D0/(1 + x)*Hr3(-1,0,-1)*LR - 4096.D0/27.D0
     & /(1 + x)*Hr3(-1,0,-1)*dlx*LM + 512.D0/27.D0/(1 + x)*Hr3(-1,0,-1)
     & *rnf*LM + 512.D0/27.D0/(1 + x)*Hr3(-1,0,-1)*rnf*LR - 1792.D0/9.D0
     & /(1 + x)*Hr3(-1,0,1)*LM - 1024.D0/27.D0/(1 + x)*Hr3(-1,0,1)*
     & LM**2 - 1408.D0/9.D0/(1 + x)*Hr3(-1,0,1)*LR + 1024.D0/27.D0/(1
     &  + x)*Hr3(-1,0,1)*dlx*LM
      c2q_minus = c2q_minus + 512.D0/27.D0/(1 + x)*Hr3(-1,0,1)*rnf*LM
     &  + 256.D0/27.D0/(1 + x)*Hr3(-1,0,1)*rnf*LR - 1792.D0/9.D0/(1 + x
     & )*Hr3(0,-1,-1)*LM - 2048.D0/27.D0/(1 + x)*Hr3(0,-1,-1)*LM**2 - 
     & 2816.D0/9.D0/(1 + x)*Hr3(0,-1,-1)*LR - 4096.D0/27.D0/(1 + x)*
     & Hr3(0,-1,-1)*dlx*LM + 512.D0/27.D0/(1 + x)*Hr3(0,-1,-1)*rnf*LM
     &  + 512.D0/27.D0/(1 + x)*Hr3(0,-1,-1)*rnf*LR + 512.D0/27.D0/(1 + 
     & x)*Hr3(0,0,-1)*LM**2 + 704.D0/9.D0/(1 + x)*Hr3(0,0,-1)*LR + 1280.
     & D0/27.D0/(1 + x)*Hr3(0,0,-1)*dlx*LM - 128.D0/27.D0/(1 + x)*Hr3(0
     & ,0,-1)*rnf*LR + 896.D0/9.D0/(1 + x)*Hr3(0,0,1)*LM + 512.D0/27.D0
     & /(1 + x)*Hr3(0,0,1)*LM**2 + 704.D0/9.D0/(1 + x)*Hr3(0,0,1)*LR - 
     & 512.D0/27.D0/(1 + x)*Hr3(0,0,1)*dlx*LM - 256.D0/27.D0/(1 + x)*
     & Hr3(0,0,1)*rnf*LM - 128.D0/27.D0/(1 + x)*Hr3(0,0,1)*rnf*LR + 
     & 1024.D0/9.D0/(1 + x)*Hr4(-1,-1,0,-1)*LM + 8192.D0/27.D0/(1 + x)*
     & Hr4(-1,-1,0,1)*LM + 1024.D0/9.D0/(1 + x)*Hr4(-1,0,-1,-1)*LM + 
     & 512.D0/3.D0/(1 + x)*Hr4(-1,0,0,-1)*LM - 5632.D0/27.D0/(1 + x)*
     & Hr4(-1,0,0,1)*LM
      c2q_minus = c2q_minus - 1024.D0/27.D0/(1 + x)*Hr4(-1,0,1,1)*LM + 
     & 1024.D0/9.D0/(1 + x)*Hr4(0,-1,-1,-1)*LM + 512.D0/3.D0/(1 + x)*
     & Hr4(0,-1,0,-1)*LM - 512.D0/3.D0/(1 + x)*Hr4(0,-1,0,1)*LM + 512.D0
     & /3.D0/(1 + x)*Hr4(0,0,-1,-1)*LM - 512.D0/9.D0/(1 + x)*Hr4(0,0,0,
     & -1)*LM + 512.D0/9.D0/(1 + x)*Hr4(0,0,0,1)*LM + 512.D0/27.D0/(1
     &  + x)*Hr4(0,0,1,1)*LM 
             c2q_minus = c2q_minus + c2q_av(iorder,x,ireg,
     & .false.,flavchange) - C2Q3DF(x, nf, 0)
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             c2q_minus =  0 
         elseif (iorder.eq.1) then 
             c2q_minus =  + LM * ( 16.D0/3.D0*dd0 )
      c2q_minus = c2q_minus + 16.D0/3.D0*dd1 - 4*dd0 
         elseif (iorder.eq.2) then 
             c2q_minus =  + LM * ( 128.D0/3.D0*dd2 - 80*dd1 + 748.D0/9.D
     &    0*dd0 - 400.D0/27.D0*Pi**2*dd0 )
      c2q_minus = c2q_minus + LM**2 * ( 256.D0/9.D0*dd1 - 8*dd0 )
      c2q_minus = c2q_minus + LR * (  - 176.D0/3.D0*dd1 + 44*dd0 )
      c2q_minus = c2q_minus + LR*LM * (  - 176.D0/3.D0*dd0 )
      c2q_minus = c2q_minus + rnf * ( 16.D0/9.D0*dd2 - 232.D0/27.D0*dd1
     &     + 988.D0/81.D0*dd0 - 16.D0/27.D0*Pi**2*dd0 )
      c2q_minus = c2q_minus + rnf*LM * ( 32.D0/9.D0*dd1 - 232.D0/27.D0*
     &    dd0 )
      c2q_minus = c2q_minus + rnf*LM**2 * ( 16.D0/9.D0*dd0 )
      c2q_minus = c2q_minus + rnf*LR * ( 32.D0/9.D0*dd1 - 8.D0/3.D0*dd0
     &     )
      c2q_minus = c2q_minus + rnf*LR*LM * ( 32.D0/9.D0*dd0 )
      c2q_minus = c2q_minus + 128.D0/9.D0*dd3 - 184.D0/3.D0*dd2 + 1036.D
     &    0/9.D0*dd1 - 5086.D0/27.D0*dd0 - 400.D0/27.D0*Pi**2*dd1 + 184.
     &    D0/9.D0*Pi**2*dd0 + 1312.D0/9.D0*Zeta3*dd0 
         elseif (iorder.eq.3) then 
             c2q_minus = 2560.D0/27.D0*dd4*LM - 18688.D0/27.D0*dd3*LM
     &  + 4096.D0/27.D0*dd3*LM**2 - 2816.D0/9.D0*dd3*LR + 26800.D0/9.D0
     & *dd2*LM - 704*dd2*LM**2 + 2048.D0/27.D0*dd2*LM**3 + 4048.D0/3.D0
     & *dd2*LR - 2816.D0/3.D0*dd2*LR*LM - 445784.D0/81.D0*dd1*LM + 
     & 48560.D0/27.D0*dd1*LM**2 - 1792.D0/9.D0*dd1*LM**3 - 27688.D0/9.D0
     & *dd1*LR + 1760*dd1*LR*LM - 5632.D0/9.D0*dd1*LR*LM**2 + 1936.D0/3.
     & D0*dd1*LR**2 + 82252.D0/27.D0*dd0*LM - 4348.D0/9.D0*dd0*LM**2 + 
     & 208.D0/9.D0*dd0*LM**3 + 122908.D0/27.D0*dd0*LR - 21352.D0/9.D0*
     & dd0*LR*LM + 176*dd0*LR*LM**2 - 484*dd0*LR**2 + 1936.D0/3.D0*dd0*
     & LR**2*LM - 1792.D0/9.D0*Pi**2*dd2*LM + 18080.D0/27.D0*Pi**2*dd1*
     & LM - 11776.D0/81.D0*Pi**2*dd1*LM**2 + 8800.D0/27.D0*Pi**2*dd1*LR
     &  - 28880.D0/27.D0*Pi**2*dd0*LM + 5872.D0/27.D0*Pi**2*dd0*LM**2
     &  - 1024.D0/81.D0*Pi**2*dd0*LM**3 - 4048.D0/9.D0*Pi**2*dd0*LR + 
     & 8800.D0/27.D0*Pi**2*dd0*LR*LM + 47776.D0/1215.D0*Pi**4*dd0*LM + 
     & 2560.D0/81.D0*rnf*dd3*LM + 512.D0/27.D0*rnf*dd3*LR - 6208.D0/27.D
     & 0*rnf*dd2*LM
      c2q_minus = c2q_minus + 128.D0/3.D0*rnf*dd2*LM**2 - 1088.D0/9.D0*
     & rnf*dd2*LR + 512.D0/9.D0*rnf*dd2*LR*LM + 133856.D0/243.D0*rnf*
     & dd1*LM - 13184.D0/81.D0*rnf*dd1*LM**2 + 512.D0/27.D0*rnf*dd1*
     & LM**3 + 11072.D0/27.D0*rnf*dd1*LR - 1664.D0/9.D0*rnf*dd1*LR*LM
     &  + 1024.D0/27.D0*rnf*dd1*LR*LM**2 - 704.D0/9.D0*rnf*dd1*LR**2 - 
     & 14776.D0/27.D0*rnf*dd0*LM + 3536.D0/27.D0*rnf*dd0*LM**2 - 320.D0/
     & 27.D0*rnf*dd0*LM**3 - 46184.D0/81.D0*rnf*dd0*LR + 9920.D0/27.D0*
     & rnf*dd0*LR*LM - 448.D0/9.D0*rnf*dd0*LR*LM**2 + 176.D0/3.D0*rnf*
     & dd0*LR**2 - 704.D0/9.D0*rnf*dd0*LR**2*LM - 2624.D0/81.D0*rnf*
     & Pi**2*dd1*LM - 1600.D0/81.D0*rnf*Pi**2*dd1*LR + 256.D0/3.D0*rnf*
     & Pi**2*dd0*LM - 1312.D0/81.D0*rnf*Pi**2*dd0*LM**2 + 1088.D0/27.D0
     & *rnf*Pi**2*dd0*LR - 1600.D0/81.D0*rnf*Pi**2*dd0*LR*LM + 64.D0/27.
     & D0*rnf**2*dd2*LM + 64.D0/27.D0*rnf**2*dd2*LR - 928.D0/81.D0*
     & rnf**2*dd1*LM + 64.D0/27.D0*rnf**2*dd1*LM**2 - 928.D0/81.D0*
     & rnf**2*dd1*LR + 128.D0/27.D0*rnf**2*dd1*LR*LM + 64.D0/27.D0*
     & rnf**2*dd1*LR**2
      c2q_minus = c2q_minus + 3760.D0/243.D0*rnf**2*dd0*LM - 464.D0/81.D
     & 0*rnf**2*dd0*LM**2 + 64.D0/81.D0*rnf**2*dd0*LM**3 + 3952.D0/243.D
     & 0*rnf**2*dd0*LR - 928.D0/81.D0*rnf**2*dd0*LR*LM + 64.D0/27.D0*
     & rnf**2*dd0*LR*LM**2 - 16.D0/9.D0*rnf**2*dd0*LR**2 + 64.D0/27.D0*
     & rnf**2*dd0*LR**2*LM - 64.D0/81.D0*rnf**2*Pi**2*dd0*LM - 64.D0/81.
     & D0*rnf**2*Pi**2*dd0*LR + 53504.D0/27.D0*Zeta3*dd1*LM - 23840.D0/
     & 9.D0*Zeta3*dd0*LM + 7424.D0/27.D0*Zeta3*dd0*LM**2 - 28864.D0/9.D0
     & *Zeta3*dd0*LR + 3520.D0/27.D0*Zeta3*rnf*dd0*LM + 5248.D0/27.D0*
     & Zeta3*rnf*dd0*LR 
             c2q_minus = c2q_minus + c2q_av(iorder,x,ireg,.false.,
     & flavchange) 
         endif 
      endif      
      return     
      end function c2q_minus  
