!>***************************************************
!> Exact DIS coefficient funtion c2qps_new in x space
!> including scale dependence
!>
      function c2qps_new(iorder,x,ireg,rmu2,fmu2,q2,flavchange)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      implicit none
      integer iorder,ireg,flavchange
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
      common /Hrs/ Hr1,Hr2,Hr3,Hr4,Hr5
!$omp threadprivate(/Hrs/)
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR
      real*8 c2qps_new,x


      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             c2qps_new =  0 
         elseif (iorder.eq.1) then 
             c2qps_new =  0 
         elseif (iorder.eq.2) then 
             c2qps_new =  0 
         elseif (iorder.eq.3) then 
             c2qps_new =  0 
             c2qps_new = c2qps_new + c2qps_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.1) then      
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             c2qps_new =  0 
         elseif (iorder.eq.1) then 
             c2qps_new =  0 
         elseif (iorder.eq.2) then 
             c2qps_new =  + LM * (  - 416.D0/9.D0 + 416.D0/27.D0*
     &    x**(-1) + 64.D0/9.D0*x**(-1)*dlx1 + 16.D0/3.D0*dlx1 - 32.D0/3.
     &    D0*dlx**2 + 16.D0/9.D0*Pi**2 + 320.D0/9.D0*x - 16.D0/3.D0*x*
     &    dlx1 - 32.D0/3.D0*x*dlx**2 + 16.D0/9.D0*x*Pi**2 - 128.D0/27.D0
     &    *x**2 - 64.D0/9.D0*x**2*dlx1 + 64.D0/3.D0*x**2*dlx - 32.D0/3.D
     &    0*Hr2(0,1) - 32.D0/3.D0*Hr2(0,1)*x )
      c2qps_new = c2qps_new + LM**2 * ( 8.D0/3.D0 + 32.D0/9.D0*x**(-1)
     &     + 16.D0/3.D0*dlx - 8.D0/3.D0*x + 16.D0/3.D0*x*dlx - 32.D0/9.D
     &    0*x**2 )
      c2qps_new = c2qps_new + 632.D0/27.D0 + 1376.D0/81.D0*x**(-1) + 
     &    416.D0/27.D0*x**(-1)*dlx1 + 32.D0/9.D0*x**(-1)*dlx1**2 - 64.D0
     &    /9.D0*x**(-1)*dlx*dlx1 - 32.D0/27.D0*x**(-1)*Pi**2 - 416.D0/9.
     &    D0*dlx1 + 8.D0/3.D0*dlx1**2 + 224.D0/3.D0*dlx - 16.D0/3.D0*
     &    dlx*dlx1 - 4.D0/3.D0*dlx**2 + 40.D0/9.D0*dlx**3 - 32.D0/9.D0*
     &    Pi**2*dlx - 32.D0/3.D0*Zeta3 - 1688.D0/27.D0*x + 320.D0/9.D0*
     &    x*dlx1 - 8.D0/3.D0*x*dlx1**2 - 352.D0/9.D0*x*dlx + 16.D0/3.D0
     &    *x*dlx*dlx1 + 20*x*dlx**2 + 40.D0/9.D0*x*dlx**3 - 32.D0/9.D0*
     &    x*Pi**2 - 32.D0/9.D0*x*Pi**2*dlx - 32.D0/3.D0*x*Zeta3 + 1792.D
     &    0/81.D0*x**2 - 128.D0/27.D0*x**2*dlx1 - 32.D0/9.D0*x**2*
     &    dlx1**2 - 512.D0/27.D0*x**2*dlx + 64.D0/9.D0*x**2*dlx*dlx1 - 
     &    128.D0/9.D0*x**2*dlx**2 + 32.D0/9.D0*x**2*Pi**2 - 64.D0/9.D0*
     &    Hr1(-1)*x**(-1)*dlx - 64.D0/3.D0*Hr1(-1)*dlx - 64.D0/3.D0*
     &    Hr1(-1)*x*dlx - 64.D0/9.D0*Hr1(-1)*x**2*dlx + 64.D0/3.D0*Hr2(
     &    0,-1) + 64.D0/9.D0*Hr2(0,-1)*x**(-1) + 64.D0/3.D0*Hr2(0,-1)*x
     &     + 64.D0/9.D0*Hr2(0,-1)*x**2
      c2qps_new = c2qps_new - 16.D0/3.D0*Hr2(0,1) - 64.D0/9.D0*Hr2(0,1)
     &    *x**(-1) + 32.D0/3.D0*Hr2(0,1)*dlx + 16.D0/3.D0*Hr2(0,1)*x + 
     &    32.D0/3.D0*Hr2(0,1)*x*dlx - 128.D0/9.D0*Hr2(0,1)*x**2 + 32.D0/
     &    3.D0*Hr3(0,1,1) + 32.D0/3.D0*Hr3(0,1,1)*x 
         elseif (iorder.eq.3) then 
             c2qps_new =  - 1061696.D0/405.D0*x**(-1)*LM - 14032.D0/27.D
     & 0*x**(-1)*LM**2 - 704.D0/9.D0*x**(-1)*LM**3 - 30272.D0/81.D0*
     & x**(-1)*LR - 9152.D0/27.D0*x**(-1)*LR*LM - 704.D0/9.D0*x**(-1)*
     & LR*LM**2 - 95072.D0/81.D0*x**(-1)*dlx1*LM - 10624.D0/81.D0*
     & x**(-1)*dlx1*LM**2 + 2176.D0/81.D0*x**(-1)*dlx1*LM**3 - 9152.D0/
     & 27.D0*x**(-1)*dlx1*LR - 1408.D0/9.D0*x**(-1)*dlx1*LR*LM - 1904.D0
     & /27.D0*x**(-1)*dlx1**2*LM + 640.D0/9.D0*x**(-1)*dlx1**2*LM**2 - 
     & 704.D0/9.D0*x**(-1)*dlx1**2*LR + 4672.D0/81.D0*x**(-1)*dlx1**3*
     & LM - 137344.D0/405.D0*x**(-1)*dlx*LM - 832.D0/9.D0*x**(-1)*dlx*
     & LM**2 - 128.D0/9.D0*x**(-1)*dlx*LM**3 + 3904.D0/27.D0*x**(-1)*
     & dlx*dlx1*LM - 1280.D0/9.D0*x**(-1)*dlx*dlx1*LM**2 + 1408.D0/9.D0
     & *x**(-1)*dlx*dlx1*LR - 4928.D0/27.D0*x**(-1)*dlx*dlx1**2*LM + 
     & 5056.D0/27.D0*x**(-1)*dlx**2*dlx1*LM + 704.D0/9.D0*x**(-1)*Pi**2
     & *LM + 704.D0/27.D0*x**(-1)*Pi**2*LR - 4672.D0/81.D0*x**(-1)*
     & Pi**2*dlx1*LM + 128.D0/9.D0*x**(-1)*Pi**2*dlx*LM + 4352.D0/243.D0
     & *x**(-1)*rnf*LM
      c2qps_new = c2qps_new + 64.D0/27.D0*x**(-1)*rnf*LM**2 + 128.D0/81.
     & D0*x**(-1)*rnf*LM**3 + 5504.D0/243.D0*x**(-1)*rnf*LR + 1664.D0/
     & 81.D0*x**(-1)*rnf*LR*LM + 128.D0/27.D0*x**(-1)*rnf*LR*LM**2 - 
     & 640.D0/81.D0*x**(-1)*rnf*dlx1*LM + 1664.D0/81.D0*x**(-1)*rnf*
     & dlx1*LR + 256.D0/27.D0*x**(-1)*rnf*dlx1*LR*LM - 64.D0/27.D0*
     & x**(-1)*rnf*dlx1**2*LM + 128.D0/27.D0*x**(-1)*rnf*dlx1**2*LR - 
     & 256.D0/27.D0*x**(-1)*rnf*dlx*dlx1*LR - 128.D0/81.D0*x**(-1)*rnf*
     & Pi**2*LM - 128.D0/81.D0*x**(-1)*rnf*Pi**2*LR + 11776.D0/27.D0*
     & x**(-1)*Zeta3*LM + 311104.D0/405.D0*LM + 71168.D0/81.D0*LM**2 + 
     & 5008.D0/81.D0*LM**3 - 13904.D0/27.D0*LR + 9152.D0/9.D0*LR*LM - 
     & 176.D0/3.D0*LR*LM**2 + 46352.D0/27.D0*dlx1*LM - 992.D0/9.D0*dlx1
     & *LM**2 + 544.D0/27.D0*dlx1*LM**3 + 9152.D0/9.D0*dlx1*LR - 352.D0/
     & 3.D0*dlx1*LR*LM - 8456.D0/27.D0*dlx1**2*LM + 160.D0/3.D0*dlx1**2
     & *LM**2 - 176.D0/3.D0*dlx1**2*LR + 1168.D0/27.D0*dlx1**3*LM - 
     & 1929568.D0/405.D0*dlx*LM - 1280.D0/3.D0*dlx*LM**2 - 352.D0/9.D0*
     & dlx*LM**3
      c2qps_new = c2qps_new - 4928.D0/3.D0*dlx*LR - 352.D0/3.D0*dlx*LR*
     & LM**2 + 17408.D0/27.D0*dlx*dlx1*LM - 320.D0/3.D0*dlx*dlx1*LM**2
     &  + 352.D0/3.D0*dlx*dlx1*LR - 1232.D0/9.D0*dlx*dlx1**2*LM + 21976.
     & D0/27.D0*dlx**2*LM + 1216.D0/9.D0*dlx**2*LM**2 + 160.D0/27.D0*
     & dlx**2*LM**3 + 88.D0/3.D0*dlx**2*LR + 704.D0/3.D0*dlx**2*LR*LM
     &  + 1528.D0/9.D0*dlx**2*dlx1*LM - 4192.D0/27.D0*dlx**3*LM - 160.D0
     & /9.D0*dlx**3*LM**2 - 880.D0/9.D0*dlx**3*LR + 440.D0/27.D0*dlx**4
     & *LM - 1768.D0/27.D0*Pi**2*LM - 176.D0/9.D0*Pi**2*LM**2 + 544.D0/
     & 81.D0*Pi**2*LM**3 - 352.D0/9.D0*Pi**2*LR*LM - 896.D0/27.D0*Pi**2
     & *dlx1*LM + 1720.D0/27.D0*Pi**2*dlx*LM - 928.D0/27.D0*Pi**2*dlx*
     & LM**2 + 704.D0/9.D0*Pi**2*dlx*LR + 1000.D0/27.D0*Pi**2*dlx**2*LM
     &  + 20.D0/27.D0*Pi**4*LM + 13120.D0/81.D0*rnf*LM - 1120.D0/27.D0*
     & rnf*LM**2 + 32.D0/27.D0*rnf*LM**3 + 2528.D0/81.D0*rnf*LR - 1664.D
     & 0/27.D0*rnf*LR*LM + 32.D0/9.D0*rnf*LR*LM**2 - 32.D0/3.D0*rnf*
     & dlx1*LM - 1664.D0/27.D0*rnf*dlx1*LR + 64.D0/9.D0*rnf*dlx1*LR*LM
     &  - 16.D0/9.D0*rnf*dlx1**2*LM
      c2qps_new = c2qps_new + 32.D0/9.D0*rnf*dlx1**2*LR + 12160.D0/81.D0
     & *rnf*dlx*LM - 512.D0/27.D0*rnf*dlx*LM**2 + 64.D0/27.D0*rnf*dlx*
     & LM**3 + 896.D0/9.D0*rnf*dlx*LR + 64.D0/9.D0*rnf*dlx*LR*LM**2 - 
     & 64.D0/9.D0*rnf*dlx*dlx1*LR + 928.D0/27.D0*rnf*dlx**2*LM - 64.D0/
     & 9.D0*rnf*dlx**2*LM**2 - 16.D0/9.D0*rnf*dlx**2*LR - 128.D0/9.D0*
     & rnf*dlx**2*LR*LM + 64.D0/9.D0*rnf*dlx**3*LM + 160.D0/27.D0*rnf*
     & dlx**3*LR - 256.D0/81.D0*rnf*Pi**2*LM + 64.D0/27.D0*rnf*Pi**2*LR
     & *LM - 128.D0/27.D0*rnf*Pi**2*dlx*LR + 704.D0/9.D0*Zeta3*LM - 
     & 1664.D0/9.D0*Zeta3*LM**2 + 704.D0/3.D0*Zeta3*LR + 9920.D0/9.D0*
     & Zeta3*dlx*LM + 64.D0/9.D0*Zeta3*rnf*LM - 128.D0/9.D0*Zeta3*rnf*
     & LR + 96496.D0/405.D0*x*LM - 41600.D0/81.D0*x*LM**2 - 5008.D0/81.D
     & 0*x*LM**3 + 37136.D0/27.D0*x*LR - 7040.D0/9.D0*x*LR*LM + 176.D0/
     & 3.D0*x*LR*LM**2 - 31472.D0/27.D0*x*dlx1*LM + 160.D0/9.D0*x*dlx1*
     & LM**2 - 544.D0/27.D0*x*dlx1*LM**3 - 7040.D0/9.D0*x*dlx1*LR + 352.
     & D0/3.D0*x*dlx1*LR*LM + 3752.D0/27.D0*x*dlx1**2*LM - 160.D0/3.D0*
     & x*dlx1**2*LM**2
      c2qps_new = c2qps_new + 176.D0/3.D0*x*dlx1**2*LR - 1168.D0/27.D0*
     & x*dlx1**3*LM - 100256.D0/135.D0*x*dlx*LM + 128*x*dlx*LM**2 - 512.
     & D0/27.D0*x*dlx*LM**3 + 7744.D0/9.D0*x*dlx*LR - 352.D0/3.D0*x*dlx
     & *LR*LM**2 - 8768.D0/27.D0*x*dlx*dlx1*LM + 320.D0/3.D0*x*dlx*dlx1
     & *LM**2 - 352.D0/3.D0*x*dlx*dlx1*LR + 1232.D0/9.D0*x*dlx*dlx1**2*
     & LM - 74368.D0/81.D0*x*dlx**2*LM + 1280.D0/9.D0*x*dlx**2*LM**2 - 
     & 704.D0/27.D0*x*dlx**2*LM**3 - 440*x*dlx**2*LR + 704.D0/3.D0*x*
     & dlx**2*LR*LM - 1528.D0/9.D0*x*dlx**2*dlx1*LM - 19952.D0/81.D0*x*
     & dlx**3*LM + 512.D0/9.D0*x*dlx**3*LM**2 - 880.D0/9.D0*x*dlx**3*LR
     &  - 1216.D0/27.D0*x*dlx**4*LM + 37912.D0/243.D0*x*Pi**2*LM - 416.D
     & 0/27.D0*x*Pi**2*LM**2 + 544.D0/81.D0*x*Pi**2*LM**3 + 704.D0/9.D0
     & *x*Pi**2*LR - 352.D0/9.D0*x*Pi**2*LR*LM + 896.D0/27.D0*x*Pi**2*
     & dlx1*LM + 13544.D0/81.D0*x*Pi**2*dlx*LM - 1216.D0/27.D0*x*Pi**2*
     & dlx*LM**2 + 704.D0/9.D0*x*Pi**2*dlx*LR + 2584.D0/27.D0*x*Pi**2*
     & dlx**2*LM - 124.D0/405.D0*x*Pi**4*LM - 10432.D0/81.D0*x*rnf*LM
     &  + 736.D0/27.D0*x*rnf*LM**2
      c2qps_new = c2qps_new - 32.D0/27.D0*x*rnf*LM**3 - 6752.D0/81.D0*x
     & *rnf*LR + 1280.D0/27.D0*x*rnf*LR*LM - 32.D0/9.D0*x*rnf*LR*LM**2
     &  + 32.D0/9.D0*x*rnf*dlx1*LM + 1280.D0/27.D0*x*rnf*dlx1*LR - 64.D0
     & /9.D0*x*rnf*dlx1*LR*LM + 16.D0/9.D0*x*rnf*dlx1**2*LM - 32.D0/9.D0
     & *x*rnf*dlx1**2*LR + 5632.D0/81.D0*x*rnf*dlx*LM - 704.D0/27.D0*x*
     & rnf*dlx*LM**2 + 64.D0/27.D0*x*rnf*dlx*LM**3 - 1408.D0/27.D0*x*
     & rnf*dlx*LR + 64.D0/9.D0*x*rnf*dlx*LR*LM**2 + 64.D0/9.D0*x*rnf*
     & dlx*dlx1*LR + 1888.D0/27.D0*x*rnf*dlx**2*LM - 64.D0/9.D0*x*rnf*
     & dlx**2*LM**2 + 80.D0/3.D0*x*rnf*dlx**2*LR - 128.D0/9.D0*x*rnf*
     & dlx**2*LR*LM + 64.D0/9.D0*x*rnf*dlx**3*LM + 160.D0/27.D0*x*rnf*
     & dlx**3*LR - 736.D0/81.D0*x*rnf*Pi**2*LM - 128.D0/27.D0*x*rnf*
     & Pi**2*LR + 64.D0/27.D0*x*rnf*Pi**2*LR*LM - 128.D0/27.D0*x*rnf*
     & Pi**2*dlx*LR + 4832.D0/9.D0*x*Zeta3*LM + 64.D0/9.D0*x*Zeta3*
     & LM**2 + 704.D0/3.D0*x*Zeta3*LR + 2432.D0/3.D0*x*Zeta3*dlx*LM + 
     & 64.D0/9.D0*x*Zeta3*rnf*LM - 128.D0/9.D0*x*Zeta3*rnf*LR + 218032.D
     & 0/135.D0*x**2*LM
      c2qps_new = c2qps_new + 464.D0/3.D0*x**2*LM**2 + 704.D0/9.D0*x**2
     & *LM**3 - 39424.D0/81.D0*x**2*LR + 2816.D0/27.D0*x**2*LR*LM + 704.
     & D0/9.D0*x**2*LR*LM**2 + 50432.D0/81.D0*x**2*dlx1*LM + 18112.D0/
     & 81.D0*x**2*dlx1*LM**2 - 2176.D0/81.D0*x**2*dlx1*LM**3 + 2816.D0/
     & 27.D0*x**2*dlx1*LR + 1408.D0/9.D0*x**2*dlx1*LR*LM + 6608.D0/27.D0
     & *x**2*dlx1**2*LM - 640.D0/9.D0*x**2*dlx1**2*LM**2 + 704.D0/9.D0*
     & x**2*dlx1**2*LR - 4672.D0/81.D0*x**2*dlx1**3*LM - 291904.D0/405.D
     & 0*x**2*dlx*LM - 58432.D0/81.D0*x**2*dlx*LM**2 + 1024.D0/81.D0*
     & x**2*dlx*LM**3 + 11264.D0/27.D0*x**2*dlx*LR - 1408.D0/3.D0*x**2*
     & dlx*LR*LM - 12544.D0/27.D0*x**2*dlx*dlx1*LM + 1280.D0/9.D0*x**2*
     & dlx*dlx1*LM**2 - 1408.D0/9.D0*x**2*dlx*dlx1*LR + 4928.D0/27.D0*
     & x**2*dlx*dlx1**2*LM + 4192.D0/3.D0*x**2*dlx**2*LM - 1792.D0/27.D0
     & *x**2*dlx**2*LM**2 + 2816.D0/9.D0*x**2*dlx**2*LR - 5056.D0/27.D0
     & *x**2*dlx**2*dlx1*LM + 7168.D0/81.D0*x**2*dlx**3*LM - 2512.D0/9.D
     & 0*x**2*Pi**2*LM + 2944.D0/81.D0*x**2*Pi**2*LM**2 - 704.D0/9.D0*
     & x**2*Pi**2*LR
      c2qps_new = c2qps_new + 4672.D0/81.D0*x**2*Pi**2*dlx1*LM - 3520.D0
     & /27.D0*x**2*Pi**2*dlx*LM - 12416.D0/243.D0*x**2*rnf*LM + 320.D0/
     & 27.D0*x**2*rnf*LM**2 - 128.D0/81.D0*x**2*rnf*LM**3 + 7168.D0/243.
     & D0*x**2*rnf*LR - 512.D0/81.D0*x**2*rnf*LR*LM - 128.D0/27.D0*x**2
     & *rnf*LR*LM**2 + 1216.D0/81.D0*x**2*rnf*dlx1*LM - 512.D0/81.D0*
     & x**2*rnf*dlx1*LR - 256.D0/27.D0*x**2*rnf*dlx1*LR*LM + 64.D0/27.D0
     & *x**2*rnf*dlx1**2*LM - 128.D0/27.D0*x**2*rnf*dlx1**2*LR - 5056.D0
     & /81.D0*x**2*rnf*dlx*LM + 256.D0/27.D0*x**2*rnf*dlx*LM**2 - 2048.D
     & 0/81.D0*x**2*rnf*dlx*LR + 256.D0/9.D0*x**2*rnf*dlx*LR*LM + 256.D0
     & /27.D0*x**2*rnf*dlx*dlx1*LR - 128.D0/9.D0*x**2*rnf*dlx**2*LM - 
     & 512.D0/27.D0*x**2*rnf*dlx**2*LR - 64.D0/81.D0*x**2*rnf*Pi**2*LM
     &  + 128.D0/27.D0*x**2*rnf*Pi**2*LR - 8320.D0/9.D0*x**2*Zeta3*LM
     &  + 512.D0/45.D0*x**3*dlx**2*LM - 512.D0/135.D0*x**3*Pi**2*LM + 
     & 1024.D0/405.D0*Hr1(-1)*x**(-2)*dlx*LM + 7552.D0/9.D0*Hr1(-1)*
     & x**(-1)*dlx*LM + 256.D0/3.D0*Hr1(-1)*x**(-1)*dlx*LM**2 + 1408.D0/
     & 9.D0*Hr1(-1)*x**(-1)*dlx*LR
      c2qps_new = c2qps_new - 192*Hr1(-1)*x**(-1)*dlx**2*LM + 3200.D0/
     & 81.D0*Hr1(-1)*x**(-1)*Pi**2*LM - 256.D0/27.D0*Hr1(-1)*x**(-1)*
     & rnf*dlx*LM - 256.D0/27.D0*Hr1(-1)*x**(-1)*rnf*dlx*LR + 48128.D0/
     & 27.D0*Hr1(-1)*dlx*LM - 64*Hr1(-1)*dlx*LM**2 + 1408.D0/3.D0*Hr1(
     & -1)*dlx*LR + 1456.D0/9.D0*Hr1(-1)*dlx**2*LM - 848.D0/27.D0*Hr1(
     & -1)*Pi**2*LM - 256.D0/9.D0*Hr1(-1)*rnf*dlx*LM - 256.D0/9.D0*Hr1(
     & -1)*rnf*dlx*LR + 120512.D0/81.D0*Hr1(-1)*x*dlx*LM - 64*Hr1(-1)*x
     & *dlx*LM**2 + 1408.D0/3.D0*Hr1(-1)*x*dlx*LR + 1456.D0/9.D0*Hr1(-1
     & )*x*dlx**2*LM - 848.D0/27.D0*Hr1(-1)*x*Pi**2*LM - 256.D0/9.D0*
     & Hr1(-1)*x*rnf*dlx*LM - 256.D0/9.D0*Hr1(-1)*x*rnf*dlx*LR + 4672.D0
     & /9.D0*Hr1(-1)*x**2*dlx*LM + 256.D0/3.D0*Hr1(-1)*x**2*dlx*LM**2
     &  + 1408.D0/9.D0*Hr1(-1)*x**2*dlx*LR - 192*Hr1(-1)*x**2*dlx**2*LM
     &  + 3200.D0/81.D0*Hr1(-1)*x**2*Pi**2*LM - 256.D0/27.D0*Hr1(-1)*
     & x**2*rnf*dlx*LM - 256.D0/27.D0*Hr1(-1)*x**2*rnf*dlx*LR - 1024.D0/
     & 45.D0*Hr1(-1)*x**3*dlx*LM + 1024.D0/27.D0*Hr2(-1,-1)*x**(-1)*dlx
     & *LM
      c2qps_new = c2qps_new - 448.D0/3.D0*Hr2(-1,-1)*dlx*LM - 448.D0/3.D
     & 0*Hr2(-1,-1)*x*dlx*LM + 1024.D0/27.D0*Hr2(-1,-1)*x**2*dlx*LM - 
     & 1024.D0/405.D0*Hr2(0,-1)*x**(-2)*LM - 7552.D0/9.D0*Hr2(0,-1)*
     & x**(-1)*LM - 256.D0/3.D0*Hr2(0,-1)*x**(-1)*LM**2 - 1408.D0/9.D0*
     & Hr2(0,-1)*x**(-1)*LR + 1408.D0/3.D0*Hr2(0,-1)*x**(-1)*dlx*LM + 
     & 256.D0/27.D0*Hr2(0,-1)*x**(-1)*rnf*LM + 256.D0/27.D0*Hr2(0,-1)*
     & x**(-1)*rnf*LR - 48128.D0/27.D0*Hr2(0,-1)*LM + 64*Hr2(0,-1)*
     & LM**2 - 1408.D0/3.D0*Hr2(0,-1)*LR - 4096.D0/9.D0*Hr2(0,-1)*dlx*
     & LM - 128*Hr2(0,-1)*dlx*LM**2 + 2528.D0/9.D0*Hr2(0,-1)*dlx**2*LM
     &  - 1376.D0/27.D0*Hr2(0,-1)*Pi**2*LM + 256.D0/9.D0*Hr2(0,-1)*rnf*
     & LM + 256.D0/9.D0*Hr2(0,-1)*rnf*LR - 120512.D0/81.D0*Hr2(0,-1)*x*
     & LM + 64*Hr2(0,-1)*x*LM**2 - 1408.D0/3.D0*Hr2(0,-1)*x*LR - 5312.D0
     & /27.D0*Hr2(0,-1)*x*dlx*LM + 128*Hr2(0,-1)*x*dlx*LM**2 - 2528.D0/
     & 9.D0*Hr2(0,-1)*x*dlx**2*LM + 1376.D0/27.D0*Hr2(0,-1)*x*Pi**2*LM
     &  + 256.D0/9.D0*Hr2(0,-1)*x*rnf*LM + 256.D0/9.D0*Hr2(0,-1)*x*rnf*
     & LR
      c2qps_new = c2qps_new - 4672.D0/9.D0*Hr2(0,-1)*x**2*LM - 256.D0/3.
     & D0*Hr2(0,-1)*x**2*LM**2 - 1408.D0/9.D0*Hr2(0,-1)*x**2*LR - 2176.D
     & 0/27.D0*Hr2(0,-1)*x**2*dlx*LM + 256.D0/27.D0*Hr2(0,-1)*x**2*rnf*
     & LM + 256.D0/27.D0*Hr2(0,-1)*x**2*rnf*LR + 1024.D0/45.D0*Hr2(0,-1
     & )*x**3*LM + 13888.D0/27.D0*Hr2(0,1)*x**(-1)*LM - 512.D0/9.D0*
     & Hr2(0,1)*x**(-1)*LM**2 + 1408.D0/9.D0*Hr2(0,1)*x**(-1)*LR + 5504.
     & D0/27.D0*Hr2(0,1)*x**(-1)*dlx*LM - 256.D0/27.D0*Hr2(0,1)*x**(-1)
     & *rnf*LR + 28016.D0/27.D0*Hr2(0,1)*LM + 32.D0/3.D0*Hr2(0,1)*LM**2
     &  - 1088.D0/27.D0*Hr2(0,1)*LM**3 + 352.D0/3.D0*Hr2(0,1)*LR + 704.D
     & 0/3.D0*Hr2(0,1)*LR*LM + 688.D0/9.D0*Hr2(0,1)*dlx*LM + 640.D0/3.D0
     & *Hr2(0,1)*dlx*LM**2 - 704.D0/3.D0*Hr2(0,1)*dlx*LR - 2704.D0/9.D0
     & *Hr2(0,1)*dlx**2*LM + 2240.D0/27.D0*Hr2(0,1)*Pi**2*LM + 512.D0/
     & 27.D0*Hr2(0,1)*rnf*LM - 64.D0/9.D0*Hr2(0,1)*rnf*LR - 128.D0/9.D0
     & *Hr2(0,1)*rnf*LR*LM + 128.D0/9.D0*Hr2(0,1)*rnf*dlx*LR + 6128.D0/
     & 27.D0*Hr2(0,1)*x*LM + 1216.D0/9.D0*Hr2(0,1)*x*LM**2 - 1088.D0/27.
     & D0*Hr2(0,1)*x*LM**3
      c2qps_new = c2qps_new - 352.D0/3.D0*Hr2(0,1)*x*LR + 704.D0/3.D0*
     & Hr2(0,1)*x*LR*LM - 3952.D0/9.D0*Hr2(0,1)*x*dlx*LM + 640.D0/3.D0*
     & Hr2(0,1)*x*dlx*LM**2 - 704.D0/3.D0*Hr2(0,1)*x*dlx*LR - 2704.D0/9.
     & D0*Hr2(0,1)*x*dlx**2*LM + 2240.D0/27.D0*Hr2(0,1)*x*Pi**2*LM + 
     & 704.D0/27.D0*Hr2(0,1)*x*rnf*LM + 64.D0/9.D0*Hr2(0,1)*x*rnf*LR - 
     & 128.D0/9.D0*Hr2(0,1)*x*rnf*LR*LM + 128.D0/9.D0*Hr2(0,1)*x*rnf*
     & dlx*LR + 32672.D0/27.D0*Hr2(0,1)*x**2*LM - 2048.D0/27.D0*Hr2(0,1
     & )*x**2*LM**2 + 2816.D0/9.D0*Hr2(0,1)*x**2*LR + 8192.D0/27.D0*
     & Hr2(0,1)*x**2*dlx*LM + 128.D0/27.D0*Hr2(0,1)*x**2*rnf*LM - 512.D0
     & /27.D0*Hr2(0,1)*x**2*rnf*LR - 1024.D0/27.D0*Hr3(-1,0,-1)*x**(-1)
     & *LM + 448.D0/3.D0*Hr3(-1,0,-1)*LM + 448.D0/3.D0*Hr3(-1,0,-1)*x*
     & LM - 1024.D0/27.D0*Hr3(-1,0,-1)*x**2*LM - 5888.D0/27.D0*Hr3(-1,0
     & ,1)*x**(-1)*LM + 1024.D0/9.D0*Hr3(-1,0,1)*LM + 1024.D0/9.D0*Hr3(
     & -1,0,1)*x*LM - 5888.D0/27.D0*Hr3(-1,0,1)*x**2*LM - 1024.D0/27.D0
     & *Hr3(0,-1,-1)*x**(-1)*LM + 448.D0/3.D0*Hr3(0,-1,-1)*LM - 896.D0/
     & 9.D0*Hr3(0,-1,-1)*dlx*LM
      c2qps_new = c2qps_new + 448.D0/3.D0*Hr3(0,-1,-1)*x*LM + 896.D0/9.D
     & 0*Hr3(0,-1,-1)*x*dlx*LM - 1024.D0/27.D0*Hr3(0,-1,-1)*x**2*LM - 
     & 1664.D0/3.D0*Hr3(0,0,-1)*x**(-1)*LM + 1760.D0/3.D0*Hr3(0,0,-1)*
     & LM + 256*Hr3(0,0,-1)*LM**2 - 448*Hr3(0,0,-1)*dlx*LM + 1888.D0/27.
     & D0*Hr3(0,0,-1)*x*LM - 256*Hr3(0,0,-1)*x*LM**2 + 8384.D0/9.D0*
     & Hr3(0,0,-1)*x*dlx*LM + 14720.D0/27.D0*Hr3(0,0,-1)*x**2*LM - 896.D
     & 0/27.D0*Hr3(0,0,1)*x**(-1)*LM - 1760.D0/9.D0*Hr3(0,0,1)*LM - 
     & 1984.D0/9.D0*Hr3(0,0,1)*LM**2 + 4928.D0/9.D0*Hr3(0,0,1)*dlx*LM
     &  - 3040.D0/9.D0*Hr3(0,0,1)*x*LM - 256.D0/9.D0*Hr3(0,0,1)*x*LM**2
     &  + 1472.D0/9.D0*Hr3(0,0,1)*x*dlx*LM - 1792.D0/9.D0*Hr3(0,0,1)*
     & x**2*LM + 4096.D0/27.D0*Hr3(0,1,1)*x**(-1)*LM - 64.D0/9.D0*Hr3(0
     & ,1,1)*LM + 640.D0/3.D0*Hr3(0,1,1)*LM**2 - 704.D0/3.D0*Hr3(0,1,1)
     & *LR - 4928.D0/9.D0*Hr3(0,1,1)*dlx*LM - 64.D0/9.D0*Hr3(0,1,1)*rnf
     & *LM + 128.D0/9.D0*Hr3(0,1,1)*rnf*LR - 3488.D0/9.D0*Hr3(0,1,1)*x*
     & LM + 640.D0/3.D0*Hr3(0,1,1)*x*LM**2 - 704.D0/3.D0*Hr3(0,1,1)*x*
     & LR
      c2qps_new = c2qps_new - 4928.D0/9.D0*Hr3(0,1,1)*x*dlx*LM - 64.D0/
     & 9.D0*Hr3(0,1,1)*x*rnf*LM + 128.D0/9.D0*Hr3(0,1,1)*x*rnf*LR + 
     & 7936.D0/27.D0*Hr3(0,1,1)*x**2*LM + 896.D0/9.D0*Hr4(0,-1,0,-1)*LM
     &  - 896.D0/9.D0*Hr4(0,-1,0,-1)*x*LM + 256*Hr4(0,-1,0,1)*LM - 256*
     & Hr4(0,-1,0,1)*x*LM + 1792.D0/9.D0*Hr4(0,0,-1,-1)*LM - 1792.D0/9.D
     & 0*Hr4(0,0,-1,-1)*x*LM - 1024.D0/3.D0*Hr4(0,0,0,-1)*LM - 3328.D0/
     & 3.D0*Hr4(0,0,0,-1)*x*LM - 2560.D0/9.D0*Hr4(0,0,0,1)*LM - 256.D0/
     & 9.D0*Hr4(0,0,0,1)*x*LM + 3392.D0/9.D0*Hr4(0,0,1,1)*LM - 64.D0/9.D
     & 0*Hr4(0,0,1,1)*x*LM - 4672.D0/9.D0*Hr4(0,1,1,1)*LM - 4672.D0/9.D0
     & *Hr4(0,1,1,1)*x*LM 
             c2qps_new = c2qps_new + c2qps_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             c2qps_new =  0 
         elseif (iorder.eq.1) then 
             c2qps_new =  0 
         elseif (iorder.eq.2) then 
             c2qps_new =  0 
         elseif (iorder.eq.3) then 
             c2qps_new =  0 
             c2qps_new = c2qps_new + c2qps_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      endif      
      return     
      end function c2qps_new  
