!>***************************************************
!> Exact DIS coefficient funtion c3q_new in x space
!> including scale dependence
!>
      function c3q_new(iorder,x,ireg,rmu2,fmu2,q2)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      implicit none
      integer iorder,ireg
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
      common /Hrs/ Hr1,Hr2,Hr3,Hr4,Hr5
!$omp threadprivate(/Hrs/)
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR
      real*8 c3q_new,x


      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
            c3q_new =  + 1 
         elseif (iorder.eq.1) then 
            c3q_new =  + LM * ( 4 + 16.D0/3.D0*dd0 )
            c3q_new = c3q_new - 12 + 16.D0/3.D0*dd1 - 4*dd0 - 8.D0/9.D0*Pi**2 ! Delta part of (4.2) arxiv:0504242.
            !> CF multiplied out along with zeta(2)
         elseif (iorder.eq.2) then
            print *, "iorder 2 not implemented for c3q"
         elseif (iorder.eq.3) then 
            print *, "iorder 3 not implemented for c3q"
         endif 
      elseif (ireg.eq.1) then ! regular component
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             c3q_new =  0 
         elseif (iorder.eq.1) then 
             c3q_new =  + LM * (  - 8.D0/3.D0 + 16.D0/3.D0*dd0 - 8.D0/3.
     &    D0*x )
             c3q_new = c3q_new + 8 - 8.D0/3.D0*dlx1 + 8.D0/3.D0*dlx + 16.D0/3.D
     &    0*dd1 - 4*dd0 - 16.D0/3.D0*dd0*dlx + 16.D0/3.D0*x - 8.D0/3.D0
     &            *x*dlx1 + 8.D0/3.D0*x*dlx
             c3q_new = c3q_new -8.D0/3.D0*(1+x) ! CONVERSION FROM c2q to c3q.
         !> Need to check scale dependence of this bit
         elseif (iorder.eq.2) then 
            print *, "iorder 2 not implemented for c3q"
         elseif (iorder.eq.3) then 
            print *, "iorder 3 not implemented for c3q"
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             c3q_new =  0 
         elseif (iorder.eq.1) then 
             c3q_new =  + LM * ( 16.D0/3.D0*dd0 ) ! + distribution component @ x=1 
      c3q_new = c3q_new + 16.D0/3.D0*dd1 - 4*dd0 
      elseif (iorder.eq.2) then
         print *, "iorder 2 not implemented for c3q"
      elseif (iorder.eq.3) then 
         print *, "iorder 3 not implemented for c3q"
         endif 
      endif      
      return     
      end function c3q_new  
