!>***************************************************
!> Exact DIS coefficient funtion c3q_diff in x space
!> not including scale dependence (yet!)
!> Function taken from results of hep-ph/0708.3731
      function c3q_diff(iorder,x,ireg,rmu2,fmu2,q2)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      implicit none
      integer iorder,ireg
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
      common /Hrs/ Hr1,Hr2,Hr3,Hr4,Hr5
!$omp threadprivate(/Hrs/)
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR,DX,DP,CAM2CF,CA,CF
      real*8 c3q_diff,x
      
      CF = 4./3.D0
      CA = 3.D0
      CAM2CF = CA - 2.* CF

      DX = 1.D0/X
      DP = 1.D0/(1.D0+X)

      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             c3q_diff = 0.D0
         elseif (iorder.eq.1) then 
             c3q_diff = 0.D0 
         elseif (iorder.eq.2) then 
             c3q_diff = 0.D0
         elseif (iorder.eq.3) then 
             c3q_diff = 0.D0
         endif 
      elseif (ireg.eq.1) then ! regular component
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             c3q_diff = 0 
         elseif (iorder.eq.1) then 
             c3q_diff = 0 
          elseif (iorder.eq.2) then
             c3q_diff =
     &  + cf*cam2cf * (  - 30.D0 + 30.D0*x + 36.D0*Zeta3 - 20.D0*Zeta3*x -
     &    56.D0*Zeta3*dp - 12.D0*Zeta2 - 4.D0*Zeta2*x - 8.D0*Zeta2*x**2 - 40.D0*
     &    Hr1(-1)*Zeta2 + 24.D0*Hr1(-1)*Zeta2*x + 64.D0*Hr1(-1)*Zeta2*dp - 14.D0
     &    *Hr1(0) - 30.D0*Hr1(0)*x + 16.D0*Hr1(0)*dp + 8.D0*Hr1(0)*Zeta2
     &     - 8.D0*Hr1(0)*Zeta2*x - 16.D0*Hr1(0)*Zeta2*dp + 16.D0*Hr1(1) - 16.D
     &    0*Hr1(1)*x - 8.D0*Hr2(-1,0)*x**2 - 8.D0*Hr2(-1,0)*dx + 16.D0*
     &    Hr2(0,0) + 8.D0*Hr2(0,0)*x + 8.D0*Hr2(0,0)*x**2 + 8.D0*Hr2(0,
     &    1) + 8.D0*Hr2(0,1)*x - 48.D0*Hr3(-1,-1,0) + 16.D0*Hr3(-1,-1,0
     &    )*x + 64.D0*Hr3(-1,-1,0)*dp + 48.D0*Hr3(-1,0,0) - 32.D0*Hr3(
     &    -1,0,0)*x - 80.D0*Hr3(-1,0,0)*dp + 16.D0*Hr3(-1,0,1) - 16.D0*
     &    Hr3(-1,0,1)*x - 32.D0*Hr3(-1,0,1)*dp + 32.D0*Hr3(0,-1,0) - 16.
     &    D0*Hr3(0,-1,0)*x - 48.D0*Hr3(0,-1,0)*dp - 12.D0*Hr3(0,0,0) +
     &    12.D0*Hr3(0,0,0)*x + 24.D0*Hr3(0,0,0)*dp - 8.D0*Hr3(0,0,1) +
     &    8.D0*Hr3(0,0,1)*x + 16.D0*Hr3(0,0,1)*dp )
      elseif (iorder.eq.3) then
         print *, "c3q_diff not implemented at n3lo. exiting"
         stop
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             c3q_diff = 0 
         elseif (iorder.eq.1) then 
             c3q_diff = 0 
         elseif (iorder.eq.2) then 
             c3q_diff = 0 
         elseif (iorder.eq.3) then 
             c3q_diff = 0 
         endif 
      endif      
      return     
      end function c3q_diff  
