!>***************************************************
!> Exact DIS coefficient funtion c3q_valence in x space
!> including scale dependence (new version)
!>
      function c3q_valence(iorder,x,ireg,rmu2,fmu2,q2,flavchange)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      implicit none
      integer iorder,ireg,flavchange
      common/Hrs/Hr1,Hr2,Hr3,Hr4,Hr5
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
!$omp threadprivate(/Hrs/)
      logical qexact
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR
      real*8 c3q_valence,x


      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             c3q_valence =  + 1 
         elseif (iorder.eq.1) then 
             c3q_valence =  + LM * ( 4 + 16.D0/3.D0*dd0 )
      c3q_valence = c3q_valence - 12 + 16.D0/3.D0*dd1 - 4*dd0 - 8.D0/9.D0*
     &    Pi**2 
         elseif (iorder.eq.2) then 
             c3q_valence =  + LM * ( 98 + 128.D0/3.D0*dd2 - 80*dd1 + 748.D
     &    0/9.D0*dd0 + 16*Pi**2 - 400.D0/27.D0*Pi**2*dd0 + 208.D0/9.D0*
     &    Zeta3 )
      c3q_valence = c3q_valence + LM**2 * (  - 14 + 256.D0/9.D0*dd1 - 8*dd0
     &     - 64.D0/27.D0*Pi**2 )
      c3q_valence = c3q_valence + LR * ( 132 - 176.D0/3.D0*dd1 + 44*dd0 + 
     &    88.D0/9.D0*Pi**2 )
      c3q_valence = c3q_valence + LR*LM * (  - 44 - 176.D0/3.D0*dd0 )
      c3q_valence = c3q_valence + rnf * ( 457.D0/27.D0 + 16.D0/9.D0*dd2 - 
     &    232.D0/27.D0*dd1 + 988.D0/81.D0*dd0 + 76.D0/27.D0*Pi**2 - 16.D
     &    0/27.D0*Pi**2*dd0 + 16.D0/9.D0*Zeta3 )
      c3q_valence = c3q_valence + rnf*LM * (  - 76.D0/9.D0 + 32.D0/9.D0*dd1
     &     - 232.D0/27.D0*dd0 - 32.D0/27.D0*Pi**2 )
      c3q_valence = c3q_valence + rnf*LM**2 * ( 4.D0/3.D0 + 16.D0/9.D0*dd0
     &     )
      c3q_valence = c3q_valence + rnf*LR * (  - 8 + 32.D0/9.D0*dd1 - 8.D0/3.
     &    D0*dd0 - 16.D0/27.D0*Pi**2 )
      c3q_valence = c3q_valence + rnf*LR*LM * ( 8.D0/3.D0 + 32.D0/9.D0*dd0
     &     )
      c3q_valence = c3q_valence - 4141.D0/18.D0 + 128.D0/9.D0*dd3 - 184.D0/
     &    3.D0*dd2 + 1036.D0/9.D0*dd1 - 5086.D0/27.D0*dd0 - 106.D0/3.D0
     &    *Pi**2 - 400.D0/27.D0*Pi**2*dd1 + 184.D0/9.D0*Pi**2*dd0 + 253.
     &    D0/135.D0*Pi**4 + 48*Zeta3 + 1312.D0/9.D0*Zeta3*dd0 
         elseif (iorder.eq.3) then 
             c3q_valence = 131770.D0/27.D0*LM - 1058*LM**2 + 84*LM**3 + 
     & 56567.D0/9.D0*LR - 2564*LR*LM + 308*LR*LM**2 - 1452*LR**2 + 484*
     & LR**2*LM + 2560.D0/27.D0*dd4*LM - 18688.D0/27.D0*dd3*LM + 4096.D0
     & /27.D0*dd3*LM**2 - 2816.D0/9.D0*dd3*LR + 26800.D0/9.D0*dd2*LM - 
     & 704*dd2*LM**2 + 2048.D0/27.D0*dd2*LM**3 + 4048.D0/3.D0*dd2*LR - 
     & 2816.D0/3.D0*dd2*LR*LM - 445784.D0/81.D0*dd1*LM + 48560.D0/27.D0
     & *dd1*LM**2 - 1792.D0/9.D0*dd1*LM**3 - 27688.D0/9.D0*dd1*LR + 
     & 1760*dd1*LR*LM - 5632.D0/9.D0*dd1*LR*LM**2 + 1936.D0/3.D0*dd1*
     & LR**2 + 82252.D0/27.D0*dd0*LM - 4348.D0/9.D0*dd0*LM**2 + 208.D0/
     & 9.D0*dd0*LM**3 + 122908.D0/27.D0*dd0*LR - 21352.D0/9.D0*dd0*LR*
     & LM + 176*dd0*LR*LM**2 - 484*dd0*LR**2 + 1936.D0/3.D0*dd0*LR**2*
     & LM + 268532.D0/243.D0*Pi**2*LM - 17936.D0/81.D0*Pi**2*LM**2 + 
     & 448.D0/27.D0*Pi**2*LM**3 + 868*Pi**2*LR - 352*Pi**2*LR*LM + 1408.
     & D0/27.D0*Pi**2*LR*LM**2 - 968.D0/9.D0*Pi**2*LR**2 - 1792.D0/9.D0
     & *Pi**2*dd2*LM + 18080.D0/27.D0*Pi**2*dd1*LM - 11776.D0/81.D0*
     & Pi**2*dd1*LM**2
      c3q_valence = c3q_valence + 8800.D0/27.D0*Pi**2*dd1*LR - 28880.D0/27.D
     & 0*Pi**2*dd0*LM + 5872.D0/27.D0*Pi**2*dd0*LM**2 - 1024.D0/81.D0*
     & Pi**2*dd0*LM**3 - 4048.D0/9.D0*Pi**2*dd0*LR + 8800.D0/27.D0*
     & Pi**2*dd0*LR*LM - 2716.D0/45.D0*Pi**4*LM + 7808.D0/1215.D0*Pi**4
     & *LM**2 - 5566.D0/135.D0*Pi**4*LR + 47776.D0/1215.D0*Pi**4*dd0*LM
     &  - 19412.D0/27.D0*rnf*LM + 1492.D0/9.D0*rnf*LM**2 - 128.D0/9.D0*
     & rnf*LM**3 - 7480.D0/9.D0*rnf*LR + 3304.D0/9.D0*rnf*LR*LM - 48*
     & rnf*LR*LM**2 + 176*rnf*LR**2 - 176.D0/3.D0*rnf*LR**2*LM + 2560.D0
     & /81.D0*rnf*dd3*LM + 512.D0/27.D0*rnf*dd3*LR - 6208.D0/27.D0*rnf*
     & dd2*LM + 128.D0/3.D0*rnf*dd2*LM**2 - 1088.D0/9.D0*rnf*dd2*LR + 
     & 512.D0/9.D0*rnf*dd2*LR*LM + 133856.D0/243.D0*rnf*dd1*LM - 13184.D
     & 0/81.D0*rnf*dd1*LM**2 + 512.D0/27.D0*rnf*dd1*LM**3 + 11072.D0/27.
     & D0*rnf*dd1*LR - 1664.D0/9.D0*rnf*dd1*LR*LM + 1024.D0/27.D0*rnf*
     & dd1*LR*LM**2 - 704.D0/9.D0*rnf*dd1*LR**2 - 14776.D0/27.D0*rnf*
     & dd0*LM + 3536.D0/27.D0*rnf*dd0*LM**2 - 320.D0/27.D0*rnf*dd0*
     & LM**3
      c3q_valence = c3q_valence - 46184.D0/81.D0*rnf*dd0*LR + 9920.D0/27.D0
     & *rnf*dd0*LR*LM - 448.D0/9.D0*rnf*dd0*LR*LM**2 + 176.D0/3.D0*rnf*
     & dd0*LR**2 - 704.D0/9.D0*rnf*dd0*LR**2*LM - 107408.D0/729.D0*rnf*
     & Pi**2*LM + 6464.D0/243.D0*rnf*Pi**2*LM**2 - 128.D0/81.D0*rnf*
     & Pi**2*LM**3 - 3248.D0/27.D0*rnf*Pi**2*LR + 1280.D0/27.D0*rnf*
     & Pi**2*LR*LM - 256.D0/81.D0*rnf*Pi**2*LR*LM**2 + 352.D0/27.D0*rnf
     & *Pi**2*LR**2 - 2624.D0/81.D0*rnf*Pi**2*dd1*LM - 1600.D0/81.D0*
     & rnf*Pi**2*dd1*LR + 256.D0/3.D0*rnf*Pi**2*dd0*LM - 1312.D0/81.D0*
     & rnf*Pi**2*dd0*LM**2 + 1088.D0/27.D0*rnf*Pi**2*dd0*LR - 1600.D0/
     & 81.D0*rnf*Pi**2*dd0*LR*LM + 5096.D0/1215.D0*rnf*Pi**4*LM + 1012.D
     & 0/405.D0*rnf*Pi**4*LR + 1624.D0/81.D0*rnf**2*LM - 152.D0/27.D0*
     & rnf**2*LM**2 + 16.D0/27.D0*rnf**2*LM**3 + 1828.D0/81.D0*rnf**2*
     & LR - 304.D0/27.D0*rnf**2*LR*LM + 16.D0/9.D0*rnf**2*LR*LM**2 - 16.
     & D0/3.D0*rnf**2*LR**2 + 16.D0/9.D0*rnf**2*LR**2*LM + 64.D0/27.D0*
     & rnf**2*dd2*LM + 64.D0/27.D0*rnf**2*dd2*LR - 928.D0/81.D0*rnf**2*
     & dd1*LM
      c3q_valence = c3q_valence + 64.D0/27.D0*rnf**2*dd1*LM**2 - 928.D0/81.D
     & 0*rnf**2*dd1*LR + 128.D0/27.D0*rnf**2*dd1*LR*LM + 64.D0/27.D0*
     & rnf**2*dd1*LR**2 + 3760.D0/243.D0*rnf**2*dd0*LM - 464.D0/81.D0*
     & rnf**2*dd0*LM**2 + 64.D0/81.D0*rnf**2*dd0*LM**3 + 3952.D0/243.D0
     & *rnf**2*dd0*LR - 928.D0/81.D0*rnf**2*dd0*LR*LM + 64.D0/27.D0*
     & rnf**2*dd0*LR*LM**2 - 16.D0/9.D0*rnf**2*dd0*LR**2 + 64.D0/27.D0*
     & rnf**2*dd0*LR**2*LM + 1072.D0/243.D0*rnf**2*Pi**2*LM - 64.D0/81.D
     & 0*rnf**2*Pi**2*LM**2 + 304.D0/81.D0*rnf**2*Pi**2*LR - 128.D0/81.D
     & 0*rnf**2*Pi**2*LR*LM - 32.D0/81.D0*rnf**2*Pi**2*LR**2 - 64.D0/81.
     & D0*rnf**2*Pi**2*dd0*LM - 64.D0/81.D0*rnf**2*Pi**2*dd0*LR + 9056.D
     & 0/9.D0*Zeta5*LM + 1120.D0/27.D0*Zeta3*LM - 432*Zeta3*LM**2 + 
     & 4096.D0/81.D0*Zeta3*LM**3 - 1056*Zeta3*LR - 4576.D0/9.D0*Zeta3*
     & LR*LM + 53504.D0/27.D0*Zeta3*dd1*LM - 23840.D0/9.D0*Zeta3*dd0*LM
     &  + 7424.D0/27.D0*Zeta3*dd0*LM**2 - 28864.D0/9.D0*Zeta3*dd0*LR - 
     & 18688.D0/81.D0*Zeta3*Pi**2*LM - 3008.D0/81.D0*Zeta3*rnf*LM + 224.
     & D0/9.D0*Zeta3*rnf*LM**2
      c3q_valence = c3q_valence + 224.D0/9.D0*Zeta3*rnf*LR + 832.D0/27.D0*
     & Zeta3*rnf*LR*LM + 3520.D0/27.D0*Zeta3*rnf*dd0*LM + 5248.D0/27.D0
     & *Zeta3*rnf*dd0*LR + 64.D0/27.D0*Zeta3*rnf**2*LR 
             c3q_valence = c3q_valence + c3q_valence_av(iorder,x,ireg,.false.) 
         endif 
      elseif (ireg.eq.1) then      
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             c3q_valence =  0 
         elseif (iorder.eq.1) then 
             c3q_valence =  + LM * (  - 8.D0/3.D0 + 16.D0/3.D0*dd0 - 8.D0/
     &    3.D0*x )
      c3q_valence = c3q_valence + 16.D0/3.D0 - 8.D0/3.D0*dlx1 + 8.D0/3.D0*
     &    dlx + 16.D0/3.D0*dd1 - 4*dd0 - 16.D0/3.D0*dd0*dlx + 8.D0/3.D0
     &    *x - 8.D0/3.D0*x*dlx1 + 8.D0/3.D0*x*dlx 
      elseif (iorder.eq.2) then
             c3q_valence =  + LM * ( 184.D0/9.D0 + 392.D0/9.D0*dlx1 - 64.D
     &    0/3.D0*dlx1**2 - 48*dlx + 128.D0/3.D0*dlx*dlx1 - 176.D0/9.D0*
     &    dlx**2 + 128.D0/3.D0*dd2 - 80*dd1 - 256.D0/3.D0*dd1*dlx + 748.
     &    D0/9.D0*dd0 + 96*dd0*dlx + 272.D0/9.D0*dd0*dlx**2 + 224.D0/27.
     &    D0*Pi**2 - 400.D0/27.D0*Pi**2*dd0 - 1184.D0/9.D0*x + 520.D0/9.
     &    D0*x*dlx1 - 64.D0/3.D0*x*dlx1**2 - 688.D0/9.D0*x*dlx + 128.D0/
     &    3.D0*x*dlx*dlx1 - 64.D0/3.D0*x*dlx**2 + 80.D0/9.D0*x*Pi**2 - 
     &    32.D0/9.D0*Hr1(-1)*dlx + 32.D0/9.D0*Hr1(-1)*x*dlx + 32.D0/9.D0
     &    *Hr2(0,-1) - 32.D0/9.D0*Hr2(0,-1)*x - 64.D0/9.D0*Hr2(0,1) - 
     &    64.D0/9.D0*Hr2(0,1)*x - 16.D0/9.D0/(1 + x)*dlx**2 + 16.D0/27.D
     &    0/(1 + x)*Pi**2 + 64.D0/9.D0/(1 + x)*Hr1(-1)*dlx - 64.D0/9.D0
     &    /(1 + x)*Hr2(0,-1) )
      c3q_valence = c3q_valence + LM**2 * (  - 28.D0/9.D0 - 128.D0/9.D0*
     &    dlx1 + 32.D0/3.D0*dlx + 256.D0/9.D0*dd1 - 8*dd0 - 128.D0/9.D0
     &    *dd0*dlx + 100.D0/9.D0*x - 128.D0/9.D0*x*dlx1 + 32.D0/3.D0*x*
     &    dlx )
      c3q_valence = c3q_valence + LR * (  - 176.D0/3.D0 + 88.D0/3.D0*dlx1
     &     - 88.D0/3.D0*dlx - 176.D0/3.D0*dd1 + 44*dd0 + 176.D0/3.D0*
     &    dd0*dlx - 88.D0/3.D0*x + 88.D0/3.D0*x*dlx1 - 88.D0/3.D0*x*dlx
     &     )
      c3q_valence = c3q_valence + LR*LM * ( 88.D0/3.D0 - 176.D0/3.D0*dd0 + 
     &    88.D0/3.D0*x )
      c3q_valence = c3q_valence + rnf * (  - 464.D0/81.D0 + 80.D0/27.D0*
     &    dlx1 - 8.D0/9.D0*dlx1**2 - 8*dlx + 16.D0/9.D0*dlx*dlx1 - 20.D0
     &    /9.D0*dlx**2 + 16.D0/9.D0*dd2 - 232.D0/27.D0*dd1 - 32.D0/9.D0
     &    *dd1*dlx + 988.D0/81.D0*dd0 + 152.D0/9.D0*dd0*dlx + 40.D0/9.D0
     &    *dd0*dlx**2 + 16.D0/27.D0*Pi**2 - 32.D0/27.D0*Pi**2*dd0 - 
     &    1208.D0/81.D0*x + 224.D0/27.D0*x*dlx1 - 8.D0/9.D0*x*dlx1**2
     &     - 40.D0/3.D0*x*dlx + 16.D0/9.D0*x*dlx*dlx1 - 20.D0/9.D0*x*
     &    dlx**2 + 16.D0/27.D0*x*Pi**2 - 16.D0/9.D0*Hr2(0,1) + 32.D0/9.D
     &    0*Hr2(0,1)*dd0 - 16.D0/9.D0*Hr2(0,1)*x )
      c3q_valence = c3q_valence + rnf*LM * ( 80.D0/27.D0 - 16.D0/9.D0*dlx1
     &     + 32.D0/9.D0*dlx + 32.D0/9.D0*dd1 - 232.D0/27.D0*dd0 - 64.D0/
     &    9.D0*dd0*dlx + 224.D0/27.D0*x - 16.D0/9.D0*x*dlx1 + 32.D0/9.D0
     &    *x*dlx )
      c3q_valence = c3q_valence + rnf*LM**2 * (  - 8.D0/9.D0 + 16.D0/9.D0*
     &    dd0 - 8.D0/9.D0*x )
      c3q_valence = c3q_valence + rnf*LR * ( 32.D0/9.D0 - 16.D0/9.D0*dlx1
     &     + 16.D0/9.D0*dlx + 32.D0/9.D0*dd1 - 8.D0/3.D0*dd0 - 32.D0/9.D
     &    0*dd0*dlx + 16.D0/9.D0*x - 16.D0/9.D0*x*dlx1 + 16.D0/9.D0*x*
     &    dlx )
      c3q_valence = c3q_valence + rnf*LR*LM * (  - 16.D0/9.D0 + 32.D0/9.D0*
     &    dd0 - 16.D0/9.D0*x )
      c3q_valence = c3q_valence + 1112.D0/27.D0 - 344.D0/9.D0*dlx1 + 292.D0/
     &    9.D0*dlx1**2 - 64.D0/9.D0*dlx1**3 + 764.D0/9.D0*dlx - 72*dlx*
     &    dlx1 + 184.D0/9.D0*dlx*dlx1**2 + 142.D0/3.D0*dlx**2 - 248.D0/
     &    9.D0*dlx**2*dlx1 + 88.D0/9.D0*dlx**3 + 128.D0/9.D0*dd3 - 184.D
     &    0/3.D0*dd2 - 368.D0/9.D0*dd2*dlx + 1036.D0/9.D0*dd1 + 368.D0/
     &    3.D0*dd1*dlx + 160.D0/3.D0*dd1*dlx**2 - 5086.D0/27.D0*dd0 - 
     &    1892.D0/9.D0*dd0*dlx - 236.D0/3.D0*dd0*dlx**2 - 344.D0/27.D0*
     &    dd0*dlx**3 - 400.D0/27.D0*Pi**2 + 32.D0/3.D0*Pi**2*dlx1 - 112.
     &    D0/9.D0*Pi**2*dlx - 560.D0/27.D0*Pi**2*dd1 + 80.D0/3.D0*Pi**2
     &    *dd0 + 176.D0/9.D0*Pi**2*dd0*dlx - 736.D0/9.D0*Zeta3 + 1168.D0
     &    /9.D0*Zeta3*dd0 + 6620.D0/27.D0*x - 1192.D0/9.D0*x*dlx1 + 356.
     &    D0/9.D0*x*dlx1**2 - 64.D0/9.D0*x*dlx1**3 + 1924.D0/9.D0*x*dlx
     &     - 72*x*dlx*dlx1 + 184.D0/9.D0*x*dlx*dlx1**2 + 530.D0/9.D0*x*
     &    dlx**2 - 232.D0/9.D0*x*dlx**2*dlx1 + 80.D0/9.D0*x*dlx**3 - 
     &    536.D0/27.D0*x*Pi**2 + 272.D0/27.D0*x*Pi**2*dlx1 - 320.D0/27.D
     &    0*x*Pi**2*dlx
      c3q_valence = c3q_valence - 592.D0/9.D0*x*Zeta3 - 16.D0/9.D0*x**2*
     &    dlx**2 + 16.D0/27.D0*x**2*Pi**2 + 32.D0/9.D0*Hr1(-1)*x**(-1)*
     &    dlx + 16.D0/9.D0*Hr1(-1)*dlx - 16.D0/3.D0*Hr1(-1)*dlx**2 + 40.
     &    D0/27.D0*Hr1(-1)*Pi**2 + 16.D0/9.D0*Hr1(-1)*x*dlx + 32.D0/9.D0
     &    *Hr1(-1)*x*dlx**2 - 8.D0/9.D0*Hr1(-1)*x*Pi**2 + 32.D0/9.D0*
     &    Hr1(-1)*x**2*dlx + 32.D0/3.D0*Hr2(-1,-1)*dlx - 32.D0/9.D0*
     &    Hr2(-1,-1)*x*dlx - 16.D0/9.D0*Hr2(0,-1) - 32.D0/9.D0*Hr2(0,-1
     &    )*x**(-1) + 32.D0/3.D0*Hr2(0,-1)*dlx - 32.D0/3.D0*Hr2(0,-1)*
     &    dd0*dlx - 16.D0/9.D0*Hr2(0,-1)*x - 32.D0/9.D0*Hr2(0,-1)*x**2
     &     + 56.D0/3.D0*Hr2(0,1) - 160.D0/9.D0*Hr2(0,1)*dlx1 - 16.D0/3.D
     &    0*Hr2(0,1)*dlx + 320.D0/9.D0*Hr2(0,1)*dd1 - 112.D0/3.D0*Hr2(0
     &    ,1)*dd0 + 64.D0/3.D0*Hr2(0,1)*dd0*dlx + 424.D0/9.D0*Hr2(0,1)*
     &    x - 160.D0/9.D0*Hr2(0,1)*x*dlx1 - 16.D0/9.D0*Hr2(0,1)*x*dlx
     &     - 32.D0/3.D0*Hr3(-1,0,-1) + 32.D0/9.D0*Hr3(-1,0,-1)*x - 32.D0
     &    /9.D0*Hr3(-1,0,1) + 32.D0/9.D0*Hr3(-1,0,1)*x - 32.D0/3.D0*
     &    Hr3(0,-1,-1)
      c3q_valence = c3q_valence + 32.D0/9.D0*Hr3(0,-1,-1)*x - 32.D0/3.D0*
     &    Hr3(0,0,-1) + 64.D0/3.D0*Hr3(0,0,-1)*dd0 - 64.D0/9.D0*Hr3(0,0
     &    ,-1)*x + 272.D0/9.D0*Hr3(0,0,1) - 160.D0/3.D0*Hr3(0,0,1)*dd0
     &     + 208.D0/9.D0*Hr3(0,0,1)*x - 176.D0/9.D0*Hr3(0,1,1) + 160.D0/
     &    3.D0*Hr3(0,1,1)*dd0 - 176.D0/9.D0*Hr3(0,1,1)*x - 32.D0/9.D0/(
     &    1 + x)*dlx - 8.D0/9.D0/(1 + x)*dlx**3 + 16.D0/27.D0/(1 + x)*
     &    Pi**2*dlx + 112.D0/9.D0/(1 + x)*Zeta3 + 80.D0/9.D0/(1 + x)*
     &    Hr1(-1)*dlx**2 - 64.D0/27.D0/(1 + x)*Hr1(-1)*Pi**2 - 128.D0/9.
     &    D0/(1 + x)*Hr2(-1,-1)*dlx - 64.D0/9.D0/(1 + x)*Hr2(0,-1)*dlx
     &     + 128.D0/9.D0/(1 + x)*Hr3(-1,0,-1) + 64.D0/9.D0/(1 + x)*Hr3(
     &    -1,0,1) + 128.D0/9.D0/(1 + x)*Hr3(0,-1,-1) - 32.D0/9.D0/(1 + 
     &    x)*Hr3(0,0,-1) - 32.D0/9.D0/(1 + x)*Hr3(0,0,1) 
         elseif (iorder.eq.3) then 
             c3q_valence = 352.D0/27.D0*x**(-1)*Pi**2*LM - 128.D0/81.D0*
     & x**(-1)*Pi**2*dlx1*LM - 64.D0/81.D0*x**(-1)*rnf*Pi**2*LM + 100.D0
     & /81.D0*x**(-1)*rnf*Pi**2*dlx1*LM + 285416.D0/81.D0*LM - 7984.D0/
     & 9.D0*LM**2 + 1544.D0/27.D0*LM**3 - 39152.D0/27.D0*LR - 1600.D0/9.
     & D0*LR*LM + 616.D0/9.D0*LR*LM**2 + 1936.D0/3.D0*LR**2 - 968.D0/3.D
     & 0*LR**2*LM + 42400.D0/81.D0*dlx1*LM - 10888.D0/27.D0*dlx1*LM**2
     &  + 1664.D0/27.D0*dlx1*LM**3 + 10016.D0/9.D0*dlx1*LR - 8624.D0/9.D
     & 0*dlx1*LR*LM + 2816.D0/9.D0*dlx1*LR*LM**2 - 968.D0/3.D0*dlx1*
     & LR**2 - 8984.D0/9.D0*dlx1**2*LM + 8224.D0/27.D0*dlx1**2*LM**2 - 
     & 1024.D0/27.D0*dlx1**2*LM**3 - 6424.D0/9.D0*dlx1**2*LR + 1408.D0/
     & 3.D0*dlx1**2*LR*LM + 8576.D0/27.D0*dlx1**3*LM - 2048.D0/27.D0*
     & dlx1**3*LM**2 + 1408.D0/9.D0*dlx1**3*LR - 1280.D0/27.D0*dlx1**4*
     & LM - 31472.D0/27.D0*dlx*LM + 13360.D0/27.D0*dlx*LM**2 - 1760.D0/
     & 27.D0*dlx*LM**3 - 19256.D0/9.D0*dlx*LR + 1056*dlx*LR*LM - 704.D0/
     & 3.D0*dlx*LR*LM**2 + 968.D0/3.D0*dlx*LR**2 + 56912.D0/27.D0*dlx*
     & dlx1*LM
      c3q_valence = c3q_valence - 4480.D0/9.D0*dlx*dlx1*LM**2 + 1024.D0/27.D
     & 0*dlx*dlx1*LM**3 + 1584*dlx*dlx1*LR - 2816.D0/3.D0*dlx*dlx1*LR*
     & LM - 24400.D0/27.D0*dlx*dlx1**2*LM + 5632.D0/27.D0*dlx*dlx1**2*
     & LM**2 - 4048.D0/9.D0*dlx*dlx1**2*LR + 1664.D0/9.D0*dlx*dlx1**3*
     & LM - 38176.D0/27.D0*dlx**2*LM + 7232.D0/27.D0*dlx**2*LM**2 - 896.
     & D0/81.D0*dlx**2*LM**3 - 3124.D0/3.D0*dlx**2*LR + 3872.D0/9.D0*
     & dlx**2*LR*LM + 26200.D0/27.D0*dlx**2*dlx1*LM - 3712.D0/27.D0*
     & dlx**2*dlx1*LM**2 + 5456.D0/9.D0*dlx**2*dlx1*LR - 6400.D0/27.D0*
     & dlx**2*dlx1**2*LM - 28576.D0/81.D0*dlx**3*LM + 2560.D0/81.D0*
     & dlx**3*LM**2 - 1936.D0/9.D0*dlx**3*LR + 11744.D0/81.D0*dlx**3*
     & dlx1*LM - 2396.D0/81.D0*dlx**4*LM + 2560.D0/27.D0*dd4*LM - 18688.
     & D0/27.D0*dd3*LM + 4096.D0/27.D0*dd3*LM**2 - 2816.D0/9.D0*dd3*LR
     &  - 3328.D0/9.D0*dd3*dlx*LM + 26800.D0/9.D0*dd2*LM - 704*dd2*
     & LM**2 + 2048.D0/27.D0*dd2*LM**3 + 4048.D0/3.D0*dd2*LR - 2816.D0/
     & 3.D0*dd2*LR*LM + 5792.D0/3.D0*dd2*dlx*LM - 11264.D0/27.D0*dd2*
     & dlx*LM**2
      c3q_valence = c3q_valence + 8096.D0/9.D0*dd2*dlx*LR + 1408.D0/3.D0*
     & dd2*dlx**2*LM - 445784.D0/81.D0*dd1*LM + 48560.D0/27.D0*dd1*
     & LM**2 - 1792.D0/9.D0*dd1*LM**3 - 27688.D0/9.D0*dd1*LR + 1760*dd1
     & *LR*LM - 5632.D0/9.D0*dd1*LR*LM**2 + 1936.D0/3.D0*dd1*LR**2 - 
     & 169888.D0/27.D0*dd1*dlx*LM + 1280*dd1*dlx*LM**2 - 2048.D0/27.D0*
     & dd1*dlx*LM**3 - 8096.D0/3.D0*dd1*dlx*LR + 5632.D0/3.D0*dd1*dlx*
     & LR*LM - 6160.D0/3.D0*dd1*dlx**2*LM + 7424.D0/27.D0*dd1*dlx**2*
     & LM**2 - 3520.D0/3.D0*dd1*dlx**2*LR - 7744.D0/27.D0*dd1*dlx**3*LM
     &  + 82252.D0/27.D0*dd0*LM - 4348.D0/9.D0*dd0*LM**2 + 208.D0/9.D0*
     & dd0*LM**3 + 122908.D0/27.D0*dd0*LR - 21352.D0/9.D0*dd0*LR*LM + 
     & 176*dd0*LR*LM**2 - 484*dd0*LR**2 + 1936.D0/3.D0*dd0*LR**2*LM + 
     & 533752.D0/81.D0*dd0*dlx*LM - 35872.D0/27.D0*dd0*dlx*LM**2 + 896.D
     & 0/9.D0*dd0*dlx*LM**3 + 46520.D0/9.D0*dd0*dlx*LR - 2112*dd0*dlx*
     & LR*LM + 2816.D0/9.D0*dd0*dlx*LR*LM**2 - 1936.D0/3.D0*dd0*dlx*
     & LR**2 + 80960.D0/27.D0*dd0*dlx**2*LM - 3760.D0/9.D0*dd0*dlx**2*
     & LM**2
      c3q_valence = c3q_valence + 1024.D0/81.D0*dd0*dlx**2*LM**3 + 5192.D0/
     & 3.D0*dd0*dlx**2*LR - 5984.D0/9.D0*dd0*dlx**2*LR*LM + 14432.D0/27.
     & D0*dd0*dlx**3*LM - 3328.D0/81.D0*dd0*dlx**3*LM**2 + 7568.D0/27.D0
     & *dd0*dlx**3*LR + 112.D0/3.D0*dd0*dlx**4*LM + 34544.D0/81.D0*
     & Pi**2*LM - 9136.D0/81.D0*Pi**2*LM**2 + 256.D0/27.D0*Pi**2*LM**3
     &  + 8800.D0/27.D0*Pi**2*LR - 4928.D0/27.D0*Pi**2*LR*LM - 29920.D0/
     & 81.D0*Pi**2*dlx1*LM + 5888.D0/81.D0*Pi**2*dlx1*LM**2 - 704.D0/3.D
     & 0*Pi**2*dlx1*LR + 9472.D0/81.D0*Pi**2*dlx1**2*LM + 36728.D0/81.D0
     & *Pi**2*dlx*LM - 5248.D0/81.D0*Pi**2*dlx*LM**2 + 2464.D0/9.D0*
     & Pi**2*dlx*LR - 21152.D0/81.D0*Pi**2*dlx*dlx1*LM + 9700.D0/81.D0*
     & Pi**2*dlx**2*LM - 18688.D0/81.D0*Pi**2*dd2*LM + 21856.D0/27.D0*
     & Pi**2*dd1*LM - 11776.D0/81.D0*Pi**2*dd1*LM**2 + 12320.D0/27.D0*
     & Pi**2*dd1*LR + 41792.D0/81.D0*Pi**2*dd1*dlx*LM - 31904.D0/27.D0*
     & Pi**2*dd0*LM + 5872.D0/27.D0*Pi**2*dd0*LM**2 - 1024.D0/81.D0*
     & Pi**2*dd0*LM**3 - 1760.D0/3.D0*Pi**2*dd0*LR + 8800.D0/27.D0*
     & Pi**2*dd0*LR*LM
      c3q_valence = c3q_valence - 21520.D0/27.D0*Pi**2*dd0*dlx*LM + 2560.D0/
     & 27.D0*Pi**2*dd0*dlx*LM**2 - 3872.D0/9.D0*Pi**2*dd0*dlx*LR - 
     & 13888.D0/81.D0*Pi**2*dd0*dlx**2*LM - 29926.D0/1215.D0*Pi**4*LM
     &  + 15616.D0/405.D0*Pi**4*dd0*LM - 152.D0/243.D0*rnf*LM + 1544.D0/
     & 81.D0*rnf*LM**2 + 32.D0/27.D0*rnf*LM**3 + 20128.D0/81.D0*rnf*LR
     &  - 1936.D0/27.D0*rnf*LR*LM + 416.D0/27.D0*rnf*LR*LM**2 - 704.D0/
     & 9.D0*rnf*LR**2 + 352.D0/9.D0*rnf*LR**2*LM - 53515.D0/243.D0*rnf*
     & dlx1*LM + 5344.D0/81.D0*rnf*dlx1*LM**2 - 256.D0/27.D0*rnf*dlx1*
     & LM**3 - 4048.D0/27.D0*rnf*dlx1*LR + 2624.D0/27.D0*rnf*dlx1*LR*LM
     &  - 512.D0/27.D0*rnf*dlx1*LR*LM**2 + 352.D0/9.D0*rnf*dlx1*LR**2
     &  + 96*rnf*dlx1**2*LM - 64.D0/3.D0*rnf*dlx1**2*LM**2 + 1696.D0/27.
     & D0*rnf*dlx1**2*LR - 256.D0/9.D0*rnf*dlx1**2*LR*LM - 1280.D0/81.D0
     & *rnf*dlx1**3*LM - 256.D0/27.D0*rnf*dlx1**3*LR + 27820.D0/81.D0*
     & rnf*dlx*LM - 2048.D0/27.D0*rnf*dlx*LM**2 + 64.D0/9.D0*rnf*dlx*
     & LM**3 + 8720.D0/27.D0*rnf*dlx*LR - 1280.D0/9.D0*rnf*dlx*LR*LM + 
     & 128.D0/9.D0*rnf*dlx*LR*LM**2
      c3q_valence = c3q_valence - 352.D0/9.D0*rnf*dlx*LR**2 - 18112.D0/81.D0
     & *rnf*dlx*dlx1*LM + 1280.D0/27.D0*rnf*dlx*dlx1*LM**2 - 1216.D0/9.D
     & 0*rnf*dlx*dlx1*LR + 512.D0/9.D0*rnf*dlx*dlx1*LR*LM + 416.D0/9.D0
     & *rnf*dlx*dlx1**2*LM + 736.D0/27.D0*rnf*dlx*dlx1**2*LR + 14593.D0/
     & 81.D0*rnf*dlx**2*LM - 640.D0/27.D0*rnf*dlx**2*LM**2 + 112*rnf*
     & dlx**2*LR - 704.D0/27.D0*rnf*dlx**2*LR*LM - 3071.D0/54.D0*rnf*
     & dlx**2*dlx1*LM - 992.D0/27.D0*rnf*dlx**2*dlx1*LR + 1973.D0/81.D0
     & *rnf*dlx**3*LM + 352.D0/27.D0*rnf*dlx**3*LR + 25.D0/54.D0*rnf*
     & dlx**4*LM + 2560.D0/81.D0*rnf*dd3*LM + 512.D0/27.D0*rnf*dd3*LR
     &  - 6208.D0/27.D0*rnf*dd2*LM + 128.D0/3.D0*rnf*dd2*LM**2 - 1088.D0
     & /9.D0*rnf*dd2*LR + 512.D0/9.D0*rnf*dd2*LR*LM - 832.D0/9.D0*rnf*
     & dd2*dlx*LM - 1472.D0/27.D0*rnf*dd2*dlx*LR + 133856.D0/243.D0*rnf
     & *dd1*LM - 13184.D0/81.D0*rnf*dd1*LM**2 + 512.D0/27.D0*rnf*dd1*
     & LM**3 + 11072.D0/27.D0*rnf*dd1*LR - 1664.D0/9.D0*rnf*dd1*LR*LM
     &  + 1024.D0/27.D0*rnf*dd1*LR*LM**2 - 704.D0/9.D0*rnf*dd1*LR**2 + 
     & 40832.D0/81.D0*rnf*dd1*dlx*LM
      c3q_valence = c3q_valence - 2560.D0/27.D0*rnf*dd1*dlx*LM**2 + 2176.D0/
     & 9.D0*rnf*dd1*dlx*LR - 1024.D0/9.D0*rnf*dd1*dlx*LR*LM + 3232.D0/
     & 27.D0*rnf*dd1*dlx**2*LM + 640.D0/9.D0*rnf*dd1*dlx**2*LR - 14776.D
     & 0/27.D0*rnf*dd0*LM + 3536.D0/27.D0*rnf*dd0*LM**2 - 320.D0/27.D0*
     & rnf*dd0*LM**3 - 46184.D0/81.D0*rnf*dd0*LR + 9920.D0/27.D0*rnf*
     & dd0*LR*LM - 448.D0/9.D0*rnf*dd0*LR*LM**2 + 176.D0/3.D0*rnf*dd0*
     & LR**2 - 704.D0/9.D0*rnf*dd0*LR**2*LM - 214240.D0/243.D0*rnf*dd0*
     & dlx*LM + 12928.D0/81.D0*rnf*dd0*dlx*LM**2 - 256.D0/27.D0*rnf*dd0
     & *dlx*LM**3 - 19424.D0/27.D0*rnf*dd0*dlx*LR + 2560.D0/9.D0*rnf*
     & dd0*dlx*LR*LM - 512.D0/27.D0*rnf*dd0*dlx*LR*LM**2 + 704.D0/9.D0*
     & rnf*dd0*dlx*LR**2 - 25376.D0/81.D0*rnf*dd0*dlx**2*LM + 928.D0/27.
     & D0*rnf*dd0*dlx**2*LM**2 - 608.D0/3.D0*rnf*dd0*dlx**2*LR + 1088.D0
     & /27.D0*rnf*dd0*dlx**2*LR*LM - 3104.D0/81.D0*rnf*dd0*dlx**3*LM - 
     & 1376.D0/81.D0*rnf*dd0*dlx**3*LR - 8737.D0/162.D0*rnf*Pi**2*LM + 
     & 736.D0/81.D0*rnf*Pi**2*LM**2 - 2656.D0/81.D0*rnf*Pi**2*LR + 896.D
     & 0/81.D0*rnf*Pi**2*LR*LM
      c3q_valence = c3q_valence + 1867.D0/81.D0*rnf*Pi**2*dlx1*LM + 128.D0/
     & 9.D0*rnf*Pi**2*dlx1*LR - 5291.D0/162.D0*rnf*Pi**2*dlx*LM - 448.D0
     & /27.D0*rnf*Pi**2*dlx*LR - 25.D0/18.D0*rnf*Pi**2*dlx**2*LM - 3520.
     & D0/81.D0*rnf*Pi**2*dd1*LM - 2240.D0/81.D0*rnf*Pi**2*dd1*LR + 
     & 2816.D0/27.D0*rnf*Pi**2*dd0*LM - 1312.D0/81.D0*rnf*Pi**2*dd0*
     & LM**2 + 1664.D0/27.D0*rnf*Pi**2*dd0*LR - 1600.D0/81.D0*rnf*Pi**2
     & *dd0*LR*LM + 4352.D0/81.D0*rnf*Pi**2*dd0*dlx*LM + 704.D0/27.D0*
     & rnf*Pi**2*dd0*dlx*LR + 125.D0/324.D0*rnf*Pi**4*LM - 512.D0/243.D0
     & *rnf**2*LM + 160.D0/81.D0*rnf**2*LM**2 - 32.D0/81.D0*rnf**2*
     & LM**3 - 1856.D0/243.D0*rnf**2*LR + 320.D0/81.D0*rnf**2*LR*LM - 
     & 32.D0/27.D0*rnf**2*LR*LM**2 + 64.D0/27.D0*rnf**2*LR**2 - 32.D0/
     & 27.D0*rnf**2*LR**2*LM + 320.D0/81.D0*rnf**2*dlx1*LM - 32.D0/27.D0
     & *rnf**2*dlx1*LM**2 + 320.D0/81.D0*rnf**2*dlx1*LR - 64.D0/27.D0*
     & rnf**2*dlx1*LR*LM - 32.D0/27.D0*rnf**2*dlx1*LR**2 - 32.D0/27.D0*
     & rnf**2*dlx1**2*LM - 32.D0/27.D0*rnf**2*dlx1**2*LR - 832.D0/81.D0
     & *rnf**2*dlx*LM
      c3q_valence = c3q_valence + 64.D0/27.D0*rnf**2*dlx*LM**2 - 32.D0/3.D0
     & *rnf**2*dlx*LR + 128.D0/27.D0*rnf**2*dlx*LR*LM + 32.D0/27.D0*
     & rnf**2*dlx*LR**2 + 64.D0/27.D0*rnf**2*dlx*dlx1*LM + 64.D0/27.D0*
     & rnf**2*dlx*dlx1*LR - 32.D0/9.D0*rnf**2*dlx**2*LM - 80.D0/27.D0*
     & rnf**2*dlx**2*LR + 64.D0/27.D0*rnf**2*dd2*LM + 64.D0/27.D0*
     & rnf**2*dd2*LR - 928.D0/81.D0*rnf**2*dd1*LM + 64.D0/27.D0*rnf**2*
     & dd1*LM**2 - 928.D0/81.D0*rnf**2*dd1*LR + 128.D0/27.D0*rnf**2*dd1
     & *LR*LM + 64.D0/27.D0*rnf**2*dd1*LR**2 - 128.D0/27.D0*rnf**2*dd1*
     & dlx*LM - 128.D0/27.D0*rnf**2*dd1*dlx*LR + 3760.D0/243.D0*rnf**2*
     & dd0*LM - 464.D0/81.D0*rnf**2*dd0*LM**2 + 64.D0/81.D0*rnf**2*dd0*
     & LM**3 + 3952.D0/243.D0*rnf**2*dd0*LR - 928.D0/81.D0*rnf**2*dd0*
     & LR*LM + 64.D0/27.D0*rnf**2*dd0*LR*LM**2 - 16.D0/9.D0*rnf**2*dd0*
     & LR**2 + 64.D0/27.D0*rnf**2*dd0*LR**2*LM + 2144.D0/81.D0*rnf**2*
     & dd0*dlx*LM - 128.D0/27.D0*rnf**2*dd0*dlx*LM**2 + 608.D0/27.D0*
     & rnf**2*dd0*dlx*LR - 256.D0/27.D0*rnf**2*dd0*dlx*LR*LM - 64.D0/27.
     & D0*rnf**2*dd0*dlx*LR**2
      c3q_valence = c3q_valence + 64.D0/9.D0*rnf**2*dd0*dlx**2*LM + 160.D0/
     & 27.D0*rnf**2*dd0*dlx**2*LR + 64.D0/81.D0*rnf**2*Pi**2*LM + 64.D0/
     & 81.D0*rnf**2*Pi**2*LR - 128.D0/81.D0*rnf**2*Pi**2*dd0*LM - 128.D0
     & /81.D0*rnf**2*Pi**2*dd0*LR + 19456.D0/27.D0*Zeta3*LM - 1664.D0/
     & 27.D0*Zeta3*LM**2 + 16192.D0/9.D0*Zeta3*LR - 20288.D0/27.D0*
     & Zeta3*dlx1*LM + 9920.D0/27.D0*Zeta3*dlx*LM + 12928.D0/9.D0*Zeta3
     & *dd1*LM - 19616.D0/9.D0*Zeta3*dd0*LM + 4352.D0/27.D0*Zeta3*dd0*
     & LM**2 - 25696.D0/9.D0*Zeta3*dd0*LR - 20992.D0/27.D0*Zeta3*dd0*
     & dlx*LM - 1708.D0/27.D0*Zeta3*rnf*LM - 2944.D0/27.D0*Zeta3*rnf*LR
     &  + 2816.D0/27.D0*Zeta3*rnf*dd0*LM + 4672.D0/27.D0*Zeta3*rnf*dd0*
     & LR - 705296.D0/81.D0*x*LM + 14600.D0/9.D0*x*LM**2 - 2168.D0/27.D0
     & *x*LM**3 - 152984.D0/27.D0*x*LR + 28496.D0/9.D0*x*LR*LM - 2200.D0
     & /9.D0*x*LR*LM**2 + 968.D0/3.D0*x*LR**2 - 968.D0/3.D0*x*LR**2*LM
     &  + 565312.D0/81.D0*x*dlx1*LM - 44872.D0/27.D0*x*dlx1*LM**2 + 
     & 3712.D0/27.D0*x*dlx1*LM**3 + 28672.D0/9.D0*x*dlx1*LR - 11440.D0/
     & 9.D0*x*dlx1*LR*LM
      c3q_valence = c3q_valence + 2816.D0/9.D0*x*dlx1*LR*LM**2 - 968.D0/3.D0
     & *x*dlx1*LR**2 - 66632.D0/27.D0*x*dlx1**2*LM + 12320.D0/27.D0*x*
     & dlx1**2*LM**2 - 1024.D0/27.D0*x*dlx1**2*LM**3 - 7832.D0/9.D0*x*
     & dlx1**2*LR + 1408.D0/3.D0*x*dlx1**2*LR*LM + 11648.D0/27.D0*x*
     & dlx1**3*LM - 2048.D0/27.D0*x*dlx1**3*LM**2 + 1408.D0/9.D0*x*
     & dlx1**3*LR - 1280.D0/27.D0*x*dlx1**4*LM - 27712.D0/3.D0*x*dlx*LM
     &  + 40816.D0/27.D0*x*dlx*LM**2 - 928.D0/9.D0*x*dlx*LM**3 - 44776.D
     & 0/9.D0*x*dlx*LR + 15136.D0/9.D0*x*dlx*LR*LM - 704.D0/3.D0*x*dlx*
     & LR*LM**2 + 968.D0/3.D0*x*dlx*LR**2 + 135376.D0/27.D0*x*dlx*dlx1*
     & LM - 7552.D0/9.D0*x*dlx*dlx1*LM**2 + 1024.D0/27.D0*x*dlx*dlx1*
     & LM**3 + 1584*x*dlx*dlx1*LR - 2816.D0/3.D0*x*dlx*dlx1*LR*LM - 
     & 32336.D0/27.D0*x*dlx*dlx1**2*LM + 5632.D0/27.D0*x*dlx*dlx1**2*
     & LM**2 - 4048.D0/9.D0*x*dlx*dlx1**2*LR + 1664.D0/9.D0*x*dlx*
     & dlx1**3*LM - 79600.D0/27.D0*x*dlx**2*LM + 11152.D0/27.D0*x*
     & dlx**2*LM**2 - 896.D0/81.D0*x*dlx**2*LM**3 - 11660.D0/9.D0*x*
     & dlx**2*LR
      c3q_valence = c3q_valence + 1408.D0/3.D0*x*dlx**2*LR*LM + 32504.D0/27.
     & D0*x*dlx**2*dlx1*LM - 3712.D0/27.D0*x*dlx**2*dlx1*LM**2 + 5104.D0
     & /9.D0*x*dlx**2*dlx1*LR - 6272.D0/27.D0*x*dlx**2*dlx1**2*LM - 
     & 40208.D0/81.D0*x*dlx**3*LM + 2944.D0/81.D0*x*dlx**3*LM**2 - 1760.
     & D0/9.D0*x*dlx**3*LR + 11488.D0/81.D0*x*dlx**3*dlx1*LM - 2624.D0/
     & 81.D0*x*dlx**4*LM + 88640.D0/81.D0*x*Pi**2*LM - 14336.D0/81.D0*x
     & *Pi**2*LM**2 + 256.D0/27.D0*x*Pi**2*LM**3 + 11792.D0/27.D0*x*
     & Pi**2*LR - 1760.D0/9.D0*x*Pi**2*LR*LM - 40448.D0/81.D0*x*Pi**2*
     & dlx1*LM + 5888.D0/81.D0*x*Pi**2*dlx1*LM**2 - 5984.D0/27.D0*x*
     & Pi**2*dlx1*LR + 1024.D0/9.D0*x*Pi**2*dlx1**2*LM + 58696.D0/81.D0
     & *x*Pi**2*dlx*LM - 5888.D0/81.D0*x*Pi**2*dlx*LM**2 + 7040.D0/27.D0
     & *x*Pi**2*dlx*LR - 6880.D0/27.D0*x*Pi**2*dlx*dlx1*LM + 11164.D0/
     & 81.D0*x*Pi**2*dlx**2*LM - 26858.D0/1215.D0*x*Pi**4*LM + 213704.D0
     & /243.D0*x*rnf*LM - 15608.D0/81.D0*x*rnf*LM**2 + 32.D0/3.D0*x*rnf
     & *LM**3 + 55792.D0/81.D0*x*rnf*LR - 10576.D0/27.D0*x*rnf*LR*LM + 
     & 928.D0/27.D0*x*rnf*LR*LM**2
      c3q_valence = c3q_valence - 352.D0/9.D0*x*rnf*LR**2 + 352.D0/9.D0*x*
     & rnf*LR**2*LM - 126709.D0/243.D0*x*rnf*dlx1*LM + 9568.D0/81.D0*x*
     & rnf*dlx1*LM**2 - 256.D0/27.D0*x*rnf*dlx1*LM**3 - 3536.D0/9.D0*x*
     & rnf*dlx1*LR + 3136.D0/27.D0*x*rnf*dlx1*LR*LM - 512.D0/27.D0*x*
     & rnf*dlx1*LR*LM**2 + 352.D0/9.D0*x*rnf*dlx1*LR**2 + 4384.D0/27.D0
     & *x*rnf*dlx1**2*LM - 64.D0/3.D0*x*rnf*dlx1**2*LM**2 + 1952.D0/27.D
     & 0*x*rnf*dlx1**2*LR - 256.D0/9.D0*x*rnf*dlx1**2*LR*LM - 1280.D0/
     & 81.D0*x*rnf*dlx1**3*LM - 256.D0/27.D0*x*rnf*dlx1**3*LR + 25153.D0
     & /27.D0*x*rnf*dlx*LM - 128*x*rnf*dlx*LM**2 + 64.D0/9.D0*x*rnf*dlx
     & *LM**3 + 16528.D0/27.D0*x*rnf*dlx*LR - 4864.D0/27.D0*x*rnf*dlx*
     & LR*LM + 128.D0/9.D0*x*rnf*dlx*LR*LM**2 - 352.D0/9.D0*x*rnf*dlx*
     & LR**2 - 27328.D0/81.D0*x*rnf*dlx*dlx1*LM + 1280.D0/27.D0*x*rnf*
     & dlx*dlx1*LM**2 - 1216.D0/9.D0*x*rnf*dlx*dlx1*LR + 512.D0/9.D0*x*
     & rnf*dlx*dlx1*LR*LM + 416.D0/9.D0*x*rnf*dlx*dlx1**2*LM + 736.D0/
     & 27.D0*x*rnf*dlx*dlx1**2*LR + 13525.D0/54.D0*x*rnf*dlx**2*LM - 
     & 224.D0/9.D0*x*rnf*dlx**2*LM**2
      c3q_valence = c3q_valence + 3440.D0/27.D0*x*rnf*dlx**2*LR - 256.D0/9.D
     & 0*x*rnf*dlx**2*LR*LM - 377.D0/6.D0*x*rnf*dlx**2*dlx1*LM - 928.D0/
     & 27.D0*x*rnf*dlx**2*dlx1*LR + 736.D0/27.D0*x*rnf*dlx**3*LM + 320.D
     & 0/27.D0*x*rnf*dlx**3*LR - 39301.D0/486.D0*x*rnf*Pi**2*LM + 256.D0
     & /27.D0*x*rnf*Pi**2*LM**2 - 3200.D0/81.D0*x*rnf*Pi**2*LR + 320.D0/
     & 27.D0*x*rnf*Pi**2*LR*LM + 551.D0/27.D0*x*rnf*Pi**2*dlx1*LM + 
     & 1088.D0/81.D0*x*rnf*Pi**2*dlx1*LR - 4411.D0/162.D0*x*rnf*Pi**2*
     & dlx*LM - 1280.D0/81.D0*x*rnf*Pi**2*dlx*LR - 125.D0/54.D0*x*rnf*
     & Pi**2*dlx**2*LM + 25.D0/108.D0*x*rnf*Pi**4*LM - 5984.D0/243.D0*x
     & *rnf**2*LM + 448.D0/81.D0*x*rnf**2*LM**2 - 32.D0/81.D0*x*rnf**2*
     & LM**3 - 4832.D0/243.D0*x*rnf**2*LR + 896.D0/81.D0*x*rnf**2*LR*LM
     &  - 32.D0/27.D0*x*rnf**2*LR*LM**2 + 32.D0/27.D0*x*rnf**2*LR**2 - 
     & 32.D0/27.D0*x*rnf**2*LR**2*LM + 896.D0/81.D0*x*rnf**2*dlx1*LM - 
     & 32.D0/27.D0*x*rnf**2*dlx1*LM**2 + 896.D0/81.D0*x*rnf**2*dlx1*LR
     &  - 64.D0/27.D0*x*rnf**2*dlx1*LR*LM - 32.D0/27.D0*x*rnf**2*dlx1*
     & LR**2
      c3q_valence = c3q_valence - 32.D0/27.D0*x*rnf**2*dlx1**2*LM - 32.D0/
     & 27.D0*x*rnf**2*dlx1**2*LR - 1792.D0/81.D0*x*rnf**2*dlx*LM + 64.D0
     & /27.D0*x*rnf**2*dlx*LM**2 - 160.D0/9.D0*x*rnf**2*dlx*LR + 128.D0/
     & 27.D0*x*rnf**2*dlx*LR*LM + 32.D0/27.D0*x*rnf**2*dlx*LR**2 + 64.D0
     & /27.D0*x*rnf**2*dlx*dlx1*LM + 64.D0/27.D0*x*rnf**2*dlx*dlx1*LR
     &  - 32.D0/9.D0*x*rnf**2*dlx**2*LM - 80.D0/27.D0*x*rnf**2*dlx**2*
     & LR + 64.D0/81.D0*x*rnf**2*Pi**2*LM + 64.D0/81.D0*x*rnf**2*Pi**2*
     & LR + 63904.D0/27.D0*x*Zeta3*LM - 1408.D0/9.D0*x*Zeta3*LM**2 + 
     & 13024.D0/9.D0*x*Zeta3*LR - 18496.D0/27.D0*x*Zeta3*dlx1*LM + 
     & 22784.D0/27.D0*x*Zeta3*dlx*LM - 52*x*Zeta3*rnf*LM - 2368.D0/27.D0
     & *x*Zeta3*rnf*LR - 200.D0/9.D0*x*Zeta3*rnf*dlx*LM + 64.D0/3.D0*
     & x**2*LM - 640.D0/27.D0*x**2*dlx*LM + 352.D0/9.D0*x**2*dlx**2*LM
     &  + 352.D0/9.D0*x**2*dlx**2*LR + 256.D0/81.D0*x**2*dlx**3*LM - 
     & 352.D0/27.D0*x**2*Pi**2*LR + 128.D0/81.D0*x**2*Pi**2*dlx1*LM - 
     & 256.D0/81.D0*x**2*Pi**2*dlx*LM - 64.D0/27.D0*x**2*rnf*dlx**2*LM
     &  - 64.D0/27.D0*x**2*rnf*dlx**2*LR
      c3q_valence = c3q_valence - 200.D0/81.D0*x**2*rnf*dlx**3*LM + 64.D0/
     & 81.D0*x**2*rnf*Pi**2*LR - 100.D0/81.D0*x**2*rnf*Pi**2*dlx1*LM + 
     & 200.D0/81.D0*x**2*rnf*Pi**2*dlx*LM + 256.D0/27.D0*x**2*Zeta3*LM
     &  - 200.D0/27.D0*x**2*Zeta3*rnf*LM + 704.D0/9.D0*Hr1(-1)*x**(-1)*
     & dlx*LM - 704.D0/9.D0*Hr1(-1)*x**(-1)*dlx*LR + 256.D0/27.D0*Hr1(
     & -1)*x**(-1)*dlx**2*LM - 128.D0/27.D0*Hr1(-1)*x**(-1)*Pi**2*LM - 
     & 128.D0/27.D0*Hr1(-1)*x**(-1)*rnf*dlx*LM + 128.D0/27.D0*Hr1(-1)*
     & x**(-1)*rnf*dlx*LR - 200.D0/27.D0*Hr1(-1)*x**(-1)*rnf*dlx**2*LM
     &  + 100.D0/27.D0*Hr1(-1)*x**(-1)*rnf*Pi**2*LM - 608.D0/9.D0*Hr1(
     & -1)*dlx*LM + 160.D0/27.D0*Hr1(-1)*dlx*LM**2 - 352.D0/9.D0*Hr1(-1
     & )*dlx*LR + 704.D0/9.D0*Hr1(-1)*dlx*LR*LM - 272.D0/3.D0*Hr1(-1)*
     & dlx**2*LM + 128.D0/9.D0*Hr1(-1)*dlx**2*LM**2 + 352.D0/3.D0*Hr1(
     & -1)*dlx**2*LR - 1888.D0/81.D0*Hr1(-1)*dlx**3*LM + 2224.D0/81.D0*
     & Hr1(-1)*Pi**2*LM - 512.D0/81.D0*Hr1(-1)*Pi**2*LM**2 - 880.D0/27.D
     & 0*Hr1(-1)*Pi**2*LR + 1568.D0/81.D0*Hr1(-1)*Pi**2*dlx*LM + 2014.D0
     & /81.D0*Hr1(-1)*rnf*dlx*LM
      c3q_valence = c3q_valence - 64.D0/27.D0*Hr1(-1)*rnf*dlx*LM**2 + 64.D0/
     & 27.D0*Hr1(-1)*rnf*dlx*LR - 128.D0/27.D0*Hr1(-1)*rnf*dlx*LR*LM + 
     & 149.D0/27.D0*Hr1(-1)*rnf*dlx**2*LM - 64.D0/9.D0*Hr1(-1)*rnf*
     & dlx**2*LR + 43.D0/27.D0*Hr1(-1)*rnf*Pi**2*LM + 160.D0/81.D0*Hr1(
     & -1)*rnf*Pi**2*LR + 3968.D0/27.D0*Hr1(-1)*Zeta3*LM + 4960.D0/27.D0
     & *Hr1(-1)*x*dlx*LM - 1184.D0/27.D0*Hr1(-1)*x*dlx*LM**2 - 352.D0/9.
     & D0*Hr1(-1)*x*dlx*LR - 704.D0/9.D0*Hr1(-1)*x*dlx*LR*LM + 368.D0/3.
     & D0*Hr1(-1)*x*dlx**2*LM - 128.D0/9.D0*Hr1(-1)*x*dlx**2*LM**2 - 
     & 704.D0/9.D0*Hr1(-1)*x*dlx**2*LR + 544.D0/27.D0*Hr1(-1)*x*dlx**3*
     & LM - 848.D0/81.D0*Hr1(-1)*x*Pi**2*LM + 512.D0/81.D0*Hr1(-1)*x*
     & Pi**2*LM**2 + 176.D0/9.D0*Hr1(-1)*x*Pi**2*LR - 352.D0/27.D0*Hr1(
     & -1)*x*Pi**2*dlx*LM + 734.D0/81.D0*Hr1(-1)*x*rnf*dlx*LM + 64.D0/
     & 27.D0*Hr1(-1)*x*rnf*dlx*LM**2 + 64.D0/27.D0*Hr1(-1)*x*rnf*dlx*LR
     &  + 128.D0/27.D0*Hr1(-1)*x*rnf*dlx*LR*LM - 235.D0/27.D0*Hr1(-1)*x
     & *rnf*dlx**2*LM + 128.D0/27.D0*Hr1(-1)*x*rnf*dlx**2*LR + 257.D0/
     & 81.D0*Hr1(-1)*x*rnf*Pi**2*LM
      c3q_valence = c3q_valence - 32.D0/27.D0*Hr1(-1)*x*rnf*Pi**2*LR - 2176.
     & D0/27.D0*Hr1(-1)*x*Zeta3*LM + 704.D0/9.D0*Hr1(-1)*x**2*dlx*LM - 
     & 704.D0/9.D0*Hr1(-1)*x**2*dlx*LR + 256.D0/27.D0*Hr1(-1)*x**2*
     & dlx**2*LM - 128.D0/27.D0*Hr1(-1)*x**2*Pi**2*LM - 128.D0/27.D0*
     & Hr1(-1)*x**2*rnf*dlx*LM + 128.D0/27.D0*Hr1(-1)*x**2*rnf*dlx*LR
     &  - 200.D0/27.D0*Hr1(-1)*x**2*rnf*dlx**2*LM + 100.D0/27.D0*Hr1(-1
     & )*x**2*rnf*Pi**2*LM - 512.D0/27.D0*Hr2(-1,-1)*x**(-1)*dlx*LM + 
     & 400.D0/27.D0*Hr2(-1,-1)*x**(-1)*rnf*dlx*LM + 4544.D0/27.D0*Hr2(
     & -1,-1)*dlx*LM - 1024.D0/27.D0*Hr2(-1,-1)*dlx*LM**2 - 704.D0/3.D0
     & *Hr2(-1,-1)*dlx*LR + 1024.D0/9.D0*Hr2(-1,-1)*dlx**2*LM - 1664.D0/
     & 81.D0*Hr2(-1,-1)*Pi**2*LM - 76.D0/3.D0*Hr2(-1,-1)*rnf*dlx*LM + 
     & 128.D0/9.D0*Hr2(-1,-1)*rnf*dlx*LR - 4672.D0/27.D0*Hr2(-1,-1)*x*
     & dlx*LM + 1024.D0/27.D0*Hr2(-1,-1)*x*dlx*LM**2 + 704.D0/9.D0*Hr2(
     & -1,-1)*x*dlx*LR - 256.D0/3.D0*Hr2(-1,-1)*x*dlx**2*LM + 640.D0/81.
     & D0*Hr2(-1,-1)*x*Pi**2*LM - 172.D0/27.D0*Hr2(-1,-1)*x*rnf*dlx*LM
     &  - 128.D0/27.D0*Hr2(-1,-1)*x*rnf*dlx*LR
      c3q_valence = c3q_valence - 512.D0/27.D0*Hr2(-1,-1)*x**2*dlx*LM + 400.
     & D0/27.D0*Hr2(-1,-1)*x**2*rnf*dlx*LM - 704.D0/9.D0*Hr2(0,-1)*
     & x**(-1)*LM + 704.D0/9.D0*Hr2(0,-1)*x**(-1)*LR - 512.D0/27.D0*
     & Hr2(0,-1)*x**(-1)*dlx*LM + 128.D0/27.D0*Hr2(0,-1)*x**(-1)*rnf*LM
     &  - 128.D0/27.D0*Hr2(0,-1)*x**(-1)*rnf*LR + 400.D0/27.D0*Hr2(0,-1
     & )*x**(-1)*rnf*dlx*LM + 608.D0/9.D0*Hr2(0,-1)*LM - 160.D0/27.D0*
     & Hr2(0,-1)*LM**2 + 352.D0/9.D0*Hr2(0,-1)*LR - 704.D0/9.D0*Hr2(0,
     & -1)*LR*LM - 1984.D0/9.D0*Hr2(0,-1)*dlx*LM - 704.D0/3.D0*Hr2(0,-1
     & )*dlx*LR + 3200.D0/27.D0*Hr2(0,-1)*dlx*dlx1*LM - 2096.D0/27.D0*
     & Hr2(0,-1)*dlx**2*LM - 6400.D0/27.D0*Hr2(0,-1)*dd1*dlx*LM + 128*
     & Hr2(0,-1)*dd0*dlx*LM + 704.D0/3.D0*Hr2(0,-1)*dd0*dlx*LR + 320.D0/
     & 9.D0*Hr2(0,-1)*dd0*dlx**2*LM + 112.D0/3.D0*Hr2(0,-1)*Pi**2*LM - 
     & 640.D0/27.D0*Hr2(0,-1)*Pi**2*dd0*LM - 2014.D0/81.D0*Hr2(0,-1)*
     & rnf*LM + 64.D0/27.D0*Hr2(0,-1)*rnf*LM**2 - 64.D0/27.D0*Hr2(0,-1)
     & *rnf*LR + 128.D0/27.D0*Hr2(0,-1)*rnf*LR*LM + 128.D0/9.D0*Hr2(0,
     & -1)*rnf*dlx*LM
      c3q_valence = c3q_valence + 128.D0/9.D0*Hr2(0,-1)*rnf*dlx*LR + 50.D0/
     & 9.D0*Hr2(0,-1)*rnf*dlx**2*LM - 128.D0/9.D0*Hr2(0,-1)*rnf*dd0*dlx
     & *LM - 128.D0/9.D0*Hr2(0,-1)*rnf*dd0*dlx*LR - 50.D0/27.D0*Hr2(0,
     & -1)*rnf*Pi**2*LM - 4960.D0/27.D0*Hr2(0,-1)*x*LM + 1184.D0/27.D0*
     & Hr2(0,-1)*x*LM**2 + 352.D0/9.D0*Hr2(0,-1)*x*LR + 704.D0/9.D0*
     & Hr2(0,-1)*x*LR*LM + 2368.D0/27.D0*Hr2(0,-1)*x*dlx*LM + 3200.D0/
     & 27.D0*Hr2(0,-1)*x*dlx*dlx1*LM + 112.D0/3.D0*Hr2(0,-1)*x*dlx**2*
     & LM - 368.D0/27.D0*Hr2(0,-1)*x*Pi**2*LM - 734.D0/81.D0*Hr2(0,-1)*
     & x*rnf*LM - 64.D0/27.D0*Hr2(0,-1)*x*rnf*LM**2 - 64.D0/27.D0*Hr2(0
     & ,-1)*x*rnf*LR - 128.D0/27.D0*Hr2(0,-1)*x*rnf*LR*LM + 200.D0/9.D0
     & *Hr2(0,-1)*x*rnf*dlx*LM - 50.D0/9.D0*Hr2(0,-1)*x*rnf*dlx**2*LM
     &  + 50.D0/27.D0*Hr2(0,-1)*x*rnf*Pi**2*LM - 704.D0/9.D0*Hr2(0,-1)*
     & x**2*LM + 704.D0/9.D0*Hr2(0,-1)*x**2*LR + 128.D0/27.D0*Hr2(0,-1)
     & *x**2*rnf*LM - 128.D0/27.D0*Hr2(0,-1)*x**2*rnf*LR - 12176.D0/27.D
     & 0*Hr2(0,1)*LM + 4832.D0/27.D0*Hr2(0,1)*LM**2 - 512.D0/27.D0*Hr2(
     & 0,1)*LM**3
      c3q_valence = c3q_valence - 1232.D0/3.D0*Hr2(0,1)*LR + 1408.D0/9.D0*
     & Hr2(0,1)*LR*LM + 8768.D0/27.D0*Hr2(0,1)*dlx1*LM + 3520.D0/9.D0*
     & Hr2(0,1)*dlx1*LR - 2560.D0/27.D0*Hr2(0,1)*dlx1**2*LM - 784.D0/3.D
     & 0*Hr2(0,1)*dlx*LM + 3328.D0/27.D0*Hr2(0,1)*dlx*LM**2 + 352.D0/3.D
     & 0*Hr2(0,1)*dlx*LR + 7168.D0/27.D0*Hr2(0,1)*dlx*dlx1*LM - 952.D0/
     & 9.D0*Hr2(0,1)*dlx**2*LM + 5120.D0/27.D0*Hr2(0,1)*dd2*LM - 7552.D0
     & /9.D0*Hr2(0,1)*dd1*LM - 7040.D0/9.D0*Hr2(0,1)*dd1*LR - 14848.D0/
     & 27.D0*Hr2(0,1)*dd1*dlx*LM + 672*Hr2(0,1)*dd0*LM + 2464.D0/3.D0*
     & Hr2(0,1)*dd0*LR - 352.D0/9.D0*Hr2(0,1)*dd0*dlx*LM - 512.D0/9.D0*
     & Hr2(0,1)*dd0*dlx*LM**2 - 1408.D0/3.D0*Hr2(0,1)*dd0*dlx*LR + 64.D0
     & /9.D0*Hr2(0,1)*dd0*dlx**2*LM + 592.D0/81.D0*Hr2(0,1)*Pi**2*LM + 
     & 5824.D0/81.D0*Hr2(0,1)*Pi**2*dd0*LM + 8099.D0/81.D0*Hr2(0,1)*rnf
     & *LM - 64.D0/9.D0*Hr2(0,1)*rnf*LM**2 + 64*Hr2(0,1)*rnf*LR - 256.D0
     & /27.D0*Hr2(0,1)*rnf*LR*LM - 896.D0/27.D0*Hr2(0,1)*rnf*dlx1*LM - 
     & 640.D0/27.D0*Hr2(0,1)*rnf*dlx1*LR + 641.D0/27.D0*Hr2(0,1)*rnf*
     & dlx*LM
      c3q_valence = c3q_valence - 64.D0/9.D0*Hr2(0,1)*rnf*dlx*LR - 25.D0/9.D
     & 0*Hr2(0,1)*rnf*dlx**2*LM + 1792.D0/27.D0*Hr2(0,1)*rnf*dd1*LM + 
     & 1280.D0/27.D0*Hr2(0,1)*rnf*dd1*LR - 1024.D0/9.D0*Hr2(0,1)*rnf*
     & dd0*LM - 128*Hr2(0,1)*rnf*dd0*LR - 64.D0/9.D0*Hr2(0,1)*rnf*dd0*
     & dlx*LM + 256.D0/9.D0*Hr2(0,1)*rnf*dd0*dlx*LR - 50.D0/27.D0*Hr2(0
     & ,1)*rnf*Pi**2*LM - 64.D0/27.D0*Hr2(0,1)*rnf**2*LM - 64.D0/27.D0*
     & Hr2(0,1)*rnf**2*LR + 128.D0/27.D0*Hr2(0,1)*rnf**2*dd0*LM + 128.D0
     & /27.D0*Hr2(0,1)*rnf**2*dd0*LR - 36944.D0/27.D0*Hr2(0,1)*x*LM + 
     & 4832.D0/27.D0*Hr2(0,1)*x*LM**2 - 512.D0/27.D0*Hr2(0,1)*x*LM**3
     &  - 9328.D0/9.D0*Hr2(0,1)*x*LR + 1408.D0/9.D0*Hr2(0,1)*x*LR*LM + 
     & 13888.D0/27.D0*Hr2(0,1)*x*dlx1*LM + 3520.D0/9.D0*Hr2(0,1)*x*dlx1
     & *LR - 2560.D0/27.D0*Hr2(0,1)*x*dlx1**2*LM - 17872.D0/27.D0*Hr2(0
     & ,1)*x*dlx*LM + 3328.D0/27.D0*Hr2(0,1)*x*dlx*LM**2 + 352.D0/9.D0*
     & Hr2(0,1)*x*dlx*LR + 2560.D0/9.D0*Hr2(0,1)*x*dlx*dlx1*LM - 2984.D0
     & /27.D0*Hr2(0,1)*x*dlx**2*LM + 848.D0/81.D0*Hr2(0,1)*x*Pi**2*LM
     &  + 12707.D0/81.D0*Hr2(0,1)*x*rnf*LM
      c3q_valence = c3q_valence - 64.D0/9.D0*Hr2(0,1)*x*rnf*LM**2 + 2752.D0/
     & 27.D0*Hr2(0,1)*x*rnf*LR - 256.D0/27.D0*Hr2(0,1)*x*rnf*LR*LM - 
     & 896.D0/27.D0*Hr2(0,1)*x*rnf*dlx1*LM - 640.D0/27.D0*Hr2(0,1)*x*
     & rnf*dlx1*LR + 319.D0/27.D0*Hr2(0,1)*x*rnf*dlx*LM - 64.D0/27.D0*
     & Hr2(0,1)*x*rnf*dlx*LR - 25.D0/9.D0*Hr2(0,1)*x*rnf*dlx**2*LM - 50.
     & D0/27.D0*Hr2(0,1)*x*rnf*Pi**2*LM - 64.D0/27.D0*Hr2(0,1)*x*rnf**2
     & *LM - 64.D0/27.D0*Hr2(0,1)*x*rnf**2*LR - 5632.D0/27.D0*Hr3(-1,-1
     & ,-1)*dlx*LM + 3584.D0/27.D0*Hr3(-1,-1,-1)*x*dlx*LM + 512.D0/27.D0
     & *Hr3(-1,0,-1)*x**(-1)*LM - 400.D0/27.D0*Hr3(-1,0,-1)*x**(-1)*rnf
     & *LM - 4544.D0/27.D0*Hr3(-1,0,-1)*LM + 1024.D0/27.D0*Hr3(-1,0,-1)
     & *LM**2 + 704.D0/3.D0*Hr3(-1,0,-1)*LR - 1792.D0/27.D0*Hr3(-1,0,-1
     & )*dlx*LM + 76.D0/3.D0*Hr3(-1,0,-1)*rnf*LM - 128.D0/9.D0*Hr3(-1,0
     & ,-1)*rnf*LR + 4672.D0/27.D0*Hr3(-1,0,-1)*x*LM - 1024.D0/27.D0*
     & Hr3(-1,0,-1)*x*LM**2 - 704.D0/9.D0*Hr3(-1,0,-1)*x*LR + 1280.D0/
     & 27.D0*Hr3(-1,0,-1)*x*dlx*LM + 172.D0/27.D0*Hr3(-1,0,-1)*x*rnf*LM
     &  + 128.D0/27.D0*Hr3(-1,0,-1)*x*rnf*LR
      c3q_valence = c3q_valence + 512.D0/27.D0*Hr3(-1,0,-1)*x**2*LM - 400.D0
     & /27.D0*Hr3(-1,0,-1)*x**2*rnf*LM + 512.D0/27.D0*Hr3(-1,0,1)*
     & x**(-1)*LM - 400.D0/27.D0*Hr3(-1,0,1)*x**(-1)*rnf*LM - 2176.D0/
     & 27.D0*Hr3(-1,0,1)*LM + 512.D0/27.D0*Hr3(-1,0,1)*LM**2 + 704.D0/9.
     & D0*Hr3(-1,0,1)*LR - 512.D0/9.D0*Hr3(-1,0,1)*dlx*LM - 200.D0/9.D0
     & *Hr3(-1,0,1)*rnf*LM - 128.D0/27.D0*Hr3(-1,0,1)*rnf*LR - 640.D0/
     & 27.D0*Hr3(-1,0,1)*x*LM - 512.D0/27.D0*Hr3(-1,0,1)*x*LM**2 - 704.D
     & 0/9.D0*Hr3(-1,0,1)*x*LR + 512.D0/9.D0*Hr3(-1,0,1)*x*dlx*LM - 200.
     & D0/9.D0*Hr3(-1,0,1)*x*rnf*LM + 128.D0/27.D0*Hr3(-1,0,1)*x*rnf*LR
     &  + 512.D0/27.D0*Hr3(-1,0,1)*x**2*LM - 400.D0/27.D0*Hr3(-1,0,1)*
     & x**2*rnf*LM + 512.D0/27.D0*Hr3(0,-1,-1)*x**(-1)*LM - 400.D0/27.D0
     & *Hr3(0,-1,-1)*x**(-1)*rnf*LM - 4544.D0/27.D0*Hr3(0,-1,-1)*LM + 
     & 1024.D0/27.D0*Hr3(0,-1,-1)*LM**2 + 704.D0/3.D0*Hr3(0,-1,-1)*LR
     &  - 1856.D0/27.D0*Hr3(0,-1,-1)*dlx*LM + 76.D0/3.D0*Hr3(0,-1,-1)*
     & rnf*LM - 128.D0/9.D0*Hr3(0,-1,-1)*rnf*LR - 200.D0/9.D0*Hr3(0,-1,
     & -1)*rnf*dlx*LM
      c3q_valence = c3q_valence + 4672.D0/27.D0*Hr3(0,-1,-1)*x*LM - 1024.D0/
     & 27.D0*Hr3(0,-1,-1)*x*LM**2 - 704.D0/9.D0*Hr3(0,-1,-1)*x*LR + 448.
     & D0/9.D0*Hr3(0,-1,-1)*x*dlx*LM + 172.D0/27.D0*Hr3(0,-1,-1)*x*rnf*
     & LM + 128.D0/27.D0*Hr3(0,-1,-1)*x*rnf*LR + 200.D0/9.D0*Hr3(0,-1,
     & -1)*x*rnf*dlx*LM + 512.D0/27.D0*Hr3(0,-1,-1)*x**2*LM - 400.D0/27.
     & D0*Hr3(0,-1,-1)*x**2*rnf*LM + 3200.D0/27.D0*Hr3(0,-1,1)*dlx*LM
     &  - 6400.D0/27.D0*Hr3(0,-1,1)*dd0*dlx*LM + 3200.D0/27.D0*Hr3(0,-1
     & ,1)*x*dlx*LM + 512.D0/27.D0*Hr3(0,0,-1)*x**(-1)*LM - 400.D0/27.D0
     & *Hr3(0,0,-1)*x**(-1)*rnf*LM + 5600.D0/9.D0*Hr3(0,0,-1)*LM - 256.D
     & 0/9.D0*Hr3(0,0,-1)*LM**2 + 704.D0/3.D0*Hr3(0,0,-1)*LR - 6400.D0/
     & 27.D0*Hr3(0,0,-1)*dlx1*LM + 1888.D0/9.D0*Hr3(0,0,-1)*dlx*LM + 
     & 12800.D0/27.D0*Hr3(0,0,-1)*dd1*LM - 256*Hr3(0,0,-1)*dd0*LM - 
     & 1408.D0/3.D0*Hr3(0,0,-1)*dd0*LR - 640.D0/27.D0*Hr3(0,0,-1)*dd0*
     & dlx*LM - 1066.D0/27.D0*Hr3(0,0,-1)*rnf*LM - 128.D0/9.D0*Hr3(0,0,
     & -1)*rnf*LR - 100.D0/9.D0*Hr3(0,0,-1)*rnf*dlx*LM + 256.D0/9.D0*
     & Hr3(0,0,-1)*rnf*dd0*LM
      c3q_valence = c3q_valence + 256.D0/9.D0*Hr3(0,0,-1)*rnf*dd0*LR - 
     & 11360.D0/27.D0*Hr3(0,0,-1)*x*LM + 256.D0/9.D0*Hr3(0,0,-1)*x*
     & LM**2 + 1408.D0/9.D0*Hr3(0,0,-1)*x*LR - 6400.D0/27.D0*Hr3(0,0,-1
     & )*x*dlx1*LM - 1504.D0/9.D0*Hr3(0,0,-1)*x*dlx*LM - 730.D0/27.D0*
     & Hr3(0,0,-1)*x*rnf*LM - 256.D0/27.D0*Hr3(0,0,-1)*x*rnf*LR + 100.D0
     & /9.D0*Hr3(0,0,-1)*x*rnf*dlx*LM - 512.D0/27.D0*Hr3(0,0,-1)*x**2*
     & LM + 400.D0/27.D0*Hr3(0,0,-1)*x**2*rnf*LM - 6944.D0/27.D0*Hr3(0,
     & 0,1)*LM - 3584.D0/27.D0*Hr3(0,0,1)*LM**2 - 5984.D0/9.D0*Hr3(0,0,
     & 1)*LR + 1792.D0/27.D0*Hr3(0,0,1)*dlx1*LM - 928.D0/27.D0*Hr3(0,0,
     & 1)*dlx*LM - 2560.D0/27.D0*Hr3(0,0,1)*dd1*LM + 2048.D0/3.D0*Hr3(0
     & ,0,1)*dd0*LM + 1024.D0/9.D0*Hr3(0,0,1)*dd0*LM**2 + 3520.D0/3.D0*
     & Hr3(0,0,1)*dd0*LR + 7552.D0/27.D0*Hr3(0,0,1)*dd0*dlx*LM + 938.D0/
     & 27.D0*Hr3(0,0,1)*rnf*LM + 1088.D0/27.D0*Hr3(0,0,1)*rnf*LR + 100.D
     & 0/9.D0*Hr3(0,0,1)*rnf*dlx*LM - 1792.D0/27.D0*Hr3(0,0,1)*rnf*dd0*
     & LM - 640.D0/9.D0*Hr3(0,0,1)*rnf*dd0*LR - 7648.D0/27.D0*Hr3(0,0,1
     & )*x*LM
      c3q_valence = c3q_valence - 1024.D0/9.D0*Hr3(0,0,1)*x*LM**2 - 4576.D0/
     & 9.D0*Hr3(0,0,1)*x*LR + 256.D0/9.D0*Hr3(0,0,1)*x*dlx1*LM - 2464.D0
     & /27.D0*Hr3(0,0,1)*x*dlx*LM + 170.D0/9.D0*Hr3(0,0,1)*x*rnf*LM + 
     & 832.D0/27.D0*Hr3(0,0,1)*x*rnf*LR + 100.D0/9.D0*Hr3(0,0,1)*x*rnf*
     & dlx*LM + 512.D0/27.D0*Hr3(0,0,1)*x**2*LM - 400.D0/27.D0*Hr3(0,0,
     & 1)*x**2*rnf*LM + 3200.D0/27.D0*Hr3(0,1,-1)*dlx*LM - 6400.D0/27.D0
     & *Hr3(0,1,-1)*dd0*dlx*LM + 3200.D0/27.D0*Hr3(0,1,-1)*x*dlx*LM - 
     & 544.D0/27.D0*Hr3(0,1,1)*LM + 2560.D0/27.D0*Hr3(0,1,1)*LM**2 + 
     & 3872.D0/9.D0*Hr3(0,1,1)*LR - 1280.D0/9.D0*Hr3(0,1,1)*dlx1*LM + 
     & 2432.D0/27.D0*Hr3(0,1,1)*dlx*LM + 2560.D0/9.D0*Hr3(0,1,1)*dd1*LM
     &  - 960*Hr3(0,1,1)*dd0*LM - 3520.D0/3.D0*Hr3(0,1,1)*dd0*LR - 
     & 17408.D0/27.D0*Hr3(0,1,1)*dd0*dlx*LM - 64.D0/3.D0*Hr3(0,1,1)*rnf
     & *LM - 704.D0/27.D0*Hr3(0,1,1)*rnf*LR + 640.D0/9.D0*Hr3(0,1,1)*
     & rnf*dd0*LM + 640.D0/9.D0*Hr3(0,1,1)*rnf*dd0*LR - 32.D0/27.D0*
     & Hr3(0,1,1)*x*LM + 2560.D0/27.D0*Hr3(0,1,1)*x*LM**2 + 3872.D0/9.D0
     & *Hr3(0,1,1)*x*LR
      c3q_valence = c3q_valence - 1280.D0/9.D0*Hr3(0,1,1)*x*dlx1*LM + 2944.D
     & 0/27.D0*Hr3(0,1,1)*x*dlx*LM - 64.D0/3.D0*Hr3(0,1,1)*x*rnf*LM - 
     & 704.D0/27.D0*Hr3(0,1,1)*x*rnf*LR + 5632.D0/27.D0*Hr4(-1,-1,0,-1)
     & *LM - 3584.D0/27.D0*Hr4(-1,-1,0,-1)*x*LM + 512.D0/27.D0*Hr4(-1,
     & -1,0,1)*LM + 512.D0/27.D0*Hr4(-1,-1,0,1)*x*LM + 5632.D0/27.D0*
     & Hr4(-1,0,-1,-1)*LM - 3584.D0/27.D0*Hr4(-1,0,-1,-1)*x*LM - 2560.D0
     & /27.D0*Hr4(-1,0,0,-1)*LM + 2048.D0/27.D0*Hr4(-1,0,0,-1)*x*LM + 
     & 512.D0/27.D0*Hr4(-1,0,0,1)*LM - 1024.D0/27.D0*Hr4(-1,0,0,1)*x*LM
     &  - 512.D0/9.D0*Hr4(-1,0,1,1)*LM + 512.D0/9.D0*Hr4(-1,0,1,1)*x*LM
     &  + 5632.D0/27.D0*Hr4(0,-1,-1,-1)*LM - 3584.D0/27.D0*Hr4(0,-1,-1,
     & -1)*x*LM - 832.D0/9.D0*Hr4(0,-1,0,-1)*LM + 200.D0/9.D0*Hr4(0,-1,
     & 0,-1)*rnf*LM + 1984.D0/27.D0*Hr4(0,-1,0,-1)*x*LM - 200.D0/9.D0*
     & Hr4(0,-1,0,-1)*x*rnf*LM - 5504.D0/27.D0*Hr4(0,-1,0,1)*LM + 1280.D
     & 0/9.D0*Hr4(0,-1,0,1)*dd0*LM + 128.D0/3.D0*Hr4(0,-1,0,1)*x*LM - 
     & 2432.D0/27.D0*Hr4(0,0,-1,-1)*LM + 400.D0/9.D0*Hr4(0,0,-1,-1)*rnf
     & *LM
      c3q_valence = c3q_valence + 640.D0/9.D0*Hr4(0,0,-1,-1)*x*LM - 400.D0/
     & 9.D0*Hr4(0,0,-1,-1)*x*rnf*LM - 6400.D0/27.D0*Hr4(0,0,-1,1)*LM + 
     & 12800.D0/27.D0*Hr4(0,0,-1,1)*dd0*LM - 6400.D0/27.D0*Hr4(0,0,-1,1
     & )*x*LM - 640.D0/27.D0*Hr4(0,0,0,-1)*LM - 1280.D0/9.D0*Hr4(0,0,0,
     & -1)*dd0*LM + 1408.D0/9.D0*Hr4(0,0,0,-1)*x*LM + 512.D0/3.D0*Hr4(0
     & ,0,0,1)*LM - 4864.D0/9.D0*Hr4(0,0,0,1)*dd0*LM + 6400.D0/27.D0*
     & Hr4(0,0,0,1)*x*LM - 6400.D0/27.D0*Hr4(0,0,1,-1)*LM + 12800.D0/27.
     & D0*Hr4(0,0,1,-1)*dd0*LM - 6400.D0/27.D0*Hr4(0,0,1,-1)*x*LM + 
     & 9472.D0/27.D0*Hr4(0,0,1,1)*LM - 11264.D0/27.D0*Hr4(0,0,1,1)*dd0*
     & LM + 6400.D0/27.D0*Hr4(0,0,1,1)*x*LM - 3200.D0/27.D0*Hr4(0,1,0,
     & -1)*LM + 6400.D0/27.D0*Hr4(0,1,0,-1)*dd0*LM - 3200.D0/27.D0*Hr4(
     & 0,1,0,-1)*x*LM + 5120.D0/27.D0*Hr4(0,1,0,1)*LM - 4096.D0/9.D0*
     & Hr4(0,1,0,1)*dd0*LM + 512.D0/3.D0*Hr4(0,1,0,1)*x*LM - 2048.D0/9.D
     & 0*Hr4(0,1,1,1)*LM - 2048.D0/9.D0*Hr4(0,1,1,1)*x*LM - 736.D0/9.D0
     & /(1 + x)*dlx*LM + 704.D0/9.D0/(1 + x)*dlx*LR - 608.D0/9.D0/(1 + 
     & x)*dlx**2*LM
      c3q_valence = c3q_valence + 112.D0/9.D0/(1 + x)*dlx**2*LM**2 + 352.D0/
     & 9.D0/(1 + x)*dlx**2*LR*LM - 800.D0/27.D0/(1 + x)*dlx**3*LM + 256.
     & D0/81.D0/(1 + x)*dlx**3*LM**2 + 176.D0/9.D0/(1 + x)*dlx**3*LR - 
     & 208.D0/81.D0/(1 + x)*dlx**4*LM + 1952.D0/81.D0/(1 + x)*Pi**2*LM
     &  - 112.D0/27.D0/(1 + x)*Pi**2*LM**2 - 352.D0/27.D0/(1 + x)*Pi**2
     & *LR*LM + 448.D0/27.D0/(1 + x)*Pi**2*dlx*LM - 512.D0/81.D0/(1 + x
     & )*Pi**2*dlx*LM**2 - 352.D0/27.D0/(1 + x)*Pi**2*dlx*LR + 608.D0/
     & 81.D0/(1 + x)*Pi**2*dlx**2*LM - 928.D0/405.D0/(1 + x)*Pi**4*LM
     &  + 128.D0/27.D0/(1 + x)*rnf*dlx*LM - 128.D0/27.D0/(1 + x)*rnf*
     & dlx*LR + 320.D0/81.D0/(1 + x)*rnf*dlx**2*LM - 32.D0/27.D0/(1 + x
     & )*rnf*dlx**2*LM**2 - 64.D0/27.D0/(1 + x)*rnf*dlx**2*LR*LM + 160.D
     & 0/81.D0/(1 + x)*rnf*dlx**3*LM - 32.D0/27.D0/(1 + x)*rnf*dlx**3*
     & LR - 320.D0/243.D0/(1 + x)*rnf*Pi**2*LM + 32.D0/81.D0/(1 + x)*
     & rnf*Pi**2*LM**2 + 64.D0/81.D0/(1 + x)*rnf*Pi**2*LR*LM - 32.D0/81.
     & D0/(1 + x)*rnf*Pi**2*dlx*LM + 64.D0/81.D0/(1 + x)*rnf*Pi**2*dlx*
     & LR
      c3q_valence = c3q_valence + 1792.D0/9.D0/(1 + x)*Zeta3*LM - 1792.D0/
     & 27.D0/(1 + x)*Zeta3*LM**2 - 2464.D0/9.D0/(1 + x)*Zeta3*LR + 2560.
     & D0/27.D0/(1 + x)*Zeta3*dlx*LM - 256.D0/27.D0/(1 + x)*Zeta3*rnf*
     & LM + 448.D0/27.D0/(1 + x)*Zeta3*rnf*LR + 6784.D0/27.D0/(1 + x)*
     & Hr1(-1)*dlx*LM - 448.D0/9.D0/(1 + x)*Hr1(-1)*dlx*LM**2 - 1408.D0/
     & 9.D0/(1 + x)*Hr1(-1)*dlx*LR*LM + 1856.D0/9.D0/(1 + x)*Hr1(-1)*
     & dlx**2*LM - 256.D0/9.D0/(1 + x)*Hr1(-1)*dlx**2*LM**2 - 1760.D0/9.
     & D0/(1 + x)*Hr1(-1)*dlx**2*LR + 3520.D0/81.D0/(1 + x)*Hr1(-1)*
     & dlx**3*LM - 320.D0/9.D0/(1 + x)*Hr1(-1)*Pi**2*LM + 1024.D0/81.D0
     & /(1 + x)*Hr1(-1)*Pi**2*LM**2 + 1408.D0/27.D0/(1 + x)*Hr1(-1)*
     & Pi**2*LR - 2624.D0/81.D0/(1 + x)*Hr1(-1)*Pi**2*dlx*LM - 1280.D0/
     & 81.D0/(1 + x)*Hr1(-1)*rnf*dlx*LM + 128.D0/27.D0/(1 + x)*Hr1(-1)*
     & rnf*dlx*LM**2 + 256.D0/27.D0/(1 + x)*Hr1(-1)*rnf*dlx*LR*LM - 128.
     & D0/9.D0/(1 + x)*Hr1(-1)*rnf*dlx**2*LM + 320.D0/27.D0/(1 + x)*
     & Hr1(-1)*rnf*dlx**2*LR + 128.D0/81.D0/(1 + x)*Hr1(-1)*rnf*Pi**2*
     & LM
      c3q_valence = c3q_valence - 256.D0/81.D0/(1 + x)*Hr1(-1)*rnf*Pi**2*LR
     &  - 2048.D0/9.D0/(1 + x)*Hr1(-1)*Zeta3*LM - 2816.D0/9.D0/(1 + x)*
     & Hr2(-1,-1)*dlx*LM + 2048.D0/27.D0/(1 + x)*Hr2(-1,-1)*dlx*LM**2
     &  + 2816.D0/9.D0/(1 + x)*Hr2(-1,-1)*dlx*LR - 1792.D0/9.D0/(1 + x)
     & *Hr2(-1,-1)*dlx**2*LM + 256.D0/9.D0/(1 + x)*Hr2(-1,-1)*Pi**2*LM
     &  + 512.D0/27.D0/(1 + x)*Hr2(-1,-1)*rnf*dlx*LM - 512.D0/27.D0/(1
     &  + x)*Hr2(-1,-1)*rnf*dlx*LR - 6784.D0/27.D0/(1 + x)*Hr2(0,-1)*LM
     &  + 448.D0/9.D0/(1 + x)*Hr2(0,-1)*LM**2 + 1408.D0/9.D0/(1 + x)*
     & Hr2(0,-1)*LR*LM - 1280.D0/9.D0/(1 + x)*Hr2(0,-1)*dlx*LM + 512.D0/
     & 27.D0/(1 + x)*Hr2(0,-1)*dlx*LM**2 + 1408.D0/9.D0/(1 + x)*Hr2(0,
     & -1)*dlx*LR + 320.D0/27.D0/(1 + x)*Hr2(0,-1)*dlx**2*LM - 64.D0/81.
     & D0/(1 + x)*Hr2(0,-1)*Pi**2*LM + 1280.D0/81.D0/(1 + x)*Hr2(0,-1)*
     & rnf*LM - 128.D0/27.D0/(1 + x)*Hr2(0,-1)*rnf*LM**2 - 256.D0/27.D0
     & /(1 + x)*Hr2(0,-1)*rnf*LR*LM + 256.D0/27.D0/(1 + x)*Hr2(0,-1)*
     & rnf*dlx*LM - 256.D0/27.D0/(1 + x)*Hr2(0,-1)*rnf*dlx*LR - 512.D0/
     & 27.D0/(1 + x)*Hr2(0,1)*LM
      c3q_valence = c3q_valence + 1024.D0/3.D0/(1 + x)*Hr3(-1,-1,-1)*dlx*LM
     &  + 2816.D0/9.D0/(1 + x)*Hr3(-1,0,-1)*LM - 2048.D0/27.D0/(1 + x)*
     & Hr3(-1,0,-1)*LM**2 - 2816.D0/9.D0/(1 + x)*Hr3(-1,0,-1)*LR + 1024.
     & D0/9.D0/(1 + x)*Hr3(-1,0,-1)*dlx*LM - 512.D0/27.D0/(1 + x)*Hr3(
     & -1,0,-1)*rnf*LM + 512.D0/27.D0/(1 + x)*Hr3(-1,0,-1)*rnf*LR + 512.
     & D0/9.D0/(1 + x)*Hr3(-1,0,1)*LM - 1024.D0/27.D0/(1 + x)*Hr3(-1,0,
     & 1)*LM**2 - 1408.D0/9.D0/(1 + x)*Hr3(-1,0,1)*LR + 1024.D0/9.D0/(1
     &  + x)*Hr3(-1,0,1)*dlx*LM + 256.D0/27.D0/(1 + x)*Hr3(-1,0,1)*rnf*
     & LR + 2816.D0/9.D0/(1 + x)*Hr3(0,-1,-1)*LM - 2048.D0/27.D0/(1 + x
     & )*Hr3(0,-1,-1)*LM**2 - 2816.D0/9.D0/(1 + x)*Hr3(0,-1,-1)*LR + 
     & 1024.D0/9.D0/(1 + x)*Hr3(0,-1,-1)*dlx*LM - 512.D0/27.D0/(1 + x)*
     & Hr3(0,-1,-1)*rnf*LM + 512.D0/27.D0/(1 + x)*Hr3(0,-1,-1)*rnf*LR
     &  - 128/(1 + x)*Hr3(0,0,-1)*LM + 512.D0/27.D0/(1 + x)*Hr3(0,0,-1)
     & *LM**2 + 704.D0/9.D0/(1 + x)*Hr3(0,0,-1)*LR - 1792.D0/9.D0/(1 + 
     & x)*Hr3(0,0,-1)*dlx*LM + 256.D0/27.D0/(1 + x)*Hr3(0,0,-1)*rnf*LM
     &  - 128.D0/27.D0/(1 + x)*Hr3(0,0,-1)*rnf*LR
      c3q_valence = c3q_valence - 256.D0/9.D0/(1 + x)*Hr3(0,0,1)*LM + 512.D0
     & /27.D0/(1 + x)*Hr3(0,0,1)*LM**2 + 704.D0/9.D0/(1 + x)*Hr3(0,0,1)
     & *LR - 512.D0/9.D0/(1 + x)*Hr3(0,0,1)*dlx*LM - 128.D0/27.D0/(1 + 
     & x)*Hr3(0,0,1)*rnf*LR - 1024.D0/3.D0/(1 + x)*Hr4(-1,-1,0,-1)*LM
     &  - 1024.D0/3.D0/(1 + x)*Hr4(-1,0,-1,-1)*LM + 512.D0/3.D0/(1 + x)
     & *Hr4(-1,0,0,-1)*LM - 512.D0/9.D0/(1 + x)*Hr4(-1,0,0,1)*LM + 1024.
     & D0/9.D0/(1 + x)*Hr4(-1,0,1,1)*LM - 1024.D0/3.D0/(1 + x)*Hr4(0,-1
     & ,-1,-1)*LM + 512.D0/3.D0/(1 + x)*Hr4(0,-1,0,-1)*LM - 512.D0/9.D0
     & /(1 + x)*Hr4(0,-1,0,1)*LM + 512.D0/3.D0/(1 + x)*Hr4(0,0,-1,-1)*
     & LM + 7168.D0/27.D0/(1 + x)*Hr4(0,0,0,-1)*LM + 2048.D0/27.D0/(1
     &  + x)*Hr4(0,0,0,1)*LM - 512.D0/9.D0/(1 + x)*Hr4(0,0,1,1)*LM 
      c3q_valence = c3q_valence + c3q_valence_av(iorder,x,ireg,.false.) 
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             c3q_valence =  0 
         elseif (iorder.eq.1) then 
             c3q_valence =  + LM * ( 16.D0/3.D0*dd0 )
             c3q_valence = c3q_valence + 16.D0/3.D0*dd1 - 4*dd0 
         elseif (iorder.eq.2) then 
             c3q_valence =  + LM * ( 128.D0/3.D0*dd2 - 80*dd1 + 748.D0/9.D
     &    0*dd0 - 400.D0/27.D0*Pi**2*dd0 )
      c3q_valence = c3q_valence + LM**2 * ( 256.D0/9.D0*dd1 - 8*dd0 )
      c3q_valence = c3q_valence + LR * (  - 176.D0/3.D0*dd1 + 44*dd0 )
      c3q_valence = c3q_valence + LR*LM * (  - 176.D0/3.D0*dd0 )
      c3q_valence = c3q_valence + rnf * ( 16.D0/9.D0*dd2 - 232.D0/27.D0*dd1
     &     + 988.D0/81.D0*dd0 - 16.D0/27.D0*Pi**2*dd0 )
      c3q_valence = c3q_valence + rnf*LM * ( 32.D0/9.D0*dd1 - 232.D0/27.D0*
     &    dd0 )
      c3q_valence = c3q_valence + rnf*LM**2 * ( 16.D0/9.D0*dd0 )
      c3q_valence = c3q_valence + rnf*LR * ( 32.D0/9.D0*dd1 - 8.D0/3.D0*dd0
     &     )
      c3q_valence = c3q_valence + rnf*LR*LM * ( 32.D0/9.D0*dd0 )
      c3q_valence = c3q_valence + 128.D0/9.D0*dd3 - 184.D0/3.D0*dd2 + 1036.D
     &    0/9.D0*dd1 - 5086.D0/27.D0*dd0 - 400.D0/27.D0*Pi**2*dd1 + 184.
     &     D0/9.D0*Pi**2*dd0 + 1312.D0/9.D0*Zeta3*dd0
         elseif (iorder.eq.3) then 
             c3q_valence = 2560.D0/27.D0*dd4*LM - 18688.D0/27.D0*dd3*LM
     &  + 4096.D0/27.D0*dd3*LM**2 - 2816.D0/9.D0*dd3*LR + 26800.D0/9.D0
     & *dd2*LM - 704*dd2*LM**2 + 2048.D0/27.D0*dd2*LM**3 + 4048.D0/3.D0
     & *dd2*LR - 2816.D0/3.D0*dd2*LR*LM - 445784.D0/81.D0*dd1*LM + 
     & 48560.D0/27.D0*dd1*LM**2 - 1792.D0/9.D0*dd1*LM**3 - 27688.D0/9.D0
     & *dd1*LR + 1760*dd1*LR*LM - 5632.D0/9.D0*dd1*LR*LM**2 + 1936.D0/3.
     & D0*dd1*LR**2 + 82252.D0/27.D0*dd0*LM - 4348.D0/9.D0*dd0*LM**2 + 
     & 208.D0/9.D0*dd0*LM**3 + 122908.D0/27.D0*dd0*LR - 21352.D0/9.D0*
     & dd0*LR*LM + 176*dd0*LR*LM**2 - 484*dd0*LR**2 + 1936.D0/3.D0*dd0*
     & LR**2*LM - 1792.D0/9.D0*Pi**2*dd2*LM + 18080.D0/27.D0*Pi**2*dd1*
     & LM - 11776.D0/81.D0*Pi**2*dd1*LM**2 + 8800.D0/27.D0*Pi**2*dd1*LR
     &  - 28880.D0/27.D0*Pi**2*dd0*LM + 5872.D0/27.D0*Pi**2*dd0*LM**2
     &  - 1024.D0/81.D0*Pi**2*dd0*LM**3 - 4048.D0/9.D0*Pi**2*dd0*LR + 
     & 8800.D0/27.D0*Pi**2*dd0*LR*LM + 47776.D0/1215.D0*Pi**4*dd0*LM + 
     & 2560.D0/81.D0*rnf*dd3*LM + 512.D0/27.D0*rnf*dd3*LR - 6208.D0/27.D
     & 0*rnf*dd2*LM
      c3q_valence = c3q_valence + 128.D0/3.D0*rnf*dd2*LM**2 - 1088.D0/9.D0*
     & rnf*dd2*LR + 512.D0/9.D0*rnf*dd2*LR*LM + 133856.D0/243.D0*rnf*
     & dd1*LM - 13184.D0/81.D0*rnf*dd1*LM**2 + 512.D0/27.D0*rnf*dd1*
     & LM**3 + 11072.D0/27.D0*rnf*dd1*LR - 1664.D0/9.D0*rnf*dd1*LR*LM
     &  + 1024.D0/27.D0*rnf*dd1*LR*LM**2 - 704.D0/9.D0*rnf*dd1*LR**2 - 
     & 14776.D0/27.D0*rnf*dd0*LM + 3536.D0/27.D0*rnf*dd0*LM**2 - 320.D0/
     & 27.D0*rnf*dd0*LM**3 - 46184.D0/81.D0*rnf*dd0*LR + 9920.D0/27.D0*
     & rnf*dd0*LR*LM - 448.D0/9.D0*rnf*dd0*LR*LM**2 + 176.D0/3.D0*rnf*
     & dd0*LR**2 - 704.D0/9.D0*rnf*dd0*LR**2*LM - 2624.D0/81.D0*rnf*
     & Pi**2*dd1*LM - 1600.D0/81.D0*rnf*Pi**2*dd1*LR + 256.D0/3.D0*rnf*
     & Pi**2*dd0*LM - 1312.D0/81.D0*rnf*Pi**2*dd0*LM**2 + 1088.D0/27.D0
     & *rnf*Pi**2*dd0*LR - 1600.D0/81.D0*rnf*Pi**2*dd0*LR*LM + 64.D0/27.
     & D0*rnf**2*dd2*LM + 64.D0/27.D0*rnf**2*dd2*LR - 928.D0/81.D0*
     & rnf**2*dd1*LM + 64.D0/27.D0*rnf**2*dd1*LM**2 - 928.D0/81.D0*
     & rnf**2*dd1*LR + 128.D0/27.D0*rnf**2*dd1*LR*LM + 64.D0/27.D0*
     & rnf**2*dd1*LR**2
      c3q_valence = c3q_valence + 3760.D0/243.D0*rnf**2*dd0*LM - 464.D0/81.D
     & 0*rnf**2*dd0*LM**2 + 64.D0/81.D0*rnf**2*dd0*LM**3 + 3952.D0/243.D
     & 0*rnf**2*dd0*LR - 928.D0/81.D0*rnf**2*dd0*LR*LM + 64.D0/27.D0*
     & rnf**2*dd0*LR*LM**2 - 16.D0/9.D0*rnf**2*dd0*LR**2 + 64.D0/27.D0*
     & rnf**2*dd0*LR**2*LM - 64.D0/81.D0*rnf**2*Pi**2*dd0*LM - 64.D0/81.
     & D0*rnf**2*Pi**2*dd0*LR + 53504.D0/27.D0*Zeta3*dd1*LM - 23840.D0/
     & 9.D0*Zeta3*dd0*LM + 7424.D0/27.D0*Zeta3*dd0*LM**2 - 28864.D0/9.D0
     & *Zeta3*dd0*LR + 3520.D0/27.D0*Zeta3*rnf*dd0*LM + 5248.D0/27.D0*
     & Zeta3*rnf*dd0*LR 
             c3q_valence = c3q_valence + c3q_valence_av(iorder,x,ireg,.false.) 
         endif 
      endif      
      return     
      end function c3q_valence  
