!>***************************************************
!> Exact DIS coefficient funtion cLg_new in x space
!> including scale dependence
!>
      function cLg_new(iorder,x,ireg,rmu2,fmu2,q2,flavchange)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      implicit none
      integer iorder,ireg,flavchange
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
      common /Hrs/ Hr1,Hr2,Hr3,Hr4,Hr5
!$omp threadprivate(/Hrs/)
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR
      real*8 cLg_new,x


      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             cLg_new =  0 
         elseif (iorder.eq.1) then 
             cLg_new =  0 
         elseif (iorder.eq.2) then 
             cLg_new =  0 
         elseif (iorder.eq.3) then 
             cLg_new =  0 
             cLg_new = cLg_new + cLg_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.1) then      
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             cLg_new =  0 
         elseif (iorder.eq.1) then 
             cLg_new =  + 8*x - 8*x**2 
         elseif (iorder.eq.2) then 
             cLg_new =  + LM * (  - 112.D0/3.D0 + 16*x**(-1) - 688.D0/3.
     &    D0*x + 96*x*dlx1 - 512.D0/3.D0*x*dlx + 752.D0/3.D0*x**2 - 96*
     &    x**2*dlx1 )
      cLg_new = cLg_new + LR * (  - 88*x + 88*x**2 )
      cLg_new = cLg_new + rnf*LR * ( 16.D0/3.D0*x - 16.D0/3.D0*x**2 )
      cLg_new = cLg_new + 208.D0/45.D0 - 112.D0/45.D0*x**(-1) + 16*
     &    x**(-1)*dlx1 - 128.D0/45.D0*x**(-1)*dlx - 112.D0/3.D0*dlx1 + 
     &    1744.D0/45.D0*dlx + 2864.D0/15.D0*x - 400*x*dlx1 + 48*x*
     &    dlx1**2 + 4928.D0/15.D0*x*dlx - 96*x*dlx*dlx1 + 1168.D0/9.D0*
     &    x*dlx**2 - 832.D0/27.D0*x*Pi**2 - 2896.D0/15.D0*x**2 + 1264.D0
     &    /3.D0*x**2*dlx1 - 48*x**2*dlx1**2 - 2992.D0/5.D0*x**2*dlx + 
     &    96*x**2*dlx*dlx1 + 16*x**2*Pi**2 - 128.D0/15.D0*x**3*dlx**2
     &     + 128.D0/45.D0*x**3*Pi**2 + 128.D0/45.D0*Hr1(-1)*x**(-2)*dlx
     &     + 736.D0/9.D0*Hr1(-1)*x*dlx + 96*Hr1(-1)*x**2*dlx + 256.D0/
     &    15.D0*Hr1(-1)*x**3*dlx - 128.D0/45.D0*Hr2(0,-1)*x**(-2) - 736.
     &    D0/9.D0*Hr2(0,-1)*x - 96*Hr2(0,-1)*x**2 - 256.D0/15.D0*Hr2(0,
     &    -1)*x**3 + 512.D0/3.D0*Hr2(0,1)*x 
         elseif (iorder.eq.3) then 
             cLg_new =  - 128.D0/45.D0*x**(-2)*Pi**2*dlx1*LM + 22064.D0/
     & 135.D0*x**(-1)*LM - 1496.D0/3.D0*x**(-1)*LM**2 + 2464.D0/45.D0*
     & x**(-1)*LR - 352*x**(-1)*LR*LM - 20528.D0/15.D0*x**(-1)*dlx1*LM
     &  + 192*x**(-1)*dlx1*LM**2 - 352*x**(-1)*dlx1*LR + 288*x**(-1)*
     & dlx1**2*LM + 12736.D0/135.D0*x**(-1)*dlx*LM - 96*x**(-1)*dlx*
     & LM**2 + 2816.D0/45.D0*x**(-1)*dlx*LR - 576*x**(-1)*dlx*dlx1*LM
     &  + 256.D0/15.D0*x**(-1)*dlx**2*LM - 512.D0/45.D0*x**(-1)*Pi**2*
     & LM - 16592.D0/405.D0*x**(-1)*rnf*LM + 272.D0/27.D0*x**(-1)*rnf*
     & LM**2 - 448.D0/135.D0*x**(-1)*rnf*LR + 64.D0/3.D0*x**(-1)*rnf*LR
     & *LM + 544.D0/27.D0*x**(-1)*rnf*dlx1*LM + 64.D0/3.D0*x**(-1)*rnf*
     & dlx1*LR - 256.D0/135.D0*x**(-1)*rnf*dlx*LM - 512.D0/135.D0*
     & x**(-1)*rnf*dlx*LR + 174112.D0/135.D0*LM + 808.D0/3.D0*LM**2 - 
     & 4576.D0/45.D0*LR + 2464.D0/3.D0*LR*LM + 23632.D0/15.D0*dlx1*LM
     &  - 4352.D0/9.D0*dlx1*LM**2 + 2464.D0/3.D0*dlx1*LR - 6688.D0/9.D0
     & *dlx1**2*LM - 108416.D0/135.D0*dlx*LM - 2144.D0/9.D0*dlx*LM**2
     &  - 38368.D0/45.D0*dlx*LR
      cLg_new = cLg_new + 13376.D0/9.D0*dlx*dlx1*LM + 21056.D0/45.D0*
     & dlx**2*LM - 64.D0/9.D0*dlx**2*dlx1*LM + 3808.D0/45.D0*Pi**2*LM
     &  + 64.D0/27.D0*Pi**2*dlx1*LM - 1632.D0/5.D0*rnf*LM + 304.D0/9.D0
     & *rnf*LM**2 + 832.D0/135.D0*rnf*LR - 448.D0/9.D0*rnf*LR*LM + 608.D
     & 0/9.D0*rnf*dlx1*LM - 448.D0/9.D0*rnf*dlx1*LR - 24832.D0/135.D0*
     & rnf*dlx*LM + 64.D0/3.D0*rnf*dlx*LM**2 + 6976.D0/135.D0*rnf*dlx*
     & LR - 128.D0/3.D0*rnf*dlx**2*LM + 64.D0/9.D0*rnf*Pi**2*LM - 44176.
     & D0/5.D0*x*LM + 7800*x*LM**2 - 75248.D0/15.D0*x*LR + 15136.D0/3.D0
     & *x*LR*LM + 968*x*LR**2 + 1227344.D0/45.D0*x*dlx1*LM - 29840.D0/9.
     & D0*x*dlx1*LM**2 + 8800*x*dlx1*LR - 2112*x*dlx1*LR*LM - 60976.D0/
     & 9.D0*x*dlx1**2*LM + 576*x*dlx1**2*LM**2 - 1056*x*dlx1**2*LR + 
     & 576*x*dlx1**3*LM - 285392.D0/15.D0*x*dlx*LM + 12256.D0/3.D0*x*
     & dlx*LM**2 - 108416.D0/15.D0*x*dlx*LR + 11264.D0/3.D0*x*dlx*LR*LM
     &  + 103520.D0/9.D0*x*dlx*dlx1*LM - 576*x*dlx*dlx1*LM**2 + 2112*x*
     & dlx*dlx1*LR - 1728*x*dlx*dlx1**2*LM - 1050592.D0/135.D0*x*dlx**2
     & *LM
      cLg_new = cLg_new + 9088.D0/9.D0*x*dlx**2*LM**2 - 25696.D0/9.D0*x
     & *dlx**2*LR + 7712.D0/9.D0*x*dlx**2*dlx1*LM - 36352.D0/27.D0*x*
     & dlx**3*LM + 938944.D0/405.D0*x*Pi**2*LM - 9536.D0/27.D0*x*Pi**2*
     & LM**2 + 18304.D0/27.D0*x*Pi**2*LR - 10688.D0/27.D0*x*Pi**2*dlx1*
     & LM + 33728.D0/27.D0*x*Pi**2*dlx*LM + 64.D0/135.D0*x*Pi**4*LM + 
     & 6912.D0/5.D0*x*rnf*LM - 1808.D0/9.D0*x*rnf*LM**2 + 16016.D0/45.D0
     & *x*rnf*LR - 2752.D0/9.D0*x*rnf*LR*LM - 352.D0/3.D0*x*rnf*LR**2
     &  - 5600.D0/9.D0*x*rnf*dlx1*LM + 32*x*rnf*dlx1*LM**2 - 1600.D0/3.D
     & 0*x*rnf*dlx1*LR + 128*x*rnf*dlx1*LR*LM + 32*x*rnf*dlx1**2*LM + 
     & 64*x*rnf*dlx1**2*LR + 110368.D0/135.D0*x*rnf*dlx*LM - 640.D0/9.D0
     & *x*rnf*dlx*LM**2 + 19712.D0/45.D0*x*rnf*dlx*LR - 2048.D0/9.D0*x*
     & rnf*dlx*LR*LM - 64*x*rnf*dlx*dlx1*LM - 128*x*rnf*dlx*dlx1*LR + 
     & 6848.D0/27.D0*x*rnf*dlx**2*LM - 64.D0/3.D0*x*rnf*dlx**2*LM**2 + 
     & 4672.D0/27.D0*x*rnf*dlx**2*LR + 128.D0/3.D0*x*rnf*dlx**3*LM - 
     & 2048.D0/81.D0*x*rnf*Pi**2*LM - 3328.D0/81.D0*x*rnf*Pi**2*LR - 
     & 128.D0/9.D0*x*rnf*Pi**2*dlx*LM
      cLg_new = cLg_new + 32.D0/9.D0*x*rnf**2*LR**2 - 1216.D0/3.D0*x*
     & Zeta3*LM - 512.D0/9.D0*x*Zeta3*dlx*LM - 256.D0/3.D0*x*Zeta3*rnf*
     & LM + 332192.D0/45.D0*x**2*LM - 22712.D0/3.D0*x**2*LM**2 + 75952.D
     & 0/15.D0*x**2*LR - 16544.D0/3.D0*x**2*LR*LM - 968*x**2*LR**2 - 
     & 1236656.D0/45.D0*x**2*dlx1*LM + 32464.D0/9.D0*x**2*dlx1*LM**2 - 
     & 27808.D0/3.D0*x**2*dlx1*LR + 2112*x**2*dlx1*LR*LM + 65072.D0/9.D0
     & *x**2*dlx1**2*LM - 576*x**2*dlx1**2*LM**2 + 1056*x**2*dlx1**2*LR
     &  - 576*x**2*dlx1**3*LM + 1797328.D0/45.D0*x**2*dlx*LM - 4672.D0/
     & 9.D0*x**2*dlx*LM**2 + 65824.D0/5.D0*x**2*dlx*LR - 111712.D0/9.D0
     & *x**2*dlx*dlx1*LM + 576*x**2*dlx*dlx1*LM**2 - 2112*x**2*dlx*dlx1
     & *LR + 1728*x**2*dlx*dlx1**2*LM + 22976.D0/15.D0*x**2*dlx**2*LM
     &  - 7648.D0/9.D0*x**2*dlx**2*dlx1*LM - 279568.D0/135.D0*x**2*
     & Pi**2*LM - 352*x**2*Pi**2*LR + 10240.D0/27.D0*x**2*Pi**2*dlx1*LM
     &  - 411088.D0/405.D0*x**2*rnf*LM + 4240.D0/27.D0*x**2*rnf*LM**2
     &  - 16144.D0/45.D0*x**2*rnf*LR + 3008.D0/9.D0*x**2*rnf*LR*LM + 
     & 352.D0/3.D0*x**2*rnf*LR**2
      cLg_new = cLg_new + 14432.D0/27.D0*x**2*rnf*dlx1*LM - 32*x**2*rnf
     & *dlx1*LM**2 + 5056.D0/9.D0*x**2*rnf*dlx1*LR - 128*x**2*rnf*dlx1*
     & LR*LM - 32*x**2*rnf*dlx1**2*LM - 64*x**2*rnf*dlx1**2*LR - 20032.D
     & 0/45.D0*x**2*rnf*dlx*LM - 256.D0/9.D0*x**2*rnf*dlx*LM**2 - 11968.
     & D0/15.D0*x**2*rnf*dlx*LR + 64*x**2*rnf*dlx*dlx1*LM + 128*x**2*
     & rnf*dlx*dlx1*LR + 256.D0/3.D0*x**2*rnf*dlx**2*LM + 32.D0/27.D0*
     & x**2*rnf*Pi**2*LM + 64.D0/3.D0*x**2*rnf*Pi**2*LR - 32.D0/9.D0*
     & x**2*rnf**2*LR**2 + 8704.D0/45.D0*x**3*dlx**2*LM + 2816.D0/15.D0
     & *x**3*dlx**2*LR + 512.D0/15.D0*x**3*dlx**3*LM - 8704.D0/135.D0*
     & x**3*Pi**2*LM - 2816.D0/45.D0*x**3*Pi**2*LR + 256.D0/15.D0*x**3*
     & Pi**2*dlx1*LM - 1024.D0/15.D0*x**3*Pi**2*dlx*LM - 256.D0/45.D0*
     & x**3*rnf*dlx**2*LM - 512.D0/45.D0*x**3*rnf*dlx**2*LR + 256.D0/
     & 135.D0*x**3*rnf*Pi**2*LM + 512.D0/135.D0*x**3*rnf*Pi**2*LR - 512
     & *x**3*Zeta3*LM - 8704.D0/135.D0*Hr1(-1)*x**(-2)*dlx*LM - 2816.D0/
     & 45.D0*Hr1(-1)*x**(-2)*dlx*LR - 256.D0/15.D0*Hr1(-1)*x**(-2)*
     & dlx**2*LM
      cLg_new = cLg_new + 128.D0/15.D0*Hr1(-1)*x**(-2)*Pi**2*LM + 256.D0
     & /135.D0*Hr1(-1)*x**(-2)*rnf*dlx*LM + 512.D0/135.D0*Hr1(-1)*
     & x**(-2)*rnf*dlx*LR + 5248.D0/15.D0*Hr1(-1)*x**(-1)*dlx*LM + 
     & 46208.D0/45.D0*Hr1(-1)*dlx*LM + 64.D0/9.D0*Hr1(-1)*dlx**2*LM - 
     & 64.D0/27.D0*Hr1(-1)*Pi**2*LM - 832096.D0/135.D0*Hr1(-1)*x*dlx*LM
     &  - 16192.D0/9.D0*Hr1(-1)*x*dlx*LR - 7072.D0/9.D0*Hr1(-1)*x*
     & dlx**2*LM + 9280.D0/27.D0*Hr1(-1)*x*Pi**2*LM + 1472.D0/27.D0*
     & Hr1(-1)*x*rnf*dlx*LM + 2944.D0/27.D0*Hr1(-1)*x*rnf*dlx*LR - 
     & 322336.D0/45.D0*Hr1(-1)*x**2*dlx*LM - 2112*Hr1(-1)*x**2*dlx*LR
     &  - 7904.D0/9.D0*Hr1(-1)*x**2*dlx**2*LM + 10496.D0/27.D0*Hr1(-1)*
     & x**2*Pi**2*LM + 64*Hr1(-1)*x**2*rnf*dlx*LM + 128*Hr1(-1)*x**2*
     & rnf*dlx*LR - 17408.D0/45.D0*Hr1(-1)*x**3*dlx*LM - 5632.D0/15.D0*
     & Hr1(-1)*x**3*dlx*LR - 512.D0/5.D0*Hr1(-1)*x**3*dlx**2*LM + 256.D0
     & /5.D0*Hr1(-1)*x**3*Pi**2*LM + 512.D0/45.D0*Hr1(-1)*x**3*rnf*dlx*
     & LM + 1024.D0/45.D0*Hr1(-1)*x**3*rnf*dlx*LR + 512.D0/15.D0*Hr2(-1
     & ,-1)*x**(-2)*dlx*LM
      cLg_new = cLg_new - 256.D0/9.D0*Hr2(-1,-1)*dlx*LM + 19456.D0/9.D0
     & *Hr2(-1,-1)*x*dlx*LM + 21248.D0/9.D0*Hr2(-1,-1)*x**2*dlx*LM + 
     & 1024.D0/5.D0*Hr2(-1,-1)*x**3*dlx*LM + 8704.D0/135.D0*Hr2(0,-1)*
     & x**(-2)*LM + 2816.D0/45.D0*Hr2(0,-1)*x**(-2)*LR + 512.D0/15.D0*
     & Hr2(0,-1)*x**(-2)*dlx*LM - 256.D0/135.D0*Hr2(0,-1)*x**(-2)*rnf*
     & LM - 512.D0/135.D0*Hr2(0,-1)*x**(-2)*rnf*LR - 5248.D0/15.D0*Hr2(
     & 0,-1)*x**(-1)*LM - 46208.D0/45.D0*Hr2(0,-1)*LM + 128.D0/9.D0*
     & Hr2(0,-1)*dlx*LM + 832096.D0/135.D0*Hr2(0,-1)*x*LM + 16192.D0/9.D
     & 0*Hr2(0,-1)*x*LR - 22208.D0/9.D0*Hr2(0,-1)*x*dlx*LM - 128.D0/9.D0
     & *Hr2(0,-1)*x*dlx**2*LM + 128.D0/27.D0*Hr2(0,-1)*x*Pi**2*LM - 
     & 1472.D0/27.D0*Hr2(0,-1)*x*rnf*LM - 2944.D0/27.D0*Hr2(0,-1)*x*rnf
     & *LR + 322336.D0/45.D0*Hr2(0,-1)*x**2*LM + 2112*Hr2(0,-1)*x**2*LR
     &  + 15296.D0/9.D0*Hr2(0,-1)*x**2*dlx*LM - 64*Hr2(0,-1)*x**2*rnf*
     & LM - 128*Hr2(0,-1)*x**2*rnf*LR + 17408.D0/45.D0*Hr2(0,-1)*x**3*
     & LM + 5632.D0/15.D0*Hr2(0,-1)*x**3*LR - 512.D0/45.D0*Hr2(0,-1)*
     & x**3*rnf*LM
      cLg_new = cLg_new - 1024.D0/45.D0*Hr2(0,-1)*x**3*rnf*LR - 2368.D0/
     & 15.D0*Hr2(0,1)*x**(-1)*LM + 44032.D0/45.D0*Hr2(0,1)*LM - 128.D0/
     & 9.D0*Hr2(0,1)*dlx*LM - 128.D0/3.D0*Hr2(0,1)*rnf*LM - 128576.D0/
     & 15.D0*Hr2(0,1)*x*LM + 13888.D0/9.D0*Hr2(0,1)*x*LM**2 - 11264.D0/
     & 3.D0*Hr2(0,1)*x*LR - 17600.D0/3.D0*Hr2(0,1)*x*dlx*LM + 128.D0/9.D
     & 0*Hr2(0,1)*x*dlx**2*LM - 128.D0/27.D0*Hr2(0,1)*x*Pi**2*LM + 1280.
     & D0/9.D0*Hr2(0,1)*x*rnf*LM + 2048.D0/9.D0*Hr2(0,1)*x*rnf*LR + 64.D
     & 0/5.D0*Hr2(0,1)*x**2*LM + 576*Hr2(0,1)*x**2*LM**2 - 4928.D0/9.D0
     & *Hr2(0,1)*x**2*dlx*LM + 512.D0/9.D0*Hr2(0,1)*x**2*rnf*LM - 512.D0
     & /15.D0*Hr3(-1,0,-1)*x**(-2)*LM + 256.D0/9.D0*Hr3(-1,0,-1)*LM - 
     & 19456.D0/9.D0*Hr3(-1,0,-1)*x*LM - 21248.D0/9.D0*Hr3(-1,0,-1)*
     & x**2*LM - 1024.D0/5.D0*Hr3(-1,0,-1)*x**3*LM - 512.D0/15.D0*Hr3(
     & -1,0,1)*x**(-2)*LM - 2944.D0/3.D0*Hr3(-1,0,1)*x*LM - 1152*Hr3(-1
     & ,0,1)*x**2*LM - 1024.D0/5.D0*Hr3(-1,0,1)*x**3*LM - 512.D0/15.D0*
     & Hr3(0,-1,-1)*x**(-2)*LM + 256.D0/9.D0*Hr3(0,-1,-1)*LM - 19456.D0/
     & 9.D0*Hr3(0,-1,-1)*x*LM
      cLg_new = cLg_new + 512.D0/9.D0*Hr3(0,-1,-1)*x*dlx*LM - 21248.D0/
     & 9.D0*Hr3(0,-1,-1)*x**2*LM - 1024.D0/5.D0*Hr3(0,-1,-1)*x**3*LM - 
     & 512.D0/15.D0*Hr3(0,0,-1)*x**(-2)*LM - 128.D0/3.D0*Hr3(0,0,-1)*LM
     &  + 19520.D0/3.D0*Hr3(0,0,-1)*x*LM + 512.D0/9.D0*Hr3(0,0,-1)*x*
     & dlx*LM - 4928.D0/3.D0*Hr3(0,0,-1)*x**2*LM + 1024.D0/5.D0*Hr3(0,0
     & ,-1)*x**3*LM + 128.D0/9.D0*Hr3(0,0,1)*LM + 17216.D0/9.D0*Hr3(0,0
     & ,1)*x*LM - 512.D0/9.D0*Hr3(0,0,1)*x*dlx*LM + 256.D0/3.D0*Hr3(0,0
     & ,1)*x*rnf*LM - 5440.D0/9.D0*Hr3(0,0,1)*x**2*LM + 1024.D0/5.D0*
     & Hr3(0,0,1)*x**3*LM - 47488.D0/9.D0*Hr3(0,1,1)*x*LM - 1152*Hr3(0,
     & 1,1)*x**2*LM - 512.D0/9.D0*Hr4(0,-1,0,-1)*x*LM - 1024.D0/9.D0*
     & Hr4(0,0,-1,-1)*x*LM - 256.D0/3.D0*Hr4(0,0,0,-1)*x*LM + 256.D0/3.D
     & 0*Hr4(0,0,0,1)*x*LM 
             cLg_new = cLg_new + cLg_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             cLg_new =  0 
         elseif (iorder.eq.1) then 
             cLg_new =  0 
         elseif (iorder.eq.2) then 
             cLg_new =  0 
         elseif (iorder.eq.3) then 
             cLg_new =  0 
             cLg_new = cLg_new + cLg_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      endif      
      return     
      end function cLg_new  
