!>***************************************************
!> Exact DIS coefficient funtion cLq_minus in x space
!> including scale dependence (new version)
!>
      function cLq_minus(iorder,x,ireg,rmu2,fmu2,q2,flavchange)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      use xcdf3p
      implicit none
      integer iorder,ireg,flavchange
      common/Hrs/Hr1,Hr2,Hr3,Hr4,Hr5
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
!$omp threadprivate(/Hrs/)
      logical qexact
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      integer, parameter :: nf  = 5
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR
      real*8 cLq_minus,x


      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      

      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             cLq_minus =  0 
         elseif (iorder.eq.1) then 
             cLq_minus =  0 
         elseif (iorder.eq.2) then 
             cLq_minus =  0 
         elseif (iorder.eq.3) then 
             cLq_minus =  0 
             cLq_minus = cLq_minus + cLq_av(iorder,x,ireg,.false.,
     & flavchange) 
         endif 
      elseif (ireg.eq.1) then      
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             cLq_minus =  0 
         elseif (iorder.eq.1) then 
             cLq_minus =  + 16.D0/3.D0*x 
         elseif (iorder.eq.2) then 
             cLq_minus =  + LM * ( 128.D0/9.D0 - 464.D0/9.D0*x + 256.D0/
     &    9.D0*x*dlx1 - 128.D0/9.D0*x*dlx )
      cLq_minus = cLq_minus + LR * (  - 176.D0/3.D0*x )
      cLq_minus = cLq_minus + rnf * ( 32.D0/9.D0 - 400.D0/27.D0*x + 32.D
     &    0/9.D0*x*dlx1 - 64.D0/9.D0*x*dlx )
      cLq_minus = cLq_minus + rnf*LM * ( 32.D0/9.D0*x )
      cLq_minus = cLq_minus + rnf*LR * ( 32.D0/9.D0*x )
      cLq_minus = cLq_minus - 496.D0/9.D0 + 128.D0/9.D0*dlx1 - 128.D0/9.
     &    D0*dlx + 1672.D0/9.D0*x - 656.D0/9.D0*x*dlx1 + 128.D0/9.D0*x*
     &    dlx1**2 + 320.D0/3.D0*x*dlx - 256.D0/9.D0*x*dlx*dlx1 + 128.D0/
     &    9.D0*x*dlx**2 - 32.D0/9.D0*x*dlx**2*dlx1 - 64.D0/9.D0*x*Pi**2
     &     + 32.D0/27.D0*x*Pi**2*dlx1 - 64.D0/9.D0*x**2*dlx**2 + 64.D0/
     &    27.D0*x**2*Pi**2 - 64.D0/9.D0*Hr1(-1)*x**(-1)*dlx + 64.D0/9.D0
     &    *Hr1(-1)*x*dlx + 32.D0/9.D0*Hr1(-1)*x*dlx**2 - 32.D0/27.D0*
     &    Hr1(-1)*x*Pi**2 + 128.D0/9.D0*Hr1(-1)*x**2*dlx - 128.D0/9.D0*
     &    Hr2(-1,-1)*x*dlx + 64.D0/9.D0*Hr2(0,-1)*x**(-1) - 64.D0/9.D0*
     &    Hr2(0,-1)*x + 64.D0/9.D0*Hr2(0,-1)*x*dlx - 128.D0/9.D0*Hr2(0,
     &    -1)*x**2 + 128.D0/9.D0*Hr2(0,1)*x - 64.D0/9.D0*Hr2(0,1)*x*dlx
     &     + 128.D0/9.D0*Hr3(-1,0,-1)*x + 128.D0/9.D0*Hr3(0,-1,-1)*x - 
     &    64.D0/3.D0*Hr3(0,0,-1)*x + 64.D0/9.D0*Hr3(0,0,1)*x 
         elseif (iorder.eq.3) then 
             cLq_minus = 256.D0/81.D0*x**(-1)*Pi**2*dlx1*LM + 64480.D0/
     & 27.D0*LM - 704.D0/3.D0*LM**2 + 10912.D0/9.D0*LR - 2816.D0/9.D0*
     & LR*LM - 22144.D0/27.D0*dlx1*LM + 2048.D0/27.D0*dlx1*LM**2 - 2816.
     & D0/9.D0*dlx1*LR + 1024.D0/9.D0*dlx1**2*LM + 16384.D0/27.D0*dlx*
     & LM - 512.D0/27.D0*dlx*LM**2 + 2816.D0/9.D0*dlx*LR - 2048.D0/9.D0
     & *dlx*dlx1*LM + 256.D0/9.D0*dlx**2*LM - 256.D0/27.D0*dlx**2*dlx1*
     & LM - 256.D0/9.D0*Pi**2*LM + 256.D0/81.D0*Pi**2*dlx1*LM - 17920.D0
     & /81.D0*rnf*LM + 128.D0/9.D0*rnf*LM**2 - 4096.D0/27.D0*rnf*LR + 
     & 512.D0/27.D0*rnf*LR*LM + 1280.D0/27.D0*rnf*dlx1*LM + 512.D0/27.D0
     & *rnf*dlx1*LR - 1024.D0/27.D0*rnf*dlx*LM - 512.D0/27.D0*rnf*dlx*
     & LR + 128.D0/27.D0*rnf**2*LM + 128.D0/27.D0*rnf**2*LR - 1024.D0/
     & 27.D0*Zeta3*LM - 140656.D0/27.D0*x*LM + 1712.D0/3.D0*x*LM**2 - 
     & 41680.D0/9.D0*x*LR + 10208.D0/9.D0*x*LR*LM + 1936.D0/3.D0*x*
     & LR**2 + 86624.D0/27.D0*x*dlx1*LM - 11648.D0/27.D0*x*dlx1*LM**2
     &  + 14432.D0/9.D0*x*dlx1*LR - 5632.D0/9.D0*x*dlx1*LR*LM - 2048.D0/
     & 3.D0*x*dlx1**2*LM
      cLq_minus = cLq_minus + 2048.D0/27.D0*x*dlx1**2*LM**2 - 2816.D0/9.
     & D0*x*dlx1**2*LR + 2048.D0/27.D0*x*dlx1**3*LM - 74816.D0/27.D0*x*
     & dlx*LM + 5824.D0/27.D0*x*dlx*LM**2 - 7040.D0/3.D0*x*dlx*LR + 
     & 2816.D0/9.D0*x*dlx*LR*LM + 11264.D0/9.D0*x*dlx*dlx1*LM - 2048.D0/
     & 27.D0*x*dlx*dlx1*LM**2 + 5632.D0/9.D0*x*dlx*dlx1*LR - 2048.D0/9.D
     & 0*x*dlx*dlx1**2*LM - 13504.D0/27.D0*x*dlx**2*LM + 256.D0/27.D0*x
     & *dlx**2*LM**2 - 2816.D0/9.D0*x*dlx**2*LR + 704.D0/3.D0*x*dlx**2*
     & dlx1*LM + 704.D0/9.D0*x*dlx**2*dlx1*LR - 256.D0/27.D0*x*dlx**2*
     & dlx1**2*LM - 1792.D0/81.D0*x*dlx**3*LM + 512.D0/81.D0*x*dlx**3*
     & dlx1*LM + 832.D0/3.D0*x*Pi**2*LM - 1024.D0/81.D0*x*Pi**2*LM**2
     &  + 1408.D0/9.D0*x*Pi**2*LR - 320.D0/3.D0*x*Pi**2*dlx1*LM - 704.D0
     & /27.D0*x*Pi**2*dlx1*LR + 512.D0/81.D0*x*Pi**2*dlx1**2*LM + 4864.D
     & 0/81.D0*x*Pi**2*dlx*LM - 1024.D0/81.D0*x*Pi**2*dlx*dlx1*LM - 704.
     & D0/1215.D0*x*Pi**4*LM + 53728.D0/81.D0*x*rnf*LM - 640.D0/9.D0*x*
     & rnf*LM**2 + 17312.D0/27.D0*x*rnf*LR - 3968.D0/27.D0*x*rnf*LR*LM
     &  - 704.D0/9.D0*x*rnf*LR**2
      cLq_minus = cLq_minus - 22784.D0/81.D0*x*rnf*dlx1*LM + 256.D0/9.D0
     & *x*rnf*dlx1*LM**2 - 4736.D0/27.D0*x*rnf*dlx1*LR + 1024.D0/27.D0*
     & x*rnf*dlx1*LR*LM + 1024.D0/27.D0*x*rnf*dlx1**2*LM + 512.D0/27.D0
     & *x*rnf*dlx1**2*LR + 26368.D0/81.D0*x*rnf*dlx*LM - 128.D0/9.D0*x*
     & rnf*dlx*LM**2 + 896.D0/3.D0*x*rnf*dlx*LR - 512.D0/27.D0*x*rnf*
     & dlx*LR*LM - 2048.D0/27.D0*x*rnf*dlx*dlx1*LM - 1024.D0/27.D0*x*
     & rnf*dlx*dlx1*LR + 896.D0/27.D0*x*rnf*dlx**2*LM + 512.D0/27.D0*x*
     & rnf*dlx**2*LR - 128.D0/27.D0*x*rnf*dlx**2*dlx1*LM - 128.D0/27.D0
     & *x*rnf*dlx**2*dlx1*LR - 1408.D0/81.D0*x*rnf*Pi**2*LM - 256.D0/27.
     & D0*x*rnf*Pi**2*LR + 128.D0/81.D0*x*rnf*Pi**2*dlx1*LM + 128.D0/81.
     & D0*x*rnf*Pi**2*dlx1*LR - 1600.D0/81.D0*x*rnf**2*LM + 64.D0/27.D0
     & *x*rnf**2*LM**2 - 1600.D0/81.D0*x*rnf**2*LR + 128.D0/27.D0*x*
     & rnf**2*LR*LM + 64.D0/27.D0*x*rnf**2*LR**2 + 128.D0/27.D0*x*
     & rnf**2*dlx1*LM + 128.D0/27.D0*x*rnf**2*dlx1*LR - 256.D0/27.D0*x*
     & rnf**2*dlx*LM - 256.D0/27.D0*x*rnf**2*dlx*LR + 2560.D0/27.D0*x*
     & Zeta3*LM
      cLq_minus = cLq_minus - 3584.D0/27.D0*x*Zeta3*dlx1*LM + 1408.D0/9.
     & D0*x**2*dlx**2*LM + 1408.D0/9.D0*x**2*dlx**2*LR + 1024.D0/81.D0*
     & x**2*dlx**3*LM - 1408.D0/27.D0*x**2*Pi**2*LM - 1408.D0/27.D0*
     & x**2*Pi**2*LR + 512.D0/81.D0*x**2*Pi**2*dlx1*LM - 2048.D0/81.D0*
     & x**2*Pi**2*dlx*LM - 256.D0/27.D0*x**2*rnf*dlx**2*LM - 256.D0/27.D
     & 0*x**2*rnf*dlx**2*LR + 256.D0/81.D0*x**2*rnf*Pi**2*LM + 256.D0/
     & 81.D0*x**2*rnf*Pi**2*LR - 5120.D0/27.D0*x**2*Zeta3*LM + 1408.D0/
     & 9.D0*Hr1(-1)*x**(-1)*dlx*LM + 1408.D0/9.D0*Hr1(-1)*x**(-1)*dlx*
     & LR + 512.D0/27.D0*Hr1(-1)*x**(-1)*dlx**2*LM - 256.D0/27.D0*Hr1(
     & -1)*x**(-1)*Pi**2*LM - 256.D0/27.D0*Hr1(-1)*x**(-1)*rnf*dlx*LM
     &  - 256.D0/27.D0*Hr1(-1)*x**(-1)*rnf*dlx*LR + 1024.D0/27.D0*Hr1(
     & -1)*dlx*LM - 256.D0/27.D0*Hr1(-1)*dlx**2*LM + 256.D0/81.D0*Hr1(
     & -1)*Pi**2*LM - 4736.D0/27.D0*Hr1(-1)*x*dlx*LM - 1408.D0/9.D0*
     & Hr1(-1)*x*dlx*LR - 2240.D0/27.D0*Hr1(-1)*x*dlx**2*LM - 704.D0/9.D
     & 0*Hr1(-1)*x*dlx**2*LR - 512.D0/81.D0*Hr1(-1)*x*dlx**3*LM + 832.D0
     & /27.D0*Hr1(-1)*x*Pi**2*LM
      cLq_minus = cLq_minus + 704.D0/27.D0*Hr1(-1)*x*Pi**2*LR + 1024.D0/
     & 81.D0*Hr1(-1)*x*Pi**2*dlx*LM + 256.D0/27.D0*Hr1(-1)*x*rnf*dlx*LM
     &  + 256.D0/27.D0*Hr1(-1)*x*rnf*dlx*LR + 128.D0/27.D0*Hr1(-1)*x*
     & rnf*dlx**2*LM + 128.D0/27.D0*Hr1(-1)*x*rnf*dlx**2*LR - 128.D0/81.
     & D0*Hr1(-1)*x*rnf*Pi**2*LM - 128.D0/81.D0*Hr1(-1)*x*rnf*Pi**2*LR
     &  + 3584.D0/27.D0*Hr1(-1)*x*Zeta3*LM - 2816.D0/9.D0*Hr1(-1)*x**2*
     & dlx*LM - 2816.D0/9.D0*Hr1(-1)*x**2*dlx*LR - 1024.D0/27.D0*Hr1(-1
     & )*x**2*dlx**2*LM + 512.D0/27.D0*Hr1(-1)*x**2*Pi**2*LM + 512.D0/
     & 27.D0*Hr1(-1)*x**2*rnf*dlx*LM + 512.D0/27.D0*Hr1(-1)*x**2*rnf*
     & dlx*LR - 1024.D0/27.D0*Hr2(-1,-1)*x**(-1)*dlx*LM + 1024.D0/27.D0
     & *Hr2(-1,-1)*dlx*LM + 7936.D0/27.D0*Hr2(-1,-1)*x*dlx*LM + 2816.D0/
     & 9.D0*Hr2(-1,-1)*x*dlx*LR + 512.D0/9.D0*Hr2(-1,-1)*x*dlx**2*LM - 
     & 2048.D0/81.D0*Hr2(-1,-1)*x*Pi**2*LM - 512.D0/27.D0*Hr2(-1,-1)*x*
     & rnf*dlx*LM - 512.D0/27.D0*Hr2(-1,-1)*x*rnf*dlx*LR + 2048.D0/27.D0
     & *Hr2(-1,-1)*x**2*dlx*LM - 1408.D0/9.D0*Hr2(0,-1)*x**(-1)*LM - 
     & 1408.D0/9.D0*Hr2(0,-1)*x**(-1)*LR
      cLq_minus = cLq_minus - 1024.D0/27.D0*Hr2(0,-1)*x**(-1)*dlx*LM + 
     & 256.D0/27.D0*Hr2(0,-1)*x**(-1)*rnf*LM + 256.D0/27.D0*Hr2(0,-1)*
     & x**(-1)*rnf*LR - 1024.D0/27.D0*Hr2(0,-1)*LM + 512.D0/27.D0*Hr2(0
     & ,-1)*dlx*LM + 4736.D0/27.D0*Hr2(0,-1)*x*LM + 1408.D0/9.D0*Hr2(0,
     & -1)*x*LR - 128*Hr2(0,-1)*x*dlx*LM - 1408.D0/9.D0*Hr2(0,-1)*x*dlx
     & *LR - 256.D0/9.D0*Hr2(0,-1)*x*dlx**2*LM + 256.D0/27.D0*Hr2(0,-1)
     & *x*Pi**2*LM - 256.D0/27.D0*Hr2(0,-1)*x*rnf*LM - 256.D0/27.D0*
     & Hr2(0,-1)*x*rnf*LR + 256.D0/27.D0*Hr2(0,-1)*x*rnf*dlx*LM + 256.D0
     & /27.D0*Hr2(0,-1)*x*rnf*dlx*LR + 2816.D0/9.D0*Hr2(0,-1)*x**2*LM
     &  + 2816.D0/9.D0*Hr2(0,-1)*x**2*LR - 512.D0/27.D0*Hr2(0,-1)*x**2*
     & rnf*LM - 512.D0/27.D0*Hr2(0,-1)*x**2*rnf*LR - 1024.D0/27.D0*Hr2(
     & 0,1)*LM - 512.D0/27.D0*Hr2(0,1)*dlx*LM - 10624.D0/27.D0*Hr2(0,1)
     & *x*LM - 2816.D0/9.D0*Hr2(0,1)*x*LR + 2432.D0/27.D0*Hr2(0,1)*x*
     & dlx*LM + 1408.D0/9.D0*Hr2(0,1)*x*dlx*LR - 1024.D0/27.D0*Hr2(0,1)
     & *x*dlx*dlx1*LM + 256.D0/27.D0*Hr2(0,1)*x*dlx**2*LM - 256.D0/81.D0
     & *Hr2(0,1)*x*Pi**2*LM
      cLq_minus = cLq_minus + 256.D0/9.D0*Hr2(0,1)*x*rnf*LM + 512.D0/27.
     & D0*Hr2(0,1)*x*rnf*LR - 256.D0/27.D0*Hr2(0,1)*x*rnf*dlx*LM - 256.D
     & 0/27.D0*Hr2(0,1)*x*rnf*dlx*LR - 4096.D0/27.D0*Hr3(-1,-1,-1)*x*
     & dlx*LM + 1024.D0/27.D0*Hr3(-1,0,-1)*x**(-1)*LM - 1024.D0/27.D0*
     & Hr3(-1,0,-1)*LM - 7936.D0/27.D0*Hr3(-1,0,-1)*x*LM - 2816.D0/9.D0
     & *Hr3(-1,0,-1)*x*LR - 1024.D0/27.D0*Hr3(-1,0,-1)*x*dlx*LM + 512.D0
     & /27.D0*Hr3(-1,0,-1)*x*rnf*LM + 512.D0/27.D0*Hr3(-1,0,-1)*x*rnf*
     & LR - 2048.D0/27.D0*Hr3(-1,0,-1)*x**2*LM + 1024.D0/27.D0*Hr3(-1,0
     & ,1)*x**(-1)*LM - 1024.D0/27.D0*Hr3(-1,0,1)*x*LM - 2048.D0/27.D0*
     & Hr3(-1,0,1)*x**2*LM + 1024.D0/27.D0*Hr3(0,-1,-1)*x**(-1)*LM - 
     & 1024.D0/27.D0*Hr3(0,-1,-1)*LM - 7936.D0/27.D0*Hr3(0,-1,-1)*x*LM
     &  - 2816.D0/9.D0*Hr3(0,-1,-1)*x*LR + 512.D0/27.D0*Hr3(0,-1,-1)*x*
     & rnf*LM + 512.D0/27.D0*Hr3(0,-1,-1)*x*rnf*LR - 2048.D0/27.D0*Hr3(
     & 0,-1,-1)*x**2*LM + 1024.D0/27.D0*Hr3(0,0,-1)*x**(-1)*LM - 512.D0/
     & 27.D0*Hr3(0,0,-1)*LM + 11392.D0/27.D0*Hr3(0,0,-1)*x*LM + 1408.D0/
     & 3.D0*Hr3(0,0,-1)*x*LR
      cLq_minus = cLq_minus + 1024.D0/9.D0*Hr3(0,0,-1)*x*dlx*LM - 256.D0
     & /9.D0*Hr3(0,0,-1)*x*rnf*LM - 256.D0/9.D0*Hr3(0,0,-1)*x*rnf*LR + 
     & 2048.D0/27.D0*Hr3(0,0,-1)*x**2*LM + 512.D0/27.D0*Hr3(0,0,1)*LM
     &  - 1408.D0/27.D0*Hr3(0,0,1)*x*LM - 1408.D0/9.D0*Hr3(0,0,1)*x*LR
     &  + 2048.D0/27.D0*Hr3(0,0,1)*x*dlx1*LM + 256.D0/27.D0*Hr3(0,0,1)*
     & x*rnf*LM + 256.D0/27.D0*Hr3(0,0,1)*x*rnf*LR + 2048.D0/27.D0*Hr3(
     & 0,0,1)*x**2*LM - 2048.D0/27.D0*Hr3(0,1,1)*x*LM - 1024.D0/27.D0*
     & Hr3(0,1,1)*x*dlx*LM + 4096.D0/27.D0*Hr4(-1,-1,0,-1)*x*LM + 2048.D
     & 0/27.D0*Hr4(-1,-1,0,1)*x*LM + 4096.D0/27.D0*Hr4(-1,0,-1,-1)*x*LM
     &  - 1024.D0/27.D0*Hr4(-1,0,0,-1)*x*LM - 1024.D0/27.D0*Hr4(-1,0,0,
     & 1)*x*LM + 4096.D0/27.D0*Hr4(0,-1,-1,-1)*x*LM - 2048.D0/27.D0*
     & Hr4(0,-1,0,-1)*x*LM - 2048.D0/27.D0*Hr4(0,-1,0,1)*x*LM - 1024.D0/
     & 9.D0*Hr4(0,0,-1,-1)*x*LM - 3584.D0/27.D0*Hr4(0,0,0,-1)*x*LM - 
     & 512.D0/27.D0*Hr4(0,0,0,1)*x*LM + 1024.D0/9.D0*Hr4(0,0,1,1)*x*LM
     &  + 1024.D0/27.D0*Hr4(0,1,0,1)*x*LM 
             cLq_minus = cLq_minus + cLq_av(iorder,x,ireg,.false.,
     &     flavchange) - CLQ3DF(x, nf, 0)
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             cLq_minus =  0 
         elseif (iorder.eq.1) then 
             cLq_minus =  0 
         elseif (iorder.eq.2) then 
             cLq_minus =  0 
         elseif (iorder.eq.3) then 
             cLq_minus =  0 
             cLq_minus = cLq_minus + cLq_av(iorder,x,ireg,.false.,
     & flavchange) 
         endif 
      endif      
      return     
      end function cLq_minus  
