!>***************************************************
!> Exact DIS coefficient funtion cLqps_new in x space
!> including scale dependence
!>
      function cLqps_new(iorder,x,ireg,rmu2,fmu2,q2,flavchange)
      use KinData_mod
      use Constants_mod
      use CoeffFunc_av
      implicit none
      integer iorder,ireg,flavchange
      double precision Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1)
      double precision Hr4(-1:1,-1:1,-1:1,-1:1)
      double precision Hr5(-1:1,-1:1,-1:1,-1:1,-1:1)
      common /Hrs/ Hr1,Hr2,Hr3,Hr4,Hr5
!$omp threadprivate(/Hrs/)
      real*8 q2,rmu2,fmu2
      double precision, parameter :: rnf  = 5d0
      double precision, parameter :: sumEQ2  = 1.2222222222222222d0
      double precision, parameter :: sumEQ   = 0.3333333333333333d0
      real*8 dd0,dd1,dd2,dd3,dd4,dd5
      real*8 x1,dlx,dlx1,dl1px,dli2mx,dli21mx,LM,LR
      real*8 cLqps_new,x


      x1   = 1d0-x      
      dlx  = dlog(x)      
      dlx1 = dlog(x1)      
      LM   = dlog(q2/fmu2)      
      LR   = dlog(fmu2/rmu2)      


      if (ireg.eq.0) then      
         dd0 = 1d0/1d0*dlx1**1 
         dd1 = 1d0/2d0*dlx1**2 
         dd2 = 1d0/3d0*dlx1**3 
         dd3 = 1d0/4d0*dlx1**4 
         dd4 = 1d0/5d0*dlx1**5 
         dd5 = 1d0/6d0*dlx1**6 
         if (iorder.eq.0) then 
             cLqps_new =  0 
         elseif (iorder.eq.1) then 
             cLqps_new =  0 
         elseif (iorder.eq.2) then 
             cLqps_new =  0 
         elseif (iorder.eq.3) then 
             cLqps_new =  0 
             cLqps_new = cLqps_new + cLqps_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.1) then      
         dd0 = 1d0/x1  
         dd1 = dlx1/x1 
         dd2 = dlx1**2/x1 
         dd3 = dlx1**3/x1 
         dd4 = dlx1**4/x1 
         dd5 = dlx1**5/x1 
         if (iorder.eq.0) then 
             cLqps_new =  0 
         elseif (iorder.eq.1) then 
             cLqps_new =  0 
         elseif (iorder.eq.2) then 
             cLqps_new =  + LM * (  - 64.D0/3.D0 + 64.D0/9.D0*x**(-1)
     &     - 64.D0/3.D0*x*dlx + 128.D0/9.D0*x**2 )
      cLqps_new = cLqps_new + 64.D0/9.D0 - 64.D0/27.D0*x**(-1) + 64.D0/
     &    9.D0*x**(-1)*dlx1 - 64.D0/3.D0*dlx1 + 64.D0/3.D0*dlx - 256.D0/
     &    9.D0*x - 64.D0/3.D0*x*dlx + 64.D0/3.D0*x*dlx**2 - 32.D0/9.D0*
     &    x*Pi**2 + 640.D0/27.D0*x**2 + 128.D0/9.D0*x**2*dlx1 - 128.D0/
     &    3.D0*x**2*dlx + 64.D0/3.D0*Hr2(0,1)*x 
         elseif (iorder.eq.3) then 
             cLqps_new = 15232.D0/135.D0*x**(-1)*LM - 5792.D0/27.D0*
     & x**(-1)*LM**2 + 1408.D0/27.D0*x**(-1)*LR - 1408.D0/9.D0*x**(-1)*
     & LR*LM - 40000.D0/81.D0*x**(-1)*dlx1*LM + 1664.D0/27.D0*x**(-1)*
     & dlx1*LM**2 - 1408.D0/9.D0*x**(-1)*dlx1*LR + 2816.D0/27.D0*
     & x**(-1)*dlx1**2*LM + 7424.D0/405.D0*x**(-1)*dlx*LM - 128.D0/3.D0
     & *x**(-1)*dlx*LM**2 - 5632.D0/27.D0*x**(-1)*dlx*dlx1*LM - 512.D0/
     & 27.D0*x**(-1)*rnf*LM + 128.D0/27.D0*x**(-1)*rnf*LM**2 - 256.D0/
     & 81.D0*x**(-1)*rnf*LR + 256.D0/27.D0*x**(-1)*rnf*LR*LM + 256.D0/
     & 27.D0*x**(-1)*rnf*dlx1*LR - 96448.D0/135.D0*LM + 7808.D0/27.D0*
     & LM**2 - 1408.D0/9.D0*LR + 1408.D0/3.D0*LR*LM + 18304.D0/27.D0*
     & dlx1*LM - 1664.D0/9.D0*dlx1*LM**2 + 1408.D0/3.D0*dlx1*LR - 2816.D
     & 0/9.D0*dlx1**2*LM - 364672.D0/405.D0*dlx*LM - 640.D0/9.D0*dlx*
     & LM**2 - 1408.D0/3.D0*dlx*LR + 5632.D0/9.D0*dlx*dlx1*LM + 1280.D0/
     & 9.D0*dlx**2*LM + 1024.D0/27.D0*Pi**2*LM + 2048.D0/27.D0*rnf*LM
     &  - 128.D0/9.D0*rnf*LM**2 + 256.D0/27.D0*rnf*LR - 256.D0/9.D0*rnf
     & *LR*LM
      cLqps_new = cLqps_new - 256.D0/9.D0*rnf*dlx1*LR + 256.D0/9.D0*rnf
     & *dlx*LM + 256.D0/9.D0*rnf*dlx*LR + 908864.D0/405.D0*x*LM + 10720.
     & D0/27.D0*x*LM**2 + 5632.D0/9.D0*x*LR + 16064.D0/27.D0*x*dlx1*LM
     &  - 62144.D0/135.D0*x*dlx*LM + 896.D0/3.D0*x*dlx*LM**2 + 1408.D0/
     & 3.D0*x*dlx*LR + 1408.D0/3.D0*x*dlx*LR*LM - 41536.D0/81.D0*x*
     & dlx**2*LM + 128*x*dlx**2*LM**2 - 1408.D0/3.D0*x*dlx**2*LR - 
     & 14336.D0/81.D0*x*dlx**3*LM + 13888.D0/243.D0*x*Pi**2*LM - 832.D0/
     & 27.D0*x*Pi**2*LM**2 + 704.D0/9.D0*x*Pi**2*LR + 10496.D0/81.D0*x*
     & Pi**2*dlx*LM - 256.D0/9.D0*x*rnf*LM - 1024.D0/27.D0*x*rnf*LR + 
     & 2048.D0/27.D0*x*rnf*dlx*LM - 128.D0/9.D0*x*rnf*dlx*LM**2 - 256.D0
     & /9.D0*x*rnf*dlx*LR - 256.D0/9.D0*x*rnf*dlx*LR*LM + 256.D0/9.D0*x
     & *rnf*dlx**2*LM + 256.D0/9.D0*x*rnf*dlx**2*LR - 128.D0/27.D0*x*
     & rnf*Pi**2*LR - 256.D0/3.D0*x*Zeta3*LM - 665216.D0/405.D0*x**2*LM
     &  - 12736.D0/27.D0*x**2*LM**2 - 14080.D0/27.D0*x**2*LR - 2816.D0/
     & 9.D0*x**2*LR*LM - 63104.D0/81.D0*x**2*dlx1*LM + 3328.D0/27.D0*
     & x**2*dlx1*LM**2
      cLqps_new = cLqps_new - 2816.D0/9.D0*x**2*dlx1*LR + 5632.D0/27.D0
     & *x**2*dlx1**2*LM + 1201024.D0/405.D0*x**2*dlx*LM - 1024.D0/27.D0
     & *x**2*dlx*LM**2 + 2816.D0/3.D0*x**2*dlx*LR - 11264.D0/27.D0*x**2
     & *dlx*dlx1*LM + 1024.D0/9.D0*x**2*dlx**2*LM - 2560.D0/27.D0*x**2*
     & Pi**2*LM - 256.D0/9.D0*x**2*rnf*LM + 256.D0/27.D0*x**2*rnf*LM**2
     &  + 2560.D0/81.D0*x**2*rnf*LR + 512.D0/27.D0*x**2*rnf*LR*LM + 512.
     & D0/27.D0*x**2*rnf*dlx1*LR - 1024.D0/27.D0*x**2*rnf*dlx*LM - 512.D
     & 0/9.D0*x**2*rnf*dlx*LR + 1024.D0/135.D0*x**3*dlx**2*LM - 1024.D0/
     & 405.D0*x**3*Pi**2*LM + 4096.D0/405.D0*Hr1(-1)*x**(-2)*dlx*LM + 
     & 512.D0/3.D0*Hr1(-1)*x**(-1)*dlx*LM + 12800.D0/27.D0*Hr1(-1)*dlx*
     & LM - 1024.D0/81.D0*Hr1(-1)*x*dlx*LM - 1024.D0/3.D0*Hr1(-1)*x**2*
     & dlx*LM - 2048.D0/135.D0*Hr1(-1)*x**3*dlx*LM - 4096.D0/405.D0*
     & Hr2(0,-1)*x**(-2)*LM - 512.D0/3.D0*Hr2(0,-1)*x**(-1)*LM - 12800.D
     & 0/27.D0*Hr2(0,-1)*LM + 1024.D0/81.D0*Hr2(0,-1)*x*LM - 12800.D0/
     & 27.D0*Hr2(0,-1)*x*dlx*LM + 1024.D0/3.D0*Hr2(0,-1)*x**2*LM + 2048.
     & D0/135.D0*Hr2(0,-1)*x**3*LM
      cLqps_new = cLqps_new - 1024.D0/27.D0*Hr2(0,1)*x**(-1)*LM + 3584.D
     & 0/9.D0*Hr2(0,1)*LM - 3200.D0/9.D0*Hr2(0,1)*x*LM + 1664.D0/9.D0*
     & Hr2(0,1)*x*LM**2 - 1408.D0/3.D0*Hr2(0,1)*x*LR - 5632.D0/9.D0*
     & Hr2(0,1)*x*dlx*LM + 256.D0/9.D0*Hr2(0,1)*x*rnf*LR + 4096.D0/27.D0
     & *Hr2(0,1)*x**2*LM + 25600.D0/27.D0*Hr3(0,0,-1)*x*LM - 5632.D0/9.D
     & 0*Hr3(0,1,1)*x*LM 
             cLqps_new = cLqps_new + cLqps_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      elseif (ireg.eq.2) then      
         dd0 = -1d0/x1  
         dd1 = -dlx1/x1 
         dd2 = -dlx1**2/x1 
         dd3 = -dlx1**3/x1 
         dd4 = -dlx1**4/x1 
         dd5 = -dlx1**5/x1 
         if (iorder.eq.0) then 
             cLqps_new =  0 
         elseif (iorder.eq.1) then 
             cLqps_new =  0 
         elseif (iorder.eq.2) then 
             cLqps_new =  0 
         elseif (iorder.eq.3) then 
             cLqps_new =  0 
             cLqps_new = cLqps_new + cLqps_av(iorder,x,ireg,.false.,flavchange) 
         endif 
      endif      
      return     
      end function cLqps_new  
