****************************************************
* quark pair two loop matrix elements for q + qbar --> e^- + e^+
*
*
* summed over colour orderings, summed and squared
*
*                    q(1) qbar(2) e-(3) e+(4)
*
      function FullB0g2Z(i1,i2,i3,i4,renscale2)
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)

      fac = 1d0 / (2d0*nc)**2  ! qqb: average factor

      fac = fac * 4d0 * (4d0*pi*amz)**2 * nc
     &          * ( (as*nc)/(2d0*pi) )**2
     &          * ( 1d0 - 1d0/nc**2 )

      FullB0g2Z = fac * (
     &            + B0g2Z(i1,i2,i3,i4,renscale2)
     &            - (1d0/nc)**2 * Bt0g2Z(i1,i2,i3,i4,renscale2)
     &            + (nf/nc) * Bh0g2Z(i1,i2,i3,i4,renscale2)
     &          )

c      write(*,*) "FullB0g2Z",FullB0g2Z,i1,i2,i3,i4

      return
      end


      function B0g2Z(i1,i2,i3,i4,renscale2)
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole

      s12=s4(i1,i2)
      tree=B0g0Z(i1,i2,i3,i4)
      dls12=log(renscale2/abs(s12))

      select case(ipole)
      case(-4)
      B0g2Z =  + tree * ( 1.D0/2.D0 )

      case(-3)
      B0g2Z =  + tree * ( 23.D0/8.D0 + dls12 )

      case(-2)
      B0g2Z =  + tree * ( 401.D0/72.D0 + 47.D0/12.D0*dls12 + dls12**2
     &     - 13.D0/24.D0*pi**2 )

      !DIS
      if(s12.lt.0d0) B0g2Z=B0g2Z+pi**2/2d0

      case(-1)
      B0g2Z =  + tree * ( 10093.D0/864.D0 + 151.D0/18.D0*dls12 + 3.D0*
     &    dls12**2 + 2.D0/3.D0*dls12**3 - 7.D0/12.D0*zeta3 - 89.D0/48.D0
     &    *pi**2 - 13.D0/12.D0*pi**2*dls12 )

      !DIS
      if(s12.lt.0d0) B0g2Z=B0g2Z+3d0/2d0*pi**2+pi**2*dls12

      case default
      B0g2Z =  + tree * (  - 60923.D0/5184.D0 - 22.D0/3.D0*dls12 + 389.D
     &    0/72.D0*zeta3 - 5.D0/36.D0*pi**2 + 49.D0/1440.D0*pi**4 )

      end select

      return
      end


      function Bt0g2Z(i1,i2,i3,i4,renscale2)
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole

      s12=s4(i1,i2)
      tree=B0g0Z(i1,i2,i3,i4)
      dls12=log(renscale2/abs(s12))

      select case(ipole)
      case(-4)
      Bt0g2Z =  + tree * ( 1.D0/2.D0 )

      case(-3)
      Bt0g2Z =  + tree * ( 3.D0/2.D0 + dls12 )

      case(-2)
      Bt0g2Z =  + tree * ( 41.D0/8.D0 + 3.D0*dls12 + dls12**2 - 7.D0/12.
     &    D0*pi**2 )

      !DIS
      if(s12.lt.0d0) Bt0g2Z=Bt0g2Z+pi**2/2d0

      case(-1)
      Bt0g2Z =  + tree * ( 445.D0/32.D0 + 41.D0/4.D0*dls12 + 3.D0*
     &    dls12**2 + 2.D0/3.D0*dls12**3 - 23.D0/6.D0*zeta3 - 13.D0/8.D0
     &    *pi**2 - 7.D0/6.D0*pi**2*dls12 )

      !DIS
      if(s12.lt.0d0) Bt0g2Z=Bt0g2Z+3d0/2d0*pi**2+pi**2*dls12

      case default
      Bt0g2Z =  + tree * ( 511.D0/64.D0 - 15.D0/4.D0*zeta3 + 29.D0/48.D0
     &    *pi**2 - 11.D0/360.D0*pi**4 )

      end select

      return
      end


      function Bh0g2Z(i1,i2,i3,i4,renscale2)
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole

      s12=s4(i1,i2)
      tree=B0g0Z(i1,i2,i3,i4)
      dls12=log(renscale2/abs(s12))

      select case(ipole)
      case(-4)
      Bh0g2Z =  0

      case(-3)
      Bh0g2Z =  + tree * (  - 1.D0/4.D0 )

      case(-2)
      Bh0g2Z =  + tree * (  - 1.D0/9.D0 - 1.D0/6.D0*dls12 )

      case(-1)
      Bh0g2Z =  + tree * ( 65.D0/216.D0 + 5.D0/18.D0*dls12 + 1.D0/24.D0
     &    *pi**2 )

      case default
      Bh0g2Z =  + tree * ( 4085.D0/1296.D0 + 4.D0/3.D0*dls12 - 1.D0/36.D
     &    0*zeta3 + 7.D0/72.D0*pi**2 )

      end select

      return
      end
