************************************************************************
*
* gluon photon two quark one loop matrix elements interfered with tree level
*
*                      q  g  qb ; p
*
* summed over colour orderings, summed and squared
*
      function FullautoB1g1G(iq,ig1,iqb,ip2,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)

c      write(*,*)" hello FullB1g1G"

      if(ig1.gt.2) then
         ave = 1/4d0/nc**2
      else
         ave = 1/4d0/nc/(nc**2-1d0)
      endif   

      fac=(as*nc/2d0/pi)*(4d0*pi*as*nc)*(4d0*pi*amz)*(nc**2-1d0)/dble(nc)

      fac=ave*fac

      FullB1g1G=                +autoB1g1G(iq,ig1,iqb,ip2,renscale2)
     .       +dble(nf)/dble(nc)*autoBh1g1G(iq,ig1,iqb,ip2,renscale2)
     .       -1d0/dble(nc)**(2)*autoBt1g1G(iq,ig1,iqb,ip2,renscale2)

      FullautoB1g1G=fac*FullB1g1G

*c      write(*,*)"FullB1g1G",FullB1g1G
      return
      end

*
************************************************************************
*
      function autoB1g1G(iq,ig1,iqb,ip2,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      if((iq.eq.1).and.(ig1.eq.2).and.(ip2.eq.4).and.(iqb.eq.3))then
        autoB1g1G=B1g1G1(iq,ig1,ip2,iqb,renscale2)
      elseif((iq.eq.1).and.(ig1.eq.3).and.(ip2.eq.4).and.(iqb.eq.2))then
        autoB1g1G=B1g1G3(iq,ig1,ip2,iqb,renscale2)
      elseif((iq.eq.2).and.(ig1.eq.1).and.(ip2.eq.4).and.(iqb.eq.3))then
        autoB1g1G=B1g1G2(iq,ig1,ip2,iqb,renscale2)
      elseif((iq.eq.2).and.(ig1.eq.3).and.(ip2.eq.4).and.(iqb.eq.1))then
        autoB1g1G=B1g1G3(iqb,ig1,ip2,iq,renscale2)
      elseif((iq.eq.3).and.(ig1.eq.1).and.(ip2.eq.4).and.(iqb.eq.2))then
        autoB1g1G=B1g1G2(iqb,ig1,ip2,iq,renscale2)
      elseif((iq.eq.3).and.(ig1.eq.2).and.(ip2.eq.4).and.(iqb.eq.1))then
        autoB1g1G=B1g1G1(iqb,ig1,ip2,iq,renscale2)
      else
        write(*,*) " WARNING: wrong arguments passed to B1g1G ",iq,ig1,ip2,iqb
      endif

      autoB1g1G =  abs(zewfac(1))**2*autoB1g1G

      return
      end
*
************************************************************************
*
      function autoBh1g1G(iq,ig1,iqb,ip2,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      if((iq.eq.1).and.(ig1.eq.2).and.(ip2.eq.4).and.(iqb.eq.3))then
        autoBh1g1G=Bh1g1G1(iq,ig1,ip2,iqb,renscale2)
      elseif((iq.eq.1).and.(ig1.eq.3).and.(ip2.eq.4).and.(iqb.eq.2))then
        autoBh1g1G=Bh1g1G3(iq,ig1,ip2,iqb,renscale2)
      elseif((iq.eq.2).and.(ig1.eq.1).and.(ip2.eq.4).and.(iqb.eq.3))then
        autoBh1g1G=Bh1g1G2(iq,ig1,ip2,iqb,renscale2)
      elseif((iq.eq.2).and.(ig1.eq.3).and.(ip2.eq.4).and.(iqb.eq.1))then
        autoBh1g1G=Bh1g1G3(iqb,ig1,ip2,iq,renscale2)
      elseif((iq.eq.3).and.(ig1.eq.1).and.(ip2.eq.4).and.(iqb.eq.2))then
        autoBh1g1G=Bh1g1G2(iqb,ig1,ip2,iq,renscale2)
      elseif((iq.eq.3).and.(ig1.eq.2).and.(ip2.eq.4).and.(iqb.eq.1))then
        autoBh1g1G=Bh1g1G1(iqb,ig1,ip2,iq,renscale2)
      else
        write(*,*) " WARNING: wrong arguments passed to Bh1g1G ",iq,ig1,ip2,iqb
      endif

      autoBh1g1G =  abs(zewfac(1))**2*autoBh1g1G

      return
      end
*
************************************************************************
*
      function autoBt1g1G(iq,ig1,iqb,ip2,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      if((iq.eq.1).and.(ig1.eq.2).and.(ip2.eq.4).and.(iqb.eq.3))then
        autoBt1g1G=Bt1g1G1(iq,ig1,ip2,iqb,renscale2)
      elseif((iq.eq.1).and.(ig1.eq.3).and.(ip2.eq.4).and.(iqb.eq.2))then
        autoBt1g1G=Bt1g1G3(iq,ig1,ip2,iqb,renscale2)
      elseif((iq.eq.2).and.(ig1.eq.1).and.(ip2.eq.4).and.(iqb.eq.3))then
        autoBt1g1G=Bt1g1G2(iq,ig1,ip2,iqb,renscale2)
      elseif((iq.eq.2).and.(ig1.eq.3).and.(ip2.eq.4).and.(iqb.eq.1))then
        autoBt1g1G=Bt1g1G3(iqb,ig1,ip2,iq,renscale2)
      elseif((iq.eq.3).and.(ig1.eq.1).and.(ip2.eq.4).and.(iqb.eq.2))then
        autoBt1g1G=Bt1g1G2(iqb,ig1,ip2,iq,renscale2)
      elseif((iq.eq.3).and.(ig1.eq.2).and.(ip2.eq.4).and.(iqb.eq.1))then
        autoBt1g1G=Bt1g1G1(iqb,ig1,ip2,iq,renscale2)
      else
        write(*,*) " WARNING: wrong arguments passed to Bt1g1G ",iq,ig1,ip2,iqb
      endif

      autoBt1g1G = -abs(zewfac(1))**2*autoBt1g1G

      return
      end
************************************************************************
*
      function B1g1G1(iq,ig1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ig1)
      s23 =s4(iq,ip2)
      s13 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      B1g1G1 =  - 16.D0 - 8.D0*s12**(-1)*s13 - 8.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      B1g1G1 =  + dls * ( 16.D0 + 8.D0*s12**(-1)*s13 + 8.D0*s13*
     &    s23**(-1) )
      B1g1G1 = B1g1G1 + dlx * ( 8.D0 + 4.D0*s12**(-1)*s13 + 4.D0*s13*
     &    s23**(-1) )
      B1g1G1 = B1g1G1 - 80.D0/3.D0 - 40.D0/3.D0*s12**(-1)*s13 - 40.D0/3.D0
     &    *s13*s23**(-1)

      elseif(ieorder.eq.0)then
      B1g1G1 =  + pi**2 * ( 16.D0/3.D0 + 8.D0/3.D0*s12**(-1)*s13 + 8.D0/
     &    3.D0*s13*s23**(-1) )
      B1g1G1 = B1g1G1 + dls * ( 12.D0 + 6.D0*s12**(-1)*s13 + 6.D0*s13*
     &    s23**(-1) )
      B1g1G1 = B1g1G1 + dls**2 * (  - 8.D0 - 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13*s23**(-1) )
      B1g1G1 = B1g1G1 + dlx * ( 6.D0 + 6.D0*s13*s23**(-1) )
      B1g1G1 = B1g1G1 + dlx*dls * (  - 8.D0 - 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13*s23**(-1) )
      B1g1G1 = B1g1G1 - 28.D0 - 14.D0*s12**(-1)*s13 - 14.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function B1g1G2(iq,ig1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ig1)
      s13 =s4(iq,ip2)
      s23 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      B1g1G2 =  - 8.D0 + 8.D0*s12**(-1)*s13 - 8.D0*s13**(-1)*s23

      elseif(ieorder.eq.-1)then
      B1g1G2 =  + dls * ( 8.D0 - 8.D0*s12**(-1)*s13 + 8.D0*s13**(-1)*s23
     &     )
      B1g1G2 = B1g1G2 + dlomx * ( 4.D0 - 4.D0*s12**(-1)*s13 + 4.D0*
     &    s13**(-1)*s23 )
      B1g1G2 = B1g1G2 - 40.D0/3.D0 + 40.D0/3.D0*s12**(-1)*s13 - 40.D0/3.D0
     &    *s13**(-1)*s23

      elseif(ieorder.eq.0)then
      B1g1G2 =  + pi**2 * ( 8.D0/3.D0 - 8.D0/3.D0*s12**(-1)*s13 + 8.D0/3.
     &    D0*s13**(-1)*s23 )
      B1g1G2 = B1g1G2 + dls * ( 6.D0 - 6.D0*s12**(-1)*s13 + 6.D0*
     &    s13**(-1)*s23 )
      B1g1G2 = B1g1G2 + dls**2 * (  - 4.D0 + 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13**(-1)*s23 )
      B1g1G2 = B1g1G2 + dlomx * ( 6.D0 + 6.D0*s13**(-1)*s23 )
      B1g1G2 = B1g1G2 + dlomx*dls * (  - 4.D0 + 4.D0*s12**(-1)*s13 - 4.D0
     &    *s13**(-1)*s23 )
      B1g1G2 = B1g1G2 - 14.D0 + 14.D0*s12**(-1)*s13 - 14.D0*s13**(-1)*s23

      endif
      return
      end
************************************************************************
*
      function B1g1G3(iq,ig1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s13 =s4(iq,ig1)
      s23 =s4(iq,ip2)
      s12 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      B1g1G3 =  - 8.D0*s13**(-1)*s23 - 8.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      B1g1G3 =  + dls * ( 8.D0*s13**(-1)*s23 + 8.D0*s13*s23**(-1) )
      B1g1G3 = B1g1G3 + dlomx * ( 4.D0*s13**(-1)*s23 + 4.D0*s13*s23**(-1)
     &     )
      B1g1G3 = B1g1G3 + dlx * ( 4.D0*s13**(-1)*s23 + 4.D0*s13*s23**(-1) )
      B1g1G3 = B1g1G3 - 40.D0/3.D0*s13**(-1)*s23 - 40.D0/3.D0*s13*
     &    s23**(-1)

      elseif(ieorder.eq.0)then
      B1g1G3 =  + pi**2 * ( 8.D0/3.D0*s13**(-1)*s23 + 8.D0/3.D0*s13*
     &    s23**(-1) )
      B1g1G3 = B1g1G3 + dls * ( 6.D0*s13**(-1)*s23 + 6.D0*s13*s23**(-1) )
      B1g1G3 = B1g1G3 + dls**2 * (  - 4.D0*s13**(-1)*s23 - 4.D0*s13*
     &    s23**(-1) )
      B1g1G3 = B1g1G3 + dlomx * ( 6.D0*s13**(-1)*s23 )
      B1g1G3 = B1g1G3 + dlomx*dls * (  - 4.D0*s13**(-1)*s23 - 4.D0*s13*
     &    s23**(-1) )
      B1g1G3 = B1g1G3 + dlx * ( 6.D0*s13*s23**(-1) )
      B1g1G3 = B1g1G3 + dlx*dls * (  - 4.D0*s13**(-1)*s23 - 4.D0*s13*
     &    s23**(-1) )
      B1g1G3 = B1g1G3 + dlx*dlomx * (  - 4.D0*s13**(-1)*s23 - 4.D0*s13*
     &    s23**(-1) )
      B1g1G3 = B1g1G3 - 14.D0*s13**(-1)*s23 - 14.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function Bh1g1G1(iq,ig1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ig1)
      s23 =s4(iq,ip2)
      s13 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Bh1g1G1 =  0

      elseif(ieorder.eq.-1)then
      Bh1g1G1 =  + 8.D0/3.D0 + 4.D0/3.D0*s12**(-1)*s13 + 4.D0/3.D0*s13*
     &    s23**(-1)

      elseif(ieorder.eq.0)then
      Bh1g1G1 =  0

      endif
      return
      end
************************************************************************
*
      function Bh1g1G2(iq,ig1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ig1)
      s13 =s4(iq,ip2)
      s23 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Bh1g1G2 =  0

      elseif(ieorder.eq.-1)then
      Bh1g1G2 =  + 4.D0/3.D0 - 4.D0/3.D0*s12**(-1)*s13 + 4.D0/3.D0*
     &    s13**(-1)*s23

      elseif(ieorder.eq.0)then
      Bh1g1G2 =  0

      endif
      return
      end
************************************************************************
*
      function Bh1g1G3(iq,ig1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s13 =s4(iq,ig1)
      s23 =s4(iq,ip2)
      s12 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Bh1g1G3 =  0

      elseif(ieorder.eq.-1)then
      Bh1g1G3 =  + 4.D0/3.D0*s13**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1)

      elseif(ieorder.eq.0)then
      Bh1g1G3 =  0

      endif
      return
      end
************************************************************************
*
      function Bt1g1G1(iq,ig1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ig1)
      s23 =s4(iq,ip2)
      s13 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Bt1g1G1 =  + 8.D0 + 4.D0*s12**(-1)*s13 + 4.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      Bt1g1G1 =  + dls * (  - 8.D0 - 4.D0*s12**(-1)*s13 - 4.D0*s13*
     &    s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + dlomx * (  - 8.D0 - 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13*s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + 12.D0 + 6.D0*s12**(-1)*s13 + 6.D0*s13*s23**(-1)

      elseif(ieorder.eq.0)then
      Bt1g1G1 =  + pi**2 * (  - 8.D0/3.D0 - 13.D0/3.D0*s12**(-1)*s13 - 7.
     &    D0/3.D0*s13*s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + dls * (  - 12.D0 - 6.D0*s12**(-1)*s13 - 6.D0*
     &    s13*s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + dls**2 * ( 4.D0 + 2.D0*s12**(-1)*s13 + 2.D0*s13
     &    *s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + dlomx * (  - 8.D0 )
      Bt1g1G1 = Bt1g1G1 + dlomx*dls * ( 8.D0 + 4.D0*s12**(-1)*s13 + 4.D0*
     &    s13*s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + dlomx**2 * (  - 4.D0*s12**(-1)*s13 - 4.D0*s13*
     &    s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + dlx * (  - 2.D0 - 6.D0*s13*s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + dlx*dlomx * ( 4.D0 + 8.D0*s12**(-1)*s13 + 4.D0*
     &    s13*s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + dlx**2 * (  - 2.D0 - 4.D0*s12**(-1)*s13 - 2.D0*
     &    s13*s23**(-1) )
      Bt1g1G1 = Bt1g1G1 + 28.D0 + 14.D0*s12**(-1)*s13 + 14.D0*s13*
     &    s23**(-1)

      endif
      return
      end
************************************************************************
*
      function Bt1g1G2(iq,ig1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ig1)
      s13 =s4(iq,ip2)
      s23 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Bt1g1G2 =  + 4.D0 - 4.D0*s12**(-1)*s13 + 4.D0*s13**(-1)*s23

      elseif(ieorder.eq.-1)then
      Bt1g1G2 =  + dls * (  - 4.D0 + 4.D0*s12**(-1)*s13 - 4.D0*s13**(-1)
     &    *s23 )
      Bt1g1G2 = Bt1g1G2 + dlx * (  - 4.D0 + 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13**(-1)*s23 )
      Bt1g1G2 = Bt1g1G2 + 6.D0 - 6.D0*s12**(-1)*s13 + 6.D0*s13**(-1)*s23

      elseif(ieorder.eq.0)then
      Bt1g1G2 =  + pi**2 * ( 5.D0/3.D0 + 13.D0/3.D0*s12**(-1)*s13 - 7.D0/
     &    3.D0*s13**(-1)*s23 )
      Bt1g1G2 = Bt1g1G2 + dls * (  - 6.D0 + 6.D0*s12**(-1)*s13 - 6.D0*
     &    s13**(-1)*s23 )
      Bt1g1G2 = Bt1g1G2 + dls**2 * ( 2.D0 - 2.D0*s12**(-1)*s13 + 2.D0*
     &    s13**(-1)*s23 )
      Bt1g1G2 = Bt1g1G2 + dlomx * (  - 2.D0 - 6.D0*s13**(-1)*s23 )
      Bt1g1G2 = Bt1g1G2 + dlomx**2 * ( 2.D0 + 4.D0*s12**(-1)*s13 - 2.D0*
     &    s13**(-1)*s23 )
      Bt1g1G2 = Bt1g1G2 + dlx * (  - 8.D0 )
      Bt1g1G2 = Bt1g1G2 + dlx*dls * ( 4.D0 - 4.D0*s12**(-1)*s13 + 4.D0*
     &    s13**(-1)*s23 )
      Bt1g1G2 = Bt1g1G2 + dlx*dlomx * (  - 4.D0 - 8.D0*s12**(-1)*s13 + 4.D
     &    0*s13**(-1)*s23 )
      Bt1g1G2 = Bt1g1G2 + dlx**2 * ( 4.D0 + 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13**(-1)*s23 )
      Bt1g1G2 = Bt1g1G2 + 14.D0 - 14.D0*s12**(-1)*s13 + 14.D0*s13**(-1)*
     &    s23

      endif
      return
      end
************************************************************************
*
      function Bt1g1G3(iq,ig1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s13 =s4(iq,ig1)
      s23 =s4(iq,ip2)
      s12 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Bt1g1G3 =  + 4.D0*s13**(-1)*s23 + 4.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      Bt1g1G3 =  + dls * (  - 4.D0*s13**(-1)*s23 - 4.D0*s13*s23**(-1) )
      Bt1g1G3 = Bt1g1G3 + 6.D0*s13**(-1)*s23 + 6.D0*s13*s23**(-1)

      elseif(ieorder.eq.0)then
      Bt1g1G3 =  + pi**2 * (  - 7.D0/3.D0*s13**(-1)*s23 - 7.D0/3.D0*s13*
     &    s23**(-1) )
      Bt1g1G3 = Bt1g1G3 + dls * (  - 6.D0*s13**(-1)*s23 - 6.D0*s13*
     &    s23**(-1) )
      Bt1g1G3 = Bt1g1G3 + dls**2 * ( 2.D0*s13**(-1)*s23 + 2.D0*s13*
     &    s23**(-1) )
      Bt1g1G3 = Bt1g1G3 + dlomx * (  - 4.D0 - 6.D0*s13**(-1)*s23 )
      Bt1g1G3 = Bt1g1G3 + dlomx**2 * (  - 4.D0 - 2.D0*s13**(-1)*s23 - 4.D0
     &    *s13*s23**(-1) )
      Bt1g1G3 = Bt1g1G3 + dlx * (  - 4.D0 - 6.D0*s13*s23**(-1) )
      Bt1g1G3 = Bt1g1G3 + dlx**2 * (  - 4.D0 - 4.D0*s13**(-1)*s23 - 2.D0*
     &    s13*s23**(-1) )
      Bt1g1G3 = Bt1g1G3 + 14.D0*s13**(-1)*s23 + 14.D0*s13*s23**(-1)

      endif
      return
      end
