c--- libGJRC   --------------------------------------------------------------
c
c     This library contains all the real emission C-type MEs for gamma+jet.
c
c----------------------------------------------------------------------------

      function fullC0g0G(iqb1,iq2,iqb2,iq1,iG)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac1(4),zewfac2(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      
      ave = 1/4d0/nc**2

      fac = ave*(4d0*pi*as)**2*(4d0*pi*amz)*4d0*(nc**2-1d0)

      FullC0g0G = C0g0G(iqb1,iq2,iqb2,iq1,iG)

      FullC0g0G = fac*FullC0g0G
      
      return
      end

*************************************************************

      function C0g0G(iqb1,iq2,iqb2,iq1,iG)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac1(4),zewfac2(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/ nf1,nf2
!$omp threadprivate(/CZFlav/)
      common/order/iorder

      call eweakV2qq(nf1,nf2,0d0)

      C0g0G=0d0

      zi = (0d0,1d0)
      zwt = 0d0

      do ihel=1,4
         do iflip=0,1
            zwt = zwt 
     .           + dconjg( zc1gam0(iqb1,iq2,iqb2,iq1,iG,ihel,iflip))
     .           * zc1gam0(iqb1,iq2,iqb2,iq1,iG,ihel,iflip)
         enddo
      enddo

      C0g0G = real(zwt)/2d0

      return
      end

*************************************************************

      function zc1gam0(iqb1,iq2,iqb2,iq1,iG,ihel,iflip)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac1(4),zewfac2(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      dimension ihel2(4)

      ihel2(1)=1
      ihel2(2)=3
      ihel2(3)=2
      ihel2(4)=4
 
      zwt = real(zewfac1(1))*zc1gam0u0(iqb1,iq2,iqb2,iq1,iG,ihel,iflip)
     .     +real(zewfac2(2))*zc1gam0u0(iqb2,iq1,iqb1,iq2,iG,ihel2(ihel),iflip)

      zc1gam0 = zwt 

      return
      end

*************************************************************
*
*     this is the tree amplitude u_1^(0) = u_2^(0) from hep-ph/9507442v1 
*

      function zc1gam0u0(iqb1,iq2,iqb2,iq1,iG,ihel,iflip)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac1(4),zewfac2(4),zewnull(4)
!$omp threadprivate(/eweakZ/)

      zi = (0d0,1d0)

      i1 = iqb1
      i2 = iq1
      i3 = iG
      i4 = iqb2
      i5 = iq2
 
************************************
*             iflip=0   iflip=1    *
*             qQG       qQG        *
*     ihel=1  +++       ---        *
*     ihel=2  -++       +--        *
*     ihel=3  +-+       -+-        *
*     ihel=4  --+       ++-        *
************************************

      if(iflip.eq.0)then
         za12=zA5(i1,i2)
         za13=zA5(i1,i3)
         za14=zA5(i1,i4)
         za15=zA5(i1,i5)
         za23=zA5(i2,i3)
         za24=zA5(i2,i4)
         za25=zA5(i2,i5)
         za45=zA5(i4,i5)
      elseif(iflip.eq.1)then
         za12=-zB5(i1,i2)
         za13=-zB5(i1,i3)
         za14=-zB5(i1,i4)
         za15=-zB5(i1,i5)
         za23=-zB5(i2,i3)
         za24=-zB5(i2,i4)
         za25=-zB5(i2,i5)
         za45=-zB5(i4,i5)
      endif   

      if(ihel.eq.1)then
         zn = -za14**2 
      elseif(ihel.eq.2)then   
         zn = za24**2
      elseif(ihel.eq.3)then   
         zn = za15**2
      elseif(ihel.eq.4)then   
         zn = -za25**2
      endif   

      zd = za45*za13*za23

      zc1gam0u0 = zi*zn/zd

      return
      end

*************************************************************

