c--- libGJRD   --------------------------------------------------------------
c
c     This library contains all the real emission D-type MEs for gamma+jet.
c
c----------------------------------------------------------------------------

      function fullD0g0G(iqb1,iq2,iqb2,iq1,iG)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac1(4),zewfac2(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      
      ave = 1/4d0/nc**2

      fac = ave*(4d0*pi*as)**2*(4d0*pi*amz)*4d0*(nc**2-1d0)/nc

      FullD0g0G = D0g0G(iqb1,iq2,iqb2,iq1,iG)

      FullD0g0G = -fac*FullD0g0G
      
      return
      end

*************************************************************

      function D0g0G(iqb1,iq2,iqb2,iq1,iG)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac1(4),zewfac2(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/ nf1,nf2
!$omp threadprivate(/CZFlav/)
      common/order/iorder
      dimension ihelD(2)

      call eweakV2qq(nf1,nf2,0d0)

c     interfernce only if quarks have same helicity
      ihelD(1)=1
      ihelD(2)=4
      
      D0g0G=0d0

      zi = (0d0,1d0)

      zwt = 0d0

      do ii=1,2
         do iflip=0,1
            zord12 = dconjg( zc1gam0(iqb1,iq2,iqb2,iq1,iG,ihelD(ii),iflip))
     .              * zc1gam0(iqb2,iq2,iqb1,iq1,iG,ihelD(ii),iflip)

            zwt = zwt + zord12
         enddo
      enddo

      D0g0G = -real(zwt)

      return
      end
 
*************************************************************
* A wrapper function for D0g0G where it inherits the flavours
* from the matrix element B2g0G
*

      function BD0g0G(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /BZFlav/ nf2g
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nf1,nf2
!$omp threadprivate(/CZFlav/)

      nf1 = nf2g
      nf2 = nf2g

      BD0g0G = D0g0G(i1,i2,i3,i4,i5)

      return
      end

*************************************************************

