c--- libGJRRB  --------------------------------------------------------------
c
c     This library contains all the double-real B-type MEs for gamma+jet.
c     Using functions from jet libB.f and GG+j MEwrapperGG.f.
c
c----------------------------------------------------------------------------

      function fullB3g0G(iqb,ig1,ig2,ig3,iq,iG)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)

      if(iqb.le.2.and.iq.le.2) then
         ave = 1/4d0/nc**2
      elseif(iqb.gt.2.and.iq.gt.2) then
         ave = 1/4d0/(nc**2-1d0)**2
      else   
         ave = 1/4d0/nc/(nc**2-1d0)
      endif   
      
      fac = ave*(4d0*pi*as)**3*(4d0*pi*amz)*4d0*nc**2*(nc**2-1d0)/2d0

      FullB3g0G = ( B3g0G(iqb,ig1,ig2,ig3,iq,iG)
     .             +B3g0G(iqb,ig1,ig3,ig2,iq,iG)
     .             +B3g0G(iqb,ig2,ig3,ig1,iq,iG)
     .             +B3g0G(iqb,ig2,ig1,ig3,iq,iG)
     .             +B3g0G(iqb,ig3,ig1,ig2,iq,iG)
     .             +B3g0G(iqb,ig3,ig2,ig1,iq,iG))
     .     -1d0/dble(nc)**2*(
     .              Bt3g0G(iqb,ig1,ig2,ig3,iq,iG)
     .             +Bt3g0G(iqb,ig1,ig3,ig2,iq,iG)
     .             +Bt3g0G(iqb,ig2,ig3,ig1,iq,iG)
     .             +Bt3g0G(iqb,ig2,ig1,ig3,iq,iG)
     .             +Bt3g0G(iqb,ig3,ig1,ig2,iq,iG)
     .             +Bt3g0G(iqb,ig3,ig2,ig1,iq,iG))
     .     +1d0/dble(nc)**4*(nc**2+1d0)*(
     .              Btt3g0G(iqb,ig1,ig2,ig3,iq,iG))

      FullB3g0G = fac*FullB3g0G

      return
      end

*************************************************************

      function B3g0G(iqb,ig4,ig3,ig2,iq,iG)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer aux
      COMPLEX*16 M(24,14),zR(24)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)
      dimension j1(3),j2(8),j3(11),j4(23)

      call eweakV1qq(nflav,0d0)

      do J=1,14
         M(1,J)=zB4g0(iqb,iq,iG,ig2,ig3,ig4,J)
         M(7,J)=zB4g0(iqb,iq,ig2,iG,ig3,ig4,J)
         M(9,J)=zB4g0(iqb,iq,ig2,ig3,iG,ig4,J)
         M(10,J)=zB4g0(iqb,iq,ig2,ig3,ig4,iG,J)
      enddo

      Bt=0d0
      
      do i=1,14
         call B4g0heliords(i,j1,j2,j3,j4)
         ztmp=M(1,i)+M(7,j1(1))+M(9,j1(2))+M(10,j1(3))
         Bt=Bt+ztmp*dconjg(ztmp)
      enddo

      B3g0G=abs(zewfac(1))**2*Bt

      return
      end

*******************************************************************
* A wrapper function for returning the normal
* matrix element for situations where either quark or
* antiquark are in the initial state. Otherwise
* it will return a line reversal symmetrised matrix element
*
*

      function sB3g0G(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i5.le.2))then
         sB3g0G=B3g0G(i1,i2,i3,i4,i5,i6)
      else
         sB3g0G=0.5d0*(B3g0G(i1,i2,i3,i4,i5,i6)+B3g0G(i5,i4,i3,i2,i1,i6))
      endif

      return
      end
      
********************************************************************************

*     first subleading contribution is leading contribution to RRB GG+j 
*     in GG/MEwrapperGG.f

      function Bt3g0G(iqb,ig2,ig3,ig4,iq,iG)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      Bt3g0G=B2g0GG(iqb,ig3,ig2,iq,ig4,iG)/abs(zewfac(1))**2

      return
      end

*******************************************************************
* A wrapper function for returning the normal
* matrix element for situations where either quark or
* antiquark are in the initial state. Otherwise
* it will return a line reversal symmetrised matrix element
*
*

      function sBt3g0G(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i5.le.2))then
         sBt3g0G=Bt3g0G(i1,i2,i3,i4,i5,i6)
      else
         sBt3g0G=0.5d0*(Bt3g0G(i1,i2,i3,i4,i5,i6)+Bt3g0G(i5,i4,i3,i2,i1,i6))
      endif

      return
      end

********************************************************************************

*     most subleading contribution is subleading contribution to RRB GG+j
*     in GG/MEwrapperGG.f

      function Btt3g0G(iqb,ig2,ig3,ig4,iq,iG)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      Btt3g0G=Bt2g0GG(iqb,ig3,ig2,iq,ig4,iG)/abs(zewfac(1))**2

      return
      end

*******************************************************************
* A wrapper function for returning the normal
* matrix element for situations where either quark or
* antiquark are in the initial state. Otherwise
* it will return a line reversal symmetrised matrix element
*
*
      
      function sBtt3g0G(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i5.le.2))then
         sBtt3g0G=Btt3g0G(i1,i2,i3,i4,i5,i6)
      else
         sBtt3g0G=0.5d0*(Btt3g0G(i1,i2,i3,i4,i5,i6)+Btt3g0G(i5,i4,i3,i2,i1,i6))
      endif

      return
      end

*******************************************************************************
