c--- libGJRRD  --------------------------------------------------------------
c
c     This library contains all the double-real D-type MEs for gamma+jet.
c
c----------------------------------------------------------------------------

      function fullD1g0G(iqb1,ig1,iq2,iqb2,iq1,iG)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac1(4),zewfac2(4)
!$omp threadprivate(/eweakZ/)
      
      if(ig1.gt.2) then
         ave = 1/4d0/nc**2
      else
         ave = 1/4d0/nc/(nc**2-1d0)
      endif   

      fac = ave*(4d0*pi*as)**3*(4d0*pi*amz)*4d0*nc**2*(nc**2-1d0)

      FullD1g0G = -1d0/dble(nc)**2*D1g0Gc(iqb1,ig1,iq2,iqb2,iq1,iG)
     .     +1d0/dble(nc)**4*(
     .            Dt1g0G(iqb1,ig1,iq2,iqb2,iq1,iG))

      FullD1g0G = fac*FullD1g0G
      
      return
      end

*************************************************************

      function D1g0Gc(iqb1,ig1,iq2,iqb2,iq1,iG)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      dimension ihelD(4)

      !Only those interferences with hel(q1)=hel(q2) survive!

      ihelD(1)=1
      ihelD(2)=4
      ihelD(3)=5
      ihelD(4)=7

      wt=0d0

      do ii=1,4
      do iflip=0,1

         zA10ij = zC1g0Ga(iqb1,iq1,iqb2,iq2,ig1,iG,ihelD(ii),iflip)
         zA10ji = zC1g0Ga(iqb2,iq1,iqb1,iq2,ig1,iG,ihelD(ii),iflip)
         zA01ij = zC1g0Gb(iqb1,iq1,iqb2,iq2,ig1,iG,ihelD(ii),iflip)
         zA01ji = zC1g0Gb(iqb2,iq1,iqb1,iq2,ig1,iG,ihelD(ii),iflip)

         zB10ij = zCt1g0Ga(iqb1,iq1,iqb2,iq2,ig1,iG,ihelD(ii),iflip)
         zB10ji = zCt1g0Ga(iqb2,iq1,iqb1,iq2,ig1,iG,ihelD(ii),iflip)
         zB01ij = zCt1g0Gb(iqb1,iq1,iqb2,iq2,ig1,iG,ihelD(ii),iflip)
         zB01ji = zCt1g0Gb(iqb2,iq1,iqb1,iq2,ig1,iG,ihelD(ii),iflip)

         zA1001ij = zA10ij+zA01ij
         zA1001ji = zA10ji+zA01ji

         wt = wt + real(  zA1001ij*dconjg(zA1001ji)
     .                  - zA10ji*dconjg(zB01ij) - zA01ji*dconjg(zB10ij)
     .                  - zA10ij*dconjg(zB01ji) - zA01ij*dconjg(zB10ji))

      enddo
      enddo

      D1g0Gc = -wt ! why the minus?

      return
      end

********************************************************************************
*
*     Dt1g0G
*

      function Dt1g0G(iqb1,ig1,iq2,iqb2,iq1,iG)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      dimension ihelD(4)

      !Only those interferences with hel(q1)=hel(q2) survive!

      ihelD(1)=1
      ihelD(2)=4
      ihelD(3)=5
      ihelD(4)=7

      wt=0d0

      do ii=1,4
      do iflip=0,1

         zB10ij = zCt1g0Ga(iqb1,iq1,iqb2,iq2,ig1,iG,ihelD(ii),iflip)
         zB10ji = zCt1g0Ga(iqb2,iq1,iqb1,iq2,ig1,iG,ihelD(ii),iflip)
         zB01ij = zCt1g0Gb(iqb1,iq1,iqb2,iq2,ig1,iG,ihelD(ii),iflip)
         zB01ji = zCt1g0Gb(iqb2,iq1,iqb1,iq2,ig1,iG,ihelD(ii),iflip)

         zB1001ij = zB10ij+zB01ij
         zB1001ji = zB10ji+zB01ji

         wt = wt + real(zB1001ij*dconjg(zB1001ji))

      enddo
      enddo

      Dt1g0G = -wt 

      return
      end

********************************************************************************
