c--- libGJVB   --------------------------------------------------------------
c
c     This library contains all the virtual B-type MEs for gamma+jet.
c
c----------------------------------------------------------------------------

      function fullB1g1G(iqb,ig1,iq,iG,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac1(4),zewfac2(4)
!$omp threadprivate(/eweakZ/)

      if(ig1.le.2.and.iG.gt.2) then
         ave = 1/4d0/nc/(nc**2-1d0)
      elseif(ig1.gt.2.and.iG.gt.2)then
         ave = 1/4d0/nc**2
      elseif(ig1.gt.2.and.iG.le.2)then
         ave = 1/4d0/nc
      else
         ave = 1/4d0/(nc**2-1d0)
      endif   
 
!      fac = ave*(4d0*pi*as)**2*(4d0*pi*amz)*4d0*nc*(nc**2-1d0)/(8d0*pi**2)

      facV = ave*(4d0*pi*as)**2*(4d0*pi*amz)*nc*(nc**2-1)/2d0/pi**2
      
      aB1g1G=handB1g1G(iqb,ig1,iq,iG,renscale2)
      aBh1g1G=handBh1g1G(iqb,ig1,iq,iG,renscale2)
      aBt1g1G=handBt1g1G(iqb,ig1,iq,iG,renscale2)

      FullB1g1G=                 +aB1g1G
     .        +dble(nf)/dble(nc)*aBh1g1G
     .        -1d0/dble(nc)**(2)*aBt1g1G

      FullB1g1G = facV*FullB1g1G

      return
      end

*************************************************************

      function handB1g1G(iqb,ig1,iq,iG,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)
      common/order/iorder
      dimension ihel2(2)

      call eweakV1qq(nflav,0d0)

      handB1g1G = 0d0
      zwt = 0d0
      
      ihel2(1) = 2
      ihel2(2) = 1

      do ihel=1,2
         do iflip=0,1
            zwt = zwt
     .           +dconjg( zA4tree(iqb,ig1,iG,iq,ihel,iflip)
     .                   +zA4tree(iqb,iG,ig1,iq,ihel2(ihel),iflip))
     .           *(-zA4Lnonadj(iqb,ig1,iG,iq,ihel,iflip,renscale2))
         enddo   
      enddo   

      handB1g1G = abs(zewfac(1))**2*real(zwt)/2d0

      if (iorder .eq. -1) then
c     UV counter term at order 1/e to renormalise the matrix element in the MS bar scheme
         subuv = 11d0/6d0
         handB1g1G = handB1g1G - subuv*B1g0G(iqb,ig1,iq,iG)
      elseif (iorder .eq. 0)then
c     +pi**2/6d0 comes from a correction for C(e)
c     -1/2 comes from a conversion of four-dimensional helicity scheme (FDH) to 't Hooft-Veltman (HV) scheme
c     see hep-ph/9708239v1 equation 6.4 or hep-ph/9409393 equation 5.5
         e0 = pi**2/6d0*1d0 - 0.5d0
         handB1g1G = handB1g1G + e0*B1g0G(iqb,ig1,iq,iG)
      endif
      
      return
      end

*************************************************************

      function handBt1g1G(iqb,ig1,iq,iG,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)
      common/order/iorder
      dimension ihel2(2)

      call eweakV1qq(nflav,0d0)

      handBt1g1G = 0d0
      zwt = 0d0
      
      ihel2(1) = 2
      ihel2(2) = 1

      do ihel=1,2
         do iflip=0,1
            zAL = zA4Ladj(iqb,ig1,iG,iq,ihel,iflip,renscale2)
     .           +zA4Ladj(iqb,iG,ig1,iq,ihel2(ihel),iflip,renscale2) 
            zASUSY = zA4SUSY(iqb,ig1,iG,iq,ihel,iflip,renscale2)
     .              +zA4SUSY(iqb,iG,ig1,iq,ihel2(ihel),iflip,renscale2) 
            zAtree = zA4tree(iqb,ig1,iG,iq,ihel,iflip)
     .              +zA4tree(iqb,iG,ig1,iq,ihel2(ihel),iflip)
            zwt = zwt + dconjg(zAtree)*(zAL-zASUSY)
         enddo   
      enddo   

      handBt1g1G = -abs(zewfac(1))**2*real(zwt)/2d0

      if (iorder .eq. 0)then
c     pi**2/12d0 comes from a correction for C(e)
c     -1/2 comes from a conversion of four-dimensional helicity scheme (FDH) to 't Hooft-Veltman (HV) scheme
c     see hep-ph/9708239v1 equation 6.4 or hep-ph/9409393 equation 5.5
         e0 = pi**2/12d0*1d0 - 0.5d0
         handBt1g1G = handBt1g1G + e0*B1g0G(iqb,ig1,iq,iG)
      endif
      
      return
      end

*************************************************************

      function handBh1g1G(iqb,ig1,iq,iG,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)
      common/order/iorder

      call eweakV1qq(nflav,0d0)

      if(iorder.eq.-2)then
         handBh1g1G = 0d0
      elseif(iorder.eq.-1)then
         handBh1g1G = 1d0/3d0*B1g0G(iqb,ig1,iq,iG)
      elseif(iorder.eq.0)then   
         handBh1g1G = 0d0
      endif   

c     Note: the NF part only contributes through the renormalisation correction

      return
      end

*************************************************************
*
*     A_4^SUSY in appendix II of  hep-ph/9409393v3
*

      function zA4SUSY(iqb,ig1,ig2,iq,ihel,iflip,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)
      common/order/iorder

      zi = (0d0,1d0)
    
c                      qb q g1 g2
c     iflip=0,ihel=1   -+-+        
c     iflip=0,ihel=2   -++-
c
c     iflip=1,ihel=1   +-+-        
c     iflip=1,ihel=2   +--+

      j1 = iqb
      j2 = iq
      j3 = ig1
      j4 = ig2

      if(iflip.eq.0)then
        za12=zA4(j1,j2)
        za21=zA4(j2,j1)
        za13=zA4(j1,j3)
        za31=zA4(j3,j1)
        za14=zA4(j1,j4)
        za41=zA4(j4,j1)
        za23=zA4(j2,j3)
        za32=zA4(j3,j2)
        za24=zA4(j2,j4)
        za42=zA4(j4,j2)
        za34=zA4(j3,j4)
        za43=zA4(j4,j3)
      elseif(iflip.eq.1)then
        za12=-zB4(j1,j2)
        za21=-zB4(j2,j1)
        za13=-zB4(j1,j3)
        za31=-zB4(j3,j1)
        za14=-zB4(j1,j4)
        za41=-zB4(j4,j1)
        za23=-zB4(j2,j3)
        za32=-zB4(j3,j2)
        za24=-zB4(j2,j4)
        za42=-zB4(j4,j2)
        za34=-zB4(j3,j4)
        za43=-zB4(j4,j3)
      endif   

      s12 = s4(j1,j2)
      s13 = s4(j1,j3)
      s14 = s4(j1,j4)
      s23 = s4(j2,j3)
      s24 = s4(j2,j4)
      s34 = s4(j3,j4)
  
      s21 = s4(j1,j2)
      s31 = s4(j1,j3)
      s41 = s4(j1,j4)
      s32 = s4(j2,j3)
      s42 = s4(j2,j4)
      s43 = s4(j3,j4)

      if(iorder.eq.-2)then
         if(ihel.eq.1)then
            zVSUSY = -4d0
            zFSUSY = 0d0
         elseif(ihel.eq.2)then
            zVSUSY = -4d0
            zFSUSY = 0d0
         endif   
      elseif(iorder.eq.-1)then
         if(ihel.eq.1)then
            zVSUSY = -2*((zzlog(renscale2) - zzlog(-s12))
     .                  +(zzlog(renscale2) - zzlog(-s23)))        
     .              -3d0
            zFSUSY = 0d0
         elseif(ihel.eq.2)then
            zVSUSY = -2*((zzlog(renscale2) - zzlog(-s12))
     .                 +(zzlog(renscale2) - zzlog(-s23)))        
     .              -3d0
            zFSUSY = 0d0
         endif   
      elseif(iorder.eq.0)then   
         if(ihel.eq.1)then
            zVSUSY = -2*(0.5d0*(zzlog(renscale2) - zzlog(-s12))**2
     .                  +0.5d0*(zzlog(renscale2) - zzlog(-s23))**2)        
     .               +(zzlog(-s12) - zzlog(-s23))**2
     .               +pi**2
     .               -3d0/2d0*((zzlog(renscale2) - zzlog(-s12))
     .                       +(zzlog(renscale2) - zzlog(-s23)))      
     .               -6d0     
            zFSUSY = 3d0*za13**3*za23/za12/za23/za34/za41
     .               *( -s12*s23/2d0/s13**2
     .                  *(( zzlog(-s12) - zzlog(-s23))**2 + pi**2)
     .                  +(s12-s23)/2d0/s13
     .                  *( zzlog(-s12) - zzlog(-s23)))    
         elseif(ihel.eq.2)then
            zVSUSY = -2*(0.5d0*(zzlog(renscale2) - zzlog(-s12))**2
     .                  +0.5d0*(zzlog(renscale2) - zzlog(-s23))**2)        
     .               +(zzlog(-s12) - zzlog(-s23))**2
     .               +pi**2
     .               -3d0*(zzlog(renscale2) - zzlog(-s12))
     .               -6d0   
            zFSUSY = 0d0
         endif   
      endif   

         ztree = zA4tree(j1,j3,j4,j2,ihel,iflip)

         zA4SUSY = zVSUSY*ztree + zi*zFSUSY

      return
      end

*************************************************************
*
*     A_4^L in appendix II of  hep-ph/9409393v3
*     adjacent quarks, i.e. usual ordering 1qb,2q,3g,4g
*

      function zA4Ladj(iqb,ig1,ig2,iq,ihel,iflip,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)
      common/order/iorder

      zi = (0d0,1d0)
    
c                      qb q g1 g2
c     iflip=0,ihel=1   -+-+        
c     iflip=0,ihel=2   -++-
c
c     iflip=1,ihel=1   +-+-        
c     iflip=1,ihel=2   +--+

      j1 = iqb
      j2 = iq
      j3 = ig1
      j4 = ig2

      if(iflip.eq.0)then
        za12=zA4(j1,j2)
        za21=zA4(j2,j1)
        za13=zA4(j1,j3)
        za31=zA4(j3,j1)
        za14=zA4(j1,j4)
        za41=zA4(j4,j1)
        za23=zA4(j2,j3)
        za32=zA4(j3,j2)
        za24=zA4(j2,j4)
        za42=zA4(j4,j2)
        za34=zA4(j3,j4)
        za43=zA4(j4,j3)
      elseif(iflip.eq.1)then
        za12=-zB4(j1,j2)
        za21=-zB4(j2,j1)
        za13=-zB4(j1,j3)
        za31=-zB4(j3,j1)
        za14=-zB4(j1,j4)
        za41=-zB4(j4,j1)
        za23=-zB4(j2,j3)
        za32=-zB4(j3,j2)
        za24=-zB4(j2,j4)
        za42=-zB4(j4,j2)
        za34=-zB4(j3,j4)
        za43=-zB4(j4,j3)
      endif   

      s12 = s4(j1,j2)
      s13 = s4(j1,j3)
      s14 = s4(j1,j4)
      s23 = s4(j2,j3)
      s24 = s4(j2,j4)
      s34 = s4(j3,j4)
  
      s21 = s4(j1,j2)
      s31 = s4(j1,j3)
      s41 = s4(j1,j4)
      s32 = s4(j2,j3)
      s42 = s4(j2,j4)
      s43 = s4(j3,j4)

      if(iorder.eq.-2)then
         if(ihel.eq.1)then
            zVL = -3d0
            zFL = 0d0
         elseif(ihel.eq.2)then
            zVL = -3d0
            zFL = 0d0
         endif   
      elseif(iorder.eq.-1)then
         if(ihel.eq.1)then
            zVL = -2*((zzlog(renscale2) - zzlog(-s12))
     .               +(zzlog(renscale2) - zzlog(-s23)))        
     .            +(zzlog(renscale2) - zzlog(-s12))
     .            -3d0/2d0
            zFL = 0d0
         elseif(ihel.eq.2)then
            zVL = -2*((zzlog(renscale2) - zzlog(-s12))
     .               +(zzlog(renscale2) - zzlog(-s23)))        
     .            +(zzlog(renscale2) - zzlog(-s12))
     .            -3d0/2d0
            zFL = 0d0
         endif   
      elseif(iorder.eq.0)then   
         if(ihel.eq.1)then
            zVL = -2*(0.5d0*(zzlog(renscale2) - zzlog(-s12))**2
     .               +0.5d0*(zzlog(renscale2) - zzlog(-s23))**2)        
     .            +(zzlog(-s12) - zzlog(-s23))**2
     .            +pi**2
     .            +0.5d0*(zzlog(renscale2) - zzlog(-s12))**2
     .            -3d0/2d0*(zzlog(renscale2) - zzlog(-s12))
     .            -5d0/2d0
            zFL = za13**3*za23/za12/za23/za34/za41*s12/2d0/s13
     .               *((3d0-2d0*s23/s13)
     .                 *(zzlog(-s12)-zzlog(-s23))
     .                 +(s12**2/s13**2-3d0*s23/s13)
     .                 *((zzlog(-s12)-zzlog(-s23))**2 + pi**2) +1d0)
         elseif(ihel.eq.2)then
            zVL = -2*(0.5d0*(zzlog(renscale2) - zzlog(-s12))**2
     .               +0.5d0*(zzlog(renscale2) - zzlog(-s23))**2)        
     .            +(zzlog(-s12) - zzlog(-s23))**2
     .            +pi**2
     .            +0.5d0*(zzlog(renscale2) - zzlog(-s12))**2
     .            -3d0/2d0*(zzlog(renscale2) - zzlog(-s12))
     .            -5d0/2d0
            zFL = za14**3*za24/za12/za23/za34/za41*s12/2d0/s13
     .            *((zzlog(-s12)-zzlog(-s23))**2 + pi**2)
         endif   
      endif   

         ztree = zA4tree(j1,j3,j4,j2,ihel,iflip)

         zA4Ladj = zVL*ztree + zi*zFL

      return
      end

*************************************************************
*
*     A_4^L in appendix II of  hep-ph/9409393v3
*     non-adjacent quarks, i.e. ordering 1qb,2g,3q,4g
*

      function zA4Lnonadj(iqb,ig1,ig2,iq,ihel,iflip,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)
      common/order/iorder

      zi = (0d0,1d0)
    
c                      qb q g1 g2
c     iflip=0,ihel=1   -+-+        
c     iflip=0,ihel=2   -++-
c
c     iflip=1,ihel=1   +-+-        
c     iflip=1,ihel=2   +--+
c
c     see II.16 for relation between helicities

      if(ihel.eq.1)then
         j1 = iqb
         j2 = ig1
         j3 = iq
         j4 = ig2
      elseif(ihel.eq.2)then
         j1 = iqb
         j2 = ig2
         j3 = iq
         j4 = ig1
      endif

      if(iflip.eq.0)then
        za12=zA4(j1,j2)
        za21=zA4(j2,j1)
        za13=zA4(j1,j3)
        za31=zA4(j3,j1)
        za14=zA4(j1,j4)
        za41=zA4(j4,j1)
        za23=zA4(j2,j3)
        za32=zA4(j3,j2)
        za24=zA4(j2,j4)
        za42=zA4(j4,j2)
        za34=zA4(j3,j4)
        za43=zA4(j4,j3)
      elseif(iflip.eq.1)then
        za12=-zB4(j1,j2)
        za21=-zB4(j2,j1)
        za13=-zB4(j1,j3)
        za31=-zB4(j3,j1)
        za14=-zB4(j1,j4)
        za41=-zB4(j4,j1)
        za23=-zB4(j2,j3)
        za32=-zB4(j3,j2)
        za24=-zB4(j2,j4)
        za42=-zB4(j4,j2)
        za34=-zB4(j3,j4)
        za43=-zB4(j4,j3)
      endif   

      s12 = s4(j1,j2)
      s13 = s4(j1,j3)
      s14 = s4(j1,j4)
      s23 = s4(j2,j3)
      s24 = s4(j2,j4)
      s34 = s4(j3,j4)
  
      s21 = s4(j1,j2)
      s31 = s4(j1,j3)
      s41 = s4(j1,j4)
      s32 = s4(j2,j3)
      s42 = s4(j2,j4)
      s43 = s4(j3,j4)


      zFL = 0d0

      if(iorder.eq.-2)then
         ztree = zi*za12**3*za32/za12/za23/za34/za41 
         zVL = -2d0
      elseif(iorder.eq.-1)then
         ztree = zi*za12**3*za32/za12/za23/za34/za41 
         zVL = (-2d0*((zzlog(renscale2) - zzlog(-s12))
     .             +(zzlog(renscale2) - zzlog(-s23)))
     .          -3d0)/2d0
      elseif(iorder.eq.0)then      
         ztree = zi*za12**3*za32/za12/za23/za34/za41 
         zVL = (-2*(0.5d0*(zzlog(renscale2) - zzlog(-s12))**2
     .             +0.5d0*(zzlog(renscale2) - zzlog(-s23))**2)        
     .          +(zzlog(-s12) - zzlog(-s23))**2
     .          +pi**2  
     .          -3d0*(zzlog(renscale2) - zzlog(-s23))
     .          -6d0 )/2d0
      endif   

      zA4Lnonadj = zVL*ztree + zi*zFL

      return
      end

*************************************************************
