************************************************************
*     a wrapper to switch between hand-coded (handB~) and  *
*     autogenerated (autoB~) virtual MEs for gamma+jet     *
************************************************************
      
      function B1g1G(iqb,ig1,iq,ip2,renscale2)
      implicit real*8(a-h,o-y)

!      B1g1G=handB1g1G(iqb,ig1,iq,ip2,renscale2)
      B1g1G=autoB1g1G(iq,ig1,iqb,ip2,renscale2)/4d0

      return
      end

      function Bh1g1G(iqb,ig1,iq,ip2,renscale2)
      implicit real*8(a-h,o-y)

!      Bh1g1G=handBh1g1G(iqb,ig1,iq,ip2,renscale2)
      Bh1g1G=autoBh1g1G(iq,ig1,iqb,ip2,renscale2)/4d0
      
      return
      end

      function Bt1g1G(iqb,ig1,iq,ip2,renscale2)
      implicit real*8(a-h,o-y)

!      Bt1g1G=handBt1g1G(iqb,ig1,iq,ip2,renscale2)
      Bt1g1G=autoBt1g1G(iq,ig1,iqb,ip2,renscale2)/4d0
      
      return
      end

***************************************************
*     flavour-inheritance and symmetrizations     *
***************************************************

      function sB1g1G(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sB1g1G = 0.5d0*(B1g1G(i1,i2,i3,i4,renscale2)+
     $     B1g1G(i3,i2,i1,i4,renscale2))

      return
      end

***************************************************************************
*
      function f1B1g1G(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf1
         f1B1g1G = B1g1G(i1,i2,i3,i4,renscale2)
      else
         write(*,*) "Error f1B2g0G: flavours have not been initialised"
         stop
      endif

      return
      end

***************************************************************************
*
      function f2B1g1G(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf2
         f2B1g1G = B1g1G(i1,i2,i3,i4,renscale2)
      else
         write(*,*) "Error f1B2g0G: flavours have not been initialised"
         stop
      endif

      return
      end


***************************************************************************
*
      function sBt1g1G(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sBt1g1G =0.5d0*(Bt1g1G(i1,i2,i3,i4,renscale2)+
     $     Bt1g1G(i3,i2,i1,i4,renscale2))

      return
      end

***************************************************************************
*
      function f1Bt1g1G(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf1
         f1Bt1g1G = Bt1g1G(i1,i2,i3,i4,renscale2)
      else
         write(*,*) "Error f1B2g0G: flavours have not been initialised"
         stop
      endif

      return
      end

***************************************************************************
*
      function f2Bt1g1G(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf2
         f2Bt1g1G = Bt1g1G(i1,i2,i3,i4,renscale2)
      else
         write(*,*) "Error f1B2g0G: flavours have not been initialised"
         stop
      endif

      return
      end

***************************************************************************
*
      function sBh1g1G(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sBh1g1G = 0.5d0*(Bh1g1G(i1,i2,i3,i4,renscale2)+
     $     Bh1g1G(i3,i2,i1,i4,renscale2))

      return
      end

***************************************************************************
*
      function f1Bh1g1G(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf1
         f1Bh1g1G = Bh1g1G(i1,i2,i3,i4,renscale2)
      else
         write(*,*) "Error f1B2g0G: flavours have not been initialised"
         stop
      endif

      return
      end

***************************************************************************
*
      function f2Bh1g1G(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf2
         f2Bh1g1G = Bh1g1G(i1,i2,i3,i4,renscale2)
      else
         write(*,*) "Error f1B2g0G: flavours have not been initialised"
         stop
      endif

      return
      end

***************************************************************************
*
