      function FullB2g1GG(i1,i2,i3,i4)
      use KinData_mod
      use Constants_mod
      use GGconst
      implicit complex*16(z)
      integer, parameter :: dp = kind(1.0d0)
      real(dp) :: ave, fac, as, amz
      real(dp) :: g2qcd, facB, facV, facVV, facB2g1GG
      real(dp) :: B2g1GG, FullB2g1GG
      integer :: i1, i2, i3, i4 
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)

      if(i1.gt.2.and.i2.gt.2) then
      write(*,*) "warning: calling FullB2g1GG as photon-initiated"
         ave =1d0/4d0
      elseif(i1.le.2.and.i2.le.2) then 
         ave = 1d0/(2d0*(nc**2-1d0))**2
      else
      write(*,*) "warning: calling FullB2g1GG as photon-initiated"         
         ave = 1d0/2d0/(2d0*(nc**2-1d0))
      endif

      g2qcd = (4d0*pi*as)

      facB=(4d0*pi*amz)**2*nc*8d0/2d0

      facV=facB*nc*g2qcd/(8d0*pi**2)
      facVV=facV*nc*g2qcd/(8d0*pi**2)
      
      facB2g1GG = facVV/nc**3

      FullB2g1GG = ave*facB2g1GG*B2g1GG(i1,i2,i3,i4)

!      write(*,*) "FullB2g1GG", ave,facB2g1GG,FullB2g1GG

      return     
      end


      function zampB2g1GG(s,t,u)
      use Constants_mod
      implicit none
      integer, parameter :: dp = kind(1.0d0)
      real(dp) :: s,t,u, ReM, ImM, lgtu, Hvsdtu, Hvsdt, Hvsdu
      complex(dp) :: zampB2g1GG
      
      lgtu = Log(Abs(t/u))
      Hvsdtu = 0.5d0*(1d0 + sign(1d0,t/u))
      Hvsdt = 0.5d0*(1d0 + sign(1d0,t))
      Hvsdu = 0.5d0*(1d0 + sign(1d0,u))

      ReM = 1 + ((t-u)/s)*lgtu + ((t**2+u**2)/(2d0*s**2))*(lgtu**2+pi**2*Hvsdtu)
      ImM = -pi*(Hvsdt-Hvsdu)*((t-u)/s+(t**2+u**2)*lgtu/s**2)
      
      zampB2g1GG = ReM + (0d0,1d0)*ImM
      return
      end


! g(1) + g(2) --> G(3) + G(4)
      function B2g1GG(i1,i2,i3,i4)
      use KinData_mod
      use Constants_mod
      use GGconst
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, parameter :: dp = kind(1.0d0)
      integer :: h1,h2,h3,h4
      real(dp) :: Qsum
      complex*16 zamp(2,2,2,2)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /order2l/ieorder

      if (ieorder.eq.0) then

         B2g1GG = 0d0

         s = s4(i1,i2)
         t = s4(i1,i3)
         u = s4(i1,i4)
         
         zamp(2,2,2,2) = zampB2g1GG(s,t,u)
         zamp(2,2,2,1) = 1d0
         
         zamp(2,2,1,2) = 1d0
         zamp(2,2,1,1) = -1d0
         
         zamp(2,1,2,2) = 1d0
         zamp(2,1,2,1) = zampB2g1GG(u,t,s)
      
         zamp(2,1,1,2) = zampB2g1GG(t,s,u)
         zamp(2,1,1,1) = 1d0

         do h2 = 1,2
            do h3 = 1,2
               do h4 = 1,2
                  zamp(1,h2,h3,h4) = zamp(2,3-h2,3-h3,3-h4)
               enddo
            enddo
         enddo
         
         do h1 = 1,2
            do h2 = 1,2
               do h3 = 1,2
                  do h4 = 1,2
                     B2g1GG = B2g1GG + abs(zamp(h1,h2,h3,h4))**2
                  enddo
               enddo
            enddo
         enddo
         
! these parameters are set in GGconst
         Qsum = nup*qup**2 + ndown*qdown**2

         B2g1GG = 4d0*B2g1GG*Qsum**2
      elseif (ieorder.lt.0) then
         B2g1GG = 0d0
      endif
      
      B2g1GG = B2g1GG/8d0   ! to account for (nc^2-1) factor now in GG.map

      return
      end
