*************************************************************
*     New approach: ignore Signer, use mixed QED-QCD amplitures directly

*     Need to figure out renormalisation

      function FullB1g1GG(iqb,ig,iq,iG1,iG2,renscale2)
      use KinData_mod
      use Constants_mod
      use GGconst
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /order/ieorder
      common /strong/ as
      common /eweakZ/amz,zewfac(4),zewnull(4)
!$omp threadprivate(/strong/)
!$omp threadprivate(/eweakZ/)

      write(*,*) "iqb, ig, iq:", iqb, ig, iq

      if(iqb.le.2.and.iq.le.2) then
         ave = 1d0/(2d0*nc)**2
      elseif(iqb.gt.2.and.iq.gt.2) then
         ave = 1d0/(2d0*(nc**2-1d0))**2
      else   
         ave = 1d0/(4d0*nc*(nc**2-1d0))
      endif   
       
      fac = ave*(4d0*pi*as)**2*(4d0*pi*amz)**2*4d0*nc*(nc**2-1)/(8d0*pi**2)
      

      FullB1g1GG =  B1g1GG(iqb,ig,iq,iG1,iG2,renscale2)
     .     +dble(nf)/dble(nc)*Bh1g1GG(iqb,ig,iq,iG1,iG2,renscale2)
     .     +1d0/dble(nc)*Bv1g1GG(iqb,ig,iq,iG1,iG2)
     .     -1d0/dble(nc)**2*Bt1g1GG(iqb,ig,iq,iG1,iG2,renscale2)

      if (ieorder.eq.0) then
         write(*,*) "LC:", B1g1GG(iqb,ig,iq,iG1,iG2,renscale2)/FullB1g1GG
         write(*,*) "SLC:", -Bt1g1GG(iqb,ig,iq,iG1,iG2,renscale2)/FullB1g1GG/dble(nc**2)
         write(*,*) "Bh:", dble(nf)*Bh1g1GG(iqb,ig,iq,iG1,iG2,renscale2)/dble(nc)/FullB1g1GG
         write(*,*) "Bv:", Bv1g1GG(iqb,ig,iq,iG1,iG2)/dble(nc)/FullB1g1GG
      endif

      
      FullB1g1GG = fac*FullB1g1GG
      
      return
      end

*************************************************************


*************************************************************     

*     Matrix Elements

*************************************************************      

*     Leading colour: interference with tree- and loop-level

      function B1g1GG(iqb,i3,iq,i4,i5,renscale2)
      use KinData_mod
      use Constants_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer, parameter :: dp     =  kind(1.d0)
      complex*16 :: tramp(2,2,2,2),lamp(2,2,2,2)
      integer :: h1,h2,h3,h4
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)
      common/order/ieorder

!      write(*,*) "hello B1"
!      write(*,*) "iqb, iq, ig, iG1, iG2:", iqb, iq, i3, i4, i5
      
      call eweakV1qq(nfB1,0d0)

      B1g1GG = 0d0

!     Helicity labelling: qb; g, G4, G5
!     (q not independent of qb: quark line)
!     1 = '-'; 2 = '+'
!     q is always opposite of qb and in this block, q=(-)=1

!     tramp: tree-level amp; lamp: loop-level amp
!     TREE-LEVEL
      
!     single '1' (-) trivially-vanishing
      tramp(2,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV      
      tramp(2,2,2,1) = zb1g0GG_MHV(iq,iqb,i3,i4,i5)  
      
      tramp(2,2,1,2) = zb1g0GG_MHV(iq,iqb,i5,i3,i4)
      tramp(2,1,2,2) = zb1g0GG_MHV(iq,iqb,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      tramp(2,1,2,1) = -zb1g0GG_MHV(iqb,iq,i3,i4,i5)
      tramp(2,1,1,2) = -zb1g0GG_MHV(iqb,iq,i5,i3,i4)
      tramp(2,2,1,1) = -zb1g0GG_MHV(iqb,iq,i4,i5,i3)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      tramp(2,1,1,1) = (0d0,0d0)
      
!     LINE REVERSAL
      
!     single '1' (-) trivially-vanishing
      tramp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      tramp(1,2,2,1) = zb1g0GG_MHV(iqb,iq,i3,i4,i5)
      tramp(1,2,1,2) = zb1g0GG_MHV(iqb,iq,i5,i3,i4)
      tramp(1,1,2,2) = zb1g0GG_MHV(iqb,iq,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      tramp(1,1,1,2) = -zb1g0GG_MHV(iq,iqb,i3,i4,i5)
      tramp(1,1,2,1) = -zb1g0GG_MHV(iq,iqb,i5,i3,i4)
      tramp(1,2,1,1) = -zb1g0GG_MHV(iq,iqb,i4,i5,i3)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      tramp(1,1,1,1) = (0d0,0d0)

      

!     LOOP-LEVEL

!     single '1' (-) don't contribute
      lamp(2,2,2,2) = (0d0,0d0)
    
!     two '1's (-) : G-MHV
      lamp(2,2,2,1) = zb1g1GG_gamMHV_AL(iq,iqb,i3,i4,i5,renscale2)      
      lamp(2,2,1,2) = zb1g1GG_gamMHV_AL(iq,iqb,i3,i5,i4,renscale2)
!      lamp(2,2,1,2) = zb1g1GG_gamMHV_AL(iq,iqb,i5,i3,i4,renscale2)
!     two '1's (-) : g-MHV
      lamp(2,1,2,2) = zb1g1GG_gMHV_AL(iq,iqb,i4,i5,i3,renscale2)
      
!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      lamp(2,1,2,1) = -zb1g1GG_gamMHV_AL(iqb,iq,i3,i4,i5,renscale2)
      lamp(2,1,1,2) = -zb1g1GG_gamMHV_AL(iqb,iq,i3,i5,i4,renscale2)
!     three '1's (--) : g-anti-MHV
      lamp(2,2,1,1) = -zb1g1GG_gMHV_AL(iqb,iq,i4,i5,i3,renscale2)
      call resetzAB_kin(5)

!     single '2' (+) : don't contribute
      lamp(2,1,1,1) = (0d0,0d0)
      
      
!     LINE REVERSAL
      
!     single '1' (-) don't contribute
      lamp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      lamp(1,2,2,1) = zb1g1GG_gamMHV_AL(iqb,iq,i3,i4,i5,renscale2)
      lamp(1,2,1,2) = zb1g1GG_gamMHV_AL(iqb,iq,i3,i5,i4,renscale2)
!      lamp(1,2,1,2) = zb1g1GG_gamMHV_AL(iqb,iq,i5,i3,i4,renscale2)

!     two '1's (-) : g-MHV
      lamp(1,1,2,2) = zb1g1GG_gMHV_AL(iqb,iq,i4,i5,i3,renscale2)


!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      lamp(1,1,1,2) = -zb1g1GG_gamMHV_AL(iq,iqb,i3,i4,i5,renscale2)
      lamp(1,1,2,1) = -zb1g1GG_gamMHV_AL(iq,iqb,i3,i5,i4,renscale2)
!     three '1's (--) : g-anti-MHV
      lamp(1,2,1,1) = -zb1g1GG_gMHV_AL(iq,iqb,i4,i5,i3,renscale2)
      call resetzAB_kin(5)

!     single '2' (+) : don't contribute
      lamp(1,1,1,1) = (0d0,0d0)
      
!      write(*,*) "NJ"
      B = 0d0
      do h1=1,2
        do h2=1,2
          do h3=1,2
            do h4=1,2
              B = B + real(dconjg(tramp(h1,h2,h3,h4))*lamp(h1,h2,h3,h4))
            enddo
          enddo
        enddo
      enddo
      
      B1g1GG = abs(zewfac(1))**4*B/2d0

!     shifts related to renormalisation, C(e) prefatcor and regularisation scheme:

      B1g1GG = -B1g1GG

      Btree = B1g0GG(iqb,i3,iq,i4,i5)
      
      if(ieorder.eq.-1) then
!     renormalisation 
         aUV = -11d0/6d0
         B1g1GG = B1g1GG + aUV*Btree
      endif

      if(ieorder.eq.0) then
!     pi**2/6 from expansion of C(e) prefactor, aRS from regularisation scheme shift (FDH->HV)
         aRS = -1d0/2d0 
         B1g1GG = B1g1GG + (pi**2/6d0+aRS)*Btree
      endif

      return
      end
      
      
*************************************************************      

*     Subleading colour: interference with tree- and loop-level

      function Bt1g1GG(iqb,i3,iq,i4,i5,renscale2)
      use KinData_mod
      use Constants_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(l)
      implicit complex*16(z)
      complex*16 :: tramp(2,2,2,2),lamp(2,2,2,2)
      integer :: h1,h2,h3,h4
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)
      common/order/ieorder


!      write(*,*) "hello Bt"
!      write(*,*) "iqb, iq, ig, iG1, iG2:", iqb, iq, i3, i4, i5

      call eweakV1qq(nfB1,0d0)
      
      Bt1g1GG = 0d0

!     Helicity labelling: qb; g, G4, G5
!     (q not independent of qb: quark line)
!     1 = '-'; 2 = '+'
!     q is always opposite of qb and in this block, q=(-)=1

!     tramp: tree-level amp; lamp: loop-level amp
!     TREE-LEVEL
      
!     single '1' (-) trivially-vanishing
      tramp(2,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV      
      tramp(2,2,2,1) = zb1g0GG_MHV(iq,iqb,i3,i4,i5)
      tramp(2,2,1,2) = zb1g0GG_MHV(iq,iqb,i5,i3,i4)
      tramp(2,1,2,2) = zb1g0GG_MHV(iq,iqb,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      tramp(2,1,2,1) = -zb1g0GG_MHV(iqb,iq,i3,i4,i5)
      tramp(2,1,1,2) = -zb1g0GG_MHV(iqb,iq,i5,i3,i4)
      tramp(2,2,1,1) = -zb1g0GG_MHV(iqb,iq,i4,i5,i3)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      tramp(2,1,1,1) = (0d0,0d0)
      
!     LINE REVERSAL
      
!     single '1' (-) trivially-vanishing
      tramp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      tramp(1,2,2,1) = zb1g0GG_MHV(iqb,iq,i3,i4,i5)
      tramp(1,2,1,2) = zb1g0GG_MHV(iqb,iq,i5,i3,i4)
      tramp(1,1,2,2) = zb1g0GG_MHV(iqb,iq,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      tramp(1,1,1,2) = -zb1g0GG_MHV(iq,iqb,i3,i4,i5)
      tramp(1,1,2,1) = -zb1g0GG_MHV(iq,iqb,i5,i3,i4)
      tramp(1,2,1,1) = -zb1g0GG_MHV(iq,iqb,i4,i5,i3)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      tramp(1,1,1,1) = (0d0,0d0)



!     LOOP-LEVEL

!     single '1' (-) don't contribute
      lamp(2,2,2,2) = (0d0,0d0)
    
!     two '1's (-) : G-MHV
      lamp(2,2,2,1) = zb0g1GGG_MHV(iq,iqb,i3,i4,i5,renscale2)
      lamp(2,2,1,2) = zb0g1GGG_MHV(iq,iqb,i5,i3,i4,renscale2)
      lamp(2,1,2,2) = zb0g1GGG_MHV(iq,iqb,i4,i5,i3,renscale2)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      lamp(2,1,2,1) = -zb0g1GGG_MHV(iqb,iq,i3,i4,i5,renscale2)
      lamp(2,1,1,2) = -zb0g1GGG_MHV(iqb,iq,i5,i3,i4,renscale2)
      lamp(2,2,1,1) = -zb0g1GGG_MHV(iqb,iq,i4,i5,i3,renscale2)
      call resetzAB_kin(5)

!     single '2' (+) : don't contribute
      lamp(2,1,1,1) = (0d0,0d0)
      
!     LINE REVERSAL
      
!     single '1' (-) don't contribute
      lamp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      lamp(1,2,2,1) = zb0g1GGG_MHV(iqb,iq,i3,i4,i5,renscale2)
      lamp(1,2,1,2) = zb0g1GGG_MHV(iqb,iq,i5,i3,i4,renscale2)
      lamp(1,1,2,2) = zb0g1GGG_MHV(iqb,iq,i4,i5,i3,renscale2)
 
!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      lamp(1,1,1,2) = -zb0g1GGG_MHV(iq,iqb,i3,i4,i5,renscale2)
      lamp(1,1,2,1) = -zb0g1GGG_MHV(iq,iqb,i5,i3,i4,renscale2)
      lamp(1,2,1,1) = -zb0g1GGG_MHV(iq,iqb,i4,i5,i3,renscale2)
      call resetzAB_kin(5);

!     single '2' (+) : don't contribute
      lamp(1,1,1,1) = (0d0,0d0)
      

      B = 0d0
      do h1=1,2
        do h2=1,2
          do h3=1,2
            do h4=1,2
              B = B + real(dconjg(tramp(h1,h2,h3,h4))*lamp(h1,h2,h3,h4))
            enddo
          enddo
        enddo
      enddo
      
!       for agreement with MG:
      Bt1g1GG = abs(zewfac(1))**4*B/2d0
!       for agreement with MCFM:
!       Bt1g1GG = -abs(zewfac(1))**4*B

!     shifts related to C(e) prefactor and regularisation scheme:

      Btree = B1g0GG(iqb,i3,iq,i4,i5)

      if(ieorder.eq.0) then
!     pi**2/12 from expansion of C(e) prefactor, aRS from regularisation scheme shift (FDH->HV)
         aRS = -1d0/2d0
         Bt1g1GG = Bt1g1GG + (pi**2/12d0+aRS)*Btree
      endif

      return
      end
      
*************************************************************      

*     Piece proportional to N_F
*     Arises at 1/eps level only, through renormalisation (-> MS-bar)
      
      
      function Bh1g1GG(iqb,i3,iq,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      complex*16 :: tramp(2,2,2,2),lamp(2,2,2,2)
      integer :: h1,h2,h3,h4
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)
      common/order/ieorder


!      write(*,*) "hello Bh"
!      write(*,*) "iqb, iq, ig, iG1, iG2:", iqb, iq, i3, i4, i5


      call eweakV1qq(nfB1,0d0)
      Bh1g1GG = 0d0
               
      if (ieorder.eq.-1) then
          betfnc = 1d0/3d0
          Bh1g1GG = betfnc*B1g0GG(iqb,i3,iq,i4,i5)        
      endif
            
      return
      end
      
*************************************************************      

*     Analagous to piece proportional to N_F; actually proportional to [e^2]

      function Bv1g1GG(iqb,ig,iq,i4,i5)
      use KinData_mod
      use Constants_mod
      use GGconst
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      complex*16 :: tramp(2,2,2,2),lamp(2,2,2,2)
      integer :: h1,h2,h3,h4
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)
      common/order/ieorder


!      write(*,*) "hello Bv"
!      write(*,*) "iqb, iq, ig, iG1, iG2:", iqb, iq, ig, i4, i5


      call eweakV1qq(nfB1,0d0)
            
      Bv1g1GG = 0d0

!     Helicity labelling: qb; g, G4, G5
!     (q not independent of qb: quark line)
!     1 = '-'; 2 = '+'
!     q is always opposite of qb and in this block, q=(-)=1

!     tramp: tree-level amp; lamp: loop-level amp
!     TREE-LEVEL
      
!     single '1' (-) trivially-vanishing
      tramp(2,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV      
      tramp(2,2,2,1) = zb1g0GG_MHV(iq,iqb,ig,i4,i5)
      tramp(2,2,1,2) = zb1g0GG_MHV(iq,iqb,i5,ig,i4)
      tramp(2,1,2,2) = zb1g0GG_MHV(iq,iqb,i4,i5,ig)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      tramp(2,1,2,1) = -zb1g0GG_MHV(iqb,iq,ig,i4,i5)
      tramp(2,1,1,2) = -zb1g0GG_MHV(iqb,iq,i5,ig,i4)
      tramp(2,2,1,1) = -zb1g0GG_MHV(iqb,iq,i4,i5,ig)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      tramp(2,1,1,1) = (0d0,0d0)
      
!     LINE REVERSAL
      
!     single '1' (-) trivially-vanishing
      tramp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      tramp(1,2,2,1) = zb1g0GG_MHV(iqb,iq,ig,i4,i5)
      tramp(1,2,1,2) = zb1g0GG_MHV(iqb,iq,i5,ig,i4)
      tramp(1,1,2,2) = zb1g0GG_MHV(iqb,iq,i4,i5,ig)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      tramp(1,1,1,2) = -zb1g0GG_MHV(iq,iqb,ig,i4,i5)
      tramp(1,1,2,1) = -zb1g0GG_MHV(iq,iqb,i5,ig,i4)
      tramp(1,2,1,1) = -zb1g0GG_MHV(iq,iqb,i4,i5,ig)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      tramp(1,1,1,1) = (0d0,0d0)
  

!     LOOP-LEVEL

!     single '1' (-) don't contribute
      lamp(2,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV      
      lamp(2,2,2,1) = zb1g1GG_MHV_ANf(iq,iqb,ig,i4,i5)
      lamp(2,2,1,2) = zb1g1GG_MHV_ANf(iq,iqb,i5,ig,i4)
!     two '1's (-) : g-MHV
      lamp(2,1,2,2) = zb1g1GG_MHV_ANf(iq,iqb,i4,i5,ig)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      lamp(2,1,2,1) = -zb1g1GG_MHV_ANf(iqb,iq,ig,i4,i5)
      lamp(2,1,1,2) = -zb1g1GG_MHV_ANf(iqb,iq,i5,ig,i4)
!     three '1's (--) : g-anti-MHV
      lamp(2,2,1,1) = -zb1g1GG_MHV_ANf(iqb,iq,i4,i5,ig)
      call resetzAB_kin(5)

!     single '2' (+) : don't contribute
      lamp(2,1,1,1) = (0d0,0d0)
      
      
!     LINE REVERSAL
      
!     single '1' (-) don't contribute
      lamp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      lamp(1,2,2,1) = zb1g1GG_MHV_ANf(iqb,iq,ig,i4,i5)
      lamp(1,2,1,2) = zb1g1GG_MHV_ANf(iqb,iq,i5,ig,i4)
!     two '1's (-) : g-MHV
      lamp(1,1,2,2) = zb1g1GG_MHV_ANf(iqb,iq,i4,i5,ig)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      lamp(1,1,1,2) = -zb1g1GG_MHV_ANf(iq,iqb,ig,i4,i5)
      lamp(1,1,2,1) = -zb1g1GG_MHV_ANf(iq,iqb,i5,ig,i4)
!     three '1's (--) : g-anti-MHV
      lamp(1,2,1,1) = -zb1g1GG_MHV_ANf(iq,iqb,i4,i5,ig)
      call resetzAB_kin(5)

!     single '2' (+) : don't contribute
      lamp(1,1,1,1) = (0d0,0d0)
      

      B = 0d0
      do h1=1,2
        do h2=1,2
          do h3=1,2
            do h4=1,2
              B = B + real(dconjg(tramp(h1,h2,h3,h4))*lamp(h1,h2,h3,h4)) + real(dconjg(lamp(h1,h2,h3,h4))*tramp(h1,h2,h3,h4))
            enddo
          enddo
        enddo
      enddo

!     these parameters are set in GGconst.f90
      
      sumeqsq = (4*nup + ndown)/9d0
!     sumeqsq = nup*qup**2 + ndown*qdown**2


      Bv1g1GG = -sumeqsq*abs(zewfac(1))**2*B/4d0
!      write(*,*) "Bv1g1GG:", ieorder, Bv1g1GG
      return
      end
      
      
      
******************************************************
*     3 PHOTON
      
      function B0g1GGG(iqb,iq,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      complex*16 :: tramp(2,2,2,2),lamp(2,2,2,2)
      integer :: h1,h2,h3,h4
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)
      common/order/ieorder

      call eweakV1qq(nfB1,0d0)

      B0g1GGG = 0d0

      write(*,*) "B0g1GGG has been validated against MadGraph; missing finite corrn."


!     Helicity labelling: qb; g, G4, G5
!     (q not independent of qb: quark line)
!     1 = '-'; 2 = '+'
!     q is always opposite of qb and in this block, q=(-)=1

!     tramp: tree-level amp; lamp: loop-level amp

!     
!     TREE-LEVEL
      
!     single '1' (-) trivially-vanishing
      tramp(2,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV      
      tramp(2,2,2,1) = zb0g0GGG_MHV(iq,iqb,i3,i4,i5)
      tramp(2,2,1,2) = zb0g0GGG_MHV(iq,iqb,i5,i3,i4)
      tramp(2,1,2,2) = zb0g0GGG_MHV(iq,iqb,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      tramp(2,1,1,2) = -zb0g0GGG_MHV(iqb,iq,i3,i4,i5)
      tramp(2,1,2,1) = -zb0g0GGG_MHV(iqb,iq,i5,i3,i4)
      tramp(2,2,1,1) = -zb0g0GGG_MHV(iqb,iq,i4,i5,i3)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      tramp(2,1,1,1) = (0d0,0d0)
      
!     LINE REVERSAL
      
!     single '1' (-) trivially-vanishing
      tramp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      tramp(1,2,2,1) = zb0g0GGG_MHV(iqb,iq,i3,i4,i5)
      tramp(1,2,1,2) = zb0g0GGG_MHV(iqb,iq,i5,i3,i4)
      tramp(1,1,2,2) = zb0g0GGG_MHV(iqb,iq,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      tramp(1,1,1,2) = -zb0g0GGG_MHV(iq,iqb,i3,i4,i5)
      tramp(1,1,2,1) = -zb0g0GGG_MHV(iq,iqb,i5,i3,i4)
      tramp(1,2,1,1) = -zb0g0GGG_MHV(iq,iqb,i4,i5,i3)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      tramp(1,1,1,1) = (0d0,0d0)
      

!     LOOP-LEVEL

!     single '1' (-) don't contribute
      lamp(2,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV      
      lamp(2,2,2,1) = zb0g1GGG_MHV(iq,iqb,i3,i4,i5,renscale2)
      lamp(2,2,1,2) = zb0g1GGG_MHV(iq,iqb,i5,i3,i4,renscale2)
      lamp(2,1,2,2) = zb0g1GGG_MHV(iq,iqb,i4,i5,i3,renscale2)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      lamp(2,1,1,2) = -zb0g1GGG_MHV(iqb,iq,i3,i4,i5,renscale2)
      lamp(2,1,2,1) = -zb0g1GGG_MHV(iqb,iq,i5,i3,i4,renscale2)
      lamp(2,2,1,1) = -zb0g1GGG_MHV(iqb,iq,i4,i5,i3,renscale2)
      call resetzAB_kin(5)

!     single '2' (+) : don't contribute
      lamp(2,1,1,1) = (0d0,0d0)
      
!     LINE REVERSAL
      
!     single '1' (-) don't contribute
      lamp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      lamp(1,2,2,1) = zb0g1GGG_MHV(iqb,iq,i3,i4,i5,renscale2)
      lamp(1,2,1,2) = zb0g1GGG_MHV(iqb,iq,i5,i3,i4,renscale2)
      lamp(1,1,2,2) = zb0g1GGG_MHV(iqb,iq,i4,i5,i3,renscale2)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      lamp(1,1,1,2) = -zb0g1GGG_MHV(iq,iqb,i3,i4,i5,renscale2)
      lamp(1,1,2,1) = -zb0g1GGG_MHV(iq,iqb,i5,i3,i4,renscale2)
      lamp(1,2,1,1) = -zb0g1GGG_MHV(iq,iqb,i4,i5,i3,renscale2)
      call resetzAB_kin(5)

!     single '2' (+) : don't contribute
      lamp(1,1,1,1) = (0d0,0d0)
      

      B = 0d0
      do h1=1,2
        do h2=1,2
          do h3=1,2
            do h4=1,2
              B = B + real(dconjg(tramp(h1,h2,h3,h4))*lamp(h1,h2,h3,h4))
            enddo
          enddo
        enddo
      enddo
      

      B0g1GGG = abs(zewfac(1))**6*B
      
      if (ieorder .eq. 0)then
c     pi**2/6d0 comes from a correction for amplitude loop factor normalisation: C(e) vs exp(-eps*gam_E)
!     This needs checking but works for agreement with MG
       e0 = -1/2d0
       B0g1GGG = B0g1GGG + e0*B0g0GGG(iqb,iq,i3,i4,i5)
!        write(*,*) "B0g0GGG", B0g0GGG(iqb,iq,i3,i4,i5)
      endif

      return
      end
      

*************************************************************      

*     Amplitudes

*************************************************************      
*     Tree-level G-MHV two-photon amplitude for q(-) qb(+) g(3+) G(4+) G(5-)
*     Coded up directly from eqn (A3) of 1403.2641v1 
*     Only one independent amplitude

      function zb1g0GG_gamMHV(iq,i3,iqb,i4,i5m)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
    
      zb1g0GG_gamMHV = zb1g0GG_gMHV(iq,i5m,iqb,i4,i3)
!       write(*,*) zb1g0GG_gamMHV
!       write(*,*) zb0g0GGG_MHV(iq,iqb,i3,i4,i5m)

      return
      end
      
      
*************************************************************      
*     Tree-level g-MHV two-photon amplitude for q(-) qb(+) g(3-) G(4+) G(5+)
*     Coded up directly from eqn (A4) of 1403.2641v1 
*     This is also the tree-level G-MHV amplitude (below) - identical at tree-level
*     Only one independent amplitude

      function zb1g0GG_gMHV(iq,i3m,iqb,i4,i5)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      zb1g0GG_gMHV = zA5(iqb,iq)*zA5(iq,i3m)**2/(zA5(iq,i5)*zA5(iq,i4)*zA5(iqb,i5)*zA5(iqb,i4))
      
!       write(*,*) zb1g0GG_gMHV, zb0g0GGG_MHV(iq,iqb,i4,i5,i3m)

      return
      end
      
*************************************************************      
*     Tree-level MHV 2G,1g amplitude for q(-) qb(+) g(3+) G(4+) G(5-)
*     Identical to three-photon amplitude (at tree-level)
*     Coded up directly from eqn (A4) of 1403.2641v1 

      function zb1g0GG_MHV(iq,iqb,i3,i4,i5m)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common/order/ieorder

      zb1g0GG_MHV = zb0g0GGG_MHV(iq,iqb,i3,i4,i5m)
      
      return
      end
      
      
*************************************************************      
*     Unrenormalised gam-MHV two-photon amplitude for q(-) qb(+) g(3+) G(4+) G(5-)
*     Coded up directly from eqn (A7) of 1403.2641v1 
*     Calls L_0, L_1 *not* as zLzero, zLone from specials/rr.f (don't have correct limits when x~y)
*     but rather as zL0d, and zL1d from Z/loopfuncs.f
*     Note that (importantly!) the functions zL0 are distinct and use Signer's notation rather than BDK's.
*     Also calls zzLogRat, zLsm1(x1,y1,x2,y2) from Z/loopfuncs.f
*     Note that we call [Ls_(-1)](x;y,z) with zLsm1(y,x,z,x)
*     Here the gluon is always in third position, with photons at the end

      function zb1g1GG_gamMHV_AL(iq,iqb,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common/order/ieorder

      
      if(ieorder.eq.0)then
         zlr13 = zzLogRat(renscale2,-s5(iq,i3))
         zlr23 = zzLogRat(renscale2,-s5(iqb,i3))
         zlr25 = zzLogRat(renscale2,-s5(iqb,i5))
         
         zb1g1GG_gamMHV_AL = (zlr13**2 + zlr23**2 + 3d0*zlr25 + 6d0)*zb1g0GG_MHV(iq,iqb,i3,i4,i5)/2d0
     & -(zA5(iq,iqb)**3*zA5(i4,i5)**2/(zA5(iq,i3)*zA5(iq,i4)*zA5(iqb,i3)*zA5(iqb,i4)**3))
     &*zLsm1(-s5(i4,i5),-s5(iq,i3),-s5(iqb,i5),-s5(iq,i3))
     & +(zA5(iq,i5)**2/(zA5(iq,i3)*zA5(iqb,i4)*zA5(i3,i4)))*zLsm1(-s5(iqb,i4),-s5(iq,i5),-s5(iqb,i3),-s5(iq,i5))
     & -(zA5(iq,iqb)*zA5(iq,i5)**2/(zA5(iq,i3)*zA5(iq,i4)*zA5(iqb,i3)*zA5(iqb,i4)))
     &*zLsm1(-s5(i4,i5),-s5(iqb,i3),-s5(iq,i5),-s5(iqb,i3))
     & -((zA5(iq,i3)*zA5(i4,i5))**2/(zA5(iq,i4)*zA5(iqb,i3)*zA5(i3,i4)**3))*zLsm1(-s5(iq,i4),-s5(iqb,i5),-s5(iq,i3),-s5(iqb,i5))
     & -(zA5(iq,iqb)*zA5(iq,i5)**2/(zA5(iq,i3)*zA5(iq,i4)*zA5(iqb,i3)*zA5(iqb,i4)))
     &*zLsm1(-s5(iq,i3),-s5(i4,i5),-s5(iqb,i3),-s5(i4,i5))
     & +(zA5(iq,iqb)*zA5(iqb,i5)**2*zB5(i3,iqb)/(zA5(iqb,i3)*zA5(iqb,i4)**2))*zL0d(-s5(iq,i3),-s5(i4,i5))/s5(i4,i5)
     & -((zA5(iq,i3)*zA5(iqb,i4)+zA5(iq,iqb)*zA5(i3,i4))*zA5(i4,i5)**2*zB5(i4,i3))/
     &(zA5(iqb,i4)*zA5(i3,i4))**2*zL0d(-s5(iq,i3),-s5(iqb,i5))/s5(iqb,i5)
     & -(zA5(iq,i3)*(zA5(i4,i5)*zB5(i4,i3))**2/(2d0*zA5(iqb,i4)*zA5(i3,i4)))*zL1d(-s5(iq,i3),-s5(iqb,i5))/s5(iqb,i5)**2
     & +((zA5(iq,i5)*zA5(i3,i4)-zA5(iq,i3)*zA5(i4,i5))*zA5(i3,i5)*zB5(i4,i3)
     & /(zA5(iqb,i3)*zA5(i3,i4)**2))*zL0d(-s5(iq,i4),-s5(iqb,i5))/s5(iqb,i5)
     & -((zA5(iq,i4)*zA5(i3,i5)**2*zB5(i4,i3)**2)/(2d0*zA5(iqb,i3)*zA5(i3,i4)))*zL1d(-s5(iq,i4),-s5(iqb,i5))/s5(iqb,i5)**2
     & +(zA5(iq,iqb)*zA5(iqb,i5)*zA5(iq,i5)/(zA5(iq,i3)*zA5(iqb,i3)*zA5(iqb,i4)**2))*zzLograt(-s5(i4,i5),-s5(iqb,i5))
     & +zA5(i3,i4)*zB5(i3,i4)**2/(2d0*zA5(iqb,i3)*zA5(iqb,i4)*zB5(iq,i5)*zB5(iqb,i5))
     
      elseif(ieorder.eq.-1)then
!         write(*,*) "iq, iqb:", iq, iqb
!         write(*,*) "ig:", i3
         zb1g1GG_gamMHV_AL = (zzLogRat(renscale2,-s5(iq,i3))+zzLogRat(renscale2,-s5(iqb,i3))+3d0/2d0)*zb1g0GG_MHV(iq,iqb,i3,i4,i5)
         
      elseif(ieorder.eq.-2)then
         zb1g1GG_gamMHV_AL = 2d0*zb1g0GG_MHV(iq,iqb,i3,i4,i5)
          
      endif
      
      return
      end
      
      
*************************************************************      
*     Unrenormalised g-MHV two-photon amplitude for q(-) qb(+) g(3-) G(4+) G(5+)
*     Coded up directly from eqn (A8) of 1403.2641v1 
*     Calls L_0, L_1 as zL0d, zL1d
*     Note that we call [Ls_(-1)](x;y,z) with zLsm1(y,x,z,x)
*     Here the gluon is always in last position

      function zb1g1GG_gMHV_AL(iq,iqb,i4,i5,i3,renscale2)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common/order/ieorder

      
      if(ieorder.eq.0)then
         zlr13 = zzLogRat(renscale2,-s5(iq,i3))
         zlr23 = zzLogRat(renscale2,-s5(iqb,i3))
         
         zb1g1GG_gMHV_AL = (zlr13**2 + zlr23**2 + 3d0*zlr23 + 6d0)*zb1g0GG_MHV(iq,iqb,i4,i5,i3)/2d0
     & +(zA5(iq,i3)**2/(zA5(iq,i4)*zA5(iqb,i5)*zA5(i4,i5)))*zLsm1(-s5(iqb,i5),-s5(iq,i4),-s5(iqb,i3),-s5(iq,i4))
     & -(zA5(iq,i3)**2/(zA5(iq,i5)*zA5(iqb,i4)*zA5(i4,i5)))*zLsm1(-s5(iqb,i4),-s5(iq,i5),-s5(iqb,i3),-s5(iq,i5))
     & -(zA5(iq,i3)**2/(zA5(iq,i5)*zA5(iqb,i4)*zA5(i4,i5)))*zLsm1(-s5(iq,i5),-s5(iqb,i4),-s5(iq,i3),-s5(iqb,i4))
     & +(zA5(iq,i3)**2/(zA5(iq,i4)*zA5(iqb,i5)*zA5(i4,i5)))*zLsm1(-s5(iq,i4),-s5(iqb,i5),-s5(iq,i3),-s5(iqb,i5))
     & -(zA5(iq,i4)*(zA5(i3,i5)*zB5(i5,i4))**2/(2d0*zA5(iqb,i5)*zA5(i4,i5)))*zL1d(-s5(iq,i4),-s5(iqb,i3))/s5(iqb,i3)**2
     & -(zA5(iq,i3)*zA5(i3,i5)*zB5(i5,i4)/(zA5(iqb,i5)*zA5(i4,i5)))*zL0d(-s5(iq,i4),-s5(iqb,i3))/s5(iqb,i3)
     & +(zA5(iq,i5)*(zA5(i3,i4)*zB5(i5,i4))**2/(2d0*zA5(iqb,i4)*zA5(i4,i5)))*zL1d(-s5(iq,i5),-s5(iqb,i3))/s5(iqb,i3)**2
     & -(zA5(iq,i3)*zA5(i3,i4)*zB5(i5,i4)/(zA5(iqb,i4)*zA5(i4,i5)))*zL0d(-s5(iq,i5),-s5(iqb,i3))/s5(iqb,i3)
     & -(zB5(i4,i5)/(2d0*zB5(iq,i3)*zB5(iqb,i3)))*(zB5(iqb,i4)/zA5(iqb,i5)-zB5(iqb,i5)/zA5(iqb,i4))
     & +zA5(iq,i3)*zB5(i4,i5)/((2d0*zA5(iqb,i3)*zB5(iqb,i3)*zA5(i4,i5)))*(zA5(i3,i4)/zA5(iqb,i4)+zA5(i3,i5)/zA5(iqb,i5))
     
     
     
      elseif(ieorder.eq.-1)then
         zb1g1GG_gMHV_AL = (zzLogRat(-renscale2,s5(iq,i3))+zzLogRat(renscale2,s5(iqb,i3))+3d0/2d0)*zb1g0GG_MHV(iq,iqb,i4,i5,i3)

         
      elseif(ieorder.eq.-2)then   
         zb1g1GG_gMHV_AL = 2d0*zb1g0GG_MHV(iq,iqb,i4,i5,i3)
         
!      Conversion to MS-bar renormalisation and to 't Hooft-Veltman scheme given byv eqn A9 of 1403.2641v1
!      Occurs in matrix element rather than amplitude

      endif
      
      return
      end
      
      
      
*************************************************************      
*     Unrenormalised closed-fermion-loop gam-MHV two-photon amplitude for q(-) qb(+) g(3+) G(4+) G(5-)
*     Coded up directly from eqn (A10) of 1403.2641v1 
*     Calls L_0, L_1 as zL0d, zL1d
*     Note that we call [Ls_(-1)](x;y,z) with zLsm1(y,x,z,x)
*     For gluon-MHV amplitude simply call this function with gluon momentum in last place.
!     Note symmetry between i3 and i4

      function zb1g1GG_MHV_ANf(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common/order/ieorder
      
      if(ieorder.eq.0)then
         zb1g1GG_MHV_ANf = 
     &        -2d0*((zA5(i1,i4)*zA5(i3,i5))**2+(zA5(i1,i3)*zA5(i4,i5))**2)
     &        /(zA5(i1,i2)*zA5(i3,i4)**4)*zLsm1(-s5(i3,i5),-s5(i1,i2),-s5(i4,i5),-s5(i1,i2))
     &        -(zA5(i1,i4)*zA5(i3,i5)*zB5(i4,i3)/(zA5(i1,i2)*zA5(i3,i4)**3))
     &        *(2d0*zA5(i1,i4)*zA5(i3,i5)+4d0*zA5(i1,i3)*zA5(i4,i5))*zL0d(-s5(i1,i2),-s5(i3,i5))/s5(i3,i5)
     &        -2d0*(zA5(i1,i4)*zA5(i3,i5))**2*zA5(i4,i5)*zB5(i4,i3)*zB5(i5,i4)
     &        /(zA5(i1,i2)*zA5(i3,i4)**3)*zL1d(-s5(i1,i2),-s5(i3,i5))/s5(i3,i5)**2
     &        -(zA5(i1,i3)*zA5(i4,i5)*zB5(i3,i4)/(zA5(i1,i2)*zA5(i4,i3)**3))
     &        *(2d0*zA5(i1,i3)*zA5(i4,i5)+4d0*zA5(i1,i4)*zA5(i3,i5))*zL0d(-s5(i1,i2),-s5(i4,i5))/s5(i4,i5)
     &        -2d0*((zA5(i1,i3)*zA5(i4,i5))**2*zA5(i3,i5)*zB5(i3,i4)*zB5(i5,i3)
     &        /(zA5(i1,i2)*zA5(i4,i3)**3))*zL1d(-s5(i1,i2),-s5(i4,i5))/s5(i4,i5)**2
     &        -2d0*(zA5(i3,i5)*zA5(i4,i5)*zB5(i2,i5)**2*zB5(i3,i4))/(zA5(i3,i4)**3
     &        *zB5(i1,i2)*zB5(i3,i5)*zB5(i4,i5))
    
      elseif(ieorder.eq.-1)then
         zb1g1GG_MHV_ANf = 0
         
      elseif(ieorder.eq.-2)then   
         zb1g1GG_MHV_ANf = 0
          
      endif
            
      return
      end
      
           
*************************************************************      
*     Unrenormalised closed-fermion-loop g-MHV two-photon amplitude for q(-) qb(+) g(3-) G(4+) G(5+)
*     Coded up directly from eqn (A11) of 1403.2641v1 
*     Note that this is slightly unnecessary (just an argument permutation of gamMHV_ANf

      function zb1g1GG_gMHV_ANf(iq,iqb,i3,i4,i5)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common/order/ieorder

      zb1g1GG_gMHV_ANf = zb1g1GG_MHV_ANf(iq,i5,iqb,i4,i3)
      
      return
      end
      
      
      
*************************************************************      
*     Tree-level MHV three-photon amplitude for q(-) qb(+) G(3+) G(4+) G(5-)
*     Coded up directly from eqn (3) of 1403.2641v1 

      function zb0g0GGG_MHV(iq,iqb,i3,i4,i5m)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common/order/ieorder

      zb0g0GGG_MHV = zA5(iqb,iq)*zA5(iq,i5m)**2/(zA5(iq,i3)*zA5(iq,i4)*zA5(iqb,i3)*zA5(iqb,i4))
      
      return
      end
      
      
*************************************************************      
*     Unrenormalised one-loop MHV three-photon amplitude for q(-) qb(+) G(3+) G(4+) G(5-)
*     Coded up directly from eqn (5) of 1403.2641v1 
*     Calls L_0, L_1 as zL0d, zL1d
*     Also calls zzLogRat, zLsm1(x1,y1,x2,y2) from Z/loopfuncs.f
*     Note that we call [Ls_(-1)](x;y,z) with zLsm1(y,x,z,x)

      function zb0g1GGG_MHV(iq,iqb,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common/order/ieorder

!      write(*,*) "q- qb+ G+ G+ G-"
!      write(*,*) iq, iqb, i3, i4, i5
      
      if(ieorder.eq.0)then
         zlr25 = zzLogRat(renscale2,-s5(iqb,i5))
         zlr12 = zzLogRat(renscale2,-s5(iq,iqb))
         
       zb0g1GGG_MHV = -(zlr12**2/2d0 + 3d0*zlr25/2d0 +3d0)*zb0g0GGG_MHV(iq,iqb,i3,i4,i5)
     & +(zA5(iq,i3)**3*zA5(iqb,i4)*zA5(i4,i5)**2-zA5(iq,i4)**3*zA5(iqb,i3)*zA5(i3,i5)**2)
     & /(zA5(iq,i3)*zA5(iq,i4)*zA5(iqb,i3)*zA5(iqb,i4)*zA5(i3,i4)**3)*zLsm1(-s5(i3,i5),-s5(iq,iqb),-s5(i4,i5),-s5(iq,iqb))
     & -((zA5(iq,iqb)*zA5(i4,i5))**2/(zA5(iq,i3)*zA5(iqb,i4)**3*zA5(i3,i4)))*zLsm1(-s5(i4,i5),-s5(iq,i3),-s5(iqb,i5),-s5(iq,i3))
     & +(zA5(iq,iqb)*zA5(i3,i5))**2/(zA5(iq,i4)*zA5(iqb,i3)**3*zA5(i3,i4))*zLsm1(-s5(i3,i5),-s5(iq,i4),-s5(iqb,i5),-s5(iq,i4))
     & +zA5(iq,i5)**2/(zA5(iq,i4)*zA5(iqb,i3)*zA5(i3,i4))*zLsm1(-s5(i4,i5),-s5(iqb,i3),-s5(iq,i5),-s5(iqb,i3))
     & -zA5(iq,i5)**2/(zA5(iq,i3)*zA5(iqb,i4)*zA5(i3,i4))*zLsm1(-s5(i3,i5),-s5(iqb,i4),-s5(iq,i5),-s5(iqb,i4))
     & -(zA5(iq,iqb)*zA5(i3,i5))**2/(zA5(iq,i3)*zA5(iqb,i3)**2
     &*zA5(iqb,i4)*zA5(i3,i4))*zLsm1(-s5(iq,i3),-s5(i4,i5),-s5(iq,iqb),-s5(i4,i5))
     & +(zA5(iq,iqb)*zA5(i4,i5))**2/(zA5(iq,i4)*zA5(iqb,i4)**2*zA5(iqb,i3)
     &*zA5(i3,i4))*zLsm1(-s5(iq,i4),-s5(i3,i5),-s5(iq,iqb),-s5(i3,i5))
     & -zA5(iq,i5)**2/(zA5(iqb,i4)*zA5(iq,i3)*zA5(i3,i4))*zLsm1(-s5(iq,iqb),-s5(i3,i5),-s5(iqb,i4),-s5(i3,i5))
     & +zA5(iq,i5)**2/(zA5(iqb,i3)*zA5(iq,i4)*zA5(i3,i4))*zLsm1(-s5(iq,iqb),-s5(i4,i5),-s5(iqb,i3),-s5(i4,i5))
     & -zA5(iq,iqb)*zA5(iqb,i5)**2*zB5(i3,iqb)/(zA5(iqb,i3)*zA5(iqb,i4)**2)*zL0d(-s5(iq,i3),-s5(i4,i5))/s5(i4,i5)
     & -zA5(iq,iqb)*zA5(iqb,i5)**2*zB5(i4,iqb)/(zA5(iqb,i4)*zA5(iqb,i3)**2)*zL0d(-s5(iq,i4),-s5(i3,i5))/s5(i3,i5)
     & +zA5(iq,iqb)*zA5(i4,i5)**2*zB5(i4,i3)/(zA5(iqb,i4)**2*zA5(i3,i4))*zL0d(-s5(iq,i3),-s5(iqb,i5))/s5(iqb,i5)
     & +zA5(iq,i3)*zA5(i4,i5)**2*zB5(i4,i3)**2/(2d0*zA5(iqb,i4)*zA5(i3,i4))*zL1d(-s5(iq,i3),-s5(iqb,i5))/s5(iqb,i5)**2
     & +zA5(iq,iqb)*zA5(i3,i5)**2*zB5(i4,i3)/(zA5(iqb,i3)**2*zA5(i3,i4))*zL0d(-s5(iq,i4),-s5(iqb,i5))/s5(iqb,i5)
     & -zA5(iq,i4)*zA5(i3,i5)**2*zB5(i4,i3)**2/(2d0*zA5(iqb,i3)*zA5(i3,i4))*zL1d(-s5(iq,i4),-s5(iqb,i5))/s5(iqb,i5)**2
     & -zA5(iq,iqb)*zA5(iq,i5)*zA5(iqb,i5)/(zA5(iq,i3)*zA5(iqb,i3)*zA5(iqb,i4)**2)*zzLogRat(-s5(i4,i5),-s5(iqb,i5))
     & -zA5(iq,iqb)*zA5(iq,i5)*zA5(iqb,i5)/(zA5(iq,i4)*zA5(iqb,i4)*zA5(iqb,i3)**2)*zzLogRat(-s5(i3,i5),-s5(iqb,i5))
     & +(zB5(i3,i4)/(2d0*zB5(iqb,i5)))*(zA5(iq,i5)/(zA5(iqb,i5)*zA5(i3,i4))*(zA5(i3,i5)/zA5(iqb,i3)+zA5(i4,i5)/zA5(iqb,i4))
     & +(zB5(iqb,i3)/zA5(iqb,i4)-zB5(iqb,i4)/zA5(iqb,i3))/zB5(iq,i5))
     
      elseif(ieorder.eq.-1)then
!         write(*,*) "iqb, iq:", iqb, iq
!         write(*,*) "-sqqb", -s5(iq,iqb), "coefficient:", -(zzLogRat(renscale2,-s5(iq,iqb))+3d0/2d0)
         zb0g1GGG_MHV = -(zzLogRat(renscale2,-s5(iq,iqb))+3d0/2d0)*zb0g0GGG_MHV(iq,iqb,i3,i4,i5)
!          write(*,*) zb0g1GGG_MHV
      elseif(ieorder.eq.-2)then
         zb0g1GGG_MHV = -zb0g0GGG_MHV(iq,iqb,i3,i4,i5)
          
      endif
      
            
      return
      end
      


************************************************************************
*
* A symmetrised version of the B1g1GG over the qqb pair.
*

      function sB1g1GG(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sB1g1GG = 0.5d0*(B1g1GG(i1,i2,i3,i4,i5,renscale2)
     .               +B1g1GG(i3,i2,i1,i4,i5,renscale2))

      return
      end


************************************************************************
*
* A symmetrised version of the Bh1g1GG over the qqb pair.
*

      function sBh1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder

      sBh1g1GG = 0d0

      if(ieorder.eq.-1)then
         sBh1g1GG = 0.5d0*(Bh1g1GG(i1,i2,i3,i4,i5,renscale2)
     .                   +Bh1g1GG(i3,i2,i1,i4,i5,renscale2))
      endif

      return
      end



      function sBt1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sBt1g1GG = 0.5d0*(Bt1g1GG(i1,i2,i3,i4,i5,renscale2)
     .                +Bt1g1GG(i3,i2,i1,i4,i5,renscale2))

      return
      end

************************************************************************
* A wrapper function for B1g1GG which inherits the flavour of the first
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the first pair of quarks
*

      function f1B1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf1
         f1B1g1GG = B1g1GG(i1,i2,i3,i4,i5,renscale2)
      else
         write(*,*) "Error in f1B1g1GG: flavours have not been initialised"
         stop
      endif

      return
      end

************************************************************************
* A wrapper function for B1g1GG which inherits the flavour of the second
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the second pair of quarks
*

      function f2B1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf2.ne.0)then
         nf1g = nf2
         f2B1g1GG = B1g1GG(i1,i2,i3,i4,i5,renscale2)
      else
         write(*,*) "Error in f2B1g0GG: flavours have not been initialised"
         stop
      endif

      return
      end

      function sf2B1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      sf2B1g1GG= 0.5d0*(f1B1g1GG(i1,i2,i3,i4,i5,renscale2)+f1B1g1GG(i3,i2,i1,i4,i5,renscale2))
      return
      end


************************************************************************
* A wrapper function for Bh1g1GG which inherits the flavour of the first
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the second pair of quarks
*

      function f1Bh1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf2.ne.0)then
         nf1g = nf1
         f1Bh1g1GG = Bh1g1GG(i1,i2,i3,i4,i5,renscale2)
      else
         write(*,*) "Error in f1Bh1g0GG: flavours have not been initialised"
         stop
      endif

      return
      end

************************************************************************
* A wrapper function for Bh1g1GG which inherits the flavour of the second
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the second pair of quarks
*

      function f2Bh1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf2.ne.0)then
         nf1g = nf2
         f2Bh1g1GG = Bh1g1GG(i1,i2,i3,i4,i5,renscale2)
      else
         write(*,*) "Error in f2Bh1g0GG: flavours have not been initialised"
         stop
      endif

      return
      end

************************************************************************
* A wrapper function for Bt1g1GG which inherits the flavour of the first
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the first pair of quarks
*

      function f1Bt1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf1
         f1Bt1g1GG = Bt1g1GG(i1,i2,i3,i4,i5,renscale2)
      else
         write(*,*) "Error in f1Bt1g1GG: flavours have not been initialised"
         stop
      endif

      return
      end


************************************************************************
* A wrapper function for B1g1GG which inherits the flavour of the second
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the second pair of quarks
*

      function f2Bt1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf2.ne.0)then
         nf1g = nf2
         f2Bt1g1GG = Bt1g1GG(i1,i2,i3,i4,i5,renscale2)
      else
         write(*,*) "Error in f2Bt1g0GG: flavours have not been initialised"
         stop
      endif

      return
      end

      
************************************************************************
* A wrapper function for Bv1g1GG which inherits the flavour of the first
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the first pair of quarks
*

      function f1Bv1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf1
         f1Bv1g1GG = Bv1g1GG(i1,i2,i3,i4,i5)
      else
         write(*,*) "Error in f1Bv1g1GG: flavours have not been initialised"
         stop
      endif

      return
      end


************************************************************************
* A wrapper function for Bv1g1GG which inherits the flavour of the second
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the second pair of quarks
*

      function f2Bv1g1GG(i1,i2,i3,i4,i5,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf2.ne.0)then
         nf1g = nf2
         f2Bv1g1GG = Bv1g1GG(i1,i2,i3,i4,i5)
      else
         write(*,*) "Error in f2Bv1g0GG: flavours have not been initialised"
         stop
      endif

      return
      end
      
************************************************************************
