************************************************************************
*
* two photon two quark one loop matrix elements interfered with tree level
*
*                      q qb ; p p
*
* summed over colour orderings, summed and squared
*
      function FullB0g1GG(iq,iqb,ip1,ip2,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)

c
c      write(*,*)" hello FullB0g1GG"
c
c from GG.map
c Ofac:="ave*(4d0*pi*amz)**2*nc*8d0";
c# include non-QCD final state averaging factor in Ofac
c# extra factor of 1/2 for two identical photons
c Ofac:=cat(Ofac,"/2d0");     
c
c V1:=[
c [B0g1GG,[qb,q,G,G],(nc**2-1)/nc**2] 
c ]:
c      
      fac=(as*nc/2d0/pi)*(4d0*pi*amz)**2*(nc**2-1d0)/dble(nc)*4d0 

      FullB0g1GG=  +B0g1GG(iq,iqb,ip1,ip2,renscale2)

      FullB0g1GG=fac*FullB0g1GG

*c      write(*,*)"FullB0g1GG",FullB0g1GG
      return
      end
*
************************************************************************
*
      function B0g1GG(iq,iqb,ip1,ip2,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)
      
      call eweakV1qq(nfB1,0d0)

*  q qb -> p1 p2   : (1,3,4,2) and (1,4,3,2)
      if((iq.eq.1).and.(ip1.eq.3).and.(ip2.eq.4).and.(iqb.eq.2))then
        B0g1GG=B0g1GG3(iq,ip1,ip2,iqb,renscale2)
      elseif((iq.eq.1).and.(ip1.eq.4).and.(ip2.eq.3).and.(iqb.eq.2))then
        B0g1GG=B0g1GG3(iq,ip1,ip2,iqb,renscale2)
*  qb q -> p1 p2   : (2,3,4,1) and (2,4,3,1)
      elseif((iq.eq.2).and.(ip1.eq.3).and.(ip2.eq.4).and.(iqb.eq.1))then
        B0g1GG=B0g1GG3(iq,ip1,ip2,iqb,renscale2)
      elseif((iq.eq.2).and.(ip1.eq.4).and.(ip2.eq.3).and.(iqb.eq.1))then
        B0g1GG=B0g1GG3(iq,ip1,ip2,iqb,renscale2)

*  p1 p2 -> qb q   : (3,1,2,4) and (3,2,1,4)
      elseif((iq.eq.3).and.(ip1.eq.1).and.(ip2.eq.2).and.(iqb.eq.4))then
        B0g1GG=B0g1GG3(iq,ip1,ip2,iqb,renscale2)
      elseif((iq.eq.3).and.(ip1.eq.2).and.(ip2.eq.1).and.(iqb.eq.4))then
        B0g1GG=B0g1GG3(iq,ip1,ip2,iqb,renscale2)

*  p1 p2 -> q qb   : (4,1,2,3) and (4,2,1,3)
      elseif((iq.eq.4).and.(ip1.eq.1).and.(ip2.eq.2).and.(iqb.eq.3))then
        B0g1GG=B0g1GG3(iq,ip1,ip2,iqb,renscale2)
      elseif((iq.eq.4).and.(ip1.eq.2).and.(ip2.eq.1).and.(iqb.eq.3))then
        B0g1GG=B0g1GG3(iq,ip1,ip2,iqb,renscale2)

*   q p1 -> q p2   : (1,2,4,3) and (1,4,2,3)
      elseif((iq.eq.1).and.(ip1.eq.2).and.(ip2.eq.4).and.(iqb.eq.3))then
        B0g1GG=B0g1GG1(iq,ip1,ip2,iqb,renscale2)
      elseif((iq.eq.1).and.(ip1.eq.4).and.(ip2.eq.2).and.(iqb.eq.3))then
        B0g1GG=B0g1GG4(iq,ip1,ip2,iqb,renscale2)

*  p1  q -> q p2   : (2,1,4,3) and (2,4,1,3)
      elseif((iq.eq.2).and.(ip1.eq.1).and.(ip2.eq.4).and.(iqb.eq.3))then
        B0g1GG=B0g1GG2(iq,ip1,ip2,iqb,renscale2)
      elseif((iq.eq.2).and.(ip1.eq.4).and.(ip2.eq.1).and.(iqb.eq.3))then
        B0g1GG=B0g1GG5(iq,ip1,ip2,iqb,renscale2)

*  qb p1 -> qb p2  : (3,2,4,1) and (3,4,2,1)
      elseif((iq.eq.3).and.(ip1.eq.2).and.(ip2.eq.4).and.(iqb.eq.1))then
        B0g1GG=B0g1GG4(iq,ip1,ip2,iqb,renscale2)
      elseif((iq.eq.3).and.(ip1.eq.4).and.(ip2.eq.2).and.(iqb.eq.1))then
        B0g1GG=B0g1GG1(iq,ip1,ip2,iqb,renscale2)

*  p1 qb -> qb p2  : (3,1,4,2) and (3,4,1,2)
      elseif((iq.eq.3).and.(ip1.eq.1).and.(ip2.eq.4).and.(iqb.eq.2))then
        B0g1GG=B0g1GG5(iq,ip1,ip2,iqb,renscale2)
      elseif((iq.eq.3).and.(ip1.eq.4).and.(ip2.eq.1).and.(iqb.eq.2))then
        B0g1GG=B0g1GG2(iq,ip1,ip2,iqb,renscale2)
      else
      write(*,*) " WARNING: wrong arguments passed to B0g1GG ",iq,iqb,ip1,ip2
      endif

      B0g1GG = abs(zewfac(1))**4*B0g1GG

      B0g1GG = B0g1GG/8d0

      return
      end

************************************************************************
*
      function B0g1GG1(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ip1)
      s23 =s4(iq,ip2)
      s13 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      B0g1GG1 =  - 16.D0 - 8.D0*s12**(-1)*s13 - 8.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      B0g1GG1 =  + dls * ( 16.D0 + 8.D0*s12**(-1)*s13 + 8.D0*s13*
     &    s23**(-1) )
      B0g1GG1 = B0g1GG1 + dlomx * ( 16.D0 + 8.D0*s12**(-1)*s13 + 8.D0*s13*
     &    s23**(-1) )
      B0g1GG1 = B0g1GG1 - 24.D0 - 12.D0*s12**(-1)*s13 - 12.D0*s13*s23**(-1)

      elseif(ieorder.eq.0)then
      B0g1GG1 =  + pi**2 * ( 16.D0/3.D0 + 26.D0/3.D0*s12**(-1)*s13 + 14.D0
     &    /3.D0*s13*s23**(-1) )
      B0g1GG1 = B0g1GG1 + dls * ( 24.D0 + 12.D0*s12**(-1)*s13 + 12.D0*s13*
     &    s23**(-1) )
      B0g1GG1 = B0g1GG1 + dls**2 * (  - 8.D0 - 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13*s23**(-1) )
      B0g1GG1 = B0g1GG1 + dlomx * ( 16.D0 )
      B0g1GG1 = B0g1GG1 + dlomx*dls * (  - 16.D0 - 8.D0*s12**(-1)*s13 - 8.D0
     &    *s13*s23**(-1) )
      B0g1GG1 = B0g1GG1 + dlomx**2 * ( 8.D0*s12**(-1)*s13 + 8.D0*s13*
     &    s23**(-1) )
      B0g1GG1 = B0g1GG1 + dlx * ( 4.D0 + 12.D0*s13*s23**(-1) )
      B0g1GG1 = B0g1GG1 + dlx*dlomx * (  - 8.D0 - 16.D0*s12**(-1)*s13 - 8.D0
     &    *s13*s23**(-1) )
      B0g1GG1 = B0g1GG1 + dlx**2 * ( 4.D0 + 8.D0*s12**(-1)*s13 + 4.D0*s13*
     &    s23**(-1) )
      B0g1GG1 = B0g1GG1 - 56.D0 - 28.D0*s12**(-1)*s13 - 28.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function B0g1GG2(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ip1)
      s13 =s4(iq,ip2)
      s23 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      B0g1GG2 =  - 8.D0 + 8.D0*s12**(-1)*s13 - 8.D0*s13**(-1)*s23

      elseif(ieorder.eq.-1)then
      B0g1GG2 =  + dls * ( 8.D0 - 8.D0*s12**(-1)*s13 + 8.D0*s13**(-1)*s23
     &     )
      B0g1GG2 = B0g1GG2 + dlx * ( 8.D0 - 8.D0*s12**(-1)*s13 + 8.D0*
     &    s13**(-1)*s23 )
      B0g1GG2 = B0g1GG2 - 12.D0 + 12.D0*s12**(-1)*s13 - 12.D0*s13**(-1)*s23

      elseif(ieorder.eq.0)then
      B0g1GG2 =  + pi**2 * (  - 10.D0/3.D0 - 26.D0/3.D0*s12**(-1)*s13 + 
     &    14.D0/3.D0*s13**(-1)*s23 )
      B0g1GG2 = B0g1GG2 + dls * ( 12.D0 - 12.D0*s12**(-1)*s13 + 12.D0*
     &    s13**(-1)*s23 )
      B0g1GG2 = B0g1GG2 + dls**2 * (  - 4.D0 + 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13**(-1)*s23 )
      B0g1GG2 = B0g1GG2 + dlomx * ( 4.D0 + 12.D0*s13**(-1)*s23 )
      B0g1GG2 = B0g1GG2 + dlomx**2 * (  - 4.D0 - 8.D0*s12**(-1)*s13 + 4.D0*
     &    s13**(-1)*s23 )
      B0g1GG2 = B0g1GG2 + dlx * ( 16.D0 )
      B0g1GG2 = B0g1GG2 + dlx*dls * (  - 8.D0 + 8.D0*s12**(-1)*s13 - 8.D0*
     &    s13**(-1)*s23 )
      B0g1GG2 = B0g1GG2 + dlx*dlomx * ( 8.D0 + 16.D0*s12**(-1)*s13 - 8.D0*
     &    s13**(-1)*s23 )
      B0g1GG2 = B0g1GG2 + dlx**2 * (  - 8.D0 - 8.D0*s12**(-1)*s13 + 8.D0*
     &    s13**(-1)*s23 )
      B0g1GG2 = B0g1GG2 - 28.D0 + 28.D0*s12**(-1)*s13 - 28.D0*s13**(-1)*s23

      endif
      return
      end
************************************************************************
*
      function B0g1GG3(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s13 =s4(iq,ip1)
      s23 =s4(iq,ip2)
      s12 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      B0g1GG3 =  - 8.D0*s13**(-1)*s23 - 8.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      B0g1GG3 =  + dls * ( 8.D0*s13**(-1)*s23 + 8.D0*s13*s23**(-1) )
      B0g1GG3 = B0g1GG3 - 12.D0*s13**(-1)*s23 - 12.D0*s13*s23**(-1)

      elseif(ieorder.eq.0)then
      B0g1GG3 =  + pi**2 * ( 14.D0/3.D0*s13**(-1)*s23 + 14.D0/3.D0*s13*
     &    s23**(-1) )
      B0g1GG3 = B0g1GG3 + dls * ( 12.D0*s13**(-1)*s23 + 12.D0*s13*s23**(-1)
     &     )
      B0g1GG3 = B0g1GG3 + dls**2 * (  - 4.D0*s13**(-1)*s23 - 4.D0*s13*
     &    s23**(-1) )
      B0g1GG3 = B0g1GG3 + dlomx * ( 8.D0 + 12.D0*s13**(-1)*s23 )
      B0g1GG3 = B0g1GG3 + dlomx**2 * ( 8.D0 + 4.D0*s13**(-1)*s23 + 8.D0*s13
     &    *s23**(-1) )
      B0g1GG3 = B0g1GG3 + dlx * ( 8.D0 + 12.D0*s13*s23**(-1) )
      B0g1GG3 = B0g1GG3 + dlx**2 * ( 8.D0 + 8.D0*s13**(-1)*s23 + 4.D0*s13*
     &    s23**(-1) )
      B0g1GG3 = B0g1GG3 - 28.D0*s13**(-1)*s23 - 28.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function B0g1GG4(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s23 =s4(iq,ip1)
      s12 =s4(iq,ip2)
      s13 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      B0g1GG4 =  - 16.D0 - 8.D0*s12**(-1)*s13 - 8.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      B0g1GG4 =  + dls * ( 16.D0 + 8.D0*s12**(-1)*s13 + 8.D0*s13*
     &    s23**(-1) )
      B0g1GG4 = B0g1GG4 + dlomx * ( 16.D0 + 8.D0*s12**(-1)*s13 + 8.D0*s13*
     &    s23**(-1) )
      B0g1GG4 = B0g1GG4 - 24.D0 - 12.D0*s12**(-1)*s13 - 12.D0*s13*s23**(-1)

      elseif(ieorder.eq.0)then
      B0g1GG4 =  + pi**2 * ( 16.D0/3.D0 + 26.D0/3.D0*s12**(-1)*s13 + 14.D0
     &    /3.D0*s13*s23**(-1) )
      B0g1GG4 = B0g1GG4 + dls * ( 24.D0 + 12.D0*s12**(-1)*s13 + 12.D0*s13*
     &    s23**(-1) )
      B0g1GG4 = B0g1GG4 + dls**2 * (  - 8.D0 - 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13*s23**(-1) )
      B0g1GG4 = B0g1GG4 + dlomx * ( 16.D0 )
      B0g1GG4 = B0g1GG4 + dlomx*dls * (  - 16.D0 - 8.D0*s12**(-1)*s13 - 8.D0
     &    *s13*s23**(-1) )
      B0g1GG4 = B0g1GG4 + dlomx**2 * ( 8.D0*s12**(-1)*s13 + 8.D0*s13*
     &    s23**(-1) )
      B0g1GG4 = B0g1GG4 + dlx * ( 4.D0 + 12.D0*s13*s23**(-1) )
      B0g1GG4 = B0g1GG4 + dlx*dlomx * (  - 8.D0 - 16.D0*s12**(-1)*s13 - 8.D0
     &    *s13*s23**(-1) )
      B0g1GG4 = B0g1GG4 + dlx**2 * ( 4.D0 + 8.D0*s12**(-1)*s13 + 4.D0*s13*
     &    s23**(-1) )
      B0g1GG4 = B0g1GG4 - 56.D0 - 28.D0*s12**(-1)*s13 - 28.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function B0g1GG5(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s13 =s4(iq,ip1)
      s12 =s4(iq,ip2)
      s23 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      B0g1GG5 =  - 8.D0 + 8.D0*s12**(-1)*s13 - 8.D0*s13**(-1)*s23

      elseif(ieorder.eq.-1)then
      B0g1GG5 =  + dls * ( 8.D0 - 8.D0*s12**(-1)*s13 + 8.D0*s13**(-1)*s23
     &     )
      B0g1GG5 = B0g1GG5 + dlx * ( 8.D0 - 8.D0*s12**(-1)*s13 + 8.D0*
     &    s13**(-1)*s23 )
      B0g1GG5 = B0g1GG5 - 12.D0 + 12.D0*s12**(-1)*s13 - 12.D0*s13**(-1)*s23

      elseif(ieorder.eq.0)then
      B0g1GG5 =  + pi**2 * (  - 10.D0/3.D0 - 26.D0/3.D0*s12**(-1)*s13 + 
     &    14.D0/3.D0*s13**(-1)*s23 )
      B0g1GG5 = B0g1GG5 + dls * ( 12.D0 - 12.D0*s12**(-1)*s13 + 12.D0*
     &    s13**(-1)*s23 )
      B0g1GG5 = B0g1GG5 + dls**2 * (  - 4.D0 + 4.D0*s12**(-1)*s13 - 4.D0*
     &    s13**(-1)*s23 )
      B0g1GG5 = B0g1GG5 + dlomx * ( 4.D0 + 12.D0*s13**(-1)*s23 )
      B0g1GG5 = B0g1GG5 + dlomx**2 * (  - 4.D0 - 8.D0*s12**(-1)*s13 + 4.D0*
     &    s13**(-1)*s23 )
      B0g1GG5 = B0g1GG5 + dlx * ( 16.D0 )
      B0g1GG5 = B0g1GG5 + dlx*dls * (  - 8.D0 + 8.D0*s12**(-1)*s13 - 8.D0*
     &    s13**(-1)*s23 )
      B0g1GG5 = B0g1GG5 + dlx*dlomx * ( 8.D0 + 16.D0*s12**(-1)*s13 - 8.D0*
     &    s13**(-1)*s23 )
      B0g1GG5 = B0g1GG5 + dlx**2 * (  - 8.D0 - 8.D0*s12**(-1)*s13 + 8.D0*
     &    s13**(-1)*s23 )
      B0g1GG5 = B0g1GG5 - 28.D0 + 28.D0*s12**(-1)*s13 - 28.D0*s13**(-1)*s23

      endif
      return
      end
************************************************************************
*
      function catB0g1GG1(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ip1)
      s23 =s4(iq,ip2)
      s13 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      catB0g1GG1 =  - 16.D0 + 16.D0*s12**(-1)*s23 - 16.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      catB0g1GG1 =  + dls * ( 16.D0 - 16.D0*s12**(-1)*s23 + 16.D0*s13*
     &    s23**(-1) )
      catB0g1GG1 = catB0g1GG1 + dlomx * ( 16.D0 - 16.D0*s12**(-1)*s23 + 16.D
     &    0*s13*s23**(-1) )
      catB0g1GG1 = catB0g1GG1 - 24.D0 + 24.D0*s12**(-1)*s23 - 24.D0*s13*
     &    s23**(-1)

      elseif(ieorder.eq.0)then
      catB0g1GG1 =  + pi**2 * ( 4.D0/3.D0 - 4.D0/3.D0*s12**(-1)*s23 + 4.D0
     &    /3.D0*s13*s23**(-1) )
      catB0g1GG1 = catB0g1GG1 + dls * ( 24.D0 - 24.D0*s12**(-1)*s23 + 24.D0
     &    *s13*s23**(-1) )
      catB0g1GG1 = catB0g1GG1 + dls**2 * (  - 8.D0 + 8.D0*s12**(-1)*s23 - 8.
     &    D0*s13*s23**(-1) )
      catB0g1GG1 = catB0g1GG1 + dlomx * ( 24.D0 - 24.D0*s12**(-1)*s23 + 24.D
     &    0*s13*s23**(-1) )
      catB0g1GG1 = catB0g1GG1 + dlomx*dls * (  - 16.D0 + 16.D0*s12**(-1)*
     &    s23 - 16.D0*s13*s23**(-1) )
      catB0g1GG1 = catB0g1GG1 + dlomx**2 * (  - 8.D0 + 8.D0*s12**(-1)*s23
     &     - 8.D0*s13*s23**(-1) )

      endif
      return
      end
************************************************************************
*
      function catB0g1GG2(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ip1)
      s13 =s4(iq,ip2)
      s23 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      catB0g1GG2 =  - 32.D0 - 16.D0*s12**(-1)*s23 - 16.D0*s13**(-1)*s23

      elseif(ieorder.eq.-1)then
      catB0g1GG2 =  + dls * ( 32.D0 + 16.D0*s12**(-1)*s23 + 16.D0*
     &    s13**(-1)*s23 )
      catB0g1GG2 = catB0g1GG2 + dlx * ( 32.D0 + 16.D0*s12**(-1)*s23 + 16.D0
     &    *s13**(-1)*s23 )
      catB0g1GG2 = catB0g1GG2 - 48.D0 - 24.D0*s12**(-1)*s23 - 24.D0*
     &    s13**(-1)*s23

      elseif(ieorder.eq.0)then
      catB0g1GG2 =  + pi**2 * ( 8.D0/3.D0 + 4.D0/3.D0*s12**(-1)*s23 + 4.D0
     &    /3.D0*s13**(-1)*s23 )
      catB0g1GG2 = catB0g1GG2 + dls * ( 48.D0 + 24.D0*s12**(-1)*s23 + 24.D0
     &    *s13**(-1)*s23 )
      catB0g1GG2 = catB0g1GG2 + dls**2 * (  - 16.D0 - 8.D0*s12**(-1)*s23 - 
     &    8.D0*s13**(-1)*s23 )
      catB0g1GG2 = catB0g1GG2 + dlx * ( 48.D0 + 24.D0*s12**(-1)*s23 + 24.D0
     &    *s13**(-1)*s23 )
      catB0g1GG2 = catB0g1GG2 + dlx*dls * (  - 32.D0 - 16.D0*s12**(-1)*s23
     &     - 16.D0*s13**(-1)*s23 )
      catB0g1GG2 = catB0g1GG2 + dlx**2 * (  - 16.D0 - 8.D0*s12**(-1)*s23 - 
     &    8.D0*s13**(-1)*s23 )

      endif
      return
      end
************************************************************************
*
      function catB0g1GG3(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s13 =s4(iq,ip1)
      s23 =s4(iq,ip2)
      s12 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      catB0g1GG3 =  - 16.D0*s13**(-1)*s23 - 16.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      catB0g1GG3 =  + dls * ( 16.D0*s13**(-1)*s23 + 16.D0*s13*s23**(-1) )
      catB0g1GG3 = catB0g1GG3 - 24.D0*s13**(-1)*s23 - 24.D0*s13*s23**(-1)

      elseif(ieorder.eq.0)then
      catB0g1GG3 =  + pi**2 * ( 28.D0/3.D0*s13**(-1)*s23 + 28.D0/3.D0*s13
     &    *s23**(-1) )
      catB0g1GG3 = catB0g1GG3 + dls * ( 24.D0*s13**(-1)*s23 + 24.D0*s13*
     &    s23**(-1) )
      catB0g1GG3 = catB0g1GG3 + dls**2 * (  - 8.D0*s13**(-1)*s23 - 8.D0*s13
     &    *s23**(-1) )

      endif
      return
      end
************************************************************************
*
      function catB0g1GG4(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s23 =s4(iq,ip1)
      s12 =s4(iq,ip2)
      s13 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      catB0g1GG4 =  - 16.D0 + 16.D0*s12**(-1)*s23 - 16.D0*s13*s23**(-1)

      elseif(ieorder.eq.-1)then
      catB0g1GG4 =  + dls * ( 16.D0 - 16.D0*s12**(-1)*s23 + 16.D0*s13*
     &    s23**(-1) )
      catB0g1GG4 = catB0g1GG4 + dlomx * ( 16.D0 - 16.D0*s12**(-1)*s23 + 16.D
     &    0*s13*s23**(-1) )
      catB0g1GG4 = catB0g1GG4 - 24.D0 + 24.D0*s12**(-1)*s23 - 24.D0*s13*
     &    s23**(-1)

      elseif(ieorder.eq.0)then
      catB0g1GG4 =  + pi**2 * ( 4.D0/3.D0 - 4.D0/3.D0*s12**(-1)*s23 + 4.D0
     &    /3.D0*s13*s23**(-1) )
      catB0g1GG4 = catB0g1GG4 + dls * ( 24.D0 - 24.D0*s12**(-1)*s23 + 24.D0
     &    *s13*s23**(-1) )
      catB0g1GG4 = catB0g1GG4 + dls**2 * (  - 8.D0 + 8.D0*s12**(-1)*s23 - 8.
     &    D0*s13*s23**(-1) )
      catB0g1GG4 = catB0g1GG4 + dlomx * ( 24.D0 - 24.D0*s12**(-1)*s23 + 24.D
     &    0*s13*s23**(-1) )
      catB0g1GG4 = catB0g1GG4 + dlomx*dls * (  - 16.D0 + 16.D0*s12**(-1)*
     &    s23 - 16.D0*s13*s23**(-1) )
      catB0g1GG4 = catB0g1GG4 + dlomx**2 * (  - 8.D0 + 8.D0*s12**(-1)*s23
     &     - 8.D0*s13*s23**(-1) )

      endif
      return
      end
************************************************************************
*
      function catB0g1GG5(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s13 =s4(iq,ip1)
      s12 =s4(iq,ip2)
      s23 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      catB0g1GG5 =  - 32.D0 - 16.D0*s12**(-1)*s23 - 16.D0*s13**(-1)*s23

      elseif(ieorder.eq.-1)then
      catB0g1GG5 =  + dls * ( 32.D0 + 16.D0*s12**(-1)*s23 + 16.D0*
     &    s13**(-1)*s23 )
      catB0g1GG5 = catB0g1GG5 + dlx * ( 32.D0 + 16.D0*s12**(-1)*s23 + 16.D0
     &    *s13**(-1)*s23 )
      catB0g1GG5 = catB0g1GG5 - 48.D0 - 24.D0*s12**(-1)*s23 - 24.D0*
     &    s13**(-1)*s23

      elseif(ieorder.eq.0)then
      catB0g1GG5 =  + pi**2 * ( 8.D0/3.D0 + 4.D0/3.D0*s12**(-1)*s23 + 4.D0
     &    /3.D0*s13**(-1)*s23 )
      catB0g1GG5 = catB0g1GG5 + dls * ( 48.D0 + 24.D0*s12**(-1)*s23 + 24.D0
     &    *s13**(-1)*s23 )
      catB0g1GG5 = catB0g1GG5 + dls**2 * (  - 16.D0 - 8.D0*s12**(-1)*s23 - 
     &    8.D0*s13**(-1)*s23 )
      catB0g1GG5 = catB0g1GG5 + dlx * ( 48.D0 + 24.D0*s12**(-1)*s23 + 24.D0
     &    *s13**(-1)*s23 )
      catB0g1GG5 = catB0g1GG5 + dlx*dls * (  - 32.D0 - 16.D0*s12**(-1)*s23
     &     - 16.D0*s13**(-1)*s23 )
      catB0g1GG5 = catB0g1GG5 + dlx**2 * (  - 16.D0 - 8.D0*s12**(-1)*s23 - 
     &    8.D0*s13**(-1)*s23 )

      endif
      return
      end
************************************************************************
*
      function finiteB0g1GG1(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ip1)
      s23 =s4(iq,ip2)
      s13 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      finiteB0g1GG1 =  0

      elseif(ieorder.eq.-1)then
      finiteB0g1GG1 =  0

      elseif(ieorder.eq.0)then
      finiteB0g1GG1 =  + pi**2 * (  - 16.D0 - 16.D0*s12**(-1)*s23 - 8.D0*
     &    s12*s23**(-1) )
      finiteB0g1GG1 = finiteB0g1GG1 + dlomx * ( 32.D0 + 24.D0*s12**(-1)*s23
     &     + 24.D0*s12*s23**(-1) )
      finiteB0g1GG1 = finiteB0g1GG1 + dlomx**2 * (  - 32.D0 - 24.D0*
     &    s12**(-1)*s23 - 24.D0*s12*s23**(-1) )
      finiteB0g1GG1 = finiteB0g1GG1 + dlx * (  - 16.D0 - 24.D0*s12*
     &    s23**(-1) )
      finiteB0g1GG1 = finiteB0g1GG1 + dlx*dlomx * ( 32.D0 + 32.D0*s12**(-1)
     &    *s23 + 16.D0*s12*s23**(-1) )
      finiteB0g1GG1 = finiteB0g1GG1 + dlx**2 * (  - 16.D0 - 16.D0*s12**(-1)
     &    *s23 - 8.D0*s12*s23**(-1) )
      finiteB0g1GG1 = finiteB0g1GG1 + 56.D0*s12**(-1)*s23 + 56.D0*s12*
     &    s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteB0g1GG2(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq,ip1)
      s13 =s4(iq,ip2)
      s23 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      finiteB0g1GG2 =  0

      elseif(ieorder.eq.-1)then
      finiteB0g1GG2 =  0

      elseif(ieorder.eq.0)then
      finiteB0g1GG2 =  + pi**2 * ( 16.D0*s12**(-1)*s23 - 8.D0*s12*
     &    s13**(-1) )
      finiteB0g1GG2 = finiteB0g1GG2 + dlomx * (  - 16.D0 - 24.D0*s12*
     &    s13**(-1) )
      finiteB0g1GG2 = finiteB0g1GG2 + dlomx**2 * ( 16.D0*s12**(-1)*s23 - 8.D
     &    0*s12*s13**(-1) )
      finiteB0g1GG2 = finiteB0g1GG2 + dlx * ( 8.D0 - 24.D0*s12**(-1)*s23 + 
     &    24.D0*s12*s13**(-1) )
      finiteB0g1GG2 = finiteB0g1GG2 + dlx*dlomx * (  - 32.D0*s12**(-1)*s23
     &     + 16.D0*s12*s13**(-1) )
      finiteB0g1GG2 = finiteB0g1GG2 + dlx**2 * (  - 8.D0 + 24.D0*s12**(-1)*
     &    s23 - 24.D0*s12*s13**(-1) )
      finiteB0g1GG2 = finiteB0g1GG2 - 56.D0 - 56.D0*s12**(-1)*s23 + 56.D0*
     &    s12*s13**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteB0g1GG3(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s13 =s4(iq,ip1)
      s23 =s4(iq,ip2)
      s12 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      finiteB0g1GG3 =  0

      elseif(ieorder.eq.-1)then
      finiteB0g1GG3 =  0

      elseif(ieorder.eq.0)then
      finiteB0g1GG3 =  + dlomx * (  - 8.D0 - 24.D0*s12*s13**(-1) )
      finiteB0g1GG3 = finiteB0g1GG3 + dlomx**2 * (  - 8.D0 - 8.D0*s12*
     &    s13**(-1) - 16.D0*s12*s23**(-1) )
      finiteB0g1GG3 = finiteB0g1GG3 + dlx * (  - 8.D0 - 24.D0*s12*s23**(-1)
     &     )
      finiteB0g1GG3 = finiteB0g1GG3 + dlx**2 * (  - 8.D0 - 16.D0*s12*
     &    s13**(-1) - 8.D0*s12*s23**(-1) )
      finiteB0g1GG3 = finiteB0g1GG3 + 112.D0 + 56.D0*s12*s13**(-1) + 56.D0*
     &    s12*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteB0g1GG4(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s23 =s4(iq,ip1)
      s12 =s4(iq,ip2)
      s13 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      finiteB0g1GG4 =  0

      elseif(ieorder.eq.-1)then
      finiteB0g1GG4 =  0

      elseif(ieorder.eq.0)then
      finiteB0g1GG4 =  + pi**2 * (  - 16.D0 - 16.D0*s12**(-1)*s23 - 8.D0*
     &    s12*s23**(-1) )
      finiteB0g1GG4 = finiteB0g1GG4 + dlomx * ( 32.D0 + 24.D0*s12**(-1)*s23
     &     + 24.D0*s12*s23**(-1) )
      finiteB0g1GG4 = finiteB0g1GG4 + dlomx**2 * (  - 32.D0 - 24.D0*
     &    s12**(-1)*s23 - 24.D0*s12*s23**(-1) )
      finiteB0g1GG4 = finiteB0g1GG4 + dlx * (  - 16.D0 - 24.D0*s12*
     &    s23**(-1) )
      finiteB0g1GG4 = finiteB0g1GG4 + dlx*dlomx * ( 32.D0 + 32.D0*s12**(-1)
     &    *s23 + 16.D0*s12*s23**(-1) )
      finiteB0g1GG4 = finiteB0g1GG4 + dlx**2 * (  - 16.D0 - 16.D0*s12**(-1)
     &    *s23 - 8.D0*s12*s23**(-1) )
      finiteB0g1GG4 = finiteB0g1GG4 + 56.D0*s12**(-1)*s23 + 56.D0*s12*
     &    s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteB0g1GG5(iq,ip1,ip2,iqb,renscale2)
        use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s13 =s4(iq,ip1)
      s12 =s4(iq,ip2)
      s23 =s4(iq,iqb)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      finiteB0g1GG5 =  0

      elseif(ieorder.eq.-1)then
      finiteB0g1GG5 =  0

      elseif(ieorder.eq.0)then
      finiteB0g1GG5 =  + pi**2 * ( 16.D0*s12**(-1)*s23 - 8.D0*s12*
     &    s13**(-1) )
      finiteB0g1GG5 = finiteB0g1GG5 + dlomx * (  - 16.D0 - 24.D0*s12*
     &    s13**(-1) )
      finiteB0g1GG5 = finiteB0g1GG5 + dlomx**2 * ( 16.D0*s12**(-1)*s23 - 8.D
     &    0*s12*s13**(-1) )
      finiteB0g1GG5 = finiteB0g1GG5 + dlx * ( 8.D0 - 24.D0*s12**(-1)*s23 + 
     &    24.D0*s12*s13**(-1) )
      finiteB0g1GG5 = finiteB0g1GG5 + dlx*dlomx * (  - 32.D0*s12**(-1)*s23
     &     + 16.D0*s12*s13**(-1) )
      finiteB0g1GG5 = finiteB0g1GG5 + dlx**2 * (  - 8.D0 + 24.D0*s12**(-1)*
     &    s23 - 24.D0*s12*s13**(-1) )
      finiteB0g1GG5 = finiteB0g1GG5 - 56.D0 - 56.D0*s12**(-1)*s23 + 56.D0*
     &    s12*s13**(-1)

      endif
      return
      end
