****************************************************
* gluon pair two loop matrix elements for g + g --> H
*
*


      function A2g2H(i1,i2,i3,i4,renscale2)
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole
      common /npars/npars,nspec,n

      if (nspec<2 .or. nspec>4) stop "A2g2H: invalid nspec"
      s12 = kin(nspec+2)%s(i1,i2)
      tree = A2g0H(i1,i2,i3,i4)
      dls12 = log(renscale2/abs(s12))

      select case(ipole)
      case(-4)
      A2g2H =  + tree * ( 2 )

      case(-3)
      A2g2H =  + tree * ( 121.D0/12.D0 + 4*dls12 )

      case(-2)
      A2g2H =  + tree * ( 74.D0/9.D0 + 55.D0/6.D0*dls12 + 4*dls12**2 - 
     &    9.D0/4.D0*pi**2 )

      case(-1)
      A2g2H =  + tree * (  - 65.D0/27.D0 - 67.D0/18.D0*dls12 + 11.D0/3.D
     &    0*dls12**2 + 8.D0/3.D0*dls12**3 - 53.D0/6.D0*zeta3 - 33.D0/8.D
     &    0*pi**2 - 9.D0/2.D0*pi**2*dls12 )

      case default
      A2g2H =  + tree * ( 5105.D0/324.D0 + 34.D0/3.D0*dls12 + 121.D0/12.
     &    D0*dls12**2 - 253.D0/36.D0*zeta3 - 83.D0/36.D0*pi**2 + 1.D0/
     &    144.D0*pi**4 )

      end select

      return
      end


      function At2g2H(i1,i2,i3,i4,renscale2)
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole
      common /npars/npars,nspec,n

      if (nspec<2 .or. nspec>4) stop "At2g2H: invalid nspec"
      s12 = kin(nspec+2)%s(i1,i2)
      tree = A2g0H(i1,i2,i3,i4)
      dls12 = log(renscale2/abs(s12))

      select case(ipole)
      case(-4)
      At2g2H =  0

      case(-3)
      At2g2H =  0

      case(-2)
      At2g2H =  0

      case(-1)
      At2g2H =  0

      case default
      At2g2H =  0

      end select

      return
      end


      function Ah2g2H(i1,i2,i3,i4,renscale2)
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole
      common /npars/npars,nspec,n

      if (nspec<2 .or. nspec>4) stop "Ah2g2H: invalid nspec"
      s12 = kin(nspec+2)%s(i1,i2)
      tree = A2g0H(i1,i2,i3,i4)
      dls12 = log(renscale2/abs(s12))

      select case(ipole)
      case(-4)
      Ah2g2H =  0

      case(-3)
      Ah2g2H =  + tree * (  - 11.D0/6.D0 )

      case(-2)
      Ah2g2H =  + tree * (  - 61.D0/18.D0 - 5.D0/3.D0*dls12 )

      case(-1)
      Ah2g2H =  + tree * ( 155.D0/108.D0 + 5.D0/9.D0*dls12 - 2.D0/3.D0*
     &    dls12**2 + 3.D0/4.D0*pi**2 )

      case default
      Ah2g2H =  + tree * (  - 5473.D0/648.D0 - 13.D0/3.D0*dls12 - 11.D0/
     &    3.D0*dls12**2 - 13.D0/18.D0*zeta3 + 217.D0/216.D0*pi**2 )

      end select

      return
      end


      function Aht2g2H(i1,i2,i3,i4,renscale2)
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole
      common /npars/npars,nspec,n

      if (nspec<2 .or. nspec>4) stop "Aht2g2H: invalid nspec"
      s12 = kin(nspec+2)%s(i1,i2)
      tree = A2g0H(i1,i2,i3,i4)
      dls12 = log(renscale2/abs(s12))

      select case(ipole)
      case(-4)
      Aht2g2H =  0

      case(-3)
      Aht2g2H =  0

      case(-2)
      Aht2g2H =  0

      case(-1)
      Aht2g2H =  + tree * (  - 1.D0/4.D0 )

      case default
      Aht2g2H =  + tree * ( 67.D0/24.D0 + dls12 - 2*zeta3 )

      end select

      return
      end


      function Ahh2g2H(i1,i2,i3,i4,renscale2)
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole
      common /npars/npars,nspec,n

      if (nspec<2 .or. nspec>4) stop "Ahh2g2H: invalid nspec"
      s12 = kin(nspec+2)%s(i1,i2)
      tree = A2g0H(i1,i2,i3,i4)
      dls12 = log(renscale2/abs(s12))

      select case(ipole)
      case(-4)
      Ahh2g2H =  0

      case(-3)
      Ahh2g2H =  0

      case(-2)
      Ahh2g2H =  + tree * ( 1.D0/3.D0 )

      case(-1)
      Ahh2g2H =  0

      case default
      Ahh2g2H =  + tree * ( 1.D0/3.D0*dls12**2 - 11.D0/108.D0*pi**2 )

      end select

      return
      end


