*************************************************************************
!XC Tree level ME for Higgs plus up to five gluons
!XC up to four gluons analytical results checked against hep-th/0411092
!  L.~J.~Dixon, E.~W.~N.~Glover and V.~V.~Khoze,
!  %``MHV rules for Higgs plus multi-gluon amplitudes,''
!  JHEP {\bf 0412} (2004) 015
!  doi:10.1088/1126-6708/2004/12/015
!  [hep-th/0411092].

!XC for five gluons analytical results calculated using BCFW method: 
!  R.~Britto, F.~Cachazo and B.~Feng,
!  %``Generalized unitarity and one-loop amplitudes in N=4 super-Yang-Mills,''
!  Nucl.\ Phys.\ B {\bf 725} (2005) 275
!  doi:10.1016/j.nuclphysb.2005.07.014
!  [hep-th/0412103].

!  R.~Britto, F.~Cachazo, B.~Feng and E.~Witten,
!  %``Direct proof of tree-level recursion relation in Yang-Mills theory,''
!  Phys.\ Rev.\ Lett.\  {\bf 94} (2005) 181602
!  doi:10.1103/PhysRevLett.94.181602
!  [hep-th/0501052].

!  R.~Britto, F.~Cachazo, B.~Feng and E.~Witten,
!  %``Direct proof of tree-level recursion relation in Yang-Mills theory,''
!  Phys.\ Rev.\ Lett.\  {\bf 94} (2005) 181602
!  doi:10.1103/PhysRevLett.94.181602
!  [hep-th/0501052].

*************************************************************************
*XC two gluon one Higgs zero quark tree level matrix elements
*XC summed over colour orderings, summed and squared

      function FullA2g0H(i1,i2,i3,i4)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

*XC (2.1) of hep-th/0411092v2
*XC take (C/2)**2 after squaring
      stop "set value for chgg correctly!"
      fac=(nc**2-1d0)*2d0*chgg**2/4d0

      FullA2g0H=+A2g0H(i1,i2,i3,i4)

      FullA2g0H=fac*FullA2g0H
*      write(*,*)"FullA2g0H",FullA2g0H

      return
      end
************************************************************************
*XC two gluon one phi higgs zero quark tree level matrix elements
*XC one colour ordering, summed and squared
*
      function A2g0H(i1,i2,i3,i4)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /npars/npars,nspec,ni
      real*8, pointer :: s12

      ipset = nspec+2
      s12 => kin(ipset)%s(i1,i2)

      A2g0H=2d0*s12**2

*      write(*,*)"A2g0H",A2g0H

      return
      end
************************************************************************
*XC three gluon one Higgs zero quark tree level matrix elements
*XC summed over colour orderings, summed and squared

      function FullA3g0H(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

*XC (2.1) of hep-th/0411092v2
*XC take (C/2)**2 after squaring
      stop "set value for chgg correctly!"
      fac=(4d0*pi*as*nc)**1*(nc**2-1d0)*2d0*chgg**2/4d0

      FullA3g0H=+A3g0H(i1,i2,i3,i4,i5)

      FullA3g0H=fac*FullA3g0H
*      write(*,*)"FullA3g0H",FullA3g0H

      return
      end
************************************************************************
*XC three gluon one phi higgs zero quark tree level matrix elements
*XC one colour ordering, summed and squared
*
      function A3g0H(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer ipset
      parameter(pi=3.141592653589793238d0)
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s31,s23

      ipset = nspec+3
      s12 => kin(ipset)%s(i1,i2)
      s31 => kin(ipset)%s(i3,i1)
      s23 => kin(ipset)%s(i2,i3)

      hs=(s12+s23+s31)**4+s12**4+s23**4+s31**4

      A3g0H=2d0*hs/s12/s23/s31

*      write(*,*)"A3g0H",A3g0H

      return
      end
************************************************************************
*XC four gluon one higgs zero quark tree level matrix elements
*XC summed over colour orderings, summed and squared
*
      function FullA4g0H(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

*XC (2.1) of hep-th/0411092v2
*XC take (C/2)**2 after squaring
      stop "set value for chgg correctly!"
      fac=(4d0*pi*as*nc)**2*(nc**2-1d0)*2d0*chgg**2/4d0
*XC form (3.38)of hep-ph 1003.2824v2

      FullA4g0H=+A4g0H(i1,i2,i3,i4,i5,i6)
     .          +A4g0H(i1,i2,i4,i3,i5,i6)
     .          +A4g0H(i1,i3,i2,i4,i5,i6)
*      FullA4g0H=fac*FullA4g0H

*      write(*,*)"FullA4g0H",FullA4g0H
      return
      end
************************************************************************
*XC four gluon one higgs zero quark tree level matrix elements
*XC one colour ordering, summed and squared  with both phi and cphi field
*
      function A4g0H(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer NHEL(4,8),PERM(6)
      integer PERMb(6),PERMc(6),PERMd(6)

      DATA (NHEL(IHEL,   1),IHEL=1, 4) / -1,-1,-1,-1/
      DATA (NHEL(IHEL,   2),IHEL=1, 4) /  1,-1,-1,-1/
      DATA (NHEL(IHEL,   3),IHEL=1, 4) / -1, 1,-1,-1/
      DATA (NHEL(IHEL,   4),IHEL=1, 4) / -1,-1, 1,-1/
      DATA (NHEL(IHEL,   5),IHEL=1, 4) / -1,-1,-1, 1/
      DATA (NHEL(IHEL,   6),IHEL=1, 4) / -1,-1, 1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1, 4) / -1, 1,-1, 1/
      DATA (NHEL(IHEL,   8),IHEL=1, 4) / -1, 1, 1,-1/

        perm(1)=i1
        perm(2)=i2
        perm(3)=i3
        perm(4)=i4
        perm(5)=i5
        perm(6)=i6

        permb(1)=i2
        permb(2)=i3
        permb(3)=i4
        permb(4)=i1
        permb(5)=i5
        permb(6)=i6

        permc(1)=i3
        permc(2)=i4
        permc(3)=i1
        permc(4)=i2
        permc(5)=i5
        permc(6)=i6

        permd(1)=i4
        permd(2)=i1
        permd(3)=i2
        permd(4)=i3
        permd(5)=i5
        permd(6)=i6


        amp2=0d0
       do i=1,8
           if(i.eq.1) then
            zamp=zA4g0Hmmmm(perm(1))
           endif
           if(i.eq.2) then
            zamp=zA4g0Hpmmm(perm(1))
           endif
           if(i.eq.3) then
            zamp=zA4g0Hpmmm(permb(1))
           endif
           if(i.eq.4) then
            zamp=zA4g0Hpmmm(permc(1))
           endif
           if(i.eq.5) then
            zamp=zA4g0Hpmmm(permd(1))
           endif
           if(i.eq.6) then
            zamp=zA4g0Hmmpp(perm(1))
           endif
           if(i.eq.7) then
            zamp=zA4g0Hmpmp(perm(1))
           endif
           if(i.eq.8) then
            zamp=Dconjg(zA4g0Hmmpp(permd(1)))
           endif

             amp2=amp2+2d0*zamp*dconjg(zamp)
       enddo

       A4g0H=amp2

*      write(*,*)"A4g0H",A4g0H
      return
      end
************************************************************************
*XC five gluon one higgs zero quark tree level matrix elements
*XC summed over colour orderings, summed and squared
*
      function FullA5g0H(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

*XC (2.1) of hep-th/0411092v2
*XC take (C/2)**2 after squaring
      stop "set value for chgg correctly!"
      fac=(4d0*pi*as*nc)**3*(nc**2-1d0)*2d0*chgg**2/4d0
*XC form (3.38)of hep-ph 1003.2824v2


      FullA5g0H=+A5g0H(i1,i2,i3,i4,i5,i6,i7)
     .          +A5g0H(i1,i2,i3,i5,i4,i6,i7)
     .          +A5g0H(i1,i2,i4,i3,i5,i6,i7)
     .          +A5g0H(i1,i2,i4,i5,i3,i6,i7)
     .          +A5g0H(i1,i2,i5,i3,i4,i6,i7)
     .          +A5g0H(i1,i2,i5,i4,i3,i6,i7)

     .          +A5g0H(i1,i3,i2,i4,i5,i6,i7)
     .          +A5g0H(i1,i3,i2,i5,i4,i6,i7)
     .          +A5g0H(i1,i4,i2,i3,i5,i6,i7)
     .          +A5g0H(i1,i4,i2,i5,i3,i6,i7)
     .          +A5g0H(i1,i5,i2,i3,i4,i6,i7)
     .          +A5g0H(i1,i5,i2,i4,i3,i6,i7)

*      FullA5g0H=fac*FullA5g0H
      return
      end
************************************************************************
* five gluon one higgs zero quark tree level matrix elements
* summed over colour orderings, summed and squared
*
      function A5g0HX(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)


      A5g0HX=+A5g0H(i1,i2,i3,i4,i5,i6,i7)
     .       +A5g0H(i1,i2,i5,i4,i3,i6,i7)

      A5g0HX=A5g0HX

*      write(*,*)"A5g0HX",A5g0HX

      return
      end
************************************************************************
* five gluon one higgs zero quark tree level matrix elements
* summed over colour orderings, summed and squared
*
      function A5g0HYall(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

      A5g0HYall=+A5g0H(i1,i3,i2,i4,i5,i6,i7)
     .          +A5g0H(i1,i3,i2,i5,i4,i6,i7)
     .          +A5g0H(i1,i4,i2,i3,i5,i6,i7)
     .          +A5g0H(i1,i4,i2,i5,i3,i6,i7)
     .          +A5g0H(i1,i5,i2,i3,i4,i6,i7)
     .          +A5g0H(i1,i5,i2,i4,i3,i6,i7)

      A5g0HYall=A5g0HYall

*      write(*,*)"A5g0HYall",A5g0HYall

      return
      end
************************************************************************
*XC four gluon one higgs zero quark tree level matrix elements
*XC one colour ordering, summed and squared  with both phi and cphi field
*
      function A5g0H(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer NHEL(5,16),PERM(7)

      DATA (NHEL(IHEL,   1),IHEL=1, 5) / -1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,   2),IHEL=1, 5) /  1,-1,-1,-1,-1/
      DATA (NHEL(IHEL,   3),IHEL=1, 5) / -1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,   4),IHEL=1, 5) / -1,-1, 1,-1,-1/
      DATA (NHEL(IHEL,   5),IHEL=1, 5) / -1,-1,-1, 1,-1/
      DATA (NHEL(IHEL,   6),IHEL=1, 5) / -1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1, 5) /  1, 1,-1,-1,-1/
      DATA (NHEL(IHEL,   8),IHEL=1, 5) / -1, 1, 1,-1,-1/
      DATA (NHEL(IHEL,   9),IHEL=1, 5) / -1,-1, 1, 1,-1/
      DATA (NHEL(IHEL,  10),IHEL=1, 5) / -1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,  11),IHEL=1, 5) /  1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,  12),IHEL=1, 5) / 1, -1, 1,-1,-1/
      DATA (NHEL(IHEL,  13),IHEL=1, 5) /-1,  1,-1, 1,-1/
      DATA (NHEL(IHEL,  14),IHEL=1, 5) /-1, -1, 1,-1, 1/
      DATA (NHEL(IHEL,  15),IHEL=1, 5) / 1, -1,-1, 1,-1/
      DATA (NHEL(IHEL,  16),IHEL=1, 5) /-1,  1,-1,-1, 1/

        perm(1)=i1
        perm(2)=i2
        perm(3)=i3
        perm(4)=i4
        perm(5)=i5
        perm(6)=i6
        perm(7)=i7

         amp2=0d0
       do i=1,16
         numplus=0

           do j=1,5
           if(NHEL(j,i).eq.1) numplus=numplus+1
           enddo
           if(numplus.eq.0) then
             zamp=zAh5gallminus(PERM(1),NHEL(1,i))
           endif
           if(numplus.eq.1) then
             zamp=zAh5gNNMHV(PERM(1),NHEL(1,i))
           endif
           if(numplus.eq.2) then
             zamp=zAh5gNMHV(PERM(1),NHEL(1,i))
           endif
          amp2=amp2+2d0*zamp*dconjg(zamp)
       enddo
         A5g0H=amp2

*      write(*,*)"A5g0H",A5g0H
      return
      end
*****************************************************************************************
*****************************************************************************************
************************** Library for four gluon tree amplitudes ***********************
*****************************************************************************************
*****************************************************************************************
************************************************************************
      complex*16 function zA4g0Hmmmm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(4),perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      s56=s12+s13+s14+s23+s24+s34

      zA4g0Hmmmm=s56**2/zb12/zb23/zb34/zb41
*      ztemp=zA4g0Hmmmm

*      write(*,*)"zA4g0Hmmmm",zA4g0Hmmmm
*      write(*,*)"perm",perm(1),perm(2),perm(3),perm(4),perm(5)

      return
      end
************************************************************************
      complex*16 function zA4g0HMHV(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(4),perm(5)
      integer m(2), p(2)

      zi=(0d0,1d0)

      j=0
      l=0
      do i=1,4
        if(HEL(i).eq.-1) then
           j=j+1
           m(j)=perm(i)
        endif
        if(HEL(i).eq.1) then
          l=l+1
          p(l)=perm(i)
        endif
      enddo

      zA4g0HMHV=zi*zA5(m(1),m(2))**4
     .  /zA5(perm(1),perm(2))/zA5(perm(2),perm(3))
     .  /zA5(perm(3),perm(4))/zA5(perm(4),perm(1))
     .+ zi*zB5(p(1),p(2))**4
     .  /zB5(perm(1),perm(2))/zB5(perm(2),perm(3))
     .  /zB5(perm(3),perm(4))/zB5(perm(4),perm(1))

*      write(*,*)"zA4g0HMHV",zA4g0HMHV

      return
      end
************************************************************************
*
      complex*16 function zA4g0HNMHV(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      integer hel(4),perm(6)
      integer permaux(6), helaux(4)
      integer permgood(6),helgood(4)
      integer aux1,aux2,aux3(4),aux4(4)

      do i=1,4
        HELaux(i)=HEL(i)
      enddo
      do i=1,6
         PERMaux(i)=PERM(i)
      enddo

*XC perform cyclic permutations of the helicity configuration
*XC untill it finds the right configuration: +---
      do i=1,4
         if( HELaux(1) .eq. 1 )then
           do k=1,4
             HELgood(k)=HELaux(k)
           enddo
           do l=1,6
             PERMgood(l)=PERMaux(l)
           enddo
         endif

*XC do the cyclic permutation
         aux1=HELaux(1)
         aux2=PERMaux(1)
         do k=1,3
           HELaux(k)=HELaux(k+1)
           PERMaux(k)=PERMaux(k+1)
         enddo
         HELaux(4)=aux1
         PERMaux(4)=aux2
      enddo

      zA4g0HNMHV=zA4g0Hpmmm(PERMgood)

      zi=(0d0,1d0)
      zA4g0HNMHV=zi*zA4g0HNMHV

*      write(*,*)"zA4g0HNMHV",zA4g0HNMHV
      return
      end
************************************************************************
*
      complex*16 function zA4g0Hpmmm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      t123=s12+s13+s23
      t234=s23+s24+s34
      t124=s12+s14+s24
      t134=s13+s14+s34

      s56=s12+s13+s14+s23+s24+s34

      zA4g0Hpmmm=-s56**2*za24**4/t124/za12/za14/(za21*zb13+za24*zb43)
     ./(za41*zb13+za42*zb23)
     .+(za42*zb21+za43*zb31)**3/t123/(za41*zb13+za42*zb23)/zb12/zb23
     .-(za23*zb31+za24*zb41)**3/t134/zb14/zb34/(za21*zb13+za24*zb43)

*      write(*,*)"zA4g0Hpmmm",zA4g0Hpmmm
      return
      end
************************************************************************
*
      complex*16 function zA4g0Hmmpp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),perma(6),permb(6),j1,j2,j3,j4,j5,j6

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)

      perma(1)=j1
      perma(2)=j2
      perma(3)=j3
      perma(4)=j4
      perma(5)=j5
      perma(6)=j6

      permb(1)=j3
      permb(2)=j4
      permb(3)=j1
      permb(4)=j2
      permb(5)=j5
      permb(6)=j6

      zA4g0Hmmpp=zAphi4g0mmpp(PERMa(1))+conjg(zAphi4g0mmpp(PERMb(1)))
      return
      end
************************************************************************
*
      complex*16 function zAphi4g0mmpp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

      zi=(0d0,1d0)

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)

      ipset = nspec+4

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      zAphi4g0mmpp=za12**4
     .  /za12/za23
     .  /za34/za41

      return
      end
************************************************************************
*
      complex*16 function zA4g0Hmpmp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),perma(6),permb(6)
      zi=(0d0,1d0)

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)

      perma(1)=j1
      perma(2)=j2
      perma(3)=j3
      perma(4)=j4
      perma(5)=j5
      perma(6)=j6

      permb(1)=j2
      permb(2)=j3
      permb(3)=j4
      permb(4)=j1
      permb(5)=j5
      permb(6)=j6

      zA4g0Hmpmp=zAphi4g0mpmp(PERMa(1))+conjg(zAphi4g0mpmp(PERMb(1)))

      return
      end
************************************************************************
*
      complex*16 function zAphi4g0mpmp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

      zi=(0d0,1d0)

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)

      ipset = nspec+4

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      zAphi4g0mpmp=za13**4
     .  /za12/za23
     .  /za34/za41

      return
      end
*****************************************************************************************
*****************************************************************************************
*************************** Library for 5 gluon tree amplitudes *************************
*****************************************************************************************
*****************************************************************************************
************************************************************************
*
      complex*16 function zAh5gallminus(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(5),perm(7),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s15,s23,s24,s25,s34,s35,s45
      real*8, pointer :: s21,s31,s41,s51,s32,s42,s52,s43,s53,s54
      complex*16, pointer :: za12,za13,za14,za15,za23,za24,za25,za34,za35,za45
      complex*16, pointer :: za21,za31,za41,za51,za32,za42,za52,za43,za53,za54
      complex*16, pointer :: zb12,zb13,zb14,zb15,zb23,zb24,zb25,zb34,zb35,zb45
      complex*16, pointer :: zb21,zb31,zb41,zb51,zb32,zb42,zb52,zb43,zb53,zb54

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)
      j7=perm(7)

      ipset = nspec+5

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s15 => kin(ipset)%s(j1,j5)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s25 => kin(ipset)%s(j2,j5)
      s34 => kin(ipset)%s(j3,j4)
      s35 => kin(ipset)%s(j3,j5)
      s45 => kin(ipset)%s(j4,j5)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s51 => kin(ipset)%s(j5,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s52 => kin(ipset)%s(j5,j2)
      s43 => kin(ipset)%s(j4,j3)
      s53 => kin(ipset)%s(j5,j3)
      s54 => kin(ipset)%s(j5,j4)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za15 => kin(ipset)%zA(j1,j5)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za25 => kin(ipset)%zA(j2,j5)
      za34 => kin(ipset)%zA(j3,j4)
      za35 => kin(ipset)%zA(j3,j5)
      za45 => kin(ipset)%zA(j4,j5)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za51 => kin(ipset)%zA(j5,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za52 => kin(ipset)%zA(j5,j2)
      za43 => kin(ipset)%zA(j4,j3)
      za53 => kin(ipset)%zA(j5,j3)
      za54 => kin(ipset)%zA(j5,j4)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb15 => kin(ipset)%zB(j1,j5)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb25 => kin(ipset)%zB(j2,j5)
      zb34 => kin(ipset)%zB(j3,j4)
      zb35 => kin(ipset)%zB(j3,j5)
      zb45 => kin(ipset)%zB(j4,j5)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb51 => kin(ipset)%zB(j5,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb52 => kin(ipset)%zB(j5,j2)
      zb43 => kin(ipset)%zB(j4,j3)
      zb53 => kin(ipset)%zB(j5,j3)
      zb54 => kin(ipset)%zB(j5,j4)

      s67=s12+s13+s14+s15+s23+s24+s25+s34+s35+s45

      zAh5gallminus=-s67**2
     . /zb12/zb23
     . /zb34/zb45/zb51

      return
      end
************************************************************************
*
      complex*16 function zAh5gNNMHV(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(5),perm(7)
      integer permaux(7), helaux(5)
      integer permgood(7),helgood(5)
      integer aux1,aux2,aux3(5),aux4(5)

      do i=1,5
        HELaux(i)=HEL(i)
      enddo

      do i=1,7
         PERMaux(i)=PERM(i)
      enddo

*XC perform cyclic permutations of the helicity configuration
*XC untill it finds the right configuration: +----
      do i=1,5
         if( HELaux(1) .eq. 1 ) then
           do k=1,5
             HELgood(k)=HELaux(k)
           enddo
           do l=1,7
             PERMgood(l)=PERMaux(l)
           enddo
         endif

*XC do the cyclic permutation
         aux1=HELaux(1)
         aux2=PERMaux(1)
         do k=1,4
           HELaux(k)=HELaux(k+1)
           PERMaux(k)=PERMaux(k+1)
         enddo
         HELaux(5)=aux1
         PERMaux(5)=aux2
      enddo

      zAh5gNNMHV=zAh5gpmmmmh(PERMgood)

      return
      end
************************************************************************
*
      complex*16 function zAh5gpmmmmh(perm)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(7),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s15,s23,s24,s25,s34,s35,s45
      real*8, pointer :: s21,s31,s41,s51,s32,s42,s52,s43,s53,s54
      complex*16, pointer :: za12,za13,za14,za15,za23,za24,za25,za34,za35,za45
      complex*16, pointer :: za21,za31,za41,za51,za32,za42,za52,za43,za53,za54
      complex*16, pointer :: zb12,zb13,zb14,zb15,zb23,zb24,zb25,zb34,zb35,zb45
      complex*16, pointer :: zb21,zb31,zb41,zb51,zb32,zb42,zb52,zb43,zb53,zb54

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)
          j7=perm(7)

      ipset = nspec+5

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s15 => kin(ipset)%s(j1,j5)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s25 => kin(ipset)%s(j2,j5)
      s34 => kin(ipset)%s(j3,j4)
      s35 => kin(ipset)%s(j3,j5)
      s45 => kin(ipset)%s(j4,j5)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s51 => kin(ipset)%s(j5,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s52 => kin(ipset)%s(j5,j2)
      s43 => kin(ipset)%s(j4,j3)
      s53 => kin(ipset)%s(j5,j3)
      s54 => kin(ipset)%s(j5,j4)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za15 => kin(ipset)%zA(j1,j5)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za25 => kin(ipset)%zA(j2,j5)
      za34 => kin(ipset)%zA(j3,j4)
      za35 => kin(ipset)%zA(j3,j5)
      za45 => kin(ipset)%zA(j4,j5)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za51 => kin(ipset)%zA(j5,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za52 => kin(ipset)%zA(j5,j2)
      za43 => kin(ipset)%zA(j4,j3)
      za53 => kin(ipset)%zA(j5,j3)
      za54 => kin(ipset)%zA(j5,j4)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb15 => kin(ipset)%zB(j1,j5)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb25 => kin(ipset)%zB(j2,j5)
      zb34 => kin(ipset)%zB(j3,j4)
      zb35 => kin(ipset)%zB(j3,j5)
      zb45 => kin(ipset)%zB(j4,j5)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb51 => kin(ipset)%zB(j5,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb52 => kin(ipset)%zB(j5,j2)
      zb43 => kin(ipset)%zB(j4,j3)
      zb53 => kin(ipset)%zB(j5,j3)
      zb54 => kin(ipset)%zB(j5,j4)

      t123=s12+s13+s23
      t145=s14+s45+s15
      t125=s12+s25+s15
      t234=s23+s34+s24
      t1235=s12+s13+s15+s23+s25+s35
      t1234=s12+s13+s14+s23+s24+s34
      t1245=s12+s14+s15+s24+s25+s45
      t1345=s13+s14+s15+s34+s35+s45

      s67=s12+s13+s14+s15+s23+s24+s25+s34+s35+s45

      zAh5gpmmmmh=s67**2*za23*(za52*zb21+za53*zb31)**4
     ./zb12/s23/t123/t1235/(za51*zb14+za52*zb24+za53*zb34)
     ./(za51*zb13+za52*zb23)/(t123*zb41+zb45*za52*zb21+zb45*za53*zb31)
*A
     .+s67**2*za25**4/zb34/za21/za51/t125/(za21*zb14+za25*zb54)
     ./(za51*zb13+za52*zb23)
*B
     .-(za52*zb21+za53*zb31+za54*zb41)**3/t1234/zb12/zb23/zb34
     ./(za51*zb14+za52*zb24+za53*zb34)
*C
     .-s67**2*za45*(za24*zb41+za25*zb51)**4/s45/t145/t1245/zb15
     ./(za21*zb13+za24*zb43+za25*zb53)/(za21*zb14+za25*zb54)
     ./(zb13*t145+zb23*(zb14*za42+zb15*za52))
*D(1)
     .-za45*(zb14*za42*zb21+zb14*za43*zb31+zb15*za52*zb21+zb15*za53*zb31)**3
     ./s45/zb12/zb23/zb15/(zb13*t145+zb23*(zb14*za42+zb15*za52))
     ./(t123*zb41+zb45*za52*zb21+zb45*za53*zb31)
*D(2)
     .+za45*(za23*zb31+za24*zb41+za25*zb51)**3/s45/t1345/zb15/zb43
     ./(za21*zb13+za24*zb43+za25*zb53)
*D(3)


      return
      end
************************************************************************
*
      complex*16 function zAh5gNMHV(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(5),perm(7)
      integer permaux(7), helaux(5)
      integer permgood(7),helgood(5)
      integer aux1,aux2,aux3(5),aux4(5)
      zamp3=zAcphi5gMHVbar(PERM,HEL)

      do i=1,5
        HELaux(i)=HEL(i)
      enddo
      do i=1,7
         PERMaux(i)=PERM(i)
      enddo

      j=0
*XC perform cyclic permutations of the helicity configuration
*XC untill it finds the right configuration: ++---;+-+--
      do i=1,5

         if( HELaux(1) .eq. 1 .and. HELaux(2) .eq. 1 ) then
           j=1
           do k=1,5
             HELgood(k)=HELaux(k)
           enddo
           do l=1,7
             PERMgood(l)=PERMaux(l)
           enddo
         endif

         if( HELaux(1) .eq. 1 .and. HELaux(2) .eq. -1 .and. HELaux(3) .eq. 1)then
           j=2
           do k=1,5
             HELgood(k)=HELaux(k)
           enddo
           do l=1,7
             PERMgood(l)=PERMaux(l)
           enddo
         endif

*XC do the cyclic permutation
           aux1=HELaux(1)
           aux2=PERMaux(1)
           do k=1,4
             HELaux(k)=HELaux(k+1)
             PERMaux(k)=PERMaux(k+1)
           enddo
           HELaux(5)=aux1
           PERMaux(5)=aux2
      enddo

      if(j.eq.1) then
        zAh5gNMHV=zAphi5gppmmm(PERMgood)+zamp3
      endif
      if(j.eq.2) then
        zAh5gNMHV=zAphi5gpmpmm(PERMgood)+zamp3
      endif

      return
      end
************************************************************************
*
      complex*16 function zAcphi5gMHVbar(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(5),perm(7)
      integer p(2),ipset
      common /npars/npars,nspec,n
      complex*16, pointer :: za12,za13,za14,za15,za23,za24,za25,za34,za35,za45
      complex*16, pointer :: za21,za31,za41,za51,za32,za42,za52,za43,za53,za54
      complex*16, pointer :: zb12,zb13,zb14,zb15,zb23,zb24,zb25,zb34,zb35,zb45
      complex*16, pointer :: zb21,zb31,zb41,zb51,zb32,zb42,zb52,zb43,zb53,zb54
      complex*16, pointer :: zbpp

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)
          j7=perm(7)

      ipset = nspec+5

      l=0
      do i=1,5
        if(HEL(i).eq.1) then
          l=l+1
          p(l)=perm(i)
        endif
      enddo

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za15 => kin(ipset)%zA(j1,j5)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za25 => kin(ipset)%zA(j2,j5)
      za34 => kin(ipset)%zA(j3,j4)
      za35 => kin(ipset)%zA(j3,j5)
      za45 => kin(ipset)%zA(j4,j5)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za51 => kin(ipset)%zA(j5,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za52 => kin(ipset)%zA(j5,j2)
      za43 => kin(ipset)%zA(j4,j3)
      za53 => kin(ipset)%zA(j5,j3)
      za54 => kin(ipset)%zA(j5,j4)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb15 => kin(ipset)%zB(j1,j5)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb25 => kin(ipset)%zB(j2,j5)
      zb34 => kin(ipset)%zB(j3,j4)
      zb35 => kin(ipset)%zB(j3,j5)
      zb45 => kin(ipset)%zB(j4,j5)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb51 => kin(ipset)%zB(j5,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb52 => kin(ipset)%zB(j5,j2)
      zb43 => kin(ipset)%zB(j4,j3)
      zb53 => kin(ipset)%zB(j5,j3)
      zb54 => kin(ipset)%zB(j5,j4)

      zbpp => kin(ipset)%zB(p(1),p(2))

      zAcphi5gMHVbar=-zbpp**4
     .  /zb12/zb23
     .  /zb34/zb45/zb51

      return
      end
************************************************************************
*
      complex*16 function zAphi5gppmmm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(7),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s15,s23,s24,s25,s34,s35,s45
      real*8, pointer :: s21,s31,s41,s51,s32,s42,s52,s43,s53,s54
      complex*16, pointer :: za12,za13,za14,za15,za23,za24,za25,za34,za35,za45
      complex*16, pointer :: za21,za31,za41,za51,za32,za42,za52,za43,za53,za54
      complex*16, pointer :: zb12,zb13,zb14,zb15,zb23,zb24,zb25,zb34,zb35,zb45
      complex*16, pointer :: zb21,zb31,zb41,zb51,zb32,zb42,zb52,zb43,zb53,zb54

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)
      j7=perm(7)

      ipset = nspec+5

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s15 => kin(ipset)%s(j1,j5)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s25 => kin(ipset)%s(j2,j5)
      s34 => kin(ipset)%s(j3,j4)
      s35 => kin(ipset)%s(j3,j5)
      s45 => kin(ipset)%s(j4,j5)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s51 => kin(ipset)%s(j5,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s52 => kin(ipset)%s(j5,j2)
      s43 => kin(ipset)%s(j4,j3)
      s53 => kin(ipset)%s(j5,j3)
      s54 => kin(ipset)%s(j5,j4)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za15 => kin(ipset)%zA(j1,j5)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za25 => kin(ipset)%zA(j2,j5)
      za34 => kin(ipset)%zA(j3,j4)
      za35 => kin(ipset)%zA(j3,j5)
      za45 => kin(ipset)%zA(j4,j5)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za51 => kin(ipset)%zA(j5,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za52 => kin(ipset)%zA(j5,j2)
      za43 => kin(ipset)%zA(j4,j3)
      za53 => kin(ipset)%zA(j5,j3)
      za54 => kin(ipset)%zA(j5,j4)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb15 => kin(ipset)%zB(j1,j5)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb25 => kin(ipset)%zB(j2,j5)
      zb34 => kin(ipset)%zB(j3,j4)
      zb35 => kin(ipset)%zB(j3,j5)
      zb45 => kin(ipset)%zB(j4,j5)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb51 => kin(ipset)%zB(j5,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb52 => kin(ipset)%zB(j5,j2)
      zb43 => kin(ipset)%zB(j4,j3)
      zb53 => kin(ipset)%zB(j5,j3)
      zb54 => kin(ipset)%zB(j5,j4)

      t123=s12+s13+s23
      t145=s14+s45+s15
      t125=s12+s25+s15
      t234=s23+s34+s24
      t1235=s12+s13+s15+s23+s25+s35
      t1234=s12+s13+s14+s23+s24+s34
      t1245=s12+s14+s15+s24+s25+s45
      t1345=s13+s14+s15+s34+s35+s45

      s67=s12+s13+s14+s15+s23+s24+s25+s34+s35+s45

      zAphi5gppmmm=zb12*za35**4*s67**2/s12/t1235
     ./(za31*zb14+za32*zb24+za35*zb54)/(za51*zb14+za52*zb24+za53*zb34)
     ./za23/za15
*A(1)
     .+zb12*(za51*zb13*za35+za51*zb14*za45+za52*zb23*za35+za52*zb24*za45)**3
     ./s12/zb34/za51/(za51*zb14+za52*zb24+za53*zb34)/(za51*zb13+za52*zb23)
     ./(za25*t234+za15*(za23*zb31+za24*zb41))
*A(2)
     .+zb12*(t125*za53+(za51*zb14+za52*zb24)*za43)**3/s12/t125/t1245/za51
     ./(za31*zb14+za32*zb24+za35*zb54)/(za21*zb14+za25*zb54)
*A(3)
     .-za45**3*zb21**3*za32/s23/t123/(za42*zb21+za43*zb31)/(za51*zb13+za52*zb23)
*B
     .+za45*(za34*zb41+za35*zb51)**3/za23/s45/zb15/(za21*zb14+za25*zb54)/t145
*C
     .-za34**3*(za52*zb21+za53*zb31+za54*zb41)**3/za23/t234/t1234
     ./(za42*zb21+za43*zb31)/(za25*t234+za15*(za23*zb31+za24*zb41))
*D

      return
      end
************************************************************************
*
      complex*16 function zAphi5gpmpmm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(7),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s15,s23,s24,s25,s34,s35,s45
      real*8, pointer :: s21,s31,s41,s51,s32,s42,s52,s43,s53,s54
      complex*16, pointer :: za12,za13,za14,za15,za23,za24,za25,za34,za35,za45
      complex*16, pointer :: za21,za31,za41,za51,za32,za42,za52,za43,za53,za54
      complex*16, pointer :: zb12,zb13,zb14,zb15,zb23,zb24,zb25,zb34,zb35,zb45
      complex*16, pointer :: zb21,zb31,zb41,zb51,zb32,zb42,zb52,zb43,zb53,zb54

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)
      j7=perm(7)

      ipset = nspec+5

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s15 => kin(ipset)%s(j1,j5)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s25 => kin(ipset)%s(j2,j5)
      s34 => kin(ipset)%s(j3,j4)
      s35 => kin(ipset)%s(j3,j5)
      s45 => kin(ipset)%s(j4,j5)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s51 => kin(ipset)%s(j5,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s52 => kin(ipset)%s(j5,j2)
      s43 => kin(ipset)%s(j4,j3)
      s53 => kin(ipset)%s(j5,j3)
      s54 => kin(ipset)%s(j5,j4)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za15 => kin(ipset)%zA(j1,j5)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za25 => kin(ipset)%zA(j2,j5)
      za34 => kin(ipset)%zA(j3,j4)
      za35 => kin(ipset)%zA(j3,j5)
      za45 => kin(ipset)%zA(j4,j5)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za51 => kin(ipset)%zA(j5,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za52 => kin(ipset)%zA(j5,j2)
      za43 => kin(ipset)%zA(j4,j3)
      za53 => kin(ipset)%zA(j5,j3)
      za54 => kin(ipset)%zA(j5,j4)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb15 => kin(ipset)%zB(j1,j5)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb25 => kin(ipset)%zB(j2,j5)
      zb34 => kin(ipset)%zB(j3,j4)
      zb35 => kin(ipset)%zB(j3,j5)
      zb45 => kin(ipset)%zB(j4,j5)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb51 => kin(ipset)%zB(j5,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb52 => kin(ipset)%zB(j5,j2)
      zb43 => kin(ipset)%zB(j4,j3)
      zb53 => kin(ipset)%zB(j5,j3)
      zb54 => kin(ipset)%zB(j5,j4)

      t123=s12+s13+s23
      t145=s14+s45+s15
      t125=s12+s25+s15
      t234=s23+s34+s24
      t345=s34+s45+s35
      t1235=s12+s13+s15+s23+s25+s35
      t1234=s12+s13+s14+s23+s24+s34
      t1245=s12+s14+s15+s24+s25+s45
      t1345=s13+s14+s15+s34+s35+s45

      s67=s12+s13+s14+s15+s23+s24+s25+s34+s35+s45

      zAphi5gpmpmm=s67**2*za24**4*zb12*za25**4/za15/s12/za34/za32
     ./(za25*t234+(za23*zb31+za24*zb41)*za15)/(t125*za42+za43*(za21*zb13+za25*zb53))
     ./(za23*zb31*za12+za23*zb35*za52+za24*zb41*za12+za24*zb45*za52)
*A(1)
     .-zb12*(za21*zb13+za24*zb43+za25*zb53)**3*za25**4/za15/zb34/s12
     ./(za21*zb14+za25*zb54)/(za23*zb31*za12+za23*zb35*za52+za24*zb41*za12+za24*zb45*za52)
     ./(za25*t345-za12*(za53*zb31+za54*zb41))
*A(2)
     .-(za41*zb13+za42*zb23+za45*zb53)**3*za25**4*zb21/s12/t1235/t125/za51
     ./(za51*zb13+za52*zb23)/(t125*za42+za43*(za21*zb13+za25*zb53))
*A(3)
     .+za45**3*(za23*zb31+za24*zb41+za25*zb51)**3/t345/t1345/za34/(za34*zb41+za35*zb51)
     ./(za54*zb41*za12+za53*zb31*za12+t345*za52)
*B
     .+za45**3*za23*zb31**4/s23/t123/zb21/(za42*zb21+za43*zb31)/(za51*zb13+za52*zb23)
*C
     .+za45*(za24*zb41+za25*zb51)**4/s45/t145/za23/zb15/(za34*zb41+za35*zb51)
     ./(za21*zb14+za25*zb54)
*D
     .+za24**4*(za52*zb21+za53*zb31+za54*zb41)**3/t1234/t234/za23/za34
     ./(za42*zb21+za43*zb31)/(za52*t234+za51*(za23*zb31+za24*zb41))
*E

      return
      end
************************************************************************




