*************************************************************************
!XC Tree level ME for Higgs plus up to three gluons with one qqbar pair
!XC up to two gluons with one qqbar pair analytical results checked against hep-th/0412275
!  S.~D.~Badger, E.~W.~N.~Glover and V.~V.~Khoze,
!  %``MHV rules for Higgs plus multi-parton amplitudes,''
!  JHEP {\bf 0503} (2005) 023
!  doi:10.1088/1126-6708/2005/03/023
!  [hep-th/0412275].

!XC for threes gluons with one qqbar pair analytical results calculated using BCFW method: 
!  R.~Britto, F.~Cachazo and B.~Feng,
!  %``Generalized unitarity and one-loop amplitudes in N=4 super-Yang-Mills,''
!  Nucl.\ Phys.\ B {\bf 725} (2005) 275
!  doi:10.1016/j.nuclphysb.2005.07.014
!  [hep-th/0412103].

!  R.~Britto, F.~Cachazo, B.~Feng and E.~Witten,
!  %``Direct proof of tree-level recursion relation in Yang-Mills theory,''
!  Phys.\ Rev.\ Lett.\  {\bf 94} (2005) 181602
!  doi:10.1103/PhysRevLett.94.181602
!  [hep-th/0501052].

!  R.~Britto, F.~Cachazo, B.~Feng and E.~Witten,
!  %``Direct proof of tree-level recursion relation in Yang-Mills theory,''
!  Phys.\ Rev.\ Lett.\  {\bf 94} (2005) 181602
!  doi:10.1103/PhysRevLett.94.181602
!  [hep-th/0501052].

************************************************************************
*XC q qbar to one gluon one Higgs tree level matrix elements
*XC summed over colour orderings, summed and squared
*
      function FullB1g0H(iq1,i3,iqbar2,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

*XC (as/3d0/pi/239d0)**2=as/3d0*pi/246d0 for gluon gluon fusion to higgs effective
*XC coupling constant

      stop "set value for chgg correctly!"
      fac=(4d0*pi*as)*(nc**2-1d0)*chgg**2/4d0
*XC form (3.1) of hep-th/0412275 coefficient squared

      FullB1g0H=B1g0H(iq1,i3,iqbar2,i4,i5)
      FullB1g0H=fac*FullB1g0H

      return
      end
************************************************************************
*XC q qbar one gluon one higgs tree level matrix elements
*XC  one colour ordering, summed and squared
      function B1g0H(iq1,i3,iqbar2,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s23

      j1=iq1
      j3=i3
      j2=iqbar2
      j4=i4
      j5=i5

      ipset = nspec+3
      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s23 => kin(ipset)%s(j2,j3)

      wt=2d0*(s13**2/s12+s23**2/s12)
      if(iq1.eq.1.or.iq1.eq.2)wt=-wt
      if(iqbar2.eq.1.or.iqbar2.eq.2)wt=-wt

      B1g0H=wt
*      write(*,*)"B1g0H=",wt
      return
      end
************************************************************************
*XC one q qbar pair and two gluon one higgs tree level matrix elements
*XC summed over colour leading and subleading pieces
*
      function FullB2g0H(iq1,i3,i4,iqbar2,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

*XC (as/3d0/pi/239d0)**2=as/3d0*pi/246d0 for gluon gluon fusion to higgs effective
*XC coupling constant
      stop "set value for chgg correctly!"
      fac=(4d0*pi*as)**2*nc*(nc**2-1d0)*chgg**2/4d0
*XC form (3.1) of hep-th/0412275 coefficient squared

      FullB2g0H=
     .            +B2g0H(iq1,i3,i4,iqbar2,i5,i6)
     .            +B2g0H(iq1,i4,i3,iqbar2,i5,i6)
     .            -(1d0/nc**2)*Bt2g0H(iq1,i3,i4,iqbar2,i5,i6)
*      FullB2g0H=fac*FullB2g0H

      return
      end
************************************************************************
*XC one q qbar pair and two gluon one higgs tree level matrix elements colour leading
*XC one colour ordering, summed and squared  with both phi and cphi field
*
      function B2g0H(iq1,i3,i4,iqbar2,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer NHEL(4,8),PERM(6)

      DATA (NHEL(IHEL,   1),IHEL=1, 4) / -1, 1, 1, 1/
      DATA (NHEL(IHEL,   2),IHEL=1, 4) / -1,-1, 1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1, 4) / -1, 1,-1, 1/
      DATA (NHEL(IHEL,   4),IHEL=1, 4) / -1,-1,-1, 1/

        perm(1)=iq1
        perm(2)=i3
        perm(3)=i4
        perm(4)=iqbar2
        perm(5)=i5
        perm(6)=i6

        amp2=0d0
        do i=1,8
           zamp=0d0

           if(i.eq.1) then
            zamp=
     .                +zB2g0Hmppp(perm(1))
           endif
           if(i.eq.2) then
            zamp=
     .                +zB2g0Hmmmp(perm(1))
           endif
           if(i.eq.3) then
            zamp=
     .                +zB2g0Hmpmp(perm(1))
           endif
           if(i.eq.4) then
            zamp=
     .                +zB2g0Hmmpp(perm(1))
           endif
           if(i.eq.5) then
            zamp=
     .                +zB2g0Hpmmm(perm(1))
           endif
           if(i.eq.6) then
            zamp=
     .                +zB2g0Hpppm(perm(1))
           endif
           if(i.eq.7) then
            zamp=
     .                +zB2g0Hpmpm(perm(1))
           endif
           if(i.eq.8) then
            zamp=
     .                +zB2g0Hppmm(perm(1))
           endif
          amp2=amp2+zamp*conjg(zamp)
       enddo

        B2g0H=amp2

      return
      end
************************************************************************
*XC one quark pair two gluon one higgs tree level matrix elements color subleading
*XC here is two-photon-like terms from |A+B|**2
*
      function Bt2g0H(iq1,i3,i4,iqbar2,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /koppel/ nf,nc,b0
      integer NHEL(4,8),PERMA(6),PERMB(6)
      integer ii
      DATA (NHEL(IHEL,   1),IHEL=1, 4) / -1, 1, 1, 1/
      DATA (NHEL(IHEL,   2),IHEL=1, 4) / -1,-1, 1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1, 4) / -1, 1,-1, 1/
      DATA (NHEL(IHEL,   4),IHEL=1, 4) / -1,-1,-1, 1/

        perma(1)=iq1
        perma(2)=i3
        perma(3)=i4
        perma(4)=iqbar2
        perma(5)=i5
        perma(6)=i6

        permb(1)=iq1
        permb(2)=i4
        permb(3)=i3
        permb(4)=iqbar2
        permb(5)=i5
        permb(6)=i6

        amp2=0d0
        do i=1,4
          numplus=0
           do j=1,4
             if(NHEL(j,i).eq.1) numplus=numplus+1
           enddo
           zamp=0d0
           if(numplus.eq.3) then
            zamp=zB2g0Hmppp(PERMA(1))+zB2g0Hmppp(PERMB(1))
           endif
           if(numplus.eq.1) then
            zamp=zB2g0Hmmmp(PERMA(1))+zB2g0Hmmmp(PERMB(1))
           endif
           if(numplus.eq.2) then
               ii=0
               if(i.eq.2) then
                 ii = 3
               end if
               if(i.eq.3) then
                 ii = 2
               end if
            zamp=zB2g0HMHV(PERMA(1),NHEL(1,i))+zB2g0HMHV(PERMB(1),NHEL(1,ii))
           endif

          amp2=amp2+2d0*zamp*dconjg(zamp)
        enddo
        Bt2g0H=amp2
      return
      end
************************************************************************
* one q qbar pair and three gluon one higgs tree level matrix elements
* summed over colour orderings, summed and squared
*
      function FullB3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

*XC C=(as/6d0/pi/239d0) and C/2 for gluon gluon fusion to higgs effective
*XC coupling constant

*XC (2.1) of hep-th/0411092v2
*XC use the value form MG5 that C=5.235154617065361E-005 and we need to
*XC take (C/2)**2 after squaring
      stop "set value for chgg correctly!"
      fac=(4d0*pi*as)**3*(nc**2-1d0)*nc**2*chgg**2/4d0
*XC form (3.1) of hep-th/0412275 coefficient squared

      FullB3g0H=
     .            +B3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)
     .            +B3g0H(iq1,i3,i5,i4,iqbar2,i6,i7)
     .            +B3g0H(iq1,i4,i3,i5,iqbar2,i6,i7)
     .            +B3g0H(iq1,i4,i5,i3,iqbar2,i6,i7)
     .            +B3g0H(iq1,i5,i3,i4,iqbar2,i6,i7)
     .            +B3g0H(iq1,i5,i4,i3,iqbar2,i6,i7)
*XC color leading
     .            -Bt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)/nc**2
     .            -Bt3g0H(iq1,i3,i5,i4,iqbar2,i6,i7)/nc**2
     .            -Bt3g0H(iq1,i4,i3,i5,iqbar2,i6,i7)/nc**2
     .            -Bt3g0H(iq1,i4,i5,i3,iqbar2,i6,i7)/nc**2
     .            -Bt3g0H(iq1,i5,i3,i4,iqbar2,i6,i7)/nc**2
     .            -Bt3g0H(iq1,i5,i4,i3,iqbar2,i6,i7)/nc**2
*XC color sub-leading (1-photon like: the last gluon is the photon like)
     .            +Btt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*(1d0/nc**2+1d0/nc**4)
*XC least color ordering term (3-photon like)

*      FullB3g0H=fac*FullB3g0H

*      wwwt = FullB3g0H

*      write(*,*)"FullB3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)=",wwwt

      return
      end

************************************************************************
* one q qbar pair and three gluon one higgs tree level matrix elements
* summed over colour orderings, summed and squared, for colour leading X topology
*
      function B3g0HX(iq1,i3,i4,i5,iqbar2,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

      B3g0HX=+B3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)
     .       +B3g0H(iq1,i5,i4,i3,iqbar2,i6,i7)

      B3g0HX=B3g0HX

*      write(*,*)"B3g0HX",B3g0HX

      return
      end

************************************************************************
* one q qbar pair and three gluon one higgs tree level matrix elements
* summed over colour orderings, summed and squared, for colour leading X topology
*
      function qgB3g0HF(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

      qgB3g0HF=+B3g0H(i1,i2,i3,i4,i5,i6,i7)
     .         +B3g0H(i1,i2,i4,i3,i5,i6,i7)
     .         +B3g0H(i1,i3,i2,i4,i5,i6,i7)
     .         +B3g0H(i1,i3,i4,i2,i5,i6,i7)
     .         +B3g0H(i1,i4,i2,i3,i5,i6,i7)
     .         +B3g0H(i1,i4,i3,i2,i5,i6,i7)

*      write(*,*) " TARGET "
*      write(*,100) i1,i2,B3g0H(i1,i2,i3,i4,i5,i6,i7)/1d20
*      write(*,100) i1,i2,B3g0H(i1,i4,i3,i2,i5,i6,i7)/1d20
*      write(*,*) " ------------------------------------- "
* 100  format(2x,i5,i5,f20.15)
      qgB3g0HF=qgB3g0HF
*      write(*,*)"qgB3g0HF",qgB3g0HF,wtmax

      return
      end
************************************************************************
* one q qbar pair and three gluon one higgs tree level matrix elements
* summed over colour orderings, summed and squared, for colour leading X topology
*
      function qgB3g0HX(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

      qgB3g0HX=+B3g0H(i1,i2,i3,i4,i5,i6,i7)
     .         +B3g0H(i1,i4,i3,i2,i5,i6,i7)

*      write(*,*) " TARGET "
*      write(*,100) i1,i2,B3g0H(i1,i2,i3,i4,i5,i6,i7)/1d20
*      write(*,100) i1,i2,B3g0H(i1,i4,i3,i2,i5,i6,i7)/1d20
*      write(*,*) " ------------------------------------- "
* 100  format(2x,i5,i5,f20.15)
      qgB3g0HX=qgB3g0HX
*      write(*,*)"qgB3g0HX",qgB3g0HX

      return
      end
************************************************************************
* one q qbar pair and three gluon one higgs tree level matrix elements
* summed over colour orderings, summed and squared, for colour leading X topology
*
      function qgB3g0HY(i1,i3,i2,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

      qgB3g0HY=+B3g0H(i1,i3,i2,i4,i5,i6,i7)
     .         +B3g0H(i1,i4,i2,i3,i5,i6,i7)
*      write(*,*) " TARGET "
*      write(*,100) i1,i2,B3g0H(i1,i3,i2,i4,i5,i6,i7)/1d20
*      write(*,100) i1,i2,B3g0H(i1,i4,i2,i3,i5,i6,i7)/1d20
*      write(*,*) " ------------------------------------- "
* 100  format(2x,i5,i5,f20.15)
      qgB3g0HY=qgB3g0HY

*      write(*,*)"qgB3g0HY",qgB3g0HY

      return
      end
************************************************************************
* one q qbar pair and three gluon one higgs tree level matrix elements
* summed over colour orderings, summed and squared, for colour leading X topology
*
      function FullqgB3g0H(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

      FullqgB3g0H=+qgB3g0HX(i1,i2,i3,i4,i5,i6,i7)
     .            +qgB3g0HX(i1,i2,i4,i3,i5,i6,i7)
     .            +qgB3g0HY(i1,i3,i2,i4,i5,i6,i7)

      FullqgB3g0H=FullqgB3g0H

*      write(*,*)"FullqgB3g0H",FullqgB3g0H

      return
      end

************************************************************************
* one q qbar pair and three gluon one higgs tree level matrix elements
* summed over colour orderings, summed and squared
*
      function Bt3g0HX(iq1,i3,i4,i5,iqbar2,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

      Bt3g0HX=
     .          +Bt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)
     .          +Bt3g0H(iq1,i3,i5,i4,iqbar2,i6,i7)
     .          +Bt3g0H(iq1,i4,i3,i5,iqbar2,i6,i7)
     .          +Bt3g0H(iq1,i4,i5,i3,iqbar2,i6,i7)
     .          +Bt3g0H(iq1,i5,i3,i4,iqbar2,i6,i7)
     .          +Bt3g0H(iq1,i5,i4,i3,iqbar2,i6,i7)

      Bt3g0HX=Bt3g0HX

*      write(*,*)"Bt3g0HX(iq1,i3,i4,i5,iqbar2,i6,i7)=",wwwt

      return
      end

************************************************************************
*XC one q qbar pair three gluon one higgs tree level matrix elements
*XC colour leading part for all ordering, summed and squared  with both phi and cphi field
*
      function B3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer NHEL(5,16),PERMa(7),PERMb(7)

      DATA (NHEL(IHEL,   1),IHEL=1, 5) / -1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,   2),IHEL=1, 5) / -1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1, 5) / -1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,   4),IHEL=1, 5) / -1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,   5),IHEL=1, 5) / -1,-1, 1, 1, 1/
      DATA (NHEL(IHEL,   6),IHEL=1, 5) / -1, 1,-1, 1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1, 5) / -1, 1, 1,-1, 1/
      DATA (NHEL(IHEL,   8),IHEL=1, 5) / -1, 1, 1, 1, 1/

        perma(1)=iq1
        perma(2)=i3
        perma(3)=i4
        perma(4)=i5
        perma(5)=iqbar2
        perma(6)=i6
        perma(7)=i7

        permb(1)=iqbar2
        permb(2)=i5
        permb(3)=i4
        permb(4)=i3
        permb(5)=iq1
        permb(6)=i6
        permb(7)=i7

         amp2=0d0
       do i=1,8
           if(i.eq.1) then
            zamp=zB3g0Hmmmmp(PERMa(1),NHEL(1,i))
           endif
           if(i.eq.2) then
            zamp=zB3g0Hmpmmp(PERMa(1),NHEL(1,i))
           endif
           if(i.eq.3) then
            zamp=zB3g0Hmmpmp(PERMa(1),NHEL(1,i))
           endif
           if(i.eq.4) then
            zamp=zB3g0Hmmmpp(PERMa(1),NHEL(1,i))
           endif
           if(i.eq.5) then
            zamp=zB3g0Hmmmpp(PERMb(1),NHEL(1,i))
           endif
           if(i.eq.6) then
            zamp=zB3g0Hmmpmp(PERMb(1),NHEL(1,i))
           endif
           if(i.eq.7) then
            zamp=zB3g0Hmpmmp(PERMb(1),NHEL(1,i))
           endif
           if(i.eq.8) then
            zamp=zB3g0Hmmmmp(PERMb(1),NHEL(1,i))
           endif
          amp2=amp2+2d0*zamp*dconjg(zamp)
       enddo

         B3g0H=amp2
*      write(*,*)" B3g0H ",B3g0H
      return
      end
************************************************************************
*XC q qbar three gluon one higgs tree level matrix elements
*XC  color sub-leading part is 1-photon like terms
*
      function Bt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer NHEL(5,16),PERMa1(7),PERMa2(7),PERMa3(7),PERMb1(7),PERMb2(7),PERMb3(7)

      DATA (NHEL(IHEL,   1),IHEL=1, 5) / -1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,   2),IHEL=1, 5) / -1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1, 5) / -1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,   4),IHEL=1, 5) / -1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,   5),IHEL=1, 5) /-1, -1, 1, 1, 1/
      DATA (NHEL(IHEL,   6),IHEL=1, 5) /-1,  1,-1, 1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1, 5) /-1,  1, 1,-1, 1/
      DATA (NHEL(IHEL,   8),IHEL=1, 5) / -1, 1, 1, 1, 1/

        perma1(1)=iq1
        perma1(2)=i3
        perma1(3)=i4
        perma1(4)=i5
        perma1(5)=iqbar2
        perma1(6)=i6
        perma1(7)=i7

        perma2(1)=iq1
        perma2(2)=i4
        perma2(3)=i3
        perma2(4)=i5
        perma2(5)=iqbar2
        perma2(6)=i6
        perma2(7)=i7

        perma3(1)=iq1
        perma3(2)=i4
        perma3(3)=i5
        perma3(4)=i3
        perma3(5)=iqbar2
        perma3(6)=i6
        perma3(7)=i7

        permb1(1)=iqbar2
        permb1(2)=i5
        permb1(3)=i4
        permb1(4)=i3
        permb1(5)=iq1
        permb1(6)=i6
        permb1(7)=i7

        permb2(1)=iqbar2
        permb2(2)=i5
        permb2(3)=i3
        permb2(4)=i4
        permb2(5)=iq1
        permb2(6)=i6
        permb2(7)=i7

        permb3(1)=iqbar2
        permb3(2)=i3
        permb3(3)=i5
        permb3(4)=i4
        permb3(5)=iq1
        permb3(6)=i6
        permb3(7)=i7

         amp2=0d0
       do i=1,8
           if(i.eq.1) then
            zamp=zB3g0Hmmmmp(PERMa1(1),NHEL(1,i))+zB3g0Hmmmmp(PERMa2(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMa3(1),NHEL(1,i))
           endif
           if(i.eq.2) then
            zamp=zB3g0Hmpmmp(PERMa1(1),NHEL(1,i))+zB3g0Hmmpmp(PERMa2(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMa3(1),NHEL(1,i))
           endif
           if(i.eq.3) then
            zamp=zB3g0Hmmpmp(PERMa1(1),NHEL(1,i))+zB3g0Hmpmmp(PERMa2(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMa3(1),NHEL(1,i))
           endif
           if(i.eq.4) then
            zamp=zB3g0Hmmmpp(PERMa1(1),NHEL(1,i))+zB3g0Hmmmpp(PERMa2(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMa3(1),NHEL(1,i))
           endif
           if(i.eq.5) then
            zamp=zB3g0Hmmmpp(PERMb1(1),NHEL(1,i))+zB3g0Hmmpmp(PERMb2(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMb3(1),NHEL(1,i))
           endif
           if(i.eq.6) then
            zamp=zB3g0Hmmpmp(PERMb1(1),NHEL(1,i))+zB3g0Hmmmpp(PERMb2(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMb3(1),NHEL(1,i))
           endif
           if(i.eq.7) then
            zamp=zB3g0Hmpmmp(PERMb1(1),NHEL(1,i))+zB3g0Hmpmmp(PERMb2(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMb3(1),NHEL(1,i))
           endif
           if(i.eq.8) then
            zamp=zB3g0Hmmmmp(PERMb1(1),NHEL(1,i))+zB3g0Hmmmmp(PERMb2(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMb3(1),NHEL(1,i))
           endif

          amp2=amp2+2d0*zamp*dconjg(zamp)
       enddo
         Bt3g0H=amp2
   10 format(" Ahq3gq0   ",e12.4,6i3)
      return
      end
************************************************************************
*XC q qbar three gluon one higgs tree level matrix elements
*XC least colour ordering is three photon like terms
*XC summed and squared with both phi and cphi field
*
      function Btt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer NHEL(5,16),PERMa1(7),PERMa2(7),PERMa3(7),PERMb1(7),PERMb2(7),PERMb3(7)
      integer PERMa4(7),PERMa5(7),PERMa6(7),PERMb4(7),PERMb5(7),PERMb6(7)

      DATA (NHEL(IHEL,   1),IHEL=1, 5) / -1,-1,-1,-1, 1/
      DATA (NHEL(IHEL,   2),IHEL=1, 5) / -1, 1,-1,-1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1, 5) / -1,-1, 1,-1, 1/
      DATA (NHEL(IHEL,   4),IHEL=1, 5) / -1,-1,-1, 1, 1/
      DATA (NHEL(IHEL,   5),IHEL=1, 5) /-1, -1, 1, 1, 1/
      DATA (NHEL(IHEL,   6),IHEL=1, 5) /-1,  1,-1, 1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1, 5) /-1,  1, 1,-1, 1/
      DATA (NHEL(IHEL,   8),IHEL=1, 5) / -1, 1, 1, 1, 1/


        perma1(1)=iq1
        perma1(2)=i3
        perma1(3)=i4
        perma1(4)=i5
        perma1(5)=iqbar2
        perma1(6)=i6
        perma1(7)=i7

        permb1(1)=iqbar2
        permb1(2)=i5
        permb1(3)=i4
        permb1(4)=i3
        permb1(5)=iq1
        permb1(6)=i6
        permb1(7)=i7

        perma2(1)=iq1
        perma2(2)=i3
        perma2(3)=i5
        perma2(4)=i4
        perma2(5)=iqbar2
        perma2(6)=i6
        perma2(7)=i7

        permb2(1)=iqbar2
        permb2(2)=i4
        permb2(3)=i5
        permb2(4)=i3
        permb2(5)=iq1
        permb2(6)=i6
        permb2(7)=i7

        perma3(1)=iq1
        perma3(2)=i4
        perma3(3)=i3
        perma3(4)=i5
        perma3(5)=iqbar2
        perma3(6)=i6
        perma3(7)=i7

        permb3(1)=iqbar2
        permb3(2)=i5
        permb3(3)=i3
        permb3(4)=i4
        permb3(5)=iq1
        permb3(6)=i6
        permb3(7)=i7

        perma4(1)=iq1
        perma4(2)=i4
        perma4(3)=i5
        perma4(4)=i3
        perma4(5)=iqbar2
        perma4(6)=i6
        perma4(7)=i7

        permb4(1)=iqbar2
        permb4(2)=i3
        permb4(3)=i5
        permb4(4)=i4
        permb4(5)=iq1
        permb4(6)=i6
        permb4(7)=i7

        perma5(1)=iq1
        perma5(2)=i5
        perma5(3)=i3
        perma5(4)=i4
        perma5(5)=iqbar2
        perma5(6)=i6
        perma5(7)=i7

        permb5(1)=iqbar2
        permb5(2)=i4
        permb5(3)=i3
        permb5(4)=i5
        permb5(5)=iq1
        permb5(6)=i6
        permb5(7)=i7

        perma6(1)=iq1
        perma6(2)=i5
        perma6(3)=i4
        perma6(4)=i3
        perma6(5)=iqbar2
        perma6(6)=i6
        perma6(7)=i7

        permb6(1)=iqbar2
        permb6(2)=i3
        permb6(3)=i4
        permb6(4)=i5
        permb6(5)=iq1
        permb6(6)=i6
        permb6(7)=i7

         amp2=0d0
       do i=1,8
           if(i.eq.1) then
            zamp=zB3g0Hmmmmp(PERMa1(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMa2(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMa3(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMa4(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMa5(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMa6(1),NHEL(1,i))
           endif
           if(i.eq.2) then
            zamp=zB3g0Hmpmmp(PERMa1(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMa2(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMa3(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMa4(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMa5(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMa6(1),NHEL(1,i))
           endif
           if(i.eq.3) then
            zamp=zB3g0Hmmpmp(PERMa1(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMa2(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMa3(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMa4(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMa5(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMa6(1),NHEL(1,i))
           endif
           if(i.eq.4) then
            zamp=zB3g0Hmmmpp(PERMa1(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMa2(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMa3(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMa4(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMa5(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMa6(1),NHEL(1,i))
           endif
           if(i.eq.5) then
            zamp=zB3g0Hmmmpp(PERMb1(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMb2(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMb3(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMb4(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMb5(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMb6(1),NHEL(1,i))
           endif
           if(i.eq.6) then
            zamp=zB3g0Hmmpmp(PERMb1(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMb2(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMb3(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMb4(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMb5(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMb6(1),NHEL(1,i))
           endif
           if(i.eq.7) then
            zamp=zB3g0Hmpmmp(PERMb1(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMb2(1),NHEL(1,i))
     .          +zB3g0Hmpmmp(PERMb3(1),NHEL(1,i))
     .          +zB3g0Hmmpmp(PERMb4(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMb5(1),NHEL(1,i))
     .          +zB3g0Hmmmpp(PERMb6(1),NHEL(1,i))
           endif
           if(i.eq.8) then
            zamp=zB3g0Hmmmmp(PERMb1(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMb2(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMb3(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMb4(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMb5(1),NHEL(1,i))
     .          +zB3g0Hmmmmp(PERMb6(1),NHEL(1,i))
           endif
          amp2=amp2+2d0*zamp*dconjg(zamp)
       enddo
         Btt3g0H=amp2

   10 format(" Ahq3gq03p   ",e12.4,6i3)
      return
      end
*****************************************************************************************
*****************************************************************************************
************ Library for 2 quarks 2 gluons one Higgs tree amplitudes ********************
*****************************************************************************************
*****************************************************************************************
************************************************************************
      complex*16 function zB2g0Hmppp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      t123=s12+s13+s23
      t234=s23+s34+s24
      t134=s13+s34+s14
      t124=s12+s24+s14

      s56=s12+s13+s14+s23+s24+s34

      zB2g0Hmppp=-zb42**3*s56**2/t124/zb41/(za31*zb12+za34*zb42)/
     .            (za31*zb14+za32*zb24)
     .           -(za12*zb24+za13*zb34)**2/(za31*zb14+za32*zb24)/
     .            za21/za32
     .           -(za13*zb32+za14*zb42)**2*(za41*zb12+za43*zb32)/
     .            t134/(za31*zb12+za34*zb42)/za41/za43

*XC                zi=(0d0,1d0)
*XC                zi*(zb32*za13+zb42*za14)**2*zb34/za13/t134*(1/s34+1/s14)
*XC     .           +zi*(zb23*za12+zb43*za14)**2*zb24/za21/t124/s14
*XC     .           +zi*(zb34*za13+zb24*za12)**2/zb14/za31/za21/za23
*XC above comment is different expression but same result as in hep-ph/0404013
      return
      end
************************************************************************
      complex*16 function zB2g0HMHV(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(4),perm(6)
      integer p(2),m(2),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43
      complex*16, pointer :: zamm21,zamp22,zbmp11,zbpp21

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      l=0
      k=0
      do i=1,4
        if(HEL(i).eq.-1) then
          l=l+1
          m(l)=perm(i)
        endif
        if(HEL(i).eq.1) then
          k=k+1
          p(k)=perm(i)
        endif
      enddo

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      zamm21=>kin(ipset)%zA(m(2),m(1))
      zamp22=>kin(ipset)%zA(m(2),p(2))
      zbmp11=>kin(ipset)%zB(m(1),p(1))
      zbpp21=>kin(ipset)%zB(p(2),p(1))

      zB2g0HMHV=
     .   zamm21**3*zamp22/za12/za23
     .  /za34/za41
     .  -zbmp11*zbpp21**3/zb21/zb32
     .  /zb43/zb14

      return
      end
************************************************************************
*
      complex*16 function zB2g0Hmmmp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      t123=s12+s13+s23
      t234=s23+s34+s24
      t134=s13+s34+s14
      t124=s12+s24+s14

      s56=s12+s13+s14+s23+s24+s34

      zB2g0Hmmmp=(za31*zb14+za32*zb24)**2*(za32*zb21+za34*zb41)/zb12
     .            /zb14/t124/(za31*zb12+za34*zb42)
     .           +s56**2*za13**3/za14/t134/(za13*zb32+za14*zb42)
     .            /(za31*zb12+za34*zb42)
     .           +(za12*zb24+za13*zb34)**2/zb23/zb34/(za13*zb32+za14*zb42)

      return
      end
*****************************************************************************************
      complex*16 function zAphiq2gqmmpp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
*      write(*,*)'hello zAphiq2gqmmpp'
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      zAphiq2gqmmpp=-za12**2*za24/za23/za34/za41

*      ztemp=zAphiq2gqmmpp
*      write(*,*)'zAphiq2gqmmpp=',ztemp
      return
      end
************************************************************************
      complex*16 function zAcphiq2gqmmpp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      zAcphiq2gqmmpp=zb13*zb34**2/zb12/zb23/zb41

*      ztemp=zAcphiq2gqmmpp
*      write(*,*)'zAcphiq2gqmmpp=',ztemp
      return
      end
************************************************************************
      complex*16 function zB2g0Hmmpp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6)
*      write(*,*)'hello zB2g0Hmmpp'

      zB2g0Hmmpp=zAcphiq2gqmmpp(perm(1))+zAphiq2gqmmpp(perm(1))

*      ztemp=zB2g0Hmmpp
*      write(*,*)'zB2g0Hmmpp=',ztemp
      return
      end
************************************************************************
      complex*16 function zAphiq2gqmpmp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      zAphiq2gqmpmp=-za13**3/za12/za23/za41

*      ztemp=zAphiq2gqmpmp
*      write(*,*)'zAphiq2gqmpmp=',ztemp
      return
      end
************************************************************************
      complex*16 function zAcphiq2gqmpmp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za34 => kin(ipset)%zA(j3,j4)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za43 => kin(ipset)%zA(j4,j3)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb34 => kin(ipset)%zB(j3,j4)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb43 => kin(ipset)%zB(j4,j3)

      zAcphiq2gqmpmp=zb24**3/zb23/zb34/zb41

*      ztemp=zAcphiq2gqmpmp
*      write(*,*)'zAcphiq2gqmpmp=',ztemp
      return
      end
************************************************************************
      complex*16 function zB2g0Hmpmp(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6)
*      write(*,*)'hello zB2g0Hmpmp'

      zB2g0Hmpmp=zAphiq2gqmpmp(perm(1))+zAcphiq2gqmpmp(perm(1))

*      ztemp=zB2g0Hmpmp
*      write(*,*)'zB2g0Hmpmp=',ztemp
      return
      end
************************************************************************
      complex*16 function zAcphiq2gqpmpm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zB(j1,j2)
      za13 => kin(ipset)%zB(j1,j3)
      za14 => kin(ipset)%zB(j1,j4)
      za23 => kin(ipset)%zB(j2,j3)
      za24 => kin(ipset)%zB(j2,j4)
      za34 => kin(ipset)%zB(j3,j4)

      za21 => kin(ipset)%zB(j2,j1)
      za31 => kin(ipset)%zB(j3,j1)
      za41 => kin(ipset)%zB(j4,j1)
      za32 => kin(ipset)%zB(j3,j2)
      za42 => kin(ipset)%zB(j4,j2)
      za43 => kin(ipset)%zB(j4,j3)

      zb12 => kin(ipset)%zA(j1,j2)
      zb13 => kin(ipset)%zA(j1,j3)
      zb14 => kin(ipset)%zA(j1,j4)
      zb23 => kin(ipset)%zA(j2,j3)
      zb24 => kin(ipset)%zA(j2,j4)
      zb34 => kin(ipset)%zA(j3,j4)

      zb21 => kin(ipset)%zA(j2,j1)
      zb31 => kin(ipset)%zA(j3,j1)
      zb41 => kin(ipset)%zA(j4,j1)
      zb32 => kin(ipset)%zA(j3,j2)
      zb42 => kin(ipset)%zA(j4,j2)
      zb43 => kin(ipset)%zA(j4,j3)

      zAcphiq2gqpmpm=zb24**3/zb23/zb34/zb41

*      ztemp=zAcphiq2gqmpmp
*      write(*,*)'zAcphiq2gqmpmp=',ztemp
      return
      end
************************************************************************
      complex*16 function zAcphiq2gqppmm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zB(j1,j2)
      za13 => kin(ipset)%zB(j1,j3)
      za14 => kin(ipset)%zB(j1,j4)
      za23 => kin(ipset)%zB(j2,j3)
      za24 => kin(ipset)%zB(j2,j4)
      za34 => kin(ipset)%zB(j3,j4)

      za21 => kin(ipset)%zB(j2,j1)
      za31 => kin(ipset)%zB(j3,j1)
      za41 => kin(ipset)%zB(j4,j1)
      za32 => kin(ipset)%zB(j3,j2)
      za42 => kin(ipset)%zB(j4,j2)
      za43 => kin(ipset)%zB(j4,j3)

      zb12 => kin(ipset)%zA(j1,j2)
      zb13 => kin(ipset)%zA(j1,j3)
      zb14 => kin(ipset)%zA(j1,j4)
      zb23 => kin(ipset)%zA(j2,j3)
      zb24 => kin(ipset)%zA(j2,j4)
      zb34 => kin(ipset)%zA(j3,j4)

      zb21 => kin(ipset)%zA(j2,j1)
      zb31 => kin(ipset)%zA(j3,j1)
      zb41 => kin(ipset)%zA(j4,j1)
      zb32 => kin(ipset)%zA(j3,j2)
      zb42 => kin(ipset)%zA(j4,j2)
      zb43 => kin(ipset)%zA(j4,j3)

      zAcphiq2gqppmm=zb13*zb34**2/zb12/zb23/zb41

*      ztemp=zAcphiq2gqmmpp
*      write(*,*)'zAcphiq2gqmmpp=',ztemp
      return
      end
************************************************************************
      complex*16 function zAphiq2gqpmpm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zB(j1,j2)
      za13 => kin(ipset)%zB(j1,j3)
      za14 => kin(ipset)%zB(j1,j4)
      za23 => kin(ipset)%zB(j2,j3)
      za24 => kin(ipset)%zB(j2,j4)
      za34 => kin(ipset)%zB(j3,j4)

      za21 => kin(ipset)%zB(j2,j1)
      za31 => kin(ipset)%zB(j3,j1)
      za41 => kin(ipset)%zB(j4,j1)
      za32 => kin(ipset)%zB(j3,j2)
      za42 => kin(ipset)%zB(j4,j2)
      za43 => kin(ipset)%zB(j4,j3)

      zb12 => kin(ipset)%zA(j1,j2)
      zb13 => kin(ipset)%zA(j1,j3)
      zb14 => kin(ipset)%zA(j1,j4)
      zb23 => kin(ipset)%zA(j2,j3)
      zb24 => kin(ipset)%zA(j2,j4)
      zb34 => kin(ipset)%zA(j3,j4)

      zb21 => kin(ipset)%zA(j2,j1)
      zb31 => kin(ipset)%zA(j3,j1)
      zb41 => kin(ipset)%zA(j4,j1)
      zb32 => kin(ipset)%zA(j3,j2)
      zb42 => kin(ipset)%zA(j4,j2)
      zb43 => kin(ipset)%zA(j4,j3)

      zAphiq2gqpmpm=-za13**3/za12/za23/za41

*      ztemp=zAphiq2gqmpmp
*      write(*,*)'zAphiq2gqmpmp=',ztemp
      return
      end
*****************************************************************************************
      complex*16 function zAphiq2gqppmm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zB(j1,j2)
      za13 => kin(ipset)%zB(j1,j3)
      za14 => kin(ipset)%zB(j1,j4)
      za23 => kin(ipset)%zB(j2,j3)
      za24 => kin(ipset)%zB(j2,j4)
      za34 => kin(ipset)%zB(j3,j4)

      za21 => kin(ipset)%zB(j2,j1)
      za31 => kin(ipset)%zB(j3,j1)
      za41 => kin(ipset)%zB(j4,j1)
      za32 => kin(ipset)%zB(j3,j2)
      za42 => kin(ipset)%zB(j4,j2)
      za43 => kin(ipset)%zB(j4,j3)

      zb12 => kin(ipset)%zA(j1,j2)
      zb13 => kin(ipset)%zA(j1,j3)
      zb14 => kin(ipset)%zA(j1,j4)
      zb23 => kin(ipset)%zA(j2,j3)
      zb24 => kin(ipset)%zA(j2,j4)
      zb34 => kin(ipset)%zA(j3,j4)

      zb21 => kin(ipset)%zA(j2,j1)
      zb31 => kin(ipset)%zA(j3,j1)
      zb41 => kin(ipset)%zA(j4,j1)
      zb32 => kin(ipset)%zA(j3,j2)
      zb42 => kin(ipset)%zA(j4,j2)
      zb43 => kin(ipset)%zA(j4,j3)

      zAphiq2gqppmm=-za12**2*za24/za23/za34/za41

*      ztemp=zAphiq2gqmmpp
*      write(*,*)'zAphiq2gqmmpp=',ztemp
      return
      end
************************************************************************
      complex*16 function zB2g0Hpmmm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zB(j1,j2)
      za13 => kin(ipset)%zB(j1,j3)
      za14 => kin(ipset)%zB(j1,j4)
      za23 => kin(ipset)%zB(j2,j3)
      za24 => kin(ipset)%zB(j2,j4)
      za34 => kin(ipset)%zB(j3,j4)

      za21 => kin(ipset)%zB(j2,j1)
      za31 => kin(ipset)%zB(j3,j1)
      za41 => kin(ipset)%zB(j4,j1)
      za32 => kin(ipset)%zB(j3,j2)
      za42 => kin(ipset)%zB(j4,j2)
      za43 => kin(ipset)%zB(j4,j3)

      zb12 => kin(ipset)%zA(j1,j2)
      zb13 => kin(ipset)%zA(j1,j3)
      zb14 => kin(ipset)%zA(j1,j4)
      zb23 => kin(ipset)%zA(j2,j3)
      zb24 => kin(ipset)%zA(j2,j4)
      zb34 => kin(ipset)%zA(j3,j4)

      zb21 => kin(ipset)%zA(j2,j1)
      zb31 => kin(ipset)%zA(j3,j1)
      zb41 => kin(ipset)%zA(j4,j1)
      zb32 => kin(ipset)%zA(j3,j2)
      zb42 => kin(ipset)%zA(j4,j2)
      zb43 => kin(ipset)%zA(j4,j3)

      t123=s12+s13+s23
      t234=s23+s34+s24
      t134=s13+s34+s14
      t124=s12+s24+s14

      s56=s12+s13+s14+s23+s24+s34

      zB2g0Hpmmm=-zb42**3*s56**2/t124/zb41/(za31*zb12+za34*zb42)/
     .            (za31*zb14+za32*zb24)
     .           -(za12*zb24+za13*zb34)**2/(za31*zb14+za32*zb24)/
     .            za21/za32
     .           -(za13*zb32+za14*zb42)**2*(za41*zb12+za43*zb32)/
     .            t134/(za31*zb12+za34*zb42)/za41/za43

      return
      end
************************************************************************
      complex*16 function zB2g0Hpmpm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6)
*      write(*,*)'hello zB2g0Hmpmp'

      zB2g0Hpmpm=zAphiq2gqpmpm(perm(1))+zAcphiq2gqpmpm(perm(1))

*      ztemp=zB2g0Hmpmp
*      write(*,*)'zB2g0Hmpmp=',ztemp
      return
      end
************************************************************************
      complex*16 function zB2g0Hppmm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6)
*      write(*,*)'hello zB2g0Hmmpp'

      zB2g0Hppmm=zAcphiq2gqppmm(perm(1))+zAphiq2gqppmm(perm(1))

*      ztemp=zB2g0Hmmpp
*      write(*,*)'zB2g0Hmmpp=',ztemp
      return
      end
************************************************************************
*
      complex*16 function zB2g0Hpppm(PERM)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer perm(6),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43
      complex*16, pointer :: za12,za13,za14,za23,za24,za34
      complex*16, pointer :: za21,za31,za41,za32,za42,za43
      complex*16, pointer :: zb12,zb13,zb14,zb23,zb24,zb34
      complex*16, pointer :: zb21,zb31,zb41,zb32,zb42,zb43

          j1=perm(1)
          j2=perm(2)
          j3=perm(3)
          j4=perm(4)
          j5=perm(5)
          j6=perm(6)

      ipset = nspec+4

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s34 => kin(ipset)%s(j3,j4)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s43 => kin(ipset)%s(j4,j3)

      za12 => kin(ipset)%zB(j1,j2)
      za13 => kin(ipset)%zB(j1,j3)
      za14 => kin(ipset)%zB(j1,j4)
      za23 => kin(ipset)%zB(j2,j3)
      za24 => kin(ipset)%zB(j2,j4)
      za34 => kin(ipset)%zB(j3,j4)

      za21 => kin(ipset)%zB(j2,j1)
      za31 => kin(ipset)%zB(j3,j1)
      za41 => kin(ipset)%zB(j4,j1)
      za32 => kin(ipset)%zB(j3,j2)
      za42 => kin(ipset)%zB(j4,j2)
      za43 => kin(ipset)%zB(j4,j3)

      zb12 => kin(ipset)%zA(j1,j2)
      zb13 => kin(ipset)%zA(j1,j3)
      zb14 => kin(ipset)%zA(j1,j4)
      zb23 => kin(ipset)%zA(j2,j3)
      zb24 => kin(ipset)%zA(j2,j4)
      zb34 => kin(ipset)%zA(j3,j4)

      zb21 => kin(ipset)%zA(j2,j1)
      zb31 => kin(ipset)%zA(j3,j1)
      zb41 => kin(ipset)%zA(j4,j1)
      zb32 => kin(ipset)%zA(j3,j2)
      zb42 => kin(ipset)%zA(j4,j2)
      zb43 => kin(ipset)%zA(j4,j3)

      t123=s12+s13+s23
      t234=s23+s34+s24
      t134=s13+s34+s14
      t124=s12+s24+s14

      s56=s12+s13+s14+s23+s24+s34

      zB2g0Hpppm=(za31*zb14+za32*zb24)**2*(za32*zb21+za34*zb41)/zb12
     .            /zb14/t124/(za31*zb12+za34*zb42)
     .           +s56**2*za13**3/za14/t134/(za13*zb32+za14*zb42)
     .            /(za31*zb12+za34*zb42)
     .           +(za12*zb24+za13*zb34)**2/zb23/zb34/(za13*zb32+za14*zb42)
      return
      end

*****************************************************************************************
*****************************************************************************************
*********** Library for 2 quarks 3 gluon one Higgs tree amplitudes **********************
*****************************************************************************************
*****************************************************************************************
************************************************************************
      complex*16 function zB3g0Hmmmmp(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(5),perm(7),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s15,s23,s24,s25,s34,s35,s45
      real*8, pointer :: s21,s31,s41,s51,s32,s42,s52,s43,s53,s54
      complex*16, pointer :: za12,za13,za14,za15,za23,za24,za25,za34,za35,za45
      complex*16, pointer :: za21,za31,za41,za51,za32,za42,za52,za43,za53,za54
      complex*16, pointer :: zb12,zb13,zb14,zb15,zb23,zb24,zb25,zb34,zb35,zb45
      complex*16, pointer :: zb21,zb31,zb41,zb51,zb32,zb42,zb52,zb43,zb53,zb54

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)
      j7=perm(7)

      ipset = nspec+5

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s15 => kin(ipset)%s(j1,j5)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s25 => kin(ipset)%s(j2,j5)
      s34 => kin(ipset)%s(j3,j4)
      s35 => kin(ipset)%s(j3,j5)
      s45 => kin(ipset)%s(j4,j5)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s51 => kin(ipset)%s(j5,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s52 => kin(ipset)%s(j5,j2)
      s43 => kin(ipset)%s(j4,j3)
      s53 => kin(ipset)%s(j5,j3)
      s54 => kin(ipset)%s(j5,j4)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za15 => kin(ipset)%zA(j1,j5)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za25 => kin(ipset)%zA(j2,j5)
      za34 => kin(ipset)%zA(j3,j4)
      za35 => kin(ipset)%zA(j3,j5)
      za45 => kin(ipset)%zA(j4,j5)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za51 => kin(ipset)%zA(j5,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za52 => kin(ipset)%zA(j5,j2)
      za43 => kin(ipset)%zA(j4,j3)
      za53 => kin(ipset)%zA(j5,j3)
      za54 => kin(ipset)%zA(j5,j4)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb15 => kin(ipset)%zB(j1,j5)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb25 => kin(ipset)%zB(j2,j5)
      zb34 => kin(ipset)%zB(j3,j4)
      zb35 => kin(ipset)%zB(j3,j5)
      zb45 => kin(ipset)%zB(j4,j5)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb51 => kin(ipset)%zB(j5,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb52 => kin(ipset)%zB(j5,j2)
      zb43 => kin(ipset)%zB(j4,j3)
      zb53 => kin(ipset)%zB(j5,j3)
      zb54 => kin(ipset)%zB(j5,j4)

      t123=s12+s13+s23
      t145=s14+s45+s15
      t125=s12+s25+s15
      t234=s23+s34+s24
      t345=s34+s45+s35
      t1235=s12+s13+s15+s23+s25+s35
      t1234=s12+s13+s14+s23+s24+s34
      t1245=s12+s14+s15+s24+s25+s45
      t1345=s13+s14+s15+s34+s35+s45

      s67=s12+s13+s14+s15+s23+s24+s25+s34+s35+s45

      zB3g0Hmmmmp=
     .              -s67**2*za12*(za41*zb15+za42*zb25)**3*(za42*zb21+za45*zb51)
     .             /s12/t125/t1245/zb15/(za41*zb13+za42*zb23+za45*zb53)
     .             /(za41*zb12+za45*zb52)/((zb51*za14+zb52*za24)*zb43+t125*zb53)
*A
     .            +za34*(zb53*za31*zb15+zb53*za32*zb25+zb54*za41*zb15+zb54*za42*zb25)**2
     .             *(t345*zb15+zb12*(za23*zb35+za24*zb45))/s34/zb12/zb15/zb45
     .             /(zb25*t345+zb21*(za13*zb35+za14*zb45))/(t125*zb35+zb34*(za41*zb15+za42*zb25))
*B(1)
     .            -s67**2*za34*(za13*zb35+za14*zb45)**3/t1345/s34/(za13*zb32+za14*zb42+za15*zb52)
     .             /zb45/(zb25*t345+zb21*(za13*zb35+za14*zb45))/(za14*zb43+za15*zb53)
*B(2)
     .            -(za12*zb25+za13*zb35+za14*zb45)**2*za34/s34/zb32/zb45
     .             /(za13*zb32+za14*zb42+za15*zb52)
*B(3)
     .            +s67**2*za14**3*zb15/s15/t145/zb23/(za41*zb12+za45*zb52)/(za14*zb43+za15*zb53)
*C
     .            +(za41*zb15+za42*zb25+za43*zb35)**2*(za42*zb21+za43*zb31+za45*zb51)
     .            /zb12/zb23/zb51/t1235/(za41*zb13+za42*zb23+za45*zb53)
*D

      return
      end
************************************************************************
      complex*16 function zB3g0Hmpmmp(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(5),perm(7),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s15,s23,s24,s25,s34,s35,s45
      real*8, pointer :: s21,s31,s41,s51,s32,s42,s52,s43,s53,s54
      complex*16, pointer :: za12,za13,za14,za15,za23,za24,za25,za34,za35,za45
      complex*16, pointer :: za21,za31,za41,za51,za32,za42,za52,za43,za53,za54
      complex*16, pointer :: zb12,zb13,zb14,zb15,zb23,zb24,zb25,zb34,zb35,zb45
      complex*16, pointer :: zb21,zb31,zb41,zb51,zb32,zb42,zb52,zb43,zb53,zb54

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)
      j7=perm(7)

      ipset = nspec+5

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s15 => kin(ipset)%s(j1,j5)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s25 => kin(ipset)%s(j2,j5)
      s34 => kin(ipset)%s(j3,j4)
      s35 => kin(ipset)%s(j3,j5)
      s45 => kin(ipset)%s(j4,j5)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s51 => kin(ipset)%s(j5,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s52 => kin(ipset)%s(j5,j2)
      s43 => kin(ipset)%s(j4,j3)
      s53 => kin(ipset)%s(j5,j3)
      s54 => kin(ipset)%s(j5,j4)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za15 => kin(ipset)%zA(j1,j5)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za25 => kin(ipset)%zA(j2,j5)
      za34 => kin(ipset)%zA(j3,j4)
      za35 => kin(ipset)%zA(j3,j5)
      za45 => kin(ipset)%zA(j4,j5)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za51 => kin(ipset)%zA(j5,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za52 => kin(ipset)%zA(j5,j2)
      za43 => kin(ipset)%zA(j4,j3)
      za53 => kin(ipset)%zA(j5,j3)
      za54 => kin(ipset)%zA(j5,j4)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb15 => kin(ipset)%zB(j1,j5)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb25 => kin(ipset)%zB(j2,j5)
      zb34 => kin(ipset)%zB(j3,j4)
      zb35 => kin(ipset)%zB(j3,j5)
      zb45 => kin(ipset)%zB(j4,j5)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb51 => kin(ipset)%zB(j5,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb52 => kin(ipset)%zB(j5,j2)
      zb43 => kin(ipset)%zB(j4,j3)
      zb53 => kin(ipset)%zB(j5,j3)
      zb54 => kin(ipset)%zB(j5,j4)

      t123=s12+s13+s23
      t145=s14+s45+s15
      t125=s12+s25+s15
      t234=s23+s34+s24
      t345=s34+s45+s35
      t1235=s12+s13+s15+s23+s25+s35
      t1234=s12+s13+s14+s23+s24+s34
      t1245=s12+s14+s15+s24+s25+s45
      t1345=s13+s14+s15+s34+s35+s45

      s67=s12+s13+s14+s15+s23+s24+s25+s34+s35+s45

      zB3g0Hmpmmp=
     .              -za34*(za13*zb35+za14*zb45)**3/za12/s34/zb45/(za23*zb35+za24*zb45)
     .              /(za14*zb43+za15*zb53)
*A
     .              -za34**3*zb25**3/zb15/t125/(za31*zb15+za32*zb25)/(za41*zb12+za45*zb52)
*B
     .              +s67**2*za13**4*za14**3*zb15/s15/za23/za21/(t145*za13+za23*(za14*zb42+za15*zb52))
     .              /(za12*zb24*za41+za12*zb25*za51+za13*zb34*za41+za13*zb35*za51)
     .              /(t123*za14-za45*(za12*zb25+za13*zb35))
*C(1)
     .              -zb51*za14**3*(za13*zb32+za14*zb42+za15*zb52)**3/s15/zb23
     .              /(za12*zb24*za41+za12*zb25*za51+za13*zb34*za41+za13*zb35*za51)
     .              /(za14*zb43+za15*zb53)/(za14*t234+za15*(za42*zb25+za43*zb35))
*C(2)
     .              -(za31*zb12+za34*zb42+za35*zb52)**3*zb15*za41**3/t145/s15/(za41*zb12+za45*zb52)
     .              /(t145*za31+za32*(zb24*za41+zb25*za51))/t1245
*C(3)
     .              +za34**3*(za12*zb25+za13*zb35+za14*zb45)**2/za23/t234/(za23*zb35+za24*zb45)
     .              /(za41*t234+za51*(za42*zb25+za43*zb35))
*D
     .              -za13**3*(za41*zb15+za42*zb25+za43*zb35)**2*(t123*za34+za54*(za31*zb15+za32*zb25))
     .              /za12/za23/t123/t1235/(za31*zb15+za32*zb25)/(t123*za14+za54*(za12*zb25+za13*zb35))
*E
     .              +zb25**3/zb23/zb34/zb45/zb15
*cphi part

      return
      end
************************************************************************
      complex*16 function zB3g0Hmmpmp(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(5),perm(7),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s15,s23,s24,s25,s34,s35,s45
      real*8, pointer :: s21,s31,s41,s51,s32,s42,s52,s43,s53,s54
      complex*16, pointer :: za12,za13,za14,za15,za23,za24,za25,za34,za35,za45
      complex*16, pointer :: za21,za31,za41,za51,za32,za42,za52,za43,za53,za54
      complex*16, pointer :: zb12,zb13,zb14,zb15,zb23,zb24,zb25,zb34,zb35,zb45
      complex*16, pointer :: zb21,zb31,zb41,zb51,zb32,zb42,zb52,zb43,zb53,zb54

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)
      j7=perm(7)

      ipset = nspec+5

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s15 => kin(ipset)%s(j1,j5)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s25 => kin(ipset)%s(j2,j5)
      s34 => kin(ipset)%s(j3,j4)
      s35 => kin(ipset)%s(j3,j5)
      s45 => kin(ipset)%s(j4,j5)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s51 => kin(ipset)%s(j5,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s52 => kin(ipset)%s(j5,j2)
      s43 => kin(ipset)%s(j4,j3)
      s53 => kin(ipset)%s(j5,j3)
      s54 => kin(ipset)%s(j5,j4)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za15 => kin(ipset)%zA(j1,j5)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za25 => kin(ipset)%zA(j2,j5)
      za34 => kin(ipset)%zA(j3,j4)
      za35 => kin(ipset)%zA(j3,j5)
      za45 => kin(ipset)%zA(j4,j5)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za51 => kin(ipset)%zA(j5,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za52 => kin(ipset)%zA(j5,j2)
      za43 => kin(ipset)%zA(j4,j3)
      za53 => kin(ipset)%zA(j5,j3)
      za54 => kin(ipset)%zA(j5,j4)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb15 => kin(ipset)%zB(j1,j5)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb25 => kin(ipset)%zB(j2,j5)
      zb34 => kin(ipset)%zB(j3,j4)
      zb35 => kin(ipset)%zB(j3,j5)
      zb45 => kin(ipset)%zB(j4,j5)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb51 => kin(ipset)%zB(j5,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb52 => kin(ipset)%zB(j5,j2)
      zb43 => kin(ipset)%zB(j4,j3)
      zb53 => kin(ipset)%zB(j5,j3)
      zb54 => kin(ipset)%zB(j5,j4)

      t123=s12+s13+s23
      t145=s14+s45+s15
      t125=s12+s25+s15
      t234=s23+s34+s24
      t345=s34+s45+s35
      t1235=s12+s13+s15+s23+s25+s35
      t1234=s12+s13+s14+s23+s24+s34
      t1245=s12+s14+s15+s24+s25+s45
      t1345=s13+s14+s15+s34+s35+s45

      s67=s12+s13+s14+s15+s23+s24+s25+s34+s35+s45

      zB3g0Hmmpmp=
     .              -za12**2*za34*zb35**3*(za24*zb43+za25*zb53)/s34/t345/zb45
     .              /(za14*zb43+za15*zb53)/(za23*zb35+za24*zb45)
*A
     .              -za12*(za41*zb15+za42*zb25)**3*(za42*zb21+za45*zb51)/s12
     .              /t125/za34/zb15/(za31*zb15+za32*zb25)/(za41*zb12+za45*zb52)
*B
     .              -s67**2*za24**4*za14**3*zb15/za23/za34/s15/(t145*za42+za32*(za41*zb13+za45*zb53))
     .              /(za42*zb21*za14+za42*zb25*za54+za43*zb31*za14+za43*zb35*za54)
     .              /(t234*za14+za15*(za42*zb25+za43*zb35))
*C(1)
     .              +(za21*zb13+za24*zb43+za25*zb53)**3*za14**3*zb15/t145/s15/t1345
     .              /(za14*zb43+za15*zb53)/(t145*za42+za32*(za41*zb13+za45*zb53))
*C(2)
     .              -(za41*zb13+za42*zb23+za45*zb53)**3*za14**3*zb15/s15/zb23/(za41*zb12+za45*zb52)
     .              /(za42*zb21*za14+za42*zb25*za54+za43*zb31*za14+za43*zb35*za54)
     .              /(t123*za14-za45*(za12*zb25+za13*zb35))
*C(3)
     .              +za24**4*(za12*zb25+za13*zb35+za14*zb45)**2/t234/za23/za34/(za23*zb35+za24*zb45)
     .              /(t234*za41+za51*(za42*zb25+za43*zb35))
*D
     .              -za12**2*(za41*zb15+za42*zb25+za43*zb35)**2*(t123*za24+za54*(za21*zb15+za23*zb35))
     .              /za23/t123/t1235/(za31*zb15+za32*zb25)/(t123*za14+za54*(za12*zb25+za13*zb35))
*E
     .              +zb35**3*zb31/zb12/zb23/zb34/zb45/zb51
*cphi part

      return
      end
************************************************************************
      complex*16 function zB3g0Hmmmpp(PERM,HEL)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer hel(5),perm(7),ipset
      common /npars/npars,nspec,n
      real*8, pointer :: s12,s13,s14,s15,s23,s24,s25,s34,s35,s45
      real*8, pointer :: s21,s31,s41,s51,s32,s42,s52,s43,s53,s54
      complex*16, pointer :: za12,za13,za14,za15,za23,za24,za25,za34,za35,za45
      complex*16, pointer :: za21,za31,za41,za51,za32,za42,za52,za43,za53,za54
      complex*16, pointer :: zb12,zb13,zb14,zb15,zb23,zb24,zb25,zb34,zb35,zb45
      complex*16, pointer :: zb21,zb31,zb41,zb51,zb32,zb42,zb52,zb43,zb53,zb54

      j1=perm(1)
      j2=perm(2)
      j3=perm(3)
      j4=perm(4)
      j5=perm(5)
      j6=perm(6)
      j7=perm(7)

      ipset = nspec+5

      s12 => kin(ipset)%s(j1,j2)
      s13 => kin(ipset)%s(j1,j3)
      s14 => kin(ipset)%s(j1,j4)
      s15 => kin(ipset)%s(j1,j5)
      s23 => kin(ipset)%s(j2,j3)
      s24 => kin(ipset)%s(j2,j4)
      s25 => kin(ipset)%s(j2,j5)
      s34 => kin(ipset)%s(j3,j4)
      s35 => kin(ipset)%s(j3,j5)
      s45 => kin(ipset)%s(j4,j5)

      s21 => kin(ipset)%s(j2,j1)
      s31 => kin(ipset)%s(j3,j1)
      s41 => kin(ipset)%s(j4,j1)
      s51 => kin(ipset)%s(j5,j1)
      s32 => kin(ipset)%s(j3,j2)
      s42 => kin(ipset)%s(j4,j2)
      s52 => kin(ipset)%s(j5,j2)
      s43 => kin(ipset)%s(j4,j3)
      s53 => kin(ipset)%s(j5,j3)
      s54 => kin(ipset)%s(j5,j4)

      za12 => kin(ipset)%zA(j1,j2)
      za13 => kin(ipset)%zA(j1,j3)
      za14 => kin(ipset)%zA(j1,j4)
      za15 => kin(ipset)%zA(j1,j5)
      za23 => kin(ipset)%zA(j2,j3)
      za24 => kin(ipset)%zA(j2,j4)
      za25 => kin(ipset)%zA(j2,j5)
      za34 => kin(ipset)%zA(j3,j4)
      za35 => kin(ipset)%zA(j3,j5)
      za45 => kin(ipset)%zA(j4,j5)

      za21 => kin(ipset)%zA(j2,j1)
      za31 => kin(ipset)%zA(j3,j1)
      za41 => kin(ipset)%zA(j4,j1)
      za51 => kin(ipset)%zA(j5,j1)
      za32 => kin(ipset)%zA(j3,j2)
      za42 => kin(ipset)%zA(j4,j2)
      za52 => kin(ipset)%zA(j5,j2)
      za43 => kin(ipset)%zA(j4,j3)
      za53 => kin(ipset)%zA(j5,j3)
      za54 => kin(ipset)%zA(j5,j4)

      zb12 => kin(ipset)%zB(j1,j2)
      zb13 => kin(ipset)%zB(j1,j3)
      zb14 => kin(ipset)%zB(j1,j4)
      zb15 => kin(ipset)%zB(j1,j5)
      zb23 => kin(ipset)%zB(j2,j3)
      zb24 => kin(ipset)%zB(j2,j4)
      zb25 => kin(ipset)%zB(j2,j5)
      zb34 => kin(ipset)%zB(j3,j4)
      zb35 => kin(ipset)%zB(j3,j5)
      zb45 => kin(ipset)%zB(j4,j5)

      zb21 => kin(ipset)%zB(j2,j1)
      zb31 => kin(ipset)%zB(j3,j1)
      zb41 => kin(ipset)%zB(j4,j1)
      zb51 => kin(ipset)%zB(j5,j1)
      zb32 => kin(ipset)%zB(j3,j2)
      zb42 => kin(ipset)%zB(j4,j2)
      zb52 => kin(ipset)%zB(j5,j2)
      zb43 => kin(ipset)%zB(j4,j3)
      zb53 => kin(ipset)%zB(j5,j3)
      zb54 => kin(ipset)%zB(j5,j4)

      t123=s12+s13+s23
      t145=s14+s45+s15
      t125=s12+s25+s15
      t234=s23+s34+s24
      t345=s34+s45+s35
      t1235=s12+s13+s15+s23+s25+s35
      t1234=s12+s13+s14+s23+s24+s34
      t1245=s12+s14+s15+s24+s25+s45
      t1345=s13+s14+s15+s34+s35+s45

      s67=s12+s13+s14+s15+s23+s24+s25+s34+s35+s45

      zB3g0Hmmmpp=
     .             +za15*za23**3*zb54**2*zb14/s15/t145/(za21*zb14+za25*zb54)/(za34*zb41+za35*zb51)
*A
     .             -za23*(za12*zb24+za13*zb34)**2*(za52*zb24+za53*zb34)/za51/s23/zb34/t234
     .             /(za53*zb32+za54*zb42)
*B
     .             +za12**2*za25*(za31*zb14+za32*zb24+za35*zb54)**3/za51/t1245/t125
     .             /(za21*zb14+za25*zb54)/(za53*t125+za43*(za51*zb14+za52*zb24))
*C
     .             +zb45*za35*(za32*zb21+za34*zb41+za35*zb51)
     .             *(za31*zb14*za43+za31*zb15*za53+za32*zb24*za43+za32*zb25*za53)**2
     .             /zb12/za34/s45/(za31*zb12+za34*zb42+za35*zb52)/(za34*zb41+za35*zb51)
     .             /(t125*za35+za34*(za51*zb14+za52*zb24))
*D(1)
     .             -s67**2*zb45*za13**3*za35/za15/za34/s45/t1345/(za13*zb32+za14*zb42+za15*zb52)
     .             /(za31*zb12+za34*zb42+za35*zb52)
*D(2)
     .             +zb45*za35*(t345*za13+za12*(zb24*za43+zb25*za53))**2/za34/t345/s45
     .             /(za13*zb32+za14*zb42+za15*zb52)/(za53*zb32+za54*zb42)

     .             +zb45**2*zb41/zb12/zb23/zb34/zb51
*cphi part

      return
      end
************************************************************************
*


