************************************************************************
*
* colour leading two quark pairs one higgs 1-loop level matrix elements with massive quark loop
**
* summed over colour orderings, summed and squared
* Need inputs from colour decomposed OL
************************************************************************
      function C0g1mH(iq1,i3qpb,i4qp,iqbar2,i5,i6)
#ifdef USE_OL  
      use openloops
      use KinData_mod
      use Channels_mod, only: OLiproc_chan
      use Process_mod
#endif 
!Need the dynamic value of alphas_scl from driver for MC run
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      real(8) :: MW,MZ
      integer :: OL_id_C0g1mHOL,nhelnonv
      complex(8) :: zm2arr(2,16)
!Here we know the colour basis dimension is 2 and helicity is 16 for C0g1mH from loop_colbasis_dim of OpenLoops
      parameter(pi=3.141592653589793238d0)
      parameter(nc=3d0)
      parameter(nf=5d0)

      !write(*,*)"Hello C0g1mH"
      C0g1mH = 0d0
      zm2arr(:,:) = (0d0,0d0)
      temp = 0d0
#ifdef USE_OL 
      select case ( name_proc ) 
      case('HJM')
         if(iq1.eq.1 .and. i3qpb.eq.3 .and. i4qp.eq.4 .and. iqbar2.eq.2 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(18)
!          OLiproc_chan(18) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.4 .and. i4qp.eq.3 .and. iqbar2.eq.2 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(18)
!          OLiproc_chan(18) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.2 .and. i4qp.eq.3 .and. iqbar2.eq.4 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(16) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.2 .and. i4qp.eq.4 .and. iqbar2.eq.3 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(16) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.3 .and. i4qp.eq.2 .and. iqbar2.eq.4 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(17) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.4 .and. i4qp.eq.2 .and. iqbar2.eq.3 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(17) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.4 .and. i4qp.eq.3 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(18)
!          OLiproc_chan(18) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.3 .and. i4qp.eq.4 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(18)
!          OLiproc_chan(18) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.4 .and. i3qpb.eq.3 .and. i4qp.eq.2 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(16) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.3 .and. i3qpb.eq.4 .and. i4qp.eq.2 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(16) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.4 .and. i3qpb.eq.2 .and. i4qp.eq.3 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(17) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.3 .and. i3qpb.eq.2 .and. i4qp.eq.4 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(17) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.1 .and. i4qp.eq.4 .and. iqbar2.eq.3 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(16) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.1 .and. i4qp.eq.3 .and. iqbar2.eq.4 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(16) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.4 .and. i4qp.eq.1 .and. iqbar2.eq.3 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(17) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.3 .and. i4qp.eq.1 .and. iqbar2.eq.4 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(17) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         else
           write(*,*)"OL_id_C0g1mHOL crossing in HJM not found"
           write(*,*)"iq1,i3qpb,i4qp,iqbar2,i5,i6 =",iq1,i3qpb,i4qp,iqbar2,i5,i6
           stop
         endif
      case('HJJM','HJJMREW')
         if(iq1.eq.1 .and. i3qpb.eq.3 .and. i4qp.eq.4 .and. iqbar2.eq.2 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(11)
!          OLiproc_chan(11) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.4 .and. i4qp.eq.3 .and. iqbar2.eq.2 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(11)
!          OLiproc_chan(11) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.2 .and. i4qp.eq.3 .and. iqbar2.eq.4 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(9)
!          OLiproc_chan(9) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.2 .and. i4qp.eq.4 .and. iqbar2.eq.3 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(9)
!          OLiproc_chan(9) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.3 .and. i4qp.eq.2 .and. iqbar2.eq.4 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(10)
!          OLiproc_chan(10) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.1 .and. i3qpb.eq.4 .and. i4qp.eq.2 .and. iqbar2.eq.3 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(10)
!          OLiproc_chan(10) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.4 .and. i4qp.eq.3 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(11)
!          OLiproc_chan(11) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.3 .and. i4qp.eq.4 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(11)
!          OLiproc_chan(11) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.4 .and. i3qpb.eq.3 .and. i4qp.eq.2 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(9)
!          OLiproc_chan(9) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.3 .and. i3qpb.eq.4 .and. i4qp.eq.2 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(9)
!          OLiproc_chan(9) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.4 .and. i3qpb.eq.2 .and. i4qp.eq.3 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(10)
!          OLiproc_chan(10) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.3 .and. i3qpb.eq.2 .and. i4qp.eq.4 .and. iqbar2.eq.1 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(10)
!          OLiproc_chan(10) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.1 .and. i4qp.eq.4 .and. iqbar2.eq.3 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(9)
!          OLiproc_chan(16) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.1 .and. i4qp.eq.3 .and. iqbar2.eq.4 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(9)
!          OLiproc_chan(16) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.4 .and. i4qp.eq.1 .and. iqbar2.eq.3 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(10)
!          OLiproc_chan(17) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         elseif(iq1.eq.2 .and. i3qpb.eq.3 .and. i4qp.eq.1 .and. iqbar2.eq.4 ) then
!$omp critical(eval_ol_reduced)
           OL_id_C0g1mHOL = OLiproc_chan(10)
!          OLiproc_chan(17) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 4, 3, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_C0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           temp = 0d0
           do i = 1,16
              temp = temp + zm2arr(1,i)*dconjg(zm2arr(1,i))
           enddo
!$omp end critical(eval_ol_reduced)
         else
           write(*,*)"OL_id_C0g1mHOL crossing in HJJM not found"
           write(*,*)"iq1,i3qpb,i4qp,iqbar2,i5,i6 =",iq1,i3qpb,i4qp,iqbar2,i5,i6
           stop
         endif
      case default
         write(*,*) "Invalid process in crossProc: ", name_proc
         stop
      end select

!$omp critical(eval_ol_reduced)
!Calculate the vev used in OL:
      call get_parameter("alpha", alpha)
      call get_parameter("alphas", alpha_s)
      call get_parameter("w_mass", MW)
      call get_parameter("z_mass", MZ)
!$omp end critical(eval_ol_reduced)
#endif 
      cw   = MW/MZ
      cw2  = cw**2d0  
      sw2  = 1d0 - cw2
      sw   = sqrt(sw2)
      vev  = 2d0*MW*sw/sqrt(4d0*pi*alpha)
      !write(*,*)"vev=",vev
      C0=(alpha_s/6d0/pi/vev)**2
      prefactor = (dble(nc)**2-1d0)*C0*(4d0*pi*alpha_s)**2/8d0
      !write(*,*)"prefactor=",prefactor
      !write(*,*)"kin(6)%pOLHinc=",kin(6)%pOLHinc
!Above parameters matches the OpenLoops pre-factor and we want to remove them for NNLOJET convention
      C0g1mH = temp/prefactor
      return
      end

************************************************************************
*
* colour sub-leading two quark pairs one higgs 1-loop level matrix elements with massive quark loop
**
* summed over colour orderings, summed and squared
* Need inputs from colour decomposed OL
************************************************************************
      function D0g1mH(iq1,i3qb,i4q,iqb2,i5,i6)
#ifdef USE_OL  
      use openloops
      use KinData_mod
      use Channels_mod, only: OLiproc_chan
      use Process_mod
#endif 
!Need the dynamic value of alphas_scl from driver for MC run
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      real(8) :: MW,MZ
      integer :: OL_id_D0g1mHOL 
      complex(8) :: zm2arr(2,16)
!Here we know the colour basis dimension is 6 for A4g1mH from loop_colbasis_dim of OpenLoops
      parameter(pi=3.141592653589793238d0)
      parameter(nc=3d0)
      parameter(nf=5d0)

      !write(*,*)"Hello D0g1mH"
      D0g1mH = 0d0
      zm2arr(:,:) = (0d0,0d0)
      temp = 0d0
#ifdef USE_OL 
!$omp critical(eval_ol_reduced)
      select case ( name_proc ) 
      case('HJM')
         if(iq1.eq.1 .and. i3qb.eq.3 .and. i4q.eq.4 .and. iqb2.eq.2 ) then
           OL_id_D0g1mHOL = OLiproc_chan(24)
!          OLiproc_chan(24) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.2 .and. i4q.eq.4 .and. iqb2.eq.3 ) then
           OL_id_D0g1mHOL = OLiproc_chan(24)
!          OLiproc_chan(24) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.4 .and. i4q.eq.3 .and. iqb2.eq.2 ) then
           OL_id_D0g1mHOL = OLiproc_chan(22)
!          OLiproc_chan(22) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.2 .and. i4q.eq.3 .and. iqb2.eq.4 ) then
           OL_id_D0g1mHOL = OLiproc_chan(22)
!          OLiproc_chan(22) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.3 .and. i4q.eq.2 .and. iqb2.eq.4 ) then
           OL_id_D0g1mHOL = OLiproc_chan(23)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.4 .and. i4q.eq.2 .and. iqb2.eq.3 ) then
           OL_id_D0g1mHOL = OLiproc_chan(23)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.4 .and. i4q.eq.3 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(24)
!          OLiproc_chan(24) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.3 .and. i3qb.eq.4 .and. i4q.eq.2 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(24)
!          OLiproc_chan(24) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.3 .and. i4q.eq.4 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(22)
!          OLiproc_chan(22) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.4 .and. i3qb.eq.3 .and. i4q.eq.2 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(22)
!          OLiproc_chan(22) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.4 .and. i3qb.eq.2 .and. i4q.eq.3 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(23)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.4 .and. i3qb.eq.1 .and. i4q.eq.3 .and. iqb2.eq.2 ) then
           OL_id_D0g1mHOL = OLiproc_chan(23)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.3 .and. i3qb.eq.1 .and. i4q.eq.4 .and. iqb2.eq.2 ) then
           OL_id_D0g1mHOL = OLiproc_chan(23)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.3 .and. i3qb.eq.2 .and. i4q.eq.4 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(23)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.3 .and. i4q.eq.1 .and. iqb2.eq.4 ) then
           OL_id_D0g1mHOL = OLiproc_chan(23)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.4 .and. i4q.eq.1 .and. iqb2.eq.3 ) then
           OL_id_D0g1mHOL = OLiproc_chan(23)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.1 .and. i4q.eq.3 .and. iqb2.eq.4 ) then
           OL_id_D0g1mHOL = OLiproc_chan(24)
!          OLiproc_chan(24) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.1 .and. i4q.eq.4 .and. iqb2.eq.3 ) then
           OL_id_D0g1mHOL = OLiproc_chan(22)
!          OLiproc_chan(22) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         else
           write(*,*)"OL_id_D0g1mHOL crossing in HJM not found"
           write(*,*)"iq1,i3qb,i4q,iqb2,i5,i6 =",iq1,i3qb,i4q,iqb2,i5,i6
           stop
         endif
      case('HJJM','HJJMREW')
         if(iq1.eq.1 .and. i3qb.eq.3 .and. i4q.eq.4 .and. iqb2.eq.2 ) then
           OL_id_D0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(17) inside registerOLHJJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.2 .and. i4q.eq.4 .and. iqb2.eq.3 ) then
           OL_id_D0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(17) inside registerOLHJJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.4 .and. i4q.eq.3 .and. iqb2.eq.2 ) then
           OL_id_D0g1mHOL = OLiproc_chan(15)
!          OLiproc_chan(15) inside registerOLHJJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.2 .and. i4q.eq.3 .and. iqb2.eq.4 ) then
           OL_id_D0g1mHOL = OLiproc_chan(15)
!          OLiproc_chan(15) inside registerOLHJJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.3 .and. i4q.eq.2 .and. iqb2.eq.4 ) then
           OL_id_D0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(16) inside registerOLHJJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.1 .and. i3qb.eq.4 .and. i4q.eq.2 .and. iqb2.eq.3 ) then
           OL_id_D0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(16) inside registerOLHJJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.4 .and. i4q.eq.3 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(24) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.3 .and. i3qb.eq.4 .and. i4q.eq.2 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(24) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.3 .and. i4q.eq.4 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(15)
!          OLiproc_chan(22) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.4 .and. i3qb.eq.3 .and. i4q.eq.2 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(15)
!          OLiproc_chan(22) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.4 .and. i3qb.eq.2 .and. i4q.eq.3 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.4 .and. i3qb.eq.1 .and. i4q.eq.3 .and. iqb2.eq.2 ) then
           OL_id_D0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.3 .and. i3qb.eq.1 .and. i4q.eq.4 .and. iqb2.eq.2 ) then
           OL_id_D0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.3 .and. i3qb.eq.2 .and. i4q.eq.4 .and. iqb2.eq.1 ) then
           OL_id_D0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.3 .and. i4q.eq.1 .and. iqb2.eq.4 ) then
           OL_id_D0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.4 .and. i4q.eq.1 .and. iqb2.eq.3 ) then
           OL_id_D0g1mHOL = OLiproc_chan(16)
!          OLiproc_chan(23) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.1 .and. i4q.eq.3 .and. iqb2.eq.4 ) then
           OL_id_D0g1mHOL = OLiproc_chan(17)
!          OLiproc_chan(24) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         elseif(iq1.eq.2 .and. i3qb.eq.1 .and. i4q.eq.4 .and. iqb2.eq.3 ) then
           OL_id_D0g1mHOL = OLiproc_chan(15)
!          OLiproc_chan(22) inside registerOLHJm()
           call fill_pOLHinc(6, (/ 1, 2, 3, 4, 5, 6 /) )
            call evaluate_loop_colvect(OL_id_D0g1mHOL,kin(6)%pOLHinc,zm2arr,nhelnonv)
           do j = 1,16
              ztemp1 = -nc**2d0/(nc**2d0-1d0)*(zm2arr(1,j) + zm2arr(2,j)/nc)
              ztemp2 = +nc**2d0/(nc**2d0-1d0)*(zm2arr(2,j) + zm2arr(1,j)/nc)
              temp = temp - 2d0*dble(ztemp1*dconjg(ztemp2))
!The minus sign here agrees with our convention
           enddo
         else
           write(*,*)"OL_id_D0g1mHOL crossing in HJJM not found"
           write(*,*)"iq1,i3qb,i4q,iqb2,i5,i6 =",iq1,i3qb,i4q,iqb2,i5,i6
           stop
         endif
      case default
         write(*,*) "Invalid process in crossProc: ", name_proc
         stop
      end select
!Calculate the vev used in OL:
      call get_parameter("alpha", alpha)
      call get_parameter("alphas", alpha_s)
      call get_parameter("w_mass", MW)
      call get_parameter("z_mass", MZ)
!$omp end critical(eval_ol_reduced)
      cw   = MW/MZ
      cw2  = cw**2d0  
      sw2  = 1d0 - cw2
      sw   = sqrt(sw2)
      vev  = 2d0*MW*sw/sqrt(4d0*pi*alpha)
      !write(*,*)"vev=",vev
      C0=(alpha_s/6d0/pi/vev)**2
      prefactor = (dble(nc)**2-1d0)*C0*(4d0*pi*alpha_s)**2/8d0
      !write(*,*)"prefactor=",prefactor
      !write(*,*)"kin(6)%pOLHinc=",kin(6)%pOLHinc
!Above parameters matches the OpenLoops pre-factor and we want to remove them for NNLOJET convention
      D0g1mH = temp/prefactor
#endif

      return
      end






ccc This is reweighted 1-loop libarary. 
************************************************************************
      function C0g1mHrew(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer i1,i2,i3,i4,i5,i6

      C0g1mHrew = C0g1H(i1,i2,i3,i4,i5,i6,renscale2)*C0g1mH(i1,i2,i3,i4,i5,i6)/C0g0H(i1,i2,i3,i4,i5,i6)

      return
      end

************************************************************************
      function Ct0g1mHrew(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer i1,i2,i3,i4,i5,i6

      Ct0g1mHrew = Ct0g1H(i1,i2,i3,i4,i5,i6,renscale2)*C0g1mH(i1,i2,i3,i4,i5,i6)/C0g0H(i1,i2,i3,i4,i5,i6)

      return
      end

************************************************************************
      function Ch0g1mHrew(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer i1,i2,i3,i4,i5,i6

      Ch0g1mHrew = Ch0g1H(i1,i2,i3,i4,i5,i6,renscale2)*C0g1mH(i1,i2,i3,i4,i5,i6)/C0g0H(i1,i2,i3,i4,i5,i6)

      return
      end

************************************************************************

      function C0g1mHFrew(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      integer iq1,iQbar3,iQ4,iqbar2,i5,i6

      if(iq1.ne.1 .and. iq1 .ne.2 .and. iqbar2.ne.1 .and. iqbar2 .ne.2) then
      C0g1mHFrew=1d0/2d0*(
     .            +C0g1mHrew(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
     .            +C0g1mHrew(iqbar2,iQbar3,iQ4,iq1,i5,i6,renscale2)
     .               )
      elseif(iQbar3.ne.1 .and. iQbar3 .ne.2 .and. iQ4.ne.1 .and. iQ4 .ne.2) then
      C0g1mHFrew=1d0/2d0*(
     .            +C0g1mHrew(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
     .            +C0g1mHrew(iq1,iQ4,iQbar3,iqbar2,i5,i6,renscale2)
     .               )
      else
      C0g1mHFrew=
     .            +C0g1mHrew(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
      endif

      return
      end

************************************************************************

      function Ct0g1mHFrew(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      integer iq1,iQbar3,iQ4,iqbar2,i5,i6

      if(iq1.ne.1 .and. iq1 .ne.2 .and. iqbar2.ne.1 .and. iqbar2 .ne.2) then
      Ct0g1mHFrew=1d0/2d0*(
     .            +Ct0g1mHrew(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
     .            +Ct0g1mHrew(iqbar2,iQbar3,iQ4,iq1,i5,i6,renscale2)
     .               )
      elseif(iQbar3.ne.1 .and. iQbar3 .ne.2 .and. iQ4.ne.1 .and. iQ4 .ne.2) then
      Ct0g1mHFrew=1d0/2d0*(
     .            +Ct0g1mHrew(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
     .            +Ct0g1mHrew(iq1,iQ4,iQbar3,iqbar2,i5,i6,renscale2)
     .               )
      else
      Ct0g1mHFrew=
     .            +Ct0g1mHrew(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
      endif

      return
      end

************************************************************************
      function D0g1mHrew(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer i1,i2,i3,i4,i5,i6

      D0g1mHrew = D0g1H(i1,i2,i3,i4,i5,i6,renscale2)*D0g1mH(i1,i2,i3,i4,i5,i6)/D0g0H(i1,i2,i3,i4,i5,i6)

      return
      end

************************************************************************
      function Dt0g1mHrew(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer i1,i2,i3,i4,i5,i6

      Dt0g1mHrew = Dt0g1H(i1,i2,i3,i4,i5,i6,renscale2)*D0g1mH(i1,i2,i3,i4,i5,i6)/D0g0H(i1,i2,i3,i4,i5,i6)

      return
      end

************************************************************************
      function Dh0g1mHrew(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer i1,i2,i3,i4,i5,i6

      Dh0g1mHrew = Dh0g1H(i1,i2,i3,i4,i5,i6,renscale2)*D0g1mH(i1,i2,i3,i4,i5,i6)/D0g0H(i1,i2,i3,i4,i5,i6)

      return
      end
