************************************************************************
*
* H-->(Z-->e-(1)e+(2))(Z-->e-(3)e+(4)) decay ME
*  higgs decay to ZZ* then decay to four leptons with identical flavour (l1+,l1-,l2+,l2-)
* i1=l1-(e-), i2=l1+(e+), i3=l2-(e-), i4=l2+(e+).
* s(i1,i2)=mZ^2(mZ*^2) and s(i3,i4)=mZ*^2(mZ^2) (invariant mass swap if isym=1)
**
*
************************************************************************
      function HZZ4e0(i1,i2,i3,i4,ipset)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /LR/ ele,ere,sin2w,enQ(-5:5),enL(5),enR(5)
      common /eweakW/ amzW,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /eweakZ/ amzZ,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /Hmass/emh,ehwidth
      real*8, pointer :: s12,s13,s14,s23,s24,s34,s21,s31,s41,s32,s42,s43

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s41 => kin(ipset)%s(i4,i1)
      s32 => kin(ipset)%s(i3,i2)
      s42 => kin(ipset)%s(i4,i2)
      s43 => kin(ipset)%s(i4,i3)

      s1234=s12+s13+s14+s23+s24+s34

      if((amzW.eq.0).or.(stw.eq.0))then
         call initeweak
      endif

      zi=(0d0,1d0)

      propHnarrow=1d0/((s1234-emh**2)**2+(emh*ehwidth)**2)
c      propHnarrow=pi/emh/ehwidth
c      propHnarrow=1d0
*Higgs propagator in Breit-Wigner resonance formalism

      propZ1=1d0/((s12-emz**2)**2+(emz*ezwidth)**2)
c      propZ1=pi/emz/ezwidth
c      propZ1=1d0
*Z propagator in Breit-Wigner resonance formalism

      propZ2=1d0/((s34-emz**2)**2+(emz*ezwidth)**2)
c      propZ2=pi/emz/ezwidth
c      propZ2=1d0
*Z propagator in Breit-Wigner resonance formalism

      propZ3=1d0/((s14-emz**2)**2+(emz*ezwidth)**2)
c      propZ3=pi/emz/ezwidth
c      propZ3=1d0
*Z propagator in Breit-Wigner resonance formalism

      propZ4=1d0/((s23-emz**2)**2+(emz*ezwidth)**2)
c      propZ3=pi/emz/ezwidth
c      propZ3=1d0
*Z propagator in Breit-Wigner resonance formalism

      zpropZ1234=1d0/(s12-emz**2+zi*emz*ezwidth)/(s34-emz**2+zi*emz*ezwidth)
     .              /(s14-emz**2-zi*emz*ezwidth)/(s23-emz**2-zi*emz*ezwidth)

      propZ1234=dreal(zpropZ1234)

      HZZ4e0=propHnarrow*(
     .  propZ1*propZ2*((ele**4+ere**4)*s13*s24 + 2d0*ele**2*ere**2*s14*s23)
     . +propZ3*propZ4*((ele**4+ere**4)*s13*s24 + 2d0*ele**2*ere**2*s12*s34)
     . +propZ1234*2d0*(ele**4+ere**4)*s13*s24
     .                   )*1d0/4d0
*1/4 average factor for two pairs of identical leptons (different charge)
      return
      end
