
      !###########################################
      !########### wrapper functions #############
      !############# 1-loop debug ################
      !## Should give the same numbers than the ##
      !## corresponding funcs. in lib(A/B)Hloop ##
      !###########################################

      function A3g1H_DB(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullA3g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32


      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .true.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      A3g1H_DB = fullA3g2H(ss,1,2,3,1,col1L,col2L,renscale2,
     . cSub=.false.)

      end function A3g1H_DB

      !###########################################

      function At3g1H_DB(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullA3g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .true.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      At3g1H_DB = fullA3g2H(ss,1,2,3,1,col1L,col2L,renscale2,
     . cSub=.false.)

      end function At3g1H_DB

      !###########################################

      function Ah3g1H_DB(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullA3g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .true.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      Ah3g1H_DB = fullA3g2H(ss,1,2,3,1,col1L,col2L,renscale2,
     . cSub=.false.)

      end function Ah3g1H_DB

      !###########################################

      function B1g1H_DB(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .true.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      B1g1H_DB = fullB1g2H(ss,1,3,2,1,col1L,col2L,renscale2,
     . cSub=.false.)

      end function B1g1H_DB

      !###########################################

      function Bt1g1H_DB(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .true.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      Bt1g1H_DB = fullB1g2H(ss,1,3,2,1,col1L,col2L,renscale2,
     . cSub=.false.)

      end function Bt1g1H_DB

      !###########################################

      function Bh1g1H_DB(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .true.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      Bh1g1H_DB = fullB1g2H(ss,1,3,2,1,col1L,col2L,renscale2,
     . cSub=.false.)

      end function Bh1g1H_DB

      !###########################################
      !########### wrapper functions #############
      !################ 2-loop ###################
      !#### Same normalisation as 1loop debug ####
      !###########################################

      function A3g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullA3g2H,fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .true.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      A3g2H = fullA3g2H(ss,1,2,3,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function A3g2H

      !###########################################

      function At3g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullA3g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .true.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      At3g2H = fullA3g2H(ss,1,2,3,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function At3g2H

      !###########################################

      function Att3g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullA3g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .true.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      Att3g2H = fullA3g2H(ss,1,2,3,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function Att3g2H

      !###########################################

      function Aht3g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullA3g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .true.
      col2L(5) = .false.
      col2L(6) = .false.

      Aht3g2H = fullA3g2H(ss,1,2,3,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function Aht3g2H

      !###########################################

      function Ah3g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullA3g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .true.
      col2L(6) = .false.

      Ah3g2H = fullA3g2H(ss,1,2,3,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function Ah3g2H

      !###########################################

      function Ahh3g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullA3g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .true.

      Ahh3g2H = fullA3g2H(ss,1,2,3,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function Ahh3g2H

      !###########################################

      function B1g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .true.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      B1g2H = fullB1g2H(ss,1,3,2,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function B1g2H

      !###########################################

      function Bt1g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .true.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      Bt1g2H = fullB1g2H(ss,1,3,2,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function Bt1g2H

      !###########################################

      function Btt1g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .true.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .false.

      Btt1g2H = fullB1g2H(ss,1,3,2,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function Btt1g2H

      !###########################################

      function Bht1g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .true.
      col2L(5) = .false.
      col2L(6) = .false.

      Bht1g2H = fullB1g2H(ss,1,3,2,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function Bht1g2H

      !###########################################

      function Bh1g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .true.
      col2L(6) = .false.

      Bh1g2H = fullB1g2H(ss,1,3,2,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function Bh1g2H

      !###########################################

      function Bhh1g2H(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use libH3p2loop, only:fullB1g2H
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /order2l/ipole
      common /order/ieorder
      common /npars/npars,nspec,n
      logical col1L(3),col2L(6)
      double precision ss(5,5)
      integer ipset
      real*8, pointer :: s12,s13,s23,s21,s31,s32

      !decay kinematics does not need nspec
      if(i4.lt.3.and.i5.lt.3)then
        ipset=5
      else
        ipset = nspec+3
      endif

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s21 => kin(ipset)%s(i2,i1)
      s31 => kin(ipset)%s(i3,i1)
      s32 => kin(ipset)%s(i3,i2)

      ss(1,2)=s12
      ss(1,3)=s13
      ss(2,3)=s23
      ss(2,1)=s21
      ss(3,1)=s31
      ss(3,2)=s32

      col1L(1) = .false.
      col1L(2) = .false.
      col1L(3) = .false.

      col2L(1) = .false.
      col2L(2) = .false.
      col2L(3) = .false.
      col2L(4) = .false.
      col2L(5) = .false.
      col2L(6) = .true.

      Bhh1g2H = fullB1g2H(ss,1,3,2,2,col1L,col2L,renscale2,
     . ieorder=-ipole)

      end function Bhh1g2H


      !###########################################

      function Dphan1g2H(i1,i2,i3,i4,i5,i6,renscale2)

      Dphan1g2H = 0d0

      end function Dphan1g2H

      !###########################################

      function Dpphan1g2H(i1,i2,i3,i4,i5,i6,renscale2)

      Dpphan1g2H = 0d0

      end function Dpphan1g2H
