************************************************************************
!XC the Branch Ratio for Higgs to di-gamma is taken from eq 2.45 of hep-ph/0503172:
!  A.~Djouadi,
!  %``The Anatomy of electro-weak symmetry breaking. I: The Higgs boson in the standard model,''
!  Phys.\ Rept.\  {\bf 457} (2008) 1
!  doi:10.1016/j.physrep.2007.10.004
!  [hep-ph/0503172].

!XC The actual value from eq 2.45 of hep-ph/0503172 is checked against 1508.02684:
!  F.~Caola, K.~Melnikov and M.~Schulze,
!  %``Fiducial cross sections for Higgs boson production in association with a jet at next-to-next-to-leading order in QCD,''
!  Phys.\ Rev.\ D {\bf 92} (2015) no.7,  074032
!  doi:10.1103/PhysRevD.92.074032
!  [arXiv:1508.02684 [hep-ph]].
************************************************************************
*XC link inclusive Higgs production ME with 2 decay particles
************************************************************************
****************All tree amplitudes*************************************
************************************************************************
      function A2g0H2(i1,i2,i3,i4)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=4

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i3,i4,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A2g0H2=A2g0H(i1,i2,i3,i4)*decayME

      return
      end

************************************************************************
      function A3g0H2(i1,i2,i3,i4,i5)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A3g0H2=A3g0H(i1,i2,i3,i4,i5)*decayME

      return
      end

************************************************************************
      function A4g0H2(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A4g0H2=A4g0H(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function A5g0H2(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A5g0H2=A5g0H(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function B1g0H2(iq1,i3,iqbar2,i4,i5)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      B1g0H2=B1g0H(iq1,i3,iqbar2,i4,i5)*decayME

      return
      end

************************************************************************
      function B2g0H2(iq1,i3,i4,iqbar2,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      B2g0H2=B2g0H(iq1,i3,i4,iqbar2,i5,i6)*decayME

      return
      end

************************************************************************
      function Bt2g0H2(iq1,i3,i4,iqbar2,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bt2g0H2=Bt2g0H(iq1,i3,i4,iqbar2,i5,i6)*decayME

      return
      end

************************************************************************
      function B3g0H2(iq1,i3,i4,i5,iqbar2,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      B3g0H2=B3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Bt3g0H2(iq1,i3,i4,i5,iqbar2,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bt3g0H2=Bt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Btt3g0H2(iq1,i3,i4,i5,iqbar2,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Btt3g0H2=Btt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function C0g0H2(iq1,iQbar3,iQ4,iqbar2,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      C0g0H2=C0g0H(iq1,iQbar3,iQ4,iqbar2,i5,i6)*decayME

      return
      end

************************************************************************
      function D0g0H2(iq1,iQbar3,iQ4,iqbar2,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      D0g0H2=D0g0H(iq1,iQbar3,iQ4,iqbar2,i5,i6)*decayME

      return
      end


************************************************************************
      function C1g0H2F(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      C1g0H2F=C1g0HF(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Ct1g0H2F(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ct1g0H2F=Ct1g0HF(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function D1g0H2F(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      D1g0H2F=D1g0HF(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Dt1g0H2(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Dt1g0H2=Dt1g0H(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end









************************************************************************
****************All 1-loop amplitudes***********************************
************************************************************************
      function A2g1H2(i1,i2,i3,i4,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=4

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i3,i4,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A2g1H2=A2g1H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function A2g1mH2(i1,i2,i3,i4)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=4

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i3,i4,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A2g1mH2=A2g1mH(i1,i2,i3,i4)*decayME

      return
      end

************************************************************************
      function Ah2g1H2(i1,i2,i3,i4,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=4

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i3,i4,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ah2g1H2=Ah2g1H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function A3g1H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A3g1H2=A3g1H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function A3g1mH2(i1,i2,i3,i4,i5)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A3g1mH2=A3g1mH(i1,i2,i3,i4,i5)*decayME

      return
      end

************************************************************************
      function Ah3g1H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ah3g1H2=Ah3g1H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function A4g1H2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A4g1H2=A4g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ah4g1H2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ah4g1H2=Ah4g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function B1g1H2(iq1,i3,iqbar2,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      B1g1H2=B1g1H(iq1,i3,iqbar2,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function B1g1mH2(i1,i3,i2,i4,i5)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      B1g1mH2=B1g1mH(i1,i3,i2,i4,i5)*decayME

      return
      end

************************************************************************
      function Bt1g1H2(iq1,i3,iqbar2,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bt1g1H2=Bt1g1H(iq1,i3,iqbar2,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bh1g1H2(iq1,i3,iqbar2,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bh1g1H2=Bh1g1H(iq1,i3,iqbar2,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function B2g1H2(i1,i3,i4,i2,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      B2g1H2=B2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Bt2g1H2(i1,i3,i4,i2,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bt2g1H2=Bt2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Bh2g1H2(i1,i3,i4,i2,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bh2g1H2=Bh2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Btt2g1H2F(i1,i3,i4,i2,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Btt2g1H2F=Btt2g1HF(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Bttt2g1H2(i1,i3,i4,i2,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bttt2g1H2=Bttt2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Btth2g1H2(i1,i3,i4,i2,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Btth2g1H2=Btth2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function C0g1H2F(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      C0g1H2F=C0g1HF(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ct0g1H2F(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ct0g1H2F=Ct0g1HF(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ch0g1H2(i1,i3,i4,i2,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ch0g1H2=Ch0g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function D0g1H2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      D0g1H2=D0g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Dt0g1H2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Dt0g1H2=Dt0g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Dh0g1H2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Dh0g1H2=Dh0g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end


************************************************************************
****************All 2-loop amplitudes***********************************
************************************************************************
      function A2g2H2(i1,i2,i3,i4,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=4

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i3,i4,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A2g2H2=A2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function At2g2H2(i1,i2,i3,i4,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=4

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i3,i4,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      At2g2H2=At2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function Aht2g2H2(i1,i2,i3,i4,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=4

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i3,i4,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Aht2g2H2=Aht2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function Ah2g2H2(i1,i2,i3,i4,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=4

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i3,i4,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ah2g2H2=Ah2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function Ahh2g2H2(i1,i2,i3,i4,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=4

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i3,i4,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ahh2g2H2=Ahh2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function A3g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      A3g2H2=A3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function At3g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      At3g2H2=At3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Ah3g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ah3g2H2=Ah3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Ahh3g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Ahh3g2H2=Ahh3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Aht3g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Aht3g2H2=Aht3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Att3g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Att3g2H2=Att3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function B1g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      B1g2H2=B1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bt1g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bt1g2H2=Bt1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bh1g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bh1g2H2=Bh1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bhh1g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bhh1g2H2=Bhh1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bht1g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Bht1g2H2=Bht1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Btt1g2H2(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i4,i5,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Btt1g2H2=Btt1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Dphan1g2H2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Dphan1g2H2=Dphan1g2H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Dpphan1g2H2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2P','HTO2PJ','HTO2PJJ','HTO2PJJJ','HTO2PM','HTO2PJM')
        decayME=2.35d-3
      case('HTO2TAU','HTO2TAUJ','HTO2TAUJJ','HTO2TAUJJJ','HTOTAUM'
     .    ,'HTO2TAUJM')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH2.f: ", name_proc
         stop
      end select

      Dpphan1g2H2=Dpphan1g2H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

