************************************************************************
*XC link inclusive Higgs production ME with 3 decay particles
************************************************************************
****************All tree amplitudes*************************************
************************************************************************
      function A2g0H3(i1,i2,i3,i4,i5)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i3,i4,i5,ipset)
#else
        decayME=HZg2l1g0(i3,i4,i5,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A2g0H3=A2g0H(i1,i2,i3,i4)*decayME

      return
      end

************************************************************************
      function A3g0H3(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A3g0H3=A3g0H(i1,i2,i3,i4,i5)*decayME

      return
      end

************************************************************************
      function A4g0H3(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A4g0H3=A4g0H(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function A5g0H3(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i6,i7,i8,ipset)
#else
        decayME=HZg2l1g0(i6,i7,i8,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A5g0H3=A5g0H(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function B1g0H3(iq1,i3,iqbar2,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      B1g0H3=B1g0H(iq1,i3,iqbar2,i4,i5)*decayME

      return
      end

************************************************************************
      function B2g0H3(iq1,i3,i4,iqbar2,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      B2g0H3=B2g0H(iq1,i3,i4,iqbar2,i5,i6)*decayME

      return
      end

************************************************************************
      function Bt2g0H3(iq1,i3,i4,iqbar2,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bt2g0H3=Bt2g0H(iq1,i3,i4,iqbar2,i5,i6)*decayME

      return
      end

************************************************************************
      function B3g0H3(iq1,i3,i4,i5,iqbar2,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i6,i7,i8,ipset)
#else
        decayME=HZg2l1g0(i6,i7,i8,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      B3g0H3=B3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Bt3g0H3(iq1,i3,i4,i5,iqbar2,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i6,i7,i8,ipset)
#else
        decayME=HZg2l1g0(i6,i7,i8,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bt3g0H3=Bt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Btt3g0H3(iq1,i3,i4,i5,iqbar2,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i6,i7,i8,ipset)
#else
        decayME=HZg2l1g0(i6,i7,i8,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Btt3g0H3=Btt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function C0g0H3(iq1,iQbar3,iQ4,iqbar2,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      C0g0H3=C0g0H(iq1,iQbar3,iQ4,iqbar2,i5,i6)*decayME

      return
      end

************************************************************************
      function D0g0H3(iq1,iQbar3,iQ4,iqbar2,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      D0g0H3=D0g0H(iq1,iQbar3,iQ4,iqbar2,i5,i6)*decayME

      return
      end


************************************************************************
      function C1g0H3F(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i6,i7,i8,ipset)
#else
        decayME=HZg2l1g0(i6,i7,i8,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      C1g0H3F=C1g0HF(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Ct1g0H3F(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i6,i7,i8,ipset)
#else
        decayME=HZg2l1g0(i6,i7,i8,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ct1g0H3F=Ct1g0HF(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function D1g0H3F(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i6,i7,i8,ipset)
#else
        decayME=HZg2l1g0(i6,i7,i8,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      D1g0H3F=D1g0HF(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Dt1g0H3(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i6,i7,i8,ipset)
#else
        decayME=HZg2l1g0(i6,i7,i8,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Dt1g0H3=Dt1g0H(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end









************************************************************************
****************All 1-loop amplitudes***********************************
************************************************************************
      function A2g1H3(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i3,i4,i5,ipset)
#else
        decayME=HZg2l1g0(i3,i4,i5,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A2g1H3=A2g1H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function A2g1mH3(i1,i2,i3,i4,i5)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i3,i4,i5,ipset)
#else
        decayME=HZg2l1g0(i3,i4,i5,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A2g1mH3=A2g1mH(i1,i2,i3,i4)*decayME

      return
      end

************************************************************************
      function Ah2g1H3(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i3,i4,i5,ipset)
#else
        decayME=HZg2l1g0(i3,i4,i5,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ah2g1H3=Ah2g1H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function A3g1H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A3g1H3=A3g1H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function A3g1mH3(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A3g1mH3=A3g1mH(i1,i2,i3,i4,i5)*decayME

      return
      end

************************************************************************
      function Ah3g1H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ah3g1H3=Ah3g1H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function A4g1H3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A4g1H3=A4g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ah4g1H3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ah4g1H3=Ah4g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function B1g1H3(iq1,i3,iqbar2,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      B1g1H3=B1g1H(iq1,i3,iqbar2,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function B1g1mH3(i1,i3,i2,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      B1g1mH3=B1g1mH(i1,i3,i2,i4,i5)*decayME

      return
      end

************************************************************************
      function Bt1g1H3(iq1,i3,iqbar2,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bt1g1H3=Bt1g1H(iq1,i3,iqbar2,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bh1g1H3(iq1,i3,iqbar2,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bh1g1H3=Bh1g1H(iq1,i3,iqbar2,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function B2g1H3(i1,i3,i4,i2,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      B2g1H3=B2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Bt2g1H3(i1,i3,i4,i2,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bt2g1H3=Bt2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Bh2g1H3(i1,i3,i4,i2,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bh2g1H3=Bh2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Btt2g1H3F(i1,i3,i4,i2,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Btt2g1H3F=Btt2g1HF(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Bttt2g1H3(i1,i3,i4,i2,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bttt2g1H3=Bttt2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Btth2g1H3(i1,i3,i4,i2,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Btth2g1H3=Btth2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function C0g1H3F(iq1,iQbar3,iQ4,iqbar2,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      C0g1H3F=C0g1HF(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ct0g1H3F(iq1,iQbar3,iQ4,iqbar2,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ct0g1H3F=Ct0g1HF(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ch0g1H3(i1,i3,i4,i2,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ch0g1H3=Ch0g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function D0g1H3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      D0g1H3=D0g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Dt0g1H3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Dt0g1H3=Dt0g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Dh0g1H3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Dh0g1H3=Dh0g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end


************************************************************************
****************All 2-loop amplitudes***********************************
************************************************************************
      function A2g2H3(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i3,i4,i5,ipset)
#else
        decayME=HZg2l1g0(i3,i4,i5,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A2g2H3=A2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function At2g2H3(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i3,i4,i5,ipset)
#else
        decayME=HZg2l1g0(i3,i4,i5,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      At2g2H3=At2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function Aht2g2H3(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i3,i4,i5,ipset)
#else
        decayME=HZg2l1g0(i3,i4,i5,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Aht2g2H3=Aht2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function Ah2g2H3(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i3,i4,i5,ipset)
#else
        decayME=HZg2l1g0(i3,i4,i5,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ah2g2H3=Ah2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function Ahh2g2H3(i1,i2,i3,i4,i5,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=5

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i3,i4,i5,ipset)
#else
        decayME=HZg2l1g0(i3,i4,i5,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ahh2g2H3=Ahh2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function A3g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      A3g2H3=A3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function At3g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      At3g2H3=At3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Ah3g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ah3g2H3=Ah3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Ahh3g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Ahh3g2H3=Ahh3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Aht3g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Aht3g2H3=Aht3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Att3g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Att3g2H3=Att3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function B1g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      B1g2H3=B1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bt1g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bt1g2H3=Bt1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bh1g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bh1g2H3=Bh1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bhh1g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bhh1g2H3=Bhh1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bht1g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Bht1g2H3=Bht1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Btt1g2H3(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i4,i5,i6,ipset)
#else
        decayME=HZg2l1g0(i4,i5,i6,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Btt1g2H3=Btt1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Dphan1g2H3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Dphan1g2H3=Dphan1g2H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Dpphan1g2H3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2L1P','HTO2L1PJ','HTO2L1PJJ','HTO2L1PJJJ','HTO2L1PM'
     .    ,'HTO2L1PJM')
#ifdef USE_OL        
        decayME=HZg2l1g0OL(i5,i6,i7,ipset)
#else
        decayME=HZg2l1g0(i5,i6,i7,ipset)
#endif
      case default
         write(*,*) "Invalid decay process in wrapH3.f: ", name_proc
         stop
      end select

      Dpphan1g2H3=Dpphan1g2H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

