************************************************************************
*XC link inclusive Higgs production ME with 4 decay particles
************************************************************************
****************All tree amplitudes*************************************
************************************************************************
      function A2g0H4(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i3,i4,i5,i6,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i3,i4,i5,i6,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i3,i4,i5,i6,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i3,i4,i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A2g0H4=A2g0H(i1,i2,i3,i4)*decayME

      return
      end

************************************************************************
      function A3g0H4(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .     ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A3g0H4=A3g0H(i1,i2,i3,i4,i5)*decayME

      return
      end

************************************************************************
      function A4g0H4(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A4g0H4=A4g0H(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function A5g0H4(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A5g0H4=A5g0H(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function B1g0H4(iq1,i3,iqbar2,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      B1g0H4=B1g0H(iq1,i3,iqbar2,i4,i5)*decayME

      return
      end

************************************************************************
      function B2g0H4(iq1,i3,i4,iqbar2,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      B2g0H4=B2g0H(iq1,i3,i4,iqbar2,i5,i6)*decayME

      return
      end

************************************************************************
      function Bt2g0H4(iq1,i3,i4,iqbar2,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bt2g0H4=Bt2g0H(iq1,i3,i4,iqbar2,i5,i6)*decayME

      return
      end

************************************************************************
      function B3g0H4(iq1,i3,i4,i5,iqbar2,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      B3g0H4=B3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Bt3g0H4(iq1,i3,i4,i5,iqbar2,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bt3g0H4=Bt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Btt3g0H4(iq1,i3,i4,i5,iqbar2,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Btt3g0H4=Btt3g0H(iq1,i3,i4,i5,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function C0g0H4(iq1,iQbar3,iQ4,iqbar2,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      C0g0H4=C0g0H(iq1,iQbar3,iQ4,iqbar2,i5,i6)*decayME

      return
      end

************************************************************************
      function D0g0H4(iq1,iQbar3,iQ4,iqbar2,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      D0g0H4=D0g0H(iq1,iQbar3,iQ4,iqbar2,i5,i6)*decayME

      return
      end


************************************************************************
      function C1g0H4F(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      C1g0H4F=C1g0HF(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Ct1g0H4F(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ct1g0H4F=Ct1g0HF(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function D1g0H4F(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      D1g0H4F=D1g0HF(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end

************************************************************************
      function Dt1g0H4(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Dt1g0H4=Dt1g0H(iq1,i5,iQbar4,iQ3,iqbar2,i6,i7)*decayME

      return
      end









************************************************************************
****************All 1-loop amplitudes***********************************
************************************************************************
      function A2g1H4(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i3,i4,i5,i6,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i3,i4,i5,i6,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i3,i4,i5,i6,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i3,i4,i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A2g1H4=A2g1H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function A2g1mH4(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i3,i4,i5,i6,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i3,i4,i5,i6,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i3,i4,i5,i6,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i3,i4,i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A2g1mH4=A2g1mH(i1,i2,i3,i4)*decayME

      return
      end

************************************************************************
      function Ah2g1H4(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i3,i4,i5,i6,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i3,i4,i5,i6,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i3,i4,i5,i6,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i3,i4,i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ah2g1H4=Ah2g1H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function A3g1H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A3g1H4=A3g1H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function A3g1mH4(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A3g1mH4=A3g1mH(i1,i2,i3,i4,i5)*decayME

      return
      end

************************************************************************
      function Ah3g1H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ah3g1H4=Ah3g1H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function A4g1H4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A4g1H4=A4g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ah4g1H4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ah4g1H4=Ah4g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function B1g1H4(iq1,i3,iqbar2,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      B1g1H4=B1g1H(iq1,i3,iqbar2,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function B1g1mH4(i1,i3,i2,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      B1g1mH4=B1g1mH(i1,i3,i2,i4,i5)*decayME

      return
      end

************************************************************************
      function Bt1g1H4(iq1,i3,iqbar2,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bt1g1H4=Bt1g1H(iq1,i3,iqbar2,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bh1g1H4(iq1,i3,iqbar2,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bh1g1H4=Bh1g1H(iq1,i3,iqbar2,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function B2g1H4(i1,i3,i4,i2,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      B2g1H4=B2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Bt2g1H4(i1,i3,i4,i2,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bt2g1H4=Bt2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Bh2g1H4(i1,i3,i4,i2,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bh2g1H4=Bh2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Btt2g1H4F(i1,i3,i4,i2,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Btt2g1H4F=Btt2g1HF(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Bttt2g1H4(i1,i3,i4,i2,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bttt2g1H4=Bttt2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Btth2g1H4(i1,i3,i4,i2,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Btth2g1H4=Btth2g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function C0g1H4F(iq1,iQbar3,iQ4,iqbar2,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      C0g1H4F=C0g1HF(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ct0g1H4F(iq1,iQbar3,iQ4,iqbar2,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ct0g1H4F=Ct0g1HF(iq1,iQbar3,iQ4,iqbar2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ch0g1H4(i1,i3,i4,i2,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ch0g1H4=Ch0g1H(i1,i3,i4,i2,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function D0g1H4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      D0g1H4=D0g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Dt0g1H4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Dt0g1H4=Dt0g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Dh0g1H4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Dh0g1H4=Dh0g1H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end


************************************************************************
****************All 2-loop amplitudes***********************************
************************************************************************
      function A2g2H4(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i3,i4,i5,i6,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i3,i4,i5,i6,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i3,i4,i5,i6,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i3,i4,i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A2g2H4=A2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function At2g2H4(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i3,i4,i5,i6,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i3,i4,i5,i6,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i3,i4,i5,i6,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i3,i4,i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      At2g2H4=At2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function Aht2g2H4(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i3,i4,i5,i6,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i3,i4,i5,i6,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i3,i4,i5,i6,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i3,i4,i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Aht2g2H4=Aht2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function Ah2g2H4(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i3,i4,i5,i6,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i3,i4,i5,i6,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i3,i4,i5,i6,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i3,i4,i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ah2g2H4=Ah2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function Ahh2g2H4(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i3,i4,i5,i6,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i3,i4,i5,i6,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i3,i4,i5,i6,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i3,i4,i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ahh2g2H4=Ahh2g2H(i1,i2,i3,i4,renscale2)*decayME

      return
      end

************************************************************************
      function A3g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      A3g2H4=A3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function At3g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      At3g2H4=At3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Ah3g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ah3g2H4=Ah3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Ahh3g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Ahh3g2H4=Ahh3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Aht3g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Aht3g2H4=Aht3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Att3g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Att3g2H4=Att3g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function B1g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      B1g2H4=B1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bt1g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bt1g2H4=Bt1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bh1g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bh1g2H4=Bh1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bhh1g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bhh1g2H4=Bhh1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Bht1g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Bht1g2H4=Bht1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Btt1g2H4(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i4,i5,i6,i7,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i4,i5,i6,i7,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i4,i5,i6,i7,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i4,i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Btt1g2H4=Btt1g2H(i1,i2,i3,i4,i5,renscale2)*decayME

      return
      end

************************************************************************
      function Dphan1g2H4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Dphan1g2H4=Dphan1g2H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Dpphan1g2H4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('HTO2E2MU','HTO2E2MUJ','HTO2E2MUJJ','HTO2E2MUJJJ','HTO2E2MUM'
     .    ,'HTO2E2MUJM')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('HTO4E','HTO4EJ','HTO4EJJ','HTO4EJJJ','HTO4EM','HTO4EJM')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('HTO2L2N','HTO2L2NJ','HTO2L2NJJ','HTO2L2NJJJ','HTO2L2NM'
     .    ,'HTO2L2NJM')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case('HH','HHJ','HHJJ','HHJJJ')
        decayME=Hto4p(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapH4.f: ", name_proc
         stop
      end select

      Dpphan1g2H4=Dpphan1g2H(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

