      double precision function C0g1VBF(i1,i3,i2,i4,i5,i6,renscale2,iboson)
      use C0gVBF_mod
      use KinData_mod
      implicit double precision (a-h, o-y)
      !
      ! q(i1) + Q(i2p) ----> Q(i3) + q(i4) + H(i5,i6)
      !
      integer npars, nspec, n
      common /npars/npars,nspec,n
      common/order/ieorder
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      parameter(pi=3.141592653589793238d0)

      rloqq = C0g0VBF(i1,i3,i2,i4,i5,i6,iboson)
      pi2   = pi**2

      s14   = kin(nspec+4)%s(i1,i4)
      s23   = kin(nspec+4)%s(i2,i3)

      dls14 = dlog(renscale2/dabs(s14))
      dls23 = dlog(renscale2/dabs(s23))

      if(ieorder.eq.-2)then
         vc1 = -1d0
         vc2 = -1d0
      elseif(ieorder.eq.-1)then
         vc1 = -3d0/2d0 - dls14
         vc2 = -3d0/2d0 - dls23
      elseif(ieorder.eq.0)then
         vc1 = (-3d0*dls14  -8d0 + 1d0*pi2/6d0 -dls14**2)/2d0
         vc2 = (-3d0*dls23  -8d0 + 1d0*pi2/6d0 -dls23**2)/2d0
         !> Difference between s and t channels
         if (all( (/i1,i4/) < 3 )) then
            vc1 = vc1 + pi2/2d0
         elseif (all( (/i2,i3/) < 3 )) then
            vc2 = vc2 + pi2/2d0
         endif
      endif


      C0g1VBF = (vc1 + vc2)*rloqq

      return
      end function

      double precision function C0g1WFH(i1,i3,i2,i4,i5,i6,renscale2)
         implicit none
         double precision C0g1VBF
         integer i1,i3,i2,i4,i5,i6
         double precision renscale2

         C0g1WFH = C0g1VBF(i1,i3,i2,i4,i5,i6,renscale2,1)

         return
      end function

      double precision function C0g1ZFH(i1,i3,i2,i4,i5,i6,renscale2)
         implicit none
         double precision C0g1VBF
         integer i1,i3,i2,i4,i5,i6
         double precision renscale2

         C0g1ZFH = C0g1VBF(i1,i3,i2,i4,i5,i6,renscale2,0)

         return
      end function

      !> Exactly the same as previous functions, done like this to take
      !> care of s-channel subtraction terms
      double precision function fC0g1WFH(i1,i3,i2,i4,i5,i6,renscale2)
         implicit none
         double precision C0g1VBF
         integer i1,i3,i2,i4,i5,i6
         double precision renscale2

         fC0g1WFH = C0g1VBF(i1,i3,i2,i4,i5,i6,renscale2,1)

         return
      end function

      double precision function fC0g1ZFH(i1,i3,i2,i4,i5,i6,renscale2)
         implicit none
         double precision C0g1VBF
         integer i1,i3,i2,i4,i5,i6
         double precision renscale2

         fC0g1ZFH = C0g1VBF(i1,i3,i2,i4,i5,i6,renscale2,0)

         return
      end function

      !>
      !> Symmetrised version of C0g1VFH over i2-i3
      !> only to be called by subtraction terms
      !>
      double precision function sC0g1WFH(i1,i3,i2,i4,i5,i6,renscale2)
         implicit none
         double precision C0g1WFH, renscale2
         integer i1,i3,i2,i4,i5,i6

         sC0g1WFH = (C0g1WFH(i1, i3,i2, i4,i5,i6,renscale2)
     .            +  C0g1WFH(i1, i2,i3, i4,i5,i6,renscale2))/2d0

      return
      end function 

      double precision function sC0g1ZFH(i1,i3,i2,i4,i5,i6,renscale2)
         implicit none
         double precision C0g1ZFH, renscale2
         integer i1,i3,i2,i4,i5,i6

         sC0g1ZFH = (C0g1ZFH(i1, i3,i2, i4,i5,i6,renscale2)
     .            +  C0g1ZFH(i1, i2,i3, i4,i5,i6,renscale2))/2d0

      return
      end function 
