      double precision function C1g0WFH(i1,i5,i3,i2,i4,i6,i7)
         use C1gVBF_mod
         implicit none
         integer i1,i5,i3,i2,i4,i6,i7

         C1g0WFH = C1g0VBF(i1,i5,i3,i2,i4,i6,i7,1)

         return
      end function

      double precision function C1g0ZFH(i1,i5,i3,i2,i4,i6,i7)
         use C1gVBF_mod
         implicit none
         integer i1,i5,i3,i2,i4,i6,i7

         C1g0ZFH = C1g0VBF(i1,i5,i3,i2,i4,i6,i7,0)

         return
      end function

      !>
      !> Wrappers in order to use the right couplings 
      !> in the subtraction terms
      !> Should only be used for quark initiated processes
      !> Gluon (i5) always radiated from the i1-i4 line
      !>

      double precision function C1g0VBFs1(i1,i5,i3,i2,i4,i6,i7,iboson)
         use C1gVBF_mod
         implicit none
         integer, intent(in) :: i1, i2, i3, i4, i5, i6, i7, iboson
         C1g0VBFs1 =  C1g0VBFs0(i1,i5,i3,i2,i4,i6,i7,iboson)
      end function

      double precision function C1g0ZFHs1(i1,i5,i3,i2,i4,i6,i7)
         use C1gVBF_mod
         implicit none
         integer, intent(in) :: i1, i2, i3, i4, i5, i6, i7
         C1g0ZFHs1 =  C1g0VBFs0(i1,i5,i3,i2,i4,i6,i7,0)
      end function

      double precision function C1g0WFHs1(i1,i5,i3,i2,i4,i6,i7)
         use C1gVBF_mod
         implicit none
         integer, intent(in) :: i1, i2, i3, i4, i5, i6, i7
         C1g0WFHs1 =  C1g0VBFs0(i1,i5,i3,i2,i4,i6,i7,1)
      end function

      !>
      !> Symmetrised versions of C1g1VFH over i2-i3
      !> s0 version only to be called by subtraction terms
      !>
      double precision function sC1g0WFH(i1,i5,i3,i2,i4,i6,i7)
         implicit none
         integer, intent(in) :: i1, i2, i3, i4, i5, i6, i7
         double precision C1g0WFH

         if ((i5 > 2)) then
            sC1g0WFH = C1g0WFH(i1,i5,i3,i2,i4,i6,i7)
         else
            if ((i1 > 2).and.(i4 > 2)) then
               sC1g0WFH = (C1g0WFH(i1, i5,i3,i2, i4,i6,i7) 
     .                  +  C1g0WFH(i4, i5,i3,i2, i1,i6,i7))/2d0
            else
               sC1g0WFH = (C1g0WFH(i1,i5, i3,i2, i4,i6,i7) 
     .                  +  C1g0WFH(i1,i5, i2,i3, i4,i6,i7))/2d0
            endif
         endif
         return
      end function sC1g0WFH

      double precision function sC1g0WFHs0(i1,i5, i3,i2, i4,i6,i7)
         implicit none
         integer, intent(in) :: i1, i2, i3, i4, i5, i6, i7
         double precision C1g0WFH

         sC1g0WFHs0 = (C1g0WFH(i1,i5, i3,i2, i4,i6,i7) 
     .              +  C1g0WFH(i1,i5, i2,i3, i4,i6,i7))/2d0

      end function sC1g0WFHs0

      double precision function sC1g0ZFH(i1,i5,i3,i2,i4,i6,i7)
         implicit none
         integer, intent(in) :: i1, i2, i3, i4, i5, i6, i7
         double precision C1g0ZFH

         if ((i5 > 2)) then
            sC1g0ZFH = C1g0ZFH(i1,i5,i3,i2,i4,i6,i7)
         else
            if ((i1 > 2).and.(i4 > 2)) then
               sC1g0ZFH = (C1g0ZFH(i1, i5,i3,i2, i4,i6,i7) 
     .                  +  C1g0ZFH(i4, i5,i3,i2, i1,i6,i7))/2d0
            else
               sC1g0ZFH = (C1g0ZFH(i1,i5, i3,i2, i4,i6,i7) 
     .                  +  C1g0ZFH(i1,i5, i2,i3, i4,i6,i7))/2d0
            endif
         endif
         return
      end function sC1g0ZFH

      double precision function sC1g0ZFHs0(i1,i5, i3,i2, i4,i6,i7)
         implicit none
         integer, intent(in) :: i1, i2, i3, i4, i5, i6, i7
         double precision C1g0ZFH

         sC1g0ZFHs0 = (C1g0ZFH(i1,i5, i3,i2, i4,i6,i7) 
     .              +  C1g0ZFH(i1,i5, i2,i3, i4,i6,i7))/2d0

      end function sC1g0ZFHs0

      !>
      !> Full version of sC1g0ZFH/sC1g0WFH
      !> (including s-channel)
      !>
      !>

      double precision function fC1g0ZFH(i1,i5,i3,i2,i4,i6,i7)
         use C1gVBF_mod
         implicit none
         integer, intent(in) :: i1, i2, i3, i4, i5, i6, i7
         double precision C1g0ZFH

         s_channel = .true.

         if ((i5 > 2)) then
            fC1g0ZFH = C1g0ZFH(i1,i5,i3,i2,i4,i6,i7)
         else
            if (any( (/i1,i4/) > 2 )) then
               fC1g0ZFH = (C1g0ZFH(i1, i5,i3,i2, i4,i6,i7) 
     .                  +  C1g0ZFH(i4, i5,i3,i2, i1,i6,i7))/2d0
            else
               fC1g0ZFH = (C1g0ZFH(i1,i5, i3,i2, i4,i6,i7) 
     .                  +  C1g0ZFH(i1,i5, i2,i3, i4,i6,i7))/2d0
            endif
         endif
         return
      end function fC1g0ZFH

      double precision function fC1g0WFH(i1,i5,i3,i2,i4,i6,i7)
         use C1gVBF_mod
         implicit none
         integer, intent(in) :: i1, i2, i3, i4, i5, i6, i7
         double precision C1g0WFH

         s_channel = .true.

         if ((i5 > 2)) then
            fC1g0WFH = C1g0WFH(i1,i5,i3,i2,i4,i6,i7)
         else
            if (any( (/i1,i4/) > 2 )) then
               fC1g0WFH = (C1g0WFH(i1, i5,i3,i2, i4,i6,i7) 
     .                  +  C1g0WFH(i4, i5,i3,i2, i1,i6,i7))/2d0
            else
               fC1g0WFH = (C1g0WFH(i1,i5, i3,i2, i4,i6,i7) 
     .                  +  C1g0WFH(i1,i5, i2,i3, i4,i6,i7))/2d0
            endif
         endif
         return
      end function fC1g0WFH

