      function Ch1g1VBF(i1,i5,i3,i2,i4,i6,i7,renscale2,iboson)
         use C1gVBF_mod
      use KinData_mod
      implicit complex(8) (z)
      implicit double precision (a-h, o-y)
      common/order/ieorder
      ! Spike testing
      integer si1, si2, si, sj, sg1, sg2, si7
      common /spiketesting/ si1,si2,si,sj,sg1,sg2,si7
      integer npars, nspec, n
      common /npars/npars,nspec,n
      if (si1.eq.0) then
         si1 = i1
         si2 = i2
         si = i4
         sj = i3
         sg1 = i5
         sg2 = 99
         si7 = 0
      endif

      ! bf*C1g0VBF

      if (ieorder == -1) then
         vc1 = 1d0/3d0
         vc2 = 1d0/3d0
      else
         Ch1g1VBF = 0d0
         return
      endif

      s1i = kin(nspec+5)%s(i1,i4)
      s1k = kin(nspec+5)%s(i1,i5)
      sik = kin(nspec+5)%s(i4,i5)

      s2j = kin(nspec+5)%s(i2,i3)
      s2k = kin(nspec+5)%s(i2,i5)
      sjk = kin(nspec+5)%s(i3,i5)

      q1 = sik + s1i + s1k
      q2 = sjk + s2j + s2k

      dls1ik = dlog(renscale2/dabs(q1))
      dls2jk = dlog(renscale2/dabs(q2))

      r1 = 0d0
      r2 = 0d0

      if(i5 > 2) then
          r1 = C1g0VBFs0(i1,i5,i3,i2,i4,i6,i7,iboson,.false.)
          r2 = C1g0VBFs0(i2,i5,i4,i1,i3,i6,i7,iboson,.true.)
      else
          if( (i1 < 3).or.(i4 < 3) ) then
            r2 = C1g0VBFs0(i2,i5,i4,i1,i3,i6,i7,iboson,.true.)
          else
            r1 = C1g0VBFs0(i1,i5,i3,i2,i4,i6,i7,iboson,.false.)
          endif
      endif

      r1 = r1*vc1
      r2 = r2*vc2

      Ch1g1VBF = r1 + r2
      return
      end function Ch1g1VBF

      double precision function Ch1g1WFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
      implicit none
      double precision Ch1g1VBF
      integer i1,i5,i3,i2,i4,i6,i7
      double precision renscale2

      Ch1g1WFH = Ch1g1VBF(i1,i5,i3,i2,i4,i6,i7,renscale2,1)

      return
      end function

      double precision function Ch1g1ZFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
      implicit none
      double precision Ch1g1VBF
      integer i1,i5,i3,i2,i4,i6,i7
      double precision renscale2

      Ch1g1ZFH = Ch1g1VBF(i1,i5,i3,i2,i4,i6,i7,renscale2,0)

      return
      end function

      !>
      !> Symmetrised versions of C1g1VFH over i2-i3
      !>
      double precision function sCh1g1WFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
         implicit none
         double precision Ch1g1WFH, renscale2
         integer i1,i5,i6,i3,i2,i4,i7
         
         if ((i5 > 2)) then
            sCh1g1WFH = Ch1g1WFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
         else
            if ((i1 > 2).and.(i4 > 2)) then
               sCh1g1WFH = (Ch1g1WFH(i1, i5,i3,i2, i4,i6,i7,renscale2) 
     .                  +  Ch1g1WFH(i4, i5,i3,i2, i1,i6,i7,renscale2))/2d0
            else
               sCh1g1WFH = (Ch1g1WFH(i1,i5, i3,i2, i4,i6,i7,renscale2) 
     .                  +  Ch1g1WFH(i1,i5, i2,i3, i4,i6,i7,renscale2))/2d0
            endif
         endif
         return
      end function sCh1g1WFH

      double precision function sCh1g1ZFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
         implicit none
         double precision Ch1g1ZFH, renscale2
         integer i1,i5,i6,i3,i2,i4,i7
         
         if ((i5 > 2)) then
            sCh1g1ZFH = Ch1g1ZFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
         else
            if ((i1 > 2).and.(i4 > 2)) then
               sCh1g1ZFH = (Ch1g1ZFH(i1, i5,i3,i2, i4,i6,i7,renscale2) 
     .                  +  Ch1g1ZFH(i4, i5,i3,i2, i1,i6,i7,renscale2))/2d0
            else
               sCh1g1ZFH = (Ch1g1ZFH(i1,i5, i3,i2, i4,i6,i7,renscale2) 
     .                  +  Ch1g1ZFH(i1,i5, i2,i3, i4,i6,i7,renscale2))/2d0
            endif
         endif
         return
      end function sCh1g1ZFH


