      function Ct1g1VBF(i1,i5,i3,i2,i4,i6,i7,renscale2,iboson)
      use KinData_mod
      use commonVBF_mod
      use C1gVBF_mod
      implicit complex(8) (z)
      implicit double precision (a-h, o-y)
      parameter (pi = 3.14159265358979d0)
      common /LR/ ele,ere,sin2w,enQ(-5:5),enL(5),enR(5)
      complex(8) zamp1(2,4), zamp2(2,4), zamp3(2,4), zamp4(2,4)
      double precision amp1(2,4), amp2(2,4), amp3(2,4), amp4(2,4)
      double precision glr1(4), glr2(4)
      integer npars, nspec, n
      common /npars/npars,nspec,n
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common/order/ieorder
      ! Spike testing
      integer si1, si2, si, sj, sg1, sg2, si7
      common /spiketesting/ si1,si2,si,sj,sg1,sg2,si7
      if (si1.eq.0) then
         si1 = i1
         si2 = i2
         si = i4
         sj = i3
         sg1 = i5
         sg2 = 99
         si7 = 0
      endif


      ! Real-Virtual subleading contribution
      !
      ! sum contribution from g (i5) emitted from both legs
      !
!
!        if((i6 < 6).or.(i7 < 6))then
!           print *, "Partons entered as photons @ Ct1g1VBF"
!           stop
!        endif
!
      zamp1(:,:) = (0d0,0d0)
      zamp2(:,:) = (0d0,0d0)
      zamp3(:,:) = (0d0,0d0)
      zamp4(:,:) = (0d0,0d0)
      amp1(:,:)  = 0d0
      amp2(:,:)  = 0d0
      amp3(:,:)  = 0d0
      amp4(:,:)  = 0d0
      rC1Tot   = 0d0
      rC2Tot   = 0d0
      rMcom1   = 0d0
      rMcom2   = 0d0

      s1i = kin(nspec+5)%s(i1,i4)
      s1k = kin(nspec+5)%s(i1,i5)
      sik = kin(nspec+5)%s(i4,i5)

      s2j = kin(nspec+5)%s(i2,i3)
      s2k = kin(nspec+5)%s(i2,i5)
      sjk = kin(nspec+5)%s(i3,i5)

      q1 = sik + s1i + s1k
      q2 = sjk + s2j + s2k

      call propagator_vbf(q1, s2j, iboson, rMcom1)
      call propagator_vbf(s1i, q2, iboson, rMcom2)
      call coupling_vbf(nfC1, nfC2, iboson, glr1)
      call coupling_vbf(nfC2, nfC1, iboson, glr2)

      dls1i = dlog(renscale2/dabs(s1i))
      dls2j = dlog(renscale2/dabs(s2j))
      pi2 = pi**2

      ! For gluon and loop in different legs
      ! Real-Virtual amplitude = vc*real amplitude
      if(ieorder.eq.-2)then
         vc1 = -1d0
         vc2 = -1d0
      elseif(ieorder.eq.-1)then
         vc1 = -3d0/2d0 - dls1i
         vc2 = -3d0/2d0 - dls2j
      elseif(ieorder.eq.0)then
         vc1 = (-3d0*dls1i  -8d0 + pi2/6d0 -dls1i**2)/2d0
         vc2 = (-3d0*dls2j  -8d0 + pi2/6d0 -dls2j**2)/2d0
      else
         print *, "ieorder in Ct1g1VBF.f is incorrect: ", ieorder
         stop
      endif

      if(i5 > 2)then
         ! Only if gluon is not a initial particle
         call C1g0VBF_vbf(i1,i5,i3,i2,i4,zamp1)
         call Ct1g1VBF_vbf(i1,i5,i3,i2,i4,renscale2,zamp3)
      else
         if( (i1 < 3).or.(i4 < 3) ) then
            rMcom1 = 0d0
         else
            rMcom2 = 0d0
            call C1g0VBF_vbf(i1,i5,i3,i2,i4,zamp1)
            call Ct1g1VBF_vbf(i1,i5,i3,i2,i4,renscale2,zamp3)
         end if
      endif

      call C1g0VBF_vbf(i2,i5,i4,i1,i3,zamp2)
      call Ct1g1VBF_vbf(i2,i5,i4,i1,i3,renscale2,zamp4)

      do i = 1,4
         zamp1(:,i) = zamp1(:,i)*glr1(i)
         zamp2(:,i) = zamp2(:,i)*glr2(i)
         zamp3(:,i) = zamp3(:,i)*glr1(i)
         zamp4(:,i) = zamp4(:,i)*glr2(i)
      enddo

      amp1 = vc2*abs(zamp1)**2
      amp2 = vc1*abs(zamp2)**2
      amp3 = real(zamp1*conjg(zamp3))
      amp4 = real(zamp2*conjg(zamp4))

      ! g from 1-i
      rC1Tot = rMcom1*(sum(amp1) + sum(amp3))
      ! g from 2-j
      rC2Tot = rMcom2*(sum(amp2) + sum(amp4))


      Ct1g1VBF = (rC1Tot + rC2Tot)

c        print *, Ct1g1VBFpoles(i1,i5,i3,i2,i4,i6,i7,renscale2,iboson)

      return
      end function

      function Ct1g1VBFpoles(i1,i5,i3,i2,i4,i6,i7,renscale2,iboson)
         use C1gVBF_mod
      use KinData_mod
      implicit complex(8) (z)
      implicit double precision (a-h, o-y)
      common/order/ieorder

      if(i5 < 3)then
         print *, "Pole check only for qq initiated"
         stop
      endif

      s1i = kin(nspec+5)%s(i1,i4)

      s2j = kin(nspec+5)%s(i2,i3)

      rloqq1 = C1g0VBFs0(i1,i5,i3,i2,i4,i6,i7, iboson, .false.)
      rloqq2 = C1g0VBFs0(i2,i5,i4,i1,i3,i6,i7, iboson, .true.)

      xpol1  = + xIqqone(s1i,renscale2,iboson)

      xpol2  = + xIqqone(s2j,renscale2,iboson)

      Ct1g1VBFpoles = 2d0*(xpol1*rloqq1 + xpol2*rloqq2)

      return
      end function

      double precision function Ct1g1WFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
      implicit none
      double precision Ct1g1VBF
      integer i1,i5,i3,i2,i4,i6,i7
      double precision renscale2

      Ct1g1WFH = Ct1g1VBF(i1,i5,i3,i2,i4,i6,i7,renscale2,1)

      return
      end function

      double precision function Ct1g1ZFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
      implicit none
      double precision Ct1g1VBF
      integer i1,i5,i3,i2,i4,i6,i7
      double precision renscale2

      Ct1g1ZFH = Ct1g1VBF(i1,i5,i3,i2,i4,i6,i7,renscale2,0)

      return
      end function

      !>
      !> Symmetrised versions of Ch1g1VFH over i2-i3
      !>
      double precision function sCt1g1WFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
         implicit none
         double precision Ct1g1WFH, renscale2
         integer i1,i5,i6,i3,i2,i4,i7
         
         if ((i5 > 2)) then
            sCt1g1WFH = Ct1g1WFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
         else
            if ((i1 > 2).and.(i4 > 2)) then
               sCt1g1WFH = (Ct1g1WFH(i1, i5,i3,i2, i4,i6,i7,renscale2) 
     .                  +  Ct1g1WFH(i4, i5,i3,i2, i1,i6,i7,renscale2))/2d0
            else
               sCt1g1WFH = (Ct1g1WFH(i1,i5, i3,i2, i4,i6,i7,renscale2) 
     .                  +  Ct1g1WFH(i1,i5, i2,i3, i4,i6,i7,renscale2))/2d0
            endif
         endif
         return
      end function sCt1g1WFH

      double precision function sCt1g1ZFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
         implicit none
         double precision Ct1g1ZFH, renscale2
         integer i1,i5,i6,i3,i2,i4,i7
         
         if ((i5 > 2)) then
            sCt1g1ZFH = Ct1g1ZFH(i1,i5,i3,i2,i4,i6,i7,renscale2)
         else
            if ((i1 > 2).and.(i4 > 2)) then
               sCt1g1ZFH = (Ct1g1ZFH(i1, i5,i3,i2, i4,i6,i7,renscale2) 
     .                  +  Ct1g1ZFH(i4, i5,i3,i2, i1,i6,i7,renscale2))/2d0
            else
               sCt1g1ZFH = (Ct1g1ZFH(i1,i5, i3,i2, i4,i6,i7,renscale2) 
     .                  +  Ct1g1ZFH(i1,i5, i2,i3, i4,i6,i7,renscale2))/2d0
            endif
         endif
         return
      end function sCt1g1ZFH



