      double precision function Ct2g0VBF(i1,i5,i6,i3,i2,i4,i7,i8,iboson)
      ! Gluons: i5, i6
      use KinData_mod
      use commonVBF_mod
      use C2gVBF_mod
      implicit none
      integer, intent(in) :: i1, i5, i6, i3, i2, i4, i7, i8, iboson
      double precision :: glr(4), amp1(4,4), amp2(4,4),
     .                   ampNadj1(4,4), ampNadj2(4,4),
     .                    s1k, s1l, s1i, s2j, s2k, s2l, pN1, pN2,
     .                    sik, sil, skl, sjk, sjl, q1, q2, qN1, qN2,
     .                    rMcom1, rMcom2, rMcomNadj1, rMcomNadj2,
     .                    rM1Tot, rM2Tot, rMnadj1, rMnadj2
      double complex :: zamp1(4,4), zamp2(4,4), zamp3(4,4), zamp4(4,4),
     .               zampNadj1(4,4), zampNadj2(4,4)
      logical :: leg1, leg2, flagDouble
      integer :: i
      double precision :: ele, ere, sin2w, enq, enL, enR
      common/LR/ele,ere,sin2w,enq(-5:5),enL(5),enR(5)
      integer npars, nspec, n
      common /npars/npars,nspec,n
      integer :: nfC1, nfC2
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      integer si1, si2, si, sj, sg1, sg2, si7
      common /spiketesting/ si1,si2,si,sj,sg1,sg2,si7
      if (si1.eq.0) then
         si1 = i1
         si2 = i2
         si = i4
         sj = i3
         sg1 = i5
         sg2 = i6
         si7 = -1
      endif

      !
      ! Sums the following contributions:
      ! (i1 - (i5 - i6) - i4, i2-i3)^2
      ! (i1-i3, i2 - (i5 - i6) - i3)^2
      !
      ! Subleading Color contribution
      ! (crossing of gluons emitted from the same leg)

      zamp1(:,:) = (0d0,0d0)
      zamp2(:,:) = (0d0,0d0)
      zamp3(:,:) = (0d0,0d0)
      zamp4(:,:) = (0d0,0d0)
      zampNadj1(:,:) = (0d0,0d0)
      zampNadj2(:,:) = (0d0,0d0)
      glr(:)     =  0d0
      amp1(:,:)  =  0d0
      amp2(:,:)  =  0d0
      ampNadj1(:,:)  =  0d0
      ampNadj2(:,:)  =  0d0
      rMnadj1     =  0d0
      rMnadj2     =  0d0
      leg1 = .true.
      leg2 = .true.
      flagDouble = .false.

      s1k = kin(nspec+6)%s(i1,i5)
      s1l = kin(nspec+6)%s(i1,i6)
      s1i = kin(nspec+6)%s(i1,i4)
      sik = kin(nspec+6)%s(i4,i5)
      sil = kin(nspec+6)%s(i4,i6)

      skl = kin(nspec+6)%s(i5,i6)

      s2j = kin(nspec+6)%s(i2,i3)
      s2k = kin(nspec+6)%s(i2,i5)
      s2l = kin(nspec+6)%s(i2,i6)
      sjk = kin(nspec+6)%s(i3,i5)
      sjl = kin(nspec+6)%s(i3,i6)

      ! Couplings
      call coupling_vbf(nfC1, nfC2, iboson, glr)

      !> One gluon in each leg
      if ( (i5 < 3).and.(i6 < 3) ) then ! gg initiated
         qN1 = s1k + s1i + sik
         qN2 = s2l + s2j + sjl
         call C2g0VBFnadj_vbf(i1,i5,i3,i2,i6,i4,zampNadj1)
         pN1 = s1l + s1i + sil
         pN2 = s2k + s2j + sjk
         call C2g0VBFnadj_vbf(i1,i6,i3,i2,i5,i4,zampNadj2)
         leg1 = .false.
         leg2 = .false.
         if (iboson /= 0) flagDouble = .true.
      elseif ( (i5 < 3).and.(i6 >= 3) ) then 
         ! qg or gq initiated
         ! Make sure we don't cross the wrong gluon
         if( (i1 < 3).or.(i4 < 3) ) then
            qN1 = s1l + s1i + sil
            qN2 = s2k + s2j + sjk
            call C2g0VBFnadj_vbf(i1,i6,i3,i2,i5,i4,zampNadj1)
            leg1 = .false.
         else
            qN1 = s1k + s1i + sik
            qN2 = s2l + s2j + sjl
            call C2g0VBFnadj_vbf(i1,i5,i3,i2,i6,i4,zampNadj1)
            leg2 = .false.
         endif
      elseif ( (i6 < 3).and.(i5 >= 3) ) then ! qg or gq initiated
         ! (non-adjacent piece already computed for the i5-i6 ordering)
         if( (i1 < 3).or.(i4 < 3) ) then
            leg1 = .false.
         else
            leg2 = .false.
         endif
      else ! qQ initiated
         qN1 = s1k + s1i + sik
         qN2 = s2l + s2j + sjl
         call C2g0VBFnadj_vbf(i1,i5,i3,i2,i6,i4,zampNadj1)
         pN1 = s1l + s1i + sil
         pN2 = s2k + s2j + sjk
         call C2g0VBFnadj_vbf(i1,i6,i3,i2,i5,i4,zampNadj2)
      endif
      ! Propagator
      call propagator_vbf(qN1, qN2, iboson, rMcomNadj1)
      if (leg1.eqv.leg2) then
         call propagator_vbf(pN1, pN2, iboson, rMcomNadj2)
      else
         rMcomNadj2 = 0d0
      endif
      if (flagDouble) then
         rMcomNadj1 = 2d0*rMcomNadj1
         rMcomNadj2 = 2d0*rMcomNadj2
      endif

      !> Both gluons in the same leg
      ! Both gluons between 1 and i
      if(leg1) then
         call C2g0VBFadj_vbf(i1,i5,i6,i3,i2,i4, zamp1)
         call C2g0VBFadj_vbf(i1,i6,i5,i3,i2,i4, zamp3)
         call joinAmplCt2g(zamp1,zamp3)
      endif

      ! Both gluons between 2 and j
      if(leg2) then
         call C2g0VBFadj_vbf(i2,i5,i6,i4,i1,i3, zamp2)
         call C2g0VBFadj_vbf(i2,i6,i5,i4,i1,i3, zamp4)
         call joinAmplCt2g(zamp2,zamp4)
      endif

      ! Propagator
      q1  = s1k + s1l + s1i + skl + sik + sil
      q2  = s2l + s2k + s2j + skl + sjk + sjl
      call propagator_vbf(q1, s2j, iboson, rMcom1)
      call propagator_vbf(s1i, q2, iboson, rMcom2)

      do i = 1,4
         amp1(:,i) = abs(zamp1(:,i)*glr(i))**2
         amp2(:,i) = abs(zamp2(:,i)*glr(i))**2
         ampNadj1(:,i) = abs(zampNadj1(:,i)*glr(i))**2
         if (leg1.eqv.leg2) then
            ampNadj2(:,i) = abs(zampNadj2(:,i)*glr(i))**2
         endif
      enddo

      rM1Tot = 2d0*rMcom1*sum(amp1)
      rM2Tot = 2d0*rMcom2*sum(amp2)
      rMNadj1 = 2d0*rMcomNadj1*sum(ampNadj1)
      if (leg1.eqv.leg2) then
         rMNadj2 = 2d0*rMcomNadj2*sum(ampNadj2)
      endif

      Ct2g0VBF = rM1Tot + rM2Tot
      Ct2g0VBF = Ct2g0VBF + rMNadj1 + rMnadj2

      return
      end function

      subroutine joinAmplCt2g(z1,z2)
      use KinData_mod
      complex(8) z1(16),z2(16)

      z1( 1) = z1( 1) + z2( 1)
      z1( 4) = z1( 4) + z2( 4)
      z1( 5) = z1( 5) + z2( 5)
      z1( 8) = z1( 8) + z2( 8)
      z1( 9) = z1( 9) + z2( 9)
      z1(12) = z1(12) + z2(12)
      z1(13) = z1(13) + z2(13)
      z1(16) = z1(16) + z2(16)

      z1( 2) = z1( 2) - z2( 3)
      z1( 3) = z1( 3) - z2( 2)
      z1( 6) = z1( 6) - z2( 7)
      z1( 7) = z1( 7) - z2( 6)
      z1(10) = z1(10) - z2(11)
      z1(11) = z1(11) - z2(10)
      z1(14) = z1(14) - z2(15)
      z1(15) = z1(15) - z2(14)

      return
      end subroutine

      double precision function Ct2g0WFH(i1,i5,i6,i3,i2,i4,i7,i8)
      implicit none
      double precision Ct2g0VBF
      integer i1,i5,i6,i3,i2,i4,i7,i8

      Ct2g0WFH = Ct2g0VBF(i1,i5,i6,i3,i2,i4,i7,i8,1)

      return
      end function

      double precision function Ct2g0ZFH(i1,i5,i6,i3,i2,i4,i7,i8)
      implicit none
      double precision Ct2g0VBF
      integer i1,i5,i6,i3,i2,i4,i7,i8

      Ct2g0ZFH = Ct2g0VBF(i1,i5,i6,i3,i2,i4,i7,i8,0)

      return
      end function

      !>
      !> Symmetrised version of Ct2g0VFH over i2-i3
      !>
      double precision function sCt2g0WFH(i1,i5,i6,i3,i2,i4,i7,i8)
         implicit none
         double precision Ct2g0WFH
         integer i1,i5,i6,i3,i2,i4,i7,i8
         
         if ((i5 > 2).and.(i6 > 2)) then
            sCt2g0WFH = Ct2g0WFH(i1,i5,i6,i3,i2,i4,i7,i8)
         elseif ((i5 < 3).and.(i6 < 3)) then
            sCt2g0WFH = Ct2g0WFH(i1,i5,i6,i3,i2,i4,i7,i8)
         else
            if ((i1 > 2).and.(i4 > 2)) then
               sCt2g0WFH = (Ct2g0WFH(i1, i5,i6,i3,i2, i4,i7,i8) 
     .                  +   Ct2g0WFH(i4, i5,i6,i3,i2, i1,i7,i8))/2d0
            else
               sCt2g0WFH = (Ct2g0WFH(i1,i5,i6, i3,i2, i4,i7,i8) 
     .                  +   Ct2g0WFH(i1,i5,i6, i2,i3, i4,i7,i8))/2d0
            endif
         endif
         return
      end function sCt2g0WFH

      double precision function sCt2g0ZFH(i1,i5,i6,i3,i2,i4,i7,i8)
         implicit none
         double precision Ct2g0ZFH
         integer i1,i5,i6,i3,i2,i4,i7,i8
         
         if ((i5 > 2).and.(i6 > 2)) then
            sCt2g0ZFH = Ct2g0ZFH(i1,i5,i6,i3,i2,i4,i7,i8)
         elseif ((i5 < 3).and.(i6 < 3)) then
            sCt2g0ZFH = Ct2g0ZFH(i1,i5,i6,i3,i2,i4,i7,i8)
         else
            if ((i1 > 2).and.(i4 > 2)) then
               sCt2g0ZFH = (Ct2g0ZFH(i1, i5,i6,i3,i2, i4,i7,i8) 
     .                  +   Ct2g0ZFH(i4, i5,i6,i3,i2, i1,i7,i8))/2d0
            else
               sCt2g0ZFH = (Ct2g0ZFH(i1,i5,i6, i3,i2, i4,i7,i8) 
     .                  +   Ct2g0ZFH(i1,i5,i6, i2,i3, i4,i7,i8))/2d0
            endif
         endif
         return
      end function sCt2g0ZFH
