      function D1g0VBF(i1,i5,i3,i2,i4,i6,i7,iboson)
      implicit double precision (a-h, o-y)
      ! Spike Testing
!        integer is
!        common /spiketesting/is
!        is = i5
!        if( (i1 > 2) .and. (i2 > 2) .and. (i5 < 3) ) is = -i5
      !
      ! q(i1) + q(i2) ----> q(i3) q(i4) + g(i5) + H(i6,i7)
      !

      r1 = 0d0
      r2 = 0d0

      ! For gluon initiated:
      ! Base sit       i3
      !               /
      !              /
      ! i5 ccccccccc-------- i2
      ! i1 ----------------- i4
      !

      if(i5 > 2) then
         r1 = D1g0VBFs0(i1,i5,i3,i2,i4,i6,i7,iboson)
         r2 = D1g0VBFs0(i2,i5,i4,i1,i3,i6,i7,iboson)
      else
          if( (i1 < 3).or.(i4 < 3) ) then
            r2 = D1g0VBFs0(i2,i5,i4,i1,i3,i6,i7,iboson)
          else
            r1 = D1g0VBFs0(i1,i5,i3,i2,i4,i6,i7,iboson)
          endif
      endif

      D1g0VBF = r1 + r2

      return
      end

      !!!!!!!!

      function D1g0VBFs0(i1,i5,i3,i2,i4,i6,i7,iboson)
      use KinData_mod
      use commonVBF_mod
      use C1gVBF_mod
      implicit double complex (z)
      implicit double precision (a-h, o-y)
      !
      ! q(i1) + q(i2) ----> q(i3) q(i4) + g(i5) + H(i6,i7,iboson)
      !
      ! D1g0 = C1g0((i1,i5,i4);(i2,i3)) * (C1g0((i1,i5,i3);(i2,i4)) + C1g0((i1,i3);(i2,i5,i4)))
      !
      double precision glr(4), amp1(2,4), amp2(2,4)
      double complex zamp0(2,4), zamp1(2,4), zamp2(2,4)
      ! Common Blocks
      common /LR/ ele,ere,sin2w,enQ(-5:5),enL(5),enR(5)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /Zmass/ emz, ezwidth
      integer npars, nspec, n
      common /npars/npars,nspec,n

      if((i6 < 6).or.(i7 < 6))then
         print *, "Partons entered as photons @ D1g0VBF"
         stop
      endif

      s1i =  kin(nspec+5)%s(i1,i4)
      s1k =  kin(nspec+5)%s(i1,i5)
      sik =  kin(nspec+5)%s(i4,i5)
      s2j =  kin(nspec+5)%s(i2,i3)
      s1j =  kin(nspec+5)%s(i1,i3)
      sjk =  kin(nspec+5)%s(i3,i5)
      s2i =  kin(nspec+5)%s(i2,i4)
      s2k =  kin(nspec+5)%s(i2,i5)

      q0  =  s1k + sik + s1i
      q1  =  s1k + sjk + s1j
      q2  =  s2k + sik + s2i

      call mix_propagator_vbf(q0, s2j, q1, s2i, iboson, rMcom1)
      call mix_propagator_vbf(q0, s2j, q2, s1j, iboson, rMcom2)

      call coupling_vbf(nfC2, nfC1, iboson, glr)

      zamp0(:,:) =  0d0
      zamp1(:,:) =  0d0
      zamp2(:,:) =  0d0
      amp1 (:,:) =  0d0
      amp2 (:,:) =  0d0

      call C1g0VBF_vbf(i1,i5,i3,i2,i4,zamp0)
      call C1g0VBF_vbf(i1,i5,i4,i2,i3,zamp1)
      call C1g0VBF_vbf(i2,i5,i3,i1,i4,zamp2)

      amp1(:, 1) = -glr(1)**2*dreal(zamp0(:,1)*dconjg(zamp1(:,1)))
      amp2(:, 1) = -glr(1)**2*dreal(zamp0(:,1)*dconjg(zamp2(:,1)))
      amp1(:, 4) = -glr(4)**2*dreal(zamp0(:,4)*dconjg(zamp1(:,4)))
      amp2(:, 4) = -glr(4)**2*dreal(zamp0(:,4)*dconjg(zamp2(:,4)))

      D1g0VBFs0 = rMcom1*sum(amp1) + rMcom2*sum(amp2)

      return
      end function

      subroutine mix_propagator_vbf(q1, s1, q2, s2, iboson, rMcom)
         use commonVBF_mod
         implicit none
         double precision, intent(in) :: q1, s1, q2, s2
         integer, intent(in) :: iboson
         double precision, intent(out) :: rMcom
         complex(8) :: prop1, prop2
         call c_propagator_vbf(q1, s1, iboson, prop1)
         call c_propagator_vbf(q2, s2, iboson, prop2)

         rMcom = prop1 * dconjg(prop2)
         return
      end subroutine


      double precision function D1g0WFH(i1,i5,i3,i2,i4,i6,i7)
      implicit none
      double precision D1g0VBF
      integer i1,i5,i3,i2,i4,i6,i7

      D1g0WFH = 0d0! D1g0VBF(i1,i5,i3,i2,i4,i6,i7,1)

      return
      end

      double precision function D1g0ZFH(i1,i5,i3,i2,i4,i6,i7)
      implicit none
      double precision D1g0VBF
      integer i1,i5,i3,i2,i4,i6,i7

      D1g0ZFH = D1g0VBF(i1,i5,i3,i2,i4,i6,i7,0)

      return
      end
