************************************************************************
!XC the Branch Ratio for Higgs to di-gamma is taken from eq 2.45 of hep-ph/0503172:
!  A.~Djouadi,
!  %``The Anatomy of electro-weak symmetry breaking. I: The Higgs boson in the standard model,''
!  Phys.\ Rept.\  {\bf 457} (2008) 1
!  doi:10.1016/j.physrep.2007.10.004
!  [hep-ph/0503172].

!XC The actual value from eq 2.45 of hep-ph/0503172 is checked against 1508.02684:
!  F.~Caola, K.~Melnikov and M.~Schulze,
!  %``Fiducial cross sections for Higgs boson production in association with a jet at next-to-next-to-leading order in QCD,''
!  Phys.\ Rev.\ D {\bf 92} (2015) no.7,  074032
!  doi:10.1103/PhysRevD.92.074032
!  [arXiv:1508.02684 [hep-ph]].
************************************************************************
*XC link inclusive VFH production ME with 2 decay particles
************************************************************************
************************All tree ME*************************************
************************************************************************
      function C0g0ZFH2(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C0g0ZFH2=C0g0ZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function C0g0WFH2(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C0g0WFH2=C0g0WFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function sC0g0WFH2(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC0g0WFH2=sC0g0WFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function sC0g0ZFH2(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC0g0ZFH2=sC0g0ZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function D0g0ZFH2(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      D0g0ZFH2=D0g0ZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function D0g0WZFH2(i1,i2,i3,i4,i5,i6)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      D0g0WZFH2=D0g0WZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function C1g0ZFH2(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C1g0ZFH2=C1g0ZFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C1g0WFH2(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C1g0WFH2=C1g0WFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function D1g0ZFH2(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      D1g0ZFH2=D1g0ZFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function D1g0WFH2(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      D1g0WFH2=D1g0WFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C1g0ZFH2s1(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C1g0ZFH2s1=C1g0ZFHs1(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C1g0WFH2s1(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C1g0WFH2s1=C1g0WFHs1(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0WFH2(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC1g0WFH2=sC1g0WFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0WFH2s0(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC1g0WFH2s0=sC1g0WFHs0(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0ZFH2(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC1g0ZFH2=sC1g0ZFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0ZFH2s0(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC1g0ZFH2s0=sC1g0ZFHs0(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C2g0WFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C2g0WFH2=C2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function C2g0ZFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C2g0ZFH2=C2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sC2g0ZFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC2g0ZFH2=sC2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sC2g0WFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC2g0WFH2=sC2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sCt2g0ZFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sCt2g0ZFH2=sCt2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sCt2g0WFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sCt2g0WFH2=sCt2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function Ct2g0WFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ct2g0WFH2=Ct2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function Ct2g0ZFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ct2g0ZFH2=Ct2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function E0g0ZFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      E0g0ZFH2=E0g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function E0g0WFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      E0g0WFH2=E0g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function F0g0ZFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      F0g0ZFH2=F0g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function F0g0WFH2(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      F0g0WFH2=F0g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
*      function D2g0ZFH2(i1,i2,i3,i4,i5,i6,i7,i8)
*      use Process_mod, only : name_proc
*      use KinData_mod
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*
*      ipset=8
*
*      select case ( name_proc )
*      case('VFHTO2P','VFHTO2PJ')
*        decayME=2.35d-3
*      case('VFHTO2TAU','VFHTO2TAUJ')
*        decayME=Htautau(i7,i8,ipset)
*      case default
*         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
*         stop
*      end select
*
*      D2g0ZFH2=D2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME
*
*      return
*      end

************************************************************************
*      function D2g0WFH2(i1,i2,i3,i4,i5,i6,i7,i8)
*      use Process_mod, only : name_proc
*      use KinData_mod
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*
*      ipset=8
*
*      select case ( name_proc )
*      case('VFHTO2P','VFHTO2PJ')
*        decayME=2.35d-3
*      case('VFHTO2TAU','VFHTO2TAUJ')
*        decayME=Htautau(i7,i8,ipset)
*      case default
*         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
*         stop
*      end select
*
*      D2g0WFH2=D2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME
*
*      return
*      end



************************************************************************
**********************All 1-loop ME*************************************
************************************************************************
      function C0g1ZFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C0g1ZFH2=C0g1ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function C0g1WFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C0g1WFH2=C0g1WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function fC0g1ZFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      fC0g1ZFH2=fC0g1ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function fC0g1WFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      fC0g1WFH2=fC0g1WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function sC0g1ZFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC0g1ZFH2=sC0g1ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function sC0g1WFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC0g1WFH2=sC0g1WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function sC1g1ZFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC1g1ZFH2=sC1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sC1g1WFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sC1g1WFH2=sC1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function C1g1ZFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C1g1ZFH2=C1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function C1g1WFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C1g1WFH2=C1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCt1g1ZFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sCt1g1ZFH2=sCt1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCt1g1WFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sCt1g1WFH2=sCt1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ct1g1ZFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ct1g1ZFH2=Ct1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ct1g1WFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ct1g1WFH2=Ct1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCh1g1ZFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sCh1g1ZFH2=sCh1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCh1g1WFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      sCh1g1WFH2=sCh1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ch1g1WFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ch1g1WFH2=Ch1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ch1g1ZFH2(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ch1g1ZFH2=Ch1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end






************************************************************************
****************All 2-loop amplitudes***********************************
************************************************************************
      function C0g2ZFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C0g2ZFH2=C0g2ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function C0g2WFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      C0g2WFH2=C0g2WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ct0g2ZFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ct0g2ZFH2=Ct0g2ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ct0g2WFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ct0g2WFH2=Ct0g2WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ch0g2ZFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ch0g2ZFH2=Ch0g2ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ch0g2WFH2(i1,i2,i3,i4,i5,i6,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=6

      select case ( name_proc )
      case('VFHTO2P','VFHTO2PJ')
        decayME=2.35d-3
      case('VFHTO2TAU','VFHTO2TAUJ')
        decayME=Htautau(i5,i6,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH2.f: ", name_proc
         stop
      end select

      Ch0g2WFH2=Ch0g2WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end


