****************************************************************
* quark pair tree level matrix elements for q + Qb -> W+ -> nu + e+
*
*
* summed over colour orderings, summed and squared
*
*                    q(1) Qb(2) nu(3) e+(4)
*
* If the overall charge of the process is negative then the momenta of the electron
* and neutrino are reversed.
*

      function FullB0g0W(i1,i2,i3,i4)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /proc/ isub(7)
      common /eweakW/ amz,stw,ewfac
!$omp threadprivate(/eweakW/)

      if((amz.eq.0).or.(stw.eq.0))then
         call initeweak
      endif

      fac = 0.25d0/nc**2 ! aveqq

      fac=fac*(4d0*pi*amz/stw)**2*nc

      FullB0g0W = fac*B0g0W(i1,i2,i3,i4)

c     write(*,*) FullB0g0W,i1,i2,i3,i4

      return
      end

****************************************************************
* quark pair tree level matrix elements for q + Qb -> W+ -> nu + e+
*
*
* summed over colour orderings, summed and squared
*
*                    q(1) Qb(2) nu(3) e+(4)
*
* Excluding overall factors
*
* If the overall charge of the process is negative then the momenta of the electron
* and neutrino are reversed.
*


      function B0g0W(i1,i2,i3,i4)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /eweakW/ amz,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /BWFlav/nf1,nf2
!$omp threadprivate(/BWFlav/)

      s = s4(i3,i4)
      u = s4(i1,i4)

      call eweakW1qq(nf1,nf2,s)

      B0g0W = (u/s)**2

      B0g0W = ewfac*B0g0W

      return
      end

************************************************************************
