****************************************************************
* quark pair tree level matrix elements for q + Qb -> g + W+ -> nu + e+
*
*
* summed over colour orderings, summed and squared
*
* q(i1) + Qb(i3) -> g(i2) + W+ -> g(i2) + nu(i4) + e+(i5)
*
* If the overall charge of the process is negative then the momenta of the electron
* and neutrino are reversed.
*
* Including overall factors
*

      function FullB1g0W(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /proc/ isub(7)
      common /eweakW/ amz,stw,ewfac
!$omp threadprivate(/eweakW/)

      if((amz.eq.0).or.(stw.eq.0))then
         call initeweak
      endif

      fac = get_avg(i1,i3)

      fac = fac*((nc**2 - 1)*((4d0*pi*amz/stw)**2)*4d0*pi*as)

      FullB1g0W = fac*B1g0W(i1,i2,i3,i4,i5)

c     write(*,*) "FullB1g0W",FullB1g0W,i1,i2,i3,i4,i5

      return
      end

****************************************************************
* quark pair tree level matrix elements for q + Qb -> g + W+ -> nu + e+
*
*
* summed over colour orderings, summed and squared
*
* q(i1) + Qb(i3) -> g(i2) + W+ -> g(i2) + nu(i4) + e+(i5)
*
* If the overall charge of the process is negative then the momenta of the electron
* and neutrino are reversed.
*
* Excluding overall factors
*

      function B1g0W(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      double complex zamps(4)
      parameter(pi=3.141592653589793238d0)
      double precision B1g0Zvec(4)
      common /eweakW/ amz,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /BWFlav/nf1,nf2
!$omp threadprivate(/BWFlav/)

      nf1=1
      nf2=1
      za34 = zA5(i3,i4)

      za14 = zA5(i1,i4)
      za32 = zA5(i3,i2)
      za31 = zA5(i3,i1)
      zb51 = zB5(i5,i1)
      zb52 = zB5(i5,i2)

      zb51 = zB5(i5,i1)
      zb12 = zB5(i1,i2)
      zb32 = zB5(i3,i2)
      za34 = zA5(i3,i4)
      zb31 = zB5(i3,i1)
      za42 = zA5(i4,i2)
      zb12 = zB5(i1,i2)

      za12 = zA5(i1,i2)

      s45 = s5(i4,i5)

      call eweakW1qq(nf1,nf2,s45)

      zamps(1) = za34/za12/za32*(za31*zb51+za32*zb52)
      zamps(2) = zb51/zb12/zb32*(za34*zb31+za42*zb12)

      B1g0W = (abs(zamps(1))**2+abs(zamps(2))**2)/s45**2

      B1g0W = ewfac*B1g0W

      return
      end

************************************************************************



