***********************************************************************
*
* Quark pair one loop level virtual correction matrix element for
*
* q(i1) + Qb(i4) -> g(i2) + g(i3) + W+ -> g(i2) + nu(i4) + e+(i5)
*
* summed and squared over helicities, single colour ordering without
* overall factors and subleading colour
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BWFlav/

      function Bhh2g1W(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      use B2gZ
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /eweakW/ amz,stw,ewfac
!$omp threadprivate(/eweakW/)
      common /order/iorder
      common /koppel/ nf,nc,b0
      common /BWFlav/nf1,nf2
!$omp threadprivate(/BWFlav/)
      double complex zampTree(2,2),zampqgqbg(2,2)

      Bhh2g1W = 0d0

      s= s6(i5,i6)

      zampqgqbg = 0d0

      call eweakW1qq(nf1,nf2,s)

      call swapzAB_kin(6)
      zampqgqbg = zampBt2g1Z(i4,i3,i2,i1,i6,i5,renscale2)
     .     +Transpose(zampBt2g1Z(i4,i2,i3,i1,i6,i5,renscale2))
      call swapzAB_kin(6)

      zampTree = zampB2g0Z(i1,i2,i3,i4,i5,i6)
     .     +Transpose(zampB2g0Z(i1,i3,i2,i4,i5,i6))


      do ii=1,2
         do jj=1,2
            Bhh2g1W = Bhh2g1W
     .           +dble(Dconjg(zampTree(ii,jj))*zampqgqbg(ii,jj))
         enddo
      enddo

      Bhh2g1W = ewfac*Bhh2g1W

      if (iorder.eq.0)then
         e0 = -pi**2/12d0 ! pi**2/12 factor from C_gamma expansion
         Bhh2g1W = Bhh2g1W - e0*Bt2g0W(i1,i2,i3,i4,i5,i6)
      endif

      return
      end

