***********************************************************************
*
* Quark pair one loop level virtual correction subleading colour matrix element for
*
* q(1) qb(3) -> g(2) e+(4) e-(5)
*
* summed and squared over helicities, single colour ordering without
* overall factors
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function Bt1g1W(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      use B1gZ, only : zampBt1g1Z
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      double precision Bt1g1Zvec(4)
      parameter(pi=3.141592653589793238d0)
      common /order/iorder
      common /koppel/ nf,nc,b0
      common /BWFlav/nf1,nf2
!$omp threadprivate(/BWFlav/)
      double complex zamp(4)
      common /eweakW/ amz,stw,ewfac
!$omp threadprivate(/eweakW/)

      zamp = zampBt1g1Z(i1,i2,i3,i5,i4,renscale2)
      Bt1g1W=dble(dconjg(zamp(1))*zamp(2))+dble(dconjg(zamp(3))*zamp(4))

      s = s5(i4,i5)

      call eweakW1qq(nf1,nf2,s)

      Bt1g1W = ewfac*Bt1g1W

      if(iorder.eq.0)then
         e0 =  -pi**2/12d0 + 0.5d0 ! pi**2/12 factor from C_gamma expansion
         Bt1g1W = Bt1g1W-e0*B1g0W(i1,i2,i3,i4,i5)
      endif

      return
      end


********************************************************************
