****************************************************
* quark pair one loop matrix elements for q + qbar --> e^- + e^+
*
*
* summed over colour orderings, summed and squared
*
*                    q(1) qbar(2) e-(3) e+(4)
*

      function FullB0g1Z(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /proc/ isub(7)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)

      fac = 0.25d0/nc**2

      fac=fac*(4d0*(4d0*pi*amz)**2)*(nc**2-1d0)*(as/(2d0*pi))

      FullB0g1Z = fac*B0g1Z(i1,i2,i3,i4,renscale2)

c      write(*,*) "FullB0g0Z",FullB0g0Z,i1,i2,i3,i4

      return
      end

****************************************************
* quark pair one loop matrix elements for q + qbar --> e^- + e^+
*
*
* summed over colour orderings and squared. Ignoring overall factors
*
*                    q(1) qbar(2) e-(3) e+(4)
*

      function B0g1Z(i1,i2,i3,i4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /order/iorder
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nf0g
!$omp threadprivate(/BZFlav/)
      parameter(pi=3.141592653589793238d0)

      s = s4(i1,i2)

      dlogs = log(abs(s/renscale2))

      e2 = -1d0
      e1 = -3/2d0
      e0 = -8d0/2d0
c     Difference between s>0 (DY) and s<0 (DIS)
      if (s.ge.0d0) e0 = e0+pi**2/2d0
      e0 = e0 + pi**2/12d0 ! Correction for C(e)
      if (iorder .eq. -2) then
         B0g1Z = e2*B0g0Z(i1,i2,i3,i4)
      elseif (iorder .eq. -1) then
         B0g1Z = (-e2*dlogs + e1)*B0g0Z(i1,i2,i3,i4)
      elseif (iorder .eq. 0) then
         B0g1Z = (((1d0/2d0)*dlogs**2*e2) - (e1*dlogs) + e0)*B0g0Z(i1,i2,i3,i4)
      endif

      return
      end

      function sB0g1Z(i1,i2,i3,i4,renscale2)
      implicit double precision (a-h,o-y)

      sB0g1Z=0.5d0*(B0g1Z(i2,i1,i3,i4,renscale2)+B0g1Z(i1,i2,i3,i4,renscale2))
      return
      end
************************************************************************
