***********************************************************************
*
* Quark pair one loop level virtual correction matrix element for
*
* q(i1) qb(i4) -> g(i2) g(i3) e+(i5) e-(i6)
*
* summed and squared over helicities, summed over all colour orderings and all colour levels
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function FullB2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /BZFlav/nf2g
!$omp threadprivate(/BZFlav/)

      fac = get_avg(i1,i4)

      fac = fac*8d0*(4d0*pi*as)**2*(4d0*pi*amz)**2*(nc**2-1d0)/(2d0*nc)*as/(2*pi)*nc**3

      FullB2g1Z = 0d0

      if((i2.le.2).and.(i3.le.2))then ! gg initial state configuration, nf type contribution
         nup = 2
         ndo = 3

         nf2g = 2 ! Up type contribution

         FullB2g1Z = nup*(B2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .           +B2g1Z(i1,i3,i2,i4,i5,i6,renscale2)
     .           -(1d0/nc**2)*(Bt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                        +Bt2g1Z(i1,i3,i2,i4,i5,i6,renscale2)
     .                        +Btt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                        -Bhh2g1Z(i1,i2,i3,i4,i5,i6,renscale2))
     .           +(1d0/nc**4)*Bttt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .           +(dble(nf)/nc)*(Bh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                          +Bh2g1Z(i1,i3,i2,i4,i5,i6,renscale2))
     .           -(dble(nf)/nc**3)*Bth2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .           -(1d0/nc)*(B2g1Ztop(i1,i2,i3,i4,i5,i6,renscale2)
     .                     +B2g1Ztop(i1,i3,i2,i4,i5,i6,renscale2))
     .           +(1d0/nc**3)*Bt2g1Ztop(i1,i2,i3,i4,i5,i6,renscale2))

         ! Vector contribution
         FullB2g1Z = FullB2g1Z
     .           +nup*(1d0/nc**2)*(dble(nc)-4d0/nc)*(
     .             Bv2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .            +Bv2g1Z(i1,i3,i2,i4,i5,i6,renscale2))

      ! Axial contribution
         FullB2g1Z = FullB2g1Z
     .           +nup*((1d0/nc)*(B2g1Zax(i1,i2,i3,i4,i5,i6,renscale2)
     .                          +B2g1Zax(i1,i3,i2,i4,i5,i6,renscale2))
     .           -(1d0/nc**3)*Bt2g1Zax(i1,i2,i3,i4,i5,i6,renscale2))

      nf2g = 1 ! Down type contribution

      FullB2g1Z = FullB2g1Z+ndo*(B2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                          +B2g1Z(i1,i3,i2,i4,i5,i6,renscale2)
     .           -(1d0/nc**2)*(Bt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                        +Bt2g1Z(i1,i3,i2,i4,i5,i6,renscale2)
     .                        +Btt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                        -Bhh2g1Z(i1,i2,i3,i4,i5,i6,renscale2))
     .           +(1d0/nc**4)*Bttt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .           +(dble(nf)/nc)*(Bh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                          +Bh2g1Z(i1,i3,i2,i4,i5,i6,renscale2))
     .           -(dble(nf)/nc**3)*Bth2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .           -(1d0/nc)*(B2g1Ztop(i1,i2,i3,i4,i5,i6,renscale2)
     .                     +B2g1Ztop(i1,i3,i2,i4,i5,i6,renscale2))
     .           +(1d0/nc**3)*Bt2g1Ztop(i1,i2,i3,i4,i5,i6,renscale2))


      ! Vector contribution
         FullB2g1Z = FullB2g1Z
     .           +ndo*(1d0/nc**2)*(dble(nc)-4d0/nc)*(
     .             Bv2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .            +Bv2g1Z(i1,i3,i2,i4,i5,i6,renscale2))

      ! Axial contribution
         FullB2g1Z = FullB2g1Z
     .           +ndo*((1d0/nc)*(B2g1Zax(i1,i2,i3,i4,i5,i6,renscale2)
     .                          +B2g1Zax(i1,i3,i2,i4,i5,i6,renscale2))
     .           -(1d0/nc**3)*Bt2g1Zax(i1,i2,i3,i4,i5,i6,renscale2))

      else
      if((i1.le.2).and.(i4.le.2))then
         ! qqb initial state => extra factor of a half
         fac = 0.5d0*fac
      endif

      FullB2g1Z = B2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .           +B2g1Z(i1,i3,i2,i4,i5,i6,renscale2)
     .           -(1d0/nc**2)*(Bt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                        +Bt2g1Z(i1,i3,i2,i4,i5,i6,renscale2)
     .                        +Btt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                        -Bhh2g1Z(i1,i2,i3,i4,i5,i6,renscale2))
     .           +(1d0/nc**4)*Bttt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .           +(dble(nf)/nc)*(Bh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                          +Bh2g1Z(i1,i3,i2,i4,i5,i6,renscale2))
     .           -(dble(nf)/nc**3)*Bth2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .           -(1d0/nc)*(B2g1Ztop(i1,i2,i3,i4,i5,i6,renscale2)
     .                     +B2g1Ztop(i1,i3,i2,i4,i5,i6,renscale2))
     .           +(1d0/nc**3)*Bt2g1Ztop(i1,i2,i3,i4,i5,i6,renscale2)

      ! Vector contribution
      FullB2g1Z = FullB2g1Z
     .           +(1d0/nc**2)*(dble(nc)-4d0/nc)*(Bv2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                                          +Bv2g1Z(i1,i3,i2,i4,i5,i6,renscale2))

      ! Axial contribution
      FullB2g1Z = FullB2g1Z
     .           +(1d0/nc)*(B2g1Zax(i1,i2,i3,i4,i5,i6,renscale2)
     .                     +B2g1Zax(i1,i3,i2,i4,i5,i6,renscale2))
     .           -(1d0/nc**3)*Bt2g1Zax(i1,i2,i3,i4,i5,i6,renscale2)

      endif

      FullB2g1Z = fac*FullB2g1Z

      return
      end

***********************************************************************
*
* Quark pair one loop level virtual correction matrix element for
*
* q(i1) qb(i4) -> g(i2) g(i3) e+(i5) e-(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function B2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      use B2gZ, only : zampB2g1Z,zampB2g0Z
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /order/iorder
      common /koppel/ nf,nc,b0
      common /BZFlav/nf2g
!$omp threadprivate(/BZFlav/)
      double precision B2g1Zvec(4)
      double complex zamp(2,2),zampTree(2,2)
      integer ihel(6,4)


      do ii=1,4
         B2g1Zvec(ii) = 0d0
      enddo

      s = s6(i5,i6)

      call eweakV1qq(nf2g,s)

      ihel = reshape((/i1,i2,i3,i4,i5,i6,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i5,i6/),(/6,4/))

      do i=1,4
         if(i.le.2)then
            zamp     = zampB2g1Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)

            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i))
        else
            call swapzAB_kin(6)     ! Swap za <-> zb
            zamp     = zampB2g1Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)

            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i))
            call swapzAB_kin(6)     ! Swap back
         endif

         do ii=1,2
            do jj=1,2
               B2g1Zvec(i) = B2g1Zvec(i)
     .                      +dble(dconjg(zampTree(ii,jj))*zamp(ii,jj))
            enddo
         enddo
      enddo
      B2g1Zvec = abs(zewfac)**2*B2g1Zvec
      B2g1Z = sum(B2g1Zvec)
      if (iorder .eq. -1) then
c     A UV counter term at order 1/e to renormalise the matrix element in the MS bar scheme
         subuv = 11d0/3d0
         B2g1Z = B2g1Z - subuv*B2g0Z(i1,i2,i3,i4,i5,i6)
      elseif (iorder .eq. 0)then
c     pi**2/6d0 comes from a correction for C(e)
c     1/2 comes from a conversion of four-dimensional helicity scheme (FDH) to t Hooft-Veltman (HV) scheme
c     see hep-ph/9708239v1 equation 6.4
         e0 = -pi**2/4d0 + 0.5d0
         B2g1Z = B2g1Z - e0*B2g0Z(i1,i2,i3,i4,i5,i6)
      endif
      return
      end

***********************************************************************
*
* Quark pair one loop level virtual correction matrix element for
*
* q(i1) qb(i4) -> g(i2) g(i3) e+(i5) e-(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors, nf contribution
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function Bh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      use B2gZ, only : zampB2g0Z,zampBh2g1Z
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /order/iorder
      common /koppel/nf,nc,b0
      common /BZFlav/nf2g
!$omp threadprivate(/BZFlav/)
      double precision Bh2g1Zvec(4)
      double complex zampnfloop(2,2),zampTree(2,2)
      integer ihel(6,4)

      Bh2g1Z = 0d0
      do ii=1,4
         Bh2g1Zvec(ii) = 0d0
      enddo

      if(iorder.eq.0)then

      s = s6(i5,i6)

      call eweakV1qq(nf2g,s)

      ihel = reshape((/i1,i2,i3,i4,i5,i6,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i5,i6/),(/6,4/))

      do i=1,4
         if (i.le.2) then
            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i))

            zampnfLoop = zampBh2g1Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)
         else
            call swapzAB_kin(6)
            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i))

            zampnfLoop = zampBh2g1Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)
            call swapzAB_kin(6)
         endif

         do ii=1,2
            do jj=1,2
               Bh2g1Zvec(i) = Bh2g1Zvec(i)
     .                      +dble(dconjg(zampTree(ii,jj))*zampnfLoop(ii,jj))
            enddo
         enddo

      enddo

      Bh2g1Zvec = abs(zewfac)**2*Bh2g1Zvec
      Bh2g1Z = sum(Bh2g1Zvec)

      elseif (iorder .eq. -1) then
c     A UV counter term at order 1/e to renormalise the matrix element in the MS bar scheme
         subuv = (2d0/3d0)
         Bh2g1Z = subuv*B2g0Z(i1,i2,i3,i4,i5,i6)
      endif

      return
      end

*******************************************************
* A symmetrised version of Bh2g1Z when we are in the gg
* configuration


      function sBh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i4.le.2))then
         sBh2g1Z=Bh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      else
         sBh2g1Z=0.5d0*(Bh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                 +Bh2g1Z(i4,i3,i2,i1,i5,i6,renscale2))
      endif

      return
      end

***********************************************************************
*
* Quark pair one loop level virtual correction matrix element for
*
* q(i1) qb(i4) -> g(i2) g(i3) e+(i5) e-(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors, vector coupling contribution
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function Bv2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      use B2gZ, only : zampB2g0Z,zampB2g1Zvec
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /vector/zewvec(2)
!$omp threadprivate(/vector/)
      common /order/iorder
      common /koppel/ nf,nc,b0
      common /BZFlav/nf2g
!$omp threadprivate(/BZFlav/)
      double complex zBv2g1Zvec(4)
      double complex zampvloop(2,2),zampTree(2,2)
      integer ihel(6,4)

      Bv2g1Z = 0d0
      do ii=1,4
         zBv2g1Zvec(ii) = 0d0
      enddo

      s = s6(i5,i6)

      call eweakV1qq(nf2g,s)
      call ewcalcvec(s)

      ihel = reshape((/i1,i2,i3,i4,i5,i6,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i5,i6/),(/6,4/))

      do i=1,4
         if (i.gt.2)then
            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i))

            zampvLoop = zampB2g1Zvec(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)
         else
            call swapzAB_kin(6)
            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i))

            zampvLoop = zampB2g1Zvec(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)

            call swapzAB_kin(6)
         endif

         do ii=1,2
            do jj=1,2
               zBv2g1Zvec(i) = zBv2g1Zvec(i)
     .                       +dconjg(zampTree(ii,jj))*zampvLoop(ii,jj)
            enddo
         enddo

      enddo

      do ii=1,4
         if ((ii.eq.1).or.(ii.eq.3))then
            jj = 1
         else
            jj = 2
         endif

         zBv2g1Zvec(ii) = dconjg(zewfac(ii))*zewvec(jj)*dconjg(zBv2g1Zvec(ii))
      enddo


      Bv2g1Z = dble(sum(zBv2g1Zvec))

      return
      end

***********************************************************************
*
* Quark pair one loop level virtual correction matrix element for
*
* q(i1) qb(i4) -> g(i2) g(i3) e+(i5) e-(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors, axial coupling contribution
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function B2g1Zax(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      use B2gZ, only : zampB2g0Z,zFaxqqbgg
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /axial/zewax(2)
!$omp threadprivate(/axial/)
      common /order/iorder
      common /koppel/ nf,nc,b0
      common /BZFlav/nf2g
!$omp threadprivate(/BZFlav/)
      double complex zB2g1Zaxvec(4)
      double complex zampaxloop(2,2),zampTree(2,2)
      integer ihel(6,4)

      B2g1Zax = 0d0
      do ii=1,4
         zB2g1Zaxvec(ii) = 0d0
      enddo

      if(iorder.eq.0)then

      s = s6(i5,i6)

      call eweakV1qq(nf2g,s)

      ihel = reshape((/i1,i2,i3,i4,i5,i6,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i5,i6/),(/6,4/))

      do i=1,4
         if (i.le.2) then
            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i))

            zampaxLoop = zFaxqqbgg(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)
         else
            call swapzAB_kin(6)
            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i))

            zampaxLoop = zFaxqqbgg(ihel(1,i),ihel(2,i),ihel(3,i)
     .           ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)

            call swapzAB_kin(6)
         endif

         do ii=1,2
            do jj=1,2
               if (i.le.2)then
                  zB2g1Zaxvec(i) = zB2g1Zaxvec(i)
     .                 -dconjg(zampTree(ii,jj))*zampaxLoop(ii,jj)
               else
                  zB2g1Zaxvec(i) = zB2g1Zaxvec(i)
     .                 +dconjg(zampTree(ii,jj))*zampaxLoop(ii,jj)
               endif
            enddo
         enddo
      enddo

      do ii=1,4
         if ((ii.eq.1).or.(ii.eq.3))then
            jj = 1
         else
            jj = 2
         endif
         zB2g1Zaxvec(ii) = dconjg(zewfac(ii))*zewax(jj)*zB2g1Zaxvec(ii)
      enddo

      B2g1Zax = dble(sum(zB2g1Zaxvec))
      endif

      return
      end

***********************************************************************
*
* Quark pair one loop level virtual correction matrix element for
*
* q(i1) qb(i4) -> g(i2) g(i3) e+(i5) e-(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors, finite top corrections
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function B2g1Ztop(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      use Parameters_mod
      use B2gZ, only : zampB2g0Z,zFaxqqbgg
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      double precision :: emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Qmass/ emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /order/iorder

      if (emt.eq.0d0)then
         write(*,*) "Error in finite top correction to B2g1Z,
     . the mass of the top has not been defined"
         stop
      endif

      B2g1Ztop = 0d0

      if (iorder.eq.0)then
         B2g1Ztop = ((1d0/20d0)*s6(i2,i3)/emt**2+(1d0/210d0)*(s6(i2,i3)/emt**2)**2
     .    +(1d0/1680d0)*(s6(i2,i3)/emt**2)**3)*Bh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      endif

      return
      end


**********************************************
* A wrapper function for returning the normal
* matrix element for situations where either quark or
* antiquark are in the initial state. Otherwise
* it will return a line reversal symmetrised matrix element
*
*

      function sB2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i4.le.2))then
        sB2g1Z = B2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      else
        sB2g1Z = 0.5d0*(B2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                 +B2g1Z(i4,i3,i2,i1,i5,i6,renscale2))
      endif
      
      return
      end

      function sBt2g1ZDIS(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sBt2g1ZDIS=sBt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)+sBt2g1Z(i1,i3,i2,i4,i5,i6,renscale2)
     .     +sBtt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)-sBhh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)

      return
      end

      function Bt2g1ZDIS(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      Bt2g1ZDIS=Bt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)+Bt2g1Z(i1,i3,i2,i4,i5,i6,renscale2)
     .     +Btt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)-Bhh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)

      return
      end


      function sBhh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i4.le.2))then
        sBhh2g1Z = Bhh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      else
        sBhh2g1Z = 0.5d0*(Bhh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                  +Bhh2g1Z(i4,i3,i2,i1,i5,i6,renscale2))
      endif
      return
      end

      function sBtt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i4.le.2))then
        sBtt2g1Z = Btt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      else
        sBtt2g1Z = 0.5d0*(Btt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                  +Btt2g1Z(i4,i3,i2,i1,i5,i6,renscale2))
      endif

      return
      end


      function sBt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i4.le.2))then
        sBt2g1Z = Bt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      else
        sBt2g1Z = 0.5d0*(Bt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                  +Bt2g1Z(i4,i3,i2,i1,i5,i6,renscale2))
      endif

      return
      end

      function sBth2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i4.le.2))then
        sBth2g1Z = Bth2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      else
        sBth2g1Z = 0.5d0*(Bth2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                   +Bth2g1Z(i4,i3,i2,i1,i5,i6,renscale2))
      endif

      return
      end



      function sBtt2g1Zc(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i4.le.2))then
        sBtt2g1Zc = Btt2g1Zc(i1,i2,i3,i4,i5,i6,renscale2)
      else
        sBtt2g1Zc = 0.5d0*(Btt2g1Zc(i1,i2,i3,i4,i5,i6,renscale2)
     .                    +Btt2g1Zc(i4,i3,i2,i1,i5,i6,renscale2))
      endif

      return
      end


      function sBttt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if((i1.le.2).or.(i4.le.2))then
        sBttt2g1Z = Bttt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      else
        sBttt2g1Z = 0.5d0*(Bttt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .                    +Bttt2g1Z(i4,i3,i2,i1,i5,i6,renscale2))
      endif

      return
      end
