***********************************************************************
*
* Quark pair one loop level virtual correction matrix element for
*
* q(i1) qb(i4) -> g(i2) g(i3) e+(i5) e-(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors and subleading colour
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function Btt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      use B2gZ
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /order/iorder
      common /koppel/ nf,nc,b0
      common /BZFlav/nf2g
!$omp threadprivate(/BZFlav/)
      double precision Btt2g1Zvec(4)
      double complex zampqgqbg(2,2),zampTree(2,2)
      integer ihel(6,4)

      Btt2g1Z = 0d0

      do ii=1,4
         Btt2g1Zvec(ii) = 0d0
      enddo

      s= s6(i5,i6)

      call eweakV1qq(nf2g,s)

      ihel = reshape((/i1,i2,i3,i4,i5,i6,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i5,i6/),(/6,4/))

      do i=1,4
         if (i.le.2) then

            zampqgqbg = zampBtt2g1Z(i1,i2,i3,i4,ihel(5,i),ihel(6,i),renscale2)
     .           +Transpose(zampBtt2g1Z(i1,i3,i2,i4,ihel(5,i),ihel(6,i),renscale2))

            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i))
     .      +Transpose(zampB2g0Z(ihel(1,i),ihel(3,i),ihel(2,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i)))


         else

            call swapzAB_kin(6)
            zampqgqbg = zampBtt2g1Z(i1,i2,i3,i4,ihel(5,i),ihel(6,i),renscale2)
     .           +Transpose(zampBtt2g1Z(i1,i3,i2,i4,ihel(5,i),ihel(6,i),renscale2))
            call swapzAB_kin(6)

            call swapzAB_kin(6)
            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i))
     .      +Transpose(zampB2g0Z(ihel(1,i),ihel(3,i),ihel(2,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i)))

            call swapzAB_kin(6)
         endif

            do ii=1,2
               do jj=1,2
                  Btt2g1Zvec(i) = Btt2g1Zvec(i)-dble(Dconjg(zampTree(ii,jj))*zampqgqbg(ii,jj))
               enddo
            enddo
      enddo

      Btt2g1Zvec = abs(zewfac)**2*Btt2g1Zvec

      Btt2g1Z = sum(Btt2g1Zvec)

      if (iorder.eq.-1)then
         subuv = 11d0/3d0
         Btt2g1Z = Btt2g1Z - subuv*Bt2g0Z(i1,i2,i3,i4,i5,i6)
      elseif (iorder.eq.0)then
c     pi**2/6d0 comes from a correction for C(e)
c     1/2 comes from a conversion of four-dimensional helicity scheme (FDH) to 't Hooft-Veltman (HV) scheme
c     see hep-ph/9708239v1 equation 6.4
         e0 = -pi**2/3d0 + 0.5d0
         Btt2g1Z = Btt2g1Z - e0*Bt2g0Z(i1,i2,i3,i4,i5,i6)
      endif

      return
      end

*******************************************************
* a wrapper function for (Btt2g1Z - Bhh2g1Z)
*

      function Btt2g1Zc(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      implicit none
      double precision Btt2g1Zc,Btt2g1Z,Bhh2g1Z,renscale2
      integer i1,i2,i3,i4,i5,i6


      Btt2g1Zc = Btt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
     .          -Bhh2g1Z(i1,i2,i3,i4,i5,i6,renscale2)

      return
      end


