***********************************************************************
*
* Quark pair one loop level virtual correction matrix element for
*
* q(i1) qb(i4) -> g(i2) g(i3) e+(i5) e-(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors and sub-subleading colour
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function Bttt2g1Z(i1,i2,i3,i4,i5,i6,renscale2)
      use KinData_mod
      use B2gZ, only : zampB2g0Z,zampBtt2g1Z
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /order/iorder
      common /koppel/ nf,nc,b0
      common /BZFlav/nf2g
!$omp threadprivate(/BZFlav/)
      double precision Bttt2g1Zvec(4)
      double complex zamp(2,2),zampTree(2,2)
      integer ihel(6,4)

      Bttt2g1Z = 0d0

      do ii=1,4
         Bttt2g1Zvec(ii) = 0d0
      enddo

      s = s6(i5,i6)

      call eweakV1qq(nf2g,s)

      ihel = reshape((/i1,i2,i3,i4,i5,i6,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i6,i5,
     .                 i1,i2,i3,i4,i5,i6/),(/6,4/))

      do i=1,4
         if(i.le.2)then
            zamp     = zampBtt2g1Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)
c     Note swapped gluon ordering
     .                +Transpose(zampBtt2g1Z(ihel(1,i),ihel(3,i),ihel(2,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2))

            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i))

     .                +Transpose(zampB2g0Z(ihel(1,i),ihel(3,i),ihel(2,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i)))

        else
            call swapzAB_kin(6)     ! Swap za <-> zb
            zamp     = zampBtt2g1Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2)
c     Note swapped gluon ordering
     .                +Transpose(zampBtt2g1Z(ihel(1,i),ihel(3,i),ihel(2,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i),renscale2))

            zampTree = zampB2g0Z(ihel(1,i),ihel(2,i),ihel(3,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i))

     .                +Transpose(zampB2g0Z(ihel(1,i),ihel(3,i),ihel(2,i)
     .                          ,ihel(4,i),ihel(5,i),ihel(6,i)))

            call swapzAB_kin(6)     ! Swap back
         endif


         do ii=1,2
            do jj=1,2
               Bttt2g1Zvec(i) = Bttt2g1Zvec(i)
     .                       +Dble(Dconjg(zampTree(ii,jj))*zamp(ii,jj))
            enddo
         enddo
      enddo

      Bttt2g1Zvec = abs(zewfac)**2*Bttt2g1Zvec
      Bttt2g1Z = sum(Bttt2g1Zvec)

      if (iorder.eq.0)then
         e0 = -pi**2/12d0 + 0.5d0 ! pi**2/3 factor from C_gamma expansion
         Bttt2g1Z = Bttt2g1Z - e0*Bt2g0Z(i1,i2,i3,i4,i5,i6)
      endif


      return
      end
