************************************************************************
*
*  four quark one loop matrix elements interfered with tree level
*
*                      q1  qb2  q2  qb1
*
* summed over colour orderings, summed and squared
*
      function FullC0g1(iq1,iqb2,iq2,iqb1,renscale2)
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

c      write(*,*)" hello FullC0g1"
      fac=(as*nc/2d0/pi)*(4d0*pi*as*nc)**2*(nc**2-1d0)/dble(nc)**2

      FullC0g1=               +C0g1(iq1,iqb2,iq2,iqb1,renscale2)
     .       +dble(nf)/dble(nc)*Ch0g1(iq1,iqb2,iq2,iqb1,renscale2)
     .        +1d0/dble(nc)**(2)*Ct0g1(iq1,iqb2,iq2,iqb1,renscale2)

      FullC0g1=fac*FullC0g1

*c      write(*,*)"FullC0g1",FullC0g1
      return
      end
*
************************************************************************
*
      function C0g1(iq1,iqb2,iq2,iqb1,renscale2)
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        C0g1=C0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        C0g1=C0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        C0g1=C0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        C0g1=C0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        C0g1=C0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        C0g1=C0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        C0g1=C0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        C0g1=C0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        C0g1=C0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        C0g1=C0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        C0g1=C0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        C0g1=C0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        C0g1=C0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        C0g1=C0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        C0g1=C0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        C0g1=C0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        C0g1=C0g13(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        C0g1=C0g13(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        C0g1=C0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        C0g1=C0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        C0g1=C0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        C0g1=C0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        C0g1=C0g13(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        C0g1=C0g13(iqb1,iq2,iqb2,iq1,renscale2)
      endif
      return
      end
*
************************************************************************
*
      function Ch0g1(iq1,iqb2,iq2,iqb1,renscale2)
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Ch0g1=Ch0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Ch0g1=Ch0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Ch0g1=Ch0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Ch0g1=Ch0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Ch0g1=Ch0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Ch0g1=Ch0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Ch0g1=Ch0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Ch0g1=Ch0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Ch0g1=Ch0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Ch0g1=Ch0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Ch0g1=Ch0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Ch0g1=Ch0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Ch0g1=Ch0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Ch0g1=Ch0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Ch0g1=Ch0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Ch0g1=Ch0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Ch0g1=Ch0g13(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Ch0g1=Ch0g13(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Ch0g1=Ch0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Ch0g1=Ch0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Ch0g1=Ch0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Ch0g1=Ch0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Ch0g1=Ch0g13(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Ch0g1=Ch0g13(iqb1,iq2,iqb2,iq1,renscale2)
      endif
      return
      end
************************************************************************
*
      function Ct0g1(iq1,iqb2,iq2,iqb1,renscale2)
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Ct0g1=Ct0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Ct0g1=Ct0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Ct0g1=Ct0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Ct0g1=Ct0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Ct0g1=Ct0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Ct0g1=Ct0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Ct0g1=Ct0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Ct0g1=Ct0g13(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Ct0g1=Ct0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Ct0g1=Ct0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Ct0g1=Ct0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Ct0g1=Ct0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Ct0g1=Ct0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Ct0g1=Ct0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Ct0g1=Ct0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Ct0g1=Ct0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Ct0g1=Ct0g13(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Ct0g1=Ct0g13(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Ct0g1=Ct0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Ct0g1=Ct0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Ct0g1=Ct0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Ct0g1=Ct0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Ct0g1=Ct0g13(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Ct0g1=Ct0g13(iqb1,iq2,iqb2,iq1,renscale2)
      endif
      return
      end


************************************************************************
*
      function C0g11(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      C0g11 =  - 4.D0 - 8.D0*s12**(-2)*s23**2 - 8.D0*s12**(-1)*s23

      elseif(ieorder.eq.-1)then
      C0g11 =  + dls * ( 4.D0 + 8.D0*s12**(-2)*s23**2 + 8.D0*s12**(-1)*
     &    s23 )
      C0g11 = C0g11 + dlx * ( 4.D0 + 8.D0*s12**(-2)*s23**2 + 8.D0*
     &    s12**(-1)*s23 )
      C0g11 = C0g11 - 6.D0 - 12.D0*s12**(-2)*s23**2 - 12.D0*s12**(-1)*
     &    s23

      elseif(ieorder.eq.0)then
      C0g11 =  + pi**2 * ( 1.D0/3.D0 + 2.D0/3.D0*s12**(-2)*s23**2 + 2.D0
     &    /3.D0*s12**(-1)*s23 )
      C0g11 = C0g11 + dls * (  - 4.D0/3.D0 - 8.D0/3.D0*s12**(-2)*s23**2
     &     - 8.D0/3.D0*s12**(-1)*s23 )
      C0g11 = C0g11 + dls**2 * (  - 2.D0 - 4.D0*s12**(-2)*s23**2 - 4.D0
     &    *s12**(-1)*s23 )
      C0g11 = C0g11 + dlx * ( 2.D0 + 2.D0*s12**(-1)*s23 )
      C0g11 = C0g11 + dlx*dls * (  - 4.D0 - 8.D0*s12**(-2)*s23**2 - 8.D0
     &    *s12**(-1)*s23 )
      C0g11 = C0g11 + dlx**2 * (  - 1.D0 - 2.D0*s12**(-1)*s23 )
      C0g11 = C0g11 + 26.D0/9.D0 + 52.D0/9.D0*s12**(-2)*s23**2 + 52.D0/
     &    9.D0*s12**(-1)*s23

      endif
      return
      end
************************************************************************
*
      function C0g12(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      C0g12 =  - 4.D0 - 8.D0*s13**(-2)*s23**2 - 8.D0*s13**(-1)*s23

      elseif(ieorder.eq.-1)then
      C0g12 =  + dls * ( 4.D0 + 8.D0*s13**(-2)*s23**2 + 8.D0*s13**(-1)*
     &    s23 )
      C0g12 = C0g12 + dlx * ( 4.D0 + 8.D0*s13**(-2)*s23**2 + 8.D0*
     &    s13**(-1)*s23 )
      C0g12 = C0g12 - 6.D0 - 12.D0*s13**(-2)*s23**2 - 12.D0*s13**(-1)*
     &    s23

      elseif(ieorder.eq.0)then
      C0g12 =  + pi**2 * ( 4.D0/3.D0 + 14.D0/3.D0*s13**(-2)*s23**2 + 8.D
     &    0/3.D0*s13**(-1)*s23 )
      C0g12 = C0g12 + dls * (  - 4.D0/3.D0 - 8.D0/3.D0*s13**(-2)*s23**2
     &     - 8.D0/3.D0*s13**(-1)*s23 )
      C0g12 = C0g12 + dls**2 * (  - 2.D0 - 4.D0*s13**(-2)*s23**2 - 4.D0
     &    *s13**(-1)*s23 )
      C0g12 = C0g12 + dlomx * (  - 10.D0/3.D0 - 8.D0/3.D0*s13**(-2)*
     &    s23**2 - 14.D0/3.D0*s13**(-1)*s23 )
      C0g12 = C0g12 + dlomx**2 * ( 1.D0 + 4.D0*s13**(-2)*s23**2 + 2.D0*
     &    s13**(-1)*s23 )
      C0g12 = C0g12 + dlx * ( 2.D0 + 2.D0*s13**(-1)*s23 )
      C0g12 = C0g12 + dlx*dls * (  - 4.D0 - 8.D0*s13**(-2)*s23**2 - 8.D0
     &    *s13**(-1)*s23 )
      C0g12 = C0g12 + dlx*dlomx * (  - 2.D0 - 8.D0*s13**(-2)*s23**2 - 4.
     &    D0*s13**(-1)*s23 )
      C0g12 = C0g12 + dlx**2 * (  - 1.D0 - 2.D0*s13**(-1)*s23 )
      C0g12 = C0g12 + 26.D0/9.D0 + 52.D0/9.D0*s13**(-2)*s23**2 + 52.D0/
     &    9.D0*s13**(-1)*s23

      endif
      return
      end
************************************************************************
*
      function C0g13(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iqb2)
      s23 =s4(iq1,iqb1)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      C0g13 =  - 4.D0 - 8.D0*s12*s23**(-1) - 8.D0*s12**2*s23**(-2)

      elseif(ieorder.eq.-1)then
      C0g13 =  + dls * ( 4.D0 + 8.D0*s12*s23**(-1) + 8.D0*s12**2*
     &    s23**(-2) )
      C0g13 = C0g13 - 6.D0 - 12.D0*s12*s23**(-1) - 12.D0*s12**2*
     &    s23**(-2)

      elseif(ieorder.eq.0)then
      C0g13 =  + pi**2 * ( 7.D0/3.D0 + 14.D0/3.D0*s12*s23**(-1) + 14.D0/
     &    3.D0*s12**2*s23**(-2) )
      C0g13 = C0g13 + dls * (  - 4.D0/3.D0 - 8.D0/3.D0*s12*s23**(-1) -
     &    8.D0/3.D0*s12**2*s23**(-2) )
      C0g13 = C0g13 + dls**2 * (  - 2.D0 - 4.D0*s12*s23**(-1) - 4.D0*
     &    s12**2*s23**(-2) )
      C0g13 = C0g13 + dlx * (  - 10.D0/3.D0 - 14.D0/3.D0*s12*s23**(-1)
     &     - 8.D0/3.D0*s12**2*s23**(-2) )
      C0g13 = C0g13 + dlx**2 * ( 1.D0 + 2.D0*s12*s23**(-1) + 4.D0*
     &    s12**2*s23**(-2) )
      C0g13 = C0g13 + 26.D0/9.D0 + 52.D0/9.D0*s12*s23**(-1) + 52.D0/9.D0
     &    *s12**2*s23**(-2)

      endif
      return
      end
************************************************************************
*
      function Ch0g11(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Ch0g11 =  0

      elseif(ieorder.eq.-1)then
      Ch0g11 =  0

      elseif(ieorder.eq.0)then
      Ch0g11 =  + dls * ( 4.D0/3.D0 + 8.D0/3.D0*s12**(-2)*s23**2 + 8.D0/
     &    3.D0*s12**(-1)*s23 )
      Ch0g11 = Ch0g11 - 20.D0/9.D0 - 40.D0/9.D0*s12**(-2)*s23**2 - 40.D0
     &    /9.D0*s12**(-1)*s23

      endif
      return
      end
************************************************************************
*
      function Ch0g12(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Ch0g12 =  0

      elseif(ieorder.eq.-1)then
      Ch0g12 =  0

      elseif(ieorder.eq.0)then
      Ch0g12 =  + dls * ( 4.D0/3.D0 + 8.D0/3.D0*s13**(-2)*s23**2 + 8.D0/
     &    3.D0*s13**(-1)*s23 )
      Ch0g12 = Ch0g12 + dlomx * ( 4.D0/3.D0 + 8.D0/3.D0*s13**(-2)*
     &    s23**2 + 8.D0/3.D0*s13**(-1)*s23 )
      Ch0g12 = Ch0g12 - 20.D0/9.D0 - 40.D0/9.D0*s13**(-2)*s23**2 - 40.D0
     &    /9.D0*s13**(-1)*s23

      endif
      return
      end
************************************************************************
*
      function Ch0g13(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iqb2)
      s23 =s4(iq1,iqb1)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Ch0g13 =  0

      elseif(ieorder.eq.-1)then
      Ch0g13 =  0

      elseif(ieorder.eq.0)then
      Ch0g13 =  + dls * ( 4.D0/3.D0 + 8.D0/3.D0*s12*s23**(-1) + 8.D0/3.D
     &    0*s12**2*s23**(-2) )
      Ch0g13 = Ch0g13 + dlx * ( 4.D0/3.D0 + 8.D0/3.D0*s12*s23**(-1) + 8.
     &    D0/3.D0*s12**2*s23**(-2) )
      Ch0g13 = Ch0g13 - 20.D0/9.D0 - 40.D0/9.D0*s12*s23**(-1) - 40.D0/9.
     &    D0*s12**2*s23**(-2)

      endif
      return
      end
************************************************************************
*
      function Ct0g11(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Ct0g11 =  + 4.D0 + 8.D0*s12**(-2)*s23**2 + 8.D0*s12**(-1)*s23

      elseif(ieorder.eq.-1)then
      Ct0g11 =  + dls * (  - 4.D0 - 8.D0*s12**(-2)*s23**2 - 8.D0*
     &    s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dlomx * ( 8.D0 + 16.D0*s12**(-2)*s23**2 + 16.D0
     &    *s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dlx * (  - 8.D0 - 16.D0*s12**(-2)*s23**2 - 16.D0
     &    *s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + 6.D0 + 12.D0*s12**(-2)*s23**2 + 12.D0*s12**(-1)
     &    *s23

      elseif(ieorder.eq.0)then
      Ct0g11 =  + pi**2 * (  - 7.D0/3.D0 - 14.D0/3.D0*s12**(-2)*s23**2
     &     - 14.D0/3.D0*s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dls * (  - 6.D0 - 12.D0*s12**(-2)*s23**2 - 12.D0
     &    *s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dls**2 * ( 2.D0 + 4.D0*s12**(-2)*s23**2 + 4.D0*
     &    s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dlomx * (  - 4.D0*s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dlomx*dls * (  - 8.D0 - 16.D0*s12**(-2)*s23**2
     &     - 16.D0*s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dlomx**2 * ( 2.D0 + 4.D0*s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dlx * (  - 4.D0 - 4.D0*s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dlx*dls * ( 8.D0 + 16.D0*s12**(-2)*s23**2 + 16.D
     &    0*s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + dlx**2 * ( 2.D0 + 4.D0*s12**(-1)*s23 )
      Ct0g11 = Ct0g11 + 16.D0 + 32.D0*s12**(-2)*s23**2 + 32.D0*
     &    s12**(-1)*s23

      endif
      return
      end
************************************************************************
*
      function Ct0g12(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Ct0g12 =  + 4.D0 + 8.D0*s13**(-2)*s23**2 + 8.D0*s13**(-1)*s23

      elseif(ieorder.eq.-1)then
      Ct0g12 =  + dls * (  - 4.D0 - 8.D0*s13**(-2)*s23**2 - 8.D0*
     &    s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dlomx * (  - 4.D0 - 8.D0*s13**(-2)*s23**2 - 8.D0
     &    *s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dlx * (  - 8.D0 - 16.D0*s13**(-2)*s23**2 - 16.D0
     &    *s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + 6.D0 + 12.D0*s13**(-2)*s23**2 + 12.D0*s13**(-1)
     &    *s23

      elseif(ieorder.eq.0)then
      Ct0g12 =  + pi**2 * ( 5.D0/3.D0 - 2.D0/3.D0*s13**(-2)*s23**2 + 10.
     &    D0/3.D0*s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dls * (  - 6.D0 - 12.D0*s13**(-2)*s23**2 - 12.D0
     &    *s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dls**2 * ( 2.D0 + 4.D0*s13**(-2)*s23**2 + 4.D0*
     &    s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dlomx * (  - 2.D0 - 12.D0*s13**(-2)*s23**2 - 4.D
     &    0*s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dlomx*dls * ( 4.D0 + 8.D0*s13**(-2)*s23**2 + 8.D
     &    0*s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dlomx**2 * ( 6.D0 + 4.D0*s13**(-2)*s23**2 + 12.D
     &    0*s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dlx * (  - 4.D0 - 4.D0*s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dlx*dls * ( 8.D0 + 16.D0*s13**(-2)*s23**2 + 16.D
     &    0*s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dlx*dlomx * ( 4.D0 + 16.D0*s13**(-2)*s23**2 + 8.
     &    D0*s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + dlx**2 * ( 2.D0 + 4.D0*s13**(-1)*s23 )
      Ct0g12 = Ct0g12 + 16.D0 + 32.D0*s13**(-2)*s23**2 + 32.D0*
     &    s13**(-1)*s23

      endif
      return
      end
************************************************************************
*
      function Ct0g13(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iqb2)
      s23 =s4(iq1,iqb1)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Ct0g13 =  + 4.D0 + 8.D0*s12*s23**(-1) + 8.D0*s12**2*s23**(-2)

      elseif(ieorder.eq.-1)then
      Ct0g13 =  + dls * (  - 4.D0 - 8.D0*s12*s23**(-1) - 8.D0*s12**2*
     &    s23**(-2) )
      Ct0g13 = Ct0g13 + dlomx * ( 8.D0 + 16.D0*s12*s23**(-1) + 16.D0*
     &    s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + dlx * (  - 4.D0 - 8.D0*s12*s23**(-1) - 8.D0*
     &    s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + 6.D0 + 12.D0*s12*s23**(-1) + 12.D0*s12**2*
     &    s23**(-2)

      elseif(ieorder.eq.0)then
      Ct0g13 =  + pi**2 * ( 5.D0/3.D0 + 10.D0/3.D0*s12*s23**(-1) - 2.D0/
     &    3.D0*s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + dls * (  - 6.D0 - 12.D0*s12*s23**(-1) - 12.D0*
     &    s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + dls**2 * ( 2.D0 + 4.D0*s12*s23**(-1) + 4.D0*
     &    s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + dlomx * (  - 4.D0*s12*s23**(-1) )
      Ct0g13 = Ct0g13 + dlomx*dls * (  - 8.D0 - 16.D0*s12*s23**(-1) -
     &    16.D0*s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + dlomx**2 * ( 2.D0 + 4.D0*s12*s23**(-1) )
      Ct0g13 = Ct0g13 + dlx * (  - 2.D0 - 4.D0*s12*s23**(-1) - 12.D0*
     &    s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + dlx*dls * ( 4.D0 + 8.D0*s12*s23**(-1) + 8.D0*
     &    s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + dlx*dlomx * (  - 12.D0 - 24.D0*s12*s23**(-1) -
     &    16.D0*s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + dlx**2 * ( 6.D0 + 12.D0*s12*s23**(-1) + 4.D0*
     &    s12**2*s23**(-2) )
      Ct0g13 = Ct0g13 + 16.D0 + 32.D0*s12*s23**(-1) + 32.D0*s12**2*
     &    s23**(-2)

      endif
      return
      end
