************************************************************************
*
*  identical four quark one loop matrix elements interfered with tree level
*
*                      q1  qb2  q2  qb1
*
* summed over colour orderings, summed and squared
*
      function FullD0g1(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

c      write(*,*)" hello FullD0g1"
      fac=(as*nc/2d0/pi)*(4d0*pi*as*nc)**2*(nc**2-1d0)/dble(nc)**3

      FullD0g1=                   +D0g1(iq1,iqb2,iq2,iqb1,renscale2)
     .       +dble(nf)/dble(nc)*Dh0g1(iq1,iqb2,iq2,iqb1,renscale2)
     .        +1d0/dble(nc)**(2)*Dt0g1(iq1,iqb2,iq2,iqb1,renscale2)

      FullD0g1=fac*FullD0g1

*c      write(*,*)"FullD0g1",FullD0g1
      return
      end
*
************************************************************************
*
      function D0g1(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        D0g1=D0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        D0g1=D0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        D0g1=D0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        D0g1=D0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        D0g1=D0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        D0g1=D0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        D0g1=D0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        D0g1=D0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        D0g1=D0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        D0g1=D0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        D0g1=D0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        D0g1=D0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        D0g1=D0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        D0g1=D0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        D0g1=D0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        D0g1=D0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        D0g1=D0g11(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        D0g1=D0g11(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        D0g1=D0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        D0g1=D0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        D0g1=D0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        D0g1=D0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        D0g1=D0g11(iqb1,iq1,iqb2,iq2,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        D0g1=D0g11(iqb1,iq1,iqb2,iq2,renscale2)
      endif
      return
      end
*
************************************************************************
*
      function Dh0g1(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dh0g1=Dh0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dh0g1=Dh0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dh0g1=Dh0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dh0g1=Dh0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dh0g1=Dh0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dh0g1=Dh0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dh0g1=Dh0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dh0g1=Dh0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dh0g1=Dh0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dh0g1=Dh0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dh0g1=Dh0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dh0g1=Dh0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dh0g1=Dh0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dh0g1=Dh0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dh0g1=Dh0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dh0g1=Dh0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dh0g1=Dh0g11(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dh0g1=Dh0g11(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dh0g1=Dh0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dh0g1=Dh0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dh0g1=Dh0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dh0g1=Dh0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dh0g1=Dh0g11(iqb1,iq1,iqb2,iq2,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dh0g1=Dh0g11(iqb1,iq1,iqb2,iq2,renscale2)
      endif
      return
      end
************************************************************************
*
      function Dt0g1(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dt0g1=Dt0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dt0g1=Dt0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dt0g1=Dt0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dt0g1=Dt0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dt0g1=Dt0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dt0g1=Dt0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dt0g1=Dt0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dt0g1=Dt0g11(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dt0g1=Dt0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dt0g1=Dt0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dt0g1=Dt0g12(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dt0g1=Dt0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dt0g1=Dt0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dt0g1=Dt0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dt0g1=Dt0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dt0g1=Dt0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dt0g1=Dt0g11(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dt0g1=Dt0g11(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dt0g1=Dt0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dt0g1=Dt0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dt0g1=Dt0g11(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dt0g1=Dt0g12(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dt0g1=Dt0g11(iqb1,iq1,iqb2,iq2,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dt0g1=Dt0g11(iqb1,iq1,iqb2,iq2,renscale2)
      endif
      return
      end

************************************************************************
*
      function D0g11(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      D0g11 =  - 16.D0 - 8.D0*s12**(-1)*s23 - 8.D0*s12*s23**(-1)

      elseif(ieorder.eq.-1)then
      D0g11 =  + dls * ( 16.D0 + 8.D0*s12**(-1)*s23 + 8.D0*s12*
     &    s23**(-1) )
      D0g11 = D0g11 + dlomx * ( 16.D0 + 8.D0*s12**(-1)*s23 + 8.D0*s12*
     &    s23**(-1) )
      D0g11 = D0g11 - 24.D0 - 12.D0*s12**(-1)*s23 - 12.D0*s12*s23**(-1)

      elseif(ieorder.eq.0)then
      D0g11 =  + pi**2 * ( 16.D0/3.D0 + 8.D0/3.D0*s12**(-1)*s23 + 8.D0/
     &    3.D0*s12*s23**(-1) )
      D0g11 = D0g11 + dls * (  - 16.D0/3.D0 - 8.D0/3.D0*s12**(-1)*s23
     &     - 8.D0/3.D0*s12*s23**(-1) )
      D0g11 = D0g11 + dls**2 * (  - 8.D0 - 4.D0*s12**(-1)*s23 - 4.D0*
     &    s12*s23**(-1) )
      D0g11 = D0g11 + dlomx*dls * (  - 16.D0 - 8.D0*s12**(-1)*s23 - 8.D0
     &    *s12*s23**(-1) )
      D0g11 = D0g11 + dlx * (  - 8.D0/3.D0 - 4.D0/3.D0*s12**(-1)*s23 -
     &    4.D0/3.D0*s12*s23**(-1) )
      D0g11 = D0g11 + dlx*dlomx * (  - 8.D0 - 4.D0*s12**(-1)*s23 - 4.D0
     &    *s12*s23**(-1) )
      D0g11 = D0g11 + dlx**2 * ( 4.D0 + 2.D0*s12**(-1)*s23 + 2.D0*s12*
     &    s23**(-1) )
      D0g11 = D0g11 + 104.D0/9.D0 + 52.D0/9.D0*s12**(-1)*s23 + 52.D0/9.D
     &    0*s12*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function D0g12(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      D0g12 =  - 8.D0 - 8.D0*s13**(-1)*s23 + 8.D0*s12*s23**(-1)

      elseif(ieorder.eq.-1)then
      D0g12 =  + dls * ( 8.D0 + 8.D0*s13**(-1)*s23 - 8.D0*s12*s23**(-1)
     &     )
      D0g12 = D0g12 - 12.D0 - 12.D0*s13**(-1)*s23 + 12.D0*s12*s23**(-1)

      elseif(ieorder.eq.0)then
      D0g12 =  + pi**2 * ( 14.D0/3.D0 + 14.D0/3.D0*s13**(-1)*s23 - 14.D0
     &    /3.D0*s12*s23**(-1) )
      D0g12 = D0g12 + dls * (  - 8.D0/3.D0 - 8.D0/3.D0*s13**(-1)*s23 +
     &    8.D0/3.D0*s12*s23**(-1) )
      D0g12 = D0g12 + dls**2 * (  - 4.D0 - 4.D0*s13**(-1)*s23 + 4.D0*
     &    s12*s23**(-1) )
      D0g12 = D0g12 + dlomx * (  - 4.D0/3.D0 - 4.D0/3.D0*s13**(-1)*s23
     &     + 4.D0/3.D0*s12*s23**(-1) )
      D0g12 = D0g12 + dlomx**2 * ( 2.D0 + 2.D0*s13**(-1)*s23 - 2.D0*s12
     &    *s23**(-1) )
      D0g12 = D0g12 + dlx * (  - 4.D0/3.D0 - 4.D0/3.D0*s13**(-1)*s23 +
     &    4.D0/3.D0*s12*s23**(-1) )
      D0g12 = D0g12 + dlx**2 * ( 2.D0 + 2.D0*s13**(-1)*s23 - 2.D0*s12*
     &    s23**(-1) )
      D0g12 = D0g12 + 52.D0/9.D0 + 52.D0/9.D0*s13**(-1)*s23 - 52.D0/9.D0
     &    *s12*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function Dh0g11(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Dh0g11 =  0

      elseif(ieorder.eq.-1)then
      Dh0g11 =  0

      elseif(ieorder.eq.0)then
      Dh0g11 =  + dls * ( 16.D0/3.D0 + 8.D0/3.D0*s12**(-1)*s23 + 8.D0/3.
     &    D0*s12*s23**(-1) )
      Dh0g11 = Dh0g11 + dlx * ( 8.D0/3.D0 + 4.D0/3.D0*s12**(-1)*s23 + 4.
     &    D0/3.D0*s12*s23**(-1) )
      Dh0g11 = Dh0g11 - 80.D0/9.D0 - 40.D0/9.D0*s12**(-1)*s23 - 40.D0/9.
     &    D0*s12*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function Dh0g12(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Dh0g12 =  0

      elseif(ieorder.eq.-1)then
      Dh0g12 =  0

      elseif(ieorder.eq.0)then
      Dh0g12 =  + dls * ( 8.D0/3.D0 + 8.D0/3.D0*s13**(-1)*s23 - 8.D0/3.D
     &    0*s12*s23**(-1) )
      Dh0g12 = Dh0g12 + dlomx * ( 4.D0/3.D0 + 4.D0/3.D0*s13**(-1)*s23
     &     - 4.D0/3.D0*s12*s23**(-1) )
      Dh0g12 = Dh0g12 + dlx * ( 4.D0/3.D0 + 4.D0/3.D0*s13**(-1)*s23 - 4.
     &    D0/3.D0*s12*s23**(-1) )
      Dh0g12 = Dh0g12 - 40.D0/9.D0 - 40.D0/9.D0*s13**(-1)*s23 + 40.D0/9.
     &    D0*s12*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function Dt0g11(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Dt0g11 =  + 16.D0 + 8.D0*s12**(-1)*s23 + 8.D0*s12*s23**(-1)

      elseif(ieorder.eq.-1)then
      Dt0g11 =  + dls * (  - 16.D0 - 8.D0*s12**(-1)*s23 - 8.D0*s12*
     &    s23**(-1) )
      Dt0g11 = Dt0g11 + dlomx * ( 16.D0 + 8.D0*s12**(-1)*s23 + 8.D0*s12
     &    *s23**(-1) )
      Dt0g11 = Dt0g11 + dlx * (  - 16.D0 - 8.D0*s12**(-1)*s23 - 8.D0*
     &    s12*s23**(-1) )
      Dt0g11 = Dt0g11 + 24.D0 + 12.D0*s12**(-1)*s23 + 12.D0*s12*
     &    s23**(-1)

      elseif(ieorder.eq.0)then
      Dt0g11 =  + pi**2 * (  - 16.D0/3.D0 - 8.D0/3.D0*s12**(-1)*s23 - 8.
     &    D0/3.D0*s12*s23**(-1) )
      Dt0g11 = Dt0g11 + dls * (  - 24.D0 - 12.D0*s12**(-1)*s23 - 12.D0*
     &    s12*s23**(-1) )
      Dt0g11 = Dt0g11 + dls**2 * ( 8.D0 + 4.D0*s12**(-1)*s23 + 4.D0*s12
     &    *s23**(-1) )
      Dt0g11 = Dt0g11 + dlomx*dls * (  - 16.D0 - 8.D0*s12**(-1)*s23 - 8.
     &    D0*s12*s23**(-1) )
      Dt0g11 = Dt0g11 + dlx * (  - 12.D0 - 4.D0*s12**(-1)*s23 - 8.D0*
     &    s12*s23**(-1) )
      Dt0g11 = Dt0g11 + dlx*dls * ( 16.D0 + 8.D0*s12**(-1)*s23 + 8.D0*
     &    s12*s23**(-1) )
      Dt0g11 = Dt0g11 + dlx*dlomx * (  - 8.D0 - 4.D0*s12**(-1)*s23 - 4.D
     &    0*s12*s23**(-1) )
      Dt0g11 = Dt0g11 + dlx**2 * ( 8.D0 + 3.D0*s12**(-1)*s23 + 3.D0*s12
     &    *s23**(-1) )
      Dt0g11 = Dt0g11 + 64.D0 + 32.D0*s12**(-1)*s23 + 32.D0*s12*
     &    s23**(-1)

      endif
      return
      end
************************************************************************
*
      function Dt0g12(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Dt0g12 =  + 8.D0 + 8.D0*s13**(-1)*s23 - 8.D0*s12*s23**(-1)

      elseif(ieorder.eq.-1)then
      Dt0g12 =  + dls * (  - 8.D0 - 8.D0*s13**(-1)*s23 + 8.D0*s12*
     &    s23**(-1) )
      Dt0g12 = Dt0g12 + dlomx * (  - 8.D0 - 8.D0*s13**(-1)*s23 + 8.D0*
     &    s12*s23**(-1) )
      Dt0g12 = Dt0g12 + dlx * (  - 8.D0 - 8.D0*s13**(-1)*s23 + 8.D0*s12
     &    *s23**(-1) )
      Dt0g12 = Dt0g12 + 12.D0 + 12.D0*s13**(-1)*s23 - 12.D0*s12*
     &    s23**(-1)

      elseif(ieorder.eq.0)then
      Dt0g12 =  + pi**2 * ( 7.D0/3.D0 + 1.D0/3.D0*s13**(-1)*s23 - 1.D0/
     &    3.D0*s12*s23**(-1) )
      Dt0g12 = Dt0g12 + dls * (  - 12.D0 - 12.D0*s13**(-1)*s23 + 12.D0*
     &    s12*s23**(-1) )
      Dt0g12 = Dt0g12 + dls**2 * ( 4.D0 + 4.D0*s13**(-1)*s23 - 4.D0*s12
     &    *s23**(-1) )
      Dt0g12 = Dt0g12 + dlomx * (  - 8.D0 - 8.D0*s13**(-1)*s23 + 4.D0*
     &    s12*s23**(-1) )
      Dt0g12 = Dt0g12 + dlomx*dls * ( 8.D0 + 8.D0*s13**(-1)*s23 - 8.D0*
     &    s12*s23**(-1) )
      Dt0g12 = Dt0g12 + dlomx**2 * ( 5.D0 + 3.D0*s13**(-1)*s23 - 3.D0*
     &    s12*s23**(-1) )
      Dt0g12 = Dt0g12 + dlx * (  - 4.D0 - 4.D0*s13**(-1)*s23 + 8.D0*s12
     &    *s23**(-1) )
      Dt0g12 = Dt0g12 + dlx*dls * ( 8.D0 + 8.D0*s13**(-1)*s23 - 8.D0*
     &    s12*s23**(-1) )
      Dt0g12 = Dt0g12 + dlx*dlomx * ( 2.D0 + 6.D0*s13**(-1)*s23 - 6.D0*
     &    s12*s23**(-1) )
      Dt0g12 = Dt0g12 + dlx**2 * ( 5.D0 + 3.D0*s13**(-1)*s23 - 3.D0*s12
     &    *s23**(-1) )
      Dt0g12 = Dt0g12 + 32.D0 + 32.D0*s13**(-1)*s23 - 32.D0*s12*
     &    s23**(-1)

      endif
      return
      end
