************************************************************************
!  All 2-loop amplitudes in this file are based on
! 
!  C.~Anastasiou, E.~W.~N.~Glover, C.~Oleari and M.~E.~Tejeda-Yeomans,
!  %``Two loop QCD corrections to massless identical quark scattering,''
!  Nucl. Phys. B \textbf{601} (2001), 341-360
!  doi:10.1016/S0550-3213(01)00080-3
!  [arXiv:hep-ph/0011094 [hep-ph]].
!  
!  C.~Anastasiou, E.~W.~N.~Glover, C.~Oleari and M.~E.~Tejeda-Yeomans,
!  %``One loop QCD corrections to quark scattering at NNLO,''
!  Phys. Lett. B \textbf{506} (2001), 59-67
!  doi:10.1016/S0370-2693(01)00356-2
!  [arXiv:hep-ph/0012007 [hep-ph]].
!  
************************************************************************
*
* identical four quark two loop matrix elements interfered with tree level
*                 plus one-loop matrix elements squared
*
*                      q1  qb2  q2  qb1
*
* summed over colour orderings, summed and squared
*
      function FullD0g2(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

c      write(*,*)" hello FullD0g2"
      fac=(as*nc/2d0/pi)**2*(4d0*pi*as*nc)**2*(nc**2-1d0)/float(nc)**3

      FullD0g2=                   +D0g2(iq1,iqb2,iq2,iqb1,renscale2)
     .        +float(nf)/float(nc)*Dh0g2(iq1,iqb2,iq2,iqb1,renscale2) 
     .  +float(nf)**2/float(nc)**2*Dhh0g2(iq1,iqb2,iq2,iqb1,renscale2) 
     .         +1d0/float(nc)**(2)*Dt0g2(iq1,iqb2,iq2,iqb1,renscale2)
     .   +float(nf)/float(nc)**(3)*Dth0g2(iq1,iqb2,iq2,iqb1,renscale2)
     .         +1d0/float(nc)**(4)*Dtt0g2(iq1,iqb2,iq2,iqb1,renscale2)

      FullD0g2=fac*FullD0g2

*c      write(*,*)"FullD0g2",FullD0g2
      return
      end
*
************************************************************************
*
      function D0g2(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        D0g2=finiteD0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        D0g2=finiteD0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        D0g2=finiteD0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        D0g2=finiteD0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        D0g2=finiteD0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        D0g2=finiteD0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        D0g2=finiteD0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        D0g2=finiteD0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        D0g2=finiteD0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        D0g2=finiteD0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        D0g2=finiteD0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        D0g2=finiteD0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        D0g2=finiteD0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        D0g2=finiteD0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        D0g2=finiteD0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        D0g2=finiteD0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        D0g2=finiteD0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        D0g2=finiteD0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        D0g2=finiteD0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        D0g2=finiteD0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        D0g2=finiteD0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        D0g2=finiteD0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        D0g2=finiteD0g21(iqb1,iq1,iqb2,iq2,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        D0g2=finiteD0g21(iqb1,iq1,iqb2,iq2,renscale2)
      endif
      return
      end
*
************************************************************************
*
      function Dh0g2(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dh0g2=finiteDh0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dh0g2=finiteDh0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dh0g2=finiteDh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dh0g2=finiteDh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dh0g2=finiteDh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dh0g2=finiteDh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dh0g2=finiteDh0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dh0g2=finiteDh0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dh0g2=finiteDh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dh0g2=finiteDh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dh0g2=finiteDh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dh0g2=finiteDh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dh0g2=finiteDh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dh0g2=finiteDh0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dh0g2=finiteDh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dh0g2=finiteDh0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dh0g2=finiteDh0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dh0g2=finiteDh0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dh0g2=finiteDh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dh0g2=finiteDh0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dh0g2=finiteDh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dh0g2=finiteDh0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dh0g2=finiteDh0g21(iqb1,iq1,iqb2,iq2,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dh0g2=finiteDh0g21(iqb1,iq1,iqb2,iq2,renscale2)
      endif
      return
      end
************************************************************************
*
      function Dhh0g2(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dhh0g2=finiteDhh0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dhh0g2=finiteDhh0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dhh0g2=finiteDhh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dhh0g2=finiteDhh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dhh0g2=finiteDhh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dhh0g2=finiteDhh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dhh0g2=finiteDhh0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dhh0g2=finiteDhh0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dhh0g2=finiteDhh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dhh0g2=finiteDhh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dhh0g2=finiteDhh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dhh0g2=finiteDhh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dhh0g2=finiteDhh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dhh0g2=finiteDhh0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dhh0g2=finiteDhh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dhh0g2=finiteDhh0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dhh0g2=finiteDhh0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dhh0g2=finiteDhh0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dhh0g2=finiteDhh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dhh0g2=finiteDhh0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dhh0g2=finiteDhh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dhh0g2=finiteDhh0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dhh0g2=finiteDhh0g21(iqb1,iq1,iqb2,iq2,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dhh0g2=finiteDhh0g21(iqb1,iq1,iqb2,iq2,renscale2)
      endif
      return
      end
************************************************************************
*
      function Dt0g2(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dt0g2=finiteDt0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dt0g2=finiteDt0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dt0g2=finiteDt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dt0g2=finiteDt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dt0g2=finiteDt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dt0g2=finiteDt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dt0g2=finiteDt0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dt0g2=finiteDt0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dt0g2=finiteDt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dt0g2=finiteDt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dt0g2=finiteDt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dt0g2=finiteDt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dt0g2=finiteDt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dt0g2=finiteDt0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dt0g2=finiteDt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dt0g2=finiteDt0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dt0g2=finiteDt0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dt0g2=finiteDt0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dt0g2=finiteDt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dt0g2=finiteDt0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dt0g2=finiteDt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dt0g2=finiteDt0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dt0g2=finiteDt0g21(iqb1,iq1,iqb2,iq2,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dt0g2=finiteDt0g21(iqb1,iq1,iqb2,iq2,renscale2)
      endif
      return
      end
************************************************************************
*
      function Dtt0g2(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dtt0g2=finiteDtt0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dtt0g2=finiteDtt0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dtt0g2=finiteDtt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dtt0g2=finiteDtt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dtt0g2=finiteDtt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dtt0g2=finiteDtt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dtt0g2=finiteDtt0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dtt0g2=finiteDtt0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dtt0g2=finiteDtt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dtt0g2=finiteDtt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dtt0g2=finiteDtt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dtt0g2=finiteDtt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dtt0g2=finiteDtt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dtt0g2=finiteDtt0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dtt0g2=finiteDtt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dtt0g2=finiteDtt0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dtt0g2=finiteDtt0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dtt0g2=finiteDtt0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dtt0g2=finiteDtt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dtt0g2=finiteDtt0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dtt0g2=finiteDtt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dtt0g2=finiteDtt0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dtt0g2=finiteDtt0g21(iqb1,iq1,iqb2,iq2,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dtt0g2=finiteDtt0g21(iqb1,iq1,iqb2,iq2,renscale2)
      endif
      return
      end
************************************************************************
*
      function Dth0g2(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dth0g2=finiteDth0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dth0g2=finiteDth0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dth0g2=finiteDth0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dth0g2=finiteDth0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dth0g2=finiteDth0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.1).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dth0g2=finiteDth0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.4))then
        Dth0g2=finiteDth0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.3))then
        Dth0g2=finiteDth0g21(iq1,iqb1,iq2,iqb2,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dth0g2=finiteDth0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.3).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dth0g2=finiteDth0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dth0g2=finiteDth0g22(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.2).and.(iqb2.eq.4).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dth0g2=finiteDth0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.4))then
        Dth0g2=finiteDth0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.1).and.(iq2.eq.4).and.(iqb1.eq.2))then
        Dth0g2=finiteDth0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.4))then
        Dth0g2=finiteDth0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.2).and.(iq2.eq.4).and.(iqb1.eq.1))then
        Dth0g2=finiteDth0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dth0g2=finiteDth0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.3).and.(iqb2.eq.4).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dth0g2=finiteDth0g21(iqb2,iq2,iqb1,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.2).and.(iqb1.eq.3))then
        Dth0g2=finiteDth0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.1).and.(iq2.eq.3).and.(iqb1.eq.2))then
        Dth0g2=finiteDth0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.1).and.(iqb1.eq.3))then
        Dth0g2=finiteDth0g21(iq1,iqb2,iq2,iqb1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.2).and.(iq2.eq.3).and.(iqb1.eq.1))then
        Dth0g2=finiteDth0g22(iqb1,iq2,iqb2,iq1,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.1).and.(iqb1.eq.2))then
        Dth0g2=finiteDth0g21(iqb1,iq1,iqb2,iq2,renscale2)
      elseif((iq1.eq.4).and.(iqb2.eq.3).and.(iq2.eq.2).and.(iqb1.eq.1))then
        Dth0g2=finiteDth0g21(iqb1,iq1,iqb2,iq2,renscale2)
      endif
      return
      end
************************************************************************
*
      function finiteD0g21(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteD0g21 =  0

      elseif(ieorder.eq.-3)then
      finiteD0g21 =  0

      elseif(ieorder.eq.-2)then
      finiteD0g21 =  0

      elseif(ieorder.eq.-1)then
      finiteD0g21 =  0

      elseif(ieorder.eq.0)then
      finiteD0g21 =  + zeta3 * ( 167.D0/9.D0 + 131.D0/9.D0*s12**(-1)*
     &    s23 - 347.D0/9.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + pi**2 * ( 79.D0/9.D0 - 6.D0*s12**(-2)
     &    *s23**2 + 16.D0/9.D0*s12**(-1)*s23 - 34.D0/9.D0*s13*s23**(-1)
     &     )
      finiteD0g21 = finiteD0g21 + pi**4 * ( 19.D0/60.D0 + 59.D0/60.D0*
     &    s12**(-1)*s23 - 121.D0/180.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dli4xx * ( 60.D0 - 4.D0*s12**(-1)*s23
     &     + 4.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dli4omx * ( 60.D0 - 4.D0*s12**(-1)*
     &    s23 + 4.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dli4x * (  - 4.D0 - 4.D0*s12**(-1)*
     &    s23 - 4.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dli3omx * ( 24.D0 + 24.D0*s12**(-1)*
     &    s23 + 24.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dli3x * ( 106.D0/3.D0 + 118.D0/3.D0*
     &    s12**(-1)*s23 - 46.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dli2x*pi**2 * (  - 2.D0/3.D0 - 14.D0/
     &    3.D0*s12**(-1)*s23 + 10.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dls * (  - 3349.D0/54.D0 - 3349.D0/54.
     &    D0*s12**(-1)*s23 + 3349.D0/54.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dls*zeta3 * (  - 28.D0 - 28.D0*
     &    s12**(-1)*s23 + 28.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dls*pi**2 * (  - 55.D0/6.D0 - 55.D0/6.
     &    D0*s12**(-1)*s23 + 55.D0/6.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dls**2 * ( 121.D0/3.D0 + 121.D0/3.D0*
     &    s12**(-1)*s23 - 121.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx * (  - 866.D0/27.D0 - 866.D0/27.
     &    D0*s12**(-1)*s23 + 866.D0/27.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx*zeta3 * (  - 52.D0 + 4.D0*
     &    s12**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx*pi**2 * (  - 227.D0/18.D0 - 227.
     &    D0/18.D0*s12**(-1)*s23 + 47.D0/18.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx*dli3x * ( 48.D0 - 8.D0*
     &    s12**(-1)*s23 + 8.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx*dli2x * ( 24.D0 + 24.D0*
     &    s12**(-1)*s23 + 24.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx*dls * ( 66.D0 + 66.D0*s12**(-1)
     &    *s23 - 66.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx**2 * ( 83.D0/3.D0 - 6.D0*
     &    s12**(-2)*s23**2 + 65.D0/3.D0*s12**(-1)*s23 - 101.D0/3.D0*s13
     &    *s23**(-1) - 6.D0*s13**2*s23**(-2) )
      finiteD0g21 = finiteD0g21 + dlomx**2*pi**2 * (  - 1.D0/3.D0 - 1.D0
     &    /3.D0*s12**(-1)*s23 + 1.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx**2*dls * (  - 22.D0 - 22.D0*
     &    s12**(-1)*s23 + 22.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx**3 * (  - 44.D0/9.D0 - 44.D0/9.D
     &    0*s12**(-1)*s23 + 44.D0/9.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlomx**4 * ( 1.D0/3.D0 + 1.D0/3.D0*
     &    s12**(-1)*s23 - 1.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx * (  - 539.D0/36.D0 - 539.D0/36.D0
     &    *s12**(-1)*s23 + 539.D0/36.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*zeta3 * ( 16.D0 - 20.D0*s12**(-1)
     &    *s23 + 16.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*pi**2 * (  - 115.D0/9.D0 - 178.D0/
     &    9.D0*s12**(-1)*s23 + 2.D0*s13**(-1)*s23 + 91.D0/9.D0*s13*
     &    s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dli3omx * (  - 12.D0 + 4.D0*
     &    s12**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dli3x * (  - 28.D0 + 8.D0*
     &    s12**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dli2x * (  - 106.D0/3.D0 - 118.D0/
     &    3.D0*s12**(-1)*s23 + 46.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dls * ( 22.D0/3.D0 + 22.D0/3.D0*
     &    s12**(-1)*s23 - 22.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dlomx * ( 22.D0/3.D0 + 12.D0*
     &    s12**(-2)*s23**2 + 58.D0/3.D0*s12**(-1)*s23 - 10.D0/3.D0*s13*
     &    s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dlomx*pi**2 * (  - 32.D0/3.D0 - 
     &    14.D0/3.D0*s12**(-1)*s23 + 8.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dlomx*dli2x * ( 8.D0*s12**(-1)*
     &    s23 - 8.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dlomx*dls * ( 22.D0 + 22.D0*
     &    s12**(-1)*s23 - 22.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dlomx**2 * ( 22.D0/3.D0 + 22.D0/3.
     &    D0*s12**(-1)*s23 + 44.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx*dlomx**3 * (  - 2.D0/3.D0 - 2.D0/
     &    3.D0*s12**(-1)*s23 + 2.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx**2 * ( 7.D0/9.D0 - 6.D0*s12**(-2)
     &    *s23**2 + 34.D0/9.D0*s12**(-1)*s23 - 106.D0/9.D0*s13*
     &    s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx**2*pi**2 * ( 2.D0 + 3.D0/2.D0*
     &    s12**(-1)*s23 + s13**(-2)*s23**2 + s13**(-1)*s23 - 1.D0/3.D0*
     &    s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx**2*dli2x * (  - 4.D0*s12**(-1)*
     &    s23 + 4.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx**2*dls * (  - 11.D0 - 11.D0*
     &    s12**(-1)*s23 + 11.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx**2*dlomx * ( 4.D0/3.D0 - 2.D0/3.D0
     &    *s12**(-1)*s23 + 8.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx**2*dlomx**2 * ( 29.D0/2.D0 + 15.D0
     &    /2.D0*s12**(-1)*s23 - 15.D0/2.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx**3 * (  - 119.D0/18.D0 - 61.D0/9.D
     &    0*s12**(-1)*s23 + s13**(-1)*s23 + 28.D0/9.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx**3*dlomx * (  - 41.D0/3.D0 - 16.D0
     &    /3.D0*s12**(-1)*s23 + 13.D0/3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + dlx**4 * ( 17.D0/6.D0 + s12**(-1)*s23
     &     + 1.D0/4.D0*s13**(-2)*s23**2 + 1.D0/4.D0*s13**(-1)*s23 - 1.D0
     &    /3.D0*s13*s23**(-1) )
      finiteD0g21 = finiteD0g21 + 24565.D0/648.D0 + 24565.D0/648.D0*
     &    s12**(-1)*s23 - 24565.D0/648.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteD0g22(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteD0g22 =  0

      elseif(ieorder.eq.-3)then
      finiteD0g22 =  0

      elseif(ieorder.eq.-2)then
      finiteD0g22 =  0

      elseif(ieorder.eq.-1)then
      finiteD0g22 =  0

      elseif(ieorder.eq.0)then
      finiteD0g22 =  + zeta3 * ( 970.D0/9.D0 + 485.D0/9.D0*s13**(-1)*
     &    s23 + 485.D0/9.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + pi**2 * (  - 236.D0/9.D0 - 73.D0/9.D0
     &    *s13**(-1)*s23 - 73.D0/9.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + pi**4 * ( 44.D0/45.D0 + 1.D0/4.D0*
     &    s12**(-2)*s23**2 + 1.D0/4.D0*s12**(-1)*s23 - 39.D0/20.D0*
     &    s13**(-1)*s23 - 23.D0/12.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dli4xx * ( 4.D0*s13**(-1)*s23 - 4.D0*
     &    s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dli4omx * (  - 56.D0 + 4.D0*s13**(-1)
     &    *s23 + 4.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dli4x * (  - 56.D0 + 4.D0*s13**(-1)*
     &    s23 + 4.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dli3omx * (  - 152.D0/3.D0 - 46.D0/3.D
     &    0*s13**(-1)*s23 - 118.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dli3x * (  - 152.D0/3.D0 - 118.D0/3.D0
     &    *s13**(-1)*s23 - 46.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dli2x*pi**2 * ( 2.D0/3.D0*s13**(-1)*
     &    s23 - 2.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dls * (  - 3349.D0/27.D0 - 3349.D0/54.
     &    D0*s13**(-1)*s23 - 3349.D0/54.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dls*zeta3 * (  - 56.D0 - 28.D0*
     &    s13**(-1)*s23 - 28.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dls*pi**2 * ( 11.D0/3.D0 + 11.D0/6.D0
     &    *s13**(-1)*s23 + 11.D0/6.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dls**2 * ( 242.D0/3.D0 + 121.D0/3.D0*
     &    s13**(-1)*s23 + 121.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx * (  - 539.D0/18.D0 - 539.D0/36.
     &    D0*s13**(-1)*s23 - 539.D0/36.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx*zeta3 * (  - 24.D0 - 12.D0*
     &    s13**(-1)*s23 - 12.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx*pi**2 * ( 241.D0/18.D0 - 
     &    s12**(-1)*s23 + 28.D0/9.D0*s13**(-1)*s23 + 112.D0/9.D0*s13*
     &    s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx*dli3omx * ( 24.D0 - 4.D0*
     &    s13**(-1)*s23 - 8.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx*dli3x * ( 16.D0 - 4.D0*s13*
     &    s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx*dli2x * (  - 152.D0/3.D0 - 46.D0
     &    /3.D0*s13**(-1)*s23 - 118.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx*dls * ( 44.D0/3.D0 + 22.D0/3.D0
     &    *s13**(-1)*s23 + 22.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx**2 * ( 113.D0/9.D0 + 106.D0/9.D0
     &    *s13**(-1)*s23 + 34.D0/9.D0*s13*s23**(-1) - 6.D0*s13**2*
     &    s23**(-2) )
      finiteD0g22 = finiteD0g22 + dlomx**2*pi**2 * ( 4.D0/3.D0 + 1.D0/2.
     &    D0*s12**(-2)*s23**2 + 1.D0/2.D0*s12**(-1)*s23 - 2.D0/3.D0*
     &    s13**(-1)*s23 - 1.D0/2.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx**2*dli2x * (  - 4.D0 - 4.D0*
     &    s13**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx**2*dls * (  - 22.D0 - 11.D0*
     &    s13**(-1)*s23 - 11.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx**3 * (  - 193.D0/18.D0 - 
     &    s12**(-1)*s23 - 28.D0/9.D0*s13**(-1)*s23 - 61.D0/9.D0*s13*
     &    s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlomx**4 * ( 5.D0/6.D0 + 1.D0/4.D0*
     &    s12**(-2)*s23**2 + 1.D0/4.D0*s12**(-1)*s23 + 1.D0/2.D0*
     &    s13**(-1)*s23 + 7.D0/6.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx * (  - 539.D0/18.D0 - 539.D0/36.D0
     &    *s13**(-1)*s23 - 539.D0/36.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx*zeta3 * (  - 24.D0 - 12.D0*
     &    s13**(-1)*s23 - 12.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx*pi**2 * ( 107.D0/18.D0 + 
     &    s12**(-1)*s23 + 53.D0/9.D0*s13**(-1)*s23 + 5.D0/9.D0*s13*
     &    s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx*dli3omx * ( 16.D0 - 4.D0*
     &    s13**(-1)*s23 )
      finiteD0g22 = finiteD0g22 + dlx*dli3x * ( 24.D0 - 8.D0*s13**(-1)*
     &    s23 - 4.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx*dli2x * ( 152.D0/3.D0 + 118.D0/3.D
     &    0*s13**(-1)*s23 + 46.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx*dls * ( 44.D0/3.D0 + 22.D0/3.D0*
     &    s13**(-1)*s23 + 22.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx*dlomx * (  - 190.D0/9.D0 - 176.D0/
     &    9.D0*s13**(-1)*s23 - 176.D0/9.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx*dlomx*pi**2 * ( 10.D0/3.D0 - 
     &    s12**(-2)*s23**2 - s12**(-1)*s23 + 7.D0*s13**(-1)*s23 + 7.D0*
     &    s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx*dlomx**2 * (  - 235.D0/6.D0 + 3.D0
     &    *s12**(-1)*s23 - 43.D0/3.D0*s13**(-1)*s23 - 88.D0/3.D0*s13*
     &    s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx*dlomx**3 * ( 4.D0/3.D0 - 
     &    s12**(-2)*s23**2 - s12**(-1)*s23 - s13**(-1)*s23 - 8.D0/3.D0*
     &    s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx**2 * ( 113.D0/9.D0 - 6.D0*
     &    s13**(-2)*s23**2 + 34.D0/9.D0*s13**(-1)*s23 + 106.D0/9.D0*s13
     &    *s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx**2*pi**2 * ( 2.D0/3.D0 + 1.D0/2.D0
     &    *s12**(-2)*s23**2 + 1.D0/2.D0*s12**(-1)*s23 - 5.D0/6.D0*
     &    s13**(-1)*s23 - 5.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx**2*dli2x * ( 4.D0 + 4.D0*
     &    s13**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx**2*dls * (  - 22.D0 - 11.D0*
     &    s13**(-1)*s23 - 11.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx**2*dlomx * ( 17.D0/2.D0 - 3.D0*
     &    s12**(-1)*s23 + 10.D0*s13**(-1)*s23 + s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx**2*dlomx**2 * ( 1.D0 + 3.D0/2.D0*
     &    s12**(-2)*s23**2 + 3.D0/2.D0*s12**(-1)*s23 - 7.D0/2.D0*
     &    s13**(-1)*s23 - 9.D0/2.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx**3 * (  - 175.D0/18.D0 + 
     &    s12**(-1)*s23 - 61.D0/9.D0*s13**(-1)*s23 - 28.D0/9.D0*s13*
     &    s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx**3*dlomx * ( 16.D0/3.D0 - 
     &    s12**(-2)*s23**2 - s12**(-1)*s23 + 2.D0/3.D0*s13**(-1)*s23 + 
     &    11.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + dlx**4 * ( 5.D0/6.D0 + 1.D0/4.D0*
     &    s12**(-2)*s23**2 + 1.D0/4.D0*s12**(-1)*s23 + 4.D0/3.D0*
     &    s13**(-1)*s23 + 1.D0/3.D0*s13*s23**(-1) )
      finiteD0g22 = finiteD0g22 + 24565.D0/324.D0 + 24565.D0/648.D0*
     &    s13**(-1)*s23 + 24565.D0/648.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDh0g21 =  0

      elseif(ieorder.eq.-3)then
      finiteDh0g21 =  0

      elseif(ieorder.eq.-2)then
      finiteDh0g21 =  0

      elseif(ieorder.eq.-1)then
      finiteDh0g21 =  0

      elseif(ieorder.eq.0)then
      finiteDh0g21 =  + zeta3 * (  - 86.D0/9.D0 - 86.D0/9.D0*s12**(-1)*
     &    s23 + 86.D0/9.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + pi**2 * (  - 2.D0/3.D0 - 2.D0/3.D0*
     &    s12**(-1)*s23 + 2.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dli3x * (  - 4.D0/3.D0 - 4.D0/3.D0*
     &    s12**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dls * ( 1100.D0/27.D0 + 1100.D0/27.D
     &    0*s12**(-1)*s23 - 1100.D0/27.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dls*pi**2 * ( 5.D0/3.D0 + 5.D0/3.D0
     &    *s12**(-1)*s23 - 5.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dls**2 * (  - 44.D0/3.D0 - 44.D0/3.D
     &    0*s12**(-1)*s23 + 44.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlomx * ( 428.D0/27.D0 + 428.D0/27.D
     &    0*s12**(-1)*s23 - 428.D0/27.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlomx*pi**2 * ( 25.D0/9.D0 + 25.D0/
     &    9.D0*s12**(-1)*s23 - 25.D0/9.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlomx*dls * (  - 12.D0 - 12.D0*
     &    s12**(-1)*s23 + 12.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlomx**2 * (  - 26.D0/3.D0 - 26.D0/
     &    3.D0*s12**(-1)*s23 + 26.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlomx**2*dls * ( 4.D0 + 4.D0*
     &    s12**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlomx**3 * ( 8.D0/9.D0 + 8.D0/9.D0*
     &    s12**(-1)*s23 - 8.D0/9.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx * ( 112.D0/9.D0 + 112.D0/9.D0*
     &    s12**(-1)*s23 - 112.D0/9.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx*pi**2 * ( 10.D0/9.D0 + 10.D0/9.D
     &    0*s12**(-1)*s23 - 10.D0/9.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx*dli2x * ( 4.D0/3.D0 + 4.D0/3.D0
     &    *s12**(-1)*s23 - 4.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx*dls * (  - 26.D0/3.D0 - 26.D0/3.
     &    D0*s12**(-1)*s23 + 26.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx*dlomx * ( 8.D0/3.D0 + 8.D0/3.D0
     &    *s12**(-1)*s23 - 8.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx*dlomx*dls * (  - 4.D0 - 4.D0*
     &    s12**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx*dlomx**2 * ( 2.D0/3.D0 + 2.D0/3.
     &    D0*s12**(-1)*s23 - 2.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx**2 * (  - 47.D0/9.D0 - 47.D0/9.D
     &    0*s12**(-1)*s23 + 47.D0/9.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx**2*dls * ( 2.D0 + 2.D0*
     &    s12**(-1)*s23 - 2.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx**2*dlomx * (  - 4.D0/3.D0 - 4.D0
     &    /3.D0*s12**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 + dlx**3 * ( 10.D0/9.D0 + 10.D0/9.D0*
     &    s12**(-1)*s23 - 10.D0/9.D0*s13*s23**(-1) )
      finiteDh0g21 = finiteDh0g21 - 2990.D0/81.D0 - 2990.D0/81.D0*
     &    s12**(-1)*s23 + 2990.D0/81.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDh0g22 =  0

      elseif(ieorder.eq.-3)then
      finiteDh0g22 =  0

      elseif(ieorder.eq.-2)then
      finiteDh0g22 =  0

      elseif(ieorder.eq.-1)then
      finiteDh0g22 =  0

      elseif(ieorder.eq.0)then
      finiteDh0g22 =  + zeta3 * (  - 196.D0/9.D0 - 98.D0/9.D0*s13**(-1)
     &    *s23 - 98.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + pi**2 * ( 50.D0/9.D0 + 25.D0/9.D0*
     &    s13**(-1)*s23 + 25.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dli3omx * ( 8.D0/3.D0 + 4.D0/3.D0*
     &    s13**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dli3x * ( 8.D0/3.D0 + 4.D0/3.D0*
     &    s13**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dls * ( 2200.D0/27.D0 + 1100.D0/27.D
     &    0*s13**(-1)*s23 + 1100.D0/27.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dls*pi**2 * (  - 2.D0/3.D0 - 1.D0/3.
     &    D0*s13**(-1)*s23 - 1.D0/3.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dls**2 * (  - 88.D0/3.D0 - 44.D0/3.D
     &    0*s13**(-1)*s23 - 44.D0/3.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlomx * ( 224.D0/9.D0 + 112.D0/9.D0
     &    *s13**(-1)*s23 + 112.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlomx*pi**2 * ( 4.D0/9.D0 + 2.D0/9.D
     &    0*s13**(-1)*s23 + 2.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlomx*dli2x * ( 8.D0/3.D0 + 4.D0/3.D
     &    0*s13**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlomx*dls * (  - 52.D0/3.D0 - 26.D0/
     &    3.D0*s13**(-1)*s23 - 26.D0/3.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlomx**2 * (  - 94.D0/9.D0 - 47.D0/
     &    9.D0*s13**(-1)*s23 - 47.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlomx**2*dls * ( 4.D0 + 2.D0*
     &    s13**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlomx**3 * ( 20.D0/9.D0 + 10.D0/9.D0
     &    *s13**(-1)*s23 + 10.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlx * ( 224.D0/9.D0 + 112.D0/9.D0*
     &    s13**(-1)*s23 + 112.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlx*pi**2 * ( 8.D0/9.D0 + 4.D0/9.D0
     &    *s13**(-1)*s23 + 4.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlx*dli2x * (  - 8.D0/3.D0 - 4.D0/3.
     &    D0*s13**(-1)*s23 - 4.D0/3.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlx*dls * (  - 52.D0/3.D0 - 26.D0/3.
     &    D0*s13**(-1)*s23 - 26.D0/3.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlx*dlomx * (  - 16.D0/9.D0 - 8.D0/
     &    9.D0*s13**(-1)*s23 - 8.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlx*dlomx**2 * ( 8.D0/3.D0 + 4.D0/3.
     &    D0*s13**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlx**2 * (  - 94.D0/9.D0 - 47.D0/9.D
     &    0*s13**(-1)*s23 - 47.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlx**2*dls * ( 4.D0 + 2.D0*
     &    s13**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 + dlx**3 * ( 20.D0/9.D0 + 10.D0/9.D0*
     &    s13**(-1)*s23 + 10.D0/9.D0*s13*s23**(-1) )
      finiteDh0g22 = finiteDh0g22 - 5980.D0/81.D0 - 2990.D0/81.D0*
     &    s13**(-1)*s23 - 2990.D0/81.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDhh0g21(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDhh0g21 =  0

      elseif(ieorder.eq.-3)then
      finiteDhh0g21 =  0

      elseif(ieorder.eq.-2)then
      finiteDhh0g21 =  0

      elseif(ieorder.eq.-1)then
      finiteDhh0g21 =  0

      elseif(ieorder.eq.0)then
      finiteDhh0g21 =  + pi**2 * (  - 4.D0/9.D0 - 4.D0/9.D0*s12**(-1)*
     &    s23 + 4.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g21 = finiteDhh0g21 + dls * (  - 40.D0/9.D0 - 40.D0/9.D0
     &    *s12**(-1)*s23 + 40.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g21 = finiteDhh0g21 + dls**2 * ( 4.D0/3.D0 + 4.D0/3.D0*
     &    s12**(-1)*s23 - 4.D0/3.D0*s13*s23**(-1) )
      finiteDhh0g21 = finiteDhh0g21 + dlx * (  - 20.D0/9.D0 - 20.D0/9.D0
     &    *s12**(-1)*s23 + 20.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g21 = finiteDhh0g21 + dlx*dls * ( 4.D0/3.D0 + 4.D0/3.D0
     &    *s12**(-1)*s23 - 4.D0/3.D0*s13*s23**(-1) )
      finiteDhh0g21 = finiteDhh0g21 + dlx**2 * ( 4.D0/9.D0 + 4.D0/9.D0*
     &    s12**(-1)*s23 - 4.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g21 = finiteDhh0g21 + 100.D0/27.D0 + 100.D0/27.D0*
     &    s12**(-1)*s23 - 100.D0/27.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDhh0g22(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDhh0g22 =  0

      elseif(ieorder.eq.-3)then
      finiteDhh0g22 =  0

      elseif(ieorder.eq.-2)then
      finiteDhh0g22 =  0

      elseif(ieorder.eq.-1)then
      finiteDhh0g22 =  0

      elseif(ieorder.eq.0)then
      finiteDhh0g22 =  + dls * (  - 80.D0/9.D0 - 40.D0/9.D0*s13**(-1)*
     &    s23 - 40.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g22 = finiteDhh0g22 + dls**2 * ( 8.D0/3.D0 + 4.D0/3.D0*
     &    s13**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1) )
      finiteDhh0g22 = finiteDhh0g22 + dlomx * (  - 40.D0/9.D0 - 20.D0/9.
     &    D0*s13**(-1)*s23 - 20.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g22 = finiteDhh0g22 + dlomx*dls * ( 8.D0/3.D0 + 4.D0/3.D
     &    0*s13**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1) )
      finiteDhh0g22 = finiteDhh0g22 + dlomx**2 * ( 8.D0/9.D0 + 4.D0/9.D0
     &    *s13**(-1)*s23 + 4.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g22 = finiteDhh0g22 + dlx * (  - 40.D0/9.D0 - 20.D0/9.D0
     &    *s13**(-1)*s23 - 20.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g22 = finiteDhh0g22 + dlx*dls * ( 8.D0/3.D0 + 4.D0/3.D0
     &    *s13**(-1)*s23 + 4.D0/3.D0*s13*s23**(-1) )
      finiteDhh0g22 = finiteDhh0g22 + dlx*dlomx * ( 8.D0/9.D0 + 4.D0/9.D
     &    0*s13**(-1)*s23 + 4.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g22 = finiteDhh0g22 + dlx**2 * ( 8.D0/9.D0 + 4.D0/9.D0*
     &    s13**(-1)*s23 + 4.D0/9.D0*s13*s23**(-1) )
      finiteDhh0g22 = finiteDhh0g22 + 200.D0/27.D0 + 100.D0/27.D0*
     &    s13**(-1)*s23 + 100.D0/27.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDt0g21 =  0

      elseif(ieorder.eq.-3)then
      finiteDt0g21 =  0

      elseif(ieorder.eq.-2)then
      finiteDt0g21 =  0

      elseif(ieorder.eq.-1)then
      finiteDt0g21 =  0

      elseif(ieorder.eq.0)then
      finiteDt0g21 =  + zeta3 * (  - 545.D0/9.D0 - 581.D0/9.D0*
     &    s12**(-1)*s23 + 581.D0/9.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + pi**2 * ( 34.D0/3.D0 - 8.D0*
     &    s12**(-2)*s23**2 + 13.D0/3.D0*s12**(-1)*s23 - 38.D0*s13*
     &    s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + pi**4 * ( 59.D0/36.D0 + 11.D0/36.D0
     &    *s12**(-1)*s23 - 31.D0/180.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dli4xx * (  - 16.D0 + 16.D0*
     &    s12**(-1)*s23 - 16.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dli4omx * (  - 16.D0 + 16.D0*
     &    s12**(-1)*s23 - 16.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dli4x * (  - 6.D0 - 6.D0*s12**(-1)*
     &    s23 - 6.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dli3x * ( 8.D0 + 12.D0*s12**(-1)*
     &    s23 - 12.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dli2x*pi**2 * ( 4.D0 + 12.D0*
     &    s12**(-1)*s23 - 12.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dls * (  - 4588.D0/27.D0 - 4588.D0/
     &    27.D0*s12**(-1)*s23 + 4588.D0/27.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dls*zeta3 * ( 4.D0 + 4.D0*s12**(-1)
     &    *s23 - 4.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dls*pi**2 * (  - 65.D0/6.D0 - 65.D0/
     &    6.D0*s12**(-1)*s23 + 65.D0/6.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlomx * (  - 3458.D0/27.D0 - 3458.D0
     &    /27.D0*s12**(-1)*s23 + 3458.D0/27.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlomx*zeta3 * (  - 12.D0 - 28.D0*
     &    s12**(-1)*s23 + 28.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlomx*pi**2 * (  - 563.D0/18.D0 - 
     &    563.D0/18.D0*s12**(-1)*s23 + 635.D0/18.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlomx*dli3x * ( 8.D0 + 24.D0*
     &    s12**(-1)*s23 - 24.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlomx*dls * ( 66.D0 + 66.D0*
     &    s12**(-1)*s23 - 66.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlomx**2 * ( 323.D0/3.D0 - 8.D0*
     &    s12**(-2)*s23**2 + 299.D0/3.D0*s12**(-1)*s23 - 347.D0/3.D0*
     &    s13*s23**(-1) - 8.D0*s13**2*s23**(-2) )
      finiteDt0g21 = finiteDt0g21 + dlomx**2*pi**2 * (  - 2.D0 - 2.D0*
     &    s12**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlomx**2*dls * (  - 22.D0 - 22.D0*
     &    s12**(-1)*s23 + 22.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlomx**3 * (  - 368.D0/9.D0 - 368.D0
     &    /9.D0*s12**(-1)*s23 + 368.D0/9.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlomx**4 * ( 4.D0 + 4.D0*s12**(-1)*
     &    s23 - 4.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx * (  - 142.D0/27.D0 - 142.D0/27.
     &    D0*s12**(-1)*s23 + 988.D0/27.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*zeta3 * (  - 4.D0 + 20.D0*
     &    s12**(-1)*s23 - 28.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*pi**2 * ( 17.D0/18.D0 + 209.D0/
     &    18.D0*s12**(-1)*s23 - 2.D0*s13**(-1)*s23 - 19.D0/2.D0*s13*
     &    s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dli3omx * ( 16.D0 - 16.D0*
     &    s12**(-1)*s23 + 16.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dli3x * ( 8.D0 - 16.D0*
     &    s12**(-1)*s23 + 24.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dli2x * (  - 8.D0 - 12.D0*
     &    s12**(-1)*s23 + 12.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dls * (  - 44.D0 - 44.D0*
     &    s12**(-1)*s23 + 22.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dlomx * (  - 194.D0/3.D0 + 16.D0
     &    *s12**(-2)*s23**2 - 146.D0/3.D0*s12**(-1)*s23 + 254.D0/3.D0*
     &    s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dlomx*pi**2 * ( 2.D0 + 6.D0*
     &    s12**(-1)*s23 - 2.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dlomx*dli2x * (  - 8.D0 - 24.D0
     &    *s12**(-1)*s23 + 24.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dlomx*dls * ( 22.D0 + 22.D0*
     &    s12**(-1)*s23 - 22.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dlomx**2 * ( 157.D0/3.D0 + 157.D
     &    0/3.D0*s12**(-1)*s23 - 145.D0/3.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx*dlomx**3 * (  - 8.D0 - 8.D0*
     &    s12**(-1)*s23 + 8.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx**2 * ( 44.D0/3.D0 - 8.D0*
     &    s12**(-2)*s23**2 - 22.D0*s12**(-1)*s23 - 7.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx**2*pi**2 * (  - 2.D0/3.D0 + 1.D0
     &    /3.D0*s12**(-1)*s23 - s13**(-2)*s23**2 - s13**(-1)*s23 - 4.D0/
     &    3.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx**2*dli2x * ( 3.D0 + 11.D0*
     &    s12**(-1)*s23 - 13.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx**2*dls * (  - 11.D0/2.D0 + 11.D0
     &    /2.D0*s12**(-1)*s23 - 11.D0/2.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx**2*dlomx * (  - 23.D0 - 19.D0*
     &    s12**(-1)*s23 + 15.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx**2*dlomx**2 * ( 3.D0 - 7.D0*
     &    s12**(-1)*s23 + 7.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx**3 * ( 11.D0/6.D0 + 31.D0/6.D0*
     &    s12**(-1)*s23 - s13**(-1)*s23 - 35.D0/9.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx**3*dlomx * ( 14.D0/3.D0 + 4.D0*
     &    s12**(-1)*s23 - 2.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + dlx**4 * (  - 7.D0/4.D0 - s12**(-1)
     &    *s23 - 1.D0/4.D0*s13**(-2)*s23**2 - 1.D0/4.D0*s13**(-1)*s23
     &     - 1.D0/12.D0*s13*s23**(-1) )
      finiteDt0g21 = finiteDt0g21 + 34403.D0/162.D0 + 34403.D0/162.D0*
     &    s12**(-1)*s23 - 34403.D0/162.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDt0g22 =  0

      elseif(ieorder.eq.-3)then
      finiteDt0g22 =  0

      elseif(ieorder.eq.-2)then
      finiteDt0g22 =  0

      elseif(ieorder.eq.-1)then
      finiteDt0g22 =  0

      elseif(ieorder.eq.0)then
      finiteDt0g22 =  + zeta3 * (  - 946.D0/9.D0 - 473.D0/9.D0*
     &    s13**(-1)*s23 - 473.D0/9.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + pi**2 * (  - 101.D0/3.D0 - 95.D0/3.D
     &    0*s13**(-1)*s23 - 95.D0/3.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + pi**4 * ( 313.D0/90.D0 - 1.D0/4.D0*
     &    s12**(-2)*s23**2 - 1.D0/4.D0*s12**(-1)*s23 + 47.D0/15.D0*
     &    s13**(-1)*s23 + 191.D0/60.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dli4xx * ( 6.D0*s13**(-1)*s23 - 6.D0
     &    *s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dli4omx * (  - 16.D0*s13**(-1)*s23
     &     - 16.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dli4x * (  - 16.D0*s13**(-1)*s23 - 
     &    16.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dli3omx * (  - 20.D0 - 12.D0*
     &    s13**(-1)*s23 - 12.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dli3x * (  - 20.D0 - 12.D0*
     &    s13**(-1)*s23 - 12.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dli2x*pi**2 * ( s13**(-1)*s23 - s13
     &    *s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dls * (  - 9176.D0/27.D0 - 4588.D0/
     &    27.D0*s13**(-1)*s23 - 4588.D0/27.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dls*zeta3 * ( 8.D0 + 4.D0*s13**(-1)
     &    *s23 + 4.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dls*pi**2 * ( 67.D0/3.D0 + 50.D0/3.D
     &    0*s13**(-1)*s23 + 50.D0/3.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx * (  - 1130.D0/27.D0 - 988.D0/
     &    27.D0*s13**(-1)*s23 - 142.D0/27.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx*zeta3 * ( 8.D0 + 4.D0*
     &    s13**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx*pi**2 * (  - 61.D0/18.D0 + 
     &    s12**(-1)*s23 + 5.D0/6.D0*s13**(-1)*s23 - 5.D0/9.D0*s13*
     &    s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx*dli3omx * ( 16.D0 + 24.D0*
     &    s13**(-1)*s23 + 16.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx*dli3x * ( 16.D0 + 8.D0*
     &    s13**(-1)*s23 )
      finiteDt0g22 = finiteDt0g22 + dlomx*dli2x * (  - 20.D0 - 12.D0*
     &    s13**(-1)*s23 - 12.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx*dls * (  - 66.D0 - 22.D0*
     &    s13**(-1)*s23 - 44.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx**2 * ( 65.D0/3.D0 + 7.D0*
     &    s13**(-1)*s23 - 22.D0*s13*s23**(-1) - 8.D0*s13**2*s23**(-2) )
      finiteDt0g22 = finiteDt0g22 + dlomx**2*pi**2 * (  - 20.D0 - 1.D0/
     &    2.D0*s12**(-2)*s23**2 - 1.D0/2.D0*s12**(-1)*s23 - 29.D0/3.D0*
     &    s13**(-1)*s23 - 65.D0/6.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx**2*dli2x * ( 16.D0 + 13.D0*
     &    s13**(-1)*s23 + 11.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx**2*dls * ( 11.D0/2.D0*
     &    s13**(-1)*s23 + 11.D0/2.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx**3 * ( 121.D0/18.D0 + 
     &    s12**(-1)*s23 + 35.D0/9.D0*s13**(-1)*s23 + 31.D0/6.D0*s13*
     &    s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlomx**4 * (  - 5.D0/3.D0 - 1.D0/4.D
     &    0*s12**(-2)*s23**2 - 1.D0/4.D0*s12**(-1)*s23 - 7.D0/12.D0*
     &    s13**(-1)*s23 - 5.D0/3.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx * (  - 1130.D0/27.D0 - 142.D0/
     &    27.D0*s13**(-1)*s23 - 988.D0/27.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*zeta3 * ( 8.D0 + 4.D0*s13**(-1)
     &    *s23 + 4.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*pi**2 * (  - 139.D0/18.D0 - 
     &    s12**(-1)*s23 - 23.D0/9.D0*s13**(-1)*s23 - 7.D0/6.D0*s13*
     &    s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dli3omx * ( 16.D0 + 8.D0*s13*
     &    s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dli3x * ( 16.D0 + 16.D0*
     &    s13**(-1)*s23 + 24.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dli2x * ( 20.D0 + 12.D0*
     &    s13**(-1)*s23 + 12.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dls * (  - 66.D0 - 44.D0*
     &    s13**(-1)*s23 - 22.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dlomx * ( 40.D0 + 146.D0/3.D0*
     &    s13**(-1)*s23 + 146.D0/3.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dlomx*pi**2 * ( 24.D0 + 
     &    s12**(-2)*s23**2 + s12**(-1)*s23 + 11.D0*s13**(-1)*s23 + 32.D0
     &    /3.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dlomx*dli2x * (  - 2.D0*
     &    s13**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dlomx*dls * (  - 44.D0 - 33.D0*
     &    s13**(-1)*s23 - 33.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dlomx**2 * (  - 13.D0/6.D0 - 3.D
     &    0*s12**(-1)*s23 - 19.D0/6.D0*s13**(-1)*s23 - 3.D0*s13*
     &    s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx*dlomx**3 * ( 16.D0 + s12**(-2)*
     &    s23**2 + s12**(-1)*s23 + 32.D0/3.D0*s13**(-1)*s23 + 11.D0*s13
     &    *s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx**2 * ( 65.D0/3.D0 - 8.D0*
     &    s13**(-2)*s23**2 - 22.D0*s13**(-1)*s23 + 7.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx**2*pi**2 * (  - 52.D0/3.D0 - 1.D
     &    0/2.D0*s12**(-2)*s23**2 - 1.D0/2.D0*s12**(-1)*s23 - 17.D0/2.D0
     &    *s13**(-1)*s23 - 8.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx**2*dli2x * (  - 16.D0 - 11.D0*
     &    s13**(-1)*s23 - 13.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx**2*dls * ( 11.D0/2.D0*s13**(-1)
     &    *s23 + 11.D0/2.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx**2*dlomx * ( 125.D0/6.D0 + 3.D0
     &    *s12**(-1)*s23 + 9.D0*s13**(-1)*s23 + 53.D0/6.D0*s13*
     &    s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx**2*dlomx**2 * ( 6.D0 - 3.D0/2.D0
     &    *s12**(-2)*s23**2 - 3.D0/2.D0*s12**(-1)*s23 + 3.D0*s13**(-1)*
     &    s23 + 7.D0/2.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx**3 * ( 103.D0/18.D0 - s12**(-1)
     &    *s23 + 31.D0/6.D0*s13**(-1)*s23 + 35.D0/9.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx**3*dlomx * ( s12**(-2)*s23**2
     &     + s12**(-1)*s23 - s13**(-1)*s23 - 4.D0/3.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + dlx**4 * (  - 5.D0/3.D0 - 1.D0/4.D0
     &    *s12**(-2)*s23**2 - 1.D0/4.D0*s12**(-1)*s23 - 17.D0/12.D0*
     &    s13**(-1)*s23 - 5.D0/6.D0*s13*s23**(-1) )
      finiteDt0g22 = finiteDt0g22 + 34403.D0/81.D0 + 34403.D0/162.D0*
     &    s13**(-1)*s23 + 34403.D0/162.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDtt0g21(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDtt0g21 =  0

      elseif(ieorder.eq.-3)then
      finiteDtt0g21 =  0

      elseif(ieorder.eq.-2)then
      finiteDtt0g21 =  0

      elseif(ieorder.eq.-1)then
      finiteDtt0g21 =  0

      elseif(ieorder.eq.0)then
      finiteDtt0g21 =  + zeta3 * (  - 30.D0 - 38.D0*s12**(-1)*s23 + 38.D
     &    0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + pi**2 * ( 43.D0/3.D0 - 2.D0*
     &    s12**(-2)*s23**2 + 40.D0/3.D0*s12**(-1)*s23 - 64.D0/3.D0*s13*
     &    s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + pi**4 * ( 17.D0/15.D0 + 7.D0/15.D0
     &    *s12**(-1)*s23 - 1.D0/45.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dli4xx * (  - 12.D0 + 4.D0*
     &    s12**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dli4omx * (  - 12.D0 + 4.D0*
     &    s12**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dli4x * (  - 10.D0 - 10.D0*
     &    s12**(-1)*s23 - 10.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dli3x * (  - 10.D0 - 2.D0*
     &    s12**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dli2x*pi**2 * (  - 2.D0/3.D0 + 10.
     &    D0/3.D0*s12**(-1)*s23 - 14.D0/3.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dls * ( 3.D0/2.D0 + 3.D0/2.D0*
     &    s12**(-1)*s23 - 3.D0/2.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dls*zeta3 * ( 24.D0 + 24.D0*
     &    s12**(-1)*s23 - 24.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dls*pi**2 * (  - 2.D0 - 2.D0*
     &    s12**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlomx * (  - 96.D0 - 96.D0*
     &    s12**(-1)*s23 + 96.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlomx*zeta3 * (  - 8.D0*s12**(-1)
     &    *s23 + 8.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlomx*pi**2 * (  - 28.D0/3.D0 - 
     &    28.D0/3.D0*s12**(-1)*s23 + 34.D0/3.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlomx*dli3x * ( 8.D0*s12**(-1)*
     &    s23 - 8.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlomx**2 * ( 48.D0 - 2.D0*
     &    s12**(-2)*s23**2 + 46.D0*s12**(-1)*s23 - 50.D0*s13*s23**(-1)
     &     - 2.D0*s13**2*s23**(-2) )
      finiteDtt0g21 = finiteDtt0g21 + dlomx**2*pi**2 * (  - 5.D0/3.D0
     &     - 5.D0/3.D0*s12**(-1)*s23 + 5.D0/3.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlomx**3 * (  - 12.D0 - 12.D0*
     &    s12**(-1)*s23 + 12.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlomx**4 * ( 1.D0 + s12**(-1)*s23
     &     - s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx * ( 275.D0/4.D0 + 275.D0/4.D0
     &    *s12**(-1)*s23 - 115.D0/4.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx*zeta3 * ( 12.D0*s12**(-1)*s23
     &     - 24.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx*pi**2 * ( 11.D0/3.D0 + 14.D0/
     &    3.D0*s12**(-1)*s23 - 2.D0*s13**(-1)*s23 + 1.D0/3.D0*s13*
     &    s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx*dli3omx * ( 12.D0 - 4.D0*
     &    s12**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx*dli3x * ( 12.D0 + 12.D0*s13*
     &    s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx*dli2x * ( 10.D0 + 2.D0*
     &    s12**(-1)*s23 - 2.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx*dlomx * (  - 48.D0 + 4.D0*
     &    s12**(-2)*s23**2 - 44.D0*s12**(-1)*s23 + 48.D0*s13*s23**(-1)
     &     )
      finiteDtt0g21 = finiteDtt0g21 + dlx*dlomx*pi**2 * ( 2.D0/3.D0 + 8.
     &    D0/3.D0*s12**(-1)*s23 - 2.D0/3.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx*dlomx*dli2x * (  - 8.D0*
     &    s12**(-1)*s23 + 8.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx*dlomx**2 * ( 19.D0 + 19.D0*
     &    s12**(-1)*s23 - 17.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx*dlomx**3 * (  - 2.D0 - 2.D0*
     &    s12**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx**2 * ( 33.D0/2.D0 - 2.D0*
     &    s12**(-2)*s23**2 - 17.D0/2.D0*s12**(-1)*s23 + 13.D0/2.D0*s13*
     &    s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx**2*pi**2 * (  - 1.D0/3.D0 - 7.
     &    D0/6.D0*s12**(-1)*s23 - s13**(-2)*s23**2 - s13**(-1)*s23 + 4.D
     &    0/3.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx**2*dli2x * (  - 1.D0 + 3.D0*
     &    s12**(-1)*s23 - 5.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx**2*dlomx * (  - 5.D0 - 3.D0*
     &    s12**(-1)*s23 + s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx**2*dlomx**2 * ( 3.D0/2.D0 - 7.
     &    D0/2.D0*s12**(-1)*s23 + 7.D0/2.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx**3 * (  - 2.D0/3.D0 - 5.D0/2.D
     &    0*s12**(-1)*s23 - s13**(-1)*s23 + 5.D0/6.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx**3*dlomx * ( 3.D0 + 8.D0/3.D0
     &    *s12**(-1)*s23 - 5.D0/3.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + dlx**4 * (  - 5.D0/4.D0 - 1.D0/6.D
     &    0*s12**(-1)*s23 - 1.D0/4.D0*s13**(-2)*s23**2 - 1.D0/4.D0*
     &    s13**(-1)*s23 - 1.D0/4.D0*s13*s23**(-1) )
      finiteDtt0g21 = finiteDtt0g21 + 1023.D0/8.D0 + 1023.D0/8.D0*
     &    s12**(-1)*s23 - 1023.D0/8.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDtt0g22(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDtt0g22 =  0

      elseif(ieorder.eq.-3)then
      finiteDtt0g22 =  0

      elseif(ieorder.eq.-2)then
      finiteDtt0g22 =  0

      elseif(ieorder.eq.-1)then
      finiteDtt0g22 =  0

      elseif(ieorder.eq.0)then
      finiteDtt0g22 =  + zeta3 * (  - 80.D0 - 40.D0*s13**(-1)*s23 - 40.D
     &    0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + pi**2 * (  - 55.D0/3.D0 - 127.D0/
     &    6.D0*s13**(-1)*s23 - 127.D0/6.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + pi**4 * ( 22.D0/15.D0 - 1.D0/4.D0
     &    *s12**(-2)*s23**2 - 1.D0/4.D0*s12**(-1)*s23 + 271.D0/180.D0*
     &    s13**(-1)*s23 + 143.D0/90.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dli4xx * ( 10.D0*s13**(-1)*s23 - 
     &    10.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dli4omx * ( 8.D0 - 4.D0*s13**(-1)
     &    *s23 - 4.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dli4x * ( 8.D0 - 4.D0*s13**(-1)*
     &    s23 - 4.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dli3omx * ( 12.D0 + 2.D0*
     &    s13**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dli3x * ( 12.D0 + 2.D0*s13**(-1)*
     &    s23 + 2.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dli2x*pi**2 * ( 5.D0/3.D0*
     &    s13**(-1)*s23 - 5.D0/3.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dls * ( 3.D0 + 3.D0/2.D0*
     &    s13**(-1)*s23 + 3.D0/2.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dls*zeta3 * ( 48.D0 + 24.D0*
     &    s13**(-1)*s23 + 24.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dls*pi**2 * (  - 4.D0 - 2.D0*
     &    s13**(-1)*s23 - 2.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx * ( 195.D0/2.D0 + 115.D0/4.D
     &    0*s13**(-1)*s23 + 275.D0/4.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx*zeta3 * ( 24.D0 + 12.D0*
     &    s13**(-1)*s23 + 12.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx*pi**2 * (  - 73.D0/6.D0 + 
     &    s12**(-1)*s23 - 31.D0/6.D0*s13**(-1)*s23 - 43.D0/6.D0*s13*
     &    s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx*dli3omx * ( 12.D0*s13**(-1)
     &    *s23 )
      finiteDtt0g22 = finiteDtt0g22 + dlomx*dli3x * ( 8.D0 + 8.D0*
     &    s13**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx*dli2x * ( 12.D0 + 2.D0*
     &    s13**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx**2 * ( 10.D0 - 13.D0/2.D0*
     &    s13**(-1)*s23 - 17.D0/2.D0*s13*s23**(-1) - 2.D0*s13**2*
     &    s23**(-2) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx**2*pi**2 * (  - 23.D0/3.D0
     &     - 1.D0/2.D0*s12**(-2)*s23**2 - 1.D0/2.D0*s12**(-1)*s23 - 3.D0
     &    *s13**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx**2*dli2x * ( 4.D0 + 5.D0*
     &    s13**(-1)*s23 + 3.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx**3 * (  - 1.D0/2.D0 + 
     &    s12**(-1)*s23 - 5.D0/6.D0*s13**(-1)*s23 - 5.D0/2.D0*s13*
     &    s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlomx**4 * (  - 2.D0/3.D0 - 1.D0/
     &    4.D0*s12**(-2)*s23**2 - 1.D0/4.D0*s12**(-1)*s23 + 1.D0/12.D0*
     &    s13**(-1)*s23 - 1.D0/3.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx * ( 195.D0/2.D0 + 275.D0/4.D0
     &    *s13**(-1)*s23 + 115.D0/4.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx*zeta3 * ( 24.D0 + 12.D0*
     &    s13**(-1)*s23 + 12.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx*pi**2 * (  - 67.D0/6.D0 - 
     &    s12**(-1)*s23 - 41.D0/6.D0*s13**(-1)*s23 - 29.D0/6.D0*s13*
     &    s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx*dli3omx * ( 8.D0 - 4.D0*
     &    s13**(-1)*s23 + 8.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx*dli3x * ( 12.D0*s13*s23**(-1)
     &     )
      finiteDtt0g22 = finiteDtt0g22 + dlx*dli2x * (  - 12.D0 - 2.D0*
     &    s13**(-1)*s23 - 2.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx*dlomx * ( 76.D0 + 61.D0*
     &    s13**(-1)*s23 + 61.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx*dlomx*pi**2 * ( 28.D0/3.D0 + 
     &    s12**(-2)*s23**2 + s12**(-1)*s23 + 10.D0/3.D0*s13**(-1)*s23
     &     + 3.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx*dlomx*dli2x * (  - 2.D0*
     &    s13**(-1)*s23 + 2.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx*dlomx**2 * ( 39.D0/2.D0 - 3.D0
     &    *s12**(-1)*s23 + 11.D0/2.D0*s13**(-1)*s23 + 25.D0/2.D0*s13*
     &    s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx*dlomx**3 * ( 10.D0/3.D0 + 
     &    s12**(-2)*s23**2 + s12**(-1)*s23 + 7.D0/3.D0*s13**(-1)*s23 + 
     &    s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx**2 * ( 10.D0 - 2.D0*s13**(-2)
     &    *s23**2 - 17.D0/2.D0*s13**(-1)*s23 - 13.D0/2.D0*s13*s23**(-1)
     &     )
      finiteDtt0g22 = finiteDtt0g22 + dlx**2*pi**2 * (  - 7.D0 - 1.D0/2.
     &    D0*s12**(-2)*s23**2 - 1.D0/2.D0*s12**(-1)*s23 - 8.D0/3.D0*
     &    s13**(-1)*s23 - 3.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx**2*dli2x * (  - 4.D0 - 3.D0*
     &    s13**(-1)*s23 - 5.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx**2*dlomx * ( 21.D0/2.D0 + 3.D0
     &    *s12**(-1)*s23 + 21.D0/2.D0*s13**(-1)*s23 + 7.D0/2.D0*s13*
     &    s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx**2*dlomx**2 * ( 4.D0 - 3.D0/2.
     &    D0*s12**(-2)*s23**2 - 3.D0/2.D0*s12**(-1)*s23 + 9.D0/2.D0*
     &    s13**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx**3 * (  - 3.D0/2.D0 - 
     &    s12**(-1)*s23 - 5.D0/2.D0*s13**(-1)*s23 - 5.D0/6.D0*s13*
     &    s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx**3*dlomx * (  - 2.D0/3.D0 + 
     &    s12**(-2)*s23**2 + s12**(-1)*s23 - 11.D0/3.D0*s13**(-1)*s23
     &     - s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + dlx**4 * (  - 2.D0/3.D0 - 1.D0/4.D
     &    0*s12**(-2)*s23**2 - 1.D0/4.D0*s12**(-1)*s23 + 1.D0/12.D0*
     &    s13**(-1)*s23 - 1.D0/3.D0*s13*s23**(-1) )
      finiteDtt0g22 = finiteDtt0g22 + 1023.D0/4.D0 + 1023.D0/8.D0*
     &    s13**(-1)*s23 + 1023.D0/8.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDth0g21(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iqb1)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iq2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDth0g21 =  0

      elseif(ieorder.eq.-3)then
      finiteDth0g21 =  0

      elseif(ieorder.eq.-2)then
      finiteDth0g21 =  0

      elseif(ieorder.eq.-1)then
      finiteDth0g21 =  0

      elseif(ieorder.eq.0)then
      finiteDth0g21 =  + zeta3 * (  - 58.D0/9.D0 - 58.D0/9.D0*s12**(-1)
     &    *s23 + 58.D0/9.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + pi**2 * (  - 10.D0/3.D0 - 10.D0/3.
     &    D0*s12**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dli3x * (  - 4.D0 - 4.D0*
     &    s12**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dls * ( 760.D0/27.D0 + 760.D0/27.D
     &    0*s12**(-1)*s23 - 760.D0/27.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dls*pi**2 * ( 7.D0/3.D0 + 7.D0/3.D
     &    0*s12**(-1)*s23 - 7.D0/3.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlomx * ( 428.D0/27.D0 + 428.D0/
     &    27.D0*s12**(-1)*s23 - 428.D0/27.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlomx*pi**2 * ( 25.D0/9.D0 + 25.D0
     &    /9.D0*s12**(-1)*s23 - 25.D0/9.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlomx*dls * (  - 12.D0 - 12.D0*
     &    s12**(-1)*s23 + 12.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlomx**2 * (  - 26.D0/3.D0 - 26.D0
     &    /3.D0*s12**(-1)*s23 + 26.D0/3.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlomx**2*dls * ( 4.D0 + 4.D0*
     &    s12**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlomx**3 * ( 8.D0/9.D0 + 8.D0/9.D0
     &    *s12**(-1)*s23 - 8.D0/9.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx * ( 40.D0/27.D0 + 40.D0/27.D0
     &    *s12**(-1)*s23 - 292.D0/27.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx*pi**2 * ( 5.D0/9.D0 - 1.D0/9.D
     &    0*s12**(-1)*s23 - s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx*dli2x * ( 4.D0 + 4.D0*
     &    s12**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx*dls * ( 8.D0 + 8.D0*s12**(-1)
     &    *s23 - 4.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx*dlomx * ( 8.D0/3.D0 + 8.D0/3.D
     &    0*s12**(-1)*s23 - 8.D0/3.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx*dlomx*dls * (  - 4.D0 - 4.D0*
     &    s12**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx*dlomx**2 * ( 2.D0/3.D0 + 2.D0/
     &    3.D0*s12**(-1)*s23 - 2.D0/3.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx**2 * ( 4.D0/3.D0 + 6.D0*
     &    s12**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx**2*dls * ( 1.D0 - s12**(-1)*
     &    s23 + s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 + dlx**3 * ( 1.D0/3.D0 - 2.D0/3.D0*
     &    s12**(-1)*s23 + 5.D0/9.D0*s13*s23**(-1) )
      finiteDth0g21 = finiteDth0g21 - 4180.D0/81.D0 - 4180.D0/81.D0*
     &    s12**(-1)*s23 + 4180.D0/81.D0*s13*s23**(-1)

      endif
      return
      end
************************************************************************
*
      function finiteDth0g22(iq1,iqb2,iq2,iqb1,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      double precision dli2x,dli2omx,dli3x,dli3omx,dli4x,dli4omx,dli4xx
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order2l/ieorder
      s12 =s4(iq1,iq2)
      s23 =s4(iq1,iqb2)
      s13 =s4(iq1,iqb1)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      dli2x   =rli2(-s23/s12)
      dli2omx =rli2(-s13/s12)
      dli3x   =rli3(-s23/s12)
      dli3omx =rli3(-s13/s12)
      dli4x   =rli4(-s23/s12)
      dli4omx =rli4(-s13/s12)
      dli4xx  =rli4(-s13/s23)
      if(ieorder.eq.-4)then
      finiteDth0g22 =  0

      elseif(ieorder.eq.-3)then
      finiteDth0g22 =  0

      elseif(ieorder.eq.-2)then
      finiteDth0g22 =  0

      elseif(ieorder.eq.-1)then
      finiteDth0g22 =  0

      elseif(ieorder.eq.0)then
      finiteDth0g22 =  + zeta3 * (  - 188.D0/9.D0 - 94.D0/9.D0*
     &    s13**(-1)*s23 - 94.D0/9.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + pi**2 * ( 26.D0/3.D0 + 20.D0/3.D0
     &    *s13**(-1)*s23 + 20.D0/3.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dli3omx * ( 8.D0 + 4.D0*s13**(-1)
     &    *s23 + 4.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dli3x * ( 8.D0 + 4.D0*s13**(-1)*
     &    s23 + 4.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dls * ( 1520.D0/27.D0 + 760.D0/27.
     &    D0*s13**(-1)*s23 + 760.D0/27.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dls*pi**2 * (  - 10.D0/3.D0 - 8.D0
     &    /3.D0*s13**(-1)*s23 - 8.D0/3.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlomx * ( 332.D0/27.D0 + 292.D0/
     &    27.D0*s13**(-1)*s23 + 40.D0/27.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlomx*pi**2 * (  - 28.D0/9.D0 - 2.
     &    D0*s13**(-1)*s23 - 19.D0/9.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlomx*dli2x * ( 8.D0 + 4.D0*
     &    s13**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlomx*dls * ( 12.D0 + 4.D0*
     &    s13**(-1)*s23 + 8.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlomx**2 * ( 16.D0/3.D0 + 4.D0*
     &    s13**(-1)*s23 + 6.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlomx**2*dls * (  - s13**(-1)*s23
     &     - s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlomx**3 * (  - 2.D0/9.D0 - 5.D0/
     &    9.D0*s13**(-1)*s23 - 2.D0/3.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx * ( 332.D0/27.D0 + 40.D0/27.D0
     &    *s13**(-1)*s23 + 292.D0/27.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx*pi**2 * (  - 16.D0/9.D0 - 13.D
     &    0/9.D0*s13**(-1)*s23 - 4.D0/3.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx*dli2x * (  - 8.D0 - 4.D0*
     &    s13**(-1)*s23 - 4.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx*dls * ( 12.D0 + 8.D0*
     &    s13**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx*dlomx * (  - 4.D0 - 20.D0/3.D0
     &    *s13**(-1)*s23 - 20.D0/3.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx*dlomx*dls * ( 8.D0 + 6.D0*
     &    s13**(-1)*s23 + 6.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx*dlomx**2 * ( 26.D0/3.D0 + 14.D
     &    0/3.D0*s13**(-1)*s23 + 5.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx**2 * ( 16.D0/3.D0 + 6.D0*
     &    s13**(-1)*s23 + 4.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx**2*dls * (  - s13**(-1)*s23
     &     - s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx**2*dlomx * ( 2.D0/3.D0 + 
     &    s13**(-1)*s23 + 2.D0/3.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 + dlx**3 * (  - 2.D0/9.D0 - 2.D0/3.D
     &    0*s13**(-1)*s23 - 5.D0/9.D0*s13*s23**(-1) )
      finiteDth0g22 = finiteDth0g22 - 8360.D0/81.D0 - 4180.D0/81.D0*
     &    s13**(-1)*s23 - 4180.D0/81.D0*s13*s23**(-1)

      endif
      return
      end
