!************************************************************************
!  All 1-loop amplitudes in this file are based on
!  Z.~Bern, L.~J.~Dixon and D.~A.~Kosower,
!  %``One loop corrections to five gluon amplitudes,''
!  Phys. Rev. Lett. \textbf{70} (1993), 2677-2680
!  doi:10.1103/PhysRevLett.70.2677
!  [arXiv:hep-ph/9302280 [hep-ph]].
!  
!  All 1-loop amplitudes in this file are based on
!  Z.~Bern, L.~J.~Dixon and D.~A.~Kosower,
!  %``One loop corrections to two quark three gluon amplitudes,''
!  Nucl. Phys. B \textbf{437} (1995), 259-304
!  doi:10.1016/0550-3213(94)00542-M
!  [arXiv:hep-ph/9409393 [hep-ph]].
!  
!  A. Signer,
!  Helicity method for next-to-leading order corrections in QCD
!  PhD thesis, 
!  ETH-Z¨urich Nr. 11143 (1995).
************************************************************************
*
* four gluon zero quark one loop matrix elements
*
* loop*tree interference between two colour orderings, M4g1(i1,i2,i3,i4)*M4g0(j1,j2,j3,j4)
* relevant for subleading colour subtraction terms
*
*
      function A4g1int(i1,i2,i3,i4,j1,j2,j3,j4,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      
      A4g1int=0d0
      
      l1=i1
      l2=i2
      l3=i3
      l4=i4

* cyclic symmetry      
      if((i1.eq.1).and.(i2.eq.3).and.(i3.eq.4).and.(i4.eq.2)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.1).and.(i2.eq.4).and.(i3.eq.2).and.(i4.eq.3)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.1).and.(i2.eq.4).and.(i3.eq.3).and.(i4.eq.2)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.2).and.(i2.eq.1).and.(i3.eq.3).and.(i4.eq.4)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.2).and.(i2.eq.1).and.(i3.eq.4).and.(i4.eq.3)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.2).and.(i2.eq.3).and.(i3.eq.1).and.(i4.eq.4)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.2).and.(i2.eq.3).and.(i3.eq.4).and.(i4.eq.1)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.2).and.(i2.eq.4).and.(i3.eq.1).and.(i4.eq.3)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.2).and.(i2.eq.4).and.(i3.eq.3).and.(i4.eq.1)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.3).and.(i2.eq.1).and.(i3.eq.2).and.(i4.eq.4)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.3).and.(i2.eq.1).and.(i3.eq.4).and.(i4.eq.2)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.3).and.(i2.eq.2).and.(i3.eq.1).and.(i4.eq.4)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.3).and.(i2.eq.2).and.(i3.eq.4).and.(i4.eq.1)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.3).and.(i2.eq.4).and.(i3.eq.1).and.(i4.eq.2)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.3).and.(i2.eq.4).and.(i3.eq.2).and.(i4.eq.1)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.4).and.(i2.eq.1).and.(i3.eq.2).and.(i4.eq.3)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.4).and.(i2.eq.1).and.(i3.eq.3).and.(i4.eq.2)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.4).and.(i2.eq.2).and.(i3.eq.1).and.(i4.eq.3)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.4).and.(i2.eq.2).and.(i3.eq.3).and.(i4.eq.1)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.4).and.(i2.eq.3).and.(i3.eq.1).and.(i4.eq.2)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.4).and.(i2.eq.3).and.(i3.eq.2).and.(i4.eq.1)) then
         l1=1; l2=2; l3=3; l4=4;      
      endif
        

      k1=j1
      k2=j2
      k3=j3
      k4=j4
     
* cyclic symmetry      
      if((j1.eq.1).and.(j2.eq.3).and.(j3.eq.4).and.(j4.eq.2)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.1).and.(j2.eq.4).and.(j3.eq.2).and.(j4.eq.3)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.1).and.(j2.eq.4).and.(j3.eq.3).and.(j4.eq.2)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.2).and.(j2.eq.1).and.(j3.eq.3).and.(j4.eq.4)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.2).and.(j2.eq.1).and.(j3.eq.4).and.(j4.eq.3)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.2).and.(j2.eq.3).and.(j3.eq.1).and.(j4.eq.4)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.2).and.(j2.eq.3).and.(j3.eq.4).and.(j4.eq.1)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.2).and.(j2.eq.4).and.(j3.eq.1).and.(j4.eq.3)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.2).and.(j2.eq.4).and.(j3.eq.3).and.(j4.eq.1)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.3).and.(j2.eq.1).and.(j3.eq.2).and.(j4.eq.4)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.3).and.(j2.eq.1).and.(j3.eq.4).and.(j4.eq.2)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.3).and.(j2.eq.2).and.(j3.eq.1).and.(j4.eq.4)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.3).and.(j2.eq.2).and.(j3.eq.4).and.(j4.eq.1)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.3).and.(j2.eq.4).and.(j3.eq.1).and.(j4.eq.2)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.3).and.(j2.eq.4).and.(j3.eq.2).and.(j4.eq.1)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.4).and.(j2.eq.1).and.(j3.eq.2).and.(j4.eq.3)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.4).and.(j2.eq.1).and.(j3.eq.3).and.(j4.eq.2)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.4).and.(j2.eq.2).and.(j3.eq.1).and.(j4.eq.3)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.4).and.(j2.eq.2).and.(j3.eq.3).and.(j4.eq.1)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.4).and.(j2.eq.3).and.(j3.eq.1).and.(j4.eq.2)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.4).and.(j2.eq.3).and.(j3.eq.2).and.(j4.eq.1)) then
         k1=1; k2=2; k3=3; k4=4;      
      endif

* helicity sum      
      call m4g1mmpp(l1,l2,l3,l4,zloop,renscale2)
      if(k2.eq.l2) call m4g0mmpp(k1,k2,k3,k4,ztree)
      if(k3.eq.l2) call m4g0mpmp(k1,k2,k3,k4,ztree)
      if(k4.eq.l2) call m4g0mmpp(k4,k1,k2,k3,ztree)
      A4g1int=A4g1int+Real(zloop*dconjg(ztree))
      
      call m4g1mpmp(l1,l2,l3,l4,zloop,renscale2)
      if(k2.eq.l3) call m4g0mmpp(k1,k2,k3,k4,ztree)
      if(k3.eq.l3) call m4g0mpmp(k1,k2,k3,k4,ztree)
      if(k4.eq.l3) call m4g0mmpp(k4,k1,k2,k3,ztree)
      A4g1int=A4g1int+Real(zloop*dconjg(ztree))
      
      call m4g1mmpp(l4,l1,l2,l3,zloop,renscale2)
      if(k2.eq.l4) call m4g0mmpp(k1,k2,k3,k4,ztree)
      if(k3.eq.l4) call m4g0mpmp(k1,k2,k3,k4,ztree)
      if(k4.eq.l4) call m4g0mmpp(k4,k1,k2,k3,ztree)
      A4g1int=A4g1int+Real(zloop*dconjg(ztree))
      
      call m4g1mmpp(l2,l3,l4,l1,zloop,renscale2)
      if(k2.eq.l4) call m4g0mmpp(k3,k4,k1,k2,ztree)
      if(k3.eq.l4) call m4g0mpmp(k2,k3,k4,k1,ztree)
      if(k4.eq.l4) call m4g0mmpp(k2,k3,k4,k1,ztree)
      A4g1int=A4g1int+Real(zloop*dconjg(ztree))
      
      call m4g1mpmp(l2,l3,l4,l1,zloop,renscale2)
      if(k2.eq.l3) call m4g0mmpp(k3,k4,k1,k2,ztree)
      if(k3.eq.l3) call m4g0mpmp(k2,k3,k4,k1,ztree)
      if(k4.eq.l3) call m4g0mmpp(k2,k3,k4,k1,ztree)
      A4g1int=A4g1int+Real(zloop*dconjg(ztree))
      
      call m4g1mmpp(l3,l4,l1,l2,zloop,renscale2)
      if(k2.eq.l2) call m4g0mmpp(k3,k4,k1,k2,ztree)
      if(k3.eq.l2) call m4g0mpmp(k4,k1,k2,k3,ztree)
      if(k4.eq.l2) call m4g0mmpp(k3,k2,k1,k4,ztree)
      A4g1int=A4g1int+Real(zloop*dconjg(ztree))
     
      return
      end





************************************************************************
*
* four gluon zero quark one-loop helicity amplitude one colour ordering
*
      subroutine m4g1mmpp(i1,i2,i3,i4,zloop,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)
      
      rs=0d0 !0=HV  1=FDH,DRED
      b0=11d0/3d0
                  
      zi=(0d0,1d0)
      
      za12=zA4(i1,i2)
      za23=zA4(i2,i3)
      za34=zA4(i3,i4)
      za41=zA4(i4,i1)
            
      s12=s4(i1,i2)
      s13=s4(i1,i3)
      s14=s4(i1,i4)
      s23=s4(i2,i3)
      s24=s4(i2,i4)
      s34=s4(i3,i4)

      ztree=zi*za12**(4)/(za12*za23*za34*za41)

      !hep-ph/9409393      
***vector pieces
      zVge2=-4d0
      zVge1=2d0*(zzlog(-s12)-zzlog(renscale2)
     &          +zzlog(-s23)-zzlog(renscale2))
      zVge0=-((zzlog(renscale2)-zzlog(-s12))**(2)
     &       +(zzlog(renscale2)-zzlog(-s23))**(2))
     &       +(zzlog(-s12)-zzlog(-s23))**(2)
     &       +pi**(2)-1d0/3d0+2d0/3d0*rs  !typo in BDK hep-ph/9409393 appendixII. Checked both rs schemes against njets of Badger

      zFge2=0d0
      zFge1=0d0
      zFge0=0d0

***fermion pieces      
      zVfe2=0d0
      zVfe1=-1d0
      zVfe0=zzlog(-s23)-zzlog(renscale2)-2d0
      
      zFfe2=0d0
      zFfe1=0d0
      zFfe0=0d0
      
***scalar pieces      
      zVse2=-zVfe2/3d0
      zVse1=-zVfe1/3d0
      zVse0=-zVfe0/3d0+2d0/9d0
      
      zFse2=0d0
      zFse1=0d0
      zFse0=0d0
      
      
      zA4ge2=(zVge2+zFge2)*ztree
      zA4ge1=(zVge1+zFge1)*ztree
      zA4ge0=(zVge0+zFge0)*ztree
      	
      zA4fe2=(zVfe2+zFfe2)*ztree
      zA4fe1=(zVfe1+zFfe1)*ztree
      zA4fe0=(zVfe0+zFfe0)*ztree

      zA4se2=(zVse2+zFse2)*ztree
      zA4se1=(zVse1+zFse1)*ztree
      zA4se0=(zVse0+zFse0)*ztree
      
      ze2=zA4ge2+4d0*zA4fe2+zA4se2
      ze1=zA4ge1+4d0*zA4fe1+zA4se1-b0*ztree
      ze0=zA4ge0+4d0*zA4fe0+zA4se0
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0
           
      if(ieorder.eq.-2) then      
        zloop=ze2
      endif
      if(ieorder.eq.-1) then      
        zloop=ze1
      endif
      if(ieorder.eq.0) then
        zloop=ze0
      endif 
      
      end
      


************************************************************************
*
* four gluon zero quark one-loop helicity amplitude one colour ordering
*
      subroutine m4g1mpmp(i1,i2,i3,i4,zloop,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)
      
      rs=0d0 !0=HV  1=FDH,DRED
      b0=11d0/3d0
                  
      zi=(0d0,1d0)
      
      za12=zA4(i1,i2)
      za13=zA4(i1,i3)
      za23=zA4(i2,i3)
      za34=zA4(i3,i4)
      za41=zA4(i4,i1)
            
      s12=s4(i1,i2)
      s13=s4(i1,i3)
      s14=s4(i1,i4)
      s23=s4(i2,i3)
      s24=s4(i2,i4)
      s34=s4(i3,i4)

      ztree=zi*za13**(4)/(za12*za23*za34*za41)

      !hep-ph/9409393      
***vector pieces
      zVge2=-4d0
      zVge1=2d0*(zzlog(-s12)-zzlog(renscale2)
     &          +zzlog(-s23)-zzlog(renscale2))
      zVge0=-((zzlog(renscale2)-zzlog(-s12))**(2)
     &       +(zzlog(renscale2)-zzlog(-s23))**(2))
     &       +(zzlog(-s12)-zzlog(-s23))**(2)
     &       +pi**(2)-1d0/3d0+2d0/3d0*rs  !typo in BDK hep-ph/9409393 appendixII. Checked both rs schemes against njets of Badger

      zFge2=0d0
      zFge1=0d0
      zFge0=0d0

***fermion pieces      
      zVfe2=0d0
      zVfe1=-1d0
      zVfe0=1d0/2d0*(zzlog(-s12)-zzlog(renscale2)
     &              +zzlog(-s23)-zzlog(renscale2))-2d0
      
      zFfe2=0d0
      zFfe1=0d0
      zFfe0=-s12*s23/(2d0*s13**(2))
     &*((zzlog(-s12)-zzlog(-s23))**(2)+pi**(2))
     &+1d0/2d0*(s12-s23)/s13*(zzlog(-s12)-zzlog(-s23))
      
***scalar pieces      
      zVse2=-zVfe2/3d0
      zVse1=-zVfe1/3d0
      zVse0=-zVfe0/3d0+2d0/9d0
      
      zFse2=0d0
      zFse1=0d0
      zFse0=(-s12*s23/s13**(2))*(-s12*s23/s13**(2)
     &*((zzlog(-s12)-zzlog(-s23))**(2)+pi**(2))
     &+(s12-s23)/s13*(1d0+s13**(2)/(6d0*s12*s23))
     &*(zzlog(-s12)-zzlog(-s23))+1d0)
      
      
      zA4ge2=(zVge2+zFge2)*ztree
      zA4ge1=(zVge1+zFge1)*ztree
      zA4ge0=(zVge0+zFge0)*ztree
      	
      zA4fe2=(zVfe2+zFfe2)*ztree
      zA4fe1=(zVfe1+zFfe1)*ztree
      zA4fe0=(zVfe0+zFfe0)*ztree

      zA4se2=(zVse2+zFse2)*ztree
      zA4se1=(zVse1+zFse1)*ztree
      zA4se0=(zVse0+zFse0)*ztree

      ze2=zA4ge2+4d0*zA4fe2+zA4se2
      ze1=zA4ge1+4d0*zA4fe1+zA4se1-b0*ztree
      ze0=zA4ge0+4d0*zA4fe0+zA4se0      
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0
           
      if(ieorder.eq.-2) then      
        zloop=ze2
      endif
      if(ieorder.eq.-1) then      
        zloop=ze1
      endif
      if(ieorder.eq.0) then
        zloop=ze0
      endif 
      
      end

************************************************************************
*
* four gluon zero quark one loop matrix elements
*
* loop*tree interference between two colour orderings, Mh4g1(i1,i2,i3,i4)*M4g0(j1,j2,j3,j4)
* relevant for subleading colour subtraction terms
* part proportional to NF
*
*
      function Ah4g1int(i1,i2,i3,i4,j1,j2,j3,j4,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      
      Ah4g1int=0d0
      
      l1=i1
      l2=i2
      l3=i3
      l4=i4

* cyclic symmetry      
      if((i1.eq.1).and.(i2.eq.3).and.(i3.eq.4).and.(i4.eq.2)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.1).and.(i2.eq.4).and.(i3.eq.2).and.(i4.eq.3)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.1).and.(i2.eq.4).and.(i3.eq.3).and.(i4.eq.2)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.2).and.(i2.eq.1).and.(i3.eq.3).and.(i4.eq.4)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.2).and.(i2.eq.1).and.(i3.eq.4).and.(i4.eq.3)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.2).and.(i2.eq.3).and.(i3.eq.1).and.(i4.eq.4)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.2).and.(i2.eq.3).and.(i3.eq.4).and.(i4.eq.1)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.2).and.(i2.eq.4).and.(i3.eq.1).and.(i4.eq.3)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.2).and.(i2.eq.4).and.(i3.eq.3).and.(i4.eq.1)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.3).and.(i2.eq.1).and.(i3.eq.2).and.(i4.eq.4)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.3).and.(i2.eq.1).and.(i3.eq.4).and.(i4.eq.2)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.3).and.(i2.eq.2).and.(i3.eq.1).and.(i4.eq.4)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.3).and.(i2.eq.2).and.(i3.eq.4).and.(i4.eq.1)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.3).and.(i2.eq.4).and.(i3.eq.1).and.(i4.eq.2)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.3).and.(i2.eq.4).and.(i3.eq.2).and.(i4.eq.1)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.4).and.(i2.eq.1).and.(i3.eq.2).and.(i4.eq.3)) then
         l1=1; l2=2; l3=3; l4=4;
      elseif((i1.eq.4).and.(i2.eq.1).and.(i3.eq.3).and.(i4.eq.2)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.4).and.(i2.eq.2).and.(i3.eq.1).and.(i4.eq.3)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.4).and.(i2.eq.2).and.(i3.eq.3).and.(i4.eq.1)) then
         l1=1; l2=3; l3=2; l4=4;
      elseif((i1.eq.4).and.(i2.eq.3).and.(i3.eq.1).and.(i4.eq.2)) then
         l1=1; l2=2; l3=4; l4=3;
      elseif((i1.eq.4).and.(i2.eq.3).and.(i3.eq.2).and.(i4.eq.1)) then
         l1=1; l2=2; l3=3; l4=4;      
      endif
        

      k1=j1
      k2=j2
      k3=j3
      k4=j4
     
* cyclic symmetry      
      if((j1.eq.1).and.(j2.eq.3).and.(j3.eq.4).and.(j4.eq.2)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.1).and.(j2.eq.4).and.(j3.eq.2).and.(j4.eq.3)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.1).and.(j2.eq.4).and.(j3.eq.3).and.(j4.eq.2)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.2).and.(j2.eq.1).and.(j3.eq.3).and.(j4.eq.4)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.2).and.(j2.eq.1).and.(j3.eq.4).and.(j4.eq.3)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.2).and.(j2.eq.3).and.(j3.eq.1).and.(j4.eq.4)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.2).and.(j2.eq.3).and.(j3.eq.4).and.(j4.eq.1)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.2).and.(j2.eq.4).and.(j3.eq.1).and.(j4.eq.3)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.2).and.(j2.eq.4).and.(j3.eq.3).and.(j4.eq.1)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.3).and.(j2.eq.1).and.(j3.eq.2).and.(j4.eq.4)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.3).and.(j2.eq.1).and.(j3.eq.4).and.(j4.eq.2)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.3).and.(j2.eq.2).and.(j3.eq.1).and.(j4.eq.4)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.3).and.(j2.eq.2).and.(j3.eq.4).and.(j4.eq.1)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.3).and.(j2.eq.4).and.(j3.eq.1).and.(j4.eq.2)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.3).and.(j2.eq.4).and.(j3.eq.2).and.(j4.eq.1)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.4).and.(j2.eq.1).and.(j3.eq.2).and.(j4.eq.3)) then
         k1=1; k2=2; k3=3; k4=4;
      elseif((j1.eq.4).and.(j2.eq.1).and.(j3.eq.3).and.(j4.eq.2)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.4).and.(j2.eq.2).and.(j3.eq.1).and.(j4.eq.3)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.4).and.(j2.eq.2).and.(j3.eq.3).and.(j4.eq.1)) then
         k1=1; k2=3; k3=2; k4=4;
      elseif((j1.eq.4).and.(j2.eq.3).and.(j3.eq.1).and.(j4.eq.2)) then
         k1=1; k2=2; k3=4; k4=3;
      elseif((j1.eq.4).and.(j2.eq.3).and.(j3.eq.2).and.(j4.eq.1)) then
         k1=1; k2=2; k3=3; k4=4;      
      endif

* helicity sum      
      call mh4g1mmpp(l1,l2,l3,l4,zloop,renscale2)
      if(k2.eq.l2) call m4g0mmpp(k1,k2,k3,k4,ztree)
      if(k3.eq.l2) call m4g0mpmp(k1,k2,k3,k4,ztree)
      if(k4.eq.l2) call m4g0mmpp(k4,k1,k2,k3,ztree)
      Ah4g1int=Ah4g1int+Real(zloop*dconjg(ztree))
      
      call mh4g1mpmp(l1,l2,l3,l4,zloop,renscale2)
      if(k2.eq.l3) call m4g0mmpp(k1,k2,k3,k4,ztree)
      if(k3.eq.l3) call m4g0mpmp(k1,k2,k3,k4,ztree)
      if(k4.eq.l3) call m4g0mmpp(k4,k1,k2,k3,ztree)
      Ah4g1int=Ah4g1int+Real(zloop*dconjg(ztree))
      
      call mh4g1mmpp(l4,l1,l2,l3,zloop,renscale2)
      if(k2.eq.l4) call m4g0mmpp(k1,k2,k3,k4,ztree)
      if(k3.eq.l4) call m4g0mpmp(k1,k2,k3,k4,ztree)
      if(k4.eq.l4) call m4g0mmpp(k4,k1,k2,k3,ztree)
      Ah4g1int=Ah4g1int+Real(zloop*dconjg(ztree))
      
      call mh4g1mmpp(l2,l3,l4,l1,zloop,renscale2)
      if(k2.eq.l4) call m4g0mmpp(k3,k4,k1,k2,ztree)
      if(k3.eq.l4) call m4g0mpmp(k2,k3,k4,k1,ztree)
      if(k4.eq.l4) call m4g0mmpp(k2,k3,k4,k1,ztree)
      Ah4g1int=Ah4g1int+Real(zloop*dconjg(ztree))
      
      call mh4g1mpmp(l2,l3,l4,l1,zloop,renscale2)
      if(k2.eq.l3) call m4g0mmpp(k3,k4,k1,k2,ztree)
      if(k3.eq.l3) call m4g0mpmp(k2,k3,k4,k1,ztree)
      if(k4.eq.l3) call m4g0mmpp(k2,k3,k4,k1,ztree)
      Ah4g1int=Ah4g1int+Real(zloop*dconjg(ztree))
      
      call mh4g1mmpp(l3,l4,l1,l2,zloop,renscale2)
      if(k2.eq.l2) call m4g0mmpp(k3,k4,k1,k2,ztree)
      if(k3.eq.l2) call m4g0mpmp(k4,k1,k2,k3,ztree)
      if(k4.eq.l2) call m4g0mmpp(k3,k2,k1,k4,ztree)
      Ah4g1int=Ah4g1int+Real(zloop*dconjg(ztree))
     
      return
      end

************************************************************************
*
* four gluon zero quark one-loop helicity amplitude one colour ordering
* part proportional to NF
*
      subroutine mh4g1mmpp(i1,i2,i3,i4,zloop,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)
      
      rs=0d0 !0=HV  1=FDH,DRED
      bF=-2d0/3d0
                  
      zi=(0d0,1d0)
      
      za12=zA4(i1,i2)
      za23=zA4(i2,i3)
      za34=zA4(i3,i4)
      za41=zA4(i4,i1)
            
      s12=s4(i1,i2)
      s13=s4(i1,i3)
      s14=s4(i1,i4)
      s23=s4(i2,i3)
      s24=s4(i2,i4)
      s34=s4(i3,i4)

      ztree=zi*za12**(4)/(za12*za23*za34*za41)

      !hep-ph/9409393      

***fermion pieces      
      zVfe2=0d0
      zVfe1=-1d0
      zVfe0=zzlog(-s23)-zzlog(renscale2)-2d0
      
      zFfe2=0d0
      zFfe1=0d0
      zFfe0=0d0
      
***scalar pieces      
      zVse2=-zVfe2/3d0
      zVse1=-zVfe1/3d0
      zVse0=-zVfe0/3d0+2d0/9d0
      
      zFse2=0d0
      zFse1=0d0
      zFse0=0d0
          	
      zA4fe2=(zVfe2+zFfe2)*ztree
      zA4fe1=(zVfe1+zFfe1)*ztree
      zA4fe0=(zVfe0+zFfe0)*ztree

      zA4se2=(zVse2+zFse2)*ztree
      zA4se1=(zVse1+zFse1)*ztree
      zA4se0=(zVse0+zFse0)*ztree
      
      ze2=-zA4fe2-zA4se2
      ze1=-zA4fe1-zA4se1-bF*ztree
      ze0=-zA4fe0-zA4se0
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0
           
      if(ieorder.eq.-2) then      
        zloop=ze2
      endif
      if(ieorder.eq.-1) then      
        zloop=ze1
      endif
      if(ieorder.eq.0) then
        zloop=ze0
      endif 
      
      end
      
************************************************************************
*
* four gluon zero quark one-loop helicity amplitude one colour ordering
* part proportional to NF
*
      subroutine mh4g1mpmp(i1,i2,i3,i4,zloop,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)
      
      rs=0d0 !0=HV  1=FDH,DRED
      bF=-2d0/3d0
                  
      zi=(0d0,1d0)
      
      za12=zA4(i1,i2)
      za13=zA4(i1,i3)
      za23=zA4(i2,i3)
      za34=zA4(i3,i4)
      za41=zA4(i4,i1)
            
      s12=s4(i1,i2)
      s13=s4(i1,i3)
      s14=s4(i1,i4)
      s23=s4(i2,i3)
      s24=s4(i2,i4)
      s34=s4(i3,i4)

      ztree=zi*za13**(4)/(za12*za23*za34*za41)

      !hep-ph/9409393      

***fermion pieces      
      zVfe2=0d0
      zVfe1=-1d0
      zVfe0=1d0/2d0*(zzlog(-s12)-zzlog(renscale2)
     &              +zzlog(-s23)-zzlog(renscale2))-2d0
      
      zFfe2=0d0
      zFfe1=0d0
      zFfe0=-s12*s23/(2d0*s13**(2))
     &*((zzlog(-s12)-zzlog(-s23))**(2)+pi**(2))
     &+1d0/2d0*(s12-s23)/s13*(zzlog(-s12)-zzlog(-s23))
      
***scalar pieces      
      zVse2=-zVfe2/3d0
      zVse1=-zVfe1/3d0
      zVse0=-zVfe0/3d0+2d0/9d0
      
      zFse2=0d0
      zFse1=0d0
      zFse0=(-s12*s23/s13**(2))*(-s12*s23/s13**(2)
     &*((zzlog(-s12)-zzlog(-s23))**(2)+pi**(2))
     &+(s12-s23)/s13*(1d0+s13**(2)/(6d0*s12*s23))
     &*(zzlog(-s12)-zzlog(-s23))+1d0)
           	
      zA4fe2=(zVfe2+zFfe2)*ztree
      zA4fe1=(zVfe1+zFfe1)*ztree
      zA4fe0=(zVfe0+zFfe0)*ztree

      zA4se2=(zVse2+zFse2)*ztree
      zA4se1=(zVse1+zFse1)*ztree
      zA4se0=(zVse0+zFse0)*ztree

      ze2=-zA4fe2-zA4se2
      ze1=-zA4fe1-zA4se1-bF*ztree
      ze0=-zA4fe0-zA4se0      
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0
           
      if(ieorder.eq.-2) then      
        zloop=ze2
      endif
      if(ieorder.eq.-1) then      
        zloop=ze1
      endif
      if(ieorder.eq.0) then
        zloop=ze0
      endif 
      
      end


************************************************************************
*
* five gluon zero quark one loop matrix elements interfered with tree level
*
*
* summed over colour orderings, summed and squared
*
      function FullA5g1(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      common /order/ieorder
      common /iregions/ isoft,icol1,icol2,ihard

      fac=(as*nc/2d0/pi)*(4d0*pi*as*nc)**3*(nc**2-1d0)*2d0

      FullA5g1=  +A5g1(i1,i2,i3,i4,i5,renscale2)
     .           +A5g1(i1,i2,i3,i5,i4,renscale2)
     .           +A5g1(i1,i2,i4,i3,i5,renscale2)
     .           +A5g1(i1,i2,i4,i5,i3,renscale2)
     .           +A5g1(i1,i2,i5,i3,i4,renscale2)
     .           +A5g1(i1,i2,i5,i4,i3,renscale2)
     .           +A5g1(i1,i3,i2,i4,i5,renscale2)
     .           +A5g1(i1,i3,i2,i5,i4,renscale2)
     .           +A5g1(i1,i4,i2,i3,i5,renscale2)
     .           +A5g1(i1,i4,i2,i5,i3,renscale2)
     .           +A5g1(i1,i5,i2,i3,i4,renscale2)
     .           +A5g1(i1,i5,i2,i4,i3,renscale2)
     .  +dble(nf)/dble(nc)*(
     .           +Ah5g1(i1,i2,i3,i4,i5,renscale2)
     .           +Ah5g1(i1,i2,i3,i5,i4,renscale2)
     .           +Ah5g1(i1,i2,i4,i3,i5,renscale2)
     .           +Ah5g1(i1,i2,i4,i5,i3,renscale2)
     .           +Ah5g1(i1,i2,i5,i3,i4,renscale2)
     .           +Ah5g1(i1,i2,i5,i4,i3,renscale2)
     .           +Ah5g1(i1,i3,i2,i4,i5,renscale2)
     .           +Ah5g1(i1,i3,i2,i5,i4,renscale2)
     .           +Ah5g1(i1,i4,i2,i3,i5,renscale2)
     .           +Ah5g1(i1,i4,i2,i5,i3,renscale2)
     .           +Ah5g1(i1,i5,i2,i3,i4,renscale2)
     .           +Ah5g1(i1,i5,i2,i4,i3,renscale2))
     .  +12d0/dble(nc)**2*(
     .           +At5g1(i1,i2,i3,i4,i5,renscale2)
     .           +At5g1(i1,i2,i3,i5,i4,renscale2)
     .           +At5g1(i1,i2,i4,i3,i5,renscale2)
     .           +At5g1(i1,i2,i4,i5,i3,renscale2)
     .           +At5g1(i1,i2,i5,i3,i4,renscale2)
     .           +At5g1(i1,i2,i5,i4,i3,renscale2)
     .           +At5g1(i1,i3,i2,i4,i5,renscale2)
     .           +At5g1(i1,i3,i2,i5,i4,renscale2)
     .           +At5g1(i1,i4,i2,i3,i5,renscale2)
     .           +At5g1(i1,i4,i2,i5,i3,renscale2)
     .           +At5g1(i1,i5,i2,i3,i4,renscale2)
     .           +At5g1(i1,i5,i2,i4,i3,renscale2))
     .  +2d0*dble(nf)/dble(nc)**3*(
     .           +Ath5g1(i1,i2,i3,i4,i5,renscale2)
     .           +Ath5g1(i1,i2,i3,i5,i4,renscale2)
     .           +Ath5g1(i1,i2,i4,i3,i5,renscale2)
     .           +Ath5g1(i1,i2,i4,i5,i3,renscale2)
     .           +Ath5g1(i1,i2,i5,i3,i4,renscale2)
     .           +Ath5g1(i1,i2,i5,i4,i3,renscale2)
     .           +Ath5g1(i1,i3,i2,i4,i5,renscale2)
     .           +Ath5g1(i1,i3,i2,i5,i4,renscale2)
     .           +Ath5g1(i1,i4,i2,i3,i5,renscale2)
     .           +Ath5g1(i1,i4,i2,i5,i3,renscale2)
     .           +Ath5g1(i1,i5,i2,i3,i4,renscale2)
     .           +Ath5g1(i1,i5,i2,i4,i3,renscale2))

       FullA5g1=FullA5g1*fac
*      write(*,*)"FullA5g1",FullA5g1
*
      return
      end
************************************************************************
*
* five gluon zero quark tree level matrix elements interfered with tree level
*
* leading colour
* one colour ordering, summed and squared
*
*
      function A5g1(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /scheme/ deltaR
      deltaR=1d0

*      write(*,*)" hello A5g1 "

      A5g1= A5g1mmppp(i1,i2,i3,i4,i5,renscale2)
     .     +A5g1mpmpp(i1,i2,i3,i4,i5,renscale2)
     .     +A5g1mpmpp(i4,i5,i1,i2,i3,renscale2)
     .     +A5g1mmppp(i5,i1,i2,i3,i4,renscale2)
     .     +A5g1mmppp(i2,i3,i4,i5,i1,renscale2)
     .     +A5g1mpmpp(i2,i3,i4,i5,i1,renscale2)
     .     +A5g1mpmpp(i5,i1,i2,i3,i4,renscale2)
     .     +A5g1mmppp(i3,i4,i5,i1,i2,renscale2)
     .     +A5g1mpmpp(i3,i4,i5,i1,i2,renscale2)
     .     +A5g1mmppp(i4,i5,i1,i2,i3,renscale2)
     .     +A5g1ppmmm(i1,i2,i3,i4,i5,renscale2)
     .     +A5g1pmpmm(i1,i2,i3,i4,i5,renscale2)
     .     +A5g1pmpmm(i4,i5,i1,i2,i3,renscale2)
     .     +A5g1ppmmm(i5,i1,i2,i3,i4,renscale2)
     .     +A5g1ppmmm(i2,i3,i4,i5,i1,renscale2)
     .     +A5g1pmpmm(i2,i3,i4,i5,i1,renscale2)
     .     +A5g1pmpmm(i5,i1,i2,i3,i4,renscale2)
     .     +A5g1ppmmm(i3,i4,i5,i1,i2,renscale2)
     .     +A5g1pmpmm(i3,i4,i5,i1,i2,renscale2)
     .     +A5g1ppmmm(i4,i5,i1,i2,i3,renscale2)

* factor of half from g^2/16/pi^2 = (as/2/pi)*1/2
      A5g1=A5g1/2d0
*      write(*,*)"A5g1",A5g1

      return
      end
************************************************************************
*
* five gluon zero quark tree level matrix elements interfered with tree level
*
* leading nf
* one colour ordering, summed and squared
*
*
      function Ah5g1(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /scheme/ deltaR
      deltaR=1d0

*      write(*,*)" hello Ah5g1 "

      Ah5g1= Ah5g1mmppp(i1,i2,i3,i4,i5,renscale2)
     .      +Ah5g1mpmpp(i1,i2,i3,i4,i5,renscale2)
     .      +Ah5g1mpmpp(i4,i5,i1,i2,i3,renscale2)
     .      +Ah5g1mmppp(i5,i1,i2,i3,i4,renscale2)
     .      +Ah5g1mmppp(i2,i3,i4,i5,i1,renscale2)
     .      +Ah5g1mpmpp(i2,i3,i4,i5,i1,renscale2)
     .      +Ah5g1mpmpp(i5,i1,i2,i3,i4,renscale2)
     .      +Ah5g1mmppp(i3,i4,i5,i1,i2,renscale2)
     .      +Ah5g1mpmpp(i3,i4,i5,i1,i2,renscale2)
     .      +Ah5g1mmppp(i4,i5,i1,i2,i3,renscale2)
     .      +Ah5g1ppmmm(i1,i2,i3,i4,i5,renscale2)
     .      +Ah5g1pmpmm(i1,i2,i3,i4,i5,renscale2)
     .      +Ah5g1pmpmm(i4,i5,i1,i2,i3,renscale2)
     .      +Ah5g1ppmmm(i5,i1,i2,i3,i4,renscale2)
     .      +Ah5g1ppmmm(i2,i3,i4,i5,i1,renscale2)
     .      +Ah5g1pmpmm(i2,i3,i4,i5,i1,renscale2)
     .      +Ah5g1pmpmm(i5,i1,i2,i3,i4,renscale2)
     .      +Ah5g1ppmmm(i3,i4,i5,i1,i2,renscale2)
     .      +Ah5g1pmpmm(i3,i4,i5,i1,i2,renscale2)
     .      +Ah5g1ppmmm(i4,i5,i1,i2,i3,renscale2)

* factor of half from g^2/16/pi^2 = (as/2/pi)*1/2
      Ah5g1=Ah5g1/2d0
c      write(*,*)"Ah5g1",i1,i2,i3,i4,i5,Ah5g1

      return
      end
************************************************************************
*
* five gluon zero quark tree level matrix elements interfered with tree level
* subleading colour
*
* A5g1(i1,i2,i3,i4,i5) interfered with A5g0(i1,i3,i5,i2,i4)
* and summed over helicities
*
      function At5g1(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /scheme/ deltaR
      deltaR=1d0

*      write(*,*)" hello At5g1 "

      At5g1  = At5g1mmppp(i1,i2,i3,i4,i5,renscale2)
     .        +At5g1mpmpp(i1,i2,i3,i4,i5,renscale2)
     .        +At5g1mpmpp(i4,i5,i1,i2,i3,renscale2)
     .        +At5g1mmppp(i5,i1,i2,i3,i4,renscale2)
     .        +At5g1mmppp(i2,i3,i4,i5,i1,renscale2)
     .        +At5g1mpmpp(i2,i3,i4,i5,i1,renscale2)
     .        +At5g1mpmpp(i5,i1,i2,i3,i4,renscale2)
     .        +At5g1mmppp(i3,i4,i5,i1,i2,renscale2)
     .        +At5g1mpmpp(i3,i4,i5,i1,i2,renscale2)
     .        +At5g1mmppp(i4,i5,i1,i2,i3,renscale2)
     .        +At5g1ppmmm(i1,i2,i3,i4,i5,renscale2)
     .        +At5g1pmpmm(i1,i2,i3,i4,i5,renscale2)
     .        +At5g1pmpmm(i4,i5,i1,i2,i3,renscale2)
     .        +At5g1ppmmm(i5,i1,i2,i3,i4,renscale2)
     .        +At5g1ppmmm(i2,i3,i4,i5,i1,renscale2)
     .        +At5g1pmpmm(i2,i3,i4,i5,i1,renscale2)
     .        +At5g1pmpmm(i5,i1,i2,i3,i4,renscale2)
     .        +At5g1ppmmm(i3,i4,i5,i1,i2,renscale2)
     .        +At5g1pmpmm(i3,i4,i5,i1,i2,renscale2)
     .        +At5g1ppmmm(i4,i5,i1,i2,i3,renscale2)

* factor of half from g^2/16/pi^2 = (as/2/pi)*1/2
      At5g1=At5g1/2d0
*      write(*,*)"At5g1",At5g1

      return
      end
************************************************************************
*
* five gluon zero quark tree level matrix elements interfered with tree level
* subleading colour, nf contribution
*
* A5g1(i1,i2,i3,i4,i5) interfered with A5g0(i1,i3,i5,i2,i4)
* and summed over helicities
*
      function Ath5g1(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /scheme/ deltaR
      deltaR=1d0

*      write(*,*)" hello Ath5g1 "

      Ath5g1  = Ath5g1mmppp(i1,i2,i3,i4,i5,renscale2)
     .         +Ath5g1mpmpp(i1,i2,i3,i4,i5,renscale2)
     .         +Ath5g1mpmpp(i4,i5,i1,i2,i3,renscale2)
     .         +Ath5g1mmppp(i5,i1,i2,i3,i4,renscale2)
     .         +Ath5g1mmppp(i2,i3,i4,i5,i1,renscale2)
     .         +Ath5g1mpmpp(i2,i3,i4,i5,i1,renscale2)
     .         +Ath5g1mpmpp(i5,i1,i2,i3,i4,renscale2)
     .         +Ath5g1mmppp(i3,i4,i5,i1,i2,renscale2)
     .         +Ath5g1mpmpp(i3,i4,i5,i1,i2,renscale2)
     .         +Ath5g1mmppp(i4,i5,i1,i2,i3,renscale2)
     .         +Ath5g1ppmmm(i1,i2,i3,i4,i5,renscale2)
     .         +Ath5g1pmpmm(i1,i2,i3,i4,i5,renscale2)
     .         +Ath5g1pmpmm(i4,i5,i1,i2,i3,renscale2)
     .         +Ath5g1ppmmm(i5,i1,i2,i3,i4,renscale2)
     .         +Ath5g1ppmmm(i2,i3,i4,i5,i1,renscale2)
     .         +Ath5g1pmpmm(i2,i3,i4,i5,i1,renscale2)
     .         +Ath5g1pmpmm(i5,i1,i2,i3,i4,renscale2)
     .         +Ath5g1ppmmm(i3,i4,i5,i1,i2,renscale2)
     .         +Ath5g1pmpmm(i3,i4,i5,i1,i2,renscale2)
     .         +Ath5g1ppmmm(i4,i5,i1,i2,i3,renscale2)

* factor of half from g^2/16/pi^2 = (as/2/pi)*1/2
      Ath5g1=Ath5g1/2d0
*      write(*,*)"Ath5g1",Ath5g1

      return
      end
************************************************************************
*
      function A5g1mmppp(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello A5g1mmppp ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !Vg+4Vf+Vs

      ze2=-5d0*zone

      ze1=(-55d0/6d0*zone-
     &(zzlog(renscale2)-zzlog(-s12)
     &+zzlog(renscale2)-zzlog(-s23)
     &+zzlog(renscale2)-zzlog(-s34)
     &+zzlog(renscale2)-zzlog(-s45)
     &+zzlog(renscale2)-zzlog(-s15)))

      zVg=-1d0/2d0*(
     & (zzlog(renscale2)-zzlog(-s12))**(2) !expand (mu/s)^(eps)*eps^(-2)
     &+(zzlog(renscale2)-zzlog(-s23))**(2)
     &+(zzlog(renscale2)-zzlog(-s34))**(2)
     &+(zzlog(renscale2)-zzlog(-s45))**(2)
     &+(zzlog(renscale2)-zzlog(-s15))**(2))
     &+(zzlog(-s12)-zzlog(-s23))*(zzlog(-s34)-zzlog(-s45))
     &+(zzlog(-s23)-zzlog(-s34))*(zzlog(-s45)-zzlog(-s15))
     &+(zzlog(-s34)-zzlog(-s45))*(zzlog(-s15)-zzlog(-s12))
     &+(zzlog(-s45)-zzlog(-s15))*(zzlog(-s12)-zzlog(-s23))
     &+(zzlog(-s15)-zzlog(-s12))*(zzlog(-s23)-zzlog(-s34))
     &+5d0/6d0*Pi**(2)-1d0/3d0*deltaR

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s23)+zzlog(renscale2)-zzlog(-s15))-2d0*zone

      zVs=-1d0/3d0*zVf+2d0/9d0*zone

      ze0=zVg+4d0*zVf+zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*za12**(4)/(za12*za23*za34*za45*za51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree


      zFf=-1d0/2d0*za12**(2)*(za23*zb34*za41+za24*zb45*za51)/
     &      (za23*za34*za45*za51)*zLzero(-s23,-s15)/s15

      zFs=-1d0/3d0*(zb34*za41*za24*zb45*(za23*zb34*za41+za24*zb45*za51))/
     & (za34*za45)*zLtwo(-s23,-s15)/s15**(3)
     &-1d0/3d0*zFf
     &-1d0/3d0*za35*zb35**(3)/(zb12*zb23*za34*za45*zb51)
     &+1d0/3d0*za12*zb35**(2)/(zb23*za34*za45*zb51)
     &+1d0/6d0*za12*zb34*za41*za24*zb45/(s23*za34*za45*s15)

      ze0=ze0+zi*(4d0*zFf+zFs)


      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        A5g1mmppp=e2
      elseif(ieorder.eq.-1)then
        A5g1mmppp=e1
      elseif(ieorder.eq.0)then
        A5g1mmppp=e0
      endif
*      write(*,10)A5g1mmppp,i1,i2,i3,i4,i5
   10 format(" A5g1mmppp   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function A5g1mpmpp(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello A5g1mpmpp ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !Vg+4Vf+Vs
      ze2=-5d0*zone

      ze1=(-55d0/6d0*zone-
     &(zzlog(renscale2)-zzlog(-s12)
     &+zzlog(renscale2)-zzlog(-s23)
     &+zzlog(renscale2)-zzlog(-s34)
     &+zzlog(renscale2)-zzlog(-s45)
     &+zzlog(renscale2)-zzlog(-s15)))


      zVg=-1d0/2d0*((zzlog(renscale2)-zzlog(-s12))**(2) !expand (mu/s)^(eps)*eps^(-2)
     &+(zzlog(renscale2)-zzlog(-s23))**(2)
     &+(zzlog(renscale2)-zzlog(-s34))**(2)
     &+(zzlog(renscale2)-zzlog(-s45))**(2)
     &+(zzlog(renscale2)-zzlog(-s15))**(2))
     &+(zzlog(-s12)-zzlog(-s23))*(zzlog(-s34)-zzlog(-s45))
     &+(zzlog(-s23)-zzlog(-s34))*(zzlog(-s45)-zzlog(-s15))
     &+(zzlog(-s34)-zzlog(-s45))*(zzlog(-s15)-zzlog(-s12))
     &+(zzlog(-s45)-zzlog(-s15))*(zzlog(-s12)-zzlog(-s23))
     &+(zzlog(-s15)-zzlog(-s12))*(zzlog(-s23)-zzlog(-s34))
     &+5d0/6d0*Pi**(2)-1d0/3d0*deltaR

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s34)+zzlog(renscale2)-zzlog(-s15))-2d0

      zVs=-1d0/3d0*zVf+2d0/9d0

      ze0=zVg+4d0*zVf+zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*za13**(4)/(za12*za23*za34*za45*za51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree


      zFf=-za13**(2)*za41*zb24**(2)/(za45*za51)*zLs1(-s23,-s15,-s34,-s15)/s15**(2)
     &    +za13**(2)*za53*zb25**(2)/(za34*za45)*zLs1(-s12,-s34,-s15,-s34)/s34**(2)
     &-1d0/2d0*za13**(3)*(za15*zb52*za23-za34*zb42*za21)/
     &   (za12*za23*za34*za45*za51)*zLzero(-s34,-s15)/s15


      zFs=-za12*za23*za34*za41**(2)*zb24**(2)/
     & (za45*za51*za24**(2))*(2d0*zLs1(-s23,-s15,-s34,-s15)
     &+zLone(-s23,-s15)+zLone(-s34,-s15))/s15**(2)
     &+za32*za21*za15*za53**(2)*zb25**(2)/
     & (za54*za43*za25**(2))*(2d0*zLs1(-s12,-s34,-s15,-s34)
     &+zLone(-s12,-s34)+zLone(-s15,-s34))/s34**(2)
     &+2d0/3d0*za23**(2)*za41**(3)*zb24**(3)/(za45*za51*za24)*zLtwo(-s23,-s15)/s15**(3)
     &-2d0/3d0*za21**(2)*za53**(3)*zb25**(3)/(za54*za43*za25)*zLtwo(-s12,-s34)/s34**(3)
     &+zLtwo(-s34,-s15)/s15**(3)*(1d0/3d0*za13*zb24*zb25*
     & (za15*zb52*za23-za34*zb42*za21)/za45
     &+2d0/3d0*za12**(2)*za34**(2)*za41*zb24**(3)/(za45*za51*za24)
     &-2d0/3d0*za32**(2)*za15**(2)*za53*zb25**(3)/(za54*za43*za25))
     &+1d0/6d0*za13**(3)*(za15*zb52*za23-za34*zb42*za21)/
     & (za12*za23*za34*za45*za51)*zLzero(-s34,-s15)/s15
     &+1d0/3d0*zb24**(2)*zb25**(2)/(zb12*zb23*zb34*za45*zb51)
     &-1d0/3d0*za12*za41**(2)*zb24**(3)/(za45*za51*za24*zb23*zb34*s15)
     &+1d0/3d0*za32*za53**(2)*zb25**(3)/(za54*za43*za25*zb21*zb15*s34)
     &+1d0/6d0*za13**(2)*zb24*zb25/(s34*za45*s15)

      ze0=ze0+zi*(4d0*zFf+zFs)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        A5g1mpmpp=e2
      elseif(ieorder.eq.-1)then
        A5g1mpmpp=e1
      elseif(ieorder.eq.0)then
        A5g1mpmpp=e0
      endif
*      write(*,10)A5g1mpmpp,i1,i2,i3,i4,i5
   10 format(" A5g1mpmpp   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function A5g1ppmmm(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello A5g1ppmmm ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !Vg+4Vf+Vs


      ze2=-5d0*zone


      ze1=(-55d0/6d0*zone-(zzlog(renscale2)-zzlog(-s12)
     &+zzlog(renscale2)-zzlog(-s23)
     &+zzlog(renscale2)-zzlog(-s34)
     &+zzlog(renscale2)-zzlog(-s45)
     &+zzlog(renscale2)-zzlog(-s15)))

      zVg=-1d0/2d0*((zzlog(renscale2)-zzlog(-s12))**(2) !expand (mu/s)^(eps)*eps^(-2)
     &+(zzlog(renscale2)-zzlog(-s23))**(2)
     &+(zzlog(renscale2)-zzlog(-s34))**(2)
     &+(zzlog(renscale2)-zzlog(-s45))**(2)
     &+(zzlog(renscale2)-zzlog(-s15))**(2))
     &+(zzlog(-s12)-zzlog(-s23))*(zzlog(-s34)-zzlog(-s45))
     &+(zzlog(-s23)-zzlog(-s34))*(zzlog(-s45)-zzlog(-s15))
     &+(zzlog(-s34)-zzlog(-s45))*(zzlog(-s15)-zzlog(-s12))
     &+(zzlog(-s45)-zzlog(-s15))*(zzlog(-s12)-zzlog(-s23))
     &+(zzlog(-s15)-zzlog(-s12))*(zzlog(-s23)-zzlog(-s34))
     &+5d0/6d0*Pi**(2)-1d0/3d0*deltaR

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s23)+zzlog(renscale2)-zzlog(-s15))-2d0*zone

      zVs=-1d0/3d0*zVf+2d0/9d0*zone

      ze0=zVg+4d0*zVf+zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*zb12**(4)/(zb12*zb23*zb34*zb45*zb51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree

      zFf=-1d0/2d0*zb12**(2)*(zb23*za34*zb41+zb24*za45*zb51)/
     &      (zb23*zb34*zb45*zb51)*zLzero(-s23,-s15)/s15

      zFs=-1d0/3d0*(za34*zb41*zb24*za45*(zb23*za34*zb41+zb24*za45*zb51))/
     & (zb34*zb45)*zLtwo(-s23,-s15)/s15**(3)
     &-1d0/3d0*zFf
     &-1d0/3d0*zb35*za35**(3)/(za12*za23*zb34*zb45*za51)
     &+1d0/3d0*zb12*za35**(2)/(za23*zb34*zb45*za51)
     &+1d0/6d0*zb12*za34*zb41*zb24*za45/(s23*zb34*zb45*s15)

      ze0=ze0+zi*(4d0*zFf+zFs)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        A5g1ppmmm=e2
      elseif(ieorder.eq.-1)then
        A5g1ppmmm=e1
      elseif(ieorder.eq.0)then
        A5g1ppmmm=e0
      endif
*      write(*,10)A5g1ppmmm,i1,i2,i3,i4,i5
   10 format(" A5g1ppmmm   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function A5g1pmpmm(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello A5g1pmpmm ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !Vg+4Vf+Vs
      ze2=-5d0*zone

      ze1=(-55d0/6d0*zone-(zzlog(renscale2)-zzlog(-s12)
     &+zzlog(renscale2)-zzlog(-s23)
     &+zzlog(renscale2)-zzlog(-s34)
     &+zzlog(renscale2)-zzlog(-s45)
     &+zzlog(renscale2)-zzlog(-s15)))


      zVg=-1d0/2d0*((zzlog(renscale2)-zzlog(-s12))**(2) !expand (mu/s)^(eps)*eps^(-2)
     &+(zzlog(renscale2)-zzlog(-s23))**(2)
     &+(zzlog(renscale2)-zzlog(-s34))**(2)
     &+(zzlog(renscale2)-zzlog(-s45))**(2)
     &+(zzlog(renscale2)-zzlog(-s15))**(2))
     &+(zzlog(-s12)-zzlog(-s23))*(zzlog(-s34)-zzlog(-s45))
     &+(zzlog(-s23)-zzlog(-s34))*(zzlog(-s45)-zzlog(-s15))
     &+(zzlog(-s34)-zzlog(-s45))*(zzlog(-s15)-zzlog(-s12))
     &+(zzlog(-s45)-zzlog(-s15))*(zzlog(-s12)-zzlog(-s23))
     &+(zzlog(-s15)-zzlog(-s12))*(zzlog(-s23)-zzlog(-s34))
     &+5d0/6d0*Pi**(2)-1d0/3d0*deltaR

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s34)+zzlog(renscale2)-zzlog(-s15))-2d0

      zVs=-1d0/3d0*zVf+2d0/9d0

      ze0=zVg+4d0*zVf+zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*zb13**(4)/(zb12*zb23*zb34*zb45*zb51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree



      zFf=-zb13**(2)*zb41*za24**(2)/(zb45*zb51)*zLs1(-s23,-s15,-s34,-s15)/s15**(2)
     &    +zb13**(2)*zb53*za25**(2)/(zb34*zb45)*zLs1(-s12,-s34,-s15,-s34)/s34**(2)
     &-1d0/2d0*zb13**(3)*(zb15*za52*zb23-zb34*za42*zb21)/
     &   (zb12*zb23*zb34*zb45*zb51)*zLzero(-s34,-s15)/s15


      zFs=-zb12*zb23*zb34*zb41**(2)*za24**(2)/
     & (zb45*zb51*zb24**(2))*(2d0*zLs1(-s23,-s15,-s34,-s15)
     &+zLone(-s23,-s15)+zLone(-s34,-s15))/s15**(2)
     &+zb32*zb21*zb15*zb53**(2)*za25**(2)/
     & (zb54*zb43*zb25**(2))*(2d0*zLs1(-s12,-s34,-s15,-s34)
     &+zLone(-s12,-s34)+zLone(-s15,-s34))/s34**(2)
     &+2d0/3d0*zb23**(2)*zb41**(3)*za24**(3)/(zb45*zb51*zb24)*zLtwo(-s23,-s15)/s15**(3)
     &-2d0/3d0*zb21**(2)*zb53**(3)*za25**(3)/(zb54*zb43*zb25)*zLtwo(-s12,-s34)/s34**(3)
     &+zLtwo(-s34,-s15)/s15**(3)*(1d0/3d0*zb13*za24*za25*
     & (zb15*za52*zb23-zb34*za42*zb21)/zb45
     &+2d0/3d0*zb12**(2)*zb34**(2)*zb41*za24**(3)/(zb45*zb51*zb24)
     &-2d0/3d0*zb32**(2)*zb15**(2)*zb53*za25**(3)/(zb54*zb43*zb25))
     &+1d0/6d0*zb13**(3)*(zb15*za52*zb23-zb34*za42*zb21)/
     & (zb12*zb23*zb34*zb45*zb51)*zLzero(-s34,-s15)/s15
     &+1d0/3d0*za24**(2)*za25**(2)/(za12*za23*za34*zb45*za51)
     &-1d0/3d0*zb12*zb41**(2)*za24**(3)/(zb45*zb51*zb24*za23*za34*s15)
     &+1d0/3d0*zb32*zb53**(2)*za25**(3)/(zb54*zb43*zb25*za21*za15*s34)
     &+1d0/6d0*zb13**(2)*za24*za25/(s34*zb45*s15)

      ze0=ze0+zi*(4d0*zFf+zFs)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        A5g1pmpmm=e2
      elseif(ieorder.eq.-1)then
        A5g1pmpmm=e1
      elseif(ieorder.eq.0)then
        A5g1pmpmm=e0
      endif
*      write(*,10)A5g1pmpmm,i1,i2,i3,i4,i5
   10 format(" A5g1pmpmm   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function Ah5g1mmppp(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello Ah5g1mmppp ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !-Vf-Vs

      ze2=0d0*zone

      ze1=10d0/6d0*zone

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s23)+zzlog(renscale2)-zzlog(-s15))-2d0*zone

      zVs=-1d0/3d0*zVf+2d0/9d0*zone

      ze0=-zVf-zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*za12**(4)/(za12*za23*za34*za45*za51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree

      zFf=-1d0/2d0*za12**(2)*(za23*zb34*za41+za24*zb45*za51)/
     &      (za23*za34*za45*za51)*zLzero(-s23,-s15)/s15

      zFs=-1d0/3d0*(zb34*za41*za24*zb45*(za23*zb34*za41+za24*zb45*za51))/
     & (za34*za45)*zLtwo(-s23,-s15)/s15**(3)
     &-1d0/3d0*zFf
     &-1d0/3d0*za35*zb35**(3)/(zb12*zb23*za34*za45*zb51)
     &+1d0/3d0*za12*zb35**(2)/(zb23*za34*za45*zb51)
     &+1d0/6d0*za12*zb34*za41*za24*zb45/(s23*za34*za45*s15)

      ze0=ze0+zi*(-zFf-zFs)


      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        Ah5g1mmppp=e2
      elseif(ieorder.eq.-1)then
        Ah5g1mmppp=e1
      elseif(ieorder.eq.0)then
        Ah5g1mmppp=e0
      endif
*      write(*,10)Ah5g1mmppp,i1,i2,i3,i4,i5
   10 format(" Ah5g1mmppp   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function Ah5g1mpmpp(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello Ah5g1mpmpp ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !-Vf-Vs

      ze2=0d0*zone

      ze1=10d0/6d0*zone


      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s34)+zzlog(renscale2)-zzlog(-s15))-2d0

      zVs=-1d0/3d0*zVf+2d0/9d0

      ze0=-zVf-zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*za13**(4)/(za12*za23*za34*za45*za51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree


      zFf=-za13**(2)*za41*zb24**(2)/(za45*za51)*zLs1(-s23,-s15,-s34,-s15)/s15**(2)
     &    +za13**(2)*za53*zb25**(2)/(za34*za45)*zLs1(-s12,-s34,-s15,-s34)/s34**(2)
     &-1d0/2d0*za13**(3)*(za15*zb52*za23-za34*zb42*za21)/
     &   (za12*za23*za34*za45*za51)*zLzero(-s34,-s15)/s15


      zFs=-za12*za23*za34*za41**(2)*zb24**(2)/
     & (za45*za51*za24**(2))*(2d0*zLs1(-s23,-s15,-s34,-s15)
     &+zLone(-s23,-s15)+zLone(-s34,-s15))/s15**(2)
     &+za32*za21*za15*za53**(2)*zb25**(2)/
     & (za54*za43*za25**(2))*(2d0*zLs1(-s12,-s34,-s15,-s34)
     &+zLone(-s12,-s34)+zLone(-s15,-s34))/s34**(2)
     &+2d0/3d0*za23**(2)*za41**(3)*zb24**(3)/(za45*za51*za24)*zLtwo(-s23,-s15)/s15**(3)
     &-2d0/3d0*za21**(2)*za53**(3)*zb25**(3)/(za54*za43*za25)*zLtwo(-s12,-s34)/s34**(3)
     &+zLtwo(-s34,-s15)/s15**(3)*(1d0/3d0*za13*zb24*zb25*
     & (za15*zb52*za23-za34*zb42*za21)/za45
     &+2d0/3d0*za12**(2)*za34**(2)*za41*zb24**(3)/(za45*za51*za24)
     &-2d0/3d0*za32**(2)*za15**(2)*za53*zb25**(3)/(za54*za43*za25))
     &+1d0/6d0*za13**(3)*(za15*zb52*za23-za34*zb42*za21)/
     & (za12*za23*za34*za45*za51)*zLzero(-s34,-s15)/s15
     &+1d0/3d0*zb24**(2)*zb25**(2)/(zb12*zb23*zb34*za45*zb51)
     &-1d0/3d0*za12*za41**(2)*zb24**(3)/(za45*za51*za24*zb23*zb34*s15)
     &+1d0/3d0*za32*za53**(2)*zb25**(3)/(za54*za43*za25*zb21*zb15*s34)
     &+1d0/6d0*za13**(2)*zb24*zb25/(s34*za45*s15)

      ze0=ze0+zi*(-zFf-zFs)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        Ah5g1mpmpp=e2
      elseif(ieorder.eq.-1)then
        Ah5g1mpmpp=e1
      elseif(ieorder.eq.0)then
        Ah5g1mpmpp=e0
      endif
*      write(*,10)Ah5g1mpmpp,i1,i2,i3,i4,i5
   10 format(" Ah5g1mpmpp   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function Ah5g1ppmmm(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello Ah5g1ppmmm ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !-Vf-Vs

      ze2=0d0*zone

      ze1=10d0/6d0*zone


      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s23)+zzlog(renscale2)-zzlog(-s15))-2d0*zone

      zVs=-1d0/3d0*zVf+2d0/9d0*zone

      ze0=-zVf-zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*zb12**(4)/(zb12*zb23*zb34*zb45*zb51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree

      zFf=-1d0/2d0*zb12**(2)*(zb23*za34*zb41+zb24*za45*zb51)/
     &      (zb23*zb34*zb45*zb51)*zLzero(-s23,-s15)/s15

      zFs=-1d0/3d0*(za34*zb41*zb24*za45*(zb23*za34*zb41+zb24*za45*zb51))/
     & (zb34*zb45)*zLtwo(-s23,-s15)/s15**(3)
     &-1d0/3d0*zFf
     &-1d0/3d0*zb35*za35**(3)/(za12*za23*zb34*zb45*za51)
     &+1d0/3d0*zb12*za35**(2)/(za23*zb34*zb45*za51)
     &+1d0/6d0*zb12*za34*zb41*zb24*za45/(s23*zb34*zb45*s15)

      ze0=ze0+zi*(-zFf-zFs)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        Ah5g1ppmmm=e2
      elseif(ieorder.eq.-1)then
        Ah5g1ppmmm=e1
      elseif(ieorder.eq.0)then
        Ah5g1ppmmm=e0
      endif
*      write(*,10)Ah5g1ppmmm,i1,i2,i3,i4,i5
   10 format(" Ah5g1ppmmm   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function Ah5g1pmpmm(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello Ah5g1pmpmm ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !-Vf-Vs

      ze2=0d0*zone

      ze1=10d0/6d0*zone

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s34)+zzlog(renscale2)-zzlog(-s15))-2d0

      zVs=-1d0/3d0*zVf+2d0/9d0

      ze0=-zVf-zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*zb13**(4)/(zb12*zb23*zb34*zb45*zb51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree



      zFf=-zb13**(2)*zb41*za24**(2)/(zb45*zb51)*zLs1(-s23,-s15,-s34,-s15)/s15**(2)
     &    +zb13**(2)*zb53*za25**(2)/(zb34*zb45)*zLs1(-s12,-s34,-s15,-s34)/s34**(2)
     &-1d0/2d0*zb13**(3)*(zb15*za52*zb23-zb34*za42*zb21)/
     &   (zb12*zb23*zb34*zb45*zb51)*zLzero(-s34,-s15)/s15


      zFs=-zb12*zb23*zb34*zb41**(2)*za24**(2)/
     & (zb45*zb51*zb24**(2))*(2d0*zLs1(-s23,-s15,-s34,-s15)
     &+zLone(-s23,-s15)+zLone(-s34,-s15))/s15**(2)
     &+zb32*zb21*zb15*zb53**(2)*za25**(2)/
     & (zb54*zb43*zb25**(2))*(2d0*zLs1(-s12,-s34,-s15,-s34)
     &+zLone(-s12,-s34)+zLone(-s15,-s34))/s34**(2)
     &+2d0/3d0*zb23**(2)*zb41**(3)*za24**(3)/(zb45*zb51*zb24)*zLtwo(-s23,-s15)/s15**(3)
     &-2d0/3d0*zb21**(2)*zb53**(3)*za25**(3)/(zb54*zb43*zb25)*zLtwo(-s12,-s34)/s34**(3)
     &+zLtwo(-s34,-s15)/s15**(3)*(1d0/3d0*zb13*za24*za25*
     & (zb15*za52*zb23-zb34*za42*zb21)/zb45
     &+2d0/3d0*zb12**(2)*zb34**(2)*zb41*za24**(3)/(zb45*zb51*zb24)
     &-2d0/3d0*zb32**(2)*zb15**(2)*zb53*za25**(3)/(zb54*zb43*zb25))
     &+1d0/6d0*zb13**(3)*(zb15*za52*zb23-zb34*za42*zb21)/
     & (zb12*zb23*zb34*zb45*zb51)*zLzero(-s34,-s15)/s15
     &+1d0/3d0*za24**(2)*za25**(2)/(za12*za23*za34*zb45*za51)
     &-1d0/3d0*zb12*zb41**(2)*za24**(3)/(zb45*zb51*zb24*za23*za34*s15)
     &+1d0/3d0*zb32*zb53**(2)*za25**(3)/(zb54*zb43*zb25*za21*za15*s34)
     &+1d0/6d0*zb13**(2)*za24*za25/(s34*zb45*s15)

      ze0=ze0+zi*(-zFf-zFs)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        Ah5g1pmpmm=e2
      elseif(ieorder.eq.-1)then
        Ah5g1pmpmm=e1
      elseif(ieorder.eq.0)then
        Ah5g1pmpmm=e0
      endif
*      write(*,10)Ah5g1pmpmm,i1,i2,i3,i4,i5
   10 format(" Ah5g1pmpmm   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function At5g1mmppp(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello At5g1mmppp ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !Vg+4Vf+Vs

      ze2=-5d0*zone

      ze1=(-55d0/6d0*zone-
     &(zzlog(renscale2)-zzlog(-s12)
     &+zzlog(renscale2)-zzlog(-s23)
     &+zzlog(renscale2)-zzlog(-s34)
     &+zzlog(renscale2)-zzlog(-s45)
     &+zzlog(renscale2)-zzlog(-s15)))

      zVg=-1d0/2d0*(
     & (zzlog(renscale2)-zzlog(-s12))**(2) !expand (mu/s)^(eps)*eps^(-2)
     &+(zzlog(renscale2)-zzlog(-s23))**(2)
     &+(zzlog(renscale2)-zzlog(-s34))**(2)
     &+(zzlog(renscale2)-zzlog(-s45))**(2)
     &+(zzlog(renscale2)-zzlog(-s15))**(2))
     &+(zzlog(-s12)-zzlog(-s23))*(zzlog(-s34)-zzlog(-s45))
     &+(zzlog(-s23)-zzlog(-s34))*(zzlog(-s45)-zzlog(-s15))
     &+(zzlog(-s34)-zzlog(-s45))*(zzlog(-s15)-zzlog(-s12))
     &+(zzlog(-s45)-zzlog(-s15))*(zzlog(-s12)-zzlog(-s23))
     &+(zzlog(-s15)-zzlog(-s12))*(zzlog(-s23)-zzlog(-s34))
     &+5d0/6d0*Pi**(2)-1d0/3d0*deltaR

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s23)+zzlog(renscale2)-zzlog(-s15))-2d0*zone

      zVs=-1d0/3d0*zVf+2d0/9d0*zone

      ze0=zVg+4d0*zVf+zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*za12**(4)/(za12*za23*za34*za45*za51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree

      zFf=-1d0/2d0*za12**(2)*(za23*zb34*za41+za24*zb45*za51)/
     &      (za23*za34*za45*za51)*zLzero(-s23,-s15)/s15

      zFs=-1d0/3d0*(zb34*za41*za24*zb45*(za23*zb34*za41+za24*zb45*za51))/
     & (za34*za45)*zLtwo(-s23,-s15)/s15**(3)
     &-1d0/3d0*zFf
     &-1d0/3d0*za35*zb35**(3)/(zb12*zb23*za34*za45*zb51)
     &+1d0/3d0*za12*zb35**(2)/(zb23*za34*za45*zb51)
     &+1d0/6d0*za12*zb34*za41*za24*zb45/(s23*za34*za45*s15)

      ze0=ze0+zi*(4d0*zFf+zFs)

* must be interfered with A5g0(i1,i3,i5,i2,i4)
      ztree=zi*za12**(4)/(za13*za35*za52*za24*za41)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        At5g1mmppp=e2
      elseif(ieorder.eq.-1)then
        At5g1mmppp=e1
      elseif(ieorder.eq.0)then
        At5g1mmppp=e0
      endif
*      write(*,10)At5g1mmppp,i1,i2,i3,i4,i5
   10 format(" At5g1mmppp   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function At5g1mpmpp(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello At5g1mpmpp ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !Vg+4Vf+Vs
      ze2=-5d0*zone

      ze1=(-55d0/6d0*zone-
     &(zzlog(renscale2)-zzlog(-s12)
     &+zzlog(renscale2)-zzlog(-s23)
     &+zzlog(renscale2)-zzlog(-s34)
     &+zzlog(renscale2)-zzlog(-s45)
     &+zzlog(renscale2)-zzlog(-s15)))


      zVg=-1d0/2d0*((zzlog(renscale2)-zzlog(-s12))**(2) !expand (mu/s)^(eps)*eps^(-2)
     &+(zzlog(renscale2)-zzlog(-s23))**(2)
     &+(zzlog(renscale2)-zzlog(-s34))**(2)
     &+(zzlog(renscale2)-zzlog(-s45))**(2)
     &+(zzlog(renscale2)-zzlog(-s15))**(2))
     &+(zzlog(-s12)-zzlog(-s23))*(zzlog(-s34)-zzlog(-s45))
     &+(zzlog(-s23)-zzlog(-s34))*(zzlog(-s45)-zzlog(-s15))
     &+(zzlog(-s34)-zzlog(-s45))*(zzlog(-s15)-zzlog(-s12))
     &+(zzlog(-s45)-zzlog(-s15))*(zzlog(-s12)-zzlog(-s23))
     &+(zzlog(-s15)-zzlog(-s12))*(zzlog(-s23)-zzlog(-s34))
     &+5d0/6d0*Pi**(2)-1d0/3d0*deltaR

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s34)+zzlog(renscale2)-zzlog(-s15))-2d0

      zVs=-1d0/3d0*zVf+2d0/9d0

      ze0=zVg+4d0*zVf+zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*za13**(4)/(za12*za23*za34*za45*za51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree


      zFf=-za13**(2)*za41*zb24**(2)/(za45*za51)*zLs1(-s23,-s15,-s34,-s15)/s15**(2)
     &    +za13**(2)*za53*zb25**(2)/(za34*za45)*zLs1(-s12,-s34,-s15,-s34)/s34**(2)
     &-1d0/2d0*za13**(3)*(za15*zb52*za23-za34*zb42*za21)/
     &   (za12*za23*za34*za45*za51)*zLzero(-s34,-s15)/s15


      zFs=-za12*za23*za34*za41**(2)*zb24**(2)/
     & (za45*za51*za24**(2))*(2d0*zLs1(-s23,-s15,-s34,-s15)
     &+zLone(-s23,-s15)+zLone(-s34,-s15))/s15**(2)
     &+za32*za21*za15*za53**(2)*zb25**(2)/
     & (za54*za43*za25**(2))*(2d0*zLs1(-s12,-s34,-s15,-s34)
     &+zLone(-s12,-s34)+zLone(-s15,-s34))/s34**(2)
     &+2d0/3d0*za23**(2)*za41**(3)*zb24**(3)/(za45*za51*za24)*zLtwo(-s23,-s15)/s15**(3)
     &-2d0/3d0*za21**(2)*za53**(3)*zb25**(3)/(za54*za43*za25)*zLtwo(-s12,-s34)/s34**(3)
     &+zLtwo(-s34,-s15)/s15**(3)*(1d0/3d0*za13*zb24*zb25*
     & (za15*zb52*za23-za34*zb42*za21)/za45
     &+2d0/3d0*za12**(2)*za34**(2)*za41*zb24**(3)/(za45*za51*za24)
     &-2d0/3d0*za32**(2)*za15**(2)*za53*zb25**(3)/(za54*za43*za25))
     &+1d0/6d0*za13**(3)*(za15*zb52*za23-za34*zb42*za21)/
     & (za12*za23*za34*za45*za51)*zLzero(-s34,-s15)/s15
     &+1d0/3d0*zb24**(2)*zb25**(2)/(zb12*zb23*zb34*za45*zb51)
     &-1d0/3d0*za12*za41**(2)*zb24**(3)/(za45*za51*za24*zb23*zb34*s15)
     &+1d0/3d0*za32*za53**(2)*zb25**(3)/(za54*za43*za25*zb21*zb15*s34)
     &+1d0/6d0*za13**(2)*zb24*zb25/(s34*za45*s15)

      ze0=ze0+zi*(4d0*zFf+zFs)

* must be interfered with A5g0(i1,i3,i5,i2,i4)
      ztree=zi*za13**(4)/(za13*za35*za52*za24*za41)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        At5g1mpmpp=e2
      elseif(ieorder.eq.-1)then
        At5g1mpmpp=e1
      elseif(ieorder.eq.0)then
        At5g1mpmpp=e0
      endif
*      write(*,10)At5g1mpmpp,i1,i2,i3,i4,i5
   10 format(" At5g1mpmpp   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function At5g1ppmmm(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello At5g1ppmmm ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !Vg+4Vf+Vs


      ze2=-5d0*zone


      ze1=(-55d0/6d0*zone-(zzlog(renscale2)-zzlog(-s12)
     &+zzlog(renscale2)-zzlog(-s23)
     &+zzlog(renscale2)-zzlog(-s34)
     &+zzlog(renscale2)-zzlog(-s45)
     &+zzlog(renscale2)-zzlog(-s15)))

      zVg=-1d0/2d0*((zzlog(renscale2)-zzlog(-s12))**(2) !expand (mu/s)^(eps)*eps^(-2)
     &+(zzlog(renscale2)-zzlog(-s23))**(2)
     &+(zzlog(renscale2)-zzlog(-s34))**(2)
     &+(zzlog(renscale2)-zzlog(-s45))**(2)
     &+(zzlog(renscale2)-zzlog(-s15))**(2))
     &+(zzlog(-s12)-zzlog(-s23))*(zzlog(-s34)-zzlog(-s45))
     &+(zzlog(-s23)-zzlog(-s34))*(zzlog(-s45)-zzlog(-s15))
     &+(zzlog(-s34)-zzlog(-s45))*(zzlog(-s15)-zzlog(-s12))
     &+(zzlog(-s45)-zzlog(-s15))*(zzlog(-s12)-zzlog(-s23))
     &+(zzlog(-s15)-zzlog(-s12))*(zzlog(-s23)-zzlog(-s34))
     &+5d0/6d0*Pi**(2)-1d0/3d0*deltaR

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s23)+zzlog(renscale2)-zzlog(-s15))-2d0*zone

      zVs=-1d0/3d0*zVf+2d0/9d0*zone

      ze0=zVg+4d0*zVf+zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*zb12**(4)/(zb12*zb23*zb34*zb45*zb51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree

      zFf=-1d0/2d0*zb12**(2)*(zb23*za34*zb41+zb24*za45*zb51)/
     &      (zb23*zb34*zb45*zb51)*zLzero(-s23,-s15)/s15

      zFs=-1d0/3d0*(za34*zb41*zb24*za45*(zb23*za34*zb41+zb24*za45*zb51))/
     & (zb34*zb45)*zLtwo(-s23,-s15)/s15**(3)
     &-1d0/3d0*zFf
     &-1d0/3d0*zb35*za35**(3)/(za12*za23*zb34*zb45*za51)
     &+1d0/3d0*zb12*za35**(2)/(za23*zb34*zb45*za51)
     &+1d0/6d0*zb12*za34*zb41*zb24*za45/(s23*zb34*zb45*s15)

      ze0=ze0+zi*(4d0*zFf+zFs)

* must be interfered with A5g0(i1,i3,i5,i2,i4)
      ztree=zi*zb12**(4)/(zb13*zb35*zb52*zb24*zb41)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        At5g1ppmmm=e2
      elseif(ieorder.eq.-1)then
        At5g1ppmmm=e1
      elseif(ieorder.eq.0)then
        At5g1ppmmm=e0
      endif
*      write(*,10)At5g1ppmmm,i1,i2,i3,i4,i5
   10 format(" At5g1ppmmm   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function At5g1pmpmm(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello At5g1pmpmm ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !Vg+4Vf+Vs
      ze2=-5d0*zone

      ze1=(-55d0/6d0*zone-(zzlog(renscale2)-zzlog(-s12)
     &+zzlog(renscale2)-zzlog(-s23)
     &+zzlog(renscale2)-zzlog(-s34)
     &+zzlog(renscale2)-zzlog(-s45)
     &+zzlog(renscale2)-zzlog(-s15)))


      zVg=-1d0/2d0*((zzlog(renscale2)-zzlog(-s12))**(2) !expand (mu/s)^(eps)*eps^(-2)
     &+(zzlog(renscale2)-zzlog(-s23))**(2)
     &+(zzlog(renscale2)-zzlog(-s34))**(2)
     &+(zzlog(renscale2)-zzlog(-s45))**(2)
     &+(zzlog(renscale2)-zzlog(-s15))**(2))
     &+(zzlog(-s12)-zzlog(-s23))*(zzlog(-s34)-zzlog(-s45))
     &+(zzlog(-s23)-zzlog(-s34))*(zzlog(-s45)-zzlog(-s15))
     &+(zzlog(-s34)-zzlog(-s45))*(zzlog(-s15)-zzlog(-s12))
     &+(zzlog(-s45)-zzlog(-s15))*(zzlog(-s12)-zzlog(-s23))
     &+(zzlog(-s15)-zzlog(-s12))*(zzlog(-s23)-zzlog(-s34))
     &+5d0/6d0*Pi**(2)-1d0/3d0*deltaR

      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s34)+zzlog(renscale2)-zzlog(-s15))-2d0

      zVs=-1d0/3d0*zVf+2d0/9d0

      ze0=zVg+4d0*zVf+zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*zb13**(4)/(zb12*zb23*zb34*zb45*zb51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree

      zFf=-zb13**(2)*zb41*za24**(2)/(zb45*zb51)*zLs1(-s23,-s15,-s34,-s15)/s15**(2)
     &    +zb13**(2)*zb53*za25**(2)/(zb34*zb45)*zLs1(-s12,-s34,-s15,-s34)/s34**(2)
     &-1d0/2d0*zb13**(3)*(zb15*za52*zb23-zb34*za42*zb21)/
     &   (zb12*zb23*zb34*zb45*zb51)*zLzero(-s34,-s15)/s15


      zFs=-zb12*zb23*zb34*zb41**(2)*za24**(2)/
     & (zb45*zb51*zb24**(2))*(2d0*zLs1(-s23,-s15,-s34,-s15)
     &+zLone(-s23,-s15)+zLone(-s34,-s15))/s15**(2)
     &+zb32*zb21*zb15*zb53**(2)*za25**(2)/
     & (zb54*zb43*zb25**(2))*(2d0*zLs1(-s12,-s34,-s15,-s34)
     &+zLone(-s12,-s34)+zLone(-s15,-s34))/s34**(2)
     &+2d0/3d0*zb23**(2)*zb41**(3)*za24**(3)/(zb45*zb51*zb24)*zLtwo(-s23,-s15)/s15**(3)
     &-2d0/3d0*zb21**(2)*zb53**(3)*za25**(3)/(zb54*zb43*zb25)*zLtwo(-s12,-s34)/s34**(3)
     &+zLtwo(-s34,-s15)/s15**(3)*(1d0/3d0*zb13*za24*za25*
     & (zb15*za52*zb23-zb34*za42*zb21)/zb45
     &+2d0/3d0*zb12**(2)*zb34**(2)*zb41*za24**(3)/(zb45*zb51*zb24)
     &-2d0/3d0*zb32**(2)*zb15**(2)*zb53*za25**(3)/(zb54*zb43*zb25))
     &+1d0/6d0*zb13**(3)*(zb15*za52*zb23-zb34*za42*zb21)/
     & (zb12*zb23*zb34*zb45*zb51)*zLzero(-s34,-s15)/s15
     &+1d0/3d0*za24**(2)*za25**(2)/(za12*za23*za34*zb45*za51)
     &-1d0/3d0*zb12*zb41**(2)*za24**(3)/(zb45*zb51*zb24*za23*za34*s15)
     &+1d0/3d0*zb32*zb53**(2)*za25**(3)/(zb54*zb43*zb25*za21*za15*s34)
     &+1d0/6d0*zb13**(2)*za24*za25/(s34*zb45*s15)

      ze0=ze0+zi*(4d0*zFf+zFs)

* must be interfered with A5g0(i1,i3,i5,i2,i4)
      ztree=zi*zb13**(4)/(zb13*zb35*zb52*zb24*zb41)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        At5g1pmpmm=e2
      elseif(ieorder.eq.-1)then
        At5g1pmpmm=e1
      elseif(ieorder.eq.0)then
        At5g1pmpmm=e0
      endif
*      write(*,10)At5g1pmpmm,i1,i2,i3,i4,i5
   10 format(" At5g1pmpmm   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function Ath5g1mmppp(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello Ath5g1mmppp ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !-Vf-Vs

      ze2=0d0*zone

      ze1=10d0/6d0*zone


      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s23)+zzlog(renscale2)-zzlog(-s15))-2d0*zone

      zVs=-1d0/3d0*zVf+2d0/9d0*zone

      ze0=-zVf-zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*za12**(4)/(za12*za23*za34*za45*za51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree

      zFf=-1d0/2d0*za12**(2)*(za23*zb34*za41+za24*zb45*za51)/
     &      (za23*za34*za45*za51)*zLzero(-s23,-s15)/s15

      zFs=-1d0/3d0*(zb34*za41*za24*zb45*(za23*zb34*za41+za24*zb45*za51))/
     & (za34*za45)*zLtwo(-s23,-s15)/s15**(3)
     &-1d0/3d0*zFf
     &-1d0/3d0*za35*zb35**(3)/(zb12*zb23*za34*za45*zb51)
     &+1d0/3d0*za12*zb35**(2)/(zb23*za34*za45*zb51)
     &+1d0/6d0*za12*zb34*za41*za24*zb45/(s23*za34*za45*s15)

      ze0=ze0+zi*(-zFf-zFs)

* must be interfered with A5g0(i1,i3,i5,i2,i4)
      ztree=zi*za12**(4)/(za13*za35*za52*za24*za41)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        Ath5g1mmppp=e2
      elseif(ieorder.eq.-1)then
        Ath5g1mmppp=e1
      elseif(ieorder.eq.0)then
        Ath5g1mmppp=e0
      endif
*      write(*,10)Ath5g1mmppp,i1,i2,i3,i4,i5
   10 format(" Ath5g1mmppp   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function Ath5g1mpmpp(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello Ath5g1mpmpp ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !-Vf-Vs

      ze2=0d0*zone

      ze1=10d0/6d0*zone


      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s34)+zzlog(renscale2)-zzlog(-s15))-2d0

      zVs=-1d0/3d0*zVf+2d0/9d0

      ze0=-zVf-zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*za13**(4)/(za12*za23*za34*za45*za51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree


      zFf=-za13**(2)*za41*zb24**(2)/(za45*za51)*zLs1(-s23,-s15,-s34,-s15)/s15**(2)
     &    +za13**(2)*za53*zb25**(2)/(za34*za45)*zLs1(-s12,-s34,-s15,-s34)/s34**(2)
     &-1d0/2d0*za13**(3)*(za15*zb52*za23-za34*zb42*za21)/
     &   (za12*za23*za34*za45*za51)*zLzero(-s34,-s15)/s15


      zFs=-za12*za23*za34*za41**(2)*zb24**(2)/
     & (za45*za51*za24**(2))*(2d0*zLs1(-s23,-s15,-s34,-s15)
     &+zLone(-s23,-s15)+zLone(-s34,-s15))/s15**(2)
     &+za32*za21*za15*za53**(2)*zb25**(2)/
     & (za54*za43*za25**(2))*(2d0*zLs1(-s12,-s34,-s15,-s34)
     &+zLone(-s12,-s34)+zLone(-s15,-s34))/s34**(2)
     &+2d0/3d0*za23**(2)*za41**(3)*zb24**(3)/(za45*za51*za24)*zLtwo(-s23,-s15)/s15**(3)
     &-2d0/3d0*za21**(2)*za53**(3)*zb25**(3)/(za54*za43*za25)*zLtwo(-s12,-s34)/s34**(3)
     &+zLtwo(-s34,-s15)/s15**(3)*(1d0/3d0*za13*zb24*zb25*
     & (za15*zb52*za23-za34*zb42*za21)/za45
     &+2d0/3d0*za12**(2)*za34**(2)*za41*zb24**(3)/(za45*za51*za24)
     &-2d0/3d0*za32**(2)*za15**(2)*za53*zb25**(3)/(za54*za43*za25))
     &+1d0/6d0*za13**(3)*(za15*zb52*za23-za34*zb42*za21)/
     & (za12*za23*za34*za45*za51)*zLzero(-s34,-s15)/s15
     &+1d0/3d0*zb24**(2)*zb25**(2)/(zb12*zb23*zb34*za45*zb51)
     &-1d0/3d0*za12*za41**(2)*zb24**(3)/(za45*za51*za24*zb23*zb34*s15)
     &+1d0/3d0*za32*za53**(2)*zb25**(3)/(za54*za43*za25*zb21*zb15*s34)
     &+1d0/6d0*za13**(2)*zb24*zb25/(s34*za45*s15)

      ze0=ze0+zi*(-zFf-zFs)

* must be interfered with A5g0(i1,i3,i5,i2,i4)
      ztree=zi*za13**(4)/(za13*za35*za52*za24*za41)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        Ath5g1mpmpp=e2
      elseif(ieorder.eq.-1)then
        Ath5g1mpmpp=e1
      elseif(ieorder.eq.0)then
        Ath5g1mpmpp=e0
      endif
*      write(*,10)Ath5g1mpmpp,i1,i2,i3,i4,i5
   10 format(" Ath5g1mpmpp   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function Ath5g1ppmmm(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello Ath5g1ppmmm ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !-Vf-Vs

      ze2=0d0*zone

      ze1=10d0/6d0*zone


      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s23)+zzlog(renscale2)-zzlog(-s15))-2d0*zone

      zVs=-1d0/3d0*zVf+2d0/9d0*zone

      ze0=-zVf-zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*zb12**(4)/(zb12*zb23*zb34*zb45*zb51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree

      zFf=-1d0/2d0*zb12**(2)*(zb23*za34*zb41+zb24*za45*zb51)/
     &      (zb23*zb34*zb45*zb51)*zLzero(-s23,-s15)/s15

      zFs=-1d0/3d0*(za34*zb41*zb24*za45*(zb23*za34*zb41+zb24*za45*zb51))/
     & (zb34*zb45)*zLtwo(-s23,-s15)/s15**(3)
     &-1d0/3d0*zFf
     &-1d0/3d0*zb35*za35**(3)/(za12*za23*zb34*zb45*za51)
     &+1d0/3d0*zb12*za35**(2)/(za23*zb34*zb45*za51)
     &+1d0/6d0*zb12*za34*zb41*zb24*za45/(s23*zb34*zb45*s15)

      ze0=ze0+zi*(-zFf-zFs)

* must be interfered with A5g0(i1,i3,i5,i2,i4)
      ztree=zi*zb12**(4)/(zb13*zb35*zb52*zb24*zb41)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        Ath5g1ppmmm=e2
      elseif(ieorder.eq.-1)then
        Ath5g1ppmmm=e1
      elseif(ieorder.eq.0)then
        Ath5g1ppmmm=e0
      endif
*      write(*,10)Ath5g1ppmmm,i1,i2,i3,i4,i5
   10 format(" Ath5g1ppmmm   ",e16.8,5i3)

      return
      end
************************************************************************
*
      function Ath5g1pmpmm(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      common /scheme/ deltaR
      parameter(pi=3.141592653589793238d0)

*      write(*,*)" hello Ath5g1pmpmm ", i1,i2,i3,i4,i5

      zone=(1d0,0d0)
      zi=(0d0,1d0)

      za12=zA5(i1,i2)
      za21=zA5(i2,i1)
      za13=zA5(i1,i3)
      za31=zA5(i3,i1)
      za14=zA5(i1,i4)
      za41=zA5(i4,i1)
      za15=zA5(i1,i5)
      za51=zA5(i5,i1)
      za23=zA5(i2,i3)
      za32=zA5(i3,i2)
      za24=zA5(i2,i4)
      za42=zA5(i4,i2)
      za25=zA5(i2,i5)
      za52=zA5(i5,i2)
      za34=zA5(i3,i4)
      za43=zA5(i4,i3)
      za35=zA5(i3,i5)
      za53=zA5(i5,i3)
      za45=zA5(i4,i5)
      za54=zA5(i5,i4)

      zb12=zB5(i1,i2)
      zb21=zB5(i2,i1)
      zb13=zB5(i1,i3)
      zb31=zB5(i3,i1)
      zb14=zB5(i1,i4)
      zb41=zB5(i4,i1)
      zb15=zB5(i1,i5)
      zb51=zB5(i5,i1)
      zb23=zB5(i2,i3)
      zb32=zB5(i3,i2)
      zb24=zB5(i2,i4)
      zb42=zB5(i4,i2)
      zb25=zB5(i2,i5)
      zb52=zB5(i5,i2)
      zb34=zB5(i3,i4)
      zb43=zB5(i4,i3)
      zb35=zB5(i3,i5)
      zb53=zB5(i5,i3)
      zb45=zB5(i4,i5)
      zb54=zB5(i5,i4)

      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)

      !hep-ph/9302280
      !-Vf-Vs

      ze2=0d0*zone

      ze1=10d0/6d0*zone


      zVf=-1d0/2d0*(zzlog(renscale2)-zzlog(-s34)+zzlog(renscale2)-zzlog(-s15))-2d0

      zVs=-1d0/3d0*zVf+2d0/9d0

      ze0=-zVf-zVs
* correction factor to convert from c_gamma prefactor
      ze0=ze0-ze2*pi**2/12d0

      ztree=zi*zb13**(4)/(zb12*zb23*zb34*zb45*zb51)

      ze2=ze2*ztree
      ze1=ze1*ztree
      ze0=ze0*ztree

      zFf=-zb13**(2)*zb41*za24**(2)/(zb45*zb51)*zLs1(-s23,-s15,-s34,-s15)/s15**(2)
     &    +zb13**(2)*zb53*za25**(2)/(zb34*zb45)*zLs1(-s12,-s34,-s15,-s34)/s34**(2)
     &-1d0/2d0*zb13**(3)*(zb15*za52*zb23-zb34*za42*zb21)/
     &   (zb12*zb23*zb34*zb45*zb51)*zLzero(-s34,-s15)/s15


      zFs=-zb12*zb23*zb34*zb41**(2)*za24**(2)/
     & (zb45*zb51*zb24**(2))*(2d0*zLs1(-s23,-s15,-s34,-s15)
     &+zLone(-s23,-s15)+zLone(-s34,-s15))/s15**(2)
     &+zb32*zb21*zb15*zb53**(2)*za25**(2)/
     & (zb54*zb43*zb25**(2))*(2d0*zLs1(-s12,-s34,-s15,-s34)
     &+zLone(-s12,-s34)+zLone(-s15,-s34))/s34**(2)
     &+2d0/3d0*zb23**(2)*zb41**(3)*za24**(3)/(zb45*zb51*zb24)*zLtwo(-s23,-s15)/s15**(3)
     &-2d0/3d0*zb21**(2)*zb53**(3)*za25**(3)/(zb54*zb43*zb25)*zLtwo(-s12,-s34)/s34**(3)
     &+zLtwo(-s34,-s15)/s15**(3)*(1d0/3d0*zb13*za24*za25*
     & (zb15*za52*zb23-zb34*za42*zb21)/zb45
     &+2d0/3d0*zb12**(2)*zb34**(2)*zb41*za24**(3)/(zb45*zb51*zb24)
     &-2d0/3d0*zb32**(2)*zb15**(2)*zb53*za25**(3)/(zb54*zb43*zb25))
     &+1d0/6d0*zb13**(3)*(zb15*za52*zb23-zb34*za42*zb21)/
     & (zb12*zb23*zb34*zb45*zb51)*zLzero(-s34,-s15)/s15
     &+1d0/3d0*za24**(2)*za25**(2)/(za12*za23*za34*zb45*za51)
     &-1d0/3d0*zb12*zb41**(2)*za24**(3)/(zb45*zb51*zb24*za23*za34*s15)
     &+1d0/3d0*zb32*zb53**(2)*za25**(3)/(zb54*zb43*zb25*za21*za15*s34)
     &+1d0/6d0*zb13**(2)*za24*za25/(s34*zb45*s15)

      ze0=ze0+zi*(-zFf-zFs)

* must be interfered with A5g0(i1,i3,i5,i2,i4)
      ztree=zi*zb13**(4)/(zb13*zb35*zb52*zb24*zb41)

      e2=2d0*real(ze2*dconjg(ztree))
      e1=2d0*real(ze1*dconjg(ztree))
      e0=2d0*real(ze0*dconjg(ztree))

      if(ieorder.eq.-2)then
        Ath5g1pmpmm=e2
      elseif(ieorder.eq.-1)then
        Ath5g1pmpmm=e1
      elseif(ieorder.eq.0)then
        Ath5g1pmpmm=e0
      endif
*      write(*,10)Ath5g1pmpmm,i1,i2,i3,i4,i5
   10 format(" Ath5g1pmpmm   ",e16.8,5i3)

      return
      end
************************************************************************
* Full LC (N^0) colour level of FullA5g1
      function A5g1full(i1,i2,i3,i4,i5,renscale2)
      double precision A5g1full,A5g1,renscale2
      integer i1,i2,i3,i4,i5

      A5g1full = +A5g1(i1,i2,i3,i4,i5,renscale2)
     .           +A5g1(i1,i2,i3,i5,i4,renscale2)
     .           +A5g1(i1,i2,i4,i3,i5,renscale2)
     .           +A5g1(i1,i2,i4,i5,i3,renscale2)
     .           +A5g1(i1,i2,i5,i3,i4,renscale2)
     .           +A5g1(i1,i2,i5,i4,i3,renscale2)
     .           +A5g1(i1,i3,i2,i4,i5,renscale2)
     .           +A5g1(i1,i3,i2,i5,i4,renscale2)
     .           +A5g1(i1,i4,i2,i3,i5,renscale2)
     .           +A5g1(i1,i4,i2,i5,i3,renscale2)
     .           +A5g1(i1,i5,i2,i3,i4,renscale2)
     .           +A5g1(i1,i5,i2,i4,i3,renscale2)

      return
      end
************************************************************************
* Full LC nf (nf/N) colour level of FullA5g1
      function Ah5g1full(i1,i2,i3,i4,i5,renscale2)
      double precision Ah5g1full,Ah5g1,renscale2
      integer i1,i2,i3,i4,i5

      Ah5g1full = +Ah5g1(i1,i2,i3,i4,i5,renscale2)
     .            +Ah5g1(i1,i2,i3,i5,i4,renscale2)
     .            +Ah5g1(i1,i2,i4,i3,i5,renscale2)
     .            +Ah5g1(i1,i2,i4,i5,i3,renscale2)
     .            +Ah5g1(i1,i2,i5,i3,i4,renscale2)
     .            +Ah5g1(i1,i2,i5,i4,i3,renscale2)
     .            +Ah5g1(i1,i3,i2,i4,i5,renscale2)
     .            +Ah5g1(i1,i3,i2,i5,i4,renscale2)
     .            +Ah5g1(i1,i4,i2,i3,i5,renscale2)
     .            +Ah5g1(i1,i4,i2,i5,i3,renscale2)
     .            +Ah5g1(i1,i5,i2,i3,i4,renscale2)
     .            +Ah5g1(i1,i5,i2,i4,i3,renscale2)

      return
      end
************************************************************************
* Full SLC (1/N^2) colour level of FullA5g1
      function At5g1full(i1,i2,i3,i4,i5,renscale2)
      double precision At5g1full,At5g1,renscale2
      integer i1,i2,i3,i4,i5

      At5g1full = 12d0*(
     .            +At5g1(i1,i2,i3,i4,i5,renscale2)
     .            +At5g1(i1,i2,i3,i5,i4,renscale2)
     .            +At5g1(i1,i2,i4,i3,i5,renscale2)
     .            +At5g1(i1,i2,i4,i5,i3,renscale2)
     .            +At5g1(i1,i2,i5,i3,i4,renscale2)
     .            +At5g1(i1,i2,i5,i4,i3,renscale2)
     .            +At5g1(i1,i3,i2,i4,i5,renscale2)
     .            +At5g1(i1,i3,i2,i5,i4,renscale2)
     .            +At5g1(i1,i4,i2,i3,i5,renscale2)
     .            +At5g1(i1,i4,i2,i5,i3,renscale2)
     .            +At5g1(i1,i5,i2,i3,i4,renscale2)
     .            +At5g1(i1,i5,i2,i4,i3,renscale2)
     .            )

      return
      end
************************************************************************
* Full SLC nf (nf/N^3) colour level of FullA5g1
      function Ath5g1full(i1,i2,i3,i4,i5,renscale2)
      double precision Ath5g1full,Ath5g1,renscale2
      integer i1,i2,i3,i4,i5

      Ath5g1full = 2d0*(
     .             +Ath5g1(i1,i2,i3,i4,i5,renscale2)
     .             +Ath5g1(i1,i2,i3,i5,i4,renscale2)
     .             +Ath5g1(i1,i2,i4,i3,i5,renscale2)
     .             +Ath5g1(i1,i2,i4,i5,i3,renscale2)
     .             +Ath5g1(i1,i2,i5,i3,i4,renscale2)
     .             +Ath5g1(i1,i2,i5,i4,i3,renscale2)
     .             +Ath5g1(i1,i3,i2,i4,i5,renscale2)
     .             +Ath5g1(i1,i3,i2,i5,i4,renscale2)
     .             +Ath5g1(i1,i4,i2,i3,i5,renscale2)
     .             +Ath5g1(i1,i4,i2,i5,i3,renscale2)
     .             +Ath5g1(i1,i5,i2,i3,i4,renscale2)
     .             +Ath5g1(i1,i5,i2,i4,i3,renscale2)
     .             )

      return
      end
************************************************************************


