* full colour matrix element for six quark zero gluon three non-identical quark pairs
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(Q,Qb),(R,Rb)
      function FullE0g0detail(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      dimension ztmp(6,4),tmp(6,4),tmp2(6,4)

c     write(*,*)"hello fullE0g0"

      fac=(4d0*pi*as)**4*(nc**2-1d0)*nc

      islc=1

      wt =
     .   + E0g0(i1,i4,i3,i6,i5,i2)
     .   + E0g0(i1,i6,i5,i4,i3,i2)
*       + N*V * (
*          + M(1,4,3,6,5,2)*Mc(1,4,3,6,5,2)
*          + M(1,6,5,4,3,2)*Mc(1,6,5,4,3,2)
*          )
     .   + 1d0/dble(nc)**2*(
     .   + Et0g0(i1,i4,i3,i2,i5,i6)
     .   + Et0g0(i1,i6,i5,i2,i3,i4)
     .   + Et0g0(i5,i4,i3,i6,i1,i2)
     .   - 3d0*Ett0g0(i1,i2,i3,i4,i5,i6)
     .    )*islc
*       + N^-1*V * (
*          + Mt(1,2,3,6,5,4)*Mtc(1,2,3,6,5,4)
*          + Mt(3,4,1,6,5,2)*Mtc(3,4,1,6,5,2)
*          + Mt(5,6,1,4,3,2)*Mtc(5,6,1,4,3,2)
*          - 3 * Mtt(1,2,3,4,5,6)*Mttc(1,2,3,4,5,6)
*          )

*key identity to simplify fullE0g0 to this result is by:
*
*zEt0g0(i1,i4,i3,i2,i5,i6) + zEt0g0(i1,i6,i5,i2,i3,i4) +  
*zEt0g0(i5,i4,i3,i6,i1,i2)= 2 * zEtt0g0(i1,i2,i3,i4,i5,i6)
*
*zE0g0(i1,i4,i3,i6,i5,i2) + zE0g0(i1,i6,i5,i4,i3,i2) =
*zEtt0g0(i1,i2,i3,i4,i5,i6)

      wt = wt*fac
      FullE0g0detail=wt
      return
      end

************************************************************************
* full colour matrix element for six quark zero gluon three non-identical quark pairs
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(Q,Qb),(R,Rb)
* same as FullE0g0detail but using a compact form
      function FullE0g0compact(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      dimension ztmp(6,4),tmp(6,4),tmp2(6,4)

c     write(*,*)"hello fullE0g0"

      fac=(4d0*pi*as)**4*(nc**2-1d0)*nc

      wt = FullE0g0(i1,i2,i3,i4,i5,i6)
      wt = wt*fac
      FullE0g0compact=wt
      return
      end

************************************************************************
* full colour matrix element for six quark zero gluon three non-identical quark pairs
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(Q,Qb),(R,Rb)
* used by FullE0g0compact
      function FullE0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0

      FullE0g0 =
     .   + E0g0XX(i1,i2,i3,i4,i5,i6)
     .   + 1d0/dble(nc)**2*(
     .   + Et0g0X(i1,i2,i3,i4,i5,i6)
     .   - 3d0*Ett0g0X(i1,i2,i3,i4,i5,i6)
     .    )

      return
      end

************************************************************************
* sum of leading colour squared amplitudes

      function E0g0X(iqb1,iq1,iqb2,iq2,iqb3,iq3)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      E0g0X =
     .   + E0g0(iq1,iqb2,iq2,iqb3,iq3,iqb1)
     .   + E0g0(iq1,iqb3,iq3,iqb2,iq2,iqb1)
      return
      end

************************************************************************
* sum of leading colour squared amplitudes
* same as E0g0X but using a different input order convention 
* E0g0XX is symmetric with any exchange of the quark pairs: 
* E0g0XX(iq1,iqb1,iq2,iqb2,iq3,iqb3) = E0g0XX(iq1,iqb1,iq3,iqb3,iq2,iqb2) = E0g0XX(iq2,iqb2,iq1,iqb1,iq3,iqb3)
      function E0g0XX(iq1,iqb1,iq2,iqb2,iq3,iqb3)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      E0g0XX =
     .   + E0g0(iq1,iqb2,iq2,iqb3,iq3,iqb1)
     .   + E0g0(iq1,iqb3,iq3,iqb2,iq2,iqb1)
      return
      end

************************************************************************
* sum of sub-leading colour squared amplitudes
* Et0g0X is symmetric with any exchange of the quark pairs: 
* Et0g0X(iq1,iqb1,iq2,iqb2,iq3,iqb3) = Et0g0X(iq1,iqb1,iq3,iqb3,iq2,iqb2) = Et0g0X(iq2,iqb2,iq1,iqb1,iq3,iqb3)

      function Et0g0X(iq1,iqb1,iq2,iqb2,iq3,iqb3)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Et0g0X =
     .   + Et0g0(iq1,iqb2,iq2,iqb1,iq3,iqb3)
     .   + Et0g0(iq1,iqb3,iq3,iqb1,iq2,iqb2)
     .   + Et0g0(iq2,iqb3,iq3,iqb2,iq1,iqb1)
      return
      end

************************************************************************
* sub-sub-leading squared amplitude same as Ett0g0, this is buffer layer for potential colour permutation at driver

      function Ett0g0X(iq1,iqb1,iq2,iqb2,iq3,iqb3)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Ett0g0X = Ett0g0(iq1,iqb1,iq2,iqb2,iq3,iqb3)

      return
      end

************************************************************************
* leading colour squared amplitude

      function E0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      do i=1,4
         ztmp=zE0g0(i1,i2,i3,i4,i5,i6,i)
         wt=wt+dreal(dconjg(ztmp)*ztmp)
      enddo

      E0g0=2d0*wt

c      write(*,*)i1,i2,i3,i4,i5,i6,E0g0

      return
      end
************************************************************************
* sub-leading colour squared amplitude (one internal photon)

      function Et0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      do i=1,4
         ztmp=zEt0g0(i1,i2,i3,i4,i5,i6,i)
         wt=wt+dreal(dconjg(ztmp)*ztmp)
c         write(*,*)"Et0g0 ",i,dreal(dconjg(ztmp)*ztmp)
      enddo
c      write(*,*)

      Et0g0=2d0*wt

      return
      end
************************************************************************
* sub-sub-leading squared amplitude (two internal photons)

      function Ett0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      do i=1,4
         ztmp=zEtt0g0(i1,i2,i3,i4,i5,i6,i)
         wt=wt+dreal(dconjg(ztmp)*ztmp)
c         write(*,*)"Ett0g0 ",i,dreal(dconjg(ztmp)*ztmp)
      enddo
c      write(*,*)

      Ett0g0=2d0*wt

      return
      end
************************************************************************
* leading colour helicity amplitudes
* The quark pairs with different flavours are (i1,i6),(i3,i2),(i5,i4).
* Following the notation of E0g0X, the flavour pairs are
* (i1,i6),(i3,i2),(i5,i4) = (q,qb),(Q,Qb),(R,Rb).

* The four helicity combinations are
*       q Qb Q Rb R qb
*ihel=1 + -  + -  + -
*ihel=2 + +  - -  + -  (exchange Q<-->Qb in ihel=1)
*ihel=3 + -  + +  - -  (exchange R<-->Rb in ihel=1)
*ihel=4 + +  - +  - -  (exchange R<-->Rb in ihel=2)
* The other four helicity combinations starting with
* q - is obtained by factor of 2 after modular square.
 
* zE0g0(i1,i2,i3,i4,i5,i6,ihel) has cyclic permutation symmetry that
* is obvious from the combinations of three zamp1 and one zamp2 that
* zE0g0(i1,i2,i3,i4,i5,i6,ihel) = zE0g0(i3,i4,i5,i6,i1,i2,ihel).

* Need to be careful that all permutations mentioned in this file carry 
* the corresponding helicity during the permutation.

      function zE0g0(i1,i2,i3,i4,i5,i6,ihel)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      if(ihel.eq.1)then
      zwt=zamp1(i1,i2,i5,i6,i3,i4,1)
     .   +zamp1(i3,i4,i1,i2,i5,i6,1)
     .   +zamp1(i5,i6,i3,i4,i1,i2,1)
     .   +zamp2(i1,i2,i3,i4,i5,i6,1)
      elseif(ihel.eq.2)then
      zwt=zamp1(i1,i2,i5,i6,i3,i4,3)
     .   +zamp1(i2,i4,i1,i3,i5,i6,1)
     .   +zamp1(i5,i6,i3,i4,i1,i2,2)
     .   +zamp2(i1,i2,i3,i4,i5,i6,2)
      elseif(ihel.eq.3)then
      zwt=zamp1(i1,i2,i5,i6,i3,i4,2)
     .   +zamp1(i3,i4,i1,i2,i5,i6,3)
     .   +zamp1(i4,i6,i3,i5,i1,i2,1)
     .   +zamp2(i1,i2,i3,i4,i5,i6,3)
      elseif(ihel.eq.4)then
      zwt=zamp1(i1,i2,i5,i6,i3,i4,4)
     .   +zamp1(i2,i4,i1,i3,i5,i6,3)
     .   +zamp1(i4,i6,i3,i5,i1,i2,2)
     .   +zamp2(i1,i2,i3,i4,i5,i6,4)
      endif

      zE0g0=zwt

      return
      end
************************************************************************
* sub-leading colour helicity amplitudes
* (i5,i6) = (R,Rb) is the abelian quark pair, 
* (i1,i4) = (q,qb) and (i3,i2) = (Q,Qb)
* are the two non-abelian quark pairs with different flavour.

* The four helicity combinations are
*       q Qb Q qb R Rb  
*ihel=1 + -  + -  + -   
*ihel=2 + +  - -  + -    (exchange Q<-->Qb in ihel=1)
*ihel=3 + -  + -  - +    (exchange R<-->Rb in ihel=1)
*ihel=4 + +  - -  - +    (exchange R<-->Rb in ihel=2)
* The other four helicity combinations starting with
* q - is obtained by factor of 2 after modular square.

* zEt0g0(i1,i2,i3,i4,i5,i6,ihel) is invariant under non-abelian quark pair exchange:
* zEt0g0(i1,i2,i3,i4,i5,i6,ihel) = zEt0g0(i3,i4,i1,i2,i5,i6,ihel)

      function zEt0g0(i1,i2,i3,i4,i5,i6,ihel)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      if(ihel.eq.1)then
      zwt=zamp1(i1,i6,i3,i4,i5,i2,1)
     .   +zamp1(i3,i6,i1,i2,i5,i4,1)
     .   +zamp1(i5,i2,i1,i6,i3,i4,1)
     .   +zamp1(i5,i4,i3,i6,i1,i2,1)
      elseif(ihel.eq.2)then
      zwt=zamp1(i1,i6,i3,i4,i5,i2,2)
     .   +zamp1(i2,i6,i1,i3,i5,i4,1)
     .   +zamp1(i5,i2,i1,i6,i3,i4,3)
     .   +zamp1(i5,i4,i3,i6,i1,i2,2)
      elseif(ihel.eq.3)then
      zwt=zamp1(i1,i6,i3,i4,i5,i2,3)
     .   +zamp1(i3,i6,i1,i2,i5,i4,3)
     .   +zamp1(i6,i2,i1,i5,i3,i4,1)
     .   +zamp1(i6,i4,i3,i5,i1,i2,1)
      elseif(ihel.eq.4)then
      zwt=zamp1(i1,i6,i3,i4,i5,i2,4)
     .   +zamp1(i2,i6,i1,i3,i5,i4,3)
     .   +zamp1(i6,i2,i1,i5,i3,i4,3)
     .   +zamp1(i6,i4,i3,i5,i1,i2,2)
      endif

      zEt0g0=zwt

      return
      end
************************************************************************
* sub-sub-leading colour helicity amplitudes
* (i1,i2) = (q,qb), (i3,i4) = (Q,Qb), (i5,i6) = (R,Rb) 
*are the three abelian quark pairs with different flavours

* The four helicity combinations are
*       q qb Q Qb R Rb
*ihel=1 + -  + -  + - 
*ihel=2 + -  - +  + -  (exchange Q<-->Qb in ihel=1)
*ihel=3 + -  + -  - +  (exchange R<-->Rb in ihel=1)
*ihel=4 + -  - +  - +  (exchange R<-->Rb in ihel=2)
* The other four helicity combinations starting with
* q - is obtained by factor of 2 after modular square.

* Any exchange of (i1,i2)<-->(i3,i4)<-->(i5,i6) would leave zEtt0g0 unchanged

      function zEtt0g0(i1,i2,i3,i4,i5,i6,ihel)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      if(ihel.eq.1)then
      zwt=zamp1(i1,i6,i3,i2,i5,i4,1)
     .   +zamp1(i1,i4,i5,i2,i3,i6,1)
     .   +zamp1(i3,i6,i1,i4,i5,i2,1)
     .   +zamp1(i3,i2,i5,i4,i1,i6,1)
     .   +zamp1(i5,i4,i1,i6,i3,i2,1)
     .   +zamp1(i5,i2,i3,i6,i1,i4,1)
      elseif(ihel.eq.2)then
      zwt=zamp1(i1,i6,i3,i2,i5,i4,2)
     .   +zamp1(i1,i4,i5,i2,i3,i6,3)
     .   +zamp1(i4,i6,i1,i3,i5,i2,1)
     .   +zamp1(i4,i2,i5,i3,i1,i6,1)
     .   +zamp1(i5,i4,i1,i6,i3,i2,3)
     .   +zamp1(i5,i2,i3,i6,i1,i4,2)
      elseif(ihel.eq.3)then
      zwt=zamp1(i1,i6,i3,i2,i5,i4,3)
     .   +zamp1(i1,i4,i5,i2,i3,i6,2)
     .   +zamp1(i3,i6,i1,i4,i5,i2,3)
     .   +zamp1(i3,i2,i5,i4,i1,i6,2)
     .   +zamp1(i6,i4,i1,i5,i3,i2,1)
     .   +zamp1(i6,i2,i3,i5,i1,i4,1)
      elseif(ihel.eq.4)then
      zwt=zamp1(i1,i6,i3,i2,i5,i4,4)
     .   +zamp1(i1,i4,i5,i2,i3,i6,4)
     .   +zamp1(i4,i6,i1,i3,i5,i2,3)
     .   +zamp1(i4,i2,i5,i3,i1,i6,2)
     .   +zamp1(i6,i4,i1,i5,i3,i2,3)
     .   +zamp1(i6,i2,i3,i5,i1,i4,2)
      endif

      zEtt0g0=zwt

      return
      end
************************************************************************
* QED-like diagram with three quark lines connected by two internal gluons
* coupling only to quark lines, i.e. |--|--|
*     i1  i3  i5
*      |---|---|
*     i2  i4  i6
* i1, i2, i3, i4, i5, i6 labeling corresponds to indices only inside this function.
* The flavour pairs are (i1,i2),(i3,i4),(i5,i6) = (q,qb),(R,Rb),(Q,Qb)
* for above labeling one could exchange i1<-->i2 or i5<-->i6 to get a different helicity 
* configuration however not i3<-->i4 since they are in the middle of the Feynman diagram

*So starting from ihel=1 inside this function, the ihel=3 is simply exchange i5<-->i6.
*To get ihel=2, one can't exchange i3<-->i4 but could exchange booth i5<-->i6
* and i1<-->i2, then take the parity operation (complex conjugate) of ihel=1 to get ihel=2.
*From ihel=2 to ihel=4 is simply exchange i5<-->i6 as in the ihel=1 to ihel=3 case.

* The four helicity combinations are 
*(note that these helicity is different from the orderings in zE0g0)
*       q Qb Q Rb R qb
*ihel=1 + -  + -  + -
*ihel=2 + -  + +  - -
*ihel=3 + +  - -  + -
*ihel=4 + +  - +  - -

      function zamp1(i1,i6,i3,i2,i5,i4,ihel)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      zi=(0d0,1d0)

      s12=s6(i1,i2)
      s13=s6(i1,i3)
      s14=s6(i1,i4)
      s15=s6(i1,i5)
      s16=s6(i1,i6)
      s23=s6(i2,i3)
      s24=s6(i2,i4)
      s25=s6(i2,i5)
      s26=s6(i2,i6)
      s34=s6(i3,i4)
      s35=s6(i3,i5)
      s36=s6(i3,i6)
      s45=s6(i4,i5)
      s46=s6(i4,i6)
      s56=s6(i5,i6)

      s123=s12+s13+s23

      za12=zA6(i1,i2)
      za13=zA6(i1,i3)
      za14=zA6(i1,i4)
      za15=zA6(i1,i5)
      za16=zA6(i1,i6)
      za23=zA6(i2,i3)
      za24=zA6(i2,i4)
      za25=zA6(i2,i5)
      za26=zA6(i2,i6)
      za34=zA6(i3,i4)
      za35=zA6(i3,i5)
      za36=zA6(i3,i6)
      za45=zA6(i4,i5)
      za46=zA6(i4,i6)
      za56=zA6(i5,i6)

      za21=zA6(i2,i1)
      za31=zA6(i3,i1)
      za41=zA6(i4,i1)
      za51=zA6(i5,i1)
      za61=zA6(i6,i1)
      za32=zA6(i3,i2)
      za42=zA6(i4,i2)
      za52=zA6(i5,i2)
      za62=zA6(i6,i2)
      za43=zA6(i4,i3)
      za53=zA6(i5,i3)
      za63=zA6(i6,i3)
      za54=zA6(i5,i4)
      za64=zA6(i6,i4)
      za65=zA6(i6,i5)

      zb12=zB6(i1,i2)
      zb13=zB6(i1,i3)
      zb14=zB6(i1,i4)
      zb15=zB6(i1,i5)
      zb16=zB6(i1,i6)
      zb23=zB6(i2,i3)
      zb24=zB6(i2,i4)
      zb25=zB6(i2,i5)
      zb26=zB6(i2,i6)
      zb34=zB6(i3,i4)
      zb35=zB6(i3,i5)
      zb36=zB6(i3,i6)
      zb45=zB6(i4,i5)
      zb46=zB6(i4,i6)
      zb56=zB6(i5,i6)

      zb21=zB6(i2,i1)
      zb31=zB6(i3,i1)
      zb41=zB6(i4,i1)
      zb51=zB6(i5,i1)
      zb61=zB6(i6,i1)
      zb32=zB6(i3,i2)
      zb42=zB6(i4,i2)
      zb52=zB6(i5,i2)
      zb62=zB6(i6,i2)
      zb43=zB6(i4,i3)
      zb53=zB6(i5,i3)
      zb63=zB6(i6,i3)
      zb54=zB6(i5,i4)
      zb64=zB6(i6,i4)
      zb65=zB6(i6,i5)

      zfac=-1d0/s123/s12/s56

      if(ihel.eq.1)zwt=za64*zb31*zba(i5,i1,i3,i2)
      if(ihel.eq.2)zwt=za32*zb54*zba(i1,i2,i3,i6)
      if(ihel.eq.3)zwt=za54*zb31*zba(i6,i1,i3,i2)
      if(ihel.eq.4)zwt=za32*zb64*zba(i1,i2,i3,i5)

      zwt=zwt*zfac
      zamp1=zwt

      return
      end
************************************************************************
* QCD-like diagram with three quark lines connected by three internal gluons
* coupling to each other via a three gluon vertex, i.e _|..Y..|_
*     i1     i5
*      |      |
*      |\    /|
*     i2 \  /i6
*         \/
*         |
*         |
*         |
*      i3---i4
* i1, i2, i3, i4, i5, i6 labeling corresponds to indices only inside this function
* The flavour pairs are (i1,i2),(i3,i4),(i5,i6) = (q,qb),(Q,Qb),(R,Rb).
* For above labeling one could exchange i1<-->i2, i5<-->i6 or i3<-->i4 
* to get a different helicity configuration.

* Based on ihel=1, one could exchange i3<-->i4 to get ihel=2
* Based on ihel=1, one could exchange i5<-->i6 to get ihel=3
* Based on ihel=1, one could exchange both i3<-->i4 and i5<-->i6 to get ihel=4

* The four helicity combinations are
*       q Qb Q Rb R qb
*ihel=1 + -  + -  + -
*ihel=2 + +  - -  + -
*ihel=3 + -  + +  - -
*ihel=4 + +  - +  - -

* There is cyclic symmetry of this Feynman diagram that
* zamp2(i1,i4,i3,i6,i5,i2,ihel) = zamp2(i3,i6,i5,i2,i1,i4,ihel),
* this property is important to guarantee the colour leading amplitude having cyclic symmetry.
* There is also fermion anti-symmetry exchange symmetry that
* zamp2(i1,i4,i3,i6,i5,i2,ihel) = -zamp2(i1,i6,i5,i4,i3,i2,ihel),
* this property is important to unify the extra minus sign when colour decompose
* f^abc= T(a,b,c) - T(a,c,b).

      function zamp2(i1,i4,i3,i6,i5,i2,ihel)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      zi=(0d0,1d0)

      s12=s6(i1,i2)
      s13=s6(i1,i3)
      s14=s6(i1,i4)
      s15=s6(i1,i5)
      s16=s6(i1,i6)
      s23=s6(i2,i3)
      s24=s6(i2,i4)
      s25=s6(i2,i5)
      s26=s6(i2,i6)
      s34=s6(i3,i4)
      s35=s6(i3,i5)
      s36=s6(i3,i6)
      s45=s6(i4,i5)
      s46=s6(i4,i6)
      s56=s6(i5,i6)

      s123=s12+s13+s23

      za12=zA6(i1,i2)
      za13=zA6(i1,i3)
      za14=zA6(i1,i4)
      za15=zA6(i1,i5)
      za16=zA6(i1,i6)
      za23=zA6(i2,i3)
      za24=zA6(i2,i4)
      za25=zA6(i2,i5)
      za26=zA6(i2,i6)
      za34=zA6(i3,i4)
      za35=zA6(i3,i5)
      za36=zA6(i3,i6)
      za45=zA6(i4,i5)
      za46=zA6(i4,i6)
      za56=zA6(i5,i6)

      za21=zA6(i2,i1)
      za31=zA6(i3,i1)
      za41=zA6(i4,i1)
      za51=zA6(i5,i1)
      za61=zA6(i6,i1)
      za32=zA6(i3,i2)
      za42=zA6(i4,i2)
      za52=zA6(i5,i2)
      za62=zA6(i6,i2)
      za43=zA6(i4,i3)
      za53=zA6(i5,i3)
      za63=zA6(i6,i3)
      za54=zA6(i5,i4)
      za64=zA6(i6,i4)
      za65=zA6(i6,i5)

      zb12=zB6(i1,i2)
      zb13=zB6(i1,i3)
      zb14=zB6(i1,i4)
      zb15=zB6(i1,i5)
      zb16=zB6(i1,i6)
      zb23=zB6(i2,i3)
      zb24=zB6(i2,i4)
      zb25=zB6(i2,i5)
      zb26=zB6(i2,i6)
      zb34=zB6(i3,i4)
      zb35=zB6(i3,i5)
      zb36=zB6(i3,i6)
      zb45=zB6(i4,i5)
      zb46=zB6(i4,i6)
      zb56=zB6(i5,i6)

      zb21=zB6(i2,i1)
      zb31=zB6(i3,i1)
      zb41=zB6(i4,i1)
      zb51=zB6(i5,i1)
      zb61=zB6(i6,i1)
      zb32=zB6(i3,i2)
      zb42=zB6(i4,i2)
      zb52=zB6(i5,i2)
      zb62=zB6(i6,i2)
      zb43=zB6(i4,i3)
      zb53=zB6(i5,i3)
      zb63=zB6(i6,i3)
      zb54=zB6(i5,i4)
      zb64=zB6(i6,i4)
      zb65=zB6(i6,i5)

      zfac=-1d0/s34/s12/s56

      if(ihel.eq.1)then
         zwt=za24*zb31*zba(i5,i3,i4,i6)
     .      +za64*zb35*zba(i1,i5,i6,i2)
     .      +za62*zb15*zba(i3,i1,i2,i4)
      elseif(ihel.eq.2)then
         zwt=za32*zb14*zba(i5,i3,i4,i6)
     .      +za36*zb54*zba(i1,i5,i6,i2)
     .      +za62*zb15*zba(i4,i1,i2,i3)
      elseif(ihel.eq.3)then
         zwt=za24*zb31*zba(i6,i3,i4,i5)
     .      +za54*zb36*zba(i1,i6,i5,i2)
     .      +za52*zb16*zba(i3,i1,i2,i4)
      elseif(ihel.eq.4)then
         zwt=za32*zb14*zba(i6,i3,i4,i5)
     .      +za35*zb64*zba(i1,i5,i6,i2)
     .      +za52*zb16*zba(i4,i1,i2,i3)
      endif

      zwt=zwt*zfac

      zamp2=zwt

      return
      end
************************************************************************
* convenient function

      function zba(i1,i2,i3,i4)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      zba=zB6(i1,i2)*zA6(i2,i4)+zB6(i1,i3)*zA6(i3,i4)

      return
      end
************************************************************************
* Wrapper function for full SLC level of FullE0g0
      function Et0g0SLC(iq1,iqb1,iq2,iqb2,iq3,iqb3)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Et0g0SLC = Et0g0X(iq1,iqb1,iq2,iqb2,iq3,iqb3)
     .         - 3d0*Ett0g0X(iq1,iqb1,iq2,iqb2,iq3,iqb3)

      return
      end
************************************************************************
