************************************************************************
* full colour matrix element for six quark zero gluon with two identical, one non-identical quark pairs
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(q,qb),(Q,Qb)
      function FullF0g0detail(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      dimension ztmp(6,4),tmp(6,4),tmp2(6,4)

c     write(*,*)"hello fullF0g0"

      fac=(4d0*pi*as)**4*(nc**2-1d0)*nc

      wt =
     .   + E0g0(i1,i4,i3,i6,i5,i2)
     .   + E0g0(i1,i6,i5,i4,i3,i2)

     .   + E0g0(i1,i2,i3,i6,i5,i4)
     .   + E0g0(i1,i6,i5,i2,i3,i4)
*       + N*V * (
*          + M(1,2,3,6,5,4)*Mc(1,2,3,6,5,4)
*          + M(1,4,3,6,5,2)*Mc(1,4,3,6,5,2)
*          + M(1,6,5,2,3,4)*Mc(1,6,5,2,3,4)
*          + M(1,6,5,4,3,2)*Mc(1,6,5,4,3,2)
*          )
     .   - 1d0/dble(nc)*(
     .   + F0g0(i1,i2,i3,i6,i5,i4)
     .   + F0g0(i1,i4,i3,i6,i5,i2)
     .   + F0g0(i3,i2,i1,i6,i5,i4)
     .   + F0g0(i3,i4,i1,i6,i5,i2)
     .    )
*       + V * (
*          - M(1,2,3,6,5,4)*Mtc(3,4,1,6,5,2)
*          - Mt(3,4,1,6,5,2)*Mc(1,2,3,6,5,4)

*          - M(1,4,3,6,5,2)*Mtc(3,2,1,6,5,4)
*          - Mt(3,2,1,6,5,4)*Mc(1,4,3,6,5,2)

*          - M(1,6,5,4,3,2)*Mtc(1,4,3,6,5,2) = - M(3,2,1,6,5,4)*Mtc(1,4,3,6,5,2)
*          - Mt(1,4,3,6,5,2)*Mc(1,6,5,4,3,2)

*          - M(1,6,5,2,3,4)*Mtc(1,2,3,6,5,4) = - M(3,4,1,6,5,2)*Mtc(1,2,3,6,5,4)
*          - Mt(1,2,3,6,5,4)*Mc(1,6,5,2,3,4)
*          )
     .   + 1d0/dble(nc)**2*(
     .   + Et0g0(i1,i4,i3,i2,i5,i6)
     .   + Et0g0(i1,i6,i5,i2,i3,i4)
     .   + Et0g0(i5,i4,i3,i6,i1,i2)

     .   + Et0g0(i5,i2,i3,i6,i1,i4)
     .   + Et0g0(i1,i6,i5,i4,i3,i2)
     .   + Et0g0(i1,i2,i3,i4,i5,i6)

     .   - 3d0*Ett0g0(i1,i2,i3,i4,i5,i6)
     .   - 3d0*Ett0g0(i1,i4,i3,i2,i5,i6)
     .    )
*       + N^-1*V * (
*          - 3 * Mtt(1,2,3,4,5,6)*Mttc(1,2,3,4,5,6)
*          - 3 * Mtt(1,4,3,2,5,6)*Mttc(1,4,3,2,5,6)
*          + Mt(1,4,3,6,5,2)*Mtc(1,4,3,6,5,2)
*          + Mt(1,2,3,6,5,4)*Mtc(1,2,3,6,5,4)
*          + Mt(3,2,1,6,5,4)*Mtc(3,2,1,6,5,4)
*          + Mt(3,4,1,6,5,2)*Mtc(3,4,1,6,5,2)
*          + Mt(5,6,1,2,3,4)*Mtc(5,6,1,2,3,4)
*          + Mt(5,6,1,4,3,2)*Mtc(5,6,1,4,3,2)
*          )
     .   + (nc**2-1d0)/dble(nc)**3*(
     .   - Ft0g0(i1,i2,i3,i4,i5,i6)
     .   - Ft0g0(i1,i4,i3,i2,i5,i6)
     .   + 3d0*Ftt0g0(i1,i2,i3,i4,i5,i6)
     .    )
*       + N^-2*V^2 * (
*          + 3 * Mtt(1,2,3,4,5,6)*Mttc(1,4,3,2,5,6)
*          + 3 * Mtt(1,4,3,2,5,6)*Mttc(1,2,3,4,5,6)
*
*          - Mt(5,6,1,2,3,4)*Mttc(1,2,3,4,5,6)
*          - Mtt(1,2,3,4,5,6)*Mtc(5,6,1,2,3,4)
*
*          - Mt(5,6,1,4,3,2)*Mttc(1,4,3,2,5,6)
*          - Mtt(1,4,3,2,5,6)*Mtc(5,6,1,4,3,2)
*          )


*      write(*,*)"testpoint, FullF0g0,i1,i2,i3,i4,i5,i6=",ip,wt,i1,i2,i3,i4,i5,i6

      wt = wt*fac

      FullF0g0detail=wt
      return
      end

************************************************************************
* full colour matrix element for six quark zero gluon two identical, one non-identical quark pairs
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(q,qb),(Q,Qb)
* same as FullF0g0 but using a compact form
      function FullF0g0compact(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      dimension ztmp(6,4),tmp(6,4),tmp2(6,4)

c     write(*,*)"hello fullF0g0"

      fac=(4d0*pi*as)**4*(nc**2-1d0)*nc

      wt =
     .   + FullF0g0(i1,i2,i3,i4,i5,i6)

      wt = wt*fac

      FullF0g0compact=wt
      return
      end

************************************************************************
* colour matrix element for full six quark zero gluon two identical, one non-identical quark pairs
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(q,qb),(Q,Qb)
* used by FullF0g0compact
      function FullF0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0

      FullF0g0 =
     .   + FullE0g0(i1,i2,i3,i4,i5,i6)
     .   + FullE0g0(i1,i4,i3,i2,i5,i6)
     .   + FullF0g0only(i1,i2,i3,i4,i5,i6)

      return
      end

************************************************************************
* colour matrix element for exclusive part of six quark zero gluon two identical, one non-identical quark pairs
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(q,qb),(Q,Qb)
* used by FullF0g0compact
      function FullF0g0only(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0

      FullF0g0only =
     .   - 1d0/dble(nc)*F0g0X(i1,i2,i3,i4,i5,i6)
     .   + (nc**2-1d0)/dble(nc)**3*(
     .   - Ft0g0X(i1,i2,i3,i4,i5,i6)
     .   + 3d0*Ftt0g0X(i1,i2,i3,i4,i5,i6)
     .    )

      return
      end

************************************************************************
* sum of leading colour squared amplitudes
* (i1,i2),(i3,i4),(i5,i6) = (q,qb),(q,qb),(Q,Qb)
* F0g0X is symmetric with any exchange of the identical particles: 
* F0g0X(i1,i2,i3,i4,i5,i6) = F0g0X(i1,i4,i3,i2,i5,i6) = F0g0X(i3,i4,i1,i2,i5,i6)

      function F0g0X(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      F0g0X =
     .   + F0g0(i1,i2,i3,i6,i5,i4)
     .   + F0g0(i1,i4,i3,i6,i5,i2)
     .   + F0g0(i3,i2,i1,i6,i5,i4)
     .   + F0g0(i3,i4,i1,i6,i5,i2)
      return
      end

************************************************************************
* sum of sub-sub-leading colour squared amplitudes
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(q,qb),(Q,Qb)
* Ft0g0X is symmetric with any exchange of the identical particles: 
* Ft0g0X(i1,i2,i3,i4,i5,i6) = Ft0g0X(i1,i4,i3,i2,i5,i6) = Ft0g0X(i3,i4,i1,i2,i5,i6)

      function Ft0g0X(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Ft0g0X =
     .   + Ft0g0(i1,i2,i3,i4,i5,i6)
     .   + Ft0g0(i1,i4,i3,i2,i5,i6)
      return
      end

************************************************************************
* sub-sub-leading squared amplitude same as Ftt0g0, this is buffer layer for potential colour permutation at driver
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(q,qb),(Q,Qb)

      function Ftt0g0X(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Ftt0g0X =
     .   + Ftt0g0(i1,i2,i3,i4,i5,i6)
      return
      end

************************************************************************
* F leading colour squared amplitude
* (i1,i2),(i3,i6),(i5,i4) = (q,qb),(q,qb),(Q,Qb)
* The four helicity combinations are (ztmpE)
*       i1 i2 i3 i4 i5 i6
*ihel=1 +  -  +  -  +  -
*ihel   +  +  -  -  +  -   
*ihel=2 +  -  +  +  -  -  
*ihel   +  +  -  +  -  -  
* For easy comparison the corresponding ztmpEt is
*       i1 i4 i5 i2 i3 i6
*ihel=1 +  -  +  -  +  - 
*ihel   +  -  +  +  -  - = 0 
*ihel=2 +  +  -  -  +  -  
*ihel   +  +  -  +  -  - = 0
*By definition of zEt0g0 amplitude, i3 and i6 forms a quark-anti-quark pair 
*However, for ihel=3 and ihel=4 the combinations following zE0g0 helicity vanish
* The other two helicity combinations starting with
* q - is obtained by factor of 2 after modular square.
      function F0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      do i=1,2
         if(i.eq.1) then
           ztmpE=zE0g0(i1,i2,i3,i4,i5,i6,1)
           ztmpEt=zEt0g0(i1,i4,i5,i2,i3,i6,1)
         elseif(i.eq.2) then
           ztmpE=zE0g0(i1,i2,i3,i4,i5,i6,3)
           ztmpEt=zEt0g0(i1,i4,i5,i2,i3,i6,2)
         endif
         wt=wt+2d0*dreal(dconjg(ztmpEt)*ztmpE)
      enddo
*          + M(1,2,3,6,5,4)*Mtc(3,4,1,6,5,2)
*          + Mt(3,4,1,6,5,2)*Mc(1,2,3,6,5,4)
      F0g0=2d0*wt

*XC F0g0 doesn't have any q//qb limit. 
*XC It only have Q//Qb limit and there is no corresponding Cxx1g0 or Dxx1g0 ME for the reduced ME. 
*XC The correct reduced ME is by taking the difference of D1g0gam - D1g0 which corresponds to two
*XC permutations of F0g0 in the Q//Qb limit.

      return
      end
************************************************************************
* F sub-leading colour squared amplitude

* (i1,i2) = (q,qb), (i3,i4) = (q,qb), (i5,i6) = (R,Rb) 
*are the three abelian quark pairs with different flavours

* The four helicity combinations are (ztmpEtt)
*       i1 i2 i3 i4 i5 i6
*ihel=1 +  -  +  -  +  - 
*ihel   +  -  -  +  +  -  
*ihel=2 +  -  +  -  -  +  
*ihel   +  -  -  +  -  + 
* For easy comparison the corresponding ztmpEt is
*       i1 i2 i3 i4 i5 i6
*ihel=1 +  -  +  -  +  - 
*ihel   +  -  -  +  +  - = 0 
*ihel=2 +  -  +  -  -  +  
*ihel   +  -  -  +  -  + = 0
*By definition of zEt0g0 amplitude, i1 and i4 forms a quark-anti-quark pair 
*However, for ihel=3 and ihel=4 the combinations following zEt0g0 helicity vanish
* The other two helicity combinations starting with
* q - is obtained by factor of 2 after modular square.
      function Ft0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      do i=1,2
         if(i.eq.1) then
           ztmpEtt=zEtt0g0(i1,i2,i3,i4,i5,i6,1)
           ztmpEt =zEt0g0(i1,i2,i3,i4,i5,i6,1)
         elseif(i.eq.2) then
           ztmpEtt=zEtt0g0(i1,i2,i3,i4,i5,i6,3)
           ztmpEt =zEt0g0(i1,i2,i3,i4,i5,i6,3)
         endif
         wt=wt+2d0*dreal(dconjg(ztmpEtt)*ztmpEt)
      enddo
*          + Mt(5,6,1,2,3,4)*Mttc(1,2,3,4,5,6)
*          + Mtt(1,2,3,4,5,6)*Mtc(5,6,1,2,3,4)
      Ft0g0=2d0*wt

*XC Ft0g0 doesn't have any q//qb limit. 

      return
      end

************************************************************************
* F sub-sub-leading colour squared amplitude

* (i1,i2) = (q,qb), (i3,i4) = (q,qb), (i5,i6) = (Q,Qb) 
*are the three abelian quark pairs with different flavours

* The four helicity combinations are (ztmpEtt1)
*       i1 i2 i3 i4 i5 i6
*ihel=1 +  -  +  -  +  - 
*ihel   +  -  -  +  +  -  
*ihel=2 +  -  +  -  -  +  
*ihel   +  -  -  +  -  + 
* For easy comparison the corresponding ztmpEtt2 is
*       i1 i4 i3 i2 i5 i6
*ihel=1 +  -  +  -  +  - 
*ihel   +  +  -  -  +  - = 0
*ihel=2 +  -  +  -  -  +  
*ihel   +  +  -  -  -  + = 0
*By definition of zEtt0g0 amplitude, i1 and i4 forms a quark-anti-quark pair 
*However, for ihel=3 and ihel=4 the combinations following zEtt0g0 helicity vanish
* The other two helicity combinations starting with
* q - is obtained by factor of 2 after modular square.
* Ftt0g0 is symmetric with any exchange of the identical particles: 
* Ftt0g0(i1,i2,i3,i4,i5,i6) = Ftt0g0X(i1,i4,i3,i2,i5,i6) = Ftt0g0X(i3,i4,i1,i2,i5,i6)
      function Ftt0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      do i=1,2
         if(i.eq.1) then
           ztmpEtt1=zEtt0g0(i1,i2,i3,i4,i5,i6,1)
           ztmpEtt2=zEtt0g0(i1,i4,i3,i2,i5,i6,1)
         elseif(i.eq.2) then
           ztmpEtt1=zEtt0g0(i1,i2,i3,i4,i5,i6,3)
           ztmpEtt2=zEtt0g0(i1,i4,i3,i2,i5,i6,3)
         endif
         wt=wt+2d0*dreal(dconjg(ztmpEtt1)*ztmpEtt2)
      enddo
*          + Mtt(1,2,3,4,5,6)*Mttc(1,4,3,2,5,6)
*          + Mtt(1,4,3,2,5,6)*Mttc(1,2,3,4,5,6)
      Ftt0g0=2d0*wt

*XC Ftt0g0 doesn't have any q//qb limit. 

      return
      end
************************************************************************
* Wrapper function for full LC level of FullF0g0
      function F0g0LC(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      F0g0LC = - F0g0X(i1,i2,i3,i4,i5,i6)
     .         - Ft0g0X(i1,i2,i3,i4,i5,i6)
     .         + 3d0*Ftt0g0X(i1,i2,i3,i4,i5,i6)

      return
      end
************************************************************************
* Wrapper function for full SLC level of FullF0g0
      function Ft0g0SLC(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Ft0g0SLC = Ft0g0X(i1,i2,i3,i4,i5,i6)
     .         - 3d0*Ftt0g0X(i1,i2,i3,i4,i5,i6)

      return
      end
************************************************************************


