      double precision function g14(x1,x2)
      double precision x1,x2,q3,x12r,R14a,I14a,br
      double complex s,b,x12,one,two
      double complex R14
      double complex ccli2

      if (x2.eq.1d0) then
         g14=0d0
         return
      endif

      if (x1.eq.1d0) then
         R14a = -Log(x2)*(Log(1d0+x2)-Log(2d0))
         g14 = R14a/(1d0-x2)/x2
         return
      endif

      x12r = x1+x2
      q3=x1*(x12r**2+4d0)-4d0*x12r
      if (q3.eq.0d0) then
         br = dsqrt(x12r**2+4d0)
         g14 =
     .      (-2d0*(-32d0*Log(2d0) + br**2*Log(64d0) - 4d0*br**2*Log(br)
     .      - 2d0*(-8d0 + br**2)*Log(br - x12r)
     .      - 4d0*Log(2d0 + br - x12r)+
     .      br**2*Log(2d0 + br - x12r) + 2d0*x12r*Log(2d0 + br - x12r) -
     .      20d0*Log(x12r) + 5d0*br**2*Log(x12r) - 6d0*x12r*Log(x12r) +
     .      16d0*Log(2d0 + x12r) - 2d0*br**2*Log(2d0 + x12r) -
     .      4d0*Log(-2d0 + br + x12r) + br**2*Log(-2d0 + br + x12r) +
     .      2d0*x12r*Log(-2d0 + br + x12r) + 16d0*Log(br + x12r) -
     .      2d0*br**2*Log(br + x12r)))/((-8d0 + br**2)*x12r)
         g14 = -g14/x1/x2
         return
      endif

      if(q3.ge.0d0) s=dcmplx(dsqrt(q3/x1),0d0)
      if(q3.lt.0d0) s=dcmplx(0d0,dsqrt(-q3/x1))

      one = (1d0,0d0)
      two = (2d0,0d0)
      x12 = dcmplx(x12r,0d0)
      b = dcmplx(dsqrt(x12r**2+4d0),0d0)
      s = s/b

c      write(6,*) 'b',b
c      write(6,*) 's',s
c      write(6,*) 'x12',x12

      R14 = -(Log(x12)*Log((b*s + x12)/(-(b*s) + x12))) +
     .  Log(one+ x12)*Log((b*s + x12)/(-(b*s) + x12)) -
     .  (-Log(x12) + Log(one+ x12))*Log((b*s + x12)/(-(b*s) + x12)) +
     .  2*Log(one+ s)*(Log((two - b*s + x12)/(two + b + x12)) -
     .     Log((two + b*s + x12)/(two - b + x12))) +
     .  2*Log(one- s)*(Log((two - b*s + x12)/(two - b + x12)) -
     .     Log((two + b*s + x12)/(two + b + x12))) +
     .  Log((two + b*s + x12)/(two - b*s + x12))*
     .   (-Log((4*x12)/(b**2*(one- s**2))) +
     .     Log(x12 - (4*x12)/(b**2*(one- s**2)))) +
     .  2*Log((two + b*s + x12)/(two - b*s + x12))*
     .   Log((4*x12)/(4 + x12**2)) + 2*ccli2((-(b*s) - x12)/2d0) -
     .  2*ccli2((b*s - x12)/2d0) -
     .  2*ccli2((-b - b*s)/(two - b + x12)) +
     .  2*ccli2((-b + b*s)/(two - b + x12)) -
     .  2*ccli2((b - b*s)/(two + b + x12)) +
     .  2*ccli2((b + b*s)/(two + b + x12)) +
     .  2*ccli2((-(b*s) + x12)/(-b + x12)) +
     .  2*ccli2((-(b*s) + x12)/(b + x12)) +
     .  2*(-(Log((b + b*s)/(b - b*s))*
     .         (Log((two - b*s - x12)/(two + b - x12)) +
     .           Log((two + b*s - x12)/(two + b - x12))))/2d0 +
     .     (Log((two + b*s - x12)/(two - b*s - x12))*
     .        (-Log((4*x12)/(b**2*(one - s**2))) +
     .          Log((-two + b + x12)/(two + b - x12))))/2d0 +
     .     ccli2((b - b*s)/(two + b - x12)) -
     .     ccli2((b + b*s)/(two + b - x12)) -
     .     ccli2((-two - b*s + x12)/(-two + b + x12)) +
     .     ccli2((-two + b*s + x12)/(-two + b + x12))) -
     .  2*ccli2((b*s + x12)/(-b + x12)) -
     .  2*ccli2((b*s + x12)/(b + x12))
      g14 = real(-R14/b/s)
      g14 = -g14/x1/x2

      return
      end

      double precision function g13(x1,x2)
      double precision x1,x2,z
      z = dsqrt(1d0+4d0*x1*x2+4d0*x2*x2)
      g13 = 1d0/z*(dlog((z+1d0-2d0*x2)/(z-1d0+2d0*x2)*(z+1d0)/(z-1d0)))
      return
      end

      double precision function g22(x1,x2)
      double precision x1,x2,dli2,z,pi,log2
      parameter(pi=3.141592653589793238d0)
      parameter(log2=0.69314718055994531d0)
      if (x2.eq.1d0) then
         g22 = 0d0
         return
      endif
      z = dsqrt(1d0+4d0*x1*x2+4d0*x2*x2)
      g22 =
     .  pi**2/12. + dli2(-(1./x2)) - dli2((-4.*x2)/(2. - 2*x2)) +
     .  dli2((-2.*x2)/(2. - 2*x2)) - dli2((1. - z)/(2. - 2*x2)) +
     .  dli2((1. - z)/(2.*x2)) +
     .  dli2((1. - 2.*x2 - z)/(2. - 2*x2)) -
     .  dli2(-(1. - 2.*x2 + z)/(2.*x2)) + (3.*log(x2)**2)/2. +
     .  log2*log((1. - x2)/(1. + x2))-2.*log(x2)*log(1. + x2) +
     .  log(1. + x2)**2/2. + log((1. - x2)/x2)*log(-1. + z) -
     .  log((-1. + z)/(1. + z))**2/2. +log(x2)*log(1. - 2.*x2 + z) -
     .  log(1. - x2)*log(-1. + 2.*x2 + z) +
     .  log((1. + z)/2.)*log((-1. + 2.*x2 + z)/(1. - 2.*x2 + z))

      return
      end

      double precision function g23(x1,x2)
      double precision x1,x2,dli2,z,pi,log2
      parameter(pi=3.141592653589793238d0)
      parameter(log2=0.69314718055994531d0)
      z = dsqrt(1d0+4d0*x1*x2+4*x2*x2)
      g23 = dli2(-1./(2.*x2)) - dli2(-2*x2) - dli2(-(x2/(1 + x2))) +
     -  dli2(-((1 + x2)/x2)) + dli2((1 - z)/(2 + 2*x2)) +
     -  dli2((1 - 2*x2 - z)/2.) +
     -  dli2((1 + 2*x2 - z)/(4.*x2)) +
     -  dli2((1 + 2*x2 - z)/(2.*x2)) -
     -  dli2((1 + 2*x2 - z)/(2 + 2*x2)) -
     -  dli2(0.5 + x2 - z/2.) - dli2(-(1 + z)/(2.*x2)) -
     -  dli2(-(1 - 2*x2 + z)/(4.*x2)) +
     -  log2*Log(1 + 1/(2.*x2)) + Log(2 + 1/x2)*Log(2*(1 + x2)) +
     -  Log(2*x2)*(Log(1 + x2) - Log(1 + 2*x2)) -
     -  Log(4*x2)*Log(1 + 2*x2) +
     -  Log(-1 + 2*x2 + z)*Log((1 + 2*x2 + z)/2.) +
     -  Log(1 + z)*(log2 + Log(x2) -
     -     Log(1 + 2*x2 + z)) +
     -  Log(1 - 2*x2 + z)*
     -   (2d0*log2 + Log(x2) - Log(1 + 2*x2 + z)) +
     -  log2*(Log(2 + 4*x2) - Log(1 + 2*x2 + z)) +
     -  Log(2*(1 + x2))*(Log(2 + 4*x2) - Log(1 + 2*x2 + z)) +
     -  Log(-1 + z)*(-Log(2 + 2*x2) + Log(1 + 2*x2 + z)) +
     -  Log(2*x2)*(-Log(2 + 4*x2) + Log(1 + 2*x2 + z)) +
     -  Log(4*x2)*(-Log(2 + 4*x2) + Log(1 + 2*x2 + z))

      return
      end

      double precision function g25(x1,x2)
      double precision x1,x2,dli2,z,pi,log2
      parameter(pi=3.141592653589793238d0)
      parameter(log2=0.69314718055994531d0)
      if (x2.eq.1d0) then
         g25 = 0d0
         return
      endif
      z = dsqrt(1d0+4d0*x1*x2+4*x2*x2)
      g25 =   -Pi**2/12. - dli2(-(1/x2)) - dli2(x2/(-1 + x2)) +
     -  dli2((2*x2)/(-1 + x2)) + dli2((-1 + z)/(2.*(-1 + x2))) -
     -  dli2(-(-1 + z)/(2.*x2)) +
     -  dli2(-(1 - 2*x2 + z)/(2.*x2)) -
     -  dli2((-1 + 2*x2 + z)/(2.*(-1 + x2))) + log2**2/2. +
     -  Log(-1 + 1/x2)*Log(2 - 2*x2) - Log(2 - 2*x2)**2 +
     -  Log(2 - 2*x2)*Log(x2) + (Log(x2)*Log(4*x2))/2. -
     -  Log(2 - 2*x2)*Log(-1 + z) +
     -  Log(2*x2)*Log(-1 + z) -
     -  Log(2*x2)*Log((1 - 2*x2 + z)/2.) +
     -  Log(-1 + z)*Log(1 - 2*x2 + z) -
     -  Log(1 - 2*x2 + z)**2/2. +
     -  Log(2 - 2*x2)*Log(-1 + 2*x2 + z) -
     -  Log(-1 + z)*Log(-1 + 2*x2 + z) +
     -  Log(1 - 2*x2 + z)*Log(-1 + 2*x2 + z) -
     -  Log(-1 + 2*x2 + z)**2/2.

      return
      end


      double precision function g23b(x2)
      double precision x2,dli2,pi,log2
      parameter(pi=3.141592653589793238d0)
      parameter(log2=0.69314718055994531d0)
      g23b =         (pi**2 + 3*dli2(-1. - 2*x2) + 6.*dli2(-2*x2) +
     .               6.*log(2*x2)*log(1. + 2*x2))/6.
      return
      end

      double precision function g23c(x2)
      double precision x2,dli2,dli3,zeta3,pi,log2,log3,li3bound
      parameter(pi=3.141592653589793238d0)
      parameter(log2=0.69314718055994531d0)
      parameter(log3=1.0986122886681097d0)
      parameter(li3bound=0.292190130562457d0)
      parameter(zeta3=1.20205690315959d0)
      g23c =
     .  li3bound + dli3(-1. - 2*x2) + (3*dli3(-2*x2))/2. + dli3(-x2) +
     .  dli3(1./(1. + x2)) - dli3(x2/(1. + x2))/2. +
     .  dli3(-((1. + x2)/x2))/2. + dli3(1./(1. + 2*x2)) -
     .  dli3(x2/(1. + 2*x2)) + dli3((2*x2)/(1. + 2*x2)) -
     .  dli3((1. + x2)/(1. + 2*x2)) + dli3(1./(2 + 2*x2))/2. +
     .  dli3((1. + 2*x2)/(2. + 2*x2)) - (Pi**2*log2)/12. +
     .  (dli2((2*x2)/(1. + 2*x2))*log2)/2. +
     .  (dli2((1. + 2*x2)/(2. + 2*x2))*log2)/2. + (17*log2**3)/6.+
     .  (Pi**2*log3)/6. - 2*log2**2*log3 + log3**3/6. +
     .  (Pi**2*Log(x2))/6. + (3*dli2(x2/(1. + x2))*Log(x2))/2. +
     .  dli2(x2/(1. + 2*x2))*Log(x2) -
     .  (dli2((2*x2)/(1. + 2*x2))*Log(x2))/2. -
     .  (dli2((1. + x2)/(1. + 2*x2))*Log(x2))/2. -
     .  (dli2((1. + 2*x2)/(2. + 2*x2))*Log(x2))/2. -
     .  (log2**2*Log(x2))/4. - Log(x2)**3/12. +
     .  (Pi**2*Log(1. + x2))/12.-(3*dli2(x2/(1. + x2))*Log(1. + x2))/2.+
     .  dli2((2*x2)/(1. + 2*x2))*Log(1. + x2) +
     .  (3*dli2((1. + x2)/(1. + 2*x2))*Log(1. + x2))/2. +
     .  dli2((1. + 2*x2)/(2. + 2*x2))*Log(1. + x2) +
     .  (7*log2**2*Log(1 + x2))/4.-(log2*Log(x2)*Log(1 + x2))/2. -
     .  (Log(x2)**2*Log(1 + x2))/4. + 2*log2*Log(1 + x2)**2 +
     .  (7*Log(x2)*Log(1 + x2)**2)/4. - Log(1 + x2)**3/12. +
     .  (Pi**2*Log(1 + 2*x2))/6. - dli2(x2/(1 + 2*x2))*Log(1 + 2*x2) -
     .  dli2((1 + x2)/(1 + 2*x2))*Log(1 + 2*x2) -
     .  (log2**2*Log(1 + 2*x2))/2. +
     .  (log2*Log(x2)*Log(1 + 2*x2))/2. +
     .  (Log(x2)**2*Log(1 + 2*x2))/2. -
     .  (3*log2*Log(1 + x2)*Log(1 + 2*x2))/2. -
     .  2*Log(x2)*Log(1 + x2)*Log(1 + 2*x2) -
     .  Log(1 + x2)**2*Log(1 + 2*x2)+(3*log2*Log(1. + 2*x2)**2)/4. +
     .  Log(x2)*Log(1 + 2*x2)**2 + (7*Log(1 + x2)*Log(1 + 2*x2)**2)/4. -
     .  Log(1 + 2*x2)**3 + (log2*Log((1 + 2*x2)/(2 + 2*x2))*
     .     Log(2 + 2*x2))/2. +
     .  (Log(1 + x2)*Log((1 + 2*x2)/(2 + 2*x2))*Log(2 + 2*x2))/2. +
     .  (5*zeta3)/16.
      return
      end


      double precision function G24(x1,x2)
      double precision x1,x2,dli2,pi,r
      parameter(pi=3.141592653589793238d0)
      r=log(2d0)**2/2d0 + dli2((1d0+x2)/2d0)
      if(x2.ne.1d0) r = r + log(1d0-x2)*log((1d0+x2)/2d0)
      if(x1.eq.x2) then
         r = r-1d0/2d0*log(1d0+x1)**2 - pi**2/6d0
      endif
      if (x1.gt.x2) then
         r = r +log(x1-x2)*log((1d0+x1)/(1d0+x2))
     .            -1d0/2d0*log(1d0+x1)**2 - dli2((1d0+x2)/(1d0+x1))
      endif
      if (x1.lt.x2) then
         r = r +log(x2-x1)*log((1d0+x1)/(1d0+x2))
     .            + 1d0/2d0*log(1d0+x2)**2 - log(1d0+x2)*log(1d0+x1)
     .            + dli2((1d0+x1)/(1d0+x2)) - pi**2/3d0
      endif
      G24 = r
      return
      end

      double precision function FXF(z1,z2)
c--- computes all 1/[z1-z2]**2 and higher terms in F30xF30
      implicit none
      double precision z1,z2
      double precision a,s,HH1,HH2,HH3
      double precision a2,a3
      double precision dli2
      double precision FXFexp

      a=z1-z2
      s=z1+z2

      if (a/s.le.0.1d0) then
         FXF = FXFexp(z1,z2)
         return
      endif

      a2 = z1/z2*((1.d0+z2)/(1.d0+z1))**2
      a3 = s**4/((1.d0+z1)*(1.d0+z2))**2/z1/z2

      HH1 = dli2(-z2/z1)-dli2(-z1/z2)+1./2.*log(z1/z2)*log(z1*z2)
     .      +2.*dli2(-z1) - 2.*dli2(-z2)
      HH2 = log(a2)
      HH3 = log(a3)/4.

      FXF =  + a * (
     &     + 55.d0/6.d0*s**4
     &     + 10*s**4*HH3
     &     - 55.d0/6.d0*s**5
     &     + 245.d0/24.d0*s**6
     &     + 45.d0/2.d0*s**6*HH3
     &     - 95.d0/12.d0*s**7
     &     + 245.d0/96.d0*s**8
     &     + 45.d0/8.d0*s**8*HH3
     &     - 55.d0/96.d0*s**9
     &     + 55.d0/384.d0*s**10
     &     + 5.d0/32.d0*s**10*HH3
     &     )
      FXF = FXF + a**2 * (
     &     - 1.d0/3.d0*s**3*HH2
     &     - 4*s**3*HH1
     &     + 225.d0/16.d0*s**5*HH2
     &     + 141.d0/8.d0*s**5*HH1
     &     - 135.d0/32.d0*s**7*HH2
     &     + 93.d0/16.d0*s**7*HH1
     &     - 161.d0/768.d0*s**9*HH2
     &     + 7.d0/128.d0*s**9*HH1
     &     )
      FXF = FXF + a**3 * (
     &     + 7.d0/18.d0*s**2
     &     + 58.d0/3.d0*s**2*HH3
     &     + s**3
     &     - 421.d0/12.d0*s**4
     &     - 63*s**4*HH3
     &     + 1159.d0/36.d0*s**5
     &     - 1087.d0/96.d0*s**6
     &     - 171.d0/8.d0*s**6*HH3
     &     + 29.d0/24.d0*s**7
     &     - 61.d0/144.d0*s**8
     &     - 1.d0/6.d0*s**8*HH3
     &     )
      FXF = FXF + a**4 * (
     &     + 115.d0/12.d0*s*HH2
     &     - 19.d0/2.d0*s*HH1
     &     - 451.d0/16.d0*s**3*HH2
     &     - 155.d0/8.d0*s**3*HH1
     &     + 169.d0/16.d0*s**5*HH2
     &     - 37.d0/4.d0*s**5*HH1
     &     + 19.d0/384.d0*s**7*HH2
     &     - 5.d0/64.d0*s**7*HH1
     &     )
      FXF = FXF + a**5 * (
     &     - 226.d0/9.d0
     &     + 136.d0/3.d0*HH3
     &     + 137.d0/6.d0*s
     &     + 1265.d0/24.d0*s**2
     &     + 117.d0/2.d0*s**2*HH3
     &     - 2111.d0/36.d0*s**3
     &     + 2107.d0/96.d0*s**4
     &     + 243.d0/8.d0*s**4*HH3
     &     + 35.d0/48.d0*s**5
     &     + 11.d0/576.d0*s**6
     &     + 13.d0/48.d0*s**6*HH3
     &     )
      FXF = FXF - 55.d0/12.d0*s**5*HH2
     &     - 5.d0/2.d0*s**5*HH1
     &     - 45.d0/16.d0*s**7*HH2
     &     - 45.d0/8.d0*s**7*HH1
     &     + 45.d0/64.d0*s**9*HH2
     &     - 45.d0/32.d0*s**9*HH1
     &     + 55.d0/768.d0*s**11*HH2
     &     - 5.d0/128.d0*s**11*HH1
     &

      FXF = FXF/a**7
      return
      end



      double precision function FXFexp(z1,z2)
c--- computes the expansion of all 1/[z1-z2]**2 and higher terms in F30xF30
      implicit none
      double precision z1,z2
      double precision a,s,s2,Ls,Ls2,Log2
      parameter(Log2=0.693147180559945309d0)

      a=z1-z2
      s=z1+z2
      s2 = 1d0/(2.d0+s)
      Ls=log(s)
      Ls2=-log(s2)

      FXFexp =  + a**2 * (
     &     + 8039.d0/2520.d0
     &     + 1876.d0/135.d0*s**(-4)
     &     + 3464.d0/315.d0*s**(-4)*Ls2
     &     - 1732.d0/315.d0*s**(-4)*Ls
     &     - 1732.d0/315.d0*s**(-3)
     &     - 523.d0/630.d0*s**(-2)
     &     + 111.d0/14.d0*s**(-2)*Ls2
     &     - 111.d0/28.d0*s**(-2)*Ls
     &     - 16717.d0/3780.d0*s**(-1)
     &     + 1317.d0/280.d0*Ls2
     &     - 1317.d0/560.d0*Ls
     &     + 28591.d0/1260.d0*s2
     &     - 1047.d0/20.d0*s2**2
     &     + 1051.d0/18.d0*s2**3
     &     )
      FXFexp = FXFexp + a**2 * (
     &     - 119.d0/144.d0*s
     &     + 403.d0/15120.d0*s**2
     &     + 7.d0/144.d0*s**2*Ls2
     &     - 7.d0/288.d0*s**2*Ls
     &     - 1732.d0/105.d0*Log2*s**(-4)
     &     - 333.d0/28.d0*Log2*s**(-2)
     &     - 3951.d0/560.d0*Log2
     &     - 7.d0/96.d0*Log2*s**2
     &     )
      FXFexp = FXFexp + a**4 * (
     &     + 6709.d0/1330560.d0
     &     + 102371.d0/10395.d0*s**(-6)
     &     + 5624.d0/693.d0*s**(-6)*Ls2
     &     - 2812.d0/693.d0*s**(-6)*Ls
     &     - 2812.d0/693.d0*s**(-5)
     &     - 42923.d0/55440.d0*s**(-4)
     &     + 2441.d0/462.d0*s**(-4)*Ls2
     &     - 2441.d0/924.d0*s**(-4)*Ls
     &     - 24781.d0/8316.d0*s**(-3)
     &     + 57523.d0/10560.d0*s**(-2)
     &     + 5939.d0/1848.d0*s**(-2)*Ls2
     &     - 5939.d0/3696.d0*s**(-2)*Ls
     &     - 52051.d0/27720.d0*s**(-1)
     &     + 383.d0/11088.d0*Ls2
     &     )
      FXFexp = FXFexp + a**4 * (
     &     - 383.d0/22176.d0*Ls
     &     + 19949.d0/18480.d0*s2
     &     + 29311.d0/22176.d0*s2**2
     &     + 36541.d0/27720.d0*s2**3
     &     - 166337.d0/6930.d0*s2**4
     &     + 1051.d0/30.d0*s2**5
     &     - 2812.d0/231.d0*Log2*s**(-6)
     &     - 2441.d0/308.d0*Log2*s**(-4)
     &     - 5939.d0/1232.d0*Log2*s**(-2)
     &     - 383.d0/7392.d0*Log2
     &     )
      FXFexp = FXFexp + a**6 * (
     &     + 1032553.d0/135135.d0*s**(-8)
     &     + 8296.d0/1287.d0*s**(-8)*Ls2
     &     - 4148.d0/1287.d0*s**(-8)*Ls
     &     - 4148.d0/1287.d0*s**(-7)
     &     - 1431293.d0/2162160.d0*s**(-6)
     &     + 10123.d0/2574.d0*s**(-6)*Ls2
     &     - 10123.d0/5148.d0*s**(-6)*Ls
     &     - 34517.d0/15444.d0*s**(-5)
     &     + 35528869.d0/8648640.d0*s**(-4)
     &     + 25021.d0/10296.d0*s**(-4)*Ls2
     &     - 25021.d0/20592.d0*s**(-4)*Ls
     &     - 219187.d0/154440.d0*s**(-3)
     &     + 37021.d0/95040.d0*s**(-2)
     &     + 553.d0/20592.d0*s**(-2)*Ls2
     &     )
      FXFexp = FXFexp + a**6 * (
     &     - 553.d0/41184.d0*s**(-2)*Ls
     &     - 24359.d0/166320.d0*s**(-1)
     &     + 24359.d0/166320.d0*s2
     &     - 1731427.d0/17297280.d0*s2**2
     &     - 1512937.d0/4324320.d0*s2**3
     &     + 1562299.d0/540540.d0*s2**4
     &     - 1307587.d0/540540.d0*s2**5
     &     - 1578641.d0/108108.d0*s2**6
     &     + 1051.d0/42.d0*s2**7
     &     - 4148.d0/429.d0*Log2*s**(-8)
     &     - 10123.d0/1716.d0*Log2*s**(-6)
     &     - 25021.d0/6864.d0*Log2*s**(-4)
     &     - 553.d0/13728.d0*Log2*s**(-2)
     &     )
      FXFexp = FXFexp + a**8 * (
     &     + 18551.d0/2970.d0*s**(-10)
     &     + 2296.d0/429.d0*s**(-10)*Ls2
     &     - 1148.d0/429.d0*s**(-10)*Ls
     &     - 1148.d0/429.d0*s**(-9)
     &     - 74267.d0/131040.d0*s**(-8)
     &     + 893.d0/286.d0*s**(-8)*Ls2
     &     - 893.d0/572.d0*s**(-8)*Ls
     &     - 835.d0/468.d0*s**(-7)
     &     + 3797713.d0/1153152.d0*s**(-6)
     &     + 2231.d0/1144.d0*s**(-6)*Ls2
     &     - 2231.d0/2288.d0*s**(-6)*Ls
     &     - 501.d0/440.d0*s**(-5)
     &     + 2159207.d0/6918912.d0*s**(-4)
     &     + 151.d0/6864.d0*s**(-4)*Ls2
     &     )
      FXFexp = FXFexp + a**8 * (
     &     - 151.d0/13728.d0*s**(-4)*Ls
     &     - 1347.d0/11440.d0*s**(-3)
     &     + 3219.d0/73216.d0*s**(-2)
     &     - 76763.d0/4324320.d0*s**(-1)
     &     + 76763.d0/4324320.d0*s2
     &     - 585539.d0/69189120.d0*s2**2
     &     + 222917.d0/17297280.d0*s2**3
     &     + 7499.d0/5765760.d0*s2**4
     &     - 43987.d0/90090.d0*s2**5
     &     + 8664251.d0/2882880.d0*s2**6
     &     - 1051663.d0/308880.d0*s2**7
     &     - 1568461.d0/154440.d0*s2**8
     &     + 1051.d0/54.d0*s2**9
     &     - 1148.d0/143.d0*Log2*s**(-10)
     &     )
      FXFexp = FXFexp + a**8 * (
     &     - 2679.d0/572.d0*Log2*s**(-8)
     &     - 6693.d0/2288.d0*Log2*s**(-6)
     &     - 151.d0/4576.d0*Log2*s**(-4)
     &     )
      FXFexp = FXFexp + a**10 * (
     &     + 17339747.d0/3281850.d0*s**(-12)
     &     + 15176.d0/3315.d0*s**(-12)*Ls2
     &     - 7588.d0/3315.d0*s**(-12)*Ls
     &     - 7588.d0/3315.d0*s**(-11)
     &     - 60252859.d0/122522400.d0*s**(-10)
     &     + 5713.d0/2210.d0*s**(-10)*Ls2
     &     - 5713.d0/4420.d0*s**(-10)*Ls
     &     - 11801.d0/7956.d0*s**(-9)
     &     + 1346098331.d0/490089600.d0*s**(-8)
     &     + 14383.d0/8840.d0*s**(-8)*Ls2
     &     - 14383.d0/17680.d0*s**(-8)*Ls
     &     - 41983.d0/44200.d0*s**(-7)
     &     + 764800123.d0/2940537600.d0*s**(-6)
     &     + 989.d0/53040.d0*s**(-6)*Ls2
     &     )
      FXFexp = FXFexp + a**10 * (
     &     - 989.d0/106080.d0*s**(-6)*Ls
     &     - 669.d0/6800.d0*s**(-5)
     &     + 4155.d0/113152.d0*s**(-4)
     &     - 123841.d0/8353800.d0*s**(-3)
     &     + 24911.d0/3993600.d0*s**(-2)
     &     - 2643187.d0/980179200.d0*s**(-1)
     &     + 2643187.d0/980179200.d0*s2
     &     - 13243513.d0/15682867200.d0*s2**2
     &     + 7764613.d0/11762150400.d0*s2**3
     &     - 4129001.d0/3920716800.d0*s2**4
     &     + 128903.d0/32672640.d0*s2**5
     &     + 1653133.d0/89107200.d0*s2**6
     &     - 4826027.d0/9801792.d0*s2**7
     &     + 116411.d0/40800.d0*s2**8
     &     )
      FXFexp = FXFexp + a**10 * (
     &     - 23749507.d0/6563700.d0*s2**9
     &     - 5573719.d0/729300.d0*s2**10
     &     + 1051.d0/66.d0*s2**11
     &     - 7588.d0/1105.d0*Log2*s**(-12)
     &     - 17139.d0/4420.d0*Log2*s**(-10)
     &     - 43149.d0/17680.d0*Log2*s**(-8)
     &     - 989.d0/35360.d0*Log2*s**(-6)
     &     )
      FXFexp = FXFexp - 68681.d0/840.d0
     &     + 7582.d0/315.d0*s**(-2)
     &     + 1816.d0/105.d0*s**(-2)*Ls2
     &     - 908.d0/105.d0*s**(-2)*Ls
     &     - 908.d0/105.d0*s**(-1)
     &     + 3139.d0/210.d0*Ls2
     &     - 3139.d0/420.d0*Ls
     &     + 1051.d0/6.d0*s2
     &     + 1039.d0/36.d0*s
     &     + 22949.d0/3360.d0*s**2
     &     + 7129.d0/840.d0*s**2*Ls2
     &     - 7129.d0/1680.d0*s**2*Ls
     &     - 501.d0/560.d0*s**3
     &     + 2227.d0/20160.d0*s**4
     &     + 139.d0/1680.d0*s**4*Ls2
     &
      FXFexp = FXFexp - 139.d0/3360.d0*s**4*Ls
     &     - 908.d0/35.d0*Log2*s**(-2)
     &     - 3139.d0/140.d0*Log2
     &     - 7129.d0/560.d0*Log2*s**2
     &     - 139.d0/1120.d0*Log2*s**4
     &

      return
      end

      complex*16 function ccli2(z)
      complex*16 z,x
      complex*16 cli2inv,one,ipi,l,l2,ml
      real*8 a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14
      real*8 b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,
     .       b11,b12,b13,b14,b15,b16,b17,b18,b19,b20
      real*8 zeta2,pi
      integer iflag
      parameter(a1  = -0.250000000000000d0)
      parameter(a2  = -0.111111111111111d0)
      parameter(a3  = -0.010000000000000d0)
      parameter(a4  = -0.0170068027210884d0)
      parameter(a5  = -0.0194444444444444d0)
      parameter(a6  = -0.0206611570247934d0)
      parameter(a7  = -0.0214173006480699d0)
      parameter(a8  = -0.0219488663772311d0)
      parameter(a9  = -0.0220893589994137d0)
      parameter(a10 = -0.0229303207720760d0)
      parameter(a11 = -0.0231276449354844d0)
      parameter(a12 = -0.0233038680700203d0)
      parameter(a13 = -0.0234539766464373d0)
      parameter(a14 = -0.0235833786876607d0)
      parameter(b1  = -0.0138888888888889d0)
      parameter(b2  = -0.0050000000000000d0)
      parameter(b3  = -0.0113378684807256d0)
      parameter(b4  = -0.0145833333333333d0)
      parameter(b5  = -0.0165289256198347d0)
      parameter(b6  = -0.0178477505400582d0)
      parameter(b7  = -0.0188133140376266d0)
      parameter(b8  = -0.0195555795847751d0)
      parameter(b9  = -0.0201455014535035d0)
      parameter(b10 = -0.0206260390394933d0)
      parameter(b11 = -0.0210251317595313d0)
      parameter(b12 = -0.0213618790641852d0)
      parameter(b13 = -0.0216498245967113d0)
      parameter(b14 = -0.0218988516385421d0)
      parameter(b15 = -0.0221163443246526d0)
      parameter(b16 = -0.0223079310420350d0)
      parameter(b17 = -0.0224779768713498d0)
      parameter(b18 = -0.0226299190182279d0)
      parameter(b19 = -0.0227665007776857d0)
      parameter(b20 = -0.0228899381337706d0)

      parameter(zeta2 =  1.644934066848226d0)
      parameter(pi =  3.14159265358979324d0)

      one = dcmplx(1d0,0d0)
      ipi = (0d0,pi)
      ccli2 = 0d0
      cli2inv = 0d0
      if (cdabs(z).gt.1d0) then
         cli2inv = -zeta2*one-0.5d0*(log(-z))**2
         x=1d0/z
         iflag=1
      else
         x=z
         iflag=0
      endif

      if (cdabs(x).le.0.5d0) then
         l=-log(one-x)
         l2=l*l
         ccli2=l*(one+a1*l*(one+a2*l*(one+a3*l2*(one+a4*l2*
     .     (one+a5*l2*(one+a6*l2*(one+a7*l2*(one+a8*l2*(one+a9*l2*
     .     (one+a10*l2*(one+a11*l2*(one+a12*l2*(one+a13*l2*
     .     (one+a14*l2))))))))))))))
      else
         if (z.eq.(1d0,0d0)) then
            ccli2=dcmplx(zeta2,0d0)
         else
         l = log(x)
         l2=l*l
         ccli2 = zeta2*one - l*log(-l) + l - 0.25d0*one*l2+
     .      b1*l*l2*(one+b2*l2*(one+b3*l2*(one+b4*l2*
     .     (one+b5*l2*(one+b6*l2*(one+b7*l2*(one+b8*l2*(one+b9*l2*
     .     (one+b10*l2*(one+b11*l2*(one+b12*l2*(one+b13*l2*(one+b14*l2*
     .     (one+b15*l2*(one+b16*l2*(one+b17*l2*(one+b18*l2*(one+b19*l2*
     .     (one+b20*l2)))))))))))))))))))
         endif
      endif

      if (iflag.eq.1) ccli2 = cli2inv-ccli2

      return
      end



      real*8 function dli2(x)
c---- Li2(x) for arbitrary real arguments
      implicit real*8(a-h,o-z)
      parameter(pi=3.141592653589793238d0)

      if (x.lt.0d0) then
         a = -x/(1d0-x)
         dli2 = -rli2(a) - 0.5d0*dlog(1d0-x)**2
      elseif(x.gt.1d0) then
         a = 1/x
         dli2 = -rli2(a) - 0.5d0*dlog(x)**2+pi**2/3d0
      else
         dli2 = rli2(x)
      endif
      return
      end

c
c real dilogarithm function  0 <= x <= 1
c
      double precision function rli2(x)
      implicit real*8(a-h,o-z)
      parameter(a1  = -0.250000000000000d0)
      parameter(a2  = -0.111111111111111d0)
      parameter(a3  = -0.010000000000000d0)
      parameter(a4  = -0.0170068027210884d0)
      parameter(a5  = -0.0194444444444444d0)
      parameter(a6  = -0.0206611570247934d0)
      parameter(a7  = -0.0214173006480699d0)
      parameter(a8  = -0.0219488663772311d0)
      parameter(a9  = -0.0220893589994137d0)
      parameter(a10 = -0.0229303207720760d0)
      parameter(a11 = -0.0231276449354844d0)
      parameter(a12 = -0.0233038680700203d0)
      parameter(a13 = -0.0234539766464373d0)
      parameter(a14 = -0.0235833786876607d0)
      parameter(zeta2 =  1.644934066848226d0)

      if(x.gt.1.d0)then
        write(*,*)' argument greater than 1 passed to li2'
        rli2=0.d0
        return
      elseif(x.lt.0.d0)then
        write(*,*)' argument less than 0 passed to li2'
        rli2=0.d0
        return
      elseif(x.eq.1.d0)then
        rli2=zeta2
        return
      elseif(x.eq.0.d0)then
        rli2=0d0
        return
      elseif(x.gt.0.5d0)then
        y=1.d0-x
        z=-log(1.d0-y)
        z2=z*z
        rli2=-z*(1.d0+a1*z*(1.d0+a2*z*(1.d0+a3*z2*(1.d0+a4*z2*
     1 (1.d0+a5*z2*(1.d0+a6*z2*(1.d0+a7*z2*(1.d0+a8*z2*(1.d0+a9*z2*
     2 (1.d0+a10*z2*(1.d0+a11*z2*(1.d0+a12*z2*(1.d0+a13*z2*
     . (1.d0+a14*z2))))))))))))))
     3 +zeta2-log(x)*log(1.d0-x)
       return
      elseif(x.le.0.5d0)then
        y=x
        z=-log(1.d0-y)
        z2=z*z
        rli2=z*(1.d0+a1*z*(1.d0+a2*z*(1.d0+a3*z2*(1.d0+a4*z2*
     1 (1.d0+a5*z2*(1.d0+a6*z2*(1.d0+a7*z2*(1.d0+a8*z2*(1.d0+a9*z2*
     2 (1.d0+a10*z2*(1.d0+a11*z2*(1.d0+a12*z2*(1.d0+a13*z2*
     . (1.d0+a14*z2))))))))))))))
        return
      endif
      rli2=0d0
      return
      end

      double precision function dli3(x)
c---- Li3(x) for real arguments <=1
      implicit real*8(a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.20205690315959d0)

      if (x.lt.0d0) then
         a = -x/(1d0-x)
         dli3 =   rs12(a) - rli3(a) + log(1d0-a)*dli2(a)
     .          + 1d0/6d0*log(1d0-a)**3
      else
         dli3 = rli3(x)
      endif
      return
      end


c
c real Li3 function  0 <= x <= 1
c
      double precision function rli3(x)
      implicit real*8(a-h,o-z)
      parameter(a1 = -0.37500000000000000d0)
      parameter(a2 = -0.20987654320987654d0)
      parameter(a3 = -0.11029411764705882d0)
      parameter(a4 = -0.014933333333333333d0)
      parameter(a5 = 0.62500000000000000d0)
      parameter(a6 = -0.042204636956823546d0)
      parameter(a7 = 0.38856907894736842d0)
      parameter(a8 = -0.065185185185185185d0)
      parameter(a9 = 0.29166666666666667d0)
      parameter(a10 = -0.084901824946903835d0)
      parameter(a11 = 0.23966633466135458d0)
      parameter(a12 = -0.10212974973960734d0)
      parameter(a13 = 0.20740230686846218d0)
      parameter(a14 = -0.11737402973292988d0)
      parameter(zeta2 =  1.644934066848226d0)
      parameter(zeta3=1.20205690315959d0)

      if(x.gt.1.d0)then
        write(*,*)' argument greater than 1 passed to li3'
        rli3=0.d0
        return
      elseif(x.lt.0.d0)then
        write(*,*)' argument less than 0 passed to li3'
        rli3=0.d0
        return
      elseif(x.eq.1.d0)then
        rli3=zeta3
        return
      elseif(x.eq.0.d0)then
        rli3=0d0
        return
      elseif(x.gt.0.5d0)then
        y=1.d0-x
        dl1 = log(1d0-y)
        rli3 = -rs12(y) -dl1*dli2(y) -0.5d0*log(y)*dl1**2
     .          +zeta2*dl1 + zeta3
       return
      elseif(x.le.0.5d0)then
        y=x
        z=-log(1.d0-y)
        rli3 = z*(1d0+a1*z*(1d0+a2*z*(1d0+a3*z*(1d0+a4*z*(1d0+a5*z*(
     .            1d0+a6*z*(1d0+a7*z*(1d0+a8*z*(1d0+a9*z*(1d0+a10*z*(
     .       1d0+a11*z*(1d0+a12*z*(1d0+a13*z*(1d0+a14*z))))))))))))))
        return
      endif
      rli3=0d0
      return
      end

c
c real S12 function  0 <= x <= 1
c
      double precision function rs12(x)
      implicit real*8(a-h,o-z)
      parameter(a1  = -0.083333333333333333d0)
      parameter(a2  = 0.25d0)
      parameter(a3  = 0.041666666666666667d0)
      parameter(a4  = -0.011111111111111111d0)
      parameter(a5  = -0.017857142857142857d0)
      parameter(a6  = -0.020000000000000000d0)
      parameter(a7  = -0.021043771043771044d0)
      parameter(a8  = -0.021695447409733124d0)
      parameter(a9  = -0.022159913169319826d0)
      parameter(a10 = -0.022514783691254279d0)
      parameter(zeta2=1.644934066848226d0)
      parameter(zeta3=1.20205690315959d0)

      if(x.gt.1.d0)then
        write(*,*)' argument greater than 1 passed to rs12'
        rs12=0.d0
        return
      elseif(x.lt.0.d0)then
        write(*,*)' argument less than 0 passed to rs12'
        rs12=0.d0
        return
      elseif(x.eq.1.d0)then
        rs12=zeta3
        return
      elseif(x.eq.0.d0)then
        rs12=0d0
        return
      elseif(x.gt.0.5d0)then
        y=1.d0-x
        dl = log(y)
        rs12 = -rli3(y) +dl*dli2(y) +0.5d0*log(1d0-y)*dl**2+zeta3
       return
      elseif(x.le.0.5d0)then
        y=x
        z=-log(1.d0-y)
        z2 =z*z
        rs12 = z*z2*a1+z2*a2*(1d0+a3*z2*(1d0+a4*z2*(1d0+a5*z2*
     .         (1d0+a6*z2*(1d0+a7*z2*(1d0+a8*z2*(1d0+a9*z2*
     .         (1d0+a10*z2))))))))
        return
      endif
      rs12=0d0
      return
      end

c
c real Li4 function  0 <= x <= 1
c
      double precision function rli4(x)
      implicit real*8(a-h,o-z)
      parameter(a1 = -.43750000000000000000d0)
      parameter(a2 = -.26631393298059964727d0)
      parameter(a3 = -.17011589403973509934d0)
      parameter(a4 = -0.097269099756690997567d0)
      parameter(a5 = -0.016109021051789001841d0)
      parameter(a6 = .50307368479144731793d0)
      parameter(a7 = -0.054308234745614546302d0)
      parameter(a8 = .26999744289995601788d0)
      parameter(a9 = -0.095298906990382182110d0)
      parameter(a10 = .17784516505023447771d0)
      parameter(a11 = -.14026623071349317886d0)
      parameter(a12 = .12780815055011240558d0)
      parameter(a13 = -.19215790819598734809d0)
      parameter(a14 = 0.095582411863702753676d0)
      parameter(zeta2 = 1.6449340668482264365d0)
      parameter(zeta3 = 1.2020569031595942854d0)
      parameter(zeta4 = 1.0823232337111381916d0)

      if(x.gt.1.d0)then
        write(*,*)' argument greater than 1 passed to rli4'
        rli4=0.d0
        return
      elseif(x.lt.-1.d0)then
        dl = log(-x)
        y=1d0/x
        z=-log(1d0-y)
        rli4 = -(7d0/4d0)*zeta4-(1d0/2d0)*zeta2*dl**2-(1d0/24d0)*dl**4
     .  -z*(1d0+a1*z*(1d0+a2*z*(1d0+a3*z*(1d0+a4*z*(1d0+a5*z*(
     .            1d0+a6*z*(1d0+a7*z*(1d0+a8*z*(1d0+a9*z*(1d0+a10*z*(
     .       1d0+a11*z*(1d0+a12*z*(1d0+a13*z*(1d0+a14*z))))))))))))))
        return
      elseif(x.eq.1.d0)then
        rli4=zeta4
        return
      elseif(x.eq.0.d0)then
        rli4=0d0
        return
      elseif(x.gt.0.5d0)then
        y=1.d0-x
        dl1 = log(1d0-y)
        rli4 = -rs13(y) -dl1*rs12(y) -1d0/6d0*log(y)*dl1**3
     .          -0.5d0*dl1**2*rli2(y)+0.5d0*zeta2*dl1**2
     .         + zeta3*dl1 +zeta4
       return
      elseif(x.le.0.5d0)then
        y=x
        z=-log(1.d0-y)
        rli4 = z*(1d0+a1*z*(1d0+a2*z*(1d0+a3*z*(1d0+a4*z*(1d0+a5*z*(
     .            1d0+a6*z*(1d0+a7*z*(1d0+a8*z*(1d0+a9*z*(1d0+a10*z*(
     .       1d0+a11*z*(1d0+a12*z*(1d0+a13*z*(1d0+a14*z))))))))))))))
        return
      endif
      rli4=0d0
      return
      end

c
c real S13 function  0 <= x <= 1
c
      double precision function rs13(x)
      implicit real*8(a-h,o-z)
      parameter(a0 = 0.055555555555555555556d0)
      parameter(a1 = -0.020833333333333333333d0)
      parameter(a2 = -.13333333333333333333d0)
      parameter(a3 = -0.011904761904761904762d0)
      parameter(a4 = -0.018518518518518518519d0)
      parameter(a5 = -0.020454545454545454545d0)
      parameter(a6 = -0.021367521367521367521d0)
      parameter(a7 = -0.021936507936507936508d0)
      parameter(a8 = -0.022346130927045203031d0)
      parameter(a9 = -0.022662907268170426065d0)
      parameter(a10 = -0.022917624027462488697d0)
      parameter(zeta2 = 1.6449340668482264365d0)
      parameter(zeta3 = 1.2020569031595942854d0)
      parameter(zeta4 = 1.0823232337111381916d0)

      if(x.gt.1.d0)then
        write(*,*)' argument greater than 1 passed to rs13'
        rs13=0.d0
        return
      elseif(x.lt.0.d0)then
        write(*,*)' argument less than 0 passed to rs13'
        rs13=0.d0
        return
      elseif(x.eq.1.d0)then
        rs13=zeta4
        return
      elseif(x.eq.0.d0)then
        rs13=0d0
        return
      elseif(x.gt.0.5d0)then
        y=1.d0-x
        dl = log(y)
        rs13 = -rli4(y) +dl*rli3(y) -0.5d0*dl**2*rli2(y)
     .     -1d0/6d0*dl**3*log(x)+zeta4
       return
      elseif(x.le.0.5d0)then
        y=x
        z=-log(1.d0-y)
        z2 =z*z
        rs13 = z*z2*(a0+a1*z*(1d0+a2*z*(1d0+a3*z2*(1d0+a4*z2*(1d0+a5*z2*
     .         (1d0+a6*z2*(1d0+a7*z2*(1d0+a8*z2*(1d0+a9*z2*
     .         (1d0+a10*z2))))))))))
        return
      endif
      rs13=0d0
      return
      end



************************************************************************
*
      real*8 function XxX1(z1,z2)
      implicit real*8(a-h,o-z)

      delta=0.1d0

      a=z1-z2
      s=z1+z2
      s2=s+2d0
      opz1=1d0+z1
      opz2=1d0+z2

      if(abs(a/s).ge.delta)then
      XxX1 =
     .     a**(-7)*(2d0*dli2(-z1)-2d0*dli2(-z2)-dli2(-z1/z2)+dli2(-z2/z1)
     .             +1d0/2d0*dlog(z1/z2)*dlog(z1*z2))
     .    -a**(-6)/s*dlog(s**4/opz1**2/opz2**2/z1/z2)
     .    -a**(-4)/s**3/3d0*(dlog(s**4/opz1**2/opz2**2/z1/z2)-s*(4d0/s-1d0/opz1**2-1d0/opz2**2))
     .    -a**(-2)/s**5/5d0*(dlog(s**4/opz1**2/opz2**2/z1/z2)-s/3d0*(16d0/s-22d0/opz1**3-22d0/opz2**3
     .            +7d0/opz1**2+7d0/opz2**2+12d0/opz1**4+12d0/opz2**4))
      else
      XxX1 =
     .   2d0*dlog(8d0*s/s2**2)/s**7
     .       *(1d0/7d0+(a/s)**2/9d0+(a/s)**4/11d0+(a/s)**6/13d0+(a/s)**8/15d0)
     .   -(4d0/105d0)*(1472d0+3936d0*s+4368d0*s**2+3332d0*s**4+190d0*s**5+23d0*s**6
     .     +2032d0*s**3)/(s**7*s2**6)
     .   -(a/s)**2*(145664d0+528896d0*s+818048d0*s**2+299d0*s**8+341824d0*s**4
     .    -157472d0*s**5+273896d0*s**6+692608d0*s**3-88d0*s**7)/(s**7*s2**8)/945d0
     .   -(a/s)**4*(3316736d0+15293440d0*s+31184640d0*s**2+36741120d0*s**3+27310080d0*s**4
     .    +12999168d0*s**5+3737664d0*s**6-6031296d0*s**7+3790692d0*s**8-35212d0*s**9
     .    +709d0*s**(10))/(s**7*s2**(10))/6930d0
     .   +(a/s)**6*(-141635584d0-793042944d0*s-2010556416d0*s**2-3038689280d0*s**3
     .   -3028227840d0*s**4-2071314432d0*s**5-974088192d0*s**6-300377088d0*s**7
     .   -50103504d0*s**8+391d0*s**(12)+203184608d0*s**9-80687640d0*s**(10)
     .   +833592d0*s**(11))/(s**7*s2**(12))/90090d0
     .   +(a/s)**8*(-14446247936d0-95219597312d0*s-288799207424d0*s**2-382136891136d0*s**6
     .   -532825366528d0*s**3-665475306496d0*s**4-591599776768d0*s**5
     .   -3609809476d0*s**(12)-178787761152d0*s**7-58431557184d0*s**8
     .   +35114828d0*s**(13)+173021d0*s**(14)-11781818048d0*s**9-640303664d0*s**(10)
     .   +12262143712d0*s**(11))/(s**7*s2**(14))/2702700d0

      endif

      return
      end

************************************************************************
*
      real*8 function XxX2(z1,z2)
      implicit real*8(a-h,o-z)

      delta=0.1d0

      a=z1-z2
      s=z1+z2
      s2=s+2d0
      opz1=1d0+z1
      opz2=1d0+z2

      if(abs(a/s).ge.delta)then
      XxX2 =
     .     a**(-7)*dlog(z1*opz2**(2)/z2/opz1**(2))
     .    +a**(-6)/s*2d0*(1d0-1d0/opz1-1d0/opz2)
     .    +a**(-4)/s**3*2d0/3d0*(1d0-3d0/opz1**2-3d0/opz2**2+2d0/opz1**3+2d0/opz2**3)
     .    +a**(-2)/s**5*2d0/5d0*(1d0+5d0/opz1**2+5d0/opz2**2-30d0/opz1**3-30d0/opz2**3
     .                          +40d0/opz1**4+40d0/opz2**4-16d0/opz1**5-16d0/opz2**5)
      else
      XxX2 =
     .   +312d0/s2**5-2241d0/(16d0*s)+12d0/s**4+272d0/s2**6-1d0/s**5+89d0/s**2+1088d0/(7d0*s2**7)
     .   +2d0/(7d0*s**7)+493d0/(2d0*s2**3)+294d0/s2**4+2241d0/(16d0*s2)-169d0/(4d0*s**3)+1529d0/(8d0*s2**2)
     . +a**2*(2d0/(9d0*s**9)+1749d0/s2**5-36163d0/(64d0*s)+47d0/s**4+5912d0/(3d0*s2**6)-29d0/(4d0*s**5)
     . +1584d0/s2**8+329d0/s**2+7424d0/(9d0*s2**9)+1960d0/s2**7+52531d0/(48d0*s2**3)+11413d0/(8d0*s2**4)
     . +36163d0/(64d0*s2)-3605d0/(24d0*s**3)+25635d0/(32d0*s2**2))
     . +a**4*(67313d0/(16d0*s2**5)-135779d0/(128d0*s)+133d0/(2d0*s**4)+5216d0/s2**10+42913d0/(8d0*s2**6)
     . -161d0/(16d0*s**5)+7014d0/s2**8+4437d0/(8d0*s**2)+2d0/(11d0*s**11)+6736d0/s2**9+12823d0/(2d0*s2**7)
     . +144253d0/(64d0*s2**3)+100491d0/(32d0*s2**4)+135779d0/(128d0*s2)+28288d0/(11d0*s2**(11))
     . -14679d0/(64d0*s**3)+100283d0/(64d0*s2**2))
     . +a**6*(402463d0/(64d0*s2**5)-670885d0/(512d0*s)+477d0/(8d0*s**4)+18304d0/s2**(10)+277635d0/(32d0*s2**6)
     . -525d0/(64d0*s**5)+115741d0/(8d0*s2**8)+9845d0/(16d0*s**2)+2d0/(13d0*s**(13))+17034d0/s2**9
     . +183905d0/(16d0*s2**7)+385083d0/(128d0*s2**3)+282223d0/(64d0*s2**4)+670885d0/(512d0*s2)+17200d0/s2**(11)
     . +12960d0/s2**(12)+80128d0/(13d0*s2**(13))-14619d0/(64d0*s**3)+513365d0/(256d0*s2**2))
     . +a**8*(1925021d0/(192d0*s2**6)+74625d0/(2d0*s2**(11))+4398963d0/(640d0*s2**5)+118850d0/(3*s2**(12))
     . -5056143d0/(4096d0*s)+27120d0/s2**(14)+2629d0/(64d0*s**4)-6501d0/(1280d0*s**5)+134043d0/(256d0*s**2)
     . +36680d0/s2**(13)+1177951d0/(256d0*s2**4)+910057d0/(64d0*s2**7)+1280301d0/(40d0*s2**(10))
     . +188608d0/(15d0*s2**(15))+2318047d0/(768d0*s2**3)+5056143d0/(4096d0*s2)+623883d0/(32d0*s2**8)
     . -537823d0/(3072d0*s**3)+3983799d0/(2048d0*s2**2)+1230883d0/(48d0*s2**9)+2d0/(15d0*s**(15)))
      endif

      return
      end


      double precision function rti2(x)
c---- computes the tangent integral function Ti2 (x) for real arguments
c---- Ti2(x) = int_0^x dz/z *ArcTan(z)
      implicit real*8(a-h,o-z)
      parameter(a1  = 2.2222222222222222d-1)
      parameter(a2  = 2.8000000000000000d-1)
      parameter(a3  = 3.0126336248785228d-1)
      parameter(a4  = 3.1863799283154121d-1)
      parameter(a5  = 3.3253074770612351d-1)
      parameter(a6  = 3.4317976067787899d-1)
      parameter(a7  = 3.5131053150151375d-1)
      parameter(a8  = 3.5762048311105234d-1)
      parameter(a9  = 3.6262732610720257d-1)
      parameter(a10 = 3.6668723668508237d-1)
      parameter(a11 = 3.7004284831854353d-1)
      parameter(a12 = 3.7286202246619033d-1)
      parameter(a13 = 3.7526365989418281d-1)
      parameter(a14 = 3.7733406743664562d-1)
      parameter(a15 = 3.7913733339835311d-1)
      parameter(a16 = 3.8072202364925942d-1)
      parameter(a17 = 3.8212560694640161d-1)
      parameter(a18 = 3.8337745163639304d-1)
      parameter(pi =  3.14159265358979324d0)

      rti2 = 0d0
      ti2norm = 1d0
      ti2shift = 0d0
      arg = x
      if (arg.lt.0.d0) then
         arg = -arg
         ti2norm = -1d0
      endif
      if (arg.gt.1d0) then
         arg = 1d0/arg
         ti2shift = -pi/2d0*dlog(arg)
      endif
      y=datan(arg)
      z=y*y
      rti2=y*(1.d0+a1*z*(1.d0+a2*z*(1.d0+a3*z*(1.d0+a4*z*
     .     (1.d0+ a5*z*(1.d0+ a6*z*(1.d0+ a7*z*(1.d0+a8*z*(1.d0+a9*z*
     .     (1.d0+a10*z*(1.d0+a11*z*(1.d0+a12*z*(1.d0+a13*z*
     .     (1.d0+a14*z*(1.d0+a15*z*(1.d0+a16*z*(1.d0+a17*z*
     .     (1.d0+a18*z))))))))))))))))))
      rti2 = ti2norm*(rti2+ti2shift)
      return
      end
